// Generated by Futhark 0.22.0
// git: e8b7244 (Wed Jan 12 23:26:03 2022 +0100)

// We need to define _GNU_SOURCE before
// _any_ headers files are imported to get
// the usage statistics of a thread (i.e. have RUSAGE_THREAD) on GNU/Linux
// https://manpages.courier-mta.org/htmlman2/getrusage.2.html
#ifndef _GNU_SOURCE // Avoid possible double-definition warning.
#define _GNU_SOURCE
#endif

#ifdef __clang__
#pragma clang diagnostic ignored "-Wunused-function"
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wparentheses"
#pragma clang diagnostic ignored "-Wunused-label"
#elif __GNUC__
#pragma GCC diagnostic ignored "-Wunused-function"
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wparentheses"
#pragma GCC diagnostic ignored "-Wunused-label"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif

// Headers\n")
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdio.h>
#include <float.h>

#ifdef __cplusplus
extern "C" {
#endif

// Initialisation
struct futhark_context_config;
struct futhark_context_config *futhark_context_config_new(void);
void futhark_context_config_free(struct futhark_context_config *cfg);
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int flag);
struct futhark_context;
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg);
void futhark_context_free(struct futhark_context *ctx);
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t param_value);
int futhark_get_tuning_param_count(void);
const char *futhark_get_tuning_param_name(int);
const char *futhark_get_tuning_param_class(int);

// Arrays
struct futhark_f64_2d;
struct futhark_f64_2d *futhark_new_f64_2d(struct futhark_context *ctx, const
                                          double *data, int64_t dim0,
                                          int64_t dim1);
struct futhark_f64_2d *futhark_new_raw_f64_2d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0,
                                              int64_t dim1);
int futhark_free_f64_2d(struct futhark_context *ctx,
                        struct futhark_f64_2d *arr);
int futhark_values_f64_2d(struct futhark_context *ctx,
                          struct futhark_f64_2d *arr, double *data);
unsigned char *futhark_values_raw_f64_2d(struct futhark_context *ctx,
                                         struct futhark_f64_2d *arr);
const int64_t *futhark_shape_f64_2d(struct futhark_context *ctx,
                                    struct futhark_f64_2d *arr);

// Opaque values


// Entry points
int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f64_2d **out0, const
                       struct futhark_f64_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5);

// Miscellaneous
int futhark_context_sync(struct futhark_context *ctx);
char *futhark_context_report(struct futhark_context *ctx);
char *futhark_context_get_error(struct futhark_context *ctx);
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f);
void futhark_context_pause_profiling(struct futhark_context *ctx);
void futhark_context_unpause_profiling(struct futhark_context *ctx);
int futhark_context_clear_caches(struct futhark_context *ctx);
#define FUTHARK_BACKEND_c

#ifdef __cplusplus
}
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>
#include <stdint.h>
// If NDEBUG is set, the assert() macro will do nothing. Since Futhark
// (unfortunately) makes use of assert() for error detection (and even some
// side effects), we want to avoid that.
#undef NDEBUG
#include <assert.h>
#include <stdarg.h>
// Start of util.h.
//
// Various helper functions that are useful in all generated C code.

#include <errno.h>
#include <string.h>

static const char *fut_progname = "(embedded Futhark)";

static void futhark_panic(int eval, const char *fmt, ...) __attribute__((noreturn));
static char* msgprintf(const char *s, ...);
static void* slurp_file(const char *filename, size_t *size);
static int dump_file(const char *file, const void *buf, size_t n);
struct str_builder;
static void str_builder_init(struct str_builder *b);
static void str_builder(struct str_builder *b, const char *s, ...);

static void futhark_panic(int eval, const char *fmt, ...) {
  va_list ap;
  va_start(ap, fmt);
  fprintf(stderr, "%s: ", fut_progname);
  vfprintf(stderr, fmt, ap);
  va_end(ap);
  exit(eval);
}

// For generating arbitrary-sized error messages.  It is the callers
// responsibility to free the buffer at some point.
static char* msgprintf(const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = 1 + (size_t)vsnprintf(NULL, 0, s, vl);
  char *buffer = (char*) malloc(needed);
  va_start(vl, s); // Must re-init.
  vsnprintf(buffer, needed, s, vl);
  return buffer;
}

static inline void check_err(int errval, int sets_errno, const char *fun, int line,
                            const char *msg, ...) {
  if (errval) {
    char errnum[10];

    va_list vl;
    va_start(vl, msg);

    fprintf(stderr, "ERROR: ");
    vfprintf(stderr, msg, vl);
    fprintf(stderr, " in %s() at line %d with error code %s\n",
            fun, line,
            sets_errno ? strerror(errno) : errnum);
    exit(errval);
  }
}

#define CHECK_ERR(err, ...) check_err(err, 0, __func__, __LINE__, __VA_ARGS__)
#define CHECK_ERRNO(err, ...) check_err(err, 1, __func__, __LINE__, __VA_ARGS__)

// Read the rest of an open file into a NUL-terminated string; returns
// NULL on error.
static void* fslurp_file(FILE *f, size_t *size) {
  long start = ftell(f);
  fseek(f, 0, SEEK_END);
  long src_size = ftell(f)-start;
  fseek(f, start, SEEK_SET);
  unsigned char *s = (unsigned char*) malloc((size_t)src_size + 1);
  if (fread(s, 1, (size_t)src_size, f) != (size_t)src_size) {
    free(s);
    s = NULL;
  } else {
    s[src_size] = '\0';
  }

  if (size) {
    *size = (size_t)src_size;
  }

  return s;
}

// Read a file into a NUL-terminated string; returns NULL on error.
static void* slurp_file(const char *filename, size_t *size) {
  FILE *f = fopen(filename, "rb"); // To avoid Windows messing with linebreaks.
  if (f == NULL) return NULL;
  unsigned char *s = fslurp_file(f, size);
  fclose(f);
  return s;
}

// Dump 'n' bytes from 'buf' into the file at the designated location.
// Returns 0 on success.
static int dump_file(const char *file, const void *buf, size_t n) {
  FILE *f = fopen(file, "w");

  if (f == NULL) {
    return 1;
  }

  if (fwrite(buf, sizeof(char), n, f) != n) {
    return 1;
  }

  if (fclose(f) != 0) {
    return 1;
  }

  return 0;
}

struct str_builder {
  char *str;
  size_t capacity; // Size of buffer.
  size_t used; // Bytes used, *not* including final zero.
};

static void str_builder_init(struct str_builder *b) {
  b->capacity = 10;
  b->used = 0;
  b->str = malloc(b->capacity);
  b->str[0] = 0;
}

static void str_builder(struct str_builder *b, const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = (size_t)vsnprintf(NULL, 0, s, vl);

  while (b->capacity < b->used + needed + 1) {
    b->capacity *= 2;
    b->str = realloc(b->str, b->capacity);
  }

  va_start(vl, s); // Must re-init.
  vsnprintf(b->str+b->used, b->capacity-b->used, s, vl);
  b->used += needed;
}

// End of util.h.
// Start of half.h.

// Conversion functions are from http://half.sourceforge.net/, but
// translated to C.
//
// Copyright (c) 2012-2021 Christian Rau
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

#ifndef __OPENCL_VERSION__
#define __constant
#endif

__constant static const uint16_t base_table[512] = {
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0002, 0x0004, 0x0008, 0x0010, 0x0020, 0x0040, 0x0080, 0x0100,
  0x0200, 0x0400, 0x0800, 0x0C00, 0x1000, 0x1400, 0x1800, 0x1C00, 0x2000, 0x2400, 0x2800, 0x2C00, 0x3000, 0x3400, 0x3800, 0x3C00,
  0x4000, 0x4400, 0x4800, 0x4C00, 0x5000, 0x5400, 0x5800, 0x5C00, 0x6000, 0x6400, 0x6800, 0x6C00, 0x7000, 0x7400, 0x7800, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8001, 0x8002, 0x8004, 0x8008, 0x8010, 0x8020, 0x8040, 0x8080, 0x8100,
  0x8200, 0x8400, 0x8800, 0x8C00, 0x9000, 0x9400, 0x9800, 0x9C00, 0xA000, 0xA400, 0xA800, 0xAC00, 0xB000, 0xB400, 0xB800, 0xBC00,
  0xC000, 0xC400, 0xC800, 0xCC00, 0xD000, 0xD400, 0xD800, 0xDC00, 0xE000, 0xE400, 0xE800, 0xEC00, 0xF000, 0xF400, 0xF800, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00 };

__constant static const unsigned char shift_table[512] = {
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13 };

__constant static const uint32_t mantissa_table[2048] = {
  0x00000000, 0x33800000, 0x34000000, 0x34400000, 0x34800000, 0x34A00000, 0x34C00000, 0x34E00000, 0x35000000, 0x35100000, 0x35200000, 0x35300000, 0x35400000, 0x35500000, 0x35600000, 0x35700000,
  0x35800000, 0x35880000, 0x35900000, 0x35980000, 0x35A00000, 0x35A80000, 0x35B00000, 0x35B80000, 0x35C00000, 0x35C80000, 0x35D00000, 0x35D80000, 0x35E00000, 0x35E80000, 0x35F00000, 0x35F80000,
  0x36000000, 0x36040000, 0x36080000, 0x360C0000, 0x36100000, 0x36140000, 0x36180000, 0x361C0000, 0x36200000, 0x36240000, 0x36280000, 0x362C0000, 0x36300000, 0x36340000, 0x36380000, 0x363C0000,
  0x36400000, 0x36440000, 0x36480000, 0x364C0000, 0x36500000, 0x36540000, 0x36580000, 0x365C0000, 0x36600000, 0x36640000, 0x36680000, 0x366C0000, 0x36700000, 0x36740000, 0x36780000, 0x367C0000,
  0x36800000, 0x36820000, 0x36840000, 0x36860000, 0x36880000, 0x368A0000, 0x368C0000, 0x368E0000, 0x36900000, 0x36920000, 0x36940000, 0x36960000, 0x36980000, 0x369A0000, 0x369C0000, 0x369E0000,
  0x36A00000, 0x36A20000, 0x36A40000, 0x36A60000, 0x36A80000, 0x36AA0000, 0x36AC0000, 0x36AE0000, 0x36B00000, 0x36B20000, 0x36B40000, 0x36B60000, 0x36B80000, 0x36BA0000, 0x36BC0000, 0x36BE0000,
  0x36C00000, 0x36C20000, 0x36C40000, 0x36C60000, 0x36C80000, 0x36CA0000, 0x36CC0000, 0x36CE0000, 0x36D00000, 0x36D20000, 0x36D40000, 0x36D60000, 0x36D80000, 0x36DA0000, 0x36DC0000, 0x36DE0000,
  0x36E00000, 0x36E20000, 0x36E40000, 0x36E60000, 0x36E80000, 0x36EA0000, 0x36EC0000, 0x36EE0000, 0x36F00000, 0x36F20000, 0x36F40000, 0x36F60000, 0x36F80000, 0x36FA0000, 0x36FC0000, 0x36FE0000,
  0x37000000, 0x37010000, 0x37020000, 0x37030000, 0x37040000, 0x37050000, 0x37060000, 0x37070000, 0x37080000, 0x37090000, 0x370A0000, 0x370B0000, 0x370C0000, 0x370D0000, 0x370E0000, 0x370F0000,
  0x37100000, 0x37110000, 0x37120000, 0x37130000, 0x37140000, 0x37150000, 0x37160000, 0x37170000, 0x37180000, 0x37190000, 0x371A0000, 0x371B0000, 0x371C0000, 0x371D0000, 0x371E0000, 0x371F0000,
  0x37200000, 0x37210000, 0x37220000, 0x37230000, 0x37240000, 0x37250000, 0x37260000, 0x37270000, 0x37280000, 0x37290000, 0x372A0000, 0x372B0000, 0x372C0000, 0x372D0000, 0x372E0000, 0x372F0000,
  0x37300000, 0x37310000, 0x37320000, 0x37330000, 0x37340000, 0x37350000, 0x37360000, 0x37370000, 0x37380000, 0x37390000, 0x373A0000, 0x373B0000, 0x373C0000, 0x373D0000, 0x373E0000, 0x373F0000,
  0x37400000, 0x37410000, 0x37420000, 0x37430000, 0x37440000, 0x37450000, 0x37460000, 0x37470000, 0x37480000, 0x37490000, 0x374A0000, 0x374B0000, 0x374C0000, 0x374D0000, 0x374E0000, 0x374F0000,
  0x37500000, 0x37510000, 0x37520000, 0x37530000, 0x37540000, 0x37550000, 0x37560000, 0x37570000, 0x37580000, 0x37590000, 0x375A0000, 0x375B0000, 0x375C0000, 0x375D0000, 0x375E0000, 0x375F0000,
  0x37600000, 0x37610000, 0x37620000, 0x37630000, 0x37640000, 0x37650000, 0x37660000, 0x37670000, 0x37680000, 0x37690000, 0x376A0000, 0x376B0000, 0x376C0000, 0x376D0000, 0x376E0000, 0x376F0000,
  0x37700000, 0x37710000, 0x37720000, 0x37730000, 0x37740000, 0x37750000, 0x37760000, 0x37770000, 0x37780000, 0x37790000, 0x377A0000, 0x377B0000, 0x377C0000, 0x377D0000, 0x377E0000, 0x377F0000,
  0x37800000, 0x37808000, 0x37810000, 0x37818000, 0x37820000, 0x37828000, 0x37830000, 0x37838000, 0x37840000, 0x37848000, 0x37850000, 0x37858000, 0x37860000, 0x37868000, 0x37870000, 0x37878000,
  0x37880000, 0x37888000, 0x37890000, 0x37898000, 0x378A0000, 0x378A8000, 0x378B0000, 0x378B8000, 0x378C0000, 0x378C8000, 0x378D0000, 0x378D8000, 0x378E0000, 0x378E8000, 0x378F0000, 0x378F8000,
  0x37900000, 0x37908000, 0x37910000, 0x37918000, 0x37920000, 0x37928000, 0x37930000, 0x37938000, 0x37940000, 0x37948000, 0x37950000, 0x37958000, 0x37960000, 0x37968000, 0x37970000, 0x37978000,
  0x37980000, 0x37988000, 0x37990000, 0x37998000, 0x379A0000, 0x379A8000, 0x379B0000, 0x379B8000, 0x379C0000, 0x379C8000, 0x379D0000, 0x379D8000, 0x379E0000, 0x379E8000, 0x379F0000, 0x379F8000,
  0x37A00000, 0x37A08000, 0x37A10000, 0x37A18000, 0x37A20000, 0x37A28000, 0x37A30000, 0x37A38000, 0x37A40000, 0x37A48000, 0x37A50000, 0x37A58000, 0x37A60000, 0x37A68000, 0x37A70000, 0x37A78000,
  0x37A80000, 0x37A88000, 0x37A90000, 0x37A98000, 0x37AA0000, 0x37AA8000, 0x37AB0000, 0x37AB8000, 0x37AC0000, 0x37AC8000, 0x37AD0000, 0x37AD8000, 0x37AE0000, 0x37AE8000, 0x37AF0000, 0x37AF8000,
  0x37B00000, 0x37B08000, 0x37B10000, 0x37B18000, 0x37B20000, 0x37B28000, 0x37B30000, 0x37B38000, 0x37B40000, 0x37B48000, 0x37B50000, 0x37B58000, 0x37B60000, 0x37B68000, 0x37B70000, 0x37B78000,
  0x37B80000, 0x37B88000, 0x37B90000, 0x37B98000, 0x37BA0000, 0x37BA8000, 0x37BB0000, 0x37BB8000, 0x37BC0000, 0x37BC8000, 0x37BD0000, 0x37BD8000, 0x37BE0000, 0x37BE8000, 0x37BF0000, 0x37BF8000,
  0x37C00000, 0x37C08000, 0x37C10000, 0x37C18000, 0x37C20000, 0x37C28000, 0x37C30000, 0x37C38000, 0x37C40000, 0x37C48000, 0x37C50000, 0x37C58000, 0x37C60000, 0x37C68000, 0x37C70000, 0x37C78000,
  0x37C80000, 0x37C88000, 0x37C90000, 0x37C98000, 0x37CA0000, 0x37CA8000, 0x37CB0000, 0x37CB8000, 0x37CC0000, 0x37CC8000, 0x37CD0000, 0x37CD8000, 0x37CE0000, 0x37CE8000, 0x37CF0000, 0x37CF8000,
  0x37D00000, 0x37D08000, 0x37D10000, 0x37D18000, 0x37D20000, 0x37D28000, 0x37D30000, 0x37D38000, 0x37D40000, 0x37D48000, 0x37D50000, 0x37D58000, 0x37D60000, 0x37D68000, 0x37D70000, 0x37D78000,
  0x37D80000, 0x37D88000, 0x37D90000, 0x37D98000, 0x37DA0000, 0x37DA8000, 0x37DB0000, 0x37DB8000, 0x37DC0000, 0x37DC8000, 0x37DD0000, 0x37DD8000, 0x37DE0000, 0x37DE8000, 0x37DF0000, 0x37DF8000,
  0x37E00000, 0x37E08000, 0x37E10000, 0x37E18000, 0x37E20000, 0x37E28000, 0x37E30000, 0x37E38000, 0x37E40000, 0x37E48000, 0x37E50000, 0x37E58000, 0x37E60000, 0x37E68000, 0x37E70000, 0x37E78000,
  0x37E80000, 0x37E88000, 0x37E90000, 0x37E98000, 0x37EA0000, 0x37EA8000, 0x37EB0000, 0x37EB8000, 0x37EC0000, 0x37EC8000, 0x37ED0000, 0x37ED8000, 0x37EE0000, 0x37EE8000, 0x37EF0000, 0x37EF8000,
  0x37F00000, 0x37F08000, 0x37F10000, 0x37F18000, 0x37F20000, 0x37F28000, 0x37F30000, 0x37F38000, 0x37F40000, 0x37F48000, 0x37F50000, 0x37F58000, 0x37F60000, 0x37F68000, 0x37F70000, 0x37F78000,
  0x37F80000, 0x37F88000, 0x37F90000, 0x37F98000, 0x37FA0000, 0x37FA8000, 0x37FB0000, 0x37FB8000, 0x37FC0000, 0x37FC8000, 0x37FD0000, 0x37FD8000, 0x37FE0000, 0x37FE8000, 0x37FF0000, 0x37FF8000,
  0x38000000, 0x38004000, 0x38008000, 0x3800C000, 0x38010000, 0x38014000, 0x38018000, 0x3801C000, 0x38020000, 0x38024000, 0x38028000, 0x3802C000, 0x38030000, 0x38034000, 0x38038000, 0x3803C000,
  0x38040000, 0x38044000, 0x38048000, 0x3804C000, 0x38050000, 0x38054000, 0x38058000, 0x3805C000, 0x38060000, 0x38064000, 0x38068000, 0x3806C000, 0x38070000, 0x38074000, 0x38078000, 0x3807C000,
  0x38080000, 0x38084000, 0x38088000, 0x3808C000, 0x38090000, 0x38094000, 0x38098000, 0x3809C000, 0x380A0000, 0x380A4000, 0x380A8000, 0x380AC000, 0x380B0000, 0x380B4000, 0x380B8000, 0x380BC000,
  0x380C0000, 0x380C4000, 0x380C8000, 0x380CC000, 0x380D0000, 0x380D4000, 0x380D8000, 0x380DC000, 0x380E0000, 0x380E4000, 0x380E8000, 0x380EC000, 0x380F0000, 0x380F4000, 0x380F8000, 0x380FC000,
  0x38100000, 0x38104000, 0x38108000, 0x3810C000, 0x38110000, 0x38114000, 0x38118000, 0x3811C000, 0x38120000, 0x38124000, 0x38128000, 0x3812C000, 0x38130000, 0x38134000, 0x38138000, 0x3813C000,
  0x38140000, 0x38144000, 0x38148000, 0x3814C000, 0x38150000, 0x38154000, 0x38158000, 0x3815C000, 0x38160000, 0x38164000, 0x38168000, 0x3816C000, 0x38170000, 0x38174000, 0x38178000, 0x3817C000,
  0x38180000, 0x38184000, 0x38188000, 0x3818C000, 0x38190000, 0x38194000, 0x38198000, 0x3819C000, 0x381A0000, 0x381A4000, 0x381A8000, 0x381AC000, 0x381B0000, 0x381B4000, 0x381B8000, 0x381BC000,
  0x381C0000, 0x381C4000, 0x381C8000, 0x381CC000, 0x381D0000, 0x381D4000, 0x381D8000, 0x381DC000, 0x381E0000, 0x381E4000, 0x381E8000, 0x381EC000, 0x381F0000, 0x381F4000, 0x381F8000, 0x381FC000,
  0x38200000, 0x38204000, 0x38208000, 0x3820C000, 0x38210000, 0x38214000, 0x38218000, 0x3821C000, 0x38220000, 0x38224000, 0x38228000, 0x3822C000, 0x38230000, 0x38234000, 0x38238000, 0x3823C000,
  0x38240000, 0x38244000, 0x38248000, 0x3824C000, 0x38250000, 0x38254000, 0x38258000, 0x3825C000, 0x38260000, 0x38264000, 0x38268000, 0x3826C000, 0x38270000, 0x38274000, 0x38278000, 0x3827C000,
  0x38280000, 0x38284000, 0x38288000, 0x3828C000, 0x38290000, 0x38294000, 0x38298000, 0x3829C000, 0x382A0000, 0x382A4000, 0x382A8000, 0x382AC000, 0x382B0000, 0x382B4000, 0x382B8000, 0x382BC000,
  0x382C0000, 0x382C4000, 0x382C8000, 0x382CC000, 0x382D0000, 0x382D4000, 0x382D8000, 0x382DC000, 0x382E0000, 0x382E4000, 0x382E8000, 0x382EC000, 0x382F0000, 0x382F4000, 0x382F8000, 0x382FC000,
  0x38300000, 0x38304000, 0x38308000, 0x3830C000, 0x38310000, 0x38314000, 0x38318000, 0x3831C000, 0x38320000, 0x38324000, 0x38328000, 0x3832C000, 0x38330000, 0x38334000, 0x38338000, 0x3833C000,
  0x38340000, 0x38344000, 0x38348000, 0x3834C000, 0x38350000, 0x38354000, 0x38358000, 0x3835C000, 0x38360000, 0x38364000, 0x38368000, 0x3836C000, 0x38370000, 0x38374000, 0x38378000, 0x3837C000,
  0x38380000, 0x38384000, 0x38388000, 0x3838C000, 0x38390000, 0x38394000, 0x38398000, 0x3839C000, 0x383A0000, 0x383A4000, 0x383A8000, 0x383AC000, 0x383B0000, 0x383B4000, 0x383B8000, 0x383BC000,
  0x383C0000, 0x383C4000, 0x383C8000, 0x383CC000, 0x383D0000, 0x383D4000, 0x383D8000, 0x383DC000, 0x383E0000, 0x383E4000, 0x383E8000, 0x383EC000, 0x383F0000, 0x383F4000, 0x383F8000, 0x383FC000,
  0x38400000, 0x38404000, 0x38408000, 0x3840C000, 0x38410000, 0x38414000, 0x38418000, 0x3841C000, 0x38420000, 0x38424000, 0x38428000, 0x3842C000, 0x38430000, 0x38434000, 0x38438000, 0x3843C000,
  0x38440000, 0x38444000, 0x38448000, 0x3844C000, 0x38450000, 0x38454000, 0x38458000, 0x3845C000, 0x38460000, 0x38464000, 0x38468000, 0x3846C000, 0x38470000, 0x38474000, 0x38478000, 0x3847C000,
  0x38480000, 0x38484000, 0x38488000, 0x3848C000, 0x38490000, 0x38494000, 0x38498000, 0x3849C000, 0x384A0000, 0x384A4000, 0x384A8000, 0x384AC000, 0x384B0000, 0x384B4000, 0x384B8000, 0x384BC000,
  0x384C0000, 0x384C4000, 0x384C8000, 0x384CC000, 0x384D0000, 0x384D4000, 0x384D8000, 0x384DC000, 0x384E0000, 0x384E4000, 0x384E8000, 0x384EC000, 0x384F0000, 0x384F4000, 0x384F8000, 0x384FC000,
  0x38500000, 0x38504000, 0x38508000, 0x3850C000, 0x38510000, 0x38514000, 0x38518000, 0x3851C000, 0x38520000, 0x38524000, 0x38528000, 0x3852C000, 0x38530000, 0x38534000, 0x38538000, 0x3853C000,
  0x38540000, 0x38544000, 0x38548000, 0x3854C000, 0x38550000, 0x38554000, 0x38558000, 0x3855C000, 0x38560000, 0x38564000, 0x38568000, 0x3856C000, 0x38570000, 0x38574000, 0x38578000, 0x3857C000,
  0x38580000, 0x38584000, 0x38588000, 0x3858C000, 0x38590000, 0x38594000, 0x38598000, 0x3859C000, 0x385A0000, 0x385A4000, 0x385A8000, 0x385AC000, 0x385B0000, 0x385B4000, 0x385B8000, 0x385BC000,
  0x385C0000, 0x385C4000, 0x385C8000, 0x385CC000, 0x385D0000, 0x385D4000, 0x385D8000, 0x385DC000, 0x385E0000, 0x385E4000, 0x385E8000, 0x385EC000, 0x385F0000, 0x385F4000, 0x385F8000, 0x385FC000,
  0x38600000, 0x38604000, 0x38608000, 0x3860C000, 0x38610000, 0x38614000, 0x38618000, 0x3861C000, 0x38620000, 0x38624000, 0x38628000, 0x3862C000, 0x38630000, 0x38634000, 0x38638000, 0x3863C000,
  0x38640000, 0x38644000, 0x38648000, 0x3864C000, 0x38650000, 0x38654000, 0x38658000, 0x3865C000, 0x38660000, 0x38664000, 0x38668000, 0x3866C000, 0x38670000, 0x38674000, 0x38678000, 0x3867C000,
  0x38680000, 0x38684000, 0x38688000, 0x3868C000, 0x38690000, 0x38694000, 0x38698000, 0x3869C000, 0x386A0000, 0x386A4000, 0x386A8000, 0x386AC000, 0x386B0000, 0x386B4000, 0x386B8000, 0x386BC000,
  0x386C0000, 0x386C4000, 0x386C8000, 0x386CC000, 0x386D0000, 0x386D4000, 0x386D8000, 0x386DC000, 0x386E0000, 0x386E4000, 0x386E8000, 0x386EC000, 0x386F0000, 0x386F4000, 0x386F8000, 0x386FC000,
  0x38700000, 0x38704000, 0x38708000, 0x3870C000, 0x38710000, 0x38714000, 0x38718000, 0x3871C000, 0x38720000, 0x38724000, 0x38728000, 0x3872C000, 0x38730000, 0x38734000, 0x38738000, 0x3873C000,
  0x38740000, 0x38744000, 0x38748000, 0x3874C000, 0x38750000, 0x38754000, 0x38758000, 0x3875C000, 0x38760000, 0x38764000, 0x38768000, 0x3876C000, 0x38770000, 0x38774000, 0x38778000, 0x3877C000,
  0x38780000, 0x38784000, 0x38788000, 0x3878C000, 0x38790000, 0x38794000, 0x38798000, 0x3879C000, 0x387A0000, 0x387A4000, 0x387A8000, 0x387AC000, 0x387B0000, 0x387B4000, 0x387B8000, 0x387BC000,
  0x387C0000, 0x387C4000, 0x387C8000, 0x387CC000, 0x387D0000, 0x387D4000, 0x387D8000, 0x387DC000, 0x387E0000, 0x387E4000, 0x387E8000, 0x387EC000, 0x387F0000, 0x387F4000, 0x387F8000, 0x387FC000,
  0x38000000, 0x38002000, 0x38004000, 0x38006000, 0x38008000, 0x3800A000, 0x3800C000, 0x3800E000, 0x38010000, 0x38012000, 0x38014000, 0x38016000, 0x38018000, 0x3801A000, 0x3801C000, 0x3801E000,
  0x38020000, 0x38022000, 0x38024000, 0x38026000, 0x38028000, 0x3802A000, 0x3802C000, 0x3802E000, 0x38030000, 0x38032000, 0x38034000, 0x38036000, 0x38038000, 0x3803A000, 0x3803C000, 0x3803E000,
  0x38040000, 0x38042000, 0x38044000, 0x38046000, 0x38048000, 0x3804A000, 0x3804C000, 0x3804E000, 0x38050000, 0x38052000, 0x38054000, 0x38056000, 0x38058000, 0x3805A000, 0x3805C000, 0x3805E000,
  0x38060000, 0x38062000, 0x38064000, 0x38066000, 0x38068000, 0x3806A000, 0x3806C000, 0x3806E000, 0x38070000, 0x38072000, 0x38074000, 0x38076000, 0x38078000, 0x3807A000, 0x3807C000, 0x3807E000,
  0x38080000, 0x38082000, 0x38084000, 0x38086000, 0x38088000, 0x3808A000, 0x3808C000, 0x3808E000, 0x38090000, 0x38092000, 0x38094000, 0x38096000, 0x38098000, 0x3809A000, 0x3809C000, 0x3809E000,
  0x380A0000, 0x380A2000, 0x380A4000, 0x380A6000, 0x380A8000, 0x380AA000, 0x380AC000, 0x380AE000, 0x380B0000, 0x380B2000, 0x380B4000, 0x380B6000, 0x380B8000, 0x380BA000, 0x380BC000, 0x380BE000,
  0x380C0000, 0x380C2000, 0x380C4000, 0x380C6000, 0x380C8000, 0x380CA000, 0x380CC000, 0x380CE000, 0x380D0000, 0x380D2000, 0x380D4000, 0x380D6000, 0x380D8000, 0x380DA000, 0x380DC000, 0x380DE000,
  0x380E0000, 0x380E2000, 0x380E4000, 0x380E6000, 0x380E8000, 0x380EA000, 0x380EC000, 0x380EE000, 0x380F0000, 0x380F2000, 0x380F4000, 0x380F6000, 0x380F8000, 0x380FA000, 0x380FC000, 0x380FE000,
  0x38100000, 0x38102000, 0x38104000, 0x38106000, 0x38108000, 0x3810A000, 0x3810C000, 0x3810E000, 0x38110000, 0x38112000, 0x38114000, 0x38116000, 0x38118000, 0x3811A000, 0x3811C000, 0x3811E000,
  0x38120000, 0x38122000, 0x38124000, 0x38126000, 0x38128000, 0x3812A000, 0x3812C000, 0x3812E000, 0x38130000, 0x38132000, 0x38134000, 0x38136000, 0x38138000, 0x3813A000, 0x3813C000, 0x3813E000,
  0x38140000, 0x38142000, 0x38144000, 0x38146000, 0x38148000, 0x3814A000, 0x3814C000, 0x3814E000, 0x38150000, 0x38152000, 0x38154000, 0x38156000, 0x38158000, 0x3815A000, 0x3815C000, 0x3815E000,
  0x38160000, 0x38162000, 0x38164000, 0x38166000, 0x38168000, 0x3816A000, 0x3816C000, 0x3816E000, 0x38170000, 0x38172000, 0x38174000, 0x38176000, 0x38178000, 0x3817A000, 0x3817C000, 0x3817E000,
  0x38180000, 0x38182000, 0x38184000, 0x38186000, 0x38188000, 0x3818A000, 0x3818C000, 0x3818E000, 0x38190000, 0x38192000, 0x38194000, 0x38196000, 0x38198000, 0x3819A000, 0x3819C000, 0x3819E000,
  0x381A0000, 0x381A2000, 0x381A4000, 0x381A6000, 0x381A8000, 0x381AA000, 0x381AC000, 0x381AE000, 0x381B0000, 0x381B2000, 0x381B4000, 0x381B6000, 0x381B8000, 0x381BA000, 0x381BC000, 0x381BE000,
  0x381C0000, 0x381C2000, 0x381C4000, 0x381C6000, 0x381C8000, 0x381CA000, 0x381CC000, 0x381CE000, 0x381D0000, 0x381D2000, 0x381D4000, 0x381D6000, 0x381D8000, 0x381DA000, 0x381DC000, 0x381DE000,
  0x381E0000, 0x381E2000, 0x381E4000, 0x381E6000, 0x381E8000, 0x381EA000, 0x381EC000, 0x381EE000, 0x381F0000, 0x381F2000, 0x381F4000, 0x381F6000, 0x381F8000, 0x381FA000, 0x381FC000, 0x381FE000,
  0x38200000, 0x38202000, 0x38204000, 0x38206000, 0x38208000, 0x3820A000, 0x3820C000, 0x3820E000, 0x38210000, 0x38212000, 0x38214000, 0x38216000, 0x38218000, 0x3821A000, 0x3821C000, 0x3821E000,
  0x38220000, 0x38222000, 0x38224000, 0x38226000, 0x38228000, 0x3822A000, 0x3822C000, 0x3822E000, 0x38230000, 0x38232000, 0x38234000, 0x38236000, 0x38238000, 0x3823A000, 0x3823C000, 0x3823E000,
  0x38240000, 0x38242000, 0x38244000, 0x38246000, 0x38248000, 0x3824A000, 0x3824C000, 0x3824E000, 0x38250000, 0x38252000, 0x38254000, 0x38256000, 0x38258000, 0x3825A000, 0x3825C000, 0x3825E000,
  0x38260000, 0x38262000, 0x38264000, 0x38266000, 0x38268000, 0x3826A000, 0x3826C000, 0x3826E000, 0x38270000, 0x38272000, 0x38274000, 0x38276000, 0x38278000, 0x3827A000, 0x3827C000, 0x3827E000,
  0x38280000, 0x38282000, 0x38284000, 0x38286000, 0x38288000, 0x3828A000, 0x3828C000, 0x3828E000, 0x38290000, 0x38292000, 0x38294000, 0x38296000, 0x38298000, 0x3829A000, 0x3829C000, 0x3829E000,
  0x382A0000, 0x382A2000, 0x382A4000, 0x382A6000, 0x382A8000, 0x382AA000, 0x382AC000, 0x382AE000, 0x382B0000, 0x382B2000, 0x382B4000, 0x382B6000, 0x382B8000, 0x382BA000, 0x382BC000, 0x382BE000,
  0x382C0000, 0x382C2000, 0x382C4000, 0x382C6000, 0x382C8000, 0x382CA000, 0x382CC000, 0x382CE000, 0x382D0000, 0x382D2000, 0x382D4000, 0x382D6000, 0x382D8000, 0x382DA000, 0x382DC000, 0x382DE000,
  0x382E0000, 0x382E2000, 0x382E4000, 0x382E6000, 0x382E8000, 0x382EA000, 0x382EC000, 0x382EE000, 0x382F0000, 0x382F2000, 0x382F4000, 0x382F6000, 0x382F8000, 0x382FA000, 0x382FC000, 0x382FE000,
  0x38300000, 0x38302000, 0x38304000, 0x38306000, 0x38308000, 0x3830A000, 0x3830C000, 0x3830E000, 0x38310000, 0x38312000, 0x38314000, 0x38316000, 0x38318000, 0x3831A000, 0x3831C000, 0x3831E000,
  0x38320000, 0x38322000, 0x38324000, 0x38326000, 0x38328000, 0x3832A000, 0x3832C000, 0x3832E000, 0x38330000, 0x38332000, 0x38334000, 0x38336000, 0x38338000, 0x3833A000, 0x3833C000, 0x3833E000,
  0x38340000, 0x38342000, 0x38344000, 0x38346000, 0x38348000, 0x3834A000, 0x3834C000, 0x3834E000, 0x38350000, 0x38352000, 0x38354000, 0x38356000, 0x38358000, 0x3835A000, 0x3835C000, 0x3835E000,
  0x38360000, 0x38362000, 0x38364000, 0x38366000, 0x38368000, 0x3836A000, 0x3836C000, 0x3836E000, 0x38370000, 0x38372000, 0x38374000, 0x38376000, 0x38378000, 0x3837A000, 0x3837C000, 0x3837E000,
  0x38380000, 0x38382000, 0x38384000, 0x38386000, 0x38388000, 0x3838A000, 0x3838C000, 0x3838E000, 0x38390000, 0x38392000, 0x38394000, 0x38396000, 0x38398000, 0x3839A000, 0x3839C000, 0x3839E000,
  0x383A0000, 0x383A2000, 0x383A4000, 0x383A6000, 0x383A8000, 0x383AA000, 0x383AC000, 0x383AE000, 0x383B0000, 0x383B2000, 0x383B4000, 0x383B6000, 0x383B8000, 0x383BA000, 0x383BC000, 0x383BE000,
  0x383C0000, 0x383C2000, 0x383C4000, 0x383C6000, 0x383C8000, 0x383CA000, 0x383CC000, 0x383CE000, 0x383D0000, 0x383D2000, 0x383D4000, 0x383D6000, 0x383D8000, 0x383DA000, 0x383DC000, 0x383DE000,
  0x383E0000, 0x383E2000, 0x383E4000, 0x383E6000, 0x383E8000, 0x383EA000, 0x383EC000, 0x383EE000, 0x383F0000, 0x383F2000, 0x383F4000, 0x383F6000, 0x383F8000, 0x383FA000, 0x383FC000, 0x383FE000,
  0x38400000, 0x38402000, 0x38404000, 0x38406000, 0x38408000, 0x3840A000, 0x3840C000, 0x3840E000, 0x38410000, 0x38412000, 0x38414000, 0x38416000, 0x38418000, 0x3841A000, 0x3841C000, 0x3841E000,
  0x38420000, 0x38422000, 0x38424000, 0x38426000, 0x38428000, 0x3842A000, 0x3842C000, 0x3842E000, 0x38430000, 0x38432000, 0x38434000, 0x38436000, 0x38438000, 0x3843A000, 0x3843C000, 0x3843E000,
  0x38440000, 0x38442000, 0x38444000, 0x38446000, 0x38448000, 0x3844A000, 0x3844C000, 0x3844E000, 0x38450000, 0x38452000, 0x38454000, 0x38456000, 0x38458000, 0x3845A000, 0x3845C000, 0x3845E000,
  0x38460000, 0x38462000, 0x38464000, 0x38466000, 0x38468000, 0x3846A000, 0x3846C000, 0x3846E000, 0x38470000, 0x38472000, 0x38474000, 0x38476000, 0x38478000, 0x3847A000, 0x3847C000, 0x3847E000,
  0x38480000, 0x38482000, 0x38484000, 0x38486000, 0x38488000, 0x3848A000, 0x3848C000, 0x3848E000, 0x38490000, 0x38492000, 0x38494000, 0x38496000, 0x38498000, 0x3849A000, 0x3849C000, 0x3849E000,
  0x384A0000, 0x384A2000, 0x384A4000, 0x384A6000, 0x384A8000, 0x384AA000, 0x384AC000, 0x384AE000, 0x384B0000, 0x384B2000, 0x384B4000, 0x384B6000, 0x384B8000, 0x384BA000, 0x384BC000, 0x384BE000,
  0x384C0000, 0x384C2000, 0x384C4000, 0x384C6000, 0x384C8000, 0x384CA000, 0x384CC000, 0x384CE000, 0x384D0000, 0x384D2000, 0x384D4000, 0x384D6000, 0x384D8000, 0x384DA000, 0x384DC000, 0x384DE000,
  0x384E0000, 0x384E2000, 0x384E4000, 0x384E6000, 0x384E8000, 0x384EA000, 0x384EC000, 0x384EE000, 0x384F0000, 0x384F2000, 0x384F4000, 0x384F6000, 0x384F8000, 0x384FA000, 0x384FC000, 0x384FE000,
  0x38500000, 0x38502000, 0x38504000, 0x38506000, 0x38508000, 0x3850A000, 0x3850C000, 0x3850E000, 0x38510000, 0x38512000, 0x38514000, 0x38516000, 0x38518000, 0x3851A000, 0x3851C000, 0x3851E000,
  0x38520000, 0x38522000, 0x38524000, 0x38526000, 0x38528000, 0x3852A000, 0x3852C000, 0x3852E000, 0x38530000, 0x38532000, 0x38534000, 0x38536000, 0x38538000, 0x3853A000, 0x3853C000, 0x3853E000,
  0x38540000, 0x38542000, 0x38544000, 0x38546000, 0x38548000, 0x3854A000, 0x3854C000, 0x3854E000, 0x38550000, 0x38552000, 0x38554000, 0x38556000, 0x38558000, 0x3855A000, 0x3855C000, 0x3855E000,
  0x38560000, 0x38562000, 0x38564000, 0x38566000, 0x38568000, 0x3856A000, 0x3856C000, 0x3856E000, 0x38570000, 0x38572000, 0x38574000, 0x38576000, 0x38578000, 0x3857A000, 0x3857C000, 0x3857E000,
  0x38580000, 0x38582000, 0x38584000, 0x38586000, 0x38588000, 0x3858A000, 0x3858C000, 0x3858E000, 0x38590000, 0x38592000, 0x38594000, 0x38596000, 0x38598000, 0x3859A000, 0x3859C000, 0x3859E000,
  0x385A0000, 0x385A2000, 0x385A4000, 0x385A6000, 0x385A8000, 0x385AA000, 0x385AC000, 0x385AE000, 0x385B0000, 0x385B2000, 0x385B4000, 0x385B6000, 0x385B8000, 0x385BA000, 0x385BC000, 0x385BE000,
  0x385C0000, 0x385C2000, 0x385C4000, 0x385C6000, 0x385C8000, 0x385CA000, 0x385CC000, 0x385CE000, 0x385D0000, 0x385D2000, 0x385D4000, 0x385D6000, 0x385D8000, 0x385DA000, 0x385DC000, 0x385DE000,
  0x385E0000, 0x385E2000, 0x385E4000, 0x385E6000, 0x385E8000, 0x385EA000, 0x385EC000, 0x385EE000, 0x385F0000, 0x385F2000, 0x385F4000, 0x385F6000, 0x385F8000, 0x385FA000, 0x385FC000, 0x385FE000,
  0x38600000, 0x38602000, 0x38604000, 0x38606000, 0x38608000, 0x3860A000, 0x3860C000, 0x3860E000, 0x38610000, 0x38612000, 0x38614000, 0x38616000, 0x38618000, 0x3861A000, 0x3861C000, 0x3861E000,
  0x38620000, 0x38622000, 0x38624000, 0x38626000, 0x38628000, 0x3862A000, 0x3862C000, 0x3862E000, 0x38630000, 0x38632000, 0x38634000, 0x38636000, 0x38638000, 0x3863A000, 0x3863C000, 0x3863E000,
  0x38640000, 0x38642000, 0x38644000, 0x38646000, 0x38648000, 0x3864A000, 0x3864C000, 0x3864E000, 0x38650000, 0x38652000, 0x38654000, 0x38656000, 0x38658000, 0x3865A000, 0x3865C000, 0x3865E000,
  0x38660000, 0x38662000, 0x38664000, 0x38666000, 0x38668000, 0x3866A000, 0x3866C000, 0x3866E000, 0x38670000, 0x38672000, 0x38674000, 0x38676000, 0x38678000, 0x3867A000, 0x3867C000, 0x3867E000,
  0x38680000, 0x38682000, 0x38684000, 0x38686000, 0x38688000, 0x3868A000, 0x3868C000, 0x3868E000, 0x38690000, 0x38692000, 0x38694000, 0x38696000, 0x38698000, 0x3869A000, 0x3869C000, 0x3869E000,
  0x386A0000, 0x386A2000, 0x386A4000, 0x386A6000, 0x386A8000, 0x386AA000, 0x386AC000, 0x386AE000, 0x386B0000, 0x386B2000, 0x386B4000, 0x386B6000, 0x386B8000, 0x386BA000, 0x386BC000, 0x386BE000,
  0x386C0000, 0x386C2000, 0x386C4000, 0x386C6000, 0x386C8000, 0x386CA000, 0x386CC000, 0x386CE000, 0x386D0000, 0x386D2000, 0x386D4000, 0x386D6000, 0x386D8000, 0x386DA000, 0x386DC000, 0x386DE000,
  0x386E0000, 0x386E2000, 0x386E4000, 0x386E6000, 0x386E8000, 0x386EA000, 0x386EC000, 0x386EE000, 0x386F0000, 0x386F2000, 0x386F4000, 0x386F6000, 0x386F8000, 0x386FA000, 0x386FC000, 0x386FE000,
  0x38700000, 0x38702000, 0x38704000, 0x38706000, 0x38708000, 0x3870A000, 0x3870C000, 0x3870E000, 0x38710000, 0x38712000, 0x38714000, 0x38716000, 0x38718000, 0x3871A000, 0x3871C000, 0x3871E000,
  0x38720000, 0x38722000, 0x38724000, 0x38726000, 0x38728000, 0x3872A000, 0x3872C000, 0x3872E000, 0x38730000, 0x38732000, 0x38734000, 0x38736000, 0x38738000, 0x3873A000, 0x3873C000, 0x3873E000,
  0x38740000, 0x38742000, 0x38744000, 0x38746000, 0x38748000, 0x3874A000, 0x3874C000, 0x3874E000, 0x38750000, 0x38752000, 0x38754000, 0x38756000, 0x38758000, 0x3875A000, 0x3875C000, 0x3875E000,
  0x38760000, 0x38762000, 0x38764000, 0x38766000, 0x38768000, 0x3876A000, 0x3876C000, 0x3876E000, 0x38770000, 0x38772000, 0x38774000, 0x38776000, 0x38778000, 0x3877A000, 0x3877C000, 0x3877E000,
  0x38780000, 0x38782000, 0x38784000, 0x38786000, 0x38788000, 0x3878A000, 0x3878C000, 0x3878E000, 0x38790000, 0x38792000, 0x38794000, 0x38796000, 0x38798000, 0x3879A000, 0x3879C000, 0x3879E000,
  0x387A0000, 0x387A2000, 0x387A4000, 0x387A6000, 0x387A8000, 0x387AA000, 0x387AC000, 0x387AE000, 0x387B0000, 0x387B2000, 0x387B4000, 0x387B6000, 0x387B8000, 0x387BA000, 0x387BC000, 0x387BE000,
  0x387C0000, 0x387C2000, 0x387C4000, 0x387C6000, 0x387C8000, 0x387CA000, 0x387CC000, 0x387CE000, 0x387D0000, 0x387D2000, 0x387D4000, 0x387D6000, 0x387D8000, 0x387DA000, 0x387DC000, 0x387DE000,
  0x387E0000, 0x387E2000, 0x387E4000, 0x387E6000, 0x387E8000, 0x387EA000, 0x387EC000, 0x387EE000, 0x387F0000, 0x387F2000, 0x387F4000, 0x387F6000, 0x387F8000, 0x387FA000, 0x387FC000, 0x387FE000 };
__constant static const uint32_t exponent_table[64] = {
  0x00000000, 0x00800000, 0x01000000, 0x01800000, 0x02000000, 0x02800000, 0x03000000, 0x03800000, 0x04000000, 0x04800000, 0x05000000, 0x05800000, 0x06000000, 0x06800000, 0x07000000, 0x07800000,
  0x08000000, 0x08800000, 0x09000000, 0x09800000, 0x0A000000, 0x0A800000, 0x0B000000, 0x0B800000, 0x0C000000, 0x0C800000, 0x0D000000, 0x0D800000, 0x0E000000, 0x0E800000, 0x0F000000, 0x47800000,
  0x80000000, 0x80800000, 0x81000000, 0x81800000, 0x82000000, 0x82800000, 0x83000000, 0x83800000, 0x84000000, 0x84800000, 0x85000000, 0x85800000, 0x86000000, 0x86800000, 0x87000000, 0x87800000,
  0x88000000, 0x88800000, 0x89000000, 0x89800000, 0x8A000000, 0x8A800000, 0x8B000000, 0x8B800000, 0x8C000000, 0x8C800000, 0x8D000000, 0x8D800000, 0x8E000000, 0x8E800000, 0x8F000000, 0xC7800000 };
__constant static const unsigned short offset_table[64] = {
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024 };

static uint16_t float2halfbits(float value) {
  union { float x; uint32_t y; } u;
  u.x = value;
  uint32_t bits = u.y;

  uint16_t hbits = base_table[bits>>23] + (uint16_t)((bits&0x7FFFFF)>>shift_table[bits>>23]);;

  return hbits;
}

static float halfbits2float(uint16_t value) {
  uint32_t bits = mantissa_table[offset_table[value>>10]+(value&0x3FF)] + exponent_table[value>>10];

  union { uint32_t x; float y; } u;
  u.x = bits;
  return u.y;
}

// End of half.h.
// Start of timing.h.

// The function get_wall_time() returns the wall time in microseconds
// (with an unspecified offset).

#ifdef _WIN32

#include <windows.h>

static int64_t get_wall_time(void) {
  LARGE_INTEGER time,freq;
  assert(QueryPerformanceFrequency(&freq));
  assert(QueryPerformanceCounter(&time));
  return ((double)time.QuadPart / freq.QuadPart) * 1000000;
}

#else
// Assuming POSIX

#include <time.h>
#include <sys/time.h>

static int64_t get_wall_time(void) {
  struct timeval time;
  assert(gettimeofday(&time,NULL) == 0);
  return time.tv_sec * 1000000 + time.tv_usec;
}

static int64_t get_wall_time_ns(void) {
  struct timespec time;
  assert(clock_gettime(CLOCK_REALTIME, &time) == 0);
  return time.tv_sec * 1000000000 + time.tv_nsec;
}

#endif

// End of timing.h.

#ifdef _MSC_VER
#define inline __inline
#endif
#include <string.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include <ctype.h>



// Start of lock.h.

// A very simple cross-platform implementation of locks.  Uses
// pthreads on Unix and some Windows thing there.  Futhark's
// host-level code is not multithreaded, but user code may be, so we
// need some mechanism for ensuring atomic access to API functions.
// This is that mechanism.  It is not exposed to user code at all, so
// we do not have to worry about name collisions.

#ifdef _WIN32

typedef HANDLE lock_t;

static void create_lock(lock_t *lock) {
  *lock = CreateMutex(NULL,  // Default security attributes.
                      FALSE, // Initially unlocked.
                      NULL); // Unnamed.
}

static void lock_lock(lock_t *lock) {
  assert(WaitForSingleObject(*lock, INFINITE) == WAIT_OBJECT_0);
}

static void lock_unlock(lock_t *lock) {
  assert(ReleaseMutex(*lock));
}

static void free_lock(lock_t *lock) {
  CloseHandle(*lock);
}

#else
// Assuming POSIX

#include <pthread.h>

typedef pthread_mutex_t lock_t;

static void create_lock(lock_t *lock) {
  int r = pthread_mutex_init(lock, NULL);
  assert(r == 0);
}

static void lock_lock(lock_t *lock) {
  int r = pthread_mutex_lock(lock);
  assert(r == 0);
}

static void lock_unlock(lock_t *lock) {
  int r = pthread_mutex_unlock(lock);
  assert(r == 0);
}

static void free_lock(lock_t *lock) {
  // Nothing to do for pthreads.
  (void)lock;
}

#endif

// End of lock.h.

#define FUTHARK_F64_ENABLED

// Start of scalar.h.

// Implementation of the primitive scalar operations.  Very
// repetitive.  This code is inserted directly into both CUDA and
// OpenCL programs, as well as the CPU code, so it has some #ifdefs to
// work everywhere.  Some operations are defined as macros because
// this allows us to use them as constant expressions in things like
// array sizes and static initialisers.

// Some of the #ifdefs are because OpenCL uses type-generic functions
// for some operations (e.g. sqrt), while C and CUDA sensibly use
// distinct functions for different precisions (e.g. sqrtf() and
// sqrt()).  This is quite annoying.  Due to C's unfortunate casting
// rules, it is also really easy to accidentally implement
// floating-point functions in the wrong precision, so be careful.

// Double-precision definitions are only included if the preprocessor
// macro FUTHARK_F64_ENABLED is set.

static inline uint8_t add8(uint8_t x, uint8_t y) {
  return x + y;
}

static inline uint16_t add16(uint16_t x, uint16_t y) {
  return x + y;
}

static inline uint32_t add32(uint32_t x, uint32_t y) {
  return x + y;
}

static inline uint64_t add64(uint64_t x, uint64_t y) {
  return x + y;
}

static inline uint8_t sub8(uint8_t x, uint8_t y) {
  return x - y;
}

static inline uint16_t sub16(uint16_t x, uint16_t y) {
  return x - y;
}

static inline uint32_t sub32(uint32_t x, uint32_t y) {
  return x - y;
}

static inline uint64_t sub64(uint64_t x, uint64_t y) {
  return x - y;
}

static inline uint8_t mul8(uint8_t x, uint8_t y) {
  return x * y;
}

static inline uint16_t mul16(uint16_t x, uint16_t y) {
  return x * y;
}

static inline uint32_t mul32(uint32_t x, uint32_t y) {
  return x * y;
}

static inline uint64_t mul64(uint64_t x, uint64_t y) {
  return x * y;
}

static inline uint8_t udiv8(uint8_t x, uint8_t y) {
  return x / y;
}

static inline uint16_t udiv16(uint16_t x, uint16_t y) {
  return x / y;
}

static inline uint32_t udiv32(uint32_t x, uint32_t y) {
  return x / y;
}

static inline uint64_t udiv64(uint64_t x, uint64_t y) {
  return x / y;
}

static inline uint8_t udiv_up8(uint8_t x, uint8_t y) {
  return (x + y - 1) / y;
}

static inline uint16_t udiv_up16(uint16_t x, uint16_t y) {
  return (x + y - 1) / y;
}

static inline uint32_t udiv_up32(uint32_t x, uint32_t y) {
  return (x + y - 1) / y;
}

static inline uint64_t udiv_up64(uint64_t x, uint64_t y) {
  return (x + y - 1) / y;
}

static inline uint8_t umod8(uint8_t x, uint8_t y) {
  return x % y;
}

static inline uint16_t umod16(uint16_t x, uint16_t y) {
  return x % y;
}

static inline uint32_t umod32(uint32_t x, uint32_t y) {
  return x % y;
}

static inline uint64_t umod64(uint64_t x, uint64_t y) {
  return x % y;
}

static inline uint8_t udiv_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint16_t udiv_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint32_t udiv_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint64_t udiv_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint8_t udiv_up_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint16_t udiv_up_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint32_t udiv_up_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint64_t udiv_up_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint8_t umod_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint16_t umod_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint32_t umod_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint64_t umod_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t sdiv8(int8_t x, int8_t y) {
  int8_t q = x / y;
  int8_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int16_t sdiv16(int16_t x, int16_t y) {
  int16_t q = x / y;
  int16_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int32_t sdiv32(int32_t x, int32_t y) {
  int32_t q = x / y;
  int32_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int64_t sdiv64(int64_t x, int64_t y) {
  int64_t q = x / y;
  int64_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int8_t sdiv_up8(int8_t x, int8_t y) {
  return sdiv8(x + y - 1, y);
}

static inline int16_t sdiv_up16(int16_t x, int16_t y) {
  return sdiv16(x + y - 1, y);
}

static inline int32_t sdiv_up32(int32_t x, int32_t y) {
  return sdiv32(x + y - 1, y);
}

static inline int64_t sdiv_up64(int64_t x, int64_t y) {
  return sdiv64(x + y - 1, y);
}

static inline int8_t smod8(int8_t x, int8_t y) {
  int8_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int16_t smod16(int16_t x, int16_t y) {
  int16_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int32_t smod32(int32_t x, int32_t y) {
  int32_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int64_t smod64(int64_t x, int64_t y) {
  int64_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int8_t sdiv_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : sdiv8(x, y);
}

static inline int16_t sdiv_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : sdiv16(x, y);
}

static inline int32_t sdiv_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : sdiv32(x, y);
}

static inline int64_t sdiv_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : sdiv64(x, y);
}

static inline int8_t sdiv_up_safe8(int8_t x, int8_t y) {
  return sdiv_safe8(x + y - 1, y);
}

static inline int16_t sdiv_up_safe16(int16_t x, int16_t y) {
  return sdiv_safe16(x + y - 1, y);
}

static inline int32_t sdiv_up_safe32(int32_t x, int32_t y) {
  return sdiv_safe32(x + y - 1, y);
}

static inline int64_t sdiv_up_safe64(int64_t x, int64_t y) {
  return sdiv_safe64(x + y - 1, y);
}

static inline int8_t smod_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : smod8(x, y);
}

static inline int16_t smod_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : smod16(x, y);
}

static inline int32_t smod_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : smod32(x, y);
}

static inline int64_t smod_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : smod64(x, y);
}

static inline int8_t squot8(int8_t x, int8_t y) {
  return x / y;
}

static inline int16_t squot16(int16_t x, int16_t y) {
  return x / y;
}

static inline int32_t squot32(int32_t x, int32_t y) {
  return x / y;
}

static inline int64_t squot64(int64_t x, int64_t y) {
  return x / y;
}

static inline int8_t srem8(int8_t x, int8_t y) {
  return x % y;
}

static inline int16_t srem16(int16_t x, int16_t y) {
  return x % y;
}

static inline int32_t srem32(int32_t x, int32_t y) {
  return x % y;
}

static inline int64_t srem64(int64_t x, int64_t y) {
  return x % y;
}

static inline int8_t squot_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int16_t squot_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int32_t squot_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int64_t squot_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int8_t srem_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int16_t srem_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int32_t srem_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int64_t srem_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t smin8(int8_t x, int8_t y) {
  return x < y ? x : y;
}

static inline int16_t smin16(int16_t x, int16_t y) {
  return x < y ? x : y;
}

static inline int32_t smin32(int32_t x, int32_t y) {
  return x < y ? x : y;
}

static inline int64_t smin64(int64_t x, int64_t y) {
  return x < y ? x : y;
}

static inline uint8_t umin8(uint8_t x, uint8_t y) {
  return x < y ? x : y;
}

static inline uint16_t umin16(uint16_t x, uint16_t y) {
  return x < y ? x : y;
}

static inline uint32_t umin32(uint32_t x, uint32_t y) {
  return x < y ? x : y;
}

static inline uint64_t umin64(uint64_t x, uint64_t y) {
  return x < y ? x : y;
}

static inline int8_t smax8(int8_t x, int8_t y) {
  return x < y ? y : x;
}

static inline int16_t smax16(int16_t x, int16_t y) {
  return x < y ? y : x;
}

static inline int32_t smax32(int32_t x, int32_t y) {
  return x < y ? y : x;
}

static inline int64_t smax64(int64_t x, int64_t y) {
  return x < y ? y : x;
}

static inline uint8_t umax8(uint8_t x, uint8_t y) {
  return x < y ? y : x;
}

static inline uint16_t umax16(uint16_t x, uint16_t y) {
  return x < y ? y : x;
}

static inline uint32_t umax32(uint32_t x, uint32_t y) {
  return x < y ? y : x;
}

static inline uint64_t umax64(uint64_t x, uint64_t y) {
  return x < y ? y : x;
}

static inline uint8_t shl8(uint8_t x, uint8_t y) {
  return (uint8_t)(x << y);
}

static inline uint16_t shl16(uint16_t x, uint16_t y) {
  return (uint16_t)(x << y);
}

static inline uint32_t shl32(uint32_t x, uint32_t y) {
  return x << y;
}

static inline uint64_t shl64(uint64_t x, uint64_t y) {
  return x << y;
}

static inline uint8_t lshr8(uint8_t x, uint8_t y) {
  return x >> y;
}

static inline uint16_t lshr16(uint16_t x, uint16_t y) {
  return x >> y;
}

static inline uint32_t lshr32(uint32_t x, uint32_t y) {
  return x >> y;
}

static inline uint64_t lshr64(uint64_t x, uint64_t y) {
  return x >> y;
}

static inline int8_t ashr8(int8_t x, int8_t y) {
  return x >> y;
}

static inline int16_t ashr16(int16_t x, int16_t y) {
  return x >> y;
}

static inline int32_t ashr32(int32_t x, int32_t y) {
  return x >> y;
}

static inline int64_t ashr64(int64_t x, int64_t y) {
  return x >> y;
}

static inline uint8_t and8(uint8_t x, uint8_t y) {
  return x & y;
}

static inline uint16_t and16(uint16_t x, uint16_t y) {
  return x & y;
}

static inline uint32_t and32(uint32_t x, uint32_t y) {
  return x & y;
}

static inline uint64_t and64(uint64_t x, uint64_t y) {
  return x & y;
}

static inline uint8_t or8(uint8_t x, uint8_t y) {
  return x | y;
}

static inline uint16_t or16(uint16_t x, uint16_t y) {
  return x | y;
}

static inline uint32_t or32(uint32_t x, uint32_t y) {
  return x | y;
}

static inline uint64_t or64(uint64_t x, uint64_t y) {
  return x | y;
}

static inline uint8_t xor8(uint8_t x, uint8_t y) {
  return x ^ y;
}

static inline uint16_t xor16(uint16_t x, uint16_t y) {
  return x ^ y;
}

static inline uint32_t xor32(uint32_t x, uint32_t y) {
  return x ^ y;
}

static inline uint64_t xor64(uint64_t x, uint64_t y) {
  return x ^ y;
}

static inline bool ult8(uint8_t x, uint8_t y) {
  return x < y;
}

static inline bool ult16(uint16_t x, uint16_t y) {
  return x < y;
}

static inline bool ult32(uint32_t x, uint32_t y) {
  return x < y;
}

static inline bool ult64(uint64_t x, uint64_t y) {
  return x < y;
}

static inline bool ule8(uint8_t x, uint8_t y) {
  return x <= y;
}

static inline bool ule16(uint16_t x, uint16_t y) {
  return x <= y;
}

static inline bool ule32(uint32_t x, uint32_t y) {
  return x <= y;
}

static inline bool ule64(uint64_t x, uint64_t y) {
  return x <= y;
}

static inline bool slt8(int8_t x, int8_t y) {
  return x < y;
}

static inline bool slt16(int16_t x, int16_t y) {
  return x < y;
}

static inline bool slt32(int32_t x, int32_t y) {
  return x < y;
}

static inline bool slt64(int64_t x, int64_t y) {
  return x < y;
}

static inline bool sle8(int8_t x, int8_t y) {
  return x <= y;
}

static inline bool sle16(int16_t x, int16_t y) {
  return x <= y;
}

static inline bool sle32(int32_t x, int32_t y) {
  return x <= y;
}

static inline bool sle64(int64_t x, int64_t y) {
  return x <= y;
}

static inline uint8_t pow8(uint8_t x, uint8_t y) {
  uint8_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint16_t pow16(uint16_t x, uint16_t y) {
  uint16_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint32_t pow32(uint32_t x, uint32_t y) {
  uint32_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint64_t pow64(uint64_t x, uint64_t y) {
  uint64_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline bool itob_i8_bool(int8_t x) {
  return x;
}

static inline bool itob_i16_bool(int16_t x) {
  return x;
}

static inline bool itob_i32_bool(int32_t x) {
  return x;
}

static inline bool itob_i64_bool(int64_t x) {
  return x;
}

static inline int8_t btoi_bool_i8(bool x) {
  return x;
}

static inline int16_t btoi_bool_i16(bool x) {
  return x;
}

static inline int32_t btoi_bool_i32(bool x) {
  return x;
}

static inline int64_t btoi_bool_i64(bool x) {
  return x;
}

#define sext_i8_i8(x) ((int8_t) (int8_t) (x))
#define sext_i8_i16(x) ((int16_t) (int8_t) (x))
#define sext_i8_i32(x) ((int32_t) (int8_t) (x))
#define sext_i8_i64(x) ((int64_t) (int8_t) (x))
#define sext_i16_i8(x) ((int8_t) (int16_t) (x))
#define sext_i16_i16(x) ((int16_t) (int16_t) (x))
#define sext_i16_i32(x) ((int32_t) (int16_t) (x))
#define sext_i16_i64(x) ((int64_t) (int16_t) (x))
#define sext_i32_i8(x) ((int8_t) (int32_t) (x))
#define sext_i32_i16(x) ((int16_t) (int32_t) (x))
#define sext_i32_i32(x) ((int32_t) (int32_t) (x))
#define sext_i32_i64(x) ((int64_t) (int32_t) (x))
#define sext_i64_i8(x) ((int8_t) (int64_t) (x))
#define sext_i64_i16(x) ((int16_t) (int64_t) (x))
#define sext_i64_i32(x) ((int32_t) (int64_t) (x))
#define sext_i64_i64(x) ((int64_t) (int64_t) (x))
#define zext_i8_i8(x) ((int8_t) (uint8_t) (x))
#define zext_i8_i16(x) ((int16_t) (uint8_t) (x))
#define zext_i8_i32(x) ((int32_t) (uint8_t) (x))
#define zext_i8_i64(x) ((int64_t) (uint8_t) (x))
#define zext_i16_i8(x) ((int8_t) (uint16_t) (x))
#define zext_i16_i16(x) ((int16_t) (uint16_t) (x))
#define zext_i16_i32(x) ((int32_t) (uint16_t) (x))
#define zext_i16_i64(x) ((int64_t) (uint16_t) (x))
#define zext_i32_i8(x) ((int8_t) (uint32_t) (x))
#define zext_i32_i16(x) ((int16_t) (uint32_t) (x))
#define zext_i32_i32(x) ((int32_t) (uint32_t) (x))
#define zext_i32_i64(x) ((int64_t) (uint32_t) (x))
#define zext_i64_i8(x) ((int8_t) (uint64_t) (x))
#define zext_i64_i16(x) ((int16_t) (uint64_t) (x))
#define zext_i64_i32(x) ((int32_t) (uint64_t) (x))
#define zext_i64_i64(x) ((int64_t) (uint64_t) (x))

static int8_t abs8(int8_t x) {
  return (int8_t)abs(x);
}

static int16_t abs16(int16_t x) {
  return (int16_t)abs(x);
}

static int32_t abs32(int32_t x) {
  return abs(x);
}

static int64_t abs64(int64_t x) {
#if defined(__OPENCL_VERSION__)
  return abs(x);
#else
  return llabs(x);
#endif
}

#if defined(__OPENCL_VERSION__)
static int32_t futrts_popc8(int8_t x) {
  return popcount(x);
}

static int32_t futrts_popc16(int16_t x) {
  return popcount(x);
}

static int32_t futrts_popc32(int32_t x) {
  return popcount(x);
}

static int32_t futrts_popc64(int64_t x) {
  return popcount(x);
}
#elif defined(__CUDA_ARCH__)

static int32_t futrts_popc8(int8_t x) {
  return __popc(zext_i8_i32(x));
}

static int32_t futrts_popc16(int16_t x) {
  return __popc(zext_i16_i32(x));
}

static int32_t futrts_popc32(int32_t x) {
  return __popc(x);
}

static int32_t futrts_popc64(int64_t x) {
  return __popcll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_popc8(uint8_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc16(uint16_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc32(uint32_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc64(uint64_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  return mul_hi(a, b);
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  return mul_hi(a, b);
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mul_hi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul_hi(a, b);
}

#elif defined(__CUDA_ARCH__)

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mulhi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul64hi(a, b);
}

#else // Not OpenCL or CUDA, but plain C.

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  uint64_t aa = a;
  uint64_t bb = b;

  return aa * bb >> 32;
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  __uint128_t aa = a;
  __uint128_t bb = b;

  return aa * bb >> 64;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return mad_hi(a, b, c);
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return mad_hi(a, b, c);
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return mad_hi(a, b, c);
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return mad_hi(a, b, c);
}

#else // Not OpenCL

static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return futrts_mul_hi8(a, b) + c;
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return futrts_mul_hi16(a, b) + c;
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return futrts_mul_hi32(a, b) + c;
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return futrts_mul_hi64(a, b) + c;
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_clzz8(int8_t x) {
  return clz(x);
}

static int32_t futrts_clzz16(int16_t x) {
  return clz(x);
}

static int32_t futrts_clzz32(int32_t x) {
  return clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return clz(x);
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_clzz8(int8_t x) {
  return __clz(zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return __clz(zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return __clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return __clzll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_clzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_clz((uint32_t)zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_clz((uint32_t)zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_clz((uint32_t)x);
}

static int32_t futrts_clzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_clzll((uint64_t)x);
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_ctzz8(int8_t x) {
  int i = 0;
  for (; i < 8 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz16(int16_t x) {
  int i = 0;
  for (; i < 16 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz32(int32_t x) {
  int i = 0;
  for (; i < 32 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz64(int64_t x) {
  int i = 0;
  for (; i < 64 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_ctzz8(int8_t x) {
  int y = __ffs(x);
  return y == 0 ? 8 : y - 1;
}

static int32_t futrts_ctzz16(int16_t x) {
  int y = __ffs(x);
  return y == 0 ? 16 : y - 1;
}

static int32_t futrts_ctzz32(int32_t x) {
  int y = __ffs(x);
  return y == 0 ? 32 : y - 1;
}

static int32_t futrts_ctzz64(int64_t x) {
  int y = __ffsll(x);
  return y == 0 ? 64 : y - 1;
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_ctzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_ctzll((uint64_t)x);
}
#endif

static inline float fdiv32(float x, float y) {
  return x / y;
}

static inline float fadd32(float x, float y) {
  return x + y;
}

static inline float fsub32(float x, float y) {
  return x - y;
}

static inline float fmul32(float x, float y) {
  return x * y;
}

static inline bool cmplt32(float x, float y) {
  return x < y;
}

static inline bool cmple32(float x, float y) {
  return x <= y;
}

static inline float sitofp_i8_f32(int8_t x) {
  return (float) x;
}

static inline float sitofp_i16_f32(int16_t x) {
  return (float) x;
}

static inline float sitofp_i32_f32(int32_t x) {
  return (float) x;
}

static inline float sitofp_i64_f32(int64_t x) {
  return (float) x;
}

static inline float uitofp_i8_f32(uint8_t x) {
  return (float) x;
}

static inline float uitofp_i16_f32(uint16_t x) {
  return (float) x;
}

static inline float uitofp_i32_f32(uint32_t x) {
  return (float) x;
}

static inline float uitofp_i64_f32(uint64_t x) {
  return (float) x;
}

static inline int8_t fptosi_f32_i8(float x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f32_i16(float x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f32_i32(float x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f32_i64(float x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f32_i8(float x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f32_i16(float x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f32_i32(float x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f32_i64(float x) {
  return (uint64_t) x;
}

#ifdef __OPENCL_VERSION__
static inline float fabs32(float x) {
  return fabs(x);
}

static inline float fmax32(float x, float y) {
  return fmax(x, y);
}

static inline float fmin32(float x, float y) {
  return fmin(x, y);
}

static inline float fpow32(float x, float y) {
  return pow(x, y);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float fabs32(float x) {
  return fabsf(x);
}

static inline float fmax32(float x, float y) {
  return fmaxf(x, y);
}

static inline float fmin32(float x, float y) {
  return fminf(x, y);
}

static inline float fpow32(float x, float y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan32(float x) {
  return isnan(x);
}

static inline bool futrts_isinf32(float x) {
  return isinf(x);
}

#ifdef __OPENCL_VERSION__
static inline float futrts_log32(float x) {
  return log(x);
}

static inline float futrts_log2_32(float x) {
  return log2(x);
}

static inline float futrts_log10_32(float x) {
  return log10(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrt(x);
}

static inline float futrts_exp32(float x) {
  return exp(x);
}

static inline float futrts_cos32(float x) {
  return cos(x);
}

static inline float futrts_sin32(float x) {
  return sin(x);
}

static inline float futrts_tan32(float x) {
  return tan(x);
}

static inline float futrts_acos32(float x) {
  return acos(x);
}

static inline float futrts_asin32(float x) {
  return asin(x);
}

static inline float futrts_atan32(float x) {
  return atan(x);
}

static inline float futrts_cosh32(float x) {
  return cosh(x);
}

static inline float futrts_sinh32(float x) {
  return sinh(x);
}

static inline float futrts_tanh32(float x) {
  return tanh(x);
}

static inline float futrts_acosh32(float x) {
  return acosh(x);
}

static inline float futrts_asinh32(float x) {
  return asinh(x);
}

static inline float futrts_atanh32(float x) {
  return atanh(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypot(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgamma(x);
}

static inline float futrts_lgamma32(float x) {
  return lgamma(x);
}

static inline float fmod32(float x, float y) {
  return fmod(x, y);
}

static inline float futrts_round32(float x) {
  return rint(x);
}

static inline float futrts_floor32(float x) {
  return floor(x);
}

static inline float futrts_ceil32(float x) {
  return ceil(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return mix(v0, v1, t);
}

static inline float futrts_mad32(float a, float b, float c) {
  return mad(a, b, c);
}

static inline float futrts_fma32(float a, float b, float c) {
  return fma(a, b, c);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float futrts_log32(float x) {
  return logf(x);
}

static inline float futrts_log2_32(float x) {
  return log2f(x);
}

static inline float futrts_log10_32(float x) {
  return log10f(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrtf(x);
}

static inline float futrts_exp32(float x) {
  return expf(x);
}

static inline float futrts_cos32(float x) {
  return cosf(x);
}

static inline float futrts_sin32(float x) {
  return sinf(x);
}

static inline float futrts_tan32(float x) {
  return tanf(x);
}

static inline float futrts_acos32(float x) {
  return acosf(x);
}

static inline float futrts_asin32(float x) {
  return asinf(x);
}

static inline float futrts_atan32(float x) {
  return atanf(x);
}

static inline float futrts_cosh32(float x) {
  return coshf(x);
}

static inline float futrts_sinh32(float x) {
  return sinhf(x);
}

static inline float futrts_tanh32(float x) {
  return tanhf(x);
}

static inline float futrts_acosh32(float x) {
  return acoshf(x);
}

static inline float futrts_asinh32(float x) {
  return asinhf(x);
}

static inline float futrts_atanh32(float x) {
  return atanhf(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2f(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypotf(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgammaf(x);
}

static inline float futrts_lgamma32(float x) {
  return lgammaf(x);
}

static inline float fmod32(float x, float y) {
  return fmodf(x, y);
}

static inline float futrts_round32(float x) {
  return rintf(x);
}

static inline float futrts_floor32(float x) {
  return floorf(x);
}

static inline float futrts_ceil32(float x) {
  return ceilf(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return v0 + (v1 - v0) * t;
}

static inline float futrts_mad32(float a, float b, float c) {
  return a * b + c;
}

static inline float futrts_fma32(float a, float b, float c) {
  return fmaf(a, b, c);
}
#endif

static inline int32_t futrts_to_bits32(float x) {
  union {
    float f;
    int32_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline float futrts_from_bits32(int32_t x) {
  union {
    int32_t f;
    float t;
  } p;

  p.f = x;
  return p.t;
}

static inline float fsignum32(float x) {
  return futrts_isnan32(x) ? x : (x > 0) - (x < 0);
}

#ifdef FUTHARK_F64_ENABLED

static inline double fdiv64(double x, double y) {
  return x / y;
}

static inline double fadd64(double x, double y) {
  return x + y;
}

static inline double fsub64(double x, double y) {
  return x - y;
}

static inline double fmul64(double x, double y) {
  return x * y;
}

static inline bool cmplt64(double x, double y) {
  return x < y;
}

static inline bool cmple64(double x, double y) {
  return x <= y;
}

static inline double sitofp_i8_f64(int8_t x) {
  return (double) x;
}

static inline double sitofp_i16_f64(int16_t x) {
  return (double) x;
}

static inline double sitofp_i32_f64(int32_t x) {
  return (double) x;
}

static inline double sitofp_i64_f64(int64_t x) {
  return (double) x;
}

static inline double uitofp_i8_f64(uint8_t x) {
  return (double) x;
}

static inline double uitofp_i16_f64(uint16_t x) {
  return (double) x;
}

static inline double uitofp_i32_f64(uint32_t x) {
  return (double) x;
}

static inline double uitofp_i64_f64(uint64_t x) {
  return (double) x;
}

static inline int8_t fptosi_f64_i8(double x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f64_i16(double x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f64_i32(double x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f64_i64(double x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f64_i8(double x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f64_i16(double x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f64_i32(double x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f64_i64(double x) {
  return (uint64_t) x;
}

static inline double fabs64(double x) {
  return fabs(x);
}

static inline double fmax64(double x, double y) {
  return fmax(x, y);
}

static inline double fmin64(double x, double y) {
  return fmin(x, y);
}

static inline double fpow64(double x, double y) {
  return pow(x, y);
}

static inline double futrts_log64(double x) {
  return log(x);
}

static inline double futrts_log2_64(double x) {
  return log2(x);
}

static inline double futrts_log10_64(double x) {
  return log10(x);
}

static inline double futrts_sqrt64(double x) {
  return sqrt(x);
}

static inline double futrts_exp64(double x) {
  return exp(x);
}

static inline double futrts_cos64(double x) {
  return cos(x);
}

static inline double futrts_sin64(double x) {
  return sin(x);
}

static inline double futrts_tan64(double x) {
  return tan(x);
}

static inline double futrts_acos64(double x) {
  return acos(x);
}

static inline double futrts_asin64(double x) {
  return asin(x);
}

static inline double futrts_atan64(double x) {
  return atan(x);
}

static inline double futrts_cosh64(double x) {
  return cosh(x);
}

static inline double futrts_sinh64(double x) {
  return sinh(x);
}

static inline double futrts_tanh64(double x) {
  return tanh(x);
}

static inline double futrts_acosh64(double x) {
  return acosh(x);
}

static inline double futrts_asinh64(double x) {
  return asinh(x);
}

static inline double futrts_atanh64(double x) {
  return atanh(x);
}

static inline double futrts_atan2_64(double x, double y) {
  return atan2(x, y);
}

static inline double futrts_hypot64(double x, double y) {
  return hypot(x, y);
}

static inline double futrts_gamma64(double x) {
  return tgamma(x);
}

static inline double futrts_lgamma64(double x) {
  return lgamma(x);
}

static inline double futrts_fma64(double a, double b, double c) {
  return fma(a, b, c);
}

static inline double futrts_round64(double x) {
  return rint(x);
}

static inline double futrts_ceil64(double x) {
  return ceil(x);
}

static inline double futrts_floor64(double x) {
  return floor(x);
}

static inline bool futrts_isnan64(double x) {
  return isnan(x);
}

static inline bool futrts_isinf64(double x) {
  return isinf(x);
}

static inline int64_t futrts_to_bits64(double x) {
  union {
    double f;
    int64_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline double futrts_from_bits64(int64_t x) {
  union {
    int64_t f;
    double t;
  } p;

  p.f = x;
  return p.t;
}

static inline double fmod64(double x, double y) {
  return fmod(x, y);
}

static inline double fsignum64(double x) {
  return futrts_isnan64(x) ? x : (x > 0) - (x < 0);
}

static inline double futrts_lerp64(double v0, double v1, double t) {
#ifdef __OPENCL_VERSION__
  return mix(v0, v1, t);
#else
  return v0 + (v1 - v0) * t;
#endif
}

static inline double futrts_mad64(double a, double b, double c) {
#ifdef __OPENCL_VERSION__
  return mad(a, b, c);
#else
  return a * b + c;
#endif
}

static inline float fpconv_f32_f32(float x) {
  return (float) x;
}

static inline double fpconv_f32_f64(float x) {
  return (double) x;
}

static inline float fpconv_f64_f32(double x) {
  return (float) x;
}

static inline double fpconv_f64_f64(double x) {
  return (double) x;
}

#endif

// End of scalar.h.
// Start of scalar_f16.h.

// Half-precision is emulated if needed (e.g. in straight C) with the
// native type used if possible.  The emulation works by typedef'ing
// 'float' to 'f16', and then implementing all operations on single
// precision.  To cut down on duplication, we use the same code for
// those Futhark functions that require just operators or casts.  The
// in-memory representation for arrays will still be 16 bits even
// under emulation, so the compiler will have to be careful when
// generating reads or writes.

#if !defined(cl_khr_fp16) && !(defined(__CUDA_ARCH__) && __CUDA_ARCH__ >= 600)
#define EMULATE_F16
#endif

#if !defined(EMULATE_F16) && defined(__OPENCL_VERSION__)
#pragma OPENCL EXTENSION cl_khr_fp16 : enable
#endif

#ifdef EMULATE_F16

// Note that the half-precision storage format is still 16 bits - the
// compiler will have to be real careful!
typedef float f16;

#else

#ifdef __CUDA_ARCH__
#include <cuda_fp16.h>
#endif

typedef half f16;

#endif

// Some of these functions convert to single precision because half
// precision versions are not available.

static inline f16 fadd16(f16 x, f16 y) {
  return x + y;
}

static inline f16 fsub16(f16 x, f16 y) {
  return x - y;
}

static inline f16 fmul16(f16 x, f16 y) {
  return x * y;
}

static inline bool cmplt16(f16 x, f16 y) {
  return x < y;
}

static inline bool cmple16(f16 x, f16 y) {
  return x <= y;
}

static inline f16 sitofp_i8_f16(int8_t x) {
  return (f16) x;
}

static inline f16 sitofp_i16_f16(int16_t x) {
  return (f16) x;
}

static inline f16 sitofp_i32_f16(int32_t x) {
  return (f16) x;
}

static inline f16 sitofp_i64_f16(int64_t x) {
  return (f16) x;
}

static inline f16 uitofp_i8_f16(uint8_t x) {
  return (f16) x;
}

static inline f16 uitofp_i16_f16(uint16_t x) {
  return (f16) x;
}

static inline f16 uitofp_i32_f16(uint32_t x) {
  return (f16) x;
}

static inline f16 uitofp_i64_f16(uint64_t x) {
  return (f16) x;
}

static inline int8_t fptosi_f16_i8(f16 x) {
  return (int8_t) (float) x;
}

static inline int16_t fptosi_f16_i16(f16 x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f16_i32(f16 x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f16_i64(f16 x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f16_i8(f16 x) {
  return (uint8_t) (float) x;
}

static inline uint16_t fptoui_f16_i16(f16 x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f16_i32(f16 x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f16_i64(f16 x) {
  return (uint64_t) x;
}

#ifndef EMULATE_F16

#ifdef __OPENCL_VERSION__
static inline f16 fabs16(f16 x) {
  return fabs(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return pow(x, y);
}

#else // Assuming CUDA.

static inline f16 fabs16(f16 x) {
  return fabsf(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmaxf(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fminf(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan16(f16 x) {
  return isnan((float)x);
}

static inline bool futrts_isinf16(f16 x) {
  return isinf((float)x);
}

#ifdef __OPENCL_VERSION__
static inline f16 futrts_log16(f16 x) {
  return log(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return log2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return log10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return sqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return exp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return cos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return sin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tan(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acos(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asin(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atan(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return cosh(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinh(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanh(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acosh(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinh(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanh(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypot(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgamma(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgamma(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rint(x);
}

static inline f16 futrts_floor16(f16 x) {
  return floor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return ceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return mix(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return mad(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fma(a, b, c);
}

#else // Assume CUDA.

static inline f16 futrts_log16(f16 x) {
  return hlog(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return hlog2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return hlog10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return hsqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return hexp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return hcos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return hsin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tanf(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acosf(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asinf(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atanf(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return coshf(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinhf(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanhf(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acoshf(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinhf(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanhf(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2f(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypotf(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgammaf(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgammaf(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmodf(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rintf(x);
}

static inline f16 futrts_floor16(f16 x) {
  return hfloor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return hceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return v0 + (v1 - v0) * t;
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return a * b + c;
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fmaf(a, b, c);
}

#endif

// The CUDA __half type cannot be put in unions for some reason, so we
// use bespoke conversion functions instead.
#ifdef __CUDA_ARCH__
static inline int16_t futrts_to_bits16(f16 x) {
  return __half_as_ushort(x);
}
static inline f16 futrts_from_bits16(int16_t x) {
  return __ushort_as_half(x);
}
#else
static inline int16_t futrts_to_bits16(f16 x) {
  union {
    f16 f;
    int16_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline f16 futrts_from_bits16(int16_t x) {
  union {
    int16_t f;
    f16 t;
  } p;

  p.f = x;
  return p.t;
}
#endif

#else // No native f16 - emulate.

static inline f16 fabs16(f16 x) {
  return fabs32(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax32(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin32(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return fpow32(x, y);
}

static inline bool futrts_isnan16(f16 x) {
  return futrts_isnan32(x);
}

static inline bool futrts_isinf16(f16 x) {
  return futrts_isinf32(x);
}

static inline f16 futrts_log16(f16 x) {
  return futrts_log32(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return futrts_log2_32(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return futrts_log10_32(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return futrts_sqrt32(x);
}

static inline f16 futrts_exp16(f16 x) {
  return futrts_exp32(x);
}

static inline f16 futrts_cos16(f16 x) {
  return futrts_cos32(x);
}

static inline f16 futrts_sin16(f16 x) {
  return futrts_sin32(x);
}

static inline f16 futrts_tan16(f16 x) {
  return futrts_tan32(x);
}

static inline f16 futrts_acos16(f16 x) {
  return futrts_acos32(x);
}

static inline f16 futrts_asin16(f16 x) {
  return futrts_asin32(x);
}

static inline f16 futrts_atan16(f16 x) {
  return futrts_atan32(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return futrts_cosh32(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return futrts_sinh32(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return futrts_tanh32(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return futrts_acosh32(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return futrts_asinh32(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return futrts_atanh32(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return futrts_atan2_32(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return futrts_hypot32(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return futrts_gamma32(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return futrts_lgamma32(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod32(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return futrts_round32(x);
}

static inline f16 futrts_floor16(f16 x) {
  return futrts_floor32(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return futrts_ceil32(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return futrts_lerp32(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return futrts_mad32(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return futrts_fma32(a, b, c);
}

// Even when we are using an OpenCL that does not support cl_khr_fp16,
// it must still support vload_half for actually creating a
// half-precision number, which can then be efficiently converted to a
// float.  Similarly for vstore_half.
#ifdef __OPENCL_VERSION__

static inline int16_t futrts_to_bits16(f16 x) {
  int16_t y;
  // Violating strict aliasing here.
  vstore_half((float)x, 0, (half*)&y);
  return y;
}

static inline f16 futrts_from_bits16(int16_t x) {
  return (f16)vload_half(0, (half*)&x);
}

#else

static inline int16_t futrts_to_bits16(f16 x) {
  return (int16_t)float2halfbits(x);
}

static inline f16 futrts_from_bits16(int16_t x) {
  return halfbits2float((uint16_t)x);
}

static inline f16 fsignum16(f16 x) {
  return futrts_isnan16(x) ? x : (x > 0) - (x < 0);
}

#endif

#endif

static inline float fpconv_f16_f16(f16 x) {
  return x;
}

static inline float fpconv_f16_f32(f16 x) {
  return x;
}

static inline f16 fpconv_f32_f16(float x) {
  return x;
}

#ifdef FUTHARK_F64_ENABLED

static inline double fpconv_f16_f64(f16 x) {
  return (double) x;
}

static inline f16 fpconv_f64_f16(double x) {
  return (f16) x;
}

#endif


// End of scalar_f16.h.

static int init_constants(struct futhark_context *);
static int free_constants(struct futhark_context *);
struct memblock {
    int *references;
    unsigned char *mem;
    int64_t size;
    const char *desc;
};
struct futhark_context_config {
    int debugging;
    int in_use;
};
struct futhark_context_config *futhark_context_config_new(void)
{
    struct futhark_context_config *cfg =
                                  (struct futhark_context_config *) malloc(sizeof(struct futhark_context_config));
    
    if (cfg == NULL)
        return NULL;
    cfg->in_use = 0;
    cfg->debugging = 0;
    return cfg;
}
void futhark_context_config_free(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    free(cfg);
}
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int detail)
{
    cfg->debugging = detail;
}
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag)
{
    (void) cfg;
    (void) flag;
}
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int detail)
{
    // Does nothing for this backend.
    (void) cfg;
    (void) detail;
}
struct futhark_context {
    struct futhark_context_config *cfg;
    int detail_memory;
    int debugging;
    int profiling;
    int logging;
    lock_t lock;
    char *error;
    FILE *log;
    int profiling_paused;
    int64_t peak_mem_usage_default;
    int64_t cur_mem_usage_default;
    struct {
        int dummy;
    } constants;
};
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    
    struct futhark_context *ctx =
                           (struct futhark_context *) malloc(sizeof(struct futhark_context));
    
    if (ctx == NULL)
        return NULL;
    ctx->cfg = cfg;
    ctx->cfg->in_use = 1;
    ctx->detail_memory = cfg->debugging;
    ctx->debugging = cfg->debugging;
    ctx->profiling = cfg->debugging;
    ctx->logging = cfg->debugging;
    ctx->error = NULL;
    ctx->log = stderr;
    create_lock(&ctx->lock);
    ctx->peak_mem_usage_default = 0;
    ctx->cur_mem_usage_default = 0;
    init_constants(ctx);
    return ctx;
}
void futhark_context_free(struct futhark_context *ctx)
{
    free_constants(ctx);
    free_lock(&ctx->lock);
    ctx->cfg->in_use = 0;
    free(ctx);
}
int futhark_context_sync(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
static const char *tuning_param_names[0];
static const char *tuning_param_vars[0];
static const char *tuning_param_classes[0];
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t param_value)
{
    (void) cfg;
    (void) param_name;
    (void) param_value;
    return 1;
}
static int memblock_unref(struct futhark_context *ctx, struct memblock *block,
                          const char *desc)
{
    if (block->references != NULL) {
        *block->references -= 1;
        if (ctx->detail_memory)
            fprintf(ctx->log,
                    "Unreferencing block %s (allocated as %s) in %s: %d references remaining.\n",
                    desc, block->desc, "default space", *block->references);
        if (*block->references == 0) {
            ctx->cur_mem_usage_default -= block->size;
            free(block->mem);
            free(block->references);
            if (ctx->detail_memory)
                fprintf(ctx->log,
                        "%lld bytes freed (now allocated: %lld bytes)\n",
                        (long long) block->size,
                        (long long) ctx->cur_mem_usage_default);
        }
        block->references = NULL;
    }
    return 0;
}
static int memblock_alloc(struct futhark_context *ctx, struct memblock *block,
                          int64_t size, const char *desc)
{
    if (size < 0)
        futhark_panic(1,
                      "Negative allocation of %lld bytes attempted for %s in %s.\n",
                      (long long) size, desc, "default space",
                      ctx->cur_mem_usage_default);
    
    int ret = memblock_unref(ctx, block, desc);
    
    ctx->cur_mem_usage_default += size;
    if (ctx->detail_memory)
        fprintf(ctx->log,
                "Allocating %lld bytes for %s in %s (then allocated: %lld bytes)",
                (long long) size, desc, "default space",
                (long long) ctx->cur_mem_usage_default);
    if (ctx->cur_mem_usage_default > ctx->peak_mem_usage_default) {
        ctx->peak_mem_usage_default = ctx->cur_mem_usage_default;
        if (ctx->detail_memory)
            fprintf(ctx->log, " (new peak).\n");
    } else if (ctx->detail_memory)
        fprintf(ctx->log, ".\n");
    block->mem = (unsigned char *) malloc((size_t) size);
    block->references = (int *) malloc(sizeof(int));
    *block->references = 1;
    block->size = size;
    block->desc = desc;
    return ret;
}
static int memblock_set(struct futhark_context *ctx, struct memblock *lhs,
                        struct memblock *rhs, const char *lhs_desc)
{
    int ret = memblock_unref(ctx, lhs, lhs_desc);
    
    if (rhs->references != NULL)
        (*rhs->references)++;
    *lhs = *rhs;
    return ret;
}
int futhark_get_tuning_param_count(void)
{
    return sizeof(tuning_param_names) / sizeof(tuning_param_names[0]);
}
const char *futhark_get_tuning_param_name(int i)
{
    return tuning_param_names[i];
}
const char *futhark_get_tuning_param_class(int i)
{
    return tuning_param_classes[i];
}
char *futhark_context_report(struct futhark_context *ctx)
{
    if (futhark_context_sync(ctx) != 0)
        return NULL;
    
    struct str_builder builder;
    
    str_builder_init(&builder);
    if (ctx->detail_memory || ctx->profiling || ctx->logging) {
        { }
    }
    if (ctx->profiling) { }
    return builder.str;
}
char *futhark_context_get_error(struct futhark_context *ctx)
{
    char *error = ctx->error;
    
    ctx->error = NULL;
    return error;
}
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f)
{
    ctx->log = f;
}
void futhark_context_pause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 1;
}
void futhark_context_unpause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 0;
}
int futhark_context_clear_caches(struct futhark_context *ctx)
{
    lock_lock(&ctx->lock);
    ctx->peak_mem_usage_default = 0;
    lock_unlock(&ctx->lock);
    return ctx->error != NULL;
}

static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock *mem_out_p_68482,
                             struct memblock Y_mem_67129, int64_t m_65377,
                             int64_t n_65378, int64_t q_65380,
                             int64_t degree_65381, int64_t jump_65382,
                             int64_t jump_threshold_65383,
                             int64_t q_threshold_65384);

static int init_constants(struct futhark_context *ctx)
{
    (void) ctx;
    
    int err = 0;
    
    
  cleanup:
    return err;
}
static int free_constants(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
struct futhark_f64_2d {
    struct memblock mem;
    int64_t shape[2];
};
struct futhark_f64_2d *futhark_new_f64_2d(struct futhark_context *ctx, const
                                          double *data, int64_t dim0,
                                          int64_t dim1)
{
    struct futhark_f64_2d *bad = NULL;
    struct futhark_f64_2d *arr =
                          (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * dim1 * 8, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    if ((size_t) (dim0 * dim1) * 8 > 0)
        memmove(arr->mem.mem + 0, data + 0, (size_t) (dim0 * dim1) * 8);
    lock_unlock(&ctx->lock);
    return arr;
}
struct futhark_f64_2d *futhark_new_raw_f64_2d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0,
                                              int64_t dim1)
{
    struct futhark_f64_2d *bad = NULL;
    struct futhark_f64_2d *arr =
                          (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * dim1 * 8, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    if ((size_t) (dim0 * dim1) * 8 > 0)
        memmove(arr->mem.mem + 0, data + offset, (size_t) (dim0 * dim1) * 8);
    lock_unlock(&ctx->lock);
    return arr;
}
int futhark_free_f64_2d(struct futhark_context *ctx, struct futhark_f64_2d *arr)
{
    lock_lock(&ctx->lock);
    if (memblock_unref(ctx, &arr->mem, "arr->mem") != 0)
        return 1;
    lock_unlock(&ctx->lock);
    free(arr);
    return 0;
}
int futhark_values_f64_2d(struct futhark_context *ctx,
                          struct futhark_f64_2d *arr, double *data)
{
    lock_lock(&ctx->lock);
    if ((size_t) (arr->shape[0] * arr->shape[1]) * 8 > 0)
        memmove(data + 0, arr->mem.mem + 0, (size_t) (arr->shape[0] *
                                                      arr->shape[1]) * 8);
    lock_unlock(&ctx->lock);
    return 0;
}
unsigned char *futhark_values_raw_f64_2d(struct futhark_context *ctx,
                                         struct futhark_f64_2d *arr)
{
    (void) ctx;
    return arr->mem.mem;
}
const int64_t *futhark_shape_f64_2d(struct futhark_context *ctx,
                                    struct futhark_f64_2d *arr)
{
    (void) ctx;
    return arr->shape;
}

static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock *mem_out_p_68482,
                             struct memblock Y_mem_67129, int64_t m_65377,
                             int64_t n_65378, int64_t q_65380,
                             int64_t degree_65381, int64_t jump_65382,
                             int64_t jump_threshold_65383,
                             int64_t q_threshold_65384)
{
    (void) ctx;
    
    int err = 0;
    size_t mem_67150_cached_sizze_68483 = 0;
    unsigned char *mem_67150 = NULL;
    size_t mem_67165_cached_sizze_68484 = 0;
    unsigned char *mem_67165 = NULL;
    size_t mem_67168_cached_sizze_68485 = 0;
    unsigned char *mem_67168 = NULL;
    size_t mem_67195_cached_sizze_68486 = 0;
    unsigned char *mem_67195 = NULL;
    size_t mem_67210_cached_sizze_68487 = 0;
    unsigned char *mem_67210 = NULL;
    size_t mem_67283_cached_sizze_68488 = 0;
    unsigned char *mem_67283 = NULL;
    size_t mem_67298_cached_sizze_68489 = 0;
    unsigned char *mem_67298 = NULL;
    size_t mem_67301_cached_sizze_68490 = 0;
    unsigned char *mem_67301 = NULL;
    size_t mem_67328_cached_sizze_68491 = 0;
    unsigned char *mem_67328 = NULL;
    size_t mem_67343_cached_sizze_68492 = 0;
    unsigned char *mem_67343 = NULL;
    size_t mem_67446_cached_sizze_68493 = 0;
    unsigned char *mem_67446 = NULL;
    size_t mem_67461_cached_sizze_68494 = 0;
    unsigned char *mem_67461 = NULL;
    size_t mem_67464_cached_sizze_68495 = 0;
    unsigned char *mem_67464 = NULL;
    size_t mem_67491_cached_sizze_68496 = 0;
    unsigned char *mem_67491 = NULL;
    size_t mem_67506_cached_sizze_68497 = 0;
    unsigned char *mem_67506 = NULL;
    size_t mem_67631_cached_sizze_68498 = 0;
    unsigned char *mem_67631 = NULL;
    size_t mem_67646_cached_sizze_68499 = 0;
    unsigned char *mem_67646 = NULL;
    size_t mem_67649_cached_sizze_68500 = 0;
    unsigned char *mem_67649 = NULL;
    size_t mem_67676_cached_sizze_68501 = 0;
    unsigned char *mem_67676 = NULL;
    size_t mem_67691_cached_sizze_68502 = 0;
    unsigned char *mem_67691 = NULL;
    size_t mem_67717_cached_sizze_68503 = 0;
    unsigned char *mem_67717 = NULL;
    size_t mem_67779_cached_sizze_68504 = 0;
    unsigned char *mem_67779 = NULL;
    size_t mem_67794_cached_sizze_68505 = 0;
    unsigned char *mem_67794 = NULL;
    size_t mem_67797_cached_sizze_68506 = 0;
    unsigned char *mem_67797 = NULL;
    size_t mem_67824_cached_sizze_68507 = 0;
    unsigned char *mem_67824 = NULL;
    size_t mem_67839_cached_sizze_68508 = 0;
    unsigned char *mem_67839 = NULL;
    size_t mem_67876_cached_sizze_68509 = 0;
    unsigned char *mem_67876 = NULL;
    size_t mem_67879_cached_sizze_68510 = 0;
    unsigned char *mem_67879 = NULL;
    size_t mem_67972_cached_sizze_68511 = 0;
    unsigned char *mem_67972 = NULL;
    size_t mem_67987_cached_sizze_68512 = 0;
    unsigned char *mem_67987 = NULL;
    size_t mem_67990_cached_sizze_68513 = 0;
    unsigned char *mem_67990 = NULL;
    size_t mem_68017_cached_sizze_68514 = 0;
    unsigned char *mem_68017 = NULL;
    size_t mem_68032_cached_sizze_68515 = 0;
    unsigned char *mem_68032 = NULL;
    size_t mem_68069_cached_sizze_68516 = 0;
    unsigned char *mem_68069 = NULL;
    size_t mem_68072_cached_sizze_68517 = 0;
    unsigned char *mem_68072 = NULL;
    size_t mem_68099_cached_sizze_68518 = 0;
    unsigned char *mem_68099 = NULL;
    size_t mem_68102_cached_sizze_68519 = 0;
    unsigned char *mem_68102 = NULL;
    struct memblock mem_out_68330;
    
    mem_out_68330.references = NULL;
    
    bool cond_65385 = jump_65382 == (int64_t) 1;
    int64_t n_m_65386;
    
    if (cond_65385) {
        n_m_65386 = n_65378;
    } else {
        bool zzero_65387 = jump_65382 == (int64_t) 0;
        bool nonzzero_65388 = !zzero_65387;
        bool nonzzero_cert_65389;
        
        if (!nonzzero_65388) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  loess.fut:580:38-45\n   #1  loess.fut:573:1-612:26\n");
            if (memblock_unref(ctx, &mem_out_68330, "mem_out_68330") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t x_65390 = sdiv64(n_65378, jump_65382);
        int64_t n_m_f_res_65391 = add64((int64_t) 1, x_65390);
        
        n_m_65386 = n_m_f_res_65391;
    }
    
    int64_t i_65392 = sub64(n_65378, (int64_t) 1);
    bool x_65393 = sle64((int64_t) 0, i_65392);
    bool y_65394 = slt64(i_65392, n_65378);
    bool bounds_check_65395 = x_65393 && y_65394;
    bool index_certs_65396;
    
    if (!bounds_check_65395) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) i_65392,
                               "] out of bounds for array of shape [",
                               (long long) n_65378, "].",
                               "-> #0  /prelude/array.fut:26:29-34\n   #1  utils.fut:45:13-20\n   #2  loess.fut:585:5-54\n   #3  loess.fut:573:1-612:26\n");
        if (memblock_unref(ctx, &mem_out_68330, "mem_out_68330") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t min_res_65398 = smin64(n_65378, q_65380);
    bool bounds_invalid_upwards_65399 = slt64(n_m_65386, (int64_t) 0);
    bool valid_65400 = !bounds_invalid_upwards_65399;
    bool range_valid_c_65401;
    
    if (!valid_65400) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) n_m_65386, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:443:3-470:10\n   #4  loess.fut:503:15-61\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
        if (memblock_unref(ctx, &mem_out_68330, "mem_out_68330") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool loop_cond_65403 = slt64((int64_t) 1, min_res_65398);
    double i64_res_65404 = sitofp_i64_f64(q_65380);
    bool cond_65405 = slt64(jump_65382, jump_threshold_65383);
    bool cond_f_res_65406 = slt64(q_threshold_65384, q_65380);
    bool x_65407 = !cond_65405;
    bool y_65408 = cond_f_res_65406 && x_65407;
    bool cond_65409 = cond_65405 || y_65408;
    struct memblock ext_mem_68205;
    
    ext_mem_68205.references = NULL;
    
    struct memblock ext_mem_68197;
    
    ext_mem_68197.references = NULL;
    if (cond_65409) {
        bool match_lit_65412 = (int64_t) 0 == degree_65381;
        int64_t binop_x_67130 = m_65377 * n_m_65386;
        int64_t binop_y_67131 = (int64_t) 8 * binop_x_67130;
        int64_t bytes_67132 = smax64((int64_t) 0, binop_y_67131);
        int64_t binop_y_67148 = (int64_t) 8 * n_65378;
        int64_t bytes_67149 = smax64((int64_t) 0, binop_y_67148);
        int64_t binop_y_67208 = (int64_t) 8 * q_65380;
        int64_t bytes_67209 = smax64((int64_t) 0, binop_y_67208);
        struct memblock ext_mem_67603;
        
        ext_mem_67603.references = NULL;
        
        struct memblock ext_mem_67595;
        
        ext_mem_67595.references = NULL;
        if (match_lit_65412) {
            struct memblock mem_67133;
            
            mem_67133.references = NULL;
            if (memblock_alloc(ctx, &mem_67133, bytes_67132, "mem_67133")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_68331 = 0; i_68331 < m_65377; i_68331++) {
                for (int64_t i_68332 = 0; i_68332 < n_m_65386; i_68332++) {
                    ((double *) mem_67133.mem)[i_68331 * n_m_65386 + i_68332] =
                        0.0;
                }
            }
            
            struct memblock mem_67137;
            
            mem_67137.references = NULL;
            if (memblock_alloc(ctx, &mem_67137, bytes_67132, "mem_67137")) {
                err = 1;
                goto cleanup;
            }
            if (mem_67150_cached_sizze_68483 < (size_t) bytes_67149) {
                mem_67150 = realloc(mem_67150, bytes_67149);
                mem_67150_cached_sizze_68483 = bytes_67149;
            }
            if (mem_67165_cached_sizze_68484 < (size_t) bytes_67149) {
                mem_67165 = realloc(mem_67165, bytes_67149);
                mem_67165_cached_sizze_68484 = bytes_67149;
            }
            if (mem_67168_cached_sizze_68485 < (size_t) bytes_67149) {
                mem_67168 = realloc(mem_67168, bytes_67149);
                mem_67168_cached_sizze_68485 = bytes_67149;
            }
            if (mem_67195_cached_sizze_68486 < (size_t) bytes_67149) {
                mem_67195 = realloc(mem_67195, bytes_67149);
                mem_67195_cached_sizze_68486 = bytes_67149;
            }
            if (mem_67210_cached_sizze_68487 < (size_t) bytes_67209) {
                mem_67210 = realloc(mem_67210, bytes_67209);
                mem_67210_cached_sizze_68487 = bytes_67209;
            }
            for (int64_t i_66758 = 0; i_66758 < m_65377; i_66758++) {
                int64_t discard_66731;
                int64_t scanacc_66727 = (int64_t) 0;
                
                for (int64_t i_66729 = 0; i_66729 < n_65378; i_66729++) {
                    double x_65423;
                    
                    x_65423 = ((double *) Y_mem_67129.mem)[i_66758 * n_65378 +
                                                           i_66729];
                    
                    bool isnan_res_65424;
                    
                    isnan_res_65424 = futrts_isnan64(x_65423);
                    
                    bool defunc_0_p_res_65425 = !isnan_res_65424;
                    int64_t defunc_0_f_res_65426 =
                            btoi_bool_i64(defunc_0_p_res_65425);
                    int64_t defunc_1_op_res_65422 = add64(defunc_0_f_res_65426,
                                                          scanacc_66727);
                    
                    ((int64_t *) mem_67150)[i_66729] = defunc_1_op_res_65422;
                    
                    int64_t scanacc_tmp_68334 = defunc_1_op_res_65422;
                    
                    scanacc_66727 = scanacc_tmp_68334;
                }
                discard_66731 = scanacc_66727;
                
                int64_t last_res_65427;
                
                last_res_65427 = ((int64_t *) mem_67150)[i_65392];
                for (int64_t i_68336 = 0; i_68336 < n_65378; i_68336++) {
                    ((double *) mem_67165)[i_68336] = 0.0;
                }
                for (int64_t i_68337 = 0; i_68337 < n_65378; i_68337++) {
                    ((int64_t *) mem_67168)[i_68337] = (int64_t) -1;
                }
                for (int64_t write_iter_66732 = 0; write_iter_66732 < n_65378;
                     write_iter_66732++) {
                    double write_iv_66735;
                    
                    write_iv_66735 = ((double *) Y_mem_67129.mem)[i_66758 *
                                                                  n_65378 +
                                                                  write_iter_66732];
                    
                    int64_t write_iv_66736;
                    
                    write_iv_66736 = ((int64_t *) mem_67150)[write_iter_66732];
                    
                    bool isnan_res_65435;
                    
                    isnan_res_65435 = futrts_isnan64(write_iv_66735);
                    
                    bool defunc_0_p_res_65436 = !isnan_res_65435;
                    int64_t defunc_1_f_res_65437;
                    
                    if (defunc_0_p_res_65436) {
                        int64_t defunc_1_f_res_t_res_65438 =
                                sub64(write_iv_66736, (int64_t) 1);
                        
                        defunc_1_f_res_65437 = defunc_1_f_res_t_res_65438;
                    } else {
                        defunc_1_f_res_65437 = (int64_t) -1;
                    }
                    if (sle64((int64_t) 0, defunc_1_f_res_65437) &&
                        slt64(defunc_1_f_res_65437, n_65378)) {
                        ((int64_t *) mem_67168)[defunc_1_f_res_65437] =
                            write_iter_66732;
                    }
                    if (sle64((int64_t) 0, defunc_1_f_res_65437) &&
                        slt64(defunc_1_f_res_65437, n_65378)) {
                        if ((int64_t) 8 > 0)
                            memmove(mem_67165 + defunc_1_f_res_65437 *
                                    (int64_t) 8, Y_mem_67129.mem + (i_66758 *
                                                                    n_65378 +
                                                                    write_iter_66732) *
                                    (int64_t) 8, (int64_t) 8);
                    }
                }
                for (int64_t i_66742 = 0; i_66742 < n_65378; i_66742++) {
                    int64_t x_65440;
                    
                    x_65440 = ((int64_t *) mem_67168)[i_66742];
                    
                    int64_t defunc_0_f_res_65441 = add64((int64_t) 1, x_65440);
                    
                    ((int64_t *) mem_67195)[i_66742] = defunc_0_f_res_65441;
                }
                
                int64_t min_arg_65442 = sub64(last_res_65427, (int64_t) 1);
                int64_t min_arg_65443 = sub64(last_res_65427, min_res_65398);
                int64_t min_res_65444 = smin64(q_65380, last_res_65427);
                double i64_res_65445 = sitofp_i64_f64(last_res_65427);
                double x_65446 = i64_res_65404 - i64_res_65445;
                double max_arg_65447 = x_65446 / 2.0;
                double max_res_65448 = fmax64(0.0, max_arg_65447);
                
                for (int64_t i_66746 = 0; i_66746 < q_65380; i_66746++) {
                    bool cond_65451 = sle64(last_res_65427, i_66746);
                    double defunc_0_f_res_65452;
                    
                    if (cond_65451) {
                        defunc_0_f_res_65452 = 0.0;
                    } else {
                        defunc_0_f_res_65452 = 1.0;
                    }
                    ((double *) mem_67210)[i_66746] = defunc_0_f_res_65452;
                }
                for (int64_t i_66754 = 0; i_66754 < n_m_65386; i_66754++) {
                    int64_t min_arg_65455 = mul64(jump_65382, i_66754);
                    int64_t min_res_65456 = smin64(i_65392, min_arg_65455);
                    int64_t defunc_0_g_res_65457 = add64((int64_t) 1,
                                                         min_res_65456);
                    bool init_idx_65458;
                    int64_t init_idx_65459;
                    int64_t init_idx_65460;
                    bool loop_while_65461;
                    int64_t low_65462;
                    int64_t high_65463;
                    
                    loop_while_65461 = x_65393;
                    low_65462 = (int64_t) 0;
                    high_65463 = i_65392;
                    while (loop_while_65461) {
                        int64_t x_65464 = add64(low_65462, high_65463);
                        int64_t mid_65465 = sdiv64(x_65464, (int64_t) 2);
                        bool x_65466 = sle64((int64_t) 0, mid_65465);
                        bool y_65467 = slt64(mid_65465, n_65378);
                        bool bounds_check_65468 = x_65466 && y_65467;
                        bool index_certs_65469;
                        
                        if (!bounds_check_65468) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) mid_65465,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:450:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67137, "mem_67137") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67133, "mem_67133") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67595,
                                               "ext_mem_67595") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67603,
                                               "ext_mem_67603") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t mid_id_65470;
                        
                        mid_id_65470 = ((int64_t *) mem_67195)[mid_65465];
                        
                        bool cond_65471 = slt64(mid_id_65470, (int64_t) 0);
                        int64_t mid_idx_65472;
                        
                        if (cond_65471) {
                            mid_idx_65472 = (int64_t) 9223372036854775807;
                        } else {
                            mid_idx_65472 = mid_id_65470;
                        }
                        
                        bool cond_65473 = sle64(defunc_0_g_res_65457,
                                                mid_idx_65472);
                        int64_t loopres_65474;
                        int64_t loopres_65475;
                        
                        if (cond_65473) {
                            int64_t loopres_t_res_65476 = sub64(mid_65465,
                                                                (int64_t) 1);
                            
                            loopres_65474 = low_65462;
                            loopres_65475 = loopres_t_res_65476;
                        } else {
                            int64_t loopres_f_res_65477 = add64((int64_t) 1,
                                                                mid_65465);
                            
                            loopres_65474 = loopres_f_res_65477;
                            loopres_65475 = high_65463;
                        }
                        
                        bool loop_cond_65478 = sle64(loopres_65474,
                                                     loopres_65475);
                        bool loop_while_tmp_68343 = loop_cond_65478;
                        int64_t low_tmp_68344 = loopres_65474;
                        int64_t high_tmp_68345 = loopres_65475;
                        
                        loop_while_65461 = loop_while_tmp_68343;
                        low_65462 = low_tmp_68344;
                        high_65463 = high_tmp_68345;
                    }
                    init_idx_65458 = loop_while_65461;
                    init_idx_65459 = low_65462;
                    init_idx_65460 = high_65463;
                    
                    bool idx_65479;
                    int64_t idx_65480;
                    int64_t idx_65481;
                    int64_t idx_65482;
                    bool loop_while_65483;
                    int64_t l_idx_65484;
                    int64_t r_idx_65485;
                    int64_t span_65486;
                    
                    loop_while_65483 = loop_cond_65403;
                    l_idx_65484 = init_idx_65459;
                    r_idx_65485 = init_idx_65459;
                    span_65486 = (int64_t) 1;
                    while (loop_while_65483) {
                        int64_t max_arg_65487 = sub64(l_idx_65484, (int64_t) 1);
                        int64_t max_res_65488 = smax64((int64_t) 0,
                                                       max_arg_65487);
                        int64_t min_arg_65489 = add64((int64_t) 1, r_idx_65485);
                        int64_t min_res_65490 = smin64(min_arg_65442,
                                                       min_arg_65489);
                        bool x_65491 = sle64((int64_t) 0, max_res_65488);
                        bool y_65492 = slt64(max_res_65488, n_65378);
                        bool bounds_check_65493 = x_65491 && y_65492;
                        bool index_certs_65494;
                        
                        if (!bounds_check_65493) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) max_res_65488,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67137, "mem_67137") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67133, "mem_67133") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67595,
                                               "ext_mem_67595") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67603,
                                               "ext_mem_67603") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_65495;
                        
                        x_65495 = ((int64_t *) mem_67195)[max_res_65488];
                        
                        int64_t abs_arg_65496 = sub64(x_65495,
                                                      defunc_0_g_res_65457);
                        int64_t abs_res_65497 = abs64(abs_arg_65496);
                        bool x_65498 = sle64((int64_t) 0, min_res_65490);
                        bool y_65499 = slt64(min_res_65490, n_65378);
                        bool bounds_check_65500 = x_65498 && y_65499;
                        bool index_certs_65501;
                        
                        if (!bounds_check_65500) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) min_res_65490,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:461:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67137, "mem_67137") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67133, "mem_67133") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67595,
                                               "ext_mem_67595") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67603,
                                               "ext_mem_67603") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_65502;
                        
                        x_65502 = ((int64_t *) mem_67195)[min_res_65490];
                        
                        int64_t abs_arg_65503 = sub64(x_65502,
                                                      defunc_0_g_res_65457);
                        int64_t abs_res_65504 = abs64(abs_arg_65503);
                        bool cond_65505 = max_res_65488 == l_idx_65484;
                        int64_t loopres_65506;
                        int64_t loopres_65507;
                        int64_t loopres_65508;
                        
                        if (cond_65505) {
                            loopres_65506 = l_idx_65484;
                            loopres_65507 = r_idx_65485;
                            loopres_65508 = min_res_65398;
                        } else {
                            bool cond_65509 = slt64(abs_res_65497,
                                                    abs_res_65504);
                            bool cond_f_res_65510 = min_res_65490 ==
                                 r_idx_65485;
                            bool x_65511 = !cond_65509;
                            bool y_65512 = cond_f_res_65510 && x_65511;
                            bool cond_65513 = cond_65509 || y_65512;
                            int64_t loopres_f_res_65514;
                            
                            if (cond_65513) {
                                loopres_f_res_65514 = max_res_65488;
                            } else {
                                loopres_f_res_65514 = l_idx_65484;
                            }
                            
                            int64_t loopres_f_res_65515;
                            
                            if (cond_65513) {
                                loopres_f_res_65515 = r_idx_65485;
                            } else {
                                loopres_f_res_65515 = min_res_65490;
                            }
                            
                            int64_t loopres_f_res_65516;
                            
                            if (cond_65513) {
                                int64_t loopres_f_res_t_res_65517 =
                                        add64((int64_t) 1, span_65486);
                                
                                loopres_f_res_65516 = loopres_f_res_t_res_65517;
                            } else {
                                int64_t loopres_f_res_f_res_65518 =
                                        add64((int64_t) 1, span_65486);
                                
                                loopres_f_res_65516 = loopres_f_res_f_res_65518;
                            }
                            loopres_65506 = loopres_f_res_65514;
                            loopres_65507 = loopres_f_res_65515;
                            loopres_65508 = loopres_f_res_65516;
                        }
                        
                        bool loop_cond_65519 = slt64(loopres_65508,
                                                     min_res_65398);
                        bool loop_while_tmp_68346 = loop_cond_65519;
                        int64_t l_idx_tmp_68347 = loopres_65506;
                        int64_t r_idx_tmp_68348 = loopres_65507;
                        int64_t span_tmp_68349 = loopres_65508;
                        
                        loop_while_65483 = loop_while_tmp_68346;
                        l_idx_65484 = l_idx_tmp_68347;
                        r_idx_65485 = r_idx_tmp_68348;
                        span_65486 = span_tmp_68349;
                    }
                    idx_65479 = loop_while_65483;
                    idx_65480 = l_idx_65484;
                    idx_65481 = r_idx_65485;
                    idx_65482 = span_65486;
                    
                    int64_t min_res_65520 = smin64(min_arg_65443, idx_65480);
                    int64_t max_res_65521 = smax64((int64_t) 0, min_res_65520);
                    int64_t x_65522 = add64(min_res_65444, max_res_65521);
                    int64_t r_65523 = sub64(x_65522, (int64_t) 1);
                    bool x_65524 = sle64((int64_t) 0, r_65523);
                    bool y_65525 = slt64(r_65523, n_65378);
                    bool bounds_check_65526 = x_65524 && y_65525;
                    bool index_certs_65527;
                    
                    if (!bounds_check_65526) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) r_65523,
                                      "] out of bounds for array of shape [",
                                      (long long) n_65378, "].",
                                      "-> #0  loess.fut:485:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
                        if (memblock_unref(ctx, &mem_67137, "mem_67137") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_67133, "mem_67133") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_67595,
                                           "ext_mem_67595") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_67603,
                                           "ext_mem_67603") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68197,
                                           "ext_mem_68197") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68205,
                                           "ext_mem_68205") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_68330,
                                           "mem_out_68330") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_65528;
                    
                    x_65528 = ((int64_t *) mem_67168)[r_65523];
                    
                    int64_t abs_arg_65529 = sub64(x_65528, min_res_65456);
                    int64_t abs_res_65530 = abs64(abs_arg_65529);
                    bool x_65531 = sle64((int64_t) 0, max_res_65521);
                    bool y_65532 = slt64(max_res_65521, n_65378);
                    bool bounds_check_65533 = x_65531 && y_65532;
                    bool index_certs_65534;
                    
                    if (!bounds_check_65533) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) max_res_65521,
                                      "] out of bounds for array of shape [",
                                      (long long) n_65378, "].",
                                      "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
                        if (memblock_unref(ctx, &mem_67137, "mem_67137") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_67133, "mem_67133") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_67595,
                                           "ext_mem_67595") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_67603,
                                           "ext_mem_67603") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68197,
                                           "ext_mem_68197") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68205,
                                           "ext_mem_68205") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_68330,
                                           "mem_out_68330") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_65535;
                    
                    x_65535 = ((int64_t *) mem_67168)[max_res_65521];
                    
                    int64_t abs_arg_65536 = sub64(x_65535, min_res_65456);
                    int64_t abs_res_65537 = abs64(abs_arg_65536);
                    int64_t max_res_65538 = smax64(abs_res_65530,
                                                   abs_res_65537);
                    double defunc_0_f_res_65539 = sitofp_i64_f64(max_res_65538);
                    double defunc_1_f_res_65540 = max_res_65448 +
                           defunc_0_f_res_65539;
                    double defunc_2_reduce_res_65541;
                    double redout_66748 = 0.0;
                    
                    for (int64_t i_66749 = 0; i_66749 < q_65380; i_66749++) {
                        double x_65546;
                        
                        x_65546 = ((double *) mem_67210)[i_66749];
                        
                        bool cond_65547 = sle64(last_res_65427, i_66749);
                        int64_t defunc_0_f_res_65548;
                        
                        if (cond_65547) {
                            defunc_0_f_res_65548 = (int64_t) 0;
                        } else {
                            int64_t i_65549 = add64(max_res_65521, i_66749);
                            int64_t defunc_0_add_arg_65550;
                            
                            defunc_0_add_arg_65550 =
                                ((int64_t *) mem_67168)[i_65549];
                            
                            int64_t defunc_1_add_res_65551 = add64((int64_t) 1,
                                                                   defunc_0_add_arg_65550);
                            
                            defunc_0_f_res_65548 = defunc_1_add_res_65551;
                        }
                        
                        int64_t binop_p_65552 = sub64(defunc_0_f_res_65548,
                                                      min_res_65456);
                        double defunc_0_f_res_65553 =
                               sitofp_i64_f64(binop_p_65552);
                        double abs_res_65554 = fabs(defunc_0_f_res_65553);
                        double tmp1_65555 = abs_res_65554 /
                               defunc_1_f_res_65540;
                        double x_65556 = tmp1_65555 * tmp1_65555;
                        double y_65557 = tmp1_65555 * x_65556;
                        double tmp2_65558 = 1.0 - y_65557;
                        double x_65559 = tmp2_65558 * tmp2_65558;
                        double tmp3_65560 = tmp2_65558 * x_65559;
                        double w_j_65561 = x_65546 * tmp3_65560;
                        double defunc_1_op_res_65544 = w_j_65561 + redout_66748;
                        double redout_tmp_68350 = defunc_1_op_res_65544;
                        
                        redout_66748 = redout_tmp_68350;
                    }
                    defunc_2_reduce_res_65541 = redout_66748;
                    
                    double a0_65562 = 1.0 / defunc_2_reduce_res_65541;
                    double defunc_2_reduce_res_65563;
                    double redout_66750 = 0.0;
                    
                    for (int64_t i_66751 = 0; i_66751 < q_65380; i_66751++) {
                        double x_65568;
                        
                        x_65568 = ((double *) mem_67210)[i_66751];
                        
                        bool cond_65569 = sle64(last_res_65427, i_66751);
                        int64_t defunc_0_f_res_65570;
                        
                        if (cond_65569) {
                            defunc_0_f_res_65570 = (int64_t) 0;
                        } else {
                            int64_t i_65571 = add64(max_res_65521, i_66751);
                            int64_t defunc_0_add_arg_65572;
                            
                            defunc_0_add_arg_65572 =
                                ((int64_t *) mem_67168)[i_65571];
                            
                            int64_t defunc_1_add_res_65573 = add64((int64_t) 1,
                                                                   defunc_0_add_arg_65572);
                            
                            defunc_0_f_res_65570 = defunc_1_add_res_65573;
                        }
                        
                        int64_t binop_p_65574 = sub64(defunc_0_f_res_65570,
                                                      min_res_65456);
                        double defunc_0_f_res_65575 =
                               sitofp_i64_f64(binop_p_65574);
                        double abs_res_65576 = fabs(defunc_0_f_res_65575);
                        double tmp1_65577 = abs_res_65576 /
                               defunc_1_f_res_65540;
                        double x_65578 = tmp1_65577 * tmp1_65577;
                        double y_65579 = tmp1_65577 * x_65578;
                        double tmp2_65580 = 1.0 - y_65579;
                        double x_65581 = tmp2_65580 * tmp2_65580;
                        double tmp3_65582 = tmp2_65580 * x_65581;
                        double tmp4_65583 = x_65568 * tmp3_65582;
                        double defunc_0_f_res_65584;
                        
                        if (cond_65569) {
                            defunc_0_f_res_65584 = 0.0;
                        } else {
                            int64_t i_65585 = add64(max_res_65521, i_66751);
                            double defunc_0_add_arg_65586;
                            
                            defunc_0_add_arg_65586 =
                                ((double *) mem_67165)[i_65585];
                            defunc_0_f_res_65584 = defunc_0_add_arg_65586;
                        }
                        
                        double x_65587 = a0_65562 * tmp4_65583;
                        double defunc_9_fit_fun_res_65588 =
                               defunc_0_f_res_65584 * x_65587;
                        double defunc_1_op_res_65566 =
                               defunc_9_fit_fun_res_65588 + redout_66750;
                        double redout_tmp_68351 = defunc_1_op_res_65566;
                        
                        redout_66750 = redout_tmp_68351;
                    }
                    defunc_2_reduce_res_65563 = redout_66750;
                    ((double *) mem_67137.mem)[i_66758 * n_m_65386 + i_66754] =
                        defunc_2_reduce_res_65563;
                }
            }
            if (memblock_set(ctx, &ext_mem_67603, &mem_67137, "mem_67137") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_67595, &mem_67133, "mem_67133") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_67137, "mem_67137") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_67133, "mem_67133") != 0)
                return 1;
        } else {
            bool match_lit_65591 = (int64_t) 1 == degree_65381;
            int64_t binop_x_67253 = m_65377 * n_m_65386;
            int64_t binop_y_67254 = (int64_t) 8 * binop_x_67253;
            int64_t bytes_67255 = smax64((int64_t) 0, binop_y_67254);
            int64_t binop_y_67281 = (int64_t) 8 * n_65378;
            int64_t bytes_67282 = smax64((int64_t) 0, binop_y_67281);
            int64_t binop_y_67341 = (int64_t) 8 * q_65380;
            int64_t bytes_67342 = smax64((int64_t) 0, binop_y_67341);
            int64_t binop_x_67416 = m_65377 * n_m_65386;
            int64_t binop_y_67417 = (int64_t) 8 * binop_x_67416;
            int64_t bytes_67418 = smax64((int64_t) 0, binop_y_67417);
            int64_t binop_y_67444 = (int64_t) 8 * n_65378;
            int64_t bytes_67445 = smax64((int64_t) 0, binop_y_67444);
            int64_t binop_y_67504 = (int64_t) 8 * q_65380;
            int64_t bytes_67505 = smax64((int64_t) 0, binop_y_67504);
            struct memblock ext_mem_67587;
            
            ext_mem_67587.references = NULL;
            
            struct memblock ext_mem_67579;
            
            ext_mem_67579.references = NULL;
            if (match_lit_65591) {
                struct memblock mem_67256;
                
                mem_67256.references = NULL;
                if (memblock_alloc(ctx, &mem_67256, bytes_67255, "mem_67256")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock mem_67260;
                
                mem_67260.references = NULL;
                if (memblock_alloc(ctx, &mem_67260, bytes_67255, "mem_67260")) {
                    err = 1;
                    goto cleanup;
                }
                if (mem_67283_cached_sizze_68488 < (size_t) bytes_67282) {
                    mem_67283 = realloc(mem_67283, bytes_67282);
                    mem_67283_cached_sizze_68488 = bytes_67282;
                }
                if (mem_67298_cached_sizze_68489 < (size_t) bytes_67282) {
                    mem_67298 = realloc(mem_67298, bytes_67282);
                    mem_67298_cached_sizze_68489 = bytes_67282;
                }
                if (mem_67301_cached_sizze_68490 < (size_t) bytes_67282) {
                    mem_67301 = realloc(mem_67301, bytes_67282);
                    mem_67301_cached_sizze_68490 = bytes_67282;
                }
                if (mem_67328_cached_sizze_68491 < (size_t) bytes_67282) {
                    mem_67328 = realloc(mem_67328, bytes_67282);
                    mem_67328_cached_sizze_68491 = bytes_67282;
                }
                if (mem_67343_cached_sizze_68492 < (size_t) bytes_67342) {
                    mem_67343 = realloc(mem_67343, bytes_67342);
                    mem_67343_cached_sizze_68492 = bytes_67342;
                }
                for (int64_t i_66800 = 0; i_66800 < m_65377; i_66800++) {
                    int64_t discard_66765;
                    int64_t scanacc_66761 = (int64_t) 0;
                    
                    for (int64_t i_66763 = 0; i_66763 < n_65378; i_66763++) {
                        double x_65602;
                        
                        x_65602 = ((double *) Y_mem_67129.mem)[i_66800 *
                                                               n_65378 +
                                                               i_66763];
                        
                        bool isnan_res_65603;
                        
                        isnan_res_65603 = futrts_isnan64(x_65602);
                        
                        bool defunc_0_p_res_65604 = !isnan_res_65603;
                        int64_t defunc_0_f_res_65605 =
                                btoi_bool_i64(defunc_0_p_res_65604);
                        int64_t defunc_1_op_res_65601 =
                                add64(defunc_0_f_res_65605, scanacc_66761);
                        
                        ((int64_t *) mem_67283)[i_66763] =
                            defunc_1_op_res_65601;
                        
                        int64_t scanacc_tmp_68354 = defunc_1_op_res_65601;
                        
                        scanacc_66761 = scanacc_tmp_68354;
                    }
                    discard_66765 = scanacc_66761;
                    
                    int64_t last_res_65606;
                    
                    last_res_65606 = ((int64_t *) mem_67283)[i_65392];
                    for (int64_t i_68356 = 0; i_68356 < n_65378; i_68356++) {
                        ((double *) mem_67298)[i_68356] = 0.0;
                    }
                    for (int64_t i_68357 = 0; i_68357 < n_65378; i_68357++) {
                        ((int64_t *) mem_67301)[i_68357] = (int64_t) -1;
                    }
                    for (int64_t write_iter_66766 = 0; write_iter_66766 <
                         n_65378; write_iter_66766++) {
                        double write_iv_66769;
                        
                        write_iv_66769 = ((double *) Y_mem_67129.mem)[i_66800 *
                                                                      n_65378 +
                                                                      write_iter_66766];
                        
                        int64_t write_iv_66770;
                        
                        write_iv_66770 =
                            ((int64_t *) mem_67283)[write_iter_66766];
                        
                        bool isnan_res_65614;
                        
                        isnan_res_65614 = futrts_isnan64(write_iv_66769);
                        
                        bool defunc_0_p_res_65615 = !isnan_res_65614;
                        int64_t defunc_1_f_res_65616;
                        
                        if (defunc_0_p_res_65615) {
                            int64_t defunc_1_f_res_t_res_65617 =
                                    sub64(write_iv_66770, (int64_t) 1);
                            
                            defunc_1_f_res_65616 = defunc_1_f_res_t_res_65617;
                        } else {
                            defunc_1_f_res_65616 = (int64_t) -1;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_65616) &&
                            slt64(defunc_1_f_res_65616, n_65378)) {
                            ((int64_t *) mem_67301)[defunc_1_f_res_65616] =
                                write_iter_66766;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_65616) &&
                            slt64(defunc_1_f_res_65616, n_65378)) {
                            if ((int64_t) 8 > 0)
                                memmove(mem_67298 + defunc_1_f_res_65616 *
                                        (int64_t) 8, Y_mem_67129.mem +
                                        (i_66800 * n_65378 + write_iter_66766) *
                                        (int64_t) 8, (int64_t) 8);
                        }
                    }
                    for (int64_t i_66776 = 0; i_66776 < n_65378; i_66776++) {
                        int64_t x_65619;
                        
                        x_65619 = ((int64_t *) mem_67301)[i_66776];
                        
                        int64_t defunc_0_f_res_65620 = add64((int64_t) 1,
                                                             x_65619);
                        
                        ((int64_t *) mem_67328)[i_66776] = defunc_0_f_res_65620;
                    }
                    
                    int64_t min_arg_65621 = sub64(last_res_65606, (int64_t) 1);
                    int64_t min_arg_65622 = sub64(last_res_65606,
                                                  min_res_65398);
                    int64_t min_res_65623 = smin64(q_65380, last_res_65606);
                    double i64_res_65624 = sitofp_i64_f64(last_res_65606);
                    double x_65625 = i64_res_65404 - i64_res_65624;
                    double max_arg_65626 = x_65625 / 2.0;
                    double max_res_65627 = fmax64(0.0, max_arg_65626);
                    
                    for (int64_t i_66780 = 0; i_66780 < q_65380; i_66780++) {
                        bool cond_65630 = sle64(last_res_65606, i_66780);
                        double defunc_0_f_res_65631;
                        
                        if (cond_65630) {
                            defunc_0_f_res_65631 = 0.0;
                        } else {
                            defunc_0_f_res_65631 = 1.0;
                        }
                        ((double *) mem_67343)[i_66780] = defunc_0_f_res_65631;
                    }
                    for (int64_t i_66793 = 0; i_66793 < n_m_65386; i_66793++) {
                        int64_t min_arg_65635 = mul64(jump_65382, i_66793);
                        int64_t min_res_65636 = smin64(i_65392, min_arg_65635);
                        int64_t defunc_0_g_res_65637 = add64((int64_t) 1,
                                                             min_res_65636);
                        bool init_idx_65638;
                        int64_t init_idx_65639;
                        int64_t init_idx_65640;
                        bool loop_while_65641;
                        int64_t low_65642;
                        int64_t high_65643;
                        
                        loop_while_65641 = x_65393;
                        low_65642 = (int64_t) 0;
                        high_65643 = i_65392;
                        while (loop_while_65641) {
                            int64_t x_65644 = add64(low_65642, high_65643);
                            int64_t mid_65645 = sdiv64(x_65644, (int64_t) 2);
                            bool x_65646 = sle64((int64_t) 0, mid_65645);
                            bool y_65647 = slt64(mid_65645, n_65378);
                            bool bounds_check_65648 = x_65646 && y_65647;
                            bool index_certs_65649;
                            
                            if (!bounds_check_65648) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [", (long long) mid_65645,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65378, "].",
                                              "-> #0  loess.fut:450:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                                if (memblock_unref(ctx, &mem_67260,
                                                   "mem_67260") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67256,
                                                   "mem_67256") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67579,
                                                   "ext_mem_67579") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67587,
                                                   "ext_mem_67587") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67595,
                                                   "ext_mem_67595") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67603,
                                                   "ext_mem_67603") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68197,
                                                   "ext_mem_68197") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68205,
                                                   "ext_mem_68205") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68330,
                                                   "mem_out_68330") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t mid_id_65650;
                            
                            mid_id_65650 = ((int64_t *) mem_67328)[mid_65645];
                            
                            bool cond_65651 = slt64(mid_id_65650, (int64_t) 0);
                            int64_t mid_idx_65652;
                            
                            if (cond_65651) {
                                mid_idx_65652 = (int64_t) 9223372036854775807;
                            } else {
                                mid_idx_65652 = mid_id_65650;
                            }
                            
                            bool cond_65653 = sle64(defunc_0_g_res_65637,
                                                    mid_idx_65652);
                            int64_t loopres_65654;
                            int64_t loopres_65655;
                            
                            if (cond_65653) {
                                int64_t loopres_t_res_65656 = sub64(mid_65645,
                                                                    (int64_t) 1);
                                
                                loopres_65654 = low_65642;
                                loopres_65655 = loopres_t_res_65656;
                            } else {
                                int64_t loopres_f_res_65657 = add64((int64_t) 1,
                                                                    mid_65645);
                                
                                loopres_65654 = loopres_f_res_65657;
                                loopres_65655 = high_65643;
                            }
                            
                            bool loop_cond_65658 = sle64(loopres_65654,
                                                         loopres_65655);
                            bool loop_while_tmp_68364 = loop_cond_65658;
                            int64_t low_tmp_68365 = loopres_65654;
                            int64_t high_tmp_68366 = loopres_65655;
                            
                            loop_while_65641 = loop_while_tmp_68364;
                            low_65642 = low_tmp_68365;
                            high_65643 = high_tmp_68366;
                        }
                        init_idx_65638 = loop_while_65641;
                        init_idx_65639 = low_65642;
                        init_idx_65640 = high_65643;
                        
                        bool idx_65659;
                        int64_t idx_65660;
                        int64_t idx_65661;
                        int64_t idx_65662;
                        bool loop_while_65663;
                        int64_t l_idx_65664;
                        int64_t r_idx_65665;
                        int64_t span_65666;
                        
                        loop_while_65663 = loop_cond_65403;
                        l_idx_65664 = init_idx_65639;
                        r_idx_65665 = init_idx_65639;
                        span_65666 = (int64_t) 1;
                        while (loop_while_65663) {
                            int64_t max_arg_65667 = sub64(l_idx_65664,
                                                          (int64_t) 1);
                            int64_t max_res_65668 = smax64((int64_t) 0,
                                                           max_arg_65667);
                            int64_t min_arg_65669 = add64((int64_t) 1,
                                                          r_idx_65665);
                            int64_t min_res_65670 = smin64(min_arg_65621,
                                                           min_arg_65669);
                            bool x_65671 = sle64((int64_t) 0, max_res_65668);
                            bool y_65672 = slt64(max_res_65668, n_65378);
                            bool bounds_check_65673 = x_65671 && y_65672;
                            bool index_certs_65674;
                            
                            if (!bounds_check_65673) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) max_res_65668,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65378, "].",
                                              "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                                if (memblock_unref(ctx, &mem_67260,
                                                   "mem_67260") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67256,
                                                   "mem_67256") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67579,
                                                   "ext_mem_67579") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67587,
                                                   "ext_mem_67587") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67595,
                                                   "ext_mem_67595") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67603,
                                                   "ext_mem_67603") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68197,
                                                   "ext_mem_68197") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68205,
                                                   "ext_mem_68205") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68330,
                                                   "mem_out_68330") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_65675;
                            
                            x_65675 = ((int64_t *) mem_67328)[max_res_65668];
                            
                            int64_t abs_arg_65676 = sub64(x_65675,
                                                          defunc_0_g_res_65637);
                            int64_t abs_res_65677 = abs64(abs_arg_65676);
                            bool x_65678 = sle64((int64_t) 0, min_res_65670);
                            bool y_65679 = slt64(min_res_65670, n_65378);
                            bool bounds_check_65680 = x_65678 && y_65679;
                            bool index_certs_65681;
                            
                            if (!bounds_check_65680) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) min_res_65670,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65378, "].",
                                              "-> #0  loess.fut:461:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                                if (memblock_unref(ctx, &mem_67260,
                                                   "mem_67260") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67256,
                                                   "mem_67256") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67579,
                                                   "ext_mem_67579") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67587,
                                                   "ext_mem_67587") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67595,
                                                   "ext_mem_67595") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67603,
                                                   "ext_mem_67603") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68197,
                                                   "ext_mem_68197") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68205,
                                                   "ext_mem_68205") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68330,
                                                   "mem_out_68330") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_65682;
                            
                            x_65682 = ((int64_t *) mem_67328)[min_res_65670];
                            
                            int64_t abs_arg_65683 = sub64(x_65682,
                                                          defunc_0_g_res_65637);
                            int64_t abs_res_65684 = abs64(abs_arg_65683);
                            bool cond_65685 = max_res_65668 == l_idx_65664;
                            int64_t loopres_65686;
                            int64_t loopres_65687;
                            int64_t loopres_65688;
                            
                            if (cond_65685) {
                                loopres_65686 = l_idx_65664;
                                loopres_65687 = r_idx_65665;
                                loopres_65688 = min_res_65398;
                            } else {
                                bool cond_65689 = slt64(abs_res_65677,
                                                        abs_res_65684);
                                bool cond_f_res_65690 = min_res_65670 ==
                                     r_idx_65665;
                                bool x_65691 = !cond_65689;
                                bool y_65692 = cond_f_res_65690 && x_65691;
                                bool cond_65693 = cond_65689 || y_65692;
                                int64_t loopres_f_res_65694;
                                
                                if (cond_65693) {
                                    loopres_f_res_65694 = max_res_65668;
                                } else {
                                    loopres_f_res_65694 = l_idx_65664;
                                }
                                
                                int64_t loopres_f_res_65695;
                                
                                if (cond_65693) {
                                    loopres_f_res_65695 = r_idx_65665;
                                } else {
                                    loopres_f_res_65695 = min_res_65670;
                                }
                                
                                int64_t loopres_f_res_65696;
                                
                                if (cond_65693) {
                                    int64_t loopres_f_res_t_res_65697 =
                                            add64((int64_t) 1, span_65666);
                                    
                                    loopres_f_res_65696 =
                                        loopres_f_res_t_res_65697;
                                } else {
                                    int64_t loopres_f_res_f_res_65698 =
                                            add64((int64_t) 1, span_65666);
                                    
                                    loopres_f_res_65696 =
                                        loopres_f_res_f_res_65698;
                                }
                                loopres_65686 = loopres_f_res_65694;
                                loopres_65687 = loopres_f_res_65695;
                                loopres_65688 = loopres_f_res_65696;
                            }
                            
                            bool loop_cond_65699 = slt64(loopres_65688,
                                                         min_res_65398);
                            bool loop_while_tmp_68367 = loop_cond_65699;
                            int64_t l_idx_tmp_68368 = loopres_65686;
                            int64_t r_idx_tmp_68369 = loopres_65687;
                            int64_t span_tmp_68370 = loopres_65688;
                            
                            loop_while_65663 = loop_while_tmp_68367;
                            l_idx_65664 = l_idx_tmp_68368;
                            r_idx_65665 = r_idx_tmp_68369;
                            span_65666 = span_tmp_68370;
                        }
                        idx_65659 = loop_while_65663;
                        idx_65660 = l_idx_65664;
                        idx_65661 = r_idx_65665;
                        idx_65662 = span_65666;
                        
                        int64_t min_res_65700 = smin64(min_arg_65622,
                                                       idx_65660);
                        int64_t max_res_65701 = smax64((int64_t) 0,
                                                       min_res_65700);
                        int64_t x_65702 = add64(min_res_65623, max_res_65701);
                        int64_t r_65703 = sub64(x_65702, (int64_t) 1);
                        bool x_65704 = sle64((int64_t) 0, r_65703);
                        bool y_65705 = slt64(r_65703, n_65378);
                        bool bounds_check_65706 = x_65704 && y_65705;
                        bool index_certs_65707;
                        
                        if (!bounds_check_65706) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) r_65703,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:485:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67260, "mem_67260") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67256, "mem_67256") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67579,
                                               "ext_mem_67579") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67587,
                                               "ext_mem_67587") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67595,
                                               "ext_mem_67595") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67603,
                                               "ext_mem_67603") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_65708;
                        
                        x_65708 = ((int64_t *) mem_67301)[r_65703];
                        
                        int64_t abs_arg_65709 = sub64(x_65708, min_res_65636);
                        int64_t abs_res_65710 = abs64(abs_arg_65709);
                        bool x_65711 = sle64((int64_t) 0, max_res_65701);
                        bool y_65712 = slt64(max_res_65701, n_65378);
                        bool bounds_check_65713 = x_65711 && y_65712;
                        bool index_certs_65714;
                        
                        if (!bounds_check_65713) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) max_res_65701,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67260, "mem_67260") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67256, "mem_67256") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67579,
                                               "ext_mem_67579") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67587,
                                               "ext_mem_67587") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67595,
                                               "ext_mem_67595") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67603,
                                               "ext_mem_67603") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_65715;
                        
                        x_65715 = ((int64_t *) mem_67301)[max_res_65701];
                        
                        int64_t abs_arg_65716 = sub64(x_65715, min_res_65636);
                        int64_t abs_res_65717 = abs64(abs_arg_65716);
                        int64_t max_res_65718 = smax64(abs_res_65710,
                                                       abs_res_65717);
                        double defunc_0_f_res_65719 =
                               sitofp_i64_f64(max_res_65718);
                        double defunc_1_f_res_65720 = max_res_65627 +
                               defunc_0_f_res_65719;
                        double defunc_2_reduce_res_65721;
                        double defunc_2_reduce_res_65722;
                        double defunc_2_reduce_res_65723;
                        double redout_66782;
                        double redout_66783;
                        double redout_66784;
                        
                        redout_66782 = 0.0;
                        redout_66783 = 0.0;
                        redout_66784 = 0.0;
                        for (int64_t i_66785 = 0; i_66785 < q_65380;
                             i_66785++) {
                            double x_65734;
                            
                            x_65734 = ((double *) mem_67343)[i_66785];
                            
                            bool cond_65735 = sle64(last_res_65606, i_66785);
                            int64_t defunc_0_f_res_65736;
                            
                            if (cond_65735) {
                                defunc_0_f_res_65736 = (int64_t) 0;
                            } else {
                                int64_t i_65737 = add64(max_res_65701, i_66785);
                                int64_t defunc_0_add_arg_65738;
                                
                                defunc_0_add_arg_65738 =
                                    ((int64_t *) mem_67301)[i_65737];
                                
                                int64_t defunc_1_add_res_65739 =
                                        add64((int64_t) 1,
                                              defunc_0_add_arg_65738);
                                
                                defunc_0_f_res_65736 = defunc_1_add_res_65739;
                            }
                            
                            int64_t binop_p_65740 = sub64(defunc_0_f_res_65736,
                                                          min_res_65636);
                            double defunc_0_f_res_65741 =
                                   sitofp_i64_f64(binop_p_65740);
                            double abs_res_65742 = fabs(defunc_0_f_res_65741);
                            double tmp1_65743 = abs_res_65742 /
                                   defunc_1_f_res_65720;
                            double x_65744 = tmp1_65743 * tmp1_65743;
                            double y_65745 = tmp1_65743 * x_65744;
                            double tmp2_65746 = 1.0 - y_65745;
                            double x_65747 = tmp2_65746 * tmp2_65746;
                            double tmp3_65748 = tmp2_65746 * x_65747;
                            double w_j_65749 = x_65734 * tmp3_65748;
                            double xw_j_65750 = defunc_0_f_res_65741 *
                                   w_j_65749;
                            double x2w_j_65751 = defunc_0_f_res_65741 *
                                   xw_j_65750;
                            double defunc_1_op_res_65726 = w_j_65749 +
                                   redout_66782;
                            double defunc_1_op_res_65729 = xw_j_65750 +
                                   redout_66783;
                            double defunc_1_op_res_65732 = x2w_j_65751 +
                                   redout_66784;
                            double redout_tmp_68371 = defunc_1_op_res_65726;
                            double redout_tmp_68372 = defunc_1_op_res_65729;
                            double redout_tmp_68373 = defunc_1_op_res_65732;
                            
                            redout_66782 = redout_tmp_68371;
                            redout_66783 = redout_tmp_68372;
                            redout_66784 = redout_tmp_68373;
                        }
                        defunc_2_reduce_res_65721 = redout_66782;
                        defunc_2_reduce_res_65722 = redout_66783;
                        defunc_2_reduce_res_65723 = redout_66784;
                        
                        double x_65752 = defunc_2_reduce_res_65721 *
                               defunc_2_reduce_res_65723;
                        double y_65753 = defunc_2_reduce_res_65722 *
                               defunc_2_reduce_res_65722;
                        double y_65754 = x_65752 - y_65753;
                        double det1_65755 = 1.0 / y_65754;
                        double a11_65756 = defunc_2_reduce_res_65723 *
                               det1_65755;
                        double x_65757 = 0.0 - defunc_2_reduce_res_65722;
                        double b11_65758 = det1_65755 * x_65757;
                        double c11_65759 = defunc_2_reduce_res_65721 *
                               det1_65755;
                        double defunc_2_reduce_res_65760;
                        double defunc_2_reduce_res_65761;
                        double redout_66786;
                        double redout_66787;
                        
                        redout_66786 = 0.0;
                        redout_66787 = 0.0;
                        for (int64_t i_66788 = 0; i_66788 < q_65380;
                             i_66788++) {
                            double x_65769;
                            
                            x_65769 = ((double *) mem_67343)[i_66788];
                            
                            bool cond_65770 = sle64(last_res_65606, i_66788);
                            int64_t defunc_0_f_res_65771;
                            
                            if (cond_65770) {
                                defunc_0_f_res_65771 = (int64_t) 0;
                            } else {
                                int64_t i_65772 = add64(max_res_65701, i_66788);
                                int64_t defunc_0_add_arg_65773;
                                
                                defunc_0_add_arg_65773 =
                                    ((int64_t *) mem_67301)[i_65772];
                                
                                int64_t defunc_1_add_res_65774 =
                                        add64((int64_t) 1,
                                              defunc_0_add_arg_65773);
                                
                                defunc_0_f_res_65771 = defunc_1_add_res_65774;
                            }
                            
                            int64_t binop_p_65775 = sub64(defunc_0_f_res_65771,
                                                          min_res_65636);
                            double defunc_0_f_res_65776 =
                                   sitofp_i64_f64(binop_p_65775);
                            double abs_res_65777 = fabs(defunc_0_f_res_65776);
                            double tmp1_65778 = abs_res_65777 /
                                   defunc_1_f_res_65720;
                            double x_65779 = tmp1_65778 * tmp1_65778;
                            double y_65780 = tmp1_65778 * x_65779;
                            double tmp2_65781 = 1.0 - y_65780;
                            double x_65782 = tmp2_65781 * tmp2_65781;
                            double tmp3_65783 = tmp2_65781 * x_65782;
                            double tmp4_65784 = x_65769 * tmp3_65783;
                            double defunc_1_f_res_65785 = defunc_0_f_res_65776 *
                                   tmp4_65784;
                            double defunc_0_f_res_65786;
                            
                            if (cond_65770) {
                                defunc_0_f_res_65786 = 0.0;
                            } else {
                                int64_t i_65787 = add64(max_res_65701, i_66788);
                                double defunc_0_add_arg_65788;
                                
                                defunc_0_add_arg_65788 =
                                    ((double *) mem_67298)[i_65787];
                                defunc_0_f_res_65786 = defunc_0_add_arg_65788;
                            }
                            
                            double x_65789 = a11_65756 * tmp4_65784;
                            double y_65790 = b11_65758 * defunc_1_f_res_65785;
                            double x_65791 = x_65789 + y_65790;
                            double defunc_9_fit_fun_res_65792 =
                                   defunc_0_f_res_65786 * x_65791;
                            double x_65793 = b11_65758 * tmp4_65784;
                            double y_65794 = c11_65759 * defunc_1_f_res_65785;
                            double x_65795 = x_65793 + y_65794;
                            double defunc_9_slope_fun_res_65796 =
                                   defunc_0_f_res_65786 * x_65795;
                            double defunc_1_op_res_65764 =
                                   defunc_9_fit_fun_res_65792 + redout_66786;
                            double defunc_1_op_res_65767 =
                                   defunc_9_slope_fun_res_65796 + redout_66787;
                            double redout_tmp_68374 = defunc_1_op_res_65764;
                            double redout_tmp_68375 = defunc_1_op_res_65767;
                            
                            redout_66786 = redout_tmp_68374;
                            redout_66787 = redout_tmp_68375;
                        }
                        defunc_2_reduce_res_65760 = redout_66786;
                        defunc_2_reduce_res_65761 = redout_66787;
                        ((double *) mem_67256.mem)[i_66800 * n_m_65386 +
                                                   i_66793] =
                            defunc_2_reduce_res_65760;
                        ((double *) mem_67260.mem)[i_66800 * n_m_65386 +
                                                   i_66793] =
                            defunc_2_reduce_res_65761;
                    }
                }
                if (memblock_set(ctx, &ext_mem_67587, &mem_67256,
                                 "mem_67256") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_67579, &mem_67260,
                                 "mem_67260") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67260, "mem_67260") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67256, "mem_67256") != 0)
                    return 1;
            } else {
                struct memblock mem_67419;
                
                mem_67419.references = NULL;
                if (memblock_alloc(ctx, &mem_67419, bytes_67418, "mem_67419")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock mem_67423;
                
                mem_67423.references = NULL;
                if (memblock_alloc(ctx, &mem_67423, bytes_67418, "mem_67423")) {
                    err = 1;
                    goto cleanup;
                }
                if (mem_67446_cached_sizze_68493 < (size_t) bytes_67445) {
                    mem_67446 = realloc(mem_67446, bytes_67445);
                    mem_67446_cached_sizze_68493 = bytes_67445;
                }
                if (mem_67461_cached_sizze_68494 < (size_t) bytes_67445) {
                    mem_67461 = realloc(mem_67461, bytes_67445);
                    mem_67461_cached_sizze_68494 = bytes_67445;
                }
                if (mem_67464_cached_sizze_68495 < (size_t) bytes_67445) {
                    mem_67464 = realloc(mem_67464, bytes_67445);
                    mem_67464_cached_sizze_68495 = bytes_67445;
                }
                if (mem_67491_cached_sizze_68496 < (size_t) bytes_67445) {
                    mem_67491 = realloc(mem_67491, bytes_67445);
                    mem_67491_cached_sizze_68496 = bytes_67445;
                }
                if (mem_67506_cached_sizze_68497 < (size_t) bytes_67505) {
                    mem_67506 = realloc(mem_67506, bytes_67505);
                    mem_67506_cached_sizze_68497 = bytes_67505;
                }
                for (int64_t i_66845 = 0; i_66845 < m_65377; i_66845++) {
                    int64_t discard_66808;
                    int64_t scanacc_66804 = (int64_t) 0;
                    
                    for (int64_t i_66806 = 0; i_66806 < n_65378; i_66806++) {
                        double x_65807;
                        
                        x_65807 = ((double *) Y_mem_67129.mem)[i_66845 *
                                                               n_65378 +
                                                               i_66806];
                        
                        bool isnan_res_65808;
                        
                        isnan_res_65808 = futrts_isnan64(x_65807);
                        
                        bool defunc_0_p_res_65809 = !isnan_res_65808;
                        int64_t defunc_0_f_res_65810 =
                                btoi_bool_i64(defunc_0_p_res_65809);
                        int64_t defunc_1_op_res_65806 =
                                add64(defunc_0_f_res_65810, scanacc_66804);
                        
                        ((int64_t *) mem_67446)[i_66806] =
                            defunc_1_op_res_65806;
                        
                        int64_t scanacc_tmp_68378 = defunc_1_op_res_65806;
                        
                        scanacc_66804 = scanacc_tmp_68378;
                    }
                    discard_66808 = scanacc_66804;
                    
                    int64_t last_res_65811;
                    
                    last_res_65811 = ((int64_t *) mem_67446)[i_65392];
                    for (int64_t i_68380 = 0; i_68380 < n_65378; i_68380++) {
                        ((double *) mem_67461)[i_68380] = 0.0;
                    }
                    for (int64_t i_68381 = 0; i_68381 < n_65378; i_68381++) {
                        ((int64_t *) mem_67464)[i_68381] = (int64_t) -1;
                    }
                    for (int64_t write_iter_66809 = 0; write_iter_66809 <
                         n_65378; write_iter_66809++) {
                        double write_iv_66812;
                        
                        write_iv_66812 = ((double *) Y_mem_67129.mem)[i_66845 *
                                                                      n_65378 +
                                                                      write_iter_66809];
                        
                        int64_t write_iv_66813;
                        
                        write_iv_66813 =
                            ((int64_t *) mem_67446)[write_iter_66809];
                        
                        bool isnan_res_65819;
                        
                        isnan_res_65819 = futrts_isnan64(write_iv_66812);
                        
                        bool defunc_0_p_res_65820 = !isnan_res_65819;
                        int64_t defunc_1_f_res_65821;
                        
                        if (defunc_0_p_res_65820) {
                            int64_t defunc_1_f_res_t_res_65822 =
                                    sub64(write_iv_66813, (int64_t) 1);
                            
                            defunc_1_f_res_65821 = defunc_1_f_res_t_res_65822;
                        } else {
                            defunc_1_f_res_65821 = (int64_t) -1;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_65821) &&
                            slt64(defunc_1_f_res_65821, n_65378)) {
                            ((int64_t *) mem_67464)[defunc_1_f_res_65821] =
                                write_iter_66809;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_65821) &&
                            slt64(defunc_1_f_res_65821, n_65378)) {
                            if ((int64_t) 8 > 0)
                                memmove(mem_67461 + defunc_1_f_res_65821 *
                                        (int64_t) 8, Y_mem_67129.mem +
                                        (i_66845 * n_65378 + write_iter_66809) *
                                        (int64_t) 8, (int64_t) 8);
                        }
                    }
                    for (int64_t i_66819 = 0; i_66819 < n_65378; i_66819++) {
                        int64_t x_65824;
                        
                        x_65824 = ((int64_t *) mem_67464)[i_66819];
                        
                        int64_t defunc_0_f_res_65825 = add64((int64_t) 1,
                                                             x_65824);
                        
                        ((int64_t *) mem_67491)[i_66819] = defunc_0_f_res_65825;
                    }
                    
                    int64_t min_arg_65826 = sub64(last_res_65811, (int64_t) 1);
                    int64_t min_arg_65827 = sub64(last_res_65811,
                                                  min_res_65398);
                    int64_t min_res_65828 = smin64(q_65380, last_res_65811);
                    double i64_res_65829 = sitofp_i64_f64(last_res_65811);
                    double x_65830 = i64_res_65404 - i64_res_65829;
                    double max_arg_65831 = x_65830 / 2.0;
                    double max_res_65832 = fmax64(0.0, max_arg_65831);
                    
                    for (int64_t i_66823 = 0; i_66823 < q_65380; i_66823++) {
                        bool cond_65835 = sle64(last_res_65811, i_66823);
                        double defunc_0_f_res_65836;
                        
                        if (cond_65835) {
                            defunc_0_f_res_65836 = 0.0;
                        } else {
                            defunc_0_f_res_65836 = 1.0;
                        }
                        ((double *) mem_67506)[i_66823] = defunc_0_f_res_65836;
                    }
                    for (int64_t i_66838 = 0; i_66838 < n_m_65386; i_66838++) {
                        int64_t min_arg_65840 = mul64(jump_65382, i_66838);
                        int64_t min_res_65841 = smin64(i_65392, min_arg_65840);
                        int64_t defunc_0_g_res_65842 = add64((int64_t) 1,
                                                             min_res_65841);
                        bool init_idx_65843;
                        int64_t init_idx_65844;
                        int64_t init_idx_65845;
                        bool loop_while_65846;
                        int64_t low_65847;
                        int64_t high_65848;
                        
                        loop_while_65846 = x_65393;
                        low_65847 = (int64_t) 0;
                        high_65848 = i_65392;
                        while (loop_while_65846) {
                            int64_t x_65849 = add64(low_65847, high_65848);
                            int64_t mid_65850 = sdiv64(x_65849, (int64_t) 2);
                            bool x_65851 = sle64((int64_t) 0, mid_65850);
                            bool y_65852 = slt64(mid_65850, n_65378);
                            bool bounds_check_65853 = x_65851 && y_65852;
                            bool index_certs_65854;
                            
                            if (!bounds_check_65853) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [", (long long) mid_65850,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65378, "].",
                                              "-> #0  loess.fut:450:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                                if (memblock_unref(ctx, &mem_67423,
                                                   "mem_67423") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67419,
                                                   "mem_67419") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67579,
                                                   "ext_mem_67579") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67587,
                                                   "ext_mem_67587") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67595,
                                                   "ext_mem_67595") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67603,
                                                   "ext_mem_67603") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68197,
                                                   "ext_mem_68197") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68205,
                                                   "ext_mem_68205") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68330,
                                                   "mem_out_68330") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t mid_id_65855;
                            
                            mid_id_65855 = ((int64_t *) mem_67491)[mid_65850];
                            
                            bool cond_65856 = slt64(mid_id_65855, (int64_t) 0);
                            int64_t mid_idx_65857;
                            
                            if (cond_65856) {
                                mid_idx_65857 = (int64_t) 9223372036854775807;
                            } else {
                                mid_idx_65857 = mid_id_65855;
                            }
                            
                            bool cond_65858 = sle64(defunc_0_g_res_65842,
                                                    mid_idx_65857);
                            int64_t loopres_65859;
                            int64_t loopres_65860;
                            
                            if (cond_65858) {
                                int64_t loopres_t_res_65861 = sub64(mid_65850,
                                                                    (int64_t) 1);
                                
                                loopres_65859 = low_65847;
                                loopres_65860 = loopres_t_res_65861;
                            } else {
                                int64_t loopres_f_res_65862 = add64((int64_t) 1,
                                                                    mid_65850);
                                
                                loopres_65859 = loopres_f_res_65862;
                                loopres_65860 = high_65848;
                            }
                            
                            bool loop_cond_65863 = sle64(loopres_65859,
                                                         loopres_65860);
                            bool loop_while_tmp_68388 = loop_cond_65863;
                            int64_t low_tmp_68389 = loopres_65859;
                            int64_t high_tmp_68390 = loopres_65860;
                            
                            loop_while_65846 = loop_while_tmp_68388;
                            low_65847 = low_tmp_68389;
                            high_65848 = high_tmp_68390;
                        }
                        init_idx_65843 = loop_while_65846;
                        init_idx_65844 = low_65847;
                        init_idx_65845 = high_65848;
                        
                        bool idx_65864;
                        int64_t idx_65865;
                        int64_t idx_65866;
                        int64_t idx_65867;
                        bool loop_while_65868;
                        int64_t l_idx_65869;
                        int64_t r_idx_65870;
                        int64_t span_65871;
                        
                        loop_while_65868 = loop_cond_65403;
                        l_idx_65869 = init_idx_65844;
                        r_idx_65870 = init_idx_65844;
                        span_65871 = (int64_t) 1;
                        while (loop_while_65868) {
                            int64_t max_arg_65872 = sub64(l_idx_65869,
                                                          (int64_t) 1);
                            int64_t max_res_65873 = smax64((int64_t) 0,
                                                           max_arg_65872);
                            int64_t min_arg_65874 = add64((int64_t) 1,
                                                          r_idx_65870);
                            int64_t min_res_65875 = smin64(min_arg_65826,
                                                           min_arg_65874);
                            bool x_65876 = sle64((int64_t) 0, max_res_65873);
                            bool y_65877 = slt64(max_res_65873, n_65378);
                            bool bounds_check_65878 = x_65876 && y_65877;
                            bool index_certs_65879;
                            
                            if (!bounds_check_65878) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) max_res_65873,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65378, "].",
                                              "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                                if (memblock_unref(ctx, &mem_67423,
                                                   "mem_67423") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67419,
                                                   "mem_67419") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67579,
                                                   "ext_mem_67579") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67587,
                                                   "ext_mem_67587") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67595,
                                                   "ext_mem_67595") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67603,
                                                   "ext_mem_67603") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68197,
                                                   "ext_mem_68197") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68205,
                                                   "ext_mem_68205") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68330,
                                                   "mem_out_68330") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_65880;
                            
                            x_65880 = ((int64_t *) mem_67491)[max_res_65873];
                            
                            int64_t abs_arg_65881 = sub64(x_65880,
                                                          defunc_0_g_res_65842);
                            int64_t abs_res_65882 = abs64(abs_arg_65881);
                            bool x_65883 = sle64((int64_t) 0, min_res_65875);
                            bool y_65884 = slt64(min_res_65875, n_65378);
                            bool bounds_check_65885 = x_65883 && y_65884;
                            bool index_certs_65886;
                            
                            if (!bounds_check_65885) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) min_res_65875,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65378, "].",
                                              "-> #0  loess.fut:461:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                                if (memblock_unref(ctx, &mem_67423,
                                                   "mem_67423") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67419,
                                                   "mem_67419") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67579,
                                                   "ext_mem_67579") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67587,
                                                   "ext_mem_67587") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67595,
                                                   "ext_mem_67595") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_67603,
                                                   "ext_mem_67603") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68197,
                                                   "ext_mem_68197") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68205,
                                                   "ext_mem_68205") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68330,
                                                   "mem_out_68330") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_65887;
                            
                            x_65887 = ((int64_t *) mem_67491)[min_res_65875];
                            
                            int64_t abs_arg_65888 = sub64(x_65887,
                                                          defunc_0_g_res_65842);
                            int64_t abs_res_65889 = abs64(abs_arg_65888);
                            bool cond_65890 = max_res_65873 == l_idx_65869;
                            int64_t loopres_65891;
                            int64_t loopres_65892;
                            int64_t loopres_65893;
                            
                            if (cond_65890) {
                                loopres_65891 = l_idx_65869;
                                loopres_65892 = r_idx_65870;
                                loopres_65893 = min_res_65398;
                            } else {
                                bool cond_65894 = slt64(abs_res_65882,
                                                        abs_res_65889);
                                bool cond_f_res_65895 = min_res_65875 ==
                                     r_idx_65870;
                                bool x_65896 = !cond_65894;
                                bool y_65897 = cond_f_res_65895 && x_65896;
                                bool cond_65898 = cond_65894 || y_65897;
                                int64_t loopres_f_res_65899;
                                
                                if (cond_65898) {
                                    loopres_f_res_65899 = max_res_65873;
                                } else {
                                    loopres_f_res_65899 = l_idx_65869;
                                }
                                
                                int64_t loopres_f_res_65900;
                                
                                if (cond_65898) {
                                    loopres_f_res_65900 = r_idx_65870;
                                } else {
                                    loopres_f_res_65900 = min_res_65875;
                                }
                                
                                int64_t loopres_f_res_65901;
                                
                                if (cond_65898) {
                                    int64_t loopres_f_res_t_res_65902 =
                                            add64((int64_t) 1, span_65871);
                                    
                                    loopres_f_res_65901 =
                                        loopres_f_res_t_res_65902;
                                } else {
                                    int64_t loopres_f_res_f_res_65903 =
                                            add64((int64_t) 1, span_65871);
                                    
                                    loopres_f_res_65901 =
                                        loopres_f_res_f_res_65903;
                                }
                                loopres_65891 = loopres_f_res_65899;
                                loopres_65892 = loopres_f_res_65900;
                                loopres_65893 = loopres_f_res_65901;
                            }
                            
                            bool loop_cond_65904 = slt64(loopres_65893,
                                                         min_res_65398);
                            bool loop_while_tmp_68391 = loop_cond_65904;
                            int64_t l_idx_tmp_68392 = loopres_65891;
                            int64_t r_idx_tmp_68393 = loopres_65892;
                            int64_t span_tmp_68394 = loopres_65893;
                            
                            loop_while_65868 = loop_while_tmp_68391;
                            l_idx_65869 = l_idx_tmp_68392;
                            r_idx_65870 = r_idx_tmp_68393;
                            span_65871 = span_tmp_68394;
                        }
                        idx_65864 = loop_while_65868;
                        idx_65865 = l_idx_65869;
                        idx_65866 = r_idx_65870;
                        idx_65867 = span_65871;
                        
                        int64_t min_res_65905 = smin64(min_arg_65827,
                                                       idx_65865);
                        int64_t max_res_65906 = smax64((int64_t) 0,
                                                       min_res_65905);
                        int64_t x_65907 = add64(min_res_65828, max_res_65906);
                        int64_t r_65908 = sub64(x_65907, (int64_t) 1);
                        bool x_65909 = sle64((int64_t) 0, r_65908);
                        bool y_65910 = slt64(r_65908, n_65378);
                        bool bounds_check_65911 = x_65909 && y_65910;
                        bool index_certs_65912;
                        
                        if (!bounds_check_65911) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) r_65908,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:485:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67423, "mem_67423") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67419, "mem_67419") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67579,
                                               "ext_mem_67579") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67587,
                                               "ext_mem_67587") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67595,
                                               "ext_mem_67595") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67603,
                                               "ext_mem_67603") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_65913;
                        
                        x_65913 = ((int64_t *) mem_67464)[r_65908];
                        
                        int64_t abs_arg_65914 = sub64(x_65913, min_res_65841);
                        int64_t abs_res_65915 = abs64(abs_arg_65914);
                        bool x_65916 = sle64((int64_t) 0, max_res_65906);
                        bool y_65917 = slt64(max_res_65906, n_65378);
                        bool bounds_check_65918 = x_65916 && y_65917;
                        bool index_certs_65919;
                        
                        if (!bounds_check_65918) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) max_res_65906,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67423, "mem_67423") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67419, "mem_67419") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67579,
                                               "ext_mem_67579") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67587,
                                               "ext_mem_67587") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67595,
                                               "ext_mem_67595") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_67603,
                                               "ext_mem_67603") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_65920;
                        
                        x_65920 = ((int64_t *) mem_67464)[max_res_65906];
                        
                        int64_t abs_arg_65921 = sub64(x_65920, min_res_65841);
                        int64_t abs_res_65922 = abs64(abs_arg_65921);
                        int64_t max_res_65923 = smax64(abs_res_65915,
                                                       abs_res_65922);
                        double defunc_0_f_res_65924 =
                               sitofp_i64_f64(max_res_65923);
                        double defunc_1_f_res_65925 = max_res_65832 +
                               defunc_0_f_res_65924;
                        double defunc_2_reduce_res_65926;
                        double defunc_2_reduce_res_65927;
                        double defunc_2_reduce_res_65928;
                        double defunc_2_reduce_res_65929;
                        double defunc_2_reduce_res_65930;
                        double redout_66825;
                        double redout_66826;
                        double redout_66827;
                        double redout_66828;
                        double redout_66829;
                        
                        redout_66825 = 0.0;
                        redout_66826 = 0.0;
                        redout_66827 = 0.0;
                        redout_66828 = 0.0;
                        redout_66829 = 0.0;
                        for (int64_t i_66830 = 0; i_66830 < q_65380;
                             i_66830++) {
                            double x_65947;
                            
                            x_65947 = ((double *) mem_67506)[i_66830];
                            
                            bool cond_65948 = sle64(last_res_65811, i_66830);
                            int64_t defunc_0_f_res_65949;
                            
                            if (cond_65948) {
                                defunc_0_f_res_65949 = (int64_t) 0;
                            } else {
                                int64_t i_65950 = add64(max_res_65906, i_66830);
                                int64_t defunc_0_add_arg_65951;
                                
                                defunc_0_add_arg_65951 =
                                    ((int64_t *) mem_67464)[i_65950];
                                
                                int64_t defunc_1_add_res_65952 =
                                        add64((int64_t) 1,
                                              defunc_0_add_arg_65951);
                                
                                defunc_0_f_res_65949 = defunc_1_add_res_65952;
                            }
                            
                            int64_t binop_p_65953 = sub64(defunc_0_f_res_65949,
                                                          min_res_65841);
                            double defunc_0_f_res_65954 =
                                   sitofp_i64_f64(binop_p_65953);
                            double abs_res_65955 = fabs(defunc_0_f_res_65954);
                            double tmp1_65956 = abs_res_65955 /
                                   defunc_1_f_res_65925;
                            double x_65957 = tmp1_65956 * tmp1_65956;
                            double y_65958 = tmp1_65956 * x_65957;
                            double tmp2_65959 = 1.0 - y_65958;
                            double x_65960 = tmp2_65959 * tmp2_65959;
                            double tmp3_65961 = tmp2_65959 * x_65960;
                            double w_j_65962 = x_65947 * tmp3_65961;
                            double xw_j_65963 = defunc_0_f_res_65954 *
                                   w_j_65962;
                            double x2w_j_65964 = defunc_0_f_res_65954 *
                                   xw_j_65963;
                            double x3w_j_65965 = defunc_0_f_res_65954 *
                                   x2w_j_65964;
                            double x4w_j_65966 = defunc_0_f_res_65954 *
                                   x3w_j_65965;
                            double defunc_1_op_res_65933 = w_j_65962 +
                                   redout_66825;
                            double defunc_1_op_res_65936 = xw_j_65963 +
                                   redout_66826;
                            double defunc_1_op_res_65939 = x2w_j_65964 +
                                   redout_66827;
                            double defunc_1_op_res_65942 = x3w_j_65965 +
                                   redout_66828;
                            double defunc_1_op_res_65945 = x4w_j_65966 +
                                   redout_66829;
                            double redout_tmp_68395 = defunc_1_op_res_65933;
                            double redout_tmp_68396 = defunc_1_op_res_65936;
                            double redout_tmp_68397 = defunc_1_op_res_65939;
                            double redout_tmp_68398 = defunc_1_op_res_65942;
                            double redout_tmp_68399 = defunc_1_op_res_65945;
                            
                            redout_66825 = redout_tmp_68395;
                            redout_66826 = redout_tmp_68396;
                            redout_66827 = redout_tmp_68397;
                            redout_66828 = redout_tmp_68398;
                            redout_66829 = redout_tmp_68399;
                        }
                        defunc_2_reduce_res_65926 = redout_66825;
                        defunc_2_reduce_res_65927 = redout_66826;
                        defunc_2_reduce_res_65928 = redout_66827;
                        defunc_2_reduce_res_65929 = redout_66828;
                        defunc_2_reduce_res_65930 = redout_66829;
                        
                        double x_65967 = defunc_2_reduce_res_65928 *
                               defunc_2_reduce_res_65930;
                        double y_65968 = defunc_2_reduce_res_65929 *
                               defunc_2_reduce_res_65929;
                        double a12_65969 = x_65967 - y_65968;
                        double x_65970 = defunc_2_reduce_res_65928 *
                               defunc_2_reduce_res_65929;
                        double y_65971 = defunc_2_reduce_res_65927 *
                               defunc_2_reduce_res_65930;
                        double b12_65972 = x_65970 - y_65971;
                        double x_65973 = defunc_2_reduce_res_65927 *
                               defunc_2_reduce_res_65929;
                        double y_65974 = defunc_2_reduce_res_65928 *
                               defunc_2_reduce_res_65928;
                        double c12_65975 = x_65973 - y_65974;
                        double x_65976 = defunc_2_reduce_res_65926 *
                               defunc_2_reduce_res_65930;
                        double b2_65977 = x_65976 - y_65974;
                        double x_65978 = defunc_2_reduce_res_65927 *
                               defunc_2_reduce_res_65928;
                        double y_65979 = defunc_2_reduce_res_65926 *
                               defunc_2_reduce_res_65929;
                        double c2_65980 = x_65978 - y_65979;
                        double x_65981 = defunc_2_reduce_res_65926 * a12_65969;
                        double y_65982 = defunc_2_reduce_res_65927 * b12_65972;
                        double x_65983 = x_65981 + y_65982;
                        double y_65984 = defunc_2_reduce_res_65928 * c12_65975;
                        double y_65985 = x_65983 + y_65984;
                        double det_65986 = 1.0 / y_65985;
                        double a12_65987 = a12_65969 * det_65986;
                        double b12_65988 = b12_65972 * det_65986;
                        double c12_65989 = c12_65975 * det_65986;
                        double b2_65990 = b2_65977 * det_65986;
                        double c2_65991 = c2_65980 * det_65986;
                        double defunc_2_reduce_res_65992;
                        double defunc_2_reduce_res_65993;
                        double redout_66831;
                        double redout_66832;
                        
                        redout_66831 = 0.0;
                        redout_66832 = 0.0;
                        for (int64_t i_66833 = 0; i_66833 < q_65380;
                             i_66833++) {
                            double x_66001;
                            
                            x_66001 = ((double *) mem_67506)[i_66833];
                            
                            bool cond_66002 = sle64(last_res_65811, i_66833);
                            int64_t defunc_0_f_res_66003;
                            
                            if (cond_66002) {
                                defunc_0_f_res_66003 = (int64_t) 0;
                            } else {
                                int64_t i_66004 = add64(max_res_65906, i_66833);
                                int64_t defunc_0_add_arg_66005;
                                
                                defunc_0_add_arg_66005 =
                                    ((int64_t *) mem_67464)[i_66004];
                                
                                int64_t defunc_1_add_res_66006 =
                                        add64((int64_t) 1,
                                              defunc_0_add_arg_66005);
                                
                                defunc_0_f_res_66003 = defunc_1_add_res_66006;
                            }
                            
                            int64_t binop_p_66007 = sub64(defunc_0_f_res_66003,
                                                          min_res_65841);
                            double defunc_0_f_res_66008 =
                                   sitofp_i64_f64(binop_p_66007);
                            double abs_res_66009 = fabs(defunc_0_f_res_66008);
                            double tmp1_66010 = abs_res_66009 /
                                   defunc_1_f_res_65925;
                            double x_66011 = tmp1_66010 * tmp1_66010;
                            double y_66012 = tmp1_66010 * x_66011;
                            double tmp2_66013 = 1.0 - y_66012;
                            double x_66014 = tmp2_66013 * tmp2_66013;
                            double tmp3_66015 = tmp2_66013 * x_66014;
                            double tmp4_66016 = x_66001 * tmp3_66015;
                            double defunc_1_f_res_66017 = defunc_0_f_res_66008 *
                                   tmp4_66016;
                            double defunc_1_f_res_66018 = defunc_0_f_res_66008 *
                                   defunc_1_f_res_66017;
                            double defunc_0_f_res_66019;
                            
                            if (cond_66002) {
                                defunc_0_f_res_66019 = 0.0;
                            } else {
                                int64_t i_66020 = add64(max_res_65906, i_66833);
                                double defunc_0_add_arg_66021;
                                
                                defunc_0_add_arg_66021 =
                                    ((double *) mem_67461)[i_66020];
                                defunc_0_f_res_66019 = defunc_0_add_arg_66021;
                            }
                            
                            double x_66022 = a12_65987 * tmp4_66016;
                            double y_66023 = b12_65988 * defunc_1_f_res_66017;
                            double x_66024 = x_66022 + y_66023;
                            double y_66025 = c12_65989 * defunc_1_f_res_66018;
                            double x_66026 = x_66024 + y_66025;
                            double defunc_9_fit_fun_res_66027 =
                                   defunc_0_f_res_66019 * x_66026;
                            double x_66028 = b12_65988 * tmp4_66016;
                            double y_66029 = b2_65990 * defunc_1_f_res_66017;
                            double x_66030 = x_66028 + y_66029;
                            double y_66031 = c2_65991 * defunc_1_f_res_66018;
                            double x_66032 = x_66030 + y_66031;
                            double defunc_9_slope_fun_res_66033 =
                                   defunc_0_f_res_66019 * x_66032;
                            double defunc_1_op_res_65996 =
                                   defunc_9_fit_fun_res_66027 + redout_66831;
                            double defunc_1_op_res_65999 =
                                   defunc_9_slope_fun_res_66033 + redout_66832;
                            double redout_tmp_68400 = defunc_1_op_res_65996;
                            double redout_tmp_68401 = defunc_1_op_res_65999;
                            
                            redout_66831 = redout_tmp_68400;
                            redout_66832 = redout_tmp_68401;
                        }
                        defunc_2_reduce_res_65992 = redout_66831;
                        defunc_2_reduce_res_65993 = redout_66832;
                        ((double *) mem_67419.mem)[i_66845 * n_m_65386 +
                                                   i_66838] =
                            defunc_2_reduce_res_65992;
                        ((double *) mem_67423.mem)[i_66845 * n_m_65386 +
                                                   i_66838] =
                            defunc_2_reduce_res_65993;
                    }
                }
                if (memblock_set(ctx, &ext_mem_67587, &mem_67419,
                                 "mem_67419") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_67579, &mem_67423,
                                 "mem_67423") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67423, "mem_67423") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67419, "mem_67419") != 0)
                    return 1;
            }
            if (memblock_set(ctx, &ext_mem_67603, &ext_mem_67587,
                             "ext_mem_67587") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_67595, &ext_mem_67579,
                             "ext_mem_67579") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_67579, "ext_mem_67579") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_67587, "ext_mem_67587") != 0)
                return 1;
        }
        if (memblock_set(ctx, &ext_mem_68205, &ext_mem_67603,
                         "ext_mem_67603") != 0)
            return 1;
        if (memblock_set(ctx, &ext_mem_68197, &ext_mem_67595,
                         "ext_mem_67595") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_67595, "ext_mem_67595") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_67603, "ext_mem_67603") != 0)
            return 1;
    } else {
        bool match_lit_66036 = (int64_t) 0 == degree_65381;
        int64_t binop_x_67611 = m_65377 * n_m_65386;
        int64_t binop_y_67612 = (int64_t) 8 * binop_x_67611;
        int64_t bytes_67613 = smax64((int64_t) 0, binop_y_67612);
        int64_t binop_y_67629 = (int64_t) 8 * n_65378;
        int64_t bytes_67630 = smax64((int64_t) 0, binop_y_67629);
        int64_t binop_y_67689 = (int64_t) 8 * q_65380;
        int64_t bytes_67690 = smax64((int64_t) 0, binop_y_67689);
        struct memblock ext_mem_68189;
        
        ext_mem_68189.references = NULL;
        
        struct memblock ext_mem_68181;
        
        ext_mem_68181.references = NULL;
        if (match_lit_66036) {
            struct memblock mem_67614;
            
            mem_67614.references = NULL;
            if (memblock_alloc(ctx, &mem_67614, bytes_67613, "mem_67614")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_68402 = 0; i_68402 < m_65377; i_68402++) {
                for (int64_t i_68403 = 0; i_68403 < n_m_65386; i_68403++) {
                    ((double *) mem_67614.mem)[i_68402 * n_m_65386 + i_68403] =
                        0.0;
                }
            }
            
            struct memblock mem_67618;
            
            mem_67618.references = NULL;
            if (memblock_alloc(ctx, &mem_67618, bytes_67613, "mem_67618")) {
                err = 1;
                goto cleanup;
            }
            if (mem_67631_cached_sizze_68498 < (size_t) bytes_67630) {
                mem_67631 = realloc(mem_67631, bytes_67630);
                mem_67631_cached_sizze_68498 = bytes_67630;
            }
            if (mem_67646_cached_sizze_68499 < (size_t) bytes_67630) {
                mem_67646 = realloc(mem_67646, bytes_67630);
                mem_67646_cached_sizze_68499 = bytes_67630;
            }
            if (mem_67649_cached_sizze_68500 < (size_t) bytes_67630) {
                mem_67649 = realloc(mem_67649, bytes_67630);
                mem_67649_cached_sizze_68500 = bytes_67630;
            }
            if (mem_67676_cached_sizze_68501 < (size_t) bytes_67630) {
                mem_67676 = realloc(mem_67676, bytes_67630);
                mem_67676_cached_sizze_68501 = bytes_67630;
            }
            if (mem_67691_cached_sizze_68502 < (size_t) bytes_67690) {
                mem_67691 = realloc(mem_67691, bytes_67690);
                mem_67691_cached_sizze_68502 = bytes_67690;
            }
            if (mem_67717_cached_sizze_68503 < (size_t) bytes_67690) {
                mem_67717 = realloc(mem_67717, bytes_67690);
                mem_67717_cached_sizze_68503 = bytes_67690;
            }
            for (int64_t i_66883 = 0; i_66883 < m_65377; i_66883++) {
                int64_t discard_66853;
                int64_t scanacc_66849 = (int64_t) 0;
                
                for (int64_t i_66851 = 0; i_66851 < n_65378; i_66851++) {
                    double x_66047;
                    
                    x_66047 = ((double *) Y_mem_67129.mem)[i_66883 * n_65378 +
                                                           i_66851];
                    
                    bool isnan_res_66048;
                    
                    isnan_res_66048 = futrts_isnan64(x_66047);
                    
                    bool defunc_0_p_res_66049 = !isnan_res_66048;
                    int64_t defunc_0_f_res_66050 =
                            btoi_bool_i64(defunc_0_p_res_66049);
                    int64_t defunc_1_op_res_66046 = add64(defunc_0_f_res_66050,
                                                          scanacc_66849);
                    
                    ((int64_t *) mem_67631)[i_66851] = defunc_1_op_res_66046;
                    
                    int64_t scanacc_tmp_68405 = defunc_1_op_res_66046;
                    
                    scanacc_66849 = scanacc_tmp_68405;
                }
                discard_66853 = scanacc_66849;
                
                int64_t last_res_66051;
                
                last_res_66051 = ((int64_t *) mem_67631)[i_65392];
                for (int64_t i_68407 = 0; i_68407 < n_65378; i_68407++) {
                    ((double *) mem_67646)[i_68407] = 0.0;
                }
                for (int64_t i_68408 = 0; i_68408 < n_65378; i_68408++) {
                    ((int64_t *) mem_67649)[i_68408] = (int64_t) -1;
                }
                for (int64_t write_iter_66854 = 0; write_iter_66854 < n_65378;
                     write_iter_66854++) {
                    double write_iv_66857;
                    
                    write_iv_66857 = ((double *) Y_mem_67129.mem)[i_66883 *
                                                                  n_65378 +
                                                                  write_iter_66854];
                    
                    int64_t write_iv_66858;
                    
                    write_iv_66858 = ((int64_t *) mem_67631)[write_iter_66854];
                    
                    bool isnan_res_66059;
                    
                    isnan_res_66059 = futrts_isnan64(write_iv_66857);
                    
                    bool defunc_0_p_res_66060 = !isnan_res_66059;
                    int64_t defunc_1_f_res_66061;
                    
                    if (defunc_0_p_res_66060) {
                        int64_t defunc_1_f_res_t_res_66062 =
                                sub64(write_iv_66858, (int64_t) 1);
                        
                        defunc_1_f_res_66061 = defunc_1_f_res_t_res_66062;
                    } else {
                        defunc_1_f_res_66061 = (int64_t) -1;
                    }
                    if (sle64((int64_t) 0, defunc_1_f_res_66061) &&
                        slt64(defunc_1_f_res_66061, n_65378)) {
                        ((int64_t *) mem_67649)[defunc_1_f_res_66061] =
                            write_iter_66854;
                    }
                    if (sle64((int64_t) 0, defunc_1_f_res_66061) &&
                        slt64(defunc_1_f_res_66061, n_65378)) {
                        if ((int64_t) 8 > 0)
                            memmove(mem_67646 + defunc_1_f_res_66061 *
                                    (int64_t) 8, Y_mem_67129.mem + (i_66883 *
                                                                    n_65378 +
                                                                    write_iter_66854) *
                                    (int64_t) 8, (int64_t) 8);
                    }
                }
                for (int64_t i_66864 = 0; i_66864 < n_65378; i_66864++) {
                    int64_t x_66064;
                    
                    x_66064 = ((int64_t *) mem_67649)[i_66864];
                    
                    int64_t defunc_0_f_res_66065 = add64((int64_t) 1, x_66064);
                    
                    ((int64_t *) mem_67676)[i_66864] = defunc_0_f_res_66065;
                }
                
                int64_t min_arg_66066 = sub64(last_res_66051, (int64_t) 1);
                int64_t min_arg_66067 = sub64(last_res_66051, min_res_65398);
                int64_t min_res_66068 = smin64(q_65380, last_res_66051);
                double i64_res_66069 = sitofp_i64_f64(last_res_66051);
                double x_66070 = i64_res_65404 - i64_res_66069;
                double max_arg_66071 = x_66070 / 2.0;
                double max_res_66072 = fmax64(0.0, max_arg_66071);
                
                for (int64_t i_66868 = 0; i_66868 < q_65380; i_66868++) {
                    bool cond_66075 = sle64(last_res_66051, i_66868);
                    double defunc_0_f_res_66076;
                    
                    if (cond_66075) {
                        defunc_0_f_res_66076 = 0.0;
                    } else {
                        defunc_0_f_res_66076 = 1.0;
                    }
                    ((double *) mem_67691)[i_66868] = defunc_0_f_res_66076;
                }
                for (int64_t i_66879 = 0; i_66879 < n_m_65386; i_66879++) {
                    int64_t min_arg_66079 = mul64(jump_65382, i_66879);
                    int64_t min_res_66080 = smin64(i_65392, min_arg_66079);
                    int64_t defunc_0_g_res_66081 = add64((int64_t) 1,
                                                         min_res_66080);
                    bool init_idx_66082;
                    int64_t init_idx_66083;
                    int64_t init_idx_66084;
                    bool loop_while_66085;
                    int64_t low_66086;
                    int64_t high_66087;
                    
                    loop_while_66085 = x_65393;
                    low_66086 = (int64_t) 0;
                    high_66087 = i_65392;
                    while (loop_while_66085) {
                        int64_t x_66088 = add64(low_66086, high_66087);
                        int64_t mid_66089 = sdiv64(x_66088, (int64_t) 2);
                        bool x_66090 = sle64((int64_t) 0, mid_66089);
                        bool y_66091 = slt64(mid_66089, n_65378);
                        bool bounds_check_66092 = x_66090 && y_66091;
                        bool index_certs_66093;
                        
                        if (!bounds_check_66092) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) mid_66089,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:450:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67618, "mem_67618") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67614, "mem_67614") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68181,
                                               "ext_mem_68181") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68189,
                                               "ext_mem_68189") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t mid_id_66094;
                        
                        mid_id_66094 = ((int64_t *) mem_67676)[mid_66089];
                        
                        bool cond_66095 = slt64(mid_id_66094, (int64_t) 0);
                        int64_t mid_idx_66096;
                        
                        if (cond_66095) {
                            mid_idx_66096 = (int64_t) 9223372036854775807;
                        } else {
                            mid_idx_66096 = mid_id_66094;
                        }
                        
                        bool cond_66097 = sle64(defunc_0_g_res_66081,
                                                mid_idx_66096);
                        int64_t loopres_66098;
                        int64_t loopres_66099;
                        
                        if (cond_66097) {
                            int64_t loopres_t_res_66100 = sub64(mid_66089,
                                                                (int64_t) 1);
                            
                            loopres_66098 = low_66086;
                            loopres_66099 = loopres_t_res_66100;
                        } else {
                            int64_t loopres_f_res_66101 = add64((int64_t) 1,
                                                                mid_66089);
                            
                            loopres_66098 = loopres_f_res_66101;
                            loopres_66099 = high_66087;
                        }
                        
                        bool loop_cond_66102 = sle64(loopres_66098,
                                                     loopres_66099);
                        bool loop_while_tmp_68414 = loop_cond_66102;
                        int64_t low_tmp_68415 = loopres_66098;
                        int64_t high_tmp_68416 = loopres_66099;
                        
                        loop_while_66085 = loop_while_tmp_68414;
                        low_66086 = low_tmp_68415;
                        high_66087 = high_tmp_68416;
                    }
                    init_idx_66082 = loop_while_66085;
                    init_idx_66083 = low_66086;
                    init_idx_66084 = high_66087;
                    
                    bool idx_66103;
                    int64_t idx_66104;
                    int64_t idx_66105;
                    int64_t idx_66106;
                    bool loop_while_66107;
                    int64_t l_idx_66108;
                    int64_t r_idx_66109;
                    int64_t span_66110;
                    
                    loop_while_66107 = loop_cond_65403;
                    l_idx_66108 = init_idx_66083;
                    r_idx_66109 = init_idx_66083;
                    span_66110 = (int64_t) 1;
                    while (loop_while_66107) {
                        int64_t max_arg_66111 = sub64(l_idx_66108, (int64_t) 1);
                        int64_t max_res_66112 = smax64((int64_t) 0,
                                                       max_arg_66111);
                        int64_t min_arg_66113 = add64((int64_t) 1, r_idx_66109);
                        int64_t min_res_66114 = smin64(min_arg_66066,
                                                       min_arg_66113);
                        bool x_66115 = sle64((int64_t) 0, max_res_66112);
                        bool y_66116 = slt64(max_res_66112, n_65378);
                        bool bounds_check_66117 = x_66115 && y_66116;
                        bool index_certs_66118;
                        
                        if (!bounds_check_66117) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) max_res_66112,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67618, "mem_67618") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67614, "mem_67614") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68181,
                                               "ext_mem_68181") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68189,
                                               "ext_mem_68189") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_66119;
                        
                        x_66119 = ((int64_t *) mem_67676)[max_res_66112];
                        
                        int64_t abs_arg_66120 = sub64(x_66119,
                                                      defunc_0_g_res_66081);
                        int64_t abs_res_66121 = abs64(abs_arg_66120);
                        bool x_66122 = sle64((int64_t) 0, min_res_66114);
                        bool y_66123 = slt64(min_res_66114, n_65378);
                        bool bounds_check_66124 = x_66122 && y_66123;
                        bool index_certs_66125;
                        
                        if (!bounds_check_66124) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) min_res_66114,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:461:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67618, "mem_67618") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67614, "mem_67614") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68181,
                                               "ext_mem_68181") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68189,
                                               "ext_mem_68189") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_66126;
                        
                        x_66126 = ((int64_t *) mem_67676)[min_res_66114];
                        
                        int64_t abs_arg_66127 = sub64(x_66126,
                                                      defunc_0_g_res_66081);
                        int64_t abs_res_66128 = abs64(abs_arg_66127);
                        bool cond_66129 = max_res_66112 == l_idx_66108;
                        int64_t loopres_66130;
                        int64_t loopres_66131;
                        int64_t loopres_66132;
                        
                        if (cond_66129) {
                            loopres_66130 = l_idx_66108;
                            loopres_66131 = r_idx_66109;
                            loopres_66132 = min_res_65398;
                        } else {
                            bool cond_66133 = slt64(abs_res_66121,
                                                    abs_res_66128);
                            bool cond_f_res_66134 = min_res_66114 ==
                                 r_idx_66109;
                            bool x_66135 = !cond_66133;
                            bool y_66136 = cond_f_res_66134 && x_66135;
                            bool cond_66137 = cond_66133 || y_66136;
                            int64_t loopres_f_res_66138;
                            
                            if (cond_66137) {
                                loopres_f_res_66138 = max_res_66112;
                            } else {
                                loopres_f_res_66138 = l_idx_66108;
                            }
                            
                            int64_t loopres_f_res_66139;
                            
                            if (cond_66137) {
                                loopres_f_res_66139 = r_idx_66109;
                            } else {
                                loopres_f_res_66139 = min_res_66114;
                            }
                            
                            int64_t loopres_f_res_66140;
                            
                            if (cond_66137) {
                                int64_t loopres_f_res_t_res_66141 =
                                        add64((int64_t) 1, span_66110);
                                
                                loopres_f_res_66140 = loopres_f_res_t_res_66141;
                            } else {
                                int64_t loopres_f_res_f_res_66142 =
                                        add64((int64_t) 1, span_66110);
                                
                                loopres_f_res_66140 = loopres_f_res_f_res_66142;
                            }
                            loopres_66130 = loopres_f_res_66138;
                            loopres_66131 = loopres_f_res_66139;
                            loopres_66132 = loopres_f_res_66140;
                        }
                        
                        bool loop_cond_66143 = slt64(loopres_66132,
                                                     min_res_65398);
                        bool loop_while_tmp_68417 = loop_cond_66143;
                        int64_t l_idx_tmp_68418 = loopres_66130;
                        int64_t r_idx_tmp_68419 = loopres_66131;
                        int64_t span_tmp_68420 = loopres_66132;
                        
                        loop_while_66107 = loop_while_tmp_68417;
                        l_idx_66108 = l_idx_tmp_68418;
                        r_idx_66109 = r_idx_tmp_68419;
                        span_66110 = span_tmp_68420;
                    }
                    idx_66103 = loop_while_66107;
                    idx_66104 = l_idx_66108;
                    idx_66105 = r_idx_66109;
                    idx_66106 = span_66110;
                    
                    int64_t min_res_66144 = smin64(min_arg_66067, idx_66104);
                    int64_t max_res_66145 = smax64((int64_t) 0, min_res_66144);
                    int64_t x_66146 = add64(min_res_66068, max_res_66145);
                    int64_t r_66147 = sub64(x_66146, (int64_t) 1);
                    bool x_66148 = sle64((int64_t) 0, r_66147);
                    bool y_66149 = slt64(r_66147, n_65378);
                    bool bounds_check_66150 = x_66148 && y_66149;
                    bool index_certs_66151;
                    
                    if (!bounds_check_66150) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) r_66147,
                                      "] out of bounds for array of shape [",
                                      (long long) n_65378, "].",
                                      "-> #0  loess.fut:485:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
                        if (memblock_unref(ctx, &mem_67618, "mem_67618") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_67614, "mem_67614") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68181,
                                           "ext_mem_68181") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68189,
                                           "ext_mem_68189") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68197,
                                           "ext_mem_68197") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68205,
                                           "ext_mem_68205") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_68330,
                                           "mem_out_68330") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_66152;
                    
                    x_66152 = ((int64_t *) mem_67649)[r_66147];
                    
                    int64_t abs_arg_66153 = sub64(x_66152, min_res_66080);
                    int64_t abs_res_66154 = abs64(abs_arg_66153);
                    bool x_66155 = sle64((int64_t) 0, max_res_66145);
                    bool y_66156 = slt64(max_res_66145, n_65378);
                    bool bounds_check_66157 = x_66155 && y_66156;
                    bool index_certs_66158;
                    
                    if (!bounds_check_66157) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) max_res_66145,
                                      "] out of bounds for array of shape [",
                                      (long long) n_65378, "].",
                                      "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
                        if (memblock_unref(ctx, &mem_67618, "mem_67618") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_67614, "mem_67614") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68181,
                                           "ext_mem_68181") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68189,
                                           "ext_mem_68189") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68197,
                                           "ext_mem_68197") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_68205,
                                           "ext_mem_68205") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_68330,
                                           "mem_out_68330") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_66159;
                    
                    x_66159 = ((int64_t *) mem_67649)[max_res_66145];
                    
                    int64_t abs_arg_66160 = sub64(x_66159, min_res_66080);
                    int64_t abs_res_66161 = abs64(abs_arg_66160);
                    int64_t max_res_66162 = smax64(abs_res_66154,
                                                   abs_res_66161);
                    double defunc_0_f_res_66163 = sitofp_i64_f64(max_res_66162);
                    double defunc_1_f_res_66164 = max_res_66072 +
                           defunc_0_f_res_66163;
                    double defunc_2_reduce_res_66165;
                    double redout_66871 = 0.0;
                    
                    for (int64_t i_66873 = 0; i_66873 < q_65380; i_66873++) {
                        double x_66171;
                        
                        x_66171 = ((double *) mem_67691)[i_66873];
                        
                        bool cond_66172 = sle64(last_res_66051, i_66873);
                        int64_t defunc_0_f_res_66173;
                        
                        if (cond_66172) {
                            defunc_0_f_res_66173 = (int64_t) 0;
                        } else {
                            int64_t i_66174 = add64(max_res_66145, i_66873);
                            int64_t defunc_0_add_arg_66175;
                            
                            defunc_0_add_arg_66175 =
                                ((int64_t *) mem_67649)[i_66174];
                            
                            int64_t defunc_1_add_res_66176 = add64((int64_t) 1,
                                                                   defunc_0_add_arg_66175);
                            
                            defunc_0_f_res_66173 = defunc_1_add_res_66176;
                        }
                        
                        int64_t binop_p_66177 = sub64(defunc_0_f_res_66173,
                                                      min_res_66080);
                        double defunc_0_f_res_66178 =
                               sitofp_i64_f64(binop_p_66177);
                        double abs_res_66179 = fabs(defunc_0_f_res_66178);
                        double tmp1_66180 = abs_res_66179 /
                               defunc_1_f_res_66164;
                        double x_66181 = tmp1_66180 * tmp1_66180;
                        double y_66182 = tmp1_66180 * x_66181;
                        double tmp2_66183 = 1.0 - y_66182;
                        double x_66184 = tmp2_66183 * tmp2_66183;
                        double tmp3_66185 = tmp2_66183 * x_66184;
                        double tmp4_66186 = x_66171 * tmp3_66185;
                        double defunc_1_op_res_66169 = tmp4_66186 +
                               redout_66871;
                        
                        ((double *) mem_67717)[i_66873] = tmp4_66186;
                        
                        double redout_tmp_68421 = defunc_1_op_res_66169;
                        
                        redout_66871 = redout_tmp_68421;
                    }
                    defunc_2_reduce_res_66165 = redout_66871;
                    
                    double a0_66187 = 1.0 / defunc_2_reduce_res_66165;
                    double defunc_2_reduce_res_66188;
                    double redout_66875 = 0.0;
                    
                    for (int64_t i_66876 = 0; i_66876 < q_65380; i_66876++) {
                        double x_66193;
                        
                        x_66193 = ((double *) mem_67717)[i_66876];
                        
                        bool cond_66194 = sle64(last_res_66051, i_66876);
                        double defunc_0_f_res_66195;
                        
                        if (cond_66194) {
                            defunc_0_f_res_66195 = 0.0;
                        } else {
                            int64_t i_66196 = add64(max_res_66145, i_66876);
                            double defunc_0_add_arg_66197;
                            
                            defunc_0_add_arg_66197 =
                                ((double *) mem_67646)[i_66196];
                            defunc_0_f_res_66195 = defunc_0_add_arg_66197;
                        }
                        
                        double x_66198 = a0_66187 * x_66193;
                        double defunc_9_fit_fun_res_66199 =
                               defunc_0_f_res_66195 * x_66198;
                        double defunc_1_op_res_66191 =
                               defunc_9_fit_fun_res_66199 + redout_66875;
                        double redout_tmp_68423 = defunc_1_op_res_66191;
                        
                        redout_66875 = redout_tmp_68423;
                    }
                    defunc_2_reduce_res_66188 = redout_66875;
                    ((double *) mem_67618.mem)[i_66883 * n_m_65386 + i_66879] =
                        defunc_2_reduce_res_66188;
                }
            }
            if (memblock_set(ctx, &ext_mem_68189, &mem_67618, "mem_67618") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_68181, &mem_67614, "mem_67614") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_67618, "mem_67618") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_67614, "mem_67614") != 0)
                return 1;
        } else {
            bool match_lit_66202 = (int64_t) 1 == degree_65381;
            int64_t binop_x_67749 = m_65377 * n_m_65386;
            int64_t binop_y_67750 = (int64_t) 8 * binop_x_67749;
            int64_t bytes_67751 = smax64((int64_t) 0, binop_y_67750);
            int64_t binop_y_67777 = (int64_t) 8 * n_65378;
            int64_t bytes_67778 = smax64((int64_t) 0, binop_y_67777);
            int64_t binop_y_67837 = (int64_t) 8 * q_65380;
            int64_t bytes_67838 = smax64((int64_t) 0, binop_y_67837);
            int64_t binop_x_67942 = m_65377 * n_m_65386;
            int64_t binop_y_67943 = (int64_t) 8 * binop_x_67942;
            int64_t bytes_67944 = smax64((int64_t) 0, binop_y_67943);
            int64_t binop_y_67970 = (int64_t) 8 * n_65378;
            int64_t bytes_67971 = smax64((int64_t) 0, binop_y_67970);
            int64_t binop_y_68030 = (int64_t) 8 * q_65380;
            int64_t bytes_68031 = smax64((int64_t) 0, binop_y_68030);
            struct memblock ext_mem_68173;
            
            ext_mem_68173.references = NULL;
            
            struct memblock ext_mem_68165;
            
            ext_mem_68165.references = NULL;
            if (match_lit_66202) {
                struct memblock mem_67752;
                
                mem_67752.references = NULL;
                if (memblock_alloc(ctx, &mem_67752, bytes_67751, "mem_67752")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock mem_67756;
                
                mem_67756.references = NULL;
                if (memblock_alloc(ctx, &mem_67756, bytes_67751, "mem_67756")) {
                    err = 1;
                    goto cleanup;
                }
                if (mem_67779_cached_sizze_68504 < (size_t) bytes_67778) {
                    mem_67779 = realloc(mem_67779, bytes_67778);
                    mem_67779_cached_sizze_68504 = bytes_67778;
                }
                if (mem_67794_cached_sizze_68505 < (size_t) bytes_67778) {
                    mem_67794 = realloc(mem_67794, bytes_67778);
                    mem_67794_cached_sizze_68505 = bytes_67778;
                }
                if (mem_67797_cached_sizze_68506 < (size_t) bytes_67778) {
                    mem_67797 = realloc(mem_67797, bytes_67778);
                    mem_67797_cached_sizze_68506 = bytes_67778;
                }
                if (mem_67824_cached_sizze_68507 < (size_t) bytes_67778) {
                    mem_67824 = realloc(mem_67824, bytes_67778);
                    mem_67824_cached_sizze_68507 = bytes_67778;
                }
                if (mem_67839_cached_sizze_68508 < (size_t) bytes_67838) {
                    mem_67839 = realloc(mem_67839, bytes_67838);
                    mem_67839_cached_sizze_68508 = bytes_67838;
                }
                if (mem_67876_cached_sizze_68509 < (size_t) bytes_67838) {
                    mem_67876 = realloc(mem_67876, bytes_67838);
                    mem_67876_cached_sizze_68509 = bytes_67838;
                }
                if (mem_67879_cached_sizze_68510 < (size_t) bytes_67838) {
                    mem_67879 = realloc(mem_67879, bytes_67838);
                    mem_67879_cached_sizze_68510 = bytes_67838;
                }
                for (int64_t i_66931 = 0; i_66931 < m_65377; i_66931++) {
                    int64_t discard_66890;
                    int64_t scanacc_66886 = (int64_t) 0;
                    
                    for (int64_t i_66888 = 0; i_66888 < n_65378; i_66888++) {
                        double x_66213;
                        
                        x_66213 = ((double *) Y_mem_67129.mem)[i_66931 *
                                                               n_65378 +
                                                               i_66888];
                        
                        bool isnan_res_66214;
                        
                        isnan_res_66214 = futrts_isnan64(x_66213);
                        
                        bool defunc_0_p_res_66215 = !isnan_res_66214;
                        int64_t defunc_0_f_res_66216 =
                                btoi_bool_i64(defunc_0_p_res_66215);
                        int64_t defunc_1_op_res_66212 =
                                add64(defunc_0_f_res_66216, scanacc_66886);
                        
                        ((int64_t *) mem_67779)[i_66888] =
                            defunc_1_op_res_66212;
                        
                        int64_t scanacc_tmp_68426 = defunc_1_op_res_66212;
                        
                        scanacc_66886 = scanacc_tmp_68426;
                    }
                    discard_66890 = scanacc_66886;
                    
                    int64_t last_res_66217;
                    
                    last_res_66217 = ((int64_t *) mem_67779)[i_65392];
                    for (int64_t i_68428 = 0; i_68428 < n_65378; i_68428++) {
                        ((double *) mem_67794)[i_68428] = 0.0;
                    }
                    for (int64_t i_68429 = 0; i_68429 < n_65378; i_68429++) {
                        ((int64_t *) mem_67797)[i_68429] = (int64_t) -1;
                    }
                    for (int64_t write_iter_66891 = 0; write_iter_66891 <
                         n_65378; write_iter_66891++) {
                        double write_iv_66894;
                        
                        write_iv_66894 = ((double *) Y_mem_67129.mem)[i_66931 *
                                                                      n_65378 +
                                                                      write_iter_66891];
                        
                        int64_t write_iv_66895;
                        
                        write_iv_66895 =
                            ((int64_t *) mem_67779)[write_iter_66891];
                        
                        bool isnan_res_66225;
                        
                        isnan_res_66225 = futrts_isnan64(write_iv_66894);
                        
                        bool defunc_0_p_res_66226 = !isnan_res_66225;
                        int64_t defunc_1_f_res_66227;
                        
                        if (defunc_0_p_res_66226) {
                            int64_t defunc_1_f_res_t_res_66228 =
                                    sub64(write_iv_66895, (int64_t) 1);
                            
                            defunc_1_f_res_66227 = defunc_1_f_res_t_res_66228;
                        } else {
                            defunc_1_f_res_66227 = (int64_t) -1;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_66227) &&
                            slt64(defunc_1_f_res_66227, n_65378)) {
                            ((int64_t *) mem_67797)[defunc_1_f_res_66227] =
                                write_iter_66891;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_66227) &&
                            slt64(defunc_1_f_res_66227, n_65378)) {
                            if ((int64_t) 8 > 0)
                                memmove(mem_67794 + defunc_1_f_res_66227 *
                                        (int64_t) 8, Y_mem_67129.mem +
                                        (i_66931 * n_65378 + write_iter_66891) *
                                        (int64_t) 8, (int64_t) 8);
                        }
                    }
                    for (int64_t i_66901 = 0; i_66901 < n_65378; i_66901++) {
                        int64_t x_66230;
                        
                        x_66230 = ((int64_t *) mem_67797)[i_66901];
                        
                        int64_t defunc_0_f_res_66231 = add64((int64_t) 1,
                                                             x_66230);
                        
                        ((int64_t *) mem_67824)[i_66901] = defunc_0_f_res_66231;
                    }
                    
                    int64_t min_arg_66232 = sub64(last_res_66217, (int64_t) 1);
                    int64_t min_arg_66233 = sub64(last_res_66217,
                                                  min_res_65398);
                    int64_t min_res_66234 = smin64(q_65380, last_res_66217);
                    double i64_res_66235 = sitofp_i64_f64(last_res_66217);
                    double x_66236 = i64_res_65404 - i64_res_66235;
                    double max_arg_66237 = x_66236 / 2.0;
                    double max_res_66238 = fmax64(0.0, max_arg_66237);
                    
                    for (int64_t i_66905 = 0; i_66905 < q_65380; i_66905++) {
                        bool cond_66241 = sle64(last_res_66217, i_66905);
                        double defunc_0_f_res_66242;
                        
                        if (cond_66241) {
                            defunc_0_f_res_66242 = 0.0;
                        } else {
                            defunc_0_f_res_66242 = 1.0;
                        }
                        ((double *) mem_67839)[i_66905] = defunc_0_f_res_66242;
                    }
                    for (int64_t i_66924 = 0; i_66924 < n_m_65386; i_66924++) {
                        int64_t min_arg_66246 = mul64(jump_65382, i_66924);
                        int64_t min_res_66247 = smin64(i_65392, min_arg_66246);
                        int64_t defunc_0_g_res_66248 = add64((int64_t) 1,
                                                             min_res_66247);
                        bool init_idx_66249;
                        int64_t init_idx_66250;
                        int64_t init_idx_66251;
                        bool loop_while_66252;
                        int64_t low_66253;
                        int64_t high_66254;
                        
                        loop_while_66252 = x_65393;
                        low_66253 = (int64_t) 0;
                        high_66254 = i_65392;
                        while (loop_while_66252) {
                            int64_t x_66255 = add64(low_66253, high_66254);
                            int64_t mid_66256 = sdiv64(x_66255, (int64_t) 2);
                            bool x_66257 = sle64((int64_t) 0, mid_66256);
                            bool y_66258 = slt64(mid_66256, n_65378);
                            bool bounds_check_66259 = x_66257 && y_66258;
                            bool index_certs_66260;
                            
                            if (!bounds_check_66259) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [", (long long) mid_66256,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65378, "].",
                                              "-> #0  loess.fut:450:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                                if (memblock_unref(ctx, &mem_67756,
                                                   "mem_67756") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67752,
                                                   "mem_67752") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68165,
                                                   "ext_mem_68165") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68173,
                                                   "ext_mem_68173") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68181,
                                                   "ext_mem_68181") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68189,
                                                   "ext_mem_68189") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68197,
                                                   "ext_mem_68197") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68205,
                                                   "ext_mem_68205") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68330,
                                                   "mem_out_68330") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t mid_id_66261;
                            
                            mid_id_66261 = ((int64_t *) mem_67824)[mid_66256];
                            
                            bool cond_66262 = slt64(mid_id_66261, (int64_t) 0);
                            int64_t mid_idx_66263;
                            
                            if (cond_66262) {
                                mid_idx_66263 = (int64_t) 9223372036854775807;
                            } else {
                                mid_idx_66263 = mid_id_66261;
                            }
                            
                            bool cond_66264 = sle64(defunc_0_g_res_66248,
                                                    mid_idx_66263);
                            int64_t loopres_66265;
                            int64_t loopres_66266;
                            
                            if (cond_66264) {
                                int64_t loopres_t_res_66267 = sub64(mid_66256,
                                                                    (int64_t) 1);
                                
                                loopres_66265 = low_66253;
                                loopres_66266 = loopres_t_res_66267;
                            } else {
                                int64_t loopres_f_res_66268 = add64((int64_t) 1,
                                                                    mid_66256);
                                
                                loopres_66265 = loopres_f_res_66268;
                                loopres_66266 = high_66254;
                            }
                            
                            bool loop_cond_66269 = sle64(loopres_66265,
                                                         loopres_66266);
                            bool loop_while_tmp_68436 = loop_cond_66269;
                            int64_t low_tmp_68437 = loopres_66265;
                            int64_t high_tmp_68438 = loopres_66266;
                            
                            loop_while_66252 = loop_while_tmp_68436;
                            low_66253 = low_tmp_68437;
                            high_66254 = high_tmp_68438;
                        }
                        init_idx_66249 = loop_while_66252;
                        init_idx_66250 = low_66253;
                        init_idx_66251 = high_66254;
                        
                        bool idx_66270;
                        int64_t idx_66271;
                        int64_t idx_66272;
                        int64_t idx_66273;
                        bool loop_while_66274;
                        int64_t l_idx_66275;
                        int64_t r_idx_66276;
                        int64_t span_66277;
                        
                        loop_while_66274 = loop_cond_65403;
                        l_idx_66275 = init_idx_66250;
                        r_idx_66276 = init_idx_66250;
                        span_66277 = (int64_t) 1;
                        while (loop_while_66274) {
                            int64_t max_arg_66278 = sub64(l_idx_66275,
                                                          (int64_t) 1);
                            int64_t max_res_66279 = smax64((int64_t) 0,
                                                           max_arg_66278);
                            int64_t min_arg_66280 = add64((int64_t) 1,
                                                          r_idx_66276);
                            int64_t min_res_66281 = smin64(min_arg_66232,
                                                           min_arg_66280);
                            bool x_66282 = sle64((int64_t) 0, max_res_66279);
                            bool y_66283 = slt64(max_res_66279, n_65378);
                            bool bounds_check_66284 = x_66282 && y_66283;
                            bool index_certs_66285;
                            
                            if (!bounds_check_66284) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) max_res_66279,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65378, "].",
                                              "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                                if (memblock_unref(ctx, &mem_67756,
                                                   "mem_67756") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67752,
                                                   "mem_67752") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68165,
                                                   "ext_mem_68165") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68173,
                                                   "ext_mem_68173") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68181,
                                                   "ext_mem_68181") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68189,
                                                   "ext_mem_68189") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68197,
                                                   "ext_mem_68197") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68205,
                                                   "ext_mem_68205") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68330,
                                                   "mem_out_68330") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_66286;
                            
                            x_66286 = ((int64_t *) mem_67824)[max_res_66279];
                            
                            int64_t abs_arg_66287 = sub64(x_66286,
                                                          defunc_0_g_res_66248);
                            int64_t abs_res_66288 = abs64(abs_arg_66287);
                            bool x_66289 = sle64((int64_t) 0, min_res_66281);
                            bool y_66290 = slt64(min_res_66281, n_65378);
                            bool bounds_check_66291 = x_66289 && y_66290;
                            bool index_certs_66292;
                            
                            if (!bounds_check_66291) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) min_res_66281,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65378, "].",
                                              "-> #0  loess.fut:461:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                                if (memblock_unref(ctx, &mem_67756,
                                                   "mem_67756") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67752,
                                                   "mem_67752") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68165,
                                                   "ext_mem_68165") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68173,
                                                   "ext_mem_68173") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68181,
                                                   "ext_mem_68181") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68189,
                                                   "ext_mem_68189") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68197,
                                                   "ext_mem_68197") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68205,
                                                   "ext_mem_68205") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68330,
                                                   "mem_out_68330") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_66293;
                            
                            x_66293 = ((int64_t *) mem_67824)[min_res_66281];
                            
                            int64_t abs_arg_66294 = sub64(x_66293,
                                                          defunc_0_g_res_66248);
                            int64_t abs_res_66295 = abs64(abs_arg_66294);
                            bool cond_66296 = max_res_66279 == l_idx_66275;
                            int64_t loopres_66297;
                            int64_t loopres_66298;
                            int64_t loopres_66299;
                            
                            if (cond_66296) {
                                loopres_66297 = l_idx_66275;
                                loopres_66298 = r_idx_66276;
                                loopres_66299 = min_res_65398;
                            } else {
                                bool cond_66300 = slt64(abs_res_66288,
                                                        abs_res_66295);
                                bool cond_f_res_66301 = min_res_66281 ==
                                     r_idx_66276;
                                bool x_66302 = !cond_66300;
                                bool y_66303 = cond_f_res_66301 && x_66302;
                                bool cond_66304 = cond_66300 || y_66303;
                                int64_t loopres_f_res_66305;
                                
                                if (cond_66304) {
                                    loopres_f_res_66305 = max_res_66279;
                                } else {
                                    loopres_f_res_66305 = l_idx_66275;
                                }
                                
                                int64_t loopres_f_res_66306;
                                
                                if (cond_66304) {
                                    loopres_f_res_66306 = r_idx_66276;
                                } else {
                                    loopres_f_res_66306 = min_res_66281;
                                }
                                
                                int64_t loopres_f_res_66307;
                                
                                if (cond_66304) {
                                    int64_t loopres_f_res_t_res_66308 =
                                            add64((int64_t) 1, span_66277);
                                    
                                    loopres_f_res_66307 =
                                        loopres_f_res_t_res_66308;
                                } else {
                                    int64_t loopres_f_res_f_res_66309 =
                                            add64((int64_t) 1, span_66277);
                                    
                                    loopres_f_res_66307 =
                                        loopres_f_res_f_res_66309;
                                }
                                loopres_66297 = loopres_f_res_66305;
                                loopres_66298 = loopres_f_res_66306;
                                loopres_66299 = loopres_f_res_66307;
                            }
                            
                            bool loop_cond_66310 = slt64(loopres_66299,
                                                         min_res_65398);
                            bool loop_while_tmp_68439 = loop_cond_66310;
                            int64_t l_idx_tmp_68440 = loopres_66297;
                            int64_t r_idx_tmp_68441 = loopres_66298;
                            int64_t span_tmp_68442 = loopres_66299;
                            
                            loop_while_66274 = loop_while_tmp_68439;
                            l_idx_66275 = l_idx_tmp_68440;
                            r_idx_66276 = r_idx_tmp_68441;
                            span_66277 = span_tmp_68442;
                        }
                        idx_66270 = loop_while_66274;
                        idx_66271 = l_idx_66275;
                        idx_66272 = r_idx_66276;
                        idx_66273 = span_66277;
                        
                        int64_t min_res_66311 = smin64(min_arg_66233,
                                                       idx_66271);
                        int64_t max_res_66312 = smax64((int64_t) 0,
                                                       min_res_66311);
                        int64_t x_66313 = add64(min_res_66234, max_res_66312);
                        int64_t r_66314 = sub64(x_66313, (int64_t) 1);
                        bool x_66315 = sle64((int64_t) 0, r_66314);
                        bool y_66316 = slt64(r_66314, n_65378);
                        bool bounds_check_66317 = x_66315 && y_66316;
                        bool index_certs_66318;
                        
                        if (!bounds_check_66317) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) r_66314,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:485:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67756, "mem_67756") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67752, "mem_67752") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68165,
                                               "ext_mem_68165") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68173,
                                               "ext_mem_68173") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68181,
                                               "ext_mem_68181") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68189,
                                               "ext_mem_68189") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_66319;
                        
                        x_66319 = ((int64_t *) mem_67797)[r_66314];
                        
                        int64_t abs_arg_66320 = sub64(x_66319, min_res_66247);
                        int64_t abs_res_66321 = abs64(abs_arg_66320);
                        bool x_66322 = sle64((int64_t) 0, max_res_66312);
                        bool y_66323 = slt64(max_res_66312, n_65378);
                        bool bounds_check_66324 = x_66322 && y_66323;
                        bool index_certs_66325;
                        
                        if (!bounds_check_66324) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) max_res_66312,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67756, "mem_67756") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67752, "mem_67752") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68165,
                                               "ext_mem_68165") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68173,
                                               "ext_mem_68173") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68181,
                                               "ext_mem_68181") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68189,
                                               "ext_mem_68189") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_66326;
                        
                        x_66326 = ((int64_t *) mem_67797)[max_res_66312];
                        
                        int64_t abs_arg_66327 = sub64(x_66326, min_res_66247);
                        int64_t abs_res_66328 = abs64(abs_arg_66327);
                        int64_t max_res_66329 = smax64(abs_res_66321,
                                                       abs_res_66328);
                        double defunc_0_f_res_66330 =
                               sitofp_i64_f64(max_res_66329);
                        double defunc_1_f_res_66331 = max_res_66238 +
                               defunc_0_f_res_66330;
                        double defunc_2_reduce_res_66353;
                        double defunc_2_reduce_res_66354;
                        double defunc_2_reduce_res_66355;
                        double redout_66909;
                        double redout_66910;
                        double redout_66911;
                        
                        redout_66909 = 0.0;
                        redout_66910 = 0.0;
                        redout_66911 = 0.0;
                        for (int64_t i_66914 = 0; i_66914 < q_65380;
                             i_66914++) {
                            double x_66368;
                            
                            x_66368 = ((double *) mem_67839)[i_66914];
                            
                            bool cond_66369 = sle64(last_res_66217, i_66914);
                            int64_t defunc_0_f_res_66370;
                            
                            if (cond_66369) {
                                defunc_0_f_res_66370 = (int64_t) 0;
                            } else {
                                int64_t i_66371 = add64(max_res_66312, i_66914);
                                int64_t defunc_0_add_arg_66372;
                                
                                defunc_0_add_arg_66372 =
                                    ((int64_t *) mem_67797)[i_66371];
                                
                                int64_t defunc_1_add_res_66373 =
                                        add64((int64_t) 1,
                                              defunc_0_add_arg_66372);
                                
                                defunc_0_f_res_66370 = defunc_1_add_res_66373;
                            }
                            
                            int64_t binop_p_66374 = sub64(defunc_0_f_res_66370,
                                                          min_res_66247);
                            double defunc_0_f_res_66375 =
                                   sitofp_i64_f64(binop_p_66374);
                            double abs_res_66376 = fabs(defunc_0_f_res_66375);
                            double tmp1_66377 = abs_res_66376 /
                                   defunc_1_f_res_66331;
                            double x_66378 = tmp1_66377 * tmp1_66377;
                            double y_66379 = tmp1_66377 * x_66378;
                            double tmp2_66380 = 1.0 - y_66379;
                            double x_66381 = tmp2_66380 * tmp2_66380;
                            double tmp3_66382 = tmp2_66380 * x_66381;
                            double tmp4_66383 = x_66368 * tmp3_66382;
                            double defunc_1_f_res_66384 = defunc_0_f_res_66375 *
                                   tmp4_66383;
                            double defunc_1_f_res_66385 = defunc_0_f_res_66375 *
                                   defunc_1_f_res_66384;
                            double defunc_1_op_res_66360 = tmp4_66383 +
                                   redout_66909;
                            double defunc_1_op_res_66363 =
                                   defunc_1_f_res_66384 + redout_66910;
                            double defunc_1_op_res_66366 =
                                   defunc_1_f_res_66385 + redout_66911;
                            
                            ((double *) mem_67876)[i_66914] =
                                defunc_1_f_res_66384;
                            ((double *) mem_67879)[i_66914] = tmp4_66383;
                            
                            double redout_tmp_68443 = defunc_1_op_res_66360;
                            double redout_tmp_68444 = defunc_1_op_res_66363;
                            double redout_tmp_68445 = defunc_1_op_res_66366;
                            
                            redout_66909 = redout_tmp_68443;
                            redout_66910 = redout_tmp_68444;
                            redout_66911 = redout_tmp_68445;
                        }
                        defunc_2_reduce_res_66353 = redout_66909;
                        defunc_2_reduce_res_66354 = redout_66910;
                        defunc_2_reduce_res_66355 = redout_66911;
                        
                        double x_66391 = defunc_2_reduce_res_66353 *
                               defunc_2_reduce_res_66355;
                        double y_66392 = defunc_2_reduce_res_66354 *
                               defunc_2_reduce_res_66354;
                        double y_66393 = x_66391 - y_66392;
                        double det1_66394 = 1.0 / y_66393;
                        double a11_66395 = defunc_2_reduce_res_66355 *
                               det1_66394;
                        double x_66396 = 0.0 - defunc_2_reduce_res_66354;
                        double b11_66397 = det1_66394 * x_66396;
                        double c11_66398 = defunc_2_reduce_res_66353 *
                               det1_66394;
                        double defunc_2_reduce_res_66399;
                        double defunc_2_reduce_res_66400;
                        double redout_66917;
                        double redout_66918;
                        
                        redout_66917 = 0.0;
                        redout_66918 = 0.0;
                        for (int64_t i_66919 = 0; i_66919 < q_65380;
                             i_66919++) {
                            double x_66408;
                            
                            x_66408 = ((double *) mem_67879)[i_66919];
                            
                            double x_66409;
                            
                            x_66409 = ((double *) mem_67876)[i_66919];
                            
                            bool cond_66410 = sle64(last_res_66217, i_66919);
                            double defunc_0_f_res_66411;
                            
                            if (cond_66410) {
                                defunc_0_f_res_66411 = 0.0;
                            } else {
                                int64_t i_66412 = add64(max_res_66312, i_66919);
                                double defunc_0_add_arg_66413;
                                
                                defunc_0_add_arg_66413 =
                                    ((double *) mem_67794)[i_66412];
                                defunc_0_f_res_66411 = defunc_0_add_arg_66413;
                            }
                            
                            double x_66414 = a11_66395 * x_66408;
                            double y_66415 = b11_66397 * x_66409;
                            double x_66416 = x_66414 + y_66415;
                            double defunc_9_fit_fun_res_66417 =
                                   defunc_0_f_res_66411 * x_66416;
                            double x_66418 = b11_66397 * x_66408;
                            double y_66419 = c11_66398 * x_66409;
                            double x_66420 = x_66418 + y_66419;
                            double defunc_9_slope_fun_res_66421 =
                                   defunc_0_f_res_66411 * x_66420;
                            double defunc_1_op_res_66403 =
                                   defunc_9_fit_fun_res_66417 + redout_66917;
                            double defunc_1_op_res_66406 =
                                   defunc_9_slope_fun_res_66421 + redout_66918;
                            double redout_tmp_68448 = defunc_1_op_res_66403;
                            double redout_tmp_68449 = defunc_1_op_res_66406;
                            
                            redout_66917 = redout_tmp_68448;
                            redout_66918 = redout_tmp_68449;
                        }
                        defunc_2_reduce_res_66399 = redout_66917;
                        defunc_2_reduce_res_66400 = redout_66918;
                        ((double *) mem_67752.mem)[i_66931 * n_m_65386 +
                                                   i_66924] =
                            defunc_2_reduce_res_66399;
                        ((double *) mem_67756.mem)[i_66931 * n_m_65386 +
                                                   i_66924] =
                            defunc_2_reduce_res_66400;
                    }
                }
                if (memblock_set(ctx, &ext_mem_68173, &mem_67752,
                                 "mem_67752") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_68165, &mem_67756,
                                 "mem_67756") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67756, "mem_67756") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67752, "mem_67752") != 0)
                    return 1;
            } else {
                struct memblock mem_67945;
                
                mem_67945.references = NULL;
                if (memblock_alloc(ctx, &mem_67945, bytes_67944, "mem_67945")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock mem_67949;
                
                mem_67949.references = NULL;
                if (memblock_alloc(ctx, &mem_67949, bytes_67944, "mem_67949")) {
                    err = 1;
                    goto cleanup;
                }
                if (mem_67972_cached_sizze_68511 < (size_t) bytes_67971) {
                    mem_67972 = realloc(mem_67972, bytes_67971);
                    mem_67972_cached_sizze_68511 = bytes_67971;
                }
                if (mem_67987_cached_sizze_68512 < (size_t) bytes_67971) {
                    mem_67987 = realloc(mem_67987, bytes_67971);
                    mem_67987_cached_sizze_68512 = bytes_67971;
                }
                if (mem_67990_cached_sizze_68513 < (size_t) bytes_67971) {
                    mem_67990 = realloc(mem_67990, bytes_67971);
                    mem_67990_cached_sizze_68513 = bytes_67971;
                }
                if (mem_68017_cached_sizze_68514 < (size_t) bytes_67971) {
                    mem_68017 = realloc(mem_68017, bytes_67971);
                    mem_68017_cached_sizze_68514 = bytes_67971;
                }
                if (mem_68032_cached_sizze_68515 < (size_t) bytes_68031) {
                    mem_68032 = realloc(mem_68032, bytes_68031);
                    mem_68032_cached_sizze_68515 = bytes_68031;
                }
                if (mem_68069_cached_sizze_68516 < (size_t) bytes_68031) {
                    mem_68069 = realloc(mem_68069, bytes_68031);
                    mem_68069_cached_sizze_68516 = bytes_68031;
                }
                if (mem_68072_cached_sizze_68517 < (size_t) bytes_68031) {
                    mem_68072 = realloc(mem_68072, bytes_68031);
                    mem_68072_cached_sizze_68517 = bytes_68031;
                }
                if (mem_68099_cached_sizze_68518 < (size_t) bytes_68031) {
                    mem_68099 = realloc(mem_68099, bytes_68031);
                    mem_68099_cached_sizze_68518 = bytes_68031;
                }
                if (mem_68102_cached_sizze_68519 < (size_t) bytes_68031) {
                    mem_68102 = realloc(mem_68102, bytes_68031);
                    mem_68102_cached_sizze_68519 = bytes_68031;
                }
                for (int64_t i_66989 = 0; i_66989 < m_65377; i_66989++) {
                    int64_t discard_66939;
                    int64_t scanacc_66935 = (int64_t) 0;
                    
                    for (int64_t i_66937 = 0; i_66937 < n_65378; i_66937++) {
                        double x_66432;
                        
                        x_66432 = ((double *) Y_mem_67129.mem)[i_66989 *
                                                               n_65378 +
                                                               i_66937];
                        
                        bool isnan_res_66433;
                        
                        isnan_res_66433 = futrts_isnan64(x_66432);
                        
                        bool defunc_0_p_res_66434 = !isnan_res_66433;
                        int64_t defunc_0_f_res_66435 =
                                btoi_bool_i64(defunc_0_p_res_66434);
                        int64_t defunc_1_op_res_66431 =
                                add64(defunc_0_f_res_66435, scanacc_66935);
                        
                        ((int64_t *) mem_67972)[i_66937] =
                            defunc_1_op_res_66431;
                        
                        int64_t scanacc_tmp_68452 = defunc_1_op_res_66431;
                        
                        scanacc_66935 = scanacc_tmp_68452;
                    }
                    discard_66939 = scanacc_66935;
                    
                    int64_t last_res_66436;
                    
                    last_res_66436 = ((int64_t *) mem_67972)[i_65392];
                    for (int64_t i_68454 = 0; i_68454 < n_65378; i_68454++) {
                        ((double *) mem_67987)[i_68454] = 0.0;
                    }
                    for (int64_t i_68455 = 0; i_68455 < n_65378; i_68455++) {
                        ((int64_t *) mem_67990)[i_68455] = (int64_t) -1;
                    }
                    for (int64_t write_iter_66940 = 0; write_iter_66940 <
                         n_65378; write_iter_66940++) {
                        double write_iv_66943;
                        
                        write_iv_66943 = ((double *) Y_mem_67129.mem)[i_66989 *
                                                                      n_65378 +
                                                                      write_iter_66940];
                        
                        int64_t write_iv_66944;
                        
                        write_iv_66944 =
                            ((int64_t *) mem_67972)[write_iter_66940];
                        
                        bool isnan_res_66444;
                        
                        isnan_res_66444 = futrts_isnan64(write_iv_66943);
                        
                        bool defunc_0_p_res_66445 = !isnan_res_66444;
                        int64_t defunc_1_f_res_66446;
                        
                        if (defunc_0_p_res_66445) {
                            int64_t defunc_1_f_res_t_res_66447 =
                                    sub64(write_iv_66944, (int64_t) 1);
                            
                            defunc_1_f_res_66446 = defunc_1_f_res_t_res_66447;
                        } else {
                            defunc_1_f_res_66446 = (int64_t) -1;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_66446) &&
                            slt64(defunc_1_f_res_66446, n_65378)) {
                            ((int64_t *) mem_67990)[defunc_1_f_res_66446] =
                                write_iter_66940;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_66446) &&
                            slt64(defunc_1_f_res_66446, n_65378)) {
                            if ((int64_t) 8 > 0)
                                memmove(mem_67987 + defunc_1_f_res_66446 *
                                        (int64_t) 8, Y_mem_67129.mem +
                                        (i_66989 * n_65378 + write_iter_66940) *
                                        (int64_t) 8, (int64_t) 8);
                        }
                    }
                    for (int64_t i_66950 = 0; i_66950 < n_65378; i_66950++) {
                        int64_t x_66449;
                        
                        x_66449 = ((int64_t *) mem_67990)[i_66950];
                        
                        int64_t defunc_0_f_res_66450 = add64((int64_t) 1,
                                                             x_66449);
                        
                        ((int64_t *) mem_68017)[i_66950] = defunc_0_f_res_66450;
                    }
                    
                    int64_t min_arg_66451 = sub64(last_res_66436, (int64_t) 1);
                    int64_t min_arg_66452 = sub64(last_res_66436,
                                                  min_res_65398);
                    int64_t min_res_66453 = smin64(q_65380, last_res_66436);
                    double i64_res_66454 = sitofp_i64_f64(last_res_66436);
                    double x_66455 = i64_res_65404 - i64_res_66454;
                    double max_arg_66456 = x_66455 / 2.0;
                    double max_res_66457 = fmax64(0.0, max_arg_66456);
                    
                    for (int64_t i_66954 = 0; i_66954 < q_65380; i_66954++) {
                        bool cond_66460 = sle64(last_res_66436, i_66954);
                        double defunc_0_f_res_66461;
                        
                        if (cond_66460) {
                            defunc_0_f_res_66461 = 0.0;
                        } else {
                            defunc_0_f_res_66461 = 1.0;
                        }
                        ((double *) mem_68032)[i_66954] = defunc_0_f_res_66461;
                    }
                    for (int64_t i_66982 = 0; i_66982 < n_m_65386; i_66982++) {
                        int64_t min_arg_66465 = mul64(jump_65382, i_66982);
                        int64_t min_res_66466 = smin64(i_65392, min_arg_66465);
                        int64_t defunc_0_g_res_66467 = add64((int64_t) 1,
                                                             min_res_66466);
                        bool init_idx_66468;
                        int64_t init_idx_66469;
                        int64_t init_idx_66470;
                        bool loop_while_66471;
                        int64_t low_66472;
                        int64_t high_66473;
                        
                        loop_while_66471 = x_65393;
                        low_66472 = (int64_t) 0;
                        high_66473 = i_65392;
                        while (loop_while_66471) {
                            int64_t x_66474 = add64(low_66472, high_66473);
                            int64_t mid_66475 = sdiv64(x_66474, (int64_t) 2);
                            bool x_66476 = sle64((int64_t) 0, mid_66475);
                            bool y_66477 = slt64(mid_66475, n_65378);
                            bool bounds_check_66478 = x_66476 && y_66477;
                            bool index_certs_66479;
                            
                            if (!bounds_check_66478) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [", (long long) mid_66475,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65378, "].",
                                              "-> #0  loess.fut:450:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                                if (memblock_unref(ctx, &mem_67949,
                                                   "mem_67949") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67945,
                                                   "mem_67945") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68165,
                                                   "ext_mem_68165") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68173,
                                                   "ext_mem_68173") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68181,
                                                   "ext_mem_68181") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68189,
                                                   "ext_mem_68189") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68197,
                                                   "ext_mem_68197") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68205,
                                                   "ext_mem_68205") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68330,
                                                   "mem_out_68330") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t mid_id_66480;
                            
                            mid_id_66480 = ((int64_t *) mem_68017)[mid_66475];
                            
                            bool cond_66481 = slt64(mid_id_66480, (int64_t) 0);
                            int64_t mid_idx_66482;
                            
                            if (cond_66481) {
                                mid_idx_66482 = (int64_t) 9223372036854775807;
                            } else {
                                mid_idx_66482 = mid_id_66480;
                            }
                            
                            bool cond_66483 = sle64(defunc_0_g_res_66467,
                                                    mid_idx_66482);
                            int64_t loopres_66484;
                            int64_t loopres_66485;
                            
                            if (cond_66483) {
                                int64_t loopres_t_res_66486 = sub64(mid_66475,
                                                                    (int64_t) 1);
                                
                                loopres_66484 = low_66472;
                                loopres_66485 = loopres_t_res_66486;
                            } else {
                                int64_t loopres_f_res_66487 = add64((int64_t) 1,
                                                                    mid_66475);
                                
                                loopres_66484 = loopres_f_res_66487;
                                loopres_66485 = high_66473;
                            }
                            
                            bool loop_cond_66488 = sle64(loopres_66484,
                                                         loopres_66485);
                            bool loop_while_tmp_68462 = loop_cond_66488;
                            int64_t low_tmp_68463 = loopres_66484;
                            int64_t high_tmp_68464 = loopres_66485;
                            
                            loop_while_66471 = loop_while_tmp_68462;
                            low_66472 = low_tmp_68463;
                            high_66473 = high_tmp_68464;
                        }
                        init_idx_66468 = loop_while_66471;
                        init_idx_66469 = low_66472;
                        init_idx_66470 = high_66473;
                        
                        bool idx_66489;
                        int64_t idx_66490;
                        int64_t idx_66491;
                        int64_t idx_66492;
                        bool loop_while_66493;
                        int64_t l_idx_66494;
                        int64_t r_idx_66495;
                        int64_t span_66496;
                        
                        loop_while_66493 = loop_cond_65403;
                        l_idx_66494 = init_idx_66469;
                        r_idx_66495 = init_idx_66469;
                        span_66496 = (int64_t) 1;
                        while (loop_while_66493) {
                            int64_t max_arg_66497 = sub64(l_idx_66494,
                                                          (int64_t) 1);
                            int64_t max_res_66498 = smax64((int64_t) 0,
                                                           max_arg_66497);
                            int64_t min_arg_66499 = add64((int64_t) 1,
                                                          r_idx_66495);
                            int64_t min_res_66500 = smin64(min_arg_66451,
                                                           min_arg_66499);
                            bool x_66501 = sle64((int64_t) 0, max_res_66498);
                            bool y_66502 = slt64(max_res_66498, n_65378);
                            bool bounds_check_66503 = x_66501 && y_66502;
                            bool index_certs_66504;
                            
                            if (!bounds_check_66503) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) max_res_66498,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65378, "].",
                                              "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                                if (memblock_unref(ctx, &mem_67949,
                                                   "mem_67949") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67945,
                                                   "mem_67945") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68165,
                                                   "ext_mem_68165") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68173,
                                                   "ext_mem_68173") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68181,
                                                   "ext_mem_68181") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68189,
                                                   "ext_mem_68189") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68197,
                                                   "ext_mem_68197") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68205,
                                                   "ext_mem_68205") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68330,
                                                   "mem_out_68330") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_66505;
                            
                            x_66505 = ((int64_t *) mem_68017)[max_res_66498];
                            
                            int64_t abs_arg_66506 = sub64(x_66505,
                                                          defunc_0_g_res_66467);
                            int64_t abs_res_66507 = abs64(abs_arg_66506);
                            bool x_66508 = sle64((int64_t) 0, min_res_66500);
                            bool y_66509 = slt64(min_res_66500, n_65378);
                            bool bounds_check_66510 = x_66508 && y_66509;
                            bool index_certs_66511;
                            
                            if (!bounds_check_66510) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [",
                                              (long long) min_res_66500,
                                              "] out of bounds for array of shape [",
                                              (long long) n_65378, "].",
                                              "-> #0  loess.fut:461:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  loess.fut:590:13-56\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:589:5-591:26\n   #10 loess.fut:573:1-612:26\n");
                                if (memblock_unref(ctx, &mem_67949,
                                                   "mem_67949") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_67945,
                                                   "mem_67945") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68165,
                                                   "ext_mem_68165") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68173,
                                                   "ext_mem_68173") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68181,
                                                   "ext_mem_68181") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68189,
                                                   "ext_mem_68189") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68197,
                                                   "ext_mem_68197") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_68205,
                                                   "ext_mem_68205") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_68330,
                                                   "mem_out_68330") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t x_66512;
                            
                            x_66512 = ((int64_t *) mem_68017)[min_res_66500];
                            
                            int64_t abs_arg_66513 = sub64(x_66512,
                                                          defunc_0_g_res_66467);
                            int64_t abs_res_66514 = abs64(abs_arg_66513);
                            bool cond_66515 = max_res_66498 == l_idx_66494;
                            int64_t loopres_66516;
                            int64_t loopres_66517;
                            int64_t loopres_66518;
                            
                            if (cond_66515) {
                                loopres_66516 = l_idx_66494;
                                loopres_66517 = r_idx_66495;
                                loopres_66518 = min_res_65398;
                            } else {
                                bool cond_66519 = slt64(abs_res_66507,
                                                        abs_res_66514);
                                bool cond_f_res_66520 = min_res_66500 ==
                                     r_idx_66495;
                                bool x_66521 = !cond_66519;
                                bool y_66522 = cond_f_res_66520 && x_66521;
                                bool cond_66523 = cond_66519 || y_66522;
                                int64_t loopres_f_res_66524;
                                
                                if (cond_66523) {
                                    loopres_f_res_66524 = max_res_66498;
                                } else {
                                    loopres_f_res_66524 = l_idx_66494;
                                }
                                
                                int64_t loopres_f_res_66525;
                                
                                if (cond_66523) {
                                    loopres_f_res_66525 = r_idx_66495;
                                } else {
                                    loopres_f_res_66525 = min_res_66500;
                                }
                                
                                int64_t loopres_f_res_66526;
                                
                                if (cond_66523) {
                                    int64_t loopres_f_res_t_res_66527 =
                                            add64((int64_t) 1, span_66496);
                                    
                                    loopres_f_res_66526 =
                                        loopres_f_res_t_res_66527;
                                } else {
                                    int64_t loopres_f_res_f_res_66528 =
                                            add64((int64_t) 1, span_66496);
                                    
                                    loopres_f_res_66526 =
                                        loopres_f_res_f_res_66528;
                                }
                                loopres_66516 = loopres_f_res_66524;
                                loopres_66517 = loopres_f_res_66525;
                                loopres_66518 = loopres_f_res_66526;
                            }
                            
                            bool loop_cond_66529 = slt64(loopres_66518,
                                                         min_res_65398);
                            bool loop_while_tmp_68465 = loop_cond_66529;
                            int64_t l_idx_tmp_68466 = loopres_66516;
                            int64_t r_idx_tmp_68467 = loopres_66517;
                            int64_t span_tmp_68468 = loopres_66518;
                            
                            loop_while_66493 = loop_while_tmp_68465;
                            l_idx_66494 = l_idx_tmp_68466;
                            r_idx_66495 = r_idx_tmp_68467;
                            span_66496 = span_tmp_68468;
                        }
                        idx_66489 = loop_while_66493;
                        idx_66490 = l_idx_66494;
                        idx_66491 = r_idx_66495;
                        idx_66492 = span_66496;
                        
                        int64_t min_res_66530 = smin64(min_arg_66452,
                                                       idx_66490);
                        int64_t max_res_66531 = smax64((int64_t) 0,
                                                       min_res_66530);
                        int64_t x_66532 = add64(min_res_66453, max_res_66531);
                        int64_t r_66533 = sub64(x_66532, (int64_t) 1);
                        bool x_66534 = sle64((int64_t) 0, r_66533);
                        bool y_66535 = slt64(r_66533, n_65378);
                        bool bounds_check_66536 = x_66534 && y_66535;
                        bool index_certs_66537;
                        
                        if (!bounds_check_66536) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) r_66533,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:485:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67949, "mem_67949") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67945, "mem_67945") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68165,
                                               "ext_mem_68165") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68173,
                                               "ext_mem_68173") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68181,
                                               "ext_mem_68181") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68189,
                                               "ext_mem_68189") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_66538;
                        
                        x_66538 = ((int64_t *) mem_67990)[r_66533];
                        
                        int64_t abs_arg_66539 = sub64(x_66538, min_res_66466);
                        int64_t abs_res_66540 = abs64(abs_arg_66539);
                        bool x_66541 = sle64((int64_t) 0, max_res_66531);
                        bool y_66542 = slt64(max_res_66531, n_65378);
                        bool bounds_check_66543 = x_66541 && y_66542;
                        bool index_certs_66544;
                        
                        if (!bounds_check_66543) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) max_res_66531,
                                          "] out of bounds for array of shape [",
                                          (long long) n_65378, "].",
                                          "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  loess.fut:590:13-56\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:589:5-591:26\n   #9  loess.fut:573:1-612:26\n");
                            if (memblock_unref(ctx, &mem_67949, "mem_67949") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &mem_67945, "mem_67945") !=
                                0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68165,
                                               "ext_mem_68165") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68173,
                                               "ext_mem_68173") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68181,
                                               "ext_mem_68181") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68189,
                                               "ext_mem_68189") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68197,
                                               "ext_mem_68197") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_68205,
                                               "ext_mem_68205") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_68330,
                                               "mem_out_68330") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t x_66545;
                        
                        x_66545 = ((int64_t *) mem_67990)[max_res_66531];
                        
                        int64_t abs_arg_66546 = sub64(x_66545, min_res_66466);
                        int64_t abs_res_66547 = abs64(abs_arg_66546);
                        int64_t max_res_66548 = smax64(abs_res_66540,
                                                       abs_res_66547);
                        double defunc_0_f_res_66549 =
                               sitofp_i64_f64(max_res_66548);
                        double defunc_1_f_res_66550 = max_res_66457 +
                               defunc_0_f_res_66549;
                        
                        for (int64_t i_66960 = 0; i_66960 < q_65380;
                             i_66960++) {
                            double x_66554;
                            
                            x_66554 = ((double *) mem_68032)[i_66960];
                            
                            bool cond_66555 = sle64(last_res_66436, i_66960);
                            int64_t defunc_0_f_res_66556;
                            
                            if (cond_66555) {
                                defunc_0_f_res_66556 = (int64_t) 0;
                            } else {
                                int64_t i_66557 = add64(max_res_66531, i_66960);
                                int64_t defunc_0_add_arg_66558;
                                
                                defunc_0_add_arg_66558 =
                                    ((int64_t *) mem_67990)[i_66557];
                                
                                int64_t defunc_1_add_res_66559 =
                                        add64((int64_t) 1,
                                              defunc_0_add_arg_66558);
                                
                                defunc_0_f_res_66556 = defunc_1_add_res_66559;
                            }
                            
                            int64_t binop_p_66560 = sub64(defunc_0_f_res_66556,
                                                          min_res_66466);
                            double defunc_0_f_res_66561 =
                                   sitofp_i64_f64(binop_p_66560);
                            double abs_res_66562 = fabs(defunc_0_f_res_66561);
                            double tmp1_66563 = abs_res_66562 /
                                   defunc_1_f_res_66550;
                            double x_66564 = tmp1_66563 * tmp1_66563;
                            double y_66565 = tmp1_66563 * x_66564;
                            double tmp2_66566 = 1.0 - y_66565;
                            double x_66567 = tmp2_66566 * tmp2_66566;
                            double tmp3_66568 = tmp2_66566 * x_66567;
                            double tmp4_66569 = x_66554 * tmp3_66568;
                            
                            ((double *) mem_68069)[i_66960] =
                                defunc_0_f_res_66561;
                            ((double *) mem_68072)[i_66960] = tmp4_66569;
                        }
                        
                        double defunc_2_reduce_res_66576;
                        double defunc_2_reduce_res_66577;
                        double defunc_2_reduce_res_66578;
                        double defunc_2_reduce_res_66579;
                        double defunc_2_reduce_res_66580;
                        double redout_66965;
                        double redout_66966;
                        double redout_66967;
                        double redout_66968;
                        double redout_66969;
                        
                        redout_66965 = 0.0;
                        redout_66966 = 0.0;
                        redout_66967 = 0.0;
                        redout_66968 = 0.0;
                        redout_66969 = 0.0;
                        for (int64_t i_66972 = 0; i_66972 < q_65380;
                             i_66972++) {
                            double x_66598;
                            
                            x_66598 = ((double *) mem_68069)[i_66972];
                            
                            double x_66599;
                            
                            x_66599 = ((double *) mem_68072)[i_66972];
                            
                            double defunc_1_f_res_66600 = x_66598 * x_66599;
                            double defunc_1_f_res_66601 = x_66598 *
                                   defunc_1_f_res_66600;
                            double defunc_1_f_res_66602 = x_66598 *
                                   defunc_1_f_res_66601;
                            double defunc_1_f_res_66603 = x_66598 *
                                   defunc_1_f_res_66602;
                            double defunc_1_op_res_66585 = x_66599 +
                                   redout_66965;
                            double defunc_1_op_res_66588 =
                                   defunc_1_f_res_66600 + redout_66966;
                            double defunc_1_op_res_66591 =
                                   defunc_1_f_res_66601 + redout_66967;
                            double defunc_1_op_res_66594 =
                                   defunc_1_f_res_66602 + redout_66968;
                            double defunc_1_op_res_66597 =
                                   defunc_1_f_res_66603 + redout_66969;
                            
                            ((double *) mem_68099)[i_66972] =
                                defunc_1_f_res_66601;
                            ((double *) mem_68102)[i_66972] =
                                defunc_1_f_res_66600;
                            
                            double redout_tmp_68471 = defunc_1_op_res_66585;
                            double redout_tmp_68472 = defunc_1_op_res_66588;
                            double redout_tmp_68473 = defunc_1_op_res_66591;
                            double redout_tmp_68474 = defunc_1_op_res_66594;
                            double redout_tmp_68475 = defunc_1_op_res_66597;
                            
                            redout_66965 = redout_tmp_68471;
                            redout_66966 = redout_tmp_68472;
                            redout_66967 = redout_tmp_68473;
                            redout_66968 = redout_tmp_68474;
                            redout_66969 = redout_tmp_68475;
                        }
                        defunc_2_reduce_res_66576 = redout_66965;
                        defunc_2_reduce_res_66577 = redout_66966;
                        defunc_2_reduce_res_66578 = redout_66967;
                        defunc_2_reduce_res_66579 = redout_66968;
                        defunc_2_reduce_res_66580 = redout_66969;
                        
                        double x_66611 = defunc_2_reduce_res_66578 *
                               defunc_2_reduce_res_66580;
                        double y_66612 = defunc_2_reduce_res_66579 *
                               defunc_2_reduce_res_66579;
                        double a12_66613 = x_66611 - y_66612;
                        double x_66614 = defunc_2_reduce_res_66578 *
                               defunc_2_reduce_res_66579;
                        double y_66615 = defunc_2_reduce_res_66577 *
                               defunc_2_reduce_res_66580;
                        double b12_66616 = x_66614 - y_66615;
                        double x_66617 = defunc_2_reduce_res_66577 *
                               defunc_2_reduce_res_66579;
                        double y_66618 = defunc_2_reduce_res_66578 *
                               defunc_2_reduce_res_66578;
                        double c12_66619 = x_66617 - y_66618;
                        double x_66620 = defunc_2_reduce_res_66576 *
                               defunc_2_reduce_res_66580;
                        double b2_66621 = x_66620 - y_66618;
                        double x_66622 = defunc_2_reduce_res_66577 *
                               defunc_2_reduce_res_66578;
                        double y_66623 = defunc_2_reduce_res_66576 *
                               defunc_2_reduce_res_66579;
                        double c2_66624 = x_66622 - y_66623;
                        double x_66625 = defunc_2_reduce_res_66576 * a12_66613;
                        double y_66626 = defunc_2_reduce_res_66577 * b12_66616;
                        double x_66627 = x_66625 + y_66626;
                        double y_66628 = defunc_2_reduce_res_66578 * c12_66619;
                        double y_66629 = x_66627 + y_66628;
                        double det_66630 = 1.0 / y_66629;
                        double a12_66631 = a12_66613 * det_66630;
                        double b12_66632 = b12_66616 * det_66630;
                        double c12_66633 = c12_66619 * det_66630;
                        double b2_66634 = b2_66621 * det_66630;
                        double c2_66635 = c2_66624 * det_66630;
                        double defunc_2_reduce_res_66636;
                        double defunc_2_reduce_res_66637;
                        double redout_66975;
                        double redout_66976;
                        
                        redout_66975 = 0.0;
                        redout_66976 = 0.0;
                        for (int64_t i_66977 = 0; i_66977 < q_65380;
                             i_66977++) {
                            double x_66645;
                            
                            x_66645 = ((double *) mem_68072)[i_66977];
                            
                            double x_66646;
                            
                            x_66646 = ((double *) mem_68102)[i_66977];
                            
                            double x_66647;
                            
                            x_66647 = ((double *) mem_68099)[i_66977];
                            
                            bool cond_66648 = sle64(last_res_66436, i_66977);
                            double defunc_0_f_res_66649;
                            
                            if (cond_66648) {
                                defunc_0_f_res_66649 = 0.0;
                            } else {
                                int64_t i_66650 = add64(max_res_66531, i_66977);
                                double defunc_0_add_arg_66651;
                                
                                defunc_0_add_arg_66651 =
                                    ((double *) mem_67987)[i_66650];
                                defunc_0_f_res_66649 = defunc_0_add_arg_66651;
                            }
                            
                            double x_66652 = a12_66631 * x_66645;
                            double y_66653 = b12_66632 * x_66646;
                            double x_66654 = x_66652 + y_66653;
                            double y_66655 = c12_66633 * x_66647;
                            double x_66656 = x_66654 + y_66655;
                            double defunc_9_fit_fun_res_66657 =
                                   defunc_0_f_res_66649 * x_66656;
                            double x_66658 = b12_66632 * x_66645;
                            double y_66659 = b2_66634 * x_66646;
                            double x_66660 = x_66658 + y_66659;
                            double y_66661 = c2_66635 * x_66647;
                            double x_66662 = x_66660 + y_66661;
                            double defunc_9_slope_fun_res_66663 =
                                   defunc_0_f_res_66649 * x_66662;
                            double defunc_1_op_res_66640 =
                                   defunc_9_fit_fun_res_66657 + redout_66975;
                            double defunc_1_op_res_66643 =
                                   defunc_9_slope_fun_res_66663 + redout_66976;
                            double redout_tmp_68478 = defunc_1_op_res_66640;
                            double redout_tmp_68479 = defunc_1_op_res_66643;
                            
                            redout_66975 = redout_tmp_68478;
                            redout_66976 = redout_tmp_68479;
                        }
                        defunc_2_reduce_res_66636 = redout_66975;
                        defunc_2_reduce_res_66637 = redout_66976;
                        ((double *) mem_67945.mem)[i_66989 * n_m_65386 +
                                                   i_66982] =
                            defunc_2_reduce_res_66636;
                        ((double *) mem_67949.mem)[i_66989 * n_m_65386 +
                                                   i_66982] =
                            defunc_2_reduce_res_66637;
                    }
                }
                if (memblock_set(ctx, &ext_mem_68173, &mem_67945,
                                 "mem_67945") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_68165, &mem_67949,
                                 "mem_67949") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67949, "mem_67949") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_67945, "mem_67945") != 0)
                    return 1;
            }
            if (memblock_set(ctx, &ext_mem_68189, &ext_mem_68173,
                             "ext_mem_68173") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_68181, &ext_mem_68165,
                             "ext_mem_68165") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_68165, "ext_mem_68165") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_68173, "ext_mem_68173") != 0)
                return 1;
        }
        if (memblock_set(ctx, &ext_mem_68205, &ext_mem_68189,
                         "ext_mem_68189") != 0)
            return 1;
        if (memblock_set(ctx, &ext_mem_68197, &ext_mem_68181,
                         "ext_mem_68181") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_68181, "ext_mem_68181") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_68189, "ext_mem_68189") != 0)
            return 1;
    }
    
    bool cond_66666 = slt64((int64_t) 1, jump_65382);
    int64_t binop_x_68213 = m_65377 * n_65378;
    int64_t binop_y_68214 = (int64_t) 8 * binop_x_68213;
    int64_t bytes_68215 = smax64((int64_t) 0, binop_y_68214);
    int64_t ext_68261;
    
    if (cond_66666) {
        ext_68261 = n_65378;
    } else {
        ext_68261 = n_m_65386;
    }
    
    int64_t ext_68260;
    
    if (cond_66666) {
        ext_68260 = n_65378;
    } else {
        ext_68260 = n_m_65386;
    }
    
    struct memblock ext_mem_68257;
    
    ext_mem_68257.references = NULL;
    if (cond_66666) {
        bool zzero_66668 = jump_65382 == (int64_t) 0;
        bool nonzzero_66669 = !zzero_66668;
        bool nonzzero_cert_66670;
        
        if (!nonzzero_66669) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  loess.fut:547:20-27\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:546:3-550:9\n   #5  loess.fut:609:13-59\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  loess.fut:608:5-610:29\n   #9  loess.fut:573:1-612:26\n");
            if (memblock_unref(ctx, &ext_mem_68257, "ext_mem_68257") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_68197, "ext_mem_68197") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_68205, "ext_mem_68205") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_68330, "mem_out_68330") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t y_66671 = sub64(n_m_65386, (int64_t) 1);
        struct memblock mem_68216;
        
        mem_68216.references = NULL;
        if (memblock_alloc(ctx, &mem_68216, bytes_68215, "mem_68216")) {
            err = 1;
            goto cleanup;
        }
        for (int64_t i_66998 = 0; i_66998 < m_65377; i_66998++) {
            for (int64_t i_66994 = 0; i_66994 < n_65378; i_66994++) {
                int64_t m_v_66677 = sdiv64(i_66994, jump_65382);
                bool cond_66678 = m_v_66677 == y_66671;
                int64_t j_66679;
                
                if (cond_66678) {
                    int64_t j_t_res_66680 = sub64(m_v_66677, (int64_t) 1);
                    
                    j_66679 = j_t_res_66680;
                } else {
                    j_66679 = m_v_66677;
                }
                
                int64_t min_arg_66681 = mul64(jump_65382, j_66679);
                int64_t min_res_66682 = smin64(i_65392, min_arg_66681);
                int64_t defunc_0_m_fun_arg_66683 = add64((int64_t) 1, j_66679);
                int64_t min_arg_66684 = mul64(jump_65382,
                                              defunc_0_m_fun_arg_66683);
                int64_t min_res_66685 = smin64(i_65392, min_arg_66684);
                int64_t i64_arg_66686 = sub64(min_res_66685, min_res_66682);
                double i64_res_66687 = sitofp_i64_f64(i64_arg_66686);
                int64_t i64_arg_66688 = sub64(i_66994, min_res_66682);
                double i64_res_66689 = sitofp_i64_f64(i64_arg_66688);
                double u_66690 = i64_res_66689 / i64_res_66687;
                double u2_66691 = u_66690 * u_66690;
                double u3_66692 = u_66690 * u2_66691;
                double x_66693 = 2.0 * u3_66692;
                double y_66694 = 3.0 * u2_66691;
                double x_66695 = x_66693 - y_66694;
                double x_66696 = 1.0 + x_66695;
                bool x_66697 = sle64((int64_t) 0, j_66679);
                bool y_66698 = slt64(j_66679, n_m_65386);
                bool bounds_check_66699 = x_66697 && y_66698;
                bool index_certs_66700;
                
                if (!bounds_check_66699) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) j_66679,
                                  "] out of bounds for array of shape [",
                                  (long long) n_m_65386, "].",
                                  "-> #0  loess.fut:536:27-33\n   #1  loess.fut:549:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:546:3-550:9\n   #6  loess.fut:609:13-59\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:608:5-610:29\n   #10 loess.fut:573:1-612:26\n");
                    if (memblock_unref(ctx, &mem_68216, "mem_68216") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_68257, "ext_mem_68257") !=
                        0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_68197, "ext_mem_68197") !=
                        0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_68205, "ext_mem_68205") !=
                        0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_68330, "mem_out_68330") !=
                        0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                double y_66701;
                
                y_66701 = ((double *) ext_mem_68205.mem)[i_66998 * n_m_65386 +
                                                         j_66679];
                
                double x_66702 = x_66696 * y_66701;
                double x_66703 = y_66694 - x_66693;
                bool x_66704 = sle64((int64_t) 0, defunc_0_m_fun_arg_66683);
                bool y_66705 = slt64(defunc_0_m_fun_arg_66683, n_m_65386);
                bool bounds_check_66706 = x_66704 && y_66705;
                bool index_certs_66707;
                
                if (!bounds_check_66706) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [",
                                  (long long) defunc_0_m_fun_arg_66683,
                                  "] out of bounds for array of shape [",
                                  (long long) n_m_65386, "].",
                                  "-> #0  loess.fut:537:27-37\n   #1  loess.fut:549:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:546:3-550:9\n   #6  loess.fut:609:13-59\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  loess.fut:608:5-610:29\n   #10 loess.fut:573:1-612:26\n");
                    if (memblock_unref(ctx, &mem_68216, "mem_68216") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_68257, "ext_mem_68257") !=
                        0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_68197, "ext_mem_68197") !=
                        0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_68205, "ext_mem_68205") !=
                        0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_68330, "mem_out_68330") !=
                        0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                double y_66708;
                
                y_66708 = ((double *) ext_mem_68205.mem)[i_66998 * n_m_65386 +
                                                         defunc_0_m_fun_arg_66683];
                
                double y_66709 = x_66703 * y_66708;
                double x_66710 = x_66702 + y_66709;
                double y_66711 = 2.0 * u2_66691;
                double x_66712 = u3_66692 - y_66711;
                double x_66713 = u_66690 + x_66712;
                double y_66714;
                
                y_66714 = ((double *) ext_mem_68197.mem)[i_66998 * n_m_65386 +
                                                         j_66679];
                
                double x_66715 = x_66713 * y_66714;
                double y_66716 = i64_res_66687 * x_66715;
                double x_66717 = x_66710 + y_66716;
                double x_66718 = u3_66692 - u2_66691;
                double y_66719;
                
                y_66719 = ((double *) ext_mem_68197.mem)[i_66998 * n_m_65386 +
                                                         defunc_0_m_fun_arg_66683];
                
                double x_66720 = x_66718 * y_66719;
                double y_66721 = i64_res_66687 * x_66720;
                double defunc_4_interpolate_proc_res_66722 = x_66717 + y_66721;
                
                ((double *) mem_68216.mem)[i_66998 * n_65378 + i_66994] =
                    defunc_4_interpolate_proc_res_66722;
            }
        }
        if (memblock_set(ctx, &ext_mem_68257, &mem_68216, "mem_68216") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_68216, "mem_68216") != 0)
            return 1;
    } else {
        bool dim_match_66723 = n_65378 == n_m_65386;
        bool empty_or_match_cert_66724;
        
        if (!dim_match_66723) {
            ctx->error =
                msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                          "Value of (core language) shape (",
                          (long long) m_65377, ", ", (long long) n_m_65386,
                          ") cannot match shape of type `[",
                          (long long) m_65377, "][", (long long) n_65378,
                          "]f64`.",
                          "-> #0  loess.fut:612:5-26\n   #1  loess.fut:573:1-612:26\n");
            if (memblock_unref(ctx, &ext_mem_68257, "ext_mem_68257") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_68197, "ext_mem_68197") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_68205, "ext_mem_68205") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_68330, "mem_out_68330") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        if (memblock_set(ctx, &ext_mem_68257, &ext_mem_68205,
                         "ext_mem_68205") != 0)
            return 1;
    }
    if (memblock_unref(ctx, &ext_mem_68197, "ext_mem_68197") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_68205, "ext_mem_68205") != 0)
        return 1;
    
    int64_t binop_x_68265 = m_65377 * n_65378;
    int64_t binop_y_68266 = (int64_t) 8 * binop_x_68265;
    int64_t bytes_68267 = smax64((int64_t) 0, binop_y_68266);
    struct memblock mem_68268;
    
    mem_68268.references = NULL;
    if (memblock_alloc(ctx, &mem_68268, bytes_68267, "mem_68268")) {
        err = 1;
        goto cleanup;
    }
    if (m_65377 * n_65378 * (int64_t) 8 > 0)
        memmove(mem_68268.mem + (int64_t) 0, ext_mem_68257.mem + (int64_t) 0,
                m_65377 * n_65378 * (int64_t) 8);
    if (memblock_unref(ctx, &ext_mem_68257, "ext_mem_68257") != 0)
        return 1;
    if (memblock_set(ctx, &mem_out_68330, &mem_68268, "mem_68268") != 0)
        return 1;
    (*mem_out_p_68482).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_68482, &mem_out_68330, "mem_out_68330") !=
        0)
        return 1;
    if (memblock_unref(ctx, &mem_68268, "mem_68268") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_68257, "ext_mem_68257") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_68197, "ext_mem_68197") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_68205, "ext_mem_68205") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_68330, "mem_out_68330") != 0)
        return 1;
    
  cleanup:
    { }
    free(mem_67150);
    free(mem_67165);
    free(mem_67168);
    free(mem_67195);
    free(mem_67210);
    free(mem_67283);
    free(mem_67298);
    free(mem_67301);
    free(mem_67328);
    free(mem_67343);
    free(mem_67446);
    free(mem_67461);
    free(mem_67464);
    free(mem_67491);
    free(mem_67506);
    free(mem_67631);
    free(mem_67646);
    free(mem_67649);
    free(mem_67676);
    free(mem_67691);
    free(mem_67717);
    free(mem_67779);
    free(mem_67794);
    free(mem_67797);
    free(mem_67824);
    free(mem_67839);
    free(mem_67876);
    free(mem_67879);
    free(mem_67972);
    free(mem_67987);
    free(mem_67990);
    free(mem_68017);
    free(mem_68032);
    free(mem_68069);
    free(mem_68072);
    free(mem_68099);
    free(mem_68102);
    return err;
}

int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f64_2d **out0, const
                       struct futhark_f64_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5)
{
    struct memblock Y_mem_67129;
    
    Y_mem_67129.references = NULL;
    
    int64_t m_65377;
    int64_t n_65378;
    int64_t q_65380;
    int64_t degree_65381;
    int64_t jump_65382;
    int64_t jump_threshold_65383;
    int64_t q_threshold_65384;
    struct memblock mem_out_68330;
    
    mem_out_68330.references = NULL;
    
    int ret = 0;
    
    lock_lock(&ctx->lock);
    Y_mem_67129 = in0->mem;
    m_65377 = in0->shape[0];
    n_65378 = in0->shape[1];
    q_65380 = in1;
    degree_65381 = in2;
    jump_65382 = in3;
    jump_threshold_65383 = in4;
    q_threshold_65384 = in5;
    if (!(m_65377 == in0->shape[0] && n_65378 == in0->shape[1])) {
        ret = 1;
        if (!ctx->error)
            ctx->error =
                msgprintf("Error: entry point arguments have invalid sizes.\n");
    }
    if (ret == 0) {
        ret = futrts_entry_main(ctx, &mem_out_68330, Y_mem_67129, m_65377,
                                n_65378, q_65380, degree_65381, jump_65382,
                                jump_threshold_65383, q_threshold_65384);
        if (ret == 0) {
            assert((*out0 =
                    (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d))) !=
                NULL);
            (*out0)->mem = mem_out_68330;
            (*out0)->shape[0] = m_65377;
            (*out0)->shape[1] = n_65378;
        }
    }
    lock_unlock(&ctx->lock);
    return ret;
}
  
