// Generated by Futhark 0.21.5
// git: e1c63b2 (Tue Feb 1 22:06:34 2022 +0100)

// We need to define _GNU_SOURCE before
// _any_ headers files are imported to get
// the usage statistics of a thread (i.e. have RUSAGE_THREAD) on GNU/Linux
// https://manpages.courier-mta.org/htmlman2/getrusage.2.html
#ifndef _GNU_SOURCE // Avoid possible double-definition warning.
#define _GNU_SOURCE
#endif

#ifdef __clang__
#pragma clang diagnostic ignored "-Wunused-function"
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wparentheses"
#pragma clang diagnostic ignored "-Wunused-label"
#elif __GNUC__
#pragma GCC diagnostic ignored "-Wunused-function"
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wparentheses"
#pragma GCC diagnostic ignored "-Wunused-label"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif

// Headers\n")
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdio.h>
#include <float.h>

#include <cuda.h>
#include <cuda_runtime.h>
#include <nvrtc.h>

#ifdef __cplusplus
extern "C" {
#endif

// Initialisation
struct futhark_context_config;
struct futhark_context_config *futhark_context_config_new(void);
void futhark_context_config_free(struct futhark_context_config *cfg);
void futhark_context_config_add_nvrtc_option(struct futhark_context_config *cfg,
                                             const char *opt);
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int flag);
void futhark_context_config_set_device(struct futhark_context_config *cfg, const
                                       char *s);
void futhark_context_config_dump_program_to(struct futhark_context_config *cfg,
                                            const char *path);
void
futhark_context_config_load_program_from(struct futhark_context_config *cfg,
                                         const char *path);
void futhark_context_config_dump_ptx_to(struct futhark_context_config *cfg,
                                        const char *path);
void futhark_context_config_load_ptx_from(struct futhark_context_config *cfg,
                                          const char *path);
void
futhark_context_config_set_default_group_size(struct futhark_context_config *cfg,
                                              int size);
void
futhark_context_config_set_default_num_groups(struct futhark_context_config *cfg,
                                              int num);
void
futhark_context_config_set_default_tile_size(struct futhark_context_config *cfg,
                                             int num);
void
futhark_context_config_set_default_reg_tile_size(struct futhark_context_config *cfg,
                                                 int num);
void
futhark_context_config_set_default_threshold(struct futhark_context_config *cfg,
                                             int num);
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t new_value);
struct futhark_context;
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg);
void futhark_context_free(struct futhark_context *ctx);
int futhark_get_tuning_param_count(void);
const char *futhark_get_tuning_param_name(int);
const char *futhark_get_tuning_param_class(int);

// Arrays
struct futhark_f32_1d;
struct futhark_f32_1d *futhark_new_f32_1d(struct futhark_context *ctx, const
                                          float *data, int64_t dim0);
struct futhark_f32_1d *futhark_new_raw_f32_1d(struct futhark_context *ctx, const
                                              CUdeviceptr data, int64_t offset,
                                              int64_t dim0);
int futhark_free_f32_1d(struct futhark_context *ctx,
                        struct futhark_f32_1d *arr);
int futhark_values_f32_1d(struct futhark_context *ctx,
                          struct futhark_f32_1d *arr, float *data);
CUdeviceptr futhark_values_raw_f32_1d(struct futhark_context *ctx,
                                      struct futhark_f32_1d *arr);
const int64_t *futhark_shape_f32_1d(struct futhark_context *ctx,
                                    struct futhark_f32_1d *arr);
struct futhark_f32_2d;
struct futhark_f32_2d *futhark_new_f32_2d(struct futhark_context *ctx, const
                                          float *data, int64_t dim0,
                                          int64_t dim1);
struct futhark_f32_2d *futhark_new_raw_f32_2d(struct futhark_context *ctx, const
                                              CUdeviceptr data, int64_t offset,
                                              int64_t dim0, int64_t dim1);
int futhark_free_f32_2d(struct futhark_context *ctx,
                        struct futhark_f32_2d *arr);
int futhark_values_f32_2d(struct futhark_context *ctx,
                          struct futhark_f32_2d *arr, float *data);
CUdeviceptr futhark_values_raw_f32_2d(struct futhark_context *ctx,
                                      struct futhark_f32_2d *arr);
const int64_t *futhark_shape_f32_2d(struct futhark_context *ctx,
                                    struct futhark_f32_2d *arr);

// Opaque values


// Entry points
int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f32_2d **out0,
                       struct futhark_f32_2d **out1,
                       struct futhark_f32_2d **out2, const
                       struct futhark_f32_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5, const int64_t in6, const int64_t in7, const
                       int64_t in8, const int64_t in9, const int64_t in10, const
                       int64_t in11, const int64_t in12, const int64_t in13,
                       const int64_t in14, const int64_t in15, const
                       int64_t in16);
int futhark_entry_seasonal_amplitude(struct futhark_context *ctx,
                                     struct futhark_f32_1d **out0, const
                                     struct futhark_f32_2d *in0);
int futhark_entry_trend_magnitude(struct futhark_context *ctx,
                                  struct futhark_f32_1d **out0, const
                                  struct futhark_f32_2d *in0);

// Miscellaneous
int futhark_context_sync(struct futhark_context *ctx);
char *futhark_context_report(struct futhark_context *ctx);
char *futhark_context_get_error(struct futhark_context *ctx);
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f);
void futhark_context_pause_profiling(struct futhark_context *ctx);
void futhark_context_unpause_profiling(struct futhark_context *ctx);
int futhark_context_clear_caches(struct futhark_context *ctx);
#define FUTHARK_BACKEND_cuda
#define FUTHARK_SUCCESS 0
#define FUTHARK_PROGRAM_ERROR 2
#define FUTHARK_OUT_OF_MEMORY 3

#ifdef __cplusplus
}
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>
#include <stdint.h>
// If NDEBUG is set, the assert() macro will do nothing. Since Futhark
// (unfortunately) makes use of assert() for error detection (and even some
// side effects), we want to avoid that.
#undef NDEBUG
#include <assert.h>
#include <stdarg.h>
// Start of util.h.
//
// Various helper functions that are useful in all generated C code.

#include <errno.h>
#include <string.h>

static const char *fut_progname = "(embedded Futhark)";

static void futhark_panic(int eval, const char *fmt, ...) __attribute__((noreturn));
static char* msgprintf(const char *s, ...);
static void* slurp_file(const char *filename, size_t *size);
static int dump_file(const char *file, const void *buf, size_t n);
struct str_builder;
static void str_builder_init(struct str_builder *b);
static void str_builder(struct str_builder *b, const char *s, ...);

static void futhark_panic(int eval, const char *fmt, ...) {
  va_list ap;
  va_start(ap, fmt);
  fprintf(stderr, "%s: ", fut_progname);
  vfprintf(stderr, fmt, ap);
  va_end(ap);
  exit(eval);
}

// For generating arbitrary-sized error messages.  It is the callers
// responsibility to free the buffer at some point.
static char* msgprintf(const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = 1 + (size_t)vsnprintf(NULL, 0, s, vl);
  char *buffer = (char*) malloc(needed);
  va_start(vl, s); // Must re-init.
  vsnprintf(buffer, needed, s, vl);
  return buffer;
}

static inline void check_err(int errval, int sets_errno, const char *fun, int line,
                            const char *msg, ...) {
  if (errval) {
    char errnum[10];

    va_list vl;
    va_start(vl, msg);

    fprintf(stderr, "ERROR: ");
    vfprintf(stderr, msg, vl);
    fprintf(stderr, " in %s() at line %d with error code %s\n",
            fun, line,
            sets_errno ? strerror(errno) : errnum);
    exit(errval);
  }
}

#define CHECK_ERR(err, ...) check_err(err, 0, __func__, __LINE__, __VA_ARGS__)
#define CHECK_ERRNO(err, ...) check_err(err, 1, __func__, __LINE__, __VA_ARGS__)

// Read the rest of an open file into a NUL-terminated string; returns
// NULL on error.
static void* fslurp_file(FILE *f, size_t *size) {
  long start = ftell(f);
  fseek(f, 0, SEEK_END);
  long src_size = ftell(f)-start;
  fseek(f, start, SEEK_SET);
  unsigned char *s = (unsigned char*) malloc((size_t)src_size + 1);
  if (fread(s, 1, (size_t)src_size, f) != (size_t)src_size) {
    free(s);
    s = NULL;
  } else {
    s[src_size] = '\0';
  }

  if (size) {
    *size = (size_t)src_size;
  }

  return s;
}

// Read a file into a NUL-terminated string; returns NULL on error.
static void* slurp_file(const char *filename, size_t *size) {
  FILE *f = fopen(filename, "rb"); // To avoid Windows messing with linebreaks.
  if (f == NULL) return NULL;
  unsigned char *s = fslurp_file(f, size);
  fclose(f);
  return s;
}

// Dump 'n' bytes from 'buf' into the file at the designated location.
// Returns 0 on success.
static int dump_file(const char *file, const void *buf, size_t n) {
  FILE *f = fopen(file, "w");

  if (f == NULL) {
    return 1;
  }

  if (fwrite(buf, sizeof(char), n, f) != n) {
    return 1;
  }

  if (fclose(f) != 0) {
    return 1;
  }

  return 0;
}

struct str_builder {
  char *str;
  size_t capacity; // Size of buffer.
  size_t used; // Bytes used, *not* including final zero.
};

static void str_builder_init(struct str_builder *b) {
  b->capacity = 10;
  b->used = 0;
  b->str = malloc(b->capacity);
  b->str[0] = 0;
}

static void str_builder(struct str_builder *b, const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = (size_t)vsnprintf(NULL, 0, s, vl);

  while (b->capacity < b->used + needed + 1) {
    b->capacity *= 2;
    b->str = realloc(b->str, b->capacity);
  }

  va_start(vl, s); // Must re-init.
  vsnprintf(b->str+b->used, b->capacity-b->used, s, vl);
  b->used += needed;
}

// End of util.h.
// Start of half.h.

// Conversion functions are from http://half.sourceforge.net/, but
// translated to C.
//
// Copyright (c) 2012-2021 Christian Rau
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

#ifndef __OPENCL_VERSION__
#define __constant
#endif

__constant static const uint16_t base_table[512] = {
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0002, 0x0004, 0x0008, 0x0010, 0x0020, 0x0040, 0x0080, 0x0100,
  0x0200, 0x0400, 0x0800, 0x0C00, 0x1000, 0x1400, 0x1800, 0x1C00, 0x2000, 0x2400, 0x2800, 0x2C00, 0x3000, 0x3400, 0x3800, 0x3C00,
  0x4000, 0x4400, 0x4800, 0x4C00, 0x5000, 0x5400, 0x5800, 0x5C00, 0x6000, 0x6400, 0x6800, 0x6C00, 0x7000, 0x7400, 0x7800, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8001, 0x8002, 0x8004, 0x8008, 0x8010, 0x8020, 0x8040, 0x8080, 0x8100,
  0x8200, 0x8400, 0x8800, 0x8C00, 0x9000, 0x9400, 0x9800, 0x9C00, 0xA000, 0xA400, 0xA800, 0xAC00, 0xB000, 0xB400, 0xB800, 0xBC00,
  0xC000, 0xC400, 0xC800, 0xCC00, 0xD000, 0xD400, 0xD800, 0xDC00, 0xE000, 0xE400, 0xE800, 0xEC00, 0xF000, 0xF400, 0xF800, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00 };

__constant static const unsigned char shift_table[512] = {
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13 };

__constant static const uint32_t mantissa_table[2048] = {
  0x00000000, 0x33800000, 0x34000000, 0x34400000, 0x34800000, 0x34A00000, 0x34C00000, 0x34E00000, 0x35000000, 0x35100000, 0x35200000, 0x35300000, 0x35400000, 0x35500000, 0x35600000, 0x35700000,
  0x35800000, 0x35880000, 0x35900000, 0x35980000, 0x35A00000, 0x35A80000, 0x35B00000, 0x35B80000, 0x35C00000, 0x35C80000, 0x35D00000, 0x35D80000, 0x35E00000, 0x35E80000, 0x35F00000, 0x35F80000,
  0x36000000, 0x36040000, 0x36080000, 0x360C0000, 0x36100000, 0x36140000, 0x36180000, 0x361C0000, 0x36200000, 0x36240000, 0x36280000, 0x362C0000, 0x36300000, 0x36340000, 0x36380000, 0x363C0000,
  0x36400000, 0x36440000, 0x36480000, 0x364C0000, 0x36500000, 0x36540000, 0x36580000, 0x365C0000, 0x36600000, 0x36640000, 0x36680000, 0x366C0000, 0x36700000, 0x36740000, 0x36780000, 0x367C0000,
  0x36800000, 0x36820000, 0x36840000, 0x36860000, 0x36880000, 0x368A0000, 0x368C0000, 0x368E0000, 0x36900000, 0x36920000, 0x36940000, 0x36960000, 0x36980000, 0x369A0000, 0x369C0000, 0x369E0000,
  0x36A00000, 0x36A20000, 0x36A40000, 0x36A60000, 0x36A80000, 0x36AA0000, 0x36AC0000, 0x36AE0000, 0x36B00000, 0x36B20000, 0x36B40000, 0x36B60000, 0x36B80000, 0x36BA0000, 0x36BC0000, 0x36BE0000,
  0x36C00000, 0x36C20000, 0x36C40000, 0x36C60000, 0x36C80000, 0x36CA0000, 0x36CC0000, 0x36CE0000, 0x36D00000, 0x36D20000, 0x36D40000, 0x36D60000, 0x36D80000, 0x36DA0000, 0x36DC0000, 0x36DE0000,
  0x36E00000, 0x36E20000, 0x36E40000, 0x36E60000, 0x36E80000, 0x36EA0000, 0x36EC0000, 0x36EE0000, 0x36F00000, 0x36F20000, 0x36F40000, 0x36F60000, 0x36F80000, 0x36FA0000, 0x36FC0000, 0x36FE0000,
  0x37000000, 0x37010000, 0x37020000, 0x37030000, 0x37040000, 0x37050000, 0x37060000, 0x37070000, 0x37080000, 0x37090000, 0x370A0000, 0x370B0000, 0x370C0000, 0x370D0000, 0x370E0000, 0x370F0000,
  0x37100000, 0x37110000, 0x37120000, 0x37130000, 0x37140000, 0x37150000, 0x37160000, 0x37170000, 0x37180000, 0x37190000, 0x371A0000, 0x371B0000, 0x371C0000, 0x371D0000, 0x371E0000, 0x371F0000,
  0x37200000, 0x37210000, 0x37220000, 0x37230000, 0x37240000, 0x37250000, 0x37260000, 0x37270000, 0x37280000, 0x37290000, 0x372A0000, 0x372B0000, 0x372C0000, 0x372D0000, 0x372E0000, 0x372F0000,
  0x37300000, 0x37310000, 0x37320000, 0x37330000, 0x37340000, 0x37350000, 0x37360000, 0x37370000, 0x37380000, 0x37390000, 0x373A0000, 0x373B0000, 0x373C0000, 0x373D0000, 0x373E0000, 0x373F0000,
  0x37400000, 0x37410000, 0x37420000, 0x37430000, 0x37440000, 0x37450000, 0x37460000, 0x37470000, 0x37480000, 0x37490000, 0x374A0000, 0x374B0000, 0x374C0000, 0x374D0000, 0x374E0000, 0x374F0000,
  0x37500000, 0x37510000, 0x37520000, 0x37530000, 0x37540000, 0x37550000, 0x37560000, 0x37570000, 0x37580000, 0x37590000, 0x375A0000, 0x375B0000, 0x375C0000, 0x375D0000, 0x375E0000, 0x375F0000,
  0x37600000, 0x37610000, 0x37620000, 0x37630000, 0x37640000, 0x37650000, 0x37660000, 0x37670000, 0x37680000, 0x37690000, 0x376A0000, 0x376B0000, 0x376C0000, 0x376D0000, 0x376E0000, 0x376F0000,
  0x37700000, 0x37710000, 0x37720000, 0x37730000, 0x37740000, 0x37750000, 0x37760000, 0x37770000, 0x37780000, 0x37790000, 0x377A0000, 0x377B0000, 0x377C0000, 0x377D0000, 0x377E0000, 0x377F0000,
  0x37800000, 0x37808000, 0x37810000, 0x37818000, 0x37820000, 0x37828000, 0x37830000, 0x37838000, 0x37840000, 0x37848000, 0x37850000, 0x37858000, 0x37860000, 0x37868000, 0x37870000, 0x37878000,
  0x37880000, 0x37888000, 0x37890000, 0x37898000, 0x378A0000, 0x378A8000, 0x378B0000, 0x378B8000, 0x378C0000, 0x378C8000, 0x378D0000, 0x378D8000, 0x378E0000, 0x378E8000, 0x378F0000, 0x378F8000,
  0x37900000, 0x37908000, 0x37910000, 0x37918000, 0x37920000, 0x37928000, 0x37930000, 0x37938000, 0x37940000, 0x37948000, 0x37950000, 0x37958000, 0x37960000, 0x37968000, 0x37970000, 0x37978000,
  0x37980000, 0x37988000, 0x37990000, 0x37998000, 0x379A0000, 0x379A8000, 0x379B0000, 0x379B8000, 0x379C0000, 0x379C8000, 0x379D0000, 0x379D8000, 0x379E0000, 0x379E8000, 0x379F0000, 0x379F8000,
  0x37A00000, 0x37A08000, 0x37A10000, 0x37A18000, 0x37A20000, 0x37A28000, 0x37A30000, 0x37A38000, 0x37A40000, 0x37A48000, 0x37A50000, 0x37A58000, 0x37A60000, 0x37A68000, 0x37A70000, 0x37A78000,
  0x37A80000, 0x37A88000, 0x37A90000, 0x37A98000, 0x37AA0000, 0x37AA8000, 0x37AB0000, 0x37AB8000, 0x37AC0000, 0x37AC8000, 0x37AD0000, 0x37AD8000, 0x37AE0000, 0x37AE8000, 0x37AF0000, 0x37AF8000,
  0x37B00000, 0x37B08000, 0x37B10000, 0x37B18000, 0x37B20000, 0x37B28000, 0x37B30000, 0x37B38000, 0x37B40000, 0x37B48000, 0x37B50000, 0x37B58000, 0x37B60000, 0x37B68000, 0x37B70000, 0x37B78000,
  0x37B80000, 0x37B88000, 0x37B90000, 0x37B98000, 0x37BA0000, 0x37BA8000, 0x37BB0000, 0x37BB8000, 0x37BC0000, 0x37BC8000, 0x37BD0000, 0x37BD8000, 0x37BE0000, 0x37BE8000, 0x37BF0000, 0x37BF8000,
  0x37C00000, 0x37C08000, 0x37C10000, 0x37C18000, 0x37C20000, 0x37C28000, 0x37C30000, 0x37C38000, 0x37C40000, 0x37C48000, 0x37C50000, 0x37C58000, 0x37C60000, 0x37C68000, 0x37C70000, 0x37C78000,
  0x37C80000, 0x37C88000, 0x37C90000, 0x37C98000, 0x37CA0000, 0x37CA8000, 0x37CB0000, 0x37CB8000, 0x37CC0000, 0x37CC8000, 0x37CD0000, 0x37CD8000, 0x37CE0000, 0x37CE8000, 0x37CF0000, 0x37CF8000,
  0x37D00000, 0x37D08000, 0x37D10000, 0x37D18000, 0x37D20000, 0x37D28000, 0x37D30000, 0x37D38000, 0x37D40000, 0x37D48000, 0x37D50000, 0x37D58000, 0x37D60000, 0x37D68000, 0x37D70000, 0x37D78000,
  0x37D80000, 0x37D88000, 0x37D90000, 0x37D98000, 0x37DA0000, 0x37DA8000, 0x37DB0000, 0x37DB8000, 0x37DC0000, 0x37DC8000, 0x37DD0000, 0x37DD8000, 0x37DE0000, 0x37DE8000, 0x37DF0000, 0x37DF8000,
  0x37E00000, 0x37E08000, 0x37E10000, 0x37E18000, 0x37E20000, 0x37E28000, 0x37E30000, 0x37E38000, 0x37E40000, 0x37E48000, 0x37E50000, 0x37E58000, 0x37E60000, 0x37E68000, 0x37E70000, 0x37E78000,
  0x37E80000, 0x37E88000, 0x37E90000, 0x37E98000, 0x37EA0000, 0x37EA8000, 0x37EB0000, 0x37EB8000, 0x37EC0000, 0x37EC8000, 0x37ED0000, 0x37ED8000, 0x37EE0000, 0x37EE8000, 0x37EF0000, 0x37EF8000,
  0x37F00000, 0x37F08000, 0x37F10000, 0x37F18000, 0x37F20000, 0x37F28000, 0x37F30000, 0x37F38000, 0x37F40000, 0x37F48000, 0x37F50000, 0x37F58000, 0x37F60000, 0x37F68000, 0x37F70000, 0x37F78000,
  0x37F80000, 0x37F88000, 0x37F90000, 0x37F98000, 0x37FA0000, 0x37FA8000, 0x37FB0000, 0x37FB8000, 0x37FC0000, 0x37FC8000, 0x37FD0000, 0x37FD8000, 0x37FE0000, 0x37FE8000, 0x37FF0000, 0x37FF8000,
  0x38000000, 0x38004000, 0x38008000, 0x3800C000, 0x38010000, 0x38014000, 0x38018000, 0x3801C000, 0x38020000, 0x38024000, 0x38028000, 0x3802C000, 0x38030000, 0x38034000, 0x38038000, 0x3803C000,
  0x38040000, 0x38044000, 0x38048000, 0x3804C000, 0x38050000, 0x38054000, 0x38058000, 0x3805C000, 0x38060000, 0x38064000, 0x38068000, 0x3806C000, 0x38070000, 0x38074000, 0x38078000, 0x3807C000,
  0x38080000, 0x38084000, 0x38088000, 0x3808C000, 0x38090000, 0x38094000, 0x38098000, 0x3809C000, 0x380A0000, 0x380A4000, 0x380A8000, 0x380AC000, 0x380B0000, 0x380B4000, 0x380B8000, 0x380BC000,
  0x380C0000, 0x380C4000, 0x380C8000, 0x380CC000, 0x380D0000, 0x380D4000, 0x380D8000, 0x380DC000, 0x380E0000, 0x380E4000, 0x380E8000, 0x380EC000, 0x380F0000, 0x380F4000, 0x380F8000, 0x380FC000,
  0x38100000, 0x38104000, 0x38108000, 0x3810C000, 0x38110000, 0x38114000, 0x38118000, 0x3811C000, 0x38120000, 0x38124000, 0x38128000, 0x3812C000, 0x38130000, 0x38134000, 0x38138000, 0x3813C000,
  0x38140000, 0x38144000, 0x38148000, 0x3814C000, 0x38150000, 0x38154000, 0x38158000, 0x3815C000, 0x38160000, 0x38164000, 0x38168000, 0x3816C000, 0x38170000, 0x38174000, 0x38178000, 0x3817C000,
  0x38180000, 0x38184000, 0x38188000, 0x3818C000, 0x38190000, 0x38194000, 0x38198000, 0x3819C000, 0x381A0000, 0x381A4000, 0x381A8000, 0x381AC000, 0x381B0000, 0x381B4000, 0x381B8000, 0x381BC000,
  0x381C0000, 0x381C4000, 0x381C8000, 0x381CC000, 0x381D0000, 0x381D4000, 0x381D8000, 0x381DC000, 0x381E0000, 0x381E4000, 0x381E8000, 0x381EC000, 0x381F0000, 0x381F4000, 0x381F8000, 0x381FC000,
  0x38200000, 0x38204000, 0x38208000, 0x3820C000, 0x38210000, 0x38214000, 0x38218000, 0x3821C000, 0x38220000, 0x38224000, 0x38228000, 0x3822C000, 0x38230000, 0x38234000, 0x38238000, 0x3823C000,
  0x38240000, 0x38244000, 0x38248000, 0x3824C000, 0x38250000, 0x38254000, 0x38258000, 0x3825C000, 0x38260000, 0x38264000, 0x38268000, 0x3826C000, 0x38270000, 0x38274000, 0x38278000, 0x3827C000,
  0x38280000, 0x38284000, 0x38288000, 0x3828C000, 0x38290000, 0x38294000, 0x38298000, 0x3829C000, 0x382A0000, 0x382A4000, 0x382A8000, 0x382AC000, 0x382B0000, 0x382B4000, 0x382B8000, 0x382BC000,
  0x382C0000, 0x382C4000, 0x382C8000, 0x382CC000, 0x382D0000, 0x382D4000, 0x382D8000, 0x382DC000, 0x382E0000, 0x382E4000, 0x382E8000, 0x382EC000, 0x382F0000, 0x382F4000, 0x382F8000, 0x382FC000,
  0x38300000, 0x38304000, 0x38308000, 0x3830C000, 0x38310000, 0x38314000, 0x38318000, 0x3831C000, 0x38320000, 0x38324000, 0x38328000, 0x3832C000, 0x38330000, 0x38334000, 0x38338000, 0x3833C000,
  0x38340000, 0x38344000, 0x38348000, 0x3834C000, 0x38350000, 0x38354000, 0x38358000, 0x3835C000, 0x38360000, 0x38364000, 0x38368000, 0x3836C000, 0x38370000, 0x38374000, 0x38378000, 0x3837C000,
  0x38380000, 0x38384000, 0x38388000, 0x3838C000, 0x38390000, 0x38394000, 0x38398000, 0x3839C000, 0x383A0000, 0x383A4000, 0x383A8000, 0x383AC000, 0x383B0000, 0x383B4000, 0x383B8000, 0x383BC000,
  0x383C0000, 0x383C4000, 0x383C8000, 0x383CC000, 0x383D0000, 0x383D4000, 0x383D8000, 0x383DC000, 0x383E0000, 0x383E4000, 0x383E8000, 0x383EC000, 0x383F0000, 0x383F4000, 0x383F8000, 0x383FC000,
  0x38400000, 0x38404000, 0x38408000, 0x3840C000, 0x38410000, 0x38414000, 0x38418000, 0x3841C000, 0x38420000, 0x38424000, 0x38428000, 0x3842C000, 0x38430000, 0x38434000, 0x38438000, 0x3843C000,
  0x38440000, 0x38444000, 0x38448000, 0x3844C000, 0x38450000, 0x38454000, 0x38458000, 0x3845C000, 0x38460000, 0x38464000, 0x38468000, 0x3846C000, 0x38470000, 0x38474000, 0x38478000, 0x3847C000,
  0x38480000, 0x38484000, 0x38488000, 0x3848C000, 0x38490000, 0x38494000, 0x38498000, 0x3849C000, 0x384A0000, 0x384A4000, 0x384A8000, 0x384AC000, 0x384B0000, 0x384B4000, 0x384B8000, 0x384BC000,
  0x384C0000, 0x384C4000, 0x384C8000, 0x384CC000, 0x384D0000, 0x384D4000, 0x384D8000, 0x384DC000, 0x384E0000, 0x384E4000, 0x384E8000, 0x384EC000, 0x384F0000, 0x384F4000, 0x384F8000, 0x384FC000,
  0x38500000, 0x38504000, 0x38508000, 0x3850C000, 0x38510000, 0x38514000, 0x38518000, 0x3851C000, 0x38520000, 0x38524000, 0x38528000, 0x3852C000, 0x38530000, 0x38534000, 0x38538000, 0x3853C000,
  0x38540000, 0x38544000, 0x38548000, 0x3854C000, 0x38550000, 0x38554000, 0x38558000, 0x3855C000, 0x38560000, 0x38564000, 0x38568000, 0x3856C000, 0x38570000, 0x38574000, 0x38578000, 0x3857C000,
  0x38580000, 0x38584000, 0x38588000, 0x3858C000, 0x38590000, 0x38594000, 0x38598000, 0x3859C000, 0x385A0000, 0x385A4000, 0x385A8000, 0x385AC000, 0x385B0000, 0x385B4000, 0x385B8000, 0x385BC000,
  0x385C0000, 0x385C4000, 0x385C8000, 0x385CC000, 0x385D0000, 0x385D4000, 0x385D8000, 0x385DC000, 0x385E0000, 0x385E4000, 0x385E8000, 0x385EC000, 0x385F0000, 0x385F4000, 0x385F8000, 0x385FC000,
  0x38600000, 0x38604000, 0x38608000, 0x3860C000, 0x38610000, 0x38614000, 0x38618000, 0x3861C000, 0x38620000, 0x38624000, 0x38628000, 0x3862C000, 0x38630000, 0x38634000, 0x38638000, 0x3863C000,
  0x38640000, 0x38644000, 0x38648000, 0x3864C000, 0x38650000, 0x38654000, 0x38658000, 0x3865C000, 0x38660000, 0x38664000, 0x38668000, 0x3866C000, 0x38670000, 0x38674000, 0x38678000, 0x3867C000,
  0x38680000, 0x38684000, 0x38688000, 0x3868C000, 0x38690000, 0x38694000, 0x38698000, 0x3869C000, 0x386A0000, 0x386A4000, 0x386A8000, 0x386AC000, 0x386B0000, 0x386B4000, 0x386B8000, 0x386BC000,
  0x386C0000, 0x386C4000, 0x386C8000, 0x386CC000, 0x386D0000, 0x386D4000, 0x386D8000, 0x386DC000, 0x386E0000, 0x386E4000, 0x386E8000, 0x386EC000, 0x386F0000, 0x386F4000, 0x386F8000, 0x386FC000,
  0x38700000, 0x38704000, 0x38708000, 0x3870C000, 0x38710000, 0x38714000, 0x38718000, 0x3871C000, 0x38720000, 0x38724000, 0x38728000, 0x3872C000, 0x38730000, 0x38734000, 0x38738000, 0x3873C000,
  0x38740000, 0x38744000, 0x38748000, 0x3874C000, 0x38750000, 0x38754000, 0x38758000, 0x3875C000, 0x38760000, 0x38764000, 0x38768000, 0x3876C000, 0x38770000, 0x38774000, 0x38778000, 0x3877C000,
  0x38780000, 0x38784000, 0x38788000, 0x3878C000, 0x38790000, 0x38794000, 0x38798000, 0x3879C000, 0x387A0000, 0x387A4000, 0x387A8000, 0x387AC000, 0x387B0000, 0x387B4000, 0x387B8000, 0x387BC000,
  0x387C0000, 0x387C4000, 0x387C8000, 0x387CC000, 0x387D0000, 0x387D4000, 0x387D8000, 0x387DC000, 0x387E0000, 0x387E4000, 0x387E8000, 0x387EC000, 0x387F0000, 0x387F4000, 0x387F8000, 0x387FC000,
  0x38000000, 0x38002000, 0x38004000, 0x38006000, 0x38008000, 0x3800A000, 0x3800C000, 0x3800E000, 0x38010000, 0x38012000, 0x38014000, 0x38016000, 0x38018000, 0x3801A000, 0x3801C000, 0x3801E000,
  0x38020000, 0x38022000, 0x38024000, 0x38026000, 0x38028000, 0x3802A000, 0x3802C000, 0x3802E000, 0x38030000, 0x38032000, 0x38034000, 0x38036000, 0x38038000, 0x3803A000, 0x3803C000, 0x3803E000,
  0x38040000, 0x38042000, 0x38044000, 0x38046000, 0x38048000, 0x3804A000, 0x3804C000, 0x3804E000, 0x38050000, 0x38052000, 0x38054000, 0x38056000, 0x38058000, 0x3805A000, 0x3805C000, 0x3805E000,
  0x38060000, 0x38062000, 0x38064000, 0x38066000, 0x38068000, 0x3806A000, 0x3806C000, 0x3806E000, 0x38070000, 0x38072000, 0x38074000, 0x38076000, 0x38078000, 0x3807A000, 0x3807C000, 0x3807E000,
  0x38080000, 0x38082000, 0x38084000, 0x38086000, 0x38088000, 0x3808A000, 0x3808C000, 0x3808E000, 0x38090000, 0x38092000, 0x38094000, 0x38096000, 0x38098000, 0x3809A000, 0x3809C000, 0x3809E000,
  0x380A0000, 0x380A2000, 0x380A4000, 0x380A6000, 0x380A8000, 0x380AA000, 0x380AC000, 0x380AE000, 0x380B0000, 0x380B2000, 0x380B4000, 0x380B6000, 0x380B8000, 0x380BA000, 0x380BC000, 0x380BE000,
  0x380C0000, 0x380C2000, 0x380C4000, 0x380C6000, 0x380C8000, 0x380CA000, 0x380CC000, 0x380CE000, 0x380D0000, 0x380D2000, 0x380D4000, 0x380D6000, 0x380D8000, 0x380DA000, 0x380DC000, 0x380DE000,
  0x380E0000, 0x380E2000, 0x380E4000, 0x380E6000, 0x380E8000, 0x380EA000, 0x380EC000, 0x380EE000, 0x380F0000, 0x380F2000, 0x380F4000, 0x380F6000, 0x380F8000, 0x380FA000, 0x380FC000, 0x380FE000,
  0x38100000, 0x38102000, 0x38104000, 0x38106000, 0x38108000, 0x3810A000, 0x3810C000, 0x3810E000, 0x38110000, 0x38112000, 0x38114000, 0x38116000, 0x38118000, 0x3811A000, 0x3811C000, 0x3811E000,
  0x38120000, 0x38122000, 0x38124000, 0x38126000, 0x38128000, 0x3812A000, 0x3812C000, 0x3812E000, 0x38130000, 0x38132000, 0x38134000, 0x38136000, 0x38138000, 0x3813A000, 0x3813C000, 0x3813E000,
  0x38140000, 0x38142000, 0x38144000, 0x38146000, 0x38148000, 0x3814A000, 0x3814C000, 0x3814E000, 0x38150000, 0x38152000, 0x38154000, 0x38156000, 0x38158000, 0x3815A000, 0x3815C000, 0x3815E000,
  0x38160000, 0x38162000, 0x38164000, 0x38166000, 0x38168000, 0x3816A000, 0x3816C000, 0x3816E000, 0x38170000, 0x38172000, 0x38174000, 0x38176000, 0x38178000, 0x3817A000, 0x3817C000, 0x3817E000,
  0x38180000, 0x38182000, 0x38184000, 0x38186000, 0x38188000, 0x3818A000, 0x3818C000, 0x3818E000, 0x38190000, 0x38192000, 0x38194000, 0x38196000, 0x38198000, 0x3819A000, 0x3819C000, 0x3819E000,
  0x381A0000, 0x381A2000, 0x381A4000, 0x381A6000, 0x381A8000, 0x381AA000, 0x381AC000, 0x381AE000, 0x381B0000, 0x381B2000, 0x381B4000, 0x381B6000, 0x381B8000, 0x381BA000, 0x381BC000, 0x381BE000,
  0x381C0000, 0x381C2000, 0x381C4000, 0x381C6000, 0x381C8000, 0x381CA000, 0x381CC000, 0x381CE000, 0x381D0000, 0x381D2000, 0x381D4000, 0x381D6000, 0x381D8000, 0x381DA000, 0x381DC000, 0x381DE000,
  0x381E0000, 0x381E2000, 0x381E4000, 0x381E6000, 0x381E8000, 0x381EA000, 0x381EC000, 0x381EE000, 0x381F0000, 0x381F2000, 0x381F4000, 0x381F6000, 0x381F8000, 0x381FA000, 0x381FC000, 0x381FE000,
  0x38200000, 0x38202000, 0x38204000, 0x38206000, 0x38208000, 0x3820A000, 0x3820C000, 0x3820E000, 0x38210000, 0x38212000, 0x38214000, 0x38216000, 0x38218000, 0x3821A000, 0x3821C000, 0x3821E000,
  0x38220000, 0x38222000, 0x38224000, 0x38226000, 0x38228000, 0x3822A000, 0x3822C000, 0x3822E000, 0x38230000, 0x38232000, 0x38234000, 0x38236000, 0x38238000, 0x3823A000, 0x3823C000, 0x3823E000,
  0x38240000, 0x38242000, 0x38244000, 0x38246000, 0x38248000, 0x3824A000, 0x3824C000, 0x3824E000, 0x38250000, 0x38252000, 0x38254000, 0x38256000, 0x38258000, 0x3825A000, 0x3825C000, 0x3825E000,
  0x38260000, 0x38262000, 0x38264000, 0x38266000, 0x38268000, 0x3826A000, 0x3826C000, 0x3826E000, 0x38270000, 0x38272000, 0x38274000, 0x38276000, 0x38278000, 0x3827A000, 0x3827C000, 0x3827E000,
  0x38280000, 0x38282000, 0x38284000, 0x38286000, 0x38288000, 0x3828A000, 0x3828C000, 0x3828E000, 0x38290000, 0x38292000, 0x38294000, 0x38296000, 0x38298000, 0x3829A000, 0x3829C000, 0x3829E000,
  0x382A0000, 0x382A2000, 0x382A4000, 0x382A6000, 0x382A8000, 0x382AA000, 0x382AC000, 0x382AE000, 0x382B0000, 0x382B2000, 0x382B4000, 0x382B6000, 0x382B8000, 0x382BA000, 0x382BC000, 0x382BE000,
  0x382C0000, 0x382C2000, 0x382C4000, 0x382C6000, 0x382C8000, 0x382CA000, 0x382CC000, 0x382CE000, 0x382D0000, 0x382D2000, 0x382D4000, 0x382D6000, 0x382D8000, 0x382DA000, 0x382DC000, 0x382DE000,
  0x382E0000, 0x382E2000, 0x382E4000, 0x382E6000, 0x382E8000, 0x382EA000, 0x382EC000, 0x382EE000, 0x382F0000, 0x382F2000, 0x382F4000, 0x382F6000, 0x382F8000, 0x382FA000, 0x382FC000, 0x382FE000,
  0x38300000, 0x38302000, 0x38304000, 0x38306000, 0x38308000, 0x3830A000, 0x3830C000, 0x3830E000, 0x38310000, 0x38312000, 0x38314000, 0x38316000, 0x38318000, 0x3831A000, 0x3831C000, 0x3831E000,
  0x38320000, 0x38322000, 0x38324000, 0x38326000, 0x38328000, 0x3832A000, 0x3832C000, 0x3832E000, 0x38330000, 0x38332000, 0x38334000, 0x38336000, 0x38338000, 0x3833A000, 0x3833C000, 0x3833E000,
  0x38340000, 0x38342000, 0x38344000, 0x38346000, 0x38348000, 0x3834A000, 0x3834C000, 0x3834E000, 0x38350000, 0x38352000, 0x38354000, 0x38356000, 0x38358000, 0x3835A000, 0x3835C000, 0x3835E000,
  0x38360000, 0x38362000, 0x38364000, 0x38366000, 0x38368000, 0x3836A000, 0x3836C000, 0x3836E000, 0x38370000, 0x38372000, 0x38374000, 0x38376000, 0x38378000, 0x3837A000, 0x3837C000, 0x3837E000,
  0x38380000, 0x38382000, 0x38384000, 0x38386000, 0x38388000, 0x3838A000, 0x3838C000, 0x3838E000, 0x38390000, 0x38392000, 0x38394000, 0x38396000, 0x38398000, 0x3839A000, 0x3839C000, 0x3839E000,
  0x383A0000, 0x383A2000, 0x383A4000, 0x383A6000, 0x383A8000, 0x383AA000, 0x383AC000, 0x383AE000, 0x383B0000, 0x383B2000, 0x383B4000, 0x383B6000, 0x383B8000, 0x383BA000, 0x383BC000, 0x383BE000,
  0x383C0000, 0x383C2000, 0x383C4000, 0x383C6000, 0x383C8000, 0x383CA000, 0x383CC000, 0x383CE000, 0x383D0000, 0x383D2000, 0x383D4000, 0x383D6000, 0x383D8000, 0x383DA000, 0x383DC000, 0x383DE000,
  0x383E0000, 0x383E2000, 0x383E4000, 0x383E6000, 0x383E8000, 0x383EA000, 0x383EC000, 0x383EE000, 0x383F0000, 0x383F2000, 0x383F4000, 0x383F6000, 0x383F8000, 0x383FA000, 0x383FC000, 0x383FE000,
  0x38400000, 0x38402000, 0x38404000, 0x38406000, 0x38408000, 0x3840A000, 0x3840C000, 0x3840E000, 0x38410000, 0x38412000, 0x38414000, 0x38416000, 0x38418000, 0x3841A000, 0x3841C000, 0x3841E000,
  0x38420000, 0x38422000, 0x38424000, 0x38426000, 0x38428000, 0x3842A000, 0x3842C000, 0x3842E000, 0x38430000, 0x38432000, 0x38434000, 0x38436000, 0x38438000, 0x3843A000, 0x3843C000, 0x3843E000,
  0x38440000, 0x38442000, 0x38444000, 0x38446000, 0x38448000, 0x3844A000, 0x3844C000, 0x3844E000, 0x38450000, 0x38452000, 0x38454000, 0x38456000, 0x38458000, 0x3845A000, 0x3845C000, 0x3845E000,
  0x38460000, 0x38462000, 0x38464000, 0x38466000, 0x38468000, 0x3846A000, 0x3846C000, 0x3846E000, 0x38470000, 0x38472000, 0x38474000, 0x38476000, 0x38478000, 0x3847A000, 0x3847C000, 0x3847E000,
  0x38480000, 0x38482000, 0x38484000, 0x38486000, 0x38488000, 0x3848A000, 0x3848C000, 0x3848E000, 0x38490000, 0x38492000, 0x38494000, 0x38496000, 0x38498000, 0x3849A000, 0x3849C000, 0x3849E000,
  0x384A0000, 0x384A2000, 0x384A4000, 0x384A6000, 0x384A8000, 0x384AA000, 0x384AC000, 0x384AE000, 0x384B0000, 0x384B2000, 0x384B4000, 0x384B6000, 0x384B8000, 0x384BA000, 0x384BC000, 0x384BE000,
  0x384C0000, 0x384C2000, 0x384C4000, 0x384C6000, 0x384C8000, 0x384CA000, 0x384CC000, 0x384CE000, 0x384D0000, 0x384D2000, 0x384D4000, 0x384D6000, 0x384D8000, 0x384DA000, 0x384DC000, 0x384DE000,
  0x384E0000, 0x384E2000, 0x384E4000, 0x384E6000, 0x384E8000, 0x384EA000, 0x384EC000, 0x384EE000, 0x384F0000, 0x384F2000, 0x384F4000, 0x384F6000, 0x384F8000, 0x384FA000, 0x384FC000, 0x384FE000,
  0x38500000, 0x38502000, 0x38504000, 0x38506000, 0x38508000, 0x3850A000, 0x3850C000, 0x3850E000, 0x38510000, 0x38512000, 0x38514000, 0x38516000, 0x38518000, 0x3851A000, 0x3851C000, 0x3851E000,
  0x38520000, 0x38522000, 0x38524000, 0x38526000, 0x38528000, 0x3852A000, 0x3852C000, 0x3852E000, 0x38530000, 0x38532000, 0x38534000, 0x38536000, 0x38538000, 0x3853A000, 0x3853C000, 0x3853E000,
  0x38540000, 0x38542000, 0x38544000, 0x38546000, 0x38548000, 0x3854A000, 0x3854C000, 0x3854E000, 0x38550000, 0x38552000, 0x38554000, 0x38556000, 0x38558000, 0x3855A000, 0x3855C000, 0x3855E000,
  0x38560000, 0x38562000, 0x38564000, 0x38566000, 0x38568000, 0x3856A000, 0x3856C000, 0x3856E000, 0x38570000, 0x38572000, 0x38574000, 0x38576000, 0x38578000, 0x3857A000, 0x3857C000, 0x3857E000,
  0x38580000, 0x38582000, 0x38584000, 0x38586000, 0x38588000, 0x3858A000, 0x3858C000, 0x3858E000, 0x38590000, 0x38592000, 0x38594000, 0x38596000, 0x38598000, 0x3859A000, 0x3859C000, 0x3859E000,
  0x385A0000, 0x385A2000, 0x385A4000, 0x385A6000, 0x385A8000, 0x385AA000, 0x385AC000, 0x385AE000, 0x385B0000, 0x385B2000, 0x385B4000, 0x385B6000, 0x385B8000, 0x385BA000, 0x385BC000, 0x385BE000,
  0x385C0000, 0x385C2000, 0x385C4000, 0x385C6000, 0x385C8000, 0x385CA000, 0x385CC000, 0x385CE000, 0x385D0000, 0x385D2000, 0x385D4000, 0x385D6000, 0x385D8000, 0x385DA000, 0x385DC000, 0x385DE000,
  0x385E0000, 0x385E2000, 0x385E4000, 0x385E6000, 0x385E8000, 0x385EA000, 0x385EC000, 0x385EE000, 0x385F0000, 0x385F2000, 0x385F4000, 0x385F6000, 0x385F8000, 0x385FA000, 0x385FC000, 0x385FE000,
  0x38600000, 0x38602000, 0x38604000, 0x38606000, 0x38608000, 0x3860A000, 0x3860C000, 0x3860E000, 0x38610000, 0x38612000, 0x38614000, 0x38616000, 0x38618000, 0x3861A000, 0x3861C000, 0x3861E000,
  0x38620000, 0x38622000, 0x38624000, 0x38626000, 0x38628000, 0x3862A000, 0x3862C000, 0x3862E000, 0x38630000, 0x38632000, 0x38634000, 0x38636000, 0x38638000, 0x3863A000, 0x3863C000, 0x3863E000,
  0x38640000, 0x38642000, 0x38644000, 0x38646000, 0x38648000, 0x3864A000, 0x3864C000, 0x3864E000, 0x38650000, 0x38652000, 0x38654000, 0x38656000, 0x38658000, 0x3865A000, 0x3865C000, 0x3865E000,
  0x38660000, 0x38662000, 0x38664000, 0x38666000, 0x38668000, 0x3866A000, 0x3866C000, 0x3866E000, 0x38670000, 0x38672000, 0x38674000, 0x38676000, 0x38678000, 0x3867A000, 0x3867C000, 0x3867E000,
  0x38680000, 0x38682000, 0x38684000, 0x38686000, 0x38688000, 0x3868A000, 0x3868C000, 0x3868E000, 0x38690000, 0x38692000, 0x38694000, 0x38696000, 0x38698000, 0x3869A000, 0x3869C000, 0x3869E000,
  0x386A0000, 0x386A2000, 0x386A4000, 0x386A6000, 0x386A8000, 0x386AA000, 0x386AC000, 0x386AE000, 0x386B0000, 0x386B2000, 0x386B4000, 0x386B6000, 0x386B8000, 0x386BA000, 0x386BC000, 0x386BE000,
  0x386C0000, 0x386C2000, 0x386C4000, 0x386C6000, 0x386C8000, 0x386CA000, 0x386CC000, 0x386CE000, 0x386D0000, 0x386D2000, 0x386D4000, 0x386D6000, 0x386D8000, 0x386DA000, 0x386DC000, 0x386DE000,
  0x386E0000, 0x386E2000, 0x386E4000, 0x386E6000, 0x386E8000, 0x386EA000, 0x386EC000, 0x386EE000, 0x386F0000, 0x386F2000, 0x386F4000, 0x386F6000, 0x386F8000, 0x386FA000, 0x386FC000, 0x386FE000,
  0x38700000, 0x38702000, 0x38704000, 0x38706000, 0x38708000, 0x3870A000, 0x3870C000, 0x3870E000, 0x38710000, 0x38712000, 0x38714000, 0x38716000, 0x38718000, 0x3871A000, 0x3871C000, 0x3871E000,
  0x38720000, 0x38722000, 0x38724000, 0x38726000, 0x38728000, 0x3872A000, 0x3872C000, 0x3872E000, 0x38730000, 0x38732000, 0x38734000, 0x38736000, 0x38738000, 0x3873A000, 0x3873C000, 0x3873E000,
  0x38740000, 0x38742000, 0x38744000, 0x38746000, 0x38748000, 0x3874A000, 0x3874C000, 0x3874E000, 0x38750000, 0x38752000, 0x38754000, 0x38756000, 0x38758000, 0x3875A000, 0x3875C000, 0x3875E000,
  0x38760000, 0x38762000, 0x38764000, 0x38766000, 0x38768000, 0x3876A000, 0x3876C000, 0x3876E000, 0x38770000, 0x38772000, 0x38774000, 0x38776000, 0x38778000, 0x3877A000, 0x3877C000, 0x3877E000,
  0x38780000, 0x38782000, 0x38784000, 0x38786000, 0x38788000, 0x3878A000, 0x3878C000, 0x3878E000, 0x38790000, 0x38792000, 0x38794000, 0x38796000, 0x38798000, 0x3879A000, 0x3879C000, 0x3879E000,
  0x387A0000, 0x387A2000, 0x387A4000, 0x387A6000, 0x387A8000, 0x387AA000, 0x387AC000, 0x387AE000, 0x387B0000, 0x387B2000, 0x387B4000, 0x387B6000, 0x387B8000, 0x387BA000, 0x387BC000, 0x387BE000,
  0x387C0000, 0x387C2000, 0x387C4000, 0x387C6000, 0x387C8000, 0x387CA000, 0x387CC000, 0x387CE000, 0x387D0000, 0x387D2000, 0x387D4000, 0x387D6000, 0x387D8000, 0x387DA000, 0x387DC000, 0x387DE000,
  0x387E0000, 0x387E2000, 0x387E4000, 0x387E6000, 0x387E8000, 0x387EA000, 0x387EC000, 0x387EE000, 0x387F0000, 0x387F2000, 0x387F4000, 0x387F6000, 0x387F8000, 0x387FA000, 0x387FC000, 0x387FE000 };
__constant static const uint32_t exponent_table[64] = {
  0x00000000, 0x00800000, 0x01000000, 0x01800000, 0x02000000, 0x02800000, 0x03000000, 0x03800000, 0x04000000, 0x04800000, 0x05000000, 0x05800000, 0x06000000, 0x06800000, 0x07000000, 0x07800000,
  0x08000000, 0x08800000, 0x09000000, 0x09800000, 0x0A000000, 0x0A800000, 0x0B000000, 0x0B800000, 0x0C000000, 0x0C800000, 0x0D000000, 0x0D800000, 0x0E000000, 0x0E800000, 0x0F000000, 0x47800000,
  0x80000000, 0x80800000, 0x81000000, 0x81800000, 0x82000000, 0x82800000, 0x83000000, 0x83800000, 0x84000000, 0x84800000, 0x85000000, 0x85800000, 0x86000000, 0x86800000, 0x87000000, 0x87800000,
  0x88000000, 0x88800000, 0x89000000, 0x89800000, 0x8A000000, 0x8A800000, 0x8B000000, 0x8B800000, 0x8C000000, 0x8C800000, 0x8D000000, 0x8D800000, 0x8E000000, 0x8E800000, 0x8F000000, 0xC7800000 };
__constant static const unsigned short offset_table[64] = {
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024 };

static uint16_t float2halfbits(float value) {
  union { float x; uint32_t y; } u;
  u.x = value;
  uint32_t bits = u.y;

  uint16_t hbits = base_table[bits>>23] + (uint16_t)((bits&0x7FFFFF)>>shift_table[bits>>23]);;

  return hbits;
}

static float halfbits2float(uint16_t value) {
  uint32_t bits = mantissa_table[offset_table[value>>10]+(value&0x3FF)] + exponent_table[value>>10];

  union { uint32_t x; float y; } u;
  u.x = bits;
  return u.y;
}

// End of half.h.
// Start of timing.h.

// The function get_wall_time() returns the wall time in microseconds
// (with an unspecified offset).

#ifdef _WIN32

#include <windows.h>

static int64_t get_wall_time(void) {
  LARGE_INTEGER time,freq;
  assert(QueryPerformanceFrequency(&freq));
  assert(QueryPerformanceCounter(&time));
  return ((double)time.QuadPart / freq.QuadPart) * 1000000;
}

#else
// Assuming POSIX

#include <time.h>
#include <sys/time.h>

static int64_t get_wall_time(void) {
  struct timeval time;
  assert(gettimeofday(&time,NULL) == 0);
  return time.tv_sec * 1000000 + time.tv_usec;
}

static int64_t get_wall_time_ns(void) {
  struct timespec time;
  assert(clock_gettime(CLOCK_REALTIME, &time) == 0);
  return time.tv_sec * 1000000000 + time.tv_nsec;
}

#endif

// End of timing.h.

#ifdef _MSC_VER
#define inline __inline
#endif
#include <string.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include <ctype.h>


#include <cuda.h>
#include <cuda_runtime.h>
#include <nvrtc.h>


// Start of lock.h.

// A very simple cross-platform implementation of locks.  Uses
// pthreads on Unix and some Windows thing there.  Futhark's
// host-level code is not multithreaded, but user code may be, so we
// need some mechanism for ensuring atomic access to API functions.
// This is that mechanism.  It is not exposed to user code at all, so
// we do not have to worry about name collisions.

#ifdef _WIN32

typedef HANDLE lock_t;

static void create_lock(lock_t *lock) {
  *lock = CreateMutex(NULL,  // Default security attributes.
                      FALSE, // Initially unlocked.
                      NULL); // Unnamed.
}

static void lock_lock(lock_t *lock) {
  assert(WaitForSingleObject(*lock, INFINITE) == WAIT_OBJECT_0);
}

static void lock_unlock(lock_t *lock) {
  assert(ReleaseMutex(*lock));
}

static void free_lock(lock_t *lock) {
  CloseHandle(*lock);
}

#else
// Assuming POSIX

#include <pthread.h>

typedef pthread_mutex_t lock_t;

static void create_lock(lock_t *lock) {
  int r = pthread_mutex_init(lock, NULL);
  assert(r == 0);
}

static void lock_lock(lock_t *lock) {
  int r = pthread_mutex_lock(lock);
  assert(r == 0);
}

static void lock_unlock(lock_t *lock) {
  int r = pthread_mutex_unlock(lock);
  assert(r == 0);
}

static void free_lock(lock_t *lock) {
  // Nothing to do for pthreads.
  (void)lock;
}

#endif

// End of lock.h.

#define FUTHARK_F64_ENABLED

// Start of scalar.h.

// Implementation of the primitive scalar operations.  Very
// repetitive.  This code is inserted directly into both CUDA and
// OpenCL programs, as well as the CPU code, so it has some #ifdefs to
// work everywhere.  Some operations are defined as macros because
// this allows us to use them as constant expressions in things like
// array sizes and static initialisers.

// Some of the #ifdefs are because OpenCL uses type-generic functions
// for some operations (e.g. sqrt), while C and CUDA sensibly use
// distinct functions for different precisions (e.g. sqrtf() and
// sqrt()).  This is quite annoying.  Due to C's unfortunate casting
// rules, it is also really easy to accidentally implement
// floating-point functions in the wrong precision, so be careful.

// Double-precision definitions are only included if the preprocessor
// macro FUTHARK_F64_ENABLED is set.

static inline uint8_t add8(uint8_t x, uint8_t y) {
  return x + y;
}

static inline uint16_t add16(uint16_t x, uint16_t y) {
  return x + y;
}

static inline uint32_t add32(uint32_t x, uint32_t y) {
  return x + y;
}

static inline uint64_t add64(uint64_t x, uint64_t y) {
  return x + y;
}

static inline uint8_t sub8(uint8_t x, uint8_t y) {
  return x - y;
}

static inline uint16_t sub16(uint16_t x, uint16_t y) {
  return x - y;
}

static inline uint32_t sub32(uint32_t x, uint32_t y) {
  return x - y;
}

static inline uint64_t sub64(uint64_t x, uint64_t y) {
  return x - y;
}

static inline uint8_t mul8(uint8_t x, uint8_t y) {
  return x * y;
}

static inline uint16_t mul16(uint16_t x, uint16_t y) {
  return x * y;
}

static inline uint32_t mul32(uint32_t x, uint32_t y) {
  return x * y;
}

static inline uint64_t mul64(uint64_t x, uint64_t y) {
  return x * y;
}

static inline uint8_t udiv8(uint8_t x, uint8_t y) {
  return x / y;
}

static inline uint16_t udiv16(uint16_t x, uint16_t y) {
  return x / y;
}

static inline uint32_t udiv32(uint32_t x, uint32_t y) {
  return x / y;
}

static inline uint64_t udiv64(uint64_t x, uint64_t y) {
  return x / y;
}

static inline uint8_t udiv_up8(uint8_t x, uint8_t y) {
  return (x + y - 1) / y;
}

static inline uint16_t udiv_up16(uint16_t x, uint16_t y) {
  return (x + y - 1) / y;
}

static inline uint32_t udiv_up32(uint32_t x, uint32_t y) {
  return (x + y - 1) / y;
}

static inline uint64_t udiv_up64(uint64_t x, uint64_t y) {
  return (x + y - 1) / y;
}

static inline uint8_t umod8(uint8_t x, uint8_t y) {
  return x % y;
}

static inline uint16_t umod16(uint16_t x, uint16_t y) {
  return x % y;
}

static inline uint32_t umod32(uint32_t x, uint32_t y) {
  return x % y;
}

static inline uint64_t umod64(uint64_t x, uint64_t y) {
  return x % y;
}

static inline uint8_t udiv_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint16_t udiv_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint32_t udiv_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint64_t udiv_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint8_t udiv_up_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint16_t udiv_up_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint32_t udiv_up_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint64_t udiv_up_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint8_t umod_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint16_t umod_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint32_t umod_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint64_t umod_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t sdiv8(int8_t x, int8_t y) {
  int8_t q = x / y;
  int8_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int16_t sdiv16(int16_t x, int16_t y) {
  int16_t q = x / y;
  int16_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int32_t sdiv32(int32_t x, int32_t y) {
  int32_t q = x / y;
  int32_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int64_t sdiv64(int64_t x, int64_t y) {
  int64_t q = x / y;
  int64_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int8_t sdiv_up8(int8_t x, int8_t y) {
  return sdiv8(x + y - 1, y);
}

static inline int16_t sdiv_up16(int16_t x, int16_t y) {
  return sdiv16(x + y - 1, y);
}

static inline int32_t sdiv_up32(int32_t x, int32_t y) {
  return sdiv32(x + y - 1, y);
}

static inline int64_t sdiv_up64(int64_t x, int64_t y) {
  return sdiv64(x + y - 1, y);
}

static inline int8_t smod8(int8_t x, int8_t y) {
  int8_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int16_t smod16(int16_t x, int16_t y) {
  int16_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int32_t smod32(int32_t x, int32_t y) {
  int32_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int64_t smod64(int64_t x, int64_t y) {
  int64_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int8_t sdiv_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : sdiv8(x, y);
}

static inline int16_t sdiv_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : sdiv16(x, y);
}

static inline int32_t sdiv_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : sdiv32(x, y);
}

static inline int64_t sdiv_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : sdiv64(x, y);
}

static inline int8_t sdiv_up_safe8(int8_t x, int8_t y) {
  return sdiv_safe8(x + y - 1, y);
}

static inline int16_t sdiv_up_safe16(int16_t x, int16_t y) {
  return sdiv_safe16(x + y - 1, y);
}

static inline int32_t sdiv_up_safe32(int32_t x, int32_t y) {
  return sdiv_safe32(x + y - 1, y);
}

static inline int64_t sdiv_up_safe64(int64_t x, int64_t y) {
  return sdiv_safe64(x + y - 1, y);
}

static inline int8_t smod_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : smod8(x, y);
}

static inline int16_t smod_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : smod16(x, y);
}

static inline int32_t smod_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : smod32(x, y);
}

static inline int64_t smod_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : smod64(x, y);
}

static inline int8_t squot8(int8_t x, int8_t y) {
  return x / y;
}

static inline int16_t squot16(int16_t x, int16_t y) {
  return x / y;
}

static inline int32_t squot32(int32_t x, int32_t y) {
  return x / y;
}

static inline int64_t squot64(int64_t x, int64_t y) {
  return x / y;
}

static inline int8_t srem8(int8_t x, int8_t y) {
  return x % y;
}

static inline int16_t srem16(int16_t x, int16_t y) {
  return x % y;
}

static inline int32_t srem32(int32_t x, int32_t y) {
  return x % y;
}

static inline int64_t srem64(int64_t x, int64_t y) {
  return x % y;
}

static inline int8_t squot_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int16_t squot_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int32_t squot_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int64_t squot_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int8_t srem_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int16_t srem_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int32_t srem_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int64_t srem_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t smin8(int8_t x, int8_t y) {
  return x < y ? x : y;
}

static inline int16_t smin16(int16_t x, int16_t y) {
  return x < y ? x : y;
}

static inline int32_t smin32(int32_t x, int32_t y) {
  return x < y ? x : y;
}

static inline int64_t smin64(int64_t x, int64_t y) {
  return x < y ? x : y;
}

static inline uint8_t umin8(uint8_t x, uint8_t y) {
  return x < y ? x : y;
}

static inline uint16_t umin16(uint16_t x, uint16_t y) {
  return x < y ? x : y;
}

static inline uint32_t umin32(uint32_t x, uint32_t y) {
  return x < y ? x : y;
}

static inline uint64_t umin64(uint64_t x, uint64_t y) {
  return x < y ? x : y;
}

static inline int8_t smax8(int8_t x, int8_t y) {
  return x < y ? y : x;
}

static inline int16_t smax16(int16_t x, int16_t y) {
  return x < y ? y : x;
}

static inline int32_t smax32(int32_t x, int32_t y) {
  return x < y ? y : x;
}

static inline int64_t smax64(int64_t x, int64_t y) {
  return x < y ? y : x;
}

static inline uint8_t umax8(uint8_t x, uint8_t y) {
  return x < y ? y : x;
}

static inline uint16_t umax16(uint16_t x, uint16_t y) {
  return x < y ? y : x;
}

static inline uint32_t umax32(uint32_t x, uint32_t y) {
  return x < y ? y : x;
}

static inline uint64_t umax64(uint64_t x, uint64_t y) {
  return x < y ? y : x;
}

static inline uint8_t shl8(uint8_t x, uint8_t y) {
  return (uint8_t)(x << y);
}

static inline uint16_t shl16(uint16_t x, uint16_t y) {
  return (uint16_t)(x << y);
}

static inline uint32_t shl32(uint32_t x, uint32_t y) {
  return x << y;
}

static inline uint64_t shl64(uint64_t x, uint64_t y) {
  return x << y;
}

static inline uint8_t lshr8(uint8_t x, uint8_t y) {
  return x >> y;
}

static inline uint16_t lshr16(uint16_t x, uint16_t y) {
  return x >> y;
}

static inline uint32_t lshr32(uint32_t x, uint32_t y) {
  return x >> y;
}

static inline uint64_t lshr64(uint64_t x, uint64_t y) {
  return x >> y;
}

static inline int8_t ashr8(int8_t x, int8_t y) {
  return x >> y;
}

static inline int16_t ashr16(int16_t x, int16_t y) {
  return x >> y;
}

static inline int32_t ashr32(int32_t x, int32_t y) {
  return x >> y;
}

static inline int64_t ashr64(int64_t x, int64_t y) {
  return x >> y;
}

static inline uint8_t and8(uint8_t x, uint8_t y) {
  return x & y;
}

static inline uint16_t and16(uint16_t x, uint16_t y) {
  return x & y;
}

static inline uint32_t and32(uint32_t x, uint32_t y) {
  return x & y;
}

static inline uint64_t and64(uint64_t x, uint64_t y) {
  return x & y;
}

static inline uint8_t or8(uint8_t x, uint8_t y) {
  return x | y;
}

static inline uint16_t or16(uint16_t x, uint16_t y) {
  return x | y;
}

static inline uint32_t or32(uint32_t x, uint32_t y) {
  return x | y;
}

static inline uint64_t or64(uint64_t x, uint64_t y) {
  return x | y;
}

static inline uint8_t xor8(uint8_t x, uint8_t y) {
  return x ^ y;
}

static inline uint16_t xor16(uint16_t x, uint16_t y) {
  return x ^ y;
}

static inline uint32_t xor32(uint32_t x, uint32_t y) {
  return x ^ y;
}

static inline uint64_t xor64(uint64_t x, uint64_t y) {
  return x ^ y;
}

static inline bool ult8(uint8_t x, uint8_t y) {
  return x < y;
}

static inline bool ult16(uint16_t x, uint16_t y) {
  return x < y;
}

static inline bool ult32(uint32_t x, uint32_t y) {
  return x < y;
}

static inline bool ult64(uint64_t x, uint64_t y) {
  return x < y;
}

static inline bool ule8(uint8_t x, uint8_t y) {
  return x <= y;
}

static inline bool ule16(uint16_t x, uint16_t y) {
  return x <= y;
}

static inline bool ule32(uint32_t x, uint32_t y) {
  return x <= y;
}

static inline bool ule64(uint64_t x, uint64_t y) {
  return x <= y;
}

static inline bool slt8(int8_t x, int8_t y) {
  return x < y;
}

static inline bool slt16(int16_t x, int16_t y) {
  return x < y;
}

static inline bool slt32(int32_t x, int32_t y) {
  return x < y;
}

static inline bool slt64(int64_t x, int64_t y) {
  return x < y;
}

static inline bool sle8(int8_t x, int8_t y) {
  return x <= y;
}

static inline bool sle16(int16_t x, int16_t y) {
  return x <= y;
}

static inline bool sle32(int32_t x, int32_t y) {
  return x <= y;
}

static inline bool sle64(int64_t x, int64_t y) {
  return x <= y;
}

static inline uint8_t pow8(uint8_t x, uint8_t y) {
  uint8_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint16_t pow16(uint16_t x, uint16_t y) {
  uint16_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint32_t pow32(uint32_t x, uint32_t y) {
  uint32_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint64_t pow64(uint64_t x, uint64_t y) {
  uint64_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline bool itob_i8_bool(int8_t x) {
  return x;
}

static inline bool itob_i16_bool(int16_t x) {
  return x;
}

static inline bool itob_i32_bool(int32_t x) {
  return x;
}

static inline bool itob_i64_bool(int64_t x) {
  return x;
}

static inline int8_t btoi_bool_i8(bool x) {
  return x;
}

static inline int16_t btoi_bool_i16(bool x) {
  return x;
}

static inline int32_t btoi_bool_i32(bool x) {
  return x;
}

static inline int64_t btoi_bool_i64(bool x) {
  return x;
}

#define sext_i8_i8(x) ((int8_t) (int8_t) (x))
#define sext_i8_i16(x) ((int16_t) (int8_t) (x))
#define sext_i8_i32(x) ((int32_t) (int8_t) (x))
#define sext_i8_i64(x) ((int64_t) (int8_t) (x))
#define sext_i16_i8(x) ((int8_t) (int16_t) (x))
#define sext_i16_i16(x) ((int16_t) (int16_t) (x))
#define sext_i16_i32(x) ((int32_t) (int16_t) (x))
#define sext_i16_i64(x) ((int64_t) (int16_t) (x))
#define sext_i32_i8(x) ((int8_t) (int32_t) (x))
#define sext_i32_i16(x) ((int16_t) (int32_t) (x))
#define sext_i32_i32(x) ((int32_t) (int32_t) (x))
#define sext_i32_i64(x) ((int64_t) (int32_t) (x))
#define sext_i64_i8(x) ((int8_t) (int64_t) (x))
#define sext_i64_i16(x) ((int16_t) (int64_t) (x))
#define sext_i64_i32(x) ((int32_t) (int64_t) (x))
#define sext_i64_i64(x) ((int64_t) (int64_t) (x))
#define zext_i8_i8(x) ((int8_t) (uint8_t) (x))
#define zext_i8_i16(x) ((int16_t) (uint8_t) (x))
#define zext_i8_i32(x) ((int32_t) (uint8_t) (x))
#define zext_i8_i64(x) ((int64_t) (uint8_t) (x))
#define zext_i16_i8(x) ((int8_t) (uint16_t) (x))
#define zext_i16_i16(x) ((int16_t) (uint16_t) (x))
#define zext_i16_i32(x) ((int32_t) (uint16_t) (x))
#define zext_i16_i64(x) ((int64_t) (uint16_t) (x))
#define zext_i32_i8(x) ((int8_t) (uint32_t) (x))
#define zext_i32_i16(x) ((int16_t) (uint32_t) (x))
#define zext_i32_i32(x) ((int32_t) (uint32_t) (x))
#define zext_i32_i64(x) ((int64_t) (uint32_t) (x))
#define zext_i64_i8(x) ((int8_t) (uint64_t) (x))
#define zext_i64_i16(x) ((int16_t) (uint64_t) (x))
#define zext_i64_i32(x) ((int32_t) (uint64_t) (x))
#define zext_i64_i64(x) ((int64_t) (uint64_t) (x))

static int8_t abs8(int8_t x) {
  return (int8_t)abs(x);
}

static int16_t abs16(int16_t x) {
  return (int16_t)abs(x);
}

static int32_t abs32(int32_t x) {
  return abs(x);
}

static int64_t abs64(int64_t x) {
#if defined(__OPENCL_VERSION__)
  return abs(x);
#else
  return llabs(x);
#endif
}

#if defined(__OPENCL_VERSION__)
static int32_t futrts_popc8(int8_t x) {
  return popcount(x);
}

static int32_t futrts_popc16(int16_t x) {
  return popcount(x);
}

static int32_t futrts_popc32(int32_t x) {
  return popcount(x);
}

static int32_t futrts_popc64(int64_t x) {
  return popcount(x);
}
#elif defined(__CUDA_ARCH__)

static int32_t futrts_popc8(int8_t x) {
  return __popc(zext_i8_i32(x));
}

static int32_t futrts_popc16(int16_t x) {
  return __popc(zext_i16_i32(x));
}

static int32_t futrts_popc32(int32_t x) {
  return __popc(x);
}

static int32_t futrts_popc64(int64_t x) {
  return __popcll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_popc8(uint8_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc16(uint16_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc32(uint32_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc64(uint64_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  return mul_hi(a, b);
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  return mul_hi(a, b);
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mul_hi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul_hi(a, b);
}

#elif defined(__CUDA_ARCH__)

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mulhi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul64hi(a, b);
}

#else // Not OpenCL or CUDA, but plain C.

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  uint64_t aa = a;
  uint64_t bb = b;

  return aa * bb >> 32;
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  __uint128_t aa = a;
  __uint128_t bb = b;

  return aa * bb >> 64;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return mad_hi(a, b, c);
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return mad_hi(a, b, c);
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return mad_hi(a, b, c);
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return mad_hi(a, b, c);
}

#else // Not OpenCL

static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return futrts_mul_hi8(a, b) + c;
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return futrts_mul_hi16(a, b) + c;
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return futrts_mul_hi32(a, b) + c;
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return futrts_mul_hi64(a, b) + c;
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_clzz8(int8_t x) {
  return clz(x);
}

static int32_t futrts_clzz16(int16_t x) {
  return clz(x);
}

static int32_t futrts_clzz32(int32_t x) {
  return clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return clz(x);
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_clzz8(int8_t x) {
  return __clz(zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return __clz(zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return __clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return __clzll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_clzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_clz((uint32_t)zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_clz((uint32_t)zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_clz((uint32_t)x);
}

static int32_t futrts_clzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_clzll((uint64_t)x);
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_ctzz8(int8_t x) {
  int i = 0;
  for (; i < 8 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz16(int16_t x) {
  int i = 0;
  for (; i < 16 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz32(int32_t x) {
  int i = 0;
  for (; i < 32 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz64(int64_t x) {
  int i = 0;
  for (; i < 64 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_ctzz8(int8_t x) {
  int y = __ffs(x);
  return y == 0 ? 8 : y - 1;
}

static int32_t futrts_ctzz16(int16_t x) {
  int y = __ffs(x);
  return y == 0 ? 16 : y - 1;
}

static int32_t futrts_ctzz32(int32_t x) {
  int y = __ffs(x);
  return y == 0 ? 32 : y - 1;
}

static int32_t futrts_ctzz64(int64_t x) {
  int y = __ffsll(x);
  return y == 0 ? 64 : y - 1;
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_ctzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_ctzll((uint64_t)x);
}
#endif

static inline float fdiv32(float x, float y) {
  return x / y;
}

static inline float fadd32(float x, float y) {
  return x + y;
}

static inline float fsub32(float x, float y) {
  return x - y;
}

static inline float fmul32(float x, float y) {
  return x * y;
}

static inline bool cmplt32(float x, float y) {
  return x < y;
}

static inline bool cmple32(float x, float y) {
  return x <= y;
}

static inline float sitofp_i8_f32(int8_t x) {
  return (float) x;
}

static inline float sitofp_i16_f32(int16_t x) {
  return (float) x;
}

static inline float sitofp_i32_f32(int32_t x) {
  return (float) x;
}

static inline float sitofp_i64_f32(int64_t x) {
  return (float) x;
}

static inline float uitofp_i8_f32(uint8_t x) {
  return (float) x;
}

static inline float uitofp_i16_f32(uint16_t x) {
  return (float) x;
}

static inline float uitofp_i32_f32(uint32_t x) {
  return (float) x;
}

static inline float uitofp_i64_f32(uint64_t x) {
  return (float) x;
}

static inline int8_t fptosi_f32_i8(float x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f32_i16(float x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f32_i32(float x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f32_i64(float x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f32_i8(float x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f32_i16(float x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f32_i32(float x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f32_i64(float x) {
  return (uint64_t) x;
}

#ifdef __OPENCL_VERSION__
static inline float fabs32(float x) {
  return fabs(x);
}

static inline float fmax32(float x, float y) {
  return fmax(x, y);
}

static inline float fmin32(float x, float y) {
  return fmin(x, y);
}

static inline float fpow32(float x, float y) {
  return pow(x, y);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float fabs32(float x) {
  return fabsf(x);
}

static inline float fmax32(float x, float y) {
  return fmaxf(x, y);
}

static inline float fmin32(float x, float y) {
  return fminf(x, y);
}

static inline float fpow32(float x, float y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan32(float x) {
  return isnan(x);
}

static inline bool futrts_isinf32(float x) {
  return isinf(x);
}

#ifdef __OPENCL_VERSION__
static inline float futrts_log32(float x) {
  return log(x);
}

static inline float futrts_log2_32(float x) {
  return log2(x);
}

static inline float futrts_log10_32(float x) {
  return log10(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrt(x);
}

static inline float futrts_exp32(float x) {
  return exp(x);
}

static inline float futrts_cos32(float x) {
  return cos(x);
}

static inline float futrts_sin32(float x) {
  return sin(x);
}

static inline float futrts_tan32(float x) {
  return tan(x);
}

static inline float futrts_acos32(float x) {
  return acos(x);
}

static inline float futrts_asin32(float x) {
  return asin(x);
}

static inline float futrts_atan32(float x) {
  return atan(x);
}

static inline float futrts_cosh32(float x) {
  return cosh(x);
}

static inline float futrts_sinh32(float x) {
  return sinh(x);
}

static inline float futrts_tanh32(float x) {
  return tanh(x);
}

static inline float futrts_acosh32(float x) {
  return acosh(x);
}

static inline float futrts_asinh32(float x) {
  return asinh(x);
}

static inline float futrts_atanh32(float x) {
  return atanh(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypot(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgamma(x);
}

static inline float futrts_lgamma32(float x) {
  return lgamma(x);
}

static inline float fmod32(float x, float y) {
  return fmod(x, y);
}

static inline float futrts_round32(float x) {
  return rint(x);
}

static inline float futrts_floor32(float x) {
  return floor(x);
}

static inline float futrts_ceil32(float x) {
  return ceil(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return mix(v0, v1, t);
}

static inline float futrts_mad32(float a, float b, float c) {
  return mad(a, b, c);
}

static inline float futrts_fma32(float a, float b, float c) {
  return fma(a, b, c);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float futrts_log32(float x) {
  return logf(x);
}

static inline float futrts_log2_32(float x) {
  return log2f(x);
}

static inline float futrts_log10_32(float x) {
  return log10f(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrtf(x);
}

static inline float futrts_exp32(float x) {
  return expf(x);
}

static inline float futrts_cos32(float x) {
  return cosf(x);
}

static inline float futrts_sin32(float x) {
  return sinf(x);
}

static inline float futrts_tan32(float x) {
  return tanf(x);
}

static inline float futrts_acos32(float x) {
  return acosf(x);
}

static inline float futrts_asin32(float x) {
  return asinf(x);
}

static inline float futrts_atan32(float x) {
  return atanf(x);
}

static inline float futrts_cosh32(float x) {
  return coshf(x);
}

static inline float futrts_sinh32(float x) {
  return sinhf(x);
}

static inline float futrts_tanh32(float x) {
  return tanhf(x);
}

static inline float futrts_acosh32(float x) {
  return acoshf(x);
}

static inline float futrts_asinh32(float x) {
  return asinhf(x);
}

static inline float futrts_atanh32(float x) {
  return atanhf(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2f(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypotf(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgammaf(x);
}

static inline float futrts_lgamma32(float x) {
  return lgammaf(x);
}

static inline float fmod32(float x, float y) {
  return fmodf(x, y);
}

static inline float futrts_round32(float x) {
  return rintf(x);
}

static inline float futrts_floor32(float x) {
  return floorf(x);
}

static inline float futrts_ceil32(float x) {
  return ceilf(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return v0 + (v1 - v0) * t;
}

static inline float futrts_mad32(float a, float b, float c) {
  return a * b + c;
}

static inline float futrts_fma32(float a, float b, float c) {
  return fmaf(a, b, c);
}
#endif

static inline int32_t futrts_to_bits32(float x) {
  union {
    float f;
    int32_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline float futrts_from_bits32(int32_t x) {
  union {
    int32_t f;
    float t;
  } p;

  p.f = x;
  return p.t;
}

static inline float fsignum32(float x) {
  return futrts_isnan32(x) ? x : (x > 0) - (x < 0);
}

#ifdef FUTHARK_F64_ENABLED

static inline double fdiv64(double x, double y) {
  return x / y;
}

static inline double fadd64(double x, double y) {
  return x + y;
}

static inline double fsub64(double x, double y) {
  return x - y;
}

static inline double fmul64(double x, double y) {
  return x * y;
}

static inline bool cmplt64(double x, double y) {
  return x < y;
}

static inline bool cmple64(double x, double y) {
  return x <= y;
}

static inline double sitofp_i8_f64(int8_t x) {
  return (double) x;
}

static inline double sitofp_i16_f64(int16_t x) {
  return (double) x;
}

static inline double sitofp_i32_f64(int32_t x) {
  return (double) x;
}

static inline double sitofp_i64_f64(int64_t x) {
  return (double) x;
}

static inline double uitofp_i8_f64(uint8_t x) {
  return (double) x;
}

static inline double uitofp_i16_f64(uint16_t x) {
  return (double) x;
}

static inline double uitofp_i32_f64(uint32_t x) {
  return (double) x;
}

static inline double uitofp_i64_f64(uint64_t x) {
  return (double) x;
}

static inline int8_t fptosi_f64_i8(double x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f64_i16(double x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f64_i32(double x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f64_i64(double x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f64_i8(double x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f64_i16(double x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f64_i32(double x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f64_i64(double x) {
  return (uint64_t) x;
}

static inline double fabs64(double x) {
  return fabs(x);
}

static inline double fmax64(double x, double y) {
  return fmax(x, y);
}

static inline double fmin64(double x, double y) {
  return fmin(x, y);
}

static inline double fpow64(double x, double y) {
  return pow(x, y);
}

static inline double futrts_log64(double x) {
  return log(x);
}

static inline double futrts_log2_64(double x) {
  return log2(x);
}

static inline double futrts_log10_64(double x) {
  return log10(x);
}

static inline double futrts_sqrt64(double x) {
  return sqrt(x);
}

static inline double futrts_exp64(double x) {
  return exp(x);
}

static inline double futrts_cos64(double x) {
  return cos(x);
}

static inline double futrts_sin64(double x) {
  return sin(x);
}

static inline double futrts_tan64(double x) {
  return tan(x);
}

static inline double futrts_acos64(double x) {
  return acos(x);
}

static inline double futrts_asin64(double x) {
  return asin(x);
}

static inline double futrts_atan64(double x) {
  return atan(x);
}

static inline double futrts_cosh64(double x) {
  return cosh(x);
}

static inline double futrts_sinh64(double x) {
  return sinh(x);
}

static inline double futrts_tanh64(double x) {
  return tanh(x);
}

static inline double futrts_acosh64(double x) {
  return acosh(x);
}

static inline double futrts_asinh64(double x) {
  return asinh(x);
}

static inline double futrts_atanh64(double x) {
  return atanh(x);
}

static inline double futrts_atan2_64(double x, double y) {
  return atan2(x, y);
}

static inline double futrts_hypot64(double x, double y) {
  return hypot(x, y);
}

static inline double futrts_gamma64(double x) {
  return tgamma(x);
}

static inline double futrts_lgamma64(double x) {
  return lgamma(x);
}

static inline double futrts_fma64(double a, double b, double c) {
  return fma(a, b, c);
}

static inline double futrts_round64(double x) {
  return rint(x);
}

static inline double futrts_ceil64(double x) {
  return ceil(x);
}

static inline double futrts_floor64(double x) {
  return floor(x);
}

static inline bool futrts_isnan64(double x) {
  return isnan(x);
}

static inline bool futrts_isinf64(double x) {
  return isinf(x);
}

static inline int64_t futrts_to_bits64(double x) {
  union {
    double f;
    int64_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline double futrts_from_bits64(int64_t x) {
  union {
    int64_t f;
    double t;
  } p;

  p.f = x;
  return p.t;
}

static inline double fmod64(double x, double y) {
  return fmod(x, y);
}

static inline double fsignum64(double x) {
  return futrts_isnan64(x) ? x : (x > 0) - (x < 0);
}

static inline double futrts_lerp64(double v0, double v1, double t) {
#ifdef __OPENCL_VERSION__
  return mix(v0, v1, t);
#else
  return v0 + (v1 - v0) * t;
#endif
}

static inline double futrts_mad64(double a, double b, double c) {
#ifdef __OPENCL_VERSION__
  return mad(a, b, c);
#else
  return a * b + c;
#endif
}

static inline float fpconv_f32_f32(float x) {
  return (float) x;
}

static inline double fpconv_f32_f64(float x) {
  return (double) x;
}

static inline float fpconv_f64_f32(double x) {
  return (float) x;
}

static inline double fpconv_f64_f64(double x) {
  return (double) x;
}

#endif

// End of scalar.h.
// Start of scalar_f16.h.

// Half-precision is emulated if needed (e.g. in straight C) with the
// native type used if possible.  The emulation works by typedef'ing
// 'float' to 'f16', and then implementing all operations on single
// precision.  To cut down on duplication, we use the same code for
// those Futhark functions that require just operators or casts.  The
// in-memory representation for arrays will still be 16 bits even
// under emulation, so the compiler will have to be careful when
// generating reads or writes.

#if !defined(cl_khr_fp16) && !(defined(__CUDA_ARCH__) && __CUDA_ARCH__ >= 600)
#define EMULATE_F16
#endif

#if !defined(EMULATE_F16) && defined(__OPENCL_VERSION__)
#pragma OPENCL EXTENSION cl_khr_fp16 : enable
#endif

#ifdef EMULATE_F16

// Note that the half-precision storage format is still 16 bits - the
// compiler will have to be real careful!
typedef float f16;

#else

#ifdef __CUDA_ARCH__
#include <cuda_fp16.h>
#endif

typedef half f16;

#endif

// Some of these functions convert to single precision because half
// precision versions are not available.

static inline f16 fadd16(f16 x, f16 y) {
  return x + y;
}

static inline f16 fsub16(f16 x, f16 y) {
  return x - y;
}

static inline f16 fmul16(f16 x, f16 y) {
  return x * y;
}

static inline bool cmplt16(f16 x, f16 y) {
  return x < y;
}

static inline bool cmple16(f16 x, f16 y) {
  return x <= y;
}

static inline f16 sitofp_i8_f16(int8_t x) {
  return (f16) x;
}

static inline f16 sitofp_i16_f16(int16_t x) {
  return (f16) x;
}

static inline f16 sitofp_i32_f16(int32_t x) {
  return (f16) x;
}

static inline f16 sitofp_i64_f16(int64_t x) {
  return (f16) x;
}

static inline f16 uitofp_i8_f16(uint8_t x) {
  return (f16) x;
}

static inline f16 uitofp_i16_f16(uint16_t x) {
  return (f16) x;
}

static inline f16 uitofp_i32_f16(uint32_t x) {
  return (f16) x;
}

static inline f16 uitofp_i64_f16(uint64_t x) {
  return (f16) x;
}

static inline int8_t fptosi_f16_i8(f16 x) {
  return (int8_t) (float) x;
}

static inline int16_t fptosi_f16_i16(f16 x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f16_i32(f16 x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f16_i64(f16 x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f16_i8(f16 x) {
  return (uint8_t) (float) x;
}

static inline uint16_t fptoui_f16_i16(f16 x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f16_i32(f16 x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f16_i64(f16 x) {
  return (uint64_t) x;
}

#ifndef EMULATE_F16

#ifdef __OPENCL_VERSION__
static inline f16 fabs16(f16 x) {
  return fabs(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return pow(x, y);
}

#else // Assuming CUDA.

static inline f16 fabs16(f16 x) {
  return fabsf(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmaxf(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fminf(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan16(f16 x) {
  return isnan((float)x);
}

static inline bool futrts_isinf16(f16 x) {
  return isinf((float)x);
}

#ifdef __OPENCL_VERSION__
static inline f16 futrts_log16(f16 x) {
  return log(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return log2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return log10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return sqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return exp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return cos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return sin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tan(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acos(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asin(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atan(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return cosh(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinh(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanh(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acosh(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinh(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanh(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypot(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgamma(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgamma(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rint(x);
}

static inline f16 futrts_floor16(f16 x) {
  return floor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return ceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return mix(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return mad(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fma(a, b, c);
}

#else // Assume CUDA.

static inline f16 futrts_log16(f16 x) {
  return hlog(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return hlog2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return hlog10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return hsqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return hexp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return hcos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return hsin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tanf(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acosf(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asinf(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atanf(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return coshf(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinhf(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanhf(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acoshf(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinhf(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanhf(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2f(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypotf(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgammaf(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgammaf(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmodf(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rintf(x);
}

static inline f16 futrts_floor16(f16 x) {
  return hfloor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return hceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return v0 + (v1 - v0) * t;
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return a * b + c;
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fmaf(a, b, c);
}

#endif

// The CUDA __half type cannot be put in unions for some reason, so we
// use bespoke conversion functions instead.
#ifdef __CUDA_ARCH__
static inline int16_t futrts_to_bits16(f16 x) {
  return __half_as_ushort(x);
}
static inline f16 futrts_from_bits16(int16_t x) {
  return __ushort_as_half(x);
}
#else
static inline int16_t futrts_to_bits16(f16 x) {
  union {
    f16 f;
    int16_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline f16 futrts_from_bits16(int16_t x) {
  union {
    int16_t f;
    f16 t;
  } p;

  p.f = x;
  return p.t;
}
#endif

#else // No native f16 - emulate.

static inline f16 fabs16(f16 x) {
  return fabs32(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax32(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin32(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return fpow32(x, y);
}

static inline bool futrts_isnan16(f16 x) {
  return futrts_isnan32(x);
}

static inline bool futrts_isinf16(f16 x) {
  return futrts_isinf32(x);
}

static inline f16 futrts_log16(f16 x) {
  return futrts_log32(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return futrts_log2_32(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return futrts_log10_32(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return futrts_sqrt32(x);
}

static inline f16 futrts_exp16(f16 x) {
  return futrts_exp32(x);
}

static inline f16 futrts_cos16(f16 x) {
  return futrts_cos32(x);
}

static inline f16 futrts_sin16(f16 x) {
  return futrts_sin32(x);
}

static inline f16 futrts_tan16(f16 x) {
  return futrts_tan32(x);
}

static inline f16 futrts_acos16(f16 x) {
  return futrts_acos32(x);
}

static inline f16 futrts_asin16(f16 x) {
  return futrts_asin32(x);
}

static inline f16 futrts_atan16(f16 x) {
  return futrts_atan32(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return futrts_cosh32(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return futrts_sinh32(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return futrts_tanh32(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return futrts_acosh32(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return futrts_asinh32(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return futrts_atanh32(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return futrts_atan2_32(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return futrts_hypot32(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return futrts_gamma32(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return futrts_lgamma32(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod32(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return futrts_round32(x);
}

static inline f16 futrts_floor16(f16 x) {
  return futrts_floor32(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return futrts_ceil32(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return futrts_lerp32(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return futrts_mad32(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return futrts_fma32(a, b, c);
}

// Even when we are using an OpenCL that does not support cl_khr_fp16,
// it must still support vload_half for actually creating a
// half-precision number, which can then be efficiently converted to a
// float.  Similarly for vstore_half.
#ifdef __OPENCL_VERSION__

static inline int16_t futrts_to_bits16(f16 x) {
  int16_t y;
  // Violating strict aliasing here.
  vstore_half((float)x, 0, (half*)&y);
  return y;
}

static inline f16 futrts_from_bits16(int16_t x) {
  return (f16)vload_half(0, (half*)&x);
}

#else

static inline int16_t futrts_to_bits16(f16 x) {
  return (int16_t)float2halfbits(x);
}

static inline f16 futrts_from_bits16(int16_t x) {
  return halfbits2float((uint16_t)x);
}

static inline f16 fsignum16(f16 x) {
  return futrts_isnan16(x) ? x : (x > 0) - (x < 0);
}

#endif

#endif

static inline float fpconv_f16_f16(f16 x) {
  return x;
}

static inline float fpconv_f16_f32(f16 x) {
  return x;
}

static inline f16 fpconv_f32_f16(float x) {
  return x;
}

#ifdef FUTHARK_F64_ENABLED

static inline double fpconv_f16_f64(f16 x) {
  return (double) x;
}

static inline f16 fpconv_f64_f16(double x) {
  return (f16) x;
}

#endif


// End of scalar_f16.h.

static int init_constants(struct futhark_context *);
static int free_constants(struct futhark_context *);
static int32_t mainziid_counter_mem_realtype_325882[1];
static int32_t mainziid_counter_mem_realtype_325915[1];
static int32_t mainziid_counter_mem_realtype_325963[1];
static int32_t mainzicounter_mem_realtype_326287[10240];
static int32_t mainzicounter_mem_realtype_326324[10240];
static int32_t mainzicounter_mem_realtype_326416[10240];
static int32_t mainzicounter_mem_realtype_326470[10240];
static int32_t mainzicounter_mem_realtype_326586[10240];
static int32_t mainzicounter_mem_realtype_326654[10240];
static int32_t mainzicounter_mem_realtype_326704[10240];
static int32_t mainziid_counter_mem_realtype_326716[1];
static int32_t mainzicounter_mem_realtype_326741[10240];
static int32_t mainziid_counter_mem_realtype_326753[1];
static int32_t mainzicounter_mem_realtype_326778[10240];
static int32_t mainziid_counter_mem_realtype_326790[1];
static int32_t mainzicounter_mem_realtype_326906[10240];
static int32_t mainzicounter_mem_realtype_326936[10240];
static int32_t mainzicounter_mem_realtype_326967[10240];
static int32_t mainzicounter_mem_realtype_327014[10240];
static int32_t mainzicounter_mem_realtype_327057[10240];
static int32_t mainzicounter_mem_realtype_327118[10240];
static int32_t mainzicounter_mem_realtype_327369[10240];
static int32_t mainzicounter_mem_realtype_327403[10240];
static int32_t mainzicounter_mem_realtype_327452[10240];
static int32_t mainzicounter_mem_realtype_327503[10240];
static int32_t mainzicounter_mem_realtype_327564[10240];
static int32_t mainzicounter_mem_realtype_327629[10240];
static int32_t mainzicounter_mem_realtype_327702[10240];
static int32_t mainziid_counter_mem_realtype_327739[1];
static int32_t mainzicounter_mem_realtype_327781[10240];
static int32_t mainziid_counter_mem_realtype_327816[1];
static int32_t mainzicounter_mem_realtype_327864[10240];
static int32_t seasonal_amplitudezicounter_mem_realtype_327933[10240];
static int32_t trend_magnitudezicounter_mem_realtype_327956[10] = {0, 0, 0, 0,
                                                                   0, 0, 0, 0,
                                                                   0, 0};
static int32_t trend_magnitudezicounter_mem_realtype_327990[10240];
struct memblock_device {
    int *references;
    CUdeviceptr mem;
    int64_t size;
    const char *desc;
};
struct memblock {
    int *references;
    unsigned char *mem;
    int64_t size;
    const char *desc;
};
#include <cuda.h>
#include <nvrtc.h>
typedef CUdeviceptr fl_mem_t;
// Start of free_list.h.

// An entry in the free list.  May be invalid, to avoid having to
// deallocate entries as soon as they are removed.  There is also a
// tag, to help with memory reuse.
struct free_list_entry {
  size_t size;
  fl_mem_t mem;
  const char *tag;
  unsigned char valid;
};

struct free_list {
  struct free_list_entry *entries;        // Pointer to entries.
  int capacity;                           // Number of entries.
  int used;                               // Number of valid entries.
};

static void free_list_init(struct free_list *l) {
  l->capacity = 30; // Picked arbitrarily.
  l->used = 0;
  l->entries = (struct free_list_entry*) malloc(sizeof(struct free_list_entry) * l->capacity);
  for (int i = 0; i < l->capacity; i++) {
    l->entries[i].valid = 0;
  }
}

// Remove invalid entries from the free list.
static void free_list_pack(struct free_list *l) {
  int p = 0;
  for (int i = 0; i < l->capacity; i++) {
    if (l->entries[i].valid) {
      l->entries[p] = l->entries[i];
      if (i > p) {
        l->entries[i].valid = 0;
      }
      p++;
    }
  }

  // Now p is the number of used elements.  We don't want it to go
  // less than the default capacity (although in practice it's OK as
  // long as it doesn't become 1).
  if (p < 30) {
    p = 30;
  }
  l->entries = realloc(l->entries, p * sizeof(struct free_list_entry));
  l->capacity = p;
}

static void free_list_destroy(struct free_list *l) {
  assert(l->used == 0);
  free(l->entries);
}

static int free_list_find_invalid(struct free_list *l) {
  int i;
  for (i = 0; i < l->capacity; i++) {
    if (!l->entries[i].valid) {
      break;
    }
  }
  return i;
}

static void free_list_insert(struct free_list *l, size_t size, fl_mem_t mem, const char *tag) {
  int i = free_list_find_invalid(l);

  if (i == l->capacity) {
    // List is full; so we have to grow it.
    int new_capacity = l->capacity * 2 * sizeof(struct free_list_entry);
    l->entries = realloc(l->entries, new_capacity);
    for (int j = 0; j < l->capacity; j++) {
      l->entries[j+l->capacity].valid = 0;
    }
    l->capacity *= 2;
  }

  // Now 'i' points to the first invalid entry.
  l->entries[i].valid = 1;
  l->entries[i].size = size;
  l->entries[i].mem = mem;
  l->entries[i].tag = tag;

  l->used++;
}

// Find and remove a memory block of the indicated tag, or if that
// does not exist, another memory block with exactly the desired size.
// Returns 0 on success.
static int free_list_find(struct free_list *l, size_t size,
                          size_t *size_out, fl_mem_t *mem_out) {
  int size_match = -1;
  int i;
  for (i = 0; i < l->capacity; i++) {
    if (l->entries[i].valid &&
        size <= l->entries[i].size &&
        (size_match < 0 || l->entries[i].size < l->entries[size_match].size)) {
      // If this entry is valid, has sufficient size, and is smaller than the
      // best entry found so far, use this entry.
      size_match = i;
    }
  }

  if (size_match >= 0) {
    l->entries[size_match].valid = 0;
    *size_out = l->entries[size_match].size;
    *mem_out = l->entries[size_match].mem;
    l->used--;
    return 0;
  } else {
    return 1;
  }
}

// Remove the first block in the free list.  Returns 0 if a block was
// removed, and nonzero if the free list was already empty.
static int free_list_first(struct free_list *l, fl_mem_t *mem_out) {
  for (int i = 0; i < l->capacity; i++) {
    if (l->entries[i].valid) {
      l->entries[i].valid = 0;
      *mem_out = l->entries[i].mem;
      l->used--;
      return 0;
    }
  }

  return 1;
}

// End of free_list.h.

// Start of cuda.h.

#define CUDA_SUCCEED_FATAL(x) cuda_api_succeed_fatal(x, #x, __FILE__, __LINE__)
#define CUDA_SUCCEED_NONFATAL(x) cuda_api_succeed_nonfatal(x, #x, __FILE__, __LINE__)
#define NVRTC_SUCCEED_FATAL(x) nvrtc_api_succeed_fatal(x, #x, __FILE__, __LINE__)
#define NVRTC_SUCCEED_NONFATAL(x) nvrtc_api_succeed_nonfatal(x, #x, __FILE__, __LINE__)
// Take care not to override an existing error.
#define CUDA_SUCCEED_OR_RETURN(e) {               \
    char *serror = CUDA_SUCCEED_NONFATAL(e);      \
    if (serror) {                                 \
      if (!ctx->error) {                          \
        ctx->error = serror;                      \
        return bad;                               \
      } else {                                    \
        free(serror);                             \
      }                                           \
    }                                             \
  }

// CUDA_SUCCEED_OR_RETURN returns the value of the variable 'bad' in
// scope.  By default, it will be this one.  Create a local variable
// of some other type if needed.  This is a bit of a hack, but it
// saves effort in the code generator.
static const int bad = 1;

static inline void cuda_api_succeed_fatal(CUresult res, const char *call,
    const char *file, int line) {
  if (res != CUDA_SUCCESS) {
    const char *err_str;
    cuGetErrorString(res, &err_str);
    if (err_str == NULL) { err_str = "Unknown"; }
    futhark_panic(-1, "%s:%d: CUDA call\n  %s\nfailed with error code %d (%s)\n",
        file, line, call, res, err_str);
  }
}

static char* cuda_api_succeed_nonfatal(CUresult res, const char *call,
    const char *file, int line) {
  if (res != CUDA_SUCCESS) {
    const char *err_str;
    cuGetErrorString(res, &err_str);
    if (err_str == NULL) { err_str = "Unknown"; }
    return msgprintf("%s:%d: CUDA call\n  %s\nfailed with error code %d (%s)\n",
        file, line, call, res, err_str);
  } else {
    return NULL;
  }
}

static inline void nvrtc_api_succeed_fatal(nvrtcResult res, const char *call,
                                           const char *file, int line) {
  if (res != NVRTC_SUCCESS) {
    const char *err_str = nvrtcGetErrorString(res);
    futhark_panic(-1, "%s:%d: NVRTC call\n  %s\nfailed with error code %d (%s)\n",
        file, line, call, res, err_str);
  }
}

static char* nvrtc_api_succeed_nonfatal(nvrtcResult res, const char *call,
                                        const char *file, int line) {
  if (res != NVRTC_SUCCESS) {
    const char *err_str = nvrtcGetErrorString(res);
    return msgprintf("%s:%d: NVRTC call\n  %s\nfailed with error code %d (%s)\n",
                     file, line, call, res, err_str);
  } else {
    return NULL;
  }
}

struct cuda_config {
  int debugging;
  int logging;
  const char *preferred_device;
  int preferred_device_num;

  const char *dump_program_to;
  const char *load_program_from;

  const char *dump_ptx_to;
  const char *load_ptx_from;

  size_t default_block_size;
  size_t default_grid_size;
  size_t default_tile_size;
  size_t default_reg_tile_size;
  size_t default_threshold;

  int default_block_size_changed;
  int default_grid_size_changed;
  int default_tile_size_changed;

  int num_sizes;
  const char **size_names;
  const char **size_vars;
  int64_t *size_values;
  const char **size_classes;
};

static void cuda_config_init(struct cuda_config *cfg,
                             int num_sizes,
                             const char *size_names[],
                             const char *size_vars[],
                             int64_t *size_values,
                             const char *size_classes[]) {
  cfg->debugging = 0;
  cfg->logging = 0;
  cfg->preferred_device_num = 0;
  cfg->preferred_device = "";
  cfg->dump_program_to = NULL;
  cfg->load_program_from = NULL;

  cfg->dump_ptx_to = NULL;
  cfg->load_ptx_from = NULL;

  cfg->default_block_size = 256;
  cfg->default_grid_size = 0; // Set properly later.
  cfg->default_tile_size = 32;
  cfg->default_reg_tile_size = 2;
  cfg->default_threshold = 32*1024;

  cfg->default_block_size_changed = 0;
  cfg->default_grid_size_changed = 0;
  cfg->default_tile_size_changed = 0;

  cfg->num_sizes = num_sizes;
  cfg->size_names = size_names;
  cfg->size_vars = size_vars;
  cfg->size_values = size_values;
  cfg->size_classes = size_classes;
}

// A record of something that happened.
struct profiling_record {
  cudaEvent_t *events; // Points to two events.
  int *runs;
  int64_t *runtime;
};

struct cuda_context {
  CUdevice dev;
  CUcontext cu_ctx;
  CUmodule module;

  struct cuda_config cfg;

  struct free_list free_list;

  size_t max_block_size;
  size_t max_grid_size;
  size_t max_tile_size;
  size_t max_threshold;
  size_t max_shared_memory;
  size_t max_bespoke;

  size_t lockstep_width;

  struct profiling_record *profiling_records;
  int profiling_records_capacity;
  int profiling_records_used;
};

#define CU_DEV_ATTR(x) (CU_DEVICE_ATTRIBUTE_##x)
#define device_query(dev,attrib) _device_query(dev, CU_DEV_ATTR(attrib))
static int _device_query(CUdevice dev, CUdevice_attribute attrib) {
  int val;
  CUDA_SUCCEED_FATAL(cuDeviceGetAttribute(&val, attrib, dev));
  return val;
}

#define CU_FUN_ATTR(x) (CU_FUNC_ATTRIBUTE_##x)
#define function_query(fn,attrib) _function_query(dev, CU_FUN_ATTR(attrib))
static int _function_query(CUfunction dev, CUfunction_attribute attrib) {
  int val;
  CUDA_SUCCEED_FATAL(cuFuncGetAttribute(&val, attrib, dev));
  return val;
}

static void set_preferred_device(struct cuda_config *cfg, const char *s) {
  int x = 0;
  if (*s == '#') {
    s++;
    while (isdigit(*s)) {
      x = x * 10 + (*s++)-'0';
    }
    // Skip trailing spaces.
    while (isspace(*s)) {
      s++;
    }
  }
  cfg->preferred_device = s;
  cfg->preferred_device_num = x;
}

static int cuda_device_setup(struct cuda_context *ctx) {
  char name[256];
  int count, chosen = -1, best_cc = -1;
  int cc_major_best, cc_minor_best;
  int cc_major, cc_minor;
  CUdevice dev;

  CUDA_SUCCEED_FATAL(cuDeviceGetCount(&count));
  if (count == 0) { return 1; }

  int num_device_matches = 0;

  // XXX: Current device selection policy is to choose the device with the
  // highest compute capability (if no preferred device is set).
  // This should maybe be changed, since greater compute capability is not
  // necessarily an indicator of better performance.
  for (int i = 0; i < count; i++) {
    CUDA_SUCCEED_FATAL(cuDeviceGet(&dev, i));

    cc_major = device_query(dev, COMPUTE_CAPABILITY_MAJOR);
    cc_minor = device_query(dev, COMPUTE_CAPABILITY_MINOR);

    CUDA_SUCCEED_FATAL(cuDeviceGetName(name, sizeof(name) - 1, dev));
    name[sizeof(name) - 1] = 0;

    if (ctx->cfg.debugging) {
      fprintf(stderr, "Device #%d: name=\"%s\", compute capability=%d.%d\n",
          i, name, cc_major, cc_minor);
    }

    if (device_query(dev, COMPUTE_MODE) == CU_COMPUTEMODE_PROHIBITED) {
      if (ctx->cfg.debugging) {
        fprintf(stderr, "Device #%d is compute-prohibited, ignoring\n", i);
      }
      continue;
    }

    if (best_cc == -1 || cc_major > cc_major_best ||
        (cc_major == cc_major_best && cc_minor > cc_minor_best)) {
      best_cc = i;
      cc_major_best = cc_major;
      cc_minor_best = cc_minor;
    }

    if (strstr(name, ctx->cfg.preferred_device) != NULL &&
        num_device_matches++ == ctx->cfg.preferred_device_num) {
      chosen = i;
      break;
    }
  }

  if (chosen == -1) { chosen = best_cc; }
  if (chosen == -1) { return 1; }

  if (ctx->cfg.debugging) {
    fprintf(stderr, "Using device #%d\n", chosen);
  }

  CUDA_SUCCEED_FATAL(cuDeviceGet(&ctx->dev, chosen));
  return 0;
}

static char *concat_fragments(const char *src_fragments[]) {
  size_t src_len = 0;
  const char **p;

  for (p = src_fragments; *p; p++) {
    src_len += strlen(*p);
  }

  char *src = (char*) malloc(src_len + 1);
  size_t n = 0;
  for (p = src_fragments; *p; p++) {
    strcpy(src + n, *p);
    n += strlen(*p);
  }

  return src;
}

static const char *cuda_nvrtc_get_arch(CUdevice dev) {
  struct {
    int major;
    int minor;
    const char *arch_str;
  } static const x[] = {
    { 3, 0, "compute_30" },
    { 3, 2, "compute_32" },
    { 3, 5, "compute_35" },
    { 3, 7, "compute_37" },
    { 5, 0, "compute_50" },
    { 5, 2, "compute_52" },
    { 5, 3, "compute_53" },
    { 6, 0, "compute_60" },
    { 6, 1, "compute_61" },
    { 6, 2, "compute_62" },
    { 7, 0, "compute_70" },
    { 7, 2, "compute_72" },
    { 7, 5, "compute_75" },
    { 8, 0, "compute_80" }
  };

  int major = device_query(dev, COMPUTE_CAPABILITY_MAJOR);
  int minor = device_query(dev, COMPUTE_CAPABILITY_MINOR);

  int chosen = -1;
  for (int i = 0; i < sizeof(x)/sizeof(x[0]); i++) {
    if (x[i].major < major || (x[i].major == major && x[i].minor <= minor)) {
      chosen = i;
    } else {
      break;
    }
  }

  if (chosen == -1) {
    futhark_panic(-1, "Unsupported compute capability %d.%d\n", major, minor);
  }

  if (x[chosen].major != major || x[chosen].minor != minor) {
    fprintf(stderr,
            "Warning: device compute capability is %d.%d, but newest supported by Futhark is %d.%d.\n",
            major, minor, x[chosen].major, x[chosen].minor);
  }

  return x[chosen].arch_str;
}

static char* cuda_nvrtc_build(struct cuda_context *ctx, const char *src,
                              const char *extra_opts[], char **ptx) {
  nvrtcProgram prog;
  char *problem = NULL;

  problem = NVRTC_SUCCEED_NONFATAL(nvrtcCreateProgram(&prog, src, "futhark-cuda", 0, NULL, NULL));

  if (problem) {
    return problem;
  }

  int arch_set = 0, num_extra_opts;

  // nvrtc cannot handle multiple -arch options.  Hence, if one of the
  // extra_opts is -arch, we have to be careful not to do our usual
  // automatic generation.
  for (num_extra_opts = 0; extra_opts[num_extra_opts] != NULL; num_extra_opts++) {
    if (strstr(extra_opts[num_extra_opts], "-arch")
        == extra_opts[num_extra_opts] ||
        strstr(extra_opts[num_extra_opts], "--gpu-architecture")
        == extra_opts[num_extra_opts]) {
      arch_set = 1;
    }
  }

  size_t n_opts, i = 0, i_dyn, n_opts_alloc = 20 + num_extra_opts + ctx->cfg.num_sizes;
  const char **opts = (const char**) malloc(n_opts_alloc * sizeof(const char *));
  if (!arch_set) {
    opts[i++] = "-arch";
    opts[i++] = cuda_nvrtc_get_arch(ctx->dev);
  }
  opts[i++] = "-default-device";
  if (ctx->cfg.debugging) {
    opts[i++] = "-G";
    opts[i++] = "-lineinfo";
  } else {
    opts[i++] = "--disable-warnings";
  }
  i_dyn = i;
  for (size_t j = 0; j < ctx->cfg.num_sizes; j++) {
    opts[i++] = msgprintf("-D%s=%zu", ctx->cfg.size_vars[j],
        ctx->cfg.size_values[j]);
  }
  opts[i++] = msgprintf("-DLOCKSTEP_WIDTH=%zu", ctx->lockstep_width);
  opts[i++] = msgprintf("-DMAX_THREADS_PER_BLOCK=%zu", ctx->max_block_size);

  // Time for the best lines of the code in the entire compiler.
  if (getenv("CUDA_HOME") != NULL) {
    opts[i++] = msgprintf("-I%s/include", getenv("CUDA_HOME"));
  }
  if (getenv("CUDA_ROOT") != NULL) {
    opts[i++] = msgprintf("-I%s/include", getenv("CUDA_ROOT"));
  }
  if (getenv("CUDA_PATH") != NULL) {
    opts[i++] = msgprintf("-I%s/include", getenv("CUDA_PATH"));
  }
  opts[i++] = msgprintf("-I/usr/local/cuda/include");
  opts[i++] = msgprintf("-I/usr/include");

  // It is crucial that the extra_opts are last, so that the free()
  // logic below does not cause problems.
  for (int j = 0; extra_opts[j] != NULL; j++) {
    opts[i++] = extra_opts[j];
  }

  n_opts = i;

  if (ctx->cfg.debugging) {
    fprintf(stderr, "NVRTC compile options:\n");
    for (size_t j = 0; j < n_opts; j++) {
      fprintf(stderr, "\t%s\n", opts[j]);
    }
    fprintf(stderr, "\n");
  }

  nvrtcResult res = nvrtcCompileProgram(prog, n_opts, opts);
  if (res != NVRTC_SUCCESS) {
    size_t log_size;
    if (nvrtcGetProgramLogSize(prog, &log_size) == NVRTC_SUCCESS) {
      char *log = (char*) malloc(log_size);
      if (nvrtcGetProgramLog(prog, log) == NVRTC_SUCCESS) {
        problem = msgprintf("NVRTC compilation failed.\n\n%s\n", log);
      } else {
        problem = msgprintf("Could not retrieve compilation log\n");
      }
      free(log);
    }
    return problem;
  }

  for (i = i_dyn; i < n_opts-num_extra_opts; i++) { free((char *)opts[i]); }
  free(opts);

  size_t ptx_size;
  NVRTC_SUCCEED_FATAL(nvrtcGetPTXSize(prog, &ptx_size));
  *ptx = (char*) malloc(ptx_size);
  NVRTC_SUCCEED_FATAL(nvrtcGetPTX(prog, *ptx));

  NVRTC_SUCCEED_FATAL(nvrtcDestroyProgram(&prog));

  return NULL;
}

static void cuda_size_setup(struct cuda_context *ctx)
{
  if (ctx->cfg.default_block_size > ctx->max_block_size) {
    if (ctx->cfg.default_block_size_changed) {
      fprintf(stderr,
          "Note: Device limits default block size to %zu (down from %zu).\n",
          ctx->max_block_size, ctx->cfg.default_block_size);
    }
    ctx->cfg.default_block_size = ctx->max_block_size;
  }
  if (ctx->cfg.default_grid_size > ctx->max_grid_size) {
    if (ctx->cfg.default_grid_size_changed) {
      fprintf(stderr,
          "Note: Device limits default grid size to %zu (down from %zu).\n",
          ctx->max_grid_size, ctx->cfg.default_grid_size);
    }
    ctx->cfg.default_grid_size = ctx->max_grid_size;
  }
  if (ctx->cfg.default_tile_size > ctx->max_tile_size) {
    if (ctx->cfg.default_tile_size_changed) {
      fprintf(stderr,
          "Note: Device limits default tile size to %zu (down from %zu).\n",
          ctx->max_tile_size, ctx->cfg.default_tile_size);
    }
    ctx->cfg.default_tile_size = ctx->max_tile_size;
  }

  if (!ctx->cfg.default_grid_size_changed) {
    ctx->cfg.default_grid_size =
      (device_query(ctx->dev, MULTIPROCESSOR_COUNT) *
       device_query(ctx->dev, MAX_THREADS_PER_MULTIPROCESSOR))
      / ctx->cfg.default_block_size;
  }

  for (int i = 0; i < ctx->cfg.num_sizes; i++) {
    const char *size_class = ctx->cfg.size_classes[i];
    int64_t *size_value = &ctx->cfg.size_values[i];
    const char* size_name = ctx->cfg.size_names[i];
    int64_t max_value = 0, default_value = 0;

    if (strstr(size_class, "group_size") == size_class) {
      max_value = ctx->max_block_size;
      default_value = ctx->cfg.default_block_size;
    } else if (strstr(size_class, "num_groups") == size_class) {
      max_value = ctx->max_grid_size;
      default_value = ctx->cfg.default_grid_size;
      // XXX: as a quick and dirty hack, use twice as many threads for
      // histograms by default.  We really should just be smarter
      // about sizes somehow.
      if (strstr(size_name, ".seghist_") != NULL) {
        default_value *= 2;
      }
    } else if (strstr(size_class, "tile_size") == size_class) {
      max_value = ctx->max_tile_size;
      default_value = ctx->cfg.default_tile_size;
    } else if (strstr(size_class, "reg_tile_size") == size_class) {
      max_value = 0; // No limit.
      default_value = ctx->cfg.default_reg_tile_size;
    } else if (strstr(size_class, "threshold") == size_class) {
      // Threshold can be as large as it takes.
      default_value = ctx->cfg.default_threshold;
    } else {
      // Bespoke sizes have no limit or default.
    }

    if (*size_value == 0) {
      *size_value = default_value;
    } else if (max_value > 0 && *size_value > max_value) {
      fprintf(stderr, "Note: Device limits %s to %zu (down from %zu)\n",
              size_name, max_value, *size_value);
      *size_value = max_value;
    }
  }
}

static char* cuda_module_setup(struct cuda_context *ctx,
                               const char *src_fragments[],
                               const char *extra_opts[]) {
  char *ptx = NULL, *src = NULL;

  if (ctx->cfg.load_program_from == NULL) {
    src = concat_fragments(src_fragments);
  } else {
    src = slurp_file(ctx->cfg.load_program_from, NULL);
  }

  if (ctx->cfg.load_ptx_from) {
    if (ctx->cfg.load_program_from != NULL) {
      fprintf(stderr,
              "WARNING: Using PTX from %s instead of C code from %s\n",
              ctx->cfg.load_ptx_from, ctx->cfg.load_program_from);
    }
    ptx = slurp_file(ctx->cfg.load_ptx_from, NULL);
  }

  if (ctx->cfg.dump_program_to != NULL) {
    dump_file(ctx->cfg.dump_program_to, src, strlen(src));
  }

  if (ptx == NULL) {
    char* problem = cuda_nvrtc_build(ctx, src, extra_opts, &ptx);
    if (problem != NULL) {
      free(src);
      return problem;
    }
  }

  if (ctx->cfg.dump_ptx_to != NULL) {
    dump_file(ctx->cfg.dump_ptx_to, ptx, strlen(ptx));
  }

  CUDA_SUCCEED_FATAL(cuModuleLoadData(&ctx->module, ptx));

  free(ptx);
  if (src != NULL) {
    free(src);
  }

  return NULL;
}

static char* cuda_setup(struct cuda_context *ctx, const char *src_fragments[], const char *extra_opts[]) {
  CUDA_SUCCEED_FATAL(cuInit(0));

  if (cuda_device_setup(ctx) != 0) {
    futhark_panic(-1, "No suitable CUDA device found.\n");
  }
  CUDA_SUCCEED_FATAL(cuCtxCreate(&ctx->cu_ctx, 0, ctx->dev));

  free_list_init(&ctx->free_list);

  ctx->max_shared_memory = device_query(ctx->dev, MAX_SHARED_MEMORY_PER_BLOCK);
  ctx->max_block_size = device_query(ctx->dev, MAX_THREADS_PER_BLOCK);
  ctx->max_grid_size = device_query(ctx->dev, MAX_GRID_DIM_X);
  ctx->max_tile_size = sqrt(ctx->max_block_size);
  ctx->max_threshold = 0;
  ctx->max_bespoke = 0;
  ctx->lockstep_width = device_query(ctx->dev, WARP_SIZE);

  cuda_size_setup(ctx);
  return cuda_module_setup(ctx, src_fragments, extra_opts);
}

// Count up the runtime all the profiling_records that occured during execution.
// Also clears the buffer of profiling_records.
static cudaError_t cuda_tally_profiling_records(struct cuda_context *ctx) {
  cudaError_t err;
  for (int i = 0; i < ctx->profiling_records_used; i++) {
    struct profiling_record record = ctx->profiling_records[i];

    float ms;
    if ((err = cudaEventElapsedTime(&ms, record.events[0], record.events[1])) != cudaSuccess) {
      return err;
    }

    // CUDA provides milisecond resolution, but we want microseconds.
    *record.runs += 1;
    *record.runtime += ms*1000;

    if ((err = cudaEventDestroy(record.events[0])) != cudaSuccess) {
      return err;
    }
    if ((err = cudaEventDestroy(record.events[1])) != cudaSuccess) {
      return err;
    }

    free(record.events);
  }

  ctx->profiling_records_used = 0;

  return cudaSuccess;
}

// Returns pointer to two events.
static cudaEvent_t* cuda_get_events(struct cuda_context *ctx, int *runs, int64_t *runtime) {
    if (ctx->profiling_records_used == ctx->profiling_records_capacity) {
      ctx->profiling_records_capacity *= 2;
      ctx->profiling_records =
        realloc(ctx->profiling_records,
                ctx->profiling_records_capacity *
                sizeof(struct profiling_record));
    }
    cudaEvent_t *events = calloc(2, sizeof(cudaEvent_t));
    cudaEventCreate(&events[0]);
    cudaEventCreate(&events[1]);
    ctx->profiling_records[ctx->profiling_records_used].events = events;
    ctx->profiling_records[ctx->profiling_records_used].runs = runs;
    ctx->profiling_records[ctx->profiling_records_used].runtime = runtime;
    ctx->profiling_records_used++;
    return events;
}

static CUresult cuda_free_all(struct cuda_context *ctx);

static void cuda_cleanup(struct cuda_context *ctx) {
  CUDA_SUCCEED_FATAL(cuda_free_all(ctx));
  (void)cuda_tally_profiling_records(ctx);
  free(ctx->profiling_records);
  CUDA_SUCCEED_FATAL(cuModuleUnload(ctx->module));
  CUDA_SUCCEED_FATAL(cuCtxDestroy(ctx->cu_ctx));
}

static CUresult cuda_alloc(struct cuda_context *ctx, size_t min_size,
                           const char *tag, CUdeviceptr *mem_out) {
  if (min_size < sizeof(int)) {
    min_size = sizeof(int);
  }

  size_t size;
  if (free_list_find(&ctx->free_list, min_size, &size, mem_out) == 0) {
    if (size >= min_size) {
      return CUDA_SUCCESS;
    } else {
      CUresult res = cuMemFree(*mem_out);
      if (res != CUDA_SUCCESS) {
        return res;
      }
    }
  }

  CUresult res = cuMemAlloc(mem_out, min_size);
  while (res == CUDA_ERROR_OUT_OF_MEMORY) {
    CUdeviceptr mem;
    if (free_list_first(&ctx->free_list, &mem) == 0) {
      res = cuMemFree(mem);
      if (res != CUDA_SUCCESS) {
        return res;
      }
    } else {
      break;
    }
    res = cuMemAlloc(mem_out, min_size);
  }

  return res;
}

static CUresult cuda_free(struct cuda_context *ctx, CUdeviceptr mem,
                          const char *tag) {
  size_t size;
  CUdeviceptr existing_mem;

  // If there is already a block with this tag, then remove it.
  if (free_list_find(&ctx->free_list, -1, &size, &existing_mem) == 0) {
    CUresult res = cuMemFree(existing_mem);
    if (res != CUDA_SUCCESS) {
      return res;
    }
  }

  CUresult res = cuMemGetAddressRange(NULL, &size, mem);
  if (res == CUDA_SUCCESS) {
    free_list_insert(&ctx->free_list, size, mem, tag);
  }

  return res;
}

static CUresult cuda_free_all(struct cuda_context *ctx) {
  CUdeviceptr mem;
  free_list_pack(&ctx->free_list);
  while (free_list_first(&ctx->free_list, &mem) == 0) {
    CUresult res = cuMemFree(mem);
    if (res != CUDA_SUCCESS) {
      return res;
    }
  }

  return CUDA_SUCCESS;
}

// End of cuda.h.

const char *cuda_program[] =
           {"\n#define FUTHARK_CUDA\n#define FUTHARK_F64_ENABLED\n\ntypedef char int8_t;\ntypedef short int16_t;\ntypedef int int32_t;\ntypedef long long int64_t;\ntypedef unsigned char uint8_t;\ntypedef unsigned short uint16_t;\ntypedef unsigned int uint32_t;\ntypedef unsigned long long uint64_t;\ntypedef uint8_t uchar;\ntypedef uint16_t ushort;\ntypedef uint32_t uint;\ntypedef uint64_t ulong;\n#define __kernel extern \"C\" __global__ __launch_bounds__(MAX_THREADS_PER_BLOCK)\n#define __global\n#define __local\n#define __private\n#define __constant\n#define __write_only\n#define __read_only\n\nstatic inline int get_group_id_fn(int block_dim0, int block_dim1, int block_dim2, int d) {\n  switch (d) {\n    case 0: d = block_dim0; break;\n    case 1: d = block_dim1; break;\n    case 2: d = block_dim2; break;\n  }\n  switch (d) {\n    case 0: return blockIdx.x;\n    case 1: return blockIdx.y;\n    case 2: return blockIdx.z;\n    default: return 0;\n  }\n}\n#define get_group_id(d) get_group_id_fn(block_dim0, block_dim1, block_dim2, d)\n\nstatic inline int get_num_groups_fn(int block_dim0, int block_dim1, int block_dim2, int d) {\n  switch (d) {\n    case 0: d = block_dim0; break;\n    case 1: d = block_dim1; break;\n    case 2: d = block_dim2; break;\n  }\n  switch(d) {\n    case 0: return gridDim.x;\n    case 1: return gridDim.y;\n    case 2: return gridDim.z;\n    default: return 0;\n  }\n}\n#define get_num_groups(d) get_num_groups_fn(block_dim0, block_dim1, block_dim2, d)\n\nstatic inline int get_local_id(int d) {\n  switch (d) {\n    case 0: return threadIdx.x;\n    case 1: return threadIdx.y;\n    case 2: return threadIdx.z;\n    default: return 0;\n  }\n}\n\nstatic inline int get_local_size(int d) {\n  switch (d) {\n    case 0: return blockDim.x;\n    case 1: return blockDim.y;\n    case 2: return blockDim.z;\n    default: return 0;\n  }\n}\n\nstatic inline int get_global_id_fn(int block_dim0, int block_dim1, int block_dim2, int d) {\n  return get_group_id(d) * get_local_size(d) + get_local_id(d);\n}\n#define get_global_id(d) get_global_id_fn(block_dim0,",
            " block_dim1, block_dim2, d)\n\nstatic inline int get_global_size(int block_dim0, int block_dim1, int block_dim2, int d) {\n  return get_num_groups(d) * get_local_size(d);\n}\n\n#define CLK_LOCAL_MEM_FENCE 1\n#define CLK_GLOBAL_MEM_FENCE 2\nstatic inline void barrier(int x) {\n  __syncthreads();\n}\nstatic inline void mem_fence_local() {\n  __threadfence_block();\n}\nstatic inline void mem_fence_global() {\n  __threadfence();\n}\n\n#define NAN (0.0/0.0)\n#define INFINITY (1.0/0.0)\nextern volatile __shared__ unsigned char shared_mem[];\n// Start of half.h.\n\n// Conversion functions are from http://half.sourceforge.net/, but\n// translated to C.\n//\n// Copyright (c) 2012-2021 Christian Rau\n//\n// Permission is hereby granted, free of charge, to any person obtaining a copy\n// of this software and associated documentation files (the \"Software\"), to deal\n// in the Software without restriction, including without limitation the rights\n// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n// copies of the Software, and to permit persons to whom the Software is\n// furnished to do so, subject to the following conditions:\n//\n// The above copyright notice and this permission notice shall be included in\n// all copies or substantial portions of the Software.\n//\n// THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN\n// THE SOFTWARE.\n\n#ifndef __OPENCL_VERSION__\n#define __constant\n#endif\n\n__constant static const uint16_t base_table[512] = {\n  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,\n  0x0000, 0x00",
            "00, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,\n  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,\n  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,\n  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,\n  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,\n  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0002, 0x0004, 0x0008, 0x0010, 0x0020, 0x0040, 0x0080, 0x0100,\n  0x0200, 0x0400, 0x0800, 0x0C00, 0x1000, 0x1400, 0x1800, 0x1C00, 0x2000, 0x2400, 0x2800, 0x2C00, 0x3000, 0x3400, 0x3800, 0x3C00,\n  0x4000, 0x4400, 0x4800, 0x4C00, 0x5000, 0x5400, 0x5800, 0x5C00, 0x6000, 0x6400, 0x6800, 0x6C00, 0x7000, 0x7400, 0x7800, 0x7C00,\n  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,\n  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,\n  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,\n  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,\n  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,\n  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,\n  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,\n  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000",
            ", 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,\n  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,\n  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,\n  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,\n  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,\n  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,\n  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8001, 0x8002, 0x8004, 0x8008, 0x8010, 0x8020, 0x8040, 0x8080, 0x8100,\n  0x8200, 0x8400, 0x8800, 0x8C00, 0x9000, 0x9400, 0x9800, 0x9C00, 0xA000, 0xA400, 0xA800, 0xAC00, 0xB000, 0xB400, 0xB800, 0xBC00,\n  0xC000, 0xC400, 0xC800, 0xCC00, 0xD000, 0xD400, 0xD800, 0xDC00, 0xE000, 0xE400, 0xE800, 0xEC00, 0xF000, 0xF400, 0xF800, 0xFC00,\n  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,\n  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,\n  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,\n  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,\n  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,\n  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,\n  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, ",
            "0xFC00, 0xFC00 };\n\n__constant static const unsigned char shift_table[512] = {\n  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,\n  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,\n  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,\n  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,\n  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,\n  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,\n  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,\n  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13,\n  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,\n  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,\n  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,\n  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,\n  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,\n  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,\n  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, ",
            "24, 24, 24, 24, 24, 24, 24,\n  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13 };\n\n__constant static const uint32_t mantissa_table[2048] = {\n  0x00000000, 0x33800000, 0x34000000, 0x34400000, 0x34800000, 0x34A00000, 0x34C00000, 0x34E00000, 0x35000000, 0x35100000, 0x35200000, 0x35300000, 0x35400000, 0x35500000, 0x35600000, 0x35700000,\n  0x35800000, 0x35880000, 0x35900000, 0x35980000, 0x35A00000, 0x35A80000, 0x35B00000, 0x35B80000, 0x35C00000, 0x35C80000, 0x35D00000, 0x35D80000, 0x35E00000, 0x35E80000, 0x35F00000, 0x35F80000,\n  0x36000000, 0x36040000, 0x36080000, 0x360C0000, 0x36100000, 0x36140000, 0x36180000, 0x361C0000, 0x36200000, 0x36240000, 0x36280000, 0x362C0000, 0x36300000, 0x36340000, 0x36380000, 0x363C0000,\n  0x36400000, 0x36440000, 0x36480000, 0x364C0000, 0x36500000, 0x36540000, 0x36580000, 0x365C0000, 0x36600000, 0x36640000, 0x36680000, 0x366C0000, 0x36700000, 0x36740000, 0x36780000, 0x367C0000,\n  0x36800000, 0x36820000, 0x36840000, 0x36860000, 0x36880000, 0x368A0000, 0x368C0000, 0x368E0000, 0x36900000, 0x36920000, 0x36940000, 0x36960000, 0x36980000, 0x369A0000, 0x369C0000, 0x369E0000,\n  0x36A00000, 0x36A20000, 0x36A40000, 0x36A60000, 0x36A80000, 0x36AA0000, 0x36AC0000, 0x36AE0000, 0x36B00000, 0x36B20000, 0x36B40000, 0x36B60000, 0x36B80000, 0x36BA0000, 0x36BC0000, 0x36BE0000,\n  0x36C00000, 0x36C20000, 0x36C40000, 0x36C60000, 0x36C80000, 0x36CA0000, 0x36CC0000, 0x36CE0000, 0x36D00000, 0x36D20000, 0x36D40000, 0x36D60000, 0x36D80000, 0x36DA0000, 0x36DC0000, 0x36DE0000,\n  0x36E00000, 0x36E20000, 0x36E40000, 0x36E60000, 0x36E80000, 0x36EA0000, 0x36EC0000, 0x36EE0000, 0x36F00000, 0x36F20000, 0x36F40000, 0x36F60000, 0x36F80000, 0x36FA0000, 0x36FC0000, 0x36FE0000,\n  0x37000000, 0x37010000, 0x37020000, 0x37030000, 0x37040000, 0x37050000, 0x37060000, 0x37070000, 0x37080000, 0x37090000, 0x370A0000, 0x370B0000, 0x370C0000, 0x370D0000, 0x370E0000, 0x370F0000,\n  0x37100000, 0x37110000, 0x3712000",
            "0, 0x37130000, 0x37140000, 0x37150000, 0x37160000, 0x37170000, 0x37180000, 0x37190000, 0x371A0000, 0x371B0000, 0x371C0000, 0x371D0000, 0x371E0000, 0x371F0000,\n  0x37200000, 0x37210000, 0x37220000, 0x37230000, 0x37240000, 0x37250000, 0x37260000, 0x37270000, 0x37280000, 0x37290000, 0x372A0000, 0x372B0000, 0x372C0000, 0x372D0000, 0x372E0000, 0x372F0000,\n  0x37300000, 0x37310000, 0x37320000, 0x37330000, 0x37340000, 0x37350000, 0x37360000, 0x37370000, 0x37380000, 0x37390000, 0x373A0000, 0x373B0000, 0x373C0000, 0x373D0000, 0x373E0000, 0x373F0000,\n  0x37400000, 0x37410000, 0x37420000, 0x37430000, 0x37440000, 0x37450000, 0x37460000, 0x37470000, 0x37480000, 0x37490000, 0x374A0000, 0x374B0000, 0x374C0000, 0x374D0000, 0x374E0000, 0x374F0000,\n  0x37500000, 0x37510000, 0x37520000, 0x37530000, 0x37540000, 0x37550000, 0x37560000, 0x37570000, 0x37580000, 0x37590000, 0x375A0000, 0x375B0000, 0x375C0000, 0x375D0000, 0x375E0000, 0x375F0000,\n  0x37600000, 0x37610000, 0x37620000, 0x37630000, 0x37640000, 0x37650000, 0x37660000, 0x37670000, 0x37680000, 0x37690000, 0x376A0000, 0x376B0000, 0x376C0000, 0x376D0000, 0x376E0000, 0x376F0000,\n  0x37700000, 0x37710000, 0x37720000, 0x37730000, 0x37740000, 0x37750000, 0x37760000, 0x37770000, 0x37780000, 0x37790000, 0x377A0000, 0x377B0000, 0x377C0000, 0x377D0000, 0x377E0000, 0x377F0000,\n  0x37800000, 0x37808000, 0x37810000, 0x37818000, 0x37820000, 0x37828000, 0x37830000, 0x37838000, 0x37840000, 0x37848000, 0x37850000, 0x37858000, 0x37860000, 0x37868000, 0x37870000, 0x37878000,\n  0x37880000, 0x37888000, 0x37890000, 0x37898000, 0x378A0000, 0x378A8000, 0x378B0000, 0x378B8000, 0x378C0000, 0x378C8000, 0x378D0000, 0x378D8000, 0x378E0000, 0x378E8000, 0x378F0000, 0x378F8000,\n  0x37900000, 0x37908000, 0x37910000, 0x37918000, 0x37920000, 0x37928000, 0x37930000, 0x37938000, 0x37940000, 0x37948000, 0x37950000, 0x37958000, 0x37960000, 0x37968000, 0x37970000, 0x37978000,\n  0x37980000, 0x37988000, 0x37990000, 0x37998000, 0x379A0000, 0x379A8000, 0x379B0000, 0x379B800",
            "0, 0x379C0000, 0x379C8000, 0x379D0000, 0x379D8000, 0x379E0000, 0x379E8000, 0x379F0000, 0x379F8000,\n  0x37A00000, 0x37A08000, 0x37A10000, 0x37A18000, 0x37A20000, 0x37A28000, 0x37A30000, 0x37A38000, 0x37A40000, 0x37A48000, 0x37A50000, 0x37A58000, 0x37A60000, 0x37A68000, 0x37A70000, 0x37A78000,\n  0x37A80000, 0x37A88000, 0x37A90000, 0x37A98000, 0x37AA0000, 0x37AA8000, 0x37AB0000, 0x37AB8000, 0x37AC0000, 0x37AC8000, 0x37AD0000, 0x37AD8000, 0x37AE0000, 0x37AE8000, 0x37AF0000, 0x37AF8000,\n  0x37B00000, 0x37B08000, 0x37B10000, 0x37B18000, 0x37B20000, 0x37B28000, 0x37B30000, 0x37B38000, 0x37B40000, 0x37B48000, 0x37B50000, 0x37B58000, 0x37B60000, 0x37B68000, 0x37B70000, 0x37B78000,\n  0x37B80000, 0x37B88000, 0x37B90000, 0x37B98000, 0x37BA0000, 0x37BA8000, 0x37BB0000, 0x37BB8000, 0x37BC0000, 0x37BC8000, 0x37BD0000, 0x37BD8000, 0x37BE0000, 0x37BE8000, 0x37BF0000, 0x37BF8000,\n  0x37C00000, 0x37C08000, 0x37C10000, 0x37C18000, 0x37C20000, 0x37C28000, 0x37C30000, 0x37C38000, 0x37C40000, 0x37C48000, 0x37C50000, 0x37C58000, 0x37C60000, 0x37C68000, 0x37C70000, 0x37C78000,\n  0x37C80000, 0x37C88000, 0x37C90000, 0x37C98000, 0x37CA0000, 0x37CA8000, 0x37CB0000, 0x37CB8000, 0x37CC0000, 0x37CC8000, 0x37CD0000, 0x37CD8000, 0x37CE0000, 0x37CE8000, 0x37CF0000, 0x37CF8000,\n  0x37D00000, 0x37D08000, 0x37D10000, 0x37D18000, 0x37D20000, 0x37D28000, 0x37D30000, 0x37D38000, 0x37D40000, 0x37D48000, 0x37D50000, 0x37D58000, 0x37D60000, 0x37D68000, 0x37D70000, 0x37D78000,\n  0x37D80000, 0x37D88000, 0x37D90000, 0x37D98000, 0x37DA0000, 0x37DA8000, 0x37DB0000, 0x37DB8000, 0x37DC0000, 0x37DC8000, 0x37DD0000, 0x37DD8000, 0x37DE0000, 0x37DE8000, 0x37DF0000, 0x37DF8000,\n  0x37E00000, 0x37E08000, 0x37E10000, 0x37E18000, 0x37E20000, 0x37E28000, 0x37E30000, 0x37E38000, 0x37E40000, 0x37E48000, 0x37E50000, 0x37E58000, 0x37E60000, 0x37E68000, 0x37E70000, 0x37E78000,\n  0x37E80000, 0x37E88000, 0x37E90000, 0x37E98000, 0x37EA0000, 0x37EA8000, 0x37EB0000, 0x37EB8000, 0x37EC0000, 0x37EC8000, 0x37ED0000, 0x37ED8000, 0x37EE000",
            "0, 0x37EE8000, 0x37EF0000, 0x37EF8000,\n  0x37F00000, 0x37F08000, 0x37F10000, 0x37F18000, 0x37F20000, 0x37F28000, 0x37F30000, 0x37F38000, 0x37F40000, 0x37F48000, 0x37F50000, 0x37F58000, 0x37F60000, 0x37F68000, 0x37F70000, 0x37F78000,\n  0x37F80000, 0x37F88000, 0x37F90000, 0x37F98000, 0x37FA0000, 0x37FA8000, 0x37FB0000, 0x37FB8000, 0x37FC0000, 0x37FC8000, 0x37FD0000, 0x37FD8000, 0x37FE0000, 0x37FE8000, 0x37FF0000, 0x37FF8000,\n  0x38000000, 0x38004000, 0x38008000, 0x3800C000, 0x38010000, 0x38014000, 0x38018000, 0x3801C000, 0x38020000, 0x38024000, 0x38028000, 0x3802C000, 0x38030000, 0x38034000, 0x38038000, 0x3803C000,\n  0x38040000, 0x38044000, 0x38048000, 0x3804C000, 0x38050000, 0x38054000, 0x38058000, 0x3805C000, 0x38060000, 0x38064000, 0x38068000, 0x3806C000, 0x38070000, 0x38074000, 0x38078000, 0x3807C000,\n  0x38080000, 0x38084000, 0x38088000, 0x3808C000, 0x38090000, 0x38094000, 0x38098000, 0x3809C000, 0x380A0000, 0x380A4000, 0x380A8000, 0x380AC000, 0x380B0000, 0x380B4000, 0x380B8000, 0x380BC000,\n  0x380C0000, 0x380C4000, 0x380C8000, 0x380CC000, 0x380D0000, 0x380D4000, 0x380D8000, 0x380DC000, 0x380E0000, 0x380E4000, 0x380E8000, 0x380EC000, 0x380F0000, 0x380F4000, 0x380F8000, 0x380FC000,\n  0x38100000, 0x38104000, 0x38108000, 0x3810C000, 0x38110000, 0x38114000, 0x38118000, 0x3811C000, 0x38120000, 0x38124000, 0x38128000, 0x3812C000, 0x38130000, 0x38134000, 0x38138000, 0x3813C000,\n  0x38140000, 0x38144000, 0x38148000, 0x3814C000, 0x38150000, 0x38154000, 0x38158000, 0x3815C000, 0x38160000, 0x38164000, 0x38168000, 0x3816C000, 0x38170000, 0x38174000, 0x38178000, 0x3817C000,\n  0x38180000, 0x38184000, 0x38188000, 0x3818C000, 0x38190000, 0x38194000, 0x38198000, 0x3819C000, 0x381A0000, 0x381A4000, 0x381A8000, 0x381AC000, 0x381B0000, 0x381B4000, 0x381B8000, 0x381BC000,\n  0x381C0000, 0x381C4000, 0x381C8000, 0x381CC000, 0x381D0000, 0x381D4000, 0x381D8000, 0x381DC000, 0x381E0000, 0x381E4000, 0x381E8000, 0x381EC000, 0x381F0000, 0x381F4000, 0x381F8000, 0x381FC000,\n  0x38200000, 0x38204",
            "000, 0x38208000, 0x3820C000, 0x38210000, 0x38214000, 0x38218000, 0x3821C000, 0x38220000, 0x38224000, 0x38228000, 0x3822C000, 0x38230000, 0x38234000, 0x38238000, 0x3823C000,\n  0x38240000, 0x38244000, 0x38248000, 0x3824C000, 0x38250000, 0x38254000, 0x38258000, 0x3825C000, 0x38260000, 0x38264000, 0x38268000, 0x3826C000, 0x38270000, 0x38274000, 0x38278000, 0x3827C000,\n  0x38280000, 0x38284000, 0x38288000, 0x3828C000, 0x38290000, 0x38294000, 0x38298000, 0x3829C000, 0x382A0000, 0x382A4000, 0x382A8000, 0x382AC000, 0x382B0000, 0x382B4000, 0x382B8000, 0x382BC000,\n  0x382C0000, 0x382C4000, 0x382C8000, 0x382CC000, 0x382D0000, 0x382D4000, 0x382D8000, 0x382DC000, 0x382E0000, 0x382E4000, 0x382E8000, 0x382EC000, 0x382F0000, 0x382F4000, 0x382F8000, 0x382FC000,\n  0x38300000, 0x38304000, 0x38308000, 0x3830C000, 0x38310000, 0x38314000, 0x38318000, 0x3831C000, 0x38320000, 0x38324000, 0x38328000, 0x3832C000, 0x38330000, 0x38334000, 0x38338000, 0x3833C000,\n  0x38340000, 0x38344000, 0x38348000, 0x3834C000, 0x38350000, 0x38354000, 0x38358000, 0x3835C000, 0x38360000, 0x38364000, 0x38368000, 0x3836C000, 0x38370000, 0x38374000, 0x38378000, 0x3837C000,\n  0x38380000, 0x38384000, 0x38388000, 0x3838C000, 0x38390000, 0x38394000, 0x38398000, 0x3839C000, 0x383A0000, 0x383A4000, 0x383A8000, 0x383AC000, 0x383B0000, 0x383B4000, 0x383B8000, 0x383BC000,\n  0x383C0000, 0x383C4000, 0x383C8000, 0x383CC000, 0x383D0000, 0x383D4000, 0x383D8000, 0x383DC000, 0x383E0000, 0x383E4000, 0x383E8000, 0x383EC000, 0x383F0000, 0x383F4000, 0x383F8000, 0x383FC000,\n  0x38400000, 0x38404000, 0x38408000, 0x3840C000, 0x38410000, 0x38414000, 0x38418000, 0x3841C000, 0x38420000, 0x38424000, 0x38428000, 0x3842C000, 0x38430000, 0x38434000, 0x38438000, 0x3843C000,\n  0x38440000, 0x38444000, 0x38448000, 0x3844C000, 0x38450000, 0x38454000, 0x38458000, 0x3845C000, 0x38460000, 0x38464000, 0x38468000, 0x3846C000, 0x38470000, 0x38474000, 0x38478000, 0x3847C000,\n  0x38480000, 0x38484000, 0x38488000, 0x3848C000, 0x38490000, 0x38494000, 0x38498",
            "000, 0x3849C000, 0x384A0000, 0x384A4000, 0x384A8000, 0x384AC000, 0x384B0000, 0x384B4000, 0x384B8000, 0x384BC000,\n  0x384C0000, 0x384C4000, 0x384C8000, 0x384CC000, 0x384D0000, 0x384D4000, 0x384D8000, 0x384DC000, 0x384E0000, 0x384E4000, 0x384E8000, 0x384EC000, 0x384F0000, 0x384F4000, 0x384F8000, 0x384FC000,\n  0x38500000, 0x38504000, 0x38508000, 0x3850C000, 0x38510000, 0x38514000, 0x38518000, 0x3851C000, 0x38520000, 0x38524000, 0x38528000, 0x3852C000, 0x38530000, 0x38534000, 0x38538000, 0x3853C000,\n  0x38540000, 0x38544000, 0x38548000, 0x3854C000, 0x38550000, 0x38554000, 0x38558000, 0x3855C000, 0x38560000, 0x38564000, 0x38568000, 0x3856C000, 0x38570000, 0x38574000, 0x38578000, 0x3857C000,\n  0x38580000, 0x38584000, 0x38588000, 0x3858C000, 0x38590000, 0x38594000, 0x38598000, 0x3859C000, 0x385A0000, 0x385A4000, 0x385A8000, 0x385AC000, 0x385B0000, 0x385B4000, 0x385B8000, 0x385BC000,\n  0x385C0000, 0x385C4000, 0x385C8000, 0x385CC000, 0x385D0000, 0x385D4000, 0x385D8000, 0x385DC000, 0x385E0000, 0x385E4000, 0x385E8000, 0x385EC000, 0x385F0000, 0x385F4000, 0x385F8000, 0x385FC000,\n  0x38600000, 0x38604000, 0x38608000, 0x3860C000, 0x38610000, 0x38614000, 0x38618000, 0x3861C000, 0x38620000, 0x38624000, 0x38628000, 0x3862C000, 0x38630000, 0x38634000, 0x38638000, 0x3863C000,\n  0x38640000, 0x38644000, 0x38648000, 0x3864C000, 0x38650000, 0x38654000, 0x38658000, 0x3865C000, 0x38660000, 0x38664000, 0x38668000, 0x3866C000, 0x38670000, 0x38674000, 0x38678000, 0x3867C000,\n  0x38680000, 0x38684000, 0x38688000, 0x3868C000, 0x38690000, 0x38694000, 0x38698000, 0x3869C000, 0x386A0000, 0x386A4000, 0x386A8000, 0x386AC000, 0x386B0000, 0x386B4000, 0x386B8000, 0x386BC000,\n  0x386C0000, 0x386C4000, 0x386C8000, 0x386CC000, 0x386D0000, 0x386D4000, 0x386D8000, 0x386DC000, 0x386E0000, 0x386E4000, 0x386E8000, 0x386EC000, 0x386F0000, 0x386F4000, 0x386F8000, 0x386FC000,\n  0x38700000, 0x38704000, 0x38708000, 0x3870C000, 0x38710000, 0x38714000, 0x38718000, 0x3871C000, 0x38720000, 0x38724000, 0x38728000, 0x3872C",
            "000, 0x38730000, 0x38734000, 0x38738000, 0x3873C000,\n  0x38740000, 0x38744000, 0x38748000, 0x3874C000, 0x38750000, 0x38754000, 0x38758000, 0x3875C000, 0x38760000, 0x38764000, 0x38768000, 0x3876C000, 0x38770000, 0x38774000, 0x38778000, 0x3877C000,\n  0x38780000, 0x38784000, 0x38788000, 0x3878C000, 0x38790000, 0x38794000, 0x38798000, 0x3879C000, 0x387A0000, 0x387A4000, 0x387A8000, 0x387AC000, 0x387B0000, 0x387B4000, 0x387B8000, 0x387BC000,\n  0x387C0000, 0x387C4000, 0x387C8000, 0x387CC000, 0x387D0000, 0x387D4000, 0x387D8000, 0x387DC000, 0x387E0000, 0x387E4000, 0x387E8000, 0x387EC000, 0x387F0000, 0x387F4000, 0x387F8000, 0x387FC000,\n  0x38000000, 0x38002000, 0x38004000, 0x38006000, 0x38008000, 0x3800A000, 0x3800C000, 0x3800E000, 0x38010000, 0x38012000, 0x38014000, 0x38016000, 0x38018000, 0x3801A000, 0x3801C000, 0x3801E000,\n  0x38020000, 0x38022000, 0x38024000, 0x38026000, 0x38028000, 0x3802A000, 0x3802C000, 0x3802E000, 0x38030000, 0x38032000, 0x38034000, 0x38036000, 0x38038000, 0x3803A000, 0x3803C000, 0x3803E000,\n  0x38040000, 0x38042000, 0x38044000, 0x38046000, 0x38048000, 0x3804A000, 0x3804C000, 0x3804E000, 0x38050000, 0x38052000, 0x38054000, 0x38056000, 0x38058000, 0x3805A000, 0x3805C000, 0x3805E000,\n  0x38060000, 0x38062000, 0x38064000, 0x38066000, 0x38068000, 0x3806A000, 0x3806C000, 0x3806E000, 0x38070000, 0x38072000, 0x38074000, 0x38076000, 0x38078000, 0x3807A000, 0x3807C000, 0x3807E000,\n  0x38080000, 0x38082000, 0x38084000, 0x38086000, 0x38088000, 0x3808A000, 0x3808C000, 0x3808E000, 0x38090000, 0x38092000, 0x38094000, 0x38096000, 0x38098000, 0x3809A000, 0x3809C000, 0x3809E000,\n  0x380A0000, 0x380A2000, 0x380A4000, 0x380A6000, 0x380A8000, 0x380AA000, 0x380AC000, 0x380AE000, 0x380B0000, 0x380B2000, 0x380B4000, 0x380B6000, 0x380B8000, 0x380BA000, 0x380BC000, 0x380BE000,\n  0x380C0000, 0x380C2000, 0x380C4000, 0x380C6000, 0x380C8000, 0x380CA000, 0x380CC000, 0x380CE000, 0x380D0000, 0x380D2000, 0x380D4000, 0x380D6000, 0x380D8000, 0x380DA000, 0x380DC000, 0x380DE000,\n  0x380",
            "E0000, 0x380E2000, 0x380E4000, 0x380E6000, 0x380E8000, 0x380EA000, 0x380EC000, 0x380EE000, 0x380F0000, 0x380F2000, 0x380F4000, 0x380F6000, 0x380F8000, 0x380FA000, 0x380FC000, 0x380FE000,\n  0x38100000, 0x38102000, 0x38104000, 0x38106000, 0x38108000, 0x3810A000, 0x3810C000, 0x3810E000, 0x38110000, 0x38112000, 0x38114000, 0x38116000, 0x38118000, 0x3811A000, 0x3811C000, 0x3811E000,\n  0x38120000, 0x38122000, 0x38124000, 0x38126000, 0x38128000, 0x3812A000, 0x3812C000, 0x3812E000, 0x38130000, 0x38132000, 0x38134000, 0x38136000, 0x38138000, 0x3813A000, 0x3813C000, 0x3813E000,\n  0x38140000, 0x38142000, 0x38144000, 0x38146000, 0x38148000, 0x3814A000, 0x3814C000, 0x3814E000, 0x38150000, 0x38152000, 0x38154000, 0x38156000, 0x38158000, 0x3815A000, 0x3815C000, 0x3815E000,\n  0x38160000, 0x38162000, 0x38164000, 0x38166000, 0x38168000, 0x3816A000, 0x3816C000, 0x3816E000, 0x38170000, 0x38172000, 0x38174000, 0x38176000, 0x38178000, 0x3817A000, 0x3817C000, 0x3817E000,\n  0x38180000, 0x38182000, 0x38184000, 0x38186000, 0x38188000, 0x3818A000, 0x3818C000, 0x3818E000, 0x38190000, 0x38192000, 0x38194000, 0x38196000, 0x38198000, 0x3819A000, 0x3819C000, 0x3819E000,\n  0x381A0000, 0x381A2000, 0x381A4000, 0x381A6000, 0x381A8000, 0x381AA000, 0x381AC000, 0x381AE000, 0x381B0000, 0x381B2000, 0x381B4000, 0x381B6000, 0x381B8000, 0x381BA000, 0x381BC000, 0x381BE000,\n  0x381C0000, 0x381C2000, 0x381C4000, 0x381C6000, 0x381C8000, 0x381CA000, 0x381CC000, 0x381CE000, 0x381D0000, 0x381D2000, 0x381D4000, 0x381D6000, 0x381D8000, 0x381DA000, 0x381DC000, 0x381DE000,\n  0x381E0000, 0x381E2000, 0x381E4000, 0x381E6000, 0x381E8000, 0x381EA000, 0x381EC000, 0x381EE000, 0x381F0000, 0x381F2000, 0x381F4000, 0x381F6000, 0x381F8000, 0x381FA000, 0x381FC000, 0x381FE000,\n  0x38200000, 0x38202000, 0x38204000, 0x38206000, 0x38208000, 0x3820A000, 0x3820C000, 0x3820E000, 0x38210000, 0x38212000, 0x38214000, 0x38216000, 0x38218000, 0x3821A000, 0x3821C000, 0x3821E000,\n  0x38220000, 0x38222000, 0x38224000, 0x38226000, 0x38228000, 0x382",
            "2A000, 0x3822C000, 0x3822E000, 0x38230000, 0x38232000, 0x38234000, 0x38236000, 0x38238000, 0x3823A000, 0x3823C000, 0x3823E000,\n  0x38240000, 0x38242000, 0x38244000, 0x38246000, 0x38248000, 0x3824A000, 0x3824C000, 0x3824E000, 0x38250000, 0x38252000, 0x38254000, 0x38256000, 0x38258000, 0x3825A000, 0x3825C000, 0x3825E000,\n  0x38260000, 0x38262000, 0x38264000, 0x38266000, 0x38268000, 0x3826A000, 0x3826C000, 0x3826E000, 0x38270000, 0x38272000, 0x38274000, 0x38276000, 0x38278000, 0x3827A000, 0x3827C000, 0x3827E000,\n  0x38280000, 0x38282000, 0x38284000, 0x38286000, 0x38288000, 0x3828A000, 0x3828C000, 0x3828E000, 0x38290000, 0x38292000, 0x38294000, 0x38296000, 0x38298000, 0x3829A000, 0x3829C000, 0x3829E000,\n  0x382A0000, 0x382A2000, 0x382A4000, 0x382A6000, 0x382A8000, 0x382AA000, 0x382AC000, 0x382AE000, 0x382B0000, 0x382B2000, 0x382B4000, 0x382B6000, 0x382B8000, 0x382BA000, 0x382BC000, 0x382BE000,\n  0x382C0000, 0x382C2000, 0x382C4000, 0x382C6000, 0x382C8000, 0x382CA000, 0x382CC000, 0x382CE000, 0x382D0000, 0x382D2000, 0x382D4000, 0x382D6000, 0x382D8000, 0x382DA000, 0x382DC000, 0x382DE000,\n  0x382E0000, 0x382E2000, 0x382E4000, 0x382E6000, 0x382E8000, 0x382EA000, 0x382EC000, 0x382EE000, 0x382F0000, 0x382F2000, 0x382F4000, 0x382F6000, 0x382F8000, 0x382FA000, 0x382FC000, 0x382FE000,\n  0x38300000, 0x38302000, 0x38304000, 0x38306000, 0x38308000, 0x3830A000, 0x3830C000, 0x3830E000, 0x38310000, 0x38312000, 0x38314000, 0x38316000, 0x38318000, 0x3831A000, 0x3831C000, 0x3831E000,\n  0x38320000, 0x38322000, 0x38324000, 0x38326000, 0x38328000, 0x3832A000, 0x3832C000, 0x3832E000, 0x38330000, 0x38332000, 0x38334000, 0x38336000, 0x38338000, 0x3833A000, 0x3833C000, 0x3833E000,\n  0x38340000, 0x38342000, 0x38344000, 0x38346000, 0x38348000, 0x3834A000, 0x3834C000, 0x3834E000, 0x38350000, 0x38352000, 0x38354000, 0x38356000, 0x38358000, 0x3835A000, 0x3835C000, 0x3835E000,\n  0x38360000, 0x38362000, 0x38364000, 0x38366000, 0x38368000, 0x3836A000, 0x3836C000, 0x3836E000, 0x38370000, 0x38372000, 0x383",
            "74000, 0x38376000, 0x38378000, 0x3837A000, 0x3837C000, 0x3837E000,\n  0x38380000, 0x38382000, 0x38384000, 0x38386000, 0x38388000, 0x3838A000, 0x3838C000, 0x3838E000, 0x38390000, 0x38392000, 0x38394000, 0x38396000, 0x38398000, 0x3839A000, 0x3839C000, 0x3839E000,\n  0x383A0000, 0x383A2000, 0x383A4000, 0x383A6000, 0x383A8000, 0x383AA000, 0x383AC000, 0x383AE000, 0x383B0000, 0x383B2000, 0x383B4000, 0x383B6000, 0x383B8000, 0x383BA000, 0x383BC000, 0x383BE000,\n  0x383C0000, 0x383C2000, 0x383C4000, 0x383C6000, 0x383C8000, 0x383CA000, 0x383CC000, 0x383CE000, 0x383D0000, 0x383D2000, 0x383D4000, 0x383D6000, 0x383D8000, 0x383DA000, 0x383DC000, 0x383DE000,\n  0x383E0000, 0x383E2000, 0x383E4000, 0x383E6000, 0x383E8000, 0x383EA000, 0x383EC000, 0x383EE000, 0x383F0000, 0x383F2000, 0x383F4000, 0x383F6000, 0x383F8000, 0x383FA000, 0x383FC000, 0x383FE000,\n  0x38400000, 0x38402000, 0x38404000, 0x38406000, 0x38408000, 0x3840A000, 0x3840C000, 0x3840E000, 0x38410000, 0x38412000, 0x38414000, 0x38416000, 0x38418000, 0x3841A000, 0x3841C000, 0x3841E000,\n  0x38420000, 0x38422000, 0x38424000, 0x38426000, 0x38428000, 0x3842A000, 0x3842C000, 0x3842E000, 0x38430000, 0x38432000, 0x38434000, 0x38436000, 0x38438000, 0x3843A000, 0x3843C000, 0x3843E000,\n  0x38440000, 0x38442000, 0x38444000, 0x38446000, 0x38448000, 0x3844A000, 0x3844C000, 0x3844E000, 0x38450000, 0x38452000, 0x38454000, 0x38456000, 0x38458000, 0x3845A000, 0x3845C000, 0x3845E000,\n  0x38460000, 0x38462000, 0x38464000, 0x38466000, 0x38468000, 0x3846A000, 0x3846C000, 0x3846E000, 0x38470000, 0x38472000, 0x38474000, 0x38476000, 0x38478000, 0x3847A000, 0x3847C000, 0x3847E000,\n  0x38480000, 0x38482000, 0x38484000, 0x38486000, 0x38488000, 0x3848A000, 0x3848C000, 0x3848E000, 0x38490000, 0x38492000, 0x38494000, 0x38496000, 0x38498000, 0x3849A000, 0x3849C000, 0x3849E000,\n  0x384A0000, 0x384A2000, 0x384A4000, 0x384A6000, 0x384A8000, 0x384AA000, 0x384AC000, 0x384AE000, 0x384B0000, 0x384B2000, 0x384B4000, 0x384B6000, 0x384B8000, 0x384BA000, 0x384BC000, 0x384",
            "BE000,\n  0x384C0000, 0x384C2000, 0x384C4000, 0x384C6000, 0x384C8000, 0x384CA000, 0x384CC000, 0x384CE000, 0x384D0000, 0x384D2000, 0x384D4000, 0x384D6000, 0x384D8000, 0x384DA000, 0x384DC000, 0x384DE000,\n  0x384E0000, 0x384E2000, 0x384E4000, 0x384E6000, 0x384E8000, 0x384EA000, 0x384EC000, 0x384EE000, 0x384F0000, 0x384F2000, 0x384F4000, 0x384F6000, 0x384F8000, 0x384FA000, 0x384FC000, 0x384FE000,\n  0x38500000, 0x38502000, 0x38504000, 0x38506000, 0x38508000, 0x3850A000, 0x3850C000, 0x3850E000, 0x38510000, 0x38512000, 0x38514000, 0x38516000, 0x38518000, 0x3851A000, 0x3851C000, 0x3851E000,\n  0x38520000, 0x38522000, 0x38524000, 0x38526000, 0x38528000, 0x3852A000, 0x3852C000, 0x3852E000, 0x38530000, 0x38532000, 0x38534000, 0x38536000, 0x38538000, 0x3853A000, 0x3853C000, 0x3853E000,\n  0x38540000, 0x38542000, 0x38544000, 0x38546000, 0x38548000, 0x3854A000, 0x3854C000, 0x3854E000, 0x38550000, 0x38552000, 0x38554000, 0x38556000, 0x38558000, 0x3855A000, 0x3855C000, 0x3855E000,\n  0x38560000, 0x38562000, 0x38564000, 0x38566000, 0x38568000, 0x3856A000, 0x3856C000, 0x3856E000, 0x38570000, 0x38572000, 0x38574000, 0x38576000, 0x38578000, 0x3857A000, 0x3857C000, 0x3857E000,\n  0x38580000, 0x38582000, 0x38584000, 0x38586000, 0x38588000, 0x3858A000, 0x3858C000, 0x3858E000, 0x38590000, 0x38592000, 0x38594000, 0x38596000, 0x38598000, 0x3859A000, 0x3859C000, 0x3859E000,\n  0x385A0000, 0x385A2000, 0x385A4000, 0x385A6000, 0x385A8000, 0x385AA000, 0x385AC000, 0x385AE000, 0x385B0000, 0x385B2000, 0x385B4000, 0x385B6000, 0x385B8000, 0x385BA000, 0x385BC000, 0x385BE000,\n  0x385C0000, 0x385C2000, 0x385C4000, 0x385C6000, 0x385C8000, 0x385CA000, 0x385CC000, 0x385CE000, 0x385D0000, 0x385D2000, 0x385D4000, 0x385D6000, 0x385D8000, 0x385DA000, 0x385DC000, 0x385DE000,\n  0x385E0000, 0x385E2000, 0x385E4000, 0x385E6000, 0x385E8000, 0x385EA000, 0x385EC000, 0x385EE000, 0x385F0000, 0x385F2000, 0x385F4000, 0x385F6000, 0x385F8000, 0x385FA000, 0x385FC000, 0x385FE000,\n  0x38600000, 0x38602000, 0x38604000, 0x38606000, 0x3",
            "8608000, 0x3860A000, 0x3860C000, 0x3860E000, 0x38610000, 0x38612000, 0x38614000, 0x38616000, 0x38618000, 0x3861A000, 0x3861C000, 0x3861E000,\n  0x38620000, 0x38622000, 0x38624000, 0x38626000, 0x38628000, 0x3862A000, 0x3862C000, 0x3862E000, 0x38630000, 0x38632000, 0x38634000, 0x38636000, 0x38638000, 0x3863A000, 0x3863C000, 0x3863E000,\n  0x38640000, 0x38642000, 0x38644000, 0x38646000, 0x38648000, 0x3864A000, 0x3864C000, 0x3864E000, 0x38650000, 0x38652000, 0x38654000, 0x38656000, 0x38658000, 0x3865A000, 0x3865C000, 0x3865E000,\n  0x38660000, 0x38662000, 0x38664000, 0x38666000, 0x38668000, 0x3866A000, 0x3866C000, 0x3866E000, 0x38670000, 0x38672000, 0x38674000, 0x38676000, 0x38678000, 0x3867A000, 0x3867C000, 0x3867E000,\n  0x38680000, 0x38682000, 0x38684000, 0x38686000, 0x38688000, 0x3868A000, 0x3868C000, 0x3868E000, 0x38690000, 0x38692000, 0x38694000, 0x38696000, 0x38698000, 0x3869A000, 0x3869C000, 0x3869E000,\n  0x386A0000, 0x386A2000, 0x386A4000, 0x386A6000, 0x386A8000, 0x386AA000, 0x386AC000, 0x386AE000, 0x386B0000, 0x386B2000, 0x386B4000, 0x386B6000, 0x386B8000, 0x386BA000, 0x386BC000, 0x386BE000,\n  0x386C0000, 0x386C2000, 0x386C4000, 0x386C6000, 0x386C8000, 0x386CA000, 0x386CC000, 0x386CE000, 0x386D0000, 0x386D2000, 0x386D4000, 0x386D6000, 0x386D8000, 0x386DA000, 0x386DC000, 0x386DE000,\n  0x386E0000, 0x386E2000, 0x386E4000, 0x386E6000, 0x386E8000, 0x386EA000, 0x386EC000, 0x386EE000, 0x386F0000, 0x386F2000, 0x386F4000, 0x386F6000, 0x386F8000, 0x386FA000, 0x386FC000, 0x386FE000,\n  0x38700000, 0x38702000, 0x38704000, 0x38706000, 0x38708000, 0x3870A000, 0x3870C000, 0x3870E000, 0x38710000, 0x38712000, 0x38714000, 0x38716000, 0x38718000, 0x3871A000, 0x3871C000, 0x3871E000,\n  0x38720000, 0x38722000, 0x38724000, 0x38726000, 0x38728000, 0x3872A000, 0x3872C000, 0x3872E000, 0x38730000, 0x38732000, 0x38734000, 0x38736000, 0x38738000, 0x3873A000, 0x3873C000, 0x3873E000,\n  0x38740000, 0x38742000, 0x38744000, 0x38746000, 0x38748000, 0x3874A000, 0x3874C000, 0x3874E000, 0x38750000, 0x3",
            "8752000, 0x38754000, 0x38756000, 0x38758000, 0x3875A000, 0x3875C000, 0x3875E000,\n  0x38760000, 0x38762000, 0x38764000, 0x38766000, 0x38768000, 0x3876A000, 0x3876C000, 0x3876E000, 0x38770000, 0x38772000, 0x38774000, 0x38776000, 0x38778000, 0x3877A000, 0x3877C000, 0x3877E000,\n  0x38780000, 0x38782000, 0x38784000, 0x38786000, 0x38788000, 0x3878A000, 0x3878C000, 0x3878E000, 0x38790000, 0x38792000, 0x38794000, 0x38796000, 0x38798000, 0x3879A000, 0x3879C000, 0x3879E000,\n  0x387A0000, 0x387A2000, 0x387A4000, 0x387A6000, 0x387A8000, 0x387AA000, 0x387AC000, 0x387AE000, 0x387B0000, 0x387B2000, 0x387B4000, 0x387B6000, 0x387B8000, 0x387BA000, 0x387BC000, 0x387BE000,\n  0x387C0000, 0x387C2000, 0x387C4000, 0x387C6000, 0x387C8000, 0x387CA000, 0x387CC000, 0x387CE000, 0x387D0000, 0x387D2000, 0x387D4000, 0x387D6000, 0x387D8000, 0x387DA000, 0x387DC000, 0x387DE000,\n  0x387E0000, 0x387E2000, 0x387E4000, 0x387E6000, 0x387E8000, 0x387EA000, 0x387EC000, 0x387EE000, 0x387F0000, 0x387F2000, 0x387F4000, 0x387F6000, 0x387F8000, 0x387FA000, 0x387FC000, 0x387FE000 };\n__constant static const uint32_t exponent_table[64] = {\n  0x00000000, 0x00800000, 0x01000000, 0x01800000, 0x02000000, 0x02800000, 0x03000000, 0x03800000, 0x04000000, 0x04800000, 0x05000000, 0x05800000, 0x06000000, 0x06800000, 0x07000000, 0x07800000,\n  0x08000000, 0x08800000, 0x09000000, 0x09800000, 0x0A000000, 0x0A800000, 0x0B000000, 0x0B800000, 0x0C000000, 0x0C800000, 0x0D000000, 0x0D800000, 0x0E000000, 0x0E800000, 0x0F000000, 0x47800000,\n  0x80000000, 0x80800000, 0x81000000, 0x81800000, 0x82000000, 0x82800000, 0x83000000, 0x83800000, 0x84000000, 0x84800000, 0x85000000, 0x85800000, 0x86000000, 0x86800000, 0x87000000, 0x87800000,\n  0x88000000, 0x88800000, 0x89000000, 0x89800000, 0x8A000000, 0x8A800000, 0x8B000000, 0x8B800000, 0x8C000000, 0x8C800000, 0x8D000000, 0x8D800000, 0x8E000000, 0x8E800000, 0x8F000000, 0xC7800000 };\n__constant static const unsigned short offset_table[64] = {\n  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, ",
            "1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,\n  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024 };\n\nstatic uint16_t float2halfbits(float value) {\n  union { float x; uint32_t y; } u;\n  u.x = value;\n  uint32_t bits = u.y;\n\n  uint16_t hbits = base_table[bits>>23] + (uint16_t)((bits&0x7FFFFF)>>shift_table[bits>>23]);;\n\n  return hbits;\n}\n\nstatic float halfbits2float(uint16_t value) {\n  uint32_t bits = mantissa_table[offset_table[value>>10]+(value&0x3FF)] + exponent_table[value>>10];\n\n  union { uint32_t x; float y; } u;\n  u.x = bits;\n  return u.y;\n}\n\n// End of half.h.\n// Start of scalar.h.\n\n// Implementation of the primitive scalar operations.  Very\n// repetitive.  This code is inserted directly into both CUDA and\n// OpenCL programs, as well as the CPU code, so it has some #ifdefs to\n// work everywhere.  Some operations are defined as macros because\n// this allows us to use them as constant expressions in things like\n// array sizes and static initialisers.\n\n// Some of the #ifdefs are because OpenCL uses type-generic functions\n// for some operations (e.g. sqrt), while C and CUDA sensibly use\n// distinct functions for different precisions (e.g. sqrtf() and\n// sqrt()).  This is quite annoying.  Due to C's unfortunate casting\n// rules, it is also really easy to accidentally implement\n// floating-point functions in the wrong precision, so be careful.\n\n// Double-precision definitions are only included if the preprocessor\n// macro FUTHARK_F64_ENABLED is set.\n\nstatic inline uint8_t add8(uint8_t x, uint8_t y) {\n  return x + y;\n}\n\nstatic inline uint16_t add16(uint16_t x, uint16_t y) {\n  return x + y;\n}\n\nstatic inline uint32_t add32(uint32_t x, uint32_t y) {\n  return x + y;\n}\n\nstatic inline uint64_t add64(uint64_t x, uint64_t y) {\n  return x + y;\n}\n\nstati",
            "c inline uint8_t sub8(uint8_t x, uint8_t y) {\n  return x - y;\n}\n\nstatic inline uint16_t sub16(uint16_t x, uint16_t y) {\n  return x - y;\n}\n\nstatic inline uint32_t sub32(uint32_t x, uint32_t y) {\n  return x - y;\n}\n\nstatic inline uint64_t sub64(uint64_t x, uint64_t y) {\n  return x - y;\n}\n\nstatic inline uint8_t mul8(uint8_t x, uint8_t y) {\n  return x * y;\n}\n\nstatic inline uint16_t mul16(uint16_t x, uint16_t y) {\n  return x * y;\n}\n\nstatic inline uint32_t mul32(uint32_t x, uint32_t y) {\n  return x * y;\n}\n\nstatic inline uint64_t mul64(uint64_t x, uint64_t y) {\n  return x * y;\n}\n\nstatic inline uint8_t udiv8(uint8_t x, uint8_t y) {\n  return x / y;\n}\n\nstatic inline uint16_t udiv16(uint16_t x, uint16_t y) {\n  return x / y;\n}\n\nstatic inline uint32_t udiv32(uint32_t x, uint32_t y) {\n  return x / y;\n}\n\nstatic inline uint64_t udiv64(uint64_t x, uint64_t y) {\n  return x / y;\n}\n\nstatic inline uint8_t udiv_up8(uint8_t x, uint8_t y) {\n  return (x + y - 1) / y;\n}\n\nstatic inline uint16_t udiv_up16(uint16_t x, uint16_t y) {\n  return (x + y - 1) / y;\n}\n\nstatic inline uint32_t udiv_up32(uint32_t x, uint32_t y) {\n  return (x + y - 1) / y;\n}\n\nstatic inline uint64_t udiv_up64(uint64_t x, uint64_t y) {\n  return (x + y - 1) / y;\n}\n\nstatic inline uint8_t umod8(uint8_t x, uint8_t y) {\n  return x % y;\n}\n\nstatic inline uint16_t umod16(uint16_t x, uint16_t y) {\n  return x % y;\n}\n\nstatic inline uint32_t umod32(uint32_t x, uint32_t y) {\n  return x % y;\n}\n\nstatic inline uint64_t umod64(uint64_t x, uint64_t y) {\n  return x % y;\n}\n\nstatic inline uint8_t udiv_safe8(uint8_t x, uint8_t y) {\n  return y == 0 ? 0 : x / y;\n}\n\nstatic inline uint16_t udiv_safe16(uint16_t x, uint16_t y) {\n  return y == 0 ? 0 : x / y;\n}\n\nstatic inline uint32_t udiv_safe32(uint32_t x, uint32_t y) {\n  return y == 0 ? 0 : x / y;\n}\n\nstatic inline uint64_t udiv_safe64(uint64_t x, uint64_t y) {\n  return y == 0 ? 0 : x / y;\n}\n\nstatic inline uint8_t udiv_up_safe8(uint8_t x, uint8_t y) {\n  return y == 0 ? 0 : (x + y - 1) / y;\n}\n\nstatic inli",
            "ne uint16_t udiv_up_safe16(uint16_t x, uint16_t y) {\n  return y == 0 ? 0 : (x + y - 1) / y;\n}\n\nstatic inline uint32_t udiv_up_safe32(uint32_t x, uint32_t y) {\n  return y == 0 ? 0 : (x + y - 1) / y;\n}\n\nstatic inline uint64_t udiv_up_safe64(uint64_t x, uint64_t y) {\n  return y == 0 ? 0 : (x + y - 1) / y;\n}\n\nstatic inline uint8_t umod_safe8(uint8_t x, uint8_t y) {\n  return y == 0 ? 0 : x % y;\n}\n\nstatic inline uint16_t umod_safe16(uint16_t x, uint16_t y) {\n  return y == 0 ? 0 : x % y;\n}\n\nstatic inline uint32_t umod_safe32(uint32_t x, uint32_t y) {\n  return y == 0 ? 0 : x % y;\n}\n\nstatic inline uint64_t umod_safe64(uint64_t x, uint64_t y) {\n  return y == 0 ? 0 : x % y;\n}\n\nstatic inline int8_t sdiv8(int8_t x, int8_t y) {\n  int8_t q = x / y;\n  int8_t r = x % y;\n\n  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);\n}\n\nstatic inline int16_t sdiv16(int16_t x, int16_t y) {\n  int16_t q = x / y;\n  int16_t r = x % y;\n\n  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);\n}\n\nstatic inline int32_t sdiv32(int32_t x, int32_t y) {\n  int32_t q = x / y;\n  int32_t r = x % y;\n\n  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);\n}\n\nstatic inline int64_t sdiv64(int64_t x, int64_t y) {\n  int64_t q = x / y;\n  int64_t r = x % y;\n\n  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);\n}\n\nstatic inline int8_t sdiv_up8(int8_t x, int8_t y) {\n  return sdiv8(x + y - 1, y);\n}\n\nstatic inline int16_t sdiv_up16(int16_t x, int16_t y) {\n  return sdiv16(x + y - 1, y);\n}\n\nstatic inline int32_t sdiv_up32(int32_t x, int32_t y) {\n  return sdiv32(x + y - 1, y);\n}\n\nstatic inline int64_t sdiv_up64(int64_t x, int64_t y) {\n  return sdiv64(x + y - 1, y);\n}\n\nstatic inline int8_t smod8(int8_t x, int8_t y) {\n  int8_t r = x % y;\n\n  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);\n}\n\nstatic inline int16_t smod16(int16_t x, int16_t y) {\n  int16_t r = x % y;\n\n  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);\n}\n\nstatic inline int32_t smod32(int32_t x, int32_t y) {\n  int32_t r = x % y;\n\n  return",
            " r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);\n}\n\nstatic inline int64_t smod64(int64_t x, int64_t y) {\n  int64_t r = x % y;\n\n  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);\n}\n\nstatic inline int8_t sdiv_safe8(int8_t x, int8_t y) {\n  return y == 0 ? 0 : sdiv8(x, y);\n}\n\nstatic inline int16_t sdiv_safe16(int16_t x, int16_t y) {\n  return y == 0 ? 0 : sdiv16(x, y);\n}\n\nstatic inline int32_t sdiv_safe32(int32_t x, int32_t y) {\n  return y == 0 ? 0 : sdiv32(x, y);\n}\n\nstatic inline int64_t sdiv_safe64(int64_t x, int64_t y) {\n  return y == 0 ? 0 : sdiv64(x, y);\n}\n\nstatic inline int8_t sdiv_up_safe8(int8_t x, int8_t y) {\n  return sdiv_safe8(x + y - 1, y);\n}\n\nstatic inline int16_t sdiv_up_safe16(int16_t x, int16_t y) {\n  return sdiv_safe16(x + y - 1, y);\n}\n\nstatic inline int32_t sdiv_up_safe32(int32_t x, int32_t y) {\n  return sdiv_safe32(x + y - 1, y);\n}\n\nstatic inline int64_t sdiv_up_safe64(int64_t x, int64_t y) {\n  return sdiv_safe64(x + y - 1, y);\n}\n\nstatic inline int8_t smod_safe8(int8_t x, int8_t y) {\n  return y == 0 ? 0 : smod8(x, y);\n}\n\nstatic inline int16_t smod_safe16(int16_t x, int16_t y) {\n  return y == 0 ? 0 : smod16(x, y);\n}\n\nstatic inline int32_t smod_safe32(int32_t x, int32_t y) {\n  return y == 0 ? 0 : smod32(x, y);\n}\n\nstatic inline int64_t smod_safe64(int64_t x, int64_t y) {\n  return y == 0 ? 0 : smod64(x, y);\n}\n\nstatic inline int8_t squot8(int8_t x, int8_t y) {\n  return x / y;\n}\n\nstatic inline int16_t squot16(int16_t x, int16_t y) {\n  return x / y;\n}\n\nstatic inline int32_t squot32(int32_t x, int32_t y) {\n  return x / y;\n}\n\nstatic inline int64_t squot64(int64_t x, int64_t y) {\n  return x / y;\n}\n\nstatic inline int8_t srem8(int8_t x, int8_t y) {\n  return x % y;\n}\n\nstatic inline int16_t srem16(int16_t x, int16_t y) {\n  return x % y;\n}\n\nstatic inline int32_t srem32(int32_t x, int32_t y) {\n  return x % y;\n}\n\nstatic inline int64_t srem64(int64_t x, int64_t y) {\n  return x % y;\n}\n\nstatic inline int8_t squot_safe8(int8_t x, int8_t y)",
            " {\n  return y == 0 ? 0 : x / y;\n}\n\nstatic inline int16_t squot_safe16(int16_t x, int16_t y) {\n  return y == 0 ? 0 : x / y;\n}\n\nstatic inline int32_t squot_safe32(int32_t x, int32_t y) {\n  return y == 0 ? 0 : x / y;\n}\n\nstatic inline int64_t squot_safe64(int64_t x, int64_t y) {\n  return y == 0 ? 0 : x / y;\n}\n\nstatic inline int8_t srem_safe8(int8_t x, int8_t y) {\n  return y == 0 ? 0 : x % y;\n}\n\nstatic inline int16_t srem_safe16(int16_t x, int16_t y) {\n  return y == 0 ? 0 : x % y;\n}\n\nstatic inline int32_t srem_safe32(int32_t x, int32_t y) {\n  return y == 0 ? 0 : x % y;\n}\n\nstatic inline int64_t srem_safe64(int64_t x, int64_t y) {\n  return y == 0 ? 0 : x % y;\n}\n\nstatic inline int8_t smin8(int8_t x, int8_t y) {\n  return x < y ? x : y;\n}\n\nstatic inline int16_t smin16(int16_t x, int16_t y) {\n  return x < y ? x : y;\n}\n\nstatic inline int32_t smin32(int32_t x, int32_t y) {\n  return x < y ? x : y;\n}\n\nstatic inline int64_t smin64(int64_t x, int64_t y) {\n  return x < y ? x : y;\n}\n\nstatic inline uint8_t umin8(uint8_t x, uint8_t y) {\n  return x < y ? x : y;\n}\n\nstatic inline uint16_t umin16(uint16_t x, uint16_t y) {\n  return x < y ? x : y;\n}\n\nstatic inline uint32_t umin32(uint32_t x, uint32_t y) {\n  return x < y ? x : y;\n}\n\nstatic inline uint64_t umin64(uint64_t x, uint64_t y) {\n  return x < y ? x : y;\n}\n\nstatic inline int8_t smax8(int8_t x, int8_t y) {\n  return x < y ? y : x;\n}\n\nstatic inline int16_t smax16(int16_t x, int16_t y) {\n  return x < y ? y : x;\n}\n\nstatic inline int32_t smax32(int32_t x, int32_t y) {\n  return x < y ? y : x;\n}\n\nstatic inline int64_t smax64(int64_t x, int64_t y) {\n  return x < y ? y : x;\n}\n\nstatic inline uint8_t umax8(uint8_t x, uint8_t y) {\n  return x < y ? y : x;\n}\n\nstatic inline uint16_t umax16(uint16_t x, uint16_t y) {\n  return x < y ? y : x;\n}\n\nstatic inline uint32_t umax32(uint32_t x, uint32_t y) {\n  return x < y ? y : x;\n}\n\nstatic inline uint64_t umax64(uint64_t x, uint64_t y) {\n  return x < y ? y : x;\n}\n\nstatic inline uint8_t shl8(uint8_t x, uint8_t y)",
            " {\n  return (uint8_t)(x << y);\n}\n\nstatic inline uint16_t shl16(uint16_t x, uint16_t y) {\n  return (uint16_t)(x << y);\n}\n\nstatic inline uint32_t shl32(uint32_t x, uint32_t y) {\n  return x << y;\n}\n\nstatic inline uint64_t shl64(uint64_t x, uint64_t y) {\n  return x << y;\n}\n\nstatic inline uint8_t lshr8(uint8_t x, uint8_t y) {\n  return x >> y;\n}\n\nstatic inline uint16_t lshr16(uint16_t x, uint16_t y) {\n  return x >> y;\n}\n\nstatic inline uint32_t lshr32(uint32_t x, uint32_t y) {\n  return x >> y;\n}\n\nstatic inline uint64_t lshr64(uint64_t x, uint64_t y) {\n  return x >> y;\n}\n\nstatic inline int8_t ashr8(int8_t x, int8_t y) {\n  return x >> y;\n}\n\nstatic inline int16_t ashr16(int16_t x, int16_t y) {\n  return x >> y;\n}\n\nstatic inline int32_t ashr32(int32_t x, int32_t y) {\n  return x >> y;\n}\n\nstatic inline int64_t ashr64(int64_t x, int64_t y) {\n  return x >> y;\n}\n\nstatic inline uint8_t and8(uint8_t x, uint8_t y) {\n  return x & y;\n}\n\nstatic inline uint16_t and16(uint16_t x, uint16_t y) {\n  return x & y;\n}\n\nstatic inline uint32_t and32(uint32_t x, uint32_t y) {\n  return x & y;\n}\n\nstatic inline uint64_t and64(uint64_t x, uint64_t y) {\n  return x & y;\n}\n\nstatic inline uint8_t or8(uint8_t x, uint8_t y) {\n  return x | y;\n}\n\nstatic inline uint16_t or16(uint16_t x, uint16_t y) {\n  return x | y;\n}\n\nstatic inline uint32_t or32(uint32_t x, uint32_t y) {\n  return x | y;\n}\n\nstatic inline uint64_t or64(uint64_t x, uint64_t y) {\n  return x | y;\n}\n\nstatic inline uint8_t xor8(uint8_t x, uint8_t y) {\n  return x ^ y;\n}\n\nstatic inline uint16_t xor16(uint16_t x, uint16_t y) {\n  return x ^ y;\n}\n\nstatic inline uint32_t xor32(uint32_t x, uint32_t y) {\n  return x ^ y;\n}\n\nstatic inline uint64_t xor64(uint64_t x, uint64_t y) {\n  return x ^ y;\n}\n\nstatic inline bool ult8(uint8_t x, uint8_t y) {\n  return x < y;\n}\n\nstatic inline bool ult16(uint16_t x, uint16_t y) {\n  return x < y;\n}\n\nstatic inline bool ult32(uint32_t x, uint32_t y) {\n  return x < y;\n}\n\nstatic inline bool ult64(uint64_t x, uint64_t y) {\n  return x ",
            "< y;\n}\n\nstatic inline bool ule8(uint8_t x, uint8_t y) {\n  return x <= y;\n}\n\nstatic inline bool ule16(uint16_t x, uint16_t y) {\n  return x <= y;\n}\n\nstatic inline bool ule32(uint32_t x, uint32_t y) {\n  return x <= y;\n}\n\nstatic inline bool ule64(uint64_t x, uint64_t y) {\n  return x <= y;\n}\n\nstatic inline bool slt8(int8_t x, int8_t y) {\n  return x < y;\n}\n\nstatic inline bool slt16(int16_t x, int16_t y) {\n  return x < y;\n}\n\nstatic inline bool slt32(int32_t x, int32_t y) {\n  return x < y;\n}\n\nstatic inline bool slt64(int64_t x, int64_t y) {\n  return x < y;\n}\n\nstatic inline bool sle8(int8_t x, int8_t y) {\n  return x <= y;\n}\n\nstatic inline bool sle16(int16_t x, int16_t y) {\n  return x <= y;\n}\n\nstatic inline bool sle32(int32_t x, int32_t y) {\n  return x <= y;\n}\n\nstatic inline bool sle64(int64_t x, int64_t y) {\n  return x <= y;\n}\n\nstatic inline uint8_t pow8(uint8_t x, uint8_t y) {\n  uint8_t res = 1, rem = y;\n\n  while (rem != 0) {\n    if (rem & 1)\n      res *= x;\n    rem >>= 1;\n    x *= x;\n  }\n  return res;\n}\n\nstatic inline uint16_t pow16(uint16_t x, uint16_t y) {\n  uint16_t res = 1, rem = y;\n\n  while (rem != 0) {\n    if (rem & 1)\n      res *= x;\n    rem >>= 1;\n    x *= x;\n  }\n  return res;\n}\n\nstatic inline uint32_t pow32(uint32_t x, uint32_t y) {\n  uint32_t res = 1, rem = y;\n\n  while (rem != 0) {\n    if (rem & 1)\n      res *= x;\n    rem >>= 1;\n    x *= x;\n  }\n  return res;\n}\n\nstatic inline uint64_t pow64(uint64_t x, uint64_t y) {\n  uint64_t res = 1, rem = y;\n\n  while (rem != 0) {\n    if (rem & 1)\n      res *= x;\n    rem >>= 1;\n    x *= x;\n  }\n  return res;\n}\n\nstatic inline bool itob_i8_bool(int8_t x) {\n  return x;\n}\n\nstatic inline bool itob_i16_bool(int16_t x) {\n  return x;\n}\n\nstatic inline bool itob_i32_bool(int32_t x) {\n  return x;\n}\n\nstatic inline bool itob_i64_bool(int64_t x) {\n  return x;\n}\n\nstatic inline int8_t btoi_bool_i8(bool x) {\n  return x;\n}\n\nstatic inline int16_t btoi_bool_i16(bool x) {\n  return x;\n}\n\nstatic inline int32_t btoi_bool_i32(bool x) {\n  return x;\n}\n\nsta",
            "tic inline int64_t btoi_bool_i64(bool x) {\n  return x;\n}\n\n#define sext_i8_i8(x) ((int8_t) (int8_t) (x))\n#define sext_i8_i16(x) ((int16_t) (int8_t) (x))\n#define sext_i8_i32(x) ((int32_t) (int8_t) (x))\n#define sext_i8_i64(x) ((int64_t) (int8_t) (x))\n#define sext_i16_i8(x) ((int8_t) (int16_t) (x))\n#define sext_i16_i16(x) ((int16_t) (int16_t) (x))\n#define sext_i16_i32(x) ((int32_t) (int16_t) (x))\n#define sext_i16_i64(x) ((int64_t) (int16_t) (x))\n#define sext_i32_i8(x) ((int8_t) (int32_t) (x))\n#define sext_i32_i16(x) ((int16_t) (int32_t) (x))\n#define sext_i32_i32(x) ((int32_t) (int32_t) (x))\n#define sext_i32_i64(x) ((int64_t) (int32_t) (x))\n#define sext_i64_i8(x) ((int8_t) (int64_t) (x))\n#define sext_i64_i16(x) ((int16_t) (int64_t) (x))\n#define sext_i64_i32(x) ((int32_t) (int64_t) (x))\n#define sext_i64_i64(x) ((int64_t) (int64_t) (x))\n#define zext_i8_i8(x) ((int8_t) (uint8_t) (x))\n#define zext_i8_i16(x) ((int16_t) (uint8_t) (x))\n#define zext_i8_i32(x) ((int32_t) (uint8_t) (x))\n#define zext_i8_i64(x) ((int64_t) (uint8_t) (x))\n#define zext_i16_i8(x) ((int8_t) (uint16_t) (x))\n#define zext_i16_i16(x) ((int16_t) (uint16_t) (x))\n#define zext_i16_i32(x) ((int32_t) (uint16_t) (x))\n#define zext_i16_i64(x) ((int64_t) (uint16_t) (x))\n#define zext_i32_i8(x) ((int8_t) (uint32_t) (x))\n#define zext_i32_i16(x) ((int16_t) (uint32_t) (x))\n#define zext_i32_i32(x) ((int32_t) (uint32_t) (x))\n#define zext_i32_i64(x) ((int64_t) (uint32_t) (x))\n#define zext_i64_i8(x) ((int8_t) (uint64_t) (x))\n#define zext_i64_i16(x) ((int16_t) (uint64_t) (x))\n#define zext_i64_i32(x) ((int32_t) (uint64_t) (x))\n#define zext_i64_i64(x) ((int64_t) (uint64_t) (x))\n\nstatic int8_t abs8(int8_t x) {\n  return (int8_t)abs(x);\n}\n\nstatic int16_t abs16(int16_t x) {\n  return (int16_t)abs(x);\n}\n\nstatic int32_t abs32(int32_t x) {\n  return abs(x);\n}\n\nstatic int64_t abs64(int64_t x) {\n#if defined(__OPENCL_VERSION__)\n  return abs(x);\n#else\n  return llabs(x);\n#endif\n}\n\n#if defined(__OPENCL_VERSION__)\nstatic int32_t futrts_popc8(int",
            "8_t x) {\n  return popcount(x);\n}\n\nstatic int32_t futrts_popc16(int16_t x) {\n  return popcount(x);\n}\n\nstatic int32_t futrts_popc32(int32_t x) {\n  return popcount(x);\n}\n\nstatic int32_t futrts_popc64(int64_t x) {\n  return popcount(x);\n}\n#elif defined(__CUDA_ARCH__)\n\nstatic int32_t futrts_popc8(int8_t x) {\n  return __popc(zext_i8_i32(x));\n}\n\nstatic int32_t futrts_popc16(int16_t x) {\n  return __popc(zext_i16_i32(x));\n}\n\nstatic int32_t futrts_popc32(int32_t x) {\n  return __popc(x);\n}\n\nstatic int32_t futrts_popc64(int64_t x) {\n  return __popcll(x);\n}\n\n#else // Not OpenCL or CUDA, but plain C.\n\nstatic int32_t futrts_popc8(uint8_t x) {\n  int c = 0;\n  for (; x; ++c) { x &= x - 1; }\n  return c;\n}\n\nstatic int32_t futrts_popc16(uint16_t x) {\n  int c = 0;\n  for (; x; ++c) { x &= x - 1; }\n  return c;\n}\n\nstatic int32_t futrts_popc32(uint32_t x) {\n  int c = 0;\n  for (; x; ++c) { x &= x - 1; }\n  return c;\n}\n\nstatic int32_t futrts_popc64(uint64_t x) {\n  int c = 0;\n  for (; x; ++c) { x &= x - 1; }\n  return c;\n}\n#endif\n\n#if defined(__OPENCL_VERSION__)\nstatic uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {\n  return mul_hi(a, b);\n}\n\nstatic uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {\n  return mul_hi(a, b);\n}\n\nstatic uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {\n  return mul_hi(a, b);\n}\n\nstatic uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {\n  return mul_hi(a, b);\n}\n\n#elif defined(__CUDA_ARCH__)\n\nstatic uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {\n  uint16_t aa = a;\n  uint16_t bb = b;\n\n  return aa * bb >> 8;\n}\n\nstatic uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {\n  uint32_t aa = a;\n  uint32_t bb = b;\n\n  return aa * bb >> 16;\n}\n\nstatic uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {\n  return mulhi(a, b);\n}\n\nstatic uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {\n  return mul64hi(a, b);\n}\n\n#else // Not OpenCL or CUDA, but plain C.\n\nstatic uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {\n  uint16_t aa = a;\n  uint16_t bb = b;\n\n  return aa * bb >> 8;\n}\n\nstatic uint16_t fu",
            "trts_mul_hi16(uint16_t a, uint16_t b) {\n  uint32_t aa = a;\n  uint32_t bb = b;\n\n  return aa * bb >> 16;\n}\n\nstatic uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {\n  uint64_t aa = a;\n  uint64_t bb = b;\n\n  return aa * bb >> 32;\n}\n\nstatic uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {\n  __uint128_t aa = a;\n  __uint128_t bb = b;\n\n  return aa * bb >> 64;\n}\n#endif\n\n#if defined(__OPENCL_VERSION__)\nstatic uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {\n  return mad_hi(a, b, c);\n}\n\nstatic uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {\n  return mad_hi(a, b, c);\n}\n\nstatic uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {\n  return mad_hi(a, b, c);\n}\n\nstatic uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {\n  return mad_hi(a, b, c);\n}\n\n#else // Not OpenCL\n\nstatic uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {\n  return futrts_mul_hi8(a, b) + c;\n}\n\nstatic uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {\n  return futrts_mul_hi16(a, b) + c;\n}\n\nstatic uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {\n  return futrts_mul_hi32(a, b) + c;\n}\n\nstatic uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {\n  return futrts_mul_hi64(a, b) + c;\n}\n#endif\n\n#if defined(__OPENCL_VERSION__)\nstatic int32_t futrts_clzz8(int8_t x) {\n  return clz(x);\n}\n\nstatic int32_t futrts_clzz16(int16_t x) {\n  return clz(x);\n}\n\nstatic int32_t futrts_clzz32(int32_t x) {\n  return clz(x);\n}\n\nstatic int32_t futrts_clzz64(int64_t x) {\n  return clz(x);\n}\n\n#elif defined(__CUDA_ARCH__)\n\nstatic int32_t futrts_clzz8(int8_t x) {\n  return __clz(zext_i8_i32(x)) - 24;\n}\n\nstatic int32_t futrts_clzz16(int16_t x) {\n  return __clz(zext_i16_i32(x)) - 16;\n}\n\nstatic int32_t futrts_clzz32(int32_t x) {\n  return __clz(x);\n}\n\nstatic int32_t futrts_clzz64(int64_t x) {\n  return __clzll(x);\n}\n\n#else // Not OpenCL or CUDA, but plain C.\n\nstatic int32_t futrts_clzz8(int8_t x) {\n  return x == 0 ? 8 : __builtin_clz((uint32_t)zext_i8_i32(x)) - 24;\n",
            "}\n\nstatic int32_t futrts_clzz16(int16_t x) {\n  return x == 0 ? 16 : __builtin_clz((uint32_t)zext_i16_i32(x)) - 16;\n}\n\nstatic int32_t futrts_clzz32(int32_t x) {\n  return x == 0 ? 32 : __builtin_clz((uint32_t)x);\n}\n\nstatic int32_t futrts_clzz64(int64_t x) {\n  return x == 0 ? 64 : __builtin_clzll((uint64_t)x);\n}\n#endif\n\n#if defined(__OPENCL_VERSION__)\nstatic int32_t futrts_ctzz8(int8_t x) {\n  int i = 0;\n  for (; i < 8 && (x & 1) == 0; i++, x >>= 1)\n    ;\n  return i;\n}\n\nstatic int32_t futrts_ctzz16(int16_t x) {\n  int i = 0;\n  for (; i < 16 && (x & 1) == 0; i++, x >>= 1)\n    ;\n  return i;\n}\n\nstatic int32_t futrts_ctzz32(int32_t x) {\n  int i = 0;\n  for (; i < 32 && (x & 1) == 0; i++, x >>= 1)\n    ;\n  return i;\n}\n\nstatic int32_t futrts_ctzz64(int64_t x) {\n  int i = 0;\n  for (; i < 64 && (x & 1) == 0; i++, x >>= 1)\n    ;\n  return i;\n}\n\n#elif defined(__CUDA_ARCH__)\n\nstatic int32_t futrts_ctzz8(int8_t x) {\n  int y = __ffs(x);\n  return y == 0 ? 8 : y - 1;\n}\n\nstatic int32_t futrts_ctzz16(int16_t x) {\n  int y = __ffs(x);\n  return y == 0 ? 16 : y - 1;\n}\n\nstatic int32_t futrts_ctzz32(int32_t x) {\n  int y = __ffs(x);\n  return y == 0 ? 32 : y - 1;\n}\n\nstatic int32_t futrts_ctzz64(int64_t x) {\n  int y = __ffsll(x);\n  return y == 0 ? 64 : y - 1;\n}\n\n#else // Not OpenCL or CUDA, but plain C.\n\nstatic int32_t futrts_ctzz8(int8_t x) {\n  return x == 0 ? 8 : __builtin_ctz((uint32_t)x);\n}\n\nstatic int32_t futrts_ctzz16(int16_t x) {\n  return x == 0 ? 16 : __builtin_ctz((uint32_t)x);\n}\n\nstatic int32_t futrts_ctzz32(int32_t x) {\n  return x == 0 ? 32 : __builtin_ctz((uint32_t)x);\n}\n\nstatic int32_t futrts_ctzz64(int64_t x) {\n  return x == 0 ? 64 : __builtin_ctzll((uint64_t)x);\n}\n#endif\n\nstatic inline float fdiv32(float x, float y) {\n  return x / y;\n}\n\nstatic inline float fadd32(float x, float y) {\n  return x + y;\n}\n\nstatic inline float fsub32(float x, float y) {\n  return x - y;\n}\n\nstatic inline float fmul32(float x, float y) {\n  return x * y;\n}\n\nstatic inline bool cmplt32(float x, float y) {\n  retur",
            "n x < y;\n}\n\nstatic inline bool cmple32(float x, float y) {\n  return x <= y;\n}\n\nstatic inline float sitofp_i8_f32(int8_t x) {\n  return (float) x;\n}\n\nstatic inline float sitofp_i16_f32(int16_t x) {\n  return (float) x;\n}\n\nstatic inline float sitofp_i32_f32(int32_t x) {\n  return (float) x;\n}\n\nstatic inline float sitofp_i64_f32(int64_t x) {\n  return (float) x;\n}\n\nstatic inline float uitofp_i8_f32(uint8_t x) {\n  return (float) x;\n}\n\nstatic inline float uitofp_i16_f32(uint16_t x) {\n  return (float) x;\n}\n\nstatic inline float uitofp_i32_f32(uint32_t x) {\n  return (float) x;\n}\n\nstatic inline float uitofp_i64_f32(uint64_t x) {\n  return (float) x;\n}\n\nstatic inline int8_t fptosi_f32_i8(float x) {\n  return (int8_t) x;\n}\n\nstatic inline int16_t fptosi_f32_i16(float x) {\n  return (int16_t) x;\n}\n\nstatic inline int32_t fptosi_f32_i32(float x) {\n  return (int32_t) x;\n}\n\nstatic inline int64_t fptosi_f32_i64(float x) {\n  return (int64_t) x;\n}\n\nstatic inline uint8_t fptoui_f32_i8(float x) {\n  return (uint8_t) x;\n}\n\nstatic inline uint16_t fptoui_f32_i16(float x) {\n  return (uint16_t) x;\n}\n\nstatic inline uint32_t fptoui_f32_i32(float x) {\n  return (uint32_t) x;\n}\n\nstatic inline uint64_t fptoui_f32_i64(float x) {\n  return (uint64_t) x;\n}\n\n#ifdef __OPENCL_VERSION__\nstatic inline float fabs32(float x) {\n  return fabs(x);\n}\n\nstatic inline float fmax32(float x, float y) {\n  return fmax(x, y);\n}\n\nstatic inline float fmin32(float x, float y) {\n  return fmin(x, y);\n}\n\nstatic inline float fpow32(float x, float y) {\n  return pow(x, y);\n}\n\n#else // Not OpenCL, but CUDA or plain C.\n\nstatic inline float fabs32(float x) {\n  return fabsf(x);\n}\n\nstatic inline float fmax32(float x, float y) {\n  return fmaxf(x, y);\n}\n\nstatic inline float fmin32(float x, float y) {\n  return fminf(x, y);\n}\n\nstatic inline float fpow32(float x, float y) {\n  return powf(x, y);\n}\n#endif\n\nstatic inline bool futrts_isnan32(float x) {\n  return isnan(x);\n}\n\nstatic inline bool futrts_isinf32(float x) {\n  return isinf(x);\n}\n\n#ifdef __OP",
            "ENCL_VERSION__\nstatic inline float futrts_log32(float x) {\n  return log(x);\n}\n\nstatic inline float futrts_log2_32(float x) {\n  return log2(x);\n}\n\nstatic inline float futrts_log10_32(float x) {\n  return log10(x);\n}\n\nstatic inline float futrts_sqrt32(float x) {\n  return sqrt(x);\n}\n\nstatic inline float futrts_exp32(float x) {\n  return exp(x);\n}\n\nstatic inline float futrts_cos32(float x) {\n  return cos(x);\n}\n\nstatic inline float futrts_sin32(float x) {\n  return sin(x);\n}\n\nstatic inline float futrts_tan32(float x) {\n  return tan(x);\n}\n\nstatic inline float futrts_acos32(float x) {\n  return acos(x);\n}\n\nstatic inline float futrts_asin32(float x) {\n  return asin(x);\n}\n\nstatic inline float futrts_atan32(float x) {\n  return atan(x);\n}\n\nstatic inline float futrts_cosh32(float x) {\n  return cosh(x);\n}\n\nstatic inline float futrts_sinh32(float x) {\n  return sinh(x);\n}\n\nstatic inline float futrts_tanh32(float x) {\n  return tanh(x);\n}\n\nstatic inline float futrts_acosh32(float x) {\n  return acosh(x);\n}\n\nstatic inline float futrts_asinh32(float x) {\n  return asinh(x);\n}\n\nstatic inline float futrts_atanh32(float x) {\n  return atanh(x);\n}\n\nstatic inline float futrts_atan2_32(float x, float y) {\n  return atan2(x, y);\n}\n\nstatic inline float futrts_hypot32(float x, float y) {\n  return hypot(x, y);\n}\n\nstatic inline float futrts_gamma32(float x) {\n  return tgamma(x);\n}\n\nstatic inline float futrts_lgamma32(float x) {\n  return lgamma(x);\n}\n\nstatic inline float fmod32(float x, float y) {\n  return fmod(x, y);\n}\n\nstatic inline float futrts_round32(float x) {\n  return rint(x);\n}\n\nstatic inline float futrts_floor32(float x) {\n  return floor(x);\n}\n\nstatic inline float futrts_ceil32(float x) {\n  return ceil(x);\n}\n\nstatic inline float futrts_lerp32(float v0, float v1, float t) {\n  return mix(v0, v1, t);\n}\n\nstatic inline float futrts_mad32(float a, float b, float c) {\n  return mad(a, b, c);\n}\n\nstatic inline float futrts_fma32(float a, float b, float c) {\n  return fma(a, b, c);\n}\n\n#else // Not OpenCL, b",
            "ut CUDA or plain C.\n\nstatic inline float futrts_log32(float x) {\n  return logf(x);\n}\n\nstatic inline float futrts_log2_32(float x) {\n  return log2f(x);\n}\n\nstatic inline float futrts_log10_32(float x) {\n  return log10f(x);\n}\n\nstatic inline float futrts_sqrt32(float x) {\n  return sqrtf(x);\n}\n\nstatic inline float futrts_exp32(float x) {\n  return expf(x);\n}\n\nstatic inline float futrts_cos32(float x) {\n  return cosf(x);\n}\n\nstatic inline float futrts_sin32(float x) {\n  return sinf(x);\n}\n\nstatic inline float futrts_tan32(float x) {\n  return tanf(x);\n}\n\nstatic inline float futrts_acos32(float x) {\n  return acosf(x);\n}\n\nstatic inline float futrts_asin32(float x) {\n  return asinf(x);\n}\n\nstatic inline float futrts_atan32(float x) {\n  return atanf(x);\n}\n\nstatic inline float futrts_cosh32(float x) {\n  return coshf(x);\n}\n\nstatic inline float futrts_sinh32(float x) {\n  return sinhf(x);\n}\n\nstatic inline float futrts_tanh32(float x) {\n  return tanhf(x);\n}\n\nstatic inline float futrts_acosh32(float x) {\n  return acoshf(x);\n}\n\nstatic inline float futrts_asinh32(float x) {\n  return asinhf(x);\n}\n\nstatic inline float futrts_atanh32(float x) {\n  return atanhf(x);\n}\n\nstatic inline float futrts_atan2_32(float x, float y) {\n  return atan2f(x, y);\n}\n\nstatic inline float futrts_hypot32(float x, float y) {\n  return hypotf(x, y);\n}\n\nstatic inline float futrts_gamma32(float x) {\n  return tgammaf(x);\n}\n\nstatic inline float futrts_lgamma32(float x) {\n  return lgammaf(x);\n}\n\nstatic inline float fmod32(float x, float y) {\n  return fmodf(x, y);\n}\n\nstatic inline float futrts_round32(float x) {\n  return rintf(x);\n}\n\nstatic inline float futrts_floor32(float x) {\n  return floorf(x);\n}\n\nstatic inline float futrts_ceil32(float x) {\n  return ceilf(x);\n}\n\nstatic inline float futrts_lerp32(float v0, float v1, float t) {\n  return v0 + (v1 - v0) * t;\n}\n\nstatic inline float futrts_mad32(float a, float b, float c) {\n  return a * b + c;\n}\n\nstatic inline float futrts_fma32(float a, float b, float c) {\n  return fmaf(a,",
            " b, c);\n}\n#endif\n\nstatic inline int32_t futrts_to_bits32(float x) {\n  union {\n    float f;\n    int32_t t;\n  } p;\n\n  p.f = x;\n  return p.t;\n}\n\nstatic inline float futrts_from_bits32(int32_t x) {\n  union {\n    int32_t f;\n    float t;\n  } p;\n\n  p.f = x;\n  return p.t;\n}\n\nstatic inline float fsignum32(float x) {\n  return futrts_isnan32(x) ? x : (x > 0) - (x < 0);\n}\n\n#ifdef FUTHARK_F64_ENABLED\n\nstatic inline double fdiv64(double x, double y) {\n  return x / y;\n}\n\nstatic inline double fadd64(double x, double y) {\n  return x + y;\n}\n\nstatic inline double fsub64(double x, double y) {\n  return x - y;\n}\n\nstatic inline double fmul64(double x, double y) {\n  return x * y;\n}\n\nstatic inline bool cmplt64(double x, double y) {\n  return x < y;\n}\n\nstatic inline bool cmple64(double x, double y) {\n  return x <= y;\n}\n\nstatic inline double sitofp_i8_f64(int8_t x) {\n  return (double) x;\n}\n\nstatic inline double sitofp_i16_f64(int16_t x) {\n  return (double) x;\n}\n\nstatic inline double sitofp_i32_f64(int32_t x) {\n  return (double) x;\n}\n\nstatic inline double sitofp_i64_f64(int64_t x) {\n  return (double) x;\n}\n\nstatic inline double uitofp_i8_f64(uint8_t x) {\n  return (double) x;\n}\n\nstatic inline double uitofp_i16_f64(uint16_t x) {\n  return (double) x;\n}\n\nstatic inline double uitofp_i32_f64(uint32_t x) {\n  return (double) x;\n}\n\nstatic inline double uitofp_i64_f64(uint64_t x) {\n  return (double) x;\n}\n\nstatic inline int8_t fptosi_f64_i8(double x) {\n  return (int8_t) x;\n}\n\nstatic inline int16_t fptosi_f64_i16(double x) {\n  return (int16_t) x;\n}\n\nstatic inline int32_t fptosi_f64_i32(double x) {\n  return (int32_t) x;\n}\n\nstatic inline int64_t fptosi_f64_i64(double x) {\n  return (int64_t) x;\n}\n\nstatic inline uint8_t fptoui_f64_i8(double x) {\n  return (uint8_t) x;\n}\n\nstatic inline uint16_t fptoui_f64_i16(double x) {\n  return (uint16_t) x;\n}\n\nstatic inline uint32_t fptoui_f64_i32(double x) {\n  return (uint32_t) x;\n}\n\nstatic inline uint64_t fptoui_f64_i64(double x) {\n  return (uint64_t) x;\n}\n\nstatic inline dou",
            "ble fabs64(double x) {\n  return fabs(x);\n}\n\nstatic inline double fmax64(double x, double y) {\n  return fmax(x, y);\n}\n\nstatic inline double fmin64(double x, double y) {\n  return fmin(x, y);\n}\n\nstatic inline double fpow64(double x, double y) {\n  return pow(x, y);\n}\n\nstatic inline double futrts_log64(double x) {\n  return log(x);\n}\n\nstatic inline double futrts_log2_64(double x) {\n  return log2(x);\n}\n\nstatic inline double futrts_log10_64(double x) {\n  return log10(x);\n}\n\nstatic inline double futrts_sqrt64(double x) {\n  return sqrt(x);\n}\n\nstatic inline double futrts_exp64(double x) {\n  return exp(x);\n}\n\nstatic inline double futrts_cos64(double x) {\n  return cos(x);\n}\n\nstatic inline double futrts_sin64(double x) {\n  return sin(x);\n}\n\nstatic inline double futrts_tan64(double x) {\n  return tan(x);\n}\n\nstatic inline double futrts_acos64(double x) {\n  return acos(x);\n}\n\nstatic inline double futrts_asin64(double x) {\n  return asin(x);\n}\n\nstatic inline double futrts_atan64(double x) {\n  return atan(x);\n}\n\nstatic inline double futrts_cosh64(double x) {\n  return cosh(x);\n}\n\nstatic inline double futrts_sinh64(double x) {\n  return sinh(x);\n}\n\nstatic inline double futrts_tanh64(double x) {\n  return tanh(x);\n}\n\nstatic inline double futrts_acosh64(double x) {\n  return acosh(x);\n}\n\nstatic inline double futrts_asinh64(double x) {\n  return asinh(x);\n}\n\nstatic inline double futrts_atanh64(double x) {\n  return atanh(x);\n}\n\nstatic inline double futrts_atan2_64(double x, double y) {\n  return atan2(x, y);\n}\n\nstatic inline double futrts_hypot64(double x, double y) {\n  return hypot(x, y);\n}\n\nstatic inline double futrts_gamma64(double x) {\n  return tgamma(x);\n}\n\nstatic inline double futrts_lgamma64(double x) {\n  return lgamma(x);\n}\n\nstatic inline double futrts_fma64(double a, double b, double c) {\n  return fma(a, b, c);\n}\n\nstatic inline double futrts_round64(double x) {\n  return rint(x);\n}\n\nstatic inline double futrts_ceil64(double x) {\n  return ceil(x);\n}\n\nstatic inline double futrts_floor64(doub",
            "le x) {\n  return floor(x);\n}\n\nstatic inline bool futrts_isnan64(double x) {\n  return isnan(x);\n}\n\nstatic inline bool futrts_isinf64(double x) {\n  return isinf(x);\n}\n\nstatic inline int64_t futrts_to_bits64(double x) {\n  union {\n    double f;\n    int64_t t;\n  } p;\n\n  p.f = x;\n  return p.t;\n}\n\nstatic inline double futrts_from_bits64(int64_t x) {\n  union {\n    int64_t f;\n    double t;\n  } p;\n\n  p.f = x;\n  return p.t;\n}\n\nstatic inline double fmod64(double x, double y) {\n  return fmod(x, y);\n}\n\nstatic inline double fsignum64(double x) {\n  return futrts_isnan64(x) ? x : (x > 0) - (x < 0);\n}\n\nstatic inline double futrts_lerp64(double v0, double v1, double t) {\n#ifdef __OPENCL_VERSION__\n  return mix(v0, v1, t);\n#else\n  return v0 + (v1 - v0) * t;\n#endif\n}\n\nstatic inline double futrts_mad64(double a, double b, double c) {\n#ifdef __OPENCL_VERSION__\n  return mad(a, b, c);\n#else\n  return a * b + c;\n#endif\n}\n\nstatic inline float fpconv_f32_f32(float x) {\n  return (float) x;\n}\n\nstatic inline double fpconv_f32_f64(float x) {\n  return (double) x;\n}\n\nstatic inline float fpconv_f64_f32(double x) {\n  return (float) x;\n}\n\nstatic inline double fpconv_f64_f64(double x) {\n  return (double) x;\n}\n\n#endif\n\n// End of scalar.h.\n// Start of scalar_f16.h.\n\n// Half-precision is emulated if needed (e.g. in straight C) with the\n// native type used if possible.  The emulation works by typedef'ing\n// 'float' to 'f16', and then implementing all operations on single\n// precision.  To cut down on duplication, we use the same code for\n// those Futhark functions that require just operators or casts.  The\n// in-memory representation for arrays will still be 16 bits even\n// under emulation, so the compiler will have to be careful when\n// generating reads or writes.\n\n#if !defined(cl_khr_fp16) && !(defined(__CUDA_ARCH__) && __CUDA_ARCH__ >= 600)\n#define EMULATE_F16\n#endif\n\n#if !defined(EMULATE_F16) && defined(__OPENCL_VERSION__)\n#pragma OPENCL EXTENSION cl_khr_fp16 : enable\n#endif\n\n#ifdef EMULATE_F16\n\n// Note t",
            "hat the half-precision storage format is still 16 bits - the\n// compiler will have to be real careful!\ntypedef float f16;\n\n#else\n\n#ifdef __CUDA_ARCH__\n#include <cuda_fp16.h>\n#endif\n\ntypedef half f16;\n\n#endif\n\n// Some of these functions convert to single precision because half\n// precision versions are not available.\n\nstatic inline f16 fadd16(f16 x, f16 y) {\n  return x + y;\n}\n\nstatic inline f16 fsub16(f16 x, f16 y) {\n  return x - y;\n}\n\nstatic inline f16 fmul16(f16 x, f16 y) {\n  return x * y;\n}\n\nstatic inline bool cmplt16(f16 x, f16 y) {\n  return x < y;\n}\n\nstatic inline bool cmple16(f16 x, f16 y) {\n  return x <= y;\n}\n\nstatic inline f16 sitofp_i8_f16(int8_t x) {\n  return (f16) x;\n}\n\nstatic inline f16 sitofp_i16_f16(int16_t x) {\n  return (f16) x;\n}\n\nstatic inline f16 sitofp_i32_f16(int32_t x) {\n  return (f16) x;\n}\n\nstatic inline f16 sitofp_i64_f16(int64_t x) {\n  return (f16) x;\n}\n\nstatic inline f16 uitofp_i8_f16(uint8_t x) {\n  return (f16) x;\n}\n\nstatic inline f16 uitofp_i16_f16(uint16_t x) {\n  return (f16) x;\n}\n\nstatic inline f16 uitofp_i32_f16(uint32_t x) {\n  return (f16) x;\n}\n\nstatic inline f16 uitofp_i64_f16(uint64_t x) {\n  return (f16) x;\n}\n\nstatic inline int8_t fptosi_f16_i8(f16 x) {\n  return (int8_t) (float) x;\n}\n\nstatic inline int16_t fptosi_f16_i16(f16 x) {\n  return (int16_t) x;\n}\n\nstatic inline int32_t fptosi_f16_i32(f16 x) {\n  return (int32_t) x;\n}\n\nstatic inline int64_t fptosi_f16_i64(f16 x) {\n  return (int64_t) x;\n}\n\nstatic inline uint8_t fptoui_f16_i8(f16 x) {\n  return (uint8_t) (float) x;\n}\n\nstatic inline uint16_t fptoui_f16_i16(f16 x) {\n  return (uint16_t) x;\n}\n\nstatic inline uint32_t fptoui_f16_i32(f16 x) {\n  return (uint32_t) x;\n}\n\nstatic inline uint64_t fptoui_f16_i64(f16 x) {\n  return (uint64_t) x;\n}\n\n#ifndef EMULATE_F16\n\n#ifdef __OPENCL_VERSION__\nstatic inline f16 fabs16(f16 x) {\n  return fabs(x);\n}\n\nstatic inline f16 fmax16(f16 x, f16 y) {\n  return fmax(x, y);\n}\n\nstatic inline f16 fmin16(f16 x, f16 y) {\n  return fmin(x, y);\n}\n\nstatic inline f16 fpow",
            "16(f16 x, f16 y) {\n  return pow(x, y);\n}\n\n#else // Assuming CUDA.\n\nstatic inline f16 fabs16(f16 x) {\n  return fabsf(x);\n}\n\nstatic inline f16 fmax16(f16 x, f16 y) {\n  return fmaxf(x, y);\n}\n\nstatic inline f16 fmin16(f16 x, f16 y) {\n  return fminf(x, y);\n}\n\nstatic inline f16 fpow16(f16 x, f16 y) {\n  return powf(x, y);\n}\n#endif\n\nstatic inline bool futrts_isnan16(f16 x) {\n  return isnan((float)x);\n}\n\nstatic inline bool futrts_isinf16(f16 x) {\n  return isinf((float)x);\n}\n\n#ifdef __OPENCL_VERSION__\nstatic inline f16 futrts_log16(f16 x) {\n  return log(x);\n}\n\nstatic inline f16 futrts_log2_16(f16 x) {\n  return log2(x);\n}\n\nstatic inline f16 futrts_log10_16(f16 x) {\n  return log10(x);\n}\n\nstatic inline f16 futrts_sqrt16(f16 x) {\n  return sqrt(x);\n}\n\nstatic inline f16 futrts_exp16(f16 x) {\n  return exp(x);\n}\n\nstatic inline f16 futrts_cos16(f16 x) {\n  return cos(x);\n}\n\nstatic inline f16 futrts_sin16(f16 x) {\n  return sin(x);\n}\n\nstatic inline f16 futrts_tan16(f16 x) {\n  return tan(x);\n}\n\nstatic inline f16 futrts_acos16(f16 x) {\n  return acos(x);\n}\n\nstatic inline f16 futrts_asin16(f16 x) {\n  return asin(x);\n}\n\nstatic inline f16 futrts_atan16(f16 x) {\n  return atan(x);\n}\n\nstatic inline f16 futrts_cosh16(f16 x) {\n  return cosh(x);\n}\n\nstatic inline f16 futrts_sinh16(f16 x) {\n  return sinh(x);\n}\n\nstatic inline f16 futrts_tanh16(f16 x) {\n  return tanh(x);\n}\n\nstatic inline f16 futrts_acosh16(f16 x) {\n  return acosh(x);\n}\n\nstatic inline f16 futrts_asinh16(f16 x) {\n  return asinh(x);\n}\n\nstatic inline f16 futrts_atanh16(f16 x) {\n  return atanh(x);\n}\n\nstatic inline f16 futrts_atan2_16(f16 x, f16 y) {\n  return atan2(x, y);\n}\n\nstatic inline f16 futrts_hypot16(f16 x, f16 y) {\n  return hypot(x, y);\n}\n\nstatic inline f16 futrts_gamma16(f16 x) {\n  return tgamma(x);\n}\n\nstatic inline f16 futrts_lgamma16(f16 x) {\n  return lgamma(x);\n}\n\nstatic inline f16 fmod16(f16 x, f16 y) {\n  return fmod(x, y);\n}\n\nstatic inline f16 futrts_round16(f16 x) {\n  return rint(x);\n}\n\nstatic inline f16 futrts_floor16(f16 x) {",
            "\n  return floor(x);\n}\n\nstatic inline f16 futrts_ceil16(f16 x) {\n  return ceil(x);\n}\n\nstatic inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {\n  return mix(v0, v1, t);\n}\n\nstatic inline f16 futrts_mad16(f16 a, f16 b, f16 c) {\n  return mad(a, b, c);\n}\n\nstatic inline f16 futrts_fma16(f16 a, f16 b, f16 c) {\n  return fma(a, b, c);\n}\n\n#else // Assume CUDA.\n\nstatic inline f16 futrts_log16(f16 x) {\n  return hlog(x);\n}\n\nstatic inline f16 futrts_log2_16(f16 x) {\n  return hlog2(x);\n}\n\nstatic inline f16 futrts_log10_16(f16 x) {\n  return hlog10(x);\n}\n\nstatic inline f16 futrts_sqrt16(f16 x) {\n  return hsqrt(x);\n}\n\nstatic inline f16 futrts_exp16(f16 x) {\n  return hexp(x);\n}\n\nstatic inline f16 futrts_cos16(f16 x) {\n  return hcos(x);\n}\n\nstatic inline f16 futrts_sin16(f16 x) {\n  return hsin(x);\n}\n\nstatic inline f16 futrts_tan16(f16 x) {\n  return tanf(x);\n}\n\nstatic inline f16 futrts_acos16(f16 x) {\n  return acosf(x);\n}\n\nstatic inline f16 futrts_asin16(f16 x) {\n  return asinf(x);\n}\n\nstatic inline f16 futrts_atan16(f16 x) {\n  return atanf(x);\n}\n\nstatic inline f16 futrts_cosh16(f16 x) {\n  return coshf(x);\n}\n\nstatic inline f16 futrts_sinh16(f16 x) {\n  return sinhf(x);\n}\n\nstatic inline f16 futrts_tanh16(f16 x) {\n  return tanhf(x);\n}\n\nstatic inline f16 futrts_acosh16(f16 x) {\n  return acoshf(x);\n}\n\nstatic inline f16 futrts_asinh16(f16 x) {\n  return asinhf(x);\n}\n\nstatic inline f16 futrts_atanh16(f16 x) {\n  return atanhf(x);\n}\n\nstatic inline f16 futrts_atan2_16(f16 x, f16 y) {\n  return atan2f(x, y);\n}\n\nstatic inline f16 futrts_hypot16(f16 x, f16 y) {\n  return hypotf(x, y);\n}\n\nstatic inline f16 futrts_gamma16(f16 x) {\n  return tgammaf(x);\n}\n\nstatic inline f16 futrts_lgamma16(f16 x) {\n  return lgammaf(x);\n}\n\nstatic inline f16 fmod16(f16 x, f16 y) {\n  return fmodf(x, y);\n}\n\nstatic inline f16 futrts_round16(f16 x) {\n  return rintf(x);\n}\n\nstatic inline f16 futrts_floor16(f16 x) {\n  return hfloor(x);\n}\n\nstatic inline f16 futrts_ceil16(f16 x) {\n  return hceil(x);\n}\n\nstatic inline f16 futrts_lerp16(f1",
            "6 v0, f16 v1, f16 t) {\n  return v0 + (v1 - v0) * t;\n}\n\nstatic inline f16 futrts_mad16(f16 a, f16 b, f16 c) {\n  return a * b + c;\n}\n\nstatic inline f16 futrts_fma16(f16 a, f16 b, f16 c) {\n  return fmaf(a, b, c);\n}\n\n#endif\n\n// The CUDA __half type cannot be put in unions for some reason, so we\n// use bespoke conversion functions instead.\n#ifdef __CUDA_ARCH__\nstatic inline int16_t futrts_to_bits16(f16 x) {\n  return __half_as_ushort(x);\n}\nstatic inline f16 futrts_from_bits16(int16_t x) {\n  return __ushort_as_half(x);\n}\n#else\nstatic inline int16_t futrts_to_bits16(f16 x) {\n  union {\n    f16 f;\n    int16_t t;\n  } p;\n\n  p.f = x;\n  return p.t;\n}\n\nstatic inline f16 futrts_from_bits16(int16_t x) {\n  union {\n    int16_t f;\n    f16 t;\n  } p;\n\n  p.f = x;\n  return p.t;\n}\n#endif\n\n#else // No native f16 - emulate.\n\nstatic inline f16 fabs16(f16 x) {\n  return fabs32(x);\n}\n\nstatic inline f16 fmax16(f16 x, f16 y) {\n  return fmax32(x, y);\n}\n\nstatic inline f16 fmin16(f16 x, f16 y) {\n  return fmin32(x, y);\n}\n\nstatic inline f16 fpow16(f16 x, f16 y) {\n  return fpow32(x, y);\n}\n\nstatic inline bool futrts_isnan16(f16 x) {\n  return futrts_isnan32(x);\n}\n\nstatic inline bool futrts_isinf16(f16 x) {\n  return futrts_isinf32(x);\n}\n\nstatic inline f16 futrts_log16(f16 x) {\n  return futrts_log32(x);\n}\n\nstatic inline f16 futrts_log2_16(f16 x) {\n  return futrts_log2_32(x);\n}\n\nstatic inline f16 futrts_log10_16(f16 x) {\n  return futrts_log10_32(x);\n}\n\nstatic inline f16 futrts_sqrt16(f16 x) {\n  return futrts_sqrt32(x);\n}\n\nstatic inline f16 futrts_exp16(f16 x) {\n  return futrts_exp32(x);\n}\n\nstatic inline f16 futrts_cos16(f16 x) {\n  return futrts_cos32(x);\n}\n\nstatic inline f16 futrts_sin16(f16 x) {\n  return futrts_sin32(x);\n}\n\nstatic inline f16 futrts_tan16(f16 x) {\n  return futrts_tan32(x);\n}\n\nstatic inline f16 futrts_acos16(f16 x) {\n  return futrts_acos32(x);\n}\n\nstatic inline f16 futrts_asin16(f16 x) {\n  return futrts_asin32(x);\n}\n\nstatic inline f16 futrts_atan16(f16 x) {\n  return futrts_atan32(x);\n}\n\nstatic ",
            "inline f16 futrts_cosh16(f16 x) {\n  return futrts_cosh32(x);\n}\n\nstatic inline f16 futrts_sinh16(f16 x) {\n  return futrts_sinh32(x);\n}\n\nstatic inline f16 futrts_tanh16(f16 x) {\n  return futrts_tanh32(x);\n}\n\nstatic inline f16 futrts_acosh16(f16 x) {\n  return futrts_acosh32(x);\n}\n\nstatic inline f16 futrts_asinh16(f16 x) {\n  return futrts_asinh32(x);\n}\n\nstatic inline f16 futrts_atanh16(f16 x) {\n  return futrts_atanh32(x);\n}\n\nstatic inline f16 futrts_atan2_16(f16 x, f16 y) {\n  return futrts_atan2_32(x, y);\n}\n\nstatic inline f16 futrts_hypot16(f16 x, f16 y) {\n  return futrts_hypot32(x, y);\n}\n\nstatic inline f16 futrts_gamma16(f16 x) {\n  return futrts_gamma32(x);\n}\n\nstatic inline f16 futrts_lgamma16(f16 x) {\n  return futrts_lgamma32(x);\n}\n\nstatic inline f16 fmod16(f16 x, f16 y) {\n  return fmod32(x, y);\n}\n\nstatic inline f16 futrts_round16(f16 x) {\n  return futrts_round32(x);\n}\n\nstatic inline f16 futrts_floor16(f16 x) {\n  return futrts_floor32(x);\n}\n\nstatic inline f16 futrts_ceil16(f16 x) {\n  return futrts_ceil32(x);\n}\n\nstatic inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {\n  return futrts_lerp32(v0, v1, t);\n}\n\nstatic inline f16 futrts_mad16(f16 a, f16 b, f16 c) {\n  return futrts_mad32(a, b, c);\n}\n\nstatic inline f16 futrts_fma16(f16 a, f16 b, f16 c) {\n  return futrts_fma32(a, b, c);\n}\n\n// Even when we are using an OpenCL that does not support cl_khr_fp16,\n// it must still support vload_half for actually creating a\n// half-precision number, which can then be efficiently converted to a\n// float.  Similarly for vstore_half.\n#ifdef __OPENCL_VERSION__\n\nstatic inline int16_t futrts_to_bits16(f16 x) {\n  int16_t y;\n  // Violating strict aliasing here.\n  vstore_half((float)x, 0, (half*)&y);\n  return y;\n}\n\nstatic inline f16 futrts_from_bits16(int16_t x) {\n  return (f16)vload_half(0, (half*)&x);\n}\n\n#else\n\nstatic inline int16_t futrts_to_bits16(f16 x) {\n  return (int16_t)float2halfbits(x);\n}\n\nstatic inline f16 futrts_from_bits16(int16_t x) {\n  return halfbits2float((uint16_t)x);\n}\n\nstat",
            "ic inline f16 fsignum16(f16 x) {\n  return futrts_isnan16(x) ? x : (x > 0) - (x < 0);\n}\n\n#endif\n\n#endif\n\nstatic inline float fpconv_f16_f16(f16 x) {\n  return x;\n}\n\nstatic inline float fpconv_f16_f32(f16 x) {\n  return x;\n}\n\nstatic inline f16 fpconv_f32_f16(float x) {\n  return x;\n}\n\n#ifdef FUTHARK_F64_ENABLED\n\nstatic inline double fpconv_f16_f64(f16 x) {\n  return (double) x;\n}\n\nstatic inline f16 fpconv_f64_f16(double x) {\n  return (f16) x;\n}\n\n#endif\n\n\n// End of scalar_f16.h.\n// Start of atomics.h\n\ninline int32_t atomic_xchg_i32_global(volatile __global int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicExch((int32_t*)p, x);\n#else\n  return atomic_xor(p, x);\n#endif\n}\n\ninline int32_t atomic_xchg_i32_local(volatile __local int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicExch((int32_t*)p, x);\n#else\n  return atomic_xor(p, x);\n#endif\n}\n\ninline int32_t atomic_cmpxchg_i32_global(volatile __global int32_t *p,\n                                         int32_t cmp, int32_t val) {\n#ifdef FUTHARK_CUDA\n  return atomicCAS((int32_t*)p, cmp, val);\n#else\n  return atomic_cmpxchg(p, cmp, val);\n#endif\n}\n\ninline int32_t atomic_cmpxchg_i32_local(volatile __local int32_t *p,\n                                        int32_t cmp, int32_t val) {\n#ifdef FUTHARK_CUDA\n  return atomicCAS((int32_t*)p, cmp, val);\n#else\n  return atomic_cmpxchg(p, cmp, val);\n#endif\n}\n\ninline int32_t atomic_add_i32_global(volatile __global int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicAdd((int32_t*)p, x);\n#else\n  return atomic_add(p, x);\n#endif\n}\n\ninline int32_t atomic_add_i32_local(volatile __local int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicAdd((int32_t*)p, x);\n#else\n  return atomic_add(p, x);\n#endif\n}\n\ninline float atomic_fadd_f32_global(volatile __global float *p, float x) {\n#ifdef FUTHARK_CUDA\n  return atomicAdd((float*)p, x);\n#else\n  union { int32_t i; float f; } old;\n  union { int32_t i; float f; } assumed;\n  old.f = *p;\n  do {\n    assumed.f = old.f;\n    old.f = old.",
            "f + x;\n    old.i = atomic_cmpxchg_i32_global((volatile __global int32_t*)p, assumed.i, old.i);\n  } while (assumed.i != old.i);\n  return old.f;\n#endif\n}\n\ninline float atomic_fadd_f32_local(volatile __local float *p, float x) {\n#ifdef FUTHARK_CUDA\n  return atomicAdd((float*)p, x);\n#else\n  union { int32_t i; float f; } old;\n  union { int32_t i; float f; } assumed;\n  old.f = *p;\n  do {\n    assumed.f = old.f;\n    old.f = old.f + x;\n    old.i = atomic_cmpxchg_i32_local((volatile __local int32_t*)p, assumed.i, old.i);\n  } while (assumed.i != old.i);\n  return old.f;\n#endif\n}\n\ninline int32_t atomic_smax_i32_global(volatile __global int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMax((int32_t*)p, x);\n#else\n  return atomic_max(p, x);\n#endif\n}\n\ninline int32_t atomic_smax_i32_local(volatile __local int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMax((int32_t*)p, x);\n#else\n  return atomic_max(p, x);\n#endif\n}\n\ninline int32_t atomic_smin_i32_global(volatile __global int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMin((int32_t*)p, x);\n#else\n  return atomic_min(p, x);\n#endif\n}\n\ninline int32_t atomic_smin_i32_local(volatile __local int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMin((int32_t*)p, x);\n#else\n  return atomic_min(p, x);\n#endif\n}\n\ninline uint32_t atomic_umax_i32_global(volatile __global uint32_t *p, uint32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMax((uint32_t*)p, x);\n#else\n  return atomic_max(p, x);\n#endif\n}\n\ninline uint32_t atomic_umax_i32_local(volatile __local uint32_t *p, uint32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMax((uint32_t*)p, x);\n#else\n  return atomic_max(p, x);\n#endif\n}\n\ninline uint32_t atomic_umin_i32_global(volatile __global uint32_t *p, uint32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMin((uint32_t*)p, x);\n#else\n  return atomic_min(p, x);\n#endif\n}\n\ninline uint32_t atomic_umin_i32_local(volatile __local uint32_t *p, uint32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMin((uint32_t*)p, x);\n#else\n  return atomi",
            "c_min(p, x);\n#endif\n}\n\ninline int32_t atomic_and_i32_global(volatile __global int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicAnd((int32_t*)p, x);\n#else\n  return atomic_and(p, x);\n#endif\n}\n\ninline int32_t atomic_and_i32_local(volatile __local int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicAnd((int32_t*)p, x);\n#else\n  return atomic_and(p, x);\n#endif\n}\n\ninline int32_t atomic_or_i32_global(volatile __global int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicOr((int32_t*)p, x);\n#else\n  return atomic_or(p, x);\n#endif\n}\n\ninline int32_t atomic_or_i32_local(volatile __local int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicOr((int32_t*)p, x);\n#else\n  return atomic_or(p, x);\n#endif\n}\n\ninline int32_t atomic_xor_i32_global(volatile __global int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicXor((int32_t*)p, x);\n#else\n  return atomic_xor(p, x);\n#endif\n}\n\ninline int32_t atomic_xor_i32_local(volatile __local int32_t *p, int32_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicXor((int32_t*)p, x);\n#else\n  return atomic_xor(p, x);\n#endif\n}\n\n// Start of 64 bit atomics\n\ninline int64_t atomic_xchg_i64_global(volatile __global int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicExch((uint64_t*)p, x);\n#else\n  return atom_xor(p, x);\n#endif\n}\n\ninline int64_t atomic_xchg_i64_local(volatile __local int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicExch((uint64_t*)p, x);\n#else\n  return atom_xor(p, x);\n#endif\n}\n\ninline int64_t atomic_cmpxchg_i64_global(volatile __global int64_t *p,\n                                         int64_t cmp, int64_t val) {\n#ifdef FUTHARK_CUDA\n  return atomicCAS((uint64_t*)p, cmp, val);\n#else\n  return atom_cmpxchg(p, cmp, val);\n#endif\n}\n\ninline int64_t atomic_cmpxchg_i64_local(volatile __local int64_t *p,\n                                        int64_t cmp, int64_t val) {\n#ifdef FUTHARK_CUDA\n  return atomicCAS((uint64_t*)p, cmp, val);\n#else\n  return atom_cmpxchg(p, cmp, val);\n#endif\n}\n\ninline int64_t atomi",
            "c_add_i64_global(volatile __global int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicAdd((uint64_t*)p, x);\n#else\n  return atom_add(p, x);\n#endif\n}\n\ninline int64_t atomic_add_i64_local(volatile __local int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicAdd((uint64_t*)p, x);\n#else\n  return atom_add(p, x);\n#endif\n}\n\n#ifdef FUTHARK_F64_ENABLED\n\ninline double atomic_fadd_f64_global(volatile __global double *p, double x) {\n#if defined(FUTHARK_CUDA) && __CUDA_ARCH__ >= 600\n  return atomicAdd((double*)p, x);\n#else\n  union { int64_t i; double f; } old;\n  union { int64_t i; double f; } assumed;\n  old.f = *p;\n  do {\n    assumed.f = old.f;\n    old.f = old.f + x;\n    old.i = atomic_cmpxchg_i64_global((volatile __global int64_t*)p, assumed.i, old.i);\n  } while (assumed.i != old.i);\n  return old.f;\n#endif\n}\n\ninline double atomic_fadd_f64_local(volatile __local double *p, double x) {\n#if defined(FUTHARK_CUDA) && __CUDA_ARCH__ >= 600\n  return atomicAdd((double*)p, x);\n#else\n  union { int64_t i; double f; } old;\n  union { int64_t i; double f; } assumed;\n  old.f = *p;\n  do {\n    assumed.f = old.f;\n    old.f = old.f + x;\n    old.i = atomic_cmpxchg_i64_local((volatile __local int64_t*)p, assumed.i, old.i);\n  } while (assumed.i != old.i);\n  return old.f;\n#endif\n}\n\n#endif\n\ninline int64_t atomic_smax_i64_global(volatile __global int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMax((int64_t*)p, x);\n#else\n  return atom_max(p, x);\n#endif\n}\n\ninline int64_t atomic_smax_i64_local(volatile __local int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMax((int64_t*)p, x);\n#else\n  return atom_max(p, x);\n#endif\n}\n\ninline int64_t atomic_smin_i64_global(volatile __global int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMin((int64_t*)p, x);\n#else\n  return atom_min(p, x);\n#endif\n}\n\ninline int64_t atomic_smin_i64_local(volatile __local int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMin((int64_t*)p, x);\n#else\n  return atom_min(p, x);\n#endif\n}\n\nin",
            "line uint64_t atomic_umax_i64_global(volatile __global uint64_t *p, uint64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMax((uint64_t*)p, x);\n#else\n  return atom_max(p, x);\n#endif\n}\n\ninline uint64_t atomic_umax_i64_local(volatile __local uint64_t *p, uint64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMax((uint64_t*)p, x);\n#else\n  return atom_max(p, x);\n#endif\n}\n\ninline uint64_t atomic_umin_i64_global(volatile __global uint64_t *p, uint64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMin((uint64_t*)p, x);\n#else\n  return atom_min(p, x);\n#endif\n}\n\ninline uint64_t atomic_umin_i64_local(volatile __local uint64_t *p, uint64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicMin((uint64_t*)p, x);\n#else\n  return atom_min(p, x);\n#endif\n}\n\ninline int64_t atomic_and_i64_global(volatile __global int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicAnd((int64_t*)p, x);\n#else\n  return atom_and(p, x);\n#endif\n}\n\ninline int64_t atomic_and_i64_local(volatile __local int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicAnd((int64_t*)p, x);\n#else\n  return atom_and(p, x);\n#endif\n}\n\ninline int64_t atomic_or_i64_global(volatile __global int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicOr((int64_t*)p, x);\n#else\n  return atom_or(p, x);\n#endif\n}\n\ninline int64_t atomic_or_i64_local(volatile __local int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicOr((int64_t*)p, x);\n#else\n  return atom_or(p, x);\n#endif\n}\n\ninline int64_t atomic_xor_i64_global(volatile __global int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicXor((int64_t*)p, x);\n#else\n  return atom_xor(p, x);\n#endif\n}\n\ninline int64_t atomic_xor_i64_local(volatile __local int64_t *p, int64_t x) {\n#ifdef FUTHARK_CUDA\n  return atomicXor((int64_t*)p, x);\n#else\n  return atom_xor(p, x);\n#endif\n}\n\n// End of atomics.h\n\n\n\n__kernel void builtinzhreplicate_f32zireplicate_325746(int32_t num_elems_325743,\n                                                       float val_325744,\n                                                   ",
            "    __global\n                                                       unsigned char *mem_325742)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    int32_t replicate_gtid_325746;\n    int32_t replicate_ltid_325747;\n    int32_t replicate_gid_325748;\n    \n    replicate_gtid_325746 = get_global_id(0);\n    replicate_ltid_325747 = get_local_id(0);\n    replicate_gid_325748 = get_group_id(0);\n    \n    int64_t slice_325752 = num_elems_325743;\n    int64_t rep_i_325751 = sext_i32_i64(replicate_gtid_325746);\n    int64_t remnant_325753 = sext_i32_i64(replicate_gtid_325746) - rep_i_325751;\n    \n    if (slt64(replicate_gtid_325746, num_elems_325743)) {\n        ((__global float *) mem_325742)[rep_i_325751] = val_325744;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void builtinzhreplicate_f64zireplicate_321586(int32_t num_elems_321583,\n                                                       double val_321584,\n                                                       __global\n                                                       unsigned char *mem_321582)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    int32_t replicate_gtid_321586;\n    int32_t replicate_ltid_321587;\n    int32_t replicate_gid_321588;\n    \n    replicate_gtid_321586 = get_global_id(0);\n    replicate_ltid_321587 = get_local_id(0);\n    replicate_gid_321588 = get_group_id(0);\n    \n    int64_t slice_321592 = num_elems_321583;\n    int64_t rep_i_321591 = sext_i32_i64(replicate_gtid_321586);\n    int64_t remnant_321593 = sext_i32_i64(replicate_gtid_321586) - rep_i_321591;\n    \n    if (slt64(replicate_gtid_321586, num_elems_321583)) {\n        ((__global double *) mem_321582)[rep_i_321591] = val_321584;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void builtinzhreplicate_i32zireplicate_325103(int32_t num_elems_325100,\n                                                       int32_t val_325101,\n                                                   ",
            "    __global\n                                                       unsigned char *mem_325099)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    int32_t replicate_gtid_325103;\n    int32_t replicate_ltid_325104;\n    int32_t replicate_gid_325105;\n    \n    replicate_gtid_325103 = get_global_id(0);\n    replicate_ltid_325104 = get_local_id(0);\n    replicate_gid_325105 = get_group_id(0);\n    \n    int64_t slice_325109 = num_elems_325100;\n    int64_t rep_i_325108 = sext_i32_i64(replicate_gtid_325103);\n    int64_t remnant_325110 = sext_i32_i64(replicate_gtid_325103) - rep_i_325108;\n    \n    if (slt64(replicate_gtid_325103, num_elems_325100)) {\n        ((__global int32_t *) mem_325099)[rep_i_325108] = val_325101;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void builtinzhreplicate_i64zireplicate_321086(int32_t num_elems_321083,\n                                                       int64_t val_321084,\n                                                       __global\n                                                       unsigned char *mem_321082)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    int32_t replicate_gtid_321086;\n    int32_t replicate_ltid_321087;\n    int32_t replicate_gid_321088;\n    \n    replicate_gtid_321086 = get_global_id(0);\n    replicate_ltid_321087 = get_local_id(0);\n    replicate_gid_321088 = get_group_id(0);\n    \n    int64_t slice_321092 = num_elems_321083;\n    int64_t rep_i_321091 = sext_i32_i64(replicate_gtid_321086);\n    int64_t remnant_321093 = sext_i32_i64(replicate_gtid_321086) - rep_i_321091;\n    \n    if (slt64(replicate_gtid_321086, num_elems_321083)) {\n        ((__global int64_t *) mem_321082)[rep_i_321091] = val_321084;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void builtinzhreplicate_i8zireplicate_320841(int32_t num_elems_320838,\n                                                      int8_t val_320839,\n                                                  ",
            "    __global\n                                                      unsigned char *mem_320837)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    int32_t replicate_gtid_320841;\n    int32_t replicate_ltid_320842;\n    int32_t replicate_gid_320843;\n    \n    replicate_gtid_320841 = get_global_id(0);\n    replicate_ltid_320842 = get_local_id(0);\n    replicate_gid_320843 = get_group_id(0);\n    \n    int64_t slice_320847 = num_elems_320838;\n    int64_t rep_i_320846 = sext_i32_i64(replicate_gtid_320841);\n    int64_t remnant_320848 = sext_i32_i64(replicate_gtid_320841) - rep_i_320846;\n    \n    if (slt64(replicate_gtid_320841, num_elems_320838)) {\n        ((__global int8_t *) mem_320837)[rep_i_320846] = val_320839;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void gpu_map_transpose_f32(const int block_dim0, const int block_dim1,\n                                    const int block_dim2,\n                                    uint block_9_backing_offset_0,\n                                    int32_t destoffset_1, int32_t srcoffset_3,\n                                    int32_t num_arrays_4, int32_t x_elems_5,\n                                    int32_t y_elems_6, int32_t mulx_7,\n                                    int32_t muly_8, __global\n                                    unsigned char *destmem_0, __global\n                                    unsigned char *srcmem_2)\n{\n    volatile unsigned char *block_9_backing_0 =\n                           &shared_mem[block_9_backing_offset_0];\n    __local unsigned char *block_9;\n    \n    block_9 = (__local unsigned char *) block_9_backing_0;\n    \n    int32_t get_global_id_0_37;\n    \n    get_global_id_0_37 = get_global_id(0);\n    \n    int32_t get_local_id_0_38;\n    \n    get_local_id_0_38 = get_local_id(0);\n    \n    int32_t get_local_id_1_39;\n    \n    get_local_id_1_39 = get_local_id(1);\n    \n    int32_t get_group_id_0_40;\n    \n    get_group_id_0_40 = get_group_id(0);\n    \n    int32_t get_group_id_1_41;",
            "\n    \n    get_group_id_1_41 = get_group_id(1);\n    \n    int32_t get_group_id_2_42;\n    \n    get_group_id_2_42 = get_group_id(2);\n    \n    int32_t our_array_offset_30 = get_group_id_2_42 * x_elems_5 * y_elems_6;\n    int32_t odata_offset_33 = squot32(destoffset_1, 4) + our_array_offset_30;\n    int32_t idata_offset_34 = squot32(srcoffset_3, 4) + our_array_offset_30;\n    int32_t x_index_31 = get_global_id_0_37;\n    int32_t y_index_32 = get_group_id_1_41 * 32 + get_local_id_1_39;\n    float val_44;\n    \n    if (slt32(x_index_31, x_elems_5)) {\n        for (int32_t j_43 = 0; j_43 < 4; j_43++) {\n            int32_t index_in_35 = (y_index_32 + j_43 * 8) * x_elems_5 +\n                    x_index_31;\n            \n            if (slt32(y_index_32 + j_43 * 8, y_elems_6)) {\n                val_44 = ((__global\n                           float *) srcmem_2)[sext_i32_i64(idata_offset_34 +\n                                              index_in_35)];\n                ((__local float *) block_9)[sext_i32_i64((get_local_id_1_39 +\n                                                          j_43 * 8) * 33 +\n                                            get_local_id_0_38)] = val_44;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    x_index_31 = get_group_id_1_41 * 32 + get_local_id_0_38;\n    y_index_32 = get_group_id_0_40 * 32 + get_local_id_1_39;\n    if (slt32(x_index_31, y_elems_6)) {\n        for (int32_t j_43 = 0; j_43 < 4; j_43++) {\n            int32_t index_out_36 = (y_index_32 + j_43 * 8) * y_elems_6 +\n                    x_index_31;\n            \n            if (slt32(y_index_32 + j_43 * 8, x_elems_5)) {\n                val_44 = ((__local\n                           float *) block_9)[sext_i32_i64(get_local_id_0_38 *\n                                             33 + get_local_id_1_39 + j_43 *\n                                             8)];\n                ((__global float *) destmem_0)[sext_i32_i64(odata_offset_33 +\n                                               index_out_",
            "36)] = val_44;\n            }\n        }\n    }\n    \n  error_0:\n    return;\n}\n__kernel void gpu_map_transpose_f32_low_height(const int block_dim0, const\n                                               int block_dim1, const\n                                               int block_dim2,\n                                               uint block_9_backing_offset_0,\n                                               int32_t destoffset_1,\n                                               int32_t srcoffset_3,\n                                               int32_t num_arrays_4,\n                                               int32_t x_elems_5,\n                                               int32_t y_elems_6,\n                                               int32_t mulx_7, int32_t muly_8,\n                                               __global\n                                               unsigned char *destmem_0,\n                                               __global unsigned char *srcmem_2)\n{\n    volatile unsigned char *block_9_backing_0 =\n                           &shared_mem[block_9_backing_offset_0];\n    __local unsigned char *block_9;\n    \n    block_9 = (__local unsigned char *) block_9_backing_0;\n    \n    int32_t get_global_id_0_37;\n    \n    get_global_id_0_37 = get_global_id(0);\n    \n    int32_t get_local_id_0_38;\n    \n    get_local_id_0_38 = get_local_id(0);\n    \n    int32_t get_local_id_1_39;\n    \n    get_local_id_1_39 = get_local_id(1);\n    \n    int32_t get_group_id_0_40;\n    \n    get_group_id_0_40 = get_group_id(0);\n    \n    int32_t get_group_id_1_41;\n    \n    get_group_id_1_41 = get_group_id(1);\n    \n    int32_t get_group_id_2_42;\n    \n    get_group_id_2_42 = get_group_id(2);\n    \n    int32_t our_array_offset_30 = get_group_id_2_42 * x_elems_5 * y_elems_6;\n    int32_t odata_offset_33 = squot32(destoffset_1, 4) + our_array_offset_30;\n    int32_t idata_offset_34 = squot32(srcoffset_3, 4) + our_array_offset_30;\n    int32_t x_index_31 = get_group_id_0_40 * 16 * mulx_7 + get_lo",
            "cal_id_0_38 +\n            srem32(get_local_id_1_39, mulx_7) * 16;\n    int32_t y_index_32 = get_group_id_1_41 * 16 + squot32(get_local_id_1_39,\n                                                          mulx_7);\n    float val_44;\n    int32_t index_in_35 = y_index_32 * x_elems_5 + x_index_31;\n    \n    if (slt32(x_index_31, x_elems_5) && slt32(y_index_32, y_elems_6)) {\n        val_44 = ((__global float *) srcmem_2)[sext_i32_i64(idata_offset_34 +\n                                               index_in_35)];\n        ((__local float *) block_9)[sext_i32_i64(get_local_id_1_39 * 17 +\n                                    get_local_id_0_38)] = val_44;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    x_index_31 = get_group_id_1_41 * 16 + squot32(get_local_id_0_38, mulx_7);\n    y_index_32 = get_group_id_0_40 * 16 * mulx_7 + get_local_id_1_39 +\n        srem32(get_local_id_0_38, mulx_7) * 16;\n    \n    int32_t index_out_36 = y_index_32 * y_elems_6 + x_index_31;\n    \n    if (slt32(x_index_31, y_elems_6) && slt32(y_index_32, x_elems_5)) {\n        val_44 = ((__local float *) block_9)[sext_i32_i64(get_local_id_0_38 *\n                                             17 + get_local_id_1_39)];\n        ((__global float *) destmem_0)[sext_i32_i64(odata_offset_33 +\n                                       index_out_36)] = val_44;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void gpu_map_transpose_f32_low_width(const int block_dim0, const\n                                              int block_dim1, const\n                                              int block_dim2,\n                                              uint block_9_backing_offset_0,\n                                              int32_t destoffset_1,\n                                              int32_t srcoffset_3,\n                                              int32_t num_arrays_4,\n                                              int32_t x_elems_5,\n                                              int32_t y_elems_6, int32_t mulx_7,\n                    ",
            "                          int32_t muly_8, __global\n                                              unsigned char *destmem_0, __global\n                                              unsigned char *srcmem_2)\n{\n    volatile unsigned char *block_9_backing_0 =\n                           &shared_mem[block_9_backing_offset_0];\n    __local unsigned char *block_9;\n    \n    block_9 = (__local unsigned char *) block_9_backing_0;\n    \n    int32_t get_global_id_0_37;\n    \n    get_global_id_0_37 = get_global_id(0);\n    \n    int32_t get_local_id_0_38;\n    \n    get_local_id_0_38 = get_local_id(0);\n    \n    int32_t get_local_id_1_39;\n    \n    get_local_id_1_39 = get_local_id(1);\n    \n    int32_t get_group_id_0_40;\n    \n    get_group_id_0_40 = get_group_id(0);\n    \n    int32_t get_group_id_1_41;\n    \n    get_group_id_1_41 = get_group_id(1);\n    \n    int32_t get_group_id_2_42;\n    \n    get_group_id_2_42 = get_group_id(2);\n    \n    int32_t our_array_offset_30 = get_group_id_2_42 * x_elems_5 * y_elems_6;\n    int32_t odata_offset_33 = squot32(destoffset_1, 4) + our_array_offset_30;\n    int32_t idata_offset_34 = squot32(srcoffset_3, 4) + our_array_offset_30;\n    int32_t x_index_31 = get_group_id_0_40 * 16 + squot32(get_local_id_0_38,\n                                                          muly_8);\n    int32_t y_index_32 = get_group_id_1_41 * 16 * muly_8 + get_local_id_1_39 +\n            srem32(get_local_id_0_38, muly_8) * 16;\n    float val_44;\n    int32_t index_in_35 = y_index_32 * x_elems_5 + x_index_31;\n    \n    if (slt32(x_index_31, x_elems_5) && slt32(y_index_32, y_elems_6)) {\n        val_44 = ((__global float *) srcmem_2)[sext_i32_i64(idata_offset_34 +\n                                               index_in_35)];\n        ((__local float *) block_9)[sext_i32_i64(get_local_id_1_39 * 17 +\n                                    get_local_id_0_38)] = val_44;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    x_index_31 = get_group_id_1_41 * 16 * muly_8 + get_local_id_0_38 +\n        srem32(get_local_",
            "id_1_39, muly_8) * 16;\n    y_index_32 = get_group_id_0_40 * 16 + squot32(get_local_id_1_39, muly_8);\n    \n    int32_t index_out_36 = y_index_32 * y_elems_6 + x_index_31;\n    \n    if (slt32(x_index_31, y_elems_6) && slt32(y_index_32, x_elems_5)) {\n        val_44 = ((__local float *) block_9)[sext_i32_i64(get_local_id_0_38 *\n                                             17 + get_local_id_1_39)];\n        ((__global float *) destmem_0)[sext_i32_i64(odata_offset_33 +\n                                       index_out_36)] = val_44;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void gpu_map_transpose_f32_small(uint block_9_backing_offset_0,\n                                          int32_t destoffset_1,\n                                          int32_t srcoffset_3,\n                                          int32_t num_arrays_4,\n                                          int32_t x_elems_5, int32_t y_elems_6,\n                                          int32_t mulx_7, int32_t muly_8,\n                                          __global unsigned char *destmem_0,\n                                          __global unsigned char *srcmem_2)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *block_9_backing_0 =\n                           &shared_mem[block_9_backing_offset_0];\n    __local unsigned char *block_9;\n    \n    block_9 = (__local unsigned char *) block_9_backing_0;\n    \n    int32_t get_global_id_0_37;\n    \n    get_global_id_0_37 = get_global_id(0);\n    \n    int32_t get_local_id_0_38;\n    \n    get_local_id_0_38 = get_local_id(0);\n    \n    int32_t get_local_id_1_39;\n    \n    get_local_id_1_39 = get_local_id(1);\n    \n    int32_t get_group_id_0_40;\n    \n    get_group_id_0_40 = get_group_id(0);\n    \n    int32_t get_group_id_1_41;\n    \n    get_group_id_1_41 = get_group_id(1);\n    \n    int32_t get_group_id_2_42;\n    \n    get_group_id_2_42 = get_group_id(2);\n    \n    int32_t our_array_offset_30 = squot32(get_global_id_0",
            "_37, y_elems_6 *\n                                          x_elems_5) * (y_elems_6 * x_elems_5);\n    int32_t x_index_31 = squot32(srem32(get_global_id_0_37, y_elems_6 *\n                                        x_elems_5), y_elems_6);\n    int32_t y_index_32 = srem32(get_global_id_0_37, y_elems_6);\n    float val_44;\n    int32_t odata_offset_33 = squot32(destoffset_1, 4) + our_array_offset_30;\n    int32_t idata_offset_34 = squot32(srcoffset_3, 4) + our_array_offset_30;\n    int32_t index_in_35 = y_index_32 * x_elems_5 + x_index_31;\n    int32_t index_out_36 = x_index_31 * y_elems_6 + y_index_32;\n    \n    if (slt32(get_global_id_0_37, x_elems_5 * y_elems_6 * num_arrays_4)) {\n        val_44 = ((__global float *) srcmem_2)[sext_i32_i64(idata_offset_34 +\n                                               index_in_35)];\n        ((__global float *) destmem_0)[sext_i32_i64(odata_offset_33 +\n                                       index_out_36)] = val_44;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void gpu_map_transpose_f64(const int block_dim0, const int block_dim1,\n                                    const int block_dim2,\n                                    uint block_9_backing_offset_0,\n                                    int32_t destoffset_1, int32_t srcoffset_3,\n                                    int32_t num_arrays_4, int32_t x_elems_5,\n                                    int32_t y_elems_6, int32_t mulx_7,\n                                    int32_t muly_8, __global\n                                    unsigned char *destmem_0, __global\n                                    unsigned char *srcmem_2)\n{\n    volatile unsigned char *block_9_backing_0 =\n                           &shared_mem[block_9_backing_offset_0];\n    __local unsigned char *block_9;\n    \n    block_9 = (__local unsigned char *) block_9_backing_0;\n    \n    int32_t get_global_id_0_37;\n    \n    get_global_id_0_37 = get_global_id(0);\n    \n    int32_t get_local_id_0_38;\n    \n    get_local_id_0_38 = get_local_id(0);\n    \n",
            "    int32_t get_local_id_1_39;\n    \n    get_local_id_1_39 = get_local_id(1);\n    \n    int32_t get_group_id_0_40;\n    \n    get_group_id_0_40 = get_group_id(0);\n    \n    int32_t get_group_id_1_41;\n    \n    get_group_id_1_41 = get_group_id(1);\n    \n    int32_t get_group_id_2_42;\n    \n    get_group_id_2_42 = get_group_id(2);\n    \n    int32_t our_array_offset_30 = get_group_id_2_42 * x_elems_5 * y_elems_6;\n    int32_t odata_offset_33 = squot32(destoffset_1, 8) + our_array_offset_30;\n    int32_t idata_offset_34 = squot32(srcoffset_3, 8) + our_array_offset_30;\n    int32_t x_index_31 = get_global_id_0_37;\n    int32_t y_index_32 = get_group_id_1_41 * 32 + get_local_id_1_39;\n    double val_44;\n    \n    if (slt32(x_index_31, x_elems_5)) {\n        for (int32_t j_43 = 0; j_43 < 4; j_43++) {\n            int32_t index_in_35 = (y_index_32 + j_43 * 8) * x_elems_5 +\n                    x_index_31;\n            \n            if (slt32(y_index_32 + j_43 * 8, y_elems_6)) {\n                val_44 = ((__global\n                           double *) srcmem_2)[sext_i32_i64(idata_offset_34 +\n                                               index_in_35)];\n                ((__local double *) block_9)[sext_i32_i64((get_local_id_1_39 +\n                                                           j_43 * 8) * 33 +\n                                             get_local_id_0_38)] = val_44;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    x_index_31 = get_group_id_1_41 * 32 + get_local_id_0_38;\n    y_index_32 = get_group_id_0_40 * 32 + get_local_id_1_39;\n    if (slt32(x_index_31, y_elems_6)) {\n        for (int32_t j_43 = 0; j_43 < 4; j_43++) {\n            int32_t index_out_36 = (y_index_32 + j_43 * 8) * y_elems_6 +\n                    x_index_31;\n            \n            if (slt32(y_index_32 + j_43 * 8, x_elems_5)) {\n                val_44 = ((__local\n                           double *) block_9)[sext_i32_i64(get_local_id_0_38 *\n                                              33 + get_local_",
            "id_1_39 + j_43 *\n                                              8)];\n                ((__global double *) destmem_0)[sext_i32_i64(odata_offset_33 +\n                                                index_out_36)] = val_44;\n            }\n        }\n    }\n    \n  error_0:\n    return;\n}\n__kernel void gpu_map_transpose_f64_low_height(const int block_dim0, const\n                                               int block_dim1, const\n                                               int block_dim2,\n                                               uint block_9_backing_offset_0,\n                                               int32_t destoffset_1,\n                                               int32_t srcoffset_3,\n                                               int32_t num_arrays_4,\n                                               int32_t x_elems_5,\n                                               int32_t y_elems_6,\n                                               int32_t mulx_7, int32_t muly_8,\n                                               __global\n                                               unsigned char *destmem_0,\n                                               __global unsigned char *srcmem_2)\n{\n    volatile unsigned char *block_9_backing_0 =\n                           &shared_mem[block_9_backing_offset_0];\n    __local unsigned char *block_9;\n    \n    block_9 = (__local unsigned char *) block_9_backing_0;\n    \n    int32_t get_global_id_0_37;\n    \n    get_global_id_0_37 = get_global_id(0);\n    \n    int32_t get_local_id_0_38;\n    \n    get_local_id_0_38 = get_local_id(0);\n    \n    int32_t get_local_id_1_39;\n    \n    get_local_id_1_39 = get_local_id(1);\n    \n    int32_t get_group_id_0_40;\n    \n    get_group_id_0_40 = get_group_id(0);\n    \n    int32_t get_group_id_1_41;\n    \n    get_group_id_1_41 = get_group_id(1);\n    \n    int32_t get_group_id_2_42;\n    \n    get_group_id_2_42 = get_group_id(2);\n    \n    int32_t our_array_offset_30 = get_group_id_2_42 * x_elems_5 * y_elems_6;\n    int32_t oda",
            "ta_offset_33 = squot32(destoffset_1, 8) + our_array_offset_30;\n    int32_t idata_offset_34 = squot32(srcoffset_3, 8) + our_array_offset_30;\n    int32_t x_index_31 = get_group_id_0_40 * 16 * mulx_7 + get_local_id_0_38 +\n            srem32(get_local_id_1_39, mulx_7) * 16;\n    int32_t y_index_32 = get_group_id_1_41 * 16 + squot32(get_local_id_1_39,\n                                                          mulx_7);\n    double val_44;\n    int32_t index_in_35 = y_index_32 * x_elems_5 + x_index_31;\n    \n    if (slt32(x_index_31, x_elems_5) && slt32(y_index_32, y_elems_6)) {\n        val_44 = ((__global double *) srcmem_2)[sext_i32_i64(idata_offset_34 +\n                                                index_in_35)];\n        ((__local double *) block_9)[sext_i32_i64(get_local_id_1_39 * 17 +\n                                     get_local_id_0_38)] = val_44;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    x_index_31 = get_group_id_1_41 * 16 + squot32(get_local_id_0_38, mulx_7);\n    y_index_32 = get_group_id_0_40 * 16 * mulx_7 + get_local_id_1_39 +\n        srem32(get_local_id_0_38, mulx_7) * 16;\n    \n    int32_t index_out_36 = y_index_32 * y_elems_6 + x_index_31;\n    \n    if (slt32(x_index_31, y_elems_6) && slt32(y_index_32, x_elems_5)) {\n        val_44 = ((__local double *) block_9)[sext_i32_i64(get_local_id_0_38 *\n                                              17 + get_local_id_1_39)];\n        ((__global double *) destmem_0)[sext_i32_i64(odata_offset_33 +\n                                        index_out_36)] = val_44;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void gpu_map_transpose_f64_low_width(const int block_dim0, const\n                                              int block_dim1, const\n                                              int block_dim2,\n                                              uint block_9_backing_offset_0,\n                                              int32_t destoffset_1,\n                                              int32_t srcoffset_3,\n                    ",
            "                          int32_t num_arrays_4,\n                                              int32_t x_elems_5,\n                                              int32_t y_elems_6, int32_t mulx_7,\n                                              int32_t muly_8, __global\n                                              unsigned char *destmem_0, __global\n                                              unsigned char *srcmem_2)\n{\n    volatile unsigned char *block_9_backing_0 =\n                           &shared_mem[block_9_backing_offset_0];\n    __local unsigned char *block_9;\n    \n    block_9 = (__local unsigned char *) block_9_backing_0;\n    \n    int32_t get_global_id_0_37;\n    \n    get_global_id_0_37 = get_global_id(0);\n    \n    int32_t get_local_id_0_38;\n    \n    get_local_id_0_38 = get_local_id(0);\n    \n    int32_t get_local_id_1_39;\n    \n    get_local_id_1_39 = get_local_id(1);\n    \n    int32_t get_group_id_0_40;\n    \n    get_group_id_0_40 = get_group_id(0);\n    \n    int32_t get_group_id_1_41;\n    \n    get_group_id_1_41 = get_group_id(1);\n    \n    int32_t get_group_id_2_42;\n    \n    get_group_id_2_42 = get_group_id(2);\n    \n    int32_t our_array_offset_30 = get_group_id_2_42 * x_elems_5 * y_elems_6;\n    int32_t odata_offset_33 = squot32(destoffset_1, 8) + our_array_offset_30;\n    int32_t idata_offset_34 = squot32(srcoffset_3, 8) + our_array_offset_30;\n    int32_t x_index_31 = get_group_id_0_40 * 16 + squot32(get_local_id_0_38,\n                                                          muly_8);\n    int32_t y_index_32 = get_group_id_1_41 * 16 * muly_8 + get_local_id_1_39 +\n            srem32(get_local_id_0_38, muly_8) * 16;\n    double val_44;\n    int32_t index_in_35 = y_index_32 * x_elems_5 + x_index_31;\n    \n    if (slt32(x_index_31, x_elems_5) && slt32(y_index_32, y_elems_6)) {\n        val_44 = ((__global double *) srcmem_2)[sext_i32_i64(idata_offset_34 +\n                                                index_in_35)];\n        ((__local double *) block_9)[sext_i32_i64(get_local",
            "_id_1_39 * 17 +\n                                     get_local_id_0_38)] = val_44;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    x_index_31 = get_group_id_1_41 * 16 * muly_8 + get_local_id_0_38 +\n        srem32(get_local_id_1_39, muly_8) * 16;\n    y_index_32 = get_group_id_0_40 * 16 + squot32(get_local_id_1_39, muly_8);\n    \n    int32_t index_out_36 = y_index_32 * y_elems_6 + x_index_31;\n    \n    if (slt32(x_index_31, y_elems_6) && slt32(y_index_32, x_elems_5)) {\n        val_44 = ((__local double *) block_9)[sext_i32_i64(get_local_id_0_38 *\n                                              17 + get_local_id_1_39)];\n        ((__global double *) destmem_0)[sext_i32_i64(odata_offset_33 +\n                                        index_out_36)] = val_44;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void gpu_map_transpose_f64_small(uint block_9_backing_offset_0,\n                                          int32_t destoffset_1,\n                                          int32_t srcoffset_3,\n                                          int32_t num_arrays_4,\n                                          int32_t x_elems_5, int32_t y_elems_6,\n                                          int32_t mulx_7, int32_t muly_8,\n                                          __global unsigned char *destmem_0,\n                                          __global unsigned char *srcmem_2)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *block_9_backing_0 =\n                           &shared_mem[block_9_backing_offset_0];\n    __local unsigned char *block_9;\n    \n    block_9 = (__local unsigned char *) block_9_backing_0;\n    \n    int32_t get_global_id_0_37;\n    \n    get_global_id_0_37 = get_global_id(0);\n    \n    int32_t get_local_id_0_38;\n    \n    get_local_id_0_38 = get_local_id(0);\n    \n    int32_t get_local_id_1_39;\n    \n    get_local_id_1_39 = get_local_id(1);\n    \n    int32_t get_group_id_0_40;\n    \n    get_group_id_0_40 = get_group_id(0);\n   ",
            " \n    int32_t get_group_id_1_41;\n    \n    get_group_id_1_41 = get_group_id(1);\n    \n    int32_t get_group_id_2_42;\n    \n    get_group_id_2_42 = get_group_id(2);\n    \n    int32_t our_array_offset_30 = squot32(get_global_id_0_37, y_elems_6 *\n                                          x_elems_5) * (y_elems_6 * x_elems_5);\n    int32_t x_index_31 = squot32(srem32(get_global_id_0_37, y_elems_6 *\n                                        x_elems_5), y_elems_6);\n    int32_t y_index_32 = srem32(get_global_id_0_37, y_elems_6);\n    double val_44;\n    int32_t odata_offset_33 = squot32(destoffset_1, 8) + our_array_offset_30;\n    int32_t idata_offset_34 = squot32(srcoffset_3, 8) + our_array_offset_30;\n    int32_t index_in_35 = y_index_32 * x_elems_5 + x_index_31;\n    int32_t index_out_36 = x_index_31 * y_elems_6 + y_index_32;\n    \n    if (slt32(get_global_id_0_37, x_elems_5 * y_elems_6 * num_arrays_4)) {\n        val_44 = ((__global double *) srcmem_2)[sext_i32_i64(idata_offset_34 +\n                                                index_in_35)];\n        ((__global double *) destmem_0)[sext_i32_i64(odata_offset_33 +\n                                        index_out_36)] = val_44;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void gpu_map_transpose_i64(const int block_dim0, const int block_dim1,\n                                    const int block_dim2,\n                                    uint block_9_backing_offset_0,\n                                    int32_t destoffset_1, int32_t srcoffset_3,\n                                    int32_t num_arrays_4, int32_t x_elems_5,\n                                    int32_t y_elems_6, int32_t mulx_7,\n                                    int32_t muly_8, __global\n                                    unsigned char *destmem_0, __global\n                                    unsigned char *srcmem_2)\n{\n    volatile unsigned char *block_9_backing_0 =\n                           &shared_mem[block_9_backing_offset_0];\n    __local unsigned char *block_9;\n    \n   ",
            " block_9 = (__local unsigned char *) block_9_backing_0;\n    \n    int32_t get_global_id_0_37;\n    \n    get_global_id_0_37 = get_global_id(0);\n    \n    int32_t get_local_id_0_38;\n    \n    get_local_id_0_38 = get_local_id(0);\n    \n    int32_t get_local_id_1_39;\n    \n    get_local_id_1_39 = get_local_id(1);\n    \n    int32_t get_group_id_0_40;\n    \n    get_group_id_0_40 = get_group_id(0);\n    \n    int32_t get_group_id_1_41;\n    \n    get_group_id_1_41 = get_group_id(1);\n    \n    int32_t get_group_id_2_42;\n    \n    get_group_id_2_42 = get_group_id(2);\n    \n    int32_t our_array_offset_30 = get_group_id_2_42 * x_elems_5 * y_elems_6;\n    int32_t odata_offset_33 = squot32(destoffset_1, 8) + our_array_offset_30;\n    int32_t idata_offset_34 = squot32(srcoffset_3, 8) + our_array_offset_30;\n    int32_t x_index_31 = get_global_id_0_37;\n    int32_t y_index_32 = get_group_id_1_41 * 32 + get_local_id_1_39;\n    int64_t val_44;\n    \n    if (slt32(x_index_31, x_elems_5)) {\n        for (int32_t j_43 = 0; j_43 < 4; j_43++) {\n            int32_t index_in_35 = (y_index_32 + j_43 * 8) * x_elems_5 +\n                    x_index_31;\n            \n            if (slt32(y_index_32 + j_43 * 8, y_elems_6)) {\n                val_44 = ((__global\n                           int64_t *) srcmem_2)[sext_i32_i64(idata_offset_34 +\n                                                index_in_35)];\n                ((__local int64_t *) block_9)[sext_i32_i64((get_local_id_1_39 +\n                                                            j_43 * 8) * 33 +\n                                              get_local_id_0_38)] = val_44;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    x_index_31 = get_group_id_1_41 * 32 + get_local_id_0_38;\n    y_index_32 = get_group_id_0_40 * 32 + get_local_id_1_39;\n    if (slt32(x_index_31, y_elems_6)) {\n        for (int32_t j_43 = 0; j_43 < 4; j_43++) {\n            int32_t index_out_36 = (y_index_32 + j_43 * 8) * y_elems_6 +\n                    x_index_31;\n            \n",
            "            if (slt32(y_index_32 + j_43 * 8, x_elems_5)) {\n                val_44 = ((__local\n                           int64_t *) block_9)[sext_i32_i64(get_local_id_0_38 *\n                                               33 + get_local_id_1_39 + j_43 *\n                                               8)];\n                ((__global int64_t *) destmem_0)[sext_i32_i64(odata_offset_33 +\n                                                 index_out_36)] = val_44;\n            }\n        }\n    }\n    \n  error_0:\n    return;\n}\n__kernel void gpu_map_transpose_i64_low_height(const int block_dim0, const\n                                               int block_dim1, const\n                                               int block_dim2,\n                                               uint block_9_backing_offset_0,\n                                               int32_t destoffset_1,\n                                               int32_t srcoffset_3,\n                                               int32_t num_arrays_4,\n                                               int32_t x_elems_5,\n                                               int32_t y_elems_6,\n                                               int32_t mulx_7, int32_t muly_8,\n                                               __global\n                                               unsigned char *destmem_0,\n                                               __global unsigned char *srcmem_2)\n{\n    volatile unsigned char *block_9_backing_0 =\n                           &shared_mem[block_9_backing_offset_0];\n    __local unsigned char *block_9;\n    \n    block_9 = (__local unsigned char *) block_9_backing_0;\n    \n    int32_t get_global_id_0_37;\n    \n    get_global_id_0_37 = get_global_id(0);\n    \n    int32_t get_local_id_0_38;\n    \n    get_local_id_0_38 = get_local_id(0);\n    \n    int32_t get_local_id_1_39;\n    \n    get_local_id_1_39 = get_local_id(1);\n    \n    int32_t get_group_id_0_40;\n    \n    get_group_id_0_40 = get_group_id(0);\n    \n    int32_t get_g",
            "roup_id_1_41;\n    \n    get_group_id_1_41 = get_group_id(1);\n    \n    int32_t get_group_id_2_42;\n    \n    get_group_id_2_42 = get_group_id(2);\n    \n    int32_t our_array_offset_30 = get_group_id_2_42 * x_elems_5 * y_elems_6;\n    int32_t odata_offset_33 = squot32(destoffset_1, 8) + our_array_offset_30;\n    int32_t idata_offset_34 = squot32(srcoffset_3, 8) + our_array_offset_30;\n    int32_t x_index_31 = get_group_id_0_40 * 16 * mulx_7 + get_local_id_0_38 +\n            srem32(get_local_id_1_39, mulx_7) * 16;\n    int32_t y_index_32 = get_group_id_1_41 * 16 + squot32(get_local_id_1_39,\n                                                          mulx_7);\n    int64_t val_44;\n    int32_t index_in_35 = y_index_32 * x_elems_5 + x_index_31;\n    \n    if (slt32(x_index_31, x_elems_5) && slt32(y_index_32, y_elems_6)) {\n        val_44 = ((__global int64_t *) srcmem_2)[sext_i32_i64(idata_offset_34 +\n                                                 index_in_35)];\n        ((__local int64_t *) block_9)[sext_i32_i64(get_local_id_1_39 * 17 +\n                                      get_local_id_0_38)] = val_44;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    x_index_31 = get_group_id_1_41 * 16 + squot32(get_local_id_0_38, mulx_7);\n    y_index_32 = get_group_id_0_40 * 16 * mulx_7 + get_local_id_1_39 +\n        srem32(get_local_id_0_38, mulx_7) * 16;\n    \n    int32_t index_out_36 = y_index_32 * y_elems_6 + x_index_31;\n    \n    if (slt32(x_index_31, y_elems_6) && slt32(y_index_32, x_elems_5)) {\n        val_44 = ((__local int64_t *) block_9)[sext_i32_i64(get_local_id_0_38 *\n                                               17 + get_local_id_1_39)];\n        ((__global int64_t *) destmem_0)[sext_i32_i64(odata_offset_33 +\n                                         index_out_36)] = val_44;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void gpu_map_transpose_i64_low_width(const int block_dim0, const\n                                              int block_dim1, const\n                                              ",
            "int block_dim2,\n                                              uint block_9_backing_offset_0,\n                                              int32_t destoffset_1,\n                                              int32_t srcoffset_3,\n                                              int32_t num_arrays_4,\n                                              int32_t x_elems_5,\n                                              int32_t y_elems_6, int32_t mulx_7,\n                                              int32_t muly_8, __global\n                                              unsigned char *destmem_0, __global\n                                              unsigned char *srcmem_2)\n{\n    volatile unsigned char *block_9_backing_0 =\n                           &shared_mem[block_9_backing_offset_0];\n    __local unsigned char *block_9;\n    \n    block_9 = (__local unsigned char *) block_9_backing_0;\n    \n    int32_t get_global_id_0_37;\n    \n    get_global_id_0_37 = get_global_id(0);\n    \n    int32_t get_local_id_0_38;\n    \n    get_local_id_0_38 = get_local_id(0);\n    \n    int32_t get_local_id_1_39;\n    \n    get_local_id_1_39 = get_local_id(1);\n    \n    int32_t get_group_id_0_40;\n    \n    get_group_id_0_40 = get_group_id(0);\n    \n    int32_t get_group_id_1_41;\n    \n    get_group_id_1_41 = get_group_id(1);\n    \n    int32_t get_group_id_2_42;\n    \n    get_group_id_2_42 = get_group_id(2);\n    \n    int32_t our_array_offset_30 = get_group_id_2_42 * x_elems_5 * y_elems_6;\n    int32_t odata_offset_33 = squot32(destoffset_1, 8) + our_array_offset_30;\n    int32_t idata_offset_34 = squot32(srcoffset_3, 8) + our_array_offset_30;\n    int32_t x_index_31 = get_group_id_0_40 * 16 + squot32(get_local_id_0_38,\n                                                          muly_8);\n    int32_t y_index_32 = get_group_id_1_41 * 16 * muly_8 + get_local_id_1_39 +\n            srem32(get_local_id_0_38, muly_8) * 16;\n    int64_t val_44;\n    int32_t index_in_35 = y_index_32 * x_elems_5 + x_index_31;\n    \n    if (slt32(x_index_31",
            ", x_elems_5) && slt32(y_index_32, y_elems_6)) {\n        val_44 = ((__global int64_t *) srcmem_2)[sext_i32_i64(idata_offset_34 +\n                                                 index_in_35)];\n        ((__local int64_t *) block_9)[sext_i32_i64(get_local_id_1_39 * 17 +\n                                      get_local_id_0_38)] = val_44;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    x_index_31 = get_group_id_1_41 * 16 * muly_8 + get_local_id_0_38 +\n        srem32(get_local_id_1_39, muly_8) * 16;\n    y_index_32 = get_group_id_0_40 * 16 + squot32(get_local_id_1_39, muly_8);\n    \n    int32_t index_out_36 = y_index_32 * y_elems_6 + x_index_31;\n    \n    if (slt32(x_index_31, y_elems_6) && slt32(y_index_32, x_elems_5)) {\n        val_44 = ((__local int64_t *) block_9)[sext_i32_i64(get_local_id_0_38 *\n                                               17 + get_local_id_1_39)];\n        ((__global int64_t *) destmem_0)[sext_i32_i64(odata_offset_33 +\n                                         index_out_36)] = val_44;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void gpu_map_transpose_i64_small(uint block_9_backing_offset_0,\n                                          int32_t destoffset_1,\n                                          int32_t srcoffset_3,\n                                          int32_t num_arrays_4,\n                                          int32_t x_elems_5, int32_t y_elems_6,\n                                          int32_t mulx_7, int32_t muly_8,\n                                          __global unsigned char *destmem_0,\n                                          __global unsigned char *srcmem_2)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *block_9_backing_0 =\n                           &shared_mem[block_9_backing_offset_0];\n    __local unsigned char *block_9;\n    \n    block_9 = (__local unsigned char *) block_9_backing_0;\n    \n    int32_t get_global_id_0_37;\n    \n    get_global_id_0_37 = get_global",
            "_id(0);\n    \n    int32_t get_local_id_0_38;\n    \n    get_local_id_0_38 = get_local_id(0);\n    \n    int32_t get_local_id_1_39;\n    \n    get_local_id_1_39 = get_local_id(1);\n    \n    int32_t get_group_id_0_40;\n    \n    get_group_id_0_40 = get_group_id(0);\n    \n    int32_t get_group_id_1_41;\n    \n    get_group_id_1_41 = get_group_id(1);\n    \n    int32_t get_group_id_2_42;\n    \n    get_group_id_2_42 = get_group_id(2);\n    \n    int32_t our_array_offset_30 = squot32(get_global_id_0_37, y_elems_6 *\n                                          x_elems_5) * (y_elems_6 * x_elems_5);\n    int32_t x_index_31 = squot32(srem32(get_global_id_0_37, y_elems_6 *\n                                        x_elems_5), y_elems_6);\n    int32_t y_index_32 = srem32(get_global_id_0_37, y_elems_6);\n    int64_t val_44;\n    int32_t odata_offset_33 = squot32(destoffset_1, 8) + our_array_offset_30;\n    int32_t idata_offset_34 = squot32(srcoffset_3, 8) + our_array_offset_30;\n    int32_t index_in_35 = y_index_32 * x_elems_5 + x_index_31;\n    int32_t index_out_36 = x_index_31 * y_elems_6 + y_index_32;\n    \n    if (slt32(get_global_id_0_37, x_elems_5 * y_elems_6 * num_arrays_4)) {\n        val_44 = ((__global int64_t *) srcmem_2)[sext_i32_i64(idata_offset_34 +\n                                                 index_in_35)];\n        ((__global int64_t *) destmem_0)[sext_i32_i64(odata_offset_33 +\n                                         index_out_36)] = val_44;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void mainzicopy_321104(int64_t n_292675,\n                                int64_t partition_sizze_292766,\n                                int64_t i_292846, __global\n                                unsigned char *mem_318531, __global\n                                unsigned char *mem_318539)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    int32_t copy_gtid_321104;\n    int32_t copy_ltid_321105;\n    int32_t copy_gid_321106;\n    \n    copy_gtid_321104 = get_global_id(",
            "0);\n    copy_ltid_321105 = get_local_id(0);\n    copy_gid_321106 = get_group_id(0);\n    \n    int64_t slice_321110 = partition_sizze_292766;\n    int64_t copy_i_321109 = sext_i32_i64(copy_gtid_321104);\n    int64_t remnant_321111 = sext_i32_i64(copy_gtid_321104) - copy_i_321109;\n    \n    if (slt64(sext_i32_i64(copy_gtid_321104), partition_sizze_292766)) {\n        int64_t tmp_321112;\n        \n        tmp_321112 = ((__global int64_t *) mem_318531)[i_292846 +\n                                                       copy_i_321109 *\n                                                       n_292675];\n        ((__global int64_t *) mem_318539)[copy_i_321109] = tmp_321112;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void mainzicopy_321321(int64_t n_p_292677,\n                                int64_t partition_sizze_292766,\n                                int64_t defunc_0_f_res_292820, int64_t i_292895,\n                                __global unsigned char *mem_318595, __global\n                                unsigned char *mem_318605)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    int32_t copy_gtid_321321;\n    int32_t copy_ltid_321322;\n    int32_t copy_gid_321323;\n    \n    copy_gtid_321321 = get_global_id(0);\n    copy_ltid_321322 = get_local_id(0);\n    copy_gid_321323 = get_group_id(0);\n    \n    int64_t slice_321328 = n_p_292677;\n    int64_t slice_321329 = partition_sizze_292766 * slice_321328;\n    int64_t copy_i_321326 = squot64(sext_i32_i64(copy_gtid_321321),\n                                    slice_321328);\n    int64_t remnant_321330 = sext_i32_i64(copy_gtid_321321) - copy_i_321326 *\n            slice_321328;\n    int64_t copy_i_321327 = remnant_321330;\n    int64_t remnant_321331 = remnant_321330 - copy_i_321327;\n    \n    if (slt64(sext_i32_i64(copy_gtid_321321), partition_sizze_292766 *\n              n_p_292677)) {\n        int64_t tmp_321332;\n        \n        tmp_321332 = ((__global int64_t *) mem_318595)[i_292895 +\n              ",
            "                                         (copy_i_321326 *\n                                                        (defunc_0_f_res_292820 *\n                                                         n_p_292677) +\n                                                        copy_i_321327 *\n                                                        defunc_0_f_res_292820)];\n        ((__global int64_t *) mem_318605)[copy_i_321326 * n_p_292677 +\n                                          copy_i_321327] = tmp_321332;\n    }\n    \n  error_0:\n    return;\n}\n__kernel void mainziseghist_global_316946(__global int *global_failure,\n                                          int failure_is_an_option, __global\n                                          int64_t *global_failure_args,\n                                          int64_t partition_sizze_292766,\n                                          int64_t replicate_arg_297080,\n                                          int64_t loopz2089U_297094,\n                                          int64_t num_groups_316941,\n                                          int64_t ctx_param_ext_320221,\n                                          int64_t ctx_param_ext_320222,\n                                          int64_t ctx_param_ext_320231,\n                                          int64_t ctx_param_ext_320232,\n                                          int32_t num_subhistos_325275,\n                                          int32_t chk_i_325344,\n                                          int64_t hist_H_chk_325345, __global\n                                          unsigned char *mem_param_320224,\n                                          __global\n                                          unsigned char *mem_param_320234,\n                                          __global unsigned char *mem_320266,\n                                          __global\n                                          unsigned char *defunc_1_map_res_subhistos_mem_325276)\n{\n    #define seghist_grou",
            "p_sizze_316939 (mainziseghist_group_sizze_316938)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325346;\n    int32_t local_tid_325347;\n    int64_t group_sizze_325350;\n    int32_t wave_sizze_325349;\n    int32_t group_tid_325348;\n    \n    global_tid_325346 = get_global_id(0);\n    local_tid_325347 = get_local_id(0);\n    group_sizze_325350 = get_local_size(0);\n    wave_sizze_325349 = LOCKSTEP_WIDTH;\n    group_tid_325348 = get_group_id(0);\n    \n    int32_t phys_tid_316946 = global_tid_325346;\n    int32_t subhisto_ind_325351 = squot32(global_tid_325346,\n                                          sdiv_up32(sext_i64_i32(seghist_group_sizze_316939 *\n                                                    num_groups_316941),\n                                                    num_subhistos_325275));\n    int64_t num_chunks_325352 = sdiv_up64(loopz2089U_297094,\n                                          sext_i32_i64(sext_i64_i32(seghist_group_sizze_316939 *\n                                          num_groups_316941)));\n    \n    for (int64_t chunk_i_325353 = 0; chunk_i_325353 < num_chunks_325352;\n         chunk_i_325353++) {\n        int64_t i_325354 = chunk_i_325353 *\n                sext_i32_i64(sext_i64_i32(seghist_group_sizze_316939 *\n                num_groups_316941)) + sext_i32_i64(global_tid_325346);\n        \n        if (slt64(i_325354, loopz2089U_297094)) {\n            int32_t gtid_316945 = sext_i64_i32(i_325354);\n            \n            if (slt64(i_325354, loopz2089U_297094)) {\n                int32_t x_316950;\n                \n                x_316950 = ((__global\n                             int32_t *) mem_param_320224)[ctx_param_ext_320221 +\n                                                          gtid_316945 *\n                                                          ctx_param_ext_320222];\n                \n                double x_316951;\n     ",
            "           \n                x_316951 = ((__global\n                             double *) mem_param_320234)[ctx_param_ext_320231 +\n                                                         gtid_316945 *\n                                                         ctx_param_ext_320232];\n                \n                int32_t sgmind_316953 = sub32(x_316950, 1);\n                int64_t sgmind_316954 = sext_i32_i64(sgmind_316953);\n                bool x_316955 = sle64((int64_t) 0, sgmind_316954);\n                bool y_316956 = slt64(sgmind_316954, partition_sizze_292766);\n                bool bounds_check_316957 = x_316955 && y_316956;\n                bool index_certs_316958;\n                \n                if (!bounds_check_316957) {\n                    {\n                        if (atomic_cmpxchg_i32_global(global_failure, -1, 76) ==\n                            -1) {\n                            global_failure_args[0] = (int64_t) sgmind_316954;\n                            global_failure_args[1] =\n                                (int64_t) partition_sizze_292766;\n                            ;\n                        }\n                        return;\n                    }\n                }\n                \n                double pivot_316959;\n                \n                pivot_316959 = ((__global double *) mem_320266)[sgmind_316954];\n                \n                int32_t h_ind_316960 = shl32(sgmind_316953, 1);\n                bool cond_316961 = x_316951 < pivot_316959;\n                int32_t binop_p_316962;\n                \n                if (cond_316961) {\n                    binop_p_316962 = h_ind_316960;\n                } else {\n                    bool cond_316963 = pivot_316959 == x_316951;\n                    int32_t binop_p_f_res_316964;\n                    \n                    if (cond_316963) {\n                        int32_t binop_p_f_res_t_res_316965 = add32(1,\n                                                                   h_ind_316960);\n            ",
            "            \n                        binop_p_f_res_316964 = binop_p_f_res_t_res_316965;\n                    } else {\n                        binop_p_f_res_316964 = -1;\n                    }\n                    binop_p_316962 = binop_p_f_res_316964;\n                }\n                \n                int64_t defunc_0_f_res_316966 = sext_i32_i64(binop_p_316962);\n                \n                // save map-out results\n                { }\n                // perform atomic updates\n                {\n                    if (sle64(sext_i32_i64(chk_i_325344) * hist_H_chk_325345,\n                              defunc_0_f_res_316966) &&\n                        (slt64(defunc_0_f_res_316966,\n                               sext_i32_i64(chk_i_325344) * hist_H_chk_325345 +\n                               hist_H_chk_325345) && (sle64((int64_t) 0,\n                                                            defunc_0_f_res_316966) &&\n                                                      slt64(defunc_0_f_res_316966,\n                                                            replicate_arg_297080)))) {\n                        int32_t x_316947;\n                        int32_t x_316948 = 1;\n                        int32_t old_325355;\n                        \n                        old_325355 = atomic_add_i32_global(&((volatile __global\n                                                              int *) defunc_1_map_res_subhistos_mem_325276)[sext_i32_i64(subhisto_ind_325351) *\n                                                                                                            replicate_arg_297080 +\n                                                                                                            defunc_0_f_res_316966],\n                                                           (int) x_316948);\n                    }\n                }\n            }\n        }\n    }\n    \n  error_0:\n    return;\n    #undef seghist_group_sizze_316939\n}\n__kernel void mainziseghist_local_316946(__glo",
            "bal int *global_failure,\n                                         int failure_is_an_option, __global\n                                         int64_t *global_failure_args,\n                                         uint subhistogram_local_mem_325313_backing_offset_0,\n                                         int64_t partition_sizze_292766,\n                                         int64_t replicate_arg_297080,\n                                         int64_t loopz2089U_297094,\n                                         int64_t ctx_param_ext_320221,\n                                         int64_t ctx_param_ext_320222,\n                                         int64_t ctx_param_ext_320231,\n                                         int64_t ctx_param_ext_320232,\n                                         int32_t max_group_sizze_325285,\n                                         int64_t num_groups_325286,\n                                         int32_t hist_M_325292,\n                                         int32_t chk_i_325296,\n                                         int64_t num_segments_325297,\n                                         int64_t hist_H_chk_325298,\n                                         int64_t histo_sizze_325299,\n                                         int32_t init_per_thread_325300,\n                                         __global\n                                         unsigned char *mem_param_320224,\n                                         __global\n                                         unsigned char *mem_param_320234,\n                                         __global unsigned char *mem_320266,\n                                         __global\n                                         unsigned char *defunc_1_map_res_subhistos_mem_325276)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *subhistogram_local_mem_325313_backing_0 =\n                           &shared_mem[subhistogram_local_",
            "mem_325313_backing_offset_0];\n    volatile __local bool local_failure;\n    \n    if (failure_is_an_option) {\n        int failed = *global_failure >= 0;\n        \n        if (failed)\n            return;\n    }\n    local_failure = false;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t global_tid_325301;\n    int32_t local_tid_325302;\n    int64_t group_sizze_325305;\n    int32_t wave_sizze_325304;\n    int32_t group_tid_325303;\n    \n    global_tid_325301 = get_global_id(0);\n    local_tid_325302 = get_local_id(0);\n    group_sizze_325305 = get_local_size(0);\n    wave_sizze_325304 = LOCKSTEP_WIDTH;\n    group_tid_325303 = get_group_id(0);\n    \n    int32_t phys_tid_316946 = global_tid_325301;\n    int32_t phys_group_id_325306;\n    \n    phys_group_id_325306 = get_group_id(0);\n    for (int32_t i_325307 = 0; i_325307 <\n         sdiv_up32(sext_i64_i32(num_groups_325286 * num_segments_325297) -\n                   phys_group_id_325306, sext_i64_i32(num_groups_325286));\n         i_325307++) {\n        int32_t virt_group_id_325308 = phys_group_id_325306 + i_325307 *\n                sext_i64_i32(num_groups_325286);\n        int32_t flat_segment_id_325309 = squot32(virt_group_id_325308,\n                                                 sext_i64_i32(num_groups_325286));\n        int32_t gid_in_segment_325310 = srem32(virt_group_id_325308,\n                                               sext_i64_i32(num_groups_325286));\n        int32_t pgtid_in_segment_325311 = gid_in_segment_325310 *\n                sext_i64_i32(max_group_sizze_325285) + local_tid_325302;\n        int32_t threads_per_segment_325312 = sext_i64_i32(num_groups_325286 *\n                max_group_sizze_325285);\n        __local unsigned char *subhistogram_local_mem_325313;\n        \n        subhistogram_local_mem_325313 = (__local\n                                         unsigned char *) subhistogram_local_mem_325313_backing_0;\n        \n        int32_t thread_local_subhisto_i_325315 = srem32(local_tid_325302,\n                         ",
            "                               hist_M_325292);\n        \n        // initialize histograms in local memory\n        {\n            for (int32_t local_i_325316 = 0; local_i_325316 <\n                 init_per_thread_325300; local_i_325316++) {\n                int32_t j_325317 = local_i_325316 *\n                        sext_i64_i32(max_group_sizze_325285) + local_tid_325302;\n                int32_t j_offset_325318 = hist_M_325292 *\n                        sext_i64_i32(histo_sizze_325299) *\n                        gid_in_segment_325310 + j_325317;\n                int32_t local_subhisto_i_325319 = squot32(j_325317,\n                                                          sext_i64_i32(histo_sizze_325299));\n                int32_t global_subhisto_i_325320 = squot32(j_offset_325318,\n                                                           sext_i64_i32(histo_sizze_325299));\n                \n                if (slt32(j_325317, hist_M_325292 *\n                          sext_i64_i32(histo_sizze_325299))) {\n                    // First subhistogram is initialised from global memory; others with neutral element.\n                    {\n                        if (global_subhisto_i_325320 == 0) {\n                            int32_t tmp_325321;\n                            \n                            tmp_325321 = ((__global\n                                           int32_t *) defunc_1_map_res_subhistos_mem_325276)[sext_i32_i64(srem32(j_325317,\n                                                                                                                 sext_i64_i32(histo_sizze_325299))) +\n                                                                                             sext_i32_i64(chk_i_325296) *\n                                                                                             hist_H_chk_325298];\n                            ((__local\n                              int32_t *) subhistogram_local_mem_325313)[sext_i32_i64(local_subhisto_i_325319) *\n               ",
            "                                                         hist_H_chk_325298 +\n                                                                        sext_i32_i64(srem32(j_325317,\n                                                                                            sext_i64_i32(histo_sizze_325299)))] =\n                                tmp_325321;\n                        } else {\n                            ((__local\n                              int32_t *) subhistogram_local_mem_325313)[sext_i32_i64(local_subhisto_i_325319) *\n                                                                        hist_H_chk_325298 +\n                                                                        sext_i32_i64(srem32(j_325317,\n                                                                                            sext_i64_i32(histo_sizze_325299)))] =\n                                0;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t num_chunks_325322 = sdiv_up32(sext_i64_i32(loopz2089U_297094),\n                                              threads_per_segment_325312);\n        \n        for (int32_t chunk_i_325323 = 0; chunk_i_325323 < num_chunks_325322;\n             chunk_i_325323++) {\n            int32_t i_325324 = chunk_i_325323 * threads_per_segment_325312 +\n                    pgtid_in_segment_325311;\n            \n            if (slt32(i_325324, sext_i64_i32(loopz2089U_297094))) {\n                int32_t gtid_316945 = i_325324;\n                int32_t x_316950;\n                \n                x_316950 = ((__global\n                             int32_t *) mem_param_320224)[ctx_param_ext_320221 +\n                                                          gtid_316945 *\n                                                          ctx_param_ext_320222];\n                \n                double x_316951;\n                \n                x_316951 = ((__global\n                ",
            "             double *) mem_param_320234)[ctx_param_ext_320231 +\n                                                         gtid_316945 *\n                                                         ctx_param_ext_320232];\n                \n                int32_t sgmind_316953 = sub32(x_316950, 1);\n                int64_t sgmind_316954 = sext_i32_i64(sgmind_316953);\n                bool x_316955 = sle64((int64_t) 0, sgmind_316954);\n                bool y_316956 = slt64(sgmind_316954, partition_sizze_292766);\n                bool bounds_check_316957 = x_316955 && y_316956;\n                bool index_certs_316958;\n                \n                if (!bounds_check_316957) {\n                    {\n                        if (atomic_cmpxchg_i32_global(global_failure, -1, 75) ==\n                            -1) {\n                            global_failure_args[0] = (int64_t) sgmind_316954;\n                            global_failure_args[1] =\n                                (int64_t) partition_sizze_292766;\n                            ;\n                        }\n                        local_failure = true;\n                        goto error_0;\n                    }\n                }\n                \n                double pivot_316959;\n                \n                pivot_316959 = ((__global double *) mem_320266)[sgmind_316954];\n                \n                int32_t h_ind_316960 = shl32(sgmind_316953, 1);\n                bool cond_316961 = x_316951 < pivot_316959;\n                int32_t binop_p_316962;\n                \n                if (cond_316961) {\n                    binop_p_316962 = h_ind_316960;\n                } else {\n                    bool cond_316963 = pivot_316959 == x_316951;\n                    int32_t binop_p_f_res_316964;\n                    \n                    if (cond_316963) {\n                        int32_t binop_p_f_res_t_res_316965 = add32(1,\n                                                                   h_ind_316960);\n                        \n ",
            "                       binop_p_f_res_316964 = binop_p_f_res_t_res_316965;\n                    } else {\n                        binop_p_f_res_316964 = -1;\n                    }\n                    binop_p_316962 = binop_p_f_res_316964;\n                }\n                \n                int64_t defunc_0_f_res_316966 = sext_i32_i64(binop_p_316962);\n                \n                if (chk_i_325296 == 0) {\n                    // save map-out results\n                    { }\n                }\n                // perform atomic updates\n                {\n                    if ((sle64((int64_t) 0, defunc_0_f_res_316966) &&\n                         slt64(defunc_0_f_res_316966, replicate_arg_297080)) &&\n                        (sle64(sext_i32_i64(chk_i_325296) * hist_H_chk_325298,\n                               defunc_0_f_res_316966) &&\n                         slt64(defunc_0_f_res_316966,\n                               sext_i32_i64(chk_i_325296) * hist_H_chk_325298 +\n                               hist_H_chk_325298))) {\n                        int32_t x_316947;\n                        int32_t x_316948 = 1;\n                        int32_t old_325325;\n                        \n                        old_325325 = atomic_add_i32_local(&((volatile __local\n                                                             int *) subhistogram_local_mem_325313)[sext_i32_i64(thread_local_subhisto_i_325315) *\n                                                                                                   hist_H_chk_325298 +\n                                                                                                   (defunc_0_f_res_316966 -\n                                                                                                    sext_i32_i64(chk_i_325296) *\n                                                                                                    hist_H_chk_325298)],\n                                                          (int) x_316948);\n                    }\n   ",
            "             }\n            }\n        }\n        \n      error_0:\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n        if (local_failure)\n            return;\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n        // Compact the multiple local memory subhistograms to result in global memory\n        {\n            int64_t trunc_H_325326 = smin64(hist_H_chk_325298,\n                                            replicate_arg_297080 -\n                                            sext_i32_i64(chk_i_325296) *\n                                            hist_H_chk_325298);\n            int32_t histo_sizze_325327 = sext_i64_i32(trunc_H_325326);\n            \n            for (int32_t local_i_325328 = 0; local_i_325328 <\n                 init_per_thread_325300; local_i_325328++) {\n                int32_t j_325329 = local_i_325328 *\n                        sext_i64_i32(max_group_sizze_325285) + local_tid_325302;\n                \n                if (slt32(j_325329, histo_sizze_325327)) {\n                    int32_t x_316947;\n                    int32_t x_316948;\n                    \n                    // Read values from subhistogram 0.\n                    {\n                        x_316947 = ((__local\n                                     int32_t *) subhistogram_local_mem_325313)[sext_i32_i64(j_325329)];\n                    }\n                    // Accumulate based on values in other subhistograms.\n                    {\n                        for (int32_t subhisto_id_325330 = 0;\n                             subhisto_id_325330 < hist_M_325292 - 1;\n                             subhisto_id_325330++) {\n                            x_316948 = ((__local\n                                         int32_t *) subhistogram_local_mem_325313)[(sext_i32_i64(subhisto_id_325330) +\n                                                                                    (int64_t) 1) *\n                                                                                   hist_H_chk_325",
            "298 +\n                                                                                   sext_i32_i64(j_325329)];\n                            \n                            int32_t defunc_1_f_res_316949 = add32(x_316947,\n                                                                  x_316948);\n                            \n                            x_316947 = defunc_1_f_res_316949;\n                        }\n                    }\n                    // Put final bucket value in global memory.\n                    {\n                        ((__global\n                          int32_t *) defunc_1_map_res_subhistos_mem_325276)[srem64(sext_i32_i64(virt_group_id_325308),\n                                                                                   num_groups_325286) *\n                                                                            replicate_arg_297080 +\n                                                                            (sext_i32_i64(j_325329) +\n                                                                             sext_i32_i64(chk_i_325296) *\n                                                                             hist_H_chk_325298)] =\n                            x_316947;\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n}\n__kernel void mainzisegmap_297617(__global int *global_failure,\n                                  int64_t m_292674, int64_t n_292675,\n                                  int64_t num_groups_297622, __global\n                                  unsigned char *mem_318493, __global\n                                  unsigned char *mem_318497, __global\n                                  unsigned char *mem_318500, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_318509)\n{\n    #define segmap_group_sizze_297620 (mainzisegmap_group_sizze_29761",
            "9)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_320937;\n    int32_t local_tid_320938;\n    int64_t group_sizze_320941;\n    int32_t wave_sizze_320940;\n    int32_t group_tid_320939;\n    \n    global_tid_320937 = get_global_id(0);\n    local_tid_320938 = get_local_id(0);\n    group_sizze_320941 = get_local_size(0);\n    wave_sizze_320940 = LOCKSTEP_WIDTH;\n    group_tid_320939 = get_group_id(0);\n    \n    int32_t phys_tid_297617 = global_tid_320937;\n    int32_t phys_group_id_320942;\n    \n    phys_group_id_320942 = get_group_id(0);\n    for (int32_t i_320943 = 0; i_320943 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(m_292674,\n                                          segmap_group_sizze_297620)) -\n                   phys_group_id_320942, sext_i64_i32(num_groups_297622));\n         i_320943++) {\n        int32_t virt_group_id_320944 = phys_group_id_320942 + i_320943 *\n                sext_i64_i32(num_groups_297622);\n        int64_t global_tid_320945 = sext_i32_i64(virt_group_id_320944) *\n                segmap_group_sizze_297620 + sext_i32_i64(local_tid_320938);\n        int64_t slice_320946 = m_292674;\n        int64_t write_i_297616 = global_tid_320945;\n        int64_t remnant_320947 = global_tid_320945 - write_i_297616;\n        \n        if (slt64(write_i_297616, m_292674)) {\n            int64_t c_292772;\n            \n            c_292772 = ((__global int64_t *) mem_318500)[write_i_297616];\n            \n            int64_t offset_292773;\n            \n            offset_292773 = ((__global int64_t *) mem_318497)[write_i_297616];\n            \n            bool is_this_one_292777 = c_292772 == (int64_t) 0;\n            int64_t this_offset_292778 = (int64_t) -1 + offset_292773;\n            int64_t total_res_292779;\n            \n            if (is_this_one_292777) {\n                total_res_292779 = this_offset_292778;\n            } else {\n                total_",
            "res_292779 = (int64_t) -1;\n            }\n            if (sle64((int64_t) 0, total_res_292779) && slt64(total_res_292779,\n                                                              m_292674)) {\n                for (int64_t i_320948 = 0; i_320948 < n_292675; i_320948++) {\n                    float tmp_320949;\n                    \n                    tmp_320949 = ((__global\n                                   float *) mem_318493)[write_i_297616 +\n                                                        i_320948 * m_292674];\n                    ((__global float *) mem_318506)[total_res_292779 *\n                                                    n_292675 + i_320948] =\n                        tmp_320949;\n                }\n            }\n            if (sle64((int64_t) 0, total_res_292779) && slt64(total_res_292779,\n                                                              m_292674)) {\n                ((__global int64_t *) mem_318509)[total_res_292779] =\n                    write_i_297616;\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_297620\n}\n__kernel void mainzisegmap_297793(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_318531, __global\n                                  unsigned char *mem_318535)\n{\n    #define segmap_group_sizze_297788 (mainzisegmap_group_sizze_297673)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321094;\n    int32_t local_tid_321095;\n    int64_t group_sizze_321098;\n    int32_t wave_sizze_321097;\n    int32_t group_tid_321096;\n    \n    global_tid_321094 = get_global_id(0);\n    local_tid_321095 ",
            "= get_local_id(0);\n    group_sizze_321098 = get_local_size(0);\n    wave_sizze_321097 = LOCKSTEP_WIDTH;\n    group_tid_321096 = get_group_id(0);\n    \n    int32_t phys_tid_297793 = global_tid_321094;\n    int64_t global_tid_321099 = sext_i32_i64(group_tid_321096) *\n            segmap_group_sizze_297788 + sext_i32_i64(local_tid_321095);\n    int64_t slice_321100 = n_292675;\n    int64_t slice_321101 = partition_sizze_292766 * slice_321100;\n    int64_t gtid_297791 = squot64(global_tid_321099, slice_321100);\n    int64_t remnant_321102 = global_tid_321099 - gtid_297791 * slice_321100;\n    int64_t gtid_297792 = remnant_321102;\n    int64_t remnant_321103 = remnant_321102 - gtid_297792;\n    \n    if (slt64(gtid_297791, partition_sizze_292766) && slt64(gtid_297792,\n                                                            n_292675)) {\n        float x_297794;\n        \n        x_297794 = ((__global float *) mem_318506)[gtid_297791 * n_292675 +\n                                                   gtid_297792];\n        \n        bool isnan_res_297797;\n        \n        isnan_res_297797 = futrts_isnan32(x_297794);\n        \n        bool defunc_0_p_res_297798 = !isnan_res_297797;\n        int64_t defunc_1_f_res_297799;\n        \n        if (defunc_0_p_res_297798) {\n            int64_t x_297795;\n            \n            x_297795 = ((__global int64_t *) mem_318531)[gtid_297791 *\n                                                         n_292675 +\n                                                         gtid_297792];\n            \n            int64_t defunc_1_f_res_t_res_297800 = sub64(x_297795, (int64_t) 1);\n            \n            defunc_1_f_res_297799 = defunc_1_f_res_t_res_297800;\n        } else {\n            defunc_1_f_res_297799 = (int64_t) -1;\n        }\n        if ((sle64((int64_t) 0, gtid_297791) && slt64(gtid_297791,\n                                                      partition_sizze_292766)) &&\n            (sle64((int64_t) 0, defunc_1_f_res_297799) &&\n             slt64(defunc_1_f_re",
            "s_297799, n_292675))) {\n            ((__global int64_t *) mem_318535)[gtid_297791 * n_292675 +\n                                              defunc_1_f_res_297799] =\n                gtid_297792;\n        }\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_297788\n}\n__kernel void mainzisegmap_297921(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675, int64_t n_p_292677,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t i_292846, __global\n                                  unsigned char *mem_318545, __global\n                                  unsigned char *mem_318551)\n{\n    #define segmap_group_sizze_297915 (mainzisegmap_group_sizze_297830)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321114;\n    int32_t local_tid_321115;\n    int64_t group_sizze_321118;\n    int32_t wave_sizze_321117;\n    int32_t group_tid_321116;\n    \n    global_tid_321114 = get_global_id(0);\n    local_tid_321115 = get_local_id(0);\n    group_sizze_321118 = get_local_size(0);\n    wave_sizze_321117 = LOCKSTEP_WIDTH;\n    group_tid_321116 = get_group_id(0);\n    \n    int32_t phys_tid_297921 = global_tid_321114;\n    int64_t global_tid_321119 = sext_i32_i64(group_tid_321116) *\n            segmap_group_sizze_297915 + sext_i32_i64(local_tid_321115);\n    int64_t slice_321120 = defunc_0_f_res_292820;\n    int64_t slice_321121 = n_p_292677 * slice_321120;\n    int64_t slice_321122 = partition_sizze_292766 * slice_321121;\n    int64_t gtid_297918 = squot64(global_tid_321119, slice_321121);\n    int64_t remnant_321123 = global_tid_321119 - gtid_297918 * slice_321121;\n    int64_t gtid_297919 = squot64(",
            "remnant_321123, slice_321120);\n    int64_t remnant_321124 = remnant_321123 - gtid_297919 * slice_321120;\n    int64_t gtid_297920 = remnant_321124;\n    int64_t remnant_321125 = remnant_321124 - gtid_297920;\n    \n    if ((slt64(gtid_297918, partition_sizze_292766) && slt64(gtid_297919,\n                                                             n_p_292677)) &&\n        slt64(gtid_297920, defunc_0_f_res_292820)) {\n        int64_t y_297925 = mul64(n_p_292677, gtid_297920);\n        int64_t new_i_297926 = add64(gtid_297919, y_297925);\n        bool cond_297927 = slt64(i_292846, new_i_297926);\n        double defunc_0_f_res_297928;\n        \n        if (cond_297927) {\n            defunc_0_f_res_297928 = NAN;\n        } else {\n            bool x_297929 = sle64((int64_t) 0, new_i_297926);\n            bool y_297930 = slt64(new_i_297926, n_292675);\n            bool bounds_check_297931 = x_297929 && y_297930;\n            bool index_certs_297932;\n            \n            if (!bounds_check_297931) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 1) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) new_i_297926;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            float f32_arg_297933;\n            \n            f32_arg_297933 = ((__global float *) mem_318545)[gtid_297918 *\n                                                             n_292675 +\n                                                             new_i_297926];\n            \n            double f32_res_297934 = fpconv_f32_f64(f32_arg_297933);\n            \n            defunc_0_f_res_297928 = f32_res_297934;\n        }\n        ((__global double *) mem_318551)[gtid_297918 * (defunc_0_f_res_292820 *\n                                                        n_p_292677) +\n                                        ",
            " gtid_297919 * defunc_0_f_res_292820 +\n                                         gtid_297920] = defunc_0_f_res_297928;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_297915\n}\n__kernel void mainzisegmap_298357(__global int *global_failure,\n                                  int64_t n_p_292677,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820, __global\n                                  unsigned char *mem_318551, __global\n                                  unsigned char *mem_318595, __global\n                                  unsigned char *mem_318600)\n{\n    #define segmap_group_sizze_298351 (mainzisegmap_group_sizze_298102)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321309;\n    int32_t local_tid_321310;\n    int64_t group_sizze_321313;\n    int32_t wave_sizze_321312;\n    int32_t group_tid_321311;\n    \n    global_tid_321309 = get_global_id(0);\n    local_tid_321310 = get_local_id(0);\n    group_sizze_321313 = get_local_size(0);\n    wave_sizze_321312 = LOCKSTEP_WIDTH;\n    group_tid_321311 = get_group_id(0);\n    \n    int32_t phys_tid_298357 = global_tid_321309;\n    int64_t global_tid_321314 = sext_i32_i64(group_tid_321311) *\n            segmap_group_sizze_298351 + sext_i32_i64(local_tid_321310);\n    int64_t slice_321315 = defunc_0_f_res_292820;\n    int64_t slice_321316 = n_p_292677 * slice_321315;\n    int64_t slice_321317 = partition_sizze_292766 * slice_321316;\n    int64_t gtid_298354 = squot64(global_tid_321314, slice_321316);\n    int64_t remnant_321318 = global_tid_321314 - gtid_298354 * slice_321316;\n    int64_t gtid_298355 = squot64(remnant_321318, slice_321315);\n    int64_t remnant_321319 = remnant_321318 - gtid_298355 * slice_321315;\n    int64_t gtid_298356 = remnant_321319;\n    int64_t remnant_321320 = remnant_321319 - gtid_298356;\n    \n    if ((",
            "slt64(gtid_298354, partition_sizze_292766) && slt64(gtid_298355,\n                                                             n_p_292677)) &&\n        slt64(gtid_298356, defunc_0_f_res_292820)) {\n        double x_298358;\n        \n        x_298358 = ((__global double *) mem_318551)[gtid_298354 *\n                                                    (defunc_0_f_res_292820 *\n                                                     n_p_292677) + gtid_298355 *\n                                                    defunc_0_f_res_292820 +\n                                                    gtid_298356];\n        \n        bool isnan_res_298361;\n        \n        isnan_res_298361 = futrts_isnan64(x_298358);\n        \n        bool defunc_0_p_res_298362 = !isnan_res_298361;\n        int64_t defunc_1_f_res_298363;\n        \n        if (defunc_0_p_res_298362) {\n            int64_t x_298359;\n            \n            x_298359 = ((__global int64_t *) mem_318595)[gtid_298354 *\n                                                         (defunc_0_f_res_292820 *\n                                                          n_p_292677) +\n                                                         gtid_298355 *\n                                                         defunc_0_f_res_292820 +\n                                                         gtid_298356];\n            \n            int64_t defunc_1_f_res_t_res_298364 = sub64(x_298359, (int64_t) 1);\n            \n            defunc_1_f_res_298363 = defunc_1_f_res_t_res_298364;\n        } else {\n            defunc_1_f_res_298363 = (int64_t) -1;\n        }\n        if (((sle64((int64_t) 0, gtid_298354) && slt64(gtid_298354,\n                                                       partition_sizze_292766)) &&\n             (sle64((int64_t) 0, gtid_298355) && slt64(gtid_298355,\n                                                       n_p_292677))) &&\n            (sle64((int64_t) 0, defunc_1_f_res_298363) &&\n             slt64(defunc_1_f_res_298363, defunc_0_f_res_292820))",
            ") {\n            ((__global int64_t *) mem_318600)[gtid_298354 *\n                                              (defunc_0_f_res_292820 *\n                                               n_p_292677) + gtid_298355 *\n                                              defunc_0_f_res_292820 +\n                                              defunc_1_f_res_298363] =\n                gtid_298356;\n        }\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_298351\n}\n__kernel void mainzisegmap_299570(__global int *global_failure,\n                                  int64_t n_p_292677,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820, __global\n                                  unsigned char *ext_mem_318610, __global\n                                  unsigned char *mem_318676)\n{\n    #define segmap_group_sizze_299564 (mainzisegmap_group_sizze_299227)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321407;\n    int32_t local_tid_321408;\n    int64_t group_sizze_321411;\n    int32_t wave_sizze_321410;\n    int32_t group_tid_321409;\n    \n    global_tid_321407 = get_global_id(0);\n    local_tid_321408 = get_local_id(0);\n    group_sizze_321411 = get_local_size(0);\n    wave_sizze_321410 = LOCKSTEP_WIDTH;\n    group_tid_321409 = get_group_id(0);\n    \n    int32_t phys_tid_299570 = global_tid_321407;\n    int64_t global_tid_321412 = sext_i32_i64(group_tid_321409) *\n            segmap_group_sizze_299564 + sext_i32_i64(local_tid_321408);\n    int64_t slice_321413 = defunc_0_f_res_292820;\n    int64_t slice_321414 = n_p_292677 * slice_321413;\n    int64_t slice_321415 = partition_sizze_292766 * slice_321414;\n    int64_t gtid_299567 = squot64(global_tid_321412, slice_321414);\n    int64_t remnant_321416 = global_tid_321412 - gtid_299567 * slice_321414;\n    int64_t gtid_299568 = squot64(remnant_321416",
            ", slice_321413);\n    int64_t remnant_321417 = remnant_321416 - gtid_299568 * slice_321413;\n    int64_t gtid_299569 = remnant_321417;\n    int64_t remnant_321418 = remnant_321417 - gtid_299569;\n    \n    if ((slt64(gtid_299567, partition_sizze_292766) && slt64(gtid_299568,\n                                                             n_p_292677)) &&\n        slt64(gtid_299569, defunc_0_f_res_292820)) {\n        int64_t x_299571;\n        \n        x_299571 = ((__global int64_t *) ext_mem_318610)[gtid_299567 *\n                                                         (defunc_0_f_res_292820 *\n                                                          n_p_292677) +\n                                                         gtid_299568 *\n                                                         defunc_0_f_res_292820 +\n                                                         gtid_299569];\n        \n        int64_t defunc_0_f_res_299572 = add64((int64_t) 1, x_299571);\n        \n        ((__global int64_t *) mem_318676)[gtid_299567 * (defunc_0_f_res_292820 *\n                                                         n_p_292677) +\n                                          gtid_299568 * defunc_0_f_res_292820 +\n                                          gtid_299569] = defunc_0_f_res_299572;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_299564\n}\n__kernel void mainzisegmap_299584(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t q_s_292678,\n                                  int64_t partition_sizze_292766,\n                                  int64_t min_res_292926, double i64_res_292932,\n                                  __global unsigned char *ext_mem_318609,\n                                  __global unsigned char *mem_318681, __global\n                                  unsigned char *mem_318685, __global\n                                  unsigned char *mem_318689, __global\n                                  unsigned char *mem_318693)\n{\n  ",
            "  #define segmap_group_sizze_299576 (mainzisegmap_group_sizze_299196)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321419;\n    int32_t local_tid_321420;\n    int64_t group_sizze_321423;\n    int32_t wave_sizze_321422;\n    int32_t group_tid_321421;\n    \n    global_tid_321419 = get_global_id(0);\n    local_tid_321420 = get_local_id(0);\n    group_sizze_321423 = get_local_size(0);\n    wave_sizze_321422 = LOCKSTEP_WIDTH;\n    group_tid_321421 = get_group_id(0);\n    \n    int32_t phys_tid_299584 = global_tid_321419;\n    int64_t global_tid_321424 = sext_i32_i64(group_tid_321421) *\n            segmap_group_sizze_299576 + sext_i32_i64(local_tid_321420);\n    int64_t slice_321425 = n_p_292677;\n    int64_t slice_321426 = partition_sizze_292766 * slice_321425;\n    int64_t gtid_299582 = squot64(global_tid_321424, slice_321425);\n    int64_t remnant_321427 = global_tid_321424 - gtid_299582 * slice_321425;\n    int64_t gtid_299583 = remnant_321427;\n    int64_t remnant_321428 = remnant_321427 - gtid_299583;\n    \n    if (slt64(gtid_299582, partition_sizze_292766) && slt64(gtid_299583,\n                                                            n_p_292677)) {\n        int64_t x_299585;\n        \n        x_299585 = ((__global int64_t *) ext_mem_318609)[gtid_299582 *\n                                                         n_p_292677 +\n                                                         gtid_299583];\n        \n        int64_t min_arg_299586 = sub64(x_299585, (int64_t) 1);\n        int64_t min_arg_299587 = sub64(x_299585, min_res_292926);\n        int64_t min_res_299588 = smin64(q_s_292678, x_299585);\n        double i64_res_299589 = sitofp_i64_f64(x_299585);\n        double x_299590 = i64_res_292932 - i64_res_299589;\n        double max_arg_299591 = x_299590 / 2.0;\n        double max_res_299592 = fmax64(0.0, max_arg_299591);\n        \n        ((__global int64_t *) mem_31",
            "8681)[gtid_299582 * n_p_292677 +\n                                          gtid_299583] = min_arg_299586;\n        ((__global int64_t *) mem_318685)[gtid_299582 * n_p_292677 +\n                                          gtid_299583] = min_arg_299587;\n        ((__global int64_t *) mem_318689)[gtid_299582 * n_p_292677 +\n                                          gtid_299583] = min_res_299588;\n        ((__global double *) mem_318693)[gtid_299582 * n_p_292677 +\n                                         gtid_299583] = max_res_299592;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_299576\n}\n__kernel void mainzisegmap_299608(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_p_292677, int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825, int64_t i_292895,\n                                  unsigned char x_292896_bits,\n                                  int64_t min_res_292926,\n                                  unsigned char loop_cond_292931_bits, __global\n                                  unsigned char *mem_318676, __global\n                                  unsigned char *mem_318681, __global\n                                  unsigned char *mem_318685, __global\n                                  unsigned char *mem_318689, __global\n                                  unsigned char *mem_318693, __global\n                                  unsigned char *mem_318699, __global\n                                  unsigned char *mem_318704)\n{\n    bool x_292896 = x_292896_bits;\n    bool loop_cond_292931 = loop_cond_292931_bits;\n    \n    #define segmap_group_sizze_299601 (mainzisegmap_group_sizze_298957)\n    \n    ",
            "const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321429;\n    int32_t local_tid_321430;\n    int64_t group_sizze_321433;\n    int32_t wave_sizze_321432;\n    int32_t group_tid_321431;\n    \n    global_tid_321429 = get_global_id(0);\n    local_tid_321430 = get_local_id(0);\n    group_sizze_321433 = get_local_size(0);\n    wave_sizze_321432 = LOCKSTEP_WIDTH;\n    group_tid_321431 = get_group_id(0);\n    \n    int32_t phys_tid_299608 = global_tid_321429;\n    int64_t global_tid_321434 = sext_i32_i64(group_tid_321431) *\n            segmap_group_sizze_299601 + sext_i32_i64(local_tid_321430);\n    int64_t slice_321435 = s_n_m_292825;\n    int64_t slice_321436 = n_p_292677 * slice_321435;\n    int64_t slice_321437 = partition_sizze_292766 * slice_321436;\n    int64_t gtid_299605 = squot64(global_tid_321434, slice_321436);\n    int64_t remnant_321438 = global_tid_321434 - gtid_299605 * slice_321436;\n    int64_t gtid_299606 = squot64(remnant_321438, slice_321435);\n    int64_t remnant_321439 = remnant_321438 - gtid_299606 * slice_321435;\n    int64_t gtid_299607 = remnant_321439;\n    int64_t remnant_321440 = remnant_321439 - gtid_299607;\n    \n    if ((slt64(gtid_299605, partition_sizze_292766) && slt64(gtid_299606,\n                                                             n_p_292677)) &&\n        slt64(gtid_299607, s_n_m_292825)) {\n        int64_t min_arg_299610;\n        \n        min_arg_299610 = ((__global int64_t *) mem_318681)[gtid_299605 *\n                                                           n_p_292677 +\n                                                           gtid_299606];\n        \n        int64_t min_arg_299611;\n        \n        min_arg_299611 = ((__global int64_t *) mem_318685)[gtid_299605 *\n                                                           n_p_292677 +\n                                                           gtid_299606];\n        \n        int64_t min_",
            "res_299612;\n        \n        min_res_299612 = ((__global int64_t *) mem_318689)[gtid_299605 *\n                                                           n_p_292677 +\n                                                           gtid_299606];\n        \n        double max_res_299613;\n        \n        max_res_299613 = ((__global double *) mem_318693)[gtid_299605 *\n                                                          n_p_292677 +\n                                                          gtid_299606];\n        \n        bool cond_299615 = gtid_299607 == (int64_t) 0;\n        int64_t defunc_0_m_fun_res_299616;\n        \n        if (cond_299615) {\n            defunc_0_m_fun_res_299616 = (int64_t) 0;\n        } else {\n            int64_t y_299617 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_299618 = gtid_299607 == y_299617;\n            int64_t defunc_0_m_fun_res_f_res_299619;\n            \n            if (cond_299618) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_299620 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_299619 =\n                    defunc_0_m_fun_res_f_res_t_res_299620;\n            } else {\n                int64_t x_299621 = sub64(gtid_299607, (int64_t) 1);\n                int64_t x_299622 = mul64(jump_s_292684, x_299621);\n                int64_t min_arg_299623 = add64((int64_t) 1, x_299622);\n                int64_t min_res_299624 = smin64(defunc_0_f_res_292820,\n                                                min_arg_299623);\n                \n                defunc_0_m_fun_res_f_res_299619 = min_res_299624;\n            }\n            defunc_0_m_fun_res_299616 = defunc_0_m_fun_res_f_res_299619;\n        }\n        \n        bool init_idx_299625;\n        int64_t init_idx_299626;\n        int64_t init_idx_299627;\n        bool loop_while_299628;\n        int64_t low_299629;\n        int64_t high_299630;\n        \n        loop_while_299628 = x_292896;\n        low_299629 = (int64_",
            "t) 0;\n        high_299630 = i_292895;\n        while (loop_while_299628) {\n            int64_t x_299631 = add64(low_299629, high_299630);\n            int64_t mid_299632 = sdiv64(x_299631, (int64_t) 2);\n            bool x_299633 = sle64((int64_t) 0, mid_299632);\n            bool y_299634 = slt64(mid_299632, defunc_0_f_res_292820);\n            bool bounds_check_299635 = x_299633 && y_299634;\n            bool index_certs_299636;\n            \n            if (!bounds_check_299635) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 12) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) mid_299632;\n                        global_failure_args[1] =\n                            (int64_t) defunc_0_f_res_292820;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            int64_t mid_id_299637;\n            \n            mid_id_299637 = ((__global int64_t *) mem_318676)[gtid_299605 *\n                                                              (defunc_0_f_res_292820 *\n                                                               n_p_292677) +\n                                                              gtid_299606 *\n                                                              defunc_0_f_res_292820 +\n                                                              mid_299632];\n            \n            bool cond_299638 = slt64(mid_id_299637, (int64_t) 0);\n            int64_t mid_idx_299639;\n            \n            if (cond_299638) {\n                mid_idx_299639 = (int64_t) 9223372036854775807;\n            } else {\n                mid_idx_299639 = mid_id_299637;\n            }\n            \n            bool cond_299640 = sle64(defunc_0_m_fun_res_299616, mid_idx_299639);\n            int64_t loopres_299641;\n            int64_t loopres_299642;\n            \n            if (cond_299640) {\n                int64_t loopres_t_res_299643 = sub",
            "64(mid_299632, (int64_t) 1);\n                \n                loopres_299641 = low_299629;\n                loopres_299642 = loopres_t_res_299643;\n            } else {\n                int64_t loopres_f_res_299644 = add64((int64_t) 1, mid_299632);\n                \n                loopres_299641 = loopres_f_res_299644;\n                loopres_299642 = high_299630;\n            }\n            \n            bool loop_cond_299645 = sle64(loopres_299641, loopres_299642);\n            bool loop_while_tmp_321441 = loop_cond_299645;\n            int64_t low_tmp_321442 = loopres_299641;\n            int64_t high_tmp_321443 = loopres_299642;\n            \n            loop_while_299628 = loop_while_tmp_321441;\n            low_299629 = low_tmp_321442;\n            high_299630 = high_tmp_321443;\n        }\n        init_idx_299625 = loop_while_299628;\n        init_idx_299626 = low_299629;\n        init_idx_299627 = high_299630;\n        \n        bool idx_299646;\n        int64_t idx_299647;\n        int64_t idx_299648;\n        int64_t idx_299649;\n        bool loop_while_299650;\n        int64_t l_idx_299651;\n        int64_t r_idx_299652;\n        int64_t span_299653;\n        \n        loop_while_299650 = loop_cond_292931;\n        l_idx_299651 = init_idx_299626;\n        r_idx_299652 = init_idx_299626;\n        span_299653 = (int64_t) 1;\n        while (loop_while_299650) {\n            int64_t max_arg_299654 = sub64(l_idx_299651, (int64_t) 1);\n            int64_t max_res_299655 = smax64((int64_t) 0, max_arg_299654);\n            int64_t min_arg_299656 = add64((int64_t) 1, r_idx_299652);\n            int64_t min_res_299657 = smin64(min_arg_299610, min_arg_299656);\n            bool x_299658 = sle64((int64_t) 0, max_res_299655);\n            bool y_299659 = slt64(max_res_299655, defunc_0_f_res_292820);\n            bool bounds_check_299660 = x_299658 && y_299659;\n            bool index_certs_299661;\n            \n            if (!bounds_check_299660) {\n                {\n                    if (atomic_cmpxchg_",
            "i32_global(global_failure, -1, 13) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) max_res_299655;\n                        global_failure_args[1] =\n                            (int64_t) defunc_0_f_res_292820;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            int64_t x_299662;\n            \n            x_299662 = ((__global int64_t *) mem_318676)[gtid_299605 *\n                                                         (defunc_0_f_res_292820 *\n                                                          n_p_292677) +\n                                                         gtid_299606 *\n                                                         defunc_0_f_res_292820 +\n                                                         max_res_299655];\n            \n            int64_t abs_arg_299663 = sub64(x_299662, defunc_0_m_fun_res_299616);\n            int64_t abs_res_299664 = abs64(abs_arg_299663);\n            bool x_299665 = sle64((int64_t) 0, min_res_299657);\n            bool y_299666 = slt64(min_res_299657, defunc_0_f_res_292820);\n            bool bounds_check_299667 = x_299665 && y_299666;\n            bool index_certs_299668;\n            \n            if (!bounds_check_299667) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 14) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) min_res_299657;\n                        global_failure_args[1] =\n                            (int64_t) defunc_0_f_res_292820;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            int64_t x_299669;\n            \n            x_299669 = ((__global int64_t *) mem_318676)[gtid_299605 *\n                                                         (defunc_0_f_res_292820 *\n                                                          n_p_",
            "292677) +\n                                                         gtid_299606 *\n                                                         defunc_0_f_res_292820 +\n                                                         min_res_299657];\n            \n            int64_t abs_arg_299670 = sub64(x_299669, defunc_0_m_fun_res_299616);\n            int64_t abs_res_299671 = abs64(abs_arg_299670);\n            bool cond_299672 = max_res_299655 == l_idx_299651;\n            int64_t loopres_299673;\n            int64_t loopres_299674;\n            int64_t loopres_299675;\n            \n            if (cond_299672) {\n                loopres_299673 = l_idx_299651;\n                loopres_299674 = r_idx_299652;\n                loopres_299675 = min_res_292926;\n            } else {\n                bool cond_299676 = slt64(abs_res_299664, abs_res_299671);\n                bool cond_f_res_299677 = min_res_299657 == r_idx_299652;\n                bool x_299678 = !cond_299676;\n                bool y_299679 = cond_f_res_299677 && x_299678;\n                bool cond_299680 = cond_299676 || y_299679;\n                int64_t loopres_f_res_299681;\n                \n                if (cond_299680) {\n                    loopres_f_res_299681 = max_res_299655;\n                } else {\n                    loopres_f_res_299681 = l_idx_299651;\n                }\n                \n                int64_t loopres_f_res_299682;\n                \n                if (cond_299680) {\n                    loopres_f_res_299682 = r_idx_299652;\n                } else {\n                    loopres_f_res_299682 = min_res_299657;\n                }\n                \n                int64_t loopres_f_res_299683;\n                \n                if (cond_299680) {\n                    int64_t loopres_f_res_t_res_299684 = add64((int64_t) 1,\n                                                               span_299653);\n                    \n                    loopres_f_res_299683 = loopres_f_res_t_res_299684;\n                } else {",
            "\n                    int64_t loopres_f_res_f_res_299685 = add64((int64_t) 1,\n                                                               span_299653);\n                    \n                    loopres_f_res_299683 = loopres_f_res_f_res_299685;\n                }\n                loopres_299673 = loopres_f_res_299681;\n                loopres_299674 = loopres_f_res_299682;\n                loopres_299675 = loopres_f_res_299683;\n            }\n            \n            bool loop_cond_299686 = slt64(loopres_299675, min_res_292926);\n            bool loop_while_tmp_321444 = loop_cond_299686;\n            int64_t l_idx_tmp_321445 = loopres_299673;\n            int64_t r_idx_tmp_321446 = loopres_299674;\n            int64_t span_tmp_321447 = loopres_299675;\n            \n            loop_while_299650 = loop_while_tmp_321444;\n            l_idx_299651 = l_idx_tmp_321445;\n            r_idx_299652 = r_idx_tmp_321446;\n            span_299653 = span_tmp_321447;\n        }\n        idx_299646 = loop_while_299650;\n        idx_299647 = l_idx_299651;\n        idx_299648 = r_idx_299652;\n        idx_299649 = span_299653;\n        \n        int64_t min_res_299687 = smin64(min_arg_299611, idx_299647);\n        int64_t max_res_299688 = smax64((int64_t) 0, min_res_299687);\n        int64_t defunc_0_m_fun_res_299689;\n        \n        if (cond_299615) {\n            defunc_0_m_fun_res_299689 = (int64_t) 0;\n        } else {\n            int64_t y_299690 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_299691 = gtid_299607 == y_299690;\n            int64_t defunc_0_m_fun_res_f_res_299692;\n            \n            if (cond_299691) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_299693 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_299692 =\n                    defunc_0_m_fun_res_f_res_t_res_299693;\n            } else {\n                int64_t x_299694 = sub64(gtid_299607, (int64_t) 1);\n                int64_t x_299695 ",
            "= mul64(jump_s_292684, x_299694);\n                int64_t min_arg_299696 = add64((int64_t) 1, x_299695);\n                int64_t min_res_299697 = smin64(defunc_0_f_res_292820,\n                                                min_arg_299696);\n                \n                defunc_0_m_fun_res_f_res_299692 = min_res_299697;\n            }\n            defunc_0_m_fun_res_299689 = defunc_0_m_fun_res_f_res_299692;\n        }\n        \n        int64_t x_299698 = add64(min_res_299612, max_res_299688);\n        int64_t r_299699 = sub64(x_299698, (int64_t) 1);\n        bool x_299700 = sle64((int64_t) 0, r_299699);\n        bool y_299701 = slt64(r_299699, defunc_0_f_res_292820);\n        bool bounds_check_299702 = x_299700 && y_299701;\n        bool index_certs_299703;\n        \n        if (!bounds_check_299702) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 15) == -1) {\n                    global_failure_args[0] = (int64_t) r_299699;\n                    global_failure_args[1] = (int64_t) defunc_0_f_res_292820;\n                    ;\n                }\n                return;\n            }\n        }\n        \n        int64_t x_299704;\n        \n        x_299704 = ((__global int64_t *) mem_318676)[gtid_299605 *\n                                                     (defunc_0_f_res_292820 *\n                                                      n_p_292677) +\n                                                     gtid_299606 *\n                                                     defunc_0_f_res_292820 +\n                                                     r_299699];\n        \n        int64_t abs_arg_299705 = sub64(x_299704, defunc_0_m_fun_res_299689);\n        int64_t abs_res_299706 = abs64(abs_arg_299705);\n        bool x_299707 = sle64((int64_t) 0, max_res_299688);\n        bool y_299708 = slt64(max_res_299688, defunc_0_f_res_292820);\n        bool bounds_check_299709 = x_299707 && y_299708;\n        bool index_certs_299710;\n        \n        if (!bounds_check_299709) ",
            "{\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 16) == -1) {\n                    global_failure_args[0] = (int64_t) max_res_299688;\n                    global_failure_args[1] = (int64_t) defunc_0_f_res_292820;\n                    ;\n                }\n                return;\n            }\n        }\n        \n        int64_t x_299711;\n        \n        x_299711 = ((__global int64_t *) mem_318676)[gtid_299605 *\n                                                     (defunc_0_f_res_292820 *\n                                                      n_p_292677) +\n                                                     gtid_299606 *\n                                                     defunc_0_f_res_292820 +\n                                                     max_res_299688];\n        \n        int64_t abs_arg_299712 = sub64(x_299711, defunc_0_m_fun_res_299689);\n        int64_t abs_res_299713 = abs64(abs_arg_299712);\n        int64_t max_res_299714 = smax64(abs_res_299706, abs_res_299713);\n        double defunc_0_f_res_299715 = sitofp_i64_f64(max_res_299714);\n        double defunc_1_f_res_299716 = max_res_299613 + defunc_0_f_res_299715;\n        \n        ((__global double *) mem_318699)[gtid_299605 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_299606 * s_n_m_292825 +\n                                         gtid_299607] = defunc_1_f_res_299716;\n        ((__global int64_t *) mem_318704)[gtid_299605 * (s_n_m_292825 *\n                                                         n_p_292677) +\n                                          gtid_299606 * s_n_m_292825 +\n                                          gtid_299607] = max_res_299688;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_299601\n}\n__kernel void mainzisegmap_300218(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze",
            "_292766, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_318733)\n{\n    #define segmap_group_sizze_300213 (mainzisegmap_group_sizze_300189)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321480;\n    int32_t local_tid_321481;\n    int64_t group_sizze_321484;\n    int32_t wave_sizze_321483;\n    int32_t group_tid_321482;\n    \n    global_tid_321480 = get_global_id(0);\n    local_tid_321481 = get_local_id(0);\n    group_sizze_321484 = get_local_size(0);\n    wave_sizze_321483 = LOCKSTEP_WIDTH;\n    group_tid_321482 = get_group_id(0);\n    \n    int32_t phys_tid_300218 = global_tid_321480;\n    int64_t global_tid_321485 = sext_i32_i64(group_tid_321482) *\n            segmap_group_sizze_300213 + sext_i32_i64(local_tid_321481);\n    int64_t slice_321486 = n_292675;\n    int64_t slice_321487 = partition_sizze_292766 * slice_321486;\n    int64_t gtid_300216 = squot64(global_tid_321485, slice_321486);\n    int64_t remnant_321488 = global_tid_321485 - gtid_300216 * slice_321486;\n    int64_t gtid_300217 = remnant_321488;\n    int64_t remnant_321489 = remnant_321488 - gtid_300217;\n    \n    if (slt64(gtid_300216, partition_sizze_292766) && slt64(gtid_300217,\n                                                            n_292675)) {\n        int64_t x_300219;\n        \n        x_300219 = ((__global int64_t *) ext_mem_318542)[gtid_300216 *\n                                                         n_292675 +\n                                                         gtid_300217];\n        \n        int64_t defunc_0_f_res_300220 = add64((int64_t) 1, x_300219);\n        \n        ((__global int64_t *) mem_318733)[gtid_300216 * n_292675 +\n                                          gtid_300217] = defunc_0_f_res_300220;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_300213\n}\n__kernel void",
            " mainzisegmap_300230(__global int *global_failure,\n                                  int64_t q_l_292680,\n                                  int64_t partition_sizze_292766,\n                                  int64_t min_res_293058, double i64_res_293064,\n                                  __global unsigned char *ext_mem_318541,\n                                  __global unsigned char *mem_318737, __global\n                                  unsigned char *mem_318740, __global\n                                  unsigned char *mem_318743, __global\n                                  unsigned char *mem_318746)\n{\n    #define segmap_group_sizze_300223 (mainzisegmap_group_sizze_300163)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321490;\n    int32_t local_tid_321491;\n    int64_t group_sizze_321494;\n    int32_t wave_sizze_321493;\n    int32_t group_tid_321492;\n    \n    global_tid_321490 = get_global_id(0);\n    local_tid_321491 = get_local_id(0);\n    group_sizze_321494 = get_local_size(0);\n    wave_sizze_321493 = LOCKSTEP_WIDTH;\n    group_tid_321492 = get_group_id(0);\n    \n    int32_t phys_tid_300230 = global_tid_321490;\n    int64_t global_tid_321495 = sext_i32_i64(group_tid_321492) *\n            segmap_group_sizze_300223 + sext_i32_i64(local_tid_321491);\n    int64_t slice_321496 = partition_sizze_292766;\n    int64_t gtid_300229 = global_tid_321495;\n    int64_t remnant_321497 = global_tid_321495 - gtid_300229;\n    \n    if (slt64(gtid_300229, partition_sizze_292766)) {\n        int64_t x_300231;\n        \n        x_300231 = ((__global int64_t *) ext_mem_318541)[gtid_300229];\n        \n        int64_t min_arg_300232 = sub64(x_300231, (int64_t) 1);\n        int64_t min_arg_300233 = sub64(x_300231, min_res_293058);\n        int64_t min_res_300234 = smin64(q_l_292680, x_300231);\n        double i64_res_300235 = sitofp_i64_f64(x_300231);\n        double x_300236 = i64_r",
            "es_293064 - i64_res_300235;\n        double max_arg_300237 = x_300236 / 2.0;\n        double max_res_300238 = fmax64(0.0, max_arg_300237);\n        \n        ((__global int64_t *) mem_318737)[gtid_300229] = min_arg_300232;\n        ((__global int64_t *) mem_318740)[gtid_300229] = min_arg_300233;\n        ((__global int64_t *) mem_318743)[gtid_300229] = min_res_300234;\n        ((__global double *) mem_318746)[gtid_300229] = max_res_300238;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_300223\n}\n__kernel void mainzisegmap_300251(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675, int64_t jump_l_292686,\n                                  int64_t partition_sizze_292766,\n                                  int64_t l_n_m_292832, int64_t i_292846,\n                                  unsigned char x_292847_bits,\n                                  int64_t min_res_293058,\n                                  unsigned char loop_cond_293063_bits, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_318733, __global\n                                  unsigned char *mem_318737, __global\n                                  unsigned char *mem_318740, __global\n                                  unsigned char *mem_318743, __global\n                                  unsigned char *mem_318746, __global\n                                  unsigned char *mem_318751, __global\n                                  unsigned char *mem_318755)\n{\n    bool x_292847 = x_292847_bits;\n    bool loop_cond_293063 = loop_cond_293063_bits;\n    \n    #define segmap_group_sizze_300245 (mainzisegmap_group_sizze_299959)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    in",
            "t32_t global_tid_321498;\n    int32_t local_tid_321499;\n    int64_t group_sizze_321502;\n    int32_t wave_sizze_321501;\n    int32_t group_tid_321500;\n    \n    global_tid_321498 = get_global_id(0);\n    local_tid_321499 = get_local_id(0);\n    group_sizze_321502 = get_local_size(0);\n    wave_sizze_321501 = LOCKSTEP_WIDTH;\n    group_tid_321500 = get_group_id(0);\n    \n    int32_t phys_tid_300251 = global_tid_321498;\n    int64_t global_tid_321503 = sext_i32_i64(group_tid_321500) *\n            segmap_group_sizze_300245 + sext_i32_i64(local_tid_321499);\n    int64_t slice_321504 = l_n_m_292832;\n    int64_t slice_321505 = partition_sizze_292766 * slice_321504;\n    int64_t gtid_300249 = squot64(global_tid_321503, slice_321504);\n    int64_t remnant_321506 = global_tid_321503 - gtid_300249 * slice_321504;\n    int64_t gtid_300250 = remnant_321506;\n    int64_t remnant_321507 = remnant_321506 - gtid_300250;\n    \n    if (slt64(gtid_300249, partition_sizze_292766) && slt64(gtid_300250,\n                                                            l_n_m_292832)) {\n        int64_t min_arg_300254;\n        \n        min_arg_300254 = ((__global int64_t *) mem_318737)[gtid_300249];\n        \n        int64_t min_arg_300255;\n        \n        min_arg_300255 = ((__global int64_t *) mem_318740)[gtid_300249];\n        \n        int64_t min_res_300256;\n        \n        min_res_300256 = ((__global int64_t *) mem_318743)[gtid_300249];\n        \n        double max_res_300257;\n        \n        max_res_300257 = ((__global double *) mem_318746)[gtid_300249];\n        \n        int64_t min_arg_300259 = mul64(jump_l_292686, gtid_300250);\n        int64_t min_res_300260 = smin64(i_292846, min_arg_300259);\n        int64_t defunc_0_g_res_300261 = add64((int64_t) 1, min_res_300260);\n        bool init_idx_300262;\n        int64_t init_idx_300263;\n        int64_t init_idx_300264;\n        bool loop_while_300265;\n        int64_t low_300266;\n        int64_t high_300267;\n        \n        loop_while_300265 = x_292847;\n        l",
            "ow_300266 = (int64_t) 0;\n        high_300267 = i_292846;\n        while (loop_while_300265) {\n            int64_t x_300268 = add64(low_300266, high_300267);\n            int64_t mid_300269 = sdiv64(x_300268, (int64_t) 2);\n            bool x_300270 = sle64((int64_t) 0, mid_300269);\n            bool y_300271 = slt64(mid_300269, n_292675);\n            bool bounds_check_300272 = x_300270 && y_300271;\n            bool index_certs_300273;\n            \n            if (!bounds_check_300272) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 22) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) mid_300269;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            int64_t mid_id_300274;\n            \n            mid_id_300274 = ((__global int64_t *) mem_318733)[gtid_300249 *\n                                                              n_292675 +\n                                                              mid_300269];\n            \n            bool cond_300275 = slt64(mid_id_300274, (int64_t) 0);\n            int64_t mid_idx_300276;\n            \n            if (cond_300275) {\n                mid_idx_300276 = (int64_t) 9223372036854775807;\n            } else {\n                mid_idx_300276 = mid_id_300274;\n            }\n            \n            bool cond_300277 = sle64(defunc_0_g_res_300261, mid_idx_300276);\n            int64_t loopres_300278;\n            int64_t loopres_300279;\n            \n            if (cond_300277) {\n                int64_t loopres_t_res_300280 = sub64(mid_300269, (int64_t) 1);\n                \n                loopres_300278 = low_300266;\n                loopres_300279 = loopres_t_res_300280;\n            } else {\n                int64_t loopres_f_res_300281 = add64((int64_t) 1, mid_300269);\n                \n                loopres_30027",
            "8 = loopres_f_res_300281;\n                loopres_300279 = high_300267;\n            }\n            \n            bool loop_cond_300282 = sle64(loopres_300278, loopres_300279);\n            bool loop_while_tmp_321508 = loop_cond_300282;\n            int64_t low_tmp_321509 = loopres_300278;\n            int64_t high_tmp_321510 = loopres_300279;\n            \n            loop_while_300265 = loop_while_tmp_321508;\n            low_300266 = low_tmp_321509;\n            high_300267 = high_tmp_321510;\n        }\n        init_idx_300262 = loop_while_300265;\n        init_idx_300263 = low_300266;\n        init_idx_300264 = high_300267;\n        \n        bool idx_300283;\n        int64_t idx_300284;\n        int64_t idx_300285;\n        int64_t idx_300286;\n        bool loop_while_300287;\n        int64_t l_idx_300288;\n        int64_t r_idx_300289;\n        int64_t span_300290;\n        \n        loop_while_300287 = loop_cond_293063;\n        l_idx_300288 = init_idx_300263;\n        r_idx_300289 = init_idx_300263;\n        span_300290 = (int64_t) 1;\n        while (loop_while_300287) {\n            int64_t max_arg_300291 = sub64(l_idx_300288, (int64_t) 1);\n            int64_t max_res_300292 = smax64((int64_t) 0, max_arg_300291);\n            int64_t min_arg_300293 = add64((int64_t) 1, r_idx_300289);\n            int64_t min_res_300294 = smin64(min_arg_300254, min_arg_300293);\n            bool x_300295 = sle64((int64_t) 0, max_res_300292);\n            bool y_300296 = slt64(max_res_300292, n_292675);\n            bool bounds_check_300297 = x_300295 && y_300296;\n            bool index_certs_300298;\n            \n            if (!bounds_check_300297) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 23) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) max_res_300292;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }",
            "\n            }\n            \n            int64_t x_300299;\n            \n            x_300299 = ((__global int64_t *) mem_318733)[gtid_300249 *\n                                                         n_292675 +\n                                                         max_res_300292];\n            \n            int64_t abs_arg_300300 = sub64(x_300299, defunc_0_g_res_300261);\n            int64_t abs_res_300301 = abs64(abs_arg_300300);\n            bool x_300302 = sle64((int64_t) 0, min_res_300294);\n            bool y_300303 = slt64(min_res_300294, n_292675);\n            bool bounds_check_300304 = x_300302 && y_300303;\n            bool index_certs_300305;\n            \n            if (!bounds_check_300304) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 24) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) min_res_300294;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            int64_t x_300306;\n            \n            x_300306 = ((__global int64_t *) mem_318733)[gtid_300249 *\n                                                         n_292675 +\n                                                         min_res_300294];\n            \n            int64_t abs_arg_300307 = sub64(x_300306, defunc_0_g_res_300261);\n            int64_t abs_res_300308 = abs64(abs_arg_300307);\n            bool cond_300309 = max_res_300292 == l_idx_300288;\n            int64_t loopres_300310;\n            int64_t loopres_300311;\n            int64_t loopres_300312;\n            \n            if (cond_300309) {\n                loopres_300310 = l_idx_300288;\n                loopres_300311 = r_idx_300289;\n                loopres_300312 = min_res_293058;\n            } else {\n                bool cond_300313 = slt64(abs_res_300301, abs_res_300308);\n                bool cond_f_res_300314 = ",
            "min_res_300294 == r_idx_300289;\n                bool x_300315 = !cond_300313;\n                bool y_300316 = cond_f_res_300314 && x_300315;\n                bool cond_300317 = cond_300313 || y_300316;\n                int64_t loopres_f_res_300318;\n                \n                if (cond_300317) {\n                    loopres_f_res_300318 = max_res_300292;\n                } else {\n                    loopres_f_res_300318 = l_idx_300288;\n                }\n                \n                int64_t loopres_f_res_300319;\n                \n                if (cond_300317) {\n                    loopres_f_res_300319 = r_idx_300289;\n                } else {\n                    loopres_f_res_300319 = min_res_300294;\n                }\n                \n                int64_t loopres_f_res_300320;\n                \n                if (cond_300317) {\n                    int64_t loopres_f_res_t_res_300321 = add64((int64_t) 1,\n                                                               span_300290);\n                    \n                    loopres_f_res_300320 = loopres_f_res_t_res_300321;\n                } else {\n                    int64_t loopres_f_res_f_res_300322 = add64((int64_t) 1,\n                                                               span_300290);\n                    \n                    loopres_f_res_300320 = loopres_f_res_f_res_300322;\n                }\n                loopres_300310 = loopres_f_res_300318;\n                loopres_300311 = loopres_f_res_300319;\n                loopres_300312 = loopres_f_res_300320;\n            }\n            \n            bool loop_cond_300323 = slt64(loopres_300312, min_res_293058);\n            bool loop_while_tmp_321511 = loop_cond_300323;\n            int64_t l_idx_tmp_321512 = loopres_300310;\n            int64_t r_idx_tmp_321513 = loopres_300311;\n            int64_t span_tmp_321514 = loopres_300312;\n            \n            loop_while_300287 = loop_while_tmp_321511;\n            l_idx_300288 = l_idx_tmp_321512;\n            r_idx",
            "_300289 = r_idx_tmp_321513;\n            span_300290 = span_tmp_321514;\n        }\n        idx_300283 = loop_while_300287;\n        idx_300284 = l_idx_300288;\n        idx_300285 = r_idx_300289;\n        idx_300286 = span_300290;\n        \n        int64_t min_res_300324 = smin64(min_arg_300255, idx_300284);\n        int64_t max_res_300325 = smax64((int64_t) 0, min_res_300324);\n        int64_t x_300326 = add64(min_res_300256, max_res_300325);\n        int64_t r_300327 = sub64(x_300326, (int64_t) 1);\n        bool x_300328 = sle64((int64_t) 0, r_300327);\n        bool y_300329 = slt64(r_300327, n_292675);\n        bool bounds_check_300330 = x_300328 && y_300329;\n        bool index_certs_300331;\n        \n        if (!bounds_check_300330) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 25) == -1) {\n                    global_failure_args[0] = (int64_t) r_300327;\n                    global_failure_args[1] = (int64_t) n_292675;\n                    ;\n                }\n                return;\n            }\n        }\n        \n        int64_t x_300332;\n        \n        x_300332 = ((__global int64_t *) ext_mem_318542)[gtid_300249 *\n                                                         n_292675 + r_300327];\n        \n        int64_t abs_arg_300333 = sub64(x_300332, min_res_300260);\n        int64_t abs_res_300334 = abs64(abs_arg_300333);\n        bool x_300335 = sle64((int64_t) 0, max_res_300325);\n        bool y_300336 = slt64(max_res_300325, n_292675);\n        bool bounds_check_300337 = x_300335 && y_300336;\n        bool index_certs_300338;\n        \n        if (!bounds_check_300337) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 26) == -1) {\n                    global_failure_args[0] = (int64_t) max_res_300325;\n                    global_failure_args[1] = (int64_t) n_292675;\n                    ;\n                }\n                return;\n            }\n        }\n        \n        int64_t x_300339;\n        \n        x_30033",
            "9 = ((__global int64_t *) ext_mem_318542)[gtid_300249 *\n                                                         n_292675 +\n                                                         max_res_300325];\n        \n        int64_t abs_arg_300340 = sub64(x_300339, min_res_300260);\n        int64_t abs_res_300341 = abs64(abs_arg_300340);\n        int64_t max_res_300342 = smax64(abs_res_300334, abs_res_300341);\n        double defunc_0_f_res_300343 = sitofp_i64_f64(max_res_300342);\n        double defunc_1_f_res_300344 = max_res_300257 + defunc_0_f_res_300343;\n        \n        ((__global double *) mem_318751)[gtid_300249 * l_n_m_292832 +\n                                         gtid_300250] = defunc_1_f_res_300344;\n        ((__global int64_t *) mem_318755)[gtid_300249 * l_n_m_292832 +\n                                          gtid_300250] = max_res_300325;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_300245\n}\n__kernel void mainzisegmap_300844(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_318782)\n{\n    #define segmap_group_sizze_300839 (mainzisegmap_group_sizze_300815)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321546;\n    int32_t local_tid_321547;\n    int64_t group_sizze_321550;\n    int32_t wave_sizze_321549;\n    int32_t group_tid_321548;\n    \n    global_tid_321546 = get_global_id(0);\n    local_tid_321547 = get_local_id(0);\n    group_sizze_321550 = get_local_size(0);\n    wave_sizze_321549 = LOCKSTEP_WIDTH;\n    group_tid_321548 = get_group_id(0);\n    \n    int32_t phys_tid_300844 = global_tid_321546;\n    int64_t global_tid_321551 = sext_i32_i64(group_tid_321548) *\n            segmap_group_sizze_300839 ",
            "+ sext_i32_i64(local_tid_321547);\n    int64_t slice_321552 = n_292675;\n    int64_t slice_321553 = partition_sizze_292766 * slice_321552;\n    int64_t gtid_300842 = squot64(global_tid_321551, slice_321552);\n    int64_t remnant_321554 = global_tid_321551 - gtid_300842 * slice_321552;\n    int64_t gtid_300843 = remnant_321554;\n    int64_t remnant_321555 = remnant_321554 - gtid_300843;\n    \n    if (slt64(gtid_300842, partition_sizze_292766) && slt64(gtid_300843,\n                                                            n_292675)) {\n        int64_t x_300845;\n        \n        x_300845 = ((__global int64_t *) ext_mem_318542)[gtid_300842 *\n                                                         n_292675 +\n                                                         gtid_300843];\n        \n        int64_t defunc_0_f_res_300846 = add64((int64_t) 1, x_300845);\n        \n        ((__global int64_t *) mem_318782)[gtid_300842 * n_292675 +\n                                          gtid_300843] = defunc_0_f_res_300846;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_300839\n}\n__kernel void mainzisegmap_300856(__global int *global_failure,\n                                  int64_t q_t_292679,\n                                  int64_t partition_sizze_292766,\n                                  int64_t min_res_293170, double i64_res_293176,\n                                  __global unsigned char *ext_mem_318541,\n                                  __global unsigned char *mem_318786, __global\n                                  unsigned char *mem_318789, __global\n                                  unsigned char *mem_318792, __global\n                                  unsigned char *mem_318795)\n{\n    #define segmap_group_sizze_300849 (mainzisegmap_group_sizze_300789)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321556;\n    int32_t local_tid_321557;\n    int6",
            "4_t group_sizze_321560;\n    int32_t wave_sizze_321559;\n    int32_t group_tid_321558;\n    \n    global_tid_321556 = get_global_id(0);\n    local_tid_321557 = get_local_id(0);\n    group_sizze_321560 = get_local_size(0);\n    wave_sizze_321559 = LOCKSTEP_WIDTH;\n    group_tid_321558 = get_group_id(0);\n    \n    int32_t phys_tid_300856 = global_tid_321556;\n    int64_t global_tid_321561 = sext_i32_i64(group_tid_321558) *\n            segmap_group_sizze_300849 + sext_i32_i64(local_tid_321557);\n    int64_t slice_321562 = partition_sizze_292766;\n    int64_t gtid_300855 = global_tid_321561;\n    int64_t remnant_321563 = global_tid_321561 - gtid_300855;\n    \n    if (slt64(gtid_300855, partition_sizze_292766)) {\n        int64_t x_300857;\n        \n        x_300857 = ((__global int64_t *) ext_mem_318541)[gtid_300855];\n        \n        int64_t min_arg_300858 = sub64(x_300857, (int64_t) 1);\n        int64_t min_arg_300859 = sub64(x_300857, min_res_293170);\n        int64_t min_res_300860 = smin64(q_t_292679, x_300857);\n        double i64_res_300861 = sitofp_i64_f64(x_300857);\n        double x_300862 = i64_res_293176 - i64_res_300861;\n        double max_arg_300863 = x_300862 / 2.0;\n        double max_res_300864 = fmax64(0.0, max_arg_300863);\n        \n        ((__global int64_t *) mem_318786)[gtid_300855] = min_arg_300858;\n        ((__global int64_t *) mem_318789)[gtid_300855] = min_arg_300859;\n        ((__global int64_t *) mem_318792)[gtid_300855] = min_res_300860;\n        ((__global double *) mem_318795)[gtid_300855] = max_res_300864;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_300849\n}\n__kernel void mainzisegmap_300877(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675, int64_t jump_t_292685,\n                                  int64_t partition_sizze_292766,\n                                  int64_t t_n_m_2928",
            "39, int64_t i_292846,\n                                  unsigned char x_292847_bits,\n                                  int64_t min_res_293170,\n                                  unsigned char loop_cond_293175_bits, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_318782, __global\n                                  unsigned char *mem_318786, __global\n                                  unsigned char *mem_318789, __global\n                                  unsigned char *mem_318792, __global\n                                  unsigned char *mem_318795, __global\n                                  unsigned char *mem_318800, __global\n                                  unsigned char *mem_318804)\n{\n    bool x_292847 = x_292847_bits;\n    bool loop_cond_293175 = loop_cond_293175_bits;\n    \n    #define segmap_group_sizze_300871 (mainzisegmap_group_sizze_300585)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321564;\n    int32_t local_tid_321565;\n    int64_t group_sizze_321568;\n    int32_t wave_sizze_321567;\n    int32_t group_tid_321566;\n    \n    global_tid_321564 = get_global_id(0);\n    local_tid_321565 = get_local_id(0);\n    group_sizze_321568 = get_local_size(0);\n    wave_sizze_321567 = LOCKSTEP_WIDTH;\n    group_tid_321566 = get_group_id(0);\n    \n    int32_t phys_tid_300877 = global_tid_321564;\n    int64_t global_tid_321569 = sext_i32_i64(group_tid_321566) *\n            segmap_group_sizze_300871 + sext_i32_i64(local_tid_321565);\n    int64_t slice_321570 = t_n_m_292839;\n    int64_t slice_321571 = partition_sizze_292766 * slice_321570;\n    int64_t gtid_300875 = squot64(global_tid_321569, slice_321570);\n    int64_t remnant_321572 = global_tid_321569 - gtid_300875 * slice_321570;\n    int64_t gtid_300876 = remnant_321572;\n    int64_t remnant_321573 = remnant_321572 - gtid_30087",
            "6;\n    \n    if (slt64(gtid_300875, partition_sizze_292766) && slt64(gtid_300876,\n                                                            t_n_m_292839)) {\n        int64_t min_arg_300880;\n        \n        min_arg_300880 = ((__global int64_t *) mem_318786)[gtid_300875];\n        \n        int64_t min_arg_300881;\n        \n        min_arg_300881 = ((__global int64_t *) mem_318789)[gtid_300875];\n        \n        int64_t min_res_300882;\n        \n        min_res_300882 = ((__global int64_t *) mem_318792)[gtid_300875];\n        \n        double max_res_300883;\n        \n        max_res_300883 = ((__global double *) mem_318795)[gtid_300875];\n        \n        int64_t min_arg_300885 = mul64(jump_t_292685, gtid_300876);\n        int64_t min_res_300886 = smin64(i_292846, min_arg_300885);\n        int64_t defunc_0_g_res_300887 = add64((int64_t) 1, min_res_300886);\n        bool init_idx_300888;\n        int64_t init_idx_300889;\n        int64_t init_idx_300890;\n        bool loop_while_300891;\n        int64_t low_300892;\n        int64_t high_300893;\n        \n        loop_while_300891 = x_292847;\n        low_300892 = (int64_t) 0;\n        high_300893 = i_292846;\n        while (loop_while_300891) {\n            int64_t x_300894 = add64(low_300892, high_300893);\n            int64_t mid_300895 = sdiv64(x_300894, (int64_t) 2);\n            bool x_300896 = sle64((int64_t) 0, mid_300895);\n            bool y_300897 = slt64(mid_300895, n_292675);\n            bool bounds_check_300898 = x_300896 && y_300897;\n            bool index_certs_300899;\n            \n            if (!bounds_check_300898) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 32) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) mid_300895;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            int64_t mid_id",
            "_300900;\n            \n            mid_id_300900 = ((__global int64_t *) mem_318782)[gtid_300875 *\n                                                              n_292675 +\n                                                              mid_300895];\n            \n            bool cond_300901 = slt64(mid_id_300900, (int64_t) 0);\n            int64_t mid_idx_300902;\n            \n            if (cond_300901) {\n                mid_idx_300902 = (int64_t) 9223372036854775807;\n            } else {\n                mid_idx_300902 = mid_id_300900;\n            }\n            \n            bool cond_300903 = sle64(defunc_0_g_res_300887, mid_idx_300902);\n            int64_t loopres_300904;\n            int64_t loopres_300905;\n            \n            if (cond_300903) {\n                int64_t loopres_t_res_300906 = sub64(mid_300895, (int64_t) 1);\n                \n                loopres_300904 = low_300892;\n                loopres_300905 = loopres_t_res_300906;\n            } else {\n                int64_t loopres_f_res_300907 = add64((int64_t) 1, mid_300895);\n                \n                loopres_300904 = loopres_f_res_300907;\n                loopres_300905 = high_300893;\n            }\n            \n            bool loop_cond_300908 = sle64(loopres_300904, loopres_300905);\n            bool loop_while_tmp_321574 = loop_cond_300908;\n            int64_t low_tmp_321575 = loopres_300904;\n            int64_t high_tmp_321576 = loopres_300905;\n            \n            loop_while_300891 = loop_while_tmp_321574;\n            low_300892 = low_tmp_321575;\n            high_300893 = high_tmp_321576;\n        }\n        init_idx_300888 = loop_while_300891;\n        init_idx_300889 = low_300892;\n        init_idx_300890 = high_300893;\n        \n        bool idx_300909;\n        int64_t idx_300910;\n        int64_t idx_300911;\n        int64_t idx_300912;\n        bool loop_while_300913;\n        int64_t l_idx_300914;\n        int64_t r_idx_300915;\n        int64_t span_300916;\n        \n        loop_while_300913 = ",
            "loop_cond_293175;\n        l_idx_300914 = init_idx_300889;\n        r_idx_300915 = init_idx_300889;\n        span_300916 = (int64_t) 1;\n        while (loop_while_300913) {\n            int64_t max_arg_300917 = sub64(l_idx_300914, (int64_t) 1);\n            int64_t max_res_300918 = smax64((int64_t) 0, max_arg_300917);\n            int64_t min_arg_300919 = add64((int64_t) 1, r_idx_300915);\n            int64_t min_res_300920 = smin64(min_arg_300880, min_arg_300919);\n            bool x_300921 = sle64((int64_t) 0, max_res_300918);\n            bool y_300922 = slt64(max_res_300918, n_292675);\n            bool bounds_check_300923 = x_300921 && y_300922;\n            bool index_certs_300924;\n            \n            if (!bounds_check_300923) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 33) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) max_res_300918;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            int64_t x_300925;\n            \n            x_300925 = ((__global int64_t *) mem_318782)[gtid_300875 *\n                                                         n_292675 +\n                                                         max_res_300918];\n            \n            int64_t abs_arg_300926 = sub64(x_300925, defunc_0_g_res_300887);\n            int64_t abs_res_300927 = abs64(abs_arg_300926);\n            bool x_300928 = sle64((int64_t) 0, min_res_300920);\n            bool y_300929 = slt64(min_res_300920, n_292675);\n            bool bounds_check_300930 = x_300928 && y_300929;\n            bool index_certs_300931;\n            \n            if (!bounds_check_300930) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 34) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) min_re",
            "s_300920;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            int64_t x_300932;\n            \n            x_300932 = ((__global int64_t *) mem_318782)[gtid_300875 *\n                                                         n_292675 +\n                                                         min_res_300920];\n            \n            int64_t abs_arg_300933 = sub64(x_300932, defunc_0_g_res_300887);\n            int64_t abs_res_300934 = abs64(abs_arg_300933);\n            bool cond_300935 = max_res_300918 == l_idx_300914;\n            int64_t loopres_300936;\n            int64_t loopres_300937;\n            int64_t loopres_300938;\n            \n            if (cond_300935) {\n                loopres_300936 = l_idx_300914;\n                loopres_300937 = r_idx_300915;\n                loopres_300938 = min_res_293170;\n            } else {\n                bool cond_300939 = slt64(abs_res_300927, abs_res_300934);\n                bool cond_f_res_300940 = min_res_300920 == r_idx_300915;\n                bool x_300941 = !cond_300939;\n                bool y_300942 = cond_f_res_300940 && x_300941;\n                bool cond_300943 = cond_300939 || y_300942;\n                int64_t loopres_f_res_300944;\n                \n                if (cond_300943) {\n                    loopres_f_res_300944 = max_res_300918;\n                } else {\n                    loopres_f_res_300944 = l_idx_300914;\n                }\n                \n                int64_t loopres_f_res_300945;\n                \n                if (cond_300943) {\n                    loopres_f_res_300945 = r_idx_300915;\n                } else {\n                    loopres_f_res_300945 = min_res_300920;\n                }\n                \n                int64_t loopres_f_res_300946;\n                \n                if (cond_300943) {\n                    int64_t loopres_f_res_t_res_30094",
            "7 = add64((int64_t) 1,\n                                                               span_300916);\n                    \n                    loopres_f_res_300946 = loopres_f_res_t_res_300947;\n                } else {\n                    int64_t loopres_f_res_f_res_300948 = add64((int64_t) 1,\n                                                               span_300916);\n                    \n                    loopres_f_res_300946 = loopres_f_res_f_res_300948;\n                }\n                loopres_300936 = loopres_f_res_300944;\n                loopres_300937 = loopres_f_res_300945;\n                loopres_300938 = loopres_f_res_300946;\n            }\n            \n            bool loop_cond_300949 = slt64(loopres_300938, min_res_293170);\n            bool loop_while_tmp_321577 = loop_cond_300949;\n            int64_t l_idx_tmp_321578 = loopres_300936;\n            int64_t r_idx_tmp_321579 = loopres_300937;\n            int64_t span_tmp_321580 = loopres_300938;\n            \n            loop_while_300913 = loop_while_tmp_321577;\n            l_idx_300914 = l_idx_tmp_321578;\n            r_idx_300915 = r_idx_tmp_321579;\n            span_300916 = span_tmp_321580;\n        }\n        idx_300909 = loop_while_300913;\n        idx_300910 = l_idx_300914;\n        idx_300911 = r_idx_300915;\n        idx_300912 = span_300916;\n        \n        int64_t min_res_300950 = smin64(min_arg_300881, idx_300910);\n        int64_t max_res_300951 = smax64((int64_t) 0, min_res_300950);\n        int64_t x_300952 = add64(min_res_300882, max_res_300951);\n        int64_t r_300953 = sub64(x_300952, (int64_t) 1);\n        bool x_300954 = sle64((int64_t) 0, r_300953);\n        bool y_300955 = slt64(r_300953, n_292675);\n        bool bounds_check_300956 = x_300954 && y_300955;\n        bool index_certs_300957;\n        \n        if (!bounds_check_300956) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 35) == -1) {\n                    global_failure_args[0] = (int64_t) r_300953;\n      ",
            "              global_failure_args[1] = (int64_t) n_292675;\n                    ;\n                }\n                return;\n            }\n        }\n        \n        int64_t x_300958;\n        \n        x_300958 = ((__global int64_t *) ext_mem_318542)[gtid_300875 *\n                                                         n_292675 + r_300953];\n        \n        int64_t abs_arg_300959 = sub64(x_300958, min_res_300886);\n        int64_t abs_res_300960 = abs64(abs_arg_300959);\n        bool x_300961 = sle64((int64_t) 0, max_res_300951);\n        bool y_300962 = slt64(max_res_300951, n_292675);\n        bool bounds_check_300963 = x_300961 && y_300962;\n        bool index_certs_300964;\n        \n        if (!bounds_check_300963) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 36) == -1) {\n                    global_failure_args[0] = (int64_t) max_res_300951;\n                    global_failure_args[1] = (int64_t) n_292675;\n                    ;\n                }\n                return;\n            }\n        }\n        \n        int64_t x_300965;\n        \n        x_300965 = ((__global int64_t *) ext_mem_318542)[gtid_300875 *\n                                                         n_292675 +\n                                                         max_res_300951];\n        \n        int64_t abs_arg_300966 = sub64(x_300965, min_res_300886);\n        int64_t abs_res_300967 = abs64(abs_arg_300966);\n        int64_t max_res_300968 = smax64(abs_res_300960, abs_res_300967);\n        double defunc_0_f_res_300969 = sitofp_i64_f64(max_res_300968);\n        double defunc_1_f_res_300970 = max_res_300883 + defunc_0_f_res_300969;\n        \n        ((__global double *) mem_318800)[gtid_300875 * t_n_m_292839 +\n                                         gtid_300876] = defunc_1_f_res_300970;\n        ((__global int64_t *) mem_318804)[gtid_300875 * t_n_m_292839 +\n                                          gtid_300876] = max_res_300951;\n    }\n    \n  error_0:\n    return;\n    #undef s",
            "egmap_group_sizze_300871\n}\n__kernel void mainzisegmap_301021(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766,\n                                  int64_t ctx_param_ext_318856, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_param_318860, __global\n                                  unsigned char *mem_318865)\n{\n    #define segmap_group_sizze_301016 (mainzisegmap_group_sizze_300988)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321623;\n    int32_t local_tid_321624;\n    int64_t group_sizze_321627;\n    int32_t wave_sizze_321626;\n    int32_t group_tid_321625;\n    \n    global_tid_321623 = get_global_id(0);\n    local_tid_321624 = get_local_id(0);\n    group_sizze_321627 = get_local_size(0);\n    wave_sizze_321626 = LOCKSTEP_WIDTH;\n    group_tid_321625 = get_group_id(0);\n    \n    int32_t phys_tid_301021 = global_tid_321623;\n    int64_t global_tid_321628 = sext_i32_i64(group_tid_321625) *\n            segmap_group_sizze_301016 + sext_i32_i64(local_tid_321624);\n    int64_t slice_321629 = n_292675;\n    int64_t slice_321630 = partition_sizze_292766 * slice_321629;\n    int64_t gtid_301019 = squot64(global_tid_321628, slice_321629);\n    int64_t remnant_321631 = global_tid_321628 - gtid_301019 * slice_321629;\n    int64_t gtid_301020 = remnant_321631;\n    int64_t remnant_321632 = remnant_321631 - gtid_301020;\n    \n    if (slt64(gtid_301019, partition_sizze_292766) && slt64(gtid_301020,\n                                                            n_292675)) {\n        float x_301022;\n        \n        x_301022 = ((__global float *) mem_318506)[gtid_301019 * n_292675 +\n                                                   gtid_301020];\n        \n        double x_301023;\n        \n        x_301",
            "023 = ((__global double *) mem_param_318860)[gtid_301019 *\n                                                          ctx_param_ext_318856 +\n                                                          gtid_301020];\n        \n        double f32_res_301024 = fpconv_f32_f64(x_301022);\n        double defunc_1_f_res_301025 = f32_res_301024 - x_301023;\n        \n        ((__global double *) mem_318865)[gtid_301019 * n_292675 + gtid_301020] =\n            defunc_1_f_res_301025;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_301016\n}\n__kernel void mainzisegmap_301167(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675, int64_t n_p_292677,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t i_292846,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n                                  int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318610, __global\n                                  unsigned char *mem_param_318838, __global\n                                  unsigned char *mem_318865, __global\n                                  unsigned char *mem_318871, __global\n                                  unsigned char *mem_318876)\n{\n    #define segmap_group_sizze_301160 (mainzisegmap_group_sizze_301054)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321633;\n    int32_t local_tid_321634;\n    int64_t group_sizze_321637;\n    int32_t wave_sizze_321636;\n    int32_t group_tid_321635;\n    \n    global_tid_321633 = get_global_id(0);\n    local_tid_321634 = get_",
            "local_id(0);\n    group_sizze_321637 = get_local_size(0);\n    wave_sizze_321636 = LOCKSTEP_WIDTH;\n    group_tid_321635 = get_group_id(0);\n    \n    int32_t phys_tid_301167 = global_tid_321633;\n    int64_t global_tid_321638 = sext_i32_i64(group_tid_321635) *\n            segmap_group_sizze_301160 + sext_i32_i64(local_tid_321634);\n    int64_t slice_321639 = defunc_0_f_res_292820;\n    int64_t slice_321640 = n_p_292677 * slice_321639;\n    int64_t slice_321641 = partition_sizze_292766 * slice_321640;\n    int64_t gtid_301164 = squot64(global_tid_321638, slice_321640);\n    int64_t remnant_321642 = global_tid_321638 - gtid_301164 * slice_321640;\n    int64_t gtid_301165 = squot64(remnant_321642, slice_321639);\n    int64_t remnant_321643 = remnant_321642 - gtid_301165 * slice_321639;\n    int64_t gtid_301166 = remnant_321643;\n    int64_t remnant_321644 = remnant_321643 - gtid_301166;\n    \n    if ((slt64(gtid_301164, partition_sizze_292766) && slt64(gtid_301165,\n                                                             n_p_292677)) &&\n        slt64(gtid_301166, defunc_0_f_res_292820)) {\n        int64_t x_301171;\n        \n        x_301171 = ((__global int64_t *) ext_mem_318610)[gtid_301164 *\n                                                         (defunc_0_f_res_292820 *\n                                                          n_p_292677) +\n                                                         gtid_301165 *\n                                                         defunc_0_f_res_292820 +\n                                                         gtid_301166];\n        \n        int64_t x_301172 = mul64(n_p_292677, x_301171);\n        int64_t idx_301173 = add64(gtid_301165, x_301172);\n        bool cond_301174 = slt64(i_292846, idx_301173);\n        bool cond_f_res_301175 = slt64(x_301171, (int64_t) 0);\n        bool x_301176 = !cond_301174;\n        bool y_301177 = cond_f_res_301175 && x_301176;\n        bool cond_301178 = cond_301174 || y_301177;\n        double defunc_0_f_res_301179;",
            "\n        double defunc_0_f_res_301180;\n        \n        if (cond_301178) {\n            defunc_0_f_res_301179 = 0.0;\n            defunc_0_f_res_301180 = 0.0;\n        } else {\n            bool x_301181 = sle64((int64_t) 0, idx_301173);\n            bool y_301182 = slt64(idx_301173, n_292675);\n            bool bounds_check_301183 = x_301181 && y_301182;\n            bool index_certs_301184;\n            \n            if (!bounds_check_301183) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 37) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) idx_301173;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_f_res_301185;\n            \n            defunc_0_f_res_f_res_301185 = ((__global\n                                            double *) mem_318865)[gtid_301164 *\n                                                                  n_292675 +\n                                                                  idx_301173];\n            \n            double defunc_0_f_res_f_res_301186;\n            \n            defunc_0_f_res_f_res_301186 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_301164 *\n                                                                         ctx_param_ext_318834 +\n                                                                         idx_301173 *\n                                                                         ctx_param_ext_318836)];\n            defunc_0_f_res_301179 = defunc_0_f_res_f_res_301185;\n            defunc_0_f_res_301180 = defunc_0_f_res_f_res_301186;\n        }\n        ((__global double *) mem_318871)[gtid_301164 * (defunc_0_f_res_292820 *\n              ",
            "                                          n_p_292677) +\n                                         gtid_301165 * defunc_0_f_res_292820 +\n                                         gtid_301166] = defunc_0_f_res_301179;\n        ((__global double *) mem_318876)[gtid_301164 * (defunc_0_f_res_292820 *\n                                                        n_p_292677) +\n                                         gtid_301165 * defunc_0_f_res_292820 +\n                                         gtid_301166] = defunc_0_f_res_301180;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_301160\n}\n__kernel void mainzisegmap_301414(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t q_s_292678,\n                                  int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825, __global\n                                  unsigned char *ext_mem_318609, __global\n                                  unsigned char *ext_mem_318610, __global\n                                  unsigned char *ext_mem_318707, __global\n                                  unsigned char *ext_mem_318708, __global\n                                  unsigned char *mem_318871, __global\n                                  unsigned char *mem_318876, __global\n                                  unsigned char *mem_318887)\n{\n    #define segmap_group_sizze_301408 (mainzisegmap_group_sizze_301208)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321645;\n    int32_t local_tid_321646;\n    int64_t group_sizze_321649;\n    int32_t wave_sizze_321648;\n    int32_t group_tid_321647;\n    \n    global_tid_321645 = get_global_id(0);\n    local_tid_321646 = get_lo",
            "cal_id(0);\n    group_sizze_321649 = get_local_size(0);\n    wave_sizze_321648 = LOCKSTEP_WIDTH;\n    group_tid_321647 = get_group_id(0);\n    \n    int32_t phys_tid_301414 = global_tid_321645;\n    int64_t global_tid_321650 = sext_i32_i64(group_tid_321647) *\n            segmap_group_sizze_301408 + sext_i32_i64(local_tid_321646);\n    int64_t slice_321651 = s_n_m_292825;\n    int64_t slice_321652 = n_p_292677 * slice_321651;\n    int64_t slice_321653 = partition_sizze_292766 * slice_321652;\n    int64_t gtid_301411 = squot64(global_tid_321650, slice_321652);\n    int64_t remnant_321654 = global_tid_321650 - gtid_301411 * slice_321652;\n    int64_t gtid_301412 = squot64(remnant_321654, slice_321651);\n    int64_t remnant_321655 = remnant_321654 - gtid_301412 * slice_321651;\n    int64_t gtid_301413 = remnant_321655;\n    int64_t remnant_321656 = remnant_321655 - gtid_301413;\n    \n    if ((slt64(gtid_301411, partition_sizze_292766) && slt64(gtid_301412,\n                                                             n_p_292677)) &&\n        slt64(gtid_301413, s_n_m_292825)) {\n        int64_t x_301418;\n        \n        x_301418 = ((__global int64_t *) ext_mem_318609)[gtid_301411 *\n                                                         n_p_292677 +\n                                                         gtid_301412];\n        \n        int64_t x_301420;\n        \n        x_301420 = ((__global int64_t *) ext_mem_318708)[gtid_301411 *\n                                                         (s_n_m_292825 *\n                                                          n_p_292677) +\n                                                         gtid_301412 *\n                                                         s_n_m_292825 +\n                                                         gtid_301413];\n        \n        double x_301421;\n        \n        x_301421 = ((__global double *) ext_mem_318707)[gtid_301411 *\n                                                        (s_n_m_292825 *\n                      ",
            "                                   n_p_292677) +\n                                                        gtid_301412 *\n                                                        s_n_m_292825 +\n                                                        gtid_301413];\n        \n        bool cond_301422 = gtid_301413 == (int64_t) 0;\n        int64_t defunc_0_m_fun_res_301423;\n        \n        if (cond_301422) {\n            defunc_0_m_fun_res_301423 = (int64_t) 0;\n        } else {\n            int64_t y_301424 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_301425 = gtid_301413 == y_301424;\n            int64_t defunc_0_m_fun_res_f_res_301426;\n            \n            if (cond_301425) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_301427 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_301426 =\n                    defunc_0_m_fun_res_f_res_t_res_301427;\n            } else {\n                int64_t x_301428 = sub64(gtid_301413, (int64_t) 1);\n                int64_t x_301429 = mul64(jump_s_292684, x_301428);\n                int64_t min_arg_301430 = add64((int64_t) 1, x_301429);\n                int64_t min_res_301431 = smin64(defunc_0_f_res_292820,\n                                                min_arg_301430);\n                \n                defunc_0_m_fun_res_f_res_301426 = min_res_301431;\n            }\n            defunc_0_m_fun_res_301423 = defunc_0_m_fun_res_f_res_301426;\n        }\n        \n        double defunc_2_reduce_res_301432;\n        double redout_317684 = 0.0;\n        \n        for (int64_t i_317685 = 0; i_317685 < q_s_292678; i_317685++) {\n            bool cond_301437 = sle64(x_301418, i_317685);\n            int64_t defunc_0_f_res_301438;\n            \n            if (cond_301437) {\n                defunc_0_f_res_301438 = (int64_t) 0;\n            } else {\n                int64_t i_301439 = add64(x_301420, i_317685);\n                int64_t defunc_0_add_arg_301440;\n             ",
            "   \n                defunc_0_add_arg_301440 = ((__global\n                                            int64_t *) ext_mem_318610)[gtid_301411 *\n                                                                       (defunc_0_f_res_292820 *\n                                                                        n_p_292677) +\n                                                                       gtid_301412 *\n                                                                       defunc_0_f_res_292820 +\n                                                                       i_301439];\n                \n                int64_t defunc_1_add_res_301441 = add64((int64_t) 1,\n                                                        defunc_0_add_arg_301440);\n                \n                defunc_0_f_res_301438 = defunc_1_add_res_301441;\n            }\n            \n            double defunc_0_f_res_301442;\n            \n            if (cond_301437) {\n                defunc_0_f_res_301442 = 0.0;\n            } else {\n                int64_t i_301443 = add64(x_301420, i_317685);\n                double defunc_0_add_arg_301444;\n                \n                defunc_0_add_arg_301444 = ((__global\n                                            double *) mem_318876)[gtid_301411 *\n                                                                  (defunc_0_f_res_292820 *\n                                                                   n_p_292677) +\n                                                                  gtid_301412 *\n                                                                  defunc_0_f_res_292820 +\n                                                                  i_301443];\n                defunc_0_f_res_301442 = defunc_0_add_arg_301444;\n            }\n            \n            int64_t binop_p_301445 = sub64(defunc_0_f_res_301438,\n                                           defunc_0_m_fun_res_301423);\n            double defunc_0_f_res_301446 = sitofp_i64_f64(binop_p_301445);\n  ",
            "          double abs_res_301447 = fabs(defunc_0_f_res_301446);\n            double tmp1_301448 = abs_res_301447 / x_301421;\n            double x_301449 = tmp1_301448 * tmp1_301448;\n            double y_301450 = tmp1_301448 * x_301449;\n            double tmp2_301451 = 1.0 - y_301450;\n            double x_301452 = tmp2_301451 * tmp2_301451;\n            double tmp3_301453 = tmp2_301451 * x_301452;\n            double w_j_301454 = defunc_0_f_res_301442 * tmp3_301453;\n            double defunc_1_op_res_301435 = w_j_301454 + redout_317684;\n            double redout_tmp_321657 = defunc_1_op_res_301435;\n            \n            redout_317684 = redout_tmp_321657;\n        }\n        defunc_2_reduce_res_301432 = redout_317684;\n        \n        double a_301455 = 2.220446049250313e-16 + defunc_2_reduce_res_301432;\n        double a0_301456 = 1.0 / a_301455;\n        int64_t defunc_0_m_fun_res_301457;\n        \n        if (cond_301422) {\n            defunc_0_m_fun_res_301457 = (int64_t) 0;\n        } else {\n            int64_t y_301458 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_301459 = gtid_301413 == y_301458;\n            int64_t defunc_0_m_fun_res_f_res_301460;\n            \n            if (cond_301459) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_301461 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_301460 =\n                    defunc_0_m_fun_res_f_res_t_res_301461;\n            } else {\n                int64_t x_301462 = sub64(gtid_301413, (int64_t) 1);\n                int64_t x_301463 = mul64(jump_s_292684, x_301462);\n                int64_t min_arg_301464 = add64((int64_t) 1, x_301463);\n                int64_t min_res_301465 = smin64(defunc_0_f_res_292820,\n                                                min_arg_301464);\n                \n                defunc_0_m_fun_res_f_res_301460 = min_res_301465;\n            }\n            defunc_0_m_fun_res_301457 = defunc_0_m_fun_res_f_res_3",
            "01460;\n        }\n        \n        double defunc_2_reduce_res_301466;\n        double redout_317686 = 0.0;\n        \n        for (int64_t i_317687 = 0; i_317687 < q_s_292678; i_317687++) {\n            bool cond_301471 = sle64(x_301418, i_317687);\n            int64_t defunc_0_f_res_301472;\n            \n            if (cond_301471) {\n                defunc_0_f_res_301472 = (int64_t) 0;\n            } else {\n                int64_t i_301473 = add64(x_301420, i_317687);\n                int64_t defunc_0_add_arg_301474;\n                \n                defunc_0_add_arg_301474 = ((__global\n                                            int64_t *) ext_mem_318610)[gtid_301411 *\n                                                                       (defunc_0_f_res_292820 *\n                                                                        n_p_292677) +\n                                                                       gtid_301412 *\n                                                                       defunc_0_f_res_292820 +\n                                                                       i_301473];\n                \n                int64_t defunc_1_add_res_301475 = add64((int64_t) 1,\n                                                        defunc_0_add_arg_301474);\n                \n                defunc_0_f_res_301472 = defunc_1_add_res_301475;\n            }\n            \n            double defunc_0_f_res_301476;\n            \n            if (cond_301471) {\n                defunc_0_f_res_301476 = 0.0;\n            } else {\n                int64_t i_301477 = add64(x_301420, i_317687);\n                double defunc_0_add_arg_301478;\n                \n                defunc_0_add_arg_301478 = ((__global\n                                            double *) mem_318876)[gtid_301411 *\n                                                                  (defunc_0_f_res_292820 *\n                                                                   n_p_292677) +\n                        ",
            "                                          gtid_301412 *\n                                                                  defunc_0_f_res_292820 +\n                                                                  i_301477];\n                defunc_0_f_res_301476 = defunc_0_add_arg_301478;\n            }\n            \n            int64_t binop_p_301479 = sub64(defunc_0_f_res_301472,\n                                           defunc_0_m_fun_res_301457);\n            double defunc_0_f_res_301480 = sitofp_i64_f64(binop_p_301479);\n            double abs_res_301481 = fabs(defunc_0_f_res_301480);\n            double tmp1_301482 = abs_res_301481 / x_301421;\n            double x_301483 = tmp1_301482 * tmp1_301482;\n            double y_301484 = tmp1_301482 * x_301483;\n            double tmp2_301485 = 1.0 - y_301484;\n            double x_301486 = tmp2_301485 * tmp2_301485;\n            double tmp3_301487 = tmp2_301485 * x_301486;\n            double tmp4_301488 = defunc_0_f_res_301476 * tmp3_301487;\n            double defunc_0_f_res_301489;\n            \n            if (cond_301471) {\n                defunc_0_f_res_301489 = 0.0;\n            } else {\n                int64_t i_301490 = add64(x_301420, i_317687);\n                double defunc_0_add_arg_301491;\n                \n                defunc_0_add_arg_301491 = ((__global\n                                            double *) mem_318871)[gtid_301411 *\n                                                                  (defunc_0_f_res_292820 *\n                                                                   n_p_292677) +\n                                                                  gtid_301412 *\n                                                                  defunc_0_f_res_292820 +\n                                                                  i_301490];\n                defunc_0_f_res_301489 = defunc_0_add_arg_301491;\n            }\n            \n            double x_301492 = a0_301456 * tmp4_301488;\n            double defunc_",
            "9_fit_fun_res_301493 = defunc_0_f_res_301489 *\n                   x_301492;\n            double defunc_1_op_res_301469 = defunc_9_fit_fun_res_301493 +\n                   redout_317686;\n            double redout_tmp_321658 = defunc_1_op_res_301469;\n            \n            redout_317686 = redout_tmp_321658;\n        }\n        defunc_2_reduce_res_301466 = redout_317686;\n        ((__global double *) mem_318887)[gtid_301411 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_301412 * s_n_m_292825 +\n                                         gtid_301413] =\n            defunc_2_reduce_res_301466;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_301408\n}\n__kernel void mainzisegmap_301783(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t q_s_292678,\n                                  int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825, __global\n                                  unsigned char *ext_mem_318609, __global\n                                  unsigned char *ext_mem_318610, __global\n                                  unsigned char *ext_mem_318707, __global\n                                  unsigned char *ext_mem_318708, __global\n                                  unsigned char *mem_318871, __global\n                                  unsigned char *mem_318876, __global\n                                  unsigned char *mem_318893, __global\n                                  unsigned char *mem_318898)\n{\n    #define segmap_group_sizze_301776 (mainzisegmap_group_sizze_301513)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    in",
            "t32_t global_tid_321659;\n    int32_t local_tid_321660;\n    int64_t group_sizze_321663;\n    int32_t wave_sizze_321662;\n    int32_t group_tid_321661;\n    \n    global_tid_321659 = get_global_id(0);\n    local_tid_321660 = get_local_id(0);\n    group_sizze_321663 = get_local_size(0);\n    wave_sizze_321662 = LOCKSTEP_WIDTH;\n    group_tid_321661 = get_group_id(0);\n    \n    int32_t phys_tid_301783 = global_tid_321659;\n    int64_t global_tid_321664 = sext_i32_i64(group_tid_321661) *\n            segmap_group_sizze_301776 + sext_i32_i64(local_tid_321660);\n    int64_t slice_321665 = s_n_m_292825;\n    int64_t slice_321666 = n_p_292677 * slice_321665;\n    int64_t slice_321667 = partition_sizze_292766 * slice_321666;\n    int64_t gtid_301780 = squot64(global_tid_321664, slice_321666);\n    int64_t remnant_321668 = global_tid_321664 - gtid_301780 * slice_321666;\n    int64_t gtid_301781 = squot64(remnant_321668, slice_321665);\n    int64_t remnant_321669 = remnant_321668 - gtid_301781 * slice_321665;\n    int64_t gtid_301782 = remnant_321669;\n    int64_t remnant_321670 = remnant_321669 - gtid_301782;\n    \n    if ((slt64(gtid_301780, partition_sizze_292766) && slt64(gtid_301781,\n                                                             n_p_292677)) &&\n        slt64(gtid_301782, s_n_m_292825)) {\n        int64_t x_301787;\n        \n        x_301787 = ((__global int64_t *) ext_mem_318609)[gtid_301780 *\n                                                         n_p_292677 +\n                                                         gtid_301781];\n        \n        int64_t x_301789;\n        \n        x_301789 = ((__global int64_t *) ext_mem_318708)[gtid_301780 *\n                                                         (s_n_m_292825 *\n                                                          n_p_292677) +\n                                                         gtid_301781 *\n                                                         s_n_m_292825 +\n                                                      ",
            "   gtid_301782];\n        \n        double x_301790;\n        \n        x_301790 = ((__global double *) ext_mem_318707)[gtid_301780 *\n                                                        (s_n_m_292825 *\n                                                         n_p_292677) +\n                                                        gtid_301781 *\n                                                        s_n_m_292825 +\n                                                        gtid_301782];\n        \n        bool cond_301791 = gtid_301782 == (int64_t) 0;\n        int64_t defunc_0_m_fun_res_301792;\n        \n        if (cond_301791) {\n            defunc_0_m_fun_res_301792 = (int64_t) 0;\n        } else {\n            int64_t y_301793 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_301794 = gtid_301782 == y_301793;\n            int64_t defunc_0_m_fun_res_f_res_301795;\n            \n            if (cond_301794) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_301796 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_301795 =\n                    defunc_0_m_fun_res_f_res_t_res_301796;\n            } else {\n                int64_t x_301797 = sub64(gtid_301782, (int64_t) 1);\n                int64_t x_301798 = mul64(jump_s_292684, x_301797);\n                int64_t min_arg_301799 = add64((int64_t) 1, x_301798);\n                int64_t min_res_301800 = smin64(defunc_0_f_res_292820,\n                                                min_arg_301799);\n                \n                defunc_0_m_fun_res_f_res_301795 = min_res_301800;\n            }\n            defunc_0_m_fun_res_301792 = defunc_0_m_fun_res_f_res_301795;\n        }\n        \n        double defunc_2_reduce_res_301801;\n        double defunc_2_reduce_res_301802;\n        double defunc_2_reduce_res_301803;\n        double redout_317694;\n        double redout_317695;\n        double redout_317696;\n        \n        redout_317694 = 0.0;\n        redout_317695 ",
            "= 0.0;\n        redout_317696 = 0.0;\n        for (int64_t i_317697 = 0; i_317697 < q_s_292678; i_317697++) {\n            bool cond_301814 = sle64(x_301787, i_317697);\n            int64_t defunc_0_f_res_301815;\n            \n            if (cond_301814) {\n                defunc_0_f_res_301815 = (int64_t) 0;\n            } else {\n                int64_t i_301816 = add64(x_301789, i_317697);\n                int64_t defunc_0_add_arg_301817;\n                \n                defunc_0_add_arg_301817 = ((__global\n                                            int64_t *) ext_mem_318610)[gtid_301780 *\n                                                                       (defunc_0_f_res_292820 *\n                                                                        n_p_292677) +\n                                                                       gtid_301781 *\n                                                                       defunc_0_f_res_292820 +\n                                                                       i_301816];\n                \n                int64_t defunc_1_add_res_301818 = add64((int64_t) 1,\n                                                        defunc_0_add_arg_301817);\n                \n                defunc_0_f_res_301815 = defunc_1_add_res_301818;\n            }\n            \n            double defunc_0_f_res_301819;\n            \n            if (cond_301814) {\n                defunc_0_f_res_301819 = 0.0;\n            } else {\n                int64_t i_301820 = add64(x_301789, i_317697);\n                double defunc_0_add_arg_301821;\n                \n                defunc_0_add_arg_301821 = ((__global\n                                            double *) mem_318876)[gtid_301780 *\n                                                                  (defunc_0_f_res_292820 *\n                                                                   n_p_292677) +\n                                                                  gtid_301781 *\n                      ",
            "                                            defunc_0_f_res_292820 +\n                                                                  i_301820];\n                defunc_0_f_res_301819 = defunc_0_add_arg_301821;\n            }\n            \n            int64_t binop_p_301822 = sub64(defunc_0_f_res_301815,\n                                           defunc_0_m_fun_res_301792);\n            double defunc_0_f_res_301823 = sitofp_i64_f64(binop_p_301822);\n            double abs_res_301824 = fabs(defunc_0_f_res_301823);\n            double tmp1_301825 = abs_res_301824 / x_301790;\n            double x_301826 = tmp1_301825 * tmp1_301825;\n            double y_301827 = tmp1_301825 * x_301826;\n            double tmp2_301828 = 1.0 - y_301827;\n            double x_301829 = tmp2_301828 * tmp2_301828;\n            double tmp3_301830 = tmp2_301828 * x_301829;\n            double w_j_301831 = defunc_0_f_res_301819 * tmp3_301830;\n            double xw_j_301832 = defunc_0_f_res_301823 * w_j_301831;\n            double x2w_j_301833 = defunc_0_f_res_301823 * xw_j_301832;\n            double defunc_1_op_res_301806 = w_j_301831 + redout_317694;\n            double defunc_1_op_res_301809 = xw_j_301832 + redout_317695;\n            double defunc_1_op_res_301812 = x2w_j_301833 + redout_317696;\n            double redout_tmp_321671 = defunc_1_op_res_301806;\n            double redout_tmp_321672 = defunc_1_op_res_301809;\n            double redout_tmp_321673 = defunc_1_op_res_301812;\n            \n            redout_317694 = redout_tmp_321671;\n            redout_317695 = redout_tmp_321672;\n            redout_317696 = redout_tmp_321673;\n        }\n        defunc_2_reduce_res_301801 = redout_317694;\n        defunc_2_reduce_res_301802 = redout_317695;\n        defunc_2_reduce_res_301803 = redout_317696;\n        \n        double a_301834 = 2.220446049250313e-16 + defunc_2_reduce_res_301801;\n        double b_301835 = 2.220446049250313e-16 + defunc_2_reduce_res_301802;\n        double c_301836 = 2.220446049250313e-16 + ",
            "defunc_2_reduce_res_301803;\n        double x_301837 = a_301834 * c_301836;\n        double y_301838 = b_301835 * b_301835;\n        double y_301839 = x_301837 - y_301838;\n        double det1_301840 = 1.0 / y_301839;\n        double a11_301841 = c_301836 * det1_301840;\n        double x_301842 = 0.0 - b_301835;\n        double b11_301843 = det1_301840 * x_301842;\n        double c11_301844 = a_301834 * det1_301840;\n        int64_t defunc_0_m_fun_res_301845;\n        \n        if (cond_301791) {\n            defunc_0_m_fun_res_301845 = (int64_t) 0;\n        } else {\n            int64_t y_301846 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_301847 = gtid_301782 == y_301846;\n            int64_t defunc_0_m_fun_res_f_res_301848;\n            \n            if (cond_301847) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_301849 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_301848 =\n                    defunc_0_m_fun_res_f_res_t_res_301849;\n            } else {\n                int64_t x_301850 = sub64(gtid_301782, (int64_t) 1);\n                int64_t x_301851 = mul64(jump_s_292684, x_301850);\n                int64_t min_arg_301852 = add64((int64_t) 1, x_301851);\n                int64_t min_res_301853 = smin64(defunc_0_f_res_292820,\n                                                min_arg_301852);\n                \n                defunc_0_m_fun_res_f_res_301848 = min_res_301853;\n            }\n            defunc_0_m_fun_res_301845 = defunc_0_m_fun_res_f_res_301848;\n        }\n        \n        double defunc_2_reduce_res_301854;\n        double defunc_2_reduce_res_301855;\n        double redout_317698;\n        double redout_317699;\n        \n        redout_317698 = 0.0;\n        redout_317699 = 0.0;\n        for (int64_t i_317700 = 0; i_317700 < q_s_292678; i_317700++) {\n            bool cond_301863 = sle64(x_301787, i_317700);\n            int64_t defunc_0_f_res_301864;\n            \n            if (",
            "cond_301863) {\n                defunc_0_f_res_301864 = (int64_t) 0;\n            } else {\n                int64_t i_301865 = add64(x_301789, i_317700);\n                int64_t defunc_0_add_arg_301866;\n                \n                defunc_0_add_arg_301866 = ((__global\n                                            int64_t *) ext_mem_318610)[gtid_301780 *\n                                                                       (defunc_0_f_res_292820 *\n                                                                        n_p_292677) +\n                                                                       gtid_301781 *\n                                                                       defunc_0_f_res_292820 +\n                                                                       i_301865];\n                \n                int64_t defunc_1_add_res_301867 = add64((int64_t) 1,\n                                                        defunc_0_add_arg_301866);\n                \n                defunc_0_f_res_301864 = defunc_1_add_res_301867;\n            }\n            \n            double defunc_0_f_res_301868;\n            \n            if (cond_301863) {\n                defunc_0_f_res_301868 = 0.0;\n            } else {\n                int64_t i_301869 = add64(x_301789, i_317700);\n                double defunc_0_add_arg_301870;\n                \n                defunc_0_add_arg_301870 = ((__global\n                                            double *) mem_318876)[gtid_301780 *\n                                                                  (defunc_0_f_res_292820 *\n                                                                   n_p_292677) +\n                                                                  gtid_301781 *\n                                                                  defunc_0_f_res_292820 +\n                                                                  i_301869];\n                defunc_0_f_res_301868 = defunc_0_add_arg_301870;\n            }\n            \n ",
            "           int64_t binop_p_301871 = sub64(defunc_0_f_res_301864,\n                                           defunc_0_m_fun_res_301845);\n            double defunc_0_f_res_301872 = sitofp_i64_f64(binop_p_301871);\n            double abs_res_301873 = fabs(defunc_0_f_res_301872);\n            double tmp1_301874 = abs_res_301873 / x_301790;\n            double x_301875 = tmp1_301874 * tmp1_301874;\n            double y_301876 = tmp1_301874 * x_301875;\n            double tmp2_301877 = 1.0 - y_301876;\n            double x_301878 = tmp2_301877 * tmp2_301877;\n            double tmp3_301879 = tmp2_301877 * x_301878;\n            double tmp4_301880 = defunc_0_f_res_301868 * tmp3_301879;\n            double defunc_1_f_res_301881 = defunc_0_f_res_301872 * tmp4_301880;\n            double defunc_0_f_res_301882;\n            \n            if (cond_301863) {\n                defunc_0_f_res_301882 = 0.0;\n            } else {\n                int64_t i_301883 = add64(x_301789, i_317700);\n                double defunc_0_add_arg_301884;\n                \n                defunc_0_add_arg_301884 = ((__global\n                                            double *) mem_318871)[gtid_301780 *\n                                                                  (defunc_0_f_res_292820 *\n                                                                   n_p_292677) +\n                                                                  gtid_301781 *\n                                                                  defunc_0_f_res_292820 +\n                                                                  i_301883];\n                defunc_0_f_res_301882 = defunc_0_add_arg_301884;\n            }\n            \n            double x_301885 = a11_301841 * tmp4_301880;\n            double y_301886 = b11_301843 * defunc_1_f_res_301881;\n            double x_301887 = x_301885 + y_301886;\n            double defunc_9_fit_fun_res_301888 = defunc_0_f_res_301882 *\n                   x_301887;\n            double x_301889 = b11_301843 *",
            " tmp4_301880;\n            double y_301890 = c11_301844 * defunc_1_f_res_301881;\n            double x_301891 = x_301889 + y_301890;\n            double defunc_9_slope_fun_res_301892 = defunc_0_f_res_301882 *\n                   x_301891;\n            double defunc_1_op_res_301858 = defunc_9_fit_fun_res_301888 +\n                   redout_317698;\n            double defunc_1_op_res_301861 = defunc_9_slope_fun_res_301892 +\n                   redout_317699;\n            double redout_tmp_321674 = defunc_1_op_res_301858;\n            double redout_tmp_321675 = defunc_1_op_res_301861;\n            \n            redout_317698 = redout_tmp_321674;\n            redout_317699 = redout_tmp_321675;\n        }\n        defunc_2_reduce_res_301854 = redout_317698;\n        defunc_2_reduce_res_301855 = redout_317699;\n        ((__global double *) mem_318893)[gtid_301780 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_301781 * s_n_m_292825 +\n                                         gtid_301782] =\n            defunc_2_reduce_res_301854;\n        ((__global double *) mem_318898)[gtid_301780 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_301781 * s_n_m_292825 +\n                                         gtid_301782] =\n            defunc_2_reduce_res_301855;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_301776\n}\n__kernel void mainzisegmap_302252(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t q_s_292678,\n                                  int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825, __global\n                                  unsigned char *ext_mem_318",
            "609, __global\n                                  unsigned char *ext_mem_318610, __global\n                                  unsigned char *ext_mem_318707, __global\n                                  unsigned char *ext_mem_318708, __global\n                                  unsigned char *mem_318871, __global\n                                  unsigned char *mem_318876, __global\n                                  unsigned char *mem_318904, __global\n                                  unsigned char *mem_318909)\n{\n    #define segmap_group_sizze_302245 (mainzisegmap_group_sizze_301914)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321676;\n    int32_t local_tid_321677;\n    int64_t group_sizze_321680;\n    int32_t wave_sizze_321679;\n    int32_t group_tid_321678;\n    \n    global_tid_321676 = get_global_id(0);\n    local_tid_321677 = get_local_id(0);\n    group_sizze_321680 = get_local_size(0);\n    wave_sizze_321679 = LOCKSTEP_WIDTH;\n    group_tid_321678 = get_group_id(0);\n    \n    int32_t phys_tid_302252 = global_tid_321676;\n    int64_t global_tid_321681 = sext_i32_i64(group_tid_321678) *\n            segmap_group_sizze_302245 + sext_i32_i64(local_tid_321677);\n    int64_t slice_321682 = s_n_m_292825;\n    int64_t slice_321683 = n_p_292677 * slice_321682;\n    int64_t slice_321684 = partition_sizze_292766 * slice_321683;\n    int64_t gtid_302249 = squot64(global_tid_321681, slice_321683);\n    int64_t remnant_321685 = global_tid_321681 - gtid_302249 * slice_321683;\n    int64_t gtid_302250 = squot64(remnant_321685, slice_321682);\n    int64_t remnant_321686 = remnant_321685 - gtid_302250 * slice_321682;\n    int64_t gtid_302251 = remnant_321686;\n    int64_t remnant_321687 = remnant_321686 - gtid_302251;\n    \n    if ((slt64(gtid_302249, partition_sizze_292766) && slt64(gtid_302250,\n                                                             n_p_292677)) &&\n        sl",
            "t64(gtid_302251, s_n_m_292825)) {\n        int64_t x_302256;\n        \n        x_302256 = ((__global int64_t *) ext_mem_318609)[gtid_302249 *\n                                                         n_p_292677 +\n                                                         gtid_302250];\n        \n        int64_t x_302258;\n        \n        x_302258 = ((__global int64_t *) ext_mem_318708)[gtid_302249 *\n                                                         (s_n_m_292825 *\n                                                          n_p_292677) +\n                                                         gtid_302250 *\n                                                         s_n_m_292825 +\n                                                         gtid_302251];\n        \n        double x_302259;\n        \n        x_302259 = ((__global double *) ext_mem_318707)[gtid_302249 *\n                                                        (s_n_m_292825 *\n                                                         n_p_292677) +\n                                                        gtid_302250 *\n                                                        s_n_m_292825 +\n                                                        gtid_302251];\n        \n        bool cond_302260 = gtid_302251 == (int64_t) 0;\n        int64_t defunc_0_m_fun_res_302261;\n        \n        if (cond_302260) {\n            defunc_0_m_fun_res_302261 = (int64_t) 0;\n        } else {\n            int64_t y_302262 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_302263 = gtid_302251 == y_302262;\n            int64_t defunc_0_m_fun_res_f_res_302264;\n            \n            if (cond_302263) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_302265 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_302264 =\n                    defunc_0_m_fun_res_f_res_t_res_302265;\n            } else {\n                int64_t x_302266 = sub64(gtid_302251, (int64_t) 1);\n    ",
            "            int64_t x_302267 = mul64(jump_s_292684, x_302266);\n                int64_t min_arg_302268 = add64((int64_t) 1, x_302267);\n                int64_t min_res_302269 = smin64(defunc_0_f_res_292820,\n                                                min_arg_302268);\n                \n                defunc_0_m_fun_res_f_res_302264 = min_res_302269;\n            }\n            defunc_0_m_fun_res_302261 = defunc_0_m_fun_res_f_res_302264;\n        }\n        \n        double defunc_2_reduce_res_302270;\n        double defunc_2_reduce_res_302271;\n        double defunc_2_reduce_res_302272;\n        double defunc_2_reduce_res_302273;\n        double defunc_2_reduce_res_302274;\n        double redout_317707;\n        double redout_317708;\n        double redout_317709;\n        double redout_317710;\n        double redout_317711;\n        \n        redout_317707 = 0.0;\n        redout_317708 = 0.0;\n        redout_317709 = 0.0;\n        redout_317710 = 0.0;\n        redout_317711 = 0.0;\n        for (int64_t i_317712 = 0; i_317712 < q_s_292678; i_317712++) {\n            bool cond_302291 = sle64(x_302256, i_317712);\n            int64_t defunc_0_f_res_302292;\n            \n            if (cond_302291) {\n                defunc_0_f_res_302292 = (int64_t) 0;\n            } else {\n                int64_t i_302293 = add64(x_302258, i_317712);\n                int64_t defunc_0_add_arg_302294;\n                \n                defunc_0_add_arg_302294 = ((__global\n                                            int64_t *) ext_mem_318610)[gtid_302249 *\n                                                                       (defunc_0_f_res_292820 *\n                                                                        n_p_292677) +\n                                                                       gtid_302250 *\n                                                                       defunc_0_f_res_292820 +\n                                                                       i_302293];\n                \n    ",
            "            int64_t defunc_1_add_res_302295 = add64((int64_t) 1,\n                                                        defunc_0_add_arg_302294);\n                \n                defunc_0_f_res_302292 = defunc_1_add_res_302295;\n            }\n            \n            double defunc_0_f_res_302296;\n            \n            if (cond_302291) {\n                defunc_0_f_res_302296 = 0.0;\n            } else {\n                int64_t i_302297 = add64(x_302258, i_317712);\n                double defunc_0_add_arg_302298;\n                \n                defunc_0_add_arg_302298 = ((__global\n                                            double *) mem_318876)[gtid_302249 *\n                                                                  (defunc_0_f_res_292820 *\n                                                                   n_p_292677) +\n                                                                  gtid_302250 *\n                                                                  defunc_0_f_res_292820 +\n                                                                  i_302297];\n                defunc_0_f_res_302296 = defunc_0_add_arg_302298;\n            }\n            \n            int64_t binop_p_302299 = sub64(defunc_0_f_res_302292,\n                                           defunc_0_m_fun_res_302261);\n            double defunc_0_f_res_302300 = sitofp_i64_f64(binop_p_302299);\n            double abs_res_302301 = fabs(defunc_0_f_res_302300);\n            double tmp1_302302 = abs_res_302301 / x_302259;\n            double x_302303 = tmp1_302302 * tmp1_302302;\n            double y_302304 = tmp1_302302 * x_302303;\n            double tmp2_302305 = 1.0 - y_302304;\n            double x_302306 = tmp2_302305 * tmp2_302305;\n            double tmp3_302307 = tmp2_302305 * x_302306;\n            double w_j_302308 = defunc_0_f_res_302296 * tmp3_302307;\n            double xw_j_302309 = defunc_0_f_res_302300 * w_j_302308;\n            double x2w_j_302310 = defunc_0_f_res_302300 * xw_j_302309;\n ",
            "           double x3w_j_302311 = defunc_0_f_res_302300 * x2w_j_302310;\n            double x4w_j_302312 = defunc_0_f_res_302300 * x3w_j_302311;\n            double defunc_1_op_res_302277 = w_j_302308 + redout_317707;\n            double defunc_1_op_res_302280 = xw_j_302309 + redout_317708;\n            double defunc_1_op_res_302283 = x2w_j_302310 + redout_317709;\n            double defunc_1_op_res_302286 = x3w_j_302311 + redout_317710;\n            double defunc_1_op_res_302289 = x4w_j_302312 + redout_317711;\n            double redout_tmp_321688 = defunc_1_op_res_302277;\n            double redout_tmp_321689 = defunc_1_op_res_302280;\n            double redout_tmp_321690 = defunc_1_op_res_302283;\n            double redout_tmp_321691 = defunc_1_op_res_302286;\n            double redout_tmp_321692 = defunc_1_op_res_302289;\n            \n            redout_317707 = redout_tmp_321688;\n            redout_317708 = redout_tmp_321689;\n            redout_317709 = redout_tmp_321690;\n            redout_317710 = redout_tmp_321691;\n            redout_317711 = redout_tmp_321692;\n        }\n        defunc_2_reduce_res_302270 = redout_317707;\n        defunc_2_reduce_res_302271 = redout_317708;\n        defunc_2_reduce_res_302272 = redout_317709;\n        defunc_2_reduce_res_302273 = redout_317710;\n        defunc_2_reduce_res_302274 = redout_317711;\n        \n        double a_302313 = 2.220446049250313e-16 + defunc_2_reduce_res_302270;\n        double b_302314 = 2.220446049250313e-16 + defunc_2_reduce_res_302271;\n        double c_302315 = 2.220446049250313e-16 + defunc_2_reduce_res_302272;\n        double d_302316 = 2.220446049250313e-16 + defunc_2_reduce_res_302273;\n        double e_302317 = 2.220446049250313e-16 + defunc_2_reduce_res_302274;\n        double x_302318 = c_302315 * e_302317;\n        double y_302319 = d_302316 * d_302316;\n        double a12_302320 = x_302318 - y_302319;\n        double x_302321 = c_302315 * d_302316;\n        double y_302322 = b_302314 * e_302317;\n        double b12_30",
            "2323 = x_302321 - y_302322;\n        double x_302324 = b_302314 * d_302316;\n        double y_302325 = c_302315 * c_302315;\n        double c12_302326 = x_302324 - y_302325;\n        double x_302327 = a_302313 * e_302317;\n        double b2_302328 = x_302327 - y_302325;\n        double x_302329 = b_302314 * c_302315;\n        double y_302330 = a_302313 * d_302316;\n        double c2_302331 = x_302329 - y_302330;\n        double x_302332 = a_302313 * a12_302320;\n        double y_302333 = b_302314 * b12_302323;\n        double x_302334 = x_302332 + y_302333;\n        double y_302335 = c_302315 * c12_302326;\n        double y_302336 = x_302334 + y_302335;\n        double det_302337 = 1.0 / y_302336;\n        double a12_302338 = a12_302320 * det_302337;\n        double b12_302339 = b12_302323 * det_302337;\n        double c12_302340 = c12_302326 * det_302337;\n        double b2_302341 = b2_302328 * det_302337;\n        double c2_302342 = c2_302331 * det_302337;\n        int64_t defunc_0_m_fun_res_302343;\n        \n        if (cond_302260) {\n            defunc_0_m_fun_res_302343 = (int64_t) 0;\n        } else {\n            int64_t y_302344 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_302345 = gtid_302251 == y_302344;\n            int64_t defunc_0_m_fun_res_f_res_302346;\n            \n            if (cond_302345) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_302347 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_302346 =\n                    defunc_0_m_fun_res_f_res_t_res_302347;\n            } else {\n                int64_t x_302348 = sub64(gtid_302251, (int64_t) 1);\n                int64_t x_302349 = mul64(jump_s_292684, x_302348);\n                int64_t min_arg_302350 = add64((int64_t) 1, x_302349);\n                int64_t min_res_302351 = smin64(defunc_0_f_res_292820,\n                                                min_arg_302350);\n                \n                defunc_0_m_fun_res_f_res_3023",
            "46 = min_res_302351;\n            }\n            defunc_0_m_fun_res_302343 = defunc_0_m_fun_res_f_res_302346;\n        }\n        \n        double defunc_2_reduce_res_302352;\n        double defunc_2_reduce_res_302353;\n        double redout_317713;\n        double redout_317714;\n        \n        redout_317713 = 0.0;\n        redout_317714 = 0.0;\n        for (int64_t i_317715 = 0; i_317715 < q_s_292678; i_317715++) {\n            bool cond_302361 = sle64(x_302256, i_317715);\n            int64_t defunc_0_f_res_302362;\n            \n            if (cond_302361) {\n                defunc_0_f_res_302362 = (int64_t) 0;\n            } else {\n                int64_t i_302363 = add64(x_302258, i_317715);\n                int64_t defunc_0_add_arg_302364;\n                \n                defunc_0_add_arg_302364 = ((__global\n                                            int64_t *) ext_mem_318610)[gtid_302249 *\n                                                                       (defunc_0_f_res_292820 *\n                                                                        n_p_292677) +\n                                                                       gtid_302250 *\n                                                                       defunc_0_f_res_292820 +\n                                                                       i_302363];\n                \n                int64_t defunc_1_add_res_302365 = add64((int64_t) 1,\n                                                        defunc_0_add_arg_302364);\n                \n                defunc_0_f_res_302362 = defunc_1_add_res_302365;\n            }\n            \n            double defunc_0_f_res_302366;\n            \n            if (cond_302361) {\n                defunc_0_f_res_302366 = 0.0;\n            } else {\n                int64_t i_302367 = add64(x_302258, i_317715);\n                double defunc_0_add_arg_302368;\n                \n                defunc_0_add_arg_302368 = ((__global\n                                            double",
            " *) mem_318876)[gtid_302249 *\n                                                                  (defunc_0_f_res_292820 *\n                                                                   n_p_292677) +\n                                                                  gtid_302250 *\n                                                                  defunc_0_f_res_292820 +\n                                                                  i_302367];\n                defunc_0_f_res_302366 = defunc_0_add_arg_302368;\n            }\n            \n            int64_t binop_p_302369 = sub64(defunc_0_f_res_302362,\n                                           defunc_0_m_fun_res_302343);\n            double defunc_0_f_res_302370 = sitofp_i64_f64(binop_p_302369);\n            double abs_res_302371 = fabs(defunc_0_f_res_302370);\n            double tmp1_302372 = abs_res_302371 / x_302259;\n            double x_302373 = tmp1_302372 * tmp1_302372;\n            double y_302374 = tmp1_302372 * x_302373;\n            double tmp2_302375 = 1.0 - y_302374;\n            double x_302376 = tmp2_302375 * tmp2_302375;\n            double tmp3_302377 = tmp2_302375 * x_302376;\n            double tmp4_302378 = defunc_0_f_res_302366 * tmp3_302377;\n            double defunc_1_f_res_302379 = defunc_0_f_res_302370 * tmp4_302378;\n            double defunc_1_f_res_302380 = defunc_0_f_res_302370 *\n                   defunc_1_f_res_302379;\n            double defunc_0_f_res_302381;\n            \n            if (cond_302361) {\n                defunc_0_f_res_302381 = 0.0;\n            } else {\n                int64_t i_302382 = add64(x_302258, i_317715);\n                double defunc_0_add_arg_302383;\n                \n                defunc_0_add_arg_302383 = ((__global\n                                            double *) mem_318871)[gtid_302249 *\n                                                                  (defunc_0_f_res_292820 *\n                                                                   n_p_292677) +\n     ",
            "                                                             gtid_302250 *\n                                                                  defunc_0_f_res_292820 +\n                                                                  i_302382];\n                defunc_0_f_res_302381 = defunc_0_add_arg_302383;\n            }\n            \n            double x_302384 = a12_302338 * tmp4_302378;\n            double y_302385 = b12_302339 * defunc_1_f_res_302379;\n            double x_302386 = x_302384 + y_302385;\n            double y_302387 = c12_302340 * defunc_1_f_res_302380;\n            double x_302388 = x_302386 + y_302387;\n            double defunc_9_fit_fun_res_302389 = defunc_0_f_res_302381 *\n                   x_302388;\n            double x_302390 = b12_302339 * tmp4_302378;\n            double y_302391 = b2_302341 * defunc_1_f_res_302379;\n            double x_302392 = x_302390 + y_302391;\n            double y_302393 = c2_302342 * defunc_1_f_res_302380;\n            double x_302394 = x_302392 + y_302393;\n            double defunc_9_slope_fun_res_302395 = defunc_0_f_res_302381 *\n                   x_302394;\n            double defunc_1_op_res_302356 = defunc_9_fit_fun_res_302389 +\n                   redout_317713;\n            double defunc_1_op_res_302359 = defunc_9_slope_fun_res_302395 +\n                   redout_317714;\n            double redout_tmp_321693 = defunc_1_op_res_302356;\n            double redout_tmp_321694 = defunc_1_op_res_302359;\n            \n            redout_317713 = redout_tmp_321693;\n            redout_317714 = redout_tmp_321694;\n        }\n        defunc_2_reduce_res_302352 = redout_317713;\n        defunc_2_reduce_res_302353 = redout_317714;\n        ((__global double *) mem_318904)[gtid_302249 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_302250 * s_n_m_292825 +\n                                         gtid_302251] =\n            defunc_2_reduce_res_302352;\n        ((",
            "__global double *) mem_318909)[gtid_302249 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_302250 * s_n_m_292825 +\n                                         gtid_302251] =\n            defunc_2_reduce_res_302353;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_302245\n}\n__kernel void mainzisegmap_304408(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t q_s_292678,\n                                  int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825,\n                                  int64_t num_groups_304388,\n                                  int64_t num_threads_320713, __global\n                                  unsigned char *ext_mem_318609, __global\n                                  unsigned char *mem_318987, __global\n                                  unsigned char *mem_318991, __global\n                                  unsigned char *mem_318995, __global\n                                  unsigned char *mem_318999, __global\n                                  unsigned char *mem_319003, __global\n                                  unsigned char *mem_319023, __global\n                                  unsigned char *color_320614)\n{\n    #define segmap_group_sizze_304387 (mainzisegmap_group_sizze_303532)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321783;\n    int32_t local_tid_321784;\n    int64_t group_sizze_321787;\n    int32_t wave_sizze_321786;\n    int32_t group_tid_321785;\n    \n    global_tid_321783 = get_global_id(0);\n    local_tid_321784 = get_local_id(0);\n    group_sizze_321787 = get_lo",
            "cal_size(0);\n    wave_sizze_321786 = LOCKSTEP_WIDTH;\n    group_tid_321785 = get_group_id(0);\n    \n    int32_t phys_tid_304408 = global_tid_321783;\n    int32_t phys_group_id_321788;\n    \n    phys_group_id_321788 = get_group_id(0);\n    for (int32_t i_321789 = 0; i_321789 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * n_p_292677,\n                                          segmap_group_sizze_304387)) -\n                   phys_group_id_321788, sext_i64_i32(num_groups_304388));\n         i_321789++) {\n        int32_t virt_group_id_321790 = phys_group_id_321788 + i_321789 *\n                sext_i64_i32(num_groups_304388);\n        int64_t global_tid_321791 = sext_i32_i64(virt_group_id_321790) *\n                segmap_group_sizze_304387 + sext_i32_i64(local_tid_321784);\n        int64_t slice_321792 = n_p_292677;\n        int64_t slice_321793 = partition_sizze_292766 * slice_321792;\n        int64_t gtid_304406 = squot64(global_tid_321791, slice_321792);\n        int64_t remnant_321794 = global_tid_321791 - gtid_304406 * slice_321792;\n        int64_t gtid_304407 = remnant_321794;\n        int64_t remnant_321795 = remnant_321794 - gtid_304407;\n        \n        if (slt64(gtid_304406, partition_sizze_292766) && slt64(gtid_304407,\n                                                                n_p_292677)) {\n            int64_t x_304412;\n            \n            x_304412 = ((__global int64_t *) ext_mem_318609)[gtid_304406 *\n                                                             n_p_292677 +\n                                                             gtid_304407];\n            for (int64_t i_318438 = 0; i_318438 < s_n_m_292825; i_318438++) {\n                int64_t x_304417;\n                \n                x_304417 = ((__global int64_t *) mem_318987)[i_318438 *\n                                                             (n_p_292677 *\n                                                              partition_sizze_292766) +\n                                     ",
            "                        gtid_304406 *\n                                                             n_p_292677 +\n                                                             gtid_304407];\n                \n                double x_304418;\n                \n                x_304418 = ((__global double *) mem_318991)[i_318438 *\n                                                            (n_p_292677 *\n                                                             partition_sizze_292766) +\n                                                            gtid_304406 *\n                                                            n_p_292677 +\n                                                            gtid_304407];\n                \n                bool cond_304419 = i_318438 == (int64_t) 0;\n                int64_t defunc_0_m_fun_res_304420;\n                \n                if (cond_304419) {\n                    defunc_0_m_fun_res_304420 = (int64_t) 0;\n                } else {\n                    int64_t y_304421 = sub64(s_n_m_292825, (int64_t) 1);\n                    bool cond_304422 = i_318438 == y_304421;\n                    int64_t defunc_0_m_fun_res_f_res_304423;\n                    \n                    if (cond_304422) {\n                        int64_t defunc_0_m_fun_res_f_res_t_res_304424 =\n                                sub64(pad_css_len_292821, (int64_t) 1);\n                        \n                        defunc_0_m_fun_res_f_res_304423 =\n                            defunc_0_m_fun_res_f_res_t_res_304424;\n                    } else {\n                        int64_t x_304425 = sub64(i_318438, (int64_t) 1);\n                        int64_t x_304426 = mul64(jump_s_292684, x_304425);\n                        int64_t min_arg_304427 = add64((int64_t) 1, x_304426);\n                        int64_t min_res_304428 = smin64(defunc_0_f_res_292820,\n                                                        min_arg_304427);\n                        \n                        defunc_0_m_fun_res_f_",
            "res_304423 = min_res_304428;\n                    }\n                    defunc_0_m_fun_res_304420 = defunc_0_m_fun_res_f_res_304423;\n                }\n                \n                double defunc_2_reduce_res_304429;\n                double redout_317740 = 0.0;\n                \n                for (int64_t i_317741 = 0; i_317741 < q_s_292678; i_317741++) {\n                    bool cond_304434 = sle64(x_304412, i_317741);\n                    int64_t defunc_0_f_res_304435;\n                    \n                    if (cond_304434) {\n                        defunc_0_f_res_304435 = (int64_t) 0;\n                    } else {\n                        int64_t i_304436 = add64(x_304417, i_317741);\n                        int64_t defunc_0_add_arg_304437;\n                        \n                        defunc_0_add_arg_304437 = ((__global\n                                                    int64_t *) mem_318995)[i_304436 *\n                                                                           (n_p_292677 *\n                                                                            partition_sizze_292766) +\n                                                                           gtid_304406 *\n                                                                           n_p_292677 +\n                                                                           gtid_304407];\n                        \n                        int64_t defunc_1_add_res_304438 = add64((int64_t) 1,\n                                                                defunc_0_add_arg_304437);\n                        \n                        defunc_0_f_res_304435 = defunc_1_add_res_304438;\n                    }\n                    \n                    double defunc_0_f_res_304439;\n                    \n                    if (cond_304434) {\n                        defunc_0_f_res_304439 = 0.0;\n                    } else {\n                        int64_t i_304440 = add64(x_304417, i_317741);\n                       ",
            " double defunc_0_add_arg_304441;\n                        \n                        defunc_0_add_arg_304441 = ((__global\n                                                    double *) mem_318999)[i_304440 *\n                                                                          (n_p_292677 *\n                                                                           partition_sizze_292766) +\n                                                                          gtid_304406 *\n                                                                          n_p_292677 +\n                                                                          gtid_304407];\n                        defunc_0_f_res_304439 = defunc_0_add_arg_304441;\n                    }\n                    \n                    int64_t binop_p_304442 = sub64(defunc_0_f_res_304435,\n                                                   defunc_0_m_fun_res_304420);\n                    double defunc_0_f_res_304443 =\n                           sitofp_i64_f64(binop_p_304442);\n                    double abs_res_304444 = fabs(defunc_0_f_res_304443);\n                    double tmp1_304445 = abs_res_304444 / x_304418;\n                    double x_304446 = tmp1_304445 * tmp1_304445;\n                    double y_304447 = tmp1_304445 * x_304446;\n                    double tmp2_304448 = 1.0 - y_304447;\n                    double x_304449 = tmp2_304448 * tmp2_304448;\n                    double tmp3_304450 = tmp2_304448 * x_304449;\n                    double w_j_304451 = defunc_0_f_res_304439 * tmp3_304450;\n                    double defunc_1_op_res_304432 = w_j_304451 + redout_317740;\n                    double redout_tmp_321797 = defunc_1_op_res_304432;\n                    \n                    redout_317740 = redout_tmp_321797;\n                }\n                defunc_2_reduce_res_304429 = redout_317740;\n                \n                double a_304452 = 2.220446049250313e-16 +\n                       defunc_2_reduce_res_304429;\n  ",
            "              double a0_304453 = 1.0 / a_304452;\n                int64_t defunc_0_m_fun_res_304454;\n                \n                if (cond_304419) {\n                    defunc_0_m_fun_res_304454 = (int64_t) 0;\n                } else {\n                    int64_t y_304455 = sub64(s_n_m_292825, (int64_t) 1);\n                    bool cond_304456 = i_318438 == y_304455;\n                    int64_t defunc_0_m_fun_res_f_res_304457;\n                    \n                    if (cond_304456) {\n                        int64_t defunc_0_m_fun_res_f_res_t_res_304458 =\n                                sub64(pad_css_len_292821, (int64_t) 1);\n                        \n                        defunc_0_m_fun_res_f_res_304457 =\n                            defunc_0_m_fun_res_f_res_t_res_304458;\n                    } else {\n                        int64_t x_304459 = sub64(i_318438, (int64_t) 1);\n                        int64_t x_304460 = mul64(jump_s_292684, x_304459);\n                        int64_t min_arg_304461 = add64((int64_t) 1, x_304460);\n                        int64_t min_res_304462 = smin64(defunc_0_f_res_292820,\n                                                        min_arg_304461);\n                        \n                        defunc_0_m_fun_res_f_res_304457 = min_res_304462;\n                    }\n                    defunc_0_m_fun_res_304454 = defunc_0_m_fun_res_f_res_304457;\n                }\n                \n                double defunc_2_reduce_res_304463;\n                double redout_317742 = 0.0;\n                \n                for (int64_t i_317743 = 0; i_317743 < q_s_292678; i_317743++) {\n                    bool cond_304468 = sle64(x_304412, i_317743);\n                    int64_t defunc_0_f_res_304469;\n                    \n                    if (cond_304468) {\n                        defunc_0_f_res_304469 = (int64_t) 0;\n                    } else {\n                        int64_t i_304470 = add64(x_304417, i_317743);\n                        int64_t defunc_",
            "0_add_arg_304471;\n                        \n                        defunc_0_add_arg_304471 = ((__global\n                                                    int64_t *) mem_318995)[i_304470 *\n                                                                           (n_p_292677 *\n                                                                            partition_sizze_292766) +\n                                                                           gtid_304406 *\n                                                                           n_p_292677 +\n                                                                           gtid_304407];\n                        \n                        int64_t defunc_1_add_res_304472 = add64((int64_t) 1,\n                                                                defunc_0_add_arg_304471);\n                        \n                        defunc_0_f_res_304469 = defunc_1_add_res_304472;\n                    }\n                    \n                    double defunc_0_f_res_304473;\n                    \n                    if (cond_304468) {\n                        defunc_0_f_res_304473 = 0.0;\n                    } else {\n                        int64_t i_304474 = add64(x_304417, i_317743);\n                        double defunc_0_add_arg_304475;\n                        \n                        defunc_0_add_arg_304475 = ((__global\n                                                    double *) mem_318999)[i_304474 *\n                                                                          (n_p_292677 *\n                                                                           partition_sizze_292766) +\n                                                                          gtid_304406 *\n                                                                          n_p_292677 +\n                                                                          gtid_304407];\n                        defunc_0_f_res_304473 = defunc_0_add_arg_304475;\n      ",
            "              }\n                    \n                    int64_t binop_p_304476 = sub64(defunc_0_f_res_304469,\n                                                   defunc_0_m_fun_res_304454);\n                    double defunc_0_f_res_304477 =\n                           sitofp_i64_f64(binop_p_304476);\n                    double abs_res_304478 = fabs(defunc_0_f_res_304477);\n                    double tmp1_304479 = abs_res_304478 / x_304418;\n                    double x_304480 = tmp1_304479 * tmp1_304479;\n                    double y_304481 = tmp1_304479 * x_304480;\n                    double tmp2_304482 = 1.0 - y_304481;\n                    double x_304483 = tmp2_304482 * tmp2_304482;\n                    double tmp3_304484 = tmp2_304482 * x_304483;\n                    double tmp4_304485 = defunc_0_f_res_304473 * tmp3_304484;\n                    double defunc_0_f_res_304486;\n                    \n                    if (cond_304468) {\n                        defunc_0_f_res_304486 = 0.0;\n                    } else {\n                        int64_t i_304487 = add64(x_304417, i_317743);\n                        double defunc_0_add_arg_304488;\n                        \n                        defunc_0_add_arg_304488 = ((__global\n                                                    double *) mem_319003)[i_304487 *\n                                                                          (n_p_292677 *\n                                                                           partition_sizze_292766) +\n                                                                          gtid_304406 *\n                                                                          n_p_292677 +\n                                                                          gtid_304407];\n                        defunc_0_f_res_304486 = defunc_0_add_arg_304488;\n                    }\n                    \n                    double x_304489 = a0_304453 * tmp4_304485;\n                    double defunc_9_fit_fun_res",
            "_304490 = defunc_0_f_res_304486 *\n                           x_304489;\n                    double defunc_1_op_res_304466 =\n                           defunc_9_fit_fun_res_304490 + redout_317742;\n                    double redout_tmp_321798 = defunc_1_op_res_304466;\n                    \n                    redout_317742 = redout_tmp_321798;\n                }\n                defunc_2_reduce_res_304463 = redout_317742;\n                ((__global double *) color_320614)[phys_tid_304408 + i_318438 *\n                                                   num_threads_320713] =\n                    defunc_2_reduce_res_304463;\n            }\n            for (int64_t i_321799 = 0; i_321799 < s_n_m_292825; i_321799++) {\n                double tmp_321800;\n                \n                tmp_321800 = ((__global\n                               double *) color_320614)[phys_tid_304408 +\n                                                       i_321799 *\n                                                       num_threads_320713];\n                ((__global double *) mem_319023)[gtid_304406 * n_p_292677 +\n                                                 gtid_304407 + i_321799 *\n                                                 (n_p_292677 *\n                                                  partition_sizze_292766)] =\n                    tmp_321800;\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_304387\n}\n__kernel void mainzisegmap_304619(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825, __global\n                                  unsigned char *mem_319056, __global\n                               ",
            "   unsigned char *mem_319060)\n{\n    #define segmap_group_sizze_304612 (mainzisegmap_group_sizze_304045)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321865;\n    int32_t local_tid_321866;\n    int64_t group_sizze_321869;\n    int32_t wave_sizze_321868;\n    int32_t group_tid_321867;\n    \n    global_tid_321865 = get_global_id(0);\n    local_tid_321866 = get_local_id(0);\n    group_sizze_321869 = get_local_size(0);\n    wave_sizze_321868 = LOCKSTEP_WIDTH;\n    group_tid_321867 = get_group_id(0);\n    \n    int32_t phys_tid_304619 = global_tid_321865;\n    int64_t global_tid_321870 = sext_i32_i64(group_tid_321867) *\n            segmap_group_sizze_304612 + sext_i32_i64(local_tid_321866);\n    int64_t slice_321871 = s_n_m_292825;\n    int64_t slice_321872 = n_p_292677 * slice_321871;\n    int64_t slice_321873 = partition_sizze_292766 * slice_321872;\n    int64_t gtid_304616 = squot64(global_tid_321870, slice_321872);\n    int64_t remnant_321874 = global_tid_321870 - gtid_304616 * slice_321872;\n    int64_t gtid_304617 = squot64(remnant_321874, slice_321871);\n    int64_t remnant_321875 = remnant_321874 - gtid_304617 * slice_321871;\n    int64_t gtid_304618 = remnant_321875;\n    int64_t remnant_321876 = remnant_321875 - gtid_304618;\n    \n    if ((slt64(gtid_304616, partition_sizze_292766) && slt64(gtid_304617,\n                                                             n_p_292677)) &&\n        slt64(gtid_304618, s_n_m_292825)) {\n        bool cond_304621 = gtid_304618 == (int64_t) 0;\n        int64_t defunc_0_m_fun_res_304622;\n        \n        if (cond_304621) {\n            defunc_0_m_fun_res_304622 = (int64_t) 0;\n        } else {\n            int64_t y_304623 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_304624 = gtid_304618 == y_304623;\n            int64_t defunc_0_m_fun_res_f_res_304625;\n            \n            if (cond_304624) {\n                int64",
            "_t defunc_0_m_fun_res_f_res_t_res_304626 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_304625 =\n                    defunc_0_m_fun_res_f_res_t_res_304626;\n            } else {\n                int64_t x_304627 = sub64(gtid_304618, (int64_t) 1);\n                int64_t x_304628 = mul64(jump_s_292684, x_304627);\n                int64_t min_arg_304629 = add64((int64_t) 1, x_304628);\n                int64_t min_res_304630 = smin64(defunc_0_f_res_292820,\n                                                min_arg_304629);\n                \n                defunc_0_m_fun_res_f_res_304625 = min_res_304630;\n            }\n            defunc_0_m_fun_res_304622 = defunc_0_m_fun_res_f_res_304625;\n        }\n        ((__global int64_t *) mem_319056)[gtid_304616 * (s_n_m_292825 *\n                                                         n_p_292677) +\n                                          gtid_304617 * s_n_m_292825 +\n                                          gtid_304618] =\n            defunc_0_m_fun_res_304622;\n        ((__global bool *) mem_319060)[gtid_304616 * (s_n_m_292825 *\n                                                      n_p_292677) +\n                                       gtid_304617 * s_n_m_292825 +\n                                       gtid_304618] = cond_304621;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_304612\n}\n__kernel void mainzisegmap_304691(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825, __global\n                                  unsigned char *mem_319066, __global\n                                  unsigned char *mem_319072, __global\n                              ",
            "    unsigned char *mem_319077)\n{\n    #define segmap_group_sizze_304684 (mainzisegmap_group_sizze_303958)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321953;\n    int32_t local_tid_321954;\n    int64_t group_sizze_321957;\n    int32_t wave_sizze_321956;\n    int32_t group_tid_321955;\n    \n    global_tid_321953 = get_global_id(0);\n    local_tid_321954 = get_local_id(0);\n    group_sizze_321957 = get_local_size(0);\n    wave_sizze_321956 = LOCKSTEP_WIDTH;\n    group_tid_321955 = get_group_id(0);\n    \n    int32_t phys_tid_304691 = global_tid_321953;\n    int64_t global_tid_321958 = sext_i32_i64(group_tid_321955) *\n            segmap_group_sizze_304684 + sext_i32_i64(local_tid_321954);\n    int64_t slice_321959 = s_n_m_292825;\n    int64_t slice_321960 = n_p_292677 * slice_321959;\n    int64_t slice_321961 = partition_sizze_292766 * slice_321960;\n    int64_t gtid_304688 = squot64(global_tid_321958, slice_321960);\n    int64_t remnant_321962 = global_tid_321958 - gtid_304688 * slice_321960;\n    int64_t gtid_304689 = squot64(remnant_321962, slice_321959);\n    int64_t remnant_321963 = remnant_321962 - gtid_304689 * slice_321959;\n    int64_t gtid_304690 = remnant_321963;\n    int64_t remnant_321964 = remnant_321963 - gtid_304690;\n    \n    if ((slt64(gtid_304688, partition_sizze_292766) && slt64(gtid_304689,\n                                                             n_p_292677)) &&\n        slt64(gtid_304690, s_n_m_292825)) {\n        bool index_primexp_317930 = gtid_304690 == (int64_t) 0;\n        double defunc_2_reduce_res_304694;\n        \n        defunc_2_reduce_res_304694 = ((__global\n                                       double *) mem_319066)[gtid_304688 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                  ",
            "           gtid_304689 *\n                                                             s_n_m_292825 +\n                                                             gtid_304690];\n        \n        double a_304695 = 2.220446049250313e-16 + defunc_2_reduce_res_304694;\n        double a0_304696 = 1.0 / a_304695;\n        int64_t defunc_0_m_fun_res_304697;\n        \n        if (index_primexp_317930) {\n            defunc_0_m_fun_res_304697 = (int64_t) 0;\n        } else {\n            int64_t y_304698 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_304699 = gtid_304690 == y_304698;\n            int64_t defunc_0_m_fun_res_f_res_304700;\n            \n            if (cond_304699) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_304701 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_304700 =\n                    defunc_0_m_fun_res_f_res_t_res_304701;\n            } else {\n                int64_t x_304702 = sub64(gtid_304690, (int64_t) 1);\n                int64_t x_304703 = mul64(jump_s_292684, x_304702);\n                int64_t min_arg_304704 = add64((int64_t) 1, x_304703);\n                int64_t min_res_304705 = smin64(defunc_0_f_res_292820,\n                                                min_arg_304704);\n                \n                defunc_0_m_fun_res_f_res_304700 = min_res_304705;\n            }\n            defunc_0_m_fun_res_304697 = defunc_0_m_fun_res_f_res_304700;\n        }\n        ((__global double *) mem_319072)[gtid_304688 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_304689 * s_n_m_292825 +\n                                         gtid_304690] = a0_304696;\n        ((__global int64_t *) mem_319077)[gtid_304688 * (s_n_m_292825 *\n                                                         n_p_292677) +\n                                          gtid_304689 * s_n_m_292825 +\n                             ",
            "             gtid_304690] =\n            defunc_0_m_fun_res_304697;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_304684\n}\n__kernel void mainzisegmap_305885(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t q_s_292678,\n                                  int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825,\n                                  int64_t num_groups_305863,\n                                  int64_t num_threads_320720, __global\n                                  unsigned char *ext_mem_318609, __global\n                                  unsigned char *mem_319095, __global\n                                  unsigned char *mem_319099, __global\n                                  unsigned char *mem_319103, __global\n                                  unsigned char *mem_319107, __global\n                                  unsigned char *mem_319111, __global\n                                  unsigned char *mem_319146, __global\n                                  unsigned char *mem_319150, __global\n                                  unsigned char *color_320619, __global\n                                  unsigned char *color_320620)\n{\n    #define segmap_group_sizze_305862 (mainzisegmap_group_sizze_304773)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322046;\n    int32_t local_tid_322047;\n    int64_t group_sizze_322050;\n    int32_t wave_sizze_322049;\n    int32_t group_tid_322048;\n    \n    global_tid_322046 = get_global_id(0);\n    local_tid_322047 = get_local_id(0);\n    group_sizze_322050 = get_local_size(0);\n    wave_sizze_322049 = LOCKSTEP_WIDTH;\n    group_tid_322048 = get_group_id",
            "(0);\n    \n    int32_t phys_tid_305885 = global_tid_322046;\n    int32_t phys_group_id_322051;\n    \n    phys_group_id_322051 = get_group_id(0);\n    for (int32_t i_322052 = 0; i_322052 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * n_p_292677,\n                                          segmap_group_sizze_305862)) -\n                   phys_group_id_322051, sext_i64_i32(num_groups_305863));\n         i_322052++) {\n        int32_t virt_group_id_322053 = phys_group_id_322051 + i_322052 *\n                sext_i64_i32(num_groups_305863);\n        int64_t global_tid_322054 = sext_i32_i64(virt_group_id_322053) *\n                segmap_group_sizze_305862 + sext_i32_i64(local_tid_322047);\n        int64_t slice_322055 = n_p_292677;\n        int64_t slice_322056 = partition_sizze_292766 * slice_322055;\n        int64_t gtid_305883 = squot64(global_tid_322054, slice_322055);\n        int64_t remnant_322057 = global_tid_322054 - gtid_305883 * slice_322055;\n        int64_t gtid_305884 = remnant_322057;\n        int64_t remnant_322058 = remnant_322057 - gtid_305884;\n        \n        if (slt64(gtid_305883, partition_sizze_292766) && slt64(gtid_305884,\n                                                                n_p_292677)) {\n            int64_t x_305889;\n            \n            x_305889 = ((__global int64_t *) ext_mem_318609)[gtid_305883 *\n                                                             n_p_292677 +\n                                                             gtid_305884];\n            for (int64_t i_318444 = 0; i_318444 < s_n_m_292825; i_318444++) {\n                int64_t x_305895;\n                \n                x_305895 = ((__global int64_t *) mem_319095)[i_318444 *\n                                                             (n_p_292677 *\n                                                              partition_sizze_292766) +\n                                                             gtid_305883 *\n                                                  ",
            "           n_p_292677 +\n                                                             gtid_305884];\n                \n                double x_305896;\n                \n                x_305896 = ((__global double *) mem_319099)[i_318444 *\n                                                            (n_p_292677 *\n                                                             partition_sizze_292766) +\n                                                            gtid_305883 *\n                                                            n_p_292677 +\n                                                            gtid_305884];\n                \n                bool cond_305897 = i_318444 == (int64_t) 0;\n                int64_t defunc_0_m_fun_res_305898;\n                \n                if (cond_305897) {\n                    defunc_0_m_fun_res_305898 = (int64_t) 0;\n                } else {\n                    int64_t y_305899 = sub64(s_n_m_292825, (int64_t) 1);\n                    bool cond_305900 = i_318444 == y_305899;\n                    int64_t defunc_0_m_fun_res_f_res_305901;\n                    \n                    if (cond_305900) {\n                        int64_t defunc_0_m_fun_res_f_res_t_res_305902 =\n                                sub64(pad_css_len_292821, (int64_t) 1);\n                        \n                        defunc_0_m_fun_res_f_res_305901 =\n                            defunc_0_m_fun_res_f_res_t_res_305902;\n                    } else {\n                        int64_t x_305903 = sub64(i_318444, (int64_t) 1);\n                        int64_t x_305904 = mul64(jump_s_292684, x_305903);\n                        int64_t min_arg_305905 = add64((int64_t) 1, x_305904);\n                        int64_t min_res_305906 = smin64(defunc_0_f_res_292820,\n                                                        min_arg_305905);\n                        \n                        defunc_0_m_fun_res_f_res_305901 = min_res_305906;\n                    }\n                    defunc_0_m_fun_re",
            "s_305898 = defunc_0_m_fun_res_f_res_305901;\n                }\n                \n                double defunc_2_reduce_res_305907;\n                double defunc_2_reduce_res_305908;\n                double defunc_2_reduce_res_305909;\n                double redout_317764;\n                double redout_317765;\n                double redout_317766;\n                \n                redout_317764 = 0.0;\n                redout_317765 = 0.0;\n                redout_317766 = 0.0;\n                for (int64_t i_317767 = 0; i_317767 < q_s_292678; i_317767++) {\n                    bool cond_305920 = sle64(x_305889, i_317767);\n                    int64_t defunc_0_f_res_305921;\n                    \n                    if (cond_305920) {\n                        defunc_0_f_res_305921 = (int64_t) 0;\n                    } else {\n                        int64_t i_305922 = add64(x_305895, i_317767);\n                        int64_t defunc_0_add_arg_305923;\n                        \n                        defunc_0_add_arg_305923 = ((__global\n                                                    int64_t *) mem_319103)[i_305922 *\n                                                                           (n_p_292677 *\n                                                                            partition_sizze_292766) +\n                                                                           gtid_305883 *\n                                                                           n_p_292677 +\n                                                                           gtid_305884];\n                        \n                        int64_t defunc_1_add_res_305924 = add64((int64_t) 1,\n                                                                defunc_0_add_arg_305923);\n                        \n                        defunc_0_f_res_305921 = defunc_1_add_res_305924;\n                    }\n                    \n                    double defunc_0_f_res_305925;\n                    \n                   ",
            " if (cond_305920) {\n                        defunc_0_f_res_305925 = 0.0;\n                    } else {\n                        int64_t i_305926 = add64(x_305895, i_317767);\n                        double defunc_0_add_arg_305927;\n                        \n                        defunc_0_add_arg_305927 = ((__global\n                                                    double *) mem_319107)[i_305926 *\n                                                                          (n_p_292677 *\n                                                                           partition_sizze_292766) +\n                                                                          gtid_305883 *\n                                                                          n_p_292677 +\n                                                                          gtid_305884];\n                        defunc_0_f_res_305925 = defunc_0_add_arg_305927;\n                    }\n                    \n                    int64_t binop_p_305928 = sub64(defunc_0_f_res_305921,\n                                                   defunc_0_m_fun_res_305898);\n                    double defunc_0_f_res_305929 =\n                           sitofp_i64_f64(binop_p_305928);\n                    double abs_res_305930 = fabs(defunc_0_f_res_305929);\n                    double tmp1_305931 = abs_res_305930 / x_305896;\n                    double x_305932 = tmp1_305931 * tmp1_305931;\n                    double y_305933 = tmp1_305931 * x_305932;\n                    double tmp2_305934 = 1.0 - y_305933;\n                    double x_305935 = tmp2_305934 * tmp2_305934;\n                    double tmp3_305936 = tmp2_305934 * x_305935;\n                    double w_j_305937 = defunc_0_f_res_305925 * tmp3_305936;\n                    double xw_j_305938 = defunc_0_f_res_305929 * w_j_305937;\n                    double x2w_j_305939 = defunc_0_f_res_305929 * xw_j_305938;\n                    double defunc_1_op_res_305912 = w_j_305937 + redout_317764;\n  ",
            "                  double defunc_1_op_res_305915 = xw_j_305938 + redout_317765;\n                    double defunc_1_op_res_305918 = x2w_j_305939 +\n                           redout_317766;\n                    double redout_tmp_322061 = defunc_1_op_res_305912;\n                    double redout_tmp_322062 = defunc_1_op_res_305915;\n                    double redout_tmp_322063 = defunc_1_op_res_305918;\n                    \n                    redout_317764 = redout_tmp_322061;\n                    redout_317765 = redout_tmp_322062;\n                    redout_317766 = redout_tmp_322063;\n                }\n                defunc_2_reduce_res_305907 = redout_317764;\n                defunc_2_reduce_res_305908 = redout_317765;\n                defunc_2_reduce_res_305909 = redout_317766;\n                \n                double a_305940 = 2.220446049250313e-16 +\n                       defunc_2_reduce_res_305907;\n                double b_305941 = 2.220446049250313e-16 +\n                       defunc_2_reduce_res_305908;\n                double c_305942 = 2.220446049250313e-16 +\n                       defunc_2_reduce_res_305909;\n                double x_305943 = a_305940 * c_305942;\n                double y_305944 = b_305941 * b_305941;\n                double y_305945 = x_305943 - y_305944;\n                double det1_305946 = 1.0 / y_305945;\n                double a11_305947 = c_305942 * det1_305946;\n                double x_305948 = 0.0 - b_305941;\n                double b11_305949 = det1_305946 * x_305948;\n                double c11_305950 = a_305940 * det1_305946;\n                int64_t defunc_0_m_fun_res_305951;\n                \n                if (cond_305897) {\n                    defunc_0_m_fun_res_305951 = (int64_t) 0;\n                } else {\n                    int64_t y_305952 = sub64(s_n_m_292825, (int64_t) 1);\n                    bool cond_305953 = i_318444 == y_305952;\n                    int64_t defunc_0_m_fun_res_f_res_305954;\n                    \n                  ",
            "  if (cond_305953) {\n                        int64_t defunc_0_m_fun_res_f_res_t_res_305955 =\n                                sub64(pad_css_len_292821, (int64_t) 1);\n                        \n                        defunc_0_m_fun_res_f_res_305954 =\n                            defunc_0_m_fun_res_f_res_t_res_305955;\n                    } else {\n                        int64_t x_305956 = sub64(i_318444, (int64_t) 1);\n                        int64_t x_305957 = mul64(jump_s_292684, x_305956);\n                        int64_t min_arg_305958 = add64((int64_t) 1, x_305957);\n                        int64_t min_res_305959 = smin64(defunc_0_f_res_292820,\n                                                        min_arg_305958);\n                        \n                        defunc_0_m_fun_res_f_res_305954 = min_res_305959;\n                    }\n                    defunc_0_m_fun_res_305951 = defunc_0_m_fun_res_f_res_305954;\n                }\n                \n                double defunc_2_reduce_res_305960;\n                double defunc_2_reduce_res_305961;\n                double redout_317768;\n                double redout_317769;\n                \n                redout_317768 = 0.0;\n                redout_317769 = 0.0;\n                for (int64_t i_317770 = 0; i_317770 < q_s_292678; i_317770++) {\n                    bool cond_305969 = sle64(x_305889, i_317770);\n                    int64_t defunc_0_f_res_305970;\n                    \n                    if (cond_305969) {\n                        defunc_0_f_res_305970 = (int64_t) 0;\n                    } else {\n                        int64_t i_305971 = add64(x_305895, i_317770);\n                        int64_t defunc_0_add_arg_305972;\n                        \n                        defunc_0_add_arg_305972 = ((__global\n                                                    int64_t *) mem_319103)[i_305971 *\n                                                                           (n_p_292677 *\n                                    ",
            "                                        partition_sizze_292766) +\n                                                                           gtid_305883 *\n                                                                           n_p_292677 +\n                                                                           gtid_305884];\n                        \n                        int64_t defunc_1_add_res_305973 = add64((int64_t) 1,\n                                                                defunc_0_add_arg_305972);\n                        \n                        defunc_0_f_res_305970 = defunc_1_add_res_305973;\n                    }\n                    \n                    double defunc_0_f_res_305974;\n                    \n                    if (cond_305969) {\n                        defunc_0_f_res_305974 = 0.0;\n                    } else {\n                        int64_t i_305975 = add64(x_305895, i_317770);\n                        double defunc_0_add_arg_305976;\n                        \n                        defunc_0_add_arg_305976 = ((__global\n                                                    double *) mem_319107)[i_305975 *\n                                                                          (n_p_292677 *\n                                                                           partition_sizze_292766) +\n                                                                          gtid_305883 *\n                                                                          n_p_292677 +\n                                                                          gtid_305884];\n                        defunc_0_f_res_305974 = defunc_0_add_arg_305976;\n                    }\n                    \n                    int64_t binop_p_305977 = sub64(defunc_0_f_res_305970,\n                                                   defunc_0_m_fun_res_305951);\n                    double defunc_0_f_res_305978 =\n                           sitofp_i64_f64(binop_p_305977);\n               ",
            "     double abs_res_305979 = fabs(defunc_0_f_res_305978);\n                    double tmp1_305980 = abs_res_305979 / x_305896;\n                    double x_305981 = tmp1_305980 * tmp1_305980;\n                    double y_305982 = tmp1_305980 * x_305981;\n                    double tmp2_305983 = 1.0 - y_305982;\n                    double x_305984 = tmp2_305983 * tmp2_305983;\n                    double tmp3_305985 = tmp2_305983 * x_305984;\n                    double tmp4_305986 = defunc_0_f_res_305974 * tmp3_305985;\n                    double defunc_1_f_res_305987 = defunc_0_f_res_305978 *\n                           tmp4_305986;\n                    double defunc_0_f_res_305988;\n                    \n                    if (cond_305969) {\n                        defunc_0_f_res_305988 = 0.0;\n                    } else {\n                        int64_t i_305989 = add64(x_305895, i_317770);\n                        double defunc_0_add_arg_305990;\n                        \n                        defunc_0_add_arg_305990 = ((__global\n                                                    double *) mem_319111)[i_305989 *\n                                                                          (n_p_292677 *\n                                                                           partition_sizze_292766) +\n                                                                          gtid_305883 *\n                                                                          n_p_292677 +\n                                                                          gtid_305884];\n                        defunc_0_f_res_305988 = defunc_0_add_arg_305990;\n                    }\n                    \n                    double x_305991 = a11_305947 * tmp4_305986;\n                    double y_305992 = b11_305949 * defunc_1_f_res_305987;\n                    double x_305993 = x_305991 + y_305992;\n                    double defunc_9_fit_fun_res_305994 = defunc_0_f_res_305988 *\n                           x_305",
            "993;\n                    double x_305995 = b11_305949 * tmp4_305986;\n                    double y_305996 = c11_305950 * defunc_1_f_res_305987;\n                    double x_305997 = x_305995 + y_305996;\n                    double defunc_9_slope_fun_res_305998 =\n                           defunc_0_f_res_305988 * x_305997;\n                    double defunc_1_op_res_305964 =\n                           defunc_9_fit_fun_res_305994 + redout_317768;\n                    double defunc_1_op_res_305967 =\n                           defunc_9_slope_fun_res_305998 + redout_317769;\n                    double redout_tmp_322064 = defunc_1_op_res_305964;\n                    double redout_tmp_322065 = defunc_1_op_res_305967;\n                    \n                    redout_317768 = redout_tmp_322064;\n                    redout_317769 = redout_tmp_322065;\n                }\n                defunc_2_reduce_res_305960 = redout_317768;\n                defunc_2_reduce_res_305961 = redout_317769;\n                ((__global double *) color_320620)[phys_tid_305885 + i_318444 *\n                                                   num_threads_320720] =\n                    defunc_2_reduce_res_305960;\n                ((__global double *) color_320619)[phys_tid_305885 + i_318444 *\n                                                   num_threads_320720] =\n                    defunc_2_reduce_res_305961;\n            }\n            for (int64_t i_322066 = 0; i_322066 < s_n_m_292825; i_322066++) {\n                double tmp_322067;\n                \n                tmp_322067 = ((__global\n                               double *) color_320620)[phys_tid_305885 +\n                                                       i_322066 *\n                                                       num_threads_320720];\n                ((__global double *) mem_319146)[gtid_305883 * n_p_292677 +\n                                                 gtid_305884 + i_322066 *\n                                                 (n_p_292677 *\n   ",
            "                                               partition_sizze_292766)] =\n                    tmp_322067;\n            }\n            for (int64_t i_322068 = 0; i_322068 < s_n_m_292825; i_322068++) {\n                double tmp_322069;\n                \n                tmp_322069 = ((__global\n                               double *) color_320619)[phys_tid_305885 +\n                                                       i_322068 *\n                                                       num_threads_320720];\n                ((__global double *) mem_319150)[gtid_305883 * n_p_292677 +\n                                                 gtid_305884 + i_322068 *\n                                                 (n_p_292677 *\n                                                  partition_sizze_292766)] =\n                    tmp_322069;\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_305862\n}\n__kernel void mainzisegmap_306165(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825, __global\n                                  unsigned char *mem_319203, __global\n                                  unsigned char *mem_319207)\n{\n    #define segmap_group_sizze_306158 (mainzisegmap_group_sizze_305437)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322168;\n    int32_t local_tid_322169;\n    int64_t group_sizze_322172;\n    int32_t wave_sizze_322171;\n    int32_t group_tid_322170;\n    \n    global_tid_322168 = get_global_id(0);\n    local_tid_322169 = get_local_id(0);\n    group_sizze_322",
            "172 = get_local_size(0);\n    wave_sizze_322171 = LOCKSTEP_WIDTH;\n    group_tid_322170 = get_group_id(0);\n    \n    int32_t phys_tid_306165 = global_tid_322168;\n    int64_t global_tid_322173 = sext_i32_i64(group_tid_322170) *\n            segmap_group_sizze_306158 + sext_i32_i64(local_tid_322169);\n    int64_t slice_322174 = s_n_m_292825;\n    int64_t slice_322175 = n_p_292677 * slice_322174;\n    int64_t slice_322176 = partition_sizze_292766 * slice_322175;\n    int64_t gtid_306162 = squot64(global_tid_322173, slice_322175);\n    int64_t remnant_322177 = global_tid_322173 - gtid_306162 * slice_322175;\n    int64_t gtid_306163 = squot64(remnant_322177, slice_322174);\n    int64_t remnant_322178 = remnant_322177 - gtid_306163 * slice_322174;\n    int64_t gtid_306164 = remnant_322178;\n    int64_t remnant_322179 = remnant_322178 - gtid_306164;\n    \n    if ((slt64(gtid_306162, partition_sizze_292766) && slt64(gtid_306163,\n                                                             n_p_292677)) &&\n        slt64(gtid_306164, s_n_m_292825)) {\n        bool cond_306167 = gtid_306164 == (int64_t) 0;\n        int64_t defunc_0_m_fun_res_306168;\n        \n        if (cond_306167) {\n            defunc_0_m_fun_res_306168 = (int64_t) 0;\n        } else {\n            int64_t y_306169 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_306170 = gtid_306164 == y_306169;\n            int64_t defunc_0_m_fun_res_f_res_306171;\n            \n            if (cond_306170) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_306172 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_306171 =\n                    defunc_0_m_fun_res_f_res_t_res_306172;\n            } else {\n                int64_t x_306173 = sub64(gtid_306164, (int64_t) 1);\n                int64_t x_306174 = mul64(jump_s_292684, x_306173);\n                int64_t min_arg_306175 = add64((int64_t) 1, x_306174);\n                int64_t min_res_306176 = smin64(defunc_",
            "0_f_res_292820,\n                                                min_arg_306175);\n                \n                defunc_0_m_fun_res_f_res_306171 = min_res_306176;\n            }\n            defunc_0_m_fun_res_306168 = defunc_0_m_fun_res_f_res_306171;\n        }\n        ((__global int64_t *) mem_319203)[gtid_306162 * (s_n_m_292825 *\n                                                         n_p_292677) +\n                                          gtid_306163 * s_n_m_292825 +\n                                          gtid_306164] =\n            defunc_0_m_fun_res_306168;\n        ((__global bool *) mem_319207)[gtid_306162 * (s_n_m_292825 *\n                                                      n_p_292677) +\n                                       gtid_306163 * s_n_m_292825 +\n                                       gtid_306164] = cond_306167;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_306158\n}\n__kernel void mainzisegmap_306249(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825, __global\n                                  unsigned char *mem_319213, __global\n                                  unsigned char *mem_319218, __global\n                                  unsigned char *mem_319223, __global\n                                  unsigned char *mem_319229, __global\n                                  unsigned char *mem_319234, __global\n                                  unsigned char *mem_319239, __global\n                                  unsigned char *mem_319244)\n{\n    #define segmap_group_sizze_306240 (mainzisegmap_group_sizze_305331)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n",
            "        return;\n    \n    int32_t global_tid_322284;\n    int32_t local_tid_322285;\n    int64_t group_sizze_322288;\n    int32_t wave_sizze_322287;\n    int32_t group_tid_322286;\n    \n    global_tid_322284 = get_global_id(0);\n    local_tid_322285 = get_local_id(0);\n    group_sizze_322288 = get_local_size(0);\n    wave_sizze_322287 = LOCKSTEP_WIDTH;\n    group_tid_322286 = get_group_id(0);\n    \n    int32_t phys_tid_306249 = global_tid_322284;\n    int64_t global_tid_322289 = sext_i32_i64(group_tid_322286) *\n            segmap_group_sizze_306240 + sext_i32_i64(local_tid_322285);\n    int64_t slice_322290 = s_n_m_292825;\n    int64_t slice_322291 = n_p_292677 * slice_322290;\n    int64_t slice_322292 = partition_sizze_292766 * slice_322291;\n    int64_t gtid_306246 = squot64(global_tid_322289, slice_322291);\n    int64_t remnant_322293 = global_tid_322289 - gtid_306246 * slice_322291;\n    int64_t gtid_306247 = squot64(remnant_322293, slice_322290);\n    int64_t remnant_322294 = remnant_322293 - gtid_306247 * slice_322290;\n    int64_t gtid_306248 = remnant_322294;\n    int64_t remnant_322295 = remnant_322294 - gtid_306248;\n    \n    if ((slt64(gtid_306246, partition_sizze_292766) && slt64(gtid_306247,\n                                                             n_p_292677)) &&\n        slt64(gtid_306248, s_n_m_292825)) {\n        bool index_primexp_317936 = gtid_306248 == (int64_t) 0;\n        double defunc_2_reduce_res_306252;\n        \n        defunc_2_reduce_res_306252 = ((__global\n                                       double *) mem_319213)[gtid_306246 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_306247 *\n                                                             s_n_m_292825 +\n                                                             gtid_306248];\n        \n        double defunc_2_reduce_res_306253;\n       ",
            " \n        defunc_2_reduce_res_306253 = ((__global\n                                       double *) mem_319218)[gtid_306246 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_306247 *\n                                                             s_n_m_292825 +\n                                                             gtid_306248];\n        \n        double defunc_2_reduce_res_306254;\n        \n        defunc_2_reduce_res_306254 = ((__global\n                                       double *) mem_319223)[gtid_306246 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_306247 *\n                                                             s_n_m_292825 +\n                                                             gtid_306248];\n        \n        double a_306255 = 2.220446049250313e-16 + defunc_2_reduce_res_306252;\n        double b_306256 = 2.220446049250313e-16 + defunc_2_reduce_res_306253;\n        double c_306257 = 2.220446049250313e-16 + defunc_2_reduce_res_306254;\n        double x_306258 = a_306255 * c_306257;\n        double y_306259 = b_306256 * b_306256;\n        double y_306260 = x_306258 - y_306259;\n        double det1_306261 = 1.0 / y_306260;\n        double a11_306262 = c_306257 * det1_306261;\n        double x_306263 = 0.0 - b_306256;\n        double b11_306264 = det1_306261 * x_306263;\n        double c11_306265 = a_306255 * det1_306261;\n        int64_t defunc_0_m_fun_res_306266;\n        \n        if (index_primexp_317936) {\n            defunc_0_m_fun_res_306266 = (int64_t) 0;\n        } else {\n            int64_t y_306267 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_306268 = gtid_306248 == y_306267;\n            int64_t defunc_",
            "0_m_fun_res_f_res_306269;\n            \n            if (cond_306268) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_306270 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_306269 =\n                    defunc_0_m_fun_res_f_res_t_res_306270;\n            } else {\n                int64_t x_306271 = sub64(gtid_306248, (int64_t) 1);\n                int64_t x_306272 = mul64(jump_s_292684, x_306271);\n                int64_t min_arg_306273 = add64((int64_t) 1, x_306272);\n                int64_t min_res_306274 = smin64(defunc_0_f_res_292820,\n                                                min_arg_306273);\n                \n                defunc_0_m_fun_res_f_res_306269 = min_res_306274;\n            }\n            defunc_0_m_fun_res_306266 = defunc_0_m_fun_res_f_res_306269;\n        }\n        ((__global double *) mem_319229)[gtid_306246 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_306247 * s_n_m_292825 +\n                                         gtid_306248] = a11_306262;\n        ((__global double *) mem_319234)[gtid_306246 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_306247 * s_n_m_292825 +\n                                         gtid_306248] = b11_306264;\n        ((__global double *) mem_319239)[gtid_306246 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_306247 * s_n_m_292825 +\n                                         gtid_306248] = c11_306265;\n        ((__global int64_t *) mem_319244)[gtid_306246 * (s_n_m_292825 *\n                                                         n_p_292677) +\n                                          gtid_306247 * s_n_m_292825 +\n                                          gtid_306248] =\n            defunc_0_m_fu",
            "n_res_306266;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_306240\n}\n__kernel void mainzisegmap_307727(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t q_s_292678,\n                                  int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825,\n                                  int64_t num_groups_307705,\n                                  int64_t num_threads_320728, __global\n                                  unsigned char *ext_mem_318609, __global\n                                  unsigned char *mem_319275, __global\n                                  unsigned char *mem_319279, __global\n                                  unsigned char *mem_319283, __global\n                                  unsigned char *mem_319287, __global\n                                  unsigned char *mem_319291, __global\n                                  unsigned char *mem_319326, __global\n                                  unsigned char *mem_319330, __global\n                                  unsigned char *color_320629, __global\n                                  unsigned char *color_320630)\n{\n    #define segmap_group_sizze_307704 (mainzisegmap_group_sizze_306361)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322391;\n    int32_t local_tid_322392;\n    int64_t group_sizze_322395;\n    int32_t wave_sizze_322394;\n    int32_t group_tid_322393;\n    \n    global_tid_322391 = get_global_id(0);\n    local_tid_322392 = get_local_id(0);\n    group_sizze_322395 = get_local_size(0);\n    wave_sizze_322394 = LOCKSTEP_WIDTH;\n    group_tid_322393 = get_group_id(0);\n    \n    int32_t phys_tid_307727 = global_tid_32",
            "2391;\n    int32_t phys_group_id_322396;\n    \n    phys_group_id_322396 = get_group_id(0);\n    for (int32_t i_322397 = 0; i_322397 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * n_p_292677,\n                                          segmap_group_sizze_307704)) -\n                   phys_group_id_322396, sext_i64_i32(num_groups_307705));\n         i_322397++) {\n        int32_t virt_group_id_322398 = phys_group_id_322396 + i_322397 *\n                sext_i64_i32(num_groups_307705);\n        int64_t global_tid_322399 = sext_i32_i64(virt_group_id_322398) *\n                segmap_group_sizze_307704 + sext_i32_i64(local_tid_322392);\n        int64_t slice_322400 = n_p_292677;\n        int64_t slice_322401 = partition_sizze_292766 * slice_322400;\n        int64_t gtid_307725 = squot64(global_tid_322399, slice_322400);\n        int64_t remnant_322402 = global_tid_322399 - gtid_307725 * slice_322400;\n        int64_t gtid_307726 = remnant_322402;\n        int64_t remnant_322403 = remnant_322402 - gtid_307726;\n        \n        if (slt64(gtid_307725, partition_sizze_292766) && slt64(gtid_307726,\n                                                                n_p_292677)) {\n            int64_t x_307731;\n            \n            x_307731 = ((__global int64_t *) ext_mem_318609)[gtid_307725 *\n                                                             n_p_292677 +\n                                                             gtid_307726];\n            for (int64_t i_318451 = 0; i_318451 < s_n_m_292825; i_318451++) {\n                int64_t x_307737;\n                \n                x_307737 = ((__global int64_t *) mem_319275)[i_318451 *\n                                                             (n_p_292677 *\n                                                              partition_sizze_292766) +\n                                                             gtid_307725 *\n                                                             n_p_292677 +\n                             ",
            "                                gtid_307726];\n                \n                double x_307738;\n                \n                x_307738 = ((__global double *) mem_319279)[i_318451 *\n                                                            (n_p_292677 *\n                                                             partition_sizze_292766) +\n                                                            gtid_307725 *\n                                                            n_p_292677 +\n                                                            gtid_307726];\n                \n                bool cond_307739 = i_318451 == (int64_t) 0;\n                int64_t defunc_0_m_fun_res_307740;\n                \n                if (cond_307739) {\n                    defunc_0_m_fun_res_307740 = (int64_t) 0;\n                } else {\n                    int64_t y_307741 = sub64(s_n_m_292825, (int64_t) 1);\n                    bool cond_307742 = i_318451 == y_307741;\n                    int64_t defunc_0_m_fun_res_f_res_307743;\n                    \n                    if (cond_307742) {\n                        int64_t defunc_0_m_fun_res_f_res_t_res_307744 =\n                                sub64(pad_css_len_292821, (int64_t) 1);\n                        \n                        defunc_0_m_fun_res_f_res_307743 =\n                            defunc_0_m_fun_res_f_res_t_res_307744;\n                    } else {\n                        int64_t x_307745 = sub64(i_318451, (int64_t) 1);\n                        int64_t x_307746 = mul64(jump_s_292684, x_307745);\n                        int64_t min_arg_307747 = add64((int64_t) 1, x_307746);\n                        int64_t min_res_307748 = smin64(defunc_0_f_res_292820,\n                                                        min_arg_307747);\n                        \n                        defunc_0_m_fun_res_f_res_307743 = min_res_307748;\n                    }\n                    defunc_0_m_fun_res_307740 = defunc_0_m_fun_res_f_res_307743;\n         ",
            "       }\n                \n                double defunc_2_reduce_res_307749;\n                double defunc_2_reduce_res_307750;\n                double defunc_2_reduce_res_307751;\n                double defunc_2_reduce_res_307752;\n                double defunc_2_reduce_res_307753;\n                double redout_317791;\n                double redout_317792;\n                double redout_317793;\n                double redout_317794;\n                double redout_317795;\n                \n                redout_317791 = 0.0;\n                redout_317792 = 0.0;\n                redout_317793 = 0.0;\n                redout_317794 = 0.0;\n                redout_317795 = 0.0;\n                for (int64_t i_317796 = 0; i_317796 < q_s_292678; i_317796++) {\n                    bool cond_307770 = sle64(x_307731, i_317796);\n                    int64_t defunc_0_f_res_307771;\n                    \n                    if (cond_307770) {\n                        defunc_0_f_res_307771 = (int64_t) 0;\n                    } else {\n                        int64_t i_307772 = add64(x_307737, i_317796);\n                        int64_t defunc_0_add_arg_307773;\n                        \n                        defunc_0_add_arg_307773 = ((__global\n                                                    int64_t *) mem_319283)[i_307772 *\n                                                                           (n_p_292677 *\n                                                                            partition_sizze_292766) +\n                                                                           gtid_307725 *\n                                                                           n_p_292677 +\n                                                                           gtid_307726];\n                        \n                        int64_t defunc_1_add_res_307774 = add64((int64_t) 1,\n                                                                defunc_0_add_arg_307773);\n                        \n       ",
            "                 defunc_0_f_res_307771 = defunc_1_add_res_307774;\n                    }\n                    \n                    double defunc_0_f_res_307775;\n                    \n                    if (cond_307770) {\n                        defunc_0_f_res_307775 = 0.0;\n                    } else {\n                        int64_t i_307776 = add64(x_307737, i_317796);\n                        double defunc_0_add_arg_307777;\n                        \n                        defunc_0_add_arg_307777 = ((__global\n                                                    double *) mem_319287)[i_307776 *\n                                                                          (n_p_292677 *\n                                                                           partition_sizze_292766) +\n                                                                          gtid_307725 *\n                                                                          n_p_292677 +\n                                                                          gtid_307726];\n                        defunc_0_f_res_307775 = defunc_0_add_arg_307777;\n                    }\n                    \n                    int64_t binop_p_307778 = sub64(defunc_0_f_res_307771,\n                                                   defunc_0_m_fun_res_307740);\n                    double defunc_0_f_res_307779 =\n                           sitofp_i64_f64(binop_p_307778);\n                    double abs_res_307780 = fabs(defunc_0_f_res_307779);\n                    double tmp1_307781 = abs_res_307780 / x_307738;\n                    double x_307782 = tmp1_307781 * tmp1_307781;\n                    double y_307783 = tmp1_307781 * x_307782;\n                    double tmp2_307784 = 1.0 - y_307783;\n                    double x_307785 = tmp2_307784 * tmp2_307784;\n                    double tmp3_307786 = tmp2_307784 * x_307785;\n                    double w_j_307787 = defunc_0_f_res_307775 * tmp3_307786;\n                    double xw_j_307788 ",
            "= defunc_0_f_res_307779 * w_j_307787;\n                    double x2w_j_307789 = defunc_0_f_res_307779 * xw_j_307788;\n                    double x3w_j_307790 = defunc_0_f_res_307779 * x2w_j_307789;\n                    double x4w_j_307791 = defunc_0_f_res_307779 * x3w_j_307790;\n                    double defunc_1_op_res_307756 = w_j_307787 + redout_317791;\n                    double defunc_1_op_res_307759 = xw_j_307788 + redout_317792;\n                    double defunc_1_op_res_307762 = x2w_j_307789 +\n                           redout_317793;\n                    double defunc_1_op_res_307765 = x3w_j_307790 +\n                           redout_317794;\n                    double defunc_1_op_res_307768 = x4w_j_307791 +\n                           redout_317795;\n                    double redout_tmp_322406 = defunc_1_op_res_307756;\n                    double redout_tmp_322407 = defunc_1_op_res_307759;\n                    double redout_tmp_322408 = defunc_1_op_res_307762;\n                    double redout_tmp_322409 = defunc_1_op_res_307765;\n                    double redout_tmp_322410 = defunc_1_op_res_307768;\n                    \n                    redout_317791 = redout_tmp_322406;\n                    redout_317792 = redout_tmp_322407;\n                    redout_317793 = redout_tmp_322408;\n                    redout_317794 = redout_tmp_322409;\n                    redout_317795 = redout_tmp_322410;\n                }\n                defunc_2_reduce_res_307749 = redout_317791;\n                defunc_2_reduce_res_307750 = redout_317792;\n                defunc_2_reduce_res_307751 = redout_317793;\n                defunc_2_reduce_res_307752 = redout_317794;\n                defunc_2_reduce_res_307753 = redout_317795;\n                \n                double a_307792 = 2.220446049250313e-16 +\n                       defunc_2_reduce_res_307749;\n                double b_307793 = 2.220446049250313e-16 +\n                       defunc_2_reduce_res_307750;\n                double c_307794",
            " = 2.220446049250313e-16 +\n                       defunc_2_reduce_res_307751;\n                double d_307795 = 2.220446049250313e-16 +\n                       defunc_2_reduce_res_307752;\n                double e_307796 = 2.220446049250313e-16 +\n                       defunc_2_reduce_res_307753;\n                double x_307797 = c_307794 * e_307796;\n                double y_307798 = d_307795 * d_307795;\n                double a12_307799 = x_307797 - y_307798;\n                double x_307800 = c_307794 * d_307795;\n                double y_307801 = b_307793 * e_307796;\n                double b12_307802 = x_307800 - y_307801;\n                double x_307803 = b_307793 * d_307795;\n                double y_307804 = c_307794 * c_307794;\n                double c12_307805 = x_307803 - y_307804;\n                double x_307806 = a_307792 * e_307796;\n                double b2_307807 = x_307806 - y_307804;\n                double x_307808 = b_307793 * c_307794;\n                double y_307809 = a_307792 * d_307795;\n                double c2_307810 = x_307808 - y_307809;\n                double x_307811 = a_307792 * a12_307799;\n                double y_307812 = b_307793 * b12_307802;\n                double x_307813 = x_307811 + y_307812;\n                double y_307814 = c_307794 * c12_307805;\n                double y_307815 = x_307813 + y_307814;\n                double det_307816 = 1.0 / y_307815;\n                double a12_307817 = a12_307799 * det_307816;\n                double b12_307818 = b12_307802 * det_307816;\n                double c12_307819 = c12_307805 * det_307816;\n                double b2_307820 = b2_307807 * det_307816;\n                double c2_307821 = c2_307810 * det_307816;\n                int64_t defunc_0_m_fun_res_307822;\n                \n                if (cond_307739) {\n                    defunc_0_m_fun_res_307822 = (int64_t) 0;\n                } else {\n                    int64_t y_307823 = sub64(s_n_m_292825, (int64_t) 1);\n                    bool cond_",
            "307824 = i_318451 == y_307823;\n                    int64_t defunc_0_m_fun_res_f_res_307825;\n                    \n                    if (cond_307824) {\n                        int64_t defunc_0_m_fun_res_f_res_t_res_307826 =\n                                sub64(pad_css_len_292821, (int64_t) 1);\n                        \n                        defunc_0_m_fun_res_f_res_307825 =\n                            defunc_0_m_fun_res_f_res_t_res_307826;\n                    } else {\n                        int64_t x_307827 = sub64(i_318451, (int64_t) 1);\n                        int64_t x_307828 = mul64(jump_s_292684, x_307827);\n                        int64_t min_arg_307829 = add64((int64_t) 1, x_307828);\n                        int64_t min_res_307830 = smin64(defunc_0_f_res_292820,\n                                                        min_arg_307829);\n                        \n                        defunc_0_m_fun_res_f_res_307825 = min_res_307830;\n                    }\n                    defunc_0_m_fun_res_307822 = defunc_0_m_fun_res_f_res_307825;\n                }\n                \n                double defunc_2_reduce_res_307831;\n                double defunc_2_reduce_res_307832;\n                double redout_317797;\n                double redout_317798;\n                \n                redout_317797 = 0.0;\n                redout_317798 = 0.0;\n                for (int64_t i_317799 = 0; i_317799 < q_s_292678; i_317799++) {\n                    bool cond_307840 = sle64(x_307731, i_317799);\n                    int64_t defunc_0_f_res_307841;\n                    \n                    if (cond_307840) {\n                        defunc_0_f_res_307841 = (int64_t) 0;\n                    } else {\n                        int64_t i_307842 = add64(x_307737, i_317799);\n                        int64_t defunc_0_add_arg_307843;\n                        \n                        defunc_0_add_arg_307843 = ((__global\n                                                    int64_t *) mem_319283)[i_307",
            "842 *\n                                                                           (n_p_292677 *\n                                                                            partition_sizze_292766) +\n                                                                           gtid_307725 *\n                                                                           n_p_292677 +\n                                                                           gtid_307726];\n                        \n                        int64_t defunc_1_add_res_307844 = add64((int64_t) 1,\n                                                                defunc_0_add_arg_307843);\n                        \n                        defunc_0_f_res_307841 = defunc_1_add_res_307844;\n                    }\n                    \n                    double defunc_0_f_res_307845;\n                    \n                    if (cond_307840) {\n                        defunc_0_f_res_307845 = 0.0;\n                    } else {\n                        int64_t i_307846 = add64(x_307737, i_317799);\n                        double defunc_0_add_arg_307847;\n                        \n                        defunc_0_add_arg_307847 = ((__global\n                                                    double *) mem_319287)[i_307846 *\n                                                                          (n_p_292677 *\n                                                                           partition_sizze_292766) +\n                                                                          gtid_307725 *\n                                                                          n_p_292677 +\n                                                                          gtid_307726];\n                        defunc_0_f_res_307845 = defunc_0_add_arg_307847;\n                    }\n                    \n                    int64_t binop_p_307848 = sub64(defunc_0_f_res_307841,\n                                                   defunc_0_m_fun_res_307",
            "822);\n                    double defunc_0_f_res_307849 =\n                           sitofp_i64_f64(binop_p_307848);\n                    double abs_res_307850 = fabs(defunc_0_f_res_307849);\n                    double tmp1_307851 = abs_res_307850 / x_307738;\n                    double x_307852 = tmp1_307851 * tmp1_307851;\n                    double y_307853 = tmp1_307851 * x_307852;\n                    double tmp2_307854 = 1.0 - y_307853;\n                    double x_307855 = tmp2_307854 * tmp2_307854;\n                    double tmp3_307856 = tmp2_307854 * x_307855;\n                    double tmp4_307857 = defunc_0_f_res_307845 * tmp3_307856;\n                    double defunc_1_f_res_307858 = defunc_0_f_res_307849 *\n                           tmp4_307857;\n                    double defunc_1_f_res_307859 = defunc_0_f_res_307849 *\n                           defunc_1_f_res_307858;\n                    double defunc_0_f_res_307860;\n                    \n                    if (cond_307840) {\n                        defunc_0_f_res_307860 = 0.0;\n                    } else {\n                        int64_t i_307861 = add64(x_307737, i_317799);\n                        double defunc_0_add_arg_307862;\n                        \n                        defunc_0_add_arg_307862 = ((__global\n                                                    double *) mem_319291)[i_307861 *\n                                                                          (n_p_292677 *\n                                                                           partition_sizze_292766) +\n                                                                          gtid_307725 *\n                                                                          n_p_292677 +\n                                                                          gtid_307726];\n                        defunc_0_f_res_307860 = defunc_0_add_arg_307862;\n                    }\n                    \n                    double x_307863 = a12_307817 * tmp",
            "4_307857;\n                    double y_307864 = b12_307818 * defunc_1_f_res_307858;\n                    double x_307865 = x_307863 + y_307864;\n                    double y_307866 = c12_307819 * defunc_1_f_res_307859;\n                    double x_307867 = x_307865 + y_307866;\n                    double defunc_9_fit_fun_res_307868 = defunc_0_f_res_307860 *\n                           x_307867;\n                    double x_307869 = b12_307818 * tmp4_307857;\n                    double y_307870 = b2_307820 * defunc_1_f_res_307858;\n                    double x_307871 = x_307869 + y_307870;\n                    double y_307872 = c2_307821 * defunc_1_f_res_307859;\n                    double x_307873 = x_307871 + y_307872;\n                    double defunc_9_slope_fun_res_307874 =\n                           defunc_0_f_res_307860 * x_307873;\n                    double defunc_1_op_res_307835 =\n                           defunc_9_fit_fun_res_307868 + redout_317797;\n                    double defunc_1_op_res_307838 =\n                           defunc_9_slope_fun_res_307874 + redout_317798;\n                    double redout_tmp_322411 = defunc_1_op_res_307835;\n                    double redout_tmp_322412 = defunc_1_op_res_307838;\n                    \n                    redout_317797 = redout_tmp_322411;\n                    redout_317798 = redout_tmp_322412;\n                }\n                defunc_2_reduce_res_307831 = redout_317797;\n                defunc_2_reduce_res_307832 = redout_317798;\n                ((__global double *) color_320630)[phys_tid_307727 + i_318451 *\n                                                   num_threads_320728] =\n                    defunc_2_reduce_res_307831;\n                ((__global double *) color_320629)[phys_tid_307727 + i_318451 *\n                                                   num_threads_320728] =\n                    defunc_2_reduce_res_307832;\n            }\n            for (int64_t i_322413 = 0; i_322413 < s_n_m_292825; i_322413++) {\n   ",
            "             double tmp_322414;\n                \n                tmp_322414 = ((__global\n                               double *) color_320630)[phys_tid_307727 +\n                                                       i_322413 *\n                                                       num_threads_320728];\n                ((__global double *) mem_319326)[gtid_307725 * n_p_292677 +\n                                                 gtid_307726 + i_322413 *\n                                                 (n_p_292677 *\n                                                  partition_sizze_292766)] =\n                    tmp_322414;\n            }\n            for (int64_t i_322415 = 0; i_322415 < s_n_m_292825; i_322415++) {\n                double tmp_322416;\n                \n                tmp_322416 = ((__global\n                               double *) color_320629)[phys_tid_307727 +\n                                                       i_322415 *\n                                                       num_threads_320728];\n                ((__global double *) mem_319330)[gtid_307725 * n_p_292677 +\n                                                 gtid_307726 + i_322415 *\n                                                 (n_p_292677 *\n                                                  partition_sizze_292766)] =\n                    tmp_322416;\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_307704\n}\n__kernel void mainzisegmap_308081(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825, __global\n                                  unsigned char *mem_319395, __global\n                          ",
            "        unsigned char *mem_319399)\n{\n    #define segmap_group_sizze_308074 (mainzisegmap_group_sizze_307191)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322535;\n    int32_t local_tid_322536;\n    int64_t group_sizze_322539;\n    int32_t wave_sizze_322538;\n    int32_t group_tid_322537;\n    \n    global_tid_322535 = get_global_id(0);\n    local_tid_322536 = get_local_id(0);\n    group_sizze_322539 = get_local_size(0);\n    wave_sizze_322538 = LOCKSTEP_WIDTH;\n    group_tid_322537 = get_group_id(0);\n    \n    int32_t phys_tid_308081 = global_tid_322535;\n    int64_t global_tid_322540 = sext_i32_i64(group_tid_322537) *\n            segmap_group_sizze_308074 + sext_i32_i64(local_tid_322536);\n    int64_t slice_322541 = s_n_m_292825;\n    int64_t slice_322542 = n_p_292677 * slice_322541;\n    int64_t slice_322543 = partition_sizze_292766 * slice_322542;\n    int64_t gtid_308078 = squot64(global_tid_322540, slice_322542);\n    int64_t remnant_322544 = global_tid_322540 - gtid_308078 * slice_322542;\n    int64_t gtid_308079 = squot64(remnant_322544, slice_322541);\n    int64_t remnant_322545 = remnant_322544 - gtid_308079 * slice_322541;\n    int64_t gtid_308080 = remnant_322545;\n    int64_t remnant_322546 = remnant_322545 - gtid_308080;\n    \n    if ((slt64(gtid_308078, partition_sizze_292766) && slt64(gtid_308079,\n                                                             n_p_292677)) &&\n        slt64(gtid_308080, s_n_m_292825)) {\n        bool cond_308083 = gtid_308080 == (int64_t) 0;\n        int64_t defunc_0_m_fun_res_308084;\n        \n        if (cond_308083) {\n            defunc_0_m_fun_res_308084 = (int64_t) 0;\n        } else {\n            int64_t y_308085 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_308086 = gtid_308080 == y_308085;\n            int64_t defunc_0_m_fun_res_f_res_308087;\n            \n            if (cond_308086) {\n                ",
            "int64_t defunc_0_m_fun_res_f_res_t_res_308088 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_308087 =\n                    defunc_0_m_fun_res_f_res_t_res_308088;\n            } else {\n                int64_t x_308089 = sub64(gtid_308080, (int64_t) 1);\n                int64_t x_308090 = mul64(jump_s_292684, x_308089);\n                int64_t min_arg_308091 = add64((int64_t) 1, x_308090);\n                int64_t min_res_308092 = smin64(defunc_0_f_res_292820,\n                                                min_arg_308091);\n                \n                defunc_0_m_fun_res_f_res_308087 = min_res_308092;\n            }\n            defunc_0_m_fun_res_308084 = defunc_0_m_fun_res_f_res_308087;\n        }\n        ((__global int64_t *) mem_319395)[gtid_308078 * (s_n_m_292825 *\n                                                         n_p_292677) +\n                                          gtid_308079 * s_n_m_292825 +\n                                          gtid_308080] =\n            defunc_0_m_fun_res_308084;\n        ((__global bool *) mem_319399)[gtid_308078 * (s_n_m_292825 *\n                                                      n_p_292677) +\n                                       gtid_308079 * s_n_m_292825 +\n                                       gtid_308080] = cond_308083;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_308074\n}\n__kernel void mainzisegmap_308177(__global int *global_failure,\n                                  int64_t n_p_292677, int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t pad_css_len_292821,\n                                  int64_t s_n_m_292825, __global\n                                  unsigned char *mem_319405, __global\n                                  unsigned char *mem_319410, __global\n                         ",
            "         unsigned char *mem_319415, __global\n                                  unsigned char *mem_319420, __global\n                                  unsigned char *mem_319425, __global\n                                  unsigned char *mem_319431, __global\n                                  unsigned char *mem_319436, __global\n                                  unsigned char *mem_319441, __global\n                                  unsigned char *mem_319446, __global\n                                  unsigned char *mem_319451, __global\n                                  unsigned char *mem_319456)\n{\n    #define segmap_group_sizze_308166 (mainzisegmap_group_sizze_307056)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322679;\n    int32_t local_tid_322680;\n    int64_t group_sizze_322683;\n    int32_t wave_sizze_322682;\n    int32_t group_tid_322681;\n    \n    global_tid_322679 = get_global_id(0);\n    local_tid_322680 = get_local_id(0);\n    group_sizze_322683 = get_local_size(0);\n    wave_sizze_322682 = LOCKSTEP_WIDTH;\n    group_tid_322681 = get_group_id(0);\n    \n    int32_t phys_tid_308177 = global_tid_322679;\n    int64_t global_tid_322684 = sext_i32_i64(group_tid_322681) *\n            segmap_group_sizze_308166 + sext_i32_i64(local_tid_322680);\n    int64_t slice_322685 = s_n_m_292825;\n    int64_t slice_322686 = n_p_292677 * slice_322685;\n    int64_t slice_322687 = partition_sizze_292766 * slice_322686;\n    int64_t gtid_308174 = squot64(global_tid_322684, slice_322686);\n    int64_t remnant_322688 = global_tid_322684 - gtid_308174 * slice_322686;\n    int64_t gtid_308175 = squot64(remnant_322688, slice_322685);\n    int64_t remnant_322689 = remnant_322688 - gtid_308175 * slice_322685;\n    int64_t gtid_308176 = remnant_322689;\n    int64_t remnant_322690 = remnant_322689 - gtid_308176;\n    \n    if ((slt64(gtid_308174, partition_sizze_292766) && slt64(gtid_308175",
            ",\n                                                             n_p_292677)) &&\n        slt64(gtid_308176, s_n_m_292825)) {\n        bool index_primexp_317942 = gtid_308176 == (int64_t) 0;\n        double defunc_2_reduce_res_308180;\n        \n        defunc_2_reduce_res_308180 = ((__global\n                                       double *) mem_319405)[gtid_308174 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308175 *\n                                                             s_n_m_292825 +\n                                                             gtid_308176];\n        \n        double defunc_2_reduce_res_308181;\n        \n        defunc_2_reduce_res_308181 = ((__global\n                                       double *) mem_319410)[gtid_308174 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308175 *\n                                                             s_n_m_292825 +\n                                                             gtid_308176];\n        \n        double defunc_2_reduce_res_308182;\n        \n        defunc_2_reduce_res_308182 = ((__global\n                                       double *) mem_319415)[gtid_308174 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308175 *\n                                                             s_n_m_292825 +\n                                                             gtid_308176];\n        \n        double defunc_2_reduce_res_308183;\n        \n        defunc_2_reduce_res_308183 = ((__global\n                        ",
            "               double *) mem_319420)[gtid_308174 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308175 *\n                                                             s_n_m_292825 +\n                                                             gtid_308176];\n        \n        double defunc_2_reduce_res_308184;\n        \n        defunc_2_reduce_res_308184 = ((__global\n                                       double *) mem_319425)[gtid_308174 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308175 *\n                                                             s_n_m_292825 +\n                                                             gtid_308176];\n        \n        double a_308185 = 2.220446049250313e-16 + defunc_2_reduce_res_308180;\n        double b_308186 = 2.220446049250313e-16 + defunc_2_reduce_res_308181;\n        double c_308187 = 2.220446049250313e-16 + defunc_2_reduce_res_308182;\n        double d_308188 = 2.220446049250313e-16 + defunc_2_reduce_res_308183;\n        double e_308189 = 2.220446049250313e-16 + defunc_2_reduce_res_308184;\n        double x_308190 = c_308187 * e_308189;\n        double y_308191 = d_308188 * d_308188;\n        double a12_308192 = x_308190 - y_308191;\n        double x_308193 = c_308187 * d_308188;\n        double y_308194 = b_308186 * e_308189;\n        double b12_308195 = x_308193 - y_308194;\n        double x_308196 = b_308186 * d_308188;\n        double y_308197 = c_308187 * c_308187;\n        double c12_308198 = x_308196 - y_308197;\n        double x_308199 = a_308185 * e_308189;\n        double b2_308200 = x_308199 - y_308197;\n        double x_308201 = b_308186 * c_308187;\n        double y_308202 = a_308185 * ",
            "d_308188;\n        double c2_308203 = x_308201 - y_308202;\n        double x_308204 = a_308185 * a12_308192;\n        double y_308205 = b_308186 * b12_308195;\n        double x_308206 = x_308204 + y_308205;\n        double y_308207 = c_308187 * c12_308198;\n        double y_308208 = x_308206 + y_308207;\n        double det_308209 = 1.0 / y_308208;\n        double a12_308210 = a12_308192 * det_308209;\n        double b12_308211 = b12_308195 * det_308209;\n        double c12_308212 = c12_308198 * det_308209;\n        double b2_308213 = b2_308200 * det_308209;\n        double c2_308214 = c2_308203 * det_308209;\n        int64_t defunc_0_m_fun_res_308215;\n        \n        if (index_primexp_317942) {\n            defunc_0_m_fun_res_308215 = (int64_t) 0;\n        } else {\n            int64_t y_308216 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_308217 = gtid_308176 == y_308216;\n            int64_t defunc_0_m_fun_res_f_res_308218;\n            \n            if (cond_308217) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_308219 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_308218 =\n                    defunc_0_m_fun_res_f_res_t_res_308219;\n            } else {\n                int64_t x_308220 = sub64(gtid_308176, (int64_t) 1);\n                int64_t x_308221 = mul64(jump_s_292684, x_308220);\n                int64_t min_arg_308222 = add64((int64_t) 1, x_308221);\n                int64_t min_res_308223 = smin64(defunc_0_f_res_292820,\n                                                min_arg_308222);\n                \n                defunc_0_m_fun_res_f_res_308218 = min_res_308223;\n            }\n            defunc_0_m_fun_res_308215 = defunc_0_m_fun_res_f_res_308218;\n        }\n        ((__global double *) mem_319431)[gtid_308174 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_308175 * s_n_m_292825 +\n            ",
            "                             gtid_308176] = a12_308210;\n        ((__global double *) mem_319436)[gtid_308174 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_308175 * s_n_m_292825 +\n                                         gtid_308176] = b12_308211;\n        ((__global double *) mem_319441)[gtid_308174 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_308175 * s_n_m_292825 +\n                                         gtid_308176] = c12_308212;\n        ((__global double *) mem_319446)[gtid_308174 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_308175 * s_n_m_292825 +\n                                         gtid_308176] = b2_308213;\n        ((__global double *) mem_319451)[gtid_308174 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_308175 * s_n_m_292825 +\n                                         gtid_308176] = c2_308214;\n        ((__global int64_t *) mem_319456)[gtid_308174 * (s_n_m_292825 *\n                                                         n_p_292677) +\n                                          gtid_308175 * s_n_m_292825 +\n                                          gtid_308176] =\n            defunc_0_m_fun_res_308215;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_308166\n}\n__kernel void mainzisegmap_308641(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_p_292677, int64_t jump_s_292684,\n                                  int64_t partition_sizze_292766,\n                                  int64_t defunc_0_f_res_292820,\n                                  int64_t ",
            "pad_css_len_292821,\n                                  int64_t s_n_m_292825, __global\n                                  unsigned char *ext_mem_319490, __global\n                                  unsigned char *ext_mem_319491, __global\n                                  unsigned char *mem_319497)\n{\n    #define segmap_group_sizze_308635 (mainzisegmap_group_sizze_308343)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322783;\n    int32_t local_tid_322784;\n    int64_t group_sizze_322787;\n    int32_t wave_sizze_322786;\n    int32_t group_tid_322785;\n    \n    global_tid_322783 = get_global_id(0);\n    local_tid_322784 = get_local_id(0);\n    group_sizze_322787 = get_local_size(0);\n    wave_sizze_322786 = LOCKSTEP_WIDTH;\n    group_tid_322785 = get_group_id(0);\n    \n    int32_t phys_tid_308641 = global_tid_322783;\n    int64_t global_tid_322788 = sext_i32_i64(group_tid_322785) *\n            segmap_group_sizze_308635 + sext_i32_i64(local_tid_322784);\n    int64_t slice_322789 = pad_css_len_292821;\n    int64_t slice_322790 = n_p_292677 * slice_322789;\n    int64_t slice_322791 = partition_sizze_292766 * slice_322790;\n    int64_t gtid_308638 = squot64(global_tid_322788, slice_322790);\n    int64_t remnant_322792 = global_tid_322788 - gtid_308638 * slice_322790;\n    int64_t gtid_308639 = squot64(remnant_322792, slice_322789);\n    int64_t remnant_322793 = remnant_322792 - gtid_308639 * slice_322789;\n    int64_t gtid_308640 = remnant_322793;\n    int64_t remnant_322794 = remnant_322793 - gtid_308640;\n    \n    if ((slt64(gtid_308638, partition_sizze_292766) && slt64(gtid_308639,\n                                                             n_p_292677)) &&\n        slt64(gtid_308640, pad_css_len_292821)) {\n        bool cond_308645 = gtid_308640 == (int64_t) 0;\n        double defunc_0_f_res_308646;\n        \n        if (cond_308645) {\n            bool y_308647 = slt64((int",
            "64_t) 0, s_n_m_292825);\n            bool index_certs_308648;\n            \n            if (!y_308647) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 38) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) (int64_t) 0;\n                        global_failure_args[1] = (int64_t) s_n_m_292825;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double head_res_308649;\n            \n            head_res_308649 = ((__global double *) ext_mem_319491)[gtid_308638 *\n                                                                   (s_n_m_292825 *\n                                                                    n_p_292677) +\n                                                                   gtid_308639 *\n                                                                   s_n_m_292825];\n            defunc_0_f_res_308646 = head_res_308649;\n        } else {\n            int64_t y_308650 = sub64(pad_css_len_292821, (int64_t) 1);\n            bool cond_308651 = gtid_308640 == y_308650;\n            double defunc_0_f_res_f_res_308652;\n            \n            if (cond_308651) {\n                int64_t i_308653 = sub64(s_n_m_292825, (int64_t) 1);\n                bool x_308654 = sle64((int64_t) 0, i_308653);\n                bool y_308655 = slt64(i_308653, s_n_m_292825);\n                bool bounds_check_308656 = x_308654 && y_308655;\n                bool index_certs_308657;\n                \n                if (!bounds_check_308656) {\n                    {\n                        if (atomic_cmpxchg_i32_global(global_failure, -1, 39) ==\n                            -1) {\n                            global_failure_args[0] = (int64_t) i_308653;\n                            global_failure_args[1] = (int64_t) s_n_m_292825;\n                            ;\n                        }\n                        return;\n                    }\n ",
            "               }\n                \n                double last_res_308658;\n                \n                last_res_308658 = ((__global\n                                    double *) ext_mem_319491)[gtid_308638 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                                              gtid_308639 *\n                                                              s_n_m_292825 +\n                                                              i_308653];\n                defunc_0_f_res_f_res_308652 = last_res_308658;\n            } else {\n                int64_t x_308659 = sub64(gtid_308640, (int64_t) 1);\n                bool zzero_308660 = jump_s_292684 == (int64_t) 0;\n                bool nonzzero_308661 = !zzero_308660;\n                bool nonzzero_cert_308662;\n                \n                if (!nonzzero_308661) {\n                    {\n                        if (atomic_cmpxchg_i32_global(global_failure, -1, 40) ==\n                            -1) {\n                            ;\n                        }\n                        return;\n                    }\n                }\n                \n                int64_t x_308663 = sdiv64(x_308659, jump_s_292684);\n                int64_t m_v_308664 = add64((int64_t) 1, x_308663);\n                int64_t j_308665;\n                \n                if (cond_308645) {\n                    j_308665 = (int64_t) 0;\n                } else {\n                    int64_t y_308666 = sub64(s_n_m_292825, (int64_t) 1);\n                    bool cond_308667 = m_v_308664 == y_308666;\n                    int64_t j_f_res_308668;\n                    \n                    if (cond_308667) {\n                        j_f_res_308668 = x_308663;\n                    } else {\n                        j_f_res_308668 = m_v_308664;\n                    }\n                    j_308665 = j_f_res_308668;\n                }\n   ",
            "             \n                bool cond_308669 = j_308665 == (int64_t) 0;\n                int64_t defunc_0_m_fun_res_308670;\n                \n                if (cond_308669) {\n                    defunc_0_m_fun_res_308670 = (int64_t) 0;\n                } else {\n                    int64_t y_308671 = sub64(s_n_m_292825, (int64_t) 1);\n                    bool cond_308672 = j_308665 == y_308671;\n                    int64_t defunc_0_m_fun_res_f_res_308673;\n                    \n                    if (cond_308672) {\n                        defunc_0_m_fun_res_f_res_308673 = y_308650;\n                    } else {\n                        int64_t x_308674 = sub64(j_308665, (int64_t) 1);\n                        int64_t x_308675 = mul64(jump_s_292684, x_308674);\n                        int64_t min_arg_308676 = add64((int64_t) 1, x_308675);\n                        int64_t min_res_308677 = smin64(defunc_0_f_res_292820,\n                                                        min_arg_308676);\n                        \n                        defunc_0_m_fun_res_f_res_308673 = min_res_308677;\n                    }\n                    defunc_0_m_fun_res_308670 = defunc_0_m_fun_res_f_res_308673;\n                }\n                \n                int64_t defunc_0_m_fun_arg_308678 = add64((int64_t) 1,\n                                                          j_308665);\n                bool cond_308679 = defunc_0_m_fun_arg_308678 == (int64_t) 0;\n                int64_t defunc_0_m_fun_res_308680;\n                \n                if (cond_308679) {\n                    defunc_0_m_fun_res_308680 = (int64_t) 0;\n                } else {\n                    int64_t y_308681 = sub64(s_n_m_292825, (int64_t) 1);\n                    bool cond_308682 = defunc_0_m_fun_arg_308678 == y_308681;\n                    int64_t defunc_0_m_fun_res_f_res_308683;\n                    \n                    if (cond_308682) {\n                        defunc_0_m_fun_res_f_res_308683 = y_308650;\n                    } e",
            "lse {\n                        int64_t x_308684 = mul64(jump_s_292684, j_308665);\n                        int64_t min_arg_308685 = add64((int64_t) 1, x_308684);\n                        int64_t min_res_308686 = smin64(defunc_0_f_res_292820,\n                                                        min_arg_308685);\n                        \n                        defunc_0_m_fun_res_f_res_308683 = min_res_308686;\n                    }\n                    defunc_0_m_fun_res_308680 = defunc_0_m_fun_res_f_res_308683;\n                }\n                \n                int64_t i64_arg_308687 = sub64(defunc_0_m_fun_res_308680,\n                                               defunc_0_m_fun_res_308670);\n                double i64_res_308688 = sitofp_i64_f64(i64_arg_308687);\n                int64_t i64_arg_308689 = sub64(gtid_308640,\n                                               defunc_0_m_fun_res_308670);\n                double i64_res_308690 = sitofp_i64_f64(i64_arg_308689);\n                double u_308691 = i64_res_308690 / i64_res_308688;\n                double u2_308692 = u_308691 * u_308691;\n                double u3_308693 = u_308691 * u2_308692;\n                double x_308694 = 2.0 * u3_308693;\n                double y_308695 = 3.0 * u2_308692;\n                double x_308696 = x_308694 - y_308695;\n                double x_308697 = 1.0 + x_308696;\n                bool x_308698 = sle64((int64_t) 0, j_308665);\n                bool y_308699 = slt64(j_308665, s_n_m_292825);\n                bool bounds_check_308700 = x_308698 && y_308699;\n                bool index_certs_308701;\n                \n                if (!bounds_check_308700) {\n                    {\n                        if (atomic_cmpxchg_i32_global(global_failure, -1, 41) ==\n                            -1) {\n                            global_failure_args[0] = (int64_t) j_308665;\n                            global_failure_args[1] = (int64_t) s_n_m_292825;\n                            ;\n                        }\n ",
            "                       return;\n                    }\n                }\n                \n                double y_308702;\n                \n                y_308702 = ((__global double *) ext_mem_319491)[gtid_308638 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_308639 *\n                                                                s_n_m_292825 +\n                                                                j_308665];\n                \n                double x_308703 = x_308697 * y_308702;\n                double x_308704 = y_308695 - x_308694;\n                bool x_308705 = sle64((int64_t) 0, defunc_0_m_fun_arg_308678);\n                bool y_308706 = slt64(defunc_0_m_fun_arg_308678, s_n_m_292825);\n                bool bounds_check_308707 = x_308705 && y_308706;\n                bool index_certs_308708;\n                \n                if (!bounds_check_308707) {\n                    {\n                        if (atomic_cmpxchg_i32_global(global_failure, -1, 42) ==\n                            -1) {\n                            global_failure_args[0] =\n                                (int64_t) defunc_0_m_fun_arg_308678;\n                            global_failure_args[1] = (int64_t) s_n_m_292825;\n                            ;\n                        }\n                        return;\n                    }\n                }\n                \n                double y_308709;\n                \n                y_308709 = ((__global double *) ext_mem_319491)[gtid_308638 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_308639 *\n                                                                s_n_m_292825 +\n               ",
            "                                                 defunc_0_m_fun_arg_308678];\n                \n                double y_308710 = x_308704 * y_308709;\n                double x_308711 = x_308703 + y_308710;\n                double y_308712 = 2.0 * u2_308692;\n                double x_308713 = u3_308693 - y_308712;\n                double x_308714 = u_308691 + x_308713;\n                double y_308715;\n                \n                y_308715 = ((__global double *) ext_mem_319490)[gtid_308638 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_308639 *\n                                                                s_n_m_292825 +\n                                                                j_308665];\n                \n                double x_308716 = x_308714 * y_308715;\n                double y_308717 = i64_res_308688 * x_308716;\n                double x_308718 = x_308711 + y_308717;\n                double x_308719 = u3_308693 - u2_308692;\n                double y_308720;\n                \n                y_308720 = ((__global double *) ext_mem_319490)[gtid_308638 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_308639 *\n                                                                s_n_m_292825 +\n                                                                defunc_0_m_fun_arg_308678];\n                \n                double x_308721 = x_308719 * y_308720;\n                double y_308722 = i64_res_308688 * x_308721;\n                double defunc_4_interpolate_proc_res_308723 = x_308718 +\n                       y_308722;\n                \n                defunc_0_f_res_f_res_308652 =\n                    defunc_4_int",
            "erpolate_proc_res_308723;\n            }\n            defunc_0_f_res_308646 = defunc_0_f_res_f_res_308652;\n        }\n        ((__global double *) mem_319497)[gtid_308638 * (pad_css_len_292821 *\n                                                        n_p_292677) +\n                                         gtid_308639 * pad_css_len_292821 +\n                                         gtid_308640] = defunc_0_f_res_308646;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_308635\n}\n__kernel void mainzisegmap_308790(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_p_292677,\n                                  int64_t partition_sizze_292766,\n                                  int64_t C_len_292823,\n                                  int64_t css_results_l_293288, __global\n                                  unsigned char *ext_mem_319498, __global\n                                  unsigned char *mem_319504)\n{\n    #define segmap_group_sizze_308785 (mainzisegmap_group_sizze_308739)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322795;\n    int32_t local_tid_322796;\n    int64_t group_sizze_322799;\n    int32_t wave_sizze_322798;\n    int32_t group_tid_322797;\n    \n    global_tid_322795 = get_global_id(0);\n    local_tid_322796 = get_local_id(0);\n    group_sizze_322799 = get_local_size(0);\n    wave_sizze_322798 = LOCKSTEP_WIDTH;\n    group_tid_322797 = get_group_id(0);\n    \n    int32_t phys_tid_308790 = global_tid_322795;\n    int64_t global_tid_322800 = sext_i32_i64(group_tid_322797) *\n            segmap_group_sizze_308785 + sext_i32_i64(local_tid_322796);\n    int64_t slice_322801 = C_len_292823;\n    int64_t slice_322802 = partition_sizze_292766 * slice_322801;\n    int64_t gtid_308788 = squot64(global_",
            "tid_322800, slice_322801);\n    int64_t remnant_322803 = global_tid_322800 - gtid_308788 * slice_322801;\n    int64_t gtid_308789 = remnant_322803;\n    int64_t remnant_322804 = remnant_322803 - gtid_308789;\n    \n    if (slt64(gtid_308788, partition_sizze_292766) && slt64(gtid_308789,\n                                                            C_len_292823)) {\n        int64_t i_308793 = smod64(gtid_308789, n_p_292677);\n        bool x_308794 = sle64((int64_t) 0, i_308793);\n        bool y_308795 = slt64(i_308793, n_p_292677);\n        bool bounds_check_308796 = x_308794 && y_308795;\n        int64_t i_308797 = sdiv64(gtid_308789, n_p_292677);\n        bool x_308798 = sle64((int64_t) 0, i_308797);\n        bool y_308799 = slt64(i_308797, css_results_l_293288);\n        bool bounds_check_308800 = x_308798 && y_308799;\n        bool index_ok_308801 = bounds_check_308796 && bounds_check_308800;\n        bool index_certs_308802;\n        \n        if (!index_ok_308801) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 43) == -1) {\n                    global_failure_args[0] = (int64_t) i_308793;\n                    global_failure_args[1] = (int64_t) i_308797;\n                    global_failure_args[2] = (int64_t) n_p_292677;\n                    global_failure_args[3] = (int64_t) css_results_l_293288;\n                    ;\n                }\n                return;\n            }\n        }\n        \n        double defunc_0_f_res_308803;\n        \n        defunc_0_f_res_308803 = ((__global\n                                  double *) ext_mem_319498)[gtid_308788 *\n                                                            (css_results_l_293288 *\n                                                             n_p_292677) +\n                                                            i_308793 *\n                                                            css_results_l_293288 +\n                                                            i_308797];\n        ((__global do",
            "uble *) mem_319504)[gtid_308788 * C_len_292823 +\n                                         gtid_308789] = defunc_0_f_res_308803;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_308785\n}\n__kernel void mainzisegmap_308826(__global int *global_failure,\n                                  int64_t n_p_292677,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_319507, __global\n                                  unsigned char *mem_319511)\n{\n    #define segmap_group_sizze_308822 (mainzisegmap_group_sizze_308810)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322805;\n    int32_t local_tid_322806;\n    int64_t group_sizze_322809;\n    int32_t wave_sizze_322808;\n    int32_t group_tid_322807;\n    \n    global_tid_322805 = get_global_id(0);\n    local_tid_322806 = get_local_id(0);\n    group_sizze_322809 = get_local_size(0);\n    wave_sizze_322808 = LOCKSTEP_WIDTH;\n    group_tid_322807 = get_group_id(0);\n    \n    int32_t phys_tid_308826 = global_tid_322805;\n    int64_t global_tid_322810 = sext_i32_i64(group_tid_322807) *\n            segmap_group_sizze_308822 + sext_i32_i64(local_tid_322806);\n    int64_t slice_322811 = partition_sizze_292766;\n    int64_t gtid_308825 = global_tid_322810;\n    int64_t remnant_322812 = global_tid_322810 - gtid_308825;\n    \n    if (slt64(gtid_308825, partition_sizze_292766)) {\n        double defunc_2_reduce_res_308828;\n        double redout_318454 = 0.0;\n        \n        for (int64_t i_318455 = 0; i_318455 < n_p_292677; i_318455++) {\n            double x_308832;\n            \n            x_308832 = ((__global double *) mem_319507)[i_318455 *\n                                                        partition_sizze_292766 +\n                                                        gtid_308825];\n            \n            double defunc_1_op_res_308831 = ",
            "x_308832 + redout_318454;\n            double redout_tmp_322813 = defunc_1_op_res_308831;\n            \n            redout_318454 = redout_tmp_322813;\n        }\n        defunc_2_reduce_res_308828 = redout_318454;\n        ((__global double *) mem_319511)[gtid_308825] =\n            defunc_2_reduce_res_308828;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_308822\n}\n__kernel void mainzisegmap_308957(__global int *global_failure,\n                                  int64_t n_p_292677,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_319524, __global\n                                  unsigned char *mem_319528)\n{\n    #define segmap_group_sizze_308953 (mainzisegmap_group_sizze_308941)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322986;\n    int32_t local_tid_322987;\n    int64_t group_sizze_322990;\n    int32_t wave_sizze_322989;\n    int32_t group_tid_322988;\n    \n    global_tid_322986 = get_global_id(0);\n    local_tid_322987 = get_local_id(0);\n    group_sizze_322990 = get_local_size(0);\n    wave_sizze_322989 = LOCKSTEP_WIDTH;\n    group_tid_322988 = get_group_id(0);\n    \n    int32_t phys_tid_308957 = global_tid_322986;\n    int64_t global_tid_322991 = sext_i32_i64(group_tid_322988) *\n            segmap_group_sizze_308953 + sext_i32_i64(local_tid_322987);\n    int64_t slice_322992 = partition_sizze_292766;\n    int64_t gtid_308956 = global_tid_322991;\n    int64_t remnant_322993 = global_tid_322991 - gtid_308956;\n    \n    if (slt64(gtid_308956, partition_sizze_292766)) {\n        double defunc_2_reduce_res_308959;\n        double redout_318456 = 0.0;\n        \n        for (int64_t i_318457 = 0; i_318457 < n_p_292677; i_318457++) {\n            double x_308963;\n            \n            x_308963 = ((__global double *) mem_319524)[i_318457 *\n                             ",
            "                           partition_sizze_292766 +\n                                                        gtid_308956];\n            \n            double defunc_1_op_res_308962 = x_308963 + redout_318456;\n            double redout_tmp_322994 = defunc_1_op_res_308962;\n            \n            redout_318456 = redout_tmp_322994;\n        }\n        defunc_2_reduce_res_308959 = redout_318456;\n        ((__global double *) mem_319528)[gtid_308956] =\n            defunc_2_reduce_res_308959;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_308953\n}\n__kernel void mainzisegmap_309088(__global int *global_failure,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_319541, __global\n                                  unsigned char *mem_319545)\n{\n    #define segmap_group_sizze_309084 (mainzisegmap_group_sizze_309072)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323167;\n    int32_t local_tid_323168;\n    int64_t group_sizze_323171;\n    int32_t wave_sizze_323170;\n    int32_t group_tid_323169;\n    \n    global_tid_323167 = get_global_id(0);\n    local_tid_323168 = get_local_id(0);\n    group_sizze_323171 = get_local_size(0);\n    wave_sizze_323170 = LOCKSTEP_WIDTH;\n    group_tid_323169 = get_group_id(0);\n    \n    int32_t phys_tid_309088 = global_tid_323167;\n    int64_t global_tid_323172 = sext_i32_i64(group_tid_323169) *\n            segmap_group_sizze_309084 + sext_i32_i64(local_tid_323168);\n    int64_t slice_323173 = partition_sizze_292766;\n    int64_t gtid_309087 = global_tid_323172;\n    int64_t remnant_323174 = global_tid_323172 - gtid_309087;\n    \n    if (slt64(gtid_309087, partition_sizze_292766)) {\n        double defunc_2_reduce_res_309090;\n        double redout_318458 = 0.0;\n        \n        for (int32_t i_318483 = 0; i_318483 < 3; i_318483++) {\n            int64_t i_",
            "318459 = sext_i32_i64(i_318483);\n            double x_309094;\n            \n            x_309094 = ((__global double *) mem_319541)[i_318459 *\n                                                        partition_sizze_292766 +\n                                                        gtid_309087];\n            \n            double defunc_1_op_res_309093 = x_309094 + redout_318458;\n            double redout_tmp_323175 = defunc_1_op_res_309093;\n            \n            redout_318458 = redout_tmp_323175;\n        }\n        defunc_2_reduce_res_309090 = redout_318458;\n        ((__global double *) mem_319545)[gtid_309087] =\n            defunc_2_reduce_res_309090;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_309084\n}\n__kernel void mainzisegmap_309288(__global int *global_failure,\n                                  int64_t n_292675, int64_t q_l_292680,\n                                  int64_t jump_t_292685,\n                                  int64_t partition_sizze_292766,\n                                  int64_t l_n_m_292832, int64_t i_292846,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n                                  int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318756, __global\n                                  unsigned char *ext_mem_318757, __global\n                                  unsigned char *mem_param_318838, __global\n                                  unsigned char *mem_319555, __global\n                                  unsigned char *mem_319564)\n{\n    #define segmap_group_sizze_309283 (mainzisegmap_group_sizze_309203)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323348;\n    int32_t local_tid_323349;\n    int64_t group_sizze_323352;\n    int32_t wave_sizze_323351;\n    int32_t group_tid_323350;\n  ",
            "  \n    global_tid_323348 = get_global_id(0);\n    local_tid_323349 = get_local_id(0);\n    group_sizze_323352 = get_local_size(0);\n    wave_sizze_323351 = LOCKSTEP_WIDTH;\n    group_tid_323350 = get_group_id(0);\n    \n    int32_t phys_tid_309288 = global_tid_323348;\n    int64_t global_tid_323353 = sext_i32_i64(group_tid_323350) *\n            segmap_group_sizze_309283 + sext_i32_i64(local_tid_323349);\n    int64_t slice_323354 = l_n_m_292832;\n    int64_t slice_323355 = partition_sizze_292766 * slice_323354;\n    int64_t gtid_309286 = squot64(global_tid_323353, slice_323354);\n    int64_t remnant_323356 = global_tid_323353 - gtid_309286 * slice_323354;\n    int64_t gtid_309287 = remnant_323356;\n    int64_t remnant_323357 = remnant_323356 - gtid_309287;\n    \n    if (slt64(gtid_309286, partition_sizze_292766) && slt64(gtid_309287,\n                                                            l_n_m_292832)) {\n        int64_t x_309292;\n        \n        x_309292 = ((__global int64_t *) ext_mem_318757)[gtid_309286 *\n                                                         l_n_m_292832 +\n                                                         gtid_309287];\n        \n        double x_309293;\n        \n        x_309293 = ((__global double *) ext_mem_318756)[gtid_309286 *\n                                                        l_n_m_292832 +\n                                                        gtid_309287];\n        \n        int64_t min_arg_309294 = mul64(jump_t_292685, gtid_309287);\n        int64_t min_res_309295 = smin64(i_292846, min_arg_309294);\n        int64_t defunc_0_g_res_309296 = add64((int64_t) 1, min_res_309295);\n        double defunc_2_reduce_res_309297;\n        double redout_317600 = 0.0;\n        \n        for (int64_t i_317601 = 0; i_317601 < q_l_292680; i_317601++) {\n            bool cond_309302 = sle64(n_292675, i_317601);\n            int64_t defunc_0_f_res_309303;\n            \n            if (cond_309302) {\n                defunc_0_f_res_309303 = (int64_t) 0;\n           ",
            " } else {\n                int64_t i_309304 = add64(x_309292, i_317601);\n                int64_t defunc_1_add_res_309305 = add64((int64_t) 1, i_309304);\n                \n                defunc_0_f_res_309303 = defunc_1_add_res_309305;\n            }\n            \n            double defunc_0_f_res_309306;\n            \n            if (cond_309302) {\n                defunc_0_f_res_309306 = 0.0;\n            } else {\n                int64_t i_309307 = add64(x_309292, i_317601);\n                double defunc_0_add_arg_309308;\n                \n                defunc_0_add_arg_309308 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_309286 *\n                                                                         ctx_param_ext_318834 +\n                                                                         i_309307 *\n                                                                         ctx_param_ext_318836)];\n                defunc_0_f_res_309306 = defunc_0_add_arg_309308;\n            }\n            \n            int64_t binop_p_309309 = sub64(defunc_0_f_res_309303,\n                                           defunc_0_g_res_309296);\n            double defunc_0_f_res_309310 = sitofp_i64_f64(binop_p_309309);\n            double abs_res_309311 = fabs(defunc_0_f_res_309310);\n            double tmp1_309312 = abs_res_309311 / x_309293;\n            double x_309313 = tmp1_309312 * tmp1_309312;\n            double y_309314 = tmp1_309312 * x_309313;\n            double tmp2_309315 = 1.0 - y_309314;\n            double x_309316 = tmp2_309315 * tmp2_309315;\n            double tmp3_309317 = tmp2_309315 * x_309316;\n            double w_j_309318 = defunc_0_f_res_309306 * tmp3_309317;\n            double defunc_1_op_res_309300 = w_j_309318 + redout_317600;\n            double redout_tmp_323358 = defunc_1_op_res_309300;\n            \n            redout_317600 = redo",
            "ut_tmp_323358;\n        }\n        defunc_2_reduce_res_309297 = redout_317600;\n        \n        double a_309319 = 2.220446049250313e-16 + defunc_2_reduce_res_309297;\n        double a0_309320 = 1.0 / a_309319;\n        double defunc_2_reduce_res_309321;\n        double redout_317602 = 0.0;\n        \n        for (int64_t i_317603 = 0; i_317603 < q_l_292680; i_317603++) {\n            bool cond_309326 = sle64(n_292675, i_317603);\n            int64_t defunc_0_f_res_309327;\n            \n            if (cond_309326) {\n                defunc_0_f_res_309327 = (int64_t) 0;\n            } else {\n                int64_t i_309328 = add64(x_309292, i_317603);\n                int64_t defunc_1_add_res_309329 = add64((int64_t) 1, i_309328);\n                \n                defunc_0_f_res_309327 = defunc_1_add_res_309329;\n            }\n            \n            double defunc_0_f_res_309330;\n            \n            if (cond_309326) {\n                defunc_0_f_res_309330 = 0.0;\n            } else {\n                int64_t i_309331 = add64(x_309292, i_317603);\n                double defunc_0_add_arg_309332;\n                \n                defunc_0_add_arg_309332 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_309286 *\n                                                                         ctx_param_ext_318834 +\n                                                                         i_309331 *\n                                                                         ctx_param_ext_318836)];\n                defunc_0_f_res_309330 = defunc_0_add_arg_309332;\n            }\n            \n            int64_t binop_p_309333 = sub64(defunc_0_f_res_309327,\n                                           defunc_0_g_res_309296);\n            double defunc_0_f_res_309334 = sitofp_i64_f64(binop_p_309333);\n            double abs_res_309335 = fabs(defunc_0_f_res_309334);\n       ",
            "     double tmp1_309336 = abs_res_309335 / x_309293;\n            double x_309337 = tmp1_309336 * tmp1_309336;\n            double y_309338 = tmp1_309336 * x_309337;\n            double tmp2_309339 = 1.0 - y_309338;\n            double x_309340 = tmp2_309339 * tmp2_309339;\n            double tmp3_309341 = tmp2_309339 * x_309340;\n            double tmp4_309342 = defunc_0_f_res_309330 * tmp3_309341;\n            double defunc_0_f_res_309343;\n            \n            if (cond_309326) {\n                defunc_0_f_res_309343 = 0.0;\n            } else {\n                int64_t i_309344 = add64(x_309292, i_317603);\n                double defunc_0_add_arg_309345;\n                \n                defunc_0_add_arg_309345 = ((__global\n                                            double *) mem_319555)[gtid_309286 *\n                                                                  n_292675 +\n                                                                  i_309344];\n                defunc_0_f_res_309343 = defunc_0_add_arg_309345;\n            }\n            \n            double x_309346 = a0_309320 * tmp4_309342;\n            double defunc_9_fit_fun_res_309347 = defunc_0_f_res_309343 *\n                   x_309346;\n            double defunc_1_op_res_309324 = defunc_9_fit_fun_res_309347 +\n                   redout_317602;\n            double redout_tmp_323359 = defunc_1_op_res_309324;\n            \n            redout_317602 = redout_tmp_323359;\n        }\n        defunc_2_reduce_res_309321 = redout_317602;\n        ((__global double *) mem_319564)[gtid_309286 * l_n_m_292832 +\n                                         gtid_309287] =\n            defunc_2_reduce_res_309321;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_309283\n}\n__kernel void mainzisegmap_309471(__global int *global_failure,\n                                  int64_t n_292675, int64_t q_l_292680,\n                                  int64_t jump_t_292685,\n                                  int64_t partition_sizze_29276",
            "6,\n                                  int64_t l_n_m_292832, int64_t i_292846,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n                                  int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318756, __global\n                                  unsigned char *ext_mem_318757, __global\n                                  unsigned char *mem_param_318838, __global\n                                  unsigned char *mem_319555, __global\n                                  unsigned char *mem_319569, __global\n                                  unsigned char *mem_319573)\n{\n    #define segmap_group_sizze_309465 (mainzisegmap_group_sizze_309354)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323360;\n    int32_t local_tid_323361;\n    int64_t group_sizze_323364;\n    int32_t wave_sizze_323363;\n    int32_t group_tid_323362;\n    \n    global_tid_323360 = get_global_id(0);\n    local_tid_323361 = get_local_id(0);\n    group_sizze_323364 = get_local_size(0);\n    wave_sizze_323363 = LOCKSTEP_WIDTH;\n    group_tid_323362 = get_group_id(0);\n    \n    int32_t phys_tid_309471 = global_tid_323360;\n    int64_t global_tid_323365 = sext_i32_i64(group_tid_323362) *\n            segmap_group_sizze_309465 + sext_i32_i64(local_tid_323361);\n    int64_t slice_323366 = l_n_m_292832;\n    int64_t slice_323367 = partition_sizze_292766 * slice_323366;\n    int64_t gtid_309469 = squot64(global_tid_323365, slice_323366);\n    int64_t remnant_323368 = global_tid_323365 - gtid_309469 * slice_323366;\n    int64_t gtid_309470 = remnant_323368;\n    int64_t remnant_323369 = remnant_323368 - gtid_309470;\n    \n    if (slt64(gtid_309469, partition_sizze_292766) && slt64(gtid_309470,\n                                                            l_n_m_292832)) {\n        ",
            "int64_t x_309475;\n        \n        x_309475 = ((__global int64_t *) ext_mem_318757)[gtid_309469 *\n                                                         l_n_m_292832 +\n                                                         gtid_309470];\n        \n        double x_309476;\n        \n        x_309476 = ((__global double *) ext_mem_318756)[gtid_309469 *\n                                                        l_n_m_292832 +\n                                                        gtid_309470];\n        \n        int64_t min_arg_309477 = mul64(jump_t_292685, gtid_309470);\n        int64_t min_res_309478 = smin64(i_292846, min_arg_309477);\n        int64_t defunc_0_g_res_309479 = add64((int64_t) 1, min_res_309478);\n        double defunc_2_reduce_res_309480;\n        double defunc_2_reduce_res_309481;\n        double defunc_2_reduce_res_309482;\n        double redout_317610;\n        double redout_317611;\n        double redout_317612;\n        \n        redout_317610 = 0.0;\n        redout_317611 = 0.0;\n        redout_317612 = 0.0;\n        for (int64_t i_317613 = 0; i_317613 < q_l_292680; i_317613++) {\n            bool cond_309493 = sle64(n_292675, i_317613);\n            int64_t defunc_0_f_res_309494;\n            \n            if (cond_309493) {\n                defunc_0_f_res_309494 = (int64_t) 0;\n            } else {\n                int64_t i_309495 = add64(x_309475, i_317613);\n                int64_t defunc_1_add_res_309496 = add64((int64_t) 1, i_309495);\n                \n                defunc_0_f_res_309494 = defunc_1_add_res_309496;\n            }\n            \n            double defunc_0_f_res_309497;\n            \n            if (cond_309493) {\n                defunc_0_f_res_309497 = 0.0;\n            } else {\n                int64_t i_309498 = add64(x_309475, i_317613);\n                double defunc_0_add_arg_309499;\n                \n                defunc_0_add_arg_309499 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n ",
            "                                                                       (gtid_309469 *\n                                                                         ctx_param_ext_318834 +\n                                                                         i_309498 *\n                                                                         ctx_param_ext_318836)];\n                defunc_0_f_res_309497 = defunc_0_add_arg_309499;\n            }\n            \n            int64_t binop_p_309500 = sub64(defunc_0_f_res_309494,\n                                           defunc_0_g_res_309479);\n            double defunc_0_f_res_309501 = sitofp_i64_f64(binop_p_309500);\n            double abs_res_309502 = fabs(defunc_0_f_res_309501);\n            double tmp1_309503 = abs_res_309502 / x_309476;\n            double x_309504 = tmp1_309503 * tmp1_309503;\n            double y_309505 = tmp1_309503 * x_309504;\n            double tmp2_309506 = 1.0 - y_309505;\n            double x_309507 = tmp2_309506 * tmp2_309506;\n            double tmp3_309508 = tmp2_309506 * x_309507;\n            double w_j_309509 = defunc_0_f_res_309497 * tmp3_309508;\n            double xw_j_309510 = defunc_0_f_res_309501 * w_j_309509;\n            double x2w_j_309511 = defunc_0_f_res_309501 * xw_j_309510;\n            double defunc_1_op_res_309485 = w_j_309509 + redout_317610;\n            double defunc_1_op_res_309488 = xw_j_309510 + redout_317611;\n            double defunc_1_op_res_309491 = x2w_j_309511 + redout_317612;\n            double redout_tmp_323370 = defunc_1_op_res_309485;\n            double redout_tmp_323371 = defunc_1_op_res_309488;\n            double redout_tmp_323372 = defunc_1_op_res_309491;\n            \n            redout_317610 = redout_tmp_323370;\n            redout_317611 = redout_tmp_323371;\n            redout_317612 = redout_tmp_323372;\n        }\n        defunc_2_reduce_res_309480 = redout_317610;\n        defunc_2_reduce_res_309481 = redout_317611;\n        defunc_2_reduce_res_309482 = redout_317612;\n ",
            "       \n        double a_309512 = 2.220446049250313e-16 + defunc_2_reduce_res_309480;\n        double b_309513 = 2.220446049250313e-16 + defunc_2_reduce_res_309481;\n        double c_309514 = 2.220446049250313e-16 + defunc_2_reduce_res_309482;\n        double x_309515 = a_309512 * c_309514;\n        double y_309516 = b_309513 * b_309513;\n        double y_309517 = x_309515 - y_309516;\n        double det1_309518 = 1.0 / y_309517;\n        double a11_309519 = c_309514 * det1_309518;\n        double x_309520 = 0.0 - b_309513;\n        double b11_309521 = det1_309518 * x_309520;\n        double c11_309522 = a_309512 * det1_309518;\n        double defunc_2_reduce_res_309523;\n        double defunc_2_reduce_res_309524;\n        double redout_317614;\n        double redout_317615;\n        \n        redout_317614 = 0.0;\n        redout_317615 = 0.0;\n        for (int64_t i_317616 = 0; i_317616 < q_l_292680; i_317616++) {\n            bool cond_309532 = sle64(n_292675, i_317616);\n            int64_t defunc_0_f_res_309533;\n            \n            if (cond_309532) {\n                defunc_0_f_res_309533 = (int64_t) 0;\n            } else {\n                int64_t i_309534 = add64(x_309475, i_317616);\n                int64_t defunc_1_add_res_309535 = add64((int64_t) 1, i_309534);\n                \n                defunc_0_f_res_309533 = defunc_1_add_res_309535;\n            }\n            \n            double defunc_0_f_res_309536;\n            \n            if (cond_309532) {\n                defunc_0_f_res_309536 = 0.0;\n            } else {\n                int64_t i_309537 = add64(x_309475, i_317616);\n                double defunc_0_add_arg_309538;\n                \n                defunc_0_add_arg_309538 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_309469 *\n                                                                         ctx_param_ext_318834 +\n         ",
            "                                                                i_309537 *\n                                                                         ctx_param_ext_318836)];\n                defunc_0_f_res_309536 = defunc_0_add_arg_309538;\n            }\n            \n            int64_t binop_p_309539 = sub64(defunc_0_f_res_309533,\n                                           defunc_0_g_res_309479);\n            double defunc_0_f_res_309540 = sitofp_i64_f64(binop_p_309539);\n            double abs_res_309541 = fabs(defunc_0_f_res_309540);\n            double tmp1_309542 = abs_res_309541 / x_309476;\n            double x_309543 = tmp1_309542 * tmp1_309542;\n            double y_309544 = tmp1_309542 * x_309543;\n            double tmp2_309545 = 1.0 - y_309544;\n            double x_309546 = tmp2_309545 * tmp2_309545;\n            double tmp3_309547 = tmp2_309545 * x_309546;\n            double tmp4_309548 = defunc_0_f_res_309536 * tmp3_309547;\n            double defunc_1_f_res_309549 = defunc_0_f_res_309540 * tmp4_309548;\n            double defunc_0_f_res_309550;\n            \n            if (cond_309532) {\n                defunc_0_f_res_309550 = 0.0;\n            } else {\n                int64_t i_309551 = add64(x_309475, i_317616);\n                double defunc_0_add_arg_309552;\n                \n                defunc_0_add_arg_309552 = ((__global\n                                            double *) mem_319555)[gtid_309469 *\n                                                                  n_292675 +\n                                                                  i_309551];\n                defunc_0_f_res_309550 = defunc_0_add_arg_309552;\n            }\n            \n            double x_309553 = a11_309519 * tmp4_309548;\n            double y_309554 = b11_309521 * defunc_1_f_res_309549;\n            double x_309555 = x_309553 + y_309554;\n            double defunc_9_fit_fun_res_309556 = defunc_0_f_res_309550 *\n                   x_309555;\n            double x_309557 = b11_309521 * tmp",
            "4_309548;\n            double y_309558 = c11_309522 * defunc_1_f_res_309549;\n            double x_309559 = x_309557 + y_309558;\n            double defunc_9_slope_fun_res_309560 = defunc_0_f_res_309550 *\n                   x_309559;\n            double defunc_1_op_res_309527 = defunc_9_fit_fun_res_309556 +\n                   redout_317614;\n            double defunc_1_op_res_309530 = defunc_9_slope_fun_res_309560 +\n                   redout_317615;\n            double redout_tmp_323373 = defunc_1_op_res_309527;\n            double redout_tmp_323374 = defunc_1_op_res_309530;\n            \n            redout_317614 = redout_tmp_323373;\n            redout_317615 = redout_tmp_323374;\n        }\n        defunc_2_reduce_res_309523 = redout_317614;\n        defunc_2_reduce_res_309524 = redout_317615;\n        ((__global double *) mem_319569)[gtid_309469 * l_n_m_292832 +\n                                         gtid_309470] =\n            defunc_2_reduce_res_309523;\n        ((__global double *) mem_319573)[gtid_309469 * l_n_m_292832 +\n                                         gtid_309470] =\n            defunc_2_reduce_res_309524;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_309465\n}\n__kernel void mainzisegmap_309719(__global int *global_failure,\n                                  int64_t n_292675, int64_t q_l_292680,\n                                  int64_t jump_t_292685,\n                                  int64_t partition_sizze_292766,\n                                  int64_t l_n_m_292832, int64_t i_292846,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n                                  int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318756, __global\n                                  unsigned char *ext_mem_318757, __global\n                                  unsigned char *mem_param_318838, __global\n                                  unsigne",
            "d char *mem_319555, __global\n                                  unsigned char *mem_319578, __global\n                                  unsigned char *mem_319582)\n{\n    #define segmap_group_sizze_309713 (mainzisegmap_group_sizze_309568)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323375;\n    int32_t local_tid_323376;\n    int64_t group_sizze_323379;\n    int32_t wave_sizze_323378;\n    int32_t group_tid_323377;\n    \n    global_tid_323375 = get_global_id(0);\n    local_tid_323376 = get_local_id(0);\n    group_sizze_323379 = get_local_size(0);\n    wave_sizze_323378 = LOCKSTEP_WIDTH;\n    group_tid_323377 = get_group_id(0);\n    \n    int32_t phys_tid_309719 = global_tid_323375;\n    int64_t global_tid_323380 = sext_i32_i64(group_tid_323377) *\n            segmap_group_sizze_309713 + sext_i32_i64(local_tid_323376);\n    int64_t slice_323381 = l_n_m_292832;\n    int64_t slice_323382 = partition_sizze_292766 * slice_323381;\n    int64_t gtid_309717 = squot64(global_tid_323380, slice_323381);\n    int64_t remnant_323383 = global_tid_323380 - gtid_309717 * slice_323381;\n    int64_t gtid_309718 = remnant_323383;\n    int64_t remnant_323384 = remnant_323383 - gtid_309718;\n    \n    if (slt64(gtid_309717, partition_sizze_292766) && slt64(gtid_309718,\n                                                            l_n_m_292832)) {\n        int64_t x_309723;\n        \n        x_309723 = ((__global int64_t *) ext_mem_318757)[gtid_309717 *\n                                                         l_n_m_292832 +\n                                                         gtid_309718];\n        \n        double x_309724;\n        \n        x_309724 = ((__global double *) ext_mem_318756)[gtid_309717 *\n                                                        l_n_m_292832 +\n                                                        gtid_309718];\n        \n        int64_t min_arg_309725 = mul64(",
            "jump_t_292685, gtid_309718);\n        int64_t min_res_309726 = smin64(i_292846, min_arg_309725);\n        int64_t defunc_0_g_res_309727 = add64((int64_t) 1, min_res_309726);\n        double defunc_2_reduce_res_309728;\n        double defunc_2_reduce_res_309729;\n        double defunc_2_reduce_res_309730;\n        double defunc_2_reduce_res_309731;\n        double defunc_2_reduce_res_309732;\n        double redout_317623;\n        double redout_317624;\n        double redout_317625;\n        double redout_317626;\n        double redout_317627;\n        \n        redout_317623 = 0.0;\n        redout_317624 = 0.0;\n        redout_317625 = 0.0;\n        redout_317626 = 0.0;\n        redout_317627 = 0.0;\n        for (int64_t i_317628 = 0; i_317628 < q_l_292680; i_317628++) {\n            bool cond_309749 = sle64(n_292675, i_317628);\n            int64_t defunc_0_f_res_309750;\n            \n            if (cond_309749) {\n                defunc_0_f_res_309750 = (int64_t) 0;\n            } else {\n                int64_t i_309751 = add64(x_309723, i_317628);\n                int64_t defunc_1_add_res_309752 = add64((int64_t) 1, i_309751);\n                \n                defunc_0_f_res_309750 = defunc_1_add_res_309752;\n            }\n            \n            double defunc_0_f_res_309753;\n            \n            if (cond_309749) {\n                defunc_0_f_res_309753 = 0.0;\n            } else {\n                int64_t i_309754 = add64(x_309723, i_317628);\n                double defunc_0_add_arg_309755;\n                \n                defunc_0_add_arg_309755 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_309717 *\n                                                                         ctx_param_ext_318834 +\n                                                                         i_309754 *\n                                                                         ",
            "ctx_param_ext_318836)];\n                defunc_0_f_res_309753 = defunc_0_add_arg_309755;\n            }\n            \n            int64_t binop_p_309756 = sub64(defunc_0_f_res_309750,\n                                           defunc_0_g_res_309727);\n            double defunc_0_f_res_309757 = sitofp_i64_f64(binop_p_309756);\n            double abs_res_309758 = fabs(defunc_0_f_res_309757);\n            double tmp1_309759 = abs_res_309758 / x_309724;\n            double x_309760 = tmp1_309759 * tmp1_309759;\n            double y_309761 = tmp1_309759 * x_309760;\n            double tmp2_309762 = 1.0 - y_309761;\n            double x_309763 = tmp2_309762 * tmp2_309762;\n            double tmp3_309764 = tmp2_309762 * x_309763;\n            double w_j_309765 = defunc_0_f_res_309753 * tmp3_309764;\n            double xw_j_309766 = defunc_0_f_res_309757 * w_j_309765;\n            double x2w_j_309767 = defunc_0_f_res_309757 * xw_j_309766;\n            double x3w_j_309768 = defunc_0_f_res_309757 * x2w_j_309767;\n            double x4w_j_309769 = defunc_0_f_res_309757 * x3w_j_309768;\n            double defunc_1_op_res_309735 = w_j_309765 + redout_317623;\n            double defunc_1_op_res_309738 = xw_j_309766 + redout_317624;\n            double defunc_1_op_res_309741 = x2w_j_309767 + redout_317625;\n            double defunc_1_op_res_309744 = x3w_j_309768 + redout_317626;\n            double defunc_1_op_res_309747 = x4w_j_309769 + redout_317627;\n            double redout_tmp_323385 = defunc_1_op_res_309735;\n            double redout_tmp_323386 = defunc_1_op_res_309738;\n            double redout_tmp_323387 = defunc_1_op_res_309741;\n            double redout_tmp_323388 = defunc_1_op_res_309744;\n            double redout_tmp_323389 = defunc_1_op_res_309747;\n            \n            redout_317623 = redout_tmp_323385;\n            redout_317624 = redout_tmp_323386;\n            redout_317625 = redout_tmp_323387;\n            redout_317626 = redout_tmp_323388;\n            redout_317627 = redout_tmp_32",
            "3389;\n        }\n        defunc_2_reduce_res_309728 = redout_317623;\n        defunc_2_reduce_res_309729 = redout_317624;\n        defunc_2_reduce_res_309730 = redout_317625;\n        defunc_2_reduce_res_309731 = redout_317626;\n        defunc_2_reduce_res_309732 = redout_317627;\n        \n        double a_309770 = 2.220446049250313e-16 + defunc_2_reduce_res_309728;\n        double b_309771 = 2.220446049250313e-16 + defunc_2_reduce_res_309729;\n        double c_309772 = 2.220446049250313e-16 + defunc_2_reduce_res_309730;\n        double d_309773 = 2.220446049250313e-16 + defunc_2_reduce_res_309731;\n        double e_309774 = 2.220446049250313e-16 + defunc_2_reduce_res_309732;\n        double x_309775 = c_309772 * e_309774;\n        double y_309776 = d_309773 * d_309773;\n        double a12_309777 = x_309775 - y_309776;\n        double x_309778 = c_309772 * d_309773;\n        double y_309779 = b_309771 * e_309774;\n        double b12_309780 = x_309778 - y_309779;\n        double x_309781 = b_309771 * d_309773;\n        double y_309782 = c_309772 * c_309772;\n        double c12_309783 = x_309781 - y_309782;\n        double x_309784 = a_309770 * e_309774;\n        double b2_309785 = x_309784 - y_309782;\n        double x_309786 = b_309771 * c_309772;\n        double y_309787 = a_309770 * d_309773;\n        double c2_309788 = x_309786 - y_309787;\n        double x_309789 = a_309770 * a12_309777;\n        double y_309790 = b_309771 * b12_309780;\n        double x_309791 = x_309789 + y_309790;\n        double y_309792 = c_309772 * c12_309783;\n        double y_309793 = x_309791 + y_309792;\n        double det_309794 = 1.0 / y_309793;\n        double a12_309795 = a12_309777 * det_309794;\n        double b12_309796 = b12_309780 * det_309794;\n        double c12_309797 = c12_309783 * det_309794;\n        double b2_309798 = b2_309785 * det_309794;\n        double c2_309799 = c2_309788 * det_309794;\n        double defunc_2_reduce_res_309800;\n        double defunc_2_reduce_res_309801;\n        double redout_31762",
            "9;\n        double redout_317630;\n        \n        redout_317629 = 0.0;\n        redout_317630 = 0.0;\n        for (int64_t i_317631 = 0; i_317631 < q_l_292680; i_317631++) {\n            bool cond_309809 = sle64(n_292675, i_317631);\n            int64_t defunc_0_f_res_309810;\n            \n            if (cond_309809) {\n                defunc_0_f_res_309810 = (int64_t) 0;\n            } else {\n                int64_t i_309811 = add64(x_309723, i_317631);\n                int64_t defunc_1_add_res_309812 = add64((int64_t) 1, i_309811);\n                \n                defunc_0_f_res_309810 = defunc_1_add_res_309812;\n            }\n            \n            double defunc_0_f_res_309813;\n            \n            if (cond_309809) {\n                defunc_0_f_res_309813 = 0.0;\n            } else {\n                int64_t i_309814 = add64(x_309723, i_317631);\n                double defunc_0_add_arg_309815;\n                \n                defunc_0_add_arg_309815 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_309717 *\n                                                                         ctx_param_ext_318834 +\n                                                                         i_309814 *\n                                                                         ctx_param_ext_318836)];\n                defunc_0_f_res_309813 = defunc_0_add_arg_309815;\n            }\n            \n            int64_t binop_p_309816 = sub64(defunc_0_f_res_309810,\n                                           defunc_0_g_res_309727);\n            double defunc_0_f_res_309817 = sitofp_i64_f64(binop_p_309816);\n            double abs_res_309818 = fabs(defunc_0_f_res_309817);\n            double tmp1_309819 = abs_res_309818 / x_309724;\n            double x_309820 = tmp1_309819 * tmp1_309819;\n            double y_309821 = tmp1_309819 * x_309820;\n            double tmp2_309822 ",
            "= 1.0 - y_309821;\n            double x_309823 = tmp2_309822 * tmp2_309822;\n            double tmp3_309824 = tmp2_309822 * x_309823;\n            double tmp4_309825 = defunc_0_f_res_309813 * tmp3_309824;\n            double defunc_1_f_res_309826 = defunc_0_f_res_309817 * tmp4_309825;\n            double defunc_1_f_res_309827 = defunc_0_f_res_309817 *\n                   defunc_1_f_res_309826;\n            double defunc_0_f_res_309828;\n            \n            if (cond_309809) {\n                defunc_0_f_res_309828 = 0.0;\n            } else {\n                int64_t i_309829 = add64(x_309723, i_317631);\n                double defunc_0_add_arg_309830;\n                \n                defunc_0_add_arg_309830 = ((__global\n                                            double *) mem_319555)[gtid_309717 *\n                                                                  n_292675 +\n                                                                  i_309829];\n                defunc_0_f_res_309828 = defunc_0_add_arg_309830;\n            }\n            \n            double x_309831 = a12_309795 * tmp4_309825;\n            double y_309832 = b12_309796 * defunc_1_f_res_309826;\n            double x_309833 = x_309831 + y_309832;\n            double y_309834 = c12_309797 * defunc_1_f_res_309827;\n            double x_309835 = x_309833 + y_309834;\n            double defunc_9_fit_fun_res_309836 = defunc_0_f_res_309828 *\n                   x_309835;\n            double x_309837 = b12_309796 * tmp4_309825;\n            double y_309838 = b2_309798 * defunc_1_f_res_309826;\n            double x_309839 = x_309837 + y_309838;\n            double y_309840 = c2_309799 * defunc_1_f_res_309827;\n            double x_309841 = x_309839 + y_309840;\n            double defunc_9_slope_fun_res_309842 = defunc_0_f_res_309828 *\n                   x_309841;\n            double defunc_1_op_res_309804 = defunc_9_fit_fun_res_309836 +\n                   redout_317629;\n            double defunc_1_op_res_309807 = defunc_9_slope_",
            "fun_res_309842 +\n                   redout_317630;\n            double redout_tmp_323390 = defunc_1_op_res_309804;\n            double redout_tmp_323391 = defunc_1_op_res_309807;\n            \n            redout_317629 = redout_tmp_323390;\n            redout_317630 = redout_tmp_323391;\n        }\n        defunc_2_reduce_res_309800 = redout_317629;\n        defunc_2_reduce_res_309801 = redout_317630;\n        ((__global double *) mem_319578)[gtid_309717 * l_n_m_292832 +\n                                         gtid_309718] =\n            defunc_2_reduce_res_309800;\n        ((__global double *) mem_319582)[gtid_309717 * l_n_m_292832 +\n                                         gtid_309718] =\n            defunc_2_reduce_res_309801;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_309713\n}\n__kernel void mainzisegmap_310801(__global int *global_failure,\n                                  int64_t partition_sizze_292766,\n                                  int64_t l_n_m_292832, __global\n                                  unsigned char *mem_319654, __global\n                                  unsigned char *mem_319659)\n{\n    #define segmap_group_sizze_310796 (mainzisegmap_group_sizze_310562)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323544;\n    int32_t local_tid_323545;\n    int64_t group_sizze_323548;\n    int32_t wave_sizze_323547;\n    int32_t group_tid_323546;\n    \n    global_tid_323544 = get_global_id(0);\n    local_tid_323545 = get_local_id(0);\n    group_sizze_323548 = get_local_size(0);\n    wave_sizze_323547 = LOCKSTEP_WIDTH;\n    group_tid_323546 = get_group_id(0);\n    \n    int32_t phys_tid_310801 = global_tid_323544;\n    int64_t global_tid_323549 = sext_i32_i64(group_tid_323546) *\n            segmap_group_sizze_310796 + sext_i32_i64(local_tid_323545);\n    int64_t slice_323550 = l_n_m_292832;\n    int64_t slice_323551 = partition_sizze_292766",
            " * slice_323550;\n    int64_t gtid_310799 = squot64(global_tid_323549, slice_323550);\n    int64_t remnant_323552 = global_tid_323549 - gtid_310799 * slice_323550;\n    int64_t gtid_310800 = remnant_323552;\n    int64_t remnant_323553 = remnant_323552 - gtid_310800;\n    \n    if (slt64(gtid_310799, partition_sizze_292766) && slt64(gtid_310800,\n                                                            l_n_m_292832)) {\n        double defunc_2_reduce_res_310802;\n        \n        defunc_2_reduce_res_310802 = ((__global\n                                       double *) mem_319654)[gtid_310799 *\n                                                             l_n_m_292832 +\n                                                             gtid_310800];\n        \n        double a_310803 = 2.220446049250313e-16 + defunc_2_reduce_res_310802;\n        double a0_310804 = 1.0 / a_310803;\n        \n        ((__global double *) mem_319659)[gtid_310799 * l_n_m_292832 +\n                                         gtid_310800] = a0_310804;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_310796\n}\n__kernel void mainzisegmap_311254(__global int *global_failure,\n                                  int64_t partition_sizze_292766,\n                                  int64_t l_n_m_292832, __global\n                                  unsigned char *mem_319669, __global\n                                  unsigned char *mem_319673, __global\n                                  unsigned char *mem_319677, __global\n                                  unsigned char *mem_319682, __global\n                                  unsigned char *mem_319686, __global\n                                  unsigned char *mem_319690)\n{\n    #define segmap_group_sizze_311247 (mainzisegmap_group_sizze_310946)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323728;\n    int32_t local_tid_323729;\n    int64_t gro",
            "up_sizze_323732;\n    int32_t wave_sizze_323731;\n    int32_t group_tid_323730;\n    \n    global_tid_323728 = get_global_id(0);\n    local_tid_323729 = get_local_id(0);\n    group_sizze_323732 = get_local_size(0);\n    wave_sizze_323731 = LOCKSTEP_WIDTH;\n    group_tid_323730 = get_group_id(0);\n    \n    int32_t phys_tid_311254 = global_tid_323728;\n    int64_t global_tid_323733 = sext_i32_i64(group_tid_323730) *\n            segmap_group_sizze_311247 + sext_i32_i64(local_tid_323729);\n    int64_t slice_323734 = l_n_m_292832;\n    int64_t slice_323735 = partition_sizze_292766 * slice_323734;\n    int64_t gtid_311252 = squot64(global_tid_323733, slice_323734);\n    int64_t remnant_323736 = global_tid_323733 - gtid_311252 * slice_323734;\n    int64_t gtid_311253 = remnant_323736;\n    int64_t remnant_323737 = remnant_323736 - gtid_311253;\n    \n    if (slt64(gtid_311252, partition_sizze_292766) && slt64(gtid_311253,\n                                                            l_n_m_292832)) {\n        double defunc_2_reduce_res_311255;\n        \n        defunc_2_reduce_res_311255 = ((__global\n                                       double *) mem_319669)[gtid_311252 *\n                                                             l_n_m_292832 +\n                                                             gtid_311253];\n        \n        double defunc_2_reduce_res_311256;\n        \n        defunc_2_reduce_res_311256 = ((__global\n                                       double *) mem_319673)[gtid_311252 *\n                                                             l_n_m_292832 +\n                                                             gtid_311253];\n        \n        double defunc_2_reduce_res_311257;\n        \n        defunc_2_reduce_res_311257 = ((__global\n                                       double *) mem_319677)[gtid_311252 *\n                                                             l_n_m_292832 +\n                                                             gtid_311253];\n        \n       ",
            " double a_311258 = 2.220446049250313e-16 + defunc_2_reduce_res_311255;\n        double b_311259 = 2.220446049250313e-16 + defunc_2_reduce_res_311256;\n        double c_311260 = 2.220446049250313e-16 + defunc_2_reduce_res_311257;\n        double x_311261 = a_311258 * c_311260;\n        double y_311262 = b_311259 * b_311259;\n        double y_311263 = x_311261 - y_311262;\n        double det1_311264 = 1.0 / y_311263;\n        double a11_311265 = c_311260 * det1_311264;\n        double x_311266 = 0.0 - b_311259;\n        double b11_311267 = det1_311264 * x_311266;\n        double c11_311268 = a_311258 * det1_311264;\n        \n        ((__global double *) mem_319682)[gtid_311252 * l_n_m_292832 +\n                                         gtid_311253] = a11_311265;\n        ((__global double *) mem_319686)[gtid_311252 * l_n_m_292832 +\n                                         gtid_311253] = b11_311267;\n        ((__global double *) mem_319690)[gtid_311252 * l_n_m_292832 +\n                                         gtid_311253] = c11_311268;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_311247\n}\n__kernel void mainzisegmap_311834(__global int *global_failure,\n                                  int64_t partition_sizze_292766,\n                                  int64_t l_n_m_292832, __global\n                                  unsigned char *mem_319704, __global\n                                  unsigned char *mem_319708, __global\n                                  unsigned char *mem_319712, __global\n                                  unsigned char *mem_319716, __global\n                                  unsigned char *mem_319720, __global\n                                  unsigned char *mem_319725, __global\n                                  unsigned char *mem_319729, __global\n                                  unsigned char *mem_319733, __global\n                                  unsigned char *mem_319737, __global\n                                  unsigned char *mem_319741)\n{\n    #",
            "define segmap_group_sizze_311825 (mainzisegmap_group_sizze_311443)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323954;\n    int32_t local_tid_323955;\n    int64_t group_sizze_323958;\n    int32_t wave_sizze_323957;\n    int32_t group_tid_323956;\n    \n    global_tid_323954 = get_global_id(0);\n    local_tid_323955 = get_local_id(0);\n    group_sizze_323958 = get_local_size(0);\n    wave_sizze_323957 = LOCKSTEP_WIDTH;\n    group_tid_323956 = get_group_id(0);\n    \n    int32_t phys_tid_311834 = global_tid_323954;\n    int64_t global_tid_323959 = sext_i32_i64(group_tid_323956) *\n            segmap_group_sizze_311825 + sext_i32_i64(local_tid_323955);\n    int64_t slice_323960 = l_n_m_292832;\n    int64_t slice_323961 = partition_sizze_292766 * slice_323960;\n    int64_t gtid_311832 = squot64(global_tid_323959, slice_323960);\n    int64_t remnant_323962 = global_tid_323959 - gtid_311832 * slice_323960;\n    int64_t gtid_311833 = remnant_323962;\n    int64_t remnant_323963 = remnant_323962 - gtid_311833;\n    \n    if (slt64(gtid_311832, partition_sizze_292766) && slt64(gtid_311833,\n                                                            l_n_m_292832)) {\n        double defunc_2_reduce_res_311835;\n        \n        defunc_2_reduce_res_311835 = ((__global\n                                       double *) mem_319704)[gtid_311832 *\n                                                             l_n_m_292832 +\n                                                             gtid_311833];\n        \n        double defunc_2_reduce_res_311836;\n        \n        defunc_2_reduce_res_311836 = ((__global\n                                       double *) mem_319708)[gtid_311832 *\n                                                             l_n_m_292832 +\n                                                             gtid_311833];\n        \n        double defunc_2_reduce_res_311837;\n     ",
            "   \n        defunc_2_reduce_res_311837 = ((__global\n                                       double *) mem_319712)[gtid_311832 *\n                                                             l_n_m_292832 +\n                                                             gtid_311833];\n        \n        double defunc_2_reduce_res_311838;\n        \n        defunc_2_reduce_res_311838 = ((__global\n                                       double *) mem_319716)[gtid_311832 *\n                                                             l_n_m_292832 +\n                                                             gtid_311833];\n        \n        double defunc_2_reduce_res_311839;\n        \n        defunc_2_reduce_res_311839 = ((__global\n                                       double *) mem_319720)[gtid_311832 *\n                                                             l_n_m_292832 +\n                                                             gtid_311833];\n        \n        double a_311840 = 2.220446049250313e-16 + defunc_2_reduce_res_311835;\n        double b_311841 = 2.220446049250313e-16 + defunc_2_reduce_res_311836;\n        double c_311842 = 2.220446049250313e-16 + defunc_2_reduce_res_311837;\n        double d_311843 = 2.220446049250313e-16 + defunc_2_reduce_res_311838;\n        double e_311844 = 2.220446049250313e-16 + defunc_2_reduce_res_311839;\n        double x_311845 = c_311842 * e_311844;\n        double y_311846 = d_311843 * d_311843;\n        double a12_311847 = x_311845 - y_311846;\n        double x_311848 = c_311842 * d_311843;\n        double y_311849 = b_311841 * e_311844;\n        double b12_311850 = x_311848 - y_311849;\n        double x_311851 = b_311841 * d_311843;\n        double y_311852 = c_311842 * c_311842;\n        double c12_311853 = x_311851 - y_311852;\n        double x_311854 = a_311840 * e_311844;\n        double b2_311855 = x_311854 - y_311852;\n        double x_311856 = b_311841 * c_311842;\n        double y_311857 = a_311840 * d_311843;\n        double c2_311858 = x_311856",
            " - y_311857;\n        double x_311859 = a_311840 * a12_311847;\n        double y_311860 = b_311841 * b12_311850;\n        double x_311861 = x_311859 + y_311860;\n        double y_311862 = c_311842 * c12_311853;\n        double y_311863 = x_311861 + y_311862;\n        double det_311864 = 1.0 / y_311863;\n        double a12_311865 = a12_311847 * det_311864;\n        double b12_311866 = b12_311850 * det_311864;\n        double c12_311867 = c12_311853 * det_311864;\n        double b2_311868 = b2_311855 * det_311864;\n        double c2_311869 = c2_311858 * det_311864;\n        \n        ((__global double *) mem_319725)[gtid_311832 * l_n_m_292832 +\n                                         gtid_311833] = a12_311865;\n        ((__global double *) mem_319729)[gtid_311832 * l_n_m_292832 +\n                                         gtid_311833] = b12_311866;\n        ((__global double *) mem_319733)[gtid_311832 * l_n_m_292832 +\n                                         gtid_311833] = c12_311867;\n        ((__global double *) mem_319737)[gtid_311832 * l_n_m_292832 +\n                                         gtid_311833] = b2_311868;\n        ((__global double *) mem_319741)[gtid_311832 * l_n_m_292832 +\n                                         gtid_311833] = c2_311869;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_311825\n}\n__kernel void mainzisegmap_312079(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675, int64_t jump_l_292686,\n                                  int64_t partition_sizze_292766,\n                                  int64_t l_n_m_292832, int64_t i_292846,\n                                  int64_t y_295743, __global\n                                  unsigned char *ext_mem_319757, __global\n                                  unsigned char *ext_mem_319758, __global\n                                  unsigned char *m",
            "em_319763)\n{\n    #define segmap_group_sizze_312074 (mainzisegmap_group_sizze_311956)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324051;\n    int32_t local_tid_324052;\n    int64_t group_sizze_324055;\n    int32_t wave_sizze_324054;\n    int32_t group_tid_324053;\n    \n    global_tid_324051 = get_global_id(0);\n    local_tid_324052 = get_local_id(0);\n    group_sizze_324055 = get_local_size(0);\n    wave_sizze_324054 = LOCKSTEP_WIDTH;\n    group_tid_324053 = get_group_id(0);\n    \n    int32_t phys_tid_312079 = global_tid_324051;\n    int64_t global_tid_324056 = sext_i32_i64(group_tid_324053) *\n            segmap_group_sizze_312074 + sext_i32_i64(local_tid_324052);\n    int64_t slice_324057 = n_292675;\n    int64_t slice_324058 = partition_sizze_292766 * slice_324057;\n    int64_t gtid_312077 = squot64(global_tid_324056, slice_324057);\n    int64_t remnant_324059 = global_tid_324056 - gtid_312077 * slice_324057;\n    int64_t gtid_312078 = remnant_324059;\n    int64_t remnant_324060 = remnant_324059 - gtid_312078;\n    \n    if (slt64(gtid_312077, partition_sizze_292766) && slt64(gtid_312078,\n                                                            n_292675)) {\n        int64_t m_v_312083 = sdiv64(gtid_312078, jump_l_292686);\n        bool cond_312084 = m_v_312083 == y_295743;\n        int64_t j_312085;\n        \n        if (cond_312084) {\n            int64_t j_t_res_312086 = sub64(m_v_312083, (int64_t) 1);\n            \n            j_312085 = j_t_res_312086;\n        } else {\n            j_312085 = m_v_312083;\n        }\n        \n        int64_t min_arg_312087 = mul64(jump_l_292686, j_312085);\n        int64_t min_res_312088 = smin64(i_292846, min_arg_312087);\n        int64_t defunc_0_m_fun_arg_312089 = add64((int64_t) 1, j_312085);\n        int64_t min_arg_312090 = mul64(jump_l_292686,\n                                       defunc_0_m_fun_arg_312089);\n        int",
            "64_t min_res_312091 = smin64(i_292846, min_arg_312090);\n        int64_t i64_arg_312092 = sub64(min_res_312091, min_res_312088);\n        double i64_res_312093 = sitofp_i64_f64(i64_arg_312092);\n        int64_t i64_arg_312094 = sub64(gtid_312078, min_res_312088);\n        double i64_res_312095 = sitofp_i64_f64(i64_arg_312094);\n        double u_312096 = i64_res_312095 / i64_res_312093;\n        double u2_312097 = u_312096 * u_312096;\n        double u3_312098 = u_312096 * u2_312097;\n        double x_312099 = 2.0 * u3_312098;\n        double y_312100 = 3.0 * u2_312097;\n        double x_312101 = x_312099 - y_312100;\n        double x_312102 = 1.0 + x_312101;\n        bool x_312103 = sle64((int64_t) 0, j_312085);\n        bool y_312104 = slt64(j_312085, l_n_m_292832);\n        bool bounds_check_312105 = x_312103 && y_312104;\n        bool index_certs_312106;\n        \n        if (!bounds_check_312105) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 50) == -1) {\n                    global_failure_args[0] = (int64_t) j_312085;\n                    global_failure_args[1] = (int64_t) l_n_m_292832;\n                    ;\n                }\n                return;\n            }\n        }\n        \n        double y_312107;\n        \n        y_312107 = ((__global double *) ext_mem_319758)[gtid_312077 *\n                                                        l_n_m_292832 +\n                                                        j_312085];\n        \n        double x_312108 = x_312102 * y_312107;\n        double x_312109 = y_312100 - x_312099;\n        bool x_312110 = sle64((int64_t) 0, defunc_0_m_fun_arg_312089);\n        bool y_312111 = slt64(defunc_0_m_fun_arg_312089, l_n_m_292832);\n        bool bounds_check_312112 = x_312110 && y_312111;\n        bool index_certs_312113;\n        \n        if (!bounds_check_312112) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 51) == -1) {\n                    global_failure_args[0] =\n               ",
            "         (int64_t) defunc_0_m_fun_arg_312089;\n                    global_failure_args[1] = (int64_t) l_n_m_292832;\n                    ;\n                }\n                return;\n            }\n        }\n        \n        double y_312114;\n        \n        y_312114 = ((__global double *) ext_mem_319758)[gtid_312077 *\n                                                        l_n_m_292832 +\n                                                        defunc_0_m_fun_arg_312089];\n        \n        double y_312115 = x_312109 * y_312114;\n        double x_312116 = x_312108 + y_312115;\n        double y_312117 = 2.0 * u2_312097;\n        double x_312118 = u3_312098 - y_312117;\n        double x_312119 = u_312096 + x_312118;\n        double y_312120;\n        \n        y_312120 = ((__global double *) ext_mem_319757)[gtid_312077 *\n                                                        l_n_m_292832 +\n                                                        j_312085];\n        \n        double x_312121 = x_312119 * y_312120;\n        double y_312122 = i64_res_312093 * x_312121;\n        double x_312123 = x_312116 + y_312122;\n        double x_312124 = u3_312098 - u2_312097;\n        double y_312125;\n        \n        y_312125 = ((__global double *) ext_mem_319757)[gtid_312077 *\n                                                        l_n_m_292832 +\n                                                        defunc_0_m_fun_arg_312089];\n        \n        double x_312126 = x_312124 * y_312125;\n        double y_312127 = i64_res_312093 * x_312126;\n        double defunc_4_interpolate_proc_res_312128 = x_312123 + y_312127;\n        \n        ((__global double *) mem_319763)[gtid_312077 * n_292675 + gtid_312078] =\n            defunc_4_interpolate_proc_res_312128;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_312074\n}\n__kernel void mainzisegmap_312174(__global int *global_failure,\n                                  int64_t n_292675, int64_t n_p_292677,\n                                  int64_t partiti",
            "on_sizze_292766,\n                                  int64_t C_len_292823, int64_t ext_319765,\n                                  __global unsigned char *mem_319504, __global\n                                  unsigned char *ext_mem_319764, __global\n                                  unsigned char *mem_319770)\n{\n    #define segmap_group_sizze_312169 (mainzisegmap_group_sizze_312143)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324061;\n    int32_t local_tid_324062;\n    int64_t group_sizze_324065;\n    int32_t wave_sizze_324064;\n    int32_t group_tid_324063;\n    \n    global_tid_324061 = get_global_id(0);\n    local_tid_324062 = get_local_id(0);\n    group_sizze_324065 = get_local_size(0);\n    wave_sizze_324064 = LOCKSTEP_WIDTH;\n    group_tid_324063 = get_group_id(0);\n    \n    int32_t phys_tid_312174 = global_tid_324061;\n    int64_t global_tid_324066 = sext_i32_i64(group_tid_324063) *\n            segmap_group_sizze_312169 + sext_i32_i64(local_tid_324062);\n    int64_t slice_324067 = n_292675;\n    int64_t slice_324068 = partition_sizze_292766 * slice_324067;\n    int64_t gtid_312172 = squot64(global_tid_324066, slice_324067);\n    int64_t remnant_324069 = global_tid_324066 - gtid_312172 * slice_324067;\n    int64_t gtid_312173 = remnant_324069;\n    int64_t remnant_324070 = remnant_324069 - gtid_312173;\n    \n    if (slt64(gtid_312172, partition_sizze_292766) && slt64(gtid_312173,\n                                                            n_292675)) {\n        int64_t slice_317597 = n_p_292677 + gtid_312173;\n        double x_312175;\n        \n        x_312175 = ((__global double *) mem_319504)[gtid_312172 * C_len_292823 +\n                                                    slice_317597];\n        \n        double x_312176;\n        \n        x_312176 = ((__global double *) ext_mem_319764)[gtid_312172 *\n                                                        ext_",
            "319765 +\n                                                        gtid_312173];\n        \n        double defunc_1_f_res_312177 = x_312175 - x_312176;\n        \n        ((__global double *) mem_319770)[gtid_312172 * n_292675 + gtid_312173] =\n            defunc_1_f_res_312177;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_312169\n}\n__kernel void mainzisegmap_312372(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_319770, __global\n                                  unsigned char *mem_319779)\n{\n    #define segmap_group_sizze_312367 (mainzisegmap_group_sizze_312339)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324071;\n    int32_t local_tid_324072;\n    int64_t group_sizze_324075;\n    int32_t wave_sizze_324074;\n    int32_t group_tid_324073;\n    \n    global_tid_324071 = get_global_id(0);\n    local_tid_324072 = get_local_id(0);\n    group_sizze_324075 = get_local_size(0);\n    wave_sizze_324074 = LOCKSTEP_WIDTH;\n    group_tid_324073 = get_group_id(0);\n    \n    int32_t phys_tid_312372 = global_tid_324071;\n    int64_t global_tid_324076 = sext_i32_i64(group_tid_324073) *\n            segmap_group_sizze_312367 + sext_i32_i64(local_tid_324072);\n    int64_t slice_324077 = n_292675;\n    int64_t slice_324078 = partition_sizze_292766 * slice_324077;\n    int64_t gtid_312370 = squot64(global_tid_324076, slice_324077);\n    int64_t remnant_324079 = global_tid_324076 - gtid_312370 * slice_324077;\n    int64_t gtid_312371 = remnant_324079;\n    int64_t remnant_324080 = remnant_324079 - gtid_312371;\n    \n    if (slt64(gtid_312370, partition_sizze_292766) && slt64(gtid_312371,\n                                                      ",
            "      n_292675)) {\n        float x_312373;\n        \n        x_312373 = ((__global float *) mem_318506)[gtid_312370 * n_292675 +\n                                                   gtid_312371];\n        \n        double x_312374;\n        \n        x_312374 = ((__global double *) mem_319770)[gtid_312370 * n_292675 +\n                                                    gtid_312371];\n        \n        double f32_res_312375 = fpconv_f32_f64(x_312373);\n        double defunc_1_f_res_312376 = f32_res_312375 - x_312374;\n        \n        ((__global double *) mem_319779)[gtid_312370 * n_292675 + gtid_312371] =\n            defunc_1_f_res_312376;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_312367\n}\n__kernel void mainzisegmap_312390(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n                                  int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_param_318838, __global\n                                  unsigned char *mem_319779, __global\n                                  unsigned char *mem_319784, __global\n                                  unsigned char *mem_319788)\n{\n    #define segmap_group_sizze_312384 (mainzisegmap_group_sizze_312283)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324081;\n    int32_t local_tid_324082;\n    int64_t group_sizze_324085;\n    int32_t wave_sizze_324084;\n    int32_t group_tid_324083;\n    \n    global_tid_324081 = get_global_id(0",
            ");\n    local_tid_324082 = get_local_id(0);\n    group_sizze_324085 = get_local_size(0);\n    wave_sizze_324084 = LOCKSTEP_WIDTH;\n    group_tid_324083 = get_group_id(0);\n    \n    int32_t phys_tid_312390 = global_tid_324081;\n    int64_t global_tid_324086 = sext_i32_i64(group_tid_324083) *\n            segmap_group_sizze_312384 + sext_i32_i64(local_tid_324082);\n    int64_t slice_324087 = n_292675;\n    int64_t slice_324088 = partition_sizze_292766 * slice_324087;\n    int64_t gtid_312388 = squot64(global_tid_324086, slice_324087);\n    int64_t remnant_324089 = global_tid_324086 - gtid_312388 * slice_324087;\n    int64_t gtid_312389 = remnant_324089;\n    int64_t remnant_324090 = remnant_324089 - gtid_312389;\n    \n    if (slt64(gtid_312388, partition_sizze_292766) && slt64(gtid_312389,\n                                                            n_292675)) {\n        int64_t x_312393;\n        \n        x_312393 = ((__global int64_t *) ext_mem_318542)[gtid_312388 *\n                                                         n_292675 +\n                                                         gtid_312389];\n        \n        bool cond_312394 = sle64((int64_t) 0, x_312393);\n        double defunc_0_f_res_312395;\n        \n        if (cond_312394) {\n            bool y_312396 = slt64(x_312393, n_292675);\n            bool bounds_check_312397 = cond_312394 && y_312396;\n            bool index_certs_312398;\n            \n            if (!bounds_check_312397) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 52) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_312393;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_312399;\n            \n            defunc_0_f_res_t_res_312399 = ((__global\n                                            double",
            " *) mem_319779)[gtid_312388 *\n                                                                  n_292675 +\n                                                                  x_312393];\n            defunc_0_f_res_312395 = defunc_0_f_res_t_res_312399;\n        } else {\n            defunc_0_f_res_312395 = 0.0;\n        }\n        \n        double defunc_0_f_res_312400;\n        \n        if (cond_312394) {\n            bool y_312401 = slt64(x_312393, n_292675);\n            bool bounds_check_312402 = cond_312394 && y_312401;\n            bool index_certs_312403;\n            \n            if (!bounds_check_312402) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 53) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_312393;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_312404;\n            \n            defunc_0_f_res_t_res_312404 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_312388 *\n                                                                         ctx_param_ext_318834 +\n                                                                         x_312393 *\n                                                                         ctx_param_ext_318836)];\n            defunc_0_f_res_312400 = defunc_0_f_res_t_res_312404;\n        } else {\n            defunc_0_f_res_312400 = 0.0;\n        }\n        ((__global double *) mem_319784)[gtid_312388 * n_292675 + gtid_312389] =\n            defunc_0_f_res_312400;\n        ((__global double *) mem_319788)[gtid_312388 * n_292675 + gtid_312389] =\n            defunc_0_f_res_312395;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_31238",
            "4\n}\n__kernel void mainzisegmap_312414(__global int *global_failure,\n                                  int64_t n_292675, int64_t q_t_292679,\n                                  int64_t jump_t_292685,\n                                  int64_t partition_sizze_292766,\n                                  int64_t t_n_m_292839, int64_t i_292846,\n                                  __global unsigned char *ext_mem_318541,\n                                  __global unsigned char *ext_mem_318542,\n                                  __global unsigned char *ext_mem_318805,\n                                  __global unsigned char *ext_mem_318806,\n                                  __global unsigned char *mem_319784, __global\n                                  unsigned char *mem_319788, __global\n                                  unsigned char *mem_319793)\n{\n    #define segmap_group_sizze_312409 (mainzisegmap_group_sizze_312186)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324091;\n    int32_t local_tid_324092;\n    int64_t group_sizze_324095;\n    int32_t wave_sizze_324094;\n    int32_t group_tid_324093;\n    \n    global_tid_324091 = get_global_id(0);\n    local_tid_324092 = get_local_id(0);\n    group_sizze_324095 = get_local_size(0);\n    wave_sizze_324094 = LOCKSTEP_WIDTH;\n    group_tid_324093 = get_group_id(0);\n    \n    int32_t phys_tid_312414 = global_tid_324091;\n    int64_t global_tid_324096 = sext_i32_i64(group_tid_324093) *\n            segmap_group_sizze_312409 + sext_i32_i64(local_tid_324092);\n    int64_t slice_324097 = t_n_m_292839;\n    int64_t slice_324098 = partition_sizze_292766 * slice_324097;\n    int64_t gtid_312412 = squot64(global_tid_324096, slice_324097);\n    int64_t remnant_324099 = global_tid_324096 - gtid_312412 * slice_324097;\n    int64_t gtid_312413 = remnant_324099;\n    int64_t remnant_324100 = remnant_324099 - gtid_312413;\n    \n    if (slt64(gtid",
            "_312412, partition_sizze_292766) && slt64(gtid_312413,\n                                                            t_n_m_292839)) {\n        int64_t x_312416;\n        \n        x_312416 = ((__global int64_t *) ext_mem_318541)[gtid_312412];\n        \n        int64_t x_312420;\n        \n        x_312420 = ((__global int64_t *) ext_mem_318806)[gtid_312412 *\n                                                         t_n_m_292839 +\n                                                         gtid_312413];\n        \n        double x_312421;\n        \n        x_312421 = ((__global double *) ext_mem_318805)[gtid_312412 *\n                                                        t_n_m_292839 +\n                                                        gtid_312413];\n        \n        int64_t min_arg_312422 = mul64(jump_t_292685, gtid_312413);\n        int64_t min_res_312423 = smin64(i_292846, min_arg_312422);\n        int64_t defunc_0_g_res_312424 = add64((int64_t) 1, min_res_312423);\n        double defunc_2_reduce_res_312425;\n        double redout_317523 = 0.0;\n        \n        for (int64_t i_317524 = 0; i_317524 < q_t_292679; i_317524++) {\n            bool cond_312430 = sle64(x_312416, i_317524);\n            int64_t defunc_0_f_res_312431;\n            \n            if (cond_312430) {\n                defunc_0_f_res_312431 = (int64_t) 0;\n            } else {\n                int64_t i_312432 = add64(x_312420, i_317524);\n                int64_t defunc_0_add_arg_312433;\n                \n                defunc_0_add_arg_312433 = ((__global\n                                            int64_t *) ext_mem_318542)[gtid_312412 *\n                                                                       n_292675 +\n                                                                       i_312432];\n                \n                int64_t defunc_1_add_res_312434 = add64((int64_t) 1,\n                                                        defunc_0_add_arg_312433);\n                \n                defunc_0_f_res_31243",
            "1 = defunc_1_add_res_312434;\n            }\n            \n            double defunc_0_f_res_312435;\n            \n            if (cond_312430) {\n                defunc_0_f_res_312435 = 0.0;\n            } else {\n                int64_t i_312436 = add64(x_312420, i_317524);\n                double defunc_0_add_arg_312437;\n                \n                defunc_0_add_arg_312437 = ((__global\n                                            double *) mem_319784)[gtid_312412 *\n                                                                  n_292675 +\n                                                                  i_312436];\n                defunc_0_f_res_312435 = defunc_0_add_arg_312437;\n            }\n            \n            int64_t binop_p_312438 = sub64(defunc_0_f_res_312431,\n                                           defunc_0_g_res_312424);\n            double defunc_0_f_res_312439 = sitofp_i64_f64(binop_p_312438);\n            double abs_res_312440 = fabs(defunc_0_f_res_312439);\n            double tmp1_312441 = abs_res_312440 / x_312421;\n            double x_312442 = tmp1_312441 * tmp1_312441;\n            double y_312443 = tmp1_312441 * x_312442;\n            double tmp2_312444 = 1.0 - y_312443;\n            double x_312445 = tmp2_312444 * tmp2_312444;\n            double tmp3_312446 = tmp2_312444 * x_312445;\n            double w_j_312447 = defunc_0_f_res_312435 * tmp3_312446;\n            double defunc_1_op_res_312428 = w_j_312447 + redout_317523;\n            double redout_tmp_324101 = defunc_1_op_res_312428;\n            \n            redout_317523 = redout_tmp_324101;\n        }\n        defunc_2_reduce_res_312425 = redout_317523;\n        \n        double a_312448 = 2.220446049250313e-16 + defunc_2_reduce_res_312425;\n        double a0_312449 = 1.0 / a_312448;\n        double defunc_2_reduce_res_312450;\n        double redout_317525 = 0.0;\n        \n        for (int64_t i_317526 = 0; i_317526 < q_t_292679; i_317526++) {\n            bool cond_312455 = sle64(x_312416, i_317526);\n     ",
            "       int64_t defunc_0_f_res_312456;\n            \n            if (cond_312455) {\n                defunc_0_f_res_312456 = (int64_t) 0;\n            } else {\n                int64_t i_312457 = add64(x_312420, i_317526);\n                int64_t defunc_0_add_arg_312458;\n                \n                defunc_0_add_arg_312458 = ((__global\n                                            int64_t *) ext_mem_318542)[gtid_312412 *\n                                                                       n_292675 +\n                                                                       i_312457];\n                \n                int64_t defunc_1_add_res_312459 = add64((int64_t) 1,\n                                                        defunc_0_add_arg_312458);\n                \n                defunc_0_f_res_312456 = defunc_1_add_res_312459;\n            }\n            \n            double defunc_0_f_res_312460;\n            \n            if (cond_312455) {\n                defunc_0_f_res_312460 = 0.0;\n            } else {\n                int64_t i_312461 = add64(x_312420, i_317526);\n                double defunc_0_add_arg_312462;\n                \n                defunc_0_add_arg_312462 = ((__global\n                                            double *) mem_319784)[gtid_312412 *\n                                                                  n_292675 +\n                                                                  i_312461];\n                defunc_0_f_res_312460 = defunc_0_add_arg_312462;\n            }\n            \n            int64_t binop_p_312463 = sub64(defunc_0_f_res_312456,\n                                           defunc_0_g_res_312424);\n            double defunc_0_f_res_312464 = sitofp_i64_f64(binop_p_312463);\n            double abs_res_312465 = fabs(defunc_0_f_res_312464);\n            double tmp1_312466 = abs_res_312465 / x_312421;\n            double x_312467 = tmp1_312466 * tmp1_312466;\n            double y_312468 = tmp1_312466 * x_312467;\n            double tmp2_312469 = 1.",
            "0 - y_312468;\n            double x_312470 = tmp2_312469 * tmp2_312469;\n            double tmp3_312471 = tmp2_312469 * x_312470;\n            double tmp4_312472 = defunc_0_f_res_312460 * tmp3_312471;\n            double defunc_0_f_res_312473;\n            \n            if (cond_312455) {\n                defunc_0_f_res_312473 = 0.0;\n            } else {\n                int64_t i_312474 = add64(x_312420, i_317526);\n                double defunc_0_add_arg_312475;\n                \n                defunc_0_add_arg_312475 = ((__global\n                                            double *) mem_319788)[gtid_312412 *\n                                                                  n_292675 +\n                                                                  i_312474];\n                defunc_0_f_res_312473 = defunc_0_add_arg_312475;\n            }\n            \n            double x_312476 = a0_312449 * tmp4_312472;\n            double defunc_9_fit_fun_res_312477 = defunc_0_f_res_312473 *\n                   x_312476;\n            double defunc_1_op_res_312453 = defunc_9_fit_fun_res_312477 +\n                   redout_317525;\n            double redout_tmp_324102 = defunc_1_op_res_312453;\n            \n            redout_317525 = redout_tmp_324102;\n        }\n        defunc_2_reduce_res_312450 = redout_317525;\n        ((__global double *) mem_319793)[gtid_312412 * t_n_m_292839 +\n                                         gtid_312413] =\n            defunc_2_reduce_res_312450;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_312409\n}\n__kernel void mainzisegmap_312703(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_319770, __global\n                                  unsigned char *mem_319798)\n{\n    #define segmap_group_sizze_312698 (mainzisegmap_group_siz",
            "ze_312670)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324103;\n    int32_t local_tid_324104;\n    int64_t group_sizze_324107;\n    int32_t wave_sizze_324106;\n    int32_t group_tid_324105;\n    \n    global_tid_324103 = get_global_id(0);\n    local_tid_324104 = get_local_id(0);\n    group_sizze_324107 = get_local_size(0);\n    wave_sizze_324106 = LOCKSTEP_WIDTH;\n    group_tid_324105 = get_group_id(0);\n    \n    int32_t phys_tid_312703 = global_tid_324103;\n    int64_t global_tid_324108 = sext_i32_i64(group_tid_324105) *\n            segmap_group_sizze_312698 + sext_i32_i64(local_tid_324104);\n    int64_t slice_324109 = n_292675;\n    int64_t slice_324110 = partition_sizze_292766 * slice_324109;\n    int64_t gtid_312701 = squot64(global_tid_324108, slice_324109);\n    int64_t remnant_324111 = global_tid_324108 - gtid_312701 * slice_324109;\n    int64_t gtid_312702 = remnant_324111;\n    int64_t remnant_324112 = remnant_324111 - gtid_312702;\n    \n    if (slt64(gtid_312701, partition_sizze_292766) && slt64(gtid_312702,\n                                                            n_292675)) {\n        float x_312704;\n        \n        x_312704 = ((__global float *) mem_318506)[gtid_312701 * n_292675 +\n                                                   gtid_312702];\n        \n        double x_312705;\n        \n        x_312705 = ((__global double *) mem_319770)[gtid_312701 * n_292675 +\n                                                    gtid_312702];\n        \n        double f32_res_312706 = fpconv_f32_f64(x_312704);\n        double defunc_1_f_res_312707 = f32_res_312706 - x_312705;\n        \n        ((__global double *) mem_319798)[gtid_312701 * n_292675 + gtid_312702] =\n            defunc_1_f_res_312707;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_312698\n}\n__kernel void mainzisegmap_312721(__global int *global_failure,\n                           ",
            "       int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n                                  int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_param_318838, __global\n                                  unsigned char *mem_319798, __global\n                                  unsigned char *mem_319803, __global\n                                  unsigned char *mem_319807)\n{\n    #define segmap_group_sizze_312715 (mainzisegmap_group_sizze_312614)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324113;\n    int32_t local_tid_324114;\n    int64_t group_sizze_324117;\n    int32_t wave_sizze_324116;\n    int32_t group_tid_324115;\n    \n    global_tid_324113 = get_global_id(0);\n    local_tid_324114 = get_local_id(0);\n    group_sizze_324117 = get_local_size(0);\n    wave_sizze_324116 = LOCKSTEP_WIDTH;\n    group_tid_324115 = get_group_id(0);\n    \n    int32_t phys_tid_312721 = global_tid_324113;\n    int64_t global_tid_324118 = sext_i32_i64(group_tid_324115) *\n            segmap_group_sizze_312715 + sext_i32_i64(local_tid_324114);\n    int64_t slice_324119 = n_292675;\n    int64_t slice_324120 = partition_sizze_292766 * slice_324119;\n    int64_t gtid_312719 = squot64(global_tid_324118, slice_324119);\n    int64_t remnant_324121 = global_tid_324118 - gtid_312719 * slice_324119;\n    int64_t gtid_312720 = remnant_324121;\n    int64_t remnant_324122 = remnant_324121 - gtid_312720;\n    \n    if (slt64(gtid_312719, partition_sizze_292766) && slt64(gtid_312720,\n                ",
            "                                            n_292675)) {\n        int64_t x_312724;\n        \n        x_312724 = ((__global int64_t *) ext_mem_318542)[gtid_312719 *\n                                                         n_292675 +\n                                                         gtid_312720];\n        \n        bool cond_312725 = sle64((int64_t) 0, x_312724);\n        double defunc_0_f_res_312726;\n        \n        if (cond_312725) {\n            bool y_312727 = slt64(x_312724, n_292675);\n            bool bounds_check_312728 = cond_312725 && y_312727;\n            bool index_certs_312729;\n            \n            if (!bounds_check_312728) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 54) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_312724;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_312730;\n            \n            defunc_0_f_res_t_res_312730 = ((__global\n                                            double *) mem_319798)[gtid_312719 *\n                                                                  n_292675 +\n                                                                  x_312724];\n            defunc_0_f_res_312726 = defunc_0_f_res_t_res_312730;\n        } else {\n            defunc_0_f_res_312726 = 0.0;\n        }\n        \n        double defunc_0_f_res_312731;\n        \n        if (cond_312725) {\n            bool y_312732 = slt64(x_312724, n_292675);\n            bool bounds_check_312733 = cond_312725 && y_312732;\n            bool index_certs_312734;\n            \n            if (!bounds_check_312733) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 55) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_312724",
            ";\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_312735;\n            \n            defunc_0_f_res_t_res_312735 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_312719 *\n                                                                         ctx_param_ext_318834 +\n                                                                         x_312724 *\n                                                                         ctx_param_ext_318836)];\n            defunc_0_f_res_312731 = defunc_0_f_res_t_res_312735;\n        } else {\n            defunc_0_f_res_312731 = 0.0;\n        }\n        ((__global double *) mem_319803)[gtid_312719 * n_292675 + gtid_312720] =\n            defunc_0_f_res_312731;\n        ((__global double *) mem_319807)[gtid_312719 * n_292675 + gtid_312720] =\n            defunc_0_f_res_312726;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_312715\n}\n__kernel void mainzisegmap_312746(__global int *global_failure,\n                                  int64_t n_292675, int64_t q_t_292679,\n                                  int64_t jump_t_292685,\n                                  int64_t partition_sizze_292766,\n                                  int64_t t_n_m_292839, int64_t i_292846,\n                                  __global unsigned char *ext_mem_318541,\n                                  __global unsigned char *ext_mem_318542,\n                                  __global unsigned char *ext_mem_318805,\n                                  __global unsigned char *ext_mem_318806,\n                                  __global unsigned char *mem_319803, __global\n                                  unsigned char *mem_319807, __global\n                   ",
            "               unsigned char *mem_319812, __global\n                                  unsigned char *mem_319816)\n{\n    #define segmap_group_sizze_312740 (mainzisegmap_group_sizze_312486)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324123;\n    int32_t local_tid_324124;\n    int64_t group_sizze_324127;\n    int32_t wave_sizze_324126;\n    int32_t group_tid_324125;\n    \n    global_tid_324123 = get_global_id(0);\n    local_tid_324124 = get_local_id(0);\n    group_sizze_324127 = get_local_size(0);\n    wave_sizze_324126 = LOCKSTEP_WIDTH;\n    group_tid_324125 = get_group_id(0);\n    \n    int32_t phys_tid_312746 = global_tid_324123;\n    int64_t global_tid_324128 = sext_i32_i64(group_tid_324125) *\n            segmap_group_sizze_312740 + sext_i32_i64(local_tid_324124);\n    int64_t slice_324129 = t_n_m_292839;\n    int64_t slice_324130 = partition_sizze_292766 * slice_324129;\n    int64_t gtid_312744 = squot64(global_tid_324128, slice_324129);\n    int64_t remnant_324131 = global_tid_324128 - gtid_312744 * slice_324129;\n    int64_t gtid_312745 = remnant_324131;\n    int64_t remnant_324132 = remnant_324131 - gtid_312745;\n    \n    if (slt64(gtid_312744, partition_sizze_292766) && slt64(gtid_312745,\n                                                            t_n_m_292839)) {\n        int64_t x_312748;\n        \n        x_312748 = ((__global int64_t *) ext_mem_318541)[gtid_312744];\n        \n        int64_t x_312752;\n        \n        x_312752 = ((__global int64_t *) ext_mem_318806)[gtid_312744 *\n                                                         t_n_m_292839 +\n                                                         gtid_312745];\n        \n        double x_312753;\n        \n        x_312753 = ((__global double *) ext_mem_318805)[gtid_312744 *\n                                                        t_n_m_292839 +\n                                                   ",
            "     gtid_312745];\n        \n        int64_t min_arg_312754 = mul64(jump_t_292685, gtid_312745);\n        int64_t min_res_312755 = smin64(i_292846, min_arg_312754);\n        int64_t defunc_0_g_res_312756 = add64((int64_t) 1, min_res_312755);\n        double defunc_2_reduce_res_312757;\n        double defunc_2_reduce_res_312758;\n        double defunc_2_reduce_res_312759;\n        double redout_317533;\n        double redout_317534;\n        double redout_317535;\n        \n        redout_317533 = 0.0;\n        redout_317534 = 0.0;\n        redout_317535 = 0.0;\n        for (int64_t i_317536 = 0; i_317536 < q_t_292679; i_317536++) {\n            bool cond_312770 = sle64(x_312748, i_317536);\n            int64_t defunc_0_f_res_312771;\n            \n            if (cond_312770) {\n                defunc_0_f_res_312771 = (int64_t) 0;\n            } else {\n                int64_t i_312772 = add64(x_312752, i_317536);\n                int64_t defunc_0_add_arg_312773;\n                \n                defunc_0_add_arg_312773 = ((__global\n                                            int64_t *) ext_mem_318542)[gtid_312744 *\n                                                                       n_292675 +\n                                                                       i_312772];\n                \n                int64_t defunc_1_add_res_312774 = add64((int64_t) 1,\n                                                        defunc_0_add_arg_312773);\n                \n                defunc_0_f_res_312771 = defunc_1_add_res_312774;\n            }\n            \n            double defunc_0_f_res_312775;\n            \n            if (cond_312770) {\n                defunc_0_f_res_312775 = 0.0;\n            } else {\n                int64_t i_312776 = add64(x_312752, i_317536);\n                double defunc_0_add_arg_312777;\n                \n                defunc_0_add_arg_312777 = ((__global\n                                            double *) mem_319803)[gtid_312744 *\n                                    ",
            "                              n_292675 +\n                                                                  i_312776];\n                defunc_0_f_res_312775 = defunc_0_add_arg_312777;\n            }\n            \n            int64_t binop_p_312778 = sub64(defunc_0_f_res_312771,\n                                           defunc_0_g_res_312756);\n            double defunc_0_f_res_312779 = sitofp_i64_f64(binop_p_312778);\n            double abs_res_312780 = fabs(defunc_0_f_res_312779);\n            double tmp1_312781 = abs_res_312780 / x_312753;\n            double x_312782 = tmp1_312781 * tmp1_312781;\n            double y_312783 = tmp1_312781 * x_312782;\n            double tmp2_312784 = 1.0 - y_312783;\n            double x_312785 = tmp2_312784 * tmp2_312784;\n            double tmp3_312786 = tmp2_312784 * x_312785;\n            double w_j_312787 = defunc_0_f_res_312775 * tmp3_312786;\n            double xw_j_312788 = defunc_0_f_res_312779 * w_j_312787;\n            double x2w_j_312789 = defunc_0_f_res_312779 * xw_j_312788;\n            double defunc_1_op_res_312762 = w_j_312787 + redout_317533;\n            double defunc_1_op_res_312765 = xw_j_312788 + redout_317534;\n            double defunc_1_op_res_312768 = x2w_j_312789 + redout_317535;\n            double redout_tmp_324133 = defunc_1_op_res_312762;\n            double redout_tmp_324134 = defunc_1_op_res_312765;\n            double redout_tmp_324135 = defunc_1_op_res_312768;\n            \n            redout_317533 = redout_tmp_324133;\n            redout_317534 = redout_tmp_324134;\n            redout_317535 = redout_tmp_324135;\n        }\n        defunc_2_reduce_res_312757 = redout_317533;\n        defunc_2_reduce_res_312758 = redout_317534;\n        defunc_2_reduce_res_312759 = redout_317535;\n        \n        double a_312790 = 2.220446049250313e-16 + defunc_2_reduce_res_312757;\n        double b_312791 = 2.220446049250313e-16 + defunc_2_reduce_res_312758;\n        double c_312792 = 2.220446049250313e-16 + defunc_2_reduce_res_312759;\n   ",
            "     double x_312793 = a_312790 * c_312792;\n        double y_312794 = b_312791 * b_312791;\n        double y_312795 = x_312793 - y_312794;\n        double det1_312796 = 1.0 / y_312795;\n        double a11_312797 = c_312792 * det1_312796;\n        double x_312798 = 0.0 - b_312791;\n        double b11_312799 = det1_312796 * x_312798;\n        double c11_312800 = a_312790 * det1_312796;\n        double defunc_2_reduce_res_312801;\n        double defunc_2_reduce_res_312802;\n        double redout_317537;\n        double redout_317538;\n        \n        redout_317537 = 0.0;\n        redout_317538 = 0.0;\n        for (int64_t i_317539 = 0; i_317539 < q_t_292679; i_317539++) {\n            bool cond_312810 = sle64(x_312748, i_317539);\n            int64_t defunc_0_f_res_312811;\n            \n            if (cond_312810) {\n                defunc_0_f_res_312811 = (int64_t) 0;\n            } else {\n                int64_t i_312812 = add64(x_312752, i_317539);\n                int64_t defunc_0_add_arg_312813;\n                \n                defunc_0_add_arg_312813 = ((__global\n                                            int64_t *) ext_mem_318542)[gtid_312744 *\n                                                                       n_292675 +\n                                                                       i_312812];\n                \n                int64_t defunc_1_add_res_312814 = add64((int64_t) 1,\n                                                        defunc_0_add_arg_312813);\n                \n                defunc_0_f_res_312811 = defunc_1_add_res_312814;\n            }\n            \n            double defunc_0_f_res_312815;\n            \n            if (cond_312810) {\n                defunc_0_f_res_312815 = 0.0;\n            } else {\n                int64_t i_312816 = add64(x_312752, i_317539);\n                double defunc_0_add_arg_312817;\n                \n                defunc_0_add_arg_312817 = ((__global\n                                            double *) mem_319803)[gtid_31274",
            "4 *\n                                                                  n_292675 +\n                                                                  i_312816];\n                defunc_0_f_res_312815 = defunc_0_add_arg_312817;\n            }\n            \n            int64_t binop_p_312818 = sub64(defunc_0_f_res_312811,\n                                           defunc_0_g_res_312756);\n            double defunc_0_f_res_312819 = sitofp_i64_f64(binop_p_312818);\n            double abs_res_312820 = fabs(defunc_0_f_res_312819);\n            double tmp1_312821 = abs_res_312820 / x_312753;\n            double x_312822 = tmp1_312821 * tmp1_312821;\n            double y_312823 = tmp1_312821 * x_312822;\n            double tmp2_312824 = 1.0 - y_312823;\n            double x_312825 = tmp2_312824 * tmp2_312824;\n            double tmp3_312826 = tmp2_312824 * x_312825;\n            double tmp4_312827 = defunc_0_f_res_312815 * tmp3_312826;\n            double defunc_1_f_res_312828 = defunc_0_f_res_312819 * tmp4_312827;\n            double defunc_0_f_res_312829;\n            \n            if (cond_312810) {\n                defunc_0_f_res_312829 = 0.0;\n            } else {\n                int64_t i_312830 = add64(x_312752, i_317539);\n                double defunc_0_add_arg_312831;\n                \n                defunc_0_add_arg_312831 = ((__global\n                                            double *) mem_319807)[gtid_312744 *\n                                                                  n_292675 +\n                                                                  i_312830];\n                defunc_0_f_res_312829 = defunc_0_add_arg_312831;\n            }\n            \n            double x_312832 = a11_312797 * tmp4_312827;\n            double y_312833 = b11_312799 * defunc_1_f_res_312828;\n            double x_312834 = x_312832 + y_312833;\n            double defunc_9_fit_fun_res_312835 = defunc_0_f_res_312829 *\n                   x_312834;\n            double x_312836 = b11_312799 * tmp4_312827;\n    ",
            "        double y_312837 = c11_312800 * defunc_1_f_res_312828;\n            double x_312838 = x_312836 + y_312837;\n            double defunc_9_slope_fun_res_312839 = defunc_0_f_res_312829 *\n                   x_312838;\n            double defunc_1_op_res_312805 = defunc_9_fit_fun_res_312835 +\n                   redout_317537;\n            double defunc_1_op_res_312808 = defunc_9_slope_fun_res_312839 +\n                   redout_317538;\n            double redout_tmp_324136 = defunc_1_op_res_312805;\n            double redout_tmp_324137 = defunc_1_op_res_312808;\n            \n            redout_317537 = redout_tmp_324136;\n            redout_317538 = redout_tmp_324137;\n        }\n        defunc_2_reduce_res_312801 = redout_317537;\n        defunc_2_reduce_res_312802 = redout_317538;\n        ((__global double *) mem_319812)[gtid_312744 * t_n_m_292839 +\n                                         gtid_312745] =\n            defunc_2_reduce_res_312801;\n        ((__global double *) mem_319816)[gtid_312744 * t_n_m_292839 +\n                                         gtid_312745] =\n            defunc_2_reduce_res_312802;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_312740\n}\n__kernel void mainzisegmap_313100(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_319770, __global\n                                  unsigned char *mem_319821)\n{\n    #define segmap_group_sizze_313095 (mainzisegmap_group_sizze_313067)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324138;\n    int32_t local_tid_324139;\n    int64_t group_sizze_324142;\n    int32_t wave_sizze_324141;\n    int32_t group_tid_324140;\n    \n    global_tid_324138 = get_global_id",
            "(0);\n    local_tid_324139 = get_local_id(0);\n    group_sizze_324142 = get_local_size(0);\n    wave_sizze_324141 = LOCKSTEP_WIDTH;\n    group_tid_324140 = get_group_id(0);\n    \n    int32_t phys_tid_313100 = global_tid_324138;\n    int64_t global_tid_324143 = sext_i32_i64(group_tid_324140) *\n            segmap_group_sizze_313095 + sext_i32_i64(local_tid_324139);\n    int64_t slice_324144 = n_292675;\n    int64_t slice_324145 = partition_sizze_292766 * slice_324144;\n    int64_t gtid_313098 = squot64(global_tid_324143, slice_324144);\n    int64_t remnant_324146 = global_tid_324143 - gtid_313098 * slice_324144;\n    int64_t gtid_313099 = remnant_324146;\n    int64_t remnant_324147 = remnant_324146 - gtid_313099;\n    \n    if (slt64(gtid_313098, partition_sizze_292766) && slt64(gtid_313099,\n                                                            n_292675)) {\n        float x_313101;\n        \n        x_313101 = ((__global float *) mem_318506)[gtid_313098 * n_292675 +\n                                                   gtid_313099];\n        \n        double x_313102;\n        \n        x_313102 = ((__global double *) mem_319770)[gtid_313098 * n_292675 +\n                                                    gtid_313099];\n        \n        double f32_res_313103 = fpconv_f32_f64(x_313101);\n        double defunc_1_f_res_313104 = f32_res_313103 - x_313102;\n        \n        ((__global double *) mem_319821)[gtid_313098 * n_292675 + gtid_313099] =\n            defunc_1_f_res_313104;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_313095\n}\n__kernel void mainzisegmap_313118(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n      ",
            "                            int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_param_318838, __global\n                                  unsigned char *mem_319821, __global\n                                  unsigned char *mem_319826, __global\n                                  unsigned char *mem_319830)\n{\n    #define segmap_group_sizze_313112 (mainzisegmap_group_sizze_313011)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324148;\n    int32_t local_tid_324149;\n    int64_t group_sizze_324152;\n    int32_t wave_sizze_324151;\n    int32_t group_tid_324150;\n    \n    global_tid_324148 = get_global_id(0);\n    local_tid_324149 = get_local_id(0);\n    group_sizze_324152 = get_local_size(0);\n    wave_sizze_324151 = LOCKSTEP_WIDTH;\n    group_tid_324150 = get_group_id(0);\n    \n    int32_t phys_tid_313118 = global_tid_324148;\n    int64_t global_tid_324153 = sext_i32_i64(group_tid_324150) *\n            segmap_group_sizze_313112 + sext_i32_i64(local_tid_324149);\n    int64_t slice_324154 = n_292675;\n    int64_t slice_324155 = partition_sizze_292766 * slice_324154;\n    int64_t gtid_313116 = squot64(global_tid_324153, slice_324154);\n    int64_t remnant_324156 = global_tid_324153 - gtid_313116 * slice_324154;\n    int64_t gtid_313117 = remnant_324156;\n    int64_t remnant_324157 = remnant_324156 - gtid_313117;\n    \n    if (slt64(gtid_313116, partition_sizze_292766) && slt64(gtid_313117,\n                                                            n_292675)) {\n        int64_t x_313121;\n        \n        x_313121 = ((__global int64_t *) ext_mem_318542)[gtid_313116 *\n                                                         n_292675 +\n                                                         gtid_313117];\n        \n        bool cond_313122 = sle64((int64_t) 0, x",
            "_313121);\n        double defunc_0_f_res_313123;\n        \n        if (cond_313122) {\n            bool y_313124 = slt64(x_313121, n_292675);\n            bool bounds_check_313125 = cond_313122 && y_313124;\n            bool index_certs_313126;\n            \n            if (!bounds_check_313125) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 56) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_313121;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_313127;\n            \n            defunc_0_f_res_t_res_313127 = ((__global\n                                            double *) mem_319821)[gtid_313116 *\n                                                                  n_292675 +\n                                                                  x_313121];\n            defunc_0_f_res_313123 = defunc_0_f_res_t_res_313127;\n        } else {\n            defunc_0_f_res_313123 = 0.0;\n        }\n        \n        double defunc_0_f_res_313128;\n        \n        if (cond_313122) {\n            bool y_313129 = slt64(x_313121, n_292675);\n            bool bounds_check_313130 = cond_313122 && y_313129;\n            bool index_certs_313131;\n            \n            if (!bounds_check_313130) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 57) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_313121;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_313132;\n            \n            defunc_0_f_res_t_res_313132 = ((__global\n                                            double *",
            ") mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_313116 *\n                                                                         ctx_param_ext_318834 +\n                                                                         x_313121 *\n                                                                         ctx_param_ext_318836)];\n            defunc_0_f_res_313128 = defunc_0_f_res_t_res_313132;\n        } else {\n            defunc_0_f_res_313128 = 0.0;\n        }\n        ((__global double *) mem_319826)[gtid_313116 * n_292675 + gtid_313117] =\n            defunc_0_f_res_313128;\n        ((__global double *) mem_319830)[gtid_313116 * n_292675 + gtid_313117] =\n            defunc_0_f_res_313123;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_313112\n}\n__kernel void mainzisegmap_313143(__global int *global_failure,\n                                  int64_t n_292675, int64_t q_t_292679,\n                                  int64_t jump_t_292685,\n                                  int64_t partition_sizze_292766,\n                                  int64_t t_n_m_292839, int64_t i_292846,\n                                  __global unsigned char *ext_mem_318541,\n                                  __global unsigned char *ext_mem_318542,\n                                  __global unsigned char *ext_mem_318805,\n                                  __global unsigned char *ext_mem_318806,\n                                  __global unsigned char *mem_319826, __global\n                                  unsigned char *mem_319830, __global\n                                  unsigned char *mem_319835, __global\n                                  unsigned char *mem_319839)\n{\n    #define segmap_group_sizze_313137 (mainzisegmap_group_sizze_312849)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_ti",
            "d_324158;\n    int32_t local_tid_324159;\n    int64_t group_sizze_324162;\n    int32_t wave_sizze_324161;\n    int32_t group_tid_324160;\n    \n    global_tid_324158 = get_global_id(0);\n    local_tid_324159 = get_local_id(0);\n    group_sizze_324162 = get_local_size(0);\n    wave_sizze_324161 = LOCKSTEP_WIDTH;\n    group_tid_324160 = get_group_id(0);\n    \n    int32_t phys_tid_313143 = global_tid_324158;\n    int64_t global_tid_324163 = sext_i32_i64(group_tid_324160) *\n            segmap_group_sizze_313137 + sext_i32_i64(local_tid_324159);\n    int64_t slice_324164 = t_n_m_292839;\n    int64_t slice_324165 = partition_sizze_292766 * slice_324164;\n    int64_t gtid_313141 = squot64(global_tid_324163, slice_324164);\n    int64_t remnant_324166 = global_tid_324163 - gtid_313141 * slice_324164;\n    int64_t gtid_313142 = remnant_324166;\n    int64_t remnant_324167 = remnant_324166 - gtid_313142;\n    \n    if (slt64(gtid_313141, partition_sizze_292766) && slt64(gtid_313142,\n                                                            t_n_m_292839)) {\n        int64_t x_313145;\n        \n        x_313145 = ((__global int64_t *) ext_mem_318541)[gtid_313141];\n        \n        int64_t x_313149;\n        \n        x_313149 = ((__global int64_t *) ext_mem_318806)[gtid_313141 *\n                                                         t_n_m_292839 +\n                                                         gtid_313142];\n        \n        double x_313150;\n        \n        x_313150 = ((__global double *) ext_mem_318805)[gtid_313141 *\n                                                        t_n_m_292839 +\n                                                        gtid_313142];\n        \n        int64_t min_arg_313151 = mul64(jump_t_292685, gtid_313142);\n        int64_t min_res_313152 = smin64(i_292846, min_arg_313151);\n        int64_t defunc_0_g_res_313153 = add64((int64_t) 1, min_res_313152);\n        double defunc_2_reduce_res_313154;\n        double defunc_2_reduce_res_313155;\n        double defunc_2_reduce_re",
            "s_313156;\n        double defunc_2_reduce_res_313157;\n        double defunc_2_reduce_res_313158;\n        double redout_317546;\n        double redout_317547;\n        double redout_317548;\n        double redout_317549;\n        double redout_317550;\n        \n        redout_317546 = 0.0;\n        redout_317547 = 0.0;\n        redout_317548 = 0.0;\n        redout_317549 = 0.0;\n        redout_317550 = 0.0;\n        for (int64_t i_317551 = 0; i_317551 < q_t_292679; i_317551++) {\n            bool cond_313175 = sle64(x_313145, i_317551);\n            int64_t defunc_0_f_res_313176;\n            \n            if (cond_313175) {\n                defunc_0_f_res_313176 = (int64_t) 0;\n            } else {\n                int64_t i_313177 = add64(x_313149, i_317551);\n                int64_t defunc_0_add_arg_313178;\n                \n                defunc_0_add_arg_313178 = ((__global\n                                            int64_t *) ext_mem_318542)[gtid_313141 *\n                                                                       n_292675 +\n                                                                       i_313177];\n                \n                int64_t defunc_1_add_res_313179 = add64((int64_t) 1,\n                                                        defunc_0_add_arg_313178);\n                \n                defunc_0_f_res_313176 = defunc_1_add_res_313179;\n            }\n            \n            double defunc_0_f_res_313180;\n            \n            if (cond_313175) {\n                defunc_0_f_res_313180 = 0.0;\n            } else {\n                int64_t i_313181 = add64(x_313149, i_317551);\n                double defunc_0_add_arg_313182;\n                \n                defunc_0_add_arg_313182 = ((__global\n                                            double *) mem_319826)[gtid_313141 *\n                                                                  n_292675 +\n                                                                  i_313181];\n                defunc_0_f_res_31318",
            "0 = defunc_0_add_arg_313182;\n            }\n            \n            int64_t binop_p_313183 = sub64(defunc_0_f_res_313176,\n                                           defunc_0_g_res_313153);\n            double defunc_0_f_res_313184 = sitofp_i64_f64(binop_p_313183);\n            double abs_res_313185 = fabs(defunc_0_f_res_313184);\n            double tmp1_313186 = abs_res_313185 / x_313150;\n            double x_313187 = tmp1_313186 * tmp1_313186;\n            double y_313188 = tmp1_313186 * x_313187;\n            double tmp2_313189 = 1.0 - y_313188;\n            double x_313190 = tmp2_313189 * tmp2_313189;\n            double tmp3_313191 = tmp2_313189 * x_313190;\n            double w_j_313192 = defunc_0_f_res_313180 * tmp3_313191;\n            double xw_j_313193 = defunc_0_f_res_313184 * w_j_313192;\n            double x2w_j_313194 = defunc_0_f_res_313184 * xw_j_313193;\n            double x3w_j_313195 = defunc_0_f_res_313184 * x2w_j_313194;\n            double x4w_j_313196 = defunc_0_f_res_313184 * x3w_j_313195;\n            double defunc_1_op_res_313161 = w_j_313192 + redout_317546;\n            double defunc_1_op_res_313164 = xw_j_313193 + redout_317547;\n            double defunc_1_op_res_313167 = x2w_j_313194 + redout_317548;\n            double defunc_1_op_res_313170 = x3w_j_313195 + redout_317549;\n            double defunc_1_op_res_313173 = x4w_j_313196 + redout_317550;\n            double redout_tmp_324168 = defunc_1_op_res_313161;\n            double redout_tmp_324169 = defunc_1_op_res_313164;\n            double redout_tmp_324170 = defunc_1_op_res_313167;\n            double redout_tmp_324171 = defunc_1_op_res_313170;\n            double redout_tmp_324172 = defunc_1_op_res_313173;\n            \n            redout_317546 = redout_tmp_324168;\n            redout_317547 = redout_tmp_324169;\n            redout_317548 = redout_tmp_324170;\n            redout_317549 = redout_tmp_324171;\n            redout_317550 = redout_tmp_324172;\n        }\n        defunc_2_reduce_res_313154 = redout_",
            "317546;\n        defunc_2_reduce_res_313155 = redout_317547;\n        defunc_2_reduce_res_313156 = redout_317548;\n        defunc_2_reduce_res_313157 = redout_317549;\n        defunc_2_reduce_res_313158 = redout_317550;\n        \n        double a_313197 = 2.220446049250313e-16 + defunc_2_reduce_res_313154;\n        double b_313198 = 2.220446049250313e-16 + defunc_2_reduce_res_313155;\n        double c_313199 = 2.220446049250313e-16 + defunc_2_reduce_res_313156;\n        double d_313200 = 2.220446049250313e-16 + defunc_2_reduce_res_313157;\n        double e_313201 = 2.220446049250313e-16 + defunc_2_reduce_res_313158;\n        double x_313202 = c_313199 * e_313201;\n        double y_313203 = d_313200 * d_313200;\n        double a12_313204 = x_313202 - y_313203;\n        double x_313205 = c_313199 * d_313200;\n        double y_313206 = b_313198 * e_313201;\n        double b12_313207 = x_313205 - y_313206;\n        double x_313208 = b_313198 * d_313200;\n        double y_313209 = c_313199 * c_313199;\n        double c12_313210 = x_313208 - y_313209;\n        double x_313211 = a_313197 * e_313201;\n        double b2_313212 = x_313211 - y_313209;\n        double x_313213 = b_313198 * c_313199;\n        double y_313214 = a_313197 * d_313200;\n        double c2_313215 = x_313213 - y_313214;\n        double x_313216 = a_313197 * a12_313204;\n        double y_313217 = b_313198 * b12_313207;\n        double x_313218 = x_313216 + y_313217;\n        double y_313219 = c_313199 * c12_313210;\n        double y_313220 = x_313218 + y_313219;\n        double det_313221 = 1.0 / y_313220;\n        double a12_313222 = a12_313204 * det_313221;\n        double b12_313223 = b12_313207 * det_313221;\n        double c12_313224 = c12_313210 * det_313221;\n        double b2_313225 = b2_313212 * det_313221;\n        double c2_313226 = c2_313215 * det_313221;\n        double defunc_2_reduce_res_313227;\n        double defunc_2_reduce_res_313228;\n        double redout_317552;\n        double redout_317553;\n        \n        redout_317",
            "552 = 0.0;\n        redout_317553 = 0.0;\n        for (int64_t i_317554 = 0; i_317554 < q_t_292679; i_317554++) {\n            bool cond_313236 = sle64(x_313145, i_317554);\n            int64_t defunc_0_f_res_313237;\n            \n            if (cond_313236) {\n                defunc_0_f_res_313237 = (int64_t) 0;\n            } else {\n                int64_t i_313238 = add64(x_313149, i_317554);\n                int64_t defunc_0_add_arg_313239;\n                \n                defunc_0_add_arg_313239 = ((__global\n                                            int64_t *) ext_mem_318542)[gtid_313141 *\n                                                                       n_292675 +\n                                                                       i_313238];\n                \n                int64_t defunc_1_add_res_313240 = add64((int64_t) 1,\n                                                        defunc_0_add_arg_313239);\n                \n                defunc_0_f_res_313237 = defunc_1_add_res_313240;\n            }\n            \n            double defunc_0_f_res_313241;\n            \n            if (cond_313236) {\n                defunc_0_f_res_313241 = 0.0;\n            } else {\n                int64_t i_313242 = add64(x_313149, i_317554);\n                double defunc_0_add_arg_313243;\n                \n                defunc_0_add_arg_313243 = ((__global\n                                            double *) mem_319826)[gtid_313141 *\n                                                                  n_292675 +\n                                                                  i_313242];\n                defunc_0_f_res_313241 = defunc_0_add_arg_313243;\n            }\n            \n            int64_t binop_p_313244 = sub64(defunc_0_f_res_313237,\n                                           defunc_0_g_res_313153);\n            double defunc_0_f_res_313245 = sitofp_i64_f64(binop_p_313244);\n            double abs_res_313246 = fabs(defunc_0_f_res_313245);\n            double tmp1_313247 ",
            "= abs_res_313246 / x_313150;\n            double x_313248 = tmp1_313247 * tmp1_313247;\n            double y_313249 = tmp1_313247 * x_313248;\n            double tmp2_313250 = 1.0 - y_313249;\n            double x_313251 = tmp2_313250 * tmp2_313250;\n            double tmp3_313252 = tmp2_313250 * x_313251;\n            double tmp4_313253 = defunc_0_f_res_313241 * tmp3_313252;\n            double defunc_1_f_res_313254 = defunc_0_f_res_313245 * tmp4_313253;\n            double defunc_1_f_res_313255 = defunc_0_f_res_313245 *\n                   defunc_1_f_res_313254;\n            double defunc_0_f_res_313256;\n            \n            if (cond_313236) {\n                defunc_0_f_res_313256 = 0.0;\n            } else {\n                int64_t i_313257 = add64(x_313149, i_317554);\n                double defunc_0_add_arg_313258;\n                \n                defunc_0_add_arg_313258 = ((__global\n                                            double *) mem_319830)[gtid_313141 *\n                                                                  n_292675 +\n                                                                  i_313257];\n                defunc_0_f_res_313256 = defunc_0_add_arg_313258;\n            }\n            \n            double x_313259 = a12_313222 * tmp4_313253;\n            double y_313260 = b12_313223 * defunc_1_f_res_313254;\n            double x_313261 = x_313259 + y_313260;\n            double y_313262 = c12_313224 * defunc_1_f_res_313255;\n            double x_313263 = x_313261 + y_313262;\n            double defunc_9_fit_fun_res_313264 = defunc_0_f_res_313256 *\n                   x_313263;\n            double x_313265 = b12_313223 * tmp4_313253;\n            double y_313266 = b2_313225 * defunc_1_f_res_313254;\n            double x_313267 = x_313265 + y_313266;\n            double y_313268 = c2_313226 * defunc_1_f_res_313255;\n            double x_313269 = x_313267 + y_313268;\n            double defunc_9_slope_fun_res_313270 = defunc_0_f_res_313256 *\n                   x_3132",
            "69;\n            double defunc_1_op_res_313231 = defunc_9_fit_fun_res_313264 +\n                   redout_317552;\n            double defunc_1_op_res_313234 = defunc_9_slope_fun_res_313270 +\n                   redout_317553;\n            double redout_tmp_324173 = defunc_1_op_res_313231;\n            double redout_tmp_324174 = defunc_1_op_res_313234;\n            \n            redout_317552 = redout_tmp_324173;\n            redout_317553 = redout_tmp_324174;\n        }\n        defunc_2_reduce_res_313227 = redout_317552;\n        defunc_2_reduce_res_313228 = redout_317553;\n        ((__global double *) mem_319835)[gtid_313141 * t_n_m_292839 +\n                                         gtid_313142] =\n            defunc_2_reduce_res_313227;\n        ((__global double *) mem_319839)[gtid_313141 * t_n_m_292839 +\n                                         gtid_313142] =\n            defunc_2_reduce_res_313228;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_313137\n}\n__kernel void mainzisegmap_313458(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_319770, __global\n                                  unsigned char *mem_319852)\n{\n    #define segmap_group_sizze_313453 (mainzisegmap_group_sizze_313425)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324175;\n    int32_t local_tid_324176;\n    int64_t group_sizze_324179;\n    int32_t wave_sizze_324178;\n    int32_t group_tid_324177;\n    \n    global_tid_324175 = get_global_id(0);\n    local_tid_324176 = get_local_id(0);\n    group_sizze_324179 = get_local_size(0);\n    wave_sizze_324178 = LOCKSTEP_WIDTH;\n    group_tid_324177 = get_group_id(0);\n    \n    int32_t phys_tid_313458 = global_ti",
            "d_324175;\n    int64_t global_tid_324180 = sext_i32_i64(group_tid_324177) *\n            segmap_group_sizze_313453 + sext_i32_i64(local_tid_324176);\n    int64_t slice_324181 = n_292675;\n    int64_t slice_324182 = partition_sizze_292766 * slice_324181;\n    int64_t gtid_313456 = squot64(global_tid_324180, slice_324181);\n    int64_t remnant_324183 = global_tid_324180 - gtid_313456 * slice_324181;\n    int64_t gtid_313457 = remnant_324183;\n    int64_t remnant_324184 = remnant_324183 - gtid_313457;\n    \n    if (slt64(gtid_313456, partition_sizze_292766) && slt64(gtid_313457,\n                                                            n_292675)) {\n        float x_313459;\n        \n        x_313459 = ((__global float *) mem_318506)[gtid_313456 * n_292675 +\n                                                   gtid_313457];\n        \n        double x_313460;\n        \n        x_313460 = ((__global double *) mem_319770)[gtid_313456 * n_292675 +\n                                                    gtid_313457];\n        \n        double f32_res_313461 = fpconv_f32_f64(x_313459);\n        double defunc_1_f_res_313462 = f32_res_313461 - x_313460;\n        \n        ((__global double *) mem_319852)[gtid_313456 * n_292675 + gtid_313457] =\n            defunc_1_f_res_313462;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_313453\n}\n__kernel void mainzisegmap_313476(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n                                  int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_param_318838, __glo",
            "bal\n                                  unsigned char *mem_319852, __global\n                                  unsigned char *mem_319857, __global\n                                  unsigned char *mem_319861)\n{\n    #define segmap_group_sizze_313470 (mainzisegmap_group_sizze_313369)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324185;\n    int32_t local_tid_324186;\n    int64_t group_sizze_324189;\n    int32_t wave_sizze_324188;\n    int32_t group_tid_324187;\n    \n    global_tid_324185 = get_global_id(0);\n    local_tid_324186 = get_local_id(0);\n    group_sizze_324189 = get_local_size(0);\n    wave_sizze_324188 = LOCKSTEP_WIDTH;\n    group_tid_324187 = get_group_id(0);\n    \n    int32_t phys_tid_313476 = global_tid_324185;\n    int64_t global_tid_324190 = sext_i32_i64(group_tid_324187) *\n            segmap_group_sizze_313470 + sext_i32_i64(local_tid_324186);\n    int64_t slice_324191 = n_292675;\n    int64_t slice_324192 = partition_sizze_292766 * slice_324191;\n    int64_t gtid_313474 = squot64(global_tid_324190, slice_324191);\n    int64_t remnant_324193 = global_tid_324190 - gtid_313474 * slice_324191;\n    int64_t gtid_313475 = remnant_324193;\n    int64_t remnant_324194 = remnant_324193 - gtid_313475;\n    \n    if (slt64(gtid_313474, partition_sizze_292766) && slt64(gtid_313475,\n                                                            n_292675)) {\n        int64_t x_313479;\n        \n        x_313479 = ((__global int64_t *) ext_mem_318542)[gtid_313474 *\n                                                         n_292675 +\n                                                         gtid_313475];\n        \n        bool cond_313480 = sle64((int64_t) 0, x_313479);\n        double defunc_0_f_res_313481;\n        \n        if (cond_313480) {\n            bool y_313482 = slt64(x_313479, n_292675);\n            bool bounds_check_313483 = cond_313480 && y_313482;\n          ",
            "  bool index_certs_313484;\n            \n            if (!bounds_check_313483) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 58) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_313479;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_313485;\n            \n            defunc_0_f_res_t_res_313485 = ((__global\n                                            double *) mem_319852)[gtid_313474 *\n                                                                  n_292675 +\n                                                                  x_313479];\n            defunc_0_f_res_313481 = defunc_0_f_res_t_res_313485;\n        } else {\n            defunc_0_f_res_313481 = 0.0;\n        }\n        \n        double defunc_0_f_res_313486;\n        \n        if (cond_313480) {\n            bool y_313487 = slt64(x_313479, n_292675);\n            bool bounds_check_313488 = cond_313480 && y_313487;\n            bool index_certs_313489;\n            \n            if (!bounds_check_313488) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 59) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_313479;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_313490;\n            \n            defunc_0_f_res_t_res_313490 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_313474 *\n                                                                         ctx_param_",
            "ext_318834 +\n                                                                         x_313479 *\n                                                                         ctx_param_ext_318836)];\n            defunc_0_f_res_313486 = defunc_0_f_res_t_res_313490;\n        } else {\n            defunc_0_f_res_313486 = 0.0;\n        }\n        ((__global double *) mem_319857)[gtid_313474 * n_292675 + gtid_313475] =\n            defunc_0_f_res_313486;\n        ((__global double *) mem_319861)[gtid_313474 * n_292675 + gtid_313475] =\n            defunc_0_f_res_313481;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_313470\n}\n__kernel void mainzisegmap_313777(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_319770, __global\n                                  unsigned char *mem_319876)\n{\n    #define segmap_group_sizze_313772 (mainzisegmap_group_sizze_313744)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324216;\n    int32_t local_tid_324217;\n    int64_t group_sizze_324220;\n    int32_t wave_sizze_324219;\n    int32_t group_tid_324218;\n    \n    global_tid_324216 = get_global_id(0);\n    local_tid_324217 = get_local_id(0);\n    group_sizze_324220 = get_local_size(0);\n    wave_sizze_324219 = LOCKSTEP_WIDTH;\n    group_tid_324218 = get_group_id(0);\n    \n    int32_t phys_tid_313777 = global_tid_324216;\n    int64_t global_tid_324221 = sext_i32_i64(group_tid_324218) *\n            segmap_group_sizze_313772 + sext_i32_i64(local_tid_324217);\n    int64_t slice_324222 = n_292675;\n    int64_t slice_324223 = partition_sizze_292766 * slice_324222;\n    int64_t gtid_313775 = squot64(global_tid_324221, slice_324222);\n    int64_t remnant_3242",
            "24 = global_tid_324221 - gtid_313775 * slice_324222;\n    int64_t gtid_313776 = remnant_324224;\n    int64_t remnant_324225 = remnant_324224 - gtid_313776;\n    \n    if (slt64(gtid_313775, partition_sizze_292766) && slt64(gtid_313776,\n                                                            n_292675)) {\n        float x_313778;\n        \n        x_313778 = ((__global float *) mem_318506)[gtid_313775 * n_292675 +\n                                                   gtid_313776];\n        \n        double x_313779;\n        \n        x_313779 = ((__global double *) mem_319770)[gtid_313775 * n_292675 +\n                                                    gtid_313776];\n        \n        double f32_res_313780 = fpconv_f32_f64(x_313778);\n        double defunc_1_f_res_313781 = f32_res_313780 - x_313779;\n        \n        ((__global double *) mem_319876)[gtid_313775 * n_292675 + gtid_313776] =\n            defunc_1_f_res_313781;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_313772\n}\n__kernel void mainzisegmap_313795(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n                                  int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_param_318838, __global\n                                  unsigned char *mem_319876, __global\n                                  unsigned char *mem_319881, __global\n                                  unsigned char *mem_319885)\n{\n    #define segmap_group_sizze_313789 (mainzisegmap_group_sizze_313688)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1",
            ";\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324226;\n    int32_t local_tid_324227;\n    int64_t group_sizze_324230;\n    int32_t wave_sizze_324229;\n    int32_t group_tid_324228;\n    \n    global_tid_324226 = get_global_id(0);\n    local_tid_324227 = get_local_id(0);\n    group_sizze_324230 = get_local_size(0);\n    wave_sizze_324229 = LOCKSTEP_WIDTH;\n    group_tid_324228 = get_group_id(0);\n    \n    int32_t phys_tid_313795 = global_tid_324226;\n    int64_t global_tid_324231 = sext_i32_i64(group_tid_324228) *\n            segmap_group_sizze_313789 + sext_i32_i64(local_tid_324227);\n    int64_t slice_324232 = n_292675;\n    int64_t slice_324233 = partition_sizze_292766 * slice_324232;\n    int64_t gtid_313793 = squot64(global_tid_324231, slice_324232);\n    int64_t remnant_324234 = global_tid_324231 - gtid_313793 * slice_324232;\n    int64_t gtid_313794 = remnant_324234;\n    int64_t remnant_324235 = remnant_324234 - gtid_313794;\n    \n    if (slt64(gtid_313793, partition_sizze_292766) && slt64(gtid_313794,\n                                                            n_292675)) {\n        int64_t x_313798;\n        \n        x_313798 = ((__global int64_t *) ext_mem_318542)[gtid_313793 *\n                                                         n_292675 +\n                                                         gtid_313794];\n        \n        bool cond_313799 = sle64((int64_t) 0, x_313798);\n        double defunc_0_f_res_313800;\n        \n        if (cond_313799) {\n            bool y_313801 = slt64(x_313798, n_292675);\n            bool bounds_check_313802 = cond_313799 && y_313801;\n            bool index_certs_313803;\n            \n            if (!bounds_check_313802) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 60) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_313798;\n                        global_failure_args[1] = (int64_t) n_292675;",
            "\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_313804;\n            \n            defunc_0_f_res_t_res_313804 = ((__global\n                                            double *) mem_319876)[gtid_313793 *\n                                                                  n_292675 +\n                                                                  x_313798];\n            defunc_0_f_res_313800 = defunc_0_f_res_t_res_313804;\n        } else {\n            defunc_0_f_res_313800 = 0.0;\n        }\n        \n        double defunc_0_f_res_313805;\n        \n        if (cond_313799) {\n            bool y_313806 = slt64(x_313798, n_292675);\n            bool bounds_check_313807 = cond_313799 && y_313806;\n            bool index_certs_313808;\n            \n            if (!bounds_check_313807) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 61) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_313798;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_313809;\n            \n            defunc_0_f_res_t_res_313809 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_313793 *\n                                                                         ctx_param_ext_318834 +\n                                                                         x_313798 *\n                                                                         ctx_param_ext_318836)];\n            defunc_0_f_res_313805 = defunc_0_f_res_t_res_313809;\n        } else {\n            defunc_0_f_res_313805 = 0.0;\n        }\n        ((__glo",
            "bal double *) mem_319881)[gtid_313793 * n_292675 + gtid_313794] =\n            defunc_0_f_res_313805;\n        ((__global double *) mem_319885)[gtid_313793 * n_292675 + gtid_313794] =\n            defunc_0_f_res_313800;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_313789\n}\n__kernel void mainzisegmap_314192(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_319770, __global\n                                  unsigned char *mem_319907)\n{\n    #define segmap_group_sizze_314187 (mainzisegmap_group_sizze_314159)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324263;\n    int32_t local_tid_324264;\n    int64_t group_sizze_324267;\n    int32_t wave_sizze_324266;\n    int32_t group_tid_324265;\n    \n    global_tid_324263 = get_global_id(0);\n    local_tid_324264 = get_local_id(0);\n    group_sizze_324267 = get_local_size(0);\n    wave_sizze_324266 = LOCKSTEP_WIDTH;\n    group_tid_324265 = get_group_id(0);\n    \n    int32_t phys_tid_314192 = global_tid_324263;\n    int64_t global_tid_324268 = sext_i32_i64(group_tid_324265) *\n            segmap_group_sizze_314187 + sext_i32_i64(local_tid_324264);\n    int64_t slice_324269 = n_292675;\n    int64_t slice_324270 = partition_sizze_292766 * slice_324269;\n    int64_t gtid_314190 = squot64(global_tid_324268, slice_324269);\n    int64_t remnant_324271 = global_tid_324268 - gtid_314190 * slice_324269;\n    int64_t gtid_314191 = remnant_324271;\n    int64_t remnant_324272 = remnant_324271 - gtid_314191;\n    \n    if (slt64(gtid_314190, partition_sizze_292766) && slt64(gtid_314191,\n                                                            n_292675)) {\n        float x_314193;\n        \n    ",
            "    x_314193 = ((__global float *) mem_318506)[gtid_314190 * n_292675 +\n                                                   gtid_314191];\n        \n        double x_314194;\n        \n        x_314194 = ((__global double *) mem_319770)[gtid_314190 * n_292675 +\n                                                    gtid_314191];\n        \n        double f32_res_314195 = fpconv_f32_f64(x_314193);\n        double defunc_1_f_res_314196 = f32_res_314195 - x_314194;\n        \n        ((__global double *) mem_319907)[gtid_314190 * n_292675 + gtid_314191] =\n            defunc_1_f_res_314196;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_314187\n}\n__kernel void mainzisegmap_314210(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n                                  int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_param_318838, __global\n                                  unsigned char *mem_319907, __global\n                                  unsigned char *mem_319912, __global\n                                  unsigned char *mem_319916)\n{\n    #define segmap_group_sizze_314204 (mainzisegmap_group_sizze_314103)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324273;\n    int32_t local_tid_324274;\n    int64_t group_sizze_324277;\n    int32_t wave_sizze_324276;\n    int32_t group_tid_324275;\n    \n    global_tid_324273 = get_global_id(0);\n    local_tid_324274 = get_local_id(0);\n    group_siz",
            "ze_324277 = get_local_size(0);\n    wave_sizze_324276 = LOCKSTEP_WIDTH;\n    group_tid_324275 = get_group_id(0);\n    \n    int32_t phys_tid_314210 = global_tid_324273;\n    int64_t global_tid_324278 = sext_i32_i64(group_tid_324275) *\n            segmap_group_sizze_314204 + sext_i32_i64(local_tid_324274);\n    int64_t slice_324279 = n_292675;\n    int64_t slice_324280 = partition_sizze_292766 * slice_324279;\n    int64_t gtid_314208 = squot64(global_tid_324278, slice_324279);\n    int64_t remnant_324281 = global_tid_324278 - gtid_314208 * slice_324279;\n    int64_t gtid_314209 = remnant_324281;\n    int64_t remnant_324282 = remnant_324281 - gtid_314209;\n    \n    if (slt64(gtid_314208, partition_sizze_292766) && slt64(gtid_314209,\n                                                            n_292675)) {\n        int64_t x_314213;\n        \n        x_314213 = ((__global int64_t *) ext_mem_318542)[gtid_314208 *\n                                                         n_292675 +\n                                                         gtid_314209];\n        \n        bool cond_314214 = sle64((int64_t) 0, x_314213);\n        double defunc_0_f_res_314215;\n        \n        if (cond_314214) {\n            bool y_314216 = slt64(x_314213, n_292675);\n            bool bounds_check_314217 = cond_314214 && y_314216;\n            bool index_certs_314218;\n            \n            if (!bounds_check_314217) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 62) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_314213;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_314219;\n            \n            defunc_0_f_res_t_res_314219 = ((__global\n                                            double *) mem_319907)[gtid_314208 *\n                          ",
            "                                        n_292675 +\n                                                                  x_314213];\n            defunc_0_f_res_314215 = defunc_0_f_res_t_res_314219;\n        } else {\n            defunc_0_f_res_314215 = 0.0;\n        }\n        \n        double defunc_0_f_res_314220;\n        \n        if (cond_314214) {\n            bool y_314221 = slt64(x_314213, n_292675);\n            bool bounds_check_314222 = cond_314214 && y_314221;\n            bool index_certs_314223;\n            \n            if (!bounds_check_314222) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 63) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_314213;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_314224;\n            \n            defunc_0_f_res_t_res_314224 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_314208 *\n                                                                         ctx_param_ext_318834 +\n                                                                         x_314213 *\n                                                                         ctx_param_ext_318836)];\n            defunc_0_f_res_314220 = defunc_0_f_res_t_res_314224;\n        } else {\n            defunc_0_f_res_314220 = 0.0;\n        }\n        ((__global double *) mem_319912)[gtid_314208 * n_292675 + gtid_314209] =\n            defunc_0_f_res_314220;\n        ((__global double *) mem_319916)[gtid_314208 * n_292675 + gtid_314209] =\n            defunc_0_f_res_314215;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_314204\n}\n__kernel void mainzisegmap_314732(__global int *glob",
            "al_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_319770, __global\n                                  unsigned char *mem_319953)\n{\n    #define segmap_group_sizze_314727 (mainzisegmap_group_sizze_314699)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324314;\n    int32_t local_tid_324315;\n    int64_t group_sizze_324318;\n    int32_t wave_sizze_324317;\n    int32_t group_tid_324316;\n    \n    global_tid_324314 = get_global_id(0);\n    local_tid_324315 = get_local_id(0);\n    group_sizze_324318 = get_local_size(0);\n    wave_sizze_324317 = LOCKSTEP_WIDTH;\n    group_tid_324316 = get_group_id(0);\n    \n    int32_t phys_tid_314732 = global_tid_324314;\n    int64_t global_tid_324319 = sext_i32_i64(group_tid_324316) *\n            segmap_group_sizze_314727 + sext_i32_i64(local_tid_324315);\n    int64_t slice_324320 = n_292675;\n    int64_t slice_324321 = partition_sizze_292766 * slice_324320;\n    int64_t gtid_314730 = squot64(global_tid_324319, slice_324320);\n    int64_t remnant_324322 = global_tid_324319 - gtid_314730 * slice_324320;\n    int64_t gtid_314731 = remnant_324322;\n    int64_t remnant_324323 = remnant_324322 - gtid_314731;\n    \n    if (slt64(gtid_314730, partition_sizze_292766) && slt64(gtid_314731,\n                                                            n_292675)) {\n        float x_314733;\n        \n        x_314733 = ((__global float *) mem_318506)[gtid_314730 * n_292675 +\n                                                   gtid_314731];\n        \n        double x_314734;\n        \n        x_314734 = ((__global double *) mem_319770)[gtid_314730 * n_292675 +\n                                                    gtid_314731];\n        \n        do",
            "uble f32_res_314735 = fpconv_f32_f64(x_314733);\n        double defunc_1_f_res_314736 = f32_res_314735 - x_314734;\n        \n        ((__global double *) mem_319953)[gtid_314730 * n_292675 + gtid_314731] =\n            defunc_1_f_res_314736;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_314727\n}\n__kernel void mainzisegmap_314750(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n                                  int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_param_318838, __global\n                                  unsigned char *mem_319953, __global\n                                  unsigned char *mem_319958, __global\n                                  unsigned char *mem_319962)\n{\n    #define segmap_group_sizze_314744 (mainzisegmap_group_sizze_314643)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324324;\n    int32_t local_tid_324325;\n    int64_t group_sizze_324328;\n    int32_t wave_sizze_324327;\n    int32_t group_tid_324326;\n    \n    global_tid_324324 = get_global_id(0);\n    local_tid_324325 = get_local_id(0);\n    group_sizze_324328 = get_local_size(0);\n    wave_sizze_324327 = LOCKSTEP_WIDTH;\n    group_tid_324326 = get_group_id(0);\n    \n    int32_t phys_tid_314750 = global_tid_324324;\n    int64_t global_tid_324329 = sext_i32_i64(group_tid_324326) *\n            segmap_group_sizze_314744 + sext_i32_i64(local_tid_324325);\n    int64_t slice_324330 = n_292675;\n   ",
            " int64_t slice_324331 = partition_sizze_292766 * slice_324330;\n    int64_t gtid_314748 = squot64(global_tid_324329, slice_324330);\n    int64_t remnant_324332 = global_tid_324329 - gtid_314748 * slice_324330;\n    int64_t gtid_314749 = remnant_324332;\n    int64_t remnant_324333 = remnant_324332 - gtid_314749;\n    \n    if (slt64(gtid_314748, partition_sizze_292766) && slt64(gtid_314749,\n                                                            n_292675)) {\n        int64_t x_314753;\n        \n        x_314753 = ((__global int64_t *) ext_mem_318542)[gtid_314748 *\n                                                         n_292675 +\n                                                         gtid_314749];\n        \n        bool cond_314754 = sle64((int64_t) 0, x_314753);\n        double defunc_0_f_res_314755;\n        \n        if (cond_314754) {\n            bool y_314756 = slt64(x_314753, n_292675);\n            bool bounds_check_314757 = cond_314754 && y_314756;\n            bool index_certs_314758;\n            \n            if (!bounds_check_314757) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 64) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_314753;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_314759;\n            \n            defunc_0_f_res_t_res_314759 = ((__global\n                                            double *) mem_319953)[gtid_314748 *\n                                                                  n_292675 +\n                                                                  x_314753];\n            defunc_0_f_res_314755 = defunc_0_f_res_t_res_314759;\n        } else {\n            defunc_0_f_res_314755 = 0.0;\n        }\n        \n        double defunc_0_f_res_314760;\n        \n        if (cond_314754) ",
            "{\n            bool y_314761 = slt64(x_314753, n_292675);\n            bool bounds_check_314762 = cond_314754 && y_314761;\n            bool index_certs_314763;\n            \n            if (!bounds_check_314762) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 65) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_314753;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_314764;\n            \n            defunc_0_f_res_t_res_314764 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_314748 *\n                                                                         ctx_param_ext_318834 +\n                                                                         x_314753 *\n                                                                         ctx_param_ext_318836)];\n            defunc_0_f_res_314760 = defunc_0_f_res_t_res_314764;\n        } else {\n            defunc_0_f_res_314760 = 0.0;\n        }\n        ((__global double *) mem_319958)[gtid_314748 * n_292675 + gtid_314749] =\n            defunc_0_f_res_314760;\n        ((__global double *) mem_319962)[gtid_314748 * n_292675 + gtid_314749] =\n            defunc_0_f_res_314755;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_314744\n}\n__kernel void mainzisegmap_314832(__global int *global_failure,\n                                  int64_t partition_sizze_292766,\n                                  int64_t t_n_m_292839, __global\n                                  unsigned char *mem_319967, __global\n                                  unsigned char *mem_319972)\n{\n    #define segmap_group_sizze_314827 (mainzisegmap_group_sizze_31",
            "4443)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324407;\n    int32_t local_tid_324408;\n    int64_t group_sizze_324411;\n    int32_t wave_sizze_324410;\n    int32_t group_tid_324409;\n    \n    global_tid_324407 = get_global_id(0);\n    local_tid_324408 = get_local_id(0);\n    group_sizze_324411 = get_local_size(0);\n    wave_sizze_324410 = LOCKSTEP_WIDTH;\n    group_tid_324409 = get_group_id(0);\n    \n    int32_t phys_tid_314832 = global_tid_324407;\n    int64_t global_tid_324412 = sext_i32_i64(group_tid_324409) *\n            segmap_group_sizze_314827 + sext_i32_i64(local_tid_324408);\n    int64_t slice_324413 = t_n_m_292839;\n    int64_t slice_324414 = partition_sizze_292766 * slice_324413;\n    int64_t gtid_314830 = squot64(global_tid_324412, slice_324413);\n    int64_t remnant_324415 = global_tid_324412 - gtid_314830 * slice_324413;\n    int64_t gtid_314831 = remnant_324415;\n    int64_t remnant_324416 = remnant_324415 - gtid_314831;\n    \n    if (slt64(gtid_314830, partition_sizze_292766) && slt64(gtid_314831,\n                                                            t_n_m_292839)) {\n        double defunc_2_reduce_res_314833;\n        \n        defunc_2_reduce_res_314833 = ((__global\n                                       double *) mem_319967)[gtid_314830 *\n                                                             t_n_m_292839 +\n                                                             gtid_314831];\n        \n        double a_314834 = 2.220446049250313e-16 + defunc_2_reduce_res_314833;\n        double a0_314835 = 1.0 / a_314834;\n        \n        ((__global double *) mem_319972)[gtid_314830 * t_n_m_292839 +\n                                         gtid_314831] = a0_314835;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_314827\n}\n__kernel void mainzisegmap_315331(__global int *global_failure,\n                                  int64_",
            "t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_319770, __global\n                                  unsigned char *mem_319982)\n{\n    #define segmap_group_sizze_315326 (mainzisegmap_group_sizze_315298)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324490;\n    int32_t local_tid_324491;\n    int64_t group_sizze_324494;\n    int32_t wave_sizze_324493;\n    int32_t group_tid_324492;\n    \n    global_tid_324490 = get_global_id(0);\n    local_tid_324491 = get_local_id(0);\n    group_sizze_324494 = get_local_size(0);\n    wave_sizze_324493 = LOCKSTEP_WIDTH;\n    group_tid_324492 = get_group_id(0);\n    \n    int32_t phys_tid_315331 = global_tid_324490;\n    int64_t global_tid_324495 = sext_i32_i64(group_tid_324492) *\n            segmap_group_sizze_315326 + sext_i32_i64(local_tid_324491);\n    int64_t slice_324496 = n_292675;\n    int64_t slice_324497 = partition_sizze_292766 * slice_324496;\n    int64_t gtid_315329 = squot64(global_tid_324495, slice_324496);\n    int64_t remnant_324498 = global_tid_324495 - gtid_315329 * slice_324496;\n    int64_t gtid_315330 = remnant_324498;\n    int64_t remnant_324499 = remnant_324498 - gtid_315330;\n    \n    if (slt64(gtid_315329, partition_sizze_292766) && slt64(gtid_315330,\n                                                            n_292675)) {\n        float x_315332;\n        \n        x_315332 = ((__global float *) mem_318506)[gtid_315329 * n_292675 +\n                                                   gtid_315330];\n        \n        double x_315333;\n        \n        x_315333 = ((__global double *) mem_319770)[gtid_315329 * n_292675 +\n                                                    gtid_315330];\n        \n        double f32_res_315334 = fpconv_f32_f64(x_315332);\n    ",
            "    double defunc_1_f_res_315335 = f32_res_315334 - x_315333;\n        \n        ((__global double *) mem_319982)[gtid_315329 * n_292675 + gtid_315330] =\n            defunc_1_f_res_315335;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_315326\n}\n__kernel void mainzisegmap_315349(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n                                  int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_param_318838, __global\n                                  unsigned char *mem_319982, __global\n                                  unsigned char *mem_319987, __global\n                                  unsigned char *mem_319991)\n{\n    #define segmap_group_sizze_315343 (mainzisegmap_group_sizze_315242)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324500;\n    int32_t local_tid_324501;\n    int64_t group_sizze_324504;\n    int32_t wave_sizze_324503;\n    int32_t group_tid_324502;\n    \n    global_tid_324500 = get_global_id(0);\n    local_tid_324501 = get_local_id(0);\n    group_sizze_324504 = get_local_size(0);\n    wave_sizze_324503 = LOCKSTEP_WIDTH;\n    group_tid_324502 = get_group_id(0);\n    \n    int32_t phys_tid_315349 = global_tid_324500;\n    int64_t global_tid_324505 = sext_i32_i64(group_tid_324502) *\n            segmap_group_sizze_315343 + sext_i32_i64(local_tid_324501);\n    int64_t slice_324506 = n_292675;\n    int64_t slice_324507 = partition_sizze_292766 * sli",
            "ce_324506;\n    int64_t gtid_315347 = squot64(global_tid_324505, slice_324506);\n    int64_t remnant_324508 = global_tid_324505 - gtid_315347 * slice_324506;\n    int64_t gtid_315348 = remnant_324508;\n    int64_t remnant_324509 = remnant_324508 - gtid_315348;\n    \n    if (slt64(gtid_315347, partition_sizze_292766) && slt64(gtid_315348,\n                                                            n_292675)) {\n        int64_t x_315352;\n        \n        x_315352 = ((__global int64_t *) ext_mem_318542)[gtid_315347 *\n                                                         n_292675 +\n                                                         gtid_315348];\n        \n        bool cond_315353 = sle64((int64_t) 0, x_315352);\n        double defunc_0_f_res_315354;\n        \n        if (cond_315353) {\n            bool y_315355 = slt64(x_315352, n_292675);\n            bool bounds_check_315356 = cond_315353 && y_315355;\n            bool index_certs_315357;\n            \n            if (!bounds_check_315356) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 66) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_315352;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_315358;\n            \n            defunc_0_f_res_t_res_315358 = ((__global\n                                            double *) mem_319982)[gtid_315347 *\n                                                                  n_292675 +\n                                                                  x_315352];\n            defunc_0_f_res_315354 = defunc_0_f_res_t_res_315358;\n        } else {\n            defunc_0_f_res_315354 = 0.0;\n        }\n        \n        double defunc_0_f_res_315359;\n        \n        if (cond_315353) {\n            bool y_315360 = slt64(x_315352, n_2926",
            "75);\n            bool bounds_check_315361 = cond_315353 && y_315360;\n            bool index_certs_315362;\n            \n            if (!bounds_check_315361) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 67) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_315352;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_315363;\n            \n            defunc_0_f_res_t_res_315363 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_315347 *\n                                                                         ctx_param_ext_318834 +\n                                                                         x_315352 *\n                                                                         ctx_param_ext_318836)];\n            defunc_0_f_res_315359 = defunc_0_f_res_t_res_315363;\n        } else {\n            defunc_0_f_res_315359 = 0.0;\n        }\n        ((__global double *) mem_319987)[gtid_315347 * n_292675 + gtid_315348] =\n            defunc_0_f_res_315359;\n        ((__global double *) mem_319991)[gtid_315347 * n_292675 + gtid_315348] =\n            defunc_0_f_res_315354;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_315343\n}\n__kernel void mainzisegmap_315443(__global int *global_failure,\n                                  int64_t partition_sizze_292766,\n                                  int64_t t_n_m_292839, __global\n                                  unsigned char *mem_319996, __global\n                                  unsigned char *mem_320000, __global\n                                  unsigned char *mem_320004, __global\n                                  unsigne",
            "d char *mem_320009, __global\n                                  unsigned char *mem_320013, __global\n                                  unsigned char *mem_320017)\n{\n    #define segmap_group_sizze_315436 (mainzisegmap_group_sizze_314985)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324611;\n    int32_t local_tid_324612;\n    int64_t group_sizze_324615;\n    int32_t wave_sizze_324614;\n    int32_t group_tid_324613;\n    \n    global_tid_324611 = get_global_id(0);\n    local_tid_324612 = get_local_id(0);\n    group_sizze_324615 = get_local_size(0);\n    wave_sizze_324614 = LOCKSTEP_WIDTH;\n    group_tid_324613 = get_group_id(0);\n    \n    int32_t phys_tid_315443 = global_tid_324611;\n    int64_t global_tid_324616 = sext_i32_i64(group_tid_324613) *\n            segmap_group_sizze_315436 + sext_i32_i64(local_tid_324612);\n    int64_t slice_324617 = t_n_m_292839;\n    int64_t slice_324618 = partition_sizze_292766 * slice_324617;\n    int64_t gtid_315441 = squot64(global_tid_324616, slice_324617);\n    int64_t remnant_324619 = global_tid_324616 - gtid_315441 * slice_324617;\n    int64_t gtid_315442 = remnant_324619;\n    int64_t remnant_324620 = remnant_324619 - gtid_315442;\n    \n    if (slt64(gtid_315441, partition_sizze_292766) && slt64(gtid_315442,\n                                                            t_n_m_292839)) {\n        double defunc_2_reduce_res_315444;\n        \n        defunc_2_reduce_res_315444 = ((__global\n                                       double *) mem_319996)[gtid_315441 *\n                                                             t_n_m_292839 +\n                                                             gtid_315442];\n        \n        double defunc_2_reduce_res_315445;\n        \n        defunc_2_reduce_res_315445 = ((__global\n                                       double *) mem_320000)[gtid_315441 *\n                                         ",
            "                    t_n_m_292839 +\n                                                             gtid_315442];\n        \n        double defunc_2_reduce_res_315446;\n        \n        defunc_2_reduce_res_315446 = ((__global\n                                       double *) mem_320004)[gtid_315441 *\n                                                             t_n_m_292839 +\n                                                             gtid_315442];\n        \n        double a_315447 = 2.220446049250313e-16 + defunc_2_reduce_res_315444;\n        double b_315448 = 2.220446049250313e-16 + defunc_2_reduce_res_315445;\n        double c_315449 = 2.220446049250313e-16 + defunc_2_reduce_res_315446;\n        double x_315450 = a_315447 * c_315449;\n        double y_315451 = b_315448 * b_315448;\n        double y_315452 = x_315450 - y_315451;\n        double det1_315453 = 1.0 / y_315452;\n        double a11_315454 = c_315449 * det1_315453;\n        double x_315455 = 0.0 - b_315448;\n        double b11_315456 = det1_315453 * x_315455;\n        double c11_315457 = a_315447 * det1_315453;\n        \n        ((__global double *) mem_320009)[gtid_315441 * t_n_m_292839 +\n                                         gtid_315442] = a11_315454;\n        ((__global double *) mem_320013)[gtid_315441 * t_n_m_292839 +\n                                         gtid_315442] = b11_315456;\n        ((__global double *) mem_320017)[gtid_315441 * t_n_m_292839 +\n                                         gtid_315442] = c11_315457;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_315436\n}\n__kernel void mainzisegmap_316057(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_319770, __global\n                                  unsigned char *mem_320031)\n{\n    #define segmap_group_sizze_316052 ",
            "(mainzisegmap_group_sizze_316024)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324708;\n    int32_t local_tid_324709;\n    int64_t group_sizze_324712;\n    int32_t wave_sizze_324711;\n    int32_t group_tid_324710;\n    \n    global_tid_324708 = get_global_id(0);\n    local_tid_324709 = get_local_id(0);\n    group_sizze_324712 = get_local_size(0);\n    wave_sizze_324711 = LOCKSTEP_WIDTH;\n    group_tid_324710 = get_group_id(0);\n    \n    int32_t phys_tid_316057 = global_tid_324708;\n    int64_t global_tid_324713 = sext_i32_i64(group_tid_324710) *\n            segmap_group_sizze_316052 + sext_i32_i64(local_tid_324709);\n    int64_t slice_324714 = n_292675;\n    int64_t slice_324715 = partition_sizze_292766 * slice_324714;\n    int64_t gtid_316055 = squot64(global_tid_324713, slice_324714);\n    int64_t remnant_324716 = global_tid_324713 - gtid_316055 * slice_324714;\n    int64_t gtid_316056 = remnant_324716;\n    int64_t remnant_324717 = remnant_324716 - gtid_316056;\n    \n    if (slt64(gtid_316055, partition_sizze_292766) && slt64(gtid_316056,\n                                                            n_292675)) {\n        float x_316058;\n        \n        x_316058 = ((__global float *) mem_318506)[gtid_316055 * n_292675 +\n                                                   gtid_316056];\n        \n        double x_316059;\n        \n        x_316059 = ((__global double *) mem_319770)[gtid_316055 * n_292675 +\n                                                    gtid_316056];\n        \n        double f32_res_316060 = fpconv_f32_f64(x_316058);\n        double defunc_1_f_res_316061 = f32_res_316060 - x_316059;\n        \n        ((__global double *) mem_320031)[gtid_316055 * n_292675 + gtid_316056] =\n            defunc_1_f_res_316061;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_316052\n}\n__kernel void mainzisegmap_316075(__global int *global_failure,\n    ",
            "                              int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766,\n                                  int64_t ctx_param_ext_318833,\n                                  int64_t ctx_param_ext_318834,\n                                  int64_t ctx_param_ext_318836, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_param_318838, __global\n                                  unsigned char *mem_320031, __global\n                                  unsigned char *mem_320036, __global\n                                  unsigned char *mem_320040)\n{\n    #define segmap_group_sizze_316069 (mainzisegmap_group_sizze_315968)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324718;\n    int32_t local_tid_324719;\n    int64_t group_sizze_324722;\n    int32_t wave_sizze_324721;\n    int32_t group_tid_324720;\n    \n    global_tid_324718 = get_global_id(0);\n    local_tid_324719 = get_local_id(0);\n    group_sizze_324722 = get_local_size(0);\n    wave_sizze_324721 = LOCKSTEP_WIDTH;\n    group_tid_324720 = get_group_id(0);\n    \n    int32_t phys_tid_316075 = global_tid_324718;\n    int64_t global_tid_324723 = sext_i32_i64(group_tid_324720) *\n            segmap_group_sizze_316069 + sext_i32_i64(local_tid_324719);\n    int64_t slice_324724 = n_292675;\n    int64_t slice_324725 = partition_sizze_292766 * slice_324724;\n    int64_t gtid_316073 = squot64(global_tid_324723, slice_324724);\n    int64_t remnant_324726 = global_tid_324723 - gtid_316073 * slice_324724;\n    int64_t gtid_316074 = remnant_324726;\n    int64_t remnant_324727 = remnant_324726 - gtid_316074;\n    \n    if (slt64(gtid_316073, partition_sizze_292766) && slt64(gtid_3",
            "16074,\n                                                            n_292675)) {\n        int64_t x_316078;\n        \n        x_316078 = ((__global int64_t *) ext_mem_318542)[gtid_316073 *\n                                                         n_292675 +\n                                                         gtid_316074];\n        \n        bool cond_316079 = sle64((int64_t) 0, x_316078);\n        double defunc_0_f_res_316080;\n        \n        if (cond_316079) {\n            bool y_316081 = slt64(x_316078, n_292675);\n            bool bounds_check_316082 = cond_316079 && y_316081;\n            bool index_certs_316083;\n            \n            if (!bounds_check_316082) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 68) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_316078;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_316084;\n            \n            defunc_0_f_res_t_res_316084 = ((__global\n                                            double *) mem_320031)[gtid_316073 *\n                                                                  n_292675 +\n                                                                  x_316078];\n            defunc_0_f_res_316080 = defunc_0_f_res_t_res_316084;\n        } else {\n            defunc_0_f_res_316080 = 0.0;\n        }\n        \n        double defunc_0_f_res_316085;\n        \n        if (cond_316079) {\n            bool y_316086 = slt64(x_316078, n_292675);\n            bool bounds_check_316087 = cond_316079 && y_316086;\n            bool index_certs_316088;\n            \n            if (!bounds_check_316087) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 69) ==\n                        -1) {\n                        global_failure_args[",
            "0] = (int64_t) x_316078;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_316089;\n            \n            defunc_0_f_res_t_res_316089 = ((__global\n                                            double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                        (gtid_316073 *\n                                                                         ctx_param_ext_318834 +\n                                                                         x_316078 *\n                                                                         ctx_param_ext_318836)];\n            defunc_0_f_res_316085 = defunc_0_f_res_t_res_316089;\n        } else {\n            defunc_0_f_res_316085 = 0.0;\n        }\n        ((__global double *) mem_320036)[gtid_316073 * n_292675 + gtid_316074] =\n            defunc_0_f_res_316085;\n        ((__global double *) mem_320040)[gtid_316073 * n_292675 + gtid_316074] =\n            defunc_0_f_res_316080;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_316069\n}\n__kernel void mainzisegmap_316181(__global int *global_failure,\n                                  int64_t partition_sizze_292766,\n                                  int64_t t_n_m_292839, __global\n                                  unsigned char *mem_320045, __global\n                                  unsigned char *mem_320049, __global\n                                  unsigned char *mem_320053, __global\n                                  unsigned char *mem_320057, __global\n                                  unsigned char *mem_320061, __global\n                                  unsigned char *mem_320066, __global\n                                  unsigned char *mem_320070, __global\n                                  unsigned char *mem_320074, __global\n                   ",
            "               unsigned char *mem_320078, __global\n                                  unsigned char *mem_320082)\n{\n    #define segmap_group_sizze_316172 (mainzisegmap_group_sizze_315640)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324857;\n    int32_t local_tid_324858;\n    int64_t group_sizze_324861;\n    int32_t wave_sizze_324860;\n    int32_t group_tid_324859;\n    \n    global_tid_324857 = get_global_id(0);\n    local_tid_324858 = get_local_id(0);\n    group_sizze_324861 = get_local_size(0);\n    wave_sizze_324860 = LOCKSTEP_WIDTH;\n    group_tid_324859 = get_group_id(0);\n    \n    int32_t phys_tid_316181 = global_tid_324857;\n    int64_t global_tid_324862 = sext_i32_i64(group_tid_324859) *\n            segmap_group_sizze_316172 + sext_i32_i64(local_tid_324858);\n    int64_t slice_324863 = t_n_m_292839;\n    int64_t slice_324864 = partition_sizze_292766 * slice_324863;\n    int64_t gtid_316179 = squot64(global_tid_324862, slice_324863);\n    int64_t remnant_324865 = global_tid_324862 - gtid_316179 * slice_324863;\n    int64_t gtid_316180 = remnant_324865;\n    int64_t remnant_324866 = remnant_324865 - gtid_316180;\n    \n    if (slt64(gtid_316179, partition_sizze_292766) && slt64(gtid_316180,\n                                                            t_n_m_292839)) {\n        double defunc_2_reduce_res_316182;\n        \n        defunc_2_reduce_res_316182 = ((__global\n                                       double *) mem_320045)[gtid_316179 *\n                                                             t_n_m_292839 +\n                                                             gtid_316180];\n        \n        double defunc_2_reduce_res_316183;\n        \n        defunc_2_reduce_res_316183 = ((__global\n                                       double *) mem_320049)[gtid_316179 *\n                                                             t_n_m_292839 +\n             ",
            "                                                gtid_316180];\n        \n        double defunc_2_reduce_res_316184;\n        \n        defunc_2_reduce_res_316184 = ((__global\n                                       double *) mem_320053)[gtid_316179 *\n                                                             t_n_m_292839 +\n                                                             gtid_316180];\n        \n        double defunc_2_reduce_res_316185;\n        \n        defunc_2_reduce_res_316185 = ((__global\n                                       double *) mem_320057)[gtid_316179 *\n                                                             t_n_m_292839 +\n                                                             gtid_316180];\n        \n        double defunc_2_reduce_res_316186;\n        \n        defunc_2_reduce_res_316186 = ((__global\n                                       double *) mem_320061)[gtid_316179 *\n                                                             t_n_m_292839 +\n                                                             gtid_316180];\n        \n        double a_316187 = 2.220446049250313e-16 + defunc_2_reduce_res_316182;\n        double b_316188 = 2.220446049250313e-16 + defunc_2_reduce_res_316183;\n        double c_316189 = 2.220446049250313e-16 + defunc_2_reduce_res_316184;\n        double d_316190 = 2.220446049250313e-16 + defunc_2_reduce_res_316185;\n        double e_316191 = 2.220446049250313e-16 + defunc_2_reduce_res_316186;\n        double x_316192 = c_316189 * e_316191;\n        double y_316193 = d_316190 * d_316190;\n        double a12_316194 = x_316192 - y_316193;\n        double x_316195 = c_316189 * d_316190;\n        double y_316196 = b_316188 * e_316191;\n        double b12_316197 = x_316195 - y_316196;\n        double x_316198 = b_316188 * d_316190;\n        double y_316199 = c_316189 * c_316189;\n        double c12_316200 = x_316198 - y_316199;\n        double x_316201 = a_316187 * e_316191;\n        double b2_316202 = x_316201 - y_316199;\n        do",
            "uble x_316203 = b_316188 * c_316189;\n        double y_316204 = a_316187 * d_316190;\n        double c2_316205 = x_316203 - y_316204;\n        double x_316206 = a_316187 * a12_316194;\n        double y_316207 = b_316188 * b12_316197;\n        double x_316208 = x_316206 + y_316207;\n        double y_316209 = c_316189 * c12_316200;\n        double y_316210 = x_316208 + y_316209;\n        double det_316211 = 1.0 / y_316210;\n        double a12_316212 = a12_316194 * det_316211;\n        double b12_316213 = b12_316197 * det_316211;\n        double c12_316214 = c12_316200 * det_316211;\n        double b2_316215 = b2_316202 * det_316211;\n        double c2_316216 = c2_316205 * det_316211;\n        \n        ((__global double *) mem_320066)[gtid_316179 * t_n_m_292839 +\n                                         gtid_316180] = a12_316212;\n        ((__global double *) mem_320070)[gtid_316179 * t_n_m_292839 +\n                                         gtid_316180] = b12_316213;\n        ((__global double *) mem_320074)[gtid_316179 * t_n_m_292839 +\n                                         gtid_316180] = c12_316214;\n        ((__global double *) mem_320078)[gtid_316179 * t_n_m_292839 +\n                                         gtid_316180] = b2_316215;\n        ((__global double *) mem_320082)[gtid_316179 * t_n_m_292839 +\n                                         gtid_316180] = c2_316216;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_316172\n}\n__kernel void mainzisegmap_316429(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675, int64_t jump_t_292685,\n                                  int64_t partition_sizze_292766,\n                                  int64_t t_n_m_292839, int64_t i_292846,\n                                  int64_t y_296962, __global\n                                  unsigned char *ext_mem_320098, __global\n     ",
            "                             unsigned char *ext_mem_320099, __global\n                                  unsigned char *mem_320104)\n{\n    #define segmap_group_sizze_316424 (mainzisegmap_group_sizze_316306)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324954;\n    int32_t local_tid_324955;\n    int64_t group_sizze_324958;\n    int32_t wave_sizze_324957;\n    int32_t group_tid_324956;\n    \n    global_tid_324954 = get_global_id(0);\n    local_tid_324955 = get_local_id(0);\n    group_sizze_324958 = get_local_size(0);\n    wave_sizze_324957 = LOCKSTEP_WIDTH;\n    group_tid_324956 = get_group_id(0);\n    \n    int32_t phys_tid_316429 = global_tid_324954;\n    int64_t global_tid_324959 = sext_i32_i64(group_tid_324956) *\n            segmap_group_sizze_316424 + sext_i32_i64(local_tid_324955);\n    int64_t slice_324960 = n_292675;\n    int64_t slice_324961 = partition_sizze_292766 * slice_324960;\n    int64_t gtid_316427 = squot64(global_tid_324959, slice_324960);\n    int64_t remnant_324962 = global_tid_324959 - gtid_316427 * slice_324960;\n    int64_t gtid_316428 = remnant_324962;\n    int64_t remnant_324963 = remnant_324962 - gtid_316428;\n    \n    if (slt64(gtid_316427, partition_sizze_292766) && slt64(gtid_316428,\n                                                            n_292675)) {\n        int64_t m_v_316433 = sdiv64(gtid_316428, jump_t_292685);\n        bool cond_316434 = m_v_316433 == y_296962;\n        int64_t j_316435;\n        \n        if (cond_316434) {\n            int64_t j_t_res_316436 = sub64(m_v_316433, (int64_t) 1);\n            \n            j_316435 = j_t_res_316436;\n        } else {\n            j_316435 = m_v_316433;\n        }\n        \n        int64_t min_arg_316437 = mul64(jump_t_292685, j_316435);\n        int64_t min_res_316438 = smin64(i_292846, min_arg_316437);\n        int64_t defunc_0_m_fun_arg_316439 = add64((int64_t) 1, j_316435);\n        int64",
            "_t min_arg_316440 = mul64(jump_t_292685,\n                                       defunc_0_m_fun_arg_316439);\n        int64_t min_res_316441 = smin64(i_292846, min_arg_316440);\n        int64_t i64_arg_316442 = sub64(min_res_316441, min_res_316438);\n        double i64_res_316443 = sitofp_i64_f64(i64_arg_316442);\n        int64_t i64_arg_316444 = sub64(gtid_316428, min_res_316438);\n        double i64_res_316445 = sitofp_i64_f64(i64_arg_316444);\n        double u_316446 = i64_res_316445 / i64_res_316443;\n        double u2_316447 = u_316446 * u_316446;\n        double u3_316448 = u_316446 * u2_316447;\n        double x_316449 = 2.0 * u3_316448;\n        double y_316450 = 3.0 * u2_316447;\n        double x_316451 = x_316449 - y_316450;\n        double x_316452 = 1.0 + x_316451;\n        bool x_316453 = sle64((int64_t) 0, j_316435);\n        bool y_316454 = slt64(j_316435, t_n_m_292839);\n        bool bounds_check_316455 = x_316453 && y_316454;\n        bool index_certs_316456;\n        \n        if (!bounds_check_316455) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 70) == -1) {\n                    global_failure_args[0] = (int64_t) j_316435;\n                    global_failure_args[1] = (int64_t) t_n_m_292839;\n                    ;\n                }\n                return;\n            }\n        }\n        \n        double y_316457;\n        \n        y_316457 = ((__global double *) ext_mem_320099)[gtid_316427 *\n                                                        t_n_m_292839 +\n                                                        j_316435];\n        \n        double x_316458 = x_316452 * y_316457;\n        double x_316459 = y_316450 - x_316449;\n        bool x_316460 = sle64((int64_t) 0, defunc_0_m_fun_arg_316439);\n        bool y_316461 = slt64(defunc_0_m_fun_arg_316439, t_n_m_292839);\n        bool bounds_check_316462 = x_316460 && y_316461;\n        bool index_certs_316463;\n        \n        if (!bounds_check_316462) {\n            {\n                if (",
            "atomic_cmpxchg_i32_global(global_failure, -1, 71) == -1) {\n                    global_failure_args[0] =\n                        (int64_t) defunc_0_m_fun_arg_316439;\n                    global_failure_args[1] = (int64_t) t_n_m_292839;\n                    ;\n                }\n                return;\n            }\n        }\n        \n        double y_316464;\n        \n        y_316464 = ((__global double *) ext_mem_320099)[gtid_316427 *\n                                                        t_n_m_292839 +\n                                                        defunc_0_m_fun_arg_316439];\n        \n        double y_316465 = x_316459 * y_316464;\n        double x_316466 = x_316458 + y_316465;\n        double y_316467 = 2.0 * u2_316447;\n        double x_316468 = u3_316448 - y_316467;\n        double x_316469 = u_316446 + x_316468;\n        double y_316470;\n        \n        y_316470 = ((__global double *) ext_mem_320098)[gtid_316427 *\n                                                        t_n_m_292839 +\n                                                        j_316435];\n        \n        double x_316471 = x_316469 * y_316470;\n        double y_316472 = i64_res_316443 * x_316471;\n        double x_316473 = x_316466 + y_316472;\n        double x_316474 = u3_316448 - u2_316447;\n        double y_316475;\n        \n        y_316475 = ((__global double *) ext_mem_320098)[gtid_316427 *\n                                                        t_n_m_292839 +\n                                                        defunc_0_m_fun_arg_316439];\n        \n        double x_316476 = x_316474 * y_316475;\n        double y_316477 = i64_res_316443 * x_316476;\n        double defunc_4_interpolate_proc_res_316478 = x_316473 + y_316477;\n        \n        ((__global double *) mem_320104)[gtid_316427 * n_292675 + gtid_316428] =\n            defunc_4_interpolate_proc_res_316478;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_316424\n}\n__kernel void mainzisegmap_316650(__global int *global_failure,\n  ",
            "                                int64_t n_292675,\n                                  int64_t partition_sizze_292766,\n                                  int64_t ext_320116, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *ext_mem_320111, __global\n                                  unsigned char *ext_mem_320112, __global\n                                  unsigned char *mem_320148)\n{\n    #define segmap_group_sizze_316645 (mainzisegmap_group_sizze_316607)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324977;\n    int32_t local_tid_324978;\n    int64_t group_sizze_324981;\n    int32_t wave_sizze_324980;\n    int32_t group_tid_324979;\n    \n    global_tid_324977 = get_global_id(0);\n    local_tid_324978 = get_local_id(0);\n    group_sizze_324981 = get_local_size(0);\n    wave_sizze_324980 = LOCKSTEP_WIDTH;\n    group_tid_324979 = get_group_id(0);\n    \n    int32_t phys_tid_316650 = global_tid_324977;\n    int64_t global_tid_324982 = sext_i32_i64(group_tid_324979) *\n            segmap_group_sizze_316645 + sext_i32_i64(local_tid_324978);\n    int64_t slice_324983 = n_292675;\n    int64_t slice_324984 = partition_sizze_292766 * slice_324983;\n    int64_t gtid_316648 = squot64(global_tid_324982, slice_324983);\n    int64_t remnant_324985 = global_tid_324982 - gtid_316648 * slice_324983;\n    int64_t gtid_316649 = remnant_324985;\n    int64_t remnant_324986 = remnant_324985 - gtid_316649;\n    \n    if (slt64(gtid_316648, partition_sizze_292766) && slt64(gtid_316649,\n                                                            n_292675)) {\n        float x_316651;\n        \n        x_316651 = ((__global float *) mem_318506)[gtid_316648 * n_292675 +\n                                                   gtid_316649];\n        \n        double x_316652;\n        \n        x_316652 = ((__global double *) ext_",
            "mem_320112)[gtid_316648 * n_292675 +\n                                                        gtid_316649];\n        \n        double x_316653;\n        \n        x_316653 = ((__global double *) ext_mem_320111)[gtid_316648 *\n                                                        ext_320116 +\n                                                        gtid_316649];\n        \n        double f32_res_316654 = fpconv_f32_f64(x_316651);\n        double x_316655 = f32_res_316654 - x_316652;\n        double defunc_2_f_res_316656 = x_316655 - x_316653;\n        bool isnan_res_316657;\n        \n        isnan_res_316657 = futrts_isnan64(defunc_2_f_res_316656);\n        \n        double defunc_0_f_res_316658;\n        \n        if (isnan_res_316657) {\n            defunc_0_f_res_316658 = defunc_2_f_res_316656;\n        } else {\n            double abs_res_316659 = fabs(defunc_2_f_res_316656);\n            \n            defunc_0_f_res_316658 = abs_res_316659;\n        }\n        ((__global double *) mem_320148)[gtid_316648 * n_292675 + gtid_316649] =\n            defunc_0_f_res_316658;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_316645\n}\n__kernel void mainzisegmap_316672(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *ext_mem_318542, __global\n                                  unsigned char *mem_320148, __global\n                                  unsigned char *mem_320153)\n{\n    #define segmap_group_sizze_316667 (mainzisegmap_group_sizze_316564)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324987;\n    int32_t local_tid_324988;\n    int64_t group_sizze_324991;\n    int32_t wav",
            "e_sizze_324990;\n    int32_t group_tid_324989;\n    \n    global_tid_324987 = get_global_id(0);\n    local_tid_324988 = get_local_id(0);\n    group_sizze_324991 = get_local_size(0);\n    wave_sizze_324990 = LOCKSTEP_WIDTH;\n    group_tid_324989 = get_group_id(0);\n    \n    int32_t phys_tid_316672 = global_tid_324987;\n    int64_t global_tid_324992 = sext_i32_i64(group_tid_324989) *\n            segmap_group_sizze_316667 + sext_i32_i64(local_tid_324988);\n    int64_t slice_324993 = n_292675;\n    int64_t slice_324994 = partition_sizze_292766 * slice_324993;\n    int64_t gtid_316670 = squot64(global_tid_324992, slice_324993);\n    int64_t remnant_324995 = global_tid_324992 - gtid_316670 * slice_324993;\n    int64_t gtid_316671 = remnant_324995;\n    int64_t remnant_324996 = remnant_324995 - gtid_316671;\n    \n    if (slt64(gtid_316670, partition_sizze_292766) && slt64(gtid_316671,\n                                                            n_292675)) {\n        int64_t x_316674;\n        \n        x_316674 = ((__global int64_t *) ext_mem_318542)[gtid_316670 *\n                                                         n_292675 +\n                                                         gtid_316671];\n        \n        bool cond_316675 = sle64((int64_t) 0, x_316674);\n        double defunc_0_f_res_316676;\n        \n        if (cond_316675) {\n            bool y_316677 = slt64(x_316674, n_292675);\n            bool bounds_check_316678 = cond_316675 && y_316677;\n            bool index_certs_316679;\n            \n            if (!bounds_check_316678) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 73) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) x_316674;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            double defunc_0_f_res_t_res_316680;\n            \n            d",
            "efunc_0_f_res_t_res_316680 = ((__global\n                                            double *) mem_320148)[gtid_316670 *\n                                                                  n_292675 +\n                                                                  x_316674];\n            defunc_0_f_res_316676 = defunc_0_f_res_t_res_316680;\n        } else {\n            defunc_0_f_res_316676 = INFINITY;\n        }\n        ((__global double *) mem_320153)[gtid_316670 * n_292675 + gtid_316671] =\n            defunc_0_f_res_316676;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_316667\n}\n__kernel void mainzisegmap_316711(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_320158, __global\n                                  unsigned char *mem_320162)\n{\n    #define segmap_group_sizze_316707 (mainzisegmap_group_sizze_316689)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324998;\n    int32_t local_tid_324999;\n    int64_t group_sizze_325002;\n    int32_t wave_sizze_325001;\n    int32_t group_tid_325000;\n    \n    global_tid_324998 = get_global_id(0);\n    local_tid_324999 = get_local_id(0);\n    group_sizze_325002 = get_local_size(0);\n    wave_sizze_325001 = LOCKSTEP_WIDTH;\n    group_tid_325000 = get_group_id(0);\n    \n    int32_t phys_tid_316711 = global_tid_324998;\n    int64_t global_tid_325003 = sext_i32_i64(group_tid_325000) *\n            segmap_group_sizze_316707 + sext_i32_i64(local_tid_324999);\n    int64_t slice_325004 = partition_sizze_292766;\n    int64_t gtid_316710 = global_tid_325003;\n    int64_t remnant_325005 = global_tid_325003 - gtid_316710;\n    \n    if (slt64(gtid_316710, partition_sizze_292766)) {\n        double defunc_0_f_res_316713;\n        double defunc_0_f_res_316714;\n   ",
            "     double redout_318460;\n        double redout_318461;\n        \n        redout_318460 = INFINITY;\n        redout_318461 = -INFINITY;\n        for (int64_t i_318462 = 0; i_318462 < n_292675; i_318462++) {\n            double x_316721;\n            \n            x_316721 = ((__global double *) mem_320158)[i_318462 *\n                                                        partition_sizze_292766 +\n                                                        gtid_316710];\n            \n            double defunc_1_op_res_316717 = fmin64(x_316721, redout_318460);\n            double defunc_1_op_res_316720 = fmax64(x_316721, redout_318461);\n            double redout_tmp_325006 = defunc_1_op_res_316717;\n            double redout_tmp_325007 = defunc_1_op_res_316720;\n            \n            redout_318460 = redout_tmp_325006;\n            redout_318461 = redout_tmp_325007;\n        }\n        defunc_0_f_res_316713 = redout_318460;\n        defunc_0_f_res_316714 = redout_318461;\n        \n        double defunc_1_f_res_316722 = defunc_0_f_res_316713 +\n               defunc_0_f_res_316714;\n        double defunc_0_f_res_316723 = defunc_1_f_res_316722 / 2.0;\n        \n        ((__global double *) mem_320162)[gtid_316710] = defunc_0_f_res_316723;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_316707\n}\n__kernel void mainzisegmap_316782(__global int *global_failure,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_320166, __global\n                                  unsigned char *mem_320169, __global\n                                  unsigned char *mem_320173)\n{\n    #define segmap_group_sizze_316778 (mainzisegmap_group_sizze_316729)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325090;\n    int32_t local_tid_325091;\n    int64_t group_sizze_325094;\n    int32_t wave_sizze_325093;\n   ",
            " int32_t group_tid_325092;\n    \n    global_tid_325090 = get_global_id(0);\n    local_tid_325091 = get_local_id(0);\n    group_sizze_325094 = get_local_size(0);\n    wave_sizze_325093 = LOCKSTEP_WIDTH;\n    group_tid_325092 = get_group_id(0);\n    \n    int32_t phys_tid_316782 = global_tid_325090;\n    int64_t global_tid_325095 = sext_i32_i64(group_tid_325092) *\n            segmap_group_sizze_316778 + sext_i32_i64(local_tid_325091);\n    int64_t slice_325096 = partition_sizze_292766;\n    int64_t gtid_316781 = global_tid_325095;\n    int64_t remnant_325097 = global_tid_325095 - gtid_316781;\n    \n    if (slt64(gtid_316781, partition_sizze_292766)) {\n        double defunc_0_f_res_316783;\n        \n        defunc_0_f_res_316783 = ((__global double *) mem_320166)[gtid_316781];\n        \n        double defunc_0_f_res_316784;\n        \n        defunc_0_f_res_316784 = ((__global double *) mem_320169)[gtid_316781];\n        \n        double defunc_1_f_res_316785 = defunc_0_f_res_316783 +\n               defunc_0_f_res_316784;\n        double defunc_0_f_res_316786 = defunc_1_f_res_316785 / 2.0;\n        \n        ((__global double *) mem_320173)[gtid_316781] = defunc_0_f_res_316786;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_316778\n}\n__kernel void mainzisegmap_316840(__global int *global_failure,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *ext_mem_318541, __global\n                                  unsigned char *mem_320181, __global\n                                  unsigned char *mem_320184)\n{\n    #define segmap_group_sizze_316835 (mainzisegmap_group_sizze_316824)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325111;\n    int32_t local_tid_325112;\n    int64_t group_sizze_325115;\n    int32_t wave_sizze_325114;\n    int32_t group_tid_325113;\n    \n    global_tid_325111 = ge",
            "t_global_id(0);\n    local_tid_325112 = get_local_id(0);\n    group_sizze_325115 = get_local_size(0);\n    wave_sizze_325114 = LOCKSTEP_WIDTH;\n    group_tid_325113 = get_group_id(0);\n    \n    int32_t phys_tid_316840 = global_tid_325111;\n    int64_t global_tid_325116 = sext_i32_i64(group_tid_325113) *\n            segmap_group_sizze_316835 + sext_i32_i64(local_tid_325112);\n    int64_t slice_325117 = partition_sizze_292766;\n    int64_t gtid_316839 = global_tid_325116;\n    int64_t remnant_325118 = global_tid_325116 - gtid_316839;\n    \n    if (slt64(gtid_316839, partition_sizze_292766)) {\n        int64_t x_316841;\n        \n        x_316841 = ((__global int64_t *) ext_mem_318541)[gtid_316839];\n        \n        int64_t defunc_0_f_res_316843 = sdiv64(x_316841, (int64_t) 2);\n        int32_t i64_res_316844 = sext_i64_i32(gtid_316839);\n        int32_t defunc_0_f_res_316845 = add32(1, i64_res_316844);\n        \n        ((__global int32_t *) mem_320181)[gtid_316839] = defunc_0_f_res_316845;\n        ((__global int64_t *) mem_320184)[gtid_316839] = defunc_0_f_res_316843;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_316835\n}\n__kernel void mainzisegmap_316857(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_320189)\n{\n    #define segmap_group_sizze_316852 (mainzisegmap_group_sizze_316803)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325119;\n    int32_t local_tid_325120;\n    int64_t group_sizze_325123;\n    int32_t wave_sizze_325122;\n    int32_t group_tid_325121;\n    \n    global_tid_325119 = get_global_id(0);\n    local_tid_325120 = get_local_id(0);\n    group_sizze_325123 = get_local_size(0);\n    wave_sizze_325122 = LOCKSTEP_WIDTH;\n    group_tid_325121 = get_group_id(0);\n    \n    int32_t",
            " phys_tid_316857 = global_tid_325119;\n    int64_t global_tid_325124 = sext_i32_i64(group_tid_325121) *\n            segmap_group_sizze_316852 + sext_i32_i64(local_tid_325120);\n    int64_t slice_325125 = n_292675;\n    int64_t slice_325126 = partition_sizze_292766 * slice_325125;\n    int64_t gtid_316855 = squot64(global_tid_325124, slice_325125);\n    int64_t remnant_325127 = global_tid_325124 - gtid_316855 * slice_325125;\n    int64_t gtid_316856 = remnant_325127;\n    int64_t remnant_325128 = remnant_325127 - gtid_316856;\n    \n    if (slt64(gtid_316855, partition_sizze_292766) && slt64(gtid_316856,\n                                                            n_292675)) {\n        int32_t binop_y_317863 = sext_i64_i32(gtid_316855);\n        int32_t index_primexp_317864 = add32(1, binop_y_317863);\n        \n        ((__global int32_t *) mem_320189)[gtid_316855 * n_292675 +\n                                          gtid_316856] = index_primexp_317864;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_316852\n}\n__kernel void mainzisegmap_316876(__global int *global_failure,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_320184, __global\n                                  unsigned char *mem_320196)\n{\n    #define segmap_group_sizze_316872 (mainzisegmap_group_sizze_316864)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325129;\n    int32_t local_tid_325130;\n    int64_t group_sizze_325133;\n    int32_t wave_sizze_325132;\n    int32_t group_tid_325131;\n    \n    global_tid_325129 = get_global_id(0);\n    local_tid_325130 = get_local_id(0);\n    group_sizze_325133 = get_local_size(0);\n    wave_sizze_325132 = LOCKSTEP_WIDTH;\n    group_tid_325131 = get_group_id(0);\n    \n    int32_t phys_tid_316876 = global_tid_325129;\n    int64_t global_tid_325134 = sext_i32_i64(group_tid_325",
            "131) *\n            segmap_group_sizze_316872 + sext_i32_i64(local_tid_325130);\n    int64_t slice_325135 = partition_sizze_292766;\n    int64_t gtid_316875 = global_tid_325134;\n    int64_t remnant_325136 = global_tid_325134 - gtid_316875;\n    \n    if (slt64(gtid_316875, partition_sizze_292766)) {\n        int64_t x_316877;\n        \n        x_316877 = ((__global int64_t *) mem_320184)[gtid_316875];\n        \n        int32_t defunc_0_f_res_316878 = sext_i64_i32(x_316877);\n        \n        ((__global int32_t *) mem_320196)[gtid_316875] = defunc_0_f_res_316878;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_316872\n}\n__kernel void mainzisegmap_316918(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t partition_sizze_292766,\n                                  int64_t loopz2089U_297094,\n                                  unsigned char cond_297105_bits,\n                                  int64_t ctx_param_ext_320231,\n                                  int64_t ctx_param_ext_320232, __global\n                                  unsigned char *ext_mem_320174, __global\n                                  unsigned char *mem_param_320234, __global\n                                  unsigned char *mem_320262, __global\n                                  unsigned char *mem_320266)\n{\n    bool cond_297105 = cond_297105_bits;\n    \n    #define segmap_group_sizze_316914 (mainzisegmap_group_sizze_316890)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325266;\n    int32_t local_tid_325267;\n    int64_t group_sizze_325270;\n    int32_t wave_sizze_325269;\n    int32_t group_tid_325268;\n    \n    global_tid_325266 = get_global_id(0);\n    local_tid_325267 = get_local_id(0);\n    group_sizze_325270 = get_local_size(0);\n   ",
            " wave_sizze_325269 = LOCKSTEP_WIDTH;\n    group_tid_325268 = get_group_id(0);\n    \n    int32_t phys_tid_316918 = global_tid_325266;\n    int64_t global_tid_325271 = sext_i32_i64(group_tid_325268) *\n            segmap_group_sizze_316914 + sext_i32_i64(local_tid_325267);\n    int64_t slice_325272 = partition_sizze_292766;\n    int64_t gtid_316917 = global_tid_325271;\n    int64_t remnant_325273 = global_tid_325271 - gtid_316917;\n    \n    if (slt64(gtid_316917, partition_sizze_292766)) {\n        double defunc_1_f_res_316922;\n        \n        if (cond_297105) {\n            double defunc_1_f_res_t_res_316927;\n            \n            defunc_1_f_res_t_res_316927 = ((__global\n                                            double *) ext_mem_320174)[gtid_316917];\n            defunc_1_f_res_316922 = defunc_1_f_res_t_res_316927;\n        } else {\n            int32_t x_316919;\n            \n            x_316919 = ((__global int32_t *) mem_320262)[gtid_316917];\n            \n            bool cond_316928 = x_316919 == 0;\n            double defunc_1_f_res_f_res_316929;\n            \n            if (cond_316928) {\n                defunc_1_f_res_f_res_316929 = 0.0;\n            } else {\n                int32_t i_316930 = sub32(x_316919, 1);\n                int64_t i_316931 = sext_i32_i64(i_316930);\n                bool x_316932 = sle64((int64_t) 0, i_316931);\n                bool y_316933 = slt64(i_316931, loopz2089U_297094);\n                bool bounds_check_316934 = x_316932 && y_316933;\n                bool index_certs_316935;\n                \n                if (!bounds_check_316934) {\n                    {\n                        if (atomic_cmpxchg_i32_global(global_failure, -1, 74) ==\n                            -1) {\n                            global_failure_args[0] = (int64_t) i_316931;\n                            global_failure_args[1] =\n                                (int64_t) loopz2089U_297094;\n                            ;\n                        }\n                        return;\n ",
            "                   }\n                }\n                \n                double defunc_1_f_res_f_res_f_res_316936;\n                \n                defunc_1_f_res_f_res_f_res_316936 = ((__global\n                                                      double *) mem_param_320234)[ctx_param_ext_320231 +\n                                                                                  i_316931 *\n                                                                                  ctx_param_ext_320232];\n                defunc_1_f_res_f_res_316929 = defunc_1_f_res_f_res_f_res_316936;\n            }\n            defunc_1_f_res_316922 = defunc_1_f_res_f_res_316929;\n        }\n        ((__global double *) mem_320266)[gtid_316917] = defunc_1_f_res_316922;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_316914\n}\n__kernel void mainzisegmap_317016(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t partition_sizze_292766,\n                                  int64_t replicate_arg_297080, __global\n                                  unsigned char *mem_param_320210, __global\n                                  unsigned char *mem_param_320215, __global\n                                  unsigned char *mem_320269, __global\n                                  unsigned char *mem_320274, __global\n                                  unsigned char *mem_320276, __global\n                                  unsigned char *mem_320279)\n{\n    #define segmap_group_sizze_317010 (mainzisegmap_group_sizze_316970)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325428;\n    int32_t local_tid_325429;\n    int64_t group_sizze_325432;\n    int32_t wave_sizze_325431;\n    int32_t group_tid_325430;\n    \n    global_tid_325428 = get_global_id(",
            "0);\n    local_tid_325429 = get_local_id(0);\n    group_sizze_325432 = get_local_size(0);\n    wave_sizze_325431 = LOCKSTEP_WIDTH;\n    group_tid_325430 = get_group_id(0);\n    \n    int32_t phys_tid_317016 = global_tid_325428;\n    int64_t global_tid_325433 = sext_i32_i64(group_tid_325430) *\n            segmap_group_sizze_317010 + sext_i32_i64(local_tid_325429);\n    int64_t slice_325434 = partition_sizze_292766;\n    int64_t gtid_317015 = global_tid_325433;\n    int64_t remnant_325435 = global_tid_325433 - gtid_317015;\n    \n    if (slt64(gtid_317015, partition_sizze_292766)) {\n        int32_t x_317017;\n        \n        x_317017 = ((__global int32_t *) mem_param_320210)[gtid_317015];\n        \n        bool cond_317019 = slt32(x_317017, 0);\n        int32_t defunc_1_f_res_317020;\n        int8_t defunc_1_f_res_317021;\n        int32_t defunc_1_f_res_317022;\n        \n        if (cond_317019) {\n            defunc_1_f_res_317020 = 0;\n            defunc_1_f_res_317021 = (int8_t) 3;\n            defunc_1_f_res_317022 = -1;\n        } else {\n            int64_t i_317023 = shl64(gtid_317015, (int64_t) 1);\n            bool x_317024 = sle64((int64_t) 0, i_317023);\n            bool y_317025 = slt64(i_317023, replicate_arg_297080);\n            bool bounds_check_317026 = x_317024 && y_317025;\n            bool index_certs_317027;\n            \n            if (!bounds_check_317026) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 77) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) i_317023;\n                        global_failure_args[1] = (int64_t) replicate_arg_297080;\n                        ;\n                    }\n                    return;\n                }\n            }\n            \n            int32_t lt_len_317028;\n            \n            lt_len_317028 = ((__global int32_t *) mem_320269)[i_317023];\n            \n            bool cond_317029 = slt32(x_317017, lt_len_317028);\n            int32_t defunc_1_f_",
            "res_f_res_317030;\n            int8_t defunc_1_f_res_f_res_317031;\n            int32_t defunc_1_f_res_f_res_317032;\n            \n            if (cond_317029) {\n                defunc_1_f_res_f_res_317030 = lt_len_317028;\n                defunc_1_f_res_f_res_317031 = (int8_t) 0;\n                defunc_1_f_res_f_res_317032 = x_317017;\n            } else {\n                int64_t i_317033 = add64((int64_t) 1, i_317023);\n                bool x_317034 = sle64((int64_t) 0, i_317033);\n                bool y_317035 = slt64(i_317033, replicate_arg_297080);\n                bool bounds_check_317036 = x_317034 && y_317035;\n                bool index_certs_317037;\n                \n                if (!bounds_check_317036) {\n                    {\n                        if (atomic_cmpxchg_i32_global(global_failure, -1, 78) ==\n                            -1) {\n                            global_failure_args[0] = (int64_t) i_317033;\n                            global_failure_args[1] =\n                                (int64_t) replicate_arg_297080;\n                            ;\n                        }\n                        return;\n                    }\n                }\n                \n                int32_t eq_len_317038;\n                \n                eq_len_317038 = ((__global int32_t *) mem_320269)[i_317033];\n                \n                int32_t lteq_len_317039 = add32(lt_len_317028, eq_len_317038);\n                bool cond_317040 = slt32(x_317017, lteq_len_317039);\n                int8_t defunc_1_f_res_f_res_f_res_317041;\n                \n                if (cond_317040) {\n                    defunc_1_f_res_f_res_f_res_317041 = (int8_t) 1;\n                } else {\n                    defunc_1_f_res_f_res_f_res_317041 = (int8_t) 2;\n                }\n                \n                int32_t defunc_1_f_res_f_res_f_res_317042;\n                int32_t defunc_1_f_res_f_res_f_res_317043;\n                \n                if (cond_317040) {\n                    defunc_1_f_res",
            "_f_res_f_res_317042 = 0;\n                    defunc_1_f_res_f_res_f_res_317043 = -1;\n                } else {\n                    int32_t x_317048;\n                    \n                    x_317048 = ((__global\n                                 int32_t *) mem_param_320215)[gtid_317015];\n                    \n                    int32_t defunc_1_f_res_f_res_f_res_f_res_317049 =\n                            sub32(x_317048, lteq_len_317039);\n                    int32_t defunc_1_f_res_f_res_f_res_f_res_317050 =\n                            sub32(x_317017, lteq_len_317039);\n                    \n                    defunc_1_f_res_f_res_f_res_317042 =\n                        defunc_1_f_res_f_res_f_res_f_res_317049;\n                    defunc_1_f_res_f_res_f_res_317043 =\n                        defunc_1_f_res_f_res_f_res_f_res_317050;\n                }\n                defunc_1_f_res_f_res_317030 = defunc_1_f_res_f_res_f_res_317042;\n                defunc_1_f_res_f_res_317031 = defunc_1_f_res_f_res_f_res_317041;\n                defunc_1_f_res_f_res_317032 = defunc_1_f_res_f_res_f_res_317043;\n            }\n            defunc_1_f_res_317020 = defunc_1_f_res_f_res_317030;\n            defunc_1_f_res_317021 = defunc_1_f_res_f_res_317031;\n            defunc_1_f_res_317022 = defunc_1_f_res_f_res_317032;\n        }\n        ((__global int32_t *) mem_320274)[gtid_317015] = defunc_1_f_res_317020;\n        ((__global int8_t *) mem_320276)[gtid_317015] = defunc_1_f_res_317021;\n        ((__global int32_t *) mem_320279)[gtid_317015] = defunc_1_f_res_317022;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_317010\n}\n__kernel void mainzisegmap_317052(__global int *global_failure,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *mem_320205, __global\n                                  unsigned char *mem_320266, __global\n                                  unsigned char *mem_320276)\n{\n    #define segmap_group_sizze_",
            "317055 (mainzisegmap_group_sizze_317054)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325436;\n    int32_t local_tid_325437;\n    int64_t group_sizze_325440;\n    int32_t wave_sizze_325439;\n    int32_t group_tid_325438;\n    \n    global_tid_325436 = get_global_id(0);\n    local_tid_325437 = get_local_id(0);\n    group_sizze_325440 = get_local_size(0);\n    wave_sizze_325439 = LOCKSTEP_WIDTH;\n    group_tid_325438 = get_group_id(0);\n    \n    int32_t phys_tid_317052 = global_tid_325436;\n    int64_t global_tid_325441 = sext_i32_i64(group_tid_325438) *\n            segmap_group_sizze_317055 + sext_i32_i64(local_tid_325437);\n    int64_t slice_325442 = partition_sizze_292766;\n    int64_t write_i_317051 = global_tid_325441;\n    int64_t remnant_325443 = global_tid_325441 - write_i_317051;\n    \n    if (slt64(write_i_317051, partition_sizze_292766)) {\n        int8_t x_297208;\n        \n        x_297208 = ((__global int8_t *) mem_320276)[write_i_317051];\n        \n        bool cond_297209 = x_297208 == (int8_t) 1;\n        int64_t defunc_1_f_res_297210;\n        \n        if (cond_297209) {\n            defunc_1_f_res_297210 = write_i_317051;\n        } else {\n            defunc_1_f_res_297210 = (int64_t) -1;\n        }\n        \n        double defunc_1_f_res_297211;\n        \n        if (cond_297209) {\n            double defunc_1_f_res_t_res_297216;\n            \n            defunc_1_f_res_t_res_297216 = ((__global\n                                            double *) mem_320266)[write_i_317051];\n            defunc_1_f_res_297211 = defunc_1_f_res_t_res_297216;\n        } else {\n            defunc_1_f_res_297211 = 0.0;\n        }\n        if (sle64((int64_t) 0, defunc_1_f_res_297210) &&\n            slt64(defunc_1_f_res_297210, partition_sizze_292766)) {\n            ((__global double *) mem_320205)[defunc_1_f_res_297210] =\n                defunc_1_f_res_297211;\n        }\n  ",
            "  }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_317055\n}\n__kernel void mainzisegmap_317089(__global int *global_failure,\n                                  int failure_is_an_option, __global\n                                  int64_t *global_failure_args,\n                                  int64_t partition_sizze_292766,\n                                  int64_t loopz2089U_297094,\n                                  int64_t ctx_param_ext_320221,\n                                  int64_t ctx_param_ext_320222,\n                                  int64_t ctx_param_ext_320231,\n                                  int64_t ctx_param_ext_320232, __global\n                                  unsigned char *mem_param_320224, __global\n                                  unsigned char *mem_param_320234, __global\n                                  unsigned char *mem_320266, __global\n                                  unsigned char *mem_320276, __global\n                                  unsigned char *mem_320289)\n{\n    #define segmap_group_sizze_317085 (mainzisegmap_group_sizze_317060)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325444;\n    int32_t local_tid_325445;\n    int64_t group_sizze_325448;\n    int32_t wave_sizze_325447;\n    int32_t group_tid_325446;\n    \n    global_tid_325444 = get_global_id(0);\n    local_tid_325445 = get_local_id(0);\n    group_sizze_325448 = get_local_size(0);\n    wave_sizze_325447 = LOCKSTEP_WIDTH;\n    group_tid_325446 = get_group_id(0);\n    \n    int32_t phys_tid_317089 = global_tid_325444;\n    int64_t global_tid_325449 = sext_i32_i64(group_tid_325446) *\n            segmap_group_sizze_317085 + sext_i32_i64(local_tid_325445);\n    int64_t slice_325450 = loopz2089U_297094;\n    int64_t gtid_317088 = global_tid_325449;\n    int64_t remnant_325451 = global_tid_325449 - gtid_317088;\n    \n    if (slt64(gtid_317088, loopz2089U_297094)) {",
            "\n        int32_t x_317090;\n        \n        x_317090 = ((__global\n                     int32_t *) mem_param_320224)[ctx_param_ext_320221 +\n                                                  gtid_317088 *\n                                                  ctx_param_ext_320222];\n        \n        double x_317091;\n        \n        x_317091 = ((__global double *) mem_param_320234)[ctx_param_ext_320231 +\n                                                          gtid_317088 *\n                                                          ctx_param_ext_320232];\n        \n        int32_t sgmind_317092 = sub32(x_317090, 1);\n        int64_t sgmind_317093 = sext_i32_i64(sgmind_317092);\n        bool x_317094 = sle64((int64_t) 0, sgmind_317093);\n        bool y_317095 = slt64(sgmind_317093, partition_sizze_292766);\n        bool bounds_check_317096 = x_317094 && y_317095;\n        bool index_certs_317097;\n        \n        if (!bounds_check_317096) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 79) == -1) {\n                    global_failure_args[0] = (int64_t) sgmind_317093;\n                    global_failure_args[1] = (int64_t) partition_sizze_292766;\n                    ;\n                }\n                return;\n            }\n        }\n        \n        double pivot_317098;\n        \n        pivot_317098 = ((__global double *) mem_320266)[sgmind_317093];\n        \n        int8_t kind_317099;\n        \n        kind_317099 = ((__global int8_t *) mem_320276)[sgmind_317093];\n        \n        bool cond_317100 = x_317091 < pivot_317098;\n        bool cond_t_res_317101 = kind_317099 == (int8_t) 0;\n        bool x_317102 = cond_317100 && cond_t_res_317101;\n        bool cond_317103 = pivot_317098 < x_317091;\n        bool defunc_1_f_res_f_res_t_res_317104 = kind_317099 == (int8_t) 2;\n        bool x_317105 = cond_317103 && defunc_1_f_res_f_res_t_res_317104;\n        bool x_317106 = !x_317102;\n        bool y_317107 = x_317105 && x_317106;\n        bool defunc_1_f_res_31710",
            "8 = x_317102 || y_317107;\n        \n        ((__global bool *) mem_320289)[gtid_317088] = defunc_1_f_res_317108;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_317085\n}\n__kernel void mainzisegmap_317118(__global int *global_failure,\n                                  int64_t loopz2088U_297093,\n                                  int64_t loopz2089U_297094,\n                                  int64_t loopz2081Uz2080U_297095,\n                                  int64_t ctx_param_ext_320221,\n                                  int64_t ctx_param_ext_320222,\n                                  int64_t ctx_param_ext_320226,\n                                  int64_t ctx_param_ext_320227,\n                                  int64_t ctx_param_ext_320231,\n                                  int64_t ctx_param_ext_320232,\n                                  int64_t ctx_param_ext_320236,\n                                  int64_t ctx_param_ext_320237, __global\n                                  unsigned char *mem_param_320224, __global\n                                  unsigned char *mem_param_320229, __global\n                                  unsigned char *mem_param_320234, __global\n                                  unsigned char *mem_param_320239, __global\n                                  unsigned char *mem_320289, __global\n                                  unsigned char *mem_320293)\n{\n    #define segmap_group_sizze_317121 (mainzisegmap_group_sizze_317120)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325548;\n    int32_t local_tid_325549;\n    int64_t group_sizze_325552;\n    int32_t wave_sizze_325551;\n    int32_t group_tid_325550;\n    \n    global_tid_325548 = get_global_id(0);\n    local_tid_325549 = get_local_id(0);\n    group_sizze_325552 = get_local_size(0);\n    wave_sizze_325551 = LOCKSTEP_WIDTH;\n    group_tid_325550 = get_group_id(0);\n    \n    int32_t",
            " phys_tid_317118 = global_tid_325548;\n    int64_t global_tid_325553 = sext_i32_i64(group_tid_325550) *\n            segmap_group_sizze_317121 + sext_i32_i64(local_tid_325549);\n    int64_t slice_325554 = loopz2089U_297094;\n    int64_t write_i_317117 = global_tid_325553;\n    int64_t remnant_325555 = global_tid_325553 - write_i_317117;\n    \n    if (slt64(write_i_317117, loopz2089U_297094)) {\n        bool x_297253;\n        \n        x_297253 = ((__global bool *) mem_320289)[write_i_317117];\n        \n        int32_t write_value_297255;\n        \n        write_value_297255 = ((__global\n                               int32_t *) mem_param_320224)[ctx_param_ext_320221 +\n                                                            write_i_317117 *\n                                                            ctx_param_ext_320222];\n        \n        double write_value_297256;\n        \n        write_value_297256 = ((__global\n                               double *) mem_param_320234)[ctx_param_ext_320231 +\n                                                           write_i_317117 *\n                                                           ctx_param_ext_320232];\n        \n        int64_t defunc_1_f_res_297257;\n        \n        if (x_297253) {\n            int32_t x_297254;\n            \n            x_297254 = ((__global int32_t *) mem_320293)[write_i_317117];\n            \n            int32_t i32_arg_297258 = sub32(x_297254, 1);\n            int64_t i32_res_297259 = sext_i32_i64(i32_arg_297258);\n            \n            defunc_1_f_res_297257 = i32_res_297259;\n        } else {\n            defunc_1_f_res_297257 = (int64_t) -1;\n        }\n        if (sle64((int64_t) 0, defunc_1_f_res_297257) &&\n            slt64(defunc_1_f_res_297257, loopz2088U_297093)) {\n            ((__global int32_t *) mem_param_320229)[ctx_param_ext_320226 +\n                                                    defunc_1_f_res_297257 *\n                                                    ctx_param_ext_320227] =\n                ",
            "write_value_297255;\n        }\n        if (sle64((int64_t) 0, defunc_1_f_res_297257) &&\n            slt64(defunc_1_f_res_297257, loopz2081Uz2080U_297095)) {\n            ((__global double *) mem_param_320239)[ctx_param_ext_320236 +\n                                                   defunc_1_f_res_297257 *\n                                                   ctx_param_ext_320237] =\n                write_value_297256;\n        }\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_317121\n}\n__kernel void mainzisegmap_317377(__global int *global_failure,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *ext_mem_318541, __global\n                                  unsigned char *mem_320184, __global\n                                  unsigned char *mem_320205, __global\n                                  unsigned char *mem_320397, __global\n                                  unsigned char *mem_320403, __global\n                                  unsigned char *mem_320407, __global\n                                  unsigned char *mem_320410, __global\n                                  unsigned char *mem_320413)\n{\n    #define segmap_group_sizze_317371 (mainzisegmap_group_sizze_317254)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325723;\n    int32_t local_tid_325724;\n    int64_t group_sizze_325727;\n    int32_t wave_sizze_325726;\n    int32_t group_tid_325725;\n    \n    global_tid_325723 = get_global_id(0);\n    local_tid_325724 = get_local_id(0);\n    group_sizze_325727 = get_local_size(0);\n    wave_sizze_325726 = LOCKSTEP_WIDTH;\n    group_tid_325725 = get_group_id(0);\n    \n    int32_t phys_tid_317377 = global_tid_325723;\n    int64_t global_tid_325728 = sext_i32_i64(group_tid_325725) *\n            segmap_group_sizze_317371 + sext_i32_i64(local_tid_325724);\n    int64_t slice_325729 =",
            " partition_sizze_292766;\n    int64_t gtid_317376 = global_tid_325728;\n    int64_t remnant_325730 = global_tid_325728 - gtid_317376;\n    \n    if (slt64(gtid_317376, partition_sizze_292766)) {\n        double x_317378;\n        \n        x_317378 = ((__global double *) mem_320205)[gtid_317376];\n        \n        int64_t x_317379;\n        \n        x_317379 = ((__global int64_t *) mem_320184)[gtid_317376];\n        \n        int64_t x_317380;\n        \n        x_317380 = ((__global int64_t *) ext_mem_318541)[gtid_317376];\n        \n        int64_t defunc_2_reduce_comm_res_317382;\n        \n        defunc_2_reduce_comm_res_317382 = ((__global\n                                            int64_t *) mem_320403)[gtid_317376];\n        \n        bool cond_317383 = x_317379 == (int64_t) 0;\n        int64_t x_317384 = smod64(x_317380, (int64_t) 2);\n        bool cond_f_res_317385 = x_317384 == (int64_t) 1;\n        bool x_317386 = !cond_317383;\n        bool y_317387 = cond_f_res_317385 && x_317386;\n        bool cond_317388 = cond_317383 || y_317387;\n        bool cond_f_res_317389 = slt64(defunc_2_reduce_comm_res_317382,\n                                       x_317379);\n        bool x_317390 = !cond_317388;\n        bool y_317391 = cond_f_res_317389 && x_317390;\n        bool cond_317392 = cond_317388 || y_317391;\n        double defunc_4_f_res_317393;\n        \n        if (cond_317392) {\n            defunc_4_f_res_317393 = x_317378;\n        } else {\n            double defunc_2_reduce_comm_res_317381;\n            \n            defunc_2_reduce_comm_res_317381 = ((__global\n                                                double *) mem_320397)[gtid_317376];\n            \n            double x_317394 = x_317378 - defunc_2_reduce_comm_res_317381;\n            double y_317395 = x_317394 / 2.0;\n            double defunc_4_f_res_f_res_317396 =\n                   defunc_2_reduce_comm_res_317381 + y_317395;\n            \n            defunc_4_f_res_317393 = defunc_4_f_res_f_res_317396;\n        }\n        \n        ",
            "double h_317397 = 6.0 * defunc_4_f_res_317393;\n        double h9_317398 = 0.999 * h_317397;\n        double h1_317399 = 1.0e-3 * h_317397;\n        \n        ((__global double *) mem_320407)[gtid_317376] = h_317397;\n        ((__global double *) mem_320410)[gtid_317376] = h9_317398;\n        ((__global double *) mem_320413)[gtid_317376] = h1_317399;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_317371\n}\n__kernel void mainzisegmap_317481(__global int *global_failure,\n                                  int64_t n_292675,\n                                  int64_t partition_sizze_292766, __global\n                                  unsigned char *ext_mem_320154, __global\n                                  unsigned char *ext_mem_320414, __global\n                                  unsigned char *ext_mem_320415, __global\n                                  unsigned char *ext_mem_320416, __global\n                                  unsigned char *mem_320421)\n{\n    #define segmap_group_sizze_317476 (mainzisegmap_group_sizze_317416)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325732;\n    int32_t local_tid_325733;\n    int64_t group_sizze_325736;\n    int32_t wave_sizze_325735;\n    int32_t group_tid_325734;\n    \n    global_tid_325732 = get_global_id(0);\n    local_tid_325733 = get_local_id(0);\n    group_sizze_325736 = get_local_size(0);\n    wave_sizze_325735 = LOCKSTEP_WIDTH;\n    group_tid_325734 = get_group_id(0);\n    \n    int32_t phys_tid_317481 = global_tid_325732;\n    int64_t global_tid_325737 = sext_i32_i64(group_tid_325734) *\n            segmap_group_sizze_317476 + sext_i32_i64(local_tid_325733);\n    int64_t slice_325738 = n_292675;\n    int64_t slice_325739 = partition_sizze_292766 * slice_325738;\n    int64_t gtid_317479 = squot64(global_tid_325737, slice_325738);\n    int64_t remnant_325740 = global_tid_325737 - gtid_317479 * slice_325738;\n   ",
            " int64_t gtid_317480 = remnant_325740;\n    int64_t remnant_325741 = remnant_325740 - gtid_317480;\n    \n    if (slt64(gtid_317479, partition_sizze_292766) && slt64(gtid_317480,\n                                                            n_292675)) {\n        double x_317482;\n        \n        x_317482 = ((__global double *) ext_mem_320416)[gtid_317479];\n        \n        double x_317484;\n        \n        x_317484 = ((__global double *) ext_mem_320414)[gtid_317479];\n        \n        double x_317485;\n        \n        x_317485 = ((__global double *) ext_mem_320154)[gtid_317479 * n_292675 +\n                                                        gtid_317480];\n        \n        double x_317486 = x_317485 / x_317482;\n        double y_317487 = fpow64(x_317486, 2.0);\n        double x_317488 = 1.0 - y_317487;\n        double bicube_317489 = fpow64(x_317488, 2.0);\n        bool isnan_res_317490;\n        \n        isnan_res_317490 = futrts_isnan64(x_317485);\n        \n        bool cond_f_res_317491 = x_317485 <= x_317484;\n        bool x_317492 = !isnan_res_317490;\n        bool y_317493 = cond_f_res_317491 && x_317492;\n        bool cond_317494 = isnan_res_317490 || y_317493;\n        double defunc_0_f_res_317495;\n        \n        if (cond_317494) {\n            defunc_0_f_res_317495 = 1.0;\n        } else {\n            double x_317483;\n            \n            x_317483 = ((__global double *) ext_mem_320415)[gtid_317479];\n            \n            bool cond_317496 = x_317483 <= x_317485;\n            bool cond_f_res_317497 = x_317485 <= 1.0e-6;\n            bool x_317498 = !cond_317496;\n            bool y_317499 = cond_f_res_317497 && x_317498;\n            bool cond_317500 = cond_317496 || y_317499;\n            double defunc_0_f_res_f_res_317501;\n            \n            if (cond_317500) {\n                defunc_0_f_res_f_res_317501 = 1.0e-6;\n            } else {\n                defunc_0_f_res_f_res_317501 = bicube_317489;\n            }\n            defunc_0_f_res_317495 = defunc_0_f_res_f_res_",
            "317501;\n        }\n        ((__global double *) mem_320421)[gtid_317479 * n_292675 + gtid_317480] =\n            defunc_0_f_res_317495;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_317476\n}\n__kernel void mainzisegmap_317504(__global int *global_failure,\n                                  int64_t m_292674, int64_t n_292675,\n                                  int64_t partition_sizze_292766,\n                                  int64_t num_groups_317509,\n                                  int64_t num_threads_320819, __global\n                                  unsigned char *mem_318506, __global\n                                  unsigned char *mem_318509, __global\n                                  unsigned char *mem_320457, __global\n                                  unsigned char *mem_320461, __global\n                                  unsigned char *mem_320465, __global\n                                  unsigned char *mem_320468, __global\n                                  unsigned char *mem_320471, __global\n                                  unsigned char *color_320672, __global\n                                  unsigned char *color_320673, __global\n                                  unsigned char *color_320674)\n{\n    #define segmap_group_sizze_317507 (mainzisegmap_group_sizze_317506)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325755;\n    int32_t local_tid_325756;\n    int64_t group_sizze_325759;\n    int32_t wave_sizze_325758;\n    int32_t group_tid_325757;\n    \n    global_tid_325755 = get_global_id(0);\n    local_tid_325756 = get_local_id(0);\n    group_sizze_325759 = get_local_size(0);\n    wave_sizze_325758 = LOCKSTEP_WIDTH;\n    group_tid_325757 = get_group_id(0);\n    \n    int32_t phys_tid_317504 = global_tid_325755;\n    int32_t phys_group_id_325760;\n    \n    phys_group_id_325760 = get_group_id(0);\n    for (int32_t i_325761 = 0; i_3257",
            "61 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766,\n                                          segmap_group_sizze_317507)) -\n                   phys_group_id_325760, sext_i64_i32(num_groups_317509));\n         i_325761++) {\n        int32_t virt_group_id_325762 = phys_group_id_325760 + i_325761 *\n                sext_i64_i32(num_groups_317509);\n        int64_t global_tid_325763 = sext_i32_i64(virt_group_id_325762) *\n                segmap_group_sizze_317507 + sext_i32_i64(local_tid_325756);\n        int64_t slice_325764 = partition_sizze_292766;\n        int64_t write_i_317503 = global_tid_325763;\n        int64_t remnant_325765 = global_tid_325763 - write_i_317503;\n        \n        if (slt64(write_i_317503, partition_sizze_292766)) {\n            int64_t write_index_297371;\n            \n            write_index_297371 = ((__global\n                                   int64_t *) mem_318509)[write_i_317503];\n            for (int64_t i_318477 = 0; i_318477 < n_292675; i_318477++) {\n                double x_297375;\n                \n                x_297375 = ((__global double *) mem_320468)[i_318477 *\n                                                            partition_sizze_292766 +\n                                                            write_i_317503];\n                \n                double x_297376;\n                \n                x_297376 = ((__global double *) mem_320471)[i_318477 *\n                                                            partition_sizze_292766 +\n                                                            write_i_317503];\n                \n                float x_297377;\n                \n                x_297377 = ((__global float *) mem_318506)[write_i_317503 *\n                                                           n_292675 + i_318477];\n                \n                float defunc_0_g_res_297378 = fpconv_f64_f32(x_297375);\n                float defunc_0_g_res_297379 = fpconv_f64_f32(x_297376);\n                float x_29738",
            "0 = x_297377 - defunc_0_g_res_297378;\n                float defunc_2_f_res_297381 = x_297380 - defunc_0_g_res_297379;\n                \n                ((__global float *) color_320674)[phys_tid_317504 + i_318477 *\n                                                  num_threads_320819] =\n                    defunc_2_f_res_297381;\n                ((__global float *) color_320673)[phys_tid_317504 + i_318477 *\n                                                  num_threads_320819] =\n                    defunc_0_g_res_297379;\n                ((__global float *) color_320672)[phys_tid_317504 + i_318477 *\n                                                  num_threads_320819] =\n                    defunc_0_g_res_297378;\n            }\n            if (sle64((int64_t) 0, write_index_297371) &&\n                slt64(write_index_297371, m_292674)) {\n                for (int64_t i_325769 = 0; i_325769 < n_292675; i_325769++) {\n                    float tmp_325770;\n                    \n                    tmp_325770 = ((__global\n                                   float *) color_320674)[phys_tid_317504 +\n                                                          i_325769 *\n                                                          num_threads_320819];\n                    ((__global float *) mem_320465)[write_index_297371 *\n                                                    n_292675 + i_325769] =\n                        tmp_325770;\n                }\n            }\n            if (sle64((int64_t) 0, write_index_297371) &&\n                slt64(write_index_297371, m_292674)) {\n                for (int64_t i_325771 = 0; i_325771 < n_292675; i_325771++) {\n                    float tmp_325772;\n                    \n                    tmp_325772 = ((__global\n                                   float *) color_320673)[phys_tid_317504 +\n                                                          i_325771 *\n                                                          num_threads_320819];\n                 ",
            "   ((__global float *) mem_320461)[write_index_297371 *\n                                                    n_292675 + i_325771] =\n                        tmp_325772;\n                }\n            }\n            if (sle64((int64_t) 0, write_index_297371) &&\n                slt64(write_index_297371, m_292674)) {\n                for (int64_t i_325773 = 0; i_325773 < n_292675; i_325773++) {\n                    float tmp_325774;\n                    \n                    tmp_325774 = ((__global\n                                   float *) color_320672)[phys_tid_317504 +\n                                                          i_325773 *\n                                                          num_threads_320819];\n                    ((__global float *) mem_320457)[write_index_297371 *\n                                                    n_292675 + i_325773] =\n                        tmp_325774;\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_317507\n}\n__kernel void mainzisegmap_intragroup_297641(__global int *global_failure,\n                                             uint color_320586_backing_offset_0,\n                                             uint color_320585_backing_offset_1,\n                                             int64_t n_292675,\n                                             int64_t partition_sizze_292766,\n                                             int64_t i_292846, __global\n                                             unsigned char *mem_318506, __global\n                                             unsigned char *mem_318523, __global\n                                             unsigned char *mem_318526)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *color_320586_backing_1 =\n                           &shared_mem[color_320586_backing_offset_0];\n    volatile unsigned ch",
            "ar *color_320585_backing_0 =\n                           &shared_mem[color_320585_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_320952;\n    int32_t local_tid_320953;\n    int64_t group_sizze_320956;\n    int32_t wave_sizze_320955;\n    int32_t group_tid_320954;\n    \n    global_tid_320952 = get_global_id(0);\n    local_tid_320953 = get_local_id(0);\n    group_sizze_320956 = get_local_size(0);\n    wave_sizze_320955 = LOCKSTEP_WIDTH;\n    group_tid_320954 = get_group_id(0);\n    \n    int32_t phys_tid_297641 = group_tid_320954;\n    int64_t slice_320958 = n_292675;\n    int64_t ltid_pre_320957 = sext_i32_i64(local_tid_320953);\n    int64_t remnant_320959 = sext_i32_i64(local_tid_320953) - ltid_pre_320957;\n    int64_t slice_320960 = partition_sizze_292766;\n    int64_t gtid_297640 = sext_i32_i64(group_tid_320954);\n    int64_t remnant_320961 = sext_i32_i64(group_tid_320954) - gtid_297640;\n    __local unsigned char *color_320585;\n    \n    color_320585 = (__local unsigned char *) color_320585_backing_0;\n    \n    __local unsigned char *color_320586;\n    \n    color_320586 = (__local unsigned char *) color_320586_backing_1;\n    \n    int32_t phys_tid_297646 = local_tid_320953;\n    int64_t gtid_297645 = sext_i32_i64(sext_i64_i32(ltid_pre_320957));\n    float x_297650;\n    \n    x_297650 = ((__global float *) mem_318506)[gtid_297640 * n_292675 +\n                                               gtid_297645];\n    \n    bool isnan_res_297651;\n    \n    isnan_res_297651 = futrts_isnan32(x_297650);\n    \n    bool defunc_0_p_res_297652 = !isnan_res_297651;\n    int64_t defunc_0_f_res_297653 = btoi_bool_i64(defunc_0_p_res_297652);\n    \n    ((__local int64_t *) color_320586)[gtid_297645] = defunc_0_f_res_297653;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t dims_flat_320962 = n_292675;\n    int64_t x_297647;\n    int64_t x_297648;\n    int64_t x_320964;\n    int64_t x_320965;\n    bool ltid_in_bounds_320967 = slt64(sext_i32_i64(local_tid_320953),\n         ",
            "                              n_292675);\n    int32_t skip_threads_320968;\n    \n    // read input for in-block scan\n    {\n        if (ltid_in_bounds_320967) {\n            x_297648 = ((volatile __local\n                         int64_t *) color_320586)[sext_i32_i64(local_tid_320953)];\n            if ((local_tid_320953 - squot32(local_tid_320953, 32) * 32) == 0) {\n                x_297647 = x_297648;\n            }\n        }\n    }\n    // in-block scan (hopefully no barriers needed)\n    {\n        skip_threads_320968 = 1;\n        while (slt32(skip_threads_320968, 32)) {\n            bool thread_active_320969 = sle32(skip_threads_320968,\n                                              local_tid_320953 -\n                                              squot32(local_tid_320953, 32) *\n                                              32) && ltid_in_bounds_320967;\n            \n            if (thread_active_320969) {\n                // read operands\n                {\n                    x_297647 = ((volatile __local\n                                 int64_t *) color_320586)[sext_i32_i64(local_tid_320953) -\n                                                          sext_i32_i64(skip_threads_320968)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_320970 =\n                     slt64(srem64(sext_i32_i64(local_tid_320953), n_292675),\n                           sext_i32_i64(local_tid_320953) -\n                           sext_i32_i64(local_tid_320953 -\n                           skip_threads_320968));\n                \n                if (thread_active_320969 && inactive_320970) {\n                    x_297647 = x_297648;\n                }\n                if (thread_active_320969) {\n                    if (!inactive_320970) {\n                        int64_t defunc_1_op_res_297649 = add64(x_297647,\n                                                               x_297648);\n                        \n                        x_297647 = defunc_",
            "1_op_res_297649;\n                    }\n                }\n            }\n            if (sle32(wave_sizze_320955, skip_threads_320968)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            if (thread_active_320969) {\n                // write result\n                {\n                    ((volatile __local\n                      int64_t *) color_320586)[sext_i32_i64(local_tid_320953)] =\n                        x_297647;\n                    x_297648 = x_297647;\n                }\n            }\n            if (sle32(wave_sizze_320955, skip_threads_320968)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            skip_threads_320968 *= 2;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // last thread of block 'i' writes its result to offset 'i'\n    {\n        if ((local_tid_320953 - squot32(local_tid_320953, 32) * 32) == 31 &&\n            ltid_in_bounds_320967) {\n            ((volatile __local\n              int64_t *) color_320586)[sext_i32_i64(squot32(local_tid_320953,\n                                                            32))] = x_297647;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n    {\n        int32_t skip_threads_320971;\n        \n        // read input for in-block scan\n        {\n            if (squot32(local_tid_320953, 32) == 0 && ltid_in_bounds_320967) {\n                x_320965 = ((volatile __local\n                             int64_t *) color_320586)[sext_i32_i64(local_tid_320953)];\n                if ((local_tid_320953 - squot32(local_tid_320953, 32) * 32) ==\n                    0) {\n                    x_320964 = x_320965;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_320971 = 1;\n            while (slt32(skip_threads_320971, 32)) {\n                bool thread_active_320972 = sle32(skip_threads_320971,\n                                       ",
            "           local_tid_320953 -\n                                                  squot32(local_tid_320953,\n                                                          32) * 32) &&\n                     (squot32(local_tid_320953, 32) == 0 &&\n                      ltid_in_bounds_320967);\n                \n                if (thread_active_320972) {\n                    // read operands\n                    {\n                        x_320964 = ((volatile __local\n                                     int64_t *) color_320586)[sext_i32_i64(local_tid_320953) -\n                                                              sext_i32_i64(skip_threads_320971)];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_320973 =\n                         slt64(srem64(sext_i32_i64(local_tid_320953 * 32 + 32 -\n                                      1), n_292675),\n                               sext_i32_i64(local_tid_320953 * 32 + 32 - 1) -\n                               sext_i32_i64((local_tid_320953 -\n                                             skip_threads_320971) * 32 + 32 -\n                               1));\n                    \n                    if (thread_active_320972 && inactive_320973) {\n                        x_320964 = x_320965;\n                    }\n                    if (thread_active_320972) {\n                        if (!inactive_320973) {\n                            int64_t defunc_1_op_res_320966 = add64(x_320964,\n                                                                   x_320965);\n                            \n                            x_320964 = defunc_1_op_res_320966;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_320955, skip_threads_320971)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_320972) {\n                    // write result\n                    {\n                    ",
            "    ((volatile __local\n                          int64_t *) color_320586)[sext_i32_i64(local_tid_320953)] =\n                            x_320964;\n                        x_320965 = x_320964;\n                    }\n                }\n                if (sle32(wave_sizze_320955, skip_threads_320971)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_320971 *= 2;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    bool no_carry_in_320974 = squot32(local_tid_320953, 32) == 0 ||\n         !ltid_in_bounds_320967;\n    \n    // carry-in for every block except the first\n    {\n        // read operands\n        {\n            if (!no_carry_in_320974) {\n                x_297648 = x_297647;\n                x_297647 = ((__local\n                             int64_t *) color_320586)[sext_i32_i64(squot32(local_tid_320953,\n                                                                           32)) -\n                                                      (int64_t) 1];\n            }\n        }\n        // perform operation\n        {\n            bool inactive_320975 = slt64(srem64(sext_i32_i64(local_tid_320953),\n                                                n_292675),\n                                         sext_i32_i64(local_tid_320953) -\n                                         sext_i32_i64(squot32(local_tid_320953,\n                                                              32) * 32 - 1));\n            \n            if (!no_carry_in_320974) {\n                if (inactive_320975) {\n                    x_297647 = x_297648;\n                }\n            }\n            if (!no_carry_in_320974) {\n                if (!inactive_320975) {\n                    int64_t defunc_1_op_res_297649 = add64(x_297647, x_297648);\n                    \n                    x_297647 = defunc_1_op_res_297649;\n                }\n            }\n        }\n        // write final result\n        {\n            if (!no_carry_in_320974) {\n               ",
            " ((__local\n                  int64_t *) color_320586)[sext_i32_i64(local_tid_320953)] =\n                    x_297647;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // restore correct values for first block\n    {\n        if (squot32(local_tid_320953, 32) == 0 && ltid_in_bounds_320967) {\n            ((__local int64_t *) color_320586)[sext_i32_i64(local_tid_320953)] =\n                x_297648;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t last_res_297654;\n    \n    last_res_297654 = ((__local int64_t *) color_320586)[i_292846];\n    \n    int64_t rep_i_320977 = sext_i32_i64(sext_i64_i32(ltid_pre_320957));\n    \n    ((__local int64_t *) color_320585)[rep_i_320977] = (int64_t) -1;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_297658 = local_tid_320953;\n    int64_t write_i_297657 = sext_i32_i64(sext_i64_i32(ltid_pre_320957));\n    float x_297659;\n    \n    x_297659 = ((__global float *) mem_318506)[gtid_297640 * n_292675 +\n                                               write_i_297657];\n    \n    bool isnan_res_297662;\n    \n    isnan_res_297662 = futrts_isnan32(x_297659);\n    \n    bool defunc_0_p_res_297663 = !isnan_res_297662;\n    int64_t defunc_1_f_res_297664;\n    \n    if (defunc_0_p_res_297663) {\n        int64_t x_297660;\n        \n        x_297660 = ((__local int64_t *) color_320586)[write_i_297657];\n        \n        int64_t defunc_1_f_res_t_res_297665 = sub64(x_297660, (int64_t) 1);\n        \n        defunc_1_f_res_297664 = defunc_1_f_res_t_res_297665;\n    } else {\n        defunc_1_f_res_297664 = (int64_t) -1;\n    }\n    if (sle64((int64_t) 0, defunc_1_f_res_297664) &&\n        slt64(defunc_1_f_res_297664, n_292675)) {\n        ((__local int64_t *) color_320585)[defunc_1_f_res_297664] =\n            write_i_297657;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t tmp_320978;\n    \n    tmp_320978 = ((__local\n                   int64_t *) color_320585)[sext_i32_i64(local_tid_320953)];\n    ((__global int64_t *) mem_31852",
            "3)[gtid_297640 * n_292675 +\n                                      sext_i32_i64(local_tid_320953)] =\n        tmp_320978;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    if (local_tid_320953 == 0) {\n        ((__global int64_t *) mem_318526)[gtid_297640] = last_res_297654;\n    }\n    \n  error_2:\n    return;\n}\n__kernel void mainzisegmap_intragroup_298000(__global int *global_failure,\n                                             uint color_320588_backing_offset_0,\n                                             uint color_320587_backing_offset_1,\n                                             int64_t n_p_292677,\n                                             int64_t partition_sizze_292766,\n                                             int64_t defunc_0_f_res_292820,\n                                             int64_t i_292895,\n                                             int64_t computed_group_sizze_297939,\n                                             int32_t num_chunks_321127, __global\n                                             unsigned char *mem_318551, __global\n                                             unsigned char *mem_318567, __global\n                                             unsigned char *mem_318571)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *color_320588_backing_1 =\n                           &shared_mem[color_320588_backing_offset_0];\n    volatile unsigned char *color_320587_backing_0 =\n                           &shared_mem[color_320587_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321128;\n    int32_t local_tid_321129;\n    int64_t group_sizze_321132;\n    int32_t wave_sizze_321131;\n    int32_t group_tid_321130;\n    \n    global_tid_321128 = get_global_id(0);\n    local_tid_321129 = get_local_id(0);\n    group_sizze_321132 = get_local_size(0);\n    wave_sizze_321131 = LOCKSTEP_WIDTH;\n    group_tid_321130 = get_group_id(0);\n    \n    int32_t phys_tid_2",
            "98000 = group_tid_321130;\n    int64_t slice_321135 = defunc_0_f_res_292820;\n    int64_t slice_321136 = n_p_292677 * slice_321135;\n    int64_t ltid_pre_321133 = squot64(sext_i32_i64(local_tid_321129),\n                                      slice_321135);\n    int64_t remnant_321137 = sext_i32_i64(local_tid_321129) - ltid_pre_321133 *\n            slice_321135;\n    int64_t ltid_pre_321134 = remnant_321137;\n    int64_t remnant_321138 = remnant_321137 - ltid_pre_321134;\n    int64_t slice_321139 = partition_sizze_292766;\n    int64_t gtid_297999 = sext_i32_i64(group_tid_321130);\n    int64_t remnant_321140 = sext_i32_i64(group_tid_321130) - gtid_297999;\n    __local unsigned char *color_320587;\n    \n    color_320587 = (__local unsigned char *) color_320587_backing_0;\n    \n    __local unsigned char *color_320588;\n    \n    color_320588 = (__local unsigned char *) color_320588_backing_1;\n    \n    int32_t phys_tid_298006 = local_tid_321129;\n    int64_t gtid_298004 = sext_i32_i64(sext_i64_i32(ltid_pre_321133));\n    int64_t gtid_298005 = sext_i32_i64(sext_i64_i32(ltid_pre_321134));\n    \n    if (slt64(gtid_298004, n_p_292677) && slt64(gtid_298005,\n                                                defunc_0_f_res_292820)) {\n        double x_298011;\n        \n        x_298011 = ((__global double *) mem_318551)[gtid_297999 *\n                                                    (defunc_0_f_res_292820 *\n                                                     n_p_292677) + gtid_298004 *\n                                                    defunc_0_f_res_292820 +\n                                                    gtid_298005];\n        \n        bool isnan_res_298012;\n        \n        isnan_res_298012 = futrts_isnan64(x_298011);\n        \n        bool defunc_0_p_res_298013 = !isnan_res_298012;\n        int64_t defunc_0_f_res_298014 = btoi_bool_i64(defunc_0_p_res_298013);\n        \n        ((__local int64_t *) color_320588)[gtid_298004 * defunc_0_f_res_292820 +\n                                           ",
            "gtid_298005] = defunc_0_f_res_298014;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t dims_flat_321141 = n_p_292677 * defunc_0_f_res_292820;\n    int64_t x_298007;\n    int64_t x_298008;\n    int64_t x_321143;\n    int64_t x_321144;\n    bool ltid_in_bounds_321146 = slt64(sext_i32_i64(local_tid_321129),\n                                       n_p_292677 * defunc_0_f_res_292820);\n    int32_t skip_threads_321147;\n    \n    // read input for in-block scan\n    {\n        if (ltid_in_bounds_321146) {\n            x_298008 = ((volatile __local\n                         int64_t *) color_320588)[sext_i32_i64(local_tid_321129)];\n            if ((local_tid_321129 - squot32(local_tid_321129, 32) * 32) == 0) {\n                x_298007 = x_298008;\n            }\n        }\n    }\n    // in-block scan (hopefully no barriers needed)\n    {\n        skip_threads_321147 = 1;\n        while (slt32(skip_threads_321147, 32)) {\n            bool thread_active_321148 = sle32(skip_threads_321147,\n                                              local_tid_321129 -\n                                              squot32(local_tid_321129, 32) *\n                                              32) && ltid_in_bounds_321146;\n            \n            if (thread_active_321148) {\n                // read operands\n                {\n                    x_298007 = ((volatile __local\n                                 int64_t *) color_320588)[sext_i32_i64(local_tid_321129) -\n                                                          sext_i32_i64(skip_threads_321147)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_321149 =\n                     slt64(srem64(sext_i32_i64(local_tid_321129),\n                                  defunc_0_f_res_292820),\n                           sext_i32_i64(local_tid_321129) -\n                           sext_i32_i64(local_tid_321129 -\n                           skip_threads_321147));\n                \n                if (thread_active",
            "_321148 && inactive_321149) {\n                    x_298007 = x_298008;\n                }\n                if (thread_active_321148) {\n                    if (!inactive_321149) {\n                        int64_t defunc_1_op_res_298009 = add64(x_298007,\n                                                               x_298008);\n                        \n                        x_298007 = defunc_1_op_res_298009;\n                    }\n                }\n            }\n            if (sle32(wave_sizze_321131, skip_threads_321147)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            if (thread_active_321148) {\n                // write result\n                {\n                    ((volatile __local\n                      int64_t *) color_320588)[sext_i32_i64(local_tid_321129)] =\n                        x_298007;\n                    x_298008 = x_298007;\n                }\n            }\n            if (sle32(wave_sizze_321131, skip_threads_321147)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            skip_threads_321147 *= 2;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // last thread of block 'i' writes its result to offset 'i'\n    {\n        if ((local_tid_321129 - squot32(local_tid_321129, 32) * 32) == 31 &&\n            ltid_in_bounds_321146) {\n            ((volatile __local\n              int64_t *) color_320588)[sext_i32_i64(squot32(local_tid_321129,\n                                                            32))] = x_298007;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n    {\n        int32_t skip_threads_321150;\n        \n        // read input for in-block scan\n        {\n            if (squot32(local_tid_321129, 32) == 0 && ltid_in_bounds_321146) {\n                x_321144 = ((volatile __local\n                             int64_t *) color_320588)[sext_i32_i64(local_tid_321129)];\n                if ((local_tid_321129 - squot32(local_tid_3211",
            "29, 32) * 32) ==\n                    0) {\n                    x_321143 = x_321144;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_321150 = 1;\n            while (slt32(skip_threads_321150, 32)) {\n                bool thread_active_321151 = sle32(skip_threads_321150,\n                                                  local_tid_321129 -\n                                                  squot32(local_tid_321129,\n                                                          32) * 32) &&\n                     (squot32(local_tid_321129, 32) == 0 &&\n                      ltid_in_bounds_321146);\n                \n                if (thread_active_321151) {\n                    // read operands\n                    {\n                        x_321143 = ((volatile __local\n                                     int64_t *) color_320588)[sext_i32_i64(local_tid_321129) -\n                                                              sext_i32_i64(skip_threads_321150)];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_321152 =\n                         slt64(srem64(sext_i32_i64(local_tid_321129 * 32 + 32 -\n                                      1), defunc_0_f_res_292820),\n                               sext_i32_i64(local_tid_321129 * 32 + 32 - 1) -\n                               sext_i32_i64((local_tid_321129 -\n                                             skip_threads_321150) * 32 + 32 -\n                               1));\n                    \n                    if (thread_active_321151 && inactive_321152) {\n                        x_321143 = x_321144;\n                    }\n                    if (thread_active_321151) {\n                        if (!inactive_321152) {\n                            int64_t defunc_1_op_res_321145 = add64(x_321143,\n                                                                   x_321144);\n             ",
            "               \n                            x_321143 = defunc_1_op_res_321145;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_321131, skip_threads_321150)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_321151) {\n                    // write result\n                    {\n                        ((volatile __local\n                          int64_t *) color_320588)[sext_i32_i64(local_tid_321129)] =\n                            x_321143;\n                        x_321144 = x_321143;\n                    }\n                }\n                if (sle32(wave_sizze_321131, skip_threads_321150)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_321150 *= 2;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    bool no_carry_in_321153 = squot32(local_tid_321129, 32) == 0 ||\n         !ltid_in_bounds_321146;\n    \n    // carry-in for every block except the first\n    {\n        // read operands\n        {\n            if (!no_carry_in_321153) {\n                x_298008 = x_298007;\n                x_298007 = ((__local\n                             int64_t *) color_320588)[sext_i32_i64(squot32(local_tid_321129,\n                                                                           32)) -\n                                                      (int64_t) 1];\n            }\n        }\n        // perform operation\n        {\n            bool inactive_321154 = slt64(srem64(sext_i32_i64(local_tid_321129),\n                                                defunc_0_f_res_292820),\n                                         sext_i32_i64(local_tid_321129) -\n                                         sext_i32_i64(squot32(local_tid_321129,\n                                                              32) * 32 - 1));\n            \n            if (!no_carry_in_321153) {\n                if (inactive_321154) {\n                    x_29800",
            "7 = x_298008;\n                }\n            }\n            if (!no_carry_in_321153) {\n                if (!inactive_321154) {\n                    int64_t defunc_1_op_res_298009 = add64(x_298007, x_298008);\n                    \n                    x_298007 = defunc_1_op_res_298009;\n                }\n            }\n        }\n        // write final result\n        {\n            if (!no_carry_in_321153) {\n                ((__local\n                  int64_t *) color_320588)[sext_i32_i64(local_tid_321129)] =\n                    x_298007;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // restore correct values for first block\n    {\n        if (squot32(local_tid_321129, 32) == 0 && ltid_in_bounds_321146) {\n            ((__local int64_t *) color_320588)[sext_i32_i64(local_tid_321129)] =\n                x_298008;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    for (int32_t chunk_i_321158 = 0; chunk_i_321158 < num_chunks_321127;\n         chunk_i_321158++) {\n        int32_t i_321159 = chunk_i_321158 *\n                sext_i64_i32(computed_group_sizze_297939) + local_tid_321129;\n        int64_t slice_321160 = defunc_0_f_res_292820;\n        int64_t slice_321161 = n_p_292677 * slice_321160;\n        int64_t rep_i_321156 = squot64(sext_i32_i64(i_321159), slice_321160);\n        int64_t remnant_321162 = sext_i32_i64(i_321159) - rep_i_321156 *\n                slice_321160;\n        int64_t rep_i_321157 = remnant_321162;\n        int64_t remnant_321163 = remnant_321162 - rep_i_321157;\n        \n        if ((sle64((int64_t) 0, rep_i_321156) && slt64(rep_i_321156,\n                                                       n_p_292677)) &&\n            (sle64((int64_t) 0, rep_i_321157) && slt64(rep_i_321157,\n                                                       defunc_0_f_res_292820))) {\n            ((__local int64_t *) color_320587)[rep_i_321156 *\n                                               defunc_0_f_res_292820 +\n                                               rep_i_321",
            "157] = (int64_t) -1;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_298028 = local_tid_321129;\n    int64_t gtid_298026 = sext_i32_i64(sext_i64_i32(ltid_pre_321133));\n    int64_t gtid_298027 = sext_i32_i64(sext_i64_i32(ltid_pre_321134));\n    \n    if (slt64(gtid_298026, n_p_292677) && slt64(gtid_298027,\n                                                defunc_0_f_res_292820)) {\n        double x_298029;\n        \n        x_298029 = ((__global double *) mem_318551)[gtid_297999 *\n                                                    (defunc_0_f_res_292820 *\n                                                     n_p_292677) + gtid_298026 *\n                                                    defunc_0_f_res_292820 +\n                                                    gtid_298027];\n        \n        bool isnan_res_298032;\n        \n        isnan_res_298032 = futrts_isnan64(x_298029);\n        \n        bool defunc_0_p_res_298033 = !isnan_res_298032;\n        int64_t defunc_1_f_res_298034;\n        \n        if (defunc_0_p_res_298033) {\n            int64_t x_298030;\n            \n            x_298030 = ((__local int64_t *) color_320588)[gtid_298026 *\n                                                          defunc_0_f_res_292820 +\n                                                          gtid_298027];\n            \n            int64_t defunc_1_f_res_t_res_298035 = sub64(x_298030, (int64_t) 1);\n            \n            defunc_1_f_res_298034 = defunc_1_f_res_t_res_298035;\n        } else {\n            defunc_1_f_res_298034 = (int64_t) -1;\n        }\n        if ((sle64((int64_t) 0, gtid_298026) && slt64(gtid_298026,\n                                                      n_p_292677)) &&\n            (sle64((int64_t) 0, defunc_1_f_res_298034) &&\n             slt64(defunc_1_f_res_298034, defunc_0_f_res_292820))) {\n            ((__local int64_t *) color_320587)[gtid_298026 *\n                                               defunc_0_f_res_292820 +\n                             ",
            "                  defunc_1_f_res_298034] =\n                gtid_298027;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321164 = sdiv_up32(sext_i64_i32(n_p_292677) *\n                                          sext_i64_i32(defunc_0_f_res_292820),\n                                          sext_i64_i32(computed_group_sizze_297939));\n    \n    for (int32_t chunk_i_321165 = 0; chunk_i_321165 < num_chunks_321164;\n         chunk_i_321165++) {\n        int32_t i_321166 = chunk_i_321165 *\n                sext_i64_i32(computed_group_sizze_297939) + local_tid_321129;\n        \n        if (slt32(i_321166, sext_i64_i32(n_p_292677) *\n                  sext_i64_i32(defunc_0_f_res_292820))) {\n            int64_t tmp_321167;\n            \n            tmp_321167 = ((__local\n                           int64_t *) color_320587)[sext_i32_i64(squot32(i_321166,\n                                                                         sext_i64_i32(defunc_0_f_res_292820))) *\n                                                    defunc_0_f_res_292820 +\n                                                    sext_i32_i64(i_321166 -\n                                                    squot32(i_321166,\n                                                            sext_i64_i32(defunc_0_f_res_292820)) *\n                                                    sext_i64_i32(defunc_0_f_res_292820))];\n            ((__global int64_t *) mem_318567)[gtid_297999 *\n                                              (defunc_0_f_res_292820 *\n                                               n_p_292677) +\n                                              sext_i32_i64(squot32(i_321166,\n                                                                   sext_i64_i32(defunc_0_f_res_292820))) *\n                                              defunc_0_f_res_292820 +\n                                              sext_i32_i64(i_321166 -\n                                              squot32(i_321166,\n                    ",
            "                                  sext_i64_i32(defunc_0_f_res_292820)) *\n                                              sext_i64_i32(defunc_0_f_res_292820))] =\n                tmp_321167;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321168 = sdiv_up32(sext_i64_i32(n_p_292677),\n                                          sext_i64_i32(computed_group_sizze_297939));\n    \n    for (int32_t chunk_i_321169 = 0; chunk_i_321169 < num_chunks_321168;\n         chunk_i_321169++) {\n        int32_t i_321170 = chunk_i_321169 *\n                sext_i64_i32(computed_group_sizze_297939) + local_tid_321129;\n        \n        if (slt32(i_321170, sext_i64_i32(n_p_292677))) {\n            int64_t tmp_321171;\n            \n            tmp_321171 = ((__local int64_t *) color_320588)[i_292895 +\n                                                            sext_i32_i64(i_321170) *\n                                                            defunc_0_f_res_292820];\n            ((__global int64_t *) mem_318571)[gtid_297999 * n_p_292677 +\n                                              sext_i32_i64(i_321170)] =\n                tmp_321171;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n  error_2:\n    return;\n}\n__kernel void mainzisegmap_intragroup_298276(__global int *global_failure,\n                                             uint color_320590_backing_offset_0,\n                                             uint color_320589_backing_offset_1,\n                                             int64_t n_p_292677,\n                                             int64_t partition_sizze_292766,\n                                             int64_t defunc_0_f_res_292820,\n                                             int64_t i_292895, __global\n                                             unsigned char *mem_318551, __global\n                                             unsigned char *mem_318585, __global\n                                             unsigned char *mem_318589)\n{\n    cons",
            "t int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *color_320590_backing_1 =\n                           &shared_mem[color_320590_backing_offset_0];\n    volatile unsigned char *color_320589_backing_0 =\n                           &shared_mem[color_320589_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321173;\n    int32_t local_tid_321174;\n    int64_t group_sizze_321177;\n    int32_t wave_sizze_321176;\n    int32_t group_tid_321175;\n    \n    global_tid_321173 = get_global_id(0);\n    local_tid_321174 = get_local_id(0);\n    group_sizze_321177 = get_local_size(0);\n    wave_sizze_321176 = LOCKSTEP_WIDTH;\n    group_tid_321175 = get_group_id(0);\n    \n    int32_t phys_tid_298276 = group_tid_321175;\n    int64_t slice_321179 = defunc_0_f_res_292820;\n    int64_t ltid_pre_321178 = sext_i32_i64(local_tid_321174);\n    int64_t remnant_321180 = sext_i32_i64(local_tid_321174) - ltid_pre_321178;\n    int64_t slice_321181 = n_p_292677;\n    int64_t slice_321182 = partition_sizze_292766 * slice_321181;\n    int64_t gtid_298274 = squot64(sext_i32_i64(group_tid_321175), slice_321181);\n    int64_t remnant_321183 = sext_i32_i64(group_tid_321175) - gtid_298274 *\n            slice_321181;\n    int64_t gtid_298275 = remnant_321183;\n    int64_t remnant_321184 = remnant_321183 - gtid_298275;\n    __local unsigned char *color_320589;\n    \n    color_320589 = (__local unsigned char *) color_320589_backing_0;\n    \n    __local unsigned char *color_320590;\n    \n    color_320590 = (__local unsigned char *) color_320590_backing_1;\n    \n    int32_t phys_tid_298281 = local_tid_321174;\n    int64_t gtid_298280 = sext_i32_i64(sext_i64_i32(ltid_pre_321178));\n    double x_298285;\n    \n    x_298285 = ((__global double *) mem_318551)[gtid_298274 *\n                                                (defunc_0_f_res_292820 *\n                                                 n_p_292677) + gtid_298275 *\n                   ",
            "                             defunc_0_f_res_292820 +\n                                                gtid_298280];\n    \n    bool isnan_res_298286;\n    \n    isnan_res_298286 = futrts_isnan64(x_298285);\n    \n    bool defunc_0_p_res_298287 = !isnan_res_298286;\n    int64_t defunc_0_f_res_298288 = btoi_bool_i64(defunc_0_p_res_298287);\n    \n    ((__local int64_t *) color_320590)[gtid_298280] = defunc_0_f_res_298288;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t dims_flat_321185 = defunc_0_f_res_292820;\n    int64_t x_298282;\n    int64_t x_298283;\n    int64_t x_321187;\n    int64_t x_321188;\n    bool ltid_in_bounds_321190 = slt64(sext_i32_i64(local_tid_321174),\n                                       defunc_0_f_res_292820);\n    int32_t skip_threads_321191;\n    \n    // read input for in-block scan\n    {\n        if (ltid_in_bounds_321190) {\n            x_298283 = ((volatile __local\n                         int64_t *) color_320590)[sext_i32_i64(local_tid_321174)];\n            if ((local_tid_321174 - squot32(local_tid_321174, 32) * 32) == 0) {\n                x_298282 = x_298283;\n            }\n        }\n    }\n    // in-block scan (hopefully no barriers needed)\n    {\n        skip_threads_321191 = 1;\n        while (slt32(skip_threads_321191, 32)) {\n            bool thread_active_321192 = sle32(skip_threads_321191,\n                                              local_tid_321174 -\n                                              squot32(local_tid_321174, 32) *\n                                              32) && ltid_in_bounds_321190;\n            \n            if (thread_active_321192) {\n                // read operands\n                {\n                    x_298282 = ((volatile __local\n                                 int64_t *) color_320590)[sext_i32_i64(local_tid_321174) -\n                                                          sext_i32_i64(skip_threads_321191)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_321193 =",
            "\n                     slt64(srem64(sext_i32_i64(local_tid_321174),\n                                  defunc_0_f_res_292820),\n                           sext_i32_i64(local_tid_321174) -\n                           sext_i32_i64(local_tid_321174 -\n                           skip_threads_321191));\n                \n                if (thread_active_321192 && inactive_321193) {\n                    x_298282 = x_298283;\n                }\n                if (thread_active_321192) {\n                    if (!inactive_321193) {\n                        int64_t defunc_1_op_res_298284 = add64(x_298282,\n                                                               x_298283);\n                        \n                        x_298282 = defunc_1_op_res_298284;\n                    }\n                }\n            }\n            if (sle32(wave_sizze_321176, skip_threads_321191)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            if (thread_active_321192) {\n                // write result\n                {\n                    ((volatile __local\n                      int64_t *) color_320590)[sext_i32_i64(local_tid_321174)] =\n                        x_298282;\n                    x_298283 = x_298282;\n                }\n            }\n            if (sle32(wave_sizze_321176, skip_threads_321191)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            skip_threads_321191 *= 2;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // last thread of block 'i' writes its result to offset 'i'\n    {\n        if ((local_tid_321174 - squot32(local_tid_321174, 32) * 32) == 31 &&\n            ltid_in_bounds_321190) {\n            ((volatile __local\n              int64_t *) color_320590)[sext_i32_i64(squot32(local_tid_321174,\n                                                            32))] = x_298282;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n    {\n        int32_t skip_threa",
            "ds_321194;\n        \n        // read input for in-block scan\n        {\n            if (squot32(local_tid_321174, 32) == 0 && ltid_in_bounds_321190) {\n                x_321188 = ((volatile __local\n                             int64_t *) color_320590)[sext_i32_i64(local_tid_321174)];\n                if ((local_tid_321174 - squot32(local_tid_321174, 32) * 32) ==\n                    0) {\n                    x_321187 = x_321188;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_321194 = 1;\n            while (slt32(skip_threads_321194, 32)) {\n                bool thread_active_321195 = sle32(skip_threads_321194,\n                                                  local_tid_321174 -\n                                                  squot32(local_tid_321174,\n                                                          32) * 32) &&\n                     (squot32(local_tid_321174, 32) == 0 &&\n                      ltid_in_bounds_321190);\n                \n                if (thread_active_321195) {\n                    // read operands\n                    {\n                        x_321187 = ((volatile __local\n                                     int64_t *) color_320590)[sext_i32_i64(local_tid_321174) -\n                                                              sext_i32_i64(skip_threads_321194)];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_321196 =\n                         slt64(srem64(sext_i32_i64(local_tid_321174 * 32 + 32 -\n                                      1), defunc_0_f_res_292820),\n                               sext_i32_i64(local_tid_321174 * 32 + 32 - 1) -\n                               sext_i32_i64((local_tid_321174 -\n                                             skip_threads_321194) * 32 + 32 -\n                               1));\n                    \n                    if (thread_active_321195 && inacti",
            "ve_321196) {\n                        x_321187 = x_321188;\n                    }\n                    if (thread_active_321195) {\n                        if (!inactive_321196) {\n                            int64_t defunc_1_op_res_321189 = add64(x_321187,\n                                                                   x_321188);\n                            \n                            x_321187 = defunc_1_op_res_321189;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_321176, skip_threads_321194)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_321195) {\n                    // write result\n                    {\n                        ((volatile __local\n                          int64_t *) color_320590)[sext_i32_i64(local_tid_321174)] =\n                            x_321187;\n                        x_321188 = x_321187;\n                    }\n                }\n                if (sle32(wave_sizze_321176, skip_threads_321194)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_321194 *= 2;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    bool no_carry_in_321197 = squot32(local_tid_321174, 32) == 0 ||\n         !ltid_in_bounds_321190;\n    \n    // carry-in for every block except the first\n    {\n        // read operands\n        {\n            if (!no_carry_in_321197) {\n                x_298283 = x_298282;\n                x_298282 = ((__local\n                             int64_t *) color_320590)[sext_i32_i64(squot32(local_tid_321174,\n                                                                           32)) -\n                                                      (int64_t) 1];\n            }\n        }\n        // perform operation\n        {\n            bool inactive_321198 = slt64(srem64(sext_i32_i64(local_tid_321174),\n                                                defunc_0_f_res_292820),\n      ",
            "                                   sext_i32_i64(local_tid_321174) -\n                                         sext_i32_i64(squot32(local_tid_321174,\n                                                              32) * 32 - 1));\n            \n            if (!no_carry_in_321197) {\n                if (inactive_321198) {\n                    x_298282 = x_298283;\n                }\n            }\n            if (!no_carry_in_321197) {\n                if (!inactive_321198) {\n                    int64_t defunc_1_op_res_298284 = add64(x_298282, x_298283);\n                    \n                    x_298282 = defunc_1_op_res_298284;\n                }\n            }\n        }\n        // write final result\n        {\n            if (!no_carry_in_321197) {\n                ((__local\n                  int64_t *) color_320590)[sext_i32_i64(local_tid_321174)] =\n                    x_298282;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // restore correct values for first block\n    {\n        if (squot32(local_tid_321174, 32) == 0 && ltid_in_bounds_321190) {\n            ((__local int64_t *) color_320590)[sext_i32_i64(local_tid_321174)] =\n                x_298283;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t last_res_298289;\n    \n    last_res_298289 = ((__local int64_t *) color_320590)[i_292895];\n    \n    int64_t rep_i_321200 = sext_i32_i64(sext_i64_i32(ltid_pre_321178));\n    \n    ((__local int64_t *) color_320589)[rep_i_321200] = (int64_t) -1;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_298293 = local_tid_321174;\n    int64_t write_i_298292 = sext_i32_i64(sext_i64_i32(ltid_pre_321178));\n    double x_298294;\n    \n    x_298294 = ((__global double *) mem_318551)[gtid_298274 *\n                                                (defunc_0_f_res_292820 *\n                                                 n_p_292677) + gtid_298275 *\n                                                defunc_0_f_res_292820 +\n                                            ",
            "    write_i_298292];\n    \n    bool isnan_res_298297;\n    \n    isnan_res_298297 = futrts_isnan64(x_298294);\n    \n    bool defunc_0_p_res_298298 = !isnan_res_298297;\n    int64_t defunc_1_f_res_298299;\n    \n    if (defunc_0_p_res_298298) {\n        int64_t x_298295;\n        \n        x_298295 = ((__local int64_t *) color_320590)[write_i_298292];\n        \n        int64_t defunc_1_f_res_t_res_298300 = sub64(x_298295, (int64_t) 1);\n        \n        defunc_1_f_res_298299 = defunc_1_f_res_t_res_298300;\n    } else {\n        defunc_1_f_res_298299 = (int64_t) -1;\n    }\n    if (sle64((int64_t) 0, defunc_1_f_res_298299) &&\n        slt64(defunc_1_f_res_298299, defunc_0_f_res_292820)) {\n        ((__local int64_t *) color_320589)[defunc_1_f_res_298299] =\n            write_i_298292;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t tmp_321201;\n    \n    tmp_321201 = ((__local\n                   int64_t *) color_320589)[sext_i32_i64(local_tid_321174)];\n    ((__global int64_t *) mem_318585)[gtid_298274 * (defunc_0_f_res_292820 *\n                                                     n_p_292677) + gtid_298275 *\n                                      defunc_0_f_res_292820 +\n                                      sext_i32_i64(local_tid_321174)] =\n        tmp_321201;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    if (local_tid_321174 == 0) {\n        ((__global int64_t *) mem_318589)[gtid_298274 * n_p_292677 +\n                                          gtid_298275] = last_res_298289;\n    }\n    \n  error_2:\n    return;\n}\n__kernel void mainzisegmap_intragroup_298529(__global int *global_failure,\n                                             int failure_is_an_option, __global\n                                             int64_t *global_failure_args,\n                                             uint color_320597_backing_offset_0,\n                                             uint color_320596_backing_offset_1,\n                                             uint color_320595_backing_offset_2,\n                ",
            "                             uint color_320594_backing_offset_3,\n                                             uint color_320593_backing_offset_4,\n                                             uint color_320592_backing_offset_5,\n                                             uint color_320591_backing_offset_6,\n                                             int64_t n_p_292677,\n                                             int64_t q_s_292678,\n                                             int64_t jump_s_292684,\n                                             int64_t partition_sizze_292766,\n                                             int64_t defunc_0_f_res_292820,\n                                             int64_t pad_css_len_292821,\n                                             int64_t s_n_m_292825,\n                                             int64_t i_292895,\n                                             unsigned char x_292896_bits,\n                                             int64_t min_res_292926,\n                                             unsigned char loop_cond_292931_bits,\n                                             double i64_res_292932,\n                                             int64_t computed_group_sizze_298371,\n                                             __global\n                                             unsigned char *ext_mem_318609,\n                                             __global\n                                             unsigned char *ext_mem_318610,\n                                             __global unsigned char *mem_318643,\n                                             __global unsigned char *mem_318648)\n{\n    bool x_292896 = x_292896_bits;\n    bool loop_cond_292931 = loop_cond_292931_bits;\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *color_320597_backing_6 =\n                           &shared_mem[color_320597_backing_offset_0];\n    volatile unsigned char *color_32059",
            "6_backing_5 =\n                           &shared_mem[color_320596_backing_offset_1];\n    volatile unsigned char *color_320595_backing_4 =\n                           &shared_mem[color_320595_backing_offset_2];\n    volatile unsigned char *color_320594_backing_3 =\n                           &shared_mem[color_320594_backing_offset_3];\n    volatile unsigned char *color_320593_backing_2 =\n                           &shared_mem[color_320593_backing_offset_4];\n    volatile unsigned char *color_320592_backing_1 =\n                           &shared_mem[color_320592_backing_offset_5];\n    volatile unsigned char *color_320591_backing_0 =\n                           &shared_mem[color_320591_backing_offset_6];\n    volatile __local bool local_failure;\n    \n    if (failure_is_an_option) {\n        int failed = *global_failure >= 0;\n        \n        if (failed)\n            return;\n    }\n    local_failure = false;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t global_tid_321338;\n    int32_t local_tid_321339;\n    int64_t group_sizze_321342;\n    int32_t wave_sizze_321341;\n    int32_t group_tid_321340;\n    \n    global_tid_321338 = get_global_id(0);\n    local_tid_321339 = get_local_id(0);\n    group_sizze_321342 = get_local_size(0);\n    wave_sizze_321341 = LOCKSTEP_WIDTH;\n    group_tid_321340 = get_group_id(0);\n    \n    int32_t phys_tid_298529 = group_tid_321340;\n    int64_t slice_321344 = n_p_292677;\n    int64_t ltid_pre_321343 = sext_i32_i64(local_tid_321339);\n    int64_t remnant_321345 = sext_i32_i64(local_tid_321339) - ltid_pre_321343;\n    int64_t slice_321348 = defunc_0_f_res_292820;\n    int64_t slice_321349 = n_p_292677 * slice_321348;\n    int64_t ltid_pre_321346 = squot64(sext_i32_i64(local_tid_321339),\n                                      slice_321348);\n    int64_t remnant_321350 = sext_i32_i64(local_tid_321339) - ltid_pre_321346 *\n            slice_321348;\n    int64_t ltid_pre_321347 = remnant_321350;\n    int64_t remnant_321351 = remnant_321350 - ltid_pre_321347;\n    int64_t s",
            "lice_321354 = s_n_m_292825;\n    int64_t slice_321355 = n_p_292677 * slice_321354;\n    int64_t ltid_pre_321352 = squot64(sext_i32_i64(local_tid_321339),\n                                      slice_321354);\n    int64_t remnant_321356 = sext_i32_i64(local_tid_321339) - ltid_pre_321352 *\n            slice_321354;\n    int64_t ltid_pre_321353 = remnant_321356;\n    int64_t remnant_321357 = remnant_321356 - ltid_pre_321353;\n    int64_t slice_321358 = partition_sizze_292766;\n    int64_t gtid_298528 = sext_i32_i64(group_tid_321340);\n    int64_t remnant_321359 = sext_i32_i64(group_tid_321340) - gtid_298528;\n    __local unsigned char *color_320591;\n    \n    color_320591 = (__local unsigned char *) color_320591_backing_0;\n    \n    __local unsigned char *color_320592;\n    \n    color_320592 = (__local unsigned char *) color_320592_backing_1;\n    \n    __local unsigned char *color_320593;\n    \n    color_320593 = (__local unsigned char *) color_320593_backing_2;\n    \n    __local unsigned char *color_320594;\n    \n    color_320594 = (__local unsigned char *) color_320594_backing_3;\n    \n    __local unsigned char *color_320595;\n    \n    color_320595 = (__local unsigned char *) color_320595_backing_4;\n    \n    __local unsigned char *color_320596;\n    \n    color_320596 = (__local unsigned char *) color_320596_backing_5;\n    \n    __local unsigned char *color_320597;\n    \n    color_320597 = (__local unsigned char *) color_320597_backing_6;\n    \n    int32_t phys_tid_298537 = local_tid_321339;\n    int64_t gtid_298535 = sext_i32_i64(sext_i64_i32(ltid_pre_321346));\n    int64_t gtid_298536 = sext_i32_i64(sext_i64_i32(ltid_pre_321347));\n    \n    if (slt64(gtid_298535, n_p_292677) && slt64(gtid_298536,\n                                                defunc_0_f_res_292820)) {\n        int64_t x_298538;\n        \n        x_298538 = ((__global int64_t *) ext_mem_318610)[gtid_298528 *\n                                                         (defunc_0_f_res_292820 *\n                                      ",
            "                    n_p_292677) +\n                                                         gtid_298535 *\n                                                         defunc_0_f_res_292820 +\n                                                         gtid_298536];\n        \n        int64_t defunc_0_f_res_298539 = add64((int64_t) 1, x_298538);\n        \n        ((__local int64_t *) color_320597)[gtid_298535 * defunc_0_f_res_292820 +\n                                           gtid_298536] = defunc_0_f_res_298539;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_298545 = local_tid_321339;\n    int64_t gtid_298544 = sext_i32_i64(sext_i64_i32(ltid_pre_321343));\n    \n    if (slt64(gtid_298544, n_p_292677)) {\n        int64_t x_298546;\n        \n        x_298546 = ((__global int64_t *) ext_mem_318609)[gtid_298528 *\n                                                         n_p_292677 +\n                                                         gtid_298544];\n        \n        int64_t min_arg_298547 = sub64(x_298546, (int64_t) 1);\n        int64_t min_arg_298548 = sub64(x_298546, min_res_292926);\n        int64_t min_res_298549 = smin64(q_s_292678, x_298546);\n        double i64_res_298550 = sitofp_i64_f64(x_298546);\n        double x_298551 = i64_res_292932 - i64_res_298550;\n        double max_arg_298552 = x_298551 / 2.0;\n        double max_res_298553 = fmax64(0.0, max_arg_298552);\n        \n        ((__local int64_t *) color_320596)[gtid_298544] = min_arg_298547;\n        ((__local int64_t *) color_320595)[gtid_298544] = min_arg_298548;\n        ((__local int64_t *) color_320594)[gtid_298544] = min_res_298549;\n        ((__local double *) color_320593)[gtid_298544] = max_res_298553;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_298558 = local_tid_321339;\n    int64_t gtid_298556 = sext_i32_i64(sext_i64_i32(ltid_pre_321352));\n    int64_t gtid_298557 = sext_i32_i64(sext_i64_i32(ltid_pre_321353));\n    \n    if (slt64(gtid_298556, n_p_292677) && slt64(gtid_298557, s_n",
            "_m_292825)) {\n        int64_t min_arg_298560;\n        \n        min_arg_298560 = ((__local int64_t *) color_320596)[gtid_298556];\n        \n        int64_t min_arg_298561;\n        \n        min_arg_298561 = ((__local int64_t *) color_320595)[gtid_298556];\n        \n        int64_t min_res_298562;\n        \n        min_res_298562 = ((__local int64_t *) color_320594)[gtid_298556];\n        \n        double max_res_298563;\n        \n        max_res_298563 = ((__local double *) color_320593)[gtid_298556];\n        \n        bool cond_298565 = gtid_298557 == (int64_t) 0;\n        int64_t defunc_0_m_fun_res_298566;\n        \n        if (cond_298565) {\n            defunc_0_m_fun_res_298566 = (int64_t) 0;\n        } else {\n            int64_t y_298567 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_298568 = gtid_298557 == y_298567;\n            int64_t defunc_0_m_fun_res_f_res_298569;\n            \n            if (cond_298568) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_298570 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_298569 =\n                    defunc_0_m_fun_res_f_res_t_res_298570;\n            } else {\n                int64_t x_298571 = sub64(gtid_298557, (int64_t) 1);\n                int64_t x_298572 = mul64(jump_s_292684, x_298571);\n                int64_t min_arg_298573 = add64((int64_t) 1, x_298572);\n                int64_t min_res_298574 = smin64(defunc_0_f_res_292820,\n                                                min_arg_298573);\n                \n                defunc_0_m_fun_res_f_res_298569 = min_res_298574;\n            }\n            defunc_0_m_fun_res_298566 = defunc_0_m_fun_res_f_res_298569;\n        }\n        \n        bool init_idx_298575;\n        int64_t init_idx_298576;\n        int64_t init_idx_298577;\n        bool loop_while_298578;\n        int64_t low_298579;\n        int64_t high_298580;\n        \n        loop_while_298578 = x_292896;\n        low_298579 = (int64_t) 0",
            ";\n        high_298580 = i_292895;\n        while (loop_while_298578) {\n            int64_t x_298581 = add64(low_298579, high_298580);\n            int64_t mid_298582 = sdiv64(x_298581, (int64_t) 2);\n            bool x_298583 = sle64((int64_t) 0, mid_298582);\n            bool y_298584 = slt64(mid_298582, defunc_0_f_res_292820);\n            bool bounds_check_298585 = x_298583 && y_298584;\n            bool index_certs_298586;\n            \n            if (!bounds_check_298585) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 2) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) mid_298582;\n                        global_failure_args[1] =\n                            (int64_t) defunc_0_f_res_292820;\n                        ;\n                    }\n                    local_failure = true;\n                    goto error_2;\n                }\n            }\n            \n            int64_t mid_id_298587;\n            \n            mid_id_298587 = ((__local int64_t *) color_320597)[gtid_298556 *\n                                                               defunc_0_f_res_292820 +\n                                                               mid_298582];\n            \n            bool cond_298588 = slt64(mid_id_298587, (int64_t) 0);\n            int64_t mid_idx_298589;\n            \n            if (cond_298588) {\n                mid_idx_298589 = (int64_t) 9223372036854775807;\n            } else {\n                mid_idx_298589 = mid_id_298587;\n            }\n            \n            bool cond_298590 = sle64(defunc_0_m_fun_res_298566, mid_idx_298589);\n            int64_t loopres_298591;\n            int64_t loopres_298592;\n            \n            if (cond_298590) {\n                int64_t loopres_t_res_298593 = sub64(mid_298582, (int64_t) 1);\n                \n                loopres_298591 = low_298579;\n                loopres_298592 = loopres_t_res_298593;\n            } else {\n                int64_t loo",
            "pres_f_res_298594 = add64((int64_t) 1, mid_298582);\n                \n                loopres_298591 = loopres_f_res_298594;\n                loopres_298592 = high_298580;\n            }\n            \n            bool loop_cond_298595 = sle64(loopres_298591, loopres_298592);\n            bool loop_while_tmp_321360 = loop_cond_298595;\n            int64_t low_tmp_321361 = loopres_298591;\n            int64_t high_tmp_321362 = loopres_298592;\n            \n            loop_while_298578 = loop_while_tmp_321360;\n            low_298579 = low_tmp_321361;\n            high_298580 = high_tmp_321362;\n        }\n        init_idx_298575 = loop_while_298578;\n        init_idx_298576 = low_298579;\n        init_idx_298577 = high_298580;\n        \n        bool idx_298596;\n        int64_t idx_298597;\n        int64_t idx_298598;\n        int64_t idx_298599;\n        bool loop_while_298600;\n        int64_t l_idx_298601;\n        int64_t r_idx_298602;\n        int64_t span_298603;\n        \n        loop_while_298600 = loop_cond_292931;\n        l_idx_298601 = init_idx_298576;\n        r_idx_298602 = init_idx_298576;\n        span_298603 = (int64_t) 1;\n        while (loop_while_298600) {\n            int64_t max_arg_298604 = sub64(l_idx_298601, (int64_t) 1);\n            int64_t max_res_298605 = smax64((int64_t) 0, max_arg_298604);\n            int64_t min_arg_298606 = add64((int64_t) 1, r_idx_298602);\n            int64_t min_res_298607 = smin64(min_arg_298560, min_arg_298606);\n            bool x_298608 = sle64((int64_t) 0, max_res_298605);\n            bool y_298609 = slt64(max_res_298605, defunc_0_f_res_292820);\n            bool bounds_check_298610 = x_298608 && y_298609;\n            bool index_certs_298611;\n            \n            if (!bounds_check_298610) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 3) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) max_res_298605;\n                        global_failure_args[1] =\n   ",
            "                         (int64_t) defunc_0_f_res_292820;\n                        ;\n                    }\n                    local_failure = true;\n                    goto error_2;\n                }\n            }\n            \n            int64_t x_298612;\n            \n            x_298612 = ((__local int64_t *) color_320597)[gtid_298556 *\n                                                          defunc_0_f_res_292820 +\n                                                          max_res_298605];\n            \n            int64_t abs_arg_298613 = sub64(x_298612, defunc_0_m_fun_res_298566);\n            int64_t abs_res_298614 = abs64(abs_arg_298613);\n            bool x_298615 = sle64((int64_t) 0, min_res_298607);\n            bool y_298616 = slt64(min_res_298607, defunc_0_f_res_292820);\n            bool bounds_check_298617 = x_298615 && y_298616;\n            bool index_certs_298618;\n            \n            if (!bounds_check_298617) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 4) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) min_res_298607;\n                        global_failure_args[1] =\n                            (int64_t) defunc_0_f_res_292820;\n                        ;\n                    }\n                    local_failure = true;\n                    goto error_2;\n                }\n            }\n            \n            int64_t x_298619;\n            \n            x_298619 = ((__local int64_t *) color_320597)[gtid_298556 *\n                                                          defunc_0_f_res_292820 +\n                                                          min_res_298607];\n            \n            int64_t abs_arg_298620 = sub64(x_298619, defunc_0_m_fun_res_298566);\n            int64_t abs_res_298621 = abs64(abs_arg_298620);\n            bool cond_298622 = max_res_298605 == l_idx_298601;\n            int64_t loopres_298623;\n            int64_t loopres_298624;\n            int64_t",
            " loopres_298625;\n            \n            if (cond_298622) {\n                loopres_298623 = l_idx_298601;\n                loopres_298624 = r_idx_298602;\n                loopres_298625 = min_res_292926;\n            } else {\n                bool cond_298626 = slt64(abs_res_298614, abs_res_298621);\n                bool cond_f_res_298627 = min_res_298607 == r_idx_298602;\n                bool x_298628 = !cond_298626;\n                bool y_298629 = cond_f_res_298627 && x_298628;\n                bool cond_298630 = cond_298626 || y_298629;\n                int64_t loopres_f_res_298631;\n                \n                if (cond_298630) {\n                    loopres_f_res_298631 = max_res_298605;\n                } else {\n                    loopres_f_res_298631 = l_idx_298601;\n                }\n                \n                int64_t loopres_f_res_298632;\n                \n                if (cond_298630) {\n                    loopres_f_res_298632 = r_idx_298602;\n                } else {\n                    loopres_f_res_298632 = min_res_298607;\n                }\n                \n                int64_t loopres_f_res_298633;\n                \n                if (cond_298630) {\n                    int64_t loopres_f_res_t_res_298634 = add64((int64_t) 1,\n                                                               span_298603);\n                    \n                    loopres_f_res_298633 = loopres_f_res_t_res_298634;\n                } else {\n                    int64_t loopres_f_res_f_res_298635 = add64((int64_t) 1,\n                                                               span_298603);\n                    \n                    loopres_f_res_298633 = loopres_f_res_f_res_298635;\n                }\n                loopres_298623 = loopres_f_res_298631;\n                loopres_298624 = loopres_f_res_298632;\n                loopres_298625 = loopres_f_res_298633;\n            }\n            \n            bool loop_cond_298636 = slt64(loopres_298625, min_res_292926);\n            b",
            "ool loop_while_tmp_321363 = loop_cond_298636;\n            int64_t l_idx_tmp_321364 = loopres_298623;\n            int64_t r_idx_tmp_321365 = loopres_298624;\n            int64_t span_tmp_321366 = loopres_298625;\n            \n            loop_while_298600 = loop_while_tmp_321363;\n            l_idx_298601 = l_idx_tmp_321364;\n            r_idx_298602 = r_idx_tmp_321365;\n            span_298603 = span_tmp_321366;\n        }\n        idx_298596 = loop_while_298600;\n        idx_298597 = l_idx_298601;\n        idx_298598 = r_idx_298602;\n        idx_298599 = span_298603;\n        \n        int64_t min_res_298637 = smin64(min_arg_298561, idx_298597);\n        int64_t max_res_298638 = smax64((int64_t) 0, min_res_298637);\n        int64_t defunc_0_m_fun_res_298639;\n        \n        if (cond_298565) {\n            defunc_0_m_fun_res_298639 = (int64_t) 0;\n        } else {\n            int64_t y_298640 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_298641 = gtid_298557 == y_298640;\n            int64_t defunc_0_m_fun_res_f_res_298642;\n            \n            if (cond_298641) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_298643 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_298642 =\n                    defunc_0_m_fun_res_f_res_t_res_298643;\n            } else {\n                int64_t x_298644 = sub64(gtid_298557, (int64_t) 1);\n                int64_t x_298645 = mul64(jump_s_292684, x_298644);\n                int64_t min_arg_298646 = add64((int64_t) 1, x_298645);\n                int64_t min_res_298647 = smin64(defunc_0_f_res_292820,\n                                                min_arg_298646);\n                \n                defunc_0_m_fun_res_f_res_298642 = min_res_298647;\n            }\n            defunc_0_m_fun_res_298639 = defunc_0_m_fun_res_f_res_298642;\n        }\n        \n        int64_t x_298648 = add64(min_res_298562, max_res_298638);\n        int64_t r_298649 = sub64(x_298648, (int6",
            "4_t) 1);\n        bool x_298650 = sle64((int64_t) 0, r_298649);\n        bool y_298651 = slt64(r_298649, defunc_0_f_res_292820);\n        bool bounds_check_298652 = x_298650 && y_298651;\n        bool index_certs_298653;\n        \n        if (!bounds_check_298652) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 5) == -1) {\n                    global_failure_args[0] = (int64_t) r_298649;\n                    global_failure_args[1] = (int64_t) defunc_0_f_res_292820;\n                    ;\n                }\n                local_failure = true;\n                goto error_2;\n            }\n        }\n        \n        int64_t x_298654;\n        \n        x_298654 = ((__local int64_t *) color_320597)[gtid_298556 *\n                                                      defunc_0_f_res_292820 +\n                                                      r_298649];\n        \n        int64_t abs_arg_298655 = sub64(x_298654, defunc_0_m_fun_res_298639);\n        int64_t abs_res_298656 = abs64(abs_arg_298655);\n        bool x_298657 = sle64((int64_t) 0, max_res_298638);\n        bool y_298658 = slt64(max_res_298638, defunc_0_f_res_292820);\n        bool bounds_check_298659 = x_298657 && y_298658;\n        bool index_certs_298660;\n        \n        if (!bounds_check_298659) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 6) == -1) {\n                    global_failure_args[0] = (int64_t) max_res_298638;\n                    global_failure_args[1] = (int64_t) defunc_0_f_res_292820;\n                    ;\n                }\n                local_failure = true;\n                goto error_2;\n            }\n        }\n        \n        int64_t x_298661;\n        \n        x_298661 = ((__local int64_t *) color_320597)[gtid_298556 *\n                                                      defunc_0_f_res_292820 +\n                                                      max_res_298638];\n        \n        int64_t abs_arg_298662 = sub64(x_298661, defunc_0_m_fun_re",
            "s_298639);\n        int64_t abs_res_298663 = abs64(abs_arg_298662);\n        int64_t max_res_298664 = smax64(abs_res_298656, abs_res_298663);\n        double defunc_0_f_res_298665 = sitofp_i64_f64(max_res_298664);\n        double defunc_1_f_res_298666 = max_res_298563 + defunc_0_f_res_298665;\n        \n        ((__local double *) color_320592)[gtid_298556 * s_n_m_292825 +\n                                          gtid_298557] = defunc_1_f_res_298666;\n        ((__local int64_t *) color_320591)[gtid_298556 * s_n_m_292825 +\n                                           gtid_298557] = max_res_298638;\n    }\n    \n  error_2:\n    barrier(CLK_LOCAL_MEM_FENCE);\n    if (local_failure)\n        return;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321367 = sdiv_up32(sext_i64_i32(n_p_292677) *\n                                          sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_298371));\n    \n    for (int32_t chunk_i_321368 = 0; chunk_i_321368 < num_chunks_321367;\n         chunk_i_321368++) {\n        int32_t i_321369 = chunk_i_321368 *\n                sext_i64_i32(computed_group_sizze_298371) + local_tid_321339;\n        \n        if (slt32(i_321369, sext_i64_i32(n_p_292677) *\n                  sext_i64_i32(s_n_m_292825))) {\n            int64_t tmp_321370;\n            \n            tmp_321370 = ((__local\n                           int64_t *) color_320591)[sext_i32_i64(squot32(i_321369,\n                                                                         sext_i64_i32(s_n_m_292825))) *\n                                                    s_n_m_292825 +\n                                                    sext_i32_i64(i_321369 -\n                                                    squot32(i_321369,\n                                                            sext_i64_i32(s_n_m_292825)) *\n                                                    sext_i64_i32(s_n_m_292825))];\n            ((__global int64_t *) mem_318643)[gtid_",
            "298528 * (s_n_m_292825 *\n                                                             n_p_292677) +\n                                              sext_i32_i64(squot32(i_321369,\n                                                                   sext_i64_i32(s_n_m_292825))) *\n                                              s_n_m_292825 +\n                                              sext_i32_i64(i_321369 -\n                                              squot32(i_321369,\n                                                      sext_i64_i32(s_n_m_292825)) *\n                                              sext_i64_i32(s_n_m_292825))] =\n                tmp_321370;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321371 = sdiv_up32(sext_i64_i32(n_p_292677) *\n                                          sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_298371));\n    \n    for (int32_t chunk_i_321372 = 0; chunk_i_321372 < num_chunks_321371;\n         chunk_i_321372++) {\n        int32_t i_321373 = chunk_i_321372 *\n                sext_i64_i32(computed_group_sizze_298371) + local_tid_321339;\n        \n        if (slt32(i_321373, sext_i64_i32(n_p_292677) *\n                  sext_i64_i32(s_n_m_292825))) {\n            double tmp_321374;\n            \n            tmp_321374 = ((__local\n                           double *) color_320592)[sext_i32_i64(squot32(i_321373,\n                                                                        sext_i64_i32(s_n_m_292825))) *\n                                                   s_n_m_292825 +\n                                                   sext_i32_i64(i_321373 -\n                                                   squot32(i_321373,\n                                                           sext_i64_i32(s_n_m_292825)) *\n                                                   sext_i64_i32(s_n_m_292825))];\n            ((__global double *) mem_318648)[gtid_298528 * (s_n_m_292825 *\n",
            "                                                            n_p_292677) +\n                                             sext_i32_i64(squot32(i_321373,\n                                                                  sext_i64_i32(s_n_m_292825))) *\n                                             s_n_m_292825 +\n                                             sext_i32_i64(i_321373 -\n                                             squot32(i_321373,\n                                                     sext_i64_i32(s_n_m_292825)) *\n                                             sext_i64_i32(s_n_m_292825))] =\n                tmp_321374;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n  error_3:\n    return;\n}\n__kernel void mainzisegmap_intragroup_299433(__global int *global_failure,\n                                             int failure_is_an_option, __global\n                                             int64_t *global_failure_args,\n                                             uint color_320600_backing_offset_0,\n                                             uint color_320599_backing_offset_1,\n                                             uint color_320598_backing_offset_2,\n                                             int64_t n_p_292677,\n                                             int64_t q_s_292678,\n                                             int64_t jump_s_292684,\n                                             int64_t partition_sizze_292766,\n                                             int64_t defunc_0_f_res_292820,\n                                             int64_t pad_css_len_292821,\n                                             int64_t s_n_m_292825,\n                                             int64_t i_292895,\n                                             unsigned char x_292896_bits,\n                                             int64_t min_res_292926,\n                                             unsigned char loop_cond_292931_bits,\n                                          ",
            "   double i64_res_292932,\n                                             int64_t computed_group_sizze_299419,\n                                             __global\n                                             unsigned char *ext_mem_318609,\n                                             __global\n                                             unsigned char *ext_mem_318610,\n                                             __global unsigned char *mem_318665,\n                                             __global unsigned char *mem_318670)\n{\n    bool x_292896 = x_292896_bits;\n    bool loop_cond_292931 = loop_cond_292931_bits;\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *color_320600_backing_2 =\n                           &shared_mem[color_320600_backing_offset_0];\n    volatile unsigned char *color_320599_backing_1 =\n                           &shared_mem[color_320599_backing_offset_1];\n    volatile unsigned char *color_320598_backing_0 =\n                           &shared_mem[color_320598_backing_offset_2];\n    volatile __local bool local_failure;\n    \n    if (failure_is_an_option) {\n        int failed = *global_failure >= 0;\n        \n        if (failed)\n            return;\n    }\n    local_failure = false;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t global_tid_321377;\n    int32_t local_tid_321378;\n    int64_t group_sizze_321381;\n    int32_t wave_sizze_321380;\n    int32_t group_tid_321379;\n    \n    global_tid_321377 = get_global_id(0);\n    local_tid_321378 = get_local_id(0);\n    group_sizze_321381 = get_local_size(0);\n    wave_sizze_321380 = LOCKSTEP_WIDTH;\n    group_tid_321379 = get_group_id(0);\n    \n    int32_t phys_tid_299433 = group_tid_321379;\n    int64_t slice_321383 = defunc_0_f_res_292820;\n    int64_t ltid_pre_321382 = sext_i32_i64(local_tid_321378);\n    int64_t remnant_321384 = sext_i32_i64(local_tid_321378) - ltid_pre_321382;\n    int64_t slice_321386 = s_n_m_292825;\n    int64_t ltid_pre_321385 ",
            "= sext_i32_i64(local_tid_321378);\n    int64_t remnant_321387 = sext_i32_i64(local_tid_321378) - ltid_pre_321385;\n    int64_t slice_321388 = n_p_292677;\n    int64_t slice_321389 = partition_sizze_292766 * slice_321388;\n    int64_t gtid_299431 = squot64(sext_i32_i64(group_tid_321379), slice_321388);\n    int64_t remnant_321390 = sext_i32_i64(group_tid_321379) - gtid_299431 *\n            slice_321388;\n    int64_t gtid_299432 = remnant_321390;\n    int64_t remnant_321391 = remnant_321390 - gtid_299432;\n    __local unsigned char *color_320598;\n    \n    color_320598 = (__local unsigned char *) color_320598_backing_0;\n    \n    __local unsigned char *color_320599;\n    \n    color_320599 = (__local unsigned char *) color_320599_backing_1;\n    \n    __local unsigned char *color_320600;\n    \n    color_320600 = (__local unsigned char *) color_320600_backing_2;\n    \n    int64_t x_299436;\n    \n    x_299436 = ((__global int64_t *) ext_mem_318609)[gtid_299431 * n_p_292677 +\n                                                     gtid_299432];\n    \n    int32_t phys_tid_299439 = local_tid_321378;\n    int64_t gtid_299438 = sext_i32_i64(sext_i64_i32(ltid_pre_321382));\n    \n    if (slt64(gtid_299438, defunc_0_f_res_292820)) {\n        int64_t x_299440;\n        \n        x_299440 = ((__global int64_t *) ext_mem_318610)[gtid_299431 *\n                                                         (defunc_0_f_res_292820 *\n                                                          n_p_292677) +\n                                                         gtid_299432 *\n                                                         defunc_0_f_res_292820 +\n                                                         gtid_299438];\n        \n        int64_t defunc_0_f_res_299441 = add64((int64_t) 1, x_299440);\n        \n        ((__local int64_t *) color_320600)[gtid_299438] = defunc_0_f_res_299441;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t min_arg_299442 = sub64(x_299436, (int64_t) 1);\n    int64_t min_arg_299443",
            " = sub64(x_299436, min_res_292926);\n    int64_t min_res_299444 = smin64(q_s_292678, x_299436);\n    double i64_res_299445 = sitofp_i64_f64(x_299436);\n    double x_299446 = i64_res_292932 - i64_res_299445;\n    double max_arg_299447 = x_299446 / 2.0;\n    double max_res_299448 = fmax64(0.0, max_arg_299447);\n    int32_t phys_tid_299452 = local_tid_321378;\n    int64_t gtid_299451 = sext_i32_i64(sext_i64_i32(ltid_pre_321385));\n    \n    if (slt64(gtid_299451, s_n_m_292825)) {\n        bool cond_299454 = gtid_299451 == (int64_t) 0;\n        int64_t defunc_0_m_fun_res_299455;\n        \n        if (cond_299454) {\n            defunc_0_m_fun_res_299455 = (int64_t) 0;\n        } else {\n            int64_t y_299456 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_299457 = gtid_299451 == y_299456;\n            int64_t defunc_0_m_fun_res_f_res_299458;\n            \n            if (cond_299457) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_299459 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_299458 =\n                    defunc_0_m_fun_res_f_res_t_res_299459;\n            } else {\n                int64_t x_299460 = sub64(gtid_299451, (int64_t) 1);\n                int64_t x_299461 = mul64(jump_s_292684, x_299460);\n                int64_t min_arg_299462 = add64((int64_t) 1, x_299461);\n                int64_t min_res_299463 = smin64(defunc_0_f_res_292820,\n                                                min_arg_299462);\n                \n                defunc_0_m_fun_res_f_res_299458 = min_res_299463;\n            }\n            defunc_0_m_fun_res_299455 = defunc_0_m_fun_res_f_res_299458;\n        }\n        \n        bool init_idx_299464;\n        int64_t init_idx_299465;\n        int64_t init_idx_299466;\n        bool loop_while_299467;\n        int64_t low_299468;\n        int64_t high_299469;\n        \n        loop_while_299467 = x_292896;\n        low_299468 = (int64_t) 0;\n        high_299469 = i_292895;\n ",
            "       while (loop_while_299467) {\n            int64_t x_299470 = add64(low_299468, high_299469);\n            int64_t mid_299471 = sdiv64(x_299470, (int64_t) 2);\n            bool x_299472 = sle64((int64_t) 0, mid_299471);\n            bool y_299473 = slt64(mid_299471, defunc_0_f_res_292820);\n            bool bounds_check_299474 = x_299472 && y_299473;\n            bool index_certs_299475;\n            \n            if (!bounds_check_299474) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 7) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) mid_299471;\n                        global_failure_args[1] =\n                            (int64_t) defunc_0_f_res_292820;\n                        ;\n                    }\n                    local_failure = true;\n                    goto error_1;\n                }\n            }\n            \n            int64_t mid_id_299476;\n            \n            mid_id_299476 = ((__local int64_t *) color_320600)[mid_299471];\n            \n            bool cond_299477 = slt64(mid_id_299476, (int64_t) 0);\n            int64_t mid_idx_299478;\n            \n            if (cond_299477) {\n                mid_idx_299478 = (int64_t) 9223372036854775807;\n            } else {\n                mid_idx_299478 = mid_id_299476;\n            }\n            \n            bool cond_299479 = sle64(defunc_0_m_fun_res_299455, mid_idx_299478);\n            int64_t loopres_299480;\n            int64_t loopres_299481;\n            \n            if (cond_299479) {\n                int64_t loopres_t_res_299482 = sub64(mid_299471, (int64_t) 1);\n                \n                loopres_299480 = low_299468;\n                loopres_299481 = loopres_t_res_299482;\n            } else {\n                int64_t loopres_f_res_299483 = add64((int64_t) 1, mid_299471);\n                \n                loopres_299480 = loopres_f_res_299483;\n                loopres_299481 = high_299469;\n            }\n            \n  ",
            "          bool loop_cond_299484 = sle64(loopres_299480, loopres_299481);\n            bool loop_while_tmp_321392 = loop_cond_299484;\n            int64_t low_tmp_321393 = loopres_299480;\n            int64_t high_tmp_321394 = loopres_299481;\n            \n            loop_while_299467 = loop_while_tmp_321392;\n            low_299468 = low_tmp_321393;\n            high_299469 = high_tmp_321394;\n        }\n        init_idx_299464 = loop_while_299467;\n        init_idx_299465 = low_299468;\n        init_idx_299466 = high_299469;\n        \n        bool idx_299485;\n        int64_t idx_299486;\n        int64_t idx_299487;\n        int64_t idx_299488;\n        bool loop_while_299489;\n        int64_t l_idx_299490;\n        int64_t r_idx_299491;\n        int64_t span_299492;\n        \n        loop_while_299489 = loop_cond_292931;\n        l_idx_299490 = init_idx_299465;\n        r_idx_299491 = init_idx_299465;\n        span_299492 = (int64_t) 1;\n        while (loop_while_299489) {\n            int64_t max_arg_299493 = sub64(l_idx_299490, (int64_t) 1);\n            int64_t max_res_299494 = smax64((int64_t) 0, max_arg_299493);\n            int64_t min_arg_299495 = add64((int64_t) 1, r_idx_299491);\n            int64_t min_res_299496 = smin64(min_arg_299442, min_arg_299495);\n            bool x_299497 = sle64((int64_t) 0, max_res_299494);\n            bool y_299498 = slt64(max_res_299494, defunc_0_f_res_292820);\n            bool bounds_check_299499 = x_299497 && y_299498;\n            bool index_certs_299500;\n            \n            if (!bounds_check_299499) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 8) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) max_res_299494;\n                        global_failure_args[1] =\n                            (int64_t) defunc_0_f_res_292820;\n                        ;\n                    }\n                    local_failure = true;\n                    goto error_1;\n                }",
            "\n            }\n            \n            int64_t x_299501;\n            \n            x_299501 = ((__local int64_t *) color_320600)[max_res_299494];\n            \n            int64_t abs_arg_299502 = sub64(x_299501, defunc_0_m_fun_res_299455);\n            int64_t abs_res_299503 = abs64(abs_arg_299502);\n            bool x_299504 = sle64((int64_t) 0, min_res_299496);\n            bool y_299505 = slt64(min_res_299496, defunc_0_f_res_292820);\n            bool bounds_check_299506 = x_299504 && y_299505;\n            bool index_certs_299507;\n            \n            if (!bounds_check_299506) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 9) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) min_res_299496;\n                        global_failure_args[1] =\n                            (int64_t) defunc_0_f_res_292820;\n                        ;\n                    }\n                    local_failure = true;\n                    goto error_1;\n                }\n            }\n            \n            int64_t x_299508;\n            \n            x_299508 = ((__local int64_t *) color_320600)[min_res_299496];\n            \n            int64_t abs_arg_299509 = sub64(x_299508, defunc_0_m_fun_res_299455);\n            int64_t abs_res_299510 = abs64(abs_arg_299509);\n            bool cond_299511 = max_res_299494 == l_idx_299490;\n            int64_t loopres_299512;\n            int64_t loopres_299513;\n            int64_t loopres_299514;\n            \n            if (cond_299511) {\n                loopres_299512 = l_idx_299490;\n                loopres_299513 = r_idx_299491;\n                loopres_299514 = min_res_292926;\n            } else {\n                bool cond_299515 = slt64(abs_res_299503, abs_res_299510);\n                bool cond_f_res_299516 = min_res_299496 == r_idx_299491;\n                bool x_299517 = !cond_299515;\n                bool y_299518 = cond_f_res_299516 && x_299517;\n                bool cond_",
            "299519 = cond_299515 || y_299518;\n                int64_t loopres_f_res_299520;\n                \n                if (cond_299519) {\n                    loopres_f_res_299520 = max_res_299494;\n                } else {\n                    loopres_f_res_299520 = l_idx_299490;\n                }\n                \n                int64_t loopres_f_res_299521;\n                \n                if (cond_299519) {\n                    loopres_f_res_299521 = r_idx_299491;\n                } else {\n                    loopres_f_res_299521 = min_res_299496;\n                }\n                \n                int64_t loopres_f_res_299522;\n                \n                if (cond_299519) {\n                    int64_t loopres_f_res_t_res_299523 = add64((int64_t) 1,\n                                                               span_299492);\n                    \n                    loopres_f_res_299522 = loopres_f_res_t_res_299523;\n                } else {\n                    int64_t loopres_f_res_f_res_299524 = add64((int64_t) 1,\n                                                               span_299492);\n                    \n                    loopres_f_res_299522 = loopres_f_res_f_res_299524;\n                }\n                loopres_299512 = loopres_f_res_299520;\n                loopres_299513 = loopres_f_res_299521;\n                loopres_299514 = loopres_f_res_299522;\n            }\n            \n            bool loop_cond_299525 = slt64(loopres_299514, min_res_292926);\n            bool loop_while_tmp_321395 = loop_cond_299525;\n            int64_t l_idx_tmp_321396 = loopres_299512;\n            int64_t r_idx_tmp_321397 = loopres_299513;\n            int64_t span_tmp_321398 = loopres_299514;\n            \n            loop_while_299489 = loop_while_tmp_321395;\n            l_idx_299490 = l_idx_tmp_321396;\n            r_idx_299491 = r_idx_tmp_321397;\n            span_299492 = span_tmp_321398;\n        }\n        idx_299485 = loop_while_299489;\n        idx_299486 = l_idx_299490;\n        idx",
            "_299487 = r_idx_299491;\n        idx_299488 = span_299492;\n        \n        int64_t min_res_299526 = smin64(min_arg_299443, idx_299486);\n        int64_t max_res_299527 = smax64((int64_t) 0, min_res_299526);\n        int64_t defunc_0_m_fun_res_299528;\n        \n        if (cond_299454) {\n            defunc_0_m_fun_res_299528 = (int64_t) 0;\n        } else {\n            int64_t y_299529 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_299530 = gtid_299451 == y_299529;\n            int64_t defunc_0_m_fun_res_f_res_299531;\n            \n            if (cond_299530) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_299532 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_299531 =\n                    defunc_0_m_fun_res_f_res_t_res_299532;\n            } else {\n                int64_t x_299533 = sub64(gtid_299451, (int64_t) 1);\n                int64_t x_299534 = mul64(jump_s_292684, x_299533);\n                int64_t min_arg_299535 = add64((int64_t) 1, x_299534);\n                int64_t min_res_299536 = smin64(defunc_0_f_res_292820,\n                                                min_arg_299535);\n                \n                defunc_0_m_fun_res_f_res_299531 = min_res_299536;\n            }\n            defunc_0_m_fun_res_299528 = defunc_0_m_fun_res_f_res_299531;\n        }\n        \n        int64_t x_299537 = add64(min_res_299444, max_res_299527);\n        int64_t r_299538 = sub64(x_299537, (int64_t) 1);\n        bool x_299539 = sle64((int64_t) 0, r_299538);\n        bool y_299540 = slt64(r_299538, defunc_0_f_res_292820);\n        bool bounds_check_299541 = x_299539 && y_299540;\n        bool index_certs_299542;\n        \n        if (!bounds_check_299541) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 10) == -1) {\n                    global_failure_args[0] = (int64_t) r_299538;\n                    global_failure_args[1] = (int64_t) defunc_0_f_res_292820;\n         ",
            "           ;\n                }\n                local_failure = true;\n                goto error_1;\n            }\n        }\n        \n        int64_t x_299543;\n        \n        x_299543 = ((__local int64_t *) color_320600)[r_299538];\n        \n        int64_t abs_arg_299544 = sub64(x_299543, defunc_0_m_fun_res_299528);\n        int64_t abs_res_299545 = abs64(abs_arg_299544);\n        bool x_299546 = sle64((int64_t) 0, max_res_299527);\n        bool y_299547 = slt64(max_res_299527, defunc_0_f_res_292820);\n        bool bounds_check_299548 = x_299546 && y_299547;\n        bool index_certs_299549;\n        \n        if (!bounds_check_299548) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 11) == -1) {\n                    global_failure_args[0] = (int64_t) max_res_299527;\n                    global_failure_args[1] = (int64_t) defunc_0_f_res_292820;\n                    ;\n                }\n                local_failure = true;\n                goto error_1;\n            }\n        }\n        \n        int64_t x_299550;\n        \n        x_299550 = ((__local int64_t *) color_320600)[max_res_299527];\n        \n        int64_t abs_arg_299551 = sub64(x_299550, defunc_0_m_fun_res_299528);\n        int64_t abs_res_299552 = abs64(abs_arg_299551);\n        int64_t max_res_299553 = smax64(abs_res_299545, abs_res_299552);\n        double defunc_0_f_res_299554 = sitofp_i64_f64(max_res_299553);\n        double defunc_1_f_res_299555 = max_res_299448 + defunc_0_f_res_299554;\n        \n        ((__local double *) color_320599)[gtid_299451] = defunc_1_f_res_299555;\n        ((__local int64_t *) color_320598)[gtid_299451] = max_res_299527;\n    }\n    \n  error_1:\n    barrier(CLK_LOCAL_MEM_FENCE);\n    if (local_failure)\n        return;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321399 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_299419));\n    \n    for (int32_t chunk_i_321400 = 0; chunk_i_3214",
            "00 < num_chunks_321399;\n         chunk_i_321400++) {\n        int32_t i_321401 = chunk_i_321400 *\n                sext_i64_i32(computed_group_sizze_299419) + local_tid_321378;\n        \n        if (slt32(i_321401, sext_i64_i32(s_n_m_292825))) {\n            int64_t tmp_321402;\n            \n            tmp_321402 = ((__local\n                           int64_t *) color_320598)[sext_i32_i64(i_321401)];\n            ((__global int64_t *) mem_318665)[gtid_299431 * (s_n_m_292825 *\n                                                             n_p_292677) +\n                                              gtid_299432 * s_n_m_292825 +\n                                              sext_i32_i64(i_321401)] =\n                tmp_321402;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321403 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_299419));\n    \n    for (int32_t chunk_i_321404 = 0; chunk_i_321404 < num_chunks_321403;\n         chunk_i_321404++) {\n        int32_t i_321405 = chunk_i_321404 *\n                sext_i64_i32(computed_group_sizze_299419) + local_tid_321378;\n        \n        if (slt32(i_321405, sext_i64_i32(s_n_m_292825))) {\n            double tmp_321406;\n            \n            tmp_321406 = ((__local\n                           double *) color_320599)[sext_i32_i64(i_321405)];\n            ((__global double *) mem_318670)[gtid_299431 * (s_n_m_292825 *\n                                                            n_p_292677) +\n                                             gtid_299432 * s_n_m_292825 +\n                                             sext_i32_i64(i_321405)] =\n                tmp_321406;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n  error_2:\n    return;\n}\n__kernel void mainzisegmap_intragroup_299834(__global int *global_failure,\n                                             int failure_is_an_option, __global\n                                             int64_t *",
            "global_failure_args,\n                                             uint color_320603_backing_offset_0,\n                                             uint color_320602_backing_offset_1,\n                                             uint color_320601_backing_offset_2,\n                                             int64_t n_292675,\n                                             int64_t q_l_292680,\n                                             int64_t jump_l_292686,\n                                             int64_t partition_sizze_292766,\n                                             int64_t l_n_m_292832,\n                                             int64_t i_292846,\n                                             unsigned char x_292847_bits,\n                                             int64_t min_res_293058,\n                                             unsigned char loop_cond_293063_bits,\n                                             double i64_res_293064,\n                                             int64_t computed_group_sizze_299725,\n                                             __global\n                                             unsigned char *ext_mem_318541,\n                                             __global\n                                             unsigned char *ext_mem_318542,\n                                             __global unsigned char *mem_318724,\n                                             __global unsigned char *mem_318728)\n{\n    bool x_292847 = x_292847_bits;\n    bool loop_cond_293063 = loop_cond_293063_bits;\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *color_320603_backing_2 =\n                           &shared_mem[color_320603_backing_offset_0];\n    volatile unsigned char *color_320602_backing_1 =\n                           &shared_mem[color_320602_backing_offset_1];\n    volatile unsigned char *color_320601_backing_0 =\n                           &shared_mem[color_320601_backi",
            "ng_offset_2];\n    volatile __local bool local_failure;\n    \n    if (failure_is_an_option) {\n        int failed = *global_failure >= 0;\n        \n        if (failed)\n            return;\n    }\n    local_failure = false;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t global_tid_321452;\n    int32_t local_tid_321453;\n    int64_t group_sizze_321456;\n    int32_t wave_sizze_321455;\n    int32_t group_tid_321454;\n    \n    global_tid_321452 = get_global_id(0);\n    local_tid_321453 = get_local_id(0);\n    group_sizze_321456 = get_local_size(0);\n    wave_sizze_321455 = LOCKSTEP_WIDTH;\n    group_tid_321454 = get_group_id(0);\n    \n    int32_t phys_tid_299834 = group_tid_321454;\n    int64_t slice_321458 = n_292675;\n    int64_t ltid_pre_321457 = sext_i32_i64(local_tid_321453);\n    int64_t remnant_321459 = sext_i32_i64(local_tid_321453) - ltid_pre_321457;\n    int64_t slice_321461 = l_n_m_292832;\n    int64_t ltid_pre_321460 = sext_i32_i64(local_tid_321453);\n    int64_t remnant_321462 = sext_i32_i64(local_tid_321453) - ltid_pre_321460;\n    int64_t slice_321463 = partition_sizze_292766;\n    int64_t gtid_299833 = sext_i32_i64(group_tid_321454);\n    int64_t remnant_321464 = sext_i32_i64(group_tid_321454) - gtid_299833;\n    __local unsigned char *color_320601;\n    \n    color_320601 = (__local unsigned char *) color_320601_backing_0;\n    \n    __local unsigned char *color_320602;\n    \n    color_320602 = (__local unsigned char *) color_320602_backing_1;\n    \n    __local unsigned char *color_320603;\n    \n    color_320603 = (__local unsigned char *) color_320603_backing_2;\n    \n    int64_t x_299837;\n    \n    x_299837 = ((__global int64_t *) ext_mem_318541)[gtid_299833];\n    \n    int32_t phys_tid_299840 = local_tid_321453;\n    int64_t gtid_299839 = sext_i32_i64(sext_i64_i32(ltid_pre_321457));\n    \n    if (slt64(gtid_299839, n_292675)) {\n        int64_t x_299841;\n        \n        x_299841 = ((__global int64_t *) ext_mem_318542)[gtid_299833 *\n                                                     ",
            "    n_292675 +\n                                                         gtid_299839];\n        \n        int64_t defunc_0_f_res_299842 = add64((int64_t) 1, x_299841);\n        \n        ((__local int64_t *) color_320603)[gtid_299839] = defunc_0_f_res_299842;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t min_arg_299843 = sub64(x_299837, (int64_t) 1);\n    int64_t min_arg_299844 = sub64(x_299837, min_res_293058);\n    int64_t min_res_299845 = smin64(q_l_292680, x_299837);\n    double i64_res_299846 = sitofp_i64_f64(x_299837);\n    double x_299847 = i64_res_293064 - i64_res_299846;\n    double max_arg_299848 = x_299847 / 2.0;\n    double max_res_299849 = fmax64(0.0, max_arg_299848);\n    int32_t phys_tid_299853 = local_tid_321453;\n    int64_t gtid_299852 = sext_i32_i64(sext_i64_i32(ltid_pre_321460));\n    \n    if (slt64(gtid_299852, l_n_m_292832)) {\n        int64_t min_arg_299855 = mul64(jump_l_292686, gtid_299852);\n        int64_t min_res_299856 = smin64(i_292846, min_arg_299855);\n        int64_t defunc_0_g_res_299857 = add64((int64_t) 1, min_res_299856);\n        bool init_idx_299858;\n        int64_t init_idx_299859;\n        int64_t init_idx_299860;\n        bool loop_while_299861;\n        int64_t low_299862;\n        int64_t high_299863;\n        \n        loop_while_299861 = x_292847;\n        low_299862 = (int64_t) 0;\n        high_299863 = i_292846;\n        while (loop_while_299861) {\n            int64_t x_299864 = add64(low_299862, high_299863);\n            int64_t mid_299865 = sdiv64(x_299864, (int64_t) 2);\n            bool x_299866 = sle64((int64_t) 0, mid_299865);\n            bool y_299867 = slt64(mid_299865, n_292675);\n            bool bounds_check_299868 = x_299866 && y_299867;\n            bool index_certs_299869;\n            \n            if (!bounds_check_299868) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 17) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) mid_299865;\n      ",
            "                  global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    local_failure = true;\n                    goto error_1;\n                }\n            }\n            \n            int64_t mid_id_299870;\n            \n            mid_id_299870 = ((__local int64_t *) color_320603)[mid_299865];\n            \n            bool cond_299871 = slt64(mid_id_299870, (int64_t) 0);\n            int64_t mid_idx_299872;\n            \n            if (cond_299871) {\n                mid_idx_299872 = (int64_t) 9223372036854775807;\n            } else {\n                mid_idx_299872 = mid_id_299870;\n            }\n            \n            bool cond_299873 = sle64(defunc_0_g_res_299857, mid_idx_299872);\n            int64_t loopres_299874;\n            int64_t loopres_299875;\n            \n            if (cond_299873) {\n                int64_t loopres_t_res_299876 = sub64(mid_299865, (int64_t) 1);\n                \n                loopres_299874 = low_299862;\n                loopres_299875 = loopres_t_res_299876;\n            } else {\n                int64_t loopres_f_res_299877 = add64((int64_t) 1, mid_299865);\n                \n                loopres_299874 = loopres_f_res_299877;\n                loopres_299875 = high_299863;\n            }\n            \n            bool loop_cond_299878 = sle64(loopres_299874, loopres_299875);\n            bool loop_while_tmp_321465 = loop_cond_299878;\n            int64_t low_tmp_321466 = loopres_299874;\n            int64_t high_tmp_321467 = loopres_299875;\n            \n            loop_while_299861 = loop_while_tmp_321465;\n            low_299862 = low_tmp_321466;\n            high_299863 = high_tmp_321467;\n        }\n        init_idx_299858 = loop_while_299861;\n        init_idx_299859 = low_299862;\n        init_idx_299860 = high_299863;\n        \n        bool idx_299879;\n        int64_t idx_299880;\n        int64_t idx_299881;\n        int64_t idx_299882;\n        bool loop_while_299883;\n        int64_t ",
            "l_idx_299884;\n        int64_t r_idx_299885;\n        int64_t span_299886;\n        \n        loop_while_299883 = loop_cond_293063;\n        l_idx_299884 = init_idx_299859;\n        r_idx_299885 = init_idx_299859;\n        span_299886 = (int64_t) 1;\n        while (loop_while_299883) {\n            int64_t max_arg_299887 = sub64(l_idx_299884, (int64_t) 1);\n            int64_t max_res_299888 = smax64((int64_t) 0, max_arg_299887);\n            int64_t min_arg_299889 = add64((int64_t) 1, r_idx_299885);\n            int64_t min_res_299890 = smin64(min_arg_299843, min_arg_299889);\n            bool x_299891 = sle64((int64_t) 0, max_res_299888);\n            bool y_299892 = slt64(max_res_299888, n_292675);\n            bool bounds_check_299893 = x_299891 && y_299892;\n            bool index_certs_299894;\n            \n            if (!bounds_check_299893) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 18) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) max_res_299888;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    local_failure = true;\n                    goto error_1;\n                }\n            }\n            \n            int64_t x_299895;\n            \n            x_299895 = ((__local int64_t *) color_320603)[max_res_299888];\n            \n            int64_t abs_arg_299896 = sub64(x_299895, defunc_0_g_res_299857);\n            int64_t abs_res_299897 = abs64(abs_arg_299896);\n            bool x_299898 = sle64((int64_t) 0, min_res_299890);\n            bool y_299899 = slt64(min_res_299890, n_292675);\n            bool bounds_check_299900 = x_299898 && y_299899;\n            bool index_certs_299901;\n            \n            if (!bounds_check_299900) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 19) ==\n                        -1) {\n                        global_failure_args[0",
            "] = (int64_t) min_res_299890;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    local_failure = true;\n                    goto error_1;\n                }\n            }\n            \n            int64_t x_299902;\n            \n            x_299902 = ((__local int64_t *) color_320603)[min_res_299890];\n            \n            int64_t abs_arg_299903 = sub64(x_299902, defunc_0_g_res_299857);\n            int64_t abs_res_299904 = abs64(abs_arg_299903);\n            bool cond_299905 = max_res_299888 == l_idx_299884;\n            int64_t loopres_299906;\n            int64_t loopres_299907;\n            int64_t loopres_299908;\n            \n            if (cond_299905) {\n                loopres_299906 = l_idx_299884;\n                loopres_299907 = r_idx_299885;\n                loopres_299908 = min_res_293058;\n            } else {\n                bool cond_299909 = slt64(abs_res_299897, abs_res_299904);\n                bool cond_f_res_299910 = min_res_299890 == r_idx_299885;\n                bool x_299911 = !cond_299909;\n                bool y_299912 = cond_f_res_299910 && x_299911;\n                bool cond_299913 = cond_299909 || y_299912;\n                int64_t loopres_f_res_299914;\n                \n                if (cond_299913) {\n                    loopres_f_res_299914 = max_res_299888;\n                } else {\n                    loopres_f_res_299914 = l_idx_299884;\n                }\n                \n                int64_t loopres_f_res_299915;\n                \n                if (cond_299913) {\n                    loopres_f_res_299915 = r_idx_299885;\n                } else {\n                    loopres_f_res_299915 = min_res_299890;\n                }\n                \n                int64_t loopres_f_res_299916;\n                \n                if (cond_299913) {\n                    int64_t loopres_f_res_t_res_299917 = add64((int64_t) 1,\n                                               ",
            "                span_299886);\n                    \n                    loopres_f_res_299916 = loopres_f_res_t_res_299917;\n                } else {\n                    int64_t loopres_f_res_f_res_299918 = add64((int64_t) 1,\n                                                               span_299886);\n                    \n                    loopres_f_res_299916 = loopres_f_res_f_res_299918;\n                }\n                loopres_299906 = loopres_f_res_299914;\n                loopres_299907 = loopres_f_res_299915;\n                loopres_299908 = loopres_f_res_299916;\n            }\n            \n            bool loop_cond_299919 = slt64(loopres_299908, min_res_293058);\n            bool loop_while_tmp_321468 = loop_cond_299919;\n            int64_t l_idx_tmp_321469 = loopres_299906;\n            int64_t r_idx_tmp_321470 = loopres_299907;\n            int64_t span_tmp_321471 = loopres_299908;\n            \n            loop_while_299883 = loop_while_tmp_321468;\n            l_idx_299884 = l_idx_tmp_321469;\n            r_idx_299885 = r_idx_tmp_321470;\n            span_299886 = span_tmp_321471;\n        }\n        idx_299879 = loop_while_299883;\n        idx_299880 = l_idx_299884;\n        idx_299881 = r_idx_299885;\n        idx_299882 = span_299886;\n        \n        int64_t min_res_299920 = smin64(min_arg_299844, idx_299880);\n        int64_t max_res_299921 = smax64((int64_t) 0, min_res_299920);\n        int64_t x_299922 = add64(min_res_299845, max_res_299921);\n        int64_t r_299923 = sub64(x_299922, (int64_t) 1);\n        bool x_299924 = sle64((int64_t) 0, r_299923);\n        bool y_299925 = slt64(r_299923, n_292675);\n        bool bounds_check_299926 = x_299924 && y_299925;\n        bool index_certs_299927;\n        \n        if (!bounds_check_299926) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 20) == -1) {\n                    global_failure_args[0] = (int64_t) r_299923;\n                    global_failure_args[1] = (int64_t) n_292675;\n           ",
            "         ;\n                }\n                local_failure = true;\n                goto error_1;\n            }\n        }\n        \n        int64_t x_299928;\n        \n        x_299928 = ((__global int64_t *) ext_mem_318542)[gtid_299833 *\n                                                         n_292675 + r_299923];\n        \n        int64_t abs_arg_299929 = sub64(x_299928, min_res_299856);\n        int64_t abs_res_299930 = abs64(abs_arg_299929);\n        bool x_299931 = sle64((int64_t) 0, max_res_299921);\n        bool y_299932 = slt64(max_res_299921, n_292675);\n        bool bounds_check_299933 = x_299931 && y_299932;\n        bool index_certs_299934;\n        \n        if (!bounds_check_299933) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 21) == -1) {\n                    global_failure_args[0] = (int64_t) max_res_299921;\n                    global_failure_args[1] = (int64_t) n_292675;\n                    ;\n                }\n                local_failure = true;\n                goto error_1;\n            }\n        }\n        \n        int64_t x_299935;\n        \n        x_299935 = ((__global int64_t *) ext_mem_318542)[gtid_299833 *\n                                                         n_292675 +\n                                                         max_res_299921];\n        \n        int64_t abs_arg_299936 = sub64(x_299935, min_res_299856);\n        int64_t abs_res_299937 = abs64(abs_arg_299936);\n        int64_t max_res_299938 = smax64(abs_res_299930, abs_res_299937);\n        double defunc_0_f_res_299939 = sitofp_i64_f64(max_res_299938);\n        double defunc_1_f_res_299940 = max_res_299849 + defunc_0_f_res_299939;\n        \n        ((__local double *) color_320602)[gtid_299852] = defunc_1_f_res_299940;\n        ((__local int64_t *) color_320601)[gtid_299852] = max_res_299921;\n    }\n    \n  error_1:\n    barrier(CLK_LOCAL_MEM_FENCE);\n    if (local_failure)\n        return;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321472 = s",
            "div_up32(sext_i64_i32(l_n_m_292832),\n                                          sext_i64_i32(computed_group_sizze_299725));\n    \n    for (int32_t chunk_i_321473 = 0; chunk_i_321473 < num_chunks_321472;\n         chunk_i_321473++) {\n        int32_t i_321474 = chunk_i_321473 *\n                sext_i64_i32(computed_group_sizze_299725) + local_tid_321453;\n        \n        if (slt32(i_321474, sext_i64_i32(l_n_m_292832))) {\n            int64_t tmp_321475;\n            \n            tmp_321475 = ((__local\n                           int64_t *) color_320601)[sext_i32_i64(i_321474)];\n            ((__global int64_t *) mem_318724)[gtid_299833 * l_n_m_292832 +\n                                              sext_i32_i64(i_321474)] =\n                tmp_321475;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321476 = sdiv_up32(sext_i64_i32(l_n_m_292832),\n                                          sext_i64_i32(computed_group_sizze_299725));\n    \n    for (int32_t chunk_i_321477 = 0; chunk_i_321477 < num_chunks_321476;\n         chunk_i_321477++) {\n        int32_t i_321478 = chunk_i_321477 *\n                sext_i64_i32(computed_group_sizze_299725) + local_tid_321453;\n        \n        if (slt32(i_321478, sext_i64_i32(l_n_m_292832))) {\n            double tmp_321479;\n            \n            tmp_321479 = ((__local\n                           double *) color_320602)[sext_i32_i64(i_321478)];\n            ((__global double *) mem_318728)[gtid_299833 * l_n_m_292832 +\n                                             sext_i32_i64(i_321478)] =\n                tmp_321479;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n  error_2:\n    return;\n}\n__kernel void mainzisegmap_intragroup_300460(__global int *global_failure,\n                                             int failure_is_an_option, __global\n                                             int64_t *global_failure_args,\n                                             uint color_320606_backing_offset_0,\n                     ",
            "                        uint color_320605_backing_offset_1,\n                                             uint color_320604_backing_offset_2,\n                                             int64_t n_292675,\n                                             int64_t q_t_292679,\n                                             int64_t jump_t_292685,\n                                             int64_t partition_sizze_292766,\n                                             int64_t t_n_m_292839,\n                                             int64_t i_292846,\n                                             unsigned char x_292847_bits,\n                                             int64_t min_res_293170,\n                                             unsigned char loop_cond_293175_bits,\n                                             double i64_res_293176,\n                                             int64_t computed_group_sizze_300351,\n                                             __global\n                                             unsigned char *ext_mem_318541,\n                                             __global\n                                             unsigned char *ext_mem_318542,\n                                             __global unsigned char *mem_318773,\n                                             __global unsigned char *mem_318777)\n{\n    bool x_292847 = x_292847_bits;\n    bool loop_cond_293175 = loop_cond_293175_bits;\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *color_320606_backing_2 =\n                           &shared_mem[color_320606_backing_offset_0];\n    volatile unsigned char *color_320605_backing_1 =\n                           &shared_mem[color_320605_backing_offset_1];\n    volatile unsigned char *color_320604_backing_0 =\n                           &shared_mem[color_320604_backing_offset_2];\n    volatile __local bool local_failure;\n    \n    if (failure_is_an_option) {\n        int failed = *global_fa",
            "ilure >= 0;\n        \n        if (failed)\n            return;\n    }\n    local_failure = false;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t global_tid_321518;\n    int32_t local_tid_321519;\n    int64_t group_sizze_321522;\n    int32_t wave_sizze_321521;\n    int32_t group_tid_321520;\n    \n    global_tid_321518 = get_global_id(0);\n    local_tid_321519 = get_local_id(0);\n    group_sizze_321522 = get_local_size(0);\n    wave_sizze_321521 = LOCKSTEP_WIDTH;\n    group_tid_321520 = get_group_id(0);\n    \n    int32_t phys_tid_300460 = group_tid_321520;\n    int64_t slice_321524 = n_292675;\n    int64_t ltid_pre_321523 = sext_i32_i64(local_tid_321519);\n    int64_t remnant_321525 = sext_i32_i64(local_tid_321519) - ltid_pre_321523;\n    int64_t slice_321527 = t_n_m_292839;\n    int64_t ltid_pre_321526 = sext_i32_i64(local_tid_321519);\n    int64_t remnant_321528 = sext_i32_i64(local_tid_321519) - ltid_pre_321526;\n    int64_t slice_321529 = partition_sizze_292766;\n    int64_t gtid_300459 = sext_i32_i64(group_tid_321520);\n    int64_t remnant_321530 = sext_i32_i64(group_tid_321520) - gtid_300459;\n    __local unsigned char *color_320604;\n    \n    color_320604 = (__local unsigned char *) color_320604_backing_0;\n    \n    __local unsigned char *color_320605;\n    \n    color_320605 = (__local unsigned char *) color_320605_backing_1;\n    \n    __local unsigned char *color_320606;\n    \n    color_320606 = (__local unsigned char *) color_320606_backing_2;\n    \n    int64_t x_300463;\n    \n    x_300463 = ((__global int64_t *) ext_mem_318541)[gtid_300459];\n    \n    int32_t phys_tid_300466 = local_tid_321519;\n    int64_t gtid_300465 = sext_i32_i64(sext_i64_i32(ltid_pre_321523));\n    \n    if (slt64(gtid_300465, n_292675)) {\n        int64_t x_300467;\n        \n        x_300467 = ((__global int64_t *) ext_mem_318542)[gtid_300459 *\n                                                         n_292675 +\n                                                         gtid_300465];\n        \n        int64_t defunc_0_f_r",
            "es_300468 = add64((int64_t) 1, x_300467);\n        \n        ((__local int64_t *) color_320606)[gtid_300465] = defunc_0_f_res_300468;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t min_arg_300469 = sub64(x_300463, (int64_t) 1);\n    int64_t min_arg_300470 = sub64(x_300463, min_res_293170);\n    int64_t min_res_300471 = smin64(q_t_292679, x_300463);\n    double i64_res_300472 = sitofp_i64_f64(x_300463);\n    double x_300473 = i64_res_293176 - i64_res_300472;\n    double max_arg_300474 = x_300473 / 2.0;\n    double max_res_300475 = fmax64(0.0, max_arg_300474);\n    int32_t phys_tid_300479 = local_tid_321519;\n    int64_t gtid_300478 = sext_i32_i64(sext_i64_i32(ltid_pre_321526));\n    \n    if (slt64(gtid_300478, t_n_m_292839)) {\n        int64_t min_arg_300481 = mul64(jump_t_292685, gtid_300478);\n        int64_t min_res_300482 = smin64(i_292846, min_arg_300481);\n        int64_t defunc_0_g_res_300483 = add64((int64_t) 1, min_res_300482);\n        bool init_idx_300484;\n        int64_t init_idx_300485;\n        int64_t init_idx_300486;\n        bool loop_while_300487;\n        int64_t low_300488;\n        int64_t high_300489;\n        \n        loop_while_300487 = x_292847;\n        low_300488 = (int64_t) 0;\n        high_300489 = i_292846;\n        while (loop_while_300487) {\n            int64_t x_300490 = add64(low_300488, high_300489);\n            int64_t mid_300491 = sdiv64(x_300490, (int64_t) 2);\n            bool x_300492 = sle64((int64_t) 0, mid_300491);\n            bool y_300493 = slt64(mid_300491, n_292675);\n            bool bounds_check_300494 = x_300492 && y_300493;\n            bool index_certs_300495;\n            \n            if (!bounds_check_300494) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 27) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) mid_300491;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n            ",
            "        local_failure = true;\n                    goto error_1;\n                }\n            }\n            \n            int64_t mid_id_300496;\n            \n            mid_id_300496 = ((__local int64_t *) color_320606)[mid_300491];\n            \n            bool cond_300497 = slt64(mid_id_300496, (int64_t) 0);\n            int64_t mid_idx_300498;\n            \n            if (cond_300497) {\n                mid_idx_300498 = (int64_t) 9223372036854775807;\n            } else {\n                mid_idx_300498 = mid_id_300496;\n            }\n            \n            bool cond_300499 = sle64(defunc_0_g_res_300483, mid_idx_300498);\n            int64_t loopres_300500;\n            int64_t loopres_300501;\n            \n            if (cond_300499) {\n                int64_t loopres_t_res_300502 = sub64(mid_300491, (int64_t) 1);\n                \n                loopres_300500 = low_300488;\n                loopres_300501 = loopres_t_res_300502;\n            } else {\n                int64_t loopres_f_res_300503 = add64((int64_t) 1, mid_300491);\n                \n                loopres_300500 = loopres_f_res_300503;\n                loopres_300501 = high_300489;\n            }\n            \n            bool loop_cond_300504 = sle64(loopres_300500, loopres_300501);\n            bool loop_while_tmp_321531 = loop_cond_300504;\n            int64_t low_tmp_321532 = loopres_300500;\n            int64_t high_tmp_321533 = loopres_300501;\n            \n            loop_while_300487 = loop_while_tmp_321531;\n            low_300488 = low_tmp_321532;\n            high_300489 = high_tmp_321533;\n        }\n        init_idx_300484 = loop_while_300487;\n        init_idx_300485 = low_300488;\n        init_idx_300486 = high_300489;\n        \n        bool idx_300505;\n        int64_t idx_300506;\n        int64_t idx_300507;\n        int64_t idx_300508;\n        bool loop_while_300509;\n        int64_t l_idx_300510;\n        int64_t r_idx_300511;\n        int64_t span_300512;\n        \n        loop_while_300509 = loop_cond_293",
            "175;\n        l_idx_300510 = init_idx_300485;\n        r_idx_300511 = init_idx_300485;\n        span_300512 = (int64_t) 1;\n        while (loop_while_300509) {\n            int64_t max_arg_300513 = sub64(l_idx_300510, (int64_t) 1);\n            int64_t max_res_300514 = smax64((int64_t) 0, max_arg_300513);\n            int64_t min_arg_300515 = add64((int64_t) 1, r_idx_300511);\n            int64_t min_res_300516 = smin64(min_arg_300469, min_arg_300515);\n            bool x_300517 = sle64((int64_t) 0, max_res_300514);\n            bool y_300518 = slt64(max_res_300514, n_292675);\n            bool bounds_check_300519 = x_300517 && y_300518;\n            bool index_certs_300520;\n            \n            if (!bounds_check_300519) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 28) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) max_res_300514;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ;\n                    }\n                    local_failure = true;\n                    goto error_1;\n                }\n            }\n            \n            int64_t x_300521;\n            \n            x_300521 = ((__local int64_t *) color_320606)[max_res_300514];\n            \n            int64_t abs_arg_300522 = sub64(x_300521, defunc_0_g_res_300483);\n            int64_t abs_res_300523 = abs64(abs_arg_300522);\n            bool x_300524 = sle64((int64_t) 0, min_res_300516);\n            bool y_300525 = slt64(min_res_300516, n_292675);\n            bool bounds_check_300526 = x_300524 && y_300525;\n            bool index_certs_300527;\n            \n            if (!bounds_check_300526) {\n                {\n                    if (atomic_cmpxchg_i32_global(global_failure, -1, 29) ==\n                        -1) {\n                        global_failure_args[0] = (int64_t) min_res_300516;\n                        global_failure_args[1] = (int64_t) n_292675;\n                        ",
            ";\n                    }\n                    local_failure = true;\n                    goto error_1;\n                }\n            }\n            \n            int64_t x_300528;\n            \n            x_300528 = ((__local int64_t *) color_320606)[min_res_300516];\n            \n            int64_t abs_arg_300529 = sub64(x_300528, defunc_0_g_res_300483);\n            int64_t abs_res_300530 = abs64(abs_arg_300529);\n            bool cond_300531 = max_res_300514 == l_idx_300510;\n            int64_t loopres_300532;\n            int64_t loopres_300533;\n            int64_t loopres_300534;\n            \n            if (cond_300531) {\n                loopres_300532 = l_idx_300510;\n                loopres_300533 = r_idx_300511;\n                loopres_300534 = min_res_293170;\n            } else {\n                bool cond_300535 = slt64(abs_res_300523, abs_res_300530);\n                bool cond_f_res_300536 = min_res_300516 == r_idx_300511;\n                bool x_300537 = !cond_300535;\n                bool y_300538 = cond_f_res_300536 && x_300537;\n                bool cond_300539 = cond_300535 || y_300538;\n                int64_t loopres_f_res_300540;\n                \n                if (cond_300539) {\n                    loopres_f_res_300540 = max_res_300514;\n                } else {\n                    loopres_f_res_300540 = l_idx_300510;\n                }\n                \n                int64_t loopres_f_res_300541;\n                \n                if (cond_300539) {\n                    loopres_f_res_300541 = r_idx_300511;\n                } else {\n                    loopres_f_res_300541 = min_res_300516;\n                }\n                \n                int64_t loopres_f_res_300542;\n                \n                if (cond_300539) {\n                    int64_t loopres_f_res_t_res_300543 = add64((int64_t) 1,\n                                                               span_300512);\n                    \n                    loopres_f_res_300542 = loopres_f_res_t_res_300543;\n ",
            "               } else {\n                    int64_t loopres_f_res_f_res_300544 = add64((int64_t) 1,\n                                                               span_300512);\n                    \n                    loopres_f_res_300542 = loopres_f_res_f_res_300544;\n                }\n                loopres_300532 = loopres_f_res_300540;\n                loopres_300533 = loopres_f_res_300541;\n                loopres_300534 = loopres_f_res_300542;\n            }\n            \n            bool loop_cond_300545 = slt64(loopres_300534, min_res_293170);\n            bool loop_while_tmp_321534 = loop_cond_300545;\n            int64_t l_idx_tmp_321535 = loopres_300532;\n            int64_t r_idx_tmp_321536 = loopres_300533;\n            int64_t span_tmp_321537 = loopres_300534;\n            \n            loop_while_300509 = loop_while_tmp_321534;\n            l_idx_300510 = l_idx_tmp_321535;\n            r_idx_300511 = r_idx_tmp_321536;\n            span_300512 = span_tmp_321537;\n        }\n        idx_300505 = loop_while_300509;\n        idx_300506 = l_idx_300510;\n        idx_300507 = r_idx_300511;\n        idx_300508 = span_300512;\n        \n        int64_t min_res_300546 = smin64(min_arg_300470, idx_300506);\n        int64_t max_res_300547 = smax64((int64_t) 0, min_res_300546);\n        int64_t x_300548 = add64(min_res_300471, max_res_300547);\n        int64_t r_300549 = sub64(x_300548, (int64_t) 1);\n        bool x_300550 = sle64((int64_t) 0, r_300549);\n        bool y_300551 = slt64(r_300549, n_292675);\n        bool bounds_check_300552 = x_300550 && y_300551;\n        bool index_certs_300553;\n        \n        if (!bounds_check_300552) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 30) == -1) {\n                    global_failure_args[0] = (int64_t) r_300549;\n                    global_failure_args[1] = (int64_t) n_292675;\n                    ;\n                }\n                local_failure = true;\n                goto error_1;\n            }\n        }\n  ",
            "      \n        int64_t x_300554;\n        \n        x_300554 = ((__global int64_t *) ext_mem_318542)[gtid_300459 *\n                                                         n_292675 + r_300549];\n        \n        int64_t abs_arg_300555 = sub64(x_300554, min_res_300482);\n        int64_t abs_res_300556 = abs64(abs_arg_300555);\n        bool x_300557 = sle64((int64_t) 0, max_res_300547);\n        bool y_300558 = slt64(max_res_300547, n_292675);\n        bool bounds_check_300559 = x_300557 && y_300558;\n        bool index_certs_300560;\n        \n        if (!bounds_check_300559) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 31) == -1) {\n                    global_failure_args[0] = (int64_t) max_res_300547;\n                    global_failure_args[1] = (int64_t) n_292675;\n                    ;\n                }\n                local_failure = true;\n                goto error_1;\n            }\n        }\n        \n        int64_t x_300561;\n        \n        x_300561 = ((__global int64_t *) ext_mem_318542)[gtid_300459 *\n                                                         n_292675 +\n                                                         max_res_300547];\n        \n        int64_t abs_arg_300562 = sub64(x_300561, min_res_300482);\n        int64_t abs_res_300563 = abs64(abs_arg_300562);\n        int64_t max_res_300564 = smax64(abs_res_300556, abs_res_300563);\n        double defunc_0_f_res_300565 = sitofp_i64_f64(max_res_300564);\n        double defunc_1_f_res_300566 = max_res_300475 + defunc_0_f_res_300565;\n        \n        ((__local double *) color_320605)[gtid_300478] = defunc_1_f_res_300566;\n        ((__local int64_t *) color_320604)[gtid_300478] = max_res_300547;\n    }\n    \n  error_1:\n    barrier(CLK_LOCAL_MEM_FENCE);\n    if (local_failure)\n        return;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321538 = sdiv_up32(sext_i64_i32(t_n_m_292839),\n                                          sext_i64_i32(computed_group_sizze_300351));\n",
            "    \n    for (int32_t chunk_i_321539 = 0; chunk_i_321539 < num_chunks_321538;\n         chunk_i_321539++) {\n        int32_t i_321540 = chunk_i_321539 *\n                sext_i64_i32(computed_group_sizze_300351) + local_tid_321519;\n        \n        if (slt32(i_321540, sext_i64_i32(t_n_m_292839))) {\n            int64_t tmp_321541;\n            \n            tmp_321541 = ((__local\n                           int64_t *) color_320604)[sext_i32_i64(i_321540)];\n            ((__global int64_t *) mem_318773)[gtid_300459 * t_n_m_292839 +\n                                              sext_i32_i64(i_321540)] =\n                tmp_321541;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321542 = sdiv_up32(sext_i64_i32(t_n_m_292839),\n                                          sext_i64_i32(computed_group_sizze_300351));\n    \n    for (int32_t chunk_i_321543 = 0; chunk_i_321543 < num_chunks_321542;\n         chunk_i_321543++) {\n        int32_t i_321544 = chunk_i_321543 *\n                sext_i64_i32(computed_group_sizze_300351) + local_tid_321519;\n        \n        if (slt32(i_321544, sext_i64_i32(t_n_m_292839))) {\n            double tmp_321545;\n            \n            tmp_321545 = ((__local\n                           double *) color_320605)[sext_i32_i64(i_321544)];\n            ((__global double *) mem_318777)[gtid_300459 * t_n_m_292839 +\n                                             sext_i32_i64(i_321544)] =\n                tmp_321545;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n  error_2:\n    return;\n}\n__kernel void mainzisegmap_intragroup_302597(__global int *global_failure,\n                                             uint red_arr_mem_321714_backing_offset_0,\n                                             uint red_arr_mem_321710_backing_offset_1,\n                                             uint color_320607_backing_offset_2,\n                                             int64_t n_p_292677,\n                                             int64_t q_s_292",
            "678,\n                                             int64_t jump_s_292684,\n                                             int64_t partition_sizze_292766,\n                                             int64_t defunc_0_f_res_292820,\n                                             int64_t pad_css_len_292821,\n                                             int64_t s_n_m_292825, __global\n                                             unsigned char *ext_mem_318609,\n                                             __global\n                                             unsigned char *ext_mem_318610,\n                                             __global\n                                             unsigned char *ext_mem_318707,\n                                             __global\n                                             unsigned char *ext_mem_318708,\n                                             __global unsigned char *mem_318871,\n                                             __global unsigned char *mem_318876,\n                                             __global unsigned char *mem_318929)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_321714_backing_2 =\n                           &shared_mem[red_arr_mem_321714_backing_offset_0];\n    volatile unsigned char *red_arr_mem_321710_backing_1 =\n                           &shared_mem[red_arr_mem_321710_backing_offset_1];\n    volatile unsigned char *color_320607_backing_0 =\n                           &shared_mem[color_320607_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321696;\n    int32_t local_tid_321697;\n    int64_t group_sizze_321700;\n    int32_t wave_sizze_321699;\n    int32_t group_tid_321698;\n    \n    global_tid_321696 = get_global_id(0);\n    local_tid_321697 = get_local_id(0);\n    group_sizze_321700 = get_local_size(0);\n    wave_sizze_321699 = LOCKSTEP_WIDTH;\n    group_tid_321698 = get_group_id(0);\n    \n  ",
            "  int32_t phys_tid_302597 = group_tid_321698;\n    int64_t slice_321702 = q_s_292678;\n    int64_t ltid_pre_321701 = sext_i32_i64(local_tid_321697);\n    int64_t remnant_321703 = sext_i32_i64(local_tid_321697) - ltid_pre_321701;\n    int64_t slice_321704 = s_n_m_292825;\n    int64_t slice_321705 = n_p_292677 * slice_321704;\n    int64_t slice_321706 = partition_sizze_292766 * slice_321705;\n    int64_t gtid_302594 = squot64(sext_i32_i64(group_tid_321698), slice_321705);\n    int64_t remnant_321707 = sext_i32_i64(group_tid_321698) - gtid_302594 *\n            slice_321705;\n    int64_t gtid_302595 = squot64(remnant_321707, slice_321704);\n    int64_t remnant_321708 = remnant_321707 - gtid_302595 * slice_321704;\n    int64_t gtid_302596 = remnant_321708;\n    int64_t remnant_321709 = remnant_321708 - gtid_302596;\n    __local unsigned char *color_320607;\n    \n    color_320607 = (__local unsigned char *) color_320607_backing_0;\n    \n    int64_t x_302604;\n    \n    x_302604 = ((__global int64_t *) ext_mem_318609)[gtid_302594 * n_p_292677 +\n                                                     gtid_302595];\n    \n    int64_t x_302606;\n    \n    x_302606 = ((__global int64_t *) ext_mem_318708)[gtid_302594 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_302595 *\n                                                     s_n_m_292825 +\n                                                     gtid_302596];\n    \n    double x_302607;\n    \n    x_302607 = ((__global double *) ext_mem_318707)[gtid_302594 *\n                                                    (s_n_m_292825 *\n                                                     n_p_292677) + gtid_302595 *\n                                                    s_n_m_292825 + gtid_302596];\n    \n    bool cond_302608 = gtid_302596 == (int64_t) 0;\n    int64_t defunc_0_m_fun_res_302609;\n    \n    if (cond_302608) {\n        ",
            "defunc_0_m_fun_res_302609 = (int64_t) 0;\n    } else {\n        int64_t y_302610 = sub64(s_n_m_292825, (int64_t) 1);\n        bool cond_302611 = gtid_302596 == y_302610;\n        int64_t defunc_0_m_fun_res_f_res_302612;\n        \n        if (cond_302611) {\n            int64_t defunc_0_m_fun_res_f_res_t_res_302613 =\n                    sub64(pad_css_len_292821, (int64_t) 1);\n            \n            defunc_0_m_fun_res_f_res_302612 =\n                defunc_0_m_fun_res_f_res_t_res_302613;\n        } else {\n            int64_t x_302614 = sub64(gtid_302596, (int64_t) 1);\n            int64_t x_302615 = mul64(jump_s_292684, x_302614);\n            int64_t min_arg_302616 = add64((int64_t) 1, x_302615);\n            int64_t min_res_302617 = smin64(defunc_0_f_res_292820,\n                                            min_arg_302616);\n            \n            defunc_0_m_fun_res_f_res_302612 = min_res_302617;\n        }\n        defunc_0_m_fun_res_302609 = defunc_0_m_fun_res_f_res_302612;\n    }\n    \n    double defunc_2_reduce_res_302618;\n    int32_t phys_tid_302621 = local_tid_321697;\n    __local unsigned char *red_arr_mem_321710;\n    \n    red_arr_mem_321710 = (__local unsigned char *) red_arr_mem_321710_backing_1;\n    \n    int64_t gtid_302620 = sext_i32_i64(sext_i64_i32(ltid_pre_321701));\n    bool cond_302626 = sle64(x_302604, gtid_302620);\n    int64_t defunc_0_f_res_302627;\n    \n    if (cond_302626) {\n        defunc_0_f_res_302627 = (int64_t) 0;\n    } else {\n        int64_t i_302628 = add64(x_302606, gtid_302620);\n        int64_t defunc_0_add_arg_302629;\n        \n        defunc_0_add_arg_302629 = ((__global\n                                    int64_t *) ext_mem_318610)[gtid_302594 *\n                                                               (defunc_0_f_res_292820 *\n                                                                n_p_292677) +\n                                                               gtid_302595 *\n                                                               defun",
            "c_0_f_res_292820 +\n                                                               i_302628];\n        \n        int64_t defunc_1_add_res_302630 = add64((int64_t) 1,\n                                                defunc_0_add_arg_302629);\n        \n        defunc_0_f_res_302627 = defunc_1_add_res_302630;\n    }\n    \n    double defunc_0_f_res_302631;\n    \n    if (cond_302626) {\n        defunc_0_f_res_302631 = 0.0;\n    } else {\n        int64_t i_302632 = add64(x_302606, gtid_302620);\n        double defunc_0_add_arg_302633;\n        \n        defunc_0_add_arg_302633 = ((__global double *) mem_318876)[gtid_302594 *\n                                                                   (defunc_0_f_res_292820 *\n                                                                    n_p_292677) +\n                                                                   gtid_302595 *\n                                                                   defunc_0_f_res_292820 +\n                                                                   i_302632];\n        defunc_0_f_res_302631 = defunc_0_add_arg_302633;\n    }\n    \n    int64_t binop_p_302634 = sub64(defunc_0_f_res_302627,\n                                   defunc_0_m_fun_res_302609);\n    double defunc_0_f_res_302635 = sitofp_i64_f64(binop_p_302634);\n    double abs_res_302636 = fabs(defunc_0_f_res_302635);\n    double tmp1_302637 = abs_res_302636 / x_302607;\n    double x_302638 = tmp1_302637 * tmp1_302637;\n    double y_302639 = tmp1_302637 * x_302638;\n    double tmp2_302640 = 1.0 - y_302639;\n    double x_302641 = tmp2_302640 * tmp2_302640;\n    double tmp3_302642 = tmp2_302640 * x_302641;\n    double tmp4_302643 = defunc_0_f_res_302631 * tmp3_302642;\n    \n    ((__local double *) red_arr_mem_321710)[gtid_302620] = tmp4_302643;\n    ((__local double *) color_320607)[gtid_302620] = tmp4_302643;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_321712;\n    int32_t skip_waves_321713 = 1;\n    double x_302622;\n    double x_302623;\n    \n    offset_",
            "321712 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_321697, sext_i64_i32(q_s_292678))) {\n            x_302622 = ((__local\n                         double *) red_arr_mem_321710)[sext_i32_i64(local_tid_321697 +\n                                                       offset_321712)];\n        }\n    }\n    offset_321712 = 1;\n    while (slt32(offset_321712, wave_sizze_321699)) {\n        if (slt32(local_tid_321697 + offset_321712, sext_i64_i32(q_s_292678)) &&\n            ((local_tid_321697 - squot32(local_tid_321697, wave_sizze_321699) *\n              wave_sizze_321699) & (2 * offset_321712 - 1)) == 0) {\n            // read array element\n            {\n                x_302623 = ((volatile __local\n                             double *) red_arr_mem_321710)[sext_i32_i64(local_tid_321697 +\n                                                           offset_321712)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_302624 = x_302622 + x_302623;\n                \n                x_302622 = defunc_1_op_res_302624;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_321710)[sext_i32_i64(local_tid_321697)] =\n                    x_302622;\n            }\n        }\n        offset_321712 *= 2;\n    }\n    while (slt32(skip_waves_321713, squot32(sext_i64_i32(q_s_292678) +\n                                            wave_sizze_321699 - 1,\n                                            wave_sizze_321699))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_321712 = skip_waves_321713 * wave_sizze_321699;\n        if (slt32(local_tid_321697 + offset_321712, sext_i64_i32(q_s_292678)) &&\n            ((local_tid_321697 - squot32(local_tid_321697, wave_sizze_321699) *\n              wave_sizze_321699) == 0 && (squot32(local_tid_321697,\n                                                  wave_sizze_321699) & (2",
            " *\n                                                                        skip_waves_321713 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_302623 = ((__local\n                             double *) red_arr_mem_321710)[sext_i32_i64(local_tid_321697 +\n                                                           offset_321712)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_302624 = x_302622 + x_302623;\n                \n                x_302622 = defunc_1_op_res_302624;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_321710)[sext_i32_i64(local_tid_321697)] =\n                    x_302622;\n            }\n        }\n        skip_waves_321713 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_302618 = ((__local\n                                   double *) red_arr_mem_321710)[(int64_t) 0];\n    \n    double a_302644 = 2.220446049250313e-16 + defunc_2_reduce_res_302618;\n    double a0_302645 = 1.0 / a_302644;\n    double defunc_2_reduce_res_302646;\n    int32_t phys_tid_302648 = local_tid_321697;\n    __local unsigned char *red_arr_mem_321714;\n    \n    red_arr_mem_321714 = (__local unsigned char *) red_arr_mem_321714_backing_2;\n    \n    int64_t gtid_302647 = sext_i32_i64(sext_i64_i32(ltid_pre_321701));\n    double x_302653;\n    \n    x_302653 = ((__local double *) color_320607)[gtid_302647];\n    \n    bool cond_302654 = sle64(x_302604, gtid_302647);\n    double defunc_0_f_res_302655;\n    \n    if (cond_302654) {\n        defunc_0_f_res_302655 = 0.0;\n    } else {\n        int64_t i_302656 = add64(x_302606, gtid_302647);\n        double defunc_0_add_arg_302657;\n        \n        defunc_0_add_arg_302657 = ((__global double *) mem_318871)[gtid_302594 *\n                                                                ",
            "   (defunc_0_f_res_292820 *\n                                                                    n_p_292677) +\n                                                                   gtid_302595 *\n                                                                   defunc_0_f_res_292820 +\n                                                                   i_302656];\n        defunc_0_f_res_302655 = defunc_0_add_arg_302657;\n    }\n    \n    double x_302658 = a0_302645 * x_302653;\n    double defunc_9_fit_fun_res_302659 = defunc_0_f_res_302655 * x_302658;\n    \n    ((__local double *) red_arr_mem_321714)[gtid_302647] =\n        defunc_9_fit_fun_res_302659;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_321716;\n    int32_t skip_waves_321717 = 1;\n    double x_302649;\n    double x_302650;\n    \n    offset_321716 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_321697, sext_i64_i32(q_s_292678))) {\n            x_302649 = ((__local\n                         double *) red_arr_mem_321714)[sext_i32_i64(local_tid_321697 +\n                                                       offset_321716)];\n        }\n    }\n    offset_321716 = 1;\n    while (slt32(offset_321716, wave_sizze_321699)) {\n        if (slt32(local_tid_321697 + offset_321716, sext_i64_i32(q_s_292678)) &&\n            ((local_tid_321697 - squot32(local_tid_321697, wave_sizze_321699) *\n              wave_sizze_321699) & (2 * offset_321716 - 1)) == 0) {\n            // read array element\n            {\n                x_302650 = ((volatile __local\n                             double *) red_arr_mem_321714)[sext_i32_i64(local_tid_321697 +\n                                                           offset_321716)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_302651 = x_302649 + x_302650;\n                \n                x_302649 = defunc_1_op_res_302651;\n            }\n            // write result of operation\n            {\n      ",
            "          ((volatile __local\n                  double *) red_arr_mem_321714)[sext_i32_i64(local_tid_321697)] =\n                    x_302649;\n            }\n        }\n        offset_321716 *= 2;\n    }\n    while (slt32(skip_waves_321717, squot32(sext_i64_i32(q_s_292678) +\n                                            wave_sizze_321699 - 1,\n                                            wave_sizze_321699))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_321716 = skip_waves_321717 * wave_sizze_321699;\n        if (slt32(local_tid_321697 + offset_321716, sext_i64_i32(q_s_292678)) &&\n            ((local_tid_321697 - squot32(local_tid_321697, wave_sizze_321699) *\n              wave_sizze_321699) == 0 && (squot32(local_tid_321697,\n                                                  wave_sizze_321699) & (2 *\n                                                                        skip_waves_321717 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_302650 = ((__local\n                             double *) red_arr_mem_321714)[sext_i32_i64(local_tid_321697 +\n                                                           offset_321716)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_302651 = x_302649 + x_302650;\n                \n                x_302649 = defunc_1_op_res_302651;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_321714)[sext_i32_i64(local_tid_321697)] =\n                    x_302649;\n            }\n        }\n        skip_waves_321717 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_302646 = ((__local\n                                   double *) red_arr_mem_321714)[(int64_t) 0];\n    if (local_tid_321697 == 0) {\n        ((__global double *) mem_318929)[gtid_302594 * (s_n_m_292825 *\n             ",
            "                                           n_p_292677) +\n                                         gtid_302595 * s_n_m_292825 +\n                                         gtid_302596] =\n            defunc_2_reduce_res_302646;\n    }\n    \n  error_4:\n    return;\n}\n__kernel void mainzisegmap_intragroup_302925(__global int *global_failure,\n                                             uint red_arr_mem_321743_backing_offset_0,\n                                             uint red_arr_mem_321741_backing_offset_1,\n                                             uint red_arr_mem_321737_backing_offset_2,\n                                             uint red_arr_mem_321735_backing_offset_3,\n                                             uint red_arr_mem_321733_backing_offset_4,\n                                             uint color_320609_backing_offset_5,\n                                             uint color_320608_backing_offset_6,\n                                             int64_t n_p_292677,\n                                             int64_t q_s_292678,\n                                             int64_t jump_s_292684,\n                                             int64_t partition_sizze_292766,\n                                             int64_t defunc_0_f_res_292820,\n                                             int64_t pad_css_len_292821,\n                                             int64_t s_n_m_292825, __global\n                                             unsigned char *ext_mem_318609,\n                                             __global\n                                             unsigned char *ext_mem_318610,\n                                             __global\n                                             unsigned char *ext_mem_318707,\n                                             __global\n                                             unsigned char *ext_mem_318708,\n                                             __global unsigned char *mem_318871,\n                      ",
            "                       __global unsigned char *mem_318876,\n                                             __global unsigned char *mem_318943,\n                                             __global unsigned char *mem_318948)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_321743_backing_6 =\n                           &shared_mem[red_arr_mem_321743_backing_offset_0];\n    volatile unsigned char *red_arr_mem_321741_backing_5 =\n                           &shared_mem[red_arr_mem_321741_backing_offset_1];\n    volatile unsigned char *red_arr_mem_321737_backing_4 =\n                           &shared_mem[red_arr_mem_321737_backing_offset_2];\n    volatile unsigned char *red_arr_mem_321735_backing_3 =\n                           &shared_mem[red_arr_mem_321735_backing_offset_3];\n    volatile unsigned char *red_arr_mem_321733_backing_2 =\n                           &shared_mem[red_arr_mem_321733_backing_offset_4];\n    volatile unsigned char *color_320609_backing_1 =\n                           &shared_mem[color_320609_backing_offset_5];\n    volatile unsigned char *color_320608_backing_0 =\n                           &shared_mem[color_320608_backing_offset_6];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321719;\n    int32_t local_tid_321720;\n    int64_t group_sizze_321723;\n    int32_t wave_sizze_321722;\n    int32_t group_tid_321721;\n    \n    global_tid_321719 = get_global_id(0);\n    local_tid_321720 = get_local_id(0);\n    group_sizze_321723 = get_local_size(0);\n    wave_sizze_321722 = LOCKSTEP_WIDTH;\n    group_tid_321721 = get_group_id(0);\n    \n    int32_t phys_tid_302925 = group_tid_321721;\n    int64_t slice_321725 = q_s_292678;\n    int64_t ltid_pre_321724 = sext_i32_i64(local_tid_321720);\n    int64_t remnant_321726 = sext_i32_i64(local_tid_321720) - ltid_pre_321724;\n    int64_t slice_321727 = s_n_m_292825;\n    int64_t slice_321728 = n_p_292677 * slice_321727;\n    int64_",
            "t slice_321729 = partition_sizze_292766 * slice_321728;\n    int64_t gtid_302922 = squot64(sext_i32_i64(group_tid_321721), slice_321728);\n    int64_t remnant_321730 = sext_i32_i64(group_tid_321721) - gtid_302922 *\n            slice_321728;\n    int64_t gtid_302923 = squot64(remnant_321730, slice_321727);\n    int64_t remnant_321731 = remnant_321730 - gtid_302923 * slice_321727;\n    int64_t gtid_302924 = remnant_321731;\n    int64_t remnant_321732 = remnant_321731 - gtid_302924;\n    __local unsigned char *color_320608;\n    \n    color_320608 = (__local unsigned char *) color_320608_backing_0;\n    \n    __local unsigned char *color_320609;\n    \n    color_320609 = (__local unsigned char *) color_320609_backing_1;\n    \n    int64_t x_302932;\n    \n    x_302932 = ((__global int64_t *) ext_mem_318609)[gtid_302922 * n_p_292677 +\n                                                     gtid_302923];\n    \n    int64_t x_302934;\n    \n    x_302934 = ((__global int64_t *) ext_mem_318708)[gtid_302922 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_302923 *\n                                                     s_n_m_292825 +\n                                                     gtid_302924];\n    \n    double x_302935;\n    \n    x_302935 = ((__global double *) ext_mem_318707)[gtid_302922 *\n                                                    (s_n_m_292825 *\n                                                     n_p_292677) + gtid_302923 *\n                                                    s_n_m_292825 + gtid_302924];\n    \n    bool cond_302936 = gtid_302924 == (int64_t) 0;\n    int64_t defunc_0_m_fun_res_302937;\n    \n    if (cond_302936) {\n        defunc_0_m_fun_res_302937 = (int64_t) 0;\n    } else {\n        int64_t y_302938 = sub64(s_n_m_292825, (int64_t) 1);\n        bool cond_302939 = gtid_302924 == y_302938;\n        int64_t defunc_0_m_fun_res_f_res_302",
            "940;\n        \n        if (cond_302939) {\n            int64_t defunc_0_m_fun_res_f_res_t_res_302941 =\n                    sub64(pad_css_len_292821, (int64_t) 1);\n            \n            defunc_0_m_fun_res_f_res_302940 =\n                defunc_0_m_fun_res_f_res_t_res_302941;\n        } else {\n            int64_t x_302942 = sub64(gtid_302924, (int64_t) 1);\n            int64_t x_302943 = mul64(jump_s_292684, x_302942);\n            int64_t min_arg_302944 = add64((int64_t) 1, x_302943);\n            int64_t min_res_302945 = smin64(defunc_0_f_res_292820,\n                                            min_arg_302944);\n            \n            defunc_0_m_fun_res_f_res_302940 = min_res_302945;\n        }\n        defunc_0_m_fun_res_302937 = defunc_0_m_fun_res_f_res_302940;\n    }\n    \n    double defunc_2_reduce_res_302946;\n    double defunc_2_reduce_res_302947;\n    double defunc_2_reduce_res_302948;\n    int32_t phys_tid_302952 = local_tid_321720;\n    __local unsigned char *red_arr_mem_321733;\n    \n    red_arr_mem_321733 = (__local unsigned char *) red_arr_mem_321733_backing_2;\n    \n    __local unsigned char *red_arr_mem_321735;\n    \n    red_arr_mem_321735 = (__local unsigned char *) red_arr_mem_321735_backing_3;\n    \n    __local unsigned char *red_arr_mem_321737;\n    \n    red_arr_mem_321737 = (__local unsigned char *) red_arr_mem_321737_backing_4;\n    \n    int64_t gtid_302951 = sext_i32_i64(sext_i64_i32(ltid_pre_321724));\n    bool cond_302963 = sle64(x_302932, gtid_302951);\n    int64_t defunc_0_f_res_302964;\n    \n    if (cond_302963) {\n        defunc_0_f_res_302964 = (int64_t) 0;\n    } else {\n        int64_t i_302965 = add64(x_302934, gtid_302951);\n        int64_t defunc_0_add_arg_302966;\n        \n        defunc_0_add_arg_302966 = ((__global\n                                    int64_t *) ext_mem_318610)[gtid_302922 *\n                                                               (defunc_0_f_res_292820 *\n                                                                n_p_292677) +\n  ",
            "                                                             gtid_302923 *\n                                                               defunc_0_f_res_292820 +\n                                                               i_302965];\n        \n        int64_t defunc_1_add_res_302967 = add64((int64_t) 1,\n                                                defunc_0_add_arg_302966);\n        \n        defunc_0_f_res_302964 = defunc_1_add_res_302967;\n    }\n    \n    double defunc_0_f_res_302968;\n    \n    if (cond_302963) {\n        defunc_0_f_res_302968 = 0.0;\n    } else {\n        int64_t i_302969 = add64(x_302934, gtid_302951);\n        double defunc_0_add_arg_302970;\n        \n        defunc_0_add_arg_302970 = ((__global double *) mem_318876)[gtid_302922 *\n                                                                   (defunc_0_f_res_292820 *\n                                                                    n_p_292677) +\n                                                                   gtid_302923 *\n                                                                   defunc_0_f_res_292820 +\n                                                                   i_302969];\n        defunc_0_f_res_302968 = defunc_0_add_arg_302970;\n    }\n    \n    int64_t binop_p_302971 = sub64(defunc_0_f_res_302964,\n                                   defunc_0_m_fun_res_302937);\n    double defunc_0_f_res_302972 = sitofp_i64_f64(binop_p_302971);\n    double abs_res_302973 = fabs(defunc_0_f_res_302972);\n    double tmp1_302974 = abs_res_302973 / x_302935;\n    double x_302975 = tmp1_302974 * tmp1_302974;\n    double y_302976 = tmp1_302974 * x_302975;\n    double tmp2_302977 = 1.0 - y_302976;\n    double x_302978 = tmp2_302977 * tmp2_302977;\n    double tmp3_302979 = tmp2_302977 * x_302978;\n    double tmp4_302980 = defunc_0_f_res_302968 * tmp3_302979;\n    double defunc_1_f_res_302981 = defunc_0_f_res_302972 * tmp4_302980;\n    double defunc_1_f_res_302982 = defunc_0_f_res_302972 *\n           defunc_1_f_res_30",
            "2981;\n    \n    ((__local double *) red_arr_mem_321733)[gtid_302951] = tmp4_302980;\n    ((__local double *) red_arr_mem_321735)[gtid_302951] =\n        defunc_1_f_res_302981;\n    ((__local double *) red_arr_mem_321737)[gtid_302951] =\n        defunc_1_f_res_302982;\n    ((__local double *) color_320609)[gtid_302951] = defunc_1_f_res_302981;\n    ((__local double *) color_320608)[gtid_302951] = tmp4_302980;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_321739;\n    int32_t skip_waves_321740 = 1;\n    double x_302953;\n    double x_302954;\n    double x_302955;\n    double x_302956;\n    double x_302957;\n    double x_302958;\n    \n    offset_321739 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_321720, sext_i64_i32(q_s_292678))) {\n            x_302953 = ((__local\n                         double *) red_arr_mem_321733)[sext_i32_i64(local_tid_321720 +\n                                                       offset_321739)];\n            x_302954 = ((__local\n                         double *) red_arr_mem_321735)[sext_i32_i64(local_tid_321720 +\n                                                       offset_321739)];\n            x_302955 = ((__local\n                         double *) red_arr_mem_321737)[sext_i32_i64(local_tid_321720 +\n                                                       offset_321739)];\n        }\n    }\n    offset_321739 = 1;\n    while (slt32(offset_321739, wave_sizze_321722)) {\n        if (slt32(local_tid_321720 + offset_321739, sext_i64_i32(q_s_292678)) &&\n            ((local_tid_321720 - squot32(local_tid_321720, wave_sizze_321722) *\n              wave_sizze_321722) & (2 * offset_321739 - 1)) == 0) {\n            // read array element\n            {\n                x_302956 = ((volatile __local\n                             double *) red_arr_mem_321733)[sext_i32_i64(local_tid_321720 +\n                                                           offset_321739)];\n                x_302957 = ((volatile __local\n          ",
            "                   double *) red_arr_mem_321735)[sext_i32_i64(local_tid_321720 +\n                                                           offset_321739)];\n                x_302958 = ((volatile __local\n                             double *) red_arr_mem_321737)[sext_i32_i64(local_tid_321720 +\n                                                           offset_321739)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_302959 = x_302953 + x_302956;\n                double defunc_1_op_res_302960 = x_302954 + x_302957;\n                double defunc_1_op_res_302961 = x_302955 + x_302958;\n                \n                x_302953 = defunc_1_op_res_302959;\n                x_302954 = defunc_1_op_res_302960;\n                x_302955 = defunc_1_op_res_302961;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_321733)[sext_i32_i64(local_tid_321720)] =\n                    x_302953;\n                ((volatile __local\n                  double *) red_arr_mem_321735)[sext_i32_i64(local_tid_321720)] =\n                    x_302954;\n                ((volatile __local\n                  double *) red_arr_mem_321737)[sext_i32_i64(local_tid_321720)] =\n                    x_302955;\n            }\n        }\n        offset_321739 *= 2;\n    }\n    while (slt32(skip_waves_321740, squot32(sext_i64_i32(q_s_292678) +\n                                            wave_sizze_321722 - 1,\n                                            wave_sizze_321722))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_321739 = skip_waves_321740 * wave_sizze_321722;\n        if (slt32(local_tid_321720 + offset_321739, sext_i64_i32(q_s_292678)) &&\n            ((local_tid_321720 - squot32(local_tid_321720, wave_sizze_321722) *\n              wave_sizze_321722) == 0 && (squot32(local_tid_321720,\n                                                  wave_sizze_321722) & (2 *\n     ",
            "                                                                   skip_waves_321740 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_302956 = ((__local\n                             double *) red_arr_mem_321733)[sext_i32_i64(local_tid_321720 +\n                                                           offset_321739)];\n                x_302957 = ((__local\n                             double *) red_arr_mem_321735)[sext_i32_i64(local_tid_321720 +\n                                                           offset_321739)];\n                x_302958 = ((__local\n                             double *) red_arr_mem_321737)[sext_i32_i64(local_tid_321720 +\n                                                           offset_321739)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_302959 = x_302953 + x_302956;\n                double defunc_1_op_res_302960 = x_302954 + x_302957;\n                double defunc_1_op_res_302961 = x_302955 + x_302958;\n                \n                x_302953 = defunc_1_op_res_302959;\n                x_302954 = defunc_1_op_res_302960;\n                x_302955 = defunc_1_op_res_302961;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_321733)[sext_i32_i64(local_tid_321720)] =\n                    x_302953;\n                ((__local\n                  double *) red_arr_mem_321735)[sext_i32_i64(local_tid_321720)] =\n                    x_302954;\n                ((__local\n                  double *) red_arr_mem_321737)[sext_i32_i64(local_tid_321720)] =\n                    x_302955;\n            }\n        }\n        skip_waves_321740 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_302946 = ((__local\n                                   double *) red_arr_mem_321733)[(int64_t) 0];\n    defu",
            "nc_2_reduce_res_302947 = ((__local\n                                   double *) red_arr_mem_321735)[(int64_t) 0];\n    defunc_2_reduce_res_302948 = ((__local\n                                   double *) red_arr_mem_321737)[(int64_t) 0];\n    \n    double a_302983 = 2.220446049250313e-16 + defunc_2_reduce_res_302946;\n    double b_302984 = 2.220446049250313e-16 + defunc_2_reduce_res_302947;\n    double c_302985 = 2.220446049250313e-16 + defunc_2_reduce_res_302948;\n    double x_302986 = a_302983 * c_302985;\n    double y_302987 = b_302984 * b_302984;\n    double y_302988 = x_302986 - y_302987;\n    double det1_302989 = 1.0 / y_302988;\n    double a11_302990 = c_302985 * det1_302989;\n    double x_302991 = 0.0 - b_302984;\n    double b11_302992 = det1_302989 * x_302991;\n    double c11_302993 = a_302983 * det1_302989;\n    double defunc_2_reduce_res_302994;\n    double defunc_2_reduce_res_302995;\n    int32_t phys_tid_302997 = local_tid_321720;\n    __local unsigned char *red_arr_mem_321741;\n    \n    red_arr_mem_321741 = (__local unsigned char *) red_arr_mem_321741_backing_5;\n    \n    __local unsigned char *red_arr_mem_321743;\n    \n    red_arr_mem_321743 = (__local unsigned char *) red_arr_mem_321743_backing_6;\n    \n    int64_t gtid_302996 = sext_i32_i64(sext_i64_i32(ltid_pre_321724));\n    double x_303005;\n    \n    x_303005 = ((__local double *) color_320608)[gtid_302996];\n    \n    double x_303006;\n    \n    x_303006 = ((__local double *) color_320609)[gtid_302996];\n    \n    bool cond_303007 = sle64(x_302932, gtid_302996);\n    double defunc_0_f_res_303008;\n    \n    if (cond_303007) {\n        defunc_0_f_res_303008 = 0.0;\n    } else {\n        int64_t i_303009 = add64(x_302934, gtid_302996);\n        double defunc_0_add_arg_303010;\n        \n        defunc_0_add_arg_303010 = ((__global double *) mem_318871)[gtid_302922 *\n                                                                   (defunc_0_f_res_292820 *\n                                                                    n_p_292677) ",
            "+\n                                                                   gtid_302923 *\n                                                                   defunc_0_f_res_292820 +\n                                                                   i_303009];\n        defunc_0_f_res_303008 = defunc_0_add_arg_303010;\n    }\n    \n    double x_303011 = a11_302990 * x_303005;\n    double y_303012 = b11_302992 * x_303006;\n    double x_303013 = x_303011 + y_303012;\n    double defunc_9_fit_fun_res_303014 = defunc_0_f_res_303008 * x_303013;\n    double x_303015 = b11_302992 * x_303005;\n    double y_303016 = c11_302993 * x_303006;\n    double x_303017 = x_303015 + y_303016;\n    double defunc_9_slope_fun_res_303018 = defunc_0_f_res_303008 * x_303017;\n    \n    ((__local double *) red_arr_mem_321741)[gtid_302996] =\n        defunc_9_fit_fun_res_303014;\n    ((__local double *) red_arr_mem_321743)[gtid_302996] =\n        defunc_9_slope_fun_res_303018;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_321745;\n    int32_t skip_waves_321746 = 1;\n    double x_302998;\n    double x_302999;\n    double x_303000;\n    double x_303001;\n    \n    offset_321745 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_321720, sext_i64_i32(q_s_292678))) {\n            x_302998 = ((__local\n                         double *) red_arr_mem_321741)[sext_i32_i64(local_tid_321720 +\n                                                       offset_321745)];\n            x_302999 = ((__local\n                         double *) red_arr_mem_321743)[sext_i32_i64(local_tid_321720 +\n                                                       offset_321745)];\n        }\n    }\n    offset_321745 = 1;\n    while (slt32(offset_321745, wave_sizze_321722)) {\n        if (slt32(local_tid_321720 + offset_321745, sext_i64_i32(q_s_292678)) &&\n            ((local_tid_321720 - squot32(local_tid_321720, wave_sizze_321722) *\n              wave_sizze_321722) & (2 * offset_321745 - 1)) == 0) {\n            // read",
            " array element\n            {\n                x_303000 = ((volatile __local\n                             double *) red_arr_mem_321741)[sext_i32_i64(local_tid_321720 +\n                                                           offset_321745)];\n                x_303001 = ((volatile __local\n                             double *) red_arr_mem_321743)[sext_i32_i64(local_tid_321720 +\n                                                           offset_321745)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_303002 = x_302998 + x_303000;\n                double defunc_1_op_res_303003 = x_302999 + x_303001;\n                \n                x_302998 = defunc_1_op_res_303002;\n                x_302999 = defunc_1_op_res_303003;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_321741)[sext_i32_i64(local_tid_321720)] =\n                    x_302998;\n                ((volatile __local\n                  double *) red_arr_mem_321743)[sext_i32_i64(local_tid_321720)] =\n                    x_302999;\n            }\n        }\n        offset_321745 *= 2;\n    }\n    while (slt32(skip_waves_321746, squot32(sext_i64_i32(q_s_292678) +\n                                            wave_sizze_321722 - 1,\n                                            wave_sizze_321722))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_321745 = skip_waves_321746 * wave_sizze_321722;\n        if (slt32(local_tid_321720 + offset_321745, sext_i64_i32(q_s_292678)) &&\n            ((local_tid_321720 - squot32(local_tid_321720, wave_sizze_321722) *\n              wave_sizze_321722) == 0 && (squot32(local_tid_321720,\n                                                  wave_sizze_321722) & (2 *\n                                                                        skip_waves_321746 -\n                                                                        1)) ==\n             0))",
            " {\n            // read array element\n            {\n                x_303000 = ((__local\n                             double *) red_arr_mem_321741)[sext_i32_i64(local_tid_321720 +\n                                                           offset_321745)];\n                x_303001 = ((__local\n                             double *) red_arr_mem_321743)[sext_i32_i64(local_tid_321720 +\n                                                           offset_321745)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_303002 = x_302998 + x_303000;\n                double defunc_1_op_res_303003 = x_302999 + x_303001;\n                \n                x_302998 = defunc_1_op_res_303002;\n                x_302999 = defunc_1_op_res_303003;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_321741)[sext_i32_i64(local_tid_321720)] =\n                    x_302998;\n                ((__local\n                  double *) red_arr_mem_321743)[sext_i32_i64(local_tid_321720)] =\n                    x_302999;\n            }\n        }\n        skip_waves_321746 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_302994 = ((__local\n                                   double *) red_arr_mem_321741)[(int64_t) 0];\n    defunc_2_reduce_res_302995 = ((__local\n                                   double *) red_arr_mem_321743)[(int64_t) 0];\n    if (local_tid_321720 == 0) {\n        ((__global double *) mem_318943)[gtid_302922 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_302923 * s_n_m_292825 +\n                                         gtid_302924] =\n            defunc_2_reduce_res_302994;\n    }\n    if (local_tid_321720 == 0) {\n        ((__global double *) mem_318948)[gtid_302922 * (s_n_m_292825 *\n                                                        n_p_292677) +\n          ",
            "                               gtid_302923 * s_n_m_292825 +\n                                         gtid_302924] =\n            defunc_2_reduce_res_302995;\n    }\n    \n  error_4:\n    return;\n}\n__kernel void mainzisegmap_intragroup_303389(__global int *global_failure,\n                                             uint red_arr_mem_321776_backing_offset_0,\n                                             uint red_arr_mem_321774_backing_offset_1,\n                                             uint red_arr_mem_321770_backing_offset_2,\n                                             uint red_arr_mem_321768_backing_offset_3,\n                                             uint red_arr_mem_321766_backing_offset_4,\n                                             uint red_arr_mem_321764_backing_offset_5,\n                                             uint red_arr_mem_321762_backing_offset_6,\n                                             uint color_320613_backing_offset_7,\n                                             uint color_320612_backing_offset_8,\n                                             uint color_320611_backing_offset_9,\n                                             uint color_320610_backing_offset_10,\n                                             int64_t n_p_292677,\n                                             int64_t q_s_292678,\n                                             int64_t jump_s_292684,\n                                             int64_t partition_sizze_292766,\n                                             int64_t defunc_0_f_res_292820,\n                                             int64_t pad_css_len_292821,\n                                             int64_t s_n_m_292825, __global\n                                             unsigned char *ext_mem_318609,\n                                             __global\n                                             unsigned char *ext_mem_318610,\n                                             __global\n                                       ",
            "      unsigned char *ext_mem_318707,\n                                             __global\n                                             unsigned char *ext_mem_318708,\n                                             __global unsigned char *mem_318871,\n                                             __global unsigned char *mem_318876,\n                                             __global unsigned char *mem_318969,\n                                             __global unsigned char *mem_318974)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_321776_backing_10 =\n                           &shared_mem[red_arr_mem_321776_backing_offset_0];\n    volatile unsigned char *red_arr_mem_321774_backing_9 =\n                           &shared_mem[red_arr_mem_321774_backing_offset_1];\n    volatile unsigned char *red_arr_mem_321770_backing_8 =\n                           &shared_mem[red_arr_mem_321770_backing_offset_2];\n    volatile unsigned char *red_arr_mem_321768_backing_7 =\n                           &shared_mem[red_arr_mem_321768_backing_offset_3];\n    volatile unsigned char *red_arr_mem_321766_backing_6 =\n                           &shared_mem[red_arr_mem_321766_backing_offset_4];\n    volatile unsigned char *red_arr_mem_321764_backing_5 =\n                           &shared_mem[red_arr_mem_321764_backing_offset_5];\n    volatile unsigned char *red_arr_mem_321762_backing_4 =\n                           &shared_mem[red_arr_mem_321762_backing_offset_6];\n    volatile unsigned char *color_320613_backing_3 =\n                           &shared_mem[color_320613_backing_offset_7];\n    volatile unsigned char *color_320612_backing_2 =\n                           &shared_mem[color_320612_backing_offset_8];\n    volatile unsigned char *color_320611_backing_1 =\n                           &shared_mem[color_320611_backing_offset_9];\n    volatile unsigned char *color_320610_backing_0 =\n                           &shared_mem[",
            "color_320610_backing_offset_10];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321748;\n    int32_t local_tid_321749;\n    int64_t group_sizze_321752;\n    int32_t wave_sizze_321751;\n    int32_t group_tid_321750;\n    \n    global_tid_321748 = get_global_id(0);\n    local_tid_321749 = get_local_id(0);\n    group_sizze_321752 = get_local_size(0);\n    wave_sizze_321751 = LOCKSTEP_WIDTH;\n    group_tid_321750 = get_group_id(0);\n    \n    int32_t phys_tid_303389 = group_tid_321750;\n    int64_t slice_321754 = q_s_292678;\n    int64_t ltid_pre_321753 = sext_i32_i64(local_tid_321749);\n    int64_t remnant_321755 = sext_i32_i64(local_tid_321749) - ltid_pre_321753;\n    int64_t slice_321756 = s_n_m_292825;\n    int64_t slice_321757 = n_p_292677 * slice_321756;\n    int64_t slice_321758 = partition_sizze_292766 * slice_321757;\n    int64_t gtid_303386 = squot64(sext_i32_i64(group_tid_321750), slice_321757);\n    int64_t remnant_321759 = sext_i32_i64(group_tid_321750) - gtid_303386 *\n            slice_321757;\n    int64_t gtid_303387 = squot64(remnant_321759, slice_321756);\n    int64_t remnant_321760 = remnant_321759 - gtid_303387 * slice_321756;\n    int64_t gtid_303388 = remnant_321760;\n    int64_t remnant_321761 = remnant_321760 - gtid_303388;\n    __local unsigned char *color_320610;\n    \n    color_320610 = (__local unsigned char *) color_320610_backing_0;\n    \n    __local unsigned char *color_320611;\n    \n    color_320611 = (__local unsigned char *) color_320611_backing_1;\n    \n    __local unsigned char *color_320612;\n    \n    color_320612 = (__local unsigned char *) color_320612_backing_2;\n    \n    __local unsigned char *color_320613;\n    \n    color_320613 = (__local unsigned char *) color_320613_backing_3;\n    \n    int64_t x_303396;\n    \n    x_303396 = ((__global int64_t *) ext_mem_318609)[gtid_303386 * n_p_292677 +\n                                                     gtid_303387];\n    \n    int64_t x_303398;\n    \n    x_303398 = ((__global int64_t *) ext_me",
            "m_318708)[gtid_303386 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_303387 *\n                                                     s_n_m_292825 +\n                                                     gtid_303388];\n    \n    double x_303399;\n    \n    x_303399 = ((__global double *) ext_mem_318707)[gtid_303386 *\n                                                    (s_n_m_292825 *\n                                                     n_p_292677) + gtid_303387 *\n                                                    s_n_m_292825 + gtid_303388];\n    \n    bool cond_303400 = gtid_303388 == (int64_t) 0;\n    int64_t defunc_0_m_fun_res_303401;\n    \n    if (cond_303400) {\n        defunc_0_m_fun_res_303401 = (int64_t) 0;\n    } else {\n        int64_t y_303402 = sub64(s_n_m_292825, (int64_t) 1);\n        bool cond_303403 = gtid_303388 == y_303402;\n        int64_t defunc_0_m_fun_res_f_res_303404;\n        \n        if (cond_303403) {\n            int64_t defunc_0_m_fun_res_f_res_t_res_303405 =\n                    sub64(pad_css_len_292821, (int64_t) 1);\n            \n            defunc_0_m_fun_res_f_res_303404 =\n                defunc_0_m_fun_res_f_res_t_res_303405;\n        } else {\n            int64_t x_303406 = sub64(gtid_303388, (int64_t) 1);\n            int64_t x_303407 = mul64(jump_s_292684, x_303406);\n            int64_t min_arg_303408 = add64((int64_t) 1, x_303407);\n            int64_t min_res_303409 = smin64(defunc_0_f_res_292820,\n                                            min_arg_303408);\n            \n            defunc_0_m_fun_res_f_res_303404 = min_res_303409;\n        }\n        defunc_0_m_fun_res_303401 = defunc_0_m_fun_res_f_res_303404;\n    }\n    \n    int32_t phys_tid_303413 = local_tid_321749;\n    int64_t gtid_303412 = sext_i32_i64(sext_i64_i32(ltid_pre_321753));\n    bool cond_303415 = sle64(x_303396, gtid_303412);\n    int64_t defun",
            "c_0_f_res_303416;\n    \n    if (cond_303415) {\n        defunc_0_f_res_303416 = (int64_t) 0;\n    } else {\n        int64_t i_303417 = add64(x_303398, gtid_303412);\n        int64_t defunc_0_add_arg_303418;\n        \n        defunc_0_add_arg_303418 = ((__global\n                                    int64_t *) ext_mem_318610)[gtid_303386 *\n                                                               (defunc_0_f_res_292820 *\n                                                                n_p_292677) +\n                                                               gtid_303387 *\n                                                               defunc_0_f_res_292820 +\n                                                               i_303417];\n        \n        int64_t defunc_1_add_res_303419 = add64((int64_t) 1,\n                                                defunc_0_add_arg_303418);\n        \n        defunc_0_f_res_303416 = defunc_1_add_res_303419;\n    }\n    \n    double defunc_0_f_res_303420;\n    \n    if (cond_303415) {\n        defunc_0_f_res_303420 = 0.0;\n    } else {\n        int64_t i_303421 = add64(x_303398, gtid_303412);\n        double defunc_0_add_arg_303422;\n        \n        defunc_0_add_arg_303422 = ((__global double *) mem_318876)[gtid_303386 *\n                                                                   (defunc_0_f_res_292820 *\n                                                                    n_p_292677) +\n                                                                   gtid_303387 *\n                                                                   defunc_0_f_res_292820 +\n                                                                   i_303421];\n        defunc_0_f_res_303420 = defunc_0_add_arg_303422;\n    }\n    \n    int64_t binop_p_303423 = sub64(defunc_0_f_res_303416,\n                                   defunc_0_m_fun_res_303401);\n    double defunc_0_f_res_303424 = sitofp_i64_f64(binop_p_303423);\n    double abs_res_303425 = fabs(defunc_0_f_res_303424);\n    do",
            "uble tmp1_303426 = abs_res_303425 / x_303399;\n    double x_303427 = tmp1_303426 * tmp1_303426;\n    double y_303428 = tmp1_303426 * x_303427;\n    double tmp2_303429 = 1.0 - y_303428;\n    double x_303430 = tmp2_303429 * tmp2_303429;\n    double tmp3_303431 = tmp2_303429 * x_303430;\n    double tmp4_303432 = defunc_0_f_res_303420 * tmp3_303431;\n    \n    ((__local double *) color_320613)[gtid_303412] = defunc_0_f_res_303424;\n    ((__local double *) color_320612)[gtid_303412] = tmp4_303432;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    double defunc_2_reduce_res_303433;\n    double defunc_2_reduce_res_303434;\n    double defunc_2_reduce_res_303435;\n    double defunc_2_reduce_res_303436;\n    double defunc_2_reduce_res_303437;\n    int32_t phys_tid_303441 = local_tid_321749;\n    __local unsigned char *red_arr_mem_321762;\n    \n    red_arr_mem_321762 = (__local unsigned char *) red_arr_mem_321762_backing_4;\n    \n    __local unsigned char *red_arr_mem_321764;\n    \n    red_arr_mem_321764 = (__local unsigned char *) red_arr_mem_321764_backing_5;\n    \n    __local unsigned char *red_arr_mem_321766;\n    \n    red_arr_mem_321766 = (__local unsigned char *) red_arr_mem_321766_backing_6;\n    \n    __local unsigned char *red_arr_mem_321768;\n    \n    red_arr_mem_321768 = (__local unsigned char *) red_arr_mem_321768_backing_7;\n    \n    __local unsigned char *red_arr_mem_321770;\n    \n    red_arr_mem_321770 = (__local unsigned char *) red_arr_mem_321770_backing_8;\n    \n    int64_t gtid_303440 = sext_i32_i64(sext_i64_i32(ltid_pre_321753));\n    double x_303457;\n    \n    x_303457 = ((__local double *) color_320613)[gtid_303440];\n    \n    double x_303458;\n    \n    x_303458 = ((__local double *) color_320612)[gtid_303440];\n    \n    double defunc_1_f_res_303459 = x_303457 * x_303458;\n    double defunc_1_f_res_303460 = x_303457 * defunc_1_f_res_303459;\n    double defunc_1_f_res_303461 = x_303457 * defunc_1_f_res_303460;\n    double defunc_1_f_res_303462 = x_303457 * defunc_1_f_res_303461;\n    \n    ((__loca",
            "l double *) red_arr_mem_321762)[gtid_303440] = x_303458;\n    ((__local double *) red_arr_mem_321764)[gtid_303440] =\n        defunc_1_f_res_303459;\n    ((__local double *) red_arr_mem_321766)[gtid_303440] =\n        defunc_1_f_res_303460;\n    ((__local double *) red_arr_mem_321768)[gtid_303440] =\n        defunc_1_f_res_303461;\n    ((__local double *) red_arr_mem_321770)[gtid_303440] =\n        defunc_1_f_res_303462;\n    ((__local double *) color_320611)[gtid_303440] = defunc_1_f_res_303460;\n    ((__local double *) color_320610)[gtid_303440] = defunc_1_f_res_303459;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_321772;\n    int32_t skip_waves_321773 = 1;\n    double x_303442;\n    double x_303443;\n    double x_303444;\n    double x_303445;\n    double x_303446;\n    double x_303447;\n    double x_303448;\n    double x_303449;\n    double x_303450;\n    double x_303451;\n    \n    offset_321772 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_321749, sext_i64_i32(q_s_292678))) {\n            x_303442 = ((__local\n                         double *) red_arr_mem_321762)[sext_i32_i64(local_tid_321749 +\n                                                       offset_321772)];\n            x_303443 = ((__local\n                         double *) red_arr_mem_321764)[sext_i32_i64(local_tid_321749 +\n                                                       offset_321772)];\n            x_303444 = ((__local\n                         double *) red_arr_mem_321766)[sext_i32_i64(local_tid_321749 +\n                                                       offset_321772)];\n            x_303445 = ((__local\n                         double *) red_arr_mem_321768)[sext_i32_i64(local_tid_321749 +\n                                                       offset_321772)];\n            x_303446 = ((__local\n                         double *) red_arr_mem_321770)[sext_i32_i64(local_tid_321749 +\n                                                       offset_321772)];\n       ",
            " }\n    }\n    offset_321772 = 1;\n    while (slt32(offset_321772, wave_sizze_321751)) {\n        if (slt32(local_tid_321749 + offset_321772, sext_i64_i32(q_s_292678)) &&\n            ((local_tid_321749 - squot32(local_tid_321749, wave_sizze_321751) *\n              wave_sizze_321751) & (2 * offset_321772 - 1)) == 0) {\n            // read array element\n            {\n                x_303447 = ((volatile __local\n                             double *) red_arr_mem_321762)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321772)];\n                x_303448 = ((volatile __local\n                             double *) red_arr_mem_321764)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321772)];\n                x_303449 = ((volatile __local\n                             double *) red_arr_mem_321766)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321772)];\n                x_303450 = ((volatile __local\n                             double *) red_arr_mem_321768)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321772)];\n                x_303451 = ((volatile __local\n                             double *) red_arr_mem_321770)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321772)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_303452 = x_303442 + x_303447;\n                double defunc_1_op_res_303453 = x_303443 + x_303448;\n                double defunc_1_op_res_303454 = x_303444 + x_303449;\n                double defunc_1_op_res_303455 = x_303445 + x_303450;\n                double defunc_1_op_res_303456 = x_303446 + x_303451;\n                \n                x_303442 = defunc_1_op_res_303452;\n                x_303443 = defunc_1_op_res_303453;\n                x_303444 = defunc_1_op_",
            "res_303454;\n                x_303445 = defunc_1_op_res_303455;\n                x_303446 = defunc_1_op_res_303456;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_321762)[sext_i32_i64(local_tid_321749)] =\n                    x_303442;\n                ((volatile __local\n                  double *) red_arr_mem_321764)[sext_i32_i64(local_tid_321749)] =\n                    x_303443;\n                ((volatile __local\n                  double *) red_arr_mem_321766)[sext_i32_i64(local_tid_321749)] =\n                    x_303444;\n                ((volatile __local\n                  double *) red_arr_mem_321768)[sext_i32_i64(local_tid_321749)] =\n                    x_303445;\n                ((volatile __local\n                  double *) red_arr_mem_321770)[sext_i32_i64(local_tid_321749)] =\n                    x_303446;\n            }\n        }\n        offset_321772 *= 2;\n    }\n    while (slt32(skip_waves_321773, squot32(sext_i64_i32(q_s_292678) +\n                                            wave_sizze_321751 - 1,\n                                            wave_sizze_321751))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_321772 = skip_waves_321773 * wave_sizze_321751;\n        if (slt32(local_tid_321749 + offset_321772, sext_i64_i32(q_s_292678)) &&\n            ((local_tid_321749 - squot32(local_tid_321749, wave_sizze_321751) *\n              wave_sizze_321751) == 0 && (squot32(local_tid_321749,\n                                                  wave_sizze_321751) & (2 *\n                                                                        skip_waves_321773 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_303447 = ((__local\n                             double *) red_arr_mem_321762)[sext_i32_i64(local_tid_321749 +\n                                               ",
            "            offset_321772)];\n                x_303448 = ((__local\n                             double *) red_arr_mem_321764)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321772)];\n                x_303449 = ((__local\n                             double *) red_arr_mem_321766)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321772)];\n                x_303450 = ((__local\n                             double *) red_arr_mem_321768)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321772)];\n                x_303451 = ((__local\n                             double *) red_arr_mem_321770)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321772)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_303452 = x_303442 + x_303447;\n                double defunc_1_op_res_303453 = x_303443 + x_303448;\n                double defunc_1_op_res_303454 = x_303444 + x_303449;\n                double defunc_1_op_res_303455 = x_303445 + x_303450;\n                double defunc_1_op_res_303456 = x_303446 + x_303451;\n                \n                x_303442 = defunc_1_op_res_303452;\n                x_303443 = defunc_1_op_res_303453;\n                x_303444 = defunc_1_op_res_303454;\n                x_303445 = defunc_1_op_res_303455;\n                x_303446 = defunc_1_op_res_303456;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_321762)[sext_i32_i64(local_tid_321749)] =\n                    x_303442;\n                ((__local\n                  double *) red_arr_mem_321764)[sext_i32_i64(local_tid_321749)] =\n                    x_303443;\n                ((__local\n                  double *) red_arr_mem_321766)[sext_i32_i64(local_tid_321749)] =\n                ",
            "    x_303444;\n                ((__local\n                  double *) red_arr_mem_321768)[sext_i32_i64(local_tid_321749)] =\n                    x_303445;\n                ((__local\n                  double *) red_arr_mem_321770)[sext_i32_i64(local_tid_321749)] =\n                    x_303446;\n            }\n        }\n        skip_waves_321773 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_303433 = ((__local\n                                   double *) red_arr_mem_321762)[(int64_t) 0];\n    defunc_2_reduce_res_303434 = ((__local\n                                   double *) red_arr_mem_321764)[(int64_t) 0];\n    defunc_2_reduce_res_303435 = ((__local\n                                   double *) red_arr_mem_321766)[(int64_t) 0];\n    defunc_2_reduce_res_303436 = ((__local\n                                   double *) red_arr_mem_321768)[(int64_t) 0];\n    defunc_2_reduce_res_303437 = ((__local\n                                   double *) red_arr_mem_321770)[(int64_t) 0];\n    \n    double a_303463 = 2.220446049250313e-16 + defunc_2_reduce_res_303433;\n    double b_303464 = 2.220446049250313e-16 + defunc_2_reduce_res_303434;\n    double c_303465 = 2.220446049250313e-16 + defunc_2_reduce_res_303435;\n    double d_303466 = 2.220446049250313e-16 + defunc_2_reduce_res_303436;\n    double e_303467 = 2.220446049250313e-16 + defunc_2_reduce_res_303437;\n    double x_303468 = c_303465 * e_303467;\n    double y_303469 = d_303466 * d_303466;\n    double a12_303470 = x_303468 - y_303469;\n    double x_303471 = c_303465 * d_303466;\n    double y_303472 = b_303464 * e_303467;\n    double b12_303473 = x_303471 - y_303472;\n    double x_303474 = b_303464 * d_303466;\n    double y_303475 = c_303465 * c_303465;\n    double c12_303476 = x_303474 - y_303475;\n    double x_303477 = a_303463 * e_303467;\n    double b2_303478 = x_303477 - y_303475;\n    double x_303479 = b_303464 * c_303465;\n    double y_303480 = a_303463 * d_303466;\n    double c2_303481 = x_303479 - y_303480;\n    double x_303482",
            " = a_303463 * a12_303470;\n    double y_303483 = b_303464 * b12_303473;\n    double x_303484 = x_303482 + y_303483;\n    double y_303485 = c_303465 * c12_303476;\n    double y_303486 = x_303484 + y_303485;\n    double det_303487 = 1.0 / y_303486;\n    double a12_303488 = a12_303470 * det_303487;\n    double b12_303489 = b12_303473 * det_303487;\n    double c12_303490 = c12_303476 * det_303487;\n    double b2_303491 = b2_303478 * det_303487;\n    double c2_303492 = c2_303481 * det_303487;\n    double defunc_2_reduce_res_303493;\n    double defunc_2_reduce_res_303494;\n    int32_t phys_tid_303496 = local_tid_321749;\n    __local unsigned char *red_arr_mem_321774;\n    \n    red_arr_mem_321774 = (__local unsigned char *) red_arr_mem_321774_backing_9;\n    \n    __local unsigned char *red_arr_mem_321776;\n    \n    red_arr_mem_321776 = (__local\n                          unsigned char *) red_arr_mem_321776_backing_10;\n    \n    int64_t gtid_303495 = sext_i32_i64(sext_i64_i32(ltid_pre_321753));\n    double x_303504;\n    \n    x_303504 = ((__local double *) color_320612)[gtid_303495];\n    \n    double x_303505;\n    \n    x_303505 = ((__local double *) color_320610)[gtid_303495];\n    \n    double x_303506;\n    \n    x_303506 = ((__local double *) color_320611)[gtid_303495];\n    \n    bool cond_303507 = sle64(x_303396, gtid_303495);\n    double defunc_0_f_res_303508;\n    \n    if (cond_303507) {\n        defunc_0_f_res_303508 = 0.0;\n    } else {\n        int64_t i_303509 = add64(x_303398, gtid_303495);\n        double defunc_0_add_arg_303510;\n        \n        defunc_0_add_arg_303510 = ((__global double *) mem_318871)[gtid_303386 *\n                                                                   (defunc_0_f_res_292820 *\n                                                                    n_p_292677) +\n                                                                   gtid_303387 *\n                                                                   defunc_0_f_res_292820 +\n                                     ",
            "                              i_303509];\n        defunc_0_f_res_303508 = defunc_0_add_arg_303510;\n    }\n    \n    double x_303511 = a12_303488 * x_303504;\n    double y_303512 = b12_303489 * x_303505;\n    double x_303513 = x_303511 + y_303512;\n    double y_303514 = c12_303490 * x_303506;\n    double x_303515 = x_303513 + y_303514;\n    double defunc_9_fit_fun_res_303516 = defunc_0_f_res_303508 * x_303515;\n    double x_303517 = b12_303489 * x_303504;\n    double y_303518 = b2_303491 * x_303505;\n    double x_303519 = x_303517 + y_303518;\n    double y_303520 = c2_303492 * x_303506;\n    double x_303521 = x_303519 + y_303520;\n    double defunc_9_slope_fun_res_303522 = defunc_0_f_res_303508 * x_303521;\n    \n    ((__local double *) red_arr_mem_321774)[gtid_303495] =\n        defunc_9_fit_fun_res_303516;\n    ((__local double *) red_arr_mem_321776)[gtid_303495] =\n        defunc_9_slope_fun_res_303522;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_321778;\n    int32_t skip_waves_321779 = 1;\n    double x_303497;\n    double x_303498;\n    double x_303499;\n    double x_303500;\n    \n    offset_321778 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_321749, sext_i64_i32(q_s_292678))) {\n            x_303497 = ((__local\n                         double *) red_arr_mem_321774)[sext_i32_i64(local_tid_321749 +\n                                                       offset_321778)];\n            x_303498 = ((__local\n                         double *) red_arr_mem_321776)[sext_i32_i64(local_tid_321749 +\n                                                       offset_321778)];\n        }\n    }\n    offset_321778 = 1;\n    while (slt32(offset_321778, wave_sizze_321751)) {\n        if (slt32(local_tid_321749 + offset_321778, sext_i64_i32(q_s_292678)) &&\n            ((local_tid_321749 - squot32(local_tid_321749, wave_sizze_321751) *\n              wave_sizze_321751) & (2 * offset_321778 - 1)) == 0) {\n            // read array element\n            {\n        ",
            "        x_303499 = ((volatile __local\n                             double *) red_arr_mem_321774)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321778)];\n                x_303500 = ((volatile __local\n                             double *) red_arr_mem_321776)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321778)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_303501 = x_303497 + x_303499;\n                double defunc_1_op_res_303502 = x_303498 + x_303500;\n                \n                x_303497 = defunc_1_op_res_303501;\n                x_303498 = defunc_1_op_res_303502;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_321774)[sext_i32_i64(local_tid_321749)] =\n                    x_303497;\n                ((volatile __local\n                  double *) red_arr_mem_321776)[sext_i32_i64(local_tid_321749)] =\n                    x_303498;\n            }\n        }\n        offset_321778 *= 2;\n    }\n    while (slt32(skip_waves_321779, squot32(sext_i64_i32(q_s_292678) +\n                                            wave_sizze_321751 - 1,\n                                            wave_sizze_321751))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_321778 = skip_waves_321779 * wave_sizze_321751;\n        if (slt32(local_tid_321749 + offset_321778, sext_i64_i32(q_s_292678)) &&\n            ((local_tid_321749 - squot32(local_tid_321749, wave_sizze_321751) *\n              wave_sizze_321751) == 0 && (squot32(local_tid_321749,\n                                                  wave_sizze_321751) & (2 *\n                                                                        skip_waves_321779 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n",
            "            {\n                x_303499 = ((__local\n                             double *) red_arr_mem_321774)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321778)];\n                x_303500 = ((__local\n                             double *) red_arr_mem_321776)[sext_i32_i64(local_tid_321749 +\n                                                           offset_321778)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_303501 = x_303497 + x_303499;\n                double defunc_1_op_res_303502 = x_303498 + x_303500;\n                \n                x_303497 = defunc_1_op_res_303501;\n                x_303498 = defunc_1_op_res_303502;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_321774)[sext_i32_i64(local_tid_321749)] =\n                    x_303497;\n                ((__local\n                  double *) red_arr_mem_321776)[sext_i32_i64(local_tid_321749)] =\n                    x_303498;\n            }\n        }\n        skip_waves_321779 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_303493 = ((__local\n                                   double *) red_arr_mem_321774)[(int64_t) 0];\n    defunc_2_reduce_res_303494 = ((__local\n                                   double *) red_arr_mem_321776)[(int64_t) 0];\n    if (local_tid_321749 == 0) {\n        ((__global double *) mem_318969)[gtid_303386 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_303387 * s_n_m_292825 +\n                                         gtid_303388] =\n            defunc_2_reduce_res_303493;\n    }\n    if (local_tid_321749 == 0) {\n        ((__global double *) mem_318974)[gtid_303386 * (s_n_m_292825 *\n                                                        n_p_292677) +\n                                         gtid_3",
            "03387 * s_n_m_292825 +\n                                         gtid_303388] =\n            defunc_2_reduce_res_303494;\n    }\n    \n  error_5:\n    return;\n}\n__kernel void mainzisegmap_intragroup_304495(__global int *global_failure,\n                                             uint red_arr_mem_321841_backing_offset_0,\n                                             uint red_arr_mem_321821_backing_offset_1,\n                                             uint color_320618_backing_offset_2,\n                                             uint color_320617_backing_offset_3,\n                                             uint color_320616_backing_offset_4,\n                                             uint color_320615_backing_offset_5,\n                                             int64_t n_p_292677,\n                                             int64_t q_s_292678,\n                                             int64_t jump_s_292684,\n                                             int64_t partition_sizze_292766,\n                                             int64_t defunc_0_f_res_292820,\n                                             int64_t pad_css_len_292821,\n                                             int64_t s_n_m_292825,\n                                             int64_t computed_group_sizze_304396,\n                                             __global\n                                             unsigned char *ext_mem_318609,\n                                             __global\n                                             unsigned char *ext_mem_318610,\n                                             __global\n                                             unsigned char *ext_mem_318707,\n                                             __global\n                                             unsigned char *ext_mem_318708,\n                                             __global unsigned char *mem_318871,\n                                             __global unsigned char *mem_318876,\n                 ",
            "                            __global unsigned char *mem_319050)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_321841_backing_5 =\n                           &shared_mem[red_arr_mem_321841_backing_offset_0];\n    volatile unsigned char *red_arr_mem_321821_backing_4 =\n                           &shared_mem[red_arr_mem_321821_backing_offset_1];\n    volatile unsigned char *color_320618_backing_3 =\n                           &shared_mem[color_320618_backing_offset_2];\n    volatile unsigned char *color_320617_backing_2 =\n                           &shared_mem[color_320617_backing_offset_3];\n    volatile unsigned char *color_320616_backing_1 =\n                           &shared_mem[color_320616_backing_offset_4];\n    volatile unsigned char *color_320615_backing_0 =\n                           &shared_mem[color_320615_backing_offset_5];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321803;\n    int32_t local_tid_321804;\n    int64_t group_sizze_321807;\n    int32_t wave_sizze_321806;\n    int32_t group_tid_321805;\n    \n    global_tid_321803 = get_global_id(0);\n    local_tid_321804 = get_local_id(0);\n    group_sizze_321807 = get_local_size(0);\n    wave_sizze_321806 = LOCKSTEP_WIDTH;\n    group_tid_321805 = get_group_id(0);\n    \n    int32_t phys_tid_304495 = group_tid_321805;\n    int64_t slice_321809 = s_n_m_292825;\n    int64_t ltid_pre_321808 = sext_i32_i64(local_tid_321804);\n    int64_t remnant_321810 = sext_i32_i64(local_tid_321804) - ltid_pre_321808;\n    int64_t slice_321813 = q_s_292678;\n    int64_t slice_321814 = s_n_m_292825 * slice_321813;\n    int64_t ltid_pre_321811 = squot64(sext_i32_i64(local_tid_321804),\n                                      slice_321813);\n    int64_t remnant_321815 = sext_i32_i64(local_tid_321804) - ltid_pre_321811 *\n            slice_321813;\n    int64_t ltid_pre_321812 = remnant_321815;\n    int64_t remnant_321816 = remnant_321815 - ltid",
            "_pre_321812;\n    int64_t slice_321817 = n_p_292677;\n    int64_t slice_321818 = partition_sizze_292766 * slice_321817;\n    int64_t gtid_304493 = squot64(sext_i32_i64(group_tid_321805), slice_321817);\n    int64_t remnant_321819 = sext_i32_i64(group_tid_321805) - gtid_304493 *\n            slice_321817;\n    int64_t gtid_304494 = remnant_321819;\n    int64_t remnant_321820 = remnant_321819 - gtid_304494;\n    __local unsigned char *color_320615;\n    \n    color_320615 = (__local unsigned char *) color_320615_backing_0;\n    \n    __local unsigned char *color_320616;\n    \n    color_320616 = (__local unsigned char *) color_320616_backing_1;\n    \n    __local unsigned char *color_320617;\n    \n    color_320617 = (__local unsigned char *) color_320617_backing_2;\n    \n    __local unsigned char *color_320618;\n    \n    color_320618 = (__local unsigned char *) color_320618_backing_3;\n    \n    int64_t x_304502;\n    \n    x_304502 = ((__global int64_t *) ext_mem_318609)[gtid_304493 * n_p_292677 +\n                                                     gtid_304494];\n    \n    int32_t phys_tid_304510 = local_tid_321804;\n    int64_t gtid_304509 = sext_i32_i64(sext_i64_i32(ltid_pre_321808));\n    \n    if (slt64(gtid_304509, s_n_m_292825)) {\n        bool cond_304512 = gtid_304509 == (int64_t) 0;\n        int64_t defunc_0_m_fun_res_304513;\n        \n        if (cond_304512) {\n            defunc_0_m_fun_res_304513 = (int64_t) 0;\n        } else {\n            int64_t y_304514 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_304515 = gtid_304509 == y_304514;\n            int64_t defunc_0_m_fun_res_f_res_304516;\n            \n            if (cond_304515) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_304517 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_304516 =\n                    defunc_0_m_fun_res_f_res_t_res_304517;\n            } else {\n                int64_t x_304518 = sub64(gtid_304509, (int64_t) 1);\n      ",
            "          int64_t x_304519 = mul64(jump_s_292684, x_304518);\n                int64_t min_arg_304520 = add64((int64_t) 1, x_304519);\n                int64_t min_res_304521 = smin64(defunc_0_f_res_292820,\n                                                min_arg_304520);\n                \n                defunc_0_m_fun_res_f_res_304516 = min_res_304521;\n            }\n            defunc_0_m_fun_res_304513 = defunc_0_m_fun_res_f_res_304516;\n        }\n        ((__local int64_t *) color_320616)[gtid_304509] =\n            defunc_0_m_fun_res_304513;\n        ((__local bool *) color_320618)[gtid_304509] = cond_304512;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_304525 = local_tid_321804;\n    __local unsigned char *red_arr_mem_321821;\n    \n    red_arr_mem_321821 = (__local unsigned char *) red_arr_mem_321821_backing_4;\n    \n    int64_t gtid_304523 = sext_i32_i64(sext_i64_i32(ltid_pre_321811));\n    int64_t gtid_304524 = sext_i32_i64(sext_i64_i32(ltid_pre_321812));\n    \n    if (slt64(gtid_304523, s_n_m_292825) && slt64(gtid_304524, q_s_292678)) {\n        int64_t x_304529;\n        \n        x_304529 = ((__global int64_t *) ext_mem_318708)[gtid_304493 *\n                                                         (s_n_m_292825 *\n                                                          n_p_292677) +\n                                                         gtid_304494 *\n                                                         s_n_m_292825 +\n                                                         gtid_304523];\n        \n        double x_304530;\n        \n        x_304530 = ((__global double *) ext_mem_318707)[gtid_304493 *\n                                                        (s_n_m_292825 *\n                                                         n_p_292677) +\n                                                        gtid_304494 *\n                                                        s_n_m_292825 +\n                                                        gtid_304523];",
            "\n        \n        int64_t defunc_0_m_fun_res_304531;\n        \n        defunc_0_m_fun_res_304531 = ((__local\n                                      int64_t *) color_320616)[gtid_304523];\n        \n        bool cond_304533 = sle64(x_304502, gtid_304524);\n        int64_t defunc_0_f_res_304534;\n        \n        if (cond_304533) {\n            defunc_0_f_res_304534 = (int64_t) 0;\n        } else {\n            int64_t i_304535 = add64(gtid_304524, x_304529);\n            int64_t defunc_0_add_arg_304536;\n            \n            defunc_0_add_arg_304536 = ((__global\n                                        int64_t *) ext_mem_318610)[gtid_304493 *\n                                                                   (defunc_0_f_res_292820 *\n                                                                    n_p_292677) +\n                                                                   gtid_304494 *\n                                                                   defunc_0_f_res_292820 +\n                                                                   i_304535];\n            \n            int64_t defunc_1_add_res_304537 = add64((int64_t) 1,\n                                                    defunc_0_add_arg_304536);\n            \n            defunc_0_f_res_304534 = defunc_1_add_res_304537;\n        }\n        \n        double defunc_0_f_res_304538;\n        \n        if (cond_304533) {\n            defunc_0_f_res_304538 = 0.0;\n        } else {\n            int64_t i_304539 = add64(gtid_304524, x_304529);\n            double defunc_0_add_arg_304540;\n            \n            defunc_0_add_arg_304540 = ((__global\n                                        double *) mem_318876)[gtid_304493 *\n                                                              (defunc_0_f_res_292820 *\n                                                               n_p_292677) +\n                                                              gtid_304494 *\n                                                              defunc_0_",
            "f_res_292820 +\n                                                              i_304539];\n            defunc_0_f_res_304538 = defunc_0_add_arg_304540;\n        }\n        \n        int64_t binop_p_304541 = sub64(defunc_0_f_res_304534,\n                                       defunc_0_m_fun_res_304531);\n        double defunc_0_f_res_304542 = sitofp_i64_f64(binop_p_304541);\n        double abs_res_304543 = fabs(defunc_0_f_res_304542);\n        double tmp1_304544 = abs_res_304543 / x_304530;\n        double x_304545 = tmp1_304544 * tmp1_304544;\n        double y_304546 = tmp1_304544 * x_304545;\n        double tmp2_304547 = 1.0 - y_304546;\n        double x_304548 = tmp2_304547 * tmp2_304547;\n        double tmp3_304549 = tmp2_304547 * x_304548;\n        double w_j_304550 = defunc_0_f_res_304538 * tmp3_304549;\n        \n        ((__local double *) red_arr_mem_321821)[gtid_304523 * q_s_292678 +\n                                                gtid_304524] = w_j_304550;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t dims_flat_321823 = s_n_m_292825 * q_s_292678;\n    double x_304526;\n    double x_304527;\n    double x_321825;\n    double x_321826;\n    bool ltid_in_bounds_321828 = slt64(sext_i32_i64(local_tid_321804),\n                                       s_n_m_292825 * q_s_292678);\n    int32_t skip_threads_321829;\n    \n    // read input for in-block scan\n    {\n        if (ltid_in_bounds_321828) {\n            x_304527 = ((volatile __local\n                         double *) red_arr_mem_321821)[sext_i32_i64(local_tid_321804)];\n            if ((local_tid_321804 - squot32(local_tid_321804, 32) * 32) == 0) {\n                x_304526 = x_304527;\n            }\n        }\n    }\n    // in-block scan (hopefully no barriers needed)\n    {\n        skip_threads_321829 = 1;\n        while (slt32(skip_threads_321829, 32)) {\n            bool thread_active_321830 = sle32(skip_threads_321829,\n                                              local_tid_321804 -\n                                              ",
            "squot32(local_tid_321804, 32) *\n                                              32) && ltid_in_bounds_321828;\n            \n            if (thread_active_321830) {\n                // read operands\n                {\n                    x_304526 = ((volatile __local\n                                 double *) red_arr_mem_321821)[sext_i32_i64(local_tid_321804) -\n                                                               sext_i32_i64(skip_threads_321829)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_321831 =\n                     slt64(srem64(sext_i32_i64(local_tid_321804), q_s_292678),\n                           sext_i32_i64(local_tid_321804) -\n                           sext_i32_i64(local_tid_321804 -\n                           skip_threads_321829));\n                \n                if (thread_active_321830 && inactive_321831) {\n                    x_304526 = x_304527;\n                }\n                if (thread_active_321830) {\n                    if (!inactive_321831) {\n                        double defunc_1_op_res_304528 = x_304526 + x_304527;\n                        \n                        x_304526 = defunc_1_op_res_304528;\n                    }\n                }\n            }\n            if (sle32(wave_sizze_321806, skip_threads_321829)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            if (thread_active_321830) {\n                // write result\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_321821)[sext_i32_i64(local_tid_321804)] =\n                        x_304526;\n                    x_304527 = x_304526;\n                }\n            }\n            if (sle32(wave_sizze_321806, skip_threads_321829)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            skip_threads_321829 *= 2;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // last thread of block 'i' writes its result to offset 'i'\n    {\n     ",
            "   if ((local_tid_321804 - squot32(local_tid_321804, 32) * 32) == 31 &&\n            ltid_in_bounds_321828) {\n            ((volatile __local\n              double *) red_arr_mem_321821)[sext_i32_i64(squot32(local_tid_321804,\n                                                                 32))] =\n                x_304526;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n    {\n        int32_t skip_threads_321832;\n        \n        // read input for in-block scan\n        {\n            if (squot32(local_tid_321804, 32) == 0 && ltid_in_bounds_321828) {\n                x_321826 = ((volatile __local\n                             double *) red_arr_mem_321821)[sext_i32_i64(local_tid_321804)];\n                if ((local_tid_321804 - squot32(local_tid_321804, 32) * 32) ==\n                    0) {\n                    x_321825 = x_321826;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_321832 = 1;\n            while (slt32(skip_threads_321832, 32)) {\n                bool thread_active_321833 = sle32(skip_threads_321832,\n                                                  local_tid_321804 -\n                                                  squot32(local_tid_321804,\n                                                          32) * 32) &&\n                     (squot32(local_tid_321804, 32) == 0 &&\n                      ltid_in_bounds_321828);\n                \n                if (thread_active_321833) {\n                    // read operands\n                    {\n                        x_321825 = ((volatile __local\n                                     double *) red_arr_mem_321821)[sext_i32_i64(local_tid_321804) -\n                                                                   sext_i32_i64(skip_threads_321832)];\n                    }\n                }\n                // perform operation\n                {\n               ",
            "     bool inactive_321834 =\n                         slt64(srem64(sext_i32_i64(local_tid_321804 * 32 + 32 -\n                                      1), q_s_292678),\n                               sext_i32_i64(local_tid_321804 * 32 + 32 - 1) -\n                               sext_i32_i64((local_tid_321804 -\n                                             skip_threads_321832) * 32 + 32 -\n                               1));\n                    \n                    if (thread_active_321833 && inactive_321834) {\n                        x_321825 = x_321826;\n                    }\n                    if (thread_active_321833) {\n                        if (!inactive_321834) {\n                            double defunc_1_op_res_321827 = x_321825 + x_321826;\n                            \n                            x_321825 = defunc_1_op_res_321827;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_321806, skip_threads_321832)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_321833) {\n                    // write result\n                    {\n                        ((volatile __local\n                          double *) red_arr_mem_321821)[sext_i32_i64(local_tid_321804)] =\n                            x_321825;\n                        x_321826 = x_321825;\n                    }\n                }\n                if (sle32(wave_sizze_321806, skip_threads_321832)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_321832 *= 2;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    bool no_carry_in_321835 = squot32(local_tid_321804, 32) == 0 ||\n         !ltid_in_bounds_321828;\n    \n    // carry-in for every block except the first\n    {\n        // read operands\n        {\n            if (!no_carry_in_321835) {\n                x_304527 = x_304526;\n                x_304526 = ((__local\n                             double *) ",
            "red_arr_mem_321821)[sext_i32_i64(squot32(local_tid_321804,\n                                                                                32)) -\n                                                           (int64_t) 1];\n            }\n        }\n        // perform operation\n        {\n            bool inactive_321836 = slt64(srem64(sext_i32_i64(local_tid_321804),\n                                                q_s_292678),\n                                         sext_i32_i64(local_tid_321804) -\n                                         sext_i32_i64(squot32(local_tid_321804,\n                                                              32) * 32 - 1));\n            \n            if (!no_carry_in_321835) {\n                if (inactive_321836) {\n                    x_304526 = x_304527;\n                }\n            }\n            if (!no_carry_in_321835) {\n                if (!inactive_321836) {\n                    double defunc_1_op_res_304528 = x_304526 + x_304527;\n                    \n                    x_304526 = defunc_1_op_res_304528;\n                }\n            }\n        }\n        // write final result\n        {\n            if (!no_carry_in_321835) {\n                ((__local\n                  double *) red_arr_mem_321821)[sext_i32_i64(local_tid_321804)] =\n                    x_304526;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // restore correct values for first block\n    {\n        if (squot32(local_tid_321804, 32) == 0 && ltid_in_bounds_321828) {\n            ((__local\n              double *) red_arr_mem_321821)[sext_i32_i64(local_tid_321804)] =\n                x_304527;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321837 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_304396));\n    \n    for (int32_t chunk_i_321838 = 0; chunk_i_321838 < num_chunks_321837;\n         chunk_i_321838++) {\n        int32_t i_321839 ",
            "= chunk_i_321838 *\n                sext_i64_i32(computed_group_sizze_304396) + local_tid_321804;\n        \n        if (slt32(i_321839, sext_i64_i32(s_n_m_292825))) {\n            double tmp_321840;\n            \n            tmp_321840 = ((__local double *) red_arr_mem_321821)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_321839) *\n                                                                 q_s_292678];\n            ((__local double *) color_320615)[sext_i32_i64(i_321839)] =\n                tmp_321840;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_304554 = local_tid_321804;\n    int64_t gtid_304553 = sext_i32_i64(sext_i64_i32(ltid_pre_321808));\n    \n    if (slt64(gtid_304553, s_n_m_292825)) {\n        bool index_primexp_317927 = gtid_304553 == (int64_t) 0;\n        double defunc_2_reduce_res_304557;\n        \n        defunc_2_reduce_res_304557 = ((__local\n                                       double *) color_320615)[gtid_304553];\n        \n        double a_304558 = 2.220446049250313e-16 + defunc_2_reduce_res_304557;\n        double a0_304559 = 1.0 / a_304558;\n        int64_t defunc_0_m_fun_res_304560;\n        \n        if (index_primexp_317927) {\n            defunc_0_m_fun_res_304560 = (int64_t) 0;\n        } else {\n            int64_t y_304561 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_304562 = gtid_304553 == y_304561;\n            int64_t defunc_0_m_fun_res_f_res_304563;\n            \n            if (cond_304562) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_304564 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_304563 =\n                    defunc_0_m_fun_res_f_res_t_res_304564;\n            } else {\n                int64_t x_304565 = sub64(gtid_304553, (int64_t) 1);\n                int6",
            "4_t x_304566 = mul64(jump_s_292684, x_304565);\n                int64_t min_arg_304567 = add64((int64_t) 1, x_304566);\n                int64_t min_res_304568 = smin64(defunc_0_f_res_292820,\n                                                min_arg_304567);\n                \n                defunc_0_m_fun_res_f_res_304563 = min_res_304568;\n            }\n            defunc_0_m_fun_res_304560 = defunc_0_m_fun_res_f_res_304563;\n        }\n        ((__local double *) color_320617)[gtid_304553] = a0_304559;\n        ((__local int64_t *) color_320616)[gtid_304553] =\n            defunc_0_m_fun_res_304560;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_304572 = local_tid_321804;\n    __local unsigned char *red_arr_mem_321841;\n    \n    red_arr_mem_321841 = (__local unsigned char *) red_arr_mem_321841_backing_5;\n    \n    int64_t gtid_304570 = sext_i32_i64(sext_i64_i32(ltid_pre_321811));\n    int64_t gtid_304571 = sext_i32_i64(sext_i64_i32(ltid_pre_321812));\n    \n    if (slt64(gtid_304570, s_n_m_292825) && slt64(gtid_304571, q_s_292678)) {\n        int64_t x_304576;\n        \n        x_304576 = ((__global int64_t *) ext_mem_318708)[gtid_304493 *\n                                                         (s_n_m_292825 *\n                                                          n_p_292677) +\n                                                         gtid_304494 *\n                                                         s_n_m_292825 +\n                                                         gtid_304570];\n        \n        double x_304577;\n        \n        x_304577 = ((__global double *) ext_mem_318707)[gtid_304493 *\n                                                        (s_n_m_292825 *\n                                                         n_p_292677) +\n                                                        gtid_304494 *\n                                                        s_n_m_292825 +\n                                                        gtid_304570];\n        \n    ",
            "    double a0_304578;\n        \n        a0_304578 = ((__local double *) color_320617)[gtid_304570];\n        \n        int64_t defunc_0_m_fun_res_304579;\n        \n        defunc_0_m_fun_res_304579 = ((__local\n                                      int64_t *) color_320616)[gtid_304570];\n        \n        bool cond_304581 = sle64(x_304502, gtid_304571);\n        int64_t defunc_0_f_res_304582;\n        \n        if (cond_304581) {\n            defunc_0_f_res_304582 = (int64_t) 0;\n        } else {\n            int64_t i_304583 = add64(gtid_304571, x_304576);\n            int64_t defunc_0_add_arg_304584;\n            \n            defunc_0_add_arg_304584 = ((__global\n                                        int64_t *) ext_mem_318610)[gtid_304493 *\n                                                                   (defunc_0_f_res_292820 *\n                                                                    n_p_292677) +\n                                                                   gtid_304494 *\n                                                                   defunc_0_f_res_292820 +\n                                                                   i_304583];\n            \n            int64_t defunc_1_add_res_304585 = add64((int64_t) 1,\n                                                    defunc_0_add_arg_304584);\n            \n            defunc_0_f_res_304582 = defunc_1_add_res_304585;\n        }\n        \n        double defunc_0_f_res_304586;\n        \n        if (cond_304581) {\n            defunc_0_f_res_304586 = 0.0;\n        } else {\n            int64_t i_304587 = add64(gtid_304571, x_304576);\n            double defunc_0_add_arg_304588;\n            \n            defunc_0_add_arg_304588 = ((__global\n                                        double *) mem_318876)[gtid_304493 *\n                                                              (defunc_0_f_res_292820 *\n                                                               n_p_292677) +\n                                                 ",
            "             gtid_304494 *\n                                                              defunc_0_f_res_292820 +\n                                                              i_304587];\n            defunc_0_f_res_304586 = defunc_0_add_arg_304588;\n        }\n        \n        int64_t binop_p_304589 = sub64(defunc_0_f_res_304582,\n                                       defunc_0_m_fun_res_304579);\n        double defunc_0_f_res_304590 = sitofp_i64_f64(binop_p_304589);\n        double abs_res_304591 = fabs(defunc_0_f_res_304590);\n        double tmp1_304592 = abs_res_304591 / x_304577;\n        double x_304593 = tmp1_304592 * tmp1_304592;\n        double y_304594 = tmp1_304592 * x_304593;\n        double tmp2_304595 = 1.0 - y_304594;\n        double x_304596 = tmp2_304595 * tmp2_304595;\n        double tmp3_304597 = tmp2_304595 * x_304596;\n        double tmp4_304598 = defunc_0_f_res_304586 * tmp3_304597;\n        double defunc_0_f_res_304599;\n        \n        if (cond_304581) {\n            defunc_0_f_res_304599 = 0.0;\n        } else {\n            int64_t i_304600 = add64(gtid_304571, x_304576);\n            double defunc_0_add_arg_304601;\n            \n            defunc_0_add_arg_304601 = ((__global\n                                        double *) mem_318871)[gtid_304493 *\n                                                              (defunc_0_f_res_292820 *\n                                                               n_p_292677) +\n                                                              gtid_304494 *\n                                                              defunc_0_f_res_292820 +\n                                                              i_304600];\n            defunc_0_f_res_304599 = defunc_0_add_arg_304601;\n        }\n        \n        double x_304602 = a0_304578 * tmp4_304598;\n        double defunc_9_fit_fun_res_304603 = defunc_0_f_res_304599 * x_304602;\n        \n        ((__local double *) red_arr_mem_321841)[gtid_304570 * q_s_292678 +\n                             ",
            "                   gtid_304571] =\n            defunc_9_fit_fun_res_304603;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t dims_flat_321843 = s_n_m_292825 * q_s_292678;\n    double x_304573;\n    double x_304574;\n    double x_321845;\n    double x_321846;\n    bool ltid_in_bounds_321848 = slt64(sext_i32_i64(local_tid_321804),\n                                       s_n_m_292825 * q_s_292678);\n    int32_t skip_threads_321849;\n    \n    // read input for in-block scan\n    {\n        if (ltid_in_bounds_321848) {\n            x_304574 = ((volatile __local\n                         double *) red_arr_mem_321841)[sext_i32_i64(local_tid_321804)];\n            if ((local_tid_321804 - squot32(local_tid_321804, 32) * 32) == 0) {\n                x_304573 = x_304574;\n            }\n        }\n    }\n    // in-block scan (hopefully no barriers needed)\n    {\n        skip_threads_321849 = 1;\n        while (slt32(skip_threads_321849, 32)) {\n            bool thread_active_321850 = sle32(skip_threads_321849,\n                                              local_tid_321804 -\n                                              squot32(local_tid_321804, 32) *\n                                              32) && ltid_in_bounds_321848;\n            \n            if (thread_active_321850) {\n                // read operands\n                {\n                    x_304573 = ((volatile __local\n                                 double *) red_arr_mem_321841)[sext_i32_i64(local_tid_321804) -\n                                                               sext_i32_i64(skip_threads_321849)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_321851 =\n                     slt64(srem64(sext_i32_i64(local_tid_321804), q_s_292678),\n                           sext_i32_i64(local_tid_321804) -\n                           sext_i32_i64(local_tid_321804 -\n                           skip_threads_321849));\n                \n                if (thread_active_321850 && inac",
            "tive_321851) {\n                    x_304573 = x_304574;\n                }\n                if (thread_active_321850) {\n                    if (!inactive_321851) {\n                        double defunc_1_op_res_304575 = x_304573 + x_304574;\n                        \n                        x_304573 = defunc_1_op_res_304575;\n                    }\n                }\n            }\n            if (sle32(wave_sizze_321806, skip_threads_321849)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            if (thread_active_321850) {\n                // write result\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_321841)[sext_i32_i64(local_tid_321804)] =\n                        x_304573;\n                    x_304574 = x_304573;\n                }\n            }\n            if (sle32(wave_sizze_321806, skip_threads_321849)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            skip_threads_321849 *= 2;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // last thread of block 'i' writes its result to offset 'i'\n    {\n        if ((local_tid_321804 - squot32(local_tid_321804, 32) * 32) == 31 &&\n            ltid_in_bounds_321848) {\n            ((volatile __local\n              double *) red_arr_mem_321841)[sext_i32_i64(squot32(local_tid_321804,\n                                                                 32))] =\n                x_304573;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n    {\n        int32_t skip_threads_321852;\n        \n        // read input for in-block scan\n        {\n            if (squot32(local_tid_321804, 32) == 0 && ltid_in_bounds_321848) {\n                x_321846 = ((volatile __local\n                             double *) red_arr_mem_321841)[sext_i32_i64(local_tid_321804)];\n                if ((local_tid_321804 - squot32(local_tid_321804, 32) * 32) ==\n                    0) {\n       ",
            "             x_321845 = x_321846;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_321852 = 1;\n            while (slt32(skip_threads_321852, 32)) {\n                bool thread_active_321853 = sle32(skip_threads_321852,\n                                                  local_tid_321804 -\n                                                  squot32(local_tid_321804,\n                                                          32) * 32) &&\n                     (squot32(local_tid_321804, 32) == 0 &&\n                      ltid_in_bounds_321848);\n                \n                if (thread_active_321853) {\n                    // read operands\n                    {\n                        x_321845 = ((volatile __local\n                                     double *) red_arr_mem_321841)[sext_i32_i64(local_tid_321804) -\n                                                                   sext_i32_i64(skip_threads_321852)];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_321854 =\n                         slt64(srem64(sext_i32_i64(local_tid_321804 * 32 + 32 -\n                                      1), q_s_292678),\n                               sext_i32_i64(local_tid_321804 * 32 + 32 - 1) -\n                               sext_i32_i64((local_tid_321804 -\n                                             skip_threads_321852) * 32 + 32 -\n                               1));\n                    \n                    if (thread_active_321853 && inactive_321854) {\n                        x_321845 = x_321846;\n                    }\n                    if (thread_active_321853) {\n                        if (!inactive_321854) {\n                            double defunc_1_op_res_321847 = x_321845 + x_321846;\n                            \n                            x_321845 = defunc_1_op_res_321847;\n                        }\n                   ",
            " }\n                }\n                if (sle32(wave_sizze_321806, skip_threads_321852)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_321853) {\n                    // write result\n                    {\n                        ((volatile __local\n                          double *) red_arr_mem_321841)[sext_i32_i64(local_tid_321804)] =\n                            x_321845;\n                        x_321846 = x_321845;\n                    }\n                }\n                if (sle32(wave_sizze_321806, skip_threads_321852)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_321852 *= 2;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    bool no_carry_in_321855 = squot32(local_tid_321804, 32) == 0 ||\n         !ltid_in_bounds_321848;\n    \n    // carry-in for every block except the first\n    {\n        // read operands\n        {\n            if (!no_carry_in_321855) {\n                x_304574 = x_304573;\n                x_304573 = ((__local\n                             double *) red_arr_mem_321841)[sext_i32_i64(squot32(local_tid_321804,\n                                                                                32)) -\n                                                           (int64_t) 1];\n            }\n        }\n        // perform operation\n        {\n            bool inactive_321856 = slt64(srem64(sext_i32_i64(local_tid_321804),\n                                                q_s_292678),\n                                         sext_i32_i64(local_tid_321804) -\n                                         sext_i32_i64(squot32(local_tid_321804,\n                                                              32) * 32 - 1));\n            \n            if (!no_carry_in_321855) {\n                if (inactive_321856) {\n                    x_304573 = x_304574;\n                }\n            }\n            if (!no_carry_in_321855) {\n                if (!inactive_",
            "321856) {\n                    double defunc_1_op_res_304575 = x_304573 + x_304574;\n                    \n                    x_304573 = defunc_1_op_res_304575;\n                }\n            }\n        }\n        // write final result\n        {\n            if (!no_carry_in_321855) {\n                ((__local\n                  double *) red_arr_mem_321841)[sext_i32_i64(local_tid_321804)] =\n                    x_304573;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // restore correct values for first block\n    {\n        if (squot32(local_tid_321804, 32) == 0 && ltid_in_bounds_321848) {\n            ((__local\n              double *) red_arr_mem_321841)[sext_i32_i64(local_tid_321804)] =\n                x_304574;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321857 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_304396));\n    \n    for (int32_t chunk_i_321858 = 0; chunk_i_321858 < num_chunks_321857;\n         chunk_i_321858++) {\n        int32_t i_321859 = chunk_i_321858 *\n                sext_i64_i32(computed_group_sizze_304396) + local_tid_321804;\n        \n        if (slt32(i_321859, sext_i64_i32(s_n_m_292825))) {\n            double tmp_321860;\n            \n            tmp_321860 = ((__local double *) red_arr_mem_321841)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_321859) *\n                                                                 q_s_292678];\n            ((__local double *) color_320615)[sext_i32_i64(i_321859)] =\n                tmp_321860;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_321861 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_304396));\n    \n    ",
            "for (int32_t chunk_i_321862 = 0; chunk_i_321862 < num_chunks_321861;\n         chunk_i_321862++) {\n        int32_t i_321863 = chunk_i_321862 *\n                sext_i64_i32(computed_group_sizze_304396) + local_tid_321804;\n        \n        if (slt32(i_321863, sext_i64_i32(s_n_m_292825))) {\n            double tmp_321864;\n            \n            tmp_321864 = ((__local\n                           double *) color_320615)[sext_i32_i64(i_321863)];\n            ((__global double *) mem_319050)[gtid_304493 * (s_n_m_292825 *\n                                                            n_p_292677) +\n                                             gtid_304494 * s_n_m_292825 +\n                                             sext_i32_i64(i_321863)] =\n                tmp_321864;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n  error_6:\n    return;\n}\n__kernel void mainzisegmap_intragroup_306005(__global int *global_failure,\n                                             uint red_arr_mem_322132_backing_offset_0,\n                                             uint red_arr_mem_322130_backing_offset_1,\n                                             uint red_arr_mem_322094_backing_offset_2,\n                                             uint red_arr_mem_322092_backing_offset_3,\n                                             uint red_arr_mem_322090_backing_offset_4,\n                                             uint color_320628_backing_offset_5,\n                                             uint color_320627_backing_offset_6,\n                                             uint color_320626_backing_offset_7,\n                                             uint color_320625_backing_offset_8,\n                                             uint color_320624_backing_offset_9,\n                                             uint color_320623_backing_offset_10,\n                                             uint color_320622_backing_offset_11,\n                                             uint color_320621_backing_offse",
            "t_12,\n                                             int64_t n_p_292677,\n                                             int64_t q_s_292678,\n                                             int64_t jump_s_292684,\n                                             int64_t partition_sizze_292766,\n                                             int64_t defunc_0_f_res_292820,\n                                             int64_t pad_css_len_292821,\n                                             int64_t s_n_m_292825,\n                                             int64_t computed_group_sizze_305871,\n                                             __global\n                                             unsigned char *ext_mem_318609,\n                                             __global\n                                             unsigned char *ext_mem_318610,\n                                             __global\n                                             unsigned char *ext_mem_318707,\n                                             __global\n                                             unsigned char *ext_mem_318708,\n                                             __global unsigned char *mem_318871,\n                                             __global unsigned char *mem_318876,\n                                             __global unsigned char *mem_319192,\n                                             __global unsigned char *mem_319197)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_322132_backing_12 =\n                           &shared_mem[red_arr_mem_322132_backing_offset_0];\n    volatile unsigned char *red_arr_mem_322130_backing_11 =\n                           &shared_mem[red_arr_mem_322130_backing_offset_1];\n    volatile unsigned char *red_arr_mem_322094_backing_10 =\n                           &shared_mem[red_arr_mem_322094_backing_offset_2];\n    volatile unsigned char *red_arr_mem_322092_backing_9 =\n               ",
            "            &shared_mem[red_arr_mem_322092_backing_offset_3];\n    volatile unsigned char *red_arr_mem_322090_backing_8 =\n                           &shared_mem[red_arr_mem_322090_backing_offset_4];\n    volatile unsigned char *color_320628_backing_7 =\n                           &shared_mem[color_320628_backing_offset_5];\n    volatile unsigned char *color_320627_backing_6 =\n                           &shared_mem[color_320627_backing_offset_6];\n    volatile unsigned char *color_320626_backing_5 =\n                           &shared_mem[color_320626_backing_offset_7];\n    volatile unsigned char *color_320625_backing_4 =\n                           &shared_mem[color_320625_backing_offset_8];\n    volatile unsigned char *color_320624_backing_3 =\n                           &shared_mem[color_320624_backing_offset_9];\n    volatile unsigned char *color_320623_backing_2 =\n                           &shared_mem[color_320623_backing_offset_10];\n    volatile unsigned char *color_320622_backing_1 =\n                           &shared_mem[color_320622_backing_offset_11];\n    volatile unsigned char *color_320621_backing_0 =\n                           &shared_mem[color_320621_backing_offset_12];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322072;\n    int32_t local_tid_322073;\n    int64_t group_sizze_322076;\n    int32_t wave_sizze_322075;\n    int32_t group_tid_322074;\n    \n    global_tid_322072 = get_global_id(0);\n    local_tid_322073 = get_local_id(0);\n    group_sizze_322076 = get_local_size(0);\n    wave_sizze_322075 = LOCKSTEP_WIDTH;\n    group_tid_322074 = get_group_id(0);\n    \n    int32_t phys_tid_306005 = group_tid_322074;\n    int64_t slice_322078 = s_n_m_292825;\n    int64_t ltid_pre_322077 = sext_i32_i64(local_tid_322073);\n    int64_t remnant_322079 = sext_i32_i64(local_tid_322073) - ltid_pre_322077;\n    int64_t slice_322082 = q_s_292678;\n    int64_t slice_322083 = s_n_m_292825 * slice_322082;\n    int64_t ltid_pre_322080 = squot64(sext_i32_i64(local",
            "_tid_322073),\n                                      slice_322082);\n    int64_t remnant_322084 = sext_i32_i64(local_tid_322073) - ltid_pre_322080 *\n            slice_322082;\n    int64_t ltid_pre_322081 = remnant_322084;\n    int64_t remnant_322085 = remnant_322084 - ltid_pre_322081;\n    int64_t slice_322086 = n_p_292677;\n    int64_t slice_322087 = partition_sizze_292766 * slice_322086;\n    int64_t gtid_306003 = squot64(sext_i32_i64(group_tid_322074), slice_322086);\n    int64_t remnant_322088 = sext_i32_i64(group_tid_322074) - gtid_306003 *\n            slice_322086;\n    int64_t gtid_306004 = remnant_322088;\n    int64_t remnant_322089 = remnant_322088 - gtid_306004;\n    __local unsigned char *color_320621;\n    \n    color_320621 = (__local unsigned char *) color_320621_backing_0;\n    \n    __local unsigned char *color_320622;\n    \n    color_320622 = (__local unsigned char *) color_320622_backing_1;\n    \n    __local unsigned char *color_320623;\n    \n    color_320623 = (__local unsigned char *) color_320623_backing_2;\n    \n    __local unsigned char *color_320624;\n    \n    color_320624 = (__local unsigned char *) color_320624_backing_3;\n    \n    __local unsigned char *color_320625;\n    \n    color_320625 = (__local unsigned char *) color_320625_backing_4;\n    \n    __local unsigned char *color_320626;\n    \n    color_320626 = (__local unsigned char *) color_320626_backing_5;\n    \n    __local unsigned char *color_320627;\n    \n    color_320627 = (__local unsigned char *) color_320627_backing_6;\n    \n    __local unsigned char *color_320628;\n    \n    color_320628 = (__local unsigned char *) color_320628_backing_7;\n    \n    int64_t x_306012;\n    \n    x_306012 = ((__global int64_t *) ext_mem_318609)[gtid_306003 * n_p_292677 +\n                                                     gtid_306004];\n    \n    int32_t phys_tid_306020 = local_tid_322073;\n    int64_t gtid_306019 = sext_i32_i64(sext_i64_i32(ltid_pre_322077));\n    \n    if (slt64(gtid_306019, s_n_m_292825)) {\n        bool cond_3060",
            "22 = gtid_306019 == (int64_t) 0;\n        int64_t defunc_0_m_fun_res_306023;\n        \n        if (cond_306022) {\n            defunc_0_m_fun_res_306023 = (int64_t) 0;\n        } else {\n            int64_t y_306024 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_306025 = gtid_306019 == y_306024;\n            int64_t defunc_0_m_fun_res_f_res_306026;\n            \n            if (cond_306025) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_306027 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_306026 =\n                    defunc_0_m_fun_res_f_res_t_res_306027;\n            } else {\n                int64_t x_306028 = sub64(gtid_306019, (int64_t) 1);\n                int64_t x_306029 = mul64(jump_s_292684, x_306028);\n                int64_t min_arg_306030 = add64((int64_t) 1, x_306029);\n                int64_t min_res_306031 = smin64(defunc_0_f_res_292820,\n                                                min_arg_306030);\n                \n                defunc_0_m_fun_res_f_res_306026 = min_res_306031;\n            }\n            defunc_0_m_fun_res_306023 = defunc_0_m_fun_res_f_res_306026;\n        }\n        ((__local int64_t *) color_320623)[gtid_306019] =\n            defunc_0_m_fun_res_306023;\n        ((__local bool *) color_320628)[gtid_306019] = cond_306022;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_306037 = local_tid_322073;\n    __local unsigned char *red_arr_mem_322090;\n    \n    red_arr_mem_322090 = (__local unsigned char *) red_arr_mem_322090_backing_8;\n    \n    __local unsigned char *red_arr_mem_322092;\n    \n    red_arr_mem_322092 = (__local unsigned char *) red_arr_mem_322092_backing_9;\n    \n    __local unsigned char *red_arr_mem_322094;\n    \n    red_arr_mem_322094 = (__local\n                          unsigned char *) red_arr_mem_322094_backing_10;\n    \n    int64_t gtid_306035 = sext_i32_i64(sext_i64_i32(ltid_pre_322080));\n    int64_t gtid_306036 = sext_i3",
            "2_i64(sext_i64_i32(ltid_pre_322081));\n    \n    if (slt64(gtid_306035, s_n_m_292825) && slt64(gtid_306036, q_s_292678)) {\n        int64_t x_306047;\n        \n        x_306047 = ((__global int64_t *) ext_mem_318708)[gtid_306003 *\n                                                         (s_n_m_292825 *\n                                                          n_p_292677) +\n                                                         gtid_306004 *\n                                                         s_n_m_292825 +\n                                                         gtid_306035];\n        \n        double x_306048;\n        \n        x_306048 = ((__global double *) ext_mem_318707)[gtid_306003 *\n                                                        (s_n_m_292825 *\n                                                         n_p_292677) +\n                                                        gtid_306004 *\n                                                        s_n_m_292825 +\n                                                        gtid_306035];\n        \n        int64_t defunc_0_m_fun_res_306049;\n        \n        defunc_0_m_fun_res_306049 = ((__local\n                                      int64_t *) color_320623)[gtid_306035];\n        \n        bool cond_306051 = sle64(x_306012, gtid_306036);\n        int64_t defunc_0_f_res_306052;\n        \n        if (cond_306051) {\n            defunc_0_f_res_306052 = (int64_t) 0;\n        } else {\n            int64_t i_306053 = add64(gtid_306036, x_306047);\n            int64_t defunc_0_add_arg_306054;\n            \n            defunc_0_add_arg_306054 = ((__global\n                                        int64_t *) ext_mem_318610)[gtid_306003 *\n                                                                   (defunc_0_f_res_292820 *\n                                                                    n_p_292677) +\n                                                                   gtid_306004 *\n                                                    ",
            "               defunc_0_f_res_292820 +\n                                                                   i_306053];\n            \n            int64_t defunc_1_add_res_306055 = add64((int64_t) 1,\n                                                    defunc_0_add_arg_306054);\n            \n            defunc_0_f_res_306052 = defunc_1_add_res_306055;\n        }\n        \n        double defunc_0_f_res_306056;\n        \n        if (cond_306051) {\n            defunc_0_f_res_306056 = 0.0;\n        } else {\n            int64_t i_306057 = add64(gtid_306036, x_306047);\n            double defunc_0_add_arg_306058;\n            \n            defunc_0_add_arg_306058 = ((__global\n                                        double *) mem_318876)[gtid_306003 *\n                                                              (defunc_0_f_res_292820 *\n                                                               n_p_292677) +\n                                                              gtid_306004 *\n                                                              defunc_0_f_res_292820 +\n                                                              i_306057];\n            defunc_0_f_res_306056 = defunc_0_add_arg_306058;\n        }\n        \n        int64_t binop_p_306059 = sub64(defunc_0_f_res_306052,\n                                       defunc_0_m_fun_res_306049);\n        double defunc_0_f_res_306060 = sitofp_i64_f64(binop_p_306059);\n        double abs_res_306061 = fabs(defunc_0_f_res_306060);\n        double tmp1_306062 = abs_res_306061 / x_306048;\n        double x_306063 = tmp1_306062 * tmp1_306062;\n        double y_306064 = tmp1_306062 * x_306063;\n        double tmp2_306065 = 1.0 - y_306064;\n        double x_306066 = tmp2_306065 * tmp2_306065;\n        double tmp3_306067 = tmp2_306065 * x_306066;\n        double w_j_306068 = defunc_0_f_res_306056 * tmp3_306067;\n        double xw_j_306069 = defunc_0_f_res_306060 * w_j_306068;\n        double x2w_j_306070 = defunc_0_f_res_306060 * xw_j_306069;\n        \n   ",
            "     ((__local double *) red_arr_mem_322090)[gtid_306035 * q_s_292678 +\n                                                gtid_306036] = w_j_306068;\n        ((__local double *) red_arr_mem_322092)[gtid_306035 * q_s_292678 +\n                                                gtid_306036] = xw_j_306069;\n        ((__local double *) red_arr_mem_322094)[gtid_306035 * q_s_292678 +\n                                                gtid_306036] = x2w_j_306070;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t dims_flat_322096 = s_n_m_292825 * q_s_292678;\n    double x_306038;\n    double x_306039;\n    double x_306040;\n    double x_306041;\n    double x_306042;\n    double x_306043;\n    double x_322100;\n    double x_322101;\n    double x_322102;\n    double x_322103;\n    double x_322104;\n    double x_322105;\n    bool ltid_in_bounds_322109 = slt64(sext_i32_i64(local_tid_322073),\n                                       s_n_m_292825 * q_s_292678);\n    int32_t skip_threads_322110;\n    \n    // read input for in-block scan\n    {\n        if (ltid_in_bounds_322109) {\n            x_306041 = ((volatile __local\n                         double *) red_arr_mem_322090)[sext_i32_i64(local_tid_322073)];\n            x_306042 = ((volatile __local\n                         double *) red_arr_mem_322092)[sext_i32_i64(local_tid_322073)];\n            x_306043 = ((volatile __local\n                         double *) red_arr_mem_322094)[sext_i32_i64(local_tid_322073)];\n            if ((local_tid_322073 - squot32(local_tid_322073, 32) * 32) == 0) {\n                x_306038 = x_306041;\n                x_306039 = x_306042;\n                x_306040 = x_306043;\n            }\n        }\n    }\n    // in-block scan (hopefully no barriers needed)\n    {\n        skip_threads_322110 = 1;\n        while (slt32(skip_threads_322110, 32)) {\n            bool thread_active_322111 = sle32(skip_threads_322110,\n                                              local_tid_322073 -\n                                              squot32(loc",
            "al_tid_322073, 32) *\n                                              32) && ltid_in_bounds_322109;\n            \n            if (thread_active_322111) {\n                // read operands\n                {\n                    x_306038 = ((volatile __local\n                                 double *) red_arr_mem_322090)[sext_i32_i64(local_tid_322073) -\n                                                               sext_i32_i64(skip_threads_322110)];\n                    x_306039 = ((volatile __local\n                                 double *) red_arr_mem_322092)[sext_i32_i64(local_tid_322073) -\n                                                               sext_i32_i64(skip_threads_322110)];\n                    x_306040 = ((volatile __local\n                                 double *) red_arr_mem_322094)[sext_i32_i64(local_tid_322073) -\n                                                               sext_i32_i64(skip_threads_322110)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_322112 =\n                     slt64(srem64(sext_i32_i64(local_tid_322073), q_s_292678),\n                           sext_i32_i64(local_tid_322073) -\n                           sext_i32_i64(local_tid_322073 -\n                           skip_threads_322110));\n                \n                if (thread_active_322111 && inactive_322112) {\n                    x_306038 = x_306041;\n                    x_306039 = x_306042;\n                    x_306040 = x_306043;\n                }\n                if (thread_active_322111) {\n                    if (!inactive_322112) {\n                        double defunc_1_op_res_306044 = x_306038 + x_306041;\n                        double defunc_1_op_res_306045 = x_306039 + x_306042;\n                        double defunc_1_op_res_306046 = x_306040 + x_306043;\n                        \n                        x_306038 = defunc_1_op_res_306044;\n                        x_306039 = defunc_1_op_res_306045;\n               ",
            "         x_306040 = defunc_1_op_res_306046;\n                    }\n                }\n            }\n            if (sle32(wave_sizze_322075, skip_threads_322110)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            if (thread_active_322111) {\n                // write result\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_322090)[sext_i32_i64(local_tid_322073)] =\n                        x_306038;\n                    x_306041 = x_306038;\n                    ((volatile __local\n                      double *) red_arr_mem_322092)[sext_i32_i64(local_tid_322073)] =\n                        x_306039;\n                    x_306042 = x_306039;\n                    ((volatile __local\n                      double *) red_arr_mem_322094)[sext_i32_i64(local_tid_322073)] =\n                        x_306040;\n                    x_306043 = x_306040;\n                }\n            }\n            if (sle32(wave_sizze_322075, skip_threads_322110)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            skip_threads_322110 *= 2;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // last thread of block 'i' writes its result to offset 'i'\n    {\n        if ((local_tid_322073 - squot32(local_tid_322073, 32) * 32) == 31 &&\n            ltid_in_bounds_322109) {\n            ((volatile __local\n              double *) red_arr_mem_322090)[sext_i32_i64(squot32(local_tid_322073,\n                                                                 32))] =\n                x_306038;\n            ((volatile __local\n              double *) red_arr_mem_322092)[sext_i32_i64(squot32(local_tid_322073,\n                                                                 32))] =\n                x_306039;\n            ((volatile __local\n              double *) red_arr_mem_322094)[sext_i32_i64(squot32(local_tid_322073,\n                                                                 32))] =\n                x_306040;\n        }\n    }\n   ",
            " barrier(CLK_LOCAL_MEM_FENCE);\n    // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n    {\n        int32_t skip_threads_322113;\n        \n        // read input for in-block scan\n        {\n            if (squot32(local_tid_322073, 32) == 0 && ltid_in_bounds_322109) {\n                x_322103 = ((volatile __local\n                             double *) red_arr_mem_322090)[sext_i32_i64(local_tid_322073)];\n                x_322104 = ((volatile __local\n                             double *) red_arr_mem_322092)[sext_i32_i64(local_tid_322073)];\n                x_322105 = ((volatile __local\n                             double *) red_arr_mem_322094)[sext_i32_i64(local_tid_322073)];\n                if ((local_tid_322073 - squot32(local_tid_322073, 32) * 32) ==\n                    0) {\n                    x_322100 = x_322103;\n                    x_322101 = x_322104;\n                    x_322102 = x_322105;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_322113 = 1;\n            while (slt32(skip_threads_322113, 32)) {\n                bool thread_active_322114 = sle32(skip_threads_322113,\n                                                  local_tid_322073 -\n                                                  squot32(local_tid_322073,\n                                                          32) * 32) &&\n                     (squot32(local_tid_322073, 32) == 0 &&\n                      ltid_in_bounds_322109);\n                \n                if (thread_active_322114) {\n                    // read operands\n                    {\n                        x_322100 = ((volatile __local\n                                     double *) red_arr_mem_322090)[sext_i32_i64(local_tid_322073) -\n                                                                   sext_i32_i64(skip_threads_322113)];\n                        x_322101 = ((volatile __local\n                                     do",
            "uble *) red_arr_mem_322092)[sext_i32_i64(local_tid_322073) -\n                                                                   sext_i32_i64(skip_threads_322113)];\n                        x_322102 = ((volatile __local\n                                     double *) red_arr_mem_322094)[sext_i32_i64(local_tid_322073) -\n                                                                   sext_i32_i64(skip_threads_322113)];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_322115 =\n                         slt64(srem64(sext_i32_i64(local_tid_322073 * 32 + 32 -\n                                      1), q_s_292678),\n                               sext_i32_i64(local_tid_322073 * 32 + 32 - 1) -\n                               sext_i32_i64((local_tid_322073 -\n                                             skip_threads_322113) * 32 + 32 -\n                               1));\n                    \n                    if (thread_active_322114 && inactive_322115) {\n                        x_322100 = x_322103;\n                        x_322101 = x_322104;\n                        x_322102 = x_322105;\n                    }\n                    if (thread_active_322114) {\n                        if (!inactive_322115) {\n                            double defunc_1_op_res_322106 = x_322100 + x_322103;\n                            double defunc_1_op_res_322107 = x_322101 + x_322104;\n                            double defunc_1_op_res_322108 = x_322102 + x_322105;\n                            \n                            x_322100 = defunc_1_op_res_322106;\n                            x_322101 = defunc_1_op_res_322107;\n                            x_322102 = defunc_1_op_res_322108;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_322075, skip_threads_322113)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_322114) {\n ",
            "                   // write result\n                    {\n                        ((volatile __local\n                          double *) red_arr_mem_322090)[sext_i32_i64(local_tid_322073)] =\n                            x_322100;\n                        x_322103 = x_322100;\n                        ((volatile __local\n                          double *) red_arr_mem_322092)[sext_i32_i64(local_tid_322073)] =\n                            x_322101;\n                        x_322104 = x_322101;\n                        ((volatile __local\n                          double *) red_arr_mem_322094)[sext_i32_i64(local_tid_322073)] =\n                            x_322102;\n                        x_322105 = x_322102;\n                    }\n                }\n                if (sle32(wave_sizze_322075, skip_threads_322113)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_322113 *= 2;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    bool no_carry_in_322116 = squot32(local_tid_322073, 32) == 0 ||\n         !ltid_in_bounds_322109;\n    \n    // carry-in for every block except the first\n    {\n        // read operands\n        {\n            if (!no_carry_in_322116) {\n                x_306041 = x_306038;\n                x_306042 = x_306039;\n                x_306043 = x_306040;\n                x_306038 = ((__local\n                             double *) red_arr_mem_322090)[sext_i32_i64(squot32(local_tid_322073,\n                                                                                32)) -\n                                                           (int64_t) 1];\n                x_306039 = ((__local\n                             double *) red_arr_mem_322092)[sext_i32_i64(squot32(local_tid_322073,\n                                                                                32)) -\n                                                           (int64_t) 1];\n                x_306040 = ((__local\n                             doubl",
            "e *) red_arr_mem_322094)[sext_i32_i64(squot32(local_tid_322073,\n                                                                                32)) -\n                                                           (int64_t) 1];\n            }\n        }\n        // perform operation\n        {\n            bool inactive_322117 = slt64(srem64(sext_i32_i64(local_tid_322073),\n                                                q_s_292678),\n                                         sext_i32_i64(local_tid_322073) -\n                                         sext_i32_i64(squot32(local_tid_322073,\n                                                              32) * 32 - 1));\n            \n            if (!no_carry_in_322116) {\n                if (inactive_322117) {\n                    x_306038 = x_306041;\n                    x_306039 = x_306042;\n                    x_306040 = x_306043;\n                }\n            }\n            if (!no_carry_in_322116) {\n                if (!inactive_322117) {\n                    double defunc_1_op_res_306044 = x_306038 + x_306041;\n                    double defunc_1_op_res_306045 = x_306039 + x_306042;\n                    double defunc_1_op_res_306046 = x_306040 + x_306043;\n                    \n                    x_306038 = defunc_1_op_res_306044;\n                    x_306039 = defunc_1_op_res_306045;\n                    x_306040 = defunc_1_op_res_306046;\n                }\n            }\n        }\n        // write final result\n        {\n            if (!no_carry_in_322116) {\n                ((__local\n                  double *) red_arr_mem_322090)[sext_i32_i64(local_tid_322073)] =\n                    x_306038;\n                ((__local\n                  double *) red_arr_mem_322092)[sext_i32_i64(local_tid_322073)] =\n                    x_306039;\n                ((__local\n                  double *) red_arr_mem_322094)[sext_i32_i64(local_tid_322073)] =\n                    x_306040;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // rest",
            "ore correct values for first block\n    {\n        if (squot32(local_tid_322073, 32) == 0 && ltid_in_bounds_322109) {\n            ((__local\n              double *) red_arr_mem_322090)[sext_i32_i64(local_tid_322073)] =\n                x_306041;\n            ((__local\n              double *) red_arr_mem_322092)[sext_i32_i64(local_tid_322073)] =\n                x_306042;\n            ((__local\n              double *) red_arr_mem_322094)[sext_i32_i64(local_tid_322073)] =\n                x_306043;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322118 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_305871));\n    \n    for (int32_t chunk_i_322119 = 0; chunk_i_322119 < num_chunks_322118;\n         chunk_i_322119++) {\n        int32_t i_322120 = chunk_i_322119 *\n                sext_i64_i32(computed_group_sizze_305871) + local_tid_322073;\n        \n        if (slt32(i_322120, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322121;\n            \n            tmp_322121 = ((__local double *) red_arr_mem_322090)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_322120) *\n                                                                 q_s_292678];\n            ((__local double *) color_320627)[sext_i32_i64(i_322120)] =\n                tmp_322121;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322122 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_305871));\n    \n    for (int32_t chunk_i_322123 = 0; chunk_i_322123 < num_chunks_322122;\n         chunk_i_322123++) {\n        int32_t i_322124 = chunk_i_322123 *\n                sext_i64_i32(computed_group_sizze_305871) + local_tid_322073;\n        \n        if (slt32(i_322124, sext_i64_i32(s_n_m",
            "_292825))) {\n            double tmp_322125;\n            \n            tmp_322125 = ((__local double *) red_arr_mem_322092)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_322124) *\n                                                                 q_s_292678];\n            ((__local double *) color_320622)[sext_i32_i64(i_322124)] =\n                tmp_322125;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322126 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_305871));\n    \n    for (int32_t chunk_i_322127 = 0; chunk_i_322127 < num_chunks_322126;\n         chunk_i_322127++) {\n        int32_t i_322128 = chunk_i_322127 *\n                sext_i64_i32(computed_group_sizze_305871) + local_tid_322073;\n        \n        if (slt32(i_322128, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322129;\n            \n            tmp_322129 = ((__local double *) red_arr_mem_322094)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_322128) *\n                                                                 q_s_292678];\n            ((__local double *) color_320621)[sext_i32_i64(i_322128)] =\n                tmp_322129;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_306076 = local_tid_322073;\n    int64_t gtid_306075 = sext_i32_i64(sext_i64_i32(ltid_pre_322077));\n    \n    if (slt64(gtid_306075, s_n_m_292825)) {\n        bool index_primexp_317933 = gtid_306075 == (int64_t) 0;\n        double defunc_2_reduce_res_306079;\n        \n        defunc_2_reduce_res_306079 = ((__local\n                                       double *) color_320627)[gtid_306075];\n        \n        double defunc_2_reduce_res_",
            "306080;\n        \n        defunc_2_reduce_res_306080 = ((__local\n                                       double *) color_320622)[gtid_306075];\n        \n        double defunc_2_reduce_res_306081;\n        \n        defunc_2_reduce_res_306081 = ((__local\n                                       double *) color_320621)[gtid_306075];\n        \n        double a_306082 = 2.220446049250313e-16 + defunc_2_reduce_res_306079;\n        double b_306083 = 2.220446049250313e-16 + defunc_2_reduce_res_306080;\n        double c_306084 = 2.220446049250313e-16 + defunc_2_reduce_res_306081;\n        double x_306085 = a_306082 * c_306084;\n        double y_306086 = b_306083 * b_306083;\n        double y_306087 = x_306085 - y_306086;\n        double det1_306088 = 1.0 / y_306087;\n        double a11_306089 = c_306084 * det1_306088;\n        double x_306090 = 0.0 - b_306083;\n        double b11_306091 = det1_306088 * x_306090;\n        double c11_306092 = a_306082 * det1_306088;\n        int64_t defunc_0_m_fun_res_306093;\n        \n        if (index_primexp_317933) {\n            defunc_0_m_fun_res_306093 = (int64_t) 0;\n        } else {\n            int64_t y_306094 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_306095 = gtid_306075 == y_306094;\n            int64_t defunc_0_m_fun_res_f_res_306096;\n            \n            if (cond_306095) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_306097 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_306096 =\n                    defunc_0_m_fun_res_f_res_t_res_306097;\n            } else {\n                int64_t x_306098 = sub64(gtid_306075, (int64_t) 1);\n                int64_t x_306099 = mul64(jump_s_292684, x_306098);\n                int64_t min_arg_306100 = add64((int64_t) 1, x_306099);\n                int64_t min_res_306101 = smin64(defunc_0_f_res_292820,\n                                                min_arg_306100);\n                \n                defunc_0_m_fun_res_f_",
            "res_306096 = min_res_306101;\n            }\n            defunc_0_m_fun_res_306093 = defunc_0_m_fun_res_f_res_306096;\n        }\n        ((__local double *) color_320626)[gtid_306075] = a11_306089;\n        ((__local double *) color_320625)[gtid_306075] = b11_306091;\n        ((__local double *) color_320624)[gtid_306075] = c11_306092;\n        ((__local int64_t *) color_320623)[gtid_306075] =\n            defunc_0_m_fun_res_306093;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_306106 = local_tid_322073;\n    __local unsigned char *red_arr_mem_322130;\n    \n    red_arr_mem_322130 = (__local\n                          unsigned char *) red_arr_mem_322130_backing_11;\n    \n    __local unsigned char *red_arr_mem_322132;\n    \n    red_arr_mem_322132 = (__local\n                          unsigned char *) red_arr_mem_322132_backing_12;\n    \n    int64_t gtid_306104 = sext_i32_i64(sext_i64_i32(ltid_pre_322080));\n    int64_t gtid_306105 = sext_i32_i64(sext_i64_i32(ltid_pre_322081));\n    \n    if (slt64(gtid_306104, s_n_m_292825) && slt64(gtid_306105, q_s_292678)) {\n        int64_t x_306113;\n        \n        x_306113 = ((__global int64_t *) ext_mem_318708)[gtid_306003 *\n                                                         (s_n_m_292825 *\n                                                          n_p_292677) +\n                                                         gtid_306004 *\n                                                         s_n_m_292825 +\n                                                         gtid_306104];\n        \n        double x_306114;\n        \n        x_306114 = ((__global double *) ext_mem_318707)[gtid_306003 *\n                                                        (s_n_m_292825 *\n                                                         n_p_292677) +\n                                                        gtid_306004 *\n                                                        s_n_m_292825 +\n                                                        gtid",
            "_306104];\n        \n        double a11_306115;\n        \n        a11_306115 = ((__local double *) color_320626)[gtid_306104];\n        \n        double b11_306116;\n        \n        b11_306116 = ((__local double *) color_320625)[gtid_306104];\n        \n        double c11_306117;\n        \n        c11_306117 = ((__local double *) color_320624)[gtid_306104];\n        \n        int64_t defunc_0_m_fun_res_306118;\n        \n        defunc_0_m_fun_res_306118 = ((__local\n                                      int64_t *) color_320623)[gtid_306104];\n        \n        bool cond_306120 = sle64(x_306012, gtid_306105);\n        int64_t defunc_0_f_res_306121;\n        \n        if (cond_306120) {\n            defunc_0_f_res_306121 = (int64_t) 0;\n        } else {\n            int64_t i_306122 = add64(gtid_306105, x_306113);\n            int64_t defunc_0_add_arg_306123;\n            \n            defunc_0_add_arg_306123 = ((__global\n                                        int64_t *) ext_mem_318610)[gtid_306003 *\n                                                                   (defunc_0_f_res_292820 *\n                                                                    n_p_292677) +\n                                                                   gtid_306004 *\n                                                                   defunc_0_f_res_292820 +\n                                                                   i_306122];\n            \n            int64_t defunc_1_add_res_306124 = add64((int64_t) 1,\n                                                    defunc_0_add_arg_306123);\n            \n            defunc_0_f_res_306121 = defunc_1_add_res_306124;\n        }\n        \n        double defunc_0_f_res_306125;\n        \n        if (cond_306120) {\n            defunc_0_f_res_306125 = 0.0;\n        } else {\n            int64_t i_306126 = add64(gtid_306105, x_306113);\n            double defunc_0_add_arg_306127;\n            \n            defunc_0_add_arg_306127 = ((__global\n                                    ",
            "    double *) mem_318876)[gtid_306003 *\n                                                              (defunc_0_f_res_292820 *\n                                                               n_p_292677) +\n                                                              gtid_306004 *\n                                                              defunc_0_f_res_292820 +\n                                                              i_306126];\n            defunc_0_f_res_306125 = defunc_0_add_arg_306127;\n        }\n        \n        int64_t binop_p_306128 = sub64(defunc_0_f_res_306121,\n                                       defunc_0_m_fun_res_306118);\n        double defunc_0_f_res_306129 = sitofp_i64_f64(binop_p_306128);\n        double abs_res_306130 = fabs(defunc_0_f_res_306129);\n        double tmp1_306131 = abs_res_306130 / x_306114;\n        double x_306132 = tmp1_306131 * tmp1_306131;\n        double y_306133 = tmp1_306131 * x_306132;\n        double tmp2_306134 = 1.0 - y_306133;\n        double x_306135 = tmp2_306134 * tmp2_306134;\n        double tmp3_306136 = tmp2_306134 * x_306135;\n        double tmp4_306137 = defunc_0_f_res_306125 * tmp3_306136;\n        double defunc_1_f_res_306138 = defunc_0_f_res_306129 * tmp4_306137;\n        double defunc_0_f_res_306139;\n        \n        if (cond_306120) {\n            defunc_0_f_res_306139 = 0.0;\n        } else {\n            int64_t i_306140 = add64(gtid_306105, x_306113);\n            double defunc_0_add_arg_306141;\n            \n            defunc_0_add_arg_306141 = ((__global\n                                        double *) mem_318871)[gtid_306003 *\n                                                              (defunc_0_f_res_292820 *\n                                                               n_p_292677) +\n                                                              gtid_306004 *\n                                                              defunc_0_f_res_292820 +\n                                                              i_306",
            "140];\n            defunc_0_f_res_306139 = defunc_0_add_arg_306141;\n        }\n        \n        double x_306142 = a11_306115 * tmp4_306137;\n        double y_306143 = b11_306116 * defunc_1_f_res_306138;\n        double x_306144 = x_306142 + y_306143;\n        double defunc_9_fit_fun_res_306145 = defunc_0_f_res_306139 * x_306144;\n        double x_306146 = b11_306116 * tmp4_306137;\n        double y_306147 = c11_306117 * defunc_1_f_res_306138;\n        double x_306148 = x_306146 + y_306147;\n        double defunc_9_slope_fun_res_306149 = defunc_0_f_res_306139 * x_306148;\n        \n        ((__local double *) red_arr_mem_322130)[gtid_306104 * q_s_292678 +\n                                                gtid_306105] =\n            defunc_9_fit_fun_res_306145;\n        ((__local double *) red_arr_mem_322132)[gtid_306104 * q_s_292678 +\n                                                gtid_306105] =\n            defunc_9_slope_fun_res_306149;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t dims_flat_322134 = s_n_m_292825 * q_s_292678;\n    double x_306107;\n    double x_306108;\n    double x_306109;\n    double x_306110;\n    double x_322137;\n    double x_322138;\n    double x_322139;\n    double x_322140;\n    bool ltid_in_bounds_322143 = slt64(sext_i32_i64(local_tid_322073),\n                                       s_n_m_292825 * q_s_292678);\n    int32_t skip_threads_322144;\n    \n    // read input for in-block scan\n    {\n        if (ltid_in_bounds_322143) {\n            x_306109 = ((volatile __local\n                         double *) red_arr_mem_322130)[sext_i32_i64(local_tid_322073)];\n            x_306110 = ((volatile __local\n                         double *) red_arr_mem_322132)[sext_i32_i64(local_tid_322073)];\n            if ((local_tid_322073 - squot32(local_tid_322073, 32) * 32) == 0) {\n                x_306107 = x_306109;\n                x_306108 = x_306110;\n            }\n        }\n    }\n    // in-block scan (hopefully no barriers needed)\n    {\n        skip_threads_322144 = 1;\n  ",
            "      while (slt32(skip_threads_322144, 32)) {\n            bool thread_active_322145 = sle32(skip_threads_322144,\n                                              local_tid_322073 -\n                                              squot32(local_tid_322073, 32) *\n                                              32) && ltid_in_bounds_322143;\n            \n            if (thread_active_322145) {\n                // read operands\n                {\n                    x_306107 = ((volatile __local\n                                 double *) red_arr_mem_322130)[sext_i32_i64(local_tid_322073) -\n                                                               sext_i32_i64(skip_threads_322144)];\n                    x_306108 = ((volatile __local\n                                 double *) red_arr_mem_322132)[sext_i32_i64(local_tid_322073) -\n                                                               sext_i32_i64(skip_threads_322144)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_322146 =\n                     slt64(srem64(sext_i32_i64(local_tid_322073), q_s_292678),\n                           sext_i32_i64(local_tid_322073) -\n                           sext_i32_i64(local_tid_322073 -\n                           skip_threads_322144));\n                \n                if (thread_active_322145 && inactive_322146) {\n                    x_306107 = x_306109;\n                    x_306108 = x_306110;\n                }\n                if (thread_active_322145) {\n                    if (!inactive_322146) {\n                        double defunc_1_op_res_306111 = x_306107 + x_306109;\n                        double defunc_1_op_res_306112 = x_306108 + x_306110;\n                        \n                        x_306107 = defunc_1_op_res_306111;\n                        x_306108 = defunc_1_op_res_306112;\n                    }\n                }\n            }\n            if (sle32(wave_sizze_322075, skip_threads_322144)) {\n                barrier",
            "(CLK_LOCAL_MEM_FENCE);\n            }\n            if (thread_active_322145) {\n                // write result\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_322130)[sext_i32_i64(local_tid_322073)] =\n                        x_306107;\n                    x_306109 = x_306107;\n                    ((volatile __local\n                      double *) red_arr_mem_322132)[sext_i32_i64(local_tid_322073)] =\n                        x_306108;\n                    x_306110 = x_306108;\n                }\n            }\n            if (sle32(wave_sizze_322075, skip_threads_322144)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            skip_threads_322144 *= 2;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // last thread of block 'i' writes its result to offset 'i'\n    {\n        if ((local_tid_322073 - squot32(local_tid_322073, 32) * 32) == 31 &&\n            ltid_in_bounds_322143) {\n            ((volatile __local\n              double *) red_arr_mem_322130)[sext_i32_i64(squot32(local_tid_322073,\n                                                                 32))] =\n                x_306107;\n            ((volatile __local\n              double *) red_arr_mem_322132)[sext_i32_i64(squot32(local_tid_322073,\n                                                                 32))] =\n                x_306108;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n    {\n        int32_t skip_threads_322147;\n        \n        // read input for in-block scan\n        {\n            if (squot32(local_tid_322073, 32) == 0 && ltid_in_bounds_322143) {\n                x_322139 = ((volatile __local\n                             double *) red_arr_mem_322130)[sext_i32_i64(local_tid_322073)];\n                x_322140 = ((volatile __local\n                             double *) red_arr_mem_322132)[sext_i32_i64(local_tid_322073)];\n                if ((loca",
            "l_tid_322073 - squot32(local_tid_322073, 32) * 32) ==\n                    0) {\n                    x_322137 = x_322139;\n                    x_322138 = x_322140;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_322147 = 1;\n            while (slt32(skip_threads_322147, 32)) {\n                bool thread_active_322148 = sle32(skip_threads_322147,\n                                                  local_tid_322073 -\n                                                  squot32(local_tid_322073,\n                                                          32) * 32) &&\n                     (squot32(local_tid_322073, 32) == 0 &&\n                      ltid_in_bounds_322143);\n                \n                if (thread_active_322148) {\n                    // read operands\n                    {\n                        x_322137 = ((volatile __local\n                                     double *) red_arr_mem_322130)[sext_i32_i64(local_tid_322073) -\n                                                                   sext_i32_i64(skip_threads_322147)];\n                        x_322138 = ((volatile __local\n                                     double *) red_arr_mem_322132)[sext_i32_i64(local_tid_322073) -\n                                                                   sext_i32_i64(skip_threads_322147)];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_322149 =\n                         slt64(srem64(sext_i32_i64(local_tid_322073 * 32 + 32 -\n                                      1), q_s_292678),\n                               sext_i32_i64(local_tid_322073 * 32 + 32 - 1) -\n                               sext_i32_i64((local_tid_322073 -\n                                             skip_threads_322147) * 32 + 32 -\n                               1));\n                    \n                    if (thread_active_322148 && inactive_322149)",
            " {\n                        x_322137 = x_322139;\n                        x_322138 = x_322140;\n                    }\n                    if (thread_active_322148) {\n                        if (!inactive_322149) {\n                            double defunc_1_op_res_322141 = x_322137 + x_322139;\n                            double defunc_1_op_res_322142 = x_322138 + x_322140;\n                            \n                            x_322137 = defunc_1_op_res_322141;\n                            x_322138 = defunc_1_op_res_322142;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_322075, skip_threads_322147)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_322148) {\n                    // write result\n                    {\n                        ((volatile __local\n                          double *) red_arr_mem_322130)[sext_i32_i64(local_tid_322073)] =\n                            x_322137;\n                        x_322139 = x_322137;\n                        ((volatile __local\n                          double *) red_arr_mem_322132)[sext_i32_i64(local_tid_322073)] =\n                            x_322138;\n                        x_322140 = x_322138;\n                    }\n                }\n                if (sle32(wave_sizze_322075, skip_threads_322147)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_322147 *= 2;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    bool no_carry_in_322150 = squot32(local_tid_322073, 32) == 0 ||\n         !ltid_in_bounds_322143;\n    \n    // carry-in for every block except the first\n    {\n        // read operands\n        {\n            if (!no_carry_in_322150) {\n                x_306109 = x_306107;\n                x_306110 = x_306108;\n                x_306107 = ((__local\n                             double *) red_arr_mem_322130)[sext_i32_i64(squot32(local_tid_322073,\n   ",
            "                                                                             32)) -\n                                                           (int64_t) 1];\n                x_306108 = ((__local\n                             double *) red_arr_mem_322132)[sext_i32_i64(squot32(local_tid_322073,\n                                                                                32)) -\n                                                           (int64_t) 1];\n            }\n        }\n        // perform operation\n        {\n            bool inactive_322151 = slt64(srem64(sext_i32_i64(local_tid_322073),\n                                                q_s_292678),\n                                         sext_i32_i64(local_tid_322073) -\n                                         sext_i32_i64(squot32(local_tid_322073,\n                                                              32) * 32 - 1));\n            \n            if (!no_carry_in_322150) {\n                if (inactive_322151) {\n                    x_306107 = x_306109;\n                    x_306108 = x_306110;\n                }\n            }\n            if (!no_carry_in_322150) {\n                if (!inactive_322151) {\n                    double defunc_1_op_res_306111 = x_306107 + x_306109;\n                    double defunc_1_op_res_306112 = x_306108 + x_306110;\n                    \n                    x_306107 = defunc_1_op_res_306111;\n                    x_306108 = defunc_1_op_res_306112;\n                }\n            }\n        }\n        // write final result\n        {\n            if (!no_carry_in_322150) {\n                ((__local\n                  double *) red_arr_mem_322130)[sext_i32_i64(local_tid_322073)] =\n                    x_306107;\n                ((__local\n                  double *) red_arr_mem_322132)[sext_i32_i64(local_tid_322073)] =\n                    x_306108;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // restore correct values for first block\n    {\n        if (squot32(local_tid_322073, ",
            "32) == 0 && ltid_in_bounds_322143) {\n            ((__local\n              double *) red_arr_mem_322130)[sext_i32_i64(local_tid_322073)] =\n                x_306109;\n            ((__local\n              double *) red_arr_mem_322132)[sext_i32_i64(local_tid_322073)] =\n                x_306110;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322152 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_305871));\n    \n    for (int32_t chunk_i_322153 = 0; chunk_i_322153 < num_chunks_322152;\n         chunk_i_322153++) {\n        int32_t i_322154 = chunk_i_322153 *\n                sext_i64_i32(computed_group_sizze_305871) + local_tid_322073;\n        \n        if (slt32(i_322154, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322155;\n            \n            tmp_322155 = ((__local double *) red_arr_mem_322130)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_322154) *\n                                                                 q_s_292678];\n            ((__local double *) color_320622)[sext_i32_i64(i_322154)] =\n                tmp_322155;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322156 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_305871));\n    \n    for (int32_t chunk_i_322157 = 0; chunk_i_322157 < num_chunks_322156;\n         chunk_i_322157++) {\n        int32_t i_322158 = chunk_i_322157 *\n                sext_i64_i32(computed_group_sizze_305871) + local_tid_322073;\n        \n        if (slt32(i_322158, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322159;\n            \n            tmp_322159 = ((__local double *) red_arr_mem_322132)[q_s_292678 -\n                                                                 (int6",
            "4_t) 1 +\n                                                                 sext_i32_i64(i_322158) *\n                                                                 q_s_292678];\n            ((__local double *) color_320621)[sext_i32_i64(i_322158)] =\n                tmp_322159;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322160 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_305871));\n    \n    for (int32_t chunk_i_322161 = 0; chunk_i_322161 < num_chunks_322160;\n         chunk_i_322161++) {\n        int32_t i_322162 = chunk_i_322161 *\n                sext_i64_i32(computed_group_sizze_305871) + local_tid_322073;\n        \n        if (slt32(i_322162, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322163;\n            \n            tmp_322163 = ((__local\n                           double *) color_320622)[sext_i32_i64(i_322162)];\n            ((__global double *) mem_319192)[gtid_306003 * (s_n_m_292825 *\n                                                            n_p_292677) +\n                                             gtid_306004 * s_n_m_292825 +\n                                             sext_i32_i64(i_322162)] =\n                tmp_322163;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322164 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_305871));\n    \n    for (int32_t chunk_i_322165 = 0; chunk_i_322165 < num_chunks_322164;\n         chunk_i_322165++) {\n        int32_t i_322166 = chunk_i_322165 *\n                sext_i64_i32(computed_group_sizze_305871) + local_tid_322073;\n        \n        if (slt32(i_322166, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322167;\n            \n            tmp_322167 = ((__local\n                           double *) color_320621)[sext_i32_i64(i_322166)];\n            ((__global double *) mem_3191",
            "97)[gtid_306003 * (s_n_m_292825 *\n                                                            n_p_292677) +\n                                             gtid_306004 * s_n_m_292825 +\n                                             sext_i32_i64(i_322166)] =\n                tmp_322167;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n  error_6:\n    return;\n}\n__kernel void mainzisegmap_intragroup_307881(__global int *global_failure,\n                                             uint red_arr_mem_322499_backing_offset_0,\n                                             uint red_arr_mem_322497_backing_offset_1,\n                                             uint red_arr_mem_322445_backing_offset_2,\n                                             uint red_arr_mem_322443_backing_offset_3,\n                                             uint red_arr_mem_322441_backing_offset_4,\n                                             uint red_arr_mem_322439_backing_offset_5,\n                                             uint red_arr_mem_322437_backing_offset_6,\n                                             uint color_320642_backing_offset_7,\n                                             uint color_320641_backing_offset_8,\n                                             uint color_320640_backing_offset_9,\n                                             uint color_320639_backing_offset_10,\n                                             uint color_320638_backing_offset_11,\n                                             uint color_320637_backing_offset_12,\n                                             uint color_320636_backing_offset_13,\n                                             uint color_320635_backing_offset_14,\n                                             uint color_320634_backing_offset_15,\n                                             uint color_320633_backing_offset_16,\n                                             uint color_320632_backing_offset_17,\n                                             uint color_",
            "320631_backing_offset_18,\n                                             int64_t n_p_292677,\n                                             int64_t q_s_292678,\n                                             int64_t jump_s_292684,\n                                             int64_t partition_sizze_292766,\n                                             int64_t defunc_0_f_res_292820,\n                                             int64_t pad_css_len_292821,\n                                             int64_t s_n_m_292825,\n                                             int64_t computed_group_sizze_307713,\n                                             __global\n                                             unsigned char *ext_mem_318609,\n                                             __global\n                                             unsigned char *ext_mem_318610,\n                                             __global\n                                             unsigned char *ext_mem_318707,\n                                             __global\n                                             unsigned char *ext_mem_318708,\n                                             __global unsigned char *mem_318871,\n                                             __global unsigned char *mem_318876,\n                                             __global unsigned char *mem_319384,\n                                             __global unsigned char *mem_319389)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_322499_backing_18 =\n                           &shared_mem[red_arr_mem_322499_backing_offset_0];\n    volatile unsigned char *red_arr_mem_322497_backing_17 =\n                           &shared_mem[red_arr_mem_322497_backing_offset_1];\n    volatile unsigned char *red_arr_mem_322445_backing_16 =\n                           &shared_mem[red_arr_mem_322445_backing_offset_2];\n    volatile unsigned char *red_arr_mem_322443_backing",
            "_15 =\n                           &shared_mem[red_arr_mem_322443_backing_offset_3];\n    volatile unsigned char *red_arr_mem_322441_backing_14 =\n                           &shared_mem[red_arr_mem_322441_backing_offset_4];\n    volatile unsigned char *red_arr_mem_322439_backing_13 =\n                           &shared_mem[red_arr_mem_322439_backing_offset_5];\n    volatile unsigned char *red_arr_mem_322437_backing_12 =\n                           &shared_mem[red_arr_mem_322437_backing_offset_6];\n    volatile unsigned char *color_320642_backing_11 =\n                           &shared_mem[color_320642_backing_offset_7];\n    volatile unsigned char *color_320641_backing_10 =\n                           &shared_mem[color_320641_backing_offset_8];\n    volatile unsigned char *color_320640_backing_9 =\n                           &shared_mem[color_320640_backing_offset_9];\n    volatile unsigned char *color_320639_backing_8 =\n                           &shared_mem[color_320639_backing_offset_10];\n    volatile unsigned char *color_320638_backing_7 =\n                           &shared_mem[color_320638_backing_offset_11];\n    volatile unsigned char *color_320637_backing_6 =\n                           &shared_mem[color_320637_backing_offset_12];\n    volatile unsigned char *color_320636_backing_5 =\n                           &shared_mem[color_320636_backing_offset_13];\n    volatile unsigned char *color_320635_backing_4 =\n                           &shared_mem[color_320635_backing_offset_14];\n    volatile unsigned char *color_320634_backing_3 =\n                           &shared_mem[color_320634_backing_offset_15];\n    volatile unsigned char *color_320633_backing_2 =\n                           &shared_mem[color_320633_backing_offset_16];\n    volatile unsigned char *color_320632_backing_1 =\n                           &shared_mem[color_320632_backing_offset_17];\n    volatile unsigned char *color_320631_backing_0 =\n                           &shared_mem[color_320631_backing_offset_18];\n    \n  ",
            "  if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322419;\n    int32_t local_tid_322420;\n    int64_t group_sizze_322423;\n    int32_t wave_sizze_322422;\n    int32_t group_tid_322421;\n    \n    global_tid_322419 = get_global_id(0);\n    local_tid_322420 = get_local_id(0);\n    group_sizze_322423 = get_local_size(0);\n    wave_sizze_322422 = LOCKSTEP_WIDTH;\n    group_tid_322421 = get_group_id(0);\n    \n    int32_t phys_tid_307881 = group_tid_322421;\n    int64_t slice_322425 = s_n_m_292825;\n    int64_t ltid_pre_322424 = sext_i32_i64(local_tid_322420);\n    int64_t remnant_322426 = sext_i32_i64(local_tid_322420) - ltid_pre_322424;\n    int64_t slice_322429 = q_s_292678;\n    int64_t slice_322430 = s_n_m_292825 * slice_322429;\n    int64_t ltid_pre_322427 = squot64(sext_i32_i64(local_tid_322420),\n                                      slice_322429);\n    int64_t remnant_322431 = sext_i32_i64(local_tid_322420) - ltid_pre_322427 *\n            slice_322429;\n    int64_t ltid_pre_322428 = remnant_322431;\n    int64_t remnant_322432 = remnant_322431 - ltid_pre_322428;\n    int64_t slice_322433 = n_p_292677;\n    int64_t slice_322434 = partition_sizze_292766 * slice_322433;\n    int64_t gtid_307879 = squot64(sext_i32_i64(group_tid_322421), slice_322433);\n    int64_t remnant_322435 = sext_i32_i64(group_tid_322421) - gtid_307879 *\n            slice_322433;\n    int64_t gtid_307880 = remnant_322435;\n    int64_t remnant_322436 = remnant_322435 - gtid_307880;\n    __local unsigned char *color_320631;\n    \n    color_320631 = (__local unsigned char *) color_320631_backing_0;\n    \n    __local unsigned char *color_320632;\n    \n    color_320632 = (__local unsigned char *) color_320632_backing_1;\n    \n    __local unsigned char *color_320633;\n    \n    color_320633 = (__local unsigned char *) color_320633_backing_2;\n    \n    __local unsigned char *color_320634;\n    \n    color_320634 = (__local unsigned char *) color_320634_backing_3;\n    \n    __local unsigned char *color_320635;\n    \n   ",
            " color_320635 = (__local unsigned char *) color_320635_backing_4;\n    \n    __local unsigned char *color_320636;\n    \n    color_320636 = (__local unsigned char *) color_320636_backing_5;\n    \n    __local unsigned char *color_320637;\n    \n    color_320637 = (__local unsigned char *) color_320637_backing_6;\n    \n    __local unsigned char *color_320638;\n    \n    color_320638 = (__local unsigned char *) color_320638_backing_7;\n    \n    __local unsigned char *color_320639;\n    \n    color_320639 = (__local unsigned char *) color_320639_backing_8;\n    \n    __local unsigned char *color_320640;\n    \n    color_320640 = (__local unsigned char *) color_320640_backing_9;\n    \n    __local unsigned char *color_320641;\n    \n    color_320641 = (__local unsigned char *) color_320641_backing_10;\n    \n    __local unsigned char *color_320642;\n    \n    color_320642 = (__local unsigned char *) color_320642_backing_11;\n    \n    int64_t x_307888;\n    \n    x_307888 = ((__global int64_t *) ext_mem_318609)[gtid_307879 * n_p_292677 +\n                                                     gtid_307880];\n    \n    int32_t phys_tid_307896 = local_tid_322420;\n    int64_t gtid_307895 = sext_i32_i64(sext_i64_i32(ltid_pre_322424));\n    \n    if (slt64(gtid_307895, s_n_m_292825)) {\n        bool cond_307898 = gtid_307895 == (int64_t) 0;\n        int64_t defunc_0_m_fun_res_307899;\n        \n        if (cond_307898) {\n            defunc_0_m_fun_res_307899 = (int64_t) 0;\n        } else {\n            int64_t y_307900 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_307901 = gtid_307895 == y_307900;\n            int64_t defunc_0_m_fun_res_f_res_307902;\n            \n            if (cond_307901) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_307903 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_307902 =\n                    defunc_0_m_fun_res_f_res_t_res_307903;\n            } else {\n                int64_t x_307904 = sub64(gt",
            "id_307895, (int64_t) 1);\n                int64_t x_307905 = mul64(jump_s_292684, x_307904);\n                int64_t min_arg_307906 = add64((int64_t) 1, x_307905);\n                int64_t min_res_307907 = smin64(defunc_0_f_res_292820,\n                                                min_arg_307906);\n                \n                defunc_0_m_fun_res_f_res_307902 = min_res_307907;\n            }\n            defunc_0_m_fun_res_307899 = defunc_0_m_fun_res_f_res_307902;\n        }\n        ((__local int64_t *) color_320633)[gtid_307895] =\n            defunc_0_m_fun_res_307899;\n        ((__local bool *) color_320642)[gtid_307895] = cond_307898;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_307915 = local_tid_322420;\n    __local unsigned char *red_arr_mem_322437;\n    \n    red_arr_mem_322437 = (__local\n                          unsigned char *) red_arr_mem_322437_backing_12;\n    \n    __local unsigned char *red_arr_mem_322439;\n    \n    red_arr_mem_322439 = (__local\n                          unsigned char *) red_arr_mem_322439_backing_13;\n    \n    __local unsigned char *red_arr_mem_322441;\n    \n    red_arr_mem_322441 = (__local\n                          unsigned char *) red_arr_mem_322441_backing_14;\n    \n    __local unsigned char *red_arr_mem_322443;\n    \n    red_arr_mem_322443 = (__local\n                          unsigned char *) red_arr_mem_322443_backing_15;\n    \n    __local unsigned char *red_arr_mem_322445;\n    \n    red_arr_mem_322445 = (__local\n                          unsigned char *) red_arr_mem_322445_backing_16;\n    \n    int64_t gtid_307913 = sext_i32_i64(sext_i64_i32(ltid_pre_322427));\n    int64_t gtid_307914 = sext_i32_i64(sext_i64_i32(ltid_pre_322428));\n    \n    if (slt64(gtid_307913, s_n_m_292825) && slt64(gtid_307914, q_s_292678)) {\n        int64_t x_307931;\n        \n        x_307931 = ((__global int64_t *) ext_mem_318708)[gtid_307879 *\n                                                         (s_n_m_292825 *\n                                  ",
            "                        n_p_292677) +\n                                                         gtid_307880 *\n                                                         s_n_m_292825 +\n                                                         gtid_307913];\n        \n        double x_307932;\n        \n        x_307932 = ((__global double *) ext_mem_318707)[gtid_307879 *\n                                                        (s_n_m_292825 *\n                                                         n_p_292677) +\n                                                        gtid_307880 *\n                                                        s_n_m_292825 +\n                                                        gtid_307913];\n        \n        int64_t defunc_0_m_fun_res_307933;\n        \n        defunc_0_m_fun_res_307933 = ((__local\n                                      int64_t *) color_320633)[gtid_307913];\n        \n        bool cond_307935 = sle64(x_307888, gtid_307914);\n        int64_t defunc_0_f_res_307936;\n        \n        if (cond_307935) {\n            defunc_0_f_res_307936 = (int64_t) 0;\n        } else {\n            int64_t i_307937 = add64(gtid_307914, x_307931);\n            int64_t defunc_0_add_arg_307938;\n            \n            defunc_0_add_arg_307938 = ((__global\n                                        int64_t *) ext_mem_318610)[gtid_307879 *\n                                                                   (defunc_0_f_res_292820 *\n                                                                    n_p_292677) +\n                                                                   gtid_307880 *\n                                                                   defunc_0_f_res_292820 +\n                                                                   i_307937];\n            \n            int64_t defunc_1_add_res_307939 = add64((int64_t) 1,\n                                                    defunc_0_add_arg_307938);\n            \n            defunc_0_f_res_307936 = defunc_1_add",
            "_res_307939;\n        }\n        \n        double defunc_0_f_res_307940;\n        \n        if (cond_307935) {\n            defunc_0_f_res_307940 = 0.0;\n        } else {\n            int64_t i_307941 = add64(gtid_307914, x_307931);\n            double defunc_0_add_arg_307942;\n            \n            defunc_0_add_arg_307942 = ((__global\n                                        double *) mem_318876)[gtid_307879 *\n                                                              (defunc_0_f_res_292820 *\n                                                               n_p_292677) +\n                                                              gtid_307880 *\n                                                              defunc_0_f_res_292820 +\n                                                              i_307941];\n            defunc_0_f_res_307940 = defunc_0_add_arg_307942;\n        }\n        \n        int64_t binop_p_307943 = sub64(defunc_0_f_res_307936,\n                                       defunc_0_m_fun_res_307933);\n        double defunc_0_f_res_307944 = sitofp_i64_f64(binop_p_307943);\n        double abs_res_307945 = fabs(defunc_0_f_res_307944);\n        double tmp1_307946 = abs_res_307945 / x_307932;\n        double x_307947 = tmp1_307946 * tmp1_307946;\n        double y_307948 = tmp1_307946 * x_307947;\n        double tmp2_307949 = 1.0 - y_307948;\n        double x_307950 = tmp2_307949 * tmp2_307949;\n        double tmp3_307951 = tmp2_307949 * x_307950;\n        double w_j_307952 = defunc_0_f_res_307940 * tmp3_307951;\n        double xw_j_307953 = defunc_0_f_res_307944 * w_j_307952;\n        double x2w_j_307954 = defunc_0_f_res_307944 * xw_j_307953;\n        double x3w_j_307955 = defunc_0_f_res_307944 * x2w_j_307954;\n        double x4w_j_307956 = defunc_0_f_res_307944 * x3w_j_307955;\n        \n        ((__local double *) red_arr_mem_322437)[gtid_307913 * q_s_292678 +\n                                                gtid_307914] = w_j_307952;\n        ((__local double *) red_arr_mem_322439)[gti",
            "d_307913 * q_s_292678 +\n                                                gtid_307914] = xw_j_307953;\n        ((__local double *) red_arr_mem_322441)[gtid_307913 * q_s_292678 +\n                                                gtid_307914] = x2w_j_307954;\n        ((__local double *) red_arr_mem_322443)[gtid_307913 * q_s_292678 +\n                                                gtid_307914] = x3w_j_307955;\n        ((__local double *) red_arr_mem_322445)[gtid_307913 * q_s_292678 +\n                                                gtid_307914] = x4w_j_307956;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t dims_flat_322447 = s_n_m_292825 * q_s_292678;\n    double x_307916;\n    double x_307917;\n    double x_307918;\n    double x_307919;\n    double x_307920;\n    double x_307921;\n    double x_307922;\n    double x_307923;\n    double x_307924;\n    double x_307925;\n    double x_322453;\n    double x_322454;\n    double x_322455;\n    double x_322456;\n    double x_322457;\n    double x_322458;\n    double x_322459;\n    double x_322460;\n    double x_322461;\n    double x_322462;\n    bool ltid_in_bounds_322468 = slt64(sext_i32_i64(local_tid_322420),\n                                       s_n_m_292825 * q_s_292678);\n    int32_t skip_threads_322469;\n    \n    // read input for in-block scan\n    {\n        if (ltid_in_bounds_322468) {\n            x_307921 = ((volatile __local\n                         double *) red_arr_mem_322437)[sext_i32_i64(local_tid_322420)];\n            x_307922 = ((volatile __local\n                         double *) red_arr_mem_322439)[sext_i32_i64(local_tid_322420)];\n            x_307923 = ((volatile __local\n                         double *) red_arr_mem_322441)[sext_i32_i64(local_tid_322420)];\n            x_307924 = ((volatile __local\n                         double *) red_arr_mem_322443)[sext_i32_i64(local_tid_322420)];\n            x_307925 = ((volatile __local\n                         double *) red_arr_mem_322445)[sext_i32_i64(local_tid_322420)];\n            if (",
            "(local_tid_322420 - squot32(local_tid_322420, 32) * 32) == 0) {\n                x_307916 = x_307921;\n                x_307917 = x_307922;\n                x_307918 = x_307923;\n                x_307919 = x_307924;\n                x_307920 = x_307925;\n            }\n        }\n    }\n    // in-block scan (hopefully no barriers needed)\n    {\n        skip_threads_322469 = 1;\n        while (slt32(skip_threads_322469, 32)) {\n            bool thread_active_322470 = sle32(skip_threads_322469,\n                                              local_tid_322420 -\n                                              squot32(local_tid_322420, 32) *\n                                              32) && ltid_in_bounds_322468;\n            \n            if (thread_active_322470) {\n                // read operands\n                {\n                    x_307916 = ((volatile __local\n                                 double *) red_arr_mem_322437)[sext_i32_i64(local_tid_322420) -\n                                                               sext_i32_i64(skip_threads_322469)];\n                    x_307917 = ((volatile __local\n                                 double *) red_arr_mem_322439)[sext_i32_i64(local_tid_322420) -\n                                                               sext_i32_i64(skip_threads_322469)];\n                    x_307918 = ((volatile __local\n                                 double *) red_arr_mem_322441)[sext_i32_i64(local_tid_322420) -\n                                                               sext_i32_i64(skip_threads_322469)];\n                    x_307919 = ((volatile __local\n                                 double *) red_arr_mem_322443)[sext_i32_i64(local_tid_322420) -\n                                                               sext_i32_i64(skip_threads_322469)];\n                    x_307920 = ((volatile __local\n                                 double *) red_arr_mem_322445)[sext_i32_i64(local_tid_322420) -\n                                                               se",
            "xt_i32_i64(skip_threads_322469)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_322471 =\n                     slt64(srem64(sext_i32_i64(local_tid_322420), q_s_292678),\n                           sext_i32_i64(local_tid_322420) -\n                           sext_i32_i64(local_tid_322420 -\n                           skip_threads_322469));\n                \n                if (thread_active_322470 && inactive_322471) {\n                    x_307916 = x_307921;\n                    x_307917 = x_307922;\n                    x_307918 = x_307923;\n                    x_307919 = x_307924;\n                    x_307920 = x_307925;\n                }\n                if (thread_active_322470) {\n                    if (!inactive_322471) {\n                        double defunc_1_op_res_307926 = x_307916 + x_307921;\n                        double defunc_1_op_res_307927 = x_307917 + x_307922;\n                        double defunc_1_op_res_307928 = x_307918 + x_307923;\n                        double defunc_1_op_res_307929 = x_307919 + x_307924;\n                        double defunc_1_op_res_307930 = x_307920 + x_307925;\n                        \n                        x_307916 = defunc_1_op_res_307926;\n                        x_307917 = defunc_1_op_res_307927;\n                        x_307918 = defunc_1_op_res_307928;\n                        x_307919 = defunc_1_op_res_307929;\n                        x_307920 = defunc_1_op_res_307930;\n                    }\n                }\n            }\n            if (sle32(wave_sizze_322422, skip_threads_322469)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            if (thread_active_322470) {\n                // write result\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_322437)[sext_i32_i64(local_tid_322420)] =\n                        x_307916;\n                    x_307921 = x_307916;\n                    ((volatile __lo",
            "cal\n                      double *) red_arr_mem_322439)[sext_i32_i64(local_tid_322420)] =\n                        x_307917;\n                    x_307922 = x_307917;\n                    ((volatile __local\n                      double *) red_arr_mem_322441)[sext_i32_i64(local_tid_322420)] =\n                        x_307918;\n                    x_307923 = x_307918;\n                    ((volatile __local\n                      double *) red_arr_mem_322443)[sext_i32_i64(local_tid_322420)] =\n                        x_307919;\n                    x_307924 = x_307919;\n                    ((volatile __local\n                      double *) red_arr_mem_322445)[sext_i32_i64(local_tid_322420)] =\n                        x_307920;\n                    x_307925 = x_307920;\n                }\n            }\n            if (sle32(wave_sizze_322422, skip_threads_322469)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            skip_threads_322469 *= 2;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // last thread of block 'i' writes its result to offset 'i'\n    {\n        if ((local_tid_322420 - squot32(local_tid_322420, 32) * 32) == 31 &&\n            ltid_in_bounds_322468) {\n            ((volatile __local\n              double *) red_arr_mem_322437)[sext_i32_i64(squot32(local_tid_322420,\n                                                                 32))] =\n                x_307916;\n            ((volatile __local\n              double *) red_arr_mem_322439)[sext_i32_i64(squot32(local_tid_322420,\n                                                                 32))] =\n                x_307917;\n            ((volatile __local\n              double *) red_arr_mem_322441)[sext_i32_i64(squot32(local_tid_322420,\n                                                                 32))] =\n                x_307918;\n            ((volatile __local\n              double *) red_arr_mem_322443)[sext_i32_i64(squot32(local_tid_322420,\n                                                     ",
            "            32))] =\n                x_307919;\n            ((volatile __local\n              double *) red_arr_mem_322445)[sext_i32_i64(squot32(local_tid_322420,\n                                                                 32))] =\n                x_307920;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n    {\n        int32_t skip_threads_322472;\n        \n        // read input for in-block scan\n        {\n            if (squot32(local_tid_322420, 32) == 0 && ltid_in_bounds_322468) {\n                x_322458 = ((volatile __local\n                             double *) red_arr_mem_322437)[sext_i32_i64(local_tid_322420)];\n                x_322459 = ((volatile __local\n                             double *) red_arr_mem_322439)[sext_i32_i64(local_tid_322420)];\n                x_322460 = ((volatile __local\n                             double *) red_arr_mem_322441)[sext_i32_i64(local_tid_322420)];\n                x_322461 = ((volatile __local\n                             double *) red_arr_mem_322443)[sext_i32_i64(local_tid_322420)];\n                x_322462 = ((volatile __local\n                             double *) red_arr_mem_322445)[sext_i32_i64(local_tid_322420)];\n                if ((local_tid_322420 - squot32(local_tid_322420, 32) * 32) ==\n                    0) {\n                    x_322453 = x_322458;\n                    x_322454 = x_322459;\n                    x_322455 = x_322460;\n                    x_322456 = x_322461;\n                    x_322457 = x_322462;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_322472 = 1;\n            while (slt32(skip_threads_322472, 32)) {\n                bool thread_active_322473 = sle32(skip_threads_322472,\n                                                  local_tid_322420 -\n                                                  squot32(local_tid_322420,\n           ",
            "                                               32) * 32) &&\n                     (squot32(local_tid_322420, 32) == 0 &&\n                      ltid_in_bounds_322468);\n                \n                if (thread_active_322473) {\n                    // read operands\n                    {\n                        x_322453 = ((volatile __local\n                                     double *) red_arr_mem_322437)[sext_i32_i64(local_tid_322420) -\n                                                                   sext_i32_i64(skip_threads_322472)];\n                        x_322454 = ((volatile __local\n                                     double *) red_arr_mem_322439)[sext_i32_i64(local_tid_322420) -\n                                                                   sext_i32_i64(skip_threads_322472)];\n                        x_322455 = ((volatile __local\n                                     double *) red_arr_mem_322441)[sext_i32_i64(local_tid_322420) -\n                                                                   sext_i32_i64(skip_threads_322472)];\n                        x_322456 = ((volatile __local\n                                     double *) red_arr_mem_322443)[sext_i32_i64(local_tid_322420) -\n                                                                   sext_i32_i64(skip_threads_322472)];\n                        x_322457 = ((volatile __local\n                                     double *) red_arr_mem_322445)[sext_i32_i64(local_tid_322420) -\n                                                                   sext_i32_i64(skip_threads_322472)];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_322474 =\n                         slt64(srem64(sext_i32_i64(local_tid_322420 * 32 + 32 -\n                                      1), q_s_292678),\n                               sext_i32_i64(local_tid_322420 * 32 + 32 - 1) -\n                               sext_i32_i64((local_tid_322420 -\n              ",
            "                               skip_threads_322472) * 32 + 32 -\n                               1));\n                    \n                    if (thread_active_322473 && inactive_322474) {\n                        x_322453 = x_322458;\n                        x_322454 = x_322459;\n                        x_322455 = x_322460;\n                        x_322456 = x_322461;\n                        x_322457 = x_322462;\n                    }\n                    if (thread_active_322473) {\n                        if (!inactive_322474) {\n                            double defunc_1_op_res_322463 = x_322453 + x_322458;\n                            double defunc_1_op_res_322464 = x_322454 + x_322459;\n                            double defunc_1_op_res_322465 = x_322455 + x_322460;\n                            double defunc_1_op_res_322466 = x_322456 + x_322461;\n                            double defunc_1_op_res_322467 = x_322457 + x_322462;\n                            \n                            x_322453 = defunc_1_op_res_322463;\n                            x_322454 = defunc_1_op_res_322464;\n                            x_322455 = defunc_1_op_res_322465;\n                            x_322456 = defunc_1_op_res_322466;\n                            x_322457 = defunc_1_op_res_322467;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_322422, skip_threads_322472)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_322473) {\n                    // write result\n                    {\n                        ((volatile __local\n                          double *) red_arr_mem_322437)[sext_i32_i64(local_tid_322420)] =\n                            x_322453;\n                        x_322458 = x_322453;\n                        ((volatile __local\n                          double *) red_arr_mem_322439)[sext_i32_i64(local_tid_322420)] =\n                            x_322454;\n                        x_32",
            "2459 = x_322454;\n                        ((volatile __local\n                          double *) red_arr_mem_322441)[sext_i32_i64(local_tid_322420)] =\n                            x_322455;\n                        x_322460 = x_322455;\n                        ((volatile __local\n                          double *) red_arr_mem_322443)[sext_i32_i64(local_tid_322420)] =\n                            x_322456;\n                        x_322461 = x_322456;\n                        ((volatile __local\n                          double *) red_arr_mem_322445)[sext_i32_i64(local_tid_322420)] =\n                            x_322457;\n                        x_322462 = x_322457;\n                    }\n                }\n                if (sle32(wave_sizze_322422, skip_threads_322472)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_322472 *= 2;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    bool no_carry_in_322475 = squot32(local_tid_322420, 32) == 0 ||\n         !ltid_in_bounds_322468;\n    \n    // carry-in for every block except the first\n    {\n        // read operands\n        {\n            if (!no_carry_in_322475) {\n                x_307921 = x_307916;\n                x_307922 = x_307917;\n                x_307923 = x_307918;\n                x_307924 = x_307919;\n                x_307925 = x_307920;\n                x_307916 = ((__local\n                             double *) red_arr_mem_322437)[sext_i32_i64(squot32(local_tid_322420,\n                                                                                32)) -\n                                                           (int64_t) 1];\n                x_307917 = ((__local\n                             double *) red_arr_mem_322439)[sext_i32_i64(squot32(local_tid_322420,\n                                                                                32)) -\n                                                           (int64_t) 1];\n                x_307918 = ((__local\n",
            "                             double *) red_arr_mem_322441)[sext_i32_i64(squot32(local_tid_322420,\n                                                                                32)) -\n                                                           (int64_t) 1];\n                x_307919 = ((__local\n                             double *) red_arr_mem_322443)[sext_i32_i64(squot32(local_tid_322420,\n                                                                                32)) -\n                                                           (int64_t) 1];\n                x_307920 = ((__local\n                             double *) red_arr_mem_322445)[sext_i32_i64(squot32(local_tid_322420,\n                                                                                32)) -\n                                                           (int64_t) 1];\n            }\n        }\n        // perform operation\n        {\n            bool inactive_322476 = slt64(srem64(sext_i32_i64(local_tid_322420),\n                                                q_s_292678),\n                                         sext_i32_i64(local_tid_322420) -\n                                         sext_i32_i64(squot32(local_tid_322420,\n                                                              32) * 32 - 1));\n            \n            if (!no_carry_in_322475) {\n                if (inactive_322476) {\n                    x_307916 = x_307921;\n                    x_307917 = x_307922;\n                    x_307918 = x_307923;\n                    x_307919 = x_307924;\n                    x_307920 = x_307925;\n                }\n            }\n            if (!no_carry_in_322475) {\n                if (!inactive_322476) {\n                    double defunc_1_op_res_307926 = x_307916 + x_307921;\n                    double defunc_1_op_res_307927 = x_307917 + x_307922;\n                    double defunc_1_op_res_307928 = x_307918 + x_307923;\n                    double defunc_1_op_res_307929 = x_307919 + x_307924;\n                 ",
            "   double defunc_1_op_res_307930 = x_307920 + x_307925;\n                    \n                    x_307916 = defunc_1_op_res_307926;\n                    x_307917 = defunc_1_op_res_307927;\n                    x_307918 = defunc_1_op_res_307928;\n                    x_307919 = defunc_1_op_res_307929;\n                    x_307920 = defunc_1_op_res_307930;\n                }\n            }\n        }\n        // write final result\n        {\n            if (!no_carry_in_322475) {\n                ((__local\n                  double *) red_arr_mem_322437)[sext_i32_i64(local_tid_322420)] =\n                    x_307916;\n                ((__local\n                  double *) red_arr_mem_322439)[sext_i32_i64(local_tid_322420)] =\n                    x_307917;\n                ((__local\n                  double *) red_arr_mem_322441)[sext_i32_i64(local_tid_322420)] =\n                    x_307918;\n                ((__local\n                  double *) red_arr_mem_322443)[sext_i32_i64(local_tid_322420)] =\n                    x_307919;\n                ((__local\n                  double *) red_arr_mem_322445)[sext_i32_i64(local_tid_322420)] =\n                    x_307920;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // restore correct values for first block\n    {\n        if (squot32(local_tid_322420, 32) == 0 && ltid_in_bounds_322468) {\n            ((__local\n              double *) red_arr_mem_322437)[sext_i32_i64(local_tid_322420)] =\n                x_307921;\n            ((__local\n              double *) red_arr_mem_322439)[sext_i32_i64(local_tid_322420)] =\n                x_307922;\n            ((__local\n              double *) red_arr_mem_322441)[sext_i32_i64(local_tid_322420)] =\n                x_307923;\n            ((__local\n              double *) red_arr_mem_322443)[sext_i32_i64(local_tid_322420)] =\n                x_307924;\n            ((__local\n              double *) red_arr_mem_322445)[sext_i32_i64(local_tid_322420)] =\n                x_307925;\n        }\n    }\n",
            "    barrier(CLK_LOCAL_MEM_FENCE);\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322477 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_307713));\n    \n    for (int32_t chunk_i_322478 = 0; chunk_i_322478 < num_chunks_322477;\n         chunk_i_322478++) {\n        int32_t i_322479 = chunk_i_322478 *\n                sext_i64_i32(computed_group_sizze_307713) + local_tid_322420;\n        \n        if (slt32(i_322479, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322480;\n            \n            tmp_322480 = ((__local double *) red_arr_mem_322437)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_322479) *\n                                                                 q_s_292678];\n            ((__local double *) color_320641)[sext_i32_i64(i_322479)] =\n                tmp_322480;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322481 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_307713));\n    \n    for (int32_t chunk_i_322482 = 0; chunk_i_322482 < num_chunks_322481;\n         chunk_i_322482++) {\n        int32_t i_322483 = chunk_i_322482 *\n                sext_i64_i32(computed_group_sizze_307713) + local_tid_322420;\n        \n        if (slt32(i_322483, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322484;\n            \n            tmp_322484 = ((__local double *) red_arr_mem_322439)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_322483) *\n                                                                 q_s_292678];\n            ((__local double *) color_320640)[sext_i32_i64(i_322483)] =\n                tmp_322484;\n        }\n    }\n    barrier(",
            "CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322485 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_307713));\n    \n    for (int32_t chunk_i_322486 = 0; chunk_i_322486 < num_chunks_322485;\n         chunk_i_322486++) {\n        int32_t i_322487 = chunk_i_322486 *\n                sext_i64_i32(computed_group_sizze_307713) + local_tid_322420;\n        \n        if (slt32(i_322487, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322488;\n            \n            tmp_322488 = ((__local double *) red_arr_mem_322441)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_322487) *\n                                                                 q_s_292678];\n            ((__local double *) color_320639)[sext_i32_i64(i_322487)] =\n                tmp_322488;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322489 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_307713));\n    \n    for (int32_t chunk_i_322490 = 0; chunk_i_322490 < num_chunks_322489;\n         chunk_i_322490++) {\n        int32_t i_322491 = chunk_i_322490 *\n                sext_i64_i32(computed_group_sizze_307713) + local_tid_322420;\n        \n        if (slt32(i_322491, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322492;\n            \n            tmp_322492 = ((__local double *) red_arr_mem_322443)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_322491) *\n                                                                 q_s_292678];\n            ((__local double *) color_320632)[sext_i32_i64(i_322491)] =\n                tmp_322492;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chu",
            "nks_322493 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_307713));\n    \n    for (int32_t chunk_i_322494 = 0; chunk_i_322494 < num_chunks_322493;\n         chunk_i_322494++) {\n        int32_t i_322495 = chunk_i_322494 *\n                sext_i64_i32(computed_group_sizze_307713) + local_tid_322420;\n        \n        if (slt32(i_322495, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322496;\n            \n            tmp_322496 = ((__local double *) red_arr_mem_322445)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_322495) *\n                                                                 q_s_292678];\n            ((__local double *) color_320631)[sext_i32_i64(i_322495)] =\n                tmp_322496;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_307964 = local_tid_322420;\n    int64_t gtid_307963 = sext_i32_i64(sext_i64_i32(ltid_pre_322424));\n    \n    if (slt64(gtid_307963, s_n_m_292825)) {\n        bool index_primexp_317939 = gtid_307963 == (int64_t) 0;\n        double defunc_2_reduce_res_307967;\n        \n        defunc_2_reduce_res_307967 = ((__local\n                                       double *) color_320641)[gtid_307963];\n        \n        double defunc_2_reduce_res_307968;\n        \n        defunc_2_reduce_res_307968 = ((__local\n                                       double *) color_320640)[gtid_307963];\n        \n        double defunc_2_reduce_res_307969;\n        \n        defunc_2_reduce_res_307969 = ((__local\n                                       double *) color_320639)[gtid_307963];\n        \n        double defunc_2_reduce_res_307970;\n        \n        defunc_2_reduce_res_307970 = ((__local\n                                       double *) color_320632)[gtid_307963];\n        \n        double defunc_2_reduce_res_3",
            "07971;\n        \n        defunc_2_reduce_res_307971 = ((__local\n                                       double *) color_320631)[gtid_307963];\n        \n        double a_307972 = 2.220446049250313e-16 + defunc_2_reduce_res_307967;\n        double b_307973 = 2.220446049250313e-16 + defunc_2_reduce_res_307968;\n        double c_307974 = 2.220446049250313e-16 + defunc_2_reduce_res_307969;\n        double d_307975 = 2.220446049250313e-16 + defunc_2_reduce_res_307970;\n        double e_307976 = 2.220446049250313e-16 + defunc_2_reduce_res_307971;\n        double x_307977 = c_307974 * e_307976;\n        double y_307978 = d_307975 * d_307975;\n        double a12_307979 = x_307977 - y_307978;\n        double x_307980 = c_307974 * d_307975;\n        double y_307981 = b_307973 * e_307976;\n        double b12_307982 = x_307980 - y_307981;\n        double x_307983 = b_307973 * d_307975;\n        double y_307984 = c_307974 * c_307974;\n        double c12_307985 = x_307983 - y_307984;\n        double x_307986 = a_307972 * e_307976;\n        double b2_307987 = x_307986 - y_307984;\n        double x_307988 = b_307973 * c_307974;\n        double y_307989 = a_307972 * d_307975;\n        double c2_307990 = x_307988 - y_307989;\n        double x_307991 = a_307972 * a12_307979;\n        double y_307992 = b_307973 * b12_307982;\n        double x_307993 = x_307991 + y_307992;\n        double y_307994 = c_307974 * c12_307985;\n        double y_307995 = x_307993 + y_307994;\n        double det_307996 = 1.0 / y_307995;\n        double a12_307997 = a12_307979 * det_307996;\n        double b12_307998 = b12_307982 * det_307996;\n        double c12_307999 = c12_307985 * det_307996;\n        double b2_308000 = b2_307987 * det_307996;\n        double c2_308001 = c2_307990 * det_307996;\n        int64_t defunc_0_m_fun_res_308002;\n        \n        if (index_primexp_317939) {\n            defunc_0_m_fun_res_308002 = (int64_t) 0;\n        } else {\n            int64_t y_308003 = sub64(s_n_m_292825, (int64_t) 1);\n            bool cond_3080",
            "04 = gtid_307963 == y_308003;\n            int64_t defunc_0_m_fun_res_f_res_308005;\n            \n            if (cond_308004) {\n                int64_t defunc_0_m_fun_res_f_res_t_res_308006 =\n                        sub64(pad_css_len_292821, (int64_t) 1);\n                \n                defunc_0_m_fun_res_f_res_308005 =\n                    defunc_0_m_fun_res_f_res_t_res_308006;\n            } else {\n                int64_t x_308007 = sub64(gtid_307963, (int64_t) 1);\n                int64_t x_308008 = mul64(jump_s_292684, x_308007);\n                int64_t min_arg_308009 = add64((int64_t) 1, x_308008);\n                int64_t min_res_308010 = smin64(defunc_0_f_res_292820,\n                                                min_arg_308009);\n                \n                defunc_0_m_fun_res_f_res_308005 = min_res_308010;\n            }\n            defunc_0_m_fun_res_308002 = defunc_0_m_fun_res_f_res_308005;\n        }\n        ((__local double *) color_320638)[gtid_307963] = a12_307997;\n        ((__local double *) color_320637)[gtid_307963] = b12_307998;\n        ((__local double *) color_320636)[gtid_307963] = c12_307999;\n        ((__local double *) color_320635)[gtid_307963] = b2_308000;\n        ((__local double *) color_320634)[gtid_307963] = c2_308001;\n        ((__local int64_t *) color_320633)[gtid_307963] =\n            defunc_0_m_fun_res_308002;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_308015 = local_tid_322420;\n    __local unsigned char *red_arr_mem_322497;\n    \n    red_arr_mem_322497 = (__local\n                          unsigned char *) red_arr_mem_322497_backing_17;\n    \n    __local unsigned char *red_arr_mem_322499;\n    \n    red_arr_mem_322499 = (__local\n                          unsigned char *) red_arr_mem_322499_backing_18;\n    \n    int64_t gtid_308013 = sext_i32_i64(sext_i64_i32(ltid_pre_322427));\n    int64_t gtid_308014 = sext_i32_i64(sext_i64_i32(ltid_pre_322428));\n    \n    if (slt64(gtid_308013, s_n_m_292825) && slt64(gtid_308014, q_s",
            "_292678)) {\n        int64_t x_308022;\n        \n        x_308022 = ((__global int64_t *) ext_mem_318708)[gtid_307879 *\n                                                         (s_n_m_292825 *\n                                                          n_p_292677) +\n                                                         gtid_307880 *\n                                                         s_n_m_292825 +\n                                                         gtid_308013];\n        \n        double x_308023;\n        \n        x_308023 = ((__global double *) ext_mem_318707)[gtid_307879 *\n                                                        (s_n_m_292825 *\n                                                         n_p_292677) +\n                                                        gtid_307880 *\n                                                        s_n_m_292825 +\n                                                        gtid_308013];\n        \n        double a12_308024;\n        \n        a12_308024 = ((__local double *) color_320638)[gtid_308013];\n        \n        double b12_308025;\n        \n        b12_308025 = ((__local double *) color_320637)[gtid_308013];\n        \n        double c12_308026;\n        \n        c12_308026 = ((__local double *) color_320636)[gtid_308013];\n        \n        double b2_308027;\n        \n        b2_308027 = ((__local double *) color_320635)[gtid_308013];\n        \n        double c2_308028;\n        \n        c2_308028 = ((__local double *) color_320634)[gtid_308013];\n        \n        int64_t defunc_0_m_fun_res_308029;\n        \n        defunc_0_m_fun_res_308029 = ((__local\n                                      int64_t *) color_320633)[gtid_308013];\n        \n        bool cond_308031 = sle64(x_307888, gtid_308014);\n        int64_t defunc_0_f_res_308032;\n        \n        if (cond_308031) {\n            defunc_0_f_res_308032 = (int64_t) 0;\n        } else {\n            int64_t i_308033 = add64(gtid_308014, x_308022);\n            int64_t defunc_0_add_arg_3",
            "08034;\n            \n            defunc_0_add_arg_308034 = ((__global\n                                        int64_t *) ext_mem_318610)[gtid_307879 *\n                                                                   (defunc_0_f_res_292820 *\n                                                                    n_p_292677) +\n                                                                   gtid_307880 *\n                                                                   defunc_0_f_res_292820 +\n                                                                   i_308033];\n            \n            int64_t defunc_1_add_res_308035 = add64((int64_t) 1,\n                                                    defunc_0_add_arg_308034);\n            \n            defunc_0_f_res_308032 = defunc_1_add_res_308035;\n        }\n        \n        double defunc_0_f_res_308036;\n        \n        if (cond_308031) {\n            defunc_0_f_res_308036 = 0.0;\n        } else {\n            int64_t i_308037 = add64(gtid_308014, x_308022);\n            double defunc_0_add_arg_308038;\n            \n            defunc_0_add_arg_308038 = ((__global\n                                        double *) mem_318876)[gtid_307879 *\n                                                              (defunc_0_f_res_292820 *\n                                                               n_p_292677) +\n                                                              gtid_307880 *\n                                                              defunc_0_f_res_292820 +\n                                                              i_308037];\n            defunc_0_f_res_308036 = defunc_0_add_arg_308038;\n        }\n        \n        int64_t binop_p_308039 = sub64(defunc_0_f_res_308032,\n                                       defunc_0_m_fun_res_308029);\n        double defunc_0_f_res_308040 = sitofp_i64_f64(binop_p_308039);\n        double abs_res_308041 = fabs(defunc_0_f_res_308040);\n        double tmp1_308042 = abs_res_308041 / x_308023;\n      ",
            "  double x_308043 = tmp1_308042 * tmp1_308042;\n        double y_308044 = tmp1_308042 * x_308043;\n        double tmp2_308045 = 1.0 - y_308044;\n        double x_308046 = tmp2_308045 * tmp2_308045;\n        double tmp3_308047 = tmp2_308045 * x_308046;\n        double tmp4_308048 = defunc_0_f_res_308036 * tmp3_308047;\n        double defunc_1_f_res_308049 = defunc_0_f_res_308040 * tmp4_308048;\n        double defunc_1_f_res_308050 = defunc_0_f_res_308040 *\n               defunc_1_f_res_308049;\n        double defunc_0_f_res_308051;\n        \n        if (cond_308031) {\n            defunc_0_f_res_308051 = 0.0;\n        } else {\n            int64_t i_308052 = add64(gtid_308014, x_308022);\n            double defunc_0_add_arg_308053;\n            \n            defunc_0_add_arg_308053 = ((__global\n                                        double *) mem_318871)[gtid_307879 *\n                                                              (defunc_0_f_res_292820 *\n                                                               n_p_292677) +\n                                                              gtid_307880 *\n                                                              defunc_0_f_res_292820 +\n                                                              i_308052];\n            defunc_0_f_res_308051 = defunc_0_add_arg_308053;\n        }\n        \n        double x_308054 = a12_308024 * tmp4_308048;\n        double y_308055 = b12_308025 * defunc_1_f_res_308049;\n        double x_308056 = x_308054 + y_308055;\n        double y_308057 = c12_308026 * defunc_1_f_res_308050;\n        double x_308058 = x_308056 + y_308057;\n        double defunc_9_fit_fun_res_308059 = defunc_0_f_res_308051 * x_308058;\n        double x_308060 = b12_308025 * tmp4_308048;\n        double y_308061 = b2_308027 * defunc_1_f_res_308049;\n        double x_308062 = x_308060 + y_308061;\n        double y_308063 = c2_308028 * defunc_1_f_res_308050;\n        double x_308064 = x_308062 + y_308063;\n        double defunc_9_slope_fun_res_",
            "308065 = defunc_0_f_res_308051 * x_308064;\n        \n        ((__local double *) red_arr_mem_322497)[gtid_308013 * q_s_292678 +\n                                                gtid_308014] =\n            defunc_9_fit_fun_res_308059;\n        ((__local double *) red_arr_mem_322499)[gtid_308013 * q_s_292678 +\n                                                gtid_308014] =\n            defunc_9_slope_fun_res_308065;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t dims_flat_322501 = s_n_m_292825 * q_s_292678;\n    double x_308016;\n    double x_308017;\n    double x_308018;\n    double x_308019;\n    double x_322504;\n    double x_322505;\n    double x_322506;\n    double x_322507;\n    bool ltid_in_bounds_322510 = slt64(sext_i32_i64(local_tid_322420),\n                                       s_n_m_292825 * q_s_292678);\n    int32_t skip_threads_322511;\n    \n    // read input for in-block scan\n    {\n        if (ltid_in_bounds_322510) {\n            x_308018 = ((volatile __local\n                         double *) red_arr_mem_322497)[sext_i32_i64(local_tid_322420)];\n            x_308019 = ((volatile __local\n                         double *) red_arr_mem_322499)[sext_i32_i64(local_tid_322420)];\n            if ((local_tid_322420 - squot32(local_tid_322420, 32) * 32) == 0) {\n                x_308016 = x_308018;\n                x_308017 = x_308019;\n            }\n        }\n    }\n    // in-block scan (hopefully no barriers needed)\n    {\n        skip_threads_322511 = 1;\n        while (slt32(skip_threads_322511, 32)) {\n            bool thread_active_322512 = sle32(skip_threads_322511,\n                                              local_tid_322420 -\n                                              squot32(local_tid_322420, 32) *\n                                              32) && ltid_in_bounds_322510;\n            \n            if (thread_active_322512) {\n                // read operands\n                {\n                    x_308016 = ((volatile __local\n                                 doubl",
            "e *) red_arr_mem_322497)[sext_i32_i64(local_tid_322420) -\n                                                               sext_i32_i64(skip_threads_322511)];\n                    x_308017 = ((volatile __local\n                                 double *) red_arr_mem_322499)[sext_i32_i64(local_tid_322420) -\n                                                               sext_i32_i64(skip_threads_322511)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_322513 =\n                     slt64(srem64(sext_i32_i64(local_tid_322420), q_s_292678),\n                           sext_i32_i64(local_tid_322420) -\n                           sext_i32_i64(local_tid_322420 -\n                           skip_threads_322511));\n                \n                if (thread_active_322512 && inactive_322513) {\n                    x_308016 = x_308018;\n                    x_308017 = x_308019;\n                }\n                if (thread_active_322512) {\n                    if (!inactive_322513) {\n                        double defunc_1_op_res_308020 = x_308016 + x_308018;\n                        double defunc_1_op_res_308021 = x_308017 + x_308019;\n                        \n                        x_308016 = defunc_1_op_res_308020;\n                        x_308017 = defunc_1_op_res_308021;\n                    }\n                }\n            }\n            if (sle32(wave_sizze_322422, skip_threads_322511)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            if (thread_active_322512) {\n                // write result\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_322497)[sext_i32_i64(local_tid_322420)] =\n                        x_308016;\n                    x_308018 = x_308016;\n                    ((volatile __local\n                      double *) red_arr_mem_322499)[sext_i32_i64(local_tid_322420)] =\n                        x_308017;\n                    x_308019 = x_308017",
            ";\n                }\n            }\n            if (sle32(wave_sizze_322422, skip_threads_322511)) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n            skip_threads_322511 *= 2;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // last thread of block 'i' writes its result to offset 'i'\n    {\n        if ((local_tid_322420 - squot32(local_tid_322420, 32) * 32) == 31 &&\n            ltid_in_bounds_322510) {\n            ((volatile __local\n              double *) red_arr_mem_322497)[sext_i32_i64(squot32(local_tid_322420,\n                                                                 32))] =\n                x_308016;\n            ((volatile __local\n              double *) red_arr_mem_322499)[sext_i32_i64(squot32(local_tid_322420,\n                                                                 32))] =\n                x_308017;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n    {\n        int32_t skip_threads_322514;\n        \n        // read input for in-block scan\n        {\n            if (squot32(local_tid_322420, 32) == 0 && ltid_in_bounds_322510) {\n                x_322506 = ((volatile __local\n                             double *) red_arr_mem_322497)[sext_i32_i64(local_tid_322420)];\n                x_322507 = ((volatile __local\n                             double *) red_arr_mem_322499)[sext_i32_i64(local_tid_322420)];\n                if ((local_tid_322420 - squot32(local_tid_322420, 32) * 32) ==\n                    0) {\n                    x_322504 = x_322506;\n                    x_322505 = x_322507;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_322514 = 1;\n            while (slt32(skip_threads_322514, 32)) {\n                bool thread_active_322515 = sle32(skip_threads_322514,\n                                                  local_tid_322420 -\n                          ",
            "                        squot32(local_tid_322420,\n                                                          32) * 32) &&\n                     (squot32(local_tid_322420, 32) == 0 &&\n                      ltid_in_bounds_322510);\n                \n                if (thread_active_322515) {\n                    // read operands\n                    {\n                        x_322504 = ((volatile __local\n                                     double *) red_arr_mem_322497)[sext_i32_i64(local_tid_322420) -\n                                                                   sext_i32_i64(skip_threads_322514)];\n                        x_322505 = ((volatile __local\n                                     double *) red_arr_mem_322499)[sext_i32_i64(local_tid_322420) -\n                                                                   sext_i32_i64(skip_threads_322514)];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_322516 =\n                         slt64(srem64(sext_i32_i64(local_tid_322420 * 32 + 32 -\n                                      1), q_s_292678),\n                               sext_i32_i64(local_tid_322420 * 32 + 32 - 1) -\n                               sext_i32_i64((local_tid_322420 -\n                                             skip_threads_322514) * 32 + 32 -\n                               1));\n                    \n                    if (thread_active_322515 && inactive_322516) {\n                        x_322504 = x_322506;\n                        x_322505 = x_322507;\n                    }\n                    if (thread_active_322515) {\n                        if (!inactive_322516) {\n                            double defunc_1_op_res_322508 = x_322504 + x_322506;\n                            double defunc_1_op_res_322509 = x_322505 + x_322507;\n                            \n                            x_322504 = defunc_1_op_res_322508;\n                            x_322505 = defunc_1_op_res_32250",
            "9;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_322422, skip_threads_322514)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_322515) {\n                    // write result\n                    {\n                        ((volatile __local\n                          double *) red_arr_mem_322497)[sext_i32_i64(local_tid_322420)] =\n                            x_322504;\n                        x_322506 = x_322504;\n                        ((volatile __local\n                          double *) red_arr_mem_322499)[sext_i32_i64(local_tid_322420)] =\n                            x_322505;\n                        x_322507 = x_322505;\n                    }\n                }\n                if (sle32(wave_sizze_322422, skip_threads_322514)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_322514 *= 2;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    bool no_carry_in_322517 = squot32(local_tid_322420, 32) == 0 ||\n         !ltid_in_bounds_322510;\n    \n    // carry-in for every block except the first\n    {\n        // read operands\n        {\n            if (!no_carry_in_322517) {\n                x_308018 = x_308016;\n                x_308019 = x_308017;\n                x_308016 = ((__local\n                             double *) red_arr_mem_322497)[sext_i32_i64(squot32(local_tid_322420,\n                                                                                32)) -\n                                                           (int64_t) 1];\n                x_308017 = ((__local\n                             double *) red_arr_mem_322499)[sext_i32_i64(squot32(local_tid_322420,\n                                                                                32)) -\n                                                           (int64_t) 1];\n            }\n        }\n        // perform operation\n        {\n          ",
            "  bool inactive_322518 = slt64(srem64(sext_i32_i64(local_tid_322420),\n                                                q_s_292678),\n                                         sext_i32_i64(local_tid_322420) -\n                                         sext_i32_i64(squot32(local_tid_322420,\n                                                              32) * 32 - 1));\n            \n            if (!no_carry_in_322517) {\n                if (inactive_322518) {\n                    x_308016 = x_308018;\n                    x_308017 = x_308019;\n                }\n            }\n            if (!no_carry_in_322517) {\n                if (!inactive_322518) {\n                    double defunc_1_op_res_308020 = x_308016 + x_308018;\n                    double defunc_1_op_res_308021 = x_308017 + x_308019;\n                    \n                    x_308016 = defunc_1_op_res_308020;\n                    x_308017 = defunc_1_op_res_308021;\n                }\n            }\n        }\n        // write final result\n        {\n            if (!no_carry_in_322517) {\n                ((__local\n                  double *) red_arr_mem_322497)[sext_i32_i64(local_tid_322420)] =\n                    x_308016;\n                ((__local\n                  double *) red_arr_mem_322499)[sext_i32_i64(local_tid_322420)] =\n                    x_308017;\n            }\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // restore correct values for first block\n    {\n        if (squot32(local_tid_322420, 32) == 0 && ltid_in_bounds_322510) {\n            ((__local\n              double *) red_arr_mem_322497)[sext_i32_i64(local_tid_322420)] =\n                x_308018;\n            ((__local\n              double *) red_arr_mem_322499)[sext_i32_i64(local_tid_322420)] =\n                x_308019;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322519 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_3",
            "07713));\n    \n    for (int32_t chunk_i_322520 = 0; chunk_i_322520 < num_chunks_322519;\n         chunk_i_322520++) {\n        int32_t i_322521 = chunk_i_322520 *\n                sext_i64_i32(computed_group_sizze_307713) + local_tid_322420;\n        \n        if (slt32(i_322521, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322522;\n            \n            tmp_322522 = ((__local double *) red_arr_mem_322497)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_322521) *\n                                                                 q_s_292678];\n            ((__local double *) color_320632)[sext_i32_i64(i_322521)] =\n                tmp_322522;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322523 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_307713));\n    \n    for (int32_t chunk_i_322524 = 0; chunk_i_322524 < num_chunks_322523;\n         chunk_i_322524++) {\n        int32_t i_322525 = chunk_i_322524 *\n                sext_i64_i32(computed_group_sizze_307713) + local_tid_322420;\n        \n        if (slt32(i_322525, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322526;\n            \n            tmp_322526 = ((__local double *) red_arr_mem_322499)[q_s_292678 -\n                                                                 (int64_t) 1 +\n                                                                 sext_i32_i64(i_322525) *\n                                                                 q_s_292678];\n            ((__local double *) color_320631)[sext_i32_i64(i_322525)] =\n                tmp_322526;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322527 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_307713));\n   ",
            " \n    for (int32_t chunk_i_322528 = 0; chunk_i_322528 < num_chunks_322527;\n         chunk_i_322528++) {\n        int32_t i_322529 = chunk_i_322528 *\n                sext_i64_i32(computed_group_sizze_307713) + local_tid_322420;\n        \n        if (slt32(i_322529, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322530;\n            \n            tmp_322530 = ((__local\n                           double *) color_320632)[sext_i32_i64(i_322529)];\n            ((__global double *) mem_319384)[gtid_307879 * (s_n_m_292825 *\n                                                            n_p_292677) +\n                                             gtid_307880 * s_n_m_292825 +\n                                             sext_i32_i64(i_322529)] =\n                tmp_322530;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t num_chunks_322531 = sdiv_up32(sext_i64_i32(s_n_m_292825),\n                                          sext_i64_i32(computed_group_sizze_307713));\n    \n    for (int32_t chunk_i_322532 = 0; chunk_i_322532 < num_chunks_322531;\n         chunk_i_322532++) {\n        int32_t i_322533 = chunk_i_322532 *\n                sext_i64_i32(computed_group_sizze_307713) + local_tid_322420;\n        \n        if (slt32(i_322533, sext_i64_i32(s_n_m_292825))) {\n            double tmp_322534;\n            \n            tmp_322534 = ((__local\n                           double *) color_320631)[sext_i32_i64(i_322533)];\n            ((__global double *) mem_319389)[gtid_307879 * (s_n_m_292825 *\n                                                            n_p_292677) +\n                                             gtid_307880 * s_n_m_292825 +\n                                             sext_i32_i64(i_322533)] =\n                tmp_322534;\n        }\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n  error_6:\n    return;\n}\n__kernel void mainzisegmap_intragroup_309930(__global int *global_failure,\n                                             uint red_arr_mem_323409_backing_offset_0,\n  ",
            "                                           uint red_arr_mem_323405_backing_offset_1,\n                                             uint color_320643_backing_offset_2,\n                                             int64_t n_292675,\n                                             int64_t q_l_292680,\n                                             int64_t jump_t_292685,\n                                             int64_t partition_sizze_292766,\n                                             int64_t l_n_m_292832,\n                                             int64_t i_292846,\n                                             int64_t ctx_param_ext_318833,\n                                             int64_t ctx_param_ext_318834,\n                                             int64_t ctx_param_ext_318836,\n                                             __global\n                                             unsigned char *ext_mem_318756,\n                                             __global\n                                             unsigned char *ext_mem_318757,\n                                             __global\n                                             unsigned char *mem_param_318838,\n                                             __global unsigned char *mem_319555,\n                                             __global unsigned char *mem_319600)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_323409_backing_2 =\n                           &shared_mem[red_arr_mem_323409_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323405_backing_1 =\n                           &shared_mem[red_arr_mem_323405_backing_offset_1];\n    volatile unsigned char *color_320643_backing_0 =\n                           &shared_mem[color_320643_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323393;\n    int32_t local_tid_323394;\n    int64_t group_sizze_323397;\n    int32_t wav",
            "e_sizze_323396;\n    int32_t group_tid_323395;\n    \n    global_tid_323393 = get_global_id(0);\n    local_tid_323394 = get_local_id(0);\n    group_sizze_323397 = get_local_size(0);\n    wave_sizze_323396 = LOCKSTEP_WIDTH;\n    group_tid_323395 = get_group_id(0);\n    \n    int32_t phys_tid_309930 = group_tid_323395;\n    int64_t slice_323399 = q_l_292680;\n    int64_t ltid_pre_323398 = sext_i32_i64(local_tid_323394);\n    int64_t remnant_323400 = sext_i32_i64(local_tid_323394) - ltid_pre_323398;\n    int64_t slice_323401 = l_n_m_292832;\n    int64_t slice_323402 = partition_sizze_292766 * slice_323401;\n    int64_t gtid_309928 = squot64(sext_i32_i64(group_tid_323395), slice_323401);\n    int64_t remnant_323403 = sext_i32_i64(group_tid_323395) - gtid_309928 *\n            slice_323401;\n    int64_t gtid_309929 = remnant_323403;\n    int64_t remnant_323404 = remnant_323403 - gtid_309929;\n    __local unsigned char *color_320643;\n    \n    color_320643 = (__local unsigned char *) color_320643_backing_0;\n    \n    int64_t x_309936;\n    \n    x_309936 = ((__global int64_t *) ext_mem_318757)[gtid_309928 *\n                                                     l_n_m_292832 +\n                                                     gtid_309929];\n    \n    double x_309937;\n    \n    x_309937 = ((__global double *) ext_mem_318756)[gtid_309928 * l_n_m_292832 +\n                                                    gtid_309929];\n    \n    int64_t min_arg_309938 = mul64(jump_t_292685, gtid_309929);\n    int64_t min_res_309939 = smin64(i_292846, min_arg_309938);\n    int64_t defunc_0_g_res_309940 = add64((int64_t) 1, min_res_309939);\n    double defunc_2_reduce_res_309941;\n    int32_t phys_tid_309944 = local_tid_323394;\n    __local unsigned char *red_arr_mem_323405;\n    \n    red_arr_mem_323405 = (__local unsigned char *) red_arr_mem_323405_backing_1;\n    \n    int64_t gtid_309943 = sext_i32_i64(sext_i64_i32(ltid_pre_323398));\n    bool cond_309949 = sle64(n_292675, gtid_309943);\n    int64_t defunc_0_f_res_309950;\n    ",
            "\n    if (cond_309949) {\n        defunc_0_f_res_309950 = (int64_t) 0;\n    } else {\n        int64_t i_309951 = add64(x_309936, gtid_309943);\n        int64_t defunc_1_add_res_309952 = add64((int64_t) 1, i_309951);\n        \n        defunc_0_f_res_309950 = defunc_1_add_res_309952;\n    }\n    \n    double defunc_0_f_res_309953;\n    \n    if (cond_309949) {\n        defunc_0_f_res_309953 = 0.0;\n    } else {\n        int64_t i_309954 = add64(x_309936, gtid_309943);\n        double defunc_0_add_arg_309955;\n        \n        defunc_0_add_arg_309955 = ((__global\n                                    double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                (gtid_309928 *\n                                                                 ctx_param_ext_318834 +\n                                                                 i_309954 *\n                                                                 ctx_param_ext_318836)];\n        defunc_0_f_res_309953 = defunc_0_add_arg_309955;\n    }\n    \n    int64_t binop_p_309956 = sub64(defunc_0_f_res_309950,\n                                   defunc_0_g_res_309940);\n    double defunc_0_f_res_309957 = sitofp_i64_f64(binop_p_309956);\n    double abs_res_309958 = fabs(defunc_0_f_res_309957);\n    double tmp1_309959 = abs_res_309958 / x_309937;\n    double x_309960 = tmp1_309959 * tmp1_309959;\n    double y_309961 = tmp1_309959 * x_309960;\n    double tmp2_309962 = 1.0 - y_309961;\n    double x_309963 = tmp2_309962 * tmp2_309962;\n    double tmp3_309964 = tmp2_309962 * x_309963;\n    double tmp4_309965 = defunc_0_f_res_309953 * tmp3_309964;\n    \n    ((__local double *) red_arr_mem_323405)[gtid_309943] = tmp4_309965;\n    ((__local double *) color_320643)[gtid_309943] = tmp4_309965;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_323407;\n    int32_t skip_waves_323408 = 1;\n    double x_309945;\n    double x_309946;\n    \n    offset_323407 = 0;\n    // participating threads read initial accumulator\n    {",
            "\n        if (slt32(local_tid_323394, sext_i64_i32(q_l_292680))) {\n            x_309945 = ((__local\n                         double *) red_arr_mem_323405)[sext_i32_i64(local_tid_323394 +\n                                                       offset_323407)];\n        }\n    }\n    offset_323407 = 1;\n    while (slt32(offset_323407, wave_sizze_323396)) {\n        if (slt32(local_tid_323394 + offset_323407, sext_i64_i32(q_l_292680)) &&\n            ((local_tid_323394 - squot32(local_tid_323394, wave_sizze_323396) *\n              wave_sizze_323396) & (2 * offset_323407 - 1)) == 0) {\n            // read array element\n            {\n                x_309946 = ((volatile __local\n                             double *) red_arr_mem_323405)[sext_i32_i64(local_tid_323394 +\n                                                           offset_323407)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_309947 = x_309945 + x_309946;\n                \n                x_309945 = defunc_1_op_res_309947;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_323405)[sext_i32_i64(local_tid_323394)] =\n                    x_309945;\n            }\n        }\n        offset_323407 *= 2;\n    }\n    while (slt32(skip_waves_323408, squot32(sext_i64_i32(q_l_292680) +\n                                            wave_sizze_323396 - 1,\n                                            wave_sizze_323396))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_323407 = skip_waves_323408 * wave_sizze_323396;\n        if (slt32(local_tid_323394 + offset_323407, sext_i64_i32(q_l_292680)) &&\n            ((local_tid_323394 - squot32(local_tid_323394, wave_sizze_323396) *\n              wave_sizze_323396) == 0 && (squot32(local_tid_323394,\n                                                  wave_sizze_323396) & (2 *\n                                                                    ",
            "    skip_waves_323408 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_309946 = ((__local\n                             double *) red_arr_mem_323405)[sext_i32_i64(local_tid_323394 +\n                                                           offset_323407)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_309947 = x_309945 + x_309946;\n                \n                x_309945 = defunc_1_op_res_309947;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_323405)[sext_i32_i64(local_tid_323394)] =\n                    x_309945;\n            }\n        }\n        skip_waves_323408 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_309941 = ((__local\n                                   double *) red_arr_mem_323405)[(int64_t) 0];\n    \n    double a_309966 = 2.220446049250313e-16 + defunc_2_reduce_res_309941;\n    double a0_309967 = 1.0 / a_309966;\n    double defunc_2_reduce_res_309968;\n    int32_t phys_tid_309970 = local_tid_323394;\n    __local unsigned char *red_arr_mem_323409;\n    \n    red_arr_mem_323409 = (__local unsigned char *) red_arr_mem_323409_backing_2;\n    \n    int64_t gtid_309969 = sext_i32_i64(sext_i64_i32(ltid_pre_323398));\n    double x_309975;\n    \n    x_309975 = ((__local double *) color_320643)[gtid_309969];\n    \n    bool cond_309976 = sle64(n_292675, gtid_309969);\n    double defunc_0_f_res_309977;\n    \n    if (cond_309976) {\n        defunc_0_f_res_309977 = 0.0;\n    } else {\n        int64_t i_309978 = add64(x_309936, gtid_309969);\n        double defunc_0_add_arg_309979;\n        \n        defunc_0_add_arg_309979 = ((__global double *) mem_319555)[gtid_309928 *\n                                                                   n_292675 +\n                                                         ",
            "          i_309978];\n        defunc_0_f_res_309977 = defunc_0_add_arg_309979;\n    }\n    \n    double x_309980 = a0_309967 * x_309975;\n    double defunc_9_fit_fun_res_309981 = defunc_0_f_res_309977 * x_309980;\n    \n    ((__local double *) red_arr_mem_323409)[gtid_309969] =\n        defunc_9_fit_fun_res_309981;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_323411;\n    int32_t skip_waves_323412 = 1;\n    double x_309971;\n    double x_309972;\n    \n    offset_323411 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_323394, sext_i64_i32(q_l_292680))) {\n            x_309971 = ((__local\n                         double *) red_arr_mem_323409)[sext_i32_i64(local_tid_323394 +\n                                                       offset_323411)];\n        }\n    }\n    offset_323411 = 1;\n    while (slt32(offset_323411, wave_sizze_323396)) {\n        if (slt32(local_tid_323394 + offset_323411, sext_i64_i32(q_l_292680)) &&\n            ((local_tid_323394 - squot32(local_tid_323394, wave_sizze_323396) *\n              wave_sizze_323396) & (2 * offset_323411 - 1)) == 0) {\n            // read array element\n            {\n                x_309972 = ((volatile __local\n                             double *) red_arr_mem_323409)[sext_i32_i64(local_tid_323394 +\n                                                           offset_323411)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_309973 = x_309971 + x_309972;\n                \n                x_309971 = defunc_1_op_res_309973;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_323409)[sext_i32_i64(local_tid_323394)] =\n                    x_309971;\n            }\n        }\n        offset_323411 *= 2;\n    }\n    while (slt32(skip_waves_323412, squot32(sext_i64_i32(q_l_292680) +\n                                            wave_sizze_323396 - 1,\n  ",
            "                                          wave_sizze_323396))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_323411 = skip_waves_323412 * wave_sizze_323396;\n        if (slt32(local_tid_323394 + offset_323411, sext_i64_i32(q_l_292680)) &&\n            ((local_tid_323394 - squot32(local_tid_323394, wave_sizze_323396) *\n              wave_sizze_323396) == 0 && (squot32(local_tid_323394,\n                                                  wave_sizze_323396) & (2 *\n                                                                        skip_waves_323412 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_309972 = ((__local\n                             double *) red_arr_mem_323409)[sext_i32_i64(local_tid_323394 +\n                                                           offset_323411)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_309973 = x_309971 + x_309972;\n                \n                x_309971 = defunc_1_op_res_309973;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_323409)[sext_i32_i64(local_tid_323394)] =\n                    x_309971;\n            }\n        }\n        skip_waves_323412 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_309968 = ((__local\n                                   double *) red_arr_mem_323409)[(int64_t) 0];\n    if (local_tid_323394 == 0) {\n        ((__global double *) mem_319600)[gtid_309928 * l_n_m_292832 +\n                                         gtid_309929] =\n            defunc_2_reduce_res_309968;\n    }\n    \n  error_4:\n    return;\n}\n__kernel void mainzisegmap_intragroup_310101(__global int *global_failure,\n                                             uint red_arr_mem_323436_backing_offset_0,\n                                             uint red_arr_m",
            "em_323434_backing_offset_1,\n                                             uint red_arr_mem_323430_backing_offset_2,\n                                             uint red_arr_mem_323428_backing_offset_3,\n                                             uint red_arr_mem_323426_backing_offset_4,\n                                             uint color_320645_backing_offset_5,\n                                             uint color_320644_backing_offset_6,\n                                             int64_t n_292675,\n                                             int64_t q_l_292680,\n                                             int64_t jump_t_292685,\n                                             int64_t partition_sizze_292766,\n                                             int64_t l_n_m_292832,\n                                             int64_t i_292846,\n                                             int64_t ctx_param_ext_318833,\n                                             int64_t ctx_param_ext_318834,\n                                             int64_t ctx_param_ext_318836,\n                                             __global\n                                             unsigned char *ext_mem_318756,\n                                             __global\n                                             unsigned char *ext_mem_318757,\n                                             __global\n                                             unsigned char *mem_param_318838,\n                                             __global unsigned char *mem_319555,\n                                             __global unsigned char *mem_319613,\n                                             __global unsigned char *mem_319617)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_323436_backing_6 =\n                           &shared_mem[red_arr_mem_323436_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323434_backing_5 =",
            "\n                           &shared_mem[red_arr_mem_323434_backing_offset_1];\n    volatile unsigned char *red_arr_mem_323430_backing_4 =\n                           &shared_mem[red_arr_mem_323430_backing_offset_2];\n    volatile unsigned char *red_arr_mem_323428_backing_3 =\n                           &shared_mem[red_arr_mem_323428_backing_offset_3];\n    volatile unsigned char *red_arr_mem_323426_backing_2 =\n                           &shared_mem[red_arr_mem_323426_backing_offset_4];\n    volatile unsigned char *color_320645_backing_1 =\n                           &shared_mem[color_320645_backing_offset_5];\n    volatile unsigned char *color_320644_backing_0 =\n                           &shared_mem[color_320644_backing_offset_6];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323414;\n    int32_t local_tid_323415;\n    int64_t group_sizze_323418;\n    int32_t wave_sizze_323417;\n    int32_t group_tid_323416;\n    \n    global_tid_323414 = get_global_id(0);\n    local_tid_323415 = get_local_id(0);\n    group_sizze_323418 = get_local_size(0);\n    wave_sizze_323417 = LOCKSTEP_WIDTH;\n    group_tid_323416 = get_group_id(0);\n    \n    int32_t phys_tid_310101 = group_tid_323416;\n    int64_t slice_323420 = q_l_292680;\n    int64_t ltid_pre_323419 = sext_i32_i64(local_tid_323415);\n    int64_t remnant_323421 = sext_i32_i64(local_tid_323415) - ltid_pre_323419;\n    int64_t slice_323422 = l_n_m_292832;\n    int64_t slice_323423 = partition_sizze_292766 * slice_323422;\n    int64_t gtid_310099 = squot64(sext_i32_i64(group_tid_323416), slice_323422);\n    int64_t remnant_323424 = sext_i32_i64(group_tid_323416) - gtid_310099 *\n            slice_323422;\n    int64_t gtid_310100 = remnant_323424;\n    int64_t remnant_323425 = remnant_323424 - gtid_310100;\n    __local unsigned char *color_320644;\n    \n    color_320644 = (__local unsigned char *) color_320644_backing_0;\n    \n    __local unsigned char *color_320645;\n    \n    color_320645 = (__local unsigned char *) color_3206",
            "45_backing_1;\n    \n    int64_t x_310107;\n    \n    x_310107 = ((__global int64_t *) ext_mem_318757)[gtid_310099 *\n                                                     l_n_m_292832 +\n                                                     gtid_310100];\n    \n    double x_310108;\n    \n    x_310108 = ((__global double *) ext_mem_318756)[gtid_310099 * l_n_m_292832 +\n                                                    gtid_310100];\n    \n    int64_t min_arg_310109 = mul64(jump_t_292685, gtid_310100);\n    int64_t min_res_310110 = smin64(i_292846, min_arg_310109);\n    int64_t defunc_0_g_res_310111 = add64((int64_t) 1, min_res_310110);\n    double defunc_2_reduce_res_310112;\n    double defunc_2_reduce_res_310113;\n    double defunc_2_reduce_res_310114;\n    int32_t phys_tid_310118 = local_tid_323415;\n    __local unsigned char *red_arr_mem_323426;\n    \n    red_arr_mem_323426 = (__local unsigned char *) red_arr_mem_323426_backing_2;\n    \n    __local unsigned char *red_arr_mem_323428;\n    \n    red_arr_mem_323428 = (__local unsigned char *) red_arr_mem_323428_backing_3;\n    \n    __local unsigned char *red_arr_mem_323430;\n    \n    red_arr_mem_323430 = (__local unsigned char *) red_arr_mem_323430_backing_4;\n    \n    int64_t gtid_310117 = sext_i32_i64(sext_i64_i32(ltid_pre_323419));\n    bool cond_310129 = sle64(n_292675, gtid_310117);\n    int64_t defunc_0_f_res_310130;\n    \n    if (cond_310129) {\n        defunc_0_f_res_310130 = (int64_t) 0;\n    } else {\n        int64_t i_310131 = add64(x_310107, gtid_310117);\n        int64_t defunc_1_add_res_310132 = add64((int64_t) 1, i_310131);\n        \n        defunc_0_f_res_310130 = defunc_1_add_res_310132;\n    }\n    \n    double defunc_0_f_res_310133;\n    \n    if (cond_310129) {\n        defunc_0_f_res_310133 = 0.0;\n    } else {\n        int64_t i_310134 = add64(x_310107, gtid_310117);\n        double defunc_0_add_arg_310135;\n        \n        defunc_0_add_arg_310135 = ((__global\n                                    double *) mem_param_318838)[ctx_param_ext",
            "_318833 +\n                                                                (gtid_310099 *\n                                                                 ctx_param_ext_318834 +\n                                                                 i_310134 *\n                                                                 ctx_param_ext_318836)];\n        defunc_0_f_res_310133 = defunc_0_add_arg_310135;\n    }\n    \n    int64_t binop_p_310136 = sub64(defunc_0_f_res_310130,\n                                   defunc_0_g_res_310111);\n    double defunc_0_f_res_310137 = sitofp_i64_f64(binop_p_310136);\n    double abs_res_310138 = fabs(defunc_0_f_res_310137);\n    double tmp1_310139 = abs_res_310138 / x_310108;\n    double x_310140 = tmp1_310139 * tmp1_310139;\n    double y_310141 = tmp1_310139 * x_310140;\n    double tmp2_310142 = 1.0 - y_310141;\n    double x_310143 = tmp2_310142 * tmp2_310142;\n    double tmp3_310144 = tmp2_310142 * x_310143;\n    double tmp4_310145 = defunc_0_f_res_310133 * tmp3_310144;\n    double defunc_1_f_res_310146 = defunc_0_f_res_310137 * tmp4_310145;\n    double defunc_1_f_res_310147 = defunc_0_f_res_310137 *\n           defunc_1_f_res_310146;\n    \n    ((__local double *) red_arr_mem_323426)[gtid_310117] = tmp4_310145;\n    ((__local double *) red_arr_mem_323428)[gtid_310117] =\n        defunc_1_f_res_310146;\n    ((__local double *) red_arr_mem_323430)[gtid_310117] =\n        defunc_1_f_res_310147;\n    ((__local double *) color_320645)[gtid_310117] = defunc_1_f_res_310146;\n    ((__local double *) color_320644)[gtid_310117] = tmp4_310145;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_323432;\n    int32_t skip_waves_323433 = 1;\n    double x_310119;\n    double x_310120;\n    double x_310121;\n    double x_310122;\n    double x_310123;\n    double x_310124;\n    \n    offset_323432 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_323415, sext_i64_i32(q_l_292680))) {\n            x_310119 = ((__local\n                        ",
            " double *) red_arr_mem_323426)[sext_i32_i64(local_tid_323415 +\n                                                       offset_323432)];\n            x_310120 = ((__local\n                         double *) red_arr_mem_323428)[sext_i32_i64(local_tid_323415 +\n                                                       offset_323432)];\n            x_310121 = ((__local\n                         double *) red_arr_mem_323430)[sext_i32_i64(local_tid_323415 +\n                                                       offset_323432)];\n        }\n    }\n    offset_323432 = 1;\n    while (slt32(offset_323432, wave_sizze_323417)) {\n        if (slt32(local_tid_323415 + offset_323432, sext_i64_i32(q_l_292680)) &&\n            ((local_tid_323415 - squot32(local_tid_323415, wave_sizze_323417) *\n              wave_sizze_323417) & (2 * offset_323432 - 1)) == 0) {\n            // read array element\n            {\n                x_310122 = ((volatile __local\n                             double *) red_arr_mem_323426)[sext_i32_i64(local_tid_323415 +\n                                                           offset_323432)];\n                x_310123 = ((volatile __local\n                             double *) red_arr_mem_323428)[sext_i32_i64(local_tid_323415 +\n                                                           offset_323432)];\n                x_310124 = ((volatile __local\n                             double *) red_arr_mem_323430)[sext_i32_i64(local_tid_323415 +\n                                                           offset_323432)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_310125 = x_310119 + x_310122;\n                double defunc_1_op_res_310126 = x_310120 + x_310123;\n                double defunc_1_op_res_310127 = x_310121 + x_310124;\n                \n                x_310119 = defunc_1_op_res_310125;\n                x_310120 = defunc_1_op_res_310126;\n                x_310121 = defunc_1_op_res_310127;\n            }\n            ",
            "// write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_323426)[sext_i32_i64(local_tid_323415)] =\n                    x_310119;\n                ((volatile __local\n                  double *) red_arr_mem_323428)[sext_i32_i64(local_tid_323415)] =\n                    x_310120;\n                ((volatile __local\n                  double *) red_arr_mem_323430)[sext_i32_i64(local_tid_323415)] =\n                    x_310121;\n            }\n        }\n        offset_323432 *= 2;\n    }\n    while (slt32(skip_waves_323433, squot32(sext_i64_i32(q_l_292680) +\n                                            wave_sizze_323417 - 1,\n                                            wave_sizze_323417))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_323432 = skip_waves_323433 * wave_sizze_323417;\n        if (slt32(local_tid_323415 + offset_323432, sext_i64_i32(q_l_292680)) &&\n            ((local_tid_323415 - squot32(local_tid_323415, wave_sizze_323417) *\n              wave_sizze_323417) == 0 && (squot32(local_tid_323415,\n                                                  wave_sizze_323417) & (2 *\n                                                                        skip_waves_323433 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_310122 = ((__local\n                             double *) red_arr_mem_323426)[sext_i32_i64(local_tid_323415 +\n                                                           offset_323432)];\n                x_310123 = ((__local\n                             double *) red_arr_mem_323428)[sext_i32_i64(local_tid_323415 +\n                                                           offset_323432)];\n                x_310124 = ((__local\n                             double *) red_arr_mem_323430)[sext_i32_i64(local_tid_323415 +\n                                                           offset_323432)",
            "];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_310125 = x_310119 + x_310122;\n                double defunc_1_op_res_310126 = x_310120 + x_310123;\n                double defunc_1_op_res_310127 = x_310121 + x_310124;\n                \n                x_310119 = defunc_1_op_res_310125;\n                x_310120 = defunc_1_op_res_310126;\n                x_310121 = defunc_1_op_res_310127;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_323426)[sext_i32_i64(local_tid_323415)] =\n                    x_310119;\n                ((__local\n                  double *) red_arr_mem_323428)[sext_i32_i64(local_tid_323415)] =\n                    x_310120;\n                ((__local\n                  double *) red_arr_mem_323430)[sext_i32_i64(local_tid_323415)] =\n                    x_310121;\n            }\n        }\n        skip_waves_323433 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_310112 = ((__local\n                                   double *) red_arr_mem_323426)[(int64_t) 0];\n    defunc_2_reduce_res_310113 = ((__local\n                                   double *) red_arr_mem_323428)[(int64_t) 0];\n    defunc_2_reduce_res_310114 = ((__local\n                                   double *) red_arr_mem_323430)[(int64_t) 0];\n    \n    double a_310148 = 2.220446049250313e-16 + defunc_2_reduce_res_310112;\n    double b_310149 = 2.220446049250313e-16 + defunc_2_reduce_res_310113;\n    double c_310150 = 2.220446049250313e-16 + defunc_2_reduce_res_310114;\n    double x_310151 = a_310148 * c_310150;\n    double y_310152 = b_310149 * b_310149;\n    double y_310153 = x_310151 - y_310152;\n    double det1_310154 = 1.0 / y_310153;\n    double a11_310155 = c_310150 * det1_310154;\n    double x_310156 = 0.0 - b_310149;\n    double b11_310157 = det1_310154 * x_310156;\n    double c11_310158 = a_310148 * det1_310154;\n    double defunc_2_reduce_",
            "res_310159;\n    double defunc_2_reduce_res_310160;\n    int32_t phys_tid_310162 = local_tid_323415;\n    __local unsigned char *red_arr_mem_323434;\n    \n    red_arr_mem_323434 = (__local unsigned char *) red_arr_mem_323434_backing_5;\n    \n    __local unsigned char *red_arr_mem_323436;\n    \n    red_arr_mem_323436 = (__local unsigned char *) red_arr_mem_323436_backing_6;\n    \n    int64_t gtid_310161 = sext_i32_i64(sext_i64_i32(ltid_pre_323419));\n    double x_310170;\n    \n    x_310170 = ((__local double *) color_320644)[gtid_310161];\n    \n    double x_310171;\n    \n    x_310171 = ((__local double *) color_320645)[gtid_310161];\n    \n    bool cond_310172 = sle64(n_292675, gtid_310161);\n    double defunc_0_f_res_310173;\n    \n    if (cond_310172) {\n        defunc_0_f_res_310173 = 0.0;\n    } else {\n        int64_t i_310174 = add64(x_310107, gtid_310161);\n        double defunc_0_add_arg_310175;\n        \n        defunc_0_add_arg_310175 = ((__global double *) mem_319555)[gtid_310099 *\n                                                                   n_292675 +\n                                                                   i_310174];\n        defunc_0_f_res_310173 = defunc_0_add_arg_310175;\n    }\n    \n    double x_310176 = a11_310155 * x_310170;\n    double y_310177 = b11_310157 * x_310171;\n    double x_310178 = x_310176 + y_310177;\n    double defunc_9_fit_fun_res_310179 = defunc_0_f_res_310173 * x_310178;\n    double x_310180 = b11_310157 * x_310170;\n    double y_310181 = c11_310158 * x_310171;\n    double x_310182 = x_310180 + y_310181;\n    double defunc_9_slope_fun_res_310183 = defunc_0_f_res_310173 * x_310182;\n    \n    ((__local double *) red_arr_mem_323434)[gtid_310161] =\n        defunc_9_fit_fun_res_310179;\n    ((__local double *) red_arr_mem_323436)[gtid_310161] =\n        defunc_9_slope_fun_res_310183;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_323438;\n    int32_t skip_waves_323439 = 1;\n    double x_310163;\n    double x_310164;\n    double x_310165;\n    doubl",
            "e x_310166;\n    \n    offset_323438 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_323415, sext_i64_i32(q_l_292680))) {\n            x_310163 = ((__local\n                         double *) red_arr_mem_323434)[sext_i32_i64(local_tid_323415 +\n                                                       offset_323438)];\n            x_310164 = ((__local\n                         double *) red_arr_mem_323436)[sext_i32_i64(local_tid_323415 +\n                                                       offset_323438)];\n        }\n    }\n    offset_323438 = 1;\n    while (slt32(offset_323438, wave_sizze_323417)) {\n        if (slt32(local_tid_323415 + offset_323438, sext_i64_i32(q_l_292680)) &&\n            ((local_tid_323415 - squot32(local_tid_323415, wave_sizze_323417) *\n              wave_sizze_323417) & (2 * offset_323438 - 1)) == 0) {\n            // read array element\n            {\n                x_310165 = ((volatile __local\n                             double *) red_arr_mem_323434)[sext_i32_i64(local_tid_323415 +\n                                                           offset_323438)];\n                x_310166 = ((volatile __local\n                             double *) red_arr_mem_323436)[sext_i32_i64(local_tid_323415 +\n                                                           offset_323438)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_310167 = x_310163 + x_310165;\n                double defunc_1_op_res_310168 = x_310164 + x_310166;\n                \n                x_310163 = defunc_1_op_res_310167;\n                x_310164 = defunc_1_op_res_310168;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_323434)[sext_i32_i64(local_tid_323415)] =\n                    x_310163;\n                ((volatile __local\n                  double *) red_arr_mem_323436)[sext_i32_i64(local_tid_323415)",
            "] =\n                    x_310164;\n            }\n        }\n        offset_323438 *= 2;\n    }\n    while (slt32(skip_waves_323439, squot32(sext_i64_i32(q_l_292680) +\n                                            wave_sizze_323417 - 1,\n                                            wave_sizze_323417))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_323438 = skip_waves_323439 * wave_sizze_323417;\n        if (slt32(local_tid_323415 + offset_323438, sext_i64_i32(q_l_292680)) &&\n            ((local_tid_323415 - squot32(local_tid_323415, wave_sizze_323417) *\n              wave_sizze_323417) == 0 && (squot32(local_tid_323415,\n                                                  wave_sizze_323417) & (2 *\n                                                                        skip_waves_323439 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_310165 = ((__local\n                             double *) red_arr_mem_323434)[sext_i32_i64(local_tid_323415 +\n                                                           offset_323438)];\n                x_310166 = ((__local\n                             double *) red_arr_mem_323436)[sext_i32_i64(local_tid_323415 +\n                                                           offset_323438)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_310167 = x_310163 + x_310165;\n                double defunc_1_op_res_310168 = x_310164 + x_310166;\n                \n                x_310163 = defunc_1_op_res_310167;\n                x_310164 = defunc_1_op_res_310168;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_323434)[sext_i32_i64(local_tid_323415)] =\n                    x_310163;\n                ((__local\n                  double *) red_arr_mem_323436)[sext_i32_i64(local_tid_323415)] =\n          ",
            "          x_310164;\n            }\n        }\n        skip_waves_323439 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_310159 = ((__local\n                                   double *) red_arr_mem_323434)[(int64_t) 0];\n    defunc_2_reduce_res_310160 = ((__local\n                                   double *) red_arr_mem_323436)[(int64_t) 0];\n    if (local_tid_323415 == 0) {\n        ((__global double *) mem_319613)[gtid_310099 * l_n_m_292832 +\n                                         gtid_310100] =\n            defunc_2_reduce_res_310159;\n    }\n    if (local_tid_323415 == 0) {\n        ((__global double *) mem_319617)[gtid_310099 * l_n_m_292832 +\n                                         gtid_310100] =\n            defunc_2_reduce_res_310160;\n    }\n    \n  error_4:\n    return;\n}\n__kernel void mainzisegmap_intragroup_310366(__global int *global_failure,\n                                             uint red_arr_mem_323467_backing_offset_0,\n                                             uint red_arr_mem_323465_backing_offset_1,\n                                             uint red_arr_mem_323461_backing_offset_2,\n                                             uint red_arr_mem_323459_backing_offset_3,\n                                             uint red_arr_mem_323457_backing_offset_4,\n                                             uint red_arr_mem_323455_backing_offset_5,\n                                             uint red_arr_mem_323453_backing_offset_6,\n                                             uint color_320649_backing_offset_7,\n                                             uint color_320648_backing_offset_8,\n                                             uint color_320647_backing_offset_9,\n                                             uint color_320646_backing_offset_10,\n                                             int64_t n_292675,\n                                             int64_t q_l_292680,\n                                             int64_t jump_t_292",
            "685,\n                                             int64_t partition_sizze_292766,\n                                             int64_t l_n_m_292832,\n                                             int64_t i_292846,\n                                             int64_t ctx_param_ext_318833,\n                                             int64_t ctx_param_ext_318834,\n                                             int64_t ctx_param_ext_318836,\n                                             __global\n                                             unsigned char *ext_mem_318756,\n                                             __global\n                                             unsigned char *ext_mem_318757,\n                                             __global\n                                             unsigned char *mem_param_318838,\n                                             __global unsigned char *mem_319555,\n                                             __global unsigned char *mem_319637,\n                                             __global unsigned char *mem_319641)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_323467_backing_10 =\n                           &shared_mem[red_arr_mem_323467_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323465_backing_9 =\n                           &shared_mem[red_arr_mem_323465_backing_offset_1];\n    volatile unsigned char *red_arr_mem_323461_backing_8 =\n                           &shared_mem[red_arr_mem_323461_backing_offset_2];\n    volatile unsigned char *red_arr_mem_323459_backing_7 =\n                           &shared_mem[red_arr_mem_323459_backing_offset_3];\n    volatile unsigned char *red_arr_mem_323457_backing_6 =\n                           &shared_mem[red_arr_mem_323457_backing_offset_4];\n    volatile unsigned char *red_arr_mem_323455_backing_5 =\n                           &shared_mem[red_arr_mem_323455_backing_offset_5];\n    volatile unsign",
            "ed char *red_arr_mem_323453_backing_4 =\n                           &shared_mem[red_arr_mem_323453_backing_offset_6];\n    volatile unsigned char *color_320649_backing_3 =\n                           &shared_mem[color_320649_backing_offset_7];\n    volatile unsigned char *color_320648_backing_2 =\n                           &shared_mem[color_320648_backing_offset_8];\n    volatile unsigned char *color_320647_backing_1 =\n                           &shared_mem[color_320647_backing_offset_9];\n    volatile unsigned char *color_320646_backing_0 =\n                           &shared_mem[color_320646_backing_offset_10];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323441;\n    int32_t local_tid_323442;\n    int64_t group_sizze_323445;\n    int32_t wave_sizze_323444;\n    int32_t group_tid_323443;\n    \n    global_tid_323441 = get_global_id(0);\n    local_tid_323442 = get_local_id(0);\n    group_sizze_323445 = get_local_size(0);\n    wave_sizze_323444 = LOCKSTEP_WIDTH;\n    group_tid_323443 = get_group_id(0);\n    \n    int32_t phys_tid_310366 = group_tid_323443;\n    int64_t slice_323447 = q_l_292680;\n    int64_t ltid_pre_323446 = sext_i32_i64(local_tid_323442);\n    int64_t remnant_323448 = sext_i32_i64(local_tid_323442) - ltid_pre_323446;\n    int64_t slice_323449 = l_n_m_292832;\n    int64_t slice_323450 = partition_sizze_292766 * slice_323449;\n    int64_t gtid_310364 = squot64(sext_i32_i64(group_tid_323443), slice_323449);\n    int64_t remnant_323451 = sext_i32_i64(group_tid_323443) - gtid_310364 *\n            slice_323449;\n    int64_t gtid_310365 = remnant_323451;\n    int64_t remnant_323452 = remnant_323451 - gtid_310365;\n    __local unsigned char *color_320646;\n    \n    color_320646 = (__local unsigned char *) color_320646_backing_0;\n    \n    __local unsigned char *color_320647;\n    \n    color_320647 = (__local unsigned char *) color_320647_backing_1;\n    \n    __local unsigned char *color_320648;\n    \n    color_320648 = (__local unsigned char *) color_3206",
            "48_backing_2;\n    \n    __local unsigned char *color_320649;\n    \n    color_320649 = (__local unsigned char *) color_320649_backing_3;\n    \n    int64_t x_310372;\n    \n    x_310372 = ((__global int64_t *) ext_mem_318757)[gtid_310364 *\n                                                     l_n_m_292832 +\n                                                     gtid_310365];\n    \n    double x_310373;\n    \n    x_310373 = ((__global double *) ext_mem_318756)[gtid_310364 * l_n_m_292832 +\n                                                    gtid_310365];\n    \n    int64_t min_arg_310374 = mul64(jump_t_292685, gtid_310365);\n    int64_t min_res_310375 = smin64(i_292846, min_arg_310374);\n    int64_t defunc_0_g_res_310376 = add64((int64_t) 1, min_res_310375);\n    int32_t phys_tid_310380 = local_tid_323442;\n    int64_t gtid_310379 = sext_i32_i64(sext_i64_i32(ltid_pre_323446));\n    bool cond_310382 = sle64(n_292675, gtid_310379);\n    int64_t defunc_0_f_res_310383;\n    \n    if (cond_310382) {\n        defunc_0_f_res_310383 = (int64_t) 0;\n    } else {\n        int64_t i_310384 = add64(x_310372, gtid_310379);\n        int64_t defunc_1_add_res_310385 = add64((int64_t) 1, i_310384);\n        \n        defunc_0_f_res_310383 = defunc_1_add_res_310385;\n    }\n    \n    double defunc_0_f_res_310386;\n    \n    if (cond_310382) {\n        defunc_0_f_res_310386 = 0.0;\n    } else {\n        int64_t i_310387 = add64(x_310372, gtid_310379);\n        double defunc_0_add_arg_310388;\n        \n        defunc_0_add_arg_310388 = ((__global\n                                    double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                (gtid_310364 *\n                                                                 ctx_param_ext_318834 +\n                                                                 i_310387 *\n                                                                 ctx_param_ext_318836)];\n        defunc_0_f_res_310386 = defunc_0_add_arg_310388;\n    }\n    \n ",
            "   int64_t binop_p_310389 = sub64(defunc_0_f_res_310383,\n                                   defunc_0_g_res_310376);\n    double defunc_0_f_res_310390 = sitofp_i64_f64(binop_p_310389);\n    double abs_res_310391 = fabs(defunc_0_f_res_310390);\n    double tmp1_310392 = abs_res_310391 / x_310373;\n    double x_310393 = tmp1_310392 * tmp1_310392;\n    double y_310394 = tmp1_310392 * x_310393;\n    double tmp2_310395 = 1.0 - y_310394;\n    double x_310396 = tmp2_310395 * tmp2_310395;\n    double tmp3_310397 = tmp2_310395 * x_310396;\n    double tmp4_310398 = defunc_0_f_res_310386 * tmp3_310397;\n    \n    ((__local double *) color_320649)[gtid_310379] = defunc_0_f_res_310390;\n    ((__local double *) color_320648)[gtid_310379] = tmp4_310398;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    double defunc_2_reduce_res_310399;\n    double defunc_2_reduce_res_310400;\n    double defunc_2_reduce_res_310401;\n    double defunc_2_reduce_res_310402;\n    double defunc_2_reduce_res_310403;\n    int32_t phys_tid_310407 = local_tid_323442;\n    __local unsigned char *red_arr_mem_323453;\n    \n    red_arr_mem_323453 = (__local unsigned char *) red_arr_mem_323453_backing_4;\n    \n    __local unsigned char *red_arr_mem_323455;\n    \n    red_arr_mem_323455 = (__local unsigned char *) red_arr_mem_323455_backing_5;\n    \n    __local unsigned char *red_arr_mem_323457;\n    \n    red_arr_mem_323457 = (__local unsigned char *) red_arr_mem_323457_backing_6;\n    \n    __local unsigned char *red_arr_mem_323459;\n    \n    red_arr_mem_323459 = (__local unsigned char *) red_arr_mem_323459_backing_7;\n    \n    __local unsigned char *red_arr_mem_323461;\n    \n    red_arr_mem_323461 = (__local unsigned char *) red_arr_mem_323461_backing_8;\n    \n    int64_t gtid_310406 = sext_i32_i64(sext_i64_i32(ltid_pre_323446));\n    double x_310423;\n    \n    x_310423 = ((__local double *) color_320649)[gtid_310406];\n    \n    double x_310424;\n    \n    x_310424 = ((__local double *) color_320648)[gtid_310406];\n    \n    double defunc_1_f_res_310425 =",
            " x_310423 * x_310424;\n    double defunc_1_f_res_310426 = x_310423 * defunc_1_f_res_310425;\n    double defunc_1_f_res_310427 = x_310423 * defunc_1_f_res_310426;\n    double defunc_1_f_res_310428 = x_310423 * defunc_1_f_res_310427;\n    \n    ((__local double *) red_arr_mem_323453)[gtid_310406] = x_310424;\n    ((__local double *) red_arr_mem_323455)[gtid_310406] =\n        defunc_1_f_res_310425;\n    ((__local double *) red_arr_mem_323457)[gtid_310406] =\n        defunc_1_f_res_310426;\n    ((__local double *) red_arr_mem_323459)[gtid_310406] =\n        defunc_1_f_res_310427;\n    ((__local double *) red_arr_mem_323461)[gtid_310406] =\n        defunc_1_f_res_310428;\n    ((__local double *) color_320647)[gtid_310406] = defunc_1_f_res_310426;\n    ((__local double *) color_320646)[gtid_310406] = defunc_1_f_res_310425;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_323463;\n    int32_t skip_waves_323464 = 1;\n    double x_310408;\n    double x_310409;\n    double x_310410;\n    double x_310411;\n    double x_310412;\n    double x_310413;\n    double x_310414;\n    double x_310415;\n    double x_310416;\n    double x_310417;\n    \n    offset_323463 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_323442, sext_i64_i32(q_l_292680))) {\n            x_310408 = ((__local\n                         double *) red_arr_mem_323453)[sext_i32_i64(local_tid_323442 +\n                                                       offset_323463)];\n            x_310409 = ((__local\n                         double *) red_arr_mem_323455)[sext_i32_i64(local_tid_323442 +\n                                                       offset_323463)];\n            x_310410 = ((__local\n                         double *) red_arr_mem_323457)[sext_i32_i64(local_tid_323442 +\n                                                       offset_323463)];\n            x_310411 = ((__local\n                         double *) red_arr_mem_323459)[sext_i32_i64(local_tid_323442 +\n                         ",
            "                              offset_323463)];\n            x_310412 = ((__local\n                         double *) red_arr_mem_323461)[sext_i32_i64(local_tid_323442 +\n                                                       offset_323463)];\n        }\n    }\n    offset_323463 = 1;\n    while (slt32(offset_323463, wave_sizze_323444)) {\n        if (slt32(local_tid_323442 + offset_323463, sext_i64_i32(q_l_292680)) &&\n            ((local_tid_323442 - squot32(local_tid_323442, wave_sizze_323444) *\n              wave_sizze_323444) & (2 * offset_323463 - 1)) == 0) {\n            // read array element\n            {\n                x_310413 = ((volatile __local\n                             double *) red_arr_mem_323453)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323463)];\n                x_310414 = ((volatile __local\n                             double *) red_arr_mem_323455)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323463)];\n                x_310415 = ((volatile __local\n                             double *) red_arr_mem_323457)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323463)];\n                x_310416 = ((volatile __local\n                             double *) red_arr_mem_323459)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323463)];\n                x_310417 = ((volatile __local\n                             double *) red_arr_mem_323461)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323463)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_310418 = x_310408 + x_310413;\n                double defunc_1_op_res_310419 = x_310409 + x_310414;\n                double defunc_1_op_res_310420 = x_310410 + x_310415;\n                double defunc_1_op_res_310421 = x_",
            "310411 + x_310416;\n                double defunc_1_op_res_310422 = x_310412 + x_310417;\n                \n                x_310408 = defunc_1_op_res_310418;\n                x_310409 = defunc_1_op_res_310419;\n                x_310410 = defunc_1_op_res_310420;\n                x_310411 = defunc_1_op_res_310421;\n                x_310412 = defunc_1_op_res_310422;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_323453)[sext_i32_i64(local_tid_323442)] =\n                    x_310408;\n                ((volatile __local\n                  double *) red_arr_mem_323455)[sext_i32_i64(local_tid_323442)] =\n                    x_310409;\n                ((volatile __local\n                  double *) red_arr_mem_323457)[sext_i32_i64(local_tid_323442)] =\n                    x_310410;\n                ((volatile __local\n                  double *) red_arr_mem_323459)[sext_i32_i64(local_tid_323442)] =\n                    x_310411;\n                ((volatile __local\n                  double *) red_arr_mem_323461)[sext_i32_i64(local_tid_323442)] =\n                    x_310412;\n            }\n        }\n        offset_323463 *= 2;\n    }\n    while (slt32(skip_waves_323464, squot32(sext_i64_i32(q_l_292680) +\n                                            wave_sizze_323444 - 1,\n                                            wave_sizze_323444))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_323463 = skip_waves_323464 * wave_sizze_323444;\n        if (slt32(local_tid_323442 + offset_323463, sext_i64_i32(q_l_292680)) &&\n            ((local_tid_323442 - squot32(local_tid_323442, wave_sizze_323444) *\n              wave_sizze_323444) == 0 && (squot32(local_tid_323442,\n                                                  wave_sizze_323444) & (2 *\n                                                                        skip_waves_323464 -\n                                                                        1))",
            " ==\n             0)) {\n            // read array element\n            {\n                x_310413 = ((__local\n                             double *) red_arr_mem_323453)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323463)];\n                x_310414 = ((__local\n                             double *) red_arr_mem_323455)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323463)];\n                x_310415 = ((__local\n                             double *) red_arr_mem_323457)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323463)];\n                x_310416 = ((__local\n                             double *) red_arr_mem_323459)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323463)];\n                x_310417 = ((__local\n                             double *) red_arr_mem_323461)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323463)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_310418 = x_310408 + x_310413;\n                double defunc_1_op_res_310419 = x_310409 + x_310414;\n                double defunc_1_op_res_310420 = x_310410 + x_310415;\n                double defunc_1_op_res_310421 = x_310411 + x_310416;\n                double defunc_1_op_res_310422 = x_310412 + x_310417;\n                \n                x_310408 = defunc_1_op_res_310418;\n                x_310409 = defunc_1_op_res_310419;\n                x_310410 = defunc_1_op_res_310420;\n                x_310411 = defunc_1_op_res_310421;\n                x_310412 = defunc_1_op_res_310422;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_323453)[sext_i32_i64(local_tid_323442)] =\n                    x_310408;\n                ",
            "((__local\n                  double *) red_arr_mem_323455)[sext_i32_i64(local_tid_323442)] =\n                    x_310409;\n                ((__local\n                  double *) red_arr_mem_323457)[sext_i32_i64(local_tid_323442)] =\n                    x_310410;\n                ((__local\n                  double *) red_arr_mem_323459)[sext_i32_i64(local_tid_323442)] =\n                    x_310411;\n                ((__local\n                  double *) red_arr_mem_323461)[sext_i32_i64(local_tid_323442)] =\n                    x_310412;\n            }\n        }\n        skip_waves_323464 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_310399 = ((__local\n                                   double *) red_arr_mem_323453)[(int64_t) 0];\n    defunc_2_reduce_res_310400 = ((__local\n                                   double *) red_arr_mem_323455)[(int64_t) 0];\n    defunc_2_reduce_res_310401 = ((__local\n                                   double *) red_arr_mem_323457)[(int64_t) 0];\n    defunc_2_reduce_res_310402 = ((__local\n                                   double *) red_arr_mem_323459)[(int64_t) 0];\n    defunc_2_reduce_res_310403 = ((__local\n                                   double *) red_arr_mem_323461)[(int64_t) 0];\n    \n    double a_310429 = 2.220446049250313e-16 + defunc_2_reduce_res_310399;\n    double b_310430 = 2.220446049250313e-16 + defunc_2_reduce_res_310400;\n    double c_310431 = 2.220446049250313e-16 + defunc_2_reduce_res_310401;\n    double d_310432 = 2.220446049250313e-16 + defunc_2_reduce_res_310402;\n    double e_310433 = 2.220446049250313e-16 + defunc_2_reduce_res_310403;\n    double x_310434 = c_310431 * e_310433;\n    double y_310435 = d_310432 * d_310432;\n    double a12_310436 = x_310434 - y_310435;\n    double x_310437 = c_310431 * d_310432;\n    double y_310438 = b_310430 * e_310433;\n    double b12_310439 = x_310437 - y_310438;\n    double x_310440 = b_310430 * d_310432;\n    double y_310441 = c_310431 * c_310431;\n    double c12_310442 = x_310440 - ",
            "y_310441;\n    double x_310443 = a_310429 * e_310433;\n    double b2_310444 = x_310443 - y_310441;\n    double x_310445 = b_310430 * c_310431;\n    double y_310446 = a_310429 * d_310432;\n    double c2_310447 = x_310445 - y_310446;\n    double x_310448 = a_310429 * a12_310436;\n    double y_310449 = b_310430 * b12_310439;\n    double x_310450 = x_310448 + y_310449;\n    double y_310451 = c_310431 * c12_310442;\n    double y_310452 = x_310450 + y_310451;\n    double det_310453 = 1.0 / y_310452;\n    double a12_310454 = a12_310436 * det_310453;\n    double b12_310455 = b12_310439 * det_310453;\n    double c12_310456 = c12_310442 * det_310453;\n    double b2_310457 = b2_310444 * det_310453;\n    double c2_310458 = c2_310447 * det_310453;\n    double defunc_2_reduce_res_310459;\n    double defunc_2_reduce_res_310460;\n    int32_t phys_tid_310462 = local_tid_323442;\n    __local unsigned char *red_arr_mem_323465;\n    \n    red_arr_mem_323465 = (__local unsigned char *) red_arr_mem_323465_backing_9;\n    \n    __local unsigned char *red_arr_mem_323467;\n    \n    red_arr_mem_323467 = (__local\n                          unsigned char *) red_arr_mem_323467_backing_10;\n    \n    int64_t gtid_310461 = sext_i32_i64(sext_i64_i32(ltid_pre_323446));\n    double x_310470;\n    \n    x_310470 = ((__local double *) color_320648)[gtid_310461];\n    \n    double x_310471;\n    \n    x_310471 = ((__local double *) color_320646)[gtid_310461];\n    \n    double x_310472;\n    \n    x_310472 = ((__local double *) color_320647)[gtid_310461];\n    \n    bool cond_310473 = sle64(n_292675, gtid_310461);\n    double defunc_0_f_res_310474;\n    \n    if (cond_310473) {\n        defunc_0_f_res_310474 = 0.0;\n    } else {\n        int64_t i_310475 = add64(x_310372, gtid_310461);\n        double defunc_0_add_arg_310476;\n        \n        defunc_0_add_arg_310476 = ((__global double *) mem_319555)[gtid_310364 *\n                                                                   n_292675 +\n                                                           ",
            "        i_310475];\n        defunc_0_f_res_310474 = defunc_0_add_arg_310476;\n    }\n    \n    double x_310477 = a12_310454 * x_310470;\n    double y_310478 = b12_310455 * x_310471;\n    double x_310479 = x_310477 + y_310478;\n    double y_310480 = c12_310456 * x_310472;\n    double x_310481 = x_310479 + y_310480;\n    double defunc_9_fit_fun_res_310482 = defunc_0_f_res_310474 * x_310481;\n    double x_310483 = b12_310455 * x_310470;\n    double y_310484 = b2_310457 * x_310471;\n    double x_310485 = x_310483 + y_310484;\n    double y_310486 = c2_310458 * x_310472;\n    double x_310487 = x_310485 + y_310486;\n    double defunc_9_slope_fun_res_310488 = defunc_0_f_res_310474 * x_310487;\n    \n    ((__local double *) red_arr_mem_323465)[gtid_310461] =\n        defunc_9_fit_fun_res_310482;\n    ((__local double *) red_arr_mem_323467)[gtid_310461] =\n        defunc_9_slope_fun_res_310488;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_323469;\n    int32_t skip_waves_323470 = 1;\n    double x_310463;\n    double x_310464;\n    double x_310465;\n    double x_310466;\n    \n    offset_323469 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_323442, sext_i64_i32(q_l_292680))) {\n            x_310463 = ((__local\n                         double *) red_arr_mem_323465)[sext_i32_i64(local_tid_323442 +\n                                                       offset_323469)];\n            x_310464 = ((__local\n                         double *) red_arr_mem_323467)[sext_i32_i64(local_tid_323442 +\n                                                       offset_323469)];\n        }\n    }\n    offset_323469 = 1;\n    while (slt32(offset_323469, wave_sizze_323444)) {\n        if (slt32(local_tid_323442 + offset_323469, sext_i64_i32(q_l_292680)) &&\n            ((local_tid_323442 - squot32(local_tid_323442, wave_sizze_323444) *\n              wave_sizze_323444) & (2 * offset_323469 - 1)) == 0) {\n            // read array element\n            {\n                x_310465 = ((v",
            "olatile __local\n                             double *) red_arr_mem_323465)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323469)];\n                x_310466 = ((volatile __local\n                             double *) red_arr_mem_323467)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323469)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_310467 = x_310463 + x_310465;\n                double defunc_1_op_res_310468 = x_310464 + x_310466;\n                \n                x_310463 = defunc_1_op_res_310467;\n                x_310464 = defunc_1_op_res_310468;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_323465)[sext_i32_i64(local_tid_323442)] =\n                    x_310463;\n                ((volatile __local\n                  double *) red_arr_mem_323467)[sext_i32_i64(local_tid_323442)] =\n                    x_310464;\n            }\n        }\n        offset_323469 *= 2;\n    }\n    while (slt32(skip_waves_323470, squot32(sext_i64_i32(q_l_292680) +\n                                            wave_sizze_323444 - 1,\n                                            wave_sizze_323444))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_323469 = skip_waves_323470 * wave_sizze_323444;\n        if (slt32(local_tid_323442 + offset_323469, sext_i64_i32(q_l_292680)) &&\n            ((local_tid_323442 - squot32(local_tid_323442, wave_sizze_323444) *\n              wave_sizze_323444) == 0 && (squot32(local_tid_323442,\n                                                  wave_sizze_323444) & (2 *\n                                                                        skip_waves_323470 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n        ",
            "        x_310465 = ((__local\n                             double *) red_arr_mem_323465)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323469)];\n                x_310466 = ((__local\n                             double *) red_arr_mem_323467)[sext_i32_i64(local_tid_323442 +\n                                                           offset_323469)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_310467 = x_310463 + x_310465;\n                double defunc_1_op_res_310468 = x_310464 + x_310466;\n                \n                x_310463 = defunc_1_op_res_310467;\n                x_310464 = defunc_1_op_res_310468;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_323465)[sext_i32_i64(local_tid_323442)] =\n                    x_310463;\n                ((__local\n                  double *) red_arr_mem_323467)[sext_i32_i64(local_tid_323442)] =\n                    x_310464;\n            }\n        }\n        skip_waves_323470 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_310459 = ((__local\n                                   double *) red_arr_mem_323465)[(int64_t) 0];\n    defunc_2_reduce_res_310460 = ((__local\n                                   double *) red_arr_mem_323467)[(int64_t) 0];\n    if (local_tid_323442 == 0) {\n        ((__global double *) mem_319637)[gtid_310364 * l_n_m_292832 +\n                                         gtid_310365] =\n            defunc_2_reduce_res_310459;\n    }\n    if (local_tid_323442 == 0) {\n        ((__global double *) mem_319641)[gtid_310364 * l_n_m_292832 +\n                                         gtid_310365] =\n            defunc_2_reduce_res_310460;\n    }\n    \n  error_5:\n    return;\n}\n__kernel void mainzisegmap_intragroup_313503(__global int *global_failure,\n                                             uint red_arr_mem_324212_backi",
            "ng_offset_0,\n                                             uint red_arr_mem_324208_backing_offset_1,\n                                             uint color_320650_backing_offset_2,\n                                             int64_t n_292675,\n                                             int64_t q_t_292679,\n                                             int64_t jump_t_292685,\n                                             int64_t partition_sizze_292766,\n                                             int64_t t_n_m_292839,\n                                             int64_t i_292846, __global\n                                             unsigned char *ext_mem_318541,\n                                             __global\n                                             unsigned char *ext_mem_318542,\n                                             __global\n                                             unsigned char *ext_mem_318805,\n                                             __global\n                                             unsigned char *ext_mem_318806,\n                                             __global unsigned char *mem_319857,\n                                             __global unsigned char *mem_319861,\n                                             __global unsigned char *mem_319871)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_324212_backing_2 =\n                           &shared_mem[red_arr_mem_324212_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324208_backing_1 =\n                           &shared_mem[red_arr_mem_324208_backing_offset_1];\n    volatile unsigned char *color_320650_backing_0 =\n                           &shared_mem[color_320650_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324196;\n    int32_t local_tid_324197;\n    int64_t group_sizze_324200;\n    int32_t wave_sizze_324199;\n    int32_t group_tid_324198;\n",
            "    \n    global_tid_324196 = get_global_id(0);\n    local_tid_324197 = get_local_id(0);\n    group_sizze_324200 = get_local_size(0);\n    wave_sizze_324199 = LOCKSTEP_WIDTH;\n    group_tid_324198 = get_group_id(0);\n    \n    int32_t phys_tid_313503 = group_tid_324198;\n    int64_t slice_324202 = q_t_292679;\n    int64_t ltid_pre_324201 = sext_i32_i64(local_tid_324197);\n    int64_t remnant_324203 = sext_i32_i64(local_tid_324197) - ltid_pre_324201;\n    int64_t slice_324204 = t_n_m_292839;\n    int64_t slice_324205 = partition_sizze_292766 * slice_324204;\n    int64_t gtid_313501 = squot64(sext_i32_i64(group_tid_324198), slice_324204);\n    int64_t remnant_324206 = sext_i32_i64(group_tid_324198) - gtid_313501 *\n            slice_324204;\n    int64_t gtid_313502 = remnant_324206;\n    int64_t remnant_324207 = remnant_324206 - gtid_313502;\n    __local unsigned char *color_320650;\n    \n    color_320650 = (__local unsigned char *) color_320650_backing_0;\n    \n    int64_t x_313506;\n    \n    x_313506 = ((__global int64_t *) ext_mem_318541)[gtid_313501];\n    \n    int64_t x_313512;\n    \n    x_313512 = ((__global int64_t *) ext_mem_318806)[gtid_313501 *\n                                                     t_n_m_292839 +\n                                                     gtid_313502];\n    \n    double x_313513;\n    \n    x_313513 = ((__global double *) ext_mem_318805)[gtid_313501 * t_n_m_292839 +\n                                                    gtid_313502];\n    \n    int64_t min_arg_313514 = mul64(jump_t_292685, gtid_313502);\n    int64_t min_res_313515 = smin64(i_292846, min_arg_313514);\n    int64_t defunc_0_g_res_313516 = add64((int64_t) 1, min_res_313515);\n    double defunc_2_reduce_res_313517;\n    int32_t phys_tid_313520 = local_tid_324197;\n    __local unsigned char *red_arr_mem_324208;\n    \n    red_arr_mem_324208 = (__local unsigned char *) red_arr_mem_324208_backing_1;\n    \n    int64_t gtid_313519 = sext_i32_i64(sext_i64_i32(ltid_pre_324201));\n    bool cond_313525 = sle64(x_313506, ",
            "gtid_313519);\n    int64_t defunc_0_f_res_313526;\n    \n    if (cond_313525) {\n        defunc_0_f_res_313526 = (int64_t) 0;\n    } else {\n        int64_t i_313527 = add64(x_313512, gtid_313519);\n        int64_t defunc_0_add_arg_313528;\n        \n        defunc_0_add_arg_313528 = ((__global\n                                    int64_t *) ext_mem_318542)[gtid_313501 *\n                                                               n_292675 +\n                                                               i_313527];\n        \n        int64_t defunc_1_add_res_313529 = add64((int64_t) 1,\n                                                defunc_0_add_arg_313528);\n        \n        defunc_0_f_res_313526 = defunc_1_add_res_313529;\n    }\n    \n    double defunc_0_f_res_313530;\n    \n    if (cond_313525) {\n        defunc_0_f_res_313530 = 0.0;\n    } else {\n        int64_t i_313531 = add64(x_313512, gtid_313519);\n        double defunc_0_add_arg_313532;\n        \n        defunc_0_add_arg_313532 = ((__global double *) mem_319857)[gtid_313501 *\n                                                                   n_292675 +\n                                                                   i_313531];\n        defunc_0_f_res_313530 = defunc_0_add_arg_313532;\n    }\n    \n    int64_t binop_p_313533 = sub64(defunc_0_f_res_313526,\n                                   defunc_0_g_res_313516);\n    double defunc_0_f_res_313534 = sitofp_i64_f64(binop_p_313533);\n    double abs_res_313535 = fabs(defunc_0_f_res_313534);\n    double tmp1_313536 = abs_res_313535 / x_313513;\n    double x_313537 = tmp1_313536 * tmp1_313536;\n    double y_313538 = tmp1_313536 * x_313537;\n    double tmp2_313539 = 1.0 - y_313538;\n    double x_313540 = tmp2_313539 * tmp2_313539;\n    double tmp3_313541 = tmp2_313539 * x_313540;\n    double tmp4_313542 = defunc_0_f_res_313530 * tmp3_313541;\n    \n    ((__local double *) red_arr_mem_324208)[gtid_313519] = tmp4_313542;\n    ((__local double *) color_320650)[gtid_313519] = tmp4_313542;\n    barrier(",
            "CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_324210;\n    int32_t skip_waves_324211 = 1;\n    double x_313521;\n    double x_313522;\n    \n    offset_324210 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_324197, sext_i64_i32(q_t_292679))) {\n            x_313521 = ((__local\n                         double *) red_arr_mem_324208)[sext_i32_i64(local_tid_324197 +\n                                                       offset_324210)];\n        }\n    }\n    offset_324210 = 1;\n    while (slt32(offset_324210, wave_sizze_324199)) {\n        if (slt32(local_tid_324197 + offset_324210, sext_i64_i32(q_t_292679)) &&\n            ((local_tid_324197 - squot32(local_tid_324197, wave_sizze_324199) *\n              wave_sizze_324199) & (2 * offset_324210 - 1)) == 0) {\n            // read array element\n            {\n                x_313522 = ((volatile __local\n                             double *) red_arr_mem_324208)[sext_i32_i64(local_tid_324197 +\n                                                           offset_324210)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_313523 = x_313521 + x_313522;\n                \n                x_313521 = defunc_1_op_res_313523;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_324208)[sext_i32_i64(local_tid_324197)] =\n                    x_313521;\n            }\n        }\n        offset_324210 *= 2;\n    }\n    while (slt32(skip_waves_324211, squot32(sext_i64_i32(q_t_292679) +\n                                            wave_sizze_324199 - 1,\n                                            wave_sizze_324199))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_324210 = skip_waves_324211 * wave_sizze_324199;\n        if (slt32(local_tid_324197 + offset_324210, sext_i64_i32(q_t_292679)) &&\n            ((local_tid_324197 - squot32(local_tid_324197, wave_sizze_3241",
            "99) *\n              wave_sizze_324199) == 0 && (squot32(local_tid_324197,\n                                                  wave_sizze_324199) & (2 *\n                                                                        skip_waves_324211 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_313522 = ((__local\n                             double *) red_arr_mem_324208)[sext_i32_i64(local_tid_324197 +\n                                                           offset_324210)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_313523 = x_313521 + x_313522;\n                \n                x_313521 = defunc_1_op_res_313523;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_324208)[sext_i32_i64(local_tid_324197)] =\n                    x_313521;\n            }\n        }\n        skip_waves_324211 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_313517 = ((__local\n                                   double *) red_arr_mem_324208)[(int64_t) 0];\n    \n    double a_313543 = 2.220446049250313e-16 + defunc_2_reduce_res_313517;\n    double a0_313544 = 1.0 / a_313543;\n    double defunc_2_reduce_res_313545;\n    int32_t phys_tid_313547 = local_tid_324197;\n    __local unsigned char *red_arr_mem_324212;\n    \n    red_arr_mem_324212 = (__local unsigned char *) red_arr_mem_324212_backing_2;\n    \n    int64_t gtid_313546 = sext_i32_i64(sext_i64_i32(ltid_pre_324201));\n    double x_313552;\n    \n    x_313552 = ((__local double *) color_320650)[gtid_313546];\n    \n    bool cond_313553 = sle64(x_313506, gtid_313546);\n    double defunc_0_f_res_313554;\n    \n    if (cond_313553) {\n        defunc_0_f_res_313554 = 0.0;\n    } else {\n        int64_t i_313555 = add64(x_313512, gtid_313546);\n        double defunc_0_add_arg_313556;\n       ",
            " \n        defunc_0_add_arg_313556 = ((__global double *) mem_319861)[gtid_313501 *\n                                                                   n_292675 +\n                                                                   i_313555];\n        defunc_0_f_res_313554 = defunc_0_add_arg_313556;\n    }\n    \n    double x_313557 = a0_313544 * x_313552;\n    double defunc_9_fit_fun_res_313558 = defunc_0_f_res_313554 * x_313557;\n    \n    ((__local double *) red_arr_mem_324212)[gtid_313546] =\n        defunc_9_fit_fun_res_313558;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_324214;\n    int32_t skip_waves_324215 = 1;\n    double x_313548;\n    double x_313549;\n    \n    offset_324214 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_324197, sext_i64_i32(q_t_292679))) {\n            x_313548 = ((__local\n                         double *) red_arr_mem_324212)[sext_i32_i64(local_tid_324197 +\n                                                       offset_324214)];\n        }\n    }\n    offset_324214 = 1;\n    while (slt32(offset_324214, wave_sizze_324199)) {\n        if (slt32(local_tid_324197 + offset_324214, sext_i64_i32(q_t_292679)) &&\n            ((local_tid_324197 - squot32(local_tid_324197, wave_sizze_324199) *\n              wave_sizze_324199) & (2 * offset_324214 - 1)) == 0) {\n            // read array element\n            {\n                x_313549 = ((volatile __local\n                             double *) red_arr_mem_324212)[sext_i32_i64(local_tid_324197 +\n                                                           offset_324214)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_313550 = x_313548 + x_313549;\n                \n                x_313548 = defunc_1_op_res_313550;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_324212)[sext_i32_i64(local_tid_324197)] =\n          ",
            "          x_313548;\n            }\n        }\n        offset_324214 *= 2;\n    }\n    while (slt32(skip_waves_324215, squot32(sext_i64_i32(q_t_292679) +\n                                            wave_sizze_324199 - 1,\n                                            wave_sizze_324199))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_324214 = skip_waves_324215 * wave_sizze_324199;\n        if (slt32(local_tid_324197 + offset_324214, sext_i64_i32(q_t_292679)) &&\n            ((local_tid_324197 - squot32(local_tid_324197, wave_sizze_324199) *\n              wave_sizze_324199) == 0 && (squot32(local_tid_324197,\n                                                  wave_sizze_324199) & (2 *\n                                                                        skip_waves_324215 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_313549 = ((__local\n                             double *) red_arr_mem_324212)[sext_i32_i64(local_tid_324197 +\n                                                           offset_324214)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_313550 = x_313548 + x_313549;\n                \n                x_313548 = defunc_1_op_res_313550;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_324212)[sext_i32_i64(local_tid_324197)] =\n                    x_313548;\n            }\n        }\n        skip_waves_324215 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_313545 = ((__local\n                                   double *) red_arr_mem_324212)[(int64_t) 0];\n    if (local_tid_324197 == 0) {\n        ((__global double *) mem_319871)[gtid_313501 * t_n_m_292839 +\n                                         gtid_313502] =\n            defunc_2_reduce_res_313545;\n    }\n    \n  error_4:\n    return;\n}\n__k",
            "ernel void mainzisegmap_intragroup_313823(__global int *global_failure,\n                                             uint red_arr_mem_324259_backing_offset_0,\n                                             uint red_arr_mem_324257_backing_offset_1,\n                                             uint red_arr_mem_324253_backing_offset_2,\n                                             uint red_arr_mem_324251_backing_offset_3,\n                                             uint red_arr_mem_324249_backing_offset_4,\n                                             uint color_320652_backing_offset_5,\n                                             uint color_320651_backing_offset_6,\n                                             int64_t n_292675,\n                                             int64_t q_t_292679,\n                                             int64_t jump_t_292685,\n                                             int64_t partition_sizze_292766,\n                                             int64_t t_n_m_292839,\n                                             int64_t i_292846, __global\n                                             unsigned char *ext_mem_318541,\n                                             __global\n                                             unsigned char *ext_mem_318542,\n                                             __global\n                                             unsigned char *ext_mem_318805,\n                                             __global\n                                             unsigned char *ext_mem_318806,\n                                             __global unsigned char *mem_319881,\n                                             __global unsigned char *mem_319885,\n                                             __global unsigned char *mem_319898,\n                                             __global unsigned char *mem_319902)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_m",
            "em_324259_backing_6 =\n                           &shared_mem[red_arr_mem_324259_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324257_backing_5 =\n                           &shared_mem[red_arr_mem_324257_backing_offset_1];\n    volatile unsigned char *red_arr_mem_324253_backing_4 =\n                           &shared_mem[red_arr_mem_324253_backing_offset_2];\n    volatile unsigned char *red_arr_mem_324251_backing_3 =\n                           &shared_mem[red_arr_mem_324251_backing_offset_3];\n    volatile unsigned char *red_arr_mem_324249_backing_2 =\n                           &shared_mem[red_arr_mem_324249_backing_offset_4];\n    volatile unsigned char *color_320652_backing_1 =\n                           &shared_mem[color_320652_backing_offset_5];\n    volatile unsigned char *color_320651_backing_0 =\n                           &shared_mem[color_320651_backing_offset_6];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324237;\n    int32_t local_tid_324238;\n    int64_t group_sizze_324241;\n    int32_t wave_sizze_324240;\n    int32_t group_tid_324239;\n    \n    global_tid_324237 = get_global_id(0);\n    local_tid_324238 = get_local_id(0);\n    group_sizze_324241 = get_local_size(0);\n    wave_sizze_324240 = LOCKSTEP_WIDTH;\n    group_tid_324239 = get_group_id(0);\n    \n    int32_t phys_tid_313823 = group_tid_324239;\n    int64_t slice_324243 = q_t_292679;\n    int64_t ltid_pre_324242 = sext_i32_i64(local_tid_324238);\n    int64_t remnant_324244 = sext_i32_i64(local_tid_324238) - ltid_pre_324242;\n    int64_t slice_324245 = t_n_m_292839;\n    int64_t slice_324246 = partition_sizze_292766 * slice_324245;\n    int64_t gtid_313821 = squot64(sext_i32_i64(group_tid_324239), slice_324245);\n    int64_t remnant_324247 = sext_i32_i64(group_tid_324239) - gtid_313821 *\n            slice_324245;\n    int64_t gtid_313822 = remnant_324247;\n    int64_t remnant_324248 = remnant_324247 - gtid_313822;\n    __local unsigned char *color_320651;\n    \n    color_320651 =",
            " (__local unsigned char *) color_320651_backing_0;\n    \n    __local unsigned char *color_320652;\n    \n    color_320652 = (__local unsigned char *) color_320652_backing_1;\n    \n    int64_t x_313826;\n    \n    x_313826 = ((__global int64_t *) ext_mem_318541)[gtid_313821];\n    \n    int64_t x_313832;\n    \n    x_313832 = ((__global int64_t *) ext_mem_318806)[gtid_313821 *\n                                                     t_n_m_292839 +\n                                                     gtid_313822];\n    \n    double x_313833;\n    \n    x_313833 = ((__global double *) ext_mem_318805)[gtid_313821 * t_n_m_292839 +\n                                                    gtid_313822];\n    \n    int64_t min_arg_313834 = mul64(jump_t_292685, gtid_313822);\n    int64_t min_res_313835 = smin64(i_292846, min_arg_313834);\n    int64_t defunc_0_g_res_313836 = add64((int64_t) 1, min_res_313835);\n    double defunc_2_reduce_res_313837;\n    double defunc_2_reduce_res_313838;\n    double defunc_2_reduce_res_313839;\n    int32_t phys_tid_313843 = local_tid_324238;\n    __local unsigned char *red_arr_mem_324249;\n    \n    red_arr_mem_324249 = (__local unsigned char *) red_arr_mem_324249_backing_2;\n    \n    __local unsigned char *red_arr_mem_324251;\n    \n    red_arr_mem_324251 = (__local unsigned char *) red_arr_mem_324251_backing_3;\n    \n    __local unsigned char *red_arr_mem_324253;\n    \n    red_arr_mem_324253 = (__local unsigned char *) red_arr_mem_324253_backing_4;\n    \n    int64_t gtid_313842 = sext_i32_i64(sext_i64_i32(ltid_pre_324242));\n    bool cond_313854 = sle64(x_313826, gtid_313842);\n    int64_t defunc_0_f_res_313855;\n    \n    if (cond_313854) {\n        defunc_0_f_res_313855 = (int64_t) 0;\n    } else {\n        int64_t i_313856 = add64(x_313832, gtid_313842);\n        int64_t defunc_0_add_arg_313857;\n        \n        defunc_0_add_arg_313857 = ((__global\n                                    int64_t *) ext_mem_318542)[gtid_313821 *\n                                                             ",
            "  n_292675 +\n                                                               i_313856];\n        \n        int64_t defunc_1_add_res_313858 = add64((int64_t) 1,\n                                                defunc_0_add_arg_313857);\n        \n        defunc_0_f_res_313855 = defunc_1_add_res_313858;\n    }\n    \n    double defunc_0_f_res_313859;\n    \n    if (cond_313854) {\n        defunc_0_f_res_313859 = 0.0;\n    } else {\n        int64_t i_313860 = add64(x_313832, gtid_313842);\n        double defunc_0_add_arg_313861;\n        \n        defunc_0_add_arg_313861 = ((__global double *) mem_319881)[gtid_313821 *\n                                                                   n_292675 +\n                                                                   i_313860];\n        defunc_0_f_res_313859 = defunc_0_add_arg_313861;\n    }\n    \n    int64_t binop_p_313862 = sub64(defunc_0_f_res_313855,\n                                   defunc_0_g_res_313836);\n    double defunc_0_f_res_313863 = sitofp_i64_f64(binop_p_313862);\n    double abs_res_313864 = fabs(defunc_0_f_res_313863);\n    double tmp1_313865 = abs_res_313864 / x_313833;\n    double x_313866 = tmp1_313865 * tmp1_313865;\n    double y_313867 = tmp1_313865 * x_313866;\n    double tmp2_313868 = 1.0 - y_313867;\n    double x_313869 = tmp2_313868 * tmp2_313868;\n    double tmp3_313870 = tmp2_313868 * x_313869;\n    double tmp4_313871 = defunc_0_f_res_313859 * tmp3_313870;\n    double defunc_1_f_res_313872 = defunc_0_f_res_313863 * tmp4_313871;\n    double defunc_1_f_res_313873 = defunc_0_f_res_313863 *\n           defunc_1_f_res_313872;\n    \n    ((__local double *) red_arr_mem_324249)[gtid_313842] = tmp4_313871;\n    ((__local double *) red_arr_mem_324251)[gtid_313842] =\n        defunc_1_f_res_313872;\n    ((__local double *) red_arr_mem_324253)[gtid_313842] =\n        defunc_1_f_res_313873;\n    ((__local double *) color_320652)[gtid_313842] = defunc_1_f_res_313872;\n    ((__local double *) color_320651)[gtid_313842] = tmp4_313871;\n    barrier(CLK_",
            "LOCAL_MEM_FENCE);\n    \n    int32_t offset_324255;\n    int32_t skip_waves_324256 = 1;\n    double x_313844;\n    double x_313845;\n    double x_313846;\n    double x_313847;\n    double x_313848;\n    double x_313849;\n    \n    offset_324255 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_324238, sext_i64_i32(q_t_292679))) {\n            x_313844 = ((__local\n                         double *) red_arr_mem_324249)[sext_i32_i64(local_tid_324238 +\n                                                       offset_324255)];\n            x_313845 = ((__local\n                         double *) red_arr_mem_324251)[sext_i32_i64(local_tid_324238 +\n                                                       offset_324255)];\n            x_313846 = ((__local\n                         double *) red_arr_mem_324253)[sext_i32_i64(local_tid_324238 +\n                                                       offset_324255)];\n        }\n    }\n    offset_324255 = 1;\n    while (slt32(offset_324255, wave_sizze_324240)) {\n        if (slt32(local_tid_324238 + offset_324255, sext_i64_i32(q_t_292679)) &&\n            ((local_tid_324238 - squot32(local_tid_324238, wave_sizze_324240) *\n              wave_sizze_324240) & (2 * offset_324255 - 1)) == 0) {\n            // read array element\n            {\n                x_313847 = ((volatile __local\n                             double *) red_arr_mem_324249)[sext_i32_i64(local_tid_324238 +\n                                                           offset_324255)];\n                x_313848 = ((volatile __local\n                             double *) red_arr_mem_324251)[sext_i32_i64(local_tid_324238 +\n                                                           offset_324255)];\n                x_313849 = ((volatile __local\n                             double *) red_arr_mem_324253)[sext_i32_i64(local_tid_324238 +\n                                                           offset_324255)];\n            }\n            // apply reduction operat",
            "ion\n            {\n                double defunc_1_op_res_313850 = x_313844 + x_313847;\n                double defunc_1_op_res_313851 = x_313845 + x_313848;\n                double defunc_1_op_res_313852 = x_313846 + x_313849;\n                \n                x_313844 = defunc_1_op_res_313850;\n                x_313845 = defunc_1_op_res_313851;\n                x_313846 = defunc_1_op_res_313852;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_324249)[sext_i32_i64(local_tid_324238)] =\n                    x_313844;\n                ((volatile __local\n                  double *) red_arr_mem_324251)[sext_i32_i64(local_tid_324238)] =\n                    x_313845;\n                ((volatile __local\n                  double *) red_arr_mem_324253)[sext_i32_i64(local_tid_324238)] =\n                    x_313846;\n            }\n        }\n        offset_324255 *= 2;\n    }\n    while (slt32(skip_waves_324256, squot32(sext_i64_i32(q_t_292679) +\n                                            wave_sizze_324240 - 1,\n                                            wave_sizze_324240))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_324255 = skip_waves_324256 * wave_sizze_324240;\n        if (slt32(local_tid_324238 + offset_324255, sext_i64_i32(q_t_292679)) &&\n            ((local_tid_324238 - squot32(local_tid_324238, wave_sizze_324240) *\n              wave_sizze_324240) == 0 && (squot32(local_tid_324238,\n                                                  wave_sizze_324240) & (2 *\n                                                                        skip_waves_324256 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_313847 = ((__local\n                             double *) red_arr_mem_324249)[sext_i32_i64(local_tid_324238 +\n                                                           o",
            "ffset_324255)];\n                x_313848 = ((__local\n                             double *) red_arr_mem_324251)[sext_i32_i64(local_tid_324238 +\n                                                           offset_324255)];\n                x_313849 = ((__local\n                             double *) red_arr_mem_324253)[sext_i32_i64(local_tid_324238 +\n                                                           offset_324255)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_313850 = x_313844 + x_313847;\n                double defunc_1_op_res_313851 = x_313845 + x_313848;\n                double defunc_1_op_res_313852 = x_313846 + x_313849;\n                \n                x_313844 = defunc_1_op_res_313850;\n                x_313845 = defunc_1_op_res_313851;\n                x_313846 = defunc_1_op_res_313852;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_324249)[sext_i32_i64(local_tid_324238)] =\n                    x_313844;\n                ((__local\n                  double *) red_arr_mem_324251)[sext_i32_i64(local_tid_324238)] =\n                    x_313845;\n                ((__local\n                  double *) red_arr_mem_324253)[sext_i32_i64(local_tid_324238)] =\n                    x_313846;\n            }\n        }\n        skip_waves_324256 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_313837 = ((__local\n                                   double *) red_arr_mem_324249)[(int64_t) 0];\n    defunc_2_reduce_res_313838 = ((__local\n                                   double *) red_arr_mem_324251)[(int64_t) 0];\n    defunc_2_reduce_res_313839 = ((__local\n                                   double *) red_arr_mem_324253)[(int64_t) 0];\n    \n    double a_313874 = 2.220446049250313e-16 + defunc_2_reduce_res_313837;\n    double b_313875 = 2.220446049250313e-16 + defunc_2_reduce_res_313838;\n    double c_313876 = 2.22044604",
            "9250313e-16 + defunc_2_reduce_res_313839;\n    double x_313877 = a_313874 * c_313876;\n    double y_313878 = b_313875 * b_313875;\n    double y_313879 = x_313877 - y_313878;\n    double det1_313880 = 1.0 / y_313879;\n    double a11_313881 = c_313876 * det1_313880;\n    double x_313882 = 0.0 - b_313875;\n    double b11_313883 = det1_313880 * x_313882;\n    double c11_313884 = a_313874 * det1_313880;\n    double defunc_2_reduce_res_313885;\n    double defunc_2_reduce_res_313886;\n    int32_t phys_tid_313888 = local_tid_324238;\n    __local unsigned char *red_arr_mem_324257;\n    \n    red_arr_mem_324257 = (__local unsigned char *) red_arr_mem_324257_backing_5;\n    \n    __local unsigned char *red_arr_mem_324259;\n    \n    red_arr_mem_324259 = (__local unsigned char *) red_arr_mem_324259_backing_6;\n    \n    int64_t gtid_313887 = sext_i32_i64(sext_i64_i32(ltid_pre_324242));\n    double x_313896;\n    \n    x_313896 = ((__local double *) color_320651)[gtid_313887];\n    \n    double x_313897;\n    \n    x_313897 = ((__local double *) color_320652)[gtid_313887];\n    \n    bool cond_313898 = sle64(x_313826, gtid_313887);\n    double defunc_0_f_res_313899;\n    \n    if (cond_313898) {\n        defunc_0_f_res_313899 = 0.0;\n    } else {\n        int64_t i_313900 = add64(x_313832, gtid_313887);\n        double defunc_0_add_arg_313901;\n        \n        defunc_0_add_arg_313901 = ((__global double *) mem_319885)[gtid_313821 *\n                                                                   n_292675 +\n                                                                   i_313900];\n        defunc_0_f_res_313899 = defunc_0_add_arg_313901;\n    }\n    \n    double x_313902 = a11_313881 * x_313896;\n    double y_313903 = b11_313883 * x_313897;\n    double x_313904 = x_313902 + y_313903;\n    double defunc_9_fit_fun_res_313905 = defunc_0_f_res_313899 * x_313904;\n    double x_313906 = b11_313883 * x_313896;\n    double y_313907 = c11_313884 * x_313897;\n    double x_313908 = x_313906 + y_313907;\n    double defunc_9_slope_fu",
            "n_res_313909 = defunc_0_f_res_313899 * x_313908;\n    \n    ((__local double *) red_arr_mem_324257)[gtid_313887] =\n        defunc_9_fit_fun_res_313905;\n    ((__local double *) red_arr_mem_324259)[gtid_313887] =\n        defunc_9_slope_fun_res_313909;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_324261;\n    int32_t skip_waves_324262 = 1;\n    double x_313889;\n    double x_313890;\n    double x_313891;\n    double x_313892;\n    \n    offset_324261 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_324238, sext_i64_i32(q_t_292679))) {\n            x_313889 = ((__local\n                         double *) red_arr_mem_324257)[sext_i32_i64(local_tid_324238 +\n                                                       offset_324261)];\n            x_313890 = ((__local\n                         double *) red_arr_mem_324259)[sext_i32_i64(local_tid_324238 +\n                                                       offset_324261)];\n        }\n    }\n    offset_324261 = 1;\n    while (slt32(offset_324261, wave_sizze_324240)) {\n        if (slt32(local_tid_324238 + offset_324261, sext_i64_i32(q_t_292679)) &&\n            ((local_tid_324238 - squot32(local_tid_324238, wave_sizze_324240) *\n              wave_sizze_324240) & (2 * offset_324261 - 1)) == 0) {\n            // read array element\n            {\n                x_313891 = ((volatile __local\n                             double *) red_arr_mem_324257)[sext_i32_i64(local_tid_324238 +\n                                                           offset_324261)];\n                x_313892 = ((volatile __local\n                             double *) red_arr_mem_324259)[sext_i32_i64(local_tid_324238 +\n                                                           offset_324261)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_313893 = x_313889 + x_313891;\n                double defunc_1_op_res_313894 = x_313890 + x_313892;\n                \n          ",
            "      x_313889 = defunc_1_op_res_313893;\n                x_313890 = defunc_1_op_res_313894;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_324257)[sext_i32_i64(local_tid_324238)] =\n                    x_313889;\n                ((volatile __local\n                  double *) red_arr_mem_324259)[sext_i32_i64(local_tid_324238)] =\n                    x_313890;\n            }\n        }\n        offset_324261 *= 2;\n    }\n    while (slt32(skip_waves_324262, squot32(sext_i64_i32(q_t_292679) +\n                                            wave_sizze_324240 - 1,\n                                            wave_sizze_324240))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_324261 = skip_waves_324262 * wave_sizze_324240;\n        if (slt32(local_tid_324238 + offset_324261, sext_i64_i32(q_t_292679)) &&\n            ((local_tid_324238 - squot32(local_tid_324238, wave_sizze_324240) *\n              wave_sizze_324240) == 0 && (squot32(local_tid_324238,\n                                                  wave_sizze_324240) & (2 *\n                                                                        skip_waves_324262 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_313891 = ((__local\n                             double *) red_arr_mem_324257)[sext_i32_i64(local_tid_324238 +\n                                                           offset_324261)];\n                x_313892 = ((__local\n                             double *) red_arr_mem_324259)[sext_i32_i64(local_tid_324238 +\n                                                           offset_324261)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_313893 = x_313889 + x_313891;\n                double defunc_1_op_res_313894 = x_313890 + x_313892;\n                \n      ",
            "          x_313889 = defunc_1_op_res_313893;\n                x_313890 = defunc_1_op_res_313894;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_324257)[sext_i32_i64(local_tid_324238)] =\n                    x_313889;\n                ((__local\n                  double *) red_arr_mem_324259)[sext_i32_i64(local_tid_324238)] =\n                    x_313890;\n            }\n        }\n        skip_waves_324262 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_313885 = ((__local\n                                   double *) red_arr_mem_324257)[(int64_t) 0];\n    defunc_2_reduce_res_313886 = ((__local\n                                   double *) red_arr_mem_324259)[(int64_t) 0];\n    if (local_tid_324238 == 0) {\n        ((__global double *) mem_319898)[gtid_313821 * t_n_m_292839 +\n                                         gtid_313822] =\n            defunc_2_reduce_res_313885;\n    }\n    if (local_tid_324238 == 0) {\n        ((__global double *) mem_319902)[gtid_313821 * t_n_m_292839 +\n                                         gtid_313822] =\n            defunc_2_reduce_res_313886;\n    }\n    \n  error_4:\n    return;\n}\n__kernel void mainzisegmap_intragroup_314238(__global int *global_failure,\n                                             uint red_arr_mem_324310_backing_offset_0,\n                                             uint red_arr_mem_324308_backing_offset_1,\n                                             uint red_arr_mem_324304_backing_offset_2,\n                                             uint red_arr_mem_324302_backing_offset_3,\n                                             uint red_arr_mem_324300_backing_offset_4,\n                                             uint red_arr_mem_324298_backing_offset_5,\n                                             uint red_arr_mem_324296_backing_offset_6,\n                                             uint color_320656_backing_offset_7,\n              ",
            "                               uint color_320655_backing_offset_8,\n                                             uint color_320654_backing_offset_9,\n                                             uint color_320653_backing_offset_10,\n                                             int64_t n_292675,\n                                             int64_t q_t_292679,\n                                             int64_t jump_t_292685,\n                                             int64_t partition_sizze_292766,\n                                             int64_t t_n_m_292839,\n                                             int64_t i_292846, __global\n                                             unsigned char *ext_mem_318541,\n                                             __global\n                                             unsigned char *ext_mem_318542,\n                                             __global\n                                             unsigned char *ext_mem_318805,\n                                             __global\n                                             unsigned char *ext_mem_318806,\n                                             __global unsigned char *mem_319912,\n                                             __global unsigned char *mem_319916,\n                                             __global unsigned char *mem_319936,\n                                             __global unsigned char *mem_319940)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_324310_backing_10 =\n                           &shared_mem[red_arr_mem_324310_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324308_backing_9 =\n                           &shared_mem[red_arr_mem_324308_backing_offset_1];\n    volatile unsigned char *red_arr_mem_324304_backing_8 =\n                           &shared_mem[red_arr_mem_324304_backing_offset_2];\n    volatile unsigned char *red_arr_mem_324302_backing_7 =\n        ",
            "                   &shared_mem[red_arr_mem_324302_backing_offset_3];\n    volatile unsigned char *red_arr_mem_324300_backing_6 =\n                           &shared_mem[red_arr_mem_324300_backing_offset_4];\n    volatile unsigned char *red_arr_mem_324298_backing_5 =\n                           &shared_mem[red_arr_mem_324298_backing_offset_5];\n    volatile unsigned char *red_arr_mem_324296_backing_4 =\n                           &shared_mem[red_arr_mem_324296_backing_offset_6];\n    volatile unsigned char *color_320656_backing_3 =\n                           &shared_mem[color_320656_backing_offset_7];\n    volatile unsigned char *color_320655_backing_2 =\n                           &shared_mem[color_320655_backing_offset_8];\n    volatile unsigned char *color_320654_backing_1 =\n                           &shared_mem[color_320654_backing_offset_9];\n    volatile unsigned char *color_320653_backing_0 =\n                           &shared_mem[color_320653_backing_offset_10];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324284;\n    int32_t local_tid_324285;\n    int64_t group_sizze_324288;\n    int32_t wave_sizze_324287;\n    int32_t group_tid_324286;\n    \n    global_tid_324284 = get_global_id(0);\n    local_tid_324285 = get_local_id(0);\n    group_sizze_324288 = get_local_size(0);\n    wave_sizze_324287 = LOCKSTEP_WIDTH;\n    group_tid_324286 = get_group_id(0);\n    \n    int32_t phys_tid_314238 = group_tid_324286;\n    int64_t slice_324290 = q_t_292679;\n    int64_t ltid_pre_324289 = sext_i32_i64(local_tid_324285);\n    int64_t remnant_324291 = sext_i32_i64(local_tid_324285) - ltid_pre_324289;\n    int64_t slice_324292 = t_n_m_292839;\n    int64_t slice_324293 = partition_sizze_292766 * slice_324292;\n    int64_t gtid_314236 = squot64(sext_i32_i64(group_tid_324286), slice_324292);\n    int64_t remnant_324294 = sext_i32_i64(group_tid_324286) - gtid_314236 *\n            slice_324292;\n    int64_t gtid_314237 = remnant_324294;\n    int64_t remnant_324295 = remnant_324",
            "294 - gtid_314237;\n    __local unsigned char *color_320653;\n    \n    color_320653 = (__local unsigned char *) color_320653_backing_0;\n    \n    __local unsigned char *color_320654;\n    \n    color_320654 = (__local unsigned char *) color_320654_backing_1;\n    \n    __local unsigned char *color_320655;\n    \n    color_320655 = (__local unsigned char *) color_320655_backing_2;\n    \n    __local unsigned char *color_320656;\n    \n    color_320656 = (__local unsigned char *) color_320656_backing_3;\n    \n    int64_t x_314241;\n    \n    x_314241 = ((__global int64_t *) ext_mem_318541)[gtid_314236];\n    \n    int64_t x_314247;\n    \n    x_314247 = ((__global int64_t *) ext_mem_318806)[gtid_314236 *\n                                                     t_n_m_292839 +\n                                                     gtid_314237];\n    \n    double x_314248;\n    \n    x_314248 = ((__global double *) ext_mem_318805)[gtid_314236 * t_n_m_292839 +\n                                                    gtid_314237];\n    \n    int64_t min_arg_314249 = mul64(jump_t_292685, gtid_314237);\n    int64_t min_res_314250 = smin64(i_292846, min_arg_314249);\n    int64_t defunc_0_g_res_314251 = add64((int64_t) 1, min_res_314250);\n    int32_t phys_tid_314255 = local_tid_324285;\n    int64_t gtid_314254 = sext_i32_i64(sext_i64_i32(ltid_pre_324289));\n    bool cond_314257 = sle64(x_314241, gtid_314254);\n    int64_t defunc_0_f_res_314258;\n    \n    if (cond_314257) {\n        defunc_0_f_res_314258 = (int64_t) 0;\n    } else {\n        int64_t i_314259 = add64(x_314247, gtid_314254);\n        int64_t defunc_0_add_arg_314260;\n        \n        defunc_0_add_arg_314260 = ((__global\n                                    int64_t *) ext_mem_318542)[gtid_314236 *\n                                                               n_292675 +\n                                                               i_314259];\n        \n        int64_t defunc_1_add_res_314261 = add64((int64_t) 1,\n                                                def",
            "unc_0_add_arg_314260);\n        \n        defunc_0_f_res_314258 = defunc_1_add_res_314261;\n    }\n    \n    double defunc_0_f_res_314262;\n    \n    if (cond_314257) {\n        defunc_0_f_res_314262 = 0.0;\n    } else {\n        int64_t i_314263 = add64(x_314247, gtid_314254);\n        double defunc_0_add_arg_314264;\n        \n        defunc_0_add_arg_314264 = ((__global double *) mem_319912)[gtid_314236 *\n                                                                   n_292675 +\n                                                                   i_314263];\n        defunc_0_f_res_314262 = defunc_0_add_arg_314264;\n    }\n    \n    int64_t binop_p_314265 = sub64(defunc_0_f_res_314258,\n                                   defunc_0_g_res_314251);\n    double defunc_0_f_res_314266 = sitofp_i64_f64(binop_p_314265);\n    double abs_res_314267 = fabs(defunc_0_f_res_314266);\n    double tmp1_314268 = abs_res_314267 / x_314248;\n    double x_314269 = tmp1_314268 * tmp1_314268;\n    double y_314270 = tmp1_314268 * x_314269;\n    double tmp2_314271 = 1.0 - y_314270;\n    double x_314272 = tmp2_314271 * tmp2_314271;\n    double tmp3_314273 = tmp2_314271 * x_314272;\n    double tmp4_314274 = defunc_0_f_res_314262 * tmp3_314273;\n    \n    ((__local double *) color_320656)[gtid_314254] = defunc_0_f_res_314266;\n    ((__local double *) color_320655)[gtid_314254] = tmp4_314274;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    double defunc_2_reduce_res_314275;\n    double defunc_2_reduce_res_314276;\n    double defunc_2_reduce_res_314277;\n    double defunc_2_reduce_res_314278;\n    double defunc_2_reduce_res_314279;\n    int32_t phys_tid_314283 = local_tid_324285;\n    __local unsigned char *red_arr_mem_324296;\n    \n    red_arr_mem_324296 = (__local unsigned char *) red_arr_mem_324296_backing_4;\n    \n    __local unsigned char *red_arr_mem_324298;\n    \n    red_arr_mem_324298 = (__local unsigned char *) red_arr_mem_324298_backing_5;\n    \n    __local unsigned char *red_arr_mem_324300;\n    \n    red_arr_mem_324300 = (__loc",
            "al unsigned char *) red_arr_mem_324300_backing_6;\n    \n    __local unsigned char *red_arr_mem_324302;\n    \n    red_arr_mem_324302 = (__local unsigned char *) red_arr_mem_324302_backing_7;\n    \n    __local unsigned char *red_arr_mem_324304;\n    \n    red_arr_mem_324304 = (__local unsigned char *) red_arr_mem_324304_backing_8;\n    \n    int64_t gtid_314282 = sext_i32_i64(sext_i64_i32(ltid_pre_324289));\n    double x_314299;\n    \n    x_314299 = ((__local double *) color_320656)[gtid_314282];\n    \n    double x_314300;\n    \n    x_314300 = ((__local double *) color_320655)[gtid_314282];\n    \n    double defunc_1_f_res_314301 = x_314299 * x_314300;\n    double defunc_1_f_res_314302 = x_314299 * defunc_1_f_res_314301;\n    double defunc_1_f_res_314303 = x_314299 * defunc_1_f_res_314302;\n    double defunc_1_f_res_314304 = x_314299 * defunc_1_f_res_314303;\n    \n    ((__local double *) red_arr_mem_324296)[gtid_314282] = x_314300;\n    ((__local double *) red_arr_mem_324298)[gtid_314282] =\n        defunc_1_f_res_314301;\n    ((__local double *) red_arr_mem_324300)[gtid_314282] =\n        defunc_1_f_res_314302;\n    ((__local double *) red_arr_mem_324302)[gtid_314282] =\n        defunc_1_f_res_314303;\n    ((__local double *) red_arr_mem_324304)[gtid_314282] =\n        defunc_1_f_res_314304;\n    ((__local double *) color_320654)[gtid_314282] = defunc_1_f_res_314302;\n    ((__local double *) color_320653)[gtid_314282] = defunc_1_f_res_314301;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_324306;\n    int32_t skip_waves_324307 = 1;\n    double x_314284;\n    double x_314285;\n    double x_314286;\n    double x_314287;\n    double x_314288;\n    double x_314289;\n    double x_314290;\n    double x_314291;\n    double x_314292;\n    double x_314293;\n    \n    offset_324306 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_324285, sext_i64_i32(q_t_292679))) {\n            x_314284 = ((__local\n                         double *) red_arr_mem_324296)[sext_i32_",
            "i64(local_tid_324285 +\n                                                       offset_324306)];\n            x_314285 = ((__local\n                         double *) red_arr_mem_324298)[sext_i32_i64(local_tid_324285 +\n                                                       offset_324306)];\n            x_314286 = ((__local\n                         double *) red_arr_mem_324300)[sext_i32_i64(local_tid_324285 +\n                                                       offset_324306)];\n            x_314287 = ((__local\n                         double *) red_arr_mem_324302)[sext_i32_i64(local_tid_324285 +\n                                                       offset_324306)];\n            x_314288 = ((__local\n                         double *) red_arr_mem_324304)[sext_i32_i64(local_tid_324285 +\n                                                       offset_324306)];\n        }\n    }\n    offset_324306 = 1;\n    while (slt32(offset_324306, wave_sizze_324287)) {\n        if (slt32(local_tid_324285 + offset_324306, sext_i64_i32(q_t_292679)) &&\n            ((local_tid_324285 - squot32(local_tid_324285, wave_sizze_324287) *\n              wave_sizze_324287) & (2 * offset_324306 - 1)) == 0) {\n            // read array element\n            {\n                x_314289 = ((volatile __local\n                             double *) red_arr_mem_324296)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324306)];\n                x_314290 = ((volatile __local\n                             double *) red_arr_mem_324298)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324306)];\n                x_314291 = ((volatile __local\n                             double *) red_arr_mem_324300)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324306)];\n                x_314292 = ((volatile __local\n                             double *) red_arr_mem_324302)[sext_i32_i64(local_tid_",
            "324285 +\n                                                           offset_324306)];\n                x_314293 = ((volatile __local\n                             double *) red_arr_mem_324304)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324306)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_314294 = x_314284 + x_314289;\n                double defunc_1_op_res_314295 = x_314285 + x_314290;\n                double defunc_1_op_res_314296 = x_314286 + x_314291;\n                double defunc_1_op_res_314297 = x_314287 + x_314292;\n                double defunc_1_op_res_314298 = x_314288 + x_314293;\n                \n                x_314284 = defunc_1_op_res_314294;\n                x_314285 = defunc_1_op_res_314295;\n                x_314286 = defunc_1_op_res_314296;\n                x_314287 = defunc_1_op_res_314297;\n                x_314288 = defunc_1_op_res_314298;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_324296)[sext_i32_i64(local_tid_324285)] =\n                    x_314284;\n                ((volatile __local\n                  double *) red_arr_mem_324298)[sext_i32_i64(local_tid_324285)] =\n                    x_314285;\n                ((volatile __local\n                  double *) red_arr_mem_324300)[sext_i32_i64(local_tid_324285)] =\n                    x_314286;\n                ((volatile __local\n                  double *) red_arr_mem_324302)[sext_i32_i64(local_tid_324285)] =\n                    x_314287;\n                ((volatile __local\n                  double *) red_arr_mem_324304)[sext_i32_i64(local_tid_324285)] =\n                    x_314288;\n            }\n        }\n        offset_324306 *= 2;\n    }\n    while (slt32(skip_waves_324307, squot32(sext_i64_i32(q_t_292679) +\n                                            wave_sizze_324287 - 1,\n                ",
            "                            wave_sizze_324287))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_324306 = skip_waves_324307 * wave_sizze_324287;\n        if (slt32(local_tid_324285 + offset_324306, sext_i64_i32(q_t_292679)) &&\n            ((local_tid_324285 - squot32(local_tid_324285, wave_sizze_324287) *\n              wave_sizze_324287) == 0 && (squot32(local_tid_324285,\n                                                  wave_sizze_324287) & (2 *\n                                                                        skip_waves_324307 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_314289 = ((__local\n                             double *) red_arr_mem_324296)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324306)];\n                x_314290 = ((__local\n                             double *) red_arr_mem_324298)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324306)];\n                x_314291 = ((__local\n                             double *) red_arr_mem_324300)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324306)];\n                x_314292 = ((__local\n                             double *) red_arr_mem_324302)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324306)];\n                x_314293 = ((__local\n                             double *) red_arr_mem_324304)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324306)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_314294 = x_314284 + x_314289;\n                double defunc_1_op_res_314295 = x_314285 + x_314290;\n                double defunc_1_op_res_314296 = x_314286 + x_314291;\n         ",
            "       double defunc_1_op_res_314297 = x_314287 + x_314292;\n                double defunc_1_op_res_314298 = x_314288 + x_314293;\n                \n                x_314284 = defunc_1_op_res_314294;\n                x_314285 = defunc_1_op_res_314295;\n                x_314286 = defunc_1_op_res_314296;\n                x_314287 = defunc_1_op_res_314297;\n                x_314288 = defunc_1_op_res_314298;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_324296)[sext_i32_i64(local_tid_324285)] =\n                    x_314284;\n                ((__local\n                  double *) red_arr_mem_324298)[sext_i32_i64(local_tid_324285)] =\n                    x_314285;\n                ((__local\n                  double *) red_arr_mem_324300)[sext_i32_i64(local_tid_324285)] =\n                    x_314286;\n                ((__local\n                  double *) red_arr_mem_324302)[sext_i32_i64(local_tid_324285)] =\n                    x_314287;\n                ((__local\n                  double *) red_arr_mem_324304)[sext_i32_i64(local_tid_324285)] =\n                    x_314288;\n            }\n        }\n        skip_waves_324307 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_314275 = ((__local\n                                   double *) red_arr_mem_324296)[(int64_t) 0];\n    defunc_2_reduce_res_314276 = ((__local\n                                   double *) red_arr_mem_324298)[(int64_t) 0];\n    defunc_2_reduce_res_314277 = ((__local\n                                   double *) red_arr_mem_324300)[(int64_t) 0];\n    defunc_2_reduce_res_314278 = ((__local\n                                   double *) red_arr_mem_324302)[(int64_t) 0];\n    defunc_2_reduce_res_314279 = ((__local\n                                   double *) red_arr_mem_324304)[(int64_t) 0];\n    \n    double a_314305 = 2.220446049250313e-16 + defunc_2_reduce_res_314275;\n    double b_314306 = 2.220446049250313e-16 + defunc_2_",
            "reduce_res_314276;\n    double c_314307 = 2.220446049250313e-16 + defunc_2_reduce_res_314277;\n    double d_314308 = 2.220446049250313e-16 + defunc_2_reduce_res_314278;\n    double e_314309 = 2.220446049250313e-16 + defunc_2_reduce_res_314279;\n    double x_314310 = c_314307 * e_314309;\n    double y_314311 = d_314308 * d_314308;\n    double a12_314312 = x_314310 - y_314311;\n    double x_314313 = c_314307 * d_314308;\n    double y_314314 = b_314306 * e_314309;\n    double b12_314315 = x_314313 - y_314314;\n    double x_314316 = b_314306 * d_314308;\n    double y_314317 = c_314307 * c_314307;\n    double c12_314318 = x_314316 - y_314317;\n    double x_314319 = a_314305 * e_314309;\n    double b2_314320 = x_314319 - y_314317;\n    double x_314321 = b_314306 * c_314307;\n    double y_314322 = a_314305 * d_314308;\n    double c2_314323 = x_314321 - y_314322;\n    double x_314324 = a_314305 * a12_314312;\n    double y_314325 = b_314306 * b12_314315;\n    double x_314326 = x_314324 + y_314325;\n    double y_314327 = c_314307 * c12_314318;\n    double y_314328 = x_314326 + y_314327;\n    double det_314329 = 1.0 / y_314328;\n    double a12_314330 = a12_314312 * det_314329;\n    double b12_314331 = b12_314315 * det_314329;\n    double c12_314332 = c12_314318 * det_314329;\n    double b2_314333 = b2_314320 * det_314329;\n    double c2_314334 = c2_314323 * det_314329;\n    double defunc_2_reduce_res_314335;\n    double defunc_2_reduce_res_314336;\n    int32_t phys_tid_314338 = local_tid_324285;\n    __local unsigned char *red_arr_mem_324308;\n    \n    red_arr_mem_324308 = (__local unsigned char *) red_arr_mem_324308_backing_9;\n    \n    __local unsigned char *red_arr_mem_324310;\n    \n    red_arr_mem_324310 = (__local\n                          unsigned char *) red_arr_mem_324310_backing_10;\n    \n    int64_t gtid_314337 = sext_i32_i64(sext_i64_i32(ltid_pre_324289));\n    double x_314346;\n    \n    x_314346 = ((__local double *) color_320655)[gtid_314337];\n    \n    double x_314347;\n    \n    x_314347 = ((__local do",
            "uble *) color_320653)[gtid_314337];\n    \n    double x_314348;\n    \n    x_314348 = ((__local double *) color_320654)[gtid_314337];\n    \n    bool cond_314349 = sle64(x_314241, gtid_314337);\n    double defunc_0_f_res_314350;\n    \n    if (cond_314349) {\n        defunc_0_f_res_314350 = 0.0;\n    } else {\n        int64_t i_314351 = add64(x_314247, gtid_314337);\n        double defunc_0_add_arg_314352;\n        \n        defunc_0_add_arg_314352 = ((__global double *) mem_319916)[gtid_314236 *\n                                                                   n_292675 +\n                                                                   i_314351];\n        defunc_0_f_res_314350 = defunc_0_add_arg_314352;\n    }\n    \n    double x_314353 = a12_314330 * x_314346;\n    double y_314354 = b12_314331 * x_314347;\n    double x_314355 = x_314353 + y_314354;\n    double y_314356 = c12_314332 * x_314348;\n    double x_314357 = x_314355 + y_314356;\n    double defunc_9_fit_fun_res_314358 = defunc_0_f_res_314350 * x_314357;\n    double x_314359 = b12_314331 * x_314346;\n    double y_314360 = b2_314333 * x_314347;\n    double x_314361 = x_314359 + y_314360;\n    double y_314362 = c2_314334 * x_314348;\n    double x_314363 = x_314361 + y_314362;\n    double defunc_9_slope_fun_res_314364 = defunc_0_f_res_314350 * x_314363;\n    \n    ((__local double *) red_arr_mem_324308)[gtid_314337] =\n        defunc_9_fit_fun_res_314358;\n    ((__local double *) red_arr_mem_324310)[gtid_314337] =\n        defunc_9_slope_fun_res_314364;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_324312;\n    int32_t skip_waves_324313 = 1;\n    double x_314339;\n    double x_314340;\n    double x_314341;\n    double x_314342;\n    \n    offset_324312 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_324285, sext_i64_i32(q_t_292679))) {\n            x_314339 = ((__local\n                         double *) red_arr_mem_324308)[sext_i32_i64(local_tid_324285 +\n                                        ",
            "               offset_324312)];\n            x_314340 = ((__local\n                         double *) red_arr_mem_324310)[sext_i32_i64(local_tid_324285 +\n                                                       offset_324312)];\n        }\n    }\n    offset_324312 = 1;\n    while (slt32(offset_324312, wave_sizze_324287)) {\n        if (slt32(local_tid_324285 + offset_324312, sext_i64_i32(q_t_292679)) &&\n            ((local_tid_324285 - squot32(local_tid_324285, wave_sizze_324287) *\n              wave_sizze_324287) & (2 * offset_324312 - 1)) == 0) {\n            // read array element\n            {\n                x_314341 = ((volatile __local\n                             double *) red_arr_mem_324308)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324312)];\n                x_314342 = ((volatile __local\n                             double *) red_arr_mem_324310)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324312)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_314343 = x_314339 + x_314341;\n                double defunc_1_op_res_314344 = x_314340 + x_314342;\n                \n                x_314339 = defunc_1_op_res_314343;\n                x_314340 = defunc_1_op_res_314344;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_324308)[sext_i32_i64(local_tid_324285)] =\n                    x_314339;\n                ((volatile __local\n                  double *) red_arr_mem_324310)[sext_i32_i64(local_tid_324285)] =\n                    x_314340;\n            }\n        }\n        offset_324312 *= 2;\n    }\n    while (slt32(skip_waves_324313, squot32(sext_i64_i32(q_t_292679) +\n                                            wave_sizze_324287 - 1,\n                                            wave_sizze_324287))) {\n        barrier(CLK_LOCAL_ME",
            "M_FENCE);\n        offset_324312 = skip_waves_324313 * wave_sizze_324287;\n        if (slt32(local_tid_324285 + offset_324312, sext_i64_i32(q_t_292679)) &&\n            ((local_tid_324285 - squot32(local_tid_324285, wave_sizze_324287) *\n              wave_sizze_324287) == 0 && (squot32(local_tid_324285,\n                                                  wave_sizze_324287) & (2 *\n                                                                        skip_waves_324313 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_314341 = ((__local\n                             double *) red_arr_mem_324308)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324312)];\n                x_314342 = ((__local\n                             double *) red_arr_mem_324310)[sext_i32_i64(local_tid_324285 +\n                                                           offset_324312)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_314343 = x_314339 + x_314341;\n                double defunc_1_op_res_314344 = x_314340 + x_314342;\n                \n                x_314339 = defunc_1_op_res_314343;\n                x_314340 = defunc_1_op_res_314344;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_324308)[sext_i32_i64(local_tid_324285)] =\n                    x_314339;\n                ((__local\n                  double *) red_arr_mem_324310)[sext_i32_i64(local_tid_324285)] =\n                    x_314340;\n            }\n        }\n        skip_waves_324313 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    defunc_2_reduce_res_314335 = ((__local\n                                   double *) red_arr_mem_324308)[(int64_t) 0];\n    defunc_2_reduce_res_314336 = ((__local\n                                   double *)",
            " red_arr_mem_324310)[(int64_t) 0];\n    if (local_tid_324285 == 0) {\n        ((__global double *) mem_319936)[gtid_314236 * t_n_m_292839 +\n                                         gtid_314237] =\n            defunc_2_reduce_res_314335;\n    }\n    if (local_tid_324285 == 0) {\n        ((__global double *) mem_319940)[gtid_314236 * t_n_m_292839 +\n                                         gtid_314237] =\n            defunc_2_reduce_res_314336;\n    }\n    \n  error_5:\n    return;\n}\n__kernel void mainzisegmap_intragroup_316520(__global int *global_failure,\n                                             int failure_is_an_option, __global\n                                             int64_t *global_failure_args,\n                                             uint color_320658_backing_offset_0,\n                                             uint color_320657_backing_offset_1,\n                                             int64_t n_292675,\n                                             int64_t partition_sizze_292766,\n                                             int64_t ext_320116, __global\n                                             unsigned char *mem_318506, __global\n                                             unsigned char *ext_mem_318542,\n                                             __global\n                                             unsigned char *ext_mem_320111,\n                                             __global\n                                             unsigned char *ext_mem_320112,\n                                             __global unsigned char *mem_320139,\n                                             __global unsigned char *mem_320143)\n{\n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *color_320658_backing_1 =\n                           &shared_mem[color_320658_backing_offset_0];\n    volatile unsigned char *color_320657_backing_0 =\n                           &shared_mem[color_320657_backing_offset_1];\n",
            "    volatile __local bool local_failure;\n    \n    if (failure_is_an_option) {\n        int failed = *global_failure >= 0;\n        \n        if (failed)\n            return;\n    }\n    local_failure = false;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t global_tid_324965;\n    int32_t local_tid_324966;\n    int64_t group_sizze_324969;\n    int32_t wave_sizze_324968;\n    int32_t group_tid_324967;\n    \n    global_tid_324965 = get_global_id(0);\n    local_tid_324966 = get_local_id(0);\n    group_sizze_324969 = get_local_size(0);\n    wave_sizze_324968 = LOCKSTEP_WIDTH;\n    group_tid_324967 = get_group_id(0);\n    \n    int32_t phys_tid_316520 = group_tid_324967;\n    int64_t slice_324971 = n_292675;\n    int64_t ltid_pre_324970 = sext_i32_i64(local_tid_324966);\n    int64_t remnant_324972 = sext_i32_i64(local_tid_324966) - ltid_pre_324970;\n    int64_t slice_324973 = partition_sizze_292766;\n    int64_t gtid_316519 = sext_i32_i64(group_tid_324967);\n    int64_t remnant_324974 = sext_i32_i64(group_tid_324967) - gtid_316519;\n    __local unsigned char *color_320657;\n    \n    color_320657 = (__local unsigned char *) color_320657_backing_0;\n    \n    __local unsigned char *color_320658;\n    \n    color_320658 = (__local unsigned char *) color_320658_backing_1;\n    \n    int32_t phys_tid_316531 = local_tid_324966;\n    int64_t gtid_316530 = sext_i32_i64(sext_i64_i32(ltid_pre_324970));\n    float x_316532;\n    \n    x_316532 = ((__global float *) mem_318506)[gtid_316519 * n_292675 +\n                                               gtid_316530];\n    \n    double x_316533;\n    \n    x_316533 = ((__global double *) ext_mem_320112)[gtid_316519 * n_292675 +\n                                                    gtid_316530];\n    \n    double x_316534;\n    \n    x_316534 = ((__global double *) ext_mem_320111)[gtid_316519 * ext_320116 +\n                                                    gtid_316530];\n    \n    double f32_res_316535 = fpconv_f32_f64(x_316532);\n    double x_316536 = f32_res_316535 - x_316533;\n   ",
            " double defunc_2_f_res_316537 = x_316536 - x_316534;\n    bool isnan_res_316538;\n    \n    isnan_res_316538 = futrts_isnan64(defunc_2_f_res_316537);\n    \n    double defunc_0_f_res_316539;\n    \n    if (isnan_res_316538) {\n        defunc_0_f_res_316539 = defunc_2_f_res_316537;\n    } else {\n        double abs_res_316540 = fabs(defunc_2_f_res_316537);\n        \n        defunc_0_f_res_316539 = abs_res_316540;\n    }\n    ((__local double *) color_320658)[gtid_316530] = defunc_0_f_res_316539;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t phys_tid_316543 = local_tid_324966;\n    int64_t gtid_316542 = sext_i32_i64(sext_i64_i32(ltid_pre_324970));\n    int64_t x_316544;\n    \n    x_316544 = ((__global int64_t *) ext_mem_318542)[gtid_316519 * n_292675 +\n                                                     gtid_316542];\n    \n    bool cond_316545 = sle64((int64_t) 0, x_316544);\n    double defunc_0_f_res_316546;\n    \n    if (cond_316545) {\n        bool y_316547 = slt64(x_316544, n_292675);\n        bool bounds_check_316548 = cond_316545 && y_316547;\n        bool index_certs_316549;\n        \n        if (!bounds_check_316548) {\n            {\n                if (atomic_cmpxchg_i32_global(global_failure, -1, 72) == -1) {\n                    global_failure_args[0] = (int64_t) x_316544;\n                    global_failure_args[1] = (int64_t) n_292675;\n                    ;\n                }\n                local_failure = true;\n                goto error_1;\n            }\n        }\n        \n        double defunc_0_f_res_t_res_316550;\n        \n        defunc_0_f_res_t_res_316550 = ((__local\n                                        double *) color_320658)[x_316544];\n        defunc_0_f_res_316546 = defunc_0_f_res_t_res_316550;\n    } else {\n        defunc_0_f_res_316546 = INFINITY;\n    }\n    ((__local double *) color_320657)[gtid_316542] = defunc_0_f_res_316546;\n    \n  error_1:\n    barrier(CLK_LOCAL_MEM_FENCE);\n    if (local_failure)\n        return;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    doub",
            "le tmp_324975;\n    \n    tmp_324975 = ((__local\n                   double *) color_320657)[sext_i32_i64(local_tid_324966)];\n    ((__global double *) mem_320139)[gtid_316519 * n_292675 +\n                                     sext_i32_i64(local_tid_324966)] =\n        tmp_324975;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    double tmp_324976;\n    \n    tmp_324976 = ((__local\n                   double *) color_320658)[sext_i32_i64(local_tid_324966)];\n    ((__global double *) mem_320143)[gtid_316519 * n_292675 +\n                                     sext_i32_i64(local_tid_324966)] =\n        tmp_324976;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n  error_2:\n    return;\n}\n__kernel void mainzisegmap_intragroup_318088(__global int *global_failure,\n                                             uint color_320669_backing_offset_0,\n                                             int64_t n_292675,\n                                             int64_t partition_sizze_292766,\n                                             int64_t segmap_usable_groups_317189,\n                                             int64_t num_whole_tiles_318102,\n                                             int64_t residual_input_318296,\n                                             unsigned char cond_318297_bits,\n                                             __global\n                                             unsigned char *ext_mem_318541,\n                                             __global unsigned char *mem_320184,\n                                             __global unsigned char *mem_320205,\n                                             __global unsigned char *mem_320336,\n                                             __global unsigned char *mem_320387,\n                                             __global unsigned char *mem_320390,\n                                             __global unsigned char *mem_320393)\n{\n    bool cond_318297 = cond_318297_bits;\n    \n    #define segmap_group_sizze_317188 (mainzisegmap_group_sizze_3",
            "17128)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *color_320669_backing_0 =\n                           &shared_mem[color_320669_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325558;\n    int32_t local_tid_325559;\n    int64_t group_sizze_325562;\n    int32_t wave_sizze_325561;\n    int32_t group_tid_325560;\n    \n    global_tid_325558 = get_global_id(0);\n    local_tid_325559 = get_local_id(0);\n    group_sizze_325562 = get_local_size(0);\n    wave_sizze_325561 = LOCKSTEP_WIDTH;\n    group_tid_325560 = get_group_id(0);\n    \n    int32_t gid_flat_318088 = group_tid_325560;\n    int64_t slice_325564 = segmap_group_sizze_317188;\n    int64_t ltid_pre_325563 = sext_i32_i64(local_tid_325559);\n    int64_t remnant_325565 = sext_i32_i64(local_tid_325559) - ltid_pre_325563;\n    int64_t slice_325566 = segmap_usable_groups_317189;\n    int64_t gid_318087 = sext_i32_i64(group_tid_325560);\n    int64_t remnant_325567 = sext_i32_i64(group_tid_325560) - gid_318087;\n    int64_t color_320662[1];\n    int64_t color_320663[1];\n    double color_320664[1];\n    double color_320665[1];\n    double color_320666[1];\n    double color_320667[1];\n    int64_t color_320668[1];\n    __local unsigned char *color_320669;\n    \n    color_320669 = (__local unsigned char *) color_320669_backing_0;\n    \n    int64_t color_320670[1];\n    double color_320671[1];\n    int64_t binop_x_318095 = segmap_group_sizze_317188 * gid_318087;\n    int32_t ltid_flat_318090 = local_tid_325559;\n    int64_t ltid_318089 = sext_i32_i64(sext_i64_i32(ltid_pre_325563));\n    int64_t gtid_318096 = ltid_318089 + binop_x_318095;\n    bool cond_318097 = slt64(gtid_318096, partition_sizze_292766);\n    double pre_318098;\n    \n    if (cond_318097) {\n        double x_318099;\n        \n        x_318099 = ((__global double *) mem_320205)[gtid_318096];\n        pre_318098 = x_318099;\n    } else {\n        pre_318098 = 0.0;\n    }\n   ",
            " color_320671[(int64_t) 0] = pre_318098;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t ltid_flat_318104 = local_tid_325559;\n    int64_t ltid_318103 = sext_i32_i64(sext_i64_i32(ltid_pre_325563));\n    \n    color_320665[(int64_t) 0] = -INFINITY;\n    color_320662[(int64_t) 0] = (int64_t) -1;\n    color_320668[(int64_t) 0] = (int64_t) 0;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    double tmp_325568;\n    \n    tmp_325568 = color_320665[(int64_t) 0];\n    color_320664[(int64_t) 0] = tmp_325568;\n    \n    int64_t tmp_325569;\n    \n    tmp_325569 = color_320662[(int64_t) 0];\n    color_320663[(int64_t) 0] = tmp_325569;\n    \n    int64_t tmp_325570;\n    \n    tmp_325570 = color_320668[(int64_t) 0];\n    color_320662[(int64_t) 0] = tmp_325570;\n    \n    double ext_mem_320364[1];\n    double ext_mem_unused_320572[1];\n    int64_t ext_mem_320363[1];\n    int64_t ext_mem_unused_320576[1];\n    int64_t ext_mem_320362[1];\n    int64_t ext_mem_unused_320580[1];\n    double mem_param_320348[1];\n    int64_t mem_param_320349[1];\n    int64_t mem_param_320350[1];\n    double mem_param_out_320573[1];\n    int64_t mem_param_out_320577[1];\n    int64_t mem_param_out_320581[1];\n    \n    for (int32_t i_1 = 0; i_1 < 1; i_1++)\n        mem_param_320348[i_1] = color_320664[i_1];\n    for (int32_t i_2 = 0; i_2 < 1; i_2++)\n        mem_param_out_320573[i_2] = color_320665[i_2];\n    for (int32_t i_3 = 0; i_3 < 1; i_3++)\n        mem_param_320349[i_3] = color_320663[i_3];\n    for (int32_t i_4 = 0; i_4 < 1; i_4++)\n        mem_param_out_320577[i_4] = color_320670[i_4];\n    for (int32_t i_5 = 0; i_5 < 1; i_5++)\n        mem_param_320350[i_5] = color_320662[i_5];\n    for (int32_t i_6 = 0; i_6 < 1; i_6++)\n        mem_param_out_320581[i_6] = color_320668[i_6];\n    for (int64_t tile_id_318114 = 0; tile_id_318114 < num_whole_tiles_318102;\n         tile_id_318114++) {\n        int64_t binop_x_318202 = segmap_group_sizze_317188 * tile_id_318114;\n        int32_t ltid_flat_318201 = local_tid_325559;\n        int64_t ltid_318200 = se",
            "xt_i32_i64(sext_i64_i32(ltid_pre_325563));\n        int64_t j_318203 = ltid_318200 + binop_x_318202;\n        bool cond_318208 = slt64(j_318203, n_292675);\n        int64_t pre1d_318209;\n        \n        if (cond_318208) {\n            pre1d_318209 = j_318203;\n        } else {\n            pre1d_318209 = (int64_t) 0;\n        }\n        ((__local int64_t *) color_320669)[ltid_318200] = pre1d_318209;\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t ltid_flat_318216 = local_tid_325559;\n        int64_t ltid_318215 = sext_i32_i64(sext_i64_i32(ltid_pre_325563));\n        int64_t gtid_318218 = binop_x_318095 + ltid_318215;\n        double acc_318221;\n        \n        acc_318221 = mem_param_320348[(int64_t) 0];\n        \n        int64_t acc_318222;\n        \n        acc_318222 = mem_param_320349[(int64_t) 0];\n        \n        int64_t acc_318223;\n        \n        acc_318223 = mem_param_320350[(int64_t) 0];\n        \n        bool cond_318226 = slt64(gtid_318218, partition_sizze_292766);\n        double acc_318227;\n        int64_t acc_318228;\n        int64_t acc_318229;\n        \n        if (cond_318226) {\n            double x_318219;\n            \n            x_318219 = color_320671[(int64_t) 0];\n            \n            double x_318230;\n            int64_t x_318231;\n            int64_t x_318232;\n            double redout_318463;\n            int64_t redout_318464;\n            int64_t redout_318465;\n            \n            redout_318463 = acc_318221;\n            redout_318464 = acc_318222;\n            redout_318465 = acc_318223;\n            for (int64_t i_318466 = 0; i_318466 < segmap_group_sizze_317188;\n                 i_318466++) {\n                int64_t slice_318482 = binop_x_318202 + i_318466;\n                double x_318259;\n                \n                x_318259 = ((__global double *) mem_320336)[slice_318482 *\n                                                            partition_sizze_292766 +\n                                                            gtid_318218",
            "];\n                \n                int64_t x_318260;\n                \n                x_318260 = ((__local int64_t *) color_320669)[i_318466];\n                \n                bool cond_318261 = x_318259 < x_318219;\n                int64_t defunc_0_f_res_318262 = btoi_bool_i64(cond_318261);\n                bool cond_318239 = redout_318465 == (int64_t) 0;\n                bool cond_t_res_318240 = slt64((int64_t) 0,\n                                               defunc_0_f_res_318262);\n                bool x_318241 = cond_318239 && cond_t_res_318240;\n                double defunc_1_op_res_318242;\n                int64_t defunc_1_op_res_318243;\n                \n                if (x_318241) {\n                    defunc_1_op_res_318242 = x_318259;\n                    defunc_1_op_res_318243 = x_318260;\n                } else {\n                    bool cond_318244 = slt64((int64_t) 0, redout_318465);\n                    bool cond_t_res_318245 = defunc_0_f_res_318262 ==\n                         (int64_t) 0;\n                    bool x_318246 = cond_318244 && cond_t_res_318245;\n                    double defunc_1_op_res_f_res_318247;\n                    int64_t defunc_1_op_res_f_res_318248;\n                    \n                    if (x_318246) {\n                        defunc_1_op_res_f_res_318247 = redout_318463;\n                        defunc_1_op_res_f_res_318248 = redout_318464;\n                    } else {\n                        bool cond_318249 = x_318259 < redout_318463;\n                        double defunc_1_op_res_f_res_f_res_318250;\n                        int64_t defunc_1_op_res_f_res_f_res_318251;\n                        \n                        if (cond_318249) {\n                            defunc_1_op_res_f_res_f_res_318250 = redout_318463;\n                            defunc_1_op_res_f_res_f_res_318251 = redout_318464;\n                        } else {\n                            bool cond_318252 = redout_318463 < x_318259;\n                            double ",
            "defunc_1_op_res_f_res_f_res_f_res_318253;\n                            int64_t defunc_1_op_res_f_res_f_res_f_res_318254;\n                            \n                            if (cond_318252) {\n                                defunc_1_op_res_f_res_f_res_f_res_318253 =\n                                    x_318259;\n                                defunc_1_op_res_f_res_f_res_f_res_318254 =\n                                    x_318260;\n                            } else {\n                                bool cond_318255 = slt64(redout_318464,\n                                                         x_318260);\n                                double\n                                defunc_1_op_res_f_res_f_res_f_res_f_res_318256;\n                                \n                                if (cond_318255) {\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_318256 =\n                                        redout_318463;\n                                } else {\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_318256 =\n                                        x_318259;\n                                }\n                                \n                                int64_t\n                                defunc_1_op_res_f_res_f_res_f_res_f_res_318257;\n                                \n                                if (cond_318255) {\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_318257 =\n                                        redout_318464;\n                                } else {\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_318257 =\n                                        x_318260;\n                                }\n                                defunc_1_op_res_f_res_f_res_f_res_318253 =\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_318256;\n                                defunc_1_op_res_f_res_f_res_f_res_318254 =\n           ",
            "                         defunc_1_op_res_f_res_f_res_f_res_f_res_318257;\n                            }\n                            defunc_1_op_res_f_res_f_res_318250 =\n                                defunc_1_op_res_f_res_f_res_f_res_318253;\n                            defunc_1_op_res_f_res_f_res_318251 =\n                                defunc_1_op_res_f_res_f_res_f_res_318254;\n                        }\n                        defunc_1_op_res_f_res_318247 =\n                            defunc_1_op_res_f_res_f_res_318250;\n                        defunc_1_op_res_f_res_318248 =\n                            defunc_1_op_res_f_res_f_res_318251;\n                    }\n                    defunc_1_op_res_318242 = defunc_1_op_res_f_res_318247;\n                    defunc_1_op_res_318243 = defunc_1_op_res_f_res_318248;\n                }\n                \n                int64_t defunc_1_op_res_318258 = add64(defunc_0_f_res_318262,\n                                                       redout_318465);\n                double redout_tmp_325580 = defunc_1_op_res_318242;\n                int64_t redout_tmp_325581 = defunc_1_op_res_318243;\n                int64_t redout_tmp_325582 = defunc_1_op_res_318258;\n                \n                redout_318463 = redout_tmp_325580;\n                redout_318464 = redout_tmp_325581;\n                redout_318465 = redout_tmp_325582;\n            }\n            x_318230 = redout_318463;\n            x_318231 = redout_318464;\n            x_318232 = redout_318465;\n            acc_318227 = x_318230;\n            acc_318228 = x_318231;\n            acc_318229 = x_318232;\n        } else {\n            acc_318227 = acc_318221;\n            acc_318228 = acc_318222;\n            acc_318229 = acc_318223;\n        }\n        mem_param_out_320573[(int64_t) 0] = acc_318227;\n        mem_param_out_320577[(int64_t) 0] = acc_318228;\n        mem_param_out_320581[(int64_t) 0] = acc_318229;\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        double mem_param_tmp_325571[1];\n",
            "        \n        for (int32_t i_7 = 0; i_7 < 1; i_7++)\n            mem_param_tmp_325571[i_7] = mem_param_out_320573[i_7];\n        \n        double mem_param_out_tmp_325572[1];\n        \n        for (int32_t i_8 = 0; i_8 < 1; i_8++)\n            mem_param_out_tmp_325572[i_8] = mem_param_320348[i_8];\n        \n        int64_t mem_param_tmp_325573[1];\n        \n        for (int32_t i_9 = 0; i_9 < 1; i_9++)\n            mem_param_tmp_325573[i_9] = mem_param_out_320577[i_9];\n        \n        int64_t mem_param_out_tmp_325574[1];\n        \n        for (int32_t i_10 = 0; i_10 < 1; i_10++)\n            mem_param_out_tmp_325574[i_10] = mem_param_320349[i_10];\n        \n        int64_t mem_param_tmp_325575[1];\n        \n        for (int32_t i_11 = 0; i_11 < 1; i_11++)\n            mem_param_tmp_325575[i_11] = mem_param_out_320581[i_11];\n        \n        int64_t mem_param_out_tmp_325576[1];\n        \n        for (int32_t i_12 = 0; i_12 < 1; i_12++)\n            mem_param_out_tmp_325576[i_12] = mem_param_320350[i_12];\n        for (int32_t i_13 = 0; i_13 < 1; i_13++)\n            mem_param_320348[i_13] = mem_param_tmp_325571[i_13];\n        for (int32_t i_14 = 0; i_14 < 1; i_14++)\n            mem_param_out_320573[i_14] = mem_param_out_tmp_325572[i_14];\n        for (int32_t i_15 = 0; i_15 < 1; i_15++)\n            mem_param_320349[i_15] = mem_param_tmp_325573[i_15];\n        for (int32_t i_16 = 0; i_16 < 1; i_16++)\n            mem_param_out_320577[i_16] = mem_param_out_tmp_325574[i_16];\n        for (int32_t i_17 = 0; i_17 < 1; i_17++)\n            mem_param_320350[i_17] = mem_param_tmp_325575[i_17];\n        for (int32_t i_18 = 0; i_18 < 1; i_18++)\n            mem_param_out_320581[i_18] = mem_param_out_tmp_325576[i_18];\n    }\n    for (int32_t i_19 = 0; i_19 < 1; i_19++)\n        ext_mem_320364[i_19] = mem_param_320348[i_19];\n    for (int32_t i_20 = 0; i_20 < 1; i_20++)\n        ext_mem_unused_320572[i_20] = mem_param_out_320573[i_20];\n    for (int32_t i_21 = 0; i_21 < 1; i_21++)\n        ext_mem_320363",
            "[i_21] = mem_param_320349[i_21];\n    for (int32_t i_22 = 0; i_22 < 1; i_22++)\n        ext_mem_unused_320576[i_22] = mem_param_out_320577[i_22];\n    for (int32_t i_23 = 0; i_23 < 1; i_23++)\n        ext_mem_320362[i_23] = mem_param_320350[i_23];\n    for (int32_t i_24 = 0; i_24 < 1; i_24++)\n        ext_mem_unused_320580[i_24] = mem_param_out_320581[i_24];\n    if (cond_318297) {\n        double tmp_325583;\n        \n        tmp_325583 = ext_mem_320364[(int64_t) 0];\n        color_320664[(int64_t) 0] = tmp_325583;\n        \n        int64_t tmp_325584;\n        \n        tmp_325584 = ext_mem_320362[(int64_t) 0];\n        color_320662[(int64_t) 0] = tmp_325584;\n    } else {\n        int64_t binop_x_318307 = segmap_group_sizze_317188 *\n                num_whole_tiles_318102;\n        int32_t ltid_flat_318299 = local_tid_325559;\n        int64_t ltid_318298 = sext_i32_i64(sext_i64_i32(ltid_pre_325563));\n        int64_t j_318308 = ltid_318298 + binop_x_318307;\n        bool cond_318313 = slt64(j_318308, n_292675);\n        int64_t pre1d_318314;\n        \n        if (cond_318313) {\n            pre1d_318314 = j_318308;\n        } else {\n            pre1d_318314 = (int64_t) 0;\n        }\n        ((__local int64_t *) color_320669)[ltid_318298] = pre1d_318314;\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int64_t slice_offset_318341 = num_whole_tiles_318102 *\n                residual_input_318296;\n        int32_t ltid_flat_318320 = local_tid_325559;\n        int64_t ltid_318319 = sext_i32_i64(sext_i64_i32(ltid_pre_325563));\n        int64_t gtid_318335 = binop_x_318095 + ltid_318319;\n        double acc_318338;\n        \n        acc_318338 = ext_mem_320364[(int64_t) 0];\n        \n        int64_t acc_318339;\n        \n        acc_318339 = ext_mem_320363[(int64_t) 0];\n        \n        int64_t acc_318340;\n        \n        acc_318340 = ext_mem_320362[(int64_t) 0];\n        \n        bool cond_318343 = slt64(gtid_318335, partition_sizze_292766);\n        double acc_318344;\n        int64_t acc_318345;",
            "\n        int64_t acc_318346;\n        \n        if (cond_318343) {\n            double x_318336;\n            \n            x_318336 = color_320671[(int64_t) 0];\n            \n            double x_318347;\n            int64_t x_318348;\n            int64_t x_318349;\n            double redout_318467;\n            int64_t redout_318468;\n            int64_t redout_318469;\n            \n            redout_318467 = acc_318338;\n            redout_318468 = acc_318339;\n            redout_318469 = acc_318340;\n            for (int64_t i_318470 = 0; i_318470 < residual_input_318296;\n                 i_318470++) {\n                int64_t slice_318481 = slice_offset_318341 + i_318470;\n                double x_318376;\n                \n                x_318376 = ((__global double *) mem_320336)[slice_318481 *\n                                                            partition_sizze_292766 +\n                                                            gtid_318335];\n                \n                int64_t x_318377;\n                \n                x_318377 = ((__local int64_t *) color_320669)[i_318470];\n                \n                bool cond_318378 = x_318376 < x_318336;\n                int64_t defunc_0_f_res_318379 = btoi_bool_i64(cond_318378);\n                bool cond_318356 = redout_318469 == (int64_t) 0;\n                bool cond_t_res_318357 = slt64((int64_t) 0,\n                                               defunc_0_f_res_318379);\n                bool x_318358 = cond_318356 && cond_t_res_318357;\n                double defunc_1_op_res_318359;\n                int64_t defunc_1_op_res_318360;\n                \n                if (x_318358) {\n                    defunc_1_op_res_318359 = x_318376;\n                    defunc_1_op_res_318360 = x_318377;\n                } else {\n                    bool cond_318361 = slt64((int64_t) 0, redout_318469);\n                    bool cond_t_res_318362 = defunc_0_f_res_318379 ==\n                         (int64_t) 0;\n                    bool x_31836",
            "3 = cond_318361 && cond_t_res_318362;\n                    double defunc_1_op_res_f_res_318364;\n                    int64_t defunc_1_op_res_f_res_318365;\n                    \n                    if (x_318363) {\n                        defunc_1_op_res_f_res_318364 = redout_318467;\n                        defunc_1_op_res_f_res_318365 = redout_318468;\n                    } else {\n                        bool cond_318366 = x_318376 < redout_318467;\n                        double defunc_1_op_res_f_res_f_res_318367;\n                        int64_t defunc_1_op_res_f_res_f_res_318368;\n                        \n                        if (cond_318366) {\n                            defunc_1_op_res_f_res_f_res_318367 = redout_318467;\n                            defunc_1_op_res_f_res_f_res_318368 = redout_318468;\n                        } else {\n                            bool cond_318369 = redout_318467 < x_318376;\n                            double defunc_1_op_res_f_res_f_res_f_res_318370;\n                            int64_t defunc_1_op_res_f_res_f_res_f_res_318371;\n                            \n                            if (cond_318369) {\n                                defunc_1_op_res_f_res_f_res_f_res_318370 =\n                                    x_318376;\n                                defunc_1_op_res_f_res_f_res_f_res_318371 =\n                                    x_318377;\n                            } else {\n                                bool cond_318372 = slt64(redout_318468,\n                                                         x_318377);\n                                double\n                                defunc_1_op_res_f_res_f_res_f_res_f_res_318373;\n                                \n                                if (cond_318372) {\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_318373 =\n                                        redout_318467;\n                                } else {\n                                    defunc_1_op_r",
            "es_f_res_f_res_f_res_f_res_318373 =\n                                        x_318376;\n                                }\n                                \n                                int64_t\n                                defunc_1_op_res_f_res_f_res_f_res_f_res_318374;\n                                \n                                if (cond_318372) {\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_318374 =\n                                        redout_318468;\n                                } else {\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_318374 =\n                                        x_318377;\n                                }\n                                defunc_1_op_res_f_res_f_res_f_res_318370 =\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_318373;\n                                defunc_1_op_res_f_res_f_res_f_res_318371 =\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_318374;\n                            }\n                            defunc_1_op_res_f_res_f_res_318367 =\n                                defunc_1_op_res_f_res_f_res_f_res_318370;\n                            defunc_1_op_res_f_res_f_res_318368 =\n                                defunc_1_op_res_f_res_f_res_f_res_318371;\n                        }\n                        defunc_1_op_res_f_res_318364 =\n                            defunc_1_op_res_f_res_f_res_318367;\n                        defunc_1_op_res_f_res_318365 =\n                            defunc_1_op_res_f_res_f_res_318368;\n                    }\n                    defunc_1_op_res_318359 = defunc_1_op_res_f_res_318364;\n                    defunc_1_op_res_318360 = defunc_1_op_res_f_res_318365;\n                }\n                \n                int64_t defunc_1_op_res_318375 = add64(defunc_0_f_res_318379,\n                                                       redout_318469);\n                double redout_tmp_325585 = defu",
            "nc_1_op_res_318359;\n                int64_t redout_tmp_325586 = defunc_1_op_res_318360;\n                int64_t redout_tmp_325587 = defunc_1_op_res_318375;\n                \n                redout_318467 = redout_tmp_325585;\n                redout_318468 = redout_tmp_325586;\n                redout_318469 = redout_tmp_325587;\n            }\n            x_318347 = redout_318467;\n            x_318348 = redout_318468;\n            x_318349 = redout_318469;\n            acc_318344 = x_318347;\n            acc_318345 = x_318348;\n            acc_318346 = x_318349;\n        } else {\n            acc_318344 = acc_318338;\n            acc_318345 = acc_318339;\n            acc_318346 = acc_318340;\n        }\n        color_320665[(int64_t) 0] = acc_318344;\n        color_320668[(int64_t) 0] = acc_318345;\n        color_320663[(int64_t) 0] = acc_318346;\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        double tmp_325588;\n        \n        tmp_325588 = color_320665[(int64_t) 0];\n        color_320664[(int64_t) 0] = tmp_325588;\n        \n        int64_t tmp_325589;\n        \n        tmp_325589 = color_320663[(int64_t) 0];\n        color_320662[(int64_t) 0] = tmp_325589;\n    }\n    \n    int32_t ltid_flat_318387 = local_tid_325559;\n    int64_t ltid_318386 = sext_i32_i64(sext_i64_i32(ltid_pre_325563));\n    int64_t gtid_318397 = binop_x_318095 + ltid_318386;\n    bool cond_318401 = slt64(gtid_318397, partition_sizze_292766);\n    double postlude_318402;\n    double postlude_318403;\n    double postlude_318404;\n    \n    if (cond_318401) {\n        int64_t defunc_2_reduce_comm_res_318400;\n        \n        defunc_2_reduce_comm_res_318400 = color_320662[(int64_t) 0];\n        \n        double x_318405;\n        \n        x_318405 = color_320671[(int64_t) 0];\n        \n        int64_t x_318407;\n        \n        x_318407 = ((__global int64_t *) mem_320184)[gtid_318397];\n        \n        int64_t x_318408;\n        \n        x_318408 = ((__global int64_t *) ext_mem_318541)[gtid_318397];\n        \n        bool cond_318",
            "409 = x_318407 == (int64_t) 0;\n        int64_t x_318410 = smod64(x_318408, (int64_t) 2);\n        bool cond_f_res_318411 = x_318410 == (int64_t) 1;\n        bool x_318412 = !cond_318409;\n        bool y_318413 = cond_f_res_318411 && x_318412;\n        bool cond_318414 = cond_318409 || y_318413;\n        bool cond_f_res_318415 = slt64(defunc_2_reduce_comm_res_318400,\n                                       x_318407);\n        bool x_318416 = !cond_318414;\n        bool y_318417 = cond_f_res_318415 && x_318416;\n        bool cond_318418 = cond_318414 || y_318417;\n        double defunc_4_f_res_318419;\n        \n        if (cond_318418) {\n            defunc_4_f_res_318419 = x_318405;\n        } else {\n            double defunc_2_reduce_comm_res_318398;\n            \n            defunc_2_reduce_comm_res_318398 = color_320664[(int64_t) 0];\n            \n            double x_318420 = x_318405 - defunc_2_reduce_comm_res_318398;\n            double y_318421 = x_318420 / 2.0;\n            double defunc_4_f_res_f_res_318422 =\n                   defunc_2_reduce_comm_res_318398 + y_318421;\n            \n            defunc_4_f_res_318419 = defunc_4_f_res_f_res_318422;\n        }\n        \n        double h_318423 = 6.0 * defunc_4_f_res_318419;\n        double h9_318424 = 0.999 * h_318423;\n        double h1_318425 = 1.0e-3 * h_318423;\n        \n        postlude_318402 = h_318423;\n        postlude_318403 = h9_318424;\n        postlude_318404 = h1_318425;\n    } else {\n        postlude_318402 = 0.0;\n        postlude_318403 = 0.0;\n        postlude_318404 = 0.0;\n    }\n    color_320667[(int64_t) 0] = postlude_318402;\n    color_320666[(int64_t) 0] = postlude_318403;\n    color_320665[(int64_t) 0] = postlude_318404;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    if (slt64(sext_i32_i64(local_tid_325559) + segmap_group_sizze_317188 *\n              sext_i32_i64(group_tid_325560), partition_sizze_292766)) {\n        double tmp_325590;\n        \n        tmp_325590 = color_320667[(int64_t) 0];\n        ((__global double *) mem_3",
            "20387)[sext_i32_i64(local_tid_325559) +\n                                         segmap_group_sizze_317188 *\n                                         sext_i32_i64(group_tid_325560)] =\n            tmp_325590;\n    }\n    if (slt64(sext_i32_i64(local_tid_325559) + segmap_group_sizze_317188 *\n              sext_i32_i64(group_tid_325560), partition_sizze_292766)) {\n        double tmp_325591;\n        \n        tmp_325591 = color_320666[(int64_t) 0];\n        ((__global double *) mem_320390)[sext_i32_i64(local_tid_325559) +\n                                         segmap_group_sizze_317188 *\n                                         sext_i32_i64(group_tid_325560)] =\n            tmp_325591;\n    }\n    if (slt64(sext_i32_i64(local_tid_325559) + segmap_group_sizze_317188 *\n              sext_i32_i64(group_tid_325560), partition_sizze_292766)) {\n        double tmp_325592;\n        \n        tmp_325592 = color_320665[(int64_t) 0];\n        ((__global double *) mem_320393)[sext_i32_i64(local_tid_325559) +\n                                         segmap_group_sizze_317188 *\n                                         sext_i32_i64(group_tid_325560)] =\n            tmp_325592;\n    }\n    \n  error_7:\n    return;\n    #undef segmap_group_sizze_317188\n}\n__kernel void mainzisegred_large_304643(__global int *global_failure,\n                                        uint sync_arr_mem_321924_backing_offset_0,\n                                        uint red_arr_mem_321922_backing_offset_1,\n                                        int64_t n_p_292677, int64_t q_s_292678,\n                                        int64_t partition_sizze_292766,\n                                        int64_t defunc_0_f_res_292820,\n                                        int64_t s_n_m_292825,\n                                        int64_t num_groups_304636,\n                                        int64_t groups_per_segment_321908,\n                                        int64_t elements_per_thread_321909,\n                     ",
            "                   int64_t virt_num_groups_321910,\n                                        int64_t threads_per_segment_321912,\n                                        __global unsigned char *ext_mem_318609,\n                                        __global unsigned char *ext_mem_318610,\n                                        __global unsigned char *ext_mem_318707,\n                                        __global unsigned char *ext_mem_318708,\n                                        __global unsigned char *mem_318876,\n                                        __global unsigned char *mem_319056,\n                                        __global unsigned char *mem_319066,\n                                        __global\n                                        unsigned char *segred_tmp_mem_321913,\n                                        __global\n                                        unsigned char *mainzicounter_mem_321915)\n{\n    #define segred_group_sizze_304635 (mainzisegred_group_sizze_303989)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_321924_backing_1 =\n                           &shared_mem[sync_arr_mem_321924_backing_offset_0];\n    volatile unsigned char *red_arr_mem_321922_backing_0 =\n                           &shared_mem[red_arr_mem_321922_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321917;\n    int32_t local_tid_321918;\n    int64_t group_sizze_321921;\n    int32_t wave_sizze_321920;\n    int32_t group_tid_321919;\n    \n    global_tid_321917 = get_global_id(0);\n    local_tid_321918 = get_local_id(0);\n    group_sizze_321921 = get_local_size(0);\n    wave_sizze_321920 = LOCKSTEP_WIDTH;\n    group_tid_321919 = get_group_id(0);\n    \n    int32_t phys_tid_304643 = global_tid_321917;\n    __local unsigned char *red_arr_mem_321922;\n    \n    red_arr_mem_321922 = (__local unsigned char *) red_arr_mem_321922_backing_0;\n    \n    __local ",
            "unsigned char *sync_arr_mem_321924;\n    \n    sync_arr_mem_321924 = (__local\n                           unsigned char *) sync_arr_mem_321924_backing_1;\n    \n    int32_t phys_group_id_321926;\n    \n    phys_group_id_321926 = get_group_id(0);\n    for (int32_t i_321927 = 0; i_321927 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_321910) - phys_group_id_321926,\n                   sext_i64_i32(num_groups_304636)); i_321927++) {\n        int32_t virt_group_id_321928 = phys_group_id_321926 + i_321927 *\n                sext_i64_i32(num_groups_304636);\n        int32_t flat_segment_id_321929 = squot32(virt_group_id_321928,\n                                                 sext_i64_i32(groups_per_segment_321908));\n        int64_t global_tid_321930 = srem64(sext_i32_i64(virt_group_id_321928) *\n                                           segred_group_sizze_304635 +\n                                           sext_i32_i64(local_tid_321918),\n                                           segred_group_sizze_304635 *\n                                           groups_per_segment_321908);\n        int64_t slice_321931 = s_n_m_292825;\n        int64_t slice_321932 = n_p_292677 * slice_321931;\n        int64_t slice_321933 = partition_sizze_292766 * slice_321932;\n        int64_t gtid_304639 = squot64(sext_i32_i64(flat_segment_id_321929),\n                                      slice_321932);\n        int64_t remnant_321934 = sext_i32_i64(flat_segment_id_321929) -\n                gtid_304639 * slice_321932;\n        int64_t gtid_304640 = squot64(remnant_321934, slice_321931);\n        int64_t remnant_321935 = remnant_321934 - gtid_304640 * slice_321931;\n        int64_t gtid_304641 = remnant_321935;\n        int64_t remnant_321936 = remnant_321935 - gtid_304641;\n        int64_t gtid_304642;\n        double x_acc_321937;\n        int64_t chunk_sizze_321938 = smin64(elements_per_thread_321909,\n                                            sdiv_up64(q_s_292678 -\n                                                 ",
            "     global_tid_321930,\n                                                      threads_per_segment_321912));\n        double x_304644;\n        double x_304645;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_321937 = 0.0;\n        }\n        for (int64_t i_321942 = 0; i_321942 < chunk_sizze_321938; i_321942++) {\n            gtid_304642 = global_tid_321930 + threads_per_segment_321912 *\n                i_321942;\n            // apply map function\n            {\n                int64_t x_304655;\n                \n                x_304655 = ((__global int64_t *) ext_mem_318609)[gtid_304639 *\n                                                                 n_p_292677 +\n                                                                 gtid_304640];\n                \n                int64_t x_304659;\n                \n                x_304659 = ((__global int64_t *) ext_mem_318708)[gtid_304639 *\n                                                                 (s_n_m_292825 *\n                                                                  n_p_292677) +\n                                                                 gtid_304640 *\n                                                                 s_n_m_292825 +\n                                                                 gtid_304641];\n                \n                double x_304660;\n                \n                x_304660 = ((__global double *) ext_mem_318707)[gtid_304639 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_304640 *\n                                                                s_n_m_292825 +\n                                                                gtid_304641];\n                \n                int64_t defunc_0_m_fun_res_304661;\n                \n                defunc_0_m_fun_res_304661 = ((__",
            "global\n                                              int64_t *) mem_319056)[gtid_304639 *\n                                                                     (s_n_m_292825 *\n                                                                      n_p_292677) +\n                                                                     gtid_304640 *\n                                                                     s_n_m_292825 +\n                                                                     gtid_304641];\n                \n                bool cond_304663 = sle64(x_304655, gtid_304642);\n                int64_t defunc_0_f_res_304664;\n                \n                if (cond_304663) {\n                    defunc_0_f_res_304664 = (int64_t) 0;\n                } else {\n                    int64_t i_304665 = add64(gtid_304642, x_304659);\n                    int64_t defunc_0_add_arg_304666;\n                    \n                    defunc_0_add_arg_304666 = ((__global\n                                                int64_t *) ext_mem_318610)[gtid_304639 *\n                                                                           (defunc_0_f_res_292820 *\n                                                                            n_p_292677) +\n                                                                           gtid_304640 *\n                                                                           defunc_0_f_res_292820 +\n                                                                           i_304665];\n                    \n                    int64_t defunc_1_add_res_304667 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_304666);\n                    \n                    defunc_0_f_res_304664 = defunc_1_add_res_304667;\n                }\n                \n                double defunc_0_f_res_304668;\n                \n                if (cond_304663) {\n                    defunc_0_f_res_304668 = 0.0;\n                } else ",
            "{\n                    int64_t i_304669 = add64(gtid_304642, x_304659);\n                    double defunc_0_add_arg_304670;\n                    \n                    defunc_0_add_arg_304670 = ((__global\n                                                double *) mem_318876)[gtid_304639 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_304640 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_304669];\n                    defunc_0_f_res_304668 = defunc_0_add_arg_304670;\n                }\n                \n                int64_t binop_p_304671 = sub64(defunc_0_f_res_304664,\n                                               defunc_0_m_fun_res_304661);\n                double defunc_0_f_res_304672 = sitofp_i64_f64(binop_p_304671);\n                double abs_res_304673 = fabs(defunc_0_f_res_304672);\n                double tmp1_304674 = abs_res_304673 / x_304660;\n                double x_304675 = tmp1_304674 * tmp1_304674;\n                double y_304676 = tmp1_304674 * x_304675;\n                double tmp2_304677 = 1.0 - y_304676;\n                double x_304678 = tmp2_304677 * tmp2_304677;\n                double tmp3_304679 = tmp2_304677 * x_304678;\n                double w_j_304680 = defunc_0_f_res_304668 * tmp3_304679;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_304644 = x_acc_321937;\n                }\n                // load new values\n                {\n                    x_304645 = w_j_304680;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_304646 = x_304644 + x_304645;\n     ",
            "               \n                    // store in accumulator\n                    {\n                        x_acc_321937 = defunc_1_op_res_304646;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_304644 = x_acc_321937;\n            ((__local\n              double *) red_arr_mem_321922)[sext_i32_i64(local_tid_321918)] =\n                x_304644;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_321943;\n        int32_t skip_waves_321944 = 1;\n        double x_321939;\n        double x_321940;\n        \n        offset_321943 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_321918,\n                      sext_i64_i32(segred_group_sizze_304635))) {\n                x_321939 = ((__local\n                             double *) red_arr_mem_321922)[sext_i32_i64(local_tid_321918 +\n                                                           offset_321943)];\n            }\n        }\n        offset_321943 = 1;\n        while (slt32(offset_321943, wave_sizze_321920)) {\n            if (slt32(local_tid_321918 + offset_321943,\n                      sext_i64_i32(segred_group_sizze_304635)) &&\n                ((local_tid_321918 - squot32(local_tid_321918,\n                                             wave_sizze_321920) *\n                  wave_sizze_321920) & (2 * offset_321943 - 1)) == 0) {\n                // read array element\n                {\n                    x_321940 = ((volatile __local\n                                 double *) red_arr_mem_321922)[sext_i32_i64(local_tid_321918 +\n                                                               offset_321943)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_321941 = x_321939 + x_321940;\n                    \n                    x_321939 = defunc_1_op_res_321941;\n               ",
            " }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_321922)[sext_i32_i64(local_tid_321918)] =\n                        x_321939;\n                }\n            }\n            offset_321943 *= 2;\n        }\n        while (slt32(skip_waves_321944,\n                     squot32(sext_i64_i32(segred_group_sizze_304635) +\n                             wave_sizze_321920 - 1, wave_sizze_321920))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_321943 = skip_waves_321944 * wave_sizze_321920;\n            if (slt32(local_tid_321918 + offset_321943,\n                      sext_i64_i32(segred_group_sizze_304635)) &&\n                ((local_tid_321918 - squot32(local_tid_321918,\n                                             wave_sizze_321920) *\n                  wave_sizze_321920) == 0 && (squot32(local_tid_321918,\n                                                      wave_sizze_321920) & (2 *\n                                                                            skip_waves_321944 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_321940 = ((__local\n                                 double *) red_arr_mem_321922)[sext_i32_i64(local_tid_321918 +\n                                                               offset_321943)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_321941 = x_321939 + x_321940;\n                    \n                    x_321939 = defunc_1_op_res_321941;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_321922)[sext_i32_i64(local_tid_321918)] =\n                        x_321939;\n                }\n            }\n            skip_waves_321944 *= 2;\n",
            "        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_321918) == (int64_t) 0) {\n                x_acc_321937 = x_321939;\n            }\n        }\n        if (groups_per_segment_321908 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_321918 == 0) {\n                    ((__global double *) mem_319066)[gtid_304639 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_304640 *\n                                                     s_n_m_292825 +\n                                                     gtid_304641] =\n                        x_acc_321937;\n                }\n            }\n        } else {\n            int32_t old_counter_321945;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_321918 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_321913)[sext_i32_i64(virt_group_id_321928)] =\n                        x_acc_321937;\n                    mem_fence_global();\n                    old_counter_321945 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_321915)[sext_i32_i64(srem32(flat_segment_id_321929,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_321924)[(int64_t) 0] =\n                        old_counter_321945 == groups_per_segment_321908 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n          ",
            "  \n            bool is_last_group_321946;\n            \n            is_last_group_321946 = ((__local\n                                     bool *) sync_arr_mem_321924)[(int64_t) 0];\n            if (is_last_group_321946) {\n                if (local_tid_321918 == 0) {\n                    old_counter_321945 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_321915)[sext_i32_i64(srem32(flat_segment_id_321929,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_321908));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_321947 =\n                            sdiv_up64(groups_per_segment_321908,\n                                      segred_group_sizze_304635);\n                    \n                    x_304644 = 0.0;\n                    for (int64_t i_321948 = 0; i_321948 <\n                         read_per_thread_321947; i_321948++) {\n                        int64_t group_res_id_321949 =\n                                sext_i32_i64(local_tid_321918) *\n                                read_per_thread_321947 + i_321948;\n                        int64_t index_of_group_res_321950 =\n                                sext_i32_i64(flat_segment_id_321929) *\n                                groups_per_segment_321908 + group_res_id_321949;\n                        \n                        if (slt64(group_res_id_321949,\n                                  groups_per_segment_321908)) {\n                            x_304645 = ((__global\n                                         double *) segred_tmp_mem_321913)[index_of_group_res_321950];\n                            \n                            double defunc_1_op_res_304646 = x_304644 +",
            " x_304645;\n                            \n                            x_304644 = defunc_1_op_res_304646;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_321922)[sext_i32_i64(local_tid_321918)] =\n                    x_304644;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_321951;\n                    int32_t skip_waves_321952 = 1;\n                    double x_321939;\n                    double x_321940;\n                    \n                    offset_321951 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_321918,\n                                  sext_i64_i32(segred_group_sizze_304635))) {\n                            x_321939 = ((__local\n                                         double *) red_arr_mem_321922)[sext_i32_i64(local_tid_321918 +\n                                                                       offset_321951)];\n                        }\n                    }\n                    offset_321951 = 1;\n                    while (slt32(offset_321951, wave_sizze_321920)) {\n                        if (slt32(local_tid_321918 + offset_321951,\n                                  sext_i64_i32(segred_group_sizze_304635)) &&\n                            ((local_tid_321918 - squot32(local_tid_321918,\n                                                         wave_sizze_321920) *\n                              wave_sizze_321920) & (2 * offset_321951 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_321940 = ((volatile __local\n                                             double *) red_arr_mem_321922)[sext_i32_i64(local_tid_321918 +\n                                                                          ",
            " offset_321951)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_321941 = x_321939 +\n                                       x_321940;\n                                \n                                x_321939 = defunc_1_op_res_321941;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_321922)[sext_i32_i64(local_tid_321918)] =\n                                    x_321939;\n                            }\n                        }\n                        offset_321951 *= 2;\n                    }\n                    while (slt32(skip_waves_321952,\n                                 squot32(sext_i64_i32(segred_group_sizze_304635) +\n                                         wave_sizze_321920 - 1,\n                                         wave_sizze_321920))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_321951 = skip_waves_321952 * wave_sizze_321920;\n                        if (slt32(local_tid_321918 + offset_321951,\n                                  sext_i64_i32(segred_group_sizze_304635)) &&\n                            ((local_tid_321918 - squot32(local_tid_321918,\n                                                         wave_sizze_321920) *\n                              wave_sizze_321920) == 0 &&\n                             (squot32(local_tid_321918, wave_sizze_321920) &\n                              (2 * skip_waves_321952 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_321940 = ((__local\n                                             double *) red_arr_mem_321922)[sext_i32_i64(local_tid_321918 +\n                                                                      ",
            "     offset_321951)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_321941 = x_321939 +\n                                       x_321940;\n                                \n                                x_321939 = defunc_1_op_res_321941;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_321922)[sext_i32_i64(local_tid_321918)] =\n                                    x_321939;\n                            }\n                        }\n                        skip_waves_321952 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_321918 == 0) {\n                            ((__global double *) mem_319066)[gtid_304639 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_304640 *\n                                                             s_n_m_292825 +\n                                                             gtid_304641] =\n                                x_321939;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_304635\n}\n__kernel void mainzisegred_large_304718(__global int *global_failure,\n                                        uint sync_arr_mem_322012_backing_offset_0,\n                                        uint red_arr_mem_322010_backing_offset_1,\n                                        int64_t n_p_292677, int64_t q_s_292678,\n                                 ",
            "       int64_t partition_sizze_292766,\n                                        int64_t defunc_0_f_res_292820,\n                                        int64_t s_n_m_292825,\n                                        int64_t num_groups_304711,\n                                        int64_t groups_per_segment_321996,\n                                        int64_t elements_per_thread_321997,\n                                        int64_t virt_num_groups_321998,\n                                        int64_t threads_per_segment_322000,\n                                        __global unsigned char *ext_mem_318609,\n                                        __global unsigned char *ext_mem_318610,\n                                        __global unsigned char *ext_mem_318707,\n                                        __global unsigned char *ext_mem_318708,\n                                        __global unsigned char *mem_318871,\n                                        __global unsigned char *mem_318876,\n                                        __global unsigned char *mem_319072,\n                                        __global unsigned char *mem_319077,\n                                        __global unsigned char *mem_319083,\n                                        __global\n                                        unsigned char *segred_tmp_mem_322001,\n                                        __global\n                                        unsigned char *mainzicounter_mem_322003)\n{\n    #define segred_group_sizze_304710 (mainzisegred_group_sizze_303886)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_322012_backing_1 =\n                           &shared_mem[sync_arr_mem_322012_backing_offset_0];\n    volatile unsigned char *red_arr_mem_322010_backing_0 =\n                           &shared_mem[red_arr_mem_322010_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    in",
            "t32_t global_tid_322005;\n    int32_t local_tid_322006;\n    int64_t group_sizze_322009;\n    int32_t wave_sizze_322008;\n    int32_t group_tid_322007;\n    \n    global_tid_322005 = get_global_id(0);\n    local_tid_322006 = get_local_id(0);\n    group_sizze_322009 = get_local_size(0);\n    wave_sizze_322008 = LOCKSTEP_WIDTH;\n    group_tid_322007 = get_group_id(0);\n    \n    int32_t phys_tid_304718 = global_tid_322005;\n    __local unsigned char *red_arr_mem_322010;\n    \n    red_arr_mem_322010 = (__local unsigned char *) red_arr_mem_322010_backing_0;\n    \n    __local unsigned char *sync_arr_mem_322012;\n    \n    sync_arr_mem_322012 = (__local\n                           unsigned char *) sync_arr_mem_322012_backing_1;\n    \n    int32_t phys_group_id_322014;\n    \n    phys_group_id_322014 = get_group_id(0);\n    for (int32_t i_322015 = 0; i_322015 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_321998) - phys_group_id_322014,\n                   sext_i64_i32(num_groups_304711)); i_322015++) {\n        int32_t virt_group_id_322016 = phys_group_id_322014 + i_322015 *\n                sext_i64_i32(num_groups_304711);\n        int32_t flat_segment_id_322017 = squot32(virt_group_id_322016,\n                                                 sext_i64_i32(groups_per_segment_321996));\n        int64_t global_tid_322018 = srem64(sext_i32_i64(virt_group_id_322016) *\n                                           segred_group_sizze_304710 +\n                                           sext_i32_i64(local_tid_322006),\n                                           segred_group_sizze_304710 *\n                                           groups_per_segment_321996);\n        int64_t slice_322019 = s_n_m_292825;\n        int64_t slice_322020 = n_p_292677 * slice_322019;\n        int64_t slice_322021 = partition_sizze_292766 * slice_322020;\n        int64_t gtid_304714 = squot64(sext_i32_i64(flat_segment_id_322017),\n                                      slice_322020);\n        int64_t remnant_322022 = sext_i32_i64(flat_segm",
            "ent_id_322017) -\n                gtid_304714 * slice_322020;\n        int64_t gtid_304715 = squot64(remnant_322022, slice_322019);\n        int64_t remnant_322023 = remnant_322022 - gtid_304715 * slice_322019;\n        int64_t gtid_304716 = remnant_322023;\n        int64_t remnant_322024 = remnant_322023 - gtid_304716;\n        int64_t gtid_304717;\n        double x_acc_322025;\n        int64_t chunk_sizze_322026 = smin64(elements_per_thread_321997,\n                                            sdiv_up64(q_s_292678 -\n                                                      global_tid_322018,\n                                                      threads_per_segment_322000));\n        double x_304719;\n        double x_304720;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_322025 = 0.0;\n        }\n        for (int64_t i_322030 = 0; i_322030 < chunk_sizze_322026; i_322030++) {\n            gtid_304717 = global_tid_322018 + threads_per_segment_322000 *\n                i_322030;\n            // apply map function\n            {\n                int64_t x_304733;\n                \n                x_304733 = ((__global int64_t *) ext_mem_318609)[gtid_304714 *\n                                                                 n_p_292677 +\n                                                                 gtid_304715];\n                \n                int64_t x_304738;\n                \n                x_304738 = ((__global int64_t *) ext_mem_318708)[gtid_304714 *\n                                                                 (s_n_m_292825 *\n                                                                  n_p_292677) +\n                                                                 gtid_304715 *\n                                                                 s_n_m_292825 +\n                                                                 gtid_304716];\n                \n                double x_304739;\n                \n                x_304739 = ((__global doub",
            "le *) ext_mem_318707)[gtid_304714 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_304715 *\n                                                                s_n_m_292825 +\n                                                                gtid_304716];\n                \n                double a0_304740;\n                \n                a0_304740 = ((__global double *) mem_319072)[gtid_304714 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_304715 *\n                                                             s_n_m_292825 +\n                                                             gtid_304716];\n                \n                int64_t defunc_0_m_fun_res_304741;\n                \n                defunc_0_m_fun_res_304741 = ((__global\n                                              int64_t *) mem_319077)[gtid_304714 *\n                                                                     (s_n_m_292825 *\n                                                                      n_p_292677) +\n                                                                     gtid_304715 *\n                                                                     s_n_m_292825 +\n                                                                     gtid_304716];\n                \n                bool cond_304743 = sle64(x_304733, gtid_304717);\n                int64_t defunc_0_f_res_304744;\n                \n                if (cond_304743) {\n                    defunc_0_f_res_304744 = (int64_t) 0;\n                } else {\n                    int64_t i_304745 = add64(gtid_304717, x_304738);\n                    int64_t defunc_0_add_arg_304746;\n                    \n",
            "                    defunc_0_add_arg_304746 = ((__global\n                                                int64_t *) ext_mem_318610)[gtid_304714 *\n                                                                           (defunc_0_f_res_292820 *\n                                                                            n_p_292677) +\n                                                                           gtid_304715 *\n                                                                           defunc_0_f_res_292820 +\n                                                                           i_304745];\n                    \n                    int64_t defunc_1_add_res_304747 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_304746);\n                    \n                    defunc_0_f_res_304744 = defunc_1_add_res_304747;\n                }\n                \n                double defunc_0_f_res_304748;\n                \n                if (cond_304743) {\n                    defunc_0_f_res_304748 = 0.0;\n                } else {\n                    int64_t i_304749 = add64(gtid_304717, x_304738);\n                    double defunc_0_add_arg_304750;\n                    \n                    defunc_0_add_arg_304750 = ((__global\n                                                double *) mem_318876)[gtid_304714 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_304715 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_304749];\n                    defunc_0_f_res_304748 = defunc_0_add_arg_304750;\n                }\n                \n                int64_t binop_p_304751 = sub64(defunc_0_f_res_304744,\n                 ",
            "                              defunc_0_m_fun_res_304741);\n                double defunc_0_f_res_304752 = sitofp_i64_f64(binop_p_304751);\n                double abs_res_304753 = fabs(defunc_0_f_res_304752);\n                double tmp1_304754 = abs_res_304753 / x_304739;\n                double x_304755 = tmp1_304754 * tmp1_304754;\n                double y_304756 = tmp1_304754 * x_304755;\n                double tmp2_304757 = 1.0 - y_304756;\n                double x_304758 = tmp2_304757 * tmp2_304757;\n                double tmp3_304759 = tmp2_304757 * x_304758;\n                double tmp4_304760 = defunc_0_f_res_304748 * tmp3_304759;\n                double defunc_0_f_res_304761;\n                \n                if (cond_304743) {\n                    defunc_0_f_res_304761 = 0.0;\n                } else {\n                    int64_t i_304762 = add64(gtid_304717, x_304738);\n                    double defunc_0_add_arg_304763;\n                    \n                    defunc_0_add_arg_304763 = ((__global\n                                                double *) mem_318871)[gtid_304714 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_304715 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_304762];\n                    defunc_0_f_res_304761 = defunc_0_add_arg_304763;\n                }\n                \n                double x_304764 = a0_304740 * tmp4_304760;\n                double defunc_9_fit_fun_res_304765 = defunc_0_f_res_304761 *\n                       x_304764;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_304719 = x_acc_322025;\n                }\n ",
            "               // load new values\n                {\n                    x_304720 = defunc_9_fit_fun_res_304765;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_304721 = x_304719 + x_304720;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_322025 = defunc_1_op_res_304721;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_304719 = x_acc_322025;\n            ((__local\n              double *) red_arr_mem_322010)[sext_i32_i64(local_tid_322006)] =\n                x_304719;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_322031;\n        int32_t skip_waves_322032 = 1;\n        double x_322027;\n        double x_322028;\n        \n        offset_322031 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_322006,\n                      sext_i64_i32(segred_group_sizze_304710))) {\n                x_322027 = ((__local\n                             double *) red_arr_mem_322010)[sext_i32_i64(local_tid_322006 +\n                                                           offset_322031)];\n            }\n        }\n        offset_322031 = 1;\n        while (slt32(offset_322031, wave_sizze_322008)) {\n            if (slt32(local_tid_322006 + offset_322031,\n                      sext_i64_i32(segred_group_sizze_304710)) &&\n                ((local_tid_322006 - squot32(local_tid_322006,\n                                             wave_sizze_322008) *\n                  wave_sizze_322008) & (2 * offset_322031 - 1)) == 0) {\n                // read array element\n                {\n                    x_322028 = ((volatile __local\n                                 double *) red_arr_mem_322010)[sext_i32_i64(local_tid_322006 +\n                                                       ",
            "        offset_322031)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_322029 = x_322027 + x_322028;\n                    \n                    x_322027 = defunc_1_op_res_322029;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_322010)[sext_i32_i64(local_tid_322006)] =\n                        x_322027;\n                }\n            }\n            offset_322031 *= 2;\n        }\n        while (slt32(skip_waves_322032,\n                     squot32(sext_i64_i32(segred_group_sizze_304710) +\n                             wave_sizze_322008 - 1, wave_sizze_322008))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_322031 = skip_waves_322032 * wave_sizze_322008;\n            if (slt32(local_tid_322006 + offset_322031,\n                      sext_i64_i32(segred_group_sizze_304710)) &&\n                ((local_tid_322006 - squot32(local_tid_322006,\n                                             wave_sizze_322008) *\n                  wave_sizze_322008) == 0 && (squot32(local_tid_322006,\n                                                      wave_sizze_322008) & (2 *\n                                                                            skip_waves_322032 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_322028 = ((__local\n                                 double *) red_arr_mem_322010)[sext_i32_i64(local_tid_322006 +\n                                                               offset_322031)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_322029 = x_322027 + x_322028;\n                    \n                    x_322027 = defunc_1_op_res_322029;\n                }\n           ",
            "     // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_322010)[sext_i32_i64(local_tid_322006)] =\n                        x_322027;\n                }\n            }\n            skip_waves_322032 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_322006) == (int64_t) 0) {\n                x_acc_322025 = x_322027;\n            }\n        }\n        if (groups_per_segment_321996 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_322006 == 0) {\n                    ((__global double *) mem_319083)[gtid_304714 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_304715 *\n                                                     s_n_m_292825 +\n                                                     gtid_304716] =\n                        x_acc_322025;\n                }\n            }\n        } else {\n            int32_t old_counter_322033;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_322006 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_322001)[sext_i32_i64(virt_group_id_322016)] =\n                        x_acc_322025;\n                    mem_fence_global();\n                    old_counter_322033 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_322003)[sext_i32_i64(srem32(flat_segment_id_322017,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((",
            "__local bool *) sync_arr_mem_322012)[(int64_t) 0] =\n                        old_counter_322033 == groups_per_segment_321996 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_322034;\n            \n            is_last_group_322034 = ((__local\n                                     bool *) sync_arr_mem_322012)[(int64_t) 0];\n            if (is_last_group_322034) {\n                if (local_tid_322006 == 0) {\n                    old_counter_322033 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_322003)[sext_i32_i64(srem32(flat_segment_id_322017,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_321996));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_322035 =\n                            sdiv_up64(groups_per_segment_321996,\n                                      segred_group_sizze_304710);\n                    \n                    x_304719 = 0.0;\n                    for (int64_t i_322036 = 0; i_322036 <\n                         read_per_thread_322035; i_322036++) {\n                        int64_t group_res_id_322037 =\n                                sext_i32_i64(local_tid_322006) *\n                                read_per_thread_322035 + i_322036;\n                        int64_t index_of_group_res_322038 =\n                                sext_i32_i64(flat_segment_id_322017) *\n                                groups_per_segment_321996 + group_res_id_322037;\n                        \n                        if (slt64(group_res_id_322037,\n                                  groups_per_",
            "segment_321996)) {\n                            x_304720 = ((__global\n                                         double *) segred_tmp_mem_322001)[index_of_group_res_322038];\n                            \n                            double defunc_1_op_res_304721 = x_304719 + x_304720;\n                            \n                            x_304719 = defunc_1_op_res_304721;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_322010)[sext_i32_i64(local_tid_322006)] =\n                    x_304719;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_322039;\n                    int32_t skip_waves_322040 = 1;\n                    double x_322027;\n                    double x_322028;\n                    \n                    offset_322039 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_322006,\n                                  sext_i64_i32(segred_group_sizze_304710))) {\n                            x_322027 = ((__local\n                                         double *) red_arr_mem_322010)[sext_i32_i64(local_tid_322006 +\n                                                                       offset_322039)];\n                        }\n                    }\n                    offset_322039 = 1;\n                    while (slt32(offset_322039, wave_sizze_322008)) {\n                        if (slt32(local_tid_322006 + offset_322039,\n                                  sext_i64_i32(segred_group_sizze_304710)) &&\n                            ((local_tid_322006 - squot32(local_tid_322006,\n                                                         wave_sizze_322008) *\n                              wave_sizze_322008) & (2 * offset_322039 - 1)) ==\n                            0) {\n                            // read array element\n   ",
            "                         {\n                                x_322028 = ((volatile __local\n                                             double *) red_arr_mem_322010)[sext_i32_i64(local_tid_322006 +\n                                                                           offset_322039)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_322029 = x_322027 +\n                                       x_322028;\n                                \n                                x_322027 = defunc_1_op_res_322029;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_322010)[sext_i32_i64(local_tid_322006)] =\n                                    x_322027;\n                            }\n                        }\n                        offset_322039 *= 2;\n                    }\n                    while (slt32(skip_waves_322040,\n                                 squot32(sext_i64_i32(segred_group_sizze_304710) +\n                                         wave_sizze_322008 - 1,\n                                         wave_sizze_322008))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_322039 = skip_waves_322040 * wave_sizze_322008;\n                        if (slt32(local_tid_322006 + offset_322039,\n                                  sext_i64_i32(segred_group_sizze_304710)) &&\n                            ((local_tid_322006 - squot32(local_tid_322006,\n                                                         wave_sizze_322008) *\n                              wave_sizze_322008) == 0 &&\n                             (squot32(local_tid_322006, wave_sizze_322008) &\n                              (2 * skip_waves_322040 - 1)) == 0)) {\n                            // read arra",
            "y element\n                            {\n                                x_322028 = ((__local\n                                             double *) red_arr_mem_322010)[sext_i32_i64(local_tid_322006 +\n                                                                           offset_322039)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_322029 = x_322027 +\n                                       x_322028;\n                                \n                                x_322027 = defunc_1_op_res_322029;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_322010)[sext_i32_i64(local_tid_322006)] =\n                                    x_322027;\n                            }\n                        }\n                        skip_waves_322040 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_322006 == 0) {\n                            ((__global double *) mem_319083)[gtid_304714 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_304715 *\n                                                             s_n_m_292825 +\n                                                             gtid_304716] =\n                                x_322027;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_304710\n}\n__kernel void mainzisegred_large_306191(__global int *global_failure,\n        ",
            "                                uint sync_arr_mem_322247_backing_offset_0,\n                                        uint red_arr_mem_322245_backing_offset_1,\n                                        uint red_arr_mem_322243_backing_offset_2,\n                                        uint red_arr_mem_322241_backing_offset_3,\n                                        int64_t n_p_292677, int64_t q_s_292678,\n                                        int64_t partition_sizze_292766,\n                                        int64_t defunc_0_f_res_292820,\n                                        int64_t s_n_m_292825,\n                                        int64_t num_groups_306182,\n                                        int64_t groups_per_segment_322223,\n                                        int64_t elements_per_thread_322224,\n                                        int64_t virt_num_groups_322225,\n                                        int64_t threads_per_segment_322227,\n                                        __global unsigned char *ext_mem_318609,\n                                        __global unsigned char *ext_mem_318610,\n                                        __global unsigned char *ext_mem_318707,\n                                        __global unsigned char *ext_mem_318708,\n                                        __global unsigned char *mem_318876,\n                                        __global unsigned char *mem_319203,\n                                        __global unsigned char *mem_319213,\n                                        __global unsigned char *mem_319218,\n                                        __global unsigned char *mem_319223,\n                                        __global\n                                        unsigned char *segred_tmp_mem_322228,\n                                        __global\n                                        unsigned char *segred_tmp_mem_322230,\n                                        __global\n                         ",
            "               unsigned char *segred_tmp_mem_322232,\n                                        __global\n                                        unsigned char *mainzicounter_mem_322234)\n{\n    #define segred_group_sizze_306181 (mainzisegred_group_sizze_305373)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_322247_backing_3 =\n                           &shared_mem[sync_arr_mem_322247_backing_offset_0];\n    volatile unsigned char *red_arr_mem_322245_backing_2 =\n                           &shared_mem[red_arr_mem_322245_backing_offset_1];\n    volatile unsigned char *red_arr_mem_322243_backing_1 =\n                           &shared_mem[red_arr_mem_322243_backing_offset_2];\n    volatile unsigned char *red_arr_mem_322241_backing_0 =\n                           &shared_mem[red_arr_mem_322241_backing_offset_3];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322236;\n    int32_t local_tid_322237;\n    int64_t group_sizze_322240;\n    int32_t wave_sizze_322239;\n    int32_t group_tid_322238;\n    \n    global_tid_322236 = get_global_id(0);\n    local_tid_322237 = get_local_id(0);\n    group_sizze_322240 = get_local_size(0);\n    wave_sizze_322239 = LOCKSTEP_WIDTH;\n    group_tid_322238 = get_group_id(0);\n    \n    int32_t phys_tid_306191 = global_tid_322236;\n    __local unsigned char *red_arr_mem_322241;\n    \n    red_arr_mem_322241 = (__local unsigned char *) red_arr_mem_322241_backing_0;\n    \n    __local unsigned char *red_arr_mem_322243;\n    \n    red_arr_mem_322243 = (__local unsigned char *) red_arr_mem_322243_backing_1;\n    \n    __local unsigned char *red_arr_mem_322245;\n    \n    red_arr_mem_322245 = (__local unsigned char *) red_arr_mem_322245_backing_2;\n    \n    __local unsigned char *sync_arr_mem_322247;\n    \n    sync_arr_mem_322247 = (__local\n                           unsigned char *) sync_arr_mem_322247_backing_3;\n    \n    int32_t phys_group_id_322249;\n    \n    ph",
            "ys_group_id_322249 = get_group_id(0);\n    for (int32_t i_322250 = 0; i_322250 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_322225) - phys_group_id_322249,\n                   sext_i64_i32(num_groups_306182)); i_322250++) {\n        int32_t virt_group_id_322251 = phys_group_id_322249 + i_322250 *\n                sext_i64_i32(num_groups_306182);\n        int32_t flat_segment_id_322252 = squot32(virt_group_id_322251,\n                                                 sext_i64_i32(groups_per_segment_322223));\n        int64_t global_tid_322253 = srem64(sext_i32_i64(virt_group_id_322251) *\n                                           segred_group_sizze_306181 +\n                                           sext_i32_i64(local_tid_322237),\n                                           segred_group_sizze_306181 *\n                                           groups_per_segment_322223);\n        int64_t slice_322254 = s_n_m_292825;\n        int64_t slice_322255 = n_p_292677 * slice_322254;\n        int64_t slice_322256 = partition_sizze_292766 * slice_322255;\n        int64_t gtid_306187 = squot64(sext_i32_i64(flat_segment_id_322252),\n                                      slice_322255);\n        int64_t remnant_322257 = sext_i32_i64(flat_segment_id_322252) -\n                gtid_306187 * slice_322255;\n        int64_t gtid_306188 = squot64(remnant_322257, slice_322254);\n        int64_t remnant_322258 = remnant_322257 - gtid_306188 * slice_322254;\n        int64_t gtid_306189 = remnant_322258;\n        int64_t remnant_322259 = remnant_322258 - gtid_306189;\n        int64_t gtid_306190;\n        double x_acc_322260;\n        double x_acc_322261;\n        double x_acc_322262;\n        int64_t chunk_sizze_322263 = smin64(elements_per_thread_322224,\n                                            sdiv_up64(q_s_292678 -\n                                                      global_tid_322253,\n                                                      threads_per_segment_322227));\n        double x_306192;\n        do",
            "uble x_306193;\n        double x_306194;\n        double x_306195;\n        double x_306196;\n        double x_306197;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_322260 = 0.0;\n            x_acc_322261 = 0.0;\n            x_acc_322262 = 0.0;\n        }\n        for (int64_t i_322273 = 0; i_322273 < chunk_sizze_322263; i_322273++) {\n            gtid_306190 = global_tid_322253 + threads_per_segment_322227 *\n                i_322273;\n            // apply map function\n            {\n                int64_t x_306209;\n                \n                x_306209 = ((__global int64_t *) ext_mem_318609)[gtid_306187 *\n                                                                 n_p_292677 +\n                                                                 gtid_306188];\n                \n                int64_t x_306213;\n                \n                x_306213 = ((__global int64_t *) ext_mem_318708)[gtid_306187 *\n                                                                 (s_n_m_292825 *\n                                                                  n_p_292677) +\n                                                                 gtid_306188 *\n                                                                 s_n_m_292825 +\n                                                                 gtid_306189];\n                \n                double x_306214;\n                \n                x_306214 = ((__global double *) ext_mem_318707)[gtid_306187 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_306188 *\n                                                                s_n_m_292825 +\n                                                                gtid_306189];\n                \n                int64_t defunc_0_m_fun_res_306215;\n                \n                defunc_0_m_",
            "fun_res_306215 = ((__global\n                                              int64_t *) mem_319203)[gtid_306187 *\n                                                                     (s_n_m_292825 *\n                                                                      n_p_292677) +\n                                                                     gtid_306188 *\n                                                                     s_n_m_292825 +\n                                                                     gtid_306189];\n                \n                bool cond_306217 = sle64(x_306209, gtid_306190);\n                int64_t defunc_0_f_res_306218;\n                \n                if (cond_306217) {\n                    defunc_0_f_res_306218 = (int64_t) 0;\n                } else {\n                    int64_t i_306219 = add64(gtid_306190, x_306213);\n                    int64_t defunc_0_add_arg_306220;\n                    \n                    defunc_0_add_arg_306220 = ((__global\n                                                int64_t *) ext_mem_318610)[gtid_306187 *\n                                                                           (defunc_0_f_res_292820 *\n                                                                            n_p_292677) +\n                                                                           gtid_306188 *\n                                                                           defunc_0_f_res_292820 +\n                                                                           i_306219];\n                    \n                    int64_t defunc_1_add_res_306221 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_306220);\n                    \n                    defunc_0_f_res_306218 = defunc_1_add_res_306221;\n                }\n                \n                double defunc_0_f_res_306222;\n                \n                if (cond_306217) {\n                    defunc_0_f_res_306222 = 0.0;\n  ",
            "              } else {\n                    int64_t i_306223 = add64(gtid_306190, x_306213);\n                    double defunc_0_add_arg_306224;\n                    \n                    defunc_0_add_arg_306224 = ((__global\n                                                double *) mem_318876)[gtid_306187 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_306188 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_306223];\n                    defunc_0_f_res_306222 = defunc_0_add_arg_306224;\n                }\n                \n                int64_t binop_p_306225 = sub64(defunc_0_f_res_306218,\n                                               defunc_0_m_fun_res_306215);\n                double defunc_0_f_res_306226 = sitofp_i64_f64(binop_p_306225);\n                double abs_res_306227 = fabs(defunc_0_f_res_306226);\n                double tmp1_306228 = abs_res_306227 / x_306214;\n                double x_306229 = tmp1_306228 * tmp1_306228;\n                double y_306230 = tmp1_306228 * x_306229;\n                double tmp2_306231 = 1.0 - y_306230;\n                double x_306232 = tmp2_306231 * tmp2_306231;\n                double tmp3_306233 = tmp2_306231 * x_306232;\n                double w_j_306234 = defunc_0_f_res_306222 * tmp3_306233;\n                double xw_j_306235 = defunc_0_f_res_306226 * w_j_306234;\n                double x2w_j_306236 = defunc_0_f_res_306226 * xw_j_306235;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_306192 = x_acc_322260;\n                    x_306193 = x_acc_322261;\n                    x_306194 = x_acc_322262;\n             ",
            "   }\n                // load new values\n                {\n                    x_306195 = w_j_306234;\n                    x_306196 = xw_j_306235;\n                    x_306197 = x2w_j_306236;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_306198 = x_306192 + x_306195;\n                    double defunc_1_op_res_306199 = x_306193 + x_306196;\n                    double defunc_1_op_res_306200 = x_306194 + x_306197;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_322260 = defunc_1_op_res_306198;\n                        x_acc_322261 = defunc_1_op_res_306199;\n                        x_acc_322262 = defunc_1_op_res_306200;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_306192 = x_acc_322260;\n            x_306193 = x_acc_322261;\n            x_306194 = x_acc_322262;\n            ((__local\n              double *) red_arr_mem_322241)[sext_i32_i64(local_tid_322237)] =\n                x_306192;\n            ((__local\n              double *) red_arr_mem_322243)[sext_i32_i64(local_tid_322237)] =\n                x_306193;\n            ((__local\n              double *) red_arr_mem_322245)[sext_i32_i64(local_tid_322237)] =\n                x_306194;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_322274;\n        int32_t skip_waves_322275 = 1;\n        double x_322264;\n        double x_322265;\n        double x_322266;\n        double x_322267;\n        double x_322268;\n        double x_322269;\n        \n        offset_322274 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_322237,\n                      sext_i64_i32(segred_group_sizze_306181))) {\n                x_322264 = ((__local\n                             double *) red_arr_mem_322241)[sext_i32_i64(local_t",
            "id_322237 +\n                                                           offset_322274)];\n                x_322265 = ((__local\n                             double *) red_arr_mem_322243)[sext_i32_i64(local_tid_322237 +\n                                                           offset_322274)];\n                x_322266 = ((__local\n                             double *) red_arr_mem_322245)[sext_i32_i64(local_tid_322237 +\n                                                           offset_322274)];\n            }\n        }\n        offset_322274 = 1;\n        while (slt32(offset_322274, wave_sizze_322239)) {\n            if (slt32(local_tid_322237 + offset_322274,\n                      sext_i64_i32(segred_group_sizze_306181)) &&\n                ((local_tid_322237 - squot32(local_tid_322237,\n                                             wave_sizze_322239) *\n                  wave_sizze_322239) & (2 * offset_322274 - 1)) == 0) {\n                // read array element\n                {\n                    x_322267 = ((volatile __local\n                                 double *) red_arr_mem_322241)[sext_i32_i64(local_tid_322237 +\n                                                               offset_322274)];\n                    x_322268 = ((volatile __local\n                                 double *) red_arr_mem_322243)[sext_i32_i64(local_tid_322237 +\n                                                               offset_322274)];\n                    x_322269 = ((volatile __local\n                                 double *) red_arr_mem_322245)[sext_i32_i64(local_tid_322237 +\n                                                               offset_322274)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_322270 = x_322264 + x_322267;\n                    double defunc_1_op_res_322271 = x_322265 + x_322268;\n                    double defunc_1_op_res_322272 = x_322266 + x_322269;\n                    \n                    ",
            "x_322264 = defunc_1_op_res_322270;\n                    x_322265 = defunc_1_op_res_322271;\n                    x_322266 = defunc_1_op_res_322272;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_322241)[sext_i32_i64(local_tid_322237)] =\n                        x_322264;\n                    ((volatile __local\n                      double *) red_arr_mem_322243)[sext_i32_i64(local_tid_322237)] =\n                        x_322265;\n                    ((volatile __local\n                      double *) red_arr_mem_322245)[sext_i32_i64(local_tid_322237)] =\n                        x_322266;\n                }\n            }\n            offset_322274 *= 2;\n        }\n        while (slt32(skip_waves_322275,\n                     squot32(sext_i64_i32(segred_group_sizze_306181) +\n                             wave_sizze_322239 - 1, wave_sizze_322239))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_322274 = skip_waves_322275 * wave_sizze_322239;\n            if (slt32(local_tid_322237 + offset_322274,\n                      sext_i64_i32(segred_group_sizze_306181)) &&\n                ((local_tid_322237 - squot32(local_tid_322237,\n                                             wave_sizze_322239) *\n                  wave_sizze_322239) == 0 && (squot32(local_tid_322237,\n                                                      wave_sizze_322239) & (2 *\n                                                                            skip_waves_322275 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_322267 = ((__local\n                                 double *) red_arr_mem_322241)[sext_i32_i64(local_tid_322237 +\n                                                               offset_322274)];\n                    x_322268 = ((__local\n          ",
            "                       double *) red_arr_mem_322243)[sext_i32_i64(local_tid_322237 +\n                                                               offset_322274)];\n                    x_322269 = ((__local\n                                 double *) red_arr_mem_322245)[sext_i32_i64(local_tid_322237 +\n                                                               offset_322274)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_322270 = x_322264 + x_322267;\n                    double defunc_1_op_res_322271 = x_322265 + x_322268;\n                    double defunc_1_op_res_322272 = x_322266 + x_322269;\n                    \n                    x_322264 = defunc_1_op_res_322270;\n                    x_322265 = defunc_1_op_res_322271;\n                    x_322266 = defunc_1_op_res_322272;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_322241)[sext_i32_i64(local_tid_322237)] =\n                        x_322264;\n                    ((__local\n                      double *) red_arr_mem_322243)[sext_i32_i64(local_tid_322237)] =\n                        x_322265;\n                    ((__local\n                      double *) red_arr_mem_322245)[sext_i32_i64(local_tid_322237)] =\n                        x_322266;\n                }\n            }\n            skip_waves_322275 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_322237) == (int64_t) 0) {\n                x_acc_322260 = x_322264;\n                x_acc_322261 = x_322265;\n                x_acc_322262 = x_322266;\n            }\n        }\n        if (groups_per_segment_322223 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_322237 == 0) {\n                    ((__glo",
            "bal double *) mem_319213)[gtid_306187 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_306188 *\n                                                     s_n_m_292825 +\n                                                     gtid_306189] =\n                        x_acc_322260;\n                    ((__global double *) mem_319218)[gtid_306187 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_306188 *\n                                                     s_n_m_292825 +\n                                                     gtid_306189] =\n                        x_acc_322261;\n                    ((__global double *) mem_319223)[gtid_306187 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_306188 *\n                                                     s_n_m_292825 +\n                                                     gtid_306189] =\n                        x_acc_322262;\n                }\n            }\n        } else {\n            int32_t old_counter_322276;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_322237 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_322228)[sext_i32_i64(virt_group_id_322251)] =\n                        x_acc_322260;\n                    ((__global\n                      double *) segred_tmp_mem_322230)[sext_i32_i64(virt_group_id_322251)] =\n                        x_acc_322261;\n                    ((__global\n                      double *) segred_tmp_mem_322232)[sext_i32_i64(virt_group_id_322251)] =\n          ",
            "              x_acc_322262;\n                    mem_fence_global();\n                    old_counter_322276 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_322234)[sext_i32_i64(srem32(flat_segment_id_322252,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_322247)[(int64_t) 0] =\n                        old_counter_322276 == groups_per_segment_322223 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_322277;\n            \n            is_last_group_322277 = ((__local\n                                     bool *) sync_arr_mem_322247)[(int64_t) 0];\n            if (is_last_group_322277) {\n                if (local_tid_322237 == 0) {\n                    old_counter_322276 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_322234)[sext_i32_i64(srem32(flat_segment_id_322252,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_322223));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_322278 =\n                            sdiv_up64(groups_per_segment_322223,\n                                      segred_group_sizze_306181);\n                    \n                    x_306192 = 0.0;\n                    x_306193 = 0.0;\n                    x_306194 = 0.0;\n                    for (int64_t i_322279 = 0; i_322279 <\n                      ",
            "   read_per_thread_322278; i_322279++) {\n                        int64_t group_res_id_322280 =\n                                sext_i32_i64(local_tid_322237) *\n                                read_per_thread_322278 + i_322279;\n                        int64_t index_of_group_res_322281 =\n                                sext_i32_i64(flat_segment_id_322252) *\n                                groups_per_segment_322223 + group_res_id_322280;\n                        \n                        if (slt64(group_res_id_322280,\n                                  groups_per_segment_322223)) {\n                            x_306195 = ((__global\n                                         double *) segred_tmp_mem_322228)[index_of_group_res_322281];\n                            x_306196 = ((__global\n                                         double *) segred_tmp_mem_322230)[index_of_group_res_322281];\n                            x_306197 = ((__global\n                                         double *) segred_tmp_mem_322232)[index_of_group_res_322281];\n                            \n                            double defunc_1_op_res_306198 = x_306192 + x_306195;\n                            double defunc_1_op_res_306199 = x_306193 + x_306196;\n                            double defunc_1_op_res_306200 = x_306194 + x_306197;\n                            \n                            x_306192 = defunc_1_op_res_306198;\n                            x_306193 = defunc_1_op_res_306199;\n                            x_306194 = defunc_1_op_res_306200;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_322241)[sext_i32_i64(local_tid_322237)] =\n                    x_306192;\n                ((__local\n                  double *) red_arr_mem_322243)[sext_i32_i64(local_tid_322237)] =\n                    x_306193;\n                ((__local\n                  double *) red_arr_mem_322245)[sext_i32_i64(local_tid_322237)] =\n                    x",
            "_306194;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_322282;\n                    int32_t skip_waves_322283 = 1;\n                    double x_322264;\n                    double x_322265;\n                    double x_322266;\n                    double x_322267;\n                    double x_322268;\n                    double x_322269;\n                    \n                    offset_322282 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_322237,\n                                  sext_i64_i32(segred_group_sizze_306181))) {\n                            x_322264 = ((__local\n                                         double *) red_arr_mem_322241)[sext_i32_i64(local_tid_322237 +\n                                                                       offset_322282)];\n                            x_322265 = ((__local\n                                         double *) red_arr_mem_322243)[sext_i32_i64(local_tid_322237 +\n                                                                       offset_322282)];\n                            x_322266 = ((__local\n                                         double *) red_arr_mem_322245)[sext_i32_i64(local_tid_322237 +\n                                                                       offset_322282)];\n                        }\n                    }\n                    offset_322282 = 1;\n                    while (slt32(offset_322282, wave_sizze_322239)) {\n                        if (slt32(local_tid_322237 + offset_322282,\n                                  sext_i64_i32(segred_group_sizze_306181)) &&\n                            ((local_tid_322237 - squot32(local_tid_322237,\n                                                         wave_sizze_322239) *\n                              wave_sizze_322239) & (2 * offset_322282 - 1)) ==\n                          ",
            "  0) {\n                            // read array element\n                            {\n                                x_322267 = ((volatile __local\n                                             double *) red_arr_mem_322241)[sext_i32_i64(local_tid_322237 +\n                                                                           offset_322282)];\n                                x_322268 = ((volatile __local\n                                             double *) red_arr_mem_322243)[sext_i32_i64(local_tid_322237 +\n                                                                           offset_322282)];\n                                x_322269 = ((volatile __local\n                                             double *) red_arr_mem_322245)[sext_i32_i64(local_tid_322237 +\n                                                                           offset_322282)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_322270 = x_322264 +\n                                       x_322267;\n                                double defunc_1_op_res_322271 = x_322265 +\n                                       x_322268;\n                                double defunc_1_op_res_322272 = x_322266 +\n                                       x_322269;\n                                \n                                x_322264 = defunc_1_op_res_322270;\n                                x_322265 = defunc_1_op_res_322271;\n                                x_322266 = defunc_1_op_res_322272;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_322241)[sext_i32_i64(local_tid_322237)] =\n                                    x_322264;\n                                ((volatile __local\n                                  double *) ",
            "red_arr_mem_322243)[sext_i32_i64(local_tid_322237)] =\n                                    x_322265;\n                                ((volatile __local\n                                  double *) red_arr_mem_322245)[sext_i32_i64(local_tid_322237)] =\n                                    x_322266;\n                            }\n                        }\n                        offset_322282 *= 2;\n                    }\n                    while (slt32(skip_waves_322283,\n                                 squot32(sext_i64_i32(segred_group_sizze_306181) +\n                                         wave_sizze_322239 - 1,\n                                         wave_sizze_322239))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_322282 = skip_waves_322283 * wave_sizze_322239;\n                        if (slt32(local_tid_322237 + offset_322282,\n                                  sext_i64_i32(segred_group_sizze_306181)) &&\n                            ((local_tid_322237 - squot32(local_tid_322237,\n                                                         wave_sizze_322239) *\n                              wave_sizze_322239) == 0 &&\n                             (squot32(local_tid_322237, wave_sizze_322239) &\n                              (2 * skip_waves_322283 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_322267 = ((__local\n                                             double *) red_arr_mem_322241)[sext_i32_i64(local_tid_322237 +\n                                                                           offset_322282)];\n                                x_322268 = ((__local\n                                             double *) red_arr_mem_322243)[sext_i32_i64(local_tid_322237 +\n                                                                           offset_322282)];\n                                x_322269 = ((__local\n                                             doub",
            "le *) red_arr_mem_322245)[sext_i32_i64(local_tid_322237 +\n                                                                           offset_322282)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_322270 = x_322264 +\n                                       x_322267;\n                                double defunc_1_op_res_322271 = x_322265 +\n                                       x_322268;\n                                double defunc_1_op_res_322272 = x_322266 +\n                                       x_322269;\n                                \n                                x_322264 = defunc_1_op_res_322270;\n                                x_322265 = defunc_1_op_res_322271;\n                                x_322266 = defunc_1_op_res_322272;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_322241)[sext_i32_i64(local_tid_322237)] =\n                                    x_322264;\n                                ((__local\n                                  double *) red_arr_mem_322243)[sext_i32_i64(local_tid_322237)] =\n                                    x_322265;\n                                ((__local\n                                  double *) red_arr_mem_322245)[sext_i32_i64(local_tid_322237)] =\n                                    x_322266;\n                            }\n                        }\n                        skip_waves_322283 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_322237 == 0) {\n                            ((__global double *) mem_319213)[gtid_306187 *\n                                                             (s_n_m_292825 *\n                                   ",
            "                           n_p_292677) +\n                                                             gtid_306188 *\n                                                             s_n_m_292825 +\n                                                             gtid_306189] =\n                                x_322264;\n                            ((__global double *) mem_319218)[gtid_306187 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_306188 *\n                                                             s_n_m_292825 +\n                                                             gtid_306189] =\n                                x_322265;\n                            ((__global double *) mem_319223)[gtid_306187 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_306188 *\n                                                             s_n_m_292825 +\n                                                             gtid_306189] =\n                                x_322266;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_306181\n}\n__kernel void mainzisegred_large_306288(__global int *global_failure,\n                                        uint sync_arr_mem_322353_backing_offset_0,\n                                        uint red_arr_mem_322351_backing_offset_1,\n                                        uint red_arr_mem_322349_backing_offset_2,\n                                        int64_t n_p_292677, int64_t q_s_292678,\n                                        int64_t partition_sizze_292766,\n   ",
            "                                     int64_t defunc_0_f_res_292820,\n                                        int64_t s_n_m_292825,\n                                        int64_t num_groups_306280,\n                                        int64_t groups_per_segment_322333,\n                                        int64_t elements_per_thread_322334,\n                                        int64_t virt_num_groups_322335,\n                                        int64_t threads_per_segment_322337,\n                                        __global unsigned char *ext_mem_318609,\n                                        __global unsigned char *ext_mem_318610,\n                                        __global unsigned char *ext_mem_318707,\n                                        __global unsigned char *ext_mem_318708,\n                                        __global unsigned char *mem_318871,\n                                        __global unsigned char *mem_318876,\n                                        __global unsigned char *mem_319229,\n                                        __global unsigned char *mem_319234,\n                                        __global unsigned char *mem_319239,\n                                        __global unsigned char *mem_319244,\n                                        __global unsigned char *mem_319250,\n                                        __global unsigned char *mem_319255,\n                                        __global\n                                        unsigned char *segred_tmp_mem_322338,\n                                        __global\n                                        unsigned char *segred_tmp_mem_322340,\n                                        __global\n                                        unsigned char *mainzicounter_mem_322342)\n{\n    #define segred_group_sizze_306279 (mainzisegred_group_sizze_305237)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned c",
            "har *sync_arr_mem_322353_backing_2 =\n                           &shared_mem[sync_arr_mem_322353_backing_offset_0];\n    volatile unsigned char *red_arr_mem_322351_backing_1 =\n                           &shared_mem[red_arr_mem_322351_backing_offset_1];\n    volatile unsigned char *red_arr_mem_322349_backing_0 =\n                           &shared_mem[red_arr_mem_322349_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322344;\n    int32_t local_tid_322345;\n    int64_t group_sizze_322348;\n    int32_t wave_sizze_322347;\n    int32_t group_tid_322346;\n    \n    global_tid_322344 = get_global_id(0);\n    local_tid_322345 = get_local_id(0);\n    group_sizze_322348 = get_local_size(0);\n    wave_sizze_322347 = LOCKSTEP_WIDTH;\n    group_tid_322346 = get_group_id(0);\n    \n    int32_t phys_tid_306288 = global_tid_322344;\n    __local unsigned char *red_arr_mem_322349;\n    \n    red_arr_mem_322349 = (__local unsigned char *) red_arr_mem_322349_backing_0;\n    \n    __local unsigned char *red_arr_mem_322351;\n    \n    red_arr_mem_322351 = (__local unsigned char *) red_arr_mem_322351_backing_1;\n    \n    __local unsigned char *sync_arr_mem_322353;\n    \n    sync_arr_mem_322353 = (__local\n                           unsigned char *) sync_arr_mem_322353_backing_2;\n    \n    int32_t phys_group_id_322355;\n    \n    phys_group_id_322355 = get_group_id(0);\n    for (int32_t i_322356 = 0; i_322356 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_322335) - phys_group_id_322355,\n                   sext_i64_i32(num_groups_306280)); i_322356++) {\n        int32_t virt_group_id_322357 = phys_group_id_322355 + i_322356 *\n                sext_i64_i32(num_groups_306280);\n        int32_t flat_segment_id_322358 = squot32(virt_group_id_322357,\n                                                 sext_i64_i32(groups_per_segment_322333));\n        int64_t global_tid_322359 = srem64(sext_i32_i64(virt_group_id_322357) *\n                                           segred_group_si",
            "zze_306279 +\n                                           sext_i32_i64(local_tid_322345),\n                                           segred_group_sizze_306279 *\n                                           groups_per_segment_322333);\n        int64_t slice_322360 = s_n_m_292825;\n        int64_t slice_322361 = n_p_292677 * slice_322360;\n        int64_t slice_322362 = partition_sizze_292766 * slice_322361;\n        int64_t gtid_306284 = squot64(sext_i32_i64(flat_segment_id_322358),\n                                      slice_322361);\n        int64_t remnant_322363 = sext_i32_i64(flat_segment_id_322358) -\n                gtid_306284 * slice_322361;\n        int64_t gtid_306285 = squot64(remnant_322363, slice_322360);\n        int64_t remnant_322364 = remnant_322363 - gtid_306285 * slice_322360;\n        int64_t gtid_306286 = remnant_322364;\n        int64_t remnant_322365 = remnant_322364 - gtid_306286;\n        int64_t gtid_306287;\n        double x_acc_322366;\n        double x_acc_322367;\n        int64_t chunk_sizze_322368 = smin64(elements_per_thread_322334,\n                                            sdiv_up64(q_s_292678 -\n                                                      global_tid_322359,\n                                                      threads_per_segment_322337));\n        double x_306289;\n        double x_306290;\n        double x_306291;\n        double x_306292;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_322366 = 0.0;\n            x_acc_322367 = 0.0;\n        }\n        for (int64_t i_322375 = 0; i_322375 < chunk_sizze_322368; i_322375++) {\n            gtid_306287 = global_tid_322359 + threads_per_segment_322337 *\n                i_322375;\n            // apply map function\n            {\n                int64_t x_306308;\n                \n                x_306308 = ((__global int64_t *) ext_mem_318609)[gtid_306284 *\n                                                                 n_p_292677 +\n                                    ",
            "                             gtid_306285];\n                \n                int64_t x_306315;\n                \n                x_306315 = ((__global int64_t *) ext_mem_318708)[gtid_306284 *\n                                                                 (s_n_m_292825 *\n                                                                  n_p_292677) +\n                                                                 gtid_306285 *\n                                                                 s_n_m_292825 +\n                                                                 gtid_306286];\n                \n                double x_306316;\n                \n                x_306316 = ((__global double *) ext_mem_318707)[gtid_306284 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_306285 *\n                                                                s_n_m_292825 +\n                                                                gtid_306286];\n                \n                double a11_306317;\n                \n                a11_306317 = ((__global double *) mem_319229)[gtid_306284 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                                              gtid_306285 *\n                                                              s_n_m_292825 +\n                                                              gtid_306286];\n                \n                double b11_306318;\n                \n                b11_306318 = ((__global double *) mem_319234)[gtid_306284 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                           ",
            "                   gtid_306285 *\n                                                              s_n_m_292825 +\n                                                              gtid_306286];\n                \n                double c11_306319;\n                \n                c11_306319 = ((__global double *) mem_319239)[gtid_306284 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                                              gtid_306285 *\n                                                              s_n_m_292825 +\n                                                              gtid_306286];\n                \n                int64_t defunc_0_m_fun_res_306320;\n                \n                defunc_0_m_fun_res_306320 = ((__global\n                                              int64_t *) mem_319244)[gtid_306284 *\n                                                                     (s_n_m_292825 *\n                                                                      n_p_292677) +\n                                                                     gtid_306285 *\n                                                                     s_n_m_292825 +\n                                                                     gtid_306286];\n                \n                bool cond_306322 = sle64(x_306308, gtid_306287);\n                int64_t defunc_0_f_res_306323;\n                \n                if (cond_306322) {\n                    defunc_0_f_res_306323 = (int64_t) 0;\n                } else {\n                    int64_t i_306324 = add64(gtid_306287, x_306315);\n                    int64_t defunc_0_add_arg_306325;\n                    \n                    defunc_0_add_arg_306325 = ((__global\n                                                int64_t *) ext_mem_318610)[gtid_306284 *\n                                                                           (defunc_0_f_res_",
            "292820 *\n                                                                            n_p_292677) +\n                                                                           gtid_306285 *\n                                                                           defunc_0_f_res_292820 +\n                                                                           i_306324];\n                    \n                    int64_t defunc_1_add_res_306326 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_306325);\n                    \n                    defunc_0_f_res_306323 = defunc_1_add_res_306326;\n                }\n                \n                double defunc_0_f_res_306327;\n                \n                if (cond_306322) {\n                    defunc_0_f_res_306327 = 0.0;\n                } else {\n                    int64_t i_306328 = add64(gtid_306287, x_306315);\n                    double defunc_0_add_arg_306329;\n                    \n                    defunc_0_add_arg_306329 = ((__global\n                                                double *) mem_318876)[gtid_306284 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_306285 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_306328];\n                    defunc_0_f_res_306327 = defunc_0_add_arg_306329;\n                }\n                \n                int64_t binop_p_306330 = sub64(defunc_0_f_res_306323,\n                                               defunc_0_m_fun_res_306320);\n                double defunc_0_f_res_306331 = sitofp_i64_f64(binop_p_306330);\n                double abs_res_306332 = fabs(defunc_0_f_res_306331);\n                double tmp1_306",
            "333 = abs_res_306332 / x_306316;\n                double x_306334 = tmp1_306333 * tmp1_306333;\n                double y_306335 = tmp1_306333 * x_306334;\n                double tmp2_306336 = 1.0 - y_306335;\n                double x_306337 = tmp2_306336 * tmp2_306336;\n                double tmp3_306338 = tmp2_306336 * x_306337;\n                double tmp4_306339 = defunc_0_f_res_306327 * tmp3_306338;\n                double defunc_1_f_res_306340 = defunc_0_f_res_306331 *\n                       tmp4_306339;\n                double defunc_0_f_res_306341;\n                \n                if (cond_306322) {\n                    defunc_0_f_res_306341 = 0.0;\n                } else {\n                    int64_t i_306342 = add64(gtid_306287, x_306315);\n                    double defunc_0_add_arg_306343;\n                    \n                    defunc_0_add_arg_306343 = ((__global\n                                                double *) mem_318871)[gtid_306284 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_306285 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_306342];\n                    defunc_0_f_res_306341 = defunc_0_add_arg_306343;\n                }\n                \n                double x_306344 = a11_306317 * tmp4_306339;\n                double y_306345 = b11_306318 * defunc_1_f_res_306340;\n                double x_306346 = x_306344 + y_306345;\n                double defunc_9_fit_fun_res_306347 = defunc_0_f_res_306341 *\n                       x_306346;\n                double x_306348 = b11_306318 * tmp4_306339;\n                double y_306349 = c11_306319 * defunc_1_f_res_306340;\n                double x_306350 = x_306348 + y_306349;\n              ",
            "  double defunc_9_slope_fun_res_306351 = defunc_0_f_res_306341 *\n                       x_306350;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_306289 = x_acc_322366;\n                    x_306290 = x_acc_322367;\n                }\n                // load new values\n                {\n                    x_306291 = defunc_9_fit_fun_res_306347;\n                    x_306292 = defunc_9_slope_fun_res_306351;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_306293 = x_306289 + x_306291;\n                    double defunc_1_op_res_306294 = x_306290 + x_306292;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_322366 = defunc_1_op_res_306293;\n                        x_acc_322367 = defunc_1_op_res_306294;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_306289 = x_acc_322366;\n            x_306290 = x_acc_322367;\n            ((__local\n              double *) red_arr_mem_322349)[sext_i32_i64(local_tid_322345)] =\n                x_306289;\n            ((__local\n              double *) red_arr_mem_322351)[sext_i32_i64(local_tid_322345)] =\n                x_306290;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_322376;\n        int32_t skip_waves_322377 = 1;\n        double x_322369;\n        double x_322370;\n        double x_322371;\n        double x_322372;\n        \n        offset_322376 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_322345,\n                      sext_i64_i32(segred_group_sizze_306279))) {\n                x_322369 = ((__local\n                             double *) red_arr_mem_322349)[sext_i32_i64(local_tid_322345 +\n               ",
            "                                            offset_322376)];\n                x_322370 = ((__local\n                             double *) red_arr_mem_322351)[sext_i32_i64(local_tid_322345 +\n                                                           offset_322376)];\n            }\n        }\n        offset_322376 = 1;\n        while (slt32(offset_322376, wave_sizze_322347)) {\n            if (slt32(local_tid_322345 + offset_322376,\n                      sext_i64_i32(segred_group_sizze_306279)) &&\n                ((local_tid_322345 - squot32(local_tid_322345,\n                                             wave_sizze_322347) *\n                  wave_sizze_322347) & (2 * offset_322376 - 1)) == 0) {\n                // read array element\n                {\n                    x_322371 = ((volatile __local\n                                 double *) red_arr_mem_322349)[sext_i32_i64(local_tid_322345 +\n                                                               offset_322376)];\n                    x_322372 = ((volatile __local\n                                 double *) red_arr_mem_322351)[sext_i32_i64(local_tid_322345 +\n                                                               offset_322376)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_322373 = x_322369 + x_322371;\n                    double defunc_1_op_res_322374 = x_322370 + x_322372;\n                    \n                    x_322369 = defunc_1_op_res_322373;\n                    x_322370 = defunc_1_op_res_322374;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_322349)[sext_i32_i64(local_tid_322345)] =\n                        x_322369;\n                    ((volatile __local\n                      double *) red_arr_mem_322351)[sext_i32_i64(local_tid_322345)] =\n                        x_322370;\n                }\n            }\n        ",
            "    offset_322376 *= 2;\n        }\n        while (slt32(skip_waves_322377,\n                     squot32(sext_i64_i32(segred_group_sizze_306279) +\n                             wave_sizze_322347 - 1, wave_sizze_322347))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_322376 = skip_waves_322377 * wave_sizze_322347;\n            if (slt32(local_tid_322345 + offset_322376,\n                      sext_i64_i32(segred_group_sizze_306279)) &&\n                ((local_tid_322345 - squot32(local_tid_322345,\n                                             wave_sizze_322347) *\n                  wave_sizze_322347) == 0 && (squot32(local_tid_322345,\n                                                      wave_sizze_322347) & (2 *\n                                                                            skip_waves_322377 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_322371 = ((__local\n                                 double *) red_arr_mem_322349)[sext_i32_i64(local_tid_322345 +\n                                                               offset_322376)];\n                    x_322372 = ((__local\n                                 double *) red_arr_mem_322351)[sext_i32_i64(local_tid_322345 +\n                                                               offset_322376)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_322373 = x_322369 + x_322371;\n                    double defunc_1_op_res_322374 = x_322370 + x_322372;\n                    \n                    x_322369 = defunc_1_op_res_322373;\n                    x_322370 = defunc_1_op_res_322374;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_322349)[sext_i32_i64(local_tid_322345)] =\n                       ",
            " x_322369;\n                    ((__local\n                      double *) red_arr_mem_322351)[sext_i32_i64(local_tid_322345)] =\n                        x_322370;\n                }\n            }\n            skip_waves_322377 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_322345) == (int64_t) 0) {\n                x_acc_322366 = x_322369;\n                x_acc_322367 = x_322370;\n            }\n        }\n        if (groups_per_segment_322333 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_322345 == 0) {\n                    ((__global double *) mem_319250)[gtid_306284 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_306285 *\n                                                     s_n_m_292825 +\n                                                     gtid_306286] =\n                        x_acc_322366;\n                    ((__global double *) mem_319255)[gtid_306284 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_306285 *\n                                                     s_n_m_292825 +\n                                                     gtid_306286] =\n                        x_acc_322367;\n                }\n            }\n        } else {\n            int32_t old_counter_322378;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_322345 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_322338)[sext_i32_i64(virt_group_id_322357)] =\n                        x_acc_322366;\n                   ",
            " ((__global\n                      double *) segred_tmp_mem_322340)[sext_i32_i64(virt_group_id_322357)] =\n                        x_acc_322367;\n                    mem_fence_global();\n                    old_counter_322378 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_322342)[sext_i32_i64(srem32(flat_segment_id_322358,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_322353)[(int64_t) 0] =\n                        old_counter_322378 == groups_per_segment_322333 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_322379;\n            \n            is_last_group_322379 = ((__local\n                                     bool *) sync_arr_mem_322353)[(int64_t) 0];\n            if (is_last_group_322379) {\n                if (local_tid_322345 == 0) {\n                    old_counter_322378 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_322342)[sext_i32_i64(srem32(flat_segment_id_322358,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_322333));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_322380 =\n                            sdiv_up64(groups_per_segment_322333,\n                                      segred_group_sizze_306279);\n                    \n                    x_306289 = 0.0;\n                    x_306290 = 0.0;\n ",
            "                   for (int64_t i_322381 = 0; i_322381 <\n                         read_per_thread_322380; i_322381++) {\n                        int64_t group_res_id_322382 =\n                                sext_i32_i64(local_tid_322345) *\n                                read_per_thread_322380 + i_322381;\n                        int64_t index_of_group_res_322383 =\n                                sext_i32_i64(flat_segment_id_322358) *\n                                groups_per_segment_322333 + group_res_id_322382;\n                        \n                        if (slt64(group_res_id_322382,\n                                  groups_per_segment_322333)) {\n                            x_306291 = ((__global\n                                         double *) segred_tmp_mem_322338)[index_of_group_res_322383];\n                            x_306292 = ((__global\n                                         double *) segred_tmp_mem_322340)[index_of_group_res_322383];\n                            \n                            double defunc_1_op_res_306293 = x_306289 + x_306291;\n                            double defunc_1_op_res_306294 = x_306290 + x_306292;\n                            \n                            x_306289 = defunc_1_op_res_306293;\n                            x_306290 = defunc_1_op_res_306294;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_322349)[sext_i32_i64(local_tid_322345)] =\n                    x_306289;\n                ((__local\n                  double *) red_arr_mem_322351)[sext_i32_i64(local_tid_322345)] =\n                    x_306290;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_322384;\n                    int32_t skip_waves_322385 = 1;\n                    double x_322369;\n                    double x_322370;\n                    double x_322371;\n                    double x_",
            "322372;\n                    \n                    offset_322384 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_322345,\n                                  sext_i64_i32(segred_group_sizze_306279))) {\n                            x_322369 = ((__local\n                                         double *) red_arr_mem_322349)[sext_i32_i64(local_tid_322345 +\n                                                                       offset_322384)];\n                            x_322370 = ((__local\n                                         double *) red_arr_mem_322351)[sext_i32_i64(local_tid_322345 +\n                                                                       offset_322384)];\n                        }\n                    }\n                    offset_322384 = 1;\n                    while (slt32(offset_322384, wave_sizze_322347)) {\n                        if (slt32(local_tid_322345 + offset_322384,\n                                  sext_i64_i32(segred_group_sizze_306279)) &&\n                            ((local_tid_322345 - squot32(local_tid_322345,\n                                                         wave_sizze_322347) *\n                              wave_sizze_322347) & (2 * offset_322384 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_322371 = ((volatile __local\n                                             double *) red_arr_mem_322349)[sext_i32_i64(local_tid_322345 +\n                                                                           offset_322384)];\n                                x_322372 = ((volatile __local\n                                             double *) red_arr_mem_322351)[sext_i32_i64(local_tid_322345 +\n                                                                           offset_322384)];\n                            }\n                            //",
            " apply reduction operation\n                            {\n                                double defunc_1_op_res_322373 = x_322369 +\n                                       x_322371;\n                                double defunc_1_op_res_322374 = x_322370 +\n                                       x_322372;\n                                \n                                x_322369 = defunc_1_op_res_322373;\n                                x_322370 = defunc_1_op_res_322374;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_322349)[sext_i32_i64(local_tid_322345)] =\n                                    x_322369;\n                                ((volatile __local\n                                  double *) red_arr_mem_322351)[sext_i32_i64(local_tid_322345)] =\n                                    x_322370;\n                            }\n                        }\n                        offset_322384 *= 2;\n                    }\n                    while (slt32(skip_waves_322385,\n                                 squot32(sext_i64_i32(segred_group_sizze_306279) +\n                                         wave_sizze_322347 - 1,\n                                         wave_sizze_322347))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_322384 = skip_waves_322385 * wave_sizze_322347;\n                        if (slt32(local_tid_322345 + offset_322384,\n                                  sext_i64_i32(segred_group_sizze_306279)) &&\n                            ((local_tid_322345 - squot32(local_tid_322345,\n                                                         wave_sizze_322347) *\n                              wave_sizze_322347) == 0 &&\n                             (squot32(local_tid_322345, wave_sizze_322347) &\n                              (2 * skip_waves_322385 - 1)) == 0)) {\n  ",
            "                          // read array element\n                            {\n                                x_322371 = ((__local\n                                             double *) red_arr_mem_322349)[sext_i32_i64(local_tid_322345 +\n                                                                           offset_322384)];\n                                x_322372 = ((__local\n                                             double *) red_arr_mem_322351)[sext_i32_i64(local_tid_322345 +\n                                                                           offset_322384)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_322373 = x_322369 +\n                                       x_322371;\n                                double defunc_1_op_res_322374 = x_322370 +\n                                       x_322372;\n                                \n                                x_322369 = defunc_1_op_res_322373;\n                                x_322370 = defunc_1_op_res_322374;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_322349)[sext_i32_i64(local_tid_322345)] =\n                                    x_322369;\n                                ((__local\n                                  double *) red_arr_mem_322351)[sext_i32_i64(local_tid_322345)] =\n                                    x_322370;\n                            }\n                        }\n                        skip_waves_322385 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_322345 == 0) {\n                            ((__global double *) mem_319250)[gtid_306284 *\n                                                         ",
            "    (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_306285 *\n                                                             s_n_m_292825 +\n                                                             gtid_306286] =\n                                x_322369;\n                            ((__global double *) mem_319255)[gtid_306284 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_306285 *\n                                                             s_n_m_292825 +\n                                                             gtid_306286] =\n                                x_322370;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_306279\n}\n__kernel void mainzisegred_large_308109(__global int *global_failure,\n                                        uint sync_arr_mem_322634_backing_offset_0,\n                                        uint red_arr_mem_322632_backing_offset_1,\n                                        uint red_arr_mem_322630_backing_offset_2,\n                                        uint red_arr_mem_322628_backing_offset_3,\n                                        uint red_arr_mem_322626_backing_offset_4,\n                                        uint red_arr_mem_322624_backing_offset_5,\n                                        int64_t n_p_292677, int64_t q_s_292678,\n                                        int64_t partition_sizze_292766,\n                                        int64_t defunc_0_f_res_292820,\n                                        int64_t s_n_m_292825,\n                                        int64_t num_groups_308098,",
            "\n                                        int64_t groups_per_segment_322602,\n                                        int64_t elements_per_thread_322603,\n                                        int64_t virt_num_groups_322604,\n                                        int64_t threads_per_segment_322606,\n                                        __global unsigned char *ext_mem_318609,\n                                        __global unsigned char *ext_mem_318610,\n                                        __global unsigned char *ext_mem_318707,\n                                        __global unsigned char *ext_mem_318708,\n                                        __global unsigned char *mem_318876,\n                                        __global unsigned char *mem_319395,\n                                        __global unsigned char *mem_319405,\n                                        __global unsigned char *mem_319410,\n                                        __global unsigned char *mem_319415,\n                                        __global unsigned char *mem_319420,\n                                        __global unsigned char *mem_319425,\n                                        __global\n                                        unsigned char *segred_tmp_mem_322607,\n                                        __global\n                                        unsigned char *segred_tmp_mem_322609,\n                                        __global\n                                        unsigned char *segred_tmp_mem_322611,\n                                        __global\n                                        unsigned char *segred_tmp_mem_322613,\n                                        __global\n                                        unsigned char *segred_tmp_mem_322615,\n                                        __global\n                                        unsigned char *mainzicounter_mem_322617)\n{\n    #define segred_group_sizze_308097 (mainzisegred_group_sizze_307119)\n    \n    ",
            "const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_322634_backing_5 =\n                           &shared_mem[sync_arr_mem_322634_backing_offset_0];\n    volatile unsigned char *red_arr_mem_322632_backing_4 =\n                           &shared_mem[red_arr_mem_322632_backing_offset_1];\n    volatile unsigned char *red_arr_mem_322630_backing_3 =\n                           &shared_mem[red_arr_mem_322630_backing_offset_2];\n    volatile unsigned char *red_arr_mem_322628_backing_2 =\n                           &shared_mem[red_arr_mem_322628_backing_offset_3];\n    volatile unsigned char *red_arr_mem_322626_backing_1 =\n                           &shared_mem[red_arr_mem_322626_backing_offset_4];\n    volatile unsigned char *red_arr_mem_322624_backing_0 =\n                           &shared_mem[red_arr_mem_322624_backing_offset_5];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322619;\n    int32_t local_tid_322620;\n    int64_t group_sizze_322623;\n    int32_t wave_sizze_322622;\n    int32_t group_tid_322621;\n    \n    global_tid_322619 = get_global_id(0);\n    local_tid_322620 = get_local_id(0);\n    group_sizze_322623 = get_local_size(0);\n    wave_sizze_322622 = LOCKSTEP_WIDTH;\n    group_tid_322621 = get_group_id(0);\n    \n    int32_t phys_tid_308109 = global_tid_322619;\n    __local unsigned char *red_arr_mem_322624;\n    \n    red_arr_mem_322624 = (__local unsigned char *) red_arr_mem_322624_backing_0;\n    \n    __local unsigned char *red_arr_mem_322626;\n    \n    red_arr_mem_322626 = (__local unsigned char *) red_arr_mem_322626_backing_1;\n    \n    __local unsigned char *red_arr_mem_322628;\n    \n    red_arr_mem_322628 = (__local unsigned char *) red_arr_mem_322628_backing_2;\n    \n    __local unsigned char *red_arr_mem_322630;\n    \n    red_arr_mem_322630 = (__local unsigned char *) red_arr_mem_322630_backing_3;\n    \n    __local unsigned char *red_arr_mem_322632;\n    \n    red_arr_mem_3",
            "22632 = (__local unsigned char *) red_arr_mem_322632_backing_4;\n    \n    __local unsigned char *sync_arr_mem_322634;\n    \n    sync_arr_mem_322634 = (__local\n                           unsigned char *) sync_arr_mem_322634_backing_5;\n    \n    int32_t phys_group_id_322636;\n    \n    phys_group_id_322636 = get_group_id(0);\n    for (int32_t i_322637 = 0; i_322637 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_322604) - phys_group_id_322636,\n                   sext_i64_i32(num_groups_308098)); i_322637++) {\n        int32_t virt_group_id_322638 = phys_group_id_322636 + i_322637 *\n                sext_i64_i32(num_groups_308098);\n        int32_t flat_segment_id_322639 = squot32(virt_group_id_322638,\n                                                 sext_i64_i32(groups_per_segment_322602));\n        int64_t global_tid_322640 = srem64(sext_i32_i64(virt_group_id_322638) *\n                                           segred_group_sizze_308097 +\n                                           sext_i32_i64(local_tid_322620),\n                                           segred_group_sizze_308097 *\n                                           groups_per_segment_322602);\n        int64_t slice_322641 = s_n_m_292825;\n        int64_t slice_322642 = n_p_292677 * slice_322641;\n        int64_t slice_322643 = partition_sizze_292766 * slice_322642;\n        int64_t gtid_308105 = squot64(sext_i32_i64(flat_segment_id_322639),\n                                      slice_322642);\n        int64_t remnant_322644 = sext_i32_i64(flat_segment_id_322639) -\n                gtid_308105 * slice_322642;\n        int64_t gtid_308106 = squot64(remnant_322644, slice_322641);\n        int64_t remnant_322645 = remnant_322644 - gtid_308106 * slice_322641;\n        int64_t gtid_308107 = remnant_322645;\n        int64_t remnant_322646 = remnant_322645 - gtid_308107;\n        int64_t gtid_308108;\n        double x_acc_322647;\n        double x_acc_322648;\n        double x_acc_322649;\n        double x_acc_322650;\n        double x_acc",
            "_322651;\n        int64_t chunk_sizze_322652 = smin64(elements_per_thread_322603,\n                                            sdiv_up64(q_s_292678 -\n                                                      global_tid_322640,\n                                                      threads_per_segment_322606));\n        double x_308110;\n        double x_308111;\n        double x_308112;\n        double x_308113;\n        double x_308114;\n        double x_308115;\n        double x_308116;\n        double x_308117;\n        double x_308118;\n        double x_308119;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_322647 = 0.0;\n            x_acc_322648 = 0.0;\n            x_acc_322649 = 0.0;\n            x_acc_322650 = 0.0;\n            x_acc_322651 = 0.0;\n        }\n        for (int64_t i_322668 = 0; i_322668 < chunk_sizze_322652; i_322668++) {\n            gtid_308108 = global_tid_322640 + threads_per_segment_322606 *\n                i_322668;\n            // apply map function\n            {\n                int64_t x_308133;\n                \n                x_308133 = ((__global int64_t *) ext_mem_318609)[gtid_308105 *\n                                                                 n_p_292677 +\n                                                                 gtid_308106];\n                \n                int64_t x_308137;\n                \n                x_308137 = ((__global int64_t *) ext_mem_318708)[gtid_308105 *\n                                                                 (s_n_m_292825 *\n                                                                  n_p_292677) +\n                                                                 gtid_308106 *\n                                                                 s_n_m_292825 +\n                                                                 gtid_308107];\n                \n                double x_308138;\n                \n                x_308138 = ((__global double *) ext_mem_318707)[gtid_308105 *\n  ",
            "                                                              (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_308106 *\n                                                                s_n_m_292825 +\n                                                                gtid_308107];\n                \n                int64_t defunc_0_m_fun_res_308139;\n                \n                defunc_0_m_fun_res_308139 = ((__global\n                                              int64_t *) mem_319395)[gtid_308105 *\n                                                                     (s_n_m_292825 *\n                                                                      n_p_292677) +\n                                                                     gtid_308106 *\n                                                                     s_n_m_292825 +\n                                                                     gtid_308107];\n                \n                bool cond_308141 = sle64(x_308133, gtid_308108);\n                int64_t defunc_0_f_res_308142;\n                \n                if (cond_308141) {\n                    defunc_0_f_res_308142 = (int64_t) 0;\n                } else {\n                    int64_t i_308143 = add64(gtid_308108, x_308137);\n                    int64_t defunc_0_add_arg_308144;\n                    \n                    defunc_0_add_arg_308144 = ((__global\n                                                int64_t *) ext_mem_318610)[gtid_308105 *\n                                                                           (defunc_0_f_res_292820 *\n                                                                            n_p_292677) +\n                                                                           gtid_308106 *\n                                                                           defunc_0_f_res_292820 +\n                                    ",
            "                                       i_308143];\n                    \n                    int64_t defunc_1_add_res_308145 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_308144);\n                    \n                    defunc_0_f_res_308142 = defunc_1_add_res_308145;\n                }\n                \n                double defunc_0_f_res_308146;\n                \n                if (cond_308141) {\n                    defunc_0_f_res_308146 = 0.0;\n                } else {\n                    int64_t i_308147 = add64(gtid_308108, x_308137);\n                    double defunc_0_add_arg_308148;\n                    \n                    defunc_0_add_arg_308148 = ((__global\n                                                double *) mem_318876)[gtid_308105 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_308106 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_308147];\n                    defunc_0_f_res_308146 = defunc_0_add_arg_308148;\n                }\n                \n                int64_t binop_p_308149 = sub64(defunc_0_f_res_308142,\n                                               defunc_0_m_fun_res_308139);\n                double defunc_0_f_res_308150 = sitofp_i64_f64(binop_p_308149);\n                double abs_res_308151 = fabs(defunc_0_f_res_308150);\n                double tmp1_308152 = abs_res_308151 / x_308138;\n                double x_308153 = tmp1_308152 * tmp1_308152;\n                double y_308154 = tmp1_308152 * x_308153;\n                double tmp2_308155 = 1.0 - y_308154;\n                double x_308156 = tmp2_308155 * tmp2_308155;\n                double tmp3_308157 = tmp2_308155 * x_3081",
            "56;\n                double w_j_308158 = defunc_0_f_res_308146 * tmp3_308157;\n                double xw_j_308159 = defunc_0_f_res_308150 * w_j_308158;\n                double x2w_j_308160 = defunc_0_f_res_308150 * xw_j_308159;\n                double x3w_j_308161 = defunc_0_f_res_308150 * x2w_j_308160;\n                double x4w_j_308162 = defunc_0_f_res_308150 * x3w_j_308161;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_308110 = x_acc_322647;\n                    x_308111 = x_acc_322648;\n                    x_308112 = x_acc_322649;\n                    x_308113 = x_acc_322650;\n                    x_308114 = x_acc_322651;\n                }\n                // load new values\n                {\n                    x_308115 = w_j_308158;\n                    x_308116 = xw_j_308159;\n                    x_308117 = x2w_j_308160;\n                    x_308118 = x3w_j_308161;\n                    x_308119 = x4w_j_308162;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_308120 = x_308110 + x_308115;\n                    double defunc_1_op_res_308121 = x_308111 + x_308116;\n                    double defunc_1_op_res_308122 = x_308112 + x_308117;\n                    double defunc_1_op_res_308123 = x_308113 + x_308118;\n                    double defunc_1_op_res_308124 = x_308114 + x_308119;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_322647 = defunc_1_op_res_308120;\n                        x_acc_322648 = defunc_1_op_res_308121;\n                        x_acc_322649 = defunc_1_op_res_308122;\n                        x_acc_322650 = defunc_1_op_res_308123;\n                        x_acc_322651 = defunc_1_op_res_308124;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in m",
            "emory\n        {\n            x_308110 = x_acc_322647;\n            x_308111 = x_acc_322648;\n            x_308112 = x_acc_322649;\n            x_308113 = x_acc_322650;\n            x_308114 = x_acc_322651;\n            ((__local\n              double *) red_arr_mem_322624)[sext_i32_i64(local_tid_322620)] =\n                x_308110;\n            ((__local\n              double *) red_arr_mem_322626)[sext_i32_i64(local_tid_322620)] =\n                x_308111;\n            ((__local\n              double *) red_arr_mem_322628)[sext_i32_i64(local_tid_322620)] =\n                x_308112;\n            ((__local\n              double *) red_arr_mem_322630)[sext_i32_i64(local_tid_322620)] =\n                x_308113;\n            ((__local\n              double *) red_arr_mem_322632)[sext_i32_i64(local_tid_322620)] =\n                x_308114;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_322669;\n        int32_t skip_waves_322670 = 1;\n        double x_322653;\n        double x_322654;\n        double x_322655;\n        double x_322656;\n        double x_322657;\n        double x_322658;\n        double x_322659;\n        double x_322660;\n        double x_322661;\n        double x_322662;\n        \n        offset_322669 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_322620,\n                      sext_i64_i32(segred_group_sizze_308097))) {\n                x_322653 = ((__local\n                             double *) red_arr_mem_322624)[sext_i32_i64(local_tid_322620 +\n                                                           offset_322669)];\n                x_322654 = ((__local\n                             double *) red_arr_mem_322626)[sext_i32_i64(local_tid_322620 +\n                                                           offset_322669)];\n                x_322655 = ((__local\n                             double *) red_arr_mem_322628)[sext_i32_i64(local_tid_322620 +\n                                              ",
            "             offset_322669)];\n                x_322656 = ((__local\n                             double *) red_arr_mem_322630)[sext_i32_i64(local_tid_322620 +\n                                                           offset_322669)];\n                x_322657 = ((__local\n                             double *) red_arr_mem_322632)[sext_i32_i64(local_tid_322620 +\n                                                           offset_322669)];\n            }\n        }\n        offset_322669 = 1;\n        while (slt32(offset_322669, wave_sizze_322622)) {\n            if (slt32(local_tid_322620 + offset_322669,\n                      sext_i64_i32(segred_group_sizze_308097)) &&\n                ((local_tid_322620 - squot32(local_tid_322620,\n                                             wave_sizze_322622) *\n                  wave_sizze_322622) & (2 * offset_322669 - 1)) == 0) {\n                // read array element\n                {\n                    x_322658 = ((volatile __local\n                                 double *) red_arr_mem_322624)[sext_i32_i64(local_tid_322620 +\n                                                               offset_322669)];\n                    x_322659 = ((volatile __local\n                                 double *) red_arr_mem_322626)[sext_i32_i64(local_tid_322620 +\n                                                               offset_322669)];\n                    x_322660 = ((volatile __local\n                                 double *) red_arr_mem_322628)[sext_i32_i64(local_tid_322620 +\n                                                               offset_322669)];\n                    x_322661 = ((volatile __local\n                                 double *) red_arr_mem_322630)[sext_i32_i64(local_tid_322620 +\n                                                               offset_322669)];\n                    x_322662 = ((volatile __local\n                                 double *) red_arr_mem_322632)[sext_i32_i64(local_tid_322620 +\n                             ",
            "                                  offset_322669)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_322663 = x_322653 + x_322658;\n                    double defunc_1_op_res_322664 = x_322654 + x_322659;\n                    double defunc_1_op_res_322665 = x_322655 + x_322660;\n                    double defunc_1_op_res_322666 = x_322656 + x_322661;\n                    double defunc_1_op_res_322667 = x_322657 + x_322662;\n                    \n                    x_322653 = defunc_1_op_res_322663;\n                    x_322654 = defunc_1_op_res_322664;\n                    x_322655 = defunc_1_op_res_322665;\n                    x_322656 = defunc_1_op_res_322666;\n                    x_322657 = defunc_1_op_res_322667;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_322624)[sext_i32_i64(local_tid_322620)] =\n                        x_322653;\n                    ((volatile __local\n                      double *) red_arr_mem_322626)[sext_i32_i64(local_tid_322620)] =\n                        x_322654;\n                    ((volatile __local\n                      double *) red_arr_mem_322628)[sext_i32_i64(local_tid_322620)] =\n                        x_322655;\n                    ((volatile __local\n                      double *) red_arr_mem_322630)[sext_i32_i64(local_tid_322620)] =\n                        x_322656;\n                    ((volatile __local\n                      double *) red_arr_mem_322632)[sext_i32_i64(local_tid_322620)] =\n                        x_322657;\n                }\n            }\n            offset_322669 *= 2;\n        }\n        while (slt32(skip_waves_322670,\n                     squot32(sext_i64_i32(segred_group_sizze_308097) +\n                             wave_sizze_322622 - 1, wave_sizze_322622))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_322669 = s",
            "kip_waves_322670 * wave_sizze_322622;\n            if (slt32(local_tid_322620 + offset_322669,\n                      sext_i64_i32(segred_group_sizze_308097)) &&\n                ((local_tid_322620 - squot32(local_tid_322620,\n                                             wave_sizze_322622) *\n                  wave_sizze_322622) == 0 && (squot32(local_tid_322620,\n                                                      wave_sizze_322622) & (2 *\n                                                                            skip_waves_322670 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_322658 = ((__local\n                                 double *) red_arr_mem_322624)[sext_i32_i64(local_tid_322620 +\n                                                               offset_322669)];\n                    x_322659 = ((__local\n                                 double *) red_arr_mem_322626)[sext_i32_i64(local_tid_322620 +\n                                                               offset_322669)];\n                    x_322660 = ((__local\n                                 double *) red_arr_mem_322628)[sext_i32_i64(local_tid_322620 +\n                                                               offset_322669)];\n                    x_322661 = ((__local\n                                 double *) red_arr_mem_322630)[sext_i32_i64(local_tid_322620 +\n                                                               offset_322669)];\n                    x_322662 = ((__local\n                                 double *) red_arr_mem_322632)[sext_i32_i64(local_tid_322620 +\n                                                               offset_322669)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_322663 = x_322653 + x_322658;\n                    double defunc_1_op_res_322664 = x_322654 + x_32",
            "2659;\n                    double defunc_1_op_res_322665 = x_322655 + x_322660;\n                    double defunc_1_op_res_322666 = x_322656 + x_322661;\n                    double defunc_1_op_res_322667 = x_322657 + x_322662;\n                    \n                    x_322653 = defunc_1_op_res_322663;\n                    x_322654 = defunc_1_op_res_322664;\n                    x_322655 = defunc_1_op_res_322665;\n                    x_322656 = defunc_1_op_res_322666;\n                    x_322657 = defunc_1_op_res_322667;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_322624)[sext_i32_i64(local_tid_322620)] =\n                        x_322653;\n                    ((__local\n                      double *) red_arr_mem_322626)[sext_i32_i64(local_tid_322620)] =\n                        x_322654;\n                    ((__local\n                      double *) red_arr_mem_322628)[sext_i32_i64(local_tid_322620)] =\n                        x_322655;\n                    ((__local\n                      double *) red_arr_mem_322630)[sext_i32_i64(local_tid_322620)] =\n                        x_322656;\n                    ((__local\n                      double *) red_arr_mem_322632)[sext_i32_i64(local_tid_322620)] =\n                        x_322657;\n                }\n            }\n            skip_waves_322670 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_322620) == (int64_t) 0) {\n                x_acc_322647 = x_322653;\n                x_acc_322648 = x_322654;\n                x_acc_322649 = x_322655;\n                x_acc_322650 = x_322656;\n                x_acc_322651 = x_322657;\n            }\n        }\n        if (groups_per_segment_322602 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_322620",
            " == 0) {\n                    ((__global double *) mem_319405)[gtid_308105 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_308106 *\n                                                     s_n_m_292825 +\n                                                     gtid_308107] =\n                        x_acc_322647;\n                    ((__global double *) mem_319410)[gtid_308105 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_308106 *\n                                                     s_n_m_292825 +\n                                                     gtid_308107] =\n                        x_acc_322648;\n                    ((__global double *) mem_319415)[gtid_308105 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_308106 *\n                                                     s_n_m_292825 +\n                                                     gtid_308107] =\n                        x_acc_322649;\n                    ((__global double *) mem_319420)[gtid_308105 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_308106 *\n                                                     s_n_m_292825 +\n                                                     gtid_308107] =\n                        x_acc_322650;\n                    ((__global double *) mem_319425)[gtid_308105 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n       ",
            "                                              gtid_308106 *\n                                                     s_n_m_292825 +\n                                                     gtid_308107] =\n                        x_acc_322651;\n                }\n            }\n        } else {\n            int32_t old_counter_322671;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_322620 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_322607)[sext_i32_i64(virt_group_id_322638)] =\n                        x_acc_322647;\n                    ((__global\n                      double *) segred_tmp_mem_322609)[sext_i32_i64(virt_group_id_322638)] =\n                        x_acc_322648;\n                    ((__global\n                      double *) segred_tmp_mem_322611)[sext_i32_i64(virt_group_id_322638)] =\n                        x_acc_322649;\n                    ((__global\n                      double *) segred_tmp_mem_322613)[sext_i32_i64(virt_group_id_322638)] =\n                        x_acc_322650;\n                    ((__global\n                      double *) segred_tmp_mem_322615)[sext_i32_i64(virt_group_id_322638)] =\n                        x_acc_322651;\n                    mem_fence_global();\n                    old_counter_322671 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_322617)[sext_i32_i64(srem32(flat_segment_id_322639,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_322634)[(int64_t) 0] =\n                        old_counter_322671 == groups_per_segment_322602 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE)",
            ";\n            \n            bool is_last_group_322672;\n            \n            is_last_group_322672 = ((__local\n                                     bool *) sync_arr_mem_322634)[(int64_t) 0];\n            if (is_last_group_322672) {\n                if (local_tid_322620 == 0) {\n                    old_counter_322671 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_322617)[sext_i32_i64(srem32(flat_segment_id_322639,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_322602));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_322673 =\n                            sdiv_up64(groups_per_segment_322602,\n                                      segred_group_sizze_308097);\n                    \n                    x_308110 = 0.0;\n                    x_308111 = 0.0;\n                    x_308112 = 0.0;\n                    x_308113 = 0.0;\n                    x_308114 = 0.0;\n                    for (int64_t i_322674 = 0; i_322674 <\n                         read_per_thread_322673; i_322674++) {\n                        int64_t group_res_id_322675 =\n                                sext_i32_i64(local_tid_322620) *\n                                read_per_thread_322673 + i_322674;\n                        int64_t index_of_group_res_322676 =\n                                sext_i32_i64(flat_segment_id_322639) *\n                                groups_per_segment_322602 + group_res_id_322675;\n                        \n                        if (slt64(group_res_id_322675,\n                                  groups_per_segment_322602)) {\n                            x_308115 = ((__global\n                                         doub",
            "le *) segred_tmp_mem_322607)[index_of_group_res_322676];\n                            x_308116 = ((__global\n                                         double *) segred_tmp_mem_322609)[index_of_group_res_322676];\n                            x_308117 = ((__global\n                                         double *) segred_tmp_mem_322611)[index_of_group_res_322676];\n                            x_308118 = ((__global\n                                         double *) segred_tmp_mem_322613)[index_of_group_res_322676];\n                            x_308119 = ((__global\n                                         double *) segred_tmp_mem_322615)[index_of_group_res_322676];\n                            \n                            double defunc_1_op_res_308120 = x_308110 + x_308115;\n                            double defunc_1_op_res_308121 = x_308111 + x_308116;\n                            double defunc_1_op_res_308122 = x_308112 + x_308117;\n                            double defunc_1_op_res_308123 = x_308113 + x_308118;\n                            double defunc_1_op_res_308124 = x_308114 + x_308119;\n                            \n                            x_308110 = defunc_1_op_res_308120;\n                            x_308111 = defunc_1_op_res_308121;\n                            x_308112 = defunc_1_op_res_308122;\n                            x_308113 = defunc_1_op_res_308123;\n                            x_308114 = defunc_1_op_res_308124;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_322624)[sext_i32_i64(local_tid_322620)] =\n                    x_308110;\n                ((__local\n                  double *) red_arr_mem_322626)[sext_i32_i64(local_tid_322620)] =\n                    x_308111;\n                ((__local\n                  double *) red_arr_mem_322628)[sext_i32_i64(local_tid_322620)] =\n                    x_308112;\n                ((__local\n                  double *) red_arr_mem_322630)[sex",
            "t_i32_i64(local_tid_322620)] =\n                    x_308113;\n                ((__local\n                  double *) red_arr_mem_322632)[sext_i32_i64(local_tid_322620)] =\n                    x_308114;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_322677;\n                    int32_t skip_waves_322678 = 1;\n                    double x_322653;\n                    double x_322654;\n                    double x_322655;\n                    double x_322656;\n                    double x_322657;\n                    double x_322658;\n                    double x_322659;\n                    double x_322660;\n                    double x_322661;\n                    double x_322662;\n                    \n                    offset_322677 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_322620,\n                                  sext_i64_i32(segred_group_sizze_308097))) {\n                            x_322653 = ((__local\n                                         double *) red_arr_mem_322624)[sext_i32_i64(local_tid_322620 +\n                                                                       offset_322677)];\n                            x_322654 = ((__local\n                                         double *) red_arr_mem_322626)[sext_i32_i64(local_tid_322620 +\n                                                                       offset_322677)];\n                            x_322655 = ((__local\n                                         double *) red_arr_mem_322628)[sext_i32_i64(local_tid_322620 +\n                                                                       offset_322677)];\n                            x_322656 = ((__local\n                                         double *) red_arr_mem_322630)[sext_i32_i64(local_tid_322620 +\n                                                                       ",
            "offset_322677)];\n                            x_322657 = ((__local\n                                         double *) red_arr_mem_322632)[sext_i32_i64(local_tid_322620 +\n                                                                       offset_322677)];\n                        }\n                    }\n                    offset_322677 = 1;\n                    while (slt32(offset_322677, wave_sizze_322622)) {\n                        if (slt32(local_tid_322620 + offset_322677,\n                                  sext_i64_i32(segred_group_sizze_308097)) &&\n                            ((local_tid_322620 - squot32(local_tid_322620,\n                                                         wave_sizze_322622) *\n                              wave_sizze_322622) & (2 * offset_322677 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_322658 = ((volatile __local\n                                             double *) red_arr_mem_322624)[sext_i32_i64(local_tid_322620 +\n                                                                           offset_322677)];\n                                x_322659 = ((volatile __local\n                                             double *) red_arr_mem_322626)[sext_i32_i64(local_tid_322620 +\n                                                                           offset_322677)];\n                                x_322660 = ((volatile __local\n                                             double *) red_arr_mem_322628)[sext_i32_i64(local_tid_322620 +\n                                                                           offset_322677)];\n                                x_322661 = ((volatile __local\n                                             double *) red_arr_mem_322630)[sext_i32_i64(local_tid_322620 +\n                                                                           offset_322677)];\n                                x_322662 = ((volati",
            "le __local\n                                             double *) red_arr_mem_322632)[sext_i32_i64(local_tid_322620 +\n                                                                           offset_322677)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_322663 = x_322653 +\n                                       x_322658;\n                                double defunc_1_op_res_322664 = x_322654 +\n                                       x_322659;\n                                double defunc_1_op_res_322665 = x_322655 +\n                                       x_322660;\n                                double defunc_1_op_res_322666 = x_322656 +\n                                       x_322661;\n                                double defunc_1_op_res_322667 = x_322657 +\n                                       x_322662;\n                                \n                                x_322653 = defunc_1_op_res_322663;\n                                x_322654 = defunc_1_op_res_322664;\n                                x_322655 = defunc_1_op_res_322665;\n                                x_322656 = defunc_1_op_res_322666;\n                                x_322657 = defunc_1_op_res_322667;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_322624)[sext_i32_i64(local_tid_322620)] =\n                                    x_322653;\n                                ((volatile __local\n                                  double *) red_arr_mem_322626)[sext_i32_i64(local_tid_322620)] =\n                                    x_322654;\n                                ((volatile __local\n                                  double *) red_arr_mem_322628)[sext_i32_i64(local_tid_322620)] =\n                             ",
            "       x_322655;\n                                ((volatile __local\n                                  double *) red_arr_mem_322630)[sext_i32_i64(local_tid_322620)] =\n                                    x_322656;\n                                ((volatile __local\n                                  double *) red_arr_mem_322632)[sext_i32_i64(local_tid_322620)] =\n                                    x_322657;\n                            }\n                        }\n                        offset_322677 *= 2;\n                    }\n                    while (slt32(skip_waves_322678,\n                                 squot32(sext_i64_i32(segred_group_sizze_308097) +\n                                         wave_sizze_322622 - 1,\n                                         wave_sizze_322622))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_322677 = skip_waves_322678 * wave_sizze_322622;\n                        if (slt32(local_tid_322620 + offset_322677,\n                                  sext_i64_i32(segred_group_sizze_308097)) &&\n                            ((local_tid_322620 - squot32(local_tid_322620,\n                                                         wave_sizze_322622) *\n                              wave_sizze_322622) == 0 &&\n                             (squot32(local_tid_322620, wave_sizze_322622) &\n                              (2 * skip_waves_322678 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_322658 = ((__local\n                                             double *) red_arr_mem_322624)[sext_i32_i64(local_tid_322620 +\n                                                                           offset_322677)];\n                                x_322659 = ((__local\n                                             double *) red_arr_mem_322626)[sext_i32_i64(local_tid_322620 +\n                                                                           offset_",
            "322677)];\n                                x_322660 = ((__local\n                                             double *) red_arr_mem_322628)[sext_i32_i64(local_tid_322620 +\n                                                                           offset_322677)];\n                                x_322661 = ((__local\n                                             double *) red_arr_mem_322630)[sext_i32_i64(local_tid_322620 +\n                                                                           offset_322677)];\n                                x_322662 = ((__local\n                                             double *) red_arr_mem_322632)[sext_i32_i64(local_tid_322620 +\n                                                                           offset_322677)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_322663 = x_322653 +\n                                       x_322658;\n                                double defunc_1_op_res_322664 = x_322654 +\n                                       x_322659;\n                                double defunc_1_op_res_322665 = x_322655 +\n                                       x_322660;\n                                double defunc_1_op_res_322666 = x_322656 +\n                                       x_322661;\n                                double defunc_1_op_res_322667 = x_322657 +\n                                       x_322662;\n                                \n                                x_322653 = defunc_1_op_res_322663;\n                                x_322654 = defunc_1_op_res_322664;\n                                x_322655 = defunc_1_op_res_322665;\n                                x_322656 = defunc_1_op_res_322666;\n                                x_322657 = defunc_1_op_res_322667;\n                            }\n                            // write result of operation\n                            {\n            ",
            "                    ((__local\n                                  double *) red_arr_mem_322624)[sext_i32_i64(local_tid_322620)] =\n                                    x_322653;\n                                ((__local\n                                  double *) red_arr_mem_322626)[sext_i32_i64(local_tid_322620)] =\n                                    x_322654;\n                                ((__local\n                                  double *) red_arr_mem_322628)[sext_i32_i64(local_tid_322620)] =\n                                    x_322655;\n                                ((__local\n                                  double *) red_arr_mem_322630)[sext_i32_i64(local_tid_322620)] =\n                                    x_322656;\n                                ((__local\n                                  double *) red_arr_mem_322632)[sext_i32_i64(local_tid_322620)] =\n                                    x_322657;\n                            }\n                        }\n                        skip_waves_322678 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_322620 == 0) {\n                            ((__global double *) mem_319405)[gtid_308105 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308106 *\n                                                             s_n_m_292825 +\n                                                             gtid_308107] =\n                                x_322653;\n                            ((__global double *) mem_319410)[gtid_308105 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308106 *\n                 ",
            "                                            s_n_m_292825 +\n                                                             gtid_308107] =\n                                x_322654;\n                            ((__global double *) mem_319415)[gtid_308105 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308106 *\n                                                             s_n_m_292825 +\n                                                             gtid_308107] =\n                                x_322655;\n                            ((__global double *) mem_319420)[gtid_308105 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308106 *\n                                                             s_n_m_292825 +\n                                                             gtid_308107] =\n                                x_322656;\n                            ((__global double *) mem_319425)[gtid_308105 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308106 *\n                                                             s_n_m_292825 +\n                                                             gtid_308107] =\n                                x_322657;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_308097\n}\n__kernel void mainzisegred_large_308237(__global int *global_failure,\n                                      ",
            "  uint sync_arr_mem_322748_backing_offset_0,\n                                        uint red_arr_mem_322746_backing_offset_1,\n                                        uint red_arr_mem_322744_backing_offset_2,\n                                        int64_t n_p_292677, int64_t q_s_292678,\n                                        int64_t partition_sizze_292766,\n                                        int64_t defunc_0_f_res_292820,\n                                        int64_t s_n_m_292825,\n                                        int64_t num_groups_308229,\n                                        int64_t groups_per_segment_322728,\n                                        int64_t elements_per_thread_322729,\n                                        int64_t virt_num_groups_322730,\n                                        int64_t threads_per_segment_322732,\n                                        __global unsigned char *ext_mem_318609,\n                                        __global unsigned char *ext_mem_318610,\n                                        __global unsigned char *ext_mem_318707,\n                                        __global unsigned char *ext_mem_318708,\n                                        __global unsigned char *mem_318871,\n                                        __global unsigned char *mem_318876,\n                                        __global unsigned char *mem_319431,\n                                        __global unsigned char *mem_319436,\n                                        __global unsigned char *mem_319441,\n                                        __global unsigned char *mem_319446,\n                                        __global unsigned char *mem_319451,\n                                        __global unsigned char *mem_319456,\n                                        __global unsigned char *mem_319462,\n                                        __global unsigned char *mem_319467,\n                                        __global\n           ",
            "                             unsigned char *segred_tmp_mem_322733,\n                                        __global\n                                        unsigned char *segred_tmp_mem_322735,\n                                        __global\n                                        unsigned char *mainzicounter_mem_322737)\n{\n    #define segred_group_sizze_308228 (mainzisegred_group_sizze_306945)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_322748_backing_2 =\n                           &shared_mem[sync_arr_mem_322748_backing_offset_0];\n    volatile unsigned char *red_arr_mem_322746_backing_1 =\n                           &shared_mem[red_arr_mem_322746_backing_offset_1];\n    volatile unsigned char *red_arr_mem_322744_backing_0 =\n                           &shared_mem[red_arr_mem_322744_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322739;\n    int32_t local_tid_322740;\n    int64_t group_sizze_322743;\n    int32_t wave_sizze_322742;\n    int32_t group_tid_322741;\n    \n    global_tid_322739 = get_global_id(0);\n    local_tid_322740 = get_local_id(0);\n    group_sizze_322743 = get_local_size(0);\n    wave_sizze_322742 = LOCKSTEP_WIDTH;\n    group_tid_322741 = get_group_id(0);\n    \n    int32_t phys_tid_308237 = global_tid_322739;\n    __local unsigned char *red_arr_mem_322744;\n    \n    red_arr_mem_322744 = (__local unsigned char *) red_arr_mem_322744_backing_0;\n    \n    __local unsigned char *red_arr_mem_322746;\n    \n    red_arr_mem_322746 = (__local unsigned char *) red_arr_mem_322746_backing_1;\n    \n    __local unsigned char *sync_arr_mem_322748;\n    \n    sync_arr_mem_322748 = (__local\n                           unsigned char *) sync_arr_mem_322748_backing_2;\n    \n    int32_t phys_group_id_322750;\n    \n    phys_group_id_322750 = get_group_id(0);\n    for (int32_t i_322751 = 0; i_322751 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_32273",
            "0) - phys_group_id_322750,\n                   sext_i64_i32(num_groups_308229)); i_322751++) {\n        int32_t virt_group_id_322752 = phys_group_id_322750 + i_322751 *\n                sext_i64_i32(num_groups_308229);\n        int32_t flat_segment_id_322753 = squot32(virt_group_id_322752,\n                                                 sext_i64_i32(groups_per_segment_322728));\n        int64_t global_tid_322754 = srem64(sext_i32_i64(virt_group_id_322752) *\n                                           segred_group_sizze_308228 +\n                                           sext_i32_i64(local_tid_322740),\n                                           segred_group_sizze_308228 *\n                                           groups_per_segment_322728);\n        int64_t slice_322755 = s_n_m_292825;\n        int64_t slice_322756 = n_p_292677 * slice_322755;\n        int64_t slice_322757 = partition_sizze_292766 * slice_322756;\n        int64_t gtid_308233 = squot64(sext_i32_i64(flat_segment_id_322753),\n                                      slice_322756);\n        int64_t remnant_322758 = sext_i32_i64(flat_segment_id_322753) -\n                gtid_308233 * slice_322756;\n        int64_t gtid_308234 = squot64(remnant_322758, slice_322755);\n        int64_t remnant_322759 = remnant_322758 - gtid_308234 * slice_322755;\n        int64_t gtid_308235 = remnant_322759;\n        int64_t remnant_322760 = remnant_322759 - gtid_308235;\n        int64_t gtid_308236;\n        double x_acc_322761;\n        double x_acc_322762;\n        int64_t chunk_sizze_322763 = smin64(elements_per_thread_322729,\n                                            sdiv_up64(q_s_292678 -\n                                                      global_tid_322754,\n                                                      threads_per_segment_322732));\n        double x_308238;\n        double x_308239;\n        double x_308240;\n        double x_308241;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_322761 = 0.0;",
            "\n            x_acc_322762 = 0.0;\n        }\n        for (int64_t i_322770 = 0; i_322770 < chunk_sizze_322763; i_322770++) {\n            gtid_308236 = global_tid_322754 + threads_per_segment_322732 *\n                i_322770;\n            // apply map function\n            {\n                int64_t x_308259;\n                \n                x_308259 = ((__global int64_t *) ext_mem_318609)[gtid_308233 *\n                                                                 n_p_292677 +\n                                                                 gtid_308234];\n                \n                int64_t x_308268;\n                \n                x_308268 = ((__global int64_t *) ext_mem_318708)[gtid_308233 *\n                                                                 (s_n_m_292825 *\n                                                                  n_p_292677) +\n                                                                 gtid_308234 *\n                                                                 s_n_m_292825 +\n                                                                 gtid_308235];\n                \n                double x_308269;\n                \n                x_308269 = ((__global double *) ext_mem_318707)[gtid_308233 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_308234 *\n                                                                s_n_m_292825 +\n                                                                gtid_308235];\n                \n                double a12_308270;\n                \n                a12_308270 = ((__global double *) mem_319431)[gtid_308233 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                                        ",
            "      gtid_308234 *\n                                                              s_n_m_292825 +\n                                                              gtid_308235];\n                \n                double b12_308271;\n                \n                b12_308271 = ((__global double *) mem_319436)[gtid_308233 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                                              gtid_308234 *\n                                                              s_n_m_292825 +\n                                                              gtid_308235];\n                \n                double c12_308272;\n                \n                c12_308272 = ((__global double *) mem_319441)[gtid_308233 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                                              gtid_308234 *\n                                                              s_n_m_292825 +\n                                                              gtid_308235];\n                \n                double b2_308273;\n                \n                b2_308273 = ((__global double *) mem_319446)[gtid_308233 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308234 *\n                                                             s_n_m_292825 +\n                                                             gtid_308235];\n                \n                double c2_308274;\n                \n                c2_308274 = ((__global double *) mem_319451)[gtid_308233 *\n                                                             (s_n_m_292825 *\n                           ",
            "                                   n_p_292677) +\n                                                             gtid_308234 *\n                                                             s_n_m_292825 +\n                                                             gtid_308235];\n                \n                int64_t defunc_0_m_fun_res_308275;\n                \n                defunc_0_m_fun_res_308275 = ((__global\n                                              int64_t *) mem_319456)[gtid_308233 *\n                                                                     (s_n_m_292825 *\n                                                                      n_p_292677) +\n                                                                     gtid_308234 *\n                                                                     s_n_m_292825 +\n                                                                     gtid_308235];\n                \n                bool cond_308277 = sle64(x_308259, gtid_308236);\n                int64_t defunc_0_f_res_308278;\n                \n                if (cond_308277) {\n                    defunc_0_f_res_308278 = (int64_t) 0;\n                } else {\n                    int64_t i_308279 = add64(gtid_308236, x_308268);\n                    int64_t defunc_0_add_arg_308280;\n                    \n                    defunc_0_add_arg_308280 = ((__global\n                                                int64_t *) ext_mem_318610)[gtid_308233 *\n                                                                           (defunc_0_f_res_292820 *\n                                                                            n_p_292677) +\n                                                                           gtid_308234 *\n                                                                           defunc_0_f_res_292820 +\n                                                                           i_308279];\n                    \n                    int64_t defunc_1_add_res_3",
            "08281 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_308280);\n                    \n                    defunc_0_f_res_308278 = defunc_1_add_res_308281;\n                }\n                \n                double defunc_0_f_res_308282;\n                \n                if (cond_308277) {\n                    defunc_0_f_res_308282 = 0.0;\n                } else {\n                    int64_t i_308283 = add64(gtid_308236, x_308268);\n                    double defunc_0_add_arg_308284;\n                    \n                    defunc_0_add_arg_308284 = ((__global\n                                                double *) mem_318876)[gtid_308233 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_308234 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_308283];\n                    defunc_0_f_res_308282 = defunc_0_add_arg_308284;\n                }\n                \n                int64_t binop_p_308285 = sub64(defunc_0_f_res_308278,\n                                               defunc_0_m_fun_res_308275);\n                double defunc_0_f_res_308286 = sitofp_i64_f64(binop_p_308285);\n                double abs_res_308287 = fabs(defunc_0_f_res_308286);\n                double tmp1_308288 = abs_res_308287 / x_308269;\n                double x_308289 = tmp1_308288 * tmp1_308288;\n                double y_308290 = tmp1_308288 * x_308289;\n                double tmp2_308291 = 1.0 - y_308290;\n                double x_308292 = tmp2_308291 * tmp2_308291;\n                double tmp3_308293 = tmp2_308291 * x_308292;\n                double tmp4_308294 = defunc_0_f_res_308282 * tmp3_308293;\n                double defunc_1_f_res_3",
            "08295 = defunc_0_f_res_308286 *\n                       tmp4_308294;\n                double defunc_1_f_res_308296 = defunc_0_f_res_308286 *\n                       defunc_1_f_res_308295;\n                double defunc_0_f_res_308297;\n                \n                if (cond_308277) {\n                    defunc_0_f_res_308297 = 0.0;\n                } else {\n                    int64_t i_308298 = add64(gtid_308236, x_308268);\n                    double defunc_0_add_arg_308299;\n                    \n                    defunc_0_add_arg_308299 = ((__global\n                                                double *) mem_318871)[gtid_308233 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_308234 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_308298];\n                    defunc_0_f_res_308297 = defunc_0_add_arg_308299;\n                }\n                \n                double x_308300 = a12_308270 * tmp4_308294;\n                double y_308301 = b12_308271 * defunc_1_f_res_308295;\n                double x_308302 = x_308300 + y_308301;\n                double y_308303 = c12_308272 * defunc_1_f_res_308296;\n                double x_308304 = x_308302 + y_308303;\n                double defunc_9_fit_fun_res_308305 = defunc_0_f_res_308297 *\n                       x_308304;\n                double x_308306 = b12_308271 * tmp4_308294;\n                double y_308307 = b2_308273 * defunc_1_f_res_308295;\n                double x_308308 = x_308306 + y_308307;\n                double y_308309 = c2_308274 * defunc_1_f_res_308296;\n                double x_308310 = x_308308 + y_308309;\n                double defunc_9_slope_fun_res_308311 = defunc_0_f_res_308297 *\n          ",
            "             x_308310;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_308238 = x_acc_322761;\n                    x_308239 = x_acc_322762;\n                }\n                // load new values\n                {\n                    x_308240 = defunc_9_fit_fun_res_308305;\n                    x_308241 = defunc_9_slope_fun_res_308311;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_308242 = x_308238 + x_308240;\n                    double defunc_1_op_res_308243 = x_308239 + x_308241;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_322761 = defunc_1_op_res_308242;\n                        x_acc_322762 = defunc_1_op_res_308243;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_308238 = x_acc_322761;\n            x_308239 = x_acc_322762;\n            ((__local\n              double *) red_arr_mem_322744)[sext_i32_i64(local_tid_322740)] =\n                x_308238;\n            ((__local\n              double *) red_arr_mem_322746)[sext_i32_i64(local_tid_322740)] =\n                x_308239;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_322771;\n        int32_t skip_waves_322772 = 1;\n        double x_322764;\n        double x_322765;\n        double x_322766;\n        double x_322767;\n        \n        offset_322771 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_322740,\n                      sext_i64_i32(segred_group_sizze_308228))) {\n                x_322764 = ((__local\n                             double *) red_arr_mem_322744)[sext_i32_i64(local_tid_322740 +\n                                                           offset_322771)];\n              ",
            "  x_322765 = ((__local\n                             double *) red_arr_mem_322746)[sext_i32_i64(local_tid_322740 +\n                                                           offset_322771)];\n            }\n        }\n        offset_322771 = 1;\n        while (slt32(offset_322771, wave_sizze_322742)) {\n            if (slt32(local_tid_322740 + offset_322771,\n                      sext_i64_i32(segred_group_sizze_308228)) &&\n                ((local_tid_322740 - squot32(local_tid_322740,\n                                             wave_sizze_322742) *\n                  wave_sizze_322742) & (2 * offset_322771 - 1)) == 0) {\n                // read array element\n                {\n                    x_322766 = ((volatile __local\n                                 double *) red_arr_mem_322744)[sext_i32_i64(local_tid_322740 +\n                                                               offset_322771)];\n                    x_322767 = ((volatile __local\n                                 double *) red_arr_mem_322746)[sext_i32_i64(local_tid_322740 +\n                                                               offset_322771)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_322768 = x_322764 + x_322766;\n                    double defunc_1_op_res_322769 = x_322765 + x_322767;\n                    \n                    x_322764 = defunc_1_op_res_322768;\n                    x_322765 = defunc_1_op_res_322769;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_322744)[sext_i32_i64(local_tid_322740)] =\n                        x_322764;\n                    ((volatile __local\n                      double *) red_arr_mem_322746)[sext_i32_i64(local_tid_322740)] =\n                        x_322765;\n                }\n            }\n            offset_322771 *= 2;\n        }\n        while (slt32(skip_waves_322772,\n ",
            "                    squot32(sext_i64_i32(segred_group_sizze_308228) +\n                             wave_sizze_322742 - 1, wave_sizze_322742))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_322771 = skip_waves_322772 * wave_sizze_322742;\n            if (slt32(local_tid_322740 + offset_322771,\n                      sext_i64_i32(segred_group_sizze_308228)) &&\n                ((local_tid_322740 - squot32(local_tid_322740,\n                                             wave_sizze_322742) *\n                  wave_sizze_322742) == 0 && (squot32(local_tid_322740,\n                                                      wave_sizze_322742) & (2 *\n                                                                            skip_waves_322772 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_322766 = ((__local\n                                 double *) red_arr_mem_322744)[sext_i32_i64(local_tid_322740 +\n                                                               offset_322771)];\n                    x_322767 = ((__local\n                                 double *) red_arr_mem_322746)[sext_i32_i64(local_tid_322740 +\n                                                               offset_322771)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_322768 = x_322764 + x_322766;\n                    double defunc_1_op_res_322769 = x_322765 + x_322767;\n                    \n                    x_322764 = defunc_1_op_res_322768;\n                    x_322765 = defunc_1_op_res_322769;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_322744)[sext_i32_i64(local_tid_322740)] =\n                        x_322764;\n                    ((__local\n                      double *) re",
            "d_arr_mem_322746)[sext_i32_i64(local_tid_322740)] =\n                        x_322765;\n                }\n            }\n            skip_waves_322772 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_322740) == (int64_t) 0) {\n                x_acc_322761 = x_322764;\n                x_acc_322762 = x_322765;\n            }\n        }\n        if (groups_per_segment_322728 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_322740 == 0) {\n                    ((__global double *) mem_319462)[gtid_308233 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_308234 *\n                                                     s_n_m_292825 +\n                                                     gtid_308235] =\n                        x_acc_322761;\n                    ((__global double *) mem_319467)[gtid_308233 *\n                                                     (s_n_m_292825 *\n                                                      n_p_292677) +\n                                                     gtid_308234 *\n                                                     s_n_m_292825 +\n                                                     gtid_308235] =\n                        x_acc_322762;\n                }\n            }\n        } else {\n            int32_t old_counter_322773;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_322740 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_322733)[sext_i32_i64(virt_group_id_322752)] =\n                        x_acc_322761;\n                    ((__global\n                      double *) segred_tmp_mem_322735)[sext_i32",
            "_i64(virt_group_id_322752)] =\n                        x_acc_322762;\n                    mem_fence_global();\n                    old_counter_322773 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_322737)[sext_i32_i64(srem32(flat_segment_id_322753,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_322748)[(int64_t) 0] =\n                        old_counter_322773 == groups_per_segment_322728 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_322774;\n            \n            is_last_group_322774 = ((__local\n                                     bool *) sync_arr_mem_322748)[(int64_t) 0];\n            if (is_last_group_322774) {\n                if (local_tid_322740 == 0) {\n                    old_counter_322773 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_322737)[sext_i32_i64(srem32(flat_segment_id_322753,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_322728));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_322775 =\n                            sdiv_up64(groups_per_segment_322728,\n                                      segred_group_sizze_308228);\n                    \n                    x_308238 = 0.0;\n                    x_308239 = 0.0;\n                    for (int64_t i_322776 = 0; i_322776 <\n                  ",
            "       read_per_thread_322775; i_322776++) {\n                        int64_t group_res_id_322777 =\n                                sext_i32_i64(local_tid_322740) *\n                                read_per_thread_322775 + i_322776;\n                        int64_t index_of_group_res_322778 =\n                                sext_i32_i64(flat_segment_id_322753) *\n                                groups_per_segment_322728 + group_res_id_322777;\n                        \n                        if (slt64(group_res_id_322777,\n                                  groups_per_segment_322728)) {\n                            x_308240 = ((__global\n                                         double *) segred_tmp_mem_322733)[index_of_group_res_322778];\n                            x_308241 = ((__global\n                                         double *) segred_tmp_mem_322735)[index_of_group_res_322778];\n                            \n                            double defunc_1_op_res_308242 = x_308238 + x_308240;\n                            double defunc_1_op_res_308243 = x_308239 + x_308241;\n                            \n                            x_308238 = defunc_1_op_res_308242;\n                            x_308239 = defunc_1_op_res_308243;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_322744)[sext_i32_i64(local_tid_322740)] =\n                    x_308238;\n                ((__local\n                  double *) red_arr_mem_322746)[sext_i32_i64(local_tid_322740)] =\n                    x_308239;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_322779;\n                    int32_t skip_waves_322780 = 1;\n                    double x_322764;\n                    double x_322765;\n                    double x_322766;\n                    double x_322767;\n                    \n                    offset_322779 = 0;\n       ",
            "             // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_322740,\n                                  sext_i64_i32(segred_group_sizze_308228))) {\n                            x_322764 = ((__local\n                                         double *) red_arr_mem_322744)[sext_i32_i64(local_tid_322740 +\n                                                                       offset_322779)];\n                            x_322765 = ((__local\n                                         double *) red_arr_mem_322746)[sext_i32_i64(local_tid_322740 +\n                                                                       offset_322779)];\n                        }\n                    }\n                    offset_322779 = 1;\n                    while (slt32(offset_322779, wave_sizze_322742)) {\n                        if (slt32(local_tid_322740 + offset_322779,\n                                  sext_i64_i32(segred_group_sizze_308228)) &&\n                            ((local_tid_322740 - squot32(local_tid_322740,\n                                                         wave_sizze_322742) *\n                              wave_sizze_322742) & (2 * offset_322779 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_322766 = ((volatile __local\n                                             double *) red_arr_mem_322744)[sext_i32_i64(local_tid_322740 +\n                                                                           offset_322779)];\n                                x_322767 = ((volatile __local\n                                             double *) red_arr_mem_322746)[sext_i32_i64(local_tid_322740 +\n                                                                           offset_322779)];\n                            }\n                            // apply reduction operation\n                            {\n                  ",
            "              double defunc_1_op_res_322768 = x_322764 +\n                                       x_322766;\n                                double defunc_1_op_res_322769 = x_322765 +\n                                       x_322767;\n                                \n                                x_322764 = defunc_1_op_res_322768;\n                                x_322765 = defunc_1_op_res_322769;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_322744)[sext_i32_i64(local_tid_322740)] =\n                                    x_322764;\n                                ((volatile __local\n                                  double *) red_arr_mem_322746)[sext_i32_i64(local_tid_322740)] =\n                                    x_322765;\n                            }\n                        }\n                        offset_322779 *= 2;\n                    }\n                    while (slt32(skip_waves_322780,\n                                 squot32(sext_i64_i32(segred_group_sizze_308228) +\n                                         wave_sizze_322742 - 1,\n                                         wave_sizze_322742))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_322779 = skip_waves_322780 * wave_sizze_322742;\n                        if (slt32(local_tid_322740 + offset_322779,\n                                  sext_i64_i32(segred_group_sizze_308228)) &&\n                            ((local_tid_322740 - squot32(local_tid_322740,\n                                                         wave_sizze_322742) *\n                              wave_sizze_322742) == 0 &&\n                             (squot32(local_tid_322740, wave_sizze_322742) &\n                              (2 * skip_waves_322780 - 1)) == 0)) {\n                            // read array element\n                           ",
            " {\n                                x_322766 = ((__local\n                                             double *) red_arr_mem_322744)[sext_i32_i64(local_tid_322740 +\n                                                                           offset_322779)];\n                                x_322767 = ((__local\n                                             double *) red_arr_mem_322746)[sext_i32_i64(local_tid_322740 +\n                                                                           offset_322779)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_322768 = x_322764 +\n                                       x_322766;\n                                double defunc_1_op_res_322769 = x_322765 +\n                                       x_322767;\n                                \n                                x_322764 = defunc_1_op_res_322768;\n                                x_322765 = defunc_1_op_res_322769;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_322744)[sext_i32_i64(local_tid_322740)] =\n                                    x_322764;\n                                ((__local\n                                  double *) red_arr_mem_322746)[sext_i32_i64(local_tid_322740)] =\n                                    x_322765;\n                            }\n                        }\n                        skip_waves_322780 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_322740 == 0) {\n                            ((__global double *) mem_319462)[gtid_308233 *\n                                                             (s_n_m_292825 *\n                                                       ",
            "       n_p_292677) +\n                                                             gtid_308234 *\n                                                             s_n_m_292825 +\n                                                             gtid_308235] =\n                                x_322764;\n                            ((__global double *) mem_319467)[gtid_308233 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308234 *\n                                                             s_n_m_292825 +\n                                                             gtid_308235] =\n                                x_322765;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_308228\n}\n__kernel void mainzisegred_large_308859(__global int *global_failure,\n                                        uint sync_arr_mem_322857_backing_offset_0,\n                                        uint red_arr_mem_322855_backing_offset_1,\n                                        int64_t n_p_292677,\n                                        int64_t partition_sizze_292766,\n                                        int64_t C_len_292823,\n                                        int64_t num_groups_308854,\n                                        int64_t groups_per_segment_322841,\n                                        int64_t elements_per_thread_322842,\n                                        int64_t virt_num_groups_322843,\n                                        int64_t threads_per_segment_322845,\n                                        __global unsigned char *mem_319504,\n                                        __global unsigned char *mem_319515,\n                                        __",
            "global\n                                        unsigned char *segred_tmp_mem_322846,\n                                        __global\n                                        unsigned char *mainzicounter_mem_322848)\n{\n    #define segred_group_sizze_308853 (mainzisegred_group_sizze_308836)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_322857_backing_1 =\n                           &shared_mem[sync_arr_mem_322857_backing_offset_0];\n    volatile unsigned char *red_arr_mem_322855_backing_0 =\n                           &shared_mem[red_arr_mem_322855_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322850;\n    int32_t local_tid_322851;\n    int64_t group_sizze_322854;\n    int32_t wave_sizze_322853;\n    int32_t group_tid_322852;\n    \n    global_tid_322850 = get_global_id(0);\n    local_tid_322851 = get_local_id(0);\n    group_sizze_322854 = get_local_size(0);\n    wave_sizze_322853 = LOCKSTEP_WIDTH;\n    group_tid_322852 = get_group_id(0);\n    \n    int32_t phys_tid_308859 = global_tid_322850;\n    __local unsigned char *red_arr_mem_322855;\n    \n    red_arr_mem_322855 = (__local unsigned char *) red_arr_mem_322855_backing_0;\n    \n    __local unsigned char *sync_arr_mem_322857;\n    \n    sync_arr_mem_322857 = (__local\n                           unsigned char *) sync_arr_mem_322857_backing_1;\n    \n    int32_t phys_group_id_322859;\n    \n    phys_group_id_322859 = get_group_id(0);\n    for (int32_t i_322860 = 0; i_322860 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_322843) - phys_group_id_322859,\n                   sext_i64_i32(num_groups_308854)); i_322860++) {\n        int32_t virt_group_id_322861 = phys_group_id_322859 + i_322860 *\n                sext_i64_i32(num_groups_308854);\n        int32_t flat_segment_id_322862 = squot32(virt_group_id_322861,\n                                                 sext_i64_i32(groups_per_segment_322841));\n     ",
            "   int64_t global_tid_322863 = srem64(sext_i32_i64(virt_group_id_322861) *\n                                           segred_group_sizze_308853 +\n                                           sext_i32_i64(local_tid_322851),\n                                           segred_group_sizze_308853 *\n                                           groups_per_segment_322841);\n        int64_t slice_322864 = partition_sizze_292766;\n        int64_t gtid_308857 = sext_i32_i64(flat_segment_id_322862);\n        int64_t remnant_322865 = sext_i32_i64(flat_segment_id_322862) -\n                gtid_308857;\n        int64_t gtid_308858;\n        double x_acc_322866;\n        int64_t chunk_sizze_322867 = smin64(elements_per_thread_322842,\n                                            sdiv_up64(n_p_292677 -\n                                                      global_tid_322863,\n                                                      threads_per_segment_322845));\n        double x_308860;\n        double x_308861;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_322866 = 0.0;\n        }\n        for (int64_t i_322871 = 0; i_322871 < chunk_sizze_322867; i_322871++) {\n            gtid_308858 = global_tid_322863 + threads_per_segment_322845 *\n                i_322871;\n            // apply map function\n            {\n                double x_308864;\n                \n                x_308864 = ((__global double *) mem_319504)[gtid_308857 *\n                                                            C_len_292823 +\n                                                            gtid_308858];\n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_308860 = x_acc_322866;\n                }\n                // load new values\n                {\n                    x_308861 = x_308864;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_30886",
            "2 = x_308860 + x_308861;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_322866 = defunc_1_op_res_308862;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_308860 = x_acc_322866;\n            ((__local\n              double *) red_arr_mem_322855)[sext_i32_i64(local_tid_322851)] =\n                x_308860;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_322872;\n        int32_t skip_waves_322873 = 1;\n        double x_322868;\n        double x_322869;\n        \n        offset_322872 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_322851,\n                      sext_i64_i32(segred_group_sizze_308853))) {\n                x_322868 = ((__local\n                             double *) red_arr_mem_322855)[sext_i32_i64(local_tid_322851 +\n                                                           offset_322872)];\n            }\n        }\n        offset_322872 = 1;\n        while (slt32(offset_322872, wave_sizze_322853)) {\n            if (slt32(local_tid_322851 + offset_322872,\n                      sext_i64_i32(segred_group_sizze_308853)) &&\n                ((local_tid_322851 - squot32(local_tid_322851,\n                                             wave_sizze_322853) *\n                  wave_sizze_322853) & (2 * offset_322872 - 1)) == 0) {\n                // read array element\n                {\n                    x_322869 = ((volatile __local\n                                 double *) red_arr_mem_322855)[sext_i32_i64(local_tid_322851 +\n                                                               offset_322872)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_322870 = x_322868 + x_322869;\n                    \n                    x_322868 = defunc_1_",
            "op_res_322870;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_322855)[sext_i32_i64(local_tid_322851)] =\n                        x_322868;\n                }\n            }\n            offset_322872 *= 2;\n        }\n        while (slt32(skip_waves_322873,\n                     squot32(sext_i64_i32(segred_group_sizze_308853) +\n                             wave_sizze_322853 - 1, wave_sizze_322853))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_322872 = skip_waves_322873 * wave_sizze_322853;\n            if (slt32(local_tid_322851 + offset_322872,\n                      sext_i64_i32(segred_group_sizze_308853)) &&\n                ((local_tid_322851 - squot32(local_tid_322851,\n                                             wave_sizze_322853) *\n                  wave_sizze_322853) == 0 && (squot32(local_tid_322851,\n                                                      wave_sizze_322853) & (2 *\n                                                                            skip_waves_322873 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_322869 = ((__local\n                                 double *) red_arr_mem_322855)[sext_i32_i64(local_tid_322851 +\n                                                               offset_322872)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_322870 = x_322868 + x_322869;\n                    \n                    x_322868 = defunc_1_op_res_322870;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_322855)[sext_i32_i64(local_tid_322851)] =\n                        x_322868;\n                }\n            }\n      ",
            "      skip_waves_322873 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_322851) == (int64_t) 0) {\n                x_acc_322866 = x_322868;\n            }\n        }\n        if (groups_per_segment_322841 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_322851 == 0) {\n                    ((__global double *) mem_319515)[gtid_308857] =\n                        x_acc_322866;\n                }\n            }\n        } else {\n            int32_t old_counter_322874;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_322851 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_322846)[sext_i32_i64(virt_group_id_322861)] =\n                        x_acc_322866;\n                    mem_fence_global();\n                    old_counter_322874 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_322848)[sext_i32_i64(srem32(flat_segment_id_322862,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_322857)[(int64_t) 0] =\n                        old_counter_322874 == groups_per_segment_322841 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_322875;\n            \n            is_last_group_322875 = ((__local\n                                     bool *) sync_arr_mem_322857)[(int64_t) 0];\n            if (is_last_group_322875) {\n                if (local_tid_322851 == 0) {\n                    old_counter_322874 =\n   ",
            "                     atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_322848)[sext_i32_i64(srem32(flat_segment_id_322862,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_322841));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_322876 =\n                            sdiv_up64(groups_per_segment_322841,\n                                      segred_group_sizze_308853);\n                    \n                    x_308860 = 0.0;\n                    for (int64_t i_322877 = 0; i_322877 <\n                         read_per_thread_322876; i_322877++) {\n                        int64_t group_res_id_322878 =\n                                sext_i32_i64(local_tid_322851) *\n                                read_per_thread_322876 + i_322877;\n                        int64_t index_of_group_res_322879 =\n                                sext_i32_i64(flat_segment_id_322862) *\n                                groups_per_segment_322841 + group_res_id_322878;\n                        \n                        if (slt64(group_res_id_322878,\n                                  groups_per_segment_322841)) {\n                            x_308861 = ((__global\n                                         double *) segred_tmp_mem_322846)[index_of_group_res_322879];\n                            \n                            double defunc_1_op_res_308862 = x_308860 + x_308861;\n                            \n                            x_308860 = defunc_1_op_res_308862;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_322855)[sext_i32_i64(local_tid_322851)] =\n                    x_308860;\n  ",
            "              barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_322880;\n                    int32_t skip_waves_322881 = 1;\n                    double x_322868;\n                    double x_322869;\n                    \n                    offset_322880 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_322851,\n                                  sext_i64_i32(segred_group_sizze_308853))) {\n                            x_322868 = ((__local\n                                         double *) red_arr_mem_322855)[sext_i32_i64(local_tid_322851 +\n                                                                       offset_322880)];\n                        }\n                    }\n                    offset_322880 = 1;\n                    while (slt32(offset_322880, wave_sizze_322853)) {\n                        if (slt32(local_tid_322851 + offset_322880,\n                                  sext_i64_i32(segred_group_sizze_308853)) &&\n                            ((local_tid_322851 - squot32(local_tid_322851,\n                                                         wave_sizze_322853) *\n                              wave_sizze_322853) & (2 * offset_322880 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_322869 = ((volatile __local\n                                             double *) red_arr_mem_322855)[sext_i32_i64(local_tid_322851 +\n                                                                           offset_322880)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_322870 = x_322868 +\n                                       x_322869;\n                                \n                 ",
            "               x_322868 = defunc_1_op_res_322870;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_322855)[sext_i32_i64(local_tid_322851)] =\n                                    x_322868;\n                            }\n                        }\n                        offset_322880 *= 2;\n                    }\n                    while (slt32(skip_waves_322881,\n                                 squot32(sext_i64_i32(segred_group_sizze_308853) +\n                                         wave_sizze_322853 - 1,\n                                         wave_sizze_322853))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_322880 = skip_waves_322881 * wave_sizze_322853;\n                        if (slt32(local_tid_322851 + offset_322880,\n                                  sext_i64_i32(segred_group_sizze_308853)) &&\n                            ((local_tid_322851 - squot32(local_tid_322851,\n                                                         wave_sizze_322853) *\n                              wave_sizze_322853) == 0 &&\n                             (squot32(local_tid_322851, wave_sizze_322853) &\n                              (2 * skip_waves_322881 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_322869 = ((__local\n                                             double *) red_arr_mem_322855)[sext_i32_i64(local_tid_322851 +\n                                                                           offset_322880)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_322870 = x_322868 +\n                                       x_322869;\n                                \n             ",
            "                   x_322868 = defunc_1_op_res_322870;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_322855)[sext_i32_i64(local_tid_322851)] =\n                                    x_322868;\n                            }\n                        }\n                        skip_waves_322881 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_322851 == 0) {\n                            ((__global double *) mem_319515)[gtid_308857] =\n                                x_322868;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_308853\n}\n__kernel void mainzisegred_large_308990(__global int *global_failure,\n                                        uint sync_arr_mem_323038_backing_offset_0,\n                                        uint red_arr_mem_323036_backing_offset_1,\n                                        int64_t n_p_292677,\n                                        int64_t partition_sizze_292766,\n                                        int64_t lifted_single_ma_l_arg_293311,\n                                        int64_t num_groups_308985,\n                                        int64_t groups_per_segment_323022,\n                                        int64_t elements_per_thread_323023,\n                                        int64_t virt_num_groups_323024,\n                                        int64_t threads_per_segment_323026,\n                                        __global unsigned char *mem_319521,\n                                        __global unsigned char *mem_319532,\n                                        __global\n                       ",
            "                 unsigned char *segred_tmp_mem_323027,\n                                        __global\n                                        unsigned char *mainzicounter_mem_323029)\n{\n    #define segred_group_sizze_308984 (mainzisegred_group_sizze_308967)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_323038_backing_1 =\n                           &shared_mem[sync_arr_mem_323038_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323036_backing_0 =\n                           &shared_mem[red_arr_mem_323036_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323031;\n    int32_t local_tid_323032;\n    int64_t group_sizze_323035;\n    int32_t wave_sizze_323034;\n    int32_t group_tid_323033;\n    \n    global_tid_323031 = get_global_id(0);\n    local_tid_323032 = get_local_id(0);\n    group_sizze_323035 = get_local_size(0);\n    wave_sizze_323034 = LOCKSTEP_WIDTH;\n    group_tid_323033 = get_group_id(0);\n    \n    int32_t phys_tid_308990 = global_tid_323031;\n    __local unsigned char *red_arr_mem_323036;\n    \n    red_arr_mem_323036 = (__local unsigned char *) red_arr_mem_323036_backing_0;\n    \n    __local unsigned char *sync_arr_mem_323038;\n    \n    sync_arr_mem_323038 = (__local\n                           unsigned char *) sync_arr_mem_323038_backing_1;\n    \n    int32_t phys_group_id_323040;\n    \n    phys_group_id_323040 = get_group_id(0);\n    for (int32_t i_323041 = 0; i_323041 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_323024) - phys_group_id_323040,\n                   sext_i64_i32(num_groups_308985)); i_323041++) {\n        int32_t virt_group_id_323042 = phys_group_id_323040 + i_323041 *\n                sext_i64_i32(num_groups_308985);\n        int32_t flat_segment_id_323043 = squot32(virt_group_id_323042,\n                                                 sext_i64_i32(groups_per_segment_323022));\n        int64_t global_tid_323044 =",
            " srem64(sext_i32_i64(virt_group_id_323042) *\n                                           segred_group_sizze_308984 +\n                                           sext_i32_i64(local_tid_323032),\n                                           segred_group_sizze_308984 *\n                                           groups_per_segment_323022);\n        int64_t slice_323045 = partition_sizze_292766;\n        int64_t gtid_308988 = sext_i32_i64(flat_segment_id_323043);\n        int64_t remnant_323046 = sext_i32_i64(flat_segment_id_323043) -\n                gtid_308988;\n        int64_t gtid_308989;\n        double x_acc_323047;\n        int64_t chunk_sizze_323048 = smin64(elements_per_thread_323023,\n                                            sdiv_up64(n_p_292677 -\n                                                      global_tid_323044,\n                                                      threads_per_segment_323026));\n        double x_308991;\n        double x_308992;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_323047 = 0.0;\n        }\n        for (int64_t i_323052 = 0; i_323052 < chunk_sizze_323048; i_323052++) {\n            gtid_308989 = global_tid_323044 + threads_per_segment_323026 *\n                i_323052;\n            // apply map function\n            {\n                double x_308995;\n                \n                x_308995 = ((__global double *) mem_319521)[gtid_308988 *\n                                                            lifted_single_ma_l_arg_293311 +\n                                                            gtid_308989];\n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_308991 = x_acc_323047;\n                }\n                // load new values\n                {\n                    x_308992 = x_308995;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_308993 = x_308991 ",
            "+ x_308992;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_323047 = defunc_1_op_res_308993;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_308991 = x_acc_323047;\n            ((__local\n              double *) red_arr_mem_323036)[sext_i32_i64(local_tid_323032)] =\n                x_308991;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_323053;\n        int32_t skip_waves_323054 = 1;\n        double x_323049;\n        double x_323050;\n        \n        offset_323053 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_323032,\n                      sext_i64_i32(segred_group_sizze_308984))) {\n                x_323049 = ((__local\n                             double *) red_arr_mem_323036)[sext_i32_i64(local_tid_323032 +\n                                                           offset_323053)];\n            }\n        }\n        offset_323053 = 1;\n        while (slt32(offset_323053, wave_sizze_323034)) {\n            if (slt32(local_tid_323032 + offset_323053,\n                      sext_i64_i32(segred_group_sizze_308984)) &&\n                ((local_tid_323032 - squot32(local_tid_323032,\n                                             wave_sizze_323034) *\n                  wave_sizze_323034) & (2 * offset_323053 - 1)) == 0) {\n                // read array element\n                {\n                    x_323050 = ((volatile __local\n                                 double *) red_arr_mem_323036)[sext_i32_i64(local_tid_323032 +\n                                                               offset_323053)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323051 = x_323049 + x_323050;\n                    \n                    x_323049 = defunc_1_op_res_323051",
            ";\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_323036)[sext_i32_i64(local_tid_323032)] =\n                        x_323049;\n                }\n            }\n            offset_323053 *= 2;\n        }\n        while (slt32(skip_waves_323054,\n                     squot32(sext_i64_i32(segred_group_sizze_308984) +\n                             wave_sizze_323034 - 1, wave_sizze_323034))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_323053 = skip_waves_323054 * wave_sizze_323034;\n            if (slt32(local_tid_323032 + offset_323053,\n                      sext_i64_i32(segred_group_sizze_308984)) &&\n                ((local_tid_323032 - squot32(local_tid_323032,\n                                             wave_sizze_323034) *\n                  wave_sizze_323034) == 0 && (squot32(local_tid_323032,\n                                                      wave_sizze_323034) & (2 *\n                                                                            skip_waves_323054 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_323050 = ((__local\n                                 double *) red_arr_mem_323036)[sext_i32_i64(local_tid_323032 +\n                                                               offset_323053)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323051 = x_323049 + x_323050;\n                    \n                    x_323049 = defunc_1_op_res_323051;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_323036)[sext_i32_i64(local_tid_323032)] =\n                        x_323049;\n                }\n            }\n            skip_wa",
            "ves_323054 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_323032) == (int64_t) 0) {\n                x_acc_323047 = x_323049;\n            }\n        }\n        if (groups_per_segment_323022 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_323032 == 0) {\n                    ((__global double *) mem_319532)[gtid_308988] =\n                        x_acc_323047;\n                }\n            }\n        } else {\n            int32_t old_counter_323055;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_323032 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_323027)[sext_i32_i64(virt_group_id_323042)] =\n                        x_acc_323047;\n                    mem_fence_global();\n                    old_counter_323055 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_323029)[sext_i32_i64(srem32(flat_segment_id_323043,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_323038)[(int64_t) 0] =\n                        old_counter_323055 == groups_per_segment_323022 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_323056;\n            \n            is_last_group_323056 = ((__local\n                                     bool *) sync_arr_mem_323038)[(int64_t) 0];\n            if (is_last_group_323056) {\n                if (local_tid_323032 == 0) {\n                    old_counter_323055 =\n                ",
            "        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_323029)[sext_i32_i64(srem32(flat_segment_id_323043,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_323022));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_323057 =\n                            sdiv_up64(groups_per_segment_323022,\n                                      segred_group_sizze_308984);\n                    \n                    x_308991 = 0.0;\n                    for (int64_t i_323058 = 0; i_323058 <\n                         read_per_thread_323057; i_323058++) {\n                        int64_t group_res_id_323059 =\n                                sext_i32_i64(local_tid_323032) *\n                                read_per_thread_323057 + i_323058;\n                        int64_t index_of_group_res_323060 =\n                                sext_i32_i64(flat_segment_id_323043) *\n                                groups_per_segment_323022 + group_res_id_323059;\n                        \n                        if (slt64(group_res_id_323059,\n                                  groups_per_segment_323022)) {\n                            x_308992 = ((__global\n                                         double *) segred_tmp_mem_323027)[index_of_group_res_323060];\n                            \n                            double defunc_1_op_res_308993 = x_308991 + x_308992;\n                            \n                            x_308991 = defunc_1_op_res_308993;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_323036)[sext_i32_i64(local_tid_323032)] =\n                    x_308991;\n               ",
            " barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_323061;\n                    int32_t skip_waves_323062 = 1;\n                    double x_323049;\n                    double x_323050;\n                    \n                    offset_323061 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_323032,\n                                  sext_i64_i32(segred_group_sizze_308984))) {\n                            x_323049 = ((__local\n                                         double *) red_arr_mem_323036)[sext_i32_i64(local_tid_323032 +\n                                                                       offset_323061)];\n                        }\n                    }\n                    offset_323061 = 1;\n                    while (slt32(offset_323061, wave_sizze_323034)) {\n                        if (slt32(local_tid_323032 + offset_323061,\n                                  sext_i64_i32(segred_group_sizze_308984)) &&\n                            ((local_tid_323032 - squot32(local_tid_323032,\n                                                         wave_sizze_323034) *\n                              wave_sizze_323034) & (2 * offset_323061 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_323050 = ((volatile __local\n                                             double *) red_arr_mem_323036)[sext_i32_i64(local_tid_323032 +\n                                                                           offset_323061)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_323051 = x_323049 +\n                                       x_323050;\n                                \n                              ",
            "  x_323049 = defunc_1_op_res_323051;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323036)[sext_i32_i64(local_tid_323032)] =\n                                    x_323049;\n                            }\n                        }\n                        offset_323061 *= 2;\n                    }\n                    while (slt32(skip_waves_323062,\n                                 squot32(sext_i64_i32(segred_group_sizze_308984) +\n                                         wave_sizze_323034 - 1,\n                                         wave_sizze_323034))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_323061 = skip_waves_323062 * wave_sizze_323034;\n                        if (slt32(local_tid_323032 + offset_323061,\n                                  sext_i64_i32(segred_group_sizze_308984)) &&\n                            ((local_tid_323032 - squot32(local_tid_323032,\n                                                         wave_sizze_323034) *\n                              wave_sizze_323034) == 0 &&\n                             (squot32(local_tid_323032, wave_sizze_323034) &\n                              (2 * skip_waves_323062 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_323050 = ((__local\n                                             double *) red_arr_mem_323036)[sext_i32_i64(local_tid_323032 +\n                                                                           offset_323061)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_323051 = x_323049 +\n                                       x_323050;\n                                \n                          ",
            "      x_323049 = defunc_1_op_res_323051;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_323036)[sext_i32_i64(local_tid_323032)] =\n                                    x_323049;\n                            }\n                        }\n                        skip_waves_323062 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_323032 == 0) {\n                            ((__global double *) mem_319532)[gtid_308988] =\n                                x_323049;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_308984\n}\n__kernel void mainzisegred_large_309121(__global int *global_failure,\n                                        uint sync_arr_mem_323219_backing_offset_0,\n                                        uint red_arr_mem_323217_backing_offset_1,\n                                        int64_t partition_sizze_292766,\n                                        int64_t dyn_lifted_single_ma_l_arg_293321,\n                                        int64_t num_groups_309116,\n                                        int64_t groups_per_segment_323203,\n                                        int64_t elements_per_thread_323204,\n                                        int64_t virt_num_groups_323205,\n                                        int64_t threads_per_segment_323207,\n                                        __global unsigned char *mem_319538,\n                                        __global unsigned char *mem_319549,\n                                        __global\n                                        unsigned char *segred_tmp_mem_323208,\n              ",
            "                          __global\n                                        unsigned char *mainzicounter_mem_323210)\n{\n    #define segred_group_sizze_309115 (mainzisegred_group_sizze_309098)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_323219_backing_1 =\n                           &shared_mem[sync_arr_mem_323219_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323217_backing_0 =\n                           &shared_mem[red_arr_mem_323217_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323212;\n    int32_t local_tid_323213;\n    int64_t group_sizze_323216;\n    int32_t wave_sizze_323215;\n    int32_t group_tid_323214;\n    \n    global_tid_323212 = get_global_id(0);\n    local_tid_323213 = get_local_id(0);\n    group_sizze_323216 = get_local_size(0);\n    wave_sizze_323215 = LOCKSTEP_WIDTH;\n    group_tid_323214 = get_group_id(0);\n    \n    int32_t phys_tid_309121 = global_tid_323212;\n    __local unsigned char *red_arr_mem_323217;\n    \n    red_arr_mem_323217 = (__local unsigned char *) red_arr_mem_323217_backing_0;\n    \n    __local unsigned char *sync_arr_mem_323219;\n    \n    sync_arr_mem_323219 = (__local\n                           unsigned char *) sync_arr_mem_323219_backing_1;\n    \n    int32_t phys_group_id_323221;\n    \n    phys_group_id_323221 = get_group_id(0);\n    for (int32_t i_323222 = 0; i_323222 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_323205) - phys_group_id_323221,\n                   sext_i64_i32(num_groups_309116)); i_323222++) {\n        int32_t virt_group_id_323223 = phys_group_id_323221 + i_323222 *\n                sext_i64_i32(num_groups_309116);\n        int32_t flat_segment_id_323224 = squot32(virt_group_id_323223,\n                                                 sext_i64_i32(groups_per_segment_323203));\n        int64_t global_tid_323225 = srem64(sext_i32_i64(virt_group_id_323223) *\n                        ",
            "                   segred_group_sizze_309115 +\n                                           sext_i32_i64(local_tid_323213),\n                                           segred_group_sizze_309115 *\n                                           groups_per_segment_323203);\n        int64_t slice_323226 = partition_sizze_292766;\n        int64_t gtid_309119 = sext_i32_i64(flat_segment_id_323224);\n        int64_t remnant_323227 = sext_i32_i64(flat_segment_id_323224) -\n                gtid_309119;\n        int64_t gtid_309120;\n        double x_acc_323228;\n        int64_t chunk_sizze_323229 = smin64(elements_per_thread_323204,\n                                            sdiv_up64((int64_t) 3 -\n                                                      global_tid_323225,\n                                                      threads_per_segment_323207));\n        double x_309122;\n        double x_309123;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_323228 = 0.0;\n        }\n        for (int64_t i_323233 = 0; i_323233 < chunk_sizze_323229; i_323233++) {\n            gtid_309120 = global_tid_323225 + threads_per_segment_323207 *\n                i_323233;\n            // apply map function\n            {\n                double x_309126;\n                \n                x_309126 = ((__global double *) mem_319538)[gtid_309119 *\n                                                            dyn_lifted_single_ma_l_arg_293321 +\n                                                            gtid_309120];\n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_309122 = x_acc_323228;\n                }\n                // load new values\n                {\n                    x_309123 = x_309126;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_309124 = x_309122 + x_309123;\n                    \n                    // store in",
            " accumulator\n                    {\n                        x_acc_323228 = defunc_1_op_res_309124;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_309122 = x_acc_323228;\n            ((__local\n              double *) red_arr_mem_323217)[sext_i32_i64(local_tid_323213)] =\n                x_309122;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_323234;\n        int32_t skip_waves_323235 = 1;\n        double x_323230;\n        double x_323231;\n        \n        offset_323234 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_323213,\n                      sext_i64_i32(segred_group_sizze_309115))) {\n                x_323230 = ((__local\n                             double *) red_arr_mem_323217)[sext_i32_i64(local_tid_323213 +\n                                                           offset_323234)];\n            }\n        }\n        offset_323234 = 1;\n        while (slt32(offset_323234, wave_sizze_323215)) {\n            if (slt32(local_tid_323213 + offset_323234,\n                      sext_i64_i32(segred_group_sizze_309115)) &&\n                ((local_tid_323213 - squot32(local_tid_323213,\n                                             wave_sizze_323215) *\n                  wave_sizze_323215) & (2 * offset_323234 - 1)) == 0) {\n                // read array element\n                {\n                    x_323231 = ((volatile __local\n                                 double *) red_arr_mem_323217)[sext_i32_i64(local_tid_323213 +\n                                                               offset_323234)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323232 = x_323230 + x_323231;\n                    \n                    x_323230 = defunc_1_op_res_323232;\n                }\n                // write result of operation",
            "\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_323217)[sext_i32_i64(local_tid_323213)] =\n                        x_323230;\n                }\n            }\n            offset_323234 *= 2;\n        }\n        while (slt32(skip_waves_323235,\n                     squot32(sext_i64_i32(segred_group_sizze_309115) +\n                             wave_sizze_323215 - 1, wave_sizze_323215))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_323234 = skip_waves_323235 * wave_sizze_323215;\n            if (slt32(local_tid_323213 + offset_323234,\n                      sext_i64_i32(segred_group_sizze_309115)) &&\n                ((local_tid_323213 - squot32(local_tid_323213,\n                                             wave_sizze_323215) *\n                  wave_sizze_323215) == 0 && (squot32(local_tid_323213,\n                                                      wave_sizze_323215) & (2 *\n                                                                            skip_waves_323235 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_323231 = ((__local\n                                 double *) red_arr_mem_323217)[sext_i32_i64(local_tid_323213 +\n                                                               offset_323234)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323232 = x_323230 + x_323231;\n                    \n                    x_323230 = defunc_1_op_res_323232;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_323217)[sext_i32_i64(local_tid_323213)] =\n                        x_323230;\n                }\n            }\n            skip_waves_323235 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);",
            "\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_323213) == (int64_t) 0) {\n                x_acc_323228 = x_323230;\n            }\n        }\n        if (groups_per_segment_323203 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_323213 == 0) {\n                    ((__global double *) mem_319549)[gtid_309119] =\n                        x_acc_323228;\n                }\n            }\n        } else {\n            int32_t old_counter_323236;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_323213 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_323208)[sext_i32_i64(virt_group_id_323223)] =\n                        x_acc_323228;\n                    mem_fence_global();\n                    old_counter_323236 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_323210)[sext_i32_i64(srem32(flat_segment_id_323224,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_323219)[(int64_t) 0] =\n                        old_counter_323236 == groups_per_segment_323203 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_323237;\n            \n            is_last_group_323237 = ((__local\n                                     bool *) sync_arr_mem_323219)[(int64_t) 0];\n            if (is_last_group_323237) {\n                if (local_tid_323213 == 0) {\n                    old_counter_323236 =\n                        atomic_add_i32_global(&((volatile __global\n             ",
            "                                    int *) mainzicounter_mem_323210)[sext_i32_i64(srem32(flat_segment_id_323224,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_323203));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_323238 =\n                            sdiv_up64(groups_per_segment_323203,\n                                      segred_group_sizze_309115);\n                    \n                    x_309122 = 0.0;\n                    for (int64_t i_323239 = 0; i_323239 <\n                         read_per_thread_323238; i_323239++) {\n                        int64_t group_res_id_323240 =\n                                sext_i32_i64(local_tid_323213) *\n                                read_per_thread_323238 + i_323239;\n                        int64_t index_of_group_res_323241 =\n                                sext_i32_i64(flat_segment_id_323224) *\n                                groups_per_segment_323203 + group_res_id_323240;\n                        \n                        if (slt64(group_res_id_323240,\n                                  groups_per_segment_323203)) {\n                            x_309123 = ((__global\n                                         double *) segred_tmp_mem_323208)[index_of_group_res_323241];\n                            \n                            double defunc_1_op_res_309124 = x_309122 + x_309123;\n                            \n                            x_309122 = defunc_1_op_res_309124;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_323217)[sext_i32_i64(local_tid_323213)] =\n                    x_309122;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per",
            "-group results\n                {\n                    int32_t offset_323242;\n                    int32_t skip_waves_323243 = 1;\n                    double x_323230;\n                    double x_323231;\n                    \n                    offset_323242 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_323213,\n                                  sext_i64_i32(segred_group_sizze_309115))) {\n                            x_323230 = ((__local\n                                         double *) red_arr_mem_323217)[sext_i32_i64(local_tid_323213 +\n                                                                       offset_323242)];\n                        }\n                    }\n                    offset_323242 = 1;\n                    while (slt32(offset_323242, wave_sizze_323215)) {\n                        if (slt32(local_tid_323213 + offset_323242,\n                                  sext_i64_i32(segred_group_sizze_309115)) &&\n                            ((local_tid_323213 - squot32(local_tid_323213,\n                                                         wave_sizze_323215) *\n                              wave_sizze_323215) & (2 * offset_323242 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_323231 = ((volatile __local\n                                             double *) red_arr_mem_323217)[sext_i32_i64(local_tid_323213 +\n                                                                           offset_323242)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_323232 = x_323230 +\n                                       x_323231;\n                                \n                                x_323230 = defunc_1_op_res_323232;\n                           ",
            " }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323217)[sext_i32_i64(local_tid_323213)] =\n                                    x_323230;\n                            }\n                        }\n                        offset_323242 *= 2;\n                    }\n                    while (slt32(skip_waves_323243,\n                                 squot32(sext_i64_i32(segred_group_sizze_309115) +\n                                         wave_sizze_323215 - 1,\n                                         wave_sizze_323215))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_323242 = skip_waves_323243 * wave_sizze_323215;\n                        if (slt32(local_tid_323213 + offset_323242,\n                                  sext_i64_i32(segred_group_sizze_309115)) &&\n                            ((local_tid_323213 - squot32(local_tid_323213,\n                                                         wave_sizze_323215) *\n                              wave_sizze_323215) == 0 &&\n                             (squot32(local_tid_323213, wave_sizze_323215) &\n                              (2 * skip_waves_323243 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_323231 = ((__local\n                                             double *) red_arr_mem_323217)[sext_i32_i64(local_tid_323213 +\n                                                                           offset_323242)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_323232 = x_323230 +\n                                       x_323231;\n                                \n                                x_323230 = defunc_1_op_res_323232;\n                       ",
            "     }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_323217)[sext_i32_i64(local_tid_323213)] =\n                                    x_323230;\n                            }\n                        }\n                        skip_waves_323243 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_323213 == 0) {\n                            ((__global double *) mem_319549)[gtid_309119] =\n                                x_323230;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_309115\n}\n__kernel void mainzisegred_large_310765(__global int *global_failure,\n                                        uint sync_arr_mem_323517_backing_offset_0,\n                                        uint red_arr_mem_323515_backing_offset_1,\n                                        int64_t n_292675, int64_t q_l_292680,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t l_n_m_292832, int64_t i_292846,\n                                        int64_t num_groups_310759,\n                                        int64_t ctx_param_ext_318833,\n                                        int64_t ctx_param_ext_318834,\n                                        int64_t ctx_param_ext_318836,\n                                        int64_t groups_per_segment_323501,\n                                        int64_t elements_per_thread_323502,\n                                        int64_t virt_num_groups_323503,\n                                        int64_t threads_per_segment_323505,\n         ",
            "                               __global unsigned char *ext_mem_318756,\n                                        __global unsigned char *ext_mem_318757,\n                                        __global\n                                        unsigned char *mem_param_318838,\n                                        __global unsigned char *mem_319654,\n                                        __global\n                                        unsigned char *segred_tmp_mem_323506,\n                                        __global\n                                        unsigned char *mainzicounter_mem_323508)\n{\n    #define segred_group_sizze_310758 (mainzisegred_group_sizze_310576)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_323517_backing_1 =\n                           &shared_mem[sync_arr_mem_323517_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323515_backing_0 =\n                           &shared_mem[red_arr_mem_323515_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323510;\n    int32_t local_tid_323511;\n    int64_t group_sizze_323514;\n    int32_t wave_sizze_323513;\n    int32_t group_tid_323512;\n    \n    global_tid_323510 = get_global_id(0);\n    local_tid_323511 = get_local_id(0);\n    group_sizze_323514 = get_local_size(0);\n    wave_sizze_323513 = LOCKSTEP_WIDTH;\n    group_tid_323512 = get_group_id(0);\n    \n    int32_t phys_tid_310765 = global_tid_323510;\n    __local unsigned char *red_arr_mem_323515;\n    \n    red_arr_mem_323515 = (__local unsigned char *) red_arr_mem_323515_backing_0;\n    \n    __local unsigned char *sync_arr_mem_323517;\n    \n    sync_arr_mem_323517 = (__local\n                           unsigned char *) sync_arr_mem_323517_backing_1;\n    \n    int32_t phys_group_id_323519;\n    \n    phys_group_id_323519 = get_group_id(0);\n    for (int32_t i_323520 = 0; i_323520 <\n         sdiv_up32(sext_i64_i32(virt_num_grou",
            "ps_323503) - phys_group_id_323519,\n                   sext_i64_i32(num_groups_310759)); i_323520++) {\n        int32_t virt_group_id_323521 = phys_group_id_323519 + i_323520 *\n                sext_i64_i32(num_groups_310759);\n        int32_t flat_segment_id_323522 = squot32(virt_group_id_323521,\n                                                 sext_i64_i32(groups_per_segment_323501));\n        int64_t global_tid_323523 = srem64(sext_i32_i64(virt_group_id_323521) *\n                                           segred_group_sizze_310758 +\n                                           sext_i32_i64(local_tid_323511),\n                                           segred_group_sizze_310758 *\n                                           groups_per_segment_323501);\n        int64_t slice_323524 = l_n_m_292832;\n        int64_t slice_323525 = partition_sizze_292766 * slice_323524;\n        int64_t gtid_310762 = squot64(sext_i32_i64(flat_segment_id_323522),\n                                      slice_323524);\n        int64_t remnant_323526 = sext_i32_i64(flat_segment_id_323522) -\n                gtid_310762 * slice_323524;\n        int64_t gtid_310763 = remnant_323526;\n        int64_t remnant_323527 = remnant_323526 - gtid_310763;\n        int64_t gtid_310764;\n        double x_acc_323528;\n        int64_t chunk_sizze_323529 = smin64(elements_per_thread_323502,\n                                            sdiv_up64(q_l_292680 -\n                                                      global_tid_323523,\n                                                      threads_per_segment_323505));\n        double x_310766;\n        double x_310767;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_323528 = 0.0;\n        }\n        for (int64_t i_323533 = 0; i_323533 < chunk_sizze_323529; i_323533++) {\n            gtid_310764 = global_tid_323523 + threads_per_segment_323505 *\n                i_323533;\n            // apply map function\n            {\n                int64_t x_310773;\n  ",
            "              \n                x_310773 = ((__global int64_t *) ext_mem_318757)[gtid_310762 *\n                                                                 l_n_m_292832 +\n                                                                 gtid_310763];\n                \n                double x_310774;\n                \n                x_310774 = ((__global double *) ext_mem_318756)[gtid_310762 *\n                                                                l_n_m_292832 +\n                                                                gtid_310763];\n                \n                int64_t binop_y_317902 = mul64(jump_t_292685, gtid_310763);\n                int64_t binop_y_317903 = smin64(i_292846, binop_y_317902);\n                int64_t index_primexp_317904 = add64((int64_t) 1,\n                                                     binop_y_317903);\n                bool cond_310777 = sle64(n_292675, gtid_310764);\n                int64_t defunc_0_f_res_310778;\n                \n                if (cond_310777) {\n                    defunc_0_f_res_310778 = (int64_t) 0;\n                } else {\n                    int64_t i_310779 = add64(gtid_310764, x_310773);\n                    int64_t defunc_1_add_res_310780 = add64((int64_t) 1,\n                                                            i_310779);\n                    \n                    defunc_0_f_res_310778 = defunc_1_add_res_310780;\n                }\n                \n                double defunc_0_f_res_310781;\n                \n                if (cond_310777) {\n                    defunc_0_f_res_310781 = 0.0;\n                } else {\n                    int64_t i_310782 = add64(gtid_310764, x_310773);\n                    double defunc_0_add_arg_310783;\n                    \n                    defunc_0_add_arg_310783 = ((__global\n                                                double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                            (gtid_31076",
            "2 *\n                                                                             ctx_param_ext_318834 +\n                                                                             i_310782 *\n                                                                             ctx_param_ext_318836)];\n                    defunc_0_f_res_310781 = defunc_0_add_arg_310783;\n                }\n                \n                int64_t binop_p_310784 = sub64(defunc_0_f_res_310778,\n                                               index_primexp_317904);\n                double defunc_0_f_res_310785 = sitofp_i64_f64(binop_p_310784);\n                double abs_res_310786 = fabs(defunc_0_f_res_310785);\n                double tmp1_310787 = abs_res_310786 / x_310774;\n                double x_310788 = tmp1_310787 * tmp1_310787;\n                double y_310789 = tmp1_310787 * x_310788;\n                double tmp2_310790 = 1.0 - y_310789;\n                double x_310791 = tmp2_310790 * tmp2_310790;\n                double tmp3_310792 = tmp2_310790 * x_310791;\n                double w_j_310793 = defunc_0_f_res_310781 * tmp3_310792;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_310766 = x_acc_323528;\n                }\n                // load new values\n                {\n                    x_310767 = w_j_310793;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_310768 = x_310766 + x_310767;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_323528 = defunc_1_op_res_310768;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_310766 = x_acc_323528;\n            ((__local\n              double *) red_arr_mem_323515)[sext_i32_i64(local_tid_323511)] =\n           ",
            "     x_310766;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_323534;\n        int32_t skip_waves_323535 = 1;\n        double x_323530;\n        double x_323531;\n        \n        offset_323534 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_323511,\n                      sext_i64_i32(segred_group_sizze_310758))) {\n                x_323530 = ((__local\n                             double *) red_arr_mem_323515)[sext_i32_i64(local_tid_323511 +\n                                                           offset_323534)];\n            }\n        }\n        offset_323534 = 1;\n        while (slt32(offset_323534, wave_sizze_323513)) {\n            if (slt32(local_tid_323511 + offset_323534,\n                      sext_i64_i32(segred_group_sizze_310758)) &&\n                ((local_tid_323511 - squot32(local_tid_323511,\n                                             wave_sizze_323513) *\n                  wave_sizze_323513) & (2 * offset_323534 - 1)) == 0) {\n                // read array element\n                {\n                    x_323531 = ((volatile __local\n                                 double *) red_arr_mem_323515)[sext_i32_i64(local_tid_323511 +\n                                                               offset_323534)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323532 = x_323530 + x_323531;\n                    \n                    x_323530 = defunc_1_op_res_323532;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_323515)[sext_i32_i64(local_tid_323511)] =\n                        x_323530;\n                }\n            }\n            offset_323534 *= 2;\n        }\n        while (slt32(skip_waves_323535,\n                     squot32(sext_i64_i32(segred_group_sizze_310758) +\n                          ",
            "   wave_sizze_323513 - 1, wave_sizze_323513))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_323534 = skip_waves_323535 * wave_sizze_323513;\n            if (slt32(local_tid_323511 + offset_323534,\n                      sext_i64_i32(segred_group_sizze_310758)) &&\n                ((local_tid_323511 - squot32(local_tid_323511,\n                                             wave_sizze_323513) *\n                  wave_sizze_323513) == 0 && (squot32(local_tid_323511,\n                                                      wave_sizze_323513) & (2 *\n                                                                            skip_waves_323535 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_323531 = ((__local\n                                 double *) red_arr_mem_323515)[sext_i32_i64(local_tid_323511 +\n                                                               offset_323534)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323532 = x_323530 + x_323531;\n                    \n                    x_323530 = defunc_1_op_res_323532;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_323515)[sext_i32_i64(local_tid_323511)] =\n                        x_323530;\n                }\n            }\n            skip_waves_323535 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_323511) == (int64_t) 0) {\n                x_acc_323528 = x_323530;\n            }\n        }\n        if (groups_per_segment_323501 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_323511 == 0) {\n           ",
            "         ((__global double *) mem_319654)[gtid_310762 *\n                                                     l_n_m_292832 +\n                                                     gtid_310763] =\n                        x_acc_323528;\n                }\n            }\n        } else {\n            int32_t old_counter_323536;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_323511 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_323506)[sext_i32_i64(virt_group_id_323521)] =\n                        x_acc_323528;\n                    mem_fence_global();\n                    old_counter_323536 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_323508)[sext_i32_i64(srem32(flat_segment_id_323522,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_323517)[(int64_t) 0] =\n                        old_counter_323536 == groups_per_segment_323501 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_323537;\n            \n            is_last_group_323537 = ((__local\n                                     bool *) sync_arr_mem_323517)[(int64_t) 0];\n            if (is_last_group_323537) {\n                if (local_tid_323511 == 0) {\n                    old_counter_323536 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_323508)[sext_i32_i64(srem32(flat_segment_id_323522,\n                                                                                                      10240))],\n                             ",
            "                 (int) ((int64_t) 0 -\n                                                     groups_per_segment_323501));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_323538 =\n                            sdiv_up64(groups_per_segment_323501,\n                                      segred_group_sizze_310758);\n                    \n                    x_310766 = 0.0;\n                    for (int64_t i_323539 = 0; i_323539 <\n                         read_per_thread_323538; i_323539++) {\n                        int64_t group_res_id_323540 =\n                                sext_i32_i64(local_tid_323511) *\n                                read_per_thread_323538 + i_323539;\n                        int64_t index_of_group_res_323541 =\n                                sext_i32_i64(flat_segment_id_323522) *\n                                groups_per_segment_323501 + group_res_id_323540;\n                        \n                        if (slt64(group_res_id_323540,\n                                  groups_per_segment_323501)) {\n                            x_310767 = ((__global\n                                         double *) segred_tmp_mem_323506)[index_of_group_res_323541];\n                            \n                            double defunc_1_op_res_310768 = x_310766 + x_310767;\n                            \n                            x_310766 = defunc_1_op_res_310768;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_323515)[sext_i32_i64(local_tid_323511)] =\n                    x_310766;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_323542;\n                    int32_t skip_waves_323543 = 1;\n                    double x_323530;\n                    double x_323531;\n                    \n                    offset_32354",
            "2 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_323511,\n                                  sext_i64_i32(segred_group_sizze_310758))) {\n                            x_323530 = ((__local\n                                         double *) red_arr_mem_323515)[sext_i32_i64(local_tid_323511 +\n                                                                       offset_323542)];\n                        }\n                    }\n                    offset_323542 = 1;\n                    while (slt32(offset_323542, wave_sizze_323513)) {\n                        if (slt32(local_tid_323511 + offset_323542,\n                                  sext_i64_i32(segred_group_sizze_310758)) &&\n                            ((local_tid_323511 - squot32(local_tid_323511,\n                                                         wave_sizze_323513) *\n                              wave_sizze_323513) & (2 * offset_323542 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_323531 = ((volatile __local\n                                             double *) red_arr_mem_323515)[sext_i32_i64(local_tid_323511 +\n                                                                           offset_323542)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_323532 = x_323530 +\n                                       x_323531;\n                                \n                                x_323530 = defunc_1_op_res_323532;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323515)[sext_i32_i64(local_tid_323511)] =\n               ",
            "                     x_323530;\n                            }\n                        }\n                        offset_323542 *= 2;\n                    }\n                    while (slt32(skip_waves_323543,\n                                 squot32(sext_i64_i32(segred_group_sizze_310758) +\n                                         wave_sizze_323513 - 1,\n                                         wave_sizze_323513))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_323542 = skip_waves_323543 * wave_sizze_323513;\n                        if (slt32(local_tid_323511 + offset_323542,\n                                  sext_i64_i32(segred_group_sizze_310758)) &&\n                            ((local_tid_323511 - squot32(local_tid_323511,\n                                                         wave_sizze_323513) *\n                              wave_sizze_323513) == 0 &&\n                             (squot32(local_tid_323511, wave_sizze_323513) &\n                              (2 * skip_waves_323543 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_323531 = ((__local\n                                             double *) red_arr_mem_323515)[sext_i32_i64(local_tid_323511 +\n                                                                           offset_323542)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_323532 = x_323530 +\n                                       x_323531;\n                                \n                                x_323530 = defunc_1_op_res_323532;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_323515)[sext_i32_i64(local_tid_323511)] =\n                    ",
            "                x_323530;\n                            }\n                        }\n                        skip_waves_323543 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_323511 == 0) {\n                            ((__global double *) mem_319654)[gtid_310762 *\n                                                             l_n_m_292832 +\n                                                             gtid_310763] =\n                                x_323530;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_310758\n}\n__kernel void mainzisegred_large_310815(__global int *global_failure,\n                                        uint sync_arr_mem_323600_backing_offset_0,\n                                        uint red_arr_mem_323598_backing_offset_1,\n                                        int64_t n_292675, int64_t q_l_292680,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t l_n_m_292832, int64_t i_292846,\n                                        int64_t num_groups_310809,\n                                        int64_t ctx_param_ext_318833,\n                                        int64_t ctx_param_ext_318834,\n                                        int64_t ctx_param_ext_318836,\n                                        int64_t groups_per_segment_323584,\n                                        int64_t elements_per_thread_323585,\n                                        int64_t virt_num_groups_323586,\n                                        int64_t threads_per_segment_323588,\n                                        __global unsigned char *ext_mem_318756,\n                                ",
            "        __global unsigned char *ext_mem_318757,\n                                        __global\n                                        unsigned char *mem_param_318838,\n                                        __global unsigned char *mem_319555,\n                                        __global unsigned char *mem_319659,\n                                        __global unsigned char *mem_319664,\n                                        __global\n                                        unsigned char *segred_tmp_mem_323589,\n                                        __global\n                                        unsigned char *mainzicounter_mem_323591)\n{\n    #define segred_group_sizze_310808 (mainzisegred_group_sizze_310508)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_323600_backing_1 =\n                           &shared_mem[sync_arr_mem_323600_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323598_backing_0 =\n                           &shared_mem[red_arr_mem_323598_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323593;\n    int32_t local_tid_323594;\n    int64_t group_sizze_323597;\n    int32_t wave_sizze_323596;\n    int32_t group_tid_323595;\n    \n    global_tid_323593 = get_global_id(0);\n    local_tid_323594 = get_local_id(0);\n    group_sizze_323597 = get_local_size(0);\n    wave_sizze_323596 = LOCKSTEP_WIDTH;\n    group_tid_323595 = get_group_id(0);\n    \n    int32_t phys_tid_310815 = global_tid_323593;\n    __local unsigned char *red_arr_mem_323598;\n    \n    red_arr_mem_323598 = (__local unsigned char *) red_arr_mem_323598_backing_0;\n    \n    __local unsigned char *sync_arr_mem_323600;\n    \n    sync_arr_mem_323600 = (__local\n                           unsigned char *) sync_arr_mem_323600_backing_1;\n    \n    int32_t phys_group_id_323602;\n    \n    phys_group_id_323602 = get_group_id(0);\n    for (int32_t i_323603 = 0; i_32360",
            "3 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_323586) - phys_group_id_323602,\n                   sext_i64_i32(num_groups_310809)); i_323603++) {\n        int32_t virt_group_id_323604 = phys_group_id_323602 + i_323603 *\n                sext_i64_i32(num_groups_310809);\n        int32_t flat_segment_id_323605 = squot32(virt_group_id_323604,\n                                                 sext_i64_i32(groups_per_segment_323584));\n        int64_t global_tid_323606 = srem64(sext_i32_i64(virt_group_id_323604) *\n                                           segred_group_sizze_310808 +\n                                           sext_i32_i64(local_tid_323594),\n                                           segred_group_sizze_310808 *\n                                           groups_per_segment_323584);\n        int64_t slice_323607 = l_n_m_292832;\n        int64_t slice_323608 = partition_sizze_292766 * slice_323607;\n        int64_t gtid_310812 = squot64(sext_i32_i64(flat_segment_id_323605),\n                                      slice_323607);\n        int64_t remnant_323609 = sext_i32_i64(flat_segment_id_323605) -\n                gtid_310812 * slice_323607;\n        int64_t gtid_310813 = remnant_323609;\n        int64_t remnant_323610 = remnant_323609 - gtid_310813;\n        int64_t gtid_310814;\n        double x_acc_323611;\n        int64_t chunk_sizze_323612 = smin64(elements_per_thread_323585,\n                                            sdiv_up64(q_l_292680 -\n                                                      global_tid_323606,\n                                                      threads_per_segment_323588));\n        double x_310816;\n        double x_310817;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_323611 = 0.0;\n        }\n        for (int64_t i_323616 = 0; i_323616 < chunk_sizze_323612; i_323616++) {\n            gtid_310814 = global_tid_323606 + threads_per_segment_323588 *\n                i_323616;\n            // apply map function\n ",
            "           {\n                int64_t x_310825;\n                \n                x_310825 = ((__global int64_t *) ext_mem_318757)[gtid_310812 *\n                                                                 l_n_m_292832 +\n                                                                 gtid_310813];\n                \n                double x_310826;\n                \n                x_310826 = ((__global double *) ext_mem_318756)[gtid_310812 *\n                                                                l_n_m_292832 +\n                                                                gtid_310813];\n                \n                int64_t binop_y_317897 = mul64(jump_t_292685, gtid_310813);\n                int64_t binop_y_317898 = smin64(i_292846, binop_y_317897);\n                int64_t index_primexp_317899 = add64((int64_t) 1,\n                                                     binop_y_317898);\n                double a0_310828;\n                \n                a0_310828 = ((__global double *) mem_319659)[gtid_310812 *\n                                                             l_n_m_292832 +\n                                                             gtid_310813];\n                \n                bool cond_310830 = sle64(n_292675, gtid_310814);\n                int64_t defunc_0_f_res_310831;\n                \n                if (cond_310830) {\n                    defunc_0_f_res_310831 = (int64_t) 0;\n                } else {\n                    int64_t i_310832 = add64(gtid_310814, x_310825);\n                    int64_t defunc_1_add_res_310833 = add64((int64_t) 1,\n                                                            i_310832);\n                    \n                    defunc_0_f_res_310831 = defunc_1_add_res_310833;\n                }\n                \n                double defunc_0_f_res_310834;\n                \n                if (cond_310830) {\n                    defunc_0_f_res_310834 = 0.0;\n                } else {\n                    int64_t i_310835 = add",
            "64(gtid_310814, x_310825);\n                    double defunc_0_add_arg_310836;\n                    \n                    defunc_0_add_arg_310836 = ((__global\n                                                double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                            (gtid_310812 *\n                                                                             ctx_param_ext_318834 +\n                                                                             i_310835 *\n                                                                             ctx_param_ext_318836)];\n                    defunc_0_f_res_310834 = defunc_0_add_arg_310836;\n                }\n                \n                int64_t binop_p_310837 = sub64(defunc_0_f_res_310831,\n                                               index_primexp_317899);\n                double defunc_0_f_res_310838 = sitofp_i64_f64(binop_p_310837);\n                double abs_res_310839 = fabs(defunc_0_f_res_310838);\n                double tmp1_310840 = abs_res_310839 / x_310826;\n                double x_310841 = tmp1_310840 * tmp1_310840;\n                double y_310842 = tmp1_310840 * x_310841;\n                double tmp2_310843 = 1.0 - y_310842;\n                double x_310844 = tmp2_310843 * tmp2_310843;\n                double tmp3_310845 = tmp2_310843 * x_310844;\n                double tmp4_310846 = defunc_0_f_res_310834 * tmp3_310845;\n                double defunc_0_f_res_310847;\n                \n                if (cond_310830) {\n                    defunc_0_f_res_310847 = 0.0;\n                } else {\n                    int64_t i_310848 = add64(gtid_310814, x_310825);\n                    double defunc_0_add_arg_310849;\n                    \n                    defunc_0_add_arg_310849 = ((__global\n                                                double *) mem_319555)[gtid_310812 *\n                                                                      n_292675 +\n    ",
            "                                                                  i_310848];\n                    defunc_0_f_res_310847 = defunc_0_add_arg_310849;\n                }\n                \n                double x_310850 = a0_310828 * tmp4_310846;\n                double defunc_9_fit_fun_res_310851 = defunc_0_f_res_310847 *\n                       x_310850;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_310816 = x_acc_323611;\n                }\n                // load new values\n                {\n                    x_310817 = defunc_9_fit_fun_res_310851;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_310818 = x_310816 + x_310817;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_323611 = defunc_1_op_res_310818;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_310816 = x_acc_323611;\n            ((__local\n              double *) red_arr_mem_323598)[sext_i32_i64(local_tid_323594)] =\n                x_310816;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_323617;\n        int32_t skip_waves_323618 = 1;\n        double x_323613;\n        double x_323614;\n        \n        offset_323617 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_323594,\n                      sext_i64_i32(segred_group_sizze_310808))) {\n                x_323613 = ((__local\n                             double *) red_arr_mem_323598)[sext_i32_i64(local_tid_323594 +\n                                                           offset_323617)];\n            }\n        }\n        offset_323617 = 1;\n        while (slt32(offset_323617, wave_sizze_323596)) {\n            if (slt32(local_tid_32",
            "3594 + offset_323617,\n                      sext_i64_i32(segred_group_sizze_310808)) &&\n                ((local_tid_323594 - squot32(local_tid_323594,\n                                             wave_sizze_323596) *\n                  wave_sizze_323596) & (2 * offset_323617 - 1)) == 0) {\n                // read array element\n                {\n                    x_323614 = ((volatile __local\n                                 double *) red_arr_mem_323598)[sext_i32_i64(local_tid_323594 +\n                                                               offset_323617)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323615 = x_323613 + x_323614;\n                    \n                    x_323613 = defunc_1_op_res_323615;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_323598)[sext_i32_i64(local_tid_323594)] =\n                        x_323613;\n                }\n            }\n            offset_323617 *= 2;\n        }\n        while (slt32(skip_waves_323618,\n                     squot32(sext_i64_i32(segred_group_sizze_310808) +\n                             wave_sizze_323596 - 1, wave_sizze_323596))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_323617 = skip_waves_323618 * wave_sizze_323596;\n            if (slt32(local_tid_323594 + offset_323617,\n                      sext_i64_i32(segred_group_sizze_310808)) &&\n                ((local_tid_323594 - squot32(local_tid_323594,\n                                             wave_sizze_323596) *\n                  wave_sizze_323596) == 0 && (squot32(local_tid_323594,\n                                                      wave_sizze_323596) & (2 *\n                                                                            skip_waves_323618 -\n                                                                            1)) ==\n         ",
            "        0)) {\n                // read array element\n                {\n                    x_323614 = ((__local\n                                 double *) red_arr_mem_323598)[sext_i32_i64(local_tid_323594 +\n                                                               offset_323617)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323615 = x_323613 + x_323614;\n                    \n                    x_323613 = defunc_1_op_res_323615;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_323598)[sext_i32_i64(local_tid_323594)] =\n                        x_323613;\n                }\n            }\n            skip_waves_323618 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_323594) == (int64_t) 0) {\n                x_acc_323611 = x_323613;\n            }\n        }\n        if (groups_per_segment_323584 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_323594 == 0) {\n                    ((__global double *) mem_319664)[gtid_310812 *\n                                                     l_n_m_292832 +\n                                                     gtid_310813] =\n                        x_acc_323611;\n                }\n            }\n        } else {\n            int32_t old_counter_323619;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_323594 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_323589)[sext_i32_i64(virt_group_id_323604)] =\n                        x_acc_323611;\n                    mem_fence_global();\n                    old_counter_323619 =\n                        atomic_add_i32_glo",
            "bal(&((volatile __global\n                                                 int *) mainzicounter_mem_323591)[sext_i32_i64(srem32(flat_segment_id_323605,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_323600)[(int64_t) 0] =\n                        old_counter_323619 == groups_per_segment_323584 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_323620;\n            \n            is_last_group_323620 = ((__local\n                                     bool *) sync_arr_mem_323600)[(int64_t) 0];\n            if (is_last_group_323620) {\n                if (local_tid_323594 == 0) {\n                    old_counter_323619 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_323591)[sext_i32_i64(srem32(flat_segment_id_323605,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_323584));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_323621 =\n                            sdiv_up64(groups_per_segment_323584,\n                                      segred_group_sizze_310808);\n                    \n                    x_310816 = 0.0;\n                    for (int64_t i_323622 = 0; i_323622 <\n                         read_per_thread_323621; i_323622++) {\n                        int64_t group_res_id_323623 =\n                                sext_i32_i64(local_tid_323594) *\n                                read_per_thread_323621 + i_3236",
            "22;\n                        int64_t index_of_group_res_323624 =\n                                sext_i32_i64(flat_segment_id_323605) *\n                                groups_per_segment_323584 + group_res_id_323623;\n                        \n                        if (slt64(group_res_id_323623,\n                                  groups_per_segment_323584)) {\n                            x_310817 = ((__global\n                                         double *) segred_tmp_mem_323589)[index_of_group_res_323624];\n                            \n                            double defunc_1_op_res_310818 = x_310816 + x_310817;\n                            \n                            x_310816 = defunc_1_op_res_310818;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_323598)[sext_i32_i64(local_tid_323594)] =\n                    x_310816;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_323625;\n                    int32_t skip_waves_323626 = 1;\n                    double x_323613;\n                    double x_323614;\n                    \n                    offset_323625 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_323594,\n                                  sext_i64_i32(segred_group_sizze_310808))) {\n                            x_323613 = ((__local\n                                         double *) red_arr_mem_323598)[sext_i32_i64(local_tid_323594 +\n                                                                       offset_323625)];\n                        }\n                    }\n                    offset_323625 = 1;\n                    while (slt32(offset_323625, wave_sizze_323596)) {\n                        if (slt32(local_tid_323594 + offset_323625,\n                                  sext_i64_i32(segred_g",
            "roup_sizze_310808)) &&\n                            ((local_tid_323594 - squot32(local_tid_323594,\n                                                         wave_sizze_323596) *\n                              wave_sizze_323596) & (2 * offset_323625 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_323614 = ((volatile __local\n                                             double *) red_arr_mem_323598)[sext_i32_i64(local_tid_323594 +\n                                                                           offset_323625)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_323615 = x_323613 +\n                                       x_323614;\n                                \n                                x_323613 = defunc_1_op_res_323615;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323598)[sext_i32_i64(local_tid_323594)] =\n                                    x_323613;\n                            }\n                        }\n                        offset_323625 *= 2;\n                    }\n                    while (slt32(skip_waves_323626,\n                                 squot32(sext_i64_i32(segred_group_sizze_310808) +\n                                         wave_sizze_323596 - 1,\n                                         wave_sizze_323596))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_323625 = skip_waves_323626 * wave_sizze_323596;\n                        if (slt32(local_tid_323594 + offset_323625,\n                                  sext_i64_i32(segred_group_sizze_310808)) &&\n                            ((local_tid_323594 - squot",
            "32(local_tid_323594,\n                                                         wave_sizze_323596) *\n                              wave_sizze_323596) == 0 &&\n                             (squot32(local_tid_323594, wave_sizze_323596) &\n                              (2 * skip_waves_323626 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_323614 = ((__local\n                                             double *) red_arr_mem_323598)[sext_i32_i64(local_tid_323594 +\n                                                                           offset_323625)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_323615 = x_323613 +\n                                       x_323614;\n                                \n                                x_323613 = defunc_1_op_res_323615;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_323598)[sext_i32_i64(local_tid_323594)] =\n                                    x_323613;\n                            }\n                        }\n                        skip_waves_323626 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_323594 == 0) {\n                            ((__global double *) mem_319664)[gtid_310812 *\n                                                             l_n_m_292832 +\n                                                             gtid_310813] =\n                                x_323613;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    ",
            "#undef segred_group_sizze_310808\n}\n__kernel void mainzisegred_large_311208(__global int *global_failure,\n                                        uint sync_arr_mem_323693_backing_offset_0,\n                                        uint red_arr_mem_323691_backing_offset_1,\n                                        uint red_arr_mem_323689_backing_offset_2,\n                                        uint red_arr_mem_323687_backing_offset_3,\n                                        int64_t n_292675, int64_t q_l_292680,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t l_n_m_292832, int64_t i_292846,\n                                        int64_t num_groups_311200,\n                                        int64_t ctx_param_ext_318833,\n                                        int64_t ctx_param_ext_318834,\n                                        int64_t ctx_param_ext_318836,\n                                        int64_t groups_per_segment_323669,\n                                        int64_t elements_per_thread_323670,\n                                        int64_t virt_num_groups_323671,\n                                        int64_t threads_per_segment_323673,\n                                        __global unsigned char *ext_mem_318756,\n                                        __global unsigned char *ext_mem_318757,\n                                        __global\n                                        unsigned char *mem_param_318838,\n                                        __global unsigned char *mem_319669,\n                                        __global unsigned char *mem_319673,\n                                        __global unsigned char *mem_319677,\n                                        __global\n                                        unsigned char *segred_tmp_mem_323674,\n                                        __global\n           ",
            "                             unsigned char *segred_tmp_mem_323676,\n                                        __global\n                                        unsigned char *segred_tmp_mem_323678,\n                                        __global\n                                        unsigned char *mainzicounter_mem_323680)\n{\n    #define segred_group_sizze_311199 (mainzisegred_group_sizze_310971)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_323693_backing_3 =\n                           &shared_mem[sync_arr_mem_323693_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323691_backing_2 =\n                           &shared_mem[red_arr_mem_323691_backing_offset_1];\n    volatile unsigned char *red_arr_mem_323689_backing_1 =\n                           &shared_mem[red_arr_mem_323689_backing_offset_2];\n    volatile unsigned char *red_arr_mem_323687_backing_0 =\n                           &shared_mem[red_arr_mem_323687_backing_offset_3];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323682;\n    int32_t local_tid_323683;\n    int64_t group_sizze_323686;\n    int32_t wave_sizze_323685;\n    int32_t group_tid_323684;\n    \n    global_tid_323682 = get_global_id(0);\n    local_tid_323683 = get_local_id(0);\n    group_sizze_323686 = get_local_size(0);\n    wave_sizze_323685 = LOCKSTEP_WIDTH;\n    group_tid_323684 = get_group_id(0);\n    \n    int32_t phys_tid_311208 = global_tid_323682;\n    __local unsigned char *red_arr_mem_323687;\n    \n    red_arr_mem_323687 = (__local unsigned char *) red_arr_mem_323687_backing_0;\n    \n    __local unsigned char *red_arr_mem_323689;\n    \n    red_arr_mem_323689 = (__local unsigned char *) red_arr_mem_323689_backing_1;\n    \n    __local unsigned char *red_arr_mem_323691;\n    \n    red_arr_mem_323691 = (__local unsigned char *) red_arr_mem_323691_backing_2;\n    \n    __local unsigned char *sync_arr_mem_323693;\n    \n    sync_arr_mem_32",
            "3693 = (__local\n                           unsigned char *) sync_arr_mem_323693_backing_3;\n    \n    int32_t phys_group_id_323695;\n    \n    phys_group_id_323695 = get_group_id(0);\n    for (int32_t i_323696 = 0; i_323696 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_323671) - phys_group_id_323695,\n                   sext_i64_i32(num_groups_311200)); i_323696++) {\n        int32_t virt_group_id_323697 = phys_group_id_323695 + i_323696 *\n                sext_i64_i32(num_groups_311200);\n        int32_t flat_segment_id_323698 = squot32(virt_group_id_323697,\n                                                 sext_i64_i32(groups_per_segment_323669));\n        int64_t global_tid_323699 = srem64(sext_i32_i64(virt_group_id_323697) *\n                                           segred_group_sizze_311199 +\n                                           sext_i32_i64(local_tid_323683),\n                                           segred_group_sizze_311199 *\n                                           groups_per_segment_323669);\n        int64_t slice_323700 = l_n_m_292832;\n        int64_t slice_323701 = partition_sizze_292766 * slice_323700;\n        int64_t gtid_311205 = squot64(sext_i32_i64(flat_segment_id_323698),\n                                      slice_323700);\n        int64_t remnant_323702 = sext_i32_i64(flat_segment_id_323698) -\n                gtid_311205 * slice_323700;\n        int64_t gtid_311206 = remnant_323702;\n        int64_t remnant_323703 = remnant_323702 - gtid_311206;\n        int64_t gtid_311207;\n        double x_acc_323704;\n        double x_acc_323705;\n        double x_acc_323706;\n        int64_t chunk_sizze_323707 = smin64(elements_per_thread_323670,\n                                            sdiv_up64(q_l_292680 -\n                                                      global_tid_323699,\n                                                      threads_per_segment_323673));\n        double x_311209;\n        double x_311210;\n        double x_311211;\n        double x_311212;",
            "\n        double x_311213;\n        double x_311214;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_323704 = 0.0;\n            x_acc_323705 = 0.0;\n            x_acc_323706 = 0.0;\n        }\n        for (int64_t i_323717 = 0; i_323717 < chunk_sizze_323707; i_323717++) {\n            gtid_311207 = global_tid_323699 + threads_per_segment_323673 *\n                i_323717;\n            // apply map function\n            {\n                int64_t x_311222;\n                \n                x_311222 = ((__global int64_t *) ext_mem_318757)[gtid_311205 *\n                                                                 l_n_m_292832 +\n                                                                 gtid_311206];\n                \n                double x_311223;\n                \n                x_311223 = ((__global double *) ext_mem_318756)[gtid_311205 *\n                                                                l_n_m_292832 +\n                                                                gtid_311206];\n                \n                int64_t binop_y_317912 = mul64(jump_t_292685, gtid_311206);\n                int64_t binop_y_317913 = smin64(i_292846, binop_y_317912);\n                int64_t index_primexp_317914 = add64((int64_t) 1,\n                                                     binop_y_317913);\n                bool cond_311226 = sle64(n_292675, gtid_311207);\n                int64_t defunc_0_f_res_311227;\n                \n                if (cond_311226) {\n                    defunc_0_f_res_311227 = (int64_t) 0;\n                } else {\n                    int64_t i_311228 = add64(gtid_311207, x_311222);\n                    int64_t defunc_1_add_res_311229 = add64((int64_t) 1,\n                                                            i_311228);\n                    \n                    defunc_0_f_res_311227 = defunc_1_add_res_311229;\n                }\n                \n                double defunc_0_f_res_311230;\n                \n      ",
            "          if (cond_311226) {\n                    defunc_0_f_res_311230 = 0.0;\n                } else {\n                    int64_t i_311231 = add64(gtid_311207, x_311222);\n                    double defunc_0_add_arg_311232;\n                    \n                    defunc_0_add_arg_311232 = ((__global\n                                                double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                            (gtid_311205 *\n                                                                             ctx_param_ext_318834 +\n                                                                             i_311231 *\n                                                                             ctx_param_ext_318836)];\n                    defunc_0_f_res_311230 = defunc_0_add_arg_311232;\n                }\n                \n                int64_t binop_p_311233 = sub64(defunc_0_f_res_311227,\n                                               index_primexp_317914);\n                double defunc_0_f_res_311234 = sitofp_i64_f64(binop_p_311233);\n                double abs_res_311235 = fabs(defunc_0_f_res_311234);\n                double tmp1_311236 = abs_res_311235 / x_311223;\n                double x_311237 = tmp1_311236 * tmp1_311236;\n                double y_311238 = tmp1_311236 * x_311237;\n                double tmp2_311239 = 1.0 - y_311238;\n                double x_311240 = tmp2_311239 * tmp2_311239;\n                double tmp3_311241 = tmp2_311239 * x_311240;\n                double w_j_311242 = defunc_0_f_res_311230 * tmp3_311241;\n                double xw_j_311243 = defunc_0_f_res_311234 * w_j_311242;\n                double x2w_j_311244 = defunc_0_f_res_311234 * xw_j_311243;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_311209 = x_acc_323704;\n                    x_311210 = x_acc_323705;\n                    x_31121",
            "1 = x_acc_323706;\n                }\n                // load new values\n                {\n                    x_311212 = w_j_311242;\n                    x_311213 = xw_j_311243;\n                    x_311214 = x2w_j_311244;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_311215 = x_311209 + x_311212;\n                    double defunc_1_op_res_311216 = x_311210 + x_311213;\n                    double defunc_1_op_res_311217 = x_311211 + x_311214;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_323704 = defunc_1_op_res_311215;\n                        x_acc_323705 = defunc_1_op_res_311216;\n                        x_acc_323706 = defunc_1_op_res_311217;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_311209 = x_acc_323704;\n            x_311210 = x_acc_323705;\n            x_311211 = x_acc_323706;\n            ((__local\n              double *) red_arr_mem_323687)[sext_i32_i64(local_tid_323683)] =\n                x_311209;\n            ((__local\n              double *) red_arr_mem_323689)[sext_i32_i64(local_tid_323683)] =\n                x_311210;\n            ((__local\n              double *) red_arr_mem_323691)[sext_i32_i64(local_tid_323683)] =\n                x_311211;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_323718;\n        int32_t skip_waves_323719 = 1;\n        double x_323708;\n        double x_323709;\n        double x_323710;\n        double x_323711;\n        double x_323712;\n        double x_323713;\n        \n        offset_323718 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_323683,\n                      sext_i64_i32(segred_group_sizze_311199))) {\n                x_323708 = ((__local\n                             double *) red_arr_m",
            "em_323687)[sext_i32_i64(local_tid_323683 +\n                                                           offset_323718)];\n                x_323709 = ((__local\n                             double *) red_arr_mem_323689)[sext_i32_i64(local_tid_323683 +\n                                                           offset_323718)];\n                x_323710 = ((__local\n                             double *) red_arr_mem_323691)[sext_i32_i64(local_tid_323683 +\n                                                           offset_323718)];\n            }\n        }\n        offset_323718 = 1;\n        while (slt32(offset_323718, wave_sizze_323685)) {\n            if (slt32(local_tid_323683 + offset_323718,\n                      sext_i64_i32(segred_group_sizze_311199)) &&\n                ((local_tid_323683 - squot32(local_tid_323683,\n                                             wave_sizze_323685) *\n                  wave_sizze_323685) & (2 * offset_323718 - 1)) == 0) {\n                // read array element\n                {\n                    x_323711 = ((volatile __local\n                                 double *) red_arr_mem_323687)[sext_i32_i64(local_tid_323683 +\n                                                               offset_323718)];\n                    x_323712 = ((volatile __local\n                                 double *) red_arr_mem_323689)[sext_i32_i64(local_tid_323683 +\n                                                               offset_323718)];\n                    x_323713 = ((volatile __local\n                                 double *) red_arr_mem_323691)[sext_i32_i64(local_tid_323683 +\n                                                               offset_323718)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323714 = x_323708 + x_323711;\n                    double defunc_1_op_res_323715 = x_323709 + x_323712;\n                    double defunc_1_op_res_323716 = x_323710 + x_323713;\n          ",
            "          \n                    x_323708 = defunc_1_op_res_323714;\n                    x_323709 = defunc_1_op_res_323715;\n                    x_323710 = defunc_1_op_res_323716;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_323687)[sext_i32_i64(local_tid_323683)] =\n                        x_323708;\n                    ((volatile __local\n                      double *) red_arr_mem_323689)[sext_i32_i64(local_tid_323683)] =\n                        x_323709;\n                    ((volatile __local\n                      double *) red_arr_mem_323691)[sext_i32_i64(local_tid_323683)] =\n                        x_323710;\n                }\n            }\n            offset_323718 *= 2;\n        }\n        while (slt32(skip_waves_323719,\n                     squot32(sext_i64_i32(segred_group_sizze_311199) +\n                             wave_sizze_323685 - 1, wave_sizze_323685))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_323718 = skip_waves_323719 * wave_sizze_323685;\n            if (slt32(local_tid_323683 + offset_323718,\n                      sext_i64_i32(segred_group_sizze_311199)) &&\n                ((local_tid_323683 - squot32(local_tid_323683,\n                                             wave_sizze_323685) *\n                  wave_sizze_323685) == 0 && (squot32(local_tid_323683,\n                                                      wave_sizze_323685) & (2 *\n                                                                            skip_waves_323719 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_323711 = ((__local\n                                 double *) red_arr_mem_323687)[sext_i32_i64(local_tid_323683 +\n                                                               offset_323718)];\n                    ",
            "x_323712 = ((__local\n                                 double *) red_arr_mem_323689)[sext_i32_i64(local_tid_323683 +\n                                                               offset_323718)];\n                    x_323713 = ((__local\n                                 double *) red_arr_mem_323691)[sext_i32_i64(local_tid_323683 +\n                                                               offset_323718)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323714 = x_323708 + x_323711;\n                    double defunc_1_op_res_323715 = x_323709 + x_323712;\n                    double defunc_1_op_res_323716 = x_323710 + x_323713;\n                    \n                    x_323708 = defunc_1_op_res_323714;\n                    x_323709 = defunc_1_op_res_323715;\n                    x_323710 = defunc_1_op_res_323716;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_323687)[sext_i32_i64(local_tid_323683)] =\n                        x_323708;\n                    ((__local\n                      double *) red_arr_mem_323689)[sext_i32_i64(local_tid_323683)] =\n                        x_323709;\n                    ((__local\n                      double *) red_arr_mem_323691)[sext_i32_i64(local_tid_323683)] =\n                        x_323710;\n                }\n            }\n            skip_waves_323719 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_323683) == (int64_t) 0) {\n                x_acc_323704 = x_323708;\n                x_acc_323705 = x_323709;\n                x_acc_323706 = x_323710;\n            }\n        }\n        if (groups_per_segment_323669 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_323683 == 0",
            ") {\n                    ((__global double *) mem_319669)[gtid_311205 *\n                                                     l_n_m_292832 +\n                                                     gtid_311206] =\n                        x_acc_323704;\n                    ((__global double *) mem_319673)[gtid_311205 *\n                                                     l_n_m_292832 +\n                                                     gtid_311206] =\n                        x_acc_323705;\n                    ((__global double *) mem_319677)[gtid_311205 *\n                                                     l_n_m_292832 +\n                                                     gtid_311206] =\n                        x_acc_323706;\n                }\n            }\n        } else {\n            int32_t old_counter_323720;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_323683 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_323674)[sext_i32_i64(virt_group_id_323697)] =\n                        x_acc_323704;\n                    ((__global\n                      double *) segred_tmp_mem_323676)[sext_i32_i64(virt_group_id_323697)] =\n                        x_acc_323705;\n                    ((__global\n                      double *) segred_tmp_mem_323678)[sext_i32_i64(virt_group_id_323697)] =\n                        x_acc_323706;\n                    mem_fence_global();\n                    old_counter_323720 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_323680)[sext_i32_i64(srem32(flat_segment_id_323698,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_323693)[(int64_t) 0] =\n                        old_counter_3",
            "23720 == groups_per_segment_323669 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_323721;\n            \n            is_last_group_323721 = ((__local\n                                     bool *) sync_arr_mem_323693)[(int64_t) 0];\n            if (is_last_group_323721) {\n                if (local_tid_323683 == 0) {\n                    old_counter_323720 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_323680)[sext_i32_i64(srem32(flat_segment_id_323698,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_323669));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_323722 =\n                            sdiv_up64(groups_per_segment_323669,\n                                      segred_group_sizze_311199);\n                    \n                    x_311209 = 0.0;\n                    x_311210 = 0.0;\n                    x_311211 = 0.0;\n                    for (int64_t i_323723 = 0; i_323723 <\n                         read_per_thread_323722; i_323723++) {\n                        int64_t group_res_id_323724 =\n                                sext_i32_i64(local_tid_323683) *\n                                read_per_thread_323722 + i_323723;\n                        int64_t index_of_group_res_323725 =\n                                sext_i32_i64(flat_segment_id_323698) *\n                                groups_per_segment_323669 + group_res_id_323724;\n                        \n                        if (slt64(group_res_id_323724,\n                                  groups_per_segment_323669)) ",
            "{\n                            x_311212 = ((__global\n                                         double *) segred_tmp_mem_323674)[index_of_group_res_323725];\n                            x_311213 = ((__global\n                                         double *) segred_tmp_mem_323676)[index_of_group_res_323725];\n                            x_311214 = ((__global\n                                         double *) segred_tmp_mem_323678)[index_of_group_res_323725];\n                            \n                            double defunc_1_op_res_311215 = x_311209 + x_311212;\n                            double defunc_1_op_res_311216 = x_311210 + x_311213;\n                            double defunc_1_op_res_311217 = x_311211 + x_311214;\n                            \n                            x_311209 = defunc_1_op_res_311215;\n                            x_311210 = defunc_1_op_res_311216;\n                            x_311211 = defunc_1_op_res_311217;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_323687)[sext_i32_i64(local_tid_323683)] =\n                    x_311209;\n                ((__local\n                  double *) red_arr_mem_323689)[sext_i32_i64(local_tid_323683)] =\n                    x_311210;\n                ((__local\n                  double *) red_arr_mem_323691)[sext_i32_i64(local_tid_323683)] =\n                    x_311211;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_323726;\n                    int32_t skip_waves_323727 = 1;\n                    double x_323708;\n                    double x_323709;\n                    double x_323710;\n                    double x_323711;\n                    double x_323712;\n                    double x_323713;\n                    \n                    offset_323726 = 0;\n                    // participating threads read initial accumulator\n              ",
            "      {\n                        if (slt32(local_tid_323683,\n                                  sext_i64_i32(segred_group_sizze_311199))) {\n                            x_323708 = ((__local\n                                         double *) red_arr_mem_323687)[sext_i32_i64(local_tid_323683 +\n                                                                       offset_323726)];\n                            x_323709 = ((__local\n                                         double *) red_arr_mem_323689)[sext_i32_i64(local_tid_323683 +\n                                                                       offset_323726)];\n                            x_323710 = ((__local\n                                         double *) red_arr_mem_323691)[sext_i32_i64(local_tid_323683 +\n                                                                       offset_323726)];\n                        }\n                    }\n                    offset_323726 = 1;\n                    while (slt32(offset_323726, wave_sizze_323685)) {\n                        if (slt32(local_tid_323683 + offset_323726,\n                                  sext_i64_i32(segred_group_sizze_311199)) &&\n                            ((local_tid_323683 - squot32(local_tid_323683,\n                                                         wave_sizze_323685) *\n                              wave_sizze_323685) & (2 * offset_323726 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_323711 = ((volatile __local\n                                             double *) red_arr_mem_323687)[sext_i32_i64(local_tid_323683 +\n                                                                           offset_323726)];\n                                x_323712 = ((volatile __local\n                                             double *) red_arr_mem_323689)[sext_i32_i64(local_tid_323683 +\n                                                                ",
            "           offset_323726)];\n                                x_323713 = ((volatile __local\n                                             double *) red_arr_mem_323691)[sext_i32_i64(local_tid_323683 +\n                                                                           offset_323726)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_323714 = x_323708 +\n                                       x_323711;\n                                double defunc_1_op_res_323715 = x_323709 +\n                                       x_323712;\n                                double defunc_1_op_res_323716 = x_323710 +\n                                       x_323713;\n                                \n                                x_323708 = defunc_1_op_res_323714;\n                                x_323709 = defunc_1_op_res_323715;\n                                x_323710 = defunc_1_op_res_323716;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323687)[sext_i32_i64(local_tid_323683)] =\n                                    x_323708;\n                                ((volatile __local\n                                  double *) red_arr_mem_323689)[sext_i32_i64(local_tid_323683)] =\n                                    x_323709;\n                                ((volatile __local\n                                  double *) red_arr_mem_323691)[sext_i32_i64(local_tid_323683)] =\n                                    x_323710;\n                            }\n                        }\n                        offset_323726 *= 2;\n                    }\n                    while (slt32(skip_waves_323727,\n                                 squot32(sext_i64_i32(segred_group_sizze_311199) +\n                             ",
            "            wave_sizze_323685 - 1,\n                                         wave_sizze_323685))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_323726 = skip_waves_323727 * wave_sizze_323685;\n                        if (slt32(local_tid_323683 + offset_323726,\n                                  sext_i64_i32(segred_group_sizze_311199)) &&\n                            ((local_tid_323683 - squot32(local_tid_323683,\n                                                         wave_sizze_323685) *\n                              wave_sizze_323685) == 0 &&\n                             (squot32(local_tid_323683, wave_sizze_323685) &\n                              (2 * skip_waves_323727 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_323711 = ((__local\n                                             double *) red_arr_mem_323687)[sext_i32_i64(local_tid_323683 +\n                                                                           offset_323726)];\n                                x_323712 = ((__local\n                                             double *) red_arr_mem_323689)[sext_i32_i64(local_tid_323683 +\n                                                                           offset_323726)];\n                                x_323713 = ((__local\n                                             double *) red_arr_mem_323691)[sext_i32_i64(local_tid_323683 +\n                                                                           offset_323726)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_323714 = x_323708 +\n                                       x_323711;\n                                double defunc_1_op_res_323715 = x_323709 +\n                                       x_323712;\n                                double defunc_1_op_res_323716 = x_",
            "323710 +\n                                       x_323713;\n                                \n                                x_323708 = defunc_1_op_res_323714;\n                                x_323709 = defunc_1_op_res_323715;\n                                x_323710 = defunc_1_op_res_323716;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_323687)[sext_i32_i64(local_tid_323683)] =\n                                    x_323708;\n                                ((__local\n                                  double *) red_arr_mem_323689)[sext_i32_i64(local_tid_323683)] =\n                                    x_323709;\n                                ((__local\n                                  double *) red_arr_mem_323691)[sext_i32_i64(local_tid_323683)] =\n                                    x_323710;\n                            }\n                        }\n                        skip_waves_323727 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_323683 == 0) {\n                            ((__global double *) mem_319669)[gtid_311205 *\n                                                             l_n_m_292832 +\n                                                             gtid_311206] =\n                                x_323708;\n                            ((__global double *) mem_319673)[gtid_311205 *\n                                                             l_n_m_292832 +\n                                                             gtid_311206] =\n                                x_323709;\n                            ((__global double *) mem_319677)[gtid_311205 *\n                                                             l_n_m_292832 +\n                                                             gtid_311206] =\n   ",
            "                             x_323710;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_311199\n}\n__kernel void mainzisegred_large_311280(__global int *global_failure,\n                                        uint sync_arr_mem_323794_backing_offset_0,\n                                        uint red_arr_mem_323792_backing_offset_1,\n                                        uint red_arr_mem_323790_backing_offset_2,\n                                        int64_t n_292675, int64_t q_l_292680,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t l_n_m_292832, int64_t i_292846,\n                                        int64_t num_groups_311273,\n                                        int64_t ctx_param_ext_318833,\n                                        int64_t ctx_param_ext_318834,\n                                        int64_t ctx_param_ext_318836,\n                                        int64_t groups_per_segment_323774,\n                                        int64_t elements_per_thread_323775,\n                                        int64_t virt_num_groups_323776,\n                                        int64_t threads_per_segment_323778,\n                                        __global unsigned char *ext_mem_318756,\n                                        __global unsigned char *ext_mem_318757,\n                                        __global\n                                        unsigned char *mem_param_318838,\n                                        __global unsigned char *mem_319555,\n                                        __global unsigned char *mem_319682,\n                                        __global unsigned char *mem_319686,\n                                        _",
            "_global unsigned char *mem_319690,\n                                        __global unsigned char *mem_319695,\n                                        __global unsigned char *mem_319699,\n                                        __global\n                                        unsigned char *segred_tmp_mem_323779,\n                                        __global\n                                        unsigned char *segred_tmp_mem_323781,\n                                        __global\n                                        unsigned char *mainzicounter_mem_323783)\n{\n    #define segred_group_sizze_311272 (mainzisegred_group_sizze_310874)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_323794_backing_2 =\n                           &shared_mem[sync_arr_mem_323794_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323792_backing_1 =\n                           &shared_mem[red_arr_mem_323792_backing_offset_1];\n    volatile unsigned char *red_arr_mem_323790_backing_0 =\n                           &shared_mem[red_arr_mem_323790_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323785;\n    int32_t local_tid_323786;\n    int64_t group_sizze_323789;\n    int32_t wave_sizze_323788;\n    int32_t group_tid_323787;\n    \n    global_tid_323785 = get_global_id(0);\n    local_tid_323786 = get_local_id(0);\n    group_sizze_323789 = get_local_size(0);\n    wave_sizze_323788 = LOCKSTEP_WIDTH;\n    group_tid_323787 = get_group_id(0);\n    \n    int32_t phys_tid_311280 = global_tid_323785;\n    __local unsigned char *red_arr_mem_323790;\n    \n    red_arr_mem_323790 = (__local unsigned char *) red_arr_mem_323790_backing_0;\n    \n    __local unsigned char *red_arr_mem_323792;\n    \n    red_arr_mem_323792 = (__local unsigned char *) red_arr_mem_323792_backing_1;\n    \n    __local unsigned char *sync_arr_mem_323794;\n    \n    sync_arr_mem_323794 = (__local\n           ",
            "                unsigned char *) sync_arr_mem_323794_backing_2;\n    \n    int32_t phys_group_id_323796;\n    \n    phys_group_id_323796 = get_group_id(0);\n    for (int32_t i_323797 = 0; i_323797 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_323776) - phys_group_id_323796,\n                   sext_i64_i32(num_groups_311273)); i_323797++) {\n        int32_t virt_group_id_323798 = phys_group_id_323796 + i_323797 *\n                sext_i64_i32(num_groups_311273);\n        int32_t flat_segment_id_323799 = squot32(virt_group_id_323798,\n                                                 sext_i64_i32(groups_per_segment_323774));\n        int64_t global_tid_323800 = srem64(sext_i32_i64(virt_group_id_323798) *\n                                           segred_group_sizze_311272 +\n                                           sext_i32_i64(local_tid_323786),\n                                           segred_group_sizze_311272 *\n                                           groups_per_segment_323774);\n        int64_t slice_323801 = l_n_m_292832;\n        int64_t slice_323802 = partition_sizze_292766 * slice_323801;\n        int64_t gtid_311277 = squot64(sext_i32_i64(flat_segment_id_323799),\n                                      slice_323801);\n        int64_t remnant_323803 = sext_i32_i64(flat_segment_id_323799) -\n                gtid_311277 * slice_323801;\n        int64_t gtid_311278 = remnant_323803;\n        int64_t remnant_323804 = remnant_323803 - gtid_311278;\n        int64_t gtid_311279;\n        double x_acc_323805;\n        double x_acc_323806;\n        int64_t chunk_sizze_323807 = smin64(elements_per_thread_323775,\n                                            sdiv_up64(q_l_292680 -\n                                                      global_tid_323800,\n                                                      threads_per_segment_323778));\n        double x_311281;\n        double x_311282;\n        double x_311283;\n        double x_311284;\n        \n        // neutral-initialise the accumulators",
            "\n        {\n            x_acc_323805 = 0.0;\n            x_acc_323806 = 0.0;\n        }\n        for (int64_t i_323814 = 0; i_323814 < chunk_sizze_323807; i_323814++) {\n            gtid_311279 = global_tid_323800 + threads_per_segment_323778 *\n                i_323814;\n            // apply map function\n            {\n                int64_t x_311295;\n                \n                x_311295 = ((__global int64_t *) ext_mem_318757)[gtid_311277 *\n                                                                 l_n_m_292832 +\n                                                                 gtid_311278];\n                \n                double x_311296;\n                \n                x_311296 = ((__global double *) ext_mem_318756)[gtid_311277 *\n                                                                l_n_m_292832 +\n                                                                gtid_311278];\n                \n                int64_t binop_y_317907 = mul64(jump_t_292685, gtid_311278);\n                int64_t binop_y_317908 = smin64(i_292846, binop_y_317907);\n                int64_t index_primexp_317909 = add64((int64_t) 1,\n                                                     binop_y_317908);\n                double a11_311298;\n                \n                a11_311298 = ((__global double *) mem_319682)[gtid_311277 *\n                                                              l_n_m_292832 +\n                                                              gtid_311278];\n                \n                double b11_311299;\n                \n                b11_311299 = ((__global double *) mem_319686)[gtid_311277 *\n                                                              l_n_m_292832 +\n                                                              gtid_311278];\n                \n                double c11_311300;\n                \n                c11_311300 = ((__global double *) mem_319690)[gtid_311277 *\n                                                              l_n_m",
            "_292832 +\n                                                              gtid_311278];\n                \n                bool cond_311302 = sle64(n_292675, gtid_311279);\n                int64_t defunc_0_f_res_311303;\n                \n                if (cond_311302) {\n                    defunc_0_f_res_311303 = (int64_t) 0;\n                } else {\n                    int64_t i_311304 = add64(gtid_311279, x_311295);\n                    int64_t defunc_1_add_res_311305 = add64((int64_t) 1,\n                                                            i_311304);\n                    \n                    defunc_0_f_res_311303 = defunc_1_add_res_311305;\n                }\n                \n                double defunc_0_f_res_311306;\n                \n                if (cond_311302) {\n                    defunc_0_f_res_311306 = 0.0;\n                } else {\n                    int64_t i_311307 = add64(gtid_311279, x_311295);\n                    double defunc_0_add_arg_311308;\n                    \n                    defunc_0_add_arg_311308 = ((__global\n                                                double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                            (gtid_311277 *\n                                                                             ctx_param_ext_318834 +\n                                                                             i_311307 *\n                                                                             ctx_param_ext_318836)];\n                    defunc_0_f_res_311306 = defunc_0_add_arg_311308;\n                }\n                \n                int64_t binop_p_311309 = sub64(defunc_0_f_res_311303,\n                                               index_primexp_317909);\n                double defunc_0_f_res_311310 = sitofp_i64_f64(binop_p_311309);\n                double abs_res_311311 = fabs(defunc_0_f_res_311310);\n                double tmp1_311312 = abs_res_311311 / x_311296;\n       ",
            "         double x_311313 = tmp1_311312 * tmp1_311312;\n                double y_311314 = tmp1_311312 * x_311313;\n                double tmp2_311315 = 1.0 - y_311314;\n                double x_311316 = tmp2_311315 * tmp2_311315;\n                double tmp3_311317 = tmp2_311315 * x_311316;\n                double tmp4_311318 = defunc_0_f_res_311306 * tmp3_311317;\n                double defunc_1_f_res_311319 = defunc_0_f_res_311310 *\n                       tmp4_311318;\n                double defunc_0_f_res_311320;\n                \n                if (cond_311302) {\n                    defunc_0_f_res_311320 = 0.0;\n                } else {\n                    int64_t i_311321 = add64(gtid_311279, x_311295);\n                    double defunc_0_add_arg_311322;\n                    \n                    defunc_0_add_arg_311322 = ((__global\n                                                double *) mem_319555)[gtid_311277 *\n                                                                      n_292675 +\n                                                                      i_311321];\n                    defunc_0_f_res_311320 = defunc_0_add_arg_311322;\n                }\n                \n                double x_311323 = a11_311298 * tmp4_311318;\n                double y_311324 = b11_311299 * defunc_1_f_res_311319;\n                double x_311325 = x_311323 + y_311324;\n                double defunc_9_fit_fun_res_311326 = defunc_0_f_res_311320 *\n                       x_311325;\n                double x_311327 = b11_311299 * tmp4_311318;\n                double y_311328 = c11_311300 * defunc_1_f_res_311319;\n                double x_311329 = x_311327 + y_311328;\n                double defunc_9_slope_fun_res_311330 = defunc_0_f_res_311320 *\n                       x_311329;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_311281 = x_acc_323805;\n                    x_311282 = x_acc_323806",
            ";\n                }\n                // load new values\n                {\n                    x_311283 = defunc_9_fit_fun_res_311326;\n                    x_311284 = defunc_9_slope_fun_res_311330;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_311285 = x_311281 + x_311283;\n                    double defunc_1_op_res_311286 = x_311282 + x_311284;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_323805 = defunc_1_op_res_311285;\n                        x_acc_323806 = defunc_1_op_res_311286;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_311281 = x_acc_323805;\n            x_311282 = x_acc_323806;\n            ((__local\n              double *) red_arr_mem_323790)[sext_i32_i64(local_tid_323786)] =\n                x_311281;\n            ((__local\n              double *) red_arr_mem_323792)[sext_i32_i64(local_tid_323786)] =\n                x_311282;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_323815;\n        int32_t skip_waves_323816 = 1;\n        double x_323808;\n        double x_323809;\n        double x_323810;\n        double x_323811;\n        \n        offset_323815 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_323786,\n                      sext_i64_i32(segred_group_sizze_311272))) {\n                x_323808 = ((__local\n                             double *) red_arr_mem_323790)[sext_i32_i64(local_tid_323786 +\n                                                           offset_323815)];\n                x_323809 = ((__local\n                             double *) red_arr_mem_323792)[sext_i32_i64(local_tid_323786 +\n                                                           offset_323815)];\n            }\n        }\n        offset_323815 = 1;\n ",
            "       while (slt32(offset_323815, wave_sizze_323788)) {\n            if (slt32(local_tid_323786 + offset_323815,\n                      sext_i64_i32(segred_group_sizze_311272)) &&\n                ((local_tid_323786 - squot32(local_tid_323786,\n                                             wave_sizze_323788) *\n                  wave_sizze_323788) & (2 * offset_323815 - 1)) == 0) {\n                // read array element\n                {\n                    x_323810 = ((volatile __local\n                                 double *) red_arr_mem_323790)[sext_i32_i64(local_tid_323786 +\n                                                               offset_323815)];\n                    x_323811 = ((volatile __local\n                                 double *) red_arr_mem_323792)[sext_i32_i64(local_tid_323786 +\n                                                               offset_323815)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323812 = x_323808 + x_323810;\n                    double defunc_1_op_res_323813 = x_323809 + x_323811;\n                    \n                    x_323808 = defunc_1_op_res_323812;\n                    x_323809 = defunc_1_op_res_323813;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_323790)[sext_i32_i64(local_tid_323786)] =\n                        x_323808;\n                    ((volatile __local\n                      double *) red_arr_mem_323792)[sext_i32_i64(local_tid_323786)] =\n                        x_323809;\n                }\n            }\n            offset_323815 *= 2;\n        }\n        while (slt32(skip_waves_323816,\n                     squot32(sext_i64_i32(segred_group_sizze_311272) +\n                             wave_sizze_323788 - 1, wave_sizze_323788))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_323815 = skip_waves_323816 * wave_si",
            "zze_323788;\n            if (slt32(local_tid_323786 + offset_323815,\n                      sext_i64_i32(segred_group_sizze_311272)) &&\n                ((local_tid_323786 - squot32(local_tid_323786,\n                                             wave_sizze_323788) *\n                  wave_sizze_323788) == 0 && (squot32(local_tid_323786,\n                                                      wave_sizze_323788) & (2 *\n                                                                            skip_waves_323816 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_323810 = ((__local\n                                 double *) red_arr_mem_323790)[sext_i32_i64(local_tid_323786 +\n                                                               offset_323815)];\n                    x_323811 = ((__local\n                                 double *) red_arr_mem_323792)[sext_i32_i64(local_tid_323786 +\n                                                               offset_323815)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323812 = x_323808 + x_323810;\n                    double defunc_1_op_res_323813 = x_323809 + x_323811;\n                    \n                    x_323808 = defunc_1_op_res_323812;\n                    x_323809 = defunc_1_op_res_323813;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_323790)[sext_i32_i64(local_tid_323786)] =\n                        x_323808;\n                    ((__local\n                      double *) red_arr_mem_323792)[sext_i32_i64(local_tid_323786)] =\n                        x_323809;\n                }\n            }\n            skip_waves_323816 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result",
            " in accumulator\n        {\n            if (sext_i32_i64(local_tid_323786) == (int64_t) 0) {\n                x_acc_323805 = x_323808;\n                x_acc_323806 = x_323809;\n            }\n        }\n        if (groups_per_segment_323774 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_323786 == 0) {\n                    ((__global double *) mem_319695)[gtid_311277 *\n                                                     l_n_m_292832 +\n                                                     gtid_311278] =\n                        x_acc_323805;\n                    ((__global double *) mem_319699)[gtid_311277 *\n                                                     l_n_m_292832 +\n                                                     gtid_311278] =\n                        x_acc_323806;\n                }\n            }\n        } else {\n            int32_t old_counter_323817;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_323786 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_323779)[sext_i32_i64(virt_group_id_323798)] =\n                        x_acc_323805;\n                    ((__global\n                      double *) segred_tmp_mem_323781)[sext_i32_i64(virt_group_id_323798)] =\n                        x_acc_323806;\n                    mem_fence_global();\n                    old_counter_323817 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_323783)[sext_i32_i64(srem32(flat_segment_id_323799,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_323794)[(int64_t) 0] =\n                        old_counter_323817 == groups_per_segment_3",
            "23774 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_323818;\n            \n            is_last_group_323818 = ((__local\n                                     bool *) sync_arr_mem_323794)[(int64_t) 0];\n            if (is_last_group_323818) {\n                if (local_tid_323786 == 0) {\n                    old_counter_323817 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_323783)[sext_i32_i64(srem32(flat_segment_id_323799,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_323774));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_323819 =\n                            sdiv_up64(groups_per_segment_323774,\n                                      segred_group_sizze_311272);\n                    \n                    x_311281 = 0.0;\n                    x_311282 = 0.0;\n                    for (int64_t i_323820 = 0; i_323820 <\n                         read_per_thread_323819; i_323820++) {\n                        int64_t group_res_id_323821 =\n                                sext_i32_i64(local_tid_323786) *\n                                read_per_thread_323819 + i_323820;\n                        int64_t index_of_group_res_323822 =\n                                sext_i32_i64(flat_segment_id_323799) *\n                                groups_per_segment_323774 + group_res_id_323821;\n                        \n                        if (slt64(group_res_id_323821,\n                                  groups_per_segment_323774)) {\n                            x_311283 = ((__global\n             ",
            "                            double *) segred_tmp_mem_323779)[index_of_group_res_323822];\n                            x_311284 = ((__global\n                                         double *) segred_tmp_mem_323781)[index_of_group_res_323822];\n                            \n                            double defunc_1_op_res_311285 = x_311281 + x_311283;\n                            double defunc_1_op_res_311286 = x_311282 + x_311284;\n                            \n                            x_311281 = defunc_1_op_res_311285;\n                            x_311282 = defunc_1_op_res_311286;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_323790)[sext_i32_i64(local_tid_323786)] =\n                    x_311281;\n                ((__local\n                  double *) red_arr_mem_323792)[sext_i32_i64(local_tid_323786)] =\n                    x_311282;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_323823;\n                    int32_t skip_waves_323824 = 1;\n                    double x_323808;\n                    double x_323809;\n                    double x_323810;\n                    double x_323811;\n                    \n                    offset_323823 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_323786,\n                                  sext_i64_i32(segred_group_sizze_311272))) {\n                            x_323808 = ((__local\n                                         double *) red_arr_mem_323790)[sext_i32_i64(local_tid_323786 +\n                                                                       offset_323823)];\n                            x_323809 = ((__local\n                                         double *) red_arr_mem_323792)[sext_i32_i64(local_tid_323786 +\n                                           ",
            "                            offset_323823)];\n                        }\n                    }\n                    offset_323823 = 1;\n                    while (slt32(offset_323823, wave_sizze_323788)) {\n                        if (slt32(local_tid_323786 + offset_323823,\n                                  sext_i64_i32(segred_group_sizze_311272)) &&\n                            ((local_tid_323786 - squot32(local_tid_323786,\n                                                         wave_sizze_323788) *\n                              wave_sizze_323788) & (2 * offset_323823 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_323810 = ((volatile __local\n                                             double *) red_arr_mem_323790)[sext_i32_i64(local_tid_323786 +\n                                                                           offset_323823)];\n                                x_323811 = ((volatile __local\n                                             double *) red_arr_mem_323792)[sext_i32_i64(local_tid_323786 +\n                                                                           offset_323823)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_323812 = x_323808 +\n                                       x_323810;\n                                double defunc_1_op_res_323813 = x_323809 +\n                                       x_323811;\n                                \n                                x_323808 = defunc_1_op_res_323812;\n                                x_323809 = defunc_1_op_res_323813;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323790)[sext_i32_i64(local_ti",
            "d_323786)] =\n                                    x_323808;\n                                ((volatile __local\n                                  double *) red_arr_mem_323792)[sext_i32_i64(local_tid_323786)] =\n                                    x_323809;\n                            }\n                        }\n                        offset_323823 *= 2;\n                    }\n                    while (slt32(skip_waves_323824,\n                                 squot32(sext_i64_i32(segred_group_sizze_311272) +\n                                         wave_sizze_323788 - 1,\n                                         wave_sizze_323788))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_323823 = skip_waves_323824 * wave_sizze_323788;\n                        if (slt32(local_tid_323786 + offset_323823,\n                                  sext_i64_i32(segred_group_sizze_311272)) &&\n                            ((local_tid_323786 - squot32(local_tid_323786,\n                                                         wave_sizze_323788) *\n                              wave_sizze_323788) == 0 &&\n                             (squot32(local_tid_323786, wave_sizze_323788) &\n                              (2 * skip_waves_323824 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_323810 = ((__local\n                                             double *) red_arr_mem_323790)[sext_i32_i64(local_tid_323786 +\n                                                                           offset_323823)];\n                                x_323811 = ((__local\n                                             double *) red_arr_mem_323792)[sext_i32_i64(local_tid_323786 +\n                                                                           offset_323823)];\n                            }\n                            // apply reduction operation\n                            {\n                          ",
            "      double defunc_1_op_res_323812 = x_323808 +\n                                       x_323810;\n                                double defunc_1_op_res_323813 = x_323809 +\n                                       x_323811;\n                                \n                                x_323808 = defunc_1_op_res_323812;\n                                x_323809 = defunc_1_op_res_323813;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_323790)[sext_i32_i64(local_tid_323786)] =\n                                    x_323808;\n                                ((__local\n                                  double *) red_arr_mem_323792)[sext_i32_i64(local_tid_323786)] =\n                                    x_323809;\n                            }\n                        }\n                        skip_waves_323824 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_323786 == 0) {\n                            ((__global double *) mem_319695)[gtid_311277 *\n                                                             l_n_m_292832 +\n                                                             gtid_311278] =\n                                x_323808;\n                            ((__global double *) mem_319699)[gtid_311277 *\n                                                             l_n_m_292832 +\n                                                             gtid_311278] =\n                                x_323809;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_311272\n}\n__kernel void mainzisegred_large_311778(__global int *global_failure,\n                         ",
            "               uint sync_arr_mem_323911_backing_offset_0,\n                                        uint red_arr_mem_323909_backing_offset_1,\n                                        uint red_arr_mem_323907_backing_offset_2,\n                                        uint red_arr_mem_323905_backing_offset_3,\n                                        uint red_arr_mem_323903_backing_offset_4,\n                                        uint red_arr_mem_323901_backing_offset_5,\n                                        int64_t n_292675, int64_t q_l_292680,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t l_n_m_292832, int64_t i_292846,\n                                        int64_t num_groups_311768,\n                                        int64_t ctx_param_ext_318833,\n                                        int64_t ctx_param_ext_318834,\n                                        int64_t ctx_param_ext_318836,\n                                        int64_t groups_per_segment_323879,\n                                        int64_t elements_per_thread_323880,\n                                        int64_t virt_num_groups_323881,\n                                        int64_t threads_per_segment_323883,\n                                        __global unsigned char *ext_mem_318756,\n                                        __global unsigned char *ext_mem_318757,\n                                        __global\n                                        unsigned char *mem_param_318838,\n                                        __global unsigned char *mem_319704,\n                                        __global unsigned char *mem_319708,\n                                        __global unsigned char *mem_319712,\n                                        __global unsigned char *mem_319716,\n                                        __global unsigned char *mem_319720,\n ",
            "                                       __global\n                                        unsigned char *segred_tmp_mem_323884,\n                                        __global\n                                        unsigned char *segred_tmp_mem_323886,\n                                        __global\n                                        unsigned char *segred_tmp_mem_323888,\n                                        __global\n                                        unsigned char *segred_tmp_mem_323890,\n                                        __global\n                                        unsigned char *segred_tmp_mem_323892,\n                                        __global\n                                        unsigned char *mainzicounter_mem_323894)\n{\n    #define segred_group_sizze_311767 (mainzisegred_group_sizze_311489)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_323911_backing_5 =\n                           &shared_mem[sync_arr_mem_323911_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323909_backing_4 =\n                           &shared_mem[red_arr_mem_323909_backing_offset_1];\n    volatile unsigned char *red_arr_mem_323907_backing_3 =\n                           &shared_mem[red_arr_mem_323907_backing_offset_2];\n    volatile unsigned char *red_arr_mem_323905_backing_2 =\n                           &shared_mem[red_arr_mem_323905_backing_offset_3];\n    volatile unsigned char *red_arr_mem_323903_backing_1 =\n                           &shared_mem[red_arr_mem_323903_backing_offset_4];\n    volatile unsigned char *red_arr_mem_323901_backing_0 =\n                           &shared_mem[red_arr_mem_323901_backing_offset_5];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323896;\n    int32_t local_tid_323897;\n    int64_t group_sizze_323900;\n    int32_t wave_sizze_323899;\n    int32_t group_tid_323898;\n    \n    global_tid_323896 = get_global",
            "_id(0);\n    local_tid_323897 = get_local_id(0);\n    group_sizze_323900 = get_local_size(0);\n    wave_sizze_323899 = LOCKSTEP_WIDTH;\n    group_tid_323898 = get_group_id(0);\n    \n    int32_t phys_tid_311778 = global_tid_323896;\n    __local unsigned char *red_arr_mem_323901;\n    \n    red_arr_mem_323901 = (__local unsigned char *) red_arr_mem_323901_backing_0;\n    \n    __local unsigned char *red_arr_mem_323903;\n    \n    red_arr_mem_323903 = (__local unsigned char *) red_arr_mem_323903_backing_1;\n    \n    __local unsigned char *red_arr_mem_323905;\n    \n    red_arr_mem_323905 = (__local unsigned char *) red_arr_mem_323905_backing_2;\n    \n    __local unsigned char *red_arr_mem_323907;\n    \n    red_arr_mem_323907 = (__local unsigned char *) red_arr_mem_323907_backing_3;\n    \n    __local unsigned char *red_arr_mem_323909;\n    \n    red_arr_mem_323909 = (__local unsigned char *) red_arr_mem_323909_backing_4;\n    \n    __local unsigned char *sync_arr_mem_323911;\n    \n    sync_arr_mem_323911 = (__local\n                           unsigned char *) sync_arr_mem_323911_backing_5;\n    \n    int32_t phys_group_id_323913;\n    \n    phys_group_id_323913 = get_group_id(0);\n    for (int32_t i_323914 = 0; i_323914 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_323881) - phys_group_id_323913,\n                   sext_i64_i32(num_groups_311768)); i_323914++) {\n        int32_t virt_group_id_323915 = phys_group_id_323913 + i_323914 *\n                sext_i64_i32(num_groups_311768);\n        int32_t flat_segment_id_323916 = squot32(virt_group_id_323915,\n                                                 sext_i64_i32(groups_per_segment_323879));\n        int64_t global_tid_323917 = srem64(sext_i32_i64(virt_group_id_323915) *\n                                           segred_group_sizze_311767 +\n                                           sext_i32_i64(local_tid_323897),\n                                           segred_group_sizze_311767 *\n                                           groups_per_segment_3",
            "23879);\n        int64_t slice_323918 = l_n_m_292832;\n        int64_t slice_323919 = partition_sizze_292766 * slice_323918;\n        int64_t gtid_311775 = squot64(sext_i32_i64(flat_segment_id_323916),\n                                      slice_323918);\n        int64_t remnant_323920 = sext_i32_i64(flat_segment_id_323916) -\n                gtid_311775 * slice_323918;\n        int64_t gtid_311776 = remnant_323920;\n        int64_t remnant_323921 = remnant_323920 - gtid_311776;\n        int64_t gtid_311777;\n        double x_acc_323922;\n        double x_acc_323923;\n        double x_acc_323924;\n        double x_acc_323925;\n        double x_acc_323926;\n        int64_t chunk_sizze_323927 = smin64(elements_per_thread_323880,\n                                            sdiv_up64(q_l_292680 -\n                                                      global_tid_323917,\n                                                      threads_per_segment_323883));\n        double x_311779;\n        double x_311780;\n        double x_311781;\n        double x_311782;\n        double x_311783;\n        double x_311784;\n        double x_311785;\n        double x_311786;\n        double x_311787;\n        double x_311788;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_323922 = 0.0;\n            x_acc_323923 = 0.0;\n            x_acc_323924 = 0.0;\n            x_acc_323925 = 0.0;\n            x_acc_323926 = 0.0;\n        }\n        for (int64_t i_323943 = 0; i_323943 < chunk_sizze_323927; i_323943++) {\n            gtid_311777 = global_tid_323917 + threads_per_segment_323883 *\n                i_323943;\n            // apply map function\n            {\n                int64_t x_311798;\n                \n                x_311798 = ((__global int64_t *) ext_mem_318757)[gtid_311775 *\n                                                                 l_n_m_292832 +\n                                                                 gtid_311776];\n                \n                double x_311799;",
            "\n                \n                x_311799 = ((__global double *) ext_mem_318756)[gtid_311775 *\n                                                                l_n_m_292832 +\n                                                                gtid_311776];\n                \n                int64_t binop_y_317922 = mul64(jump_t_292685, gtid_311776);\n                int64_t binop_y_317923 = smin64(i_292846, binop_y_317922);\n                int64_t index_primexp_317924 = add64((int64_t) 1,\n                                                     binop_y_317923);\n                bool cond_311802 = sle64(n_292675, gtid_311777);\n                int64_t defunc_0_f_res_311803;\n                \n                if (cond_311802) {\n                    defunc_0_f_res_311803 = (int64_t) 0;\n                } else {\n                    int64_t i_311804 = add64(gtid_311777, x_311798);\n                    int64_t defunc_1_add_res_311805 = add64((int64_t) 1,\n                                                            i_311804);\n                    \n                    defunc_0_f_res_311803 = defunc_1_add_res_311805;\n                }\n                \n                double defunc_0_f_res_311806;\n                \n                if (cond_311802) {\n                    defunc_0_f_res_311806 = 0.0;\n                } else {\n                    int64_t i_311807 = add64(gtid_311777, x_311798);\n                    double defunc_0_add_arg_311808;\n                    \n                    defunc_0_add_arg_311808 = ((__global\n                                                double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                            (gtid_311775 *\n                                                                             ctx_param_ext_318834 +\n                                                                             i_311807 *\n                                                                             ctx_param_ext_318836)];\n         ",
            "           defunc_0_f_res_311806 = defunc_0_add_arg_311808;\n                }\n                \n                int64_t binop_p_311809 = sub64(defunc_0_f_res_311803,\n                                               index_primexp_317924);\n                double defunc_0_f_res_311810 = sitofp_i64_f64(binop_p_311809);\n                double abs_res_311811 = fabs(defunc_0_f_res_311810);\n                double tmp1_311812 = abs_res_311811 / x_311799;\n                double x_311813 = tmp1_311812 * tmp1_311812;\n                double y_311814 = tmp1_311812 * x_311813;\n                double tmp2_311815 = 1.0 - y_311814;\n                double x_311816 = tmp2_311815 * tmp2_311815;\n                double tmp3_311817 = tmp2_311815 * x_311816;\n                double w_j_311818 = defunc_0_f_res_311806 * tmp3_311817;\n                double xw_j_311819 = defunc_0_f_res_311810 * w_j_311818;\n                double x2w_j_311820 = defunc_0_f_res_311810 * xw_j_311819;\n                double x3w_j_311821 = defunc_0_f_res_311810 * x2w_j_311820;\n                double x4w_j_311822 = defunc_0_f_res_311810 * x3w_j_311821;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_311779 = x_acc_323922;\n                    x_311780 = x_acc_323923;\n                    x_311781 = x_acc_323924;\n                    x_311782 = x_acc_323925;\n                    x_311783 = x_acc_323926;\n                }\n                // load new values\n                {\n                    x_311784 = w_j_311818;\n                    x_311785 = xw_j_311819;\n                    x_311786 = x2w_j_311820;\n                    x_311787 = x3w_j_311821;\n                    x_311788 = x4w_j_311822;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_311789 = x_311779 + x_311784;\n                    double defunc_1_op_res_311790 = x_311780 + x_311785;\n           ",
            "         double defunc_1_op_res_311791 = x_311781 + x_311786;\n                    double defunc_1_op_res_311792 = x_311782 + x_311787;\n                    double defunc_1_op_res_311793 = x_311783 + x_311788;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_323922 = defunc_1_op_res_311789;\n                        x_acc_323923 = defunc_1_op_res_311790;\n                        x_acc_323924 = defunc_1_op_res_311791;\n                        x_acc_323925 = defunc_1_op_res_311792;\n                        x_acc_323926 = defunc_1_op_res_311793;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_311779 = x_acc_323922;\n            x_311780 = x_acc_323923;\n            x_311781 = x_acc_323924;\n            x_311782 = x_acc_323925;\n            x_311783 = x_acc_323926;\n            ((__local\n              double *) red_arr_mem_323901)[sext_i32_i64(local_tid_323897)] =\n                x_311779;\n            ((__local\n              double *) red_arr_mem_323903)[sext_i32_i64(local_tid_323897)] =\n                x_311780;\n            ((__local\n              double *) red_arr_mem_323905)[sext_i32_i64(local_tid_323897)] =\n                x_311781;\n            ((__local\n              double *) red_arr_mem_323907)[sext_i32_i64(local_tid_323897)] =\n                x_311782;\n            ((__local\n              double *) red_arr_mem_323909)[sext_i32_i64(local_tid_323897)] =\n                x_311783;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_323944;\n        int32_t skip_waves_323945 = 1;\n        double x_323928;\n        double x_323929;\n        double x_323930;\n        double x_323931;\n        double x_323932;\n        double x_323933;\n        double x_323934;\n        double x_323935;\n        double x_323936;\n        double x_323937;\n        \n        offset_323944 = 0;\n        // particip",
            "ating threads read initial accumulator\n        {\n            if (slt32(local_tid_323897,\n                      sext_i64_i32(segred_group_sizze_311767))) {\n                x_323928 = ((__local\n                             double *) red_arr_mem_323901)[sext_i32_i64(local_tid_323897 +\n                                                           offset_323944)];\n                x_323929 = ((__local\n                             double *) red_arr_mem_323903)[sext_i32_i64(local_tid_323897 +\n                                                           offset_323944)];\n                x_323930 = ((__local\n                             double *) red_arr_mem_323905)[sext_i32_i64(local_tid_323897 +\n                                                           offset_323944)];\n                x_323931 = ((__local\n                             double *) red_arr_mem_323907)[sext_i32_i64(local_tid_323897 +\n                                                           offset_323944)];\n                x_323932 = ((__local\n                             double *) red_arr_mem_323909)[sext_i32_i64(local_tid_323897 +\n                                                           offset_323944)];\n            }\n        }\n        offset_323944 = 1;\n        while (slt32(offset_323944, wave_sizze_323899)) {\n            if (slt32(local_tid_323897 + offset_323944,\n                      sext_i64_i32(segred_group_sizze_311767)) &&\n                ((local_tid_323897 - squot32(local_tid_323897,\n                                             wave_sizze_323899) *\n                  wave_sizze_323899) & (2 * offset_323944 - 1)) == 0) {\n                // read array element\n                {\n                    x_323933 = ((volatile __local\n                                 double *) red_arr_mem_323901)[sext_i32_i64(local_tid_323897 +\n                                                               offset_323944)];\n                    x_323934 = ((volatile __local\n                                 double *) red_arr_mem_323903)",
            "[sext_i32_i64(local_tid_323897 +\n                                                               offset_323944)];\n                    x_323935 = ((volatile __local\n                                 double *) red_arr_mem_323905)[sext_i32_i64(local_tid_323897 +\n                                                               offset_323944)];\n                    x_323936 = ((volatile __local\n                                 double *) red_arr_mem_323907)[sext_i32_i64(local_tid_323897 +\n                                                               offset_323944)];\n                    x_323937 = ((volatile __local\n                                 double *) red_arr_mem_323909)[sext_i32_i64(local_tid_323897 +\n                                                               offset_323944)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323938 = x_323928 + x_323933;\n                    double defunc_1_op_res_323939 = x_323929 + x_323934;\n                    double defunc_1_op_res_323940 = x_323930 + x_323935;\n                    double defunc_1_op_res_323941 = x_323931 + x_323936;\n                    double defunc_1_op_res_323942 = x_323932 + x_323937;\n                    \n                    x_323928 = defunc_1_op_res_323938;\n                    x_323929 = defunc_1_op_res_323939;\n                    x_323930 = defunc_1_op_res_323940;\n                    x_323931 = defunc_1_op_res_323941;\n                    x_323932 = defunc_1_op_res_323942;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_323901)[sext_i32_i64(local_tid_323897)] =\n                        x_323928;\n                    ((volatile __local\n                      double *) red_arr_mem_323903)[sext_i32_i64(local_tid_323897)] =\n                        x_323929;\n                    ((volatile __local\n                      double *) ",
            "red_arr_mem_323905)[sext_i32_i64(local_tid_323897)] =\n                        x_323930;\n                    ((volatile __local\n                      double *) red_arr_mem_323907)[sext_i32_i64(local_tid_323897)] =\n                        x_323931;\n                    ((volatile __local\n                      double *) red_arr_mem_323909)[sext_i32_i64(local_tid_323897)] =\n                        x_323932;\n                }\n            }\n            offset_323944 *= 2;\n        }\n        while (slt32(skip_waves_323945,\n                     squot32(sext_i64_i32(segred_group_sizze_311767) +\n                             wave_sizze_323899 - 1, wave_sizze_323899))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_323944 = skip_waves_323945 * wave_sizze_323899;\n            if (slt32(local_tid_323897 + offset_323944,\n                      sext_i64_i32(segred_group_sizze_311767)) &&\n                ((local_tid_323897 - squot32(local_tid_323897,\n                                             wave_sizze_323899) *\n                  wave_sizze_323899) == 0 && (squot32(local_tid_323897,\n                                                      wave_sizze_323899) & (2 *\n                                                                            skip_waves_323945 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_323933 = ((__local\n                                 double *) red_arr_mem_323901)[sext_i32_i64(local_tid_323897 +\n                                                               offset_323944)];\n                    x_323934 = ((__local\n                                 double *) red_arr_mem_323903)[sext_i32_i64(local_tid_323897 +\n                                                               offset_323944)];\n                    x_323935 = ((__local\n                                 double *) red_arr_mem_323905)[sext_i32_i64(local_tid_32389",
            "7 +\n                                                               offset_323944)];\n                    x_323936 = ((__local\n                                 double *) red_arr_mem_323907)[sext_i32_i64(local_tid_323897 +\n                                                               offset_323944)];\n                    x_323937 = ((__local\n                                 double *) red_arr_mem_323909)[sext_i32_i64(local_tid_323897 +\n                                                               offset_323944)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_323938 = x_323928 + x_323933;\n                    double defunc_1_op_res_323939 = x_323929 + x_323934;\n                    double defunc_1_op_res_323940 = x_323930 + x_323935;\n                    double defunc_1_op_res_323941 = x_323931 + x_323936;\n                    double defunc_1_op_res_323942 = x_323932 + x_323937;\n                    \n                    x_323928 = defunc_1_op_res_323938;\n                    x_323929 = defunc_1_op_res_323939;\n                    x_323930 = defunc_1_op_res_323940;\n                    x_323931 = defunc_1_op_res_323941;\n                    x_323932 = defunc_1_op_res_323942;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_323901)[sext_i32_i64(local_tid_323897)] =\n                        x_323928;\n                    ((__local\n                      double *) red_arr_mem_323903)[sext_i32_i64(local_tid_323897)] =\n                        x_323929;\n                    ((__local\n                      double *) red_arr_mem_323905)[sext_i32_i64(local_tid_323897)] =\n                        x_323930;\n                    ((__local\n                      double *) red_arr_mem_323907)[sext_i32_i64(local_tid_323897)] =\n                        x_323931;\n                    ((__local\n                      double *)",
            " red_arr_mem_323909)[sext_i32_i64(local_tid_323897)] =\n                        x_323932;\n                }\n            }\n            skip_waves_323945 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_323897) == (int64_t) 0) {\n                x_acc_323922 = x_323928;\n                x_acc_323923 = x_323929;\n                x_acc_323924 = x_323930;\n                x_acc_323925 = x_323931;\n                x_acc_323926 = x_323932;\n            }\n        }\n        if (groups_per_segment_323879 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_323897 == 0) {\n                    ((__global double *) mem_319704)[gtid_311775 *\n                                                     l_n_m_292832 +\n                                                     gtid_311776] =\n                        x_acc_323922;\n                    ((__global double *) mem_319708)[gtid_311775 *\n                                                     l_n_m_292832 +\n                                                     gtid_311776] =\n                        x_acc_323923;\n                    ((__global double *) mem_319712)[gtid_311775 *\n                                                     l_n_m_292832 +\n                                                     gtid_311776] =\n                        x_acc_323924;\n                    ((__global double *) mem_319716)[gtid_311775 *\n                                                     l_n_m_292832 +\n                                                     gtid_311776] =\n                        x_acc_323925;\n                    ((__global double *) mem_319720)[gtid_311775 *\n                                                     l_n_m_292832 +\n                                                     gtid_311776] =\n                        x_acc_323926;\n                }\n            }\n        } else {\n",
            "            int32_t old_counter_323946;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_323897 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_323884)[sext_i32_i64(virt_group_id_323915)] =\n                        x_acc_323922;\n                    ((__global\n                      double *) segred_tmp_mem_323886)[sext_i32_i64(virt_group_id_323915)] =\n                        x_acc_323923;\n                    ((__global\n                      double *) segred_tmp_mem_323888)[sext_i32_i64(virt_group_id_323915)] =\n                        x_acc_323924;\n                    ((__global\n                      double *) segred_tmp_mem_323890)[sext_i32_i64(virt_group_id_323915)] =\n                        x_acc_323925;\n                    ((__global\n                      double *) segred_tmp_mem_323892)[sext_i32_i64(virt_group_id_323915)] =\n                        x_acc_323926;\n                    mem_fence_global();\n                    old_counter_323946 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_323894)[sext_i32_i64(srem32(flat_segment_id_323916,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_323911)[(int64_t) 0] =\n                        old_counter_323946 == groups_per_segment_323879 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_323947;\n            \n            is_last_group_323947 = ((__local\n                                     bool *) sync_arr_mem_323911)[(int64_t) 0];\n            if (is_last_group_323947) {\n                if (local_tid_323897 == 0) {\n      ",
            "              old_counter_323946 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_323894)[sext_i32_i64(srem32(flat_segment_id_323916,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_323879));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_323948 =\n                            sdiv_up64(groups_per_segment_323879,\n                                      segred_group_sizze_311767);\n                    \n                    x_311779 = 0.0;\n                    x_311780 = 0.0;\n                    x_311781 = 0.0;\n                    x_311782 = 0.0;\n                    x_311783 = 0.0;\n                    for (int64_t i_323949 = 0; i_323949 <\n                         read_per_thread_323948; i_323949++) {\n                        int64_t group_res_id_323950 =\n                                sext_i32_i64(local_tid_323897) *\n                                read_per_thread_323948 + i_323949;\n                        int64_t index_of_group_res_323951 =\n                                sext_i32_i64(flat_segment_id_323916) *\n                                groups_per_segment_323879 + group_res_id_323950;\n                        \n                        if (slt64(group_res_id_323950,\n                                  groups_per_segment_323879)) {\n                            x_311784 = ((__global\n                                         double *) segred_tmp_mem_323884)[index_of_group_res_323951];\n                            x_311785 = ((__global\n                                         double *) segred_tmp_mem_323886)[index_of_group_res_323951];\n                            x_311786 = ((__global\n                        ",
            "                 double *) segred_tmp_mem_323888)[index_of_group_res_323951];\n                            x_311787 = ((__global\n                                         double *) segred_tmp_mem_323890)[index_of_group_res_323951];\n                            x_311788 = ((__global\n                                         double *) segred_tmp_mem_323892)[index_of_group_res_323951];\n                            \n                            double defunc_1_op_res_311789 = x_311779 + x_311784;\n                            double defunc_1_op_res_311790 = x_311780 + x_311785;\n                            double defunc_1_op_res_311791 = x_311781 + x_311786;\n                            double defunc_1_op_res_311792 = x_311782 + x_311787;\n                            double defunc_1_op_res_311793 = x_311783 + x_311788;\n                            \n                            x_311779 = defunc_1_op_res_311789;\n                            x_311780 = defunc_1_op_res_311790;\n                            x_311781 = defunc_1_op_res_311791;\n                            x_311782 = defunc_1_op_res_311792;\n                            x_311783 = defunc_1_op_res_311793;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_323901)[sext_i32_i64(local_tid_323897)] =\n                    x_311779;\n                ((__local\n                  double *) red_arr_mem_323903)[sext_i32_i64(local_tid_323897)] =\n                    x_311780;\n                ((__local\n                  double *) red_arr_mem_323905)[sext_i32_i64(local_tid_323897)] =\n                    x_311781;\n                ((__local\n                  double *) red_arr_mem_323907)[sext_i32_i64(local_tid_323897)] =\n                    x_311782;\n                ((__local\n                  double *) red_arr_mem_323909)[sext_i32_i64(local_tid_323897)] =\n                    x_311783;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-grou",
            "p results\n                {\n                    int32_t offset_323952;\n                    int32_t skip_waves_323953 = 1;\n                    double x_323928;\n                    double x_323929;\n                    double x_323930;\n                    double x_323931;\n                    double x_323932;\n                    double x_323933;\n                    double x_323934;\n                    double x_323935;\n                    double x_323936;\n                    double x_323937;\n                    \n                    offset_323952 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_323897,\n                                  sext_i64_i32(segred_group_sizze_311767))) {\n                            x_323928 = ((__local\n                                         double *) red_arr_mem_323901)[sext_i32_i64(local_tid_323897 +\n                                                                       offset_323952)];\n                            x_323929 = ((__local\n                                         double *) red_arr_mem_323903)[sext_i32_i64(local_tid_323897 +\n                                                                       offset_323952)];\n                            x_323930 = ((__local\n                                         double *) red_arr_mem_323905)[sext_i32_i64(local_tid_323897 +\n                                                                       offset_323952)];\n                            x_323931 = ((__local\n                                         double *) red_arr_mem_323907)[sext_i32_i64(local_tid_323897 +\n                                                                       offset_323952)];\n                            x_323932 = ((__local\n                                         double *) red_arr_mem_323909)[sext_i32_i64(local_tid_323897 +\n                                                                       offset_323952)];\n                        }\n",
            "                    }\n                    offset_323952 = 1;\n                    while (slt32(offset_323952, wave_sizze_323899)) {\n                        if (slt32(local_tid_323897 + offset_323952,\n                                  sext_i64_i32(segred_group_sizze_311767)) &&\n                            ((local_tid_323897 - squot32(local_tid_323897,\n                                                         wave_sizze_323899) *\n                              wave_sizze_323899) & (2 * offset_323952 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_323933 = ((volatile __local\n                                             double *) red_arr_mem_323901)[sext_i32_i64(local_tid_323897 +\n                                                                           offset_323952)];\n                                x_323934 = ((volatile __local\n                                             double *) red_arr_mem_323903)[sext_i32_i64(local_tid_323897 +\n                                                                           offset_323952)];\n                                x_323935 = ((volatile __local\n                                             double *) red_arr_mem_323905)[sext_i32_i64(local_tid_323897 +\n                                                                           offset_323952)];\n                                x_323936 = ((volatile __local\n                                             double *) red_arr_mem_323907)[sext_i32_i64(local_tid_323897 +\n                                                                           offset_323952)];\n                                x_323937 = ((volatile __local\n                                             double *) red_arr_mem_323909)[sext_i32_i64(local_tid_323897 +\n                                                                           offset_323952)];\n                            }\n                            // apply reduct",
            "ion operation\n                            {\n                                double defunc_1_op_res_323938 = x_323928 +\n                                       x_323933;\n                                double defunc_1_op_res_323939 = x_323929 +\n                                       x_323934;\n                                double defunc_1_op_res_323940 = x_323930 +\n                                       x_323935;\n                                double defunc_1_op_res_323941 = x_323931 +\n                                       x_323936;\n                                double defunc_1_op_res_323942 = x_323932 +\n                                       x_323937;\n                                \n                                x_323928 = defunc_1_op_res_323938;\n                                x_323929 = defunc_1_op_res_323939;\n                                x_323930 = defunc_1_op_res_323940;\n                                x_323931 = defunc_1_op_res_323941;\n                                x_323932 = defunc_1_op_res_323942;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323901)[sext_i32_i64(local_tid_323897)] =\n                                    x_323928;\n                                ((volatile __local\n                                  double *) red_arr_mem_323903)[sext_i32_i64(local_tid_323897)] =\n                                    x_323929;\n                                ((volatile __local\n                                  double *) red_arr_mem_323905)[sext_i32_i64(local_tid_323897)] =\n                                    x_323930;\n                                ((volatile __local\n                                  double *) red_arr_mem_323907)[sext_i32_i64(local_tid_323897)] =\n                                    x_323931;\n                                ((volatile __local\n                    ",
            "              double *) red_arr_mem_323909)[sext_i32_i64(local_tid_323897)] =\n                                    x_323932;\n                            }\n                        }\n                        offset_323952 *= 2;\n                    }\n                    while (slt32(skip_waves_323953,\n                                 squot32(sext_i64_i32(segred_group_sizze_311767) +\n                                         wave_sizze_323899 - 1,\n                                         wave_sizze_323899))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_323952 = skip_waves_323953 * wave_sizze_323899;\n                        if (slt32(local_tid_323897 + offset_323952,\n                                  sext_i64_i32(segred_group_sizze_311767)) &&\n                            ((local_tid_323897 - squot32(local_tid_323897,\n                                                         wave_sizze_323899) *\n                              wave_sizze_323899) == 0 &&\n                             (squot32(local_tid_323897, wave_sizze_323899) &\n                              (2 * skip_waves_323953 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_323933 = ((__local\n                                             double *) red_arr_mem_323901)[sext_i32_i64(local_tid_323897 +\n                                                                           offset_323952)];\n                                x_323934 = ((__local\n                                             double *) red_arr_mem_323903)[sext_i32_i64(local_tid_323897 +\n                                                                           offset_323952)];\n                                x_323935 = ((__local\n                                             double *) red_arr_mem_323905)[sext_i32_i64(local_tid_323897 +\n                                                                           offset_323952)];\n                     ",
            "           x_323936 = ((__local\n                                             double *) red_arr_mem_323907)[sext_i32_i64(local_tid_323897 +\n                                                                           offset_323952)];\n                                x_323937 = ((__local\n                                             double *) red_arr_mem_323909)[sext_i32_i64(local_tid_323897 +\n                                                                           offset_323952)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_323938 = x_323928 +\n                                       x_323933;\n                                double defunc_1_op_res_323939 = x_323929 +\n                                       x_323934;\n                                double defunc_1_op_res_323940 = x_323930 +\n                                       x_323935;\n                                double defunc_1_op_res_323941 = x_323931 +\n                                       x_323936;\n                                double defunc_1_op_res_323942 = x_323932 +\n                                       x_323937;\n                                \n                                x_323928 = defunc_1_op_res_323938;\n                                x_323929 = defunc_1_op_res_323939;\n                                x_323930 = defunc_1_op_res_323940;\n                                x_323931 = defunc_1_op_res_323941;\n                                x_323932 = defunc_1_op_res_323942;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_323901)[sext_i32_i64(local_tid_323897)] =\n                                    x_323928;\n                                ((__local\n                                  double *) red_arr_mem_323903)[sex",
            "t_i32_i64(local_tid_323897)] =\n                                    x_323929;\n                                ((__local\n                                  double *) red_arr_mem_323905)[sext_i32_i64(local_tid_323897)] =\n                                    x_323930;\n                                ((__local\n                                  double *) red_arr_mem_323907)[sext_i32_i64(local_tid_323897)] =\n                                    x_323931;\n                                ((__local\n                                  double *) red_arr_mem_323909)[sext_i32_i64(local_tid_323897)] =\n                                    x_323932;\n                            }\n                        }\n                        skip_waves_323953 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_323897 == 0) {\n                            ((__global double *) mem_319704)[gtid_311775 *\n                                                             l_n_m_292832 +\n                                                             gtid_311776] =\n                                x_323928;\n                            ((__global double *) mem_319708)[gtid_311775 *\n                                                             l_n_m_292832 +\n                                                             gtid_311776] =\n                                x_323929;\n                            ((__global double *) mem_319712)[gtid_311775 *\n                                                             l_n_m_292832 +\n                                                             gtid_311776] =\n                                x_323930;\n                            ((__global double *) mem_319716)[gtid_311775 *\n                                                             l_n_m_292832 +\n                                                             gtid_311776] =\n                                x_323931;\n                        ",
            "    ((__global double *) mem_319720)[gtid_311775 *\n                                                             l_n_m_292832 +\n                                                             gtid_311776] =\n                                x_323932;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_311767\n}\n__kernel void mainzisegred_large_311881(__global int *global_failure,\n                                        uint sync_arr_mem_324020_backing_offset_0,\n                                        uint red_arr_mem_324018_backing_offset_1,\n                                        uint red_arr_mem_324016_backing_offset_2,\n                                        int64_t n_292675, int64_t q_l_292680,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t l_n_m_292832, int64_t i_292846,\n                                        int64_t num_groups_311874,\n                                        int64_t ctx_param_ext_318833,\n                                        int64_t ctx_param_ext_318834,\n                                        int64_t ctx_param_ext_318836,\n                                        int64_t groups_per_segment_324000,\n                                        int64_t elements_per_thread_324001,\n                                        int64_t virt_num_groups_324002,\n                                        int64_t threads_per_segment_324004,\n                                        __global unsigned char *ext_mem_318756,\n                                        __global unsigned char *ext_mem_318757,\n                                        __global\n                                        unsigned char *mem_param_318838,\n                                        __global unsigned char ",
            "*mem_319555,\n                                        __global unsigned char *mem_319725,\n                                        __global unsigned char *mem_319729,\n                                        __global unsigned char *mem_319733,\n                                        __global unsigned char *mem_319737,\n                                        __global unsigned char *mem_319741,\n                                        __global unsigned char *mem_319746,\n                                        __global unsigned char *mem_319750,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324005,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324007,\n                                        __global\n                                        unsigned char *mainzicounter_mem_324009)\n{\n    #define segred_group_sizze_311873 (mainzisegred_group_sizze_311358)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_324020_backing_2 =\n                           &shared_mem[sync_arr_mem_324020_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324018_backing_1 =\n                           &shared_mem[red_arr_mem_324018_backing_offset_1];\n    volatile unsigned char *red_arr_mem_324016_backing_0 =\n                           &shared_mem[red_arr_mem_324016_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324011;\n    int32_t local_tid_324012;\n    int64_t group_sizze_324015;\n    int32_t wave_sizze_324014;\n    int32_t group_tid_324013;\n    \n    global_tid_324011 = get_global_id(0);\n    local_tid_324012 = get_local_id(0);\n    group_sizze_324015 = get_local_size(0);\n    wave_sizze_324014 = LOCKSTEP_WIDTH;\n    group_tid_324013 = get_group_id(0);\n    \n    int32_t phys_tid_311881 = global_tid_324011;\n    __local unsig",
            "ned char *red_arr_mem_324016;\n    \n    red_arr_mem_324016 = (__local unsigned char *) red_arr_mem_324016_backing_0;\n    \n    __local unsigned char *red_arr_mem_324018;\n    \n    red_arr_mem_324018 = (__local unsigned char *) red_arr_mem_324018_backing_1;\n    \n    __local unsigned char *sync_arr_mem_324020;\n    \n    sync_arr_mem_324020 = (__local\n                           unsigned char *) sync_arr_mem_324020_backing_2;\n    \n    int32_t phys_group_id_324022;\n    \n    phys_group_id_324022 = get_group_id(0);\n    for (int32_t i_324023 = 0; i_324023 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_324002) - phys_group_id_324022,\n                   sext_i64_i32(num_groups_311874)); i_324023++) {\n        int32_t virt_group_id_324024 = phys_group_id_324022 + i_324023 *\n                sext_i64_i32(num_groups_311874);\n        int32_t flat_segment_id_324025 = squot32(virt_group_id_324024,\n                                                 sext_i64_i32(groups_per_segment_324000));\n        int64_t global_tid_324026 = srem64(sext_i32_i64(virt_group_id_324024) *\n                                           segred_group_sizze_311873 +\n                                           sext_i32_i64(local_tid_324012),\n                                           segred_group_sizze_311873 *\n                                           groups_per_segment_324000);\n        int64_t slice_324027 = l_n_m_292832;\n        int64_t slice_324028 = partition_sizze_292766 * slice_324027;\n        int64_t gtid_311878 = squot64(sext_i32_i64(flat_segment_id_324025),\n                                      slice_324027);\n        int64_t remnant_324029 = sext_i32_i64(flat_segment_id_324025) -\n                gtid_311878 * slice_324027;\n        int64_t gtid_311879 = remnant_324029;\n        int64_t remnant_324030 = remnant_324029 - gtid_311879;\n        int64_t gtid_311880;\n        double x_acc_324031;\n        double x_acc_324032;\n        int64_t chunk_sizze_324033 = smin64(elements_per_thread_324001,\n                     ",
            "                       sdiv_up64(q_l_292680 -\n                                                      global_tid_324026,\n                                                      threads_per_segment_324004));\n        double x_311882;\n        double x_311883;\n        double x_311884;\n        double x_311885;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_324031 = 0.0;\n            x_acc_324032 = 0.0;\n        }\n        for (int64_t i_324040 = 0; i_324040 < chunk_sizze_324033; i_324040++) {\n            gtid_311880 = global_tid_324026 + threads_per_segment_324004 *\n                i_324040;\n            // apply map function\n            {\n                int64_t x_311898;\n                \n                x_311898 = ((__global int64_t *) ext_mem_318757)[gtid_311878 *\n                                                                 l_n_m_292832 +\n                                                                 gtid_311879];\n                \n                double x_311899;\n                \n                x_311899 = ((__global double *) ext_mem_318756)[gtid_311878 *\n                                                                l_n_m_292832 +\n                                                                gtid_311879];\n                \n                int64_t binop_y_317917 = mul64(jump_t_292685, gtid_311879);\n                int64_t binop_y_317918 = smin64(i_292846, binop_y_317917);\n                int64_t index_primexp_317919 = add64((int64_t) 1,\n                                                     binop_y_317918);\n                double a12_311901;\n                \n                a12_311901 = ((__global double *) mem_319725)[gtid_311878 *\n                                                              l_n_m_292832 +\n                                                              gtid_311879];\n                \n                double b12_311902;\n                \n                b12_311902 = ((__global double *) mem_319729)[gtid_311878 *\n       ",
            "                                                       l_n_m_292832 +\n                                                              gtid_311879];\n                \n                double c12_311903;\n                \n                c12_311903 = ((__global double *) mem_319733)[gtid_311878 *\n                                                              l_n_m_292832 +\n                                                              gtid_311879];\n                \n                double b2_311904;\n                \n                b2_311904 = ((__global double *) mem_319737)[gtid_311878 *\n                                                             l_n_m_292832 +\n                                                             gtid_311879];\n                \n                double c2_311905;\n                \n                c2_311905 = ((__global double *) mem_319741)[gtid_311878 *\n                                                             l_n_m_292832 +\n                                                             gtid_311879];\n                \n                bool cond_311907 = sle64(n_292675, gtid_311880);\n                int64_t defunc_0_f_res_311908;\n                \n                if (cond_311907) {\n                    defunc_0_f_res_311908 = (int64_t) 0;\n                } else {\n                    int64_t i_311909 = add64(gtid_311880, x_311898);\n                    int64_t defunc_1_add_res_311910 = add64((int64_t) 1,\n                                                            i_311909);\n                    \n                    defunc_0_f_res_311908 = defunc_1_add_res_311910;\n                }\n                \n                double defunc_0_f_res_311911;\n                \n                if (cond_311907) {\n                    defunc_0_f_res_311911 = 0.0;\n                } else {\n                    int64_t i_311912 = add64(gtid_311880, x_311898);\n                    double defunc_0_add_arg_311913;\n                    \n                    defunc_0_add_arg_311913 = ((__glo",
            "bal\n                                                double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                            (gtid_311878 *\n                                                                             ctx_param_ext_318834 +\n                                                                             i_311912 *\n                                                                             ctx_param_ext_318836)];\n                    defunc_0_f_res_311911 = defunc_0_add_arg_311913;\n                }\n                \n                int64_t binop_p_311914 = sub64(defunc_0_f_res_311908,\n                                               index_primexp_317919);\n                double defunc_0_f_res_311915 = sitofp_i64_f64(binop_p_311914);\n                double abs_res_311916 = fabs(defunc_0_f_res_311915);\n                double tmp1_311917 = abs_res_311916 / x_311899;\n                double x_311918 = tmp1_311917 * tmp1_311917;\n                double y_311919 = tmp1_311917 * x_311918;\n                double tmp2_311920 = 1.0 - y_311919;\n                double x_311921 = tmp2_311920 * tmp2_311920;\n                double tmp3_311922 = tmp2_311920 * x_311921;\n                double tmp4_311923 = defunc_0_f_res_311911 * tmp3_311922;\n                double defunc_1_f_res_311924 = defunc_0_f_res_311915 *\n                       tmp4_311923;\n                double defunc_1_f_res_311925 = defunc_0_f_res_311915 *\n                       defunc_1_f_res_311924;\n                double defunc_0_f_res_311926;\n                \n                if (cond_311907) {\n                    defunc_0_f_res_311926 = 0.0;\n                } else {\n                    int64_t i_311927 = add64(gtid_311880, x_311898);\n                    double defunc_0_add_arg_311928;\n                    \n                    defunc_0_add_arg_311928 = ((__global\n                                                double *) mem_319555)[gtid_311878 *\n              ",
            "                                                        n_292675 +\n                                                                      i_311927];\n                    defunc_0_f_res_311926 = defunc_0_add_arg_311928;\n                }\n                \n                double x_311929 = a12_311901 * tmp4_311923;\n                double y_311930 = b12_311902 * defunc_1_f_res_311924;\n                double x_311931 = x_311929 + y_311930;\n                double y_311932 = c12_311903 * defunc_1_f_res_311925;\n                double x_311933 = x_311931 + y_311932;\n                double defunc_9_fit_fun_res_311934 = defunc_0_f_res_311926 *\n                       x_311933;\n                double x_311935 = b12_311902 * tmp4_311923;\n                double y_311936 = b2_311904 * defunc_1_f_res_311924;\n                double x_311937 = x_311935 + y_311936;\n                double y_311938 = c2_311905 * defunc_1_f_res_311925;\n                double x_311939 = x_311937 + y_311938;\n                double defunc_9_slope_fun_res_311940 = defunc_0_f_res_311926 *\n                       x_311939;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_311882 = x_acc_324031;\n                    x_311883 = x_acc_324032;\n                }\n                // load new values\n                {\n                    x_311884 = defunc_9_fit_fun_res_311934;\n                    x_311885 = defunc_9_slope_fun_res_311940;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_311886 = x_311882 + x_311884;\n                    double defunc_1_op_res_311887 = x_311883 + x_311885;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_324031 = defunc_1_op_res_311886;\n                        x_acc_324032 = defunc_1_op_res_311887;\n                    }\n                }\n            }\n ",
            "       }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_311882 = x_acc_324031;\n            x_311883 = x_acc_324032;\n            ((__local\n              double *) red_arr_mem_324016)[sext_i32_i64(local_tid_324012)] =\n                x_311882;\n            ((__local\n              double *) red_arr_mem_324018)[sext_i32_i64(local_tid_324012)] =\n                x_311883;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_324041;\n        int32_t skip_waves_324042 = 1;\n        double x_324034;\n        double x_324035;\n        double x_324036;\n        double x_324037;\n        \n        offset_324041 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_324012,\n                      sext_i64_i32(segred_group_sizze_311873))) {\n                x_324034 = ((__local\n                             double *) red_arr_mem_324016)[sext_i32_i64(local_tid_324012 +\n                                                           offset_324041)];\n                x_324035 = ((__local\n                             double *) red_arr_mem_324018)[sext_i32_i64(local_tid_324012 +\n                                                           offset_324041)];\n            }\n        }\n        offset_324041 = 1;\n        while (slt32(offset_324041, wave_sizze_324014)) {\n            if (slt32(local_tid_324012 + offset_324041,\n                      sext_i64_i32(segred_group_sizze_311873)) &&\n                ((local_tid_324012 - squot32(local_tid_324012,\n                                             wave_sizze_324014) *\n                  wave_sizze_324014) & (2 * offset_324041 - 1)) == 0) {\n                // read array element\n                {\n                    x_324036 = ((volatile __local\n                                 double *) red_arr_mem_324016)[sext_i32_i64(local_tid_324012 +\n                                                               offset_324041)];\n                    x_324037",
            " = ((volatile __local\n                                 double *) red_arr_mem_324018)[sext_i32_i64(local_tid_324012 +\n                                                               offset_324041)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324038 = x_324034 + x_324036;\n                    double defunc_1_op_res_324039 = x_324035 + x_324037;\n                    \n                    x_324034 = defunc_1_op_res_324038;\n                    x_324035 = defunc_1_op_res_324039;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_324016)[sext_i32_i64(local_tid_324012)] =\n                        x_324034;\n                    ((volatile __local\n                      double *) red_arr_mem_324018)[sext_i32_i64(local_tid_324012)] =\n                        x_324035;\n                }\n            }\n            offset_324041 *= 2;\n        }\n        while (slt32(skip_waves_324042,\n                     squot32(sext_i64_i32(segred_group_sizze_311873) +\n                             wave_sizze_324014 - 1, wave_sizze_324014))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_324041 = skip_waves_324042 * wave_sizze_324014;\n            if (slt32(local_tid_324012 + offset_324041,\n                      sext_i64_i32(segred_group_sizze_311873)) &&\n                ((local_tid_324012 - squot32(local_tid_324012,\n                                             wave_sizze_324014) *\n                  wave_sizze_324014) == 0 && (squot32(local_tid_324012,\n                                                      wave_sizze_324014) & (2 *\n                                                                            skip_waves_324042 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                ",
            "    x_324036 = ((__local\n                                 double *) red_arr_mem_324016)[sext_i32_i64(local_tid_324012 +\n                                                               offset_324041)];\n                    x_324037 = ((__local\n                                 double *) red_arr_mem_324018)[sext_i32_i64(local_tid_324012 +\n                                                               offset_324041)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324038 = x_324034 + x_324036;\n                    double defunc_1_op_res_324039 = x_324035 + x_324037;\n                    \n                    x_324034 = defunc_1_op_res_324038;\n                    x_324035 = defunc_1_op_res_324039;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_324016)[sext_i32_i64(local_tid_324012)] =\n                        x_324034;\n                    ((__local\n                      double *) red_arr_mem_324018)[sext_i32_i64(local_tid_324012)] =\n                        x_324035;\n                }\n            }\n            skip_waves_324042 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_324012) == (int64_t) 0) {\n                x_acc_324031 = x_324034;\n                x_acc_324032 = x_324035;\n            }\n        }\n        if (groups_per_segment_324000 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_324012 == 0) {\n                    ((__global double *) mem_319746)[gtid_311878 *\n                                                     l_n_m_292832 +\n                                                     gtid_311879] =\n                        x_acc_324031;\n                    ((__global double *) mem_319750)[gtid_311878 *\n   ",
            "                                                  l_n_m_292832 +\n                                                     gtid_311879] =\n                        x_acc_324032;\n                }\n            }\n        } else {\n            int32_t old_counter_324043;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_324012 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_324005)[sext_i32_i64(virt_group_id_324024)] =\n                        x_acc_324031;\n                    ((__global\n                      double *) segred_tmp_mem_324007)[sext_i32_i64(virt_group_id_324024)] =\n                        x_acc_324032;\n                    mem_fence_global();\n                    old_counter_324043 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324009)[sext_i32_i64(srem32(flat_segment_id_324025,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_324020)[(int64_t) 0] =\n                        old_counter_324043 == groups_per_segment_324000 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_324044;\n            \n            is_last_group_324044 = ((__local\n                                     bool *) sync_arr_mem_324020)[(int64_t) 0];\n            if (is_last_group_324044) {\n                if (local_tid_324012 == 0) {\n                    old_counter_324043 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324009)[sext_i32_i64(srem32(flat_segment_id_324025,\n                                      ",
            "                                                                10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_324000));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_324045 =\n                            sdiv_up64(groups_per_segment_324000,\n                                      segred_group_sizze_311873);\n                    \n                    x_311882 = 0.0;\n                    x_311883 = 0.0;\n                    for (int64_t i_324046 = 0; i_324046 <\n                         read_per_thread_324045; i_324046++) {\n                        int64_t group_res_id_324047 =\n                                sext_i32_i64(local_tid_324012) *\n                                read_per_thread_324045 + i_324046;\n                        int64_t index_of_group_res_324048 =\n                                sext_i32_i64(flat_segment_id_324025) *\n                                groups_per_segment_324000 + group_res_id_324047;\n                        \n                        if (slt64(group_res_id_324047,\n                                  groups_per_segment_324000)) {\n                            x_311884 = ((__global\n                                         double *) segred_tmp_mem_324005)[index_of_group_res_324048];\n                            x_311885 = ((__global\n                                         double *) segred_tmp_mem_324007)[index_of_group_res_324048];\n                            \n                            double defunc_1_op_res_311886 = x_311882 + x_311884;\n                            double defunc_1_op_res_311887 = x_311883 + x_311885;\n                            \n                            x_311882 = defunc_1_op_res_311886;\n                            x_311883 = defunc_1_op_res_311887;\n                        }\n                    }\n                }\n                ((__local\n          ",
            "        double *) red_arr_mem_324016)[sext_i32_i64(local_tid_324012)] =\n                    x_311882;\n                ((__local\n                  double *) red_arr_mem_324018)[sext_i32_i64(local_tid_324012)] =\n                    x_311883;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_324049;\n                    int32_t skip_waves_324050 = 1;\n                    double x_324034;\n                    double x_324035;\n                    double x_324036;\n                    double x_324037;\n                    \n                    offset_324049 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_324012,\n                                  sext_i64_i32(segred_group_sizze_311873))) {\n                            x_324034 = ((__local\n                                         double *) red_arr_mem_324016)[sext_i32_i64(local_tid_324012 +\n                                                                       offset_324049)];\n                            x_324035 = ((__local\n                                         double *) red_arr_mem_324018)[sext_i32_i64(local_tid_324012 +\n                                                                       offset_324049)];\n                        }\n                    }\n                    offset_324049 = 1;\n                    while (slt32(offset_324049, wave_sizze_324014)) {\n                        if (slt32(local_tid_324012 + offset_324049,\n                                  sext_i64_i32(segred_group_sizze_311873)) &&\n                            ((local_tid_324012 - squot32(local_tid_324012,\n                                                         wave_sizze_324014) *\n                              wave_sizze_324014) & (2 * offset_324049 - 1)) ==\n                            0) {\n                            // read array element\n                          ",
            "  {\n                                x_324036 = ((volatile __local\n                                             double *) red_arr_mem_324016)[sext_i32_i64(local_tid_324012 +\n                                                                           offset_324049)];\n                                x_324037 = ((volatile __local\n                                             double *) red_arr_mem_324018)[sext_i32_i64(local_tid_324012 +\n                                                                           offset_324049)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_324038 = x_324034 +\n                                       x_324036;\n                                double defunc_1_op_res_324039 = x_324035 +\n                                       x_324037;\n                                \n                                x_324034 = defunc_1_op_res_324038;\n                                x_324035 = defunc_1_op_res_324039;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_324016)[sext_i32_i64(local_tid_324012)] =\n                                    x_324034;\n                                ((volatile __local\n                                  double *) red_arr_mem_324018)[sext_i32_i64(local_tid_324012)] =\n                                    x_324035;\n                            }\n                        }\n                        offset_324049 *= 2;\n                    }\n                    while (slt32(skip_waves_324050,\n                                 squot32(sext_i64_i32(segred_group_sizze_311873) +\n                                         wave_sizze_324014 - 1,\n                                         wave_sizze_324014))) {\n                        barrier(CLK_LOCAL_MEM_FENC",
            "E);\n                        offset_324049 = skip_waves_324050 * wave_sizze_324014;\n                        if (slt32(local_tid_324012 + offset_324049,\n                                  sext_i64_i32(segred_group_sizze_311873)) &&\n                            ((local_tid_324012 - squot32(local_tid_324012,\n                                                         wave_sizze_324014) *\n                              wave_sizze_324014) == 0 &&\n                             (squot32(local_tid_324012, wave_sizze_324014) &\n                              (2 * skip_waves_324050 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_324036 = ((__local\n                                             double *) red_arr_mem_324016)[sext_i32_i64(local_tid_324012 +\n                                                                           offset_324049)];\n                                x_324037 = ((__local\n                                             double *) red_arr_mem_324018)[sext_i32_i64(local_tid_324012 +\n                                                                           offset_324049)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_324038 = x_324034 +\n                                       x_324036;\n                                double defunc_1_op_res_324039 = x_324035 +\n                                       x_324037;\n                                \n                                x_324034 = defunc_1_op_res_324038;\n                                x_324035 = defunc_1_op_res_324039;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_324016)[sext_i32_i64(local_tid_324012)] =\n                                    x_32403",
            "4;\n                                ((__local\n                                  double *) red_arr_mem_324018)[sext_i32_i64(local_tid_324012)] =\n                                    x_324035;\n                            }\n                        }\n                        skip_waves_324050 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_324012 == 0) {\n                            ((__global double *) mem_319746)[gtid_311878 *\n                                                             l_n_m_292832 +\n                                                             gtid_311879] =\n                                x_324034;\n                            ((__global double *) mem_319750)[gtid_311878 *\n                                                             l_n_m_292832 +\n                                                             gtid_311879] =\n                                x_324035;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_311873\n}\n__kernel void mainzisegred_large_314793(__global int *global_failure,\n                                        uint sync_arr_mem_324380_backing_offset_0,\n                                        uint red_arr_mem_324378_backing_offset_1,\n                                        int64_t n_292675, int64_t q_t_292679,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t t_n_m_292839, int64_t i_292846,\n                                        int64_t num_groups_314787,\n                                        int64_t groups_per_segment_324364,\n                                        int64_t elements_per_thread_324365,\n                                      ",
            "  int64_t virt_num_groups_324366,\n                                        int64_t threads_per_segment_324368,\n                                        __global unsigned char *ext_mem_318541,\n                                        __global unsigned char *ext_mem_318542,\n                                        __global unsigned char *ext_mem_318805,\n                                        __global unsigned char *ext_mem_318806,\n                                        __global unsigned char *mem_319958,\n                                        __global unsigned char *mem_319967,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324369,\n                                        __global\n                                        unsigned char *mainzicounter_mem_324371)\n{\n    #define segred_group_sizze_314786 (mainzisegred_group_sizze_314457)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_324380_backing_1 =\n                           &shared_mem[sync_arr_mem_324380_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324378_backing_0 =\n                           &shared_mem[red_arr_mem_324378_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324373;\n    int32_t local_tid_324374;\n    int64_t group_sizze_324377;\n    int32_t wave_sizze_324376;\n    int32_t group_tid_324375;\n    \n    global_tid_324373 = get_global_id(0);\n    local_tid_324374 = get_local_id(0);\n    group_sizze_324377 = get_local_size(0);\n    wave_sizze_324376 = LOCKSTEP_WIDTH;\n    group_tid_324375 = get_group_id(0);\n    \n    int32_t phys_tid_314793 = global_tid_324373;\n    __local unsigned char *red_arr_mem_324378;\n    \n    red_arr_mem_324378 = (__local unsigned char *) red_arr_mem_324378_backing_0;\n    \n    __local unsigned char *sync_arr_mem_324380;\n    \n    sync_arr_mem_324380 = (__local\n                 ",
            "          unsigned char *) sync_arr_mem_324380_backing_1;\n    \n    int32_t phys_group_id_324382;\n    \n    phys_group_id_324382 = get_group_id(0);\n    for (int32_t i_324383 = 0; i_324383 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_324366) - phys_group_id_324382,\n                   sext_i64_i32(num_groups_314787)); i_324383++) {\n        int32_t virt_group_id_324384 = phys_group_id_324382 + i_324383 *\n                sext_i64_i32(num_groups_314787);\n        int32_t flat_segment_id_324385 = squot32(virt_group_id_324384,\n                                                 sext_i64_i32(groups_per_segment_324364));\n        int64_t global_tid_324386 = srem64(sext_i32_i64(virt_group_id_324384) *\n                                           segred_group_sizze_314786 +\n                                           sext_i32_i64(local_tid_324374),\n                                           segred_group_sizze_314786 *\n                                           groups_per_segment_324364);\n        int64_t slice_324387 = t_n_m_292839;\n        int64_t slice_324388 = partition_sizze_292766 * slice_324387;\n        int64_t gtid_314790 = squot64(sext_i32_i64(flat_segment_id_324385),\n                                      slice_324387);\n        int64_t remnant_324389 = sext_i32_i64(flat_segment_id_324385) -\n                gtid_314790 * slice_324387;\n        int64_t gtid_314791 = remnant_324389;\n        int64_t remnant_324390 = remnant_324389 - gtid_314791;\n        int64_t gtid_314792;\n        double x_acc_324391;\n        int64_t chunk_sizze_324392 = smin64(elements_per_thread_324365,\n                                            sdiv_up64(q_t_292679 -\n                                                      global_tid_324386,\n                                                      threads_per_segment_324368));\n        double x_314794;\n        double x_314795;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_324391 = 0.0;\n        }\n        for (int64_t i_324396 = ",
            "0; i_324396 < chunk_sizze_324392; i_324396++) {\n            gtid_314792 = global_tid_324386 + threads_per_segment_324368 *\n                i_324396;\n            // apply map function\n            {\n                int64_t x_314798;\n                \n                x_314798 = ((__global int64_t *) ext_mem_318541)[gtid_314790];\n                \n                int64_t x_314803;\n                \n                x_314803 = ((__global int64_t *) ext_mem_318806)[gtid_314790 *\n                                                                 t_n_m_292839 +\n                                                                 gtid_314791];\n                \n                double x_314804;\n                \n                x_314804 = ((__global double *) ext_mem_318805)[gtid_314790 *\n                                                                t_n_m_292839 +\n                                                                gtid_314791];\n                \n                int64_t binop_y_317872 = mul64(jump_t_292685, gtid_314791);\n                int64_t binop_y_317873 = smin64(i_292846, binop_y_317872);\n                int64_t index_primexp_317874 = add64((int64_t) 1,\n                                                     binop_y_317873);\n                bool cond_314807 = sle64(x_314798, gtid_314792);\n                int64_t defunc_0_f_res_314808;\n                \n                if (cond_314807) {\n                    defunc_0_f_res_314808 = (int64_t) 0;\n                } else {\n                    int64_t i_314809 = add64(gtid_314792, x_314803);\n                    int64_t defunc_0_add_arg_314810;\n                    \n                    defunc_0_add_arg_314810 = ((__global\n                                                int64_t *) ext_mem_318542)[gtid_314790 *\n                                                                           n_292675 +\n                                                                           i_314809];\n                    \n                    int64_t defun",
            "c_1_add_res_314811 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_314810);\n                    \n                    defunc_0_f_res_314808 = defunc_1_add_res_314811;\n                }\n                \n                double defunc_0_f_res_314812;\n                \n                if (cond_314807) {\n                    defunc_0_f_res_314812 = 0.0;\n                } else {\n                    int64_t i_314813 = add64(gtid_314792, x_314803);\n                    double defunc_0_add_arg_314814;\n                    \n                    defunc_0_add_arg_314814 = ((__global\n                                                double *) mem_319958)[gtid_314790 *\n                                                                      n_292675 +\n                                                                      i_314813];\n                    defunc_0_f_res_314812 = defunc_0_add_arg_314814;\n                }\n                \n                int64_t binop_p_314815 = sub64(defunc_0_f_res_314808,\n                                               index_primexp_317874);\n                double defunc_0_f_res_314816 = sitofp_i64_f64(binop_p_314815);\n                double abs_res_314817 = fabs(defunc_0_f_res_314816);\n                double tmp1_314818 = abs_res_314817 / x_314804;\n                double x_314819 = tmp1_314818 * tmp1_314818;\n                double y_314820 = tmp1_314818 * x_314819;\n                double tmp2_314821 = 1.0 - y_314820;\n                double x_314822 = tmp2_314821 * tmp2_314821;\n                double tmp3_314823 = tmp2_314821 * x_314822;\n                double w_j_314824 = defunc_0_f_res_314812 * tmp3_314823;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_314794 = x_acc_324391;\n                }\n                // load new values\n                {\n                    x_314795 = w_j_314824;\n                }\n ",
            "               // apply reduction operator\n                {\n                    double defunc_1_op_res_314796 = x_314794 + x_314795;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_324391 = defunc_1_op_res_314796;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_314794 = x_acc_324391;\n            ((__local\n              double *) red_arr_mem_324378)[sext_i32_i64(local_tid_324374)] =\n                x_314794;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_324397;\n        int32_t skip_waves_324398 = 1;\n        double x_324393;\n        double x_324394;\n        \n        offset_324397 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_324374,\n                      sext_i64_i32(segred_group_sizze_314786))) {\n                x_324393 = ((__local\n                             double *) red_arr_mem_324378)[sext_i32_i64(local_tid_324374 +\n                                                           offset_324397)];\n            }\n        }\n        offset_324397 = 1;\n        while (slt32(offset_324397, wave_sizze_324376)) {\n            if (slt32(local_tid_324374 + offset_324397,\n                      sext_i64_i32(segred_group_sizze_314786)) &&\n                ((local_tid_324374 - squot32(local_tid_324374,\n                                             wave_sizze_324376) *\n                  wave_sizze_324376) & (2 * offset_324397 - 1)) == 0) {\n                // read array element\n                {\n                    x_324394 = ((volatile __local\n                                 double *) red_arr_mem_324378)[sext_i32_i64(local_tid_324374 +\n                                                               offset_324397)];\n                }\n                // apply reduction operation\n                {\n                    doubl",
            "e defunc_1_op_res_324395 = x_324393 + x_324394;\n                    \n                    x_324393 = defunc_1_op_res_324395;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_324378)[sext_i32_i64(local_tid_324374)] =\n                        x_324393;\n                }\n            }\n            offset_324397 *= 2;\n        }\n        while (slt32(skip_waves_324398,\n                     squot32(sext_i64_i32(segred_group_sizze_314786) +\n                             wave_sizze_324376 - 1, wave_sizze_324376))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_324397 = skip_waves_324398 * wave_sizze_324376;\n            if (slt32(local_tid_324374 + offset_324397,\n                      sext_i64_i32(segred_group_sizze_314786)) &&\n                ((local_tid_324374 - squot32(local_tid_324374,\n                                             wave_sizze_324376) *\n                  wave_sizze_324376) == 0 && (squot32(local_tid_324374,\n                                                      wave_sizze_324376) & (2 *\n                                                                            skip_waves_324398 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_324394 = ((__local\n                                 double *) red_arr_mem_324378)[sext_i32_i64(local_tid_324374 +\n                                                               offset_324397)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324395 = x_324393 + x_324394;\n                    \n                    x_324393 = defunc_1_op_res_324395;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_32437",
            "8)[sext_i32_i64(local_tid_324374)] =\n                        x_324393;\n                }\n            }\n            skip_waves_324398 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_324374) == (int64_t) 0) {\n                x_acc_324391 = x_324393;\n            }\n        }\n        if (groups_per_segment_324364 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_324374 == 0) {\n                    ((__global double *) mem_319967)[gtid_314790 *\n                                                     t_n_m_292839 +\n                                                     gtid_314791] =\n                        x_acc_324391;\n                }\n            }\n        } else {\n            int32_t old_counter_324399;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_324374 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_324369)[sext_i32_i64(virt_group_id_324384)] =\n                        x_acc_324391;\n                    mem_fence_global();\n                    old_counter_324399 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324371)[sext_i32_i64(srem32(flat_segment_id_324385,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_324380)[(int64_t) 0] =\n                        old_counter_324399 == groups_per_segment_324364 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_324400;\n            \n          ",
            "  is_last_group_324400 = ((__local\n                                     bool *) sync_arr_mem_324380)[(int64_t) 0];\n            if (is_last_group_324400) {\n                if (local_tid_324374 == 0) {\n                    old_counter_324399 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324371)[sext_i32_i64(srem32(flat_segment_id_324385,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_324364));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_324401 =\n                            sdiv_up64(groups_per_segment_324364,\n                                      segred_group_sizze_314786);\n                    \n                    x_314794 = 0.0;\n                    for (int64_t i_324402 = 0; i_324402 <\n                         read_per_thread_324401; i_324402++) {\n                        int64_t group_res_id_324403 =\n                                sext_i32_i64(local_tid_324374) *\n                                read_per_thread_324401 + i_324402;\n                        int64_t index_of_group_res_324404 =\n                                sext_i32_i64(flat_segment_id_324385) *\n                                groups_per_segment_324364 + group_res_id_324403;\n                        \n                        if (slt64(group_res_id_324403,\n                                  groups_per_segment_324364)) {\n                            x_314795 = ((__global\n                                         double *) segred_tmp_mem_324369)[index_of_group_res_324404];\n                            \n                            double defunc_1_op_res_314796 = x_314794 + x_314795;\n                            \n                         ",
            "   x_314794 = defunc_1_op_res_314796;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_324378)[sext_i32_i64(local_tid_324374)] =\n                    x_314794;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_324405;\n                    int32_t skip_waves_324406 = 1;\n                    double x_324393;\n                    double x_324394;\n                    \n                    offset_324405 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_324374,\n                                  sext_i64_i32(segred_group_sizze_314786))) {\n                            x_324393 = ((__local\n                                         double *) red_arr_mem_324378)[sext_i32_i64(local_tid_324374 +\n                                                                       offset_324405)];\n                        }\n                    }\n                    offset_324405 = 1;\n                    while (slt32(offset_324405, wave_sizze_324376)) {\n                        if (slt32(local_tid_324374 + offset_324405,\n                                  sext_i64_i32(segred_group_sizze_314786)) &&\n                            ((local_tid_324374 - squot32(local_tid_324374,\n                                                         wave_sizze_324376) *\n                              wave_sizze_324376) & (2 * offset_324405 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_324394 = ((volatile __local\n                                             double *) red_arr_mem_324378)[sext_i32_i64(local_tid_324374 +\n                                                                           offset_324405)];\n                            }\n                 ",
            "           // apply reduction operation\n                            {\n                                double defunc_1_op_res_324395 = x_324393 +\n                                       x_324394;\n                                \n                                x_324393 = defunc_1_op_res_324395;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_324378)[sext_i32_i64(local_tid_324374)] =\n                                    x_324393;\n                            }\n                        }\n                        offset_324405 *= 2;\n                    }\n                    while (slt32(skip_waves_324406,\n                                 squot32(sext_i64_i32(segred_group_sizze_314786) +\n                                         wave_sizze_324376 - 1,\n                                         wave_sizze_324376))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_324405 = skip_waves_324406 * wave_sizze_324376;\n                        if (slt32(local_tid_324374 + offset_324405,\n                                  sext_i64_i32(segred_group_sizze_314786)) &&\n                            ((local_tid_324374 - squot32(local_tid_324374,\n                                                         wave_sizze_324376) *\n                              wave_sizze_324376) == 0 &&\n                             (squot32(local_tid_324374, wave_sizze_324376) &\n                              (2 * skip_waves_324406 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_324394 = ((__local\n                                             double *) red_arr_mem_324378)[sext_i32_i64(local_tid_324374 +\n                                                                           offset_324405)];\n                            }\n             ",
            "               // apply reduction operation\n                            {\n                                double defunc_1_op_res_324395 = x_324393 +\n                                       x_324394;\n                                \n                                x_324393 = defunc_1_op_res_324395;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_324378)[sext_i32_i64(local_tid_324374)] =\n                                    x_324393;\n                            }\n                        }\n                        skip_waves_324406 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_324374 == 0) {\n                            ((__global double *) mem_319967)[gtid_314790 *\n                                                             t_n_m_292839 +\n                                                             gtid_314791] =\n                                x_324393;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_314786\n}\n__kernel void mainzisegred_large_314846(__global int *global_failure,\n                                        uint sync_arr_mem_324463_backing_offset_0,\n                                        uint red_arr_mem_324461_backing_offset_1,\n                                        int64_t n_292675, int64_t q_t_292679,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t t_n_m_292839, int64_t i_292846,\n                                        int64_t num_groups_314840,\n                                        int64_",
            "t groups_per_segment_324447,\n                                        int64_t elements_per_thread_324448,\n                                        int64_t virt_num_groups_324449,\n                                        int64_t threads_per_segment_324451,\n                                        __global unsigned char *ext_mem_318541,\n                                        __global unsigned char *ext_mem_318542,\n                                        __global unsigned char *ext_mem_318805,\n                                        __global unsigned char *ext_mem_318806,\n                                        __global unsigned char *mem_319958,\n                                        __global unsigned char *mem_319962,\n                                        __global unsigned char *mem_319972,\n                                        __global unsigned char *mem_319977,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324452,\n                                        __global\n                                        unsigned char *mainzicounter_mem_324454)\n{\n    #define segred_group_sizze_314839 (mainzisegred_group_sizze_314386)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_324463_backing_1 =\n                           &shared_mem[sync_arr_mem_324463_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324461_backing_0 =\n                           &shared_mem[red_arr_mem_324461_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324456;\n    int32_t local_tid_324457;\n    int64_t group_sizze_324460;\n    int32_t wave_sizze_324459;\n    int32_t group_tid_324458;\n    \n    global_tid_324456 = get_global_id(0);\n    local_tid_324457 = get_local_id(0);\n    group_sizze_324460 = get_local_size(0);\n    wave_sizze_324459 = LOCKSTEP_WIDTH;\n    group_tid_324458 = get_group_id(0);\n  ",
            "  \n    int32_t phys_tid_314846 = global_tid_324456;\n    __local unsigned char *red_arr_mem_324461;\n    \n    red_arr_mem_324461 = (__local unsigned char *) red_arr_mem_324461_backing_0;\n    \n    __local unsigned char *sync_arr_mem_324463;\n    \n    sync_arr_mem_324463 = (__local\n                           unsigned char *) sync_arr_mem_324463_backing_1;\n    \n    int32_t phys_group_id_324465;\n    \n    phys_group_id_324465 = get_group_id(0);\n    for (int32_t i_324466 = 0; i_324466 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_324449) - phys_group_id_324465,\n                   sext_i64_i32(num_groups_314840)); i_324466++) {\n        int32_t virt_group_id_324467 = phys_group_id_324465 + i_324466 *\n                sext_i64_i32(num_groups_314840);\n        int32_t flat_segment_id_324468 = squot32(virt_group_id_324467,\n                                                 sext_i64_i32(groups_per_segment_324447));\n        int64_t global_tid_324469 = srem64(sext_i32_i64(virt_group_id_324467) *\n                                           segred_group_sizze_314839 +\n                                           sext_i32_i64(local_tid_324457),\n                                           segred_group_sizze_314839 *\n                                           groups_per_segment_324447);\n        int64_t slice_324470 = t_n_m_292839;\n        int64_t slice_324471 = partition_sizze_292766 * slice_324470;\n        int64_t gtid_314843 = squot64(sext_i32_i64(flat_segment_id_324468),\n                                      slice_324470);\n        int64_t remnant_324472 = sext_i32_i64(flat_segment_id_324468) -\n                gtid_314843 * slice_324470;\n        int64_t gtid_314844 = remnant_324472;\n        int64_t remnant_324473 = remnant_324472 - gtid_314844;\n        int64_t gtid_314845;\n        double x_acc_324474;\n        int64_t chunk_sizze_324475 = smin64(elements_per_thread_324448,\n                                            sdiv_up64(q_t_292679 -\n                                                    ",
            "  global_tid_324469,\n                                                      threads_per_segment_324451));\n        double x_314847;\n        double x_314848;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_324474 = 0.0;\n        }\n        for (int64_t i_324479 = 0; i_324479 < chunk_sizze_324475; i_324479++) {\n            gtid_314845 = global_tid_324469 + threads_per_segment_324451 *\n                i_324479;\n            // apply map function\n            {\n                int64_t x_314851;\n                \n                x_314851 = ((__global int64_t *) ext_mem_318541)[gtid_314843];\n                \n                int64_t x_314858;\n                \n                x_314858 = ((__global int64_t *) ext_mem_318806)[gtid_314843 *\n                                                                 t_n_m_292839 +\n                                                                 gtid_314844];\n                \n                double x_314859;\n                \n                x_314859 = ((__global double *) ext_mem_318805)[gtid_314843 *\n                                                                t_n_m_292839 +\n                                                                gtid_314844];\n                \n                int64_t binop_y_317867 = mul64(jump_t_292685, gtid_314844);\n                int64_t binop_y_317868 = smin64(i_292846, binop_y_317867);\n                int64_t index_primexp_317869 = add64((int64_t) 1,\n                                                     binop_y_317868);\n                double a0_314861;\n                \n                a0_314861 = ((__global double *) mem_319972)[gtid_314843 *\n                                                             t_n_m_292839 +\n                                                             gtid_314844];\n                \n                bool cond_314863 = sle64(x_314851, gtid_314845);\n                int64_t defunc_0_f_res_314864;\n                \n                if (cond_314863) {\n        ",
            "            defunc_0_f_res_314864 = (int64_t) 0;\n                } else {\n                    int64_t i_314865 = add64(gtid_314845, x_314858);\n                    int64_t defunc_0_add_arg_314866;\n                    \n                    defunc_0_add_arg_314866 = ((__global\n                                                int64_t *) ext_mem_318542)[gtid_314843 *\n                                                                           n_292675 +\n                                                                           i_314865];\n                    \n                    int64_t defunc_1_add_res_314867 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_314866);\n                    \n                    defunc_0_f_res_314864 = defunc_1_add_res_314867;\n                }\n                \n                double defunc_0_f_res_314868;\n                \n                if (cond_314863) {\n                    defunc_0_f_res_314868 = 0.0;\n                } else {\n                    int64_t i_314869 = add64(gtid_314845, x_314858);\n                    double defunc_0_add_arg_314870;\n                    \n                    defunc_0_add_arg_314870 = ((__global\n                                                double *) mem_319958)[gtid_314843 *\n                                                                      n_292675 +\n                                                                      i_314869];\n                    defunc_0_f_res_314868 = defunc_0_add_arg_314870;\n                }\n                \n                int64_t binop_p_314871 = sub64(defunc_0_f_res_314864,\n                                               index_primexp_317869);\n                double defunc_0_f_res_314872 = sitofp_i64_f64(binop_p_314871);\n                double abs_res_314873 = fabs(defunc_0_f_res_314872);\n                double tmp1_314874 = abs_res_314873 / x_314859;\n                double x_314875 = tmp1_314874 * tmp1_314874;\n                double y_3",
            "14876 = tmp1_314874 * x_314875;\n                double tmp2_314877 = 1.0 - y_314876;\n                double x_314878 = tmp2_314877 * tmp2_314877;\n                double tmp3_314879 = tmp2_314877 * x_314878;\n                double tmp4_314880 = defunc_0_f_res_314868 * tmp3_314879;\n                double defunc_0_f_res_314881;\n                \n                if (cond_314863) {\n                    defunc_0_f_res_314881 = 0.0;\n                } else {\n                    int64_t i_314882 = add64(gtid_314845, x_314858);\n                    double defunc_0_add_arg_314883;\n                    \n                    defunc_0_add_arg_314883 = ((__global\n                                                double *) mem_319962)[gtid_314843 *\n                                                                      n_292675 +\n                                                                      i_314882];\n                    defunc_0_f_res_314881 = defunc_0_add_arg_314883;\n                }\n                \n                double x_314884 = a0_314861 * tmp4_314880;\n                double defunc_9_fit_fun_res_314885 = defunc_0_f_res_314881 *\n                       x_314884;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_314847 = x_acc_324474;\n                }\n                // load new values\n                {\n                    x_314848 = defunc_9_fit_fun_res_314885;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_314849 = x_314847 + x_314848;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_324474 = defunc_1_op_res_314849;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_314847 = x_acc_324474;\n            ((__local\n              dou",
            "ble *) red_arr_mem_324461)[sext_i32_i64(local_tid_324457)] =\n                x_314847;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_324480;\n        int32_t skip_waves_324481 = 1;\n        double x_324476;\n        double x_324477;\n        \n        offset_324480 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_324457,\n                      sext_i64_i32(segred_group_sizze_314839))) {\n                x_324476 = ((__local\n                             double *) red_arr_mem_324461)[sext_i32_i64(local_tid_324457 +\n                                                           offset_324480)];\n            }\n        }\n        offset_324480 = 1;\n        while (slt32(offset_324480, wave_sizze_324459)) {\n            if (slt32(local_tid_324457 + offset_324480,\n                      sext_i64_i32(segred_group_sizze_314839)) &&\n                ((local_tid_324457 - squot32(local_tid_324457,\n                                             wave_sizze_324459) *\n                  wave_sizze_324459) & (2 * offset_324480 - 1)) == 0) {\n                // read array element\n                {\n                    x_324477 = ((volatile __local\n                                 double *) red_arr_mem_324461)[sext_i32_i64(local_tid_324457 +\n                                                               offset_324480)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324478 = x_324476 + x_324477;\n                    \n                    x_324476 = defunc_1_op_res_324478;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_324461)[sext_i32_i64(local_tid_324457)] =\n                        x_324476;\n                }\n            }\n            offset_324480 *= 2;\n        }\n        while (slt32(skip_waves_324481,\n                     squo",
            "t32(sext_i64_i32(segred_group_sizze_314839) +\n                             wave_sizze_324459 - 1, wave_sizze_324459))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_324480 = skip_waves_324481 * wave_sizze_324459;\n            if (slt32(local_tid_324457 + offset_324480,\n                      sext_i64_i32(segred_group_sizze_314839)) &&\n                ((local_tid_324457 - squot32(local_tid_324457,\n                                             wave_sizze_324459) *\n                  wave_sizze_324459) == 0 && (squot32(local_tid_324457,\n                                                      wave_sizze_324459) & (2 *\n                                                                            skip_waves_324481 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_324477 = ((__local\n                                 double *) red_arr_mem_324461)[sext_i32_i64(local_tid_324457 +\n                                                               offset_324480)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324478 = x_324476 + x_324477;\n                    \n                    x_324476 = defunc_1_op_res_324478;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_324461)[sext_i32_i64(local_tid_324457)] =\n                        x_324476;\n                }\n            }\n            skip_waves_324481 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_324457) == (int64_t) 0) {\n                x_acc_324474 = x_324476;\n            }\n        }\n        if (groups_per_segment_324447 == (int64_t) 1) {\n            // first thread in group saves final result to memor",
            "y\n            {\n                if (local_tid_324457 == 0) {\n                    ((__global double *) mem_319977)[gtid_314843 *\n                                                     t_n_m_292839 +\n                                                     gtid_314844] =\n                        x_acc_324474;\n                }\n            }\n        } else {\n            int32_t old_counter_324482;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_324457 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_324452)[sext_i32_i64(virt_group_id_324467)] =\n                        x_acc_324474;\n                    mem_fence_global();\n                    old_counter_324482 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324454)[sext_i32_i64(srem32(flat_segment_id_324468,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_324463)[(int64_t) 0] =\n                        old_counter_324482 == groups_per_segment_324447 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_324483;\n            \n            is_last_group_324483 = ((__local\n                                     bool *) sync_arr_mem_324463)[(int64_t) 0];\n            if (is_last_group_324483) {\n                if (local_tid_324457 == 0) {\n                    old_counter_324482 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324454)[sext_i32_i64(srem32(flat_segment_id_324468,\n                                                                     ",
            "                                 10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_324447));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_324484 =\n                            sdiv_up64(groups_per_segment_324447,\n                                      segred_group_sizze_314839);\n                    \n                    x_314847 = 0.0;\n                    for (int64_t i_324485 = 0; i_324485 <\n                         read_per_thread_324484; i_324485++) {\n                        int64_t group_res_id_324486 =\n                                sext_i32_i64(local_tid_324457) *\n                                read_per_thread_324484 + i_324485;\n                        int64_t index_of_group_res_324487 =\n                                sext_i32_i64(flat_segment_id_324468) *\n                                groups_per_segment_324447 + group_res_id_324486;\n                        \n                        if (slt64(group_res_id_324486,\n                                  groups_per_segment_324447)) {\n                            x_314848 = ((__global\n                                         double *) segred_tmp_mem_324452)[index_of_group_res_324487];\n                            \n                            double defunc_1_op_res_314849 = x_314847 + x_314848;\n                            \n                            x_314847 = defunc_1_op_res_314849;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_324461)[sext_i32_i64(local_tid_324457)] =\n                    x_314847;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_324488;\n                    int32_t skip_waves_324489 = 1;\n                    double x_324476;\n                  ",
            "  double x_324477;\n                    \n                    offset_324488 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_324457,\n                                  sext_i64_i32(segred_group_sizze_314839))) {\n                            x_324476 = ((__local\n                                         double *) red_arr_mem_324461)[sext_i32_i64(local_tid_324457 +\n                                                                       offset_324488)];\n                        }\n                    }\n                    offset_324488 = 1;\n                    while (slt32(offset_324488, wave_sizze_324459)) {\n                        if (slt32(local_tid_324457 + offset_324488,\n                                  sext_i64_i32(segred_group_sizze_314839)) &&\n                            ((local_tid_324457 - squot32(local_tid_324457,\n                                                         wave_sizze_324459) *\n                              wave_sizze_324459) & (2 * offset_324488 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_324477 = ((volatile __local\n                                             double *) red_arr_mem_324461)[sext_i32_i64(local_tid_324457 +\n                                                                           offset_324488)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_324478 = x_324476 +\n                                       x_324477;\n                                \n                                x_324476 = defunc_1_op_res_324478;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double ",
            "*) red_arr_mem_324461)[sext_i32_i64(local_tid_324457)] =\n                                    x_324476;\n                            }\n                        }\n                        offset_324488 *= 2;\n                    }\n                    while (slt32(skip_waves_324489,\n                                 squot32(sext_i64_i32(segred_group_sizze_314839) +\n                                         wave_sizze_324459 - 1,\n                                         wave_sizze_324459))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_324488 = skip_waves_324489 * wave_sizze_324459;\n                        if (slt32(local_tid_324457 + offset_324488,\n                                  sext_i64_i32(segred_group_sizze_314839)) &&\n                            ((local_tid_324457 - squot32(local_tid_324457,\n                                                         wave_sizze_324459) *\n                              wave_sizze_324459) == 0 &&\n                             (squot32(local_tid_324457, wave_sizze_324459) &\n                              (2 * skip_waves_324489 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_324477 = ((__local\n                                             double *) red_arr_mem_324461)[sext_i32_i64(local_tid_324457 +\n                                                                           offset_324488)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_324478 = x_324476 +\n                                       x_324477;\n                                \n                                x_324476 = defunc_1_op_res_324478;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) re",
            "d_arr_mem_324461)[sext_i32_i64(local_tid_324457)] =\n                                    x_324476;\n                            }\n                        }\n                        skip_waves_324489 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_324457 == 0) {\n                            ((__global double *) mem_319977)[gtid_314843 *\n                                                             t_n_m_292839 +\n                                                             gtid_314844] =\n                                x_324476;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_314839\n}\n__kernel void mainzisegred_large_315394(__global int *global_failure,\n                                        uint sync_arr_mem_324576_backing_offset_0,\n                                        uint red_arr_mem_324574_backing_offset_1,\n                                        uint red_arr_mem_324572_backing_offset_2,\n                                        uint red_arr_mem_324570_backing_offset_3,\n                                        int64_t n_292675, int64_t q_t_292679,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t t_n_m_292839, int64_t i_292846,\n                                        int64_t num_groups_315386,\n                                        int64_t groups_per_segment_324552,\n                                        int64_t elements_per_thread_324553,\n                                        int64_t virt_num_groups_324554,\n                                        int64_t threads_per_segment_324556,\n                                        __global unsigned char *ext_mem_318541,\n      ",
            "                                  __global unsigned char *ext_mem_318542,\n                                        __global unsigned char *ext_mem_318805,\n                                        __global unsigned char *ext_mem_318806,\n                                        __global unsigned char *mem_319987,\n                                        __global unsigned char *mem_319996,\n                                        __global unsigned char *mem_320000,\n                                        __global unsigned char *mem_320004,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324557,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324559,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324561,\n                                        __global\n                                        unsigned char *mainzicounter_mem_324563)\n{\n    #define segred_group_sizze_315385 (mainzisegred_group_sizze_315010)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_324576_backing_3 =\n                           &shared_mem[sync_arr_mem_324576_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324574_backing_2 =\n                           &shared_mem[red_arr_mem_324574_backing_offset_1];\n    volatile unsigned char *red_arr_mem_324572_backing_1 =\n                           &shared_mem[red_arr_mem_324572_backing_offset_2];\n    volatile unsigned char *red_arr_mem_324570_backing_0 =\n                           &shared_mem[red_arr_mem_324570_backing_offset_3];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324565;\n    int32_t local_tid_324566;\n    int64_t group_sizze_324569;\n    int32_t wave_sizze_324568;\n    int32_t group_tid_324567;\n    \n    global_tid_324565",
            " = get_global_id(0);\n    local_tid_324566 = get_local_id(0);\n    group_sizze_324569 = get_local_size(0);\n    wave_sizze_324568 = LOCKSTEP_WIDTH;\n    group_tid_324567 = get_group_id(0);\n    \n    int32_t phys_tid_315394 = global_tid_324565;\n    __local unsigned char *red_arr_mem_324570;\n    \n    red_arr_mem_324570 = (__local unsigned char *) red_arr_mem_324570_backing_0;\n    \n    __local unsigned char *red_arr_mem_324572;\n    \n    red_arr_mem_324572 = (__local unsigned char *) red_arr_mem_324572_backing_1;\n    \n    __local unsigned char *red_arr_mem_324574;\n    \n    red_arr_mem_324574 = (__local unsigned char *) red_arr_mem_324574_backing_2;\n    \n    __local unsigned char *sync_arr_mem_324576;\n    \n    sync_arr_mem_324576 = (__local\n                           unsigned char *) sync_arr_mem_324576_backing_3;\n    \n    int32_t phys_group_id_324578;\n    \n    phys_group_id_324578 = get_group_id(0);\n    for (int32_t i_324579 = 0; i_324579 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_324554) - phys_group_id_324578,\n                   sext_i64_i32(num_groups_315386)); i_324579++) {\n        int32_t virt_group_id_324580 = phys_group_id_324578 + i_324579 *\n                sext_i64_i32(num_groups_315386);\n        int32_t flat_segment_id_324581 = squot32(virt_group_id_324580,\n                                                 sext_i64_i32(groups_per_segment_324552));\n        int64_t global_tid_324582 = srem64(sext_i32_i64(virt_group_id_324580) *\n                                           segred_group_sizze_315385 +\n                                           sext_i32_i64(local_tid_324566),\n                                           segred_group_sizze_315385 *\n                                           groups_per_segment_324552);\n        int64_t slice_324583 = t_n_m_292839;\n        int64_t slice_324584 = partition_sizze_292766 * slice_324583;\n        int64_t gtid_315391 = squot64(sext_i32_i64(flat_segment_id_324581),\n                                      slice_324583);\n        int",
            "64_t remnant_324585 = sext_i32_i64(flat_segment_id_324581) -\n                gtid_315391 * slice_324583;\n        int64_t gtid_315392 = remnant_324585;\n        int64_t remnant_324586 = remnant_324585 - gtid_315392;\n        int64_t gtid_315393;\n        double x_acc_324587;\n        double x_acc_324588;\n        double x_acc_324589;\n        int64_t chunk_sizze_324590 = smin64(elements_per_thread_324553,\n                                            sdiv_up64(q_t_292679 -\n                                                      global_tid_324582,\n                                                      threads_per_segment_324556));\n        double x_315395;\n        double x_315396;\n        double x_315397;\n        double x_315398;\n        double x_315399;\n        double x_315400;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_324587 = 0.0;\n            x_acc_324588 = 0.0;\n            x_acc_324589 = 0.0;\n        }\n        for (int64_t i_324600 = 0; i_324600 < chunk_sizze_324590; i_324600++) {\n            gtid_315393 = global_tid_324582 + threads_per_segment_324556 *\n                i_324600;\n            // apply map function\n            {\n                int64_t x_315405;\n                \n                x_315405 = ((__global int64_t *) ext_mem_318541)[gtid_315391];\n                \n                int64_t x_315410;\n                \n                x_315410 = ((__global int64_t *) ext_mem_318806)[gtid_315391 *\n                                                                 t_n_m_292839 +\n                                                                 gtid_315392];\n                \n                double x_315411;\n                \n                x_315411 = ((__global double *) ext_mem_318805)[gtid_315391 *\n                                                                t_n_m_292839 +\n                                                                gtid_315392];\n                \n                int64_t binop_y_317882 = mul64(jump_t_292685, gtid_3",
            "15392);\n                int64_t binop_y_317883 = smin64(i_292846, binop_y_317882);\n                int64_t index_primexp_317884 = add64((int64_t) 1,\n                                                     binop_y_317883);\n                bool cond_315414 = sle64(x_315405, gtid_315393);\n                int64_t defunc_0_f_res_315415;\n                \n                if (cond_315414) {\n                    defunc_0_f_res_315415 = (int64_t) 0;\n                } else {\n                    int64_t i_315416 = add64(gtid_315393, x_315410);\n                    int64_t defunc_0_add_arg_315417;\n                    \n                    defunc_0_add_arg_315417 = ((__global\n                                                int64_t *) ext_mem_318542)[gtid_315391 *\n                                                                           n_292675 +\n                                                                           i_315416];\n                    \n                    int64_t defunc_1_add_res_315418 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_315417);\n                    \n                    defunc_0_f_res_315415 = defunc_1_add_res_315418;\n                }\n                \n                double defunc_0_f_res_315419;\n                \n                if (cond_315414) {\n                    defunc_0_f_res_315419 = 0.0;\n                } else {\n                    int64_t i_315420 = add64(gtid_315393, x_315410);\n                    double defunc_0_add_arg_315421;\n                    \n                    defunc_0_add_arg_315421 = ((__global\n                                                double *) mem_319987)[gtid_315391 *\n                                                                      n_292675 +\n                                                                      i_315420];\n                    defunc_0_f_res_315419 = defunc_0_add_arg_315421;\n                }\n                \n                int64_t binop_p_315422 = sub64(d",
            "efunc_0_f_res_315415,\n                                               index_primexp_317884);\n                double defunc_0_f_res_315423 = sitofp_i64_f64(binop_p_315422);\n                double abs_res_315424 = fabs(defunc_0_f_res_315423);\n                double tmp1_315425 = abs_res_315424 / x_315411;\n                double x_315426 = tmp1_315425 * tmp1_315425;\n                double y_315427 = tmp1_315425 * x_315426;\n                double tmp2_315428 = 1.0 - y_315427;\n                double x_315429 = tmp2_315428 * tmp2_315428;\n                double tmp3_315430 = tmp2_315428 * x_315429;\n                double w_j_315431 = defunc_0_f_res_315419 * tmp3_315430;\n                double xw_j_315432 = defunc_0_f_res_315423 * w_j_315431;\n                double x2w_j_315433 = defunc_0_f_res_315423 * xw_j_315432;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_315395 = x_acc_324587;\n                    x_315396 = x_acc_324588;\n                    x_315397 = x_acc_324589;\n                }\n                // load new values\n                {\n                    x_315398 = w_j_315431;\n                    x_315399 = xw_j_315432;\n                    x_315400 = x2w_j_315433;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_315401 = x_315395 + x_315398;\n                    double defunc_1_op_res_315402 = x_315396 + x_315399;\n                    double defunc_1_op_res_315403 = x_315397 + x_315400;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_324587 = defunc_1_op_res_315401;\n                        x_acc_324588 = defunc_1_op_res_315402;\n                        x_acc_324589 = defunc_1_op_res_315403;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n    ",
            "    {\n            x_315395 = x_acc_324587;\n            x_315396 = x_acc_324588;\n            x_315397 = x_acc_324589;\n            ((__local\n              double *) red_arr_mem_324570)[sext_i32_i64(local_tid_324566)] =\n                x_315395;\n            ((__local\n              double *) red_arr_mem_324572)[sext_i32_i64(local_tid_324566)] =\n                x_315396;\n            ((__local\n              double *) red_arr_mem_324574)[sext_i32_i64(local_tid_324566)] =\n                x_315397;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_324601;\n        int32_t skip_waves_324602 = 1;\n        double x_324591;\n        double x_324592;\n        double x_324593;\n        double x_324594;\n        double x_324595;\n        double x_324596;\n        \n        offset_324601 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_324566,\n                      sext_i64_i32(segred_group_sizze_315385))) {\n                x_324591 = ((__local\n                             double *) red_arr_mem_324570)[sext_i32_i64(local_tid_324566 +\n                                                           offset_324601)];\n                x_324592 = ((__local\n                             double *) red_arr_mem_324572)[sext_i32_i64(local_tid_324566 +\n                                                           offset_324601)];\n                x_324593 = ((__local\n                             double *) red_arr_mem_324574)[sext_i32_i64(local_tid_324566 +\n                                                           offset_324601)];\n            }\n        }\n        offset_324601 = 1;\n        while (slt32(offset_324601, wave_sizze_324568)) {\n            if (slt32(local_tid_324566 + offset_324601,\n                      sext_i64_i32(segred_group_sizze_315385)) &&\n                ((local_tid_324566 - squot32(local_tid_324566,\n                                             wave_sizze_324568) *\n                  wave_sizze_324568) & (2 * of",
            "fset_324601 - 1)) == 0) {\n                // read array element\n                {\n                    x_324594 = ((volatile __local\n                                 double *) red_arr_mem_324570)[sext_i32_i64(local_tid_324566 +\n                                                               offset_324601)];\n                    x_324595 = ((volatile __local\n                                 double *) red_arr_mem_324572)[sext_i32_i64(local_tid_324566 +\n                                                               offset_324601)];\n                    x_324596 = ((volatile __local\n                                 double *) red_arr_mem_324574)[sext_i32_i64(local_tid_324566 +\n                                                               offset_324601)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324597 = x_324591 + x_324594;\n                    double defunc_1_op_res_324598 = x_324592 + x_324595;\n                    double defunc_1_op_res_324599 = x_324593 + x_324596;\n                    \n                    x_324591 = defunc_1_op_res_324597;\n                    x_324592 = defunc_1_op_res_324598;\n                    x_324593 = defunc_1_op_res_324599;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_324570)[sext_i32_i64(local_tid_324566)] =\n                        x_324591;\n                    ((volatile __local\n                      double *) red_arr_mem_324572)[sext_i32_i64(local_tid_324566)] =\n                        x_324592;\n                    ((volatile __local\n                      double *) red_arr_mem_324574)[sext_i32_i64(local_tid_324566)] =\n                        x_324593;\n                }\n            }\n            offset_324601 *= 2;\n        }\n        while (slt32(skip_waves_324602,\n                     squot32(sext_i64_i32(segred_group_sizze_315385) +\n              ",
            "               wave_sizze_324568 - 1, wave_sizze_324568))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_324601 = skip_waves_324602 * wave_sizze_324568;\n            if (slt32(local_tid_324566 + offset_324601,\n                      sext_i64_i32(segred_group_sizze_315385)) &&\n                ((local_tid_324566 - squot32(local_tid_324566,\n                                             wave_sizze_324568) *\n                  wave_sizze_324568) == 0 && (squot32(local_tid_324566,\n                                                      wave_sizze_324568) & (2 *\n                                                                            skip_waves_324602 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_324594 = ((__local\n                                 double *) red_arr_mem_324570)[sext_i32_i64(local_tid_324566 +\n                                                               offset_324601)];\n                    x_324595 = ((__local\n                                 double *) red_arr_mem_324572)[sext_i32_i64(local_tid_324566 +\n                                                               offset_324601)];\n                    x_324596 = ((__local\n                                 double *) red_arr_mem_324574)[sext_i32_i64(local_tid_324566 +\n                                                               offset_324601)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324597 = x_324591 + x_324594;\n                    double defunc_1_op_res_324598 = x_324592 + x_324595;\n                    double defunc_1_op_res_324599 = x_324593 + x_324596;\n                    \n                    x_324591 = defunc_1_op_res_324597;\n                    x_324592 = defunc_1_op_res_324598;\n                    x_324593 = defunc_1_op_res_324599;\n                }\n                /",
            "/ write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_324570)[sext_i32_i64(local_tid_324566)] =\n                        x_324591;\n                    ((__local\n                      double *) red_arr_mem_324572)[sext_i32_i64(local_tid_324566)] =\n                        x_324592;\n                    ((__local\n                      double *) red_arr_mem_324574)[sext_i32_i64(local_tid_324566)] =\n                        x_324593;\n                }\n            }\n            skip_waves_324602 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_324566) == (int64_t) 0) {\n                x_acc_324587 = x_324591;\n                x_acc_324588 = x_324592;\n                x_acc_324589 = x_324593;\n            }\n        }\n        if (groups_per_segment_324552 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_324566 == 0) {\n                    ((__global double *) mem_319996)[gtid_315391 *\n                                                     t_n_m_292839 +\n                                                     gtid_315392] =\n                        x_acc_324587;\n                    ((__global double *) mem_320000)[gtid_315391 *\n                                                     t_n_m_292839 +\n                                                     gtid_315392] =\n                        x_acc_324588;\n                    ((__global double *) mem_320004)[gtid_315391 *\n                                                     t_n_m_292839 +\n                                                     gtid_315392] =\n                        x_acc_324589;\n                }\n            }\n        } else {\n            int32_t old_counter_324603;\n            \n            // first thread in group saves group result to global memory\n            {\n                i",
            "f (local_tid_324566 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_324557)[sext_i32_i64(virt_group_id_324580)] =\n                        x_acc_324587;\n                    ((__global\n                      double *) segred_tmp_mem_324559)[sext_i32_i64(virt_group_id_324580)] =\n                        x_acc_324588;\n                    ((__global\n                      double *) segred_tmp_mem_324561)[sext_i32_i64(virt_group_id_324580)] =\n                        x_acc_324589;\n                    mem_fence_global();\n                    old_counter_324603 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324563)[sext_i32_i64(srem32(flat_segment_id_324581,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_324576)[(int64_t) 0] =\n                        old_counter_324603 == groups_per_segment_324552 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_324604;\n            \n            is_last_group_324604 = ((__local\n                                     bool *) sync_arr_mem_324576)[(int64_t) 0];\n            if (is_last_group_324604) {\n                if (local_tid_324566 == 0) {\n                    old_counter_324603 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324563)[sext_i32_i64(srem32(flat_segment_id_324581,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_32",
            "4552));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_324605 =\n                            sdiv_up64(groups_per_segment_324552,\n                                      segred_group_sizze_315385);\n                    \n                    x_315395 = 0.0;\n                    x_315396 = 0.0;\n                    x_315397 = 0.0;\n                    for (int64_t i_324606 = 0; i_324606 <\n                         read_per_thread_324605; i_324606++) {\n                        int64_t group_res_id_324607 =\n                                sext_i32_i64(local_tid_324566) *\n                                read_per_thread_324605 + i_324606;\n                        int64_t index_of_group_res_324608 =\n                                sext_i32_i64(flat_segment_id_324581) *\n                                groups_per_segment_324552 + group_res_id_324607;\n                        \n                        if (slt64(group_res_id_324607,\n                                  groups_per_segment_324552)) {\n                            x_315398 = ((__global\n                                         double *) segred_tmp_mem_324557)[index_of_group_res_324608];\n                            x_315399 = ((__global\n                                         double *) segred_tmp_mem_324559)[index_of_group_res_324608];\n                            x_315400 = ((__global\n                                         double *) segred_tmp_mem_324561)[index_of_group_res_324608];\n                            \n                            double defunc_1_op_res_315401 = x_315395 + x_315398;\n                            double defunc_1_op_res_315402 = x_315396 + x_315399;\n                            double defunc_1_op_res_315403 = x_315397 + x_315400;\n                            \n                            x_315395 = defunc_1_op_res_315401;\n                            x_315396 = defunc_1_op_res_315402;\n                            x_315397 = defunc_1_",
            "op_res_315403;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_324570)[sext_i32_i64(local_tid_324566)] =\n                    x_315395;\n                ((__local\n                  double *) red_arr_mem_324572)[sext_i32_i64(local_tid_324566)] =\n                    x_315396;\n                ((__local\n                  double *) red_arr_mem_324574)[sext_i32_i64(local_tid_324566)] =\n                    x_315397;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_324609;\n                    int32_t skip_waves_324610 = 1;\n                    double x_324591;\n                    double x_324592;\n                    double x_324593;\n                    double x_324594;\n                    double x_324595;\n                    double x_324596;\n                    \n                    offset_324609 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_324566,\n                                  sext_i64_i32(segred_group_sizze_315385))) {\n                            x_324591 = ((__local\n                                         double *) red_arr_mem_324570)[sext_i32_i64(local_tid_324566 +\n                                                                       offset_324609)];\n                            x_324592 = ((__local\n                                         double *) red_arr_mem_324572)[sext_i32_i64(local_tid_324566 +\n                                                                       offset_324609)];\n                            x_324593 = ((__local\n                                         double *) red_arr_mem_324574)[sext_i32_i64(local_tid_324566 +\n                                                                       offset_324609)];\n                        }\n                    }\n                    offset_",
            "324609 = 1;\n                    while (slt32(offset_324609, wave_sizze_324568)) {\n                        if (slt32(local_tid_324566 + offset_324609,\n                                  sext_i64_i32(segred_group_sizze_315385)) &&\n                            ((local_tid_324566 - squot32(local_tid_324566,\n                                                         wave_sizze_324568) *\n                              wave_sizze_324568) & (2 * offset_324609 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_324594 = ((volatile __local\n                                             double *) red_arr_mem_324570)[sext_i32_i64(local_tid_324566 +\n                                                                           offset_324609)];\n                                x_324595 = ((volatile __local\n                                             double *) red_arr_mem_324572)[sext_i32_i64(local_tid_324566 +\n                                                                           offset_324609)];\n                                x_324596 = ((volatile __local\n                                             double *) red_arr_mem_324574)[sext_i32_i64(local_tid_324566 +\n                                                                           offset_324609)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_324597 = x_324591 +\n                                       x_324594;\n                                double defunc_1_op_res_324598 = x_324592 +\n                                       x_324595;\n                                double defunc_1_op_res_324599 = x_324593 +\n                                       x_324596;\n                                \n                                x_324591 = defunc_1_op_res_324597;\n                                x_324592 = defunc_1_op_",
            "res_324598;\n                                x_324593 = defunc_1_op_res_324599;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_324570)[sext_i32_i64(local_tid_324566)] =\n                                    x_324591;\n                                ((volatile __local\n                                  double *) red_arr_mem_324572)[sext_i32_i64(local_tid_324566)] =\n                                    x_324592;\n                                ((volatile __local\n                                  double *) red_arr_mem_324574)[sext_i32_i64(local_tid_324566)] =\n                                    x_324593;\n                            }\n                        }\n                        offset_324609 *= 2;\n                    }\n                    while (slt32(skip_waves_324610,\n                                 squot32(sext_i64_i32(segred_group_sizze_315385) +\n                                         wave_sizze_324568 - 1,\n                                         wave_sizze_324568))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_324609 = skip_waves_324610 * wave_sizze_324568;\n                        if (slt32(local_tid_324566 + offset_324609,\n                                  sext_i64_i32(segred_group_sizze_315385)) &&\n                            ((local_tid_324566 - squot32(local_tid_324566,\n                                                         wave_sizze_324568) *\n                              wave_sizze_324568) == 0 &&\n                             (squot32(local_tid_324566, wave_sizze_324568) &\n                              (2 * skip_waves_324610 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_324594 = ((__local\n                                             double *) red_arr_mem_",
            "324570)[sext_i32_i64(local_tid_324566 +\n                                                                           offset_324609)];\n                                x_324595 = ((__local\n                                             double *) red_arr_mem_324572)[sext_i32_i64(local_tid_324566 +\n                                                                           offset_324609)];\n                                x_324596 = ((__local\n                                             double *) red_arr_mem_324574)[sext_i32_i64(local_tid_324566 +\n                                                                           offset_324609)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_324597 = x_324591 +\n                                       x_324594;\n                                double defunc_1_op_res_324598 = x_324592 +\n                                       x_324595;\n                                double defunc_1_op_res_324599 = x_324593 +\n                                       x_324596;\n                                \n                                x_324591 = defunc_1_op_res_324597;\n                                x_324592 = defunc_1_op_res_324598;\n                                x_324593 = defunc_1_op_res_324599;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_324570)[sext_i32_i64(local_tid_324566)] =\n                                    x_324591;\n                                ((__local\n                                  double *) red_arr_mem_324572)[sext_i32_i64(local_tid_324566)] =\n                                    x_324592;\n                                ((__local\n                                  double *) red_arr_mem_324574)[sext_i32_i64(local_tid_324566)] =\n            ",
            "                        x_324593;\n                            }\n                        }\n                        skip_waves_324610 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_324566 == 0) {\n                            ((__global double *) mem_319996)[gtid_315391 *\n                                                             t_n_m_292839 +\n                                                             gtid_315392] =\n                                x_324591;\n                            ((__global double *) mem_320000)[gtid_315391 *\n                                                             t_n_m_292839 +\n                                                             gtid_315392] =\n                                x_324592;\n                            ((__global double *) mem_320004)[gtid_315391 *\n                                                             t_n_m_292839 +\n                                                             gtid_315392] =\n                                x_324593;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_315385\n}\n__kernel void mainzisegred_large_315469(__global int *global_failure,\n                                        uint sync_arr_mem_324677_backing_offset_0,\n                                        uint red_arr_mem_324675_backing_offset_1,\n                                        uint red_arr_mem_324673_backing_offset_2,\n                                        int64_t n_292675, int64_t q_t_292679,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t t_n_m_292839, int64_t i_292846,\n                                        int64_t num_groups_3",
            "15462,\n                                        int64_t groups_per_segment_324657,\n                                        int64_t elements_per_thread_324658,\n                                        int64_t virt_num_groups_324659,\n                                        int64_t threads_per_segment_324661,\n                                        __global unsigned char *ext_mem_318541,\n                                        __global unsigned char *ext_mem_318542,\n                                        __global unsigned char *ext_mem_318805,\n                                        __global unsigned char *ext_mem_318806,\n                                        __global unsigned char *mem_319987,\n                                        __global unsigned char *mem_319991,\n                                        __global unsigned char *mem_320009,\n                                        __global unsigned char *mem_320013,\n                                        __global unsigned char *mem_320017,\n                                        __global unsigned char *mem_320022,\n                                        __global unsigned char *mem_320026,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324662,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324664,\n                                        __global\n                                        unsigned char *mainzicounter_mem_324666)\n{\n    #define segred_group_sizze_315461 (mainzisegred_group_sizze_314910)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_324677_backing_2 =\n                           &shared_mem[sync_arr_mem_324677_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324675_backing_1 =\n                           &shared_mem[red_arr_mem_324675_backing_offset_1];\n    volatile un",
            "signed char *red_arr_mem_324673_backing_0 =\n                           &shared_mem[red_arr_mem_324673_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324668;\n    int32_t local_tid_324669;\n    int64_t group_sizze_324672;\n    int32_t wave_sizze_324671;\n    int32_t group_tid_324670;\n    \n    global_tid_324668 = get_global_id(0);\n    local_tid_324669 = get_local_id(0);\n    group_sizze_324672 = get_local_size(0);\n    wave_sizze_324671 = LOCKSTEP_WIDTH;\n    group_tid_324670 = get_group_id(0);\n    \n    int32_t phys_tid_315469 = global_tid_324668;\n    __local unsigned char *red_arr_mem_324673;\n    \n    red_arr_mem_324673 = (__local unsigned char *) red_arr_mem_324673_backing_0;\n    \n    __local unsigned char *red_arr_mem_324675;\n    \n    red_arr_mem_324675 = (__local unsigned char *) red_arr_mem_324675_backing_1;\n    \n    __local unsigned char *sync_arr_mem_324677;\n    \n    sync_arr_mem_324677 = (__local\n                           unsigned char *) sync_arr_mem_324677_backing_2;\n    \n    int32_t phys_group_id_324679;\n    \n    phys_group_id_324679 = get_group_id(0);\n    for (int32_t i_324680 = 0; i_324680 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_324659) - phys_group_id_324679,\n                   sext_i64_i32(num_groups_315462)); i_324680++) {\n        int32_t virt_group_id_324681 = phys_group_id_324679 + i_324680 *\n                sext_i64_i32(num_groups_315462);\n        int32_t flat_segment_id_324682 = squot32(virt_group_id_324681,\n                                                 sext_i64_i32(groups_per_segment_324657));\n        int64_t global_tid_324683 = srem64(sext_i32_i64(virt_group_id_324681) *\n                                           segred_group_sizze_315461 +\n                                           sext_i32_i64(local_tid_324669),\n                                           segred_group_sizze_315461 *\n                                           groups_per_segment_324657);\n        int64_t slice_324684 = t_n_m",
            "_292839;\n        int64_t slice_324685 = partition_sizze_292766 * slice_324684;\n        int64_t gtid_315466 = squot64(sext_i32_i64(flat_segment_id_324682),\n                                      slice_324684);\n        int64_t remnant_324686 = sext_i32_i64(flat_segment_id_324682) -\n                gtid_315466 * slice_324684;\n        int64_t gtid_315467 = remnant_324686;\n        int64_t remnant_324687 = remnant_324686 - gtid_315467;\n        int64_t gtid_315468;\n        double x_acc_324688;\n        double x_acc_324689;\n        int64_t chunk_sizze_324690 = smin64(elements_per_thread_324658,\n                                            sdiv_up64(q_t_292679 -\n                                                      global_tid_324683,\n                                                      threads_per_segment_324661));\n        double x_315470;\n        double x_315471;\n        double x_315472;\n        double x_315473;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_324688 = 0.0;\n            x_acc_324689 = 0.0;\n        }\n        for (int64_t i_324697 = 0; i_324697 < chunk_sizze_324690; i_324697++) {\n            gtid_315468 = global_tid_324683 + threads_per_segment_324661 *\n                i_324697;\n            // apply map function\n            {\n                int64_t x_315477;\n                \n                x_315477 = ((__global int64_t *) ext_mem_318541)[gtid_315466];\n                \n                int64_t x_315486;\n                \n                x_315486 = ((__global int64_t *) ext_mem_318806)[gtid_315466 *\n                                                                 t_n_m_292839 +\n                                                                 gtid_315467];\n                \n                double x_315487;\n                \n                x_315487 = ((__global double *) ext_mem_318805)[gtid_315466 *\n                                                                t_n_m_292839 +\n                                                       ",
            "         gtid_315467];\n                \n                int64_t binop_y_317877 = mul64(jump_t_292685, gtid_315467);\n                int64_t binop_y_317878 = smin64(i_292846, binop_y_317877);\n                int64_t index_primexp_317879 = add64((int64_t) 1,\n                                                     binop_y_317878);\n                double a11_315489;\n                \n                a11_315489 = ((__global double *) mem_320009)[gtid_315466 *\n                                                              t_n_m_292839 +\n                                                              gtid_315467];\n                \n                double b11_315490;\n                \n                b11_315490 = ((__global double *) mem_320013)[gtid_315466 *\n                                                              t_n_m_292839 +\n                                                              gtid_315467];\n                \n                double c11_315491;\n                \n                c11_315491 = ((__global double *) mem_320017)[gtid_315466 *\n                                                              t_n_m_292839 +\n                                                              gtid_315467];\n                \n                bool cond_315493 = sle64(x_315477, gtid_315468);\n                int64_t defunc_0_f_res_315494;\n                \n                if (cond_315493) {\n                    defunc_0_f_res_315494 = (int64_t) 0;\n                } else {\n                    int64_t i_315495 = add64(gtid_315468, x_315486);\n                    int64_t defunc_0_add_arg_315496;\n                    \n                    defunc_0_add_arg_315496 = ((__global\n                                                int64_t *) ext_mem_318542)[gtid_315466 *\n                                                                           n_292675 +\n                                                                           i_315495];\n                    \n                    int64_t defunc_1_add_res_315497",
            " = add64((int64_t) 1,\n                                                            defunc_0_add_arg_315496);\n                    \n                    defunc_0_f_res_315494 = defunc_1_add_res_315497;\n                }\n                \n                double defunc_0_f_res_315498;\n                \n                if (cond_315493) {\n                    defunc_0_f_res_315498 = 0.0;\n                } else {\n                    int64_t i_315499 = add64(gtid_315468, x_315486);\n                    double defunc_0_add_arg_315500;\n                    \n                    defunc_0_add_arg_315500 = ((__global\n                                                double *) mem_319987)[gtid_315466 *\n                                                                      n_292675 +\n                                                                      i_315499];\n                    defunc_0_f_res_315498 = defunc_0_add_arg_315500;\n                }\n                \n                int64_t binop_p_315501 = sub64(defunc_0_f_res_315494,\n                                               index_primexp_317879);\n                double defunc_0_f_res_315502 = sitofp_i64_f64(binop_p_315501);\n                double abs_res_315503 = fabs(defunc_0_f_res_315502);\n                double tmp1_315504 = abs_res_315503 / x_315487;\n                double x_315505 = tmp1_315504 * tmp1_315504;\n                double y_315506 = tmp1_315504 * x_315505;\n                double tmp2_315507 = 1.0 - y_315506;\n                double x_315508 = tmp2_315507 * tmp2_315507;\n                double tmp3_315509 = tmp2_315507 * x_315508;\n                double tmp4_315510 = defunc_0_f_res_315498 * tmp3_315509;\n                double defunc_1_f_res_315511 = defunc_0_f_res_315502 *\n                       tmp4_315510;\n                double defunc_0_f_res_315512;\n                \n                if (cond_315493) {\n                    defunc_0_f_res_315512 = 0.0;\n                } else {\n                    int64_t i_315513 = add64(gt",
            "id_315468, x_315486);\n                    double defunc_0_add_arg_315514;\n                    \n                    defunc_0_add_arg_315514 = ((__global\n                                                double *) mem_319991)[gtid_315466 *\n                                                                      n_292675 +\n                                                                      i_315513];\n                    defunc_0_f_res_315512 = defunc_0_add_arg_315514;\n                }\n                \n                double x_315515 = a11_315489 * tmp4_315510;\n                double y_315516 = b11_315490 * defunc_1_f_res_315511;\n                double x_315517 = x_315515 + y_315516;\n                double defunc_9_fit_fun_res_315518 = defunc_0_f_res_315512 *\n                       x_315517;\n                double x_315519 = b11_315490 * tmp4_315510;\n                double y_315520 = c11_315491 * defunc_1_f_res_315511;\n                double x_315521 = x_315519 + y_315520;\n                double defunc_9_slope_fun_res_315522 = defunc_0_f_res_315512 *\n                       x_315521;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_315470 = x_acc_324688;\n                    x_315471 = x_acc_324689;\n                }\n                // load new values\n                {\n                    x_315472 = defunc_9_fit_fun_res_315518;\n                    x_315473 = defunc_9_slope_fun_res_315522;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_315474 = x_315470 + x_315472;\n                    double defunc_1_op_res_315475 = x_315471 + x_315473;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_324688 = defunc_1_op_res_315474;\n                        x_acc_324689 = defunc_1_op_res_315475;\n                    }\n                }\n            }",
            "\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_315470 = x_acc_324688;\n            x_315471 = x_acc_324689;\n            ((__local\n              double *) red_arr_mem_324673)[sext_i32_i64(local_tid_324669)] =\n                x_315470;\n            ((__local\n              double *) red_arr_mem_324675)[sext_i32_i64(local_tid_324669)] =\n                x_315471;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_324698;\n        int32_t skip_waves_324699 = 1;\n        double x_324691;\n        double x_324692;\n        double x_324693;\n        double x_324694;\n        \n        offset_324698 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_324669,\n                      sext_i64_i32(segred_group_sizze_315461))) {\n                x_324691 = ((__local\n                             double *) red_arr_mem_324673)[sext_i32_i64(local_tid_324669 +\n                                                           offset_324698)];\n                x_324692 = ((__local\n                             double *) red_arr_mem_324675)[sext_i32_i64(local_tid_324669 +\n                                                           offset_324698)];\n            }\n        }\n        offset_324698 = 1;\n        while (slt32(offset_324698, wave_sizze_324671)) {\n            if (slt32(local_tid_324669 + offset_324698,\n                      sext_i64_i32(segred_group_sizze_315461)) &&\n                ((local_tid_324669 - squot32(local_tid_324669,\n                                             wave_sizze_324671) *\n                  wave_sizze_324671) & (2 * offset_324698 - 1)) == 0) {\n                // read array element\n                {\n                    x_324693 = ((volatile __local\n                                 double *) red_arr_mem_324673)[sext_i32_i64(local_tid_324669 +\n                                                               offset_324698)];\n                    x_3246",
            "94 = ((volatile __local\n                                 double *) red_arr_mem_324675)[sext_i32_i64(local_tid_324669 +\n                                                               offset_324698)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324695 = x_324691 + x_324693;\n                    double defunc_1_op_res_324696 = x_324692 + x_324694;\n                    \n                    x_324691 = defunc_1_op_res_324695;\n                    x_324692 = defunc_1_op_res_324696;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_324673)[sext_i32_i64(local_tid_324669)] =\n                        x_324691;\n                    ((volatile __local\n                      double *) red_arr_mem_324675)[sext_i32_i64(local_tid_324669)] =\n                        x_324692;\n                }\n            }\n            offset_324698 *= 2;\n        }\n        while (slt32(skip_waves_324699,\n                     squot32(sext_i64_i32(segred_group_sizze_315461) +\n                             wave_sizze_324671 - 1, wave_sizze_324671))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_324698 = skip_waves_324699 * wave_sizze_324671;\n            if (slt32(local_tid_324669 + offset_324698,\n                      sext_i64_i32(segred_group_sizze_315461)) &&\n                ((local_tid_324669 - squot32(local_tid_324669,\n                                             wave_sizze_324671) *\n                  wave_sizze_324671) == 0 && (squot32(local_tid_324669,\n                                                      wave_sizze_324671) & (2 *\n                                                                            skip_waves_324699 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n              ",
            "      x_324693 = ((__local\n                                 double *) red_arr_mem_324673)[sext_i32_i64(local_tid_324669 +\n                                                               offset_324698)];\n                    x_324694 = ((__local\n                                 double *) red_arr_mem_324675)[sext_i32_i64(local_tid_324669 +\n                                                               offset_324698)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324695 = x_324691 + x_324693;\n                    double defunc_1_op_res_324696 = x_324692 + x_324694;\n                    \n                    x_324691 = defunc_1_op_res_324695;\n                    x_324692 = defunc_1_op_res_324696;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_324673)[sext_i32_i64(local_tid_324669)] =\n                        x_324691;\n                    ((__local\n                      double *) red_arr_mem_324675)[sext_i32_i64(local_tid_324669)] =\n                        x_324692;\n                }\n            }\n            skip_waves_324699 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_324669) == (int64_t) 0) {\n                x_acc_324688 = x_324691;\n                x_acc_324689 = x_324692;\n            }\n        }\n        if (groups_per_segment_324657 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_324669 == 0) {\n                    ((__global double *) mem_320022)[gtid_315466 *\n                                                     t_n_m_292839 +\n                                                     gtid_315467] =\n                        x_acc_324688;\n                    ((__global double *) mem_320026)[gtid_315466 *\n ",
            "                                                    t_n_m_292839 +\n                                                     gtid_315467] =\n                        x_acc_324689;\n                }\n            }\n        } else {\n            int32_t old_counter_324700;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_324669 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_324662)[sext_i32_i64(virt_group_id_324681)] =\n                        x_acc_324688;\n                    ((__global\n                      double *) segred_tmp_mem_324664)[sext_i32_i64(virt_group_id_324681)] =\n                        x_acc_324689;\n                    mem_fence_global();\n                    old_counter_324700 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324666)[sext_i32_i64(srem32(flat_segment_id_324682,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_324677)[(int64_t) 0] =\n                        old_counter_324700 == groups_per_segment_324657 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_324701;\n            \n            is_last_group_324701 = ((__local\n                                     bool *) sync_arr_mem_324677)[(int64_t) 0];\n            if (is_last_group_324701) {\n                if (local_tid_324669 == 0) {\n                    old_counter_324700 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324666)[sext_i32_i64(srem32(flat_segment_id_324682,\n                                    ",
            "                                                                  10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_324657));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_324702 =\n                            sdiv_up64(groups_per_segment_324657,\n                                      segred_group_sizze_315461);\n                    \n                    x_315470 = 0.0;\n                    x_315471 = 0.0;\n                    for (int64_t i_324703 = 0; i_324703 <\n                         read_per_thread_324702; i_324703++) {\n                        int64_t group_res_id_324704 =\n                                sext_i32_i64(local_tid_324669) *\n                                read_per_thread_324702 + i_324703;\n                        int64_t index_of_group_res_324705 =\n                                sext_i32_i64(flat_segment_id_324682) *\n                                groups_per_segment_324657 + group_res_id_324704;\n                        \n                        if (slt64(group_res_id_324704,\n                                  groups_per_segment_324657)) {\n                            x_315472 = ((__global\n                                         double *) segred_tmp_mem_324662)[index_of_group_res_324705];\n                            x_315473 = ((__global\n                                         double *) segred_tmp_mem_324664)[index_of_group_res_324705];\n                            \n                            double defunc_1_op_res_315474 = x_315470 + x_315472;\n                            double defunc_1_op_res_315475 = x_315471 + x_315473;\n                            \n                            x_315470 = defunc_1_op_res_315474;\n                            x_315471 = defunc_1_op_res_315475;\n                        }\n                    }\n                }\n                ((__local\n        ",
            "          double *) red_arr_mem_324673)[sext_i32_i64(local_tid_324669)] =\n                    x_315470;\n                ((__local\n                  double *) red_arr_mem_324675)[sext_i32_i64(local_tid_324669)] =\n                    x_315471;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_324706;\n                    int32_t skip_waves_324707 = 1;\n                    double x_324691;\n                    double x_324692;\n                    double x_324693;\n                    double x_324694;\n                    \n                    offset_324706 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_324669,\n                                  sext_i64_i32(segred_group_sizze_315461))) {\n                            x_324691 = ((__local\n                                         double *) red_arr_mem_324673)[sext_i32_i64(local_tid_324669 +\n                                                                       offset_324706)];\n                            x_324692 = ((__local\n                                         double *) red_arr_mem_324675)[sext_i32_i64(local_tid_324669 +\n                                                                       offset_324706)];\n                        }\n                    }\n                    offset_324706 = 1;\n                    while (slt32(offset_324706, wave_sizze_324671)) {\n                        if (slt32(local_tid_324669 + offset_324706,\n                                  sext_i64_i32(segred_group_sizze_315461)) &&\n                            ((local_tid_324669 - squot32(local_tid_324669,\n                                                         wave_sizze_324671) *\n                              wave_sizze_324671) & (2 * offset_324706 - 1)) ==\n                            0) {\n                            // read array element\n                        ",
            "    {\n                                x_324693 = ((volatile __local\n                                             double *) red_arr_mem_324673)[sext_i32_i64(local_tid_324669 +\n                                                                           offset_324706)];\n                                x_324694 = ((volatile __local\n                                             double *) red_arr_mem_324675)[sext_i32_i64(local_tid_324669 +\n                                                                           offset_324706)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_324695 = x_324691 +\n                                       x_324693;\n                                double defunc_1_op_res_324696 = x_324692 +\n                                       x_324694;\n                                \n                                x_324691 = defunc_1_op_res_324695;\n                                x_324692 = defunc_1_op_res_324696;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_324673)[sext_i32_i64(local_tid_324669)] =\n                                    x_324691;\n                                ((volatile __local\n                                  double *) red_arr_mem_324675)[sext_i32_i64(local_tid_324669)] =\n                                    x_324692;\n                            }\n                        }\n                        offset_324706 *= 2;\n                    }\n                    while (slt32(skip_waves_324707,\n                                 squot32(sext_i64_i32(segred_group_sizze_315461) +\n                                         wave_sizze_324671 - 1,\n                                         wave_sizze_324671))) {\n                        barrier(CLK_LOCAL_MEM_FE",
            "NCE);\n                        offset_324706 = skip_waves_324707 * wave_sizze_324671;\n                        if (slt32(local_tid_324669 + offset_324706,\n                                  sext_i64_i32(segred_group_sizze_315461)) &&\n                            ((local_tid_324669 - squot32(local_tid_324669,\n                                                         wave_sizze_324671) *\n                              wave_sizze_324671) == 0 &&\n                             (squot32(local_tid_324669, wave_sizze_324671) &\n                              (2 * skip_waves_324707 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_324693 = ((__local\n                                             double *) red_arr_mem_324673)[sext_i32_i64(local_tid_324669 +\n                                                                           offset_324706)];\n                                x_324694 = ((__local\n                                             double *) red_arr_mem_324675)[sext_i32_i64(local_tid_324669 +\n                                                                           offset_324706)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_324695 = x_324691 +\n                                       x_324693;\n                                double defunc_1_op_res_324696 = x_324692 +\n                                       x_324694;\n                                \n                                x_324691 = defunc_1_op_res_324695;\n                                x_324692 = defunc_1_op_res_324696;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_324673)[sext_i32_i64(local_tid_324669)] =\n                                    x_324",
            "691;\n                                ((__local\n                                  double *) red_arr_mem_324675)[sext_i32_i64(local_tid_324669)] =\n                                    x_324692;\n                            }\n                        }\n                        skip_waves_324707 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_324669 == 0) {\n                            ((__global double *) mem_320022)[gtid_315466 *\n                                                             t_n_m_292839 +\n                                                             gtid_315467] =\n                                x_324691;\n                            ((__global double *) mem_320026)[gtid_315466 *\n                                                             t_n_m_292839 +\n                                                             gtid_315467] =\n                                x_324692;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_315461\n}\n__kernel void mainzisegred_large_316122(__global int *global_failure,\n                                        uint sync_arr_mem_324814_backing_offset_0,\n                                        uint red_arr_mem_324812_backing_offset_1,\n                                        uint red_arr_mem_324810_backing_offset_2,\n                                        uint red_arr_mem_324808_backing_offset_3,\n                                        uint red_arr_mem_324806_backing_offset_4,\n                                        uint red_arr_mem_324804_backing_offset_5,\n                                        int64_t n_292675, int64_t q_t_292679,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n      ",
            "                                  int64_t t_n_m_292839, int64_t i_292846,\n                                        int64_t num_groups_316112,\n                                        int64_t groups_per_segment_324782,\n                                        int64_t elements_per_thread_324783,\n                                        int64_t virt_num_groups_324784,\n                                        int64_t threads_per_segment_324786,\n                                        __global unsigned char *ext_mem_318541,\n                                        __global unsigned char *ext_mem_318542,\n                                        __global unsigned char *ext_mem_318805,\n                                        __global unsigned char *ext_mem_318806,\n                                        __global unsigned char *mem_320036,\n                                        __global unsigned char *mem_320045,\n                                        __global unsigned char *mem_320049,\n                                        __global unsigned char *mem_320053,\n                                        __global unsigned char *mem_320057,\n                                        __global unsigned char *mem_320061,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324787,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324789,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324791,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324793,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324795,\n                                        __global\n                                        unsigned char *mainzicounter_mem_324797)\n{\n    #define segre",
            "d_group_sizze_316111 (mainzisegred_group_sizze_315686)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_324814_backing_5 =\n                           &shared_mem[sync_arr_mem_324814_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324812_backing_4 =\n                           &shared_mem[red_arr_mem_324812_backing_offset_1];\n    volatile unsigned char *red_arr_mem_324810_backing_3 =\n                           &shared_mem[red_arr_mem_324810_backing_offset_2];\n    volatile unsigned char *red_arr_mem_324808_backing_2 =\n                           &shared_mem[red_arr_mem_324808_backing_offset_3];\n    volatile unsigned char *red_arr_mem_324806_backing_1 =\n                           &shared_mem[red_arr_mem_324806_backing_offset_4];\n    volatile unsigned char *red_arr_mem_324804_backing_0 =\n                           &shared_mem[red_arr_mem_324804_backing_offset_5];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324799;\n    int32_t local_tid_324800;\n    int64_t group_sizze_324803;\n    int32_t wave_sizze_324802;\n    int32_t group_tid_324801;\n    \n    global_tid_324799 = get_global_id(0);\n    local_tid_324800 = get_local_id(0);\n    group_sizze_324803 = get_local_size(0);\n    wave_sizze_324802 = LOCKSTEP_WIDTH;\n    group_tid_324801 = get_group_id(0);\n    \n    int32_t phys_tid_316122 = global_tid_324799;\n    __local unsigned char *red_arr_mem_324804;\n    \n    red_arr_mem_324804 = (__local unsigned char *) red_arr_mem_324804_backing_0;\n    \n    __local unsigned char *red_arr_mem_324806;\n    \n    red_arr_mem_324806 = (__local unsigned char *) red_arr_mem_324806_backing_1;\n    \n    __local unsigned char *red_arr_mem_324808;\n    \n    red_arr_mem_324808 = (__local unsigned char *) red_arr_mem_324808_backing_2;\n    \n    __local unsigned char *red_arr_mem_324810;\n    \n    red_arr_mem_324810 = (__local unsigned char *) red_arr_mem_324810_backing_3;\n    \n    _",
            "_local unsigned char *red_arr_mem_324812;\n    \n    red_arr_mem_324812 = (__local unsigned char *) red_arr_mem_324812_backing_4;\n    \n    __local unsigned char *sync_arr_mem_324814;\n    \n    sync_arr_mem_324814 = (__local\n                           unsigned char *) sync_arr_mem_324814_backing_5;\n    \n    int32_t phys_group_id_324816;\n    \n    phys_group_id_324816 = get_group_id(0);\n    for (int32_t i_324817 = 0; i_324817 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_324784) - phys_group_id_324816,\n                   sext_i64_i32(num_groups_316112)); i_324817++) {\n        int32_t virt_group_id_324818 = phys_group_id_324816 + i_324817 *\n                sext_i64_i32(num_groups_316112);\n        int32_t flat_segment_id_324819 = squot32(virt_group_id_324818,\n                                                 sext_i64_i32(groups_per_segment_324782));\n        int64_t global_tid_324820 = srem64(sext_i32_i64(virt_group_id_324818) *\n                                           segred_group_sizze_316111 +\n                                           sext_i32_i64(local_tid_324800),\n                                           segred_group_sizze_316111 *\n                                           groups_per_segment_324782);\n        int64_t slice_324821 = t_n_m_292839;\n        int64_t slice_324822 = partition_sizze_292766 * slice_324821;\n        int64_t gtid_316119 = squot64(sext_i32_i64(flat_segment_id_324819),\n                                      slice_324821);\n        int64_t remnant_324823 = sext_i32_i64(flat_segment_id_324819) -\n                gtid_316119 * slice_324821;\n        int64_t gtid_316120 = remnant_324823;\n        int64_t remnant_324824 = remnant_324823 - gtid_316120;\n        int64_t gtid_316121;\n        double x_acc_324825;\n        double x_acc_324826;\n        double x_acc_324827;\n        double x_acc_324828;\n        double x_acc_324829;\n        int64_t chunk_sizze_324830 = smin64(elements_per_thread_324783,\n                                            sdiv_up64(q_t_29",
            "2679 -\n                                                      global_tid_324820,\n                                                      threads_per_segment_324786));\n        double x_316123;\n        double x_316124;\n        double x_316125;\n        double x_316126;\n        double x_316127;\n        double x_316128;\n        double x_316129;\n        double x_316130;\n        double x_316131;\n        double x_316132;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_324825 = 0.0;\n            x_acc_324826 = 0.0;\n            x_acc_324827 = 0.0;\n            x_acc_324828 = 0.0;\n            x_acc_324829 = 0.0;\n        }\n        for (int64_t i_324846 = 0; i_324846 < chunk_sizze_324830; i_324846++) {\n            gtid_316121 = global_tid_324820 + threads_per_segment_324786 *\n                i_324846;\n            // apply map function\n            {\n                int64_t x_316139;\n                \n                x_316139 = ((__global int64_t *) ext_mem_318541)[gtid_316119];\n                \n                int64_t x_316144;\n                \n                x_316144 = ((__global int64_t *) ext_mem_318806)[gtid_316119 *\n                                                                 t_n_m_292839 +\n                                                                 gtid_316120];\n                \n                double x_316145;\n                \n                x_316145 = ((__global double *) ext_mem_318805)[gtid_316119 *\n                                                                t_n_m_292839 +\n                                                                gtid_316120];\n                \n                int64_t binop_y_317892 = mul64(jump_t_292685, gtid_316120);\n                int64_t binop_y_317893 = smin64(i_292846, binop_y_317892);\n                int64_t index_primexp_317894 = add64((int64_t) 1,\n                                                     binop_y_317893);\n                bool cond_316148 = sle64(x_316139, gtid_316121);\n              ",
            "  int64_t defunc_0_f_res_316149;\n                \n                if (cond_316148) {\n                    defunc_0_f_res_316149 = (int64_t) 0;\n                } else {\n                    int64_t i_316150 = add64(gtid_316121, x_316144);\n                    int64_t defunc_0_add_arg_316151;\n                    \n                    defunc_0_add_arg_316151 = ((__global\n                                                int64_t *) ext_mem_318542)[gtid_316119 *\n                                                                           n_292675 +\n                                                                           i_316150];\n                    \n                    int64_t defunc_1_add_res_316152 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_316151);\n                    \n                    defunc_0_f_res_316149 = defunc_1_add_res_316152;\n                }\n                \n                double defunc_0_f_res_316153;\n                \n                if (cond_316148) {\n                    defunc_0_f_res_316153 = 0.0;\n                } else {\n                    int64_t i_316154 = add64(gtid_316121, x_316144);\n                    double defunc_0_add_arg_316155;\n                    \n                    defunc_0_add_arg_316155 = ((__global\n                                                double *) mem_320036)[gtid_316119 *\n                                                                      n_292675 +\n                                                                      i_316154];\n                    defunc_0_f_res_316153 = defunc_0_add_arg_316155;\n                }\n                \n                int64_t binop_p_316156 = sub64(defunc_0_f_res_316149,\n                                               index_primexp_317894);\n                double defunc_0_f_res_316157 = sitofp_i64_f64(binop_p_316156);\n                double abs_res_316158 = fabs(defunc_0_f_res_316157);\n                double tmp1_316159 = abs_res_316158 / x_31",
            "6145;\n                double x_316160 = tmp1_316159 * tmp1_316159;\n                double y_316161 = tmp1_316159 * x_316160;\n                double tmp2_316162 = 1.0 - y_316161;\n                double x_316163 = tmp2_316162 * tmp2_316162;\n                double tmp3_316164 = tmp2_316162 * x_316163;\n                double w_j_316165 = defunc_0_f_res_316153 * tmp3_316164;\n                double xw_j_316166 = defunc_0_f_res_316157 * w_j_316165;\n                double x2w_j_316167 = defunc_0_f_res_316157 * xw_j_316166;\n                double x3w_j_316168 = defunc_0_f_res_316157 * x2w_j_316167;\n                double x4w_j_316169 = defunc_0_f_res_316157 * x3w_j_316168;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_316123 = x_acc_324825;\n                    x_316124 = x_acc_324826;\n                    x_316125 = x_acc_324827;\n                    x_316126 = x_acc_324828;\n                    x_316127 = x_acc_324829;\n                }\n                // load new values\n                {\n                    x_316128 = w_j_316165;\n                    x_316129 = xw_j_316166;\n                    x_316130 = x2w_j_316167;\n                    x_316131 = x3w_j_316168;\n                    x_316132 = x4w_j_316169;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_316133 = x_316123 + x_316128;\n                    double defunc_1_op_res_316134 = x_316124 + x_316129;\n                    double defunc_1_op_res_316135 = x_316125 + x_316130;\n                    double defunc_1_op_res_316136 = x_316126 + x_316131;\n                    double defunc_1_op_res_316137 = x_316127 + x_316132;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_324825 = defunc_1_op_res_316133;\n                        x_acc_324826 = defunc_1_op_res_316134;\n                    ",
            "    x_acc_324827 = defunc_1_op_res_316135;\n                        x_acc_324828 = defunc_1_op_res_316136;\n                        x_acc_324829 = defunc_1_op_res_316137;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_316123 = x_acc_324825;\n            x_316124 = x_acc_324826;\n            x_316125 = x_acc_324827;\n            x_316126 = x_acc_324828;\n            x_316127 = x_acc_324829;\n            ((__local\n              double *) red_arr_mem_324804)[sext_i32_i64(local_tid_324800)] =\n                x_316123;\n            ((__local\n              double *) red_arr_mem_324806)[sext_i32_i64(local_tid_324800)] =\n                x_316124;\n            ((__local\n              double *) red_arr_mem_324808)[sext_i32_i64(local_tid_324800)] =\n                x_316125;\n            ((__local\n              double *) red_arr_mem_324810)[sext_i32_i64(local_tid_324800)] =\n                x_316126;\n            ((__local\n              double *) red_arr_mem_324812)[sext_i32_i64(local_tid_324800)] =\n                x_316127;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_324847;\n        int32_t skip_waves_324848 = 1;\n        double x_324831;\n        double x_324832;\n        double x_324833;\n        double x_324834;\n        double x_324835;\n        double x_324836;\n        double x_324837;\n        double x_324838;\n        double x_324839;\n        double x_324840;\n        \n        offset_324847 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_324800,\n                      sext_i64_i32(segred_group_sizze_316111))) {\n                x_324831 = ((__local\n                             double *) red_arr_mem_324804)[sext_i32_i64(local_tid_324800 +\n                                                           offset_324847)];\n                x_324832 = ((__local\n                             double *) red_ar",
            "r_mem_324806)[sext_i32_i64(local_tid_324800 +\n                                                           offset_324847)];\n                x_324833 = ((__local\n                             double *) red_arr_mem_324808)[sext_i32_i64(local_tid_324800 +\n                                                           offset_324847)];\n                x_324834 = ((__local\n                             double *) red_arr_mem_324810)[sext_i32_i64(local_tid_324800 +\n                                                           offset_324847)];\n                x_324835 = ((__local\n                             double *) red_arr_mem_324812)[sext_i32_i64(local_tid_324800 +\n                                                           offset_324847)];\n            }\n        }\n        offset_324847 = 1;\n        while (slt32(offset_324847, wave_sizze_324802)) {\n            if (slt32(local_tid_324800 + offset_324847,\n                      sext_i64_i32(segred_group_sizze_316111)) &&\n                ((local_tid_324800 - squot32(local_tid_324800,\n                                             wave_sizze_324802) *\n                  wave_sizze_324802) & (2 * offset_324847 - 1)) == 0) {\n                // read array element\n                {\n                    x_324836 = ((volatile __local\n                                 double *) red_arr_mem_324804)[sext_i32_i64(local_tid_324800 +\n                                                               offset_324847)];\n                    x_324837 = ((volatile __local\n                                 double *) red_arr_mem_324806)[sext_i32_i64(local_tid_324800 +\n                                                               offset_324847)];\n                    x_324838 = ((volatile __local\n                                 double *) red_arr_mem_324808)[sext_i32_i64(local_tid_324800 +\n                                                               offset_324847)];\n                    x_324839 = ((volatile __local\n                                 double *) red_arr_me",
            "m_324810)[sext_i32_i64(local_tid_324800 +\n                                                               offset_324847)];\n                    x_324840 = ((volatile __local\n                                 double *) red_arr_mem_324812)[sext_i32_i64(local_tid_324800 +\n                                                               offset_324847)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324841 = x_324831 + x_324836;\n                    double defunc_1_op_res_324842 = x_324832 + x_324837;\n                    double defunc_1_op_res_324843 = x_324833 + x_324838;\n                    double defunc_1_op_res_324844 = x_324834 + x_324839;\n                    double defunc_1_op_res_324845 = x_324835 + x_324840;\n                    \n                    x_324831 = defunc_1_op_res_324841;\n                    x_324832 = defunc_1_op_res_324842;\n                    x_324833 = defunc_1_op_res_324843;\n                    x_324834 = defunc_1_op_res_324844;\n                    x_324835 = defunc_1_op_res_324845;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_324804)[sext_i32_i64(local_tid_324800)] =\n                        x_324831;\n                    ((volatile __local\n                      double *) red_arr_mem_324806)[sext_i32_i64(local_tid_324800)] =\n                        x_324832;\n                    ((volatile __local\n                      double *) red_arr_mem_324808)[sext_i32_i64(local_tid_324800)] =\n                        x_324833;\n                    ((volatile __local\n                      double *) red_arr_mem_324810)[sext_i32_i64(local_tid_324800)] =\n                        x_324834;\n                    ((volatile __local\n                      double *) red_arr_mem_324812)[sext_i32_i64(local_tid_324800)] =\n                        x_324835;\n                }\n            }\n   ",
            "         offset_324847 *= 2;\n        }\n        while (slt32(skip_waves_324848,\n                     squot32(sext_i64_i32(segred_group_sizze_316111) +\n                             wave_sizze_324802 - 1, wave_sizze_324802))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_324847 = skip_waves_324848 * wave_sizze_324802;\n            if (slt32(local_tid_324800 + offset_324847,\n                      sext_i64_i32(segred_group_sizze_316111)) &&\n                ((local_tid_324800 - squot32(local_tid_324800,\n                                             wave_sizze_324802) *\n                  wave_sizze_324802) == 0 && (squot32(local_tid_324800,\n                                                      wave_sizze_324802) & (2 *\n                                                                            skip_waves_324848 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_324836 = ((__local\n                                 double *) red_arr_mem_324804)[sext_i32_i64(local_tid_324800 +\n                                                               offset_324847)];\n                    x_324837 = ((__local\n                                 double *) red_arr_mem_324806)[sext_i32_i64(local_tid_324800 +\n                                                               offset_324847)];\n                    x_324838 = ((__local\n                                 double *) red_arr_mem_324808)[sext_i32_i64(local_tid_324800 +\n                                                               offset_324847)];\n                    x_324839 = ((__local\n                                 double *) red_arr_mem_324810)[sext_i32_i64(local_tid_324800 +\n                                                               offset_324847)];\n                    x_324840 = ((__local\n                                 double *) red_arr_mem_324812)[sext_i32_i64(local_tid_324800 +\n     ",
            "                                                          offset_324847)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324841 = x_324831 + x_324836;\n                    double defunc_1_op_res_324842 = x_324832 + x_324837;\n                    double defunc_1_op_res_324843 = x_324833 + x_324838;\n                    double defunc_1_op_res_324844 = x_324834 + x_324839;\n                    double defunc_1_op_res_324845 = x_324835 + x_324840;\n                    \n                    x_324831 = defunc_1_op_res_324841;\n                    x_324832 = defunc_1_op_res_324842;\n                    x_324833 = defunc_1_op_res_324843;\n                    x_324834 = defunc_1_op_res_324844;\n                    x_324835 = defunc_1_op_res_324845;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_324804)[sext_i32_i64(local_tid_324800)] =\n                        x_324831;\n                    ((__local\n                      double *) red_arr_mem_324806)[sext_i32_i64(local_tid_324800)] =\n                        x_324832;\n                    ((__local\n                      double *) red_arr_mem_324808)[sext_i32_i64(local_tid_324800)] =\n                        x_324833;\n                    ((__local\n                      double *) red_arr_mem_324810)[sext_i32_i64(local_tid_324800)] =\n                        x_324834;\n                    ((__local\n                      double *) red_arr_mem_324812)[sext_i32_i64(local_tid_324800)] =\n                        x_324835;\n                }\n            }\n            skip_waves_324848 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_324800) == (int64_t) 0) {\n                x_acc_324825 = x_324831;\n                x_acc_324826 = x_324832;\n                x_acc_3",
            "24827 = x_324833;\n                x_acc_324828 = x_324834;\n                x_acc_324829 = x_324835;\n            }\n        }\n        if (groups_per_segment_324782 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_324800 == 0) {\n                    ((__global double *) mem_320045)[gtid_316119 *\n                                                     t_n_m_292839 +\n                                                     gtid_316120] =\n                        x_acc_324825;\n                    ((__global double *) mem_320049)[gtid_316119 *\n                                                     t_n_m_292839 +\n                                                     gtid_316120] =\n                        x_acc_324826;\n                    ((__global double *) mem_320053)[gtid_316119 *\n                                                     t_n_m_292839 +\n                                                     gtid_316120] =\n                        x_acc_324827;\n                    ((__global double *) mem_320057)[gtid_316119 *\n                                                     t_n_m_292839 +\n                                                     gtid_316120] =\n                        x_acc_324828;\n                    ((__global double *) mem_320061)[gtid_316119 *\n                                                     t_n_m_292839 +\n                                                     gtid_316120] =\n                        x_acc_324829;\n                }\n            }\n        } else {\n            int32_t old_counter_324849;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_324800 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_324787)[sext_i32_i64(virt_group_id_324818)] =\n                        x_acc_324825;\n                    ((__global\n                      double *) segred_tmp_mem_324789)[sext_i32",
            "_i64(virt_group_id_324818)] =\n                        x_acc_324826;\n                    ((__global\n                      double *) segred_tmp_mem_324791)[sext_i32_i64(virt_group_id_324818)] =\n                        x_acc_324827;\n                    ((__global\n                      double *) segred_tmp_mem_324793)[sext_i32_i64(virt_group_id_324818)] =\n                        x_acc_324828;\n                    ((__global\n                      double *) segred_tmp_mem_324795)[sext_i32_i64(virt_group_id_324818)] =\n                        x_acc_324829;\n                    mem_fence_global();\n                    old_counter_324849 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324797)[sext_i32_i64(srem32(flat_segment_id_324819,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_324814)[(int64_t) 0] =\n                        old_counter_324849 == groups_per_segment_324782 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_324850;\n            \n            is_last_group_324850 = ((__local\n                                     bool *) sync_arr_mem_324814)[(int64_t) 0];\n            if (is_last_group_324850) {\n                if (local_tid_324800 == 0) {\n                    old_counter_324849 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324797)[sext_i32_i64(srem32(flat_segment_id_324819,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                  ",
            "                   groups_per_segment_324782));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_324851 =\n                            sdiv_up64(groups_per_segment_324782,\n                                      segred_group_sizze_316111);\n                    \n                    x_316123 = 0.0;\n                    x_316124 = 0.0;\n                    x_316125 = 0.0;\n                    x_316126 = 0.0;\n                    x_316127 = 0.0;\n                    for (int64_t i_324852 = 0; i_324852 <\n                         read_per_thread_324851; i_324852++) {\n                        int64_t group_res_id_324853 =\n                                sext_i32_i64(local_tid_324800) *\n                                read_per_thread_324851 + i_324852;\n                        int64_t index_of_group_res_324854 =\n                                sext_i32_i64(flat_segment_id_324819) *\n                                groups_per_segment_324782 + group_res_id_324853;\n                        \n                        if (slt64(group_res_id_324853,\n                                  groups_per_segment_324782)) {\n                            x_316128 = ((__global\n                                         double *) segred_tmp_mem_324787)[index_of_group_res_324854];\n                            x_316129 = ((__global\n                                         double *) segred_tmp_mem_324789)[index_of_group_res_324854];\n                            x_316130 = ((__global\n                                         double *) segred_tmp_mem_324791)[index_of_group_res_324854];\n                            x_316131 = ((__global\n                                         double *) segred_tmp_mem_324793)[index_of_group_res_324854];\n                            x_316132 = ((__global\n                                         double *) segred_tmp_mem_324795)[index_of_group_res_324854];\n                            \n                            do",
            "uble defunc_1_op_res_316133 = x_316123 + x_316128;\n                            double defunc_1_op_res_316134 = x_316124 + x_316129;\n                            double defunc_1_op_res_316135 = x_316125 + x_316130;\n                            double defunc_1_op_res_316136 = x_316126 + x_316131;\n                            double defunc_1_op_res_316137 = x_316127 + x_316132;\n                            \n                            x_316123 = defunc_1_op_res_316133;\n                            x_316124 = defunc_1_op_res_316134;\n                            x_316125 = defunc_1_op_res_316135;\n                            x_316126 = defunc_1_op_res_316136;\n                            x_316127 = defunc_1_op_res_316137;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_324804)[sext_i32_i64(local_tid_324800)] =\n                    x_316123;\n                ((__local\n                  double *) red_arr_mem_324806)[sext_i32_i64(local_tid_324800)] =\n                    x_316124;\n                ((__local\n                  double *) red_arr_mem_324808)[sext_i32_i64(local_tid_324800)] =\n                    x_316125;\n                ((__local\n                  double *) red_arr_mem_324810)[sext_i32_i64(local_tid_324800)] =\n                    x_316126;\n                ((__local\n                  double *) red_arr_mem_324812)[sext_i32_i64(local_tid_324800)] =\n                    x_316127;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_324855;\n                    int32_t skip_waves_324856 = 1;\n                    double x_324831;\n                    double x_324832;\n                    double x_324833;\n                    double x_324834;\n                    double x_324835;\n                    double x_324836;\n                    double x_324837;\n                    double x_324838;\n                    dou",
            "ble x_324839;\n                    double x_324840;\n                    \n                    offset_324855 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_324800,\n                                  sext_i64_i32(segred_group_sizze_316111))) {\n                            x_324831 = ((__local\n                                         double *) red_arr_mem_324804)[sext_i32_i64(local_tid_324800 +\n                                                                       offset_324855)];\n                            x_324832 = ((__local\n                                         double *) red_arr_mem_324806)[sext_i32_i64(local_tid_324800 +\n                                                                       offset_324855)];\n                            x_324833 = ((__local\n                                         double *) red_arr_mem_324808)[sext_i32_i64(local_tid_324800 +\n                                                                       offset_324855)];\n                            x_324834 = ((__local\n                                         double *) red_arr_mem_324810)[sext_i32_i64(local_tid_324800 +\n                                                                       offset_324855)];\n                            x_324835 = ((__local\n                                         double *) red_arr_mem_324812)[sext_i32_i64(local_tid_324800 +\n                                                                       offset_324855)];\n                        }\n                    }\n                    offset_324855 = 1;\n                    while (slt32(offset_324855, wave_sizze_324802)) {\n                        if (slt32(local_tid_324800 + offset_324855,\n                                  sext_i64_i32(segred_group_sizze_316111)) &&\n                            ((local_tid_324800 - squot32(local_tid_324800,\n                                                         wave_sizze_324802) *\n           ",
            "                   wave_sizze_324802) & (2 * offset_324855 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_324836 = ((volatile __local\n                                             double *) red_arr_mem_324804)[sext_i32_i64(local_tid_324800 +\n                                                                           offset_324855)];\n                                x_324837 = ((volatile __local\n                                             double *) red_arr_mem_324806)[sext_i32_i64(local_tid_324800 +\n                                                                           offset_324855)];\n                                x_324838 = ((volatile __local\n                                             double *) red_arr_mem_324808)[sext_i32_i64(local_tid_324800 +\n                                                                           offset_324855)];\n                                x_324839 = ((volatile __local\n                                             double *) red_arr_mem_324810)[sext_i32_i64(local_tid_324800 +\n                                                                           offset_324855)];\n                                x_324840 = ((volatile __local\n                                             double *) red_arr_mem_324812)[sext_i32_i64(local_tid_324800 +\n                                                                           offset_324855)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_324841 = x_324831 +\n                                       x_324836;\n                                double defunc_1_op_res_324842 = x_324832 +\n                                       x_324837;\n                                double defunc_1_op_res_324843 = x_324833 +\n                                       x_324838;\n                         ",
            "       double defunc_1_op_res_324844 = x_324834 +\n                                       x_324839;\n                                double defunc_1_op_res_324845 = x_324835 +\n                                       x_324840;\n                                \n                                x_324831 = defunc_1_op_res_324841;\n                                x_324832 = defunc_1_op_res_324842;\n                                x_324833 = defunc_1_op_res_324843;\n                                x_324834 = defunc_1_op_res_324844;\n                                x_324835 = defunc_1_op_res_324845;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_324804)[sext_i32_i64(local_tid_324800)] =\n                                    x_324831;\n                                ((volatile __local\n                                  double *) red_arr_mem_324806)[sext_i32_i64(local_tid_324800)] =\n                                    x_324832;\n                                ((volatile __local\n                                  double *) red_arr_mem_324808)[sext_i32_i64(local_tid_324800)] =\n                                    x_324833;\n                                ((volatile __local\n                                  double *) red_arr_mem_324810)[sext_i32_i64(local_tid_324800)] =\n                                    x_324834;\n                                ((volatile __local\n                                  double *) red_arr_mem_324812)[sext_i32_i64(local_tid_324800)] =\n                                    x_324835;\n                            }\n                        }\n                        offset_324855 *= 2;\n                    }\n                    while (slt32(skip_waves_324856,\n                                 squot32(sext_i64_i32(segred_group_sizze_316111) +\n                                         wave_sizze_324802 -",
            " 1,\n                                         wave_sizze_324802))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_324855 = skip_waves_324856 * wave_sizze_324802;\n                        if (slt32(local_tid_324800 + offset_324855,\n                                  sext_i64_i32(segred_group_sizze_316111)) &&\n                            ((local_tid_324800 - squot32(local_tid_324800,\n                                                         wave_sizze_324802) *\n                              wave_sizze_324802) == 0 &&\n                             (squot32(local_tid_324800, wave_sizze_324802) &\n                              (2 * skip_waves_324856 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_324836 = ((__local\n                                             double *) red_arr_mem_324804)[sext_i32_i64(local_tid_324800 +\n                                                                           offset_324855)];\n                                x_324837 = ((__local\n                                             double *) red_arr_mem_324806)[sext_i32_i64(local_tid_324800 +\n                                                                           offset_324855)];\n                                x_324838 = ((__local\n                                             double *) red_arr_mem_324808)[sext_i32_i64(local_tid_324800 +\n                                                                           offset_324855)];\n                                x_324839 = ((__local\n                                             double *) red_arr_mem_324810)[sext_i32_i64(local_tid_324800 +\n                                                                           offset_324855)];\n                                x_324840 = ((__local\n                                             double *) red_arr_mem_324812)[sext_i32_i64(local_tid_324800 +\n                                                  ",
            "                         offset_324855)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_324841 = x_324831 +\n                                       x_324836;\n                                double defunc_1_op_res_324842 = x_324832 +\n                                       x_324837;\n                                double defunc_1_op_res_324843 = x_324833 +\n                                       x_324838;\n                                double defunc_1_op_res_324844 = x_324834 +\n                                       x_324839;\n                                double defunc_1_op_res_324845 = x_324835 +\n                                       x_324840;\n                                \n                                x_324831 = defunc_1_op_res_324841;\n                                x_324832 = defunc_1_op_res_324842;\n                                x_324833 = defunc_1_op_res_324843;\n                                x_324834 = defunc_1_op_res_324844;\n                                x_324835 = defunc_1_op_res_324845;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_324804)[sext_i32_i64(local_tid_324800)] =\n                                    x_324831;\n                                ((__local\n                                  double *) red_arr_mem_324806)[sext_i32_i64(local_tid_324800)] =\n                                    x_324832;\n                                ((__local\n                                  double *) red_arr_mem_324808)[sext_i32_i64(local_tid_324800)] =\n                                    x_324833;\n                                ((__local\n                                  double *) red_arr_mem_324810)[sext_i32_i64(local_tid_324800)] =\n                                    x_",
            "324834;\n                                ((__local\n                                  double *) red_arr_mem_324812)[sext_i32_i64(local_tid_324800)] =\n                                    x_324835;\n                            }\n                        }\n                        skip_waves_324856 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_324800 == 0) {\n                            ((__global double *) mem_320045)[gtid_316119 *\n                                                             t_n_m_292839 +\n                                                             gtid_316120] =\n                                x_324831;\n                            ((__global double *) mem_320049)[gtid_316119 *\n                                                             t_n_m_292839 +\n                                                             gtid_316120] =\n                                x_324832;\n                            ((__global double *) mem_320053)[gtid_316119 *\n                                                             t_n_m_292839 +\n                                                             gtid_316120] =\n                                x_324833;\n                            ((__global double *) mem_320057)[gtid_316119 *\n                                                             t_n_m_292839 +\n                                                             gtid_316120] =\n                                x_324834;\n                            ((__global double *) mem_320061)[gtid_316119 *\n                                                             t_n_m_292839 +\n                                                             gtid_316120] =\n                                x_324835;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef ",
            "segred_group_sizze_316111\n}\n__kernel void mainzisegred_large_316228(__global int *global_failure,\n                                        uint sync_arr_mem_324923_backing_offset_0,\n                                        uint red_arr_mem_324921_backing_offset_1,\n                                        uint red_arr_mem_324919_backing_offset_2,\n                                        int64_t n_292675, int64_t q_t_292679,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t t_n_m_292839, int64_t i_292846,\n                                        int64_t num_groups_316221,\n                                        int64_t groups_per_segment_324903,\n                                        int64_t elements_per_thread_324904,\n                                        int64_t virt_num_groups_324905,\n                                        int64_t threads_per_segment_324907,\n                                        __global unsigned char *ext_mem_318541,\n                                        __global unsigned char *ext_mem_318542,\n                                        __global unsigned char *ext_mem_318805,\n                                        __global unsigned char *ext_mem_318806,\n                                        __global unsigned char *mem_320036,\n                                        __global unsigned char *mem_320040,\n                                        __global unsigned char *mem_320066,\n                                        __global unsigned char *mem_320070,\n                                        __global unsigned char *mem_320074,\n                                        __global unsigned char *mem_320078,\n                                        __global unsigned char *mem_320082,\n                                        __global unsigned char *mem_320087,\n                                        __global unsigned char *mem_",
            "320091,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324908,\n                                        __global\n                                        unsigned char *segred_tmp_mem_324910,\n                                        __global\n                                        unsigned char *mainzicounter_mem_324912)\n{\n    #define segred_group_sizze_316220 (mainzisegred_group_sizze_315552)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_324923_backing_2 =\n                           &shared_mem[sync_arr_mem_324923_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324921_backing_1 =\n                           &shared_mem[red_arr_mem_324921_backing_offset_1];\n    volatile unsigned char *red_arr_mem_324919_backing_0 =\n                           &shared_mem[red_arr_mem_324919_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324914;\n    int32_t local_tid_324915;\n    int64_t group_sizze_324918;\n    int32_t wave_sizze_324917;\n    int32_t group_tid_324916;\n    \n    global_tid_324914 = get_global_id(0);\n    local_tid_324915 = get_local_id(0);\n    group_sizze_324918 = get_local_size(0);\n    wave_sizze_324917 = LOCKSTEP_WIDTH;\n    group_tid_324916 = get_group_id(0);\n    \n    int32_t phys_tid_316228 = global_tid_324914;\n    __local unsigned char *red_arr_mem_324919;\n    \n    red_arr_mem_324919 = (__local unsigned char *) red_arr_mem_324919_backing_0;\n    \n    __local unsigned char *red_arr_mem_324921;\n    \n    red_arr_mem_324921 = (__local unsigned char *) red_arr_mem_324921_backing_1;\n    \n    __local unsigned char *sync_arr_mem_324923;\n    \n    sync_arr_mem_324923 = (__local\n                           unsigned char *) sync_arr_mem_324923_backing_2;\n    \n    int32_t phys_group_id_324925;\n    \n    phys_group_id_324925 = get_group_id(0);\n    for (int32_t i_324926 =",
            " 0; i_324926 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_324905) - phys_group_id_324925,\n                   sext_i64_i32(num_groups_316221)); i_324926++) {\n        int32_t virt_group_id_324927 = phys_group_id_324925 + i_324926 *\n                sext_i64_i32(num_groups_316221);\n        int32_t flat_segment_id_324928 = squot32(virt_group_id_324927,\n                                                 sext_i64_i32(groups_per_segment_324903));\n        int64_t global_tid_324929 = srem64(sext_i32_i64(virt_group_id_324927) *\n                                           segred_group_sizze_316220 +\n                                           sext_i32_i64(local_tid_324915),\n                                           segred_group_sizze_316220 *\n                                           groups_per_segment_324903);\n        int64_t slice_324930 = t_n_m_292839;\n        int64_t slice_324931 = partition_sizze_292766 * slice_324930;\n        int64_t gtid_316225 = squot64(sext_i32_i64(flat_segment_id_324928),\n                                      slice_324930);\n        int64_t remnant_324932 = sext_i32_i64(flat_segment_id_324928) -\n                gtid_316225 * slice_324930;\n        int64_t gtid_316226 = remnant_324932;\n        int64_t remnant_324933 = remnant_324932 - gtid_316226;\n        int64_t gtid_316227;\n        double x_acc_324934;\n        double x_acc_324935;\n        int64_t chunk_sizze_324936 = smin64(elements_per_thread_324904,\n                                            sdiv_up64(q_t_292679 -\n                                                      global_tid_324929,\n                                                      threads_per_segment_324907));\n        double x_316229;\n        double x_316230;\n        double x_316231;\n        double x_316232;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_324934 = 0.0;\n            x_acc_324935 = 0.0;\n        }\n        for (int64_t i_324943 = 0; i_324943 < chunk_sizze_324936; i_324943++) {\n            gt",
            "id_316227 = global_tid_324929 + threads_per_segment_324907 *\n                i_324943;\n            // apply map function\n            {\n                int64_t x_316236;\n                \n                x_316236 = ((__global int64_t *) ext_mem_318541)[gtid_316225];\n                \n                int64_t x_316247;\n                \n                x_316247 = ((__global int64_t *) ext_mem_318806)[gtid_316225 *\n                                                                 t_n_m_292839 +\n                                                                 gtid_316226];\n                \n                double x_316248;\n                \n                x_316248 = ((__global double *) ext_mem_318805)[gtid_316225 *\n                                                                t_n_m_292839 +\n                                                                gtid_316226];\n                \n                int64_t binop_y_317887 = mul64(jump_t_292685, gtid_316226);\n                int64_t binop_y_317888 = smin64(i_292846, binop_y_317887);\n                int64_t index_primexp_317889 = add64((int64_t) 1,\n                                                     binop_y_317888);\n                double a12_316250;\n                \n                a12_316250 = ((__global double *) mem_320066)[gtid_316225 *\n                                                              t_n_m_292839 +\n                                                              gtid_316226];\n                \n                double b12_316251;\n                \n                b12_316251 = ((__global double *) mem_320070)[gtid_316225 *\n                                                              t_n_m_292839 +\n                                                              gtid_316226];\n                \n                double c12_316252;\n                \n                c12_316252 = ((__global double *) mem_320074)[gtid_316225 *\n                                                              t_n_m_292839 +\n                      ",
            "                                        gtid_316226];\n                \n                double b2_316253;\n                \n                b2_316253 = ((__global double *) mem_320078)[gtid_316225 *\n                                                             t_n_m_292839 +\n                                                             gtid_316226];\n                \n                double c2_316254;\n                \n                c2_316254 = ((__global double *) mem_320082)[gtid_316225 *\n                                                             t_n_m_292839 +\n                                                             gtid_316226];\n                \n                bool cond_316256 = sle64(x_316236, gtid_316227);\n                int64_t defunc_0_f_res_316257;\n                \n                if (cond_316256) {\n                    defunc_0_f_res_316257 = (int64_t) 0;\n                } else {\n                    int64_t i_316258 = add64(gtid_316227, x_316247);\n                    int64_t defunc_0_add_arg_316259;\n                    \n                    defunc_0_add_arg_316259 = ((__global\n                                                int64_t *) ext_mem_318542)[gtid_316225 *\n                                                                           n_292675 +\n                                                                           i_316258];\n                    \n                    int64_t defunc_1_add_res_316260 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_316259);\n                    \n                    defunc_0_f_res_316257 = defunc_1_add_res_316260;\n                }\n                \n                double defunc_0_f_res_316261;\n                \n                if (cond_316256) {\n                    defunc_0_f_res_316261 = 0.0;\n                } else {\n                    int64_t i_316262 = add64(gtid_316227, x_316247);\n                    double defunc_0_add_arg_316263;\n                    \n               ",
            "     defunc_0_add_arg_316263 = ((__global\n                                                double *) mem_320036)[gtid_316225 *\n                                                                      n_292675 +\n                                                                      i_316262];\n                    defunc_0_f_res_316261 = defunc_0_add_arg_316263;\n                }\n                \n                int64_t binop_p_316264 = sub64(defunc_0_f_res_316257,\n                                               index_primexp_317889);\n                double defunc_0_f_res_316265 = sitofp_i64_f64(binop_p_316264);\n                double abs_res_316266 = fabs(defunc_0_f_res_316265);\n                double tmp1_316267 = abs_res_316266 / x_316248;\n                double x_316268 = tmp1_316267 * tmp1_316267;\n                double y_316269 = tmp1_316267 * x_316268;\n                double tmp2_316270 = 1.0 - y_316269;\n                double x_316271 = tmp2_316270 * tmp2_316270;\n                double tmp3_316272 = tmp2_316270 * x_316271;\n                double tmp4_316273 = defunc_0_f_res_316261 * tmp3_316272;\n                double defunc_1_f_res_316274 = defunc_0_f_res_316265 *\n                       tmp4_316273;\n                double defunc_1_f_res_316275 = defunc_0_f_res_316265 *\n                       defunc_1_f_res_316274;\n                double defunc_0_f_res_316276;\n                \n                if (cond_316256) {\n                    defunc_0_f_res_316276 = 0.0;\n                } else {\n                    int64_t i_316277 = add64(gtid_316227, x_316247);\n                    double defunc_0_add_arg_316278;\n                    \n                    defunc_0_add_arg_316278 = ((__global\n                                                double *) mem_320040)[gtid_316225 *\n                                                                      n_292675 +\n                                                                      i_316277];\n                    defunc_0_f_res_316276 = def",
            "unc_0_add_arg_316278;\n                }\n                \n                double x_316279 = a12_316250 * tmp4_316273;\n                double y_316280 = b12_316251 * defunc_1_f_res_316274;\n                double x_316281 = x_316279 + y_316280;\n                double y_316282 = c12_316252 * defunc_1_f_res_316275;\n                double x_316283 = x_316281 + y_316282;\n                double defunc_9_fit_fun_res_316284 = defunc_0_f_res_316276 *\n                       x_316283;\n                double x_316285 = b12_316251 * tmp4_316273;\n                double y_316286 = b2_316253 * defunc_1_f_res_316274;\n                double x_316287 = x_316285 + y_316286;\n                double y_316288 = c2_316254 * defunc_1_f_res_316275;\n                double x_316289 = x_316287 + y_316288;\n                double defunc_9_slope_fun_res_316290 = defunc_0_f_res_316276 *\n                       x_316289;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_316229 = x_acc_324934;\n                    x_316230 = x_acc_324935;\n                }\n                // load new values\n                {\n                    x_316231 = defunc_9_fit_fun_res_316284;\n                    x_316232 = defunc_9_slope_fun_res_316290;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_316233 = x_316229 + x_316231;\n                    double defunc_1_op_res_316234 = x_316230 + x_316232;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_324934 = defunc_1_op_res_316233;\n                        x_acc_324935 = defunc_1_op_res_316234;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_316229 = x_acc_324934;\n            x_316230 = x_acc_324935;\n            ((__local\n           ",
            "   double *) red_arr_mem_324919)[sext_i32_i64(local_tid_324915)] =\n                x_316229;\n            ((__local\n              double *) red_arr_mem_324921)[sext_i32_i64(local_tid_324915)] =\n                x_316230;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_324944;\n        int32_t skip_waves_324945 = 1;\n        double x_324937;\n        double x_324938;\n        double x_324939;\n        double x_324940;\n        \n        offset_324944 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_324915,\n                      sext_i64_i32(segred_group_sizze_316220))) {\n                x_324937 = ((__local\n                             double *) red_arr_mem_324919)[sext_i32_i64(local_tid_324915 +\n                                                           offset_324944)];\n                x_324938 = ((__local\n                             double *) red_arr_mem_324921)[sext_i32_i64(local_tid_324915 +\n                                                           offset_324944)];\n            }\n        }\n        offset_324944 = 1;\n        while (slt32(offset_324944, wave_sizze_324917)) {\n            if (slt32(local_tid_324915 + offset_324944,\n                      sext_i64_i32(segred_group_sizze_316220)) &&\n                ((local_tid_324915 - squot32(local_tid_324915,\n                                             wave_sizze_324917) *\n                  wave_sizze_324917) & (2 * offset_324944 - 1)) == 0) {\n                // read array element\n                {\n                    x_324939 = ((volatile __local\n                                 double *) red_arr_mem_324919)[sext_i32_i64(local_tid_324915 +\n                                                               offset_324944)];\n                    x_324940 = ((volatile __local\n                                 double *) red_arr_mem_324921)[sext_i32_i64(local_tid_324915 +\n                                                               offset_324944)]",
            ";\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324941 = x_324937 + x_324939;\n                    double defunc_1_op_res_324942 = x_324938 + x_324940;\n                    \n                    x_324937 = defunc_1_op_res_324941;\n                    x_324938 = defunc_1_op_res_324942;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_324919)[sext_i32_i64(local_tid_324915)] =\n                        x_324937;\n                    ((volatile __local\n                      double *) red_arr_mem_324921)[sext_i32_i64(local_tid_324915)] =\n                        x_324938;\n                }\n            }\n            offset_324944 *= 2;\n        }\n        while (slt32(skip_waves_324945,\n                     squot32(sext_i64_i32(segred_group_sizze_316220) +\n                             wave_sizze_324917 - 1, wave_sizze_324917))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_324944 = skip_waves_324945 * wave_sizze_324917;\n            if (slt32(local_tid_324915 + offset_324944,\n                      sext_i64_i32(segred_group_sizze_316220)) &&\n                ((local_tid_324915 - squot32(local_tid_324915,\n                                             wave_sizze_324917) *\n                  wave_sizze_324917) == 0 && (squot32(local_tid_324915,\n                                                      wave_sizze_324917) & (2 *\n                                                                            skip_waves_324945 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_324939 = ((__local\n                                 double *) red_arr_mem_324919)[sext_i32_i64(local_tid_324915 +\n                                                               offset_32494",
            "4)];\n                    x_324940 = ((__local\n                                 double *) red_arr_mem_324921)[sext_i32_i64(local_tid_324915 +\n                                                               offset_324944)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_324941 = x_324937 + x_324939;\n                    double defunc_1_op_res_324942 = x_324938 + x_324940;\n                    \n                    x_324937 = defunc_1_op_res_324941;\n                    x_324938 = defunc_1_op_res_324942;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_324919)[sext_i32_i64(local_tid_324915)] =\n                        x_324937;\n                    ((__local\n                      double *) red_arr_mem_324921)[sext_i32_i64(local_tid_324915)] =\n                        x_324938;\n                }\n            }\n            skip_waves_324945 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_324915) == (int64_t) 0) {\n                x_acc_324934 = x_324937;\n                x_acc_324935 = x_324938;\n            }\n        }\n        if (groups_per_segment_324903 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_324915 == 0) {\n                    ((__global double *) mem_320087)[gtid_316225 *\n                                                     t_n_m_292839 +\n                                                     gtid_316226] =\n                        x_acc_324934;\n                    ((__global double *) mem_320091)[gtid_316225 *\n                                                     t_n_m_292839 +\n                                                     gtid_316226] =\n                        x_acc_324935;\n                }\n      ",
            "      }\n        } else {\n            int32_t old_counter_324946;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_324915 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_324908)[sext_i32_i64(virt_group_id_324927)] =\n                        x_acc_324934;\n                    ((__global\n                      double *) segred_tmp_mem_324910)[sext_i32_i64(virt_group_id_324927)] =\n                        x_acc_324935;\n                    mem_fence_global();\n                    old_counter_324946 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324912)[sext_i32_i64(srem32(flat_segment_id_324928,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_324923)[(int64_t) 0] =\n                        old_counter_324946 == groups_per_segment_324903 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_324947;\n            \n            is_last_group_324947 = ((__local\n                                     bool *) sync_arr_mem_324923)[(int64_t) 0];\n            if (is_last_group_324947) {\n                if (local_tid_324915 == 0) {\n                    old_counter_324946 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_324912)[sext_i32_i64(srem32(flat_segment_id_324928,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     g",
            "roups_per_segment_324903));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_324948 =\n                            sdiv_up64(groups_per_segment_324903,\n                                      segred_group_sizze_316220);\n                    \n                    x_316229 = 0.0;\n                    x_316230 = 0.0;\n                    for (int64_t i_324949 = 0; i_324949 <\n                         read_per_thread_324948; i_324949++) {\n                        int64_t group_res_id_324950 =\n                                sext_i32_i64(local_tid_324915) *\n                                read_per_thread_324948 + i_324949;\n                        int64_t index_of_group_res_324951 =\n                                sext_i32_i64(flat_segment_id_324928) *\n                                groups_per_segment_324903 + group_res_id_324950;\n                        \n                        if (slt64(group_res_id_324950,\n                                  groups_per_segment_324903)) {\n                            x_316231 = ((__global\n                                         double *) segred_tmp_mem_324908)[index_of_group_res_324951];\n                            x_316232 = ((__global\n                                         double *) segred_tmp_mem_324910)[index_of_group_res_324951];\n                            \n                            double defunc_1_op_res_316233 = x_316229 + x_316231;\n                            double defunc_1_op_res_316234 = x_316230 + x_316232;\n                            \n                            x_316229 = defunc_1_op_res_316233;\n                            x_316230 = defunc_1_op_res_316234;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_324919)[sext_i32_i64(local_tid_324915)] =\n                    x_316229;\n                ((__local\n                  double *) red_arr_mem_324921)[sext_i32_i64(local_",
            "tid_324915)] =\n                    x_316230;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_324952;\n                    int32_t skip_waves_324953 = 1;\n                    double x_324937;\n                    double x_324938;\n                    double x_324939;\n                    double x_324940;\n                    \n                    offset_324952 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_324915,\n                                  sext_i64_i32(segred_group_sizze_316220))) {\n                            x_324937 = ((__local\n                                         double *) red_arr_mem_324919)[sext_i32_i64(local_tid_324915 +\n                                                                       offset_324952)];\n                            x_324938 = ((__local\n                                         double *) red_arr_mem_324921)[sext_i32_i64(local_tid_324915 +\n                                                                       offset_324952)];\n                        }\n                    }\n                    offset_324952 = 1;\n                    while (slt32(offset_324952, wave_sizze_324917)) {\n                        if (slt32(local_tid_324915 + offset_324952,\n                                  sext_i64_i32(segred_group_sizze_316220)) &&\n                            ((local_tid_324915 - squot32(local_tid_324915,\n                                                         wave_sizze_324917) *\n                              wave_sizze_324917) & (2 * offset_324952 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_324939 = ((volatile __local\n                                             double *) red_arr_mem_324919)[sext_i32_i64(local_tid_324915 +\n                      ",
            "                                                     offset_324952)];\n                                x_324940 = ((volatile __local\n                                             double *) red_arr_mem_324921)[sext_i32_i64(local_tid_324915 +\n                                                                           offset_324952)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_324941 = x_324937 +\n                                       x_324939;\n                                double defunc_1_op_res_324942 = x_324938 +\n                                       x_324940;\n                                \n                                x_324937 = defunc_1_op_res_324941;\n                                x_324938 = defunc_1_op_res_324942;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_324919)[sext_i32_i64(local_tid_324915)] =\n                                    x_324937;\n                                ((volatile __local\n                                  double *) red_arr_mem_324921)[sext_i32_i64(local_tid_324915)] =\n                                    x_324938;\n                            }\n                        }\n                        offset_324952 *= 2;\n                    }\n                    while (slt32(skip_waves_324953,\n                                 squot32(sext_i64_i32(segred_group_sizze_316220) +\n                                         wave_sizze_324917 - 1,\n                                         wave_sizze_324917))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_324952 = skip_waves_324953 * wave_sizze_324917;\n                        if (slt32(local_tid_324915 + offset_324952,\n                                  sext_i64_i",
            "32(segred_group_sizze_316220)) &&\n                            ((local_tid_324915 - squot32(local_tid_324915,\n                                                         wave_sizze_324917) *\n                              wave_sizze_324917) == 0 &&\n                             (squot32(local_tid_324915, wave_sizze_324917) &\n                              (2 * skip_waves_324953 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_324939 = ((__local\n                                             double *) red_arr_mem_324919)[sext_i32_i64(local_tid_324915 +\n                                                                           offset_324952)];\n                                x_324940 = ((__local\n                                             double *) red_arr_mem_324921)[sext_i32_i64(local_tid_324915 +\n                                                                           offset_324952)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_324941 = x_324937 +\n                                       x_324939;\n                                double defunc_1_op_res_324942 = x_324938 +\n                                       x_324940;\n                                \n                                x_324937 = defunc_1_op_res_324941;\n                                x_324938 = defunc_1_op_res_324942;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_324919)[sext_i32_i64(local_tid_324915)] =\n                                    x_324937;\n                                ((__local\n                                  double *) red_arr_mem_324921)[sext_i32_i64(local_tid_324915)] =\n                                    x_324938;\n      ",
            "                      }\n                        }\n                        skip_waves_324953 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_324915 == 0) {\n                            ((__global double *) mem_320087)[gtid_316225 *\n                                                             t_n_m_292839 +\n                                                             gtid_316226] =\n                                x_324937;\n                            ((__global double *) mem_320091)[gtid_316225 *\n                                                             t_n_m_292839 +\n                                                             gtid_316226] =\n                                x_324938;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_316220\n}\n__kernel void mainzisegred_large_316768(__global int *global_failure,\n                                        uint sync_arr_mem_325061_backing_offset_0,\n                                        uint red_arr_mem_325059_backing_offset_1,\n                                        uint red_arr_mem_325057_backing_offset_2,\n                                        int64_t n_292675,\n                                        int64_t partition_sizze_292766,\n                                        int64_t num_groups_316762,\n                                        int64_t groups_per_segment_325041,\n                                        int64_t elements_per_thread_325042,\n                                        int64_t virt_num_groups_325043,\n                                        int64_t threads_per_segment_325045,\n                                        __global unsigned char *ext_mem_320155,\n                                        __global unsigned char *mem_320166,\n          ",
            "                              __global unsigned char *mem_320169,\n                                        __global\n                                        unsigned char *segred_tmp_mem_325046,\n                                        __global\n                                        unsigned char *segred_tmp_mem_325048,\n                                        __global\n                                        unsigned char *mainzicounter_mem_325050)\n{\n    #define segred_group_sizze_316761 (mainzisegred_group_sizze_316741)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_325061_backing_2 =\n                           &shared_mem[sync_arr_mem_325061_backing_offset_0];\n    volatile unsigned char *red_arr_mem_325059_backing_1 =\n                           &shared_mem[red_arr_mem_325059_backing_offset_1];\n    volatile unsigned char *red_arr_mem_325057_backing_0 =\n                           &shared_mem[red_arr_mem_325057_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325052;\n    int32_t local_tid_325053;\n    int64_t group_sizze_325056;\n    int32_t wave_sizze_325055;\n    int32_t group_tid_325054;\n    \n    global_tid_325052 = get_global_id(0);\n    local_tid_325053 = get_local_id(0);\n    group_sizze_325056 = get_local_size(0);\n    wave_sizze_325055 = LOCKSTEP_WIDTH;\n    group_tid_325054 = get_group_id(0);\n    \n    int32_t phys_tid_316768 = global_tid_325052;\n    __local unsigned char *red_arr_mem_325057;\n    \n    red_arr_mem_325057 = (__local unsigned char *) red_arr_mem_325057_backing_0;\n    \n    __local unsigned char *red_arr_mem_325059;\n    \n    red_arr_mem_325059 = (__local unsigned char *) red_arr_mem_325059_backing_1;\n    \n    __local unsigned char *sync_arr_mem_325061;\n    \n    sync_arr_mem_325061 = (__local\n                           unsigned char *) sync_arr_mem_325061_backing_2;\n    \n    int32_t phys_group_id_325063;\n    \n    phys_grou",
            "p_id_325063 = get_group_id(0);\n    for (int32_t i_325064 = 0; i_325064 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_325043) - phys_group_id_325063,\n                   sext_i64_i32(num_groups_316762)); i_325064++) {\n        int32_t virt_group_id_325065 = phys_group_id_325063 + i_325064 *\n                sext_i64_i32(num_groups_316762);\n        int32_t flat_segment_id_325066 = squot32(virt_group_id_325065,\n                                                 sext_i64_i32(groups_per_segment_325041));\n        int64_t global_tid_325067 = srem64(sext_i32_i64(virt_group_id_325065) *\n                                           segred_group_sizze_316761 +\n                                           sext_i32_i64(local_tid_325053),\n                                           segred_group_sizze_316761 *\n                                           groups_per_segment_325041);\n        int64_t slice_325068 = partition_sizze_292766;\n        int64_t gtid_316766 = sext_i32_i64(flat_segment_id_325066);\n        int64_t remnant_325069 = sext_i32_i64(flat_segment_id_325066) -\n                gtid_316766;\n        int64_t gtid_316767;\n        double x_acc_325070;\n        double x_acc_325071;\n        int64_t chunk_sizze_325072 = smin64(elements_per_thread_325042,\n                                            sdiv_up64(n_292675 -\n                                                      global_tid_325067,\n                                                      threads_per_segment_325045));\n        double x_316769;\n        double x_316770;\n        double x_316771;\n        double x_316772;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_325070 = INFINITY;\n            x_acc_325071 = -INFINITY;\n        }\n        for (int64_t i_325079 = 0; i_325079 < chunk_sizze_325072; i_325079++) {\n            gtid_316767 = global_tid_325067 + threads_per_segment_325045 *\n                i_325079;\n            // apply map function\n            {\n                double x_316776;\n          ",
            "      \n                x_316776 = ((__global double *) ext_mem_320155)[gtid_316766 *\n                                                                n_292675 +\n                                                                gtid_316767];\n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_316769 = x_acc_325070;\n                    x_316770 = x_acc_325071;\n                }\n                // load new values\n                {\n                    x_316771 = x_316776;\n                    x_316772 = x_316776;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_316773 = fmin64(x_316769, x_316771);\n                    double defunc_1_op_res_316774 = fmax64(x_316770, x_316772);\n                    \n                    // store in accumulator\n                    {\n                        x_acc_325070 = defunc_1_op_res_316773;\n                        x_acc_325071 = defunc_1_op_res_316774;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_316769 = x_acc_325070;\n            x_316770 = x_acc_325071;\n            ((__local\n              double *) red_arr_mem_325057)[sext_i32_i64(local_tid_325053)] =\n                x_316769;\n            ((__local\n              double *) red_arr_mem_325059)[sext_i32_i64(local_tid_325053)] =\n                x_316770;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_325080;\n        int32_t skip_waves_325081 = 1;\n        double x_325073;\n        double x_325074;\n        double x_325075;\n        double x_325076;\n        \n        offset_325080 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_325053,\n                      sext_i64_i32(segred_group_sizze_316761))) {\n                x_325073 = ((__local\n         ",
            "                    double *) red_arr_mem_325057)[sext_i32_i64(local_tid_325053 +\n                                                           offset_325080)];\n                x_325074 = ((__local\n                             double *) red_arr_mem_325059)[sext_i32_i64(local_tid_325053 +\n                                                           offset_325080)];\n            }\n        }\n        offset_325080 = 1;\n        while (slt32(offset_325080, wave_sizze_325055)) {\n            if (slt32(local_tid_325053 + offset_325080,\n                      sext_i64_i32(segred_group_sizze_316761)) &&\n                ((local_tid_325053 - squot32(local_tid_325053,\n                                             wave_sizze_325055) *\n                  wave_sizze_325055) & (2 * offset_325080 - 1)) == 0) {\n                // read array element\n                {\n                    x_325075 = ((volatile __local\n                                 double *) red_arr_mem_325057)[sext_i32_i64(local_tid_325053 +\n                                                               offset_325080)];\n                    x_325076 = ((volatile __local\n                                 double *) red_arr_mem_325059)[sext_i32_i64(local_tid_325053 +\n                                                               offset_325080)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_325077 = fmin64(x_325073, x_325075);\n                    double defunc_1_op_res_325078 = fmax64(x_325074, x_325076);\n                    \n                    x_325073 = defunc_1_op_res_325077;\n                    x_325074 = defunc_1_op_res_325078;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_325057)[sext_i32_i64(local_tid_325053)] =\n                        x_325073;\n                    ((volatile __local\n                      double *) red_arr_mem_32505",
            "9)[sext_i32_i64(local_tid_325053)] =\n                        x_325074;\n                }\n            }\n            offset_325080 *= 2;\n        }\n        while (slt32(skip_waves_325081,\n                     squot32(sext_i64_i32(segred_group_sizze_316761) +\n                             wave_sizze_325055 - 1, wave_sizze_325055))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_325080 = skip_waves_325081 * wave_sizze_325055;\n            if (slt32(local_tid_325053 + offset_325080,\n                      sext_i64_i32(segred_group_sizze_316761)) &&\n                ((local_tid_325053 - squot32(local_tid_325053,\n                                             wave_sizze_325055) *\n                  wave_sizze_325055) == 0 && (squot32(local_tid_325053,\n                                                      wave_sizze_325055) & (2 *\n                                                                            skip_waves_325081 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_325075 = ((__local\n                                 double *) red_arr_mem_325057)[sext_i32_i64(local_tid_325053 +\n                                                               offset_325080)];\n                    x_325076 = ((__local\n                                 double *) red_arr_mem_325059)[sext_i32_i64(local_tid_325053 +\n                                                               offset_325080)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_325077 = fmin64(x_325073, x_325075);\n                    double defunc_1_op_res_325078 = fmax64(x_325074, x_325076);\n                    \n                    x_325073 = defunc_1_op_res_325077;\n                    x_325074 = defunc_1_op_res_325078;\n                }\n                // write result of operation\n                {\n              ",
            "      ((__local\n                      double *) red_arr_mem_325057)[sext_i32_i64(local_tid_325053)] =\n                        x_325073;\n                    ((__local\n                      double *) red_arr_mem_325059)[sext_i32_i64(local_tid_325053)] =\n                        x_325074;\n                }\n            }\n            skip_waves_325081 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_325053) == (int64_t) 0) {\n                x_acc_325070 = x_325073;\n                x_acc_325071 = x_325074;\n            }\n        }\n        if (groups_per_segment_325041 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_325053 == 0) {\n                    ((__global double *) mem_320166)[gtid_316766] =\n                        x_acc_325070;\n                    ((__global double *) mem_320169)[gtid_316766] =\n                        x_acc_325071;\n                }\n            }\n        } else {\n            int32_t old_counter_325082;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_325053 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_325046)[sext_i32_i64(virt_group_id_325065)] =\n                        x_acc_325070;\n                    ((__global\n                      double *) segred_tmp_mem_325048)[sext_i32_i64(virt_group_id_325065)] =\n                        x_acc_325071;\n                    mem_fence_global();\n                    old_counter_325082 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_325050)[sext_i32_i64(srem32(flat_segment_id_325066,\n                                                                                                      10240))],\n                        ",
            "                      (int) 1);\n                    ((__local bool *) sync_arr_mem_325061)[(int64_t) 0] =\n                        old_counter_325082 == groups_per_segment_325041 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_325083;\n            \n            is_last_group_325083 = ((__local\n                                     bool *) sync_arr_mem_325061)[(int64_t) 0];\n            if (is_last_group_325083) {\n                if (local_tid_325053 == 0) {\n                    old_counter_325082 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_325050)[sext_i32_i64(srem32(flat_segment_id_325066,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_325041));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_325084 =\n                            sdiv_up64(groups_per_segment_325041,\n                                      segred_group_sizze_316761);\n                    \n                    x_316769 = INFINITY;\n                    x_316770 = -INFINITY;\n                    for (int64_t i_325085 = 0; i_325085 <\n                         read_per_thread_325084; i_325085++) {\n                        int64_t group_res_id_325086 =\n                                sext_i32_i64(local_tid_325053) *\n                                read_per_thread_325084 + i_325085;\n                        int64_t index_of_group_res_325087 =\n                                sext_i32_i64(flat_segment_id_325066) *\n                                groups_per_segment_325041 + group_res_id_325086;\n                        ",
            "\n                        if (slt64(group_res_id_325086,\n                                  groups_per_segment_325041)) {\n                            x_316771 = ((__global\n                                         double *) segred_tmp_mem_325046)[index_of_group_res_325087];\n                            x_316772 = ((__global\n                                         double *) segred_tmp_mem_325048)[index_of_group_res_325087];\n                            \n                            double defunc_1_op_res_316773 = fmin64(x_316769,\n                                                                   x_316771);\n                            double defunc_1_op_res_316774 = fmax64(x_316770,\n                                                                   x_316772);\n                            \n                            x_316769 = defunc_1_op_res_316773;\n                            x_316770 = defunc_1_op_res_316774;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_325057)[sext_i32_i64(local_tid_325053)] =\n                    x_316769;\n                ((__local\n                  double *) red_arr_mem_325059)[sext_i32_i64(local_tid_325053)] =\n                    x_316770;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_325088;\n                    int32_t skip_waves_325089 = 1;\n                    double x_325073;\n                    double x_325074;\n                    double x_325075;\n                    double x_325076;\n                    \n                    offset_325088 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_325053,\n                                  sext_i64_i32(segred_group_sizze_316761))) {\n                            x_325073 = ((__local\n                                         double *) red_",
            "arr_mem_325057)[sext_i32_i64(local_tid_325053 +\n                                                                       offset_325088)];\n                            x_325074 = ((__local\n                                         double *) red_arr_mem_325059)[sext_i32_i64(local_tid_325053 +\n                                                                       offset_325088)];\n                        }\n                    }\n                    offset_325088 = 1;\n                    while (slt32(offset_325088, wave_sizze_325055)) {\n                        if (slt32(local_tid_325053 + offset_325088,\n                                  sext_i64_i32(segred_group_sizze_316761)) &&\n                            ((local_tid_325053 - squot32(local_tid_325053,\n                                                         wave_sizze_325055) *\n                              wave_sizze_325055) & (2 * offset_325088 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_325075 = ((volatile __local\n                                             double *) red_arr_mem_325057)[sext_i32_i64(local_tid_325053 +\n                                                                           offset_325088)];\n                                x_325076 = ((volatile __local\n                                             double *) red_arr_mem_325059)[sext_i32_i64(local_tid_325053 +\n                                                                           offset_325088)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_325077 = fmin64(x_325073,\n                                                                       x_325075);\n                                double defunc_1_op_res_325078 = fmax64(x_325074,\n                                                                       x_325076);\n           ",
            "                     \n                                x_325073 = defunc_1_op_res_325077;\n                                x_325074 = defunc_1_op_res_325078;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_325057)[sext_i32_i64(local_tid_325053)] =\n                                    x_325073;\n                                ((volatile __local\n                                  double *) red_arr_mem_325059)[sext_i32_i64(local_tid_325053)] =\n                                    x_325074;\n                            }\n                        }\n                        offset_325088 *= 2;\n                    }\n                    while (slt32(skip_waves_325089,\n                                 squot32(sext_i64_i32(segred_group_sizze_316761) +\n                                         wave_sizze_325055 - 1,\n                                         wave_sizze_325055))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_325088 = skip_waves_325089 * wave_sizze_325055;\n                        if (slt32(local_tid_325053 + offset_325088,\n                                  sext_i64_i32(segred_group_sizze_316761)) &&\n                            ((local_tid_325053 - squot32(local_tid_325053,\n                                                         wave_sizze_325055) *\n                              wave_sizze_325055) == 0 &&\n                             (squot32(local_tid_325053, wave_sizze_325055) &\n                              (2 * skip_waves_325089 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_325075 = ((__local\n                                             double *) red_arr_mem_325057)[sext_i32_i64(local_tid_325053 +\n                                                                           off",
            "set_325088)];\n                                x_325076 = ((__local\n                                             double *) red_arr_mem_325059)[sext_i32_i64(local_tid_325053 +\n                                                                           offset_325088)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_325077 = fmin64(x_325073,\n                                                                       x_325075);\n                                double defunc_1_op_res_325078 = fmax64(x_325074,\n                                                                       x_325076);\n                                \n                                x_325073 = defunc_1_op_res_325077;\n                                x_325074 = defunc_1_op_res_325078;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_325057)[sext_i32_i64(local_tid_325053)] =\n                                    x_325073;\n                                ((__local\n                                  double *) red_arr_mem_325059)[sext_i32_i64(local_tid_325053)] =\n                                    x_325074;\n                            }\n                        }\n                        skip_waves_325089 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_325053 == 0) {\n                            ((__global double *) mem_320166)[gtid_316766] =\n                                x_325073;\n                            ((__global double *) mem_320169)[gtid_316766] =\n                                x_325074;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_L",
            "OCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_316761\n}\n__kernel void mainzisegred_large_317337(__global int *global_failure,\n                                        uint sync_arr_mem_325673_backing_offset_0,\n                                        uint red_arr_mem_325671_backing_offset_1,\n                                        uint red_arr_mem_325669_backing_offset_2,\n                                        uint red_arr_mem_325667_backing_offset_3,\n                                        int64_t n_292675,\n                                        int64_t partition_sizze_292766,\n                                        int64_t num_groups_317330,\n                                        int64_t groups_per_segment_325649,\n                                        int64_t elements_per_thread_325650,\n                                        int64_t virt_num_groups_325651,\n                                        int64_t threads_per_segment_325653,\n                                        __global unsigned char *ext_mem_320155,\n                                        __global unsigned char *mem_320205,\n                                        __global unsigned char *mem_320397,\n                                        __global unsigned char *mem_320400,\n                                        __global unsigned char *mem_320403,\n                                        __global\n                                        unsigned char *segred_tmp_mem_325654,\n                                        __global\n                                        unsigned char *segred_tmp_mem_325656,\n                                        __global\n                                        unsigned char *segred_tmp_mem_325658,\n                                        __global\n                                        unsigned char *mainzicounter_mem_325660)\n{\n    #define segred_group_sizze_317329 (mainzisegred_group_sizze_317285)\n    \n    const int block_dim0 = 0;\n    const i",
            "nt block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_325673_backing_3 =\n                           &shared_mem[sync_arr_mem_325673_backing_offset_0];\n    volatile unsigned char *red_arr_mem_325671_backing_2 =\n                           &shared_mem[red_arr_mem_325671_backing_offset_1];\n    volatile unsigned char *red_arr_mem_325669_backing_1 =\n                           &shared_mem[red_arr_mem_325669_backing_offset_2];\n    volatile unsigned char *red_arr_mem_325667_backing_0 =\n                           &shared_mem[red_arr_mem_325667_backing_offset_3];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325662;\n    int32_t local_tid_325663;\n    int64_t group_sizze_325666;\n    int32_t wave_sizze_325665;\n    int32_t group_tid_325664;\n    \n    global_tid_325662 = get_global_id(0);\n    local_tid_325663 = get_local_id(0);\n    group_sizze_325666 = get_local_size(0);\n    wave_sizze_325665 = LOCKSTEP_WIDTH;\n    group_tid_325664 = get_group_id(0);\n    \n    int32_t phys_tid_317337 = global_tid_325662;\n    __local unsigned char *red_arr_mem_325667;\n    \n    red_arr_mem_325667 = (__local unsigned char *) red_arr_mem_325667_backing_0;\n    \n    __local unsigned char *red_arr_mem_325669;\n    \n    red_arr_mem_325669 = (__local unsigned char *) red_arr_mem_325669_backing_1;\n    \n    __local unsigned char *red_arr_mem_325671;\n    \n    red_arr_mem_325671 = (__local unsigned char *) red_arr_mem_325671_backing_2;\n    \n    __local unsigned char *sync_arr_mem_325673;\n    \n    sync_arr_mem_325673 = (__local\n                           unsigned char *) sync_arr_mem_325673_backing_3;\n    \n    int32_t phys_group_id_325675;\n    \n    phys_group_id_325675 = get_group_id(0);\n    for (int32_t i_325676 = 0; i_325676 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_325651) - phys_group_id_325675,\n                   sext_i64_i32(num_groups_317330)); i_325676++) {\n        int32_t virt_group_id_325677 = phys_group_id_325675 + i_325676 *\n   ",
            "             sext_i64_i32(num_groups_317330);\n        int32_t flat_segment_id_325678 = squot32(virt_group_id_325677,\n                                                 sext_i64_i32(groups_per_segment_325649));\n        int64_t global_tid_325679 = srem64(sext_i32_i64(virt_group_id_325677) *\n                                           segred_group_sizze_317329 +\n                                           sext_i32_i64(local_tid_325663),\n                                           segred_group_sizze_317329 *\n                                           groups_per_segment_325649);\n        int64_t slice_325680 = partition_sizze_292766;\n        int64_t gtid_317335 = sext_i32_i64(flat_segment_id_325678);\n        int64_t remnant_325681 = sext_i32_i64(flat_segment_id_325678) -\n                gtid_317335;\n        int64_t gtid_317336;\n        double x_acc_325682;\n        int64_t x_acc_325683;\n        int64_t x_acc_325684;\n        int64_t chunk_sizze_325685 = smin64(elements_per_thread_325650,\n                                            sdiv_up64(n_292675 -\n                                                      global_tid_325679,\n                                                      threads_per_segment_325653));\n        double x_317338;\n        int64_t x_317339;\n        int64_t x_317340;\n        double x_317341;\n        int64_t x_317342;\n        int64_t x_317343;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_325682 = -INFINITY;\n            x_acc_325683 = (int64_t) -1;\n            x_acc_325684 = (int64_t) 0;\n        }\n        for (int64_t i_325712 = 0; i_325712 < chunk_sizze_325685; i_325712++) {\n            gtid_317336 = global_tid_325679 + threads_per_segment_325653 *\n                i_325712;\n            // apply map function\n            {\n                double x_317365;\n                \n                x_317365 = ((__global double *) mem_320205)[gtid_317335];\n                \n                double x_317366;\n                \n                x_3",
            "17366 = ((__global double *) ext_mem_320155)[gtid_317335 *\n                                                                n_292675 +\n                                                                gtid_317336];\n                \n                bool cond_317368 = x_317366 < x_317365;\n                int64_t defunc_0_f_res_317369 = btoi_bool_i64(cond_317368);\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_317338 = x_acc_325682;\n                    x_317339 = x_acc_325683;\n                    x_317340 = x_acc_325684;\n                }\n                // load new values\n                {\n                    x_317341 = x_317366;\n                    x_317342 = gtid_317336;\n                    x_317343 = defunc_0_f_res_317369;\n                }\n                // apply reduction operator\n                {\n                    bool cond_317344 = x_317340 == (int64_t) 0;\n                    bool cond_t_res_317345 = slt64((int64_t) 0, x_317343);\n                    bool x_317346 = cond_317344 && cond_t_res_317345;\n                    double defunc_1_op_res_317347;\n                    int64_t defunc_1_op_res_317348;\n                    \n                    if (x_317346) {\n                        defunc_1_op_res_317347 = x_317341;\n                        defunc_1_op_res_317348 = x_317342;\n                    } else {\n                        bool cond_317349 = slt64((int64_t) 0, x_317340);\n                        bool cond_t_res_317350 = x_317343 == (int64_t) 0;\n                        bool x_317351 = cond_317349 && cond_t_res_317350;\n                        double defunc_1_op_res_f_res_317352;\n                        int64_t defunc_1_op_res_f_res_317353;\n                        \n                        if (x_317351) {\n                            defunc_1_op_res_f_res_317352 = x_317338;\n                            defunc_1_op_res_f_res_317353 = x_317339;\n                    ",
            "    } else {\n                            bool cond_317354 = x_317341 < x_317338;\n                            double defunc_1_op_res_f_res_f_res_317355;\n                            int64_t defunc_1_op_res_f_res_f_res_317356;\n                            \n                            if (cond_317354) {\n                                defunc_1_op_res_f_res_f_res_317355 = x_317338;\n                                defunc_1_op_res_f_res_f_res_317356 = x_317339;\n                            } else {\n                                bool cond_317357 = x_317338 < x_317341;\n                                double defunc_1_op_res_f_res_f_res_f_res_317358;\n                                int64_t\n                                defunc_1_op_res_f_res_f_res_f_res_317359;\n                                \n                                if (cond_317357) {\n                                    defunc_1_op_res_f_res_f_res_f_res_317358 =\n                                        x_317341;\n                                    defunc_1_op_res_f_res_f_res_f_res_317359 =\n                                        x_317342;\n                                } else {\n                                    bool cond_317360 = slt64(x_317339,\n                                                             x_317342);\n                                    double\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_317361;\n                                    \n                                    if (cond_317360) {\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_317361 =\n                                            x_317338;\n                                    } else {\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_317361 =\n                                            x_317341;\n                                    }\n                                    \n                                    int64_t\n                                    defunc_",
            "1_op_res_f_res_f_res_f_res_f_res_317362;\n                                    \n                                    if (cond_317360) {\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_317362 =\n                                            x_317339;\n                                    } else {\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_317362 =\n                                            x_317342;\n                                    }\n                                    defunc_1_op_res_f_res_f_res_f_res_317358 =\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_317361;\n                                    defunc_1_op_res_f_res_f_res_f_res_317359 =\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_317362;\n                                }\n                                defunc_1_op_res_f_res_f_res_317355 =\n                                    defunc_1_op_res_f_res_f_res_f_res_317358;\n                                defunc_1_op_res_f_res_f_res_317356 =\n                                    defunc_1_op_res_f_res_f_res_f_res_317359;\n                            }\n                            defunc_1_op_res_f_res_317352 =\n                                defunc_1_op_res_f_res_f_res_317355;\n                            defunc_1_op_res_f_res_317353 =\n                                defunc_1_op_res_f_res_f_res_317356;\n                        }\n                        defunc_1_op_res_317347 = defunc_1_op_res_f_res_317352;\n                        defunc_1_op_res_317348 = defunc_1_op_res_f_res_317353;\n                    }\n                    \n                    int64_t defunc_1_op_res_317363 = add64(x_317340, x_317343);\n                    \n                    // store in accumulator\n                    {\n                        x_acc_325682 = defunc_1_op_res_317347;\n                        x_acc_325683 = defunc_1_op_res_317348;\n                        x_acc_32",
            "5684 = defunc_1_op_res_317363;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_317338 = x_acc_325682;\n            x_317339 = x_acc_325683;\n            x_317340 = x_acc_325684;\n            ((__local\n              double *) red_arr_mem_325667)[sext_i32_i64(local_tid_325663)] =\n                x_317338;\n            ((__local\n              int64_t *) red_arr_mem_325669)[sext_i32_i64(local_tid_325663)] =\n                x_317339;\n            ((__local\n              int64_t *) red_arr_mem_325671)[sext_i32_i64(local_tid_325663)] =\n                x_317340;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_325713;\n        int32_t skip_waves_325714 = 1;\n        double x_325686;\n        int64_t x_325687;\n        int64_t x_325688;\n        double x_325689;\n        int64_t x_325690;\n        int64_t x_325691;\n        \n        offset_325713 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_325663,\n                      sext_i64_i32(segred_group_sizze_317329))) {\n                x_325686 = ((__local\n                             double *) red_arr_mem_325667)[sext_i32_i64(local_tid_325663 +\n                                                           offset_325713)];\n                x_325687 = ((__local\n                             int64_t *) red_arr_mem_325669)[sext_i32_i64(local_tid_325663 +\n                                                            offset_325713)];\n                x_325688 = ((__local\n                             int64_t *) red_arr_mem_325671)[sext_i32_i64(local_tid_325663 +\n                                                            offset_325713)];\n            }\n        }\n        offset_325713 = 1;\n        while (slt32(offset_325713, wave_sizze_325665)) {\n            if (slt32(local_tid_325663 + offset_325713,\n                      sext_i64_i32(segred_group_sizze_317329)) ",
            "&&\n                ((local_tid_325663 - squot32(local_tid_325663,\n                                             wave_sizze_325665) *\n                  wave_sizze_325665) & (2 * offset_325713 - 1)) == 0) {\n                // read array element\n                {\n                    x_325689 = ((volatile __local\n                                 double *) red_arr_mem_325667)[sext_i32_i64(local_tid_325663 +\n                                                               offset_325713)];\n                    x_325690 = ((volatile __local\n                                 int64_t *) red_arr_mem_325669)[sext_i32_i64(local_tid_325663 +\n                                                                offset_325713)];\n                    x_325691 = ((volatile __local\n                                 int64_t *) red_arr_mem_325671)[sext_i32_i64(local_tid_325663 +\n                                                                offset_325713)];\n                }\n                // apply reduction operation\n                {\n                    bool cond_325692 = x_325688 == (int64_t) 0;\n                    bool cond_t_res_325693 = slt64((int64_t) 0, x_325691);\n                    bool x_325694 = cond_325692 && cond_t_res_325693;\n                    double defunc_1_op_res_325695;\n                    int64_t defunc_1_op_res_325696;\n                    \n                    if (x_325694) {\n                        defunc_1_op_res_325695 = x_325689;\n                        defunc_1_op_res_325696 = x_325690;\n                    } else {\n                        bool cond_325697 = slt64((int64_t) 0, x_325688);\n                        bool cond_t_res_325698 = x_325691 == (int64_t) 0;\n                        bool x_325699 = cond_325697 && cond_t_res_325698;\n                        double defunc_1_op_res_f_res_325700;\n                        int64_t defunc_1_op_res_f_res_325701;\n                        \n                        if (x_325699) {\n                            defunc_1_op_res_f_res_32570",
            "0 = x_325686;\n                            defunc_1_op_res_f_res_325701 = x_325687;\n                        } else {\n                            bool cond_325702 = x_325689 < x_325686;\n                            double defunc_1_op_res_f_res_f_res_325703;\n                            int64_t defunc_1_op_res_f_res_f_res_325704;\n                            \n                            if (cond_325702) {\n                                defunc_1_op_res_f_res_f_res_325703 = x_325686;\n                                defunc_1_op_res_f_res_f_res_325704 = x_325687;\n                            } else {\n                                bool cond_325705 = x_325686 < x_325689;\n                                double defunc_1_op_res_f_res_f_res_f_res_325706;\n                                int64_t\n                                defunc_1_op_res_f_res_f_res_f_res_325707;\n                                \n                                if (cond_325705) {\n                                    defunc_1_op_res_f_res_f_res_f_res_325706 =\n                                        x_325689;\n                                    defunc_1_op_res_f_res_f_res_f_res_325707 =\n                                        x_325690;\n                                } else {\n                                    bool cond_325708 = slt64(x_325687,\n                                                             x_325690);\n                                    double\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325709;\n                                    \n                                    if (cond_325708) {\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325709 =\n                                            x_325686;\n                                    } else {\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325709 =\n                                            x_325689;\n                                    }\n                     ",
            "               \n                                    int64_t\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325710;\n                                    \n                                    if (cond_325708) {\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325710 =\n                                            x_325687;\n                                    } else {\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325710 =\n                                            x_325690;\n                                    }\n                                    defunc_1_op_res_f_res_f_res_f_res_325706 =\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325709;\n                                    defunc_1_op_res_f_res_f_res_f_res_325707 =\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325710;\n                                }\n                                defunc_1_op_res_f_res_f_res_325703 =\n                                    defunc_1_op_res_f_res_f_res_f_res_325706;\n                                defunc_1_op_res_f_res_f_res_325704 =\n                                    defunc_1_op_res_f_res_f_res_f_res_325707;\n                            }\n                            defunc_1_op_res_f_res_325700 =\n                                defunc_1_op_res_f_res_f_res_325703;\n                            defunc_1_op_res_f_res_325701 =\n                                defunc_1_op_res_f_res_f_res_325704;\n                        }\n                        defunc_1_op_res_325695 = defunc_1_op_res_f_res_325700;\n                        defunc_1_op_res_325696 = defunc_1_op_res_f_res_325701;\n                    }\n                    \n                    int64_t defunc_1_op_res_325711 = add64(x_325688, x_325691);\n                    \n                    x_325686 = defunc_1_op_res_325695;\n                    x_325687 = defunc_1_op_res_325696;\n           ",
            "         x_325688 = defunc_1_op_res_325711;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_325667)[sext_i32_i64(local_tid_325663)] =\n                        x_325686;\n                    ((volatile __local\n                      int64_t *) red_arr_mem_325669)[sext_i32_i64(local_tid_325663)] =\n                        x_325687;\n                    ((volatile __local\n                      int64_t *) red_arr_mem_325671)[sext_i32_i64(local_tid_325663)] =\n                        x_325688;\n                }\n            }\n            offset_325713 *= 2;\n        }\n        while (slt32(skip_waves_325714,\n                     squot32(sext_i64_i32(segred_group_sizze_317329) +\n                             wave_sizze_325665 - 1, wave_sizze_325665))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_325713 = skip_waves_325714 * wave_sizze_325665;\n            if (slt32(local_tid_325663 + offset_325713,\n                      sext_i64_i32(segred_group_sizze_317329)) &&\n                ((local_tid_325663 - squot32(local_tid_325663,\n                                             wave_sizze_325665) *\n                  wave_sizze_325665) == 0 && (squot32(local_tid_325663,\n                                                      wave_sizze_325665) & (2 *\n                                                                            skip_waves_325714 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_325689 = ((__local\n                                 double *) red_arr_mem_325667)[sext_i32_i64(local_tid_325663 +\n                                                               offset_325713)];\n                    x_325690 = ((__local\n                                 int64_t *) red_arr_mem_325669)[sext_i32_i64(local_tid_325663 +\n             ",
            "                                                   offset_325713)];\n                    x_325691 = ((__local\n                                 int64_t *) red_arr_mem_325671)[sext_i32_i64(local_tid_325663 +\n                                                                offset_325713)];\n                }\n                // apply reduction operation\n                {\n                    bool cond_325692 = x_325688 == (int64_t) 0;\n                    bool cond_t_res_325693 = slt64((int64_t) 0, x_325691);\n                    bool x_325694 = cond_325692 && cond_t_res_325693;\n                    double defunc_1_op_res_325695;\n                    int64_t defunc_1_op_res_325696;\n                    \n                    if (x_325694) {\n                        defunc_1_op_res_325695 = x_325689;\n                        defunc_1_op_res_325696 = x_325690;\n                    } else {\n                        bool cond_325697 = slt64((int64_t) 0, x_325688);\n                        bool cond_t_res_325698 = x_325691 == (int64_t) 0;\n                        bool x_325699 = cond_325697 && cond_t_res_325698;\n                        double defunc_1_op_res_f_res_325700;\n                        int64_t defunc_1_op_res_f_res_325701;\n                        \n                        if (x_325699) {\n                            defunc_1_op_res_f_res_325700 = x_325686;\n                            defunc_1_op_res_f_res_325701 = x_325687;\n                        } else {\n                            bool cond_325702 = x_325689 < x_325686;\n                            double defunc_1_op_res_f_res_f_res_325703;\n                            int64_t defunc_1_op_res_f_res_f_res_325704;\n                            \n                            if (cond_325702) {\n                                defunc_1_op_res_f_res_f_res_325703 = x_325686;\n                                defunc_1_op_res_f_res_f_res_325704 = x_325687;\n                            } else {\n                                bool cond_325705 = x_32",
            "5686 < x_325689;\n                                double defunc_1_op_res_f_res_f_res_f_res_325706;\n                                int64_t\n                                defunc_1_op_res_f_res_f_res_f_res_325707;\n                                \n                                if (cond_325705) {\n                                    defunc_1_op_res_f_res_f_res_f_res_325706 =\n                                        x_325689;\n                                    defunc_1_op_res_f_res_f_res_f_res_325707 =\n                                        x_325690;\n                                } else {\n                                    bool cond_325708 = slt64(x_325687,\n                                                             x_325690);\n                                    double\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325709;\n                                    \n                                    if (cond_325708) {\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325709 =\n                                            x_325686;\n                                    } else {\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325709 =\n                                            x_325689;\n                                    }\n                                    \n                                    int64_t\n                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325710;\n                                    \n                                    if (cond_325708) {\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325710 =\n                                            x_325687;\n                                    } else {\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325710 =\n                                            x_325690;\n                                    }\n                                    defunc_1_op_",
            "res_f_res_f_res_f_res_325706 =\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325709;\n                                    defunc_1_op_res_f_res_f_res_f_res_325707 =\n                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325710;\n                                }\n                                defunc_1_op_res_f_res_f_res_325703 =\n                                    defunc_1_op_res_f_res_f_res_f_res_325706;\n                                defunc_1_op_res_f_res_f_res_325704 =\n                                    defunc_1_op_res_f_res_f_res_f_res_325707;\n                            }\n                            defunc_1_op_res_f_res_325700 =\n                                defunc_1_op_res_f_res_f_res_325703;\n                            defunc_1_op_res_f_res_325701 =\n                                defunc_1_op_res_f_res_f_res_325704;\n                        }\n                        defunc_1_op_res_325695 = defunc_1_op_res_f_res_325700;\n                        defunc_1_op_res_325696 = defunc_1_op_res_f_res_325701;\n                    }\n                    \n                    int64_t defunc_1_op_res_325711 = add64(x_325688, x_325691);\n                    \n                    x_325686 = defunc_1_op_res_325695;\n                    x_325687 = defunc_1_op_res_325696;\n                    x_325688 = defunc_1_op_res_325711;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_325667)[sext_i32_i64(local_tid_325663)] =\n                        x_325686;\n                    ((__local\n                      int64_t *) red_arr_mem_325669)[sext_i32_i64(local_tid_325663)] =\n                        x_325687;\n                    ((__local\n                      int64_t *) red_arr_mem_325671)[sext_i32_i64(local_tid_325663)] =\n                        x_325688;\n                }\n            }\n            skip_waves_325714 *= 2;\n        ",
            "}\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_325663) == (int64_t) 0) {\n                x_acc_325682 = x_325686;\n                x_acc_325683 = x_325687;\n                x_acc_325684 = x_325688;\n            }\n        }\n        if (groups_per_segment_325649 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_325663 == 0) {\n                    ((__global double *) mem_320397)[gtid_317335] =\n                        x_acc_325682;\n                    ((__global int64_t *) mem_320400)[gtid_317335] =\n                        x_acc_325683;\n                    ((__global int64_t *) mem_320403)[gtid_317335] =\n                        x_acc_325684;\n                }\n            }\n        } else {\n            int32_t old_counter_325715;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_325663 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_325654)[sext_i32_i64(virt_group_id_325677)] =\n                        x_acc_325682;\n                    ((__global\n                      int64_t *) segred_tmp_mem_325656)[sext_i32_i64(virt_group_id_325677)] =\n                        x_acc_325683;\n                    ((__global\n                      int64_t *) segred_tmp_mem_325658)[sext_i32_i64(virt_group_id_325677)] =\n                        x_acc_325684;\n                    mem_fence_global();\n                    old_counter_325715 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_325660)[sext_i32_i64(srem32(flat_segment_id_325678,\n                                                                                                      10240))],\n                                              (int) 1);\n                 ",
            "   ((__local bool *) sync_arr_mem_325673)[(int64_t) 0] =\n                        old_counter_325715 == groups_per_segment_325649 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_325716;\n            \n            is_last_group_325716 = ((__local\n                                     bool *) sync_arr_mem_325673)[(int64_t) 0];\n            if (is_last_group_325716) {\n                if (local_tid_325663 == 0) {\n                    old_counter_325715 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_325660)[sext_i32_i64(srem32(flat_segment_id_325678,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_325649));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_325717 =\n                            sdiv_up64(groups_per_segment_325649,\n                                      segred_group_sizze_317329);\n                    \n                    x_317338 = -INFINITY;\n                    x_317339 = (int64_t) -1;\n                    x_317340 = (int64_t) 0;\n                    for (int64_t i_325718 = 0; i_325718 <\n                         read_per_thread_325717; i_325718++) {\n                        int64_t group_res_id_325719 =\n                                sext_i32_i64(local_tid_325663) *\n                                read_per_thread_325717 + i_325718;\n                        int64_t index_of_group_res_325720 =\n                                sext_i32_i64(flat_segment_id_325678) *\n                                groups_per_segment_325649 + group_res_id_325719;\n                        \n",
            "                        if (slt64(group_res_id_325719,\n                                  groups_per_segment_325649)) {\n                            x_317341 = ((__global\n                                         double *) segred_tmp_mem_325654)[index_of_group_res_325720];\n                            x_317342 = ((__global\n                                         int64_t *) segred_tmp_mem_325656)[index_of_group_res_325720];\n                            x_317343 = ((__global\n                                         int64_t *) segred_tmp_mem_325658)[index_of_group_res_325720];\n                            \n                            bool cond_317344 = x_317340 == (int64_t) 0;\n                            bool cond_t_res_317345 = slt64((int64_t) 0,\n                                                           x_317343);\n                            bool x_317346 = cond_317344 && cond_t_res_317345;\n                            double defunc_1_op_res_317347;\n                            int64_t defunc_1_op_res_317348;\n                            \n                            if (x_317346) {\n                                defunc_1_op_res_317347 = x_317341;\n                                defunc_1_op_res_317348 = x_317342;\n                            } else {\n                                bool cond_317349 = slt64((int64_t) 0, x_317340);\n                                bool cond_t_res_317350 = x_317343 ==\n                                     (int64_t) 0;\n                                bool x_317351 = cond_317349 &&\n                                     cond_t_res_317350;\n                                double defunc_1_op_res_f_res_317352;\n                                int64_t defunc_1_op_res_f_res_317353;\n                                \n                                if (x_317351) {\n                                    defunc_1_op_res_f_res_317352 = x_317338;\n                                    defunc_1_op_res_f_res_317353 = x_317339;\n                                } else {\n     ",
            "                               bool cond_317354 = x_317341 < x_317338;\n                                    double defunc_1_op_res_f_res_f_res_317355;\n                                    int64_t defunc_1_op_res_f_res_f_res_317356;\n                                    \n                                    if (cond_317354) {\n                                        defunc_1_op_res_f_res_f_res_317355 =\n                                            x_317338;\n                                        defunc_1_op_res_f_res_f_res_317356 =\n                                            x_317339;\n                                    } else {\n                                        bool cond_317357 = x_317338 < x_317341;\n                                        double\n                                        defunc_1_op_res_f_res_f_res_f_res_317358;\n                                        int64_t\n                                        defunc_1_op_res_f_res_f_res_f_res_317359;\n                                        \n                                        if (cond_317357) {\n                                            defunc_1_op_res_f_res_f_res_f_res_317358 =\n                                                x_317341;\n                                            defunc_1_op_res_f_res_f_res_f_res_317359 =\n                                                x_317342;\n                                        } else {\n                                            bool cond_317360 = slt64(x_317339,\n                                                                     x_317342);\n                                            double\n                                            defunc_1_op_res_f_res_f_res_f_res_f_res_317361;\n                                            \n                                            if (cond_317360) {\n                                                defunc_1_op_res_f_res_f_res_f_res_f_res_317361 =\n                                                    x_317338;\n                        ",
            "                    } else {\n                                                defunc_1_op_res_f_res_f_res_f_res_f_res_317361 =\n                                                    x_317341;\n                                            }\n                                            \n                                            int64_t\n                                            defunc_1_op_res_f_res_f_res_f_res_f_res_317362;\n                                            \n                                            if (cond_317360) {\n                                                defunc_1_op_res_f_res_f_res_f_res_f_res_317362 =\n                                                    x_317339;\n                                            } else {\n                                                defunc_1_op_res_f_res_f_res_f_res_f_res_317362 =\n                                                    x_317342;\n                                            }\n                                            defunc_1_op_res_f_res_f_res_f_res_317358 =\n                                                defunc_1_op_res_f_res_f_res_f_res_f_res_317361;\n                                            defunc_1_op_res_f_res_f_res_f_res_317359 =\n                                                defunc_1_op_res_f_res_f_res_f_res_f_res_317362;\n                                        }\n                                        defunc_1_op_res_f_res_f_res_317355 =\n                                            defunc_1_op_res_f_res_f_res_f_res_317358;\n                                        defunc_1_op_res_f_res_f_res_317356 =\n                                            defunc_1_op_res_f_res_f_res_f_res_317359;\n                                    }\n                                    defunc_1_op_res_f_res_317352 =\n                                        defunc_1_op_res_f_res_f_res_317355;\n                                    defunc_1_op_res_f_res_317353 =\n                                        defunc_1_op_res_f_res_f_res_31",
            "7356;\n                                }\n                                defunc_1_op_res_317347 =\n                                    defunc_1_op_res_f_res_317352;\n                                defunc_1_op_res_317348 =\n                                    defunc_1_op_res_f_res_317353;\n                            }\n                            \n                            int64_t defunc_1_op_res_317363 = add64(x_317340,\n                                                                   x_317343);\n                            \n                            x_317338 = defunc_1_op_res_317347;\n                            x_317339 = defunc_1_op_res_317348;\n                            x_317340 = defunc_1_op_res_317363;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_325667)[sext_i32_i64(local_tid_325663)] =\n                    x_317338;\n                ((__local\n                  int64_t *) red_arr_mem_325669)[sext_i32_i64(local_tid_325663)] =\n                    x_317339;\n                ((__local\n                  int64_t *) red_arr_mem_325671)[sext_i32_i64(local_tid_325663)] =\n                    x_317340;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_325721;\n                    int32_t skip_waves_325722 = 1;\n                    double x_325686;\n                    int64_t x_325687;\n                    int64_t x_325688;\n                    double x_325689;\n                    int64_t x_325690;\n                    int64_t x_325691;\n                    \n                    offset_325721 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_325663,\n                                  sext_i64_i32(segred_group_sizze_317329))) {\n                            x_325686 = ((__local\n                                     ",
            "    double *) red_arr_mem_325667)[sext_i32_i64(local_tid_325663 +\n                                                                       offset_325721)];\n                            x_325687 = ((__local\n                                         int64_t *) red_arr_mem_325669)[sext_i32_i64(local_tid_325663 +\n                                                                        offset_325721)];\n                            x_325688 = ((__local\n                                         int64_t *) red_arr_mem_325671)[sext_i32_i64(local_tid_325663 +\n                                                                        offset_325721)];\n                        }\n                    }\n                    offset_325721 = 1;\n                    while (slt32(offset_325721, wave_sizze_325665)) {\n                        if (slt32(local_tid_325663 + offset_325721,\n                                  sext_i64_i32(segred_group_sizze_317329)) &&\n                            ((local_tid_325663 - squot32(local_tid_325663,\n                                                         wave_sizze_325665) *\n                              wave_sizze_325665) & (2 * offset_325721 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_325689 = ((volatile __local\n                                             double *) red_arr_mem_325667)[sext_i32_i64(local_tid_325663 +\n                                                                           offset_325721)];\n                                x_325690 = ((volatile __local\n                                             int64_t *) red_arr_mem_325669)[sext_i32_i64(local_tid_325663 +\n                                                                            offset_325721)];\n                                x_325691 = ((volatile __local\n                                             int64_t *) red_arr_mem_325671)[sext_i32_i64(local_tid_325663 +\n                    ",
            "                                                        offset_325721)];\n                            }\n                            // apply reduction operation\n                            {\n                                bool cond_325692 = x_325688 == (int64_t) 0;\n                                bool cond_t_res_325693 = slt64((int64_t) 0,\n                                                               x_325691);\n                                bool x_325694 = cond_325692 &&\n                                     cond_t_res_325693;\n                                double defunc_1_op_res_325695;\n                                int64_t defunc_1_op_res_325696;\n                                \n                                if (x_325694) {\n                                    defunc_1_op_res_325695 = x_325689;\n                                    defunc_1_op_res_325696 = x_325690;\n                                } else {\n                                    bool cond_325697 = slt64((int64_t) 0,\n                                                             x_325688);\n                                    bool cond_t_res_325698 = x_325691 ==\n                                         (int64_t) 0;\n                                    bool x_325699 = cond_325697 &&\n                                         cond_t_res_325698;\n                                    double defunc_1_op_res_f_res_325700;\n                                    int64_t defunc_1_op_res_f_res_325701;\n                                    \n                                    if (x_325699) {\n                                        defunc_1_op_res_f_res_325700 = x_325686;\n                                        defunc_1_op_res_f_res_325701 = x_325687;\n                                    } else {\n                                        bool cond_325702 = x_325689 < x_325686;\n                                        double\n                                        defunc_1_op_res_f_res_f_res_325703;\n                            ",
            "            int64_t\n                                        defunc_1_op_res_f_res_f_res_325704;\n                                        \n                                        if (cond_325702) {\n                                            defunc_1_op_res_f_res_f_res_325703 =\n                                                x_325686;\n                                            defunc_1_op_res_f_res_f_res_325704 =\n                                                x_325687;\n                                        } else {\n                                            bool cond_325705 = x_325686 <\n                                                 x_325689;\n                                            double\n                                            defunc_1_op_res_f_res_f_res_f_res_325706;\n                                            int64_t\n                                            defunc_1_op_res_f_res_f_res_f_res_325707;\n                                            \n                                            if (cond_325705) {\n                                                defunc_1_op_res_f_res_f_res_f_res_325706 =\n                                                    x_325689;\n                                                defunc_1_op_res_f_res_f_res_f_res_325707 =\n                                                    x_325690;\n                                            } else {\n                                                bool cond_325708 =\n                                                     slt64(x_325687, x_325690);\n                                                double\n                                                defunc_1_op_res_f_res_f_res_f_res_f_res_325709;\n                                                \n                                                if (cond_325708) {\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325709 =\n                                                        x_325686;\n                     ",
            "                           } else {\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325709 =\n                                                        x_325689;\n                                                }\n                                                \n                                                int64_t\n                                                defunc_1_op_res_f_res_f_res_f_res_f_res_325710;\n                                                \n                                                if (cond_325708) {\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325710 =\n                                                        x_325687;\n                                                } else {\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325710 =\n                                                        x_325690;\n                                                }\n                                                defunc_1_op_res_f_res_f_res_f_res_325706 =\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325709;\n                                                defunc_1_op_res_f_res_f_res_f_res_325707 =\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325710;\n                                            }\n                                            defunc_1_op_res_f_res_f_res_325703 =\n                                                defunc_1_op_res_f_res_f_res_f_res_325706;\n                                            defunc_1_op_res_f_res_f_res_325704 =\n                                                defunc_1_op_res_f_res_f_res_f_res_325707;\n                                        }\n                                        defunc_1_op_res_f_res_325700 =\n                                            defunc_1_op_res_f_res_f_res_325703;\n                          ",
            "              defunc_1_op_res_f_res_325701 =\n                                            defunc_1_op_res_f_res_f_res_325704;\n                                    }\n                                    defunc_1_op_res_325695 =\n                                        defunc_1_op_res_f_res_325700;\n                                    defunc_1_op_res_325696 =\n                                        defunc_1_op_res_f_res_325701;\n                                }\n                                \n                                int64_t defunc_1_op_res_325711 = add64(x_325688,\n                                                                       x_325691);\n                                \n                                x_325686 = defunc_1_op_res_325695;\n                                x_325687 = defunc_1_op_res_325696;\n                                x_325688 = defunc_1_op_res_325711;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_325667)[sext_i32_i64(local_tid_325663)] =\n                                    x_325686;\n                                ((volatile __local\n                                  int64_t *) red_arr_mem_325669)[sext_i32_i64(local_tid_325663)] =\n                                    x_325687;\n                                ((volatile __local\n                                  int64_t *) red_arr_mem_325671)[sext_i32_i64(local_tid_325663)] =\n                                    x_325688;\n                            }\n                        }\n                        offset_325721 *= 2;\n                    }\n                    while (slt32(skip_waves_325722,\n                                 squot32(sext_i64_i32(segred_group_sizze_317329) +\n                                         wave_sizze_325665 - 1,\n                                         wave_sizze_325665))) {\n                      ",
            "  barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_325721 = skip_waves_325722 * wave_sizze_325665;\n                        if (slt32(local_tid_325663 + offset_325721,\n                                  sext_i64_i32(segred_group_sizze_317329)) &&\n                            ((local_tid_325663 - squot32(local_tid_325663,\n                                                         wave_sizze_325665) *\n                              wave_sizze_325665) == 0 &&\n                             (squot32(local_tid_325663, wave_sizze_325665) &\n                              (2 * skip_waves_325722 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_325689 = ((__local\n                                             double *) red_arr_mem_325667)[sext_i32_i64(local_tid_325663 +\n                                                                           offset_325721)];\n                                x_325690 = ((__local\n                                             int64_t *) red_arr_mem_325669)[sext_i32_i64(local_tid_325663 +\n                                                                            offset_325721)];\n                                x_325691 = ((__local\n                                             int64_t *) red_arr_mem_325671)[sext_i32_i64(local_tid_325663 +\n                                                                            offset_325721)];\n                            }\n                            // apply reduction operation\n                            {\n                                bool cond_325692 = x_325688 == (int64_t) 0;\n                                bool cond_t_res_325693 = slt64((int64_t) 0,\n                                                               x_325691);\n                                bool x_325694 = cond_325692 &&\n                                     cond_t_res_325693;\n                                double defunc_1_op_res_325695;\n                       ",
            "         int64_t defunc_1_op_res_325696;\n                                \n                                if (x_325694) {\n                                    defunc_1_op_res_325695 = x_325689;\n                                    defunc_1_op_res_325696 = x_325690;\n                                } else {\n                                    bool cond_325697 = slt64((int64_t) 0,\n                                                             x_325688);\n                                    bool cond_t_res_325698 = x_325691 ==\n                                         (int64_t) 0;\n                                    bool x_325699 = cond_325697 &&\n                                         cond_t_res_325698;\n                                    double defunc_1_op_res_f_res_325700;\n                                    int64_t defunc_1_op_res_f_res_325701;\n                                    \n                                    if (x_325699) {\n                                        defunc_1_op_res_f_res_325700 = x_325686;\n                                        defunc_1_op_res_f_res_325701 = x_325687;\n                                    } else {\n                                        bool cond_325702 = x_325689 < x_325686;\n                                        double\n                                        defunc_1_op_res_f_res_f_res_325703;\n                                        int64_t\n                                        defunc_1_op_res_f_res_f_res_325704;\n                                        \n                                        if (cond_325702) {\n                                            defunc_1_op_res_f_res_f_res_325703 =\n                                                x_325686;\n                                            defunc_1_op_res_f_res_f_res_325704 =\n                                                x_325687;\n                                        } else {\n                                            bool cond_325705 = x_325686 <\n                        ",
            "                         x_325689;\n                                            double\n                                            defunc_1_op_res_f_res_f_res_f_res_325706;\n                                            int64_t\n                                            defunc_1_op_res_f_res_f_res_f_res_325707;\n                                            \n                                            if (cond_325705) {\n                                                defunc_1_op_res_f_res_f_res_f_res_325706 =\n                                                    x_325689;\n                                                defunc_1_op_res_f_res_f_res_f_res_325707 =\n                                                    x_325690;\n                                            } else {\n                                                bool cond_325708 =\n                                                     slt64(x_325687, x_325690);\n                                                double\n                                                defunc_1_op_res_f_res_f_res_f_res_f_res_325709;\n                                                \n                                                if (cond_325708) {\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325709 =\n                                                        x_325686;\n                                                } else {\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325709 =\n                                                        x_325689;\n                                                }\n                                                \n                                                int64_t\n                                                defunc_1_op_res_f_res_f_res_f_res_f_res_325710;\n                                                \n                                                if (cond_325708) {\n                                                   ",
            " defunc_1_op_res_f_res_f_res_f_res_f_res_325710 =\n                                                        x_325687;\n                                                } else {\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325710 =\n                                                        x_325690;\n                                                }\n                                                defunc_1_op_res_f_res_f_res_f_res_325706 =\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325709;\n                                                defunc_1_op_res_f_res_f_res_f_res_325707 =\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_325710;\n                                            }\n                                            defunc_1_op_res_f_res_f_res_325703 =\n                                                defunc_1_op_res_f_res_f_res_f_res_325706;\n                                            defunc_1_op_res_f_res_f_res_325704 =\n                                                defunc_1_op_res_f_res_f_res_f_res_325707;\n                                        }\n                                        defunc_1_op_res_f_res_325700 =\n                                            defunc_1_op_res_f_res_f_res_325703;\n                                        defunc_1_op_res_f_res_325701 =\n                                            defunc_1_op_res_f_res_f_res_325704;\n                                    }\n                                    defunc_1_op_res_325695 =\n                                        defunc_1_op_res_f_res_325700;\n                                    defunc_1_op_res_325696 =\n                                        defunc_1_op_res_f_res_325701;\n                                }\n                                \n                                int64_t defunc_1_op_res_325711 = add64(x_325688,\n                                                ",
            "                       x_325691);\n                                \n                                x_325686 = defunc_1_op_res_325695;\n                                x_325687 = defunc_1_op_res_325696;\n                                x_325688 = defunc_1_op_res_325711;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  double *) red_arr_mem_325667)[sext_i32_i64(local_tid_325663)] =\n                                    x_325686;\n                                ((__local\n                                  int64_t *) red_arr_mem_325669)[sext_i32_i64(local_tid_325663)] =\n                                    x_325687;\n                                ((__local\n                                  int64_t *) red_arr_mem_325671)[sext_i32_i64(local_tid_325663)] =\n                                    x_325688;\n                            }\n                        }\n                        skip_waves_325722 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_325663 == 0) {\n                            ((__global double *) mem_320397)[gtid_317335] =\n                                x_325686;\n                            ((__global int64_t *) mem_320400)[gtid_317335] =\n                                x_325687;\n                            ((__global int64_t *) mem_320403)[gtid_317335] =\n                                x_325688;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_317329\n}\n__kernel void mainzisegred_large_325358(__global int *global_failure,\n                                        uint sync_arr_mem_325403_backing_offset_0,\n                                        uint red_arr_mem_",
            "325401_backing_offset_1,\n                                        int64_t replicate_arg_297080,\n                                        int64_t num_groups_316941,\n                                        int32_t num_subhistos_325275,\n                                        int64_t groups_per_segment_325387,\n                                        int64_t elements_per_thread_325388,\n                                        int64_t virt_num_groups_325389,\n                                        int64_t threads_per_segment_325391,\n                                        __global unsigned char *mem_320269,\n                                        __global\n                                        unsigned char *defunc_1_map_res_subhistos_mem_325276,\n                                        __global\n                                        unsigned char *segred_tmp_mem_325392,\n                                        __global\n                                        unsigned char *mainzicounter_mem_325394)\n{\n    #define seghist_group_sizze_316939 (mainziseghist_group_sizze_316938)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_325403_backing_1 =\n                           &shared_mem[sync_arr_mem_325403_backing_offset_0];\n    volatile unsigned char *red_arr_mem_325401_backing_0 =\n                           &shared_mem[red_arr_mem_325401_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325396;\n    int32_t local_tid_325397;\n    int64_t group_sizze_325400;\n    int32_t wave_sizze_325399;\n    int32_t group_tid_325398;\n    \n    global_tid_325396 = get_global_id(0);\n    local_tid_325397 = get_local_id(0);\n    group_sizze_325400 = get_local_size(0);\n    wave_sizze_325399 = LOCKSTEP_WIDTH;\n    group_tid_325398 = get_group_id(0);\n    \n    int32_t flat_gtid_325358 = global_tid_325396;\n    __local unsigned char *red_arr_mem_325401;\n    \n    red_arr_mem_3254",
            "01 = (__local unsigned char *) red_arr_mem_325401_backing_0;\n    \n    __local unsigned char *sync_arr_mem_325403;\n    \n    sync_arr_mem_325403 = (__local\n                           unsigned char *) sync_arr_mem_325403_backing_1;\n    \n    int32_t phys_group_id_325405;\n    \n    phys_group_id_325405 = get_group_id(0);\n    for (int32_t i_325406 = 0; i_325406 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_325389) - phys_group_id_325405,\n                   sext_i64_i32(num_groups_316941)); i_325406++) {\n        int32_t virt_group_id_325407 = phys_group_id_325405 + i_325406 *\n                sext_i64_i32(num_groups_316941);\n        int32_t flat_segment_id_325408 = squot32(virt_group_id_325407,\n                                                 sext_i64_i32(groups_per_segment_325387));\n        int64_t global_tid_325409 = srem64(sext_i32_i64(virt_group_id_325407) *\n                                           seghist_group_sizze_316939 +\n                                           sext_i32_i64(local_tid_325397),\n                                           seghist_group_sizze_316939 *\n                                           groups_per_segment_325387);\n        int64_t slice_325410 = replicate_arg_297080;\n        int64_t bucket_id_325356 = sext_i32_i64(flat_segment_id_325408);\n        int64_t remnant_325411 = sext_i32_i64(flat_segment_id_325408) -\n                bucket_id_325356;\n        int64_t subhistogram_id_325357;\n        int32_t x_acc_325412;\n        int64_t chunk_sizze_325413 = smin64(elements_per_thread_325388,\n                                            sdiv_up64(num_subhistos_325275 -\n                                                      global_tid_325409,\n                                                      threads_per_segment_325391));\n        int32_t x_316947;\n        int32_t x_316948;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_325412 = 0;\n        }\n        for (int64_t i_325417 = 0; i_325417 < chunk_sizze_325413; i_325417",
            "++) {\n            subhistogram_id_325357 = global_tid_325409 +\n                threads_per_segment_325391 * i_325417;\n            // apply map function\n            {\n                // load accumulator\n                {\n                    x_316947 = x_acc_325412;\n                }\n                // load new values\n                {\n                    x_316948 = ((__global\n                                 int32_t *) defunc_1_map_res_subhistos_mem_325276)[subhistogram_id_325357 *\n                                                                                   replicate_arg_297080 +\n                                                                                   bucket_id_325356];\n                }\n                // apply reduction operator\n                {\n                    int32_t defunc_1_f_res_316949 = add32(x_316947, x_316948);\n                    \n                    // store in accumulator\n                    {\n                        x_acc_325412 = defunc_1_f_res_316949;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_316947 = x_acc_325412;\n            ((__local\n              int32_t *) red_arr_mem_325401)[sext_i32_i64(local_tid_325397)] =\n                x_316947;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_325418;\n        int32_t skip_waves_325419 = 1;\n        int32_t x_325414;\n        int32_t x_325415;\n        \n        offset_325418 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_325397,\n                      sext_i64_i32(seghist_group_sizze_316939))) {\n                x_325414 = ((__local\n                             int32_t *) red_arr_mem_325401)[sext_i32_i64(local_tid_325397 +\n                                                            offset_325418)];\n            }\n        }\n        offset_325418 = 1;\n        while (slt32(offset_325418, wave_siz",
            "ze_325399)) {\n            if (slt32(local_tid_325397 + offset_325418,\n                      sext_i64_i32(seghist_group_sizze_316939)) &&\n                ((local_tid_325397 - squot32(local_tid_325397,\n                                             wave_sizze_325399) *\n                  wave_sizze_325399) & (2 * offset_325418 - 1)) == 0) {\n                // read array element\n                {\n                    x_325415 = ((volatile __local\n                                 int32_t *) red_arr_mem_325401)[sext_i32_i64(local_tid_325397 +\n                                                                offset_325418)];\n                }\n                // apply reduction operation\n                {\n                    int32_t defunc_1_f_res_325416 = add32(x_325414, x_325415);\n                    \n                    x_325414 = defunc_1_f_res_325416;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      int32_t *) red_arr_mem_325401)[sext_i32_i64(local_tid_325397)] =\n                        x_325414;\n                }\n            }\n            offset_325418 *= 2;\n        }\n        while (slt32(skip_waves_325419,\n                     squot32(sext_i64_i32(seghist_group_sizze_316939) +\n                             wave_sizze_325399 - 1, wave_sizze_325399))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_325418 = skip_waves_325419 * wave_sizze_325399;\n            if (slt32(local_tid_325397 + offset_325418,\n                      sext_i64_i32(seghist_group_sizze_316939)) &&\n                ((local_tid_325397 - squot32(local_tid_325397,\n                                             wave_sizze_325399) *\n                  wave_sizze_325399) == 0 && (squot32(local_tid_325397,\n                                                      wave_sizze_325399) & (2 *\n                                                                            skip_waves_325419 -\n                                 ",
            "                                           1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_325415 = ((__local\n                                 int32_t *) red_arr_mem_325401)[sext_i32_i64(local_tid_325397 +\n                                                                offset_325418)];\n                }\n                // apply reduction operation\n                {\n                    int32_t defunc_1_f_res_325416 = add32(x_325414, x_325415);\n                    \n                    x_325414 = defunc_1_f_res_325416;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      int32_t *) red_arr_mem_325401)[sext_i32_i64(local_tid_325397)] =\n                        x_325414;\n                }\n            }\n            skip_waves_325419 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_325397) == (int64_t) 0) {\n                x_acc_325412 = x_325414;\n            }\n        }\n        if (groups_per_segment_325387 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_325397 == 0) {\n                    ((__global int32_t *) mem_320269)[bucket_id_325356] =\n                        x_acc_325412;\n                }\n            }\n        } else {\n            int32_t old_counter_325420;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_325397 == 0) {\n                    ((__global\n                      int32_t *) segred_tmp_mem_325392)[sext_i32_i64(virt_group_id_325407)] =\n                        x_acc_325412;\n                    mem_fence_global();\n                    old_counter_325420 =\n                        atomic_add_i32_global(&((volatile __global\n                                    ",
            "             int *) mainzicounter_mem_325394)[sext_i32_i64(srem32(flat_segment_id_325408,\n                                                                                                      10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_325403)[(int64_t) 0] =\n                        old_counter_325420 == groups_per_segment_325387 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_325421;\n            \n            is_last_group_325421 = ((__local\n                                     bool *) sync_arr_mem_325403)[(int64_t) 0];\n            if (is_last_group_325421) {\n                if (local_tid_325397 == 0) {\n                    old_counter_325420 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) mainzicounter_mem_325394)[sext_i32_i64(srem32(flat_segment_id_325408,\n                                                                                                      10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_325387));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_325422 =\n                            sdiv_up64(groups_per_segment_325387,\n                                      seghist_group_sizze_316939);\n                    \n                    x_316947 = 0;\n                    for (int64_t i_325423 = 0; i_325423 <\n                         read_per_thread_325422; i_325423++) {\n                        int64_t group_res_id_325424 =\n                                sext_i32_i64(local_tid_325397) *\n                                read_per_thread_325422 + i_325423;\n                        int64_t index_of_group_res_325425 ",
            "=\n                                sext_i32_i64(flat_segment_id_325408) *\n                                groups_per_segment_325387 + group_res_id_325424;\n                        \n                        if (slt64(group_res_id_325424,\n                                  groups_per_segment_325387)) {\n                            x_316948 = ((__global\n                                         int32_t *) segred_tmp_mem_325392)[index_of_group_res_325425];\n                            \n                            int32_t defunc_1_f_res_316949 = add32(x_316947,\n                                                                  x_316948);\n                            \n                            x_316947 = defunc_1_f_res_316949;\n                        }\n                    }\n                }\n                ((__local\n                  int32_t *) red_arr_mem_325401)[sext_i32_i64(local_tid_325397)] =\n                    x_316947;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_325426;\n                    int32_t skip_waves_325427 = 1;\n                    int32_t x_325414;\n                    int32_t x_325415;\n                    \n                    offset_325426 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_325397,\n                                  sext_i64_i32(seghist_group_sizze_316939))) {\n                            x_325414 = ((__local\n                                         int32_t *) red_arr_mem_325401)[sext_i32_i64(local_tid_325397 +\n                                                                        offset_325426)];\n                        }\n                    }\n                    offset_325426 = 1;\n                    while (slt32(offset_325426, wave_sizze_325399)) {\n                        if (slt32(local_tid_325397 + offset_325426,\n                                  sext_",
            "i64_i32(seghist_group_sizze_316939)) &&\n                            ((local_tid_325397 - squot32(local_tid_325397,\n                                                         wave_sizze_325399) *\n                              wave_sizze_325399) & (2 * offset_325426 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_325415 = ((volatile __local\n                                             int32_t *) red_arr_mem_325401)[sext_i32_i64(local_tid_325397 +\n                                                                            offset_325426)];\n                            }\n                            // apply reduction operation\n                            {\n                                int32_t defunc_1_f_res_325416 = add32(x_325414,\n                                                                      x_325415);\n                                \n                                x_325414 = defunc_1_f_res_325416;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  int32_t *) red_arr_mem_325401)[sext_i32_i64(local_tid_325397)] =\n                                    x_325414;\n                            }\n                        }\n                        offset_325426 *= 2;\n                    }\n                    while (slt32(skip_waves_325427,\n                                 squot32(sext_i64_i32(seghist_group_sizze_316939) +\n                                         wave_sizze_325399 - 1,\n                                         wave_sizze_325399))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_325426 = skip_waves_325427 * wave_sizze_325399;\n                        if (slt32(local_tid_325397 + offset_325426,\n                                  sext_i64_i32(seghist_group_sizze_316939))",
            " &&\n                            ((local_tid_325397 - squot32(local_tid_325397,\n                                                         wave_sizze_325399) *\n                              wave_sizze_325399) == 0 &&\n                             (squot32(local_tid_325397, wave_sizze_325399) &\n                              (2 * skip_waves_325427 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_325415 = ((__local\n                                             int32_t *) red_arr_mem_325401)[sext_i32_i64(local_tid_325397 +\n                                                                            offset_325426)];\n                            }\n                            // apply reduction operation\n                            {\n                                int32_t defunc_1_f_res_325416 = add32(x_325414,\n                                                                      x_325415);\n                                \n                                x_325414 = defunc_1_f_res_325416;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  int32_t *) red_arr_mem_325401)[sext_i32_i64(local_tid_325397)] =\n                                    x_325414;\n                            }\n                        }\n                        skip_waves_325427 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_325397 == 0) {\n                            ((__global\n                              int32_t *) mem_320269)[bucket_id_325356] =\n                                x_325414;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef seghist_gro",
            "up_sizze_316939\n}\n__kernel void mainzisegred_small_304643(__global int *global_failure,\n                                        uint red_arr_mem_321884_backing_offset_0,\n                                        int64_t n_p_292677, int64_t q_s_292678,\n                                        int64_t partition_sizze_292766,\n                                        int64_t defunc_0_f_res_292820,\n                                        int64_t s_n_m_292825,\n                                        int64_t num_groups_304636,\n                                        int64_t segment_sizze_nonzzero_321877,\n                                        __global unsigned char *ext_mem_318609,\n                                        __global unsigned char *ext_mem_318610,\n                                        __global unsigned char *ext_mem_318707,\n                                        __global unsigned char *ext_mem_318708,\n                                        __global unsigned char *mem_318876,\n                                        __global unsigned char *mem_319056,\n                                        __global unsigned char *mem_319066)\n{\n    #define segred_group_sizze_304635 (mainzisegred_group_sizze_303989)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_321884_backing_0 =\n                           &shared_mem[red_arr_mem_321884_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321879;\n    int32_t local_tid_321880;\n    int64_t group_sizze_321883;\n    int32_t wave_sizze_321882;\n    int32_t group_tid_321881;\n    \n    global_tid_321879 = get_global_id(0);\n    local_tid_321880 = get_local_id(0);\n    group_sizze_321883 = get_local_size(0);\n    wave_sizze_321882 = LOCKSTEP_WIDTH;\n    group_tid_321881 = get_group_id(0);\n    \n    int32_t phys_tid_304643 = global_tid_321879;\n    __local unsigned char *red_arr_mem_321884;\n    \n    red_arr_mem_321",
            "884 = (__local unsigned char *) red_arr_mem_321884_backing_0;\n    \n    int32_t phys_group_id_321886;\n    \n    phys_group_id_321886 = get_group_id(0);\n    for (int32_t i_321887 = 0; i_321887 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * n_p_292677 *\n                                          s_n_m_292825,\n                                          squot64(segred_group_sizze_304635,\n                                                  segment_sizze_nonzzero_321877))) -\n                   phys_group_id_321886, sext_i64_i32(num_groups_304636));\n         i_321887++) {\n        int32_t virt_group_id_321888 = phys_group_id_321886 + i_321887 *\n                sext_i64_i32(num_groups_304636);\n        int64_t slice_321889 = s_n_m_292825;\n        int64_t slice_321890 = n_p_292677 * slice_321889;\n        int64_t slice_321891 = partition_sizze_292766 * slice_321890;\n        int64_t gtid_304639 = squot64(squot64(sext_i32_i64(local_tid_321880),\n                                              segment_sizze_nonzzero_321877) +\n                                      sext_i32_i64(virt_group_id_321888) *\n                                      squot64(segred_group_sizze_304635,\n                                              segment_sizze_nonzzero_321877),\n                                      slice_321890);\n        int64_t remnant_321892 = squot64(sext_i32_i64(local_tid_321880),\n                                         segment_sizze_nonzzero_321877) +\n                sext_i32_i64(virt_group_id_321888) *\n                squot64(segred_group_sizze_304635,\n                        segment_sizze_nonzzero_321877) - gtid_304639 *\n                slice_321890;\n        int64_t gtid_304640 = squot64(remnant_321892, slice_321889);\n        int64_t remnant_321893 = remnant_321892 - gtid_304640 * slice_321889;\n        int64_t gtid_304641 = remnant_321893;\n        int64_t remnant_321894 = remnant_321893 - gtid_304641;\n        int64_t gtid_304642 = srem64(sext_i32_i64(local_tid_321880),\n    ",
            "                                 q_s_292678);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_s_292678) && (((slt64(gtid_304639,\n                                                           partition_sizze_292766) &&\n                                                     slt64(gtid_304640,\n                                                           n_p_292677)) &&\n                                                    slt64(gtid_304641,\n                                                          s_n_m_292825)) &&\n                                                   slt64(sext_i32_i64(local_tid_321880),\n                                                         q_s_292678 *\n                                                         squot64(segred_group_sizze_304635,\n                                                                 segment_sizze_nonzzero_321877)))) {\n                int64_t x_304655;\n                \n                x_304655 = ((__global int64_t *) ext_mem_318609)[gtid_304639 *\n                                                                 n_p_292677 +\n                                                                 gtid_304640];\n                \n                int64_t x_304659;\n                \n                x_304659 = ((__global int64_t *) ext_mem_318708)[gtid_304639 *\n                                                                 (s_n_m_292825 *\n                                                                  n_p_292677) +\n                                                                 gtid_304640 *\n                                                                 s_n_m_292825 +\n                                                                 gtid_304641];\n                \n                double x_304660;\n                \n                x_304660 = ((__global double *) ext_mem_318707)[gtid_304639 *\n                                                                (s_n_m_292825 *\n                              ",
            "                                   n_p_292677) +\n                                                                gtid_304640 *\n                                                                s_n_m_292825 +\n                                                                gtid_304641];\n                \n                int64_t defunc_0_m_fun_res_304661;\n                \n                defunc_0_m_fun_res_304661 = ((__global\n                                              int64_t *) mem_319056)[gtid_304639 *\n                                                                     (s_n_m_292825 *\n                                                                      n_p_292677) +\n                                                                     gtid_304640 *\n                                                                     s_n_m_292825 +\n                                                                     gtid_304641];\n                \n                bool cond_304663 = sle64(x_304655, gtid_304642);\n                int64_t defunc_0_f_res_304664;\n                \n                if (cond_304663) {\n                    defunc_0_f_res_304664 = (int64_t) 0;\n                } else {\n                    int64_t i_304665 = add64(gtid_304642, x_304659);\n                    int64_t defunc_0_add_arg_304666;\n                    \n                    defunc_0_add_arg_304666 = ((__global\n                                                int64_t *) ext_mem_318610)[gtid_304639 *\n                                                                           (defunc_0_f_res_292820 *\n                                                                            n_p_292677) +\n                                                                           gtid_304640 *\n                                                                           defunc_0_f_res_292820 +\n                                                                           i_304665];\n                    \n                    int64_t defunc_1_",
            "add_res_304667 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_304666);\n                    \n                    defunc_0_f_res_304664 = defunc_1_add_res_304667;\n                }\n                \n                double defunc_0_f_res_304668;\n                \n                if (cond_304663) {\n                    defunc_0_f_res_304668 = 0.0;\n                } else {\n                    int64_t i_304669 = add64(gtid_304642, x_304659);\n                    double defunc_0_add_arg_304670;\n                    \n                    defunc_0_add_arg_304670 = ((__global\n                                                double *) mem_318876)[gtid_304639 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_304640 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_304669];\n                    defunc_0_f_res_304668 = defunc_0_add_arg_304670;\n                }\n                \n                int64_t binop_p_304671 = sub64(defunc_0_f_res_304664,\n                                               defunc_0_m_fun_res_304661);\n                double defunc_0_f_res_304672 = sitofp_i64_f64(binop_p_304671);\n                double abs_res_304673 = fabs(defunc_0_f_res_304672);\n                double tmp1_304674 = abs_res_304673 / x_304660;\n                double x_304675 = tmp1_304674 * tmp1_304674;\n                double y_304676 = tmp1_304674 * x_304675;\n                double tmp2_304677 = 1.0 - y_304676;\n                double x_304678 = tmp2_304677 * tmp2_304677;\n                double tmp3_304679 = tmp2_304677 * x_304678;\n                double w_j_304680 = defunc_0_f_res_304668 * tmp3_304679;\n                \n              ",
            "  // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_321884)[sext_i32_i64(local_tid_321880)] =\n                        w_j_304680;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_321884)[sext_i32_i64(local_tid_321880)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_s_292678)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_304644;\n                double x_304645;\n                double x_321895;\n                double x_321896;\n                bool ltid_in_bounds_321898 =\n                     slt64(sext_i32_i64(local_tid_321880), q_s_292678 *\n                           squot64(segred_group_sizze_304635,\n                                   segment_sizze_nonzzero_321877));\n                int32_t skip_threads_321899;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_321898) {\n                        x_304645 = ((volatile __local\n                                     double *) red_arr_mem_321884)[sext_i32_i64(local_tid_321880)];\n                        if ((local_tid_321880 - squot32(local_tid_321880, 32) *\n                             32) == 0) {\n                            x_304644 = x_304645;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_321899 = 1;\n                    while (slt32(skip_threads_321899, 32)) {\n                        bool thread_active_321900 = sle32(skip_threads_321899,\n                                                          local_tid_321880 -\n                                                          squot32(local_tid_321880,\n           ",
            "                                                       32) * 32) &&\n                             ltid_in_bounds_321898;\n                        \n                        if (thread_active_321900) {\n                            // read operands\n                            {\n                                x_304644 = ((volatile __local\n                                             double *) red_arr_mem_321884)[sext_i32_i64(local_tid_321880) -\n                                                                           sext_i32_i64(skip_threads_321899)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_321901 =\n                                 slt64(srem64(sext_i32_i64(local_tid_321880),\n                                              q_s_292678),\n                                       sext_i32_i64(local_tid_321880) -\n                                       sext_i32_i64(local_tid_321880 -\n                                       skip_threads_321899));\n                            \n                            if (thread_active_321900 && inactive_321901) {\n                                x_304644 = x_304645;\n                            }\n                            if (thread_active_321900) {\n                                if (!inactive_321901) {\n                                    double defunc_1_op_res_304646 = x_304644 +\n                                           x_304645;\n                                    \n                                    x_304644 = defunc_1_op_res_304646;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_321882, skip_threads_321899)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_321900) {\n                            // write result\n                            {\n           ",
            "                     ((volatile __local\n                                  double *) red_arr_mem_321884)[sext_i32_i64(local_tid_321880)] =\n                                    x_304644;\n                                x_304645 = x_304644;\n                            }\n                        }\n                        if (sle32(wave_sizze_321882, skip_threads_321899)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_321899 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_321880 - squot32(local_tid_321880, 32) *\n                         32) == 31 && ltid_in_bounds_321898) {\n                        ((volatile __local\n                          double *) red_arr_mem_321884)[sext_i32_i64(squot32(local_tid_321880,\n                                                                             32))] =\n                            x_304644;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_321902;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_321880, 32) == 0 &&\n                            ltid_in_bounds_321898) {\n                            x_321896 = ((volatile __local\n                                         double *) red_arr_mem_321884)[sext_i32_i64(local_tid_321880)];\n                            if ((local_tid_321880 - squot32(local_tid_321880,\n                                                            32) * 32) == 0) {\n                                x_321895 = x_321896;\n                            }\n                        }\n                    }\n  ",
            "                  // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_321902 = 1;\n                        while (slt32(skip_threads_321902, 32)) {\n                            bool thread_active_321903 =\n                                 sle32(skip_threads_321902, local_tid_321880 -\n                                       squot32(local_tid_321880, 32) * 32) &&\n                                 (squot32(local_tid_321880, 32) == 0 &&\n                                  ltid_in_bounds_321898);\n                            \n                            if (thread_active_321903) {\n                                // read operands\n                                {\n                                    x_321895 = ((volatile __local\n                                                 double *) red_arr_mem_321884)[sext_i32_i64(local_tid_321880) -\n                                                                               sext_i32_i64(skip_threads_321902)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_321904 =\n                                     slt64(srem64(sext_i32_i64(local_tid_321880 *\n                                                  32 + 32 - 1), q_s_292678),\n                                           sext_i32_i64(local_tid_321880 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_321880 -\n                                                         skip_threads_321902) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_321903 && inactive_321904) {\n                                    x_321895 = x_321896;\n                                }\n                                if (thread_active_321903) {\n                           ",
            "         if (!inactive_321904) {\n                                        double defunc_1_op_res_321897 =\n                                               x_321895 + x_321896;\n                                        \n                                        x_321895 = defunc_1_op_res_321897;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_321882, skip_threads_321902)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_321903) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_321884)[sext_i32_i64(local_tid_321880)] =\n                                        x_321895;\n                                    x_321896 = x_321895;\n                                }\n                            }\n                            if (sle32(wave_sizze_321882, skip_threads_321902)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_321902 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_321905 = squot32(local_tid_321880, 32) == 0 ||\n                     !ltid_in_bounds_321898;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_321905) {\n                            x_304645 = x_304644;\n                            x_304644 = ((__local\n                                         double *) red_arr_mem_321884)[sext_i32_i64(squot32(local_tid_321880,\n                                                                           ",
            "                 32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_321906 =\n                             slt64(srem64(sext_i32_i64(local_tid_321880),\n                                          q_s_292678),\n                                   sext_i32_i64(local_tid_321880) -\n                                   sext_i32_i64(squot32(local_tid_321880, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_321905) {\n                            if (inactive_321906) {\n                                x_304644 = x_304645;\n                            }\n                        }\n                        if (!no_carry_in_321905) {\n                            if (!inactive_321906) {\n                                double defunc_1_op_res_304646 = x_304644 +\n                                       x_304645;\n                                \n                                x_304644 = defunc_1_op_res_304646;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_321905) {\n                            ((__local\n                              double *) red_arr_mem_321884)[sext_i32_i64(local_tid_321880)] =\n                                x_304644;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_321880, 32) == 0 &&\n                        ltid_in_bounds_321898) {\n                        ((__local\n                          double *) red_arr_mem_321884)[sext_i32_i64(local_tid_321880)] =\n                            x_304645;\n                    ",
            "}\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_321888) *\n                      squot64(segred_group_sizze_304635,\n                              segment_sizze_nonzzero_321877) +\n                      sext_i32_i64(local_tid_321880), partition_sizze_292766 *\n                      n_p_292677 * s_n_m_292825) &&\n                slt64(sext_i32_i64(local_tid_321880),\n                      squot64(segred_group_sizze_304635,\n                              segment_sizze_nonzzero_321877))) {\n                double tmp_321907;\n                \n                tmp_321907 = ((__local\n                               double *) red_arr_mem_321884)[(sext_i32_i64(local_tid_321880) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_321877 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319066)[squot64(sext_i32_i64(virt_group_id_321888) *\n                                                squot64(segred_group_sizze_304635,\n                                                        segment_sizze_nonzzero_321877) +\n                                                sext_i32_i64(local_tid_321880),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_321888) *\n                                                squot64(segred_group_sizze_304635,\n                                                        segment_sizze_nonzzero_321877) +\n                                                sext_i32_i64(local_tid_321880) -\n                                                squot64",
            "(sext_i32_i64(virt_group_id_321888) *\n                                                        squot64(segred_group_sizze_304635,\n                                                                segment_sizze_nonzzero_321877) +\n                                                        sext_i32_i64(local_tid_321880),\n                                                        n_p_292677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_321888) *\n                                         squot64(segred_group_sizze_304635,\n                                                 segment_sizze_nonzzero_321877) +\n                                         sext_i32_i64(local_tid_321880) -\n                                         squot64(sext_i32_i64(virt_group_id_321888) *\n                                                 squot64(segred_group_sizze_304635,\n                                                         segment_sizze_nonzzero_321877) +\n                                                 sext_i32_i64(local_tid_321880),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_group_id_321888) *\n                                                 squot64(segred_group_sizze_304635,\n                                                         segment_sizze_nonzzero_321877) +\n                                                 sext_i32_i64(local_tid_321880) -\n                                                 squot64(sext_i32_i64(virt_group_id_321888) *\n                                                         squot64(segred_group_sizze_304635,\n                                                             ",
            "    segment_sizze_nonzzero_321877) +\n                                                         sext_i32_i64(local_tid_321880),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_321907;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_304635\n}\n__kernel void mainzisegred_small_304718(__global int *global_failure,\n                                        uint red_arr_mem_321972_backing_offset_0,\n                                        int64_t n_p_292677, int64_t q_s_292678,\n                                        int64_t partition_sizze_292766,\n                                        int64_t defunc_0_f_res_292820,\n                                        int64_t s_n_m_292825,\n                                        int64_t num_groups_304711,\n                                        int64_t segment_sizze_nonzzero_321965,\n                                        __global unsigned char *ext_mem_318609,\n                                        __global unsigned char *ext_mem_318610,\n                                        __global unsigned char *ext_mem_318707,\n                                        __global unsigned char *ext_mem_318708,\n                                        __global unsigned char *mem_318871,\n                                        __global unsigned char *mem_318876,\n                                        __global unsigned char *mem_319072,\n                                        __global unsigned char *mem_319077,\n                                        __global unsigned char *mem_319083)\n{\n    #define segred_group_sizze_304710",
            " (mainzisegred_group_sizze_303886)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_321972_backing_0 =\n                           &shared_mem[red_arr_mem_321972_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321967;\n    int32_t local_tid_321968;\n    int64_t group_sizze_321971;\n    int32_t wave_sizze_321970;\n    int32_t group_tid_321969;\n    \n    global_tid_321967 = get_global_id(0);\n    local_tid_321968 = get_local_id(0);\n    group_sizze_321971 = get_local_size(0);\n    wave_sizze_321970 = LOCKSTEP_WIDTH;\n    group_tid_321969 = get_group_id(0);\n    \n    int32_t phys_tid_304718 = global_tid_321967;\n    __local unsigned char *red_arr_mem_321972;\n    \n    red_arr_mem_321972 = (__local unsigned char *) red_arr_mem_321972_backing_0;\n    \n    int32_t phys_group_id_321974;\n    \n    phys_group_id_321974 = get_group_id(0);\n    for (int32_t i_321975 = 0; i_321975 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * n_p_292677 *\n                                          s_n_m_292825,\n                                          squot64(segred_group_sizze_304710,\n                                                  segment_sizze_nonzzero_321965))) -\n                   phys_group_id_321974, sext_i64_i32(num_groups_304711));\n         i_321975++) {\n        int32_t virt_group_id_321976 = phys_group_id_321974 + i_321975 *\n                sext_i64_i32(num_groups_304711);\n        int64_t slice_321977 = s_n_m_292825;\n        int64_t slice_321978 = n_p_292677 * slice_321977;\n        int64_t slice_321979 = partition_sizze_292766 * slice_321978;\n        int64_t gtid_304714 = squot64(squot64(sext_i32_i64(local_tid_321968),\n                                              segment_sizze_nonzzero_321965) +\n                                      sext_i32_i64(virt_group_id_321976) *\n                                      squot64(segred_group_sizze_304710,\n",
            "                                              segment_sizze_nonzzero_321965),\n                                      slice_321978);\n        int64_t remnant_321980 = squot64(sext_i32_i64(local_tid_321968),\n                                         segment_sizze_nonzzero_321965) +\n                sext_i32_i64(virt_group_id_321976) *\n                squot64(segred_group_sizze_304710,\n                        segment_sizze_nonzzero_321965) - gtid_304714 *\n                slice_321978;\n        int64_t gtid_304715 = squot64(remnant_321980, slice_321977);\n        int64_t remnant_321981 = remnant_321980 - gtid_304715 * slice_321977;\n        int64_t gtid_304716 = remnant_321981;\n        int64_t remnant_321982 = remnant_321981 - gtid_304716;\n        int64_t gtid_304717 = srem64(sext_i32_i64(local_tid_321968),\n                                     q_s_292678);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_s_292678) && (((slt64(gtid_304714,\n                                                           partition_sizze_292766) &&\n                                                     slt64(gtid_304715,\n                                                           n_p_292677)) &&\n                                                    slt64(gtid_304716,\n                                                          s_n_m_292825)) &&\n                                                   slt64(sext_i32_i64(local_tid_321968),\n                                                         q_s_292678 *\n                                                         squot64(segred_group_sizze_304710,\n                                                                 segment_sizze_nonzzero_321965)))) {\n                int64_t x_304733;\n                \n                x_304733 = ((__global int64_t *) ext_mem_318609)[gtid_304714 *\n                                                                 n_p_292677 +\n                                                                 gti",
            "d_304715];\n                \n                int64_t x_304738;\n                \n                x_304738 = ((__global int64_t *) ext_mem_318708)[gtid_304714 *\n                                                                 (s_n_m_292825 *\n                                                                  n_p_292677) +\n                                                                 gtid_304715 *\n                                                                 s_n_m_292825 +\n                                                                 gtid_304716];\n                \n                double x_304739;\n                \n                x_304739 = ((__global double *) ext_mem_318707)[gtid_304714 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_304715 *\n                                                                s_n_m_292825 +\n                                                                gtid_304716];\n                \n                double a0_304740;\n                \n                a0_304740 = ((__global double *) mem_319072)[gtid_304714 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_304715 *\n                                                             s_n_m_292825 +\n                                                             gtid_304716];\n                \n                int64_t defunc_0_m_fun_res_304741;\n                \n                defunc_0_m_fun_res_304741 = ((__global\n                                              int64_t *) mem_319077)[gtid_304714 *\n                                                                     (s_n_m_292825 *\n                                                                      n_p_",
            "292677) +\n                                                                     gtid_304715 *\n                                                                     s_n_m_292825 +\n                                                                     gtid_304716];\n                \n                bool cond_304743 = sle64(x_304733, gtid_304717);\n                int64_t defunc_0_f_res_304744;\n                \n                if (cond_304743) {\n                    defunc_0_f_res_304744 = (int64_t) 0;\n                } else {\n                    int64_t i_304745 = add64(gtid_304717, x_304738);\n                    int64_t defunc_0_add_arg_304746;\n                    \n                    defunc_0_add_arg_304746 = ((__global\n                                                int64_t *) ext_mem_318610)[gtid_304714 *\n                                                                           (defunc_0_f_res_292820 *\n                                                                            n_p_292677) +\n                                                                           gtid_304715 *\n                                                                           defunc_0_f_res_292820 +\n                                                                           i_304745];\n                    \n                    int64_t defunc_1_add_res_304747 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_304746);\n                    \n                    defunc_0_f_res_304744 = defunc_1_add_res_304747;\n                }\n                \n                double defunc_0_f_res_304748;\n                \n                if (cond_304743) {\n                    defunc_0_f_res_304748 = 0.0;\n                } else {\n                    int64_t i_304749 = add64(gtid_304717, x_304738);\n                    double defunc_0_add_arg_304750;\n                    \n                    defunc_0_add_arg_304750 = ((__global\n                                                ",
            "double *) mem_318876)[gtid_304714 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_304715 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_304749];\n                    defunc_0_f_res_304748 = defunc_0_add_arg_304750;\n                }\n                \n                int64_t binop_p_304751 = sub64(defunc_0_f_res_304744,\n                                               defunc_0_m_fun_res_304741);\n                double defunc_0_f_res_304752 = sitofp_i64_f64(binop_p_304751);\n                double abs_res_304753 = fabs(defunc_0_f_res_304752);\n                double tmp1_304754 = abs_res_304753 / x_304739;\n                double x_304755 = tmp1_304754 * tmp1_304754;\n                double y_304756 = tmp1_304754 * x_304755;\n                double tmp2_304757 = 1.0 - y_304756;\n                double x_304758 = tmp2_304757 * tmp2_304757;\n                double tmp3_304759 = tmp2_304757 * x_304758;\n                double tmp4_304760 = defunc_0_f_res_304748 * tmp3_304759;\n                double defunc_0_f_res_304761;\n                \n                if (cond_304743) {\n                    defunc_0_f_res_304761 = 0.0;\n                } else {\n                    int64_t i_304762 = add64(gtid_304717, x_304738);\n                    double defunc_0_add_arg_304763;\n                    \n                    defunc_0_add_arg_304763 = ((__global\n                                                double *) mem_318871)[gtid_304714 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                             ",
            "         gtid_304715 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_304762];\n                    defunc_0_f_res_304761 = defunc_0_add_arg_304763;\n                }\n                \n                double x_304764 = a0_304740 * tmp4_304760;\n                double defunc_9_fit_fun_res_304765 = defunc_0_f_res_304761 *\n                       x_304764;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_321972)[sext_i32_i64(local_tid_321968)] =\n                        defunc_9_fit_fun_res_304765;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_321972)[sext_i32_i64(local_tid_321968)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_s_292678)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_304719;\n                double x_304720;\n                double x_321983;\n                double x_321984;\n                bool ltid_in_bounds_321986 =\n                     slt64(sext_i32_i64(local_tid_321968), q_s_292678 *\n                           squot64(segred_group_sizze_304710,\n                                   segment_sizze_nonzzero_321965));\n                int32_t skip_threads_321987;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_321986) {\n                        x_304720 = ((volatile __local\n                                     double *) red_arr_mem_321972)[sext_i32_i64(local_tid_321968)];\n                        if ((local_tid_321968 - squot32(local_tid_321968, 32) *\n                             32) == 0) {\n                            x_30471",
            "9 = x_304720;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_321987 = 1;\n                    while (slt32(skip_threads_321987, 32)) {\n                        bool thread_active_321988 = sle32(skip_threads_321987,\n                                                          local_tid_321968 -\n                                                          squot32(local_tid_321968,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_321986;\n                        \n                        if (thread_active_321988) {\n                            // read operands\n                            {\n                                x_304719 = ((volatile __local\n                                             double *) red_arr_mem_321972)[sext_i32_i64(local_tid_321968) -\n                                                                           sext_i32_i64(skip_threads_321987)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_321989 =\n                                 slt64(srem64(sext_i32_i64(local_tid_321968),\n                                              q_s_292678),\n                                       sext_i32_i64(local_tid_321968) -\n                                       sext_i32_i64(local_tid_321968 -\n                                       skip_threads_321987));\n                            \n                            if (thread_active_321988 && inactive_321989) {\n                                x_304719 = x_304720;\n                            }\n                            if (thread_active_321988) {\n                                if (!inactive_321989) {\n                                    double defunc_1_op_res_304721 = x_304719 +\n                              ",
            "             x_304720;\n                                    \n                                    x_304719 = defunc_1_op_res_304721;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_321970, skip_threads_321987)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_321988) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_321972)[sext_i32_i64(local_tid_321968)] =\n                                    x_304719;\n                                x_304720 = x_304719;\n                            }\n                        }\n                        if (sle32(wave_sizze_321970, skip_threads_321987)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_321987 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_321968 - squot32(local_tid_321968, 32) *\n                         32) == 31 && ltid_in_bounds_321986) {\n                        ((volatile __local\n                          double *) red_arr_mem_321972)[sext_i32_i64(squot32(local_tid_321968,\n                                                                             32))] =\n                            x_304719;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_321990;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_32196",
            "8, 32) == 0 &&\n                            ltid_in_bounds_321986) {\n                            x_321984 = ((volatile __local\n                                         double *) red_arr_mem_321972)[sext_i32_i64(local_tid_321968)];\n                            if ((local_tid_321968 - squot32(local_tid_321968,\n                                                            32) * 32) == 0) {\n                                x_321983 = x_321984;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_321990 = 1;\n                        while (slt32(skip_threads_321990, 32)) {\n                            bool thread_active_321991 =\n                                 sle32(skip_threads_321990, local_tid_321968 -\n                                       squot32(local_tid_321968, 32) * 32) &&\n                                 (squot32(local_tid_321968, 32) == 0 &&\n                                  ltid_in_bounds_321986);\n                            \n                            if (thread_active_321991) {\n                                // read operands\n                                {\n                                    x_321983 = ((volatile __local\n                                                 double *) red_arr_mem_321972)[sext_i32_i64(local_tid_321968) -\n                                                                               sext_i32_i64(skip_threads_321990)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_321992 =\n                                     slt64(srem64(sext_i32_i64(local_tid_321968 *\n                                                  32 + 32 - 1), q_s_292678),\n                                           sext_i32_i64(local_tid_321968 * 32 +\n                                      ",
            "     32 - 1) -\n                                           sext_i32_i64((local_tid_321968 -\n                                                         skip_threads_321990) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_321991 && inactive_321992) {\n                                    x_321983 = x_321984;\n                                }\n                                if (thread_active_321991) {\n                                    if (!inactive_321992) {\n                                        double defunc_1_op_res_321985 =\n                                               x_321983 + x_321984;\n                                        \n                                        x_321983 = defunc_1_op_res_321985;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_321970, skip_threads_321990)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_321991) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_321972)[sext_i32_i64(local_tid_321968)] =\n                                        x_321983;\n                                    x_321984 = x_321983;\n                                }\n                            }\n                            if (sle32(wave_sizze_321970, skip_threads_321990)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_321990 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_321993 = squot32(local_tid_321968, 32) == 0 ||\n               ",
            "      !ltid_in_bounds_321986;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_321993) {\n                            x_304720 = x_304719;\n                            x_304719 = ((__local\n                                         double *) red_arr_mem_321972)[sext_i32_i64(squot32(local_tid_321968,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_321994 =\n                             slt64(srem64(sext_i32_i64(local_tid_321968),\n                                          q_s_292678),\n                                   sext_i32_i64(local_tid_321968) -\n                                   sext_i32_i64(squot32(local_tid_321968, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_321993) {\n                            if (inactive_321994) {\n                                x_304719 = x_304720;\n                            }\n                        }\n                        if (!no_carry_in_321993) {\n                            if (!inactive_321994) {\n                                double defunc_1_op_res_304721 = x_304719 +\n                                       x_304720;\n                                \n                                x_304719 = defunc_1_op_res_304721;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_321993) {\n                            ((__local\n                              double *) red_arr_mem_321972)[sext_i32_i64(local_tid_321968)] =\n    ",
            "                            x_304719;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_321968, 32) == 0 &&\n                        ltid_in_bounds_321986) {\n                        ((__local\n                          double *) red_arr_mem_321972)[sext_i32_i64(local_tid_321968)] =\n                            x_304720;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_321976) *\n                      squot64(segred_group_sizze_304710,\n                              segment_sizze_nonzzero_321965) +\n                      sext_i32_i64(local_tid_321968), partition_sizze_292766 *\n                      n_p_292677 * s_n_m_292825) &&\n                slt64(sext_i32_i64(local_tid_321968),\n                      squot64(segred_group_sizze_304710,\n                              segment_sizze_nonzzero_321965))) {\n                double tmp_321995;\n                \n                tmp_321995 = ((__local\n                               double *) red_arr_mem_321972)[(sext_i32_i64(local_tid_321968) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_321965 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319083)[squot64(sext_i32_i64(virt_group_id_321976) *\n                                                squot64(segred_group_sizze_304710,\n                                                        segment_sizze_nonzzero_321965) +\n                                                sext_i32_i64(local_tid_321968),\n                     ",
            "                           n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_321976) *\n                                                squot64(segred_group_sizze_304710,\n                                                        segment_sizze_nonzzero_321965) +\n                                                sext_i32_i64(local_tid_321968) -\n                                                squot64(sext_i32_i64(virt_group_id_321976) *\n                                                        squot64(segred_group_sizze_304710,\n                                                                segment_sizze_nonzzero_321965) +\n                                                        sext_i32_i64(local_tid_321968),\n                                                        n_p_292677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_321976) *\n                                         squot64(segred_group_sizze_304710,\n                                                 segment_sizze_nonzzero_321965) +\n                                         sext_i32_i64(local_tid_321968) -\n                                         squot64(sext_i32_i64(virt_group_id_321976) *\n                                                 squot64(segred_group_sizze_304710,\n                                                         segment_sizze_nonzzero_321965) +\n                                                 sext_i32_i64(local_tid_321968),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_gro",
            "up_id_321976) *\n                                                 squot64(segred_group_sizze_304710,\n                                                         segment_sizze_nonzzero_321965) +\n                                                 sext_i32_i64(local_tid_321968) -\n                                                 squot64(sext_i32_i64(virt_group_id_321976) *\n                                                         squot64(segred_group_sizze_304710,\n                                                                 segment_sizze_nonzzero_321965) +\n                                                         sext_i32_i64(local_tid_321968),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_321995;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_304710\n}\n__kernel void mainzisegred_small_306191(__global int *global_failure,\n                                        uint red_arr_mem_322191_backing_offset_0,\n                                        uint red_arr_mem_322189_backing_offset_1,\n                                        uint red_arr_mem_322187_backing_offset_2,\n                                        int64_t n_p_292677, int64_t q_s_292678,\n                                        int64_t partition_sizze_292766,\n                                        int64_t defunc_0_f_res_292820,\n                                        int64_t s_n_m_292825,\n                                        int64_t num_groups_306182,\n                                        int64_t segment_sizze_nonzzero_322180,\n                                        __global unsigne",
            "d char *ext_mem_318609,\n                                        __global unsigned char *ext_mem_318610,\n                                        __global unsigned char *ext_mem_318707,\n                                        __global unsigned char *ext_mem_318708,\n                                        __global unsigned char *mem_318876,\n                                        __global unsigned char *mem_319203,\n                                        __global unsigned char *mem_319213,\n                                        __global unsigned char *mem_319218,\n                                        __global unsigned char *mem_319223)\n{\n    #define segred_group_sizze_306181 (mainzisegred_group_sizze_305373)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_322191_backing_2 =\n                           &shared_mem[red_arr_mem_322191_backing_offset_0];\n    volatile unsigned char *red_arr_mem_322189_backing_1 =\n                           &shared_mem[red_arr_mem_322189_backing_offset_1];\n    volatile unsigned char *red_arr_mem_322187_backing_0 =\n                           &shared_mem[red_arr_mem_322187_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322182;\n    int32_t local_tid_322183;\n    int64_t group_sizze_322186;\n    int32_t wave_sizze_322185;\n    int32_t group_tid_322184;\n    \n    global_tid_322182 = get_global_id(0);\n    local_tid_322183 = get_local_id(0);\n    group_sizze_322186 = get_local_size(0);\n    wave_sizze_322185 = LOCKSTEP_WIDTH;\n    group_tid_322184 = get_group_id(0);\n    \n    int32_t phys_tid_306191 = global_tid_322182;\n    __local unsigned char *red_arr_mem_322187;\n    \n    red_arr_mem_322187 = (__local unsigned char *) red_arr_mem_322187_backing_0;\n    \n    __local unsigned char *red_arr_mem_322189;\n    \n    red_arr_mem_322189 = (__local unsigned char *) red_arr_mem_322189_backing_1;\n    \n    __local unsigned char *r",
            "ed_arr_mem_322191;\n    \n    red_arr_mem_322191 = (__local unsigned char *) red_arr_mem_322191_backing_2;\n    \n    int32_t phys_group_id_322193;\n    \n    phys_group_id_322193 = get_group_id(0);\n    for (int32_t i_322194 = 0; i_322194 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * n_p_292677 *\n                                          s_n_m_292825,\n                                          squot64(segred_group_sizze_306181,\n                                                  segment_sizze_nonzzero_322180))) -\n                   phys_group_id_322193, sext_i64_i32(num_groups_306182));\n         i_322194++) {\n        int32_t virt_group_id_322195 = phys_group_id_322193 + i_322194 *\n                sext_i64_i32(num_groups_306182);\n        int64_t slice_322196 = s_n_m_292825;\n        int64_t slice_322197 = n_p_292677 * slice_322196;\n        int64_t slice_322198 = partition_sizze_292766 * slice_322197;\n        int64_t gtid_306187 = squot64(squot64(sext_i32_i64(local_tid_322183),\n                                              segment_sizze_nonzzero_322180) +\n                                      sext_i32_i64(virt_group_id_322195) *\n                                      squot64(segred_group_sizze_306181,\n                                              segment_sizze_nonzzero_322180),\n                                      slice_322197);\n        int64_t remnant_322199 = squot64(sext_i32_i64(local_tid_322183),\n                                         segment_sizze_nonzzero_322180) +\n                sext_i32_i64(virt_group_id_322195) *\n                squot64(segred_group_sizze_306181,\n                        segment_sizze_nonzzero_322180) - gtid_306187 *\n                slice_322197;\n        int64_t gtid_306188 = squot64(remnant_322199, slice_322196);\n        int64_t remnant_322200 = remnant_322199 - gtid_306188 * slice_322196;\n        int64_t gtid_306189 = remnant_322200;\n        int64_t remnant_322201 = remnant_322200 - gtid_306189;\n        int64_t gtid_306190 = ",
            "srem64(sext_i32_i64(local_tid_322183),\n                                     q_s_292678);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_s_292678) && (((slt64(gtid_306187,\n                                                           partition_sizze_292766) &&\n                                                     slt64(gtid_306188,\n                                                           n_p_292677)) &&\n                                                    slt64(gtid_306189,\n                                                          s_n_m_292825)) &&\n                                                   slt64(sext_i32_i64(local_tid_322183),\n                                                         q_s_292678 *\n                                                         squot64(segred_group_sizze_306181,\n                                                                 segment_sizze_nonzzero_322180)))) {\n                int64_t x_306209;\n                \n                x_306209 = ((__global int64_t *) ext_mem_318609)[gtid_306187 *\n                                                                 n_p_292677 +\n                                                                 gtid_306188];\n                \n                int64_t x_306213;\n                \n                x_306213 = ((__global int64_t *) ext_mem_318708)[gtid_306187 *\n                                                                 (s_n_m_292825 *\n                                                                  n_p_292677) +\n                                                                 gtid_306188 *\n                                                                 s_n_m_292825 +\n                                                                 gtid_306189];\n                \n                double x_306214;\n                \n                x_306214 = ((__global double *) ext_mem_318707)[gtid_306187 *\n                                                                (s_",
            "n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_306188 *\n                                                                s_n_m_292825 +\n                                                                gtid_306189];\n                \n                int64_t defunc_0_m_fun_res_306215;\n                \n                defunc_0_m_fun_res_306215 = ((__global\n                                              int64_t *) mem_319203)[gtid_306187 *\n                                                                     (s_n_m_292825 *\n                                                                      n_p_292677) +\n                                                                     gtid_306188 *\n                                                                     s_n_m_292825 +\n                                                                     gtid_306189];\n                \n                bool cond_306217 = sle64(x_306209, gtid_306190);\n                int64_t defunc_0_f_res_306218;\n                \n                if (cond_306217) {\n                    defunc_0_f_res_306218 = (int64_t) 0;\n                } else {\n                    int64_t i_306219 = add64(gtid_306190, x_306213);\n                    int64_t defunc_0_add_arg_306220;\n                    \n                    defunc_0_add_arg_306220 = ((__global\n                                                int64_t *) ext_mem_318610)[gtid_306187 *\n                                                                           (defunc_0_f_res_292820 *\n                                                                            n_p_292677) +\n                                                                           gtid_306188 *\n                                                                           defunc_0_f_res_292820 +\n                                                                           i_306219];\n               ",
            "     \n                    int64_t defunc_1_add_res_306221 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_306220);\n                    \n                    defunc_0_f_res_306218 = defunc_1_add_res_306221;\n                }\n                \n                double defunc_0_f_res_306222;\n                \n                if (cond_306217) {\n                    defunc_0_f_res_306222 = 0.0;\n                } else {\n                    int64_t i_306223 = add64(gtid_306190, x_306213);\n                    double defunc_0_add_arg_306224;\n                    \n                    defunc_0_add_arg_306224 = ((__global\n                                                double *) mem_318876)[gtid_306187 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_306188 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_306223];\n                    defunc_0_f_res_306222 = defunc_0_add_arg_306224;\n                }\n                \n                int64_t binop_p_306225 = sub64(defunc_0_f_res_306218,\n                                               defunc_0_m_fun_res_306215);\n                double defunc_0_f_res_306226 = sitofp_i64_f64(binop_p_306225);\n                double abs_res_306227 = fabs(defunc_0_f_res_306226);\n                double tmp1_306228 = abs_res_306227 / x_306214;\n                double x_306229 = tmp1_306228 * tmp1_306228;\n                double y_306230 = tmp1_306228 * x_306229;\n                double tmp2_306231 = 1.0 - y_306230;\n                double x_306232 = tmp2_306231 * tmp2_306231;\n                double tmp3_306233 = tmp2_306231 * x_306232;\n                double w_j_306234 = defunc_0_f_res_306222 * t",
            "mp3_306233;\n                double xw_j_306235 = defunc_0_f_res_306226 * w_j_306234;\n                double x2w_j_306236 = defunc_0_f_res_306226 * xw_j_306235;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_322187)[sext_i32_i64(local_tid_322183)] =\n                        w_j_306234;\n                    ((__local\n                      double *) red_arr_mem_322189)[sext_i32_i64(local_tid_322183)] =\n                        xw_j_306235;\n                    ((__local\n                      double *) red_arr_mem_322191)[sext_i32_i64(local_tid_322183)] =\n                        x2w_j_306236;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_322187)[sext_i32_i64(local_tid_322183)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_322189)[sext_i32_i64(local_tid_322183)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_322191)[sext_i32_i64(local_tid_322183)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_s_292678)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_306192;\n                double x_306193;\n                double x_306194;\n                double x_306195;\n                double x_306196;\n                double x_306197;\n                double x_322202;\n                double x_322203;\n                double x_322204;\n                double x_322205;\n                double x_322206;\n                double x_322207;\n                bool ltid_in_bounds_322211 =\n                     slt64(sext_i32_i64(local_tid_322183), q_s_292678 *\n                           squot64(segred_group_sizze_306181,\n                                   segment_siz",
            "ze_nonzzero_322180));\n                int32_t skip_threads_322212;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_322211) {\n                        x_306195 = ((volatile __local\n                                     double *) red_arr_mem_322187)[sext_i32_i64(local_tid_322183)];\n                        x_306196 = ((volatile __local\n                                     double *) red_arr_mem_322189)[sext_i32_i64(local_tid_322183)];\n                        x_306197 = ((volatile __local\n                                     double *) red_arr_mem_322191)[sext_i32_i64(local_tid_322183)];\n                        if ((local_tid_322183 - squot32(local_tid_322183, 32) *\n                             32) == 0) {\n                            x_306192 = x_306195;\n                            x_306193 = x_306196;\n                            x_306194 = x_306197;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_322212 = 1;\n                    while (slt32(skip_threads_322212, 32)) {\n                        bool thread_active_322213 = sle32(skip_threads_322212,\n                                                          local_tid_322183 -\n                                                          squot32(local_tid_322183,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_322211;\n                        \n                        if (thread_active_322213) {\n                            // read operands\n                            {\n                                x_306192 = ((volatile __local\n                                             double *) red_arr_mem_322187)[sext_i32_i64(local_tid_322183) -\n                                                                           sext_i32_i64(skip_threads_322212)];\n             ",
            "                   x_306193 = ((volatile __local\n                                             double *) red_arr_mem_322189)[sext_i32_i64(local_tid_322183) -\n                                                                           sext_i32_i64(skip_threads_322212)];\n                                x_306194 = ((volatile __local\n                                             double *) red_arr_mem_322191)[sext_i32_i64(local_tid_322183) -\n                                                                           sext_i32_i64(skip_threads_322212)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_322214 =\n                                 slt64(srem64(sext_i32_i64(local_tid_322183),\n                                              q_s_292678),\n                                       sext_i32_i64(local_tid_322183) -\n                                       sext_i32_i64(local_tid_322183 -\n                                       skip_threads_322212));\n                            \n                            if (thread_active_322213 && inactive_322214) {\n                                x_306192 = x_306195;\n                                x_306193 = x_306196;\n                                x_306194 = x_306197;\n                            }\n                            if (thread_active_322213) {\n                                if (!inactive_322214) {\n                                    double defunc_1_op_res_306198 = x_306192 +\n                                           x_306195;\n                                    double defunc_1_op_res_306199 = x_306193 +\n                                           x_306196;\n                                    double defunc_1_op_res_306200 = x_306194 +\n                                           x_306197;\n                                    \n                                    x_306192 = defunc_1_op_res_306198;\n                      ",
            "              x_306193 = defunc_1_op_res_306199;\n                                    x_306194 = defunc_1_op_res_306200;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_322185, skip_threads_322212)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_322213) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_322187)[sext_i32_i64(local_tid_322183)] =\n                                    x_306192;\n                                x_306195 = x_306192;\n                                ((volatile __local\n                                  double *) red_arr_mem_322189)[sext_i32_i64(local_tid_322183)] =\n                                    x_306193;\n                                x_306196 = x_306193;\n                                ((volatile __local\n                                  double *) red_arr_mem_322191)[sext_i32_i64(local_tid_322183)] =\n                                    x_306194;\n                                x_306197 = x_306194;\n                            }\n                        }\n                        if (sle32(wave_sizze_322185, skip_threads_322212)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_322212 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_322183 - squot32(local_tid_322183, 32) *\n                         32) == 31 && ltid_in_bounds_322211) {\n                        ((volatile __local\n                          double *) red_arr_mem_322187)[sext_i32_i64(squot32(local_tid_322183,\n                                   ",
            "                                          32))] =\n                            x_306192;\n                        ((volatile __local\n                          double *) red_arr_mem_322189)[sext_i32_i64(squot32(local_tid_322183,\n                                                                             32))] =\n                            x_306193;\n                        ((volatile __local\n                          double *) red_arr_mem_322191)[sext_i32_i64(squot32(local_tid_322183,\n                                                                             32))] =\n                            x_306194;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_322215;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_322183, 32) == 0 &&\n                            ltid_in_bounds_322211) {\n                            x_322205 = ((volatile __local\n                                         double *) red_arr_mem_322187)[sext_i32_i64(local_tid_322183)];\n                            x_322206 = ((volatile __local\n                                         double *) red_arr_mem_322189)[sext_i32_i64(local_tid_322183)];\n                            x_322207 = ((volatile __local\n                                         double *) red_arr_mem_322191)[sext_i32_i64(local_tid_322183)];\n                            if ((local_tid_322183 - squot32(local_tid_322183,\n                                                            32) * 32) == 0) {\n                                x_322202 = x_322205;\n                                x_322203 = x_322206;\n                                x_322204 = x_322207;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefull",
            "y no barriers needed)\n                    {\n                        skip_threads_322215 = 1;\n                        while (slt32(skip_threads_322215, 32)) {\n                            bool thread_active_322216 =\n                                 sle32(skip_threads_322215, local_tid_322183 -\n                                       squot32(local_tid_322183, 32) * 32) &&\n                                 (squot32(local_tid_322183, 32) == 0 &&\n                                  ltid_in_bounds_322211);\n                            \n                            if (thread_active_322216) {\n                                // read operands\n                                {\n                                    x_322202 = ((volatile __local\n                                                 double *) red_arr_mem_322187)[sext_i32_i64(local_tid_322183) -\n                                                                               sext_i32_i64(skip_threads_322215)];\n                                    x_322203 = ((volatile __local\n                                                 double *) red_arr_mem_322189)[sext_i32_i64(local_tid_322183) -\n                                                                               sext_i32_i64(skip_threads_322215)];\n                                    x_322204 = ((volatile __local\n                                                 double *) red_arr_mem_322191)[sext_i32_i64(local_tid_322183) -\n                                                                               sext_i32_i64(skip_threads_322215)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_322217 =\n                                     slt64(srem64(sext_i32_i64(local_tid_322183 *\n                                                  32 + 32 - 1), q_s_292678),\n                                           sext_i32_i64(local_tid_322183 * 32 +\n               ",
            "                            32 - 1) -\n                                           sext_i32_i64((local_tid_322183 -\n                                                         skip_threads_322215) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_322216 && inactive_322217) {\n                                    x_322202 = x_322205;\n                                    x_322203 = x_322206;\n                                    x_322204 = x_322207;\n                                }\n                                if (thread_active_322216) {\n                                    if (!inactive_322217) {\n                                        double defunc_1_op_res_322208 =\n                                               x_322202 + x_322205;\n                                        double defunc_1_op_res_322209 =\n                                               x_322203 + x_322206;\n                                        double defunc_1_op_res_322210 =\n                                               x_322204 + x_322207;\n                                        \n                                        x_322202 = defunc_1_op_res_322208;\n                                        x_322203 = defunc_1_op_res_322209;\n                                        x_322204 = defunc_1_op_res_322210;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_322185, skip_threads_322215)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_322216) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_322187)[sext_i32_i64(local_tid_322183)] =\n                                        x_322202;\n     ",
            "                               x_322205 = x_322202;\n                                    ((volatile __local\n                                      double *) red_arr_mem_322189)[sext_i32_i64(local_tid_322183)] =\n                                        x_322203;\n                                    x_322206 = x_322203;\n                                    ((volatile __local\n                                      double *) red_arr_mem_322191)[sext_i32_i64(local_tid_322183)] =\n                                        x_322204;\n                                    x_322207 = x_322204;\n                                }\n                            }\n                            if (sle32(wave_sizze_322185, skip_threads_322215)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_322215 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_322218 = squot32(local_tid_322183, 32) == 0 ||\n                     !ltid_in_bounds_322211;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_322218) {\n                            x_306195 = x_306192;\n                            x_306196 = x_306193;\n                            x_306197 = x_306194;\n                            x_306192 = ((__local\n                                         double *) red_arr_mem_322187)[sext_i32_i64(squot32(local_tid_322183,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_306193 = ((__local\n                                         double *) red_arr_mem_322189)[sext_i32_i64(squot32(local_tid_322183,\n                    ",
            "                                                                        32)) -\n                                                                       (int64_t) 1];\n                            x_306194 = ((__local\n                                         double *) red_arr_mem_322191)[sext_i32_i64(squot32(local_tid_322183,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_322219 =\n                             slt64(srem64(sext_i32_i64(local_tid_322183),\n                                          q_s_292678),\n                                   sext_i32_i64(local_tid_322183) -\n                                   sext_i32_i64(squot32(local_tid_322183, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_322218) {\n                            if (inactive_322219) {\n                                x_306192 = x_306195;\n                                x_306193 = x_306196;\n                                x_306194 = x_306197;\n                            }\n                        }\n                        if (!no_carry_in_322218) {\n                            if (!inactive_322219) {\n                                double defunc_1_op_res_306198 = x_306192 +\n                                       x_306195;\n                                double defunc_1_op_res_306199 = x_306193 +\n                                       x_306196;\n                                double defunc_1_op_res_306200 = x_306194 +\n                                       x_306197;\n                                \n                                x_306192 = defunc_1_op_res_306198;\n                                x_306193 = defunc_1_op_res_306199;\n                             ",
            "   x_306194 = defunc_1_op_res_306200;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_322218) {\n                            ((__local\n                              double *) red_arr_mem_322187)[sext_i32_i64(local_tid_322183)] =\n                                x_306192;\n                            ((__local\n                              double *) red_arr_mem_322189)[sext_i32_i64(local_tid_322183)] =\n                                x_306193;\n                            ((__local\n                              double *) red_arr_mem_322191)[sext_i32_i64(local_tid_322183)] =\n                                x_306194;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_322183, 32) == 0 &&\n                        ltid_in_bounds_322211) {\n                        ((__local\n                          double *) red_arr_mem_322187)[sext_i32_i64(local_tid_322183)] =\n                            x_306195;\n                        ((__local\n                          double *) red_arr_mem_322189)[sext_i32_i64(local_tid_322183)] =\n                            x_306196;\n                        ((__local\n                          double *) red_arr_mem_322191)[sext_i32_i64(local_tid_322183)] =\n                            x_306197;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_322195) *\n                      squot64(segred_group_sizze_306181,\n                              segment_sizze_nonzzero_322180) +\n                      sext_i32_i64(local_tid_322183), partition_sizze_292766 *\n     ",
            "                 n_p_292677 * s_n_m_292825) &&\n                slt64(sext_i32_i64(local_tid_322183),\n                      squot64(segred_group_sizze_306181,\n                              segment_sizze_nonzzero_322180))) {\n                double tmp_322220;\n                \n                tmp_322220 = ((__local\n                               double *) red_arr_mem_322187)[(sext_i32_i64(local_tid_322183) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322180 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319213)[squot64(sext_i32_i64(virt_group_id_322195) *\n                                                squot64(segred_group_sizze_306181,\n                                                        segment_sizze_nonzzero_322180) +\n                                                sext_i32_i64(local_tid_322183),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_322195) *\n                                                squot64(segred_group_sizze_306181,\n                                                        segment_sizze_nonzzero_322180) +\n                                                sext_i32_i64(local_tid_322183) -\n                                                squot64(sext_i32_i64(virt_group_id_322195) *\n                                                        squot64(segred_group_sizze_306181,\n                                                                segment_sizze_nonzzero_322180) +\n                                                        sext_i32_i64(local_tid_322183),\n                                                        n_p_292677 *\n                                                        s_n",
            "_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_322195) *\n                                         squot64(segred_group_sizze_306181,\n                                                 segment_sizze_nonzzero_322180) +\n                                         sext_i32_i64(local_tid_322183) -\n                                         squot64(sext_i32_i64(virt_group_id_322195) *\n                                                 squot64(segred_group_sizze_306181,\n                                                         segment_sizze_nonzzero_322180) +\n                                                 sext_i32_i64(local_tid_322183),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_group_id_322195) *\n                                                 squot64(segred_group_sizze_306181,\n                                                         segment_sizze_nonzzero_322180) +\n                                                 sext_i32_i64(local_tid_322183) -\n                                                 squot64(sext_i32_i64(virt_group_id_322195) *\n                                                         squot64(segred_group_sizze_306181,\n                                                                 segment_sizze_nonzzero_322180) +\n                                                         sext_i32_i64(local_tid_322183),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                              ",
            "           s_n_m_292825)] = tmp_322220;\n                \n                double tmp_322221;\n                \n                tmp_322221 = ((__local\n                               double *) red_arr_mem_322189)[(sext_i32_i64(local_tid_322183) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322180 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319218)[squot64(sext_i32_i64(virt_group_id_322195) *\n                                                squot64(segred_group_sizze_306181,\n                                                        segment_sizze_nonzzero_322180) +\n                                                sext_i32_i64(local_tid_322183),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_322195) *\n                                                squot64(segred_group_sizze_306181,\n                                                        segment_sizze_nonzzero_322180) +\n                                                sext_i32_i64(local_tid_322183) -\n                                                squot64(sext_i32_i64(virt_group_id_322195) *\n                                                        squot64(segred_group_sizze_306181,\n                                                                segment_sizze_nonzzero_322180) +\n                                                        sext_i32_i64(local_tid_322183),\n                                                        n_p_292677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825",
            " +\n                                        (sext_i32_i64(virt_group_id_322195) *\n                                         squot64(segred_group_sizze_306181,\n                                                 segment_sizze_nonzzero_322180) +\n                                         sext_i32_i64(local_tid_322183) -\n                                         squot64(sext_i32_i64(virt_group_id_322195) *\n                                                 squot64(segred_group_sizze_306181,\n                                                         segment_sizze_nonzzero_322180) +\n                                                 sext_i32_i64(local_tid_322183),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_group_id_322195) *\n                                                 squot64(segred_group_sizze_306181,\n                                                         segment_sizze_nonzzero_322180) +\n                                                 sext_i32_i64(local_tid_322183) -\n                                                 squot64(sext_i32_i64(virt_group_id_322195) *\n                                                         squot64(segred_group_sizze_306181,\n                                                                 segment_sizze_nonzzero_322180) +\n                                                         sext_i32_i64(local_tid_322183),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_322221;\n                \n                double tmp_322222;\n                \n                tmp_322222 = ((__local\n                  ",
            "             double *) red_arr_mem_322191)[(sext_i32_i64(local_tid_322183) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322180 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319223)[squot64(sext_i32_i64(virt_group_id_322195) *\n                                                squot64(segred_group_sizze_306181,\n                                                        segment_sizze_nonzzero_322180) +\n                                                sext_i32_i64(local_tid_322183),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_322195) *\n                                                squot64(segred_group_sizze_306181,\n                                                        segment_sizze_nonzzero_322180) +\n                                                sext_i32_i64(local_tid_322183) -\n                                                squot64(sext_i32_i64(virt_group_id_322195) *\n                                                        squot64(segred_group_sizze_306181,\n                                                                segment_sizze_nonzzero_322180) +\n                                                        sext_i32_i64(local_tid_322183),\n                                                        n_p_292677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_322195) *\n                                         squot64(segred_group_sizze_306181,\n         ",
            "                                        segment_sizze_nonzzero_322180) +\n                                         sext_i32_i64(local_tid_322183) -\n                                         squot64(sext_i32_i64(virt_group_id_322195) *\n                                                 squot64(segred_group_sizze_306181,\n                                                         segment_sizze_nonzzero_322180) +\n                                                 sext_i32_i64(local_tid_322183),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_group_id_322195) *\n                                                 squot64(segred_group_sizze_306181,\n                                                         segment_sizze_nonzzero_322180) +\n                                                 sext_i32_i64(local_tid_322183) -\n                                                 squot64(sext_i32_i64(virt_group_id_322195) *\n                                                         squot64(segred_group_sizze_306181,\n                                                                 segment_sizze_nonzzero_322180) +\n                                                         sext_i32_i64(local_tid_322183),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_322222;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_306181\n}\n__kernel void mainzisegred_small_306288(__global int *global_failure,\n                          ",
            "              uint red_arr_mem_322305_backing_offset_0,\n                                        uint red_arr_mem_322303_backing_offset_1,\n                                        int64_t n_p_292677, int64_t q_s_292678,\n                                        int64_t partition_sizze_292766,\n                                        int64_t defunc_0_f_res_292820,\n                                        int64_t s_n_m_292825,\n                                        int64_t num_groups_306280,\n                                        int64_t segment_sizze_nonzzero_322296,\n                                        __global unsigned char *ext_mem_318609,\n                                        __global unsigned char *ext_mem_318610,\n                                        __global unsigned char *ext_mem_318707,\n                                        __global unsigned char *ext_mem_318708,\n                                        __global unsigned char *mem_318871,\n                                        __global unsigned char *mem_318876,\n                                        __global unsigned char *mem_319229,\n                                        __global unsigned char *mem_319234,\n                                        __global unsigned char *mem_319239,\n                                        __global unsigned char *mem_319244,\n                                        __global unsigned char *mem_319250,\n                                        __global unsigned char *mem_319255)\n{\n    #define segred_group_sizze_306279 (mainzisegred_group_sizze_305237)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_322305_backing_1 =\n                           &shared_mem[red_arr_mem_322305_backing_offset_0];\n    volatile unsigned char *red_arr_mem_322303_backing_0 =\n                           &shared_mem[red_arr_mem_322303_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    in",
            "t32_t global_tid_322298;\n    int32_t local_tid_322299;\n    int64_t group_sizze_322302;\n    int32_t wave_sizze_322301;\n    int32_t group_tid_322300;\n    \n    global_tid_322298 = get_global_id(0);\n    local_tid_322299 = get_local_id(0);\n    group_sizze_322302 = get_local_size(0);\n    wave_sizze_322301 = LOCKSTEP_WIDTH;\n    group_tid_322300 = get_group_id(0);\n    \n    int32_t phys_tid_306288 = global_tid_322298;\n    __local unsigned char *red_arr_mem_322303;\n    \n    red_arr_mem_322303 = (__local unsigned char *) red_arr_mem_322303_backing_0;\n    \n    __local unsigned char *red_arr_mem_322305;\n    \n    red_arr_mem_322305 = (__local unsigned char *) red_arr_mem_322305_backing_1;\n    \n    int32_t phys_group_id_322307;\n    \n    phys_group_id_322307 = get_group_id(0);\n    for (int32_t i_322308 = 0; i_322308 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * n_p_292677 *\n                                          s_n_m_292825,\n                                          squot64(segred_group_sizze_306279,\n                                                  segment_sizze_nonzzero_322296))) -\n                   phys_group_id_322307, sext_i64_i32(num_groups_306280));\n         i_322308++) {\n        int32_t virt_group_id_322309 = phys_group_id_322307 + i_322308 *\n                sext_i64_i32(num_groups_306280);\n        int64_t slice_322310 = s_n_m_292825;\n        int64_t slice_322311 = n_p_292677 * slice_322310;\n        int64_t slice_322312 = partition_sizze_292766 * slice_322311;\n        int64_t gtid_306284 = squot64(squot64(sext_i32_i64(local_tid_322299),\n                                              segment_sizze_nonzzero_322296) +\n                                      sext_i32_i64(virt_group_id_322309) *\n                                      squot64(segred_group_sizze_306279,\n                                              segment_sizze_nonzzero_322296),\n                                      slice_322311);\n        int64_t remnant_322313 = squot64(sext_i32_i64(local",
            "_tid_322299),\n                                         segment_sizze_nonzzero_322296) +\n                sext_i32_i64(virt_group_id_322309) *\n                squot64(segred_group_sizze_306279,\n                        segment_sizze_nonzzero_322296) - gtid_306284 *\n                slice_322311;\n        int64_t gtid_306285 = squot64(remnant_322313, slice_322310);\n        int64_t remnant_322314 = remnant_322313 - gtid_306285 * slice_322310;\n        int64_t gtid_306286 = remnant_322314;\n        int64_t remnant_322315 = remnant_322314 - gtid_306286;\n        int64_t gtid_306287 = srem64(sext_i32_i64(local_tid_322299),\n                                     q_s_292678);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_s_292678) && (((slt64(gtid_306284,\n                                                           partition_sizze_292766) &&\n                                                     slt64(gtid_306285,\n                                                           n_p_292677)) &&\n                                                    slt64(gtid_306286,\n                                                          s_n_m_292825)) &&\n                                                   slt64(sext_i32_i64(local_tid_322299),\n                                                         q_s_292678 *\n                                                         squot64(segred_group_sizze_306279,\n                                                                 segment_sizze_nonzzero_322296)))) {\n                int64_t x_306308;\n                \n                x_306308 = ((__global int64_t *) ext_mem_318609)[gtid_306284 *\n                                                                 n_p_292677 +\n                                                                 gtid_306285];\n                \n                int64_t x_306315;\n                \n                x_306315 = ((__global int64_t *) ext_mem_318708)[gtid_306284 *\n                                ",
            "                                 (s_n_m_292825 *\n                                                                  n_p_292677) +\n                                                                 gtid_306285 *\n                                                                 s_n_m_292825 +\n                                                                 gtid_306286];\n                \n                double x_306316;\n                \n                x_306316 = ((__global double *) ext_mem_318707)[gtid_306284 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_306285 *\n                                                                s_n_m_292825 +\n                                                                gtid_306286];\n                \n                double a11_306317;\n                \n                a11_306317 = ((__global double *) mem_319229)[gtid_306284 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                                              gtid_306285 *\n                                                              s_n_m_292825 +\n                                                              gtid_306286];\n                \n                double b11_306318;\n                \n                b11_306318 = ((__global double *) mem_319234)[gtid_306284 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                                              gtid_306285 *\n                                                              s_n_m_292825 +\n                                                              gtid_306286];\n                \n                dou",
            "ble c11_306319;\n                \n                c11_306319 = ((__global double *) mem_319239)[gtid_306284 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                                              gtid_306285 *\n                                                              s_n_m_292825 +\n                                                              gtid_306286];\n                \n                int64_t defunc_0_m_fun_res_306320;\n                \n                defunc_0_m_fun_res_306320 = ((__global\n                                              int64_t *) mem_319244)[gtid_306284 *\n                                                                     (s_n_m_292825 *\n                                                                      n_p_292677) +\n                                                                     gtid_306285 *\n                                                                     s_n_m_292825 +\n                                                                     gtid_306286];\n                \n                bool cond_306322 = sle64(x_306308, gtid_306287);\n                int64_t defunc_0_f_res_306323;\n                \n                if (cond_306322) {\n                    defunc_0_f_res_306323 = (int64_t) 0;\n                } else {\n                    int64_t i_306324 = add64(gtid_306287, x_306315);\n                    int64_t defunc_0_add_arg_306325;\n                    \n                    defunc_0_add_arg_306325 = ((__global\n                                                int64_t *) ext_mem_318610)[gtid_306284 *\n                                                                           (defunc_0_f_res_292820 *\n                                                                            n_p_292677) +\n                                                                           gtid_306285 *\n                                  ",
            "                                         defunc_0_f_res_292820 +\n                                                                           i_306324];\n                    \n                    int64_t defunc_1_add_res_306326 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_306325);\n                    \n                    defunc_0_f_res_306323 = defunc_1_add_res_306326;\n                }\n                \n                double defunc_0_f_res_306327;\n                \n                if (cond_306322) {\n                    defunc_0_f_res_306327 = 0.0;\n                } else {\n                    int64_t i_306328 = add64(gtid_306287, x_306315);\n                    double defunc_0_add_arg_306329;\n                    \n                    defunc_0_add_arg_306329 = ((__global\n                                                double *) mem_318876)[gtid_306284 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_306285 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_306328];\n                    defunc_0_f_res_306327 = defunc_0_add_arg_306329;\n                }\n                \n                int64_t binop_p_306330 = sub64(defunc_0_f_res_306323,\n                                               defunc_0_m_fun_res_306320);\n                double defunc_0_f_res_306331 = sitofp_i64_f64(binop_p_306330);\n                double abs_res_306332 = fabs(defunc_0_f_res_306331);\n                double tmp1_306333 = abs_res_306332 / x_306316;\n                double x_306334 = tmp1_306333 * tmp1_306333;\n                double y_306335 = tmp1_306333 * x_306334;\n                double tmp2_306336 = 1.0 - y_306335;\n                d",
            "ouble x_306337 = tmp2_306336 * tmp2_306336;\n                double tmp3_306338 = tmp2_306336 * x_306337;\n                double tmp4_306339 = defunc_0_f_res_306327 * tmp3_306338;\n                double defunc_1_f_res_306340 = defunc_0_f_res_306331 *\n                       tmp4_306339;\n                double defunc_0_f_res_306341;\n                \n                if (cond_306322) {\n                    defunc_0_f_res_306341 = 0.0;\n                } else {\n                    int64_t i_306342 = add64(gtid_306287, x_306315);\n                    double defunc_0_add_arg_306343;\n                    \n                    defunc_0_add_arg_306343 = ((__global\n                                                double *) mem_318871)[gtid_306284 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_306285 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_306342];\n                    defunc_0_f_res_306341 = defunc_0_add_arg_306343;\n                }\n                \n                double x_306344 = a11_306317 * tmp4_306339;\n                double y_306345 = b11_306318 * defunc_1_f_res_306340;\n                double x_306346 = x_306344 + y_306345;\n                double defunc_9_fit_fun_res_306347 = defunc_0_f_res_306341 *\n                       x_306346;\n                double x_306348 = b11_306318 * tmp4_306339;\n                double y_306349 = c11_306319 * defunc_1_f_res_306340;\n                double x_306350 = x_306348 + y_306349;\n                double defunc_9_slope_fun_res_306351 = defunc_0_f_res_306341 *\n                       x_306350;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n ",
            "               {\n                    ((__local\n                      double *) red_arr_mem_322303)[sext_i32_i64(local_tid_322299)] =\n                        defunc_9_fit_fun_res_306347;\n                    ((__local\n                      double *) red_arr_mem_322305)[sext_i32_i64(local_tid_322299)] =\n                        defunc_9_slope_fun_res_306351;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_322303)[sext_i32_i64(local_tid_322299)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_322305)[sext_i32_i64(local_tid_322299)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_s_292678)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_306289;\n                double x_306290;\n                double x_306291;\n                double x_306292;\n                double x_322316;\n                double x_322317;\n                double x_322318;\n                double x_322319;\n                bool ltid_in_bounds_322322 =\n                     slt64(sext_i32_i64(local_tid_322299), q_s_292678 *\n                           squot64(segred_group_sizze_306279,\n                                   segment_sizze_nonzzero_322296));\n                int32_t skip_threads_322323;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_322322) {\n                        x_306291 = ((volatile __local\n                                     double *) red_arr_mem_322303)[sext_i32_i64(local_tid_322299)];\n                        x_306292 = ((volatile __local\n                                     double *) red_arr_mem_322305)[sext_i32_i64(local_tid_322299)];\n                        if ((local_tid_322299 - squot32(local_tid_322299, 32) *\n                             32) == 0) {\n                            x_306289 = x",
            "_306291;\n                            x_306290 = x_306292;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_322323 = 1;\n                    while (slt32(skip_threads_322323, 32)) {\n                        bool thread_active_322324 = sle32(skip_threads_322323,\n                                                          local_tid_322299 -\n                                                          squot32(local_tid_322299,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_322322;\n                        \n                        if (thread_active_322324) {\n                            // read operands\n                            {\n                                x_306289 = ((volatile __local\n                                             double *) red_arr_mem_322303)[sext_i32_i64(local_tid_322299) -\n                                                                           sext_i32_i64(skip_threads_322323)];\n                                x_306290 = ((volatile __local\n                                             double *) red_arr_mem_322305)[sext_i32_i64(local_tid_322299) -\n                                                                           sext_i32_i64(skip_threads_322323)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_322325 =\n                                 slt64(srem64(sext_i32_i64(local_tid_322299),\n                                              q_s_292678),\n                                       sext_i32_i64(local_tid_322299) -\n                                       sext_i32_i64(local_tid_322299 -\n                                       skip_threads_322323));\n                            \n                            if (thread_active_322324 &",
            "& inactive_322325) {\n                                x_306289 = x_306291;\n                                x_306290 = x_306292;\n                            }\n                            if (thread_active_322324) {\n                                if (!inactive_322325) {\n                                    double defunc_1_op_res_306293 = x_306289 +\n                                           x_306291;\n                                    double defunc_1_op_res_306294 = x_306290 +\n                                           x_306292;\n                                    \n                                    x_306289 = defunc_1_op_res_306293;\n                                    x_306290 = defunc_1_op_res_306294;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_322301, skip_threads_322323)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_322324) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_322303)[sext_i32_i64(local_tid_322299)] =\n                                    x_306289;\n                                x_306291 = x_306289;\n                                ((volatile __local\n                                  double *) red_arr_mem_322305)[sext_i32_i64(local_tid_322299)] =\n                                    x_306290;\n                                x_306292 = x_306290;\n                            }\n                        }\n                        if (sle32(wave_sizze_322301, skip_threads_322323)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_322323 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result ",
            "to offset 'i'\n                {\n                    if ((local_tid_322299 - squot32(local_tid_322299, 32) *\n                         32) == 31 && ltid_in_bounds_322322) {\n                        ((volatile __local\n                          double *) red_arr_mem_322303)[sext_i32_i64(squot32(local_tid_322299,\n                                                                             32))] =\n                            x_306289;\n                        ((volatile __local\n                          double *) red_arr_mem_322305)[sext_i32_i64(squot32(local_tid_322299,\n                                                                             32))] =\n                            x_306290;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_322326;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_322299, 32) == 0 &&\n                            ltid_in_bounds_322322) {\n                            x_322318 = ((volatile __local\n                                         double *) red_arr_mem_322303)[sext_i32_i64(local_tid_322299)];\n                            x_322319 = ((volatile __local\n                                         double *) red_arr_mem_322305)[sext_i32_i64(local_tid_322299)];\n                            if ((local_tid_322299 - squot32(local_tid_322299,\n                                                            32) * 32) == 0) {\n                                x_322316 = x_322318;\n                                x_322317 = x_322319;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_322326 = 1;\n                        while (slt32(sk",
            "ip_threads_322326, 32)) {\n                            bool thread_active_322327 =\n                                 sle32(skip_threads_322326, local_tid_322299 -\n                                       squot32(local_tid_322299, 32) * 32) &&\n                                 (squot32(local_tid_322299, 32) == 0 &&\n                                  ltid_in_bounds_322322);\n                            \n                            if (thread_active_322327) {\n                                // read operands\n                                {\n                                    x_322316 = ((volatile __local\n                                                 double *) red_arr_mem_322303)[sext_i32_i64(local_tid_322299) -\n                                                                               sext_i32_i64(skip_threads_322326)];\n                                    x_322317 = ((volatile __local\n                                                 double *) red_arr_mem_322305)[sext_i32_i64(local_tid_322299) -\n                                                                               sext_i32_i64(skip_threads_322326)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_322328 =\n                                     slt64(srem64(sext_i32_i64(local_tid_322299 *\n                                                  32 + 32 - 1), q_s_292678),\n                                           sext_i32_i64(local_tid_322299 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_322299 -\n                                                         skip_threads_322326) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_322327 && inactive_322328) {\n                                    x_322316 = x_322318;\n    ",
            "                                x_322317 = x_322319;\n                                }\n                                if (thread_active_322327) {\n                                    if (!inactive_322328) {\n                                        double defunc_1_op_res_322320 =\n                                               x_322316 + x_322318;\n                                        double defunc_1_op_res_322321 =\n                                               x_322317 + x_322319;\n                                        \n                                        x_322316 = defunc_1_op_res_322320;\n                                        x_322317 = defunc_1_op_res_322321;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_322301, skip_threads_322326)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_322327) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_322303)[sext_i32_i64(local_tid_322299)] =\n                                        x_322316;\n                                    x_322318 = x_322316;\n                                    ((volatile __local\n                                      double *) red_arr_mem_322305)[sext_i32_i64(local_tid_322299)] =\n                                        x_322317;\n                                    x_322319 = x_322317;\n                                }\n                            }\n                            if (sle32(wave_sizze_322301, skip_threads_322326)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_322326 *= 2;\n                        }\n                    }\n                }\n                barrier(",
            "CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_322329 = squot32(local_tid_322299, 32) == 0 ||\n                     !ltid_in_bounds_322322;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_322329) {\n                            x_306291 = x_306289;\n                            x_306292 = x_306290;\n                            x_306289 = ((__local\n                                         double *) red_arr_mem_322303)[sext_i32_i64(squot32(local_tid_322299,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_306290 = ((__local\n                                         double *) red_arr_mem_322305)[sext_i32_i64(squot32(local_tid_322299,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_322330 =\n                             slt64(srem64(sext_i32_i64(local_tid_322299),\n                                          q_s_292678),\n                                   sext_i32_i64(local_tid_322299) -\n                                   sext_i32_i64(squot32(local_tid_322299, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_322329) {\n                            if (inactive_322330) {\n                                x_306289 = x_306291;\n                                x_306290 = x_306292;\n                            }\n                        }\n                        if (!no_carry_in_322329) {\n                          ",
            "  if (!inactive_322330) {\n                                double defunc_1_op_res_306293 = x_306289 +\n                                       x_306291;\n                                double defunc_1_op_res_306294 = x_306290 +\n                                       x_306292;\n                                \n                                x_306289 = defunc_1_op_res_306293;\n                                x_306290 = defunc_1_op_res_306294;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_322329) {\n                            ((__local\n                              double *) red_arr_mem_322303)[sext_i32_i64(local_tid_322299)] =\n                                x_306289;\n                            ((__local\n                              double *) red_arr_mem_322305)[sext_i32_i64(local_tid_322299)] =\n                                x_306290;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_322299, 32) == 0 &&\n                        ltid_in_bounds_322322) {\n                        ((__local\n                          double *) red_arr_mem_322303)[sext_i32_i64(local_tid_322299)] =\n                            x_306291;\n                        ((__local\n                          double *) red_arr_mem_322305)[sext_i32_i64(local_tid_322299)] =\n                            x_306292;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_322309) *\n                      squot64(segred_group_sizze_306279,\n                              segment_sizze_nonzzero_322296) +\n                 ",
            "     sext_i32_i64(local_tid_322299), partition_sizze_292766 *\n                      n_p_292677 * s_n_m_292825) &&\n                slt64(sext_i32_i64(local_tid_322299),\n                      squot64(segred_group_sizze_306279,\n                              segment_sizze_nonzzero_322296))) {\n                double tmp_322331;\n                \n                tmp_322331 = ((__local\n                               double *) red_arr_mem_322303)[(sext_i32_i64(local_tid_322299) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322296 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319250)[squot64(sext_i32_i64(virt_group_id_322309) *\n                                                squot64(segred_group_sizze_306279,\n                                                        segment_sizze_nonzzero_322296) +\n                                                sext_i32_i64(local_tid_322299),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_322309) *\n                                                squot64(segred_group_sizze_306279,\n                                                        segment_sizze_nonzzero_322296) +\n                                                sext_i32_i64(local_tid_322299) -\n                                                squot64(sext_i32_i64(virt_group_id_322309) *\n                                                        squot64(segred_group_sizze_306279,\n                                                                segment_sizze_nonzzero_322296) +\n                                                        sext_i32_i64(local_tid_322299),\n                                                        n_p_2",
            "92677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_322309) *\n                                         squot64(segred_group_sizze_306279,\n                                                 segment_sizze_nonzzero_322296) +\n                                         sext_i32_i64(local_tid_322299) -\n                                         squot64(sext_i32_i64(virt_group_id_322309) *\n                                                 squot64(segred_group_sizze_306279,\n                                                         segment_sizze_nonzzero_322296) +\n                                                 sext_i32_i64(local_tid_322299),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_group_id_322309) *\n                                                 squot64(segred_group_sizze_306279,\n                                                         segment_sizze_nonzzero_322296) +\n                                                 sext_i32_i64(local_tid_322299) -\n                                                 squot64(sext_i32_i64(virt_group_id_322309) *\n                                                         squot64(segred_group_sizze_306279,\n                                                                 segment_sizze_nonzzero_322296) +\n                                                         sext_i32_i64(local_tid_322299),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                            ",
            "                     s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_322331;\n                \n                double tmp_322332;\n                \n                tmp_322332 = ((__local\n                               double *) red_arr_mem_322305)[(sext_i32_i64(local_tid_322299) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322296 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319255)[squot64(sext_i32_i64(virt_group_id_322309) *\n                                                squot64(segred_group_sizze_306279,\n                                                        segment_sizze_nonzzero_322296) +\n                                                sext_i32_i64(local_tid_322299),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_322309) *\n                                                squot64(segred_group_sizze_306279,\n                                                        segment_sizze_nonzzero_322296) +\n                                                sext_i32_i64(local_tid_322299) -\n                                                squot64(sext_i32_i64(virt_group_id_322309) *\n                                                        squot64(segred_group_sizze_306279,\n                                                                segment_sizze_nonzzero_322296) +\n                                                        sext_i32_i64(local_tid_322299),\n                                                        n_p_292677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n         ",
            "                                       s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_322309) *\n                                         squot64(segred_group_sizze_306279,\n                                                 segment_sizze_nonzzero_322296) +\n                                         sext_i32_i64(local_tid_322299) -\n                                         squot64(sext_i32_i64(virt_group_id_322309) *\n                                                 squot64(segred_group_sizze_306279,\n                                                         segment_sizze_nonzzero_322296) +\n                                                 sext_i32_i64(local_tid_322299),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_group_id_322309) *\n                                                 squot64(segred_group_sizze_306279,\n                                                         segment_sizze_nonzzero_322296) +\n                                                 sext_i32_i64(local_tid_322299) -\n                                                 squot64(sext_i32_i64(virt_group_id_322309) *\n                                                         squot64(segred_group_sizze_306279,\n                                                                 segment_sizze_nonzzero_322296) +\n                                                         sext_i32_i64(local_tid_322299),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_322332;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE",
            ");\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_306279\n}\n__kernel void mainzisegred_small_308109(__global int *global_failure,\n                                        uint red_arr_mem_322562_backing_offset_0,\n                                        uint red_arr_mem_322560_backing_offset_1,\n                                        uint red_arr_mem_322558_backing_offset_2,\n                                        uint red_arr_mem_322556_backing_offset_3,\n                                        uint red_arr_mem_322554_backing_offset_4,\n                                        int64_t n_p_292677, int64_t q_s_292678,\n                                        int64_t partition_sizze_292766,\n                                        int64_t defunc_0_f_res_292820,\n                                        int64_t s_n_m_292825,\n                                        int64_t num_groups_308098,\n                                        int64_t segment_sizze_nonzzero_322547,\n                                        __global unsigned char *ext_mem_318609,\n                                        __global unsigned char *ext_mem_318610,\n                                        __global unsigned char *ext_mem_318707,\n                                        __global unsigned char *ext_mem_318708,\n                                        __global unsigned char *mem_318876,\n                                        __global unsigned char *mem_319395,\n                                        __global unsigned char *mem_319405,\n                                        __global unsigned char *mem_319410,\n                                        __global unsigned char *mem_319415,\n                                        __global unsigned char *mem_319420,\n                                        __global unsigned char *mem_319425)\n{\n    #define segred_group_sizze_308097 (mainzisegred_group_sizze_307119)\n    \n    const int block_d",
            "im0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_322562_backing_4 =\n                           &shared_mem[red_arr_mem_322562_backing_offset_0];\n    volatile unsigned char *red_arr_mem_322560_backing_3 =\n                           &shared_mem[red_arr_mem_322560_backing_offset_1];\n    volatile unsigned char *red_arr_mem_322558_backing_2 =\n                           &shared_mem[red_arr_mem_322558_backing_offset_2];\n    volatile unsigned char *red_arr_mem_322556_backing_1 =\n                           &shared_mem[red_arr_mem_322556_backing_offset_3];\n    volatile unsigned char *red_arr_mem_322554_backing_0 =\n                           &shared_mem[red_arr_mem_322554_backing_offset_4];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322549;\n    int32_t local_tid_322550;\n    int64_t group_sizze_322553;\n    int32_t wave_sizze_322552;\n    int32_t group_tid_322551;\n    \n    global_tid_322549 = get_global_id(0);\n    local_tid_322550 = get_local_id(0);\n    group_sizze_322553 = get_local_size(0);\n    wave_sizze_322552 = LOCKSTEP_WIDTH;\n    group_tid_322551 = get_group_id(0);\n    \n    int32_t phys_tid_308109 = global_tid_322549;\n    __local unsigned char *red_arr_mem_322554;\n    \n    red_arr_mem_322554 = (__local unsigned char *) red_arr_mem_322554_backing_0;\n    \n    __local unsigned char *red_arr_mem_322556;\n    \n    red_arr_mem_322556 = (__local unsigned char *) red_arr_mem_322556_backing_1;\n    \n    __local unsigned char *red_arr_mem_322558;\n    \n    red_arr_mem_322558 = (__local unsigned char *) red_arr_mem_322558_backing_2;\n    \n    __local unsigned char *red_arr_mem_322560;\n    \n    red_arr_mem_322560 = (__local unsigned char *) red_arr_mem_322560_backing_3;\n    \n    __local unsigned char *red_arr_mem_322562;\n    \n    red_arr_mem_322562 = (__local unsigned char *) red_arr_mem_322562_backing_4;\n    \n    int32_t phys_group_id_322564;\n    \n    phys_group_id_322564 = get_group_id(0);\n   ",
            " for (int32_t i_322565 = 0; i_322565 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * n_p_292677 *\n                                          s_n_m_292825,\n                                          squot64(segred_group_sizze_308097,\n                                                  segment_sizze_nonzzero_322547))) -\n                   phys_group_id_322564, sext_i64_i32(num_groups_308098));\n         i_322565++) {\n        int32_t virt_group_id_322566 = phys_group_id_322564 + i_322565 *\n                sext_i64_i32(num_groups_308098);\n        int64_t slice_322567 = s_n_m_292825;\n        int64_t slice_322568 = n_p_292677 * slice_322567;\n        int64_t slice_322569 = partition_sizze_292766 * slice_322568;\n        int64_t gtid_308105 = squot64(squot64(sext_i32_i64(local_tid_322550),\n                                              segment_sizze_nonzzero_322547) +\n                                      sext_i32_i64(virt_group_id_322566) *\n                                      squot64(segred_group_sizze_308097,\n                                              segment_sizze_nonzzero_322547),\n                                      slice_322568);\n        int64_t remnant_322570 = squot64(sext_i32_i64(local_tid_322550),\n                                         segment_sizze_nonzzero_322547) +\n                sext_i32_i64(virt_group_id_322566) *\n                squot64(segred_group_sizze_308097,\n                        segment_sizze_nonzzero_322547) - gtid_308105 *\n                slice_322568;\n        int64_t gtid_308106 = squot64(remnant_322570, slice_322567);\n        int64_t remnant_322571 = remnant_322570 - gtid_308106 * slice_322567;\n        int64_t gtid_308107 = remnant_322571;\n        int64_t remnant_322572 = remnant_322571 - gtid_308107;\n        int64_t gtid_308108 = srem64(sext_i32_i64(local_tid_322550),\n                                     q_s_292678);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_s_292678",
            ") && (((slt64(gtid_308105,\n                                                           partition_sizze_292766) &&\n                                                     slt64(gtid_308106,\n                                                           n_p_292677)) &&\n                                                    slt64(gtid_308107,\n                                                          s_n_m_292825)) &&\n                                                   slt64(sext_i32_i64(local_tid_322550),\n                                                         q_s_292678 *\n                                                         squot64(segred_group_sizze_308097,\n                                                                 segment_sizze_nonzzero_322547)))) {\n                int64_t x_308133;\n                \n                x_308133 = ((__global int64_t *) ext_mem_318609)[gtid_308105 *\n                                                                 n_p_292677 +\n                                                                 gtid_308106];\n                \n                int64_t x_308137;\n                \n                x_308137 = ((__global int64_t *) ext_mem_318708)[gtid_308105 *\n                                                                 (s_n_m_292825 *\n                                                                  n_p_292677) +\n                                                                 gtid_308106 *\n                                                                 s_n_m_292825 +\n                                                                 gtid_308107];\n                \n                double x_308138;\n                \n                x_308138 = ((__global double *) ext_mem_318707)[gtid_308105 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_308106 *\n                          ",
            "                                      s_n_m_292825 +\n                                                                gtid_308107];\n                \n                int64_t defunc_0_m_fun_res_308139;\n                \n                defunc_0_m_fun_res_308139 = ((__global\n                                              int64_t *) mem_319395)[gtid_308105 *\n                                                                     (s_n_m_292825 *\n                                                                      n_p_292677) +\n                                                                     gtid_308106 *\n                                                                     s_n_m_292825 +\n                                                                     gtid_308107];\n                \n                bool cond_308141 = sle64(x_308133, gtid_308108);\n                int64_t defunc_0_f_res_308142;\n                \n                if (cond_308141) {\n                    defunc_0_f_res_308142 = (int64_t) 0;\n                } else {\n                    int64_t i_308143 = add64(gtid_308108, x_308137);\n                    int64_t defunc_0_add_arg_308144;\n                    \n                    defunc_0_add_arg_308144 = ((__global\n                                                int64_t *) ext_mem_318610)[gtid_308105 *\n                                                                           (defunc_0_f_res_292820 *\n                                                                            n_p_292677) +\n                                                                           gtid_308106 *\n                                                                           defunc_0_f_res_292820 +\n                                                                           i_308143];\n                    \n                    int64_t defunc_1_add_res_308145 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_308144);\n                    \n          ",
            "          defunc_0_f_res_308142 = defunc_1_add_res_308145;\n                }\n                \n                double defunc_0_f_res_308146;\n                \n                if (cond_308141) {\n                    defunc_0_f_res_308146 = 0.0;\n                } else {\n                    int64_t i_308147 = add64(gtid_308108, x_308137);\n                    double defunc_0_add_arg_308148;\n                    \n                    defunc_0_add_arg_308148 = ((__global\n                                                double *) mem_318876)[gtid_308105 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_308106 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_308147];\n                    defunc_0_f_res_308146 = defunc_0_add_arg_308148;\n                }\n                \n                int64_t binop_p_308149 = sub64(defunc_0_f_res_308142,\n                                               defunc_0_m_fun_res_308139);\n                double defunc_0_f_res_308150 = sitofp_i64_f64(binop_p_308149);\n                double abs_res_308151 = fabs(defunc_0_f_res_308150);\n                double tmp1_308152 = abs_res_308151 / x_308138;\n                double x_308153 = tmp1_308152 * tmp1_308152;\n                double y_308154 = tmp1_308152 * x_308153;\n                double tmp2_308155 = 1.0 - y_308154;\n                double x_308156 = tmp2_308155 * tmp2_308155;\n                double tmp3_308157 = tmp2_308155 * x_308156;\n                double w_j_308158 = defunc_0_f_res_308146 * tmp3_308157;\n                double xw_j_308159 = defunc_0_f_res_308150 * w_j_308158;\n                double x2w_j_308160 = defunc_0_f_res_308150 * xw_j_308159;\n                double x3w_j_308161 ",
            "= defunc_0_f_res_308150 * x2w_j_308160;\n                double x4w_j_308162 = defunc_0_f_res_308150 * x3w_j_308161;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_322554)[sext_i32_i64(local_tid_322550)] =\n                        w_j_308158;\n                    ((__local\n                      double *) red_arr_mem_322556)[sext_i32_i64(local_tid_322550)] =\n                        xw_j_308159;\n                    ((__local\n                      double *) red_arr_mem_322558)[sext_i32_i64(local_tid_322550)] =\n                        x2w_j_308160;\n                    ((__local\n                      double *) red_arr_mem_322560)[sext_i32_i64(local_tid_322550)] =\n                        x3w_j_308161;\n                    ((__local\n                      double *) red_arr_mem_322562)[sext_i32_i64(local_tid_322550)] =\n                        x4w_j_308162;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_322554)[sext_i32_i64(local_tid_322550)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_322556)[sext_i32_i64(local_tid_322550)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_322558)[sext_i32_i64(local_tid_322550)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_322560)[sext_i32_i64(local_tid_322550)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_322562)[sext_i32_i64(local_tid_322550)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_s_292678)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_308110;\n                double x_308111;\n                double x_",
            "308112;\n                double x_308113;\n                double x_308114;\n                double x_308115;\n                double x_308116;\n                double x_308117;\n                double x_308118;\n                double x_308119;\n                double x_322573;\n                double x_322574;\n                double x_322575;\n                double x_322576;\n                double x_322577;\n                double x_322578;\n                double x_322579;\n                double x_322580;\n                double x_322581;\n                double x_322582;\n                bool ltid_in_bounds_322588 =\n                     slt64(sext_i32_i64(local_tid_322550), q_s_292678 *\n                           squot64(segred_group_sizze_308097,\n                                   segment_sizze_nonzzero_322547));\n                int32_t skip_threads_322589;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_322588) {\n                        x_308115 = ((volatile __local\n                                     double *) red_arr_mem_322554)[sext_i32_i64(local_tid_322550)];\n                        x_308116 = ((volatile __local\n                                     double *) red_arr_mem_322556)[sext_i32_i64(local_tid_322550)];\n                        x_308117 = ((volatile __local\n                                     double *) red_arr_mem_322558)[sext_i32_i64(local_tid_322550)];\n                        x_308118 = ((volatile __local\n                                     double *) red_arr_mem_322560)[sext_i32_i64(local_tid_322550)];\n                        x_308119 = ((volatile __local\n                                     double *) red_arr_mem_322562)[sext_i32_i64(local_tid_322550)];\n                        if ((local_tid_322550 - squot32(local_tid_322550, 32) *\n                             32) == 0) {\n                            x_308110 = x_308115;\n                            x_308111 = x_308116;\n                  ",
            "          x_308112 = x_308117;\n                            x_308113 = x_308118;\n                            x_308114 = x_308119;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_322589 = 1;\n                    while (slt32(skip_threads_322589, 32)) {\n                        bool thread_active_322590 = sle32(skip_threads_322589,\n                                                          local_tid_322550 -\n                                                          squot32(local_tid_322550,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_322588;\n                        \n                        if (thread_active_322590) {\n                            // read operands\n                            {\n                                x_308110 = ((volatile __local\n                                             double *) red_arr_mem_322554)[sext_i32_i64(local_tid_322550) -\n                                                                           sext_i32_i64(skip_threads_322589)];\n                                x_308111 = ((volatile __local\n                                             double *) red_arr_mem_322556)[sext_i32_i64(local_tid_322550) -\n                                                                           sext_i32_i64(skip_threads_322589)];\n                                x_308112 = ((volatile __local\n                                             double *) red_arr_mem_322558)[sext_i32_i64(local_tid_322550) -\n                                                                           sext_i32_i64(skip_threads_322589)];\n                                x_308113 = ((volatile __local\n                                             double *) red_arr_mem_322560)[sext_i32_i64(local_tid_322550) -\n                                                                           sext_i",
            "32_i64(skip_threads_322589)];\n                                x_308114 = ((volatile __local\n                                             double *) red_arr_mem_322562)[sext_i32_i64(local_tid_322550) -\n                                                                           sext_i32_i64(skip_threads_322589)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_322591 =\n                                 slt64(srem64(sext_i32_i64(local_tid_322550),\n                                              q_s_292678),\n                                       sext_i32_i64(local_tid_322550) -\n                                       sext_i32_i64(local_tid_322550 -\n                                       skip_threads_322589));\n                            \n                            if (thread_active_322590 && inactive_322591) {\n                                x_308110 = x_308115;\n                                x_308111 = x_308116;\n                                x_308112 = x_308117;\n                                x_308113 = x_308118;\n                                x_308114 = x_308119;\n                            }\n                            if (thread_active_322590) {\n                                if (!inactive_322591) {\n                                    double defunc_1_op_res_308120 = x_308110 +\n                                           x_308115;\n                                    double defunc_1_op_res_308121 = x_308111 +\n                                           x_308116;\n                                    double defunc_1_op_res_308122 = x_308112 +\n                                           x_308117;\n                                    double defunc_1_op_res_308123 = x_308113 +\n                                           x_308118;\n                                    double defunc_1_op_res_308124 = x_308114 +\n                                           x_308119",
            ";\n                                    \n                                    x_308110 = defunc_1_op_res_308120;\n                                    x_308111 = defunc_1_op_res_308121;\n                                    x_308112 = defunc_1_op_res_308122;\n                                    x_308113 = defunc_1_op_res_308123;\n                                    x_308114 = defunc_1_op_res_308124;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_322552, skip_threads_322589)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_322590) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_322554)[sext_i32_i64(local_tid_322550)] =\n                                    x_308110;\n                                x_308115 = x_308110;\n                                ((volatile __local\n                                  double *) red_arr_mem_322556)[sext_i32_i64(local_tid_322550)] =\n                                    x_308111;\n                                x_308116 = x_308111;\n                                ((volatile __local\n                                  double *) red_arr_mem_322558)[sext_i32_i64(local_tid_322550)] =\n                                    x_308112;\n                                x_308117 = x_308112;\n                                ((volatile __local\n                                  double *) red_arr_mem_322560)[sext_i32_i64(local_tid_322550)] =\n                                    x_308113;\n                                x_308118 = x_308113;\n                                ((volatile __local\n                                  double *) red_arr_mem_322562)[sext_i32_i64(local_tid_322550)] =\n                                    x_308114;\n                                x_308119 =",
            " x_308114;\n                            }\n                        }\n                        if (sle32(wave_sizze_322552, skip_threads_322589)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_322589 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_322550 - squot32(local_tid_322550, 32) *\n                         32) == 31 && ltid_in_bounds_322588) {\n                        ((volatile __local\n                          double *) red_arr_mem_322554)[sext_i32_i64(squot32(local_tid_322550,\n                                                                             32))] =\n                            x_308110;\n                        ((volatile __local\n                          double *) red_arr_mem_322556)[sext_i32_i64(squot32(local_tid_322550,\n                                                                             32))] =\n                            x_308111;\n                        ((volatile __local\n                          double *) red_arr_mem_322558)[sext_i32_i64(squot32(local_tid_322550,\n                                                                             32))] =\n                            x_308112;\n                        ((volatile __local\n                          double *) red_arr_mem_322560)[sext_i32_i64(squot32(local_tid_322550,\n                                                                             32))] =\n                            x_308113;\n                        ((volatile __local\n                          double *) red_arr_mem_322562)[sext_i32_i64(squot32(local_tid_322550,\n                                                                             32))] =\n                            x_308114;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            ",
            "    // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_322592;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_322550, 32) == 0 &&\n                            ltid_in_bounds_322588) {\n                            x_322578 = ((volatile __local\n                                         double *) red_arr_mem_322554)[sext_i32_i64(local_tid_322550)];\n                            x_322579 = ((volatile __local\n                                         double *) red_arr_mem_322556)[sext_i32_i64(local_tid_322550)];\n                            x_322580 = ((volatile __local\n                                         double *) red_arr_mem_322558)[sext_i32_i64(local_tid_322550)];\n                            x_322581 = ((volatile __local\n                                         double *) red_arr_mem_322560)[sext_i32_i64(local_tid_322550)];\n                            x_322582 = ((volatile __local\n                                         double *) red_arr_mem_322562)[sext_i32_i64(local_tid_322550)];\n                            if ((local_tid_322550 - squot32(local_tid_322550,\n                                                            32) * 32) == 0) {\n                                x_322573 = x_322578;\n                                x_322574 = x_322579;\n                                x_322575 = x_322580;\n                                x_322576 = x_322581;\n                                x_322577 = x_322582;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_322592 = 1;\n                        while (slt32(skip_threads_322592, 32)) {\n                            bool thread_active_322593 =\n                                 sle32(skip_threads_322592, loca",
            "l_tid_322550 -\n                                       squot32(local_tid_322550, 32) * 32) &&\n                                 (squot32(local_tid_322550, 32) == 0 &&\n                                  ltid_in_bounds_322588);\n                            \n                            if (thread_active_322593) {\n                                // read operands\n                                {\n                                    x_322573 = ((volatile __local\n                                                 double *) red_arr_mem_322554)[sext_i32_i64(local_tid_322550) -\n                                                                               sext_i32_i64(skip_threads_322592)];\n                                    x_322574 = ((volatile __local\n                                                 double *) red_arr_mem_322556)[sext_i32_i64(local_tid_322550) -\n                                                                               sext_i32_i64(skip_threads_322592)];\n                                    x_322575 = ((volatile __local\n                                                 double *) red_arr_mem_322558)[sext_i32_i64(local_tid_322550) -\n                                                                               sext_i32_i64(skip_threads_322592)];\n                                    x_322576 = ((volatile __local\n                                                 double *) red_arr_mem_322560)[sext_i32_i64(local_tid_322550) -\n                                                                               sext_i32_i64(skip_threads_322592)];\n                                    x_322577 = ((volatile __local\n                                                 double *) red_arr_mem_322562)[sext_i32_i64(local_tid_322550) -\n                                                                               sext_i32_i64(skip_threads_322592)];\n                                }\n                            }\n                            // perform operation\n                            {\n ",
            "                               bool inactive_322594 =\n                                     slt64(srem64(sext_i32_i64(local_tid_322550 *\n                                                  32 + 32 - 1), q_s_292678),\n                                           sext_i32_i64(local_tid_322550 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_322550 -\n                                                         skip_threads_322592) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_322593 && inactive_322594) {\n                                    x_322573 = x_322578;\n                                    x_322574 = x_322579;\n                                    x_322575 = x_322580;\n                                    x_322576 = x_322581;\n                                    x_322577 = x_322582;\n                                }\n                                if (thread_active_322593) {\n                                    if (!inactive_322594) {\n                                        double defunc_1_op_res_322583 =\n                                               x_322573 + x_322578;\n                                        double defunc_1_op_res_322584 =\n                                               x_322574 + x_322579;\n                                        double defunc_1_op_res_322585 =\n                                               x_322575 + x_322580;\n                                        double defunc_1_op_res_322586 =\n                                               x_322576 + x_322581;\n                                        double defunc_1_op_res_322587 =\n                                               x_322577 + x_322582;\n                                        \n                                        x_322573 = defunc_1_op_res_322583;\n                                        x_322574 = defunc_1_op_res_322584",
            ";\n                                        x_322575 = defunc_1_op_res_322585;\n                                        x_322576 = defunc_1_op_res_322586;\n                                        x_322577 = defunc_1_op_res_322587;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_322552, skip_threads_322592)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_322593) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_322554)[sext_i32_i64(local_tid_322550)] =\n                                        x_322573;\n                                    x_322578 = x_322573;\n                                    ((volatile __local\n                                      double *) red_arr_mem_322556)[sext_i32_i64(local_tid_322550)] =\n                                        x_322574;\n                                    x_322579 = x_322574;\n                                    ((volatile __local\n                                      double *) red_arr_mem_322558)[sext_i32_i64(local_tid_322550)] =\n                                        x_322575;\n                                    x_322580 = x_322575;\n                                    ((volatile __local\n                                      double *) red_arr_mem_322560)[sext_i32_i64(local_tid_322550)] =\n                                        x_322576;\n                                    x_322581 = x_322576;\n                                    ((volatile __local\n                                      double *) red_arr_mem_322562)[sext_i32_i64(local_tid_322550)] =\n                                        x_322577;\n                                    x_322582 = x_322577;\n                                }\n      ",
            "                      }\n                            if (sle32(wave_sizze_322552, skip_threads_322592)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_322592 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_322595 = squot32(local_tid_322550, 32) == 0 ||\n                     !ltid_in_bounds_322588;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_322595) {\n                            x_308115 = x_308110;\n                            x_308116 = x_308111;\n                            x_308117 = x_308112;\n                            x_308118 = x_308113;\n                            x_308119 = x_308114;\n                            x_308110 = ((__local\n                                         double *) red_arr_mem_322554)[sext_i32_i64(squot32(local_tid_322550,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_308111 = ((__local\n                                         double *) red_arr_mem_322556)[sext_i32_i64(squot32(local_tid_322550,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_308112 = ((__local\n                                         double *) red_arr_mem_322558)[sext_i32_i64(squot32(local_tid_322550,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n               ",
            "             x_308113 = ((__local\n                                         double *) red_arr_mem_322560)[sext_i32_i64(squot32(local_tid_322550,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_308114 = ((__local\n                                         double *) red_arr_mem_322562)[sext_i32_i64(squot32(local_tid_322550,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_322596 =\n                             slt64(srem64(sext_i32_i64(local_tid_322550),\n                                          q_s_292678),\n                                   sext_i32_i64(local_tid_322550) -\n                                   sext_i32_i64(squot32(local_tid_322550, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_322595) {\n                            if (inactive_322596) {\n                                x_308110 = x_308115;\n                                x_308111 = x_308116;\n                                x_308112 = x_308117;\n                                x_308113 = x_308118;\n                                x_308114 = x_308119;\n                            }\n                        }\n                        if (!no_carry_in_322595) {\n                            if (!inactive_322596) {\n                                double defunc_1_op_res_308120 = x_308110 +\n                                       x_308115;\n                                double defunc_1_op_res_308121 = x_308111 +\n                                       x_308116;\n                                double defunc_1_op",
            "_res_308122 = x_308112 +\n                                       x_308117;\n                                double defunc_1_op_res_308123 = x_308113 +\n                                       x_308118;\n                                double defunc_1_op_res_308124 = x_308114 +\n                                       x_308119;\n                                \n                                x_308110 = defunc_1_op_res_308120;\n                                x_308111 = defunc_1_op_res_308121;\n                                x_308112 = defunc_1_op_res_308122;\n                                x_308113 = defunc_1_op_res_308123;\n                                x_308114 = defunc_1_op_res_308124;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_322595) {\n                            ((__local\n                              double *) red_arr_mem_322554)[sext_i32_i64(local_tid_322550)] =\n                                x_308110;\n                            ((__local\n                              double *) red_arr_mem_322556)[sext_i32_i64(local_tid_322550)] =\n                                x_308111;\n                            ((__local\n                              double *) red_arr_mem_322558)[sext_i32_i64(local_tid_322550)] =\n                                x_308112;\n                            ((__local\n                              double *) red_arr_mem_322560)[sext_i32_i64(local_tid_322550)] =\n                                x_308113;\n                            ((__local\n                              double *) red_arr_mem_322562)[sext_i32_i64(local_tid_322550)] =\n                                x_308114;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_322550, 32) == 0 ",
            "&&\n                        ltid_in_bounds_322588) {\n                        ((__local\n                          double *) red_arr_mem_322554)[sext_i32_i64(local_tid_322550)] =\n                            x_308115;\n                        ((__local\n                          double *) red_arr_mem_322556)[sext_i32_i64(local_tid_322550)] =\n                            x_308116;\n                        ((__local\n                          double *) red_arr_mem_322558)[sext_i32_i64(local_tid_322550)] =\n                            x_308117;\n                        ((__local\n                          double *) red_arr_mem_322560)[sext_i32_i64(local_tid_322550)] =\n                            x_308118;\n                        ((__local\n                          double *) red_arr_mem_322562)[sext_i32_i64(local_tid_322550)] =\n                            x_308119;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_322566) *\n                      squot64(segred_group_sizze_308097,\n                              segment_sizze_nonzzero_322547) +\n                      sext_i32_i64(local_tid_322550), partition_sizze_292766 *\n                      n_p_292677 * s_n_m_292825) &&\n                slt64(sext_i32_i64(local_tid_322550),\n                      squot64(segred_group_sizze_308097,\n                              segment_sizze_nonzzero_322547))) {\n                double tmp_322597;\n                \n                tmp_322597 = ((__local\n                               double *) red_arr_mem_322554)[(sext_i32_i64(local_tid_322550) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322547 -\n                                                             (int64_t) 1];\n                ((__gl",
            "obal\n                  double *) mem_319405)[squot64(sext_i32_i64(virt_group_id_322566) *\n                                                squot64(segred_group_sizze_308097,\n                                                        segment_sizze_nonzzero_322547) +\n                                                sext_i32_i64(local_tid_322550),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_322566) *\n                                                squot64(segred_group_sizze_308097,\n                                                        segment_sizze_nonzzero_322547) +\n                                                sext_i32_i64(local_tid_322550) -\n                                                squot64(sext_i32_i64(virt_group_id_322566) *\n                                                        squot64(segred_group_sizze_308097,\n                                                                segment_sizze_nonzzero_322547) +\n                                                        sext_i32_i64(local_tid_322550),\n                                                        n_p_292677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_322566) *\n                                         squot64(segred_group_sizze_308097,\n                                                 segment_sizze_nonzzero_322547) +\n                                         sext_i32_i64(local_tid_322550) -\n                                         squot64(sext_i32_i64(virt_group_id_322566) *\n                                                 squot64(segred_group_sizze_308097,\n                           ",
            "                              segment_sizze_nonzzero_322547) +\n                                                 sext_i32_i64(local_tid_322550),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_group_id_322566) *\n                                                 squot64(segred_group_sizze_308097,\n                                                         segment_sizze_nonzzero_322547) +\n                                                 sext_i32_i64(local_tid_322550) -\n                                                 squot64(sext_i32_i64(virt_group_id_322566) *\n                                                         squot64(segred_group_sizze_308097,\n                                                                 segment_sizze_nonzzero_322547) +\n                                                         sext_i32_i64(local_tid_322550),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_322597;\n                \n                double tmp_322598;\n                \n                tmp_322598 = ((__local\n                               double *) red_arr_mem_322556)[(sext_i32_i64(local_tid_322550) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322547 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319410)[squot64(sext_i32_i64(virt_group_id_322566) *\n                                                squot64(segred_group_sizze_3",
            "08097,\n                                                        segment_sizze_nonzzero_322547) +\n                                                sext_i32_i64(local_tid_322550),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_322566) *\n                                                squot64(segred_group_sizze_308097,\n                                                        segment_sizze_nonzzero_322547) +\n                                                sext_i32_i64(local_tid_322550) -\n                                                squot64(sext_i32_i64(virt_group_id_322566) *\n                                                        squot64(segred_group_sizze_308097,\n                                                                segment_sizze_nonzzero_322547) +\n                                                        sext_i32_i64(local_tid_322550),\n                                                        n_p_292677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_322566) *\n                                         squot64(segred_group_sizze_308097,\n                                                 segment_sizze_nonzzero_322547) +\n                                         sext_i32_i64(local_tid_322550) -\n                                         squot64(sext_i32_i64(virt_group_id_322566) *\n                                                 squot64(segred_group_sizze_308097,\n                                                         segment_sizze_nonzzero_322547) +\n                                                 sext_i32_i64(local_tid_322550),\n                      ",
            "                           n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_group_id_322566) *\n                                                 squot64(segred_group_sizze_308097,\n                                                         segment_sizze_nonzzero_322547) +\n                                                 sext_i32_i64(local_tid_322550) -\n                                                 squot64(sext_i32_i64(virt_group_id_322566) *\n                                                         squot64(segred_group_sizze_308097,\n                                                                 segment_sizze_nonzzero_322547) +\n                                                         sext_i32_i64(local_tid_322550),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_322598;\n                \n                double tmp_322599;\n                \n                tmp_322599 = ((__local\n                               double *) red_arr_mem_322558)[(sext_i32_i64(local_tid_322550) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322547 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319415)[squot64(sext_i32_i64(virt_group_id_322566) *\n                                                squot64(segred_group_sizze_308097,\n                                                        segment_sizze_nonzzero_322547) +\n                                                sext_i32_i64(local_tid",
            "_322550),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_322566) *\n                                                squot64(segred_group_sizze_308097,\n                                                        segment_sizze_nonzzero_322547) +\n                                                sext_i32_i64(local_tid_322550) -\n                                                squot64(sext_i32_i64(virt_group_id_322566) *\n                                                        squot64(segred_group_sizze_308097,\n                                                                segment_sizze_nonzzero_322547) +\n                                                        sext_i32_i64(local_tid_322550),\n                                                        n_p_292677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_322566) *\n                                         squot64(segred_group_sizze_308097,\n                                                 segment_sizze_nonzzero_322547) +\n                                         sext_i32_i64(local_tid_322550) -\n                                         squot64(sext_i32_i64(virt_group_id_322566) *\n                                                 squot64(segred_group_sizze_308097,\n                                                         segment_sizze_nonzzero_322547) +\n                                                 sext_i32_i64(local_tid_322550),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                       ",
            "  squot64(sext_i32_i64(virt_group_id_322566) *\n                                                 squot64(segred_group_sizze_308097,\n                                                         segment_sizze_nonzzero_322547) +\n                                                 sext_i32_i64(local_tid_322550) -\n                                                 squot64(sext_i32_i64(virt_group_id_322566) *\n                                                         squot64(segred_group_sizze_308097,\n                                                                 segment_sizze_nonzzero_322547) +\n                                                         sext_i32_i64(local_tid_322550),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_322599;\n                \n                double tmp_322600;\n                \n                tmp_322600 = ((__local\n                               double *) red_arr_mem_322560)[(sext_i32_i64(local_tid_322550) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322547 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319420)[squot64(sext_i32_i64(virt_group_id_322566) *\n                                                squot64(segred_group_sizze_308097,\n                                                        segment_sizze_nonzzero_322547) +\n                                                sext_i32_i64(local_tid_322550),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n         ",
            "                               squot64(sext_i32_i64(virt_group_id_322566) *\n                                                squot64(segred_group_sizze_308097,\n                                                        segment_sizze_nonzzero_322547) +\n                                                sext_i32_i64(local_tid_322550) -\n                                                squot64(sext_i32_i64(virt_group_id_322566) *\n                                                        squot64(segred_group_sizze_308097,\n                                                                segment_sizze_nonzzero_322547) +\n                                                        sext_i32_i64(local_tid_322550),\n                                                        n_p_292677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_322566) *\n                                         squot64(segred_group_sizze_308097,\n                                                 segment_sizze_nonzzero_322547) +\n                                         sext_i32_i64(local_tid_322550) -\n                                         squot64(sext_i32_i64(virt_group_id_322566) *\n                                                 squot64(segred_group_sizze_308097,\n                                                         segment_sizze_nonzzero_322547) +\n                                                 sext_i32_i64(local_tid_322550),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_group_id_322566) *\n                                                 squot64(segred_group_sizze_308097,\n                                   ",
            "                      segment_sizze_nonzzero_322547) +\n                                                 sext_i32_i64(local_tid_322550) -\n                                                 squot64(sext_i32_i64(virt_group_id_322566) *\n                                                         squot64(segred_group_sizze_308097,\n                                                                 segment_sizze_nonzzero_322547) +\n                                                         sext_i32_i64(local_tid_322550),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_322600;\n                \n                double tmp_322601;\n                \n                tmp_322601 = ((__local\n                               double *) red_arr_mem_322562)[(sext_i32_i64(local_tid_322550) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322547 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319425)[squot64(sext_i32_i64(virt_group_id_322566) *\n                                                squot64(segred_group_sizze_308097,\n                                                        segment_sizze_nonzzero_322547) +\n                                                sext_i32_i64(local_tid_322550),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_322566) *\n                                                squot64(segred_group_sizze_308097,\n       ",
            "                                                 segment_sizze_nonzzero_322547) +\n                                                sext_i32_i64(local_tid_322550) -\n                                                squot64(sext_i32_i64(virt_group_id_322566) *\n                                                        squot64(segred_group_sizze_308097,\n                                                                segment_sizze_nonzzero_322547) +\n                                                        sext_i32_i64(local_tid_322550),\n                                                        n_p_292677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_322566) *\n                                         squot64(segred_group_sizze_308097,\n                                                 segment_sizze_nonzzero_322547) +\n                                         sext_i32_i64(local_tid_322550) -\n                                         squot64(sext_i32_i64(virt_group_id_322566) *\n                                                 squot64(segred_group_sizze_308097,\n                                                         segment_sizze_nonzzero_322547) +\n                                                 sext_i32_i64(local_tid_322550),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_group_id_322566) *\n                                                 squot64(segred_group_sizze_308097,\n                                                         segment_sizze_nonzzero_322547) +\n                                                 sext_i32_i64(local_tid_322550) -\n                             ",
            "                    squot64(sext_i32_i64(virt_group_id_322566) *\n                                                         squot64(segred_group_sizze_308097,\n                                                                 segment_sizze_nonzzero_322547) +\n                                                         sext_i32_i64(local_tid_322550),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_322601;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_308097\n}\n__kernel void mainzisegred_small_308237(__global int *global_failure,\n                                        uint red_arr_mem_322700_backing_offset_0,\n                                        uint red_arr_mem_322698_backing_offset_1,\n                                        int64_t n_p_292677, int64_t q_s_292678,\n                                        int64_t partition_sizze_292766,\n                                        int64_t defunc_0_f_res_292820,\n                                        int64_t s_n_m_292825,\n                                        int64_t num_groups_308229,\n                                        int64_t segment_sizze_nonzzero_322691,\n                                        __global unsigned char *ext_mem_318609,\n                                        __global unsigned char *ext_mem_318610,\n                                        __global unsigned char *ext_mem_318707,\n                                        __global unsigned char *ext_mem_318708,\n                                        __global unsigned char *mem_318871,\n                                        __g",
            "lobal unsigned char *mem_318876,\n                                        __global unsigned char *mem_319431,\n                                        __global unsigned char *mem_319436,\n                                        __global unsigned char *mem_319441,\n                                        __global unsigned char *mem_319446,\n                                        __global unsigned char *mem_319451,\n                                        __global unsigned char *mem_319456,\n                                        __global unsigned char *mem_319462,\n                                        __global unsigned char *mem_319467)\n{\n    #define segred_group_sizze_308228 (mainzisegred_group_sizze_306945)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_322700_backing_1 =\n                           &shared_mem[red_arr_mem_322700_backing_offset_0];\n    volatile unsigned char *red_arr_mem_322698_backing_0 =\n                           &shared_mem[red_arr_mem_322698_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322693;\n    int32_t local_tid_322694;\n    int64_t group_sizze_322697;\n    int32_t wave_sizze_322696;\n    int32_t group_tid_322695;\n    \n    global_tid_322693 = get_global_id(0);\n    local_tid_322694 = get_local_id(0);\n    group_sizze_322697 = get_local_size(0);\n    wave_sizze_322696 = LOCKSTEP_WIDTH;\n    group_tid_322695 = get_group_id(0);\n    \n    int32_t phys_tid_308237 = global_tid_322693;\n    __local unsigned char *red_arr_mem_322698;\n    \n    red_arr_mem_322698 = (__local unsigned char *) red_arr_mem_322698_backing_0;\n    \n    __local unsigned char *red_arr_mem_322700;\n    \n    red_arr_mem_322700 = (__local unsigned char *) red_arr_mem_322700_backing_1;\n    \n    int32_t phys_group_id_322702;\n    \n    phys_group_id_322702 = get_group_id(0);\n    for (int32_t i_322703 = 0; i_322703 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(",
            "partition_sizze_292766 * n_p_292677 *\n                                          s_n_m_292825,\n                                          squot64(segred_group_sizze_308228,\n                                                  segment_sizze_nonzzero_322691))) -\n                   phys_group_id_322702, sext_i64_i32(num_groups_308229));\n         i_322703++) {\n        int32_t virt_group_id_322704 = phys_group_id_322702 + i_322703 *\n                sext_i64_i32(num_groups_308229);\n        int64_t slice_322705 = s_n_m_292825;\n        int64_t slice_322706 = n_p_292677 * slice_322705;\n        int64_t slice_322707 = partition_sizze_292766 * slice_322706;\n        int64_t gtid_308233 = squot64(squot64(sext_i32_i64(local_tid_322694),\n                                              segment_sizze_nonzzero_322691) +\n                                      sext_i32_i64(virt_group_id_322704) *\n                                      squot64(segred_group_sizze_308228,\n                                              segment_sizze_nonzzero_322691),\n                                      slice_322706);\n        int64_t remnant_322708 = squot64(sext_i32_i64(local_tid_322694),\n                                         segment_sizze_nonzzero_322691) +\n                sext_i32_i64(virt_group_id_322704) *\n                squot64(segred_group_sizze_308228,\n                        segment_sizze_nonzzero_322691) - gtid_308233 *\n                slice_322706;\n        int64_t gtid_308234 = squot64(remnant_322708, slice_322705);\n        int64_t remnant_322709 = remnant_322708 - gtid_308234 * slice_322705;\n        int64_t gtid_308235 = remnant_322709;\n        int64_t remnant_322710 = remnant_322709 - gtid_308235;\n        int64_t gtid_308236 = srem64(sext_i32_i64(local_tid_322694),\n                                     q_s_292678);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_s_292678) && (((slt64(gtid_308233,\n                                                      ",
            "     partition_sizze_292766) &&\n                                                     slt64(gtid_308234,\n                                                           n_p_292677)) &&\n                                                    slt64(gtid_308235,\n                                                          s_n_m_292825)) &&\n                                                   slt64(sext_i32_i64(local_tid_322694),\n                                                         q_s_292678 *\n                                                         squot64(segred_group_sizze_308228,\n                                                                 segment_sizze_nonzzero_322691)))) {\n                int64_t x_308259;\n                \n                x_308259 = ((__global int64_t *) ext_mem_318609)[gtid_308233 *\n                                                                 n_p_292677 +\n                                                                 gtid_308234];\n                \n                int64_t x_308268;\n                \n                x_308268 = ((__global int64_t *) ext_mem_318708)[gtid_308233 *\n                                                                 (s_n_m_292825 *\n                                                                  n_p_292677) +\n                                                                 gtid_308234 *\n                                                                 s_n_m_292825 +\n                                                                 gtid_308235];\n                \n                double x_308269;\n                \n                x_308269 = ((__global double *) ext_mem_318707)[gtid_308233 *\n                                                                (s_n_m_292825 *\n                                                                 n_p_292677) +\n                                                                gtid_308234 *\n                                                                s_n_m_292825 +\n                            ",
            "                                    gtid_308235];\n                \n                double a12_308270;\n                \n                a12_308270 = ((__global double *) mem_319431)[gtid_308233 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                                              gtid_308234 *\n                                                              s_n_m_292825 +\n                                                              gtid_308235];\n                \n                double b12_308271;\n                \n                b12_308271 = ((__global double *) mem_319436)[gtid_308233 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                                              gtid_308234 *\n                                                              s_n_m_292825 +\n                                                              gtid_308235];\n                \n                double c12_308272;\n                \n                c12_308272 = ((__global double *) mem_319441)[gtid_308233 *\n                                                              (s_n_m_292825 *\n                                                               n_p_292677) +\n                                                              gtid_308234 *\n                                                              s_n_m_292825 +\n                                                              gtid_308235];\n                \n                double b2_308273;\n                \n                b2_308273 = ((__global double *) mem_319446)[gtid_308233 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_3",
            "08234 *\n                                                             s_n_m_292825 +\n                                                             gtid_308235];\n                \n                double c2_308274;\n                \n                c2_308274 = ((__global double *) mem_319451)[gtid_308233 *\n                                                             (s_n_m_292825 *\n                                                              n_p_292677) +\n                                                             gtid_308234 *\n                                                             s_n_m_292825 +\n                                                             gtid_308235];\n                \n                int64_t defunc_0_m_fun_res_308275;\n                \n                defunc_0_m_fun_res_308275 = ((__global\n                                              int64_t *) mem_319456)[gtid_308233 *\n                                                                     (s_n_m_292825 *\n                                                                      n_p_292677) +\n                                                                     gtid_308234 *\n                                                                     s_n_m_292825 +\n                                                                     gtid_308235];\n                \n                bool cond_308277 = sle64(x_308259, gtid_308236);\n                int64_t defunc_0_f_res_308278;\n                \n                if (cond_308277) {\n                    defunc_0_f_res_308278 = (int64_t) 0;\n                } else {\n                    int64_t i_308279 = add64(gtid_308236, x_308268);\n                    int64_t defunc_0_add_arg_308280;\n                    \n                    defunc_0_add_arg_308280 = ((__global\n                                                int64_t *) ext_mem_318610)[gtid_308233 *\n                                                                           (defunc_0_f_res_292820 *\n                         ",
            "                                                   n_p_292677) +\n                                                                           gtid_308234 *\n                                                                           defunc_0_f_res_292820 +\n                                                                           i_308279];\n                    \n                    int64_t defunc_1_add_res_308281 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_308280);\n                    \n                    defunc_0_f_res_308278 = defunc_1_add_res_308281;\n                }\n                \n                double defunc_0_f_res_308282;\n                \n                if (cond_308277) {\n                    defunc_0_f_res_308282 = 0.0;\n                } else {\n                    int64_t i_308283 = add64(gtid_308236, x_308268);\n                    double defunc_0_add_arg_308284;\n                    \n                    defunc_0_add_arg_308284 = ((__global\n                                                double *) mem_318876)[gtid_308233 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_308234 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_308283];\n                    defunc_0_f_res_308282 = defunc_0_add_arg_308284;\n                }\n                \n                int64_t binop_p_308285 = sub64(defunc_0_f_res_308278,\n                                               defunc_0_m_fun_res_308275);\n                double defunc_0_f_res_308286 = sitofp_i64_f64(binop_p_308285);\n                double abs_res_308287 = fabs(defunc_0_f_res_308286);\n                double tmp1_308288 = abs_res_308287 / x_308269;\n ",
            "               double x_308289 = tmp1_308288 * tmp1_308288;\n                double y_308290 = tmp1_308288 * x_308289;\n                double tmp2_308291 = 1.0 - y_308290;\n                double x_308292 = tmp2_308291 * tmp2_308291;\n                double tmp3_308293 = tmp2_308291 * x_308292;\n                double tmp4_308294 = defunc_0_f_res_308282 * tmp3_308293;\n                double defunc_1_f_res_308295 = defunc_0_f_res_308286 *\n                       tmp4_308294;\n                double defunc_1_f_res_308296 = defunc_0_f_res_308286 *\n                       defunc_1_f_res_308295;\n                double defunc_0_f_res_308297;\n                \n                if (cond_308277) {\n                    defunc_0_f_res_308297 = 0.0;\n                } else {\n                    int64_t i_308298 = add64(gtid_308236, x_308268);\n                    double defunc_0_add_arg_308299;\n                    \n                    defunc_0_add_arg_308299 = ((__global\n                                                double *) mem_318871)[gtid_308233 *\n                                                                      (defunc_0_f_res_292820 *\n                                                                       n_p_292677) +\n                                                                      gtid_308234 *\n                                                                      defunc_0_f_res_292820 +\n                                                                      i_308298];\n                    defunc_0_f_res_308297 = defunc_0_add_arg_308299;\n                }\n                \n                double x_308300 = a12_308270 * tmp4_308294;\n                double y_308301 = b12_308271 * defunc_1_f_res_308295;\n                double x_308302 = x_308300 + y_308301;\n                double y_308303 = c12_308272 * defunc_1_f_res_308296;\n                double x_308304 = x_308302 + y_308303;\n                double defunc_9_fit_fun_res_308305 = defunc_0_f_res_308297 *\n                       x",
            "_308304;\n                double x_308306 = b12_308271 * tmp4_308294;\n                double y_308307 = b2_308273 * defunc_1_f_res_308295;\n                double x_308308 = x_308306 + y_308307;\n                double y_308309 = c2_308274 * defunc_1_f_res_308296;\n                double x_308310 = x_308308 + y_308309;\n                double defunc_9_slope_fun_res_308311 = defunc_0_f_res_308297 *\n                       x_308310;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_322698)[sext_i32_i64(local_tid_322694)] =\n                        defunc_9_fit_fun_res_308305;\n                    ((__local\n                      double *) red_arr_mem_322700)[sext_i32_i64(local_tid_322694)] =\n                        defunc_9_slope_fun_res_308311;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_322698)[sext_i32_i64(local_tid_322694)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_322700)[sext_i32_i64(local_tid_322694)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_s_292678)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_308238;\n                double x_308239;\n                double x_308240;\n                double x_308241;\n                double x_322711;\n                double x_322712;\n                double x_322713;\n                double x_322714;\n                bool ltid_in_bounds_322717 =\n                     slt64(sext_i32_i64(local_tid_322694), q_s_292678 *\n                           squot64(segred_group_sizze_308228,\n                                   segment_sizze_nonzzero_322691));\n                int32_t skip_threads_322718;\n                \n                // read input f",
            "or in-block scan\n                {\n                    if (ltid_in_bounds_322717) {\n                        x_308240 = ((volatile __local\n                                     double *) red_arr_mem_322698)[sext_i32_i64(local_tid_322694)];\n                        x_308241 = ((volatile __local\n                                     double *) red_arr_mem_322700)[sext_i32_i64(local_tid_322694)];\n                        if ((local_tid_322694 - squot32(local_tid_322694, 32) *\n                             32) == 0) {\n                            x_308238 = x_308240;\n                            x_308239 = x_308241;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_322718 = 1;\n                    while (slt32(skip_threads_322718, 32)) {\n                        bool thread_active_322719 = sle32(skip_threads_322718,\n                                                          local_tid_322694 -\n                                                          squot32(local_tid_322694,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_322717;\n                        \n                        if (thread_active_322719) {\n                            // read operands\n                            {\n                                x_308238 = ((volatile __local\n                                             double *) red_arr_mem_322698)[sext_i32_i64(local_tid_322694) -\n                                                                           sext_i32_i64(skip_threads_322718)];\n                                x_308239 = ((volatile __local\n                                             double *) red_arr_mem_322700)[sext_i32_i64(local_tid_322694) -\n                                                                           sext_i32_i64(skip_threads_322718)];\n                            }\n                    ",
            "    }\n                        // perform operation\n                        {\n                            bool inactive_322720 =\n                                 slt64(srem64(sext_i32_i64(local_tid_322694),\n                                              q_s_292678),\n                                       sext_i32_i64(local_tid_322694) -\n                                       sext_i32_i64(local_tid_322694 -\n                                       skip_threads_322718));\n                            \n                            if (thread_active_322719 && inactive_322720) {\n                                x_308238 = x_308240;\n                                x_308239 = x_308241;\n                            }\n                            if (thread_active_322719) {\n                                if (!inactive_322720) {\n                                    double defunc_1_op_res_308242 = x_308238 +\n                                           x_308240;\n                                    double defunc_1_op_res_308243 = x_308239 +\n                                           x_308241;\n                                    \n                                    x_308238 = defunc_1_op_res_308242;\n                                    x_308239 = defunc_1_op_res_308243;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_322696, skip_threads_322718)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_322719) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_322698)[sext_i32_i64(local_tid_322694)] =\n                                    x_308238;\n                                x_308240 = x_308238;\n                                ((volatile __local\n                                  double *) red_arr_mem_322",
            "700)[sext_i32_i64(local_tid_322694)] =\n                                    x_308239;\n                                x_308241 = x_308239;\n                            }\n                        }\n                        if (sle32(wave_sizze_322696, skip_threads_322718)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_322718 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_322694 - squot32(local_tid_322694, 32) *\n                         32) == 31 && ltid_in_bounds_322717) {\n                        ((volatile __local\n                          double *) red_arr_mem_322698)[sext_i32_i64(squot32(local_tid_322694,\n                                                                             32))] =\n                            x_308238;\n                        ((volatile __local\n                          double *) red_arr_mem_322700)[sext_i32_i64(squot32(local_tid_322694,\n                                                                             32))] =\n                            x_308239;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_322721;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_322694, 32) == 0 &&\n                            ltid_in_bounds_322717) {\n                            x_322713 = ((volatile __local\n                                         double *) red_arr_mem_322698)[sext_i32_i64(local_tid_322694)];\n                            x_322714 = ((volatile __local\n                                         double *) red_arr_mem_322700",
            ")[sext_i32_i64(local_tid_322694)];\n                            if ((local_tid_322694 - squot32(local_tid_322694,\n                                                            32) * 32) == 0) {\n                                x_322711 = x_322713;\n                                x_322712 = x_322714;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_322721 = 1;\n                        while (slt32(skip_threads_322721, 32)) {\n                            bool thread_active_322722 =\n                                 sle32(skip_threads_322721, local_tid_322694 -\n                                       squot32(local_tid_322694, 32) * 32) &&\n                                 (squot32(local_tid_322694, 32) == 0 &&\n                                  ltid_in_bounds_322717);\n                            \n                            if (thread_active_322722) {\n                                // read operands\n                                {\n                                    x_322711 = ((volatile __local\n                                                 double *) red_arr_mem_322698)[sext_i32_i64(local_tid_322694) -\n                                                                               sext_i32_i64(skip_threads_322721)];\n                                    x_322712 = ((volatile __local\n                                                 double *) red_arr_mem_322700)[sext_i32_i64(local_tid_322694) -\n                                                                               sext_i32_i64(skip_threads_322721)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_322723 =\n                                     slt64(srem64(sext_i32_i64(local_tid_322694 *\n                                            ",
            "      32 + 32 - 1), q_s_292678),\n                                           sext_i32_i64(local_tid_322694 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_322694 -\n                                                         skip_threads_322721) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_322722 && inactive_322723) {\n                                    x_322711 = x_322713;\n                                    x_322712 = x_322714;\n                                }\n                                if (thread_active_322722) {\n                                    if (!inactive_322723) {\n                                        double defunc_1_op_res_322715 =\n                                               x_322711 + x_322713;\n                                        double defunc_1_op_res_322716 =\n                                               x_322712 + x_322714;\n                                        \n                                        x_322711 = defunc_1_op_res_322715;\n                                        x_322712 = defunc_1_op_res_322716;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_322696, skip_threads_322721)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_322722) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_322698)[sext_i32_i64(local_tid_322694)] =\n                                        x_322711;\n                                    x_322713 = x_322711;\n                                    ((volatile __local\n                                     ",
            " double *) red_arr_mem_322700)[sext_i32_i64(local_tid_322694)] =\n                                        x_322712;\n                                    x_322714 = x_322712;\n                                }\n                            }\n                            if (sle32(wave_sizze_322696, skip_threads_322721)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_322721 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_322724 = squot32(local_tid_322694, 32) == 0 ||\n                     !ltid_in_bounds_322717;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_322724) {\n                            x_308240 = x_308238;\n                            x_308241 = x_308239;\n                            x_308238 = ((__local\n                                         double *) red_arr_mem_322698)[sext_i32_i64(squot32(local_tid_322694,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_308239 = ((__local\n                                         double *) red_arr_mem_322700)[sext_i32_i64(squot32(local_tid_322694,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_322725 =\n                             slt64(srem64(sext_i32_i64(local_tid_322694),\n                                          q_s_292678),\n      ",
            "                             sext_i32_i64(local_tid_322694) -\n                                   sext_i32_i64(squot32(local_tid_322694, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_322724) {\n                            if (inactive_322725) {\n                                x_308238 = x_308240;\n                                x_308239 = x_308241;\n                            }\n                        }\n                        if (!no_carry_in_322724) {\n                            if (!inactive_322725) {\n                                double defunc_1_op_res_308242 = x_308238 +\n                                       x_308240;\n                                double defunc_1_op_res_308243 = x_308239 +\n                                       x_308241;\n                                \n                                x_308238 = defunc_1_op_res_308242;\n                                x_308239 = defunc_1_op_res_308243;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_322724) {\n                            ((__local\n                              double *) red_arr_mem_322698)[sext_i32_i64(local_tid_322694)] =\n                                x_308238;\n                            ((__local\n                              double *) red_arr_mem_322700)[sext_i32_i64(local_tid_322694)] =\n                                x_308239;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_322694, 32) == 0 &&\n                        ltid_in_bounds_322717) {\n                        ((__local\n                          double *) red_arr_mem_322698)[sext_i32_i64(local_tid_322694)] =\n                            x_308240;\n    ",
            "                    ((__local\n                          double *) red_arr_mem_322700)[sext_i32_i64(local_tid_322694)] =\n                            x_308241;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_322704) *\n                      squot64(segred_group_sizze_308228,\n                              segment_sizze_nonzzero_322691) +\n                      sext_i32_i64(local_tid_322694), partition_sizze_292766 *\n                      n_p_292677 * s_n_m_292825) &&\n                slt64(sext_i32_i64(local_tid_322694),\n                      squot64(segred_group_sizze_308228,\n                              segment_sizze_nonzzero_322691))) {\n                double tmp_322726;\n                \n                tmp_322726 = ((__local\n                               double *) red_arr_mem_322698)[(sext_i32_i64(local_tid_322694) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322691 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319462)[squot64(sext_i32_i64(virt_group_id_322704) *\n                                                squot64(segred_group_sizze_308228,\n                                                        segment_sizze_nonzzero_322691) +\n                                                sext_i32_i64(local_tid_322694),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_322704) *\n                                                squot64(segred_group_sizze_308228,\n                                               ",
            "         segment_sizze_nonzzero_322691) +\n                                                sext_i32_i64(local_tid_322694) -\n                                                squot64(sext_i32_i64(virt_group_id_322704) *\n                                                        squot64(segred_group_sizze_308228,\n                                                                segment_sizze_nonzzero_322691) +\n                                                        sext_i32_i64(local_tid_322694),\n                                                        n_p_292677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_322704) *\n                                         squot64(segred_group_sizze_308228,\n                                                 segment_sizze_nonzzero_322691) +\n                                         sext_i32_i64(local_tid_322694) -\n                                         squot64(sext_i32_i64(virt_group_id_322704) *\n                                                 squot64(segred_group_sizze_308228,\n                                                         segment_sizze_nonzzero_322691) +\n                                                 sext_i32_i64(local_tid_322694),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_group_id_322704) *\n                                                 squot64(segred_group_sizze_308228,\n                                                         segment_sizze_nonzzero_322691) +\n                                                 sext_i32_i64(local_tid_322694) -\n                                                 squot64(sext_i32_i64",
            "(virt_group_id_322704) *\n                                                         squot64(segred_group_sizze_308228,\n                                                                 segment_sizze_nonzzero_322691) +\n                                                         sext_i32_i64(local_tid_322694),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_322726;\n                \n                double tmp_322727;\n                \n                tmp_322727 = ((__local\n                               double *) red_arr_mem_322700)[(sext_i32_i64(local_tid_322694) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322691 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319467)[squot64(sext_i32_i64(virt_group_id_322704) *\n                                                squot64(segred_group_sizze_308228,\n                                                        segment_sizze_nonzzero_322691) +\n                                                sext_i32_i64(local_tid_322694),\n                                                n_p_292677 * s_n_m_292825) *\n                                        (s_n_m_292825 * n_p_292677) +\n                                        squot64(sext_i32_i64(virt_group_id_322704) *\n                                                squot64(segred_group_sizze_308228,\n                                                        segment_sizze_nonzzero_322691) +\n                                                sext_i32_i64(local_tid_322694) -\n                                           ",
            "     squot64(sext_i32_i64(virt_group_id_322704) *\n                                                        squot64(segred_group_sizze_308228,\n                                                                segment_sizze_nonzzero_322691) +\n                                                        sext_i32_i64(local_tid_322694),\n                                                        n_p_292677 *\n                                                        s_n_m_292825) *\n                                                (n_p_292677 * s_n_m_292825),\n                                                s_n_m_292825) * s_n_m_292825 +\n                                        (sext_i32_i64(virt_group_id_322704) *\n                                         squot64(segred_group_sizze_308228,\n                                                 segment_sizze_nonzzero_322691) +\n                                         sext_i32_i64(local_tid_322694) -\n                                         squot64(sext_i32_i64(virt_group_id_322704) *\n                                                 squot64(segred_group_sizze_308228,\n                                                         segment_sizze_nonzzero_322691) +\n                                                 sext_i32_i64(local_tid_322694),\n                                                 n_p_292677 * s_n_m_292825) *\n                                         (n_p_292677 * s_n_m_292825) -\n                                         squot64(sext_i32_i64(virt_group_id_322704) *\n                                                 squot64(segred_group_sizze_308228,\n                                                         segment_sizze_nonzzero_322691) +\n                                                 sext_i32_i64(local_tid_322694) -\n                                                 squot64(sext_i32_i64(virt_group_id_322704) *\n                                                         squot64(segred_group_sizze_308228,\n                                                 ",
            "                segment_sizze_nonzzero_322691) +\n                                                         sext_i32_i64(local_tid_322694),\n                                                         n_p_292677 *\n                                                         s_n_m_292825) *\n                                                 (n_p_292677 * s_n_m_292825),\n                                                 s_n_m_292825) *\n                                         s_n_m_292825)] = tmp_322727;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_308228\n}\n__kernel void mainzisegred_small_308859(__global int *global_failure,\n                                        uint red_arr_mem_322821_backing_offset_0,\n                                        int64_t n_p_292677,\n                                        int64_t partition_sizze_292766,\n                                        int64_t C_len_292823,\n                                        int64_t num_groups_308854,\n                                        int64_t segment_sizze_nonzzero_322814,\n                                        __global unsigned char *mem_319504,\n                                        __global unsigned char *mem_319515)\n{\n    #define segred_group_sizze_308853 (mainzisegred_group_sizze_308836)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_322821_backing_0 =\n                           &shared_mem[red_arr_mem_322821_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322816;\n    int32_t local_tid_322817;\n    int64_t group_sizze_322820;\n    int32_t wave_sizze_322819;\n    int32_t group_tid_322818;\n    \n    global_tid_322816 = get_global_id(0);\n    local_tid_322817 = get_local_id(0);\n    group_sizze_322820 = get_local_size(0);\n    wave_sizze_32281",
            "9 = LOCKSTEP_WIDTH;\n    group_tid_322818 = get_group_id(0);\n    \n    int32_t phys_tid_308859 = global_tid_322816;\n    __local unsigned char *red_arr_mem_322821;\n    \n    red_arr_mem_322821 = (__local unsigned char *) red_arr_mem_322821_backing_0;\n    \n    int32_t phys_group_id_322823;\n    \n    phys_group_id_322823 = get_group_id(0);\n    for (int32_t i_322824 = 0; i_322824 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766,\n                                          squot64(segred_group_sizze_308853,\n                                                  segment_sizze_nonzzero_322814))) -\n                   phys_group_id_322823, sext_i64_i32(num_groups_308854));\n         i_322824++) {\n        int32_t virt_group_id_322825 = phys_group_id_322823 + i_322824 *\n                sext_i64_i32(num_groups_308854);\n        int64_t slice_322826 = partition_sizze_292766;\n        int64_t gtid_308857 = squot64(sext_i32_i64(local_tid_322817),\n                                      segment_sizze_nonzzero_322814) +\n                sext_i32_i64(virt_group_id_322825) *\n                squot64(segred_group_sizze_308853,\n                        segment_sizze_nonzzero_322814);\n        int64_t remnant_322827 = squot64(sext_i32_i64(local_tid_322817),\n                                         segment_sizze_nonzzero_322814) +\n                sext_i32_i64(virt_group_id_322825) *\n                squot64(segred_group_sizze_308853,\n                        segment_sizze_nonzzero_322814) - gtid_308857;\n        int64_t gtid_308858 = srem64(sext_i32_i64(local_tid_322817),\n                                     n_p_292677);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, n_p_292677) && (slt64(gtid_308857,\n                                                         partition_sizze_292766) &&\n                                                   slt64(sext_i32_i64(local_tid_322817),\n                                                         n_p_292677 *\n    ",
            "                                                     squot64(segred_group_sizze_308853,\n                                                                 segment_sizze_nonzzero_322814)))) {\n                double x_308864;\n                \n                x_308864 = ((__global double *) mem_319504)[gtid_308857 *\n                                                            C_len_292823 +\n                                                            gtid_308858];\n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_322821)[sext_i32_i64(local_tid_322817)] =\n                        x_308864;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_322821)[sext_i32_i64(local_tid_322817)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, n_p_292677)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_308860;\n                double x_308861;\n                double x_322828;\n                double x_322829;\n                bool ltid_in_bounds_322831 =\n                     slt64(sext_i32_i64(local_tid_322817), n_p_292677 *\n                           squot64(segred_group_sizze_308853,\n                                   segment_sizze_nonzzero_322814));\n                int32_t skip_threads_322832;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_322831) {\n                        x_308861 = ((volatile __local\n                                     double *) red_arr_mem_322821)[sext_i32_i64(local_tid_322817)];\n                        if ((local_tid_322817 - squot32(local_tid_322817, 32) *\n                             32) == 0) {\n                            x_308860 = x_308861;\n                        }\n     ",
            "               }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_322832 = 1;\n                    while (slt32(skip_threads_322832, 32)) {\n                        bool thread_active_322833 = sle32(skip_threads_322832,\n                                                          local_tid_322817 -\n                                                          squot32(local_tid_322817,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_322831;\n                        \n                        if (thread_active_322833) {\n                            // read operands\n                            {\n                                x_308860 = ((volatile __local\n                                             double *) red_arr_mem_322821)[sext_i32_i64(local_tid_322817) -\n                                                                           sext_i32_i64(skip_threads_322832)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_322834 =\n                                 slt64(srem64(sext_i32_i64(local_tid_322817),\n                                              n_p_292677),\n                                       sext_i32_i64(local_tid_322817) -\n                                       sext_i32_i64(local_tid_322817 -\n                                       skip_threads_322832));\n                            \n                            if (thread_active_322833 && inactive_322834) {\n                                x_308860 = x_308861;\n                            }\n                            if (thread_active_322833) {\n                                if (!inactive_322834) {\n                                    double defunc_1_op_res_308862 = x_308860 +\n                                           x_308861;\n                      ",
            "              \n                                    x_308860 = defunc_1_op_res_308862;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_322819, skip_threads_322832)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_322833) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_322821)[sext_i32_i64(local_tid_322817)] =\n                                    x_308860;\n                                x_308861 = x_308860;\n                            }\n                        }\n                        if (sle32(wave_sizze_322819, skip_threads_322832)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_322832 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_322817 - squot32(local_tid_322817, 32) *\n                         32) == 31 && ltid_in_bounds_322831) {\n                        ((volatile __local\n                          double *) red_arr_mem_322821)[sext_i32_i64(squot32(local_tid_322817,\n                                                                             32))] =\n                            x_308860;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_322835;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_322817, 32) == 0 &&\n                            lt",
            "id_in_bounds_322831) {\n                            x_322829 = ((volatile __local\n                                         double *) red_arr_mem_322821)[sext_i32_i64(local_tid_322817)];\n                            if ((local_tid_322817 - squot32(local_tid_322817,\n                                                            32) * 32) == 0) {\n                                x_322828 = x_322829;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_322835 = 1;\n                        while (slt32(skip_threads_322835, 32)) {\n                            bool thread_active_322836 =\n                                 sle32(skip_threads_322835, local_tid_322817 -\n                                       squot32(local_tid_322817, 32) * 32) &&\n                                 (squot32(local_tid_322817, 32) == 0 &&\n                                  ltid_in_bounds_322831);\n                            \n                            if (thread_active_322836) {\n                                // read operands\n                                {\n                                    x_322828 = ((volatile __local\n                                                 double *) red_arr_mem_322821)[sext_i32_i64(local_tid_322817) -\n                                                                               sext_i32_i64(skip_threads_322835)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_322837 =\n                                     slt64(srem64(sext_i32_i64(local_tid_322817 *\n                                                  32 + 32 - 1), n_p_292677),\n                                           sext_i32_i64(local_tid_322817 * 32 +\n                                           32 - 1) -\n                              ",
            "             sext_i32_i64((local_tid_322817 -\n                                                         skip_threads_322835) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_322836 && inactive_322837) {\n                                    x_322828 = x_322829;\n                                }\n                                if (thread_active_322836) {\n                                    if (!inactive_322837) {\n                                        double defunc_1_op_res_322830 =\n                                               x_322828 + x_322829;\n                                        \n                                        x_322828 = defunc_1_op_res_322830;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_322819, skip_threads_322835)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_322836) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_322821)[sext_i32_i64(local_tid_322817)] =\n                                        x_322828;\n                                    x_322829 = x_322828;\n                                }\n                            }\n                            if (sle32(wave_sizze_322819, skip_threads_322835)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_322835 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_322838 = squot32(local_tid_322817, 32) == 0 ||\n                     !ltid_in_bounds_322831;\n               ",
            " \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_322838) {\n                            x_308861 = x_308860;\n                            x_308860 = ((__local\n                                         double *) red_arr_mem_322821)[sext_i32_i64(squot32(local_tid_322817,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_322839 =\n                             slt64(srem64(sext_i32_i64(local_tid_322817),\n                                          n_p_292677),\n                                   sext_i32_i64(local_tid_322817) -\n                                   sext_i32_i64(squot32(local_tid_322817, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_322838) {\n                            if (inactive_322839) {\n                                x_308860 = x_308861;\n                            }\n                        }\n                        if (!no_carry_in_322838) {\n                            if (!inactive_322839) {\n                                double defunc_1_op_res_308862 = x_308860 +\n                                       x_308861;\n                                \n                                x_308860 = defunc_1_op_res_308862;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_322838) {\n                            ((__local\n                              double *) red_arr_mem_322821)[sext_i32_i64(local_tid_322817)] =\n                                x_308860;\n       ",
            "                 }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_322817, 32) == 0 &&\n                        ltid_in_bounds_322831) {\n                        ((__local\n                          double *) red_arr_mem_322821)[sext_i32_i64(local_tid_322817)] =\n                            x_308861;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_322825) *\n                      squot64(segred_group_sizze_308853,\n                              segment_sizze_nonzzero_322814) +\n                      sext_i32_i64(local_tid_322817), partition_sizze_292766) &&\n                slt64(sext_i32_i64(local_tid_322817),\n                      squot64(segred_group_sizze_308853,\n                              segment_sizze_nonzzero_322814))) {\n                double tmp_322840;\n                \n                tmp_322840 = ((__local\n                               double *) red_arr_mem_322821)[(sext_i32_i64(local_tid_322817) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322814 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319515)[sext_i32_i64(virt_group_id_322825) *\n                                        squot64(segred_group_sizze_308853,\n                                                segment_sizze_nonzzero_322814) +\n                                        sext_i32_i64(local_tid_322817)] =\n                    tmp_322840;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM",
            "_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_308853\n}\n__kernel void mainzisegred_small_308990(__global int *global_failure,\n                                        uint red_arr_mem_323002_backing_offset_0,\n                                        int64_t n_p_292677,\n                                        int64_t partition_sizze_292766,\n                                        int64_t lifted_single_ma_l_arg_293311,\n                                        int64_t num_groups_308985,\n                                        int64_t segment_sizze_nonzzero_322995,\n                                        __global unsigned char *mem_319521,\n                                        __global unsigned char *mem_319532)\n{\n    #define segred_group_sizze_308984 (mainzisegred_group_sizze_308967)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_323002_backing_0 =\n                           &shared_mem[red_arr_mem_323002_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_322997;\n    int32_t local_tid_322998;\n    int64_t group_sizze_323001;\n    int32_t wave_sizze_323000;\n    int32_t group_tid_322999;\n    \n    global_tid_322997 = get_global_id(0);\n    local_tid_322998 = get_local_id(0);\n    group_sizze_323001 = get_local_size(0);\n    wave_sizze_323000 = LOCKSTEP_WIDTH;\n    group_tid_322999 = get_group_id(0);\n    \n    int32_t phys_tid_308990 = global_tid_322997;\n    __local unsigned char *red_arr_mem_323002;\n    \n    red_arr_mem_323002 = (__local unsigned char *) red_arr_mem_323002_backing_0;\n    \n    int32_t phys_group_id_323004;\n    \n    phys_group_id_323004 = get_group_id(0);\n    for (int32_t i_323005 = 0; i_323005 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766,\n                                          squot64(segred_group_sizze_308984,\n                                                  segment_sizze_nonzzer",
            "o_322995))) -\n                   phys_group_id_323004, sext_i64_i32(num_groups_308985));\n         i_323005++) {\n        int32_t virt_group_id_323006 = phys_group_id_323004 + i_323005 *\n                sext_i64_i32(num_groups_308985);\n        int64_t slice_323007 = partition_sizze_292766;\n        int64_t gtid_308988 = squot64(sext_i32_i64(local_tid_322998),\n                                      segment_sizze_nonzzero_322995) +\n                sext_i32_i64(virt_group_id_323006) *\n                squot64(segred_group_sizze_308984,\n                        segment_sizze_nonzzero_322995);\n        int64_t remnant_323008 = squot64(sext_i32_i64(local_tid_322998),\n                                         segment_sizze_nonzzero_322995) +\n                sext_i32_i64(virt_group_id_323006) *\n                squot64(segred_group_sizze_308984,\n                        segment_sizze_nonzzero_322995) - gtid_308988;\n        int64_t gtid_308989 = srem64(sext_i32_i64(local_tid_322998),\n                                     n_p_292677);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, n_p_292677) && (slt64(gtid_308988,\n                                                         partition_sizze_292766) &&\n                                                   slt64(sext_i32_i64(local_tid_322998),\n                                                         n_p_292677 *\n                                                         squot64(segred_group_sizze_308984,\n                                                                 segment_sizze_nonzzero_322995)))) {\n                double x_308995;\n                \n                x_308995 = ((__global double *) mem_319521)[gtid_308988 *\n                                                            lifted_single_ma_l_arg_293311 +\n                                                            gtid_308989];\n                // save map-out results\n                { }\n                // save results to be reduced\n      ",
            "          {\n                    ((__local\n                      double *) red_arr_mem_323002)[sext_i32_i64(local_tid_322998)] =\n                        x_308995;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_323002)[sext_i32_i64(local_tid_322998)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, n_p_292677)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_308991;\n                double x_308992;\n                double x_323009;\n                double x_323010;\n                bool ltid_in_bounds_323012 =\n                     slt64(sext_i32_i64(local_tid_322998), n_p_292677 *\n                           squot64(segred_group_sizze_308984,\n                                   segment_sizze_nonzzero_322995));\n                int32_t skip_threads_323013;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_323012) {\n                        x_308992 = ((volatile __local\n                                     double *) red_arr_mem_323002)[sext_i32_i64(local_tid_322998)];\n                        if ((local_tid_322998 - squot32(local_tid_322998, 32) *\n                             32) == 0) {\n                            x_308991 = x_308992;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_323013 = 1;\n                    while (slt32(skip_threads_323013, 32)) {\n                        bool thread_active_323014 = sle32(skip_threads_323013,\n                                                          local_tid_322998 -\n                                                          squot32(local_tid_322998,\n                                                                  32) * 32) &&\n                             lti",
            "d_in_bounds_323012;\n                        \n                        if (thread_active_323014) {\n                            // read operands\n                            {\n                                x_308991 = ((volatile __local\n                                             double *) red_arr_mem_323002)[sext_i32_i64(local_tid_322998) -\n                                                                           sext_i32_i64(skip_threads_323013)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_323015 =\n                                 slt64(srem64(sext_i32_i64(local_tid_322998),\n                                              n_p_292677),\n                                       sext_i32_i64(local_tid_322998) -\n                                       sext_i32_i64(local_tid_322998 -\n                                       skip_threads_323013));\n                            \n                            if (thread_active_323014 && inactive_323015) {\n                                x_308991 = x_308992;\n                            }\n                            if (thread_active_323014) {\n                                if (!inactive_323015) {\n                                    double defunc_1_op_res_308993 = x_308991 +\n                                           x_308992;\n                                    \n                                    x_308991 = defunc_1_op_res_308993;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_323000, skip_threads_323013)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_323014) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_3230",
            "02)[sext_i32_i64(local_tid_322998)] =\n                                    x_308991;\n                                x_308992 = x_308991;\n                            }\n                        }\n                        if (sle32(wave_sizze_323000, skip_threads_323013)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_323013 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_322998 - squot32(local_tid_322998, 32) *\n                         32) == 31 && ltid_in_bounds_323012) {\n                        ((volatile __local\n                          double *) red_arr_mem_323002)[sext_i32_i64(squot32(local_tid_322998,\n                                                                             32))] =\n                            x_308991;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_323016;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_322998, 32) == 0 &&\n                            ltid_in_bounds_323012) {\n                            x_323010 = ((volatile __local\n                                         double *) red_arr_mem_323002)[sext_i32_i64(local_tid_322998)];\n                            if ((local_tid_322998 - squot32(local_tid_322998,\n                                                            32) * 32) == 0) {\n                                x_323009 = x_323010;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n            ",
            "            skip_threads_323016 = 1;\n                        while (slt32(skip_threads_323016, 32)) {\n                            bool thread_active_323017 =\n                                 sle32(skip_threads_323016, local_tid_322998 -\n                                       squot32(local_tid_322998, 32) * 32) &&\n                                 (squot32(local_tid_322998, 32) == 0 &&\n                                  ltid_in_bounds_323012);\n                            \n                            if (thread_active_323017) {\n                                // read operands\n                                {\n                                    x_323009 = ((volatile __local\n                                                 double *) red_arr_mem_323002)[sext_i32_i64(local_tid_322998) -\n                                                                               sext_i32_i64(skip_threads_323016)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_323018 =\n                                     slt64(srem64(sext_i32_i64(local_tid_322998 *\n                                                  32 + 32 - 1), n_p_292677),\n                                           sext_i32_i64(local_tid_322998 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_322998 -\n                                                         skip_threads_323016) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_323017 && inactive_323018) {\n                                    x_323009 = x_323010;\n                                }\n                                if (thread_active_323017) {\n                                    if (!inactive_323018) {\n                                        double defunc_1_op_res_3230",
            "11 =\n                                               x_323009 + x_323010;\n                                        \n                                        x_323009 = defunc_1_op_res_323011;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_323000, skip_threads_323016)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_323017) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_323002)[sext_i32_i64(local_tid_322998)] =\n                                        x_323009;\n                                    x_323010 = x_323009;\n                                }\n                            }\n                            if (sle32(wave_sizze_323000, skip_threads_323016)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_323016 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_323019 = squot32(local_tid_322998, 32) == 0 ||\n                     !ltid_in_bounds_323012;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_323019) {\n                            x_308992 = x_308991;\n                            x_308991 = ((__local\n                                         double *) red_arr_mem_323002)[sext_i32_i64(squot32(local_tid_322998,\n                                                                                            32)) -\n                                                                       (int6",
            "4_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_323020 =\n                             slt64(srem64(sext_i32_i64(local_tid_322998),\n                                          n_p_292677),\n                                   sext_i32_i64(local_tid_322998) -\n                                   sext_i32_i64(squot32(local_tid_322998, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_323019) {\n                            if (inactive_323020) {\n                                x_308991 = x_308992;\n                            }\n                        }\n                        if (!no_carry_in_323019) {\n                            if (!inactive_323020) {\n                                double defunc_1_op_res_308993 = x_308991 +\n                                       x_308992;\n                                \n                                x_308991 = defunc_1_op_res_308993;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_323019) {\n                            ((__local\n                              double *) red_arr_mem_323002)[sext_i32_i64(local_tid_322998)] =\n                                x_308991;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_322998, 32) == 0 &&\n                        ltid_in_bounds_323012) {\n                        ((__local\n                          double *) red_arr_mem_323002)[sext_i32_i64(local_tid_322998)] =\n                            x_308992;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        ba",
            "rrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_323006) *\n                      squot64(segred_group_sizze_308984,\n                              segment_sizze_nonzzero_322995) +\n                      sext_i32_i64(local_tid_322998), partition_sizze_292766) &&\n                slt64(sext_i32_i64(local_tid_322998),\n                      squot64(segred_group_sizze_308984,\n                              segment_sizze_nonzzero_322995))) {\n                double tmp_323021;\n                \n                tmp_323021 = ((__local\n                               double *) red_arr_mem_323002)[(sext_i32_i64(local_tid_322998) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_322995 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319532)[sext_i32_i64(virt_group_id_323006) *\n                                        squot64(segred_group_sizze_308984,\n                                                segment_sizze_nonzzero_322995) +\n                                        sext_i32_i64(local_tid_322998)] =\n                    tmp_323021;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_308984\n}\n__kernel void mainzisegred_small_309121(__global int *global_failure,\n                                        uint red_arr_mem_323183_backing_offset_0,\n                                        int64_t partition_sizze_292766,\n                                        int64_t dyn_lifted_single_ma_l_arg_293321,\n                                        int64_t num_groups_309116,\n                                        int64_t segment_sizze_nonzzero_323176,\n                                       ",
            " __global unsigned char *mem_319538,\n                                        __global unsigned char *mem_319549)\n{\n    #define segred_group_sizze_309115 (mainzisegred_group_sizze_309098)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_323183_backing_0 =\n                           &shared_mem[red_arr_mem_323183_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323178;\n    int32_t local_tid_323179;\n    int64_t group_sizze_323182;\n    int32_t wave_sizze_323181;\n    int32_t group_tid_323180;\n    \n    global_tid_323178 = get_global_id(0);\n    local_tid_323179 = get_local_id(0);\n    group_sizze_323182 = get_local_size(0);\n    wave_sizze_323181 = LOCKSTEP_WIDTH;\n    group_tid_323180 = get_group_id(0);\n    \n    int32_t phys_tid_309121 = global_tid_323178;\n    __local unsigned char *red_arr_mem_323183;\n    \n    red_arr_mem_323183 = (__local unsigned char *) red_arr_mem_323183_backing_0;\n    \n    int32_t phys_group_id_323185;\n    \n    phys_group_id_323185 = get_group_id(0);\n    for (int32_t i_323186 = 0; i_323186 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766,\n                                          squot64(segred_group_sizze_309115,\n                                                  segment_sizze_nonzzero_323176))) -\n                   phys_group_id_323185, sext_i64_i32(num_groups_309116));\n         i_323186++) {\n        int32_t virt_group_id_323187 = phys_group_id_323185 + i_323186 *\n                sext_i64_i32(num_groups_309116);\n        int64_t slice_323188 = partition_sizze_292766;\n        int64_t gtid_309119 = squot64(sext_i32_i64(local_tid_323179),\n                                      segment_sizze_nonzzero_323176) +\n                sext_i32_i64(virt_group_id_323187) *\n                squot64(segred_group_sizze_309115,\n                        segment_sizze_nonzzero_323176);\n        int64_t remnant_323189 = squot64",
            "(sext_i32_i64(local_tid_323179),\n                                         segment_sizze_nonzzero_323176) +\n                sext_i32_i64(virt_group_id_323187) *\n                squot64(segred_group_sizze_309115,\n                        segment_sizze_nonzzero_323176) - gtid_309119;\n        int64_t gtid_309120 = srem64(sext_i32_i64(local_tid_323179),\n                                     (int64_t) 3);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, (int64_t) 3) && (slt64(gtid_309119,\n                                                          partition_sizze_292766) &&\n                                                    slt64(sext_i32_i64(local_tid_323179),\n                                                          (int64_t) 3 *\n                                                          squot64(segred_group_sizze_309115,\n                                                                  segment_sizze_nonzzero_323176)))) {\n                double x_309126;\n                \n                x_309126 = ((__global double *) mem_319538)[gtid_309119 *\n                                                            dyn_lifted_single_ma_l_arg_293321 +\n                                                            gtid_309120];\n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_323183)[sext_i32_i64(local_tid_323179)] =\n                        x_309126;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_323183)[sext_i32_i64(local_tid_323179)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, (int64_t) 3)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_309122;\n                double x_309123;\n                double x_323190;\n   ",
            "             double x_323191;\n                bool ltid_in_bounds_323193 =\n                     slt64(sext_i32_i64(local_tid_323179), (int64_t) 3 *\n                           squot64(segred_group_sizze_309115,\n                                   segment_sizze_nonzzero_323176));\n                int32_t skip_threads_323194;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_323193) {\n                        x_309123 = ((volatile __local\n                                     double *) red_arr_mem_323183)[sext_i32_i64(local_tid_323179)];\n                        if ((local_tid_323179 - squot32(local_tid_323179, 32) *\n                             32) == 0) {\n                            x_309122 = x_309123;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_323194 = 1;\n                    while (slt32(skip_threads_323194, 32)) {\n                        bool thread_active_323195 = sle32(skip_threads_323194,\n                                                          local_tid_323179 -\n                                                          squot32(local_tid_323179,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_323193;\n                        \n                        if (thread_active_323195) {\n                            // read operands\n                            {\n                                x_309122 = ((volatile __local\n                                             double *) red_arr_mem_323183)[sext_i32_i64(local_tid_323179) -\n                                                                           sext_i32_i64(skip_threads_323194)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool ina",
            "ctive_323196 =\n                                 slt64(srem64(sext_i32_i64(local_tid_323179),\n                                              (int64_t) 3),\n                                       sext_i32_i64(local_tid_323179) -\n                                       sext_i32_i64(local_tid_323179 -\n                                       skip_threads_323194));\n                            \n                            if (thread_active_323195 && inactive_323196) {\n                                x_309122 = x_309123;\n                            }\n                            if (thread_active_323195) {\n                                if (!inactive_323196) {\n                                    double defunc_1_op_res_309124 = x_309122 +\n                                           x_309123;\n                                    \n                                    x_309122 = defunc_1_op_res_309124;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_323181, skip_threads_323194)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_323195) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323183)[sext_i32_i64(local_tid_323179)] =\n                                    x_309122;\n                                x_309123 = x_309122;\n                            }\n                        }\n                        if (sle32(wave_sizze_323181, skip_threads_323194)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_323194 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_",
            "tid_323179 - squot32(local_tid_323179, 32) *\n                         32) == 31 && ltid_in_bounds_323193) {\n                        ((volatile __local\n                          double *) red_arr_mem_323183)[sext_i32_i64(squot32(local_tid_323179,\n                                                                             32))] =\n                            x_309122;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_323197;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_323179, 32) == 0 &&\n                            ltid_in_bounds_323193) {\n                            x_323191 = ((volatile __local\n                                         double *) red_arr_mem_323183)[sext_i32_i64(local_tid_323179)];\n                            if ((local_tid_323179 - squot32(local_tid_323179,\n                                                            32) * 32) == 0) {\n                                x_323190 = x_323191;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_323197 = 1;\n                        while (slt32(skip_threads_323197, 32)) {\n                            bool thread_active_323198 =\n                                 sle32(skip_threads_323197, local_tid_323179 -\n                                       squot32(local_tid_323179, 32) * 32) &&\n                                 (squot32(local_tid_323179, 32) == 0 &&\n                                  ltid_in_bounds_323193);\n                            \n                            if (thread_active_323198) {\n                                // read operands\n                                {\n  ",
            "                                  x_323190 = ((volatile __local\n                                                 double *) red_arr_mem_323183)[sext_i32_i64(local_tid_323179) -\n                                                                               sext_i32_i64(skip_threads_323197)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_323199 =\n                                     slt64(srem64(sext_i32_i64(local_tid_323179 *\n                                                  32 + 32 - 1), (int64_t) 3),\n                                           sext_i32_i64(local_tid_323179 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_323179 -\n                                                         skip_threads_323197) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_323198 && inactive_323199) {\n                                    x_323190 = x_323191;\n                                }\n                                if (thread_active_323198) {\n                                    if (!inactive_323199) {\n                                        double defunc_1_op_res_323192 =\n                                               x_323190 + x_323191;\n                                        \n                                        x_323190 = defunc_1_op_res_323192;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_323181, skip_threads_323197)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_323198) {\n                                // write result\n                                {\n            ",
            "                        ((volatile __local\n                                      double *) red_arr_mem_323183)[sext_i32_i64(local_tid_323179)] =\n                                        x_323190;\n                                    x_323191 = x_323190;\n                                }\n                            }\n                            if (sle32(wave_sizze_323181, skip_threads_323197)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_323197 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_323200 = squot32(local_tid_323179, 32) == 0 ||\n                     !ltid_in_bounds_323193;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_323200) {\n                            x_309123 = x_309122;\n                            x_309122 = ((__local\n                                         double *) red_arr_mem_323183)[sext_i32_i64(squot32(local_tid_323179,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_323201 =\n                             slt64(srem64(sext_i32_i64(local_tid_323179),\n                                          (int64_t) 3),\n                                   sext_i32_i64(local_tid_323179) -\n                                   sext_i32_i64(squot32(local_tid_323179, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_323200) {\n                            if (inactive_323201)",
            " {\n                                x_309122 = x_309123;\n                            }\n                        }\n                        if (!no_carry_in_323200) {\n                            if (!inactive_323201) {\n                                double defunc_1_op_res_309124 = x_309122 +\n                                       x_309123;\n                                \n                                x_309122 = defunc_1_op_res_309124;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_323200) {\n                            ((__local\n                              double *) red_arr_mem_323183)[sext_i32_i64(local_tid_323179)] =\n                                x_309122;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_323179, 32) == 0 &&\n                        ltid_in_bounds_323193) {\n                        ((__local\n                          double *) red_arr_mem_323183)[sext_i32_i64(local_tid_323179)] =\n                            x_309123;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_323187) *\n                      squot64(segred_group_sizze_309115,\n                              segment_sizze_nonzzero_323176) +\n                      sext_i32_i64(local_tid_323179), partition_sizze_292766) &&\n                slt64(sext_i32_i64(local_tid_323179),\n                      squot64(segred_group_sizze_309115,\n                              segment_sizze_nonzzero_323176))) {\n                double tmp_323202;\n                \n                tmp_323202 = ((__local\n       ",
            "                        double *) red_arr_mem_323183)[(sext_i32_i64(local_tid_323179) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323176 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319549)[sext_i32_i64(virt_group_id_323187) *\n                                        squot64(segred_group_sizze_309115,\n                                                segment_sizze_nonzzero_323176) +\n                                        sext_i32_i64(local_tid_323179)] =\n                    tmp_323202;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_309115\n}\n__kernel void mainzisegred_small_310765(__global int *global_failure,\n                                        uint red_arr_mem_323479_backing_offset_0,\n                                        int64_t n_292675, int64_t q_l_292680,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t l_n_m_292832, int64_t i_292846,\n                                        int64_t num_groups_310759,\n                                        int64_t ctx_param_ext_318833,\n                                        int64_t ctx_param_ext_318834,\n                                        int64_t ctx_param_ext_318836,\n                                        int64_t segment_sizze_nonzzero_323472,\n                                        __global unsigned char *ext_mem_318756,\n                                        __global unsigned char *ext_mem_318757,\n                                        __global\n                                        unsigned char *mem_param_318838,\n                      ",
            "                  __global unsigned char *mem_319654)\n{\n    #define segred_group_sizze_310758 (mainzisegred_group_sizze_310576)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_323479_backing_0 =\n                           &shared_mem[red_arr_mem_323479_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323474;\n    int32_t local_tid_323475;\n    int64_t group_sizze_323478;\n    int32_t wave_sizze_323477;\n    int32_t group_tid_323476;\n    \n    global_tid_323474 = get_global_id(0);\n    local_tid_323475 = get_local_id(0);\n    group_sizze_323478 = get_local_size(0);\n    wave_sizze_323477 = LOCKSTEP_WIDTH;\n    group_tid_323476 = get_group_id(0);\n    \n    int32_t phys_tid_310765 = global_tid_323474;\n    __local unsigned char *red_arr_mem_323479;\n    \n    red_arr_mem_323479 = (__local unsigned char *) red_arr_mem_323479_backing_0;\n    \n    int32_t phys_group_id_323481;\n    \n    phys_group_id_323481 = get_group_id(0);\n    for (int32_t i_323482 = 0; i_323482 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * l_n_m_292832,\n                                          squot64(segred_group_sizze_310758,\n                                                  segment_sizze_nonzzero_323472))) -\n                   phys_group_id_323481, sext_i64_i32(num_groups_310759));\n         i_323482++) {\n        int32_t virt_group_id_323483 = phys_group_id_323481 + i_323482 *\n                sext_i64_i32(num_groups_310759);\n        int64_t slice_323484 = l_n_m_292832;\n        int64_t slice_323485 = partition_sizze_292766 * slice_323484;\n        int64_t gtid_310762 = squot64(squot64(sext_i32_i64(local_tid_323475),\n                                              segment_sizze_nonzzero_323472) +\n                                      sext_i32_i64(virt_group_id_323483) *\n                                      squot64(segred_group_sizze_310758,\n                    ",
            "                          segment_sizze_nonzzero_323472),\n                                      slice_323484);\n        int64_t remnant_323486 = squot64(sext_i32_i64(local_tid_323475),\n                                         segment_sizze_nonzzero_323472) +\n                sext_i32_i64(virt_group_id_323483) *\n                squot64(segred_group_sizze_310758,\n                        segment_sizze_nonzzero_323472) - gtid_310762 *\n                slice_323484;\n        int64_t gtid_310763 = remnant_323486;\n        int64_t remnant_323487 = remnant_323486 - gtid_310763;\n        int64_t gtid_310764 = srem64(sext_i32_i64(local_tid_323475),\n                                     q_l_292680);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_l_292680) && ((slt64(gtid_310762,\n                                                          partition_sizze_292766) &&\n                                                    slt64(gtid_310763,\n                                                          l_n_m_292832)) &&\n                                                   slt64(sext_i32_i64(local_tid_323475),\n                                                         q_l_292680 *\n                                                         squot64(segred_group_sizze_310758,\n                                                                 segment_sizze_nonzzero_323472)))) {\n                int64_t x_310773;\n                \n                x_310773 = ((__global int64_t *) ext_mem_318757)[gtid_310762 *\n                                                                 l_n_m_292832 +\n                                                                 gtid_310763];\n                \n                double x_310774;\n                \n                x_310774 = ((__global double *) ext_mem_318756)[gtid_310762 *\n                                                                l_n_m_292832 +\n                                                                gtid_310763];\n ",
            "               \n                int64_t binop_y_317902 = mul64(jump_t_292685, gtid_310763);\n                int64_t binop_y_317903 = smin64(i_292846, binop_y_317902);\n                int64_t index_primexp_317904 = add64((int64_t) 1,\n                                                     binop_y_317903);\n                bool cond_310777 = sle64(n_292675, gtid_310764);\n                int64_t defunc_0_f_res_310778;\n                \n                if (cond_310777) {\n                    defunc_0_f_res_310778 = (int64_t) 0;\n                } else {\n                    int64_t i_310779 = add64(gtid_310764, x_310773);\n                    int64_t defunc_1_add_res_310780 = add64((int64_t) 1,\n                                                            i_310779);\n                    \n                    defunc_0_f_res_310778 = defunc_1_add_res_310780;\n                }\n                \n                double defunc_0_f_res_310781;\n                \n                if (cond_310777) {\n                    defunc_0_f_res_310781 = 0.0;\n                } else {\n                    int64_t i_310782 = add64(gtid_310764, x_310773);\n                    double defunc_0_add_arg_310783;\n                    \n                    defunc_0_add_arg_310783 = ((__global\n                                                double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                            (gtid_310762 *\n                                                                             ctx_param_ext_318834 +\n                                                                             i_310782 *\n                                                                             ctx_param_ext_318836)];\n                    defunc_0_f_res_310781 = defunc_0_add_arg_310783;\n                }\n                \n                int64_t binop_p_310784 = sub64(defunc_0_f_res_310778,\n                                               index_primexp_317904);\n                dou",
            "ble defunc_0_f_res_310785 = sitofp_i64_f64(binop_p_310784);\n                double abs_res_310786 = fabs(defunc_0_f_res_310785);\n                double tmp1_310787 = abs_res_310786 / x_310774;\n                double x_310788 = tmp1_310787 * tmp1_310787;\n                double y_310789 = tmp1_310787 * x_310788;\n                double tmp2_310790 = 1.0 - y_310789;\n                double x_310791 = tmp2_310790 * tmp2_310790;\n                double tmp3_310792 = tmp2_310790 * x_310791;\n                double w_j_310793 = defunc_0_f_res_310781 * tmp3_310792;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_323479)[sext_i32_i64(local_tid_323475)] =\n                        w_j_310793;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_323479)[sext_i32_i64(local_tid_323475)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_l_292680)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_310766;\n                double x_310767;\n                double x_323488;\n                double x_323489;\n                bool ltid_in_bounds_323491 =\n                     slt64(sext_i32_i64(local_tid_323475), q_l_292680 *\n                           squot64(segred_group_sizze_310758,\n                                   segment_sizze_nonzzero_323472));\n                int32_t skip_threads_323492;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_323491) {\n                        x_310767 = ((volatile __local\n                                     double *) red_arr_mem_323479)[sext_i32_i64(local_tid_323475)];\n                        if ((local_tid_323475 - squot32(local_tid_323475, 32) *\n    ",
            "                         32) == 0) {\n                            x_310766 = x_310767;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_323492 = 1;\n                    while (slt32(skip_threads_323492, 32)) {\n                        bool thread_active_323493 = sle32(skip_threads_323492,\n                                                          local_tid_323475 -\n                                                          squot32(local_tid_323475,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_323491;\n                        \n                        if (thread_active_323493) {\n                            // read operands\n                            {\n                                x_310766 = ((volatile __local\n                                             double *) red_arr_mem_323479)[sext_i32_i64(local_tid_323475) -\n                                                                           sext_i32_i64(skip_threads_323492)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_323494 =\n                                 slt64(srem64(sext_i32_i64(local_tid_323475),\n                                              q_l_292680),\n                                       sext_i32_i64(local_tid_323475) -\n                                       sext_i32_i64(local_tid_323475 -\n                                       skip_threads_323492));\n                            \n                            if (thread_active_323493 && inactive_323494) {\n                                x_310766 = x_310767;\n                            }\n                            if (thread_active_323493) {\n                                if (!inactive_323494) {\n                                    d",
            "ouble defunc_1_op_res_310768 = x_310766 +\n                                           x_310767;\n                                    \n                                    x_310766 = defunc_1_op_res_310768;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_323477, skip_threads_323492)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_323493) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323479)[sext_i32_i64(local_tid_323475)] =\n                                    x_310766;\n                                x_310767 = x_310766;\n                            }\n                        }\n                        if (sle32(wave_sizze_323477, skip_threads_323492)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_323492 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_323475 - squot32(local_tid_323475, 32) *\n                         32) == 31 && ltid_in_bounds_323491) {\n                        ((volatile __local\n                          double *) red_arr_mem_323479)[sext_i32_i64(squot32(local_tid_323475,\n                                                                             32))] =\n                            x_310766;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_323495;\n                    \n                    // read input for in-block scan\n ",
            "                   {\n                        if (squot32(local_tid_323475, 32) == 0 &&\n                            ltid_in_bounds_323491) {\n                            x_323489 = ((volatile __local\n                                         double *) red_arr_mem_323479)[sext_i32_i64(local_tid_323475)];\n                            if ((local_tid_323475 - squot32(local_tid_323475,\n                                                            32) * 32) == 0) {\n                                x_323488 = x_323489;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_323495 = 1;\n                        while (slt32(skip_threads_323495, 32)) {\n                            bool thread_active_323496 =\n                                 sle32(skip_threads_323495, local_tid_323475 -\n                                       squot32(local_tid_323475, 32) * 32) &&\n                                 (squot32(local_tid_323475, 32) == 0 &&\n                                  ltid_in_bounds_323491);\n                            \n                            if (thread_active_323496) {\n                                // read operands\n                                {\n                                    x_323488 = ((volatile __local\n                                                 double *) red_arr_mem_323479)[sext_i32_i64(local_tid_323475) -\n                                                                               sext_i32_i64(skip_threads_323495)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_323497 =\n                                     slt64(srem64(sext_i32_i64(local_tid_323475 *\n                                                  32 + 32 - 1), q_l_292680),\n                                           sex",
            "t_i32_i64(local_tid_323475 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_323475 -\n                                                         skip_threads_323495) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_323496 && inactive_323497) {\n                                    x_323488 = x_323489;\n                                }\n                                if (thread_active_323496) {\n                                    if (!inactive_323497) {\n                                        double defunc_1_op_res_323490 =\n                                               x_323488 + x_323489;\n                                        \n                                        x_323488 = defunc_1_op_res_323490;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_323477, skip_threads_323495)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_323496) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_323479)[sext_i32_i64(local_tid_323475)] =\n                                        x_323488;\n                                    x_323489 = x_323488;\n                                }\n                            }\n                            if (sle32(wave_sizze_323477, skip_threads_323495)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_323495 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no",
            "_carry_in_323498 = squot32(local_tid_323475, 32) == 0 ||\n                     !ltid_in_bounds_323491;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_323498) {\n                            x_310767 = x_310766;\n                            x_310766 = ((__local\n                                         double *) red_arr_mem_323479)[sext_i32_i64(squot32(local_tid_323475,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_323499 =\n                             slt64(srem64(sext_i32_i64(local_tid_323475),\n                                          q_l_292680),\n                                   sext_i32_i64(local_tid_323475) -\n                                   sext_i32_i64(squot32(local_tid_323475, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_323498) {\n                            if (inactive_323499) {\n                                x_310766 = x_310767;\n                            }\n                        }\n                        if (!no_carry_in_323498) {\n                            if (!inactive_323499) {\n                                double defunc_1_op_res_310768 = x_310766 +\n                                       x_310767;\n                                \n                                x_310766 = defunc_1_op_res_310768;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_323498) {\n                            ((__local\n                          ",
            "    double *) red_arr_mem_323479)[sext_i32_i64(local_tid_323475)] =\n                                x_310766;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_323475, 32) == 0 &&\n                        ltid_in_bounds_323491) {\n                        ((__local\n                          double *) red_arr_mem_323479)[sext_i32_i64(local_tid_323475)] =\n                            x_310767;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_323483) *\n                      squot64(segred_group_sizze_310758,\n                              segment_sizze_nonzzero_323472) +\n                      sext_i32_i64(local_tid_323475), partition_sizze_292766 *\n                      l_n_m_292832) && slt64(sext_i32_i64(local_tid_323475),\n                                             squot64(segred_group_sizze_310758,\n                                                     segment_sizze_nonzzero_323472))) {\n                double tmp_323500;\n                \n                tmp_323500 = ((__local\n                               double *) red_arr_mem_323479)[(sext_i32_i64(local_tid_323475) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323472 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319654)[squot64(sext_i32_i64(virt_group_id_323483) *\n                                                squot64(segred_group_sizze_310758,\n                                                        segment_sizze_nonzzero_323472) +\n            ",
            "                                    sext_i32_i64(local_tid_323475),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323483) *\n                                         squot64(segred_group_sizze_310758,\n                                                 segment_sizze_nonzzero_323472) +\n                                         sext_i32_i64(local_tid_323475) -\n                                         squot64(sext_i32_i64(virt_group_id_323483) *\n                                                 squot64(segred_group_sizze_310758,\n                                                         segment_sizze_nonzzero_323472) +\n                                                 sext_i32_i64(local_tid_323475),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323500;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_310758\n}\n__kernel void mainzisegred_small_310815(__global int *global_failure,\n                                        uint red_arr_mem_323562_backing_offset_0,\n                                        int64_t n_292675, int64_t q_l_292680,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t l_n_m_292832, int64_t i_292846,\n                                        int64_t num_groups_310809,\n                                        int64_t ctx_param_ext_318833,\n                                        int64_t ctx_param_ext_318834,\n                                        int64_t ctx_param_ext_318836,\n                                        int64_t segment_sizze_nonzzero_323555,\n                                        __global unsigned char *ext_me",
            "m_318756,\n                                        __global unsigned char *ext_mem_318757,\n                                        __global\n                                        unsigned char *mem_param_318838,\n                                        __global unsigned char *mem_319555,\n                                        __global unsigned char *mem_319659,\n                                        __global unsigned char *mem_319664)\n{\n    #define segred_group_sizze_310808 (mainzisegred_group_sizze_310508)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_323562_backing_0 =\n                           &shared_mem[red_arr_mem_323562_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323557;\n    int32_t local_tid_323558;\n    int64_t group_sizze_323561;\n    int32_t wave_sizze_323560;\n    int32_t group_tid_323559;\n    \n    global_tid_323557 = get_global_id(0);\n    local_tid_323558 = get_local_id(0);\n    group_sizze_323561 = get_local_size(0);\n    wave_sizze_323560 = LOCKSTEP_WIDTH;\n    group_tid_323559 = get_group_id(0);\n    \n    int32_t phys_tid_310815 = global_tid_323557;\n    __local unsigned char *red_arr_mem_323562;\n    \n    red_arr_mem_323562 = (__local unsigned char *) red_arr_mem_323562_backing_0;\n    \n    int32_t phys_group_id_323564;\n    \n    phys_group_id_323564 = get_group_id(0);\n    for (int32_t i_323565 = 0; i_323565 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * l_n_m_292832,\n                                          squot64(segred_group_sizze_310808,\n                                                  segment_sizze_nonzzero_323555))) -\n                   phys_group_id_323564, sext_i64_i32(num_groups_310809));\n         i_323565++) {\n        int32_t virt_group_id_323566 = phys_group_id_323564 + i_323565 *\n                sext_i64_i32(num_groups_310809);\n        int64_t slice_323567 = l_n_m_292832;\n        i",
            "nt64_t slice_323568 = partition_sizze_292766 * slice_323567;\n        int64_t gtid_310812 = squot64(squot64(sext_i32_i64(local_tid_323558),\n                                              segment_sizze_nonzzero_323555) +\n                                      sext_i32_i64(virt_group_id_323566) *\n                                      squot64(segred_group_sizze_310808,\n                                              segment_sizze_nonzzero_323555),\n                                      slice_323567);\n        int64_t remnant_323569 = squot64(sext_i32_i64(local_tid_323558),\n                                         segment_sizze_nonzzero_323555) +\n                sext_i32_i64(virt_group_id_323566) *\n                squot64(segred_group_sizze_310808,\n                        segment_sizze_nonzzero_323555) - gtid_310812 *\n                slice_323567;\n        int64_t gtid_310813 = remnant_323569;\n        int64_t remnant_323570 = remnant_323569 - gtid_310813;\n        int64_t gtid_310814 = srem64(sext_i32_i64(local_tid_323558),\n                                     q_l_292680);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_l_292680) && ((slt64(gtid_310812,\n                                                          partition_sizze_292766) &&\n                                                    slt64(gtid_310813,\n                                                          l_n_m_292832)) &&\n                                                   slt64(sext_i32_i64(local_tid_323558),\n                                                         q_l_292680 *\n                                                         squot64(segred_group_sizze_310808,\n                                                                 segment_sizze_nonzzero_323555)))) {\n                int64_t x_310825;\n                \n                x_310825 = ((__global int64_t *) ext_mem_318757)[gtid_310812 *\n                                                                 l_n_m_29283",
            "2 +\n                                                                 gtid_310813];\n                \n                double x_310826;\n                \n                x_310826 = ((__global double *) ext_mem_318756)[gtid_310812 *\n                                                                l_n_m_292832 +\n                                                                gtid_310813];\n                \n                int64_t binop_y_317897 = mul64(jump_t_292685, gtid_310813);\n                int64_t binop_y_317898 = smin64(i_292846, binop_y_317897);\n                int64_t index_primexp_317899 = add64((int64_t) 1,\n                                                     binop_y_317898);\n                double a0_310828;\n                \n                a0_310828 = ((__global double *) mem_319659)[gtid_310812 *\n                                                             l_n_m_292832 +\n                                                             gtid_310813];\n                \n                bool cond_310830 = sle64(n_292675, gtid_310814);\n                int64_t defunc_0_f_res_310831;\n                \n                if (cond_310830) {\n                    defunc_0_f_res_310831 = (int64_t) 0;\n                } else {\n                    int64_t i_310832 = add64(gtid_310814, x_310825);\n                    int64_t defunc_1_add_res_310833 = add64((int64_t) 1,\n                                                            i_310832);\n                    \n                    defunc_0_f_res_310831 = defunc_1_add_res_310833;\n                }\n                \n                double defunc_0_f_res_310834;\n                \n                if (cond_310830) {\n                    defunc_0_f_res_310834 = 0.0;\n                } else {\n                    int64_t i_310835 = add64(gtid_310814, x_310825);\n                    double defunc_0_add_arg_310836;\n                    \n                    defunc_0_add_arg_310836 = ((__global\n                                                double *) mem_",
            "param_318838)[ctx_param_ext_318833 +\n                                                                            (gtid_310812 *\n                                                                             ctx_param_ext_318834 +\n                                                                             i_310835 *\n                                                                             ctx_param_ext_318836)];\n                    defunc_0_f_res_310834 = defunc_0_add_arg_310836;\n                }\n                \n                int64_t binop_p_310837 = sub64(defunc_0_f_res_310831,\n                                               index_primexp_317899);\n                double defunc_0_f_res_310838 = sitofp_i64_f64(binop_p_310837);\n                double abs_res_310839 = fabs(defunc_0_f_res_310838);\n                double tmp1_310840 = abs_res_310839 / x_310826;\n                double x_310841 = tmp1_310840 * tmp1_310840;\n                double y_310842 = tmp1_310840 * x_310841;\n                double tmp2_310843 = 1.0 - y_310842;\n                double x_310844 = tmp2_310843 * tmp2_310843;\n                double tmp3_310845 = tmp2_310843 * x_310844;\n                double tmp4_310846 = defunc_0_f_res_310834 * tmp3_310845;\n                double defunc_0_f_res_310847;\n                \n                if (cond_310830) {\n                    defunc_0_f_res_310847 = 0.0;\n                } else {\n                    int64_t i_310848 = add64(gtid_310814, x_310825);\n                    double defunc_0_add_arg_310849;\n                    \n                    defunc_0_add_arg_310849 = ((__global\n                                                double *) mem_319555)[gtid_310812 *\n                                                                      n_292675 +\n                                                                      i_310848];\n                    defunc_0_f_res_310847 = defunc_0_add_arg_310849;\n                }\n                \n                double x_310850 = a0_3",
            "10828 * tmp4_310846;\n                double defunc_9_fit_fun_res_310851 = defunc_0_f_res_310847 *\n                       x_310850;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_323562)[sext_i32_i64(local_tid_323558)] =\n                        defunc_9_fit_fun_res_310851;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_323562)[sext_i32_i64(local_tid_323558)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_l_292680)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_310816;\n                double x_310817;\n                double x_323571;\n                double x_323572;\n                bool ltid_in_bounds_323574 =\n                     slt64(sext_i32_i64(local_tid_323558), q_l_292680 *\n                           squot64(segred_group_sizze_310808,\n                                   segment_sizze_nonzzero_323555));\n                int32_t skip_threads_323575;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_323574) {\n                        x_310817 = ((volatile __local\n                                     double *) red_arr_mem_323562)[sext_i32_i64(local_tid_323558)];\n                        if ((local_tid_323558 - squot32(local_tid_323558, 32) *\n                             32) == 0) {\n                            x_310816 = x_310817;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_323575 = 1;\n                    while (slt32(skip_threads_323575, 32)) {\n                        bool thread_active_323576 = sle32(skip_threads_3",
            "23575,\n                                                          local_tid_323558 -\n                                                          squot32(local_tid_323558,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_323574;\n                        \n                        if (thread_active_323576) {\n                            // read operands\n                            {\n                                x_310816 = ((volatile __local\n                                             double *) red_arr_mem_323562)[sext_i32_i64(local_tid_323558) -\n                                                                           sext_i32_i64(skip_threads_323575)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_323577 =\n                                 slt64(srem64(sext_i32_i64(local_tid_323558),\n                                              q_l_292680),\n                                       sext_i32_i64(local_tid_323558) -\n                                       sext_i32_i64(local_tid_323558 -\n                                       skip_threads_323575));\n                            \n                            if (thread_active_323576 && inactive_323577) {\n                                x_310816 = x_310817;\n                            }\n                            if (thread_active_323576) {\n                                if (!inactive_323577) {\n                                    double defunc_1_op_res_310818 = x_310816 +\n                                           x_310817;\n                                    \n                                    x_310816 = defunc_1_op_res_310818;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_323560, skip_threads_323575)) {\n                            barrier(CLK_LO",
            "CAL_MEM_FENCE);\n                        }\n                        if (thread_active_323576) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323562)[sext_i32_i64(local_tid_323558)] =\n                                    x_310816;\n                                x_310817 = x_310816;\n                            }\n                        }\n                        if (sle32(wave_sizze_323560, skip_threads_323575)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_323575 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_323558 - squot32(local_tid_323558, 32) *\n                         32) == 31 && ltid_in_bounds_323574) {\n                        ((volatile __local\n                          double *) red_arr_mem_323562)[sext_i32_i64(squot32(local_tid_323558,\n                                                                             32))] =\n                            x_310816;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_323578;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_323558, 32) == 0 &&\n                            ltid_in_bounds_323574) {\n                            x_323572 = ((volatile __local\n                                         double *) red_arr_mem_323562)[sext_i32_i64(local_tid_323558)];\n                            if ((local_tid_323558 - squot32(local_tid_323558,\n                                ",
            "                            32) * 32) == 0) {\n                                x_323571 = x_323572;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_323578 = 1;\n                        while (slt32(skip_threads_323578, 32)) {\n                            bool thread_active_323579 =\n                                 sle32(skip_threads_323578, local_tid_323558 -\n                                       squot32(local_tid_323558, 32) * 32) &&\n                                 (squot32(local_tid_323558, 32) == 0 &&\n                                  ltid_in_bounds_323574);\n                            \n                            if (thread_active_323579) {\n                                // read operands\n                                {\n                                    x_323571 = ((volatile __local\n                                                 double *) red_arr_mem_323562)[sext_i32_i64(local_tid_323558) -\n                                                                               sext_i32_i64(skip_threads_323578)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_323580 =\n                                     slt64(srem64(sext_i32_i64(local_tid_323558 *\n                                                  32 + 32 - 1), q_l_292680),\n                                           sext_i32_i64(local_tid_323558 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_323558 -\n                                                         skip_threads_323578) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_323579 && inactive_323580) {",
            "\n                                    x_323571 = x_323572;\n                                }\n                                if (thread_active_323579) {\n                                    if (!inactive_323580) {\n                                        double defunc_1_op_res_323573 =\n                                               x_323571 + x_323572;\n                                        \n                                        x_323571 = defunc_1_op_res_323573;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_323560, skip_threads_323578)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_323579) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_323562)[sext_i32_i64(local_tid_323558)] =\n                                        x_323571;\n                                    x_323572 = x_323571;\n                                }\n                            }\n                            if (sle32(wave_sizze_323560, skip_threads_323578)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_323578 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_323581 = squot32(local_tid_323558, 32) == 0 ||\n                     !ltid_in_bounds_323574;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_323581) {\n                            x_310817 = x_310816;\n                            x_310816 = ((__local\n      ",
            "                                   double *) red_arr_mem_323562)[sext_i32_i64(squot32(local_tid_323558,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_323582 =\n                             slt64(srem64(sext_i32_i64(local_tid_323558),\n                                          q_l_292680),\n                                   sext_i32_i64(local_tid_323558) -\n                                   sext_i32_i64(squot32(local_tid_323558, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_323581) {\n                            if (inactive_323582) {\n                                x_310816 = x_310817;\n                            }\n                        }\n                        if (!no_carry_in_323581) {\n                            if (!inactive_323582) {\n                                double defunc_1_op_res_310818 = x_310816 +\n                                       x_310817;\n                                \n                                x_310816 = defunc_1_op_res_310818;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_323581) {\n                            ((__local\n                              double *) red_arr_mem_323562)[sext_i32_i64(local_tid_323558)] =\n                                x_310816;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_323558, 32) == 0 &&\n                        ltid_in_bounds_323574) {\n   ",
            "                     ((__local\n                          double *) red_arr_mem_323562)[sext_i32_i64(local_tid_323558)] =\n                            x_310817;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_323566) *\n                      squot64(segred_group_sizze_310808,\n                              segment_sizze_nonzzero_323555) +\n                      sext_i32_i64(local_tid_323558), partition_sizze_292766 *\n                      l_n_m_292832) && slt64(sext_i32_i64(local_tid_323558),\n                                             squot64(segred_group_sizze_310808,\n                                                     segment_sizze_nonzzero_323555))) {\n                double tmp_323583;\n                \n                tmp_323583 = ((__local\n                               double *) red_arr_mem_323562)[(sext_i32_i64(local_tid_323558) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323555 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319664)[squot64(sext_i32_i64(virt_group_id_323566) *\n                                                squot64(segred_group_sizze_310808,\n                                                        segment_sizze_nonzzero_323555) +\n                                                sext_i32_i64(local_tid_323558),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323566) *\n                                         squot64(segred_group_sizze_310808,\n                                                 segment_sizze_nonzzero_323555) +\n                             ",
            "            sext_i32_i64(local_tid_323558) -\n                                         squot64(sext_i32_i64(virt_group_id_323566) *\n                                                 squot64(segred_group_sizze_310808,\n                                                         segment_sizze_nonzzero_323555) +\n                                                 sext_i32_i64(local_tid_323558),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323583;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_310808\n}\n__kernel void mainzisegred_small_311208(__global int *global_failure,\n                                        uint red_arr_mem_323639_backing_offset_0,\n                                        uint red_arr_mem_323637_backing_offset_1,\n                                        uint red_arr_mem_323635_backing_offset_2,\n                                        int64_t n_292675, int64_t q_l_292680,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t l_n_m_292832, int64_t i_292846,\n                                        int64_t num_groups_311200,\n                                        int64_t ctx_param_ext_318833,\n                                        int64_t ctx_param_ext_318834,\n                                        int64_t ctx_param_ext_318836,\n                                        int64_t segment_sizze_nonzzero_323628,\n                                        __global unsigned char *ext_mem_318756,\n                                        __global unsigned char *ext_mem_318757,\n                                        __global\n                                        unsigned char *mem_param_318838,\n                                    ",
            "    __global unsigned char *mem_319669,\n                                        __global unsigned char *mem_319673,\n                                        __global unsigned char *mem_319677)\n{\n    #define segred_group_sizze_311199 (mainzisegred_group_sizze_310971)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_323639_backing_2 =\n                           &shared_mem[red_arr_mem_323639_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323637_backing_1 =\n                           &shared_mem[red_arr_mem_323637_backing_offset_1];\n    volatile unsigned char *red_arr_mem_323635_backing_0 =\n                           &shared_mem[red_arr_mem_323635_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323630;\n    int32_t local_tid_323631;\n    int64_t group_sizze_323634;\n    int32_t wave_sizze_323633;\n    int32_t group_tid_323632;\n    \n    global_tid_323630 = get_global_id(0);\n    local_tid_323631 = get_local_id(0);\n    group_sizze_323634 = get_local_size(0);\n    wave_sizze_323633 = LOCKSTEP_WIDTH;\n    group_tid_323632 = get_group_id(0);\n    \n    int32_t phys_tid_311208 = global_tid_323630;\n    __local unsigned char *red_arr_mem_323635;\n    \n    red_arr_mem_323635 = (__local unsigned char *) red_arr_mem_323635_backing_0;\n    \n    __local unsigned char *red_arr_mem_323637;\n    \n    red_arr_mem_323637 = (__local unsigned char *) red_arr_mem_323637_backing_1;\n    \n    __local unsigned char *red_arr_mem_323639;\n    \n    red_arr_mem_323639 = (__local unsigned char *) red_arr_mem_323639_backing_2;\n    \n    int32_t phys_group_id_323641;\n    \n    phys_group_id_323641 = get_group_id(0);\n    for (int32_t i_323642 = 0; i_323642 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * l_n_m_292832,\n                                          squot64(segred_group_sizze_311199,\n                                                  segment_s",
            "izze_nonzzero_323628))) -\n                   phys_group_id_323641, sext_i64_i32(num_groups_311200));\n         i_323642++) {\n        int32_t virt_group_id_323643 = phys_group_id_323641 + i_323642 *\n                sext_i64_i32(num_groups_311200);\n        int64_t slice_323644 = l_n_m_292832;\n        int64_t slice_323645 = partition_sizze_292766 * slice_323644;\n        int64_t gtid_311205 = squot64(squot64(sext_i32_i64(local_tid_323631),\n                                              segment_sizze_nonzzero_323628) +\n                                      sext_i32_i64(virt_group_id_323643) *\n                                      squot64(segred_group_sizze_311199,\n                                              segment_sizze_nonzzero_323628),\n                                      slice_323644);\n        int64_t remnant_323646 = squot64(sext_i32_i64(local_tid_323631),\n                                         segment_sizze_nonzzero_323628) +\n                sext_i32_i64(virt_group_id_323643) *\n                squot64(segred_group_sizze_311199,\n                        segment_sizze_nonzzero_323628) - gtid_311205 *\n                slice_323644;\n        int64_t gtid_311206 = remnant_323646;\n        int64_t remnant_323647 = remnant_323646 - gtid_311206;\n        int64_t gtid_311207 = srem64(sext_i32_i64(local_tid_323631),\n                                     q_l_292680);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_l_292680) && ((slt64(gtid_311205,\n                                                          partition_sizze_292766) &&\n                                                    slt64(gtid_311206,\n                                                          l_n_m_292832)) &&\n                                                   slt64(sext_i32_i64(local_tid_323631),\n                                                         q_l_292680 *\n                                                         squot64(segred_group_sizze_311199,\n       ",
            "                                                          segment_sizze_nonzzero_323628)))) {\n                int64_t x_311222;\n                \n                x_311222 = ((__global int64_t *) ext_mem_318757)[gtid_311205 *\n                                                                 l_n_m_292832 +\n                                                                 gtid_311206];\n                \n                double x_311223;\n                \n                x_311223 = ((__global double *) ext_mem_318756)[gtid_311205 *\n                                                                l_n_m_292832 +\n                                                                gtid_311206];\n                \n                int64_t binop_y_317912 = mul64(jump_t_292685, gtid_311206);\n                int64_t binop_y_317913 = smin64(i_292846, binop_y_317912);\n                int64_t index_primexp_317914 = add64((int64_t) 1,\n                                                     binop_y_317913);\n                bool cond_311226 = sle64(n_292675, gtid_311207);\n                int64_t defunc_0_f_res_311227;\n                \n                if (cond_311226) {\n                    defunc_0_f_res_311227 = (int64_t) 0;\n                } else {\n                    int64_t i_311228 = add64(gtid_311207, x_311222);\n                    int64_t defunc_1_add_res_311229 = add64((int64_t) 1,\n                                                            i_311228);\n                    \n                    defunc_0_f_res_311227 = defunc_1_add_res_311229;\n                }\n                \n                double defunc_0_f_res_311230;\n                \n                if (cond_311226) {\n                    defunc_0_f_res_311230 = 0.0;\n                } else {\n                    int64_t i_311231 = add64(gtid_311207, x_311222);\n                    double defunc_0_add_arg_311232;\n                    \n                    defunc_0_add_arg_311232 = ((__global\n                                                double *",
            ") mem_param_318838)[ctx_param_ext_318833 +\n                                                                            (gtid_311205 *\n                                                                             ctx_param_ext_318834 +\n                                                                             i_311231 *\n                                                                             ctx_param_ext_318836)];\n                    defunc_0_f_res_311230 = defunc_0_add_arg_311232;\n                }\n                \n                int64_t binop_p_311233 = sub64(defunc_0_f_res_311227,\n                                               index_primexp_317914);\n                double defunc_0_f_res_311234 = sitofp_i64_f64(binop_p_311233);\n                double abs_res_311235 = fabs(defunc_0_f_res_311234);\n                double tmp1_311236 = abs_res_311235 / x_311223;\n                double x_311237 = tmp1_311236 * tmp1_311236;\n                double y_311238 = tmp1_311236 * x_311237;\n                double tmp2_311239 = 1.0 - y_311238;\n                double x_311240 = tmp2_311239 * tmp2_311239;\n                double tmp3_311241 = tmp2_311239 * x_311240;\n                double w_j_311242 = defunc_0_f_res_311230 * tmp3_311241;\n                double xw_j_311243 = defunc_0_f_res_311234 * w_j_311242;\n                double x2w_j_311244 = defunc_0_f_res_311234 * xw_j_311243;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_323635)[sext_i32_i64(local_tid_323631)] =\n                        w_j_311242;\n                    ((__local\n                      double *) red_arr_mem_323637)[sext_i32_i64(local_tid_323631)] =\n                        xw_j_311243;\n                    ((__local\n                      double *) red_arr_mem_323639)[sext_i32_i64(local_tid_323631)] =\n                        x2w_j_311244;\n      ",
            "          }\n            } else {\n                ((__local\n                  double *) red_arr_mem_323635)[sext_i32_i64(local_tid_323631)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_323637)[sext_i32_i64(local_tid_323631)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_323639)[sext_i32_i64(local_tid_323631)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_l_292680)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_311209;\n                double x_311210;\n                double x_311211;\n                double x_311212;\n                double x_311213;\n                double x_311214;\n                double x_323648;\n                double x_323649;\n                double x_323650;\n                double x_323651;\n                double x_323652;\n                double x_323653;\n                bool ltid_in_bounds_323657 =\n                     slt64(sext_i32_i64(local_tid_323631), q_l_292680 *\n                           squot64(segred_group_sizze_311199,\n                                   segment_sizze_nonzzero_323628));\n                int32_t skip_threads_323658;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_323657) {\n                        x_311212 = ((volatile __local\n                                     double *) red_arr_mem_323635)[sext_i32_i64(local_tid_323631)];\n                        x_311213 = ((volatile __local\n                                     double *) red_arr_mem_323637)[sext_i32_i64(local_tid_323631)];\n                        x_311214 = ((volatile __local\n                                     double *) red_arr_mem_323639)[sext_i32_i64(local_tid_323631)];\n                        if ((local_tid_323631 - squot32(local_tid_323631, 32) *\n                         ",
            "    32) == 0) {\n                            x_311209 = x_311212;\n                            x_311210 = x_311213;\n                            x_311211 = x_311214;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_323658 = 1;\n                    while (slt32(skip_threads_323658, 32)) {\n                        bool thread_active_323659 = sle32(skip_threads_323658,\n                                                          local_tid_323631 -\n                                                          squot32(local_tid_323631,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_323657;\n                        \n                        if (thread_active_323659) {\n                            // read operands\n                            {\n                                x_311209 = ((volatile __local\n                                             double *) red_arr_mem_323635)[sext_i32_i64(local_tid_323631) -\n                                                                           sext_i32_i64(skip_threads_323658)];\n                                x_311210 = ((volatile __local\n                                             double *) red_arr_mem_323637)[sext_i32_i64(local_tid_323631) -\n                                                                           sext_i32_i64(skip_threads_323658)];\n                                x_311211 = ((volatile __local\n                                             double *) red_arr_mem_323639)[sext_i32_i64(local_tid_323631) -\n                                                                           sext_i32_i64(skip_threads_323658)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_323660 =\n                                 slt64(",
            "srem64(sext_i32_i64(local_tid_323631),\n                                              q_l_292680),\n                                       sext_i32_i64(local_tid_323631) -\n                                       sext_i32_i64(local_tid_323631 -\n                                       skip_threads_323658));\n                            \n                            if (thread_active_323659 && inactive_323660) {\n                                x_311209 = x_311212;\n                                x_311210 = x_311213;\n                                x_311211 = x_311214;\n                            }\n                            if (thread_active_323659) {\n                                if (!inactive_323660) {\n                                    double defunc_1_op_res_311215 = x_311209 +\n                                           x_311212;\n                                    double defunc_1_op_res_311216 = x_311210 +\n                                           x_311213;\n                                    double defunc_1_op_res_311217 = x_311211 +\n                                           x_311214;\n                                    \n                                    x_311209 = defunc_1_op_res_311215;\n                                    x_311210 = defunc_1_op_res_311216;\n                                    x_311211 = defunc_1_op_res_311217;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_323633, skip_threads_323658)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_323659) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323635)[sext_i32_i64(local_tid_323631)] =\n                                    x_311209;\n                                x_311212 = x_311209;\n                     ",
            "           ((volatile __local\n                                  double *) red_arr_mem_323637)[sext_i32_i64(local_tid_323631)] =\n                                    x_311210;\n                                x_311213 = x_311210;\n                                ((volatile __local\n                                  double *) red_arr_mem_323639)[sext_i32_i64(local_tid_323631)] =\n                                    x_311211;\n                                x_311214 = x_311211;\n                            }\n                        }\n                        if (sle32(wave_sizze_323633, skip_threads_323658)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_323658 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_323631 - squot32(local_tid_323631, 32) *\n                         32) == 31 && ltid_in_bounds_323657) {\n                        ((volatile __local\n                          double *) red_arr_mem_323635)[sext_i32_i64(squot32(local_tid_323631,\n                                                                             32))] =\n                            x_311209;\n                        ((volatile __local\n                          double *) red_arr_mem_323637)[sext_i32_i64(squot32(local_tid_323631,\n                                                                             32))] =\n                            x_311210;\n                        ((volatile __local\n                          double *) red_arr_mem_323639)[sext_i32_i64(squot32(local_tid_323631,\n                                                                             32))] =\n                            x_311211;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contai",
            "ns carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_323661;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_323631, 32) == 0 &&\n                            ltid_in_bounds_323657) {\n                            x_323651 = ((volatile __local\n                                         double *) red_arr_mem_323635)[sext_i32_i64(local_tid_323631)];\n                            x_323652 = ((volatile __local\n                                         double *) red_arr_mem_323637)[sext_i32_i64(local_tid_323631)];\n                            x_323653 = ((volatile __local\n                                         double *) red_arr_mem_323639)[sext_i32_i64(local_tid_323631)];\n                            if ((local_tid_323631 - squot32(local_tid_323631,\n                                                            32) * 32) == 0) {\n                                x_323648 = x_323651;\n                                x_323649 = x_323652;\n                                x_323650 = x_323653;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_323661 = 1;\n                        while (slt32(skip_threads_323661, 32)) {\n                            bool thread_active_323662 =\n                                 sle32(skip_threads_323661, local_tid_323631 -\n                                       squot32(local_tid_323631, 32) * 32) &&\n                                 (squot32(local_tid_323631, 32) == 0 &&\n                                  ltid_in_bounds_323657);\n                            \n                            if (thread_active_323662) {\n                                // read operands\n                                {\n                                    x_323648 = ((volatile __local\n                               ",
            "                  double *) red_arr_mem_323635)[sext_i32_i64(local_tid_323631) -\n                                                                               sext_i32_i64(skip_threads_323661)];\n                                    x_323649 = ((volatile __local\n                                                 double *) red_arr_mem_323637)[sext_i32_i64(local_tid_323631) -\n                                                                               sext_i32_i64(skip_threads_323661)];\n                                    x_323650 = ((volatile __local\n                                                 double *) red_arr_mem_323639)[sext_i32_i64(local_tid_323631) -\n                                                                               sext_i32_i64(skip_threads_323661)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_323663 =\n                                     slt64(srem64(sext_i32_i64(local_tid_323631 *\n                                                  32 + 32 - 1), q_l_292680),\n                                           sext_i32_i64(local_tid_323631 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_323631 -\n                                                         skip_threads_323661) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_323662 && inactive_323663) {\n                                    x_323648 = x_323651;\n                                    x_323649 = x_323652;\n                                    x_323650 = x_323653;\n                                }\n                                if (thread_active_323662) {\n                                    if (!inactive_323663) {\n                                        double defunc_1_op_res_323654 =\n     ",
            "                                          x_323648 + x_323651;\n                                        double defunc_1_op_res_323655 =\n                                               x_323649 + x_323652;\n                                        double defunc_1_op_res_323656 =\n                                               x_323650 + x_323653;\n                                        \n                                        x_323648 = defunc_1_op_res_323654;\n                                        x_323649 = defunc_1_op_res_323655;\n                                        x_323650 = defunc_1_op_res_323656;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_323633, skip_threads_323661)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_323662) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_323635)[sext_i32_i64(local_tid_323631)] =\n                                        x_323648;\n                                    x_323651 = x_323648;\n                                    ((volatile __local\n                                      double *) red_arr_mem_323637)[sext_i32_i64(local_tid_323631)] =\n                                        x_323649;\n                                    x_323652 = x_323649;\n                                    ((volatile __local\n                                      double *) red_arr_mem_323639)[sext_i32_i64(local_tid_323631)] =\n                                        x_323650;\n                                    x_323653 = x_323650;\n                                }\n                            }\n                            if (sle32(wave_sizze_323633, skip_threads_323661)) {\n                                barrier(C",
            "LK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_323661 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_323664 = squot32(local_tid_323631, 32) == 0 ||\n                     !ltid_in_bounds_323657;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_323664) {\n                            x_311212 = x_311209;\n                            x_311213 = x_311210;\n                            x_311214 = x_311211;\n                            x_311209 = ((__local\n                                         double *) red_arr_mem_323635)[sext_i32_i64(squot32(local_tid_323631,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_311210 = ((__local\n                                         double *) red_arr_mem_323637)[sext_i32_i64(squot32(local_tid_323631,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_311211 = ((__local\n                                         double *) red_arr_mem_323639)[sext_i32_i64(squot32(local_tid_323631,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_323665 =\n                             slt64(srem64(sext_i32_i64(local_tid_323631),\n                           ",
            "               q_l_292680),\n                                   sext_i32_i64(local_tid_323631) -\n                                   sext_i32_i64(squot32(local_tid_323631, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_323664) {\n                            if (inactive_323665) {\n                                x_311209 = x_311212;\n                                x_311210 = x_311213;\n                                x_311211 = x_311214;\n                            }\n                        }\n                        if (!no_carry_in_323664) {\n                            if (!inactive_323665) {\n                                double defunc_1_op_res_311215 = x_311209 +\n                                       x_311212;\n                                double defunc_1_op_res_311216 = x_311210 +\n                                       x_311213;\n                                double defunc_1_op_res_311217 = x_311211 +\n                                       x_311214;\n                                \n                                x_311209 = defunc_1_op_res_311215;\n                                x_311210 = defunc_1_op_res_311216;\n                                x_311211 = defunc_1_op_res_311217;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_323664) {\n                            ((__local\n                              double *) red_arr_mem_323635)[sext_i32_i64(local_tid_323631)] =\n                                x_311209;\n                            ((__local\n                              double *) red_arr_mem_323637)[sext_i32_i64(local_tid_323631)] =\n                                x_311210;\n                            ((__local\n                              double *) red_arr_mem_323639)[sext_i32_i64(local_tid_323631)] =\n                                x_311211;\n             ",
            "           }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_323631, 32) == 0 &&\n                        ltid_in_bounds_323657) {\n                        ((__local\n                          double *) red_arr_mem_323635)[sext_i32_i64(local_tid_323631)] =\n                            x_311212;\n                        ((__local\n                          double *) red_arr_mem_323637)[sext_i32_i64(local_tid_323631)] =\n                            x_311213;\n                        ((__local\n                          double *) red_arr_mem_323639)[sext_i32_i64(local_tid_323631)] =\n                            x_311214;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_323643) *\n                      squot64(segred_group_sizze_311199,\n                              segment_sizze_nonzzero_323628) +\n                      sext_i32_i64(local_tid_323631), partition_sizze_292766 *\n                      l_n_m_292832) && slt64(sext_i32_i64(local_tid_323631),\n                                             squot64(segred_group_sizze_311199,\n                                                     segment_sizze_nonzzero_323628))) {\n                double tmp_323666;\n                \n                tmp_323666 = ((__local\n                               double *) red_arr_mem_323635)[(sext_i32_i64(local_tid_323631) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323628 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319669)[squot64(sext_i32_i64(virt_gr",
            "oup_id_323643) *\n                                                squot64(segred_group_sizze_311199,\n                                                        segment_sizze_nonzzero_323628) +\n                                                sext_i32_i64(local_tid_323631),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323643) *\n                                         squot64(segred_group_sizze_311199,\n                                                 segment_sizze_nonzzero_323628) +\n                                         sext_i32_i64(local_tid_323631) -\n                                         squot64(sext_i32_i64(virt_group_id_323643) *\n                                                 squot64(segred_group_sizze_311199,\n                                                         segment_sizze_nonzzero_323628) +\n                                                 sext_i32_i64(local_tid_323631),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323666;\n                \n                double tmp_323667;\n                \n                tmp_323667 = ((__local\n                               double *) red_arr_mem_323637)[(sext_i32_i64(local_tid_323631) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323628 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319673)[squot64(sext_i32_i64(virt_group_id_323643) *\n                                                squot64(segred_group_sizze_311199,\n                                                        segment_sizze_nonzzero_323628) +\n                                                sext_i32_i64(local_tid_323631),\n                                                l_n_m_",
            "292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323643) *\n                                         squot64(segred_group_sizze_311199,\n                                                 segment_sizze_nonzzero_323628) +\n                                         sext_i32_i64(local_tid_323631) -\n                                         squot64(sext_i32_i64(virt_group_id_323643) *\n                                                 squot64(segred_group_sizze_311199,\n                                                         segment_sizze_nonzzero_323628) +\n                                                 sext_i32_i64(local_tid_323631),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323667;\n                \n                double tmp_323668;\n                \n                tmp_323668 = ((__local\n                               double *) red_arr_mem_323639)[(sext_i32_i64(local_tid_323631) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323628 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319677)[squot64(sext_i32_i64(virt_group_id_323643) *\n                                                squot64(segred_group_sizze_311199,\n                                                        segment_sizze_nonzzero_323628) +\n                                                sext_i32_i64(local_tid_323631),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323643) *\n                                         squot64(segred_group_sizze_311199,\n                                                 segment_sizze_nonzzero_323628) +\n                                         sext_i32_i64(local_ti",
            "d_323631) -\n                                         squot64(sext_i32_i64(virt_group_id_323643) *\n                                                 squot64(segred_group_sizze_311199,\n                                                         segment_sizze_nonzzero_323628) +\n                                                 sext_i32_i64(local_tid_323631),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323668;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_311199\n}\n__kernel void mainzisegred_small_311280(__global int *global_failure,\n                                        uint red_arr_mem_323748_backing_offset_0,\n                                        uint red_arr_mem_323746_backing_offset_1,\n                                        int64_t n_292675, int64_t q_l_292680,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t l_n_m_292832, int64_t i_292846,\n                                        int64_t num_groups_311273,\n                                        int64_t ctx_param_ext_318833,\n                                        int64_t ctx_param_ext_318834,\n                                        int64_t ctx_param_ext_318836,\n                                        int64_t segment_sizze_nonzzero_323739,\n                                        __global unsigned char *ext_mem_318756,\n                                        __global unsigned char *ext_mem_318757,\n                                        __global\n                                        unsigned char *mem_param_318838,\n                                        __global unsigned char *mem_319555,\n                                        __global unsigned char *mem_319682,",
            "\n                                        __global unsigned char *mem_319686,\n                                        __global unsigned char *mem_319690,\n                                        __global unsigned char *mem_319695,\n                                        __global unsigned char *mem_319699)\n{\n    #define segred_group_sizze_311272 (mainzisegred_group_sizze_310874)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_323748_backing_1 =\n                           &shared_mem[red_arr_mem_323748_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323746_backing_0 =\n                           &shared_mem[red_arr_mem_323746_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323741;\n    int32_t local_tid_323742;\n    int64_t group_sizze_323745;\n    int32_t wave_sizze_323744;\n    int32_t group_tid_323743;\n    \n    global_tid_323741 = get_global_id(0);\n    local_tid_323742 = get_local_id(0);\n    group_sizze_323745 = get_local_size(0);\n    wave_sizze_323744 = LOCKSTEP_WIDTH;\n    group_tid_323743 = get_group_id(0);\n    \n    int32_t phys_tid_311280 = global_tid_323741;\n    __local unsigned char *red_arr_mem_323746;\n    \n    red_arr_mem_323746 = (__local unsigned char *) red_arr_mem_323746_backing_0;\n    \n    __local unsigned char *red_arr_mem_323748;\n    \n    red_arr_mem_323748 = (__local unsigned char *) red_arr_mem_323748_backing_1;\n    \n    int32_t phys_group_id_323750;\n    \n    phys_group_id_323750 = get_group_id(0);\n    for (int32_t i_323751 = 0; i_323751 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * l_n_m_292832,\n                                          squot64(segred_group_sizze_311272,\n                                                  segment_sizze_nonzzero_323739))) -\n                   phys_group_id_323750, sext_i64_i32(num_groups_311273));\n         i_323751++) {\n        int32_t virt_group_id_323752 ",
            "= phys_group_id_323750 + i_323751 *\n                sext_i64_i32(num_groups_311273);\n        int64_t slice_323753 = l_n_m_292832;\n        int64_t slice_323754 = partition_sizze_292766 * slice_323753;\n        int64_t gtid_311277 = squot64(squot64(sext_i32_i64(local_tid_323742),\n                                              segment_sizze_nonzzero_323739) +\n                                      sext_i32_i64(virt_group_id_323752) *\n                                      squot64(segred_group_sizze_311272,\n                                              segment_sizze_nonzzero_323739),\n                                      slice_323753);\n        int64_t remnant_323755 = squot64(sext_i32_i64(local_tid_323742),\n                                         segment_sizze_nonzzero_323739) +\n                sext_i32_i64(virt_group_id_323752) *\n                squot64(segred_group_sizze_311272,\n                        segment_sizze_nonzzero_323739) - gtid_311277 *\n                slice_323753;\n        int64_t gtid_311278 = remnant_323755;\n        int64_t remnant_323756 = remnant_323755 - gtid_311278;\n        int64_t gtid_311279 = srem64(sext_i32_i64(local_tid_323742),\n                                     q_l_292680);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_l_292680) && ((slt64(gtid_311277,\n                                                          partition_sizze_292766) &&\n                                                    slt64(gtid_311278,\n                                                          l_n_m_292832)) &&\n                                                   slt64(sext_i32_i64(local_tid_323742),\n                                                         q_l_292680 *\n                                                         squot64(segred_group_sizze_311272,\n                                                                 segment_sizze_nonzzero_323739)))) {\n                int64_t x_311295;\n                \n                ",
            "x_311295 = ((__global int64_t *) ext_mem_318757)[gtid_311277 *\n                                                                 l_n_m_292832 +\n                                                                 gtid_311278];\n                \n                double x_311296;\n                \n                x_311296 = ((__global double *) ext_mem_318756)[gtid_311277 *\n                                                                l_n_m_292832 +\n                                                                gtid_311278];\n                \n                int64_t binop_y_317907 = mul64(jump_t_292685, gtid_311278);\n                int64_t binop_y_317908 = smin64(i_292846, binop_y_317907);\n                int64_t index_primexp_317909 = add64((int64_t) 1,\n                                                     binop_y_317908);\n                double a11_311298;\n                \n                a11_311298 = ((__global double *) mem_319682)[gtid_311277 *\n                                                              l_n_m_292832 +\n                                                              gtid_311278];\n                \n                double b11_311299;\n                \n                b11_311299 = ((__global double *) mem_319686)[gtid_311277 *\n                                                              l_n_m_292832 +\n                                                              gtid_311278];\n                \n                double c11_311300;\n                \n                c11_311300 = ((__global double *) mem_319690)[gtid_311277 *\n                                                              l_n_m_292832 +\n                                                              gtid_311278];\n                \n                bool cond_311302 = sle64(n_292675, gtid_311279);\n                int64_t defunc_0_f_res_311303;\n                \n                if (cond_311302) {\n                    defunc_0_f_res_311303 = (int64_t) 0;\n                } else {\n                    int64_t i_31",
            "1304 = add64(gtid_311279, x_311295);\n                    int64_t defunc_1_add_res_311305 = add64((int64_t) 1,\n                                                            i_311304);\n                    \n                    defunc_0_f_res_311303 = defunc_1_add_res_311305;\n                }\n                \n                double defunc_0_f_res_311306;\n                \n                if (cond_311302) {\n                    defunc_0_f_res_311306 = 0.0;\n                } else {\n                    int64_t i_311307 = add64(gtid_311279, x_311295);\n                    double defunc_0_add_arg_311308;\n                    \n                    defunc_0_add_arg_311308 = ((__global\n                                                double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                            (gtid_311277 *\n                                                                             ctx_param_ext_318834 +\n                                                                             i_311307 *\n                                                                             ctx_param_ext_318836)];\n                    defunc_0_f_res_311306 = defunc_0_add_arg_311308;\n                }\n                \n                int64_t binop_p_311309 = sub64(defunc_0_f_res_311303,\n                                               index_primexp_317909);\n                double defunc_0_f_res_311310 = sitofp_i64_f64(binop_p_311309);\n                double abs_res_311311 = fabs(defunc_0_f_res_311310);\n                double tmp1_311312 = abs_res_311311 / x_311296;\n                double x_311313 = tmp1_311312 * tmp1_311312;\n                double y_311314 = tmp1_311312 * x_311313;\n                double tmp2_311315 = 1.0 - y_311314;\n                double x_311316 = tmp2_311315 * tmp2_311315;\n                double tmp3_311317 = tmp2_311315 * x_311316;\n                double tmp4_311318 = defunc_0_f_res_311306 * tmp3_311317;\n                doub",
            "le defunc_1_f_res_311319 = defunc_0_f_res_311310 *\n                       tmp4_311318;\n                double defunc_0_f_res_311320;\n                \n                if (cond_311302) {\n                    defunc_0_f_res_311320 = 0.0;\n                } else {\n                    int64_t i_311321 = add64(gtid_311279, x_311295);\n                    double defunc_0_add_arg_311322;\n                    \n                    defunc_0_add_arg_311322 = ((__global\n                                                double *) mem_319555)[gtid_311277 *\n                                                                      n_292675 +\n                                                                      i_311321];\n                    defunc_0_f_res_311320 = defunc_0_add_arg_311322;\n                }\n                \n                double x_311323 = a11_311298 * tmp4_311318;\n                double y_311324 = b11_311299 * defunc_1_f_res_311319;\n                double x_311325 = x_311323 + y_311324;\n                double defunc_9_fit_fun_res_311326 = defunc_0_f_res_311320 *\n                       x_311325;\n                double x_311327 = b11_311299 * tmp4_311318;\n                double y_311328 = c11_311300 * defunc_1_f_res_311319;\n                double x_311329 = x_311327 + y_311328;\n                double defunc_9_slope_fun_res_311330 = defunc_0_f_res_311320 *\n                       x_311329;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_323746)[sext_i32_i64(local_tid_323742)] =\n                        defunc_9_fit_fun_res_311326;\n                    ((__local\n                      double *) red_arr_mem_323748)[sext_i32_i64(local_tid_323742)] =\n                        defunc_9_slope_fun_res_311330;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_323746)[sext_i",
            "32_i64(local_tid_323742)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_323748)[sext_i32_i64(local_tid_323742)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_l_292680)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_311281;\n                double x_311282;\n                double x_311283;\n                double x_311284;\n                double x_323757;\n                double x_323758;\n                double x_323759;\n                double x_323760;\n                bool ltid_in_bounds_323763 =\n                     slt64(sext_i32_i64(local_tid_323742), q_l_292680 *\n                           squot64(segred_group_sizze_311272,\n                                   segment_sizze_nonzzero_323739));\n                int32_t skip_threads_323764;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_323763) {\n                        x_311283 = ((volatile __local\n                                     double *) red_arr_mem_323746)[sext_i32_i64(local_tid_323742)];\n                        x_311284 = ((volatile __local\n                                     double *) red_arr_mem_323748)[sext_i32_i64(local_tid_323742)];\n                        if ((local_tid_323742 - squot32(local_tid_323742, 32) *\n                             32) == 0) {\n                            x_311281 = x_311283;\n                            x_311282 = x_311284;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_323764 = 1;\n                    while (slt32(skip_threads_323764, 32)) {\n                        bool thread_active_323765 = sle32(skip_threads_323764,\n                                                          local_tid_323742 -\n        ",
            "                                                  squot32(local_tid_323742,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_323763;\n                        \n                        if (thread_active_323765) {\n                            // read operands\n                            {\n                                x_311281 = ((volatile __local\n                                             double *) red_arr_mem_323746)[sext_i32_i64(local_tid_323742) -\n                                                                           sext_i32_i64(skip_threads_323764)];\n                                x_311282 = ((volatile __local\n                                             double *) red_arr_mem_323748)[sext_i32_i64(local_tid_323742) -\n                                                                           sext_i32_i64(skip_threads_323764)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_323766 =\n                                 slt64(srem64(sext_i32_i64(local_tid_323742),\n                                              q_l_292680),\n                                       sext_i32_i64(local_tid_323742) -\n                                       sext_i32_i64(local_tid_323742 -\n                                       skip_threads_323764));\n                            \n                            if (thread_active_323765 && inactive_323766) {\n                                x_311281 = x_311283;\n                                x_311282 = x_311284;\n                            }\n                            if (thread_active_323765) {\n                                if (!inactive_323766) {\n                                    double defunc_1_op_res_311285 = x_311281 +\n                                           x_311283;\n                                    double defunc_1_op_res_311286 = x_31128",
            "2 +\n                                           x_311284;\n                                    \n                                    x_311281 = defunc_1_op_res_311285;\n                                    x_311282 = defunc_1_op_res_311286;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_323744, skip_threads_323764)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_323765) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323746)[sext_i32_i64(local_tid_323742)] =\n                                    x_311281;\n                                x_311283 = x_311281;\n                                ((volatile __local\n                                  double *) red_arr_mem_323748)[sext_i32_i64(local_tid_323742)] =\n                                    x_311282;\n                                x_311284 = x_311282;\n                            }\n                        }\n                        if (sle32(wave_sizze_323744, skip_threads_323764)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_323764 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_323742 - squot32(local_tid_323742, 32) *\n                         32) == 31 && ltid_in_bounds_323763) {\n                        ((volatile __local\n                          double *) red_arr_mem_323746)[sext_i32_i64(squot32(local_tid_323742,\n                                                                             32))] =\n                            x_311281;\n                        ((volatile __local\n ",
            "                         double *) red_arr_mem_323748)[sext_i32_i64(squot32(local_tid_323742,\n                                                                             32))] =\n                            x_311282;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_323767;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_323742, 32) == 0 &&\n                            ltid_in_bounds_323763) {\n                            x_323759 = ((volatile __local\n                                         double *) red_arr_mem_323746)[sext_i32_i64(local_tid_323742)];\n                            x_323760 = ((volatile __local\n                                         double *) red_arr_mem_323748)[sext_i32_i64(local_tid_323742)];\n                            if ((local_tid_323742 - squot32(local_tid_323742,\n                                                            32) * 32) == 0) {\n                                x_323757 = x_323759;\n                                x_323758 = x_323760;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_323767 = 1;\n                        while (slt32(skip_threads_323767, 32)) {\n                            bool thread_active_323768 =\n                                 sle32(skip_threads_323767, local_tid_323742 -\n                                       squot32(local_tid_323742, 32) * 32) &&\n                                 (squot32(local_tid_323742, 32) == 0 &&\n                                  ltid_in_bounds_323763);\n                            \n                            if (thread_active_323768) {\n                      ",
            "          // read operands\n                                {\n                                    x_323757 = ((volatile __local\n                                                 double *) red_arr_mem_323746)[sext_i32_i64(local_tid_323742) -\n                                                                               sext_i32_i64(skip_threads_323767)];\n                                    x_323758 = ((volatile __local\n                                                 double *) red_arr_mem_323748)[sext_i32_i64(local_tid_323742) -\n                                                                               sext_i32_i64(skip_threads_323767)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_323769 =\n                                     slt64(srem64(sext_i32_i64(local_tid_323742 *\n                                                  32 + 32 - 1), q_l_292680),\n                                           sext_i32_i64(local_tid_323742 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_323742 -\n                                                         skip_threads_323767) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_323768 && inactive_323769) {\n                                    x_323757 = x_323759;\n                                    x_323758 = x_323760;\n                                }\n                                if (thread_active_323768) {\n                                    if (!inactive_323769) {\n                                        double defunc_1_op_res_323761 =\n                                               x_323757 + x_323759;\n                                        double defunc_1_op_res_323762 =\n                                               x_323758 +",
            " x_323760;\n                                        \n                                        x_323757 = defunc_1_op_res_323761;\n                                        x_323758 = defunc_1_op_res_323762;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_323744, skip_threads_323767)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_323768) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_323746)[sext_i32_i64(local_tid_323742)] =\n                                        x_323757;\n                                    x_323759 = x_323757;\n                                    ((volatile __local\n                                      double *) red_arr_mem_323748)[sext_i32_i64(local_tid_323742)] =\n                                        x_323758;\n                                    x_323760 = x_323758;\n                                }\n                            }\n                            if (sle32(wave_sizze_323744, skip_threads_323767)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_323767 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_323770 = squot32(local_tid_323742, 32) == 0 ||\n                     !ltid_in_bounds_323763;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_323770) {\n                            x_311283 = x_311281;\n                            x_311284 = x_311282;\n        ",
            "                    x_311281 = ((__local\n                                         double *) red_arr_mem_323746)[sext_i32_i64(squot32(local_tid_323742,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_311282 = ((__local\n                                         double *) red_arr_mem_323748)[sext_i32_i64(squot32(local_tid_323742,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_323771 =\n                             slt64(srem64(sext_i32_i64(local_tid_323742),\n                                          q_l_292680),\n                                   sext_i32_i64(local_tid_323742) -\n                                   sext_i32_i64(squot32(local_tid_323742, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_323770) {\n                            if (inactive_323771) {\n                                x_311281 = x_311283;\n                                x_311282 = x_311284;\n                            }\n                        }\n                        if (!no_carry_in_323770) {\n                            if (!inactive_323771) {\n                                double defunc_1_op_res_311285 = x_311281 +\n                                       x_311283;\n                                double defunc_1_op_res_311286 = x_311282 +\n                                       x_311284;\n                                \n                                x_311281 = defunc_1_op_res_311285;\n                                x_311282 = defunc_1_op_res_311286;\n                            }\n     ",
            "                   }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_323770) {\n                            ((__local\n                              double *) red_arr_mem_323746)[sext_i32_i64(local_tid_323742)] =\n                                x_311281;\n                            ((__local\n                              double *) red_arr_mem_323748)[sext_i32_i64(local_tid_323742)] =\n                                x_311282;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_323742, 32) == 0 &&\n                        ltid_in_bounds_323763) {\n                        ((__local\n                          double *) red_arr_mem_323746)[sext_i32_i64(local_tid_323742)] =\n                            x_311283;\n                        ((__local\n                          double *) red_arr_mem_323748)[sext_i32_i64(local_tid_323742)] =\n                            x_311284;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_323752) *\n                      squot64(segred_group_sizze_311272,\n                              segment_sizze_nonzzero_323739) +\n                      sext_i32_i64(local_tid_323742), partition_sizze_292766 *\n                      l_n_m_292832) && slt64(sext_i32_i64(local_tid_323742),\n                                             squot64(segred_group_sizze_311272,\n                                                     segment_sizze_nonzzero_323739))) {\n                double tmp_323772;\n                \n                tmp_323772 = ((__local\n                               double *) red_arr_mem_323746)[(sext_i32_i64(loc",
            "al_tid_323742) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323739 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319695)[squot64(sext_i32_i64(virt_group_id_323752) *\n                                                squot64(segred_group_sizze_311272,\n                                                        segment_sizze_nonzzero_323739) +\n                                                sext_i32_i64(local_tid_323742),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323752) *\n                                         squot64(segred_group_sizze_311272,\n                                                 segment_sizze_nonzzero_323739) +\n                                         sext_i32_i64(local_tid_323742) -\n                                         squot64(sext_i32_i64(virt_group_id_323752) *\n                                                 squot64(segred_group_sizze_311272,\n                                                         segment_sizze_nonzzero_323739) +\n                                                 sext_i32_i64(local_tid_323742),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323772;\n                \n                double tmp_323773;\n                \n                tmp_323773 = ((__local\n                               double *) red_arr_mem_323748)[(sext_i32_i64(local_tid_323742) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323739 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_31",
            "9699)[squot64(sext_i32_i64(virt_group_id_323752) *\n                                                squot64(segred_group_sizze_311272,\n                                                        segment_sizze_nonzzero_323739) +\n                                                sext_i32_i64(local_tid_323742),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323752) *\n                                         squot64(segred_group_sizze_311272,\n                                                 segment_sizze_nonzzero_323739) +\n                                         sext_i32_i64(local_tid_323742) -\n                                         squot64(sext_i32_i64(virt_group_id_323752) *\n                                                 squot64(segred_group_sizze_311272,\n                                                         segment_sizze_nonzzero_323739) +\n                                                 sext_i32_i64(local_tid_323742),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323773;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_311272\n}\n__kernel void mainzisegred_small_311778(__global int *global_failure,\n                                        uint red_arr_mem_323841_backing_offset_0,\n                                        uint red_arr_mem_323839_backing_offset_1,\n                                        uint red_arr_mem_323837_backing_offset_2,\n                                        uint red_arr_mem_323835_backing_offset_3,\n                                        uint red_arr_mem_323833_backing_offset_4,\n                                        int64_t n_292675, int64_t q_l_292680,\n                                        int64_t jump_t_292685,\n               ",
            "                         int64_t partition_sizze_292766,\n                                        int64_t l_n_m_292832, int64_t i_292846,\n                                        int64_t num_groups_311768,\n                                        int64_t ctx_param_ext_318833,\n                                        int64_t ctx_param_ext_318834,\n                                        int64_t ctx_param_ext_318836,\n                                        int64_t segment_sizze_nonzzero_323826,\n                                        __global unsigned char *ext_mem_318756,\n                                        __global unsigned char *ext_mem_318757,\n                                        __global\n                                        unsigned char *mem_param_318838,\n                                        __global unsigned char *mem_319704,\n                                        __global unsigned char *mem_319708,\n                                        __global unsigned char *mem_319712,\n                                        __global unsigned char *mem_319716,\n                                        __global unsigned char *mem_319720)\n{\n    #define segred_group_sizze_311767 (mainzisegred_group_sizze_311489)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_323841_backing_4 =\n                           &shared_mem[red_arr_mem_323841_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323839_backing_3 =\n                           &shared_mem[red_arr_mem_323839_backing_offset_1];\n    volatile unsigned char *red_arr_mem_323837_backing_2 =\n                           &shared_mem[red_arr_mem_323837_backing_offset_2];\n    volatile unsigned char *red_arr_mem_323835_backing_1 =\n                           &shared_mem[red_arr_mem_323835_backing_offset_3];\n    volatile unsigned char *red_arr_mem_323833_backing_0 =\n                           &shared_mem[red_arr_mem_323833_backing_offset_",
            "4];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323828;\n    int32_t local_tid_323829;\n    int64_t group_sizze_323832;\n    int32_t wave_sizze_323831;\n    int32_t group_tid_323830;\n    \n    global_tid_323828 = get_global_id(0);\n    local_tid_323829 = get_local_id(0);\n    group_sizze_323832 = get_local_size(0);\n    wave_sizze_323831 = LOCKSTEP_WIDTH;\n    group_tid_323830 = get_group_id(0);\n    \n    int32_t phys_tid_311778 = global_tid_323828;\n    __local unsigned char *red_arr_mem_323833;\n    \n    red_arr_mem_323833 = (__local unsigned char *) red_arr_mem_323833_backing_0;\n    \n    __local unsigned char *red_arr_mem_323835;\n    \n    red_arr_mem_323835 = (__local unsigned char *) red_arr_mem_323835_backing_1;\n    \n    __local unsigned char *red_arr_mem_323837;\n    \n    red_arr_mem_323837 = (__local unsigned char *) red_arr_mem_323837_backing_2;\n    \n    __local unsigned char *red_arr_mem_323839;\n    \n    red_arr_mem_323839 = (__local unsigned char *) red_arr_mem_323839_backing_3;\n    \n    __local unsigned char *red_arr_mem_323841;\n    \n    red_arr_mem_323841 = (__local unsigned char *) red_arr_mem_323841_backing_4;\n    \n    int32_t phys_group_id_323843;\n    \n    phys_group_id_323843 = get_group_id(0);\n    for (int32_t i_323844 = 0; i_323844 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * l_n_m_292832,\n                                          squot64(segred_group_sizze_311767,\n                                                  segment_sizze_nonzzero_323826))) -\n                   phys_group_id_323843, sext_i64_i32(num_groups_311768));\n         i_323844++) {\n        int32_t virt_group_id_323845 = phys_group_id_323843 + i_323844 *\n                sext_i64_i32(num_groups_311768);\n        int64_t slice_323846 = l_n_m_292832;\n        int64_t slice_323847 = partition_sizze_292766 * slice_323846;\n        int64_t gtid_311775 = squot64(squot64(sext_i32_i64(local_tid_323829),\n                                              segm",
            "ent_sizze_nonzzero_323826) +\n                                      sext_i32_i64(virt_group_id_323845) *\n                                      squot64(segred_group_sizze_311767,\n                                              segment_sizze_nonzzero_323826),\n                                      slice_323846);\n        int64_t remnant_323848 = squot64(sext_i32_i64(local_tid_323829),\n                                         segment_sizze_nonzzero_323826) +\n                sext_i32_i64(virt_group_id_323845) *\n                squot64(segred_group_sizze_311767,\n                        segment_sizze_nonzzero_323826) - gtid_311775 *\n                slice_323846;\n        int64_t gtid_311776 = remnant_323848;\n        int64_t remnant_323849 = remnant_323848 - gtid_311776;\n        int64_t gtid_311777 = srem64(sext_i32_i64(local_tid_323829),\n                                     q_l_292680);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_l_292680) && ((slt64(gtid_311775,\n                                                          partition_sizze_292766) &&\n                                                    slt64(gtid_311776,\n                                                          l_n_m_292832)) &&\n                                                   slt64(sext_i32_i64(local_tid_323829),\n                                                         q_l_292680 *\n                                                         squot64(segred_group_sizze_311767,\n                                                                 segment_sizze_nonzzero_323826)))) {\n                int64_t x_311798;\n                \n                x_311798 = ((__global int64_t *) ext_mem_318757)[gtid_311775 *\n                                                                 l_n_m_292832 +\n                                                                 gtid_311776];\n                \n                double x_311799;\n                \n                x_311799 = ((__global d",
            "ouble *) ext_mem_318756)[gtid_311775 *\n                                                                l_n_m_292832 +\n                                                                gtid_311776];\n                \n                int64_t binop_y_317922 = mul64(jump_t_292685, gtid_311776);\n                int64_t binop_y_317923 = smin64(i_292846, binop_y_317922);\n                int64_t index_primexp_317924 = add64((int64_t) 1,\n                                                     binop_y_317923);\n                bool cond_311802 = sle64(n_292675, gtid_311777);\n                int64_t defunc_0_f_res_311803;\n                \n                if (cond_311802) {\n                    defunc_0_f_res_311803 = (int64_t) 0;\n                } else {\n                    int64_t i_311804 = add64(gtid_311777, x_311798);\n                    int64_t defunc_1_add_res_311805 = add64((int64_t) 1,\n                                                            i_311804);\n                    \n                    defunc_0_f_res_311803 = defunc_1_add_res_311805;\n                }\n                \n                double defunc_0_f_res_311806;\n                \n                if (cond_311802) {\n                    defunc_0_f_res_311806 = 0.0;\n                } else {\n                    int64_t i_311807 = add64(gtid_311777, x_311798);\n                    double defunc_0_add_arg_311808;\n                    \n                    defunc_0_add_arg_311808 = ((__global\n                                                double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                            (gtid_311775 *\n                                                                             ctx_param_ext_318834 +\n                                                                             i_311807 *\n                                                                             ctx_param_ext_318836)];\n                    defunc_0_f_res_311806 = defunc_0_add_arg_31180",
            "8;\n                }\n                \n                int64_t binop_p_311809 = sub64(defunc_0_f_res_311803,\n                                               index_primexp_317924);\n                double defunc_0_f_res_311810 = sitofp_i64_f64(binop_p_311809);\n                double abs_res_311811 = fabs(defunc_0_f_res_311810);\n                double tmp1_311812 = abs_res_311811 / x_311799;\n                double x_311813 = tmp1_311812 * tmp1_311812;\n                double y_311814 = tmp1_311812 * x_311813;\n                double tmp2_311815 = 1.0 - y_311814;\n                double x_311816 = tmp2_311815 * tmp2_311815;\n                double tmp3_311817 = tmp2_311815 * x_311816;\n                double w_j_311818 = defunc_0_f_res_311806 * tmp3_311817;\n                double xw_j_311819 = defunc_0_f_res_311810 * w_j_311818;\n                double x2w_j_311820 = defunc_0_f_res_311810 * xw_j_311819;\n                double x3w_j_311821 = defunc_0_f_res_311810 * x2w_j_311820;\n                double x4w_j_311822 = defunc_0_f_res_311810 * x3w_j_311821;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_323833)[sext_i32_i64(local_tid_323829)] =\n                        w_j_311818;\n                    ((__local\n                      double *) red_arr_mem_323835)[sext_i32_i64(local_tid_323829)] =\n                        xw_j_311819;\n                    ((__local\n                      double *) red_arr_mem_323837)[sext_i32_i64(local_tid_323829)] =\n                        x2w_j_311820;\n                    ((__local\n                      double *) red_arr_mem_323839)[sext_i32_i64(local_tid_323829)] =\n                        x3w_j_311821;\n                    ((__local\n                      double *) red_arr_mem_323841)[sext_i32_i64(local_tid_323829)] =\n                        x4w_j_311822;\n                }\n            } els",
            "e {\n                ((__local\n                  double *) red_arr_mem_323833)[sext_i32_i64(local_tid_323829)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_323835)[sext_i32_i64(local_tid_323829)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_323837)[sext_i32_i64(local_tid_323829)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_323839)[sext_i32_i64(local_tid_323829)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_323841)[sext_i32_i64(local_tid_323829)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_l_292680)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_311779;\n                double x_311780;\n                double x_311781;\n                double x_311782;\n                double x_311783;\n                double x_311784;\n                double x_311785;\n                double x_311786;\n                double x_311787;\n                double x_311788;\n                double x_323850;\n                double x_323851;\n                double x_323852;\n                double x_323853;\n                double x_323854;\n                double x_323855;\n                double x_323856;\n                double x_323857;\n                double x_323858;\n                double x_323859;\n                bool ltid_in_bounds_323865 =\n                     slt64(sext_i32_i64(local_tid_323829), q_l_292680 *\n                           squot64(segred_group_sizze_311767,\n                                   segment_sizze_nonzzero_323826));\n                int32_t skip_threads_323866;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_323865) {\n                        x_311784 = ((volatile __local\n            ",
            "                         double *) red_arr_mem_323833)[sext_i32_i64(local_tid_323829)];\n                        x_311785 = ((volatile __local\n                                     double *) red_arr_mem_323835)[sext_i32_i64(local_tid_323829)];\n                        x_311786 = ((volatile __local\n                                     double *) red_arr_mem_323837)[sext_i32_i64(local_tid_323829)];\n                        x_311787 = ((volatile __local\n                                     double *) red_arr_mem_323839)[sext_i32_i64(local_tid_323829)];\n                        x_311788 = ((volatile __local\n                                     double *) red_arr_mem_323841)[sext_i32_i64(local_tid_323829)];\n                        if ((local_tid_323829 - squot32(local_tid_323829, 32) *\n                             32) == 0) {\n                            x_311779 = x_311784;\n                            x_311780 = x_311785;\n                            x_311781 = x_311786;\n                            x_311782 = x_311787;\n                            x_311783 = x_311788;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_323866 = 1;\n                    while (slt32(skip_threads_323866, 32)) {\n                        bool thread_active_323867 = sle32(skip_threads_323866,\n                                                          local_tid_323829 -\n                                                          squot32(local_tid_323829,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_323865;\n                        \n                        if (thread_active_323867) {\n                            // read operands\n                            {\n                                x_311779 = ((volatile __local\n                                             double *) red_arr_mem_323833)[sext_i32_i64(loc",
            "al_tid_323829) -\n                                                                           sext_i32_i64(skip_threads_323866)];\n                                x_311780 = ((volatile __local\n                                             double *) red_arr_mem_323835)[sext_i32_i64(local_tid_323829) -\n                                                                           sext_i32_i64(skip_threads_323866)];\n                                x_311781 = ((volatile __local\n                                             double *) red_arr_mem_323837)[sext_i32_i64(local_tid_323829) -\n                                                                           sext_i32_i64(skip_threads_323866)];\n                                x_311782 = ((volatile __local\n                                             double *) red_arr_mem_323839)[sext_i32_i64(local_tid_323829) -\n                                                                           sext_i32_i64(skip_threads_323866)];\n                                x_311783 = ((volatile __local\n                                             double *) red_arr_mem_323841)[sext_i32_i64(local_tid_323829) -\n                                                                           sext_i32_i64(skip_threads_323866)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_323868 =\n                                 slt64(srem64(sext_i32_i64(local_tid_323829),\n                                              q_l_292680),\n                                       sext_i32_i64(local_tid_323829) -\n                                       sext_i32_i64(local_tid_323829 -\n                                       skip_threads_323866));\n                            \n                            if (thread_active_323867 && inactive_323868) {\n                                x_311779 = x_311784;\n                                x_311780 = x_311785;\n                  ",
            "              x_311781 = x_311786;\n                                x_311782 = x_311787;\n                                x_311783 = x_311788;\n                            }\n                            if (thread_active_323867) {\n                                if (!inactive_323868) {\n                                    double defunc_1_op_res_311789 = x_311779 +\n                                           x_311784;\n                                    double defunc_1_op_res_311790 = x_311780 +\n                                           x_311785;\n                                    double defunc_1_op_res_311791 = x_311781 +\n                                           x_311786;\n                                    double defunc_1_op_res_311792 = x_311782 +\n                                           x_311787;\n                                    double defunc_1_op_res_311793 = x_311783 +\n                                           x_311788;\n                                    \n                                    x_311779 = defunc_1_op_res_311789;\n                                    x_311780 = defunc_1_op_res_311790;\n                                    x_311781 = defunc_1_op_res_311791;\n                                    x_311782 = defunc_1_op_res_311792;\n                                    x_311783 = defunc_1_op_res_311793;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_323831, skip_threads_323866)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_323867) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323833)[sext_i32_i64(local_tid_323829)] =\n                                    x_311779;\n                                x_311784 = x_311779;\n                                ((volati",
            "le __local\n                                  double *) red_arr_mem_323835)[sext_i32_i64(local_tid_323829)] =\n                                    x_311780;\n                                x_311785 = x_311780;\n                                ((volatile __local\n                                  double *) red_arr_mem_323837)[sext_i32_i64(local_tid_323829)] =\n                                    x_311781;\n                                x_311786 = x_311781;\n                                ((volatile __local\n                                  double *) red_arr_mem_323839)[sext_i32_i64(local_tid_323829)] =\n                                    x_311782;\n                                x_311787 = x_311782;\n                                ((volatile __local\n                                  double *) red_arr_mem_323841)[sext_i32_i64(local_tid_323829)] =\n                                    x_311783;\n                                x_311788 = x_311783;\n                            }\n                        }\n                        if (sle32(wave_sizze_323831, skip_threads_323866)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_323866 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_323829 - squot32(local_tid_323829, 32) *\n                         32) == 31 && ltid_in_bounds_323865) {\n                        ((volatile __local\n                          double *) red_arr_mem_323833)[sext_i32_i64(squot32(local_tid_323829,\n                                                                             32))] =\n                            x_311779;\n                        ((volatile __local\n                          double *) red_arr_mem_323835)[sext_i32_i64(squot32(local_tid_323829,\n                                                               ",
            "              32))] =\n                            x_311780;\n                        ((volatile __local\n                          double *) red_arr_mem_323837)[sext_i32_i64(squot32(local_tid_323829,\n                                                                             32))] =\n                            x_311781;\n                        ((volatile __local\n                          double *) red_arr_mem_323839)[sext_i32_i64(squot32(local_tid_323829,\n                                                                             32))] =\n                            x_311782;\n                        ((volatile __local\n                          double *) red_arr_mem_323841)[sext_i32_i64(squot32(local_tid_323829,\n                                                                             32))] =\n                            x_311783;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_323869;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_323829, 32) == 0 &&\n                            ltid_in_bounds_323865) {\n                            x_323855 = ((volatile __local\n                                         double *) red_arr_mem_323833)[sext_i32_i64(local_tid_323829)];\n                            x_323856 = ((volatile __local\n                                         double *) red_arr_mem_323835)[sext_i32_i64(local_tid_323829)];\n                            x_323857 = ((volatile __local\n                                         double *) red_arr_mem_323837)[sext_i32_i64(local_tid_323829)];\n                            x_323858 = ((volatile __local\n                                         double *) red_arr_mem_323839)[sext_i32_i64(local_tid_323829)];\n                            x_323859 = ((vol",
            "atile __local\n                                         double *) red_arr_mem_323841)[sext_i32_i64(local_tid_323829)];\n                            if ((local_tid_323829 - squot32(local_tid_323829,\n                                                            32) * 32) == 0) {\n                                x_323850 = x_323855;\n                                x_323851 = x_323856;\n                                x_323852 = x_323857;\n                                x_323853 = x_323858;\n                                x_323854 = x_323859;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_323869 = 1;\n                        while (slt32(skip_threads_323869, 32)) {\n                            bool thread_active_323870 =\n                                 sle32(skip_threads_323869, local_tid_323829 -\n                                       squot32(local_tid_323829, 32) * 32) &&\n                                 (squot32(local_tid_323829, 32) == 0 &&\n                                  ltid_in_bounds_323865);\n                            \n                            if (thread_active_323870) {\n                                // read operands\n                                {\n                                    x_323850 = ((volatile __local\n                                                 double *) red_arr_mem_323833)[sext_i32_i64(local_tid_323829) -\n                                                                               sext_i32_i64(skip_threads_323869)];\n                                    x_323851 = ((volatile __local\n                                                 double *) red_arr_mem_323835)[sext_i32_i64(local_tid_323829) -\n                                                                               sext_i32_i64(skip_threads_323869)];\n                                    x_323852 = ((volatile __local\n                ",
            "                                 double *) red_arr_mem_323837)[sext_i32_i64(local_tid_323829) -\n                                                                               sext_i32_i64(skip_threads_323869)];\n                                    x_323853 = ((volatile __local\n                                                 double *) red_arr_mem_323839)[sext_i32_i64(local_tid_323829) -\n                                                                               sext_i32_i64(skip_threads_323869)];\n                                    x_323854 = ((volatile __local\n                                                 double *) red_arr_mem_323841)[sext_i32_i64(local_tid_323829) -\n                                                                               sext_i32_i64(skip_threads_323869)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_323871 =\n                                     slt64(srem64(sext_i32_i64(local_tid_323829 *\n                                                  32 + 32 - 1), q_l_292680),\n                                           sext_i32_i64(local_tid_323829 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_323829 -\n                                                         skip_threads_323869) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_323870 && inactive_323871) {\n                                    x_323850 = x_323855;\n                                    x_323851 = x_323856;\n                                    x_323852 = x_323857;\n                                    x_323853 = x_323858;\n                                    x_323854 = x_323859;\n                                }\n                                if (thread_active_323870) {\n        ",
            "                            if (!inactive_323871) {\n                                        double defunc_1_op_res_323860 =\n                                               x_323850 + x_323855;\n                                        double defunc_1_op_res_323861 =\n                                               x_323851 + x_323856;\n                                        double defunc_1_op_res_323862 =\n                                               x_323852 + x_323857;\n                                        double defunc_1_op_res_323863 =\n                                               x_323853 + x_323858;\n                                        double defunc_1_op_res_323864 =\n                                               x_323854 + x_323859;\n                                        \n                                        x_323850 = defunc_1_op_res_323860;\n                                        x_323851 = defunc_1_op_res_323861;\n                                        x_323852 = defunc_1_op_res_323862;\n                                        x_323853 = defunc_1_op_res_323863;\n                                        x_323854 = defunc_1_op_res_323864;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_323831, skip_threads_323869)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_323870) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_323833)[sext_i32_i64(local_tid_323829)] =\n                                        x_323850;\n                                    x_323855 = x_323850;\n                                    ((volatile __local\n                                      double *) red_arr_mem_323835)[sext_i32_i64(local_tid_323829)] ",
            "=\n                                        x_323851;\n                                    x_323856 = x_323851;\n                                    ((volatile __local\n                                      double *) red_arr_mem_323837)[sext_i32_i64(local_tid_323829)] =\n                                        x_323852;\n                                    x_323857 = x_323852;\n                                    ((volatile __local\n                                      double *) red_arr_mem_323839)[sext_i32_i64(local_tid_323829)] =\n                                        x_323853;\n                                    x_323858 = x_323853;\n                                    ((volatile __local\n                                      double *) red_arr_mem_323841)[sext_i32_i64(local_tid_323829)] =\n                                        x_323854;\n                                    x_323859 = x_323854;\n                                }\n                            }\n                            if (sle32(wave_sizze_323831, skip_threads_323869)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_323869 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_323872 = squot32(local_tid_323829, 32) == 0 ||\n                     !ltid_in_bounds_323865;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_323872) {\n                            x_311784 = x_311779;\n                            x_311785 = x_311780;\n                            x_311786 = x_311781;\n                            x_311787 = x_311782;\n                            x_311788 = x_311783;\n                            x_311779 = ((__local\n                                         double *) red",
            "_arr_mem_323833)[sext_i32_i64(squot32(local_tid_323829,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_311780 = ((__local\n                                         double *) red_arr_mem_323835)[sext_i32_i64(squot32(local_tid_323829,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_311781 = ((__local\n                                         double *) red_arr_mem_323837)[sext_i32_i64(squot32(local_tid_323829,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_311782 = ((__local\n                                         double *) red_arr_mem_323839)[sext_i32_i64(squot32(local_tid_323829,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_311783 = ((__local\n                                         double *) red_arr_mem_323841)[sext_i32_i64(squot32(local_tid_323829,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_323873 =\n                             slt64(srem64(sext_i32_i64(local_tid_323829),\n                                          q_l_292680),\n                                   sext_i32_i64(local_tid_323829) -\n                                 ",
            "  sext_i32_i64(squot32(local_tid_323829, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_323872) {\n                            if (inactive_323873) {\n                                x_311779 = x_311784;\n                                x_311780 = x_311785;\n                                x_311781 = x_311786;\n                                x_311782 = x_311787;\n                                x_311783 = x_311788;\n                            }\n                        }\n                        if (!no_carry_in_323872) {\n                            if (!inactive_323873) {\n                                double defunc_1_op_res_311789 = x_311779 +\n                                       x_311784;\n                                double defunc_1_op_res_311790 = x_311780 +\n                                       x_311785;\n                                double defunc_1_op_res_311791 = x_311781 +\n                                       x_311786;\n                                double defunc_1_op_res_311792 = x_311782 +\n                                       x_311787;\n                                double defunc_1_op_res_311793 = x_311783 +\n                                       x_311788;\n                                \n                                x_311779 = defunc_1_op_res_311789;\n                                x_311780 = defunc_1_op_res_311790;\n                                x_311781 = defunc_1_op_res_311791;\n                                x_311782 = defunc_1_op_res_311792;\n                                x_311783 = defunc_1_op_res_311793;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_323872) {\n                            ((__local\n                              double *) red_arr_mem_323833)[sext_i32_i64(local_tid_323829)] =\n                                x_311779;\n  ",
            "                          ((__local\n                              double *) red_arr_mem_323835)[sext_i32_i64(local_tid_323829)] =\n                                x_311780;\n                            ((__local\n                              double *) red_arr_mem_323837)[sext_i32_i64(local_tid_323829)] =\n                                x_311781;\n                            ((__local\n                              double *) red_arr_mem_323839)[sext_i32_i64(local_tid_323829)] =\n                                x_311782;\n                            ((__local\n                              double *) red_arr_mem_323841)[sext_i32_i64(local_tid_323829)] =\n                                x_311783;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_323829, 32) == 0 &&\n                        ltid_in_bounds_323865) {\n                        ((__local\n                          double *) red_arr_mem_323833)[sext_i32_i64(local_tid_323829)] =\n                            x_311784;\n                        ((__local\n                          double *) red_arr_mem_323835)[sext_i32_i64(local_tid_323829)] =\n                            x_311785;\n                        ((__local\n                          double *) red_arr_mem_323837)[sext_i32_i64(local_tid_323829)] =\n                            x_311786;\n                        ((__local\n                          double *) red_arr_mem_323839)[sext_i32_i64(local_tid_323829)] =\n                            x_311787;\n                        ((__local\n                          double *) red_arr_mem_323841)[sext_i32_i64(local_tid_323829)] =\n                            x_311788;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        ",
            "{\n            if (slt64(sext_i32_i64(virt_group_id_323845) *\n                      squot64(segred_group_sizze_311767,\n                              segment_sizze_nonzzero_323826) +\n                      sext_i32_i64(local_tid_323829), partition_sizze_292766 *\n                      l_n_m_292832) && slt64(sext_i32_i64(local_tid_323829),\n                                             squot64(segred_group_sizze_311767,\n                                                     segment_sizze_nonzzero_323826))) {\n                double tmp_323874;\n                \n                tmp_323874 = ((__local\n                               double *) red_arr_mem_323833)[(sext_i32_i64(local_tid_323829) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323826 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319704)[squot64(sext_i32_i64(virt_group_id_323845) *\n                                                squot64(segred_group_sizze_311767,\n                                                        segment_sizze_nonzzero_323826) +\n                                                sext_i32_i64(local_tid_323829),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323845) *\n                                         squot64(segred_group_sizze_311767,\n                                                 segment_sizze_nonzzero_323826) +\n                                         sext_i32_i64(local_tid_323829) -\n                                         squot64(sext_i32_i64(virt_group_id_323845) *\n                                                 squot64(segred_group_sizze_311767,\n                                                         segment_sizze_nonzzero_323826) +\n                                                 se",
            "xt_i32_i64(local_tid_323829),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323874;\n                \n                double tmp_323875;\n                \n                tmp_323875 = ((__local\n                               double *) red_arr_mem_323835)[(sext_i32_i64(local_tid_323829) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323826 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319708)[squot64(sext_i32_i64(virt_group_id_323845) *\n                                                squot64(segred_group_sizze_311767,\n                                                        segment_sizze_nonzzero_323826) +\n                                                sext_i32_i64(local_tid_323829),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323845) *\n                                         squot64(segred_group_sizze_311767,\n                                                 segment_sizze_nonzzero_323826) +\n                                         sext_i32_i64(local_tid_323829) -\n                                         squot64(sext_i32_i64(virt_group_id_323845) *\n                                                 squot64(segred_group_sizze_311767,\n                                                         segment_sizze_nonzzero_323826) +\n                                                 sext_i32_i64(local_tid_323829),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323875;\n                \n                double tmp_323876;\n                \n                tmp_323876 = ((__local\n                               double *) red_arr_m",
            "em_323837)[(sext_i32_i64(local_tid_323829) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323826 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319712)[squot64(sext_i32_i64(virt_group_id_323845) *\n                                                squot64(segred_group_sizze_311767,\n                                                        segment_sizze_nonzzero_323826) +\n                                                sext_i32_i64(local_tid_323829),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323845) *\n                                         squot64(segred_group_sizze_311767,\n                                                 segment_sizze_nonzzero_323826) +\n                                         sext_i32_i64(local_tid_323829) -\n                                         squot64(sext_i32_i64(virt_group_id_323845) *\n                                                 squot64(segred_group_sizze_311767,\n                                                         segment_sizze_nonzzero_323826) +\n                                                 sext_i32_i64(local_tid_323829),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323876;\n                \n                double tmp_323877;\n                \n                tmp_323877 = ((__local\n                               double *) red_arr_mem_323839)[(sext_i32_i64(local_tid_323829) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323826 -\n                                                             (int64_t) 1];\n                ((__global\n      ",
            "            double *) mem_319716)[squot64(sext_i32_i64(virt_group_id_323845) *\n                                                squot64(segred_group_sizze_311767,\n                                                        segment_sizze_nonzzero_323826) +\n                                                sext_i32_i64(local_tid_323829),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323845) *\n                                         squot64(segred_group_sizze_311767,\n                                                 segment_sizze_nonzzero_323826) +\n                                         sext_i32_i64(local_tid_323829) -\n                                         squot64(sext_i32_i64(virt_group_id_323845) *\n                                                 squot64(segred_group_sizze_311767,\n                                                         segment_sizze_nonzzero_323826) +\n                                                 sext_i32_i64(local_tid_323829),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323877;\n                \n                double tmp_323878;\n                \n                tmp_323878 = ((__local\n                               double *) red_arr_mem_323841)[(sext_i32_i64(local_tid_323829) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323826 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319720)[squot64(sext_i32_i64(virt_group_id_323845) *\n                                                squot64(segred_group_sizze_311767,\n                                                        segment_sizze_nonzzero_323826) +\n                                                sext_i32_i64(local_tid_3",
            "23829),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323845) *\n                                         squot64(segred_group_sizze_311767,\n                                                 segment_sizze_nonzzero_323826) +\n                                         sext_i32_i64(local_tid_323829) -\n                                         squot64(sext_i32_i64(virt_group_id_323845) *\n                                                 squot64(segred_group_sizze_311767,\n                                                         segment_sizze_nonzzero_323826) +\n                                                 sext_i32_i64(local_tid_323829),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323878;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_311767\n}\n__kernel void mainzisegred_small_311881(__global int *global_failure,\n                                        uint red_arr_mem_323974_backing_offset_0,\n                                        uint red_arr_mem_323972_backing_offset_1,\n                                        int64_t n_292675, int64_t q_l_292680,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t l_n_m_292832, int64_t i_292846,\n                                        int64_t num_groups_311874,\n                                        int64_t ctx_param_ext_318833,\n                                        int64_t ctx_param_ext_318834,\n                                        int64_t ctx_param_ext_318836,\n                                        int64_t segment_sizze_nonzzero_323965,\n                                        __global",
            " unsigned char *ext_mem_318756,\n                                        __global unsigned char *ext_mem_318757,\n                                        __global\n                                        unsigned char *mem_param_318838,\n                                        __global unsigned char *mem_319555,\n                                        __global unsigned char *mem_319725,\n                                        __global unsigned char *mem_319729,\n                                        __global unsigned char *mem_319733,\n                                        __global unsigned char *mem_319737,\n                                        __global unsigned char *mem_319741,\n                                        __global unsigned char *mem_319746,\n                                        __global unsigned char *mem_319750)\n{\n    #define segred_group_sizze_311873 (mainzisegred_group_sizze_311358)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_323974_backing_1 =\n                           &shared_mem[red_arr_mem_323974_backing_offset_0];\n    volatile unsigned char *red_arr_mem_323972_backing_0 =\n                           &shared_mem[red_arr_mem_323972_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_323967;\n    int32_t local_tid_323968;\n    int64_t group_sizze_323971;\n    int32_t wave_sizze_323970;\n    int32_t group_tid_323969;\n    \n    global_tid_323967 = get_global_id(0);\n    local_tid_323968 = get_local_id(0);\n    group_sizze_323971 = get_local_size(0);\n    wave_sizze_323970 = LOCKSTEP_WIDTH;\n    group_tid_323969 = get_group_id(0);\n    \n    int32_t phys_tid_311881 = global_tid_323967;\n    __local unsigned char *red_arr_mem_323972;\n    \n    red_arr_mem_323972 = (__local unsigned char *) red_arr_mem_323972_backing_0;\n    \n    __local unsigned char *red_arr_mem_323974;\n    \n    red_arr_mem_323974 = (__local unsigned char *) r",
            "ed_arr_mem_323974_backing_1;\n    \n    int32_t phys_group_id_323976;\n    \n    phys_group_id_323976 = get_group_id(0);\n    for (int32_t i_323977 = 0; i_323977 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * l_n_m_292832,\n                                          squot64(segred_group_sizze_311873,\n                                                  segment_sizze_nonzzero_323965))) -\n                   phys_group_id_323976, sext_i64_i32(num_groups_311874));\n         i_323977++) {\n        int32_t virt_group_id_323978 = phys_group_id_323976 + i_323977 *\n                sext_i64_i32(num_groups_311874);\n        int64_t slice_323979 = l_n_m_292832;\n        int64_t slice_323980 = partition_sizze_292766 * slice_323979;\n        int64_t gtid_311878 = squot64(squot64(sext_i32_i64(local_tid_323968),\n                                              segment_sizze_nonzzero_323965) +\n                                      sext_i32_i64(virt_group_id_323978) *\n                                      squot64(segred_group_sizze_311873,\n                                              segment_sizze_nonzzero_323965),\n                                      slice_323979);\n        int64_t remnant_323981 = squot64(sext_i32_i64(local_tid_323968),\n                                         segment_sizze_nonzzero_323965) +\n                sext_i32_i64(virt_group_id_323978) *\n                squot64(segred_group_sizze_311873,\n                        segment_sizze_nonzzero_323965) - gtid_311878 *\n                slice_323979;\n        int64_t gtid_311879 = remnant_323981;\n        int64_t remnant_323982 = remnant_323981 - gtid_311879;\n        int64_t gtid_311880 = srem64(sext_i32_i64(local_tid_323968),\n                                     q_l_292680);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_l_292680) && ((slt64(gtid_311878,\n                                                          partition_sizze_292766) &&\n                             ",
            "                       slt64(gtid_311879,\n                                                          l_n_m_292832)) &&\n                                                   slt64(sext_i32_i64(local_tid_323968),\n                                                         q_l_292680 *\n                                                         squot64(segred_group_sizze_311873,\n                                                                 segment_sizze_nonzzero_323965)))) {\n                int64_t x_311898;\n                \n                x_311898 = ((__global int64_t *) ext_mem_318757)[gtid_311878 *\n                                                                 l_n_m_292832 +\n                                                                 gtid_311879];\n                \n                double x_311899;\n                \n                x_311899 = ((__global double *) ext_mem_318756)[gtid_311878 *\n                                                                l_n_m_292832 +\n                                                                gtid_311879];\n                \n                int64_t binop_y_317917 = mul64(jump_t_292685, gtid_311879);\n                int64_t binop_y_317918 = smin64(i_292846, binop_y_317917);\n                int64_t index_primexp_317919 = add64((int64_t) 1,\n                                                     binop_y_317918);\n                double a12_311901;\n                \n                a12_311901 = ((__global double *) mem_319725)[gtid_311878 *\n                                                              l_n_m_292832 +\n                                                              gtid_311879];\n                \n                double b12_311902;\n                \n                b12_311902 = ((__global double *) mem_319729)[gtid_311878 *\n                                                              l_n_m_292832 +\n                                                              gtid_311879];\n                \n                double c12_311903;\n    ",
            "            \n                c12_311903 = ((__global double *) mem_319733)[gtid_311878 *\n                                                              l_n_m_292832 +\n                                                              gtid_311879];\n                \n                double b2_311904;\n                \n                b2_311904 = ((__global double *) mem_319737)[gtid_311878 *\n                                                             l_n_m_292832 +\n                                                             gtid_311879];\n                \n                double c2_311905;\n                \n                c2_311905 = ((__global double *) mem_319741)[gtid_311878 *\n                                                             l_n_m_292832 +\n                                                             gtid_311879];\n                \n                bool cond_311907 = sle64(n_292675, gtid_311880);\n                int64_t defunc_0_f_res_311908;\n                \n                if (cond_311907) {\n                    defunc_0_f_res_311908 = (int64_t) 0;\n                } else {\n                    int64_t i_311909 = add64(gtid_311880, x_311898);\n                    int64_t defunc_1_add_res_311910 = add64((int64_t) 1,\n                                                            i_311909);\n                    \n                    defunc_0_f_res_311908 = defunc_1_add_res_311910;\n                }\n                \n                double defunc_0_f_res_311911;\n                \n                if (cond_311907) {\n                    defunc_0_f_res_311911 = 0.0;\n                } else {\n                    int64_t i_311912 = add64(gtid_311880, x_311898);\n                    double defunc_0_add_arg_311913;\n                    \n                    defunc_0_add_arg_311913 = ((__global\n                                                double *) mem_param_318838)[ctx_param_ext_318833 +\n                                                                            (gtid_311878 *\n        ",
            "                                                                     ctx_param_ext_318834 +\n                                                                             i_311912 *\n                                                                             ctx_param_ext_318836)];\n                    defunc_0_f_res_311911 = defunc_0_add_arg_311913;\n                }\n                \n                int64_t binop_p_311914 = sub64(defunc_0_f_res_311908,\n                                               index_primexp_317919);\n                double defunc_0_f_res_311915 = sitofp_i64_f64(binop_p_311914);\n                double abs_res_311916 = fabs(defunc_0_f_res_311915);\n                double tmp1_311917 = abs_res_311916 / x_311899;\n                double x_311918 = tmp1_311917 * tmp1_311917;\n                double y_311919 = tmp1_311917 * x_311918;\n                double tmp2_311920 = 1.0 - y_311919;\n                double x_311921 = tmp2_311920 * tmp2_311920;\n                double tmp3_311922 = tmp2_311920 * x_311921;\n                double tmp4_311923 = defunc_0_f_res_311911 * tmp3_311922;\n                double defunc_1_f_res_311924 = defunc_0_f_res_311915 *\n                       tmp4_311923;\n                double defunc_1_f_res_311925 = defunc_0_f_res_311915 *\n                       defunc_1_f_res_311924;\n                double defunc_0_f_res_311926;\n                \n                if (cond_311907) {\n                    defunc_0_f_res_311926 = 0.0;\n                } else {\n                    int64_t i_311927 = add64(gtid_311880, x_311898);\n                    double defunc_0_add_arg_311928;\n                    \n                    defunc_0_add_arg_311928 = ((__global\n                                                double *) mem_319555)[gtid_311878 *\n                                                                      n_292675 +\n                                                                      i_311927];\n                    defunc_0_f_res_311926 = defunc_0_a",
            "dd_arg_311928;\n                }\n                \n                double x_311929 = a12_311901 * tmp4_311923;\n                double y_311930 = b12_311902 * defunc_1_f_res_311924;\n                double x_311931 = x_311929 + y_311930;\n                double y_311932 = c12_311903 * defunc_1_f_res_311925;\n                double x_311933 = x_311931 + y_311932;\n                double defunc_9_fit_fun_res_311934 = defunc_0_f_res_311926 *\n                       x_311933;\n                double x_311935 = b12_311902 * tmp4_311923;\n                double y_311936 = b2_311904 * defunc_1_f_res_311924;\n                double x_311937 = x_311935 + y_311936;\n                double y_311938 = c2_311905 * defunc_1_f_res_311925;\n                double x_311939 = x_311937 + y_311938;\n                double defunc_9_slope_fun_res_311940 = defunc_0_f_res_311926 *\n                       x_311939;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_323972)[sext_i32_i64(local_tid_323968)] =\n                        defunc_9_fit_fun_res_311934;\n                    ((__local\n                      double *) red_arr_mem_323974)[sext_i32_i64(local_tid_323968)] =\n                        defunc_9_slope_fun_res_311940;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_323972)[sext_i32_i64(local_tid_323968)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_323974)[sext_i32_i64(local_tid_323968)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_l_292680)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_311882;\n                double x_311883;\n                double x_311884;\n                double x_311885;\n           ",
            "     double x_323983;\n                double x_323984;\n                double x_323985;\n                double x_323986;\n                bool ltid_in_bounds_323989 =\n                     slt64(sext_i32_i64(local_tid_323968), q_l_292680 *\n                           squot64(segred_group_sizze_311873,\n                                   segment_sizze_nonzzero_323965));\n                int32_t skip_threads_323990;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_323989) {\n                        x_311884 = ((volatile __local\n                                     double *) red_arr_mem_323972)[sext_i32_i64(local_tid_323968)];\n                        x_311885 = ((volatile __local\n                                     double *) red_arr_mem_323974)[sext_i32_i64(local_tid_323968)];\n                        if ((local_tid_323968 - squot32(local_tid_323968, 32) *\n                             32) == 0) {\n                            x_311882 = x_311884;\n                            x_311883 = x_311885;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_323990 = 1;\n                    while (slt32(skip_threads_323990, 32)) {\n                        bool thread_active_323991 = sle32(skip_threads_323990,\n                                                          local_tid_323968 -\n                                                          squot32(local_tid_323968,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_323989;\n                        \n                        if (thread_active_323991) {\n                            // read operands\n                            {\n                                x_311882 = ((volatile __local\n                                             double *) red_arr_mem_323972)[sext_i32_i64(l",
            "ocal_tid_323968) -\n                                                                           sext_i32_i64(skip_threads_323990)];\n                                x_311883 = ((volatile __local\n                                             double *) red_arr_mem_323974)[sext_i32_i64(local_tid_323968) -\n                                                                           sext_i32_i64(skip_threads_323990)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_323992 =\n                                 slt64(srem64(sext_i32_i64(local_tid_323968),\n                                              q_l_292680),\n                                       sext_i32_i64(local_tid_323968) -\n                                       sext_i32_i64(local_tid_323968 -\n                                       skip_threads_323990));\n                            \n                            if (thread_active_323991 && inactive_323992) {\n                                x_311882 = x_311884;\n                                x_311883 = x_311885;\n                            }\n                            if (thread_active_323991) {\n                                if (!inactive_323992) {\n                                    double defunc_1_op_res_311886 = x_311882 +\n                                           x_311884;\n                                    double defunc_1_op_res_311887 = x_311883 +\n                                           x_311885;\n                                    \n                                    x_311882 = defunc_1_op_res_311886;\n                                    x_311883 = defunc_1_op_res_311887;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_323970, skip_threads_323990)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                       ",
            " if (thread_active_323991) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_323972)[sext_i32_i64(local_tid_323968)] =\n                                    x_311882;\n                                x_311884 = x_311882;\n                                ((volatile __local\n                                  double *) red_arr_mem_323974)[sext_i32_i64(local_tid_323968)] =\n                                    x_311883;\n                                x_311885 = x_311883;\n                            }\n                        }\n                        if (sle32(wave_sizze_323970, skip_threads_323990)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_323990 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_323968 - squot32(local_tid_323968, 32) *\n                         32) == 31 && ltid_in_bounds_323989) {\n                        ((volatile __local\n                          double *) red_arr_mem_323972)[sext_i32_i64(squot32(local_tid_323968,\n                                                                             32))] =\n                            x_311882;\n                        ((volatile __local\n                          double *) red_arr_mem_323974)[sext_i32_i64(squot32(local_tid_323968,\n                                                                             32))] =\n                            x_311883;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_323993;\n                    \n                    /",
            "/ read input for in-block scan\n                    {\n                        if (squot32(local_tid_323968, 32) == 0 &&\n                            ltid_in_bounds_323989) {\n                            x_323985 = ((volatile __local\n                                         double *) red_arr_mem_323972)[sext_i32_i64(local_tid_323968)];\n                            x_323986 = ((volatile __local\n                                         double *) red_arr_mem_323974)[sext_i32_i64(local_tid_323968)];\n                            if ((local_tid_323968 - squot32(local_tid_323968,\n                                                            32) * 32) == 0) {\n                                x_323983 = x_323985;\n                                x_323984 = x_323986;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_323993 = 1;\n                        while (slt32(skip_threads_323993, 32)) {\n                            bool thread_active_323994 =\n                                 sle32(skip_threads_323993, local_tid_323968 -\n                                       squot32(local_tid_323968, 32) * 32) &&\n                                 (squot32(local_tid_323968, 32) == 0 &&\n                                  ltid_in_bounds_323989);\n                            \n                            if (thread_active_323994) {\n                                // read operands\n                                {\n                                    x_323983 = ((volatile __local\n                                                 double *) red_arr_mem_323972)[sext_i32_i64(local_tid_323968) -\n                                                                               sext_i32_i64(skip_threads_323993)];\n                                    x_323984 = ((volatile __local\n                                                 double *) red_arr_mem_323974)[sext_i32_i6",
            "4(local_tid_323968) -\n                                                                               sext_i32_i64(skip_threads_323993)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_323995 =\n                                     slt64(srem64(sext_i32_i64(local_tid_323968 *\n                                                  32 + 32 - 1), q_l_292680),\n                                           sext_i32_i64(local_tid_323968 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_323968 -\n                                                         skip_threads_323993) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_323994 && inactive_323995) {\n                                    x_323983 = x_323985;\n                                    x_323984 = x_323986;\n                                }\n                                if (thread_active_323994) {\n                                    if (!inactive_323995) {\n                                        double defunc_1_op_res_323987 =\n                                               x_323983 + x_323985;\n                                        double defunc_1_op_res_323988 =\n                                               x_323984 + x_323986;\n                                        \n                                        x_323983 = defunc_1_op_res_323987;\n                                        x_323984 = defunc_1_op_res_323988;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_323970, skip_threads_323993)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (t",
            "hread_active_323994) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_323972)[sext_i32_i64(local_tid_323968)] =\n                                        x_323983;\n                                    x_323985 = x_323983;\n                                    ((volatile __local\n                                      double *) red_arr_mem_323974)[sext_i32_i64(local_tid_323968)] =\n                                        x_323984;\n                                    x_323986 = x_323984;\n                                }\n                            }\n                            if (sle32(wave_sizze_323970, skip_threads_323993)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_323993 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_323996 = squot32(local_tid_323968, 32) == 0 ||\n                     !ltid_in_bounds_323989;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_323996) {\n                            x_311884 = x_311882;\n                            x_311885 = x_311883;\n                            x_311882 = ((__local\n                                         double *) red_arr_mem_323972)[sext_i32_i64(squot32(local_tid_323968,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_311883 = ((__local\n                                         double *) red_arr_mem_323974)[sext_i32_i64(squot32(local_tid_323968,\n                ",
            "                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_323997 =\n                             slt64(srem64(sext_i32_i64(local_tid_323968),\n                                          q_l_292680),\n                                   sext_i32_i64(local_tid_323968) -\n                                   sext_i32_i64(squot32(local_tid_323968, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_323996) {\n                            if (inactive_323997) {\n                                x_311882 = x_311884;\n                                x_311883 = x_311885;\n                            }\n                        }\n                        if (!no_carry_in_323996) {\n                            if (!inactive_323997) {\n                                double defunc_1_op_res_311886 = x_311882 +\n                                       x_311884;\n                                double defunc_1_op_res_311887 = x_311883 +\n                                       x_311885;\n                                \n                                x_311882 = defunc_1_op_res_311886;\n                                x_311883 = defunc_1_op_res_311887;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_323996) {\n                            ((__local\n                              double *) red_arr_mem_323972)[sext_i32_i64(local_tid_323968)] =\n                                x_311882;\n                            ((__local\n                              double *) red_arr_mem_323974)[sext_i32_i64(local_tid_323968)] =\n                                x_311883;\n    ",
            "                    }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_323968, 32) == 0 &&\n                        ltid_in_bounds_323989) {\n                        ((__local\n                          double *) red_arr_mem_323972)[sext_i32_i64(local_tid_323968)] =\n                            x_311884;\n                        ((__local\n                          double *) red_arr_mem_323974)[sext_i32_i64(local_tid_323968)] =\n                            x_311885;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_323978) *\n                      squot64(segred_group_sizze_311873,\n                              segment_sizze_nonzzero_323965) +\n                      sext_i32_i64(local_tid_323968), partition_sizze_292766 *\n                      l_n_m_292832) && slt64(sext_i32_i64(local_tid_323968),\n                                             squot64(segred_group_sizze_311873,\n                                                     segment_sizze_nonzzero_323965))) {\n                double tmp_323998;\n                \n                tmp_323998 = ((__local\n                               double *) red_arr_mem_323972)[(sext_i32_i64(local_tid_323968) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323965 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319746)[squot64(sext_i32_i64(virt_group_id_323978) *\n                                                squot64(segred_group_sizze_311873,\n                                                     ",
            "   segment_sizze_nonzzero_323965) +\n                                                sext_i32_i64(local_tid_323968),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323978) *\n                                         squot64(segred_group_sizze_311873,\n                                                 segment_sizze_nonzzero_323965) +\n                                         sext_i32_i64(local_tid_323968) -\n                                         squot64(sext_i32_i64(virt_group_id_323978) *\n                                                 squot64(segred_group_sizze_311873,\n                                                         segment_sizze_nonzzero_323965) +\n                                                 sext_i32_i64(local_tid_323968),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323998;\n                \n                double tmp_323999;\n                \n                tmp_323999 = ((__local\n                               double *) red_arr_mem_323974)[(sext_i32_i64(local_tid_323968) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_323965 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319750)[squot64(sext_i32_i64(virt_group_id_323978) *\n                                                squot64(segred_group_sizze_311873,\n                                                        segment_sizze_nonzzero_323965) +\n                                                sext_i32_i64(local_tid_323968),\n                                                l_n_m_292832) * l_n_m_292832 +\n                                        (sext_i32_i64(virt_group_id_323978) *\n                                         squot64(s",
            "egred_group_sizze_311873,\n                                                 segment_sizze_nonzzero_323965) +\n                                         sext_i32_i64(local_tid_323968) -\n                                         squot64(sext_i32_i64(virt_group_id_323978) *\n                                                 squot64(segred_group_sizze_311873,\n                                                         segment_sizze_nonzzero_323965) +\n                                                 sext_i32_i64(local_tid_323968),\n                                                 l_n_m_292832) *\n                                         l_n_m_292832)] = tmp_323999;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_311873\n}\n__kernel void mainzisegred_small_314793(__global int *global_failure,\n                                        uint red_arr_mem_324342_backing_offset_0,\n                                        int64_t n_292675, int64_t q_t_292679,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t t_n_m_292839, int64_t i_292846,\n                                        int64_t num_groups_314787,\n                                        int64_t segment_sizze_nonzzero_324335,\n                                        __global unsigned char *ext_mem_318541,\n                                        __global unsigned char *ext_mem_318542,\n                                        __global unsigned char *ext_mem_318805,\n                                        __global unsigned char *ext_mem_318806,\n                                        __global unsigned char *mem_319958,\n                                        __global unsigned char *mem_319967)\n{\n    #define segred_group_sizze_314786 (mainzisegred_group_sizze_314457)\n    \n    ",
            "const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_324342_backing_0 =\n                           &shared_mem[red_arr_mem_324342_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324337;\n    int32_t local_tid_324338;\n    int64_t group_sizze_324341;\n    int32_t wave_sizze_324340;\n    int32_t group_tid_324339;\n    \n    global_tid_324337 = get_global_id(0);\n    local_tid_324338 = get_local_id(0);\n    group_sizze_324341 = get_local_size(0);\n    wave_sizze_324340 = LOCKSTEP_WIDTH;\n    group_tid_324339 = get_group_id(0);\n    \n    int32_t phys_tid_314793 = global_tid_324337;\n    __local unsigned char *red_arr_mem_324342;\n    \n    red_arr_mem_324342 = (__local unsigned char *) red_arr_mem_324342_backing_0;\n    \n    int32_t phys_group_id_324344;\n    \n    phys_group_id_324344 = get_group_id(0);\n    for (int32_t i_324345 = 0; i_324345 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * t_n_m_292839,\n                                          squot64(segred_group_sizze_314786,\n                                                  segment_sizze_nonzzero_324335))) -\n                   phys_group_id_324344, sext_i64_i32(num_groups_314787));\n         i_324345++) {\n        int32_t virt_group_id_324346 = phys_group_id_324344 + i_324345 *\n                sext_i64_i32(num_groups_314787);\n        int64_t slice_324347 = t_n_m_292839;\n        int64_t slice_324348 = partition_sizze_292766 * slice_324347;\n        int64_t gtid_314790 = squot64(squot64(sext_i32_i64(local_tid_324338),\n                                              segment_sizze_nonzzero_324335) +\n                                      sext_i32_i64(virt_group_id_324346) *\n                                      squot64(segred_group_sizze_314786,\n                                              segment_sizze_nonzzero_324335),\n                                      slice_324347);\n        int64_t remnant_32",
            "4349 = squot64(sext_i32_i64(local_tid_324338),\n                                         segment_sizze_nonzzero_324335) +\n                sext_i32_i64(virt_group_id_324346) *\n                squot64(segred_group_sizze_314786,\n                        segment_sizze_nonzzero_324335) - gtid_314790 *\n                slice_324347;\n        int64_t gtid_314791 = remnant_324349;\n        int64_t remnant_324350 = remnant_324349 - gtid_314791;\n        int64_t gtid_314792 = srem64(sext_i32_i64(local_tid_324338),\n                                     q_t_292679);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_t_292679) && ((slt64(gtid_314790,\n                                                          partition_sizze_292766) &&\n                                                    slt64(gtid_314791,\n                                                          t_n_m_292839)) &&\n                                                   slt64(sext_i32_i64(local_tid_324338),\n                                                         q_t_292679 *\n                                                         squot64(segred_group_sizze_314786,\n                                                                 segment_sizze_nonzzero_324335)))) {\n                int64_t x_314798;\n                \n                x_314798 = ((__global int64_t *) ext_mem_318541)[gtid_314790];\n                \n                int64_t x_314803;\n                \n                x_314803 = ((__global int64_t *) ext_mem_318806)[gtid_314790 *\n                                                                 t_n_m_292839 +\n                                                                 gtid_314791];\n                \n                double x_314804;\n                \n                x_314804 = ((__global double *) ext_mem_318805)[gtid_314790 *\n                                                                t_n_m_292839 +\n                                                                gtid_",
            "314791];\n                \n                int64_t binop_y_317872 = mul64(jump_t_292685, gtid_314791);\n                int64_t binop_y_317873 = smin64(i_292846, binop_y_317872);\n                int64_t index_primexp_317874 = add64((int64_t) 1,\n                                                     binop_y_317873);\n                bool cond_314807 = sle64(x_314798, gtid_314792);\n                int64_t defunc_0_f_res_314808;\n                \n                if (cond_314807) {\n                    defunc_0_f_res_314808 = (int64_t) 0;\n                } else {\n                    int64_t i_314809 = add64(gtid_314792, x_314803);\n                    int64_t defunc_0_add_arg_314810;\n                    \n                    defunc_0_add_arg_314810 = ((__global\n                                                int64_t *) ext_mem_318542)[gtid_314790 *\n                                                                           n_292675 +\n                                                                           i_314809];\n                    \n                    int64_t defunc_1_add_res_314811 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_314810);\n                    \n                    defunc_0_f_res_314808 = defunc_1_add_res_314811;\n                }\n                \n                double defunc_0_f_res_314812;\n                \n                if (cond_314807) {\n                    defunc_0_f_res_314812 = 0.0;\n                } else {\n                    int64_t i_314813 = add64(gtid_314792, x_314803);\n                    double defunc_0_add_arg_314814;\n                    \n                    defunc_0_add_arg_314814 = ((__global\n                                                double *) mem_319958)[gtid_314790 *\n                                                                      n_292675 +\n                                                                      i_314813];\n                    defunc_0_f_res_314812 = defunc_0_add_a",
            "rg_314814;\n                }\n                \n                int64_t binop_p_314815 = sub64(defunc_0_f_res_314808,\n                                               index_primexp_317874);\n                double defunc_0_f_res_314816 = sitofp_i64_f64(binop_p_314815);\n                double abs_res_314817 = fabs(defunc_0_f_res_314816);\n                double tmp1_314818 = abs_res_314817 / x_314804;\n                double x_314819 = tmp1_314818 * tmp1_314818;\n                double y_314820 = tmp1_314818 * x_314819;\n                double tmp2_314821 = 1.0 - y_314820;\n                double x_314822 = tmp2_314821 * tmp2_314821;\n                double tmp3_314823 = tmp2_314821 * x_314822;\n                double w_j_314824 = defunc_0_f_res_314812 * tmp3_314823;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_324342)[sext_i32_i64(local_tid_324338)] =\n                        w_j_314824;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_324342)[sext_i32_i64(local_tid_324338)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_t_292679)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_314794;\n                double x_314795;\n                double x_324351;\n                double x_324352;\n                bool ltid_in_bounds_324354 =\n                     slt64(sext_i32_i64(local_tid_324338), q_t_292679 *\n                           squot64(segred_group_sizze_314786,\n                                   segment_sizze_nonzzero_324335));\n                int32_t skip_threads_324355;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_324354) {\n                        x_314795 ",
            "= ((volatile __local\n                                     double *) red_arr_mem_324342)[sext_i32_i64(local_tid_324338)];\n                        if ((local_tid_324338 - squot32(local_tid_324338, 32) *\n                             32) == 0) {\n                            x_314794 = x_314795;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_324355 = 1;\n                    while (slt32(skip_threads_324355, 32)) {\n                        bool thread_active_324356 = sle32(skip_threads_324355,\n                                                          local_tid_324338 -\n                                                          squot32(local_tid_324338,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_324354;\n                        \n                        if (thread_active_324356) {\n                            // read operands\n                            {\n                                x_314794 = ((volatile __local\n                                             double *) red_arr_mem_324342)[sext_i32_i64(local_tid_324338) -\n                                                                           sext_i32_i64(skip_threads_324355)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_324357 =\n                                 slt64(srem64(sext_i32_i64(local_tid_324338),\n                                              q_t_292679),\n                                       sext_i32_i64(local_tid_324338) -\n                                       sext_i32_i64(local_tid_324338 -\n                                       skip_threads_324355));\n                            \n                            if (thread_active_324356 && inactive_324357) {\n                           ",
            "     x_314794 = x_314795;\n                            }\n                            if (thread_active_324356) {\n                                if (!inactive_324357) {\n                                    double defunc_1_op_res_314796 = x_314794 +\n                                           x_314795;\n                                    \n                                    x_314794 = defunc_1_op_res_314796;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_324340, skip_threads_324355)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_324356) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_324342)[sext_i32_i64(local_tid_324338)] =\n                                    x_314794;\n                                x_314795 = x_314794;\n                            }\n                        }\n                        if (sle32(wave_sizze_324340, skip_threads_324355)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_324355 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_324338 - squot32(local_tid_324338, 32) *\n                         32) == 31 && ltid_in_bounds_324354) {\n                        ((volatile __local\n                          double *) red_arr_mem_324342)[sext_i32_i64(squot32(local_tid_324338,\n                                                                             32))] =\n                            x_314794;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first ",
            "block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_324358;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_324338, 32) == 0 &&\n                            ltid_in_bounds_324354) {\n                            x_324352 = ((volatile __local\n                                         double *) red_arr_mem_324342)[sext_i32_i64(local_tid_324338)];\n                            if ((local_tid_324338 - squot32(local_tid_324338,\n                                                            32) * 32) == 0) {\n                                x_324351 = x_324352;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_324358 = 1;\n                        while (slt32(skip_threads_324358, 32)) {\n                            bool thread_active_324359 =\n                                 sle32(skip_threads_324358, local_tid_324338 -\n                                       squot32(local_tid_324338, 32) * 32) &&\n                                 (squot32(local_tid_324338, 32) == 0 &&\n                                  ltid_in_bounds_324354);\n                            \n                            if (thread_active_324359) {\n                                // read operands\n                                {\n                                    x_324351 = ((volatile __local\n                                                 double *) red_arr_mem_324342)[sext_i32_i64(local_tid_324338) -\n                                                                               sext_i32_i64(skip_threads_324358)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_324360 =\n",
            "                                     slt64(srem64(sext_i32_i64(local_tid_324338 *\n                                                  32 + 32 - 1), q_t_292679),\n                                           sext_i32_i64(local_tid_324338 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_324338 -\n                                                         skip_threads_324358) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_324359 && inactive_324360) {\n                                    x_324351 = x_324352;\n                                }\n                                if (thread_active_324359) {\n                                    if (!inactive_324360) {\n                                        double defunc_1_op_res_324353 =\n                                               x_324351 + x_324352;\n                                        \n                                        x_324351 = defunc_1_op_res_324353;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_324340, skip_threads_324358)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_324359) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_324342)[sext_i32_i64(local_tid_324338)] =\n                                        x_324351;\n                                    x_324352 = x_324351;\n                                }\n                            }\n                            if (sle32(wave_sizze_324340, skip_threads_324358)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n ",
            "                           skip_threads_324358 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_324361 = squot32(local_tid_324338, 32) == 0 ||\n                     !ltid_in_bounds_324354;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_324361) {\n                            x_314795 = x_314794;\n                            x_314794 = ((__local\n                                         double *) red_arr_mem_324342)[sext_i32_i64(squot32(local_tid_324338,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_324362 =\n                             slt64(srem64(sext_i32_i64(local_tid_324338),\n                                          q_t_292679),\n                                   sext_i32_i64(local_tid_324338) -\n                                   sext_i32_i64(squot32(local_tid_324338, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_324361) {\n                            if (inactive_324362) {\n                                x_314794 = x_314795;\n                            }\n                        }\n                        if (!no_carry_in_324361) {\n                            if (!inactive_324362) {\n                                double defunc_1_op_res_314796 = x_314794 +\n                                       x_314795;\n                                \n                                x_314794 = defunc_1_op_res_314796;\n                            }\n                      ",
            "  }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_324361) {\n                            ((__local\n                              double *) red_arr_mem_324342)[sext_i32_i64(local_tid_324338)] =\n                                x_314794;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_324338, 32) == 0 &&\n                        ltid_in_bounds_324354) {\n                        ((__local\n                          double *) red_arr_mem_324342)[sext_i32_i64(local_tid_324338)] =\n                            x_314795;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_324346) *\n                      squot64(segred_group_sizze_314786,\n                              segment_sizze_nonzzero_324335) +\n                      sext_i32_i64(local_tid_324338), partition_sizze_292766 *\n                      t_n_m_292839) && slt64(sext_i32_i64(local_tid_324338),\n                                             squot64(segred_group_sizze_314786,\n                                                     segment_sizze_nonzzero_324335))) {\n                double tmp_324363;\n                \n                tmp_324363 = ((__local\n                               double *) red_arr_mem_324342)[(sext_i32_i64(local_tid_324338) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324335 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319967)[squot64(sext_i32_i64(vir",
            "t_group_id_324346) *\n                                                squot64(segred_group_sizze_314786,\n                                                        segment_sizze_nonzzero_324335) +\n                                                sext_i32_i64(local_tid_324338),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324346) *\n                                         squot64(segred_group_sizze_314786,\n                                                 segment_sizze_nonzzero_324335) +\n                                         sext_i32_i64(local_tid_324338) -\n                                         squot64(sext_i32_i64(virt_group_id_324346) *\n                                                 squot64(segred_group_sizze_314786,\n                                                         segment_sizze_nonzzero_324335) +\n                                                 sext_i32_i64(local_tid_324338),\n                                                 t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324363;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_314786\n}\n__kernel void mainzisegred_small_314846(__global int *global_failure,\n                                        uint red_arr_mem_324425_backing_offset_0,\n                                        int64_t n_292675, int64_t q_t_292679,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t t_n_m_292839, int64_t i_292846,\n                                        int64_t num_groups_314840,\n                                        int64_t segment_sizze_nonzzero_324418,\n                                        __global unsigned char *ext_mem_318",
            "541,\n                                        __global unsigned char *ext_mem_318542,\n                                        __global unsigned char *ext_mem_318805,\n                                        __global unsigned char *ext_mem_318806,\n                                        __global unsigned char *mem_319958,\n                                        __global unsigned char *mem_319962,\n                                        __global unsigned char *mem_319972,\n                                        __global unsigned char *mem_319977)\n{\n    #define segred_group_sizze_314839 (mainzisegred_group_sizze_314386)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_324425_backing_0 =\n                           &shared_mem[red_arr_mem_324425_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324420;\n    int32_t local_tid_324421;\n    int64_t group_sizze_324424;\n    int32_t wave_sizze_324423;\n    int32_t group_tid_324422;\n    \n    global_tid_324420 = get_global_id(0);\n    local_tid_324421 = get_local_id(0);\n    group_sizze_324424 = get_local_size(0);\n    wave_sizze_324423 = LOCKSTEP_WIDTH;\n    group_tid_324422 = get_group_id(0);\n    \n    int32_t phys_tid_314846 = global_tid_324420;\n    __local unsigned char *red_arr_mem_324425;\n    \n    red_arr_mem_324425 = (__local unsigned char *) red_arr_mem_324425_backing_0;\n    \n    int32_t phys_group_id_324427;\n    \n    phys_group_id_324427 = get_group_id(0);\n    for (int32_t i_324428 = 0; i_324428 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * t_n_m_292839,\n                                          squot64(segred_group_sizze_314839,\n                                                  segment_sizze_nonzzero_324418))) -\n                   phys_group_id_324427, sext_i64_i32(num_groups_314840));\n         i_324428++) {\n        int32_t virt_group_id_324429 = phys_group_id_324427 + i_324",
            "428 *\n                sext_i64_i32(num_groups_314840);\n        int64_t slice_324430 = t_n_m_292839;\n        int64_t slice_324431 = partition_sizze_292766 * slice_324430;\n        int64_t gtid_314843 = squot64(squot64(sext_i32_i64(local_tid_324421),\n                                              segment_sizze_nonzzero_324418) +\n                                      sext_i32_i64(virt_group_id_324429) *\n                                      squot64(segred_group_sizze_314839,\n                                              segment_sizze_nonzzero_324418),\n                                      slice_324430);\n        int64_t remnant_324432 = squot64(sext_i32_i64(local_tid_324421),\n                                         segment_sizze_nonzzero_324418) +\n                sext_i32_i64(virt_group_id_324429) *\n                squot64(segred_group_sizze_314839,\n                        segment_sizze_nonzzero_324418) - gtid_314843 *\n                slice_324430;\n        int64_t gtid_314844 = remnant_324432;\n        int64_t remnant_324433 = remnant_324432 - gtid_314844;\n        int64_t gtid_314845 = srem64(sext_i32_i64(local_tid_324421),\n                                     q_t_292679);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_t_292679) && ((slt64(gtid_314843,\n                                                          partition_sizze_292766) &&\n                                                    slt64(gtid_314844,\n                                                          t_n_m_292839)) &&\n                                                   slt64(sext_i32_i64(local_tid_324421),\n                                                         q_t_292679 *\n                                                         squot64(segred_group_sizze_314839,\n                                                                 segment_sizze_nonzzero_324418)))) {\n                int64_t x_314851;\n                \n                x_314851 = ((__global int64_t ",
            "*) ext_mem_318541)[gtid_314843];\n                \n                int64_t x_314858;\n                \n                x_314858 = ((__global int64_t *) ext_mem_318806)[gtid_314843 *\n                                                                 t_n_m_292839 +\n                                                                 gtid_314844];\n                \n                double x_314859;\n                \n                x_314859 = ((__global double *) ext_mem_318805)[gtid_314843 *\n                                                                t_n_m_292839 +\n                                                                gtid_314844];\n                \n                int64_t binop_y_317867 = mul64(jump_t_292685, gtid_314844);\n                int64_t binop_y_317868 = smin64(i_292846, binop_y_317867);\n                int64_t index_primexp_317869 = add64((int64_t) 1,\n                                                     binop_y_317868);\n                double a0_314861;\n                \n                a0_314861 = ((__global double *) mem_319972)[gtid_314843 *\n                                                             t_n_m_292839 +\n                                                             gtid_314844];\n                \n                bool cond_314863 = sle64(x_314851, gtid_314845);\n                int64_t defunc_0_f_res_314864;\n                \n                if (cond_314863) {\n                    defunc_0_f_res_314864 = (int64_t) 0;\n                } else {\n                    int64_t i_314865 = add64(gtid_314845, x_314858);\n                    int64_t defunc_0_add_arg_314866;\n                    \n                    defunc_0_add_arg_314866 = ((__global\n                                                int64_t *) ext_mem_318542)[gtid_314843 *\n                                                                           n_292675 +\n                                                                           i_314865];\n                    \n                    int64_t defun",
            "c_1_add_res_314867 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_314866);\n                    \n                    defunc_0_f_res_314864 = defunc_1_add_res_314867;\n                }\n                \n                double defunc_0_f_res_314868;\n                \n                if (cond_314863) {\n                    defunc_0_f_res_314868 = 0.0;\n                } else {\n                    int64_t i_314869 = add64(gtid_314845, x_314858);\n                    double defunc_0_add_arg_314870;\n                    \n                    defunc_0_add_arg_314870 = ((__global\n                                                double *) mem_319958)[gtid_314843 *\n                                                                      n_292675 +\n                                                                      i_314869];\n                    defunc_0_f_res_314868 = defunc_0_add_arg_314870;\n                }\n                \n                int64_t binop_p_314871 = sub64(defunc_0_f_res_314864,\n                                               index_primexp_317869);\n                double defunc_0_f_res_314872 = sitofp_i64_f64(binop_p_314871);\n                double abs_res_314873 = fabs(defunc_0_f_res_314872);\n                double tmp1_314874 = abs_res_314873 / x_314859;\n                double x_314875 = tmp1_314874 * tmp1_314874;\n                double y_314876 = tmp1_314874 * x_314875;\n                double tmp2_314877 = 1.0 - y_314876;\n                double x_314878 = tmp2_314877 * tmp2_314877;\n                double tmp3_314879 = tmp2_314877 * x_314878;\n                double tmp4_314880 = defunc_0_f_res_314868 * tmp3_314879;\n                double defunc_0_f_res_314881;\n                \n                if (cond_314863) {\n                    defunc_0_f_res_314881 = 0.0;\n                } else {\n                    int64_t i_314882 = add64(gtid_314845, x_314858);\n                    double defunc_0_add_arg_314883;\n               ",
            "     \n                    defunc_0_add_arg_314883 = ((__global\n                                                double *) mem_319962)[gtid_314843 *\n                                                                      n_292675 +\n                                                                      i_314882];\n                    defunc_0_f_res_314881 = defunc_0_add_arg_314883;\n                }\n                \n                double x_314884 = a0_314861 * tmp4_314880;\n                double defunc_9_fit_fun_res_314885 = defunc_0_f_res_314881 *\n                       x_314884;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_324425)[sext_i32_i64(local_tid_324421)] =\n                        defunc_9_fit_fun_res_314885;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_324425)[sext_i32_i64(local_tid_324421)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_t_292679)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_314847;\n                double x_314848;\n                double x_324434;\n                double x_324435;\n                bool ltid_in_bounds_324437 =\n                     slt64(sext_i32_i64(local_tid_324421), q_t_292679 *\n                           squot64(segred_group_sizze_314839,\n                                   segment_sizze_nonzzero_324418));\n                int32_t skip_threads_324438;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_324437) {\n                        x_314848 = ((volatile __local\n                                     double *) red_arr_mem_324425)[sext_i32_i64(local_tid_324421)];\n                        if ((local_tid_324421",
            " - squot32(local_tid_324421, 32) *\n                             32) == 0) {\n                            x_314847 = x_314848;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_324438 = 1;\n                    while (slt32(skip_threads_324438, 32)) {\n                        bool thread_active_324439 = sle32(skip_threads_324438,\n                                                          local_tid_324421 -\n                                                          squot32(local_tid_324421,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_324437;\n                        \n                        if (thread_active_324439) {\n                            // read operands\n                            {\n                                x_314847 = ((volatile __local\n                                             double *) red_arr_mem_324425)[sext_i32_i64(local_tid_324421) -\n                                                                           sext_i32_i64(skip_threads_324438)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_324440 =\n                                 slt64(srem64(sext_i32_i64(local_tid_324421),\n                                              q_t_292679),\n                                       sext_i32_i64(local_tid_324421) -\n                                       sext_i32_i64(local_tid_324421 -\n                                       skip_threads_324438));\n                            \n                            if (thread_active_324439 && inactive_324440) {\n                                x_314847 = x_314848;\n                            }\n                            if (thread_active_324439) {\n                                if (!inactive_324440) ",
            "{\n                                    double defunc_1_op_res_314849 = x_314847 +\n                                           x_314848;\n                                    \n                                    x_314847 = defunc_1_op_res_314849;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_324423, skip_threads_324438)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_324439) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_324425)[sext_i32_i64(local_tid_324421)] =\n                                    x_314847;\n                                x_314848 = x_314847;\n                            }\n                        }\n                        if (sle32(wave_sizze_324423, skip_threads_324438)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_324438 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_324421 - squot32(local_tid_324421, 32) *\n                         32) == 31 && ltid_in_bounds_324437) {\n                        ((volatile __local\n                          double *) red_arr_mem_324425)[sext_i32_i64(squot32(local_tid_324421,\n                                                                             32))] =\n                            x_314847;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_324441;\n                    \n              ",
            "      // read input for in-block scan\n                    {\n                        if (squot32(local_tid_324421, 32) == 0 &&\n                            ltid_in_bounds_324437) {\n                            x_324435 = ((volatile __local\n                                         double *) red_arr_mem_324425)[sext_i32_i64(local_tid_324421)];\n                            if ((local_tid_324421 - squot32(local_tid_324421,\n                                                            32) * 32) == 0) {\n                                x_324434 = x_324435;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_324441 = 1;\n                        while (slt32(skip_threads_324441, 32)) {\n                            bool thread_active_324442 =\n                                 sle32(skip_threads_324441, local_tid_324421 -\n                                       squot32(local_tid_324421, 32) * 32) &&\n                                 (squot32(local_tid_324421, 32) == 0 &&\n                                  ltid_in_bounds_324437);\n                            \n                            if (thread_active_324442) {\n                                // read operands\n                                {\n                                    x_324434 = ((volatile __local\n                                                 double *) red_arr_mem_324425)[sext_i32_i64(local_tid_324421) -\n                                                                               sext_i32_i64(skip_threads_324441)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_324443 =\n                                     slt64(srem64(sext_i32_i64(local_tid_324421 *\n                                                  32 + 32 - 1), q_t_292679),\n       ",
            "                                    sext_i32_i64(local_tid_324421 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_324421 -\n                                                         skip_threads_324441) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_324442 && inactive_324443) {\n                                    x_324434 = x_324435;\n                                }\n                                if (thread_active_324442) {\n                                    if (!inactive_324443) {\n                                        double defunc_1_op_res_324436 =\n                                               x_324434 + x_324435;\n                                        \n                                        x_324434 = defunc_1_op_res_324436;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_324423, skip_threads_324441)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_324442) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_324425)[sext_i32_i64(local_tid_324421)] =\n                                        x_324434;\n                                    x_324435 = x_324434;\n                                }\n                            }\n                            if (sle32(wave_sizze_324423, skip_threads_324441)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_324441 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n ",
            "               \n                bool no_carry_in_324444 = squot32(local_tid_324421, 32) == 0 ||\n                     !ltid_in_bounds_324437;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_324444) {\n                            x_314848 = x_314847;\n                            x_314847 = ((__local\n                                         double *) red_arr_mem_324425)[sext_i32_i64(squot32(local_tid_324421,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_324445 =\n                             slt64(srem64(sext_i32_i64(local_tid_324421),\n                                          q_t_292679),\n                                   sext_i32_i64(local_tid_324421) -\n                                   sext_i32_i64(squot32(local_tid_324421, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_324444) {\n                            if (inactive_324445) {\n                                x_314847 = x_314848;\n                            }\n                        }\n                        if (!no_carry_in_324444) {\n                            if (!inactive_324445) {\n                                double defunc_1_op_res_314849 = x_314847 +\n                                       x_314848;\n                                \n                                x_314847 = defunc_1_op_res_314849;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_324444) {\n                         ",
            "   ((__local\n                              double *) red_arr_mem_324425)[sext_i32_i64(local_tid_324421)] =\n                                x_314847;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_324421, 32) == 0 &&\n                        ltid_in_bounds_324437) {\n                        ((__local\n                          double *) red_arr_mem_324425)[sext_i32_i64(local_tid_324421)] =\n                            x_314848;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_324429) *\n                      squot64(segred_group_sizze_314839,\n                              segment_sizze_nonzzero_324418) +\n                      sext_i32_i64(local_tid_324421), partition_sizze_292766 *\n                      t_n_m_292839) && slt64(sext_i32_i64(local_tid_324421),\n                                             squot64(segred_group_sizze_314839,\n                                                     segment_sizze_nonzzero_324418))) {\n                double tmp_324446;\n                \n                tmp_324446 = ((__local\n                               double *) red_arr_mem_324425)[(sext_i32_i64(local_tid_324421) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324418 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319977)[squot64(sext_i32_i64(virt_group_id_324429) *\n                                                squot64(segred_group_sizze_314839,\n                                                        segmen",
            "t_sizze_nonzzero_324418) +\n                                                sext_i32_i64(local_tid_324421),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324429) *\n                                         squot64(segred_group_sizze_314839,\n                                                 segment_sizze_nonzzero_324418) +\n                                         sext_i32_i64(local_tid_324421) -\n                                         squot64(sext_i32_i64(virt_group_id_324429) *\n                                                 squot64(segred_group_sizze_314839,\n                                                         segment_sizze_nonzzero_324418) +\n                                                 sext_i32_i64(local_tid_324421),\n                                                 t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324446;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_314839\n}\n__kernel void mainzisegred_small_315394(__global int *global_failure,\n                                        uint red_arr_mem_324522_backing_offset_0,\n                                        uint red_arr_mem_324520_backing_offset_1,\n                                        uint red_arr_mem_324518_backing_offset_2,\n                                        int64_t n_292675, int64_t q_t_292679,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t t_n_m_292839, int64_t i_292846,\n                                        int64_t num_groups_315386,\n                                        int64_t segment_sizze_nonzzero_324511,\n                                        __global unsigned char *ext_mem_31854",
            "1,\n                                        __global unsigned char *ext_mem_318542,\n                                        __global unsigned char *ext_mem_318805,\n                                        __global unsigned char *ext_mem_318806,\n                                        __global unsigned char *mem_319987,\n                                        __global unsigned char *mem_319996,\n                                        __global unsigned char *mem_320000,\n                                        __global unsigned char *mem_320004)\n{\n    #define segred_group_sizze_315385 (mainzisegred_group_sizze_315010)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_324522_backing_2 =\n                           &shared_mem[red_arr_mem_324522_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324520_backing_1 =\n                           &shared_mem[red_arr_mem_324520_backing_offset_1];\n    volatile unsigned char *red_arr_mem_324518_backing_0 =\n                           &shared_mem[red_arr_mem_324518_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324513;\n    int32_t local_tid_324514;\n    int64_t group_sizze_324517;\n    int32_t wave_sizze_324516;\n    int32_t group_tid_324515;\n    \n    global_tid_324513 = get_global_id(0);\n    local_tid_324514 = get_local_id(0);\n    group_sizze_324517 = get_local_size(0);\n    wave_sizze_324516 = LOCKSTEP_WIDTH;\n    group_tid_324515 = get_group_id(0);\n    \n    int32_t phys_tid_315394 = global_tid_324513;\n    __local unsigned char *red_arr_mem_324518;\n    \n    red_arr_mem_324518 = (__local unsigned char *) red_arr_mem_324518_backing_0;\n    \n    __local unsigned char *red_arr_mem_324520;\n    \n    red_arr_mem_324520 = (__local unsigned char *) red_arr_mem_324520_backing_1;\n    \n    __local unsigned char *red_arr_mem_324522;\n    \n    red_arr_mem_324522 = (__local unsigned char *) red_arr_mem_324522_bac",
            "king_2;\n    \n    int32_t phys_group_id_324524;\n    \n    phys_group_id_324524 = get_group_id(0);\n    for (int32_t i_324525 = 0; i_324525 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * t_n_m_292839,\n                                          squot64(segred_group_sizze_315385,\n                                                  segment_sizze_nonzzero_324511))) -\n                   phys_group_id_324524, sext_i64_i32(num_groups_315386));\n         i_324525++) {\n        int32_t virt_group_id_324526 = phys_group_id_324524 + i_324525 *\n                sext_i64_i32(num_groups_315386);\n        int64_t slice_324527 = t_n_m_292839;\n        int64_t slice_324528 = partition_sizze_292766 * slice_324527;\n        int64_t gtid_315391 = squot64(squot64(sext_i32_i64(local_tid_324514),\n                                              segment_sizze_nonzzero_324511) +\n                                      sext_i32_i64(virt_group_id_324526) *\n                                      squot64(segred_group_sizze_315385,\n                                              segment_sizze_nonzzero_324511),\n                                      slice_324527);\n        int64_t remnant_324529 = squot64(sext_i32_i64(local_tid_324514),\n                                         segment_sizze_nonzzero_324511) +\n                sext_i32_i64(virt_group_id_324526) *\n                squot64(segred_group_sizze_315385,\n                        segment_sizze_nonzzero_324511) - gtid_315391 *\n                slice_324527;\n        int64_t gtid_315392 = remnant_324529;\n        int64_t remnant_324530 = remnant_324529 - gtid_315392;\n        int64_t gtid_315393 = srem64(sext_i32_i64(local_tid_324514),\n                                     q_t_292679);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_t_292679) && ((slt64(gtid_315391,\n                                                          partition_sizze_292766) &&\n                                                  ",
            "  slt64(gtid_315392,\n                                                          t_n_m_292839)) &&\n                                                   slt64(sext_i32_i64(local_tid_324514),\n                                                         q_t_292679 *\n                                                         squot64(segred_group_sizze_315385,\n                                                                 segment_sizze_nonzzero_324511)))) {\n                int64_t x_315405;\n                \n                x_315405 = ((__global int64_t *) ext_mem_318541)[gtid_315391];\n                \n                int64_t x_315410;\n                \n                x_315410 = ((__global int64_t *) ext_mem_318806)[gtid_315391 *\n                                                                 t_n_m_292839 +\n                                                                 gtid_315392];\n                \n                double x_315411;\n                \n                x_315411 = ((__global double *) ext_mem_318805)[gtid_315391 *\n                                                                t_n_m_292839 +\n                                                                gtid_315392];\n                \n                int64_t binop_y_317882 = mul64(jump_t_292685, gtid_315392);\n                int64_t binop_y_317883 = smin64(i_292846, binop_y_317882);\n                int64_t index_primexp_317884 = add64((int64_t) 1,\n                                                     binop_y_317883);\n                bool cond_315414 = sle64(x_315405, gtid_315393);\n                int64_t defunc_0_f_res_315415;\n                \n                if (cond_315414) {\n                    defunc_0_f_res_315415 = (int64_t) 0;\n                } else {\n                    int64_t i_315416 = add64(gtid_315393, x_315410);\n                    int64_t defunc_0_add_arg_315417;\n                    \n                    defunc_0_add_arg_315417 = ((__global\n                                                int64_t *) ext_",
            "mem_318542)[gtid_315391 *\n                                                                           n_292675 +\n                                                                           i_315416];\n                    \n                    int64_t defunc_1_add_res_315418 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_315417);\n                    \n                    defunc_0_f_res_315415 = defunc_1_add_res_315418;\n                }\n                \n                double defunc_0_f_res_315419;\n                \n                if (cond_315414) {\n                    defunc_0_f_res_315419 = 0.0;\n                } else {\n                    int64_t i_315420 = add64(gtid_315393, x_315410);\n                    double defunc_0_add_arg_315421;\n                    \n                    defunc_0_add_arg_315421 = ((__global\n                                                double *) mem_319987)[gtid_315391 *\n                                                                      n_292675 +\n                                                                      i_315420];\n                    defunc_0_f_res_315419 = defunc_0_add_arg_315421;\n                }\n                \n                int64_t binop_p_315422 = sub64(defunc_0_f_res_315415,\n                                               index_primexp_317884);\n                double defunc_0_f_res_315423 = sitofp_i64_f64(binop_p_315422);\n                double abs_res_315424 = fabs(defunc_0_f_res_315423);\n                double tmp1_315425 = abs_res_315424 / x_315411;\n                double x_315426 = tmp1_315425 * tmp1_315425;\n                double y_315427 = tmp1_315425 * x_315426;\n                double tmp2_315428 = 1.0 - y_315427;\n                double x_315429 = tmp2_315428 * tmp2_315428;\n                double tmp3_315430 = tmp2_315428 * x_315429;\n                double w_j_315431 = defunc_0_f_res_315419 * tmp3_315430;\n                double xw_j_315432 = defunc_0_f_res_31542",
            "3 * w_j_315431;\n                double x2w_j_315433 = defunc_0_f_res_315423 * xw_j_315432;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_324518)[sext_i32_i64(local_tid_324514)] =\n                        w_j_315431;\n                    ((__local\n                      double *) red_arr_mem_324520)[sext_i32_i64(local_tid_324514)] =\n                        xw_j_315432;\n                    ((__local\n                      double *) red_arr_mem_324522)[sext_i32_i64(local_tid_324514)] =\n                        x2w_j_315433;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_324518)[sext_i32_i64(local_tid_324514)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_324520)[sext_i32_i64(local_tid_324514)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_324522)[sext_i32_i64(local_tid_324514)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_t_292679)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_315395;\n                double x_315396;\n                double x_315397;\n                double x_315398;\n                double x_315399;\n                double x_315400;\n                double x_324531;\n                double x_324532;\n                double x_324533;\n                double x_324534;\n                double x_324535;\n                double x_324536;\n                bool ltid_in_bounds_324540 =\n                     slt64(sext_i32_i64(local_tid_324514), q_t_292679 *\n                           squot64(segred_group_sizze_315385,\n                                   segment_sizze_nonzzero_324511));\n                int32_t skip_threads_324541;\n  ",
            "              \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_324540) {\n                        x_315398 = ((volatile __local\n                                     double *) red_arr_mem_324518)[sext_i32_i64(local_tid_324514)];\n                        x_315399 = ((volatile __local\n                                     double *) red_arr_mem_324520)[sext_i32_i64(local_tid_324514)];\n                        x_315400 = ((volatile __local\n                                     double *) red_arr_mem_324522)[sext_i32_i64(local_tid_324514)];\n                        if ((local_tid_324514 - squot32(local_tid_324514, 32) *\n                             32) == 0) {\n                            x_315395 = x_315398;\n                            x_315396 = x_315399;\n                            x_315397 = x_315400;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_324541 = 1;\n                    while (slt32(skip_threads_324541, 32)) {\n                        bool thread_active_324542 = sle32(skip_threads_324541,\n                                                          local_tid_324514 -\n                                                          squot32(local_tid_324514,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_324540;\n                        \n                        if (thread_active_324542) {\n                            // read operands\n                            {\n                                x_315395 = ((volatile __local\n                                             double *) red_arr_mem_324518)[sext_i32_i64(local_tid_324514) -\n                                                                           sext_i32_i64(skip_threads_324541)];\n                                x_315396 = ((volatile __local\n                    ",
            "                         double *) red_arr_mem_324520)[sext_i32_i64(local_tid_324514) -\n                                                                           sext_i32_i64(skip_threads_324541)];\n                                x_315397 = ((volatile __local\n                                             double *) red_arr_mem_324522)[sext_i32_i64(local_tid_324514) -\n                                                                           sext_i32_i64(skip_threads_324541)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_324543 =\n                                 slt64(srem64(sext_i32_i64(local_tid_324514),\n                                              q_t_292679),\n                                       sext_i32_i64(local_tid_324514) -\n                                       sext_i32_i64(local_tid_324514 -\n                                       skip_threads_324541));\n                            \n                            if (thread_active_324542 && inactive_324543) {\n                                x_315395 = x_315398;\n                                x_315396 = x_315399;\n                                x_315397 = x_315400;\n                            }\n                            if (thread_active_324542) {\n                                if (!inactive_324543) {\n                                    double defunc_1_op_res_315401 = x_315395 +\n                                           x_315398;\n                                    double defunc_1_op_res_315402 = x_315396 +\n                                           x_315399;\n                                    double defunc_1_op_res_315403 = x_315397 +\n                                           x_315400;\n                                    \n                                    x_315395 = defunc_1_op_res_315401;\n                                    x_315396 = defunc_1_op_res_315402;\n                    ",
            "                x_315397 = defunc_1_op_res_315403;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_324516, skip_threads_324541)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_324542) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_324518)[sext_i32_i64(local_tid_324514)] =\n                                    x_315395;\n                                x_315398 = x_315395;\n                                ((volatile __local\n                                  double *) red_arr_mem_324520)[sext_i32_i64(local_tid_324514)] =\n                                    x_315396;\n                                x_315399 = x_315396;\n                                ((volatile __local\n                                  double *) red_arr_mem_324522)[sext_i32_i64(local_tid_324514)] =\n                                    x_315397;\n                                x_315400 = x_315397;\n                            }\n                        }\n                        if (sle32(wave_sizze_324516, skip_threads_324541)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_324541 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_324514 - squot32(local_tid_324514, 32) *\n                         32) == 31 && ltid_in_bounds_324540) {\n                        ((volatile __local\n                          double *) red_arr_mem_324518)[sext_i32_i64(squot32(local_tid_324514,\n                                                                             32))] =\n                   ",
            "         x_315395;\n                        ((volatile __local\n                          double *) red_arr_mem_324520)[sext_i32_i64(squot32(local_tid_324514,\n                                                                             32))] =\n                            x_315396;\n                        ((volatile __local\n                          double *) red_arr_mem_324522)[sext_i32_i64(squot32(local_tid_324514,\n                                                                             32))] =\n                            x_315397;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_324544;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_324514, 32) == 0 &&\n                            ltid_in_bounds_324540) {\n                            x_324534 = ((volatile __local\n                                         double *) red_arr_mem_324518)[sext_i32_i64(local_tid_324514)];\n                            x_324535 = ((volatile __local\n                                         double *) red_arr_mem_324520)[sext_i32_i64(local_tid_324514)];\n                            x_324536 = ((volatile __local\n                                         double *) red_arr_mem_324522)[sext_i32_i64(local_tid_324514)];\n                            if ((local_tid_324514 - squot32(local_tid_324514,\n                                                            32) * 32) == 0) {\n                                x_324531 = x_324534;\n                                x_324532 = x_324535;\n                                x_324533 = x_324536;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        s",
            "kip_threads_324544 = 1;\n                        while (slt32(skip_threads_324544, 32)) {\n                            bool thread_active_324545 =\n                                 sle32(skip_threads_324544, local_tid_324514 -\n                                       squot32(local_tid_324514, 32) * 32) &&\n                                 (squot32(local_tid_324514, 32) == 0 &&\n                                  ltid_in_bounds_324540);\n                            \n                            if (thread_active_324545) {\n                                // read operands\n                                {\n                                    x_324531 = ((volatile __local\n                                                 double *) red_arr_mem_324518)[sext_i32_i64(local_tid_324514) -\n                                                                               sext_i32_i64(skip_threads_324544)];\n                                    x_324532 = ((volatile __local\n                                                 double *) red_arr_mem_324520)[sext_i32_i64(local_tid_324514) -\n                                                                               sext_i32_i64(skip_threads_324544)];\n                                    x_324533 = ((volatile __local\n                                                 double *) red_arr_mem_324522)[sext_i32_i64(local_tid_324514) -\n                                                                               sext_i32_i64(skip_threads_324544)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_324546 =\n                                     slt64(srem64(sext_i32_i64(local_tid_324514 *\n                                                  32 + 32 - 1), q_t_292679),\n                                           sext_i32_i64(local_tid_324514 * 32 +\n                                           32 - 1) -\n                               ",
            "            sext_i32_i64((local_tid_324514 -\n                                                         skip_threads_324544) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_324545 && inactive_324546) {\n                                    x_324531 = x_324534;\n                                    x_324532 = x_324535;\n                                    x_324533 = x_324536;\n                                }\n                                if (thread_active_324545) {\n                                    if (!inactive_324546) {\n                                        double defunc_1_op_res_324537 =\n                                               x_324531 + x_324534;\n                                        double defunc_1_op_res_324538 =\n                                               x_324532 + x_324535;\n                                        double defunc_1_op_res_324539 =\n                                               x_324533 + x_324536;\n                                        \n                                        x_324531 = defunc_1_op_res_324537;\n                                        x_324532 = defunc_1_op_res_324538;\n                                        x_324533 = defunc_1_op_res_324539;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_324516, skip_threads_324544)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_324545) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_324518)[sext_i32_i64(local_tid_324514)] =\n                                        x_324531;\n                                    x_324534 = x_324531;\n                 ",
            "                   ((volatile __local\n                                      double *) red_arr_mem_324520)[sext_i32_i64(local_tid_324514)] =\n                                        x_324532;\n                                    x_324535 = x_324532;\n                                    ((volatile __local\n                                      double *) red_arr_mem_324522)[sext_i32_i64(local_tid_324514)] =\n                                        x_324533;\n                                    x_324536 = x_324533;\n                                }\n                            }\n                            if (sle32(wave_sizze_324516, skip_threads_324544)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_324544 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_324547 = squot32(local_tid_324514, 32) == 0 ||\n                     !ltid_in_bounds_324540;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_324547) {\n                            x_315398 = x_315395;\n                            x_315399 = x_315396;\n                            x_315400 = x_315397;\n                            x_315395 = ((__local\n                                         double *) red_arr_mem_324518)[sext_i32_i64(squot32(local_tid_324514,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_315396 = ((__local\n                                         double *) red_arr_mem_324520)[sext_i32_i64(squot32(local_tid_324514,\n                                                                                         ",
            "   32)) -\n                                                                       (int64_t) 1];\n                            x_315397 = ((__local\n                                         double *) red_arr_mem_324522)[sext_i32_i64(squot32(local_tid_324514,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_324548 =\n                             slt64(srem64(sext_i32_i64(local_tid_324514),\n                                          q_t_292679),\n                                   sext_i32_i64(local_tid_324514) -\n                                   sext_i32_i64(squot32(local_tid_324514, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_324547) {\n                            if (inactive_324548) {\n                                x_315395 = x_315398;\n                                x_315396 = x_315399;\n                                x_315397 = x_315400;\n                            }\n                        }\n                        if (!no_carry_in_324547) {\n                            if (!inactive_324548) {\n                                double defunc_1_op_res_315401 = x_315395 +\n                                       x_315398;\n                                double defunc_1_op_res_315402 = x_315396 +\n                                       x_315399;\n                                double defunc_1_op_res_315403 = x_315397 +\n                                       x_315400;\n                                \n                                x_315395 = defunc_1_op_res_315401;\n                                x_315396 = defunc_1_op_res_315402;\n                                x_315397 = defunc_1_op_res_315403;\n                            }\n ",
            "                       }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_324547) {\n                            ((__local\n                              double *) red_arr_mem_324518)[sext_i32_i64(local_tid_324514)] =\n                                x_315395;\n                            ((__local\n                              double *) red_arr_mem_324520)[sext_i32_i64(local_tid_324514)] =\n                                x_315396;\n                            ((__local\n                              double *) red_arr_mem_324522)[sext_i32_i64(local_tid_324514)] =\n                                x_315397;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_324514, 32) == 0 &&\n                        ltid_in_bounds_324540) {\n                        ((__local\n                          double *) red_arr_mem_324518)[sext_i32_i64(local_tid_324514)] =\n                            x_315398;\n                        ((__local\n                          double *) red_arr_mem_324520)[sext_i32_i64(local_tid_324514)] =\n                            x_315399;\n                        ((__local\n                          double *) red_arr_mem_324522)[sext_i32_i64(local_tid_324514)] =\n                            x_315400;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_324526) *\n                      squot64(segred_group_sizze_315385,\n                              segment_sizze_nonzzero_324511) +\n                      sext_i32_i64(local_tid_324514), partition_sizze_292766 *\n                      t_n_m_292839) && slt64(sext_i32_i64(local_tid_324514",
            "),\n                                             squot64(segred_group_sizze_315385,\n                                                     segment_sizze_nonzzero_324511))) {\n                double tmp_324549;\n                \n                tmp_324549 = ((__local\n                               double *) red_arr_mem_324518)[(sext_i32_i64(local_tid_324514) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324511 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_319996)[squot64(sext_i32_i64(virt_group_id_324526) *\n                                                squot64(segred_group_sizze_315385,\n                                                        segment_sizze_nonzzero_324511) +\n                                                sext_i32_i64(local_tid_324514),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324526) *\n                                         squot64(segred_group_sizze_315385,\n                                                 segment_sizze_nonzzero_324511) +\n                                         sext_i32_i64(local_tid_324514) -\n                                         squot64(sext_i32_i64(virt_group_id_324526) *\n                                                 squot64(segred_group_sizze_315385,\n                                                         segment_sizze_nonzzero_324511) +\n                                                 sext_i32_i64(local_tid_324514),\n                                                 t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324549;\n                \n                double tmp_324550;\n                \n                tmp_324550 = ((__local\n                               double *) red_arr_mem_324520)[",
            "(sext_i32_i64(local_tid_324514) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324511 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_320000)[squot64(sext_i32_i64(virt_group_id_324526) *\n                                                squot64(segred_group_sizze_315385,\n                                                        segment_sizze_nonzzero_324511) +\n                                                sext_i32_i64(local_tid_324514),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324526) *\n                                         squot64(segred_group_sizze_315385,\n                                                 segment_sizze_nonzzero_324511) +\n                                         sext_i32_i64(local_tid_324514) -\n                                         squot64(sext_i32_i64(virt_group_id_324526) *\n                                                 squot64(segred_group_sizze_315385,\n                                                         segment_sizze_nonzzero_324511) +\n                                                 sext_i32_i64(local_tid_324514),\n                                                 t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324550;\n                \n                double tmp_324551;\n                \n                tmp_324551 = ((__local\n                               double *) red_arr_mem_324522)[(sext_i32_i64(local_tid_324514) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324511 -\n                                                             (int64_t) 1];\n                ((__global\n                 ",
            " double *) mem_320004)[squot64(sext_i32_i64(virt_group_id_324526) *\n                                                squot64(segred_group_sizze_315385,\n                                                        segment_sizze_nonzzero_324511) +\n                                                sext_i32_i64(local_tid_324514),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324526) *\n                                         squot64(segred_group_sizze_315385,\n                                                 segment_sizze_nonzzero_324511) +\n                                         sext_i32_i64(local_tid_324514) -\n                                         squot64(sext_i32_i64(virt_group_id_324526) *\n                                                 squot64(segred_group_sizze_315385,\n                                                         segment_sizze_nonzzero_324511) +\n                                                 sext_i32_i64(local_tid_324514),\n                                                 t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324551;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_315385\n}\n__kernel void mainzisegred_small_315469(__global int *global_failure,\n                                        uint red_arr_mem_324631_backing_offset_0,\n                                        uint red_arr_mem_324629_backing_offset_1,\n                                        int64_t n_292675, int64_t q_t_292679,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t t_n_m_292839, int64_t i_292846,\n                                        int64_t num_groups_315462,\n                         ",
            "               int64_t segment_sizze_nonzzero_324622,\n                                        __global unsigned char *ext_mem_318541,\n                                        __global unsigned char *ext_mem_318542,\n                                        __global unsigned char *ext_mem_318805,\n                                        __global unsigned char *ext_mem_318806,\n                                        __global unsigned char *mem_319987,\n                                        __global unsigned char *mem_319991,\n                                        __global unsigned char *mem_320009,\n                                        __global unsigned char *mem_320013,\n                                        __global unsigned char *mem_320017,\n                                        __global unsigned char *mem_320022,\n                                        __global unsigned char *mem_320026)\n{\n    #define segred_group_sizze_315461 (mainzisegred_group_sizze_314910)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_324631_backing_1 =\n                           &shared_mem[red_arr_mem_324631_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324629_backing_0 =\n                           &shared_mem[red_arr_mem_324629_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324624;\n    int32_t local_tid_324625;\n    int64_t group_sizze_324628;\n    int32_t wave_sizze_324627;\n    int32_t group_tid_324626;\n    \n    global_tid_324624 = get_global_id(0);\n    local_tid_324625 = get_local_id(0);\n    group_sizze_324628 = get_local_size(0);\n    wave_sizze_324627 = LOCKSTEP_WIDTH;\n    group_tid_324626 = get_group_id(0);\n    \n    int32_t phys_tid_315469 = global_tid_324624;\n    __local unsigned char *red_arr_mem_324629;\n    \n    red_arr_mem_324629 = (__local unsigned char *) red_arr_mem_324629_backing_0;\n    \n    __local unsigned char *red_arr_mem_3",
            "24631;\n    \n    red_arr_mem_324631 = (__local unsigned char *) red_arr_mem_324631_backing_1;\n    \n    int32_t phys_group_id_324633;\n    \n    phys_group_id_324633 = get_group_id(0);\n    for (int32_t i_324634 = 0; i_324634 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * t_n_m_292839,\n                                          squot64(segred_group_sizze_315461,\n                                                  segment_sizze_nonzzero_324622))) -\n                   phys_group_id_324633, sext_i64_i32(num_groups_315462));\n         i_324634++) {\n        int32_t virt_group_id_324635 = phys_group_id_324633 + i_324634 *\n                sext_i64_i32(num_groups_315462);\n        int64_t slice_324636 = t_n_m_292839;\n        int64_t slice_324637 = partition_sizze_292766 * slice_324636;\n        int64_t gtid_315466 = squot64(squot64(sext_i32_i64(local_tid_324625),\n                                              segment_sizze_nonzzero_324622) +\n                                      sext_i32_i64(virt_group_id_324635) *\n                                      squot64(segred_group_sizze_315461,\n                                              segment_sizze_nonzzero_324622),\n                                      slice_324636);\n        int64_t remnant_324638 = squot64(sext_i32_i64(local_tid_324625),\n                                         segment_sizze_nonzzero_324622) +\n                sext_i32_i64(virt_group_id_324635) *\n                squot64(segred_group_sizze_315461,\n                        segment_sizze_nonzzero_324622) - gtid_315466 *\n                slice_324636;\n        int64_t gtid_315467 = remnant_324638;\n        int64_t remnant_324639 = remnant_324638 - gtid_315467;\n        int64_t gtid_315468 = srem64(sext_i32_i64(local_tid_324625),\n                                     q_t_292679);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_t_292679) && ((slt64(gtid_315466,\n                                                  ",
            "        partition_sizze_292766) &&\n                                                    slt64(gtid_315467,\n                                                          t_n_m_292839)) &&\n                                                   slt64(sext_i32_i64(local_tid_324625),\n                                                         q_t_292679 *\n                                                         squot64(segred_group_sizze_315461,\n                                                                 segment_sizze_nonzzero_324622)))) {\n                int64_t x_315477;\n                \n                x_315477 = ((__global int64_t *) ext_mem_318541)[gtid_315466];\n                \n                int64_t x_315486;\n                \n                x_315486 = ((__global int64_t *) ext_mem_318806)[gtid_315466 *\n                                                                 t_n_m_292839 +\n                                                                 gtid_315467];\n                \n                double x_315487;\n                \n                x_315487 = ((__global double *) ext_mem_318805)[gtid_315466 *\n                                                                t_n_m_292839 +\n                                                                gtid_315467];\n                \n                int64_t binop_y_317877 = mul64(jump_t_292685, gtid_315467);\n                int64_t binop_y_317878 = smin64(i_292846, binop_y_317877);\n                int64_t index_primexp_317879 = add64((int64_t) 1,\n                                                     binop_y_317878);\n                double a11_315489;\n                \n                a11_315489 = ((__global double *) mem_320009)[gtid_315466 *\n                                                              t_n_m_292839 +\n                                                              gtid_315467];\n                \n                double b11_315490;\n                \n                b11_315490 = ((__global double *) mem_320013)[gtid_315466 ",
            "*\n                                                              t_n_m_292839 +\n                                                              gtid_315467];\n                \n                double c11_315491;\n                \n                c11_315491 = ((__global double *) mem_320017)[gtid_315466 *\n                                                              t_n_m_292839 +\n                                                              gtid_315467];\n                \n                bool cond_315493 = sle64(x_315477, gtid_315468);\n                int64_t defunc_0_f_res_315494;\n                \n                if (cond_315493) {\n                    defunc_0_f_res_315494 = (int64_t) 0;\n                } else {\n                    int64_t i_315495 = add64(gtid_315468, x_315486);\n                    int64_t defunc_0_add_arg_315496;\n                    \n                    defunc_0_add_arg_315496 = ((__global\n                                                int64_t *) ext_mem_318542)[gtid_315466 *\n                                                                           n_292675 +\n                                                                           i_315495];\n                    \n                    int64_t defunc_1_add_res_315497 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_315496);\n                    \n                    defunc_0_f_res_315494 = defunc_1_add_res_315497;\n                }\n                \n                double defunc_0_f_res_315498;\n                \n                if (cond_315493) {\n                    defunc_0_f_res_315498 = 0.0;\n                } else {\n                    int64_t i_315499 = add64(gtid_315468, x_315486);\n                    double defunc_0_add_arg_315500;\n                    \n                    defunc_0_add_arg_315500 = ((__global\n                                                double *) mem_319987)[gtid_315466 *\n                                                               ",
            "       n_292675 +\n                                                                      i_315499];\n                    defunc_0_f_res_315498 = defunc_0_add_arg_315500;\n                }\n                \n                int64_t binop_p_315501 = sub64(defunc_0_f_res_315494,\n                                               index_primexp_317879);\n                double defunc_0_f_res_315502 = sitofp_i64_f64(binop_p_315501);\n                double abs_res_315503 = fabs(defunc_0_f_res_315502);\n                double tmp1_315504 = abs_res_315503 / x_315487;\n                double x_315505 = tmp1_315504 * tmp1_315504;\n                double y_315506 = tmp1_315504 * x_315505;\n                double tmp2_315507 = 1.0 - y_315506;\n                double x_315508 = tmp2_315507 * tmp2_315507;\n                double tmp3_315509 = tmp2_315507 * x_315508;\n                double tmp4_315510 = defunc_0_f_res_315498 * tmp3_315509;\n                double defunc_1_f_res_315511 = defunc_0_f_res_315502 *\n                       tmp4_315510;\n                double defunc_0_f_res_315512;\n                \n                if (cond_315493) {\n                    defunc_0_f_res_315512 = 0.0;\n                } else {\n                    int64_t i_315513 = add64(gtid_315468, x_315486);\n                    double defunc_0_add_arg_315514;\n                    \n                    defunc_0_add_arg_315514 = ((__global\n                                                double *) mem_319991)[gtid_315466 *\n                                                                      n_292675 +\n                                                                      i_315513];\n                    defunc_0_f_res_315512 = defunc_0_add_arg_315514;\n                }\n                \n                double x_315515 = a11_315489 * tmp4_315510;\n                double y_315516 = b11_315490 * defunc_1_f_res_315511;\n                double x_315517 = x_315515 + y_315516;\n                double defunc_9_fit_fun_res_315518 = defunc_0_f_",
            "res_315512 *\n                       x_315517;\n                double x_315519 = b11_315490 * tmp4_315510;\n                double y_315520 = c11_315491 * defunc_1_f_res_315511;\n                double x_315521 = x_315519 + y_315520;\n                double defunc_9_slope_fun_res_315522 = defunc_0_f_res_315512 *\n                       x_315521;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_324629)[sext_i32_i64(local_tid_324625)] =\n                        defunc_9_fit_fun_res_315518;\n                    ((__local\n                      double *) red_arr_mem_324631)[sext_i32_i64(local_tid_324625)] =\n                        defunc_9_slope_fun_res_315522;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_324629)[sext_i32_i64(local_tid_324625)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_324631)[sext_i32_i64(local_tid_324625)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_t_292679)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_315470;\n                double x_315471;\n                double x_315472;\n                double x_315473;\n                double x_324640;\n                double x_324641;\n                double x_324642;\n                double x_324643;\n                bool ltid_in_bounds_324646 =\n                     slt64(sext_i32_i64(local_tid_324625), q_t_292679 *\n                           squot64(segred_group_sizze_315461,\n                                   segment_sizze_nonzzero_324622));\n                int32_t skip_threads_324647;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_324646) {\n  ",
            "                      x_315472 = ((volatile __local\n                                     double *) red_arr_mem_324629)[sext_i32_i64(local_tid_324625)];\n                        x_315473 = ((volatile __local\n                                     double *) red_arr_mem_324631)[sext_i32_i64(local_tid_324625)];\n                        if ((local_tid_324625 - squot32(local_tid_324625, 32) *\n                             32) == 0) {\n                            x_315470 = x_315472;\n                            x_315471 = x_315473;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_324647 = 1;\n                    while (slt32(skip_threads_324647, 32)) {\n                        bool thread_active_324648 = sle32(skip_threads_324647,\n                                                          local_tid_324625 -\n                                                          squot32(local_tid_324625,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_324646;\n                        \n                        if (thread_active_324648) {\n                            // read operands\n                            {\n                                x_315470 = ((volatile __local\n                                             double *) red_arr_mem_324629)[sext_i32_i64(local_tid_324625) -\n                                                                           sext_i32_i64(skip_threads_324647)];\n                                x_315471 = ((volatile __local\n                                             double *) red_arr_mem_324631)[sext_i32_i64(local_tid_324625) -\n                                                                           sext_i32_i64(skip_threads_324647)];\n                            }\n                        }\n                        // perform operation\n                        {\n         ",
            "                   bool inactive_324649 =\n                                 slt64(srem64(sext_i32_i64(local_tid_324625),\n                                              q_t_292679),\n                                       sext_i32_i64(local_tid_324625) -\n                                       sext_i32_i64(local_tid_324625 -\n                                       skip_threads_324647));\n                            \n                            if (thread_active_324648 && inactive_324649) {\n                                x_315470 = x_315472;\n                                x_315471 = x_315473;\n                            }\n                            if (thread_active_324648) {\n                                if (!inactive_324649) {\n                                    double defunc_1_op_res_315474 = x_315470 +\n                                           x_315472;\n                                    double defunc_1_op_res_315475 = x_315471 +\n                                           x_315473;\n                                    \n                                    x_315470 = defunc_1_op_res_315474;\n                                    x_315471 = defunc_1_op_res_315475;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_324627, skip_threads_324647)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_324648) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_324629)[sext_i32_i64(local_tid_324625)] =\n                                    x_315470;\n                                x_315472 = x_315470;\n                                ((volatile __local\n                                  double *) red_arr_mem_324631)[sext_i32_i64(local_tid_324625)] =\n                                    x_315471;\n ",
            "                               x_315473 = x_315471;\n                            }\n                        }\n                        if (sle32(wave_sizze_324627, skip_threads_324647)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_324647 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_324625 - squot32(local_tid_324625, 32) *\n                         32) == 31 && ltid_in_bounds_324646) {\n                        ((volatile __local\n                          double *) red_arr_mem_324629)[sext_i32_i64(squot32(local_tid_324625,\n                                                                             32))] =\n                            x_315470;\n                        ((volatile __local\n                          double *) red_arr_mem_324631)[sext_i32_i64(squot32(local_tid_324625,\n                                                                             32))] =\n                            x_315471;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_324650;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_324625, 32) == 0 &&\n                            ltid_in_bounds_324646) {\n                            x_324642 = ((volatile __local\n                                         double *) red_arr_mem_324629)[sext_i32_i64(local_tid_324625)];\n                            x_324643 = ((volatile __local\n                                         double *) red_arr_mem_324631)[sext_i32_i64(local_tid_324625)];\n                            if ((local_tid_324625 -",
            " squot32(local_tid_324625,\n                                                            32) * 32) == 0) {\n                                x_324640 = x_324642;\n                                x_324641 = x_324643;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_324650 = 1;\n                        while (slt32(skip_threads_324650, 32)) {\n                            bool thread_active_324651 =\n                                 sle32(skip_threads_324650, local_tid_324625 -\n                                       squot32(local_tid_324625, 32) * 32) &&\n                                 (squot32(local_tid_324625, 32) == 0 &&\n                                  ltid_in_bounds_324646);\n                            \n                            if (thread_active_324651) {\n                                // read operands\n                                {\n                                    x_324640 = ((volatile __local\n                                                 double *) red_arr_mem_324629)[sext_i32_i64(local_tid_324625) -\n                                                                               sext_i32_i64(skip_threads_324650)];\n                                    x_324641 = ((volatile __local\n                                                 double *) red_arr_mem_324631)[sext_i32_i64(local_tid_324625) -\n                                                                               sext_i32_i64(skip_threads_324650)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_324652 =\n                                     slt64(srem64(sext_i32_i64(local_tid_324625 *\n                                                  32 + 32 - 1), q_t_292679),\n                                           sext_i32_i",
            "64(local_tid_324625 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_324625 -\n                                                         skip_threads_324650) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_324651 && inactive_324652) {\n                                    x_324640 = x_324642;\n                                    x_324641 = x_324643;\n                                }\n                                if (thread_active_324651) {\n                                    if (!inactive_324652) {\n                                        double defunc_1_op_res_324644 =\n                                               x_324640 + x_324642;\n                                        double defunc_1_op_res_324645 =\n                                               x_324641 + x_324643;\n                                        \n                                        x_324640 = defunc_1_op_res_324644;\n                                        x_324641 = defunc_1_op_res_324645;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_324627, skip_threads_324650)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_324651) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_324629)[sext_i32_i64(local_tid_324625)] =\n                                        x_324640;\n                                    x_324642 = x_324640;\n                                    ((volatile __local\n                                      double *) red_arr_mem_324631)[sext_i32_i64(local_tid_324625)] =\n                     ",
            "                   x_324641;\n                                    x_324643 = x_324641;\n                                }\n                            }\n                            if (sle32(wave_sizze_324627, skip_threads_324650)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_324650 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_324653 = squot32(local_tid_324625, 32) == 0 ||\n                     !ltid_in_bounds_324646;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_324653) {\n                            x_315472 = x_315470;\n                            x_315473 = x_315471;\n                            x_315470 = ((__local\n                                         double *) red_arr_mem_324629)[sext_i32_i64(squot32(local_tid_324625,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_315471 = ((__local\n                                         double *) red_arr_mem_324631)[sext_i32_i64(squot32(local_tid_324625,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_324654 =\n                             slt64(srem64(sext_i32_i64(local_tid_324625),\n                                          q_t_292679),\n                                   sext_i32_i64(local_tid_324625) -\n                        ",
            "           sext_i32_i64(squot32(local_tid_324625, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_324653) {\n                            if (inactive_324654) {\n                                x_315470 = x_315472;\n                                x_315471 = x_315473;\n                            }\n                        }\n                        if (!no_carry_in_324653) {\n                            if (!inactive_324654) {\n                                double defunc_1_op_res_315474 = x_315470 +\n                                       x_315472;\n                                double defunc_1_op_res_315475 = x_315471 +\n                                       x_315473;\n                                \n                                x_315470 = defunc_1_op_res_315474;\n                                x_315471 = defunc_1_op_res_315475;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_324653) {\n                            ((__local\n                              double *) red_arr_mem_324629)[sext_i32_i64(local_tid_324625)] =\n                                x_315470;\n                            ((__local\n                              double *) red_arr_mem_324631)[sext_i32_i64(local_tid_324625)] =\n                                x_315471;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_324625, 32) == 0 &&\n                        ltid_in_bounds_324646) {\n                        ((__local\n                          double *) red_arr_mem_324629)[sext_i32_i64(local_tid_324625)] =\n                            x_315472;\n                        ((__local\n                          double *) red_arr_mem_324631)[",
            "sext_i32_i64(local_tid_324625)] =\n                            x_315473;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_324635) *\n                      squot64(segred_group_sizze_315461,\n                              segment_sizze_nonzzero_324622) +\n                      sext_i32_i64(local_tid_324625), partition_sizze_292766 *\n                      t_n_m_292839) && slt64(sext_i32_i64(local_tid_324625),\n                                             squot64(segred_group_sizze_315461,\n                                                     segment_sizze_nonzzero_324622))) {\n                double tmp_324655;\n                \n                tmp_324655 = ((__local\n                               double *) red_arr_mem_324629)[(sext_i32_i64(local_tid_324625) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324622 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_320022)[squot64(sext_i32_i64(virt_group_id_324635) *\n                                                squot64(segred_group_sizze_315461,\n                                                        segment_sizze_nonzzero_324622) +\n                                                sext_i32_i64(local_tid_324625),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324635) *\n                                         squot64(segred_group_sizze_315461,\n                                                 segment_sizze_nonzzero_324622) +\n                                         sext_i32_i64(local_tid_324625) -\n                                         s",
            "quot64(sext_i32_i64(virt_group_id_324635) *\n                                                 squot64(segred_group_sizze_315461,\n                                                         segment_sizze_nonzzero_324622) +\n                                                 sext_i32_i64(local_tid_324625),\n                                                 t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324655;\n                \n                double tmp_324656;\n                \n                tmp_324656 = ((__local\n                               double *) red_arr_mem_324631)[(sext_i32_i64(local_tid_324625) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324622 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_320026)[squot64(sext_i32_i64(virt_group_id_324635) *\n                                                squot64(segred_group_sizze_315461,\n                                                        segment_sizze_nonzzero_324622) +\n                                                sext_i32_i64(local_tid_324625),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324635) *\n                                         squot64(segred_group_sizze_315461,\n                                                 segment_sizze_nonzzero_324622) +\n                                         sext_i32_i64(local_tid_324625) -\n                                         squot64(sext_i32_i64(virt_group_id_324635) *\n                                                 squot64(segred_group_sizze_315461,\n                                                         segment_sizze_nonzzero_324622) +\n                                                 sext_i32_i64(local_tid_324625),\n                        ",
            "                         t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324656;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_315461\n}\n__kernel void mainzisegred_small_316122(__global int *global_failure,\n                                        uint red_arr_mem_324744_backing_offset_0,\n                                        uint red_arr_mem_324742_backing_offset_1,\n                                        uint red_arr_mem_324740_backing_offset_2,\n                                        uint red_arr_mem_324738_backing_offset_3,\n                                        uint red_arr_mem_324736_backing_offset_4,\n                                        int64_t n_292675, int64_t q_t_292679,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t t_n_m_292839, int64_t i_292846,\n                                        int64_t num_groups_316112,\n                                        int64_t segment_sizze_nonzzero_324729,\n                                        __global unsigned char *ext_mem_318541,\n                                        __global unsigned char *ext_mem_318542,\n                                        __global unsigned char *ext_mem_318805,\n                                        __global unsigned char *ext_mem_318806,\n                                        __global unsigned char *mem_320036,\n                                        __global unsigned char *mem_320045,\n                                        __global unsigned char *mem_320049,\n                                        __global unsigned char *mem_320053,\n                                        __global unsigned char *mem_320057,\n                                        __global unsigned char *mem_320061",
            ")\n{\n    #define segred_group_sizze_316111 (mainzisegred_group_sizze_315686)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_324744_backing_4 =\n                           &shared_mem[red_arr_mem_324744_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324742_backing_3 =\n                           &shared_mem[red_arr_mem_324742_backing_offset_1];\n    volatile unsigned char *red_arr_mem_324740_backing_2 =\n                           &shared_mem[red_arr_mem_324740_backing_offset_2];\n    volatile unsigned char *red_arr_mem_324738_backing_1 =\n                           &shared_mem[red_arr_mem_324738_backing_offset_3];\n    volatile unsigned char *red_arr_mem_324736_backing_0 =\n                           &shared_mem[red_arr_mem_324736_backing_offset_4];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324731;\n    int32_t local_tid_324732;\n    int64_t group_sizze_324735;\n    int32_t wave_sizze_324734;\n    int32_t group_tid_324733;\n    \n    global_tid_324731 = get_global_id(0);\n    local_tid_324732 = get_local_id(0);\n    group_sizze_324735 = get_local_size(0);\n    wave_sizze_324734 = LOCKSTEP_WIDTH;\n    group_tid_324733 = get_group_id(0);\n    \n    int32_t phys_tid_316122 = global_tid_324731;\n    __local unsigned char *red_arr_mem_324736;\n    \n    red_arr_mem_324736 = (__local unsigned char *) red_arr_mem_324736_backing_0;\n    \n    __local unsigned char *red_arr_mem_324738;\n    \n    red_arr_mem_324738 = (__local unsigned char *) red_arr_mem_324738_backing_1;\n    \n    __local unsigned char *red_arr_mem_324740;\n    \n    red_arr_mem_324740 = (__local unsigned char *) red_arr_mem_324740_backing_2;\n    \n    __local unsigned char *red_arr_mem_324742;\n    \n    red_arr_mem_324742 = (__local unsigned char *) red_arr_mem_324742_backing_3;\n    \n    __local unsigned char *red_arr_mem_324744;\n    \n    red_arr_mem_324744 = (__local unsigned char *) red_arr_mem_324744_",
            "backing_4;\n    \n    int32_t phys_group_id_324746;\n    \n    phys_group_id_324746 = get_group_id(0);\n    for (int32_t i_324747 = 0; i_324747 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * t_n_m_292839,\n                                          squot64(segred_group_sizze_316111,\n                                                  segment_sizze_nonzzero_324729))) -\n                   phys_group_id_324746, sext_i64_i32(num_groups_316112));\n         i_324747++) {\n        int32_t virt_group_id_324748 = phys_group_id_324746 + i_324747 *\n                sext_i64_i32(num_groups_316112);\n        int64_t slice_324749 = t_n_m_292839;\n        int64_t slice_324750 = partition_sizze_292766 * slice_324749;\n        int64_t gtid_316119 = squot64(squot64(sext_i32_i64(local_tid_324732),\n                                              segment_sizze_nonzzero_324729) +\n                                      sext_i32_i64(virt_group_id_324748) *\n                                      squot64(segred_group_sizze_316111,\n                                              segment_sizze_nonzzero_324729),\n                                      slice_324749);\n        int64_t remnant_324751 = squot64(sext_i32_i64(local_tid_324732),\n                                         segment_sizze_nonzzero_324729) +\n                sext_i32_i64(virt_group_id_324748) *\n                squot64(segred_group_sizze_316111,\n                        segment_sizze_nonzzero_324729) - gtid_316119 *\n                slice_324749;\n        int64_t gtid_316120 = remnant_324751;\n        int64_t remnant_324752 = remnant_324751 - gtid_316120;\n        int64_t gtid_316121 = srem64(sext_i32_i64(local_tid_324732),\n                                     q_t_292679);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_t_292679) && ((slt64(gtid_316119,\n                                                          partition_sizze_292766) &&\n                                               ",
            "     slt64(gtid_316120,\n                                                          t_n_m_292839)) &&\n                                                   slt64(sext_i32_i64(local_tid_324732),\n                                                         q_t_292679 *\n                                                         squot64(segred_group_sizze_316111,\n                                                                 segment_sizze_nonzzero_324729)))) {\n                int64_t x_316139;\n                \n                x_316139 = ((__global int64_t *) ext_mem_318541)[gtid_316119];\n                \n                int64_t x_316144;\n                \n                x_316144 = ((__global int64_t *) ext_mem_318806)[gtid_316119 *\n                                                                 t_n_m_292839 +\n                                                                 gtid_316120];\n                \n                double x_316145;\n                \n                x_316145 = ((__global double *) ext_mem_318805)[gtid_316119 *\n                                                                t_n_m_292839 +\n                                                                gtid_316120];\n                \n                int64_t binop_y_317892 = mul64(jump_t_292685, gtid_316120);\n                int64_t binop_y_317893 = smin64(i_292846, binop_y_317892);\n                int64_t index_primexp_317894 = add64((int64_t) 1,\n                                                     binop_y_317893);\n                bool cond_316148 = sle64(x_316139, gtid_316121);\n                int64_t defunc_0_f_res_316149;\n                \n                if (cond_316148) {\n                    defunc_0_f_res_316149 = (int64_t) 0;\n                } else {\n                    int64_t i_316150 = add64(gtid_316121, x_316144);\n                    int64_t defunc_0_add_arg_316151;\n                    \n                    defunc_0_add_arg_316151 = ((__global\n                                                int64_t *) e",
            "xt_mem_318542)[gtid_316119 *\n                                                                           n_292675 +\n                                                                           i_316150];\n                    \n                    int64_t defunc_1_add_res_316152 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_316151);\n                    \n                    defunc_0_f_res_316149 = defunc_1_add_res_316152;\n                }\n                \n                double defunc_0_f_res_316153;\n                \n                if (cond_316148) {\n                    defunc_0_f_res_316153 = 0.0;\n                } else {\n                    int64_t i_316154 = add64(gtid_316121, x_316144);\n                    double defunc_0_add_arg_316155;\n                    \n                    defunc_0_add_arg_316155 = ((__global\n                                                double *) mem_320036)[gtid_316119 *\n                                                                      n_292675 +\n                                                                      i_316154];\n                    defunc_0_f_res_316153 = defunc_0_add_arg_316155;\n                }\n                \n                int64_t binop_p_316156 = sub64(defunc_0_f_res_316149,\n                                               index_primexp_317894);\n                double defunc_0_f_res_316157 = sitofp_i64_f64(binop_p_316156);\n                double abs_res_316158 = fabs(defunc_0_f_res_316157);\n                double tmp1_316159 = abs_res_316158 / x_316145;\n                double x_316160 = tmp1_316159 * tmp1_316159;\n                double y_316161 = tmp1_316159 * x_316160;\n                double tmp2_316162 = 1.0 - y_316161;\n                double x_316163 = tmp2_316162 * tmp2_316162;\n                double tmp3_316164 = tmp2_316162 * x_316163;\n                double w_j_316165 = defunc_0_f_res_316153 * tmp3_316164;\n                double xw_j_316166 = defunc_0_f_res_31",
            "6157 * w_j_316165;\n                double x2w_j_316167 = defunc_0_f_res_316157 * xw_j_316166;\n                double x3w_j_316168 = defunc_0_f_res_316157 * x2w_j_316167;\n                double x4w_j_316169 = defunc_0_f_res_316157 * x3w_j_316168;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_324736)[sext_i32_i64(local_tid_324732)] =\n                        w_j_316165;\n                    ((__local\n                      double *) red_arr_mem_324738)[sext_i32_i64(local_tid_324732)] =\n                        xw_j_316166;\n                    ((__local\n                      double *) red_arr_mem_324740)[sext_i32_i64(local_tid_324732)] =\n                        x2w_j_316167;\n                    ((__local\n                      double *) red_arr_mem_324742)[sext_i32_i64(local_tid_324732)] =\n                        x3w_j_316168;\n                    ((__local\n                      double *) red_arr_mem_324744)[sext_i32_i64(local_tid_324732)] =\n                        x4w_j_316169;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_324736)[sext_i32_i64(local_tid_324732)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_324738)[sext_i32_i64(local_tid_324732)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_324740)[sext_i32_i64(local_tid_324732)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_324742)[sext_i32_i64(local_tid_324732)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_324744)[sext_i32_i64(local_tid_324732)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_t_292679)) {\n            // perform segmented s",
            "can to imitate reduction\n            {\n                double x_316123;\n                double x_316124;\n                double x_316125;\n                double x_316126;\n                double x_316127;\n                double x_316128;\n                double x_316129;\n                double x_316130;\n                double x_316131;\n                double x_316132;\n                double x_324753;\n                double x_324754;\n                double x_324755;\n                double x_324756;\n                double x_324757;\n                double x_324758;\n                double x_324759;\n                double x_324760;\n                double x_324761;\n                double x_324762;\n                bool ltid_in_bounds_324768 =\n                     slt64(sext_i32_i64(local_tid_324732), q_t_292679 *\n                           squot64(segred_group_sizze_316111,\n                                   segment_sizze_nonzzero_324729));\n                int32_t skip_threads_324769;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_324768) {\n                        x_316128 = ((volatile __local\n                                     double *) red_arr_mem_324736)[sext_i32_i64(local_tid_324732)];\n                        x_316129 = ((volatile __local\n                                     double *) red_arr_mem_324738)[sext_i32_i64(local_tid_324732)];\n                        x_316130 = ((volatile __local\n                                     double *) red_arr_mem_324740)[sext_i32_i64(local_tid_324732)];\n                        x_316131 = ((volatile __local\n                                     double *) red_arr_mem_324742)[sext_i32_i64(local_tid_324732)];\n                        x_316132 = ((volatile __local\n                                     double *) red_arr_mem_324744)[sext_i32_i64(local_tid_324732)];\n                        if ((local_tid_324732 - squot32(local_tid_324732, 32) *\n                           ",
            "  32) == 0) {\n                            x_316123 = x_316128;\n                            x_316124 = x_316129;\n                            x_316125 = x_316130;\n                            x_316126 = x_316131;\n                            x_316127 = x_316132;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_324769 = 1;\n                    while (slt32(skip_threads_324769, 32)) {\n                        bool thread_active_324770 = sle32(skip_threads_324769,\n                                                          local_tid_324732 -\n                                                          squot32(local_tid_324732,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_324768;\n                        \n                        if (thread_active_324770) {\n                            // read operands\n                            {\n                                x_316123 = ((volatile __local\n                                             double *) red_arr_mem_324736)[sext_i32_i64(local_tid_324732) -\n                                                                           sext_i32_i64(skip_threads_324769)];\n                                x_316124 = ((volatile __local\n                                             double *) red_arr_mem_324738)[sext_i32_i64(local_tid_324732) -\n                                                                           sext_i32_i64(skip_threads_324769)];\n                                x_316125 = ((volatile __local\n                                             double *) red_arr_mem_324740)[sext_i32_i64(local_tid_324732) -\n                                                                           sext_i32_i64(skip_threads_324769)];\n                                x_316126 = ((volatile __local\n                                             double *) red_",
            "arr_mem_324742)[sext_i32_i64(local_tid_324732) -\n                                                                           sext_i32_i64(skip_threads_324769)];\n                                x_316127 = ((volatile __local\n                                             double *) red_arr_mem_324744)[sext_i32_i64(local_tid_324732) -\n                                                                           sext_i32_i64(skip_threads_324769)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_324771 =\n                                 slt64(srem64(sext_i32_i64(local_tid_324732),\n                                              q_t_292679),\n                                       sext_i32_i64(local_tid_324732) -\n                                       sext_i32_i64(local_tid_324732 -\n                                       skip_threads_324769));\n                            \n                            if (thread_active_324770 && inactive_324771) {\n                                x_316123 = x_316128;\n                                x_316124 = x_316129;\n                                x_316125 = x_316130;\n                                x_316126 = x_316131;\n                                x_316127 = x_316132;\n                            }\n                            if (thread_active_324770) {\n                                if (!inactive_324771) {\n                                    double defunc_1_op_res_316133 = x_316123 +\n                                           x_316128;\n                                    double defunc_1_op_res_316134 = x_316124 +\n                                           x_316129;\n                                    double defunc_1_op_res_316135 = x_316125 +\n                                           x_316130;\n                                    double defunc_1_op_res_316136 = x_316126 +\n                                           x_316131;\n",
            "                                    double defunc_1_op_res_316137 = x_316127 +\n                                           x_316132;\n                                    \n                                    x_316123 = defunc_1_op_res_316133;\n                                    x_316124 = defunc_1_op_res_316134;\n                                    x_316125 = defunc_1_op_res_316135;\n                                    x_316126 = defunc_1_op_res_316136;\n                                    x_316127 = defunc_1_op_res_316137;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_324734, skip_threads_324769)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_324770) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_324736)[sext_i32_i64(local_tid_324732)] =\n                                    x_316123;\n                                x_316128 = x_316123;\n                                ((volatile __local\n                                  double *) red_arr_mem_324738)[sext_i32_i64(local_tid_324732)] =\n                                    x_316124;\n                                x_316129 = x_316124;\n                                ((volatile __local\n                                  double *) red_arr_mem_324740)[sext_i32_i64(local_tid_324732)] =\n                                    x_316125;\n                                x_316130 = x_316125;\n                                ((volatile __local\n                                  double *) red_arr_mem_324742)[sext_i32_i64(local_tid_324732)] =\n                                    x_316126;\n                                x_316131 = x_316126;\n                                ((volatile __local\n                                  double *) red_arr_mem_",
            "324744)[sext_i32_i64(local_tid_324732)] =\n                                    x_316127;\n                                x_316132 = x_316127;\n                            }\n                        }\n                        if (sle32(wave_sizze_324734, skip_threads_324769)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_324769 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_324732 - squot32(local_tid_324732, 32) *\n                         32) == 31 && ltid_in_bounds_324768) {\n                        ((volatile __local\n                          double *) red_arr_mem_324736)[sext_i32_i64(squot32(local_tid_324732,\n                                                                             32))] =\n                            x_316123;\n                        ((volatile __local\n                          double *) red_arr_mem_324738)[sext_i32_i64(squot32(local_tid_324732,\n                                                                             32))] =\n                            x_316124;\n                        ((volatile __local\n                          double *) red_arr_mem_324740)[sext_i32_i64(squot32(local_tid_324732,\n                                                                             32))] =\n                            x_316125;\n                        ((volatile __local\n                          double *) red_arr_mem_324742)[sext_i32_i64(squot32(local_tid_324732,\n                                                                             32))] =\n                            x_316126;\n                        ((volatile __local\n                          double *) red_arr_mem_324744)[sext_i32_i64(squot32(local_tid_324732,\n                                                                             32))] =\n      ",
            "                      x_316127;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_324772;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_324732, 32) == 0 &&\n                            ltid_in_bounds_324768) {\n                            x_324758 = ((volatile __local\n                                         double *) red_arr_mem_324736)[sext_i32_i64(local_tid_324732)];\n                            x_324759 = ((volatile __local\n                                         double *) red_arr_mem_324738)[sext_i32_i64(local_tid_324732)];\n                            x_324760 = ((volatile __local\n                                         double *) red_arr_mem_324740)[sext_i32_i64(local_tid_324732)];\n                            x_324761 = ((volatile __local\n                                         double *) red_arr_mem_324742)[sext_i32_i64(local_tid_324732)];\n                            x_324762 = ((volatile __local\n                                         double *) red_arr_mem_324744)[sext_i32_i64(local_tid_324732)];\n                            if ((local_tid_324732 - squot32(local_tid_324732,\n                                                            32) * 32) == 0) {\n                                x_324753 = x_324758;\n                                x_324754 = x_324759;\n                                x_324755 = x_324760;\n                                x_324756 = x_324761;\n                                x_324757 = x_324762;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_324772 = 1;\n                        while (slt32(skip_threads_32477",
            "2, 32)) {\n                            bool thread_active_324773 =\n                                 sle32(skip_threads_324772, local_tid_324732 -\n                                       squot32(local_tid_324732, 32) * 32) &&\n                                 (squot32(local_tid_324732, 32) == 0 &&\n                                  ltid_in_bounds_324768);\n                            \n                            if (thread_active_324773) {\n                                // read operands\n                                {\n                                    x_324753 = ((volatile __local\n                                                 double *) red_arr_mem_324736)[sext_i32_i64(local_tid_324732) -\n                                                                               sext_i32_i64(skip_threads_324772)];\n                                    x_324754 = ((volatile __local\n                                                 double *) red_arr_mem_324738)[sext_i32_i64(local_tid_324732) -\n                                                                               sext_i32_i64(skip_threads_324772)];\n                                    x_324755 = ((volatile __local\n                                                 double *) red_arr_mem_324740)[sext_i32_i64(local_tid_324732) -\n                                                                               sext_i32_i64(skip_threads_324772)];\n                                    x_324756 = ((volatile __local\n                                                 double *) red_arr_mem_324742)[sext_i32_i64(local_tid_324732) -\n                                                                               sext_i32_i64(skip_threads_324772)];\n                                    x_324757 = ((volatile __local\n                                                 double *) red_arr_mem_324744)[sext_i32_i64(local_tid_324732) -\n                                                                               sext_i32_i64(skip_threads_324772)];\n              ",
            "                  }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_324774 =\n                                     slt64(srem64(sext_i32_i64(local_tid_324732 *\n                                                  32 + 32 - 1), q_t_292679),\n                                           sext_i32_i64(local_tid_324732 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_324732 -\n                                                         skip_threads_324772) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_324773 && inactive_324774) {\n                                    x_324753 = x_324758;\n                                    x_324754 = x_324759;\n                                    x_324755 = x_324760;\n                                    x_324756 = x_324761;\n                                    x_324757 = x_324762;\n                                }\n                                if (thread_active_324773) {\n                                    if (!inactive_324774) {\n                                        double defunc_1_op_res_324763 =\n                                               x_324753 + x_324758;\n                                        double defunc_1_op_res_324764 =\n                                               x_324754 + x_324759;\n                                        double defunc_1_op_res_324765 =\n                                               x_324755 + x_324760;\n                                        double defunc_1_op_res_324766 =\n                                               x_324756 + x_324761;\n                                        double defunc_1_op_res_324767 =\n                                               x_324757 + x_324762;\n                                        \n                  ",
            "                      x_324753 = defunc_1_op_res_324763;\n                                        x_324754 = defunc_1_op_res_324764;\n                                        x_324755 = defunc_1_op_res_324765;\n                                        x_324756 = defunc_1_op_res_324766;\n                                        x_324757 = defunc_1_op_res_324767;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_324734, skip_threads_324772)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_324773) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_324736)[sext_i32_i64(local_tid_324732)] =\n                                        x_324753;\n                                    x_324758 = x_324753;\n                                    ((volatile __local\n                                      double *) red_arr_mem_324738)[sext_i32_i64(local_tid_324732)] =\n                                        x_324754;\n                                    x_324759 = x_324754;\n                                    ((volatile __local\n                                      double *) red_arr_mem_324740)[sext_i32_i64(local_tid_324732)] =\n                                        x_324755;\n                                    x_324760 = x_324755;\n                                    ((volatile __local\n                                      double *) red_arr_mem_324742)[sext_i32_i64(local_tid_324732)] =\n                                        x_324756;\n                                    x_324761 = x_324756;\n                                    ((volatile __local\n                                      double *) red_arr_mem_324744)[sext_i32_i64(local_tid_324732)] =\n                 ",
            "                       x_324757;\n                                    x_324762 = x_324757;\n                                }\n                            }\n                            if (sle32(wave_sizze_324734, skip_threads_324772)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_324772 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_324775 = squot32(local_tid_324732, 32) == 0 ||\n                     !ltid_in_bounds_324768;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_324775) {\n                            x_316128 = x_316123;\n                            x_316129 = x_316124;\n                            x_316130 = x_316125;\n                            x_316131 = x_316126;\n                            x_316132 = x_316127;\n                            x_316123 = ((__local\n                                         double *) red_arr_mem_324736)[sext_i32_i64(squot32(local_tid_324732,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_316124 = ((__local\n                                         double *) red_arr_mem_324738)[sext_i32_i64(squot32(local_tid_324732,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_316125 = ((__local\n                                         double *) red_arr_mem_324740)[sext_i32_i64(squot32(local_tid_324732,\n                                                                     ",
            "                       32)) -\n                                                                       (int64_t) 1];\n                            x_316126 = ((__local\n                                         double *) red_arr_mem_324742)[sext_i32_i64(squot32(local_tid_324732,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_316127 = ((__local\n                                         double *) red_arr_mem_324744)[sext_i32_i64(squot32(local_tid_324732,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_324776 =\n                             slt64(srem64(sext_i32_i64(local_tid_324732),\n                                          q_t_292679),\n                                   sext_i32_i64(local_tid_324732) -\n                                   sext_i32_i64(squot32(local_tid_324732, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_324775) {\n                            if (inactive_324776) {\n                                x_316123 = x_316128;\n                                x_316124 = x_316129;\n                                x_316125 = x_316130;\n                                x_316126 = x_316131;\n                                x_316127 = x_316132;\n                            }\n                        }\n                        if (!no_carry_in_324775) {\n                            if (!inactive_324776) {\n                                double defunc_1_op_res_316133 = x_316123 +\n                                       x_316128;\n                                double defun",
            "c_1_op_res_316134 = x_316124 +\n                                       x_316129;\n                                double defunc_1_op_res_316135 = x_316125 +\n                                       x_316130;\n                                double defunc_1_op_res_316136 = x_316126 +\n                                       x_316131;\n                                double defunc_1_op_res_316137 = x_316127 +\n                                       x_316132;\n                                \n                                x_316123 = defunc_1_op_res_316133;\n                                x_316124 = defunc_1_op_res_316134;\n                                x_316125 = defunc_1_op_res_316135;\n                                x_316126 = defunc_1_op_res_316136;\n                                x_316127 = defunc_1_op_res_316137;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_324775) {\n                            ((__local\n                              double *) red_arr_mem_324736)[sext_i32_i64(local_tid_324732)] =\n                                x_316123;\n                            ((__local\n                              double *) red_arr_mem_324738)[sext_i32_i64(local_tid_324732)] =\n                                x_316124;\n                            ((__local\n                              double *) red_arr_mem_324740)[sext_i32_i64(local_tid_324732)] =\n                                x_316125;\n                            ((__local\n                              double *) red_arr_mem_324742)[sext_i32_i64(local_tid_324732)] =\n                                x_316126;\n                            ((__local\n                              double *) red_arr_mem_324744)[sext_i32_i64(local_tid_324732)] =\n                                x_316127;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n     ",
            "           // restore correct values for first block\n                {\n                    if (squot32(local_tid_324732, 32) == 0 &&\n                        ltid_in_bounds_324768) {\n                        ((__local\n                          double *) red_arr_mem_324736)[sext_i32_i64(local_tid_324732)] =\n                            x_316128;\n                        ((__local\n                          double *) red_arr_mem_324738)[sext_i32_i64(local_tid_324732)] =\n                            x_316129;\n                        ((__local\n                          double *) red_arr_mem_324740)[sext_i32_i64(local_tid_324732)] =\n                            x_316130;\n                        ((__local\n                          double *) red_arr_mem_324742)[sext_i32_i64(local_tid_324732)] =\n                            x_316131;\n                        ((__local\n                          double *) red_arr_mem_324744)[sext_i32_i64(local_tid_324732)] =\n                            x_316132;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_324748) *\n                      squot64(segred_group_sizze_316111,\n                              segment_sizze_nonzzero_324729) +\n                      sext_i32_i64(local_tid_324732), partition_sizze_292766 *\n                      t_n_m_292839) && slt64(sext_i32_i64(local_tid_324732),\n                                             squot64(segred_group_sizze_316111,\n                                                     segment_sizze_nonzzero_324729))) {\n                double tmp_324777;\n                \n                tmp_324777 = ((__local\n                               double *) red_arr_mem_324736)[(sext_i32_i64(local_tid_324732) +\n                                                              (int64_t) 1) *\n                                           ",
            "                  segment_sizze_nonzzero_324729 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_320045)[squot64(sext_i32_i64(virt_group_id_324748) *\n                                                squot64(segred_group_sizze_316111,\n                                                        segment_sizze_nonzzero_324729) +\n                                                sext_i32_i64(local_tid_324732),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324748) *\n                                         squot64(segred_group_sizze_316111,\n                                                 segment_sizze_nonzzero_324729) +\n                                         sext_i32_i64(local_tid_324732) -\n                                         squot64(sext_i32_i64(virt_group_id_324748) *\n                                                 squot64(segred_group_sizze_316111,\n                                                         segment_sizze_nonzzero_324729) +\n                                                 sext_i32_i64(local_tid_324732),\n                                                 t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324777;\n                \n                double tmp_324778;\n                \n                tmp_324778 = ((__local\n                               double *) red_arr_mem_324738)[(sext_i32_i64(local_tid_324732) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324729 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_320049)[squot64(sext_i32_i64(virt_group_id_324748) *\n                                                squot64(segred_group_sizze_316111,\n   ",
            "                                                     segment_sizze_nonzzero_324729) +\n                                                sext_i32_i64(local_tid_324732),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324748) *\n                                         squot64(segred_group_sizze_316111,\n                                                 segment_sizze_nonzzero_324729) +\n                                         sext_i32_i64(local_tid_324732) -\n                                         squot64(sext_i32_i64(virt_group_id_324748) *\n                                                 squot64(segred_group_sizze_316111,\n                                                         segment_sizze_nonzzero_324729) +\n                                                 sext_i32_i64(local_tid_324732),\n                                                 t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324778;\n                \n                double tmp_324779;\n                \n                tmp_324779 = ((__local\n                               double *) red_arr_mem_324740)[(sext_i32_i64(local_tid_324732) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324729 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_320053)[squot64(sext_i32_i64(virt_group_id_324748) *\n                                                squot64(segred_group_sizze_316111,\n                                                        segment_sizze_nonzzero_324729) +\n                                                sext_i32_i64(local_tid_324732),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324748) *\n",
            "                                         squot64(segred_group_sizze_316111,\n                                                 segment_sizze_nonzzero_324729) +\n                                         sext_i32_i64(local_tid_324732) -\n                                         squot64(sext_i32_i64(virt_group_id_324748) *\n                                                 squot64(segred_group_sizze_316111,\n                                                         segment_sizze_nonzzero_324729) +\n                                                 sext_i32_i64(local_tid_324732),\n                                                 t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324779;\n                \n                double tmp_324780;\n                \n                tmp_324780 = ((__local\n                               double *) red_arr_mem_324742)[(sext_i32_i64(local_tid_324732) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324729 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_320057)[squot64(sext_i32_i64(virt_group_id_324748) *\n                                                squot64(segred_group_sizze_316111,\n                                                        segment_sizze_nonzzero_324729) +\n                                                sext_i32_i64(local_tid_324732),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324748) *\n                                         squot64(segred_group_sizze_316111,\n                                                 segment_sizze_nonzzero_324729) +\n                                         sext_i32_i64(local_tid_324732) -\n                                         squot64(sext_i32_i64(virt_group_id_324748) *\n     ",
            "                                            squot64(segred_group_sizze_316111,\n                                                         segment_sizze_nonzzero_324729) +\n                                                 sext_i32_i64(local_tid_324732),\n                                                 t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324780;\n                \n                double tmp_324781;\n                \n                tmp_324781 = ((__local\n                               double *) red_arr_mem_324744)[(sext_i32_i64(local_tid_324732) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324729 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_320061)[squot64(sext_i32_i64(virt_group_id_324748) *\n                                                squot64(segred_group_sizze_316111,\n                                                        segment_sizze_nonzzero_324729) +\n                                                sext_i32_i64(local_tid_324732),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324748) *\n                                         squot64(segred_group_sizze_316111,\n                                                 segment_sizze_nonzzero_324729) +\n                                         sext_i32_i64(local_tid_324732) -\n                                         squot64(sext_i32_i64(virt_group_id_324748) *\n                                                 squot64(segred_group_sizze_316111,\n                                                         segment_sizze_nonzzero_324729) +\n                                                 sext_i32_i64(local_tid_324732),\n                                                 t_n_m_292839) *\n        ",
            "                                 t_n_m_292839)] = tmp_324781;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_316111\n}\n__kernel void mainzisegred_small_316228(__global int *global_failure,\n                                        uint red_arr_mem_324877_backing_offset_0,\n                                        uint red_arr_mem_324875_backing_offset_1,\n                                        int64_t n_292675, int64_t q_t_292679,\n                                        int64_t jump_t_292685,\n                                        int64_t partition_sizze_292766,\n                                        int64_t t_n_m_292839, int64_t i_292846,\n                                        int64_t num_groups_316221,\n                                        int64_t segment_sizze_nonzzero_324868,\n                                        __global unsigned char *ext_mem_318541,\n                                        __global unsigned char *ext_mem_318542,\n                                        __global unsigned char *ext_mem_318805,\n                                        __global unsigned char *ext_mem_318806,\n                                        __global unsigned char *mem_320036,\n                                        __global unsigned char *mem_320040,\n                                        __global unsigned char *mem_320066,\n                                        __global unsigned char *mem_320070,\n                                        __global unsigned char *mem_320074,\n                                        __global unsigned char *mem_320078,\n                                        __global unsigned char *mem_320082,\n                                        __global unsigned char *mem_320087,\n                                        __global unsigned char *mem_320091)\n{\n    #define segred_group_sizze_316220 (mainzisegred_group_sizze",
            "_315552)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_324877_backing_1 =\n                           &shared_mem[red_arr_mem_324877_backing_offset_0];\n    volatile unsigned char *red_arr_mem_324875_backing_0 =\n                           &shared_mem[red_arr_mem_324875_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_324870;\n    int32_t local_tid_324871;\n    int64_t group_sizze_324874;\n    int32_t wave_sizze_324873;\n    int32_t group_tid_324872;\n    \n    global_tid_324870 = get_global_id(0);\n    local_tid_324871 = get_local_id(0);\n    group_sizze_324874 = get_local_size(0);\n    wave_sizze_324873 = LOCKSTEP_WIDTH;\n    group_tid_324872 = get_group_id(0);\n    \n    int32_t phys_tid_316228 = global_tid_324870;\n    __local unsigned char *red_arr_mem_324875;\n    \n    red_arr_mem_324875 = (__local unsigned char *) red_arr_mem_324875_backing_0;\n    \n    __local unsigned char *red_arr_mem_324877;\n    \n    red_arr_mem_324877 = (__local unsigned char *) red_arr_mem_324877_backing_1;\n    \n    int32_t phys_group_id_324879;\n    \n    phys_group_id_324879 = get_group_id(0);\n    for (int32_t i_324880 = 0; i_324880 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766 * t_n_m_292839,\n                                          squot64(segred_group_sizze_316220,\n                                                  segment_sizze_nonzzero_324868))) -\n                   phys_group_id_324879, sext_i64_i32(num_groups_316221));\n         i_324880++) {\n        int32_t virt_group_id_324881 = phys_group_id_324879 + i_324880 *\n                sext_i64_i32(num_groups_316221);\n        int64_t slice_324882 = t_n_m_292839;\n        int64_t slice_324883 = partition_sizze_292766 * slice_324882;\n        int64_t gtid_316225 = squot64(squot64(sext_i32_i64(local_tid_324871),\n                                              segment_sizze_nonzzero_324868) +\n             ",
            "                         sext_i32_i64(virt_group_id_324881) *\n                                      squot64(segred_group_sizze_316220,\n                                              segment_sizze_nonzzero_324868),\n                                      slice_324882);\n        int64_t remnant_324884 = squot64(sext_i32_i64(local_tid_324871),\n                                         segment_sizze_nonzzero_324868) +\n                sext_i32_i64(virt_group_id_324881) *\n                squot64(segred_group_sizze_316220,\n                        segment_sizze_nonzzero_324868) - gtid_316225 *\n                slice_324882;\n        int64_t gtid_316226 = remnant_324884;\n        int64_t remnant_324885 = remnant_324884 - gtid_316226;\n        int64_t gtid_316227 = srem64(sext_i32_i64(local_tid_324871),\n                                     q_t_292679);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, q_t_292679) && ((slt64(gtid_316225,\n                                                          partition_sizze_292766) &&\n                                                    slt64(gtid_316226,\n                                                          t_n_m_292839)) &&\n                                                   slt64(sext_i32_i64(local_tid_324871),\n                                                         q_t_292679 *\n                                                         squot64(segred_group_sizze_316220,\n                                                                 segment_sizze_nonzzero_324868)))) {\n                int64_t x_316236;\n                \n                x_316236 = ((__global int64_t *) ext_mem_318541)[gtid_316225];\n                \n                int64_t x_316247;\n                \n                x_316247 = ((__global int64_t *) ext_mem_318806)[gtid_316225 *\n                                                                 t_n_m_292839 +\n                                                                 gtid_316226];\n ",
            "               \n                double x_316248;\n                \n                x_316248 = ((__global double *) ext_mem_318805)[gtid_316225 *\n                                                                t_n_m_292839 +\n                                                                gtid_316226];\n                \n                int64_t binop_y_317887 = mul64(jump_t_292685, gtid_316226);\n                int64_t binop_y_317888 = smin64(i_292846, binop_y_317887);\n                int64_t index_primexp_317889 = add64((int64_t) 1,\n                                                     binop_y_317888);\n                double a12_316250;\n                \n                a12_316250 = ((__global double *) mem_320066)[gtid_316225 *\n                                                              t_n_m_292839 +\n                                                              gtid_316226];\n                \n                double b12_316251;\n                \n                b12_316251 = ((__global double *) mem_320070)[gtid_316225 *\n                                                              t_n_m_292839 +\n                                                              gtid_316226];\n                \n                double c12_316252;\n                \n                c12_316252 = ((__global double *) mem_320074)[gtid_316225 *\n                                                              t_n_m_292839 +\n                                                              gtid_316226];\n                \n                double b2_316253;\n                \n                b2_316253 = ((__global double *) mem_320078)[gtid_316225 *\n                                                             t_n_m_292839 +\n                                                             gtid_316226];\n                \n                double c2_316254;\n                \n                c2_316254 = ((__global double *) mem_320082)[gtid_316225 *\n                                                             t_n_m_292839 +\n     ",
            "                                                        gtid_316226];\n                \n                bool cond_316256 = sle64(x_316236, gtid_316227);\n                int64_t defunc_0_f_res_316257;\n                \n                if (cond_316256) {\n                    defunc_0_f_res_316257 = (int64_t) 0;\n                } else {\n                    int64_t i_316258 = add64(gtid_316227, x_316247);\n                    int64_t defunc_0_add_arg_316259;\n                    \n                    defunc_0_add_arg_316259 = ((__global\n                                                int64_t *) ext_mem_318542)[gtid_316225 *\n                                                                           n_292675 +\n                                                                           i_316258];\n                    \n                    int64_t defunc_1_add_res_316260 = add64((int64_t) 1,\n                                                            defunc_0_add_arg_316259);\n                    \n                    defunc_0_f_res_316257 = defunc_1_add_res_316260;\n                }\n                \n                double defunc_0_f_res_316261;\n                \n                if (cond_316256) {\n                    defunc_0_f_res_316261 = 0.0;\n                } else {\n                    int64_t i_316262 = add64(gtid_316227, x_316247);\n                    double defunc_0_add_arg_316263;\n                    \n                    defunc_0_add_arg_316263 = ((__global\n                                                double *) mem_320036)[gtid_316225 *\n                                                                      n_292675 +\n                                                                      i_316262];\n                    defunc_0_f_res_316261 = defunc_0_add_arg_316263;\n                }\n                \n                int64_t binop_p_316264 = sub64(defunc_0_f_res_316257,\n                                               index_primexp_317889);\n                double defunc_0_f_res_31",
            "6265 = sitofp_i64_f64(binop_p_316264);\n                double abs_res_316266 = fabs(defunc_0_f_res_316265);\n                double tmp1_316267 = abs_res_316266 / x_316248;\n                double x_316268 = tmp1_316267 * tmp1_316267;\n                double y_316269 = tmp1_316267 * x_316268;\n                double tmp2_316270 = 1.0 - y_316269;\n                double x_316271 = tmp2_316270 * tmp2_316270;\n                double tmp3_316272 = tmp2_316270 * x_316271;\n                double tmp4_316273 = defunc_0_f_res_316261 * tmp3_316272;\n                double defunc_1_f_res_316274 = defunc_0_f_res_316265 *\n                       tmp4_316273;\n                double defunc_1_f_res_316275 = defunc_0_f_res_316265 *\n                       defunc_1_f_res_316274;\n                double defunc_0_f_res_316276;\n                \n                if (cond_316256) {\n                    defunc_0_f_res_316276 = 0.0;\n                } else {\n                    int64_t i_316277 = add64(gtid_316227, x_316247);\n                    double defunc_0_add_arg_316278;\n                    \n                    defunc_0_add_arg_316278 = ((__global\n                                                double *) mem_320040)[gtid_316225 *\n                                                                      n_292675 +\n                                                                      i_316277];\n                    defunc_0_f_res_316276 = defunc_0_add_arg_316278;\n                }\n                \n                double x_316279 = a12_316250 * tmp4_316273;\n                double y_316280 = b12_316251 * defunc_1_f_res_316274;\n                double x_316281 = x_316279 + y_316280;\n                double y_316282 = c12_316252 * defunc_1_f_res_316275;\n                double x_316283 = x_316281 + y_316282;\n                double defunc_9_fit_fun_res_316284 = defunc_0_f_res_316276 *\n                       x_316283;\n                double x_316285 = b12_316251 * tmp4_316273;\n                double y_316286 = b",
            "2_316253 * defunc_1_f_res_316274;\n                double x_316287 = x_316285 + y_316286;\n                double y_316288 = c2_316254 * defunc_1_f_res_316275;\n                double x_316289 = x_316287 + y_316288;\n                double defunc_9_slope_fun_res_316290 = defunc_0_f_res_316276 *\n                       x_316289;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_324875)[sext_i32_i64(local_tid_324871)] =\n                        defunc_9_fit_fun_res_316284;\n                    ((__local\n                      double *) red_arr_mem_324877)[sext_i32_i64(local_tid_324871)] =\n                        defunc_9_slope_fun_res_316290;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_324875)[sext_i32_i64(local_tid_324871)] =\n                    0.0;\n                ((__local\n                  double *) red_arr_mem_324877)[sext_i32_i64(local_tid_324871)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, q_t_292679)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_316229;\n                double x_316230;\n                double x_316231;\n                double x_316232;\n                double x_324886;\n                double x_324887;\n                double x_324888;\n                double x_324889;\n                bool ltid_in_bounds_324892 =\n                     slt64(sext_i32_i64(local_tid_324871), q_t_292679 *\n                           squot64(segred_group_sizze_316220,\n                                   segment_sizze_nonzzero_324868));\n                int32_t skip_threads_324893;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_324892) {\n                    ",
            "    x_316231 = ((volatile __local\n                                     double *) red_arr_mem_324875)[sext_i32_i64(local_tid_324871)];\n                        x_316232 = ((volatile __local\n                                     double *) red_arr_mem_324877)[sext_i32_i64(local_tid_324871)];\n                        if ((local_tid_324871 - squot32(local_tid_324871, 32) *\n                             32) == 0) {\n                            x_316229 = x_316231;\n                            x_316230 = x_316232;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_324893 = 1;\n                    while (slt32(skip_threads_324893, 32)) {\n                        bool thread_active_324894 = sle32(skip_threads_324893,\n                                                          local_tid_324871 -\n                                                          squot32(local_tid_324871,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_324892;\n                        \n                        if (thread_active_324894) {\n                            // read operands\n                            {\n                                x_316229 = ((volatile __local\n                                             double *) red_arr_mem_324875)[sext_i32_i64(local_tid_324871) -\n                                                                           sext_i32_i64(skip_threads_324893)];\n                                x_316230 = ((volatile __local\n                                             double *) red_arr_mem_324877)[sext_i32_i64(local_tid_324871) -\n                                                                           sext_i32_i64(skip_threads_324893)];\n                            }\n                        }\n                        // perform operation\n                        {\n                           ",
            " bool inactive_324895 =\n                                 slt64(srem64(sext_i32_i64(local_tid_324871),\n                                              q_t_292679),\n                                       sext_i32_i64(local_tid_324871) -\n                                       sext_i32_i64(local_tid_324871 -\n                                       skip_threads_324893));\n                            \n                            if (thread_active_324894 && inactive_324895) {\n                                x_316229 = x_316231;\n                                x_316230 = x_316232;\n                            }\n                            if (thread_active_324894) {\n                                if (!inactive_324895) {\n                                    double defunc_1_op_res_316233 = x_316229 +\n                                           x_316231;\n                                    double defunc_1_op_res_316234 = x_316230 +\n                                           x_316232;\n                                    \n                                    x_316229 = defunc_1_op_res_316233;\n                                    x_316230 = defunc_1_op_res_316234;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_324873, skip_threads_324893)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_324894) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_324875)[sext_i32_i64(local_tid_324871)] =\n                                    x_316229;\n                                x_316231 = x_316229;\n                                ((volatile __local\n                                  double *) red_arr_mem_324877)[sext_i32_i64(local_tid_324871)] =\n                                    x_316230;\n                   ",
            "             x_316232 = x_316230;\n                            }\n                        }\n                        if (sle32(wave_sizze_324873, skip_threads_324893)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_324893 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_324871 - squot32(local_tid_324871, 32) *\n                         32) == 31 && ltid_in_bounds_324892) {\n                        ((volatile __local\n                          double *) red_arr_mem_324875)[sext_i32_i64(squot32(local_tid_324871,\n                                                                             32))] =\n                            x_316229;\n                        ((volatile __local\n                          double *) red_arr_mem_324877)[sext_i32_i64(squot32(local_tid_324871,\n                                                                             32))] =\n                            x_316230;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_324896;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_324871, 32) == 0 &&\n                            ltid_in_bounds_324892) {\n                            x_324888 = ((volatile __local\n                                         double *) red_arr_mem_324875)[sext_i32_i64(local_tid_324871)];\n                            x_324889 = ((volatile __local\n                                         double *) red_arr_mem_324877)[sext_i32_i64(local_tid_324871)];\n                            if ((local_tid_324871 - squot32(local_tid",
            "_324871,\n                                                            32) * 32) == 0) {\n                                x_324886 = x_324888;\n                                x_324887 = x_324889;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_324896 = 1;\n                        while (slt32(skip_threads_324896, 32)) {\n                            bool thread_active_324897 =\n                                 sle32(skip_threads_324896, local_tid_324871 -\n                                       squot32(local_tid_324871, 32) * 32) &&\n                                 (squot32(local_tid_324871, 32) == 0 &&\n                                  ltid_in_bounds_324892);\n                            \n                            if (thread_active_324897) {\n                                // read operands\n                                {\n                                    x_324886 = ((volatile __local\n                                                 double *) red_arr_mem_324875)[sext_i32_i64(local_tid_324871) -\n                                                                               sext_i32_i64(skip_threads_324896)];\n                                    x_324887 = ((volatile __local\n                                                 double *) red_arr_mem_324877)[sext_i32_i64(local_tid_324871) -\n                                                                               sext_i32_i64(skip_threads_324896)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_324898 =\n                                     slt64(srem64(sext_i32_i64(local_tid_324871 *\n                                                  32 + 32 - 1), q_t_292679),\n                                           sext_i32_i64(local_tid_32487",
            "1 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_324871 -\n                                                         skip_threads_324896) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_324897 && inactive_324898) {\n                                    x_324886 = x_324888;\n                                    x_324887 = x_324889;\n                                }\n                                if (thread_active_324897) {\n                                    if (!inactive_324898) {\n                                        double defunc_1_op_res_324890 =\n                                               x_324886 + x_324888;\n                                        double defunc_1_op_res_324891 =\n                                               x_324887 + x_324889;\n                                        \n                                        x_324886 = defunc_1_op_res_324890;\n                                        x_324887 = defunc_1_op_res_324891;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_324873, skip_threads_324896)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_324897) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_324875)[sext_i32_i64(local_tid_324871)] =\n                                        x_324886;\n                                    x_324888 = x_324886;\n                                    ((volatile __local\n                                      double *) red_arr_mem_324877)[sext_i32_i64(local_tid_324871)] =\n                                       ",
            " x_324887;\n                                    x_324889 = x_324887;\n                                }\n                            }\n                            if (sle32(wave_sizze_324873, skip_threads_324896)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_324896 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_324899 = squot32(local_tid_324871, 32) == 0 ||\n                     !ltid_in_bounds_324892;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_324899) {\n                            x_316231 = x_316229;\n                            x_316232 = x_316230;\n                            x_316229 = ((__local\n                                         double *) red_arr_mem_324875)[sext_i32_i64(squot32(local_tid_324871,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_316230 = ((__local\n                                         double *) red_arr_mem_324877)[sext_i32_i64(squot32(local_tid_324871,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_324900 =\n                             slt64(srem64(sext_i32_i64(local_tid_324871),\n                                          q_t_292679),\n                                   sext_i32_i64(local_tid_324871) -\n                                   sext_i3",
            "2_i64(squot32(local_tid_324871, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_324899) {\n                            if (inactive_324900) {\n                                x_316229 = x_316231;\n                                x_316230 = x_316232;\n                            }\n                        }\n                        if (!no_carry_in_324899) {\n                            if (!inactive_324900) {\n                                double defunc_1_op_res_316233 = x_316229 +\n                                       x_316231;\n                                double defunc_1_op_res_316234 = x_316230 +\n                                       x_316232;\n                                \n                                x_316229 = defunc_1_op_res_316233;\n                                x_316230 = defunc_1_op_res_316234;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_324899) {\n                            ((__local\n                              double *) red_arr_mem_324875)[sext_i32_i64(local_tid_324871)] =\n                                x_316229;\n                            ((__local\n                              double *) red_arr_mem_324877)[sext_i32_i64(local_tid_324871)] =\n                                x_316230;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_324871, 32) == 0 &&\n                        ltid_in_bounds_324892) {\n                        ((__local\n                          double *) red_arr_mem_324875)[sext_i32_i64(local_tid_324871)] =\n                            x_316231;\n                        ((__local\n                          double *) red_arr_mem_324877)[sext_i32_i64(local",
            "_tid_324871)] =\n                            x_316232;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_324881) *\n                      squot64(segred_group_sizze_316220,\n                              segment_sizze_nonzzero_324868) +\n                      sext_i32_i64(local_tid_324871), partition_sizze_292766 *\n                      t_n_m_292839) && slt64(sext_i32_i64(local_tid_324871),\n                                             squot64(segred_group_sizze_316220,\n                                                     segment_sizze_nonzzero_324868))) {\n                double tmp_324901;\n                \n                tmp_324901 = ((__local\n                               double *) red_arr_mem_324875)[(sext_i32_i64(local_tid_324871) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324868 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_320087)[squot64(sext_i32_i64(virt_group_id_324881) *\n                                                squot64(segred_group_sizze_316220,\n                                                        segment_sizze_nonzzero_324868) +\n                                                sext_i32_i64(local_tid_324871),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324881) *\n                                         squot64(segred_group_sizze_316220,\n                                                 segment_sizze_nonzzero_324868) +\n                                         sext_i32_i64(local_tid_324871) -\n                                         squot64(sext_i32_i6",
            "4(virt_group_id_324881) *\n                                                 squot64(segred_group_sizze_316220,\n                                                         segment_sizze_nonzzero_324868) +\n                                                 sext_i32_i64(local_tid_324871),\n                                                 t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324901;\n                \n                double tmp_324902;\n                \n                tmp_324902 = ((__local\n                               double *) red_arr_mem_324877)[(sext_i32_i64(local_tid_324871) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_324868 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_320091)[squot64(sext_i32_i64(virt_group_id_324881) *\n                                                squot64(segred_group_sizze_316220,\n                                                        segment_sizze_nonzzero_324868) +\n                                                sext_i32_i64(local_tid_324871),\n                                                t_n_m_292839) * t_n_m_292839 +\n                                        (sext_i32_i64(virt_group_id_324881) *\n                                         squot64(segred_group_sizze_316220,\n                                                 segment_sizze_nonzzero_324868) +\n                                         sext_i32_i64(local_tid_324871) -\n                                         squot64(sext_i32_i64(virt_group_id_324881) *\n                                                 squot64(segred_group_sizze_316220,\n                                                         segment_sizze_nonzzero_324868) +\n                                                 sext_i32_i64(local_tid_324871),\n                                          ",
            "       t_n_m_292839) *\n                                         t_n_m_292839)] = tmp_324902;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_316220\n}\n__kernel void mainzisegred_small_316768(__global int *global_failure,\n                                        uint red_arr_mem_325017_backing_offset_0,\n                                        uint red_arr_mem_325015_backing_offset_1,\n                                        int64_t n_292675,\n                                        int64_t partition_sizze_292766,\n                                        int64_t num_groups_316762,\n                                        int64_t segment_sizze_nonzzero_325008,\n                                        __global unsigned char *ext_mem_320155,\n                                        __global unsigned char *mem_320166,\n                                        __global unsigned char *mem_320169)\n{\n    #define segred_group_sizze_316761 (mainzisegred_group_sizze_316741)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_325017_backing_1 =\n                           &shared_mem[red_arr_mem_325017_backing_offset_0];\n    volatile unsigned char *red_arr_mem_325015_backing_0 =\n                           &shared_mem[red_arr_mem_325015_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325010;\n    int32_t local_tid_325011;\n    int64_t group_sizze_325014;\n    int32_t wave_sizze_325013;\n    int32_t group_tid_325012;\n    \n    global_tid_325010 = get_global_id(0);\n    local_tid_325011 = get_local_id(0);\n    group_sizze_325014 = get_local_size(0);\n    wave_sizze_325013 = LOCKSTEP_WIDTH;\n    group_tid_325012 = get_group_id(0);\n    \n    int32_t phys_tid_316768 = global_tid_325010;\n    __local unsigned char *red_arr_mem_325015;\n    \n ",
            "   red_arr_mem_325015 = (__local unsigned char *) red_arr_mem_325015_backing_0;\n    \n    __local unsigned char *red_arr_mem_325017;\n    \n    red_arr_mem_325017 = (__local unsigned char *) red_arr_mem_325017_backing_1;\n    \n    int32_t phys_group_id_325019;\n    \n    phys_group_id_325019 = get_group_id(0);\n    for (int32_t i_325020 = 0; i_325020 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766,\n                                          squot64(segred_group_sizze_316761,\n                                                  segment_sizze_nonzzero_325008))) -\n                   phys_group_id_325019, sext_i64_i32(num_groups_316762));\n         i_325020++) {\n        int32_t virt_group_id_325021 = phys_group_id_325019 + i_325020 *\n                sext_i64_i32(num_groups_316762);\n        int64_t slice_325022 = partition_sizze_292766;\n        int64_t gtid_316766 = squot64(sext_i32_i64(local_tid_325011),\n                                      segment_sizze_nonzzero_325008) +\n                sext_i32_i64(virt_group_id_325021) *\n                squot64(segred_group_sizze_316761,\n                        segment_sizze_nonzzero_325008);\n        int64_t remnant_325023 = squot64(sext_i32_i64(local_tid_325011),\n                                         segment_sizze_nonzzero_325008) +\n                sext_i32_i64(virt_group_id_325021) *\n                squot64(segred_group_sizze_316761,\n                        segment_sizze_nonzzero_325008) - gtid_316766;\n        int64_t gtid_316767 = srem64(sext_i32_i64(local_tid_325011), n_292675);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, n_292675) && (slt64(gtid_316766,\n                                                       partition_sizze_292766) &&\n                                                 slt64(sext_i32_i64(local_tid_325011),\n                                                       n_292675 *\n                                                       squot64(segred_group_sizze_",
            "316761,\n                                                               segment_sizze_nonzzero_325008)))) {\n                double x_316776;\n                \n                x_316776 = ((__global double *) ext_mem_320155)[gtid_316766 *\n                                                                n_292675 +\n                                                                gtid_316767];\n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_325015)[sext_i32_i64(local_tid_325011)] =\n                        x_316776;\n                    ((__local\n                      double *) red_arr_mem_325017)[sext_i32_i64(local_tid_325011)] =\n                        x_316776;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_325015)[sext_i32_i64(local_tid_325011)] =\n                    INFINITY;\n                ((__local\n                  double *) red_arr_mem_325017)[sext_i32_i64(local_tid_325011)] =\n                    -INFINITY;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, n_292675)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_316769;\n                double x_316770;\n                double x_316771;\n                double x_316772;\n                double x_325024;\n                double x_325025;\n                double x_325026;\n                double x_325027;\n                bool ltid_in_bounds_325030 =\n                     slt64(sext_i32_i64(local_tid_325011), n_292675 *\n                           squot64(segred_group_sizze_316761,\n                                   segment_sizze_nonzzero_325008));\n                int32_t skip_threads_325031;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_325030) {\n       ",
            "                 x_316771 = ((volatile __local\n                                     double *) red_arr_mem_325015)[sext_i32_i64(local_tid_325011)];\n                        x_316772 = ((volatile __local\n                                     double *) red_arr_mem_325017)[sext_i32_i64(local_tid_325011)];\n                        if ((local_tid_325011 - squot32(local_tid_325011, 32) *\n                             32) == 0) {\n                            x_316769 = x_316771;\n                            x_316770 = x_316772;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_325031 = 1;\n                    while (slt32(skip_threads_325031, 32)) {\n                        bool thread_active_325032 = sle32(skip_threads_325031,\n                                                          local_tid_325011 -\n                                                          squot32(local_tid_325011,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_325030;\n                        \n                        if (thread_active_325032) {\n                            // read operands\n                            {\n                                x_316769 = ((volatile __local\n                                             double *) red_arr_mem_325015)[sext_i32_i64(local_tid_325011) -\n                                                                           sext_i32_i64(skip_threads_325031)];\n                                x_316770 = ((volatile __local\n                                             double *) red_arr_mem_325017)[sext_i32_i64(local_tid_325011) -\n                                                                           sext_i32_i64(skip_threads_325031)];\n                            }\n                        }\n                        // perform operation\n                        {\n              ",
            "              bool inactive_325033 =\n                                 slt64(srem64(sext_i32_i64(local_tid_325011),\n                                              n_292675),\n                                       sext_i32_i64(local_tid_325011) -\n                                       sext_i32_i64(local_tid_325011 -\n                                       skip_threads_325031));\n                            \n                            if (thread_active_325032 && inactive_325033) {\n                                x_316769 = x_316771;\n                                x_316770 = x_316772;\n                            }\n                            if (thread_active_325032) {\n                                if (!inactive_325033) {\n                                    double defunc_1_op_res_316773 =\n                                           fmin64(x_316769, x_316771);\n                                    double defunc_1_op_res_316774 =\n                                           fmax64(x_316770, x_316772);\n                                    \n                                    x_316769 = defunc_1_op_res_316773;\n                                    x_316770 = defunc_1_op_res_316774;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_325013, skip_threads_325031)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_325032) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_325015)[sext_i32_i64(local_tid_325011)] =\n                                    x_316769;\n                                x_316771 = x_316769;\n                                ((volatile __local\n                                  double *) red_arr_mem_325017)[sext_i32_i64(local_tid_325011)] =\n                                    x_31",
            "6770;\n                                x_316772 = x_316770;\n                            }\n                        }\n                        if (sle32(wave_sizze_325013, skip_threads_325031)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_325031 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_325011 - squot32(local_tid_325011, 32) *\n                         32) == 31 && ltid_in_bounds_325030) {\n                        ((volatile __local\n                          double *) red_arr_mem_325015)[sext_i32_i64(squot32(local_tid_325011,\n                                                                             32))] =\n                            x_316769;\n                        ((volatile __local\n                          double *) red_arr_mem_325017)[sext_i32_i64(squot32(local_tid_325011,\n                                                                             32))] =\n                            x_316770;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_325034;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_325011, 32) == 0 &&\n                            ltid_in_bounds_325030) {\n                            x_325026 = ((volatile __local\n                                         double *) red_arr_mem_325015)[sext_i32_i64(local_tid_325011)];\n                            x_325027 = ((volatile __local\n                                         double *) red_arr_mem_325017)[sext_i32_i64(local_tid_325011)];\n                            if ((local_tid_3",
            "25011 - squot32(local_tid_325011,\n                                                            32) * 32) == 0) {\n                                x_325024 = x_325026;\n                                x_325025 = x_325027;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_325034 = 1;\n                        while (slt32(skip_threads_325034, 32)) {\n                            bool thread_active_325035 =\n                                 sle32(skip_threads_325034, local_tid_325011 -\n                                       squot32(local_tid_325011, 32) * 32) &&\n                                 (squot32(local_tid_325011, 32) == 0 &&\n                                  ltid_in_bounds_325030);\n                            \n                            if (thread_active_325035) {\n                                // read operands\n                                {\n                                    x_325024 = ((volatile __local\n                                                 double *) red_arr_mem_325015)[sext_i32_i64(local_tid_325011) -\n                                                                               sext_i32_i64(skip_threads_325034)];\n                                    x_325025 = ((volatile __local\n                                                 double *) red_arr_mem_325017)[sext_i32_i64(local_tid_325011) -\n                                                                               sext_i32_i64(skip_threads_325034)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_325036 =\n                                     slt64(srem64(sext_i32_i64(local_tid_325011 *\n                                                  32 + 32 - 1), n_292675),\n                                           sext_",
            "i32_i64(local_tid_325011 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_325011 -\n                                                         skip_threads_325034) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_325035 && inactive_325036) {\n                                    x_325024 = x_325026;\n                                    x_325025 = x_325027;\n                                }\n                                if (thread_active_325035) {\n                                    if (!inactive_325036) {\n                                        double defunc_1_op_res_325028 =\n                                               fmin64(x_325024, x_325026);\n                                        double defunc_1_op_res_325029 =\n                                               fmax64(x_325025, x_325027);\n                                        \n                                        x_325024 = defunc_1_op_res_325028;\n                                        x_325025 = defunc_1_op_res_325029;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_325013, skip_threads_325034)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_325035) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_325015)[sext_i32_i64(local_tid_325011)] =\n                                        x_325024;\n                                    x_325026 = x_325024;\n                                    ((volatile __local\n                                      double *) red_arr_mem_325017)[sext_i32_i64(local_tid_325011)] =\n  ",
            "                                      x_325025;\n                                    x_325027 = x_325025;\n                                }\n                            }\n                            if (sle32(wave_sizze_325013, skip_threads_325034)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_325034 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_325037 = squot32(local_tid_325011, 32) == 0 ||\n                     !ltid_in_bounds_325030;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_325037) {\n                            x_316771 = x_316769;\n                            x_316772 = x_316770;\n                            x_316769 = ((__local\n                                         double *) red_arr_mem_325015)[sext_i32_i64(squot32(local_tid_325011,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_316770 = ((__local\n                                         double *) red_arr_mem_325017)[sext_i32_i64(squot32(local_tid_325011,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_325038 =\n                             slt64(srem64(sext_i32_i64(local_tid_325011),\n                                          n_292675),\n                                   sext_i32_i64(local_tid_325011) -\n       ",
            "                            sext_i32_i64(squot32(local_tid_325011, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_325037) {\n                            if (inactive_325038) {\n                                x_316769 = x_316771;\n                                x_316770 = x_316772;\n                            }\n                        }\n                        if (!no_carry_in_325037) {\n                            if (!inactive_325038) {\n                                double defunc_1_op_res_316773 = fmin64(x_316769,\n                                                                       x_316771);\n                                double defunc_1_op_res_316774 = fmax64(x_316770,\n                                                                       x_316772);\n                                \n                                x_316769 = defunc_1_op_res_316773;\n                                x_316770 = defunc_1_op_res_316774;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_325037) {\n                            ((__local\n                              double *) red_arr_mem_325015)[sext_i32_i64(local_tid_325011)] =\n                                x_316769;\n                            ((__local\n                              double *) red_arr_mem_325017)[sext_i32_i64(local_tid_325011)] =\n                                x_316770;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_325011, 32) == 0 &&\n                        ltid_in_bounds_325030) {\n                        ((__local\n                          double *) red_arr_mem_325015)[sext_i32_i64(local_tid_325011)] =\n                            x_316",
            "771;\n                        ((__local\n                          double *) red_arr_mem_325017)[sext_i32_i64(local_tid_325011)] =\n                            x_316772;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_325021) *\n                      squot64(segred_group_sizze_316761,\n                              segment_sizze_nonzzero_325008) +\n                      sext_i32_i64(local_tid_325011), partition_sizze_292766) &&\n                slt64(sext_i32_i64(local_tid_325011),\n                      squot64(segred_group_sizze_316761,\n                              segment_sizze_nonzzero_325008))) {\n                double tmp_325039;\n                \n                tmp_325039 = ((__local\n                               double *) red_arr_mem_325015)[(sext_i32_i64(local_tid_325011) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_325008 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_320166)[sext_i32_i64(virt_group_id_325021) *\n                                        squot64(segred_group_sizze_316761,\n                                                segment_sizze_nonzzero_325008) +\n                                        sext_i32_i64(local_tid_325011)] =\n                    tmp_325039;\n                \n                double tmp_325040;\n                \n                tmp_325040 = ((__local\n                               double *) red_arr_mem_325017)[(sext_i32_i64(local_tid_325011) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_325008 -\n                            ",
            "                                 (int64_t) 1];\n                ((__global\n                  double *) mem_320169)[sext_i32_i64(virt_group_id_325021) *\n                                        squot64(segred_group_sizze_316761,\n                                                segment_sizze_nonzzero_325008) +\n                                        sext_i32_i64(local_tid_325011)] =\n                    tmp_325040;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_316761\n}\n__kernel void mainzisegred_small_317337(__global int *global_failure,\n                                        uint red_arr_mem_325604_backing_offset_0,\n                                        uint red_arr_mem_325602_backing_offset_1,\n                                        uint red_arr_mem_325600_backing_offset_2,\n                                        int64_t n_292675,\n                                        int64_t partition_sizze_292766,\n                                        int64_t num_groups_317330,\n                                        int64_t segment_sizze_nonzzero_325593,\n                                        __global unsigned char *ext_mem_320155,\n                                        __global unsigned char *mem_320205,\n                                        __global unsigned char *mem_320397,\n                                        __global unsigned char *mem_320400,\n                                        __global unsigned char *mem_320403)\n{\n    #define segred_group_sizze_317329 (mainzisegred_group_sizze_317285)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_325604_backing_2 =\n                           &shared_mem[red_arr_mem_325604_backing_offset_0];\n    volatile unsigned char *red_arr_mem_325602_backing_1 =\n                           &shared_mem[red_arr_mem_",
            "325602_backing_offset_1];\n    volatile unsigned char *red_arr_mem_325600_backing_0 =\n                           &shared_mem[red_arr_mem_325600_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325595;\n    int32_t local_tid_325596;\n    int64_t group_sizze_325599;\n    int32_t wave_sizze_325598;\n    int32_t group_tid_325597;\n    \n    global_tid_325595 = get_global_id(0);\n    local_tid_325596 = get_local_id(0);\n    group_sizze_325599 = get_local_size(0);\n    wave_sizze_325598 = LOCKSTEP_WIDTH;\n    group_tid_325597 = get_group_id(0);\n    \n    int32_t phys_tid_317337 = global_tid_325595;\n    __local unsigned char *red_arr_mem_325600;\n    \n    red_arr_mem_325600 = (__local unsigned char *) red_arr_mem_325600_backing_0;\n    \n    __local unsigned char *red_arr_mem_325602;\n    \n    red_arr_mem_325602 = (__local unsigned char *) red_arr_mem_325602_backing_1;\n    \n    __local unsigned char *red_arr_mem_325604;\n    \n    red_arr_mem_325604 = (__local unsigned char *) red_arr_mem_325604_backing_2;\n    \n    int32_t phys_group_id_325606;\n    \n    phys_group_id_325606 = get_group_id(0);\n    for (int32_t i_325607 = 0; i_325607 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(partition_sizze_292766,\n                                          squot64(segred_group_sizze_317329,\n                                                  segment_sizze_nonzzero_325593))) -\n                   phys_group_id_325606, sext_i64_i32(num_groups_317330));\n         i_325607++) {\n        int32_t virt_group_id_325608 = phys_group_id_325606 + i_325607 *\n                sext_i64_i32(num_groups_317330);\n        int64_t slice_325609 = partition_sizze_292766;\n        int64_t gtid_317335 = squot64(sext_i32_i64(local_tid_325596),\n                                      segment_sizze_nonzzero_325593) +\n                sext_i32_i64(virt_group_id_325608) *\n                squot64(segred_group_sizze_317329,\n                        segment_sizze_nonzzero_325593);\n        int64_t remn",
            "ant_325610 = squot64(sext_i32_i64(local_tid_325596),\n                                         segment_sizze_nonzzero_325593) +\n                sext_i32_i64(virt_group_id_325608) *\n                squot64(segred_group_sizze_317329,\n                        segment_sizze_nonzzero_325593) - gtid_317335;\n        int64_t gtid_317336 = srem64(sext_i32_i64(local_tid_325596), n_292675);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, n_292675) && (slt64(gtid_317335,\n                                                       partition_sizze_292766) &&\n                                                 slt64(sext_i32_i64(local_tid_325596),\n                                                       n_292675 *\n                                                       squot64(segred_group_sizze_317329,\n                                                               segment_sizze_nonzzero_325593)))) {\n                double x_317365;\n                \n                x_317365 = ((__global double *) mem_320205)[gtid_317335];\n                \n                double x_317366;\n                \n                x_317366 = ((__global double *) ext_mem_320155)[gtid_317335 *\n                                                                n_292675 +\n                                                                gtid_317336];\n                \n                bool cond_317368 = x_317366 < x_317365;\n                int64_t defunc_0_f_res_317369 = btoi_bool_i64(cond_317368);\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_325600)[sext_i32_i64(local_tid_325596)] =\n                        x_317366;\n                    ((__local\n                      int64_t *) red_arr_mem_325602)[sext_i32_i64(local_tid_325596)] =\n                        gtid_317336;\n                    ((__local\n                   ",
            "   int64_t *) red_arr_mem_325604)[sext_i32_i64(local_tid_325596)] =\n                        defunc_0_f_res_317369;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_325600)[sext_i32_i64(local_tid_325596)] =\n                    -INFINITY;\n                ((__local\n                  int64_t *) red_arr_mem_325602)[sext_i32_i64(local_tid_325596)] =\n                    (int64_t) -1;\n                ((__local\n                  int64_t *) red_arr_mem_325604)[sext_i32_i64(local_tid_325596)] =\n                    (int64_t) 0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, n_292675)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_317338;\n                int64_t x_317339;\n                int64_t x_317340;\n                double x_317341;\n                int64_t x_317342;\n                int64_t x_317343;\n                double x_325611;\n                int64_t x_325612;\n                int64_t x_325613;\n                double x_325614;\n                int64_t x_325615;\n                int64_t x_325616;\n                bool ltid_in_bounds_325637 =\n                     slt64(sext_i32_i64(local_tid_325596), n_292675 *\n                           squot64(segred_group_sizze_317329,\n                                   segment_sizze_nonzzero_325593));\n                int32_t skip_threads_325638;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_325637) {\n                        x_317341 = ((volatile __local\n                                     double *) red_arr_mem_325600)[sext_i32_i64(local_tid_325596)];\n                        x_317342 = ((volatile __local\n                                     int64_t *) red_arr_mem_325602)[sext_i32_i64(local_tid_325596)];\n                        x_317343 = ((volatile __local\n                                     int64_t *) red_ar",
            "r_mem_325604)[sext_i32_i64(local_tid_325596)];\n                        if ((local_tid_325596 - squot32(local_tid_325596, 32) *\n                             32) == 0) {\n                            x_317338 = x_317341;\n                            x_317339 = x_317342;\n                            x_317340 = x_317343;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_325638 = 1;\n                    while (slt32(skip_threads_325638, 32)) {\n                        bool thread_active_325639 = sle32(skip_threads_325638,\n                                                          local_tid_325596 -\n                                                          squot32(local_tid_325596,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_325637;\n                        \n                        if (thread_active_325639) {\n                            // read operands\n                            {\n                                x_317338 = ((volatile __local\n                                             double *) red_arr_mem_325600)[sext_i32_i64(local_tid_325596) -\n                                                                           sext_i32_i64(skip_threads_325638)];\n                                x_317339 = ((volatile __local\n                                             int64_t *) red_arr_mem_325602)[sext_i32_i64(local_tid_325596) -\n                                                                            sext_i32_i64(skip_threads_325638)];\n                                x_317340 = ((volatile __local\n                                             int64_t *) red_arr_mem_325604)[sext_i32_i64(local_tid_325596) -\n                                                                            sext_i32_i64(skip_threads_325638)];\n                            }\n                        }\n     ",
            "                   // perform operation\n                        {\n                            bool inactive_325640 =\n                                 slt64(srem64(sext_i32_i64(local_tid_325596),\n                                              n_292675),\n                                       sext_i32_i64(local_tid_325596) -\n                                       sext_i32_i64(local_tid_325596 -\n                                       skip_threads_325638));\n                            \n                            if (thread_active_325639 && inactive_325640) {\n                                x_317338 = x_317341;\n                                x_317339 = x_317342;\n                                x_317340 = x_317343;\n                            }\n                            if (thread_active_325639) {\n                                if (!inactive_325640) {\n                                    bool cond_317344 = x_317340 == (int64_t) 0;\n                                    bool cond_t_res_317345 = slt64((int64_t) 0,\n                                                                   x_317343);\n                                    bool x_317346 = cond_317344 &&\n                                         cond_t_res_317345;\n                                    double defunc_1_op_res_317347;\n                                    int64_t defunc_1_op_res_317348;\n                                    \n                                    if (x_317346) {\n                                        defunc_1_op_res_317347 = x_317341;\n                                        defunc_1_op_res_317348 = x_317342;\n                                    } else {\n                                        bool cond_317349 = slt64((int64_t) 0,\n                                                                 x_317340);\n                                        bool cond_t_res_317350 = x_317343 ==\n                                             (int64_t) 0;\n                                        bool x_317351 = cond_3173",
            "49 &&\n                                             cond_t_res_317350;\n                                        double defunc_1_op_res_f_res_317352;\n                                        int64_t defunc_1_op_res_f_res_317353;\n                                        \n                                        if (x_317351) {\n                                            defunc_1_op_res_f_res_317352 =\n                                                x_317338;\n                                            defunc_1_op_res_f_res_317353 =\n                                                x_317339;\n                                        } else {\n                                            bool cond_317354 = x_317341 <\n                                                 x_317338;\n                                            double\n                                            defunc_1_op_res_f_res_f_res_317355;\n                                            int64_t\n                                            defunc_1_op_res_f_res_f_res_317356;\n                                            \n                                            if (cond_317354) {\n                                                defunc_1_op_res_f_res_f_res_317355 =\n                                                    x_317338;\n                                                defunc_1_op_res_f_res_f_res_317356 =\n                                                    x_317339;\n                                            } else {\n                                                bool cond_317357 = x_317338 <\n                                                     x_317341;\n                                                double\n                                                defunc_1_op_res_f_res_f_res_f_res_317358;\n                                                int64_t\n                                                defunc_1_op_res_f_res_f_res_f_res_317359;\n                                                \n                               ",
            "                 if (cond_317357) {\n                                                    defunc_1_op_res_f_res_f_res_f_res_317358 =\n                                                        x_317341;\n                                                    defunc_1_op_res_f_res_f_res_f_res_317359 =\n                                                        x_317342;\n                                                } else {\n                                                    bool cond_317360 =\n                                                         slt64(x_317339,\n                                                               x_317342);\n                                                    double\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_317361;\n                                                    \n                                                    if (cond_317360) {\n                                                        defunc_1_op_res_f_res_f_res_f_res_f_res_317361 =\n                                                            x_317338;\n                                                    } else {\n                                                        defunc_1_op_res_f_res_f_res_f_res_f_res_317361 =\n                                                            x_317341;\n                                                    }\n                                                    \n                                                    int64_t\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_317362;\n                                                    \n                                                    if (cond_317360) {\n                                                        defunc_1_op_res_f_res_f_res_f_res_f_res_317362 =\n                                                            x_317339;\n                                                    } else {\n                                              ",
            "          defunc_1_op_res_f_res_f_res_f_res_f_res_317362 =\n                                                            x_317342;\n                                                    }\n                                                    defunc_1_op_res_f_res_f_res_f_res_317358 =\n                                                        defunc_1_op_res_f_res_f_res_f_res_f_res_317361;\n                                                    defunc_1_op_res_f_res_f_res_f_res_317359 =\n                                                        defunc_1_op_res_f_res_f_res_f_res_f_res_317362;\n                                                }\n                                                defunc_1_op_res_f_res_f_res_317355 =\n                                                    defunc_1_op_res_f_res_f_res_f_res_317358;\n                                                defunc_1_op_res_f_res_f_res_317356 =\n                                                    defunc_1_op_res_f_res_f_res_f_res_317359;\n                                            }\n                                            defunc_1_op_res_f_res_317352 =\n                                                defunc_1_op_res_f_res_f_res_317355;\n                                            defunc_1_op_res_f_res_317353 =\n                                                defunc_1_op_res_f_res_f_res_317356;\n                                        }\n                                        defunc_1_op_res_317347 =\n                                            defunc_1_op_res_f_res_317352;\n                                        defunc_1_op_res_317348 =\n                                            defunc_1_op_res_f_res_317353;\n                                    }\n                                    \n                                    int64_t defunc_1_op_res_317363 =\n                                            add64(x_317340, x_317343);\n                                    \n                                    x_317338 = defunc_1_op_res_317347;\n    ",
            "                                x_317339 = defunc_1_op_res_317348;\n                                    x_317340 = defunc_1_op_res_317363;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_325598, skip_threads_325638)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_325639) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_325600)[sext_i32_i64(local_tid_325596)] =\n                                    x_317338;\n                                x_317341 = x_317338;\n                                ((volatile __local\n                                  int64_t *) red_arr_mem_325602)[sext_i32_i64(local_tid_325596)] =\n                                    x_317339;\n                                x_317342 = x_317339;\n                                ((volatile __local\n                                  int64_t *) red_arr_mem_325604)[sext_i32_i64(local_tid_325596)] =\n                                    x_317340;\n                                x_317343 = x_317340;\n                            }\n                        }\n                        if (sle32(wave_sizze_325598, skip_threads_325638)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_325638 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_325596 - squot32(local_tid_325596, 32) *\n                         32) == 31 && ltid_in_bounds_325637) {\n                        ((volatile __local\n                          double *) red_arr_mem_325600)[sext_i32_i64(squot32(local_tid_325596,\n               ",
            "                                                              32))] =\n                            x_317338;\n                        ((volatile __local\n                          int64_t *) red_arr_mem_325602)[sext_i32_i64(squot32(local_tid_325596,\n                                                                              32))] =\n                            x_317339;\n                        ((volatile __local\n                          int64_t *) red_arr_mem_325604)[sext_i32_i64(squot32(local_tid_325596,\n                                                                              32))] =\n                            x_317340;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_325641;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_325596, 32) == 0 &&\n                            ltid_in_bounds_325637) {\n                            x_325614 = ((volatile __local\n                                         double *) red_arr_mem_325600)[sext_i32_i64(local_tid_325596)];\n                            x_325615 = ((volatile __local\n                                         int64_t *) red_arr_mem_325602)[sext_i32_i64(local_tid_325596)];\n                            x_325616 = ((volatile __local\n                                         int64_t *) red_arr_mem_325604)[sext_i32_i64(local_tid_325596)];\n                            if ((local_tid_325596 - squot32(local_tid_325596,\n                                                            32) * 32) == 0) {\n                                x_325611 = x_325614;\n                                x_325612 = x_325615;\n                                x_325613 = x_325616;\n                            }\n                        }\n                    }\n                    ",
            "// in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_325641 = 1;\n                        while (slt32(skip_threads_325641, 32)) {\n                            bool thread_active_325642 =\n                                 sle32(skip_threads_325641, local_tid_325596 -\n                                       squot32(local_tid_325596, 32) * 32) &&\n                                 (squot32(local_tid_325596, 32) == 0 &&\n                                  ltid_in_bounds_325637);\n                            \n                            if (thread_active_325642) {\n                                // read operands\n                                {\n                                    x_325611 = ((volatile __local\n                                                 double *) red_arr_mem_325600)[sext_i32_i64(local_tid_325596) -\n                                                                               sext_i32_i64(skip_threads_325641)];\n                                    x_325612 = ((volatile __local\n                                                 int64_t *) red_arr_mem_325602)[sext_i32_i64(local_tid_325596) -\n                                                                                sext_i32_i64(skip_threads_325641)];\n                                    x_325613 = ((volatile __local\n                                                 int64_t *) red_arr_mem_325604)[sext_i32_i64(local_tid_325596) -\n                                                                                sext_i32_i64(skip_threads_325641)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_325643 =\n                                     slt64(srem64(sext_i32_i64(local_tid_325596 *\n                                                  32 + 32 - 1), n_292675),\n                                           sext_i32_i64(local_tid_3",
            "25596 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_325596 -\n                                                         skip_threads_325641) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_325642 && inactive_325643) {\n                                    x_325611 = x_325614;\n                                    x_325612 = x_325615;\n                                    x_325613 = x_325616;\n                                }\n                                if (thread_active_325642) {\n                                    if (!inactive_325643) {\n                                        bool cond_325617 = x_325613 ==\n                                             (int64_t) 0;\n                                        bool cond_t_res_325618 =\n                                             slt64((int64_t) 0, x_325616);\n                                        bool x_325619 = cond_325617 &&\n                                             cond_t_res_325618;\n                                        double defunc_1_op_res_325620;\n                                        int64_t defunc_1_op_res_325621;\n                                        \n                                        if (x_325619) {\n                                            defunc_1_op_res_325620 = x_325614;\n                                            defunc_1_op_res_325621 = x_325615;\n                                        } else {\n                                            bool cond_325622 =\n                                                 slt64((int64_t) 0, x_325613);\n                                            bool cond_t_res_325623 = x_325616 ==\n                                                 (int64_t) 0;\n                                            bool x_325624 = cond_325622 &&\n                                                 cond_t_res_325623;\n    ",
            "                                        double defunc_1_op_res_f_res_325625;\n                                            int64_t\n                                            defunc_1_op_res_f_res_325626;\n                                            \n                                            if (x_325624) {\n                                                defunc_1_op_res_f_res_325625 =\n                                                    x_325611;\n                                                defunc_1_op_res_f_res_325626 =\n                                                    x_325612;\n                                            } else {\n                                                bool cond_325627 = x_325614 <\n                                                     x_325611;\n                                                double\n                                                defunc_1_op_res_f_res_f_res_325628;\n                                                int64_t\n                                                defunc_1_op_res_f_res_f_res_325629;\n                                                \n                                                if (cond_325627) {\n                                                    defunc_1_op_res_f_res_f_res_325628 =\n                                                        x_325611;\n                                                    defunc_1_op_res_f_res_f_res_325629 =\n                                                        x_325612;\n                                                } else {\n                                                    bool cond_325630 =\n                                                         x_325611 < x_325614;\n                                                    double\n                                                    defunc_1_op_res_f_res_f_res_f_res_325631;\n                                                    int64_t\n                                                    defunc_1_op_res_f_res_f_res_f_res_325632",
            ";\n                                                    \n                                                    if (cond_325630) {\n                                                        defunc_1_op_res_f_res_f_res_f_res_325631 =\n                                                            x_325614;\n                                                        defunc_1_op_res_f_res_f_res_f_res_325632 =\n                                                            x_325615;\n                                                    } else {\n                                                        bool cond_325633 =\n                                                             slt64(x_325612,\n                                                                   x_325615);\n                                                        double\n                                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325634;\n                                                        \n                                                        if (cond_325633) {\n                                                            defunc_1_op_res_f_res_f_res_f_res_f_res_325634 =\n                                                                x_325611;\n                                                        } else {\n                                                            defunc_1_op_res_f_res_f_res_f_res_f_res_325634 =\n                                                                x_325614;\n                                                        }\n                                                        \n                                                        int64_t\n                                                        defunc_1_op_res_f_res_f_res_f_res_f_res_325635;\n                                                        \n                                                        if (cond_325633) {\n                                                            defunc_1_op_res_f_res_f_res_f_res_f_res_",
            "325635 =\n                                                                x_325612;\n                                                        } else {\n                                                            defunc_1_op_res_f_res_f_res_f_res_f_res_325635 =\n                                                                x_325615;\n                                                        }\n                                                        defunc_1_op_res_f_res_f_res_f_res_325631 =\n                                                            defunc_1_op_res_f_res_f_res_f_res_f_res_325634;\n                                                        defunc_1_op_res_f_res_f_res_f_res_325632 =\n                                                            defunc_1_op_res_f_res_f_res_f_res_f_res_325635;\n                                                    }\n                                                    defunc_1_op_res_f_res_f_res_325628 =\n                                                        defunc_1_op_res_f_res_f_res_f_res_325631;\n                                                    defunc_1_op_res_f_res_f_res_325629 =\n                                                        defunc_1_op_res_f_res_f_res_f_res_325632;\n                                                }\n                                                defunc_1_op_res_f_res_325625 =\n                                                    defunc_1_op_res_f_res_f_res_325628;\n                                                defunc_1_op_res_f_res_325626 =\n                                                    defunc_1_op_res_f_res_f_res_325629;\n                                            }\n                                            defunc_1_op_res_325620 =\n                                                defunc_1_op_res_f_res_325625;\n                                            defunc_1_op_res_325621 =\n                                                defunc_1_op_res_f_res_325626;\n                                        }\n   ",
            "                                     \n                                        int64_t defunc_1_op_res_325636 =\n                                                add64(x_325613, x_325616);\n                                        \n                                        x_325611 = defunc_1_op_res_325620;\n                                        x_325612 = defunc_1_op_res_325621;\n                                        x_325613 = defunc_1_op_res_325636;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_325598, skip_threads_325641)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_325642) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_325600)[sext_i32_i64(local_tid_325596)] =\n                                        x_325611;\n                                    x_325614 = x_325611;\n                                    ((volatile __local\n                                      int64_t *) red_arr_mem_325602)[sext_i32_i64(local_tid_325596)] =\n                                        x_325612;\n                                    x_325615 = x_325612;\n                                    ((volatile __local\n                                      int64_t *) red_arr_mem_325604)[sext_i32_i64(local_tid_325596)] =\n                                        x_325613;\n                                    x_325616 = x_325613;\n                                }\n                            }\n                            if (sle32(wave_sizze_325598, skip_threads_325641)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_325641 *= 2;\n                        }\n                    }\n  ",
            "              }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_325644 = squot32(local_tid_325596, 32) == 0 ||\n                     !ltid_in_bounds_325637;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_325644) {\n                            x_317341 = x_317338;\n                            x_317342 = x_317339;\n                            x_317343 = x_317340;\n                            x_317338 = ((__local\n                                         double *) red_arr_mem_325600)[sext_i32_i64(squot32(local_tid_325596,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                            x_317339 = ((__local\n                                         int64_t *) red_arr_mem_325602)[sext_i32_i64(squot32(local_tid_325596,\n                                                                                             32)) -\n                                                                        (int64_t) 1];\n                            x_317340 = ((__local\n                                         int64_t *) red_arr_mem_325604)[sext_i32_i64(squot32(local_tid_325596,\n                                                                                             32)) -\n                                                                        (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_325645 =\n                             slt64(srem64(sext_i32_i64(local_tid_325596),\n                                          n_292675),\n                                   sext_i32_i64(local_tid_325596) -\n                                   sext_i32_i64(squot32",
            "(local_tid_325596, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_325644) {\n                            if (inactive_325645) {\n                                x_317338 = x_317341;\n                                x_317339 = x_317342;\n                                x_317340 = x_317343;\n                            }\n                        }\n                        if (!no_carry_in_325644) {\n                            if (!inactive_325645) {\n                                bool cond_317344 = x_317340 == (int64_t) 0;\n                                bool cond_t_res_317345 = slt64((int64_t) 0,\n                                                               x_317343);\n                                bool x_317346 = cond_317344 &&\n                                     cond_t_res_317345;\n                                double defunc_1_op_res_317347;\n                                int64_t defunc_1_op_res_317348;\n                                \n                                if (x_317346) {\n                                    defunc_1_op_res_317347 = x_317341;\n                                    defunc_1_op_res_317348 = x_317342;\n                                } else {\n                                    bool cond_317349 = slt64((int64_t) 0,\n                                                             x_317340);\n                                    bool cond_t_res_317350 = x_317343 ==\n                                         (int64_t) 0;\n                                    bool x_317351 = cond_317349 &&\n                                         cond_t_res_317350;\n                                    double defunc_1_op_res_f_res_317352;\n                                    int64_t defunc_1_op_res_f_res_317353;\n                                    \n                                    if (x_317351) {\n                                        defunc_1_op_res_f_res_317352 = x_317338;\n                                ",
            "        defunc_1_op_res_f_res_317353 = x_317339;\n                                    } else {\n                                        bool cond_317354 = x_317341 < x_317338;\n                                        double\n                                        defunc_1_op_res_f_res_f_res_317355;\n                                        int64_t\n                                        defunc_1_op_res_f_res_f_res_317356;\n                                        \n                                        if (cond_317354) {\n                                            defunc_1_op_res_f_res_f_res_317355 =\n                                                x_317338;\n                                            defunc_1_op_res_f_res_f_res_317356 =\n                                                x_317339;\n                                        } else {\n                                            bool cond_317357 = x_317338 <\n                                                 x_317341;\n                                            double\n                                            defunc_1_op_res_f_res_f_res_f_res_317358;\n                                            int64_t\n                                            defunc_1_op_res_f_res_f_res_f_res_317359;\n                                            \n                                            if (cond_317357) {\n                                                defunc_1_op_res_f_res_f_res_f_res_317358 =\n                                                    x_317341;\n                                                defunc_1_op_res_f_res_f_res_f_res_317359 =\n                                                    x_317342;\n                                            } else {\n                                                bool cond_317360 =\n                                                     slt64(x_317339, x_317342);\n                                                double\n                                                defunc_1_op_res_f_res_f_res",
            "_f_res_f_res_317361;\n                                                \n                                                if (cond_317360) {\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_317361 =\n                                                        x_317338;\n                                                } else {\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_317361 =\n                                                        x_317341;\n                                                }\n                                                \n                                                int64_t\n                                                defunc_1_op_res_f_res_f_res_f_res_f_res_317362;\n                                                \n                                                if (cond_317360) {\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_317362 =\n                                                        x_317339;\n                                                } else {\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_317362 =\n                                                        x_317342;\n                                                }\n                                                defunc_1_op_res_f_res_f_res_f_res_317358 =\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_317361;\n                                                defunc_1_op_res_f_res_f_res_f_res_317359 =\n                                                    defunc_1_op_res_f_res_f_res_f_res_f_res_317362;\n                                            }\n                                            defunc_1_op_res_f_res_f_res_317355 =\n                                                defunc_1_op_res_f_res_f_res_f_res_317358;\n                                            defunc_1_op_res_f_res",
            "_f_res_317356 =\n                                                defunc_1_op_res_f_res_f_res_f_res_317359;\n                                        }\n                                        defunc_1_op_res_f_res_317352 =\n                                            defunc_1_op_res_f_res_f_res_317355;\n                                        defunc_1_op_res_f_res_317353 =\n                                            defunc_1_op_res_f_res_f_res_317356;\n                                    }\n                                    defunc_1_op_res_317347 =\n                                        defunc_1_op_res_f_res_317352;\n                                    defunc_1_op_res_317348 =\n                                        defunc_1_op_res_f_res_317353;\n                                }\n                                \n                                int64_t defunc_1_op_res_317363 = add64(x_317340,\n                                                                       x_317343);\n                                \n                                x_317338 = defunc_1_op_res_317347;\n                                x_317339 = defunc_1_op_res_317348;\n                                x_317340 = defunc_1_op_res_317363;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_325644) {\n                            ((__local\n                              double *) red_arr_mem_325600)[sext_i32_i64(local_tid_325596)] =\n                                x_317338;\n                            ((__local\n                              int64_t *) red_arr_mem_325602)[sext_i32_i64(local_tid_325596)] =\n                                x_317339;\n                            ((__local\n                              int64_t *) red_arr_mem_325604)[sext_i32_i64(local_tid_325596)] =\n                                x_317340;\n                        }\n                    }\n                }\n   ",
            "             barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_325596, 32) == 0 &&\n                        ltid_in_bounds_325637) {\n                        ((__local\n                          double *) red_arr_mem_325600)[sext_i32_i64(local_tid_325596)] =\n                            x_317341;\n                        ((__local\n                          int64_t *) red_arr_mem_325602)[sext_i32_i64(local_tid_325596)] =\n                            x_317342;\n                        ((__local\n                          int64_t *) red_arr_mem_325604)[sext_i32_i64(local_tid_325596)] =\n                            x_317343;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_325608) *\n                      squot64(segred_group_sizze_317329,\n                              segment_sizze_nonzzero_325593) +\n                      sext_i32_i64(local_tid_325596), partition_sizze_292766) &&\n                slt64(sext_i32_i64(local_tid_325596),\n                      squot64(segred_group_sizze_317329,\n                              segment_sizze_nonzzero_325593))) {\n                double tmp_325646;\n                \n                tmp_325646 = ((__local\n                               double *) red_arr_mem_325600)[(sext_i32_i64(local_tid_325596) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_325593 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_320397)[sext_i32_i64(virt_group_id_325608) *\n                                        squot64(segred_group_sizze_317329,\n                                     ",
            "           segment_sizze_nonzzero_325593) +\n                                        sext_i32_i64(local_tid_325596)] =\n                    tmp_325646;\n                \n                int64_t tmp_325647;\n                \n                tmp_325647 = ((__local\n                               int64_t *) red_arr_mem_325602)[(sext_i32_i64(local_tid_325596) +\n                                                               (int64_t) 1) *\n                                                              segment_sizze_nonzzero_325593 -\n                                                              (int64_t) 1];\n                ((__global\n                  int64_t *) mem_320400)[sext_i32_i64(virt_group_id_325608) *\n                                         squot64(segred_group_sizze_317329,\n                                                 segment_sizze_nonzzero_325593) +\n                                         sext_i32_i64(local_tid_325596)] =\n                    tmp_325647;\n                \n                int64_t tmp_325648;\n                \n                tmp_325648 = ((__local\n                               int64_t *) red_arr_mem_325604)[(sext_i32_i64(local_tid_325596) +\n                                                               (int64_t) 1) *\n                                                              segment_sizze_nonzzero_325593 -\n                                                              (int64_t) 1];\n                ((__global\n                  int64_t *) mem_320403)[sext_i32_i64(virt_group_id_325608) *\n                                         squot64(segred_group_sizze_317329,\n                                                 segment_sizze_nonzzero_325593) +\n                                         sext_i32_i64(local_tid_325596)] =\n                    tmp_325648;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_317329\n}\n__kernel",
            " void mainzisegred_small_325358(__global int *global_failure,\n                                        uint red_arr_mem_325366_backing_offset_0,\n                                        int64_t replicate_arg_297080,\n                                        int64_t num_groups_316941,\n                                        int32_t num_subhistos_325275,\n                                        int64_t segment_sizze_nonzzero_325359,\n                                        __global unsigned char *mem_320269,\n                                        __global\n                                        unsigned char *defunc_1_map_res_subhistos_mem_325276)\n{\n    #define seghist_group_sizze_316939 (mainziseghist_group_sizze_316938)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_325366_backing_0 =\n                           &shared_mem[red_arr_mem_325366_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325361;\n    int32_t local_tid_325362;\n    int64_t group_sizze_325365;\n    int32_t wave_sizze_325364;\n    int32_t group_tid_325363;\n    \n    global_tid_325361 = get_global_id(0);\n    local_tid_325362 = get_local_id(0);\n    group_sizze_325365 = get_local_size(0);\n    wave_sizze_325364 = LOCKSTEP_WIDTH;\n    group_tid_325363 = get_group_id(0);\n    \n    int32_t flat_gtid_325358 = global_tid_325361;\n    __local unsigned char *red_arr_mem_325366;\n    \n    red_arr_mem_325366 = (__local unsigned char *) red_arr_mem_325366_backing_0;\n    \n    int32_t phys_group_id_325368;\n    \n    phys_group_id_325368 = get_group_id(0);\n    for (int32_t i_325369 = 0; i_325369 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(replicate_arg_297080,\n                                          squot64(seghist_group_sizze_316939,\n                                                  segment_sizze_nonzzero_325359))) -\n                   phys_group_id_325368, sext_i64_i32(num_groups_316941));\n   ",
            "      i_325369++) {\n        int32_t virt_group_id_325370 = phys_group_id_325368 + i_325369 *\n                sext_i64_i32(num_groups_316941);\n        int64_t slice_325371 = replicate_arg_297080;\n        int64_t bucket_id_325356 = squot64(sext_i32_i64(local_tid_325362),\n                                           segment_sizze_nonzzero_325359) +\n                sext_i32_i64(virt_group_id_325370) *\n                squot64(seghist_group_sizze_316939,\n                        segment_sizze_nonzzero_325359);\n        int64_t remnant_325372 = squot64(sext_i32_i64(local_tid_325362),\n                                         segment_sizze_nonzzero_325359) +\n                sext_i32_i64(virt_group_id_325370) *\n                squot64(seghist_group_sizze_316939,\n                        segment_sizze_nonzzero_325359) - bucket_id_325356;\n        int64_t subhistogram_id_325357 = srem64(sext_i32_i64(local_tid_325362),\n                                                num_subhistos_325275);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, num_subhistos_325275) &&\n                (slt64(bucket_id_325356, replicate_arg_297080) &&\n                 slt64(sext_i32_i64(local_tid_325362), num_subhistos_325275 *\n                       squot64(seghist_group_sizze_316939,\n                               segment_sizze_nonzzero_325359)))) {\n                // save results to be reduced\n                {\n                    int32_t tmp_325373;\n                    \n                    tmp_325373 = ((__global\n                                   int32_t *) defunc_1_map_res_subhistos_mem_325276)[subhistogram_id_325357 *\n                                                                                     replicate_arg_297080 +\n                                                                                     bucket_id_325356];\n                    ((__local\n                      int32_t *) red_arr_mem_325366)[sext_i32_i64(local_tid_325362)] =\n               ",
            "         tmp_325373;\n                }\n            } else {\n                ((__local\n                  int32_t *) red_arr_mem_325366)[sext_i32_i64(local_tid_325362)] =\n                    0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, num_subhistos_325275)) {\n            // perform segmented scan to imitate reduction\n            {\n                int32_t x_316947;\n                int32_t x_316948;\n                int32_t x_325374;\n                int32_t x_325375;\n                bool ltid_in_bounds_325377 =\n                     slt64(sext_i32_i64(local_tid_325362),\n                           num_subhistos_325275 *\n                           squot64(seghist_group_sizze_316939,\n                                   segment_sizze_nonzzero_325359));\n                int32_t skip_threads_325378;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_325377) {\n                        x_316948 = ((volatile __local\n                                     int32_t *) red_arr_mem_325366)[sext_i32_i64(local_tid_325362)];\n                        if ((local_tid_325362 - squot32(local_tid_325362, 32) *\n                             32) == 0) {\n                            x_316947 = x_316948;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_325378 = 1;\n                    while (slt32(skip_threads_325378, 32)) {\n                        bool thread_active_325379 = sle32(skip_threads_325378,\n                                                          local_tid_325362 -\n                                                          squot32(local_tid_325362,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_325377;\n                        \n                        if (thread_active_32",
            "5379) {\n                            // read operands\n                            {\n                                x_316947 = ((volatile __local\n                                             int32_t *) red_arr_mem_325366)[sext_i32_i64(local_tid_325362) -\n                                                                            sext_i32_i64(skip_threads_325378)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_325380 =\n                                 slt64(srem64(sext_i32_i64(local_tid_325362),\n                                              num_subhistos_325275),\n                                       sext_i32_i64(local_tid_325362) -\n                                       sext_i32_i64(local_tid_325362 -\n                                       skip_threads_325378));\n                            \n                            if (thread_active_325379 && inactive_325380) {\n                                x_316947 = x_316948;\n                            }\n                            if (thread_active_325379) {\n                                if (!inactive_325380) {\n                                    int32_t defunc_1_f_res_316949 =\n                                            add32(x_316947, x_316948);\n                                    \n                                    x_316947 = defunc_1_f_res_316949;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_325364, skip_threads_325378)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_325379) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  int32_t *) red_arr_mem_325366)[sext_i32_i64(local_tid_325362)] =\n                                ",
            "    x_316947;\n                                x_316948 = x_316947;\n                            }\n                        }\n                        if (sle32(wave_sizze_325364, skip_threads_325378)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_325378 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_325362 - squot32(local_tid_325362, 32) *\n                         32) == 31 && ltid_in_bounds_325377) {\n                        ((volatile __local\n                          int32_t *) red_arr_mem_325366)[sext_i32_i64(squot32(local_tid_325362,\n                                                                              32))] =\n                            x_316947;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_325381;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_325362, 32) == 0 &&\n                            ltid_in_bounds_325377) {\n                            x_325375 = ((volatile __local\n                                         int32_t *) red_arr_mem_325366)[sext_i32_i64(local_tid_325362)];\n                            if ((local_tid_325362 - squot32(local_tid_325362,\n                                                            32) * 32) == 0) {\n                                x_325374 = x_325375;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_325381 = 1;\n                        while ",
            "(slt32(skip_threads_325381, 32)) {\n                            bool thread_active_325382 =\n                                 sle32(skip_threads_325381, local_tid_325362 -\n                                       squot32(local_tid_325362, 32) * 32) &&\n                                 (squot32(local_tid_325362, 32) == 0 &&\n                                  ltid_in_bounds_325377);\n                            \n                            if (thread_active_325382) {\n                                // read operands\n                                {\n                                    x_325374 = ((volatile __local\n                                                 int32_t *) red_arr_mem_325366)[sext_i32_i64(local_tid_325362) -\n                                                                                sext_i32_i64(skip_threads_325381)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_325383 =\n                                     slt64(srem64(sext_i32_i64(local_tid_325362 *\n                                                  32 + 32 - 1),\n                                                  num_subhistos_325275),\n                                           sext_i32_i64(local_tid_325362 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_325362 -\n                                                         skip_threads_325381) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_325382 && inactive_325383) {\n                                    x_325374 = x_325375;\n                                }\n                                if (thread_active_325382) {\n                                    if (!inactive_325383) {\n                                        int32_t defunc_1_f_res_325376 =\n",
            "                                                add32(x_325374, x_325375);\n                                        \n                                        x_325374 = defunc_1_f_res_325376;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_325364, skip_threads_325381)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_325382) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      int32_t *) red_arr_mem_325366)[sext_i32_i64(local_tid_325362)] =\n                                        x_325374;\n                                    x_325375 = x_325374;\n                                }\n                            }\n                            if (sle32(wave_sizze_325364, skip_threads_325381)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_325381 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_325384 = squot32(local_tid_325362, 32) == 0 ||\n                     !ltid_in_bounds_325377;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_325384) {\n                            x_316948 = x_316947;\n                            x_316947 = ((__local\n                                         int32_t *) red_arr_mem_325366)[sext_i32_i64(squot32(local_tid_325362,\n                                                                                             32)) -\n                                                                        ",
            "(int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_325385 =\n                             slt64(srem64(sext_i32_i64(local_tid_325362),\n                                          num_subhistos_325275),\n                                   sext_i32_i64(local_tid_325362) -\n                                   sext_i32_i64(squot32(local_tid_325362, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_325384) {\n                            if (inactive_325385) {\n                                x_316947 = x_316948;\n                            }\n                        }\n                        if (!no_carry_in_325384) {\n                            if (!inactive_325385) {\n                                int32_t defunc_1_f_res_316949 = add32(x_316947,\n                                                                      x_316948);\n                                \n                                x_316947 = defunc_1_f_res_316949;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_325384) {\n                            ((__local\n                              int32_t *) red_arr_mem_325366)[sext_i32_i64(local_tid_325362)] =\n                                x_316947;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_325362, 32) == 0 &&\n                        ltid_in_bounds_325377) {\n                        ((__local\n                          int32_t *) red_arr_mem_325366)[sext_i32_i64(local_tid_325362)] =\n                            x_316948;\n                    }\n                }\n                barrier(CLK",
            "_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_325370) *\n                      squot64(seghist_group_sizze_316939,\n                              segment_sizze_nonzzero_325359) +\n                      sext_i32_i64(local_tid_325362), replicate_arg_297080) &&\n                slt64(sext_i32_i64(local_tid_325362),\n                      squot64(seghist_group_sizze_316939,\n                              segment_sizze_nonzzero_325359))) {\n                int32_t tmp_325386;\n                \n                tmp_325386 = ((__local\n                               int32_t *) red_arr_mem_325366)[(sext_i32_i64(local_tid_325362) +\n                                                               (int64_t) 1) *\n                                                              segment_sizze_nonzzero_325359 -\n                                                              (int64_t) 1];\n                ((__global\n                  int32_t *) mem_320269)[sext_i32_i64(virt_group_id_325370) *\n                                         squot64(seghist_group_sizze_316939,\n                                                 segment_sizze_nonzzero_325359) +\n                                         sext_i32_i64(local_tid_325362)] =\n                    tmp_325386;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef seghist_group_sizze_316939\n}\n__kernel void mainzisegscan_297615(__global int *global_failure,\n                                   int failure_is_an_option, __global\n                                   int64_t *global_failure_args,\n                                   uint local_mem_320858_backing_offset_0,\n                                   int64_t m_292674, int64_t n_292675,\n                                   int64_t n_p_292677,\n                           ",
            "        int64_t defunc_0_f_res_292697, __global\n                                   unsigned char *mem_318493, __global\n                                   unsigned char *mem_318497, __global\n                                   unsigned char *mem_318500, __global\n                                   unsigned char *mem_318502, __global\n                                   unsigned char *mainziid_counter_mem_320829,\n                                   __global\n                                   unsigned char *status_flags_mem_320831,\n                                   __global\n                                   unsigned char *aggregates_mem_320833,\n                                   __global\n                                   unsigned char *incprefixes_mem_320835)\n{\n    #define segscan_group_sizze_297610 (mainzisegscan_group_sizze_297609)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *local_mem_320858_backing_0 =\n                           &shared_mem[local_mem_320858_backing_offset_0];\n    volatile __local bool local_failure;\n    \n    if (failure_is_an_option) {\n        int failed = *global_failure >= 0;\n        \n        if (failed)\n            return;\n    }\n    local_failure = false;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t global_tid_320849;\n    int32_t local_tid_320850;\n    int64_t group_sizze_320853;\n    int32_t wave_sizze_320852;\n    int32_t group_tid_320851;\n    \n    global_tid_320849 = get_global_id(0);\n    local_tid_320850 = get_local_id(0);\n    group_sizze_320853 = get_local_size(0);\n    wave_sizze_320852 = LOCKSTEP_WIDTH;\n    group_tid_320851 = get_group_id(0);\n    \n    int32_t phys_tid_297615 = global_tid_320849;\n    int64_t byte_offsets_320854 = (int64_t) 0;\n    int64_t byte_offsets_320855 = segscan_group_sizze_297610 * (int64_t) 8;\n    int64_t warp_byte_offset_320856 = (int64_t) 32;\n    int64_t warp_byte_offset_320857 = (int64_t) 288;\n    \n    // Allocate reused shared memeory\n",
            "    { }\n    \n    __local unsigned char *local_mem_320858;\n    \n    local_mem_320858 = (__local unsigned char *) local_mem_320858_backing_0;\n    \n    int64_t trans_arr_len_320859 = (int64_t) 11 * segscan_group_sizze_297610;\n    int32_t dynamic_id_320865;\n    \n    if (local_tid_320850 == 0) {\n        dynamic_id_320865 = atomic_add_i32_global(&((volatile __global\n                                                     int *) mainziid_counter_mem_320829)[(int64_t) 0],\n                                                  (int) 1);\n        ((__local int32_t *) local_mem_320858)[(int64_t) 0] = dynamic_id_320865;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    dynamic_id_320865 = ((__local int32_t *) local_mem_320858)[(int64_t) 0];\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t blockOff_320866 = sext_i32_i64(dynamic_id_320865) * (int64_t) 11 *\n            segscan_group_sizze_297610;\n    int64_t sgm_idx_320867 = smod64(blockOff_320866, m_292674);\n    int32_t boundary_320868 = sext_i64_i32(smin64((int64_t) 11 *\n                                                  segscan_group_sizze_297610,\n                                                  m_292674 - sgm_idx_320867));\n    int32_t segsizze_compact_320869 = sext_i64_i32(smin64((int64_t) 11 *\n                                                          segscan_group_sizze_297610,\n                                                          m_292674));\n    int64_t private_mem_320870[(int64_t) 11];\n    \n    // Load and map\n    {\n        for (int64_t i_320872 = 0; i_320872 < (int64_t) 11; i_320872++) {\n            int64_t phys_tid_320873 = blockOff_320866 +\n                    sext_i32_i64(local_tid_320850) + i_320872 *\n                    segscan_group_sizze_297610;\n            int64_t slice_320874 = m_292674;\n            int64_t gtid_297614 = phys_tid_320873;\n            int64_t remnant_320875 = phys_tid_320873 - gtid_297614;\n            \n            if (slt64(phys_tid_320873, m_292674)) {\n                bool defunc_2_reduce_res_292736;\n      ",
            "          bool redout_317853 = 0;\n                \n                for (int64_t i_317854 = 0; i_317854 < n_p_292677; i_317854++) {\n                    bool defunc_2_reduce_res_292741;\n                    bool redout_317855 = 1;\n                    \n                    for (int64_t i_317856 = 0; i_317856 < defunc_0_f_res_292697;\n                         i_317856++) {\n                        int64_t x_292746 = mul64(n_p_292677, i_317856);\n                        int64_t idx_292747 = add64(x_292746, i_317854);\n                        bool cond_292748 = sle64(n_292675, idx_292747);\n                        bool defunc_0_f_res_292749;\n                        \n                        if (cond_292748) {\n                            defunc_0_f_res_292749 = 1;\n                        } else {\n                            bool x_292750 = sle64((int64_t) 0, idx_292747);\n                            bool y_292751 = slt64(idx_292747, n_292675);\n                            bool bounds_check_292752 = x_292750 && y_292751;\n                            bool index_certs_292753;\n                            \n                            if (!bounds_check_292752) {\n                                {\n                                    if (atomic_cmpxchg_i32_global(global_failure,\n                                                                  -1, 0) ==\n                                        -1) {\n                                        global_failure_args[0] =\n                                            (int64_t) idx_292747;\n                                        global_failure_args[1] =\n                                            (int64_t) n_292675;\n                                        ;\n                                    }\n                                    local_failure = true;\n                                    goto error_0;\n                                }\n                            }\n                            \n                            float isnan_arg_292754;\n            ",
            "                \n                            isnan_arg_292754 = ((__global\n                                                 float *) mem_318493)[idx_292747 *\n                                                                      m_292674 +\n                                                                      gtid_297614];\n                            \n                            bool isnan_res_292755;\n                            \n                            isnan_res_292755 = futrts_isnan32(isnan_arg_292754);\n                            defunc_0_f_res_292749 = isnan_res_292755;\n                        }\n                        \n                        bool x_292744 = defunc_0_f_res_292749 && redout_317855;\n                        bool redout_tmp_320877 = x_292744;\n                        \n                        redout_317855 = redout_tmp_320877;\n                    }\n                    defunc_2_reduce_res_292741 = redout_317855;\n                    \n                    bool defunc_1_op_res_292739 = defunc_2_reduce_res_292741 ||\n                         redout_317853;\n                    bool redout_tmp_320876 = defunc_1_op_res_292739;\n                    \n                    redout_317853 = redout_tmp_320876;\n                }\n                defunc_2_reduce_res_292736 = redout_317853;\n                \n                int64_t defunc_2_lifted_lambda_res_292756 =\n                        btoi_bool_i64(defunc_2_reduce_res_292736);\n                bool is_i_292757 = defunc_2_lifted_lambda_res_292756 ==\n                     (int64_t) 0;\n                bool cond_neg_292758 = !is_i_292757;\n                int64_t part_res_292759 = btoi_bool_i64(cond_neg_292758);\n                int64_t part_res_292760 = btoi_bool_i64(is_i_292757);\n                \n                ((__global int64_t *) mem_318500)[gtid_297614] =\n                    part_res_292759;\n                ((__global bool *) mem_318502)[gtid_297614] =\n                    defunc_2_reduce_res_292736;\n                p",
            "rivate_mem_320870[i_320872] = part_res_292760;\n            } else {\n                private_mem_320870[i_320872] = (int64_t) 0;\n            }\n        }\n    }\n    // Transpose scan inputs\n    {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_320878 = 0; i_320878 < (int64_t) 11; i_320878++) {\n            int64_t sharedIdx_320879 = sext_i32_i64(local_tid_320850) +\n                    i_320878 * segscan_group_sizze_297610;\n            int64_t tmp_320880;\n            \n            tmp_320880 = private_mem_320870[i_320878];\n            ((__local int64_t *) local_mem_320858)[sharedIdx_320879] =\n                tmp_320880;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int32_t i_320881 = 0; i_320881 < 11; i_320881++) {\n            int32_t sharedIdx_320882 = local_tid_320850 * 11 + i_320881;\n            int64_t tmp_320883;\n            \n            tmp_320883 = ((__local\n                           int64_t *) local_mem_320858)[sext_i32_i64(sharedIdx_320882)];\n            private_mem_320870[sext_i32_i64(i_320881)] = tmp_320883;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // Per thread scan\n    {\n        int32_t gidx_320884 = local_tid_320850 * 11 + 1;\n        \n        for (int64_t i_320885 = 0; i_320885 < (int64_t) 10; i_320885++) {\n            int64_t x_292732;\n            int64_t y_292733;\n            \n            x_292732 = private_mem_320870[i_320885];\n            y_292733 = private_mem_320870[i_320885 + (int64_t) 1];\n            \n            int64_t zz_292734 = x_292732 + y_292733;\n            \n            private_mem_320870[i_320885 + (int64_t) 1] = zz_292734;\n        }\n    }\n    // Publish results in shared memory\n    {\n        int64_t tmp_320886;\n        \n        tmp_320886 = private_mem_320870[(int64_t) 10];\n        ((__local int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                       (int64_t) 8) +\n                                               sext_i32_i64(local_tid_320850)] ",
            "=\n            tmp_320886;\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    int64_t acc_320890;\n    \n    // Scan results (with warp scan)\n    {\n        int64_t x_320887;\n        int64_t y_320888;\n        int64_t x_320891;\n        int64_t y_320892;\n        bool ltid_in_bounds_320894 = slt64(sext_i32_i64(local_tid_320850),\n                                           segscan_group_sizze_297610);\n        int32_t skip_threads_320895;\n        \n        // read input for in-block scan\n        {\n            if (ltid_in_bounds_320894) {\n                y_320888 = ((volatile __local\n                             int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                                  (int64_t) 8) +\n                                                          sext_i32_i64(local_tid_320850)];\n                if ((local_tid_320850 - squot32(local_tid_320850, 32) * 32) ==\n                    0) {\n                    x_320887 = y_320888;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_320895 = 1;\n            while (slt32(skip_threads_320895, 32)) {\n                bool thread_active_320896 = sle32(skip_threads_320895,\n                                                  local_tid_320850 -\n                                                  squot32(local_tid_320850,\n                                                          32) * 32) &&\n                     ltid_in_bounds_320894;\n                \n                if (thread_active_320896) {\n                    // read operands\n                    {\n                        x_320887 = ((volatile __local\n                                     int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                                          (int64_t) 8) +\n                                                                  (sext_i32_i64(local_tid_320850) -\n                            ",
            "                                       sext_i32_i64(skip_threads_320895))];\n                    }\n                }\n                // perform operation\n                {\n                    if (thread_active_320896) {\n                        int64_t zz_320889 = x_320887 + y_320888;\n                        \n                        x_320887 = zz_320889;\n                    }\n                }\n                if (sle32(wave_sizze_320852, skip_threads_320895)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_320896) {\n                    // write result\n                    {\n                        ((volatile __local\n                          int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                               (int64_t) 8) +\n                                                       sext_i32_i64(local_tid_320850)] =\n                            x_320887;\n                        y_320888 = x_320887;\n                    }\n                }\n                if (sle32(wave_sizze_320852, skip_threads_320895)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_320895 *= 2;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // last thread of block 'i' writes its result to offset 'i'\n        {\n            if ((local_tid_320850 - squot32(local_tid_320850, 32) * 32) == 31 &&\n                ltid_in_bounds_320894) {\n                ((volatile __local\n                  int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                       (int64_t) 8) +\n                                               sext_i32_i64(squot32(local_tid_320850,\n                                                                    32))] =\n                    x_320887;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // scan the first block, after which offset 'i' contains carry-in",
            " for block 'i+1'\n        {\n            int32_t skip_threads_320897;\n            \n            // read input for in-block scan\n            {\n                if (squot32(local_tid_320850, 32) == 0 &&\n                    ltid_in_bounds_320894) {\n                    y_320892 = ((volatile __local\n                                 int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                                      (int64_t) 8) +\n                                                              sext_i32_i64(local_tid_320850)];\n                    if ((local_tid_320850 - squot32(local_tid_320850, 32) *\n                         32) == 0) {\n                        x_320891 = y_320892;\n                    }\n                }\n            }\n            // in-block scan (hopefully no barriers needed)\n            {\n                skip_threads_320897 = 1;\n                while (slt32(skip_threads_320897, 32)) {\n                    bool thread_active_320898 = sle32(skip_threads_320897,\n                                                      local_tid_320850 -\n                                                      squot32(local_tid_320850,\n                                                              32) * 32) &&\n                         (squot32(local_tid_320850, 32) == 0 &&\n                          ltid_in_bounds_320894);\n                    \n                    if (thread_active_320898) {\n                        // read operands\n                        {\n                            x_320891 = ((volatile __local\n                                         int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                                              (int64_t) 8) +\n                                                                      (sext_i32_i64(local_tid_320850) -\n                                                                       sext_i32_i64(skip_threads_320897))];\n                        }\n            ",
            "        }\n                    // perform operation\n                    {\n                        if (thread_active_320898) {\n                            int64_t zz_320893 = x_320891 + y_320892;\n                            \n                            x_320891 = zz_320893;\n                        }\n                    }\n                    if (sle32(wave_sizze_320852, skip_threads_320897)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    if (thread_active_320898) {\n                        // write result\n                        {\n                            ((volatile __local\n                              int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                                   (int64_t) 8) +\n                                                           sext_i32_i64(local_tid_320850)] =\n                                x_320891;\n                            y_320892 = x_320891;\n                        }\n                    }\n                    if (sle32(wave_sizze_320852, skip_threads_320897)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    skip_threads_320897 *= 2;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        bool no_carry_in_320899 = squot32(local_tid_320850, 32) == 0 ||\n             !ltid_in_bounds_320894;\n        \n        // carry-in for every block except the first\n        {\n            // read operands\n            {\n                if (!no_carry_in_320899) {\n                    y_320888 = x_320887;\n                    x_320887 = ((__local\n                                 int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                                      (int64_t) 8) +\n                                                              (sext_i32_i64(squot32(local_tid_320850,\n                                                        ",
            "                            32)) -\n                                                               (int64_t) 1)];\n                }\n            }\n            // perform operation\n            {\n                if (!no_carry_in_320899) {\n                    int64_t zz_320889 = x_320887 + y_320888;\n                    \n                    x_320887 = zz_320889;\n                }\n            }\n            // write final result\n            {\n                if (!no_carry_in_320899) {\n                    ((__local\n                      int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                           (int64_t) 8) +\n                                                   sext_i32_i64(local_tid_320850)] =\n                        x_320887;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // restore correct values for first block\n        {\n            if (squot32(local_tid_320850, 32) == 0 && ltid_in_bounds_320894) {\n                ((__local\n                  int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                       (int64_t) 8) +\n                                               sext_i32_i64(local_tid_320850)] =\n                    y_320888;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (local_tid_320850 == 0) {\n            acc_320890 = ((__local\n                           int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                                (int64_t) 8) +\n                                                        (segscan_group_sizze_297610 -\n                                                         (int64_t) 1)];\n        } else {\n            acc_320890 = ((__local\n                           int64_t *) local_mem_320858)[squot64(byte_offsets_320854,\n                                                                (int64_t) 8) +\n   ",
            "                                                     (sext_i32_i64(local_tid_320850) -\n                                                         (int64_t) 1)];\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    int64_t prefix_320900 = (int64_t) 0;\n    bool block_new_sgm_320901 = sgm_idx_320867 == (int64_t) 0;\n    \n    // Perform lookback\n    {\n        if (block_new_sgm_320901 && local_tid_320850 == 0) {\n            ((volatile __global\n              int64_t *) incprefixes_mem_320835)[dynamic_id_320865] =\n                acc_320890;\n            mem_fence_global();\n            ((volatile __global\n              int8_t *) status_flags_mem_320831)[dynamic_id_320865] =\n                (int8_t) 2;\n            acc_320890 = (int64_t) 0;\n        }\n        if (!block_new_sgm_320901 && slt32(local_tid_320850,\n                                           wave_sizze_320852)) {\n            if (local_tid_320850 == 0) {\n                ((volatile __global\n                  int64_t *) aggregates_mem_320833)[dynamic_id_320865] =\n                    acc_320890;\n                mem_fence_global();\n                ((volatile __global\n                  int8_t *) status_flags_mem_320831)[dynamic_id_320865] =\n                    (int8_t) 1;\n                \n                int8_t tmp_320902;\n                \n                tmp_320902 = ((volatile __global\n                               int8_t *) status_flags_mem_320831)[dynamic_id_320865 -\n                                                                  (int64_t) 1];\n                ((volatile __local int8_t *) local_mem_320858)[(int64_t) 0] =\n                    tmp_320902;\n            }\n            mem_fence_local();\n            \n            int8_t status_320903;\n            \n            status_320903 = ((__local int8_t *) local_mem_320858)[(int64_t) 0];\n            if (status_320903 == (int8_t) 2) {\n                if (local_tid_320850 == 0) {\n                    prefix_320900 = ((volatile __global\n                             ",
            "         int64_t *) incprefixes_mem_320835)[dynamic_id_320865 -\n                                                                         (int64_t) 1];\n                }\n            } else {\n                int32_t readOffset_320904 = dynamic_id_320865 -\n                        sext_i32_i64(wave_sizze_320852);\n                \n                while (slt32(wave_sizze_320852 * -1, readOffset_320904)) {\n                    int32_t read_i_320905 = readOffset_320904 +\n                            local_tid_320850;\n                    int64_t aggr_320906 = (int64_t) 0;\n                    int8_t flag_320907 = (int8_t) 0;\n                    \n                    if (sle32(0, read_i_320905)) {\n                        flag_320907 = ((volatile __global\n                                        int8_t *) status_flags_mem_320831)[sext_i32_i64(read_i_320905)];\n                        if (flag_320907 == (int8_t) 2) {\n                            aggr_320906 = ((volatile __global\n                                            int64_t *) incprefixes_mem_320835)[sext_i32_i64(read_i_320905)];\n                        } else {\n                            if (flag_320907 == (int8_t) 1) {\n                                aggr_320906 = ((volatile __global\n                                                int64_t *) aggregates_mem_320833)[sext_i32_i64(read_i_320905)];\n                            }\n                        }\n                    }\n                    ((__local\n                      int64_t *) local_mem_320858)[squot64(warp_byte_offset_320856,\n                                                           (int64_t) 8) +\n                                                   sext_i32_i64(local_tid_320850)] =\n                        aggr_320906;\n                    ((__local\n                      int8_t *) local_mem_320858)[sext_i32_i64(local_tid_320850)] =\n                        flag_320907;\n                    flag_320907 = ((__local\n                                    int8_t *) local_mem_32085",
            "8)[sext_i32_i64(wave_sizze_320852) -\n                                                                (int64_t) 1];\n                    if (slt8(flag_320907, (int8_t) 2)) {\n                        int8_t flg_x_320911;\n                        int8_t flg_y_320912;\n                        int64_t x_320908;\n                        int64_t y_320909;\n                        int32_t skip_threads_320913;\n                        \n                        // read input for in-block scan\n                        {\n                            flg_y_320912 = ((volatile __local\n                                             int8_t *) local_mem_320858)[sext_i32_i64(local_tid_320850)];\n                            y_320909 = ((volatile __local\n                                         int64_t *) local_mem_320858)[squot64(warp_byte_offset_320856,\n                                                                              (int64_t) 8) +\n                                                                      sext_i32_i64(local_tid_320850)];\n                            if ((local_tid_320850 - squot32(local_tid_320850,\n                                                            32) * 32) == 0) {\n                                x_320908 = y_320909;\n                                flg_x_320911 = flg_y_320912;\n                            }\n                        }\n                        // in-block scan (hopefully no barriers needed)\n                        {\n                            skip_threads_320913 = 1;\n                            while (slt32(skip_threads_320913, 32)) {\n                                if (sle32(skip_threads_320913,\n                                          local_tid_320850 -\n                                          squot32(local_tid_320850, 32) * 32)) {\n                                    // read operands\n                                    {\n                                        flg_x_320911 = ((volatile __local\n                                                     ",
            "    int8_t *) local_mem_320858)[sext_i32_i64(local_tid_320850) -\n                                                                                     sext_i32_i64(skip_threads_320913)];\n                                        x_320908 = ((volatile __local\n                                                     int64_t *) local_mem_320858)[squot64(warp_byte_offset_320856,\n                                                                                          (int64_t) 8) +\n                                                                                  (sext_i32_i64(local_tid_320850) -\n                                                                                   sext_i32_i64(skip_threads_320913))];\n                                    }\n                                    // perform operation\n                                    {\n                                        if (flg_y_320912 == (int8_t) 2 ||\n                                            flg_y_320912 == (int8_t) 0) {\n                                            flg_x_320911 = flg_y_320912;\n                                            x_320908 = y_320909;\n                                        } else {\n                                            int64_t zz_320910 = x_320908 +\n                                                    y_320909;\n                                            \n                                            x_320908 = zz_320910;\n                                        }\n                                    }\n                                    // write result\n                                    {\n                                        ((volatile __local\n                                          int8_t *) local_mem_320858)[sext_i32_i64(local_tid_320850)] =\n                                            flg_x_320911;\n                                        flg_y_320912 = flg_x_320911;\n                                        ((volatile __local\n                                          int64_t *) ",
            "local_mem_320858)[squot64(warp_byte_offset_320856,\n                                                                               (int64_t) 8) +\n                                                                       sext_i32_i64(local_tid_320850)] =\n                                            x_320908;\n                                        y_320909 = x_320908;\n                                    }\n                                }\n                                skip_threads_320913 *= 2;\n                            }\n                        }\n                    }\n                    flag_320907 = ((__local\n                                    int8_t *) local_mem_320858)[sext_i32_i64(wave_sizze_320852) -\n                                                                (int64_t) 1];\n                    aggr_320906 = ((__local\n                                    int64_t *) local_mem_320858)[squot64(warp_byte_offset_320856,\n                                                                         (int64_t) 8) +\n                                                                 (sext_i32_i64(wave_sizze_320852) -\n                                                                  (int64_t) 1)];\n                    if (flag_320907 == (int8_t) 2) {\n                        readOffset_320904 = wave_sizze_320852 * -1;\n                    } else {\n                        if (flag_320907 == (int8_t) 1) {\n                            readOffset_320904 -= wave_sizze_320852;\n                        }\n                    }\n                    if (slt8((int8_t) 0, flag_320907)) {\n                        int64_t x_320914 = aggr_320906;\n                        int64_t y_320915 = prefix_320900;\n                        int64_t zz_320916 = x_320914 + y_320915;\n                        \n                        prefix_320900 = zz_320916;\n                    }\n                    mem_fence_local();\n                }\n            }\n            if (local_tid_320850 == 0) {\n                if (boundar",
            "y_320868 == sext_i64_i32(segscan_group_sizze_297610 *\n                    (int64_t) 11)) {\n                    int64_t x_320917 = prefix_320900;\n                    int64_t y_320918 = acc_320890;\n                    int64_t zz_320919 = x_320917 + y_320918;\n                    \n                    ((volatile __global\n                      int64_t *) incprefixes_mem_320835)[dynamic_id_320865] =\n                        zz_320919;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_320831)[dynamic_id_320865] =\n                        (int8_t) 2;\n                }\n                ((__local\n                  int64_t *) local_mem_320858)[squot64(warp_byte_offset_320856,\n                                                       (int64_t) 8)] =\n                    prefix_320900;\n                acc_320890 = (int64_t) 0;\n            }\n        }\n        if (!(dynamic_id_320865 == (int64_t) 0)) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            prefix_320900 = ((__local\n                              int64_t *) local_mem_320858)[squot64(warp_byte_offset_320856,\n                                                                   (int64_t) 8)];\n            barrier(CLK_LOCAL_MEM_FENCE);\n        }\n    }\n    // Distribute results\n    {\n        int64_t x_320920;\n        int64_t y_320921;\n        int64_t x_320923 = prefix_320900;\n        int64_t y_320924 = acc_320890;\n        \n        if (slt32(local_tid_320850 * 11, boundary_320868) &&\n            !block_new_sgm_320901) {\n            int64_t zz_320925 = x_320923 + y_320924;\n            \n            x_320920 = zz_320925;\n        } else {\n            x_320920 = acc_320890;\n        }\n        \n        int32_t stopping_point_320926 = segsizze_compact_320869 -\n                srem32(local_tid_320850 * 11 - 1 + segsizze_compact_320869 -\n                       boundary_320868, segsizze_compact_320869);\n        \n        for (int64_t i_320927 = 0; i_320927 < (int64_t)",
            " 11; i_320927++) {\n            if (slt32(sext_i64_i32(i_320927), stopping_point_320926 - 1)) {\n                y_320921 = private_mem_320870[i_320927];\n                \n                int64_t zz_320922 = x_320920 + y_320921;\n                \n                private_mem_320870[i_320927] = zz_320922;\n            }\n        }\n    }\n    // Transpose scan output and Write it to global memory in coalesced fashion\n    {\n        for (int64_t i_320928 = 0; i_320928 < (int64_t) 11; i_320928++) {\n            int64_t sharedIdx_320929 = sext_i32_i64(local_tid_320850 * 11) +\n                    i_320928;\n            int64_t tmp_320930;\n            \n            tmp_320930 = private_mem_320870[i_320928];\n            ((__local int64_t *) local_mem_320858)[sharedIdx_320929] =\n                tmp_320930;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_320931 = 0; i_320931 < (int64_t) 11; i_320931++) {\n            int64_t flat_idx_320932 = blockOff_320866 +\n                    segscan_group_sizze_297610 * i_320931 +\n                    sext_i32_i64(local_tid_320850);\n            int64_t slice_320933 = m_292674;\n            int64_t gtid_297614 = flat_idx_320932;\n            int64_t remnant_320934 = flat_idx_320932 - gtid_297614;\n            \n            if (slt64(flat_idx_320932, m_292674)) {\n                int64_t tmp_320935;\n                \n                tmp_320935 = ((__local\n                               int64_t *) local_mem_320858)[flat_idx_320932 -\n                                                            blockOff_320866];\n                ((__global int64_t *) mem_318497)[gtid_297614] = tmp_320935;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // If this is the last block, reset the dynamicId\n    {\n        if (dynamic_id_320865 == sdiv_up64(m_292674,\n                                           segscan_group_sizze_297610 *\n                                           (int64_t) 11) - (int64_t) 1) {\n            ((__global int32_t *",
            ") mainziid_counter_mem_320829)[(int64_t) 0] = 0;\n        }\n    }\n    \n  error_0:\n    return;\n    #undef segscan_group_sizze_297610\n}\n__kernel void mainzisegscan_297755(__global int *global_failure,\n                                   uint local_mem_320998_backing_offset_0,\n                                   int64_t n_292675,\n                                   int64_t partition_sizze_292766, __global\n                                   unsigned char *mem_318506, __global\n                                   unsigned char *mem_318531, __global\n                                   unsigned char *mainziid_counter_mem_320981,\n                                   __global\n                                   unsigned char *status_flags_mem_320983,\n                                   __global\n                                   unsigned char *aggregates_mem_320985,\n                                   __global\n                                   unsigned char *incprefixes_mem_320987)\n{\n    #define segscan_group_sizze_297749 (mainzisegscan_group_sizze_297729)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *local_mem_320998_backing_0 =\n                           &shared_mem[local_mem_320998_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_320989;\n    int32_t local_tid_320990;\n    int64_t group_sizze_320993;\n    int32_t wave_sizze_320992;\n    int32_t group_tid_320991;\n    \n    global_tid_320989 = get_global_id(0);\n    local_tid_320990 = get_local_id(0);\n    group_sizze_320993 = get_local_size(0);\n    wave_sizze_320992 = LOCKSTEP_WIDTH;\n    group_tid_320991 = get_group_id(0);\n    \n    int32_t phys_tid_297755 = global_tid_320989;\n    int64_t byte_offsets_320994 = (int64_t) 0;\n    int64_t byte_offsets_320995 = segscan_group_sizze_297749 * (int64_t) 8;\n    int64_t warp_byte_offset_320996 = (int64_t) 32;\n    int64_t warp_byte_offset_320997 = (int64_t) 288;\n    \n    // Alloc",
            "ate reused shared memeory\n    { }\n    \n    __local unsigned char *local_mem_320998;\n    \n    local_mem_320998 = (__local unsigned char *) local_mem_320998_backing_0;\n    \n    int64_t trans_arr_len_320999 = (int64_t) 11 * segscan_group_sizze_297749;\n    int32_t dynamic_id_321005;\n    \n    if (local_tid_320990 == 0) {\n        dynamic_id_321005 = atomic_add_i32_global(&((volatile __global\n                                                     int *) mainziid_counter_mem_320981)[(int64_t) 0],\n                                                  (int) 1);\n        ((__local int32_t *) local_mem_320998)[(int64_t) 0] = dynamic_id_321005;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    dynamic_id_321005 = ((__local int32_t *) local_mem_320998)[(int64_t) 0];\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t blockOff_321006 = sext_i32_i64(dynamic_id_321005) * (int64_t) 11 *\n            segscan_group_sizze_297749;\n    int64_t sgm_idx_321007 = smod64(blockOff_321006, n_292675);\n    int32_t boundary_321008 = sext_i64_i32(smin64((int64_t) 11 *\n                                                  segscan_group_sizze_297749,\n                                                  n_292675 - sgm_idx_321007));\n    int32_t segsizze_compact_321009 = sext_i64_i32(smin64((int64_t) 11 *\n                                                          segscan_group_sizze_297749,\n                                                          n_292675));\n    int64_t private_mem_321010[(int64_t) 11];\n    \n    // Load and map\n    {\n        for (int64_t i_321012 = 0; i_321012 < (int64_t) 11; i_321012++) {\n            int64_t phys_tid_321013 = blockOff_321006 +\n                    sext_i32_i64(local_tid_320990) + i_321012 *\n                    segscan_group_sizze_297749;\n            int64_t slice_321014 = n_292675;\n            int64_t slice_321015 = partition_sizze_292766 * slice_321014;\n            int64_t gtid_297753 = squot64(phys_tid_321013, slice_321014);\n            int64_t remnant_321016 = phys_tid_321013 - gtid_29775",
            "3 *\n                    slice_321014;\n            int64_t gtid_297754 = remnant_321016;\n            int64_t remnant_321017 = remnant_321016 - gtid_297754;\n            \n            if (slt64(phys_tid_321013, partition_sizze_292766 * n_292675)) {\n                float x_297760;\n                \n                x_297760 = ((__global float *) mem_318506)[gtid_297753 *\n                                                           n_292675 +\n                                                           gtid_297754];\n                \n                bool isnan_res_297761;\n                \n                isnan_res_297761 = futrts_isnan32(x_297760);\n                \n                bool defunc_0_p_res_297762 = !isnan_res_297761;\n                int64_t defunc_0_f_res_297763 =\n                        btoi_bool_i64(defunc_0_p_res_297762);\n                \n                private_mem_321010[i_321012] = defunc_0_f_res_297763;\n            } else {\n                private_mem_321010[i_321012] = (int64_t) 0;\n            }\n        }\n    }\n    // Transpose scan inputs\n    {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_321018 = 0; i_321018 < (int64_t) 11; i_321018++) {\n            int64_t sharedIdx_321019 = sext_i32_i64(local_tid_320990) +\n                    i_321018 * segscan_group_sizze_297749;\n            int64_t tmp_321020;\n            \n            tmp_321020 = private_mem_321010[i_321018];\n            ((__local int64_t *) local_mem_320998)[sharedIdx_321019] =\n                tmp_321020;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int32_t i_321021 = 0; i_321021 < 11; i_321021++) {\n            int32_t sharedIdx_321022 = local_tid_320990 * 11 + i_321021;\n            int64_t tmp_321023;\n            \n            tmp_321023 = ((__local\n                           int64_t *) local_mem_320998)[sext_i32_i64(sharedIdx_321022)];\n            private_mem_321010[sext_i32_i64(i_321021)] = tmp_321023;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // Per th",
            "read scan\n    {\n        int32_t gidx_321024 = local_tid_320990 * 11 + 1;\n        \n        for (int64_t i_321025 = 0; i_321025 < (int64_t) 10; i_321025++) {\n            bool new_sgm_321026 = smod32(gidx_321024 + sext_i64_i32(i_321025) -\n                                         boundary_321008,\n                                         segsizze_compact_321009) == 0;\n            \n            if (!new_sgm_321026) {\n                int64_t x_297756;\n                int64_t x_297757;\n                \n                x_297756 = private_mem_321010[i_321025];\n                x_297757 = private_mem_321010[i_321025 + (int64_t) 1];\n                \n                int64_t defunc_1_op_res_297758 = add64(x_297756, x_297757);\n                \n                private_mem_321010[i_321025 + (int64_t) 1] =\n                    defunc_1_op_res_297758;\n            }\n        }\n    }\n    // Publish results in shared memory\n    {\n        int64_t tmp_321027;\n        \n        tmp_321027 = private_mem_321010[(int64_t) 10];\n        ((__local int64_t *) local_mem_320998)[squot64(byte_offsets_320994,\n                                                       (int64_t) 8) +\n                                               sext_i32_i64(local_tid_320990)] =\n            tmp_321027;\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    int64_t acc_321031;\n    \n    // Scan results (with warp scan)\n    {\n        int64_t x_321028;\n        int64_t x_321029;\n        int64_t x_321032;\n        int64_t x_321033;\n        bool ltid_in_bounds_321035 = slt64(sext_i32_i64(local_tid_320990),\n                                           segscan_group_sizze_297749);\n        int32_t skip_threads_321036;\n        \n        // read input for in-block scan\n        {\n            if (ltid_in_bounds_321035) {\n                x_321029 = ((volatile __local\n                             int64_t *) local_mem_320998)[squot64(byte_offsets_320994,\n                                                                  (int64_t) 8) +\n                ",
            "                                          sext_i32_i64(local_tid_320990)];\n                if ((local_tid_320990 - squot32(local_tid_320990, 32) * 32) ==\n                    0) {\n                    x_321028 = x_321029;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_321036 = 1;\n            while (slt32(skip_threads_321036, 32)) {\n                bool thread_active_321037 = sle32(skip_threads_321036,\n                                                  local_tid_320990 -\n                                                  squot32(local_tid_320990,\n                                                          32) * 32) &&\n                     ltid_in_bounds_321035;\n                \n                if (thread_active_321037) {\n                    // read operands\n                    {\n                        x_321028 = ((volatile __local\n                                     int64_t *) local_mem_320998)[squot64(byte_offsets_320994,\n                                                                          (int64_t) 8) +\n                                                                  (sext_i32_i64(local_tid_320990) -\n                                                                   sext_i32_i64(skip_threads_321036))];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_321038 = slt32(smod32((local_tid_320990 + 1) *\n                                                        11 - 1 +\n                                                        segsizze_compact_321009 -\n                                                        boundary_321008,\n                                                        segsizze_compact_321009),\n                                                 (local_tid_320990 + 1) * 11 -\n                                                 1 - ((local_tid_320990 -\n                                                       ski",
            "p_threads_321036 +\n                                                       1) * 11 - 1));\n                    \n                    if (thread_active_321037 && inactive_321038) {\n                        x_321028 = x_321029;\n                    }\n                    if (thread_active_321037) {\n                        if (!inactive_321038) {\n                            int64_t defunc_1_op_res_321030 = add64(x_321028,\n                                                                   x_321029);\n                            \n                            x_321028 = defunc_1_op_res_321030;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_320992, skip_threads_321036)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_321037) {\n                    // write result\n                    {\n                        ((volatile __local\n                          int64_t *) local_mem_320998)[squot64(byte_offsets_320994,\n                                                               (int64_t) 8) +\n                                                       sext_i32_i64(local_tid_320990)] =\n                            x_321028;\n                        x_321029 = x_321028;\n                    }\n                }\n                if (sle32(wave_sizze_320992, skip_threads_321036)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_321036 *= 2;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // last thread of block 'i' writes its result to offset 'i'\n        {\n            if ((local_tid_320990 - squot32(local_tid_320990, 32) * 32) == 31 &&\n                ltid_in_bounds_321035) {\n                ((volatile __local\n                  int64_t *) local_mem_320998)[squot64(byte_offsets_320994,\n                                                       (int64_t) 8) +\n                                               sext_i32_i64(squot32(l",
            "ocal_tid_320990,\n                                                                    32))] =\n                    x_321028;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n        {\n            int32_t skip_threads_321039;\n            \n            // read input for in-block scan\n            {\n                if (squot32(local_tid_320990, 32) == 0 &&\n                    ltid_in_bounds_321035) {\n                    x_321033 = ((volatile __local\n                                 int64_t *) local_mem_320998)[squot64(byte_offsets_320994,\n                                                                      (int64_t) 8) +\n                                                              sext_i32_i64(local_tid_320990)];\n                    if ((local_tid_320990 - squot32(local_tid_320990, 32) *\n                         32) == 0) {\n                        x_321032 = x_321033;\n                    }\n                }\n            }\n            // in-block scan (hopefully no barriers needed)\n            {\n                skip_threads_321039 = 1;\n                while (slt32(skip_threads_321039, 32)) {\n                    bool thread_active_321040 = sle32(skip_threads_321039,\n                                                      local_tid_320990 -\n                                                      squot32(local_tid_320990,\n                                                              32) * 32) &&\n                         (squot32(local_tid_320990, 32) == 0 &&\n                          ltid_in_bounds_321035);\n                    \n                    if (thread_active_321040) {\n                        // read operands\n                        {\n                            x_321032 = ((volatile __local\n                                         int64_t *) local_mem_320998)[squot64(byte_offsets_320994,\n                                                                              (int64_",
            "t) 8) +\n                                                                      (sext_i32_i64(local_tid_320990) -\n                                                                       sext_i32_i64(skip_threads_321039))];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_321041 = slt32(smod32((local_tid_320990 *\n                                                             32 + 32 - 1 + 1) *\n                                                            11 - 1 +\n                                                            segsizze_compact_321009 -\n                                                            boundary_321008,\n                                                            segsizze_compact_321009),\n                                                     (local_tid_320990 * 32 +\n                                                      32 - 1 + 1) * 11 - 1 -\n                                                     (((local_tid_320990 -\n                                                        skip_threads_321039) *\n                                                       32 + 32 - 1 + 1) * 11 -\n                                                      1));\n                        \n                        if (thread_active_321040 && inactive_321041) {\n                            x_321032 = x_321033;\n                        }\n                        if (thread_active_321040) {\n                            if (!inactive_321041) {\n                                int64_t defunc_1_op_res_321034 = add64(x_321032,\n                                                                       x_321033);\n                                \n                                x_321032 = defunc_1_op_res_321034;\n                            }\n                        }\n                    }\n                    if (sle32(wave_sizze_320992, skip_threads_321039)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n ",
            "                   }\n                    if (thread_active_321040) {\n                        // write result\n                        {\n                            ((volatile __local\n                              int64_t *) local_mem_320998)[squot64(byte_offsets_320994,\n                                                                   (int64_t) 8) +\n                                                           sext_i32_i64(local_tid_320990)] =\n                                x_321032;\n                            x_321033 = x_321032;\n                        }\n                    }\n                    if (sle32(wave_sizze_320992, skip_threads_321039)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    skip_threads_321039 *= 2;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        bool no_carry_in_321042 = squot32(local_tid_320990, 32) == 0 ||\n             !ltid_in_bounds_321035;\n        \n        // carry-in for every block except the first\n        {\n            // read operands\n            {\n                if (!no_carry_in_321042) {\n                    x_321029 = x_321028;\n                    x_321028 = ((__local\n                                 int64_t *) local_mem_320998)[squot64(byte_offsets_320994,\n                                                                      (int64_t) 8) +\n                                                              (sext_i32_i64(squot32(local_tid_320990,\n                                                                                    32)) -\n                                                               (int64_t) 1)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_321043 = slt32(smod32((local_tid_320990 + 1) *\n                                                    11 - 1 +\n                                                    segsizze_compact_321009 -\n                                         ",
            "           boundary_321008,\n                                                    segsizze_compact_321009),\n                                             (local_tid_320990 + 1) * 11 - 1 -\n                                             ((squot32(local_tid_320990, 32) *\n                                               32 - 1 + 1) * 11 - 1));\n                \n                if (!no_carry_in_321042) {\n                    if (inactive_321043) {\n                        x_321028 = x_321029;\n                    }\n                }\n                if (!no_carry_in_321042) {\n                    if (!inactive_321043) {\n                        int64_t defunc_1_op_res_321030 = add64(x_321028,\n                                                               x_321029);\n                        \n                        x_321028 = defunc_1_op_res_321030;\n                    }\n                }\n            }\n            // write final result\n            {\n                if (!no_carry_in_321042) {\n                    ((__local\n                      int64_t *) local_mem_320998)[squot64(byte_offsets_320994,\n                                                           (int64_t) 8) +\n                                                   sext_i32_i64(local_tid_320990)] =\n                        x_321028;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // restore correct values for first block\n        {\n            if (squot32(local_tid_320990, 32) == 0 && ltid_in_bounds_321035) {\n                ((__local\n                  int64_t *) local_mem_320998)[squot64(byte_offsets_320994,\n                                                       (int64_t) 8) +\n                                               sext_i32_i64(local_tid_320990)] =\n                    x_321029;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (local_tid_320990 == 0) {\n            acc_321031 = ((__local\n                           int64_t *)",
            " local_mem_320998)[squot64(byte_offsets_320994,\n                                                                (int64_t) 8) +\n                                                        (segscan_group_sizze_297749 -\n                                                         (int64_t) 1)];\n        } else {\n            acc_321031 = ((__local\n                           int64_t *) local_mem_320998)[squot64(byte_offsets_320994,\n                                                                (int64_t) 8) +\n                                                        (sext_i32_i64(local_tid_320990) -\n                                                         (int64_t) 1)];\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    int64_t prefix_321044 = (int64_t) 0;\n    bool block_new_sgm_321045 = sgm_idx_321007 == (int64_t) 0;\n    \n    // Perform lookback\n    {\n        if (block_new_sgm_321045 && local_tid_320990 == 0) {\n            ((volatile __global\n              int64_t *) incprefixes_mem_320987)[dynamic_id_321005] =\n                acc_321031;\n            mem_fence_global();\n            ((volatile __global\n              int8_t *) status_flags_mem_320983)[dynamic_id_321005] =\n                (int8_t) 2;\n            acc_321031 = (int64_t) 0;\n        }\n        if (!block_new_sgm_321045 && slt32(local_tid_320990,\n                                           wave_sizze_320992)) {\n            if (local_tid_320990 == 0) {\n                if (boundary_321008 == sext_i64_i32(segscan_group_sizze_297749 *\n                    (int64_t) 11)) {\n                    ((volatile __global\n                      int64_t *) aggregates_mem_320985)[dynamic_id_321005] =\n                        acc_321031;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_320983)[dynamic_id_321005] =\n                        (int8_t) 1;\n                } else {\n                    ((volatile __global\n                      int64_t *) incprefi",
            "xes_mem_320987)[dynamic_id_321005] =\n                        acc_321031;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_320983)[dynamic_id_321005] =\n                        (int8_t) 2;\n                }\n                \n                int8_t tmp_321046;\n                \n                tmp_321046 = ((volatile __global\n                               int8_t *) status_flags_mem_320983)[dynamic_id_321005 -\n                                                                  (int64_t) 1];\n                ((volatile __local int8_t *) local_mem_320998)[(int64_t) 0] =\n                    tmp_321046;\n            }\n            mem_fence_local();\n            \n            int8_t status_321047;\n            \n            status_321047 = ((__local int8_t *) local_mem_320998)[(int64_t) 0];\n            if (status_321047 == (int8_t) 2) {\n                if (local_tid_320990 == 0) {\n                    prefix_321044 = ((volatile __global\n                                      int64_t *) incprefixes_mem_320987)[dynamic_id_321005 -\n                                                                         (int64_t) 1];\n                }\n            } else {\n                int32_t readOffset_321048 = dynamic_id_321005 -\n                        sext_i32_i64(wave_sizze_320992);\n                \n                while (slt32(wave_sizze_320992 * -1, readOffset_321048)) {\n                    int32_t read_i_321049 = readOffset_321048 +\n                            local_tid_320990;\n                    int64_t aggr_321050 = (int64_t) 0;\n                    int8_t flag_321051 = (int8_t) 0;\n                    \n                    if (sle32(0, read_i_321049)) {\n                        if (sle64(blockOff_321006 -\n                                  (sext_i32_i64(read_i_321049 + 1) *\n                                   segscan_group_sizze_297749 * (int64_t) 11 -\n                                   (int64_t) 1), sgm_idx_321007)) ",
            "{\n                            flag_321051 = ((volatile __global\n                                            int8_t *) status_flags_mem_320983)[sext_i32_i64(read_i_321049)];\n                            if (flag_321051 == (int8_t) 2) {\n                                aggr_321050 = ((volatile __global\n                                                int64_t *) incprefixes_mem_320987)[sext_i32_i64(read_i_321049)];\n                            } else {\n                                if (flag_321051 == (int8_t) 1) {\n                                    aggr_321050 = ((volatile __global\n                                                    int64_t *) aggregates_mem_320985)[sext_i32_i64(read_i_321049)];\n                                }\n                            }\n                        } else {\n                            flag_321051 = (int8_t) 2;\n                        }\n                    }\n                    ((__local\n                      int64_t *) local_mem_320998)[squot64(warp_byte_offset_320996,\n                                                           (int64_t) 8) +\n                                                   sext_i32_i64(local_tid_320990)] =\n                        aggr_321050;\n                    ((__local\n                      int8_t *) local_mem_320998)[sext_i32_i64(local_tid_320990)] =\n                        flag_321051;\n                    flag_321051 = ((__local\n                                    int8_t *) local_mem_320998)[sext_i32_i64(wave_sizze_320992) -\n                                                                (int64_t) 1];\n                    if (slt8(flag_321051, (int8_t) 2)) {\n                        int8_t flg_x_321055;\n                        int8_t flg_y_321056;\n                        int64_t x_321052;\n                        int64_t x_321053;\n                        int32_t skip_threads_321057;\n                        \n                        // read input for in-block scan\n                        {\n                            ",
            "flg_y_321056 = ((volatile __local\n                                             int8_t *) local_mem_320998)[sext_i32_i64(local_tid_320990)];\n                            x_321053 = ((volatile __local\n                                         int64_t *) local_mem_320998)[squot64(warp_byte_offset_320996,\n                                                                              (int64_t) 8) +\n                                                                      sext_i32_i64(local_tid_320990)];\n                            if ((local_tid_320990 - squot32(local_tid_320990,\n                                                            32) * 32) == 0) {\n                                x_321052 = x_321053;\n                                flg_x_321055 = flg_y_321056;\n                            }\n                        }\n                        // in-block scan (hopefully no barriers needed)\n                        {\n                            skip_threads_321057 = 1;\n                            while (slt32(skip_threads_321057, 32)) {\n                                if (sle32(skip_threads_321057,\n                                          local_tid_320990 -\n                                          squot32(local_tid_320990, 32) * 32)) {\n                                    // read operands\n                                    {\n                                        flg_x_321055 = ((volatile __local\n                                                         int8_t *) local_mem_320998)[sext_i32_i64(local_tid_320990) -\n                                                                                     sext_i32_i64(skip_threads_321057)];\n                                        x_321052 = ((volatile __local\n                                                     int64_t *) local_mem_320998)[squot64(warp_byte_offset_320996,\n                                                                                          (int64_t) 8) +\n                                                          ",
            "                        (sext_i32_i64(local_tid_320990) -\n                                                                                   sext_i32_i64(skip_threads_321057))];\n                                    }\n                                    // perform operation\n                                    {\n                                        if (flg_y_321056 == (int8_t) 2 ||\n                                            flg_y_321056 == (int8_t) 0) {\n                                            flg_x_321055 = flg_y_321056;\n                                            x_321052 = x_321053;\n                                        } else {\n                                            int64_t defunc_1_op_res_321054 =\n                                                    add64(x_321052, x_321053);\n                                            \n                                            x_321052 = defunc_1_op_res_321054;\n                                        }\n                                    }\n                                    // write result\n                                    {\n                                        ((volatile __local\n                                          int8_t *) local_mem_320998)[sext_i32_i64(local_tid_320990)] =\n                                            flg_x_321055;\n                                        flg_y_321056 = flg_x_321055;\n                                        ((volatile __local\n                                          int64_t *) local_mem_320998)[squot64(warp_byte_offset_320996,\n                                                                               (int64_t) 8) +\n                                                                       sext_i32_i64(local_tid_320990)] =\n                                            x_321052;\n                                        x_321053 = x_321052;\n                                    }\n                                }\n                                skip_threads_321057 *= 2;\n       ",
            "                     }\n                        }\n                    }\n                    flag_321051 = ((__local\n                                    int8_t *) local_mem_320998)[sext_i32_i64(wave_sizze_320992) -\n                                                                (int64_t) 1];\n                    aggr_321050 = ((__local\n                                    int64_t *) local_mem_320998)[squot64(warp_byte_offset_320996,\n                                                                         (int64_t) 8) +\n                                                                 (sext_i32_i64(wave_sizze_320992) -\n                                                                  (int64_t) 1)];\n                    if (flag_321051 == (int8_t) 2) {\n                        readOffset_321048 = wave_sizze_320992 * -1;\n                    } else {\n                        if (flag_321051 == (int8_t) 1) {\n                            readOffset_321048 -= wave_sizze_320992;\n                        }\n                    }\n                    if (slt8((int8_t) 0, flag_321051)) {\n                        int64_t x_321058 = aggr_321050;\n                        int64_t x_321059 = prefix_321044;\n                        int64_t defunc_1_op_res_321060 = add64(x_321058,\n                                                               x_321059);\n                        \n                        prefix_321044 = defunc_1_op_res_321060;\n                    }\n                    mem_fence_local();\n                }\n            }\n            if (local_tid_320990 == 0) {\n                if (boundary_321008 == sext_i64_i32(segscan_group_sizze_297749 *\n                    (int64_t) 11)) {\n                    int64_t x_321061 = prefix_321044;\n                    int64_t x_321062 = acc_321031;\n                    int64_t defunc_1_op_res_321063 = add64(x_321061, x_321062);\n                    \n                    ((volatile __global\n                      int64_t *) incprefixes_mem_320987)[dynamic_id_32",
            "1005] =\n                        defunc_1_op_res_321063;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_320983)[dynamic_id_321005] =\n                        (int8_t) 2;\n                }\n                ((__local\n                  int64_t *) local_mem_320998)[squot64(warp_byte_offset_320996,\n                                                       (int64_t) 8)] =\n                    prefix_321044;\n                acc_321031 = (int64_t) 0;\n            }\n        }\n        if (!(dynamic_id_321005 == (int64_t) 0)) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            prefix_321044 = ((__local\n                              int64_t *) local_mem_320998)[squot64(warp_byte_offset_320996,\n                                                                   (int64_t) 8)];\n            barrier(CLK_LOCAL_MEM_FENCE);\n        }\n    }\n    // Distribute results\n    {\n        int64_t x_321064;\n        int64_t x_321065;\n        int64_t x_321067 = prefix_321044;\n        int64_t x_321068 = acc_321031;\n        \n        if (slt32(local_tid_320990 * 11, boundary_321008) &&\n            !block_new_sgm_321045) {\n            int64_t defunc_1_op_res_321069 = add64(x_321067, x_321068);\n            \n            x_321064 = defunc_1_op_res_321069;\n        } else {\n            x_321064 = acc_321031;\n        }\n        \n        int32_t stopping_point_321070 = segsizze_compact_321009 -\n                srem32(local_tid_320990 * 11 - 1 + segsizze_compact_321009 -\n                       boundary_321008, segsizze_compact_321009);\n        \n        for (int64_t i_321071 = 0; i_321071 < (int64_t) 11; i_321071++) {\n            if (slt32(sext_i64_i32(i_321071), stopping_point_321070 - 1)) {\n                x_321065 = private_mem_321010[i_321071];\n                \n                int64_t defunc_1_op_res_321066 = add64(x_321064, x_321065);\n                \n                private_mem_321010[i_321071] = defunc_1_op_res_321066;\n          ",
            "  }\n        }\n    }\n    // Transpose scan output and Write it to global memory in coalesced fashion\n    {\n        for (int64_t i_321072 = 0; i_321072 < (int64_t) 11; i_321072++) {\n            int64_t sharedIdx_321073 = sext_i32_i64(local_tid_320990 * 11) +\n                    i_321072;\n            int64_t tmp_321074;\n            \n            tmp_321074 = private_mem_321010[i_321072];\n            ((__local int64_t *) local_mem_320998)[sharedIdx_321073] =\n                tmp_321074;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_321075 = 0; i_321075 < (int64_t) 11; i_321075++) {\n            int64_t flat_idx_321076 = blockOff_321006 +\n                    segscan_group_sizze_297749 * i_321075 +\n                    sext_i32_i64(local_tid_320990);\n            int64_t slice_321077 = n_292675;\n            int64_t slice_321078 = partition_sizze_292766 * slice_321077;\n            int64_t gtid_297753 = squot64(flat_idx_321076, slice_321077);\n            int64_t remnant_321079 = flat_idx_321076 - gtid_297753 *\n                    slice_321077;\n            int64_t gtid_297754 = remnant_321079;\n            int64_t remnant_321080 = remnant_321079 - gtid_297754;\n            \n            if (slt64(flat_idx_321076, partition_sizze_292766 * n_292675)) {\n                int64_t tmp_321081;\n                \n                tmp_321081 = ((__local\n                               int64_t *) local_mem_320998)[flat_idx_321076 -\n                                                            blockOff_321006];\n                ((__global int64_t *) mem_318531)[gtid_297753 * n_292675 +\n                                                  gtid_297754] = tmp_321081;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // If this is the last block, reset the dynamicId\n    {\n        if (dynamic_id_321005 == sdiv_up64(partition_sizze_292766 * n_292675,\n                                           segscan_group_sizze_297749 *\n                                           ",
            "(int64_t) 11) - (int64_t) 1) {\n            ((__global int32_t *) mainziid_counter_mem_320981)[(int64_t) 0] = 0;\n        }\n    }\n    \n  error_0:\n    return;\n    #undef segscan_group_sizze_297749\n}\n__kernel void mainzisegscan_298311(__global int *global_failure,\n                                   uint local_mem_321221_backing_offset_0,\n                                   int64_t n_p_292677,\n                                   int64_t partition_sizze_292766,\n                                   int64_t defunc_0_f_res_292820, __global\n                                   unsigned char *mem_318551, __global\n                                   unsigned char *mem_318595, __global\n                                   unsigned char *mainziid_counter_mem_321204,\n                                   __global\n                                   unsigned char *status_flags_mem_321206,\n                                   __global\n                                   unsigned char *aggregates_mem_321208,\n                                   __global\n                                   unsigned char *incprefixes_mem_321210)\n{\n    #define segscan_group_sizze_298304 (mainzisegscan_group_sizze_298171)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *local_mem_321221_backing_0 =\n                           &shared_mem[local_mem_321221_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_321212;\n    int32_t local_tid_321213;\n    int64_t group_sizze_321216;\n    int32_t wave_sizze_321215;\n    int32_t group_tid_321214;\n    \n    global_tid_321212 = get_global_id(0);\n    local_tid_321213 = get_local_id(0);\n    group_sizze_321216 = get_local_size(0);\n    wave_sizze_321215 = LOCKSTEP_WIDTH;\n    group_tid_321214 = get_group_id(0);\n    \n    int32_t phys_tid_298311 = global_tid_321212;\n    int64_t byte_offsets_321217 = (int64_t) 0;\n    int64_t byte_offsets_321218 = segscan_group_sizze_298304 * (int",
            "64_t) 8;\n    int64_t warp_byte_offset_321219 = (int64_t) 32;\n    int64_t warp_byte_offset_321220 = (int64_t) 288;\n    \n    // Allocate reused shared memeory\n    { }\n    \n    __local unsigned char *local_mem_321221;\n    \n    local_mem_321221 = (__local unsigned char *) local_mem_321221_backing_0;\n    \n    int64_t trans_arr_len_321222 = (int64_t) 11 * segscan_group_sizze_298304;\n    int32_t dynamic_id_321228;\n    \n    if (local_tid_321213 == 0) {\n        dynamic_id_321228 = atomic_add_i32_global(&((volatile __global\n                                                     int *) mainziid_counter_mem_321204)[(int64_t) 0],\n                                                  (int) 1);\n        ((__local int32_t *) local_mem_321221)[(int64_t) 0] = dynamic_id_321228;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    dynamic_id_321228 = ((__local int32_t *) local_mem_321221)[(int64_t) 0];\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t blockOff_321229 = sext_i32_i64(dynamic_id_321228) * (int64_t) 11 *\n            segscan_group_sizze_298304;\n    int64_t sgm_idx_321230 = smod64(blockOff_321229, defunc_0_f_res_292820);\n    int32_t boundary_321231 = sext_i64_i32(smin64((int64_t) 11 *\n                                                  segscan_group_sizze_298304,\n                                                  defunc_0_f_res_292820 -\n                                                  sgm_idx_321230));\n    int32_t segsizze_compact_321232 = sext_i64_i32(smin64((int64_t) 11 *\n                                                          segscan_group_sizze_298304,\n                                                          defunc_0_f_res_292820));\n    int64_t private_mem_321233[(int64_t) 11];\n    \n    // Load and map\n    {\n        for (int64_t i_321235 = 0; i_321235 < (int64_t) 11; i_321235++) {\n            int64_t phys_tid_321236 = blockOff_321229 +\n                    sext_i32_i64(local_tid_321213) + i_321235 *\n                    segscan_group_sizze_298304;\n            int64_t slice_321237 = def",
            "unc_0_f_res_292820;\n            int64_t slice_321238 = n_p_292677 * slice_321237;\n            int64_t slice_321239 = partition_sizze_292766 * slice_321238;\n            int64_t gtid_298308 = squot64(phys_tid_321236, slice_321238);\n            int64_t remnant_321240 = phys_tid_321236 - gtid_298308 *\n                    slice_321238;\n            int64_t gtid_298309 = squot64(remnant_321240, slice_321237);\n            int64_t remnant_321241 = remnant_321240 - gtid_298309 *\n                    slice_321237;\n            int64_t gtid_298310 = remnant_321241;\n            int64_t remnant_321242 = remnant_321241 - gtid_298310;\n            \n            if (slt64(phys_tid_321236, partition_sizze_292766 * n_p_292677 *\n                      defunc_0_f_res_292820)) {\n                double x_298317;\n                \n                x_298317 = ((__global double *) mem_318551)[gtid_298308 *\n                                                            (defunc_0_f_res_292820 *\n                                                             n_p_292677) +\n                                                            gtid_298309 *\n                                                            defunc_0_f_res_292820 +\n                                                            gtid_298310];\n                \n                bool isnan_res_298318;\n                \n                isnan_res_298318 = futrts_isnan64(x_298317);\n                \n                bool defunc_0_p_res_298319 = !isnan_res_298318;\n                int64_t defunc_0_f_res_298320 =\n                        btoi_bool_i64(defunc_0_p_res_298319);\n                \n                private_mem_321233[i_321235] = defunc_0_f_res_298320;\n            } else {\n                private_mem_321233[i_321235] = (int64_t) 0;\n            }\n        }\n    }\n    // Transpose scan inputs\n    {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_321243 = 0; i_321243 < (int64_t) 11; i_321243++) {\n            int64_t sharedIdx_321244 = sext_i32_i64",
            "(local_tid_321213) +\n                    i_321243 * segscan_group_sizze_298304;\n            int64_t tmp_321245;\n            \n            tmp_321245 = private_mem_321233[i_321243];\n            ((__local int64_t *) local_mem_321221)[sharedIdx_321244] =\n                tmp_321245;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int32_t i_321246 = 0; i_321246 < 11; i_321246++) {\n            int32_t sharedIdx_321247 = local_tid_321213 * 11 + i_321246;\n            int64_t tmp_321248;\n            \n            tmp_321248 = ((__local\n                           int64_t *) local_mem_321221)[sext_i32_i64(sharedIdx_321247)];\n            private_mem_321233[sext_i32_i64(i_321246)] = tmp_321248;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // Per thread scan\n    {\n        int32_t gidx_321249 = local_tid_321213 * 11 + 1;\n        \n        for (int64_t i_321250 = 0; i_321250 < (int64_t) 10; i_321250++) {\n            bool new_sgm_321251 = smod32(gidx_321249 + sext_i64_i32(i_321250) -\n                                         boundary_321231,\n                                         segsizze_compact_321232) == 0;\n            \n            if (!new_sgm_321251) {\n                int64_t x_298312;\n                int64_t x_298313;\n                \n                x_298312 = private_mem_321233[i_321250];\n                x_298313 = private_mem_321233[i_321250 + (int64_t) 1];\n                \n                int64_t defunc_1_op_res_298314 = add64(x_298312, x_298313);\n                \n                private_mem_321233[i_321250 + (int64_t) 1] =\n                    defunc_1_op_res_298314;\n            }\n        }\n    }\n    // Publish results in shared memory\n    {\n        int64_t tmp_321252;\n        \n        tmp_321252 = private_mem_321233[(int64_t) 10];\n        ((__local int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                       (int64_t) 8) +\n                                               sext_i32_i64(local_tid_32121",
            "3)] =\n            tmp_321252;\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    int64_t acc_321256;\n    \n    // Scan results (with warp scan)\n    {\n        int64_t x_321253;\n        int64_t x_321254;\n        int64_t x_321257;\n        int64_t x_321258;\n        bool ltid_in_bounds_321260 = slt64(sext_i32_i64(local_tid_321213),\n                                           segscan_group_sizze_298304);\n        int32_t skip_threads_321261;\n        \n        // read input for in-block scan\n        {\n            if (ltid_in_bounds_321260) {\n                x_321254 = ((volatile __local\n                             int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                                  (int64_t) 8) +\n                                                          sext_i32_i64(local_tid_321213)];\n                if ((local_tid_321213 - squot32(local_tid_321213, 32) * 32) ==\n                    0) {\n                    x_321253 = x_321254;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_321261 = 1;\n            while (slt32(skip_threads_321261, 32)) {\n                bool thread_active_321262 = sle32(skip_threads_321261,\n                                                  local_tid_321213 -\n                                                  squot32(local_tid_321213,\n                                                          32) * 32) &&\n                     ltid_in_bounds_321260;\n                \n                if (thread_active_321262) {\n                    // read operands\n                    {\n                        x_321253 = ((volatile __local\n                                     int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                                          (int64_t) 8) +\n                                                                  (sext_i32_i64(local_tid_321213) -\n                        ",
            "                                           sext_i32_i64(skip_threads_321261))];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_321263 = slt32(smod32((local_tid_321213 + 1) *\n                                                        11 - 1 +\n                                                        segsizze_compact_321232 -\n                                                        boundary_321231,\n                                                        segsizze_compact_321232),\n                                                 (local_tid_321213 + 1) * 11 -\n                                                 1 - ((local_tid_321213 -\n                                                       skip_threads_321261 +\n                                                       1) * 11 - 1));\n                    \n                    if (thread_active_321262 && inactive_321263) {\n                        x_321253 = x_321254;\n                    }\n                    if (thread_active_321262) {\n                        if (!inactive_321263) {\n                            int64_t defunc_1_op_res_321255 = add64(x_321253,\n                                                                   x_321254);\n                            \n                            x_321253 = defunc_1_op_res_321255;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_321215, skip_threads_321261)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_321262) {\n                    // write result\n                    {\n                        ((volatile __local\n                          int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                               (int64_t) 8) +\n                                                       sext_i32_i64(local_tid_321213)] =\n                            x_321253;\n       ",
            "                 x_321254 = x_321253;\n                    }\n                }\n                if (sle32(wave_sizze_321215, skip_threads_321261)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_321261 *= 2;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // last thread of block 'i' writes its result to offset 'i'\n        {\n            if ((local_tid_321213 - squot32(local_tid_321213, 32) * 32) == 31 &&\n                ltid_in_bounds_321260) {\n                ((volatile __local\n                  int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                       (int64_t) 8) +\n                                               sext_i32_i64(squot32(local_tid_321213,\n                                                                    32))] =\n                    x_321253;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n        {\n            int32_t skip_threads_321264;\n            \n            // read input for in-block scan\n            {\n                if (squot32(local_tid_321213, 32) == 0 &&\n                    ltid_in_bounds_321260) {\n                    x_321258 = ((volatile __local\n                                 int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                                      (int64_t) 8) +\n                                                              sext_i32_i64(local_tid_321213)];\n                    if ((local_tid_321213 - squot32(local_tid_321213, 32) *\n                         32) == 0) {\n                        x_321257 = x_321258;\n                    }\n                }\n            }\n            // in-block scan (hopefully no barriers needed)\n            {\n                skip_threads_321264 = 1;\n                while (slt32(skip_threads_321264, 32)) {\n                    bool t",
            "hread_active_321265 = sle32(skip_threads_321264,\n                                                      local_tid_321213 -\n                                                      squot32(local_tid_321213,\n                                                              32) * 32) &&\n                         (squot32(local_tid_321213, 32) == 0 &&\n                          ltid_in_bounds_321260);\n                    \n                    if (thread_active_321265) {\n                        // read operands\n                        {\n                            x_321257 = ((volatile __local\n                                         int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                                              (int64_t) 8) +\n                                                                      (sext_i32_i64(local_tid_321213) -\n                                                                       sext_i32_i64(skip_threads_321264))];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_321266 = slt32(smod32((local_tid_321213 *\n                                                             32 + 32 - 1 + 1) *\n                                                            11 - 1 +\n                                                            segsizze_compact_321232 -\n                                                            boundary_321231,\n                                                            segsizze_compact_321232),\n                                                     (local_tid_321213 * 32 +\n                                                      32 - 1 + 1) * 11 - 1 -\n                                                     (((local_tid_321213 -\n                                                        skip_threads_321264) *\n                                                       32 + 32 - 1 + 1) * 11 -\n                                  ",
            "                    1));\n                        \n                        if (thread_active_321265 && inactive_321266) {\n                            x_321257 = x_321258;\n                        }\n                        if (thread_active_321265) {\n                            if (!inactive_321266) {\n                                int64_t defunc_1_op_res_321259 = add64(x_321257,\n                                                                       x_321258);\n                                \n                                x_321257 = defunc_1_op_res_321259;\n                            }\n                        }\n                    }\n                    if (sle32(wave_sizze_321215, skip_threads_321264)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    if (thread_active_321265) {\n                        // write result\n                        {\n                            ((volatile __local\n                              int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                                   (int64_t) 8) +\n                                                           sext_i32_i64(local_tid_321213)] =\n                                x_321257;\n                            x_321258 = x_321257;\n                        }\n                    }\n                    if (sle32(wave_sizze_321215, skip_threads_321264)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    skip_threads_321264 *= 2;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        bool no_carry_in_321267 = squot32(local_tid_321213, 32) == 0 ||\n             !ltid_in_bounds_321260;\n        \n        // carry-in for every block except the first\n        {\n            // read operands\n            {\n                if (!no_carry_in_321267) {\n                    x_321254 = x_321253;\n                    x_321253 = ((__local\n              ",
            "                   int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                                      (int64_t) 8) +\n                                                              (sext_i32_i64(squot32(local_tid_321213,\n                                                                                    32)) -\n                                                               (int64_t) 1)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_321268 = slt32(smod32((local_tid_321213 + 1) *\n                                                    11 - 1 +\n                                                    segsizze_compact_321232 -\n                                                    boundary_321231,\n                                                    segsizze_compact_321232),\n                                             (local_tid_321213 + 1) * 11 - 1 -\n                                             ((squot32(local_tid_321213, 32) *\n                                               32 - 1 + 1) * 11 - 1));\n                \n                if (!no_carry_in_321267) {\n                    if (inactive_321268) {\n                        x_321253 = x_321254;\n                    }\n                }\n                if (!no_carry_in_321267) {\n                    if (!inactive_321268) {\n                        int64_t defunc_1_op_res_321255 = add64(x_321253,\n                                                               x_321254);\n                        \n                        x_321253 = defunc_1_op_res_321255;\n                    }\n                }\n            }\n            // write final result\n            {\n                if (!no_carry_in_321267) {\n                    ((__local\n                      int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                           (int64_t) 8) +\n                                                   sext_i32_i",
            "64(local_tid_321213)] =\n                        x_321253;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // restore correct values for first block\n        {\n            if (squot32(local_tid_321213, 32) == 0 && ltid_in_bounds_321260) {\n                ((__local\n                  int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                       (int64_t) 8) +\n                                               sext_i32_i64(local_tid_321213)] =\n                    x_321254;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (local_tid_321213 == 0) {\n            acc_321256 = ((__local\n                           int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                                (int64_t) 8) +\n                                                        (segscan_group_sizze_298304 -\n                                                         (int64_t) 1)];\n        } else {\n            acc_321256 = ((__local\n                           int64_t *) local_mem_321221)[squot64(byte_offsets_321217,\n                                                                (int64_t) 8) +\n                                                        (sext_i32_i64(local_tid_321213) -\n                                                         (int64_t) 1)];\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    int64_t prefix_321269 = (int64_t) 0;\n    bool block_new_sgm_321270 = sgm_idx_321230 == (int64_t) 0;\n    \n    // Perform lookback\n    {\n        if (block_new_sgm_321270 && local_tid_321213 == 0) {\n            ((volatile __global\n              int64_t *) incprefixes_mem_321210)[dynamic_id_321228] =\n                acc_321256;\n            mem_fence_global();\n            ((volatile __global\n              int8_t *) status_flags_mem_321206)[dynamic_id_321228] =\n                (int8_t) 2;\n            acc_3",
            "21256 = (int64_t) 0;\n        }\n        if (!block_new_sgm_321270 && slt32(local_tid_321213,\n                                           wave_sizze_321215)) {\n            if (local_tid_321213 == 0) {\n                if (boundary_321231 == sext_i64_i32(segscan_group_sizze_298304 *\n                    (int64_t) 11)) {\n                    ((volatile __global\n                      int64_t *) aggregates_mem_321208)[dynamic_id_321228] =\n                        acc_321256;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_321206)[dynamic_id_321228] =\n                        (int8_t) 1;\n                } else {\n                    ((volatile __global\n                      int64_t *) incprefixes_mem_321210)[dynamic_id_321228] =\n                        acc_321256;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_321206)[dynamic_id_321228] =\n                        (int8_t) 2;\n                }\n                \n                int8_t tmp_321271;\n                \n                tmp_321271 = ((volatile __global\n                               int8_t *) status_flags_mem_321206)[dynamic_id_321228 -\n                                                                  (int64_t) 1];\n                ((volatile __local int8_t *) local_mem_321221)[(int64_t) 0] =\n                    tmp_321271;\n            }\n            mem_fence_local();\n            \n            int8_t status_321272;\n            \n            status_321272 = ((__local int8_t *) local_mem_321221)[(int64_t) 0];\n            if (status_321272 == (int8_t) 2) {\n                if (local_tid_321213 == 0) {\n                    prefix_321269 = ((volatile __global\n                                      int64_t *) incprefixes_mem_321210)[dynamic_id_321228 -\n                                                                         (int64_t) 1];\n                }\n            } else {\n",
            "                int32_t readOffset_321273 = dynamic_id_321228 -\n                        sext_i32_i64(wave_sizze_321215);\n                \n                while (slt32(wave_sizze_321215 * -1, readOffset_321273)) {\n                    int32_t read_i_321274 = readOffset_321273 +\n                            local_tid_321213;\n                    int64_t aggr_321275 = (int64_t) 0;\n                    int8_t flag_321276 = (int8_t) 0;\n                    \n                    if (sle32(0, read_i_321274)) {\n                        if (sle64(blockOff_321229 -\n                                  (sext_i32_i64(read_i_321274 + 1) *\n                                   segscan_group_sizze_298304 * (int64_t) 11 -\n                                   (int64_t) 1), sgm_idx_321230)) {\n                            flag_321276 = ((volatile __global\n                                            int8_t *) status_flags_mem_321206)[sext_i32_i64(read_i_321274)];\n                            if (flag_321276 == (int8_t) 2) {\n                                aggr_321275 = ((volatile __global\n                                                int64_t *) incprefixes_mem_321210)[sext_i32_i64(read_i_321274)];\n                            } else {\n                                if (flag_321276 == (int8_t) 1) {\n                                    aggr_321275 = ((volatile __global\n                                                    int64_t *) aggregates_mem_321208)[sext_i32_i64(read_i_321274)];\n                                }\n                            }\n                        } else {\n                            flag_321276 = (int8_t) 2;\n                        }\n                    }\n                    ((__local\n                      int64_t *) local_mem_321221)[squot64(warp_byte_offset_321219,\n                                                           (int64_t) 8) +\n                                                   sext_i32_i64(local_tid_321213)] =\n                        aggr_321275;\n                    (",
            "(__local\n                      int8_t *) local_mem_321221)[sext_i32_i64(local_tid_321213)] =\n                        flag_321276;\n                    flag_321276 = ((__local\n                                    int8_t *) local_mem_321221)[sext_i32_i64(wave_sizze_321215) -\n                                                                (int64_t) 1];\n                    if (slt8(flag_321276, (int8_t) 2)) {\n                        int8_t flg_x_321280;\n                        int8_t flg_y_321281;\n                        int64_t x_321277;\n                        int64_t x_321278;\n                        int32_t skip_threads_321282;\n                        \n                        // read input for in-block scan\n                        {\n                            flg_y_321281 = ((volatile __local\n                                             int8_t *) local_mem_321221)[sext_i32_i64(local_tid_321213)];\n                            x_321278 = ((volatile __local\n                                         int64_t *) local_mem_321221)[squot64(warp_byte_offset_321219,\n                                                                              (int64_t) 8) +\n                                                                      sext_i32_i64(local_tid_321213)];\n                            if ((local_tid_321213 - squot32(local_tid_321213,\n                                                            32) * 32) == 0) {\n                                x_321277 = x_321278;\n                                flg_x_321280 = flg_y_321281;\n                            }\n                        }\n                        // in-block scan (hopefully no barriers needed)\n                        {\n                            skip_threads_321282 = 1;\n                            while (slt32(skip_threads_321282, 32)) {\n                                if (sle32(skip_threads_321282,\n                                          local_tid_321213 -\n                                          squot32(local_tid_3212",
            "13, 32) * 32)) {\n                                    // read operands\n                                    {\n                                        flg_x_321280 = ((volatile __local\n                                                         int8_t *) local_mem_321221)[sext_i32_i64(local_tid_321213) -\n                                                                                     sext_i32_i64(skip_threads_321282)];\n                                        x_321277 = ((volatile __local\n                                                     int64_t *) local_mem_321221)[squot64(warp_byte_offset_321219,\n                                                                                          (int64_t) 8) +\n                                                                                  (sext_i32_i64(local_tid_321213) -\n                                                                                   sext_i32_i64(skip_threads_321282))];\n                                    }\n                                    // perform operation\n                                    {\n                                        if (flg_y_321281 == (int8_t) 2 ||\n                                            flg_y_321281 == (int8_t) 0) {\n                                            flg_x_321280 = flg_y_321281;\n                                            x_321277 = x_321278;\n                                        } else {\n                                            int64_t defunc_1_op_res_321279 =\n                                                    add64(x_321277, x_321278);\n                                            \n                                            x_321277 = defunc_1_op_res_321279;\n                                        }\n                                    }\n                                    // write result\n                                    {\n                                        ((volatile __local\n                                          int8_t *) local_mem_321221)[sext_i",
            "32_i64(local_tid_321213)] =\n                                            flg_x_321280;\n                                        flg_y_321281 = flg_x_321280;\n                                        ((volatile __local\n                                          int64_t *) local_mem_321221)[squot64(warp_byte_offset_321219,\n                                                                               (int64_t) 8) +\n                                                                       sext_i32_i64(local_tid_321213)] =\n                                            x_321277;\n                                        x_321278 = x_321277;\n                                    }\n                                }\n                                skip_threads_321282 *= 2;\n                            }\n                        }\n                    }\n                    flag_321276 = ((__local\n                                    int8_t *) local_mem_321221)[sext_i32_i64(wave_sizze_321215) -\n                                                                (int64_t) 1];\n                    aggr_321275 = ((__local\n                                    int64_t *) local_mem_321221)[squot64(warp_byte_offset_321219,\n                                                                         (int64_t) 8) +\n                                                                 (sext_i32_i64(wave_sizze_321215) -\n                                                                  (int64_t) 1)];\n                    if (flag_321276 == (int8_t) 2) {\n                        readOffset_321273 = wave_sizze_321215 * -1;\n                    } else {\n                        if (flag_321276 == (int8_t) 1) {\n                            readOffset_321273 -= wave_sizze_321215;\n                        }\n                    }\n                    if (slt8((int8_t) 0, flag_321276)) {\n                        int64_t x_321283 = aggr_321275;\n                        int64_t x_321284 = prefix_321269;\n                        int64_t def",
            "unc_1_op_res_321285 = add64(x_321283,\n                                                               x_321284);\n                        \n                        prefix_321269 = defunc_1_op_res_321285;\n                    }\n                    mem_fence_local();\n                }\n            }\n            if (local_tid_321213 == 0) {\n                if (boundary_321231 == sext_i64_i32(segscan_group_sizze_298304 *\n                    (int64_t) 11)) {\n                    int64_t x_321286 = prefix_321269;\n                    int64_t x_321287 = acc_321256;\n                    int64_t defunc_1_op_res_321288 = add64(x_321286, x_321287);\n                    \n                    ((volatile __global\n                      int64_t *) incprefixes_mem_321210)[dynamic_id_321228] =\n                        defunc_1_op_res_321288;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_321206)[dynamic_id_321228] =\n                        (int8_t) 2;\n                }\n                ((__local\n                  int64_t *) local_mem_321221)[squot64(warp_byte_offset_321219,\n                                                       (int64_t) 8)] =\n                    prefix_321269;\n                acc_321256 = (int64_t) 0;\n            }\n        }\n        if (!(dynamic_id_321228 == (int64_t) 0)) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            prefix_321269 = ((__local\n                              int64_t *) local_mem_321221)[squot64(warp_byte_offset_321219,\n                                                                   (int64_t) 8)];\n            barrier(CLK_LOCAL_MEM_FENCE);\n        }\n    }\n    // Distribute results\n    {\n        int64_t x_321289;\n        int64_t x_321290;\n        int64_t x_321292 = prefix_321269;\n        int64_t x_321293 = acc_321256;\n        \n        if (slt32(local_tid_321213 * 11, boundary_321231) &&\n            !block_new_sgm_321270) {\n            int64_t defunc_1_op_res_321294 = add64",
            "(x_321292, x_321293);\n            \n            x_321289 = defunc_1_op_res_321294;\n        } else {\n            x_321289 = acc_321256;\n        }\n        \n        int32_t stopping_point_321295 = segsizze_compact_321232 -\n                srem32(local_tid_321213 * 11 - 1 + segsizze_compact_321232 -\n                       boundary_321231, segsizze_compact_321232);\n        \n        for (int64_t i_321296 = 0; i_321296 < (int64_t) 11; i_321296++) {\n            if (slt32(sext_i64_i32(i_321296), stopping_point_321295 - 1)) {\n                x_321290 = private_mem_321233[i_321296];\n                \n                int64_t defunc_1_op_res_321291 = add64(x_321289, x_321290);\n                \n                private_mem_321233[i_321296] = defunc_1_op_res_321291;\n            }\n        }\n    }\n    // Transpose scan output and Write it to global memory in coalesced fashion\n    {\n        for (int64_t i_321297 = 0; i_321297 < (int64_t) 11; i_321297++) {\n            int64_t sharedIdx_321298 = sext_i32_i64(local_tid_321213 * 11) +\n                    i_321297;\n            int64_t tmp_321299;\n            \n            tmp_321299 = private_mem_321233[i_321297];\n            ((__local int64_t *) local_mem_321221)[sharedIdx_321298] =\n                tmp_321299;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_321300 = 0; i_321300 < (int64_t) 11; i_321300++) {\n            int64_t flat_idx_321301 = blockOff_321229 +\n                    segscan_group_sizze_298304 * i_321300 +\n                    sext_i32_i64(local_tid_321213);\n            int64_t slice_321302 = defunc_0_f_res_292820;\n            int64_t slice_321303 = n_p_292677 * slice_321302;\n            int64_t slice_321304 = partition_sizze_292766 * slice_321303;\n            int64_t gtid_298308 = squot64(flat_idx_321301, slice_321303);\n            int64_t remnant_321305 = flat_idx_321301 - gtid_298308 *\n                    slice_321303;\n            int64_t gtid_298309 = squot64(remnant_321305, slice_321302);\n           ",
            " int64_t remnant_321306 = remnant_321305 - gtid_298309 *\n                    slice_321302;\n            int64_t gtid_298310 = remnant_321306;\n            int64_t remnant_321307 = remnant_321306 - gtid_298310;\n            \n            if (slt64(flat_idx_321301, partition_sizze_292766 * n_p_292677 *\n                      defunc_0_f_res_292820)) {\n                int64_t tmp_321308;\n                \n                tmp_321308 = ((__local\n                               int64_t *) local_mem_321221)[flat_idx_321301 -\n                                                            blockOff_321229];\n                ((__global int64_t *) mem_318595)[gtid_298308 *\n                                                  (defunc_0_f_res_292820 *\n                                                   n_p_292677) + gtid_298309 *\n                                                  defunc_0_f_res_292820 +\n                                                  gtid_298310] = tmp_321308;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // If this is the last block, reset the dynamicId\n    {\n        if (dynamic_id_321228 == sdiv_up64(partition_sizze_292766 * n_p_292677 *\n                                           defunc_0_f_res_292820,\n                                           segscan_group_sizze_298304 *\n                                           (int64_t) 11) - (int64_t) 1) {\n            ((__global int32_t *) mainziid_counter_mem_321204)[(int64_t) 0] = 0;\n        }\n    }\n    \n  error_0:\n    return;\n    #undef segscan_group_sizze_298304\n}\n__kernel void mainzisegscan_308911(__global int *global_failure,\n                                   int failure_is_an_option, __global\n                                   int64_t *global_failure_args,\n                                   uint local_mem_322902_backing_offset_0,\n                                   int64_t n_p_292677, double i64_res_292694,\n                                   int64_t partition_sizze_292766,\n                               ",
            "    int64_t C_len_292823,\n                                   int64_t lifted_single_ma_l_arg_293311,\n                                   __global unsigned char *mem_319504, __global\n                                   unsigned char *ext_mem_319516, __global\n                                   unsigned char *mem_319521, __global\n                                   unsigned char *mainziid_counter_mem_322885,\n                                   __global\n                                   unsigned char *status_flags_mem_322887,\n                                   __global\n                                   unsigned char *aggregates_mem_322889,\n                                   __global\n                                   unsigned char *incprefixes_mem_322891)\n{\n    #define segscan_group_sizze_308905 (mainzisegscan_group_sizze_308869)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *local_mem_322902_backing_0 =\n                           &shared_mem[local_mem_322902_backing_offset_0];\n    volatile __local bool local_failure;\n    \n    if (failure_is_an_option) {\n        int failed = *global_failure >= 0;\n        \n        if (failed)\n            return;\n    }\n    local_failure = false;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t global_tid_322893;\n    int32_t local_tid_322894;\n    int64_t group_sizze_322897;\n    int32_t wave_sizze_322896;\n    int32_t group_tid_322895;\n    \n    global_tid_322893 = get_global_id(0);\n    local_tid_322894 = get_local_id(0);\n    group_sizze_322897 = get_local_size(0);\n    wave_sizze_322896 = LOCKSTEP_WIDTH;\n    group_tid_322895 = get_group_id(0);\n    \n    int32_t phys_tid_308911 = global_tid_322893;\n    int64_t byte_offsets_322898 = (int64_t) 0;\n    int64_t byte_offsets_322899 = segscan_group_sizze_308905 * (int64_t) 8;\n    int64_t warp_byte_offset_322900 = (int64_t) 32;\n    int64_t warp_byte_offset_322901 = (int64_t) 288;\n    \n    // Allocate reused shared memeory\n    { ",
            "}\n    \n    __local unsigned char *local_mem_322902;\n    \n    local_mem_322902 = (__local unsigned char *) local_mem_322902_backing_0;\n    \n    int64_t trans_arr_len_322903 = (int64_t) 11 * segscan_group_sizze_308905;\n    int32_t dynamic_id_322909;\n    \n    if (local_tid_322894 == 0) {\n        dynamic_id_322909 = atomic_add_i32_global(&((volatile __global\n                                                     int *) mainziid_counter_mem_322885)[(int64_t) 0],\n                                                  (int) 1);\n        ((__local int32_t *) local_mem_322902)[(int64_t) 0] = dynamic_id_322909;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    dynamic_id_322909 = ((__local int32_t *) local_mem_322902)[(int64_t) 0];\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t blockOff_322910 = sext_i32_i64(dynamic_id_322909) * (int64_t) 11 *\n            segscan_group_sizze_308905;\n    int64_t sgm_idx_322911 = smod64(blockOff_322910,\n                                    lifted_single_ma_l_arg_293311);\n    int32_t boundary_322912 = sext_i64_i32(smin64((int64_t) 11 *\n                                                  segscan_group_sizze_308905,\n                                                  lifted_single_ma_l_arg_293311 -\n                                                  sgm_idx_322911));\n    int32_t segsizze_compact_322913 = sext_i64_i32(smin64((int64_t) 11 *\n                                                          segscan_group_sizze_308905,\n                                                          lifted_single_ma_l_arg_293311));\n    double private_mem_322914[(int64_t) 11];\n    \n    // Load and map\n    {\n        for (int64_t i_322916 = 0; i_322916 < (int64_t) 11; i_322916++) {\n            int64_t phys_tid_322917 = blockOff_322910 +\n                    sext_i32_i64(local_tid_322894) + i_322916 *\n                    segscan_group_sizze_308905;\n            int64_t slice_322918 = lifted_single_ma_l_arg_293311;\n            int64_t slice_322919 = partition_sizze_292766 * slice_322918;\n  ",
            "          int64_t gtid_308909 = squot64(phys_tid_322917, slice_322918);\n            int64_t remnant_322920 = phys_tid_322917 - gtid_308909 *\n                    slice_322918;\n            int64_t gtid_308910 = remnant_322920;\n            int64_t remnant_322921 = remnant_322920 - gtid_308910;\n            \n            if (slt64(phys_tid_322917, partition_sizze_292766 *\n                      lifted_single_ma_l_arg_293311)) {\n                bool cond_308918 = gtid_308910 == (int64_t) 0;\n                double defunc_0_f_res_308919;\n                \n                if (cond_308918) {\n                    double x_308916;\n                    \n                    x_308916 = ((__global\n                                 double *) ext_mem_319516)[gtid_308909];\n                    \n                    double defunc_0_f_res_t_res_308920 = x_308916 /\n                           i64_res_292694;\n                    \n                    defunc_0_f_res_308919 = defunc_0_f_res_t_res_308920;\n                } else {\n                    int64_t x_308921 = add64(n_p_292677, gtid_308910);\n                    int64_t i_308922 = sub64(x_308921, (int64_t) 1);\n                    bool x_308923 = sle64((int64_t) 0, i_308922);\n                    bool y_308924 = slt64(i_308922, C_len_292823);\n                    bool bounds_check_308925 = x_308923 && y_308924;\n                    bool index_certs_308926;\n                    \n                    if (!bounds_check_308925) {\n                        {\n                            if (atomic_cmpxchg_i32_global(global_failure, -1,\n                                                          44) == -1) {\n                                global_failure_args[0] = (int64_t) i_308922;\n                                global_failure_args[1] = (int64_t) C_len_292823;\n                                ;\n                            }\n                            local_failure = true;\n                            goto error_0;\n                        }\n                   ",
            " }\n                    \n                    double x_308927;\n                    \n                    x_308927 = ((__global double *) mem_319504)[gtid_308909 *\n                                                                C_len_292823 +\n                                                                i_308922];\n                    \n                    int64_t i_308928 = sub64(gtid_308910, (int64_t) 1);\n                    bool x_308929 = sle64((int64_t) 0, i_308928);\n                    bool y_308930 = slt64(i_308928, C_len_292823);\n                    bool bounds_check_308931 = x_308929 && y_308930;\n                    bool index_certs_308932;\n                    \n                    if (!bounds_check_308931) {\n                        {\n                            if (atomic_cmpxchg_i32_global(global_failure, -1,\n                                                          45) == -1) {\n                                global_failure_args[0] = (int64_t) i_308928;\n                                global_failure_args[1] = (int64_t) C_len_292823;\n                                ;\n                            }\n                            local_failure = true;\n                            goto error_0;\n                        }\n                    }\n                    \n                    double y_308933;\n                    \n                    y_308933 = ((__global double *) mem_319504)[gtid_308909 *\n                                                                C_len_292823 +\n                                                                i_308928];\n                    \n                    double x_308934 = x_308927 - y_308933;\n                    double defunc_0_f_res_f_res_308935 = x_308934 /\n                           i64_res_292694;\n                    \n                    defunc_0_f_res_308919 = defunc_0_f_res_f_res_308935;\n                }\n                private_mem_322914[i_322916] = defunc_0_f_res_308919;\n            } else {\n                private_mem_322914[",
            "i_322916] = 0.0;\n            }\n        }\n    }\n    // Transpose scan inputs\n    {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_322922 = 0; i_322922 < (int64_t) 11; i_322922++) {\n            int64_t sharedIdx_322923 = sext_i32_i64(local_tid_322894) +\n                    i_322922 * segscan_group_sizze_308905;\n            double tmp_322924;\n            \n            tmp_322924 = private_mem_322914[i_322922];\n            ((__local double *) local_mem_322902)[sharedIdx_322923] =\n                tmp_322924;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int32_t i_322925 = 0; i_322925 < 11; i_322925++) {\n            int32_t sharedIdx_322926 = local_tid_322894 * 11 + i_322925;\n            double tmp_322927;\n            \n            tmp_322927 = ((__local\n                           double *) local_mem_322902)[sext_i32_i64(sharedIdx_322926)];\n            private_mem_322914[sext_i32_i64(i_322925)] = tmp_322927;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // Per thread scan\n    {\n        int32_t gidx_322928 = local_tid_322894 * 11 + 1;\n        \n        for (int64_t i_322929 = 0; i_322929 < (int64_t) 10; i_322929++) {\n            bool new_sgm_322930 = smod32(gidx_322928 + sext_i64_i32(i_322929) -\n                                         boundary_322912,\n                                         segsizze_compact_322913) == 0;\n            \n            if (!new_sgm_322930) {\n                double x_308912;\n                double x_308913;\n                \n                x_308912 = private_mem_322914[i_322929];\n                x_308913 = private_mem_322914[i_322929 + (int64_t) 1];\n                \n                double defunc_1_op_res_308914 = x_308912 + x_308913;\n                \n                private_mem_322914[i_322929 + (int64_t) 1] =\n                    defunc_1_op_res_308914;\n            }\n        }\n    }\n    // Publish results in shared memory\n    {\n        double tmp_322931;\n        \n        tmp_322931 = private_mem_322914[(int6",
            "4_t) 10];\n        ((__local double *) local_mem_322902)[squot64(byte_offsets_322898,\n                                                      (int64_t) 8) +\n                                              sext_i32_i64(local_tid_322894)] =\n            tmp_322931;\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    double acc_322935;\n    \n    // Scan results (with warp scan)\n    {\n        double x_322932;\n        double x_322933;\n        double x_322936;\n        double x_322937;\n        bool ltid_in_bounds_322939 = slt64(sext_i32_i64(local_tid_322894),\n                                           segscan_group_sizze_308905);\n        int32_t skip_threads_322940;\n        \n        // read input for in-block scan\n        {\n            if (ltid_in_bounds_322939) {\n                x_322933 = ((volatile __local\n                             double *) local_mem_322902)[squot64(byte_offsets_322898,\n                                                                 (int64_t) 8) +\n                                                         sext_i32_i64(local_tid_322894)];\n                if ((local_tid_322894 - squot32(local_tid_322894, 32) * 32) ==\n                    0) {\n                    x_322932 = x_322933;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_322940 = 1;\n            while (slt32(skip_threads_322940, 32)) {\n                bool thread_active_322941 = sle32(skip_threads_322940,\n                                                  local_tid_322894 -\n                                                  squot32(local_tid_322894,\n                                                          32) * 32) &&\n                     ltid_in_bounds_322939;\n                \n                if (thread_active_322941) {\n                    // read operands\n                    {\n                        x_322932 = ((volatile __local\n                                     double *) local_mem_322902)[squot64(byte_offsets_32",
            "2898,\n                                                                         (int64_t) 8) +\n                                                                 (sext_i32_i64(local_tid_322894) -\n                                                                  sext_i32_i64(skip_threads_322940))];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_322942 = slt32(smod32((local_tid_322894 + 1) *\n                                                        11 - 1 +\n                                                        segsizze_compact_322913 -\n                                                        boundary_322912,\n                                                        segsizze_compact_322913),\n                                                 (local_tid_322894 + 1) * 11 -\n                                                 1 - ((local_tid_322894 -\n                                                       skip_threads_322940 +\n                                                       1) * 11 - 1));\n                    \n                    if (thread_active_322941 && inactive_322942) {\n                        x_322932 = x_322933;\n                    }\n                    if (thread_active_322941) {\n                        if (!inactive_322942) {\n                            double defunc_1_op_res_322934 = x_322932 + x_322933;\n                            \n                            x_322932 = defunc_1_op_res_322934;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_322896, skip_threads_322940)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_322941) {\n                    // write result\n                    {\n                        ((volatile __local\n                          double *) local_mem_322902)[squot64(byte_offsets_322898,\n                                                              (int64_t)",
            " 8) +\n                                                      sext_i32_i64(local_tid_322894)] =\n                            x_322932;\n                        x_322933 = x_322932;\n                    }\n                }\n                if (sle32(wave_sizze_322896, skip_threads_322940)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_322940 *= 2;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // last thread of block 'i' writes its result to offset 'i'\n        {\n            if ((local_tid_322894 - squot32(local_tid_322894, 32) * 32) == 31 &&\n                ltid_in_bounds_322939) {\n                ((volatile __local\n                  double *) local_mem_322902)[squot64(byte_offsets_322898,\n                                                      (int64_t) 8) +\n                                              sext_i32_i64(squot32(local_tid_322894,\n                                                                   32))] =\n                    x_322932;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n        {\n            int32_t skip_threads_322943;\n            \n            // read input for in-block scan\n            {\n                if (squot32(local_tid_322894, 32) == 0 &&\n                    ltid_in_bounds_322939) {\n                    x_322937 = ((volatile __local\n                                 double *) local_mem_322902)[squot64(byte_offsets_322898,\n                                                                     (int64_t) 8) +\n                                                             sext_i32_i64(local_tid_322894)];\n                    if ((local_tid_322894 - squot32(local_tid_322894, 32) *\n                         32) == 0) {\n                        x_322936 = x_322937;\n                    }\n                }\n            }\n            // in-block scan (hopefully no barriers needed)\n      ",
            "      {\n                skip_threads_322943 = 1;\n                while (slt32(skip_threads_322943, 32)) {\n                    bool thread_active_322944 = sle32(skip_threads_322943,\n                                                      local_tid_322894 -\n                                                      squot32(local_tid_322894,\n                                                              32) * 32) &&\n                         (squot32(local_tid_322894, 32) == 0 &&\n                          ltid_in_bounds_322939);\n                    \n                    if (thread_active_322944) {\n                        // read operands\n                        {\n                            x_322936 = ((volatile __local\n                                         double *) local_mem_322902)[squot64(byte_offsets_322898,\n                                                                             (int64_t) 8) +\n                                                                     (sext_i32_i64(local_tid_322894) -\n                                                                      sext_i32_i64(skip_threads_322943))];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_322945 = slt32(smod32((local_tid_322894 *\n                                                             32 + 32 - 1 + 1) *\n                                                            11 - 1 +\n                                                            segsizze_compact_322913 -\n                                                            boundary_322912,\n                                                            segsizze_compact_322913),\n                                                     (local_tid_322894 * 32 +\n                                                      32 - 1 + 1) * 11 - 1 -\n                                                     (((local_tid_322894 -\n                                                        skip_thr",
            "eads_322943) *\n                                                       32 + 32 - 1 + 1) * 11 -\n                                                      1));\n                        \n                        if (thread_active_322944 && inactive_322945) {\n                            x_322936 = x_322937;\n                        }\n                        if (thread_active_322944) {\n                            if (!inactive_322945) {\n                                double defunc_1_op_res_322938 = x_322936 +\n                                       x_322937;\n                                \n                                x_322936 = defunc_1_op_res_322938;\n                            }\n                        }\n                    }\n                    if (sle32(wave_sizze_322896, skip_threads_322943)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    if (thread_active_322944) {\n                        // write result\n                        {\n                            ((volatile __local\n                              double *) local_mem_322902)[squot64(byte_offsets_322898,\n                                                                  (int64_t) 8) +\n                                                          sext_i32_i64(local_tid_322894)] =\n                                x_322936;\n                            x_322937 = x_322936;\n                        }\n                    }\n                    if (sle32(wave_sizze_322896, skip_threads_322943)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    skip_threads_322943 *= 2;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        bool no_carry_in_322946 = squot32(local_tid_322894, 32) == 0 ||\n             !ltid_in_bounds_322939;\n        \n        // carry-in for every block except the first\n        {\n            // read operands\n            {\n                if (!no_carry_in_322946) {\n          ",
            "          x_322933 = x_322932;\n                    x_322932 = ((__local\n                                 double *) local_mem_322902)[squot64(byte_offsets_322898,\n                                                                     (int64_t) 8) +\n                                                             (sext_i32_i64(squot32(local_tid_322894,\n                                                                                   32)) -\n                                                              (int64_t) 1)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_322947 = slt32(smod32((local_tid_322894 + 1) *\n                                                    11 - 1 +\n                                                    segsizze_compact_322913 -\n                                                    boundary_322912,\n                                                    segsizze_compact_322913),\n                                             (local_tid_322894 + 1) * 11 - 1 -\n                                             ((squot32(local_tid_322894, 32) *\n                                               32 - 1 + 1) * 11 - 1));\n                \n                if (!no_carry_in_322946) {\n                    if (inactive_322947) {\n                        x_322932 = x_322933;\n                    }\n                }\n                if (!no_carry_in_322946) {\n                    if (!inactive_322947) {\n                        double defunc_1_op_res_322934 = x_322932 + x_322933;\n                        \n                        x_322932 = defunc_1_op_res_322934;\n                    }\n                }\n            }\n            // write final result\n            {\n                if (!no_carry_in_322946) {\n                    ((__local\n                      double *) local_mem_322902)[squot64(byte_offsets_322898,\n                                                          (int64_t) 8) +\n                                                  se",
            "xt_i32_i64(local_tid_322894)] =\n                        x_322932;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // restore correct values for first block\n        {\n            if (squot32(local_tid_322894, 32) == 0 && ltid_in_bounds_322939) {\n                ((__local\n                  double *) local_mem_322902)[squot64(byte_offsets_322898,\n                                                      (int64_t) 8) +\n                                              sext_i32_i64(local_tid_322894)] =\n                    x_322933;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (local_tid_322894 == 0) {\n            acc_322935 = ((__local\n                           double *) local_mem_322902)[squot64(byte_offsets_322898,\n                                                               (int64_t) 8) +\n                                                       (segscan_group_sizze_308905 -\n                                                        (int64_t) 1)];\n        } else {\n            acc_322935 = ((__local\n                           double *) local_mem_322902)[squot64(byte_offsets_322898,\n                                                               (int64_t) 8) +\n                                                       (sext_i32_i64(local_tid_322894) -\n                                                        (int64_t) 1)];\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    double prefix_322948 = 0.0;\n    bool block_new_sgm_322949 = sgm_idx_322911 == (int64_t) 0;\n    \n    // Perform lookback\n    {\n        if (block_new_sgm_322949 && local_tid_322894 == 0) {\n            ((volatile __global\n              double *) incprefixes_mem_322891)[dynamic_id_322909] = acc_322935;\n            mem_fence_global();\n            ((volatile __global\n              int8_t *) status_flags_mem_322887)[dynamic_id_322909] =\n                (int8_t) 2;\n            acc_322935 = 0.0;\n        }\n      ",
            "  if (!block_new_sgm_322949 && slt32(local_tid_322894,\n                                           wave_sizze_322896)) {\n            if (local_tid_322894 == 0) {\n                if (boundary_322912 == sext_i64_i32(segscan_group_sizze_308905 *\n                    (int64_t) 11)) {\n                    ((volatile __global\n                      double *) aggregates_mem_322889)[dynamic_id_322909] =\n                        acc_322935;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_322887)[dynamic_id_322909] =\n                        (int8_t) 1;\n                } else {\n                    ((volatile __global\n                      double *) incprefixes_mem_322891)[dynamic_id_322909] =\n                        acc_322935;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_322887)[dynamic_id_322909] =\n                        (int8_t) 2;\n                }\n                \n                int8_t tmp_322950;\n                \n                tmp_322950 = ((volatile __global\n                               int8_t *) status_flags_mem_322887)[dynamic_id_322909 -\n                                                                  (int64_t) 1];\n                ((volatile __local int8_t *) local_mem_322902)[(int64_t) 0] =\n                    tmp_322950;\n            }\n            mem_fence_local();\n            \n            int8_t status_322951;\n            \n            status_322951 = ((__local int8_t *) local_mem_322902)[(int64_t) 0];\n            if (status_322951 == (int8_t) 2) {\n                if (local_tid_322894 == 0) {\n                    prefix_322948 = ((volatile __global\n                                      double *) incprefixes_mem_322891)[dynamic_id_322909 -\n                                                                        (int64_t) 1];\n                }\n            } else {\n                int32_t readOffset_322952",
            " = dynamic_id_322909 -\n                        sext_i32_i64(wave_sizze_322896);\n                \n                while (slt32(wave_sizze_322896 * -1, readOffset_322952)) {\n                    int32_t read_i_322953 = readOffset_322952 +\n                            local_tid_322894;\n                    double aggr_322954 = 0.0;\n                    int8_t flag_322955 = (int8_t) 0;\n                    \n                    if (sle32(0, read_i_322953)) {\n                        if (sle64(blockOff_322910 -\n                                  (sext_i32_i64(read_i_322953 + 1) *\n                                   segscan_group_sizze_308905 * (int64_t) 11 -\n                                   (int64_t) 1), sgm_idx_322911)) {\n                            flag_322955 = ((volatile __global\n                                            int8_t *) status_flags_mem_322887)[sext_i32_i64(read_i_322953)];\n                            if (flag_322955 == (int8_t) 2) {\n                                aggr_322954 = ((volatile __global\n                                                double *) incprefixes_mem_322891)[sext_i32_i64(read_i_322953)];\n                            } else {\n                                if (flag_322955 == (int8_t) 1) {\n                                    aggr_322954 = ((volatile __global\n                                                    double *) aggregates_mem_322889)[sext_i32_i64(read_i_322953)];\n                                }\n                            }\n                        } else {\n                            flag_322955 = (int8_t) 2;\n                        }\n                    }\n                    ((__local\n                      double *) local_mem_322902)[squot64(warp_byte_offset_322900,\n                                                          (int64_t) 8) +\n                                                  sext_i32_i64(local_tid_322894)] =\n                        aggr_322954;\n                    ((__local\n                      int8_t *) local_mem_3229",
            "02)[sext_i32_i64(local_tid_322894)] =\n                        flag_322955;\n                    flag_322955 = ((__local\n                                    int8_t *) local_mem_322902)[sext_i32_i64(wave_sizze_322896) -\n                                                                (int64_t) 1];\n                    if (slt8(flag_322955, (int8_t) 2)) {\n                        int8_t flg_x_322959;\n                        int8_t flg_y_322960;\n                        double x_322956;\n                        double x_322957;\n                        int32_t skip_threads_322961;\n                        \n                        // read input for in-block scan\n                        {\n                            flg_y_322960 = ((volatile __local\n                                             int8_t *) local_mem_322902)[sext_i32_i64(local_tid_322894)];\n                            x_322957 = ((volatile __local\n                                         double *) local_mem_322902)[squot64(warp_byte_offset_322900,\n                                                                             (int64_t) 8) +\n                                                                     sext_i32_i64(local_tid_322894)];\n                            if ((local_tid_322894 - squot32(local_tid_322894,\n                                                            32) * 32) == 0) {\n                                x_322956 = x_322957;\n                                flg_x_322959 = flg_y_322960;\n                            }\n                        }\n                        // in-block scan (hopefully no barriers needed)\n                        {\n                            skip_threads_322961 = 1;\n                            while (slt32(skip_threads_322961, 32)) {\n                                if (sle32(skip_threads_322961,\n                                          local_tid_322894 -\n                                          squot32(local_tid_322894, 32) * 32)) {\n                                    // read",
            " operands\n                                    {\n                                        flg_x_322959 = ((volatile __local\n                                                         int8_t *) local_mem_322902)[sext_i32_i64(local_tid_322894) -\n                                                                                     sext_i32_i64(skip_threads_322961)];\n                                        x_322956 = ((volatile __local\n                                                     double *) local_mem_322902)[squot64(warp_byte_offset_322900,\n                                                                                         (int64_t) 8) +\n                                                                                 (sext_i32_i64(local_tid_322894) -\n                                                                                  sext_i32_i64(skip_threads_322961))];\n                                    }\n                                    // perform operation\n                                    {\n                                        if (flg_y_322960 == (int8_t) 2 ||\n                                            flg_y_322960 == (int8_t) 0) {\n                                            flg_x_322959 = flg_y_322960;\n                                            x_322956 = x_322957;\n                                        } else {\n                                            double defunc_1_op_res_322958 =\n                                                   x_322956 + x_322957;\n                                            \n                                            x_322956 = defunc_1_op_res_322958;\n                                        }\n                                    }\n                                    // write result\n                                    {\n                                        ((volatile __local\n                                          int8_t *) local_mem_322902)[sext_i32_i64(local_tid_322894)] =\n                                            ",
            "flg_x_322959;\n                                        flg_y_322960 = flg_x_322959;\n                                        ((volatile __local\n                                          double *) local_mem_322902)[squot64(warp_byte_offset_322900,\n                                                                              (int64_t) 8) +\n                                                                      sext_i32_i64(local_tid_322894)] =\n                                            x_322956;\n                                        x_322957 = x_322956;\n                                    }\n                                }\n                                skip_threads_322961 *= 2;\n                            }\n                        }\n                    }\n                    flag_322955 = ((__local\n                                    int8_t *) local_mem_322902)[sext_i32_i64(wave_sizze_322896) -\n                                                                (int64_t) 1];\n                    aggr_322954 = ((__local\n                                    double *) local_mem_322902)[squot64(warp_byte_offset_322900,\n                                                                        (int64_t) 8) +\n                                                                (sext_i32_i64(wave_sizze_322896) -\n                                                                 (int64_t) 1)];\n                    if (flag_322955 == (int8_t) 2) {\n                        readOffset_322952 = wave_sizze_322896 * -1;\n                    } else {\n                        if (flag_322955 == (int8_t) 1) {\n                            readOffset_322952 -= wave_sizze_322896;\n                        }\n                    }\n                    if (slt8((int8_t) 0, flag_322955)) {\n                        double x_322962 = aggr_322954;\n                        double x_322963 = prefix_322948;\n                        double defunc_1_op_res_322964 = x_322962 + x_322963;\n                        \n              ",
            "          prefix_322948 = defunc_1_op_res_322964;\n                    }\n                    mem_fence_local();\n                }\n            }\n            if (local_tid_322894 == 0) {\n                if (boundary_322912 == sext_i64_i32(segscan_group_sizze_308905 *\n                    (int64_t) 11)) {\n                    double x_322965 = prefix_322948;\n                    double x_322966 = acc_322935;\n                    double defunc_1_op_res_322967 = x_322965 + x_322966;\n                    \n                    ((volatile __global\n                      double *) incprefixes_mem_322891)[dynamic_id_322909] =\n                        defunc_1_op_res_322967;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_322887)[dynamic_id_322909] =\n                        (int8_t) 2;\n                }\n                ((__local\n                  double *) local_mem_322902)[squot64(warp_byte_offset_322900,\n                                                      (int64_t) 8)] =\n                    prefix_322948;\n                acc_322935 = 0.0;\n            }\n        }\n        if (!(dynamic_id_322909 == (int64_t) 0)) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            prefix_322948 = ((__local\n                              double *) local_mem_322902)[squot64(warp_byte_offset_322900,\n                                                                  (int64_t) 8)];\n            barrier(CLK_LOCAL_MEM_FENCE);\n        }\n    }\n    // Distribute results\n    {\n        double x_322968;\n        double x_322969;\n        double x_322971 = prefix_322948;\n        double x_322972 = acc_322935;\n        \n        if (slt32(local_tid_322894 * 11, boundary_322912) &&\n            !block_new_sgm_322949) {\n            double defunc_1_op_res_322973 = x_322971 + x_322972;\n            \n            x_322968 = defunc_1_op_res_322973;\n        } else {\n            x_322968 = acc_322935;\n        }\n        \n        int32_t stopping_point_",
            "322974 = segsizze_compact_322913 -\n                srem32(local_tid_322894 * 11 - 1 + segsizze_compact_322913 -\n                       boundary_322912, segsizze_compact_322913);\n        \n        for (int64_t i_322975 = 0; i_322975 < (int64_t) 11; i_322975++) {\n            if (slt32(sext_i64_i32(i_322975), stopping_point_322974 - 1)) {\n                x_322969 = private_mem_322914[i_322975];\n                \n                double defunc_1_op_res_322970 = x_322968 + x_322969;\n                \n                private_mem_322914[i_322975] = defunc_1_op_res_322970;\n            }\n        }\n    }\n    // Transpose scan output and Write it to global memory in coalesced fashion\n    {\n        for (int64_t i_322976 = 0; i_322976 < (int64_t) 11; i_322976++) {\n            int64_t sharedIdx_322977 = sext_i32_i64(local_tid_322894 * 11) +\n                    i_322976;\n            double tmp_322978;\n            \n            tmp_322978 = private_mem_322914[i_322976];\n            ((__local double *) local_mem_322902)[sharedIdx_322977] =\n                tmp_322978;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_322979 = 0; i_322979 < (int64_t) 11; i_322979++) {\n            int64_t flat_idx_322980 = blockOff_322910 +\n                    segscan_group_sizze_308905 * i_322979 +\n                    sext_i32_i64(local_tid_322894);\n            int64_t slice_322981 = lifted_single_ma_l_arg_293311;\n            int64_t slice_322982 = partition_sizze_292766 * slice_322981;\n            int64_t gtid_308909 = squot64(flat_idx_322980, slice_322981);\n            int64_t remnant_322983 = flat_idx_322980 - gtid_308909 *\n                    slice_322981;\n            int64_t gtid_308910 = remnant_322983;\n            int64_t remnant_322984 = remnant_322983 - gtid_308910;\n            \n            if (slt64(flat_idx_322980, partition_sizze_292766 *\n                      lifted_single_ma_l_arg_293311)) {\n                double tmp_322985;\n                \n                tmp_322985 = ",
            "((__local\n                               double *) local_mem_322902)[flat_idx_322980 -\n                                                           blockOff_322910];\n                ((__global double *) mem_319521)[gtid_308909 *\n                                                 lifted_single_ma_l_arg_293311 +\n                                                 gtid_308910] = tmp_322985;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // If this is the last block, reset the dynamicId\n    {\n        if (dynamic_id_322909 == sdiv_up64(partition_sizze_292766 *\n                                           lifted_single_ma_l_arg_293311,\n                                           segscan_group_sizze_308905 *\n                                           (int64_t) 11) - (int64_t) 1) {\n            ((__global int32_t *) mainziid_counter_mem_322885)[(int64_t) 0] = 0;\n        }\n    }\n    \n  error_0:\n    return;\n    #undef segscan_group_sizze_308905\n}\n__kernel void mainzisegscan_309042(__global int *global_failure,\n                                   int failure_is_an_option, __global\n                                   int64_t *global_failure_args,\n                                   uint local_mem_323083_backing_offset_0,\n                                   int64_t n_p_292677, double i64_res_292694,\n                                   int64_t partition_sizze_292766,\n                                   int64_t lifted_single_ma_l_arg_293311,\n                                   int64_t dyn_lifted_single_ma_l_arg_293321,\n                                   __global unsigned char *mem_319521, __global\n                                   unsigned char *ext_mem_319533, __global\n                                   unsigned char *mem_319538, __global\n                                   unsigned char *mainziid_counter_mem_323066,\n                                   __global\n                                   unsigned char *status_flags_mem_323068,\n                                   __gl",
            "obal\n                                   unsigned char *aggregates_mem_323070,\n                                   __global\n                                   unsigned char *incprefixes_mem_323072)\n{\n    #define segscan_group_sizze_309036 (mainzisegscan_group_sizze_309000)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *local_mem_323083_backing_0 =\n                           &shared_mem[local_mem_323083_backing_offset_0];\n    volatile __local bool local_failure;\n    \n    if (failure_is_an_option) {\n        int failed = *global_failure >= 0;\n        \n        if (failed)\n            return;\n    }\n    local_failure = false;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t global_tid_323074;\n    int32_t local_tid_323075;\n    int64_t group_sizze_323078;\n    int32_t wave_sizze_323077;\n    int32_t group_tid_323076;\n    \n    global_tid_323074 = get_global_id(0);\n    local_tid_323075 = get_local_id(0);\n    group_sizze_323078 = get_local_size(0);\n    wave_sizze_323077 = LOCKSTEP_WIDTH;\n    group_tid_323076 = get_group_id(0);\n    \n    int32_t phys_tid_309042 = global_tid_323074;\n    int64_t byte_offsets_323079 = (int64_t) 0;\n    int64_t byte_offsets_323080 = segscan_group_sizze_309036 * (int64_t) 8;\n    int64_t warp_byte_offset_323081 = (int64_t) 32;\n    int64_t warp_byte_offset_323082 = (int64_t) 288;\n    \n    // Allocate reused shared memeory\n    { }\n    \n    __local unsigned char *local_mem_323083;\n    \n    local_mem_323083 = (__local unsigned char *) local_mem_323083_backing_0;\n    \n    int64_t trans_arr_len_323084 = (int64_t) 11 * segscan_group_sizze_309036;\n    int32_t dynamic_id_323090;\n    \n    if (local_tid_323075 == 0) {\n        dynamic_id_323090 = atomic_add_i32_global(&((volatile __global\n                                                     int *) mainziid_counter_mem_323066)[(int64_t) 0],\n                                                  (int) 1);\n        ((__local int32_t *) local_mem_3230",
            "83)[(int64_t) 0] = dynamic_id_323090;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    dynamic_id_323090 = ((__local int32_t *) local_mem_323083)[(int64_t) 0];\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t blockOff_323091 = sext_i32_i64(dynamic_id_323090) * (int64_t) 11 *\n            segscan_group_sizze_309036;\n    int64_t sgm_idx_323092 = smod64(blockOff_323091,\n                                    dyn_lifted_single_ma_l_arg_293321);\n    int32_t boundary_323093 = sext_i64_i32(smin64((int64_t) 11 *\n                                                  segscan_group_sizze_309036,\n                                                  dyn_lifted_single_ma_l_arg_293321 -\n                                                  sgm_idx_323092));\n    int32_t segsizze_compact_323094 = sext_i64_i32(smin64((int64_t) 11 *\n                                                          segscan_group_sizze_309036,\n                                                          dyn_lifted_single_ma_l_arg_293321));\n    double private_mem_323095[(int64_t) 11];\n    \n    // Load and map\n    {\n        for (int64_t i_323097 = 0; i_323097 < (int64_t) 11; i_323097++) {\n            int64_t phys_tid_323098 = blockOff_323091 +\n                    sext_i32_i64(local_tid_323075) + i_323097 *\n                    segscan_group_sizze_309036;\n            int64_t slice_323099 = dyn_lifted_single_ma_l_arg_293321;\n            int64_t slice_323100 = partition_sizze_292766 * slice_323099;\n            int64_t gtid_309040 = squot64(phys_tid_323098, slice_323099);\n            int64_t remnant_323101 = phys_tid_323098 - gtid_309040 *\n                    slice_323099;\n            int64_t gtid_309041 = remnant_323101;\n            int64_t remnant_323102 = remnant_323101 - gtid_309041;\n            \n            if (slt64(phys_tid_323098, partition_sizze_292766 *\n                      dyn_lifted_single_ma_l_arg_293321)) {\n                bool cond_309049 = gtid_309041 == (int64_t) 0;\n                double defunc_0_f_res_309050;\n         ",
            "       \n                if (cond_309049) {\n                    double x_309047;\n                    \n                    x_309047 = ((__global\n                                 double *) ext_mem_319533)[gtid_309040];\n                    \n                    double defunc_0_f_res_t_res_309051 = x_309047 /\n                           i64_res_292694;\n                    \n                    defunc_0_f_res_309050 = defunc_0_f_res_t_res_309051;\n                } else {\n                    int64_t x_309052 = add64(n_p_292677, gtid_309041);\n                    int64_t i_309053 = sub64(x_309052, (int64_t) 1);\n                    bool x_309054 = sle64((int64_t) 0, i_309053);\n                    bool y_309055 = slt64(i_309053,\n                                          lifted_single_ma_l_arg_293311);\n                    bool bounds_check_309056 = x_309054 && y_309055;\n                    bool index_certs_309057;\n                    \n                    if (!bounds_check_309056) {\n                        {\n                            if (atomic_cmpxchg_i32_global(global_failure, -1,\n                                                          46) == -1) {\n                                global_failure_args[0] = (int64_t) i_309053;\n                                global_failure_args[1] =\n                                    (int64_t) lifted_single_ma_l_arg_293311;\n                                ;\n                            }\n                            local_failure = true;\n                            goto error_0;\n                        }\n                    }\n                    \n                    double x_309058;\n                    \n                    x_309058 = ((__global double *) mem_319521)[gtid_309040 *\n                                                                lifted_single_ma_l_arg_293311 +\n                                                                i_309053];\n                    \n                    int64_t i_309059 = sub64(gtid_309041, (int64_t) 1);\n       ",
            "             bool x_309060 = sle64((int64_t) 0, i_309059);\n                    bool y_309061 = slt64(i_309059,\n                                          lifted_single_ma_l_arg_293311);\n                    bool bounds_check_309062 = x_309060 && y_309061;\n                    bool index_certs_309063;\n                    \n                    if (!bounds_check_309062) {\n                        {\n                            if (atomic_cmpxchg_i32_global(global_failure, -1,\n                                                          47) == -1) {\n                                global_failure_args[0] = (int64_t) i_309059;\n                                global_failure_args[1] =\n                                    (int64_t) lifted_single_ma_l_arg_293311;\n                                ;\n                            }\n                            local_failure = true;\n                            goto error_0;\n                        }\n                    }\n                    \n                    double y_309064;\n                    \n                    y_309064 = ((__global double *) mem_319521)[gtid_309040 *\n                                                                lifted_single_ma_l_arg_293311 +\n                                                                i_309059];\n                    \n                    double x_309065 = x_309058 - y_309064;\n                    double defunc_0_f_res_f_res_309066 = x_309065 /\n                           i64_res_292694;\n                    \n                    defunc_0_f_res_309050 = defunc_0_f_res_f_res_309066;\n                }\n                private_mem_323095[i_323097] = defunc_0_f_res_309050;\n            } else {\n                private_mem_323095[i_323097] = 0.0;\n            }\n        }\n    }\n    // Transpose scan inputs\n    {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_323103 = 0; i_323103 < (int64_t) 11; i_323103++) {\n            int64_t sharedIdx_323104 = sext_i32_i64(local_tid_323075) +\n                   ",
            " i_323103 * segscan_group_sizze_309036;\n            double tmp_323105;\n            \n            tmp_323105 = private_mem_323095[i_323103];\n            ((__local double *) local_mem_323083)[sharedIdx_323104] =\n                tmp_323105;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int32_t i_323106 = 0; i_323106 < 11; i_323106++) {\n            int32_t sharedIdx_323107 = local_tid_323075 * 11 + i_323106;\n            double tmp_323108;\n            \n            tmp_323108 = ((__local\n                           double *) local_mem_323083)[sext_i32_i64(sharedIdx_323107)];\n            private_mem_323095[sext_i32_i64(i_323106)] = tmp_323108;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // Per thread scan\n    {\n        int32_t gidx_323109 = local_tid_323075 * 11 + 1;\n        \n        for (int64_t i_323110 = 0; i_323110 < (int64_t) 10; i_323110++) {\n            bool new_sgm_323111 = smod32(gidx_323109 + sext_i64_i32(i_323110) -\n                                         boundary_323093,\n                                         segsizze_compact_323094) == 0;\n            \n            if (!new_sgm_323111) {\n                double x_309043;\n                double x_309044;\n                \n                x_309043 = private_mem_323095[i_323110];\n                x_309044 = private_mem_323095[i_323110 + (int64_t) 1];\n                \n                double defunc_1_op_res_309045 = x_309043 + x_309044;\n                \n                private_mem_323095[i_323110 + (int64_t) 1] =\n                    defunc_1_op_res_309045;\n            }\n        }\n    }\n    // Publish results in shared memory\n    {\n        double tmp_323112;\n        \n        tmp_323112 = private_mem_323095[(int64_t) 10];\n        ((__local double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                      (int64_t) 8) +\n                                              sext_i32_i64(local_tid_323075)] =\n            tmp_323112;\n        barrier(CLK_LOCAL_M",
            "EM_FENCE);\n    }\n    \n    double acc_323116;\n    \n    // Scan results (with warp scan)\n    {\n        double x_323113;\n        double x_323114;\n        double x_323117;\n        double x_323118;\n        bool ltid_in_bounds_323120 = slt64(sext_i32_i64(local_tid_323075),\n                                           segscan_group_sizze_309036);\n        int32_t skip_threads_323121;\n        \n        // read input for in-block scan\n        {\n            if (ltid_in_bounds_323120) {\n                x_323114 = ((volatile __local\n                             double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                                 (int64_t) 8) +\n                                                         sext_i32_i64(local_tid_323075)];\n                if ((local_tid_323075 - squot32(local_tid_323075, 32) * 32) ==\n                    0) {\n                    x_323113 = x_323114;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_323121 = 1;\n            while (slt32(skip_threads_323121, 32)) {\n                bool thread_active_323122 = sle32(skip_threads_323121,\n                                                  local_tid_323075 -\n                                                  squot32(local_tid_323075,\n                                                          32) * 32) &&\n                     ltid_in_bounds_323120;\n                \n                if (thread_active_323122) {\n                    // read operands\n                    {\n                        x_323113 = ((volatile __local\n                                     double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                                         (int64_t) 8) +\n                                                                 (sext_i32_i64(local_tid_323075) -\n                                                                  sext_i32_i64(skip_threads_",
            "323121))];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_323123 = slt32(smod32((local_tid_323075 + 1) *\n                                                        11 - 1 +\n                                                        segsizze_compact_323094 -\n                                                        boundary_323093,\n                                                        segsizze_compact_323094),\n                                                 (local_tid_323075 + 1) * 11 -\n                                                 1 - ((local_tid_323075 -\n                                                       skip_threads_323121 +\n                                                       1) * 11 - 1));\n                    \n                    if (thread_active_323122 && inactive_323123) {\n                        x_323113 = x_323114;\n                    }\n                    if (thread_active_323122) {\n                        if (!inactive_323123) {\n                            double defunc_1_op_res_323115 = x_323113 + x_323114;\n                            \n                            x_323113 = defunc_1_op_res_323115;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_323077, skip_threads_323121)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_323122) {\n                    // write result\n                    {\n                        ((volatile __local\n                          double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                              (int64_t) 8) +\n                                                      sext_i32_i64(local_tid_323075)] =\n                            x_323113;\n                        x_323114 = x_323113;\n                    }\n                }\n                if (sle32(wave_sizze_323077, skip_threads_323121)) {",
            "\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_323121 *= 2;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // last thread of block 'i' writes its result to offset 'i'\n        {\n            if ((local_tid_323075 - squot32(local_tid_323075, 32) * 32) == 31 &&\n                ltid_in_bounds_323120) {\n                ((volatile __local\n                  double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                      (int64_t) 8) +\n                                              sext_i32_i64(squot32(local_tid_323075,\n                                                                   32))] =\n                    x_323113;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n        {\n            int32_t skip_threads_323124;\n            \n            // read input for in-block scan\n            {\n                if (squot32(local_tid_323075, 32) == 0 &&\n                    ltid_in_bounds_323120) {\n                    x_323118 = ((volatile __local\n                                 double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                                     (int64_t) 8) +\n                                                             sext_i32_i64(local_tid_323075)];\n                    if ((local_tid_323075 - squot32(local_tid_323075, 32) *\n                         32) == 0) {\n                        x_323117 = x_323118;\n                    }\n                }\n            }\n            // in-block scan (hopefully no barriers needed)\n            {\n                skip_threads_323124 = 1;\n                while (slt32(skip_threads_323124, 32)) {\n                    bool thread_active_323125 = sle32(skip_threads_323124,\n                                                      local_tid_323075 -\n                               ",
            "                       squot32(local_tid_323075,\n                                                              32) * 32) &&\n                         (squot32(local_tid_323075, 32) == 0 &&\n                          ltid_in_bounds_323120);\n                    \n                    if (thread_active_323125) {\n                        // read operands\n                        {\n                            x_323117 = ((volatile __local\n                                         double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                                             (int64_t) 8) +\n                                                                     (sext_i32_i64(local_tid_323075) -\n                                                                      sext_i32_i64(skip_threads_323124))];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_323126 = slt32(smod32((local_tid_323075 *\n                                                             32 + 32 - 1 + 1) *\n                                                            11 - 1 +\n                                                            segsizze_compact_323094 -\n                                                            boundary_323093,\n                                                            segsizze_compact_323094),\n                                                     (local_tid_323075 * 32 +\n                                                      32 - 1 + 1) * 11 - 1 -\n                                                     (((local_tid_323075 -\n                                                        skip_threads_323124) *\n                                                       32 + 32 - 1 + 1) * 11 -\n                                                      1));\n                        \n                        if (thread_active_323125 && inactive_323126) {\n                            x_323117",
            " = x_323118;\n                        }\n                        if (thread_active_323125) {\n                            if (!inactive_323126) {\n                                double defunc_1_op_res_323119 = x_323117 +\n                                       x_323118;\n                                \n                                x_323117 = defunc_1_op_res_323119;\n                            }\n                        }\n                    }\n                    if (sle32(wave_sizze_323077, skip_threads_323124)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    if (thread_active_323125) {\n                        // write result\n                        {\n                            ((volatile __local\n                              double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                                  (int64_t) 8) +\n                                                          sext_i32_i64(local_tid_323075)] =\n                                x_323117;\n                            x_323118 = x_323117;\n                        }\n                    }\n                    if (sle32(wave_sizze_323077, skip_threads_323124)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    skip_threads_323124 *= 2;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        bool no_carry_in_323127 = squot32(local_tid_323075, 32) == 0 ||\n             !ltid_in_bounds_323120;\n        \n        // carry-in for every block except the first\n        {\n            // read operands\n            {\n                if (!no_carry_in_323127) {\n                    x_323114 = x_323113;\n                    x_323113 = ((__local\n                                 double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                                     (int64_t) 8) +\n                                       ",
            "                      (sext_i32_i64(squot32(local_tid_323075,\n                                                                                   32)) -\n                                                              (int64_t) 1)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_323128 = slt32(smod32((local_tid_323075 + 1) *\n                                                    11 - 1 +\n                                                    segsizze_compact_323094 -\n                                                    boundary_323093,\n                                                    segsizze_compact_323094),\n                                             (local_tid_323075 + 1) * 11 - 1 -\n                                             ((squot32(local_tid_323075, 32) *\n                                               32 - 1 + 1) * 11 - 1));\n                \n                if (!no_carry_in_323127) {\n                    if (inactive_323128) {\n                        x_323113 = x_323114;\n                    }\n                }\n                if (!no_carry_in_323127) {\n                    if (!inactive_323128) {\n                        double defunc_1_op_res_323115 = x_323113 + x_323114;\n                        \n                        x_323113 = defunc_1_op_res_323115;\n                    }\n                }\n            }\n            // write final result\n            {\n                if (!no_carry_in_323127) {\n                    ((__local\n                      double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                          (int64_t) 8) +\n                                                  sext_i32_i64(local_tid_323075)] =\n                        x_323113;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // restore correct values for first block\n        {\n            if (squot32(local_tid_323075, 32) == 0 && ltid_in_bounds_323120) {\n",
            "                ((__local\n                  double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                      (int64_t) 8) +\n                                              sext_i32_i64(local_tid_323075)] =\n                    x_323114;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (local_tid_323075 == 0) {\n            acc_323116 = ((__local\n                           double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                               (int64_t) 8) +\n                                                       (segscan_group_sizze_309036 -\n                                                        (int64_t) 1)];\n        } else {\n            acc_323116 = ((__local\n                           double *) local_mem_323083)[squot64(byte_offsets_323079,\n                                                               (int64_t) 8) +\n                                                       (sext_i32_i64(local_tid_323075) -\n                                                        (int64_t) 1)];\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    double prefix_323129 = 0.0;\n    bool block_new_sgm_323130 = sgm_idx_323092 == (int64_t) 0;\n    \n    // Perform lookback\n    {\n        if (block_new_sgm_323130 && local_tid_323075 == 0) {\n            ((volatile __global\n              double *) incprefixes_mem_323072)[dynamic_id_323090] = acc_323116;\n            mem_fence_global();\n            ((volatile __global\n              int8_t *) status_flags_mem_323068)[dynamic_id_323090] =\n                (int8_t) 2;\n            acc_323116 = 0.0;\n        }\n        if (!block_new_sgm_323130 && slt32(local_tid_323075,\n                                           wave_sizze_323077)) {\n            if (local_tid_323075 == 0) {\n                if (boundary_323093 == sext_i64_i32(segscan_group_sizze_309036 *\n                    (int64_t) 11)) {\n      ",
            "              ((volatile __global\n                      double *) aggregates_mem_323070)[dynamic_id_323090] =\n                        acc_323116;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_323068)[dynamic_id_323090] =\n                        (int8_t) 1;\n                } else {\n                    ((volatile __global\n                      double *) incprefixes_mem_323072)[dynamic_id_323090] =\n                        acc_323116;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_323068)[dynamic_id_323090] =\n                        (int8_t) 2;\n                }\n                \n                int8_t tmp_323131;\n                \n                tmp_323131 = ((volatile __global\n                               int8_t *) status_flags_mem_323068)[dynamic_id_323090 -\n                                                                  (int64_t) 1];\n                ((volatile __local int8_t *) local_mem_323083)[(int64_t) 0] =\n                    tmp_323131;\n            }\n            mem_fence_local();\n            \n            int8_t status_323132;\n            \n            status_323132 = ((__local int8_t *) local_mem_323083)[(int64_t) 0];\n            if (status_323132 == (int8_t) 2) {\n                if (local_tid_323075 == 0) {\n                    prefix_323129 = ((volatile __global\n                                      double *) incprefixes_mem_323072)[dynamic_id_323090 -\n                                                                        (int64_t) 1];\n                }\n            } else {\n                int32_t readOffset_323133 = dynamic_id_323090 -\n                        sext_i32_i64(wave_sizze_323077);\n                \n                while (slt32(wave_sizze_323077 * -1, readOffset_323133)) {\n                    int32_t read_i_323134 = readOffset_323133 +\n                            local_tid_323075;\n   ",
            "                 double aggr_323135 = 0.0;\n                    int8_t flag_323136 = (int8_t) 0;\n                    \n                    if (sle32(0, read_i_323134)) {\n                        if (sle64(blockOff_323091 -\n                                  (sext_i32_i64(read_i_323134 + 1) *\n                                   segscan_group_sizze_309036 * (int64_t) 11 -\n                                   (int64_t) 1), sgm_idx_323092)) {\n                            flag_323136 = ((volatile __global\n                                            int8_t *) status_flags_mem_323068)[sext_i32_i64(read_i_323134)];\n                            if (flag_323136 == (int8_t) 2) {\n                                aggr_323135 = ((volatile __global\n                                                double *) incprefixes_mem_323072)[sext_i32_i64(read_i_323134)];\n                            } else {\n                                if (flag_323136 == (int8_t) 1) {\n                                    aggr_323135 = ((volatile __global\n                                                    double *) aggregates_mem_323070)[sext_i32_i64(read_i_323134)];\n                                }\n                            }\n                        } else {\n                            flag_323136 = (int8_t) 2;\n                        }\n                    }\n                    ((__local\n                      double *) local_mem_323083)[squot64(warp_byte_offset_323081,\n                                                          (int64_t) 8) +\n                                                  sext_i32_i64(local_tid_323075)] =\n                        aggr_323135;\n                    ((__local\n                      int8_t *) local_mem_323083)[sext_i32_i64(local_tid_323075)] =\n                        flag_323136;\n                    flag_323136 = ((__local\n                                    int8_t *) local_mem_323083)[sext_i32_i64(wave_sizze_323077) -\n                                                                (int",
            "64_t) 1];\n                    if (slt8(flag_323136, (int8_t) 2)) {\n                        int8_t flg_x_323140;\n                        int8_t flg_y_323141;\n                        double x_323137;\n                        double x_323138;\n                        int32_t skip_threads_323142;\n                        \n                        // read input for in-block scan\n                        {\n                            flg_y_323141 = ((volatile __local\n                                             int8_t *) local_mem_323083)[sext_i32_i64(local_tid_323075)];\n                            x_323138 = ((volatile __local\n                                         double *) local_mem_323083)[squot64(warp_byte_offset_323081,\n                                                                             (int64_t) 8) +\n                                                                     sext_i32_i64(local_tid_323075)];\n                            if ((local_tid_323075 - squot32(local_tid_323075,\n                                                            32) * 32) == 0) {\n                                x_323137 = x_323138;\n                                flg_x_323140 = flg_y_323141;\n                            }\n                        }\n                        // in-block scan (hopefully no barriers needed)\n                        {\n                            skip_threads_323142 = 1;\n                            while (slt32(skip_threads_323142, 32)) {\n                                if (sle32(skip_threads_323142,\n                                          local_tid_323075 -\n                                          squot32(local_tid_323075, 32) * 32)) {\n                                    // read operands\n                                    {\n                                        flg_x_323140 = ((volatile __local\n                                                         int8_t *) local_mem_323083)[sext_i32_i64(local_tid_323075) -\n                                             ",
            "                                        sext_i32_i64(skip_threads_323142)];\n                                        x_323137 = ((volatile __local\n                                                     double *) local_mem_323083)[squot64(warp_byte_offset_323081,\n                                                                                         (int64_t) 8) +\n                                                                                 (sext_i32_i64(local_tid_323075) -\n                                                                                  sext_i32_i64(skip_threads_323142))];\n                                    }\n                                    // perform operation\n                                    {\n                                        if (flg_y_323141 == (int8_t) 2 ||\n                                            flg_y_323141 == (int8_t) 0) {\n                                            flg_x_323140 = flg_y_323141;\n                                            x_323137 = x_323138;\n                                        } else {\n                                            double defunc_1_op_res_323139 =\n                                                   x_323137 + x_323138;\n                                            \n                                            x_323137 = defunc_1_op_res_323139;\n                                        }\n                                    }\n                                    // write result\n                                    {\n                                        ((volatile __local\n                                          int8_t *) local_mem_323083)[sext_i32_i64(local_tid_323075)] =\n                                            flg_x_323140;\n                                        flg_y_323141 = flg_x_323140;\n                                        ((volatile __local\n                                          double *) local_mem_323083)[squot64(warp_byte_offset_323081,\n                                        ",
            "                                      (int64_t) 8) +\n                                                                      sext_i32_i64(local_tid_323075)] =\n                                            x_323137;\n                                        x_323138 = x_323137;\n                                    }\n                                }\n                                skip_threads_323142 *= 2;\n                            }\n                        }\n                    }\n                    flag_323136 = ((__local\n                                    int8_t *) local_mem_323083)[sext_i32_i64(wave_sizze_323077) -\n                                                                (int64_t) 1];\n                    aggr_323135 = ((__local\n                                    double *) local_mem_323083)[squot64(warp_byte_offset_323081,\n                                                                        (int64_t) 8) +\n                                                                (sext_i32_i64(wave_sizze_323077) -\n                                                                 (int64_t) 1)];\n                    if (flag_323136 == (int8_t) 2) {\n                        readOffset_323133 = wave_sizze_323077 * -1;\n                    } else {\n                        if (flag_323136 == (int8_t) 1) {\n                            readOffset_323133 -= wave_sizze_323077;\n                        }\n                    }\n                    if (slt8((int8_t) 0, flag_323136)) {\n                        double x_323143 = aggr_323135;\n                        double x_323144 = prefix_323129;\n                        double defunc_1_op_res_323145 = x_323143 + x_323144;\n                        \n                        prefix_323129 = defunc_1_op_res_323145;\n                    }\n                    mem_fence_local();\n                }\n            }\n            if (local_tid_323075 == 0) {\n                if (boundary_323093 == sext_i64_i32(segscan_group_sizze_309036 *\n                    ",
            "(int64_t) 11)) {\n                    double x_323146 = prefix_323129;\n                    double x_323147 = acc_323116;\n                    double defunc_1_op_res_323148 = x_323146 + x_323147;\n                    \n                    ((volatile __global\n                      double *) incprefixes_mem_323072)[dynamic_id_323090] =\n                        defunc_1_op_res_323148;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_323068)[dynamic_id_323090] =\n                        (int8_t) 2;\n                }\n                ((__local\n                  double *) local_mem_323083)[squot64(warp_byte_offset_323081,\n                                                      (int64_t) 8)] =\n                    prefix_323129;\n                acc_323116 = 0.0;\n            }\n        }\n        if (!(dynamic_id_323090 == (int64_t) 0)) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            prefix_323129 = ((__local\n                              double *) local_mem_323083)[squot64(warp_byte_offset_323081,\n                                                                  (int64_t) 8)];\n            barrier(CLK_LOCAL_MEM_FENCE);\n        }\n    }\n    // Distribute results\n    {\n        double x_323149;\n        double x_323150;\n        double x_323152 = prefix_323129;\n        double x_323153 = acc_323116;\n        \n        if (slt32(local_tid_323075 * 11, boundary_323093) &&\n            !block_new_sgm_323130) {\n            double defunc_1_op_res_323154 = x_323152 + x_323153;\n            \n            x_323149 = defunc_1_op_res_323154;\n        } else {\n            x_323149 = acc_323116;\n        }\n        \n        int32_t stopping_point_323155 = segsizze_compact_323094 -\n                srem32(local_tid_323075 * 11 - 1 + segsizze_compact_323094 -\n                       boundary_323093, segsizze_compact_323094);\n        \n        for (int64_t i_323156 = 0; i_323156 < (int64_t) 11; i_323156++) {\n            if (slt32(se",
            "xt_i64_i32(i_323156), stopping_point_323155 - 1)) {\n                x_323150 = private_mem_323095[i_323156];\n                \n                double defunc_1_op_res_323151 = x_323149 + x_323150;\n                \n                private_mem_323095[i_323156] = defunc_1_op_res_323151;\n            }\n        }\n    }\n    // Transpose scan output and Write it to global memory in coalesced fashion\n    {\n        for (int64_t i_323157 = 0; i_323157 < (int64_t) 11; i_323157++) {\n            int64_t sharedIdx_323158 = sext_i32_i64(local_tid_323075 * 11) +\n                    i_323157;\n            double tmp_323159;\n            \n            tmp_323159 = private_mem_323095[i_323157];\n            ((__local double *) local_mem_323083)[sharedIdx_323158] =\n                tmp_323159;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_323160 = 0; i_323160 < (int64_t) 11; i_323160++) {\n            int64_t flat_idx_323161 = blockOff_323091 +\n                    segscan_group_sizze_309036 * i_323160 +\n                    sext_i32_i64(local_tid_323075);\n            int64_t slice_323162 = dyn_lifted_single_ma_l_arg_293321;\n            int64_t slice_323163 = partition_sizze_292766 * slice_323162;\n            int64_t gtid_309040 = squot64(flat_idx_323161, slice_323162);\n            int64_t remnant_323164 = flat_idx_323161 - gtid_309040 *\n                    slice_323162;\n            int64_t gtid_309041 = remnant_323164;\n            int64_t remnant_323165 = remnant_323164 - gtid_309041;\n            \n            if (slt64(flat_idx_323161, partition_sizze_292766 *\n                      dyn_lifted_single_ma_l_arg_293321)) {\n                double tmp_323166;\n                \n                tmp_323166 = ((__local\n                               double *) local_mem_323083)[flat_idx_323161 -\n                                                           blockOff_323091];\n                ((__global double *) mem_319538)[gtid_309040 *\n                                                 d",
            "yn_lifted_single_ma_l_arg_293321 +\n                                                 gtid_309041] = tmp_323166;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // If this is the last block, reset the dynamicId\n    {\n        if (dynamic_id_323090 == sdiv_up64(partition_sizze_292766 *\n                                           dyn_lifted_single_ma_l_arg_293321,\n                                           segscan_group_sizze_309036 *\n                                           (int64_t) 11) - (int64_t) 1) {\n            ((__global int32_t *) mainziid_counter_mem_323066)[(int64_t) 0] = 0;\n        }\n    }\n    \n  error_0:\n    return;\n    #undef segscan_group_sizze_309036\n}\n__kernel void mainzisegscan_309173(__global int *global_failure,\n                                   int failure_is_an_option, __global\n                                   int64_t *global_failure_args,\n                                   uint local_mem_323264_backing_offset_0,\n                                   int64_t n_292675,\n                                   int64_t partition_sizze_292766,\n                                   int64_t dyn_lifted_single_ma_l_arg_293321,\n                                   __global unsigned char *mem_319538, __global\n                                   unsigned char *ext_mem_319550, __global\n                                   unsigned char *mem_319555, __global\n                                   unsigned char *mainziid_counter_mem_323247,\n                                   __global\n                                   unsigned char *status_flags_mem_323249,\n                                   __global\n                                   unsigned char *aggregates_mem_323251,\n                                   __global\n                                   unsigned char *incprefixes_mem_323253)\n{\n    #define segscan_group_sizze_309167 (mainzisegscan_group_sizze_309131)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n ",
            "   volatile unsigned char *local_mem_323264_backing_0 =\n                           &shared_mem[local_mem_323264_backing_offset_0];\n    volatile __local bool local_failure;\n    \n    if (failure_is_an_option) {\n        int failed = *global_failure >= 0;\n        \n        if (failed)\n            return;\n    }\n    local_failure = false;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t global_tid_323255;\n    int32_t local_tid_323256;\n    int64_t group_sizze_323259;\n    int32_t wave_sizze_323258;\n    int32_t group_tid_323257;\n    \n    global_tid_323255 = get_global_id(0);\n    local_tid_323256 = get_local_id(0);\n    group_sizze_323259 = get_local_size(0);\n    wave_sizze_323258 = LOCKSTEP_WIDTH;\n    group_tid_323257 = get_group_id(0);\n    \n    int32_t phys_tid_309173 = global_tid_323255;\n    int64_t byte_offsets_323260 = (int64_t) 0;\n    int64_t byte_offsets_323261 = segscan_group_sizze_309167 * (int64_t) 8;\n    int64_t warp_byte_offset_323262 = (int64_t) 32;\n    int64_t warp_byte_offset_323263 = (int64_t) 288;\n    \n    // Allocate reused shared memeory\n    { }\n    \n    __local unsigned char *local_mem_323264;\n    \n    local_mem_323264 = (__local unsigned char *) local_mem_323264_backing_0;\n    \n    int64_t trans_arr_len_323265 = (int64_t) 11 * segscan_group_sizze_309167;\n    int32_t dynamic_id_323271;\n    \n    if (local_tid_323256 == 0) {\n        dynamic_id_323271 = atomic_add_i32_global(&((volatile __global\n                                                     int *) mainziid_counter_mem_323247)[(int64_t) 0],\n                                                  (int) 1);\n        ((__local int32_t *) local_mem_323264)[(int64_t) 0] = dynamic_id_323271;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    dynamic_id_323271 = ((__local int32_t *) local_mem_323264)[(int64_t) 0];\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t blockOff_323272 = sext_i32_i64(dynamic_id_323271) * (int64_t) 11 *\n            segscan_group_sizze_309167;\n    int64_t sgm_idx_323273 = smod64(blockOff_323272, n_",
            "292675);\n    int32_t boundary_323274 = sext_i64_i32(smin64((int64_t) 11 *\n                                                  segscan_group_sizze_309167,\n                                                  n_292675 - sgm_idx_323273));\n    int32_t segsizze_compact_323275 = sext_i64_i32(smin64((int64_t) 11 *\n                                                          segscan_group_sizze_309167,\n                                                          n_292675));\n    double private_mem_323276[(int64_t) 11];\n    \n    // Load and map\n    {\n        for (int64_t i_323278 = 0; i_323278 < (int64_t) 11; i_323278++) {\n            int64_t phys_tid_323279 = blockOff_323272 +\n                    sext_i32_i64(local_tid_323256) + i_323278 *\n                    segscan_group_sizze_309167;\n            int64_t slice_323280 = n_292675;\n            int64_t slice_323281 = partition_sizze_292766 * slice_323280;\n            int64_t gtid_309171 = squot64(phys_tid_323279, slice_323280);\n            int64_t remnant_323282 = phys_tid_323279 - gtid_309171 *\n                    slice_323280;\n            int64_t gtid_309172 = remnant_323282;\n            int64_t remnant_323283 = remnant_323282 - gtid_309172;\n            \n            if (slt64(phys_tid_323279, partition_sizze_292766 * n_292675)) {\n                bool cond_309180 = gtid_309172 == (int64_t) 0;\n                double defunc_0_f_res_309181;\n                \n                if (cond_309180) {\n                    double x_309178;\n                    \n                    x_309178 = ((__global\n                                 double *) ext_mem_319550)[gtid_309171];\n                    \n                    double defunc_0_f_res_t_res_309182 = x_309178 / 3.0;\n                    \n                    defunc_0_f_res_309181 = defunc_0_f_res_t_res_309182;\n                } else {\n                    int64_t x_309183 = add64((int64_t) 3, gtid_309172);\n                    int64_t i_309184 = sub64(x_309183, (int64_t) 1);\n                    bool x_3091",
            "85 = sle64((int64_t) 0, i_309184);\n                    bool y_309186 = slt64(i_309184,\n                                          dyn_lifted_single_ma_l_arg_293321);\n                    bool bounds_check_309187 = x_309185 && y_309186;\n                    bool index_certs_309188;\n                    \n                    if (!bounds_check_309187) {\n                        {\n                            if (atomic_cmpxchg_i32_global(global_failure, -1,\n                                                          48) == -1) {\n                                global_failure_args[0] = (int64_t) i_309184;\n                                global_failure_args[1] =\n                                    (int64_t) dyn_lifted_single_ma_l_arg_293321;\n                                ;\n                            }\n                            local_failure = true;\n                            goto error_0;\n                        }\n                    }\n                    \n                    double x_309189;\n                    \n                    x_309189 = ((__global double *) mem_319538)[gtid_309171 *\n                                                                dyn_lifted_single_ma_l_arg_293321 +\n                                                                i_309184];\n                    \n                    int64_t i_309190 = sub64(gtid_309172, (int64_t) 1);\n                    bool x_309191 = sle64((int64_t) 0, i_309190);\n                    bool y_309192 = slt64(i_309190,\n                                          dyn_lifted_single_ma_l_arg_293321);\n                    bool bounds_check_309193 = x_309191 && y_309192;\n                    bool index_certs_309194;\n                    \n                    if (!bounds_check_309193) {\n                        {\n                            if (atomic_cmpxchg_i32_global(global_failure, -1,\n                                                          49) == -1) {\n                                global_failure_args[0] = (int64_t) i_309190;\n  ",
            "                              global_failure_args[1] =\n                                    (int64_t) dyn_lifted_single_ma_l_arg_293321;\n                                ;\n                            }\n                            local_failure = true;\n                            goto error_0;\n                        }\n                    }\n                    \n                    double y_309195;\n                    \n                    y_309195 = ((__global double *) mem_319538)[gtid_309171 *\n                                                                dyn_lifted_single_ma_l_arg_293321 +\n                                                                i_309190];\n                    \n                    double x_309196 = x_309189 - y_309195;\n                    double defunc_0_f_res_f_res_309197 = x_309196 / 3.0;\n                    \n                    defunc_0_f_res_309181 = defunc_0_f_res_f_res_309197;\n                }\n                private_mem_323276[i_323278] = defunc_0_f_res_309181;\n            } else {\n                private_mem_323276[i_323278] = 0.0;\n            }\n        }\n    }\n    // Transpose scan inputs\n    {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_323284 = 0; i_323284 < (int64_t) 11; i_323284++) {\n            int64_t sharedIdx_323285 = sext_i32_i64(local_tid_323256) +\n                    i_323284 * segscan_group_sizze_309167;\n            double tmp_323286;\n            \n            tmp_323286 = private_mem_323276[i_323284];\n            ((__local double *) local_mem_323264)[sharedIdx_323285] =\n                tmp_323286;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int32_t i_323287 = 0; i_323287 < 11; i_323287++) {\n            int32_t sharedIdx_323288 = local_tid_323256 * 11 + i_323287;\n            double tmp_323289;\n            \n            tmp_323289 = ((__local\n                           double *) local_mem_323264)[sext_i32_i64(sharedIdx_323288)];\n            private_mem_323276[sext_i32_i64(i_323287)] = tmp_32",
            "3289;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // Per thread scan\n    {\n        int32_t gidx_323290 = local_tid_323256 * 11 + 1;\n        \n        for (int64_t i_323291 = 0; i_323291 < (int64_t) 10; i_323291++) {\n            bool new_sgm_323292 = smod32(gidx_323290 + sext_i64_i32(i_323291) -\n                                         boundary_323274,\n                                         segsizze_compact_323275) == 0;\n            \n            if (!new_sgm_323292) {\n                double x_309174;\n                double x_309175;\n                \n                x_309174 = private_mem_323276[i_323291];\n                x_309175 = private_mem_323276[i_323291 + (int64_t) 1];\n                \n                double defunc_1_op_res_309176 = x_309174 + x_309175;\n                \n                private_mem_323276[i_323291 + (int64_t) 1] =\n                    defunc_1_op_res_309176;\n            }\n        }\n    }\n    // Publish results in shared memory\n    {\n        double tmp_323293;\n        \n        tmp_323293 = private_mem_323276[(int64_t) 10];\n        ((__local double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                                      (int64_t) 8) +\n                                              sext_i32_i64(local_tid_323256)] =\n            tmp_323293;\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    double acc_323297;\n    \n    // Scan results (with warp scan)\n    {\n        double x_323294;\n        double x_323295;\n        double x_323298;\n        double x_323299;\n        bool ltid_in_bounds_323301 = slt64(sext_i32_i64(local_tid_323256),\n                                           segscan_group_sizze_309167);\n        int32_t skip_threads_323302;\n        \n        // read input for in-block scan\n        {\n            if (ltid_in_bounds_323301) {\n                x_323295 = ((volatile __local\n                             double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                           ",
            "                      (int64_t) 8) +\n                                                         sext_i32_i64(local_tid_323256)];\n                if ((local_tid_323256 - squot32(local_tid_323256, 32) * 32) ==\n                    0) {\n                    x_323294 = x_323295;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_323302 = 1;\n            while (slt32(skip_threads_323302, 32)) {\n                bool thread_active_323303 = sle32(skip_threads_323302,\n                                                  local_tid_323256 -\n                                                  squot32(local_tid_323256,\n                                                          32) * 32) &&\n                     ltid_in_bounds_323301;\n                \n                if (thread_active_323303) {\n                    // read operands\n                    {\n                        x_323294 = ((volatile __local\n                                     double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                                                         (int64_t) 8) +\n                                                                 (sext_i32_i64(local_tid_323256) -\n                                                                  sext_i32_i64(skip_threads_323302))];\n                    }\n                }\n                // perform operation\n                {\n                    bool inactive_323304 = slt32(smod32((local_tid_323256 + 1) *\n                                                        11 - 1 +\n                                                        segsizze_compact_323275 -\n                                                        boundary_323274,\n                                                        segsizze_compact_323275),\n                                                 (local_tid_323256 + 1) * 11 -\n                                                 1 - ((local_tid_323256 -\n          ",
            "                                             skip_threads_323302 +\n                                                       1) * 11 - 1));\n                    \n                    if (thread_active_323303 && inactive_323304) {\n                        x_323294 = x_323295;\n                    }\n                    if (thread_active_323303) {\n                        if (!inactive_323304) {\n                            double defunc_1_op_res_323296 = x_323294 + x_323295;\n                            \n                            x_323294 = defunc_1_op_res_323296;\n                        }\n                    }\n                }\n                if (sle32(wave_sizze_323258, skip_threads_323302)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_323303) {\n                    // write result\n                    {\n                        ((volatile __local\n                          double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                                              (int64_t) 8) +\n                                                      sext_i32_i64(local_tid_323256)] =\n                            x_323294;\n                        x_323295 = x_323294;\n                    }\n                }\n                if (sle32(wave_sizze_323258, skip_threads_323302)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_323302 *= 2;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // last thread of block 'i' writes its result to offset 'i'\n        {\n            if ((local_tid_323256 - squot32(local_tid_323256, 32) * 32) == 31 &&\n                ltid_in_bounds_323301) {\n                ((volatile __local\n                  double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                                      (int64_t) 8) +\n                                              sext_i32_i64(squot32(local_tid_323256,\n               ",
            "                                                    32))] =\n                    x_323294;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n        {\n            int32_t skip_threads_323305;\n            \n            // read input for in-block scan\n            {\n                if (squot32(local_tid_323256, 32) == 0 &&\n                    ltid_in_bounds_323301) {\n                    x_323299 = ((volatile __local\n                                 double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                                                     (int64_t) 8) +\n                                                             sext_i32_i64(local_tid_323256)];\n                    if ((local_tid_323256 - squot32(local_tid_323256, 32) *\n                         32) == 0) {\n                        x_323298 = x_323299;\n                    }\n                }\n            }\n            // in-block scan (hopefully no barriers needed)\n            {\n                skip_threads_323305 = 1;\n                while (slt32(skip_threads_323305, 32)) {\n                    bool thread_active_323306 = sle32(skip_threads_323305,\n                                                      local_tid_323256 -\n                                                      squot32(local_tid_323256,\n                                                              32) * 32) &&\n                         (squot32(local_tid_323256, 32) == 0 &&\n                          ltid_in_bounds_323301);\n                    \n                    if (thread_active_323306) {\n                        // read operands\n                        {\n                            x_323298 = ((volatile __local\n                                         double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                                                             (int64_t) 8) +\n                              ",
            "                                       (sext_i32_i64(local_tid_323256) -\n                                                                      sext_i32_i64(skip_threads_323305))];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_323307 = slt32(smod32((local_tid_323256 *\n                                                             32 + 32 - 1 + 1) *\n                                                            11 - 1 +\n                                                            segsizze_compact_323275 -\n                                                            boundary_323274,\n                                                            segsizze_compact_323275),\n                                                     (local_tid_323256 * 32 +\n                                                      32 - 1 + 1) * 11 - 1 -\n                                                     (((local_tid_323256 -\n                                                        skip_threads_323305) *\n                                                       32 + 32 - 1 + 1) * 11 -\n                                                      1));\n                        \n                        if (thread_active_323306 && inactive_323307) {\n                            x_323298 = x_323299;\n                        }\n                        if (thread_active_323306) {\n                            if (!inactive_323307) {\n                                double defunc_1_op_res_323300 = x_323298 +\n                                       x_323299;\n                                \n                                x_323298 = defunc_1_op_res_323300;\n                            }\n                        }\n                    }\n                    if (sle32(wave_sizze_323258, skip_threads_323305)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    if (thread_active_323306) {\n          ",
            "              // write result\n                        {\n                            ((volatile __local\n                              double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                                                  (int64_t) 8) +\n                                                          sext_i32_i64(local_tid_323256)] =\n                                x_323298;\n                            x_323299 = x_323298;\n                        }\n                    }\n                    if (sle32(wave_sizze_323258, skip_threads_323305)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    skip_threads_323305 *= 2;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        bool no_carry_in_323308 = squot32(local_tid_323256, 32) == 0 ||\n             !ltid_in_bounds_323301;\n        \n        // carry-in for every block except the first\n        {\n            // read operands\n            {\n                if (!no_carry_in_323308) {\n                    x_323295 = x_323294;\n                    x_323294 = ((__local\n                                 double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                                                     (int64_t) 8) +\n                                                             (sext_i32_i64(squot32(local_tid_323256,\n                                                                                   32)) -\n                                                              (int64_t) 1)];\n                }\n            }\n            // perform operation\n            {\n                bool inactive_323309 = slt32(smod32((local_tid_323256 + 1) *\n                                                    11 - 1 +\n                                                    segsizze_compact_323275 -\n                                                    boundary_323274,\n                                                    segsizz",
            "e_compact_323275),\n                                             (local_tid_323256 + 1) * 11 - 1 -\n                                             ((squot32(local_tid_323256, 32) *\n                                               32 - 1 + 1) * 11 - 1));\n                \n                if (!no_carry_in_323308) {\n                    if (inactive_323309) {\n                        x_323294 = x_323295;\n                    }\n                }\n                if (!no_carry_in_323308) {\n                    if (!inactive_323309) {\n                        double defunc_1_op_res_323296 = x_323294 + x_323295;\n                        \n                        x_323294 = defunc_1_op_res_323296;\n                    }\n                }\n            }\n            // write final result\n            {\n                if (!no_carry_in_323308) {\n                    ((__local\n                      double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                                          (int64_t) 8) +\n                                                  sext_i32_i64(local_tid_323256)] =\n                        x_323294;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // restore correct values for first block\n        {\n            if (squot32(local_tid_323256, 32) == 0 && ltid_in_bounds_323301) {\n                ((__local\n                  double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                                      (int64_t) 8) +\n                                              sext_i32_i64(local_tid_323256)] =\n                    x_323295;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (local_tid_323256 == 0) {\n            acc_323297 = ((__local\n                           double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                                               (int64_t) 8) +\n                                      ",
            "                 (segscan_group_sizze_309167 -\n                                                        (int64_t) 1)];\n        } else {\n            acc_323297 = ((__local\n                           double *) local_mem_323264)[squot64(byte_offsets_323260,\n                                                               (int64_t) 8) +\n                                                       (sext_i32_i64(local_tid_323256) -\n                                                        (int64_t) 1)];\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    double prefix_323310 = 0.0;\n    bool block_new_sgm_323311 = sgm_idx_323273 == (int64_t) 0;\n    \n    // Perform lookback\n    {\n        if (block_new_sgm_323311 && local_tid_323256 == 0) {\n            ((volatile __global\n              double *) incprefixes_mem_323253)[dynamic_id_323271] = acc_323297;\n            mem_fence_global();\n            ((volatile __global\n              int8_t *) status_flags_mem_323249)[dynamic_id_323271] =\n                (int8_t) 2;\n            acc_323297 = 0.0;\n        }\n        if (!block_new_sgm_323311 && slt32(local_tid_323256,\n                                           wave_sizze_323258)) {\n            if (local_tid_323256 == 0) {\n                if (boundary_323274 == sext_i64_i32(segscan_group_sizze_309167 *\n                    (int64_t) 11)) {\n                    ((volatile __global\n                      double *) aggregates_mem_323251)[dynamic_id_323271] =\n                        acc_323297;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_323249)[dynamic_id_323271] =\n                        (int8_t) 1;\n                } else {\n                    ((volatile __global\n                      double *) incprefixes_mem_323253)[dynamic_id_323271] =\n                        acc_323297;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_32324",
            "9)[dynamic_id_323271] =\n                        (int8_t) 2;\n                }\n                \n                int8_t tmp_323312;\n                \n                tmp_323312 = ((volatile __global\n                               int8_t *) status_flags_mem_323249)[dynamic_id_323271 -\n                                                                  (int64_t) 1];\n                ((volatile __local int8_t *) local_mem_323264)[(int64_t) 0] =\n                    tmp_323312;\n            }\n            mem_fence_local();\n            \n            int8_t status_323313;\n            \n            status_323313 = ((__local int8_t *) local_mem_323264)[(int64_t) 0];\n            if (status_323313 == (int8_t) 2) {\n                if (local_tid_323256 == 0) {\n                    prefix_323310 = ((volatile __global\n                                      double *) incprefixes_mem_323253)[dynamic_id_323271 -\n                                                                        (int64_t) 1];\n                }\n            } else {\n                int32_t readOffset_323314 = dynamic_id_323271 -\n                        sext_i32_i64(wave_sizze_323258);\n                \n                while (slt32(wave_sizze_323258 * -1, readOffset_323314)) {\n                    int32_t read_i_323315 = readOffset_323314 +\n                            local_tid_323256;\n                    double aggr_323316 = 0.0;\n                    int8_t flag_323317 = (int8_t) 0;\n                    \n                    if (sle32(0, read_i_323315)) {\n                        if (sle64(blockOff_323272 -\n                                  (sext_i32_i64(read_i_323315 + 1) *\n                                   segscan_group_sizze_309167 * (int64_t) 11 -\n                                   (int64_t) 1), sgm_idx_323273)) {\n                            flag_323317 = ((volatile __global\n                                            int8_t *) status_flags_mem_323249)[sext_i32_i64(read_i_323315)];\n                            if (flag_323317 =",
            "= (int8_t) 2) {\n                                aggr_323316 = ((volatile __global\n                                                double *) incprefixes_mem_323253)[sext_i32_i64(read_i_323315)];\n                            } else {\n                                if (flag_323317 == (int8_t) 1) {\n                                    aggr_323316 = ((volatile __global\n                                                    double *) aggregates_mem_323251)[sext_i32_i64(read_i_323315)];\n                                }\n                            }\n                        } else {\n                            flag_323317 = (int8_t) 2;\n                        }\n                    }\n                    ((__local\n                      double *) local_mem_323264)[squot64(warp_byte_offset_323262,\n                                                          (int64_t) 8) +\n                                                  sext_i32_i64(local_tid_323256)] =\n                        aggr_323316;\n                    ((__local\n                      int8_t *) local_mem_323264)[sext_i32_i64(local_tid_323256)] =\n                        flag_323317;\n                    flag_323317 = ((__local\n                                    int8_t *) local_mem_323264)[sext_i32_i64(wave_sizze_323258) -\n                                                                (int64_t) 1];\n                    if (slt8(flag_323317, (int8_t) 2)) {\n                        int8_t flg_x_323321;\n                        int8_t flg_y_323322;\n                        double x_323318;\n                        double x_323319;\n                        int32_t skip_threads_323323;\n                        \n                        // read input for in-block scan\n                        {\n                            flg_y_323322 = ((volatile __local\n                                             int8_t *) local_mem_323264)[sext_i32_i64(local_tid_323256)];\n                            x_323319 = ((volatile __local\n                           ",
            "              double *) local_mem_323264)[squot64(warp_byte_offset_323262,\n                                                                             (int64_t) 8) +\n                                                                     sext_i32_i64(local_tid_323256)];\n                            if ((local_tid_323256 - squot32(local_tid_323256,\n                                                            32) * 32) == 0) {\n                                x_323318 = x_323319;\n                                flg_x_323321 = flg_y_323322;\n                            }\n                        }\n                        // in-block scan (hopefully no barriers needed)\n                        {\n                            skip_threads_323323 = 1;\n                            while (slt32(skip_threads_323323, 32)) {\n                                if (sle32(skip_threads_323323,\n                                          local_tid_323256 -\n                                          squot32(local_tid_323256, 32) * 32)) {\n                                    // read operands\n                                    {\n                                        flg_x_323321 = ((volatile __local\n                                                         int8_t *) local_mem_323264)[sext_i32_i64(local_tid_323256) -\n                                                                                     sext_i32_i64(skip_threads_323323)];\n                                        x_323318 = ((volatile __local\n                                                     double *) local_mem_323264)[squot64(warp_byte_offset_323262,\n                                                                                         (int64_t) 8) +\n                                                                                 (sext_i32_i64(local_tid_323256) -\n                                                                                  sext_i32_i64(skip_threads_323323))];\n                                    }\n                ",
            "                    // perform operation\n                                    {\n                                        if (flg_y_323322 == (int8_t) 2 ||\n                                            flg_y_323322 == (int8_t) 0) {\n                                            flg_x_323321 = flg_y_323322;\n                                            x_323318 = x_323319;\n                                        } else {\n                                            double defunc_1_op_res_323320 =\n                                                   x_323318 + x_323319;\n                                            \n                                            x_323318 = defunc_1_op_res_323320;\n                                        }\n                                    }\n                                    // write result\n                                    {\n                                        ((volatile __local\n                                          int8_t *) local_mem_323264)[sext_i32_i64(local_tid_323256)] =\n                                            flg_x_323321;\n                                        flg_y_323322 = flg_x_323321;\n                                        ((volatile __local\n                                          double *) local_mem_323264)[squot64(warp_byte_offset_323262,\n                                                                              (int64_t) 8) +\n                                                                      sext_i32_i64(local_tid_323256)] =\n                                            x_323318;\n                                        x_323319 = x_323318;\n                                    }\n                                }\n                                skip_threads_323323 *= 2;\n                            }\n                        }\n                    }\n                    flag_323317 = ((__local\n                                    int8_t *) local_mem_323264)[sext_i32_i64(wave_sizze_323258) -\n                              ",
            "                                  (int64_t) 1];\n                    aggr_323316 = ((__local\n                                    double *) local_mem_323264)[squot64(warp_byte_offset_323262,\n                                                                        (int64_t) 8) +\n                                                                (sext_i32_i64(wave_sizze_323258) -\n                                                                 (int64_t) 1)];\n                    if (flag_323317 == (int8_t) 2) {\n                        readOffset_323314 = wave_sizze_323258 * -1;\n                    } else {\n                        if (flag_323317 == (int8_t) 1) {\n                            readOffset_323314 -= wave_sizze_323258;\n                        }\n                    }\n                    if (slt8((int8_t) 0, flag_323317)) {\n                        double x_323324 = aggr_323316;\n                        double x_323325 = prefix_323310;\n                        double defunc_1_op_res_323326 = x_323324 + x_323325;\n                        \n                        prefix_323310 = defunc_1_op_res_323326;\n                    }\n                    mem_fence_local();\n                }\n            }\n            if (local_tid_323256 == 0) {\n                if (boundary_323274 == sext_i64_i32(segscan_group_sizze_309167 *\n                    (int64_t) 11)) {\n                    double x_323327 = prefix_323310;\n                    double x_323328 = acc_323297;\n                    double defunc_1_op_res_323329 = x_323327 + x_323328;\n                    \n                    ((volatile __global\n                      double *) incprefixes_mem_323253)[dynamic_id_323271] =\n                        defunc_1_op_res_323329;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_323249)[dynamic_id_323271] =\n                        (int8_t) 2;\n                }\n                ((__local\n                  double *) local_m",
            "em_323264)[squot64(warp_byte_offset_323262,\n                                                      (int64_t) 8)] =\n                    prefix_323310;\n                acc_323297 = 0.0;\n            }\n        }\n        if (!(dynamic_id_323271 == (int64_t) 0)) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            prefix_323310 = ((__local\n                              double *) local_mem_323264)[squot64(warp_byte_offset_323262,\n                                                                  (int64_t) 8)];\n            barrier(CLK_LOCAL_MEM_FENCE);\n        }\n    }\n    // Distribute results\n    {\n        double x_323330;\n        double x_323331;\n        double x_323333 = prefix_323310;\n        double x_323334 = acc_323297;\n        \n        if (slt32(local_tid_323256 * 11, boundary_323274) &&\n            !block_new_sgm_323311) {\n            double defunc_1_op_res_323335 = x_323333 + x_323334;\n            \n            x_323330 = defunc_1_op_res_323335;\n        } else {\n            x_323330 = acc_323297;\n        }\n        \n        int32_t stopping_point_323336 = segsizze_compact_323275 -\n                srem32(local_tid_323256 * 11 - 1 + segsizze_compact_323275 -\n                       boundary_323274, segsizze_compact_323275);\n        \n        for (int64_t i_323337 = 0; i_323337 < (int64_t) 11; i_323337++) {\n            if (slt32(sext_i64_i32(i_323337), stopping_point_323336 - 1)) {\n                x_323331 = private_mem_323276[i_323337];\n                \n                double defunc_1_op_res_323332 = x_323330 + x_323331;\n                \n                private_mem_323276[i_323337] = defunc_1_op_res_323332;\n            }\n        }\n    }\n    // Transpose scan output and Write it to global memory in coalesced fashion\n    {\n        for (int64_t i_323338 = 0; i_323338 < (int64_t) 11; i_323338++) {\n            int64_t sharedIdx_323339 = sext_i32_i64(local_tid_323256 * 11) +\n                    i_323338;\n            double tmp_323340;\n            \n            tmp_323340 = pri",
            "vate_mem_323276[i_323338];\n            ((__local double *) local_mem_323264)[sharedIdx_323339] =\n                tmp_323340;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_323341 = 0; i_323341 < (int64_t) 11; i_323341++) {\n            int64_t flat_idx_323342 = blockOff_323272 +\n                    segscan_group_sizze_309167 * i_323341 +\n                    sext_i32_i64(local_tid_323256);\n            int64_t slice_323343 = n_292675;\n            int64_t slice_323344 = partition_sizze_292766 * slice_323343;\n            int64_t gtid_309171 = squot64(flat_idx_323342, slice_323343);\n            int64_t remnant_323345 = flat_idx_323342 - gtid_309171 *\n                    slice_323343;\n            int64_t gtid_309172 = remnant_323345;\n            int64_t remnant_323346 = remnant_323345 - gtid_309172;\n            \n            if (slt64(flat_idx_323342, partition_sizze_292766 * n_292675)) {\n                double tmp_323347;\n                \n                tmp_323347 = ((__local\n                               double *) local_mem_323264)[flat_idx_323342 -\n                                                           blockOff_323272];\n                ((__global double *) mem_319555)[gtid_309171 * n_292675 +\n                                                 gtid_309172] = tmp_323347;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // If this is the last block, reset the dynamicId\n    {\n        if (dynamic_id_323271 == sdiv_up64(partition_sizze_292766 * n_292675,\n                                           segscan_group_sizze_309167 *\n                                           (int64_t) 11) - (int64_t) 1) {\n            ((__global int32_t *) mainziid_counter_mem_323247)[(int64_t) 0] = 0;\n        }\n    }\n    \n  error_0:\n    return;\n    #undef segscan_group_sizze_309167\n}\n__kernel void mainzisegscan_316886(__global int *global_failure,\n                                   uint local_mem_325190_backing_offset_0,\n                              ",
            "     int64_t partition_sizze_292766, __global\n                                   unsigned char *mem_param_320215, __global\n                                   unsigned char *mem_320262, __global\n                                   unsigned char *mainziid_counter_mem_325173,\n                                   __global\n                                   unsigned char *status_flags_mem_325175,\n                                   __global\n                                   unsigned char *aggregates_mem_325177,\n                                   __global\n                                   unsigned char *incprefixes_mem_325179)\n{\n    #define segscan_group_sizze_316881 (mainzisegscan_group_sizze_316880)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *local_mem_325190_backing_0 =\n                           &shared_mem[local_mem_325190_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325181;\n    int32_t local_tid_325182;\n    int64_t group_sizze_325185;\n    int32_t wave_sizze_325184;\n    int32_t group_tid_325183;\n    \n    global_tid_325181 = get_global_id(0);\n    local_tid_325182 = get_local_id(0);\n    group_sizze_325185 = get_local_size(0);\n    wave_sizze_325184 = LOCKSTEP_WIDTH;\n    group_tid_325183 = get_group_id(0);\n    \n    int32_t phys_tid_316886 = global_tid_325181;\n    int64_t byte_offsets_325186 = (int64_t) 0;\n    int64_t byte_offsets_325187 = segscan_group_sizze_316881 * (int64_t) 4;\n    int64_t warp_byte_offset_325188 = (int64_t) 32;\n    int64_t warp_byte_offset_325189 = (int64_t) 160;\n    \n    // Allocate reused shared memeory\n    { }\n    \n    __local unsigned char *local_mem_325190;\n    \n    local_mem_325190 = (__local unsigned char *) local_mem_325190_backing_0;\n    \n    int64_t trans_arr_len_325191 = (int64_t) 23 * segscan_group_sizze_316881;\n    int32_t dynamic_id_325197;\n    \n    if (local_tid_325182 == 0) {\n        dynamic_id_325197 = atom",
            "ic_add_i32_global(&((volatile __global\n                                                     int *) mainziid_counter_mem_325173)[(int64_t) 0],\n                                                  (int) 1);\n        ((__local int32_t *) local_mem_325190)[(int64_t) 0] = dynamic_id_325197;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    dynamic_id_325197 = ((__local int32_t *) local_mem_325190)[(int64_t) 0];\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t blockOff_325198 = sext_i32_i64(dynamic_id_325197) * (int64_t) 23 *\n            segscan_group_sizze_316881;\n    int64_t sgm_idx_325199 = smod64(blockOff_325198, partition_sizze_292766);\n    int32_t boundary_325200 = sext_i64_i32(smin64((int64_t) 23 *\n                                                  segscan_group_sizze_316881,\n                                                  partition_sizze_292766 -\n                                                  sgm_idx_325199));\n    int32_t segsizze_compact_325201 = sext_i64_i32(smin64((int64_t) 23 *\n                                                          segscan_group_sizze_316881,\n                                                          partition_sizze_292766));\n    int32_t private_mem_325202[(int64_t) 23];\n    \n    // Load and map\n    {\n        for (int64_t i_325204 = 0; i_325204 < (int64_t) 23; i_325204++) {\n            int64_t phys_tid_325205 = blockOff_325198 +\n                    sext_i32_i64(local_tid_325182) + i_325204 *\n                    segscan_group_sizze_316881;\n            int64_t slice_325206 = partition_sizze_292766;\n            int64_t gtid_316885 = phys_tid_325205;\n            int64_t remnant_325207 = phys_tid_325205 - gtid_316885;\n            \n            if (slt64(phys_tid_325205, partition_sizze_292766)) {\n                int32_t x_297116;\n                \n                x_297116 = ((__global int32_t *) mem_param_320215)[gtid_316885];\n                private_mem_325202[i_325204] = x_297116;\n            } else {\n                private_mem_325202[i_325204] = 0;",
            "\n            }\n        }\n    }\n    // Transpose scan inputs\n    {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_325208 = 0; i_325208 < (int64_t) 23; i_325208++) {\n            int64_t sharedIdx_325209 = sext_i32_i64(local_tid_325182) +\n                    i_325208 * segscan_group_sizze_316881;\n            int32_t tmp_325210;\n            \n            tmp_325210 = private_mem_325202[i_325208];\n            ((__local int32_t *) local_mem_325190)[sharedIdx_325209] =\n                tmp_325210;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int32_t i_325211 = 0; i_325211 < 23; i_325211++) {\n            int32_t sharedIdx_325212 = local_tid_325182 * 23 + i_325211;\n            int32_t tmp_325213;\n            \n            tmp_325213 = ((__local\n                           int32_t *) local_mem_325190)[sext_i32_i64(sharedIdx_325212)];\n            private_mem_325202[sext_i32_i64(i_325211)] = tmp_325213;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // Per thread scan\n    {\n        int32_t gidx_325214 = local_tid_325182 * 23 + 1;\n        \n        for (int64_t i_325215 = 0; i_325215 < (int64_t) 22; i_325215++) {\n            int32_t x_297113;\n            int32_t x_297114;\n            \n            x_297113 = private_mem_325202[i_325215];\n            x_297114 = private_mem_325202[i_325215 + (int64_t) 1];\n            \n            int32_t defunc_1_op_res_297115 = add32(x_297113, x_297114);\n            \n            private_mem_325202[i_325215 + (int64_t) 1] = defunc_1_op_res_297115;\n        }\n    }\n    // Publish results in shared memory\n    {\n        int32_t tmp_325216;\n        \n        tmp_325216 = private_mem_325202[(int64_t) 22];\n        ((__local int32_t *) local_mem_325190)[squot64(byte_offsets_325186,\n                                                       (int64_t) 4) +\n                                               sext_i32_i64(local_tid_325182)] =\n            tmp_325216;\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    int32_t acc_3252",
            "20;\n    \n    // Scan results (with warp scan)\n    {\n        int32_t x_325217;\n        int32_t x_325218;\n        int32_t x_325221;\n        int32_t x_325222;\n        bool ltid_in_bounds_325224 = slt64(sext_i32_i64(local_tid_325182),\n                                           segscan_group_sizze_316881);\n        int32_t skip_threads_325225;\n        \n        // read input for in-block scan\n        {\n            if (ltid_in_bounds_325224) {\n                x_325218 = ((volatile __local\n                             int32_t *) local_mem_325190)[squot64(byte_offsets_325186,\n                                                                  (int64_t) 4) +\n                                                          sext_i32_i64(local_tid_325182)];\n                if ((local_tid_325182 - squot32(local_tid_325182, 32) * 32) ==\n                    0) {\n                    x_325217 = x_325218;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_325225 = 1;\n            while (slt32(skip_threads_325225, 32)) {\n                bool thread_active_325226 = sle32(skip_threads_325225,\n                                                  local_tid_325182 -\n                                                  squot32(local_tid_325182,\n                                                          32) * 32) &&\n                     ltid_in_bounds_325224;\n                \n                if (thread_active_325226) {\n                    // read operands\n                    {\n                        x_325217 = ((volatile __local\n                                     int32_t *) local_mem_325190)[squot64(byte_offsets_325186,\n                                                                          (int64_t) 4) +\n                                                                  (sext_i32_i64(local_tid_325182) -\n                                                                   sext_i32_i64(skip_threads_325225))];\n                   ",
            " }\n                }\n                // perform operation\n                {\n                    if (thread_active_325226) {\n                        int32_t defunc_1_op_res_325219 = add32(x_325217,\n                                                               x_325218);\n                        \n                        x_325217 = defunc_1_op_res_325219;\n                    }\n                }\n                if (sle32(wave_sizze_325184, skip_threads_325225)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_325226) {\n                    // write result\n                    {\n                        ((volatile __local\n                          int32_t *) local_mem_325190)[squot64(byte_offsets_325186,\n                                                               (int64_t) 4) +\n                                                       sext_i32_i64(local_tid_325182)] =\n                            x_325217;\n                        x_325218 = x_325217;\n                    }\n                }\n                if (sle32(wave_sizze_325184, skip_threads_325225)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_325225 *= 2;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // last thread of block 'i' writes its result to offset 'i'\n        {\n            if ((local_tid_325182 - squot32(local_tid_325182, 32) * 32) == 31 &&\n                ltid_in_bounds_325224) {\n                ((volatile __local\n                  int32_t *) local_mem_325190)[squot64(byte_offsets_325186,\n                                                       (int64_t) 4) +\n                                               sext_i32_i64(squot32(local_tid_325182,\n                                                                    32))] =\n                    x_325217;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // scan the first block, after which offset 'i' contains carry-in",
            " for block 'i+1'\n        {\n            int32_t skip_threads_325227;\n            \n            // read input for in-block scan\n            {\n                if (squot32(local_tid_325182, 32) == 0 &&\n                    ltid_in_bounds_325224) {\n                    x_325222 = ((volatile __local\n                                 int32_t *) local_mem_325190)[squot64(byte_offsets_325186,\n                                                                      (int64_t) 4) +\n                                                              sext_i32_i64(local_tid_325182)];\n                    if ((local_tid_325182 - squot32(local_tid_325182, 32) *\n                         32) == 0) {\n                        x_325221 = x_325222;\n                    }\n                }\n            }\n            // in-block scan (hopefully no barriers needed)\n            {\n                skip_threads_325227 = 1;\n                while (slt32(skip_threads_325227, 32)) {\n                    bool thread_active_325228 = sle32(skip_threads_325227,\n                                                      local_tid_325182 -\n                                                      squot32(local_tid_325182,\n                                                              32) * 32) &&\n                         (squot32(local_tid_325182, 32) == 0 &&\n                          ltid_in_bounds_325224);\n                    \n                    if (thread_active_325228) {\n                        // read operands\n                        {\n                            x_325221 = ((volatile __local\n                                         int32_t *) local_mem_325190)[squot64(byte_offsets_325186,\n                                                                              (int64_t) 4) +\n                                                                      (sext_i32_i64(local_tid_325182) -\n                                                                       sext_i32_i64(skip_threads_325227))];\n                        }\n            ",
            "        }\n                    // perform operation\n                    {\n                        if (thread_active_325228) {\n                            int32_t defunc_1_op_res_325223 = add32(x_325221,\n                                                                   x_325222);\n                            \n                            x_325221 = defunc_1_op_res_325223;\n                        }\n                    }\n                    if (sle32(wave_sizze_325184, skip_threads_325227)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    if (thread_active_325228) {\n                        // write result\n                        {\n                            ((volatile __local\n                              int32_t *) local_mem_325190)[squot64(byte_offsets_325186,\n                                                                   (int64_t) 4) +\n                                                           sext_i32_i64(local_tid_325182)] =\n                                x_325221;\n                            x_325222 = x_325221;\n                        }\n                    }\n                    if (sle32(wave_sizze_325184, skip_threads_325227)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    skip_threads_325227 *= 2;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        bool no_carry_in_325229 = squot32(local_tid_325182, 32) == 0 ||\n             !ltid_in_bounds_325224;\n        \n        // carry-in for every block except the first\n        {\n            // read operands\n            {\n                if (!no_carry_in_325229) {\n                    x_325218 = x_325217;\n                    x_325217 = ((__local\n                                 int32_t *) local_mem_325190)[squot64(byte_offsets_325186,\n                                                                      (int64_t) 4) +\n                                                           ",
            "   (sext_i32_i64(squot32(local_tid_325182,\n                                                                                    32)) -\n                                                               (int64_t) 1)];\n                }\n            }\n            // perform operation\n            {\n                if (!no_carry_in_325229) {\n                    int32_t defunc_1_op_res_325219 = add32(x_325217, x_325218);\n                    \n                    x_325217 = defunc_1_op_res_325219;\n                }\n            }\n            // write final result\n            {\n                if (!no_carry_in_325229) {\n                    ((__local\n                      int32_t *) local_mem_325190)[squot64(byte_offsets_325186,\n                                                           (int64_t) 4) +\n                                                   sext_i32_i64(local_tid_325182)] =\n                        x_325217;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // restore correct values for first block\n        {\n            if (squot32(local_tid_325182, 32) == 0 && ltid_in_bounds_325224) {\n                ((__local\n                  int32_t *) local_mem_325190)[squot64(byte_offsets_325186,\n                                                       (int64_t) 4) +\n                                               sext_i32_i64(local_tid_325182)] =\n                    x_325218;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (local_tid_325182 == 0) {\n            acc_325220 = ((__local\n                           int32_t *) local_mem_325190)[squot64(byte_offsets_325186,\n                                                                (int64_t) 4) +\n                                                        (segscan_group_sizze_316881 -\n                                                         (int64_t) 1)];\n        } else {\n            acc_325220 = ((__local\n                           int32_t *",
            ") local_mem_325190)[squot64(byte_offsets_325186,\n                                                                (int64_t) 4) +\n                                                        (sext_i32_i64(local_tid_325182) -\n                                                         (int64_t) 1)];\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    int32_t prefix_325230 = 0;\n    bool block_new_sgm_325231 = sgm_idx_325199 == (int64_t) 0;\n    \n    // Perform lookback\n    {\n        if (block_new_sgm_325231 && local_tid_325182 == 0) {\n            ((volatile __global\n              int32_t *) incprefixes_mem_325179)[dynamic_id_325197] =\n                acc_325220;\n            mem_fence_global();\n            ((volatile __global\n              int8_t *) status_flags_mem_325175)[dynamic_id_325197] =\n                (int8_t) 2;\n            acc_325220 = 0;\n        }\n        if (!block_new_sgm_325231 && slt32(local_tid_325182,\n                                           wave_sizze_325184)) {\n            if (local_tid_325182 == 0) {\n                ((volatile __global\n                  int32_t *) aggregates_mem_325177)[dynamic_id_325197] =\n                    acc_325220;\n                mem_fence_global();\n                ((volatile __global\n                  int8_t *) status_flags_mem_325175)[dynamic_id_325197] =\n                    (int8_t) 1;\n                \n                int8_t tmp_325232;\n                \n                tmp_325232 = ((volatile __global\n                               int8_t *) status_flags_mem_325175)[dynamic_id_325197 -\n                                                                  (int64_t) 1];\n                ((volatile __local int8_t *) local_mem_325190)[(int64_t) 0] =\n                    tmp_325232;\n            }\n            mem_fence_local();\n            \n            int8_t status_325233;\n            \n            status_325233 = ((__local int8_t *) local_mem_325190)[(int64_t) 0];\n            if (status_325233 == (int8_t) 2) {\n                if ",
            "(local_tid_325182 == 0) {\n                    prefix_325230 = ((volatile __global\n                                      int32_t *) incprefixes_mem_325179)[dynamic_id_325197 -\n                                                                         (int64_t) 1];\n                }\n            } else {\n                int32_t readOffset_325234 = dynamic_id_325197 -\n                        sext_i32_i64(wave_sizze_325184);\n                \n                while (slt32(wave_sizze_325184 * -1, readOffset_325234)) {\n                    int32_t read_i_325235 = readOffset_325234 +\n                            local_tid_325182;\n                    int32_t aggr_325236 = 0;\n                    int8_t flag_325237 = (int8_t) 0;\n                    \n                    if (sle32(0, read_i_325235)) {\n                        flag_325237 = ((volatile __global\n                                        int8_t *) status_flags_mem_325175)[sext_i32_i64(read_i_325235)];\n                        if (flag_325237 == (int8_t) 2) {\n                            aggr_325236 = ((volatile __global\n                                            int32_t *) incprefixes_mem_325179)[sext_i32_i64(read_i_325235)];\n                        } else {\n                            if (flag_325237 == (int8_t) 1) {\n                                aggr_325236 = ((volatile __global\n                                                int32_t *) aggregates_mem_325177)[sext_i32_i64(read_i_325235)];\n                            }\n                        }\n                    }\n                    ((__local\n                      int32_t *) local_mem_325190)[squot64(warp_byte_offset_325188,\n                                                           (int64_t) 4) +\n                                                   sext_i32_i64(local_tid_325182)] =\n                        aggr_325236;\n                    ((__local\n                      int8_t *) local_mem_325190)[sext_i32_i64(local_tid_325182)] =\n                        flag_325237;\n    ",
            "                flag_325237 = ((__local\n                                    int8_t *) local_mem_325190)[sext_i32_i64(wave_sizze_325184) -\n                                                                (int64_t) 1];\n                    if (slt8(flag_325237, (int8_t) 2)) {\n                        int8_t flg_x_325241;\n                        int8_t flg_y_325242;\n                        int32_t x_325238;\n                        int32_t x_325239;\n                        int32_t skip_threads_325243;\n                        \n                        // read input for in-block scan\n                        {\n                            flg_y_325242 = ((volatile __local\n                                             int8_t *) local_mem_325190)[sext_i32_i64(local_tid_325182)];\n                            x_325239 = ((volatile __local\n                                         int32_t *) local_mem_325190)[squot64(warp_byte_offset_325188,\n                                                                              (int64_t) 4) +\n                                                                      sext_i32_i64(local_tid_325182)];\n                            if ((local_tid_325182 - squot32(local_tid_325182,\n                                                            32) * 32) == 0) {\n                                x_325238 = x_325239;\n                                flg_x_325241 = flg_y_325242;\n                            }\n                        }\n                        // in-block scan (hopefully no barriers needed)\n                        {\n                            skip_threads_325243 = 1;\n                            while (slt32(skip_threads_325243, 32)) {\n                                if (sle32(skip_threads_325243,\n                                          local_tid_325182 -\n                                          squot32(local_tid_325182, 32) * 32)) {\n                                    // read operands\n                                    {\n                          ",
            "              flg_x_325241 = ((volatile __local\n                                                         int8_t *) local_mem_325190)[sext_i32_i64(local_tid_325182) -\n                                                                                     sext_i32_i64(skip_threads_325243)];\n                                        x_325238 = ((volatile __local\n                                                     int32_t *) local_mem_325190)[squot64(warp_byte_offset_325188,\n                                                                                          (int64_t) 4) +\n                                                                                  (sext_i32_i64(local_tid_325182) -\n                                                                                   sext_i32_i64(skip_threads_325243))];\n                                    }\n                                    // perform operation\n                                    {\n                                        if (flg_y_325242 == (int8_t) 2 ||\n                                            flg_y_325242 == (int8_t) 0) {\n                                            flg_x_325241 = flg_y_325242;\n                                            x_325238 = x_325239;\n                                        } else {\n                                            int32_t defunc_1_op_res_325240 =\n                                                    add32(x_325238, x_325239);\n                                            \n                                            x_325238 = defunc_1_op_res_325240;\n                                        }\n                                    }\n                                    // write result\n                                    {\n                                        ((volatile __local\n                                          int8_t *) local_mem_325190)[sext_i32_i64(local_tid_325182)] =\n                                            flg_x_325241;\n                                        flg_y_32",
            "5242 = flg_x_325241;\n                                        ((volatile __local\n                                          int32_t *) local_mem_325190)[squot64(warp_byte_offset_325188,\n                                                                               (int64_t) 4) +\n                                                                       sext_i32_i64(local_tid_325182)] =\n                                            x_325238;\n                                        x_325239 = x_325238;\n                                    }\n                                }\n                                skip_threads_325243 *= 2;\n                            }\n                        }\n                    }\n                    flag_325237 = ((__local\n                                    int8_t *) local_mem_325190)[sext_i32_i64(wave_sizze_325184) -\n                                                                (int64_t) 1];\n                    aggr_325236 = ((__local\n                                    int32_t *) local_mem_325190)[squot64(warp_byte_offset_325188,\n                                                                         (int64_t) 4) +\n                                                                 (sext_i32_i64(wave_sizze_325184) -\n                                                                  (int64_t) 1)];\n                    if (flag_325237 == (int8_t) 2) {\n                        readOffset_325234 = wave_sizze_325184 * -1;\n                    } else {\n                        if (flag_325237 == (int8_t) 1) {\n                            readOffset_325234 -= wave_sizze_325184;\n                        }\n                    }\n                    if (slt8((int8_t) 0, flag_325237)) {\n                        int32_t x_325244 = aggr_325236;\n                        int32_t x_325245 = prefix_325230;\n                        int32_t defunc_1_op_res_325246 = add32(x_325244,\n                                                               x_325245);\n                      ",
            "  \n                        prefix_325230 = defunc_1_op_res_325246;\n                    }\n                    mem_fence_local();\n                }\n            }\n            if (local_tid_325182 == 0) {\n                if (boundary_325200 == sext_i64_i32(segscan_group_sizze_316881 *\n                    (int64_t) 23)) {\n                    int32_t x_325247 = prefix_325230;\n                    int32_t x_325248 = acc_325220;\n                    int32_t defunc_1_op_res_325249 = add32(x_325247, x_325248);\n                    \n                    ((volatile __global\n                      int32_t *) incprefixes_mem_325179)[dynamic_id_325197] =\n                        defunc_1_op_res_325249;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_325175)[dynamic_id_325197] =\n                        (int8_t) 2;\n                }\n                ((__local\n                  int32_t *) local_mem_325190)[squot64(warp_byte_offset_325188,\n                                                       (int64_t) 4)] =\n                    prefix_325230;\n                acc_325220 = 0;\n            }\n        }\n        if (!(dynamic_id_325197 == (int64_t) 0)) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            prefix_325230 = ((__local\n                              int32_t *) local_mem_325190)[squot64(warp_byte_offset_325188,\n                                                                   (int64_t) 4)];\n            barrier(CLK_LOCAL_MEM_FENCE);\n        }\n    }\n    // Distribute results\n    {\n        int32_t x_325250;\n        int32_t x_325251;\n        int32_t x_325253 = prefix_325230;\n        int32_t x_325254 = acc_325220;\n        \n        if (slt32(local_tid_325182 * 23, boundary_325200) &&\n            !block_new_sgm_325231) {\n            int32_t defunc_1_op_res_325255 = add32(x_325253, x_325254);\n            \n            x_325250 = defunc_1_op_res_325255;\n        } else {\n            x_325250 = acc_325220;\n        }\n",
            "        \n        int32_t stopping_point_325256 = segsizze_compact_325201 -\n                srem32(local_tid_325182 * 23 - 1 + segsizze_compact_325201 -\n                       boundary_325200, segsizze_compact_325201);\n        \n        for (int64_t i_325257 = 0; i_325257 < (int64_t) 23; i_325257++) {\n            if (slt32(sext_i64_i32(i_325257), stopping_point_325256 - 1)) {\n                x_325251 = private_mem_325202[i_325257];\n                \n                int32_t defunc_1_op_res_325252 = add32(x_325250, x_325251);\n                \n                private_mem_325202[i_325257] = defunc_1_op_res_325252;\n            }\n        }\n    }\n    // Transpose scan output and Write it to global memory in coalesced fashion\n    {\n        for (int64_t i_325258 = 0; i_325258 < (int64_t) 23; i_325258++) {\n            int64_t sharedIdx_325259 = sext_i32_i64(local_tid_325182 * 23) +\n                    i_325258;\n            int32_t tmp_325260;\n            \n            tmp_325260 = private_mem_325202[i_325258];\n            ((__local int32_t *) local_mem_325190)[sharedIdx_325259] =\n                tmp_325260;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_325261 = 0; i_325261 < (int64_t) 23; i_325261++) {\n            int64_t flat_idx_325262 = blockOff_325198 +\n                    segscan_group_sizze_316881 * i_325261 +\n                    sext_i32_i64(local_tid_325182);\n            int64_t slice_325263 = partition_sizze_292766;\n            int64_t gtid_316885 = flat_idx_325262;\n            int64_t remnant_325264 = flat_idx_325262 - gtid_316885;\n            \n            if (slt64(flat_idx_325262, partition_sizze_292766)) {\n                int32_t tmp_325265;\n                \n                tmp_325265 = ((__local\n                               int32_t *) local_mem_325190)[flat_idx_325262 -\n                                                            blockOff_325198];\n                ((__global int32_t *) mem_320262)[gtid_316885] = tmp_325265;\n            }\n   ",
            "     }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // If this is the last block, reset the dynamicId\n    {\n        if (dynamic_id_325197 == sdiv_up64(partition_sizze_292766,\n                                           segscan_group_sizze_316881 *\n                                           (int64_t) 23) - (int64_t) 1) {\n            ((__global int32_t *) mainziid_counter_mem_325173)[(int64_t) 0] = 0;\n        }\n    }\n    \n  error_0:\n    return;\n    #undef segscan_group_sizze_316881\n}\n__kernel void mainzisegscan_317116(__global int *global_failure,\n                                   uint local_mem_325472_backing_offset_0,\n                                   int64_t loopz2089U_297094, __global\n                                   unsigned char *mem_320289, __global\n                                   unsigned char *mem_320293, __global\n                                   unsigned char *mainziid_counter_mem_325455,\n                                   __global\n                                   unsigned char *status_flags_mem_325457,\n                                   __global\n                                   unsigned char *aggregates_mem_325459,\n                                   __global\n                                   unsigned char *incprefixes_mem_325461)\n{\n    #define segscan_group_sizze_317111 (mainzisegscan_group_sizze_317110)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *local_mem_325472_backing_0 =\n                           &shared_mem[local_mem_325472_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_325463;\n    int32_t local_tid_325464;\n    int64_t group_sizze_325467;\n    int32_t wave_sizze_325466;\n    int32_t group_tid_325465;\n    \n    global_tid_325463 = get_global_id(0);\n    local_tid_325464 = get_local_id(0);\n    group_sizze_325467 = get_local_size(0);\n    wave_sizze_325466 = LOCKSTEP_WIDTH;\n    group_tid_325465 = get_group_id(0);\n ",
            "   \n    int32_t phys_tid_317116 = global_tid_325463;\n    int64_t byte_offsets_325468 = (int64_t) 0;\n    int64_t byte_offsets_325469 = segscan_group_sizze_317111 * (int64_t) 4;\n    int64_t warp_byte_offset_325470 = (int64_t) 32;\n    int64_t warp_byte_offset_325471 = (int64_t) 160;\n    \n    // Allocate reused shared memeory\n    { }\n    \n    __local unsigned char *local_mem_325472;\n    \n    local_mem_325472 = (__local unsigned char *) local_mem_325472_backing_0;\n    \n    int64_t trans_arr_len_325473 = (int64_t) 23 * segscan_group_sizze_317111;\n    int32_t dynamic_id_325479;\n    \n    if (local_tid_325464 == 0) {\n        dynamic_id_325479 = atomic_add_i32_global(&((volatile __global\n                                                     int *) mainziid_counter_mem_325455)[(int64_t) 0],\n                                                  (int) 1);\n        ((__local int32_t *) local_mem_325472)[(int64_t) 0] = dynamic_id_325479;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    dynamic_id_325479 = ((__local int32_t *) local_mem_325472)[(int64_t) 0];\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t blockOff_325480 = sext_i32_i64(dynamic_id_325479) * (int64_t) 23 *\n            segscan_group_sizze_317111;\n    int64_t sgm_idx_325481 = smod64(blockOff_325480, loopz2089U_297094);\n    int32_t boundary_325482 = sext_i64_i32(smin64((int64_t) 23 *\n                                                  segscan_group_sizze_317111,\n                                                  loopz2089U_297094 -\n                                                  sgm_idx_325481));\n    int32_t segsizze_compact_325483 = sext_i64_i32(smin64((int64_t) 23 *\n                                                          segscan_group_sizze_317111,\n                                                          loopz2089U_297094));\n    int32_t private_mem_325484[(int64_t) 23];\n    \n    // Load and map\n    {\n        for (int64_t i_325486 = 0; i_325486 < (int64_t) 23; i_325486++) {\n            int64_t phys_tid_325487 = blockOff_3254",
            "80 +\n                    sext_i32_i64(local_tid_325464) + i_325486 *\n                    segscan_group_sizze_317111;\n            int64_t slice_325488 = loopz2089U_297094;\n            int64_t gtid_317115 = phys_tid_325487;\n            int64_t remnant_325489 = phys_tid_325487 - gtid_317115;\n            \n            if (slt64(phys_tid_325487, loopz2089U_297094)) {\n                bool x_297242;\n                \n                x_297242 = ((__global bool *) mem_320289)[gtid_317115];\n                \n                int32_t defunc_0_f_res_297243 = btoi_bool_i32(x_297242);\n                \n                private_mem_325484[i_325486] = defunc_0_f_res_297243;\n            } else {\n                private_mem_325484[i_325486] = 0;\n            }\n        }\n    }\n    // Transpose scan inputs\n    {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_325490 = 0; i_325490 < (int64_t) 23; i_325490++) {\n            int64_t sharedIdx_325491 = sext_i32_i64(local_tid_325464) +\n                    i_325490 * segscan_group_sizze_317111;\n            int32_t tmp_325492;\n            \n            tmp_325492 = private_mem_325484[i_325490];\n            ((__local int32_t *) local_mem_325472)[sharedIdx_325491] =\n                tmp_325492;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int32_t i_325493 = 0; i_325493 < 23; i_325493++) {\n            int32_t sharedIdx_325494 = local_tid_325464 * 23 + i_325493;\n            int32_t tmp_325495;\n            \n            tmp_325495 = ((__local\n                           int32_t *) local_mem_325472)[sext_i32_i64(sharedIdx_325494)];\n            private_mem_325484[sext_i32_i64(i_325493)] = tmp_325495;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // Per thread scan\n    {\n        int32_t gidx_325496 = local_tid_325464 * 23 + 1;\n        \n        for (int64_t i_325497 = 0; i_325497 < (int64_t) 22; i_325497++) {\n            int32_t x_297239;\n            int32_t x_297240;\n            \n            x_297239 = private_mem_325484[",
            "i_325497];\n            x_297240 = private_mem_325484[i_325497 + (int64_t) 1];\n            \n            int32_t defunc_1_op_res_297241 = add32(x_297239, x_297240);\n            \n            private_mem_325484[i_325497 + (int64_t) 1] = defunc_1_op_res_297241;\n        }\n    }\n    // Publish results in shared memory\n    {\n        int32_t tmp_325498;\n        \n        tmp_325498 = private_mem_325484[(int64_t) 22];\n        ((__local int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                                       (int64_t) 4) +\n                                               sext_i32_i64(local_tid_325464)] =\n            tmp_325498;\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    int32_t acc_325502;\n    \n    // Scan results (with warp scan)\n    {\n        int32_t x_325499;\n        int32_t x_325500;\n        int32_t x_325503;\n        int32_t x_325504;\n        bool ltid_in_bounds_325506 = slt64(sext_i32_i64(local_tid_325464),\n                                           segscan_group_sizze_317111);\n        int32_t skip_threads_325507;\n        \n        // read input for in-block scan\n        {\n            if (ltid_in_bounds_325506) {\n                x_325500 = ((volatile __local\n                             int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                                                  (int64_t) 4) +\n                                                          sext_i32_i64(local_tid_325464)];\n                if ((local_tid_325464 - squot32(local_tid_325464, 32) * 32) ==\n                    0) {\n                    x_325499 = x_325500;\n                }\n            }\n        }\n        // in-block scan (hopefully no barriers needed)\n        {\n            skip_threads_325507 = 1;\n            while (slt32(skip_threads_325507, 32)) {\n                bool thread_active_325508 = sle32(skip_threads_325507,\n                                                  local_tid_325464 -\n                                         ",
            "         squot32(local_tid_325464,\n                                                          32) * 32) &&\n                     ltid_in_bounds_325506;\n                \n                if (thread_active_325508) {\n                    // read operands\n                    {\n                        x_325499 = ((volatile __local\n                                     int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                                                          (int64_t) 4) +\n                                                                  (sext_i32_i64(local_tid_325464) -\n                                                                   sext_i32_i64(skip_threads_325507))];\n                    }\n                }\n                // perform operation\n                {\n                    if (thread_active_325508) {\n                        int32_t defunc_1_op_res_325501 = add32(x_325499,\n                                                               x_325500);\n                        \n                        x_325499 = defunc_1_op_res_325501;\n                    }\n                }\n                if (sle32(wave_sizze_325466, skip_threads_325507)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                if (thread_active_325508) {\n                    // write result\n                    {\n                        ((volatile __local\n                          int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                                               (int64_t) 4) +\n                                                       sext_i32_i64(local_tid_325464)] =\n                            x_325499;\n                        x_325500 = x_325499;\n                    }\n                }\n                if (sle32(wave_sizze_325466, skip_threads_325507)) {\n                    barrier(CLK_LOCAL_MEM_FENCE);\n                }\n                skip_threads_325507 *= 2;\n            }\n        }\n        barrier",
            "(CLK_LOCAL_MEM_FENCE);\n        // last thread of block 'i' writes its result to offset 'i'\n        {\n            if ((local_tid_325464 - squot32(local_tid_325464, 32) * 32) == 31 &&\n                ltid_in_bounds_325506) {\n                ((volatile __local\n                  int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                                       (int64_t) 4) +\n                                               sext_i32_i64(squot32(local_tid_325464,\n                                                                    32))] =\n                    x_325499;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n        {\n            int32_t skip_threads_325509;\n            \n            // read input for in-block scan\n            {\n                if (squot32(local_tid_325464, 32) == 0 &&\n                    ltid_in_bounds_325506) {\n                    x_325504 = ((volatile __local\n                                 int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                                                      (int64_t) 4) +\n                                                              sext_i32_i64(local_tid_325464)];\n                    if ((local_tid_325464 - squot32(local_tid_325464, 32) *\n                         32) == 0) {\n                        x_325503 = x_325504;\n                    }\n                }\n            }\n            // in-block scan (hopefully no barriers needed)\n            {\n                skip_threads_325509 = 1;\n                while (slt32(skip_threads_325509, 32)) {\n                    bool thread_active_325510 = sle32(skip_threads_325509,\n                                                      local_tid_325464 -\n                                                      squot32(local_tid_325464,\n                                                              32) * 32) &&\n                   ",
            "      (squot32(local_tid_325464, 32) == 0 &&\n                          ltid_in_bounds_325506);\n                    \n                    if (thread_active_325510) {\n                        // read operands\n                        {\n                            x_325503 = ((volatile __local\n                                         int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                                                              (int64_t) 4) +\n                                                                      (sext_i32_i64(local_tid_325464) -\n                                                                       sext_i32_i64(skip_threads_325509))];\n                        }\n                    }\n                    // perform operation\n                    {\n                        if (thread_active_325510) {\n                            int32_t defunc_1_op_res_325505 = add32(x_325503,\n                                                                   x_325504);\n                            \n                            x_325503 = defunc_1_op_res_325505;\n                        }\n                    }\n                    if (sle32(wave_sizze_325466, skip_threads_325509)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                    }\n                    if (thread_active_325510) {\n                        // write result\n                        {\n                            ((volatile __local\n                              int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                                                   (int64_t) 4) +\n                                                           sext_i32_i64(local_tid_325464)] =\n                                x_325503;\n                            x_325504 = x_325503;\n                        }\n                    }\n                    if (sle32(wave_sizze_325466, skip_threads_325509)) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n          ",
            "          }\n                    skip_threads_325509 *= 2;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        bool no_carry_in_325511 = squot32(local_tid_325464, 32) == 0 ||\n             !ltid_in_bounds_325506;\n        \n        // carry-in for every block except the first\n        {\n            // read operands\n            {\n                if (!no_carry_in_325511) {\n                    x_325500 = x_325499;\n                    x_325499 = ((__local\n                                 int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                                                      (int64_t) 4) +\n                                                              (sext_i32_i64(squot32(local_tid_325464,\n                                                                                    32)) -\n                                                               (int64_t) 1)];\n                }\n            }\n            // perform operation\n            {\n                if (!no_carry_in_325511) {\n                    int32_t defunc_1_op_res_325501 = add32(x_325499, x_325500);\n                    \n                    x_325499 = defunc_1_op_res_325501;\n                }\n            }\n            // write final result\n            {\n                if (!no_carry_in_325511) {\n                    ((__local\n                      int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                                           (int64_t) 4) +\n                                                   sext_i32_i64(local_tid_325464)] =\n                        x_325499;\n                }\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // restore correct values for first block\n        {\n            if (squot32(local_tid_325464, 32) == 0 && ltid_in_bounds_325506) {\n                ((__local\n                  int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                ",
            "                       (int64_t) 4) +\n                                               sext_i32_i64(local_tid_325464)] =\n                    x_325500;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (local_tid_325464 == 0) {\n            acc_325502 = ((__local\n                           int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                                                (int64_t) 4) +\n                                                        (segscan_group_sizze_317111 -\n                                                         (int64_t) 1)];\n        } else {\n            acc_325502 = ((__local\n                           int32_t *) local_mem_325472)[squot64(byte_offsets_325468,\n                                                                (int64_t) 4) +\n                                                        (sext_i32_i64(local_tid_325464) -\n                                                         (int64_t) 1)];\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    \n    int32_t prefix_325512 = 0;\n    bool block_new_sgm_325513 = sgm_idx_325481 == (int64_t) 0;\n    \n    // Perform lookback\n    {\n        if (block_new_sgm_325513 && local_tid_325464 == 0) {\n            ((volatile __global\n              int32_t *) incprefixes_mem_325461)[dynamic_id_325479] =\n                acc_325502;\n            mem_fence_global();\n            ((volatile __global\n              int8_t *) status_flags_mem_325457)[dynamic_id_325479] =\n                (int8_t) 2;\n            acc_325502 = 0;\n        }\n        if (!block_new_sgm_325513 && slt32(local_tid_325464,\n                                           wave_sizze_325466)) {\n            if (local_tid_325464 == 0) {\n                ((volatile __global\n                  int32_t *) aggregates_mem_325459)[dynamic_id_325479] =\n                    acc_325502;\n                mem_fence_global();\n                ((volatile __global\n                  in",
            "t8_t *) status_flags_mem_325457)[dynamic_id_325479] =\n                    (int8_t) 1;\n                \n                int8_t tmp_325514;\n                \n                tmp_325514 = ((volatile __global\n                               int8_t *) status_flags_mem_325457)[dynamic_id_325479 -\n                                                                  (int64_t) 1];\n                ((volatile __local int8_t *) local_mem_325472)[(int64_t) 0] =\n                    tmp_325514;\n            }\n            mem_fence_local();\n            \n            int8_t status_325515;\n            \n            status_325515 = ((__local int8_t *) local_mem_325472)[(int64_t) 0];\n            if (status_325515 == (int8_t) 2) {\n                if (local_tid_325464 == 0) {\n                    prefix_325512 = ((volatile __global\n                                      int32_t *) incprefixes_mem_325461)[dynamic_id_325479 -\n                                                                         (int64_t) 1];\n                }\n            } else {\n                int32_t readOffset_325516 = dynamic_id_325479 -\n                        sext_i32_i64(wave_sizze_325466);\n                \n                while (slt32(wave_sizze_325466 * -1, readOffset_325516)) {\n                    int32_t read_i_325517 = readOffset_325516 +\n                            local_tid_325464;\n                    int32_t aggr_325518 = 0;\n                    int8_t flag_325519 = (int8_t) 0;\n                    \n                    if (sle32(0, read_i_325517)) {\n                        flag_325519 = ((volatile __global\n                                        int8_t *) status_flags_mem_325457)[sext_i32_i64(read_i_325517)];\n                        if (flag_325519 == (int8_t) 2) {\n                            aggr_325518 = ((volatile __global\n                                            int32_t *) incprefixes_mem_325461)[sext_i32_i64(read_i_325517)];\n                        } else {\n                            if (flag_325519 == (int",
            "8_t) 1) {\n                                aggr_325518 = ((volatile __global\n                                                int32_t *) aggregates_mem_325459)[sext_i32_i64(read_i_325517)];\n                            }\n                        }\n                    }\n                    ((__local\n                      int32_t *) local_mem_325472)[squot64(warp_byte_offset_325470,\n                                                           (int64_t) 4) +\n                                                   sext_i32_i64(local_tid_325464)] =\n                        aggr_325518;\n                    ((__local\n                      int8_t *) local_mem_325472)[sext_i32_i64(local_tid_325464)] =\n                        flag_325519;\n                    flag_325519 = ((__local\n                                    int8_t *) local_mem_325472)[sext_i32_i64(wave_sizze_325466) -\n                                                                (int64_t) 1];\n                    if (slt8(flag_325519, (int8_t) 2)) {\n                        int8_t flg_x_325523;\n                        int8_t flg_y_325524;\n                        int32_t x_325520;\n                        int32_t x_325521;\n                        int32_t skip_threads_325525;\n                        \n                        // read input for in-block scan\n                        {\n                            flg_y_325524 = ((volatile __local\n                                             int8_t *) local_mem_325472)[sext_i32_i64(local_tid_325464)];\n                            x_325521 = ((volatile __local\n                                         int32_t *) local_mem_325472)[squot64(warp_byte_offset_325470,\n                                                                              (int64_t) 4) +\n                                                                      sext_i32_i64(local_tid_325464)];\n                            if ((local_tid_325464 - squot32(local_tid_325464,\n                                                           ",
            " 32) * 32) == 0) {\n                                x_325520 = x_325521;\n                                flg_x_325523 = flg_y_325524;\n                            }\n                        }\n                        // in-block scan (hopefully no barriers needed)\n                        {\n                            skip_threads_325525 = 1;\n                            while (slt32(skip_threads_325525, 32)) {\n                                if (sle32(skip_threads_325525,\n                                          local_tid_325464 -\n                                          squot32(local_tid_325464, 32) * 32)) {\n                                    // read operands\n                                    {\n                                        flg_x_325523 = ((volatile __local\n                                                         int8_t *) local_mem_325472)[sext_i32_i64(local_tid_325464) -\n                                                                                     sext_i32_i64(skip_threads_325525)];\n                                        x_325520 = ((volatile __local\n                                                     int32_t *) local_mem_325472)[squot64(warp_byte_offset_325470,\n                                                                                          (int64_t) 4) +\n                                                                                  (sext_i32_i64(local_tid_325464) -\n                                                                                   sext_i32_i64(skip_threads_325525))];\n                                    }\n                                    // perform operation\n                                    {\n                                        if (flg_y_325524 == (int8_t) 2 ||\n                                            flg_y_325524 == (int8_t) 0) {\n                                            flg_x_325523 = flg_y_325524;\n                                            x_325520 = x_325521;\n                                     ",
            "   } else {\n                                            int32_t defunc_1_op_res_325522 =\n                                                    add32(x_325520, x_325521);\n                                            \n                                            x_325520 = defunc_1_op_res_325522;\n                                        }\n                                    }\n                                    // write result\n                                    {\n                                        ((volatile __local\n                                          int8_t *) local_mem_325472)[sext_i32_i64(local_tid_325464)] =\n                                            flg_x_325523;\n                                        flg_y_325524 = flg_x_325523;\n                                        ((volatile __local\n                                          int32_t *) local_mem_325472)[squot64(warp_byte_offset_325470,\n                                                                               (int64_t) 4) +\n                                                                       sext_i32_i64(local_tid_325464)] =\n                                            x_325520;\n                                        x_325521 = x_325520;\n                                    }\n                                }\n                                skip_threads_325525 *= 2;\n                            }\n                        }\n                    }\n                    flag_325519 = ((__local\n                                    int8_t *) local_mem_325472)[sext_i32_i64(wave_sizze_325466) -\n                                                                (int64_t) 1];\n                    aggr_325518 = ((__local\n                                    int32_t *) local_mem_325472)[squot64(warp_byte_offset_325470,\n                                                                         (int64_t) 4) +\n                                                                 (sext_i32_i64(wave_sizze_325466) -\n             ",
            "                                                     (int64_t) 1)];\n                    if (flag_325519 == (int8_t) 2) {\n                        readOffset_325516 = wave_sizze_325466 * -1;\n                    } else {\n                        if (flag_325519 == (int8_t) 1) {\n                            readOffset_325516 -= wave_sizze_325466;\n                        }\n                    }\n                    if (slt8((int8_t) 0, flag_325519)) {\n                        int32_t x_325526 = aggr_325518;\n                        int32_t x_325527 = prefix_325512;\n                        int32_t defunc_1_op_res_325528 = add32(x_325526,\n                                                               x_325527);\n                        \n                        prefix_325512 = defunc_1_op_res_325528;\n                    }\n                    mem_fence_local();\n                }\n            }\n            if (local_tid_325464 == 0) {\n                if (boundary_325482 == sext_i64_i32(segscan_group_sizze_317111 *\n                    (int64_t) 23)) {\n                    int32_t x_325529 = prefix_325512;\n                    int32_t x_325530 = acc_325502;\n                    int32_t defunc_1_op_res_325531 = add32(x_325529, x_325530);\n                    \n                    ((volatile __global\n                      int32_t *) incprefixes_mem_325461)[dynamic_id_325479] =\n                        defunc_1_op_res_325531;\n                    mem_fence_global();\n                    ((volatile __global\n                      int8_t *) status_flags_mem_325457)[dynamic_id_325479] =\n                        (int8_t) 2;\n                }\n                ((__local\n                  int32_t *) local_mem_325472)[squot64(warp_byte_offset_325470,\n                                                       (int64_t) 4)] =\n                    prefix_325512;\n                acc_325502 = 0;\n            }\n        }\n        if (!(dynamic_id_325479 == (int64_t) 0)) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n     ",
            "       prefix_325512 = ((__local\n                              int32_t *) local_mem_325472)[squot64(warp_byte_offset_325470,\n                                                                   (int64_t) 4)];\n            barrier(CLK_LOCAL_MEM_FENCE);\n        }\n    }\n    // Distribute results\n    {\n        int32_t x_325532;\n        int32_t x_325533;\n        int32_t x_325535 = prefix_325512;\n        int32_t x_325536 = acc_325502;\n        \n        if (slt32(local_tid_325464 * 23, boundary_325482) &&\n            !block_new_sgm_325513) {\n            int32_t defunc_1_op_res_325537 = add32(x_325535, x_325536);\n            \n            x_325532 = defunc_1_op_res_325537;\n        } else {\n            x_325532 = acc_325502;\n        }\n        \n        int32_t stopping_point_325538 = segsizze_compact_325483 -\n                srem32(local_tid_325464 * 23 - 1 + segsizze_compact_325483 -\n                       boundary_325482, segsizze_compact_325483);\n        \n        for (int64_t i_325539 = 0; i_325539 < (int64_t) 23; i_325539++) {\n            if (slt32(sext_i64_i32(i_325539), stopping_point_325538 - 1)) {\n                x_325533 = private_mem_325484[i_325539];\n                \n                int32_t defunc_1_op_res_325534 = add32(x_325532, x_325533);\n                \n                private_mem_325484[i_325539] = defunc_1_op_res_325534;\n            }\n        }\n    }\n    // Transpose scan output and Write it to global memory in coalesced fashion\n    {\n        for (int64_t i_325540 = 0; i_325540 < (int64_t) 23; i_325540++) {\n            int64_t sharedIdx_325541 = sext_i32_i64(local_tid_325464 * 23) +\n                    i_325540;\n            int32_t tmp_325542;\n            \n            tmp_325542 = private_mem_325484[i_325540];\n            ((__local int32_t *) local_mem_325472)[sharedIdx_325541] =\n                tmp_325542;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        for (int64_t i_325543 = 0; i_325543 < (int64_t) 23; i_325543++) {\n            int64_t flat_idx_325544 ",
            "= blockOff_325480 +\n                    segscan_group_sizze_317111 * i_325543 +\n                    sext_i32_i64(local_tid_325464);\n            int64_t slice_325545 = loopz2089U_297094;\n            int64_t gtid_317115 = flat_idx_325544;\n            int64_t remnant_325546 = flat_idx_325544 - gtid_317115;\n            \n            if (slt64(flat_idx_325544, loopz2089U_297094)) {\n                int32_t tmp_325547;\n                \n                tmp_325547 = ((__local\n                               int32_t *) local_mem_325472)[flat_idx_325544 -\n                                                            blockOff_325480];\n                ((__global int32_t *) mem_320293)[gtid_317115] = tmp_325547;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n    }\n    // If this is the last block, reset the dynamicId\n    {\n        if (dynamic_id_325479 == sdiv_up64(loopz2089U_297094,\n                                           segscan_group_sizze_317111 *\n                                           (int64_t) 23) - (int64_t) 1) {\n            ((__global int32_t *) mainziid_counter_mem_325455)[(int64_t) 0] = 0;\n        }\n    }\n    \n  error_0:\n    return;\n    #undef segscan_group_sizze_317111\n}\n__kernel void seasonal_amplitudezisegmap_297410(__global int *global_failure,\n                                                int64_t m_292609,\n                                                int64_t n_292610, __global\n                                                unsigned char *mem_318493,\n                                                __global\n                                                unsigned char *mem_318497)\n{\n    #define segmap_group_sizze_297406 (seasonal_amplitudezisegmap_group_sizze_297387)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_320825;\n    int32_t local_tid_320826;\n    int64_t group_sizze_320829;\n    int32_t wave_sizze_320828;\n    in",
            "t32_t group_tid_320827;\n    \n    global_tid_320825 = get_global_id(0);\n    local_tid_320826 = get_local_id(0);\n    group_sizze_320829 = get_local_size(0);\n    wave_sizze_320828 = LOCKSTEP_WIDTH;\n    group_tid_320827 = get_group_id(0);\n    \n    int32_t phys_tid_297410 = global_tid_320825;\n    int64_t global_tid_320830 = sext_i32_i64(group_tid_320827) *\n            segmap_group_sizze_297406 + sext_i32_i64(local_tid_320826);\n    int64_t slice_320831 = m_292609;\n    int64_t gtid_297409 = global_tid_320830;\n    int64_t remnant_320832 = global_tid_320830 - gtid_297409;\n    \n    if (slt64(gtid_297409, m_292609)) {\n        float defunc_2_reduce_res_297412;\n        float defunc_2_reduce_res_297413;\n        float redout_318436;\n        float redout_318437;\n        \n        redout_318436 = -INFINITY;\n        redout_318437 = INFINITY;\n        for (int64_t i_318438 = 0; i_318438 < n_292610; i_318438++) {\n            float x_297420;\n            \n            x_297420 = ((__global float *) mem_318493)[i_318438 * m_292609 +\n                                                       gtid_297409];\n            \n            float defunc_1_op_res_297416 = fmax32(x_297420, redout_318436);\n            float defunc_1_op_res_297419 = fmin32(x_297420, redout_318437);\n            float redout_tmp_320833 = defunc_1_op_res_297416;\n            float redout_tmp_320834 = defunc_1_op_res_297419;\n            \n            redout_318436 = redout_tmp_320833;\n            redout_318437 = redout_tmp_320834;\n        }\n        defunc_2_reduce_res_297412 = redout_318436;\n        defunc_2_reduce_res_297413 = redout_318437;\n        \n        float v_297421 = defunc_2_reduce_res_297412 -\n              defunc_2_reduce_res_297413;\n        bool isinf_res_297422;\n        \n        isinf_res_297422 = futrts_isinf32(v_297421);\n        \n        float defunc_0_f_res_297423;\n        \n        if (isinf_res_297422) {\n            defunc_0_f_res_297423 = NAN;\n        } else {\n            defunc_0_f_res_297423 = v_297421;\n        }",
            "\n        ((__global float *) mem_318497)[gtid_297409] = defunc_0_f_res_297423;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_297406\n}\n__kernel void seasonal_amplitudezisegmap_297483(__global int *global_failure,\n                                                int64_t m_292609, __global\n                                                unsigned char *mem_318501,\n                                                __global\n                                                unsigned char *mem_318504,\n                                                __global\n                                                unsigned char *mem_318508)\n{\n    #define segmap_group_sizze_297479 (seasonal_amplitudezisegmap_group_sizze_297429)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_320917;\n    int32_t local_tid_320918;\n    int64_t group_sizze_320921;\n    int32_t wave_sizze_320920;\n    int32_t group_tid_320919;\n    \n    global_tid_320917 = get_global_id(0);\n    local_tid_320918 = get_local_id(0);\n    group_sizze_320921 = get_local_size(0);\n    wave_sizze_320920 = LOCKSTEP_WIDTH;\n    group_tid_320919 = get_group_id(0);\n    \n    int32_t phys_tid_297483 = global_tid_320917;\n    int64_t global_tid_320922 = sext_i32_i64(group_tid_320919) *\n            segmap_group_sizze_297479 + sext_i32_i64(local_tid_320918);\n    int64_t slice_320923 = m_292609;\n    int64_t gtid_297482 = global_tid_320922;\n    int64_t remnant_320924 = global_tid_320922 - gtid_297482;\n    \n    if (slt64(gtid_297482, m_292609)) {\n        float defunc_2_reduce_res_297484;\n        \n        defunc_2_reduce_res_297484 = ((__global\n                                       float *) mem_318501)[gtid_297482];\n        \n        float defunc_2_reduce_res_297485;\n        \n        defunc_2_reduce_res_297485 = ((__global\n                                       float *) mem_318504)[gtid_297482];\n        \n        ",
            "float v_297486 = defunc_2_reduce_res_297484 -\n              defunc_2_reduce_res_297485;\n        bool isinf_res_297487;\n        \n        isinf_res_297487 = futrts_isinf32(v_297486);\n        \n        float defunc_0_f_res_297488;\n        \n        if (isinf_res_297487) {\n            defunc_0_f_res_297488 = NAN;\n        } else {\n            defunc_0_f_res_297488 = v_297486;\n        }\n        ((__global float *) mem_318508)[gtid_297482] = defunc_0_f_res_297488;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_297479\n}\n__kernel void seasonal_amplitudezisegred_large_297469(__global\n                                                      int *global_failure,\n                                                      uint sync_arr_mem_320888_backing_offset_0,\n                                                      uint red_arr_mem_320886_backing_offset_1,\n                                                      uint red_arr_mem_320884_backing_offset_2,\n                                                      int64_t m_292609,\n                                                      int64_t n_292610,\n                                                      int64_t num_groups_297463,\n                                                      int64_t groups_per_segment_320868,\n                                                      int64_t elements_per_thread_320869,\n                                                      int64_t virt_num_groups_320870,\n                                                      int64_t threads_per_segment_320872,\n                                                      __global\n                                                      unsigned char *seasonal_l_mem_318490,\n                                                      __global\n                                                      unsigned char *mem_318501,\n                                                      __global\n                                                      unsigned char *mem_318504,\n                 ",
            "                                     __global\n                                                      unsigned char *segred_tmp_mem_320873,\n                                                      __global\n                                                      unsigned char *segred_tmp_mem_320875,\n                                                      __global\n                                                      unsigned char *seasonal_amplitudezicounter_mem_320877)\n{\n    #define segred_group_sizze_297462 (seasonal_amplitudezisegred_group_sizze_297442)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_320888_backing_2 =\n                           &shared_mem[sync_arr_mem_320888_backing_offset_0];\n    volatile unsigned char *red_arr_mem_320886_backing_1 =\n                           &shared_mem[red_arr_mem_320886_backing_offset_1];\n    volatile unsigned char *red_arr_mem_320884_backing_0 =\n                           &shared_mem[red_arr_mem_320884_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_320879;\n    int32_t local_tid_320880;\n    int64_t group_sizze_320883;\n    int32_t wave_sizze_320882;\n    int32_t group_tid_320881;\n    \n    global_tid_320879 = get_global_id(0);\n    local_tid_320880 = get_local_id(0);\n    group_sizze_320883 = get_local_size(0);\n    wave_sizze_320882 = LOCKSTEP_WIDTH;\n    group_tid_320881 = get_group_id(0);\n    \n    int32_t phys_tid_297469 = global_tid_320879;\n    __local unsigned char *red_arr_mem_320884;\n    \n    red_arr_mem_320884 = (__local unsigned char *) red_arr_mem_320884_backing_0;\n    \n    __local unsigned char *red_arr_mem_320886;\n    \n    red_arr_mem_320886 = (__local unsigned char *) red_arr_mem_320886_backing_1;\n    \n    __local unsigned char *sync_arr_mem_320888;\n    \n    sync_arr_mem_320888 = (__local\n                           unsigned char *) sync_arr_mem_320888_backing_2;\n    \n    int32_t phys_group_",
            "id_320890;\n    \n    phys_group_id_320890 = get_group_id(0);\n    for (int32_t i_320891 = 0; i_320891 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_320870) - phys_group_id_320890,\n                   sext_i64_i32(num_groups_297463)); i_320891++) {\n        int32_t virt_group_id_320892 = phys_group_id_320890 + i_320891 *\n                sext_i64_i32(num_groups_297463);\n        int32_t flat_segment_id_320893 = squot32(virt_group_id_320892,\n                                                 sext_i64_i32(groups_per_segment_320868));\n        int64_t global_tid_320894 = srem64(sext_i32_i64(virt_group_id_320892) *\n                                           segred_group_sizze_297462 +\n                                           sext_i32_i64(local_tid_320880),\n                                           segred_group_sizze_297462 *\n                                           groups_per_segment_320868);\n        int64_t slice_320895 = m_292609;\n        int64_t gtid_297467 = sext_i32_i64(flat_segment_id_320893);\n        int64_t remnant_320896 = sext_i32_i64(flat_segment_id_320893) -\n                gtid_297467;\n        int64_t gtid_297468;\n        float x_acc_320897;\n        float x_acc_320898;\n        int64_t chunk_sizze_320899 = smin64(elements_per_thread_320869,\n                                            sdiv_up64(n_292610 -\n                                                      global_tid_320894,\n                                                      threads_per_segment_320872));\n        float x_297470;\n        float x_297471;\n        float x_297472;\n        float x_297473;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_320897 = -INFINITY;\n            x_acc_320898 = INFINITY;\n        }\n        for (int64_t i_320906 = 0; i_320906 < chunk_sizze_320899; i_320906++) {\n            gtid_297468 = global_tid_320894 + threads_per_segment_320872 *\n                i_320906;\n            // apply map function\n            {\n                float x_297477;\n  ",
            "              \n                x_297477 = ((__global\n                             float *) seasonal_l_mem_318490)[gtid_297467 *\n                                                             n_292610 +\n                                                             gtid_297468];\n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_297470 = x_acc_320897;\n                    x_297471 = x_acc_320898;\n                }\n                // load new values\n                {\n                    x_297472 = x_297477;\n                    x_297473 = x_297477;\n                }\n                // apply reduction operator\n                {\n                    float defunc_1_op_res_297474 = fmax32(x_297470, x_297472);\n                    float defunc_1_op_res_297475 = fmin32(x_297471, x_297473);\n                    \n                    // store in accumulator\n                    {\n                        x_acc_320897 = defunc_1_op_res_297474;\n                        x_acc_320898 = defunc_1_op_res_297475;\n                    }\n                }\n            }\n        }\n        // to reduce current chunk, first store our result in memory\n        {\n            x_297470 = x_acc_320897;\n            x_297471 = x_acc_320898;\n            ((__local\n              float *) red_arr_mem_320884)[sext_i32_i64(local_tid_320880)] =\n                x_297470;\n            ((__local\n              float *) red_arr_mem_320886)[sext_i32_i64(local_tid_320880)] =\n                x_297471;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_320907;\n        int32_t skip_waves_320908 = 1;\n        float x_320900;\n        float x_320901;\n        float x_320902;\n        float x_320903;\n        \n        offset_320907 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_320880,\n                      sext_i64_i32(segred_group_sizze_297462))) {\n                x",
            "_320900 = ((__local\n                             float *) red_arr_mem_320884)[sext_i32_i64(local_tid_320880 +\n                                                          offset_320907)];\n                x_320901 = ((__local\n                             float *) red_arr_mem_320886)[sext_i32_i64(local_tid_320880 +\n                                                          offset_320907)];\n            }\n        }\n        offset_320907 = 1;\n        while (slt32(offset_320907, wave_sizze_320882)) {\n            if (slt32(local_tid_320880 + offset_320907,\n                      sext_i64_i32(segred_group_sizze_297462)) &&\n                ((local_tid_320880 - squot32(local_tid_320880,\n                                             wave_sizze_320882) *\n                  wave_sizze_320882) & (2 * offset_320907 - 1)) == 0) {\n                // read array element\n                {\n                    x_320902 = ((volatile __local\n                                 float *) red_arr_mem_320884)[sext_i32_i64(local_tid_320880 +\n                                                              offset_320907)];\n                    x_320903 = ((volatile __local\n                                 float *) red_arr_mem_320886)[sext_i32_i64(local_tid_320880 +\n                                                              offset_320907)];\n                }\n                // apply reduction operation\n                {\n                    float defunc_1_op_res_320904 = fmax32(x_320900, x_320902);\n                    float defunc_1_op_res_320905 = fmin32(x_320901, x_320903);\n                    \n                    x_320900 = defunc_1_op_res_320904;\n                    x_320901 = defunc_1_op_res_320905;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      float *) red_arr_mem_320884)[sext_i32_i64(local_tid_320880)] =\n                        x_320900;\n                    ((volatile __local\n                      float *) ",
            "red_arr_mem_320886)[sext_i32_i64(local_tid_320880)] =\n                        x_320901;\n                }\n            }\n            offset_320907 *= 2;\n        }\n        while (slt32(skip_waves_320908,\n                     squot32(sext_i64_i32(segred_group_sizze_297462) +\n                             wave_sizze_320882 - 1, wave_sizze_320882))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_320907 = skip_waves_320908 * wave_sizze_320882;\n            if (slt32(local_tid_320880 + offset_320907,\n                      sext_i64_i32(segred_group_sizze_297462)) &&\n                ((local_tid_320880 - squot32(local_tid_320880,\n                                             wave_sizze_320882) *\n                  wave_sizze_320882) == 0 && (squot32(local_tid_320880,\n                                                      wave_sizze_320882) & (2 *\n                                                                            skip_waves_320908 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_320902 = ((__local\n                                 float *) red_arr_mem_320884)[sext_i32_i64(local_tid_320880 +\n                                                              offset_320907)];\n                    x_320903 = ((__local\n                                 float *) red_arr_mem_320886)[sext_i32_i64(local_tid_320880 +\n                                                              offset_320907)];\n                }\n                // apply reduction operation\n                {\n                    float defunc_1_op_res_320904 = fmax32(x_320900, x_320902);\n                    float defunc_1_op_res_320905 = fmin32(x_320901, x_320903);\n                    \n                    x_320900 = defunc_1_op_res_320904;\n                    x_320901 = defunc_1_op_res_320905;\n                }\n                // write result of operation\n                {\n   ",
            "                 ((__local\n                      float *) red_arr_mem_320884)[sext_i32_i64(local_tid_320880)] =\n                        x_320900;\n                    ((__local\n                      float *) red_arr_mem_320886)[sext_i32_i64(local_tid_320880)] =\n                        x_320901;\n                }\n            }\n            skip_waves_320908 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_320880) == (int64_t) 0) {\n                x_acc_320897 = x_320900;\n                x_acc_320898 = x_320901;\n            }\n        }\n        if (groups_per_segment_320868 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_320880 == 0) {\n                    ((__global float *) mem_318501)[gtid_297467] = x_acc_320897;\n                    ((__global float *) mem_318504)[gtid_297467] = x_acc_320898;\n                }\n            }\n        } else {\n            int32_t old_counter_320909;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_320880 == 0) {\n                    ((__global\n                      float *) segred_tmp_mem_320873)[sext_i32_i64(virt_group_id_320892)] =\n                        x_acc_320897;\n                    ((__global\n                      float *) segred_tmp_mem_320875)[sext_i32_i64(virt_group_id_320892)] =\n                        x_acc_320898;\n                    mem_fence_global();\n                    old_counter_320909 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) seasonal_amplitudezicounter_mem_320877)[sext_i32_i64(srem32(flat_segment_id_320893,\n                                                                                                                    10240))],\n                                       ",
            "       (int) 1);\n                    ((__local bool *) sync_arr_mem_320888)[(int64_t) 0] =\n                        old_counter_320909 == groups_per_segment_320868 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_320910;\n            \n            is_last_group_320910 = ((__local\n                                     bool *) sync_arr_mem_320888)[(int64_t) 0];\n            if (is_last_group_320910) {\n                if (local_tid_320880 == 0) {\n                    old_counter_320909 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) seasonal_amplitudezicounter_mem_320877)[sext_i32_i64(srem32(flat_segment_id_320893,\n                                                                                                                    10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_320868));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_320911 =\n                            sdiv_up64(groups_per_segment_320868,\n                                      segred_group_sizze_297462);\n                    \n                    x_297470 = -INFINITY;\n                    x_297471 = INFINITY;\n                    for (int64_t i_320912 = 0; i_320912 <\n                         read_per_thread_320911; i_320912++) {\n                        int64_t group_res_id_320913 =\n                                sext_i32_i64(local_tid_320880) *\n                                read_per_thread_320911 + i_320912;\n                        int64_t index_of_group_res_320914 =\n                                sext_i32_i64(flat_segment_id_320893) *\n                                groups_per_segment_320868 + group_res_id_320913;\n           ",
            "             \n                        if (slt64(group_res_id_320913,\n                                  groups_per_segment_320868)) {\n                            x_297472 = ((__global\n                                         float *) segred_tmp_mem_320873)[index_of_group_res_320914];\n                            x_297473 = ((__global\n                                         float *) segred_tmp_mem_320875)[index_of_group_res_320914];\n                            \n                            float defunc_1_op_res_297474 = fmax32(x_297470,\n                                                                  x_297472);\n                            float defunc_1_op_res_297475 = fmin32(x_297471,\n                                                                  x_297473);\n                            \n                            x_297470 = defunc_1_op_res_297474;\n                            x_297471 = defunc_1_op_res_297475;\n                        }\n                    }\n                }\n                ((__local\n                  float *) red_arr_mem_320884)[sext_i32_i64(local_tid_320880)] =\n                    x_297470;\n                ((__local\n                  float *) red_arr_mem_320886)[sext_i32_i64(local_tid_320880)] =\n                    x_297471;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_320915;\n                    int32_t skip_waves_320916 = 1;\n                    float x_320900;\n                    float x_320901;\n                    float x_320902;\n                    float x_320903;\n                    \n                    offset_320915 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_320880,\n                                  sext_i64_i32(segred_group_sizze_297462))) {\n                            x_320900 = ((__local\n                                         float *) red_",
            "arr_mem_320884)[sext_i32_i64(local_tid_320880 +\n                                                                      offset_320915)];\n                            x_320901 = ((__local\n                                         float *) red_arr_mem_320886)[sext_i32_i64(local_tid_320880 +\n                                                                      offset_320915)];\n                        }\n                    }\n                    offset_320915 = 1;\n                    while (slt32(offset_320915, wave_sizze_320882)) {\n                        if (slt32(local_tid_320880 + offset_320915,\n                                  sext_i64_i32(segred_group_sizze_297462)) &&\n                            ((local_tid_320880 - squot32(local_tid_320880,\n                                                         wave_sizze_320882) *\n                              wave_sizze_320882) & (2 * offset_320915 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_320902 = ((volatile __local\n                                             float *) red_arr_mem_320884)[sext_i32_i64(local_tid_320880 +\n                                                                          offset_320915)];\n                                x_320903 = ((volatile __local\n                                             float *) red_arr_mem_320886)[sext_i32_i64(local_tid_320880 +\n                                                                          offset_320915)];\n                            }\n                            // apply reduction operation\n                            {\n                                float defunc_1_op_res_320904 = fmax32(x_320900,\n                                                                      x_320902);\n                                float defunc_1_op_res_320905 = fmin32(x_320901,\n                                                                      x_320903);\n                      ",
            "          \n                                x_320900 = defunc_1_op_res_320904;\n                                x_320901 = defunc_1_op_res_320905;\n                            }\n                            // write result of operation\n                            {\n                                ((volatile __local\n                                  float *) red_arr_mem_320884)[sext_i32_i64(local_tid_320880)] =\n                                    x_320900;\n                                ((volatile __local\n                                  float *) red_arr_mem_320886)[sext_i32_i64(local_tid_320880)] =\n                                    x_320901;\n                            }\n                        }\n                        offset_320915 *= 2;\n                    }\n                    while (slt32(skip_waves_320916,\n                                 squot32(sext_i64_i32(segred_group_sizze_297462) +\n                                         wave_sizze_320882 - 1,\n                                         wave_sizze_320882))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_320915 = skip_waves_320916 * wave_sizze_320882;\n                        if (slt32(local_tid_320880 + offset_320915,\n                                  sext_i64_i32(segred_group_sizze_297462)) &&\n                            ((local_tid_320880 - squot32(local_tid_320880,\n                                                         wave_sizze_320882) *\n                              wave_sizze_320882) == 0 &&\n                             (squot32(local_tid_320880, wave_sizze_320882) &\n                              (2 * skip_waves_320916 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_320902 = ((__local\n                                             float *) red_arr_mem_320884)[sext_i32_i64(local_tid_320880 +\n                                                                          offset_320915)];\n ",
            "                               x_320903 = ((__local\n                                             float *) red_arr_mem_320886)[sext_i32_i64(local_tid_320880 +\n                                                                          offset_320915)];\n                            }\n                            // apply reduction operation\n                            {\n                                float defunc_1_op_res_320904 = fmax32(x_320900,\n                                                                      x_320902);\n                                float defunc_1_op_res_320905 = fmin32(x_320901,\n                                                                      x_320903);\n                                \n                                x_320900 = defunc_1_op_res_320904;\n                                x_320901 = defunc_1_op_res_320905;\n                            }\n                            // write result of operation\n                            {\n                                ((__local\n                                  float *) red_arr_mem_320884)[sext_i32_i64(local_tid_320880)] =\n                                    x_320900;\n                                ((__local\n                                  float *) red_arr_mem_320886)[sext_i32_i64(local_tid_320880)] =\n                                    x_320901;\n                            }\n                        }\n                        skip_waves_320916 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_320880 == 0) {\n                            ((__global float *) mem_318501)[gtid_297467] =\n                                x_320900;\n                            ((__global float *) mem_318504)[gtid_297467] =\n                                x_320901;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n  ",
            "  \n  error_1:\n    return;\n    #undef segred_group_sizze_297462\n}\n__kernel void seasonal_amplitudezisegred_small_297469(__global\n                                                      int *global_failure,\n                                                      uint red_arr_mem_320844_backing_offset_0,\n                                                      uint red_arr_mem_320842_backing_offset_1,\n                                                      int64_t m_292609,\n                                                      int64_t n_292610,\n                                                      int64_t num_groups_297463,\n                                                      int64_t segment_sizze_nonzzero_320835,\n                                                      __global\n                                                      unsigned char *seasonal_l_mem_318490,\n                                                      __global\n                                                      unsigned char *mem_318501,\n                                                      __global\n                                                      unsigned char *mem_318504)\n{\n    #define segred_group_sizze_297462 (seasonal_amplitudezisegred_group_sizze_297442)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_320844_backing_1 =\n                           &shared_mem[red_arr_mem_320844_backing_offset_0];\n    volatile unsigned char *red_arr_mem_320842_backing_0 =\n                           &shared_mem[red_arr_mem_320842_backing_offset_1];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_320837;\n    int32_t local_tid_320838;\n    int64_t group_sizze_320841;\n    int32_t wave_sizze_320840;\n    int32_t group_tid_320839;\n    \n    global_tid_320837 = get_global_id(0);\n    local_tid_320838 = get_local_id(0);\n    group_sizze_320841 = get_local_size(0);\n    wave_sizze_320840 = LOCKSTEP_WIDTH;\n    grou",
            "p_tid_320839 = get_group_id(0);\n    \n    int32_t phys_tid_297469 = global_tid_320837;\n    __local unsigned char *red_arr_mem_320842;\n    \n    red_arr_mem_320842 = (__local unsigned char *) red_arr_mem_320842_backing_0;\n    \n    __local unsigned char *red_arr_mem_320844;\n    \n    red_arr_mem_320844 = (__local unsigned char *) red_arr_mem_320844_backing_1;\n    \n    int32_t phys_group_id_320846;\n    \n    phys_group_id_320846 = get_group_id(0);\n    for (int32_t i_320847 = 0; i_320847 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(m_292609,\n                                          squot64(segred_group_sizze_297462,\n                                                  segment_sizze_nonzzero_320835))) -\n                   phys_group_id_320846, sext_i64_i32(num_groups_297463));\n         i_320847++) {\n        int32_t virt_group_id_320848 = phys_group_id_320846 + i_320847 *\n                sext_i64_i32(num_groups_297463);\n        int64_t slice_320849 = m_292609;\n        int64_t gtid_297467 = squot64(sext_i32_i64(local_tid_320838),\n                                      segment_sizze_nonzzero_320835) +\n                sext_i32_i64(virt_group_id_320848) *\n                squot64(segred_group_sizze_297462,\n                        segment_sizze_nonzzero_320835);\n        int64_t remnant_320850 = squot64(sext_i32_i64(local_tid_320838),\n                                         segment_sizze_nonzzero_320835) +\n                sext_i32_i64(virt_group_id_320848) *\n                squot64(segred_group_sizze_297462,\n                        segment_sizze_nonzzero_320835) - gtid_297467;\n        int64_t gtid_297468 = srem64(sext_i32_i64(local_tid_320838), n_292610);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, n_292610) && (slt64(gtid_297467, m_292609) &&\n                                                 slt64(sext_i32_i64(local_tid_320838),\n                                                       n_292610 *\n                                        ",
            "               squot64(segred_group_sizze_297462,\n                                                               segment_sizze_nonzzero_320835)))) {\n                float x_297477;\n                \n                x_297477 = ((__global\n                             float *) seasonal_l_mem_318490)[gtid_297467 *\n                                                             n_292610 +\n                                                             gtid_297468];\n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      float *) red_arr_mem_320842)[sext_i32_i64(local_tid_320838)] =\n                        x_297477;\n                    ((__local\n                      float *) red_arr_mem_320844)[sext_i32_i64(local_tid_320838)] =\n                        x_297477;\n                }\n            } else {\n                ((__local\n                  float *) red_arr_mem_320842)[sext_i32_i64(local_tid_320838)] =\n                    -INFINITY;\n                ((__local\n                  float *) red_arr_mem_320844)[sext_i32_i64(local_tid_320838)] =\n                    INFINITY;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, n_292610)) {\n            // perform segmented scan to imitate reduction\n            {\n                float x_297470;\n                float x_297471;\n                float x_297472;\n                float x_297473;\n                float x_320851;\n                float x_320852;\n                float x_320853;\n                float x_320854;\n                bool ltid_in_bounds_320857 =\n                     slt64(sext_i32_i64(local_tid_320838), n_292610 *\n                           squot64(segred_group_sizze_297462,\n                                   segment_sizze_nonzzero_320835));\n                int32_t skip_threads_320858;\n                \n                // read input for in-block scan\n                ",
            "{\n                    if (ltid_in_bounds_320857) {\n                        x_297472 = ((volatile __local\n                                     float *) red_arr_mem_320842)[sext_i32_i64(local_tid_320838)];\n                        x_297473 = ((volatile __local\n                                     float *) red_arr_mem_320844)[sext_i32_i64(local_tid_320838)];\n                        if ((local_tid_320838 - squot32(local_tid_320838, 32) *\n                             32) == 0) {\n                            x_297470 = x_297472;\n                            x_297471 = x_297473;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_320858 = 1;\n                    while (slt32(skip_threads_320858, 32)) {\n                        bool thread_active_320859 = sle32(skip_threads_320858,\n                                                          local_tid_320838 -\n                                                          squot32(local_tid_320838,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_320857;\n                        \n                        if (thread_active_320859) {\n                            // read operands\n                            {\n                                x_297470 = ((volatile __local\n                                             float *) red_arr_mem_320842)[sext_i32_i64(local_tid_320838) -\n                                                                          sext_i32_i64(skip_threads_320858)];\n                                x_297471 = ((volatile __local\n                                             float *) red_arr_mem_320844)[sext_i32_i64(local_tid_320838) -\n                                                                          sext_i32_i64(skip_threads_320858)];\n                            }\n                        }\n                        // perfor",
            "m operation\n                        {\n                            bool inactive_320860 =\n                                 slt64(srem64(sext_i32_i64(local_tid_320838),\n                                              n_292610),\n                                       sext_i32_i64(local_tid_320838) -\n                                       sext_i32_i64(local_tid_320838 -\n                                       skip_threads_320858));\n                            \n                            if (thread_active_320859 && inactive_320860) {\n                                x_297470 = x_297472;\n                                x_297471 = x_297473;\n                            }\n                            if (thread_active_320859) {\n                                if (!inactive_320860) {\n                                    float defunc_1_op_res_297474 =\n                                          fmax32(x_297470, x_297472);\n                                    float defunc_1_op_res_297475 =\n                                          fmin32(x_297471, x_297473);\n                                    \n                                    x_297470 = defunc_1_op_res_297474;\n                                    x_297471 = defunc_1_op_res_297475;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_320840, skip_threads_320858)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_320859) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  float *) red_arr_mem_320842)[sext_i32_i64(local_tid_320838)] =\n                                    x_297470;\n                                x_297472 = x_297470;\n                                ((volatile __local\n                                  float *) red_arr_mem_320844)[sext_i32_i64(local_tid_32083",
            "8)] =\n                                    x_297471;\n                                x_297473 = x_297471;\n                            }\n                        }\n                        if (sle32(wave_sizze_320840, skip_threads_320858)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_320858 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_320838 - squot32(local_tid_320838, 32) *\n                         32) == 31 && ltid_in_bounds_320857) {\n                        ((volatile __local\n                          float *) red_arr_mem_320842)[sext_i32_i64(squot32(local_tid_320838,\n                                                                            32))] =\n                            x_297470;\n                        ((volatile __local\n                          float *) red_arr_mem_320844)[sext_i32_i64(squot32(local_tid_320838,\n                                                                            32))] =\n                            x_297471;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_320861;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_320838, 32) == 0 &&\n                            ltid_in_bounds_320857) {\n                            x_320853 = ((volatile __local\n                                         float *) red_arr_mem_320842)[sext_i32_i64(local_tid_320838)];\n                            x_320854 = ((volatile __local\n                                         float *) red_arr_mem_320844)[sext_i32_i64(local_tid_320838)];\n    ",
            "                        if ((local_tid_320838 - squot32(local_tid_320838,\n                                                            32) * 32) == 0) {\n                                x_320851 = x_320853;\n                                x_320852 = x_320854;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_320861 = 1;\n                        while (slt32(skip_threads_320861, 32)) {\n                            bool thread_active_320862 =\n                                 sle32(skip_threads_320861, local_tid_320838 -\n                                       squot32(local_tid_320838, 32) * 32) &&\n                                 (squot32(local_tid_320838, 32) == 0 &&\n                                  ltid_in_bounds_320857);\n                            \n                            if (thread_active_320862) {\n                                // read operands\n                                {\n                                    x_320851 = ((volatile __local\n                                                 float *) red_arr_mem_320842)[sext_i32_i64(local_tid_320838) -\n                                                                              sext_i32_i64(skip_threads_320861)];\n                                    x_320852 = ((volatile __local\n                                                 float *) red_arr_mem_320844)[sext_i32_i64(local_tid_320838) -\n                                                                              sext_i32_i64(skip_threads_320861)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_320863 =\n                                     slt64(srem64(sext_i32_i64(local_tid_320838 *\n                                                  32 + 32 - 1), n_292610),\n            ",
            "                               sext_i32_i64(local_tid_320838 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_320838 -\n                                                         skip_threads_320861) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_320862 && inactive_320863) {\n                                    x_320851 = x_320853;\n                                    x_320852 = x_320854;\n                                }\n                                if (thread_active_320862) {\n                                    if (!inactive_320863) {\n                                        float defunc_1_op_res_320855 =\n                                              fmax32(x_320851, x_320853);\n                                        float defunc_1_op_res_320856 =\n                                              fmin32(x_320852, x_320854);\n                                        \n                                        x_320851 = defunc_1_op_res_320855;\n                                        x_320852 = defunc_1_op_res_320856;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_320840, skip_threads_320861)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_320862) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      float *) red_arr_mem_320842)[sext_i32_i64(local_tid_320838)] =\n                                        x_320851;\n                                    x_320853 = x_320851;\n                                    ((volatile __local\n                                      float *) red_arr_mem_320844)[sext_i",
            "32_i64(local_tid_320838)] =\n                                        x_320852;\n                                    x_320854 = x_320852;\n                                }\n                            }\n                            if (sle32(wave_sizze_320840, skip_threads_320861)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_320861 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_320864 = squot32(local_tid_320838, 32) == 0 ||\n                     !ltid_in_bounds_320857;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_320864) {\n                            x_297472 = x_297470;\n                            x_297473 = x_297471;\n                            x_297470 = ((__local\n                                         float *) red_arr_mem_320842)[sext_i32_i64(squot32(local_tid_320838,\n                                                                                           32)) -\n                                                                      (int64_t) 1];\n                            x_297471 = ((__local\n                                         float *) red_arr_mem_320844)[sext_i32_i64(squot32(local_tid_320838,\n                                                                                           32)) -\n                                                                      (int64_t) 1];\n                        }\n                    }\n                    // perform operation\n                    {\n                        bool inactive_320865 =\n                             slt64(srem64(sext_i32_i64(local_tid_320838),\n                                          n_292610),\n                                   sext_i32_i64(loc",
            "al_tid_320838) -\n                                   sext_i32_i64(squot32(local_tid_320838, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_320864) {\n                            if (inactive_320865) {\n                                x_297470 = x_297472;\n                                x_297471 = x_297473;\n                            }\n                        }\n                        if (!no_carry_in_320864) {\n                            if (!inactive_320865) {\n                                float defunc_1_op_res_297474 = fmax32(x_297470,\n                                                                      x_297472);\n                                float defunc_1_op_res_297475 = fmin32(x_297471,\n                                                                      x_297473);\n                                \n                                x_297470 = defunc_1_op_res_297474;\n                                x_297471 = defunc_1_op_res_297475;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_320864) {\n                            ((__local\n                              float *) red_arr_mem_320842)[sext_i32_i64(local_tid_320838)] =\n                                x_297470;\n                            ((__local\n                              float *) red_arr_mem_320844)[sext_i32_i64(local_tid_320838)] =\n                                x_297471;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_320838, 32) == 0 &&\n                        ltid_in_bounds_320857) {\n                        ((__local\n                          float *) red_arr_mem_320842)[sext_i32_i64(local_tid_320838)] =\n                ",
            "            x_297472;\n                        ((__local\n                          float *) red_arr_mem_320844)[sext_i32_i64(local_tid_320838)] =\n                            x_297473;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n            if (slt64(sext_i32_i64(virt_group_id_320848) *\n                      squot64(segred_group_sizze_297462,\n                              segment_sizze_nonzzero_320835) +\n                      sext_i32_i64(local_tid_320838), m_292609) &&\n                slt64(sext_i32_i64(local_tid_320838),\n                      squot64(segred_group_sizze_297462,\n                              segment_sizze_nonzzero_320835))) {\n                float tmp_320866;\n                \n                tmp_320866 = ((__local\n                               float *) red_arr_mem_320842)[(sext_i32_i64(local_tid_320838) +\n                                                             (int64_t) 1) *\n                                                            segment_sizze_nonzzero_320835 -\n                                                            (int64_t) 1];\n                ((__global\n                  float *) mem_318501)[sext_i32_i64(virt_group_id_320848) *\n                                       squot64(segred_group_sizze_297462,\n                                               segment_sizze_nonzzero_320835) +\n                                       sext_i32_i64(local_tid_320838)] =\n                    tmp_320866;\n                \n                float tmp_320867;\n                \n                tmp_320867 = ((__local\n                               float *) red_arr_mem_320844)[(sext_i32_i64(local_tid_320838) +\n                                                             (int64_t) 1) *\n                                                            segment_sizze_nonzzero_320835 -\n                                       ",
            "                     (int64_t) 1];\n                ((__global\n                  float *) mem_318504)[sext_i32_i64(virt_group_id_320848) *\n                                       squot64(segred_group_sizze_297462,\n                                               segment_sizze_nonzzero_320835) +\n                                       sext_i32_i64(local_tid_320838)] =\n                    tmp_320867;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_297462\n}\n__kernel void trend_magnitudezisegmap_297603(__global int *global_failure,\n                                             int64_t m_292626,\n                                             double i64_res_292652, __global\n                                             unsigned char *mem_318532, __global\n                                             unsigned char *mem_318536)\n{\n    #define segmap_group_sizze_297599 (trend_magnitudezisegmap_group_sizze_297548)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_320952;\n    int32_t local_tid_320953;\n    int64_t group_sizze_320956;\n    int32_t wave_sizze_320955;\n    int32_t group_tid_320954;\n    \n    global_tid_320952 = get_global_id(0);\n    local_tid_320953 = get_local_id(0);\n    group_sizze_320956 = get_local_size(0);\n    wave_sizze_320955 = LOCKSTEP_WIDTH;\n    group_tid_320954 = get_group_id(0);\n    \n    int32_t phys_tid_297603 = global_tid_320952;\n    int64_t global_tid_320957 = sext_i32_i64(group_tid_320954) *\n            segmap_group_sizze_297599 + sext_i32_i64(local_tid_320953);\n    int64_t slice_320958 = m_292626;\n    int64_t gtid_297602 = global_tid_320957;\n    int64_t remnant_320959 = global_tid_320957 - gtid_297602;\n    \n    if (slt64(gtid_297602, m_292626)) {\n        double defunc_2_reduce_res_297604;\n        \n      ",
            "  defunc_2_reduce_res_297604 = ((__global\n                                       double *) mem_318532)[gtid_297602];\n        \n        double defunc_0_f_res_297605 = i64_res_292652 *\n               defunc_2_reduce_res_297604;\n        float defunc_0_f_res_297606 = fpconv_f64_f32(defunc_0_f_res_297605);\n        \n        ((__global float *) mem_318536)[gtid_297602] = defunc_0_f_res_297606;\n    }\n    \n  error_0:\n    return;\n    #undef segmap_group_sizze_297599\n}\n__kernel void trend_magnitudezisegmap_intragroup_318088(__global\n                                                        int *global_failure,\n                                                        uint color_320589_backing_offset_0,\n                                                        int64_t m_292626,\n                                                        int64_t n_292627,\n                                                        double i64_res_292652,\n                                                        double b11_292658,\n                                                        double c11_292659,\n                                                        int64_t segmap_usable_groups_297527,\n                                                        int64_t num_whole_tiles_318096,\n                                                        int64_t residual_input_318195,\n                                                        unsigned char cond_318196_bits,\n                                                        __global\n                                                        unsigned char *mem_318498,\n                                                        __global\n                                                        unsigned char *mem_318501,\n                                                        __global\n                                                        unsigned char *mem_318528)\n{\n    bool cond_318196 = cond_318196_bits;\n    \n    #define segmap_group_sizze_297526 (trend_magnitudezisegmap_group_sizze_2975",
            "07)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *color_320589_backing_0 =\n                           &shared_mem[color_320589_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_320865;\n    int32_t local_tid_320866;\n    int64_t group_sizze_320869;\n    int32_t wave_sizze_320868;\n    int32_t group_tid_320867;\n    \n    global_tid_320865 = get_global_id(0);\n    local_tid_320866 = get_local_id(0);\n    group_sizze_320869 = get_local_size(0);\n    wave_sizze_320868 = LOCKSTEP_WIDTH;\n    group_tid_320867 = get_group_id(0);\n    \n    int32_t gid_flat_318088 = group_tid_320867;\n    int64_t slice_320871 = segmap_group_sizze_297526;\n    int64_t ltid_pre_320870 = sext_i32_i64(local_tid_320866);\n    int64_t remnant_320872 = sext_i32_i64(local_tid_320866) - ltid_pre_320870;\n    int64_t slice_320873 = segmap_usable_groups_297527;\n    int64_t gid_318087 = sext_i32_i64(group_tid_320867);\n    int64_t remnant_320874 = sext_i32_i64(group_tid_320867) - gid_318087;\n    double color_320585[1];\n    double color_320586[1];\n    float color_320587[1];\n    double color_320588[1];\n    __local unsigned char *color_320589;\n    \n    color_320589 = (__local unsigned char *) color_320589_backing_0;\n    \n    double color_320590[1];\n    int32_t ltid_flat_318098 = local_tid_320866;\n    int64_t ltid_318097 = sext_i32_i64(sext_i64_i32(ltid_pre_320870));\n    \n    color_320586[(int64_t) 0] = 0.0;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int64_t binop_x_318167 = segmap_group_sizze_297526 * gid_318087;\n    double tmp_320875;\n    \n    tmp_320875 = color_320586[(int64_t) 0];\n    color_320585[(int64_t) 0] = tmp_320875;\n    \n    double ext_mem_318514[1];\n    double ext_mem_unused_320572[1];\n    double mem_param_318506[1];\n    double mem_param_out_320573[1];\n    \n    for (int32_t i_1 = 0; i_1 < 1; i_1++)\n        mem_param_318506[i_1] = color_320585[i_1];\n    for (int32_t i_2 = 0; i_2 < 1; i_2",
            "++)\n        mem_param_out_320573[i_2] = color_320590[i_2];\n    for (int64_t tile_id_318104 = 0; tile_id_318104 < num_whole_tiles_318096;\n         tile_id_318104++) {\n        int64_t binop_x_318155 = segmap_group_sizze_297526 * tile_id_318104;\n        int32_t ltid_flat_318154 = local_tid_320866;\n        int64_t ltid_318153 = sext_i32_i64(sext_i64_i32(ltid_pre_320870));\n        int64_t j_318156 = ltid_318153 + binop_x_318155;\n        bool cond_318160 = slt64(j_318156, n_292627);\n        double pre1d_318161;\n        \n        if (cond_318160) {\n            double tile_elem_318162;\n            \n            tile_elem_318162 = ((__global double *) mem_318498)[j_318156];\n            pre1d_318161 = tile_elem_318162;\n        } else {\n            pre1d_318161 = 0.0;\n        }\n        ((__local double *) color_320589)[ltid_318153] = pre1d_318161;\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t ltid_flat_318166 = local_tid_320866;\n        int64_t ltid_318165 = sext_i32_i64(sext_i64_i32(ltid_pre_320870));\n        int64_t gtid_318168 = ltid_318165 + binop_x_318167;\n        double acc_318170;\n        \n        acc_318170 = mem_param_318506[(int64_t) 0];\n        \n        bool cond_318173 = slt64(gtid_318168, m_292626);\n        double acc_318174;\n        \n        if (cond_318173) {\n            double x_318175;\n            double redout_318436 = acc_318170;\n            \n            for (int64_t i_318437 = 0; i_318437 < segmap_group_sizze_297526;\n                 i_318437++) {\n                double x_318179;\n                \n                x_318179 = ((__local double *) color_320589)[i_318437];\n                \n                int64_t slice_318482 = binop_x_318155 + i_318437;\n                float x_318180;\n                \n                x_318180 = ((__global float *) mem_318501)[slice_318482 *\n                                                           m_292626 +\n                                                           gtid_318168];\n                \n                ",
            "double y_318181 = c11_292659 * x_318179;\n                double x_318182 = b11_292658 + y_318181;\n                double f32_res_318183 = fpconv_f32_f64(x_318180);\n                double defunc_1_f_res_318184 = x_318182 * f32_res_318183;\n                double defunc_1_op_res_318178 = defunc_1_f_res_318184 +\n                       redout_318436;\n                double redout_tmp_320879 = defunc_1_op_res_318178;\n                \n                redout_318436 = redout_tmp_320879;\n            }\n            x_318175 = redout_318436;\n            acc_318174 = x_318175;\n        } else {\n            acc_318174 = acc_318170;\n        }\n        mem_param_out_320573[(int64_t) 0] = acc_318174;\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        double mem_param_tmp_320876[1];\n        \n        for (int32_t i_3 = 0; i_3 < 1; i_3++)\n            mem_param_tmp_320876[i_3] = mem_param_out_320573[i_3];\n        \n        double mem_param_out_tmp_320877[1];\n        \n        for (int32_t i_4 = 0; i_4 < 1; i_4++)\n            mem_param_out_tmp_320877[i_4] = mem_param_318506[i_4];\n        for (int32_t i_5 = 0; i_5 < 1; i_5++)\n            mem_param_318506[i_5] = mem_param_tmp_320876[i_5];\n        for (int32_t i_6 = 0; i_6 < 1; i_6++)\n            mem_param_out_320573[i_6] = mem_param_out_tmp_320877[i_6];\n    }\n    for (int32_t i_7 = 0; i_7 < 1; i_7++)\n        ext_mem_318514[i_7] = mem_param_318506[i_7];\n    for (int32_t i_8 = 0; i_8 < 1; i_8++)\n        ext_mem_unused_320572[i_8] = mem_param_out_320573[i_8];\n    if (cond_318196) {\n        double tmp_320880;\n        \n        tmp_320880 = ext_mem_318514[(int64_t) 0];\n        color_320586[(int64_t) 0] = tmp_320880;\n    } else {\n        int64_t binop_x_318206 = segmap_group_sizze_297526 *\n                num_whole_tiles_318096;\n        int32_t ltid_flat_318198 = local_tid_320866;\n        int64_t ltid_318197 = sext_i32_i64(sext_i64_i32(ltid_pre_320870));\n        int64_t j_318207 = ltid_318197 + binop_x_318206;\n        bool cond_318211 = slt64(j_31",
            "8207, n_292627);\n        double pre1d_318212;\n        \n        if (cond_318211) {\n            double tile_elem_318213;\n            \n            tile_elem_318213 = ((__global double *) mem_318498)[j_318207];\n            pre1d_318212 = tile_elem_318213;\n        } else {\n            pre1d_318212 = 0.0;\n        }\n        ((__local double *) color_320589)[ltid_318197] = pre1d_318212;\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int64_t slice_offset_318230 = num_whole_tiles_318096 *\n                residual_input_318195;\n        int32_t ltid_flat_318218 = local_tid_320866;\n        int64_t ltid_318217 = sext_i32_i64(sext_i64_i32(ltid_pre_320870));\n        int64_t gtid_318227 = binop_x_318167 + ltid_318217;\n        double acc_318229;\n        \n        acc_318229 = ext_mem_318514[(int64_t) 0];\n        \n        bool cond_318232 = slt64(gtid_318227, m_292626);\n        double acc_318233;\n        \n        if (cond_318232) {\n            double x_318234;\n            double redout_318438 = acc_318229;\n            \n            for (int64_t i_318439 = 0; i_318439 < residual_input_318195;\n                 i_318439++) {\n                double x_318238;\n                \n                x_318238 = ((__local double *) color_320589)[i_318439];\n                \n                int64_t slice_318481 = slice_offset_318230 + i_318439;\n                float x_318239;\n                \n                x_318239 = ((__global float *) mem_318501)[slice_318481 *\n                                                           m_292626 +\n                                                           gtid_318227];\n                \n                double y_318240 = c11_292659 * x_318238;\n                double x_318241 = b11_292658 + y_318240;\n                double f32_res_318242 = fpconv_f32_f64(x_318239);\n                double defunc_1_f_res_318243 = x_318241 * f32_res_318242;\n                double defunc_1_op_res_318237 = defunc_1_f_res_318243 +\n                       redout_318438;\n                ",
            "double redout_tmp_320881 = defunc_1_op_res_318237;\n                \n                redout_318438 = redout_tmp_320881;\n            }\n            x_318234 = redout_318438;\n            acc_318233 = x_318234;\n        } else {\n            acc_318233 = acc_318229;\n        }\n        color_320588[(int64_t) 0] = acc_318233;\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        double tmp_320882;\n        \n        tmp_320882 = color_320588[(int64_t) 0];\n        color_320586[(int64_t) 0] = tmp_320882;\n    }\n    \n    int32_t ltid_flat_318247 = local_tid_320866;\n    int64_t ltid_318246 = sext_i32_i64(sext_i64_i32(ltid_pre_320870));\n    int64_t gtid_318253 = binop_x_318167 + ltid_318246;\n    bool cond_318255 = slt64(gtid_318253, m_292626);\n    float postlude_318256;\n    \n    if (cond_318255) {\n        double defunc_2_reduce_res_318254;\n        \n        defunc_2_reduce_res_318254 = color_320586[(int64_t) 0];\n        \n        double defunc_0_f_res_318258 = i64_res_292652 *\n               defunc_2_reduce_res_318254;\n        float defunc_0_f_res_318259 = fpconv_f64_f32(defunc_0_f_res_318258);\n        \n        postlude_318256 = defunc_0_f_res_318259;\n    } else {\n        postlude_318256 = 0.0F;\n    }\n    color_320587[(int64_t) 0] = postlude_318256;\n    barrier(CLK_LOCAL_MEM_FENCE);\n    if (slt64(sext_i32_i64(local_tid_320866) + segmap_group_sizze_297526 *\n              sext_i32_i64(group_tid_320867), m_292626)) {\n        float tmp_320883;\n        \n        tmp_320883 = color_320587[(int64_t) 0];\n        ((__global float *) mem_318528)[sext_i32_i64(local_tid_320866) +\n                                        segmap_group_sizze_297526 *\n                                        sext_i32_i64(group_tid_320867)] =\n            tmp_320883;\n    }\n    \n  error_6:\n    return;\n    #undef segmap_group_sizze_297526\n}\n__kernel void trend_magnitudezisegred_large_297587(__global int *global_failure,\n                                                   uint sync_arr_mem_320927_backing_offset_0,\n           ",
            "                                        uint red_arr_mem_320925_backing_offset_1,\n                                                   int64_t m_292626,\n                                                   int64_t n_292627,\n                                                   double b11_292658,\n                                                   double c11_292659,\n                                                   int64_t num_groups_297582,\n                                                   int64_t groups_per_segment_320911,\n                                                   int64_t elements_per_thread_320912,\n                                                   int64_t virt_num_groups_320913,\n                                                   int64_t threads_per_segment_320915,\n                                                   __global\n                                                   unsigned char *trend_l_mem_318490,\n                                                   __global\n                                                   unsigned char *mem_318498,\n                                                   __global\n                                                   unsigned char *mem_318532,\n                                                   __global\n                                                   unsigned char *segred_tmp_mem_320916,\n                                                   __global\n                                                   unsigned char *trend_magnitudezicounter_mem_320918)\n{\n    #define segred_group_sizze_297581 (trend_magnitudezisegred_group_sizze_297559)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *sync_arr_mem_320927_backing_1 =\n                           &shared_mem[sync_arr_mem_320927_backing_offset_0];\n    volatile unsigned char *red_arr_mem_320925_backing_0 =\n                           &shared_mem[red_arr_mem_320925_backing_offset_1];\n    \n    if (*global_failure >=",
            " 0)\n        return;\n    \n    int32_t global_tid_320920;\n    int32_t local_tid_320921;\n    int64_t group_sizze_320924;\n    int32_t wave_sizze_320923;\n    int32_t group_tid_320922;\n    \n    global_tid_320920 = get_global_id(0);\n    local_tid_320921 = get_local_id(0);\n    group_sizze_320924 = get_local_size(0);\n    wave_sizze_320923 = LOCKSTEP_WIDTH;\n    group_tid_320922 = get_group_id(0);\n    \n    int32_t phys_tid_297587 = global_tid_320920;\n    __local unsigned char *red_arr_mem_320925;\n    \n    red_arr_mem_320925 = (__local unsigned char *) red_arr_mem_320925_backing_0;\n    \n    __local unsigned char *sync_arr_mem_320927;\n    \n    sync_arr_mem_320927 = (__local\n                           unsigned char *) sync_arr_mem_320927_backing_1;\n    \n    int32_t phys_group_id_320929;\n    \n    phys_group_id_320929 = get_group_id(0);\n    for (int32_t i_320930 = 0; i_320930 <\n         sdiv_up32(sext_i64_i32(virt_num_groups_320913) - phys_group_id_320929,\n                   sext_i64_i32(num_groups_297582)); i_320930++) {\n        int32_t virt_group_id_320931 = phys_group_id_320929 + i_320930 *\n                sext_i64_i32(num_groups_297582);\n        int32_t flat_segment_id_320932 = squot32(virt_group_id_320931,\n                                                 sext_i64_i32(groups_per_segment_320911));\n        int64_t global_tid_320933 = srem64(sext_i32_i64(virt_group_id_320931) *\n                                           segred_group_sizze_297581 +\n                                           sext_i32_i64(local_tid_320921),\n                                           segred_group_sizze_297581 *\n                                           groups_per_segment_320911);\n        int64_t slice_320934 = m_292626;\n        int64_t gtid_297585 = sext_i32_i64(flat_segment_id_320932);\n        int64_t remnant_320935 = sext_i32_i64(flat_segment_id_320932) -\n                gtid_297585;\n        int64_t gtid_297586;\n        double x_acc_320936;\n        int64_t chunk_sizze_320937 = smin64(elements_per_t",
            "hread_320912,\n                                            sdiv_up64(n_292627 -\n                                                      global_tid_320933,\n                                                      threads_per_segment_320915));\n        double x_297588;\n        double x_297589;\n        \n        // neutral-initialise the accumulators\n        {\n            x_acc_320936 = 0.0;\n        }\n        for (int64_t i_320941 = 0; i_320941 < chunk_sizze_320937; i_320941++) {\n            gtid_297586 = global_tid_320933 + threads_per_segment_320915 *\n                i_320941;\n            // apply map function\n            {\n                double x_297592;\n                \n                x_297592 = ((__global double *) mem_318498)[gtid_297586];\n                \n                float x_297593;\n                \n                x_297593 = ((__global float *) trend_l_mem_318490)[gtid_297585 *\n                                                                   n_292627 +\n                                                                   gtid_297586];\n                \n                double y_297594 = c11_292659 * x_297592;\n                double x_297595 = b11_292658 + y_297594;\n                double f32_res_297596 = fpconv_f32_f64(x_297593);\n                double defunc_1_f_res_297597 = x_297595 * f32_res_297596;\n                \n                // save map-out results\n                { }\n                // load accumulator\n                {\n                    x_297588 = x_acc_320936;\n                }\n                // load new values\n                {\n                    x_297589 = defunc_1_f_res_297597;\n                }\n                // apply reduction operator\n                {\n                    double defunc_1_op_res_297590 = x_297588 + x_297589;\n                    \n                    // store in accumulator\n                    {\n                        x_acc_320936 = defunc_1_op_res_297590;\n                    }\n                }\n            }\n        }\n        ",
            "// to reduce current chunk, first store our result in memory\n        {\n            x_297588 = x_acc_320936;\n            ((__local\n              double *) red_arr_mem_320925)[sext_i32_i64(local_tid_320921)] =\n                x_297588;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        \n        int32_t offset_320942;\n        int32_t skip_waves_320943 = 1;\n        double x_320938;\n        double x_320939;\n        \n        offset_320942 = 0;\n        // participating threads read initial accumulator\n        {\n            if (slt32(local_tid_320921,\n                      sext_i64_i32(segred_group_sizze_297581))) {\n                x_320938 = ((__local\n                             double *) red_arr_mem_320925)[sext_i32_i64(local_tid_320921 +\n                                                           offset_320942)];\n            }\n        }\n        offset_320942 = 1;\n        while (slt32(offset_320942, wave_sizze_320923)) {\n            if (slt32(local_tid_320921 + offset_320942,\n                      sext_i64_i32(segred_group_sizze_297581)) &&\n                ((local_tid_320921 - squot32(local_tid_320921,\n                                             wave_sizze_320923) *\n                  wave_sizze_320923) & (2 * offset_320942 - 1)) == 0) {\n                // read array element\n                {\n                    x_320939 = ((volatile __local\n                                 double *) red_arr_mem_320925)[sext_i32_i64(local_tid_320921 +\n                                                               offset_320942)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_320940 = x_320938 + x_320939;\n                    \n                    x_320938 = defunc_1_op_res_320940;\n                }\n                // write result of operation\n                {\n                    ((volatile __local\n                      double *) red_arr_mem_320925)[sext_i32_i64(local_tid_320921)] =\n                        x_",
            "320938;\n                }\n            }\n            offset_320942 *= 2;\n        }\n        while (slt32(skip_waves_320943,\n                     squot32(sext_i64_i32(segred_group_sizze_297581) +\n                             wave_sizze_320923 - 1, wave_sizze_320923))) {\n            barrier(CLK_LOCAL_MEM_FENCE);\n            offset_320942 = skip_waves_320943 * wave_sizze_320923;\n            if (slt32(local_tid_320921 + offset_320942,\n                      sext_i64_i32(segred_group_sizze_297581)) &&\n                ((local_tid_320921 - squot32(local_tid_320921,\n                                             wave_sizze_320923) *\n                  wave_sizze_320923) == 0 && (squot32(local_tid_320921,\n                                                      wave_sizze_320923) & (2 *\n                                                                            skip_waves_320943 -\n                                                                            1)) ==\n                 0)) {\n                // read array element\n                {\n                    x_320939 = ((__local\n                                 double *) red_arr_mem_320925)[sext_i32_i64(local_tid_320921 +\n                                                               offset_320942)];\n                }\n                // apply reduction operation\n                {\n                    double defunc_1_op_res_320940 = x_320938 + x_320939;\n                    \n                    x_320938 = defunc_1_op_res_320940;\n                }\n                // write result of operation\n                {\n                    ((__local\n                      double *) red_arr_mem_320925)[sext_i32_i64(local_tid_320921)] =\n                        x_320938;\n                }\n            }\n            skip_waves_320943 *= 2;\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // first thread saves the result in accumulator\n        {\n            if (sext_i32_i64(local_tid_320921) == (int64_t) 0) {\n                x_acc_320936 = x_32093",
            "8;\n            }\n        }\n        if (groups_per_segment_320911 == (int64_t) 1) {\n            // first thread in group saves final result to memory\n            {\n                if (local_tid_320921 == 0) {\n                    ((__global double *) mem_318532)[gtid_297585] =\n                        x_acc_320936;\n                }\n            }\n        } else {\n            int32_t old_counter_320944;\n            \n            // first thread in group saves group result to global memory\n            {\n                if (local_tid_320921 == 0) {\n                    ((__global\n                      double *) segred_tmp_mem_320916)[sext_i32_i64(virt_group_id_320931)] =\n                        x_acc_320936;\n                    mem_fence_global();\n                    old_counter_320944 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) trend_magnitudezicounter_mem_320918)[sext_i32_i64(srem32(flat_segment_id_320932,\n                                                                                                                 10240))],\n                                              (int) 1);\n                    ((__local bool *) sync_arr_mem_320927)[(int64_t) 0] =\n                        old_counter_320944 == groups_per_segment_320911 -\n                        (int64_t) 1;\n                }\n            }\n            barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n            \n            bool is_last_group_320945;\n            \n            is_last_group_320945 = ((__local\n                                     bool *) sync_arr_mem_320927)[(int64_t) 0];\n            if (is_last_group_320945) {\n                if (local_tid_320921 == 0) {\n                    old_counter_320944 =\n                        atomic_add_i32_global(&((volatile __global\n                                                 int *) trend_magnitudezicounter_mem_320918)[sext_i32_i64(srem32(flat_segment_id_320932,\n                        ",
            "                                                                                         10240))],\n                                              (int) ((int64_t) 0 -\n                                                     groups_per_segment_320911));\n                }\n                // read in the per-group-results\n                {\n                    int64_t read_per_thread_320946 =\n                            sdiv_up64(groups_per_segment_320911,\n                                      segred_group_sizze_297581);\n                    \n                    x_297588 = 0.0;\n                    for (int64_t i_320947 = 0; i_320947 <\n                         read_per_thread_320946; i_320947++) {\n                        int64_t group_res_id_320948 =\n                                sext_i32_i64(local_tid_320921) *\n                                read_per_thread_320946 + i_320947;\n                        int64_t index_of_group_res_320949 =\n                                sext_i32_i64(flat_segment_id_320932) *\n                                groups_per_segment_320911 + group_res_id_320948;\n                        \n                        if (slt64(group_res_id_320948,\n                                  groups_per_segment_320911)) {\n                            x_297589 = ((__global\n                                         double *) segred_tmp_mem_320916)[index_of_group_res_320949];\n                            \n                            double defunc_1_op_res_297590 = x_297588 + x_297589;\n                            \n                            x_297588 = defunc_1_op_res_297590;\n                        }\n                    }\n                }\n                ((__local\n                  double *) red_arr_mem_320925)[sext_i32_i64(local_tid_320921)] =\n                    x_297588;\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // reduce the per-group results\n                {\n                    int32_t offset_320950;\n                    int32_t skip_waves_320951 = 1;",
            "\n                    double x_320938;\n                    double x_320939;\n                    \n                    offset_320950 = 0;\n                    // participating threads read initial accumulator\n                    {\n                        if (slt32(local_tid_320921,\n                                  sext_i64_i32(segred_group_sizze_297581))) {\n                            x_320938 = ((__local\n                                         double *) red_arr_mem_320925)[sext_i32_i64(local_tid_320921 +\n                                                                       offset_320950)];\n                        }\n                    }\n                    offset_320950 = 1;\n                    while (slt32(offset_320950, wave_sizze_320923)) {\n                        if (slt32(local_tid_320921 + offset_320950,\n                                  sext_i64_i32(segred_group_sizze_297581)) &&\n                            ((local_tid_320921 - squot32(local_tid_320921,\n                                                         wave_sizze_320923) *\n                              wave_sizze_320923) & (2 * offset_320950 - 1)) ==\n                            0) {\n                            // read array element\n                            {\n                                x_320939 = ((volatile __local\n                                             double *) red_arr_mem_320925)[sext_i32_i64(local_tid_320921 +\n                                                                           offset_320950)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_320940 = x_320938 +\n                                       x_320939;\n                                \n                                x_320938 = defunc_1_op_res_320940;\n                            }\n                            // write result of operation\n                            {\n                                ((vo",
            "latile __local\n                                  double *) red_arr_mem_320925)[sext_i32_i64(local_tid_320921)] =\n                                    x_320938;\n                            }\n                        }\n                        offset_320950 *= 2;\n                    }\n                    while (slt32(skip_waves_320951,\n                                 squot32(sext_i64_i32(segred_group_sizze_297581) +\n                                         wave_sizze_320923 - 1,\n                                         wave_sizze_320923))) {\n                        barrier(CLK_LOCAL_MEM_FENCE);\n                        offset_320950 = skip_waves_320951 * wave_sizze_320923;\n                        if (slt32(local_tid_320921 + offset_320950,\n                                  sext_i64_i32(segred_group_sizze_297581)) &&\n                            ((local_tid_320921 - squot32(local_tid_320921,\n                                                         wave_sizze_320923) *\n                              wave_sizze_320923) == 0 &&\n                             (squot32(local_tid_320921, wave_sizze_320923) &\n                              (2 * skip_waves_320951 - 1)) == 0)) {\n                            // read array element\n                            {\n                                x_320939 = ((__local\n                                             double *) red_arr_mem_320925)[sext_i32_i64(local_tid_320921 +\n                                                                           offset_320950)];\n                            }\n                            // apply reduction operation\n                            {\n                                double defunc_1_op_res_320940 = x_320938 +\n                                       x_320939;\n                                \n                                x_320938 = defunc_1_op_res_320940;\n                            }\n                            // write result of operation\n                            {\n                                ",
            "((__local\n                                  double *) red_arr_mem_320925)[sext_i32_i64(local_tid_320921)] =\n                                    x_320938;\n                            }\n                        }\n                        skip_waves_320951 *= 2;\n                    }\n                    // and back to memory with the final result\n                    {\n                        if (local_tid_320921 == 0) {\n                            ((__global double *) mem_318532)[gtid_297585] =\n                                x_320938;\n                        }\n                    }\n                }\n            }\n        }\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_297581\n}\n__kernel void trend_magnitudezisegred_nonseg_297501(__global\n                                                    int *global_failure,\n                                                    uint red_arr_mem_320841_backing_offset_0,\n                                                    uint red_arr_mem_320839_backing_offset_1,\n                                                    uint sync_arr_mem_320837_backing_offset_2,\n                                                    int64_t n_292627,\n                                                    int64_t num_groups_297494,\n                                                    int64_t num_threads_320831,\n                                                    __global\n                                                    unsigned char *mem_318493,\n                                                    __global\n                                                    unsigned char *mem_318495,\n                                                    __global\n                                                    unsigned char *mem_318498,\n                                                    __global\n                                                    unsigned char *trend_magnitudezicounter_mem_320825,\n        ",
            "                                            __global\n                                                    unsigned char *segred_tmp_mem_320827,\n                                                    __global\n                                                    unsigned char *segred_tmp_mem_320829)\n{\n    #define segred_group_sizze_297492 (trend_magnitudezisegred_group_sizze_297491)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_320841_backing_2 =\n                           &shared_mem[red_arr_mem_320841_backing_offset_0];\n    volatile unsigned char *red_arr_mem_320839_backing_1 =\n                           &shared_mem[red_arr_mem_320839_backing_offset_1];\n    volatile unsigned char *sync_arr_mem_320837_backing_0 =\n                           &shared_mem[sync_arr_mem_320837_backing_offset_2];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_320832;\n    int32_t local_tid_320833;\n    int64_t group_sizze_320836;\n    int32_t wave_sizze_320835;\n    int32_t group_tid_320834;\n    \n    global_tid_320832 = get_global_id(0);\n    local_tid_320833 = get_local_id(0);\n    group_sizze_320836 = get_local_size(0);\n    wave_sizze_320835 = LOCKSTEP_WIDTH;\n    group_tid_320834 = get_group_id(0);\n    \n    int32_t phys_tid_297501 = global_tid_320832;\n    __local unsigned char *sync_arr_mem_320837;\n    \n    sync_arr_mem_320837 = (__local\n                           unsigned char *) sync_arr_mem_320837_backing_0;\n    \n    __local unsigned char *red_arr_mem_320839;\n    \n    red_arr_mem_320839 = (__local unsigned char *) red_arr_mem_320839_backing_1;\n    \n    __local unsigned char *red_arr_mem_320841;\n    \n    red_arr_mem_320841 = (__local unsigned char *) red_arr_mem_320841_backing_2;\n    \n    int64_t dummy_297499 = (int64_t) 0;\n    int64_t gtid_297500 = (int64_t) 0;\n    double x_acc_320843;\n    double x_acc_320844;\n    int64_t chunk_sizze_320845 = smin64(sdiv_up64(n_292627,\n        ",
            "                                          sext_i32_i64(sext_i64_i32(segred_group_sizze_297492 *\n                                                  num_groups_297494))),\n                                        sdiv_up64(n_292627 - phys_tid_297501,\n                                                  num_threads_320831));\n    double x_292639;\n    double x_292640;\n    double x_292642;\n    double x_292643;\n    \n    // neutral-initialise the accumulators\n    {\n        x_acc_320843 = 0.0;\n        x_acc_320844 = 0.0;\n    }\n    for (int64_t i_320852 = 0; i_320852 < chunk_sizze_320845; i_320852++) {\n        gtid_297500 = phys_tid_297501 + num_threads_320831 * i_320852;\n        // apply map function\n        {\n            int64_t x__292646 = add64((int64_t) 1, gtid_297500);\n            double i64_res_292647 = sitofp_i64_f64(x__292646);\n            double defunc_0_f_res_292648 = i64_res_292647 * i64_res_292647;\n            \n            // save map-out results\n            {\n                ((__global double *) mem_318498)[dummy_297499 * n_292627 +\n                                                 gtid_297500] = i64_res_292647;\n            }\n            // load accumulator\n            {\n                x_292639 = x_acc_320843;\n                x_292642 = x_acc_320844;\n            }\n            // load new values\n            {\n                x_292640 = i64_res_292647;\n                x_292643 = defunc_0_f_res_292648;\n            }\n            // apply reduction operator\n            {\n                double defunc_1_op_res_292641 = x_292639 + x_292640;\n                double defunc_1_op_res_292644 = x_292642 + x_292643;\n                \n                // store in accumulator\n                {\n                    x_acc_320843 = defunc_1_op_res_292641;\n                    x_acc_320844 = defunc_1_op_res_292644;\n                }\n            }\n        }\n    }\n    // to reduce current chunk, first store our result in memory\n    {\n        x_292639 = x_acc_320843;\n        x_292642 = x_acc_320",
            "844;\n        ((__local\n          double *) red_arr_mem_320839)[sext_i32_i64(local_tid_320833)] =\n            x_292639;\n        ((__local\n          double *) red_arr_mem_320841)[sext_i32_i64(local_tid_320833)] =\n            x_292642;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    \n    int32_t offset_320853;\n    int32_t skip_waves_320854 = 1;\n    double x_320846;\n    double x_320847;\n    double x_320848;\n    double x_320849;\n    \n    offset_320853 = 0;\n    // participating threads read initial accumulator\n    {\n        if (slt32(local_tid_320833, sext_i64_i32(segred_group_sizze_297492))) {\n            x_320846 = ((__local\n                         double *) red_arr_mem_320839)[sext_i32_i64(local_tid_320833 +\n                                                       offset_320853)];\n            x_320847 = ((__local\n                         double *) red_arr_mem_320841)[sext_i32_i64(local_tid_320833 +\n                                                       offset_320853)];\n        }\n    }\n    offset_320853 = 1;\n    while (slt32(offset_320853, wave_sizze_320835)) {\n        if (slt32(local_tid_320833 + offset_320853,\n                  sext_i64_i32(segred_group_sizze_297492)) &&\n            ((local_tid_320833 - squot32(local_tid_320833, wave_sizze_320835) *\n              wave_sizze_320835) & (2 * offset_320853 - 1)) == 0) {\n            // read array element\n            {\n                x_320848 = ((volatile __local\n                             double *) red_arr_mem_320839)[sext_i32_i64(local_tid_320833 +\n                                                           offset_320853)];\n                x_320849 = ((volatile __local\n                             double *) red_arr_mem_320841)[sext_i32_i64(local_tid_320833 +\n                                                           offset_320853)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_320850 = x_320846 + x_320848;\n                double defunc_1_op_res_320851 = x_320847 ",
            "+ x_320849;\n                \n                x_320846 = defunc_1_op_res_320850;\n                x_320847 = defunc_1_op_res_320851;\n            }\n            // write result of operation\n            {\n                ((volatile __local\n                  double *) red_arr_mem_320839)[sext_i32_i64(local_tid_320833)] =\n                    x_320846;\n                ((volatile __local\n                  double *) red_arr_mem_320841)[sext_i32_i64(local_tid_320833)] =\n                    x_320847;\n            }\n        }\n        offset_320853 *= 2;\n    }\n    while (slt32(skip_waves_320854,\n                 squot32(sext_i64_i32(segred_group_sizze_297492) +\n                         wave_sizze_320835 - 1, wave_sizze_320835))) {\n        barrier(CLK_LOCAL_MEM_FENCE);\n        offset_320853 = skip_waves_320854 * wave_sizze_320835;\n        if (slt32(local_tid_320833 + offset_320853,\n                  sext_i64_i32(segred_group_sizze_297492)) &&\n            ((local_tid_320833 - squot32(local_tid_320833, wave_sizze_320835) *\n              wave_sizze_320835) == 0 && (squot32(local_tid_320833,\n                                                  wave_sizze_320835) & (2 *\n                                                                        skip_waves_320854 -\n                                                                        1)) ==\n             0)) {\n            // read array element\n            {\n                x_320848 = ((__local\n                             double *) red_arr_mem_320839)[sext_i32_i64(local_tid_320833 +\n                                                           offset_320853)];\n                x_320849 = ((__local\n                             double *) red_arr_mem_320841)[sext_i32_i64(local_tid_320833 +\n                                                           offset_320853)];\n            }\n            // apply reduction operation\n            {\n                double defunc_1_op_res_320850 = x_320846 + x_320848;\n                double defunc_1_op_res_320851 = x_3",
            "20847 + x_320849;\n                \n                x_320846 = defunc_1_op_res_320850;\n                x_320847 = defunc_1_op_res_320851;\n            }\n            // write result of operation\n            {\n                ((__local\n                  double *) red_arr_mem_320839)[sext_i32_i64(local_tid_320833)] =\n                    x_320846;\n                ((__local\n                  double *) red_arr_mem_320841)[sext_i32_i64(local_tid_320833)] =\n                    x_320847;\n            }\n        }\n        skip_waves_320854 *= 2;\n    }\n    barrier(CLK_LOCAL_MEM_FENCE);\n    // first thread saves the result in accumulator\n    {\n        if (sext_i32_i64(local_tid_320833) == (int64_t) 0) {\n            x_acc_320843 = x_320846;\n            x_acc_320844 = x_320847;\n        }\n    }\n    \n    int32_t old_counter_320855;\n    \n    // first thread in group saves group result to global memory\n    {\n        if (local_tid_320833 == 0) {\n            ((__global\n              double *) segred_tmp_mem_320827)[sext_i32_i64(group_tid_320834)] =\n                x_acc_320843;\n            ((__global\n              double *) segred_tmp_mem_320829)[sext_i32_i64(group_tid_320834)] =\n                x_acc_320844;\n            mem_fence_global();\n            old_counter_320855 = atomic_add_i32_global(&((volatile __global\n                                                          int *) trend_magnitudezicounter_mem_320825)[(int64_t) 0],\n                                                       (int) 1);\n            ((__local bool *) sync_arr_mem_320837)[(int64_t) 0] =\n                old_counter_320855 == num_groups_297494 - (int64_t) 1;\n        }\n    }\n    barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    \n    bool is_last_group_320856;\n    \n    is_last_group_320856 = ((__local bool *) sync_arr_mem_320837)[(int64_t) 0];\n    if (is_last_group_320856) {\n        if (local_tid_320833 == 0) {\n            old_counter_320855 = atomic_add_i32_global(&((volatile __global\n                              ",
            "                            int *) trend_magnitudezicounter_mem_320825)[(int64_t) 0],\n                                                       (int) ((int64_t) 0 -\n                                                              num_groups_297494));\n        }\n        // read in the per-group-results\n        {\n            int64_t read_per_thread_320857 = sdiv_up64(num_groups_297494,\n                                                       segred_group_sizze_297492);\n            \n            x_292639 = 0.0;\n            x_292642 = 0.0;\n            for (int64_t i_320858 = 0; i_320858 < read_per_thread_320857;\n                 i_320858++) {\n                int64_t group_res_id_320859 = sext_i32_i64(local_tid_320833) *\n                        read_per_thread_320857 + i_320858;\n                int64_t index_of_group_res_320860 = group_res_id_320859;\n                \n                if (slt64(group_res_id_320859, num_groups_297494)) {\n                    x_292640 = ((__global\n                                 double *) segred_tmp_mem_320827)[index_of_group_res_320860];\n                    x_292643 = ((__global\n                                 double *) segred_tmp_mem_320829)[index_of_group_res_320860];\n                    \n                    double defunc_1_op_res_292641 = x_292639 + x_292640;\n                    double defunc_1_op_res_292644 = x_292642 + x_292643;\n                    \n                    x_292639 = defunc_1_op_res_292641;\n                    x_292642 = defunc_1_op_res_292644;\n                }\n            }\n        }\n        ((__local\n          double *) red_arr_mem_320839)[sext_i32_i64(local_tid_320833)] =\n            x_292639;\n        ((__local\n          double *) red_arr_mem_320841)[sext_i32_i64(local_tid_320833)] =\n            x_292642;\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // reduce the per-group results\n        {\n            int32_t offset_320861;\n            int32_t skip_waves_320862 = 1;\n            double x_320846;\n            double x_320847;\n  ",
            "          double x_320848;\n            double x_320849;\n            \n            offset_320861 = 0;\n            // participating threads read initial accumulator\n            {\n                if (slt32(local_tid_320833,\n                          sext_i64_i32(segred_group_sizze_297492))) {\n                    x_320846 = ((__local\n                                 double *) red_arr_mem_320839)[sext_i32_i64(local_tid_320833 +\n                                                               offset_320861)];\n                    x_320847 = ((__local\n                                 double *) red_arr_mem_320841)[sext_i32_i64(local_tid_320833 +\n                                                               offset_320861)];\n                }\n            }\n            offset_320861 = 1;\n            while (slt32(offset_320861, wave_sizze_320835)) {\n                if (slt32(local_tid_320833 + offset_320861,\n                          sext_i64_i32(segred_group_sizze_297492)) &&\n                    ((local_tid_320833 - squot32(local_tid_320833,\n                                                 wave_sizze_320835) *\n                      wave_sizze_320835) & (2 * offset_320861 - 1)) == 0) {\n                    // read array element\n                    {\n                        x_320848 = ((volatile __local\n                                     double *) red_arr_mem_320839)[sext_i32_i64(local_tid_320833 +\n                                                                   offset_320861)];\n                        x_320849 = ((volatile __local\n                                     double *) red_arr_mem_320841)[sext_i32_i64(local_tid_320833 +\n                                                                   offset_320861)];\n                    }\n                    // apply reduction operation\n                    {\n                        double defunc_1_op_res_320850 = x_320846 + x_320848;\n                        double defunc_1_op_res_320851 = x_320847 + x_320849;\n                        \n",
            "                        x_320846 = defunc_1_op_res_320850;\n                        x_320847 = defunc_1_op_res_320851;\n                    }\n                    // write result of operation\n                    {\n                        ((volatile __local\n                          double *) red_arr_mem_320839)[sext_i32_i64(local_tid_320833)] =\n                            x_320846;\n                        ((volatile __local\n                          double *) red_arr_mem_320841)[sext_i32_i64(local_tid_320833)] =\n                            x_320847;\n                    }\n                }\n                offset_320861 *= 2;\n            }\n            while (slt32(skip_waves_320862,\n                         squot32(sext_i64_i32(segred_group_sizze_297492) +\n                                 wave_sizze_320835 - 1, wave_sizze_320835))) {\n                barrier(CLK_LOCAL_MEM_FENCE);\n                offset_320861 = skip_waves_320862 * wave_sizze_320835;\n                if (slt32(local_tid_320833 + offset_320861,\n                          sext_i64_i32(segred_group_sizze_297492)) &&\n                    ((local_tid_320833 - squot32(local_tid_320833,\n                                                 wave_sizze_320835) *\n                      wave_sizze_320835) == 0 && (squot32(local_tid_320833,\n                                                          wave_sizze_320835) &\n                                                  (2 * skip_waves_320862 -\n                                                   1)) == 0)) {\n                    // read array element\n                    {\n                        x_320848 = ((__local\n                                     double *) red_arr_mem_320839)[sext_i32_i64(local_tid_320833 +\n                                                                   offset_320861)];\n                        x_320849 = ((__local\n                                     double *) red_arr_mem_320841)[sext_i32_i64(local_tid_320833 +\n                                             ",
            "                      offset_320861)];\n                    }\n                    // apply reduction operation\n                    {\n                        double defunc_1_op_res_320850 = x_320846 + x_320848;\n                        double defunc_1_op_res_320851 = x_320847 + x_320849;\n                        \n                        x_320846 = defunc_1_op_res_320850;\n                        x_320847 = defunc_1_op_res_320851;\n                    }\n                    // write result of operation\n                    {\n                        ((__local\n                          double *) red_arr_mem_320839)[sext_i32_i64(local_tid_320833)] =\n                            x_320846;\n                        ((__local\n                          double *) red_arr_mem_320841)[sext_i32_i64(local_tid_320833)] =\n                            x_320847;\n                    }\n                }\n                skip_waves_320862 *= 2;\n            }\n            // and back to memory with the final result\n            {\n                if (local_tid_320833 == 0) {\n                    ((__global double *) mem_318493)[(int64_t) 0] = x_320846;\n                    ((__global double *) mem_318495)[(int64_t) 0] = x_320847;\n                }\n            }\n        }\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_297492\n}\n__kernel void trend_magnitudezisegred_small_297587(__global int *global_failure,\n                                                   uint red_arr_mem_320891_backing_offset_0,\n                                                   int64_t m_292626,\n                                                   int64_t n_292627,\n                                                   double b11_292658,\n                                                   double c11_292659,\n                                                   int64_t num_groups_297582,\n                                                   int64_t segment_sizze_nonzzero_320884,\n                                                   __g",
            "lobal\n                                                   unsigned char *trend_l_mem_318490,\n                                                   __global\n                                                   unsigned char *mem_318498,\n                                                   __global\n                                                   unsigned char *mem_318532)\n{\n    #define segred_group_sizze_297581 (trend_magnitudezisegred_group_sizze_297559)\n    \n    const int block_dim0 = 0;\n    const int block_dim1 = 1;\n    const int block_dim2 = 2;\n    volatile unsigned char *red_arr_mem_320891_backing_0 =\n                           &shared_mem[red_arr_mem_320891_backing_offset_0];\n    \n    if (*global_failure >= 0)\n        return;\n    \n    int32_t global_tid_320886;\n    int32_t local_tid_320887;\n    int64_t group_sizze_320890;\n    int32_t wave_sizze_320889;\n    int32_t group_tid_320888;\n    \n    global_tid_320886 = get_global_id(0);\n    local_tid_320887 = get_local_id(0);\n    group_sizze_320890 = get_local_size(0);\n    wave_sizze_320889 = LOCKSTEP_WIDTH;\n    group_tid_320888 = get_group_id(0);\n    \n    int32_t phys_tid_297587 = global_tid_320886;\n    __local unsigned char *red_arr_mem_320891;\n    \n    red_arr_mem_320891 = (__local unsigned char *) red_arr_mem_320891_backing_0;\n    \n    int32_t phys_group_id_320893;\n    \n    phys_group_id_320893 = get_group_id(0);\n    for (int32_t i_320894 = 0; i_320894 <\n         sdiv_up32(sext_i64_i32(sdiv_up64(m_292626,\n                                          squot64(segred_group_sizze_297581,\n                                                  segment_sizze_nonzzero_320884))) -\n                   phys_group_id_320893, sext_i64_i32(num_groups_297582));\n         i_320894++) {\n        int32_t virt_group_id_320895 = phys_group_id_320893 + i_320894 *\n                sext_i64_i32(num_groups_297582);\n        int64_t slice_320896 = m_292626;\n        int64_t gtid_297585 = squot64(sext_i32_i64(local_tid_320887),\n                                 ",
            "     segment_sizze_nonzzero_320884) +\n                sext_i32_i64(virt_group_id_320895) *\n                squot64(segred_group_sizze_297581,\n                        segment_sizze_nonzzero_320884);\n        int64_t remnant_320897 = squot64(sext_i32_i64(local_tid_320887),\n                                         segment_sizze_nonzzero_320884) +\n                sext_i32_i64(virt_group_id_320895) *\n                squot64(segred_group_sizze_297581,\n                        segment_sizze_nonzzero_320884) - gtid_297585;\n        int64_t gtid_297586 = srem64(sext_i32_i64(local_tid_320887), n_292627);\n        \n        // apply map function if in bounds\n        {\n            if (slt64((int64_t) 0, n_292627) && (slt64(gtid_297585, m_292626) &&\n                                                 slt64(sext_i32_i64(local_tid_320887),\n                                                       n_292627 *\n                                                       squot64(segred_group_sizze_297581,\n                                                               segment_sizze_nonzzero_320884)))) {\n                double x_297592;\n                \n                x_297592 = ((__global double *) mem_318498)[gtid_297586];\n                \n                float x_297593;\n                \n                x_297593 = ((__global float *) trend_l_mem_318490)[gtid_297585 *\n                                                                   n_292627 +\n                                                                   gtid_297586];\n                \n                double y_297594 = c11_292659 * x_297592;\n                double x_297595 = b11_292658 + y_297594;\n                double f32_res_297596 = fpconv_f32_f64(x_297593);\n                double defunc_1_f_res_297597 = x_297595 * f32_res_297596;\n                \n                // save map-out results\n                { }\n                // save results to be reduced\n                {\n                    ((__local\n                      double *) red_arr_mem_",
            "320891)[sext_i32_i64(local_tid_320887)] =\n                        defunc_1_f_res_297597;\n                }\n            } else {\n                ((__local\n                  double *) red_arr_mem_320891)[sext_i32_i64(local_tid_320887)] =\n                    0.0;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        if (slt64((int64_t) 0, n_292627)) {\n            // perform segmented scan to imitate reduction\n            {\n                double x_297588;\n                double x_297589;\n                double x_320898;\n                double x_320899;\n                bool ltid_in_bounds_320901 =\n                     slt64(sext_i32_i64(local_tid_320887), n_292627 *\n                           squot64(segred_group_sizze_297581,\n                                   segment_sizze_nonzzero_320884));\n                int32_t skip_threads_320902;\n                \n                // read input for in-block scan\n                {\n                    if (ltid_in_bounds_320901) {\n                        x_297589 = ((volatile __local\n                                     double *) red_arr_mem_320891)[sext_i32_i64(local_tid_320887)];\n                        if ((local_tid_320887 - squot32(local_tid_320887, 32) *\n                             32) == 0) {\n                            x_297588 = x_297589;\n                        }\n                    }\n                }\n                // in-block scan (hopefully no barriers needed)\n                {\n                    skip_threads_320902 = 1;\n                    while (slt32(skip_threads_320902, 32)) {\n                        bool thread_active_320903 = sle32(skip_threads_320902,\n                                                          local_tid_320887 -\n                                                          squot32(local_tid_320887,\n                                                                  32) * 32) &&\n                             ltid_in_bounds_320901;\n                        \n                        if (thre",
            "ad_active_320903) {\n                            // read operands\n                            {\n                                x_297588 = ((volatile __local\n                                             double *) red_arr_mem_320891)[sext_i32_i64(local_tid_320887) -\n                                                                           sext_i32_i64(skip_threads_320902)];\n                            }\n                        }\n                        // perform operation\n                        {\n                            bool inactive_320904 =\n                                 slt64(srem64(sext_i32_i64(local_tid_320887),\n                                              n_292627),\n                                       sext_i32_i64(local_tid_320887) -\n                                       sext_i32_i64(local_tid_320887 -\n                                       skip_threads_320902));\n                            \n                            if (thread_active_320903 && inactive_320904) {\n                                x_297588 = x_297589;\n                            }\n                            if (thread_active_320903) {\n                                if (!inactive_320904) {\n                                    double defunc_1_op_res_297590 = x_297588 +\n                                           x_297589;\n                                    \n                                    x_297588 = defunc_1_op_res_297590;\n                                }\n                            }\n                        }\n                        if (sle32(wave_sizze_320889, skip_threads_320902)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        if (thread_active_320903) {\n                            // write result\n                            {\n                                ((volatile __local\n                                  double *) red_arr_mem_320891)[sext_i32_i64(local_tid_320887)] =\n                                    x_297",
            "588;\n                                x_297589 = x_297588;\n                            }\n                        }\n                        if (sle32(wave_sizze_320889, skip_threads_320902)) {\n                            barrier(CLK_LOCAL_MEM_FENCE);\n                        }\n                        skip_threads_320902 *= 2;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // last thread of block 'i' writes its result to offset 'i'\n                {\n                    if ((local_tid_320887 - squot32(local_tid_320887, 32) *\n                         32) == 31 && ltid_in_bounds_320901) {\n                        ((volatile __local\n                          double *) red_arr_mem_320891)[sext_i32_i64(squot32(local_tid_320887,\n                                                                             32))] =\n                            x_297588;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // scan the first block, after which offset 'i' contains carry-in for block 'i+1'\n                {\n                    int32_t skip_threads_320905;\n                    \n                    // read input for in-block scan\n                    {\n                        if (squot32(local_tid_320887, 32) == 0 &&\n                            ltid_in_bounds_320901) {\n                            x_320899 = ((volatile __local\n                                         double *) red_arr_mem_320891)[sext_i32_i64(local_tid_320887)];\n                            if ((local_tid_320887 - squot32(local_tid_320887,\n                                                            32) * 32) == 0) {\n                                x_320898 = x_320899;\n                            }\n                        }\n                    }\n                    // in-block scan (hopefully no barriers needed)\n                    {\n                        skip_threads_320905 = 1;\n                        while (slt32(skip_",
            "threads_320905, 32)) {\n                            bool thread_active_320906 =\n                                 sle32(skip_threads_320905, local_tid_320887 -\n                                       squot32(local_tid_320887, 32) * 32) &&\n                                 (squot32(local_tid_320887, 32) == 0 &&\n                                  ltid_in_bounds_320901);\n                            \n                            if (thread_active_320906) {\n                                // read operands\n                                {\n                                    x_320898 = ((volatile __local\n                                                 double *) red_arr_mem_320891)[sext_i32_i64(local_tid_320887) -\n                                                                               sext_i32_i64(skip_threads_320905)];\n                                }\n                            }\n                            // perform operation\n                            {\n                                bool inactive_320907 =\n                                     slt64(srem64(sext_i32_i64(local_tid_320887 *\n                                                  32 + 32 - 1), n_292627),\n                                           sext_i32_i64(local_tid_320887 * 32 +\n                                           32 - 1) -\n                                           sext_i32_i64((local_tid_320887 -\n                                                         skip_threads_320905) *\n                                           32 + 32 - 1));\n                                \n                                if (thread_active_320906 && inactive_320907) {\n                                    x_320898 = x_320899;\n                                }\n                                if (thread_active_320906) {\n                                    if (!inactive_320907) {\n                                        double defunc_1_op_res_320900 =\n                                               x_320898 + x_320899;\n        ",
            "                                \n                                        x_320898 = defunc_1_op_res_320900;\n                                    }\n                                }\n                            }\n                            if (sle32(wave_sizze_320889, skip_threads_320905)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            if (thread_active_320906) {\n                                // write result\n                                {\n                                    ((volatile __local\n                                      double *) red_arr_mem_320891)[sext_i32_i64(local_tid_320887)] =\n                                        x_320898;\n                                    x_320899 = x_320898;\n                                }\n                            }\n                            if (sle32(wave_sizze_320889, skip_threads_320905)) {\n                                barrier(CLK_LOCAL_MEM_FENCE);\n                            }\n                            skip_threads_320905 *= 2;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                \n                bool no_carry_in_320908 = squot32(local_tid_320887, 32) == 0 ||\n                     !ltid_in_bounds_320901;\n                \n                // carry-in for every block except the first\n                {\n                    // read operands\n                    {\n                        if (!no_carry_in_320908) {\n                            x_297589 = x_297588;\n                            x_297588 = ((__local\n                                         double *) red_arr_mem_320891)[sext_i32_i64(squot32(local_tid_320887,\n                                                                                            32)) -\n                                                                       (int64_t) 1];\n                        }\n                    }\n                    // p",
            "erform operation\n                    {\n                        bool inactive_320909 =\n                             slt64(srem64(sext_i32_i64(local_tid_320887),\n                                          n_292627),\n                                   sext_i32_i64(local_tid_320887) -\n                                   sext_i32_i64(squot32(local_tid_320887, 32) *\n                                   32 - 1));\n                        \n                        if (!no_carry_in_320908) {\n                            if (inactive_320909) {\n                                x_297588 = x_297589;\n                            }\n                        }\n                        if (!no_carry_in_320908) {\n                            if (!inactive_320909) {\n                                double defunc_1_op_res_297590 = x_297588 +\n                                       x_297589;\n                                \n                                x_297588 = defunc_1_op_res_297590;\n                            }\n                        }\n                    }\n                    // write final result\n                    {\n                        if (!no_carry_in_320908) {\n                            ((__local\n                              double *) red_arr_mem_320891)[sext_i32_i64(local_tid_320887)] =\n                                x_297588;\n                        }\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n                // restore correct values for first block\n                {\n                    if (squot32(local_tid_320887, 32) == 0 &&\n                        ltid_in_bounds_320901) {\n                        ((__local\n                          double *) red_arr_mem_320891)[sext_i32_i64(local_tid_320887)] =\n                            x_297589;\n                    }\n                }\n                barrier(CLK_LOCAL_MEM_FENCE);\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        // save final values of segments\n        {\n    ",
            "        if (slt64(sext_i32_i64(virt_group_id_320895) *\n                      squot64(segred_group_sizze_297581,\n                              segment_sizze_nonzzero_320884) +\n                      sext_i32_i64(local_tid_320887), m_292626) &&\n                slt64(sext_i32_i64(local_tid_320887),\n                      squot64(segred_group_sizze_297581,\n                              segment_sizze_nonzzero_320884))) {\n                double tmp_320910;\n                \n                tmp_320910 = ((__local\n                               double *) red_arr_mem_320891)[(sext_i32_i64(local_tid_320887) +\n                                                              (int64_t) 1) *\n                                                             segment_sizze_nonzzero_320884 -\n                                                             (int64_t) 1];\n                ((__global\n                  double *) mem_318532)[sext_i32_i64(virt_group_id_320895) *\n                                        squot64(segred_group_sizze_297581,\n                                                segment_sizze_nonzzero_320884) +\n                                        sext_i32_i64(local_tid_320887)] =\n                    tmp_320910;\n            }\n        }\n        barrier(CLK_LOCAL_MEM_FENCE);\n        barrier(CLK_GLOBAL_MEM_FENCE | CLK_LOCAL_MEM_FENCE);\n    }\n    \n  error_1:\n    return;\n    #undef segred_group_sizze_297581\n}\n",
            NULL};
static const char *tuning_param_names[] =
                  {"builtin#replicate_f32.group_size_325749",
                   "builtin#replicate_f64.group_size_321589",
                   "builtin#replicate_i32.group_size_325106",
                   "builtin#replicate_i64.group_size_321089",
                   "builtin#replicate_i8.group_size_320844",
                   "main.L2_size_325336", "main.group_size_321107",
                   "main.group_size_321324", "main.seghist_group_size_316938",
                   "main.seghist_num_groups_316940",
                   "main.segmap_group_size_297619",
                   "main.segmap_group_size_297673",
                   "main.segmap_group_size_297830",
                   "main.segmap_group_size_298102",
                   "main.segmap_group_size_298957",
                   "main.segmap_group_size_299196",
                   "main.segmap_group_size_299227",
                   "main.segmap_group_size_299959",
                   "main.segmap_group_size_300163",
                   "main.segmap_group_size_300189",
                   "main.segmap_group_size_300585",
                   "main.segmap_group_size_300789",
                   "main.segmap_group_size_300815",
                   "main.segmap_group_size_300988",
                   "main.segmap_group_size_301054",
                   "main.segmap_group_size_301208",
                   "main.segmap_group_size_301513",
                   "main.segmap_group_size_301914",
                   "main.segmap_group_size_303532",
                   "main.segmap_group_size_303958",
                   "main.segmap_group_size_304045",
                   "main.segmap_group_size_304773",
                   "main.segmap_group_size_305331",
                   "main.segmap_group_size_305437",
                   "main.segmap_group_size_306361",
                   "main.segmap_group_size_307056",
                   "main.segmap_group_size_307191",
                   "main.segmap_group_size_308343",
                   "main.segmap_group_size_308739",
                   "main.segmap_group_size_308810",
                   "main.segmap_group_size_308941",
                   "main.segmap_group_size_309072",
                   "main.segmap_group_size_309203",
                   "main.segmap_group_size_309354",
                   "main.segmap_group_size_309568",
                   "main.segmap_group_size_310562",
                   "main.segmap_group_size_310946",
                   "main.segmap_group_size_311443",
                   "main.segmap_group_size_311956",
                   "main.segmap_group_size_312143",
                   "main.segmap_group_size_312186",
                   "main.segmap_group_size_312283",
                   "main.segmap_group_size_312339",
                   "main.segmap_group_size_312486",
                   "main.segmap_group_size_312614",
                   "main.segmap_group_size_312670",
                   "main.segmap_group_size_312849",
                   "main.segmap_group_size_313011",
                   "main.segmap_group_size_313067",
                   "main.segmap_group_size_313369",
                   "main.segmap_group_size_313425",
                   "main.segmap_group_size_313688",
                   "main.segmap_group_size_313744",
                   "main.segmap_group_size_314103",
                   "main.segmap_group_size_314159",
                   "main.segmap_group_size_314443",
                   "main.segmap_group_size_314643",
                   "main.segmap_group_size_314699",
                   "main.segmap_group_size_314985",
                   "main.segmap_group_size_315242",
                   "main.segmap_group_size_315298",
                   "main.segmap_group_size_315640",
                   "main.segmap_group_size_315968",
                   "main.segmap_group_size_316024",
                   "main.segmap_group_size_316306",
                   "main.segmap_group_size_316564",
                   "main.segmap_group_size_316607",
                   "main.segmap_group_size_316689",
                   "main.segmap_group_size_316729",
                   "main.segmap_group_size_316803",
                   "main.segmap_group_size_316824",
                   "main.segmap_group_size_316864",
                   "main.segmap_group_size_316890",
                   "main.segmap_group_size_316970",
                   "main.segmap_group_size_317054",
                   "main.segmap_group_size_317060",
                   "main.segmap_group_size_317120",
                   "main.segmap_group_size_317128",
                   "main.segmap_group_size_317254",
                   "main.segmap_group_size_317416",
                   "main.segmap_group_size_317506",
                   "main.segmap_num_groups_297621",
                   "main.segmap_num_groups_303534",
                   "main.segmap_num_groups_304775",
                   "main.segmap_num_groups_306363",
                   "main.segmap_num_groups_317508",
                   "main.segred_group_size_303886",
                   "main.segred_group_size_303989",
                   "main.segred_group_size_305237",
                   "main.segred_group_size_305373",
                   "main.segred_group_size_306945",
                   "main.segred_group_size_307119",
                   "main.segred_group_size_308836",
                   "main.segred_group_size_308967",
                   "main.segred_group_size_309098",
                   "main.segred_group_size_310508",
                   "main.segred_group_size_310576",
                   "main.segred_group_size_310874",
                   "main.segred_group_size_310971",
                   "main.segred_group_size_311358",
                   "main.segred_group_size_311489",
                   "main.segred_group_size_314386",
                   "main.segred_group_size_314457",
                   "main.segred_group_size_314910",
                   "main.segred_group_size_315010",
                   "main.segred_group_size_315552",
                   "main.segred_group_size_315686",
                   "main.segred_group_size_316741",
                   "main.segred_group_size_317285",
                   "main.segred_num_groups_303888",
                   "main.segred_num_groups_303991",
                   "main.segred_num_groups_305239",
                   "main.segred_num_groups_305375",
                   "main.segred_num_groups_306947",
                   "main.segred_num_groups_307121",
                   "main.segred_num_groups_308838",
                   "main.segred_num_groups_308969",
                   "main.segred_num_groups_309100",
                   "main.segred_num_groups_310510",
                   "main.segred_num_groups_310578",
                   "main.segred_num_groups_310876",
                   "main.segred_num_groups_310973",
                   "main.segred_num_groups_311360",
                   "main.segred_num_groups_311491",
                   "main.segred_num_groups_314388",
                   "main.segred_num_groups_314459",
                   "main.segred_num_groups_314912",
                   "main.segred_num_groups_315012",
                   "main.segred_num_groups_315554",
                   "main.segred_num_groups_315688",
                   "main.segred_num_groups_316743",
                   "main.segred_num_groups_317287",
                   "main.segscan_group_size_297609",
                   "main.segscan_group_size_297729",
                   "main.segscan_group_size_298171",
                   "main.segscan_group_size_308869",
                   "main.segscan_group_size_309000",
                   "main.segscan_group_size_309131",
                   "main.segscan_group_size_316880",
                   "main.segscan_group_size_317110",
                   "main.segscan_num_groups_297611",
                   "main.segscan_num_groups_297731",
                   "main.segscan_num_groups_298173",
                   "main.segscan_num_groups_308871",
                   "main.segscan_num_groups_309002",
                   "main.segscan_num_groups_309133",
                   "main.segscan_num_groups_316882",
                   "main.segscan_num_groups_317112", "main.suff_intra_par_0",
                   "main.suff_intra_par_1", "main.suff_intra_par_10",
                   "main.suff_intra_par_12", "main.suff_intra_par_16",
                   "main.suff_intra_par_2", "main.suff_intra_par_3",
                   "main.suff_intra_par_4", "main.suff_intra_par_5",
                   "main.suff_intra_par_6", "main.suff_intra_par_8",
                   "main.suff_outer_par_11", "main.suff_outer_par_13",
                   "main.suff_outer_par_14", "main.suff_outer_par_15",
                   "main.suff_outer_par_17", "main.suff_outer_par_18",
                   "main.suff_outer_par_7", "main.suff_outer_par_9",
                   "seasonal_amplitude.segmap_group_size_297387",
                   "seasonal_amplitude.segmap_group_size_297429",
                   "seasonal_amplitude.segred_group_size_297442",
                   "seasonal_amplitude.segred_num_groups_297444",
                   "seasonal_amplitude.suff_outer_par_0",
                   "trend_magnitude.segmap_group_size_297507",
                   "trend_magnitude.segmap_group_size_297548",
                   "trend_magnitude.segred_group_size_297491",
                   "trend_magnitude.segred_group_size_297559",
                   "trend_magnitude.segred_num_groups_297493",
                   "trend_magnitude.segred_num_groups_297561",
                   "trend_magnitude.suff_outer_par_0"};
static const char *tuning_param_vars[] =
                  {"builtinzhreplicate_f32zigroup_sizze_325749",
                   "builtinzhreplicate_f64zigroup_sizze_321589",
                   "builtinzhreplicate_i32zigroup_sizze_325106",
                   "builtinzhreplicate_i64zigroup_sizze_321089",
                   "builtinzhreplicate_i8zigroup_sizze_320844",
                   "mainziL2_sizze_325336", "mainzigroup_sizze_321107",
                   "mainzigroup_sizze_321324",
                   "mainziseghist_group_sizze_316938",
                   "mainziseghist_num_groups_316940",
                   "mainzisegmap_group_sizze_297619",
                   "mainzisegmap_group_sizze_297673",
                   "mainzisegmap_group_sizze_297830",
                   "mainzisegmap_group_sizze_298102",
                   "mainzisegmap_group_sizze_298957",
                   "mainzisegmap_group_sizze_299196",
                   "mainzisegmap_group_sizze_299227",
                   "mainzisegmap_group_sizze_299959",
                   "mainzisegmap_group_sizze_300163",
                   "mainzisegmap_group_sizze_300189",
                   "mainzisegmap_group_sizze_300585",
                   "mainzisegmap_group_sizze_300789",
                   "mainzisegmap_group_sizze_300815",
                   "mainzisegmap_group_sizze_300988",
                   "mainzisegmap_group_sizze_301054",
                   "mainzisegmap_group_sizze_301208",
                   "mainzisegmap_group_sizze_301513",
                   "mainzisegmap_group_sizze_301914",
                   "mainzisegmap_group_sizze_303532",
                   "mainzisegmap_group_sizze_303958",
                   "mainzisegmap_group_sizze_304045",
                   "mainzisegmap_group_sizze_304773",
                   "mainzisegmap_group_sizze_305331",
                   "mainzisegmap_group_sizze_305437",
                   "mainzisegmap_group_sizze_306361",
                   "mainzisegmap_group_sizze_307056",
                   "mainzisegmap_group_sizze_307191",
                   "mainzisegmap_group_sizze_308343",
                   "mainzisegmap_group_sizze_308739",
                   "mainzisegmap_group_sizze_308810",
                   "mainzisegmap_group_sizze_308941",
                   "mainzisegmap_group_sizze_309072",
                   "mainzisegmap_group_sizze_309203",
                   "mainzisegmap_group_sizze_309354",
                   "mainzisegmap_group_sizze_309568",
                   "mainzisegmap_group_sizze_310562",
                   "mainzisegmap_group_sizze_310946",
                   "mainzisegmap_group_sizze_311443",
                   "mainzisegmap_group_sizze_311956",
                   "mainzisegmap_group_sizze_312143",
                   "mainzisegmap_group_sizze_312186",
                   "mainzisegmap_group_sizze_312283",
                   "mainzisegmap_group_sizze_312339",
                   "mainzisegmap_group_sizze_312486",
                   "mainzisegmap_group_sizze_312614",
                   "mainzisegmap_group_sizze_312670",
                   "mainzisegmap_group_sizze_312849",
                   "mainzisegmap_group_sizze_313011",
                   "mainzisegmap_group_sizze_313067",
                   "mainzisegmap_group_sizze_313369",
                   "mainzisegmap_group_sizze_313425",
                   "mainzisegmap_group_sizze_313688",
                   "mainzisegmap_group_sizze_313744",
                   "mainzisegmap_group_sizze_314103",
                   "mainzisegmap_group_sizze_314159",
                   "mainzisegmap_group_sizze_314443",
                   "mainzisegmap_group_sizze_314643",
                   "mainzisegmap_group_sizze_314699",
                   "mainzisegmap_group_sizze_314985",
                   "mainzisegmap_group_sizze_315242",
                   "mainzisegmap_group_sizze_315298",
                   "mainzisegmap_group_sizze_315640",
                   "mainzisegmap_group_sizze_315968",
                   "mainzisegmap_group_sizze_316024",
                   "mainzisegmap_group_sizze_316306",
                   "mainzisegmap_group_sizze_316564",
                   "mainzisegmap_group_sizze_316607",
                   "mainzisegmap_group_sizze_316689",
                   "mainzisegmap_group_sizze_316729",
                   "mainzisegmap_group_sizze_316803",
                   "mainzisegmap_group_sizze_316824",
                   "mainzisegmap_group_sizze_316864",
                   "mainzisegmap_group_sizze_316890",
                   "mainzisegmap_group_sizze_316970",
                   "mainzisegmap_group_sizze_317054",
                   "mainzisegmap_group_sizze_317060",
                   "mainzisegmap_group_sizze_317120",
                   "mainzisegmap_group_sizze_317128",
                   "mainzisegmap_group_sizze_317254",
                   "mainzisegmap_group_sizze_317416",
                   "mainzisegmap_group_sizze_317506",
                   "mainzisegmap_num_groups_297621",
                   "mainzisegmap_num_groups_303534",
                   "mainzisegmap_num_groups_304775",
                   "mainzisegmap_num_groups_306363",
                   "mainzisegmap_num_groups_317508",
                   "mainzisegred_group_sizze_303886",
                   "mainzisegred_group_sizze_303989",
                   "mainzisegred_group_sizze_305237",
                   "mainzisegred_group_sizze_305373",
                   "mainzisegred_group_sizze_306945",
                   "mainzisegred_group_sizze_307119",
                   "mainzisegred_group_sizze_308836",
                   "mainzisegred_group_sizze_308967",
                   "mainzisegred_group_sizze_309098",
                   "mainzisegred_group_sizze_310508",
                   "mainzisegred_group_sizze_310576",
                   "mainzisegred_group_sizze_310874",
                   "mainzisegred_group_sizze_310971",
                   "mainzisegred_group_sizze_311358",
                   "mainzisegred_group_sizze_311489",
                   "mainzisegred_group_sizze_314386",
                   "mainzisegred_group_sizze_314457",
                   "mainzisegred_group_sizze_314910",
                   "mainzisegred_group_sizze_315010",
                   "mainzisegred_group_sizze_315552",
                   "mainzisegred_group_sizze_315686",
                   "mainzisegred_group_sizze_316741",
                   "mainzisegred_group_sizze_317285",
                   "mainzisegred_num_groups_303888",
                   "mainzisegred_num_groups_303991",
                   "mainzisegred_num_groups_305239",
                   "mainzisegred_num_groups_305375",
                   "mainzisegred_num_groups_306947",
                   "mainzisegred_num_groups_307121",
                   "mainzisegred_num_groups_308838",
                   "mainzisegred_num_groups_308969",
                   "mainzisegred_num_groups_309100",
                   "mainzisegred_num_groups_310510",
                   "mainzisegred_num_groups_310578",
                   "mainzisegred_num_groups_310876",
                   "mainzisegred_num_groups_310973",
                   "mainzisegred_num_groups_311360",
                   "mainzisegred_num_groups_311491",
                   "mainzisegred_num_groups_314388",
                   "mainzisegred_num_groups_314459",
                   "mainzisegred_num_groups_314912",
                   "mainzisegred_num_groups_315012",
                   "mainzisegred_num_groups_315554",
                   "mainzisegred_num_groups_315688",
                   "mainzisegred_num_groups_316743",
                   "mainzisegred_num_groups_317287",
                   "mainzisegscan_group_sizze_297609",
                   "mainzisegscan_group_sizze_297729",
                   "mainzisegscan_group_sizze_298171",
                   "mainzisegscan_group_sizze_308869",
                   "mainzisegscan_group_sizze_309000",
                   "mainzisegscan_group_sizze_309131",
                   "mainzisegscan_group_sizze_316880",
                   "mainzisegscan_group_sizze_317110",
                   "mainzisegscan_num_groups_297611",
                   "mainzisegscan_num_groups_297731",
                   "mainzisegscan_num_groups_298173",
                   "mainzisegscan_num_groups_308871",
                   "mainzisegscan_num_groups_309002",
                   "mainzisegscan_num_groups_309133",
                   "mainzisegscan_num_groups_316882",
                   "mainzisegscan_num_groups_317112", "mainzisuff_intra_par_0",
                   "mainzisuff_intra_par_1", "mainzisuff_intra_par_10",
                   "mainzisuff_intra_par_12", "mainzisuff_intra_par_16",
                   "mainzisuff_intra_par_2", "mainzisuff_intra_par_3",
                   "mainzisuff_intra_par_4", "mainzisuff_intra_par_5",
                   "mainzisuff_intra_par_6", "mainzisuff_intra_par_8",
                   "mainzisuff_outer_par_11", "mainzisuff_outer_par_13",
                   "mainzisuff_outer_par_14", "mainzisuff_outer_par_15",
                   "mainzisuff_outer_par_17", "mainzisuff_outer_par_18",
                   "mainzisuff_outer_par_7", "mainzisuff_outer_par_9",
                   "seasonal_amplitudezisegmap_group_sizze_297387",
                   "seasonal_amplitudezisegmap_group_sizze_297429",
                   "seasonal_amplitudezisegred_group_sizze_297442",
                   "seasonal_amplitudezisegred_num_groups_297444",
                   "seasonal_amplitudezisuff_outer_par_0",
                   "trend_magnitudezisegmap_group_sizze_297507",
                   "trend_magnitudezisegmap_group_sizze_297548",
                   "trend_magnitudezisegred_group_sizze_297491",
                   "trend_magnitudezisegred_group_sizze_297559",
                   "trend_magnitudezisegred_num_groups_297493",
                   "trend_magnitudezisegred_num_groups_297561",
                   "trend_magnitudezisuff_outer_par_0"};
static const char *tuning_param_classes[] = {"group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size",
                                             "bespoke(L2_for_histogram, 4194304)",
                                             "group_size", "group_size",
                                             "group_size", "num_groups",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "num_groups", "num_groups",
                                             "threshold(32,)", "threshold(32,)",
                                             "threshold(32, !main.suff_outer_par_9)",
                                             "threshold(32, !main.suff_outer_par_11)",
                                             "threshold(32,)",
                                             "threshold(32, !main.suff_intra_par_1)",
                                             "threshold(32,)",
                                             "threshold(32, !main.suff_intra_par_3)",
                                             "threshold(32,)", "threshold(32,)",
                                             "threshold(32, !main.suff_outer_par_7)",
                                             "threshold(def,)",
                                             "threshold(def,)",
                                             "threshold(def,)",
                                             "threshold(def,)",
                                             "threshold(def,)",
                                             "threshold(def,)",
                                             "threshold(def,)",
                                             "threshold(def,)", "group_size",
                                             "group_size", "group_size",
                                             "num_groups", "threshold(def,)",
                                             "group_size", "group_size",
                                             "group_size", "group_size",
                                             "num_groups", "num_groups",
                                             "threshold(def,)"};
struct tuning_params {
    int64_t *builtinzhreplicate_f32zigroup_sizze_325749;
    int64_t *builtinzhreplicate_f64zigroup_sizze_321589;
    int64_t *builtinzhreplicate_i32zigroup_sizze_325106;
    int64_t *builtinzhreplicate_i64zigroup_sizze_321089;
    int64_t *builtinzhreplicate_i8zigroup_sizze_320844;
    int64_t *mainziL2_sizze_325336;
    int64_t *mainzigroup_sizze_321107;
    int64_t *mainzigroup_sizze_321324;
    int64_t *mainziseghist_group_sizze_316938;
    int64_t *mainziseghist_num_groups_316940;
    int64_t *mainzisegmap_group_sizze_297619;
    int64_t *mainzisegmap_group_sizze_297673;
    int64_t *mainzisegmap_group_sizze_297830;
    int64_t *mainzisegmap_group_sizze_298102;
    int64_t *mainzisegmap_group_sizze_298957;
    int64_t *mainzisegmap_group_sizze_299196;
    int64_t *mainzisegmap_group_sizze_299227;
    int64_t *mainzisegmap_group_sizze_299959;
    int64_t *mainzisegmap_group_sizze_300163;
    int64_t *mainzisegmap_group_sizze_300189;
    int64_t *mainzisegmap_group_sizze_300585;
    int64_t *mainzisegmap_group_sizze_300789;
    int64_t *mainzisegmap_group_sizze_300815;
    int64_t *mainzisegmap_group_sizze_300988;
    int64_t *mainzisegmap_group_sizze_301054;
    int64_t *mainzisegmap_group_sizze_301208;
    int64_t *mainzisegmap_group_sizze_301513;
    int64_t *mainzisegmap_group_sizze_301914;
    int64_t *mainzisegmap_group_sizze_303532;
    int64_t *mainzisegmap_group_sizze_303958;
    int64_t *mainzisegmap_group_sizze_304045;
    int64_t *mainzisegmap_group_sizze_304773;
    int64_t *mainzisegmap_group_sizze_305331;
    int64_t *mainzisegmap_group_sizze_305437;
    int64_t *mainzisegmap_group_sizze_306361;
    int64_t *mainzisegmap_group_sizze_307056;
    int64_t *mainzisegmap_group_sizze_307191;
    int64_t *mainzisegmap_group_sizze_308343;
    int64_t *mainzisegmap_group_sizze_308739;
    int64_t *mainzisegmap_group_sizze_308810;
    int64_t *mainzisegmap_group_sizze_308941;
    int64_t *mainzisegmap_group_sizze_309072;
    int64_t *mainzisegmap_group_sizze_309203;
    int64_t *mainzisegmap_group_sizze_309354;
    int64_t *mainzisegmap_group_sizze_309568;
    int64_t *mainzisegmap_group_sizze_310562;
    int64_t *mainzisegmap_group_sizze_310946;
    int64_t *mainzisegmap_group_sizze_311443;
    int64_t *mainzisegmap_group_sizze_311956;
    int64_t *mainzisegmap_group_sizze_312143;
    int64_t *mainzisegmap_group_sizze_312186;
    int64_t *mainzisegmap_group_sizze_312283;
    int64_t *mainzisegmap_group_sizze_312339;
    int64_t *mainzisegmap_group_sizze_312486;
    int64_t *mainzisegmap_group_sizze_312614;
    int64_t *mainzisegmap_group_sizze_312670;
    int64_t *mainzisegmap_group_sizze_312849;
    int64_t *mainzisegmap_group_sizze_313011;
    int64_t *mainzisegmap_group_sizze_313067;
    int64_t *mainzisegmap_group_sizze_313369;
    int64_t *mainzisegmap_group_sizze_313425;
    int64_t *mainzisegmap_group_sizze_313688;
    int64_t *mainzisegmap_group_sizze_313744;
    int64_t *mainzisegmap_group_sizze_314103;
    int64_t *mainzisegmap_group_sizze_314159;
    int64_t *mainzisegmap_group_sizze_314443;
    int64_t *mainzisegmap_group_sizze_314643;
    int64_t *mainzisegmap_group_sizze_314699;
    int64_t *mainzisegmap_group_sizze_314985;
    int64_t *mainzisegmap_group_sizze_315242;
    int64_t *mainzisegmap_group_sizze_315298;
    int64_t *mainzisegmap_group_sizze_315640;
    int64_t *mainzisegmap_group_sizze_315968;
    int64_t *mainzisegmap_group_sizze_316024;
    int64_t *mainzisegmap_group_sizze_316306;
    int64_t *mainzisegmap_group_sizze_316564;
    int64_t *mainzisegmap_group_sizze_316607;
    int64_t *mainzisegmap_group_sizze_316689;
    int64_t *mainzisegmap_group_sizze_316729;
    int64_t *mainzisegmap_group_sizze_316803;
    int64_t *mainzisegmap_group_sizze_316824;
    int64_t *mainzisegmap_group_sizze_316864;
    int64_t *mainzisegmap_group_sizze_316890;
    int64_t *mainzisegmap_group_sizze_316970;
    int64_t *mainzisegmap_group_sizze_317054;
    int64_t *mainzisegmap_group_sizze_317060;
    int64_t *mainzisegmap_group_sizze_317120;
    int64_t *mainzisegmap_group_sizze_317128;
    int64_t *mainzisegmap_group_sizze_317254;
    int64_t *mainzisegmap_group_sizze_317416;
    int64_t *mainzisegmap_group_sizze_317506;
    int64_t *mainzisegmap_num_groups_297621;
    int64_t *mainzisegmap_num_groups_303534;
    int64_t *mainzisegmap_num_groups_304775;
    int64_t *mainzisegmap_num_groups_306363;
    int64_t *mainzisegmap_num_groups_317508;
    int64_t *mainzisegred_group_sizze_303886;
    int64_t *mainzisegred_group_sizze_303989;
    int64_t *mainzisegred_group_sizze_305237;
    int64_t *mainzisegred_group_sizze_305373;
    int64_t *mainzisegred_group_sizze_306945;
    int64_t *mainzisegred_group_sizze_307119;
    int64_t *mainzisegred_group_sizze_308836;
    int64_t *mainzisegred_group_sizze_308967;
    int64_t *mainzisegred_group_sizze_309098;
    int64_t *mainzisegred_group_sizze_310508;
    int64_t *mainzisegred_group_sizze_310576;
    int64_t *mainzisegred_group_sizze_310874;
    int64_t *mainzisegred_group_sizze_310971;
    int64_t *mainzisegred_group_sizze_311358;
    int64_t *mainzisegred_group_sizze_311489;
    int64_t *mainzisegred_group_sizze_314386;
    int64_t *mainzisegred_group_sizze_314457;
    int64_t *mainzisegred_group_sizze_314910;
    int64_t *mainzisegred_group_sizze_315010;
    int64_t *mainzisegred_group_sizze_315552;
    int64_t *mainzisegred_group_sizze_315686;
    int64_t *mainzisegred_group_sizze_316741;
    int64_t *mainzisegred_group_sizze_317285;
    int64_t *mainzisegred_num_groups_303888;
    int64_t *mainzisegred_num_groups_303991;
    int64_t *mainzisegred_num_groups_305239;
    int64_t *mainzisegred_num_groups_305375;
    int64_t *mainzisegred_num_groups_306947;
    int64_t *mainzisegred_num_groups_307121;
    int64_t *mainzisegred_num_groups_308838;
    int64_t *mainzisegred_num_groups_308969;
    int64_t *mainzisegred_num_groups_309100;
    int64_t *mainzisegred_num_groups_310510;
    int64_t *mainzisegred_num_groups_310578;
    int64_t *mainzisegred_num_groups_310876;
    int64_t *mainzisegred_num_groups_310973;
    int64_t *mainzisegred_num_groups_311360;
    int64_t *mainzisegred_num_groups_311491;
    int64_t *mainzisegred_num_groups_314388;
    int64_t *mainzisegred_num_groups_314459;
    int64_t *mainzisegred_num_groups_314912;
    int64_t *mainzisegred_num_groups_315012;
    int64_t *mainzisegred_num_groups_315554;
    int64_t *mainzisegred_num_groups_315688;
    int64_t *mainzisegred_num_groups_316743;
    int64_t *mainzisegred_num_groups_317287;
    int64_t *mainzisegscan_group_sizze_297609;
    int64_t *mainzisegscan_group_sizze_297729;
    int64_t *mainzisegscan_group_sizze_298171;
    int64_t *mainzisegscan_group_sizze_308869;
    int64_t *mainzisegscan_group_sizze_309000;
    int64_t *mainzisegscan_group_sizze_309131;
    int64_t *mainzisegscan_group_sizze_316880;
    int64_t *mainzisegscan_group_sizze_317110;
    int64_t *mainzisegscan_num_groups_297611;
    int64_t *mainzisegscan_num_groups_297731;
    int64_t *mainzisegscan_num_groups_298173;
    int64_t *mainzisegscan_num_groups_308871;
    int64_t *mainzisegscan_num_groups_309002;
    int64_t *mainzisegscan_num_groups_309133;
    int64_t *mainzisegscan_num_groups_316882;
    int64_t *mainzisegscan_num_groups_317112;
    int64_t *mainzisuff_intra_par_0;
    int64_t *mainzisuff_intra_par_1;
    int64_t *mainzisuff_intra_par_10;
    int64_t *mainzisuff_intra_par_12;
    int64_t *mainzisuff_intra_par_16;
    int64_t *mainzisuff_intra_par_2;
    int64_t *mainzisuff_intra_par_3;
    int64_t *mainzisuff_intra_par_4;
    int64_t *mainzisuff_intra_par_5;
    int64_t *mainzisuff_intra_par_6;
    int64_t *mainzisuff_intra_par_8;
    int64_t *mainzisuff_outer_par_11;
    int64_t *mainzisuff_outer_par_13;
    int64_t *mainzisuff_outer_par_14;
    int64_t *mainzisuff_outer_par_15;
    int64_t *mainzisuff_outer_par_17;
    int64_t *mainzisuff_outer_par_18;
    int64_t *mainzisuff_outer_par_7;
    int64_t *mainzisuff_outer_par_9;
    int64_t *seasonal_amplitudezisegmap_group_sizze_297387;
    int64_t *seasonal_amplitudezisegmap_group_sizze_297429;
    int64_t *seasonal_amplitudezisegred_group_sizze_297442;
    int64_t *seasonal_amplitudezisegred_num_groups_297444;
    int64_t *seasonal_amplitudezisuff_outer_par_0;
    int64_t *trend_magnitudezisegmap_group_sizze_297507;
    int64_t *trend_magnitudezisegmap_group_sizze_297548;
    int64_t *trend_magnitudezisegred_group_sizze_297491;
    int64_t *trend_magnitudezisegred_group_sizze_297559;
    int64_t *trend_magnitudezisegred_num_groups_297493;
    int64_t *trend_magnitudezisegred_num_groups_297561;
    int64_t *trend_magnitudezisuff_outer_par_0;
};
struct futhark_context_config {
    int in_use;
    struct cuda_config cu_cfg;
    int profiling;
    int64_t tuning_params[189];
    int num_nvrtc_opts;
    const char **nvrtc_opts;
};
struct futhark_context_config *futhark_context_config_new(void)
{
    struct futhark_context_config *cfg =
                                  (struct futhark_context_config *) malloc(sizeof(struct futhark_context_config));
    
    if (cfg == NULL)
        return NULL;
    cfg->in_use = 0;
    cfg->profiling = 0;
    cfg->num_nvrtc_opts = 0;
    cfg->nvrtc_opts = (const char **) malloc(sizeof(const char *));
    cfg->nvrtc_opts[0] = NULL;
    cfg->tuning_params[0] = 0;
    cfg->tuning_params[1] = 0;
    cfg->tuning_params[2] = 0;
    cfg->tuning_params[3] = 0;
    cfg->tuning_params[4] = 0;
    cfg->tuning_params[5] = 4194304;
    cfg->tuning_params[6] = 0;
    cfg->tuning_params[7] = 0;
    cfg->tuning_params[8] = 0;
    cfg->tuning_params[9] = 0;
    cfg->tuning_params[10] = 0;
    cfg->tuning_params[11] = 0;
    cfg->tuning_params[12] = 0;
    cfg->tuning_params[13] = 0;
    cfg->tuning_params[14] = 0;
    cfg->tuning_params[15] = 0;
    cfg->tuning_params[16] = 0;
    cfg->tuning_params[17] = 0;
    cfg->tuning_params[18] = 0;
    cfg->tuning_params[19] = 0;
    cfg->tuning_params[20] = 0;
    cfg->tuning_params[21] = 0;
    cfg->tuning_params[22] = 0;
    cfg->tuning_params[23] = 0;
    cfg->tuning_params[24] = 0;
    cfg->tuning_params[25] = 0;
    cfg->tuning_params[26] = 0;
    cfg->tuning_params[27] = 0;
    cfg->tuning_params[28] = 0;
    cfg->tuning_params[29] = 0;
    cfg->tuning_params[30] = 0;
    cfg->tuning_params[31] = 0;
    cfg->tuning_params[32] = 0;
    cfg->tuning_params[33] = 0;
    cfg->tuning_params[34] = 0;
    cfg->tuning_params[35] = 0;
    cfg->tuning_params[36] = 0;
    cfg->tuning_params[37] = 0;
    cfg->tuning_params[38] = 0;
    cfg->tuning_params[39] = 0;
    cfg->tuning_params[40] = 0;
    cfg->tuning_params[41] = 0;
    cfg->tuning_params[42] = 0;
    cfg->tuning_params[43] = 0;
    cfg->tuning_params[44] = 0;
    cfg->tuning_params[45] = 0;
    cfg->tuning_params[46] = 0;
    cfg->tuning_params[47] = 0;
    cfg->tuning_params[48] = 0;
    cfg->tuning_params[49] = 0;
    cfg->tuning_params[50] = 0;
    cfg->tuning_params[51] = 0;
    cfg->tuning_params[52] = 0;
    cfg->tuning_params[53] = 0;
    cfg->tuning_params[54] = 0;
    cfg->tuning_params[55] = 0;
    cfg->tuning_params[56] = 0;
    cfg->tuning_params[57] = 0;
    cfg->tuning_params[58] = 0;
    cfg->tuning_params[59] = 0;
    cfg->tuning_params[60] = 0;
    cfg->tuning_params[61] = 0;
    cfg->tuning_params[62] = 0;
    cfg->tuning_params[63] = 0;
    cfg->tuning_params[64] = 0;
    cfg->tuning_params[65] = 0;
    cfg->tuning_params[66] = 0;
    cfg->tuning_params[67] = 0;
    cfg->tuning_params[68] = 0;
    cfg->tuning_params[69] = 0;
    cfg->tuning_params[70] = 0;
    cfg->tuning_params[71] = 0;
    cfg->tuning_params[72] = 0;
    cfg->tuning_params[73] = 0;
    cfg->tuning_params[74] = 0;
    cfg->tuning_params[75] = 0;
    cfg->tuning_params[76] = 0;
    cfg->tuning_params[77] = 0;
    cfg->tuning_params[78] = 0;
    cfg->tuning_params[79] = 0;
    cfg->tuning_params[80] = 0;
    cfg->tuning_params[81] = 0;
    cfg->tuning_params[82] = 0;
    cfg->tuning_params[83] = 0;
    cfg->tuning_params[84] = 0;
    cfg->tuning_params[85] = 0;
    cfg->tuning_params[86] = 0;
    cfg->tuning_params[87] = 0;
    cfg->tuning_params[88] = 0;
    cfg->tuning_params[89] = 0;
    cfg->tuning_params[90] = 0;
    cfg->tuning_params[91] = 0;
    cfg->tuning_params[92] = 0;
    cfg->tuning_params[93] = 0;
    cfg->tuning_params[94] = 0;
    cfg->tuning_params[95] = 0;
    cfg->tuning_params[96] = 0;
    cfg->tuning_params[97] = 0;
    cfg->tuning_params[98] = 0;
    cfg->tuning_params[99] = 0;
    cfg->tuning_params[100] = 0;
    cfg->tuning_params[101] = 0;
    cfg->tuning_params[102] = 0;
    cfg->tuning_params[103] = 0;
    cfg->tuning_params[104] = 0;
    cfg->tuning_params[105] = 0;
    cfg->tuning_params[106] = 0;
    cfg->tuning_params[107] = 0;
    cfg->tuning_params[108] = 0;
    cfg->tuning_params[109] = 0;
    cfg->tuning_params[110] = 0;
    cfg->tuning_params[111] = 0;
    cfg->tuning_params[112] = 0;
    cfg->tuning_params[113] = 0;
    cfg->tuning_params[114] = 0;
    cfg->tuning_params[115] = 0;
    cfg->tuning_params[116] = 0;
    cfg->tuning_params[117] = 0;
    cfg->tuning_params[118] = 0;
    cfg->tuning_params[119] = 0;
    cfg->tuning_params[120] = 0;
    cfg->tuning_params[121] = 0;
    cfg->tuning_params[122] = 0;
    cfg->tuning_params[123] = 0;
    cfg->tuning_params[124] = 0;
    cfg->tuning_params[125] = 0;
    cfg->tuning_params[126] = 0;
    cfg->tuning_params[127] = 0;
    cfg->tuning_params[128] = 0;
    cfg->tuning_params[129] = 0;
    cfg->tuning_params[130] = 0;
    cfg->tuning_params[131] = 0;
    cfg->tuning_params[132] = 0;
    cfg->tuning_params[133] = 0;
    cfg->tuning_params[134] = 0;
    cfg->tuning_params[135] = 0;
    cfg->tuning_params[136] = 0;
    cfg->tuning_params[137] = 0;
    cfg->tuning_params[138] = 0;
    cfg->tuning_params[139] = 0;
    cfg->tuning_params[140] = 0;
    cfg->tuning_params[141] = 0;
    cfg->tuning_params[142] = 0;
    cfg->tuning_params[143] = 0;
    cfg->tuning_params[144] = 0;
    cfg->tuning_params[145] = 0;
    cfg->tuning_params[146] = 0;
    cfg->tuning_params[147] = 0;
    cfg->tuning_params[148] = 0;
    cfg->tuning_params[149] = 0;
    cfg->tuning_params[150] = 0;
    cfg->tuning_params[151] = 0;
    cfg->tuning_params[152] = 0;
    cfg->tuning_params[153] = 0;
    cfg->tuning_params[154] = 0;
    cfg->tuning_params[155] = 0;
    cfg->tuning_params[156] = 0;
    cfg->tuning_params[157] = 0;
    cfg->tuning_params[158] = 32;
    cfg->tuning_params[159] = 32;
    cfg->tuning_params[160] = 32;
    cfg->tuning_params[161] = 32;
    cfg->tuning_params[162] = 32;
    cfg->tuning_params[163] = 32;
    cfg->tuning_params[164] = 32;
    cfg->tuning_params[165] = 32;
    cfg->tuning_params[166] = 32;
    cfg->tuning_params[167] = 32;
    cfg->tuning_params[168] = 32;
    cfg->tuning_params[169] = 0;
    cfg->tuning_params[170] = 0;
    cfg->tuning_params[171] = 0;
    cfg->tuning_params[172] = 0;
    cfg->tuning_params[173] = 0;
    cfg->tuning_params[174] = 0;
    cfg->tuning_params[175] = 0;
    cfg->tuning_params[176] = 0;
    cfg->tuning_params[177] = 0;
    cfg->tuning_params[178] = 0;
    cfg->tuning_params[179] = 0;
    cfg->tuning_params[180] = 0;
    cfg->tuning_params[181] = 0;
    cfg->tuning_params[182] = 0;
    cfg->tuning_params[183] = 0;
    cfg->tuning_params[184] = 0;
    cfg->tuning_params[185] = 0;
    cfg->tuning_params[186] = 0;
    cfg->tuning_params[187] = 0;
    cfg->tuning_params[188] = 0;
    cuda_config_init(&cfg->cu_cfg, 189, tuning_param_names, tuning_param_vars,
                     cfg->tuning_params, tuning_param_classes);
    return cfg;
}
void futhark_context_config_free(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    free(cfg->nvrtc_opts);
    free(cfg);
}
void futhark_context_config_add_nvrtc_option(struct futhark_context_config *cfg,
                                             const char *opt)
{
    cfg->nvrtc_opts[cfg->num_nvrtc_opts] = opt;
    cfg->num_nvrtc_opts++;
    cfg->nvrtc_opts = (const char **) realloc(cfg->nvrtc_opts,
                                              (cfg->num_nvrtc_opts + 1) *
                                              sizeof(const char *));
    cfg->nvrtc_opts[cfg->num_nvrtc_opts] = NULL;
}
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int flag)
{
    cfg->cu_cfg.logging = cfg->cu_cfg.debugging = flag;
}
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag)
{
    cfg->profiling = flag;
}
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int flag)
{
    cfg->cu_cfg.logging = flag;
}
void futhark_context_config_set_device(struct futhark_context_config *cfg, const
                                       char *s)
{
    set_preferred_device(&cfg->cu_cfg, s);
}
void futhark_context_config_dump_program_to(struct futhark_context_config *cfg,
                                            const char *path)
{
    cfg->cu_cfg.dump_program_to = path;
}
void futhark_context_config_load_program_from(struct futhark_context_config *cfg,
                                              const char *path)
{
    cfg->cu_cfg.load_program_from = path;
}
void futhark_context_config_dump_ptx_to(struct futhark_context_config *cfg,
                                        const char *path)
{
    cfg->cu_cfg.dump_ptx_to = path;
}
void futhark_context_config_load_ptx_from(struct futhark_context_config *cfg,
                                          const char *path)
{
    cfg->cu_cfg.load_ptx_from = path;
}
void futhark_context_config_set_default_group_size(struct futhark_context_config *cfg,
                                                   int size)
{
    cfg->cu_cfg.default_block_size = size;
    cfg->cu_cfg.default_block_size_changed = 1;
}
void futhark_context_config_set_default_num_groups(struct futhark_context_config *cfg,
                                                   int num)
{
    cfg->cu_cfg.default_grid_size = num;
    cfg->cu_cfg.default_grid_size_changed = 1;
}
void futhark_context_config_set_default_tile_size(struct futhark_context_config *cfg,
                                                  int size)
{
    cfg->cu_cfg.default_tile_size = size;
    cfg->cu_cfg.default_tile_size_changed = 1;
}
void futhark_context_config_set_default_reg_tile_size(struct futhark_context_config *cfg,
                                                      int size)
{
    cfg->cu_cfg.default_reg_tile_size = size;
}
void futhark_context_config_set_default_threshold(struct futhark_context_config *cfg,
                                                  int size)
{
    cfg->cu_cfg.default_threshold = size;
}
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t new_value)
{
    for (int i = 0; i < 189; i++) {
        if (strcmp(param_name, tuning_param_names[i]) == 0) {
            cfg->tuning_params[i] = new_value;
            return 0;
        }
    }
    if (strcmp(param_name, "default_group_size") == 0) {
        cfg->cu_cfg.default_block_size = new_value;
        return 0;
    }
    if (strcmp(param_name, "default_num_groups") == 0) {
        cfg->cu_cfg.default_grid_size = new_value;
        return 0;
    }
    if (strcmp(param_name, "default_threshold") == 0) {
        cfg->cu_cfg.default_threshold = new_value;
        return 0;
    }
    if (strcmp(param_name, "default_tile_size") == 0) {
        cfg->cu_cfg.default_tile_size = new_value;
        return 0;
    }
    if (strcmp(param_name, "default_reg_tile_size") == 0) {
        cfg->cu_cfg.default_reg_tile_size = new_value;
        return 0;
    }
    return 1;
}
struct futhark_context {
    struct futhark_context_config *cfg;
    int detail_memory;
    int debugging;
    int profiling;
    int profiling_paused;
    int logging;
    lock_t lock;
    char *error;
    FILE *log;
    int64_t peak_mem_usage_device;
    int64_t cur_mem_usage_device;
    int64_t peak_mem_usage_default;
    int64_t cur_mem_usage_default;
    struct {
        int dummy;
    } constants;
    struct memblock_device mainziid_counter_mem_320829;
    struct memblock_device mainziid_counter_mem_320981;
    struct memblock_device mainziid_counter_mem_321204;
    struct memblock_device mainzicounter_mem_321915;
    struct memblock_device mainzicounter_mem_322003;
    struct memblock_device mainzicounter_mem_322234;
    struct memblock_device mainzicounter_mem_322342;
    struct memblock_device mainzicounter_mem_322617;
    struct memblock_device mainzicounter_mem_322737;
    struct memblock_device mainzicounter_mem_322848;
    struct memblock_device mainziid_counter_mem_322885;
    struct memblock_device mainzicounter_mem_323029;
    struct memblock_device mainziid_counter_mem_323066;
    struct memblock_device mainzicounter_mem_323210;
    struct memblock_device mainziid_counter_mem_323247;
    struct memblock_device mainzicounter_mem_323508;
    struct memblock_device mainzicounter_mem_323591;
    struct memblock_device mainzicounter_mem_323680;
    struct memblock_device mainzicounter_mem_323783;
    struct memblock_device mainzicounter_mem_323894;
    struct memblock_device mainzicounter_mem_324009;
    struct memblock_device mainzicounter_mem_324371;
    struct memblock_device mainzicounter_mem_324454;
    struct memblock_device mainzicounter_mem_324563;
    struct memblock_device mainzicounter_mem_324666;
    struct memblock_device mainzicounter_mem_324797;
    struct memblock_device mainzicounter_mem_324912;
    struct memblock_device mainzicounter_mem_325050;
    struct memblock_device mainziid_counter_mem_325173;
    struct memblock_device mainzicounter_mem_325394;
    struct memblock_device mainziid_counter_mem_325455;
    struct memblock_device mainzicounter_mem_325660;
    struct memblock_device seasonal_amplitudezicounter_mem_320877;
    struct memblock_device trend_magnitudezicounter_mem_320825;
    struct memblock_device trend_magnitudezicounter_mem_320918;
    CUfunction builtinzhreplicate_f32zireplicate_325746;
    int64_t builtinzhreplicate_f32zireplicate_325746_total_runtime;
    int builtinzhreplicate_f32zireplicate_325746_runs;
    CUfunction builtinzhreplicate_f64zireplicate_321586;
    int64_t builtinzhreplicate_f64zireplicate_321586_total_runtime;
    int builtinzhreplicate_f64zireplicate_321586_runs;
    CUfunction builtinzhreplicate_i32zireplicate_325103;
    int64_t builtinzhreplicate_i32zireplicate_325103_total_runtime;
    int builtinzhreplicate_i32zireplicate_325103_runs;
    CUfunction builtinzhreplicate_i64zireplicate_321086;
    int64_t builtinzhreplicate_i64zireplicate_321086_total_runtime;
    int builtinzhreplicate_i64zireplicate_321086_runs;
    CUfunction builtinzhreplicate_i8zireplicate_320841;
    int64_t builtinzhreplicate_i8zireplicate_320841_total_runtime;
    int builtinzhreplicate_i8zireplicate_320841_runs;
    CUfunction gpu_map_transpose_f32;
    int64_t gpu_map_transpose_f32_total_runtime;
    int gpu_map_transpose_f32_runs;
    CUfunction gpu_map_transpose_f32_low_height;
    int64_t gpu_map_transpose_f32_low_height_total_runtime;
    int gpu_map_transpose_f32_low_height_runs;
    CUfunction gpu_map_transpose_f32_low_width;
    int64_t gpu_map_transpose_f32_low_width_total_runtime;
    int gpu_map_transpose_f32_low_width_runs;
    CUfunction gpu_map_transpose_f32_small;
    int64_t gpu_map_transpose_f32_small_total_runtime;
    int gpu_map_transpose_f32_small_runs;
    CUfunction gpu_map_transpose_f64;
    int64_t gpu_map_transpose_f64_total_runtime;
    int gpu_map_transpose_f64_runs;
    CUfunction gpu_map_transpose_f64_low_height;
    int64_t gpu_map_transpose_f64_low_height_total_runtime;
    int gpu_map_transpose_f64_low_height_runs;
    CUfunction gpu_map_transpose_f64_low_width;
    int64_t gpu_map_transpose_f64_low_width_total_runtime;
    int gpu_map_transpose_f64_low_width_runs;
    CUfunction gpu_map_transpose_f64_small;
    int64_t gpu_map_transpose_f64_small_total_runtime;
    int gpu_map_transpose_f64_small_runs;
    CUfunction gpu_map_transpose_i64;
    int64_t gpu_map_transpose_i64_total_runtime;
    int gpu_map_transpose_i64_runs;
    CUfunction gpu_map_transpose_i64_low_height;
    int64_t gpu_map_transpose_i64_low_height_total_runtime;
    int gpu_map_transpose_i64_low_height_runs;
    CUfunction gpu_map_transpose_i64_low_width;
    int64_t gpu_map_transpose_i64_low_width_total_runtime;
    int gpu_map_transpose_i64_low_width_runs;
    CUfunction gpu_map_transpose_i64_small;
    int64_t gpu_map_transpose_i64_small_total_runtime;
    int gpu_map_transpose_i64_small_runs;
    CUfunction mainzicopy_321104;
    int64_t mainzicopy_321104_total_runtime;
    int mainzicopy_321104_runs;
    CUfunction mainzicopy_321321;
    int64_t mainzicopy_321321_total_runtime;
    int mainzicopy_321321_runs;
    CUfunction mainziseghist_global_316946;
    int64_t mainziseghist_global_316946_total_runtime;
    int mainziseghist_global_316946_runs;
    CUfunction mainziseghist_local_316946;
    int64_t mainziseghist_local_316946_total_runtime;
    int mainziseghist_local_316946_runs;
    CUfunction mainzisegmap_297617;
    int64_t mainzisegmap_297617_total_runtime;
    int mainzisegmap_297617_runs;
    CUfunction mainzisegmap_297793;
    int64_t mainzisegmap_297793_total_runtime;
    int mainzisegmap_297793_runs;
    CUfunction mainzisegmap_297921;
    int64_t mainzisegmap_297921_total_runtime;
    int mainzisegmap_297921_runs;
    CUfunction mainzisegmap_298357;
    int64_t mainzisegmap_298357_total_runtime;
    int mainzisegmap_298357_runs;
    CUfunction mainzisegmap_299570;
    int64_t mainzisegmap_299570_total_runtime;
    int mainzisegmap_299570_runs;
    CUfunction mainzisegmap_299584;
    int64_t mainzisegmap_299584_total_runtime;
    int mainzisegmap_299584_runs;
    CUfunction mainzisegmap_299608;
    int64_t mainzisegmap_299608_total_runtime;
    int mainzisegmap_299608_runs;
    CUfunction mainzisegmap_300218;
    int64_t mainzisegmap_300218_total_runtime;
    int mainzisegmap_300218_runs;
    CUfunction mainzisegmap_300230;
    int64_t mainzisegmap_300230_total_runtime;
    int mainzisegmap_300230_runs;
    CUfunction mainzisegmap_300251;
    int64_t mainzisegmap_300251_total_runtime;
    int mainzisegmap_300251_runs;
    CUfunction mainzisegmap_300844;
    int64_t mainzisegmap_300844_total_runtime;
    int mainzisegmap_300844_runs;
    CUfunction mainzisegmap_300856;
    int64_t mainzisegmap_300856_total_runtime;
    int mainzisegmap_300856_runs;
    CUfunction mainzisegmap_300877;
    int64_t mainzisegmap_300877_total_runtime;
    int mainzisegmap_300877_runs;
    CUfunction mainzisegmap_301021;
    int64_t mainzisegmap_301021_total_runtime;
    int mainzisegmap_301021_runs;
    CUfunction mainzisegmap_301167;
    int64_t mainzisegmap_301167_total_runtime;
    int mainzisegmap_301167_runs;
    CUfunction mainzisegmap_301414;
    int64_t mainzisegmap_301414_total_runtime;
    int mainzisegmap_301414_runs;
    CUfunction mainzisegmap_301783;
    int64_t mainzisegmap_301783_total_runtime;
    int mainzisegmap_301783_runs;
    CUfunction mainzisegmap_302252;
    int64_t mainzisegmap_302252_total_runtime;
    int mainzisegmap_302252_runs;
    CUfunction mainzisegmap_304408;
    int64_t mainzisegmap_304408_total_runtime;
    int mainzisegmap_304408_runs;
    CUfunction mainzisegmap_304619;
    int64_t mainzisegmap_304619_total_runtime;
    int mainzisegmap_304619_runs;
    CUfunction mainzisegmap_304691;
    int64_t mainzisegmap_304691_total_runtime;
    int mainzisegmap_304691_runs;
    CUfunction mainzisegmap_305885;
    int64_t mainzisegmap_305885_total_runtime;
    int mainzisegmap_305885_runs;
    CUfunction mainzisegmap_306165;
    int64_t mainzisegmap_306165_total_runtime;
    int mainzisegmap_306165_runs;
    CUfunction mainzisegmap_306249;
    int64_t mainzisegmap_306249_total_runtime;
    int mainzisegmap_306249_runs;
    CUfunction mainzisegmap_307727;
    int64_t mainzisegmap_307727_total_runtime;
    int mainzisegmap_307727_runs;
    CUfunction mainzisegmap_308081;
    int64_t mainzisegmap_308081_total_runtime;
    int mainzisegmap_308081_runs;
    CUfunction mainzisegmap_308177;
    int64_t mainzisegmap_308177_total_runtime;
    int mainzisegmap_308177_runs;
    CUfunction mainzisegmap_308641;
    int64_t mainzisegmap_308641_total_runtime;
    int mainzisegmap_308641_runs;
    CUfunction mainzisegmap_308790;
    int64_t mainzisegmap_308790_total_runtime;
    int mainzisegmap_308790_runs;
    CUfunction mainzisegmap_308826;
    int64_t mainzisegmap_308826_total_runtime;
    int mainzisegmap_308826_runs;
    CUfunction mainzisegmap_308957;
    int64_t mainzisegmap_308957_total_runtime;
    int mainzisegmap_308957_runs;
    CUfunction mainzisegmap_309088;
    int64_t mainzisegmap_309088_total_runtime;
    int mainzisegmap_309088_runs;
    CUfunction mainzisegmap_309288;
    int64_t mainzisegmap_309288_total_runtime;
    int mainzisegmap_309288_runs;
    CUfunction mainzisegmap_309471;
    int64_t mainzisegmap_309471_total_runtime;
    int mainzisegmap_309471_runs;
    CUfunction mainzisegmap_309719;
    int64_t mainzisegmap_309719_total_runtime;
    int mainzisegmap_309719_runs;
    CUfunction mainzisegmap_310801;
    int64_t mainzisegmap_310801_total_runtime;
    int mainzisegmap_310801_runs;
    CUfunction mainzisegmap_311254;
    int64_t mainzisegmap_311254_total_runtime;
    int mainzisegmap_311254_runs;
    CUfunction mainzisegmap_311834;
    int64_t mainzisegmap_311834_total_runtime;
    int mainzisegmap_311834_runs;
    CUfunction mainzisegmap_312079;
    int64_t mainzisegmap_312079_total_runtime;
    int mainzisegmap_312079_runs;
    CUfunction mainzisegmap_312174;
    int64_t mainzisegmap_312174_total_runtime;
    int mainzisegmap_312174_runs;
    CUfunction mainzisegmap_312372;
    int64_t mainzisegmap_312372_total_runtime;
    int mainzisegmap_312372_runs;
    CUfunction mainzisegmap_312390;
    int64_t mainzisegmap_312390_total_runtime;
    int mainzisegmap_312390_runs;
    CUfunction mainzisegmap_312414;
    int64_t mainzisegmap_312414_total_runtime;
    int mainzisegmap_312414_runs;
    CUfunction mainzisegmap_312703;
    int64_t mainzisegmap_312703_total_runtime;
    int mainzisegmap_312703_runs;
    CUfunction mainzisegmap_312721;
    int64_t mainzisegmap_312721_total_runtime;
    int mainzisegmap_312721_runs;
    CUfunction mainzisegmap_312746;
    int64_t mainzisegmap_312746_total_runtime;
    int mainzisegmap_312746_runs;
    CUfunction mainzisegmap_313100;
    int64_t mainzisegmap_313100_total_runtime;
    int mainzisegmap_313100_runs;
    CUfunction mainzisegmap_313118;
    int64_t mainzisegmap_313118_total_runtime;
    int mainzisegmap_313118_runs;
    CUfunction mainzisegmap_313143;
    int64_t mainzisegmap_313143_total_runtime;
    int mainzisegmap_313143_runs;
    CUfunction mainzisegmap_313458;
    int64_t mainzisegmap_313458_total_runtime;
    int mainzisegmap_313458_runs;
    CUfunction mainzisegmap_313476;
    int64_t mainzisegmap_313476_total_runtime;
    int mainzisegmap_313476_runs;
    CUfunction mainzisegmap_313777;
    int64_t mainzisegmap_313777_total_runtime;
    int mainzisegmap_313777_runs;
    CUfunction mainzisegmap_313795;
    int64_t mainzisegmap_313795_total_runtime;
    int mainzisegmap_313795_runs;
    CUfunction mainzisegmap_314192;
    int64_t mainzisegmap_314192_total_runtime;
    int mainzisegmap_314192_runs;
    CUfunction mainzisegmap_314210;
    int64_t mainzisegmap_314210_total_runtime;
    int mainzisegmap_314210_runs;
    CUfunction mainzisegmap_314732;
    int64_t mainzisegmap_314732_total_runtime;
    int mainzisegmap_314732_runs;
    CUfunction mainzisegmap_314750;
    int64_t mainzisegmap_314750_total_runtime;
    int mainzisegmap_314750_runs;
    CUfunction mainzisegmap_314832;
    int64_t mainzisegmap_314832_total_runtime;
    int mainzisegmap_314832_runs;
    CUfunction mainzisegmap_315331;
    int64_t mainzisegmap_315331_total_runtime;
    int mainzisegmap_315331_runs;
    CUfunction mainzisegmap_315349;
    int64_t mainzisegmap_315349_total_runtime;
    int mainzisegmap_315349_runs;
    CUfunction mainzisegmap_315443;
    int64_t mainzisegmap_315443_total_runtime;
    int mainzisegmap_315443_runs;
    CUfunction mainzisegmap_316057;
    int64_t mainzisegmap_316057_total_runtime;
    int mainzisegmap_316057_runs;
    CUfunction mainzisegmap_316075;
    int64_t mainzisegmap_316075_total_runtime;
    int mainzisegmap_316075_runs;
    CUfunction mainzisegmap_316181;
    int64_t mainzisegmap_316181_total_runtime;
    int mainzisegmap_316181_runs;
    CUfunction mainzisegmap_316429;
    int64_t mainzisegmap_316429_total_runtime;
    int mainzisegmap_316429_runs;
    CUfunction mainzisegmap_316650;
    int64_t mainzisegmap_316650_total_runtime;
    int mainzisegmap_316650_runs;
    CUfunction mainzisegmap_316672;
    int64_t mainzisegmap_316672_total_runtime;
    int mainzisegmap_316672_runs;
    CUfunction mainzisegmap_316711;
    int64_t mainzisegmap_316711_total_runtime;
    int mainzisegmap_316711_runs;
    CUfunction mainzisegmap_316782;
    int64_t mainzisegmap_316782_total_runtime;
    int mainzisegmap_316782_runs;
    CUfunction mainzisegmap_316840;
    int64_t mainzisegmap_316840_total_runtime;
    int mainzisegmap_316840_runs;
    CUfunction mainzisegmap_316857;
    int64_t mainzisegmap_316857_total_runtime;
    int mainzisegmap_316857_runs;
    CUfunction mainzisegmap_316876;
    int64_t mainzisegmap_316876_total_runtime;
    int mainzisegmap_316876_runs;
    CUfunction mainzisegmap_316918;
    int64_t mainzisegmap_316918_total_runtime;
    int mainzisegmap_316918_runs;
    CUfunction mainzisegmap_317016;
    int64_t mainzisegmap_317016_total_runtime;
    int mainzisegmap_317016_runs;
    CUfunction mainzisegmap_317052;
    int64_t mainzisegmap_317052_total_runtime;
    int mainzisegmap_317052_runs;
    CUfunction mainzisegmap_317089;
    int64_t mainzisegmap_317089_total_runtime;
    int mainzisegmap_317089_runs;
    CUfunction mainzisegmap_317118;
    int64_t mainzisegmap_317118_total_runtime;
    int mainzisegmap_317118_runs;
    CUfunction mainzisegmap_317377;
    int64_t mainzisegmap_317377_total_runtime;
    int mainzisegmap_317377_runs;
    CUfunction mainzisegmap_317481;
    int64_t mainzisegmap_317481_total_runtime;
    int mainzisegmap_317481_runs;
    CUfunction mainzisegmap_317504;
    int64_t mainzisegmap_317504_total_runtime;
    int mainzisegmap_317504_runs;
    CUfunction mainzisegmap_intragroup_297641;
    int64_t mainzisegmap_intragroup_297641_total_runtime;
    int mainzisegmap_intragroup_297641_runs;
    CUfunction mainzisegmap_intragroup_298000;
    int64_t mainzisegmap_intragroup_298000_total_runtime;
    int mainzisegmap_intragroup_298000_runs;
    CUfunction mainzisegmap_intragroup_298276;
    int64_t mainzisegmap_intragroup_298276_total_runtime;
    int mainzisegmap_intragroup_298276_runs;
    CUfunction mainzisegmap_intragroup_298529;
    int64_t mainzisegmap_intragroup_298529_total_runtime;
    int mainzisegmap_intragroup_298529_runs;
    CUfunction mainzisegmap_intragroup_299433;
    int64_t mainzisegmap_intragroup_299433_total_runtime;
    int mainzisegmap_intragroup_299433_runs;
    CUfunction mainzisegmap_intragroup_299834;
    int64_t mainzisegmap_intragroup_299834_total_runtime;
    int mainzisegmap_intragroup_299834_runs;
    CUfunction mainzisegmap_intragroup_300460;
    int64_t mainzisegmap_intragroup_300460_total_runtime;
    int mainzisegmap_intragroup_300460_runs;
    CUfunction mainzisegmap_intragroup_302597;
    int64_t mainzisegmap_intragroup_302597_total_runtime;
    int mainzisegmap_intragroup_302597_runs;
    CUfunction mainzisegmap_intragroup_302925;
    int64_t mainzisegmap_intragroup_302925_total_runtime;
    int mainzisegmap_intragroup_302925_runs;
    CUfunction mainzisegmap_intragroup_303389;
    int64_t mainzisegmap_intragroup_303389_total_runtime;
    int mainzisegmap_intragroup_303389_runs;
    CUfunction mainzisegmap_intragroup_304495;
    int64_t mainzisegmap_intragroup_304495_total_runtime;
    int mainzisegmap_intragroup_304495_runs;
    CUfunction mainzisegmap_intragroup_306005;
    int64_t mainzisegmap_intragroup_306005_total_runtime;
    int mainzisegmap_intragroup_306005_runs;
    CUfunction mainzisegmap_intragroup_307881;
    int64_t mainzisegmap_intragroup_307881_total_runtime;
    int mainzisegmap_intragroup_307881_runs;
    CUfunction mainzisegmap_intragroup_309930;
    int64_t mainzisegmap_intragroup_309930_total_runtime;
    int mainzisegmap_intragroup_309930_runs;
    CUfunction mainzisegmap_intragroup_310101;
    int64_t mainzisegmap_intragroup_310101_total_runtime;
    int mainzisegmap_intragroup_310101_runs;
    CUfunction mainzisegmap_intragroup_310366;
    int64_t mainzisegmap_intragroup_310366_total_runtime;
    int mainzisegmap_intragroup_310366_runs;
    CUfunction mainzisegmap_intragroup_313503;
    int64_t mainzisegmap_intragroup_313503_total_runtime;
    int mainzisegmap_intragroup_313503_runs;
    CUfunction mainzisegmap_intragroup_313823;
    int64_t mainzisegmap_intragroup_313823_total_runtime;
    int mainzisegmap_intragroup_313823_runs;
    CUfunction mainzisegmap_intragroup_314238;
    int64_t mainzisegmap_intragroup_314238_total_runtime;
    int mainzisegmap_intragroup_314238_runs;
    CUfunction mainzisegmap_intragroup_316520;
    int64_t mainzisegmap_intragroup_316520_total_runtime;
    int mainzisegmap_intragroup_316520_runs;
    CUfunction mainzisegmap_intragroup_318088;
    int64_t mainzisegmap_intragroup_318088_total_runtime;
    int mainzisegmap_intragroup_318088_runs;
    CUfunction mainzisegred_large_304643;
    int64_t mainzisegred_large_304643_total_runtime;
    int mainzisegred_large_304643_runs;
    CUfunction mainzisegred_large_304718;
    int64_t mainzisegred_large_304718_total_runtime;
    int mainzisegred_large_304718_runs;
    CUfunction mainzisegred_large_306191;
    int64_t mainzisegred_large_306191_total_runtime;
    int mainzisegred_large_306191_runs;
    CUfunction mainzisegred_large_306288;
    int64_t mainzisegred_large_306288_total_runtime;
    int mainzisegred_large_306288_runs;
    CUfunction mainzisegred_large_308109;
    int64_t mainzisegred_large_308109_total_runtime;
    int mainzisegred_large_308109_runs;
    CUfunction mainzisegred_large_308237;
    int64_t mainzisegred_large_308237_total_runtime;
    int mainzisegred_large_308237_runs;
    CUfunction mainzisegred_large_308859;
    int64_t mainzisegred_large_308859_total_runtime;
    int mainzisegred_large_308859_runs;
    CUfunction mainzisegred_large_308990;
    int64_t mainzisegred_large_308990_total_runtime;
    int mainzisegred_large_308990_runs;
    CUfunction mainzisegred_large_309121;
    int64_t mainzisegred_large_309121_total_runtime;
    int mainzisegred_large_309121_runs;
    CUfunction mainzisegred_large_310765;
    int64_t mainzisegred_large_310765_total_runtime;
    int mainzisegred_large_310765_runs;
    CUfunction mainzisegred_large_310815;
    int64_t mainzisegred_large_310815_total_runtime;
    int mainzisegred_large_310815_runs;
    CUfunction mainzisegred_large_311208;
    int64_t mainzisegred_large_311208_total_runtime;
    int mainzisegred_large_311208_runs;
    CUfunction mainzisegred_large_311280;
    int64_t mainzisegred_large_311280_total_runtime;
    int mainzisegred_large_311280_runs;
    CUfunction mainzisegred_large_311778;
    int64_t mainzisegred_large_311778_total_runtime;
    int mainzisegred_large_311778_runs;
    CUfunction mainzisegred_large_311881;
    int64_t mainzisegred_large_311881_total_runtime;
    int mainzisegred_large_311881_runs;
    CUfunction mainzisegred_large_314793;
    int64_t mainzisegred_large_314793_total_runtime;
    int mainzisegred_large_314793_runs;
    CUfunction mainzisegred_large_314846;
    int64_t mainzisegred_large_314846_total_runtime;
    int mainzisegred_large_314846_runs;
    CUfunction mainzisegred_large_315394;
    int64_t mainzisegred_large_315394_total_runtime;
    int mainzisegred_large_315394_runs;
    CUfunction mainzisegred_large_315469;
    int64_t mainzisegred_large_315469_total_runtime;
    int mainzisegred_large_315469_runs;
    CUfunction mainzisegred_large_316122;
    int64_t mainzisegred_large_316122_total_runtime;
    int mainzisegred_large_316122_runs;
    CUfunction mainzisegred_large_316228;
    int64_t mainzisegred_large_316228_total_runtime;
    int mainzisegred_large_316228_runs;
    CUfunction mainzisegred_large_316768;
    int64_t mainzisegred_large_316768_total_runtime;
    int mainzisegred_large_316768_runs;
    CUfunction mainzisegred_large_317337;
    int64_t mainzisegred_large_317337_total_runtime;
    int mainzisegred_large_317337_runs;
    CUfunction mainzisegred_large_325358;
    int64_t mainzisegred_large_325358_total_runtime;
    int mainzisegred_large_325358_runs;
    CUfunction mainzisegred_small_304643;
    int64_t mainzisegred_small_304643_total_runtime;
    int mainzisegred_small_304643_runs;
    CUfunction mainzisegred_small_304718;
    int64_t mainzisegred_small_304718_total_runtime;
    int mainzisegred_small_304718_runs;
    CUfunction mainzisegred_small_306191;
    int64_t mainzisegred_small_306191_total_runtime;
    int mainzisegred_small_306191_runs;
    CUfunction mainzisegred_small_306288;
    int64_t mainzisegred_small_306288_total_runtime;
    int mainzisegred_small_306288_runs;
    CUfunction mainzisegred_small_308109;
    int64_t mainzisegred_small_308109_total_runtime;
    int mainzisegred_small_308109_runs;
    CUfunction mainzisegred_small_308237;
    int64_t mainzisegred_small_308237_total_runtime;
    int mainzisegred_small_308237_runs;
    CUfunction mainzisegred_small_308859;
    int64_t mainzisegred_small_308859_total_runtime;
    int mainzisegred_small_308859_runs;
    CUfunction mainzisegred_small_308990;
    int64_t mainzisegred_small_308990_total_runtime;
    int mainzisegred_small_308990_runs;
    CUfunction mainzisegred_small_309121;
    int64_t mainzisegred_small_309121_total_runtime;
    int mainzisegred_small_309121_runs;
    CUfunction mainzisegred_small_310765;
    int64_t mainzisegred_small_310765_total_runtime;
    int mainzisegred_small_310765_runs;
    CUfunction mainzisegred_small_310815;
    int64_t mainzisegred_small_310815_total_runtime;
    int mainzisegred_small_310815_runs;
    CUfunction mainzisegred_small_311208;
    int64_t mainzisegred_small_311208_total_runtime;
    int mainzisegred_small_311208_runs;
    CUfunction mainzisegred_small_311280;
    int64_t mainzisegred_small_311280_total_runtime;
    int mainzisegred_small_311280_runs;
    CUfunction mainzisegred_small_311778;
    int64_t mainzisegred_small_311778_total_runtime;
    int mainzisegred_small_311778_runs;
    CUfunction mainzisegred_small_311881;
    int64_t mainzisegred_small_311881_total_runtime;
    int mainzisegred_small_311881_runs;
    CUfunction mainzisegred_small_314793;
    int64_t mainzisegred_small_314793_total_runtime;
    int mainzisegred_small_314793_runs;
    CUfunction mainzisegred_small_314846;
    int64_t mainzisegred_small_314846_total_runtime;
    int mainzisegred_small_314846_runs;
    CUfunction mainzisegred_small_315394;
    int64_t mainzisegred_small_315394_total_runtime;
    int mainzisegred_small_315394_runs;
    CUfunction mainzisegred_small_315469;
    int64_t mainzisegred_small_315469_total_runtime;
    int mainzisegred_small_315469_runs;
    CUfunction mainzisegred_small_316122;
    int64_t mainzisegred_small_316122_total_runtime;
    int mainzisegred_small_316122_runs;
    CUfunction mainzisegred_small_316228;
    int64_t mainzisegred_small_316228_total_runtime;
    int mainzisegred_small_316228_runs;
    CUfunction mainzisegred_small_316768;
    int64_t mainzisegred_small_316768_total_runtime;
    int mainzisegred_small_316768_runs;
    CUfunction mainzisegred_small_317337;
    int64_t mainzisegred_small_317337_total_runtime;
    int mainzisegred_small_317337_runs;
    CUfunction mainzisegred_small_325358;
    int64_t mainzisegred_small_325358_total_runtime;
    int mainzisegred_small_325358_runs;
    CUfunction mainzisegscan_297615;
    int64_t mainzisegscan_297615_total_runtime;
    int mainzisegscan_297615_runs;
    CUfunction mainzisegscan_297755;
    int64_t mainzisegscan_297755_total_runtime;
    int mainzisegscan_297755_runs;
    CUfunction mainzisegscan_298311;
    int64_t mainzisegscan_298311_total_runtime;
    int mainzisegscan_298311_runs;
    CUfunction mainzisegscan_308911;
    int64_t mainzisegscan_308911_total_runtime;
    int mainzisegscan_308911_runs;
    CUfunction mainzisegscan_309042;
    int64_t mainzisegscan_309042_total_runtime;
    int mainzisegscan_309042_runs;
    CUfunction mainzisegscan_309173;
    int64_t mainzisegscan_309173_total_runtime;
    int mainzisegscan_309173_runs;
    CUfunction mainzisegscan_316886;
    int64_t mainzisegscan_316886_total_runtime;
    int mainzisegscan_316886_runs;
    CUfunction mainzisegscan_317116;
    int64_t mainzisegscan_317116_total_runtime;
    int mainzisegscan_317116_runs;
    CUfunction seasonal_amplitudezisegmap_297410;
    int64_t seasonal_amplitudezisegmap_297410_total_runtime;
    int seasonal_amplitudezisegmap_297410_runs;
    CUfunction seasonal_amplitudezisegmap_297483;
    int64_t seasonal_amplitudezisegmap_297483_total_runtime;
    int seasonal_amplitudezisegmap_297483_runs;
    CUfunction seasonal_amplitudezisegred_large_297469;
    int64_t seasonal_amplitudezisegred_large_297469_total_runtime;
    int seasonal_amplitudezisegred_large_297469_runs;
    CUfunction seasonal_amplitudezisegred_small_297469;
    int64_t seasonal_amplitudezisegred_small_297469_total_runtime;
    int seasonal_amplitudezisegred_small_297469_runs;
    CUfunction trend_magnitudezisegmap_297603;
    int64_t trend_magnitudezisegmap_297603_total_runtime;
    int trend_magnitudezisegmap_297603_runs;
    CUfunction trend_magnitudezisegmap_intragroup_318088;
    int64_t trend_magnitudezisegmap_intragroup_318088_total_runtime;
    int trend_magnitudezisegmap_intragroup_318088_runs;
    CUfunction trend_magnitudezisegred_large_297587;
    int64_t trend_magnitudezisegred_large_297587_total_runtime;
    int trend_magnitudezisegred_large_297587_runs;
    CUfunction trend_magnitudezisegred_nonseg_297501;
    int64_t trend_magnitudezisegred_nonseg_297501_total_runtime;
    int trend_magnitudezisegred_nonseg_297501_runs;
    CUfunction trend_magnitudezisegred_small_297587;
    int64_t trend_magnitudezisegred_small_297587_total_runtime;
    int trend_magnitudezisegred_small_297587_runs;
    int64_t copy_dev_to_dev_total_runtime;
    int copy_dev_to_dev_runs;
    int64_t copy_dev_to_host_total_runtime;
    int copy_dev_to_host_runs;
    int64_t copy_host_to_dev_total_runtime;
    int copy_host_to_dev_runs;
    int64_t copy_scalar_to_dev_total_runtime;
    int copy_scalar_to_dev_runs;
    int64_t copy_scalar_from_dev_total_runtime;
    int copy_scalar_from_dev_runs;
    CUdeviceptr global_failure;
    CUdeviceptr global_failure_args;
    struct cuda_context cuda;
    struct tuning_params tuning_params;
    int32_t failure_is_an_option;
    int total_runs;
    long total_runtime;
};
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    
    struct futhark_context *ctx =
                           (struct futhark_context *) malloc(sizeof(struct futhark_context));
    
    if (ctx == NULL)
        return NULL;
    ctx->cfg = cfg;
    ctx->cfg->in_use = 1;
    ctx->debugging = ctx->detail_memory = cfg->cu_cfg.debugging;
    ctx->profiling = cfg->profiling;
    ctx->profiling_paused = 0;
    ctx->logging = cfg->cu_cfg.logging;
    ctx->error = NULL;
    ctx->log = stderr;
    ctx->cuda.profiling_records_capacity = 200;
    ctx->cuda.profiling_records_used = 0;
    ctx->cuda.profiling_records = malloc(ctx->cuda.profiling_records_capacity *
        sizeof(struct profiling_record));
    ctx->cuda.cfg = cfg->cu_cfg;
    create_lock(&ctx->lock);
    ctx->failure_is_an_option = 0;
    ctx->total_runs = 0;
    ctx->total_runtime = 0;
    ctx->peak_mem_usage_device = 0;
    ctx->cur_mem_usage_device = 0;
    ctx->peak_mem_usage_default = 0;
    ctx->cur_mem_usage_default = 0;
    ctx->error = cuda_setup(&ctx->cuda, cuda_program, cfg->nvrtc_opts);
    if (ctx->error != NULL)
        return NULL;
    
    int32_t no_error = -1;
    
    CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->global_failure, sizeof(no_error)));
    CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->global_failure, &no_error,
                                    sizeof(no_error)));
    // The +1 is to avoid zero-byte allocations.
    CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->global_failure_args, sizeof(int64_t) *
                                  (4 + 1)));
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->builtinzhreplicate_f32zireplicate_325746,
                                           ctx->cuda.module,
                                           "builtinzhreplicate_f32zireplicate_325746"));
    ctx->builtinzhreplicate_f32zireplicate_325746_total_runtime = 0;
    ctx->builtinzhreplicate_f32zireplicate_325746_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->builtinzhreplicate_f64zireplicate_321586,
                                           ctx->cuda.module,
                                           "builtinzhreplicate_f64zireplicate_321586"));
    ctx->builtinzhreplicate_f64zireplicate_321586_total_runtime = 0;
    ctx->builtinzhreplicate_f64zireplicate_321586_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->builtinzhreplicate_i32zireplicate_325103,
                                           ctx->cuda.module,
                                           "builtinzhreplicate_i32zireplicate_325103"));
    ctx->builtinzhreplicate_i32zireplicate_325103_total_runtime = 0;
    ctx->builtinzhreplicate_i32zireplicate_325103_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->builtinzhreplicate_i64zireplicate_321086,
                                           ctx->cuda.module,
                                           "builtinzhreplicate_i64zireplicate_321086"));
    ctx->builtinzhreplicate_i64zireplicate_321086_total_runtime = 0;
    ctx->builtinzhreplicate_i64zireplicate_321086_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->builtinzhreplicate_i8zireplicate_320841,
                                           ctx->cuda.module,
                                           "builtinzhreplicate_i8zireplicate_320841"));
    ctx->builtinzhreplicate_i8zireplicate_320841_total_runtime = 0;
    ctx->builtinzhreplicate_i8zireplicate_320841_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->gpu_map_transpose_f32,
                                           ctx->cuda.module,
                                           "gpu_map_transpose_f32"));
    ctx->gpu_map_transpose_f32_total_runtime = 0;
    ctx->gpu_map_transpose_f32_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->gpu_map_transpose_f32_low_height,
                                           ctx->cuda.module,
                                           "gpu_map_transpose_f32_low_height"));
    ctx->gpu_map_transpose_f32_low_height_total_runtime = 0;
    ctx->gpu_map_transpose_f32_low_height_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->gpu_map_transpose_f32_low_width,
                                           ctx->cuda.module,
                                           "gpu_map_transpose_f32_low_width"));
    ctx->gpu_map_transpose_f32_low_width_total_runtime = 0;
    ctx->gpu_map_transpose_f32_low_width_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->gpu_map_transpose_f32_small,
                                           ctx->cuda.module,
                                           "gpu_map_transpose_f32_small"));
    ctx->gpu_map_transpose_f32_small_total_runtime = 0;
    ctx->gpu_map_transpose_f32_small_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->gpu_map_transpose_f64,
                                           ctx->cuda.module,
                                           "gpu_map_transpose_f64"));
    ctx->gpu_map_transpose_f64_total_runtime = 0;
    ctx->gpu_map_transpose_f64_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->gpu_map_transpose_f64_low_height,
                                           ctx->cuda.module,
                                           "gpu_map_transpose_f64_low_height"));
    ctx->gpu_map_transpose_f64_low_height_total_runtime = 0;
    ctx->gpu_map_transpose_f64_low_height_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->gpu_map_transpose_f64_low_width,
                                           ctx->cuda.module,
                                           "gpu_map_transpose_f64_low_width"));
    ctx->gpu_map_transpose_f64_low_width_total_runtime = 0;
    ctx->gpu_map_transpose_f64_low_width_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->gpu_map_transpose_f64_small,
                                           ctx->cuda.module,
                                           "gpu_map_transpose_f64_small"));
    ctx->gpu_map_transpose_f64_small_total_runtime = 0;
    ctx->gpu_map_transpose_f64_small_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->gpu_map_transpose_i64,
                                           ctx->cuda.module,
                                           "gpu_map_transpose_i64"));
    ctx->gpu_map_transpose_i64_total_runtime = 0;
    ctx->gpu_map_transpose_i64_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->gpu_map_transpose_i64_low_height,
                                           ctx->cuda.module,
                                           "gpu_map_transpose_i64_low_height"));
    ctx->gpu_map_transpose_i64_low_height_total_runtime = 0;
    ctx->gpu_map_transpose_i64_low_height_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->gpu_map_transpose_i64_low_width,
                                           ctx->cuda.module,
                                           "gpu_map_transpose_i64_low_width"));
    ctx->gpu_map_transpose_i64_low_width_total_runtime = 0;
    ctx->gpu_map_transpose_i64_low_width_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->gpu_map_transpose_i64_small,
                                           ctx->cuda.module,
                                           "gpu_map_transpose_i64_small"));
    ctx->gpu_map_transpose_i64_small_total_runtime = 0;
    ctx->gpu_map_transpose_i64_small_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzicopy_321104,
                                           ctx->cuda.module,
                                           "mainzicopy_321104"));
    ctx->mainzicopy_321104_total_runtime = 0;
    ctx->mainzicopy_321104_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzicopy_321321,
                                           ctx->cuda.module,
                                           "mainzicopy_321321"));
    ctx->mainzicopy_321321_total_runtime = 0;
    ctx->mainzicopy_321321_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainziseghist_global_316946,
                                           ctx->cuda.module,
                                           "mainziseghist_global_316946"));
    ctx->mainziseghist_global_316946_total_runtime = 0;
    ctx->mainziseghist_global_316946_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainziseghist_local_316946,
                                           ctx->cuda.module,
                                           "mainziseghist_local_316946"));
    ctx->mainziseghist_local_316946_total_runtime = 0;
    ctx->mainziseghist_local_316946_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_297617,
                                           ctx->cuda.module,
                                           "mainzisegmap_297617"));
    ctx->mainzisegmap_297617_total_runtime = 0;
    ctx->mainzisegmap_297617_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_297793,
                                           ctx->cuda.module,
                                           "mainzisegmap_297793"));
    ctx->mainzisegmap_297793_total_runtime = 0;
    ctx->mainzisegmap_297793_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_297921,
                                           ctx->cuda.module,
                                           "mainzisegmap_297921"));
    ctx->mainzisegmap_297921_total_runtime = 0;
    ctx->mainzisegmap_297921_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_298357,
                                           ctx->cuda.module,
                                           "mainzisegmap_298357"));
    ctx->mainzisegmap_298357_total_runtime = 0;
    ctx->mainzisegmap_298357_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_299570,
                                           ctx->cuda.module,
                                           "mainzisegmap_299570"));
    ctx->mainzisegmap_299570_total_runtime = 0;
    ctx->mainzisegmap_299570_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_299584,
                                           ctx->cuda.module,
                                           "mainzisegmap_299584"));
    ctx->mainzisegmap_299584_total_runtime = 0;
    ctx->mainzisegmap_299584_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_299608,
                                           ctx->cuda.module,
                                           "mainzisegmap_299608"));
    ctx->mainzisegmap_299608_total_runtime = 0;
    ctx->mainzisegmap_299608_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_300218,
                                           ctx->cuda.module,
                                           "mainzisegmap_300218"));
    ctx->mainzisegmap_300218_total_runtime = 0;
    ctx->mainzisegmap_300218_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_300230,
                                           ctx->cuda.module,
                                           "mainzisegmap_300230"));
    ctx->mainzisegmap_300230_total_runtime = 0;
    ctx->mainzisegmap_300230_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_300251,
                                           ctx->cuda.module,
                                           "mainzisegmap_300251"));
    ctx->mainzisegmap_300251_total_runtime = 0;
    ctx->mainzisegmap_300251_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_300844,
                                           ctx->cuda.module,
                                           "mainzisegmap_300844"));
    ctx->mainzisegmap_300844_total_runtime = 0;
    ctx->mainzisegmap_300844_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_300856,
                                           ctx->cuda.module,
                                           "mainzisegmap_300856"));
    ctx->mainzisegmap_300856_total_runtime = 0;
    ctx->mainzisegmap_300856_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_300877,
                                           ctx->cuda.module,
                                           "mainzisegmap_300877"));
    ctx->mainzisegmap_300877_total_runtime = 0;
    ctx->mainzisegmap_300877_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_301021,
                                           ctx->cuda.module,
                                           "mainzisegmap_301021"));
    ctx->mainzisegmap_301021_total_runtime = 0;
    ctx->mainzisegmap_301021_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_301167,
                                           ctx->cuda.module,
                                           "mainzisegmap_301167"));
    ctx->mainzisegmap_301167_total_runtime = 0;
    ctx->mainzisegmap_301167_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_301414,
                                           ctx->cuda.module,
                                           "mainzisegmap_301414"));
    ctx->mainzisegmap_301414_total_runtime = 0;
    ctx->mainzisegmap_301414_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_301783,
                                           ctx->cuda.module,
                                           "mainzisegmap_301783"));
    ctx->mainzisegmap_301783_total_runtime = 0;
    ctx->mainzisegmap_301783_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_302252,
                                           ctx->cuda.module,
                                           "mainzisegmap_302252"));
    ctx->mainzisegmap_302252_total_runtime = 0;
    ctx->mainzisegmap_302252_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_304408,
                                           ctx->cuda.module,
                                           "mainzisegmap_304408"));
    ctx->mainzisegmap_304408_total_runtime = 0;
    ctx->mainzisegmap_304408_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_304619,
                                           ctx->cuda.module,
                                           "mainzisegmap_304619"));
    ctx->mainzisegmap_304619_total_runtime = 0;
    ctx->mainzisegmap_304619_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_304691,
                                           ctx->cuda.module,
                                           "mainzisegmap_304691"));
    ctx->mainzisegmap_304691_total_runtime = 0;
    ctx->mainzisegmap_304691_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_305885,
                                           ctx->cuda.module,
                                           "mainzisegmap_305885"));
    ctx->mainzisegmap_305885_total_runtime = 0;
    ctx->mainzisegmap_305885_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_306165,
                                           ctx->cuda.module,
                                           "mainzisegmap_306165"));
    ctx->mainzisegmap_306165_total_runtime = 0;
    ctx->mainzisegmap_306165_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_306249,
                                           ctx->cuda.module,
                                           "mainzisegmap_306249"));
    ctx->mainzisegmap_306249_total_runtime = 0;
    ctx->mainzisegmap_306249_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_307727,
                                           ctx->cuda.module,
                                           "mainzisegmap_307727"));
    ctx->mainzisegmap_307727_total_runtime = 0;
    ctx->mainzisegmap_307727_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_308081,
                                           ctx->cuda.module,
                                           "mainzisegmap_308081"));
    ctx->mainzisegmap_308081_total_runtime = 0;
    ctx->mainzisegmap_308081_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_308177,
                                           ctx->cuda.module,
                                           "mainzisegmap_308177"));
    ctx->mainzisegmap_308177_total_runtime = 0;
    ctx->mainzisegmap_308177_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_308641,
                                           ctx->cuda.module,
                                           "mainzisegmap_308641"));
    ctx->mainzisegmap_308641_total_runtime = 0;
    ctx->mainzisegmap_308641_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_308790,
                                           ctx->cuda.module,
                                           "mainzisegmap_308790"));
    ctx->mainzisegmap_308790_total_runtime = 0;
    ctx->mainzisegmap_308790_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_308826,
                                           ctx->cuda.module,
                                           "mainzisegmap_308826"));
    ctx->mainzisegmap_308826_total_runtime = 0;
    ctx->mainzisegmap_308826_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_308957,
                                           ctx->cuda.module,
                                           "mainzisegmap_308957"));
    ctx->mainzisegmap_308957_total_runtime = 0;
    ctx->mainzisegmap_308957_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_309088,
                                           ctx->cuda.module,
                                           "mainzisegmap_309088"));
    ctx->mainzisegmap_309088_total_runtime = 0;
    ctx->mainzisegmap_309088_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_309288,
                                           ctx->cuda.module,
                                           "mainzisegmap_309288"));
    ctx->mainzisegmap_309288_total_runtime = 0;
    ctx->mainzisegmap_309288_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_309471,
                                           ctx->cuda.module,
                                           "mainzisegmap_309471"));
    ctx->mainzisegmap_309471_total_runtime = 0;
    ctx->mainzisegmap_309471_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_309719,
                                           ctx->cuda.module,
                                           "mainzisegmap_309719"));
    ctx->mainzisegmap_309719_total_runtime = 0;
    ctx->mainzisegmap_309719_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_310801,
                                           ctx->cuda.module,
                                           "mainzisegmap_310801"));
    ctx->mainzisegmap_310801_total_runtime = 0;
    ctx->mainzisegmap_310801_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_311254,
                                           ctx->cuda.module,
                                           "mainzisegmap_311254"));
    ctx->mainzisegmap_311254_total_runtime = 0;
    ctx->mainzisegmap_311254_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_311834,
                                           ctx->cuda.module,
                                           "mainzisegmap_311834"));
    ctx->mainzisegmap_311834_total_runtime = 0;
    ctx->mainzisegmap_311834_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_312079,
                                           ctx->cuda.module,
                                           "mainzisegmap_312079"));
    ctx->mainzisegmap_312079_total_runtime = 0;
    ctx->mainzisegmap_312079_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_312174,
                                           ctx->cuda.module,
                                           "mainzisegmap_312174"));
    ctx->mainzisegmap_312174_total_runtime = 0;
    ctx->mainzisegmap_312174_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_312372,
                                           ctx->cuda.module,
                                           "mainzisegmap_312372"));
    ctx->mainzisegmap_312372_total_runtime = 0;
    ctx->mainzisegmap_312372_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_312390,
                                           ctx->cuda.module,
                                           "mainzisegmap_312390"));
    ctx->mainzisegmap_312390_total_runtime = 0;
    ctx->mainzisegmap_312390_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_312414,
                                           ctx->cuda.module,
                                           "mainzisegmap_312414"));
    ctx->mainzisegmap_312414_total_runtime = 0;
    ctx->mainzisegmap_312414_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_312703,
                                           ctx->cuda.module,
                                           "mainzisegmap_312703"));
    ctx->mainzisegmap_312703_total_runtime = 0;
    ctx->mainzisegmap_312703_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_312721,
                                           ctx->cuda.module,
                                           "mainzisegmap_312721"));
    ctx->mainzisegmap_312721_total_runtime = 0;
    ctx->mainzisegmap_312721_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_312746,
                                           ctx->cuda.module,
                                           "mainzisegmap_312746"));
    ctx->mainzisegmap_312746_total_runtime = 0;
    ctx->mainzisegmap_312746_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_313100,
                                           ctx->cuda.module,
                                           "mainzisegmap_313100"));
    ctx->mainzisegmap_313100_total_runtime = 0;
    ctx->mainzisegmap_313100_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_313118,
                                           ctx->cuda.module,
                                           "mainzisegmap_313118"));
    ctx->mainzisegmap_313118_total_runtime = 0;
    ctx->mainzisegmap_313118_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_313143,
                                           ctx->cuda.module,
                                           "mainzisegmap_313143"));
    ctx->mainzisegmap_313143_total_runtime = 0;
    ctx->mainzisegmap_313143_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_313458,
                                           ctx->cuda.module,
                                           "mainzisegmap_313458"));
    ctx->mainzisegmap_313458_total_runtime = 0;
    ctx->mainzisegmap_313458_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_313476,
                                           ctx->cuda.module,
                                           "mainzisegmap_313476"));
    ctx->mainzisegmap_313476_total_runtime = 0;
    ctx->mainzisegmap_313476_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_313777,
                                           ctx->cuda.module,
                                           "mainzisegmap_313777"));
    ctx->mainzisegmap_313777_total_runtime = 0;
    ctx->mainzisegmap_313777_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_313795,
                                           ctx->cuda.module,
                                           "mainzisegmap_313795"));
    ctx->mainzisegmap_313795_total_runtime = 0;
    ctx->mainzisegmap_313795_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_314192,
                                           ctx->cuda.module,
                                           "mainzisegmap_314192"));
    ctx->mainzisegmap_314192_total_runtime = 0;
    ctx->mainzisegmap_314192_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_314210,
                                           ctx->cuda.module,
                                           "mainzisegmap_314210"));
    ctx->mainzisegmap_314210_total_runtime = 0;
    ctx->mainzisegmap_314210_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_314732,
                                           ctx->cuda.module,
                                           "mainzisegmap_314732"));
    ctx->mainzisegmap_314732_total_runtime = 0;
    ctx->mainzisegmap_314732_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_314750,
                                           ctx->cuda.module,
                                           "mainzisegmap_314750"));
    ctx->mainzisegmap_314750_total_runtime = 0;
    ctx->mainzisegmap_314750_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_314832,
                                           ctx->cuda.module,
                                           "mainzisegmap_314832"));
    ctx->mainzisegmap_314832_total_runtime = 0;
    ctx->mainzisegmap_314832_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_315331,
                                           ctx->cuda.module,
                                           "mainzisegmap_315331"));
    ctx->mainzisegmap_315331_total_runtime = 0;
    ctx->mainzisegmap_315331_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_315349,
                                           ctx->cuda.module,
                                           "mainzisegmap_315349"));
    ctx->mainzisegmap_315349_total_runtime = 0;
    ctx->mainzisegmap_315349_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_315443,
                                           ctx->cuda.module,
                                           "mainzisegmap_315443"));
    ctx->mainzisegmap_315443_total_runtime = 0;
    ctx->mainzisegmap_315443_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_316057,
                                           ctx->cuda.module,
                                           "mainzisegmap_316057"));
    ctx->mainzisegmap_316057_total_runtime = 0;
    ctx->mainzisegmap_316057_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_316075,
                                           ctx->cuda.module,
                                           "mainzisegmap_316075"));
    ctx->mainzisegmap_316075_total_runtime = 0;
    ctx->mainzisegmap_316075_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_316181,
                                           ctx->cuda.module,
                                           "mainzisegmap_316181"));
    ctx->mainzisegmap_316181_total_runtime = 0;
    ctx->mainzisegmap_316181_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_316429,
                                           ctx->cuda.module,
                                           "mainzisegmap_316429"));
    ctx->mainzisegmap_316429_total_runtime = 0;
    ctx->mainzisegmap_316429_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_316650,
                                           ctx->cuda.module,
                                           "mainzisegmap_316650"));
    ctx->mainzisegmap_316650_total_runtime = 0;
    ctx->mainzisegmap_316650_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_316672,
                                           ctx->cuda.module,
                                           "mainzisegmap_316672"));
    ctx->mainzisegmap_316672_total_runtime = 0;
    ctx->mainzisegmap_316672_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_316711,
                                           ctx->cuda.module,
                                           "mainzisegmap_316711"));
    ctx->mainzisegmap_316711_total_runtime = 0;
    ctx->mainzisegmap_316711_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_316782,
                                           ctx->cuda.module,
                                           "mainzisegmap_316782"));
    ctx->mainzisegmap_316782_total_runtime = 0;
    ctx->mainzisegmap_316782_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_316840,
                                           ctx->cuda.module,
                                           "mainzisegmap_316840"));
    ctx->mainzisegmap_316840_total_runtime = 0;
    ctx->mainzisegmap_316840_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_316857,
                                           ctx->cuda.module,
                                           "mainzisegmap_316857"));
    ctx->mainzisegmap_316857_total_runtime = 0;
    ctx->mainzisegmap_316857_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_316876,
                                           ctx->cuda.module,
                                           "mainzisegmap_316876"));
    ctx->mainzisegmap_316876_total_runtime = 0;
    ctx->mainzisegmap_316876_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_316918,
                                           ctx->cuda.module,
                                           "mainzisegmap_316918"));
    ctx->mainzisegmap_316918_total_runtime = 0;
    ctx->mainzisegmap_316918_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_317016,
                                           ctx->cuda.module,
                                           "mainzisegmap_317016"));
    ctx->mainzisegmap_317016_total_runtime = 0;
    ctx->mainzisegmap_317016_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_317052,
                                           ctx->cuda.module,
                                           "mainzisegmap_317052"));
    ctx->mainzisegmap_317052_total_runtime = 0;
    ctx->mainzisegmap_317052_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_317089,
                                           ctx->cuda.module,
                                           "mainzisegmap_317089"));
    ctx->mainzisegmap_317089_total_runtime = 0;
    ctx->mainzisegmap_317089_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_317118,
                                           ctx->cuda.module,
                                           "mainzisegmap_317118"));
    ctx->mainzisegmap_317118_total_runtime = 0;
    ctx->mainzisegmap_317118_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_317377,
                                           ctx->cuda.module,
                                           "mainzisegmap_317377"));
    ctx->mainzisegmap_317377_total_runtime = 0;
    ctx->mainzisegmap_317377_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_317481,
                                           ctx->cuda.module,
                                           "mainzisegmap_317481"));
    ctx->mainzisegmap_317481_total_runtime = 0;
    ctx->mainzisegmap_317481_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_317504,
                                           ctx->cuda.module,
                                           "mainzisegmap_317504"));
    ctx->mainzisegmap_317504_total_runtime = 0;
    ctx->mainzisegmap_317504_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_297641,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_297641"));
    ctx->mainzisegmap_intragroup_297641_total_runtime = 0;
    ctx->mainzisegmap_intragroup_297641_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_298000,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_298000"));
    ctx->mainzisegmap_intragroup_298000_total_runtime = 0;
    ctx->mainzisegmap_intragroup_298000_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_298276,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_298276"));
    ctx->mainzisegmap_intragroup_298276_total_runtime = 0;
    ctx->mainzisegmap_intragroup_298276_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_298529,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_298529"));
    ctx->mainzisegmap_intragroup_298529_total_runtime = 0;
    ctx->mainzisegmap_intragroup_298529_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_299433,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_299433"));
    ctx->mainzisegmap_intragroup_299433_total_runtime = 0;
    ctx->mainzisegmap_intragroup_299433_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_299834,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_299834"));
    ctx->mainzisegmap_intragroup_299834_total_runtime = 0;
    ctx->mainzisegmap_intragroup_299834_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_300460,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_300460"));
    ctx->mainzisegmap_intragroup_300460_total_runtime = 0;
    ctx->mainzisegmap_intragroup_300460_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_302597,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_302597"));
    ctx->mainzisegmap_intragroup_302597_total_runtime = 0;
    ctx->mainzisegmap_intragroup_302597_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_302925,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_302925"));
    ctx->mainzisegmap_intragroup_302925_total_runtime = 0;
    ctx->mainzisegmap_intragroup_302925_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_303389,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_303389"));
    ctx->mainzisegmap_intragroup_303389_total_runtime = 0;
    ctx->mainzisegmap_intragroup_303389_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_304495,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_304495"));
    ctx->mainzisegmap_intragroup_304495_total_runtime = 0;
    ctx->mainzisegmap_intragroup_304495_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_306005,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_306005"));
    ctx->mainzisegmap_intragroup_306005_total_runtime = 0;
    ctx->mainzisegmap_intragroup_306005_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_307881,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_307881"));
    ctx->mainzisegmap_intragroup_307881_total_runtime = 0;
    ctx->mainzisegmap_intragroup_307881_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_309930,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_309930"));
    ctx->mainzisegmap_intragroup_309930_total_runtime = 0;
    ctx->mainzisegmap_intragroup_309930_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_310101,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_310101"));
    ctx->mainzisegmap_intragroup_310101_total_runtime = 0;
    ctx->mainzisegmap_intragroup_310101_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_310366,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_310366"));
    ctx->mainzisegmap_intragroup_310366_total_runtime = 0;
    ctx->mainzisegmap_intragroup_310366_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_313503,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_313503"));
    ctx->mainzisegmap_intragroup_313503_total_runtime = 0;
    ctx->mainzisegmap_intragroup_313503_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_313823,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_313823"));
    ctx->mainzisegmap_intragroup_313823_total_runtime = 0;
    ctx->mainzisegmap_intragroup_313823_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_314238,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_314238"));
    ctx->mainzisegmap_intragroup_314238_total_runtime = 0;
    ctx->mainzisegmap_intragroup_314238_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_316520,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_316520"));
    ctx->mainzisegmap_intragroup_316520_total_runtime = 0;
    ctx->mainzisegmap_intragroup_316520_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegmap_intragroup_318088,
                                           ctx->cuda.module,
                                           "mainzisegmap_intragroup_318088"));
    ctx->mainzisegmap_intragroup_318088_total_runtime = 0;
    ctx->mainzisegmap_intragroup_318088_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_304643,
                                           ctx->cuda.module,
                                           "mainzisegred_large_304643"));
    ctx->mainzisegred_large_304643_total_runtime = 0;
    ctx->mainzisegred_large_304643_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_304718,
                                           ctx->cuda.module,
                                           "mainzisegred_large_304718"));
    ctx->mainzisegred_large_304718_total_runtime = 0;
    ctx->mainzisegred_large_304718_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_306191,
                                           ctx->cuda.module,
                                           "mainzisegred_large_306191"));
    ctx->mainzisegred_large_306191_total_runtime = 0;
    ctx->mainzisegred_large_306191_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_306288,
                                           ctx->cuda.module,
                                           "mainzisegred_large_306288"));
    ctx->mainzisegred_large_306288_total_runtime = 0;
    ctx->mainzisegred_large_306288_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_308109,
                                           ctx->cuda.module,
                                           "mainzisegred_large_308109"));
    ctx->mainzisegred_large_308109_total_runtime = 0;
    ctx->mainzisegred_large_308109_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_308237,
                                           ctx->cuda.module,
                                           "mainzisegred_large_308237"));
    ctx->mainzisegred_large_308237_total_runtime = 0;
    ctx->mainzisegred_large_308237_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_308859,
                                           ctx->cuda.module,
                                           "mainzisegred_large_308859"));
    ctx->mainzisegred_large_308859_total_runtime = 0;
    ctx->mainzisegred_large_308859_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_308990,
                                           ctx->cuda.module,
                                           "mainzisegred_large_308990"));
    ctx->mainzisegred_large_308990_total_runtime = 0;
    ctx->mainzisegred_large_308990_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_309121,
                                           ctx->cuda.module,
                                           "mainzisegred_large_309121"));
    ctx->mainzisegred_large_309121_total_runtime = 0;
    ctx->mainzisegred_large_309121_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_310765,
                                           ctx->cuda.module,
                                           "mainzisegred_large_310765"));
    ctx->mainzisegred_large_310765_total_runtime = 0;
    ctx->mainzisegred_large_310765_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_310815,
                                           ctx->cuda.module,
                                           "mainzisegred_large_310815"));
    ctx->mainzisegred_large_310815_total_runtime = 0;
    ctx->mainzisegred_large_310815_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_311208,
                                           ctx->cuda.module,
                                           "mainzisegred_large_311208"));
    ctx->mainzisegred_large_311208_total_runtime = 0;
    ctx->mainzisegred_large_311208_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_311280,
                                           ctx->cuda.module,
                                           "mainzisegred_large_311280"));
    ctx->mainzisegred_large_311280_total_runtime = 0;
    ctx->mainzisegred_large_311280_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_311778,
                                           ctx->cuda.module,
                                           "mainzisegred_large_311778"));
    ctx->mainzisegred_large_311778_total_runtime = 0;
    ctx->mainzisegred_large_311778_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_311881,
                                           ctx->cuda.module,
                                           "mainzisegred_large_311881"));
    ctx->mainzisegred_large_311881_total_runtime = 0;
    ctx->mainzisegred_large_311881_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_314793,
                                           ctx->cuda.module,
                                           "mainzisegred_large_314793"));
    ctx->mainzisegred_large_314793_total_runtime = 0;
    ctx->mainzisegred_large_314793_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_314846,
                                           ctx->cuda.module,
                                           "mainzisegred_large_314846"));
    ctx->mainzisegred_large_314846_total_runtime = 0;
    ctx->mainzisegred_large_314846_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_315394,
                                           ctx->cuda.module,
                                           "mainzisegred_large_315394"));
    ctx->mainzisegred_large_315394_total_runtime = 0;
    ctx->mainzisegred_large_315394_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_315469,
                                           ctx->cuda.module,
                                           "mainzisegred_large_315469"));
    ctx->mainzisegred_large_315469_total_runtime = 0;
    ctx->mainzisegred_large_315469_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_316122,
                                           ctx->cuda.module,
                                           "mainzisegred_large_316122"));
    ctx->mainzisegred_large_316122_total_runtime = 0;
    ctx->mainzisegred_large_316122_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_316228,
                                           ctx->cuda.module,
                                           "mainzisegred_large_316228"));
    ctx->mainzisegred_large_316228_total_runtime = 0;
    ctx->mainzisegred_large_316228_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_316768,
                                           ctx->cuda.module,
                                           "mainzisegred_large_316768"));
    ctx->mainzisegred_large_316768_total_runtime = 0;
    ctx->mainzisegred_large_316768_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_317337,
                                           ctx->cuda.module,
                                           "mainzisegred_large_317337"));
    ctx->mainzisegred_large_317337_total_runtime = 0;
    ctx->mainzisegred_large_317337_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_large_325358,
                                           ctx->cuda.module,
                                           "mainzisegred_large_325358"));
    ctx->mainzisegred_large_325358_total_runtime = 0;
    ctx->mainzisegred_large_325358_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_304643,
                                           ctx->cuda.module,
                                           "mainzisegred_small_304643"));
    ctx->mainzisegred_small_304643_total_runtime = 0;
    ctx->mainzisegred_small_304643_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_304718,
                                           ctx->cuda.module,
                                           "mainzisegred_small_304718"));
    ctx->mainzisegred_small_304718_total_runtime = 0;
    ctx->mainzisegred_small_304718_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_306191,
                                           ctx->cuda.module,
                                           "mainzisegred_small_306191"));
    ctx->mainzisegred_small_306191_total_runtime = 0;
    ctx->mainzisegred_small_306191_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_306288,
                                           ctx->cuda.module,
                                           "mainzisegred_small_306288"));
    ctx->mainzisegred_small_306288_total_runtime = 0;
    ctx->mainzisegred_small_306288_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_308109,
                                           ctx->cuda.module,
                                           "mainzisegred_small_308109"));
    ctx->mainzisegred_small_308109_total_runtime = 0;
    ctx->mainzisegred_small_308109_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_308237,
                                           ctx->cuda.module,
                                           "mainzisegred_small_308237"));
    ctx->mainzisegred_small_308237_total_runtime = 0;
    ctx->mainzisegred_small_308237_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_308859,
                                           ctx->cuda.module,
                                           "mainzisegred_small_308859"));
    ctx->mainzisegred_small_308859_total_runtime = 0;
    ctx->mainzisegred_small_308859_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_308990,
                                           ctx->cuda.module,
                                           "mainzisegred_small_308990"));
    ctx->mainzisegred_small_308990_total_runtime = 0;
    ctx->mainzisegred_small_308990_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_309121,
                                           ctx->cuda.module,
                                           "mainzisegred_small_309121"));
    ctx->mainzisegred_small_309121_total_runtime = 0;
    ctx->mainzisegred_small_309121_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_310765,
                                           ctx->cuda.module,
                                           "mainzisegred_small_310765"));
    ctx->mainzisegred_small_310765_total_runtime = 0;
    ctx->mainzisegred_small_310765_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_310815,
                                           ctx->cuda.module,
                                           "mainzisegred_small_310815"));
    ctx->mainzisegred_small_310815_total_runtime = 0;
    ctx->mainzisegred_small_310815_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_311208,
                                           ctx->cuda.module,
                                           "mainzisegred_small_311208"));
    ctx->mainzisegred_small_311208_total_runtime = 0;
    ctx->mainzisegred_small_311208_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_311280,
                                           ctx->cuda.module,
                                           "mainzisegred_small_311280"));
    ctx->mainzisegred_small_311280_total_runtime = 0;
    ctx->mainzisegred_small_311280_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_311778,
                                           ctx->cuda.module,
                                           "mainzisegred_small_311778"));
    ctx->mainzisegred_small_311778_total_runtime = 0;
    ctx->mainzisegred_small_311778_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_311881,
                                           ctx->cuda.module,
                                           "mainzisegred_small_311881"));
    ctx->mainzisegred_small_311881_total_runtime = 0;
    ctx->mainzisegred_small_311881_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_314793,
                                           ctx->cuda.module,
                                           "mainzisegred_small_314793"));
    ctx->mainzisegred_small_314793_total_runtime = 0;
    ctx->mainzisegred_small_314793_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_314846,
                                           ctx->cuda.module,
                                           "mainzisegred_small_314846"));
    ctx->mainzisegred_small_314846_total_runtime = 0;
    ctx->mainzisegred_small_314846_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_315394,
                                           ctx->cuda.module,
                                           "mainzisegred_small_315394"));
    ctx->mainzisegred_small_315394_total_runtime = 0;
    ctx->mainzisegred_small_315394_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_315469,
                                           ctx->cuda.module,
                                           "mainzisegred_small_315469"));
    ctx->mainzisegred_small_315469_total_runtime = 0;
    ctx->mainzisegred_small_315469_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_316122,
                                           ctx->cuda.module,
                                           "mainzisegred_small_316122"));
    ctx->mainzisegred_small_316122_total_runtime = 0;
    ctx->mainzisegred_small_316122_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_316228,
                                           ctx->cuda.module,
                                           "mainzisegred_small_316228"));
    ctx->mainzisegred_small_316228_total_runtime = 0;
    ctx->mainzisegred_small_316228_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_316768,
                                           ctx->cuda.module,
                                           "mainzisegred_small_316768"));
    ctx->mainzisegred_small_316768_total_runtime = 0;
    ctx->mainzisegred_small_316768_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_317337,
                                           ctx->cuda.module,
                                           "mainzisegred_small_317337"));
    ctx->mainzisegred_small_317337_total_runtime = 0;
    ctx->mainzisegred_small_317337_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegred_small_325358,
                                           ctx->cuda.module,
                                           "mainzisegred_small_325358"));
    ctx->mainzisegred_small_325358_total_runtime = 0;
    ctx->mainzisegred_small_325358_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegscan_297615,
                                           ctx->cuda.module,
                                           "mainzisegscan_297615"));
    ctx->mainzisegscan_297615_total_runtime = 0;
    ctx->mainzisegscan_297615_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegscan_297755,
                                           ctx->cuda.module,
                                           "mainzisegscan_297755"));
    ctx->mainzisegscan_297755_total_runtime = 0;
    ctx->mainzisegscan_297755_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegscan_298311,
                                           ctx->cuda.module,
                                           "mainzisegscan_298311"));
    ctx->mainzisegscan_298311_total_runtime = 0;
    ctx->mainzisegscan_298311_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegscan_308911,
                                           ctx->cuda.module,
                                           "mainzisegscan_308911"));
    ctx->mainzisegscan_308911_total_runtime = 0;
    ctx->mainzisegscan_308911_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegscan_309042,
                                           ctx->cuda.module,
                                           "mainzisegscan_309042"));
    ctx->mainzisegscan_309042_total_runtime = 0;
    ctx->mainzisegscan_309042_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegscan_309173,
                                           ctx->cuda.module,
                                           "mainzisegscan_309173"));
    ctx->mainzisegscan_309173_total_runtime = 0;
    ctx->mainzisegscan_309173_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegscan_316886,
                                           ctx->cuda.module,
                                           "mainzisegscan_316886"));
    ctx->mainzisegscan_316886_total_runtime = 0;
    ctx->mainzisegscan_316886_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->mainzisegscan_317116,
                                           ctx->cuda.module,
                                           "mainzisegscan_317116"));
    ctx->mainzisegscan_317116_total_runtime = 0;
    ctx->mainzisegscan_317116_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->seasonal_amplitudezisegmap_297410,
                                           ctx->cuda.module,
                                           "seasonal_amplitudezisegmap_297410"));
    ctx->seasonal_amplitudezisegmap_297410_total_runtime = 0;
    ctx->seasonal_amplitudezisegmap_297410_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->seasonal_amplitudezisegmap_297483,
                                           ctx->cuda.module,
                                           "seasonal_amplitudezisegmap_297483"));
    ctx->seasonal_amplitudezisegmap_297483_total_runtime = 0;
    ctx->seasonal_amplitudezisegmap_297483_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->seasonal_amplitudezisegred_large_297469,
                                           ctx->cuda.module,
                                           "seasonal_amplitudezisegred_large_297469"));
    ctx->seasonal_amplitudezisegred_large_297469_total_runtime = 0;
    ctx->seasonal_amplitudezisegred_large_297469_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->seasonal_amplitudezisegred_small_297469,
                                           ctx->cuda.module,
                                           "seasonal_amplitudezisegred_small_297469"));
    ctx->seasonal_amplitudezisegred_small_297469_total_runtime = 0;
    ctx->seasonal_amplitudezisegred_small_297469_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->trend_magnitudezisegmap_297603,
                                           ctx->cuda.module,
                                           "trend_magnitudezisegmap_297603"));
    ctx->trend_magnitudezisegmap_297603_total_runtime = 0;
    ctx->trend_magnitudezisegmap_297603_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->trend_magnitudezisegmap_intragroup_318088,
                                           ctx->cuda.module,
                                           "trend_magnitudezisegmap_intragroup_318088"));
    ctx->trend_magnitudezisegmap_intragroup_318088_total_runtime = 0;
    ctx->trend_magnitudezisegmap_intragroup_318088_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->trend_magnitudezisegred_large_297587,
                                           ctx->cuda.module,
                                           "trend_magnitudezisegred_large_297587"));
    ctx->trend_magnitudezisegred_large_297587_total_runtime = 0;
    ctx->trend_magnitudezisegred_large_297587_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->trend_magnitudezisegred_nonseg_297501,
                                           ctx->cuda.module,
                                           "trend_magnitudezisegred_nonseg_297501"));
    ctx->trend_magnitudezisegred_nonseg_297501_total_runtime = 0;
    ctx->trend_magnitudezisegred_nonseg_297501_runs = 0;
    CUDA_SUCCEED_FATAL(cuModuleGetFunction(&ctx->trend_magnitudezisegred_small_297587,
                                           ctx->cuda.module,
                                           "trend_magnitudezisegred_small_297587"));
    ctx->trend_magnitudezisegred_small_297587_total_runtime = 0;
    ctx->trend_magnitudezisegred_small_297587_runs = 0;
    ctx->copy_dev_to_dev_total_runtime = 0;
    ctx->copy_dev_to_dev_runs = 0;
    ctx->copy_dev_to_host_total_runtime = 0;
    ctx->copy_dev_to_host_runs = 0;
    ctx->copy_host_to_dev_total_runtime = 0;
    ctx->copy_host_to_dev_runs = 0;
    ctx->copy_scalar_to_dev_total_runtime = 0;
    ctx->copy_scalar_to_dev_runs = 0;
    ctx->copy_scalar_from_dev_total_runtime = 0;
    ctx->copy_scalar_from_dev_runs = 0;
    {
        ctx->mainziid_counter_mem_320829.references = NULL;
        ctx->mainziid_counter_mem_320829.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainziid_counter_mem_320829.mem,
                                      (1 > 0 ? 1 : 1) * sizeof(int32_t)));
        if (1 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainziid_counter_mem_320829.mem,
                                            mainziid_counter_mem_realtype_325882,
                                            1 * sizeof(int32_t)));
    }
    {
        ctx->mainziid_counter_mem_320981.references = NULL;
        ctx->mainziid_counter_mem_320981.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainziid_counter_mem_320981.mem,
                                      (1 > 0 ? 1 : 1) * sizeof(int32_t)));
        if (1 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainziid_counter_mem_320981.mem,
                                            mainziid_counter_mem_realtype_325915,
                                            1 * sizeof(int32_t)));
    }
    {
        ctx->mainziid_counter_mem_321204.references = NULL;
        ctx->mainziid_counter_mem_321204.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainziid_counter_mem_321204.mem,
                                      (1 > 0 ? 1 : 1) * sizeof(int32_t)));
        if (1 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainziid_counter_mem_321204.mem,
                                            mainziid_counter_mem_realtype_325963,
                                            1 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_321915.references = NULL;
        ctx->mainzicounter_mem_321915.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_321915.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_321915.mem,
                                            mainzicounter_mem_realtype_326287,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_322003.references = NULL;
        ctx->mainzicounter_mem_322003.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_322003.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_322003.mem,
                                            mainzicounter_mem_realtype_326324,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_322234.references = NULL;
        ctx->mainzicounter_mem_322234.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_322234.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_322234.mem,
                                            mainzicounter_mem_realtype_326416,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_322342.references = NULL;
        ctx->mainzicounter_mem_322342.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_322342.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_322342.mem,
                                            mainzicounter_mem_realtype_326470,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_322617.references = NULL;
        ctx->mainzicounter_mem_322617.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_322617.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_322617.mem,
                                            mainzicounter_mem_realtype_326586,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_322737.references = NULL;
        ctx->mainzicounter_mem_322737.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_322737.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_322737.mem,
                                            mainzicounter_mem_realtype_326654,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_322848.references = NULL;
        ctx->mainzicounter_mem_322848.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_322848.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_322848.mem,
                                            mainzicounter_mem_realtype_326704,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainziid_counter_mem_322885.references = NULL;
        ctx->mainziid_counter_mem_322885.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainziid_counter_mem_322885.mem,
                                      (1 > 0 ? 1 : 1) * sizeof(int32_t)));
        if (1 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainziid_counter_mem_322885.mem,
                                            mainziid_counter_mem_realtype_326716,
                                            1 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_323029.references = NULL;
        ctx->mainzicounter_mem_323029.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_323029.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_323029.mem,
                                            mainzicounter_mem_realtype_326741,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainziid_counter_mem_323066.references = NULL;
        ctx->mainziid_counter_mem_323066.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainziid_counter_mem_323066.mem,
                                      (1 > 0 ? 1 : 1) * sizeof(int32_t)));
        if (1 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainziid_counter_mem_323066.mem,
                                            mainziid_counter_mem_realtype_326753,
                                            1 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_323210.references = NULL;
        ctx->mainzicounter_mem_323210.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_323210.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_323210.mem,
                                            mainzicounter_mem_realtype_326778,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainziid_counter_mem_323247.references = NULL;
        ctx->mainziid_counter_mem_323247.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainziid_counter_mem_323247.mem,
                                      (1 > 0 ? 1 : 1) * sizeof(int32_t)));
        if (1 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainziid_counter_mem_323247.mem,
                                            mainziid_counter_mem_realtype_326790,
                                            1 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_323508.references = NULL;
        ctx->mainzicounter_mem_323508.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_323508.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_323508.mem,
                                            mainzicounter_mem_realtype_326906,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_323591.references = NULL;
        ctx->mainzicounter_mem_323591.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_323591.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_323591.mem,
                                            mainzicounter_mem_realtype_326936,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_323680.references = NULL;
        ctx->mainzicounter_mem_323680.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_323680.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_323680.mem,
                                            mainzicounter_mem_realtype_326967,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_323783.references = NULL;
        ctx->mainzicounter_mem_323783.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_323783.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_323783.mem,
                                            mainzicounter_mem_realtype_327014,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_323894.references = NULL;
        ctx->mainzicounter_mem_323894.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_323894.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_323894.mem,
                                            mainzicounter_mem_realtype_327057,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_324009.references = NULL;
        ctx->mainzicounter_mem_324009.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_324009.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_324009.mem,
                                            mainzicounter_mem_realtype_327118,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_324371.references = NULL;
        ctx->mainzicounter_mem_324371.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_324371.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_324371.mem,
                                            mainzicounter_mem_realtype_327369,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_324454.references = NULL;
        ctx->mainzicounter_mem_324454.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_324454.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_324454.mem,
                                            mainzicounter_mem_realtype_327403,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_324563.references = NULL;
        ctx->mainzicounter_mem_324563.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_324563.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_324563.mem,
                                            mainzicounter_mem_realtype_327452,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_324666.references = NULL;
        ctx->mainzicounter_mem_324666.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_324666.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_324666.mem,
                                            mainzicounter_mem_realtype_327503,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_324797.references = NULL;
        ctx->mainzicounter_mem_324797.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_324797.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_324797.mem,
                                            mainzicounter_mem_realtype_327564,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_324912.references = NULL;
        ctx->mainzicounter_mem_324912.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_324912.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_324912.mem,
                                            mainzicounter_mem_realtype_327629,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_325050.references = NULL;
        ctx->mainzicounter_mem_325050.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_325050.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_325050.mem,
                                            mainzicounter_mem_realtype_327702,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainziid_counter_mem_325173.references = NULL;
        ctx->mainziid_counter_mem_325173.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainziid_counter_mem_325173.mem,
                                      (1 > 0 ? 1 : 1) * sizeof(int32_t)));
        if (1 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainziid_counter_mem_325173.mem,
                                            mainziid_counter_mem_realtype_327739,
                                            1 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_325394.references = NULL;
        ctx->mainzicounter_mem_325394.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_325394.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_325394.mem,
                                            mainzicounter_mem_realtype_327781,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->mainziid_counter_mem_325455.references = NULL;
        ctx->mainziid_counter_mem_325455.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainziid_counter_mem_325455.mem,
                                      (1 > 0 ? 1 : 1) * sizeof(int32_t)));
        if (1 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainziid_counter_mem_325455.mem,
                                            mainziid_counter_mem_realtype_327816,
                                            1 * sizeof(int32_t)));
    }
    {
        ctx->mainzicounter_mem_325660.references = NULL;
        ctx->mainzicounter_mem_325660.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->mainzicounter_mem_325660.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->mainzicounter_mem_325660.mem,
                                            mainzicounter_mem_realtype_327864,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->seasonal_amplitudezicounter_mem_320877.references = NULL;
        ctx->seasonal_amplitudezicounter_mem_320877.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->seasonal_amplitudezicounter_mem_320877.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->seasonal_amplitudezicounter_mem_320877.mem,
                                            seasonal_amplitudezicounter_mem_realtype_327933,
                                            10240 * sizeof(int32_t)));
    }
    {
        ctx->trend_magnitudezicounter_mem_320825.references = NULL;
        ctx->trend_magnitudezicounter_mem_320825.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->trend_magnitudezicounter_mem_320825.mem,
                                      (10 > 0 ? 10 : 1) * sizeof(int32_t)));
        if (10 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->trend_magnitudezicounter_mem_320825.mem,
                                            trend_magnitudezicounter_mem_realtype_327956,
                                            10 * sizeof(int32_t)));
    }
    {
        ctx->trend_magnitudezicounter_mem_320918.references = NULL;
        ctx->trend_magnitudezicounter_mem_320918.size = 0;
        CUDA_SUCCEED_FATAL(cuMemAlloc(&ctx->trend_magnitudezicounter_mem_320918.mem,
                                      (10240 > 0 ? 10240 : 1) *
                                      sizeof(int32_t)));
        if (10240 > 0)
            CUDA_SUCCEED_FATAL(cuMemcpyHtoD(ctx->trend_magnitudezicounter_mem_320918.mem,
                                            trend_magnitudezicounter_mem_realtype_327990,
                                            10240 * sizeof(int32_t)));
    }
    ctx->tuning_params.builtinzhreplicate_f32zigroup_sizze_325749 =
        &cfg->tuning_params[0];
    ctx->tuning_params.builtinzhreplicate_f64zigroup_sizze_321589 =
        &cfg->tuning_params[1];
    ctx->tuning_params.builtinzhreplicate_i32zigroup_sizze_325106 =
        &cfg->tuning_params[2];
    ctx->tuning_params.builtinzhreplicate_i64zigroup_sizze_321089 =
        &cfg->tuning_params[3];
    ctx->tuning_params.builtinzhreplicate_i8zigroup_sizze_320844 =
        &cfg->tuning_params[4];
    ctx->tuning_params.mainziL2_sizze_325336 = &cfg->tuning_params[5];
    ctx->tuning_params.mainzigroup_sizze_321107 = &cfg->tuning_params[6];
    ctx->tuning_params.mainzigroup_sizze_321324 = &cfg->tuning_params[7];
    ctx->tuning_params.mainziseghist_group_sizze_316938 =
        &cfg->tuning_params[8];
    ctx->tuning_params.mainziseghist_num_groups_316940 = &cfg->tuning_params[9];
    ctx->tuning_params.mainzisegmap_group_sizze_297619 =
        &cfg->tuning_params[10];
    ctx->tuning_params.mainzisegmap_group_sizze_297673 =
        &cfg->tuning_params[11];
    ctx->tuning_params.mainzisegmap_group_sizze_297830 =
        &cfg->tuning_params[12];
    ctx->tuning_params.mainzisegmap_group_sizze_298102 =
        &cfg->tuning_params[13];
    ctx->tuning_params.mainzisegmap_group_sizze_298957 =
        &cfg->tuning_params[14];
    ctx->tuning_params.mainzisegmap_group_sizze_299196 =
        &cfg->tuning_params[15];
    ctx->tuning_params.mainzisegmap_group_sizze_299227 =
        &cfg->tuning_params[16];
    ctx->tuning_params.mainzisegmap_group_sizze_299959 =
        &cfg->tuning_params[17];
    ctx->tuning_params.mainzisegmap_group_sizze_300163 =
        &cfg->tuning_params[18];
    ctx->tuning_params.mainzisegmap_group_sizze_300189 =
        &cfg->tuning_params[19];
    ctx->tuning_params.mainzisegmap_group_sizze_300585 =
        &cfg->tuning_params[20];
    ctx->tuning_params.mainzisegmap_group_sizze_300789 =
        &cfg->tuning_params[21];
    ctx->tuning_params.mainzisegmap_group_sizze_300815 =
        &cfg->tuning_params[22];
    ctx->tuning_params.mainzisegmap_group_sizze_300988 =
        &cfg->tuning_params[23];
    ctx->tuning_params.mainzisegmap_group_sizze_301054 =
        &cfg->tuning_params[24];
    ctx->tuning_params.mainzisegmap_group_sizze_301208 =
        &cfg->tuning_params[25];
    ctx->tuning_params.mainzisegmap_group_sizze_301513 =
        &cfg->tuning_params[26];
    ctx->tuning_params.mainzisegmap_group_sizze_301914 =
        &cfg->tuning_params[27];
    ctx->tuning_params.mainzisegmap_group_sizze_303532 =
        &cfg->tuning_params[28];
    ctx->tuning_params.mainzisegmap_group_sizze_303958 =
        &cfg->tuning_params[29];
    ctx->tuning_params.mainzisegmap_group_sizze_304045 =
        &cfg->tuning_params[30];
    ctx->tuning_params.mainzisegmap_group_sizze_304773 =
        &cfg->tuning_params[31];
    ctx->tuning_params.mainzisegmap_group_sizze_305331 =
        &cfg->tuning_params[32];
    ctx->tuning_params.mainzisegmap_group_sizze_305437 =
        &cfg->tuning_params[33];
    ctx->tuning_params.mainzisegmap_group_sizze_306361 =
        &cfg->tuning_params[34];
    ctx->tuning_params.mainzisegmap_group_sizze_307056 =
        &cfg->tuning_params[35];
    ctx->tuning_params.mainzisegmap_group_sizze_307191 =
        &cfg->tuning_params[36];
    ctx->tuning_params.mainzisegmap_group_sizze_308343 =
        &cfg->tuning_params[37];
    ctx->tuning_params.mainzisegmap_group_sizze_308739 =
        &cfg->tuning_params[38];
    ctx->tuning_params.mainzisegmap_group_sizze_308810 =
        &cfg->tuning_params[39];
    ctx->tuning_params.mainzisegmap_group_sizze_308941 =
        &cfg->tuning_params[40];
    ctx->tuning_params.mainzisegmap_group_sizze_309072 =
        &cfg->tuning_params[41];
    ctx->tuning_params.mainzisegmap_group_sizze_309203 =
        &cfg->tuning_params[42];
    ctx->tuning_params.mainzisegmap_group_sizze_309354 =
        &cfg->tuning_params[43];
    ctx->tuning_params.mainzisegmap_group_sizze_309568 =
        &cfg->tuning_params[44];
    ctx->tuning_params.mainzisegmap_group_sizze_310562 =
        &cfg->tuning_params[45];
    ctx->tuning_params.mainzisegmap_group_sizze_310946 =
        &cfg->tuning_params[46];
    ctx->tuning_params.mainzisegmap_group_sizze_311443 =
        &cfg->tuning_params[47];
    ctx->tuning_params.mainzisegmap_group_sizze_311956 =
        &cfg->tuning_params[48];
    ctx->tuning_params.mainzisegmap_group_sizze_312143 =
        &cfg->tuning_params[49];
    ctx->tuning_params.mainzisegmap_group_sizze_312186 =
        &cfg->tuning_params[50];
    ctx->tuning_params.mainzisegmap_group_sizze_312283 =
        &cfg->tuning_params[51];
    ctx->tuning_params.mainzisegmap_group_sizze_312339 =
        &cfg->tuning_params[52];
    ctx->tuning_params.mainzisegmap_group_sizze_312486 =
        &cfg->tuning_params[53];
    ctx->tuning_params.mainzisegmap_group_sizze_312614 =
        &cfg->tuning_params[54];
    ctx->tuning_params.mainzisegmap_group_sizze_312670 =
        &cfg->tuning_params[55];
    ctx->tuning_params.mainzisegmap_group_sizze_312849 =
        &cfg->tuning_params[56];
    ctx->tuning_params.mainzisegmap_group_sizze_313011 =
        &cfg->tuning_params[57];
    ctx->tuning_params.mainzisegmap_group_sizze_313067 =
        &cfg->tuning_params[58];
    ctx->tuning_params.mainzisegmap_group_sizze_313369 =
        &cfg->tuning_params[59];
    ctx->tuning_params.mainzisegmap_group_sizze_313425 =
        &cfg->tuning_params[60];
    ctx->tuning_params.mainzisegmap_group_sizze_313688 =
        &cfg->tuning_params[61];
    ctx->tuning_params.mainzisegmap_group_sizze_313744 =
        &cfg->tuning_params[62];
    ctx->tuning_params.mainzisegmap_group_sizze_314103 =
        &cfg->tuning_params[63];
    ctx->tuning_params.mainzisegmap_group_sizze_314159 =
        &cfg->tuning_params[64];
    ctx->tuning_params.mainzisegmap_group_sizze_314443 =
        &cfg->tuning_params[65];
    ctx->tuning_params.mainzisegmap_group_sizze_314643 =
        &cfg->tuning_params[66];
    ctx->tuning_params.mainzisegmap_group_sizze_314699 =
        &cfg->tuning_params[67];
    ctx->tuning_params.mainzisegmap_group_sizze_314985 =
        &cfg->tuning_params[68];
    ctx->tuning_params.mainzisegmap_group_sizze_315242 =
        &cfg->tuning_params[69];
    ctx->tuning_params.mainzisegmap_group_sizze_315298 =
        &cfg->tuning_params[70];
    ctx->tuning_params.mainzisegmap_group_sizze_315640 =
        &cfg->tuning_params[71];
    ctx->tuning_params.mainzisegmap_group_sizze_315968 =
        &cfg->tuning_params[72];
    ctx->tuning_params.mainzisegmap_group_sizze_316024 =
        &cfg->tuning_params[73];
    ctx->tuning_params.mainzisegmap_group_sizze_316306 =
        &cfg->tuning_params[74];
    ctx->tuning_params.mainzisegmap_group_sizze_316564 =
        &cfg->tuning_params[75];
    ctx->tuning_params.mainzisegmap_group_sizze_316607 =
        &cfg->tuning_params[76];
    ctx->tuning_params.mainzisegmap_group_sizze_316689 =
        &cfg->tuning_params[77];
    ctx->tuning_params.mainzisegmap_group_sizze_316729 =
        &cfg->tuning_params[78];
    ctx->tuning_params.mainzisegmap_group_sizze_316803 =
        &cfg->tuning_params[79];
    ctx->tuning_params.mainzisegmap_group_sizze_316824 =
        &cfg->tuning_params[80];
    ctx->tuning_params.mainzisegmap_group_sizze_316864 =
        &cfg->tuning_params[81];
    ctx->tuning_params.mainzisegmap_group_sizze_316890 =
        &cfg->tuning_params[82];
    ctx->tuning_params.mainzisegmap_group_sizze_316970 =
        &cfg->tuning_params[83];
    ctx->tuning_params.mainzisegmap_group_sizze_317054 =
        &cfg->tuning_params[84];
    ctx->tuning_params.mainzisegmap_group_sizze_317060 =
        &cfg->tuning_params[85];
    ctx->tuning_params.mainzisegmap_group_sizze_317120 =
        &cfg->tuning_params[86];
    ctx->tuning_params.mainzisegmap_group_sizze_317128 =
        &cfg->tuning_params[87];
    ctx->tuning_params.mainzisegmap_group_sizze_317254 =
        &cfg->tuning_params[88];
    ctx->tuning_params.mainzisegmap_group_sizze_317416 =
        &cfg->tuning_params[89];
    ctx->tuning_params.mainzisegmap_group_sizze_317506 =
        &cfg->tuning_params[90];
    ctx->tuning_params.mainzisegmap_num_groups_297621 = &cfg->tuning_params[91];
    ctx->tuning_params.mainzisegmap_num_groups_303534 = &cfg->tuning_params[92];
    ctx->tuning_params.mainzisegmap_num_groups_304775 = &cfg->tuning_params[93];
    ctx->tuning_params.mainzisegmap_num_groups_306363 = &cfg->tuning_params[94];
    ctx->tuning_params.mainzisegmap_num_groups_317508 = &cfg->tuning_params[95];
    ctx->tuning_params.mainzisegred_group_sizze_303886 =
        &cfg->tuning_params[96];
    ctx->tuning_params.mainzisegred_group_sizze_303989 =
        &cfg->tuning_params[97];
    ctx->tuning_params.mainzisegred_group_sizze_305237 =
        &cfg->tuning_params[98];
    ctx->tuning_params.mainzisegred_group_sizze_305373 =
        &cfg->tuning_params[99];
    ctx->tuning_params.mainzisegred_group_sizze_306945 =
        &cfg->tuning_params[100];
    ctx->tuning_params.mainzisegred_group_sizze_307119 =
        &cfg->tuning_params[101];
    ctx->tuning_params.mainzisegred_group_sizze_308836 =
        &cfg->tuning_params[102];
    ctx->tuning_params.mainzisegred_group_sizze_308967 =
        &cfg->tuning_params[103];
    ctx->tuning_params.mainzisegred_group_sizze_309098 =
        &cfg->tuning_params[104];
    ctx->tuning_params.mainzisegred_group_sizze_310508 =
        &cfg->tuning_params[105];
    ctx->tuning_params.mainzisegred_group_sizze_310576 =
        &cfg->tuning_params[106];
    ctx->tuning_params.mainzisegred_group_sizze_310874 =
        &cfg->tuning_params[107];
    ctx->tuning_params.mainzisegred_group_sizze_310971 =
        &cfg->tuning_params[108];
    ctx->tuning_params.mainzisegred_group_sizze_311358 =
        &cfg->tuning_params[109];
    ctx->tuning_params.mainzisegred_group_sizze_311489 =
        &cfg->tuning_params[110];
    ctx->tuning_params.mainzisegred_group_sizze_314386 =
        &cfg->tuning_params[111];
    ctx->tuning_params.mainzisegred_group_sizze_314457 =
        &cfg->tuning_params[112];
    ctx->tuning_params.mainzisegred_group_sizze_314910 =
        &cfg->tuning_params[113];
    ctx->tuning_params.mainzisegred_group_sizze_315010 =
        &cfg->tuning_params[114];
    ctx->tuning_params.mainzisegred_group_sizze_315552 =
        &cfg->tuning_params[115];
    ctx->tuning_params.mainzisegred_group_sizze_315686 =
        &cfg->tuning_params[116];
    ctx->tuning_params.mainzisegred_group_sizze_316741 =
        &cfg->tuning_params[117];
    ctx->tuning_params.mainzisegred_group_sizze_317285 =
        &cfg->tuning_params[118];
    ctx->tuning_params.mainzisegred_num_groups_303888 =
        &cfg->tuning_params[119];
    ctx->tuning_params.mainzisegred_num_groups_303991 =
        &cfg->tuning_params[120];
    ctx->tuning_params.mainzisegred_num_groups_305239 =
        &cfg->tuning_params[121];
    ctx->tuning_params.mainzisegred_num_groups_305375 =
        &cfg->tuning_params[122];
    ctx->tuning_params.mainzisegred_num_groups_306947 =
        &cfg->tuning_params[123];
    ctx->tuning_params.mainzisegred_num_groups_307121 =
        &cfg->tuning_params[124];
    ctx->tuning_params.mainzisegred_num_groups_308838 =
        &cfg->tuning_params[125];
    ctx->tuning_params.mainzisegred_num_groups_308969 =
        &cfg->tuning_params[126];
    ctx->tuning_params.mainzisegred_num_groups_309100 =
        &cfg->tuning_params[127];
    ctx->tuning_params.mainzisegred_num_groups_310510 =
        &cfg->tuning_params[128];
    ctx->tuning_params.mainzisegred_num_groups_310578 =
        &cfg->tuning_params[129];
    ctx->tuning_params.mainzisegred_num_groups_310876 =
        &cfg->tuning_params[130];
    ctx->tuning_params.mainzisegred_num_groups_310973 =
        &cfg->tuning_params[131];
    ctx->tuning_params.mainzisegred_num_groups_311360 =
        &cfg->tuning_params[132];
    ctx->tuning_params.mainzisegred_num_groups_311491 =
        &cfg->tuning_params[133];
    ctx->tuning_params.mainzisegred_num_groups_314388 =
        &cfg->tuning_params[134];
    ctx->tuning_params.mainzisegred_num_groups_314459 =
        &cfg->tuning_params[135];
    ctx->tuning_params.mainzisegred_num_groups_314912 =
        &cfg->tuning_params[136];
    ctx->tuning_params.mainzisegred_num_groups_315012 =
        &cfg->tuning_params[137];
    ctx->tuning_params.mainzisegred_num_groups_315554 =
        &cfg->tuning_params[138];
    ctx->tuning_params.mainzisegred_num_groups_315688 =
        &cfg->tuning_params[139];
    ctx->tuning_params.mainzisegred_num_groups_316743 =
        &cfg->tuning_params[140];
    ctx->tuning_params.mainzisegred_num_groups_317287 =
        &cfg->tuning_params[141];
    ctx->tuning_params.mainzisegscan_group_sizze_297609 =
        &cfg->tuning_params[142];
    ctx->tuning_params.mainzisegscan_group_sizze_297729 =
        &cfg->tuning_params[143];
    ctx->tuning_params.mainzisegscan_group_sizze_298171 =
        &cfg->tuning_params[144];
    ctx->tuning_params.mainzisegscan_group_sizze_308869 =
        &cfg->tuning_params[145];
    ctx->tuning_params.mainzisegscan_group_sizze_309000 =
        &cfg->tuning_params[146];
    ctx->tuning_params.mainzisegscan_group_sizze_309131 =
        &cfg->tuning_params[147];
    ctx->tuning_params.mainzisegscan_group_sizze_316880 =
        &cfg->tuning_params[148];
    ctx->tuning_params.mainzisegscan_group_sizze_317110 =
        &cfg->tuning_params[149];
    ctx->tuning_params.mainzisegscan_num_groups_297611 =
        &cfg->tuning_params[150];
    ctx->tuning_params.mainzisegscan_num_groups_297731 =
        &cfg->tuning_params[151];
    ctx->tuning_params.mainzisegscan_num_groups_298173 =
        &cfg->tuning_params[152];
    ctx->tuning_params.mainzisegscan_num_groups_308871 =
        &cfg->tuning_params[153];
    ctx->tuning_params.mainzisegscan_num_groups_309002 =
        &cfg->tuning_params[154];
    ctx->tuning_params.mainzisegscan_num_groups_309133 =
        &cfg->tuning_params[155];
    ctx->tuning_params.mainzisegscan_num_groups_316882 =
        &cfg->tuning_params[156];
    ctx->tuning_params.mainzisegscan_num_groups_317112 =
        &cfg->tuning_params[157];
    ctx->tuning_params.mainzisuff_intra_par_0 = &cfg->tuning_params[158];
    ctx->tuning_params.mainzisuff_intra_par_1 = &cfg->tuning_params[159];
    ctx->tuning_params.mainzisuff_intra_par_10 = &cfg->tuning_params[160];
    ctx->tuning_params.mainzisuff_intra_par_12 = &cfg->tuning_params[161];
    ctx->tuning_params.mainzisuff_intra_par_16 = &cfg->tuning_params[162];
    ctx->tuning_params.mainzisuff_intra_par_2 = &cfg->tuning_params[163];
    ctx->tuning_params.mainzisuff_intra_par_3 = &cfg->tuning_params[164];
    ctx->tuning_params.mainzisuff_intra_par_4 = &cfg->tuning_params[165];
    ctx->tuning_params.mainzisuff_intra_par_5 = &cfg->tuning_params[166];
    ctx->tuning_params.mainzisuff_intra_par_6 = &cfg->tuning_params[167];
    ctx->tuning_params.mainzisuff_intra_par_8 = &cfg->tuning_params[168];
    ctx->tuning_params.mainzisuff_outer_par_11 = &cfg->tuning_params[169];
    ctx->tuning_params.mainzisuff_outer_par_13 = &cfg->tuning_params[170];
    ctx->tuning_params.mainzisuff_outer_par_14 = &cfg->tuning_params[171];
    ctx->tuning_params.mainzisuff_outer_par_15 = &cfg->tuning_params[172];
    ctx->tuning_params.mainzisuff_outer_par_17 = &cfg->tuning_params[173];
    ctx->tuning_params.mainzisuff_outer_par_18 = &cfg->tuning_params[174];
    ctx->tuning_params.mainzisuff_outer_par_7 = &cfg->tuning_params[175];
    ctx->tuning_params.mainzisuff_outer_par_9 = &cfg->tuning_params[176];
    ctx->tuning_params.seasonal_amplitudezisegmap_group_sizze_297387 =
        &cfg->tuning_params[177];
    ctx->tuning_params.seasonal_amplitudezisegmap_group_sizze_297429 =
        &cfg->tuning_params[178];
    ctx->tuning_params.seasonal_amplitudezisegred_group_sizze_297442 =
        &cfg->tuning_params[179];
    ctx->tuning_params.seasonal_amplitudezisegred_num_groups_297444 =
        &cfg->tuning_params[180];
    ctx->tuning_params.seasonal_amplitudezisuff_outer_par_0 =
        &cfg->tuning_params[181];
    ctx->tuning_params.trend_magnitudezisegmap_group_sizze_297507 =
        &cfg->tuning_params[182];
    ctx->tuning_params.trend_magnitudezisegmap_group_sizze_297548 =
        &cfg->tuning_params[183];
    ctx->tuning_params.trend_magnitudezisegred_group_sizze_297491 =
        &cfg->tuning_params[184];
    ctx->tuning_params.trend_magnitudezisegred_group_sizze_297559 =
        &cfg->tuning_params[185];
    ctx->tuning_params.trend_magnitudezisegred_num_groups_297493 =
        &cfg->tuning_params[186];
    ctx->tuning_params.trend_magnitudezisegred_num_groups_297561 =
        &cfg->tuning_params[187];
    ctx->tuning_params.trend_magnitudezisuff_outer_par_0 =
        &cfg->tuning_params[188];
    init_constants(ctx);
    // Clear the free list of any deallocations that occurred while initialising constants.
    CUDA_SUCCEED_FATAL(cuda_free_all(&ctx->cuda));
    futhark_context_sync(ctx);
    return ctx;
}
void futhark_context_free(struct futhark_context *ctx)
{
    free_constants(ctx);
    cuMemFree(ctx->global_failure);
    cuMemFree(ctx->global_failure_args);
    cuda_cleanup(&ctx->cuda);
    free_lock(&ctx->lock);
    ctx->cfg->in_use = 0;
    free(ctx);
}
int futhark_context_sync(struct futhark_context *ctx)
{
    CUDA_SUCCEED_OR_RETURN(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    CUDA_SUCCEED_OR_RETURN(cuCtxSynchronize());
    if (ctx->failure_is_an_option) {
        int32_t failure_idx;
        
        CUDA_SUCCEED_OR_RETURN(cuMemcpyDtoH(&failure_idx, ctx->global_failure,
                                            sizeof(int32_t)));
        ctx->failure_is_an_option = 0;
        if (failure_idx >= 0) {
            int32_t no_failure = -1;
            
            CUDA_SUCCEED_OR_RETURN(cuMemcpyHtoD(ctx->global_failure,
                                                &no_failure, sizeof(int32_t)));
            
            int64_t args[4 + 1];
            
            CUDA_SUCCEED_OR_RETURN(cuMemcpyDtoH(&args, ctx->global_failure_args,
                                                sizeof(args)));
            switch (failure_idx) {
                
              case 0:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  stl.fut:410:68-73\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:408:36-411:52\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:407:29-412:37\n   #9  stl.fut:406:22-413:28\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 1:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  stl.fut:122:39-46\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:117:20-123:36\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:115:12-124:20\n   #9  stl.fut:114:5-125:11\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 2:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 3:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 4:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 5:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:713:16-54\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 6:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:713:16-54\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 7:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 8:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 9:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 10:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:713:16-54\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 11:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:713:16-54\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 12:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 13:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 14:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 15:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:713:16-54\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 16:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:713:16-54\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 17:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:148:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:146:5-149:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 18:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:148:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:146:5-149:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 19:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:148:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:146:5-149:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 20:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:148:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:146:5-149:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 21:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:148:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:146:5-149:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 22:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:148:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:146:5-149:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 23:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:148:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:146:5-149:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 24:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:148:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:146:5-149:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 25:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:148:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:146:5-149:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 26:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:148:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:146:5-149:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 27:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:155:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:153:5-156:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 28:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:155:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:153:5-156:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 29:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:155:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:153:5-156:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 30:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:155:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:153:5-156:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 31:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:155:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:153:5-156:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 32:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:155:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:153:5-156:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 33:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:155:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:153:5-156:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 34:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:155:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:153:5-156:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 35:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:155:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:153:5-156:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 36:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:155:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:153:5-156:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 37:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  stl.fut:193:42-57\n   #1  stl.fut:188:28-194:44\n   #2  /prelude/soacs.fut:67:19-23\n   #3  /prelude/soacs.fut:67:3-37\n   #4  stl.fut:186:21-195:50\n   #5  /prelude/soacs.fut:75:22-28\n   #6  /prelude/soacs.fut:75:3-45\n   #7  stl.fut:184:13-196:57\n   #8  stl.fut:419:61-435:77\n   #9  stl.fut:463:3-479:36\n   #10 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 38:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  /prelude/array.fut:21:29-32\n   #1  loess.fut:754:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 39:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  /prelude/array.fut:26:29-34\n   #1  loess.fut:756:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 40:
                {
                    ctx->error =
                        msgprintf("division by zero\n-> #0  loess.fut:758:22-35\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:752:3-761:9\n   #5  stl.fut:222:31-96\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:221:23-223:48\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:220:15-224:44\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n");
                    break;
                }
                
              case 41:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:731:27-33\n   #1  loess.fut:760:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 42:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:732:27-37\n   #1  loess.fut:760:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 43:
                {
                    ctx->error =
                        msgprintf("Index [%lld, %lld] out of bounds for array of shape [%lld][%lld].\n-> #0  stl.fut:228:39-67\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:228:28-74\n   #5  stl.fut:227:21-229:39\n   #6  stl.fut:419:61-435:77\n   #7  stl.fut:463:3-479:36\n   #8  stl.fut:445:1-479:36\n",
                                  args[0], args[1], args[2], args[3]);
                    break;
                }
                
              case 44:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  stl.fut:40:3-36\n   #9  stl.fut:233:23-47\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 45:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  stl.fut:40:3-36\n   #9  stl.fut:233:23-47\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 46:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-64\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 47:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-64\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 48:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-84\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 49:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-84\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 50:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:731:27-33\n   #1  loess.fut:744:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:741:3-745:9\n   #6  stl.fut:256:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:254:15-257:43\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 51:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:732:27-37\n   #1  loess.fut:744:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:741:3-745:9\n   #6  stl.fut:256:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:254:15-257:43\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 52:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 53:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 54:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 55:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 56:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 57:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 58:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 59:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 60:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 61:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 62:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 63:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 64:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 65:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 66:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 67:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 68:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 69:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 70:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:731:27-33\n   #1  loess.fut:744:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:741:3-745:9\n   #6  stl.fut:310:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:309:15-311:43\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 71:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  loess.fut:732:27-37\n   #1  loess.fut:744:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:741:3-745:9\n   #6  stl.fut:310:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:309:15-311:43\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 72:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:340:21-49\n   #3  /prelude/soacs.fut:67:19-23\n   #4  /prelude/soacs.fut:67:3-37\n   #5  stl.fut:338:13-341:35\n   #6  stl.fut:419:61-435:77\n   #7  stl.fut:463:3-479:36\n   #8  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 73:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:340:21-49\n   #3  /prelude/soacs.fut:67:19-23\n   #4  /prelude/soacs.fut:67:3-37\n   #5  stl.fut:338:13-341:35\n   #6  stl.fut:419:61-435:77\n   #7  stl.fut:463:3-479:36\n   #8  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 74:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  median.fut:35:37-46\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  median.fut:9:27-38\n   #4  median.fut:30:13-36:15\n   #5  median.fut:112:18-67\n   #6  stl.fut:343:23-52\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 75:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  median.fut:43:34-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  median.fut:9:27-38\n   #4  median.fut:40:13-49:19\n   #5  median.fut:112:18-67\n   #6  stl.fut:343:23-52\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 76:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  median.fut:43:34-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  median.fut:9:27-38\n   #4  median.fut:40:13-49:19\n   #5  median.fut:112:18-67\n   #6  stl.fut:343:23-52\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 77:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  median.fut:57:35-46\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  median.fut:9:27-38\n   #4  median.fut:54:11-63:13\n   #5  median.fut:112:18-67\n   #6  stl.fut:343:23-52\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 78:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  median.fut:59:40-58\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  median.fut:9:27-38\n   #4  median.fut:54:11-63:13\n   #5  median.fut:112:18-67\n   #6  stl.fut:343:23-52\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
                
              case 79:
                {
                    ctx->error =
                        msgprintf("Index [%lld] out of bounds for array of shape [%lld].\n-> #0  median.fut:80:23-36\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  median.fut:84:21-39\n   #4  median.fut:112:18-67\n   #5  stl.fut:343:23-52\n   #6  stl.fut:419:61-435:77\n   #7  stl.fut:463:3-479:36\n   #8  stl.fut:445:1-479:36\n",
                                  args[0], args[1]);
                    break;
                }
            }
            return FUTHARK_PROGRAM_ERROR;
        }
    }
    CUDA_SUCCEED_OR_RETURN(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    return 0;
}
static int memblock_unref_device(struct futhark_context *ctx,
                                 struct memblock_device *block, const
                                 char *desc)
{
    if (block->references != NULL) {
        *block->references -= 1;
        if (ctx->detail_memory)
            fprintf(ctx->log,
                    "Unreferencing block %s (allocated as %s) in %s: %d references remaining.\n",
                    desc, block->desc, "space 'device'", *block->references);
        if (*block->references == 0) {
            ctx->cur_mem_usage_device -= block->size;
            CUDA_SUCCEED_OR_RETURN(cuda_free(&ctx->cuda, block->mem, desc));
            free(block->references);
            if (ctx->detail_memory)
                fprintf(ctx->log,
                        "%lld bytes freed (now allocated: %lld bytes)\n",
                        (long long) block->size,
                        (long long) ctx->cur_mem_usage_device);
        }
        block->references = NULL;
    }
    return 0;
}
static int memblock_alloc_device(struct futhark_context *ctx,
                                 struct memblock_device *block, int64_t size,
                                 const char *desc)
{
    if (size < 0)
        futhark_panic(1,
                      "Negative allocation of %lld bytes attempted for %s in %s.\n",
                      (long long) size, desc, "space 'device'",
                      ctx->cur_mem_usage_device);
    
    int ret = memblock_unref_device(ctx, block, desc);
    
    if (ret != FUTHARK_SUCCESS)
        return ret;
    if (ctx->detail_memory)
        fprintf(ctx->log,
                "Allocating %lld bytes for %s in %s (then allocated: %lld bytes)",
                (long long) size, desc, "space 'device'",
                (long long) ctx->cur_mem_usage_device + size);
    if (ctx->cur_mem_usage_device > ctx->peak_mem_usage_device) {
        ctx->peak_mem_usage_device = ctx->cur_mem_usage_device;
        if (ctx->detail_memory)
            fprintf(ctx->log, " (new peak).\n");
    } else if (ctx->detail_memory)
        fprintf(ctx->log, ".\n");
    ctx->error = CUDA_SUCCEED_NONFATAL(cuda_alloc(&ctx->cuda, (size_t) size,
                                                  desc, &block->mem));
    if (ctx->error == NULL) {
        block->references = (int *) malloc(sizeof(int));
        *block->references = 1;
        block->size = size;
        block->desc = desc;
        ctx->cur_mem_usage_device += size;
        return FUTHARK_SUCCESS;
    } else {
        char *old_error = ctx->error;
        
        ctx->error =
            msgprintf("Failed to allocate memory in %s.\nAttempted allocation: %12lld bytes\nCurrently allocated:  %12lld bytes\n%s",
                      "space 'device'", (long long) size,
                      (long long) ctx->cur_mem_usage_device, old_error);
        free(old_error);
        return FUTHARK_OUT_OF_MEMORY;
    }
}
static int memblock_set_device(struct futhark_context *ctx,
                               struct memblock_device *lhs,
                               struct memblock_device *rhs, const
                               char *lhs_desc)
{
    int ret = memblock_unref_device(ctx, lhs, lhs_desc);
    
    if (rhs->references != NULL)
        (*rhs->references)++;
    *lhs = *rhs;
    return ret;
}
static int memblock_unref(struct futhark_context *ctx, struct memblock *block,
                          const char *desc)
{
    if (block->references != NULL) {
        *block->references -= 1;
        if (ctx->detail_memory)
            fprintf(ctx->log,
                    "Unreferencing block %s (allocated as %s) in %s: %d references remaining.\n",
                    desc, block->desc, "default space", *block->references);
        if (*block->references == 0) {
            ctx->cur_mem_usage_default -= block->size;
            free(block->mem);
            free(block->references);
            if (ctx->detail_memory)
                fprintf(ctx->log,
                        "%lld bytes freed (now allocated: %lld bytes)\n",
                        (long long) block->size,
                        (long long) ctx->cur_mem_usage_default);
        }
        block->references = NULL;
    }
    return 0;
}
static int memblock_alloc(struct futhark_context *ctx, struct memblock *block,
                          int64_t size, const char *desc)
{
    if (size < 0)
        futhark_panic(1,
                      "Negative allocation of %lld bytes attempted for %s in %s.\n",
                      (long long) size, desc, "default space",
                      ctx->cur_mem_usage_default);
    
    int ret = memblock_unref(ctx, block, desc);
    
    if (ret != FUTHARK_SUCCESS)
        return ret;
    if (ctx->detail_memory)
        fprintf(ctx->log,
                "Allocating %lld bytes for %s in %s (then allocated: %lld bytes)",
                (long long) size, desc, "default space",
                (long long) ctx->cur_mem_usage_default + size);
    if (ctx->cur_mem_usage_default > ctx->peak_mem_usage_default) {
        ctx->peak_mem_usage_default = ctx->cur_mem_usage_default;
        if (ctx->detail_memory)
            fprintf(ctx->log, " (new peak).\n");
    } else if (ctx->detail_memory)
        fprintf(ctx->log, ".\n");
    block->mem = (unsigned char *) malloc((size_t) size);
    if (ctx->error == NULL) {
        block->references = (int *) malloc(sizeof(int));
        *block->references = 1;
        block->size = size;
        block->desc = desc;
        ctx->cur_mem_usage_default += size;
        return FUTHARK_SUCCESS;
    } else {
        char *old_error = ctx->error;
        
        ctx->error =
            msgprintf("Failed to allocate memory in %s.\nAttempted allocation: %12lld bytes\nCurrently allocated:  %12lld bytes\n%s",
                      "default space", (long long) size,
                      (long long) ctx->cur_mem_usage_default, old_error);
        free(old_error);
        return FUTHARK_OUT_OF_MEMORY;
    }
}
static int memblock_set(struct futhark_context *ctx, struct memblock *lhs,
                        struct memblock *rhs, const char *lhs_desc)
{
    int ret = memblock_unref(ctx, lhs, lhs_desc);
    
    if (rhs->references != NULL)
        (*rhs->references)++;
    *lhs = *rhs;
    return ret;
}
int futhark_get_tuning_param_count(void)
{
    return sizeof(tuning_param_names) / sizeof(tuning_param_names[0]);
}
const char *futhark_get_tuning_param_name(int i)
{
    return tuning_param_names[i];
}
const char *futhark_get_tuning_param_class(int i)
{
    return tuning_param_classes[i];
}
char *futhark_context_report(struct futhark_context *ctx)
{
    if (futhark_context_sync(ctx) != 0)
        return NULL;
    
    struct str_builder builder;
    
    str_builder_init(&builder);
    if (ctx->detail_memory || ctx->profiling || ctx->logging) {
        str_builder(&builder,
                    "Peak memory usage for space 'device': %lld bytes.\n",
                    (long long) ctx->peak_mem_usage_device);
        { }
    }
    if (ctx->profiling) {
        CUDA_SUCCEED_FATAL(cuda_tally_profiling_records(&ctx->cuda));
        str_builder(&builder,
                    "copy_dev_to_dev                          ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->copy_dev_to_dev_runs,
                    (long) ctx->copy_dev_to_dev_total_runtime /
                    (ctx->copy_dev_to_dev_runs !=
                     0 ? ctx->copy_dev_to_dev_runs : 1),
                    (long) ctx->copy_dev_to_dev_total_runtime);
        ctx->total_runtime += ctx->copy_dev_to_dev_total_runtime;
        ctx->total_runs += ctx->copy_dev_to_dev_runs;
        str_builder(&builder,
                    "copy_dev_to_host                         ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->copy_dev_to_host_runs,
                    (long) ctx->copy_dev_to_host_total_runtime /
                    (ctx->copy_dev_to_host_runs !=
                     0 ? ctx->copy_dev_to_host_runs : 1),
                    (long) ctx->copy_dev_to_host_total_runtime);
        ctx->total_runtime += ctx->copy_dev_to_host_total_runtime;
        ctx->total_runs += ctx->copy_dev_to_host_runs;
        str_builder(&builder,
                    "copy_host_to_dev                         ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->copy_host_to_dev_runs,
                    (long) ctx->copy_host_to_dev_total_runtime /
                    (ctx->copy_host_to_dev_runs !=
                     0 ? ctx->copy_host_to_dev_runs : 1),
                    (long) ctx->copy_host_to_dev_total_runtime);
        ctx->total_runtime += ctx->copy_host_to_dev_total_runtime;
        ctx->total_runs += ctx->copy_host_to_dev_runs;
        str_builder(&builder,
                    "copy_scalar_to_dev                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->copy_scalar_to_dev_runs,
                    (long) ctx->copy_scalar_to_dev_total_runtime /
                    (ctx->copy_scalar_to_dev_runs !=
                     0 ? ctx->copy_scalar_to_dev_runs : 1),
                    (long) ctx->copy_scalar_to_dev_total_runtime);
        ctx->total_runtime += ctx->copy_scalar_to_dev_total_runtime;
        ctx->total_runs += ctx->copy_scalar_to_dev_runs;
        str_builder(&builder,
                    "copy_scalar_from_dev                     ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->copy_scalar_from_dev_runs,
                    (long) ctx->copy_scalar_from_dev_total_runtime /
                    (ctx->copy_scalar_from_dev_runs !=
                     0 ? ctx->copy_scalar_from_dev_runs : 1),
                    (long) ctx->copy_scalar_from_dev_total_runtime);
        ctx->total_runtime += ctx->copy_scalar_from_dev_total_runtime;
        ctx->total_runs += ctx->copy_scalar_from_dev_runs;
        str_builder(&builder,
                    "builtin#replicate_f32.replicate_325746   ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->builtinzhreplicate_f32zireplicate_325746_runs,
                    (long) ctx->builtinzhreplicate_f32zireplicate_325746_total_runtime /
                    (ctx->builtinzhreplicate_f32zireplicate_325746_runs !=
                     0 ? ctx->builtinzhreplicate_f32zireplicate_325746_runs : 1),
                    (long) ctx->builtinzhreplicate_f32zireplicate_325746_total_runtime);
        ctx->total_runtime +=
            ctx->builtinzhreplicate_f32zireplicate_325746_total_runtime;
        ctx->total_runs += ctx->builtinzhreplicate_f32zireplicate_325746_runs;
        str_builder(&builder,
                    "builtin#replicate_f64.replicate_321586   ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->builtinzhreplicate_f64zireplicate_321586_runs,
                    (long) ctx->builtinzhreplicate_f64zireplicate_321586_total_runtime /
                    (ctx->builtinzhreplicate_f64zireplicate_321586_runs !=
                     0 ? ctx->builtinzhreplicate_f64zireplicate_321586_runs : 1),
                    (long) ctx->builtinzhreplicate_f64zireplicate_321586_total_runtime);
        ctx->total_runtime +=
            ctx->builtinzhreplicate_f64zireplicate_321586_total_runtime;
        ctx->total_runs += ctx->builtinzhreplicate_f64zireplicate_321586_runs;
        str_builder(&builder,
                    "builtin#replicate_i32.replicate_325103   ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->builtinzhreplicate_i32zireplicate_325103_runs,
                    (long) ctx->builtinzhreplicate_i32zireplicate_325103_total_runtime /
                    (ctx->builtinzhreplicate_i32zireplicate_325103_runs !=
                     0 ? ctx->builtinzhreplicate_i32zireplicate_325103_runs : 1),
                    (long) ctx->builtinzhreplicate_i32zireplicate_325103_total_runtime);
        ctx->total_runtime +=
            ctx->builtinzhreplicate_i32zireplicate_325103_total_runtime;
        ctx->total_runs += ctx->builtinzhreplicate_i32zireplicate_325103_runs;
        str_builder(&builder,
                    "builtin#replicate_i64.replicate_321086   ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->builtinzhreplicate_i64zireplicate_321086_runs,
                    (long) ctx->builtinzhreplicate_i64zireplicate_321086_total_runtime /
                    (ctx->builtinzhreplicate_i64zireplicate_321086_runs !=
                     0 ? ctx->builtinzhreplicate_i64zireplicate_321086_runs : 1),
                    (long) ctx->builtinzhreplicate_i64zireplicate_321086_total_runtime);
        ctx->total_runtime +=
            ctx->builtinzhreplicate_i64zireplicate_321086_total_runtime;
        ctx->total_runs += ctx->builtinzhreplicate_i64zireplicate_321086_runs;
        str_builder(&builder,
                    "builtin#replicate_i8.replicate_320841    ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->builtinzhreplicate_i8zireplicate_320841_runs,
                    (long) ctx->builtinzhreplicate_i8zireplicate_320841_total_runtime /
                    (ctx->builtinzhreplicate_i8zireplicate_320841_runs !=
                     0 ? ctx->builtinzhreplicate_i8zireplicate_320841_runs : 1),
                    (long) ctx->builtinzhreplicate_i8zireplicate_320841_total_runtime);
        ctx->total_runtime +=
            ctx->builtinzhreplicate_i8zireplicate_320841_total_runtime;
        ctx->total_runs += ctx->builtinzhreplicate_i8zireplicate_320841_runs;
        str_builder(&builder,
                    "gpu_map_transpose_f32                    ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->gpu_map_transpose_f32_runs,
                    (long) ctx->gpu_map_transpose_f32_total_runtime /
                    (ctx->gpu_map_transpose_f32_runs !=
                     0 ? ctx->gpu_map_transpose_f32_runs : 1),
                    (long) ctx->gpu_map_transpose_f32_total_runtime);
        ctx->total_runtime += ctx->gpu_map_transpose_f32_total_runtime;
        ctx->total_runs += ctx->gpu_map_transpose_f32_runs;
        str_builder(&builder,
                    "gpu_map_transpose_f32_low_height         ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->gpu_map_transpose_f32_low_height_runs,
                    (long) ctx->gpu_map_transpose_f32_low_height_total_runtime /
                    (ctx->gpu_map_transpose_f32_low_height_runs !=
                     0 ? ctx->gpu_map_transpose_f32_low_height_runs : 1),
                    (long) ctx->gpu_map_transpose_f32_low_height_total_runtime);
        ctx->total_runtime +=
            ctx->gpu_map_transpose_f32_low_height_total_runtime;
        ctx->total_runs += ctx->gpu_map_transpose_f32_low_height_runs;
        str_builder(&builder,
                    "gpu_map_transpose_f32_low_width          ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->gpu_map_transpose_f32_low_width_runs,
                    (long) ctx->gpu_map_transpose_f32_low_width_total_runtime /
                    (ctx->gpu_map_transpose_f32_low_width_runs !=
                     0 ? ctx->gpu_map_transpose_f32_low_width_runs : 1),
                    (long) ctx->gpu_map_transpose_f32_low_width_total_runtime);
        ctx->total_runtime +=
            ctx->gpu_map_transpose_f32_low_width_total_runtime;
        ctx->total_runs += ctx->gpu_map_transpose_f32_low_width_runs;
        str_builder(&builder,
                    "gpu_map_transpose_f32_small              ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->gpu_map_transpose_f32_small_runs,
                    (long) ctx->gpu_map_transpose_f32_small_total_runtime /
                    (ctx->gpu_map_transpose_f32_small_runs !=
                     0 ? ctx->gpu_map_transpose_f32_small_runs : 1),
                    (long) ctx->gpu_map_transpose_f32_small_total_runtime);
        ctx->total_runtime += ctx->gpu_map_transpose_f32_small_total_runtime;
        ctx->total_runs += ctx->gpu_map_transpose_f32_small_runs;
        str_builder(&builder,
                    "gpu_map_transpose_f64                    ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->gpu_map_transpose_f64_runs,
                    (long) ctx->gpu_map_transpose_f64_total_runtime /
                    (ctx->gpu_map_transpose_f64_runs !=
                     0 ? ctx->gpu_map_transpose_f64_runs : 1),
                    (long) ctx->gpu_map_transpose_f64_total_runtime);
        ctx->total_runtime += ctx->gpu_map_transpose_f64_total_runtime;
        ctx->total_runs += ctx->gpu_map_transpose_f64_runs;
        str_builder(&builder,
                    "gpu_map_transpose_f64_low_height         ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->gpu_map_transpose_f64_low_height_runs,
                    (long) ctx->gpu_map_transpose_f64_low_height_total_runtime /
                    (ctx->gpu_map_transpose_f64_low_height_runs !=
                     0 ? ctx->gpu_map_transpose_f64_low_height_runs : 1),
                    (long) ctx->gpu_map_transpose_f64_low_height_total_runtime);
        ctx->total_runtime +=
            ctx->gpu_map_transpose_f64_low_height_total_runtime;
        ctx->total_runs += ctx->gpu_map_transpose_f64_low_height_runs;
        str_builder(&builder,
                    "gpu_map_transpose_f64_low_width          ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->gpu_map_transpose_f64_low_width_runs,
                    (long) ctx->gpu_map_transpose_f64_low_width_total_runtime /
                    (ctx->gpu_map_transpose_f64_low_width_runs !=
                     0 ? ctx->gpu_map_transpose_f64_low_width_runs : 1),
                    (long) ctx->gpu_map_transpose_f64_low_width_total_runtime);
        ctx->total_runtime +=
            ctx->gpu_map_transpose_f64_low_width_total_runtime;
        ctx->total_runs += ctx->gpu_map_transpose_f64_low_width_runs;
        str_builder(&builder,
                    "gpu_map_transpose_f64_small              ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->gpu_map_transpose_f64_small_runs,
                    (long) ctx->gpu_map_transpose_f64_small_total_runtime /
                    (ctx->gpu_map_transpose_f64_small_runs !=
                     0 ? ctx->gpu_map_transpose_f64_small_runs : 1),
                    (long) ctx->gpu_map_transpose_f64_small_total_runtime);
        ctx->total_runtime += ctx->gpu_map_transpose_f64_small_total_runtime;
        ctx->total_runs += ctx->gpu_map_transpose_f64_small_runs;
        str_builder(&builder,
                    "gpu_map_transpose_i64                    ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->gpu_map_transpose_i64_runs,
                    (long) ctx->gpu_map_transpose_i64_total_runtime /
                    (ctx->gpu_map_transpose_i64_runs !=
                     0 ? ctx->gpu_map_transpose_i64_runs : 1),
                    (long) ctx->gpu_map_transpose_i64_total_runtime);
        ctx->total_runtime += ctx->gpu_map_transpose_i64_total_runtime;
        ctx->total_runs += ctx->gpu_map_transpose_i64_runs;
        str_builder(&builder,
                    "gpu_map_transpose_i64_low_height         ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->gpu_map_transpose_i64_low_height_runs,
                    (long) ctx->gpu_map_transpose_i64_low_height_total_runtime /
                    (ctx->gpu_map_transpose_i64_low_height_runs !=
                     0 ? ctx->gpu_map_transpose_i64_low_height_runs : 1),
                    (long) ctx->gpu_map_transpose_i64_low_height_total_runtime);
        ctx->total_runtime +=
            ctx->gpu_map_transpose_i64_low_height_total_runtime;
        ctx->total_runs += ctx->gpu_map_transpose_i64_low_height_runs;
        str_builder(&builder,
                    "gpu_map_transpose_i64_low_width          ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->gpu_map_transpose_i64_low_width_runs,
                    (long) ctx->gpu_map_transpose_i64_low_width_total_runtime /
                    (ctx->gpu_map_transpose_i64_low_width_runs !=
                     0 ? ctx->gpu_map_transpose_i64_low_width_runs : 1),
                    (long) ctx->gpu_map_transpose_i64_low_width_total_runtime);
        ctx->total_runtime +=
            ctx->gpu_map_transpose_i64_low_width_total_runtime;
        ctx->total_runs += ctx->gpu_map_transpose_i64_low_width_runs;
        str_builder(&builder,
                    "gpu_map_transpose_i64_small              ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->gpu_map_transpose_i64_small_runs,
                    (long) ctx->gpu_map_transpose_i64_small_total_runtime /
                    (ctx->gpu_map_transpose_i64_small_runs !=
                     0 ? ctx->gpu_map_transpose_i64_small_runs : 1),
                    (long) ctx->gpu_map_transpose_i64_small_total_runtime);
        ctx->total_runtime += ctx->gpu_map_transpose_i64_small_total_runtime;
        ctx->total_runs += ctx->gpu_map_transpose_i64_small_runs;
        str_builder(&builder,
                    "main.copy_321104                         ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzicopy_321104_runs,
                    (long) ctx->mainzicopy_321104_total_runtime /
                    (ctx->mainzicopy_321104_runs !=
                     0 ? ctx->mainzicopy_321104_runs : 1),
                    (long) ctx->mainzicopy_321104_total_runtime);
        ctx->total_runtime += ctx->mainzicopy_321104_total_runtime;
        ctx->total_runs += ctx->mainzicopy_321104_runs;
        str_builder(&builder,
                    "main.copy_321321                         ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzicopy_321321_runs,
                    (long) ctx->mainzicopy_321321_total_runtime /
                    (ctx->mainzicopy_321321_runs !=
                     0 ? ctx->mainzicopy_321321_runs : 1),
                    (long) ctx->mainzicopy_321321_total_runtime);
        ctx->total_runtime += ctx->mainzicopy_321321_total_runtime;
        ctx->total_runs += ctx->mainzicopy_321321_runs;
        str_builder(&builder,
                    "main.seghist_global_316946               ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainziseghist_global_316946_runs,
                    (long) ctx->mainziseghist_global_316946_total_runtime /
                    (ctx->mainziseghist_global_316946_runs !=
                     0 ? ctx->mainziseghist_global_316946_runs : 1),
                    (long) ctx->mainziseghist_global_316946_total_runtime);
        ctx->total_runtime += ctx->mainziseghist_global_316946_total_runtime;
        ctx->total_runs += ctx->mainziseghist_global_316946_runs;
        str_builder(&builder,
                    "main.seghist_local_316946                ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainziseghist_local_316946_runs,
                    (long) ctx->mainziseghist_local_316946_total_runtime /
                    (ctx->mainziseghist_local_316946_runs !=
                     0 ? ctx->mainziseghist_local_316946_runs : 1),
                    (long) ctx->mainziseghist_local_316946_total_runtime);
        ctx->total_runtime += ctx->mainziseghist_local_316946_total_runtime;
        ctx->total_runs += ctx->mainziseghist_local_316946_runs;
        str_builder(&builder,
                    "main.segmap_297617                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_297617_runs,
                    (long) ctx->mainzisegmap_297617_total_runtime /
                    (ctx->mainzisegmap_297617_runs !=
                     0 ? ctx->mainzisegmap_297617_runs : 1),
                    (long) ctx->mainzisegmap_297617_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_297617_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_297617_runs;
        str_builder(&builder,
                    "main.segmap_297793                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_297793_runs,
                    (long) ctx->mainzisegmap_297793_total_runtime /
                    (ctx->mainzisegmap_297793_runs !=
                     0 ? ctx->mainzisegmap_297793_runs : 1),
                    (long) ctx->mainzisegmap_297793_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_297793_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_297793_runs;
        str_builder(&builder,
                    "main.segmap_297921                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_297921_runs,
                    (long) ctx->mainzisegmap_297921_total_runtime /
                    (ctx->mainzisegmap_297921_runs !=
                     0 ? ctx->mainzisegmap_297921_runs : 1),
                    (long) ctx->mainzisegmap_297921_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_297921_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_297921_runs;
        str_builder(&builder,
                    "main.segmap_298357                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_298357_runs,
                    (long) ctx->mainzisegmap_298357_total_runtime /
                    (ctx->mainzisegmap_298357_runs !=
                     0 ? ctx->mainzisegmap_298357_runs : 1),
                    (long) ctx->mainzisegmap_298357_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_298357_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_298357_runs;
        str_builder(&builder,
                    "main.segmap_299570                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_299570_runs,
                    (long) ctx->mainzisegmap_299570_total_runtime /
                    (ctx->mainzisegmap_299570_runs !=
                     0 ? ctx->mainzisegmap_299570_runs : 1),
                    (long) ctx->mainzisegmap_299570_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_299570_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_299570_runs;
        str_builder(&builder,
                    "main.segmap_299584                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_299584_runs,
                    (long) ctx->mainzisegmap_299584_total_runtime /
                    (ctx->mainzisegmap_299584_runs !=
                     0 ? ctx->mainzisegmap_299584_runs : 1),
                    (long) ctx->mainzisegmap_299584_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_299584_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_299584_runs;
        str_builder(&builder,
                    "main.segmap_299608                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_299608_runs,
                    (long) ctx->mainzisegmap_299608_total_runtime /
                    (ctx->mainzisegmap_299608_runs !=
                     0 ? ctx->mainzisegmap_299608_runs : 1),
                    (long) ctx->mainzisegmap_299608_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_299608_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_299608_runs;
        str_builder(&builder,
                    "main.segmap_300218                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_300218_runs,
                    (long) ctx->mainzisegmap_300218_total_runtime /
                    (ctx->mainzisegmap_300218_runs !=
                     0 ? ctx->mainzisegmap_300218_runs : 1),
                    (long) ctx->mainzisegmap_300218_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_300218_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_300218_runs;
        str_builder(&builder,
                    "main.segmap_300230                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_300230_runs,
                    (long) ctx->mainzisegmap_300230_total_runtime /
                    (ctx->mainzisegmap_300230_runs !=
                     0 ? ctx->mainzisegmap_300230_runs : 1),
                    (long) ctx->mainzisegmap_300230_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_300230_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_300230_runs;
        str_builder(&builder,
                    "main.segmap_300251                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_300251_runs,
                    (long) ctx->mainzisegmap_300251_total_runtime /
                    (ctx->mainzisegmap_300251_runs !=
                     0 ? ctx->mainzisegmap_300251_runs : 1),
                    (long) ctx->mainzisegmap_300251_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_300251_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_300251_runs;
        str_builder(&builder,
                    "main.segmap_300844                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_300844_runs,
                    (long) ctx->mainzisegmap_300844_total_runtime /
                    (ctx->mainzisegmap_300844_runs !=
                     0 ? ctx->mainzisegmap_300844_runs : 1),
                    (long) ctx->mainzisegmap_300844_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_300844_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_300844_runs;
        str_builder(&builder,
                    "main.segmap_300856                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_300856_runs,
                    (long) ctx->mainzisegmap_300856_total_runtime /
                    (ctx->mainzisegmap_300856_runs !=
                     0 ? ctx->mainzisegmap_300856_runs : 1),
                    (long) ctx->mainzisegmap_300856_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_300856_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_300856_runs;
        str_builder(&builder,
                    "main.segmap_300877                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_300877_runs,
                    (long) ctx->mainzisegmap_300877_total_runtime /
                    (ctx->mainzisegmap_300877_runs !=
                     0 ? ctx->mainzisegmap_300877_runs : 1),
                    (long) ctx->mainzisegmap_300877_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_300877_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_300877_runs;
        str_builder(&builder,
                    "main.segmap_301021                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_301021_runs,
                    (long) ctx->mainzisegmap_301021_total_runtime /
                    (ctx->mainzisegmap_301021_runs !=
                     0 ? ctx->mainzisegmap_301021_runs : 1),
                    (long) ctx->mainzisegmap_301021_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_301021_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_301021_runs;
        str_builder(&builder,
                    "main.segmap_301167                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_301167_runs,
                    (long) ctx->mainzisegmap_301167_total_runtime /
                    (ctx->mainzisegmap_301167_runs !=
                     0 ? ctx->mainzisegmap_301167_runs : 1),
                    (long) ctx->mainzisegmap_301167_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_301167_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_301167_runs;
        str_builder(&builder,
                    "main.segmap_301414                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_301414_runs,
                    (long) ctx->mainzisegmap_301414_total_runtime /
                    (ctx->mainzisegmap_301414_runs !=
                     0 ? ctx->mainzisegmap_301414_runs : 1),
                    (long) ctx->mainzisegmap_301414_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_301414_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_301414_runs;
        str_builder(&builder,
                    "main.segmap_301783                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_301783_runs,
                    (long) ctx->mainzisegmap_301783_total_runtime /
                    (ctx->mainzisegmap_301783_runs !=
                     0 ? ctx->mainzisegmap_301783_runs : 1),
                    (long) ctx->mainzisegmap_301783_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_301783_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_301783_runs;
        str_builder(&builder,
                    "main.segmap_302252                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_302252_runs,
                    (long) ctx->mainzisegmap_302252_total_runtime /
                    (ctx->mainzisegmap_302252_runs !=
                     0 ? ctx->mainzisegmap_302252_runs : 1),
                    (long) ctx->mainzisegmap_302252_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_302252_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_302252_runs;
        str_builder(&builder,
                    "main.segmap_304408                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_304408_runs,
                    (long) ctx->mainzisegmap_304408_total_runtime /
                    (ctx->mainzisegmap_304408_runs !=
                     0 ? ctx->mainzisegmap_304408_runs : 1),
                    (long) ctx->mainzisegmap_304408_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_304408_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_304408_runs;
        str_builder(&builder,
                    "main.segmap_304619                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_304619_runs,
                    (long) ctx->mainzisegmap_304619_total_runtime /
                    (ctx->mainzisegmap_304619_runs !=
                     0 ? ctx->mainzisegmap_304619_runs : 1),
                    (long) ctx->mainzisegmap_304619_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_304619_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_304619_runs;
        str_builder(&builder,
                    "main.segmap_304691                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_304691_runs,
                    (long) ctx->mainzisegmap_304691_total_runtime /
                    (ctx->mainzisegmap_304691_runs !=
                     0 ? ctx->mainzisegmap_304691_runs : 1),
                    (long) ctx->mainzisegmap_304691_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_304691_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_304691_runs;
        str_builder(&builder,
                    "main.segmap_305885                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_305885_runs,
                    (long) ctx->mainzisegmap_305885_total_runtime /
                    (ctx->mainzisegmap_305885_runs !=
                     0 ? ctx->mainzisegmap_305885_runs : 1),
                    (long) ctx->mainzisegmap_305885_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_305885_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_305885_runs;
        str_builder(&builder,
                    "main.segmap_306165                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_306165_runs,
                    (long) ctx->mainzisegmap_306165_total_runtime /
                    (ctx->mainzisegmap_306165_runs !=
                     0 ? ctx->mainzisegmap_306165_runs : 1),
                    (long) ctx->mainzisegmap_306165_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_306165_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_306165_runs;
        str_builder(&builder,
                    "main.segmap_306249                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_306249_runs,
                    (long) ctx->mainzisegmap_306249_total_runtime /
                    (ctx->mainzisegmap_306249_runs !=
                     0 ? ctx->mainzisegmap_306249_runs : 1),
                    (long) ctx->mainzisegmap_306249_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_306249_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_306249_runs;
        str_builder(&builder,
                    "main.segmap_307727                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_307727_runs,
                    (long) ctx->mainzisegmap_307727_total_runtime /
                    (ctx->mainzisegmap_307727_runs !=
                     0 ? ctx->mainzisegmap_307727_runs : 1),
                    (long) ctx->mainzisegmap_307727_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_307727_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_307727_runs;
        str_builder(&builder,
                    "main.segmap_308081                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_308081_runs,
                    (long) ctx->mainzisegmap_308081_total_runtime /
                    (ctx->mainzisegmap_308081_runs !=
                     0 ? ctx->mainzisegmap_308081_runs : 1),
                    (long) ctx->mainzisegmap_308081_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_308081_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_308081_runs;
        str_builder(&builder,
                    "main.segmap_308177                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_308177_runs,
                    (long) ctx->mainzisegmap_308177_total_runtime /
                    (ctx->mainzisegmap_308177_runs !=
                     0 ? ctx->mainzisegmap_308177_runs : 1),
                    (long) ctx->mainzisegmap_308177_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_308177_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_308177_runs;
        str_builder(&builder,
                    "main.segmap_308641                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_308641_runs,
                    (long) ctx->mainzisegmap_308641_total_runtime /
                    (ctx->mainzisegmap_308641_runs !=
                     0 ? ctx->mainzisegmap_308641_runs : 1),
                    (long) ctx->mainzisegmap_308641_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_308641_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_308641_runs;
        str_builder(&builder,
                    "main.segmap_308790                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_308790_runs,
                    (long) ctx->mainzisegmap_308790_total_runtime /
                    (ctx->mainzisegmap_308790_runs !=
                     0 ? ctx->mainzisegmap_308790_runs : 1),
                    (long) ctx->mainzisegmap_308790_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_308790_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_308790_runs;
        str_builder(&builder,
                    "main.segmap_308826                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_308826_runs,
                    (long) ctx->mainzisegmap_308826_total_runtime /
                    (ctx->mainzisegmap_308826_runs !=
                     0 ? ctx->mainzisegmap_308826_runs : 1),
                    (long) ctx->mainzisegmap_308826_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_308826_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_308826_runs;
        str_builder(&builder,
                    "main.segmap_308957                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_308957_runs,
                    (long) ctx->mainzisegmap_308957_total_runtime /
                    (ctx->mainzisegmap_308957_runs !=
                     0 ? ctx->mainzisegmap_308957_runs : 1),
                    (long) ctx->mainzisegmap_308957_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_308957_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_308957_runs;
        str_builder(&builder,
                    "main.segmap_309088                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_309088_runs,
                    (long) ctx->mainzisegmap_309088_total_runtime /
                    (ctx->mainzisegmap_309088_runs !=
                     0 ? ctx->mainzisegmap_309088_runs : 1),
                    (long) ctx->mainzisegmap_309088_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_309088_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_309088_runs;
        str_builder(&builder,
                    "main.segmap_309288                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_309288_runs,
                    (long) ctx->mainzisegmap_309288_total_runtime /
                    (ctx->mainzisegmap_309288_runs !=
                     0 ? ctx->mainzisegmap_309288_runs : 1),
                    (long) ctx->mainzisegmap_309288_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_309288_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_309288_runs;
        str_builder(&builder,
                    "main.segmap_309471                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_309471_runs,
                    (long) ctx->mainzisegmap_309471_total_runtime /
                    (ctx->mainzisegmap_309471_runs !=
                     0 ? ctx->mainzisegmap_309471_runs : 1),
                    (long) ctx->mainzisegmap_309471_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_309471_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_309471_runs;
        str_builder(&builder,
                    "main.segmap_309719                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_309719_runs,
                    (long) ctx->mainzisegmap_309719_total_runtime /
                    (ctx->mainzisegmap_309719_runs !=
                     0 ? ctx->mainzisegmap_309719_runs : 1),
                    (long) ctx->mainzisegmap_309719_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_309719_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_309719_runs;
        str_builder(&builder,
                    "main.segmap_310801                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_310801_runs,
                    (long) ctx->mainzisegmap_310801_total_runtime /
                    (ctx->mainzisegmap_310801_runs !=
                     0 ? ctx->mainzisegmap_310801_runs : 1),
                    (long) ctx->mainzisegmap_310801_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_310801_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_310801_runs;
        str_builder(&builder,
                    "main.segmap_311254                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_311254_runs,
                    (long) ctx->mainzisegmap_311254_total_runtime /
                    (ctx->mainzisegmap_311254_runs !=
                     0 ? ctx->mainzisegmap_311254_runs : 1),
                    (long) ctx->mainzisegmap_311254_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_311254_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_311254_runs;
        str_builder(&builder,
                    "main.segmap_311834                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_311834_runs,
                    (long) ctx->mainzisegmap_311834_total_runtime /
                    (ctx->mainzisegmap_311834_runs !=
                     0 ? ctx->mainzisegmap_311834_runs : 1),
                    (long) ctx->mainzisegmap_311834_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_311834_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_311834_runs;
        str_builder(&builder,
                    "main.segmap_312079                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_312079_runs,
                    (long) ctx->mainzisegmap_312079_total_runtime /
                    (ctx->mainzisegmap_312079_runs !=
                     0 ? ctx->mainzisegmap_312079_runs : 1),
                    (long) ctx->mainzisegmap_312079_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_312079_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_312079_runs;
        str_builder(&builder,
                    "main.segmap_312174                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_312174_runs,
                    (long) ctx->mainzisegmap_312174_total_runtime /
                    (ctx->mainzisegmap_312174_runs !=
                     0 ? ctx->mainzisegmap_312174_runs : 1),
                    (long) ctx->mainzisegmap_312174_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_312174_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_312174_runs;
        str_builder(&builder,
                    "main.segmap_312372                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_312372_runs,
                    (long) ctx->mainzisegmap_312372_total_runtime /
                    (ctx->mainzisegmap_312372_runs !=
                     0 ? ctx->mainzisegmap_312372_runs : 1),
                    (long) ctx->mainzisegmap_312372_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_312372_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_312372_runs;
        str_builder(&builder,
                    "main.segmap_312390                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_312390_runs,
                    (long) ctx->mainzisegmap_312390_total_runtime /
                    (ctx->mainzisegmap_312390_runs !=
                     0 ? ctx->mainzisegmap_312390_runs : 1),
                    (long) ctx->mainzisegmap_312390_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_312390_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_312390_runs;
        str_builder(&builder,
                    "main.segmap_312414                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_312414_runs,
                    (long) ctx->mainzisegmap_312414_total_runtime /
                    (ctx->mainzisegmap_312414_runs !=
                     0 ? ctx->mainzisegmap_312414_runs : 1),
                    (long) ctx->mainzisegmap_312414_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_312414_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_312414_runs;
        str_builder(&builder,
                    "main.segmap_312703                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_312703_runs,
                    (long) ctx->mainzisegmap_312703_total_runtime /
                    (ctx->mainzisegmap_312703_runs !=
                     0 ? ctx->mainzisegmap_312703_runs : 1),
                    (long) ctx->mainzisegmap_312703_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_312703_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_312703_runs;
        str_builder(&builder,
                    "main.segmap_312721                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_312721_runs,
                    (long) ctx->mainzisegmap_312721_total_runtime /
                    (ctx->mainzisegmap_312721_runs !=
                     0 ? ctx->mainzisegmap_312721_runs : 1),
                    (long) ctx->mainzisegmap_312721_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_312721_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_312721_runs;
        str_builder(&builder,
                    "main.segmap_312746                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_312746_runs,
                    (long) ctx->mainzisegmap_312746_total_runtime /
                    (ctx->mainzisegmap_312746_runs !=
                     0 ? ctx->mainzisegmap_312746_runs : 1),
                    (long) ctx->mainzisegmap_312746_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_312746_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_312746_runs;
        str_builder(&builder,
                    "main.segmap_313100                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_313100_runs,
                    (long) ctx->mainzisegmap_313100_total_runtime /
                    (ctx->mainzisegmap_313100_runs !=
                     0 ? ctx->mainzisegmap_313100_runs : 1),
                    (long) ctx->mainzisegmap_313100_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_313100_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_313100_runs;
        str_builder(&builder,
                    "main.segmap_313118                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_313118_runs,
                    (long) ctx->mainzisegmap_313118_total_runtime /
                    (ctx->mainzisegmap_313118_runs !=
                     0 ? ctx->mainzisegmap_313118_runs : 1),
                    (long) ctx->mainzisegmap_313118_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_313118_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_313118_runs;
        str_builder(&builder,
                    "main.segmap_313143                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_313143_runs,
                    (long) ctx->mainzisegmap_313143_total_runtime /
                    (ctx->mainzisegmap_313143_runs !=
                     0 ? ctx->mainzisegmap_313143_runs : 1),
                    (long) ctx->mainzisegmap_313143_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_313143_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_313143_runs;
        str_builder(&builder,
                    "main.segmap_313458                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_313458_runs,
                    (long) ctx->mainzisegmap_313458_total_runtime /
                    (ctx->mainzisegmap_313458_runs !=
                     0 ? ctx->mainzisegmap_313458_runs : 1),
                    (long) ctx->mainzisegmap_313458_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_313458_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_313458_runs;
        str_builder(&builder,
                    "main.segmap_313476                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_313476_runs,
                    (long) ctx->mainzisegmap_313476_total_runtime /
                    (ctx->mainzisegmap_313476_runs !=
                     0 ? ctx->mainzisegmap_313476_runs : 1),
                    (long) ctx->mainzisegmap_313476_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_313476_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_313476_runs;
        str_builder(&builder,
                    "main.segmap_313777                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_313777_runs,
                    (long) ctx->mainzisegmap_313777_total_runtime /
                    (ctx->mainzisegmap_313777_runs !=
                     0 ? ctx->mainzisegmap_313777_runs : 1),
                    (long) ctx->mainzisegmap_313777_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_313777_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_313777_runs;
        str_builder(&builder,
                    "main.segmap_313795                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_313795_runs,
                    (long) ctx->mainzisegmap_313795_total_runtime /
                    (ctx->mainzisegmap_313795_runs !=
                     0 ? ctx->mainzisegmap_313795_runs : 1),
                    (long) ctx->mainzisegmap_313795_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_313795_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_313795_runs;
        str_builder(&builder,
                    "main.segmap_314192                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_314192_runs,
                    (long) ctx->mainzisegmap_314192_total_runtime /
                    (ctx->mainzisegmap_314192_runs !=
                     0 ? ctx->mainzisegmap_314192_runs : 1),
                    (long) ctx->mainzisegmap_314192_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_314192_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_314192_runs;
        str_builder(&builder,
                    "main.segmap_314210                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_314210_runs,
                    (long) ctx->mainzisegmap_314210_total_runtime /
                    (ctx->mainzisegmap_314210_runs !=
                     0 ? ctx->mainzisegmap_314210_runs : 1),
                    (long) ctx->mainzisegmap_314210_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_314210_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_314210_runs;
        str_builder(&builder,
                    "main.segmap_314732                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_314732_runs,
                    (long) ctx->mainzisegmap_314732_total_runtime /
                    (ctx->mainzisegmap_314732_runs !=
                     0 ? ctx->mainzisegmap_314732_runs : 1),
                    (long) ctx->mainzisegmap_314732_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_314732_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_314732_runs;
        str_builder(&builder,
                    "main.segmap_314750                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_314750_runs,
                    (long) ctx->mainzisegmap_314750_total_runtime /
                    (ctx->mainzisegmap_314750_runs !=
                     0 ? ctx->mainzisegmap_314750_runs : 1),
                    (long) ctx->mainzisegmap_314750_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_314750_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_314750_runs;
        str_builder(&builder,
                    "main.segmap_314832                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_314832_runs,
                    (long) ctx->mainzisegmap_314832_total_runtime /
                    (ctx->mainzisegmap_314832_runs !=
                     0 ? ctx->mainzisegmap_314832_runs : 1),
                    (long) ctx->mainzisegmap_314832_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_314832_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_314832_runs;
        str_builder(&builder,
                    "main.segmap_315331                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_315331_runs,
                    (long) ctx->mainzisegmap_315331_total_runtime /
                    (ctx->mainzisegmap_315331_runs !=
                     0 ? ctx->mainzisegmap_315331_runs : 1),
                    (long) ctx->mainzisegmap_315331_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_315331_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_315331_runs;
        str_builder(&builder,
                    "main.segmap_315349                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_315349_runs,
                    (long) ctx->mainzisegmap_315349_total_runtime /
                    (ctx->mainzisegmap_315349_runs !=
                     0 ? ctx->mainzisegmap_315349_runs : 1),
                    (long) ctx->mainzisegmap_315349_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_315349_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_315349_runs;
        str_builder(&builder,
                    "main.segmap_315443                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_315443_runs,
                    (long) ctx->mainzisegmap_315443_total_runtime /
                    (ctx->mainzisegmap_315443_runs !=
                     0 ? ctx->mainzisegmap_315443_runs : 1),
                    (long) ctx->mainzisegmap_315443_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_315443_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_315443_runs;
        str_builder(&builder,
                    "main.segmap_316057                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_316057_runs,
                    (long) ctx->mainzisegmap_316057_total_runtime /
                    (ctx->mainzisegmap_316057_runs !=
                     0 ? ctx->mainzisegmap_316057_runs : 1),
                    (long) ctx->mainzisegmap_316057_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_316057_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_316057_runs;
        str_builder(&builder,
                    "main.segmap_316075                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_316075_runs,
                    (long) ctx->mainzisegmap_316075_total_runtime /
                    (ctx->mainzisegmap_316075_runs !=
                     0 ? ctx->mainzisegmap_316075_runs : 1),
                    (long) ctx->mainzisegmap_316075_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_316075_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_316075_runs;
        str_builder(&builder,
                    "main.segmap_316181                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_316181_runs,
                    (long) ctx->mainzisegmap_316181_total_runtime /
                    (ctx->mainzisegmap_316181_runs !=
                     0 ? ctx->mainzisegmap_316181_runs : 1),
                    (long) ctx->mainzisegmap_316181_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_316181_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_316181_runs;
        str_builder(&builder,
                    "main.segmap_316429                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_316429_runs,
                    (long) ctx->mainzisegmap_316429_total_runtime /
                    (ctx->mainzisegmap_316429_runs !=
                     0 ? ctx->mainzisegmap_316429_runs : 1),
                    (long) ctx->mainzisegmap_316429_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_316429_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_316429_runs;
        str_builder(&builder,
                    "main.segmap_316650                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_316650_runs,
                    (long) ctx->mainzisegmap_316650_total_runtime /
                    (ctx->mainzisegmap_316650_runs !=
                     0 ? ctx->mainzisegmap_316650_runs : 1),
                    (long) ctx->mainzisegmap_316650_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_316650_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_316650_runs;
        str_builder(&builder,
                    "main.segmap_316672                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_316672_runs,
                    (long) ctx->mainzisegmap_316672_total_runtime /
                    (ctx->mainzisegmap_316672_runs !=
                     0 ? ctx->mainzisegmap_316672_runs : 1),
                    (long) ctx->mainzisegmap_316672_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_316672_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_316672_runs;
        str_builder(&builder,
                    "main.segmap_316711                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_316711_runs,
                    (long) ctx->mainzisegmap_316711_total_runtime /
                    (ctx->mainzisegmap_316711_runs !=
                     0 ? ctx->mainzisegmap_316711_runs : 1),
                    (long) ctx->mainzisegmap_316711_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_316711_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_316711_runs;
        str_builder(&builder,
                    "main.segmap_316782                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_316782_runs,
                    (long) ctx->mainzisegmap_316782_total_runtime /
                    (ctx->mainzisegmap_316782_runs !=
                     0 ? ctx->mainzisegmap_316782_runs : 1),
                    (long) ctx->mainzisegmap_316782_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_316782_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_316782_runs;
        str_builder(&builder,
                    "main.segmap_316840                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_316840_runs,
                    (long) ctx->mainzisegmap_316840_total_runtime /
                    (ctx->mainzisegmap_316840_runs !=
                     0 ? ctx->mainzisegmap_316840_runs : 1),
                    (long) ctx->mainzisegmap_316840_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_316840_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_316840_runs;
        str_builder(&builder,
                    "main.segmap_316857                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_316857_runs,
                    (long) ctx->mainzisegmap_316857_total_runtime /
                    (ctx->mainzisegmap_316857_runs !=
                     0 ? ctx->mainzisegmap_316857_runs : 1),
                    (long) ctx->mainzisegmap_316857_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_316857_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_316857_runs;
        str_builder(&builder,
                    "main.segmap_316876                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_316876_runs,
                    (long) ctx->mainzisegmap_316876_total_runtime /
                    (ctx->mainzisegmap_316876_runs !=
                     0 ? ctx->mainzisegmap_316876_runs : 1),
                    (long) ctx->mainzisegmap_316876_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_316876_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_316876_runs;
        str_builder(&builder,
                    "main.segmap_316918                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_316918_runs,
                    (long) ctx->mainzisegmap_316918_total_runtime /
                    (ctx->mainzisegmap_316918_runs !=
                     0 ? ctx->mainzisegmap_316918_runs : 1),
                    (long) ctx->mainzisegmap_316918_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_316918_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_316918_runs;
        str_builder(&builder,
                    "main.segmap_317016                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_317016_runs,
                    (long) ctx->mainzisegmap_317016_total_runtime /
                    (ctx->mainzisegmap_317016_runs !=
                     0 ? ctx->mainzisegmap_317016_runs : 1),
                    (long) ctx->mainzisegmap_317016_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_317016_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_317016_runs;
        str_builder(&builder,
                    "main.segmap_317052                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_317052_runs,
                    (long) ctx->mainzisegmap_317052_total_runtime /
                    (ctx->mainzisegmap_317052_runs !=
                     0 ? ctx->mainzisegmap_317052_runs : 1),
                    (long) ctx->mainzisegmap_317052_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_317052_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_317052_runs;
        str_builder(&builder,
                    "main.segmap_317089                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_317089_runs,
                    (long) ctx->mainzisegmap_317089_total_runtime /
                    (ctx->mainzisegmap_317089_runs !=
                     0 ? ctx->mainzisegmap_317089_runs : 1),
                    (long) ctx->mainzisegmap_317089_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_317089_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_317089_runs;
        str_builder(&builder,
                    "main.segmap_317118                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_317118_runs,
                    (long) ctx->mainzisegmap_317118_total_runtime /
                    (ctx->mainzisegmap_317118_runs !=
                     0 ? ctx->mainzisegmap_317118_runs : 1),
                    (long) ctx->mainzisegmap_317118_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_317118_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_317118_runs;
        str_builder(&builder,
                    "main.segmap_317377                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_317377_runs,
                    (long) ctx->mainzisegmap_317377_total_runtime /
                    (ctx->mainzisegmap_317377_runs !=
                     0 ? ctx->mainzisegmap_317377_runs : 1),
                    (long) ctx->mainzisegmap_317377_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_317377_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_317377_runs;
        str_builder(&builder,
                    "main.segmap_317481                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_317481_runs,
                    (long) ctx->mainzisegmap_317481_total_runtime /
                    (ctx->mainzisegmap_317481_runs !=
                     0 ? ctx->mainzisegmap_317481_runs : 1),
                    (long) ctx->mainzisegmap_317481_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_317481_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_317481_runs;
        str_builder(&builder,
                    "main.segmap_317504                       ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_317504_runs,
                    (long) ctx->mainzisegmap_317504_total_runtime /
                    (ctx->mainzisegmap_317504_runs !=
                     0 ? ctx->mainzisegmap_317504_runs : 1),
                    (long) ctx->mainzisegmap_317504_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_317504_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_317504_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_297641            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_297641_runs,
                    (long) ctx->mainzisegmap_intragroup_297641_total_runtime /
                    (ctx->mainzisegmap_intragroup_297641_runs !=
                     0 ? ctx->mainzisegmap_intragroup_297641_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_297641_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_297641_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_297641_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_298000            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_298000_runs,
                    (long) ctx->mainzisegmap_intragroup_298000_total_runtime /
                    (ctx->mainzisegmap_intragroup_298000_runs !=
                     0 ? ctx->mainzisegmap_intragroup_298000_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_298000_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_298000_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_298000_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_298276            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_298276_runs,
                    (long) ctx->mainzisegmap_intragroup_298276_total_runtime /
                    (ctx->mainzisegmap_intragroup_298276_runs !=
                     0 ? ctx->mainzisegmap_intragroup_298276_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_298276_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_298276_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_298276_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_298529            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_298529_runs,
                    (long) ctx->mainzisegmap_intragroup_298529_total_runtime /
                    (ctx->mainzisegmap_intragroup_298529_runs !=
                     0 ? ctx->mainzisegmap_intragroup_298529_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_298529_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_298529_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_298529_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_299433            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_299433_runs,
                    (long) ctx->mainzisegmap_intragroup_299433_total_runtime /
                    (ctx->mainzisegmap_intragroup_299433_runs !=
                     0 ? ctx->mainzisegmap_intragroup_299433_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_299433_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_299433_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_299433_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_299834            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_299834_runs,
                    (long) ctx->mainzisegmap_intragroup_299834_total_runtime /
                    (ctx->mainzisegmap_intragroup_299834_runs !=
                     0 ? ctx->mainzisegmap_intragroup_299834_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_299834_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_299834_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_299834_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_300460            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_300460_runs,
                    (long) ctx->mainzisegmap_intragroup_300460_total_runtime /
                    (ctx->mainzisegmap_intragroup_300460_runs !=
                     0 ? ctx->mainzisegmap_intragroup_300460_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_300460_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_300460_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_300460_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_302597            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_302597_runs,
                    (long) ctx->mainzisegmap_intragroup_302597_total_runtime /
                    (ctx->mainzisegmap_intragroup_302597_runs !=
                     0 ? ctx->mainzisegmap_intragroup_302597_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_302597_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_302597_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_302597_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_302925            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_302925_runs,
                    (long) ctx->mainzisegmap_intragroup_302925_total_runtime /
                    (ctx->mainzisegmap_intragroup_302925_runs !=
                     0 ? ctx->mainzisegmap_intragroup_302925_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_302925_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_302925_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_302925_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_303389            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_303389_runs,
                    (long) ctx->mainzisegmap_intragroup_303389_total_runtime /
                    (ctx->mainzisegmap_intragroup_303389_runs !=
                     0 ? ctx->mainzisegmap_intragroup_303389_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_303389_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_303389_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_303389_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_304495            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_304495_runs,
                    (long) ctx->mainzisegmap_intragroup_304495_total_runtime /
                    (ctx->mainzisegmap_intragroup_304495_runs !=
                     0 ? ctx->mainzisegmap_intragroup_304495_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_304495_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_304495_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_304495_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_306005            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_306005_runs,
                    (long) ctx->mainzisegmap_intragroup_306005_total_runtime /
                    (ctx->mainzisegmap_intragroup_306005_runs !=
                     0 ? ctx->mainzisegmap_intragroup_306005_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_306005_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_306005_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_306005_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_307881            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_307881_runs,
                    (long) ctx->mainzisegmap_intragroup_307881_total_runtime /
                    (ctx->mainzisegmap_intragroup_307881_runs !=
                     0 ? ctx->mainzisegmap_intragroup_307881_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_307881_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_307881_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_307881_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_309930            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_309930_runs,
                    (long) ctx->mainzisegmap_intragroup_309930_total_runtime /
                    (ctx->mainzisegmap_intragroup_309930_runs !=
                     0 ? ctx->mainzisegmap_intragroup_309930_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_309930_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_309930_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_309930_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_310101            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_310101_runs,
                    (long) ctx->mainzisegmap_intragroup_310101_total_runtime /
                    (ctx->mainzisegmap_intragroup_310101_runs !=
                     0 ? ctx->mainzisegmap_intragroup_310101_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_310101_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_310101_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_310101_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_310366            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_310366_runs,
                    (long) ctx->mainzisegmap_intragroup_310366_total_runtime /
                    (ctx->mainzisegmap_intragroup_310366_runs !=
                     0 ? ctx->mainzisegmap_intragroup_310366_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_310366_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_310366_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_310366_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_313503            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_313503_runs,
                    (long) ctx->mainzisegmap_intragroup_313503_total_runtime /
                    (ctx->mainzisegmap_intragroup_313503_runs !=
                     0 ? ctx->mainzisegmap_intragroup_313503_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_313503_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_313503_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_313503_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_313823            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_313823_runs,
                    (long) ctx->mainzisegmap_intragroup_313823_total_runtime /
                    (ctx->mainzisegmap_intragroup_313823_runs !=
                     0 ? ctx->mainzisegmap_intragroup_313823_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_313823_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_313823_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_313823_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_314238            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_314238_runs,
                    (long) ctx->mainzisegmap_intragroup_314238_total_runtime /
                    (ctx->mainzisegmap_intragroup_314238_runs !=
                     0 ? ctx->mainzisegmap_intragroup_314238_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_314238_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_314238_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_314238_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_316520            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_316520_runs,
                    (long) ctx->mainzisegmap_intragroup_316520_total_runtime /
                    (ctx->mainzisegmap_intragroup_316520_runs !=
                     0 ? ctx->mainzisegmap_intragroup_316520_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_316520_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_316520_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_316520_runs;
        str_builder(&builder,
                    "main.segmap_intragroup_318088            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegmap_intragroup_318088_runs,
                    (long) ctx->mainzisegmap_intragroup_318088_total_runtime /
                    (ctx->mainzisegmap_intragroup_318088_runs !=
                     0 ? ctx->mainzisegmap_intragroup_318088_runs : 1),
                    (long) ctx->mainzisegmap_intragroup_318088_total_runtime);
        ctx->total_runtime += ctx->mainzisegmap_intragroup_318088_total_runtime;
        ctx->total_runs += ctx->mainzisegmap_intragroup_318088_runs;
        str_builder(&builder,
                    "main.segred_large_304643                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_304643_runs,
                    (long) ctx->mainzisegred_large_304643_total_runtime /
                    (ctx->mainzisegred_large_304643_runs !=
                     0 ? ctx->mainzisegred_large_304643_runs : 1),
                    (long) ctx->mainzisegred_large_304643_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_304643_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_304643_runs;
        str_builder(&builder,
                    "main.segred_large_304718                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_304718_runs,
                    (long) ctx->mainzisegred_large_304718_total_runtime /
                    (ctx->mainzisegred_large_304718_runs !=
                     0 ? ctx->mainzisegred_large_304718_runs : 1),
                    (long) ctx->mainzisegred_large_304718_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_304718_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_304718_runs;
        str_builder(&builder,
                    "main.segred_large_306191                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_306191_runs,
                    (long) ctx->mainzisegred_large_306191_total_runtime /
                    (ctx->mainzisegred_large_306191_runs !=
                     0 ? ctx->mainzisegred_large_306191_runs : 1),
                    (long) ctx->mainzisegred_large_306191_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_306191_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_306191_runs;
        str_builder(&builder,
                    "main.segred_large_306288                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_306288_runs,
                    (long) ctx->mainzisegred_large_306288_total_runtime /
                    (ctx->mainzisegred_large_306288_runs !=
                     0 ? ctx->mainzisegred_large_306288_runs : 1),
                    (long) ctx->mainzisegred_large_306288_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_306288_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_306288_runs;
        str_builder(&builder,
                    "main.segred_large_308109                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_308109_runs,
                    (long) ctx->mainzisegred_large_308109_total_runtime /
                    (ctx->mainzisegred_large_308109_runs !=
                     0 ? ctx->mainzisegred_large_308109_runs : 1),
                    (long) ctx->mainzisegred_large_308109_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_308109_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_308109_runs;
        str_builder(&builder,
                    "main.segred_large_308237                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_308237_runs,
                    (long) ctx->mainzisegred_large_308237_total_runtime /
                    (ctx->mainzisegred_large_308237_runs !=
                     0 ? ctx->mainzisegred_large_308237_runs : 1),
                    (long) ctx->mainzisegred_large_308237_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_308237_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_308237_runs;
        str_builder(&builder,
                    "main.segred_large_308859                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_308859_runs,
                    (long) ctx->mainzisegred_large_308859_total_runtime /
                    (ctx->mainzisegred_large_308859_runs !=
                     0 ? ctx->mainzisegred_large_308859_runs : 1),
                    (long) ctx->mainzisegred_large_308859_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_308859_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_308859_runs;
        str_builder(&builder,
                    "main.segred_large_308990                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_308990_runs,
                    (long) ctx->mainzisegred_large_308990_total_runtime /
                    (ctx->mainzisegred_large_308990_runs !=
                     0 ? ctx->mainzisegred_large_308990_runs : 1),
                    (long) ctx->mainzisegred_large_308990_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_308990_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_308990_runs;
        str_builder(&builder,
                    "main.segred_large_309121                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_309121_runs,
                    (long) ctx->mainzisegred_large_309121_total_runtime /
                    (ctx->mainzisegred_large_309121_runs !=
                     0 ? ctx->mainzisegred_large_309121_runs : 1),
                    (long) ctx->mainzisegred_large_309121_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_309121_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_309121_runs;
        str_builder(&builder,
                    "main.segred_large_310765                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_310765_runs,
                    (long) ctx->mainzisegred_large_310765_total_runtime /
                    (ctx->mainzisegred_large_310765_runs !=
                     0 ? ctx->mainzisegred_large_310765_runs : 1),
                    (long) ctx->mainzisegred_large_310765_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_310765_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_310765_runs;
        str_builder(&builder,
                    "main.segred_large_310815                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_310815_runs,
                    (long) ctx->mainzisegred_large_310815_total_runtime /
                    (ctx->mainzisegred_large_310815_runs !=
                     0 ? ctx->mainzisegred_large_310815_runs : 1),
                    (long) ctx->mainzisegred_large_310815_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_310815_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_310815_runs;
        str_builder(&builder,
                    "main.segred_large_311208                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_311208_runs,
                    (long) ctx->mainzisegred_large_311208_total_runtime /
                    (ctx->mainzisegred_large_311208_runs !=
                     0 ? ctx->mainzisegred_large_311208_runs : 1),
                    (long) ctx->mainzisegred_large_311208_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_311208_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_311208_runs;
        str_builder(&builder,
                    "main.segred_large_311280                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_311280_runs,
                    (long) ctx->mainzisegred_large_311280_total_runtime /
                    (ctx->mainzisegred_large_311280_runs !=
                     0 ? ctx->mainzisegred_large_311280_runs : 1),
                    (long) ctx->mainzisegred_large_311280_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_311280_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_311280_runs;
        str_builder(&builder,
                    "main.segred_large_311778                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_311778_runs,
                    (long) ctx->mainzisegred_large_311778_total_runtime /
                    (ctx->mainzisegred_large_311778_runs !=
                     0 ? ctx->mainzisegred_large_311778_runs : 1),
                    (long) ctx->mainzisegred_large_311778_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_311778_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_311778_runs;
        str_builder(&builder,
                    "main.segred_large_311881                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_311881_runs,
                    (long) ctx->mainzisegred_large_311881_total_runtime /
                    (ctx->mainzisegred_large_311881_runs !=
                     0 ? ctx->mainzisegred_large_311881_runs : 1),
                    (long) ctx->mainzisegred_large_311881_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_311881_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_311881_runs;
        str_builder(&builder,
                    "main.segred_large_314793                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_314793_runs,
                    (long) ctx->mainzisegred_large_314793_total_runtime /
                    (ctx->mainzisegred_large_314793_runs !=
                     0 ? ctx->mainzisegred_large_314793_runs : 1),
                    (long) ctx->mainzisegred_large_314793_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_314793_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_314793_runs;
        str_builder(&builder,
                    "main.segred_large_314846                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_314846_runs,
                    (long) ctx->mainzisegred_large_314846_total_runtime /
                    (ctx->mainzisegred_large_314846_runs !=
                     0 ? ctx->mainzisegred_large_314846_runs : 1),
                    (long) ctx->mainzisegred_large_314846_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_314846_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_314846_runs;
        str_builder(&builder,
                    "main.segred_large_315394                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_315394_runs,
                    (long) ctx->mainzisegred_large_315394_total_runtime /
                    (ctx->mainzisegred_large_315394_runs !=
                     0 ? ctx->mainzisegred_large_315394_runs : 1),
                    (long) ctx->mainzisegred_large_315394_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_315394_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_315394_runs;
        str_builder(&builder,
                    "main.segred_large_315469                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_315469_runs,
                    (long) ctx->mainzisegred_large_315469_total_runtime /
                    (ctx->mainzisegred_large_315469_runs !=
                     0 ? ctx->mainzisegred_large_315469_runs : 1),
                    (long) ctx->mainzisegred_large_315469_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_315469_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_315469_runs;
        str_builder(&builder,
                    "main.segred_large_316122                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_316122_runs,
                    (long) ctx->mainzisegred_large_316122_total_runtime /
                    (ctx->mainzisegred_large_316122_runs !=
                     0 ? ctx->mainzisegred_large_316122_runs : 1),
                    (long) ctx->mainzisegred_large_316122_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_316122_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_316122_runs;
        str_builder(&builder,
                    "main.segred_large_316228                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_316228_runs,
                    (long) ctx->mainzisegred_large_316228_total_runtime /
                    (ctx->mainzisegred_large_316228_runs !=
                     0 ? ctx->mainzisegred_large_316228_runs : 1),
                    (long) ctx->mainzisegred_large_316228_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_316228_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_316228_runs;
        str_builder(&builder,
                    "main.segred_large_316768                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_316768_runs,
                    (long) ctx->mainzisegred_large_316768_total_runtime /
                    (ctx->mainzisegred_large_316768_runs !=
                     0 ? ctx->mainzisegred_large_316768_runs : 1),
                    (long) ctx->mainzisegred_large_316768_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_316768_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_316768_runs;
        str_builder(&builder,
                    "main.segred_large_317337                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_317337_runs,
                    (long) ctx->mainzisegred_large_317337_total_runtime /
                    (ctx->mainzisegred_large_317337_runs !=
                     0 ? ctx->mainzisegred_large_317337_runs : 1),
                    (long) ctx->mainzisegred_large_317337_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_317337_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_317337_runs;
        str_builder(&builder,
                    "main.segred_large_325358                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_large_325358_runs,
                    (long) ctx->mainzisegred_large_325358_total_runtime /
                    (ctx->mainzisegred_large_325358_runs !=
                     0 ? ctx->mainzisegred_large_325358_runs : 1),
                    (long) ctx->mainzisegred_large_325358_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_large_325358_total_runtime;
        ctx->total_runs += ctx->mainzisegred_large_325358_runs;
        str_builder(&builder,
                    "main.segred_small_304643                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_304643_runs,
                    (long) ctx->mainzisegred_small_304643_total_runtime /
                    (ctx->mainzisegred_small_304643_runs !=
                     0 ? ctx->mainzisegred_small_304643_runs : 1),
                    (long) ctx->mainzisegred_small_304643_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_304643_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_304643_runs;
        str_builder(&builder,
                    "main.segred_small_304718                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_304718_runs,
                    (long) ctx->mainzisegred_small_304718_total_runtime /
                    (ctx->mainzisegred_small_304718_runs !=
                     0 ? ctx->mainzisegred_small_304718_runs : 1),
                    (long) ctx->mainzisegred_small_304718_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_304718_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_304718_runs;
        str_builder(&builder,
                    "main.segred_small_306191                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_306191_runs,
                    (long) ctx->mainzisegred_small_306191_total_runtime /
                    (ctx->mainzisegred_small_306191_runs !=
                     0 ? ctx->mainzisegred_small_306191_runs : 1),
                    (long) ctx->mainzisegred_small_306191_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_306191_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_306191_runs;
        str_builder(&builder,
                    "main.segred_small_306288                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_306288_runs,
                    (long) ctx->mainzisegred_small_306288_total_runtime /
                    (ctx->mainzisegred_small_306288_runs !=
                     0 ? ctx->mainzisegred_small_306288_runs : 1),
                    (long) ctx->mainzisegred_small_306288_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_306288_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_306288_runs;
        str_builder(&builder,
                    "main.segred_small_308109                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_308109_runs,
                    (long) ctx->mainzisegred_small_308109_total_runtime /
                    (ctx->mainzisegred_small_308109_runs !=
                     0 ? ctx->mainzisegred_small_308109_runs : 1),
                    (long) ctx->mainzisegred_small_308109_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_308109_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_308109_runs;
        str_builder(&builder,
                    "main.segred_small_308237                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_308237_runs,
                    (long) ctx->mainzisegred_small_308237_total_runtime /
                    (ctx->mainzisegred_small_308237_runs !=
                     0 ? ctx->mainzisegred_small_308237_runs : 1),
                    (long) ctx->mainzisegred_small_308237_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_308237_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_308237_runs;
        str_builder(&builder,
                    "main.segred_small_308859                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_308859_runs,
                    (long) ctx->mainzisegred_small_308859_total_runtime /
                    (ctx->mainzisegred_small_308859_runs !=
                     0 ? ctx->mainzisegred_small_308859_runs : 1),
                    (long) ctx->mainzisegred_small_308859_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_308859_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_308859_runs;
        str_builder(&builder,
                    "main.segred_small_308990                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_308990_runs,
                    (long) ctx->mainzisegred_small_308990_total_runtime /
                    (ctx->mainzisegred_small_308990_runs !=
                     0 ? ctx->mainzisegred_small_308990_runs : 1),
                    (long) ctx->mainzisegred_small_308990_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_308990_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_308990_runs;
        str_builder(&builder,
                    "main.segred_small_309121                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_309121_runs,
                    (long) ctx->mainzisegred_small_309121_total_runtime /
                    (ctx->mainzisegred_small_309121_runs !=
                     0 ? ctx->mainzisegred_small_309121_runs : 1),
                    (long) ctx->mainzisegred_small_309121_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_309121_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_309121_runs;
        str_builder(&builder,
                    "main.segred_small_310765                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_310765_runs,
                    (long) ctx->mainzisegred_small_310765_total_runtime /
                    (ctx->mainzisegred_small_310765_runs !=
                     0 ? ctx->mainzisegred_small_310765_runs : 1),
                    (long) ctx->mainzisegred_small_310765_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_310765_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_310765_runs;
        str_builder(&builder,
                    "main.segred_small_310815                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_310815_runs,
                    (long) ctx->mainzisegred_small_310815_total_runtime /
                    (ctx->mainzisegred_small_310815_runs !=
                     0 ? ctx->mainzisegred_small_310815_runs : 1),
                    (long) ctx->mainzisegred_small_310815_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_310815_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_310815_runs;
        str_builder(&builder,
                    "main.segred_small_311208                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_311208_runs,
                    (long) ctx->mainzisegred_small_311208_total_runtime /
                    (ctx->mainzisegred_small_311208_runs !=
                     0 ? ctx->mainzisegred_small_311208_runs : 1),
                    (long) ctx->mainzisegred_small_311208_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_311208_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_311208_runs;
        str_builder(&builder,
                    "main.segred_small_311280                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_311280_runs,
                    (long) ctx->mainzisegred_small_311280_total_runtime /
                    (ctx->mainzisegred_small_311280_runs !=
                     0 ? ctx->mainzisegred_small_311280_runs : 1),
                    (long) ctx->mainzisegred_small_311280_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_311280_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_311280_runs;
        str_builder(&builder,
                    "main.segred_small_311778                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_311778_runs,
                    (long) ctx->mainzisegred_small_311778_total_runtime /
                    (ctx->mainzisegred_small_311778_runs !=
                     0 ? ctx->mainzisegred_small_311778_runs : 1),
                    (long) ctx->mainzisegred_small_311778_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_311778_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_311778_runs;
        str_builder(&builder,
                    "main.segred_small_311881                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_311881_runs,
                    (long) ctx->mainzisegred_small_311881_total_runtime /
                    (ctx->mainzisegred_small_311881_runs !=
                     0 ? ctx->mainzisegred_small_311881_runs : 1),
                    (long) ctx->mainzisegred_small_311881_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_311881_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_311881_runs;
        str_builder(&builder,
                    "main.segred_small_314793                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_314793_runs,
                    (long) ctx->mainzisegred_small_314793_total_runtime /
                    (ctx->mainzisegred_small_314793_runs !=
                     0 ? ctx->mainzisegred_small_314793_runs : 1),
                    (long) ctx->mainzisegred_small_314793_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_314793_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_314793_runs;
        str_builder(&builder,
                    "main.segred_small_314846                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_314846_runs,
                    (long) ctx->mainzisegred_small_314846_total_runtime /
                    (ctx->mainzisegred_small_314846_runs !=
                     0 ? ctx->mainzisegred_small_314846_runs : 1),
                    (long) ctx->mainzisegred_small_314846_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_314846_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_314846_runs;
        str_builder(&builder,
                    "main.segred_small_315394                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_315394_runs,
                    (long) ctx->mainzisegred_small_315394_total_runtime /
                    (ctx->mainzisegred_small_315394_runs !=
                     0 ? ctx->mainzisegred_small_315394_runs : 1),
                    (long) ctx->mainzisegred_small_315394_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_315394_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_315394_runs;
        str_builder(&builder,
                    "main.segred_small_315469                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_315469_runs,
                    (long) ctx->mainzisegred_small_315469_total_runtime /
                    (ctx->mainzisegred_small_315469_runs !=
                     0 ? ctx->mainzisegred_small_315469_runs : 1),
                    (long) ctx->mainzisegred_small_315469_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_315469_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_315469_runs;
        str_builder(&builder,
                    "main.segred_small_316122                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_316122_runs,
                    (long) ctx->mainzisegred_small_316122_total_runtime /
                    (ctx->mainzisegred_small_316122_runs !=
                     0 ? ctx->mainzisegred_small_316122_runs : 1),
                    (long) ctx->mainzisegred_small_316122_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_316122_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_316122_runs;
        str_builder(&builder,
                    "main.segred_small_316228                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_316228_runs,
                    (long) ctx->mainzisegred_small_316228_total_runtime /
                    (ctx->mainzisegred_small_316228_runs !=
                     0 ? ctx->mainzisegred_small_316228_runs : 1),
                    (long) ctx->mainzisegred_small_316228_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_316228_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_316228_runs;
        str_builder(&builder,
                    "main.segred_small_316768                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_316768_runs,
                    (long) ctx->mainzisegred_small_316768_total_runtime /
                    (ctx->mainzisegred_small_316768_runs !=
                     0 ? ctx->mainzisegred_small_316768_runs : 1),
                    (long) ctx->mainzisegred_small_316768_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_316768_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_316768_runs;
        str_builder(&builder,
                    "main.segred_small_317337                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_317337_runs,
                    (long) ctx->mainzisegred_small_317337_total_runtime /
                    (ctx->mainzisegred_small_317337_runs !=
                     0 ? ctx->mainzisegred_small_317337_runs : 1),
                    (long) ctx->mainzisegred_small_317337_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_317337_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_317337_runs;
        str_builder(&builder,
                    "main.segred_small_325358                 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegred_small_325358_runs,
                    (long) ctx->mainzisegred_small_325358_total_runtime /
                    (ctx->mainzisegred_small_325358_runs !=
                     0 ? ctx->mainzisegred_small_325358_runs : 1),
                    (long) ctx->mainzisegred_small_325358_total_runtime);
        ctx->total_runtime += ctx->mainzisegred_small_325358_total_runtime;
        ctx->total_runs += ctx->mainzisegred_small_325358_runs;
        str_builder(&builder,
                    "main.segscan_297615                      ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegscan_297615_runs,
                    (long) ctx->mainzisegscan_297615_total_runtime /
                    (ctx->mainzisegscan_297615_runs !=
                     0 ? ctx->mainzisegscan_297615_runs : 1),
                    (long) ctx->mainzisegscan_297615_total_runtime);
        ctx->total_runtime += ctx->mainzisegscan_297615_total_runtime;
        ctx->total_runs += ctx->mainzisegscan_297615_runs;
        str_builder(&builder,
                    "main.segscan_297755                      ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegscan_297755_runs,
                    (long) ctx->mainzisegscan_297755_total_runtime /
                    (ctx->mainzisegscan_297755_runs !=
                     0 ? ctx->mainzisegscan_297755_runs : 1),
                    (long) ctx->mainzisegscan_297755_total_runtime);
        ctx->total_runtime += ctx->mainzisegscan_297755_total_runtime;
        ctx->total_runs += ctx->mainzisegscan_297755_runs;
        str_builder(&builder,
                    "main.segscan_298311                      ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegscan_298311_runs,
                    (long) ctx->mainzisegscan_298311_total_runtime /
                    (ctx->mainzisegscan_298311_runs !=
                     0 ? ctx->mainzisegscan_298311_runs : 1),
                    (long) ctx->mainzisegscan_298311_total_runtime);
        ctx->total_runtime += ctx->mainzisegscan_298311_total_runtime;
        ctx->total_runs += ctx->mainzisegscan_298311_runs;
        str_builder(&builder,
                    "main.segscan_308911                      ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegscan_308911_runs,
                    (long) ctx->mainzisegscan_308911_total_runtime /
                    (ctx->mainzisegscan_308911_runs !=
                     0 ? ctx->mainzisegscan_308911_runs : 1),
                    (long) ctx->mainzisegscan_308911_total_runtime);
        ctx->total_runtime += ctx->mainzisegscan_308911_total_runtime;
        ctx->total_runs += ctx->mainzisegscan_308911_runs;
        str_builder(&builder,
                    "main.segscan_309042                      ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegscan_309042_runs,
                    (long) ctx->mainzisegscan_309042_total_runtime /
                    (ctx->mainzisegscan_309042_runs !=
                     0 ? ctx->mainzisegscan_309042_runs : 1),
                    (long) ctx->mainzisegscan_309042_total_runtime);
        ctx->total_runtime += ctx->mainzisegscan_309042_total_runtime;
        ctx->total_runs += ctx->mainzisegscan_309042_runs;
        str_builder(&builder,
                    "main.segscan_309173                      ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegscan_309173_runs,
                    (long) ctx->mainzisegscan_309173_total_runtime /
                    (ctx->mainzisegscan_309173_runs !=
                     0 ? ctx->mainzisegscan_309173_runs : 1),
                    (long) ctx->mainzisegscan_309173_total_runtime);
        ctx->total_runtime += ctx->mainzisegscan_309173_total_runtime;
        ctx->total_runs += ctx->mainzisegscan_309173_runs;
        str_builder(&builder,
                    "main.segscan_316886                      ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegscan_316886_runs,
                    (long) ctx->mainzisegscan_316886_total_runtime /
                    (ctx->mainzisegscan_316886_runs !=
                     0 ? ctx->mainzisegscan_316886_runs : 1),
                    (long) ctx->mainzisegscan_316886_total_runtime);
        ctx->total_runtime += ctx->mainzisegscan_316886_total_runtime;
        ctx->total_runs += ctx->mainzisegscan_316886_runs;
        str_builder(&builder,
                    "main.segscan_317116                      ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->mainzisegscan_317116_runs,
                    (long) ctx->mainzisegscan_317116_total_runtime /
                    (ctx->mainzisegscan_317116_runs !=
                     0 ? ctx->mainzisegscan_317116_runs : 1),
                    (long) ctx->mainzisegscan_317116_total_runtime);
        ctx->total_runtime += ctx->mainzisegscan_317116_total_runtime;
        ctx->total_runs += ctx->mainzisegscan_317116_runs;
        str_builder(&builder,
                    "seasonal_amplitude.segmap_297410         ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->seasonal_amplitudezisegmap_297410_runs,
                    (long) ctx->seasonal_amplitudezisegmap_297410_total_runtime /
                    (ctx->seasonal_amplitudezisegmap_297410_runs !=
                     0 ? ctx->seasonal_amplitudezisegmap_297410_runs : 1),
                    (long) ctx->seasonal_amplitudezisegmap_297410_total_runtime);
        ctx->total_runtime +=
            ctx->seasonal_amplitudezisegmap_297410_total_runtime;
        ctx->total_runs += ctx->seasonal_amplitudezisegmap_297410_runs;
        str_builder(&builder,
                    "seasonal_amplitude.segmap_297483         ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->seasonal_amplitudezisegmap_297483_runs,
                    (long) ctx->seasonal_amplitudezisegmap_297483_total_runtime /
                    (ctx->seasonal_amplitudezisegmap_297483_runs !=
                     0 ? ctx->seasonal_amplitudezisegmap_297483_runs : 1),
                    (long) ctx->seasonal_amplitudezisegmap_297483_total_runtime);
        ctx->total_runtime +=
            ctx->seasonal_amplitudezisegmap_297483_total_runtime;
        ctx->total_runs += ctx->seasonal_amplitudezisegmap_297483_runs;
        str_builder(&builder,
                    "seasonal_amplitude.segred_large_297469   ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->seasonal_amplitudezisegred_large_297469_runs,
                    (long) ctx->seasonal_amplitudezisegred_large_297469_total_runtime /
                    (ctx->seasonal_amplitudezisegred_large_297469_runs !=
                     0 ? ctx->seasonal_amplitudezisegred_large_297469_runs : 1),
                    (long) ctx->seasonal_amplitudezisegred_large_297469_total_runtime);
        ctx->total_runtime +=
            ctx->seasonal_amplitudezisegred_large_297469_total_runtime;
        ctx->total_runs += ctx->seasonal_amplitudezisegred_large_297469_runs;
        str_builder(&builder,
                    "seasonal_amplitude.segred_small_297469   ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->seasonal_amplitudezisegred_small_297469_runs,
                    (long) ctx->seasonal_amplitudezisegred_small_297469_total_runtime /
                    (ctx->seasonal_amplitudezisegred_small_297469_runs !=
                     0 ? ctx->seasonal_amplitudezisegred_small_297469_runs : 1),
                    (long) ctx->seasonal_amplitudezisegred_small_297469_total_runtime);
        ctx->total_runtime +=
            ctx->seasonal_amplitudezisegred_small_297469_total_runtime;
        ctx->total_runs += ctx->seasonal_amplitudezisegred_small_297469_runs;
        str_builder(&builder,
                    "trend_magnitude.segmap_297603            ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->trend_magnitudezisegmap_297603_runs,
                    (long) ctx->trend_magnitudezisegmap_297603_total_runtime /
                    (ctx->trend_magnitudezisegmap_297603_runs !=
                     0 ? ctx->trend_magnitudezisegmap_297603_runs : 1),
                    (long) ctx->trend_magnitudezisegmap_297603_total_runtime);
        ctx->total_runtime += ctx->trend_magnitudezisegmap_297603_total_runtime;
        ctx->total_runs += ctx->trend_magnitudezisegmap_297603_runs;
        str_builder(&builder,
                    "trend_magnitude.segmap_intragroup_318088 ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->trend_magnitudezisegmap_intragroup_318088_runs,
                    (long) ctx->trend_magnitudezisegmap_intragroup_318088_total_runtime /
                    (ctx->trend_magnitudezisegmap_intragroup_318088_runs !=
                     0 ? ctx->trend_magnitudezisegmap_intragroup_318088_runs : 1),
                    (long) ctx->trend_magnitudezisegmap_intragroup_318088_total_runtime);
        ctx->total_runtime +=
            ctx->trend_magnitudezisegmap_intragroup_318088_total_runtime;
        ctx->total_runs += ctx->trend_magnitudezisegmap_intragroup_318088_runs;
        str_builder(&builder,
                    "trend_magnitude.segred_large_297587      ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->trend_magnitudezisegred_large_297587_runs,
                    (long) ctx->trend_magnitudezisegred_large_297587_total_runtime /
                    (ctx->trend_magnitudezisegred_large_297587_runs !=
                     0 ? ctx->trend_magnitudezisegred_large_297587_runs : 1),
                    (long) ctx->trend_magnitudezisegred_large_297587_total_runtime);
        ctx->total_runtime +=
            ctx->trend_magnitudezisegred_large_297587_total_runtime;
        ctx->total_runs += ctx->trend_magnitudezisegred_large_297587_runs;
        str_builder(&builder,
                    "trend_magnitude.segred_nonseg_297501     ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->trend_magnitudezisegred_nonseg_297501_runs,
                    (long) ctx->trend_magnitudezisegred_nonseg_297501_total_runtime /
                    (ctx->trend_magnitudezisegred_nonseg_297501_runs !=
                     0 ? ctx->trend_magnitudezisegred_nonseg_297501_runs : 1),
                    (long) ctx->trend_magnitudezisegred_nonseg_297501_total_runtime);
        ctx->total_runtime +=
            ctx->trend_magnitudezisegred_nonseg_297501_total_runtime;
        ctx->total_runs += ctx->trend_magnitudezisegred_nonseg_297501_runs;
        str_builder(&builder,
                    "trend_magnitude.segred_small_297587      ran %5d times; avg: %8ldus; total: %8ldus\n",
                    ctx->trend_magnitudezisegred_small_297587_runs,
                    (long) ctx->trend_magnitudezisegred_small_297587_total_runtime /
                    (ctx->trend_magnitudezisegred_small_297587_runs !=
                     0 ? ctx->trend_magnitudezisegred_small_297587_runs : 1),
                    (long) ctx->trend_magnitudezisegred_small_297587_total_runtime);
        ctx->total_runtime +=
            ctx->trend_magnitudezisegred_small_297587_total_runtime;
        ctx->total_runs += ctx->trend_magnitudezisegred_small_297587_runs;
        str_builder(&builder, "%d operations with cumulative runtime: %6ldus\n",
                    ctx->total_runs, ctx->total_runtime);
    }
    return builder.str;
}
char *futhark_context_get_error(struct futhark_context *ctx)
{
    char *error = ctx->error;
    
    ctx->error = NULL;
    return error;
}
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f)
{
    ctx->log = f;
}
void futhark_context_pause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 1;
}
void futhark_context_unpause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 0;
}
int futhark_context_clear_caches(struct futhark_context *ctx)
{
    lock_lock(&ctx->lock);
    CUDA_SUCCEED_FATAL(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    ctx->peak_mem_usage_device = 0;
    ctx->peak_mem_usage_default = 0;
    if (ctx->error == NULL)
        CUDA_SUCCEED_NONFATAL(cuda_free_all(&ctx->cuda));
    CUDA_SUCCEED_FATAL(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    lock_unlock(&ctx->lock);
    return ctx->error != NULL;
}

static int futrts_builtinzhgpu_map_transpose_f32(struct futhark_context *ctx,
                                                 struct memblock_device destmem_0,
                                                 int32_t destoffset_1,
                                                 struct memblock_device srcmem_2,
                                                 int32_t srcoffset_3,
                                                 int32_t num_arrays_4,
                                                 int32_t x_elems_5,
                                                 int32_t y_elems_6);
static int futrts_builtinzhgpu_map_transpose_f64(struct futhark_context *ctx,
                                                 struct memblock_device destmem_0,
                                                 int32_t destoffset_1,
                                                 struct memblock_device srcmem_2,
                                                 int32_t srcoffset_3,
                                                 int32_t num_arrays_4,
                                                 int32_t x_elems_5,
                                                 int32_t y_elems_6);
static int futrts_builtinzhgpu_map_transpose_i64(struct futhark_context *ctx,
                                                 struct memblock_device destmem_0,
                                                 int32_t destoffset_1,
                                                 struct memblock_device srcmem_2,
                                                 int32_t srcoffset_3,
                                                 int32_t num_arrays_4,
                                                 int32_t x_elems_5,
                                                 int32_t y_elems_6);
static int futrts_builtinzhreplicate_f32(struct futhark_context *ctx,
                                         struct memblock_device mem_325742,
                                         int32_t num_elems_325743,
                                         float val_325744);
static int futrts_builtinzhreplicate_f64(struct futhark_context *ctx,
                                         struct memblock_device mem_321582,
                                         int32_t num_elems_321583,
                                         double val_321584);
static int futrts_builtinzhreplicate_i32(struct futhark_context *ctx,
                                         struct memblock_device mem_325099,
                                         int32_t num_elems_325100,
                                         int32_t val_325101);
static int futrts_builtinzhreplicate_i64(struct futhark_context *ctx,
                                         struct memblock_device mem_321082,
                                         int32_t num_elems_321083,
                                         int64_t val_321084);
static int futrts_builtinzhreplicate_i8(struct futhark_context *ctx,
                                        struct memblock_device mem_320837,
                                        int32_t num_elems_320838,
                                        int8_t val_320839);
static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock_device *mem_out_p_325879,
                             struct memblock_device *mem_out_p_325880,
                             struct memblock_device *mem_out_p_325881,
                             struct memblock_device Y_mem_318490,
                             int64_t m_292674, int64_t n_292675,
                             int64_t n_p_292677, int64_t q_s_292678,
                             int64_t q_t_292679, int64_t q_l_292680,
                             int64_t d_s_292681, int64_t d_t_292682,
                             int64_t d_l_292683, int64_t jump_s_292684,
                             int64_t jump_t_292685, int64_t jump_l_292686,
                             int64_t n_inner_292687, int64_t n_outer_292688,
                             int64_t jump_threshold_1_292689,
                             int64_t jump_threshold_2_292690,
                             int64_t q_threshold_1_292691,
                             int64_t q_threshold_2_292692);
static int futrts_entry_seasonal_amplitude(struct futhark_context *ctx,
                                           struct memblock_device *mem_out_p_327917,
                                           struct memblock_device seasonal_l_mem_318490,
                                           int64_t m_292609, int64_t n_292610);
static int futrts_entry_trend_magnitude(struct futhark_context *ctx,
                                        struct memblock_device *mem_out_p_327955,
                                        struct memblock_device trend_l_mem_318490,
                                        int64_t m_292626, int64_t n_292627);

static int init_constants(struct futhark_context *ctx)
{
    (void) ctx;
    
    int err = 0;
    
    
  cleanup:
    return err;
}
static int free_constants(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
struct futhark_f32_1d {
    struct memblock_device mem;
    int64_t shape[1];
};
struct futhark_f32_1d *futhark_new_f32_1d(struct futhark_context *ctx, const
                                          float *data, int64_t dim0)
{
    struct futhark_f32_1d *bad = NULL;
    struct futhark_f32_1d *arr =
                          (struct futhark_f32_1d *) malloc(sizeof(struct futhark_f32_1d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    CUDA_SUCCEED_FATAL(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    arr->mem.references = NULL;
    if (memblock_alloc_device(ctx, &arr->mem, dim0 * 4, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    {
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda, &ctx->copy_host_to_dev_runs,
                                      &ctx->copy_host_to_dev_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuMemcpyHtoD(arr->mem.mem + 0, data + 0,
                                            (size_t) dim0 * 4));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
    }
    CUDA_SUCCEED_FATAL(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    lock_unlock(&ctx->lock);
    return arr;
}
struct futhark_f32_1d *futhark_new_raw_f32_1d(struct futhark_context *ctx, const
                                              CUdeviceptr data, int64_t offset,
                                              int64_t dim0)
{
    struct futhark_f32_1d *bad = NULL;
    struct futhark_f32_1d *arr =
                          (struct futhark_f32_1d *) malloc(sizeof(struct futhark_f32_1d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    CUDA_SUCCEED_FATAL(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    arr->mem.references = NULL;
    if (memblock_alloc_device(ctx, &arr->mem, dim0 * 4, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    {
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda, &ctx->copy_dev_to_dev_runs,
                                      &ctx->copy_dev_to_dev_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuMemcpy(arr->mem.mem + 0, data + offset,
                                        (size_t) dim0 * 4));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
    }
    CUDA_SUCCEED_FATAL(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    lock_unlock(&ctx->lock);
    return arr;
}
int futhark_free_f32_1d(struct futhark_context *ctx, struct futhark_f32_1d *arr)
{
    lock_lock(&ctx->lock);
    CUDA_SUCCEED_FATAL(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    if (memblock_unref_device(ctx, &arr->mem, "arr->mem") != 0)
        return 1;
    CUDA_SUCCEED_FATAL(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    lock_unlock(&ctx->lock);
    free(arr);
    return 0;
}
int futhark_values_f32_1d(struct futhark_context *ctx,
                          struct futhark_f32_1d *arr, float *data)
{
    lock_lock(&ctx->lock);
    CUDA_SUCCEED_FATAL(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    {
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda, &ctx->copy_dev_to_host_runs,
                                      &ctx->copy_dev_to_host_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuMemcpyDtoH(data + 0, arr->mem.mem + 0,
                                            (size_t) arr->shape[0] * 4));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
    }
    CUDA_SUCCEED_FATAL(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    lock_unlock(&ctx->lock);
    return 0;
}
CUdeviceptr futhark_values_raw_f32_1d(struct futhark_context *ctx,
                                      struct futhark_f32_1d *arr)
{
    (void) ctx;
    return arr->mem.mem;
}
const int64_t *futhark_shape_f32_1d(struct futhark_context *ctx,
                                    struct futhark_f32_1d *arr)
{
    (void) ctx;
    return arr->shape;
}
struct futhark_f32_2d {
    struct memblock_device mem;
    int64_t shape[2];
};
struct futhark_f32_2d *futhark_new_f32_2d(struct futhark_context *ctx, const
                                          float *data, int64_t dim0,
                                          int64_t dim1)
{
    struct futhark_f32_2d *bad = NULL;
    struct futhark_f32_2d *arr =
                          (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    CUDA_SUCCEED_FATAL(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    arr->mem.references = NULL;
    if (memblock_alloc_device(ctx, &arr->mem, dim0 * dim1 * 4, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    {
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda, &ctx->copy_host_to_dev_runs,
                                      &ctx->copy_host_to_dev_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuMemcpyHtoD(arr->mem.mem + 0, data + 0,
                                            (size_t) (dim0 * dim1) * 4));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
    }
    CUDA_SUCCEED_FATAL(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    lock_unlock(&ctx->lock);
    return arr;
}
struct futhark_f32_2d *futhark_new_raw_f32_2d(struct futhark_context *ctx, const
                                              CUdeviceptr data, int64_t offset,
                                              int64_t dim0, int64_t dim1)
{
    struct futhark_f32_2d *bad = NULL;
    struct futhark_f32_2d *arr =
                          (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    CUDA_SUCCEED_FATAL(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    arr->mem.references = NULL;
    if (memblock_alloc_device(ctx, &arr->mem, dim0 * dim1 * 4, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    {
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda, &ctx->copy_dev_to_dev_runs,
                                      &ctx->copy_dev_to_dev_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuMemcpy(arr->mem.mem + 0, data + offset,
                                        (size_t) (dim0 * dim1) * 4));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
    }
    CUDA_SUCCEED_FATAL(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    lock_unlock(&ctx->lock);
    return arr;
}
int futhark_free_f32_2d(struct futhark_context *ctx, struct futhark_f32_2d *arr)
{
    lock_lock(&ctx->lock);
    CUDA_SUCCEED_FATAL(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    if (memblock_unref_device(ctx, &arr->mem, "arr->mem") != 0)
        return 1;
    CUDA_SUCCEED_FATAL(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    lock_unlock(&ctx->lock);
    free(arr);
    return 0;
}
int futhark_values_f32_2d(struct futhark_context *ctx,
                          struct futhark_f32_2d *arr, float *data)
{
    lock_lock(&ctx->lock);
    CUDA_SUCCEED_FATAL(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    {
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda, &ctx->copy_dev_to_host_runs,
                                      &ctx->copy_dev_to_host_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuMemcpyDtoH(data + 0, arr->mem.mem + 0,
                                            (size_t) (arr->shape[0] *
                                                      arr->shape[1]) * 4));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
    }
    CUDA_SUCCEED_FATAL(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    lock_unlock(&ctx->lock);
    return 0;
}
CUdeviceptr futhark_values_raw_f32_2d(struct futhark_context *ctx,
                                      struct futhark_f32_2d *arr)
{
    (void) ctx;
    return arr->mem.mem;
}
const int64_t *futhark_shape_f32_2d(struct futhark_context *ctx,
                                    struct futhark_f32_2d *arr)
{
    (void) ctx;
    return arr->shape;
}

static int futrts_builtinzhgpu_map_transpose_f32(struct futhark_context *ctx,
                                                 struct memblock_device destmem_0,
                                                 int32_t destoffset_1,
                                                 struct memblock_device srcmem_2,
                                                 int32_t srcoffset_3,
                                                 int32_t num_arrays_4,
                                                 int32_t x_elems_5,
                                                 int32_t y_elems_6)
{
    (void) ctx;
    
    int err = 0;
    
    if (!(num_arrays_4 == 0 || (x_elems_5 == 0 || y_elems_6 == 0))) {
        int32_t muly_8 = squot32(16, x_elems_5);
        int32_t mulx_7 = squot32(16, y_elems_6);
        
        if (num_arrays_4 == 1 && (x_elems_5 == 1 || y_elems_6 == 1)) {
            {
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->copy_dev_to_dev_runs,
                                              &ctx->copy_dev_to_dev_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuMemcpy(destmem_0.mem +
                                                sext_i32_i64(destoffset_1),
                                                srcmem_2.mem +
                                                sext_i32_i64(srcoffset_3),
                                                sext_i32_i64(x_elems_5 *
                                                y_elems_6 * 4)));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            }
        } else {
            if (sle32(x_elems_5, 8) && slt32(16, y_elems_6)) {
                unsigned int shared_sizze_325778 = (int64_t) 1088;
                CUdeviceptr kernel_arg_325780 = destmem_0.mem;
                CUdeviceptr kernel_arg_325781 = srcmem_2.mem;
                unsigned int shared_offset_325779 = 0;
                
                if ((((((1 && sdiv_up32(x_elems_5, 16) != 0) &&
                        sdiv_up32(sdiv_up32(y_elems_6, muly_8), 16) != 0) &&
                       num_arrays_4 != 0) && 16 != 0) && 16 != 0) && 1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (sdiv_up32(sdiv_up32(y_elems_6, muly_8), 16) >= 1 <<
                        16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (num_arrays_4 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = sdiv_up32(x_elems_5, 16);
                    grid[perm[1]] = sdiv_up32(sdiv_up32(y_elems_6, muly_8), 16);
                    grid[perm[2]] = num_arrays_4;
                    
                    void *kernel_args_325775[] = {&perm[0], &perm[1], &perm[2],
                                                  &shared_offset_325779,
                                                  &destoffset_1, &srcoffset_3,
                                                  &num_arrays_4, &x_elems_5,
                                                  &y_elems_6, &mulx_7, &muly_8,
                                                  &kernel_arg_325780,
                                                  &kernel_arg_325781};
                    int64_t time_start_325776 = 0, time_end_325777 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "gpu_map_transpose_f32_low_width",
                                (long) sdiv_up32(x_elems_5, 16),
                                (long) sdiv_up32(sdiv_up32(y_elems_6, muly_8),
                                                 16), (long) num_arrays_4,
                                (long) 16, (long) 16, (long) 1, (int) (0 +
                                                                       (shared_sizze_325778 +
                                                                        (8 -
                                                                         shared_sizze_325778 %
                                                                         8) %
                                                                        8)));
                        time_start_325776 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->gpu_map_transpose_f32_low_width_runs,
                                                  &ctx->gpu_map_transpose_f32_low_width_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->gpu_map_transpose_f32_low_width,
                                                          grid[0], grid[1],
                                                          grid[2], 16, 16, 1,
                                                          0 +
                                                          (shared_sizze_325778 +
                                                           (8 -
                                                            shared_sizze_325778 %
                                                            8) % 8), NULL,
                                                          kernel_args_325775,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_325777 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "gpu_map_transpose_f32_low_width",
                                time_end_325777 - time_start_325776);
                    }
                }
            } else {
                if (sle32(y_elems_6, 8) && slt32(16, x_elems_5)) {
                    unsigned int shared_sizze_325785 = (int64_t) 1088;
                    CUdeviceptr kernel_arg_325787 = destmem_0.mem;
                    CUdeviceptr kernel_arg_325788 = srcmem_2.mem;
                    unsigned int shared_offset_325786 = 0;
                    
                    if ((((((1 && sdiv_up32(sdiv_up32(x_elems_5, mulx_7), 16) !=
                             0) && sdiv_up32(y_elems_6, 16) != 0) &&
                           num_arrays_4 != 0) && 16 != 0) && 16 != 0) && 1 !=
                        0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (sdiv_up32(y_elems_6, 16) >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (num_arrays_4 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = sdiv_up32(sdiv_up32(x_elems_5, mulx_7),
                                                  16);
                        grid[perm[1]] = sdiv_up32(y_elems_6, 16);
                        grid[perm[2]] = num_arrays_4;
                        
                        void *kernel_args_325782[] = {&perm[0], &perm[1],
                                                      &perm[2],
                                                      &shared_offset_325786,
                                                      &destoffset_1,
                                                      &srcoffset_3,
                                                      &num_arrays_4, &x_elems_5,
                                                      &y_elems_6, &mulx_7,
                                                      &muly_8,
                                                      &kernel_arg_325787,
                                                      &kernel_arg_325788};
                        int64_t time_start_325783 = 0, time_end_325784 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "gpu_map_transpose_f32_low_height",
                                    (long) sdiv_up32(sdiv_up32(x_elems_5,
                                                               mulx_7), 16),
                                    (long) sdiv_up32(y_elems_6, 16),
                                    (long) num_arrays_4, (long) 16, (long) 16,
                                    (long) 1, (int) (0 + (shared_sizze_325785 +
                                                          (8 -
                                                           shared_sizze_325785 %
                                                           8) % 8)));
                            time_start_325783 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->gpu_map_transpose_f32_low_height_runs,
                                                      &ctx->gpu_map_transpose_f32_low_height_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->gpu_map_transpose_f32_low_height,
                                                              grid[0], grid[1],
                                                              grid[2], 16, 16,
                                                              1, 0 +
                                                              (shared_sizze_325785 +
                                                               (8 -
                                                                shared_sizze_325785 %
                                                                8) % 8), NULL,
                                                              kernel_args_325782,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_325784 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "gpu_map_transpose_f32_low_height",
                                    time_end_325784 - time_start_325783);
                        }
                    }
                } else {
                    if (sle32(x_elems_5, 8) && sle32(y_elems_6, 8)) {
                        unsigned int shared_sizze_325792 = (int64_t) 1;
                        CUdeviceptr kernel_arg_325794 = destmem_0.mem;
                        CUdeviceptr kernel_arg_325795 = srcmem_2.mem;
                        unsigned int shared_offset_325793 = 0;
                        
                        if ((((((1 && sdiv_up32(num_arrays_4 * x_elems_5 *
                                                y_elems_6, 256) != 0) && 1 !=
                                0) && 1 != 0) && 256 != 0) && 1 != 0) && 1 !=
                            0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = sdiv_up32(num_arrays_4 * x_elems_5 *
                                                      y_elems_6, 256);
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_325789[] = {&shared_offset_325793,
                                                          &destoffset_1,
                                                          &srcoffset_3,
                                                          &num_arrays_4,
                                                          &x_elems_5,
                                                          &y_elems_6, &mulx_7,
                                                          &muly_8,
                                                          &kernel_arg_325794,
                                                          &kernel_arg_325795};
                            int64_t time_start_325790 = 0, time_end_325791 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "gpu_map_transpose_f32_small",
                                        (long) sdiv_up32(num_arrays_4 *
                                                         x_elems_5 * y_elems_6,
                                                         256), (long) 1,
                                        (long) 1, (long) 256, (long) 1,
                                        (long) 1, (int) (0 +
                                                         (shared_sizze_325792 +
                                                          (8 -
                                                           shared_sizze_325792 %
                                                           8) % 8)));
                                time_start_325790 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->gpu_map_transpose_f32_small_runs,
                                                          &ctx->gpu_map_transpose_f32_small_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->gpu_map_transpose_f32_small,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2], 256,
                                                                  1, 1, 0 +
                                                                  (shared_sizze_325792 +
                                                                   (8 -
                                                                    shared_sizze_325792 %
                                                                    8) % 8),
                                                                  NULL,
                                                                  kernel_args_325789,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_325791 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "gpu_map_transpose_f32_small",
                                        time_end_325791 - time_start_325790);
                            }
                        }
                    } else {
                        unsigned int shared_sizze_325799 = (int64_t) 4224;
                        CUdeviceptr kernel_arg_325801 = destmem_0.mem;
                        CUdeviceptr kernel_arg_325802 = srcmem_2.mem;
                        unsigned int shared_offset_325800 = 0;
                        
                        if ((((((1 && sdiv_up32(x_elems_5, 32) != 0) &&
                                sdiv_up32(y_elems_6, 32) != 0) &&
                               num_arrays_4 != 0) && 32 != 0) && 8 != 0) && 1 !=
                            0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (sdiv_up32(y_elems_6, 32) >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (num_arrays_4 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = sdiv_up32(x_elems_5, 32);
                            grid[perm[1]] = sdiv_up32(y_elems_6, 32);
                            grid[perm[2]] = num_arrays_4;
                            
                            void *kernel_args_325796[] = {&perm[0], &perm[1],
                                                          &perm[2],
                                                          &shared_offset_325800,
                                                          &destoffset_1,
                                                          &srcoffset_3,
                                                          &num_arrays_4,
                                                          &x_elems_5,
                                                          &y_elems_6, &mulx_7,
                                                          &muly_8,
                                                          &kernel_arg_325801,
                                                          &kernel_arg_325802};
                            int64_t time_start_325797 = 0, time_end_325798 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "gpu_map_transpose_f32",
                                        (long) sdiv_up32(x_elems_5, 32),
                                        (long) sdiv_up32(y_elems_6, 32),
                                        (long) num_arrays_4, (long) 32,
                                        (long) 8, (long) 1, (int) (0 +
                                                                   (shared_sizze_325799 +
                                                                    (8 -
                                                                     shared_sizze_325799 %
                                                                     8) % 8)));
                                time_start_325797 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->gpu_map_transpose_f32_runs,
                                                          &ctx->gpu_map_transpose_f32_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->gpu_map_transpose_f32,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2], 32,
                                                                  8, 1, 0 +
                                                                  (shared_sizze_325799 +
                                                                   (8 -
                                                                    shared_sizze_325799 %
                                                                    8) % 8),
                                                                  NULL,
                                                                  kernel_args_325796,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_325798 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "gpu_map_transpose_f32",
                                        time_end_325798 - time_start_325797);
                            }
                        }
                    }
                }
            }
        }
    }
    
  cleanup:
    { }
    return err;
}
static int futrts_builtinzhgpu_map_transpose_f64(struct futhark_context *ctx,
                                                 struct memblock_device destmem_0,
                                                 int32_t destoffset_1,
                                                 struct memblock_device srcmem_2,
                                                 int32_t srcoffset_3,
                                                 int32_t num_arrays_4,
                                                 int32_t x_elems_5,
                                                 int32_t y_elems_6)
{
    (void) ctx;
    
    int err = 0;
    
    if (!(num_arrays_4 == 0 || (x_elems_5 == 0 || y_elems_6 == 0))) {
        int32_t muly_8 = squot32(16, x_elems_5);
        int32_t mulx_7 = squot32(16, y_elems_6);
        
        if (num_arrays_4 == 1 && (x_elems_5 == 1 || y_elems_6 == 1)) {
            {
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->copy_dev_to_dev_runs,
                                              &ctx->copy_dev_to_dev_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuMemcpy(destmem_0.mem +
                                                sext_i32_i64(destoffset_1),
                                                srcmem_2.mem +
                                                sext_i32_i64(srcoffset_3),
                                                sext_i32_i64(x_elems_5 *
                                                y_elems_6 * 8)));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            }
        } else {
            if (sle32(x_elems_5, 8) && slt32(16, y_elems_6)) {
                unsigned int shared_sizze_325806 = (int64_t) 2176;
                CUdeviceptr kernel_arg_325808 = destmem_0.mem;
                CUdeviceptr kernel_arg_325809 = srcmem_2.mem;
                unsigned int shared_offset_325807 = 0;
                
                if ((((((1 && sdiv_up32(x_elems_5, 16) != 0) &&
                        sdiv_up32(sdiv_up32(y_elems_6, muly_8), 16) != 0) &&
                       num_arrays_4 != 0) && 16 != 0) && 16 != 0) && 1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (sdiv_up32(sdiv_up32(y_elems_6, muly_8), 16) >= 1 <<
                        16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (num_arrays_4 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = sdiv_up32(x_elems_5, 16);
                    grid[perm[1]] = sdiv_up32(sdiv_up32(y_elems_6, muly_8), 16);
                    grid[perm[2]] = num_arrays_4;
                    
                    void *kernel_args_325803[] = {&perm[0], &perm[1], &perm[2],
                                                  &shared_offset_325807,
                                                  &destoffset_1, &srcoffset_3,
                                                  &num_arrays_4, &x_elems_5,
                                                  &y_elems_6, &mulx_7, &muly_8,
                                                  &kernel_arg_325808,
                                                  &kernel_arg_325809};
                    int64_t time_start_325804 = 0, time_end_325805 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "gpu_map_transpose_f64_low_width",
                                (long) sdiv_up32(x_elems_5, 16),
                                (long) sdiv_up32(sdiv_up32(y_elems_6, muly_8),
                                                 16), (long) num_arrays_4,
                                (long) 16, (long) 16, (long) 1, (int) (0 +
                                                                       (shared_sizze_325806 +
                                                                        (8 -
                                                                         shared_sizze_325806 %
                                                                         8) %
                                                                        8)));
                        time_start_325804 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->gpu_map_transpose_f64_low_width_runs,
                                                  &ctx->gpu_map_transpose_f64_low_width_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->gpu_map_transpose_f64_low_width,
                                                          grid[0], grid[1],
                                                          grid[2], 16, 16, 1,
                                                          0 +
                                                          (shared_sizze_325806 +
                                                           (8 -
                                                            shared_sizze_325806 %
                                                            8) % 8), NULL,
                                                          kernel_args_325803,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_325805 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "gpu_map_transpose_f64_low_width",
                                time_end_325805 - time_start_325804);
                    }
                }
            } else {
                if (sle32(y_elems_6, 8) && slt32(16, x_elems_5)) {
                    unsigned int shared_sizze_325813 = (int64_t) 2176;
                    CUdeviceptr kernel_arg_325815 = destmem_0.mem;
                    CUdeviceptr kernel_arg_325816 = srcmem_2.mem;
                    unsigned int shared_offset_325814 = 0;
                    
                    if ((((((1 && sdiv_up32(sdiv_up32(x_elems_5, mulx_7), 16) !=
                             0) && sdiv_up32(y_elems_6, 16) != 0) &&
                           num_arrays_4 != 0) && 16 != 0) && 16 != 0) && 1 !=
                        0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (sdiv_up32(y_elems_6, 16) >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (num_arrays_4 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = sdiv_up32(sdiv_up32(x_elems_5, mulx_7),
                                                  16);
                        grid[perm[1]] = sdiv_up32(y_elems_6, 16);
                        grid[perm[2]] = num_arrays_4;
                        
                        void *kernel_args_325810[] = {&perm[0], &perm[1],
                                                      &perm[2],
                                                      &shared_offset_325814,
                                                      &destoffset_1,
                                                      &srcoffset_3,
                                                      &num_arrays_4, &x_elems_5,
                                                      &y_elems_6, &mulx_7,
                                                      &muly_8,
                                                      &kernel_arg_325815,
                                                      &kernel_arg_325816};
                        int64_t time_start_325811 = 0, time_end_325812 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "gpu_map_transpose_f64_low_height",
                                    (long) sdiv_up32(sdiv_up32(x_elems_5,
                                                               mulx_7), 16),
                                    (long) sdiv_up32(y_elems_6, 16),
                                    (long) num_arrays_4, (long) 16, (long) 16,
                                    (long) 1, (int) (0 + (shared_sizze_325813 +
                                                          (8 -
                                                           shared_sizze_325813 %
                                                           8) % 8)));
                            time_start_325811 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->gpu_map_transpose_f64_low_height_runs,
                                                      &ctx->gpu_map_transpose_f64_low_height_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->gpu_map_transpose_f64_low_height,
                                                              grid[0], grid[1],
                                                              grid[2], 16, 16,
                                                              1, 0 +
                                                              (shared_sizze_325813 +
                                                               (8 -
                                                                shared_sizze_325813 %
                                                                8) % 8), NULL,
                                                              kernel_args_325810,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_325812 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "gpu_map_transpose_f64_low_height",
                                    time_end_325812 - time_start_325811);
                        }
                    }
                } else {
                    if (sle32(x_elems_5, 8) && sle32(y_elems_6, 8)) {
                        unsigned int shared_sizze_325820 = (int64_t) 1;
                        CUdeviceptr kernel_arg_325822 = destmem_0.mem;
                        CUdeviceptr kernel_arg_325823 = srcmem_2.mem;
                        unsigned int shared_offset_325821 = 0;
                        
                        if ((((((1 && sdiv_up32(num_arrays_4 * x_elems_5 *
                                                y_elems_6, 256) != 0) && 1 !=
                                0) && 1 != 0) && 256 != 0) && 1 != 0) && 1 !=
                            0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = sdiv_up32(num_arrays_4 * x_elems_5 *
                                                      y_elems_6, 256);
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_325817[] = {&shared_offset_325821,
                                                          &destoffset_1,
                                                          &srcoffset_3,
                                                          &num_arrays_4,
                                                          &x_elems_5,
                                                          &y_elems_6, &mulx_7,
                                                          &muly_8,
                                                          &kernel_arg_325822,
                                                          &kernel_arg_325823};
                            int64_t time_start_325818 = 0, time_end_325819 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "gpu_map_transpose_f64_small",
                                        (long) sdiv_up32(num_arrays_4 *
                                                         x_elems_5 * y_elems_6,
                                                         256), (long) 1,
                                        (long) 1, (long) 256, (long) 1,
                                        (long) 1, (int) (0 +
                                                         (shared_sizze_325820 +
                                                          (8 -
                                                           shared_sizze_325820 %
                                                           8) % 8)));
                                time_start_325818 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->gpu_map_transpose_f64_small_runs,
                                                          &ctx->gpu_map_transpose_f64_small_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->gpu_map_transpose_f64_small,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2], 256,
                                                                  1, 1, 0 +
                                                                  (shared_sizze_325820 +
                                                                   (8 -
                                                                    shared_sizze_325820 %
                                                                    8) % 8),
                                                                  NULL,
                                                                  kernel_args_325817,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_325819 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "gpu_map_transpose_f64_small",
                                        time_end_325819 - time_start_325818);
                            }
                        }
                    } else {
                        unsigned int shared_sizze_325827 = (int64_t) 8448;
                        CUdeviceptr kernel_arg_325829 = destmem_0.mem;
                        CUdeviceptr kernel_arg_325830 = srcmem_2.mem;
                        unsigned int shared_offset_325828 = 0;
                        
                        if ((((((1 && sdiv_up32(x_elems_5, 32) != 0) &&
                                sdiv_up32(y_elems_6, 32) != 0) &&
                               num_arrays_4 != 0) && 32 != 0) && 8 != 0) && 1 !=
                            0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (sdiv_up32(y_elems_6, 32) >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (num_arrays_4 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = sdiv_up32(x_elems_5, 32);
                            grid[perm[1]] = sdiv_up32(y_elems_6, 32);
                            grid[perm[2]] = num_arrays_4;
                            
                            void *kernel_args_325824[] = {&perm[0], &perm[1],
                                                          &perm[2],
                                                          &shared_offset_325828,
                                                          &destoffset_1,
                                                          &srcoffset_3,
                                                          &num_arrays_4,
                                                          &x_elems_5,
                                                          &y_elems_6, &mulx_7,
                                                          &muly_8,
                                                          &kernel_arg_325829,
                                                          &kernel_arg_325830};
                            int64_t time_start_325825 = 0, time_end_325826 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "gpu_map_transpose_f64",
                                        (long) sdiv_up32(x_elems_5, 32),
                                        (long) sdiv_up32(y_elems_6, 32),
                                        (long) num_arrays_4, (long) 32,
                                        (long) 8, (long) 1, (int) (0 +
                                                                   (shared_sizze_325827 +
                                                                    (8 -
                                                                     shared_sizze_325827 %
                                                                     8) % 8)));
                                time_start_325825 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->gpu_map_transpose_f64_runs,
                                                          &ctx->gpu_map_transpose_f64_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->gpu_map_transpose_f64,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2], 32,
                                                                  8, 1, 0 +
                                                                  (shared_sizze_325827 +
                                                                   (8 -
                                                                    shared_sizze_325827 %
                                                                    8) % 8),
                                                                  NULL,
                                                                  kernel_args_325824,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_325826 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "gpu_map_transpose_f64",
                                        time_end_325826 - time_start_325825);
                            }
                        }
                    }
                }
            }
        }
    }
    
  cleanup:
    { }
    return err;
}
static int futrts_builtinzhgpu_map_transpose_i64(struct futhark_context *ctx,
                                                 struct memblock_device destmem_0,
                                                 int32_t destoffset_1,
                                                 struct memblock_device srcmem_2,
                                                 int32_t srcoffset_3,
                                                 int32_t num_arrays_4,
                                                 int32_t x_elems_5,
                                                 int32_t y_elems_6)
{
    (void) ctx;
    
    int err = 0;
    
    if (!(num_arrays_4 == 0 || (x_elems_5 == 0 || y_elems_6 == 0))) {
        int32_t muly_8 = squot32(16, x_elems_5);
        int32_t mulx_7 = squot32(16, y_elems_6);
        
        if (num_arrays_4 == 1 && (x_elems_5 == 1 || y_elems_6 == 1)) {
            {
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->copy_dev_to_dev_runs,
                                              &ctx->copy_dev_to_dev_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuMemcpy(destmem_0.mem +
                                                sext_i32_i64(destoffset_1),
                                                srcmem_2.mem +
                                                sext_i32_i64(srcoffset_3),
                                                sext_i32_i64(x_elems_5 *
                                                y_elems_6 * 8)));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            }
        } else {
            if (sle32(x_elems_5, 8) && slt32(16, y_elems_6)) {
                unsigned int shared_sizze_325834 = (int64_t) 2176;
                CUdeviceptr kernel_arg_325836 = destmem_0.mem;
                CUdeviceptr kernel_arg_325837 = srcmem_2.mem;
                unsigned int shared_offset_325835 = 0;
                
                if ((((((1 && sdiv_up32(x_elems_5, 16) != 0) &&
                        sdiv_up32(sdiv_up32(y_elems_6, muly_8), 16) != 0) &&
                       num_arrays_4 != 0) && 16 != 0) && 16 != 0) && 1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (sdiv_up32(sdiv_up32(y_elems_6, muly_8), 16) >= 1 <<
                        16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (num_arrays_4 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = sdiv_up32(x_elems_5, 16);
                    grid[perm[1]] = sdiv_up32(sdiv_up32(y_elems_6, muly_8), 16);
                    grid[perm[2]] = num_arrays_4;
                    
                    void *kernel_args_325831[] = {&perm[0], &perm[1], &perm[2],
                                                  &shared_offset_325835,
                                                  &destoffset_1, &srcoffset_3,
                                                  &num_arrays_4, &x_elems_5,
                                                  &y_elems_6, &mulx_7, &muly_8,
                                                  &kernel_arg_325836,
                                                  &kernel_arg_325837};
                    int64_t time_start_325832 = 0, time_end_325833 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "gpu_map_transpose_i64_low_width",
                                (long) sdiv_up32(x_elems_5, 16),
                                (long) sdiv_up32(sdiv_up32(y_elems_6, muly_8),
                                                 16), (long) num_arrays_4,
                                (long) 16, (long) 16, (long) 1, (int) (0 +
                                                                       (shared_sizze_325834 +
                                                                        (8 -
                                                                         shared_sizze_325834 %
                                                                         8) %
                                                                        8)));
                        time_start_325832 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->gpu_map_transpose_i64_low_width_runs,
                                                  &ctx->gpu_map_transpose_i64_low_width_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->gpu_map_transpose_i64_low_width,
                                                          grid[0], grid[1],
                                                          grid[2], 16, 16, 1,
                                                          0 +
                                                          (shared_sizze_325834 +
                                                           (8 -
                                                            shared_sizze_325834 %
                                                            8) % 8), NULL,
                                                          kernel_args_325831,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_325833 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "gpu_map_transpose_i64_low_width",
                                time_end_325833 - time_start_325832);
                    }
                }
            } else {
                if (sle32(y_elems_6, 8) && slt32(16, x_elems_5)) {
                    unsigned int shared_sizze_325841 = (int64_t) 2176;
                    CUdeviceptr kernel_arg_325843 = destmem_0.mem;
                    CUdeviceptr kernel_arg_325844 = srcmem_2.mem;
                    unsigned int shared_offset_325842 = 0;
                    
                    if ((((((1 && sdiv_up32(sdiv_up32(x_elems_5, mulx_7), 16) !=
                             0) && sdiv_up32(y_elems_6, 16) != 0) &&
                           num_arrays_4 != 0) && 16 != 0) && 16 != 0) && 1 !=
                        0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (sdiv_up32(y_elems_6, 16) >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (num_arrays_4 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = sdiv_up32(sdiv_up32(x_elems_5, mulx_7),
                                                  16);
                        grid[perm[1]] = sdiv_up32(y_elems_6, 16);
                        grid[perm[2]] = num_arrays_4;
                        
                        void *kernel_args_325838[] = {&perm[0], &perm[1],
                                                      &perm[2],
                                                      &shared_offset_325842,
                                                      &destoffset_1,
                                                      &srcoffset_3,
                                                      &num_arrays_4, &x_elems_5,
                                                      &y_elems_6, &mulx_7,
                                                      &muly_8,
                                                      &kernel_arg_325843,
                                                      &kernel_arg_325844};
                        int64_t time_start_325839 = 0, time_end_325840 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "gpu_map_transpose_i64_low_height",
                                    (long) sdiv_up32(sdiv_up32(x_elems_5,
                                                               mulx_7), 16),
                                    (long) sdiv_up32(y_elems_6, 16),
                                    (long) num_arrays_4, (long) 16, (long) 16,
                                    (long) 1, (int) (0 + (shared_sizze_325841 +
                                                          (8 -
                                                           shared_sizze_325841 %
                                                           8) % 8)));
                            time_start_325839 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->gpu_map_transpose_i64_low_height_runs,
                                                      &ctx->gpu_map_transpose_i64_low_height_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->gpu_map_transpose_i64_low_height,
                                                              grid[0], grid[1],
                                                              grid[2], 16, 16,
                                                              1, 0 +
                                                              (shared_sizze_325841 +
                                                               (8 -
                                                                shared_sizze_325841 %
                                                                8) % 8), NULL,
                                                              kernel_args_325838,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_325840 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "gpu_map_transpose_i64_low_height",
                                    time_end_325840 - time_start_325839);
                        }
                    }
                } else {
                    if (sle32(x_elems_5, 8) && sle32(y_elems_6, 8)) {
                        unsigned int shared_sizze_325848 = (int64_t) 1;
                        CUdeviceptr kernel_arg_325850 = destmem_0.mem;
                        CUdeviceptr kernel_arg_325851 = srcmem_2.mem;
                        unsigned int shared_offset_325849 = 0;
                        
                        if ((((((1 && sdiv_up32(num_arrays_4 * x_elems_5 *
                                                y_elems_6, 256) != 0) && 1 !=
                                0) && 1 != 0) && 256 != 0) && 1 != 0) && 1 !=
                            0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = sdiv_up32(num_arrays_4 * x_elems_5 *
                                                      y_elems_6, 256);
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_325845[] = {&shared_offset_325849,
                                                          &destoffset_1,
                                                          &srcoffset_3,
                                                          &num_arrays_4,
                                                          &x_elems_5,
                                                          &y_elems_6, &mulx_7,
                                                          &muly_8,
                                                          &kernel_arg_325850,
                                                          &kernel_arg_325851};
                            int64_t time_start_325846 = 0, time_end_325847 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "gpu_map_transpose_i64_small",
                                        (long) sdiv_up32(num_arrays_4 *
                                                         x_elems_5 * y_elems_6,
                                                         256), (long) 1,
                                        (long) 1, (long) 256, (long) 1,
                                        (long) 1, (int) (0 +
                                                         (shared_sizze_325848 +
                                                          (8 -
                                                           shared_sizze_325848 %
                                                           8) % 8)));
                                time_start_325846 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->gpu_map_transpose_i64_small_runs,
                                                          &ctx->gpu_map_transpose_i64_small_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->gpu_map_transpose_i64_small,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2], 256,
                                                                  1, 1, 0 +
                                                                  (shared_sizze_325848 +
                                                                   (8 -
                                                                    shared_sizze_325848 %
                                                                    8) % 8),
                                                                  NULL,
                                                                  kernel_args_325845,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_325847 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "gpu_map_transpose_i64_small",
                                        time_end_325847 - time_start_325846);
                            }
                        }
                    } else {
                        unsigned int shared_sizze_325855 = (int64_t) 8448;
                        CUdeviceptr kernel_arg_325857 = destmem_0.mem;
                        CUdeviceptr kernel_arg_325858 = srcmem_2.mem;
                        unsigned int shared_offset_325856 = 0;
                        
                        if ((((((1 && sdiv_up32(x_elems_5, 32) != 0) &&
                                sdiv_up32(y_elems_6, 32) != 0) &&
                               num_arrays_4 != 0) && 32 != 0) && 8 != 0) && 1 !=
                            0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (sdiv_up32(y_elems_6, 32) >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (num_arrays_4 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = sdiv_up32(x_elems_5, 32);
                            grid[perm[1]] = sdiv_up32(y_elems_6, 32);
                            grid[perm[2]] = num_arrays_4;
                            
                            void *kernel_args_325852[] = {&perm[0], &perm[1],
                                                          &perm[2],
                                                          &shared_offset_325856,
                                                          &destoffset_1,
                                                          &srcoffset_3,
                                                          &num_arrays_4,
                                                          &x_elems_5,
                                                          &y_elems_6, &mulx_7,
                                                          &muly_8,
                                                          &kernel_arg_325857,
                                                          &kernel_arg_325858};
                            int64_t time_start_325853 = 0, time_end_325854 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "gpu_map_transpose_i64",
                                        (long) sdiv_up32(x_elems_5, 32),
                                        (long) sdiv_up32(y_elems_6, 32),
                                        (long) num_arrays_4, (long) 32,
                                        (long) 8, (long) 1, (int) (0 +
                                                                   (shared_sizze_325855 +
                                                                    (8 -
                                                                     shared_sizze_325855 %
                                                                     8) % 8)));
                                time_start_325853 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->gpu_map_transpose_i64_runs,
                                                          &ctx->gpu_map_transpose_i64_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->gpu_map_transpose_i64,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2], 32,
                                                                  8, 1, 0 +
                                                                  (shared_sizze_325855 +
                                                                   (8 -
                                                                    shared_sizze_325855 %
                                                                    8) % 8),
                                                                  NULL,
                                                                  kernel_args_325852,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_325854 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "gpu_map_transpose_i64",
                                        time_end_325854 - time_start_325853);
                            }
                        }
                    }
                }
            }
        }
    }
    
  cleanup:
    { }
    return err;
}
static int futrts_builtinzhreplicate_f32(struct futhark_context *ctx,
                                         struct memblock_device mem_325742,
                                         int32_t num_elems_325743,
                                         float val_325744)
{
    (void) ctx;
    
    int err = 0;
    int64_t group_sizze_325749;
    
    group_sizze_325749 =
        *ctx->tuning_params.builtinzhreplicate_f32zigroup_sizze_325749;
    
    int64_t num_groups_325750 = sdiv_up64(num_elems_325743, group_sizze_325749);
    CUdeviceptr kernel_arg_325862 = mem_325742.mem;
    
    if ((((((1 && num_groups_325750 != 0) && 1 != 0) && 1 != 0) &&
          group_sizze_325749 != 0) && 1 != 0) && 1 != 0) {
        int perm[3] = {0, 1, 2};
        
        if (1 >= 1 << 16) {
            perm[1] = perm[0];
            perm[0] = 1;
        }
        if (1 >= 1 << 16) {
            perm[2] = perm[0];
            perm[0] = 2;
        }
        
        size_t grid[3];
        
        grid[perm[0]] = num_groups_325750;
        grid[perm[1]] = 1;
        grid[perm[2]] = 1;
        
        void *kernel_args_325859[] = {&num_elems_325743, &val_325744,
                                      &kernel_arg_325862};
        int64_t time_start_325860 = 0, time_end_325861 = 0;
        
        if (ctx->debugging) {
            fprintf(ctx->log,
                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                    "builtin#replicate_f32.replicate_325746",
                    (long) num_groups_325750, (long) 1, (long) 1,
                    (long) group_sizze_325749, (long) 1, (long) 1, (int) 0);
            time_start_325860 = get_wall_time();
        }
        
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda,
                                      &ctx->builtinzhreplicate_f32zireplicate_325746_runs,
                                      &ctx->builtinzhreplicate_f32zireplicate_325746_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->builtinzhreplicate_f32zireplicate_325746,
                                              grid[0], grid[1], grid[2],
                                              group_sizze_325749, 1, 1, 0, NULL,
                                              kernel_args_325859, NULL));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
        if (ctx->debugging) {
            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
            time_end_325861 = get_wall_time();
            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                    "builtin#replicate_f32.replicate_325746", time_end_325861 -
                    time_start_325860);
        }
    }
    
  cleanup:
    { }
    return err;
}
static int futrts_builtinzhreplicate_f64(struct futhark_context *ctx,
                                         struct memblock_device mem_321582,
                                         int32_t num_elems_321583,
                                         double val_321584)
{
    (void) ctx;
    
    int err = 0;
    int64_t group_sizze_321589;
    
    group_sizze_321589 =
        *ctx->tuning_params.builtinzhreplicate_f64zigroup_sizze_321589;
    
    int64_t num_groups_321590 = sdiv_up64(num_elems_321583, group_sizze_321589);
    CUdeviceptr kernel_arg_325866 = mem_321582.mem;
    
    if ((((((1 && num_groups_321590 != 0) && 1 != 0) && 1 != 0) &&
          group_sizze_321589 != 0) && 1 != 0) && 1 != 0) {
        int perm[3] = {0, 1, 2};
        
        if (1 >= 1 << 16) {
            perm[1] = perm[0];
            perm[0] = 1;
        }
        if (1 >= 1 << 16) {
            perm[2] = perm[0];
            perm[0] = 2;
        }
        
        size_t grid[3];
        
        grid[perm[0]] = num_groups_321590;
        grid[perm[1]] = 1;
        grid[perm[2]] = 1;
        
        void *kernel_args_325863[] = {&num_elems_321583, &val_321584,
                                      &kernel_arg_325866};
        int64_t time_start_325864 = 0, time_end_325865 = 0;
        
        if (ctx->debugging) {
            fprintf(ctx->log,
                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                    "builtin#replicate_f64.replicate_321586",
                    (long) num_groups_321590, (long) 1, (long) 1,
                    (long) group_sizze_321589, (long) 1, (long) 1, (int) 0);
            time_start_325864 = get_wall_time();
        }
        
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda,
                                      &ctx->builtinzhreplicate_f64zireplicate_321586_runs,
                                      &ctx->builtinzhreplicate_f64zireplicate_321586_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->builtinzhreplicate_f64zireplicate_321586,
                                              grid[0], grid[1], grid[2],
                                              group_sizze_321589, 1, 1, 0, NULL,
                                              kernel_args_325863, NULL));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
        if (ctx->debugging) {
            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
            time_end_325865 = get_wall_time();
            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                    "builtin#replicate_f64.replicate_321586", time_end_325865 -
                    time_start_325864);
        }
    }
    
  cleanup:
    { }
    return err;
}
static int futrts_builtinzhreplicate_i32(struct futhark_context *ctx,
                                         struct memblock_device mem_325099,
                                         int32_t num_elems_325100,
                                         int32_t val_325101)
{
    (void) ctx;
    
    int err = 0;
    int64_t group_sizze_325106;
    
    group_sizze_325106 =
        *ctx->tuning_params.builtinzhreplicate_i32zigroup_sizze_325106;
    
    int64_t num_groups_325107 = sdiv_up64(num_elems_325100, group_sizze_325106);
    CUdeviceptr kernel_arg_325870 = mem_325099.mem;
    
    if ((((((1 && num_groups_325107 != 0) && 1 != 0) && 1 != 0) &&
          group_sizze_325106 != 0) && 1 != 0) && 1 != 0) {
        int perm[3] = {0, 1, 2};
        
        if (1 >= 1 << 16) {
            perm[1] = perm[0];
            perm[0] = 1;
        }
        if (1 >= 1 << 16) {
            perm[2] = perm[0];
            perm[0] = 2;
        }
        
        size_t grid[3];
        
        grid[perm[0]] = num_groups_325107;
        grid[perm[1]] = 1;
        grid[perm[2]] = 1;
        
        void *kernel_args_325867[] = {&num_elems_325100, &val_325101,
                                      &kernel_arg_325870};
        int64_t time_start_325868 = 0, time_end_325869 = 0;
        
        if (ctx->debugging) {
            fprintf(ctx->log,
                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                    "builtin#replicate_i32.replicate_325103",
                    (long) num_groups_325107, (long) 1, (long) 1,
                    (long) group_sizze_325106, (long) 1, (long) 1, (int) 0);
            time_start_325868 = get_wall_time();
        }
        
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda,
                                      &ctx->builtinzhreplicate_i32zireplicate_325103_runs,
                                      &ctx->builtinzhreplicate_i32zireplicate_325103_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->builtinzhreplicate_i32zireplicate_325103,
                                              grid[0], grid[1], grid[2],
                                              group_sizze_325106, 1, 1, 0, NULL,
                                              kernel_args_325867, NULL));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
        if (ctx->debugging) {
            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
            time_end_325869 = get_wall_time();
            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                    "builtin#replicate_i32.replicate_325103", time_end_325869 -
                    time_start_325868);
        }
    }
    
  cleanup:
    { }
    return err;
}
static int futrts_builtinzhreplicate_i64(struct futhark_context *ctx,
                                         struct memblock_device mem_321082,
                                         int32_t num_elems_321083,
                                         int64_t val_321084)
{
    (void) ctx;
    
    int err = 0;
    int64_t group_sizze_321089;
    
    group_sizze_321089 =
        *ctx->tuning_params.builtinzhreplicate_i64zigroup_sizze_321089;
    
    int64_t num_groups_321090 = sdiv_up64(num_elems_321083, group_sizze_321089);
    CUdeviceptr kernel_arg_325874 = mem_321082.mem;
    
    if ((((((1 && num_groups_321090 != 0) && 1 != 0) && 1 != 0) &&
          group_sizze_321089 != 0) && 1 != 0) && 1 != 0) {
        int perm[3] = {0, 1, 2};
        
        if (1 >= 1 << 16) {
            perm[1] = perm[0];
            perm[0] = 1;
        }
        if (1 >= 1 << 16) {
            perm[2] = perm[0];
            perm[0] = 2;
        }
        
        size_t grid[3];
        
        grid[perm[0]] = num_groups_321090;
        grid[perm[1]] = 1;
        grid[perm[2]] = 1;
        
        void *kernel_args_325871[] = {&num_elems_321083, &val_321084,
                                      &kernel_arg_325874};
        int64_t time_start_325872 = 0, time_end_325873 = 0;
        
        if (ctx->debugging) {
            fprintf(ctx->log,
                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                    "builtin#replicate_i64.replicate_321086",
                    (long) num_groups_321090, (long) 1, (long) 1,
                    (long) group_sizze_321089, (long) 1, (long) 1, (int) 0);
            time_start_325872 = get_wall_time();
        }
        
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda,
                                      &ctx->builtinzhreplicate_i64zireplicate_321086_runs,
                                      &ctx->builtinzhreplicate_i64zireplicate_321086_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->builtinzhreplicate_i64zireplicate_321086,
                                              grid[0], grid[1], grid[2],
                                              group_sizze_321089, 1, 1, 0, NULL,
                                              kernel_args_325871, NULL));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
        if (ctx->debugging) {
            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
            time_end_325873 = get_wall_time();
            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                    "builtin#replicate_i64.replicate_321086", time_end_325873 -
                    time_start_325872);
        }
    }
    
  cleanup:
    { }
    return err;
}
static int futrts_builtinzhreplicate_i8(struct futhark_context *ctx,
                                        struct memblock_device mem_320837,
                                        int32_t num_elems_320838,
                                        int8_t val_320839)
{
    (void) ctx;
    
    int err = 0;
    int64_t group_sizze_320844;
    
    group_sizze_320844 =
        *ctx->tuning_params.builtinzhreplicate_i8zigroup_sizze_320844;
    
    int64_t num_groups_320845 = sdiv_up64(num_elems_320838, group_sizze_320844);
    CUdeviceptr kernel_arg_325878 = mem_320837.mem;
    
    if ((((((1 && num_groups_320845 != 0) && 1 != 0) && 1 != 0) &&
          group_sizze_320844 != 0) && 1 != 0) && 1 != 0) {
        int perm[3] = {0, 1, 2};
        
        if (1 >= 1 << 16) {
            perm[1] = perm[0];
            perm[0] = 1;
        }
        if (1 >= 1 << 16) {
            perm[2] = perm[0];
            perm[0] = 2;
        }
        
        size_t grid[3];
        
        grid[perm[0]] = num_groups_320845;
        grid[perm[1]] = 1;
        grid[perm[2]] = 1;
        
        void *kernel_args_325875[] = {&num_elems_320838, &val_320839,
                                      &kernel_arg_325878};
        int64_t time_start_325876 = 0, time_end_325877 = 0;
        
        if (ctx->debugging) {
            fprintf(ctx->log,
                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                    "builtin#replicate_i8.replicate_320841",
                    (long) num_groups_320845, (long) 1, (long) 1,
                    (long) group_sizze_320844, (long) 1, (long) 1, (int) 0);
            time_start_325876 = get_wall_time();
        }
        
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda,
                                      &ctx->builtinzhreplicate_i8zireplicate_320841_runs,
                                      &ctx->builtinzhreplicate_i8zireplicate_320841_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->builtinzhreplicate_i8zireplicate_320841,
                                              grid[0], grid[1], grid[2],
                                              group_sizze_320844, 1, 1, 0, NULL,
                                              kernel_args_325875, NULL));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
        if (ctx->debugging) {
            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
            time_end_325877 = get_wall_time();
            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                    "builtin#replicate_i8.replicate_320841", time_end_325877 -
                    time_start_325876);
        }
    }
    
  cleanup:
    { }
    return err;
}
static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock_device *mem_out_p_325879,
                             struct memblock_device *mem_out_p_325880,
                             struct memblock_device *mem_out_p_325881,
                             struct memblock_device Y_mem_318490,
                             int64_t m_292674, int64_t n_292675,
                             int64_t n_p_292677, int64_t q_s_292678,
                             int64_t q_t_292679, int64_t q_l_292680,
                             int64_t d_s_292681, int64_t d_t_292682,
                             int64_t d_l_292683, int64_t jump_s_292684,
                             int64_t jump_t_292685, int64_t jump_l_292686,
                             int64_t n_inner_292687, int64_t n_outer_292688,
                             int64_t jump_threshold_1_292689,
                             int64_t jump_threshold_2_292690,
                             int64_t q_threshold_1_292691,
                             int64_t q_threshold_2_292692)
{
    (void) ctx;
    
    int err = 0;
    struct memblock_device mem_out_320823;
    
    mem_out_320823.references = NULL;
    
    struct memblock_device mem_out_320824;
    
    mem_out_320824.references = NULL;
    
    struct memblock_device mem_out_320825;
    
    mem_out_320825.references = NULL;
    
    double i64_res_292693 = sitofp_i64_f64(n_292675);
    double i64_res_292694 = sitofp_i64_f64(n_p_292677);
    double ceil_arg_292695 = i64_res_292693 / i64_res_292694;
    double ceil_res_292696;
    
    ceil_res_292696 = futrts_ceil64(ceil_arg_292695);
    
    int64_t defunc_0_f_res_292697 = fptosi_f64_i64(ceil_res_292696);
    bool bounds_invalid_upwards_292698 = slt64(n_p_292677, (int64_t) 0);
    bool valid_292699 = !bounds_invalid_upwards_292698;
    bool range_valid_c_292700;
    
    if (!valid_292699) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) n_p_292677, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:407:29-412:37\n   #4  stl.fut:406:22-413:28\n   #5  stl.fut:463:3-479:36\n   #6  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_292702 = slt64(defunc_0_f_res_292697,
                                               (int64_t) 0);
    bool valid_292703 = !bounds_invalid_upwards_292702;
    bool range_valid_c_292704;
    
    if (!valid_292703) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) defunc_0_f_res_292697,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:408:36-411:52\n   #4  /prelude/soacs.fut:59:3-10\n   #5  /prelude/array.fut:195:3-17\n   #6  utils.fut:6:3-16\n   #7  stl.fut:407:29-412:37\n   #8  stl.fut:406:22-413:28\n   #9  stl.fut:463:3-479:36\n   #10 stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t segscan_group_sizze_297610;
    
    segscan_group_sizze_297610 =
        *ctx->tuning_params.mainzisegscan_group_sizze_297609;
    
    int64_t num_groups_297612;
    int32_t max_num_groups_320826;
    
    max_num_groups_320826 = *ctx->tuning_params.mainzisegscan_num_groups_297611;
    num_groups_297612 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(m_292674,
                                                             segscan_group_sizze_297610),
                                                   sext_i32_i64(max_num_groups_320826))));
    
    int64_t binop_x_318491 = m_292674 * n_292675;
    int64_t bytes_318492 = (int64_t) 4 * binop_x_318491;
    struct memblock_device mem_318493;
    
    mem_318493.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318493, bytes_318492, "mem_318493")) {
        err = 1;
        goto cleanup;
    }
    if (futrts_builtinzhgpu_map_transpose_f32(ctx, mem_318493, (int64_t) 0,
                                              Y_mem_318490, (int64_t) 0,
                                              (int64_t) 1, n_292675,
                                              m_292674) != 0) {
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_y_318495 = (int64_t) 8 * m_292674;
    int64_t bytes_318496 = smax64((int64_t) 0, binop_y_318495);
    struct memblock_device mem_318497;
    
    mem_318497.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318497, bytes_318496, "mem_318497")) {
        err = 1;
        goto cleanup;
    }
    
    struct memblock_device mem_318500;
    
    mem_318500.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318500, bytes_318496, "mem_318500")) {
        err = 1;
        goto cleanup;
    }
    
    int64_t bytes_318501 = smax64((int64_t) 0, m_292674);
    struct memblock_device mem_318502;
    
    mem_318502.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318502, bytes_318501, "mem_318502")) {
        err = 1;
        goto cleanup;
    }
    if (slt64((int64_t) 0, m_292674)) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegScan");
        if (ctx->debugging)
            fprintf(ctx->log, "%s: %llu%c",
                    "SegScan: number of elements processed sequentially per thread is m:",
                    (long long) 11, '\n');
        if (ctx->debugging)
            fprintf(ctx->log, "%s: %llu%c", "SegScan: memory constraints is: ",
                    (long long) 11, '\n');
        if (ctx->debugging)
            fprintf(ctx->log, "%s: %llu%c",
                    "SegScan: register constraints is: ", (long long) 15, '\n');
        if (ctx->debugging)
            fprintf(ctx->log, "%s: %llu%c", "SegScan: sumT' is: ",
                    (long long) 2, '\n');
        
        int64_t numThreads_320827 = sdiv_up64(m_292674,
                                              segscan_group_sizze_297610 *
                                              (int64_t) 11) *
                segscan_group_sizze_297610;
        int64_t numGroups_320828 = sdiv_up64(m_292674,
                                             segscan_group_sizze_297610 *
                                             (int64_t) 11);
        struct memblock_device mainziid_counter_mem_320829 =
                               ctx->mainziid_counter_mem_320829;
        struct memblock_device status_flags_mem_320831;
        
        status_flags_mem_320831.references = NULL;
        if (memblock_alloc_device(ctx, &status_flags_mem_320831,
                                  numGroups_320828,
                                  "status_flags_mem_320831")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device aggregates_mem_320833;
        
        aggregates_mem_320833.references = NULL;
        if (memblock_alloc_device(ctx, &aggregates_mem_320833, (int64_t) 8 *
                                  numGroups_320828, "aggregates_mem_320833")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device incprefixes_mem_320835;
        
        incprefixes_mem_320835.references = NULL;
        if (memblock_alloc_device(ctx, &incprefixes_mem_320835, (int64_t) 8 *
                                  numGroups_320828, "incprefixes_mem_320835")) {
            err = 1;
            goto cleanup;
        }
        if (futrts_builtinzhreplicate_i8(ctx, status_flags_mem_320831,
                                         numGroups_320828, (int8_t) 0) != 0) {
            if (memblock_unref_device(ctx, &incprefixes_mem_320835,
                                      "incprefixes_mem_320835") != 0)
                return 1;
            if (memblock_unref_device(ctx, &aggregates_mem_320833,
                                      "aggregates_mem_320833") != 0)
                return 1;
            if (memblock_unref_device(ctx, &status_flags_mem_320831,
                                      "status_flags_mem_320831") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") !=
                0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        unsigned int shared_sizze_325886 = smax64(smax64((int64_t) 288,
                                                         (int64_t) 8 *
                                                         segscan_group_sizze_297610),
                                                  (int64_t) 11 *
                                                  segscan_group_sizze_297610 *
                                                  (int64_t) 8);
        CUdeviceptr kernel_arg_325888 = mem_318493.mem;
        CUdeviceptr kernel_arg_325889 = mem_318497.mem;
        CUdeviceptr kernel_arg_325890 = mem_318500.mem;
        CUdeviceptr kernel_arg_325891 = mem_318502.mem;
        CUdeviceptr kernel_arg_325892 = mainziid_counter_mem_320829.mem;
        CUdeviceptr kernel_arg_325893 = status_flags_mem_320831.mem;
        CUdeviceptr kernel_arg_325894 = aggregates_mem_320833.mem;
        CUdeviceptr kernel_arg_325895 = incprefixes_mem_320835.mem;
        unsigned int shared_offset_325887 = 0;
        
        if ((((((1 && sdiv_up64(m_292674, segscan_group_sizze_297610 *
                                (int64_t) 11) != 0) && 1 != 0) && 1 != 0) &&
              segscan_group_sizze_297610 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = sdiv_up64(m_292674, segscan_group_sizze_297610 *
                                      (int64_t) 11);
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_325883[] = {&ctx->global_failure,
                                          &ctx->failure_is_an_option,
                                          &ctx->global_failure_args,
                                          &shared_offset_325887, &m_292674,
                                          &n_292675, &n_p_292677,
                                          &defunc_0_f_res_292697,
                                          &kernel_arg_325888,
                                          &kernel_arg_325889,
                                          &kernel_arg_325890,
                                          &kernel_arg_325891,
                                          &kernel_arg_325892,
                                          &kernel_arg_325893,
                                          &kernel_arg_325894,
                                          &kernel_arg_325895};
            int64_t time_start_325884 = 0, time_end_325885 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segscan_297615", (long) sdiv_up64(m_292674,
                                                                segscan_group_sizze_297610 *
                                                                (int64_t) 11),
                        (long) 1, (long) 1, (long) segscan_group_sizze_297610,
                        (long) 1, (long) 1, (int) (0 + (shared_sizze_325886 +
                                                        (8 -
                                                         shared_sizze_325886 %
                                                         8) % 8)));
                time_start_325884 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegscan_297615_runs,
                                          &ctx->mainzisegscan_297615_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegscan_297615,
                                                  grid[0], grid[1], grid[2],
                                                  segscan_group_sizze_297610, 1,
                                                  1, 0 + (shared_sizze_325886 +
                                                          (8 -
                                                           shared_sizze_325886 %
                                                           8) % 8), NULL,
                                                  kernel_args_325883, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_325885 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segscan_297615", time_end_325885 -
                        time_start_325884);
            }
        }
        ctx->failure_is_an_option = 1;
        if (memblock_unref_device(ctx, &incprefixes_mem_320835,
                                  "incprefixes_mem_320835") != 0)
            return 1;
        if (memblock_unref_device(ctx, &aggregates_mem_320833,
                                  "aggregates_mem_320833") != 0)
            return 1;
        if (memblock_unref_device(ctx, &status_flags_mem_320831,
                                  "status_flags_mem_320831") != 0)
            return 1;
    }
    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
        return 1;
    
    int64_t last_index_292764 = m_292674 - (int64_t) 1;
    bool is_empty_292765 = m_292674 == (int64_t) 0;
    int64_t partition_sizze_292766;
    
    if (is_empty_292765) {
        partition_sizze_292766 = (int64_t) 0;
    } else {
        int64_t last_offset_292767;
        int64_t read_res_325896;
        
        {
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->copy_scalar_from_dev_runs,
                                          &ctx->copy_scalar_from_dev_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuMemcpyDtoH(&read_res_325896,
                                                mem_318497.mem +
                                                last_index_292764 *
                                                sizeof(int64_t),
                                                sizeof(int64_t)));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
        }
        if (futhark_context_sync(ctx) != 0)
            return 1;
        last_offset_292767 = read_res_325896;
        partition_sizze_292766 = last_offset_292767;
    }
    
    int64_t bytes_318505 = smax64((int64_t) 0, bytes_318492);
    struct memblock_device mem_318506;
    
    mem_318506.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318506, bytes_318505, "mem_318506")) {
        err = 1;
        goto cleanup;
    }
    
    struct memblock_device mem_318509;
    
    mem_318509.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318509, bytes_318496, "mem_318509")) {
        err = 1;
        goto cleanup;
    }
    
    int64_t segmap_group_sizze_297620;
    
    segmap_group_sizze_297620 =
        *ctx->tuning_params.mainzisegmap_group_sizze_297619;
    
    int64_t num_groups_297622;
    int32_t max_num_groups_320936;
    
    max_num_groups_320936 = *ctx->tuning_params.mainzisegmap_num_groups_297621;
    num_groups_297622 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(m_292674,
                                                             segmap_group_sizze_297620),
                                                   sext_i32_i64(max_num_groups_320936))));
    if (ctx->debugging)
        fprintf(ctx->log, "%s\n", "\n# SegMap");
    
    CUdeviceptr kernel_arg_325900 = mem_318493.mem;
    CUdeviceptr kernel_arg_325901 = mem_318497.mem;
    CUdeviceptr kernel_arg_325902 = mem_318500.mem;
    CUdeviceptr kernel_arg_325903 = mem_318506.mem;
    CUdeviceptr kernel_arg_325904 = mem_318509.mem;
    
    if ((((((1 && num_groups_297622 != 0) && 1 != 0) && 1 != 0) &&
          segmap_group_sizze_297620 != 0) && 1 != 0) && 1 != 0) {
        int perm[3] = {0, 1, 2};
        
        if (1 >= 1 << 16) {
            perm[1] = perm[0];
            perm[0] = 1;
        }
        if (1 >= 1 << 16) {
            perm[2] = perm[0];
            perm[0] = 2;
        }
        
        size_t grid[3];
        
        grid[perm[0]] = num_groups_297622;
        grid[perm[1]] = 1;
        grid[perm[2]] = 1;
        
        void *kernel_args_325897[] = {&ctx->global_failure, &m_292674,
                                      &n_292675, &num_groups_297622,
                                      &kernel_arg_325900, &kernel_arg_325901,
                                      &kernel_arg_325902, &kernel_arg_325903,
                                      &kernel_arg_325904};
        int64_t time_start_325898 = 0, time_end_325899 = 0;
        
        if (ctx->debugging) {
            fprintf(ctx->log,
                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                    "main.segmap_297617", (long) num_groups_297622, (long) 1,
                    (long) 1, (long) segmap_group_sizze_297620, (long) 1,
                    (long) 1, (int) 0);
            time_start_325898 = get_wall_time();
        }
        
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda,
                                      &ctx->mainzisegmap_297617_runs,
                                      &ctx->mainzisegmap_297617_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_297617, grid[0],
                                              grid[1], grid[2],
                                              segmap_group_sizze_297620, 1, 1,
                                              0, NULL, kernel_args_325897,
                                              NULL));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
        if (ctx->debugging) {
            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
            time_end_325899 = get_wall_time();
            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                    "main.segmap_297617", time_end_325899 - time_start_325898);
        }
    }
    if (ctx->debugging)
        fprintf(ctx->log, "%s\n", "");
    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
        return 1;
    
    bool empty_slice_292780 = partition_sizze_292766 == (int64_t) 0;
    int64_t m_292781 = sub64(partition_sizze_292766, (int64_t) 1);
    bool zzero_leq_i_p_m_t_s_292782 = sle64((int64_t) 0, m_292781);
    bool i_p_m_t_s_leq_w_292783 = slt64(m_292781, m_292674);
    bool i_lte_j_292784 = sle64((int64_t) 0, partition_sizze_292766);
    bool y_292785 = zzero_leq_i_p_m_t_s_292782 && i_p_m_t_s_leq_w_292783;
    bool y_292786 = i_lte_j_292784 && y_292785;
    bool ok_or_empty_292787 = empty_slice_292780 || y_292786;
    bool index_certs_292788;
    
    if (!ok_or_empty_292787) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) partition_sizze_292766,
                               "] out of bounds for array of shape [",
                               (long long) m_292674, "].",
                               "-> #0  /prelude/soacs.fut:163:6-16\n   #1  stl.fut:416:7-66\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292791 = sle64((int64_t) 4, n_p_292677);
    bool assert_c_292792;
    
    if (!assert_cond_292791) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (n_p >= 4)",
                               "-> #0  stl.fut:74:13-33\n   #1  stl.fut:419:61-435:77\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t x_292793 = smod64(q_t_292679, (int64_t) 2);
    bool assert_cond_292794 = x_292793 == (int64_t) 1;
    bool assert_c_292795;
    
    if (!assert_cond_292794) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x % 2 == 1)",
                               "-> #0  utils.fut:20:3-23\n   #1  /prelude/functional.fut:39:62-64\n   #2  stl.fut:76:13-25\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292796 = slt64((int64_t) 0, q_t_292679);
    bool assert_c_292797;
    
    if (!assert_cond_292796) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  /prelude/functional.fut:39:59-65\n   #2  stl.fut:76:13-25\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t x_292798 = smod64(q_l_292680, (int64_t) 2);
    bool assert_cond_292799 = x_292798 == (int64_t) 1;
    bool assert_c_292800;
    
    if (!assert_cond_292799) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x % 2 == 1)",
                               "-> #0  utils.fut:20:3-23\n   #1  /prelude/functional.fut:39:62-64\n   #2  stl.fut:77:13-25\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292801 = slt64((int64_t) 0, q_l_292680);
    bool assert_c_292802;
    
    if (!assert_cond_292801) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  /prelude/functional.fut:39:59-65\n   #2  stl.fut:77:13-25\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool cond_292803 = sle64((int64_t) 0, d_t_292682);
    bool assert_cond_t_res_292804 = sle64(d_t_292682, (int64_t) 2);
    bool x_292805 = cond_292803 && assert_cond_t_res_292804;
    bool assert_c_292806;
    
    if (!x_292805) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x >= 0 && x <= 2)",
                               "-> #0  utils.fut:23:3-29\n   #1  stl.fut:79:13-25\n   #2  stl.fut:419:61-435:77\n   #3  stl.fut:463:3-479:36\n   #4  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool cond_292807 = sle64((int64_t) 0, d_l_292683);
    bool assert_cond_t_res_292808 = sle64(d_l_292683, (int64_t) 2);
    bool x_292809 = cond_292807 && assert_cond_t_res_292808;
    bool assert_c_292810;
    
    if (!x_292809) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x >= 0 && x <= 2)",
                               "-> #0  utils.fut:23:3-29\n   #1  stl.fut:80:13-25\n   #2  stl.fut:419:61-435:77\n   #3  stl.fut:463:3-479:36\n   #4  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292811 = slt64((int64_t) 0, jump_t_292685);
    bool assert_c_292812;
    
    if (!assert_cond_292811) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:82:16-31\n   #2  stl.fut:419:61-435:77\n   #3  stl.fut:463:3-479:36\n   #4  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292813 = slt64((int64_t) 0, jump_l_292686);
    bool assert_c_292814;
    
    if (!assert_cond_292813) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:83:16-31\n   #2  stl.fut:419:61-435:77\n   #3  stl.fut:463:3-479:36\n   #4  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292815 = slt64((int64_t) 0, n_inner_292687);
    bool assert_c_292816;
    
    if (!assert_cond_292815) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:85:17-33\n   #2  stl.fut:419:61-435:77\n   #3  stl.fut:463:3-479:36\n   #4  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292817 = slt64((int64_t) 0, n_outer_292688);
    bool assert_c_292818;
    
    if (!assert_cond_292817) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:86:17-33\n   #2  stl.fut:419:61-435:77\n   #3  stl.fut:463:3-479:36\n   #4  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    double ceil_res_292819;
    
    ceil_res_292819 = futrts_ceil64(ceil_arg_292695);
    
    int64_t defunc_0_f_res_292820 = fptosi_f64_i64(ceil_res_292819);
    int64_t pad_css_len_292821 = add64((int64_t) 2, defunc_0_f_res_292820);
    int64_t y_292822 = mul64((int64_t) 2, n_p_292677);
    int64_t C_len_292823 = add64(n_292675, y_292822);
    bool cond_292824 = jump_s_292684 == (int64_t) 1;
    int64_t s_n_m_292825;
    
    if (cond_292824) {
        s_n_m_292825 = pad_css_len_292821;
    } else {
        bool zzero_292826 = jump_s_292684 == (int64_t) 0;
        bool nonzzero_292827 = !zzero_292826;
        bool nonzzero_cert_292828;
        
        if (!nonzzero_292827) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:93:52-71\n   #1  stl.fut:419:61-435:77\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
            if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") !=
                0)
                return 1;
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        int64_t x_292829 = sdiv64(defunc_0_f_res_292820, jump_s_292684);
        int64_t s_n_m_f_res_292830 = add64((int64_t) 3, x_292829);
        
        s_n_m_292825 = s_n_m_f_res_292830;
    }
    
    bool cond_292831 = jump_l_292686 == (int64_t) 1;
    int64_t l_n_m_292832;
    
    if (cond_292831) {
        l_n_m_292832 = n_292675;
    } else {
        bool zzero_292833 = jump_l_292686 == (int64_t) 0;
        bool nonzzero_292834 = !zzero_292833;
        bool nonzzero_cert_292835;
        
        if (!nonzzero_292834) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:99:42-51\n   #1  stl.fut:419:61-435:77\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
            if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") !=
                0)
                return 1;
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        int64_t x_292836 = sdiv64(n_292675, jump_l_292686);
        int64_t l_n_m_f_res_292837 = add64((int64_t) 1, x_292836);
        
        l_n_m_292832 = l_n_m_f_res_292837;
    }
    
    bool cond_292838 = jump_t_292685 == (int64_t) 1;
    int64_t t_n_m_292839;
    
    if (cond_292838) {
        t_n_m_292839 = n_292675;
    } else {
        bool zzero_292840 = jump_t_292685 == (int64_t) 0;
        bool nonzzero_292841 = !zzero_292840;
        bool nonzzero_cert_292842;
        
        if (!nonzzero_292841) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:103:42-51\n   #1  stl.fut:419:61-435:77\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
            if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") !=
                0)
                return 1;
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        int64_t x_292843 = sdiv64(n_292675, jump_t_292685);
        int64_t t_n_m_f_res_292844 = add64((int64_t) 1, x_292843);
        
        t_n_m_292839 = t_n_m_f_res_292844;
    }
    
    int64_t i_292846 = sub64(n_292675, (int64_t) 1);
    bool x_292847 = sle64((int64_t) 0, i_292846);
    bool y_292848 = slt64(i_292846, n_292675);
    bool bounds_check_292849 = x_292847 && y_292848;
    bool index_certs_292850;
    
    if (!bounds_check_292849) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) i_292846,
                               "] out of bounds for array of shape [",
                               (long long) n_292675, "].",
                               "-> #0  /prelude/array.fut:26:29-34\n   #1  utils.fut:45:13-20\n   #2  stl.fut:110:31-51\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t max_group_sizze_297635;
    
    max_group_sizze_297635 = ctx->cuda.max_block_size;
    
    bool fits_297636 = sle64(n_292675, max_group_sizze_297635);
    bool suff_intra_par_297634;
    
    suff_intra_par_297634 = *ctx->tuning_params.mainzisuff_intra_par_0 <=
        n_292675;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n", "main.suff_intra_par_0",
                (long) n_292675, suff_intra_par_297634 ? "true" : "false");
    
    bool intra_suff_and_fits_297637 = suff_intra_par_297634 && fits_297636;
    int64_t nest_sizze_297748 = n_292675 * partition_sizze_292766;
    int64_t segscan_group_sizze_297749;
    
    segscan_group_sizze_297749 =
        *ctx->tuning_params.mainzisegscan_group_sizze_297729;
    
    int64_t num_groups_297750;
    int32_t max_num_groups_320950;
    
    max_num_groups_320950 = *ctx->tuning_params.mainzisegscan_num_groups_297731;
    num_groups_297750 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(nest_sizze_297748,
                                                             segscan_group_sizze_297749),
                                                   sext_i32_i64(max_num_groups_320950))));
    
    int64_t segmap_group_sizze_297788;
    
    segmap_group_sizze_297788 =
        *ctx->tuning_params.mainzisegmap_group_sizze_297673;
    
    int64_t binop_y_318521 = (int64_t) 8 * nest_sizze_297748;
    int64_t bytes_318522 = smax64((int64_t) 0, binop_y_318521);
    int64_t binop_y_318524 = (int64_t) 8 * partition_sizze_292766;
    int64_t bytes_318525 = smax64((int64_t) 0, binop_y_318524);
    int64_t binop_y_318513 = (int64_t) 8 * n_292675;
    int64_t bytes_318514 = smax64((int64_t) 0, binop_y_318513);
    struct memblock_device ext_mem_318542;
    
    ext_mem_318542.references = NULL;
    
    struct memblock_device ext_mem_318541;
    
    ext_mem_318541.references = NULL;
    
    int32_t local_memory_capacity_321113;
    
    local_memory_capacity_321113 = ctx->cuda.max_shared_memory;
    if (sle64(bytes_318514 + srem64((int64_t) 8 - srem64(bytes_318514,
                                                         (int64_t) 8),
                                    (int64_t) 8) + (bytes_318514 +
                                                    srem64((int64_t) 8 -
                                                           srem64(bytes_318514,
                                                                  (int64_t) 8),
                                                           (int64_t) 8)),
              sext_i32_i64(local_memory_capacity_321113)) &&
        intra_suff_and_fits_297637) {
        struct memblock_device mem_318523;
        
        mem_318523.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318523, bytes_318522,
                                  "mem_318523")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318526;
        
        mem_318526.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318526, bytes_318525,
                                  "mem_318526")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        int32_t num_chunks_320951 = sext_i64_i32(sdiv_up64(n_292675, n_292675));
        unsigned int shared_sizze_325908 = bytes_318514;
        unsigned int shared_sizze_325910 = bytes_318514;
        CUdeviceptr kernel_arg_325912 = mem_318506.mem;
        CUdeviceptr kernel_arg_325913 = mem_318523.mem;
        CUdeviceptr kernel_arg_325914 = mem_318526.mem;
        unsigned int shared_offset_325909 = 0;
        unsigned int shared_offset_325911 = 0 + (shared_sizze_325908 + (8 -
                                                                        shared_sizze_325908 %
                                                                        8) % 8);
        
        if ((((((1 && partition_sizze_292766 != 0) && 1 != 0) && 1 != 0) &&
              n_292675 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = partition_sizze_292766;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_325905[] = {&ctx->global_failure,
                                          &shared_offset_325909,
                                          &shared_offset_325911, &n_292675,
                                          &partition_sizze_292766, &i_292846,
                                          &kernel_arg_325912,
                                          &kernel_arg_325913,
                                          &kernel_arg_325914};
            int64_t time_start_325906 = 0, time_end_325907 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segmap_intragroup_297641",
                        (long) partition_sizze_292766, (long) 1, (long) 1,
                        (long) n_292675, (long) 1, (long) 1, (int) (0 +
                                                                    (shared_sizze_325908 +
                                                                     (8 -
                                                                      shared_sizze_325908 %
                                                                      8) % 8) +
                                                                    (shared_sizze_325910 +
                                                                     (8 -
                                                                      shared_sizze_325910 %
                                                                      8) % 8)));
                time_start_325906 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegmap_intragroup_297641_runs,
                                          &ctx->mainzisegmap_intragroup_297641_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_297641,
                                                  grid[0], grid[1], grid[2],
                                                  n_292675, 1, 1, 0 +
                                                  (shared_sizze_325908 + (8 -
                                                                          shared_sizze_325908 %
                                                                          8) %
                                                   8) + (shared_sizze_325910 +
                                                         (8 -
                                                          shared_sizze_325910 %
                                                          8) % 8), NULL,
                                                  kernel_args_325905, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_325907 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segmap_intragroup_297641", time_end_325907 -
                        time_start_325906);
            }
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        if (memblock_set_device(ctx, &ext_mem_318542, &mem_318523,
                                "mem_318523") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318541, &mem_318526,
                                "mem_318526") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318526, "mem_318526") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318523, "mem_318523") != 0)
            return 1;
    } else {
        struct memblock_device mem_318531;
        
        mem_318531.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318531, bytes_318522,
                                  "mem_318531")) {
            err = 1;
            goto cleanup;
        }
        if (slt64((int64_t) 0, partition_sizze_292766 * n_292675)) {
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegScan");
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c",
                        "SegScan: number of elements processed sequentially per thread is m:",
                        (long long) 11, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c",
                        "SegScan: memory constraints is: ", (long long) 11,
                        '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c",
                        "SegScan: register constraints is: ", (long long) 15,
                        '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "SegScan: sumT' is: ",
                        (long long) 2, '\n');
            
            int64_t numThreads_320979 = sdiv_up64(partition_sizze_292766 *
                                                  n_292675,
                                                  segscan_group_sizze_297749 *
                                                  (int64_t) 11) *
                    segscan_group_sizze_297749;
            int64_t numGroups_320980 = sdiv_up64(partition_sizze_292766 *
                                                 n_292675,
                                                 segscan_group_sizze_297749 *
                                                 (int64_t) 11);
            struct memblock_device mainziid_counter_mem_320981 =
                                   ctx->mainziid_counter_mem_320981;
            struct memblock_device status_flags_mem_320983;
            
            status_flags_mem_320983.references = NULL;
            if (memblock_alloc_device(ctx, &status_flags_mem_320983,
                                      numGroups_320980,
                                      "status_flags_mem_320983")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device aggregates_mem_320985;
            
            aggregates_mem_320985.references = NULL;
            if (memblock_alloc_device(ctx, &aggregates_mem_320985, (int64_t) 8 *
                                      numGroups_320980,
                                      "aggregates_mem_320985")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device incprefixes_mem_320987;
            
            incprefixes_mem_320987.references = NULL;
            if (memblock_alloc_device(ctx, &incprefixes_mem_320987,
                                      (int64_t) 8 * numGroups_320980,
                                      "incprefixes_mem_320987")) {
                err = 1;
                goto cleanup;
            }
            if (futrts_builtinzhreplicate_i8(ctx, status_flags_mem_320983,
                                             numGroups_320980, (int8_t) 0) !=
                0) {
                if (memblock_unref_device(ctx, &incprefixes_mem_320987,
                                          "incprefixes_mem_320987") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &aggregates_mem_320985,
                                          "aggregates_mem_320985") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &status_flags_mem_320983,
                                          "status_flags_mem_320983") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318531, "mem_318531") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318541,
                                          "ext_mem_318541") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318542,
                                          "ext_mem_318542") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320825,
                                          "mem_out_320825") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320824,
                                          "mem_out_320824") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320823,
                                          "mem_out_320823") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            unsigned int shared_sizze_325919 = smax64(smax64((int64_t) 288,
                                                             (int64_t) 8 *
                                                             segscan_group_sizze_297749),
                                                      (int64_t) 11 *
                                                      segscan_group_sizze_297749 *
                                                      (int64_t) 8);
            CUdeviceptr kernel_arg_325921 = mem_318506.mem;
            CUdeviceptr kernel_arg_325922 = mem_318531.mem;
            CUdeviceptr kernel_arg_325923 = mainziid_counter_mem_320981.mem;
            CUdeviceptr kernel_arg_325924 = status_flags_mem_320983.mem;
            CUdeviceptr kernel_arg_325925 = aggregates_mem_320985.mem;
            CUdeviceptr kernel_arg_325926 = incprefixes_mem_320987.mem;
            unsigned int shared_offset_325920 = 0;
            
            if ((((((1 && sdiv_up64(partition_sizze_292766 * n_292675,
                                    segscan_group_sizze_297749 *
                                    (int64_t) 11) != 0) && 1 != 0) && 1 != 0) &&
                  segscan_group_sizze_297749 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = sdiv_up64(partition_sizze_292766 * n_292675,
                                          segscan_group_sizze_297749 *
                                          (int64_t) 11);
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_325916[] = {&ctx->global_failure,
                                              &shared_offset_325920, &n_292675,
                                              &partition_sizze_292766,
                                              &kernel_arg_325921,
                                              &kernel_arg_325922,
                                              &kernel_arg_325923,
                                              &kernel_arg_325924,
                                              &kernel_arg_325925,
                                              &kernel_arg_325926};
                int64_t time_start_325917 = 0, time_end_325918 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segscan_297755",
                            (long) sdiv_up64(partition_sizze_292766 * n_292675,
                                             segscan_group_sizze_297749 *
                                             (int64_t) 11), (long) 1, (long) 1,
                            (long) segscan_group_sizze_297749, (long) 1,
                            (long) 1, (int) (0 + (shared_sizze_325919 + (8 -
                                                                         shared_sizze_325919 %
                                                                         8) %
                                                  8)));
                    time_start_325917 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegscan_297755_runs,
                                              &ctx->mainzisegscan_297755_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegscan_297755,
                                                      grid[0], grid[1], grid[2],
                                                      segscan_group_sizze_297749,
                                                      1, 1, 0 +
                                                      (shared_sizze_325919 +
                                                       (8 -
                                                        shared_sizze_325919 %
                                                        8) % 8), NULL,
                                                      kernel_args_325916,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_325918 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segscan_297755", time_end_325918 -
                            time_start_325917);
                }
            }
            if (memblock_unref_device(ctx, &incprefixes_mem_320987,
                                      "incprefixes_mem_320987") != 0)
                return 1;
            if (memblock_unref_device(ctx, &aggregates_mem_320985,
                                      "aggregates_mem_320985") != 0)
                return 1;
            if (memblock_unref_device(ctx, &status_flags_mem_320983,
                                      "status_flags_mem_320983") != 0)
                return 1;
        }
        
        struct memblock_device mem_318535;
        
        mem_318535.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318535, bytes_318522,
                                  "mem_318535")) {
            err = 1;
            goto cleanup;
        }
        if (futrts_builtinzhreplicate_i64(ctx, mem_318535,
                                          partition_sizze_292766 * n_292675,
                                          (int64_t) -1) != 0) {
            if (memblock_unref_device(ctx, &mem_318535, "mem_318535") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318531, "mem_318531") != 0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") !=
                0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t segmap_usable_groups_297789 = sdiv_up64(nest_sizze_297748,
                                                        segmap_group_sizze_297788);
        
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        CUdeviceptr kernel_arg_325930 = mem_318506.mem;
        CUdeviceptr kernel_arg_325931 = mem_318531.mem;
        CUdeviceptr kernel_arg_325932 = mem_318535.mem;
        
        if ((((((1 && segmap_usable_groups_297789 != 0) && 1 != 0) && 1 != 0) &&
              segmap_group_sizze_297788 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = segmap_usable_groups_297789;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_325927[] = {&ctx->global_failure, &n_292675,
                                          &partition_sizze_292766,
                                          &kernel_arg_325930,
                                          &kernel_arg_325931,
                                          &kernel_arg_325932};
            int64_t time_start_325928 = 0, time_end_325929 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segmap_297793",
                        (long) segmap_usable_groups_297789, (long) 1, (long) 1,
                        (long) segmap_group_sizze_297788, (long) 1, (long) 1,
                        (int) 0);
                time_start_325928 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegmap_297793_runs,
                                          &ctx->mainzisegmap_297793_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_297793,
                                                  grid[0], grid[1], grid[2],
                                                  segmap_group_sizze_297788, 1,
                                                  1, 0, NULL,
                                                  kernel_args_325927, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_325929 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segmap_297793", time_end_325929 -
                        time_start_325928);
            }
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        
        struct memblock_device mem_318539;
        
        mem_318539.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318539, bytes_318525,
                                  "mem_318539")) {
            err = 1;
            goto cleanup;
        }
        
        int64_t group_sizze_321107;
        
        group_sizze_321107 = *ctx->tuning_params.mainzigroup_sizze_321107;
        
        int64_t num_groups_321108 = sdiv_up64(partition_sizze_292766,
                                              group_sizze_321107);
        CUdeviceptr kernel_arg_325936 = mem_318531.mem;
        CUdeviceptr kernel_arg_325937 = mem_318539.mem;
        
        if ((((((1 && num_groups_321108 != 0) && 1 != 0) && 1 != 0) &&
              group_sizze_321107 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = num_groups_321108;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_325933[] = {&n_292675, &partition_sizze_292766,
                                          &i_292846, &kernel_arg_325936,
                                          &kernel_arg_325937};
            int64_t time_start_325934 = 0, time_end_325935 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.copy_321104", (long) num_groups_321108, (long) 1,
                        (long) 1, (long) group_sizze_321107, (long) 1, (long) 1,
                        (int) 0);
                time_start_325934 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzicopy_321104_runs,
                                          &ctx->mainzicopy_321104_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzicopy_321104,
                                                  grid[0], grid[1], grid[2],
                                                  group_sizze_321107, 1, 1, 0,
                                                  NULL, kernel_args_325933,
                                                  NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_325935 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.copy_321104", time_end_325935 -
                        time_start_325934);
            }
        }
        if (memblock_unref_device(ctx, &mem_318531, "mem_318531") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318542, &mem_318535,
                                "mem_318535") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318541, &mem_318539,
                                "mem_318539") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318539, "mem_318539") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318535, "mem_318535") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318531, "mem_318531") != 0)
            return 1;
    }
    
    bool bounds_invalid_upwards_292874 = slt64(defunc_0_f_res_292820,
                                               (int64_t) 0);
    bool valid_292875 = !bounds_invalid_upwards_292874;
    bool range_valid_c_292876;
    
    if (!valid_292875) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) defunc_0_f_res_292820,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:117:20-123:36\n   #4  /prelude/soacs.fut:59:3-10\n   #5  /prelude/array.fut:195:3-17\n   #6  utils.fut:6:3-16\n   #7  stl.fut:115:12-124:20\n   #8  stl.fut:114:5-125:11\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t y_297913 = n_p_292677 * defunc_0_f_res_292820;
    int64_t nest_sizze_297914 = partition_sizze_292766 * y_297913;
    int64_t segmap_group_sizze_297915;
    
    segmap_group_sizze_297915 =
        *ctx->tuning_params.mainzisegmap_group_sizze_297830;
    
    int64_t segmap_usable_groups_297916 = sdiv_up64(nest_sizze_297914,
                                                    segmap_group_sizze_297915);
    struct memblock_device mem_318545;
    
    mem_318545.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318545, bytes_318492, "mem_318545")) {
        err = 1;
        goto cleanup;
    }
    {
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda, &ctx->copy_dev_to_dev_runs,
                                      &ctx->copy_dev_to_dev_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuMemcpy(mem_318545.mem + (int64_t) 0,
                                        mem_318506.mem + (int64_t) 0, m_292674 *
                                        n_292675 * (int64_t) 4));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
    }
    
    int64_t binop_x_318547 = n_p_292677 * partition_sizze_292766;
    int64_t binop_x_318548 = defunc_0_f_res_292820 * binop_x_318547;
    int64_t binop_y_318549 = (int64_t) 8 * binop_x_318548;
    int64_t bytes_318550 = smax64((int64_t) 0, binop_y_318549);
    struct memblock_device mem_318551;
    
    mem_318551.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318551, bytes_318550, "mem_318551")) {
        err = 1;
        goto cleanup;
    }
    if (ctx->debugging)
        fprintf(ctx->log, "%s\n", "\n# SegMap");
    
    CUdeviceptr kernel_arg_325941 = mem_318545.mem;
    CUdeviceptr kernel_arg_325942 = mem_318551.mem;
    
    if ((((((1 && segmap_usable_groups_297916 != 0) && 1 != 0) && 1 != 0) &&
          segmap_group_sizze_297915 != 0) && 1 != 0) && 1 != 0) {
        int perm[3] = {0, 1, 2};
        
        if (1 >= 1 << 16) {
            perm[1] = perm[0];
            perm[0] = 1;
        }
        if (1 >= 1 << 16) {
            perm[2] = perm[0];
            perm[0] = 2;
        }
        
        size_t grid[3];
        
        grid[perm[0]] = segmap_usable_groups_297916;
        grid[perm[1]] = 1;
        grid[perm[2]] = 1;
        
        void *kernel_args_325938[] = {&ctx->global_failure,
                                      &ctx->failure_is_an_option,
                                      &ctx->global_failure_args, &n_292675,
                                      &n_p_292677, &partition_sizze_292766,
                                      &defunc_0_f_res_292820, &i_292846,
                                      &kernel_arg_325941, &kernel_arg_325942};
        int64_t time_start_325939 = 0, time_end_325940 = 0;
        
        if (ctx->debugging) {
            fprintf(ctx->log,
                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                    "main.segmap_297921", (long) segmap_usable_groups_297916,
                    (long) 1, (long) 1, (long) segmap_group_sizze_297915,
                    (long) 1, (long) 1, (int) 0);
            time_start_325939 = get_wall_time();
        }
        
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda,
                                      &ctx->mainzisegmap_297921_runs,
                                      &ctx->mainzisegmap_297921_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_297921, grid[0],
                                              grid[1], grid[2],
                                              segmap_group_sizze_297915, 1, 1,
                                              0, NULL, kernel_args_325938,
                                              NULL));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
        if (ctx->debugging) {
            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
            time_end_325940 = get_wall_time();
            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                    "main.segmap_297921", time_end_325940 - time_start_325939);
        }
    }
    ctx->failure_is_an_option = 1;
    if (ctx->debugging)
        fprintf(ctx->log, "%s\n", "");
    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
        return 1;
    
    int64_t i_292895 = sub64(defunc_0_f_res_292820, (int64_t) 1);
    bool x_292896 = sle64((int64_t) 0, i_292895);
    bool y_292897 = slt64(i_292895, defunc_0_f_res_292820);
    bool bounds_check_292898 = x_292896 && y_292897;
    bool index_certs_292899;
    
    if (!bounds_check_292898) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) i_292895,
                               "] out of bounds for array of shape [",
                               (long long) defunc_0_f_res_292820, "].",
                               "-> #0  /prelude/array.fut:26:29-34\n   #1  utils.fut:45:13-20\n   #2  stl.fut:131:51-67\n   #3  stl.fut:130:12-133:21\n   #4  stl.fut:129:5-134:16\n   #5  stl.fut:419:61-435:77\n   #6  stl.fut:463:3-479:36\n   #7  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t y_297987 = smin64(n_p_292677, y_297913);
    int64_t intra_avail_par_297988 = smin64(y_297913, y_297987);
    int64_t computed_group_sizze_297939 = smax64(n_p_292677, y_297913);
    bool fits_297995 = sle64(computed_group_sizze_297939,
                             max_group_sizze_297635);
    bool suff_intra_par_297993;
    
    suff_intra_par_297993 = *ctx->tuning_params.mainzisuff_intra_par_1 <=
        intra_avail_par_297988;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n", "main.suff_intra_par_1",
                (long) intra_avail_par_297988,
                suff_intra_par_297993 ? "true" : "false");
    
    bool intra_suff_and_fits_297996 = suff_intra_par_297993 && fits_297995;
    bool fits_298266 = sle64(defunc_0_f_res_292820, max_group_sizze_297635);
    bool suff_intra_par_298268;
    
    suff_intra_par_298268 = *ctx->tuning_params.mainzisuff_intra_par_2 <=
        defunc_0_f_res_292820;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n", "main.suff_intra_par_2",
                (long) defunc_0_f_res_292820,
                suff_intra_par_298268 ? "true" : "false");
    
    bool intra_suff_and_fits_298269 = fits_298266 && suff_intra_par_298268;
    int64_t segscan_group_sizze_298304;
    
    segscan_group_sizze_298304 =
        *ctx->tuning_params.mainzisegscan_group_sizze_298171;
    
    int64_t num_groups_298305;
    int32_t max_num_groups_321126;
    
    max_num_groups_321126 = *ctx->tuning_params.mainzisegscan_num_groups_298173;
    num_groups_298305 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(binop_x_318548,
                                                             segscan_group_sizze_298304),
                                                   sext_i32_i64(max_num_groups_321126))));
    
    int64_t segmap_group_sizze_298351;
    
    segmap_group_sizze_298351 =
        *ctx->tuning_params.mainzisegmap_group_sizze_298102;
    
    int64_t binop_y_318569 = (int64_t) 8 * binop_x_318547;
    int64_t bytes_318570 = smax64((int64_t) 0, binop_y_318569);
    int64_t binop_y_318555 = (int64_t) 8 * y_297913;
    int64_t bytes_318556 = smax64((int64_t) 0, binop_y_318555);
    int64_t binop_y_318574 = (int64_t) 8 * defunc_0_f_res_292820;
    int64_t bytes_318575 = smax64((int64_t) 0, binop_y_318574);
    struct memblock_device ext_mem_318610;
    
    ext_mem_318610.references = NULL;
    
    struct memblock_device ext_mem_318609;
    
    ext_mem_318609.references = NULL;
    
    int32_t local_memory_capacity_321334;
    
    local_memory_capacity_321334 = ctx->cuda.max_shared_memory;
    if (sle64(bytes_318556 + srem64((int64_t) 8 - srem64(bytes_318556,
                                                         (int64_t) 8),
                                    (int64_t) 8) + (bytes_318556 +
                                                    srem64((int64_t) 8 -
                                                           srem64(bytes_318556,
                                                                  (int64_t) 8),
                                                           (int64_t) 8)),
              sext_i32_i64(local_memory_capacity_321334)) &&
        intra_suff_and_fits_297996) {
        struct memblock_device mem_318567;
        
        mem_318567.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318567, bytes_318550,
                                  "mem_318567")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318571;
        
        mem_318571.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318571, bytes_318570,
                                  "mem_318571")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        int32_t num_chunks_321127 = sext_i64_i32(sdiv_up64(n_p_292677 *
                                                           defunc_0_f_res_292820,
                                                           computed_group_sizze_297939));
        unsigned int shared_sizze_325946 = bytes_318556;
        unsigned int shared_sizze_325948 = bytes_318556;
        CUdeviceptr kernel_arg_325950 = mem_318551.mem;
        CUdeviceptr kernel_arg_325951 = mem_318567.mem;
        CUdeviceptr kernel_arg_325952 = mem_318571.mem;
        unsigned int shared_offset_325947 = 0;
        unsigned int shared_offset_325949 = 0 + (shared_sizze_325946 + (8 -
                                                                        shared_sizze_325946 %
                                                                        8) % 8);
        
        if ((((((1 && partition_sizze_292766 != 0) && 1 != 0) && 1 != 0) &&
              computed_group_sizze_297939 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = partition_sizze_292766;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_325943[] = {&ctx->global_failure,
                                          &shared_offset_325947,
                                          &shared_offset_325949, &n_p_292677,
                                          &partition_sizze_292766,
                                          &defunc_0_f_res_292820, &i_292895,
                                          &computed_group_sizze_297939,
                                          &num_chunks_321127,
                                          &kernel_arg_325950,
                                          &kernel_arg_325951,
                                          &kernel_arg_325952};
            int64_t time_start_325944 = 0, time_end_325945 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segmap_intragroup_298000",
                        (long) partition_sizze_292766, (long) 1, (long) 1,
                        (long) computed_group_sizze_297939, (long) 1, (long) 1,
                        (int) (0 + (shared_sizze_325946 + (8 -
                                                           shared_sizze_325946 %
                                                           8) % 8) +
                               (shared_sizze_325948 + (8 - shared_sizze_325948 %
                                                       8) % 8)));
                time_start_325944 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegmap_intragroup_298000_runs,
                                          &ctx->mainzisegmap_intragroup_298000_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_298000,
                                                  grid[0], grid[1], grid[2],
                                                  computed_group_sizze_297939,
                                                  1, 1, 0 +
                                                  (shared_sizze_325946 + (8 -
                                                                          shared_sizze_325946 %
                                                                          8) %
                                                   8) + (shared_sizze_325948 +
                                                         (8 -
                                                          shared_sizze_325948 %
                                                          8) % 8), NULL,
                                                  kernel_args_325943, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_325945 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segmap_intragroup_298000", time_end_325945 -
                        time_start_325944);
            }
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        if (memblock_set_device(ctx, &ext_mem_318610, &mem_318567,
                                "mem_318567") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318609, &mem_318571,
                                "mem_318571") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318571, "mem_318571") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318567, "mem_318567") != 0)
            return 1;
    } else {
        struct memblock_device ext_mem_318608;
        
        ext_mem_318608.references = NULL;
        
        struct memblock_device ext_mem_318607;
        
        ext_mem_318607.references = NULL;
        
        int32_t local_memory_capacity_321333;
        
        local_memory_capacity_321333 = ctx->cuda.max_shared_memory;
        if (sle64(bytes_318575 + srem64((int64_t) 8 - srem64(bytes_318575,
                                                             (int64_t) 8),
                                        (int64_t) 8) + (bytes_318575 +
                                                        srem64((int64_t) 8 -
                                                               srem64(bytes_318575,
                                                                      (int64_t) 8),
                                                               (int64_t) 8)),
                  sext_i32_i64(local_memory_capacity_321333)) &&
            intra_suff_and_fits_298269) {
            struct memblock_device mem_318585;
            
            mem_318585.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318585, bytes_318550,
                                      "mem_318585")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_318589;
            
            mem_318589.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318589, bytes_318570,
                                      "mem_318589")) {
                err = 1;
                goto cleanup;
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            int32_t num_chunks_321172 =
                    sext_i64_i32(sdiv_up64(defunc_0_f_res_292820,
                                           defunc_0_f_res_292820));
            unsigned int shared_sizze_325956 = bytes_318575;
            unsigned int shared_sizze_325958 = bytes_318575;
            CUdeviceptr kernel_arg_325960 = mem_318551.mem;
            CUdeviceptr kernel_arg_325961 = mem_318585.mem;
            CUdeviceptr kernel_arg_325962 = mem_318589.mem;
            unsigned int shared_offset_325957 = 0;
            unsigned int shared_offset_325959 = 0 + (shared_sizze_325956 + (8 -
                                                                            shared_sizze_325956 %
                                                                            8) %
                                                     8);
            
            if ((((((1 && binop_x_318547 != 0) && 1 != 0) && 1 != 0) &&
                  defunc_0_f_res_292820 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = binop_x_318547;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_325953[] = {&ctx->global_failure,
                                              &shared_offset_325957,
                                              &shared_offset_325959,
                                              &n_p_292677,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820, &i_292895,
                                              &kernel_arg_325960,
                                              &kernel_arg_325961,
                                              &kernel_arg_325962};
                int64_t time_start_325954 = 0, time_end_325955 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_intragroup_298276",
                            (long) binop_x_318547, (long) 1, (long) 1,
                            (long) defunc_0_f_res_292820, (long) 1, (long) 1,
                            (int) (0 + (shared_sizze_325956 + (8 -
                                                               shared_sizze_325956 %
                                                               8) % 8) +
                                   (shared_sizze_325958 + (8 -
                                                           shared_sizze_325958 %
                                                           8) % 8)));
                    time_start_325954 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_intragroup_298276_runs,
                                              &ctx->mainzisegmap_intragroup_298276_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_298276,
                                                      grid[0], grid[1], grid[2],
                                                      defunc_0_f_res_292820, 1,
                                                      1, 0 +
                                                      (shared_sizze_325956 +
                                                       (8 -
                                                        shared_sizze_325956 %
                                                        8) % 8) +
                                                      (shared_sizze_325958 +
                                                       (8 -
                                                        shared_sizze_325958 %
                                                        8) % 8), NULL,
                                                      kernel_args_325953,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_325955 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_intragroup_298276", time_end_325955 -
                            time_start_325954);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            if (memblock_set_device(ctx, &ext_mem_318608, &mem_318585,
                                    "mem_318585") != 0)
                return 1;
            if (memblock_set_device(ctx, &ext_mem_318607, &mem_318589,
                                    "mem_318589") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318589, "mem_318589") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318585, "mem_318585") != 0)
                return 1;
        } else {
            struct memblock_device mem_318595;
            
            mem_318595.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318595, bytes_318550,
                                      "mem_318595")) {
                err = 1;
                goto cleanup;
            }
            if (slt64((int64_t) 0, partition_sizze_292766 * n_p_292677 *
                      defunc_0_f_res_292820)) {
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegScan");
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c",
                            "SegScan: number of elements processed sequentially per thread is m:",
                            (long long) 11, '\n');
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c",
                            "SegScan: memory constraints is: ", (long long) 11,
                            '\n');
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c",
                            "SegScan: register constraints is: ",
                            (long long) 15, '\n');
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c", "SegScan: sumT' is: ",
                            (long long) 2, '\n');
                
                int64_t numThreads_321202 = sdiv_up64(partition_sizze_292766 *
                                                      n_p_292677 *
                                                      defunc_0_f_res_292820,
                                                      segscan_group_sizze_298304 *
                                                      (int64_t) 11) *
                        segscan_group_sizze_298304;
                int64_t numGroups_321203 = sdiv_up64(partition_sizze_292766 *
                                                     n_p_292677 *
                                                     defunc_0_f_res_292820,
                                                     segscan_group_sizze_298304 *
                                                     (int64_t) 11);
                struct memblock_device mainziid_counter_mem_321204 =
                                       ctx->mainziid_counter_mem_321204;
                struct memblock_device status_flags_mem_321206;
                
                status_flags_mem_321206.references = NULL;
                if (memblock_alloc_device(ctx, &status_flags_mem_321206,
                                          numGroups_321203,
                                          "status_flags_mem_321206")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device aggregates_mem_321208;
                
                aggregates_mem_321208.references = NULL;
                if (memblock_alloc_device(ctx, &aggregates_mem_321208,
                                          (int64_t) 8 * numGroups_321203,
                                          "aggregates_mem_321208")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device incprefixes_mem_321210;
                
                incprefixes_mem_321210.references = NULL;
                if (memblock_alloc_device(ctx, &incprefixes_mem_321210,
                                          (int64_t) 8 * numGroups_321203,
                                          "incprefixes_mem_321210")) {
                    err = 1;
                    goto cleanup;
                }
                if (futrts_builtinzhreplicate_i8(ctx, status_flags_mem_321206,
                                                 numGroups_321203,
                                                 (int8_t) 0) != 0) {
                    if (memblock_unref_device(ctx, &incprefixes_mem_321210,
                                              "incprefixes_mem_321210") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &aggregates_mem_321208,
                                              "aggregates_mem_321208") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &status_flags_mem_321206,
                                              "status_flags_mem_321206") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318595, "mem_318595") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318607,
                                              "ext_mem_318607") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318608,
                                              "ext_mem_318608") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                unsigned int shared_sizze_325967 = smax64(smax64((int64_t) 288,
                                                                 (int64_t) 8 *
                                                                 segscan_group_sizze_298304),
                                                          (int64_t) 11 *
                                                          segscan_group_sizze_298304 *
                                                          (int64_t) 8);
                CUdeviceptr kernel_arg_325969 = mem_318551.mem;
                CUdeviceptr kernel_arg_325970 = mem_318595.mem;
                CUdeviceptr kernel_arg_325971 = mainziid_counter_mem_321204.mem;
                CUdeviceptr kernel_arg_325972 = status_flags_mem_321206.mem;
                CUdeviceptr kernel_arg_325973 = aggregates_mem_321208.mem;
                CUdeviceptr kernel_arg_325974 = incprefixes_mem_321210.mem;
                unsigned int shared_offset_325968 = 0;
                
                if ((((((1 && sdiv_up64(partition_sizze_292766 * n_p_292677 *
                                        defunc_0_f_res_292820,
                                        segscan_group_sizze_298304 *
                                        (int64_t) 11) != 0) && 1 != 0) && 1 !=
                       0) && segscan_group_sizze_298304 != 0) && 1 != 0) && 1 !=
                    0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = sdiv_up64(partition_sizze_292766 *
                                              n_p_292677 *
                                              defunc_0_f_res_292820,
                                              segscan_group_sizze_298304 *
                                              (int64_t) 11);
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_325964[] = {&ctx->global_failure,
                                                  &shared_offset_325968,
                                                  &n_p_292677,
                                                  &partition_sizze_292766,
                                                  &defunc_0_f_res_292820,
                                                  &kernel_arg_325969,
                                                  &kernel_arg_325970,
                                                  &kernel_arg_325971,
                                                  &kernel_arg_325972,
                                                  &kernel_arg_325973,
                                                  &kernel_arg_325974};
                    int64_t time_start_325965 = 0, time_end_325966 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segscan_298311",
                                (long) sdiv_up64(partition_sizze_292766 *
                                                 n_p_292677 *
                                                 defunc_0_f_res_292820,
                                                 segscan_group_sizze_298304 *
                                                 (int64_t) 11), (long) 1,
                                (long) 1, (long) segscan_group_sizze_298304,
                                (long) 1, (long) 1, (int) (0 +
                                                           (shared_sizze_325967 +
                                                            (8 -
                                                             shared_sizze_325967 %
                                                             8) % 8)));
                        time_start_325965 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegscan_298311_runs,
                                                  &ctx->mainzisegscan_298311_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegscan_298311,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segscan_group_sizze_298304,
                                                          1, 1, 0 +
                                                          (shared_sizze_325967 +
                                                           (8 -
                                                            shared_sizze_325967 %
                                                            8) % 8), NULL,
                                                          kernel_args_325964,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_325966 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segscan_298311", time_end_325966 -
                                time_start_325965);
                    }
                }
                if (memblock_unref_device(ctx, &incprefixes_mem_321210,
                                          "incprefixes_mem_321210") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &aggregates_mem_321208,
                                          "aggregates_mem_321208") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &status_flags_mem_321206,
                                          "status_flags_mem_321206") != 0)
                    return 1;
            }
            
            struct memblock_device mem_318600;
            
            mem_318600.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318600, bytes_318550,
                                      "mem_318600")) {
                err = 1;
                goto cleanup;
            }
            if (futrts_builtinzhreplicate_i64(ctx, mem_318600,
                                              partition_sizze_292766 *
                                              n_p_292677 *
                                              defunc_0_f_res_292820,
                                              (int64_t) -1) != 0) {
                if (memblock_unref_device(ctx, &mem_318600, "mem_318600") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318595, "mem_318595") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318607,
                                          "ext_mem_318607") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318608,
                                          "ext_mem_318608") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318609,
                                          "ext_mem_318609") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318610,
                                          "ext_mem_318610") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318541,
                                          "ext_mem_318541") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318542,
                                          "ext_mem_318542") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320825,
                                          "mem_out_320825") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320824,
                                          "mem_out_320824") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320823,
                                          "mem_out_320823") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t segmap_usable_groups_298352 = sdiv_up64(nest_sizze_297914,
                                                            segmap_group_sizze_298351);
            
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            CUdeviceptr kernel_arg_325978 = mem_318551.mem;
            CUdeviceptr kernel_arg_325979 = mem_318595.mem;
            CUdeviceptr kernel_arg_325980 = mem_318600.mem;
            
            if ((((((1 && segmap_usable_groups_298352 != 0) && 1 != 0) && 1 !=
                   0) && segmap_group_sizze_298351 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = segmap_usable_groups_298352;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_325975[] = {&ctx->global_failure, &n_p_292677,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &kernel_arg_325978,
                                              &kernel_arg_325979,
                                              &kernel_arg_325980};
                int64_t time_start_325976 = 0, time_end_325977 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_298357",
                            (long) segmap_usable_groups_298352, (long) 1,
                            (long) 1, (long) segmap_group_sizze_298351,
                            (long) 1, (long) 1, (int) 0);
                    time_start_325976 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_298357_runs,
                                              &ctx->mainzisegmap_298357_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_298357,
                                                      grid[0], grid[1], grid[2],
                                                      segmap_group_sizze_298351,
                                                      1, 1, 0, NULL,
                                                      kernel_args_325975,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_325977 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_298357", time_end_325977 -
                            time_start_325976);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            
            struct memblock_device mem_318605;
            
            mem_318605.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318605, bytes_318570,
                                      "mem_318605")) {
                err = 1;
                goto cleanup;
            }
            
            int64_t group_sizze_321324;
            
            group_sizze_321324 = *ctx->tuning_params.mainzigroup_sizze_321324;
            
            int64_t num_groups_321325 = sdiv_up64(partition_sizze_292766 *
                                                  n_p_292677,
                                                  group_sizze_321324);
            CUdeviceptr kernel_arg_325984 = mem_318595.mem;
            CUdeviceptr kernel_arg_325985 = mem_318605.mem;
            
            if ((((((1 && num_groups_321325 != 0) && 1 != 0) && 1 != 0) &&
                  group_sizze_321324 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = num_groups_321325;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_325981[] = {&n_p_292677,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820, &i_292895,
                                              &kernel_arg_325984,
                                              &kernel_arg_325985};
                int64_t time_start_325982 = 0, time_end_325983 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.copy_321321", (long) num_groups_321325,
                            (long) 1, (long) 1, (long) group_sizze_321324,
                            (long) 1, (long) 1, (int) 0);
                    time_start_325982 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzicopy_321321_runs,
                                              &ctx->mainzicopy_321321_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzicopy_321321,
                                                      grid[0], grid[1], grid[2],
                                                      group_sizze_321324, 1, 1,
                                                      0, NULL,
                                                      kernel_args_325981,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_325983 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.copy_321321", time_end_325983 -
                            time_start_325982);
                }
            }
            if (memblock_unref_device(ctx, &mem_318595, "mem_318595") != 0)
                return 1;
            if (memblock_set_device(ctx, &ext_mem_318608, &mem_318600,
                                    "mem_318600") != 0)
                return 1;
            if (memblock_set_device(ctx, &ext_mem_318607, &mem_318605,
                                    "mem_318605") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318605, "mem_318605") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318600, "mem_318600") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318595, "mem_318595") != 0)
                return 1;
        }
        if (memblock_set_device(ctx, &ext_mem_318610, &ext_mem_318608,
                                "ext_mem_318608") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318609, &ext_mem_318607,
                                "ext_mem_318607") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318607, "ext_mem_318607") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318608, "ext_mem_318608") != 0)
            return 1;
    }
    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
        return 1;
    
    int64_t min_res_292926 = smin64(q_s_292678, defunc_0_f_res_292820);
    bool bounds_invalid_upwards_292927 = slt64(s_n_m_292825, (int64_t) 0);
    bool valid_292928 = !bounds_invalid_upwards_292927;
    bool range_valid_c_292929;
    
    if (!valid_292928) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) s_n_m_292825, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:638:3-665:10\n   #4  loess.fut:712:15-50\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool loop_cond_292931 = slt64((int64_t) 1, min_res_292926);
    double i64_res_292932 = sitofp_i64_f64(q_s_292678);
    int64_t one_intra_par_min_298512 = n_p_292677 * s_n_m_292825;
    int64_t y_298515 = smin64(n_p_292677, one_intra_par_min_298512);
    int64_t intra_avail_par_298516 = smin64(y_297913, y_298515);
    int64_t y_298517 = smax64(n_p_292677, one_intra_par_min_298512);
    int64_t computed_group_sizze_298371 = smax64(y_297913, y_298517);
    bool fits_298524 = sle64(computed_group_sizze_298371,
                             max_group_sizze_297635);
    bool suff_intra_par_298522;
    
    suff_intra_par_298522 = *ctx->tuning_params.mainzisuff_intra_par_3 <=
        intra_avail_par_298516;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n", "main.suff_intra_par_3",
                (long) intra_avail_par_298516,
                suff_intra_par_298522 ? "true" : "false");
    
    bool intra_suff_and_fits_298525 = suff_intra_par_298522 && fits_298524;
    int64_t intra_avail_par_299418 = smin64(defunc_0_f_res_292820,
                                            s_n_m_292825);
    int64_t computed_group_sizze_299419 = smax64(defunc_0_f_res_292820,
                                                 s_n_m_292825);
    bool fits_299423 = sle64(computed_group_sizze_299419,
                             max_group_sizze_297635);
    bool suff_intra_par_299425;
    
    suff_intra_par_299425 = *ctx->tuning_params.mainzisuff_intra_par_4 <=
        intra_avail_par_299418;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n", "main.suff_intra_par_4",
                (long) intra_avail_par_299418,
                suff_intra_par_299425 ? "true" : "false");
    
    bool intra_suff_and_fits_299426 = fits_299423 && suff_intra_par_299425;
    int64_t segmap_group_sizze_299564;
    
    segmap_group_sizze_299564 =
        *ctx->tuning_params.mainzisegmap_group_sizze_299227;
    
    int64_t segmap_group_sizze_299576;
    
    segmap_group_sizze_299576 =
        *ctx->tuning_params.mainzisegmap_group_sizze_299196;
    
    int64_t nest_sizze_299600 = partition_sizze_292766 *
            one_intra_par_min_298512;
    int64_t segmap_group_sizze_299601;
    
    segmap_group_sizze_299601 =
        *ctx->tuning_params.mainzisegmap_group_sizze_298957;
    
    int64_t binop_x_318640 = s_n_m_292825 * binop_x_318547;
    int64_t binop_y_318641 = (int64_t) 8 * binop_x_318640;
    int64_t bytes_318642 = smax64((int64_t) 0, binop_y_318641);
    int64_t binop_y_318618 = (int64_t) 8 * n_p_292677;
    int64_t bytes_318619 = smax64((int64_t) 0, binop_y_318618);
    int64_t binop_y_318632 = (int64_t) 8 * one_intra_par_min_298512;
    int64_t bytes_318633 = smax64((int64_t) 0, binop_y_318632);
    int64_t binop_y_318655 = (int64_t) 8 * s_n_m_292825;
    int64_t bytes_318656 = smax64((int64_t) 0, binop_y_318655);
    struct memblock_device ext_mem_318708;
    
    ext_mem_318708.references = NULL;
    
    struct memblock_device ext_mem_318707;
    
    ext_mem_318707.references = NULL;
    
    int32_t local_memory_capacity_321449;
    
    local_memory_capacity_321449 = ctx->cuda.max_shared_memory;
    if (sle64(bytes_318633 + srem64((int64_t) 8 - srem64(bytes_318633,
                                                         (int64_t) 8),
                                    (int64_t) 8) + (bytes_318633 +
                                                    srem64((int64_t) 8 -
                                                           srem64(bytes_318633,
                                                                  (int64_t) 8),
                                                           (int64_t) 8)) +
              (bytes_318619 + srem64((int64_t) 8 - srem64(bytes_318619,
                                                          (int64_t) 8),
                                     (int64_t) 8)) + (bytes_318619 +
                                                      srem64((int64_t) 8 -
                                                             srem64(bytes_318619,
                                                                    (int64_t) 8),
                                                             (int64_t) 8)) +
              (bytes_318619 + srem64((int64_t) 8 - srem64(bytes_318619,
                                                          (int64_t) 8),
                                     (int64_t) 8)) + (bytes_318619 +
                                                      srem64((int64_t) 8 -
                                                             srem64(bytes_318619,
                                                                    (int64_t) 8),
                                                             (int64_t) 8)) +
              (bytes_318556 + srem64((int64_t) 8 - srem64(bytes_318556,
                                                          (int64_t) 8),
                                     (int64_t) 8)),
              sext_i32_i64(local_memory_capacity_321449)) &&
        intra_suff_and_fits_298525) {
        struct memblock_device mem_318643;
        
        mem_318643.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318643, bytes_318642,
                                  "mem_318643")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318648;
        
        mem_318648.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318648, bytes_318642,
                                  "mem_318648")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        int32_t num_chunks_321335 = sext_i64_i32(sdiv_up64(n_p_292677,
                                                           computed_group_sizze_298371));
        int32_t num_chunks_321336 = sext_i64_i32(sdiv_up64(n_p_292677 *
                                                           defunc_0_f_res_292820,
                                                           computed_group_sizze_298371));
        int32_t num_chunks_321337 = sext_i64_i32(sdiv_up64(n_p_292677 *
                                                           s_n_m_292825,
                                                           computed_group_sizze_298371));
        unsigned int shared_sizze_325989 = bytes_318556;
        unsigned int shared_sizze_325991 = bytes_318619;
        unsigned int shared_sizze_325993 = bytes_318619;
        unsigned int shared_sizze_325995 = bytes_318619;
        unsigned int shared_sizze_325997 = bytes_318619;
        unsigned int shared_sizze_325999 = bytes_318633;
        unsigned int shared_sizze_326001 = bytes_318633;
        CUdeviceptr kernel_arg_326003 = ext_mem_318609.mem;
        CUdeviceptr kernel_arg_326004 = ext_mem_318610.mem;
        CUdeviceptr kernel_arg_326005 = mem_318643.mem;
        CUdeviceptr kernel_arg_326006 = mem_318648.mem;
        unsigned int shared_offset_325990 = 0;
        unsigned int shared_offset_325992 = 0 + (shared_sizze_325989 + (8 -
                                                                        shared_sizze_325989 %
                                                                        8) % 8);
        unsigned int shared_offset_325994 = 0 + (shared_sizze_325989 + (8 -
                                                                        shared_sizze_325989 %
                                                                        8) %
                                                 8) + (shared_sizze_325991 +
                                                       (8 -
                                                        shared_sizze_325991 %
                                                        8) % 8);
        unsigned int shared_offset_325996 = 0 + (shared_sizze_325989 + (8 -
                                                                        shared_sizze_325989 %
                                                                        8) %
                                                 8) + (shared_sizze_325991 +
                                                       (8 -
                                                        shared_sizze_325991 %
                                                        8) % 8) +
                     (shared_sizze_325993 + (8 - shared_sizze_325993 % 8) % 8);
        unsigned int shared_offset_325998 = 0 + (shared_sizze_325989 + (8 -
                                                                        shared_sizze_325989 %
                                                                        8) %
                                                 8) + (shared_sizze_325991 +
                                                       (8 -
                                                        shared_sizze_325991 %
                                                        8) % 8) +
                     (shared_sizze_325993 + (8 - shared_sizze_325993 % 8) % 8) +
                     (shared_sizze_325995 + (8 - shared_sizze_325995 % 8) % 8);
        unsigned int shared_offset_326000 = 0 + (shared_sizze_325989 + (8 -
                                                                        shared_sizze_325989 %
                                                                        8) %
                                                 8) + (shared_sizze_325991 +
                                                       (8 -
                                                        shared_sizze_325991 %
                                                        8) % 8) +
                     (shared_sizze_325993 + (8 - shared_sizze_325993 % 8) % 8) +
                     (shared_sizze_325995 + (8 - shared_sizze_325995 % 8) % 8) +
                     (shared_sizze_325997 + (8 - shared_sizze_325997 % 8) % 8);
        unsigned int shared_offset_326002 = 0 + (shared_sizze_325989 + (8 -
                                                                        shared_sizze_325989 %
                                                                        8) %
                                                 8) + (shared_sizze_325991 +
                                                       (8 -
                                                        shared_sizze_325991 %
                                                        8) % 8) +
                     (shared_sizze_325993 + (8 - shared_sizze_325993 % 8) % 8) +
                     (shared_sizze_325995 + (8 - shared_sizze_325995 % 8) % 8) +
                     (shared_sizze_325997 + (8 - shared_sizze_325997 % 8) % 8) +
                     (shared_sizze_325999 + (8 - shared_sizze_325999 % 8) % 8);
        
        if ((((((1 && partition_sizze_292766 != 0) && 1 != 0) && 1 != 0) &&
              computed_group_sizze_298371 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = partition_sizze_292766;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_325986[] = {&ctx->global_failure,
                                          &ctx->failure_is_an_option,
                                          &ctx->global_failure_args,
                                          &shared_offset_325990,
                                          &shared_offset_325992,
                                          &shared_offset_325994,
                                          &shared_offset_325996,
                                          &shared_offset_325998,
                                          &shared_offset_326000,
                                          &shared_offset_326002, &n_p_292677,
                                          &q_s_292678, &jump_s_292684,
                                          &partition_sizze_292766,
                                          &defunc_0_f_res_292820,
                                          &pad_css_len_292821, &s_n_m_292825,
                                          &i_292895, &x_292896, &min_res_292926,
                                          &loop_cond_292931, &i64_res_292932,
                                          &computed_group_sizze_298371,
                                          &kernel_arg_326003,
                                          &kernel_arg_326004,
                                          &kernel_arg_326005,
                                          &kernel_arg_326006};
            int64_t time_start_325987 = 0, time_end_325988 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segmap_intragroup_298529",
                        (long) partition_sizze_292766, (long) 1, (long) 1,
                        (long) computed_group_sizze_298371, (long) 1, (long) 1,
                        (int) (0 + (shared_sizze_325989 + (8 -
                                                           shared_sizze_325989 %
                                                           8) % 8) +
                               (shared_sizze_325991 + (8 - shared_sizze_325991 %
                                                       8) % 8) +
                               (shared_sizze_325993 + (8 - shared_sizze_325993 %
                                                       8) % 8) +
                               (shared_sizze_325995 + (8 - shared_sizze_325995 %
                                                       8) % 8) +
                               (shared_sizze_325997 + (8 - shared_sizze_325997 %
                                                       8) % 8) +
                               (shared_sizze_325999 + (8 - shared_sizze_325999 %
                                                       8) % 8) +
                               (shared_sizze_326001 + (8 - shared_sizze_326001 %
                                                       8) % 8)));
                time_start_325987 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegmap_intragroup_298529_runs,
                                          &ctx->mainzisegmap_intragroup_298529_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_298529,
                                                  grid[0], grid[1], grid[2],
                                                  computed_group_sizze_298371,
                                                  1, 1, 0 +
                                                  (shared_sizze_325989 + (8 -
                                                                          shared_sizze_325989 %
                                                                          8) %
                                                   8) + (shared_sizze_325991 +
                                                         (8 -
                                                          shared_sizze_325991 %
                                                          8) % 8) +
                                                  (shared_sizze_325993 + (8 -
                                                                          shared_sizze_325993 %
                                                                          8) %
                                                   8) + (shared_sizze_325995 +
                                                         (8 -
                                                          shared_sizze_325995 %
                                                          8) % 8) +
                                                  (shared_sizze_325997 + (8 -
                                                                          shared_sizze_325997 %
                                                                          8) %
                                                   8) + (shared_sizze_325999 +
                                                         (8 -
                                                          shared_sizze_325999 %
                                                          8) % 8) +
                                                  (shared_sizze_326001 + (8 -
                                                                          shared_sizze_326001 %
                                                                          8) %
                                                   8), NULL, kernel_args_325986,
                                                  NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_325988 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segmap_intragroup_298529", time_end_325988 -
                        time_start_325987);
            }
        }
        ctx->failure_is_an_option = 1;
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        if (memblock_set_device(ctx, &ext_mem_318708, &mem_318643,
                                "mem_318643") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318707, &mem_318648,
                                "mem_318648") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318648, "mem_318648") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318643, "mem_318643") != 0)
            return 1;
    } else {
        struct memblock_device ext_mem_318706;
        
        ext_mem_318706.references = NULL;
        
        struct memblock_device ext_mem_318705;
        
        ext_mem_318705.references = NULL;
        
        int32_t local_memory_capacity_321448;
        
        local_memory_capacity_321448 = ctx->cuda.max_shared_memory;
        if (sle64(bytes_318656 + srem64((int64_t) 8 - srem64(bytes_318656,
                                                             (int64_t) 8),
                                        (int64_t) 8) + (bytes_318656 +
                                                        srem64((int64_t) 8 -
                                                               srem64(bytes_318656,
                                                                      (int64_t) 8),
                                                               (int64_t) 8)) +
                  (bytes_318575 + srem64((int64_t) 8 - srem64(bytes_318575,
                                                              (int64_t) 8),
                                         (int64_t) 8)),
                  sext_i32_i64(local_memory_capacity_321448)) &&
            intra_suff_and_fits_299426) {
            struct memblock_device mem_318665;
            
            mem_318665.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318665, bytes_318642,
                                      "mem_318665")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_318670;
            
            mem_318670.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318670, bytes_318642,
                                      "mem_318670")) {
                err = 1;
                goto cleanup;
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            int32_t num_chunks_321375 =
                    sext_i64_i32(sdiv_up64(defunc_0_f_res_292820,
                                           computed_group_sizze_299419));
            int32_t num_chunks_321376 = sext_i64_i32(sdiv_up64(s_n_m_292825,
                                                               computed_group_sizze_299419));
            unsigned int shared_sizze_326010 = bytes_318575;
            unsigned int shared_sizze_326012 = bytes_318656;
            unsigned int shared_sizze_326014 = bytes_318656;
            CUdeviceptr kernel_arg_326016 = ext_mem_318609.mem;
            CUdeviceptr kernel_arg_326017 = ext_mem_318610.mem;
            CUdeviceptr kernel_arg_326018 = mem_318665.mem;
            CUdeviceptr kernel_arg_326019 = mem_318670.mem;
            unsigned int shared_offset_326011 = 0;
            unsigned int shared_offset_326013 = 0 + (shared_sizze_326010 + (8 -
                                                                            shared_sizze_326010 %
                                                                            8) %
                                                     8);
            unsigned int shared_offset_326015 = 0 + (shared_sizze_326010 + (8 -
                                                                            shared_sizze_326010 %
                                                                            8) %
                                                     8) + (shared_sizze_326012 +
                                                           (8 -
                                                            shared_sizze_326012 %
                                                            8) % 8);
            
            if ((((((1 && binop_x_318547 != 0) && 1 != 0) && 1 != 0) &&
                  computed_group_sizze_299419 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = binop_x_318547;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_326007[] = {&ctx->global_failure,
                                              &ctx->failure_is_an_option,
                                              &ctx->global_failure_args,
                                              &shared_offset_326011,
                                              &shared_offset_326013,
                                              &shared_offset_326015,
                                              &n_p_292677, &q_s_292678,
                                              &jump_s_292684,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &pad_css_len_292821,
                                              &s_n_m_292825, &i_292895,
                                              &x_292896, &min_res_292926,
                                              &loop_cond_292931,
                                              &i64_res_292932,
                                              &computed_group_sizze_299419,
                                              &kernel_arg_326016,
                                              &kernel_arg_326017,
                                              &kernel_arg_326018,
                                              &kernel_arg_326019};
                int64_t time_start_326008 = 0, time_end_326009 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_intragroup_299433",
                            (long) binop_x_318547, (long) 1, (long) 1,
                            (long) computed_group_sizze_299419, (long) 1,
                            (long) 1, (int) (0 + (shared_sizze_326010 + (8 -
                                                                         shared_sizze_326010 %
                                                                         8) %
                                                  8) + (shared_sizze_326012 +
                                                        (8 -
                                                         shared_sizze_326012 %
                                                         8) % 8) +
                                             (shared_sizze_326014 + (8 -
                                                                     shared_sizze_326014 %
                                                                     8) % 8)));
                    time_start_326008 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_intragroup_299433_runs,
                                              &ctx->mainzisegmap_intragroup_299433_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_299433,
                                                      grid[0], grid[1], grid[2],
                                                      computed_group_sizze_299419,
                                                      1, 1, 0 +
                                                      (shared_sizze_326010 +
                                                       (8 -
                                                        shared_sizze_326010 %
                                                        8) % 8) +
                                                      (shared_sizze_326012 +
                                                       (8 -
                                                        shared_sizze_326012 %
                                                        8) % 8) +
                                                      (shared_sizze_326014 +
                                                       (8 -
                                                        shared_sizze_326014 %
                                                        8) % 8), NULL,
                                                      kernel_args_326007,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_326009 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_intragroup_299433", time_end_326009 -
                            time_start_326008);
                }
            }
            ctx->failure_is_an_option = 1;
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            if (memblock_set_device(ctx, &ext_mem_318706, &mem_318665,
                                    "mem_318665") != 0)
                return 1;
            if (memblock_set_device(ctx, &ext_mem_318705, &mem_318670,
                                    "mem_318670") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318670, "mem_318670") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318665, "mem_318665") != 0)
                return 1;
        } else {
            int64_t segmap_usable_groups_299565 = sdiv_up64(nest_sizze_297914,
                                                            segmap_group_sizze_299564);
            struct memblock_device mem_318676;
            
            mem_318676.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318676, bytes_318550,
                                      "mem_318676")) {
                err = 1;
                goto cleanup;
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            CUdeviceptr kernel_arg_326023 = ext_mem_318610.mem;
            CUdeviceptr kernel_arg_326024 = mem_318676.mem;
            
            if ((((((1 && segmap_usable_groups_299565 != 0) && 1 != 0) && 1 !=
                   0) && segmap_group_sizze_299564 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = segmap_usable_groups_299565;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_326020[] = {&ctx->global_failure, &n_p_292677,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &kernel_arg_326023,
                                              &kernel_arg_326024};
                int64_t time_start_326021 = 0, time_end_326022 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_299570",
                            (long) segmap_usable_groups_299565, (long) 1,
                            (long) 1, (long) segmap_group_sizze_299564,
                            (long) 1, (long) 1, (int) 0);
                    time_start_326021 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_299570_runs,
                                              &ctx->mainzisegmap_299570_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_299570,
                                                      grid[0], grid[1], grid[2],
                                                      segmap_group_sizze_299564,
                                                      1, 1, 0, NULL,
                                                      kernel_args_326020,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_326022 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_299570", time_end_326022 -
                            time_start_326021);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            
            int64_t segmap_usable_groups_299577 = sdiv_up64(binop_x_318547,
                                                            segmap_group_sizze_299576);
            struct memblock_device mem_318681;
            
            mem_318681.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318681, bytes_318570,
                                      "mem_318681")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_318685;
            
            mem_318685.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318685, bytes_318570,
                                      "mem_318685")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_318689;
            
            mem_318689.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318689, bytes_318570,
                                      "mem_318689")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_318693;
            
            mem_318693.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318693, bytes_318570,
                                      "mem_318693")) {
                err = 1;
                goto cleanup;
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            CUdeviceptr kernel_arg_326028 = ext_mem_318609.mem;
            CUdeviceptr kernel_arg_326029 = mem_318681.mem;
            CUdeviceptr kernel_arg_326030 = mem_318685.mem;
            CUdeviceptr kernel_arg_326031 = mem_318689.mem;
            CUdeviceptr kernel_arg_326032 = mem_318693.mem;
            
            if ((((((1 && segmap_usable_groups_299577 != 0) && 1 != 0) && 1 !=
                   0) && segmap_group_sizze_299576 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = segmap_usable_groups_299577;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_326025[] = {&ctx->global_failure, &n_p_292677,
                                              &q_s_292678,
                                              &partition_sizze_292766,
                                              &min_res_292926, &i64_res_292932,
                                              &kernel_arg_326028,
                                              &kernel_arg_326029,
                                              &kernel_arg_326030,
                                              &kernel_arg_326031,
                                              &kernel_arg_326032};
                int64_t time_start_326026 = 0, time_end_326027 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_299584",
                            (long) segmap_usable_groups_299577, (long) 1,
                            (long) 1, (long) segmap_group_sizze_299576,
                            (long) 1, (long) 1, (int) 0);
                    time_start_326026 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_299584_runs,
                                              &ctx->mainzisegmap_299584_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_299584,
                                                      grid[0], grid[1], grid[2],
                                                      segmap_group_sizze_299576,
                                                      1, 1, 0, NULL,
                                                      kernel_args_326025,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_326027 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_299584", time_end_326027 -
                            time_start_326026);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            
            int64_t segmap_usable_groups_299602 = sdiv_up64(nest_sizze_299600,
                                                            segmap_group_sizze_299601);
            struct memblock_device mem_318699;
            
            mem_318699.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318699, bytes_318642,
                                      "mem_318699")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_318704;
            
            mem_318704.references = NULL;
            if (memblock_alloc_device(ctx, &mem_318704, bytes_318642,
                                      "mem_318704")) {
                err = 1;
                goto cleanup;
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            CUdeviceptr kernel_arg_326036 = mem_318676.mem;
            CUdeviceptr kernel_arg_326037 = mem_318681.mem;
            CUdeviceptr kernel_arg_326038 = mem_318685.mem;
            CUdeviceptr kernel_arg_326039 = mem_318689.mem;
            CUdeviceptr kernel_arg_326040 = mem_318693.mem;
            CUdeviceptr kernel_arg_326041 = mem_318699.mem;
            CUdeviceptr kernel_arg_326042 = mem_318704.mem;
            
            if ((((((1 && segmap_usable_groups_299602 != 0) && 1 != 0) && 1 !=
                   0) && segmap_group_sizze_299601 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = segmap_usable_groups_299602;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_326033[] = {&ctx->global_failure,
                                              &ctx->failure_is_an_option,
                                              &ctx->global_failure_args,
                                              &n_p_292677, &jump_s_292684,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &pad_css_len_292821,
                                              &s_n_m_292825, &i_292895,
                                              &x_292896, &min_res_292926,
                                              &loop_cond_292931,
                                              &kernel_arg_326036,
                                              &kernel_arg_326037,
                                              &kernel_arg_326038,
                                              &kernel_arg_326039,
                                              &kernel_arg_326040,
                                              &kernel_arg_326041,
                                              &kernel_arg_326042};
                int64_t time_start_326034 = 0, time_end_326035 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_299608",
                            (long) segmap_usable_groups_299602, (long) 1,
                            (long) 1, (long) segmap_group_sizze_299601,
                            (long) 1, (long) 1, (int) 0);
                    time_start_326034 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_299608_runs,
                                              &ctx->mainzisegmap_299608_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_299608,
                                                      grid[0], grid[1], grid[2],
                                                      segmap_group_sizze_299601,
                                                      1, 1, 0, NULL,
                                                      kernel_args_326033,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_326035 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_299608", time_end_326035 -
                            time_start_326034);
                }
            }
            ctx->failure_is_an_option = 1;
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            if (memblock_unref_device(ctx, &mem_318676, "mem_318676") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318681, "mem_318681") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318685, "mem_318685") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318689, "mem_318689") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318693, "mem_318693") != 0)
                return 1;
            if (memblock_set_device(ctx, &ext_mem_318706, &mem_318704,
                                    "mem_318704") != 0)
                return 1;
            if (memblock_set_device(ctx, &ext_mem_318705, &mem_318699,
                                    "mem_318699") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318704, "mem_318704") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318699, "mem_318699") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318693, "mem_318693") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318689, "mem_318689") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318685, "mem_318685") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318681, "mem_318681") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318676, "mem_318676") != 0)
                return 1;
        }
        if (memblock_set_device(ctx, &ext_mem_318708, &ext_mem_318706,
                                "ext_mem_318706") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318707, &ext_mem_318705,
                                "ext_mem_318705") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318705, "ext_mem_318705") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318706, "ext_mem_318706") != 0)
            return 1;
    }
    
    int64_t min_res_293058 = smin64(n_292675, q_l_292680);
    bool bounds_invalid_upwards_293059 = slt64(l_n_m_292832, (int64_t) 0);
    bool valid_293060 = !bounds_invalid_upwards_293059;
    bool range_valid_c_293061;
    
    if (!valid_293060) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) l_n_m_292832, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:638:3-665:10\n   #4  loess.fut:698:15-61\n   #5  stl.fut:148:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:146:5-149:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool loop_cond_293063 = slt64((int64_t) 1, min_res_293058);
    double i64_res_293064 = sitofp_i64_f64(q_l_292680);
    int64_t intra_avail_par_299823 = smin64(n_292675, l_n_m_292832);
    int64_t computed_group_sizze_299725 = smax64(n_292675, l_n_m_292832);
    bool fits_299829 = sle64(computed_group_sizze_299725,
                             max_group_sizze_297635);
    bool suff_intra_par_299827;
    
    suff_intra_par_299827 = *ctx->tuning_params.mainzisuff_intra_par_5 <=
        intra_avail_par_299823;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n", "main.suff_intra_par_5",
                (long) intra_avail_par_299823,
                suff_intra_par_299827 ? "true" : "false");
    
    bool intra_suff_and_fits_299830 = suff_intra_par_299827 && fits_299829;
    int64_t segmap_group_sizze_300213;
    
    segmap_group_sizze_300213 =
        *ctx->tuning_params.mainzisegmap_group_sizze_300189;
    
    int64_t segmap_group_sizze_300223;
    
    segmap_group_sizze_300223 =
        *ctx->tuning_params.mainzisegmap_group_sizze_300163;
    
    int64_t nest_sizze_300244 = partition_sizze_292766 * l_n_m_292832;
    int64_t segmap_group_sizze_300245;
    
    segmap_group_sizze_300245 =
        *ctx->tuning_params.mainzisegmap_group_sizze_299959;
    
    int64_t binop_y_318722 = (int64_t) 8 * nest_sizze_300244;
    int64_t bytes_318723 = smax64((int64_t) 0, binop_y_318722);
    int64_t binop_y_318715 = (int64_t) 8 * l_n_m_292832;
    int64_t bytes_318716 = smax64((int64_t) 0, binop_y_318715);
    struct memblock_device ext_mem_318757;
    
    ext_mem_318757.references = NULL;
    
    struct memblock_device ext_mem_318756;
    
    ext_mem_318756.references = NULL;
    
    int32_t local_memory_capacity_321515;
    
    local_memory_capacity_321515 = ctx->cuda.max_shared_memory;
    if (sle64(bytes_318716 + srem64((int64_t) 8 - srem64(bytes_318716,
                                                         (int64_t) 8),
                                    (int64_t) 8) + (bytes_318716 +
                                                    srem64((int64_t) 8 -
                                                           srem64(bytes_318716,
                                                                  (int64_t) 8),
                                                           (int64_t) 8)) +
              (bytes_318514 + srem64((int64_t) 8 - srem64(bytes_318514,
                                                          (int64_t) 8),
                                     (int64_t) 8)),
              sext_i32_i64(local_memory_capacity_321515)) &&
        intra_suff_and_fits_299830) {
        struct memblock_device mem_318724;
        
        mem_318724.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318724, bytes_318723,
                                  "mem_318724")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318728;
        
        mem_318728.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318728, bytes_318723,
                                  "mem_318728")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        int32_t num_chunks_321450 = sext_i64_i32(sdiv_up64(n_292675,
                                                           computed_group_sizze_299725));
        int32_t num_chunks_321451 = sext_i64_i32(sdiv_up64(l_n_m_292832,
                                                           computed_group_sizze_299725));
        unsigned int shared_sizze_326046 = bytes_318514;
        unsigned int shared_sizze_326048 = bytes_318716;
        unsigned int shared_sizze_326050 = bytes_318716;
        CUdeviceptr kernel_arg_326052 = ext_mem_318541.mem;
        CUdeviceptr kernel_arg_326053 = ext_mem_318542.mem;
        CUdeviceptr kernel_arg_326054 = mem_318724.mem;
        CUdeviceptr kernel_arg_326055 = mem_318728.mem;
        unsigned int shared_offset_326047 = 0;
        unsigned int shared_offset_326049 = 0 + (shared_sizze_326046 + (8 -
                                                                        shared_sizze_326046 %
                                                                        8) % 8);
        unsigned int shared_offset_326051 = 0 + (shared_sizze_326046 + (8 -
                                                                        shared_sizze_326046 %
                                                                        8) %
                                                 8) + (shared_sizze_326048 +
                                                       (8 -
                                                        shared_sizze_326048 %
                                                        8) % 8);
        
        if ((((((1 && partition_sizze_292766 != 0) && 1 != 0) && 1 != 0) &&
              computed_group_sizze_299725 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = partition_sizze_292766;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_326043[] = {&ctx->global_failure,
                                          &ctx->failure_is_an_option,
                                          &ctx->global_failure_args,
                                          &shared_offset_326047,
                                          &shared_offset_326049,
                                          &shared_offset_326051, &n_292675,
                                          &q_l_292680, &jump_l_292686,
                                          &partition_sizze_292766,
                                          &l_n_m_292832, &i_292846, &x_292847,
                                          &min_res_293058, &loop_cond_293063,
                                          &i64_res_293064,
                                          &computed_group_sizze_299725,
                                          &kernel_arg_326052,
                                          &kernel_arg_326053,
                                          &kernel_arg_326054,
                                          &kernel_arg_326055};
            int64_t time_start_326044 = 0, time_end_326045 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segmap_intragroup_299834",
                        (long) partition_sizze_292766, (long) 1, (long) 1,
                        (long) computed_group_sizze_299725, (long) 1, (long) 1,
                        (int) (0 + (shared_sizze_326046 + (8 -
                                                           shared_sizze_326046 %
                                                           8) % 8) +
                               (shared_sizze_326048 + (8 - shared_sizze_326048 %
                                                       8) % 8) +
                               (shared_sizze_326050 + (8 - shared_sizze_326050 %
                                                       8) % 8)));
                time_start_326044 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegmap_intragroup_299834_runs,
                                          &ctx->mainzisegmap_intragroup_299834_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_299834,
                                                  grid[0], grid[1], grid[2],
                                                  computed_group_sizze_299725,
                                                  1, 1, 0 +
                                                  (shared_sizze_326046 + (8 -
                                                                          shared_sizze_326046 %
                                                                          8) %
                                                   8) + (shared_sizze_326048 +
                                                         (8 -
                                                          shared_sizze_326048 %
                                                          8) % 8) +
                                                  (shared_sizze_326050 + (8 -
                                                                          shared_sizze_326050 %
                                                                          8) %
                                                   8), NULL, kernel_args_326043,
                                                  NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_326045 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segmap_intragroup_299834", time_end_326045 -
                        time_start_326044);
            }
        }
        ctx->failure_is_an_option = 1;
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        if (memblock_set_device(ctx, &ext_mem_318757, &mem_318724,
                                "mem_318724") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318756, &mem_318728,
                                "mem_318728") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318728, "mem_318728") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318724, "mem_318724") != 0)
            return 1;
    } else {
        int64_t segmap_usable_groups_300214 = sdiv_up64(nest_sizze_297748,
                                                        segmap_group_sizze_300213);
        struct memblock_device mem_318733;
        
        mem_318733.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318733, bytes_318522,
                                  "mem_318733")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        CUdeviceptr kernel_arg_326059 = ext_mem_318542.mem;
        CUdeviceptr kernel_arg_326060 = mem_318733.mem;
        
        if ((((((1 && segmap_usable_groups_300214 != 0) && 1 != 0) && 1 != 0) &&
              segmap_group_sizze_300213 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = segmap_usable_groups_300214;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_326056[] = {&ctx->global_failure, &n_292675,
                                          &partition_sizze_292766,
                                          &kernel_arg_326059,
                                          &kernel_arg_326060};
            int64_t time_start_326057 = 0, time_end_326058 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segmap_300218",
                        (long) segmap_usable_groups_300214, (long) 1, (long) 1,
                        (long) segmap_group_sizze_300213, (long) 1, (long) 1,
                        (int) 0);
                time_start_326057 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegmap_300218_runs,
                                          &ctx->mainzisegmap_300218_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_300218,
                                                  grid[0], grid[1], grid[2],
                                                  segmap_group_sizze_300213, 1,
                                                  1, 0, NULL,
                                                  kernel_args_326056, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_326058 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segmap_300218", time_end_326058 -
                        time_start_326057);
            }
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        
        int64_t segmap_usable_groups_300224 = sdiv_up64(partition_sizze_292766,
                                                        segmap_group_sizze_300223);
        struct memblock_device mem_318737;
        
        mem_318737.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318737, bytes_318525,
                                  "mem_318737")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318740;
        
        mem_318740.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318740, bytes_318525,
                                  "mem_318740")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318743;
        
        mem_318743.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318743, bytes_318525,
                                  "mem_318743")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318746;
        
        mem_318746.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318746, bytes_318525,
                                  "mem_318746")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        CUdeviceptr kernel_arg_326064 = ext_mem_318541.mem;
        CUdeviceptr kernel_arg_326065 = mem_318737.mem;
        CUdeviceptr kernel_arg_326066 = mem_318740.mem;
        CUdeviceptr kernel_arg_326067 = mem_318743.mem;
        CUdeviceptr kernel_arg_326068 = mem_318746.mem;
        
        if ((((((1 && segmap_usable_groups_300224 != 0) && 1 != 0) && 1 != 0) &&
              segmap_group_sizze_300223 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = segmap_usable_groups_300224;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_326061[] = {&ctx->global_failure, &q_l_292680,
                                          &partition_sizze_292766,
                                          &min_res_293058, &i64_res_293064,
                                          &kernel_arg_326064,
                                          &kernel_arg_326065,
                                          &kernel_arg_326066,
                                          &kernel_arg_326067,
                                          &kernel_arg_326068};
            int64_t time_start_326062 = 0, time_end_326063 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segmap_300230",
                        (long) segmap_usable_groups_300224, (long) 1, (long) 1,
                        (long) segmap_group_sizze_300223, (long) 1, (long) 1,
                        (int) 0);
                time_start_326062 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegmap_300230_runs,
                                          &ctx->mainzisegmap_300230_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_300230,
                                                  grid[0], grid[1], grid[2],
                                                  segmap_group_sizze_300223, 1,
                                                  1, 0, NULL,
                                                  kernel_args_326061, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_326063 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segmap_300230", time_end_326063 -
                        time_start_326062);
            }
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        
        int64_t segmap_usable_groups_300246 = sdiv_up64(nest_sizze_300244,
                                                        segmap_group_sizze_300245);
        struct memblock_device mem_318751;
        
        mem_318751.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318751, bytes_318723,
                                  "mem_318751")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318755;
        
        mem_318755.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318755, bytes_318723,
                                  "mem_318755")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        CUdeviceptr kernel_arg_326072 = ext_mem_318542.mem;
        CUdeviceptr kernel_arg_326073 = mem_318733.mem;
        CUdeviceptr kernel_arg_326074 = mem_318737.mem;
        CUdeviceptr kernel_arg_326075 = mem_318740.mem;
        CUdeviceptr kernel_arg_326076 = mem_318743.mem;
        CUdeviceptr kernel_arg_326077 = mem_318746.mem;
        CUdeviceptr kernel_arg_326078 = mem_318751.mem;
        CUdeviceptr kernel_arg_326079 = mem_318755.mem;
        
        if ((((((1 && segmap_usable_groups_300246 != 0) && 1 != 0) && 1 != 0) &&
              segmap_group_sizze_300245 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = segmap_usable_groups_300246;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_326069[] = {&ctx->global_failure,
                                          &ctx->failure_is_an_option,
                                          &ctx->global_failure_args, &n_292675,
                                          &jump_l_292686,
                                          &partition_sizze_292766,
                                          &l_n_m_292832, &i_292846, &x_292847,
                                          &min_res_293058, &loop_cond_293063,
                                          &kernel_arg_326072,
                                          &kernel_arg_326073,
                                          &kernel_arg_326074,
                                          &kernel_arg_326075,
                                          &kernel_arg_326076,
                                          &kernel_arg_326077,
                                          &kernel_arg_326078,
                                          &kernel_arg_326079};
            int64_t time_start_326070 = 0, time_end_326071 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segmap_300251",
                        (long) segmap_usable_groups_300246, (long) 1, (long) 1,
                        (long) segmap_group_sizze_300245, (long) 1, (long) 1,
                        (int) 0);
                time_start_326070 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegmap_300251_runs,
                                          &ctx->mainzisegmap_300251_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_300251,
                                                  grid[0], grid[1], grid[2],
                                                  segmap_group_sizze_300245, 1,
                                                  1, 0, NULL,
                                                  kernel_args_326069, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_326071 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segmap_300251", time_end_326071 -
                        time_start_326070);
            }
        }
        ctx->failure_is_an_option = 1;
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        if (memblock_unref_device(ctx, &mem_318733, "mem_318733") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318737, "mem_318737") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318740, "mem_318740") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318743, "mem_318743") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318746, "mem_318746") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318757, &mem_318755,
                                "mem_318755") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318756, &mem_318751,
                                "mem_318751") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318755, "mem_318755") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318751, "mem_318751") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318746, "mem_318746") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318743, "mem_318743") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318740, "mem_318740") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318737, "mem_318737") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318733, "mem_318733") != 0)
            return 1;
    }
    
    int64_t min_res_293170 = smin64(n_292675, q_t_292679);
    bool bounds_invalid_upwards_293171 = slt64(t_n_m_292839, (int64_t) 0);
    bool valid_293172 = !bounds_invalid_upwards_293171;
    bool range_valid_c_293173;
    
    if (!valid_293172) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) t_n_m_292839, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:638:3-665:10\n   #4  loess.fut:698:15-61\n   #5  stl.fut:155:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:153:5-156:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool loop_cond_293175 = slt64((int64_t) 1, min_res_293170);
    double i64_res_293176 = sitofp_i64_f64(q_t_292679);
    int64_t intra_avail_par_300449 = smin64(n_292675, t_n_m_292839);
    int64_t computed_group_sizze_300351 = smax64(n_292675, t_n_m_292839);
    bool fits_300455 = sle64(computed_group_sizze_300351,
                             max_group_sizze_297635);
    bool suff_intra_par_300453;
    
    suff_intra_par_300453 = *ctx->tuning_params.mainzisuff_intra_par_6 <=
        intra_avail_par_300449;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n", "main.suff_intra_par_6",
                (long) intra_avail_par_300449,
                suff_intra_par_300453 ? "true" : "false");
    
    bool intra_suff_and_fits_300456 = suff_intra_par_300453 && fits_300455;
    int64_t segmap_group_sizze_300839;
    
    segmap_group_sizze_300839 =
        *ctx->tuning_params.mainzisegmap_group_sizze_300815;
    
    int64_t segmap_group_sizze_300849;
    
    segmap_group_sizze_300849 =
        *ctx->tuning_params.mainzisegmap_group_sizze_300789;
    
    int64_t nest_sizze_300870 = partition_sizze_292766 * t_n_m_292839;
    int64_t segmap_group_sizze_300871;
    
    segmap_group_sizze_300871 =
        *ctx->tuning_params.mainzisegmap_group_sizze_300585;
    
    int64_t binop_y_318771 = (int64_t) 8 * nest_sizze_300870;
    int64_t bytes_318772 = smax64((int64_t) 0, binop_y_318771);
    int64_t binop_y_318764 = (int64_t) 8 * t_n_m_292839;
    int64_t bytes_318765 = smax64((int64_t) 0, binop_y_318764);
    struct memblock_device ext_mem_318806;
    
    ext_mem_318806.references = NULL;
    
    struct memblock_device ext_mem_318805;
    
    ext_mem_318805.references = NULL;
    
    int32_t local_memory_capacity_321581;
    
    local_memory_capacity_321581 = ctx->cuda.max_shared_memory;
    if (sle64(bytes_318765 + srem64((int64_t) 8 - srem64(bytes_318765,
                                                         (int64_t) 8),
                                    (int64_t) 8) + (bytes_318765 +
                                                    srem64((int64_t) 8 -
                                                           srem64(bytes_318765,
                                                                  (int64_t) 8),
                                                           (int64_t) 8)) +
              (bytes_318514 + srem64((int64_t) 8 - srem64(bytes_318514,
                                                          (int64_t) 8),
                                     (int64_t) 8)),
              sext_i32_i64(local_memory_capacity_321581)) &&
        intra_suff_and_fits_300456) {
        struct memblock_device mem_318773;
        
        mem_318773.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318773, bytes_318772,
                                  "mem_318773")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318777;
        
        mem_318777.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318777, bytes_318772,
                                  "mem_318777")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        int32_t num_chunks_321516 = sext_i64_i32(sdiv_up64(n_292675,
                                                           computed_group_sizze_300351));
        int32_t num_chunks_321517 = sext_i64_i32(sdiv_up64(t_n_m_292839,
                                                           computed_group_sizze_300351));
        unsigned int shared_sizze_326083 = bytes_318514;
        unsigned int shared_sizze_326085 = bytes_318765;
        unsigned int shared_sizze_326087 = bytes_318765;
        CUdeviceptr kernel_arg_326089 = ext_mem_318541.mem;
        CUdeviceptr kernel_arg_326090 = ext_mem_318542.mem;
        CUdeviceptr kernel_arg_326091 = mem_318773.mem;
        CUdeviceptr kernel_arg_326092 = mem_318777.mem;
        unsigned int shared_offset_326084 = 0;
        unsigned int shared_offset_326086 = 0 + (shared_sizze_326083 + (8 -
                                                                        shared_sizze_326083 %
                                                                        8) % 8);
        unsigned int shared_offset_326088 = 0 + (shared_sizze_326083 + (8 -
                                                                        shared_sizze_326083 %
                                                                        8) %
                                                 8) + (shared_sizze_326085 +
                                                       (8 -
                                                        shared_sizze_326085 %
                                                        8) % 8);
        
        if ((((((1 && partition_sizze_292766 != 0) && 1 != 0) && 1 != 0) &&
              computed_group_sizze_300351 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = partition_sizze_292766;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_326080[] = {&ctx->global_failure,
                                          &ctx->failure_is_an_option,
                                          &ctx->global_failure_args,
                                          &shared_offset_326084,
                                          &shared_offset_326086,
                                          &shared_offset_326088, &n_292675,
                                          &q_t_292679, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &t_n_m_292839, &i_292846, &x_292847,
                                          &min_res_293170, &loop_cond_293175,
                                          &i64_res_293176,
                                          &computed_group_sizze_300351,
                                          &kernel_arg_326089,
                                          &kernel_arg_326090,
                                          &kernel_arg_326091,
                                          &kernel_arg_326092};
            int64_t time_start_326081 = 0, time_end_326082 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segmap_intragroup_300460",
                        (long) partition_sizze_292766, (long) 1, (long) 1,
                        (long) computed_group_sizze_300351, (long) 1, (long) 1,
                        (int) (0 + (shared_sizze_326083 + (8 -
                                                           shared_sizze_326083 %
                                                           8) % 8) +
                               (shared_sizze_326085 + (8 - shared_sizze_326085 %
                                                       8) % 8) +
                               (shared_sizze_326087 + (8 - shared_sizze_326087 %
                                                       8) % 8)));
                time_start_326081 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegmap_intragroup_300460_runs,
                                          &ctx->mainzisegmap_intragroup_300460_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_300460,
                                                  grid[0], grid[1], grid[2],
                                                  computed_group_sizze_300351,
                                                  1, 1, 0 +
                                                  (shared_sizze_326083 + (8 -
                                                                          shared_sizze_326083 %
                                                                          8) %
                                                   8) + (shared_sizze_326085 +
                                                         (8 -
                                                          shared_sizze_326085 %
                                                          8) % 8) +
                                                  (shared_sizze_326087 + (8 -
                                                                          shared_sizze_326087 %
                                                                          8) %
                                                   8), NULL, kernel_args_326080,
                                                  NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_326082 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segmap_intragroup_300460", time_end_326082 -
                        time_start_326081);
            }
        }
        ctx->failure_is_an_option = 1;
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        if (memblock_set_device(ctx, &ext_mem_318806, &mem_318773,
                                "mem_318773") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318805, &mem_318777,
                                "mem_318777") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318777, "mem_318777") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318773, "mem_318773") != 0)
            return 1;
    } else {
        int64_t segmap_usable_groups_300840 = sdiv_up64(nest_sizze_297748,
                                                        segmap_group_sizze_300839);
        struct memblock_device mem_318782;
        
        mem_318782.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318782, bytes_318522,
                                  "mem_318782")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        CUdeviceptr kernel_arg_326096 = ext_mem_318542.mem;
        CUdeviceptr kernel_arg_326097 = mem_318782.mem;
        
        if ((((((1 && segmap_usable_groups_300840 != 0) && 1 != 0) && 1 != 0) &&
              segmap_group_sizze_300839 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = segmap_usable_groups_300840;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_326093[] = {&ctx->global_failure, &n_292675,
                                          &partition_sizze_292766,
                                          &kernel_arg_326096,
                                          &kernel_arg_326097};
            int64_t time_start_326094 = 0, time_end_326095 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segmap_300844",
                        (long) segmap_usable_groups_300840, (long) 1, (long) 1,
                        (long) segmap_group_sizze_300839, (long) 1, (long) 1,
                        (int) 0);
                time_start_326094 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegmap_300844_runs,
                                          &ctx->mainzisegmap_300844_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_300844,
                                                  grid[0], grid[1], grid[2],
                                                  segmap_group_sizze_300839, 1,
                                                  1, 0, NULL,
                                                  kernel_args_326093, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_326095 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segmap_300844", time_end_326095 -
                        time_start_326094);
            }
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        
        int64_t segmap_usable_groups_300850 = sdiv_up64(partition_sizze_292766,
                                                        segmap_group_sizze_300849);
        struct memblock_device mem_318786;
        
        mem_318786.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318786, bytes_318525,
                                  "mem_318786")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318789;
        
        mem_318789.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318789, bytes_318525,
                                  "mem_318789")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318792;
        
        mem_318792.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318792, bytes_318525,
                                  "mem_318792")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318795;
        
        mem_318795.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318795, bytes_318525,
                                  "mem_318795")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        CUdeviceptr kernel_arg_326101 = ext_mem_318541.mem;
        CUdeviceptr kernel_arg_326102 = mem_318786.mem;
        CUdeviceptr kernel_arg_326103 = mem_318789.mem;
        CUdeviceptr kernel_arg_326104 = mem_318792.mem;
        CUdeviceptr kernel_arg_326105 = mem_318795.mem;
        
        if ((((((1 && segmap_usable_groups_300850 != 0) && 1 != 0) && 1 != 0) &&
              segmap_group_sizze_300849 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = segmap_usable_groups_300850;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_326098[] = {&ctx->global_failure, &q_t_292679,
                                          &partition_sizze_292766,
                                          &min_res_293170, &i64_res_293176,
                                          &kernel_arg_326101,
                                          &kernel_arg_326102,
                                          &kernel_arg_326103,
                                          &kernel_arg_326104,
                                          &kernel_arg_326105};
            int64_t time_start_326099 = 0, time_end_326100 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segmap_300856",
                        (long) segmap_usable_groups_300850, (long) 1, (long) 1,
                        (long) segmap_group_sizze_300849, (long) 1, (long) 1,
                        (int) 0);
                time_start_326099 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegmap_300856_runs,
                                          &ctx->mainzisegmap_300856_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_300856,
                                                  grid[0], grid[1], grid[2],
                                                  segmap_group_sizze_300849, 1,
                                                  1, 0, NULL,
                                                  kernel_args_326098, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_326100 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segmap_300856", time_end_326100 -
                        time_start_326099);
            }
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        
        int64_t segmap_usable_groups_300872 = sdiv_up64(nest_sizze_300870,
                                                        segmap_group_sizze_300871);
        struct memblock_device mem_318800;
        
        mem_318800.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318800, bytes_318772,
                                  "mem_318800")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318804;
        
        mem_318804.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318804, bytes_318772,
                                  "mem_318804")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        CUdeviceptr kernel_arg_326109 = ext_mem_318542.mem;
        CUdeviceptr kernel_arg_326110 = mem_318782.mem;
        CUdeviceptr kernel_arg_326111 = mem_318786.mem;
        CUdeviceptr kernel_arg_326112 = mem_318789.mem;
        CUdeviceptr kernel_arg_326113 = mem_318792.mem;
        CUdeviceptr kernel_arg_326114 = mem_318795.mem;
        CUdeviceptr kernel_arg_326115 = mem_318800.mem;
        CUdeviceptr kernel_arg_326116 = mem_318804.mem;
        
        if ((((((1 && segmap_usable_groups_300872 != 0) && 1 != 0) && 1 != 0) &&
              segmap_group_sizze_300871 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = segmap_usable_groups_300872;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_326106[] = {&ctx->global_failure,
                                          &ctx->failure_is_an_option,
                                          &ctx->global_failure_args, &n_292675,
                                          &jump_t_292685,
                                          &partition_sizze_292766,
                                          &t_n_m_292839, &i_292846, &x_292847,
                                          &min_res_293170, &loop_cond_293175,
                                          &kernel_arg_326109,
                                          &kernel_arg_326110,
                                          &kernel_arg_326111,
                                          &kernel_arg_326112,
                                          &kernel_arg_326113,
                                          &kernel_arg_326114,
                                          &kernel_arg_326115,
                                          &kernel_arg_326116};
            int64_t time_start_326107 = 0, time_end_326108 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "main.segmap_300877",
                        (long) segmap_usable_groups_300872, (long) 1, (long) 1,
                        (long) segmap_group_sizze_300871, (long) 1, (long) 1,
                        (int) 0);
                time_start_326107 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->mainzisegmap_300877_runs,
                                          &ctx->mainzisegmap_300877_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_300877,
                                                  grid[0], grid[1], grid[2],
                                                  segmap_group_sizze_300871, 1,
                                                  1, 0, NULL,
                                                  kernel_args_326106, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_326108 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "main.segmap_300877", time_end_326108 -
                        time_start_326107);
            }
        }
        ctx->failure_is_an_option = 1;
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        if (memblock_unref_device(ctx, &mem_318782, "mem_318782") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318786, "mem_318786") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318789, "mem_318789") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318792, "mem_318792") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318795, "mem_318795") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318806, &mem_318804,
                                "mem_318804") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318805, &mem_318800,
                                "mem_318800") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318804, "mem_318804") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318800, "mem_318800") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318795, "mem_318795") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318792, "mem_318792") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318789, "mem_318789") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318786, "mem_318786") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318782, "mem_318782") != 0)
            return 1;
    }
    
    struct memblock_device mem_318810;
    
    mem_318810.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318810, bytes_318522, "mem_318810")) {
        err = 1;
        goto cleanup;
    }
    if (futrts_builtinzhreplicate_f64(ctx, mem_318810, partition_sizze_292766 *
                                      n_292675, 0.0) != 0) {
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    struct memblock_device mem_318814;
    
    mem_318814.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318814, bytes_318522, "mem_318814")) {
        err = 1;
        goto cleanup;
    }
    if (futrts_builtinzhreplicate_f64(ctx, mem_318814, partition_sizze_292766 *
                                      n_292675, 1.0) != 0) {
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool cond_293285 = slt64((int64_t) 1, jump_l_292686);
    bool cond_293286 = slt64((int64_t) 1, jump_t_292685);
    int64_t y_293287 = sub64(n_outer_292688, (int64_t) 1);
    int64_t css_results_l_293288;
    
    if (cond_292824) {
        css_results_l_293288 = s_n_m_292825;
    } else {
        css_results_l_293288 = pad_css_len_292821;
    }
    
    bool zzero_293289 = n_p_292677 == (int64_t) 0;
    bool nonzzero_293290 = !zzero_293289;
    bool loop_not_taken_293291 = !assert_cond_292815;
    bool protect_assert_disj_293292 = nonzzero_293290 || loop_not_taken_293291;
    bool loop_not_taken_293293 = !assert_cond_292817;
    bool protect_assert_disj_293294 = protect_assert_disj_293292 ||
         loop_not_taken_293293;
    bool nonzzero_cert_293295;
    
    if (!protect_assert_disj_293294) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "division by zero",
                               "-> #0  stl.fut:228:51-57\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:228:28-74\n   #5  stl.fut:227:21-229:39\n   #6  stl.fut:419:61-435:77\n   #7  stl.fut:463:3-479:36\n   #8  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t j_293296 = add64(n_292675, n_p_292677);
    bool empty_slice_293297 = n_292675 == (int64_t) 0;
    int64_t i_p_m_t_s_293298 = add64(n_p_292677, i_292846);
    bool zzero_leq_i_p_m_t_s_293299 = sle64((int64_t) 0, i_p_m_t_s_293298);
    bool i_p_m_t_s_leq_w_293300 = slt64(i_p_m_t_s_293298, C_len_292823);
    bool zzero_lte_i_293301 = sle64((int64_t) 0, n_p_292677);
    bool i_lte_j_293302 = sle64(n_p_292677, j_293296);
    bool y_293303 = i_p_m_t_s_leq_w_293300 && zzero_lte_i_293301;
    bool y_293304 = zzero_leq_i_p_m_t_s_293299 && y_293303;
    bool y_293305 = i_lte_j_293302 && y_293304;
    bool forwards_ok_293306 = zzero_lte_i_293301 && y_293305;
    bool ok_or_empty_293307 = empty_slice_293297 || forwards_ok_293306;
    bool protect_assert_disj_293308 = loop_not_taken_293291 ||
         ok_or_empty_293307;
    bool protect_assert_disj_293309 = loop_not_taken_293293 ||
         protect_assert_disj_293308;
    bool index_certs_293310;
    
    if (!protect_assert_disj_293309) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) n_p_292677, ":",
                               (long long) j_293296,
                               "] out of bounds for array of shape [",
                               (long long) C_len_292823, "].",
                               "-> #0  stl.fut:266:35-50\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  stl.fut:264:13-269:26\n   #4  stl.fut:419:61-435:77\n   #5  stl.fut:463:3-479:36\n   #6  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t lifted_single_ma_l_arg_293311 = add64((int64_t) 1, j_293296);
    int64_t m_293312 = sub64(n_p_292677, (int64_t) 1);
    bool zzero_leq_i_p_m_t_s_293313 = sle64((int64_t) 0, m_293312);
    bool i_p_m_t_s_leq_w_293314 = slt64(m_293312, C_len_292823);
    bool y_293315 = zzero_leq_i_p_m_t_s_293313 && i_p_m_t_s_leq_w_293314;
    bool y_293316 = zzero_lte_i_293301 && y_293315;
    bool ok_or_empty_293317 = zzero_293289 || y_293316;
    bool protect_assert_disj_293318 = loop_not_taken_293291 ||
         ok_or_empty_293317;
    bool protect_assert_disj_293319 = loop_not_taken_293293 ||
         protect_assert_disj_293318;
    bool index_certs_293320;
    
    if (!protect_assert_disj_293319) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) n_p_292677,
                               "] out of bounds for array of shape [",
                               (long long) C_len_292823, "].",
                               "-> #0  stl.fut:26:37-43\n   #1  stl.fut:26:20-48\n   #2  stl.fut:40:3-36\n   #3  stl.fut:233:23-47\n   #4  stl.fut:419:61-435:77\n   #5  stl.fut:463:3-479:36\n   #6  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t dyn_lifted_single_ma_l_arg_293321 = add64((int64_t) 2, n_292675);
    bool i_p_m_t_s_leq_w_293322 = slt64(m_293312,
                                        lifted_single_ma_l_arg_293311);
    bool y_293323 = zzero_leq_i_p_m_t_s_293313 && i_p_m_t_s_leq_w_293322;
    bool y_293324 = zzero_lte_i_293301 && y_293323;
    bool ok_or_empty_293325 = zzero_293289 || y_293324;
    bool protect_assert_disj_293326 = loop_not_taken_293291 ||
         ok_or_empty_293325;
    bool protect_assert_disj_293327 = loop_not_taken_293293 ||
         protect_assert_disj_293326;
    bool index_certs_293328;
    
    if (!protect_assert_disj_293327) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) n_p_292677,
                               "] out of bounds for array of shape [",
                               (long long) lifted_single_ma_l_arg_293311, "].",
                               "-> #0  stl.fut:26:37-43\n   #1  stl.fut:26:20-48\n   #2  /prelude/functional.fut:9:42-44\n   #3  stl.fut:40:3-64\n   #4  stl.fut:233:23-47\n   #5  stl.fut:419:61-435:77\n   #6  stl.fut:463:3-479:36\n   #7  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool i_p_m_t_s_leq_w_293329 = slt64((int64_t) 2,
                                        dyn_lifted_single_ma_l_arg_293321);
    bool protect_assert_disj_293330 = loop_not_taken_293291 ||
         i_p_m_t_s_leq_w_293329;
    bool protect_assert_disj_293331 = loop_not_taken_293293 ||
         protect_assert_disj_293330;
    bool index_certs_293332;
    
    if (!protect_assert_disj_293331) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) (int64_t) 3,
                               "] out of bounds for array of shape [",
                               (long long) dyn_lifted_single_ma_l_arg_293321,
                               "].",
                               "-> #0  stl.fut:26:37-43\n   #1  stl.fut:26:20-48\n   #2  /prelude/functional.fut:9:42-44\n   #3  stl.fut:40:3-84\n   #4  stl.fut:233:23-47\n   #5  stl.fut:419:61-435:77\n   #6  stl.fut:463:3-479:36\n   #7  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool cond_293333 = slt64(jump_l_292686, jump_threshold_1_292689);
    bool cond_293334 = slt64(jump_l_292686, jump_threshold_2_292690);
    bool cond_f_res_t_res_293335 = slt64(q_l_292680, q_threshold_2_292692);
    bool x_293336 = cond_293334 && cond_f_res_t_res_293335;
    bool x_293337 = !cond_293333;
    bool y_293338 = x_293336 && x_293337;
    bool cond_293339 = cond_293333 || y_293338;
    bool cond_293340 = slt64(jump_t_292685, jump_threshold_1_292689);
    bool cond_293341 = slt64(jump_t_292685, jump_threshold_2_292690);
    bool cond_f_res_t_res_293342 = slt64(q_t_292679, q_threshold_2_292692);
    bool x_293343 = cond_293341 && cond_f_res_t_res_293342;
    bool x_293344 = !cond_293340;
    bool y_293345 = x_293343 && x_293344;
    bool cond_293346 = cond_293340 || y_293345;
    bool cond_293347 = slt64(jump_s_292684, jump_threshold_1_292689);
    bool cond_293348 = slt64(jump_s_292684, jump_threshold_2_292690);
    bool cond_f_res_t_res_293349 = slt64(q_s_292678, q_threshold_2_292692);
    bool x_293350 = cond_293348 && cond_f_res_t_res_293349;
    bool x_293351 = !cond_293347;
    bool y_293352 = x_293350 && x_293351;
    bool cond_293353 = cond_293347 || y_293352;
    bool bounds_invalid_upwards_293354 = slt64(C_len_292823, (int64_t) 0);
    bool valid_293355 = !bounds_invalid_upwards_293354;
    bool protect_assert_disj_293356 = loop_not_taken_293291 || valid_293355;
    bool protect_assert_disj_293357 = loop_not_taken_293293 ||
         protect_assert_disj_293356;
    bool range_valid_c_293358;
    
    if (!protect_assert_disj_293357) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) C_len_292823, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:228:28-74\n   #4  stl.fut:227:21-229:39\n   #5  stl.fut:419:61-435:77\n   #6  stl.fut:463:3-479:36\n   #7  stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_293360 = slt64(lifted_single_ma_l_arg_293311,
                                               (int64_t) 0);
    bool valid_293361 = !bounds_invalid_upwards_293360;
    bool protect_assert_disj_293362 = loop_not_taken_293291 || valid_293361;
    bool protect_assert_disj_293363 = loop_not_taken_293293 ||
         protect_assert_disj_293362;
    bool range_valid_c_293364;
    
    if (!protect_assert_disj_293363) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) lifted_single_ma_l_arg_293311,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:29:13-35:19\n   #4  /prelude/soacs.fut:67:19-23\n   #5  /prelude/soacs.fut:67:3-37\n   #6  stl.fut:28:5-36:23\n   #7  stl.fut:40:3-36\n   #8  stl.fut:233:23-47\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_293366 =
         slt64(dyn_lifted_single_ma_l_arg_293321, (int64_t) 0);
    bool valid_293367 = !bounds_invalid_upwards_293366;
    bool protect_assert_disj_293368 = loop_not_taken_293291 || valid_293367;
    bool protect_assert_disj_293369 = loop_not_taken_293293 ||
         protect_assert_disj_293368;
    bool range_valid_c_293370;
    
    if (!protect_assert_disj_293369) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) dyn_lifted_single_ma_l_arg_293321,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:29:13-35:19\n   #4  /prelude/soacs.fut:67:19-23\n   #5  /prelude/soacs.fut:67:3-37\n   #6  stl.fut:28:5-36:23\n   #7  /prelude/functional.fut:9:42-44\n   #8  stl.fut:40:3-64\n   #9  stl.fut:233:23-47\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t segmap_group_sizze_301016;
    
    segmap_group_sizze_301016 =
        *ctx->tuning_params.mainzisegmap_group_sizze_300988;
    
    int64_t segmap_usable_groups_301017 = sdiv_up_safe64(nest_sizze_297748,
                                                         segmap_group_sizze_301016);
    int64_t segmap_group_sizze_301160;
    
    segmap_group_sizze_301160 =
        *ctx->tuning_params.mainzisegmap_group_sizze_301054;
    
    int64_t segmap_usable_groups_301161 = sdiv_up_safe64(nest_sizze_297914,
                                                         segmap_group_sizze_301160);
    int64_t nest_sizze_308784 = partition_sizze_292766 * C_len_292823;
    int64_t segmap_group_sizze_308785;
    
    segmap_group_sizze_308785 =
        *ctx->tuning_params.mainzisegmap_group_sizze_308739;
    
    int64_t segmap_usable_groups_308786 = sdiv_up_safe64(nest_sizze_308784,
                                                         segmap_group_sizze_308785);
    bool suff_outer_par_308806;
    
    suff_outer_par_308806 = *ctx->tuning_params.mainzisuff_outer_par_13 <=
        partition_sizze_292766;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n", "main.suff_outer_par_13",
                (long) partition_sizze_292766,
                suff_outer_par_308806 ? "true" : "false");
    
    int64_t segmap_group_sizze_308822;
    
    segmap_group_sizze_308822 =
        *ctx->tuning_params.mainzisegmap_group_sizze_308810;
    
    int64_t segred_group_sizze_308853;
    
    segred_group_sizze_308853 =
        *ctx->tuning_params.mainzisegred_group_sizze_308836;
    
    int64_t num_groups_308854;
    int32_t max_num_groups_321594;
    
    max_num_groups_321594 = *ctx->tuning_params.mainzisegred_num_groups_308838;
    num_groups_308854 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(binop_x_318547,
                                                             segred_group_sizze_308853),
                                                   sext_i32_i64(max_num_groups_321594))));
    
    int64_t nest_sizze_308904 = partition_sizze_292766 *
            lifted_single_ma_l_arg_293311;
    int64_t segscan_group_sizze_308905;
    
    segscan_group_sizze_308905 =
        *ctx->tuning_params.mainzisegscan_group_sizze_308869;
    
    int64_t num_groups_308906;
    int32_t max_num_groups_321595;
    
    max_num_groups_321595 = *ctx->tuning_params.mainzisegscan_num_groups_308871;
    num_groups_308906 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(nest_sizze_308904,
                                                             segscan_group_sizze_308905),
                                                   sext_i32_i64(max_num_groups_321595))));
    
    bool suff_outer_par_308937;
    
    suff_outer_par_308937 = *ctx->tuning_params.mainzisuff_outer_par_14 <=
        partition_sizze_292766;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n", "main.suff_outer_par_14",
                (long) partition_sizze_292766,
                suff_outer_par_308937 ? "true" : "false");
    
    int64_t segmap_group_sizze_308953;
    
    segmap_group_sizze_308953 =
        *ctx->tuning_params.mainzisegmap_group_sizze_308941;
    
    int64_t segred_group_sizze_308984;
    
    segred_group_sizze_308984 =
        *ctx->tuning_params.mainzisegred_group_sizze_308967;
    
    int64_t num_groups_308985;
    int32_t max_num_groups_321596;
    
    max_num_groups_321596 = *ctx->tuning_params.mainzisegred_num_groups_308969;
    num_groups_308985 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(binop_x_318547,
                                                             segred_group_sizze_308984),
                                                   sext_i32_i64(max_num_groups_321596))));
    
    int64_t nest_sizze_309035 = partition_sizze_292766 *
            dyn_lifted_single_ma_l_arg_293321;
    int64_t segscan_group_sizze_309036;
    
    segscan_group_sizze_309036 =
        *ctx->tuning_params.mainzisegscan_group_sizze_309000;
    
    int64_t num_groups_309037;
    int32_t max_num_groups_321597;
    
    max_num_groups_321597 = *ctx->tuning_params.mainzisegscan_num_groups_309002;
    num_groups_309037 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(nest_sizze_309035,
                                                             segscan_group_sizze_309036),
                                                   sext_i32_i64(max_num_groups_321597))));
    
    bool suff_outer_par_309068;
    
    suff_outer_par_309068 = *ctx->tuning_params.mainzisuff_outer_par_15 <=
        partition_sizze_292766;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n", "main.suff_outer_par_15",
                (long) partition_sizze_292766,
                suff_outer_par_309068 ? "true" : "false");
    
    int64_t segmap_group_sizze_309084;
    
    segmap_group_sizze_309084 =
        *ctx->tuning_params.mainzisegmap_group_sizze_309072;
    
    int64_t nest_sizze_309114 = (int64_t) 3 * partition_sizze_292766;
    int64_t segred_group_sizze_309115;
    
    segred_group_sizze_309115 =
        *ctx->tuning_params.mainzisegred_group_sizze_309098;
    
    int64_t num_groups_309116;
    int32_t max_num_groups_321598;
    
    max_num_groups_321598 = *ctx->tuning_params.mainzisegred_num_groups_309100;
    num_groups_309116 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(nest_sizze_309114,
                                                             segred_group_sizze_309115),
                                                   sext_i32_i64(max_num_groups_321598))));
    
    int64_t segscan_group_sizze_309167;
    
    segscan_group_sizze_309167 =
        *ctx->tuning_params.mainzisegscan_group_sizze_309131;
    
    int64_t num_groups_309168;
    int32_t max_num_groups_321599;
    
    max_num_groups_321599 = *ctx->tuning_params.mainzisegscan_num_groups_309133;
    num_groups_309168 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(nest_sizze_297748,
                                                             segscan_group_sizze_309167),
                                                   sext_i32_i64(max_num_groups_321599))));
    
    int64_t segmap_group_sizze_312169;
    
    segmap_group_sizze_312169 =
        *ctx->tuning_params.mainzisegmap_group_sizze_312143;
    
    int64_t segmap_usable_groups_312170 = sdiv_up_safe64(nest_sizze_297748,
                                                         segmap_group_sizze_312169);
    int64_t segmap_usable_groups_308823 = sdiv_up_safe64(partition_sizze_292766,
                                                         segmap_group_sizze_308822);
    int64_t segmap_usable_groups_308954 = sdiv_up_safe64(partition_sizze_292766,
                                                         segmap_group_sizze_308953);
    int64_t segmap_usable_groups_309085 = sdiv_up_safe64(partition_sizze_292766,
                                                         segmap_group_sizze_309084);
    struct memblock_device mem_318865;
    
    mem_318865.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318865, bytes_318522, "mem_318865")) {
        err = 1;
        goto cleanup;
    }
    
    struct memblock_device mem_318871;
    
    mem_318871.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318871, bytes_318550, "mem_318871")) {
        err = 1;
        goto cleanup;
    }
    
    struct memblock_device mem_318876;
    
    mem_318876.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318876, bytes_318550, "mem_318876")) {
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_x_319494 = pad_css_len_292821 * binop_x_318547;
    int64_t binop_y_319495 = (int64_t) 8 * binop_x_319494;
    int64_t bytes_319496 = smax64((int64_t) 0, binop_y_319495);
    int64_t binop_y_319502 = (int64_t) 8 * nest_sizze_308784;
    int64_t bytes_319503 = smax64((int64_t) 0, binop_y_319502);
    struct memblock_device mem_319504;
    
    mem_319504.references = NULL;
    if (memblock_alloc_device(ctx, &mem_319504, bytes_319503, "mem_319504")) {
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_y_319519 = (int64_t) 8 * nest_sizze_308904;
    int64_t bytes_319520 = smax64((int64_t) 0, binop_y_319519);
    struct memblock_device mem_319521;
    
    mem_319521.references = NULL;
    if (memblock_alloc_device(ctx, &mem_319521, bytes_319520, "mem_319521")) {
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_y_319536 = (int64_t) 8 * nest_sizze_309035;
    int64_t bytes_319537 = smax64((int64_t) 0, binop_y_319536);
    struct memblock_device mem_319538;
    
    mem_319538.references = NULL;
    if (memblock_alloc_device(ctx, &mem_319538, bytes_319537, "mem_319538")) {
        err = 1;
        goto cleanup;
    }
    
    struct memblock_device mem_319555;
    
    mem_319555.references = NULL;
    if (memblock_alloc_device(ctx, &mem_319555, bytes_318522, "mem_319555")) {
        err = 1;
        goto cleanup;
    }
    
    int64_t ext_319765;
    
    if (cond_293285) {
        ext_319765 = n_292675;
    } else {
        ext_319765 = l_n_m_292832;
    }
    
    int64_t ext_320106;
    
    if (cond_293286) {
        ext_320106 = n_292675;
    } else {
        ext_320106 = t_n_m_292839;
    }
    
    bool suff_intra_par_316513;
    
    suff_intra_par_316513 = *ctx->tuning_params.mainzisuff_intra_par_16 <=
        n_292675;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n", "main.suff_intra_par_16",
                (long) n_292675, suff_intra_par_316513 ? "true" : "false");
    
    bool intra_suff_and_fits_316516 = fits_297636 && suff_intra_par_316513;
    int64_t segmap_group_sizze_316645;
    
    segmap_group_sizze_316645 =
        *ctx->tuning_params.mainzisegmap_group_sizze_316607;
    
    int64_t segmap_group_sizze_316667;
    
    segmap_group_sizze_316667 =
        *ctx->tuning_params.mainzisegmap_group_sizze_316564;
    
    bool suff_outer_par_316685;
    
    suff_outer_par_316685 = *ctx->tuning_params.mainzisuff_outer_par_17 <=
        partition_sizze_292766;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n", "main.suff_outer_par_17",
                (long) partition_sizze_292766,
                suff_outer_par_316685 ? "true" : "false");
    
    int64_t segmap_group_sizze_316707;
    
    segmap_group_sizze_316707 =
        *ctx->tuning_params.mainzisegmap_group_sizze_316689;
    
    int64_t segred_group_sizze_316761;
    
    segred_group_sizze_316761 =
        *ctx->tuning_params.mainzisegred_group_sizze_316741;
    
    int64_t num_groups_316762;
    int32_t max_num_groups_321600;
    
    max_num_groups_321600 = *ctx->tuning_params.mainzisegred_num_groups_316743;
    num_groups_316762 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(nest_sizze_297748,
                                                             segred_group_sizze_316761),
                                                   sext_i32_i64(max_num_groups_321600))));
    
    int64_t segmap_group_sizze_316778;
    
    segmap_group_sizze_316778 =
        *ctx->tuning_params.mainzisegmap_group_sizze_316729;
    
    int32_t i64_res_297059 = sext_i64_i32(n_292675);
    int64_t binop_y_320175 = (int64_t) 4 * partition_sizze_292766;
    int64_t bytes_320176 = smax64((int64_t) 0, binop_y_320175);
    int64_t segmap_group_sizze_316835;
    
    segmap_group_sizze_316835 =
        *ctx->tuning_params.mainzisegmap_group_sizze_316824;
    
    int64_t segmap_group_sizze_316852;
    
    segmap_group_sizze_316852 =
        *ctx->tuning_params.mainzisegmap_group_sizze_316803;
    
    int64_t binop_y_320187 = (int64_t) 4 * nest_sizze_297748;
    int64_t bytes_320188 = smax64((int64_t) 0, binop_y_320187);
    int64_t segmap_group_sizze_316872;
    
    segmap_group_sizze_316872 =
        *ctx->tuning_params.mainzisegmap_group_sizze_316864;
    
    bool loop_cond_297079 = slt64((int64_t) 0, nest_sizze_297748);
    int64_t replicate_arg_297080 = mul64((int64_t) 2, partition_sizze_292766);
    int64_t segscan_group_sizze_316881;
    
    segscan_group_sizze_316881 =
        *ctx->tuning_params.mainzisegscan_group_sizze_316880;
    
    int64_t num_groups_316883;
    int32_t max_num_groups_321601;
    
    max_num_groups_321601 = *ctx->tuning_params.mainzisegscan_num_groups_316882;
    num_groups_316883 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(partition_sizze_292766,
                                                             segscan_group_sizze_316881),
                                                   sext_i32_i64(max_num_groups_321601))));
    
    int64_t segmap_group_sizze_316914;
    
    segmap_group_sizze_316914 =
        *ctx->tuning_params.mainzisegmap_group_sizze_316890;
    
    int64_t segmap_usable_groups_316915 = sdiv_up_safe64(partition_sizze_292766,
                                                         segmap_group_sizze_316914);
    int64_t seghist_group_sizze_316939;
    
    seghist_group_sizze_316939 =
        *ctx->tuning_params.mainziseghist_group_sizze_316938;
    
    int64_t segmap_group_sizze_317010;
    
    segmap_group_sizze_317010 =
        *ctx->tuning_params.mainzisegmap_group_sizze_316970;
    
    int64_t segmap_usable_groups_317011 = sdiv_up_safe64(partition_sizze_292766,
                                                         segmap_group_sizze_317010);
    int64_t segmap_group_sizze_317055;
    
    segmap_group_sizze_317055 =
        *ctx->tuning_params.mainzisegmap_group_sizze_317054;
    
    int64_t segmap_usable_groups_317056 = sdiv_up_safe64(partition_sizze_292766,
                                                         segmap_group_sizze_317055);
    int64_t segmap_group_sizze_317085;
    
    segmap_group_sizze_317085 =
        *ctx->tuning_params.mainzisegmap_group_sizze_317060;
    
    int64_t segscan_group_sizze_317111;
    
    segscan_group_sizze_317111 =
        *ctx->tuning_params.mainzisegscan_group_sizze_317110;
    
    int64_t segmap_group_sizze_317121;
    
    segmap_group_sizze_317121 =
        *ctx->tuning_params.mainzisegmap_group_sizze_317120;
    
    int64_t binop_y_320267 = (int64_t) 4 * replicate_arg_297080;
    int64_t bytes_320268 = smax64((int64_t) 0, binop_y_320267);
    int64_t bytes_320275 = smax64((int64_t) 0, partition_sizze_292766);
    int64_t ext_320445;
    int64_t ext_320443;
    int64_t ext_320439;
    int64_t ext_320438;
    int64_t ext_320437;
    int64_t ext_320436;
    int64_t ext_320435;
    int64_t ext_320434;
    int64_t ext_320433;
    struct memblock_device ext_mem_320432;
    
    ext_mem_320432.references = NULL;
    
    struct memblock_device ext_mem_320431;
    
    ext_mem_320431.references = NULL;
    
    struct memblock_device ext_mem_320430;
    
    ext_mem_320430.references = NULL;
    
    struct memblock_device mem_param_318822;
    
    mem_param_318822.references = NULL;
    
    int64_t ctx_param_ext_318824;
    int64_t ctx_param_ext_318826;
    struct memblock_device mem_param_318830;
    
    mem_param_318830.references = NULL;
    
    int64_t ctx_param_ext_318831;
    int64_t ctx_param_ext_318832;
    int64_t ctx_param_ext_318833;
    int64_t ctx_param_ext_318834;
    int64_t ctx_param_ext_318835;
    int64_t ctx_param_ext_318836;
    int64_t ctx_param_ext_318837;
    struct memblock_device mem_param_318838;
    
    mem_param_318838.references = NULL;
    ctx_param_ext_318824 = n_292675;
    ctx_param_ext_318826 = n_292675;
    ctx_param_ext_318831 = partition_sizze_292766;
    ctx_param_ext_318832 = n_292675;
    ctx_param_ext_318833 = (int64_t) 0;
    ctx_param_ext_318834 = n_292675;
    ctx_param_ext_318835 = partition_sizze_292766;
    ctx_param_ext_318836 = (int64_t) 1;
    ctx_param_ext_318837 = n_292675;
    if (memblock_set_device(ctx, &mem_param_318822, &mem_318810,
                            "mem_318810") != 0)
        return 1;
    if (memblock_set_device(ctx, &mem_param_318830, &mem_318810,
                            "mem_318810") != 0)
        return 1;
    if (memblock_set_device(ctx, &mem_param_318838, &mem_318814,
                            "mem_318814") != 0)
        return 1;
    for (int64_t i_outer_293375 = 0; i_outer_293375 < n_outer_292688;
         i_outer_293375++) {
        int64_t ext_320118;
        int64_t ext_320116;
        struct memblock_device ext_mem_320112;
        
        ext_mem_320112.references = NULL;
        
        struct memblock_device ext_mem_320111;
        
        ext_mem_320111.references = NULL;
        
        struct memblock_device mem_param_318852;
        
        mem_param_318852.references = NULL;
        
        int64_t ctx_param_ext_318854;
        int64_t ctx_param_ext_318856;
        struct memblock_device mem_param_318860;
        
        mem_param_318860.references = NULL;
        ctx_param_ext_318854 = ctx_param_ext_318824;
        ctx_param_ext_318856 = ctx_param_ext_318826;
        if (memblock_set_device(ctx, &mem_param_318852, &mem_param_318822,
                                "mem_param_318822") != 0)
            return 1;
        if (memblock_set_device(ctx, &mem_param_318860, &mem_param_318830,
                                "mem_param_318830") != 0)
            return 1;
        for (int64_t _i_inner_293381 = 0; _i_inner_293381 < n_inner_292687;
             _i_inner_293381++) {
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            CUdeviceptr kernel_arg_326120 = mem_318506.mem;
            CUdeviceptr kernel_arg_326121 = mem_param_318860.mem;
            CUdeviceptr kernel_arg_326122 = mem_318865.mem;
            
            if ((((((1 && segmap_usable_groups_301017 != 0) && 1 != 0) && 1 !=
                   0) && segmap_group_sizze_301016 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = segmap_usable_groups_301017;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_326117[] = {&ctx->global_failure, &n_292675,
                                              &partition_sizze_292766,
                                              &ctx_param_ext_318856,
                                              &kernel_arg_326120,
                                              &kernel_arg_326121,
                                              &kernel_arg_326122};
                int64_t time_start_326118 = 0, time_end_326119 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_301021",
                            (long) segmap_usable_groups_301017, (long) 1,
                            (long) 1, (long) segmap_group_sizze_301016,
                            (long) 1, (long) 1, (int) 0);
                    time_start_326118 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_301021_runs,
                                              &ctx->mainzisegmap_301021_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_301021,
                                                      grid[0], grid[1], grid[2],
                                                      segmap_group_sizze_301016,
                                                      1, 1, 0, NULL,
                                                      kernel_args_326117,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_326119 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_301021", time_end_326119 -
                            time_start_326118);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            CUdeviceptr kernel_arg_326126 = ext_mem_318610.mem;
            CUdeviceptr kernel_arg_326127 = mem_param_318838.mem;
            CUdeviceptr kernel_arg_326128 = mem_318865.mem;
            CUdeviceptr kernel_arg_326129 = mem_318871.mem;
            CUdeviceptr kernel_arg_326130 = mem_318876.mem;
            
            if ((((((1 && segmap_usable_groups_301161 != 0) && 1 != 0) && 1 !=
                   0) && segmap_group_sizze_301160 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = segmap_usable_groups_301161;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_326123[] = {&ctx->global_failure,
                                              &ctx->failure_is_an_option,
                                              &ctx->global_failure_args,
                                              &n_292675, &n_p_292677,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820, &i_292846,
                                              &ctx_param_ext_318833,
                                              &ctx_param_ext_318834,
                                              &ctx_param_ext_318836,
                                              &kernel_arg_326126,
                                              &kernel_arg_326127,
                                              &kernel_arg_326128,
                                              &kernel_arg_326129,
                                              &kernel_arg_326130};
                int64_t time_start_326124 = 0, time_end_326125 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_301167",
                            (long) segmap_usable_groups_301161, (long) 1,
                            (long) 1, (long) segmap_group_sizze_301160,
                            (long) 1, (long) 1, (int) 0);
                    time_start_326124 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_301167_runs,
                                              &ctx->mainzisegmap_301167_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_301167,
                                                      grid[0], grid[1], grid[2],
                                                      segmap_group_sizze_301160,
                                                      1, 1, 0, NULL,
                                                      kernel_args_326123,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_326125 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_301167", time_end_326125 -
                            time_start_326124);
                }
            }
            ctx->failure_is_an_option = 1;
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            
            struct memblock_device ext_mem_319491;
            
            ext_mem_319491.references = NULL;
            
            struct memblock_device ext_mem_319490;
            
            ext_mem_319490.references = NULL;
            if (cond_293353) {
                bool match_lit_293424 = (int64_t) 0 == d_s_292681;
                struct memblock_device ext_mem_318913;
                
                ext_mem_318913.references = NULL;
                
                struct memblock_device ext_mem_318912;
                
                ext_mem_318912.references = NULL;
                if (match_lit_293424) {
                    struct memblock_device mem_318881;
                    
                    mem_318881.references = NULL;
                    if (memblock_alloc_device(ctx, &mem_318881, bytes_318642,
                                              "mem_318881")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (futrts_builtinzhreplicate_f64(ctx, mem_318881,
                                                      partition_sizze_292766 *
                                                      n_p_292677 * s_n_m_292825,
                                                      0.0) != 0) {
                        if (memblock_unref_device(ctx, &mem_318881,
                                                  "mem_318881") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318912,
                                                  "ext_mem_318912") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318913,
                                                  "ext_mem_318913") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319490,
                                                  "ext_mem_319490") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319491,
                                                  "ext_mem_319491") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318860,
                                                  "mem_param_318860") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318852,
                                                  "mem_param_318852") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320111,
                                                  "ext_mem_320111") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320112,
                                                  "ext_mem_320112") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318838,
                                                  "mem_param_318838") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318830,
                                                  "mem_param_318830") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318822,
                                                  "mem_param_318822") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320430,
                                                  "ext_mem_320430") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320431,
                                                  "ext_mem_320431") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320432,
                                                  "ext_mem_320432") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319555,
                                                  "mem_319555") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319538,
                                                  "mem_319538") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319521,
                                                  "mem_319521") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319504,
                                                  "mem_319504") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318876,
                                                  "mem_318876") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318871,
                                                  "mem_318871") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318865,
                                                  "mem_318865") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318814,
                                                  "mem_318814") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318810,
                                                  "mem_318810") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318805,
                                                  "ext_mem_318805") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318806,
                                                  "ext_mem_318806") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318756,
                                                  "ext_mem_318756") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318757,
                                                  "ext_mem_318757") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318707,
                                                  "ext_mem_318707") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318708,
                                                  "ext_mem_318708") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318609,
                                                  "ext_mem_318609") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318610,
                                                  "ext_mem_318610") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318551,
                                                  "mem_318551") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318545,
                                                  "mem_318545") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318541,
                                                  "ext_mem_318541") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318542,
                                                  "ext_mem_318542") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318509,
                                                  "mem_318509") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318506,
                                                  "mem_318506") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318502,
                                                  "mem_318502") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318500,
                                                  "mem_318500") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318497,
                                                  "mem_318497") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318493,
                                                  "mem_318493") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320825,
                                                  "mem_out_320825") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320824,
                                                  "mem_out_320824") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320823,
                                                  "mem_out_320823") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t segmap_group_sizze_301408;
                    
                    segmap_group_sizze_301408 =
                        *ctx->tuning_params.mainzisegmap_group_sizze_301208;
                    
                    int64_t segmap_usable_groups_301409 =
                            sdiv_up64(nest_sizze_299600,
                                      segmap_group_sizze_301408);
                    struct memblock_device mem_318887;
                    
                    mem_318887.references = NULL;
                    if (memblock_alloc_device(ctx, &mem_318887, bytes_318642,
                                              "mem_318887")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegMap");
                    
                    CUdeviceptr kernel_arg_326134 = ext_mem_318609.mem;
                    CUdeviceptr kernel_arg_326135 = ext_mem_318610.mem;
                    CUdeviceptr kernel_arg_326136 = ext_mem_318707.mem;
                    CUdeviceptr kernel_arg_326137 = ext_mem_318708.mem;
                    CUdeviceptr kernel_arg_326138 = mem_318871.mem;
                    CUdeviceptr kernel_arg_326139 = mem_318876.mem;
                    CUdeviceptr kernel_arg_326140 = mem_318887.mem;
                    
                    if ((((((1 && segmap_usable_groups_301409 != 0) && 1 !=
                            0) && 1 != 0) && segmap_group_sizze_301408 != 0) &&
                         1 != 0) && 1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = segmap_usable_groups_301409;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_326131[] = {&ctx->global_failure,
                                                      &n_p_292677, &q_s_292678,
                                                      &jump_s_292684,
                                                      &partition_sizze_292766,
                                                      &defunc_0_f_res_292820,
                                                      &pad_css_len_292821,
                                                      &s_n_m_292825,
                                                      &kernel_arg_326134,
                                                      &kernel_arg_326135,
                                                      &kernel_arg_326136,
                                                      &kernel_arg_326137,
                                                      &kernel_arg_326138,
                                                      &kernel_arg_326139,
                                                      &kernel_arg_326140};
                        int64_t time_start_326132 = 0, time_end_326133 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segmap_301414",
                                    (long) segmap_usable_groups_301409,
                                    (long) 1, (long) 1,
                                    (long) segmap_group_sizze_301408, (long) 1,
                                    (long) 1, (int) 0);
                            time_start_326132 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegmap_301414_runs,
                                                      &ctx->mainzisegmap_301414_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_301414,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segmap_group_sizze_301408,
                                                              1, 1, 0, NULL,
                                                              kernel_args_326131,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_326133 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segmap_301414", time_end_326133 -
                                    time_start_326132);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                    if (memblock_set_device(ctx, &ext_mem_318913, &mem_318887,
                                            "mem_318887") != 0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_318912, &mem_318881,
                                            "mem_318881") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318887, "mem_318887") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318881, "mem_318881") !=
                        0)
                        return 1;
                } else {
                    bool match_lit_293523 = (int64_t) 1 == d_s_292681;
                    struct memblock_device ext_mem_318911;
                    
                    ext_mem_318911.references = NULL;
                    
                    struct memblock_device ext_mem_318910;
                    
                    ext_mem_318910.references = NULL;
                    if (match_lit_293523) {
                        int64_t segmap_group_sizze_301776;
                        
                        segmap_group_sizze_301776 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_301513;
                        
                        int64_t segmap_usable_groups_301777 =
                                sdiv_up64(nest_sizze_299600,
                                          segmap_group_sizze_301776);
                        struct memblock_device mem_318893;
                        
                        mem_318893.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_318893,
                                                  bytes_318642, "mem_318893")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock_device mem_318898;
                        
                        mem_318898.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_318898,
                                                  bytes_318642, "mem_318898")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_326144 = ext_mem_318609.mem;
                        CUdeviceptr kernel_arg_326145 = ext_mem_318610.mem;
                        CUdeviceptr kernel_arg_326146 = ext_mem_318707.mem;
                        CUdeviceptr kernel_arg_326147 = ext_mem_318708.mem;
                        CUdeviceptr kernel_arg_326148 = mem_318871.mem;
                        CUdeviceptr kernel_arg_326149 = mem_318876.mem;
                        CUdeviceptr kernel_arg_326150 = mem_318893.mem;
                        CUdeviceptr kernel_arg_326151 = mem_318898.mem;
                        
                        if ((((((1 && segmap_usable_groups_301777 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_301776 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_301777;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_326141[] = {&ctx->global_failure,
                                                          &n_p_292677,
                                                          &q_s_292678,
                                                          &jump_s_292684,
                                                          &partition_sizze_292766,
                                                          &defunc_0_f_res_292820,
                                                          &pad_css_len_292821,
                                                          &s_n_m_292825,
                                                          &kernel_arg_326144,
                                                          &kernel_arg_326145,
                                                          &kernel_arg_326146,
                                                          &kernel_arg_326147,
                                                          &kernel_arg_326148,
                                                          &kernel_arg_326149,
                                                          &kernel_arg_326150,
                                                          &kernel_arg_326151};
                            int64_t time_start_326142 = 0, time_end_326143 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_301783",
                                        (long) segmap_usable_groups_301777,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_301776,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_326142 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_301783_runs,
                                                          &ctx->mainzisegmap_301783_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_301783,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_301776,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_326141,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_326143 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_301783", time_end_326143 -
                                        time_start_326142);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_set_device(ctx, &ext_mem_318911,
                                                &mem_318893, "mem_318893") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_318910,
                                                &mem_318898, "mem_318898") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318898,
                                                  "mem_318898") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318893,
                                                  "mem_318893") != 0)
                            return 1;
                    } else {
                        int64_t segmap_group_sizze_302245;
                        
                        segmap_group_sizze_302245 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_301914;
                        
                        int64_t segmap_usable_groups_302246 =
                                sdiv_up64(nest_sizze_299600,
                                          segmap_group_sizze_302245);
                        struct memblock_device mem_318904;
                        
                        mem_318904.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_318904,
                                                  bytes_318642, "mem_318904")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock_device mem_318909;
                        
                        mem_318909.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_318909,
                                                  bytes_318642, "mem_318909")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_326155 = ext_mem_318609.mem;
                        CUdeviceptr kernel_arg_326156 = ext_mem_318610.mem;
                        CUdeviceptr kernel_arg_326157 = ext_mem_318707.mem;
                        CUdeviceptr kernel_arg_326158 = ext_mem_318708.mem;
                        CUdeviceptr kernel_arg_326159 = mem_318871.mem;
                        CUdeviceptr kernel_arg_326160 = mem_318876.mem;
                        CUdeviceptr kernel_arg_326161 = mem_318904.mem;
                        CUdeviceptr kernel_arg_326162 = mem_318909.mem;
                        
                        if ((((((1 && segmap_usable_groups_302246 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_302245 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_302246;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_326152[] = {&ctx->global_failure,
                                                          &n_p_292677,
                                                          &q_s_292678,
                                                          &jump_s_292684,
                                                          &partition_sizze_292766,
                                                          &defunc_0_f_res_292820,
                                                          &pad_css_len_292821,
                                                          &s_n_m_292825,
                                                          &kernel_arg_326155,
                                                          &kernel_arg_326156,
                                                          &kernel_arg_326157,
                                                          &kernel_arg_326158,
                                                          &kernel_arg_326159,
                                                          &kernel_arg_326160,
                                                          &kernel_arg_326161,
                                                          &kernel_arg_326162};
                            int64_t time_start_326153 = 0, time_end_326154 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_302252",
                                        (long) segmap_usable_groups_302246,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_302245,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_326153 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_302252_runs,
                                                          &ctx->mainzisegmap_302252_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_302252,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_302245,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_326152,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_326154 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_302252", time_end_326154 -
                                        time_start_326153);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_set_device(ctx, &ext_mem_318911,
                                                &mem_318904, "mem_318904") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_318910,
                                                &mem_318909, "mem_318909") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318909,
                                                  "mem_318909") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318904,
                                                  "mem_318904") != 0)
                            return 1;
                    }
                    if (memblock_set_device(ctx, &ext_mem_318913,
                                            &ext_mem_318911,
                                            "ext_mem_318911") != 0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_318912,
                                            &ext_mem_318910,
                                            "ext_mem_318910") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318910,
                                              "ext_mem_318910") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318911,
                                              "ext_mem_318911") != 0)
                        return 1;
                }
                if (memblock_set_device(ctx, &ext_mem_319491, &ext_mem_318913,
                                        "ext_mem_318913") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_319490, &ext_mem_318912,
                                        "ext_mem_318912") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318912,
                                          "ext_mem_318912") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318913,
                                          "ext_mem_318913") != 0)
                    return 1;
            } else {
                bool cond_293816 = sle64(jump_threshold_2_292690,
                                         jump_s_292684);
                bool cond_t_res_293817 = slt64(q_s_292678,
                                               q_threshold_1_292691);
                bool x_293818 = cond_293816 && cond_t_res_293817;
                struct memblock_device ext_mem_319489;
                
                ext_mem_319489.references = NULL;
                
                struct memblock_device ext_mem_319488;
                
                ext_mem_319488.references = NULL;
                if (x_293818) {
                    bool match_lit_293821 = (int64_t) 0 == d_s_292681;
                    int64_t binop_y_318921 = (int64_t) 8 * q_s_292678;
                    int64_t bytes_318922 = smax64((int64_t) 0, binop_y_318921);
                    struct memblock_device ext_mem_318978;
                    
                    ext_mem_318978.references = NULL;
                    
                    struct memblock_device ext_mem_318977;
                    
                    ext_mem_318977.references = NULL;
                    if (match_lit_293821) {
                        struct memblock_device mem_318918;
                        
                        mem_318918.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_318918,
                                                  bytes_318642, "mem_318918")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (futrts_builtinzhreplicate_f64(ctx, mem_318918,
                                                          partition_sizze_292766 *
                                                          n_p_292677 *
                                                          s_n_m_292825, 0.0) !=
                            0) {
                            if (memblock_unref_device(ctx, &mem_318918,
                                                      "mem_318918") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318977,
                                                      "ext_mem_318977") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318978,
                                                      "ext_mem_318978") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319488,
                                                      "ext_mem_319488") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319489,
                                                      "ext_mem_319489") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319490,
                                                      "ext_mem_319490") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319491,
                                                      "ext_mem_319491") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318860,
                                                      "mem_param_318860") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318852,
                                                      "mem_param_318852") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320111,
                                                      "ext_mem_320111") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320112,
                                                      "ext_mem_320112") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318838,
                                                      "mem_param_318838") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318830,
                                                      "mem_param_318830") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318822,
                                                      "mem_param_318822") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320430,
                                                      "ext_mem_320430") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320431,
                                                      "ext_mem_320431") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320432,
                                                      "ext_mem_320432") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319555,
                                                      "mem_319555") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319538,
                                                      "mem_319538") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319521,
                                                      "mem_319521") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319504,
                                                      "mem_319504") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318876,
                                                      "mem_318876") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318871,
                                                      "mem_318871") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318865,
                                                      "mem_318865") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318814,
                                                      "mem_318814") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318810,
                                                      "mem_318810") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318805,
                                                      "ext_mem_318805") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318806,
                                                      "ext_mem_318806") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318756,
                                                      "ext_mem_318756") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318757,
                                                      "ext_mem_318757") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318707,
                                                      "ext_mem_318707") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318708,
                                                      "ext_mem_318708") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318609,
                                                      "ext_mem_318609") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318610,
                                                      "ext_mem_318610") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318551,
                                                      "mem_318551") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318545,
                                                      "mem_318545") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318541,
                                                      "ext_mem_318541") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318542,
                                                      "ext_mem_318542") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318509,
                                                      "mem_318509") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318506,
                                                      "mem_318506") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318502,
                                                      "mem_318502") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318500,
                                                      "mem_318500") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318497,
                                                      "mem_318497") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318493,
                                                      "mem_318493") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320825,
                                                      "mem_out_320825") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320824,
                                                      "mem_out_320824") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320823,
                                                      "mem_out_320823") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock_device mem_318929;
                        
                        mem_318929.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_318929,
                                                  bytes_318642, "mem_318929")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        int32_t num_chunks_321695 =
                                sext_i64_i32(sdiv_up64(q_s_292678, q_s_292678));
                        unsigned int shared_sizze_326166 = (int64_t) 8 *
                                     q_s_292678;
                        unsigned int shared_sizze_326168 = (int64_t) 8 *
                                     q_s_292678;
                        unsigned int shared_sizze_326170 = bytes_318922;
                        CUdeviceptr kernel_arg_326172 = ext_mem_318609.mem;
                        CUdeviceptr kernel_arg_326173 = ext_mem_318610.mem;
                        CUdeviceptr kernel_arg_326174 = ext_mem_318707.mem;
                        CUdeviceptr kernel_arg_326175 = ext_mem_318708.mem;
                        CUdeviceptr kernel_arg_326176 = mem_318871.mem;
                        CUdeviceptr kernel_arg_326177 = mem_318876.mem;
                        CUdeviceptr kernel_arg_326178 = mem_318929.mem;
                        unsigned int shared_offset_326167 = 0;
                        unsigned int shared_offset_326169 = 0 +
                                     (shared_sizze_326166 + (8 -
                                                             shared_sizze_326166 %
                                                             8) % 8);
                        unsigned int shared_offset_326171 = 0 +
                                     (shared_sizze_326166 + (8 -
                                                             shared_sizze_326166 %
                                                             8) % 8) +
                                     (shared_sizze_326168 + (8 -
                                                             shared_sizze_326168 %
                                                             8) % 8);
                        
                        if ((((((1 && nest_sizze_299600 != 0) && 1 != 0) && 1 !=
                               0) && q_s_292678 != 0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = nest_sizze_299600;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_326163[] = {&ctx->global_failure,
                                                          &shared_offset_326167,
                                                          &shared_offset_326169,
                                                          &shared_offset_326171,
                                                          &n_p_292677,
                                                          &q_s_292678,
                                                          &jump_s_292684,
                                                          &partition_sizze_292766,
                                                          &defunc_0_f_res_292820,
                                                          &pad_css_len_292821,
                                                          &s_n_m_292825,
                                                          &kernel_arg_326172,
                                                          &kernel_arg_326173,
                                                          &kernel_arg_326174,
                                                          &kernel_arg_326175,
                                                          &kernel_arg_326176,
                                                          &kernel_arg_326177,
                                                          &kernel_arg_326178};
                            int64_t time_start_326164 = 0, time_end_326165 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_intragroup_302597",
                                        (long) nest_sizze_299600, (long) 1,
                                        (long) 1, (long) q_s_292678, (long) 1,
                                        (long) 1, (int) (0 +
                                                         (shared_sizze_326166 +
                                                          (8 -
                                                           shared_sizze_326166 %
                                                           8) % 8) +
                                                         (shared_sizze_326168 +
                                                          (8 -
                                                           shared_sizze_326168 %
                                                           8) % 8) +
                                                         (shared_sizze_326170 +
                                                          (8 -
                                                           shared_sizze_326170 %
                                                           8) % 8)));
                                time_start_326164 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_intragroup_302597_runs,
                                                          &ctx->mainzisegmap_intragroup_302597_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_302597,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  q_s_292678, 1,
                                                                  1, 0 +
                                                                  (shared_sizze_326166 +
                                                                   (8 -
                                                                    shared_sizze_326166 %
                                                                    8) % 8) +
                                                                  (shared_sizze_326168 +
                                                                   (8 -
                                                                    shared_sizze_326168 %
                                                                    8) % 8) +
                                                                  (shared_sizze_326170 +
                                                                   (8 -
                                                                    shared_sizze_326170 %
                                                                    8) % 8),
                                                                  NULL,
                                                                  kernel_args_326163,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_326165 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_intragroup_302597",
                                        time_end_326165 - time_start_326164);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_set_device(ctx, &ext_mem_318978,
                                                &mem_318929, "mem_318929") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_318977,
                                                &mem_318918, "mem_318918") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318929,
                                                  "mem_318929") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318918,
                                                  "mem_318918") != 0)
                            return 1;
                    } else {
                        bool match_lit_293896 = (int64_t) 1 == d_s_292681;
                        struct memblock_device ext_mem_318976;
                        
                        ext_mem_318976.references = NULL;
                        
                        struct memblock_device ext_mem_318975;
                        
                        ext_mem_318975.references = NULL;
                        if (match_lit_293896) {
                            struct memblock_device mem_318943;
                            
                            mem_318943.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_318943,
                                                      bytes_318642,
                                                      "mem_318943")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_318948;
                            
                            mem_318948.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_318948,
                                                      bytes_318642,
                                                      "mem_318948")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            int32_t num_chunks_321718 =
                                    sext_i64_i32(sdiv_up64(q_s_292678,
                                                           q_s_292678));
                            unsigned int shared_sizze_326182 = (int64_t) 8 *
                                         q_s_292678;
                            unsigned int shared_sizze_326184 = (int64_t) 8 *
                                         q_s_292678;
                            unsigned int shared_sizze_326186 = (int64_t) 8 *
                                         q_s_292678;
                            unsigned int shared_sizze_326188 = (int64_t) 8 *
                                         q_s_292678;
                            unsigned int shared_sizze_326190 = (int64_t) 8 *
                                         q_s_292678;
                            unsigned int shared_sizze_326192 = bytes_318922;
                            unsigned int shared_sizze_326194 = bytes_318922;
                            CUdeviceptr kernel_arg_326196 = ext_mem_318609.mem;
                            CUdeviceptr kernel_arg_326197 = ext_mem_318610.mem;
                            CUdeviceptr kernel_arg_326198 = ext_mem_318707.mem;
                            CUdeviceptr kernel_arg_326199 = ext_mem_318708.mem;
                            CUdeviceptr kernel_arg_326200 = mem_318871.mem;
                            CUdeviceptr kernel_arg_326201 = mem_318876.mem;
                            CUdeviceptr kernel_arg_326202 = mem_318943.mem;
                            CUdeviceptr kernel_arg_326203 = mem_318948.mem;
                            unsigned int shared_offset_326183 = 0;
                            unsigned int shared_offset_326185 = 0 +
                                         (shared_sizze_326182 + (8 -
                                                                 shared_sizze_326182 %
                                                                 8) % 8);
                            unsigned int shared_offset_326187 = 0 +
                                         (shared_sizze_326182 + (8 -
                                                                 shared_sizze_326182 %
                                                                 8) % 8) +
                                         (shared_sizze_326184 + (8 -
                                                                 shared_sizze_326184 %
                                                                 8) % 8);
                            unsigned int shared_offset_326189 = 0 +
                                         (shared_sizze_326182 + (8 -
                                                                 shared_sizze_326182 %
                                                                 8) % 8) +
                                         (shared_sizze_326184 + (8 -
                                                                 shared_sizze_326184 %
                                                                 8) % 8) +
                                         (shared_sizze_326186 + (8 -
                                                                 shared_sizze_326186 %
                                                                 8) % 8);
                            unsigned int shared_offset_326191 = 0 +
                                         (shared_sizze_326182 + (8 -
                                                                 shared_sizze_326182 %
                                                                 8) % 8) +
                                         (shared_sizze_326184 + (8 -
                                                                 shared_sizze_326184 %
                                                                 8) % 8) +
                                         (shared_sizze_326186 + (8 -
                                                                 shared_sizze_326186 %
                                                                 8) % 8) +
                                         (shared_sizze_326188 + (8 -
                                                                 shared_sizze_326188 %
                                                                 8) % 8);
                            unsigned int shared_offset_326193 = 0 +
                                         (shared_sizze_326182 + (8 -
                                                                 shared_sizze_326182 %
                                                                 8) % 8) +
                                         (shared_sizze_326184 + (8 -
                                                                 shared_sizze_326184 %
                                                                 8) % 8) +
                                         (shared_sizze_326186 + (8 -
                                                                 shared_sizze_326186 %
                                                                 8) % 8) +
                                         (shared_sizze_326188 + (8 -
                                                                 shared_sizze_326188 %
                                                                 8) % 8) +
                                         (shared_sizze_326190 + (8 -
                                                                 shared_sizze_326190 %
                                                                 8) % 8);
                            unsigned int shared_offset_326195 = 0 +
                                         (shared_sizze_326182 + (8 -
                                                                 shared_sizze_326182 %
                                                                 8) % 8) +
                                         (shared_sizze_326184 + (8 -
                                                                 shared_sizze_326184 %
                                                                 8) % 8) +
                                         (shared_sizze_326186 + (8 -
                                                                 shared_sizze_326186 %
                                                                 8) % 8) +
                                         (shared_sizze_326188 + (8 -
                                                                 shared_sizze_326188 %
                                                                 8) % 8) +
                                         (shared_sizze_326190 + (8 -
                                                                 shared_sizze_326190 %
                                                                 8) % 8) +
                                         (shared_sizze_326192 + (8 -
                                                                 shared_sizze_326192 %
                                                                 8) % 8);
                            
                            if ((((((1 && nest_sizze_299600 != 0) && 1 != 0) &&
                                   1 != 0) && q_s_292678 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = nest_sizze_299600;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_326179[] =
                                     {&ctx->global_failure,
                                      &shared_offset_326183,
                                      &shared_offset_326185,
                                      &shared_offset_326187,
                                      &shared_offset_326189,
                                      &shared_offset_326191,
                                      &shared_offset_326193,
                                      &shared_offset_326195, &n_p_292677,
                                      &q_s_292678, &jump_s_292684,
                                      &partition_sizze_292766,
                                      &defunc_0_f_res_292820,
                                      &pad_css_len_292821, &s_n_m_292825,
                                      &kernel_arg_326196, &kernel_arg_326197,
                                      &kernel_arg_326198, &kernel_arg_326199,
                                      &kernel_arg_326200, &kernel_arg_326201,
                                      &kernel_arg_326202, &kernel_arg_326203};
                                int64_t time_start_326180 = 0, time_end_326181 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_intragroup_302925",
                                            (long) nest_sizze_299600, (long) 1,
                                            (long) 1, (long) q_s_292678,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_326182 +
                                                                        (8 -
                                                                         shared_sizze_326182 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326184 +
                                                                        (8 -
                                                                         shared_sizze_326184 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326186 +
                                                                        (8 -
                                                                         shared_sizze_326186 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326188 +
                                                                        (8 -
                                                                         shared_sizze_326188 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326190 +
                                                                        (8 -
                                                                         shared_sizze_326190 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326192 +
                                                                        (8 -
                                                                         shared_sizze_326192 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326194 +
                                                                        (8 -
                                                                         shared_sizze_326194 %
                                                                         8) %
                                                                        8)));
                                    time_start_326180 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_intragroup_302925_runs,
                                                              &ctx->mainzisegmap_intragroup_302925_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_302925,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      q_s_292678,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_326182 +
                                                                       (8 -
                                                                        shared_sizze_326182 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326184 +
                                                                       (8 -
                                                                        shared_sizze_326184 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326186 +
                                                                       (8 -
                                                                        shared_sizze_326186 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326188 +
                                                                       (8 -
                                                                        shared_sizze_326188 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326190 +
                                                                       (8 -
                                                                        shared_sizze_326190 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326192 +
                                                                       (8 -
                                                                        shared_sizze_326192 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326194 +
                                                                       (8 -
                                                                        shared_sizze_326194 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_326179,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_326181 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_intragroup_302925",
                                            time_end_326181 -
                                            time_start_326180);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_set_device(ctx, &ext_mem_318976,
                                                    &mem_318943,
                                                    "mem_318943") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_318975,
                                                    &mem_318948,
                                                    "mem_318948") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318948,
                                                      "mem_318948") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318943,
                                                      "mem_318943") != 0)
                                return 1;
                        } else {
                            struct memblock_device mem_318969;
                            
                            mem_318969.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_318969,
                                                      bytes_318642,
                                                      "mem_318969")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_318974;
                            
                            mem_318974.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_318974,
                                                      bytes_318642,
                                                      "mem_318974")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            int32_t num_chunks_321747 =
                                    sext_i64_i32(sdiv_up64(q_s_292678,
                                                           q_s_292678));
                            unsigned int shared_sizze_326207 = (int64_t) 8 *
                                         q_s_292678;
                            unsigned int shared_sizze_326209 = (int64_t) 8 *
                                         q_s_292678;
                            unsigned int shared_sizze_326211 = (int64_t) 8 *
                                         q_s_292678;
                            unsigned int shared_sizze_326213 = (int64_t) 8 *
                                         q_s_292678;
                            unsigned int shared_sizze_326215 = (int64_t) 8 *
                                         q_s_292678;
                            unsigned int shared_sizze_326217 = (int64_t) 8 *
                                         q_s_292678;
                            unsigned int shared_sizze_326219 = (int64_t) 8 *
                                         q_s_292678;
                            unsigned int shared_sizze_326221 = bytes_318922;
                            unsigned int shared_sizze_326223 = bytes_318922;
                            unsigned int shared_sizze_326225 = bytes_318922;
                            unsigned int shared_sizze_326227 = bytes_318922;
                            CUdeviceptr kernel_arg_326229 = ext_mem_318609.mem;
                            CUdeviceptr kernel_arg_326230 = ext_mem_318610.mem;
                            CUdeviceptr kernel_arg_326231 = ext_mem_318707.mem;
                            CUdeviceptr kernel_arg_326232 = ext_mem_318708.mem;
                            CUdeviceptr kernel_arg_326233 = mem_318871.mem;
                            CUdeviceptr kernel_arg_326234 = mem_318876.mem;
                            CUdeviceptr kernel_arg_326235 = mem_318969.mem;
                            CUdeviceptr kernel_arg_326236 = mem_318974.mem;
                            unsigned int shared_offset_326208 = 0;
                            unsigned int shared_offset_326210 = 0 +
                                         (shared_sizze_326207 + (8 -
                                                                 shared_sizze_326207 %
                                                                 8) % 8);
                            unsigned int shared_offset_326212 = 0 +
                                         (shared_sizze_326207 + (8 -
                                                                 shared_sizze_326207 %
                                                                 8) % 8) +
                                         (shared_sizze_326209 + (8 -
                                                                 shared_sizze_326209 %
                                                                 8) % 8);
                            unsigned int shared_offset_326214 = 0 +
                                         (shared_sizze_326207 + (8 -
                                                                 shared_sizze_326207 %
                                                                 8) % 8) +
                                         (shared_sizze_326209 + (8 -
                                                                 shared_sizze_326209 %
                                                                 8) % 8) +
                                         (shared_sizze_326211 + (8 -
                                                                 shared_sizze_326211 %
                                                                 8) % 8);
                            unsigned int shared_offset_326216 = 0 +
                                         (shared_sizze_326207 + (8 -
                                                                 shared_sizze_326207 %
                                                                 8) % 8) +
                                         (shared_sizze_326209 + (8 -
                                                                 shared_sizze_326209 %
                                                                 8) % 8) +
                                         (shared_sizze_326211 + (8 -
                                                                 shared_sizze_326211 %
                                                                 8) % 8) +
                                         (shared_sizze_326213 + (8 -
                                                                 shared_sizze_326213 %
                                                                 8) % 8);
                            unsigned int shared_offset_326218 = 0 +
                                         (shared_sizze_326207 + (8 -
                                                                 shared_sizze_326207 %
                                                                 8) % 8) +
                                         (shared_sizze_326209 + (8 -
                                                                 shared_sizze_326209 %
                                                                 8) % 8) +
                                         (shared_sizze_326211 + (8 -
                                                                 shared_sizze_326211 %
                                                                 8) % 8) +
                                         (shared_sizze_326213 + (8 -
                                                                 shared_sizze_326213 %
                                                                 8) % 8) +
                                         (shared_sizze_326215 + (8 -
                                                                 shared_sizze_326215 %
                                                                 8) % 8);
                            unsigned int shared_offset_326220 = 0 +
                                         (shared_sizze_326207 + (8 -
                                                                 shared_sizze_326207 %
                                                                 8) % 8) +
                                         (shared_sizze_326209 + (8 -
                                                                 shared_sizze_326209 %
                                                                 8) % 8) +
                                         (shared_sizze_326211 + (8 -
                                                                 shared_sizze_326211 %
                                                                 8) % 8) +
                                         (shared_sizze_326213 + (8 -
                                                                 shared_sizze_326213 %
                                                                 8) % 8) +
                                         (shared_sizze_326215 + (8 -
                                                                 shared_sizze_326215 %
                                                                 8) % 8) +
                                         (shared_sizze_326217 + (8 -
                                                                 shared_sizze_326217 %
                                                                 8) % 8);
                            unsigned int shared_offset_326222 = 0 +
                                         (shared_sizze_326207 + (8 -
                                                                 shared_sizze_326207 %
                                                                 8) % 8) +
                                         (shared_sizze_326209 + (8 -
                                                                 shared_sizze_326209 %
                                                                 8) % 8) +
                                         (shared_sizze_326211 + (8 -
                                                                 shared_sizze_326211 %
                                                                 8) % 8) +
                                         (shared_sizze_326213 + (8 -
                                                                 shared_sizze_326213 %
                                                                 8) % 8) +
                                         (shared_sizze_326215 + (8 -
                                                                 shared_sizze_326215 %
                                                                 8) % 8) +
                                         (shared_sizze_326217 + (8 -
                                                                 shared_sizze_326217 %
                                                                 8) % 8) +
                                         (shared_sizze_326219 + (8 -
                                                                 shared_sizze_326219 %
                                                                 8) % 8);
                            unsigned int shared_offset_326224 = 0 +
                                         (shared_sizze_326207 + (8 -
                                                                 shared_sizze_326207 %
                                                                 8) % 8) +
                                         (shared_sizze_326209 + (8 -
                                                                 shared_sizze_326209 %
                                                                 8) % 8) +
                                         (shared_sizze_326211 + (8 -
                                                                 shared_sizze_326211 %
                                                                 8) % 8) +
                                         (shared_sizze_326213 + (8 -
                                                                 shared_sizze_326213 %
                                                                 8) % 8) +
                                         (shared_sizze_326215 + (8 -
                                                                 shared_sizze_326215 %
                                                                 8) % 8) +
                                         (shared_sizze_326217 + (8 -
                                                                 shared_sizze_326217 %
                                                                 8) % 8) +
                                         (shared_sizze_326219 + (8 -
                                                                 shared_sizze_326219 %
                                                                 8) % 8) +
                                         (shared_sizze_326221 + (8 -
                                                                 shared_sizze_326221 %
                                                                 8) % 8);
                            unsigned int shared_offset_326226 = 0 +
                                         (shared_sizze_326207 + (8 -
                                                                 shared_sizze_326207 %
                                                                 8) % 8) +
                                         (shared_sizze_326209 + (8 -
                                                                 shared_sizze_326209 %
                                                                 8) % 8) +
                                         (shared_sizze_326211 + (8 -
                                                                 shared_sizze_326211 %
                                                                 8) % 8) +
                                         (shared_sizze_326213 + (8 -
                                                                 shared_sizze_326213 %
                                                                 8) % 8) +
                                         (shared_sizze_326215 + (8 -
                                                                 shared_sizze_326215 %
                                                                 8) % 8) +
                                         (shared_sizze_326217 + (8 -
                                                                 shared_sizze_326217 %
                                                                 8) % 8) +
                                         (shared_sizze_326219 + (8 -
                                                                 shared_sizze_326219 %
                                                                 8) % 8) +
                                         (shared_sizze_326221 + (8 -
                                                                 shared_sizze_326221 %
                                                                 8) % 8) +
                                         (shared_sizze_326223 + (8 -
                                                                 shared_sizze_326223 %
                                                                 8) % 8);
                            unsigned int shared_offset_326228 = 0 +
                                         (shared_sizze_326207 + (8 -
                                                                 shared_sizze_326207 %
                                                                 8) % 8) +
                                         (shared_sizze_326209 + (8 -
                                                                 shared_sizze_326209 %
                                                                 8) % 8) +
                                         (shared_sizze_326211 + (8 -
                                                                 shared_sizze_326211 %
                                                                 8) % 8) +
                                         (shared_sizze_326213 + (8 -
                                                                 shared_sizze_326213 %
                                                                 8) % 8) +
                                         (shared_sizze_326215 + (8 -
                                                                 shared_sizze_326215 %
                                                                 8) % 8) +
                                         (shared_sizze_326217 + (8 -
                                                                 shared_sizze_326217 %
                                                                 8) % 8) +
                                         (shared_sizze_326219 + (8 -
                                                                 shared_sizze_326219 %
                                                                 8) % 8) +
                                         (shared_sizze_326221 + (8 -
                                                                 shared_sizze_326221 %
                                                                 8) % 8) +
                                         (shared_sizze_326223 + (8 -
                                                                 shared_sizze_326223 %
                                                                 8) % 8) +
                                         (shared_sizze_326225 + (8 -
                                                                 shared_sizze_326225 %
                                                                 8) % 8);
                            
                            if ((((((1 && nest_sizze_299600 != 0) && 1 != 0) &&
                                   1 != 0) && q_s_292678 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = nest_sizze_299600;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_326204[] =
                                     {&ctx->global_failure,
                                      &shared_offset_326208,
                                      &shared_offset_326210,
                                      &shared_offset_326212,
                                      &shared_offset_326214,
                                      &shared_offset_326216,
                                      &shared_offset_326218,
                                      &shared_offset_326220,
                                      &shared_offset_326222,
                                      &shared_offset_326224,
                                      &shared_offset_326226,
                                      &shared_offset_326228, &n_p_292677,
                                      &q_s_292678, &jump_s_292684,
                                      &partition_sizze_292766,
                                      &defunc_0_f_res_292820,
                                      &pad_css_len_292821, &s_n_m_292825,
                                      &kernel_arg_326229, &kernel_arg_326230,
                                      &kernel_arg_326231, &kernel_arg_326232,
                                      &kernel_arg_326233, &kernel_arg_326234,
                                      &kernel_arg_326235, &kernel_arg_326236};
                                int64_t time_start_326205 = 0, time_end_326206 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_intragroup_303389",
                                            (long) nest_sizze_299600, (long) 1,
                                            (long) 1, (long) q_s_292678,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_326207 +
                                                                        (8 -
                                                                         shared_sizze_326207 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326209 +
                                                                        (8 -
                                                                         shared_sizze_326209 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326211 +
                                                                        (8 -
                                                                         shared_sizze_326211 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326213 +
                                                                        (8 -
                                                                         shared_sizze_326213 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326215 +
                                                                        (8 -
                                                                         shared_sizze_326215 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326217 +
                                                                        (8 -
                                                                         shared_sizze_326217 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326219 +
                                                                        (8 -
                                                                         shared_sizze_326219 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326221 +
                                                                        (8 -
                                                                         shared_sizze_326221 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326223 +
                                                                        (8 -
                                                                         shared_sizze_326223 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326225 +
                                                                        (8 -
                                                                         shared_sizze_326225 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326227 +
                                                                        (8 -
                                                                         shared_sizze_326227 %
                                                                         8) %
                                                                        8)));
                                    time_start_326205 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_intragroup_303389_runs,
                                                              &ctx->mainzisegmap_intragroup_303389_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_303389,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      q_s_292678,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_326207 +
                                                                       (8 -
                                                                        shared_sizze_326207 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326209 +
                                                                       (8 -
                                                                        shared_sizze_326209 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326211 +
                                                                       (8 -
                                                                        shared_sizze_326211 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326213 +
                                                                       (8 -
                                                                        shared_sizze_326213 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326215 +
                                                                       (8 -
                                                                        shared_sizze_326215 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326217 +
                                                                       (8 -
                                                                        shared_sizze_326217 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326219 +
                                                                       (8 -
                                                                        shared_sizze_326219 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326221 +
                                                                       (8 -
                                                                        shared_sizze_326221 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326223 +
                                                                       (8 -
                                                                        shared_sizze_326223 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326225 +
                                                                       (8 -
                                                                        shared_sizze_326225 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326227 +
                                                                       (8 -
                                                                        shared_sizze_326227 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_326204,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_326206 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_intragroup_303389",
                                            time_end_326206 -
                                            time_start_326205);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_set_device(ctx, &ext_mem_318976,
                                                    &mem_318969,
                                                    "mem_318969") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_318975,
                                                    &mem_318974,
                                                    "mem_318974") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318974,
                                                      "mem_318974") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318969,
                                                      "mem_318969") != 0)
                                return 1;
                        }
                        if (memblock_set_device(ctx, &ext_mem_318978,
                                                &ext_mem_318976,
                                                "ext_mem_318976") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_318977,
                                                &ext_mem_318975,
                                                "ext_mem_318975") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318975,
                                                  "ext_mem_318975") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318976,
                                                  "ext_mem_318976") != 0)
                            return 1;
                    }
                    if (memblock_set_device(ctx, &ext_mem_319489,
                                            &ext_mem_318978,
                                            "ext_mem_318978") != 0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_319488,
                                            &ext_mem_318977,
                                            "ext_mem_318977") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318977,
                                              "ext_mem_318977") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318978,
                                              "ext_mem_318978") != 0)
                        return 1;
                } else {
                    bool match_lit_294188 = (int64_t) 0 == d_s_292681;
                    struct memblock_device ext_mem_319487;
                    
                    ext_mem_319487.references = NULL;
                    
                    struct memblock_device ext_mem_319486;
                    
                    ext_mem_319486.references = NULL;
                    if (match_lit_294188) {
                        struct memblock_device mem_318983;
                        
                        mem_318983.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_318983,
                                                  bytes_318642, "mem_318983")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (futrts_builtinzhreplicate_f64(ctx, mem_318983,
                                                          partition_sizze_292766 *
                                                          n_p_292677 *
                                                          s_n_m_292825, 0.0) !=
                            0) {
                            if (memblock_unref_device(ctx, &mem_318983,
                                                      "mem_318983") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319486,
                                                      "ext_mem_319486") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319487,
                                                      "ext_mem_319487") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319488,
                                                      "ext_mem_319488") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319489,
                                                      "ext_mem_319489") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319490,
                                                      "ext_mem_319490") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319491,
                                                      "ext_mem_319491") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318860,
                                                      "mem_param_318860") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318852,
                                                      "mem_param_318852") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320111,
                                                      "ext_mem_320111") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320112,
                                                      "ext_mem_320112") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318838,
                                                      "mem_param_318838") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318830,
                                                      "mem_param_318830") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318822,
                                                      "mem_param_318822") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320430,
                                                      "ext_mem_320430") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320431,
                                                      "ext_mem_320431") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320432,
                                                      "ext_mem_320432") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319555,
                                                      "mem_319555") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319538,
                                                      "mem_319538") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319521,
                                                      "mem_319521") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319504,
                                                      "mem_319504") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318876,
                                                      "mem_318876") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318871,
                                                      "mem_318871") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318865,
                                                      "mem_318865") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318814,
                                                      "mem_318814") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318810,
                                                      "mem_318810") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318805,
                                                      "ext_mem_318805") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318806,
                                                      "ext_mem_318806") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318756,
                                                      "ext_mem_318756") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318757,
                                                      "ext_mem_318757") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318707,
                                                      "ext_mem_318707") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318708,
                                                      "ext_mem_318708") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318609,
                                                      "ext_mem_318609") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318610,
                                                      "ext_mem_318610") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318551,
                                                      "mem_318551") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318545,
                                                      "mem_318545") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318541,
                                                      "ext_mem_318541") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318542,
                                                      "ext_mem_318542") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318509,
                                                      "mem_318509") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318506,
                                                      "mem_318506") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318502,
                                                      "mem_318502") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318500,
                                                      "mem_318500") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318497,
                                                      "mem_318497") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318493,
                                                      "mem_318493") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320825,
                                                      "mem_out_320825") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320824,
                                                      "mem_out_320824") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320823,
                                                      "mem_out_320823") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t segmap_group_sizze_304387;
                        
                        segmap_group_sizze_304387 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_303532;
                        
                        int64_t num_groups_304388;
                        int32_t max_num_groups_321780;
                        
                        max_num_groups_321780 =
                            *ctx->tuning_params.mainzisegmap_num_groups_303534;
                        num_groups_304388 = sext_i64_i32(smax64((int64_t) 1,
                                                                smin64(sdiv_up64(binop_x_318547,
                                                                                 segmap_group_sizze_304387),
                                                                       sext_i32_i64(max_num_groups_321780))));
                        
                        bool suff_outer_par_304392;
                        
                        suff_outer_par_304392 =
                            *ctx->tuning_params.mainzisuff_outer_par_7 <=
                            binop_x_318547;
                        if (ctx->logging)
                            fprintf(ctx->log, "Compared %s <= %ld: %s.\n",
                                    "main.suff_outer_par_7",
                                    (long) binop_x_318547,
                                    suff_outer_par_304392 ? "true" : "false");
                        
                        int64_t one_intra_par_min_304393 = q_s_292678 *
                                s_n_m_292825;
                        int64_t intra_avail_par_304395 = smin64(s_n_m_292825,
                                                                one_intra_par_min_304393);
                        int64_t computed_group_sizze_304396 =
                                smax64(s_n_m_292825, one_intra_par_min_304393);
                        bool fits_304400 = sle64(computed_group_sizze_304396,
                                                 max_group_sizze_297635);
                        bool suff_intra_par_304402;
                        
                        suff_intra_par_304402 =
                            *ctx->tuning_params.mainzisuff_intra_par_8 <=
                            intra_avail_par_304395;
                        if (ctx->logging)
                            fprintf(ctx->log, "Compared %s <= %ld: %s.\n",
                                    "main.suff_intra_par_8",
                                    (long) intra_avail_par_304395,
                                    suff_intra_par_304402 ? "true" : "false");
                        
                        bool intra_suff_and_fits_304403 = fits_304400 &&
                             suff_intra_par_304402;
                        int64_t segmap_group_sizze_304612;
                        
                        segmap_group_sizze_304612 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_304045;
                        
                        int64_t nest_sizze_304634 = q_s_292678 *
                                nest_sizze_299600;
                        int64_t segred_group_sizze_304635;
                        
                        segred_group_sizze_304635 =
                            *ctx->tuning_params.mainzisegred_group_sizze_303989;
                        
                        int64_t num_groups_304636;
                        int32_t max_num_groups_321781;
                        
                        max_num_groups_321781 =
                            *ctx->tuning_params.mainzisegred_num_groups_303991;
                        num_groups_304636 = sext_i64_i32(smax64((int64_t) 1,
                                                                smin64(sdiv_up64(nest_sizze_304634,
                                                                                 segred_group_sizze_304635),
                                                                       sext_i32_i64(max_num_groups_321781))));
                        
                        int64_t segmap_group_sizze_304684;
                        
                        segmap_group_sizze_304684 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_303958;
                        
                        int64_t segred_group_sizze_304710;
                        
                        segred_group_sizze_304710 =
                            *ctx->tuning_params.mainzisegred_group_sizze_303886;
                        
                        int64_t num_groups_304711;
                        int32_t max_num_groups_321782;
                        
                        max_num_groups_321782 =
                            *ctx->tuning_params.mainzisegred_num_groups_303888;
                        num_groups_304711 = sext_i64_i32(smax64((int64_t) 1,
                                                                smin64(sdiv_up64(nest_sizze_304634,
                                                                                 segred_group_sizze_304710),
                                                                       sext_i32_i64(max_num_groups_321782))));
                        
                        int64_t binop_x_318984 = partition_sizze_292766 *
                                s_n_m_292825;
                        int64_t binop_x_318985 = n_p_292677 * binop_x_318984;
                        int64_t bytes_318986 = (int64_t) 8 * binop_x_318985;
                        int64_t binop_x_318992 = partition_sizze_292766 *
                                defunc_0_f_res_292820;
                        int64_t binop_x_318993 = n_p_292677 * binop_x_318992;
                        int64_t bytes_318994 = (int64_t) 8 * binop_x_318993;
                        int64_t bytes_319029 = smax64((int64_t) 0,
                                                      s_n_m_292825);
                        int64_t bytes_319059 = smax64((int64_t) 0,
                                                      binop_x_318640);
                        int64_t num_threads_320713 = segmap_group_sizze_304387 *
                                num_groups_304388;
                        int64_t total_sizze_320714 = bytes_318656 *
                                num_threads_320713;
                        struct memblock_device ext_mem_319091;
                        
                        ext_mem_319091.references = NULL;
                        
                        int32_t local_memory_capacity_322042;
                        
                        local_memory_capacity_322042 =
                            ctx->cuda.max_shared_memory;
                        if (sle64((int64_t) 0,
                                  sext_i32_i64(local_memory_capacity_322042)) &&
                            suff_outer_par_304392) {
                            struct memblock_device mem_318987;
                            
                            mem_318987.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_318987,
                                                      bytes_318986,
                                                      "mem_318987")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (futrts_builtinzhgpu_map_transpose_i64(ctx,
                                                                      mem_318987,
                                                                      (int64_t) 0,
                                                                      ext_mem_318708,
                                                                      (int64_t) 0,
                                                                      (int64_t) 1,
                                                                      s_n_m_292825,
                                                                      partition_sizze_292766 *
                                                                      n_p_292677) !=
                                0) {
                                if (memblock_unref_device(ctx, &mem_318987,
                                                          "mem_318987") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319091,
                                                          "ext_mem_319091") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318983,
                                                          "mem_318983") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319486,
                                                          "ext_mem_319486") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319487,
                                                          "ext_mem_319487") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319488,
                                                          "ext_mem_319488") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319489,
                                                          "ext_mem_319489") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319490,
                                                          "ext_mem_319490") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319491,
                                                          "ext_mem_319491") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318860,
                                                          "mem_param_318860") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318852,
                                                          "mem_param_318852") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320111,
                                                          "ext_mem_320111") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320112,
                                                          "ext_mem_320112") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318838,
                                                          "mem_param_318838") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318830,
                                                          "mem_param_318830") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318822,
                                                          "mem_param_318822") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320430,
                                                          "ext_mem_320430") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320431,
                                                          "ext_mem_320431") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320432,
                                                          "ext_mem_320432") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319555,
                                                          "mem_319555") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319538,
                                                          "mem_319538") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319521,
                                                          "mem_319521") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319504,
                                                          "mem_319504") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318876,
                                                          "mem_318876") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318871,
                                                          "mem_318871") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318865,
                                                          "mem_318865") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318814,
                                                          "mem_318814") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318810,
                                                          "mem_318810") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318805,
                                                          "ext_mem_318805") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318806,
                                                          "ext_mem_318806") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318756,
                                                          "ext_mem_318756") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318757,
                                                          "ext_mem_318757") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318707,
                                                          "ext_mem_318707") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318708,
                                                          "ext_mem_318708") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318609,
                                                          "ext_mem_318609") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318610,
                                                          "ext_mem_318610") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318551,
                                                          "mem_318551") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318545,
                                                          "mem_318545") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318541,
                                                          "ext_mem_318541") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318542,
                                                          "ext_mem_318542") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318509,
                                                          "mem_318509") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318506,
                                                          "mem_318506") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318502,
                                                          "mem_318502") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318500,
                                                          "mem_318500") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318497,
                                                          "mem_318497") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318493,
                                                          "mem_318493") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320825,
                                                          "mem_out_320825") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320824,
                                                          "mem_out_320824") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320823,
                                                          "mem_out_320823") !=
                                    0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_318991;
                            
                            mem_318991.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_318991,
                                                      bytes_318986,
                                                      "mem_318991")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                      mem_318991,
                                                                      (int64_t) 0,
                                                                      ext_mem_318707,
                                                                      (int64_t) 0,
                                                                      (int64_t) 1,
                                                                      s_n_m_292825,
                                                                      partition_sizze_292766 *
                                                                      n_p_292677) !=
                                0) {
                                if (memblock_unref_device(ctx, &mem_318991,
                                                          "mem_318991") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318987,
                                                          "mem_318987") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319091,
                                                          "ext_mem_319091") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318983,
                                                          "mem_318983") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319486,
                                                          "ext_mem_319486") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319487,
                                                          "ext_mem_319487") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319488,
                                                          "ext_mem_319488") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319489,
                                                          "ext_mem_319489") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319490,
                                                          "ext_mem_319490") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319491,
                                                          "ext_mem_319491") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318860,
                                                          "mem_param_318860") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318852,
                                                          "mem_param_318852") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320111,
                                                          "ext_mem_320111") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320112,
                                                          "ext_mem_320112") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318838,
                                                          "mem_param_318838") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318830,
                                                          "mem_param_318830") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318822,
                                                          "mem_param_318822") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320430,
                                                          "ext_mem_320430") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320431,
                                                          "ext_mem_320431") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320432,
                                                          "ext_mem_320432") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319555,
                                                          "mem_319555") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319538,
                                                          "mem_319538") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319521,
                                                          "mem_319521") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319504,
                                                          "mem_319504") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318876,
                                                          "mem_318876") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318871,
                                                          "mem_318871") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318865,
                                                          "mem_318865") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318814,
                                                          "mem_318814") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318810,
                                                          "mem_318810") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318805,
                                                          "ext_mem_318805") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318806,
                                                          "ext_mem_318806") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318756,
                                                          "ext_mem_318756") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318757,
                                                          "ext_mem_318757") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318707,
                                                          "ext_mem_318707") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318708,
                                                          "ext_mem_318708") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318609,
                                                          "ext_mem_318609") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318610,
                                                          "ext_mem_318610") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318551,
                                                          "mem_318551") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318545,
                                                          "mem_318545") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318541,
                                                          "ext_mem_318541") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318542,
                                                          "ext_mem_318542") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318509,
                                                          "mem_318509") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318506,
                                                          "mem_318506") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318502,
                                                          "mem_318502") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318500,
                                                          "mem_318500") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318497,
                                                          "mem_318497") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318493,
                                                          "mem_318493") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320825,
                                                          "mem_out_320825") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320824,
                                                          "mem_out_320824") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320823,
                                                          "mem_out_320823") !=
                                    0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_318995;
                            
                            mem_318995.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_318995,
                                                      bytes_318994,
                                                      "mem_318995")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (futrts_builtinzhgpu_map_transpose_i64(ctx,
                                                                      mem_318995,
                                                                      (int64_t) 0,
                                                                      ext_mem_318610,
                                                                      (int64_t) 0,
                                                                      (int64_t) 1,
                                                                      defunc_0_f_res_292820,
                                                                      partition_sizze_292766 *
                                                                      n_p_292677) !=
                                0) {
                                if (memblock_unref_device(ctx, &mem_318995,
                                                          "mem_318995") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318991,
                                                          "mem_318991") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318987,
                                                          "mem_318987") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319091,
                                                          "ext_mem_319091") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318983,
                                                          "mem_318983") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319486,
                                                          "ext_mem_319486") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319487,
                                                          "ext_mem_319487") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319488,
                                                          "ext_mem_319488") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319489,
                                                          "ext_mem_319489") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319490,
                                                          "ext_mem_319490") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319491,
                                                          "ext_mem_319491") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318860,
                                                          "mem_param_318860") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318852,
                                                          "mem_param_318852") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320111,
                                                          "ext_mem_320111") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320112,
                                                          "ext_mem_320112") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318838,
                                                          "mem_param_318838") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318830,
                                                          "mem_param_318830") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318822,
                                                          "mem_param_318822") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320430,
                                                          "ext_mem_320430") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320431,
                                                          "ext_mem_320431") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320432,
                                                          "ext_mem_320432") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319555,
                                                          "mem_319555") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319538,
                                                          "mem_319538") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319521,
                                                          "mem_319521") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319504,
                                                          "mem_319504") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318876,
                                                          "mem_318876") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318871,
                                                          "mem_318871") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318865,
                                                          "mem_318865") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318814,
                                                          "mem_318814") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318810,
                                                          "mem_318810") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318805,
                                                          "ext_mem_318805") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318806,
                                                          "ext_mem_318806") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318756,
                                                          "ext_mem_318756") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318757,
                                                          "ext_mem_318757") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318707,
                                                          "ext_mem_318707") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318708,
                                                          "ext_mem_318708") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318609,
                                                          "ext_mem_318609") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318610,
                                                          "ext_mem_318610") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318551,
                                                          "mem_318551") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318545,
                                                          "mem_318545") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318541,
                                                          "ext_mem_318541") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318542,
                                                          "ext_mem_318542") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318509,
                                                          "mem_318509") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318506,
                                                          "mem_318506") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318502,
                                                          "mem_318502") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318500,
                                                          "mem_318500") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318497,
                                                          "mem_318497") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318493,
                                                          "mem_318493") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320825,
                                                          "mem_out_320825") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320824,
                                                          "mem_out_320824") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320823,
                                                          "mem_out_320823") !=
                                    0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_318999;
                            
                            mem_318999.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_318999,
                                                      bytes_318994,
                                                      "mem_318999")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                      mem_318999,
                                                                      (int64_t) 0,
                                                                      mem_318876,
                                                                      (int64_t) 0,
                                                                      (int64_t) 1,
                                                                      defunc_0_f_res_292820,
                                                                      partition_sizze_292766 *
                                                                      n_p_292677) !=
                                0) {
                                if (memblock_unref_device(ctx, &mem_318999,
                                                          "mem_318999") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318995,
                                                          "mem_318995") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318991,
                                                          "mem_318991") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318987,
                                                          "mem_318987") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319091,
                                                          "ext_mem_319091") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318983,
                                                          "mem_318983") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319486,
                                                          "ext_mem_319486") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319487,
                                                          "ext_mem_319487") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319488,
                                                          "ext_mem_319488") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319489,
                                                          "ext_mem_319489") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319490,
                                                          "ext_mem_319490") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319491,
                                                          "ext_mem_319491") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318860,
                                                          "mem_param_318860") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318852,
                                                          "mem_param_318852") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320111,
                                                          "ext_mem_320111") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320112,
                                                          "ext_mem_320112") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318838,
                                                          "mem_param_318838") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318830,
                                                          "mem_param_318830") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318822,
                                                          "mem_param_318822") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320430,
                                                          "ext_mem_320430") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320431,
                                                          "ext_mem_320431") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320432,
                                                          "ext_mem_320432") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319555,
                                                          "mem_319555") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319538,
                                                          "mem_319538") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319521,
                                                          "mem_319521") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319504,
                                                          "mem_319504") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318876,
                                                          "mem_318876") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318871,
                                                          "mem_318871") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318865,
                                                          "mem_318865") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318814,
                                                          "mem_318814") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318810,
                                                          "mem_318810") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318805,
                                                          "ext_mem_318805") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318806,
                                                          "ext_mem_318806") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318756,
                                                          "ext_mem_318756") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318757,
                                                          "ext_mem_318757") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318707,
                                                          "ext_mem_318707") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318708,
                                                          "ext_mem_318708") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318609,
                                                          "ext_mem_318609") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318610,
                                                          "ext_mem_318610") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318551,
                                                          "mem_318551") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318545,
                                                          "mem_318545") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318541,
                                                          "ext_mem_318541") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318542,
                                                          "ext_mem_318542") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318509,
                                                          "mem_318509") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318506,
                                                          "mem_318506") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318502,
                                                          "mem_318502") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318500,
                                                          "mem_318500") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318497,
                                                          "mem_318497") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318493,
                                                          "mem_318493") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320825,
                                                          "mem_out_320825") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320824,
                                                          "mem_out_320824") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320823,
                                                          "mem_out_320823") !=
                                    0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319003;
                            
                            mem_319003.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319003,
                                                      bytes_318994,
                                                      "mem_319003")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                      mem_319003,
                                                                      (int64_t) 0,
                                                                      mem_318871,
                                                                      (int64_t) 0,
                                                                      (int64_t) 1,
                                                                      defunc_0_f_res_292820,
                                                                      partition_sizze_292766 *
                                                                      n_p_292677) !=
                                0) {
                                if (memblock_unref_device(ctx, &mem_319003,
                                                          "mem_319003") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318999,
                                                          "mem_318999") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318995,
                                                          "mem_318995") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318991,
                                                          "mem_318991") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318987,
                                                          "mem_318987") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319091,
                                                          "ext_mem_319091") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318983,
                                                          "mem_318983") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319486,
                                                          "ext_mem_319486") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319487,
                                                          "ext_mem_319487") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319488,
                                                          "ext_mem_319488") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319489,
                                                          "ext_mem_319489") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319490,
                                                          "ext_mem_319490") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319491,
                                                          "ext_mem_319491") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318860,
                                                          "mem_param_318860") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318852,
                                                          "mem_param_318852") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320111,
                                                          "ext_mem_320111") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320112,
                                                          "ext_mem_320112") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318838,
                                                          "mem_param_318838") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318830,
                                                          "mem_param_318830") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318822,
                                                          "mem_param_318822") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320430,
                                                          "ext_mem_320430") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320431,
                                                          "ext_mem_320431") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320432,
                                                          "ext_mem_320432") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319555,
                                                          "mem_319555") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319538,
                                                          "mem_319538") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319521,
                                                          "mem_319521") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319504,
                                                          "mem_319504") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318876,
                                                          "mem_318876") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318871,
                                                          "mem_318871") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318865,
                                                          "mem_318865") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318814,
                                                          "mem_318814") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318810,
                                                          "mem_318810") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318805,
                                                          "ext_mem_318805") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318806,
                                                          "ext_mem_318806") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318756,
                                                          "ext_mem_318756") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318757,
                                                          "ext_mem_318757") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318707,
                                                          "ext_mem_318707") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318708,
                                                          "ext_mem_318708") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318609,
                                                          "ext_mem_318609") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318610,
                                                          "ext_mem_318610") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318551,
                                                          "mem_318551") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318545,
                                                          "mem_318545") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318541,
                                                          "ext_mem_318541") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318542,
                                                          "ext_mem_318542") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318509,
                                                          "mem_318509") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318506,
                                                          "mem_318506") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318502,
                                                          "mem_318502") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318500,
                                                          "mem_318500") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318497,
                                                          "mem_318497") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318493,
                                                          "mem_318493") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320825,
                                                          "mem_out_320825") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320824,
                                                          "mem_out_320824") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320823,
                                                          "mem_out_320823") !=
                                    0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319023;
                            
                            mem_319023.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319023,
                                                      bytes_318986,
                                                      "mem_319023")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device color_320614;
                            
                            color_320614.references = NULL;
                            if (memblock_alloc_device(ctx, &color_320614,
                                                      total_sizze_320714,
                                                      "color_320614")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_326240 = ext_mem_318609.mem;
                            CUdeviceptr kernel_arg_326241 = mem_318987.mem;
                            CUdeviceptr kernel_arg_326242 = mem_318991.mem;
                            CUdeviceptr kernel_arg_326243 = mem_318995.mem;
                            CUdeviceptr kernel_arg_326244 = mem_318999.mem;
                            CUdeviceptr kernel_arg_326245 = mem_319003.mem;
                            CUdeviceptr kernel_arg_326246 = mem_319023.mem;
                            CUdeviceptr kernel_arg_326247 = color_320614.mem;
                            
                            if ((((((1 && num_groups_304388 != 0) && 1 != 0) &&
                                   1 != 0) && segmap_group_sizze_304387 != 0) &&
                                 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_304388;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_326237[] =
                                     {&ctx->global_failure, &n_p_292677,
                                      &q_s_292678, &jump_s_292684,
                                      &partition_sizze_292766,
                                      &defunc_0_f_res_292820,
                                      &pad_css_len_292821, &s_n_m_292825,
                                      &num_groups_304388, &num_threads_320713,
                                      &kernel_arg_326240, &kernel_arg_326241,
                                      &kernel_arg_326242, &kernel_arg_326243,
                                      &kernel_arg_326244, &kernel_arg_326245,
                                      &kernel_arg_326246, &kernel_arg_326247};
                                int64_t time_start_326238 = 0, time_end_326239 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_304408",
                                            (long) num_groups_304388, (long) 1,
                                            (long) 1,
                                            (long) segmap_group_sizze_304387,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_326238 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_304408_runs,
                                                              &ctx->mainzisegmap_304408_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_304408,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_304387,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_326237,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_326239 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_304408",
                                            time_end_326239 -
                                            time_start_326238);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx, &mem_318987,
                                                      "mem_318987") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318991,
                                                      "mem_318991") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318995,
                                                      "mem_318995") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318999,
                                                      "mem_318999") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319003,
                                                      "mem_319003") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &color_320614,
                                                      "color_320614") != 0)
                                return 1;
                            
                            struct memblock_device mem_319089;
                            
                            mem_319089.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319089,
                                                      bytes_318642,
                                                      "mem_319089")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                      mem_319089,
                                                                      (int64_t) 0,
                                                                      mem_319023,
                                                                      (int64_t) 0,
                                                                      (int64_t) 1,
                                                                      partition_sizze_292766 *
                                                                      n_p_292677,
                                                                      s_n_m_292825) !=
                                0) {
                                if (memblock_unref_device(ctx, &mem_319089,
                                                          "mem_319089") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &color_320614,
                                                          "color_320614") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319023,
                                                          "mem_319023") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319003,
                                                          "mem_319003") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318999,
                                                          "mem_318999") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318995,
                                                          "mem_318995") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318991,
                                                          "mem_318991") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318987,
                                                          "mem_318987") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319091,
                                                          "ext_mem_319091") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318983,
                                                          "mem_318983") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319486,
                                                          "ext_mem_319486") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319487,
                                                          "ext_mem_319487") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319488,
                                                          "ext_mem_319488") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319489,
                                                          "ext_mem_319489") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319490,
                                                          "ext_mem_319490") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319491,
                                                          "ext_mem_319491") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318860,
                                                          "mem_param_318860") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318852,
                                                          "mem_param_318852") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320111,
                                                          "ext_mem_320111") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320112,
                                                          "ext_mem_320112") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318838,
                                                          "mem_param_318838") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318830,
                                                          "mem_param_318830") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318822,
                                                          "mem_param_318822") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320430,
                                                          "ext_mem_320430") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320431,
                                                          "ext_mem_320431") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320432,
                                                          "ext_mem_320432") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319555,
                                                          "mem_319555") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319538,
                                                          "mem_319538") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319521,
                                                          "mem_319521") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319504,
                                                          "mem_319504") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318876,
                                                          "mem_318876") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318871,
                                                          "mem_318871") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318865,
                                                          "mem_318865") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318814,
                                                          "mem_318814") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318810,
                                                          "mem_318810") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318805,
                                                          "ext_mem_318805") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318806,
                                                          "ext_mem_318806") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318756,
                                                          "ext_mem_318756") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318757,
                                                          "ext_mem_318757") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318707,
                                                          "ext_mem_318707") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318708,
                                                          "ext_mem_318708") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318609,
                                                          "ext_mem_318609") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318610,
                                                          "ext_mem_318610") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318551,
                                                          "mem_318551") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318545,
                                                          "mem_318545") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318541,
                                                          "ext_mem_318541") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318542,
                                                          "ext_mem_318542") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318509,
                                                          "mem_318509") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318506,
                                                          "mem_318506") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318502,
                                                          "mem_318502") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318500,
                                                          "mem_318500") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318497,
                                                          "mem_318497") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318493,
                                                          "mem_318493") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320825,
                                                          "mem_out_320825") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320824,
                                                          "mem_out_320824") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320823,
                                                          "mem_out_320823") !=
                                    0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            if (memblock_unref_device(ctx, &mem_319023,
                                                      "mem_319023") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319091,
                                                    &mem_319089,
                                                    "mem_319089") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319089,
                                                      "mem_319089") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &color_320614,
                                                      "color_320614") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319023,
                                                      "mem_319023") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319003,
                                                      "mem_319003") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318999,
                                                      "mem_318999") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318995,
                                                      "mem_318995") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318991,
                                                      "mem_318991") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318987,
                                                      "mem_318987") != 0)
                                return 1;
                        } else {
                            struct memblock_device ext_mem_319084;
                            
                            ext_mem_319084.references = NULL;
                            
                            int32_t local_memory_capacity_322041;
                            
                            local_memory_capacity_322041 =
                                ctx->cuda.max_shared_memory;
                            if (sle64(bytes_318656 + srem64((int64_t) 8 -
                                                            srem64(bytes_318656,
                                                                   (int64_t) 8),
                                                            (int64_t) 8) +
                                      (bytes_318656 + srem64((int64_t) 8 -
                                                             srem64(bytes_318656,
                                                                    (int64_t) 8),
                                                             (int64_t) 8)) +
                                      (bytes_318656 + srem64((int64_t) 8 -
                                                             srem64(bytes_318656,
                                                                    (int64_t) 8),
                                                             (int64_t) 8)) +
                                      (bytes_319029 + srem64((int64_t) 8 -
                                                             srem64(bytes_319029,
                                                                    (int64_t) 8),
                                                             (int64_t) 8)) +
                                      ((int64_t) 8 * (s_n_m_292825 *
                                                      q_s_292678) +
                                       srem64((int64_t) 8 - srem64((int64_t) 8 *
                                                                   (s_n_m_292825 *
                                                                    q_s_292678),
                                                                   (int64_t) 8),
                                              (int64_t) 8)) + ((int64_t) 8 *
                                                               (s_n_m_292825 *
                                                                q_s_292678) +
                                                               srem64((int64_t) 8 -
                                                                      srem64((int64_t) 8 *
                                                                             (s_n_m_292825 *
                                                                              q_s_292678),
                                                                             (int64_t) 8),
                                                                      (int64_t) 8)),
                                      sext_i32_i64(local_memory_capacity_322041)) &&
                                intra_suff_and_fits_304403) {
                                struct memblock_device mem_319050;
                                
                                mem_319050.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319050,
                                                          bytes_318642,
                                                          "mem_319050")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                                
                                int32_t num_chunks_321801 =
                                        sext_i64_i32(sdiv_up64(s_n_m_292825,
                                                               computed_group_sizze_304396));
                                int32_t num_chunks_321802 =
                                        sext_i64_i32(sdiv_up64(s_n_m_292825 *
                                                               q_s_292678,
                                                               computed_group_sizze_304396));
                                unsigned int shared_sizze_326251 = (int64_t) 8 *
                                             (s_n_m_292825 * q_s_292678);
                                unsigned int shared_sizze_326253 = (int64_t) 8 *
                                             (s_n_m_292825 * q_s_292678);
                                unsigned int shared_sizze_326255 = bytes_319029;
                                unsigned int shared_sizze_326257 = bytes_318656;
                                unsigned int shared_sizze_326259 = bytes_318656;
                                unsigned int shared_sizze_326261 = bytes_318656;
                                CUdeviceptr kernel_arg_326263 =
                                            ext_mem_318609.mem;
                                CUdeviceptr kernel_arg_326264 =
                                            ext_mem_318610.mem;
                                CUdeviceptr kernel_arg_326265 =
                                            ext_mem_318707.mem;
                                CUdeviceptr kernel_arg_326266 =
                                            ext_mem_318708.mem;
                                CUdeviceptr kernel_arg_326267 = mem_318871.mem;
                                CUdeviceptr kernel_arg_326268 = mem_318876.mem;
                                CUdeviceptr kernel_arg_326269 = mem_319050.mem;
                                unsigned int shared_offset_326252 = 0;
                                unsigned int shared_offset_326254 = 0 +
                                             (shared_sizze_326251 + (8 -
                                                                     shared_sizze_326251 %
                                                                     8) % 8);
                                unsigned int shared_offset_326256 = 0 +
                                             (shared_sizze_326251 + (8 -
                                                                     shared_sizze_326251 %
                                                                     8) % 8) +
                                             (shared_sizze_326253 + (8 -
                                                                     shared_sizze_326253 %
                                                                     8) % 8);
                                unsigned int shared_offset_326258 = 0 +
                                             (shared_sizze_326251 + (8 -
                                                                     shared_sizze_326251 %
                                                                     8) % 8) +
                                             (shared_sizze_326253 + (8 -
                                                                     shared_sizze_326253 %
                                                                     8) % 8) +
                                             (shared_sizze_326255 + (8 -
                                                                     shared_sizze_326255 %
                                                                     8) % 8);
                                unsigned int shared_offset_326260 = 0 +
                                             (shared_sizze_326251 + (8 -
                                                                     shared_sizze_326251 %
                                                                     8) % 8) +
                                             (shared_sizze_326253 + (8 -
                                                                     shared_sizze_326253 %
                                                                     8) % 8) +
                                             (shared_sizze_326255 + (8 -
                                                                     shared_sizze_326255 %
                                                                     8) % 8) +
                                             (shared_sizze_326257 + (8 -
                                                                     shared_sizze_326257 %
                                                                     8) % 8);
                                unsigned int shared_offset_326262 = 0 +
                                             (shared_sizze_326251 + (8 -
                                                                     shared_sizze_326251 %
                                                                     8) % 8) +
                                             (shared_sizze_326253 + (8 -
                                                                     shared_sizze_326253 %
                                                                     8) % 8) +
                                             (shared_sizze_326255 + (8 -
                                                                     shared_sizze_326255 %
                                                                     8) % 8) +
                                             (shared_sizze_326257 + (8 -
                                                                     shared_sizze_326257 %
                                                                     8) % 8) +
                                             (shared_sizze_326259 + (8 -
                                                                     shared_sizze_326259 %
                                                                     8) % 8);
                                
                                if ((((((1 && binop_x_318547 != 0) && 1 != 0) &&
                                       1 != 0) && computed_group_sizze_304396 !=
                                      0) && 1 != 0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = binop_x_318547;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_326248[] =
                                         {&ctx->global_failure,
                                          &shared_offset_326252,
                                          &shared_offset_326254,
                                          &shared_offset_326256,
                                          &shared_offset_326258,
                                          &shared_offset_326260,
                                          &shared_offset_326262, &n_p_292677,
                                          &q_s_292678, &jump_s_292684,
                                          &partition_sizze_292766,
                                          &defunc_0_f_res_292820,
                                          &pad_css_len_292821, &s_n_m_292825,
                                          &computed_group_sizze_304396,
                                          &kernel_arg_326263,
                                          &kernel_arg_326264,
                                          &kernel_arg_326265,
                                          &kernel_arg_326266,
                                          &kernel_arg_326267,
                                          &kernel_arg_326268,
                                          &kernel_arg_326269};
                                    int64_t time_start_326249 = 0,
                                            time_end_326250 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segmap_intragroup_304495",
                                                (long) binop_x_318547, (long) 1,
                                                (long) 1,
                                                (long) computed_group_sizze_304396,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_326251 +
                                                                            (8 -
                                                                             shared_sizze_326251 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_326253 +
                                                                            (8 -
                                                                             shared_sizze_326253 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_326255 +
                                                                            (8 -
                                                                             shared_sizze_326255 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_326257 +
                                                                            (8 -
                                                                             shared_sizze_326257 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_326259 +
                                                                            (8 -
                                                                             shared_sizze_326259 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_326261 +
                                                                            (8 -
                                                                             shared_sizze_326261 %
                                                                             8) %
                                                                            8)));
                                        time_start_326249 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegmap_intragroup_304495_runs,
                                                                  &ctx->mainzisegmap_intragroup_304495_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_304495,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          computed_group_sizze_304396,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_326251 +
                                                                           (8 -
                                                                            shared_sizze_326251 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_326253 +
                                                                           (8 -
                                                                            shared_sizze_326253 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_326255 +
                                                                           (8 -
                                                                            shared_sizze_326255 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_326257 +
                                                                           (8 -
                                                                            shared_sizze_326257 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_326259 +
                                                                           (8 -
                                                                            shared_sizze_326259 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_326261 +
                                                                           (8 -
                                                                            shared_sizze_326261 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_326248,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_326250 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segmap_intragroup_304495",
                                                time_end_326250 -
                                                time_start_326249);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_set_device(ctx, &ext_mem_319084,
                                                        &mem_319050,
                                                        "mem_319050") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319050,
                                                          "mem_319050") != 0)
                                    return 1;
                            } else {
                                int64_t segmap_usable_groups_304613 =
                                        sdiv_up64(nest_sizze_299600,
                                                  segmap_group_sizze_304612);
                                struct memblock_device mem_319056;
                                
                                mem_319056.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319056,
                                                          bytes_318642,
                                                          "mem_319056")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319060;
                                
                                mem_319060.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319060,
                                                          bytes_319059,
                                                          "mem_319060")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                                
                                CUdeviceptr kernel_arg_326273 = mem_319056.mem;
                                CUdeviceptr kernel_arg_326274 = mem_319060.mem;
                                
                                if ((((((1 && segmap_usable_groups_304613 !=
                                         0) && 1 != 0) && 1 != 0) &&
                                      segmap_group_sizze_304612 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = segmap_usable_groups_304613;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_326270[] =
                                         {&ctx->global_failure, &n_p_292677,
                                          &jump_s_292684,
                                          &partition_sizze_292766,
                                          &defunc_0_f_res_292820,
                                          &pad_css_len_292821, &s_n_m_292825,
                                          &kernel_arg_326273,
                                          &kernel_arg_326274};
                                    int64_t time_start_326271 = 0,
                                            time_end_326272 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segmap_304619",
                                                (long) segmap_usable_groups_304613,
                                                (long) 1, (long) 1,
                                                (long) segmap_group_sizze_304612,
                                                (long) 1, (long) 1, (int) 0);
                                        time_start_326271 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegmap_304619_runs,
                                                                  &ctx->mainzisegmap_304619_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_304619,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segmap_group_sizze_304612,
                                                                          1, 1,
                                                                          0,
                                                                          NULL,
                                                                          kernel_args_326270,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_326272 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segmap_304619",
                                                time_end_326272 -
                                                time_start_326271);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_unref_device(ctx, &mem_319060,
                                                          "mem_319060") != 0)
                                    return 1;
                                
                                struct memblock_device mem_319066;
                                
                                mem_319066.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319066,
                                                          bytes_318642,
                                                          "mem_319066")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (slt64(q_s_292678 * (int64_t) 2,
                                          segred_group_sizze_304635)) {
                                    int64_t segment_sizze_nonzzero_321877 =
                                            smax64((int64_t) 1, q_s_292678);
                                    int64_t num_threads_321878 =
                                            num_groups_304636 *
                                            segred_group_sizze_304635;
                                    
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n",
                                                "\n# SegRed-small");
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "num_segments",
                                                (long long) (partition_sizze_292766 *
                                                             n_p_292677 *
                                                             s_n_m_292825),
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "segment_size",
                                                (long long) q_s_292678, '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "segments_per_group",
                                                (long long) squot64(segred_group_sizze_304635,
                                                                    segment_sizze_nonzzero_321877),
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "required_groups",
                                                (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                                   n_p_292677 *
                                                                                   s_n_m_292825,
                                                                                   squot64(segred_group_sizze_304635,
                                                                                           segment_sizze_nonzzero_321877))),
                                                '\n');
                                    
                                    unsigned int shared_sizze_326278 =
                                                 (int64_t) 8 *
                                                 segred_group_sizze_304635;
                                    CUdeviceptr kernel_arg_326280 =
                                                ext_mem_318609.mem;
                                    CUdeviceptr kernel_arg_326281 =
                                                ext_mem_318610.mem;
                                    CUdeviceptr kernel_arg_326282 =
                                                ext_mem_318707.mem;
                                    CUdeviceptr kernel_arg_326283 =
                                                ext_mem_318708.mem;
                                    CUdeviceptr kernel_arg_326284 =
                                                mem_318876.mem;
                                    CUdeviceptr kernel_arg_326285 =
                                                mem_319056.mem;
                                    CUdeviceptr kernel_arg_326286 =
                                                mem_319066.mem;
                                    unsigned int shared_offset_326279 = 0;
                                    
                                    if ((((((1 && num_groups_304636 != 0) &&
                                            1 != 0) && 1 != 0) &&
                                          segred_group_sizze_304635 != 0) &&
                                         1 != 0) && 1 != 0) {
                                        int perm[3] = {0, 1, 2};
                                        
                                        if (1 >= 1 << 16) {
                                            perm[1] = perm[0];
                                            perm[0] = 1;
                                        }
                                        if (1 >= 1 << 16) {
                                            perm[2] = perm[0];
                                            perm[0] = 2;
                                        }
                                        
                                        size_t grid[3];
                                        
                                        grid[perm[0]] = num_groups_304636;
                                        grid[perm[1]] = 1;
                                        grid[perm[2]] = 1;
                                        
                                        void *kernel_args_326275[] =
                                             {&ctx->global_failure,
                                              &shared_offset_326279,
                                              &n_p_292677, &q_s_292678,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &s_n_m_292825, &num_groups_304636,
                                              &segment_sizze_nonzzero_321877,
                                              &kernel_arg_326280,
                                              &kernel_arg_326281,
                                              &kernel_arg_326282,
                                              &kernel_arg_326283,
                                              &kernel_arg_326284,
                                              &kernel_arg_326285,
                                              &kernel_arg_326286};
                                        int64_t time_start_326276 = 0,
                                                time_end_326277 = 0;
                                        
                                        if (ctx->debugging) {
                                            fprintf(ctx->log,
                                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                    "main.segred_small_304643",
                                                    (long) num_groups_304636,
                                                    (long) 1, (long) 1,
                                                    (long) segred_group_sizze_304635,
                                                    (long) 1, (long) 1,
                                                    (int) (0 +
                                                           (shared_sizze_326278 +
                                                            (8 -
                                                             shared_sizze_326278 %
                                                             8) % 8)));
                                            time_start_326276 = get_wall_time();
                                        }
                                        
                                        cudaEvent_t *pevents = NULL;
                                        
                                        if (ctx->profiling &&
                                            !ctx->profiling_paused) {
                                            pevents =
                                                cuda_get_events(&ctx->cuda,
                                                                &ctx->mainzisegred_small_304643_runs,
                                                                &ctx->mainzisegred_small_304643_total_runtime);
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                               0));
                                        }
                                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_304643,
                                                                              grid[0],
                                                                              grid[1],
                                                                              grid[2],
                                                                              segred_group_sizze_304635,
                                                                              1,
                                                                              1,
                                                                              0 +
                                                                              (shared_sizze_326278 +
                                                                               (8 -
                                                                                shared_sizze_326278 %
                                                                                8) %
                                                                               8),
                                                                              NULL,
                                                                              kernel_args_326275,
                                                                              NULL));
                                        if (pevents != NULL)
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                               0));
                                        if (ctx->debugging) {
                                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                            time_end_326277 = get_wall_time();
                                            fprintf(ctx->log,
                                                    "Kernel %s runtime: %ldus\n",
                                                    "main.segred_small_304643",
                                                    time_end_326277 -
                                                    time_start_326276);
                                        }
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "");
                                } else {
                                    int64_t groups_per_segment_321908 =
                                            sdiv_up64(num_groups_304636,
                                                      smax64((int64_t) 1,
                                                             partition_sizze_292766 *
                                                             n_p_292677 *
                                                             s_n_m_292825));
                                    int64_t elements_per_thread_321909 =
                                            sdiv_up64(q_s_292678,
                                                      segred_group_sizze_304635 *
                                                      groups_per_segment_321908);
                                    int64_t virt_num_groups_321910 =
                                            groups_per_segment_321908 *
                                            (partition_sizze_292766 *
                                             n_p_292677 * s_n_m_292825);
                                    int64_t num_threads_321911 =
                                            num_groups_304636 *
                                            segred_group_sizze_304635;
                                    int64_t threads_per_segment_321912 =
                                            groups_per_segment_321908 *
                                            segred_group_sizze_304635;
                                    
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n",
                                                "\n# SegRed-large");
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "num_segments",
                                                (long long) (partition_sizze_292766 *
                                                             n_p_292677 *
                                                             s_n_m_292825),
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "segment_size",
                                                (long long) q_s_292678, '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "virt_num_groups",
                                                (long long) virt_num_groups_321910,
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "num_groups",
                                                (long long) num_groups_304636,
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "group_size",
                                                (long long) segred_group_sizze_304635,
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "elems_per_thread",
                                                (long long) elements_per_thread_321909,
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "groups_per_segment",
                                                (long long) groups_per_segment_321908,
                                                '\n');
                                    
                                    struct memblock_device
                                    segred_tmp_mem_321913;
                                    
                                    segred_tmp_mem_321913.references = NULL;
                                    if (memblock_alloc_device(ctx,
                                                              &segred_tmp_mem_321913,
                                                              (int64_t) 8 *
                                                              virt_num_groups_321910,
                                                              "segred_tmp_mem_321913")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device
                                    mainzicounter_mem_321915 =
                                    ctx->mainzicounter_mem_321915;
                                    unsigned int shared_sizze_326291 = 1;
                                    unsigned int shared_sizze_326293 =
                                                 (int64_t) 8 *
                                                 segred_group_sizze_304635;
                                    CUdeviceptr kernel_arg_326295 =
                                                ext_mem_318609.mem;
                                    CUdeviceptr kernel_arg_326296 =
                                                ext_mem_318610.mem;
                                    CUdeviceptr kernel_arg_326297 =
                                                ext_mem_318707.mem;
                                    CUdeviceptr kernel_arg_326298 =
                                                ext_mem_318708.mem;
                                    CUdeviceptr kernel_arg_326299 =
                                                mem_318876.mem;
                                    CUdeviceptr kernel_arg_326300 =
                                                mem_319056.mem;
                                    CUdeviceptr kernel_arg_326301 =
                                                mem_319066.mem;
                                    CUdeviceptr kernel_arg_326302 =
                                                segred_tmp_mem_321913.mem;
                                    CUdeviceptr kernel_arg_326303 =
                                                mainzicounter_mem_321915.mem;
                                    unsigned int shared_offset_326292 = 0;
                                    unsigned int shared_offset_326294 = 0 +
                                                 (shared_sizze_326291 + (8 -
                                                                         shared_sizze_326291 %
                                                                         8) %
                                                  8);
                                    
                                    if ((((((1 && num_groups_304636 != 0) &&
                                            1 != 0) && 1 != 0) &&
                                          segred_group_sizze_304635 != 0) &&
                                         1 != 0) && 1 != 0) {
                                        int perm[3] = {0, 1, 2};
                                        
                                        if (1 >= 1 << 16) {
                                            perm[1] = perm[0];
                                            perm[0] = 1;
                                        }
                                        if (1 >= 1 << 16) {
                                            perm[2] = perm[0];
                                            perm[0] = 2;
                                        }
                                        
                                        size_t grid[3];
                                        
                                        grid[perm[0]] = num_groups_304636;
                                        grid[perm[1]] = 1;
                                        grid[perm[2]] = 1;
                                        
                                        void *kernel_args_326288[] =
                                             {&ctx->global_failure,
                                              &shared_offset_326292,
                                              &shared_offset_326294,
                                              &n_p_292677, &q_s_292678,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &s_n_m_292825, &num_groups_304636,
                                              &groups_per_segment_321908,
                                              &elements_per_thread_321909,
                                              &virt_num_groups_321910,
                                              &threads_per_segment_321912,
                                              &kernel_arg_326295,
                                              &kernel_arg_326296,
                                              &kernel_arg_326297,
                                              &kernel_arg_326298,
                                              &kernel_arg_326299,
                                              &kernel_arg_326300,
                                              &kernel_arg_326301,
                                              &kernel_arg_326302,
                                              &kernel_arg_326303};
                                        int64_t time_start_326289 = 0,
                                                time_end_326290 = 0;
                                        
                                        if (ctx->debugging) {
                                            fprintf(ctx->log,
                                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                    "main.segred_large_304643",
                                                    (long) num_groups_304636,
                                                    (long) 1, (long) 1,
                                                    (long) segred_group_sizze_304635,
                                                    (long) 1, (long) 1,
                                                    (int) (0 +
                                                           (shared_sizze_326291 +
                                                            (8 -
                                                             shared_sizze_326291 %
                                                             8) % 8) +
                                                           (shared_sizze_326293 +
                                                            (8 -
                                                             shared_sizze_326293 %
                                                             8) % 8)));
                                            time_start_326289 = get_wall_time();
                                        }
                                        
                                        cudaEvent_t *pevents = NULL;
                                        
                                        if (ctx->profiling &&
                                            !ctx->profiling_paused) {
                                            pevents =
                                                cuda_get_events(&ctx->cuda,
                                                                &ctx->mainzisegred_large_304643_runs,
                                                                &ctx->mainzisegred_large_304643_total_runtime);
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                               0));
                                        }
                                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_304643,
                                                                              grid[0],
                                                                              grid[1],
                                                                              grid[2],
                                                                              segred_group_sizze_304635,
                                                                              1,
                                                                              1,
                                                                              0 +
                                                                              (shared_sizze_326291 +
                                                                               (8 -
                                                                                shared_sizze_326291 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326293 +
                                                                               (8 -
                                                                                shared_sizze_326293 %
                                                                                8) %
                                                                               8),
                                                                              NULL,
                                                                              kernel_args_326288,
                                                                              NULL));
                                        if (pevents != NULL)
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                               0));
                                        if (ctx->debugging) {
                                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                            time_end_326290 = get_wall_time();
                                            fprintf(ctx->log,
                                                    "Kernel %s runtime: %ldus\n",
                                                    "main.segred_large_304643",
                                                    time_end_326290 -
                                                    time_start_326289);
                                        }
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "");
                                    if (memblock_unref_device(ctx,
                                                              &segred_tmp_mem_321913,
                                                              "segred_tmp_mem_321913") !=
                                        0)
                                        return 1;
                                }
                                if (memblock_unref_device(ctx, &mem_319056,
                                                          "mem_319056") != 0)
                                    return 1;
                                
                                int64_t segmap_usable_groups_304685 =
                                        sdiv_up64(nest_sizze_299600,
                                                  segmap_group_sizze_304684);
                                struct memblock_device mem_319072;
                                
                                mem_319072.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319072,
                                                          bytes_318642,
                                                          "mem_319072")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319077;
                                
                                mem_319077.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319077,
                                                          bytes_318642,
                                                          "mem_319077")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                                
                                CUdeviceptr kernel_arg_326307 = mem_319066.mem;
                                CUdeviceptr kernel_arg_326308 = mem_319072.mem;
                                CUdeviceptr kernel_arg_326309 = mem_319077.mem;
                                
                                if ((((((1 && segmap_usable_groups_304685 !=
                                         0) && 1 != 0) && 1 != 0) &&
                                      segmap_group_sizze_304684 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = segmap_usable_groups_304685;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_326304[] =
                                         {&ctx->global_failure, &n_p_292677,
                                          &jump_s_292684,
                                          &partition_sizze_292766,
                                          &defunc_0_f_res_292820,
                                          &pad_css_len_292821, &s_n_m_292825,
                                          &kernel_arg_326307,
                                          &kernel_arg_326308,
                                          &kernel_arg_326309};
                                    int64_t time_start_326305 = 0,
                                            time_end_326306 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segmap_304691",
                                                (long) segmap_usable_groups_304685,
                                                (long) 1, (long) 1,
                                                (long) segmap_group_sizze_304684,
                                                (long) 1, (long) 1, (int) 0);
                                        time_start_326305 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegmap_304691_runs,
                                                                  &ctx->mainzisegmap_304691_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_304691,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segmap_group_sizze_304684,
                                                                          1, 1,
                                                                          0,
                                                                          NULL,
                                                                          kernel_args_326304,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_326306 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segmap_304691",
                                                time_end_326306 -
                                                time_start_326305);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_unref_device(ctx, &mem_319066,
                                                          "mem_319066") != 0)
                                    return 1;
                                
                                struct memblock_device mem_319083;
                                
                                mem_319083.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319083,
                                                          bytes_318642,
                                                          "mem_319083")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (slt64(q_s_292678 * (int64_t) 2,
                                          segred_group_sizze_304710)) {
                                    int64_t segment_sizze_nonzzero_321965 =
                                            smax64((int64_t) 1, q_s_292678);
                                    int64_t num_threads_321966 =
                                            num_groups_304711 *
                                            segred_group_sizze_304710;
                                    
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n",
                                                "\n# SegRed-small");
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "num_segments",
                                                (long long) (partition_sizze_292766 *
                                                             n_p_292677 *
                                                             s_n_m_292825),
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "segment_size",
                                                (long long) q_s_292678, '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "segments_per_group",
                                                (long long) squot64(segred_group_sizze_304710,
                                                                    segment_sizze_nonzzero_321965),
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "required_groups",
                                                (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                                   n_p_292677 *
                                                                                   s_n_m_292825,
                                                                                   squot64(segred_group_sizze_304710,
                                                                                           segment_sizze_nonzzero_321965))),
                                                '\n');
                                    
                                    unsigned int shared_sizze_326313 =
                                                 (int64_t) 8 *
                                                 segred_group_sizze_304710;
                                    CUdeviceptr kernel_arg_326315 =
                                                ext_mem_318609.mem;
                                    CUdeviceptr kernel_arg_326316 =
                                                ext_mem_318610.mem;
                                    CUdeviceptr kernel_arg_326317 =
                                                ext_mem_318707.mem;
                                    CUdeviceptr kernel_arg_326318 =
                                                ext_mem_318708.mem;
                                    CUdeviceptr kernel_arg_326319 =
                                                mem_318871.mem;
                                    CUdeviceptr kernel_arg_326320 =
                                                mem_318876.mem;
                                    CUdeviceptr kernel_arg_326321 =
                                                mem_319072.mem;
                                    CUdeviceptr kernel_arg_326322 =
                                                mem_319077.mem;
                                    CUdeviceptr kernel_arg_326323 =
                                                mem_319083.mem;
                                    unsigned int shared_offset_326314 = 0;
                                    
                                    if ((((((1 && num_groups_304711 != 0) &&
                                            1 != 0) && 1 != 0) &&
                                          segred_group_sizze_304710 != 0) &&
                                         1 != 0) && 1 != 0) {
                                        int perm[3] = {0, 1, 2};
                                        
                                        if (1 >= 1 << 16) {
                                            perm[1] = perm[0];
                                            perm[0] = 1;
                                        }
                                        if (1 >= 1 << 16) {
                                            perm[2] = perm[0];
                                            perm[0] = 2;
                                        }
                                        
                                        size_t grid[3];
                                        
                                        grid[perm[0]] = num_groups_304711;
                                        grid[perm[1]] = 1;
                                        grid[perm[2]] = 1;
                                        
                                        void *kernel_args_326310[] =
                                             {&ctx->global_failure,
                                              &shared_offset_326314,
                                              &n_p_292677, &q_s_292678,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &s_n_m_292825, &num_groups_304711,
                                              &segment_sizze_nonzzero_321965,
                                              &kernel_arg_326315,
                                              &kernel_arg_326316,
                                              &kernel_arg_326317,
                                              &kernel_arg_326318,
                                              &kernel_arg_326319,
                                              &kernel_arg_326320,
                                              &kernel_arg_326321,
                                              &kernel_arg_326322,
                                              &kernel_arg_326323};
                                        int64_t time_start_326311 = 0,
                                                time_end_326312 = 0;
                                        
                                        if (ctx->debugging) {
                                            fprintf(ctx->log,
                                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                    "main.segred_small_304718",
                                                    (long) num_groups_304711,
                                                    (long) 1, (long) 1,
                                                    (long) segred_group_sizze_304710,
                                                    (long) 1, (long) 1,
                                                    (int) (0 +
                                                           (shared_sizze_326313 +
                                                            (8 -
                                                             shared_sizze_326313 %
                                                             8) % 8)));
                                            time_start_326311 = get_wall_time();
                                        }
                                        
                                        cudaEvent_t *pevents = NULL;
                                        
                                        if (ctx->profiling &&
                                            !ctx->profiling_paused) {
                                            pevents =
                                                cuda_get_events(&ctx->cuda,
                                                                &ctx->mainzisegred_small_304718_runs,
                                                                &ctx->mainzisegred_small_304718_total_runtime);
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                               0));
                                        }
                                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_304718,
                                                                              grid[0],
                                                                              grid[1],
                                                                              grid[2],
                                                                              segred_group_sizze_304710,
                                                                              1,
                                                                              1,
                                                                              0 +
                                                                              (shared_sizze_326313 +
                                                                               (8 -
                                                                                shared_sizze_326313 %
                                                                                8) %
                                                                               8),
                                                                              NULL,
                                                                              kernel_args_326310,
                                                                              NULL));
                                        if (pevents != NULL)
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                               0));
                                        if (ctx->debugging) {
                                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                            time_end_326312 = get_wall_time();
                                            fprintf(ctx->log,
                                                    "Kernel %s runtime: %ldus\n",
                                                    "main.segred_small_304718",
                                                    time_end_326312 -
                                                    time_start_326311);
                                        }
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "");
                                } else {
                                    int64_t groups_per_segment_321996 =
                                            sdiv_up64(num_groups_304711,
                                                      smax64((int64_t) 1,
                                                             partition_sizze_292766 *
                                                             n_p_292677 *
                                                             s_n_m_292825));
                                    int64_t elements_per_thread_321997 =
                                            sdiv_up64(q_s_292678,
                                                      segred_group_sizze_304710 *
                                                      groups_per_segment_321996);
                                    int64_t virt_num_groups_321998 =
                                            groups_per_segment_321996 *
                                            (partition_sizze_292766 *
                                             n_p_292677 * s_n_m_292825);
                                    int64_t num_threads_321999 =
                                            num_groups_304711 *
                                            segred_group_sizze_304710;
                                    int64_t threads_per_segment_322000 =
                                            groups_per_segment_321996 *
                                            segred_group_sizze_304710;
                                    
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n",
                                                "\n# SegRed-large");
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "num_segments",
                                                (long long) (partition_sizze_292766 *
                                                             n_p_292677 *
                                                             s_n_m_292825),
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "segment_size",
                                                (long long) q_s_292678, '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "virt_num_groups",
                                                (long long) virt_num_groups_321998,
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "num_groups",
                                                (long long) num_groups_304711,
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "group_size",
                                                (long long) segred_group_sizze_304710,
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "elems_per_thread",
                                                (long long) elements_per_thread_321997,
                                                '\n');
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s: %llu%c",
                                                "groups_per_segment",
                                                (long long) groups_per_segment_321996,
                                                '\n');
                                    
                                    struct memblock_device
                                    segred_tmp_mem_322001;
                                    
                                    segred_tmp_mem_322001.references = NULL;
                                    if (memblock_alloc_device(ctx,
                                                              &segred_tmp_mem_322001,
                                                              (int64_t) 8 *
                                                              virt_num_groups_321998,
                                                              "segred_tmp_mem_322001")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device
                                    mainzicounter_mem_322003 =
                                    ctx->mainzicounter_mem_322003;
                                    unsigned int shared_sizze_326328 = 1;
                                    unsigned int shared_sizze_326330 =
                                                 (int64_t) 8 *
                                                 segred_group_sizze_304710;
                                    CUdeviceptr kernel_arg_326332 =
                                                ext_mem_318609.mem;
                                    CUdeviceptr kernel_arg_326333 =
                                                ext_mem_318610.mem;
                                    CUdeviceptr kernel_arg_326334 =
                                                ext_mem_318707.mem;
                                    CUdeviceptr kernel_arg_326335 =
                                                ext_mem_318708.mem;
                                    CUdeviceptr kernel_arg_326336 =
                                                mem_318871.mem;
                                    CUdeviceptr kernel_arg_326337 =
                                                mem_318876.mem;
                                    CUdeviceptr kernel_arg_326338 =
                                                mem_319072.mem;
                                    CUdeviceptr kernel_arg_326339 =
                                                mem_319077.mem;
                                    CUdeviceptr kernel_arg_326340 =
                                                mem_319083.mem;
                                    CUdeviceptr kernel_arg_326341 =
                                                segred_tmp_mem_322001.mem;
                                    CUdeviceptr kernel_arg_326342 =
                                                mainzicounter_mem_322003.mem;
                                    unsigned int shared_offset_326329 = 0;
                                    unsigned int shared_offset_326331 = 0 +
                                                 (shared_sizze_326328 + (8 -
                                                                         shared_sizze_326328 %
                                                                         8) %
                                                  8);
                                    
                                    if ((((((1 && num_groups_304711 != 0) &&
                                            1 != 0) && 1 != 0) &&
                                          segred_group_sizze_304710 != 0) &&
                                         1 != 0) && 1 != 0) {
                                        int perm[3] = {0, 1, 2};
                                        
                                        if (1 >= 1 << 16) {
                                            perm[1] = perm[0];
                                            perm[0] = 1;
                                        }
                                        if (1 >= 1 << 16) {
                                            perm[2] = perm[0];
                                            perm[0] = 2;
                                        }
                                        
                                        size_t grid[3];
                                        
                                        grid[perm[0]] = num_groups_304711;
                                        grid[perm[1]] = 1;
                                        grid[perm[2]] = 1;
                                        
                                        void *kernel_args_326325[] =
                                             {&ctx->global_failure,
                                              &shared_offset_326329,
                                              &shared_offset_326331,
                                              &n_p_292677, &q_s_292678,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &s_n_m_292825, &num_groups_304711,
                                              &groups_per_segment_321996,
                                              &elements_per_thread_321997,
                                              &virt_num_groups_321998,
                                              &threads_per_segment_322000,
                                              &kernel_arg_326332,
                                              &kernel_arg_326333,
                                              &kernel_arg_326334,
                                              &kernel_arg_326335,
                                              &kernel_arg_326336,
                                              &kernel_arg_326337,
                                              &kernel_arg_326338,
                                              &kernel_arg_326339,
                                              &kernel_arg_326340,
                                              &kernel_arg_326341,
                                              &kernel_arg_326342};
                                        int64_t time_start_326326 = 0,
                                                time_end_326327 = 0;
                                        
                                        if (ctx->debugging) {
                                            fprintf(ctx->log,
                                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                    "main.segred_large_304718",
                                                    (long) num_groups_304711,
                                                    (long) 1, (long) 1,
                                                    (long) segred_group_sizze_304710,
                                                    (long) 1, (long) 1,
                                                    (int) (0 +
                                                           (shared_sizze_326328 +
                                                            (8 -
                                                             shared_sizze_326328 %
                                                             8) % 8) +
                                                           (shared_sizze_326330 +
                                                            (8 -
                                                             shared_sizze_326330 %
                                                             8) % 8)));
                                            time_start_326326 = get_wall_time();
                                        }
                                        
                                        cudaEvent_t *pevents = NULL;
                                        
                                        if (ctx->profiling &&
                                            !ctx->profiling_paused) {
                                            pevents =
                                                cuda_get_events(&ctx->cuda,
                                                                &ctx->mainzisegred_large_304718_runs,
                                                                &ctx->mainzisegred_large_304718_total_runtime);
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                               0));
                                        }
                                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_304718,
                                                                              grid[0],
                                                                              grid[1],
                                                                              grid[2],
                                                                              segred_group_sizze_304710,
                                                                              1,
                                                                              1,
                                                                              0 +
                                                                              (shared_sizze_326328 +
                                                                               (8 -
                                                                                shared_sizze_326328 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326330 +
                                                                               (8 -
                                                                                shared_sizze_326330 %
                                                                                8) %
                                                                               8),
                                                                              NULL,
                                                                              kernel_args_326325,
                                                                              NULL));
                                        if (pevents != NULL)
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                               0));
                                        if (ctx->debugging) {
                                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                            time_end_326327 = get_wall_time();
                                            fprintf(ctx->log,
                                                    "Kernel %s runtime: %ldus\n",
                                                    "main.segred_large_304718",
                                                    time_end_326327 -
                                                    time_start_326326);
                                        }
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "");
                                    if (memblock_unref_device(ctx,
                                                              &segred_tmp_mem_322001,
                                                              "segred_tmp_mem_322001") !=
                                        0)
                                        return 1;
                                }
                                if (memblock_unref_device(ctx, &mem_319072,
                                                          "mem_319072") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319077,
                                                          "mem_319077") != 0)
                                    return 1;
                                if (memblock_set_device(ctx, &ext_mem_319084,
                                                        &mem_319083,
                                                        "mem_319083") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319083,
                                                          "mem_319083") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319077,
                                                          "mem_319077") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319072,
                                                          "mem_319072") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319066,
                                                          "mem_319066") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319060,
                                                          "mem_319060") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319056,
                                                          "mem_319056") != 0)
                                    return 1;
                            }
                            if (memblock_set_device(ctx, &ext_mem_319091,
                                                    &ext_mem_319084,
                                                    "ext_mem_319084") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319084,
                                                      "ext_mem_319084") != 0)
                                return 1;
                        }
                        if (memblock_set_device(ctx, &ext_mem_319487,
                                                &ext_mem_319091,
                                                "ext_mem_319091") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319486,
                                                &mem_318983, "mem_318983") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319091,
                                                  "ext_mem_319091") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318983,
                                                  "mem_318983") != 0)
                            return 1;
                    } else {
                        bool match_lit_294287 = (int64_t) 1 == d_s_292681;
                        struct memblock_device ext_mem_319485;
                        
                        ext_mem_319485.references = NULL;
                        
                        struct memblock_device ext_mem_319484;
                        
                        ext_mem_319484.references = NULL;
                        if (match_lit_294287) {
                            int64_t segmap_group_sizze_305862;
                            
                            segmap_group_sizze_305862 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_304773;
                            
                            int64_t num_groups_305863;
                            int32_t max_num_groups_322043;
                            
                            max_num_groups_322043 =
                                *ctx->tuning_params.mainzisegmap_num_groups_304775;
                            num_groups_305863 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(binop_x_318547,
                                                                                     segmap_group_sizze_305862),
                                                                           sext_i32_i64(max_num_groups_322043))));
                            
                            bool suff_outer_par_305867;
                            
                            suff_outer_par_305867 =
                                *ctx->tuning_params.mainzisuff_outer_par_9 <=
                                binop_x_318547;
                            if (ctx->logging)
                                fprintf(ctx->log, "Compared %s <= %ld: %s.\n",
                                        "main.suff_outer_par_9",
                                        (long) binop_x_318547,
                                        suff_outer_par_305867 ? "true" : "false");
                            
                            int64_t one_intra_par_min_305868 = q_s_292678 *
                                    s_n_m_292825;
                            int64_t intra_avail_par_305870 =
                                    smin64(s_n_m_292825,
                                           one_intra_par_min_305868);
                            int64_t computed_group_sizze_305871 =
                                    smax64(s_n_m_292825,
                                           one_intra_par_min_305868);
                            bool fits_305875 =
                                 sle64(computed_group_sizze_305871,
                                       max_group_sizze_297635);
                            bool suff_intra_par_305877;
                            
                            suff_intra_par_305877 =
                                *ctx->tuning_params.mainzisuff_intra_par_10 <=
                                intra_avail_par_305870;
                            if (ctx->logging)
                                fprintf(ctx->log, "Compared %s <= %ld: %s.\n",
                                        "main.suff_intra_par_10",
                                        (long) intra_avail_par_305870,
                                        suff_intra_par_305877 ? "true" : "false");
                            
                            bool intra_suff_and_fits_305878 = fits_305875 &&
                                 suff_intra_par_305877;
                            int64_t segmap_group_sizze_306158;
                            
                            segmap_group_sizze_306158 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_305437;
                            
                            int64_t nest_sizze_306180 = q_s_292678 *
                                    nest_sizze_299600;
                            int64_t segred_group_sizze_306181;
                            
                            segred_group_sizze_306181 =
                                *ctx->tuning_params.mainzisegred_group_sizze_305373;
                            
                            int64_t num_groups_306182;
                            int32_t max_num_groups_322044;
                            
                            max_num_groups_322044 =
                                *ctx->tuning_params.mainzisegred_num_groups_305375;
                            num_groups_306182 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(nest_sizze_306180,
                                                                                     segred_group_sizze_306181),
                                                                           sext_i32_i64(max_num_groups_322044))));
                            
                            int64_t segmap_group_sizze_306240;
                            
                            segmap_group_sizze_306240 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_305331;
                            
                            int64_t segred_group_sizze_306279;
                            
                            segred_group_sizze_306279 =
                                *ctx->tuning_params.mainzisegred_group_sizze_305237;
                            
                            int64_t num_groups_306280;
                            int32_t max_num_groups_322045;
                            
                            max_num_groups_322045 =
                                *ctx->tuning_params.mainzisegred_num_groups_305239;
                            num_groups_306280 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(nest_sizze_306180,
                                                                                     segred_group_sizze_306279),
                                                                           sext_i32_i64(max_num_groups_322045))));
                            
                            int64_t binop_x_319092 = partition_sizze_292766 *
                                    s_n_m_292825;
                            int64_t binop_x_319093 = n_p_292677 *
                                    binop_x_319092;
                            int64_t bytes_319094 = (int64_t) 8 * binop_x_319093;
                            int64_t binop_x_319100 = partition_sizze_292766 *
                                    defunc_0_f_res_292820;
                            int64_t binop_x_319101 = n_p_292677 *
                                    binop_x_319100;
                            int64_t bytes_319102 = (int64_t) 8 * binop_x_319101;
                            int64_t bytes_319156 = smax64((int64_t) 0,
                                                          s_n_m_292825);
                            int64_t bytes_319206 = smax64((int64_t) 0,
                                                          binop_x_318640);
                            int64_t num_threads_320720 =
                                    segmap_group_sizze_305862 *
                                    num_groups_305863;
                            int64_t total_sizze_320721 = bytes_318656 *
                                    num_threads_320720;
                            int64_t total_sizze_320722 = bytes_318656 *
                                    num_threads_320720;
                            struct memblock_device ext_mem_319271;
                            
                            ext_mem_319271.references = NULL;
                            
                            struct memblock_device ext_mem_319270;
                            
                            ext_mem_319270.references = NULL;
                            
                            int32_t local_memory_capacity_322387;
                            
                            local_memory_capacity_322387 =
                                ctx->cuda.max_shared_memory;
                            if (sle64((int64_t) 0,
                                      sext_i32_i64(local_memory_capacity_322387)) &&
                                suff_outer_par_305867) {
                                struct memblock_device mem_319095;
                                
                                mem_319095.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319095,
                                                          bytes_319094,
                                                          "mem_319095")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_i64(ctx,
                                                                          mem_319095,
                                                                          (int64_t) 0,
                                                                          ext_mem_318708,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          s_n_m_292825,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319095,
                                                              "mem_319095") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319270,
                                                              "ext_mem_319270") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319271,
                                                              "ext_mem_319271") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319099;
                                
                                mem_319099.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319099,
                                                          bytes_319094,
                                                          "mem_319099")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                          mem_319099,
                                                                          (int64_t) 0,
                                                                          ext_mem_318707,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          s_n_m_292825,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319099,
                                                              "mem_319099") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319095,
                                                              "mem_319095") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319270,
                                                              "ext_mem_319270") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319271,
                                                              "ext_mem_319271") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319103;
                                
                                mem_319103.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319103,
                                                          bytes_319102,
                                                          "mem_319103")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_i64(ctx,
                                                                          mem_319103,
                                                                          (int64_t) 0,
                                                                          ext_mem_318610,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          defunc_0_f_res_292820,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319103,
                                                              "mem_319103") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319099,
                                                              "mem_319099") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319095,
                                                              "mem_319095") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319270,
                                                              "ext_mem_319270") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319271,
                                                              "ext_mem_319271") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319107;
                                
                                mem_319107.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319107,
                                                          bytes_319102,
                                                          "mem_319107")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                          mem_319107,
                                                                          (int64_t) 0,
                                                                          mem_318876,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          defunc_0_f_res_292820,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319107,
                                                              "mem_319107") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319103,
                                                              "mem_319103") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319099,
                                                              "mem_319099") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319095,
                                                              "mem_319095") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319270,
                                                              "ext_mem_319270") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319271,
                                                              "ext_mem_319271") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319111;
                                
                                mem_319111.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319111,
                                                          bytes_319102,
                                                          "mem_319111")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                          mem_319111,
                                                                          (int64_t) 0,
                                                                          mem_318871,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          defunc_0_f_res_292820,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319111,
                                                              "mem_319111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319107,
                                                              "mem_319107") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319103,
                                                              "mem_319103") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319099,
                                                              "mem_319099") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319095,
                                                              "mem_319095") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319270,
                                                              "ext_mem_319270") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319271,
                                                              "ext_mem_319271") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319146;
                                
                                mem_319146.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319146,
                                                          bytes_319094,
                                                          "mem_319146")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319150;
                                
                                mem_319150.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319150,
                                                          bytes_319094,
                                                          "mem_319150")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device color_320619;
                                
                                color_320619.references = NULL;
                                if (memblock_alloc_device(ctx, &color_320619,
                                                          total_sizze_320721,
                                                          "color_320619")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device color_320620;
                                
                                color_320620.references = NULL;
                                if (memblock_alloc_device(ctx, &color_320620,
                                                          total_sizze_320722,
                                                          "color_320620")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                                
                                CUdeviceptr kernel_arg_326346 =
                                            ext_mem_318609.mem;
                                CUdeviceptr kernel_arg_326347 = mem_319095.mem;
                                CUdeviceptr kernel_arg_326348 = mem_319099.mem;
                                CUdeviceptr kernel_arg_326349 = mem_319103.mem;
                                CUdeviceptr kernel_arg_326350 = mem_319107.mem;
                                CUdeviceptr kernel_arg_326351 = mem_319111.mem;
                                CUdeviceptr kernel_arg_326352 = mem_319146.mem;
                                CUdeviceptr kernel_arg_326353 = mem_319150.mem;
                                CUdeviceptr kernel_arg_326354 =
                                            color_320619.mem;
                                CUdeviceptr kernel_arg_326355 =
                                            color_320620.mem;
                                
                                if ((((((1 && num_groups_305863 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segmap_group_sizze_305862 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_305863;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_326343[] =
                                         {&ctx->global_failure, &n_p_292677,
                                          &q_s_292678, &jump_s_292684,
                                          &partition_sizze_292766,
                                          &defunc_0_f_res_292820,
                                          &pad_css_len_292821, &s_n_m_292825,
                                          &num_groups_305863,
                                          &num_threads_320720,
                                          &kernel_arg_326346,
                                          &kernel_arg_326347,
                                          &kernel_arg_326348,
                                          &kernel_arg_326349,
                                          &kernel_arg_326350,
                                          &kernel_arg_326351,
                                          &kernel_arg_326352,
                                          &kernel_arg_326353,
                                          &kernel_arg_326354,
                                          &kernel_arg_326355};
                                    int64_t time_start_326344 = 0,
                                            time_end_326345 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segmap_305885",
                                                (long) num_groups_305863,
                                                (long) 1, (long) 1,
                                                (long) segmap_group_sizze_305862,
                                                (long) 1, (long) 1, (int) 0);
                                        time_start_326344 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegmap_305885_runs,
                                                                  &ctx->mainzisegmap_305885_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_305885,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segmap_group_sizze_305862,
                                                                          1, 1,
                                                                          0,
                                                                          NULL,
                                                                          kernel_args_326343,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_326345 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segmap_305885",
                                                time_end_326345 -
                                                time_start_326344);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_unref_device(ctx, &mem_319095,
                                                          "mem_319095") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319099,
                                                          "mem_319099") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319103,
                                                          "mem_319103") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319107,
                                                          "mem_319107") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319111,
                                                          "mem_319111") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &color_320619,
                                                          "color_320619") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &color_320620,
                                                          "color_320620") != 0)
                                    return 1;
                                
                                struct memblock_device mem_319262;
                                
                                mem_319262.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319262,
                                                          bytes_318642,
                                                          "mem_319262")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                          mem_319262,
                                                                          (int64_t) 0,
                                                                          mem_319146,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677,
                                                                          s_n_m_292825) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319262,
                                                              "mem_319262") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &color_320620,
                                                              "color_320620") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &color_320619,
                                                              "color_320619") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319150,
                                                              "mem_319150") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319146,
                                                              "mem_319146") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319111,
                                                              "mem_319111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319107,
                                                              "mem_319107") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319103,
                                                              "mem_319103") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319099,
                                                              "mem_319099") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319095,
                                                              "mem_319095") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319270,
                                                              "ext_mem_319270") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319271,
                                                              "ext_mem_319271") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                if (memblock_unref_device(ctx, &mem_319146,
                                                          "mem_319146") != 0)
                                    return 1;
                                
                                struct memblock_device mem_319268;
                                
                                mem_319268.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319268,
                                                          bytes_318642,
                                                          "mem_319268")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                          mem_319268,
                                                                          (int64_t) 0,
                                                                          mem_319150,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677,
                                                                          s_n_m_292825) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319268,
                                                              "mem_319268") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319262,
                                                              "mem_319262") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &color_320620,
                                                              "color_320620") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &color_320619,
                                                              "color_320619") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319150,
                                                              "mem_319150") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319146,
                                                              "mem_319146") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319111,
                                                              "mem_319111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319107,
                                                              "mem_319107") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319103,
                                                              "mem_319103") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319099,
                                                              "mem_319099") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319095,
                                                              "mem_319095") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319270,
                                                              "ext_mem_319270") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319271,
                                                              "ext_mem_319271") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                if (memblock_unref_device(ctx, &mem_319150,
                                                          "mem_319150") != 0)
                                    return 1;
                                if (memblock_set_device(ctx, &ext_mem_319271,
                                                        &mem_319262,
                                                        "mem_319262") != 0)
                                    return 1;
                                if (memblock_set_device(ctx, &ext_mem_319270,
                                                        &mem_319268,
                                                        "mem_319268") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319268,
                                                          "mem_319268") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319262,
                                                          "mem_319262") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &color_320620,
                                                          "color_320620") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &color_320619,
                                                          "color_320619") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319150,
                                                          "mem_319150") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319146,
                                                          "mem_319146") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319111,
                                                          "mem_319111") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319107,
                                                          "mem_319107") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319103,
                                                          "mem_319103") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319099,
                                                          "mem_319099") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319095,
                                                          "mem_319095") != 0)
                                    return 1;
                            } else {
                                struct memblock_device ext_mem_319257;
                                
                                ext_mem_319257.references = NULL;
                                
                                struct memblock_device ext_mem_319256;
                                
                                ext_mem_319256.references = NULL;
                                
                                int32_t local_memory_capacity_322386;
                                
                                local_memory_capacity_322386 =
                                    ctx->cuda.max_shared_memory;
                                if (sle64(bytes_318656 + srem64((int64_t) 8 -
                                                                srem64(bytes_318656,
                                                                       (int64_t) 8),
                                                                (int64_t) 8) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_319156 + srem64((int64_t) 8 -
                                                                 srem64(bytes_319156,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          ((int64_t) 8 * (s_n_m_292825 *
                                                          q_s_292678) +
                                           srem64((int64_t) 8 -
                                                  srem64((int64_t) 8 *
                                                         (s_n_m_292825 *
                                                          q_s_292678),
                                                         (int64_t) 8),
                                                  (int64_t) 8)) + ((int64_t) 8 *
                                                                   (s_n_m_292825 *
                                                                    q_s_292678) +
                                                                   srem64((int64_t) 8 -
                                                                          srem64((int64_t) 8 *
                                                                                 (s_n_m_292825 *
                                                                                  q_s_292678),
                                                                                 (int64_t) 8),
                                                                          (int64_t) 8)) +
                                          ((int64_t) 8 * (s_n_m_292825 *
                                                          q_s_292678) +
                                           srem64((int64_t) 8 -
                                                  srem64((int64_t) 8 *
                                                         (s_n_m_292825 *
                                                          q_s_292678),
                                                         (int64_t) 8),
                                                  (int64_t) 8)) + ((int64_t) 8 *
                                                                   (s_n_m_292825 *
                                                                    q_s_292678) +
                                                                   srem64((int64_t) 8 -
                                                                          srem64((int64_t) 8 *
                                                                                 (s_n_m_292825 *
                                                                                  q_s_292678),
                                                                                 (int64_t) 8),
                                                                          (int64_t) 8)) +
                                          ((int64_t) 8 * (s_n_m_292825 *
                                                          q_s_292678) +
                                           srem64((int64_t) 8 -
                                                  srem64((int64_t) 8 *
                                                         (s_n_m_292825 *
                                                          q_s_292678),
                                                         (int64_t) 8),
                                                  (int64_t) 8)),
                                          sext_i32_i64(local_memory_capacity_322386)) &&
                                    intra_suff_and_fits_305878) {
                                    struct memblock_device mem_319192;
                                    
                                    mem_319192.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319192,
                                                              bytes_318642,
                                                              "mem_319192")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319197;
                                    
                                    mem_319197.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319197,
                                                              bytes_318642,
                                                              "mem_319197")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "\n# SegMap");
                                    
                                    int32_t num_chunks_322070 =
                                            sext_i64_i32(sdiv_up64(s_n_m_292825,
                                                                   computed_group_sizze_305871));
                                    int32_t num_chunks_322071 =
                                            sext_i64_i32(sdiv_up64(s_n_m_292825 *
                                                                   q_s_292678,
                                                                   computed_group_sizze_305871));
                                    unsigned int shared_sizze_326359 =
                                                 (int64_t) 8 * (s_n_m_292825 *
                                                                q_s_292678);
                                    unsigned int shared_sizze_326361 =
                                                 (int64_t) 8 * (s_n_m_292825 *
                                                                q_s_292678);
                                    unsigned int shared_sizze_326363 =
                                                 (int64_t) 8 * (s_n_m_292825 *
                                                                q_s_292678);
                                    unsigned int shared_sizze_326365 =
                                                 (int64_t) 8 * (s_n_m_292825 *
                                                                q_s_292678);
                                    unsigned int shared_sizze_326367 =
                                                 (int64_t) 8 * (s_n_m_292825 *
                                                                q_s_292678);
                                    unsigned int shared_sizze_326369 =
                                                 bytes_319156;
                                    unsigned int shared_sizze_326371 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326373 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326375 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326377 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326379 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326381 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326383 =
                                                 bytes_318656;
                                    CUdeviceptr kernel_arg_326385 =
                                                ext_mem_318609.mem;
                                    CUdeviceptr kernel_arg_326386 =
                                                ext_mem_318610.mem;
                                    CUdeviceptr kernel_arg_326387 =
                                                ext_mem_318707.mem;
                                    CUdeviceptr kernel_arg_326388 =
                                                ext_mem_318708.mem;
                                    CUdeviceptr kernel_arg_326389 =
                                                mem_318871.mem;
                                    CUdeviceptr kernel_arg_326390 =
                                                mem_318876.mem;
                                    CUdeviceptr kernel_arg_326391 =
                                                mem_319192.mem;
                                    CUdeviceptr kernel_arg_326392 =
                                                mem_319197.mem;
                                    unsigned int shared_offset_326360 = 0;
                                    unsigned int shared_offset_326362 = 0 +
                                                 (shared_sizze_326359 + (8 -
                                                                         shared_sizze_326359 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326364 = 0 +
                                                 (shared_sizze_326359 + (8 -
                                                                         shared_sizze_326359 %
                                                                         8) %
                                                  8) + (shared_sizze_326361 +
                                                        (8 -
                                                         shared_sizze_326361 %
                                                         8) % 8);
                                    unsigned int shared_offset_326366 = 0 +
                                                 (shared_sizze_326359 + (8 -
                                                                         shared_sizze_326359 %
                                                                         8) %
                                                  8) + (shared_sizze_326361 +
                                                        (8 -
                                                         shared_sizze_326361 %
                                                         8) % 8) +
                                                 (shared_sizze_326363 + (8 -
                                                                         shared_sizze_326363 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326368 = 0 +
                                                 (shared_sizze_326359 + (8 -
                                                                         shared_sizze_326359 %
                                                                         8) %
                                                  8) + (shared_sizze_326361 +
                                                        (8 -
                                                         shared_sizze_326361 %
                                                         8) % 8) +
                                                 (shared_sizze_326363 + (8 -
                                                                         shared_sizze_326363 %
                                                                         8) %
                                                  8) + (shared_sizze_326365 +
                                                        (8 -
                                                         shared_sizze_326365 %
                                                         8) % 8);
                                    unsigned int shared_offset_326370 = 0 +
                                                 (shared_sizze_326359 + (8 -
                                                                         shared_sizze_326359 %
                                                                         8) %
                                                  8) + (shared_sizze_326361 +
                                                        (8 -
                                                         shared_sizze_326361 %
                                                         8) % 8) +
                                                 (shared_sizze_326363 + (8 -
                                                                         shared_sizze_326363 %
                                                                         8) %
                                                  8) + (shared_sizze_326365 +
                                                        (8 -
                                                         shared_sizze_326365 %
                                                         8) % 8) +
                                                 (shared_sizze_326367 + (8 -
                                                                         shared_sizze_326367 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326372 = 0 +
                                                 (shared_sizze_326359 + (8 -
                                                                         shared_sizze_326359 %
                                                                         8) %
                                                  8) + (shared_sizze_326361 +
                                                        (8 -
                                                         shared_sizze_326361 %
                                                         8) % 8) +
                                                 (shared_sizze_326363 + (8 -
                                                                         shared_sizze_326363 %
                                                                         8) %
                                                  8) + (shared_sizze_326365 +
                                                        (8 -
                                                         shared_sizze_326365 %
                                                         8) % 8) +
                                                 (shared_sizze_326367 + (8 -
                                                                         shared_sizze_326367 %
                                                                         8) %
                                                  8) + (shared_sizze_326369 +
                                                        (8 -
                                                         shared_sizze_326369 %
                                                         8) % 8);
                                    unsigned int shared_offset_326374 = 0 +
                                                 (shared_sizze_326359 + (8 -
                                                                         shared_sizze_326359 %
                                                                         8) %
                                                  8) + (shared_sizze_326361 +
                                                        (8 -
                                                         shared_sizze_326361 %
                                                         8) % 8) +
                                                 (shared_sizze_326363 + (8 -
                                                                         shared_sizze_326363 %
                                                                         8) %
                                                  8) + (shared_sizze_326365 +
                                                        (8 -
                                                         shared_sizze_326365 %
                                                         8) % 8) +
                                                 (shared_sizze_326367 + (8 -
                                                                         shared_sizze_326367 %
                                                                         8) %
                                                  8) + (shared_sizze_326369 +
                                                        (8 -
                                                         shared_sizze_326369 %
                                                         8) % 8) +
                                                 (shared_sizze_326371 + (8 -
                                                                         shared_sizze_326371 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326376 = 0 +
                                                 (shared_sizze_326359 + (8 -
                                                                         shared_sizze_326359 %
                                                                         8) %
                                                  8) + (shared_sizze_326361 +
                                                        (8 -
                                                         shared_sizze_326361 %
                                                         8) % 8) +
                                                 (shared_sizze_326363 + (8 -
                                                                         shared_sizze_326363 %
                                                                         8) %
                                                  8) + (shared_sizze_326365 +
                                                        (8 -
                                                         shared_sizze_326365 %
                                                         8) % 8) +
                                                 (shared_sizze_326367 + (8 -
                                                                         shared_sizze_326367 %
                                                                         8) %
                                                  8) + (shared_sizze_326369 +
                                                        (8 -
                                                         shared_sizze_326369 %
                                                         8) % 8) +
                                                 (shared_sizze_326371 + (8 -
                                                                         shared_sizze_326371 %
                                                                         8) %
                                                  8) + (shared_sizze_326373 +
                                                        (8 -
                                                         shared_sizze_326373 %
                                                         8) % 8);
                                    unsigned int shared_offset_326378 = 0 +
                                                 (shared_sizze_326359 + (8 -
                                                                         shared_sizze_326359 %
                                                                         8) %
                                                  8) + (shared_sizze_326361 +
                                                        (8 -
                                                         shared_sizze_326361 %
                                                         8) % 8) +
                                                 (shared_sizze_326363 + (8 -
                                                                         shared_sizze_326363 %
                                                                         8) %
                                                  8) + (shared_sizze_326365 +
                                                        (8 -
                                                         shared_sizze_326365 %
                                                         8) % 8) +
                                                 (shared_sizze_326367 + (8 -
                                                                         shared_sizze_326367 %
                                                                         8) %
                                                  8) + (shared_sizze_326369 +
                                                        (8 -
                                                         shared_sizze_326369 %
                                                         8) % 8) +
                                                 (shared_sizze_326371 + (8 -
                                                                         shared_sizze_326371 %
                                                                         8) %
                                                  8) + (shared_sizze_326373 +
                                                        (8 -
                                                         shared_sizze_326373 %
                                                         8) % 8) +
                                                 (shared_sizze_326375 + (8 -
                                                                         shared_sizze_326375 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326380 = 0 +
                                                 (shared_sizze_326359 + (8 -
                                                                         shared_sizze_326359 %
                                                                         8) %
                                                  8) + (shared_sizze_326361 +
                                                        (8 -
                                                         shared_sizze_326361 %
                                                         8) % 8) +
                                                 (shared_sizze_326363 + (8 -
                                                                         shared_sizze_326363 %
                                                                         8) %
                                                  8) + (shared_sizze_326365 +
                                                        (8 -
                                                         shared_sizze_326365 %
                                                         8) % 8) +
                                                 (shared_sizze_326367 + (8 -
                                                                         shared_sizze_326367 %
                                                                         8) %
                                                  8) + (shared_sizze_326369 +
                                                        (8 -
                                                         shared_sizze_326369 %
                                                         8) % 8) +
                                                 (shared_sizze_326371 + (8 -
                                                                         shared_sizze_326371 %
                                                                         8) %
                                                  8) + (shared_sizze_326373 +
                                                        (8 -
                                                         shared_sizze_326373 %
                                                         8) % 8) +
                                                 (shared_sizze_326375 + (8 -
                                                                         shared_sizze_326375 %
                                                                         8) %
                                                  8) + (shared_sizze_326377 +
                                                        (8 -
                                                         shared_sizze_326377 %
                                                         8) % 8);
                                    unsigned int shared_offset_326382 = 0 +
                                                 (shared_sizze_326359 + (8 -
                                                                         shared_sizze_326359 %
                                                                         8) %
                                                  8) + (shared_sizze_326361 +
                                                        (8 -
                                                         shared_sizze_326361 %
                                                         8) % 8) +
                                                 (shared_sizze_326363 + (8 -
                                                                         shared_sizze_326363 %
                                                                         8) %
                                                  8) + (shared_sizze_326365 +
                                                        (8 -
                                                         shared_sizze_326365 %
                                                         8) % 8) +
                                                 (shared_sizze_326367 + (8 -
                                                                         shared_sizze_326367 %
                                                                         8) %
                                                  8) + (shared_sizze_326369 +
                                                        (8 -
                                                         shared_sizze_326369 %
                                                         8) % 8) +
                                                 (shared_sizze_326371 + (8 -
                                                                         shared_sizze_326371 %
                                                                         8) %
                                                  8) + (shared_sizze_326373 +
                                                        (8 -
                                                         shared_sizze_326373 %
                                                         8) % 8) +
                                                 (shared_sizze_326375 + (8 -
                                                                         shared_sizze_326375 %
                                                                         8) %
                                                  8) + (shared_sizze_326377 +
                                                        (8 -
                                                         shared_sizze_326377 %
                                                         8) % 8) +
                                                 (shared_sizze_326379 + (8 -
                                                                         shared_sizze_326379 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326384 = 0 +
                                                 (shared_sizze_326359 + (8 -
                                                                         shared_sizze_326359 %
                                                                         8) %
                                                  8) + (shared_sizze_326361 +
                                                        (8 -
                                                         shared_sizze_326361 %
                                                         8) % 8) +
                                                 (shared_sizze_326363 + (8 -
                                                                         shared_sizze_326363 %
                                                                         8) %
                                                  8) + (shared_sizze_326365 +
                                                        (8 -
                                                         shared_sizze_326365 %
                                                         8) % 8) +
                                                 (shared_sizze_326367 + (8 -
                                                                         shared_sizze_326367 %
                                                                         8) %
                                                  8) + (shared_sizze_326369 +
                                                        (8 -
                                                         shared_sizze_326369 %
                                                         8) % 8) +
                                                 (shared_sizze_326371 + (8 -
                                                                         shared_sizze_326371 %
                                                                         8) %
                                                  8) + (shared_sizze_326373 +
                                                        (8 -
                                                         shared_sizze_326373 %
                                                         8) % 8) +
                                                 (shared_sizze_326375 + (8 -
                                                                         shared_sizze_326375 %
                                                                         8) %
                                                  8) + (shared_sizze_326377 +
                                                        (8 -
                                                         shared_sizze_326377 %
                                                         8) % 8) +
                                                 (shared_sizze_326379 + (8 -
                                                                         shared_sizze_326379 %
                                                                         8) %
                                                  8) + (shared_sizze_326381 +
                                                        (8 -
                                                         shared_sizze_326381 %
                                                         8) % 8);
                                    
                                    if ((((((1 && binop_x_318547 != 0) && 1 !=
                                            0) && 1 != 0) &&
                                          computed_group_sizze_305871 != 0) &&
                                         1 != 0) && 1 != 0) {
                                        int perm[3] = {0, 1, 2};
                                        
                                        if (1 >= 1 << 16) {
                                            perm[1] = perm[0];
                                            perm[0] = 1;
                                        }
                                        if (1 >= 1 << 16) {
                                            perm[2] = perm[0];
                                            perm[0] = 2;
                                        }
                                        
                                        size_t grid[3];
                                        
                                        grid[perm[0]] = binop_x_318547;
                                        grid[perm[1]] = 1;
                                        grid[perm[2]] = 1;
                                        
                                        void *kernel_args_326356[] =
                                             {&ctx->global_failure,
                                              &shared_offset_326360,
                                              &shared_offset_326362,
                                              &shared_offset_326364,
                                              &shared_offset_326366,
                                              &shared_offset_326368,
                                              &shared_offset_326370,
                                              &shared_offset_326372,
                                              &shared_offset_326374,
                                              &shared_offset_326376,
                                              &shared_offset_326378,
                                              &shared_offset_326380,
                                              &shared_offset_326382,
                                              &shared_offset_326384,
                                              &n_p_292677, &q_s_292678,
                                              &jump_s_292684,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &pad_css_len_292821,
                                              &s_n_m_292825,
                                              &computed_group_sizze_305871,
                                              &kernel_arg_326385,
                                              &kernel_arg_326386,
                                              &kernel_arg_326387,
                                              &kernel_arg_326388,
                                              &kernel_arg_326389,
                                              &kernel_arg_326390,
                                              &kernel_arg_326391,
                                              &kernel_arg_326392};
                                        int64_t time_start_326357 = 0,
                                                time_end_326358 = 0;
                                        
                                        if (ctx->debugging) {
                                            fprintf(ctx->log,
                                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                    "main.segmap_intragroup_306005",
                                                    (long) binop_x_318547,
                                                    (long) 1, (long) 1,
                                                    (long) computed_group_sizze_305871,
                                                    (long) 1, (long) 1,
                                                    (int) (0 +
                                                           (shared_sizze_326359 +
                                                            (8 -
                                                             shared_sizze_326359 %
                                                             8) % 8) +
                                                           (shared_sizze_326361 +
                                                            (8 -
                                                             shared_sizze_326361 %
                                                             8) % 8) +
                                                           (shared_sizze_326363 +
                                                            (8 -
                                                             shared_sizze_326363 %
                                                             8) % 8) +
                                                           (shared_sizze_326365 +
                                                            (8 -
                                                             shared_sizze_326365 %
                                                             8) % 8) +
                                                           (shared_sizze_326367 +
                                                            (8 -
                                                             shared_sizze_326367 %
                                                             8) % 8) +
                                                           (shared_sizze_326369 +
                                                            (8 -
                                                             shared_sizze_326369 %
                                                             8) % 8) +
                                                           (shared_sizze_326371 +
                                                            (8 -
                                                             shared_sizze_326371 %
                                                             8) % 8) +
                                                           (shared_sizze_326373 +
                                                            (8 -
                                                             shared_sizze_326373 %
                                                             8) % 8) +
                                                           (shared_sizze_326375 +
                                                            (8 -
                                                             shared_sizze_326375 %
                                                             8) % 8) +
                                                           (shared_sizze_326377 +
                                                            (8 -
                                                             shared_sizze_326377 %
                                                             8) % 8) +
                                                           (shared_sizze_326379 +
                                                            (8 -
                                                             shared_sizze_326379 %
                                                             8) % 8) +
                                                           (shared_sizze_326381 +
                                                            (8 -
                                                             shared_sizze_326381 %
                                                             8) % 8) +
                                                           (shared_sizze_326383 +
                                                            (8 -
                                                             shared_sizze_326383 %
                                                             8) % 8)));
                                            time_start_326357 = get_wall_time();
                                        }
                                        
                                        cudaEvent_t *pevents = NULL;
                                        
                                        if (ctx->profiling &&
                                            !ctx->profiling_paused) {
                                            pevents =
                                                cuda_get_events(&ctx->cuda,
                                                                &ctx->mainzisegmap_intragroup_306005_runs,
                                                                &ctx->mainzisegmap_intragroup_306005_total_runtime);
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                               0));
                                        }
                                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_306005,
                                                                              grid[0],
                                                                              grid[1],
                                                                              grid[2],
                                                                              computed_group_sizze_305871,
                                                                              1,
                                                                              1,
                                                                              0 +
                                                                              (shared_sizze_326359 +
                                                                               (8 -
                                                                                shared_sizze_326359 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326361 +
                                                                               (8 -
                                                                                shared_sizze_326361 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326363 +
                                                                               (8 -
                                                                                shared_sizze_326363 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326365 +
                                                                               (8 -
                                                                                shared_sizze_326365 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326367 +
                                                                               (8 -
                                                                                shared_sizze_326367 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326369 +
                                                                               (8 -
                                                                                shared_sizze_326369 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326371 +
                                                                               (8 -
                                                                                shared_sizze_326371 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326373 +
                                                                               (8 -
                                                                                shared_sizze_326373 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326375 +
                                                                               (8 -
                                                                                shared_sizze_326375 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326377 +
                                                                               (8 -
                                                                                shared_sizze_326377 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326379 +
                                                                               (8 -
                                                                                shared_sizze_326379 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326381 +
                                                                               (8 -
                                                                                shared_sizze_326381 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326383 +
                                                                               (8 -
                                                                                shared_sizze_326383 %
                                                                                8) %
                                                                               8),
                                                                              NULL,
                                                                              kernel_args_326356,
                                                                              NULL));
                                        if (pevents != NULL)
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                               0));
                                        if (ctx->debugging) {
                                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                            time_end_326358 = get_wall_time();
                                            fprintf(ctx->log,
                                                    "Kernel %s runtime: %ldus\n",
                                                    "main.segmap_intragroup_306005",
                                                    time_end_326358 -
                                                    time_start_326357);
                                        }
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "");
                                    if (memblock_set_device(ctx,
                                                            &ext_mem_319257,
                                                            &mem_319192,
                                                            "mem_319192") != 0)
                                        return 1;
                                    if (memblock_set_device(ctx,
                                                            &ext_mem_319256,
                                                            &mem_319197,
                                                            "mem_319197") != 0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319197,
                                                              "mem_319197") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319192,
                                                              "mem_319192") !=
                                        0)
                                        return 1;
                                } else {
                                    int64_t segmap_usable_groups_306159 =
                                            sdiv_up64(nest_sizze_299600,
                                                      segmap_group_sizze_306158);
                                    struct memblock_device mem_319203;
                                    
                                    mem_319203.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319203,
                                                              bytes_318642,
                                                              "mem_319203")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319207;
                                    
                                    mem_319207.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319207,
                                                              bytes_319206,
                                                              "mem_319207")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "\n# SegMap");
                                    
                                    CUdeviceptr kernel_arg_326396 =
                                                mem_319203.mem;
                                    CUdeviceptr kernel_arg_326397 =
                                                mem_319207.mem;
                                    
                                    if ((((((1 && segmap_usable_groups_306159 !=
                                             0) && 1 != 0) && 1 != 0) &&
                                          segmap_group_sizze_306158 != 0) &&
                                         1 != 0) && 1 != 0) {
                                        int perm[3] = {0, 1, 2};
                                        
                                        if (1 >= 1 << 16) {
                                            perm[1] = perm[0];
                                            perm[0] = 1;
                                        }
                                        if (1 >= 1 << 16) {
                                            perm[2] = perm[0];
                                            perm[0] = 2;
                                        }
                                        
                                        size_t grid[3];
                                        
                                        grid[perm[0]] =
                                            segmap_usable_groups_306159;
                                        grid[perm[1]] = 1;
                                        grid[perm[2]] = 1;
                                        
                                        void *kernel_args_326393[] =
                                             {&ctx->global_failure, &n_p_292677,
                                              &jump_s_292684,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &pad_css_len_292821,
                                              &s_n_m_292825, &kernel_arg_326396,
                                              &kernel_arg_326397};
                                        int64_t time_start_326394 = 0,
                                                time_end_326395 = 0;
                                        
                                        if (ctx->debugging) {
                                            fprintf(ctx->log,
                                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                    "main.segmap_306165",
                                                    (long) segmap_usable_groups_306159,
                                                    (long) 1, (long) 1,
                                                    (long) segmap_group_sizze_306158,
                                                    (long) 1, (long) 1,
                                                    (int) 0);
                                            time_start_326394 = get_wall_time();
                                        }
                                        
                                        cudaEvent_t *pevents = NULL;
                                        
                                        if (ctx->profiling &&
                                            !ctx->profiling_paused) {
                                            pevents =
                                                cuda_get_events(&ctx->cuda,
                                                                &ctx->mainzisegmap_306165_runs,
                                                                &ctx->mainzisegmap_306165_total_runtime);
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                               0));
                                        }
                                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_306165,
                                                                              grid[0],
                                                                              grid[1],
                                                                              grid[2],
                                                                              segmap_group_sizze_306158,
                                                                              1,
                                                                              1,
                                                                              0,
                                                                              NULL,
                                                                              kernel_args_326393,
                                                                              NULL));
                                        if (pevents != NULL)
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                               0));
                                        if (ctx->debugging) {
                                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                            time_end_326395 = get_wall_time();
                                            fprintf(ctx->log,
                                                    "Kernel %s runtime: %ldus\n",
                                                    "main.segmap_306165",
                                                    time_end_326395 -
                                                    time_start_326394);
                                        }
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "");
                                    if (memblock_unref_device(ctx, &mem_319207,
                                                              "mem_319207") !=
                                        0)
                                        return 1;
                                    
                                    struct memblock_device mem_319213;
                                    
                                    mem_319213.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319213,
                                                              bytes_318642,
                                                              "mem_319213")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319218;
                                    
                                    mem_319218.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319218,
                                                              bytes_318642,
                                                              "mem_319218")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319223;
                                    
                                    mem_319223.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319223,
                                                              bytes_318642,
                                                              "mem_319223")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    if (slt64(q_s_292678 * (int64_t) 2,
                                              segred_group_sizze_306181)) {
                                        int64_t segment_sizze_nonzzero_322180 =
                                                smax64((int64_t) 1, q_s_292678);
                                        int64_t num_threads_322181 =
                                                num_groups_306182 *
                                                segred_group_sizze_306181;
                                        
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n",
                                                    "\n# SegRed-small");
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "num_segments",
                                                    (long long) (partition_sizze_292766 *
                                                                 n_p_292677 *
                                                                 s_n_m_292825),
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "segment_size",
                                                    (long long) q_s_292678,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "segments_per_group",
                                                    (long long) squot64(segred_group_sizze_306181,
                                                                        segment_sizze_nonzzero_322180),
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "required_groups",
                                                    (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                                       n_p_292677 *
                                                                                       s_n_m_292825,
                                                                                       squot64(segred_group_sizze_306181,
                                                                                               segment_sizze_nonzzero_322180))),
                                                    '\n');
                                        
                                        unsigned int shared_sizze_326401 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_306181;
                                        unsigned int shared_sizze_326403 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_306181;
                                        unsigned int shared_sizze_326405 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_306181;
                                        CUdeviceptr kernel_arg_326407 =
                                                    ext_mem_318609.mem;
                                        CUdeviceptr kernel_arg_326408 =
                                                    ext_mem_318610.mem;
                                        CUdeviceptr kernel_arg_326409 =
                                                    ext_mem_318707.mem;
                                        CUdeviceptr kernel_arg_326410 =
                                                    ext_mem_318708.mem;
                                        CUdeviceptr kernel_arg_326411 =
                                                    mem_318876.mem;
                                        CUdeviceptr kernel_arg_326412 =
                                                    mem_319203.mem;
                                        CUdeviceptr kernel_arg_326413 =
                                                    mem_319213.mem;
                                        CUdeviceptr kernel_arg_326414 =
                                                    mem_319218.mem;
                                        CUdeviceptr kernel_arg_326415 =
                                                    mem_319223.mem;
                                        unsigned int shared_offset_326402 = 0;
                                        unsigned int shared_offset_326404 = 0 +
                                                     (shared_sizze_326401 + (8 -
                                                                             shared_sizze_326401 %
                                                                             8) %
                                                      8);
                                        unsigned int shared_offset_326406 = 0 +
                                                     (shared_sizze_326401 + (8 -
                                                                             shared_sizze_326401 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326403 + (8 -
                                                                             shared_sizze_326403 %
                                                                             8) %
                                                      8);
                                        
                                        if ((((((1 && num_groups_306182 != 0) &&
                                                1 != 0) && 1 != 0) &&
                                              segred_group_sizze_306181 != 0) &&
                                             1 != 0) && 1 != 0) {
                                            int perm[3] = {0, 1, 2};
                                            
                                            if (1 >= 1 << 16) {
                                                perm[1] = perm[0];
                                                perm[0] = 1;
                                            }
                                            if (1 >= 1 << 16) {
                                                perm[2] = perm[0];
                                                perm[0] = 2;
                                            }
                                            
                                            size_t grid[3];
                                            
                                            grid[perm[0]] = num_groups_306182;
                                            grid[perm[1]] = 1;
                                            grid[perm[2]] = 1;
                                            
                                            void *kernel_args_326398[] =
                                                 {&ctx->global_failure,
                                                  &shared_offset_326402,
                                                  &shared_offset_326404,
                                                  &shared_offset_326406,
                                                  &n_p_292677, &q_s_292678,
                                                  &partition_sizze_292766,
                                                  &defunc_0_f_res_292820,
                                                  &s_n_m_292825,
                                                  &num_groups_306182,
                                                  &segment_sizze_nonzzero_322180,
                                                  &kernel_arg_326407,
                                                  &kernel_arg_326408,
                                                  &kernel_arg_326409,
                                                  &kernel_arg_326410,
                                                  &kernel_arg_326411,
                                                  &kernel_arg_326412,
                                                  &kernel_arg_326413,
                                                  &kernel_arg_326414,
                                                  &kernel_arg_326415};
                                            int64_t time_start_326399 = 0,
                                                    time_end_326400 = 0;
                                            
                                            if (ctx->debugging) {
                                                fprintf(ctx->log,
                                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                        "main.segred_small_306191",
                                                        (long) num_groups_306182,
                                                        (long) 1, (long) 1,
                                                        (long) segred_group_sizze_306181,
                                                        (long) 1, (long) 1,
                                                        (int) (0 +
                                                               (shared_sizze_326401 +
                                                                (8 -
                                                                 shared_sizze_326401 %
                                                                 8) % 8) +
                                                               (shared_sizze_326403 +
                                                                (8 -
                                                                 shared_sizze_326403 %
                                                                 8) % 8) +
                                                               (shared_sizze_326405 +
                                                                (8 -
                                                                 shared_sizze_326405 %
                                                                 8) % 8)));
                                                time_start_326399 =
                                                    get_wall_time();
                                            }
                                            
                                            cudaEvent_t *pevents = NULL;
                                            
                                            if (ctx->profiling &&
                                                !ctx->profiling_paused) {
                                                pevents =
                                                    cuda_get_events(&ctx->cuda,
                                                                    &ctx->mainzisegred_small_306191_runs,
                                                                    &ctx->mainzisegred_small_306191_total_runtime);
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                                   0));
                                            }
                                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_306191,
                                                                                  grid[0],
                                                                                  grid[1],
                                                                                  grid[2],
                                                                                  segred_group_sizze_306181,
                                                                                  1,
                                                                                  1,
                                                                                  0 +
                                                                                  (shared_sizze_326401 +
                                                                                   (8 -
                                                                                    shared_sizze_326401 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326403 +
                                                                                   (8 -
                                                                                    shared_sizze_326403 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326405 +
                                                                                   (8 -
                                                                                    shared_sizze_326405 %
                                                                                    8) %
                                                                                   8),
                                                                                  NULL,
                                                                                  kernel_args_326398,
                                                                                  NULL));
                                            if (pevents != NULL)
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                                   0));
                                            if (ctx->debugging) {
                                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                                time_end_326400 =
                                                    get_wall_time();
                                                fprintf(ctx->log,
                                                        "Kernel %s runtime: %ldus\n",
                                                        "main.segred_small_306191",
                                                        time_end_326400 -
                                                        time_start_326399);
                                            }
                                        }
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n", "");
                                    } else {
                                        int64_t groups_per_segment_322223 =
                                                sdiv_up64(num_groups_306182,
                                                          smax64((int64_t) 1,
                                                                 partition_sizze_292766 *
                                                                 n_p_292677 *
                                                                 s_n_m_292825));
                                        int64_t elements_per_thread_322224 =
                                                sdiv_up64(q_s_292678,
                                                          segred_group_sizze_306181 *
                                                          groups_per_segment_322223);
                                        int64_t virt_num_groups_322225 =
                                                groups_per_segment_322223 *
                                                (partition_sizze_292766 *
                                                 n_p_292677 * s_n_m_292825);
                                        int64_t num_threads_322226 =
                                                num_groups_306182 *
                                                segred_group_sizze_306181;
                                        int64_t threads_per_segment_322227 =
                                                groups_per_segment_322223 *
                                                segred_group_sizze_306181;
                                        
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n",
                                                    "\n# SegRed-large");
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "num_segments",
                                                    (long long) (partition_sizze_292766 *
                                                                 n_p_292677 *
                                                                 s_n_m_292825),
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "segment_size",
                                                    (long long) q_s_292678,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "virt_num_groups",
                                                    (long long) virt_num_groups_322225,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "num_groups",
                                                    (long long) num_groups_306182,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "group_size",
                                                    (long long) segred_group_sizze_306181,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "elems_per_thread",
                                                    (long long) elements_per_thread_322224,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "groups_per_segment",
                                                    (long long) groups_per_segment_322223,
                                                    '\n');
                                        
                                        struct memblock_device
                                        segred_tmp_mem_322228;
                                        
                                        segred_tmp_mem_322228.references = NULL;
                                        if (memblock_alloc_device(ctx,
                                                                  &segred_tmp_mem_322228,
                                                                  (int64_t) 8 *
                                                                  virt_num_groups_322225,
                                                                  "segred_tmp_mem_322228")) {
                                            err = 1;
                                            goto cleanup;
                                        }
                                        
                                        struct memblock_device
                                        segred_tmp_mem_322230;
                                        
                                        segred_tmp_mem_322230.references = NULL;
                                        if (memblock_alloc_device(ctx,
                                                                  &segred_tmp_mem_322230,
                                                                  (int64_t) 8 *
                                                                  virt_num_groups_322225,
                                                                  "segred_tmp_mem_322230")) {
                                            err = 1;
                                            goto cleanup;
                                        }
                                        
                                        struct memblock_device
                                        segred_tmp_mem_322232;
                                        
                                        segred_tmp_mem_322232.references = NULL;
                                        if (memblock_alloc_device(ctx,
                                                                  &segred_tmp_mem_322232,
                                                                  (int64_t) 8 *
                                                                  virt_num_groups_322225,
                                                                  "segred_tmp_mem_322232")) {
                                            err = 1;
                                            goto cleanup;
                                        }
                                        
                                        struct memblock_device
                                        mainzicounter_mem_322234 =
                                        ctx->mainzicounter_mem_322234;
                                        unsigned int shared_sizze_326420 = 1;
                                        unsigned int shared_sizze_326422 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_306181;
                                        unsigned int shared_sizze_326424 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_306181;
                                        unsigned int shared_sizze_326426 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_306181;
                                        CUdeviceptr kernel_arg_326428 =
                                                    ext_mem_318609.mem;
                                        CUdeviceptr kernel_arg_326429 =
                                                    ext_mem_318610.mem;
                                        CUdeviceptr kernel_arg_326430 =
                                                    ext_mem_318707.mem;
                                        CUdeviceptr kernel_arg_326431 =
                                                    ext_mem_318708.mem;
                                        CUdeviceptr kernel_arg_326432 =
                                                    mem_318876.mem;
                                        CUdeviceptr kernel_arg_326433 =
                                                    mem_319203.mem;
                                        CUdeviceptr kernel_arg_326434 =
                                                    mem_319213.mem;
                                        CUdeviceptr kernel_arg_326435 =
                                                    mem_319218.mem;
                                        CUdeviceptr kernel_arg_326436 =
                                                    mem_319223.mem;
                                        CUdeviceptr kernel_arg_326437 =
                                                    segred_tmp_mem_322228.mem;
                                        CUdeviceptr kernel_arg_326438 =
                                                    segred_tmp_mem_322230.mem;
                                        CUdeviceptr kernel_arg_326439 =
                                                    segred_tmp_mem_322232.mem;
                                        CUdeviceptr kernel_arg_326440 =
                                                    mainzicounter_mem_322234.mem;
                                        unsigned int shared_offset_326421 = 0;
                                        unsigned int shared_offset_326423 = 0 +
                                                     (shared_sizze_326420 + (8 -
                                                                             shared_sizze_326420 %
                                                                             8) %
                                                      8);
                                        unsigned int shared_offset_326425 = 0 +
                                                     (shared_sizze_326420 + (8 -
                                                                             shared_sizze_326420 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326422 + (8 -
                                                                             shared_sizze_326422 %
                                                                             8) %
                                                      8);
                                        unsigned int shared_offset_326427 = 0 +
                                                     (shared_sizze_326420 + (8 -
                                                                             shared_sizze_326420 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326422 + (8 -
                                                                             shared_sizze_326422 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326424 + (8 -
                                                                             shared_sizze_326424 %
                                                                             8) %
                                                      8);
                                        
                                        if ((((((1 && num_groups_306182 != 0) &&
                                                1 != 0) && 1 != 0) &&
                                              segred_group_sizze_306181 != 0) &&
                                             1 != 0) && 1 != 0) {
                                            int perm[3] = {0, 1, 2};
                                            
                                            if (1 >= 1 << 16) {
                                                perm[1] = perm[0];
                                                perm[0] = 1;
                                            }
                                            if (1 >= 1 << 16) {
                                                perm[2] = perm[0];
                                                perm[0] = 2;
                                            }
                                            
                                            size_t grid[3];
                                            
                                            grid[perm[0]] = num_groups_306182;
                                            grid[perm[1]] = 1;
                                            grid[perm[2]] = 1;
                                            
                                            void *kernel_args_326417[] =
                                                 {&ctx->global_failure,
                                                  &shared_offset_326421,
                                                  &shared_offset_326423,
                                                  &shared_offset_326425,
                                                  &shared_offset_326427,
                                                  &n_p_292677, &q_s_292678,
                                                  &partition_sizze_292766,
                                                  &defunc_0_f_res_292820,
                                                  &s_n_m_292825,
                                                  &num_groups_306182,
                                                  &groups_per_segment_322223,
                                                  &elements_per_thread_322224,
                                                  &virt_num_groups_322225,
                                                  &threads_per_segment_322227,
                                                  &kernel_arg_326428,
                                                  &kernel_arg_326429,
                                                  &kernel_arg_326430,
                                                  &kernel_arg_326431,
                                                  &kernel_arg_326432,
                                                  &kernel_arg_326433,
                                                  &kernel_arg_326434,
                                                  &kernel_arg_326435,
                                                  &kernel_arg_326436,
                                                  &kernel_arg_326437,
                                                  &kernel_arg_326438,
                                                  &kernel_arg_326439,
                                                  &kernel_arg_326440};
                                            int64_t time_start_326418 = 0,
                                                    time_end_326419 = 0;
                                            
                                            if (ctx->debugging) {
                                                fprintf(ctx->log,
                                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                        "main.segred_large_306191",
                                                        (long) num_groups_306182,
                                                        (long) 1, (long) 1,
                                                        (long) segred_group_sizze_306181,
                                                        (long) 1, (long) 1,
                                                        (int) (0 +
                                                               (shared_sizze_326420 +
                                                                (8 -
                                                                 shared_sizze_326420 %
                                                                 8) % 8) +
                                                               (shared_sizze_326422 +
                                                                (8 -
                                                                 shared_sizze_326422 %
                                                                 8) % 8) +
                                                               (shared_sizze_326424 +
                                                                (8 -
                                                                 shared_sizze_326424 %
                                                                 8) % 8) +
                                                               (shared_sizze_326426 +
                                                                (8 -
                                                                 shared_sizze_326426 %
                                                                 8) % 8)));
                                                time_start_326418 =
                                                    get_wall_time();
                                            }
                                            
                                            cudaEvent_t *pevents = NULL;
                                            
                                            if (ctx->profiling &&
                                                !ctx->profiling_paused) {
                                                pevents =
                                                    cuda_get_events(&ctx->cuda,
                                                                    &ctx->mainzisegred_large_306191_runs,
                                                                    &ctx->mainzisegred_large_306191_total_runtime);
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                                   0));
                                            }
                                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_306191,
                                                                                  grid[0],
                                                                                  grid[1],
                                                                                  grid[2],
                                                                                  segred_group_sizze_306181,
                                                                                  1,
                                                                                  1,
                                                                                  0 +
                                                                                  (shared_sizze_326420 +
                                                                                   (8 -
                                                                                    shared_sizze_326420 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326422 +
                                                                                   (8 -
                                                                                    shared_sizze_326422 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326424 +
                                                                                   (8 -
                                                                                    shared_sizze_326424 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326426 +
                                                                                   (8 -
                                                                                    shared_sizze_326426 %
                                                                                    8) %
                                                                                   8),
                                                                                  NULL,
                                                                                  kernel_args_326417,
                                                                                  NULL));
                                            if (pevents != NULL)
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                                   0));
                                            if (ctx->debugging) {
                                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                                time_end_326419 =
                                                    get_wall_time();
                                                fprintf(ctx->log,
                                                        "Kernel %s runtime: %ldus\n",
                                                        "main.segred_large_306191",
                                                        time_end_326419 -
                                                        time_start_326418);
                                            }
                                        }
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n", "");
                                        if (memblock_unref_device(ctx,
                                                                  &segred_tmp_mem_322232,
                                                                  "segred_tmp_mem_322232") !=
                                            0)
                                            return 1;
                                        if (memblock_unref_device(ctx,
                                                                  &segred_tmp_mem_322230,
                                                                  "segred_tmp_mem_322230") !=
                                            0)
                                            return 1;
                                        if (memblock_unref_device(ctx,
                                                                  &segred_tmp_mem_322228,
                                                                  "segred_tmp_mem_322228") !=
                                            0)
                                            return 1;
                                    }
                                    if (memblock_unref_device(ctx, &mem_319203,
                                                              "mem_319203") !=
                                        0)
                                        return 1;
                                    
                                    int64_t segmap_usable_groups_306241 =
                                            sdiv_up64(nest_sizze_299600,
                                                      segmap_group_sizze_306240);
                                    struct memblock_device mem_319229;
                                    
                                    mem_319229.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319229,
                                                              bytes_318642,
                                                              "mem_319229")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319234;
                                    
                                    mem_319234.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319234,
                                                              bytes_318642,
                                                              "mem_319234")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319239;
                                    
                                    mem_319239.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319239,
                                                              bytes_318642,
                                                              "mem_319239")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319244;
                                    
                                    mem_319244.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319244,
                                                              bytes_318642,
                                                              "mem_319244")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "\n# SegMap");
                                    
                                    CUdeviceptr kernel_arg_326444 =
                                                mem_319213.mem;
                                    CUdeviceptr kernel_arg_326445 =
                                                mem_319218.mem;
                                    CUdeviceptr kernel_arg_326446 =
                                                mem_319223.mem;
                                    CUdeviceptr kernel_arg_326447 =
                                                mem_319229.mem;
                                    CUdeviceptr kernel_arg_326448 =
                                                mem_319234.mem;
                                    CUdeviceptr kernel_arg_326449 =
                                                mem_319239.mem;
                                    CUdeviceptr kernel_arg_326450 =
                                                mem_319244.mem;
                                    
                                    if ((((((1 && segmap_usable_groups_306241 !=
                                             0) && 1 != 0) && 1 != 0) &&
                                          segmap_group_sizze_306240 != 0) &&
                                         1 != 0) && 1 != 0) {
                                        int perm[3] = {0, 1, 2};
                                        
                                        if (1 >= 1 << 16) {
                                            perm[1] = perm[0];
                                            perm[0] = 1;
                                        }
                                        if (1 >= 1 << 16) {
                                            perm[2] = perm[0];
                                            perm[0] = 2;
                                        }
                                        
                                        size_t grid[3];
                                        
                                        grid[perm[0]] =
                                            segmap_usable_groups_306241;
                                        grid[perm[1]] = 1;
                                        grid[perm[2]] = 1;
                                        
                                        void *kernel_args_326441[] =
                                             {&ctx->global_failure, &n_p_292677,
                                              &jump_s_292684,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &pad_css_len_292821,
                                              &s_n_m_292825, &kernel_arg_326444,
                                              &kernel_arg_326445,
                                              &kernel_arg_326446,
                                              &kernel_arg_326447,
                                              &kernel_arg_326448,
                                              &kernel_arg_326449,
                                              &kernel_arg_326450};
                                        int64_t time_start_326442 = 0,
                                                time_end_326443 = 0;
                                        
                                        if (ctx->debugging) {
                                            fprintf(ctx->log,
                                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                    "main.segmap_306249",
                                                    (long) segmap_usable_groups_306241,
                                                    (long) 1, (long) 1,
                                                    (long) segmap_group_sizze_306240,
                                                    (long) 1, (long) 1,
                                                    (int) 0);
                                            time_start_326442 = get_wall_time();
                                        }
                                        
                                        cudaEvent_t *pevents = NULL;
                                        
                                        if (ctx->profiling &&
                                            !ctx->profiling_paused) {
                                            pevents =
                                                cuda_get_events(&ctx->cuda,
                                                                &ctx->mainzisegmap_306249_runs,
                                                                &ctx->mainzisegmap_306249_total_runtime);
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                               0));
                                        }
                                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_306249,
                                                                              grid[0],
                                                                              grid[1],
                                                                              grid[2],
                                                                              segmap_group_sizze_306240,
                                                                              1,
                                                                              1,
                                                                              0,
                                                                              NULL,
                                                                              kernel_args_326441,
                                                                              NULL));
                                        if (pevents != NULL)
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                               0));
                                        if (ctx->debugging) {
                                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                            time_end_326443 = get_wall_time();
                                            fprintf(ctx->log,
                                                    "Kernel %s runtime: %ldus\n",
                                                    "main.segmap_306249",
                                                    time_end_326443 -
                                                    time_start_326442);
                                        }
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "");
                                    if (memblock_unref_device(ctx, &mem_319213,
                                                              "mem_319213") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319218,
                                                              "mem_319218") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319223,
                                                              "mem_319223") !=
                                        0)
                                        return 1;
                                    
                                    struct memblock_device mem_319250;
                                    
                                    mem_319250.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319250,
                                                              bytes_318642,
                                                              "mem_319250")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319255;
                                    
                                    mem_319255.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319255,
                                                              bytes_318642,
                                                              "mem_319255")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    if (slt64(q_s_292678 * (int64_t) 2,
                                              segred_group_sizze_306279)) {
                                        int64_t segment_sizze_nonzzero_322296 =
                                                smax64((int64_t) 1, q_s_292678);
                                        int64_t num_threads_322297 =
                                                num_groups_306280 *
                                                segred_group_sizze_306279;
                                        
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n",
                                                    "\n# SegRed-small");
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "num_segments",
                                                    (long long) (partition_sizze_292766 *
                                                                 n_p_292677 *
                                                                 s_n_m_292825),
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "segment_size",
                                                    (long long) q_s_292678,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "segments_per_group",
                                                    (long long) squot64(segred_group_sizze_306279,
                                                                        segment_sizze_nonzzero_322296),
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "required_groups",
                                                    (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                                       n_p_292677 *
                                                                                       s_n_m_292825,
                                                                                       squot64(segred_group_sizze_306279,
                                                                                               segment_sizze_nonzzero_322296))),
                                                    '\n');
                                        
                                        unsigned int shared_sizze_326454 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_306279;
                                        unsigned int shared_sizze_326456 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_306279;
                                        CUdeviceptr kernel_arg_326458 =
                                                    ext_mem_318609.mem;
                                        CUdeviceptr kernel_arg_326459 =
                                                    ext_mem_318610.mem;
                                        CUdeviceptr kernel_arg_326460 =
                                                    ext_mem_318707.mem;
                                        CUdeviceptr kernel_arg_326461 =
                                                    ext_mem_318708.mem;
                                        CUdeviceptr kernel_arg_326462 =
                                                    mem_318871.mem;
                                        CUdeviceptr kernel_arg_326463 =
                                                    mem_318876.mem;
                                        CUdeviceptr kernel_arg_326464 =
                                                    mem_319229.mem;
                                        CUdeviceptr kernel_arg_326465 =
                                                    mem_319234.mem;
                                        CUdeviceptr kernel_arg_326466 =
                                                    mem_319239.mem;
                                        CUdeviceptr kernel_arg_326467 =
                                                    mem_319244.mem;
                                        CUdeviceptr kernel_arg_326468 =
                                                    mem_319250.mem;
                                        CUdeviceptr kernel_arg_326469 =
                                                    mem_319255.mem;
                                        unsigned int shared_offset_326455 = 0;
                                        unsigned int shared_offset_326457 = 0 +
                                                     (shared_sizze_326454 + (8 -
                                                                             shared_sizze_326454 %
                                                                             8) %
                                                      8);
                                        
                                        if ((((((1 && num_groups_306280 != 0) &&
                                                1 != 0) && 1 != 0) &&
                                              segred_group_sizze_306279 != 0) &&
                                             1 != 0) && 1 != 0) {
                                            int perm[3] = {0, 1, 2};
                                            
                                            if (1 >= 1 << 16) {
                                                perm[1] = perm[0];
                                                perm[0] = 1;
                                            }
                                            if (1 >= 1 << 16) {
                                                perm[2] = perm[0];
                                                perm[0] = 2;
                                            }
                                            
                                            size_t grid[3];
                                            
                                            grid[perm[0]] = num_groups_306280;
                                            grid[perm[1]] = 1;
                                            grid[perm[2]] = 1;
                                            
                                            void *kernel_args_326451[] =
                                                 {&ctx->global_failure,
                                                  &shared_offset_326455,
                                                  &shared_offset_326457,
                                                  &n_p_292677, &q_s_292678,
                                                  &partition_sizze_292766,
                                                  &defunc_0_f_res_292820,
                                                  &s_n_m_292825,
                                                  &num_groups_306280,
                                                  &segment_sizze_nonzzero_322296,
                                                  &kernel_arg_326458,
                                                  &kernel_arg_326459,
                                                  &kernel_arg_326460,
                                                  &kernel_arg_326461,
                                                  &kernel_arg_326462,
                                                  &kernel_arg_326463,
                                                  &kernel_arg_326464,
                                                  &kernel_arg_326465,
                                                  &kernel_arg_326466,
                                                  &kernel_arg_326467,
                                                  &kernel_arg_326468,
                                                  &kernel_arg_326469};
                                            int64_t time_start_326452 = 0,
                                                    time_end_326453 = 0;
                                            
                                            if (ctx->debugging) {
                                                fprintf(ctx->log,
                                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                        "main.segred_small_306288",
                                                        (long) num_groups_306280,
                                                        (long) 1, (long) 1,
                                                        (long) segred_group_sizze_306279,
                                                        (long) 1, (long) 1,
                                                        (int) (0 +
                                                               (shared_sizze_326454 +
                                                                (8 -
                                                                 shared_sizze_326454 %
                                                                 8) % 8) +
                                                               (shared_sizze_326456 +
                                                                (8 -
                                                                 shared_sizze_326456 %
                                                                 8) % 8)));
                                                time_start_326452 =
                                                    get_wall_time();
                                            }
                                            
                                            cudaEvent_t *pevents = NULL;
                                            
                                            if (ctx->profiling &&
                                                !ctx->profiling_paused) {
                                                pevents =
                                                    cuda_get_events(&ctx->cuda,
                                                                    &ctx->mainzisegred_small_306288_runs,
                                                                    &ctx->mainzisegred_small_306288_total_runtime);
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                                   0));
                                            }
                                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_306288,
                                                                                  grid[0],
                                                                                  grid[1],
                                                                                  grid[2],
                                                                                  segred_group_sizze_306279,
                                                                                  1,
                                                                                  1,
                                                                                  0 +
                                                                                  (shared_sizze_326454 +
                                                                                   (8 -
                                                                                    shared_sizze_326454 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326456 +
                                                                                   (8 -
                                                                                    shared_sizze_326456 %
                                                                                    8) %
                                                                                   8),
                                                                                  NULL,
                                                                                  kernel_args_326451,
                                                                                  NULL));
                                            if (pevents != NULL)
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                                   0));
                                            if (ctx->debugging) {
                                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                                time_end_326453 =
                                                    get_wall_time();
                                                fprintf(ctx->log,
                                                        "Kernel %s runtime: %ldus\n",
                                                        "main.segred_small_306288",
                                                        time_end_326453 -
                                                        time_start_326452);
                                            }
                                        }
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n", "");
                                    } else {
                                        int64_t groups_per_segment_322333 =
                                                sdiv_up64(num_groups_306280,
                                                          smax64((int64_t) 1,
                                                                 partition_sizze_292766 *
                                                                 n_p_292677 *
                                                                 s_n_m_292825));
                                        int64_t elements_per_thread_322334 =
                                                sdiv_up64(q_s_292678,
                                                          segred_group_sizze_306279 *
                                                          groups_per_segment_322333);
                                        int64_t virt_num_groups_322335 =
                                                groups_per_segment_322333 *
                                                (partition_sizze_292766 *
                                                 n_p_292677 * s_n_m_292825);
                                        int64_t num_threads_322336 =
                                                num_groups_306280 *
                                                segred_group_sizze_306279;
                                        int64_t threads_per_segment_322337 =
                                                groups_per_segment_322333 *
                                                segred_group_sizze_306279;
                                        
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n",
                                                    "\n# SegRed-large");
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "num_segments",
                                                    (long long) (partition_sizze_292766 *
                                                                 n_p_292677 *
                                                                 s_n_m_292825),
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "segment_size",
                                                    (long long) q_s_292678,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "virt_num_groups",
                                                    (long long) virt_num_groups_322335,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "num_groups",
                                                    (long long) num_groups_306280,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "group_size",
                                                    (long long) segred_group_sizze_306279,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "elems_per_thread",
                                                    (long long) elements_per_thread_322334,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "groups_per_segment",
                                                    (long long) groups_per_segment_322333,
                                                    '\n');
                                        
                                        struct memblock_device
                                        segred_tmp_mem_322338;
                                        
                                        segred_tmp_mem_322338.references = NULL;
                                        if (memblock_alloc_device(ctx,
                                                                  &segred_tmp_mem_322338,
                                                                  (int64_t) 8 *
                                                                  virt_num_groups_322335,
                                                                  "segred_tmp_mem_322338")) {
                                            err = 1;
                                            goto cleanup;
                                        }
                                        
                                        struct memblock_device
                                        segred_tmp_mem_322340;
                                        
                                        segred_tmp_mem_322340.references = NULL;
                                        if (memblock_alloc_device(ctx,
                                                                  &segred_tmp_mem_322340,
                                                                  (int64_t) 8 *
                                                                  virt_num_groups_322335,
                                                                  "segred_tmp_mem_322340")) {
                                            err = 1;
                                            goto cleanup;
                                        }
                                        
                                        struct memblock_device
                                        mainzicounter_mem_322342 =
                                        ctx->mainzicounter_mem_322342;
                                        unsigned int shared_sizze_326474 = 1;
                                        unsigned int shared_sizze_326476 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_306279;
                                        unsigned int shared_sizze_326478 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_306279;
                                        CUdeviceptr kernel_arg_326480 =
                                                    ext_mem_318609.mem;
                                        CUdeviceptr kernel_arg_326481 =
                                                    ext_mem_318610.mem;
                                        CUdeviceptr kernel_arg_326482 =
                                                    ext_mem_318707.mem;
                                        CUdeviceptr kernel_arg_326483 =
                                                    ext_mem_318708.mem;
                                        CUdeviceptr kernel_arg_326484 =
                                                    mem_318871.mem;
                                        CUdeviceptr kernel_arg_326485 =
                                                    mem_318876.mem;
                                        CUdeviceptr kernel_arg_326486 =
                                                    mem_319229.mem;
                                        CUdeviceptr kernel_arg_326487 =
                                                    mem_319234.mem;
                                        CUdeviceptr kernel_arg_326488 =
                                                    mem_319239.mem;
                                        CUdeviceptr kernel_arg_326489 =
                                                    mem_319244.mem;
                                        CUdeviceptr kernel_arg_326490 =
                                                    mem_319250.mem;
                                        CUdeviceptr kernel_arg_326491 =
                                                    mem_319255.mem;
                                        CUdeviceptr kernel_arg_326492 =
                                                    segred_tmp_mem_322338.mem;
                                        CUdeviceptr kernel_arg_326493 =
                                                    segred_tmp_mem_322340.mem;
                                        CUdeviceptr kernel_arg_326494 =
                                                    mainzicounter_mem_322342.mem;
                                        unsigned int shared_offset_326475 = 0;
                                        unsigned int shared_offset_326477 = 0 +
                                                     (shared_sizze_326474 + (8 -
                                                                             shared_sizze_326474 %
                                                                             8) %
                                                      8);
                                        unsigned int shared_offset_326479 = 0 +
                                                     (shared_sizze_326474 + (8 -
                                                                             shared_sizze_326474 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326476 + (8 -
                                                                             shared_sizze_326476 %
                                                                             8) %
                                                      8);
                                        
                                        if ((((((1 && num_groups_306280 != 0) &&
                                                1 != 0) && 1 != 0) &&
                                              segred_group_sizze_306279 != 0) &&
                                             1 != 0) && 1 != 0) {
                                            int perm[3] = {0, 1, 2};
                                            
                                            if (1 >= 1 << 16) {
                                                perm[1] = perm[0];
                                                perm[0] = 1;
                                            }
                                            if (1 >= 1 << 16) {
                                                perm[2] = perm[0];
                                                perm[0] = 2;
                                            }
                                            
                                            size_t grid[3];
                                            
                                            grid[perm[0]] = num_groups_306280;
                                            grid[perm[1]] = 1;
                                            grid[perm[2]] = 1;
                                            
                                            void *kernel_args_326471[] =
                                                 {&ctx->global_failure,
                                                  &shared_offset_326475,
                                                  &shared_offset_326477,
                                                  &shared_offset_326479,
                                                  &n_p_292677, &q_s_292678,
                                                  &partition_sizze_292766,
                                                  &defunc_0_f_res_292820,
                                                  &s_n_m_292825,
                                                  &num_groups_306280,
                                                  &groups_per_segment_322333,
                                                  &elements_per_thread_322334,
                                                  &virt_num_groups_322335,
                                                  &threads_per_segment_322337,
                                                  &kernel_arg_326480,
                                                  &kernel_arg_326481,
                                                  &kernel_arg_326482,
                                                  &kernel_arg_326483,
                                                  &kernel_arg_326484,
                                                  &kernel_arg_326485,
                                                  &kernel_arg_326486,
                                                  &kernel_arg_326487,
                                                  &kernel_arg_326488,
                                                  &kernel_arg_326489,
                                                  &kernel_arg_326490,
                                                  &kernel_arg_326491,
                                                  &kernel_arg_326492,
                                                  &kernel_arg_326493,
                                                  &kernel_arg_326494};
                                            int64_t time_start_326472 = 0,
                                                    time_end_326473 = 0;
                                            
                                            if (ctx->debugging) {
                                                fprintf(ctx->log,
                                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                        "main.segred_large_306288",
                                                        (long) num_groups_306280,
                                                        (long) 1, (long) 1,
                                                        (long) segred_group_sizze_306279,
                                                        (long) 1, (long) 1,
                                                        (int) (0 +
                                                               (shared_sizze_326474 +
                                                                (8 -
                                                                 shared_sizze_326474 %
                                                                 8) % 8) +
                                                               (shared_sizze_326476 +
                                                                (8 -
                                                                 shared_sizze_326476 %
                                                                 8) % 8) +
                                                               (shared_sizze_326478 +
                                                                (8 -
                                                                 shared_sizze_326478 %
                                                                 8) % 8)));
                                                time_start_326472 =
                                                    get_wall_time();
                                            }
                                            
                                            cudaEvent_t *pevents = NULL;
                                            
                                            if (ctx->profiling &&
                                                !ctx->profiling_paused) {
                                                pevents =
                                                    cuda_get_events(&ctx->cuda,
                                                                    &ctx->mainzisegred_large_306288_runs,
                                                                    &ctx->mainzisegred_large_306288_total_runtime);
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                                   0));
                                            }
                                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_306288,
                                                                                  grid[0],
                                                                                  grid[1],
                                                                                  grid[2],
                                                                                  segred_group_sizze_306279,
                                                                                  1,
                                                                                  1,
                                                                                  0 +
                                                                                  (shared_sizze_326474 +
                                                                                   (8 -
                                                                                    shared_sizze_326474 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326476 +
                                                                                   (8 -
                                                                                    shared_sizze_326476 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326478 +
                                                                                   (8 -
                                                                                    shared_sizze_326478 %
                                                                                    8) %
                                                                                   8),
                                                                                  NULL,
                                                                                  kernel_args_326471,
                                                                                  NULL));
                                            if (pevents != NULL)
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                                   0));
                                            if (ctx->debugging) {
                                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                                time_end_326473 =
                                                    get_wall_time();
                                                fprintf(ctx->log,
                                                        "Kernel %s runtime: %ldus\n",
                                                        "main.segred_large_306288",
                                                        time_end_326473 -
                                                        time_start_326472);
                                            }
                                        }
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n", "");
                                        if (memblock_unref_device(ctx,
                                                                  &segred_tmp_mem_322340,
                                                                  "segred_tmp_mem_322340") !=
                                            0)
                                            return 1;
                                        if (memblock_unref_device(ctx,
                                                                  &segred_tmp_mem_322338,
                                                                  "segred_tmp_mem_322338") !=
                                            0)
                                            return 1;
                                    }
                                    if (memblock_unref_device(ctx, &mem_319229,
                                                              "mem_319229") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319234,
                                                              "mem_319234") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319239,
                                                              "mem_319239") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319244,
                                                              "mem_319244") !=
                                        0)
                                        return 1;
                                    if (memblock_set_device(ctx,
                                                            &ext_mem_319257,
                                                            &mem_319250,
                                                            "mem_319250") != 0)
                                        return 1;
                                    if (memblock_set_device(ctx,
                                                            &ext_mem_319256,
                                                            &mem_319255,
                                                            "mem_319255") != 0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319255,
                                                              "mem_319255") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319250,
                                                              "mem_319250") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319244,
                                                              "mem_319244") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319239,
                                                              "mem_319239") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319234,
                                                              "mem_319234") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319229,
                                                              "mem_319229") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319223,
                                                              "mem_319223") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319218,
                                                              "mem_319218") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319213,
                                                              "mem_319213") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319207,
                                                              "mem_319207") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319203,
                                                              "mem_319203") !=
                                        0)
                                        return 1;
                                }
                                if (memblock_set_device(ctx, &ext_mem_319271,
                                                        &ext_mem_319257,
                                                        "ext_mem_319257") != 0)
                                    return 1;
                                if (memblock_set_device(ctx, &ext_mem_319270,
                                                        &ext_mem_319256,
                                                        "ext_mem_319256") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319256,
                                                          "ext_mem_319256") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319257,
                                                          "ext_mem_319257") !=
                                    0)
                                    return 1;
                            }
                            if (memblock_set_device(ctx, &ext_mem_319485,
                                                    &ext_mem_319271,
                                                    "ext_mem_319271") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319484,
                                                    &ext_mem_319270,
                                                    "ext_mem_319270") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319270,
                                                      "ext_mem_319270") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319271,
                                                      "ext_mem_319271") != 0)
                                return 1;
                        } else {
                            int64_t segmap_group_sizze_307704;
                            
                            segmap_group_sizze_307704 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_306361;
                            
                            int64_t num_groups_307705;
                            int32_t max_num_groups_322388;
                            
                            max_num_groups_322388 =
                                *ctx->tuning_params.mainzisegmap_num_groups_306363;
                            num_groups_307705 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(binop_x_318547,
                                                                                     segmap_group_sizze_307704),
                                                                           sext_i32_i64(max_num_groups_322388))));
                            
                            bool suff_outer_par_307709;
                            
                            suff_outer_par_307709 =
                                *ctx->tuning_params.mainzisuff_outer_par_11 <=
                                binop_x_318547;
                            if (ctx->logging)
                                fprintf(ctx->log, "Compared %s <= %ld: %s.\n",
                                        "main.suff_outer_par_11",
                                        (long) binop_x_318547,
                                        suff_outer_par_307709 ? "true" : "false");
                            
                            int64_t one_intra_par_min_307710 = q_s_292678 *
                                    s_n_m_292825;
                            int64_t intra_avail_par_307712 =
                                    smin64(s_n_m_292825,
                                           one_intra_par_min_307710);
                            int64_t computed_group_sizze_307713 =
                                    smax64(s_n_m_292825,
                                           one_intra_par_min_307710);
                            bool fits_307717 =
                                 sle64(computed_group_sizze_307713,
                                       max_group_sizze_297635);
                            bool suff_intra_par_307719;
                            
                            suff_intra_par_307719 =
                                *ctx->tuning_params.mainzisuff_intra_par_12 <=
                                intra_avail_par_307712;
                            if (ctx->logging)
                                fprintf(ctx->log, "Compared %s <= %ld: %s.\n",
                                        "main.suff_intra_par_12",
                                        (long) intra_avail_par_307712,
                                        suff_intra_par_307719 ? "true" : "false");
                            
                            bool intra_suff_and_fits_307720 = fits_307717 &&
                                 suff_intra_par_307719;
                            int64_t segmap_group_sizze_308074;
                            
                            segmap_group_sizze_308074 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_307191;
                            
                            int64_t nest_sizze_308096 = q_s_292678 *
                                    nest_sizze_299600;
                            int64_t segred_group_sizze_308097;
                            
                            segred_group_sizze_308097 =
                                *ctx->tuning_params.mainzisegred_group_sizze_307119;
                            
                            int64_t num_groups_308098;
                            int32_t max_num_groups_322389;
                            
                            max_num_groups_322389 =
                                *ctx->tuning_params.mainzisegred_num_groups_307121;
                            num_groups_308098 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(nest_sizze_308096,
                                                                                     segred_group_sizze_308097),
                                                                           sext_i32_i64(max_num_groups_322389))));
                            
                            int64_t segmap_group_sizze_308166;
                            
                            segmap_group_sizze_308166 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_307056;
                            
                            int64_t segred_group_sizze_308228;
                            
                            segred_group_sizze_308228 =
                                *ctx->tuning_params.mainzisegred_group_sizze_306945;
                            
                            int64_t num_groups_308229;
                            int32_t max_num_groups_322390;
                            
                            max_num_groups_322390 =
                                *ctx->tuning_params.mainzisegred_num_groups_306947;
                            num_groups_308229 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(nest_sizze_308096,
                                                                                     segred_group_sizze_308228),
                                                                           sext_i32_i64(max_num_groups_322390))));
                            
                            int64_t binop_x_319272 = partition_sizze_292766 *
                                    s_n_m_292825;
                            int64_t binop_x_319273 = n_p_292677 *
                                    binop_x_319272;
                            int64_t bytes_319274 = (int64_t) 8 * binop_x_319273;
                            int64_t binop_x_319280 = partition_sizze_292766 *
                                    defunc_0_f_res_292820;
                            int64_t binop_x_319281 = n_p_292677 *
                                    binop_x_319280;
                            int64_t bytes_319282 = (int64_t) 8 * binop_x_319281;
                            int64_t bytes_319336 = smax64((int64_t) 0,
                                                          s_n_m_292825);
                            int64_t bytes_319398 = smax64((int64_t) 0,
                                                          binop_x_318640);
                            int64_t num_threads_320728 =
                                    segmap_group_sizze_307704 *
                                    num_groups_307705;
                            int64_t total_sizze_320729 = bytes_318656 *
                                    num_threads_320728;
                            int64_t total_sizze_320730 = bytes_318656 *
                                    num_threads_320728;
                            struct memblock_device ext_mem_319483;
                            
                            ext_mem_319483.references = NULL;
                            
                            struct memblock_device ext_mem_319482;
                            
                            ext_mem_319482.references = NULL;
                            
                            int32_t local_memory_capacity_322782;
                            
                            local_memory_capacity_322782 =
                                ctx->cuda.max_shared_memory;
                            if (sle64((int64_t) 0,
                                      sext_i32_i64(local_memory_capacity_322782)) &&
                                suff_outer_par_307709) {
                                struct memblock_device mem_319275;
                                
                                mem_319275.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319275,
                                                          bytes_319274,
                                                          "mem_319275")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_i64(ctx,
                                                                          mem_319275,
                                                                          (int64_t) 0,
                                                                          ext_mem_318708,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          s_n_m_292825,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319275,
                                                              "mem_319275") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319482,
                                                              "ext_mem_319482") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319483,
                                                              "ext_mem_319483") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319279;
                                
                                mem_319279.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319279,
                                                          bytes_319274,
                                                          "mem_319279")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                          mem_319279,
                                                                          (int64_t) 0,
                                                                          ext_mem_318707,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          s_n_m_292825,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319279,
                                                              "mem_319279") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319275,
                                                              "mem_319275") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319482,
                                                              "ext_mem_319482") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319483,
                                                              "ext_mem_319483") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319283;
                                
                                mem_319283.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319283,
                                                          bytes_319282,
                                                          "mem_319283")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_i64(ctx,
                                                                          mem_319283,
                                                                          (int64_t) 0,
                                                                          ext_mem_318610,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          defunc_0_f_res_292820,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319283,
                                                              "mem_319283") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319279,
                                                              "mem_319279") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319275,
                                                              "mem_319275") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319482,
                                                              "ext_mem_319482") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319483,
                                                              "ext_mem_319483") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319287;
                                
                                mem_319287.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319287,
                                                          bytes_319282,
                                                          "mem_319287")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                          mem_319287,
                                                                          (int64_t) 0,
                                                                          mem_318876,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          defunc_0_f_res_292820,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319287,
                                                              "mem_319287") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319283,
                                                              "mem_319283") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319279,
                                                              "mem_319279") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319275,
                                                              "mem_319275") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319482,
                                                              "ext_mem_319482") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319483,
                                                              "ext_mem_319483") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319291;
                                
                                mem_319291.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319291,
                                                          bytes_319282,
                                                          "mem_319291")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                          mem_319291,
                                                                          (int64_t) 0,
                                                                          mem_318871,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          defunc_0_f_res_292820,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319291,
                                                              "mem_319291") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319287,
                                                              "mem_319287") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319283,
                                                              "mem_319283") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319279,
                                                              "mem_319279") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319275,
                                                              "mem_319275") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319482,
                                                              "ext_mem_319482") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319483,
                                                              "ext_mem_319483") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319326;
                                
                                mem_319326.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319326,
                                                          bytes_319274,
                                                          "mem_319326")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mem_319330;
                                
                                mem_319330.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319330,
                                                          bytes_319274,
                                                          "mem_319330")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device color_320629;
                                
                                color_320629.references = NULL;
                                if (memblock_alloc_device(ctx, &color_320629,
                                                          total_sizze_320729,
                                                          "color_320629")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device color_320630;
                                
                                color_320630.references = NULL;
                                if (memblock_alloc_device(ctx, &color_320630,
                                                          total_sizze_320730,
                                                          "color_320630")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                                
                                CUdeviceptr kernel_arg_326498 =
                                            ext_mem_318609.mem;
                                CUdeviceptr kernel_arg_326499 = mem_319275.mem;
                                CUdeviceptr kernel_arg_326500 = mem_319279.mem;
                                CUdeviceptr kernel_arg_326501 = mem_319283.mem;
                                CUdeviceptr kernel_arg_326502 = mem_319287.mem;
                                CUdeviceptr kernel_arg_326503 = mem_319291.mem;
                                CUdeviceptr kernel_arg_326504 = mem_319326.mem;
                                CUdeviceptr kernel_arg_326505 = mem_319330.mem;
                                CUdeviceptr kernel_arg_326506 =
                                            color_320629.mem;
                                CUdeviceptr kernel_arg_326507 =
                                            color_320630.mem;
                                
                                if ((((((1 && num_groups_307705 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segmap_group_sizze_307704 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_307705;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_326495[] =
                                         {&ctx->global_failure, &n_p_292677,
                                          &q_s_292678, &jump_s_292684,
                                          &partition_sizze_292766,
                                          &defunc_0_f_res_292820,
                                          &pad_css_len_292821, &s_n_m_292825,
                                          &num_groups_307705,
                                          &num_threads_320728,
                                          &kernel_arg_326498,
                                          &kernel_arg_326499,
                                          &kernel_arg_326500,
                                          &kernel_arg_326501,
                                          &kernel_arg_326502,
                                          &kernel_arg_326503,
                                          &kernel_arg_326504,
                                          &kernel_arg_326505,
                                          &kernel_arg_326506,
                                          &kernel_arg_326507};
                                    int64_t time_start_326496 = 0,
                                            time_end_326497 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segmap_307727",
                                                (long) num_groups_307705,
                                                (long) 1, (long) 1,
                                                (long) segmap_group_sizze_307704,
                                                (long) 1, (long) 1, (int) 0);
                                        time_start_326496 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegmap_307727_runs,
                                                                  &ctx->mainzisegmap_307727_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_307727,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segmap_group_sizze_307704,
                                                                          1, 1,
                                                                          0,
                                                                          NULL,
                                                                          kernel_args_326495,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_326497 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segmap_307727",
                                                time_end_326497 -
                                                time_start_326496);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_unref_device(ctx, &mem_319275,
                                                          "mem_319275") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319279,
                                                          "mem_319279") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319283,
                                                          "mem_319283") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319287,
                                                          "mem_319287") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319291,
                                                          "mem_319291") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &color_320629,
                                                          "color_320629") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &color_320630,
                                                          "color_320630") != 0)
                                    return 1;
                                
                                struct memblock_device mem_319474;
                                
                                mem_319474.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319474,
                                                          bytes_318642,
                                                          "mem_319474")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                          mem_319474,
                                                                          (int64_t) 0,
                                                                          mem_319326,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677,
                                                                          s_n_m_292825) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319474,
                                                              "mem_319474") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &color_320630,
                                                              "color_320630") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &color_320629,
                                                              "color_320629") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319330,
                                                              "mem_319330") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319326,
                                                              "mem_319326") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319291,
                                                              "mem_319291") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319287,
                                                              "mem_319287") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319283,
                                                              "mem_319283") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319279,
                                                              "mem_319279") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319275,
                                                              "mem_319275") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319482,
                                                              "ext_mem_319482") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319483,
                                                              "ext_mem_319483") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                if (memblock_unref_device(ctx, &mem_319326,
                                                          "mem_319326") != 0)
                                    return 1;
                                
                                struct memblock_device mem_319480;
                                
                                mem_319480.references = NULL;
                                if (memblock_alloc_device(ctx, &mem_319480,
                                                          bytes_318642,
                                                          "mem_319480")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhgpu_map_transpose_f64(ctx,
                                                                          mem_319480,
                                                                          (int64_t) 0,
                                                                          mem_319330,
                                                                          (int64_t) 0,
                                                                          (int64_t) 1,
                                                                          partition_sizze_292766 *
                                                                          n_p_292677,
                                                                          s_n_m_292825) !=
                                    0) {
                                    if (memblock_unref_device(ctx, &mem_319480,
                                                              "mem_319480") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319474,
                                                              "mem_319474") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &color_320630,
                                                              "color_320630") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &color_320629,
                                                              "color_320629") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319330,
                                                              "mem_319330") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319326,
                                                              "mem_319326") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319291,
                                                              "mem_319291") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319287,
                                                              "mem_319287") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319283,
                                                              "mem_319283") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319279,
                                                              "mem_319279") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319275,
                                                              "mem_319275") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319482,
                                                              "ext_mem_319482") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319483,
                                                              "ext_mem_319483") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319484,
                                                              "ext_mem_319484") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319485,
                                                              "ext_mem_319485") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319486,
                                                              "ext_mem_319486") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319487,
                                                              "ext_mem_319487") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319488,
                                                              "ext_mem_319488") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319489,
                                                              "ext_mem_319489") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319490,
                                                              "ext_mem_319490") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_319491,
                                                              "ext_mem_319491") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                if (memblock_unref_device(ctx, &mem_319330,
                                                          "mem_319330") != 0)
                                    return 1;
                                if (memblock_set_device(ctx, &ext_mem_319483,
                                                        &mem_319474,
                                                        "mem_319474") != 0)
                                    return 1;
                                if (memblock_set_device(ctx, &ext_mem_319482,
                                                        &mem_319480,
                                                        "mem_319480") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319480,
                                                          "mem_319480") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319474,
                                                          "mem_319474") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &color_320630,
                                                          "color_320630") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &color_320629,
                                                          "color_320629") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319330,
                                                          "mem_319330") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319326,
                                                          "mem_319326") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319291,
                                                          "mem_319291") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319287,
                                                          "mem_319287") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319283,
                                                          "mem_319283") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319279,
                                                          "mem_319279") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319275,
                                                          "mem_319275") != 0)
                                    return 1;
                            } else {
                                struct memblock_device ext_mem_319469;
                                
                                ext_mem_319469.references = NULL;
                                
                                struct memblock_device ext_mem_319468;
                                
                                ext_mem_319468.references = NULL;
                                
                                int32_t local_memory_capacity_322781;
                                
                                local_memory_capacity_322781 =
                                    ctx->cuda.max_shared_memory;
                                if (sle64(bytes_318656 + srem64((int64_t) 8 -
                                                                srem64(bytes_318656,
                                                                       (int64_t) 8),
                                                                (int64_t) 8) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_318656 + srem64((int64_t) 8 -
                                                                 srem64(bytes_318656,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          (bytes_319336 + srem64((int64_t) 8 -
                                                                 srem64(bytes_319336,
                                                                        (int64_t) 8),
                                                                 (int64_t) 8)) +
                                          ((int64_t) 8 * (s_n_m_292825 *
                                                          q_s_292678) +
                                           srem64((int64_t) 8 -
                                                  srem64((int64_t) 8 *
                                                         (s_n_m_292825 *
                                                          q_s_292678),
                                                         (int64_t) 8),
                                                  (int64_t) 8)) + ((int64_t) 8 *
                                                                   (s_n_m_292825 *
                                                                    q_s_292678) +
                                                                   srem64((int64_t) 8 -
                                                                          srem64((int64_t) 8 *
                                                                                 (s_n_m_292825 *
                                                                                  q_s_292678),
                                                                                 (int64_t) 8),
                                                                          (int64_t) 8)) +
                                          ((int64_t) 8 * (s_n_m_292825 *
                                                          q_s_292678) +
                                           srem64((int64_t) 8 -
                                                  srem64((int64_t) 8 *
                                                         (s_n_m_292825 *
                                                          q_s_292678),
                                                         (int64_t) 8),
                                                  (int64_t) 8)) + ((int64_t) 8 *
                                                                   (s_n_m_292825 *
                                                                    q_s_292678) +
                                                                   srem64((int64_t) 8 -
                                                                          srem64((int64_t) 8 *
                                                                                 (s_n_m_292825 *
                                                                                  q_s_292678),
                                                                                 (int64_t) 8),
                                                                          (int64_t) 8)) +
                                          ((int64_t) 8 * (s_n_m_292825 *
                                                          q_s_292678) +
                                           srem64((int64_t) 8 -
                                                  srem64((int64_t) 8 *
                                                         (s_n_m_292825 *
                                                          q_s_292678),
                                                         (int64_t) 8),
                                                  (int64_t) 8)) + ((int64_t) 8 *
                                                                   (s_n_m_292825 *
                                                                    q_s_292678) +
                                                                   srem64((int64_t) 8 -
                                                                          srem64((int64_t) 8 *
                                                                                 (s_n_m_292825 *
                                                                                  q_s_292678),
                                                                                 (int64_t) 8),
                                                                          (int64_t) 8)) +
                                          ((int64_t) 8 * (s_n_m_292825 *
                                                          q_s_292678) +
                                           srem64((int64_t) 8 -
                                                  srem64((int64_t) 8 *
                                                         (s_n_m_292825 *
                                                          q_s_292678),
                                                         (int64_t) 8),
                                                  (int64_t) 8)),
                                          sext_i32_i64(local_memory_capacity_322781)) &&
                                    intra_suff_and_fits_307720) {
                                    struct memblock_device mem_319384;
                                    
                                    mem_319384.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319384,
                                                              bytes_318642,
                                                              "mem_319384")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319389;
                                    
                                    mem_319389.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319389,
                                                              bytes_318642,
                                                              "mem_319389")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "\n# SegMap");
                                    
                                    int32_t num_chunks_322417 =
                                            sext_i64_i32(sdiv_up64(s_n_m_292825,
                                                                   computed_group_sizze_307713));
                                    int32_t num_chunks_322418 =
                                            sext_i64_i32(sdiv_up64(s_n_m_292825 *
                                                                   q_s_292678,
                                                                   computed_group_sizze_307713));
                                    unsigned int shared_sizze_326511 =
                                                 (int64_t) 8 * (s_n_m_292825 *
                                                                q_s_292678);
                                    unsigned int shared_sizze_326513 =
                                                 (int64_t) 8 * (s_n_m_292825 *
                                                                q_s_292678);
                                    unsigned int shared_sizze_326515 =
                                                 (int64_t) 8 * (s_n_m_292825 *
                                                                q_s_292678);
                                    unsigned int shared_sizze_326517 =
                                                 (int64_t) 8 * (s_n_m_292825 *
                                                                q_s_292678);
                                    unsigned int shared_sizze_326519 =
                                                 (int64_t) 8 * (s_n_m_292825 *
                                                                q_s_292678);
                                    unsigned int shared_sizze_326521 =
                                                 (int64_t) 8 * (s_n_m_292825 *
                                                                q_s_292678);
                                    unsigned int shared_sizze_326523 =
                                                 (int64_t) 8 * (s_n_m_292825 *
                                                                q_s_292678);
                                    unsigned int shared_sizze_326525 =
                                                 bytes_319336;
                                    unsigned int shared_sizze_326527 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326529 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326531 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326533 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326535 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326537 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326539 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326541 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326543 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326545 =
                                                 bytes_318656;
                                    unsigned int shared_sizze_326547 =
                                                 bytes_318656;
                                    CUdeviceptr kernel_arg_326549 =
                                                ext_mem_318609.mem;
                                    CUdeviceptr kernel_arg_326550 =
                                                ext_mem_318610.mem;
                                    CUdeviceptr kernel_arg_326551 =
                                                ext_mem_318707.mem;
                                    CUdeviceptr kernel_arg_326552 =
                                                ext_mem_318708.mem;
                                    CUdeviceptr kernel_arg_326553 =
                                                mem_318871.mem;
                                    CUdeviceptr kernel_arg_326554 =
                                                mem_318876.mem;
                                    CUdeviceptr kernel_arg_326555 =
                                                mem_319384.mem;
                                    CUdeviceptr kernel_arg_326556 =
                                                mem_319389.mem;
                                    unsigned int shared_offset_326512 = 0;
                                    unsigned int shared_offset_326514 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326516 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8);
                                    unsigned int shared_offset_326518 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326520 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8);
                                    unsigned int shared_offset_326522 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326524 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8);
                                    unsigned int shared_offset_326526 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8) +
                                                 (shared_sizze_326523 + (8 -
                                                                         shared_sizze_326523 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326528 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8) +
                                                 (shared_sizze_326523 + (8 -
                                                                         shared_sizze_326523 %
                                                                         8) %
                                                  8) + (shared_sizze_326525 +
                                                        (8 -
                                                         shared_sizze_326525 %
                                                         8) % 8);
                                    unsigned int shared_offset_326530 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8) +
                                                 (shared_sizze_326523 + (8 -
                                                                         shared_sizze_326523 %
                                                                         8) %
                                                  8) + (shared_sizze_326525 +
                                                        (8 -
                                                         shared_sizze_326525 %
                                                         8) % 8) +
                                                 (shared_sizze_326527 + (8 -
                                                                         shared_sizze_326527 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326532 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8) +
                                                 (shared_sizze_326523 + (8 -
                                                                         shared_sizze_326523 %
                                                                         8) %
                                                  8) + (shared_sizze_326525 +
                                                        (8 -
                                                         shared_sizze_326525 %
                                                         8) % 8) +
                                                 (shared_sizze_326527 + (8 -
                                                                         shared_sizze_326527 %
                                                                         8) %
                                                  8) + (shared_sizze_326529 +
                                                        (8 -
                                                         shared_sizze_326529 %
                                                         8) % 8);
                                    unsigned int shared_offset_326534 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8) +
                                                 (shared_sizze_326523 + (8 -
                                                                         shared_sizze_326523 %
                                                                         8) %
                                                  8) + (shared_sizze_326525 +
                                                        (8 -
                                                         shared_sizze_326525 %
                                                         8) % 8) +
                                                 (shared_sizze_326527 + (8 -
                                                                         shared_sizze_326527 %
                                                                         8) %
                                                  8) + (shared_sizze_326529 +
                                                        (8 -
                                                         shared_sizze_326529 %
                                                         8) % 8) +
                                                 (shared_sizze_326531 + (8 -
                                                                         shared_sizze_326531 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326536 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8) +
                                                 (shared_sizze_326523 + (8 -
                                                                         shared_sizze_326523 %
                                                                         8) %
                                                  8) + (shared_sizze_326525 +
                                                        (8 -
                                                         shared_sizze_326525 %
                                                         8) % 8) +
                                                 (shared_sizze_326527 + (8 -
                                                                         shared_sizze_326527 %
                                                                         8) %
                                                  8) + (shared_sizze_326529 +
                                                        (8 -
                                                         shared_sizze_326529 %
                                                         8) % 8) +
                                                 (shared_sizze_326531 + (8 -
                                                                         shared_sizze_326531 %
                                                                         8) %
                                                  8) + (shared_sizze_326533 +
                                                        (8 -
                                                         shared_sizze_326533 %
                                                         8) % 8);
                                    unsigned int shared_offset_326538 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8) +
                                                 (shared_sizze_326523 + (8 -
                                                                         shared_sizze_326523 %
                                                                         8) %
                                                  8) + (shared_sizze_326525 +
                                                        (8 -
                                                         shared_sizze_326525 %
                                                         8) % 8) +
                                                 (shared_sizze_326527 + (8 -
                                                                         shared_sizze_326527 %
                                                                         8) %
                                                  8) + (shared_sizze_326529 +
                                                        (8 -
                                                         shared_sizze_326529 %
                                                         8) % 8) +
                                                 (shared_sizze_326531 + (8 -
                                                                         shared_sizze_326531 %
                                                                         8) %
                                                  8) + (shared_sizze_326533 +
                                                        (8 -
                                                         shared_sizze_326533 %
                                                         8) % 8) +
                                                 (shared_sizze_326535 + (8 -
                                                                         shared_sizze_326535 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326540 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8) +
                                                 (shared_sizze_326523 + (8 -
                                                                         shared_sizze_326523 %
                                                                         8) %
                                                  8) + (shared_sizze_326525 +
                                                        (8 -
                                                         shared_sizze_326525 %
                                                         8) % 8) +
                                                 (shared_sizze_326527 + (8 -
                                                                         shared_sizze_326527 %
                                                                         8) %
                                                  8) + (shared_sizze_326529 +
                                                        (8 -
                                                         shared_sizze_326529 %
                                                         8) % 8) +
                                                 (shared_sizze_326531 + (8 -
                                                                         shared_sizze_326531 %
                                                                         8) %
                                                  8) + (shared_sizze_326533 +
                                                        (8 -
                                                         shared_sizze_326533 %
                                                         8) % 8) +
                                                 (shared_sizze_326535 + (8 -
                                                                         shared_sizze_326535 %
                                                                         8) %
                                                  8) + (shared_sizze_326537 +
                                                        (8 -
                                                         shared_sizze_326537 %
                                                         8) % 8);
                                    unsigned int shared_offset_326542 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8) +
                                                 (shared_sizze_326523 + (8 -
                                                                         shared_sizze_326523 %
                                                                         8) %
                                                  8) + (shared_sizze_326525 +
                                                        (8 -
                                                         shared_sizze_326525 %
                                                         8) % 8) +
                                                 (shared_sizze_326527 + (8 -
                                                                         shared_sizze_326527 %
                                                                         8) %
                                                  8) + (shared_sizze_326529 +
                                                        (8 -
                                                         shared_sizze_326529 %
                                                         8) % 8) +
                                                 (shared_sizze_326531 + (8 -
                                                                         shared_sizze_326531 %
                                                                         8) %
                                                  8) + (shared_sizze_326533 +
                                                        (8 -
                                                         shared_sizze_326533 %
                                                         8) % 8) +
                                                 (shared_sizze_326535 + (8 -
                                                                         shared_sizze_326535 %
                                                                         8) %
                                                  8) + (shared_sizze_326537 +
                                                        (8 -
                                                         shared_sizze_326537 %
                                                         8) % 8) +
                                                 (shared_sizze_326539 + (8 -
                                                                         shared_sizze_326539 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326544 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8) +
                                                 (shared_sizze_326523 + (8 -
                                                                         shared_sizze_326523 %
                                                                         8) %
                                                  8) + (shared_sizze_326525 +
                                                        (8 -
                                                         shared_sizze_326525 %
                                                         8) % 8) +
                                                 (shared_sizze_326527 + (8 -
                                                                         shared_sizze_326527 %
                                                                         8) %
                                                  8) + (shared_sizze_326529 +
                                                        (8 -
                                                         shared_sizze_326529 %
                                                         8) % 8) +
                                                 (shared_sizze_326531 + (8 -
                                                                         shared_sizze_326531 %
                                                                         8) %
                                                  8) + (shared_sizze_326533 +
                                                        (8 -
                                                         shared_sizze_326533 %
                                                         8) % 8) +
                                                 (shared_sizze_326535 + (8 -
                                                                         shared_sizze_326535 %
                                                                         8) %
                                                  8) + (shared_sizze_326537 +
                                                        (8 -
                                                         shared_sizze_326537 %
                                                         8) % 8) +
                                                 (shared_sizze_326539 + (8 -
                                                                         shared_sizze_326539 %
                                                                         8) %
                                                  8) + (shared_sizze_326541 +
                                                        (8 -
                                                         shared_sizze_326541 %
                                                         8) % 8);
                                    unsigned int shared_offset_326546 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8) +
                                                 (shared_sizze_326523 + (8 -
                                                                         shared_sizze_326523 %
                                                                         8) %
                                                  8) + (shared_sizze_326525 +
                                                        (8 -
                                                         shared_sizze_326525 %
                                                         8) % 8) +
                                                 (shared_sizze_326527 + (8 -
                                                                         shared_sizze_326527 %
                                                                         8) %
                                                  8) + (shared_sizze_326529 +
                                                        (8 -
                                                         shared_sizze_326529 %
                                                         8) % 8) +
                                                 (shared_sizze_326531 + (8 -
                                                                         shared_sizze_326531 %
                                                                         8) %
                                                  8) + (shared_sizze_326533 +
                                                        (8 -
                                                         shared_sizze_326533 %
                                                         8) % 8) +
                                                 (shared_sizze_326535 + (8 -
                                                                         shared_sizze_326535 %
                                                                         8) %
                                                  8) + (shared_sizze_326537 +
                                                        (8 -
                                                         shared_sizze_326537 %
                                                         8) % 8) +
                                                 (shared_sizze_326539 + (8 -
                                                                         shared_sizze_326539 %
                                                                         8) %
                                                  8) + (shared_sizze_326541 +
                                                        (8 -
                                                         shared_sizze_326541 %
                                                         8) % 8) +
                                                 (shared_sizze_326543 + (8 -
                                                                         shared_sizze_326543 %
                                                                         8) %
                                                  8);
                                    unsigned int shared_offset_326548 = 0 +
                                                 (shared_sizze_326511 + (8 -
                                                                         shared_sizze_326511 %
                                                                         8) %
                                                  8) + (shared_sizze_326513 +
                                                        (8 -
                                                         shared_sizze_326513 %
                                                         8) % 8) +
                                                 (shared_sizze_326515 + (8 -
                                                                         shared_sizze_326515 %
                                                                         8) %
                                                  8) + (shared_sizze_326517 +
                                                        (8 -
                                                         shared_sizze_326517 %
                                                         8) % 8) +
                                                 (shared_sizze_326519 + (8 -
                                                                         shared_sizze_326519 %
                                                                         8) %
                                                  8) + (shared_sizze_326521 +
                                                        (8 -
                                                         shared_sizze_326521 %
                                                         8) % 8) +
                                                 (shared_sizze_326523 + (8 -
                                                                         shared_sizze_326523 %
                                                                         8) %
                                                  8) + (shared_sizze_326525 +
                                                        (8 -
                                                         shared_sizze_326525 %
                                                         8) % 8) +
                                                 (shared_sizze_326527 + (8 -
                                                                         shared_sizze_326527 %
                                                                         8) %
                                                  8) + (shared_sizze_326529 +
                                                        (8 -
                                                         shared_sizze_326529 %
                                                         8) % 8) +
                                                 (shared_sizze_326531 + (8 -
                                                                         shared_sizze_326531 %
                                                                         8) %
                                                  8) + (shared_sizze_326533 +
                                                        (8 -
                                                         shared_sizze_326533 %
                                                         8) % 8) +
                                                 (shared_sizze_326535 + (8 -
                                                                         shared_sizze_326535 %
                                                                         8) %
                                                  8) + (shared_sizze_326537 +
                                                        (8 -
                                                         shared_sizze_326537 %
                                                         8) % 8) +
                                                 (shared_sizze_326539 + (8 -
                                                                         shared_sizze_326539 %
                                                                         8) %
                                                  8) + (shared_sizze_326541 +
                                                        (8 -
                                                         shared_sizze_326541 %
                                                         8) % 8) +
                                                 (shared_sizze_326543 + (8 -
                                                                         shared_sizze_326543 %
                                                                         8) %
                                                  8) + (shared_sizze_326545 +
                                                        (8 -
                                                         shared_sizze_326545 %
                                                         8) % 8);
                                    
                                    if ((((((1 && binop_x_318547 != 0) && 1 !=
                                            0) && 1 != 0) &&
                                          computed_group_sizze_307713 != 0) &&
                                         1 != 0) && 1 != 0) {
                                        int perm[3] = {0, 1, 2};
                                        
                                        if (1 >= 1 << 16) {
                                            perm[1] = perm[0];
                                            perm[0] = 1;
                                        }
                                        if (1 >= 1 << 16) {
                                            perm[2] = perm[0];
                                            perm[0] = 2;
                                        }
                                        
                                        size_t grid[3];
                                        
                                        grid[perm[0]] = binop_x_318547;
                                        grid[perm[1]] = 1;
                                        grid[perm[2]] = 1;
                                        
                                        void *kernel_args_326508[] =
                                             {&ctx->global_failure,
                                              &shared_offset_326512,
                                              &shared_offset_326514,
                                              &shared_offset_326516,
                                              &shared_offset_326518,
                                              &shared_offset_326520,
                                              &shared_offset_326522,
                                              &shared_offset_326524,
                                              &shared_offset_326526,
                                              &shared_offset_326528,
                                              &shared_offset_326530,
                                              &shared_offset_326532,
                                              &shared_offset_326534,
                                              &shared_offset_326536,
                                              &shared_offset_326538,
                                              &shared_offset_326540,
                                              &shared_offset_326542,
                                              &shared_offset_326544,
                                              &shared_offset_326546,
                                              &shared_offset_326548,
                                              &n_p_292677, &q_s_292678,
                                              &jump_s_292684,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &pad_css_len_292821,
                                              &s_n_m_292825,
                                              &computed_group_sizze_307713,
                                              &kernel_arg_326549,
                                              &kernel_arg_326550,
                                              &kernel_arg_326551,
                                              &kernel_arg_326552,
                                              &kernel_arg_326553,
                                              &kernel_arg_326554,
                                              &kernel_arg_326555,
                                              &kernel_arg_326556};
                                        int64_t time_start_326509 = 0,
                                                time_end_326510 = 0;
                                        
                                        if (ctx->debugging) {
                                            fprintf(ctx->log,
                                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                    "main.segmap_intragroup_307881",
                                                    (long) binop_x_318547,
                                                    (long) 1, (long) 1,
                                                    (long) computed_group_sizze_307713,
                                                    (long) 1, (long) 1,
                                                    (int) (0 +
                                                           (shared_sizze_326511 +
                                                            (8 -
                                                             shared_sizze_326511 %
                                                             8) % 8) +
                                                           (shared_sizze_326513 +
                                                            (8 -
                                                             shared_sizze_326513 %
                                                             8) % 8) +
                                                           (shared_sizze_326515 +
                                                            (8 -
                                                             shared_sizze_326515 %
                                                             8) % 8) +
                                                           (shared_sizze_326517 +
                                                            (8 -
                                                             shared_sizze_326517 %
                                                             8) % 8) +
                                                           (shared_sizze_326519 +
                                                            (8 -
                                                             shared_sizze_326519 %
                                                             8) % 8) +
                                                           (shared_sizze_326521 +
                                                            (8 -
                                                             shared_sizze_326521 %
                                                             8) % 8) +
                                                           (shared_sizze_326523 +
                                                            (8 -
                                                             shared_sizze_326523 %
                                                             8) % 8) +
                                                           (shared_sizze_326525 +
                                                            (8 -
                                                             shared_sizze_326525 %
                                                             8) % 8) +
                                                           (shared_sizze_326527 +
                                                            (8 -
                                                             shared_sizze_326527 %
                                                             8) % 8) +
                                                           (shared_sizze_326529 +
                                                            (8 -
                                                             shared_sizze_326529 %
                                                             8) % 8) +
                                                           (shared_sizze_326531 +
                                                            (8 -
                                                             shared_sizze_326531 %
                                                             8) % 8) +
                                                           (shared_sizze_326533 +
                                                            (8 -
                                                             shared_sizze_326533 %
                                                             8) % 8) +
                                                           (shared_sizze_326535 +
                                                            (8 -
                                                             shared_sizze_326535 %
                                                             8) % 8) +
                                                           (shared_sizze_326537 +
                                                            (8 -
                                                             shared_sizze_326537 %
                                                             8) % 8) +
                                                           (shared_sizze_326539 +
                                                            (8 -
                                                             shared_sizze_326539 %
                                                             8) % 8) +
                                                           (shared_sizze_326541 +
                                                            (8 -
                                                             shared_sizze_326541 %
                                                             8) % 8) +
                                                           (shared_sizze_326543 +
                                                            (8 -
                                                             shared_sizze_326543 %
                                                             8) % 8) +
                                                           (shared_sizze_326545 +
                                                            (8 -
                                                             shared_sizze_326545 %
                                                             8) % 8) +
                                                           (shared_sizze_326547 +
                                                            (8 -
                                                             shared_sizze_326547 %
                                                             8) % 8)));
                                            time_start_326509 = get_wall_time();
                                        }
                                        
                                        cudaEvent_t *pevents = NULL;
                                        
                                        if (ctx->profiling &&
                                            !ctx->profiling_paused) {
                                            pevents =
                                                cuda_get_events(&ctx->cuda,
                                                                &ctx->mainzisegmap_intragroup_307881_runs,
                                                                &ctx->mainzisegmap_intragroup_307881_total_runtime);
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                               0));
                                        }
                                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_307881,
                                                                              grid[0],
                                                                              grid[1],
                                                                              grid[2],
                                                                              computed_group_sizze_307713,
                                                                              1,
                                                                              1,
                                                                              0 +
                                                                              (shared_sizze_326511 +
                                                                               (8 -
                                                                                shared_sizze_326511 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326513 +
                                                                               (8 -
                                                                                shared_sizze_326513 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326515 +
                                                                               (8 -
                                                                                shared_sizze_326515 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326517 +
                                                                               (8 -
                                                                                shared_sizze_326517 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326519 +
                                                                               (8 -
                                                                                shared_sizze_326519 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326521 +
                                                                               (8 -
                                                                                shared_sizze_326521 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326523 +
                                                                               (8 -
                                                                                shared_sizze_326523 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326525 +
                                                                               (8 -
                                                                                shared_sizze_326525 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326527 +
                                                                               (8 -
                                                                                shared_sizze_326527 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326529 +
                                                                               (8 -
                                                                                shared_sizze_326529 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326531 +
                                                                               (8 -
                                                                                shared_sizze_326531 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326533 +
                                                                               (8 -
                                                                                shared_sizze_326533 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326535 +
                                                                               (8 -
                                                                                shared_sizze_326535 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326537 +
                                                                               (8 -
                                                                                shared_sizze_326537 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326539 +
                                                                               (8 -
                                                                                shared_sizze_326539 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326541 +
                                                                               (8 -
                                                                                shared_sizze_326541 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326543 +
                                                                               (8 -
                                                                                shared_sizze_326543 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326545 +
                                                                               (8 -
                                                                                shared_sizze_326545 %
                                                                                8) %
                                                                               8) +
                                                                              (shared_sizze_326547 +
                                                                               (8 -
                                                                                shared_sizze_326547 %
                                                                                8) %
                                                                               8),
                                                                              NULL,
                                                                              kernel_args_326508,
                                                                              NULL));
                                        if (pevents != NULL)
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                               0));
                                        if (ctx->debugging) {
                                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                            time_end_326510 = get_wall_time();
                                            fprintf(ctx->log,
                                                    "Kernel %s runtime: %ldus\n",
                                                    "main.segmap_intragroup_307881",
                                                    time_end_326510 -
                                                    time_start_326509);
                                        }
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "");
                                    if (memblock_set_device(ctx,
                                                            &ext_mem_319469,
                                                            &mem_319384,
                                                            "mem_319384") != 0)
                                        return 1;
                                    if (memblock_set_device(ctx,
                                                            &ext_mem_319468,
                                                            &mem_319389,
                                                            "mem_319389") != 0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319389,
                                                              "mem_319389") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319384,
                                                              "mem_319384") !=
                                        0)
                                        return 1;
                                } else {
                                    int64_t segmap_usable_groups_308075 =
                                            sdiv_up64(nest_sizze_299600,
                                                      segmap_group_sizze_308074);
                                    struct memblock_device mem_319395;
                                    
                                    mem_319395.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319395,
                                                              bytes_318642,
                                                              "mem_319395")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319399;
                                    
                                    mem_319399.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319399,
                                                              bytes_319398,
                                                              "mem_319399")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "\n# SegMap");
                                    
                                    CUdeviceptr kernel_arg_326560 =
                                                mem_319395.mem;
                                    CUdeviceptr kernel_arg_326561 =
                                                mem_319399.mem;
                                    
                                    if ((((((1 && segmap_usable_groups_308075 !=
                                             0) && 1 != 0) && 1 != 0) &&
                                          segmap_group_sizze_308074 != 0) &&
                                         1 != 0) && 1 != 0) {
                                        int perm[3] = {0, 1, 2};
                                        
                                        if (1 >= 1 << 16) {
                                            perm[1] = perm[0];
                                            perm[0] = 1;
                                        }
                                        if (1 >= 1 << 16) {
                                            perm[2] = perm[0];
                                            perm[0] = 2;
                                        }
                                        
                                        size_t grid[3];
                                        
                                        grid[perm[0]] =
                                            segmap_usable_groups_308075;
                                        grid[perm[1]] = 1;
                                        grid[perm[2]] = 1;
                                        
                                        void *kernel_args_326557[] =
                                             {&ctx->global_failure, &n_p_292677,
                                              &jump_s_292684,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &pad_css_len_292821,
                                              &s_n_m_292825, &kernel_arg_326560,
                                              &kernel_arg_326561};
                                        int64_t time_start_326558 = 0,
                                                time_end_326559 = 0;
                                        
                                        if (ctx->debugging) {
                                            fprintf(ctx->log,
                                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                    "main.segmap_308081",
                                                    (long) segmap_usable_groups_308075,
                                                    (long) 1, (long) 1,
                                                    (long) segmap_group_sizze_308074,
                                                    (long) 1, (long) 1,
                                                    (int) 0);
                                            time_start_326558 = get_wall_time();
                                        }
                                        
                                        cudaEvent_t *pevents = NULL;
                                        
                                        if (ctx->profiling &&
                                            !ctx->profiling_paused) {
                                            pevents =
                                                cuda_get_events(&ctx->cuda,
                                                                &ctx->mainzisegmap_308081_runs,
                                                                &ctx->mainzisegmap_308081_total_runtime);
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                               0));
                                        }
                                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_308081,
                                                                              grid[0],
                                                                              grid[1],
                                                                              grid[2],
                                                                              segmap_group_sizze_308074,
                                                                              1,
                                                                              1,
                                                                              0,
                                                                              NULL,
                                                                              kernel_args_326557,
                                                                              NULL));
                                        if (pevents != NULL)
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                               0));
                                        if (ctx->debugging) {
                                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                            time_end_326559 = get_wall_time();
                                            fprintf(ctx->log,
                                                    "Kernel %s runtime: %ldus\n",
                                                    "main.segmap_308081",
                                                    time_end_326559 -
                                                    time_start_326558);
                                        }
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "");
                                    if (memblock_unref_device(ctx, &mem_319399,
                                                              "mem_319399") !=
                                        0)
                                        return 1;
                                    
                                    struct memblock_device mem_319405;
                                    
                                    mem_319405.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319405,
                                                              bytes_318642,
                                                              "mem_319405")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319410;
                                    
                                    mem_319410.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319410,
                                                              bytes_318642,
                                                              "mem_319410")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319415;
                                    
                                    mem_319415.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319415,
                                                              bytes_318642,
                                                              "mem_319415")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319420;
                                    
                                    mem_319420.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319420,
                                                              bytes_318642,
                                                              "mem_319420")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319425;
                                    
                                    mem_319425.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319425,
                                                              bytes_318642,
                                                              "mem_319425")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    if (slt64(q_s_292678 * (int64_t) 2,
                                              segred_group_sizze_308097)) {
                                        int64_t segment_sizze_nonzzero_322547 =
                                                smax64((int64_t) 1, q_s_292678);
                                        int64_t num_threads_322548 =
                                                num_groups_308098 *
                                                segred_group_sizze_308097;
                                        
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n",
                                                    "\n# SegRed-small");
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "num_segments",
                                                    (long long) (partition_sizze_292766 *
                                                                 n_p_292677 *
                                                                 s_n_m_292825),
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "segment_size",
                                                    (long long) q_s_292678,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "segments_per_group",
                                                    (long long) squot64(segred_group_sizze_308097,
                                                                        segment_sizze_nonzzero_322547),
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "required_groups",
                                                    (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                                       n_p_292677 *
                                                                                       s_n_m_292825,
                                                                                       squot64(segred_group_sizze_308097,
                                                                                               segment_sizze_nonzzero_322547))),
                                                    '\n');
                                        
                                        unsigned int shared_sizze_326565 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308097;
                                        unsigned int shared_sizze_326567 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308097;
                                        unsigned int shared_sizze_326569 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308097;
                                        unsigned int shared_sizze_326571 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308097;
                                        unsigned int shared_sizze_326573 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308097;
                                        CUdeviceptr kernel_arg_326575 =
                                                    ext_mem_318609.mem;
                                        CUdeviceptr kernel_arg_326576 =
                                                    ext_mem_318610.mem;
                                        CUdeviceptr kernel_arg_326577 =
                                                    ext_mem_318707.mem;
                                        CUdeviceptr kernel_arg_326578 =
                                                    ext_mem_318708.mem;
                                        CUdeviceptr kernel_arg_326579 =
                                                    mem_318876.mem;
                                        CUdeviceptr kernel_arg_326580 =
                                                    mem_319395.mem;
                                        CUdeviceptr kernel_arg_326581 =
                                                    mem_319405.mem;
                                        CUdeviceptr kernel_arg_326582 =
                                                    mem_319410.mem;
                                        CUdeviceptr kernel_arg_326583 =
                                                    mem_319415.mem;
                                        CUdeviceptr kernel_arg_326584 =
                                                    mem_319420.mem;
                                        CUdeviceptr kernel_arg_326585 =
                                                    mem_319425.mem;
                                        unsigned int shared_offset_326566 = 0;
                                        unsigned int shared_offset_326568 = 0 +
                                                     (shared_sizze_326565 + (8 -
                                                                             shared_sizze_326565 %
                                                                             8) %
                                                      8);
                                        unsigned int shared_offset_326570 = 0 +
                                                     (shared_sizze_326565 + (8 -
                                                                             shared_sizze_326565 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326567 + (8 -
                                                                             shared_sizze_326567 %
                                                                             8) %
                                                      8);
                                        unsigned int shared_offset_326572 = 0 +
                                                     (shared_sizze_326565 + (8 -
                                                                             shared_sizze_326565 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326567 + (8 -
                                                                             shared_sizze_326567 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326569 + (8 -
                                                                             shared_sizze_326569 %
                                                                             8) %
                                                      8);
                                        unsigned int shared_offset_326574 = 0 +
                                                     (shared_sizze_326565 + (8 -
                                                                             shared_sizze_326565 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326567 + (8 -
                                                                             shared_sizze_326567 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326569 + (8 -
                                                                             shared_sizze_326569 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326571 + (8 -
                                                                             shared_sizze_326571 %
                                                                             8) %
                                                      8);
                                        
                                        if ((((((1 && num_groups_308098 != 0) &&
                                                1 != 0) && 1 != 0) &&
                                              segred_group_sizze_308097 != 0) &&
                                             1 != 0) && 1 != 0) {
                                            int perm[3] = {0, 1, 2};
                                            
                                            if (1 >= 1 << 16) {
                                                perm[1] = perm[0];
                                                perm[0] = 1;
                                            }
                                            if (1 >= 1 << 16) {
                                                perm[2] = perm[0];
                                                perm[0] = 2;
                                            }
                                            
                                            size_t grid[3];
                                            
                                            grid[perm[0]] = num_groups_308098;
                                            grid[perm[1]] = 1;
                                            grid[perm[2]] = 1;
                                            
                                            void *kernel_args_326562[] =
                                                 {&ctx->global_failure,
                                                  &shared_offset_326566,
                                                  &shared_offset_326568,
                                                  &shared_offset_326570,
                                                  &shared_offset_326572,
                                                  &shared_offset_326574,
                                                  &n_p_292677, &q_s_292678,
                                                  &partition_sizze_292766,
                                                  &defunc_0_f_res_292820,
                                                  &s_n_m_292825,
                                                  &num_groups_308098,
                                                  &segment_sizze_nonzzero_322547,
                                                  &kernel_arg_326575,
                                                  &kernel_arg_326576,
                                                  &kernel_arg_326577,
                                                  &kernel_arg_326578,
                                                  &kernel_arg_326579,
                                                  &kernel_arg_326580,
                                                  &kernel_arg_326581,
                                                  &kernel_arg_326582,
                                                  &kernel_arg_326583,
                                                  &kernel_arg_326584,
                                                  &kernel_arg_326585};
                                            int64_t time_start_326563 = 0,
                                                    time_end_326564 = 0;
                                            
                                            if (ctx->debugging) {
                                                fprintf(ctx->log,
                                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                        "main.segred_small_308109",
                                                        (long) num_groups_308098,
                                                        (long) 1, (long) 1,
                                                        (long) segred_group_sizze_308097,
                                                        (long) 1, (long) 1,
                                                        (int) (0 +
                                                               (shared_sizze_326565 +
                                                                (8 -
                                                                 shared_sizze_326565 %
                                                                 8) % 8) +
                                                               (shared_sizze_326567 +
                                                                (8 -
                                                                 shared_sizze_326567 %
                                                                 8) % 8) +
                                                               (shared_sizze_326569 +
                                                                (8 -
                                                                 shared_sizze_326569 %
                                                                 8) % 8) +
                                                               (shared_sizze_326571 +
                                                                (8 -
                                                                 shared_sizze_326571 %
                                                                 8) % 8) +
                                                               (shared_sizze_326573 +
                                                                (8 -
                                                                 shared_sizze_326573 %
                                                                 8) % 8)));
                                                time_start_326563 =
                                                    get_wall_time();
                                            }
                                            
                                            cudaEvent_t *pevents = NULL;
                                            
                                            if (ctx->profiling &&
                                                !ctx->profiling_paused) {
                                                pevents =
                                                    cuda_get_events(&ctx->cuda,
                                                                    &ctx->mainzisegred_small_308109_runs,
                                                                    &ctx->mainzisegred_small_308109_total_runtime);
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                                   0));
                                            }
                                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_308109,
                                                                                  grid[0],
                                                                                  grid[1],
                                                                                  grid[2],
                                                                                  segred_group_sizze_308097,
                                                                                  1,
                                                                                  1,
                                                                                  0 +
                                                                                  (shared_sizze_326565 +
                                                                                   (8 -
                                                                                    shared_sizze_326565 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326567 +
                                                                                   (8 -
                                                                                    shared_sizze_326567 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326569 +
                                                                                   (8 -
                                                                                    shared_sizze_326569 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326571 +
                                                                                   (8 -
                                                                                    shared_sizze_326571 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326573 +
                                                                                   (8 -
                                                                                    shared_sizze_326573 %
                                                                                    8) %
                                                                                   8),
                                                                                  NULL,
                                                                                  kernel_args_326562,
                                                                                  NULL));
                                            if (pevents != NULL)
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                                   0));
                                            if (ctx->debugging) {
                                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                                time_end_326564 =
                                                    get_wall_time();
                                                fprintf(ctx->log,
                                                        "Kernel %s runtime: %ldus\n",
                                                        "main.segred_small_308109",
                                                        time_end_326564 -
                                                        time_start_326563);
                                            }
                                        }
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n", "");
                                    } else {
                                        int64_t groups_per_segment_322602 =
                                                sdiv_up64(num_groups_308098,
                                                          smax64((int64_t) 1,
                                                                 partition_sizze_292766 *
                                                                 n_p_292677 *
                                                                 s_n_m_292825));
                                        int64_t elements_per_thread_322603 =
                                                sdiv_up64(q_s_292678,
                                                          segred_group_sizze_308097 *
                                                          groups_per_segment_322602);
                                        int64_t virt_num_groups_322604 =
                                                groups_per_segment_322602 *
                                                (partition_sizze_292766 *
                                                 n_p_292677 * s_n_m_292825);
                                        int64_t num_threads_322605 =
                                                num_groups_308098 *
                                                segred_group_sizze_308097;
                                        int64_t threads_per_segment_322606 =
                                                groups_per_segment_322602 *
                                                segred_group_sizze_308097;
                                        
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n",
                                                    "\n# SegRed-large");
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "num_segments",
                                                    (long long) (partition_sizze_292766 *
                                                                 n_p_292677 *
                                                                 s_n_m_292825),
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "segment_size",
                                                    (long long) q_s_292678,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "virt_num_groups",
                                                    (long long) virt_num_groups_322604,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "num_groups",
                                                    (long long) num_groups_308098,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "group_size",
                                                    (long long) segred_group_sizze_308097,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "elems_per_thread",
                                                    (long long) elements_per_thread_322603,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "groups_per_segment",
                                                    (long long) groups_per_segment_322602,
                                                    '\n');
                                        
                                        struct memblock_device
                                        segred_tmp_mem_322607;
                                        
                                        segred_tmp_mem_322607.references = NULL;
                                        if (memblock_alloc_device(ctx,
                                                                  &segred_tmp_mem_322607,
                                                                  (int64_t) 8 *
                                                                  virt_num_groups_322604,
                                                                  "segred_tmp_mem_322607")) {
                                            err = 1;
                                            goto cleanup;
                                        }
                                        
                                        struct memblock_device
                                        segred_tmp_mem_322609;
                                        
                                        segred_tmp_mem_322609.references = NULL;
                                        if (memblock_alloc_device(ctx,
                                                                  &segred_tmp_mem_322609,
                                                                  (int64_t) 8 *
                                                                  virt_num_groups_322604,
                                                                  "segred_tmp_mem_322609")) {
                                            err = 1;
                                            goto cleanup;
                                        }
                                        
                                        struct memblock_device
                                        segred_tmp_mem_322611;
                                        
                                        segred_tmp_mem_322611.references = NULL;
                                        if (memblock_alloc_device(ctx,
                                                                  &segred_tmp_mem_322611,
                                                                  (int64_t) 8 *
                                                                  virt_num_groups_322604,
                                                                  "segred_tmp_mem_322611")) {
                                            err = 1;
                                            goto cleanup;
                                        }
                                        
                                        struct memblock_device
                                        segred_tmp_mem_322613;
                                        
                                        segred_tmp_mem_322613.references = NULL;
                                        if (memblock_alloc_device(ctx,
                                                                  &segred_tmp_mem_322613,
                                                                  (int64_t) 8 *
                                                                  virt_num_groups_322604,
                                                                  "segred_tmp_mem_322613")) {
                                            err = 1;
                                            goto cleanup;
                                        }
                                        
                                        struct memblock_device
                                        segred_tmp_mem_322615;
                                        
                                        segred_tmp_mem_322615.references = NULL;
                                        if (memblock_alloc_device(ctx,
                                                                  &segred_tmp_mem_322615,
                                                                  (int64_t) 8 *
                                                                  virt_num_groups_322604,
                                                                  "segred_tmp_mem_322615")) {
                                            err = 1;
                                            goto cleanup;
                                        }
                                        
                                        struct memblock_device
                                        mainzicounter_mem_322617 =
                                        ctx->mainzicounter_mem_322617;
                                        unsigned int shared_sizze_326590 = 1;
                                        unsigned int shared_sizze_326592 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308097;
                                        unsigned int shared_sizze_326594 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308097;
                                        unsigned int shared_sizze_326596 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308097;
                                        unsigned int shared_sizze_326598 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308097;
                                        unsigned int shared_sizze_326600 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308097;
                                        CUdeviceptr kernel_arg_326602 =
                                                    ext_mem_318609.mem;
                                        CUdeviceptr kernel_arg_326603 =
                                                    ext_mem_318610.mem;
                                        CUdeviceptr kernel_arg_326604 =
                                                    ext_mem_318707.mem;
                                        CUdeviceptr kernel_arg_326605 =
                                                    ext_mem_318708.mem;
                                        CUdeviceptr kernel_arg_326606 =
                                                    mem_318876.mem;
                                        CUdeviceptr kernel_arg_326607 =
                                                    mem_319395.mem;
                                        CUdeviceptr kernel_arg_326608 =
                                                    mem_319405.mem;
                                        CUdeviceptr kernel_arg_326609 =
                                                    mem_319410.mem;
                                        CUdeviceptr kernel_arg_326610 =
                                                    mem_319415.mem;
                                        CUdeviceptr kernel_arg_326611 =
                                                    mem_319420.mem;
                                        CUdeviceptr kernel_arg_326612 =
                                                    mem_319425.mem;
                                        CUdeviceptr kernel_arg_326613 =
                                                    segred_tmp_mem_322607.mem;
                                        CUdeviceptr kernel_arg_326614 =
                                                    segred_tmp_mem_322609.mem;
                                        CUdeviceptr kernel_arg_326615 =
                                                    segred_tmp_mem_322611.mem;
                                        CUdeviceptr kernel_arg_326616 =
                                                    segred_tmp_mem_322613.mem;
                                        CUdeviceptr kernel_arg_326617 =
                                                    segred_tmp_mem_322615.mem;
                                        CUdeviceptr kernel_arg_326618 =
                                                    mainzicounter_mem_322617.mem;
                                        unsigned int shared_offset_326591 = 0;
                                        unsigned int shared_offset_326593 = 0 +
                                                     (shared_sizze_326590 + (8 -
                                                                             shared_sizze_326590 %
                                                                             8) %
                                                      8);
                                        unsigned int shared_offset_326595 = 0 +
                                                     (shared_sizze_326590 + (8 -
                                                                             shared_sizze_326590 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326592 + (8 -
                                                                             shared_sizze_326592 %
                                                                             8) %
                                                      8);
                                        unsigned int shared_offset_326597 = 0 +
                                                     (shared_sizze_326590 + (8 -
                                                                             shared_sizze_326590 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326592 + (8 -
                                                                             shared_sizze_326592 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326594 + (8 -
                                                                             shared_sizze_326594 %
                                                                             8) %
                                                      8);
                                        unsigned int shared_offset_326599 = 0 +
                                                     (shared_sizze_326590 + (8 -
                                                                             shared_sizze_326590 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326592 + (8 -
                                                                             shared_sizze_326592 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326594 + (8 -
                                                                             shared_sizze_326594 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326596 + (8 -
                                                                             shared_sizze_326596 %
                                                                             8) %
                                                      8);
                                        unsigned int shared_offset_326601 = 0 +
                                                     (shared_sizze_326590 + (8 -
                                                                             shared_sizze_326590 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326592 + (8 -
                                                                             shared_sizze_326592 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326594 + (8 -
                                                                             shared_sizze_326594 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326596 + (8 -
                                                                             shared_sizze_326596 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326598 + (8 -
                                                                             shared_sizze_326598 %
                                                                             8) %
                                                      8);
                                        
                                        if ((((((1 && num_groups_308098 != 0) &&
                                                1 != 0) && 1 != 0) &&
                                              segred_group_sizze_308097 != 0) &&
                                             1 != 0) && 1 != 0) {
                                            int perm[3] = {0, 1, 2};
                                            
                                            if (1 >= 1 << 16) {
                                                perm[1] = perm[0];
                                                perm[0] = 1;
                                            }
                                            if (1 >= 1 << 16) {
                                                perm[2] = perm[0];
                                                perm[0] = 2;
                                            }
                                            
                                            size_t grid[3];
                                            
                                            grid[perm[0]] = num_groups_308098;
                                            grid[perm[1]] = 1;
                                            grid[perm[2]] = 1;
                                            
                                            void *kernel_args_326587[] =
                                                 {&ctx->global_failure,
                                                  &shared_offset_326591,
                                                  &shared_offset_326593,
                                                  &shared_offset_326595,
                                                  &shared_offset_326597,
                                                  &shared_offset_326599,
                                                  &shared_offset_326601,
                                                  &n_p_292677, &q_s_292678,
                                                  &partition_sizze_292766,
                                                  &defunc_0_f_res_292820,
                                                  &s_n_m_292825,
                                                  &num_groups_308098,
                                                  &groups_per_segment_322602,
                                                  &elements_per_thread_322603,
                                                  &virt_num_groups_322604,
                                                  &threads_per_segment_322606,
                                                  &kernel_arg_326602,
                                                  &kernel_arg_326603,
                                                  &kernel_arg_326604,
                                                  &kernel_arg_326605,
                                                  &kernel_arg_326606,
                                                  &kernel_arg_326607,
                                                  &kernel_arg_326608,
                                                  &kernel_arg_326609,
                                                  &kernel_arg_326610,
                                                  &kernel_arg_326611,
                                                  &kernel_arg_326612,
                                                  &kernel_arg_326613,
                                                  &kernel_arg_326614,
                                                  &kernel_arg_326615,
                                                  &kernel_arg_326616,
                                                  &kernel_arg_326617,
                                                  &kernel_arg_326618};
                                            int64_t time_start_326588 = 0,
                                                    time_end_326589 = 0;
                                            
                                            if (ctx->debugging) {
                                                fprintf(ctx->log,
                                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                        "main.segred_large_308109",
                                                        (long) num_groups_308098,
                                                        (long) 1, (long) 1,
                                                        (long) segred_group_sizze_308097,
                                                        (long) 1, (long) 1,
                                                        (int) (0 +
                                                               (shared_sizze_326590 +
                                                                (8 -
                                                                 shared_sizze_326590 %
                                                                 8) % 8) +
                                                               (shared_sizze_326592 +
                                                                (8 -
                                                                 shared_sizze_326592 %
                                                                 8) % 8) +
                                                               (shared_sizze_326594 +
                                                                (8 -
                                                                 shared_sizze_326594 %
                                                                 8) % 8) +
                                                               (shared_sizze_326596 +
                                                                (8 -
                                                                 shared_sizze_326596 %
                                                                 8) % 8) +
                                                               (shared_sizze_326598 +
                                                                (8 -
                                                                 shared_sizze_326598 %
                                                                 8) % 8) +
                                                               (shared_sizze_326600 +
                                                                (8 -
                                                                 shared_sizze_326600 %
                                                                 8) % 8)));
                                                time_start_326588 =
                                                    get_wall_time();
                                            }
                                            
                                            cudaEvent_t *pevents = NULL;
                                            
                                            if (ctx->profiling &&
                                                !ctx->profiling_paused) {
                                                pevents =
                                                    cuda_get_events(&ctx->cuda,
                                                                    &ctx->mainzisegred_large_308109_runs,
                                                                    &ctx->mainzisegred_large_308109_total_runtime);
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                                   0));
                                            }
                                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_308109,
                                                                                  grid[0],
                                                                                  grid[1],
                                                                                  grid[2],
                                                                                  segred_group_sizze_308097,
                                                                                  1,
                                                                                  1,
                                                                                  0 +
                                                                                  (shared_sizze_326590 +
                                                                                   (8 -
                                                                                    shared_sizze_326590 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326592 +
                                                                                   (8 -
                                                                                    shared_sizze_326592 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326594 +
                                                                                   (8 -
                                                                                    shared_sizze_326594 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326596 +
                                                                                   (8 -
                                                                                    shared_sizze_326596 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326598 +
                                                                                   (8 -
                                                                                    shared_sizze_326598 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326600 +
                                                                                   (8 -
                                                                                    shared_sizze_326600 %
                                                                                    8) %
                                                                                   8),
                                                                                  NULL,
                                                                                  kernel_args_326587,
                                                                                  NULL));
                                            if (pevents != NULL)
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                                   0));
                                            if (ctx->debugging) {
                                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                                time_end_326589 =
                                                    get_wall_time();
                                                fprintf(ctx->log,
                                                        "Kernel %s runtime: %ldus\n",
                                                        "main.segred_large_308109",
                                                        time_end_326589 -
                                                        time_start_326588);
                                            }
                                        }
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n", "");
                                        if (memblock_unref_device(ctx,
                                                                  &segred_tmp_mem_322615,
                                                                  "segred_tmp_mem_322615") !=
                                            0)
                                            return 1;
                                        if (memblock_unref_device(ctx,
                                                                  &segred_tmp_mem_322613,
                                                                  "segred_tmp_mem_322613") !=
                                            0)
                                            return 1;
                                        if (memblock_unref_device(ctx,
                                                                  &segred_tmp_mem_322611,
                                                                  "segred_tmp_mem_322611") !=
                                            0)
                                            return 1;
                                        if (memblock_unref_device(ctx,
                                                                  &segred_tmp_mem_322609,
                                                                  "segred_tmp_mem_322609") !=
                                            0)
                                            return 1;
                                        if (memblock_unref_device(ctx,
                                                                  &segred_tmp_mem_322607,
                                                                  "segred_tmp_mem_322607") !=
                                            0)
                                            return 1;
                                    }
                                    if (memblock_unref_device(ctx, &mem_319395,
                                                              "mem_319395") !=
                                        0)
                                        return 1;
                                    
                                    int64_t segmap_usable_groups_308167 =
                                            sdiv_up64(nest_sizze_299600,
                                                      segmap_group_sizze_308166);
                                    struct memblock_device mem_319431;
                                    
                                    mem_319431.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319431,
                                                              bytes_318642,
                                                              "mem_319431")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319436;
                                    
                                    mem_319436.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319436,
                                                              bytes_318642,
                                                              "mem_319436")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319441;
                                    
                                    mem_319441.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319441,
                                                              bytes_318642,
                                                              "mem_319441")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319446;
                                    
                                    mem_319446.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319446,
                                                              bytes_318642,
                                                              "mem_319446")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319451;
                                    
                                    mem_319451.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319451,
                                                              bytes_318642,
                                                              "mem_319451")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319456;
                                    
                                    mem_319456.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319456,
                                                              bytes_318642,
                                                              "mem_319456")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "\n# SegMap");
                                    
                                    CUdeviceptr kernel_arg_326622 =
                                                mem_319405.mem;
                                    CUdeviceptr kernel_arg_326623 =
                                                mem_319410.mem;
                                    CUdeviceptr kernel_arg_326624 =
                                                mem_319415.mem;
                                    CUdeviceptr kernel_arg_326625 =
                                                mem_319420.mem;
                                    CUdeviceptr kernel_arg_326626 =
                                                mem_319425.mem;
                                    CUdeviceptr kernel_arg_326627 =
                                                mem_319431.mem;
                                    CUdeviceptr kernel_arg_326628 =
                                                mem_319436.mem;
                                    CUdeviceptr kernel_arg_326629 =
                                                mem_319441.mem;
                                    CUdeviceptr kernel_arg_326630 =
                                                mem_319446.mem;
                                    CUdeviceptr kernel_arg_326631 =
                                                mem_319451.mem;
                                    CUdeviceptr kernel_arg_326632 =
                                                mem_319456.mem;
                                    
                                    if ((((((1 && segmap_usable_groups_308167 !=
                                             0) && 1 != 0) && 1 != 0) &&
                                          segmap_group_sizze_308166 != 0) &&
                                         1 != 0) && 1 != 0) {
                                        int perm[3] = {0, 1, 2};
                                        
                                        if (1 >= 1 << 16) {
                                            perm[1] = perm[0];
                                            perm[0] = 1;
                                        }
                                        if (1 >= 1 << 16) {
                                            perm[2] = perm[0];
                                            perm[0] = 2;
                                        }
                                        
                                        size_t grid[3];
                                        
                                        grid[perm[0]] =
                                            segmap_usable_groups_308167;
                                        grid[perm[1]] = 1;
                                        grid[perm[2]] = 1;
                                        
                                        void *kernel_args_326619[] =
                                             {&ctx->global_failure, &n_p_292677,
                                              &jump_s_292684,
                                              &partition_sizze_292766,
                                              &defunc_0_f_res_292820,
                                              &pad_css_len_292821,
                                              &s_n_m_292825, &kernel_arg_326622,
                                              &kernel_arg_326623,
                                              &kernel_arg_326624,
                                              &kernel_arg_326625,
                                              &kernel_arg_326626,
                                              &kernel_arg_326627,
                                              &kernel_arg_326628,
                                              &kernel_arg_326629,
                                              &kernel_arg_326630,
                                              &kernel_arg_326631,
                                              &kernel_arg_326632};
                                        int64_t time_start_326620 = 0,
                                                time_end_326621 = 0;
                                        
                                        if (ctx->debugging) {
                                            fprintf(ctx->log,
                                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                    "main.segmap_308177",
                                                    (long) segmap_usable_groups_308167,
                                                    (long) 1, (long) 1,
                                                    (long) segmap_group_sizze_308166,
                                                    (long) 1, (long) 1,
                                                    (int) 0);
                                            time_start_326620 = get_wall_time();
                                        }
                                        
                                        cudaEvent_t *pevents = NULL;
                                        
                                        if (ctx->profiling &&
                                            !ctx->profiling_paused) {
                                            pevents =
                                                cuda_get_events(&ctx->cuda,
                                                                &ctx->mainzisegmap_308177_runs,
                                                                &ctx->mainzisegmap_308177_total_runtime);
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                               0));
                                        }
                                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_308177,
                                                                              grid[0],
                                                                              grid[1],
                                                                              grid[2],
                                                                              segmap_group_sizze_308166,
                                                                              1,
                                                                              1,
                                                                              0,
                                                                              NULL,
                                                                              kernel_args_326619,
                                                                              NULL));
                                        if (pevents != NULL)
                                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                               0));
                                        if (ctx->debugging) {
                                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                            time_end_326621 = get_wall_time();
                                            fprintf(ctx->log,
                                                    "Kernel %s runtime: %ldus\n",
                                                    "main.segmap_308177",
                                                    time_end_326621 -
                                                    time_start_326620);
                                        }
                                    }
                                    if (ctx->debugging)
                                        fprintf(ctx->log, "%s\n", "");
                                    if (memblock_unref_device(ctx, &mem_319405,
                                                              "mem_319405") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319410,
                                                              "mem_319410") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319415,
                                                              "mem_319415") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319420,
                                                              "mem_319420") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319425,
                                                              "mem_319425") !=
                                        0)
                                        return 1;
                                    
                                    struct memblock_device mem_319462;
                                    
                                    mem_319462.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319462,
                                                              bytes_318642,
                                                              "mem_319462")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    struct memblock_device mem_319467;
                                    
                                    mem_319467.references = NULL;
                                    if (memblock_alloc_device(ctx, &mem_319467,
                                                              bytes_318642,
                                                              "mem_319467")) {
                                        err = 1;
                                        goto cleanup;
                                    }
                                    if (slt64(q_s_292678 * (int64_t) 2,
                                              segred_group_sizze_308228)) {
                                        int64_t segment_sizze_nonzzero_322691 =
                                                smax64((int64_t) 1, q_s_292678);
                                        int64_t num_threads_322692 =
                                                num_groups_308229 *
                                                segred_group_sizze_308228;
                                        
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n",
                                                    "\n# SegRed-small");
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "num_segments",
                                                    (long long) (partition_sizze_292766 *
                                                                 n_p_292677 *
                                                                 s_n_m_292825),
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "segment_size",
                                                    (long long) q_s_292678,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "segments_per_group",
                                                    (long long) squot64(segred_group_sizze_308228,
                                                                        segment_sizze_nonzzero_322691),
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "required_groups",
                                                    (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                                       n_p_292677 *
                                                                                       s_n_m_292825,
                                                                                       squot64(segred_group_sizze_308228,
                                                                                               segment_sizze_nonzzero_322691))),
                                                    '\n');
                                        
                                        unsigned int shared_sizze_326636 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308228;
                                        unsigned int shared_sizze_326638 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308228;
                                        CUdeviceptr kernel_arg_326640 =
                                                    ext_mem_318609.mem;
                                        CUdeviceptr kernel_arg_326641 =
                                                    ext_mem_318610.mem;
                                        CUdeviceptr kernel_arg_326642 =
                                                    ext_mem_318707.mem;
                                        CUdeviceptr kernel_arg_326643 =
                                                    ext_mem_318708.mem;
                                        CUdeviceptr kernel_arg_326644 =
                                                    mem_318871.mem;
                                        CUdeviceptr kernel_arg_326645 =
                                                    mem_318876.mem;
                                        CUdeviceptr kernel_arg_326646 =
                                                    mem_319431.mem;
                                        CUdeviceptr kernel_arg_326647 =
                                                    mem_319436.mem;
                                        CUdeviceptr kernel_arg_326648 =
                                                    mem_319441.mem;
                                        CUdeviceptr kernel_arg_326649 =
                                                    mem_319446.mem;
                                        CUdeviceptr kernel_arg_326650 =
                                                    mem_319451.mem;
                                        CUdeviceptr kernel_arg_326651 =
                                                    mem_319456.mem;
                                        CUdeviceptr kernel_arg_326652 =
                                                    mem_319462.mem;
                                        CUdeviceptr kernel_arg_326653 =
                                                    mem_319467.mem;
                                        unsigned int shared_offset_326637 = 0;
                                        unsigned int shared_offset_326639 = 0 +
                                                     (shared_sizze_326636 + (8 -
                                                                             shared_sizze_326636 %
                                                                             8) %
                                                      8);
                                        
                                        if ((((((1 && num_groups_308229 != 0) &&
                                                1 != 0) && 1 != 0) &&
                                              segred_group_sizze_308228 != 0) &&
                                             1 != 0) && 1 != 0) {
                                            int perm[3] = {0, 1, 2};
                                            
                                            if (1 >= 1 << 16) {
                                                perm[1] = perm[0];
                                                perm[0] = 1;
                                            }
                                            if (1 >= 1 << 16) {
                                                perm[2] = perm[0];
                                                perm[0] = 2;
                                            }
                                            
                                            size_t grid[3];
                                            
                                            grid[perm[0]] = num_groups_308229;
                                            grid[perm[1]] = 1;
                                            grid[perm[2]] = 1;
                                            
                                            void *kernel_args_326633[] =
                                                 {&ctx->global_failure,
                                                  &shared_offset_326637,
                                                  &shared_offset_326639,
                                                  &n_p_292677, &q_s_292678,
                                                  &partition_sizze_292766,
                                                  &defunc_0_f_res_292820,
                                                  &s_n_m_292825,
                                                  &num_groups_308229,
                                                  &segment_sizze_nonzzero_322691,
                                                  &kernel_arg_326640,
                                                  &kernel_arg_326641,
                                                  &kernel_arg_326642,
                                                  &kernel_arg_326643,
                                                  &kernel_arg_326644,
                                                  &kernel_arg_326645,
                                                  &kernel_arg_326646,
                                                  &kernel_arg_326647,
                                                  &kernel_arg_326648,
                                                  &kernel_arg_326649,
                                                  &kernel_arg_326650,
                                                  &kernel_arg_326651,
                                                  &kernel_arg_326652,
                                                  &kernel_arg_326653};
                                            int64_t time_start_326634 = 0,
                                                    time_end_326635 = 0;
                                            
                                            if (ctx->debugging) {
                                                fprintf(ctx->log,
                                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                        "main.segred_small_308237",
                                                        (long) num_groups_308229,
                                                        (long) 1, (long) 1,
                                                        (long) segred_group_sizze_308228,
                                                        (long) 1, (long) 1,
                                                        (int) (0 +
                                                               (shared_sizze_326636 +
                                                                (8 -
                                                                 shared_sizze_326636 %
                                                                 8) % 8) +
                                                               (shared_sizze_326638 +
                                                                (8 -
                                                                 shared_sizze_326638 %
                                                                 8) % 8)));
                                                time_start_326634 =
                                                    get_wall_time();
                                            }
                                            
                                            cudaEvent_t *pevents = NULL;
                                            
                                            if (ctx->profiling &&
                                                !ctx->profiling_paused) {
                                                pevents =
                                                    cuda_get_events(&ctx->cuda,
                                                                    &ctx->mainzisegred_small_308237_runs,
                                                                    &ctx->mainzisegred_small_308237_total_runtime);
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                                   0));
                                            }
                                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_308237,
                                                                                  grid[0],
                                                                                  grid[1],
                                                                                  grid[2],
                                                                                  segred_group_sizze_308228,
                                                                                  1,
                                                                                  1,
                                                                                  0 +
                                                                                  (shared_sizze_326636 +
                                                                                   (8 -
                                                                                    shared_sizze_326636 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326638 +
                                                                                   (8 -
                                                                                    shared_sizze_326638 %
                                                                                    8) %
                                                                                   8),
                                                                                  NULL,
                                                                                  kernel_args_326633,
                                                                                  NULL));
                                            if (pevents != NULL)
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                                   0));
                                            if (ctx->debugging) {
                                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                                time_end_326635 =
                                                    get_wall_time();
                                                fprintf(ctx->log,
                                                        "Kernel %s runtime: %ldus\n",
                                                        "main.segred_small_308237",
                                                        time_end_326635 -
                                                        time_start_326634);
                                            }
                                        }
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n", "");
                                    } else {
                                        int64_t groups_per_segment_322728 =
                                                sdiv_up64(num_groups_308229,
                                                          smax64((int64_t) 1,
                                                                 partition_sizze_292766 *
                                                                 n_p_292677 *
                                                                 s_n_m_292825));
                                        int64_t elements_per_thread_322729 =
                                                sdiv_up64(q_s_292678,
                                                          segred_group_sizze_308228 *
                                                          groups_per_segment_322728);
                                        int64_t virt_num_groups_322730 =
                                                groups_per_segment_322728 *
                                                (partition_sizze_292766 *
                                                 n_p_292677 * s_n_m_292825);
                                        int64_t num_threads_322731 =
                                                num_groups_308229 *
                                                segred_group_sizze_308228;
                                        int64_t threads_per_segment_322732 =
                                                groups_per_segment_322728 *
                                                segred_group_sizze_308228;
                                        
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n",
                                                    "\n# SegRed-large");
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "num_segments",
                                                    (long long) (partition_sizze_292766 *
                                                                 n_p_292677 *
                                                                 s_n_m_292825),
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "segment_size",
                                                    (long long) q_s_292678,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "virt_num_groups",
                                                    (long long) virt_num_groups_322730,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "num_groups",
                                                    (long long) num_groups_308229,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "group_size",
                                                    (long long) segred_group_sizze_308228,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "elems_per_thread",
                                                    (long long) elements_per_thread_322729,
                                                    '\n');
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s: %llu%c",
                                                    "groups_per_segment",
                                                    (long long) groups_per_segment_322728,
                                                    '\n');
                                        
                                        struct memblock_device
                                        segred_tmp_mem_322733;
                                        
                                        segred_tmp_mem_322733.references = NULL;
                                        if (memblock_alloc_device(ctx,
                                                                  &segred_tmp_mem_322733,
                                                                  (int64_t) 8 *
                                                                  virt_num_groups_322730,
                                                                  "segred_tmp_mem_322733")) {
                                            err = 1;
                                            goto cleanup;
                                        }
                                        
                                        struct memblock_device
                                        segred_tmp_mem_322735;
                                        
                                        segred_tmp_mem_322735.references = NULL;
                                        if (memblock_alloc_device(ctx,
                                                                  &segred_tmp_mem_322735,
                                                                  (int64_t) 8 *
                                                                  virt_num_groups_322730,
                                                                  "segred_tmp_mem_322735")) {
                                            err = 1;
                                            goto cleanup;
                                        }
                                        
                                        struct memblock_device
                                        mainzicounter_mem_322737 =
                                        ctx->mainzicounter_mem_322737;
                                        unsigned int shared_sizze_326658 = 1;
                                        unsigned int shared_sizze_326660 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308228;
                                        unsigned int shared_sizze_326662 =
                                                     (int64_t) 8 *
                                                     segred_group_sizze_308228;
                                        CUdeviceptr kernel_arg_326664 =
                                                    ext_mem_318609.mem;
                                        CUdeviceptr kernel_arg_326665 =
                                                    ext_mem_318610.mem;
                                        CUdeviceptr kernel_arg_326666 =
                                                    ext_mem_318707.mem;
                                        CUdeviceptr kernel_arg_326667 =
                                                    ext_mem_318708.mem;
                                        CUdeviceptr kernel_arg_326668 =
                                                    mem_318871.mem;
                                        CUdeviceptr kernel_arg_326669 =
                                                    mem_318876.mem;
                                        CUdeviceptr kernel_arg_326670 =
                                                    mem_319431.mem;
                                        CUdeviceptr kernel_arg_326671 =
                                                    mem_319436.mem;
                                        CUdeviceptr kernel_arg_326672 =
                                                    mem_319441.mem;
                                        CUdeviceptr kernel_arg_326673 =
                                                    mem_319446.mem;
                                        CUdeviceptr kernel_arg_326674 =
                                                    mem_319451.mem;
                                        CUdeviceptr kernel_arg_326675 =
                                                    mem_319456.mem;
                                        CUdeviceptr kernel_arg_326676 =
                                                    mem_319462.mem;
                                        CUdeviceptr kernel_arg_326677 =
                                                    mem_319467.mem;
                                        CUdeviceptr kernel_arg_326678 =
                                                    segred_tmp_mem_322733.mem;
                                        CUdeviceptr kernel_arg_326679 =
                                                    segred_tmp_mem_322735.mem;
                                        CUdeviceptr kernel_arg_326680 =
                                                    mainzicounter_mem_322737.mem;
                                        unsigned int shared_offset_326659 = 0;
                                        unsigned int shared_offset_326661 = 0 +
                                                     (shared_sizze_326658 + (8 -
                                                                             shared_sizze_326658 %
                                                                             8) %
                                                      8);
                                        unsigned int shared_offset_326663 = 0 +
                                                     (shared_sizze_326658 + (8 -
                                                                             shared_sizze_326658 %
                                                                             8) %
                                                      8) +
                                                     (shared_sizze_326660 + (8 -
                                                                             shared_sizze_326660 %
                                                                             8) %
                                                      8);
                                        
                                        if ((((((1 && num_groups_308229 != 0) &&
                                                1 != 0) && 1 != 0) &&
                                              segred_group_sizze_308228 != 0) &&
                                             1 != 0) && 1 != 0) {
                                            int perm[3] = {0, 1, 2};
                                            
                                            if (1 >= 1 << 16) {
                                                perm[1] = perm[0];
                                                perm[0] = 1;
                                            }
                                            if (1 >= 1 << 16) {
                                                perm[2] = perm[0];
                                                perm[0] = 2;
                                            }
                                            
                                            size_t grid[3];
                                            
                                            grid[perm[0]] = num_groups_308229;
                                            grid[perm[1]] = 1;
                                            grid[perm[2]] = 1;
                                            
                                            void *kernel_args_326655[] =
                                                 {&ctx->global_failure,
                                                  &shared_offset_326659,
                                                  &shared_offset_326661,
                                                  &shared_offset_326663,
                                                  &n_p_292677, &q_s_292678,
                                                  &partition_sizze_292766,
                                                  &defunc_0_f_res_292820,
                                                  &s_n_m_292825,
                                                  &num_groups_308229,
                                                  &groups_per_segment_322728,
                                                  &elements_per_thread_322729,
                                                  &virt_num_groups_322730,
                                                  &threads_per_segment_322732,
                                                  &kernel_arg_326664,
                                                  &kernel_arg_326665,
                                                  &kernel_arg_326666,
                                                  &kernel_arg_326667,
                                                  &kernel_arg_326668,
                                                  &kernel_arg_326669,
                                                  &kernel_arg_326670,
                                                  &kernel_arg_326671,
                                                  &kernel_arg_326672,
                                                  &kernel_arg_326673,
                                                  &kernel_arg_326674,
                                                  &kernel_arg_326675,
                                                  &kernel_arg_326676,
                                                  &kernel_arg_326677,
                                                  &kernel_arg_326678,
                                                  &kernel_arg_326679,
                                                  &kernel_arg_326680};
                                            int64_t time_start_326656 = 0,
                                                    time_end_326657 = 0;
                                            
                                            if (ctx->debugging) {
                                                fprintf(ctx->log,
                                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                        "main.segred_large_308237",
                                                        (long) num_groups_308229,
                                                        (long) 1, (long) 1,
                                                        (long) segred_group_sizze_308228,
                                                        (long) 1, (long) 1,
                                                        (int) (0 +
                                                               (shared_sizze_326658 +
                                                                (8 -
                                                                 shared_sizze_326658 %
                                                                 8) % 8) +
                                                               (shared_sizze_326660 +
                                                                (8 -
                                                                 shared_sizze_326660 %
                                                                 8) % 8) +
                                                               (shared_sizze_326662 +
                                                                (8 -
                                                                 shared_sizze_326662 %
                                                                 8) % 8)));
                                                time_start_326656 =
                                                    get_wall_time();
                                            }
                                            
                                            cudaEvent_t *pevents = NULL;
                                            
                                            if (ctx->profiling &&
                                                !ctx->profiling_paused) {
                                                pevents =
                                                    cuda_get_events(&ctx->cuda,
                                                                    &ctx->mainzisegred_large_308237_runs,
                                                                    &ctx->mainzisegred_large_308237_total_runtime);
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                                   0));
                                            }
                                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_308237,
                                                                                  grid[0],
                                                                                  grid[1],
                                                                                  grid[2],
                                                                                  segred_group_sizze_308228,
                                                                                  1,
                                                                                  1,
                                                                                  0 +
                                                                                  (shared_sizze_326658 +
                                                                                   (8 -
                                                                                    shared_sizze_326658 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326660 +
                                                                                   (8 -
                                                                                    shared_sizze_326660 %
                                                                                    8) %
                                                                                   8) +
                                                                                  (shared_sizze_326662 +
                                                                                   (8 -
                                                                                    shared_sizze_326662 %
                                                                                    8) %
                                                                                   8),
                                                                                  NULL,
                                                                                  kernel_args_326655,
                                                                                  NULL));
                                            if (pevents != NULL)
                                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                                   0));
                                            if (ctx->debugging) {
                                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                                time_end_326657 =
                                                    get_wall_time();
                                                fprintf(ctx->log,
                                                        "Kernel %s runtime: %ldus\n",
                                                        "main.segred_large_308237",
                                                        time_end_326657 -
                                                        time_start_326656);
                                            }
                                        }
                                        if (ctx->debugging)
                                            fprintf(ctx->log, "%s\n", "");
                                        if (memblock_unref_device(ctx,
                                                                  &segred_tmp_mem_322735,
                                                                  "segred_tmp_mem_322735") !=
                                            0)
                                            return 1;
                                        if (memblock_unref_device(ctx,
                                                                  &segred_tmp_mem_322733,
                                                                  "segred_tmp_mem_322733") !=
                                            0)
                                            return 1;
                                    }
                                    if (memblock_unref_device(ctx, &mem_319431,
                                                              "mem_319431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319436,
                                                              "mem_319436") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319441,
                                                              "mem_319441") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319446,
                                                              "mem_319446") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319451,
                                                              "mem_319451") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319456,
                                                              "mem_319456") !=
                                        0)
                                        return 1;
                                    if (memblock_set_device(ctx,
                                                            &ext_mem_319469,
                                                            &mem_319462,
                                                            "mem_319462") != 0)
                                        return 1;
                                    if (memblock_set_device(ctx,
                                                            &ext_mem_319468,
                                                            &mem_319467,
                                                            "mem_319467") != 0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319467,
                                                              "mem_319467") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319462,
                                                              "mem_319462") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319456,
                                                              "mem_319456") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319451,
                                                              "mem_319451") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319446,
                                                              "mem_319446") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319441,
                                                              "mem_319441") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319436,
                                                              "mem_319436") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319431,
                                                              "mem_319431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319425,
                                                              "mem_319425") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319420,
                                                              "mem_319420") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319415,
                                                              "mem_319415") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319410,
                                                              "mem_319410") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319405,
                                                              "mem_319405") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319399,
                                                              "mem_319399") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319395,
                                                              "mem_319395") !=
                                        0)
                                        return 1;
                                }
                                if (memblock_set_device(ctx, &ext_mem_319483,
                                                        &ext_mem_319469,
                                                        "ext_mem_319469") != 0)
                                    return 1;
                                if (memblock_set_device(ctx, &ext_mem_319482,
                                                        &ext_mem_319468,
                                                        "ext_mem_319468") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319468,
                                                          "ext_mem_319468") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_319469,
                                                          "ext_mem_319469") !=
                                    0)
                                    return 1;
                            }
                            if (memblock_set_device(ctx, &ext_mem_319485,
                                                    &ext_mem_319483,
                                                    "ext_mem_319483") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319484,
                                                    &ext_mem_319482,
                                                    "ext_mem_319482") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319482,
                                                      "ext_mem_319482") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319483,
                                                      "ext_mem_319483") != 0)
                                return 1;
                        }
                        if (memblock_set_device(ctx, &ext_mem_319487,
                                                &ext_mem_319485,
                                                "ext_mem_319485") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319486,
                                                &ext_mem_319484,
                                                "ext_mem_319484") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319484,
                                                  "ext_mem_319484") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319485,
                                                  "ext_mem_319485") != 0)
                            return 1;
                    }
                    if (memblock_set_device(ctx, &ext_mem_319489,
                                            &ext_mem_319487,
                                            "ext_mem_319487") != 0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_319488,
                                            &ext_mem_319486,
                                            "ext_mem_319486") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319486,
                                              "ext_mem_319486") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319487,
                                              "ext_mem_319487") != 0)
                        return 1;
                }
                if (memblock_set_device(ctx, &ext_mem_319491, &ext_mem_319489,
                                        "ext_mem_319489") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_319490, &ext_mem_319488,
                                        "ext_mem_319488") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_319488,
                                          "ext_mem_319488") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_319489,
                                          "ext_mem_319489") != 0)
                    return 1;
            }
            
            struct memblock_device ext_mem_319498;
            
            ext_mem_319498.references = NULL;
            if (cond_292824) {
                if (memblock_set_device(ctx, &ext_mem_319498, &ext_mem_319491,
                                        "ext_mem_319491") != 0)
                    return 1;
            } else {
                bool bounds_invalid_upwards_294584 = slt64(pad_css_len_292821,
                                                           (int64_t) 0);
                bool valid_294585 = !bounds_invalid_upwards_294584;
                bool range_valid_c_294586;
                
                if (!valid_294585) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Range ", (long long) (int64_t) 0, "..",
                                  (long long) (int64_t) 1, "..<",
                                  (long long) pad_css_len_292821,
                                  " is invalid.",
                                  "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:752:3-761:9\n   #4  stl.fut:222:31-96\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:221:23-223:48\n   #8  /prelude/soacs.fut:67:19-23\n   #9  /prelude/soacs.fut:67:3-37\n   #10 stl.fut:220:15-224:44\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    if (memblock_unref_device(ctx, &ext_mem_319498,
                                              "ext_mem_319498") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319490,
                                              "ext_mem_319490") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319491,
                                              "ext_mem_319491") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t y_308633 = n_p_292677 * pad_css_len_292821;
                int64_t nest_sizze_308634 = partition_sizze_292766 * y_308633;
                int64_t segmap_group_sizze_308635;
                
                segmap_group_sizze_308635 =
                    *ctx->tuning_params.mainzisegmap_group_sizze_308343;
                
                int64_t segmap_usable_groups_308636 =
                        sdiv_up64(nest_sizze_308634, segmap_group_sizze_308635);
                struct memblock_device mem_319497;
                
                mem_319497.references = NULL;
                if (memblock_alloc_device(ctx, &mem_319497, bytes_319496,
                                          "mem_319497")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_326684 = ext_mem_319490.mem;
                CUdeviceptr kernel_arg_326685 = ext_mem_319491.mem;
                CUdeviceptr kernel_arg_326686 = mem_319497.mem;
                
                if ((((((1 && segmap_usable_groups_308636 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_308635 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_308636;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_326681[] = {&ctx->global_failure,
                                                  &ctx->failure_is_an_option,
                                                  &ctx->global_failure_args,
                                                  &n_p_292677, &jump_s_292684,
                                                  &partition_sizze_292766,
                                                  &defunc_0_f_res_292820,
                                                  &pad_css_len_292821,
                                                  &s_n_m_292825,
                                                  &kernel_arg_326684,
                                                  &kernel_arg_326685,
                                                  &kernel_arg_326686};
                    int64_t time_start_326682 = 0, time_end_326683 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_308641",
                                (long) segmap_usable_groups_308636, (long) 1,
                                (long) 1, (long) segmap_group_sizze_308635,
                                (long) 1, (long) 1, (int) 0);
                        time_start_326682 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_308641_runs,
                                                  &ctx->mainzisegmap_308641_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_308641,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_308635,
                                                          1, 1, 0, NULL,
                                                          kernel_args_326681,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_326683 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_308641", time_end_326683 -
                                time_start_326682);
                    }
                }
                ctx->failure_is_an_option = 1;
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_set_device(ctx, &ext_mem_319498, &mem_319497,
                                        "mem_319497") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319497, "mem_319497") != 0)
                    return 1;
            }
            if (memblock_unref_device(ctx, &ext_mem_319490, "ext_mem_319490") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_319491, "ext_mem_319491") !=
                0)
                return 1;
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            CUdeviceptr kernel_arg_326690 = ext_mem_319498.mem;
            CUdeviceptr kernel_arg_326691 = mem_319504.mem;
            
            if ((((((1 && segmap_usable_groups_308786 != 0) && 1 != 0) && 1 !=
                   0) && segmap_group_sizze_308785 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = segmap_usable_groups_308786;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_326687[] = {&ctx->global_failure,
                                              &ctx->failure_is_an_option,
                                              &ctx->global_failure_args,
                                              &n_p_292677,
                                              &partition_sizze_292766,
                                              &C_len_292823,
                                              &css_results_l_293288,
                                              &kernel_arg_326690,
                                              &kernel_arg_326691};
                int64_t time_start_326688 = 0, time_end_326689 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_308790",
                            (long) segmap_usable_groups_308786, (long) 1,
                            (long) 1, (long) segmap_group_sizze_308785,
                            (long) 1, (long) 1, (int) 0);
                    time_start_326688 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_308790_runs,
                                              &ctx->mainzisegmap_308790_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_308790,
                                                      grid[0], grid[1], grid[2],
                                                      segmap_group_sizze_308785,
                                                      1, 1, 0, NULL,
                                                      kernel_args_326687,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_326689 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_308790", time_end_326689 -
                            time_start_326688);
                }
            }
            ctx->failure_is_an_option = 1;
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            if (memblock_unref_device(ctx, &ext_mem_319498, "ext_mem_319498") !=
                0)
                return 1;
            
            struct memblock_device ext_mem_319516;
            
            ext_mem_319516.references = NULL;
            
            int32_t local_memory_capacity_322882;
            
            local_memory_capacity_322882 = ctx->cuda.max_shared_memory;
            if (sle64((int64_t) 0,
                      sext_i32_i64(local_memory_capacity_322882)) &&
                suff_outer_par_308806) {
                struct memblock_device mem_319507;
                
                mem_319507.references = NULL;
                if (memblock_alloc_device(ctx, &mem_319507, binop_y_319502,
                                          "mem_319507")) {
                    err = 1;
                    goto cleanup;
                }
                if (futrts_builtinzhgpu_map_transpose_f64(ctx, mem_319507,
                                                          (int64_t) 0,
                                                          mem_319504,
                                                          (int64_t) 0,
                                                          (int64_t) 1,
                                                          C_len_292823,
                                                          partition_sizze_292766) !=
                    0) {
                    if (memblock_unref_device(ctx, &mem_319507, "mem_319507") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319516,
                                              "ext_mem_319516") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319498,
                                              "ext_mem_319498") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319490,
                                              "ext_mem_319490") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319491,
                                              "ext_mem_319491") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device mem_319511;
                
                mem_319511.references = NULL;
                if (memblock_alloc_device(ctx, &mem_319511, bytes_318525,
                                          "mem_319511")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_326695 = mem_319507.mem;
                CUdeviceptr kernel_arg_326696 = mem_319511.mem;
                
                if ((((((1 && segmap_usable_groups_308823 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_308822 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_308823;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_326692[] = {&ctx->global_failure,
                                                  &n_p_292677,
                                                  &partition_sizze_292766,
                                                  &kernel_arg_326695,
                                                  &kernel_arg_326696};
                    int64_t time_start_326693 = 0, time_end_326694 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_308826",
                                (long) segmap_usable_groups_308823, (long) 1,
                                (long) 1, (long) segmap_group_sizze_308822,
                                (long) 1, (long) 1, (int) 0);
                        time_start_326693 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_308826_runs,
                                                  &ctx->mainzisegmap_308826_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_308826,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_308822,
                                                          1, 1, 0, NULL,
                                                          kernel_args_326692,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_326694 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_308826", time_end_326694 -
                                time_start_326693);
                    }
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_unref_device(ctx, &mem_319507, "mem_319507") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_319516, &mem_319511,
                                        "mem_319511") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319511, "mem_319511") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319507, "mem_319507") != 0)
                    return 1;
            } else {
                struct memblock_device mem_319515;
                
                mem_319515.references = NULL;
                if (memblock_alloc_device(ctx, &mem_319515, bytes_318525,
                                          "mem_319515")) {
                    err = 1;
                    goto cleanup;
                }
                if (slt64(n_p_292677 * (int64_t) 2,
                          segred_group_sizze_308853)) {
                    int64_t segment_sizze_nonzzero_322814 = smax64((int64_t) 1,
                                                                   n_p_292677);
                    int64_t num_threads_322815 = num_groups_308854 *
                            segred_group_sizze_308853;
                    
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegRed-small");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                (long long) partition_sizze_292766, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                (long long) n_p_292677, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segments_per_group",
                                (long long) squot64(segred_group_sizze_308853,
                                                    segment_sizze_nonzzero_322814),
                                '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "required_groups",
                                (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766,
                                                                   squot64(segred_group_sizze_308853,
                                                                           segment_sizze_nonzzero_322814))),
                                '\n');
                    
                    unsigned int shared_sizze_326700 = (int64_t) 8 *
                                 segred_group_sizze_308853;
                    CUdeviceptr kernel_arg_326702 = mem_319504.mem;
                    CUdeviceptr kernel_arg_326703 = mem_319515.mem;
                    unsigned int shared_offset_326701 = 0;
                    
                    if ((((((1 && num_groups_308854 != 0) && 1 != 0) && 1 !=
                           0) && segred_group_sizze_308853 != 0) && 1 != 0) &&
                        1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = num_groups_308854;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_326697[] = {&ctx->global_failure,
                                                      &shared_offset_326701,
                                                      &n_p_292677,
                                                      &partition_sizze_292766,
                                                      &C_len_292823,
                                                      &num_groups_308854,
                                                      &segment_sizze_nonzzero_322814,
                                                      &kernel_arg_326702,
                                                      &kernel_arg_326703};
                        int64_t time_start_326698 = 0, time_end_326699 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segred_small_308859",
                                    (long) num_groups_308854, (long) 1,
                                    (long) 1, (long) segred_group_sizze_308853,
                                    (long) 1, (long) 1, (int) (0 +
                                                               (shared_sizze_326700 +
                                                                (8 -
                                                                 shared_sizze_326700 %
                                                                 8) % 8)));
                            time_start_326698 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegred_small_308859_runs,
                                                      &ctx->mainzisegred_small_308859_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_308859,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segred_group_sizze_308853,
                                                              1, 1, 0 +
                                                              (shared_sizze_326700 +
                                                               (8 -
                                                                shared_sizze_326700 %
                                                                8) % 8), NULL,
                                                              kernel_args_326697,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_326699 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segred_small_308859",
                                    time_end_326699 - time_start_326698);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                } else {
                    int64_t groups_per_segment_322841 =
                            sdiv_up64(num_groups_308854, smax64((int64_t) 1,
                                                                partition_sizze_292766));
                    int64_t elements_per_thread_322842 = sdiv_up64(n_p_292677,
                                                                   segred_group_sizze_308853 *
                                                                   groups_per_segment_322841);
                    int64_t virt_num_groups_322843 = groups_per_segment_322841 *
                            partition_sizze_292766;
                    int64_t num_threads_322844 = num_groups_308854 *
                            segred_group_sizze_308853;
                    int64_t threads_per_segment_322845 =
                            groups_per_segment_322841 *
                            segred_group_sizze_308853;
                    
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegRed-large");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                (long long) partition_sizze_292766, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                (long long) n_p_292677, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "virt_num_groups",
                                (long long) virt_num_groups_322843, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_groups",
                                (long long) num_groups_308854, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "group_size",
                                (long long) segred_group_sizze_308853, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "elems_per_thread",
                                (long long) elements_per_thread_322842, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "groups_per_segment",
                                (long long) groups_per_segment_322841, '\n');
                    
                    struct memblock_device segred_tmp_mem_322846;
                    
                    segred_tmp_mem_322846.references = NULL;
                    if (memblock_alloc_device(ctx, &segred_tmp_mem_322846,
                                              (int64_t) 8 *
                                              virt_num_groups_322843,
                                              "segred_tmp_mem_322846")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device mainzicounter_mem_322848 =
                                           ctx->mainzicounter_mem_322848;
                    unsigned int shared_sizze_326708 = 1;
                    unsigned int shared_sizze_326710 = (int64_t) 8 *
                                 segred_group_sizze_308853;
                    CUdeviceptr kernel_arg_326712 = mem_319504.mem;
                    CUdeviceptr kernel_arg_326713 = mem_319515.mem;
                    CUdeviceptr kernel_arg_326714 = segred_tmp_mem_322846.mem;
                    CUdeviceptr kernel_arg_326715 =
                                mainzicounter_mem_322848.mem;
                    unsigned int shared_offset_326709 = 0;
                    unsigned int shared_offset_326711 = 0 +
                                 (shared_sizze_326708 + (8 -
                                                         shared_sizze_326708 %
                                                         8) % 8);
                    
                    if ((((((1 && num_groups_308854 != 0) && 1 != 0) && 1 !=
                           0) && segred_group_sizze_308853 != 0) && 1 != 0) &&
                        1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = num_groups_308854;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_326705[] = {&ctx->global_failure,
                                                      &shared_offset_326709,
                                                      &shared_offset_326711,
                                                      &n_p_292677,
                                                      &partition_sizze_292766,
                                                      &C_len_292823,
                                                      &num_groups_308854,
                                                      &groups_per_segment_322841,
                                                      &elements_per_thread_322842,
                                                      &virt_num_groups_322843,
                                                      &threads_per_segment_322845,
                                                      &kernel_arg_326712,
                                                      &kernel_arg_326713,
                                                      &kernel_arg_326714,
                                                      &kernel_arg_326715};
                        int64_t time_start_326706 = 0, time_end_326707 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segred_large_308859",
                                    (long) num_groups_308854, (long) 1,
                                    (long) 1, (long) segred_group_sizze_308853,
                                    (long) 1, (long) 1, (int) (0 +
                                                               (shared_sizze_326708 +
                                                                (8 -
                                                                 shared_sizze_326708 %
                                                                 8) % 8) +
                                                               (shared_sizze_326710 +
                                                                (8 -
                                                                 shared_sizze_326710 %
                                                                 8) % 8)));
                            time_start_326706 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegred_large_308859_runs,
                                                      &ctx->mainzisegred_large_308859_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_308859,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segred_group_sizze_308853,
                                                              1, 1, 0 +
                                                              (shared_sizze_326708 +
                                                               (8 -
                                                                shared_sizze_326708 %
                                                                8) % 8) +
                                                              (shared_sizze_326710 +
                                                               (8 -
                                                                shared_sizze_326710 %
                                                                8) % 8), NULL,
                                                              kernel_args_326705,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_326707 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segred_large_308859",
                                    time_end_326707 - time_start_326706);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                    if (memblock_unref_device(ctx, &segred_tmp_mem_322846,
                                              "segred_tmp_mem_322846") != 0)
                        return 1;
                }
                if (memblock_set_device(ctx, &ext_mem_319516, &mem_319515,
                                        "mem_319515") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319515, "mem_319515") != 0)
                    return 1;
            }
            if (slt64((int64_t) 0, partition_sizze_292766 *
                      lifted_single_ma_l_arg_293311)) {
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegScan");
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c",
                            "SegScan: number of elements processed sequentially per thread is m:",
                            (long long) 11, '\n');
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c",
                            "SegScan: memory constraints is: ", (long long) 11,
                            '\n');
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c",
                            "SegScan: register constraints is: ",
                            (long long) 15, '\n');
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c", "SegScan: sumT' is: ",
                            (long long) 2, '\n');
                
                int64_t numThreads_322883 = sdiv_up64(partition_sizze_292766 *
                                                      lifted_single_ma_l_arg_293311,
                                                      segscan_group_sizze_308905 *
                                                      (int64_t) 11) *
                        segscan_group_sizze_308905;
                int64_t numGroups_322884 = sdiv_up64(partition_sizze_292766 *
                                                     lifted_single_ma_l_arg_293311,
                                                     segscan_group_sizze_308905 *
                                                     (int64_t) 11);
                struct memblock_device mainziid_counter_mem_322885 =
                                       ctx->mainziid_counter_mem_322885;
                struct memblock_device status_flags_mem_322887;
                
                status_flags_mem_322887.references = NULL;
                if (memblock_alloc_device(ctx, &status_flags_mem_322887,
                                          numGroups_322884,
                                          "status_flags_mem_322887")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device aggregates_mem_322889;
                
                aggregates_mem_322889.references = NULL;
                if (memblock_alloc_device(ctx, &aggregates_mem_322889,
                                          (int64_t) 8 * numGroups_322884,
                                          "aggregates_mem_322889")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device incprefixes_mem_322891;
                
                incprefixes_mem_322891.references = NULL;
                if (memblock_alloc_device(ctx, &incprefixes_mem_322891,
                                          (int64_t) 8 * numGroups_322884,
                                          "incprefixes_mem_322891")) {
                    err = 1;
                    goto cleanup;
                }
                if (futrts_builtinzhreplicate_i8(ctx, status_flags_mem_322887,
                                                 numGroups_322884,
                                                 (int8_t) 0) != 0) {
                    if (memblock_unref_device(ctx, &incprefixes_mem_322891,
                                              "incprefixes_mem_322891") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &aggregates_mem_322889,
                                              "aggregates_mem_322889") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &status_flags_mem_322887,
                                              "status_flags_mem_322887") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319516,
                                              "ext_mem_319516") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319498,
                                              "ext_mem_319498") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319490,
                                              "ext_mem_319490") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319491,
                                              "ext_mem_319491") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                unsigned int shared_sizze_326720 = smax64(smax64((int64_t) 288,
                                                                 (int64_t) 8 *
                                                                 segscan_group_sizze_308905),
                                                          (int64_t) 11 *
                                                          segscan_group_sizze_308905 *
                                                          (int64_t) 8);
                CUdeviceptr kernel_arg_326722 = mem_319504.mem;
                CUdeviceptr kernel_arg_326723 = ext_mem_319516.mem;
                CUdeviceptr kernel_arg_326724 = mem_319521.mem;
                CUdeviceptr kernel_arg_326725 = mainziid_counter_mem_322885.mem;
                CUdeviceptr kernel_arg_326726 = status_flags_mem_322887.mem;
                CUdeviceptr kernel_arg_326727 = aggregates_mem_322889.mem;
                CUdeviceptr kernel_arg_326728 = incprefixes_mem_322891.mem;
                unsigned int shared_offset_326721 = 0;
                
                if ((((((1 && sdiv_up64(partition_sizze_292766 *
                                        lifted_single_ma_l_arg_293311,
                                        segscan_group_sizze_308905 *
                                        (int64_t) 11) != 0) && 1 != 0) && 1 !=
                       0) && segscan_group_sizze_308905 != 0) && 1 != 0) && 1 !=
                    0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = sdiv_up64(partition_sizze_292766 *
                                              lifted_single_ma_l_arg_293311,
                                              segscan_group_sizze_308905 *
                                              (int64_t) 11);
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_326717[] = {&ctx->global_failure,
                                                  &ctx->failure_is_an_option,
                                                  &ctx->global_failure_args,
                                                  &shared_offset_326721,
                                                  &n_p_292677, &i64_res_292694,
                                                  &partition_sizze_292766,
                                                  &C_len_292823,
                                                  &lifted_single_ma_l_arg_293311,
                                                  &kernel_arg_326722,
                                                  &kernel_arg_326723,
                                                  &kernel_arg_326724,
                                                  &kernel_arg_326725,
                                                  &kernel_arg_326726,
                                                  &kernel_arg_326727,
                                                  &kernel_arg_326728};
                    int64_t time_start_326718 = 0, time_end_326719 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segscan_308911",
                                (long) sdiv_up64(partition_sizze_292766 *
                                                 lifted_single_ma_l_arg_293311,
                                                 segscan_group_sizze_308905 *
                                                 (int64_t) 11), (long) 1,
                                (long) 1, (long) segscan_group_sizze_308905,
                                (long) 1, (long) 1, (int) (0 +
                                                           (shared_sizze_326720 +
                                                            (8 -
                                                             shared_sizze_326720 %
                                                             8) % 8)));
                        time_start_326718 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegscan_308911_runs,
                                                  &ctx->mainzisegscan_308911_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegscan_308911,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segscan_group_sizze_308905,
                                                          1, 1, 0 +
                                                          (shared_sizze_326720 +
                                                           (8 -
                                                            shared_sizze_326720 %
                                                            8) % 8), NULL,
                                                          kernel_args_326717,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_326719 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segscan_308911", time_end_326719 -
                                time_start_326718);
                    }
                }
                ctx->failure_is_an_option = 1;
                if (memblock_unref_device(ctx, &incprefixes_mem_322891,
                                          "incprefixes_mem_322891") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &aggregates_mem_322889,
                                          "aggregates_mem_322889") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &status_flags_mem_322887,
                                          "status_flags_mem_322887") != 0)
                    return 1;
            }
            if (memblock_unref_device(ctx, &ext_mem_319516, "ext_mem_319516") !=
                0)
                return 1;
            
            struct memblock_device ext_mem_319533;
            
            ext_mem_319533.references = NULL;
            
            int32_t local_memory_capacity_323063;
            
            local_memory_capacity_323063 = ctx->cuda.max_shared_memory;
            if (sle64((int64_t) 0,
                      sext_i32_i64(local_memory_capacity_323063)) &&
                suff_outer_par_308937) {
                struct memblock_device mem_319524;
                
                mem_319524.references = NULL;
                if (memblock_alloc_device(ctx, &mem_319524, binop_y_319519,
                                          "mem_319524")) {
                    err = 1;
                    goto cleanup;
                }
                if (futrts_builtinzhgpu_map_transpose_f64(ctx, mem_319524,
                                                          (int64_t) 0,
                                                          mem_319521,
                                                          (int64_t) 0,
                                                          (int64_t) 1,
                                                          lifted_single_ma_l_arg_293311,
                                                          partition_sizze_292766) !=
                    0) {
                    if (memblock_unref_device(ctx, &mem_319524, "mem_319524") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319533,
                                              "ext_mem_319533") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319516,
                                              "ext_mem_319516") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319498,
                                              "ext_mem_319498") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319490,
                                              "ext_mem_319490") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319491,
                                              "ext_mem_319491") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device mem_319528;
                
                mem_319528.references = NULL;
                if (memblock_alloc_device(ctx, &mem_319528, bytes_318525,
                                          "mem_319528")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_326732 = mem_319524.mem;
                CUdeviceptr kernel_arg_326733 = mem_319528.mem;
                
                if ((((((1 && segmap_usable_groups_308954 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_308953 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_308954;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_326729[] = {&ctx->global_failure,
                                                  &n_p_292677,
                                                  &partition_sizze_292766,
                                                  &kernel_arg_326732,
                                                  &kernel_arg_326733};
                    int64_t time_start_326730 = 0, time_end_326731 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_308957",
                                (long) segmap_usable_groups_308954, (long) 1,
                                (long) 1, (long) segmap_group_sizze_308953,
                                (long) 1, (long) 1, (int) 0);
                        time_start_326730 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_308957_runs,
                                                  &ctx->mainzisegmap_308957_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_308957,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_308953,
                                                          1, 1, 0, NULL,
                                                          kernel_args_326729,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_326731 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_308957", time_end_326731 -
                                time_start_326730);
                    }
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_unref_device(ctx, &mem_319524, "mem_319524") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_319533, &mem_319528,
                                        "mem_319528") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319528, "mem_319528") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319524, "mem_319524") != 0)
                    return 1;
            } else {
                struct memblock_device mem_319532;
                
                mem_319532.references = NULL;
                if (memblock_alloc_device(ctx, &mem_319532, bytes_318525,
                                          "mem_319532")) {
                    err = 1;
                    goto cleanup;
                }
                if (slt64(n_p_292677 * (int64_t) 2,
                          segred_group_sizze_308984)) {
                    int64_t segment_sizze_nonzzero_322995 = smax64((int64_t) 1,
                                                                   n_p_292677);
                    int64_t num_threads_322996 = num_groups_308985 *
                            segred_group_sizze_308984;
                    
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegRed-small");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                (long long) partition_sizze_292766, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                (long long) n_p_292677, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segments_per_group",
                                (long long) squot64(segred_group_sizze_308984,
                                                    segment_sizze_nonzzero_322995),
                                '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "required_groups",
                                (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766,
                                                                   squot64(segred_group_sizze_308984,
                                                                           segment_sizze_nonzzero_322995))),
                                '\n');
                    
                    unsigned int shared_sizze_326737 = (int64_t) 8 *
                                 segred_group_sizze_308984;
                    CUdeviceptr kernel_arg_326739 = mem_319521.mem;
                    CUdeviceptr kernel_arg_326740 = mem_319532.mem;
                    unsigned int shared_offset_326738 = 0;
                    
                    if ((((((1 && num_groups_308985 != 0) && 1 != 0) && 1 !=
                           0) && segred_group_sizze_308984 != 0) && 1 != 0) &&
                        1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = num_groups_308985;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_326734[] = {&ctx->global_failure,
                                                      &shared_offset_326738,
                                                      &n_p_292677,
                                                      &partition_sizze_292766,
                                                      &lifted_single_ma_l_arg_293311,
                                                      &num_groups_308985,
                                                      &segment_sizze_nonzzero_322995,
                                                      &kernel_arg_326739,
                                                      &kernel_arg_326740};
                        int64_t time_start_326735 = 0, time_end_326736 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segred_small_308990",
                                    (long) num_groups_308985, (long) 1,
                                    (long) 1, (long) segred_group_sizze_308984,
                                    (long) 1, (long) 1, (int) (0 +
                                                               (shared_sizze_326737 +
                                                                (8 -
                                                                 shared_sizze_326737 %
                                                                 8) % 8)));
                            time_start_326735 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegred_small_308990_runs,
                                                      &ctx->mainzisegred_small_308990_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_308990,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segred_group_sizze_308984,
                                                              1, 1, 0 +
                                                              (shared_sizze_326737 +
                                                               (8 -
                                                                shared_sizze_326737 %
                                                                8) % 8), NULL,
                                                              kernel_args_326734,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_326736 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segred_small_308990",
                                    time_end_326736 - time_start_326735);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                } else {
                    int64_t groups_per_segment_323022 =
                            sdiv_up64(num_groups_308985, smax64((int64_t) 1,
                                                                partition_sizze_292766));
                    int64_t elements_per_thread_323023 = sdiv_up64(n_p_292677,
                                                                   segred_group_sizze_308984 *
                                                                   groups_per_segment_323022);
                    int64_t virt_num_groups_323024 = groups_per_segment_323022 *
                            partition_sizze_292766;
                    int64_t num_threads_323025 = num_groups_308985 *
                            segred_group_sizze_308984;
                    int64_t threads_per_segment_323026 =
                            groups_per_segment_323022 *
                            segred_group_sizze_308984;
                    
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegRed-large");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                (long long) partition_sizze_292766, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                (long long) n_p_292677, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "virt_num_groups",
                                (long long) virt_num_groups_323024, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_groups",
                                (long long) num_groups_308985, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "group_size",
                                (long long) segred_group_sizze_308984, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "elems_per_thread",
                                (long long) elements_per_thread_323023, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "groups_per_segment",
                                (long long) groups_per_segment_323022, '\n');
                    
                    struct memblock_device segred_tmp_mem_323027;
                    
                    segred_tmp_mem_323027.references = NULL;
                    if (memblock_alloc_device(ctx, &segred_tmp_mem_323027,
                                              (int64_t) 8 *
                                              virt_num_groups_323024,
                                              "segred_tmp_mem_323027")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device mainzicounter_mem_323029 =
                                           ctx->mainzicounter_mem_323029;
                    unsigned int shared_sizze_326745 = 1;
                    unsigned int shared_sizze_326747 = (int64_t) 8 *
                                 segred_group_sizze_308984;
                    CUdeviceptr kernel_arg_326749 = mem_319521.mem;
                    CUdeviceptr kernel_arg_326750 = mem_319532.mem;
                    CUdeviceptr kernel_arg_326751 = segred_tmp_mem_323027.mem;
                    CUdeviceptr kernel_arg_326752 =
                                mainzicounter_mem_323029.mem;
                    unsigned int shared_offset_326746 = 0;
                    unsigned int shared_offset_326748 = 0 +
                                 (shared_sizze_326745 + (8 -
                                                         shared_sizze_326745 %
                                                         8) % 8);
                    
                    if ((((((1 && num_groups_308985 != 0) && 1 != 0) && 1 !=
                           0) && segred_group_sizze_308984 != 0) && 1 != 0) &&
                        1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = num_groups_308985;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_326742[] = {&ctx->global_failure,
                                                      &shared_offset_326746,
                                                      &shared_offset_326748,
                                                      &n_p_292677,
                                                      &partition_sizze_292766,
                                                      &lifted_single_ma_l_arg_293311,
                                                      &num_groups_308985,
                                                      &groups_per_segment_323022,
                                                      &elements_per_thread_323023,
                                                      &virt_num_groups_323024,
                                                      &threads_per_segment_323026,
                                                      &kernel_arg_326749,
                                                      &kernel_arg_326750,
                                                      &kernel_arg_326751,
                                                      &kernel_arg_326752};
                        int64_t time_start_326743 = 0, time_end_326744 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segred_large_308990",
                                    (long) num_groups_308985, (long) 1,
                                    (long) 1, (long) segred_group_sizze_308984,
                                    (long) 1, (long) 1, (int) (0 +
                                                               (shared_sizze_326745 +
                                                                (8 -
                                                                 shared_sizze_326745 %
                                                                 8) % 8) +
                                                               (shared_sizze_326747 +
                                                                (8 -
                                                                 shared_sizze_326747 %
                                                                 8) % 8)));
                            time_start_326743 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegred_large_308990_runs,
                                                      &ctx->mainzisegred_large_308990_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_308990,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segred_group_sizze_308984,
                                                              1, 1, 0 +
                                                              (shared_sizze_326745 +
                                                               (8 -
                                                                shared_sizze_326745 %
                                                                8) % 8) +
                                                              (shared_sizze_326747 +
                                                               (8 -
                                                                shared_sizze_326747 %
                                                                8) % 8), NULL,
                                                              kernel_args_326742,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_326744 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segred_large_308990",
                                    time_end_326744 - time_start_326743);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                    if (memblock_unref_device(ctx, &segred_tmp_mem_323027,
                                              "segred_tmp_mem_323027") != 0)
                        return 1;
                }
                if (memblock_set_device(ctx, &ext_mem_319533, &mem_319532,
                                        "mem_319532") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319532, "mem_319532") != 0)
                    return 1;
            }
            if (slt64((int64_t) 0, partition_sizze_292766 *
                      dyn_lifted_single_ma_l_arg_293321)) {
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegScan");
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c",
                            "SegScan: number of elements processed sequentially per thread is m:",
                            (long long) 11, '\n');
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c",
                            "SegScan: memory constraints is: ", (long long) 11,
                            '\n');
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c",
                            "SegScan: register constraints is: ",
                            (long long) 15, '\n');
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c", "SegScan: sumT' is: ",
                            (long long) 2, '\n');
                
                int64_t numThreads_323064 = sdiv_up64(partition_sizze_292766 *
                                                      dyn_lifted_single_ma_l_arg_293321,
                                                      segscan_group_sizze_309036 *
                                                      (int64_t) 11) *
                        segscan_group_sizze_309036;
                int64_t numGroups_323065 = sdiv_up64(partition_sizze_292766 *
                                                     dyn_lifted_single_ma_l_arg_293321,
                                                     segscan_group_sizze_309036 *
                                                     (int64_t) 11);
                struct memblock_device mainziid_counter_mem_323066 =
                                       ctx->mainziid_counter_mem_323066;
                struct memblock_device status_flags_mem_323068;
                
                status_flags_mem_323068.references = NULL;
                if (memblock_alloc_device(ctx, &status_flags_mem_323068,
                                          numGroups_323065,
                                          "status_flags_mem_323068")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device aggregates_mem_323070;
                
                aggregates_mem_323070.references = NULL;
                if (memblock_alloc_device(ctx, &aggregates_mem_323070,
                                          (int64_t) 8 * numGroups_323065,
                                          "aggregates_mem_323070")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device incprefixes_mem_323072;
                
                incprefixes_mem_323072.references = NULL;
                if (memblock_alloc_device(ctx, &incprefixes_mem_323072,
                                          (int64_t) 8 * numGroups_323065,
                                          "incprefixes_mem_323072")) {
                    err = 1;
                    goto cleanup;
                }
                if (futrts_builtinzhreplicate_i8(ctx, status_flags_mem_323068,
                                                 numGroups_323065,
                                                 (int8_t) 0) != 0) {
                    if (memblock_unref_device(ctx, &incprefixes_mem_323072,
                                              "incprefixes_mem_323072") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &aggregates_mem_323070,
                                              "aggregates_mem_323070") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &status_flags_mem_323068,
                                              "status_flags_mem_323068") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319533,
                                              "ext_mem_319533") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319516,
                                              "ext_mem_319516") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319498,
                                              "ext_mem_319498") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319490,
                                              "ext_mem_319490") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319491,
                                              "ext_mem_319491") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                unsigned int shared_sizze_326757 = smax64(smax64((int64_t) 288,
                                                                 (int64_t) 8 *
                                                                 segscan_group_sizze_309036),
                                                          (int64_t) 11 *
                                                          segscan_group_sizze_309036 *
                                                          (int64_t) 8);
                CUdeviceptr kernel_arg_326759 = mem_319521.mem;
                CUdeviceptr kernel_arg_326760 = ext_mem_319533.mem;
                CUdeviceptr kernel_arg_326761 = mem_319538.mem;
                CUdeviceptr kernel_arg_326762 = mainziid_counter_mem_323066.mem;
                CUdeviceptr kernel_arg_326763 = status_flags_mem_323068.mem;
                CUdeviceptr kernel_arg_326764 = aggregates_mem_323070.mem;
                CUdeviceptr kernel_arg_326765 = incprefixes_mem_323072.mem;
                unsigned int shared_offset_326758 = 0;
                
                if ((((((1 && sdiv_up64(partition_sizze_292766 *
                                        dyn_lifted_single_ma_l_arg_293321,
                                        segscan_group_sizze_309036 *
                                        (int64_t) 11) != 0) && 1 != 0) && 1 !=
                       0) && segscan_group_sizze_309036 != 0) && 1 != 0) && 1 !=
                    0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = sdiv_up64(partition_sizze_292766 *
                                              dyn_lifted_single_ma_l_arg_293321,
                                              segscan_group_sizze_309036 *
                                              (int64_t) 11);
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_326754[] = {&ctx->global_failure,
                                                  &ctx->failure_is_an_option,
                                                  &ctx->global_failure_args,
                                                  &shared_offset_326758,
                                                  &n_p_292677, &i64_res_292694,
                                                  &partition_sizze_292766,
                                                  &lifted_single_ma_l_arg_293311,
                                                  &dyn_lifted_single_ma_l_arg_293321,
                                                  &kernel_arg_326759,
                                                  &kernel_arg_326760,
                                                  &kernel_arg_326761,
                                                  &kernel_arg_326762,
                                                  &kernel_arg_326763,
                                                  &kernel_arg_326764,
                                                  &kernel_arg_326765};
                    int64_t time_start_326755 = 0, time_end_326756 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segscan_309042",
                                (long) sdiv_up64(partition_sizze_292766 *
                                                 dyn_lifted_single_ma_l_arg_293321,
                                                 segscan_group_sizze_309036 *
                                                 (int64_t) 11), (long) 1,
                                (long) 1, (long) segscan_group_sizze_309036,
                                (long) 1, (long) 1, (int) (0 +
                                                           (shared_sizze_326757 +
                                                            (8 -
                                                             shared_sizze_326757 %
                                                             8) % 8)));
                        time_start_326755 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegscan_309042_runs,
                                                  &ctx->mainzisegscan_309042_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegscan_309042,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segscan_group_sizze_309036,
                                                          1, 1, 0 +
                                                          (shared_sizze_326757 +
                                                           (8 -
                                                            shared_sizze_326757 %
                                                            8) % 8), NULL,
                                                          kernel_args_326754,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_326756 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segscan_309042", time_end_326756 -
                                time_start_326755);
                    }
                }
                ctx->failure_is_an_option = 1;
                if (memblock_unref_device(ctx, &incprefixes_mem_323072,
                                          "incprefixes_mem_323072") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &aggregates_mem_323070,
                                          "aggregates_mem_323070") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &status_flags_mem_323068,
                                          "status_flags_mem_323068") != 0)
                    return 1;
            }
            if (memblock_unref_device(ctx, &ext_mem_319533, "ext_mem_319533") !=
                0)
                return 1;
            
            struct memblock_device ext_mem_319550;
            
            ext_mem_319550.references = NULL;
            
            int32_t local_memory_capacity_323244;
            
            local_memory_capacity_323244 = ctx->cuda.max_shared_memory;
            if (sle64((int64_t) 0,
                      sext_i32_i64(local_memory_capacity_323244)) &&
                suff_outer_par_309068) {
                struct memblock_device mem_319541;
                
                mem_319541.references = NULL;
                if (memblock_alloc_device(ctx, &mem_319541, binop_y_319536,
                                          "mem_319541")) {
                    err = 1;
                    goto cleanup;
                }
                if (futrts_builtinzhgpu_map_transpose_f64(ctx, mem_319541,
                                                          (int64_t) 0,
                                                          mem_319538,
                                                          (int64_t) 0,
                                                          (int64_t) 1,
                                                          dyn_lifted_single_ma_l_arg_293321,
                                                          partition_sizze_292766) !=
                    0) {
                    if (memblock_unref_device(ctx, &mem_319541, "mem_319541") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319550,
                                              "ext_mem_319550") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319533,
                                              "ext_mem_319533") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319516,
                                              "ext_mem_319516") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319498,
                                              "ext_mem_319498") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319490,
                                              "ext_mem_319490") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319491,
                                              "ext_mem_319491") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device mem_319545;
                
                mem_319545.references = NULL;
                if (memblock_alloc_device(ctx, &mem_319545, bytes_318525,
                                          "mem_319545")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_326769 = mem_319541.mem;
                CUdeviceptr kernel_arg_326770 = mem_319545.mem;
                
                if ((((((1 && segmap_usable_groups_309085 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_309084 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_309085;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_326766[] = {&ctx->global_failure,
                                                  &partition_sizze_292766,
                                                  &kernel_arg_326769,
                                                  &kernel_arg_326770};
                    int64_t time_start_326767 = 0, time_end_326768 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_309088",
                                (long) segmap_usable_groups_309085, (long) 1,
                                (long) 1, (long) segmap_group_sizze_309084,
                                (long) 1, (long) 1, (int) 0);
                        time_start_326767 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_309088_runs,
                                                  &ctx->mainzisegmap_309088_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_309088,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_309084,
                                                          1, 1, 0, NULL,
                                                          kernel_args_326766,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_326768 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_309088", time_end_326768 -
                                time_start_326767);
                    }
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_unref_device(ctx, &mem_319541, "mem_319541") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_319550, &mem_319545,
                                        "mem_319545") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319545, "mem_319545") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319541, "mem_319541") != 0)
                    return 1;
            } else {
                struct memblock_device mem_319549;
                
                mem_319549.references = NULL;
                if (memblock_alloc_device(ctx, &mem_319549, bytes_318525,
                                          "mem_319549")) {
                    err = 1;
                    goto cleanup;
                }
                if (slt64((int64_t) 6, segred_group_sizze_309115)) {
                    int64_t segment_sizze_nonzzero_323176 = smax64((int64_t) 1,
                                                                   (int64_t) 3);
                    int64_t num_threads_323177 = num_groups_309116 *
                            segred_group_sizze_309115;
                    
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegRed-small");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                (long long) partition_sizze_292766, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                (long long) (int64_t) 3, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segments_per_group",
                                (long long) squot64(segred_group_sizze_309115,
                                                    segment_sizze_nonzzero_323176),
                                '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "required_groups",
                                (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766,
                                                                   squot64(segred_group_sizze_309115,
                                                                           segment_sizze_nonzzero_323176))),
                                '\n');
                    
                    unsigned int shared_sizze_326774 = (int64_t) 8 *
                                 segred_group_sizze_309115;
                    CUdeviceptr kernel_arg_326776 = mem_319538.mem;
                    CUdeviceptr kernel_arg_326777 = mem_319549.mem;
                    unsigned int shared_offset_326775 = 0;
                    
                    if ((((((1 && num_groups_309116 != 0) && 1 != 0) && 1 !=
                           0) && segred_group_sizze_309115 != 0) && 1 != 0) &&
                        1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = num_groups_309116;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_326771[] = {&ctx->global_failure,
                                                      &shared_offset_326775,
                                                      &partition_sizze_292766,
                                                      &dyn_lifted_single_ma_l_arg_293321,
                                                      &num_groups_309116,
                                                      &segment_sizze_nonzzero_323176,
                                                      &kernel_arg_326776,
                                                      &kernel_arg_326777};
                        int64_t time_start_326772 = 0, time_end_326773 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segred_small_309121",
                                    (long) num_groups_309116, (long) 1,
                                    (long) 1, (long) segred_group_sizze_309115,
                                    (long) 1, (long) 1, (int) (0 +
                                                               (shared_sizze_326774 +
                                                                (8 -
                                                                 shared_sizze_326774 %
                                                                 8) % 8)));
                            time_start_326772 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegred_small_309121_runs,
                                                      &ctx->mainzisegred_small_309121_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_309121,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segred_group_sizze_309115,
                                                              1, 1, 0 +
                                                              (shared_sizze_326774 +
                                                               (8 -
                                                                shared_sizze_326774 %
                                                                8) % 8), NULL,
                                                              kernel_args_326771,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_326773 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segred_small_309121",
                                    time_end_326773 - time_start_326772);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                } else {
                    int64_t groups_per_segment_323203 =
                            sdiv_up64(num_groups_309116, smax64((int64_t) 1,
                                                                partition_sizze_292766));
                    int64_t elements_per_thread_323204 = sdiv_up64((int64_t) 3,
                                                                   segred_group_sizze_309115 *
                                                                   groups_per_segment_323203);
                    int64_t virt_num_groups_323205 = groups_per_segment_323203 *
                            partition_sizze_292766;
                    int64_t num_threads_323206 = num_groups_309116 *
                            segred_group_sizze_309115;
                    int64_t threads_per_segment_323207 =
                            groups_per_segment_323203 *
                            segred_group_sizze_309115;
                    
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegRed-large");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                (long long) partition_sizze_292766, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                (long long) (int64_t) 3, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "virt_num_groups",
                                (long long) virt_num_groups_323205, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_groups",
                                (long long) num_groups_309116, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "group_size",
                                (long long) segred_group_sizze_309115, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "elems_per_thread",
                                (long long) elements_per_thread_323204, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "groups_per_segment",
                                (long long) groups_per_segment_323203, '\n');
                    
                    struct memblock_device segred_tmp_mem_323208;
                    
                    segred_tmp_mem_323208.references = NULL;
                    if (memblock_alloc_device(ctx, &segred_tmp_mem_323208,
                                              (int64_t) 8 *
                                              virt_num_groups_323205,
                                              "segred_tmp_mem_323208")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device mainzicounter_mem_323210 =
                                           ctx->mainzicounter_mem_323210;
                    unsigned int shared_sizze_326782 = 1;
                    unsigned int shared_sizze_326784 = (int64_t) 8 *
                                 segred_group_sizze_309115;
                    CUdeviceptr kernel_arg_326786 = mem_319538.mem;
                    CUdeviceptr kernel_arg_326787 = mem_319549.mem;
                    CUdeviceptr kernel_arg_326788 = segred_tmp_mem_323208.mem;
                    CUdeviceptr kernel_arg_326789 =
                                mainzicounter_mem_323210.mem;
                    unsigned int shared_offset_326783 = 0;
                    unsigned int shared_offset_326785 = 0 +
                                 (shared_sizze_326782 + (8 -
                                                         shared_sizze_326782 %
                                                         8) % 8);
                    
                    if ((((((1 && num_groups_309116 != 0) && 1 != 0) && 1 !=
                           0) && segred_group_sizze_309115 != 0) && 1 != 0) &&
                        1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = num_groups_309116;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_326779[] = {&ctx->global_failure,
                                                      &shared_offset_326783,
                                                      &shared_offset_326785,
                                                      &partition_sizze_292766,
                                                      &dyn_lifted_single_ma_l_arg_293321,
                                                      &num_groups_309116,
                                                      &groups_per_segment_323203,
                                                      &elements_per_thread_323204,
                                                      &virt_num_groups_323205,
                                                      &threads_per_segment_323207,
                                                      &kernel_arg_326786,
                                                      &kernel_arg_326787,
                                                      &kernel_arg_326788,
                                                      &kernel_arg_326789};
                        int64_t time_start_326780 = 0, time_end_326781 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segred_large_309121",
                                    (long) num_groups_309116, (long) 1,
                                    (long) 1, (long) segred_group_sizze_309115,
                                    (long) 1, (long) 1, (int) (0 +
                                                               (shared_sizze_326782 +
                                                                (8 -
                                                                 shared_sizze_326782 %
                                                                 8) % 8) +
                                                               (shared_sizze_326784 +
                                                                (8 -
                                                                 shared_sizze_326784 %
                                                                 8) % 8)));
                            time_start_326780 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegred_large_309121_runs,
                                                      &ctx->mainzisegred_large_309121_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_309121,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segred_group_sizze_309115,
                                                              1, 1, 0 +
                                                              (shared_sizze_326782 +
                                                               (8 -
                                                                shared_sizze_326782 %
                                                                8) % 8) +
                                                              (shared_sizze_326784 +
                                                               (8 -
                                                                shared_sizze_326784 %
                                                                8) % 8), NULL,
                                                              kernel_args_326779,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_326781 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segred_large_309121",
                                    time_end_326781 - time_start_326780);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                    if (memblock_unref_device(ctx, &segred_tmp_mem_323208,
                                              "segred_tmp_mem_323208") != 0)
                        return 1;
                }
                if (memblock_set_device(ctx, &ext_mem_319550, &mem_319549,
                                        "mem_319549") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319549, "mem_319549") != 0)
                    return 1;
            }
            if (slt64((int64_t) 0, partition_sizze_292766 * n_292675)) {
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegScan");
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c",
                            "SegScan: number of elements processed sequentially per thread is m:",
                            (long long) 11, '\n');
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c",
                            "SegScan: memory constraints is: ", (long long) 11,
                            '\n');
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c",
                            "SegScan: register constraints is: ",
                            (long long) 15, '\n');
                if (ctx->debugging)
                    fprintf(ctx->log, "%s: %llu%c", "SegScan: sumT' is: ",
                            (long long) 2, '\n');
                
                int64_t numThreads_323245 = sdiv_up64(partition_sizze_292766 *
                                                      n_292675,
                                                      segscan_group_sizze_309167 *
                                                      (int64_t) 11) *
                        segscan_group_sizze_309167;
                int64_t numGroups_323246 = sdiv_up64(partition_sizze_292766 *
                                                     n_292675,
                                                     segscan_group_sizze_309167 *
                                                     (int64_t) 11);
                struct memblock_device mainziid_counter_mem_323247 =
                                       ctx->mainziid_counter_mem_323247;
                struct memblock_device status_flags_mem_323249;
                
                status_flags_mem_323249.references = NULL;
                if (memblock_alloc_device(ctx, &status_flags_mem_323249,
                                          numGroups_323246,
                                          "status_flags_mem_323249")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device aggregates_mem_323251;
                
                aggregates_mem_323251.references = NULL;
                if (memblock_alloc_device(ctx, &aggregates_mem_323251,
                                          (int64_t) 8 * numGroups_323246,
                                          "aggregates_mem_323251")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device incprefixes_mem_323253;
                
                incprefixes_mem_323253.references = NULL;
                if (memblock_alloc_device(ctx, &incprefixes_mem_323253,
                                          (int64_t) 8 * numGroups_323246,
                                          "incprefixes_mem_323253")) {
                    err = 1;
                    goto cleanup;
                }
                if (futrts_builtinzhreplicate_i8(ctx, status_flags_mem_323249,
                                                 numGroups_323246,
                                                 (int8_t) 0) != 0) {
                    if (memblock_unref_device(ctx, &incprefixes_mem_323253,
                                              "incprefixes_mem_323253") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &aggregates_mem_323251,
                                              "aggregates_mem_323251") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &status_flags_mem_323249,
                                              "status_flags_mem_323249") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319550,
                                              "ext_mem_319550") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319533,
                                              "ext_mem_319533") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319516,
                                              "ext_mem_319516") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319498,
                                              "ext_mem_319498") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319490,
                                              "ext_mem_319490") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319491,
                                              "ext_mem_319491") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                unsigned int shared_sizze_326794 = smax64(smax64((int64_t) 288,
                                                                 (int64_t) 8 *
                                                                 segscan_group_sizze_309167),
                                                          (int64_t) 11 *
                                                          segscan_group_sizze_309167 *
                                                          (int64_t) 8);
                CUdeviceptr kernel_arg_326796 = mem_319538.mem;
                CUdeviceptr kernel_arg_326797 = ext_mem_319550.mem;
                CUdeviceptr kernel_arg_326798 = mem_319555.mem;
                CUdeviceptr kernel_arg_326799 = mainziid_counter_mem_323247.mem;
                CUdeviceptr kernel_arg_326800 = status_flags_mem_323249.mem;
                CUdeviceptr kernel_arg_326801 = aggregates_mem_323251.mem;
                CUdeviceptr kernel_arg_326802 = incprefixes_mem_323253.mem;
                unsigned int shared_offset_326795 = 0;
                
                if ((((((1 && sdiv_up64(partition_sizze_292766 * n_292675,
                                        segscan_group_sizze_309167 *
                                        (int64_t) 11) != 0) && 1 != 0) && 1 !=
                       0) && segscan_group_sizze_309167 != 0) && 1 != 0) && 1 !=
                    0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = sdiv_up64(partition_sizze_292766 * n_292675,
                                              segscan_group_sizze_309167 *
                                              (int64_t) 11);
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_326791[] = {&ctx->global_failure,
                                                  &ctx->failure_is_an_option,
                                                  &ctx->global_failure_args,
                                                  &shared_offset_326795,
                                                  &n_292675,
                                                  &partition_sizze_292766,
                                                  &dyn_lifted_single_ma_l_arg_293321,
                                                  &kernel_arg_326796,
                                                  &kernel_arg_326797,
                                                  &kernel_arg_326798,
                                                  &kernel_arg_326799,
                                                  &kernel_arg_326800,
                                                  &kernel_arg_326801,
                                                  &kernel_arg_326802};
                    int64_t time_start_326792 = 0, time_end_326793 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segscan_309173",
                                (long) sdiv_up64(partition_sizze_292766 *
                                                 n_292675,
                                                 segscan_group_sizze_309167 *
                                                 (int64_t) 11), (long) 1,
                                (long) 1, (long) segscan_group_sizze_309167,
                                (long) 1, (long) 1, (int) (0 +
                                                           (shared_sizze_326794 +
                                                            (8 -
                                                             shared_sizze_326794 %
                                                             8) % 8)));
                        time_start_326792 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegscan_309173_runs,
                                                  &ctx->mainzisegscan_309173_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegscan_309173,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segscan_group_sizze_309167,
                                                          1, 1, 0 +
                                                          (shared_sizze_326794 +
                                                           (8 -
                                                            shared_sizze_326794 %
                                                            8) % 8), NULL,
                                                          kernel_args_326791,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_326793 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segscan_309173", time_end_326793 -
                                time_start_326792);
                    }
                }
                ctx->failure_is_an_option = 1;
                if (memblock_unref_device(ctx, &incprefixes_mem_323253,
                                          "incprefixes_mem_323253") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &aggregates_mem_323251,
                                          "aggregates_mem_323251") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &status_flags_mem_323249,
                                          "status_flags_mem_323249") != 0)
                    return 1;
            }
            if (memblock_unref_device(ctx, &ext_mem_319550, "ext_mem_319550") !=
                0)
                return 1;
            
            struct memblock_device ext_mem_319758;
            
            ext_mem_319758.references = NULL;
            
            struct memblock_device ext_mem_319757;
            
            ext_mem_319757.references = NULL;
            if (cond_293339) {
                bool match_lit_294803 = (int64_t) 0 == d_l_292683;
                struct memblock_device ext_mem_319586;
                
                ext_mem_319586.references = NULL;
                
                struct memblock_device ext_mem_319585;
                
                ext_mem_319585.references = NULL;
                if (match_lit_294803) {
                    struct memblock_device mem_319559;
                    
                    mem_319559.references = NULL;
                    if (memblock_alloc_device(ctx, &mem_319559, bytes_318723,
                                              "mem_319559")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (futrts_builtinzhreplicate_f64(ctx, mem_319559,
                                                      partition_sizze_292766 *
                                                      l_n_m_292832, 0.0) != 0) {
                        if (memblock_unref_device(ctx, &mem_319559,
                                                  "mem_319559") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319585,
                                                  "ext_mem_319585") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319586,
                                                  "ext_mem_319586") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319757,
                                                  "ext_mem_319757") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319758,
                                                  "ext_mem_319758") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319550,
                                                  "ext_mem_319550") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319533,
                                                  "ext_mem_319533") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319516,
                                                  "ext_mem_319516") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319498,
                                                  "ext_mem_319498") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319490,
                                                  "ext_mem_319490") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319491,
                                                  "ext_mem_319491") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318860,
                                                  "mem_param_318860") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318852,
                                                  "mem_param_318852") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320111,
                                                  "ext_mem_320111") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320112,
                                                  "ext_mem_320112") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318838,
                                                  "mem_param_318838") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318830,
                                                  "mem_param_318830") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318822,
                                                  "mem_param_318822") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320430,
                                                  "ext_mem_320430") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320431,
                                                  "ext_mem_320431") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320432,
                                                  "ext_mem_320432") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319555,
                                                  "mem_319555") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319538,
                                                  "mem_319538") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319521,
                                                  "mem_319521") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319504,
                                                  "mem_319504") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318876,
                                                  "mem_318876") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318871,
                                                  "mem_318871") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318865,
                                                  "mem_318865") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318814,
                                                  "mem_318814") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318810,
                                                  "mem_318810") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318805,
                                                  "ext_mem_318805") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318806,
                                                  "ext_mem_318806") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318756,
                                                  "ext_mem_318756") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318757,
                                                  "ext_mem_318757") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318707,
                                                  "ext_mem_318707") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318708,
                                                  "ext_mem_318708") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318609,
                                                  "ext_mem_318609") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318610,
                                                  "ext_mem_318610") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318551,
                                                  "mem_318551") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318545,
                                                  "mem_318545") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318541,
                                                  "ext_mem_318541") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318542,
                                                  "ext_mem_318542") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318509,
                                                  "mem_318509") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318506,
                                                  "mem_318506") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318502,
                                                  "mem_318502") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318500,
                                                  "mem_318500") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318497,
                                                  "mem_318497") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318493,
                                                  "mem_318493") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320825,
                                                  "mem_out_320825") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320824,
                                                  "mem_out_320824") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320823,
                                                  "mem_out_320823") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t segmap_group_sizze_309283;
                    
                    segmap_group_sizze_309283 =
                        *ctx->tuning_params.mainzisegmap_group_sizze_309203;
                    
                    int64_t segmap_usable_groups_309284 =
                            sdiv_up64(nest_sizze_300244,
                                      segmap_group_sizze_309283);
                    struct memblock_device mem_319564;
                    
                    mem_319564.references = NULL;
                    if (memblock_alloc_device(ctx, &mem_319564, bytes_318723,
                                              "mem_319564")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegMap");
                    
                    CUdeviceptr kernel_arg_326806 = ext_mem_318756.mem;
                    CUdeviceptr kernel_arg_326807 = ext_mem_318757.mem;
                    CUdeviceptr kernel_arg_326808 = mem_param_318838.mem;
                    CUdeviceptr kernel_arg_326809 = mem_319555.mem;
                    CUdeviceptr kernel_arg_326810 = mem_319564.mem;
                    
                    if ((((((1 && segmap_usable_groups_309284 != 0) && 1 !=
                            0) && 1 != 0) && segmap_group_sizze_309283 != 0) &&
                         1 != 0) && 1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = segmap_usable_groups_309284;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_326803[] = {&ctx->global_failure,
                                                      &n_292675, &q_l_292680,
                                                      &jump_t_292685,
                                                      &partition_sizze_292766,
                                                      &l_n_m_292832, &i_292846,
                                                      &ctx_param_ext_318833,
                                                      &ctx_param_ext_318834,
                                                      &ctx_param_ext_318836,
                                                      &kernel_arg_326806,
                                                      &kernel_arg_326807,
                                                      &kernel_arg_326808,
                                                      &kernel_arg_326809,
                                                      &kernel_arg_326810};
                        int64_t time_start_326804 = 0, time_end_326805 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segmap_309288",
                                    (long) segmap_usable_groups_309284,
                                    (long) 1, (long) 1,
                                    (long) segmap_group_sizze_309283, (long) 1,
                                    (long) 1, (int) 0);
                            time_start_326804 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegmap_309288_runs,
                                                      &ctx->mainzisegmap_309288_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_309288,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segmap_group_sizze_309283,
                                                              1, 1, 0, NULL,
                                                              kernel_args_326803,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_326805 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segmap_309288", time_end_326805 -
                                    time_start_326804);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                    if (memblock_set_device(ctx, &ext_mem_319586, &mem_319564,
                                            "mem_319564") != 0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_319585, &mem_319559,
                                            "mem_319559") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319564, "mem_319564") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319559, "mem_319559") !=
                        0)
                        return 1;
                } else {
                    bool match_lit_294875 = (int64_t) 1 == d_l_292683;
                    struct memblock_device ext_mem_319584;
                    
                    ext_mem_319584.references = NULL;
                    
                    struct memblock_device ext_mem_319583;
                    
                    ext_mem_319583.references = NULL;
                    if (match_lit_294875) {
                        int64_t segmap_group_sizze_309465;
                        
                        segmap_group_sizze_309465 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_309354;
                        
                        int64_t segmap_usable_groups_309466 =
                                sdiv_up64(nest_sizze_300244,
                                          segmap_group_sizze_309465);
                        struct memblock_device mem_319569;
                        
                        mem_319569.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319569,
                                                  bytes_318723, "mem_319569")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock_device mem_319573;
                        
                        mem_319573.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319573,
                                                  bytes_318723, "mem_319573")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_326814 = ext_mem_318756.mem;
                        CUdeviceptr kernel_arg_326815 = ext_mem_318757.mem;
                        CUdeviceptr kernel_arg_326816 = mem_param_318838.mem;
                        CUdeviceptr kernel_arg_326817 = mem_319555.mem;
                        CUdeviceptr kernel_arg_326818 = mem_319569.mem;
                        CUdeviceptr kernel_arg_326819 = mem_319573.mem;
                        
                        if ((((((1 && segmap_usable_groups_309466 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_309465 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_309466;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_326811[] = {&ctx->global_failure,
                                                          &n_292675,
                                                          &q_l_292680,
                                                          &jump_t_292685,
                                                          &partition_sizze_292766,
                                                          &l_n_m_292832,
                                                          &i_292846,
                                                          &ctx_param_ext_318833,
                                                          &ctx_param_ext_318834,
                                                          &ctx_param_ext_318836,
                                                          &kernel_arg_326814,
                                                          &kernel_arg_326815,
                                                          &kernel_arg_326816,
                                                          &kernel_arg_326817,
                                                          &kernel_arg_326818,
                                                          &kernel_arg_326819};
                            int64_t time_start_326812 = 0, time_end_326813 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_309471",
                                        (long) segmap_usable_groups_309466,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_309465,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_326812 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_309471_runs,
                                                          &ctx->mainzisegmap_309471_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_309471,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_309465,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_326811,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_326813 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_309471", time_end_326813 -
                                        time_start_326812);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_set_device(ctx, &ext_mem_319584,
                                                &mem_319569, "mem_319569") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319583,
                                                &mem_319573, "mem_319573") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319573,
                                                  "mem_319573") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319569,
                                                  "mem_319569") != 0)
                            return 1;
                    } else {
                        int64_t segmap_group_sizze_309713;
                        
                        segmap_group_sizze_309713 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_309568;
                        
                        int64_t segmap_usable_groups_309714 =
                                sdiv_up64(nest_sizze_300244,
                                          segmap_group_sizze_309713);
                        struct memblock_device mem_319578;
                        
                        mem_319578.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319578,
                                                  bytes_318723, "mem_319578")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock_device mem_319582;
                        
                        mem_319582.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319582,
                                                  bytes_318723, "mem_319582")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_326823 = ext_mem_318756.mem;
                        CUdeviceptr kernel_arg_326824 = ext_mem_318757.mem;
                        CUdeviceptr kernel_arg_326825 = mem_param_318838.mem;
                        CUdeviceptr kernel_arg_326826 = mem_319555.mem;
                        CUdeviceptr kernel_arg_326827 = mem_319578.mem;
                        CUdeviceptr kernel_arg_326828 = mem_319582.mem;
                        
                        if ((((((1 && segmap_usable_groups_309714 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_309713 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_309714;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_326820[] = {&ctx->global_failure,
                                                          &n_292675,
                                                          &q_l_292680,
                                                          &jump_t_292685,
                                                          &partition_sizze_292766,
                                                          &l_n_m_292832,
                                                          &i_292846,
                                                          &ctx_param_ext_318833,
                                                          &ctx_param_ext_318834,
                                                          &ctx_param_ext_318836,
                                                          &kernel_arg_326823,
                                                          &kernel_arg_326824,
                                                          &kernel_arg_326825,
                                                          &kernel_arg_326826,
                                                          &kernel_arg_326827,
                                                          &kernel_arg_326828};
                            int64_t time_start_326821 = 0, time_end_326822 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_309719",
                                        (long) segmap_usable_groups_309714,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_309713,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_326821 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_309719_runs,
                                                          &ctx->mainzisegmap_309719_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_309719,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_309713,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_326820,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_326822 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_309719", time_end_326822 -
                                        time_start_326821);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_set_device(ctx, &ext_mem_319584,
                                                &mem_319578, "mem_319578") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319583,
                                                &mem_319582, "mem_319582") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319582,
                                                  "mem_319582") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319578,
                                                  "mem_319578") != 0)
                            return 1;
                    }
                    if (memblock_set_device(ctx, &ext_mem_319586,
                                            &ext_mem_319584,
                                            "ext_mem_319584") != 0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_319585,
                                            &ext_mem_319583,
                                            "ext_mem_319583") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319583,
                                              "ext_mem_319583") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319584,
                                              "ext_mem_319584") != 0)
                        return 1;
                }
                if (memblock_set_device(ctx, &ext_mem_319758, &ext_mem_319586,
                                        "ext_mem_319586") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_319757, &ext_mem_319585,
                                        "ext_mem_319585") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_319585,
                                          "ext_mem_319585") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_319586,
                                          "ext_mem_319586") != 0)
                    return 1;
            } else {
                bool cond_295112 = sle64(jump_threshold_2_292690,
                                         jump_l_292686);
                bool cond_t_res_295113 = slt64(q_l_292680,
                                               q_threshold_1_292691);
                bool x_295114 = cond_295112 && cond_t_res_295113;
                struct memblock_device ext_mem_319756;
                
                ext_mem_319756.references = NULL;
                
                struct memblock_device ext_mem_319755;
                
                ext_mem_319755.references = NULL;
                if (x_295114) {
                    bool match_lit_295117 = (int64_t) 0 == d_l_292683;
                    int64_t binop_y_319593 = (int64_t) 8 * q_l_292680;
                    int64_t bytes_319594 = smax64((int64_t) 0, binop_y_319593);
                    struct memblock_device ext_mem_319645;
                    
                    ext_mem_319645.references = NULL;
                    
                    struct memblock_device ext_mem_319644;
                    
                    ext_mem_319644.references = NULL;
                    if (match_lit_295117) {
                        struct memblock_device mem_319590;
                        
                        mem_319590.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319590,
                                                  bytes_318723, "mem_319590")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (futrts_builtinzhreplicate_f64(ctx, mem_319590,
                                                          partition_sizze_292766 *
                                                          l_n_m_292832, 0.0) !=
                            0) {
                            if (memblock_unref_device(ctx, &mem_319590,
                                                      "mem_319590") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319644,
                                                      "ext_mem_319644") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319645,
                                                      "ext_mem_319645") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319755,
                                                      "ext_mem_319755") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319756,
                                                      "ext_mem_319756") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319757,
                                                      "ext_mem_319757") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319758,
                                                      "ext_mem_319758") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319550,
                                                      "ext_mem_319550") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319533,
                                                      "ext_mem_319533") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319516,
                                                      "ext_mem_319516") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319498,
                                                      "ext_mem_319498") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319490,
                                                      "ext_mem_319490") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319491,
                                                      "ext_mem_319491") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318860,
                                                      "mem_param_318860") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318852,
                                                      "mem_param_318852") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320111,
                                                      "ext_mem_320111") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320112,
                                                      "ext_mem_320112") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318838,
                                                      "mem_param_318838") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318830,
                                                      "mem_param_318830") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318822,
                                                      "mem_param_318822") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320430,
                                                      "ext_mem_320430") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320431,
                                                      "ext_mem_320431") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320432,
                                                      "ext_mem_320432") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319555,
                                                      "mem_319555") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319538,
                                                      "mem_319538") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319521,
                                                      "mem_319521") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319504,
                                                      "mem_319504") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318876,
                                                      "mem_318876") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318871,
                                                      "mem_318871") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318865,
                                                      "mem_318865") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318814,
                                                      "mem_318814") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318810,
                                                      "mem_318810") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318805,
                                                      "ext_mem_318805") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318806,
                                                      "ext_mem_318806") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318756,
                                                      "ext_mem_318756") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318757,
                                                      "ext_mem_318757") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318707,
                                                      "ext_mem_318707") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318708,
                                                      "ext_mem_318708") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318609,
                                                      "ext_mem_318609") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318610,
                                                      "ext_mem_318610") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318551,
                                                      "mem_318551") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318545,
                                                      "mem_318545") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318541,
                                                      "ext_mem_318541") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318542,
                                                      "ext_mem_318542") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318509,
                                                      "mem_318509") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318506,
                                                      "mem_318506") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318502,
                                                      "mem_318502") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318500,
                                                      "mem_318500") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318497,
                                                      "mem_318497") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318493,
                                                      "mem_318493") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320825,
                                                      "mem_out_320825") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320824,
                                                      "mem_out_320824") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320823,
                                                      "mem_out_320823") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock_device mem_319600;
                        
                        mem_319600.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319600,
                                                  bytes_318723, "mem_319600")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        int32_t num_chunks_323392 =
                                sext_i64_i32(sdiv_up64(q_l_292680, q_l_292680));
                        unsigned int shared_sizze_326832 = (int64_t) 8 *
                                     q_l_292680;
                        unsigned int shared_sizze_326834 = (int64_t) 8 *
                                     q_l_292680;
                        unsigned int shared_sizze_326836 = bytes_319594;
                        CUdeviceptr kernel_arg_326838 = ext_mem_318756.mem;
                        CUdeviceptr kernel_arg_326839 = ext_mem_318757.mem;
                        CUdeviceptr kernel_arg_326840 = mem_param_318838.mem;
                        CUdeviceptr kernel_arg_326841 = mem_319555.mem;
                        CUdeviceptr kernel_arg_326842 = mem_319600.mem;
                        unsigned int shared_offset_326833 = 0;
                        unsigned int shared_offset_326835 = 0 +
                                     (shared_sizze_326832 + (8 -
                                                             shared_sizze_326832 %
                                                             8) % 8);
                        unsigned int shared_offset_326837 = 0 +
                                     (shared_sizze_326832 + (8 -
                                                             shared_sizze_326832 %
                                                             8) % 8) +
                                     (shared_sizze_326834 + (8 -
                                                             shared_sizze_326834 %
                                                             8) % 8);
                        
                        if ((((((1 && nest_sizze_300244 != 0) && 1 != 0) && 1 !=
                               0) && q_l_292680 != 0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = nest_sizze_300244;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_326829[] = {&ctx->global_failure,
                                                          &shared_offset_326833,
                                                          &shared_offset_326835,
                                                          &shared_offset_326837,
                                                          &n_292675,
                                                          &q_l_292680,
                                                          &jump_t_292685,
                                                          &partition_sizze_292766,
                                                          &l_n_m_292832,
                                                          &i_292846,
                                                          &ctx_param_ext_318833,
                                                          &ctx_param_ext_318834,
                                                          &ctx_param_ext_318836,
                                                          &kernel_arg_326838,
                                                          &kernel_arg_326839,
                                                          &kernel_arg_326840,
                                                          &kernel_arg_326841,
                                                          &kernel_arg_326842};
                            int64_t time_start_326830 = 0, time_end_326831 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_intragroup_309930",
                                        (long) nest_sizze_300244, (long) 1,
                                        (long) 1, (long) q_l_292680, (long) 1,
                                        (long) 1, (int) (0 +
                                                         (shared_sizze_326832 +
                                                          (8 -
                                                           shared_sizze_326832 %
                                                           8) % 8) +
                                                         (shared_sizze_326834 +
                                                          (8 -
                                                           shared_sizze_326834 %
                                                           8) % 8) +
                                                         (shared_sizze_326836 +
                                                          (8 -
                                                           shared_sizze_326836 %
                                                           8) % 8)));
                                time_start_326830 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_intragroup_309930_runs,
                                                          &ctx->mainzisegmap_intragroup_309930_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_309930,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  q_l_292680, 1,
                                                                  1, 0 +
                                                                  (shared_sizze_326832 +
                                                                   (8 -
                                                                    shared_sizze_326832 %
                                                                    8) % 8) +
                                                                  (shared_sizze_326834 +
                                                                   (8 -
                                                                    shared_sizze_326834 %
                                                                    8) % 8) +
                                                                  (shared_sizze_326836 +
                                                                   (8 -
                                                                    shared_sizze_326836 %
                                                                    8) % 8),
                                                                  NULL,
                                                                  kernel_args_326829,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_326831 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_intragroup_309930",
                                        time_end_326831 - time_start_326830);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_set_device(ctx, &ext_mem_319645,
                                                &mem_319600, "mem_319600") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319644,
                                                &mem_319590, "mem_319590") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319600,
                                                  "mem_319600") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319590,
                                                  "mem_319590") != 0)
                            return 1;
                    } else {
                        bool match_lit_295175 = (int64_t) 1 == d_l_292683;
                        struct memblock_device ext_mem_319643;
                        
                        ext_mem_319643.references = NULL;
                        
                        struct memblock_device ext_mem_319642;
                        
                        ext_mem_319642.references = NULL;
                        if (match_lit_295175) {
                            struct memblock_device mem_319613;
                            
                            mem_319613.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319613,
                                                      bytes_318723,
                                                      "mem_319613")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319617;
                            
                            mem_319617.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319617,
                                                      bytes_318723,
                                                      "mem_319617")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            int32_t num_chunks_323413 =
                                    sext_i64_i32(sdiv_up64(q_l_292680,
                                                           q_l_292680));
                            unsigned int shared_sizze_326846 = (int64_t) 8 *
                                         q_l_292680;
                            unsigned int shared_sizze_326848 = (int64_t) 8 *
                                         q_l_292680;
                            unsigned int shared_sizze_326850 = (int64_t) 8 *
                                         q_l_292680;
                            unsigned int shared_sizze_326852 = (int64_t) 8 *
                                         q_l_292680;
                            unsigned int shared_sizze_326854 = (int64_t) 8 *
                                         q_l_292680;
                            unsigned int shared_sizze_326856 = bytes_319594;
                            unsigned int shared_sizze_326858 = bytes_319594;
                            CUdeviceptr kernel_arg_326860 = ext_mem_318756.mem;
                            CUdeviceptr kernel_arg_326861 = ext_mem_318757.mem;
                            CUdeviceptr kernel_arg_326862 =
                                        mem_param_318838.mem;
                            CUdeviceptr kernel_arg_326863 = mem_319555.mem;
                            CUdeviceptr kernel_arg_326864 = mem_319613.mem;
                            CUdeviceptr kernel_arg_326865 = mem_319617.mem;
                            unsigned int shared_offset_326847 = 0;
                            unsigned int shared_offset_326849 = 0 +
                                         (shared_sizze_326846 + (8 -
                                                                 shared_sizze_326846 %
                                                                 8) % 8);
                            unsigned int shared_offset_326851 = 0 +
                                         (shared_sizze_326846 + (8 -
                                                                 shared_sizze_326846 %
                                                                 8) % 8) +
                                         (shared_sizze_326848 + (8 -
                                                                 shared_sizze_326848 %
                                                                 8) % 8);
                            unsigned int shared_offset_326853 = 0 +
                                         (shared_sizze_326846 + (8 -
                                                                 shared_sizze_326846 %
                                                                 8) % 8) +
                                         (shared_sizze_326848 + (8 -
                                                                 shared_sizze_326848 %
                                                                 8) % 8) +
                                         (shared_sizze_326850 + (8 -
                                                                 shared_sizze_326850 %
                                                                 8) % 8);
                            unsigned int shared_offset_326855 = 0 +
                                         (shared_sizze_326846 + (8 -
                                                                 shared_sizze_326846 %
                                                                 8) % 8) +
                                         (shared_sizze_326848 + (8 -
                                                                 shared_sizze_326848 %
                                                                 8) % 8) +
                                         (shared_sizze_326850 + (8 -
                                                                 shared_sizze_326850 %
                                                                 8) % 8) +
                                         (shared_sizze_326852 + (8 -
                                                                 shared_sizze_326852 %
                                                                 8) % 8);
                            unsigned int shared_offset_326857 = 0 +
                                         (shared_sizze_326846 + (8 -
                                                                 shared_sizze_326846 %
                                                                 8) % 8) +
                                         (shared_sizze_326848 + (8 -
                                                                 shared_sizze_326848 %
                                                                 8) % 8) +
                                         (shared_sizze_326850 + (8 -
                                                                 shared_sizze_326850 %
                                                                 8) % 8) +
                                         (shared_sizze_326852 + (8 -
                                                                 shared_sizze_326852 %
                                                                 8) % 8) +
                                         (shared_sizze_326854 + (8 -
                                                                 shared_sizze_326854 %
                                                                 8) % 8);
                            unsigned int shared_offset_326859 = 0 +
                                         (shared_sizze_326846 + (8 -
                                                                 shared_sizze_326846 %
                                                                 8) % 8) +
                                         (shared_sizze_326848 + (8 -
                                                                 shared_sizze_326848 %
                                                                 8) % 8) +
                                         (shared_sizze_326850 + (8 -
                                                                 shared_sizze_326850 %
                                                                 8) % 8) +
                                         (shared_sizze_326852 + (8 -
                                                                 shared_sizze_326852 %
                                                                 8) % 8) +
                                         (shared_sizze_326854 + (8 -
                                                                 shared_sizze_326854 %
                                                                 8) % 8) +
                                         (shared_sizze_326856 + (8 -
                                                                 shared_sizze_326856 %
                                                                 8) % 8);
                            
                            if ((((((1 && nest_sizze_300244 != 0) && 1 != 0) &&
                                   1 != 0) && q_l_292680 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = nest_sizze_300244;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_326843[] =
                                     {&ctx->global_failure,
                                      &shared_offset_326847,
                                      &shared_offset_326849,
                                      &shared_offset_326851,
                                      &shared_offset_326853,
                                      &shared_offset_326855,
                                      &shared_offset_326857,
                                      &shared_offset_326859, &n_292675,
                                      &q_l_292680, &jump_t_292685,
                                      &partition_sizze_292766, &l_n_m_292832,
                                      &i_292846, &ctx_param_ext_318833,
                                      &ctx_param_ext_318834,
                                      &ctx_param_ext_318836, &kernel_arg_326860,
                                      &kernel_arg_326861, &kernel_arg_326862,
                                      &kernel_arg_326863, &kernel_arg_326864,
                                      &kernel_arg_326865};
                                int64_t time_start_326844 = 0, time_end_326845 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_intragroup_310101",
                                            (long) nest_sizze_300244, (long) 1,
                                            (long) 1, (long) q_l_292680,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_326846 +
                                                                        (8 -
                                                                         shared_sizze_326846 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326848 +
                                                                        (8 -
                                                                         shared_sizze_326848 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326850 +
                                                                        (8 -
                                                                         shared_sizze_326850 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326852 +
                                                                        (8 -
                                                                         shared_sizze_326852 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326854 +
                                                                        (8 -
                                                                         shared_sizze_326854 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326856 +
                                                                        (8 -
                                                                         shared_sizze_326856 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326858 +
                                                                        (8 -
                                                                         shared_sizze_326858 %
                                                                         8) %
                                                                        8)));
                                    time_start_326844 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_intragroup_310101_runs,
                                                              &ctx->mainzisegmap_intragroup_310101_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_310101,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      q_l_292680,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_326846 +
                                                                       (8 -
                                                                        shared_sizze_326846 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326848 +
                                                                       (8 -
                                                                        shared_sizze_326848 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326850 +
                                                                       (8 -
                                                                        shared_sizze_326850 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326852 +
                                                                       (8 -
                                                                        shared_sizze_326852 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326854 +
                                                                       (8 -
                                                                        shared_sizze_326854 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326856 +
                                                                       (8 -
                                                                        shared_sizze_326856 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326858 +
                                                                       (8 -
                                                                        shared_sizze_326858 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_326843,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_326845 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_intragroup_310101",
                                            time_end_326845 -
                                            time_start_326844);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_set_device(ctx, &ext_mem_319643,
                                                    &mem_319613,
                                                    "mem_319613") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319642,
                                                    &mem_319617,
                                                    "mem_319617") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319617,
                                                      "mem_319617") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319613,
                                                      "mem_319613") != 0)
                                return 1;
                        } else {
                            struct memblock_device mem_319637;
                            
                            mem_319637.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319637,
                                                      bytes_318723,
                                                      "mem_319637")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319641;
                            
                            mem_319641.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319641,
                                                      bytes_318723,
                                                      "mem_319641")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            int32_t num_chunks_323440 =
                                    sext_i64_i32(sdiv_up64(q_l_292680,
                                                           q_l_292680));
                            unsigned int shared_sizze_326869 = (int64_t) 8 *
                                         q_l_292680;
                            unsigned int shared_sizze_326871 = (int64_t) 8 *
                                         q_l_292680;
                            unsigned int shared_sizze_326873 = (int64_t) 8 *
                                         q_l_292680;
                            unsigned int shared_sizze_326875 = (int64_t) 8 *
                                         q_l_292680;
                            unsigned int shared_sizze_326877 = (int64_t) 8 *
                                         q_l_292680;
                            unsigned int shared_sizze_326879 = (int64_t) 8 *
                                         q_l_292680;
                            unsigned int shared_sizze_326881 = (int64_t) 8 *
                                         q_l_292680;
                            unsigned int shared_sizze_326883 = bytes_319594;
                            unsigned int shared_sizze_326885 = bytes_319594;
                            unsigned int shared_sizze_326887 = bytes_319594;
                            unsigned int shared_sizze_326889 = bytes_319594;
                            CUdeviceptr kernel_arg_326891 = ext_mem_318756.mem;
                            CUdeviceptr kernel_arg_326892 = ext_mem_318757.mem;
                            CUdeviceptr kernel_arg_326893 =
                                        mem_param_318838.mem;
                            CUdeviceptr kernel_arg_326894 = mem_319555.mem;
                            CUdeviceptr kernel_arg_326895 = mem_319637.mem;
                            CUdeviceptr kernel_arg_326896 = mem_319641.mem;
                            unsigned int shared_offset_326870 = 0;
                            unsigned int shared_offset_326872 = 0 +
                                         (shared_sizze_326869 + (8 -
                                                                 shared_sizze_326869 %
                                                                 8) % 8);
                            unsigned int shared_offset_326874 = 0 +
                                         (shared_sizze_326869 + (8 -
                                                                 shared_sizze_326869 %
                                                                 8) % 8) +
                                         (shared_sizze_326871 + (8 -
                                                                 shared_sizze_326871 %
                                                                 8) % 8);
                            unsigned int shared_offset_326876 = 0 +
                                         (shared_sizze_326869 + (8 -
                                                                 shared_sizze_326869 %
                                                                 8) % 8) +
                                         (shared_sizze_326871 + (8 -
                                                                 shared_sizze_326871 %
                                                                 8) % 8) +
                                         (shared_sizze_326873 + (8 -
                                                                 shared_sizze_326873 %
                                                                 8) % 8);
                            unsigned int shared_offset_326878 = 0 +
                                         (shared_sizze_326869 + (8 -
                                                                 shared_sizze_326869 %
                                                                 8) % 8) +
                                         (shared_sizze_326871 + (8 -
                                                                 shared_sizze_326871 %
                                                                 8) % 8) +
                                         (shared_sizze_326873 + (8 -
                                                                 shared_sizze_326873 %
                                                                 8) % 8) +
                                         (shared_sizze_326875 + (8 -
                                                                 shared_sizze_326875 %
                                                                 8) % 8);
                            unsigned int shared_offset_326880 = 0 +
                                         (shared_sizze_326869 + (8 -
                                                                 shared_sizze_326869 %
                                                                 8) % 8) +
                                         (shared_sizze_326871 + (8 -
                                                                 shared_sizze_326871 %
                                                                 8) % 8) +
                                         (shared_sizze_326873 + (8 -
                                                                 shared_sizze_326873 %
                                                                 8) % 8) +
                                         (shared_sizze_326875 + (8 -
                                                                 shared_sizze_326875 %
                                                                 8) % 8) +
                                         (shared_sizze_326877 + (8 -
                                                                 shared_sizze_326877 %
                                                                 8) % 8);
                            unsigned int shared_offset_326882 = 0 +
                                         (shared_sizze_326869 + (8 -
                                                                 shared_sizze_326869 %
                                                                 8) % 8) +
                                         (shared_sizze_326871 + (8 -
                                                                 shared_sizze_326871 %
                                                                 8) % 8) +
                                         (shared_sizze_326873 + (8 -
                                                                 shared_sizze_326873 %
                                                                 8) % 8) +
                                         (shared_sizze_326875 + (8 -
                                                                 shared_sizze_326875 %
                                                                 8) % 8) +
                                         (shared_sizze_326877 + (8 -
                                                                 shared_sizze_326877 %
                                                                 8) % 8) +
                                         (shared_sizze_326879 + (8 -
                                                                 shared_sizze_326879 %
                                                                 8) % 8);
                            unsigned int shared_offset_326884 = 0 +
                                         (shared_sizze_326869 + (8 -
                                                                 shared_sizze_326869 %
                                                                 8) % 8) +
                                         (shared_sizze_326871 + (8 -
                                                                 shared_sizze_326871 %
                                                                 8) % 8) +
                                         (shared_sizze_326873 + (8 -
                                                                 shared_sizze_326873 %
                                                                 8) % 8) +
                                         (shared_sizze_326875 + (8 -
                                                                 shared_sizze_326875 %
                                                                 8) % 8) +
                                         (shared_sizze_326877 + (8 -
                                                                 shared_sizze_326877 %
                                                                 8) % 8) +
                                         (shared_sizze_326879 + (8 -
                                                                 shared_sizze_326879 %
                                                                 8) % 8) +
                                         (shared_sizze_326881 + (8 -
                                                                 shared_sizze_326881 %
                                                                 8) % 8);
                            unsigned int shared_offset_326886 = 0 +
                                         (shared_sizze_326869 + (8 -
                                                                 shared_sizze_326869 %
                                                                 8) % 8) +
                                         (shared_sizze_326871 + (8 -
                                                                 shared_sizze_326871 %
                                                                 8) % 8) +
                                         (shared_sizze_326873 + (8 -
                                                                 shared_sizze_326873 %
                                                                 8) % 8) +
                                         (shared_sizze_326875 + (8 -
                                                                 shared_sizze_326875 %
                                                                 8) % 8) +
                                         (shared_sizze_326877 + (8 -
                                                                 shared_sizze_326877 %
                                                                 8) % 8) +
                                         (shared_sizze_326879 + (8 -
                                                                 shared_sizze_326879 %
                                                                 8) % 8) +
                                         (shared_sizze_326881 + (8 -
                                                                 shared_sizze_326881 %
                                                                 8) % 8) +
                                         (shared_sizze_326883 + (8 -
                                                                 shared_sizze_326883 %
                                                                 8) % 8);
                            unsigned int shared_offset_326888 = 0 +
                                         (shared_sizze_326869 + (8 -
                                                                 shared_sizze_326869 %
                                                                 8) % 8) +
                                         (shared_sizze_326871 + (8 -
                                                                 shared_sizze_326871 %
                                                                 8) % 8) +
                                         (shared_sizze_326873 + (8 -
                                                                 shared_sizze_326873 %
                                                                 8) % 8) +
                                         (shared_sizze_326875 + (8 -
                                                                 shared_sizze_326875 %
                                                                 8) % 8) +
                                         (shared_sizze_326877 + (8 -
                                                                 shared_sizze_326877 %
                                                                 8) % 8) +
                                         (shared_sizze_326879 + (8 -
                                                                 shared_sizze_326879 %
                                                                 8) % 8) +
                                         (shared_sizze_326881 + (8 -
                                                                 shared_sizze_326881 %
                                                                 8) % 8) +
                                         (shared_sizze_326883 + (8 -
                                                                 shared_sizze_326883 %
                                                                 8) % 8) +
                                         (shared_sizze_326885 + (8 -
                                                                 shared_sizze_326885 %
                                                                 8) % 8);
                            unsigned int shared_offset_326890 = 0 +
                                         (shared_sizze_326869 + (8 -
                                                                 shared_sizze_326869 %
                                                                 8) % 8) +
                                         (shared_sizze_326871 + (8 -
                                                                 shared_sizze_326871 %
                                                                 8) % 8) +
                                         (shared_sizze_326873 + (8 -
                                                                 shared_sizze_326873 %
                                                                 8) % 8) +
                                         (shared_sizze_326875 + (8 -
                                                                 shared_sizze_326875 %
                                                                 8) % 8) +
                                         (shared_sizze_326877 + (8 -
                                                                 shared_sizze_326877 %
                                                                 8) % 8) +
                                         (shared_sizze_326879 + (8 -
                                                                 shared_sizze_326879 %
                                                                 8) % 8) +
                                         (shared_sizze_326881 + (8 -
                                                                 shared_sizze_326881 %
                                                                 8) % 8) +
                                         (shared_sizze_326883 + (8 -
                                                                 shared_sizze_326883 %
                                                                 8) % 8) +
                                         (shared_sizze_326885 + (8 -
                                                                 shared_sizze_326885 %
                                                                 8) % 8) +
                                         (shared_sizze_326887 + (8 -
                                                                 shared_sizze_326887 %
                                                                 8) % 8);
                            
                            if ((((((1 && nest_sizze_300244 != 0) && 1 != 0) &&
                                   1 != 0) && q_l_292680 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = nest_sizze_300244;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_326866[] =
                                     {&ctx->global_failure,
                                      &shared_offset_326870,
                                      &shared_offset_326872,
                                      &shared_offset_326874,
                                      &shared_offset_326876,
                                      &shared_offset_326878,
                                      &shared_offset_326880,
                                      &shared_offset_326882,
                                      &shared_offset_326884,
                                      &shared_offset_326886,
                                      &shared_offset_326888,
                                      &shared_offset_326890, &n_292675,
                                      &q_l_292680, &jump_t_292685,
                                      &partition_sizze_292766, &l_n_m_292832,
                                      &i_292846, &ctx_param_ext_318833,
                                      &ctx_param_ext_318834,
                                      &ctx_param_ext_318836, &kernel_arg_326891,
                                      &kernel_arg_326892, &kernel_arg_326893,
                                      &kernel_arg_326894, &kernel_arg_326895,
                                      &kernel_arg_326896};
                                int64_t time_start_326867 = 0, time_end_326868 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_intragroup_310366",
                                            (long) nest_sizze_300244, (long) 1,
                                            (long) 1, (long) q_l_292680,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_326869 +
                                                                        (8 -
                                                                         shared_sizze_326869 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326871 +
                                                                        (8 -
                                                                         shared_sizze_326871 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326873 +
                                                                        (8 -
                                                                         shared_sizze_326873 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326875 +
                                                                        (8 -
                                                                         shared_sizze_326875 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326877 +
                                                                        (8 -
                                                                         shared_sizze_326877 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326879 +
                                                                        (8 -
                                                                         shared_sizze_326879 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326881 +
                                                                        (8 -
                                                                         shared_sizze_326881 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326883 +
                                                                        (8 -
                                                                         shared_sizze_326883 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326885 +
                                                                        (8 -
                                                                         shared_sizze_326885 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326887 +
                                                                        (8 -
                                                                         shared_sizze_326887 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326889 +
                                                                        (8 -
                                                                         shared_sizze_326889 %
                                                                         8) %
                                                                        8)));
                                    time_start_326867 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_intragroup_310366_runs,
                                                              &ctx->mainzisegmap_intragroup_310366_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_310366,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      q_l_292680,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_326869 +
                                                                       (8 -
                                                                        shared_sizze_326869 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326871 +
                                                                       (8 -
                                                                        shared_sizze_326871 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326873 +
                                                                       (8 -
                                                                        shared_sizze_326873 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326875 +
                                                                       (8 -
                                                                        shared_sizze_326875 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326877 +
                                                                       (8 -
                                                                        shared_sizze_326877 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326879 +
                                                                       (8 -
                                                                        shared_sizze_326879 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326881 +
                                                                       (8 -
                                                                        shared_sizze_326881 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326883 +
                                                                       (8 -
                                                                        shared_sizze_326883 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326885 +
                                                                       (8 -
                                                                        shared_sizze_326885 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326887 +
                                                                       (8 -
                                                                        shared_sizze_326887 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326889 +
                                                                       (8 -
                                                                        shared_sizze_326889 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_326866,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_326868 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_intragroup_310366",
                                            time_end_326868 -
                                            time_start_326867);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_set_device(ctx, &ext_mem_319643,
                                                    &mem_319637,
                                                    "mem_319637") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319642,
                                                    &mem_319641,
                                                    "mem_319641") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319641,
                                                      "mem_319641") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319637,
                                                      "mem_319637") != 0)
                                return 1;
                        }
                        if (memblock_set_device(ctx, &ext_mem_319645,
                                                &ext_mem_319643,
                                                "ext_mem_319643") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319644,
                                                &ext_mem_319642,
                                                "ext_mem_319642") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319642,
                                                  "ext_mem_319642") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319643,
                                                  "ext_mem_319643") != 0)
                            return 1;
                    }
                    if (memblock_set_device(ctx, &ext_mem_319756,
                                            &ext_mem_319645,
                                            "ext_mem_319645") != 0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_319755,
                                            &ext_mem_319644,
                                            "ext_mem_319644") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319644,
                                              "ext_mem_319644") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319645,
                                              "ext_mem_319645") != 0)
                        return 1;
                } else {
                    bool match_lit_295430 = (int64_t) 0 == d_l_292683;
                    struct memblock_device ext_mem_319754;
                    
                    ext_mem_319754.references = NULL;
                    
                    struct memblock_device ext_mem_319753;
                    
                    ext_mem_319753.references = NULL;
                    if (match_lit_295430) {
                        struct memblock_device mem_319649;
                        
                        mem_319649.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319649,
                                                  bytes_318723, "mem_319649")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (futrts_builtinzhreplicate_f64(ctx, mem_319649,
                                                          partition_sizze_292766 *
                                                          l_n_m_292832, 0.0) !=
                            0) {
                            if (memblock_unref_device(ctx, &mem_319649,
                                                      "mem_319649") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319753,
                                                      "ext_mem_319753") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319754,
                                                      "ext_mem_319754") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319755,
                                                      "ext_mem_319755") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319756,
                                                      "ext_mem_319756") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319757,
                                                      "ext_mem_319757") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319758,
                                                      "ext_mem_319758") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319550,
                                                      "ext_mem_319550") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319533,
                                                      "ext_mem_319533") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319516,
                                                      "ext_mem_319516") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319498,
                                                      "ext_mem_319498") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319490,
                                                      "ext_mem_319490") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319491,
                                                      "ext_mem_319491") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318860,
                                                      "mem_param_318860") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318852,
                                                      "mem_param_318852") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320111,
                                                      "ext_mem_320111") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320112,
                                                      "ext_mem_320112") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318838,
                                                      "mem_param_318838") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318830,
                                                      "mem_param_318830") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318822,
                                                      "mem_param_318822") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320430,
                                                      "ext_mem_320430") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320431,
                                                      "ext_mem_320431") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320432,
                                                      "ext_mem_320432") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319555,
                                                      "mem_319555") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319538,
                                                      "mem_319538") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319521,
                                                      "mem_319521") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319504,
                                                      "mem_319504") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318876,
                                                      "mem_318876") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318871,
                                                      "mem_318871") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318865,
                                                      "mem_318865") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318814,
                                                      "mem_318814") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318810,
                                                      "mem_318810") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318805,
                                                      "ext_mem_318805") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318806,
                                                      "ext_mem_318806") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318756,
                                                      "ext_mem_318756") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318757,
                                                      "ext_mem_318757") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318707,
                                                      "ext_mem_318707") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318708,
                                                      "ext_mem_318708") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318609,
                                                      "ext_mem_318609") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318610,
                                                      "ext_mem_318610") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318551,
                                                      "mem_318551") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318545,
                                                      "mem_318545") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318541,
                                                      "ext_mem_318541") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318542,
                                                      "ext_mem_318542") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318509,
                                                      "mem_318509") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318506,
                                                      "mem_318506") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318502,
                                                      "mem_318502") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318500,
                                                      "mem_318500") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318497,
                                                      "mem_318497") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318493,
                                                      "mem_318493") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320825,
                                                      "mem_out_320825") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320824,
                                                      "mem_out_320824") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320823,
                                                      "mem_out_320823") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t nest_sizze_310757 = q_l_292680 *
                                nest_sizze_300244;
                        int64_t segred_group_sizze_310758;
                        
                        segred_group_sizze_310758 =
                            *ctx->tuning_params.mainzisegred_group_sizze_310576;
                        
                        int64_t num_groups_310759;
                        int32_t max_num_groups_323471;
                        
                        max_num_groups_323471 =
                            *ctx->tuning_params.mainzisegred_num_groups_310578;
                        num_groups_310759 = sext_i64_i32(smax64((int64_t) 1,
                                                                smin64(sdiv_up64(nest_sizze_310757,
                                                                                 segred_group_sizze_310758),
                                                                       sext_i32_i64(max_num_groups_323471))));
                        
                        struct memblock_device mem_319654;
                        
                        mem_319654.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319654,
                                                  bytes_318723, "mem_319654")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (slt64(q_l_292680 * (int64_t) 2,
                                  segred_group_sizze_310758)) {
                            int64_t segment_sizze_nonzzero_323472 =
                                    smax64((int64_t) 1, q_l_292680);
                            int64_t num_threads_323473 = num_groups_310759 *
                                    segred_group_sizze_310758;
                            
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegRed-small");
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                        (long long) (partition_sizze_292766 *
                                                     l_n_m_292832), '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                        (long long) q_l_292680, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "segments_per_group",
                                        (long long) squot64(segred_group_sizze_310758,
                                                            segment_sizze_nonzzero_323472),
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "required_groups",
                                        (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                           l_n_m_292832,
                                                                           squot64(segred_group_sizze_310758,
                                                                                   segment_sizze_nonzzero_323472))),
                                        '\n');
                            
                            unsigned int shared_sizze_326900 = (int64_t) 8 *
                                         segred_group_sizze_310758;
                            CUdeviceptr kernel_arg_326902 = ext_mem_318756.mem;
                            CUdeviceptr kernel_arg_326903 = ext_mem_318757.mem;
                            CUdeviceptr kernel_arg_326904 =
                                        mem_param_318838.mem;
                            CUdeviceptr kernel_arg_326905 = mem_319654.mem;
                            unsigned int shared_offset_326901 = 0;
                            
                            if ((((((1 && num_groups_310759 != 0) && 1 != 0) &&
                                   1 != 0) && segred_group_sizze_310758 != 0) &&
                                 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_310759;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_326897[] =
                                     {&ctx->global_failure,
                                      &shared_offset_326901, &n_292675,
                                      &q_l_292680, &jump_t_292685,
                                      &partition_sizze_292766, &l_n_m_292832,
                                      &i_292846, &num_groups_310759,
                                      &ctx_param_ext_318833,
                                      &ctx_param_ext_318834,
                                      &ctx_param_ext_318836,
                                      &segment_sizze_nonzzero_323472,
                                      &kernel_arg_326902, &kernel_arg_326903,
                                      &kernel_arg_326904, &kernel_arg_326905};
                                int64_t time_start_326898 = 0, time_end_326899 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segred_small_310765",
                                            (long) num_groups_310759, (long) 1,
                                            (long) 1,
                                            (long) segred_group_sizze_310758,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_326900 +
                                                                        (8 -
                                                                         shared_sizze_326900 %
                                                                         8) %
                                                                        8)));
                                    time_start_326898 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegred_small_310765_runs,
                                                              &ctx->mainzisegred_small_310765_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_310765,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segred_group_sizze_310758,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_326900 +
                                                                       (8 -
                                                                        shared_sizze_326900 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_326897,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_326899 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segred_small_310765",
                                            time_end_326899 -
                                            time_start_326898);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                        } else {
                            int64_t groups_per_segment_323501 =
                                    sdiv_up64(num_groups_310759,
                                              smax64((int64_t) 1,
                                                     partition_sizze_292766 *
                                                     l_n_m_292832));
                            int64_t elements_per_thread_323502 =
                                    sdiv_up64(q_l_292680,
                                              segred_group_sizze_310758 *
                                              groups_per_segment_323501);
                            int64_t virt_num_groups_323503 =
                                    groups_per_segment_323501 *
                                    (partition_sizze_292766 * l_n_m_292832);
                            int64_t num_threads_323504 = num_groups_310759 *
                                    segred_group_sizze_310758;
                            int64_t threads_per_segment_323505 =
                                    groups_per_segment_323501 *
                                    segred_group_sizze_310758;
                            
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegRed-large");
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                        (long long) (partition_sizze_292766 *
                                                     l_n_m_292832), '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                        (long long) q_l_292680, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "virt_num_groups",
                                        (long long) virt_num_groups_323503,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_groups",
                                        (long long) num_groups_310759, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "group_size",
                                        (long long) segred_group_sizze_310758,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "elems_per_thread",
                                        (long long) elements_per_thread_323502,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "groups_per_segment",
                                        (long long) groups_per_segment_323501,
                                        '\n');
                            
                            struct memblock_device segred_tmp_mem_323506;
                            
                            segred_tmp_mem_323506.references = NULL;
                            if (memblock_alloc_device(ctx,
                                                      &segred_tmp_mem_323506,
                                                      (int64_t) 8 *
                                                      virt_num_groups_323503,
                                                      "segred_tmp_mem_323506")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mainzicounter_mem_323508 =
                                                   ctx->mainzicounter_mem_323508;
                            unsigned int shared_sizze_326910 = 1;
                            unsigned int shared_sizze_326912 = (int64_t) 8 *
                                         segred_group_sizze_310758;
                            CUdeviceptr kernel_arg_326914 = ext_mem_318756.mem;
                            CUdeviceptr kernel_arg_326915 = ext_mem_318757.mem;
                            CUdeviceptr kernel_arg_326916 =
                                        mem_param_318838.mem;
                            CUdeviceptr kernel_arg_326917 = mem_319654.mem;
                            CUdeviceptr kernel_arg_326918 =
                                        segred_tmp_mem_323506.mem;
                            CUdeviceptr kernel_arg_326919 =
                                        mainzicounter_mem_323508.mem;
                            unsigned int shared_offset_326911 = 0;
                            unsigned int shared_offset_326913 = 0 +
                                         (shared_sizze_326910 + (8 -
                                                                 shared_sizze_326910 %
                                                                 8) % 8);
                            
                            if ((((((1 && num_groups_310759 != 0) && 1 != 0) &&
                                   1 != 0) && segred_group_sizze_310758 != 0) &&
                                 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_310759;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_326907[] =
                                     {&ctx->global_failure,
                                      &shared_offset_326911,
                                      &shared_offset_326913, &n_292675,
                                      &q_l_292680, &jump_t_292685,
                                      &partition_sizze_292766, &l_n_m_292832,
                                      &i_292846, &num_groups_310759,
                                      &ctx_param_ext_318833,
                                      &ctx_param_ext_318834,
                                      &ctx_param_ext_318836,
                                      &groups_per_segment_323501,
                                      &elements_per_thread_323502,
                                      &virt_num_groups_323503,
                                      &threads_per_segment_323505,
                                      &kernel_arg_326914, &kernel_arg_326915,
                                      &kernel_arg_326916, &kernel_arg_326917,
                                      &kernel_arg_326918, &kernel_arg_326919};
                                int64_t time_start_326908 = 0, time_end_326909 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segred_large_310765",
                                            (long) num_groups_310759, (long) 1,
                                            (long) 1,
                                            (long) segred_group_sizze_310758,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_326910 +
                                                                        (8 -
                                                                         shared_sizze_326910 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326912 +
                                                                        (8 -
                                                                         shared_sizze_326912 %
                                                                         8) %
                                                                        8)));
                                    time_start_326908 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegred_large_310765_runs,
                                                              &ctx->mainzisegred_large_310765_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_310765,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segred_group_sizze_310758,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_326910 +
                                                                       (8 -
                                                                        shared_sizze_326910 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326912 +
                                                                       (8 -
                                                                        shared_sizze_326912 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_326907,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_326909 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segred_large_310765",
                                            time_end_326909 -
                                            time_start_326908);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx,
                                                      &segred_tmp_mem_323506,
                                                      "segred_tmp_mem_323506") !=
                                0)
                                return 1;
                        }
                        
                        int64_t segmap_group_sizze_310796;
                        
                        segmap_group_sizze_310796 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_310562;
                        
                        int64_t segmap_usable_groups_310797 =
                                sdiv_up64(nest_sizze_300244,
                                          segmap_group_sizze_310796);
                        struct memblock_device mem_319659;
                        
                        mem_319659.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319659,
                                                  bytes_318723, "mem_319659")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_326923 = mem_319654.mem;
                        CUdeviceptr kernel_arg_326924 = mem_319659.mem;
                        
                        if ((((((1 && segmap_usable_groups_310797 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_310796 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_310797;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_326920[] = {&ctx->global_failure,
                                                          &partition_sizze_292766,
                                                          &l_n_m_292832,
                                                          &kernel_arg_326923,
                                                          &kernel_arg_326924};
                            int64_t time_start_326921 = 0, time_end_326922 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_310801",
                                        (long) segmap_usable_groups_310797,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_310796,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_326921 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_310801_runs,
                                                          &ctx->mainzisegmap_310801_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_310801,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_310796,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_326920,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_326922 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_310801", time_end_326922 -
                                        time_start_326921);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_unref_device(ctx, &mem_319654,
                                                  "mem_319654") != 0)
                            return 1;
                        
                        int64_t segred_group_sizze_310808;
                        
                        segred_group_sizze_310808 =
                            *ctx->tuning_params.mainzisegred_group_sizze_310508;
                        
                        int64_t num_groups_310809;
                        int32_t max_num_groups_323554;
                        
                        max_num_groups_323554 =
                            *ctx->tuning_params.mainzisegred_num_groups_310510;
                        num_groups_310809 = sext_i64_i32(smax64((int64_t) 1,
                                                                smin64(sdiv_up64(nest_sizze_310757,
                                                                                 segred_group_sizze_310808),
                                                                       sext_i32_i64(max_num_groups_323554))));
                        
                        struct memblock_device mem_319664;
                        
                        mem_319664.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319664,
                                                  bytes_318723, "mem_319664")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (slt64(q_l_292680 * (int64_t) 2,
                                  segred_group_sizze_310808)) {
                            int64_t segment_sizze_nonzzero_323555 =
                                    smax64((int64_t) 1, q_l_292680);
                            int64_t num_threads_323556 = num_groups_310809 *
                                    segred_group_sizze_310808;
                            
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegRed-small");
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                        (long long) (partition_sizze_292766 *
                                                     l_n_m_292832), '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                        (long long) q_l_292680, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "segments_per_group",
                                        (long long) squot64(segred_group_sizze_310808,
                                                            segment_sizze_nonzzero_323555),
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "required_groups",
                                        (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                           l_n_m_292832,
                                                                           squot64(segred_group_sizze_310808,
                                                                                   segment_sizze_nonzzero_323555))),
                                        '\n');
                            
                            unsigned int shared_sizze_326928 = (int64_t) 8 *
                                         segred_group_sizze_310808;
                            CUdeviceptr kernel_arg_326930 = ext_mem_318756.mem;
                            CUdeviceptr kernel_arg_326931 = ext_mem_318757.mem;
                            CUdeviceptr kernel_arg_326932 =
                                        mem_param_318838.mem;
                            CUdeviceptr kernel_arg_326933 = mem_319555.mem;
                            CUdeviceptr kernel_arg_326934 = mem_319659.mem;
                            CUdeviceptr kernel_arg_326935 = mem_319664.mem;
                            unsigned int shared_offset_326929 = 0;
                            
                            if ((((((1 && num_groups_310809 != 0) && 1 != 0) &&
                                   1 != 0) && segred_group_sizze_310808 != 0) &&
                                 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_310809;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_326925[] =
                                     {&ctx->global_failure,
                                      &shared_offset_326929, &n_292675,
                                      &q_l_292680, &jump_t_292685,
                                      &partition_sizze_292766, &l_n_m_292832,
                                      &i_292846, &num_groups_310809,
                                      &ctx_param_ext_318833,
                                      &ctx_param_ext_318834,
                                      &ctx_param_ext_318836,
                                      &segment_sizze_nonzzero_323555,
                                      &kernel_arg_326930, &kernel_arg_326931,
                                      &kernel_arg_326932, &kernel_arg_326933,
                                      &kernel_arg_326934, &kernel_arg_326935};
                                int64_t time_start_326926 = 0, time_end_326927 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segred_small_310815",
                                            (long) num_groups_310809, (long) 1,
                                            (long) 1,
                                            (long) segred_group_sizze_310808,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_326928 +
                                                                        (8 -
                                                                         shared_sizze_326928 %
                                                                         8) %
                                                                        8)));
                                    time_start_326926 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegred_small_310815_runs,
                                                              &ctx->mainzisegred_small_310815_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_310815,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segred_group_sizze_310808,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_326928 +
                                                                       (8 -
                                                                        shared_sizze_326928 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_326925,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_326927 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segred_small_310815",
                                            time_end_326927 -
                                            time_start_326926);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                        } else {
                            int64_t groups_per_segment_323584 =
                                    sdiv_up64(num_groups_310809,
                                              smax64((int64_t) 1,
                                                     partition_sizze_292766 *
                                                     l_n_m_292832));
                            int64_t elements_per_thread_323585 =
                                    sdiv_up64(q_l_292680,
                                              segred_group_sizze_310808 *
                                              groups_per_segment_323584);
                            int64_t virt_num_groups_323586 =
                                    groups_per_segment_323584 *
                                    (partition_sizze_292766 * l_n_m_292832);
                            int64_t num_threads_323587 = num_groups_310809 *
                                    segred_group_sizze_310808;
                            int64_t threads_per_segment_323588 =
                                    groups_per_segment_323584 *
                                    segred_group_sizze_310808;
                            
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegRed-large");
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                        (long long) (partition_sizze_292766 *
                                                     l_n_m_292832), '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                        (long long) q_l_292680, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "virt_num_groups",
                                        (long long) virt_num_groups_323586,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_groups",
                                        (long long) num_groups_310809, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "group_size",
                                        (long long) segred_group_sizze_310808,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "elems_per_thread",
                                        (long long) elements_per_thread_323585,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "groups_per_segment",
                                        (long long) groups_per_segment_323584,
                                        '\n');
                            
                            struct memblock_device segred_tmp_mem_323589;
                            
                            segred_tmp_mem_323589.references = NULL;
                            if (memblock_alloc_device(ctx,
                                                      &segred_tmp_mem_323589,
                                                      (int64_t) 8 *
                                                      virt_num_groups_323586,
                                                      "segred_tmp_mem_323589")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mainzicounter_mem_323591 =
                                                   ctx->mainzicounter_mem_323591;
                            unsigned int shared_sizze_326940 = 1;
                            unsigned int shared_sizze_326942 = (int64_t) 8 *
                                         segred_group_sizze_310808;
                            CUdeviceptr kernel_arg_326944 = ext_mem_318756.mem;
                            CUdeviceptr kernel_arg_326945 = ext_mem_318757.mem;
                            CUdeviceptr kernel_arg_326946 =
                                        mem_param_318838.mem;
                            CUdeviceptr kernel_arg_326947 = mem_319555.mem;
                            CUdeviceptr kernel_arg_326948 = mem_319659.mem;
                            CUdeviceptr kernel_arg_326949 = mem_319664.mem;
                            CUdeviceptr kernel_arg_326950 =
                                        segred_tmp_mem_323589.mem;
                            CUdeviceptr kernel_arg_326951 =
                                        mainzicounter_mem_323591.mem;
                            unsigned int shared_offset_326941 = 0;
                            unsigned int shared_offset_326943 = 0 +
                                         (shared_sizze_326940 + (8 -
                                                                 shared_sizze_326940 %
                                                                 8) % 8);
                            
                            if ((((((1 && num_groups_310809 != 0) && 1 != 0) &&
                                   1 != 0) && segred_group_sizze_310808 != 0) &&
                                 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_310809;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_326937[] =
                                     {&ctx->global_failure,
                                      &shared_offset_326941,
                                      &shared_offset_326943, &n_292675,
                                      &q_l_292680, &jump_t_292685,
                                      &partition_sizze_292766, &l_n_m_292832,
                                      &i_292846, &num_groups_310809,
                                      &ctx_param_ext_318833,
                                      &ctx_param_ext_318834,
                                      &ctx_param_ext_318836,
                                      &groups_per_segment_323584,
                                      &elements_per_thread_323585,
                                      &virt_num_groups_323586,
                                      &threads_per_segment_323588,
                                      &kernel_arg_326944, &kernel_arg_326945,
                                      &kernel_arg_326946, &kernel_arg_326947,
                                      &kernel_arg_326948, &kernel_arg_326949,
                                      &kernel_arg_326950, &kernel_arg_326951};
                                int64_t time_start_326938 = 0, time_end_326939 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segred_large_310815",
                                            (long) num_groups_310809, (long) 1,
                                            (long) 1,
                                            (long) segred_group_sizze_310808,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_326940 +
                                                                        (8 -
                                                                         shared_sizze_326940 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_326942 +
                                                                        (8 -
                                                                         shared_sizze_326942 %
                                                                         8) %
                                                                        8)));
                                    time_start_326938 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegred_large_310815_runs,
                                                              &ctx->mainzisegred_large_310815_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_310815,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segred_group_sizze_310808,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_326940 +
                                                                       (8 -
                                                                        shared_sizze_326940 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_326942 +
                                                                       (8 -
                                                                        shared_sizze_326942 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_326937,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_326939 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segred_large_310815",
                                            time_end_326939 -
                                            time_start_326938);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx,
                                                      &segred_tmp_mem_323589,
                                                      "segred_tmp_mem_323589") !=
                                0)
                                return 1;
                        }
                        if (memblock_unref_device(ctx, &mem_319659,
                                                  "mem_319659") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319754,
                                                &mem_319664, "mem_319664") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319753,
                                                &mem_319649, "mem_319649") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319664,
                                                  "mem_319664") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319659,
                                                  "mem_319659") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319654,
                                                  "mem_319654") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319649,
                                                  "mem_319649") != 0)
                            return 1;
                    } else {
                        bool match_lit_295502 = (int64_t) 1 == d_l_292683;
                        struct memblock_device ext_mem_319752;
                        
                        ext_mem_319752.references = NULL;
                        
                        struct memblock_device ext_mem_319751;
                        
                        ext_mem_319751.references = NULL;
                        if (match_lit_295502) {
                            int64_t nest_sizze_311198 = q_l_292680 *
                                    nest_sizze_300244;
                            int64_t segred_group_sizze_311199;
                            
                            segred_group_sizze_311199 =
                                *ctx->tuning_params.mainzisegred_group_sizze_310971;
                            
                            int64_t num_groups_311200;
                            int32_t max_num_groups_323627;
                            
                            max_num_groups_323627 =
                                *ctx->tuning_params.mainzisegred_num_groups_310973;
                            num_groups_311200 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(nest_sizze_311198,
                                                                                     segred_group_sizze_311199),
                                                                           sext_i32_i64(max_num_groups_323627))));
                            
                            struct memblock_device mem_319669;
                            
                            mem_319669.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319669,
                                                      bytes_318723,
                                                      "mem_319669")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319673;
                            
                            mem_319673.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319673,
                                                      bytes_318723,
                                                      "mem_319673")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319677;
                            
                            mem_319677.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319677,
                                                      bytes_318723,
                                                      "mem_319677")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (slt64(q_l_292680 * (int64_t) 2,
                                      segred_group_sizze_311199)) {
                                int64_t segment_sizze_nonzzero_323628 =
                                        smax64((int64_t) 1, q_l_292680);
                                int64_t num_threads_323629 = num_groups_311200 *
                                        segred_group_sizze_311199;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-small");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         l_n_m_292832), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_l_292680, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segments_per_group",
                                            (long long) squot64(segred_group_sizze_311199,
                                                                segment_sizze_nonzzero_323628),
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "required_groups",
                                            (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                               l_n_m_292832,
                                                                               squot64(segred_group_sizze_311199,
                                                                                       segment_sizze_nonzzero_323628))),
                                            '\n');
                                
                                unsigned int shared_sizze_326955 = (int64_t) 8 *
                                             segred_group_sizze_311199;
                                unsigned int shared_sizze_326957 = (int64_t) 8 *
                                             segred_group_sizze_311199;
                                unsigned int shared_sizze_326959 = (int64_t) 8 *
                                             segred_group_sizze_311199;
                                CUdeviceptr kernel_arg_326961 =
                                            ext_mem_318756.mem;
                                CUdeviceptr kernel_arg_326962 =
                                            ext_mem_318757.mem;
                                CUdeviceptr kernel_arg_326963 =
                                            mem_param_318838.mem;
                                CUdeviceptr kernel_arg_326964 = mem_319669.mem;
                                CUdeviceptr kernel_arg_326965 = mem_319673.mem;
                                CUdeviceptr kernel_arg_326966 = mem_319677.mem;
                                unsigned int shared_offset_326956 = 0;
                                unsigned int shared_offset_326958 = 0 +
                                             (shared_sizze_326955 + (8 -
                                                                     shared_sizze_326955 %
                                                                     8) % 8);
                                unsigned int shared_offset_326960 = 0 +
                                             (shared_sizze_326955 + (8 -
                                                                     shared_sizze_326955 %
                                                                     8) % 8) +
                                             (shared_sizze_326957 + (8 -
                                                                     shared_sizze_326957 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_311200 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_311199 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_311200;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_326952[] =
                                         {&ctx->global_failure,
                                          &shared_offset_326956,
                                          &shared_offset_326958,
                                          &shared_offset_326960, &n_292675,
                                          &q_l_292680, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &l_n_m_292832, &i_292846,
                                          &num_groups_311200,
                                          &ctx_param_ext_318833,
                                          &ctx_param_ext_318834,
                                          &ctx_param_ext_318836,
                                          &segment_sizze_nonzzero_323628,
                                          &kernel_arg_326961,
                                          &kernel_arg_326962,
                                          &kernel_arg_326963,
                                          &kernel_arg_326964,
                                          &kernel_arg_326965,
                                          &kernel_arg_326966};
                                    int64_t time_start_326953 = 0,
                                            time_end_326954 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_small_311208",
                                                (long) num_groups_311200,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_311199,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_326955 +
                                                                            (8 -
                                                                             shared_sizze_326955 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_326957 +
                                                                            (8 -
                                                                             shared_sizze_326957 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_326959 +
                                                                            (8 -
                                                                             shared_sizze_326959 %
                                                                             8) %
                                                                            8)));
                                        time_start_326953 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_small_311208_runs,
                                                                  &ctx->mainzisegred_small_311208_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_311208,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_311199,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_326955 +
                                                                           (8 -
                                                                            shared_sizze_326955 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_326957 +
                                                                           (8 -
                                                                            shared_sizze_326957 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_326959 +
                                                                           (8 -
                                                                            shared_sizze_326959 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_326952,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_326954 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_small_311208",
                                                time_end_326954 -
                                                time_start_326953);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                            } else {
                                int64_t groups_per_segment_323669 =
                                        sdiv_up64(num_groups_311200,
                                                  smax64((int64_t) 1,
                                                         partition_sizze_292766 *
                                                         l_n_m_292832));
                                int64_t elements_per_thread_323670 =
                                        sdiv_up64(q_l_292680,
                                                  segred_group_sizze_311199 *
                                                  groups_per_segment_323669);
                                int64_t virt_num_groups_323671 =
                                        groups_per_segment_323669 *
                                        (partition_sizze_292766 * l_n_m_292832);
                                int64_t num_threads_323672 = num_groups_311200 *
                                        segred_group_sizze_311199;
                                int64_t threads_per_segment_323673 =
                                        groups_per_segment_323669 *
                                        segred_group_sizze_311199;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-large");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         l_n_m_292832), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_l_292680, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "virt_num_groups",
                                            (long long) virt_num_groups_323671,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_groups",
                                            (long long) num_groups_311200,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "group_size",
                                            (long long) segred_group_sizze_311199,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "elems_per_thread",
                                            (long long) elements_per_thread_323670,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "groups_per_segment",
                                            (long long) groups_per_segment_323669,
                                            '\n');
                                
                                struct memblock_device segred_tmp_mem_323674;
                                
                                segred_tmp_mem_323674.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_323674,
                                                          (int64_t) 8 *
                                                          virt_num_groups_323671,
                                                          "segred_tmp_mem_323674")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_323676;
                                
                                segred_tmp_mem_323676.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_323676,
                                                          (int64_t) 8 *
                                                          virt_num_groups_323671,
                                                          "segred_tmp_mem_323676")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_323678;
                                
                                segred_tmp_mem_323678.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_323678,
                                                          (int64_t) 8 *
                                                          virt_num_groups_323671,
                                                          "segred_tmp_mem_323678")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mainzicounter_mem_323680
                                                       =
                                                       ctx->mainzicounter_mem_323680;
                                unsigned int shared_sizze_326971 = 1;
                                unsigned int shared_sizze_326973 = (int64_t) 8 *
                                             segred_group_sizze_311199;
                                unsigned int shared_sizze_326975 = (int64_t) 8 *
                                             segred_group_sizze_311199;
                                unsigned int shared_sizze_326977 = (int64_t) 8 *
                                             segred_group_sizze_311199;
                                CUdeviceptr kernel_arg_326979 =
                                            ext_mem_318756.mem;
                                CUdeviceptr kernel_arg_326980 =
                                            ext_mem_318757.mem;
                                CUdeviceptr kernel_arg_326981 =
                                            mem_param_318838.mem;
                                CUdeviceptr kernel_arg_326982 = mem_319669.mem;
                                CUdeviceptr kernel_arg_326983 = mem_319673.mem;
                                CUdeviceptr kernel_arg_326984 = mem_319677.mem;
                                CUdeviceptr kernel_arg_326985 =
                                            segred_tmp_mem_323674.mem;
                                CUdeviceptr kernel_arg_326986 =
                                            segred_tmp_mem_323676.mem;
                                CUdeviceptr kernel_arg_326987 =
                                            segred_tmp_mem_323678.mem;
                                CUdeviceptr kernel_arg_326988 =
                                            mainzicounter_mem_323680.mem;
                                unsigned int shared_offset_326972 = 0;
                                unsigned int shared_offset_326974 = 0 +
                                             (shared_sizze_326971 + (8 -
                                                                     shared_sizze_326971 %
                                                                     8) % 8);
                                unsigned int shared_offset_326976 = 0 +
                                             (shared_sizze_326971 + (8 -
                                                                     shared_sizze_326971 %
                                                                     8) % 8) +
                                             (shared_sizze_326973 + (8 -
                                                                     shared_sizze_326973 %
                                                                     8) % 8);
                                unsigned int shared_offset_326978 = 0 +
                                             (shared_sizze_326971 + (8 -
                                                                     shared_sizze_326971 %
                                                                     8) % 8) +
                                             (shared_sizze_326973 + (8 -
                                                                     shared_sizze_326973 %
                                                                     8) % 8) +
                                             (shared_sizze_326975 + (8 -
                                                                     shared_sizze_326975 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_311200 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_311199 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_311200;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_326968[] =
                                         {&ctx->global_failure,
                                          &shared_offset_326972,
                                          &shared_offset_326974,
                                          &shared_offset_326976,
                                          &shared_offset_326978, &n_292675,
                                          &q_l_292680, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &l_n_m_292832, &i_292846,
                                          &num_groups_311200,
                                          &ctx_param_ext_318833,
                                          &ctx_param_ext_318834,
                                          &ctx_param_ext_318836,
                                          &groups_per_segment_323669,
                                          &elements_per_thread_323670,
                                          &virt_num_groups_323671,
                                          &threads_per_segment_323673,
                                          &kernel_arg_326979,
                                          &kernel_arg_326980,
                                          &kernel_arg_326981,
                                          &kernel_arg_326982,
                                          &kernel_arg_326983,
                                          &kernel_arg_326984,
                                          &kernel_arg_326985,
                                          &kernel_arg_326986,
                                          &kernel_arg_326987,
                                          &kernel_arg_326988};
                                    int64_t time_start_326969 = 0,
                                            time_end_326970 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_large_311208",
                                                (long) num_groups_311200,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_311199,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_326971 +
                                                                            (8 -
                                                                             shared_sizze_326971 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_326973 +
                                                                            (8 -
                                                                             shared_sizze_326973 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_326975 +
                                                                            (8 -
                                                                             shared_sizze_326975 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_326977 +
                                                                            (8 -
                                                                             shared_sizze_326977 %
                                                                             8) %
                                                                            8)));
                                        time_start_326969 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_large_311208_runs,
                                                                  &ctx->mainzisegred_large_311208_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_311208,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_311199,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_326971 +
                                                                           (8 -
                                                                            shared_sizze_326971 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_326973 +
                                                                           (8 -
                                                                            shared_sizze_326973 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_326975 +
                                                                           (8 -
                                                                            shared_sizze_326975 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_326977 +
                                                                           (8 -
                                                                            shared_sizze_326977 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_326968,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_326970 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_large_311208",
                                                time_end_326970 -
                                                time_start_326969);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_323678,
                                                          "segred_tmp_mem_323678") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_323676,
                                                          "segred_tmp_mem_323676") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_323674,
                                                          "segred_tmp_mem_323674") !=
                                    0)
                                    return 1;
                            }
                            
                            int64_t segmap_group_sizze_311247;
                            
                            segmap_group_sizze_311247 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_310946;
                            
                            int64_t segmap_usable_groups_311248 =
                                    sdiv_up64(nest_sizze_300244,
                                              segmap_group_sizze_311247);
                            struct memblock_device mem_319682;
                            
                            mem_319682.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319682,
                                                      bytes_318723,
                                                      "mem_319682")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319686;
                            
                            mem_319686.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319686,
                                                      bytes_318723,
                                                      "mem_319686")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319690;
                            
                            mem_319690.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319690,
                                                      bytes_318723,
                                                      "mem_319690")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_326992 = mem_319669.mem;
                            CUdeviceptr kernel_arg_326993 = mem_319673.mem;
                            CUdeviceptr kernel_arg_326994 = mem_319677.mem;
                            CUdeviceptr kernel_arg_326995 = mem_319682.mem;
                            CUdeviceptr kernel_arg_326996 = mem_319686.mem;
                            CUdeviceptr kernel_arg_326997 = mem_319690.mem;
                            
                            if ((((((1 && segmap_usable_groups_311248 != 0) &&
                                    1 != 0) && 1 != 0) &&
                                  segmap_group_sizze_311247 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = segmap_usable_groups_311248;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_326989[] =
                                     {&ctx->global_failure,
                                      &partition_sizze_292766, &l_n_m_292832,
                                      &kernel_arg_326992, &kernel_arg_326993,
                                      &kernel_arg_326994, &kernel_arg_326995,
                                      &kernel_arg_326996, &kernel_arg_326997};
                                int64_t time_start_326990 = 0, time_end_326991 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_311254",
                                            (long) segmap_usable_groups_311248,
                                            (long) 1, (long) 1,
                                            (long) segmap_group_sizze_311247,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_326990 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_311254_runs,
                                                              &ctx->mainzisegmap_311254_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_311254,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_311247,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_326989,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_326991 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_311254",
                                            time_end_326991 -
                                            time_start_326990);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx, &mem_319669,
                                                      "mem_319669") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319673,
                                                      "mem_319673") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319677,
                                                      "mem_319677") != 0)
                                return 1;
                            
                            int64_t segred_group_sizze_311272;
                            
                            segred_group_sizze_311272 =
                                *ctx->tuning_params.mainzisegred_group_sizze_310874;
                            
                            int64_t num_groups_311273;
                            int32_t max_num_groups_323738;
                            
                            max_num_groups_323738 =
                                *ctx->tuning_params.mainzisegred_num_groups_310876;
                            num_groups_311273 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(nest_sizze_311198,
                                                                                     segred_group_sizze_311272),
                                                                           sext_i32_i64(max_num_groups_323738))));
                            
                            struct memblock_device mem_319695;
                            
                            mem_319695.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319695,
                                                      bytes_318723,
                                                      "mem_319695")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319699;
                            
                            mem_319699.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319699,
                                                      bytes_318723,
                                                      "mem_319699")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (slt64(q_l_292680 * (int64_t) 2,
                                      segred_group_sizze_311272)) {
                                int64_t segment_sizze_nonzzero_323739 =
                                        smax64((int64_t) 1, q_l_292680);
                                int64_t num_threads_323740 = num_groups_311273 *
                                        segred_group_sizze_311272;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-small");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         l_n_m_292832), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_l_292680, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segments_per_group",
                                            (long long) squot64(segred_group_sizze_311272,
                                                                segment_sizze_nonzzero_323739),
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "required_groups",
                                            (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                               l_n_m_292832,
                                                                               squot64(segred_group_sizze_311272,
                                                                                       segment_sizze_nonzzero_323739))),
                                            '\n');
                                
                                unsigned int shared_sizze_327001 = (int64_t) 8 *
                                             segred_group_sizze_311272;
                                unsigned int shared_sizze_327003 = (int64_t) 8 *
                                             segred_group_sizze_311272;
                                CUdeviceptr kernel_arg_327005 =
                                            ext_mem_318756.mem;
                                CUdeviceptr kernel_arg_327006 =
                                            ext_mem_318757.mem;
                                CUdeviceptr kernel_arg_327007 =
                                            mem_param_318838.mem;
                                CUdeviceptr kernel_arg_327008 = mem_319555.mem;
                                CUdeviceptr kernel_arg_327009 = mem_319682.mem;
                                CUdeviceptr kernel_arg_327010 = mem_319686.mem;
                                CUdeviceptr kernel_arg_327011 = mem_319690.mem;
                                CUdeviceptr kernel_arg_327012 = mem_319695.mem;
                                CUdeviceptr kernel_arg_327013 = mem_319699.mem;
                                unsigned int shared_offset_327002 = 0;
                                unsigned int shared_offset_327004 = 0 +
                                             (shared_sizze_327001 + (8 -
                                                                     shared_sizze_327001 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_311273 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_311272 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_311273;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_326998[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327002,
                                          &shared_offset_327004, &n_292675,
                                          &q_l_292680, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &l_n_m_292832, &i_292846,
                                          &num_groups_311273,
                                          &ctx_param_ext_318833,
                                          &ctx_param_ext_318834,
                                          &ctx_param_ext_318836,
                                          &segment_sizze_nonzzero_323739,
                                          &kernel_arg_327005,
                                          &kernel_arg_327006,
                                          &kernel_arg_327007,
                                          &kernel_arg_327008,
                                          &kernel_arg_327009,
                                          &kernel_arg_327010,
                                          &kernel_arg_327011,
                                          &kernel_arg_327012,
                                          &kernel_arg_327013};
                                    int64_t time_start_326999 = 0,
                                            time_end_327000 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_small_311280",
                                                (long) num_groups_311273,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_311272,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327001 +
                                                                            (8 -
                                                                             shared_sizze_327001 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327003 +
                                                                            (8 -
                                                                             shared_sizze_327003 %
                                                                             8) %
                                                                            8)));
                                        time_start_326999 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_small_311280_runs,
                                                                  &ctx->mainzisegred_small_311280_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_311280,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_311272,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327001 +
                                                                           (8 -
                                                                            shared_sizze_327001 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327003 +
                                                                           (8 -
                                                                            shared_sizze_327003 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_326998,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327000 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_small_311280",
                                                time_end_327000 -
                                                time_start_326999);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                            } else {
                                int64_t groups_per_segment_323774 =
                                        sdiv_up64(num_groups_311273,
                                                  smax64((int64_t) 1,
                                                         partition_sizze_292766 *
                                                         l_n_m_292832));
                                int64_t elements_per_thread_323775 =
                                        sdiv_up64(q_l_292680,
                                                  segred_group_sizze_311272 *
                                                  groups_per_segment_323774);
                                int64_t virt_num_groups_323776 =
                                        groups_per_segment_323774 *
                                        (partition_sizze_292766 * l_n_m_292832);
                                int64_t num_threads_323777 = num_groups_311273 *
                                        segred_group_sizze_311272;
                                int64_t threads_per_segment_323778 =
                                        groups_per_segment_323774 *
                                        segred_group_sizze_311272;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-large");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         l_n_m_292832), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_l_292680, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "virt_num_groups",
                                            (long long) virt_num_groups_323776,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_groups",
                                            (long long) num_groups_311273,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "group_size",
                                            (long long) segred_group_sizze_311272,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "elems_per_thread",
                                            (long long) elements_per_thread_323775,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "groups_per_segment",
                                            (long long) groups_per_segment_323774,
                                            '\n');
                                
                                struct memblock_device segred_tmp_mem_323779;
                                
                                segred_tmp_mem_323779.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_323779,
                                                          (int64_t) 8 *
                                                          virt_num_groups_323776,
                                                          "segred_tmp_mem_323779")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_323781;
                                
                                segred_tmp_mem_323781.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_323781,
                                                          (int64_t) 8 *
                                                          virt_num_groups_323776,
                                                          "segred_tmp_mem_323781")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mainzicounter_mem_323783
                                                       =
                                                       ctx->mainzicounter_mem_323783;
                                unsigned int shared_sizze_327018 = 1;
                                unsigned int shared_sizze_327020 = (int64_t) 8 *
                                             segred_group_sizze_311272;
                                unsigned int shared_sizze_327022 = (int64_t) 8 *
                                             segred_group_sizze_311272;
                                CUdeviceptr kernel_arg_327024 =
                                            ext_mem_318756.mem;
                                CUdeviceptr kernel_arg_327025 =
                                            ext_mem_318757.mem;
                                CUdeviceptr kernel_arg_327026 =
                                            mem_param_318838.mem;
                                CUdeviceptr kernel_arg_327027 = mem_319555.mem;
                                CUdeviceptr kernel_arg_327028 = mem_319682.mem;
                                CUdeviceptr kernel_arg_327029 = mem_319686.mem;
                                CUdeviceptr kernel_arg_327030 = mem_319690.mem;
                                CUdeviceptr kernel_arg_327031 = mem_319695.mem;
                                CUdeviceptr kernel_arg_327032 = mem_319699.mem;
                                CUdeviceptr kernel_arg_327033 =
                                            segred_tmp_mem_323779.mem;
                                CUdeviceptr kernel_arg_327034 =
                                            segred_tmp_mem_323781.mem;
                                CUdeviceptr kernel_arg_327035 =
                                            mainzicounter_mem_323783.mem;
                                unsigned int shared_offset_327019 = 0;
                                unsigned int shared_offset_327021 = 0 +
                                             (shared_sizze_327018 + (8 -
                                                                     shared_sizze_327018 %
                                                                     8) % 8);
                                unsigned int shared_offset_327023 = 0 +
                                             (shared_sizze_327018 + (8 -
                                                                     shared_sizze_327018 %
                                                                     8) % 8) +
                                             (shared_sizze_327020 + (8 -
                                                                     shared_sizze_327020 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_311273 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_311272 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_311273;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327015[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327019,
                                          &shared_offset_327021,
                                          &shared_offset_327023, &n_292675,
                                          &q_l_292680, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &l_n_m_292832, &i_292846,
                                          &num_groups_311273,
                                          &ctx_param_ext_318833,
                                          &ctx_param_ext_318834,
                                          &ctx_param_ext_318836,
                                          &groups_per_segment_323774,
                                          &elements_per_thread_323775,
                                          &virt_num_groups_323776,
                                          &threads_per_segment_323778,
                                          &kernel_arg_327024,
                                          &kernel_arg_327025,
                                          &kernel_arg_327026,
                                          &kernel_arg_327027,
                                          &kernel_arg_327028,
                                          &kernel_arg_327029,
                                          &kernel_arg_327030,
                                          &kernel_arg_327031,
                                          &kernel_arg_327032,
                                          &kernel_arg_327033,
                                          &kernel_arg_327034,
                                          &kernel_arg_327035};
                                    int64_t time_start_327016 = 0,
                                            time_end_327017 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_large_311280",
                                                (long) num_groups_311273,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_311272,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327018 +
                                                                            (8 -
                                                                             shared_sizze_327018 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327020 +
                                                                            (8 -
                                                                             shared_sizze_327020 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327022 +
                                                                            (8 -
                                                                             shared_sizze_327022 %
                                                                             8) %
                                                                            8)));
                                        time_start_327016 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_large_311280_runs,
                                                                  &ctx->mainzisegred_large_311280_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_311280,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_311272,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327018 +
                                                                           (8 -
                                                                            shared_sizze_327018 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327020 +
                                                                           (8 -
                                                                            shared_sizze_327020 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327022 +
                                                                           (8 -
                                                                            shared_sizze_327022 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327015,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327017 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_large_311280",
                                                time_end_327017 -
                                                time_start_327016);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_323781,
                                                          "segred_tmp_mem_323781") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_323779,
                                                          "segred_tmp_mem_323779") !=
                                    0)
                                    return 1;
                            }
                            if (memblock_unref_device(ctx, &mem_319682,
                                                      "mem_319682") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319686,
                                                      "mem_319686") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319690,
                                                      "mem_319690") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319752,
                                                    &mem_319695,
                                                    "mem_319695") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319751,
                                                    &mem_319699,
                                                    "mem_319699") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319699,
                                                      "mem_319699") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319695,
                                                      "mem_319695") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319690,
                                                      "mem_319690") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319686,
                                                      "mem_319686") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319682,
                                                      "mem_319682") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319677,
                                                      "mem_319677") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319673,
                                                      "mem_319673") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319669,
                                                      "mem_319669") != 0)
                                return 1;
                        } else {
                            int64_t nest_sizze_311766 = q_l_292680 *
                                    nest_sizze_300244;
                            int64_t segred_group_sizze_311767;
                            
                            segred_group_sizze_311767 =
                                *ctx->tuning_params.mainzisegred_group_sizze_311489;
                            
                            int64_t num_groups_311768;
                            int32_t max_num_groups_323825;
                            
                            max_num_groups_323825 =
                                *ctx->tuning_params.mainzisegred_num_groups_311491;
                            num_groups_311768 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(nest_sizze_311766,
                                                                                     segred_group_sizze_311767),
                                                                           sext_i32_i64(max_num_groups_323825))));
                            
                            struct memblock_device mem_319704;
                            
                            mem_319704.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319704,
                                                      bytes_318723,
                                                      "mem_319704")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319708;
                            
                            mem_319708.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319708,
                                                      bytes_318723,
                                                      "mem_319708")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319712;
                            
                            mem_319712.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319712,
                                                      bytes_318723,
                                                      "mem_319712")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319716;
                            
                            mem_319716.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319716,
                                                      bytes_318723,
                                                      "mem_319716")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319720;
                            
                            mem_319720.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319720,
                                                      bytes_318723,
                                                      "mem_319720")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (slt64(q_l_292680 * (int64_t) 2,
                                      segred_group_sizze_311767)) {
                                int64_t segment_sizze_nonzzero_323826 =
                                        smax64((int64_t) 1, q_l_292680);
                                int64_t num_threads_323827 = num_groups_311768 *
                                        segred_group_sizze_311767;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-small");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         l_n_m_292832), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_l_292680, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segments_per_group",
                                            (long long) squot64(segred_group_sizze_311767,
                                                                segment_sizze_nonzzero_323826),
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "required_groups",
                                            (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                               l_n_m_292832,
                                                                               squot64(segred_group_sizze_311767,
                                                                                       segment_sizze_nonzzero_323826))),
                                            '\n');
                                
                                unsigned int shared_sizze_327039 = (int64_t) 8 *
                                             segred_group_sizze_311767;
                                unsigned int shared_sizze_327041 = (int64_t) 8 *
                                             segred_group_sizze_311767;
                                unsigned int shared_sizze_327043 = (int64_t) 8 *
                                             segred_group_sizze_311767;
                                unsigned int shared_sizze_327045 = (int64_t) 8 *
                                             segred_group_sizze_311767;
                                unsigned int shared_sizze_327047 = (int64_t) 8 *
                                             segred_group_sizze_311767;
                                CUdeviceptr kernel_arg_327049 =
                                            ext_mem_318756.mem;
                                CUdeviceptr kernel_arg_327050 =
                                            ext_mem_318757.mem;
                                CUdeviceptr kernel_arg_327051 =
                                            mem_param_318838.mem;
                                CUdeviceptr kernel_arg_327052 = mem_319704.mem;
                                CUdeviceptr kernel_arg_327053 = mem_319708.mem;
                                CUdeviceptr kernel_arg_327054 = mem_319712.mem;
                                CUdeviceptr kernel_arg_327055 = mem_319716.mem;
                                CUdeviceptr kernel_arg_327056 = mem_319720.mem;
                                unsigned int shared_offset_327040 = 0;
                                unsigned int shared_offset_327042 = 0 +
                                             (shared_sizze_327039 + (8 -
                                                                     shared_sizze_327039 %
                                                                     8) % 8);
                                unsigned int shared_offset_327044 = 0 +
                                             (shared_sizze_327039 + (8 -
                                                                     shared_sizze_327039 %
                                                                     8) % 8) +
                                             (shared_sizze_327041 + (8 -
                                                                     shared_sizze_327041 %
                                                                     8) % 8);
                                unsigned int shared_offset_327046 = 0 +
                                             (shared_sizze_327039 + (8 -
                                                                     shared_sizze_327039 %
                                                                     8) % 8) +
                                             (shared_sizze_327041 + (8 -
                                                                     shared_sizze_327041 %
                                                                     8) % 8) +
                                             (shared_sizze_327043 + (8 -
                                                                     shared_sizze_327043 %
                                                                     8) % 8);
                                unsigned int shared_offset_327048 = 0 +
                                             (shared_sizze_327039 + (8 -
                                                                     shared_sizze_327039 %
                                                                     8) % 8) +
                                             (shared_sizze_327041 + (8 -
                                                                     shared_sizze_327041 %
                                                                     8) % 8) +
                                             (shared_sizze_327043 + (8 -
                                                                     shared_sizze_327043 %
                                                                     8) % 8) +
                                             (shared_sizze_327045 + (8 -
                                                                     shared_sizze_327045 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_311768 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_311767 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_311768;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327036[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327040,
                                          &shared_offset_327042,
                                          &shared_offset_327044,
                                          &shared_offset_327046,
                                          &shared_offset_327048, &n_292675,
                                          &q_l_292680, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &l_n_m_292832, &i_292846,
                                          &num_groups_311768,
                                          &ctx_param_ext_318833,
                                          &ctx_param_ext_318834,
                                          &ctx_param_ext_318836,
                                          &segment_sizze_nonzzero_323826,
                                          &kernel_arg_327049,
                                          &kernel_arg_327050,
                                          &kernel_arg_327051,
                                          &kernel_arg_327052,
                                          &kernel_arg_327053,
                                          &kernel_arg_327054,
                                          &kernel_arg_327055,
                                          &kernel_arg_327056};
                                    int64_t time_start_327037 = 0,
                                            time_end_327038 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_small_311778",
                                                (long) num_groups_311768,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_311767,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327039 +
                                                                            (8 -
                                                                             shared_sizze_327039 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327041 +
                                                                            (8 -
                                                                             shared_sizze_327041 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327043 +
                                                                            (8 -
                                                                             shared_sizze_327043 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327045 +
                                                                            (8 -
                                                                             shared_sizze_327045 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327047 +
                                                                            (8 -
                                                                             shared_sizze_327047 %
                                                                             8) %
                                                                            8)));
                                        time_start_327037 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_small_311778_runs,
                                                                  &ctx->mainzisegred_small_311778_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_311778,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_311767,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327039 +
                                                                           (8 -
                                                                            shared_sizze_327039 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327041 +
                                                                           (8 -
                                                                            shared_sizze_327041 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327043 +
                                                                           (8 -
                                                                            shared_sizze_327043 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327045 +
                                                                           (8 -
                                                                            shared_sizze_327045 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327047 +
                                                                           (8 -
                                                                            shared_sizze_327047 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327036,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327038 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_small_311778",
                                                time_end_327038 -
                                                time_start_327037);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                            } else {
                                int64_t groups_per_segment_323879 =
                                        sdiv_up64(num_groups_311768,
                                                  smax64((int64_t) 1,
                                                         partition_sizze_292766 *
                                                         l_n_m_292832));
                                int64_t elements_per_thread_323880 =
                                        sdiv_up64(q_l_292680,
                                                  segred_group_sizze_311767 *
                                                  groups_per_segment_323879);
                                int64_t virt_num_groups_323881 =
                                        groups_per_segment_323879 *
                                        (partition_sizze_292766 * l_n_m_292832);
                                int64_t num_threads_323882 = num_groups_311768 *
                                        segred_group_sizze_311767;
                                int64_t threads_per_segment_323883 =
                                        groups_per_segment_323879 *
                                        segred_group_sizze_311767;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-large");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         l_n_m_292832), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_l_292680, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "virt_num_groups",
                                            (long long) virt_num_groups_323881,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_groups",
                                            (long long) num_groups_311768,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "group_size",
                                            (long long) segred_group_sizze_311767,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "elems_per_thread",
                                            (long long) elements_per_thread_323880,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "groups_per_segment",
                                            (long long) groups_per_segment_323879,
                                            '\n');
                                
                                struct memblock_device segred_tmp_mem_323884;
                                
                                segred_tmp_mem_323884.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_323884,
                                                          (int64_t) 8 *
                                                          virt_num_groups_323881,
                                                          "segred_tmp_mem_323884")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_323886;
                                
                                segred_tmp_mem_323886.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_323886,
                                                          (int64_t) 8 *
                                                          virt_num_groups_323881,
                                                          "segred_tmp_mem_323886")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_323888;
                                
                                segred_tmp_mem_323888.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_323888,
                                                          (int64_t) 8 *
                                                          virt_num_groups_323881,
                                                          "segred_tmp_mem_323888")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_323890;
                                
                                segred_tmp_mem_323890.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_323890,
                                                          (int64_t) 8 *
                                                          virt_num_groups_323881,
                                                          "segred_tmp_mem_323890")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_323892;
                                
                                segred_tmp_mem_323892.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_323892,
                                                          (int64_t) 8 *
                                                          virt_num_groups_323881,
                                                          "segred_tmp_mem_323892")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mainzicounter_mem_323894
                                                       =
                                                       ctx->mainzicounter_mem_323894;
                                unsigned int shared_sizze_327061 = 1;
                                unsigned int shared_sizze_327063 = (int64_t) 8 *
                                             segred_group_sizze_311767;
                                unsigned int shared_sizze_327065 = (int64_t) 8 *
                                             segred_group_sizze_311767;
                                unsigned int shared_sizze_327067 = (int64_t) 8 *
                                             segred_group_sizze_311767;
                                unsigned int shared_sizze_327069 = (int64_t) 8 *
                                             segred_group_sizze_311767;
                                unsigned int shared_sizze_327071 = (int64_t) 8 *
                                             segred_group_sizze_311767;
                                CUdeviceptr kernel_arg_327073 =
                                            ext_mem_318756.mem;
                                CUdeviceptr kernel_arg_327074 =
                                            ext_mem_318757.mem;
                                CUdeviceptr kernel_arg_327075 =
                                            mem_param_318838.mem;
                                CUdeviceptr kernel_arg_327076 = mem_319704.mem;
                                CUdeviceptr kernel_arg_327077 = mem_319708.mem;
                                CUdeviceptr kernel_arg_327078 = mem_319712.mem;
                                CUdeviceptr kernel_arg_327079 = mem_319716.mem;
                                CUdeviceptr kernel_arg_327080 = mem_319720.mem;
                                CUdeviceptr kernel_arg_327081 =
                                            segred_tmp_mem_323884.mem;
                                CUdeviceptr kernel_arg_327082 =
                                            segred_tmp_mem_323886.mem;
                                CUdeviceptr kernel_arg_327083 =
                                            segred_tmp_mem_323888.mem;
                                CUdeviceptr kernel_arg_327084 =
                                            segred_tmp_mem_323890.mem;
                                CUdeviceptr kernel_arg_327085 =
                                            segred_tmp_mem_323892.mem;
                                CUdeviceptr kernel_arg_327086 =
                                            mainzicounter_mem_323894.mem;
                                unsigned int shared_offset_327062 = 0;
                                unsigned int shared_offset_327064 = 0 +
                                             (shared_sizze_327061 + (8 -
                                                                     shared_sizze_327061 %
                                                                     8) % 8);
                                unsigned int shared_offset_327066 = 0 +
                                             (shared_sizze_327061 + (8 -
                                                                     shared_sizze_327061 %
                                                                     8) % 8) +
                                             (shared_sizze_327063 + (8 -
                                                                     shared_sizze_327063 %
                                                                     8) % 8);
                                unsigned int shared_offset_327068 = 0 +
                                             (shared_sizze_327061 + (8 -
                                                                     shared_sizze_327061 %
                                                                     8) % 8) +
                                             (shared_sizze_327063 + (8 -
                                                                     shared_sizze_327063 %
                                                                     8) % 8) +
                                             (shared_sizze_327065 + (8 -
                                                                     shared_sizze_327065 %
                                                                     8) % 8);
                                unsigned int shared_offset_327070 = 0 +
                                             (shared_sizze_327061 + (8 -
                                                                     shared_sizze_327061 %
                                                                     8) % 8) +
                                             (shared_sizze_327063 + (8 -
                                                                     shared_sizze_327063 %
                                                                     8) % 8) +
                                             (shared_sizze_327065 + (8 -
                                                                     shared_sizze_327065 %
                                                                     8) % 8) +
                                             (shared_sizze_327067 + (8 -
                                                                     shared_sizze_327067 %
                                                                     8) % 8);
                                unsigned int shared_offset_327072 = 0 +
                                             (shared_sizze_327061 + (8 -
                                                                     shared_sizze_327061 %
                                                                     8) % 8) +
                                             (shared_sizze_327063 + (8 -
                                                                     shared_sizze_327063 %
                                                                     8) % 8) +
                                             (shared_sizze_327065 + (8 -
                                                                     shared_sizze_327065 %
                                                                     8) % 8) +
                                             (shared_sizze_327067 + (8 -
                                                                     shared_sizze_327067 %
                                                                     8) % 8) +
                                             (shared_sizze_327069 + (8 -
                                                                     shared_sizze_327069 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_311768 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_311767 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_311768;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327058[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327062,
                                          &shared_offset_327064,
                                          &shared_offset_327066,
                                          &shared_offset_327068,
                                          &shared_offset_327070,
                                          &shared_offset_327072, &n_292675,
                                          &q_l_292680, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &l_n_m_292832, &i_292846,
                                          &num_groups_311768,
                                          &ctx_param_ext_318833,
                                          &ctx_param_ext_318834,
                                          &ctx_param_ext_318836,
                                          &groups_per_segment_323879,
                                          &elements_per_thread_323880,
                                          &virt_num_groups_323881,
                                          &threads_per_segment_323883,
                                          &kernel_arg_327073,
                                          &kernel_arg_327074,
                                          &kernel_arg_327075,
                                          &kernel_arg_327076,
                                          &kernel_arg_327077,
                                          &kernel_arg_327078,
                                          &kernel_arg_327079,
                                          &kernel_arg_327080,
                                          &kernel_arg_327081,
                                          &kernel_arg_327082,
                                          &kernel_arg_327083,
                                          &kernel_arg_327084,
                                          &kernel_arg_327085,
                                          &kernel_arg_327086};
                                    int64_t time_start_327059 = 0,
                                            time_end_327060 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_large_311778",
                                                (long) num_groups_311768,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_311767,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327061 +
                                                                            (8 -
                                                                             shared_sizze_327061 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327063 +
                                                                            (8 -
                                                                             shared_sizze_327063 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327065 +
                                                                            (8 -
                                                                             shared_sizze_327065 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327067 +
                                                                            (8 -
                                                                             shared_sizze_327067 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327069 +
                                                                            (8 -
                                                                             shared_sizze_327069 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327071 +
                                                                            (8 -
                                                                             shared_sizze_327071 %
                                                                             8) %
                                                                            8)));
                                        time_start_327059 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_large_311778_runs,
                                                                  &ctx->mainzisegred_large_311778_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_311778,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_311767,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327061 +
                                                                           (8 -
                                                                            shared_sizze_327061 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327063 +
                                                                           (8 -
                                                                            shared_sizze_327063 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327065 +
                                                                           (8 -
                                                                            shared_sizze_327065 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327067 +
                                                                           (8 -
                                                                            shared_sizze_327067 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327069 +
                                                                           (8 -
                                                                            shared_sizze_327069 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327071 +
                                                                           (8 -
                                                                            shared_sizze_327071 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327058,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327060 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_large_311778",
                                                time_end_327060 -
                                                time_start_327059);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_323892,
                                                          "segred_tmp_mem_323892") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_323890,
                                                          "segred_tmp_mem_323890") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_323888,
                                                          "segred_tmp_mem_323888") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_323886,
                                                          "segred_tmp_mem_323886") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_323884,
                                                          "segred_tmp_mem_323884") !=
                                    0)
                                    return 1;
                            }
                            
                            int64_t segmap_group_sizze_311825;
                            
                            segmap_group_sizze_311825 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_311443;
                            
                            int64_t segmap_usable_groups_311826 =
                                    sdiv_up64(nest_sizze_300244,
                                              segmap_group_sizze_311825);
                            struct memblock_device mem_319725;
                            
                            mem_319725.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319725,
                                                      bytes_318723,
                                                      "mem_319725")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319729;
                            
                            mem_319729.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319729,
                                                      bytes_318723,
                                                      "mem_319729")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319733;
                            
                            mem_319733.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319733,
                                                      bytes_318723,
                                                      "mem_319733")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319737;
                            
                            mem_319737.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319737,
                                                      bytes_318723,
                                                      "mem_319737")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319741;
                            
                            mem_319741.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319741,
                                                      bytes_318723,
                                                      "mem_319741")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_327090 = mem_319704.mem;
                            CUdeviceptr kernel_arg_327091 = mem_319708.mem;
                            CUdeviceptr kernel_arg_327092 = mem_319712.mem;
                            CUdeviceptr kernel_arg_327093 = mem_319716.mem;
                            CUdeviceptr kernel_arg_327094 = mem_319720.mem;
                            CUdeviceptr kernel_arg_327095 = mem_319725.mem;
                            CUdeviceptr kernel_arg_327096 = mem_319729.mem;
                            CUdeviceptr kernel_arg_327097 = mem_319733.mem;
                            CUdeviceptr kernel_arg_327098 = mem_319737.mem;
                            CUdeviceptr kernel_arg_327099 = mem_319741.mem;
                            
                            if ((((((1 && segmap_usable_groups_311826 != 0) &&
                                    1 != 0) && 1 != 0) &&
                                  segmap_group_sizze_311825 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = segmap_usable_groups_311826;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327087[] =
                                     {&ctx->global_failure,
                                      &partition_sizze_292766, &l_n_m_292832,
                                      &kernel_arg_327090, &kernel_arg_327091,
                                      &kernel_arg_327092, &kernel_arg_327093,
                                      &kernel_arg_327094, &kernel_arg_327095,
                                      &kernel_arg_327096, &kernel_arg_327097,
                                      &kernel_arg_327098, &kernel_arg_327099};
                                int64_t time_start_327088 = 0, time_end_327089 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_311834",
                                            (long) segmap_usable_groups_311826,
                                            (long) 1, (long) 1,
                                            (long) segmap_group_sizze_311825,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_327088 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_311834_runs,
                                                              &ctx->mainzisegmap_311834_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_311834,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_311825,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_327087,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327089 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_311834",
                                            time_end_327089 -
                                            time_start_327088);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx, &mem_319704,
                                                      "mem_319704") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319708,
                                                      "mem_319708") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319712,
                                                      "mem_319712") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319716,
                                                      "mem_319716") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319720,
                                                      "mem_319720") != 0)
                                return 1;
                            
                            int64_t segred_group_sizze_311873;
                            
                            segred_group_sizze_311873 =
                                *ctx->tuning_params.mainzisegred_group_sizze_311358;
                            
                            int64_t num_groups_311874;
                            int32_t max_num_groups_323964;
                            
                            max_num_groups_323964 =
                                *ctx->tuning_params.mainzisegred_num_groups_311360;
                            num_groups_311874 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(nest_sizze_311766,
                                                                                     segred_group_sizze_311873),
                                                                           sext_i32_i64(max_num_groups_323964))));
                            
                            struct memblock_device mem_319746;
                            
                            mem_319746.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319746,
                                                      bytes_318723,
                                                      "mem_319746")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319750;
                            
                            mem_319750.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319750,
                                                      bytes_318723,
                                                      "mem_319750")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (slt64(q_l_292680 * (int64_t) 2,
                                      segred_group_sizze_311873)) {
                                int64_t segment_sizze_nonzzero_323965 =
                                        smax64((int64_t) 1, q_l_292680);
                                int64_t num_threads_323966 = num_groups_311874 *
                                        segred_group_sizze_311873;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-small");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         l_n_m_292832), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_l_292680, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segments_per_group",
                                            (long long) squot64(segred_group_sizze_311873,
                                                                segment_sizze_nonzzero_323965),
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "required_groups",
                                            (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                               l_n_m_292832,
                                                                               squot64(segred_group_sizze_311873,
                                                                                       segment_sizze_nonzzero_323965))),
                                            '\n');
                                
                                unsigned int shared_sizze_327103 = (int64_t) 8 *
                                             segred_group_sizze_311873;
                                unsigned int shared_sizze_327105 = (int64_t) 8 *
                                             segred_group_sizze_311873;
                                CUdeviceptr kernel_arg_327107 =
                                            ext_mem_318756.mem;
                                CUdeviceptr kernel_arg_327108 =
                                            ext_mem_318757.mem;
                                CUdeviceptr kernel_arg_327109 =
                                            mem_param_318838.mem;
                                CUdeviceptr kernel_arg_327110 = mem_319555.mem;
                                CUdeviceptr kernel_arg_327111 = mem_319725.mem;
                                CUdeviceptr kernel_arg_327112 = mem_319729.mem;
                                CUdeviceptr kernel_arg_327113 = mem_319733.mem;
                                CUdeviceptr kernel_arg_327114 = mem_319737.mem;
                                CUdeviceptr kernel_arg_327115 = mem_319741.mem;
                                CUdeviceptr kernel_arg_327116 = mem_319746.mem;
                                CUdeviceptr kernel_arg_327117 = mem_319750.mem;
                                unsigned int shared_offset_327104 = 0;
                                unsigned int shared_offset_327106 = 0 +
                                             (shared_sizze_327103 + (8 -
                                                                     shared_sizze_327103 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_311874 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_311873 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_311874;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327100[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327104,
                                          &shared_offset_327106, &n_292675,
                                          &q_l_292680, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &l_n_m_292832, &i_292846,
                                          &num_groups_311874,
                                          &ctx_param_ext_318833,
                                          &ctx_param_ext_318834,
                                          &ctx_param_ext_318836,
                                          &segment_sizze_nonzzero_323965,
                                          &kernel_arg_327107,
                                          &kernel_arg_327108,
                                          &kernel_arg_327109,
                                          &kernel_arg_327110,
                                          &kernel_arg_327111,
                                          &kernel_arg_327112,
                                          &kernel_arg_327113,
                                          &kernel_arg_327114,
                                          &kernel_arg_327115,
                                          &kernel_arg_327116,
                                          &kernel_arg_327117};
                                    int64_t time_start_327101 = 0,
                                            time_end_327102 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_small_311881",
                                                (long) num_groups_311874,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_311873,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327103 +
                                                                            (8 -
                                                                             shared_sizze_327103 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327105 +
                                                                            (8 -
                                                                             shared_sizze_327105 %
                                                                             8) %
                                                                            8)));
                                        time_start_327101 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_small_311881_runs,
                                                                  &ctx->mainzisegred_small_311881_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_311881,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_311873,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327103 +
                                                                           (8 -
                                                                            shared_sizze_327103 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327105 +
                                                                           (8 -
                                                                            shared_sizze_327105 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327100,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327102 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_small_311881",
                                                time_end_327102 -
                                                time_start_327101);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                            } else {
                                int64_t groups_per_segment_324000 =
                                        sdiv_up64(num_groups_311874,
                                                  smax64((int64_t) 1,
                                                         partition_sizze_292766 *
                                                         l_n_m_292832));
                                int64_t elements_per_thread_324001 =
                                        sdiv_up64(q_l_292680,
                                                  segred_group_sizze_311873 *
                                                  groups_per_segment_324000);
                                int64_t virt_num_groups_324002 =
                                        groups_per_segment_324000 *
                                        (partition_sizze_292766 * l_n_m_292832);
                                int64_t num_threads_324003 = num_groups_311874 *
                                        segred_group_sizze_311873;
                                int64_t threads_per_segment_324004 =
                                        groups_per_segment_324000 *
                                        segred_group_sizze_311873;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-large");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         l_n_m_292832), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_l_292680, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "virt_num_groups",
                                            (long long) virt_num_groups_324002,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_groups",
                                            (long long) num_groups_311874,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "group_size",
                                            (long long) segred_group_sizze_311873,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "elems_per_thread",
                                            (long long) elements_per_thread_324001,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "groups_per_segment",
                                            (long long) groups_per_segment_324000,
                                            '\n');
                                
                                struct memblock_device segred_tmp_mem_324005;
                                
                                segred_tmp_mem_324005.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324005,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324002,
                                                          "segred_tmp_mem_324005")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_324007;
                                
                                segred_tmp_mem_324007.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324007,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324002,
                                                          "segred_tmp_mem_324007")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mainzicounter_mem_324009
                                                       =
                                                       ctx->mainzicounter_mem_324009;
                                unsigned int shared_sizze_327122 = 1;
                                unsigned int shared_sizze_327124 = (int64_t) 8 *
                                             segred_group_sizze_311873;
                                unsigned int shared_sizze_327126 = (int64_t) 8 *
                                             segred_group_sizze_311873;
                                CUdeviceptr kernel_arg_327128 =
                                            ext_mem_318756.mem;
                                CUdeviceptr kernel_arg_327129 =
                                            ext_mem_318757.mem;
                                CUdeviceptr kernel_arg_327130 =
                                            mem_param_318838.mem;
                                CUdeviceptr kernel_arg_327131 = mem_319555.mem;
                                CUdeviceptr kernel_arg_327132 = mem_319725.mem;
                                CUdeviceptr kernel_arg_327133 = mem_319729.mem;
                                CUdeviceptr kernel_arg_327134 = mem_319733.mem;
                                CUdeviceptr kernel_arg_327135 = mem_319737.mem;
                                CUdeviceptr kernel_arg_327136 = mem_319741.mem;
                                CUdeviceptr kernel_arg_327137 = mem_319746.mem;
                                CUdeviceptr kernel_arg_327138 = mem_319750.mem;
                                CUdeviceptr kernel_arg_327139 =
                                            segred_tmp_mem_324005.mem;
                                CUdeviceptr kernel_arg_327140 =
                                            segred_tmp_mem_324007.mem;
                                CUdeviceptr kernel_arg_327141 =
                                            mainzicounter_mem_324009.mem;
                                unsigned int shared_offset_327123 = 0;
                                unsigned int shared_offset_327125 = 0 +
                                             (shared_sizze_327122 + (8 -
                                                                     shared_sizze_327122 %
                                                                     8) % 8);
                                unsigned int shared_offset_327127 = 0 +
                                             (shared_sizze_327122 + (8 -
                                                                     shared_sizze_327122 %
                                                                     8) % 8) +
                                             (shared_sizze_327124 + (8 -
                                                                     shared_sizze_327124 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_311874 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_311873 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_311874;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327119[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327123,
                                          &shared_offset_327125,
                                          &shared_offset_327127, &n_292675,
                                          &q_l_292680, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &l_n_m_292832, &i_292846,
                                          &num_groups_311874,
                                          &ctx_param_ext_318833,
                                          &ctx_param_ext_318834,
                                          &ctx_param_ext_318836,
                                          &groups_per_segment_324000,
                                          &elements_per_thread_324001,
                                          &virt_num_groups_324002,
                                          &threads_per_segment_324004,
                                          &kernel_arg_327128,
                                          &kernel_arg_327129,
                                          &kernel_arg_327130,
                                          &kernel_arg_327131,
                                          &kernel_arg_327132,
                                          &kernel_arg_327133,
                                          &kernel_arg_327134,
                                          &kernel_arg_327135,
                                          &kernel_arg_327136,
                                          &kernel_arg_327137,
                                          &kernel_arg_327138,
                                          &kernel_arg_327139,
                                          &kernel_arg_327140,
                                          &kernel_arg_327141};
                                    int64_t time_start_327120 = 0,
                                            time_end_327121 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_large_311881",
                                                (long) num_groups_311874,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_311873,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327122 +
                                                                            (8 -
                                                                             shared_sizze_327122 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327124 +
                                                                            (8 -
                                                                             shared_sizze_327124 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327126 +
                                                                            (8 -
                                                                             shared_sizze_327126 %
                                                                             8) %
                                                                            8)));
                                        time_start_327120 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_large_311881_runs,
                                                                  &ctx->mainzisegred_large_311881_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_311881,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_311873,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327122 +
                                                                           (8 -
                                                                            shared_sizze_327122 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327124 +
                                                                           (8 -
                                                                            shared_sizze_327124 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327126 +
                                                                           (8 -
                                                                            shared_sizze_327126 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327119,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327121 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_large_311881",
                                                time_end_327121 -
                                                time_start_327120);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324007,
                                                          "segred_tmp_mem_324007") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324005,
                                                          "segred_tmp_mem_324005") !=
                                    0)
                                    return 1;
                            }
                            if (memblock_unref_device(ctx, &mem_319725,
                                                      "mem_319725") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319729,
                                                      "mem_319729") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319733,
                                                      "mem_319733") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319737,
                                                      "mem_319737") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319741,
                                                      "mem_319741") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319752,
                                                    &mem_319746,
                                                    "mem_319746") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319751,
                                                    &mem_319750,
                                                    "mem_319750") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319750,
                                                      "mem_319750") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319746,
                                                      "mem_319746") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319741,
                                                      "mem_319741") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319737,
                                                      "mem_319737") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319733,
                                                      "mem_319733") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319729,
                                                      "mem_319729") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319725,
                                                      "mem_319725") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319720,
                                                      "mem_319720") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319716,
                                                      "mem_319716") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319712,
                                                      "mem_319712") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319708,
                                                      "mem_319708") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319704,
                                                      "mem_319704") != 0)
                                return 1;
                        }
                        if (memblock_set_device(ctx, &ext_mem_319754,
                                                &ext_mem_319752,
                                                "ext_mem_319752") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319753,
                                                &ext_mem_319751,
                                                "ext_mem_319751") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319751,
                                                  "ext_mem_319751") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319752,
                                                  "ext_mem_319752") != 0)
                            return 1;
                    }
                    if (memblock_set_device(ctx, &ext_mem_319756,
                                            &ext_mem_319754,
                                            "ext_mem_319754") != 0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_319755,
                                            &ext_mem_319753,
                                            "ext_mem_319753") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319753,
                                              "ext_mem_319753") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319754,
                                              "ext_mem_319754") != 0)
                        return 1;
                }
                if (memblock_set_device(ctx, &ext_mem_319758, &ext_mem_319756,
                                        "ext_mem_319756") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_319757, &ext_mem_319755,
                                        "ext_mem_319755") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_319755,
                                          "ext_mem_319755") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_319756,
                                          "ext_mem_319756") != 0)
                    return 1;
            }
            
            struct memblock_device ext_mem_319764;
            
            ext_mem_319764.references = NULL;
            if (cond_293285) {
                bool zzero_295740 = jump_l_292686 == (int64_t) 0;
                bool nonzzero_295741 = !zzero_295740;
                bool nonzzero_cert_295742;
                
                if (!nonzzero_295741) {
                    ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                           "division by zero",
                                           "-> #0  loess.fut:742:20-27\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:741:3-745:9\n   #5  stl.fut:256:23-75\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:254:15-257:43\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                    if (memblock_unref_device(ctx, &ext_mem_319764,
                                              "ext_mem_319764") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319757,
                                              "ext_mem_319757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319758,
                                              "ext_mem_319758") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319550,
                                              "ext_mem_319550") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319533,
                                              "ext_mem_319533") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319516,
                                              "ext_mem_319516") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319498,
                                              "ext_mem_319498") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319490,
                                              "ext_mem_319490") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319491,
                                              "ext_mem_319491") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t y_295743 = sub64(l_n_m_292832, (int64_t) 1);
                int64_t segmap_group_sizze_312074;
                
                segmap_group_sizze_312074 =
                    *ctx->tuning_params.mainzisegmap_group_sizze_311956;
                
                int64_t segmap_usable_groups_312075 =
                        sdiv_up64(nest_sizze_297748, segmap_group_sizze_312074);
                struct memblock_device mem_319763;
                
                mem_319763.references = NULL;
                if (memblock_alloc_device(ctx, &mem_319763, bytes_318522,
                                          "mem_319763")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_327145 = ext_mem_319757.mem;
                CUdeviceptr kernel_arg_327146 = ext_mem_319758.mem;
                CUdeviceptr kernel_arg_327147 = mem_319763.mem;
                
                if ((((((1 && segmap_usable_groups_312075 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_312074 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_312075;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327142[] = {&ctx->global_failure,
                                                  &ctx->failure_is_an_option,
                                                  &ctx->global_failure_args,
                                                  &n_292675, &jump_l_292686,
                                                  &partition_sizze_292766,
                                                  &l_n_m_292832, &i_292846,
                                                  &y_295743, &kernel_arg_327145,
                                                  &kernel_arg_327146,
                                                  &kernel_arg_327147};
                    int64_t time_start_327143 = 0, time_end_327144 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_312079",
                                (long) segmap_usable_groups_312075, (long) 1,
                                (long) 1, (long) segmap_group_sizze_312074,
                                (long) 1, (long) 1, (int) 0);
                        time_start_327143 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_312079_runs,
                                                  &ctx->mainzisegmap_312079_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_312079,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_312074,
                                                          1, 1, 0, NULL,
                                                          kernel_args_327142,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327144 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_312079", time_end_327144 -
                                time_start_327143);
                    }
                }
                ctx->failure_is_an_option = 1;
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_set_device(ctx, &ext_mem_319764, &mem_319763,
                                        "mem_319763") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319763, "mem_319763") != 0)
                    return 1;
            } else {
                bool dim_match_295795 = n_292675 == l_n_m_292832;
                bool empty_or_match_cert_295796;
                
                if (!dim_match_295795) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Value of (core language) shape (",
                                  (long long) partition_sizze_292766, ", ",
                                  (long long) l_n_m_292832,
                                  ") cannot match shape of type `[",
                                  (long long) partition_sizze_292766, "][",
                                  (long long) n_292675, "]t`.",
                                  "-> #0  stl.fut:259:15-36\n   #1  stl.fut:419:61-435:77\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
                    if (memblock_unref_device(ctx, &ext_mem_319764,
                                              "ext_mem_319764") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319757,
                                              "ext_mem_319757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319758,
                                              "ext_mem_319758") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319550,
                                              "ext_mem_319550") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319533,
                                              "ext_mem_319533") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319516,
                                              "ext_mem_319516") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319498,
                                              "ext_mem_319498") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319490,
                                              "ext_mem_319490") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319491,
                                              "ext_mem_319491") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                if (memblock_set_device(ctx, &ext_mem_319764, &ext_mem_319758,
                                        "ext_mem_319758") != 0)
                    return 1;
            }
            if (memblock_unref_device(ctx, &ext_mem_319757, "ext_mem_319757") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_319758, "ext_mem_319758") !=
                0)
                return 1;
            
            struct memblock_device mem_319770;
            
            mem_319770.references = NULL;
            if (memblock_alloc_device(ctx, &mem_319770, bytes_318522,
                                      "mem_319770")) {
                err = 1;
                goto cleanup;
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            CUdeviceptr kernel_arg_327151 = mem_319504.mem;
            CUdeviceptr kernel_arg_327152 = ext_mem_319764.mem;
            CUdeviceptr kernel_arg_327153 = mem_319770.mem;
            
            if ((((((1 && segmap_usable_groups_312170 != 0) && 1 != 0) && 1 !=
                   0) && segmap_group_sizze_312169 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = segmap_usable_groups_312170;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_327148[] = {&ctx->global_failure, &n_292675,
                                              &n_p_292677,
                                              &partition_sizze_292766,
                                              &C_len_292823, &ext_319765,
                                              &kernel_arg_327151,
                                              &kernel_arg_327152,
                                              &kernel_arg_327153};
                int64_t time_start_327149 = 0, time_end_327150 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_312174",
                            (long) segmap_usable_groups_312170, (long) 1,
                            (long) 1, (long) segmap_group_sizze_312169,
                            (long) 1, (long) 1, (int) 0);
                    time_start_327149 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_312174_runs,
                                              &ctx->mainzisegmap_312174_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_312174,
                                                      grid[0], grid[1], grid[2],
                                                      segmap_group_sizze_312169,
                                                      1, 1, 0, NULL,
                                                      kernel_args_327148,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_327150 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_312174", time_end_327150 -
                            time_start_327149);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            if (memblock_unref_device(ctx, &ext_mem_319764, "ext_mem_319764") !=
                0)
                return 1;
            
            struct memblock_device ext_mem_320099;
            
            ext_mem_320099.references = NULL;
            
            struct memblock_device ext_mem_320098;
            
            ext_mem_320098.references = NULL;
            if (cond_293346) {
                bool match_lit_295808 = (int64_t) 0 == d_t_292682;
                struct memblock_device ext_mem_319843;
                
                ext_mem_319843.references = NULL;
                
                struct memblock_device ext_mem_319842;
                
                ext_mem_319842.references = NULL;
                if (match_lit_295808) {
                    struct memblock_device mem_319774;
                    
                    mem_319774.references = NULL;
                    if (memblock_alloc_device(ctx, &mem_319774, bytes_318772,
                                              "mem_319774")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (futrts_builtinzhreplicate_f64(ctx, mem_319774,
                                                      partition_sizze_292766 *
                                                      t_n_m_292839, 0.0) != 0) {
                        if (memblock_unref_device(ctx, &mem_319774,
                                                  "mem_319774") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319842,
                                                  "ext_mem_319842") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319843,
                                                  "ext_mem_319843") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320098,
                                                  "ext_mem_320098") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320099,
                                                  "ext_mem_320099") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319770,
                                                  "mem_319770") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319764,
                                                  "ext_mem_319764") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319757,
                                                  "ext_mem_319757") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319758,
                                                  "ext_mem_319758") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319550,
                                                  "ext_mem_319550") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319533,
                                                  "ext_mem_319533") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319516,
                                                  "ext_mem_319516") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319498,
                                                  "ext_mem_319498") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319490,
                                                  "ext_mem_319490") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319491,
                                                  "ext_mem_319491") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318860,
                                                  "mem_param_318860") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318852,
                                                  "mem_param_318852") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320111,
                                                  "ext_mem_320111") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320112,
                                                  "ext_mem_320112") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318838,
                                                  "mem_param_318838") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318830,
                                                  "mem_param_318830") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318822,
                                                  "mem_param_318822") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320430,
                                                  "ext_mem_320430") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320431,
                                                  "ext_mem_320431") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320432,
                                                  "ext_mem_320432") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319555,
                                                  "mem_319555") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319538,
                                                  "mem_319538") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319521,
                                                  "mem_319521") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319504,
                                                  "mem_319504") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318876,
                                                  "mem_318876") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318871,
                                                  "mem_318871") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318865,
                                                  "mem_318865") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318814,
                                                  "mem_318814") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318810,
                                                  "mem_318810") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318805,
                                                  "ext_mem_318805") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318806,
                                                  "ext_mem_318806") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318756,
                                                  "ext_mem_318756") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318757,
                                                  "ext_mem_318757") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318707,
                                                  "ext_mem_318707") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318708,
                                                  "ext_mem_318708") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318609,
                                                  "ext_mem_318609") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318610,
                                                  "ext_mem_318610") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318551,
                                                  "mem_318551") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318545,
                                                  "mem_318545") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318541,
                                                  "ext_mem_318541") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318542,
                                                  "ext_mem_318542") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318509,
                                                  "mem_318509") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318506,
                                                  "mem_318506") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318502,
                                                  "mem_318502") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318500,
                                                  "mem_318500") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318497,
                                                  "mem_318497") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318493,
                                                  "mem_318493") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320825,
                                                  "mem_out_320825") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320824,
                                                  "mem_out_320824") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320823,
                                                  "mem_out_320823") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t segmap_group_sizze_312367;
                    
                    segmap_group_sizze_312367 =
                        *ctx->tuning_params.mainzisegmap_group_sizze_312339;
                    
                    int64_t segmap_usable_groups_312368 =
                            sdiv_up64(nest_sizze_297748,
                                      segmap_group_sizze_312367);
                    struct memblock_device mem_319779;
                    
                    mem_319779.references = NULL;
                    if (memblock_alloc_device(ctx, &mem_319779, bytes_318522,
                                              "mem_319779")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegMap");
                    
                    CUdeviceptr kernel_arg_327157 = mem_318506.mem;
                    CUdeviceptr kernel_arg_327158 = mem_319770.mem;
                    CUdeviceptr kernel_arg_327159 = mem_319779.mem;
                    
                    if ((((((1 && segmap_usable_groups_312368 != 0) && 1 !=
                            0) && 1 != 0) && segmap_group_sizze_312367 != 0) &&
                         1 != 0) && 1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = segmap_usable_groups_312368;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_327154[] = {&ctx->global_failure,
                                                      &n_292675,
                                                      &partition_sizze_292766,
                                                      &kernel_arg_327157,
                                                      &kernel_arg_327158,
                                                      &kernel_arg_327159};
                        int64_t time_start_327155 = 0, time_end_327156 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segmap_312372",
                                    (long) segmap_usable_groups_312368,
                                    (long) 1, (long) 1,
                                    (long) segmap_group_sizze_312367, (long) 1,
                                    (long) 1, (int) 0);
                            time_start_327155 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegmap_312372_runs,
                                                      &ctx->mainzisegmap_312372_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_312372,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segmap_group_sizze_312367,
                                                              1, 1, 0, NULL,
                                                              kernel_args_327154,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_327156 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segmap_312372", time_end_327156 -
                                    time_start_327155);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                    
                    int64_t segmap_group_sizze_312384;
                    
                    segmap_group_sizze_312384 =
                        *ctx->tuning_params.mainzisegmap_group_sizze_312283;
                    
                    int64_t segmap_usable_groups_312385 =
                            sdiv_up64(nest_sizze_297748,
                                      segmap_group_sizze_312384);
                    struct memblock_device mem_319784;
                    
                    mem_319784.references = NULL;
                    if (memblock_alloc_device(ctx, &mem_319784, bytes_318522,
                                              "mem_319784")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device mem_319788;
                    
                    mem_319788.references = NULL;
                    if (memblock_alloc_device(ctx, &mem_319788, bytes_318522,
                                              "mem_319788")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegMap");
                    
                    CUdeviceptr kernel_arg_327163 = ext_mem_318542.mem;
                    CUdeviceptr kernel_arg_327164 = mem_param_318838.mem;
                    CUdeviceptr kernel_arg_327165 = mem_319779.mem;
                    CUdeviceptr kernel_arg_327166 = mem_319784.mem;
                    CUdeviceptr kernel_arg_327167 = mem_319788.mem;
                    
                    if ((((((1 && segmap_usable_groups_312385 != 0) && 1 !=
                            0) && 1 != 0) && segmap_group_sizze_312384 != 0) &&
                         1 != 0) && 1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = segmap_usable_groups_312385;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_327160[] = {&ctx->global_failure,
                                                      &ctx->failure_is_an_option,
                                                      &ctx->global_failure_args,
                                                      &n_292675,
                                                      &partition_sizze_292766,
                                                      &ctx_param_ext_318833,
                                                      &ctx_param_ext_318834,
                                                      &ctx_param_ext_318836,
                                                      &kernel_arg_327163,
                                                      &kernel_arg_327164,
                                                      &kernel_arg_327165,
                                                      &kernel_arg_327166,
                                                      &kernel_arg_327167};
                        int64_t time_start_327161 = 0, time_end_327162 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segmap_312390",
                                    (long) segmap_usable_groups_312385,
                                    (long) 1, (long) 1,
                                    (long) segmap_group_sizze_312384, (long) 1,
                                    (long) 1, (int) 0);
                            time_start_327161 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegmap_312390_runs,
                                                      &ctx->mainzisegmap_312390_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_312390,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segmap_group_sizze_312384,
                                                              1, 1, 0, NULL,
                                                              kernel_args_327160,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_327162 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segmap_312390", time_end_327162 -
                                    time_start_327161);
                        }
                    }
                    ctx->failure_is_an_option = 1;
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                    if (memblock_unref_device(ctx, &mem_319779, "mem_319779") !=
                        0)
                        return 1;
                    
                    int64_t segmap_group_sizze_312409;
                    
                    segmap_group_sizze_312409 =
                        *ctx->tuning_params.mainzisegmap_group_sizze_312186;
                    
                    int64_t segmap_usable_groups_312410 =
                            sdiv_up64(nest_sizze_300870,
                                      segmap_group_sizze_312409);
                    struct memblock_device mem_319793;
                    
                    mem_319793.references = NULL;
                    if (memblock_alloc_device(ctx, &mem_319793, bytes_318772,
                                              "mem_319793")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegMap");
                    
                    CUdeviceptr kernel_arg_327171 = ext_mem_318541.mem;
                    CUdeviceptr kernel_arg_327172 = ext_mem_318542.mem;
                    CUdeviceptr kernel_arg_327173 = ext_mem_318805.mem;
                    CUdeviceptr kernel_arg_327174 = ext_mem_318806.mem;
                    CUdeviceptr kernel_arg_327175 = mem_319784.mem;
                    CUdeviceptr kernel_arg_327176 = mem_319788.mem;
                    CUdeviceptr kernel_arg_327177 = mem_319793.mem;
                    
                    if ((((((1 && segmap_usable_groups_312410 != 0) && 1 !=
                            0) && 1 != 0) && segmap_group_sizze_312409 != 0) &&
                         1 != 0) && 1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = segmap_usable_groups_312410;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_327168[] = {&ctx->global_failure,
                                                      &n_292675, &q_t_292679,
                                                      &jump_t_292685,
                                                      &partition_sizze_292766,
                                                      &t_n_m_292839, &i_292846,
                                                      &kernel_arg_327171,
                                                      &kernel_arg_327172,
                                                      &kernel_arg_327173,
                                                      &kernel_arg_327174,
                                                      &kernel_arg_327175,
                                                      &kernel_arg_327176,
                                                      &kernel_arg_327177};
                        int64_t time_start_327169 = 0, time_end_327170 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segmap_312414",
                                    (long) segmap_usable_groups_312410,
                                    (long) 1, (long) 1,
                                    (long) segmap_group_sizze_312409, (long) 1,
                                    (long) 1, (int) 0);
                            time_start_327169 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegmap_312414_runs,
                                                      &ctx->mainzisegmap_312414_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_312414,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segmap_group_sizze_312409,
                                                              1, 1, 0, NULL,
                                                              kernel_args_327168,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_327170 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segmap_312414", time_end_327170 -
                                    time_start_327169);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                    if (memblock_unref_device(ctx, &mem_319784, "mem_319784") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319788, "mem_319788") !=
                        0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_319843, &mem_319793,
                                            "mem_319793") != 0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_319842, &mem_319774,
                                            "mem_319774") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319793, "mem_319793") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319788, "mem_319788") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319784, "mem_319784") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319779, "mem_319779") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319774, "mem_319774") !=
                        0)
                        return 1;
                } else {
                    bool match_lit_295904 = (int64_t) 1 == d_t_292682;
                    struct memblock_device ext_mem_319841;
                    
                    ext_mem_319841.references = NULL;
                    
                    struct memblock_device ext_mem_319840;
                    
                    ext_mem_319840.references = NULL;
                    if (match_lit_295904) {
                        int64_t segmap_group_sizze_312698;
                        
                        segmap_group_sizze_312698 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_312670;
                        
                        int64_t segmap_usable_groups_312699 =
                                sdiv_up64(nest_sizze_297748,
                                          segmap_group_sizze_312698);
                        struct memblock_device mem_319798;
                        
                        mem_319798.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319798,
                                                  bytes_318522, "mem_319798")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_327181 = mem_318506.mem;
                        CUdeviceptr kernel_arg_327182 = mem_319770.mem;
                        CUdeviceptr kernel_arg_327183 = mem_319798.mem;
                        
                        if ((((((1 && segmap_usable_groups_312699 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_312698 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_312699;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_327178[] = {&ctx->global_failure,
                                                          &n_292675,
                                                          &partition_sizze_292766,
                                                          &kernel_arg_327181,
                                                          &kernel_arg_327182,
                                                          &kernel_arg_327183};
                            int64_t time_start_327179 = 0, time_end_327180 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_312703",
                                        (long) segmap_usable_groups_312699,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_312698,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_327179 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_312703_runs,
                                                          &ctx->mainzisegmap_312703_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_312703,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_312698,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_327178,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_327180 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_312703", time_end_327180 -
                                        time_start_327179);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        
                        int64_t segmap_group_sizze_312715;
                        
                        segmap_group_sizze_312715 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_312614;
                        
                        int64_t segmap_usable_groups_312716 =
                                sdiv_up64(nest_sizze_297748,
                                          segmap_group_sizze_312715);
                        struct memblock_device mem_319803;
                        
                        mem_319803.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319803,
                                                  bytes_318522, "mem_319803")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock_device mem_319807;
                        
                        mem_319807.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319807,
                                                  bytes_318522, "mem_319807")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_327187 = ext_mem_318542.mem;
                        CUdeviceptr kernel_arg_327188 = mem_param_318838.mem;
                        CUdeviceptr kernel_arg_327189 = mem_319798.mem;
                        CUdeviceptr kernel_arg_327190 = mem_319803.mem;
                        CUdeviceptr kernel_arg_327191 = mem_319807.mem;
                        
                        if ((((((1 && segmap_usable_groups_312716 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_312715 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_312716;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_327184[] = {&ctx->global_failure,
                                                          &ctx->failure_is_an_option,
                                                          &ctx->global_failure_args,
                                                          &n_292675,
                                                          &partition_sizze_292766,
                                                          &ctx_param_ext_318833,
                                                          &ctx_param_ext_318834,
                                                          &ctx_param_ext_318836,
                                                          &kernel_arg_327187,
                                                          &kernel_arg_327188,
                                                          &kernel_arg_327189,
                                                          &kernel_arg_327190,
                                                          &kernel_arg_327191};
                            int64_t time_start_327185 = 0, time_end_327186 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_312721",
                                        (long) segmap_usable_groups_312716,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_312715,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_327185 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_312721_runs,
                                                          &ctx->mainzisegmap_312721_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_312721,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_312715,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_327184,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_327186 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_312721", time_end_327186 -
                                        time_start_327185);
                            }
                        }
                        ctx->failure_is_an_option = 1;
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_unref_device(ctx, &mem_319798,
                                                  "mem_319798") != 0)
                            return 1;
                        
                        int64_t segmap_group_sizze_312740;
                        
                        segmap_group_sizze_312740 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_312486;
                        
                        int64_t segmap_usable_groups_312741 =
                                sdiv_up64(nest_sizze_300870,
                                          segmap_group_sizze_312740);
                        struct memblock_device mem_319812;
                        
                        mem_319812.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319812,
                                                  bytes_318772, "mem_319812")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock_device mem_319816;
                        
                        mem_319816.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319816,
                                                  bytes_318772, "mem_319816")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_327195 = ext_mem_318541.mem;
                        CUdeviceptr kernel_arg_327196 = ext_mem_318542.mem;
                        CUdeviceptr kernel_arg_327197 = ext_mem_318805.mem;
                        CUdeviceptr kernel_arg_327198 = ext_mem_318806.mem;
                        CUdeviceptr kernel_arg_327199 = mem_319803.mem;
                        CUdeviceptr kernel_arg_327200 = mem_319807.mem;
                        CUdeviceptr kernel_arg_327201 = mem_319812.mem;
                        CUdeviceptr kernel_arg_327202 = mem_319816.mem;
                        
                        if ((((((1 && segmap_usable_groups_312741 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_312740 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_312741;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_327192[] = {&ctx->global_failure,
                                                          &n_292675,
                                                          &q_t_292679,
                                                          &jump_t_292685,
                                                          &partition_sizze_292766,
                                                          &t_n_m_292839,
                                                          &i_292846,
                                                          &kernel_arg_327195,
                                                          &kernel_arg_327196,
                                                          &kernel_arg_327197,
                                                          &kernel_arg_327198,
                                                          &kernel_arg_327199,
                                                          &kernel_arg_327200,
                                                          &kernel_arg_327201,
                                                          &kernel_arg_327202};
                            int64_t time_start_327193 = 0, time_end_327194 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_312746",
                                        (long) segmap_usable_groups_312741,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_312740,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_327193 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_312746_runs,
                                                          &ctx->mainzisegmap_312746_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_312746,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_312740,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_327192,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_327194 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_312746", time_end_327194 -
                                        time_start_327193);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_unref_device(ctx, &mem_319803,
                                                  "mem_319803") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319807,
                                                  "mem_319807") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319841,
                                                &mem_319812, "mem_319812") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319840,
                                                &mem_319816, "mem_319816") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319816,
                                                  "mem_319816") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319812,
                                                  "mem_319812") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319807,
                                                  "mem_319807") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319803,
                                                  "mem_319803") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319798,
                                                  "mem_319798") != 0)
                            return 1;
                    } else {
                        int64_t segmap_group_sizze_313095;
                        
                        segmap_group_sizze_313095 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_313067;
                        
                        int64_t segmap_usable_groups_313096 =
                                sdiv_up64(nest_sizze_297748,
                                          segmap_group_sizze_313095);
                        struct memblock_device mem_319821;
                        
                        mem_319821.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319821,
                                                  bytes_318522, "mem_319821")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_327206 = mem_318506.mem;
                        CUdeviceptr kernel_arg_327207 = mem_319770.mem;
                        CUdeviceptr kernel_arg_327208 = mem_319821.mem;
                        
                        if ((((((1 && segmap_usable_groups_313096 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_313095 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_313096;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_327203[] = {&ctx->global_failure,
                                                          &n_292675,
                                                          &partition_sizze_292766,
                                                          &kernel_arg_327206,
                                                          &kernel_arg_327207,
                                                          &kernel_arg_327208};
                            int64_t time_start_327204 = 0, time_end_327205 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_313100",
                                        (long) segmap_usable_groups_313096,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_313095,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_327204 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_313100_runs,
                                                          &ctx->mainzisegmap_313100_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_313100,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_313095,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_327203,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_327205 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_313100", time_end_327205 -
                                        time_start_327204);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        
                        int64_t segmap_group_sizze_313112;
                        
                        segmap_group_sizze_313112 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_313011;
                        
                        int64_t segmap_usable_groups_313113 =
                                sdiv_up64(nest_sizze_297748,
                                          segmap_group_sizze_313112);
                        struct memblock_device mem_319826;
                        
                        mem_319826.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319826,
                                                  bytes_318522, "mem_319826")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock_device mem_319830;
                        
                        mem_319830.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319830,
                                                  bytes_318522, "mem_319830")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_327212 = ext_mem_318542.mem;
                        CUdeviceptr kernel_arg_327213 = mem_param_318838.mem;
                        CUdeviceptr kernel_arg_327214 = mem_319821.mem;
                        CUdeviceptr kernel_arg_327215 = mem_319826.mem;
                        CUdeviceptr kernel_arg_327216 = mem_319830.mem;
                        
                        if ((((((1 && segmap_usable_groups_313113 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_313112 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_313113;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_327209[] = {&ctx->global_failure,
                                                          &ctx->failure_is_an_option,
                                                          &ctx->global_failure_args,
                                                          &n_292675,
                                                          &partition_sizze_292766,
                                                          &ctx_param_ext_318833,
                                                          &ctx_param_ext_318834,
                                                          &ctx_param_ext_318836,
                                                          &kernel_arg_327212,
                                                          &kernel_arg_327213,
                                                          &kernel_arg_327214,
                                                          &kernel_arg_327215,
                                                          &kernel_arg_327216};
                            int64_t time_start_327210 = 0, time_end_327211 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_313118",
                                        (long) segmap_usable_groups_313113,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_313112,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_327210 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_313118_runs,
                                                          &ctx->mainzisegmap_313118_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_313118,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_313112,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_327209,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_327211 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_313118", time_end_327211 -
                                        time_start_327210);
                            }
                        }
                        ctx->failure_is_an_option = 1;
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_unref_device(ctx, &mem_319821,
                                                  "mem_319821") != 0)
                            return 1;
                        
                        int64_t segmap_group_sizze_313137;
                        
                        segmap_group_sizze_313137 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_312849;
                        
                        int64_t segmap_usable_groups_313138 =
                                sdiv_up64(nest_sizze_300870,
                                          segmap_group_sizze_313137);
                        struct memblock_device mem_319835;
                        
                        mem_319835.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319835,
                                                  bytes_318772, "mem_319835")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock_device mem_319839;
                        
                        mem_319839.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319839,
                                                  bytes_318772, "mem_319839")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_327220 = ext_mem_318541.mem;
                        CUdeviceptr kernel_arg_327221 = ext_mem_318542.mem;
                        CUdeviceptr kernel_arg_327222 = ext_mem_318805.mem;
                        CUdeviceptr kernel_arg_327223 = ext_mem_318806.mem;
                        CUdeviceptr kernel_arg_327224 = mem_319826.mem;
                        CUdeviceptr kernel_arg_327225 = mem_319830.mem;
                        CUdeviceptr kernel_arg_327226 = mem_319835.mem;
                        CUdeviceptr kernel_arg_327227 = mem_319839.mem;
                        
                        if ((((((1 && segmap_usable_groups_313138 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_313137 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_313138;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_327217[] = {&ctx->global_failure,
                                                          &n_292675,
                                                          &q_t_292679,
                                                          &jump_t_292685,
                                                          &partition_sizze_292766,
                                                          &t_n_m_292839,
                                                          &i_292846,
                                                          &kernel_arg_327220,
                                                          &kernel_arg_327221,
                                                          &kernel_arg_327222,
                                                          &kernel_arg_327223,
                                                          &kernel_arg_327224,
                                                          &kernel_arg_327225,
                                                          &kernel_arg_327226,
                                                          &kernel_arg_327227};
                            int64_t time_start_327218 = 0, time_end_327219 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_313143",
                                        (long) segmap_usable_groups_313138,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_313137,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_327218 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_313143_runs,
                                                          &ctx->mainzisegmap_313143_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_313143,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_313137,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_327217,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_327219 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_313143", time_end_327219 -
                                        time_start_327218);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_unref_device(ctx, &mem_319826,
                                                  "mem_319826") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319830,
                                                  "mem_319830") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319841,
                                                &mem_319835, "mem_319835") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319840,
                                                &mem_319839, "mem_319839") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319839,
                                                  "mem_319839") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319835,
                                                  "mem_319835") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319830,
                                                  "mem_319830") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319826,
                                                  "mem_319826") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319821,
                                                  "mem_319821") != 0)
                            return 1;
                    }
                    if (memblock_set_device(ctx, &ext_mem_319843,
                                            &ext_mem_319841,
                                            "ext_mem_319841") != 0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_319842,
                                            &ext_mem_319840,
                                            "ext_mem_319840") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319840,
                                              "ext_mem_319840") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319841,
                                              "ext_mem_319841") != 0)
                        return 1;
                }
                if (memblock_set_device(ctx, &ext_mem_320099, &ext_mem_319843,
                                        "ext_mem_319843") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_320098, &ext_mem_319842,
                                        "ext_mem_319842") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_319842,
                                          "ext_mem_319842") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_319843,
                                          "ext_mem_319843") != 0)
                    return 1;
            } else {
                bool cond_296189 = sle64(jump_threshold_2_292690,
                                         jump_t_292685);
                bool cond_t_res_296190 = slt64(q_t_292679,
                                               q_threshold_1_292691);
                bool x_296191 = cond_296189 && cond_t_res_296190;
                struct memblock_device ext_mem_320097;
                
                ext_mem_320097.references = NULL;
                
                struct memblock_device ext_mem_320096;
                
                ext_mem_320096.references = NULL;
                if (x_296191) {
                    bool match_lit_296194 = (int64_t) 0 == d_t_292682;
                    int64_t binop_y_319864 = (int64_t) 8 * q_t_292679;
                    int64_t bytes_319865 = smax64((int64_t) 0, binop_y_319864);
                    struct memblock_device ext_mem_319944;
                    
                    ext_mem_319944.references = NULL;
                    
                    struct memblock_device ext_mem_319943;
                    
                    ext_mem_319943.references = NULL;
                    if (match_lit_296194) {
                        struct memblock_device mem_319847;
                        
                        mem_319847.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319847,
                                                  bytes_318772, "mem_319847")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (futrts_builtinzhreplicate_f64(ctx, mem_319847,
                                                          partition_sizze_292766 *
                                                          t_n_m_292839, 0.0) !=
                            0) {
                            if (memblock_unref_device(ctx, &mem_319847,
                                                      "mem_319847") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319943,
                                                      "ext_mem_319943") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319944,
                                                      "ext_mem_319944") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320096,
                                                      "ext_mem_320096") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320097,
                                                      "ext_mem_320097") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320098,
                                                      "ext_mem_320098") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320099,
                                                      "ext_mem_320099") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319770,
                                                      "mem_319770") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319764,
                                                      "ext_mem_319764") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319757,
                                                      "ext_mem_319757") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319758,
                                                      "ext_mem_319758") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319550,
                                                      "ext_mem_319550") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319533,
                                                      "ext_mem_319533") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319516,
                                                      "ext_mem_319516") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319498,
                                                      "ext_mem_319498") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319490,
                                                      "ext_mem_319490") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319491,
                                                      "ext_mem_319491") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318860,
                                                      "mem_param_318860") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318852,
                                                      "mem_param_318852") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320111,
                                                      "ext_mem_320111") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320112,
                                                      "ext_mem_320112") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318838,
                                                      "mem_param_318838") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318830,
                                                      "mem_param_318830") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318822,
                                                      "mem_param_318822") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320430,
                                                      "ext_mem_320430") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320431,
                                                      "ext_mem_320431") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320432,
                                                      "ext_mem_320432") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319555,
                                                      "mem_319555") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319538,
                                                      "mem_319538") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319521,
                                                      "mem_319521") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319504,
                                                      "mem_319504") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318876,
                                                      "mem_318876") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318871,
                                                      "mem_318871") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318865,
                                                      "mem_318865") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318814,
                                                      "mem_318814") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318810,
                                                      "mem_318810") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318805,
                                                      "ext_mem_318805") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318806,
                                                      "ext_mem_318806") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318756,
                                                      "ext_mem_318756") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318757,
                                                      "ext_mem_318757") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318707,
                                                      "ext_mem_318707") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318708,
                                                      "ext_mem_318708") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318609,
                                                      "ext_mem_318609") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318610,
                                                      "ext_mem_318610") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318551,
                                                      "mem_318551") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318545,
                                                      "mem_318545") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318541,
                                                      "ext_mem_318541") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318542,
                                                      "ext_mem_318542") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318509,
                                                      "mem_318509") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318506,
                                                      "mem_318506") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318502,
                                                      "mem_318502") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318500,
                                                      "mem_318500") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318497,
                                                      "mem_318497") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318493,
                                                      "mem_318493") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320825,
                                                      "mem_out_320825") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320824,
                                                      "mem_out_320824") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320823,
                                                      "mem_out_320823") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t segmap_group_sizze_313453;
                        
                        segmap_group_sizze_313453 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_313425;
                        
                        int64_t segmap_usable_groups_313454 =
                                sdiv_up64(nest_sizze_297748,
                                          segmap_group_sizze_313453);
                        struct memblock_device mem_319852;
                        
                        mem_319852.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319852,
                                                  bytes_318522, "mem_319852")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_327231 = mem_318506.mem;
                        CUdeviceptr kernel_arg_327232 = mem_319770.mem;
                        CUdeviceptr kernel_arg_327233 = mem_319852.mem;
                        
                        if ((((((1 && segmap_usable_groups_313454 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_313453 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_313454;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_327228[] = {&ctx->global_failure,
                                                          &n_292675,
                                                          &partition_sizze_292766,
                                                          &kernel_arg_327231,
                                                          &kernel_arg_327232,
                                                          &kernel_arg_327233};
                            int64_t time_start_327229 = 0, time_end_327230 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_313458",
                                        (long) segmap_usable_groups_313454,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_313453,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_327229 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_313458_runs,
                                                          &ctx->mainzisegmap_313458_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_313458,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_313453,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_327228,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_327230 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_313458", time_end_327230 -
                                        time_start_327229);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        
                        int64_t segmap_group_sizze_313470;
                        
                        segmap_group_sizze_313470 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_313369;
                        
                        int64_t segmap_usable_groups_313471 =
                                sdiv_up64(nest_sizze_297748,
                                          segmap_group_sizze_313470);
                        struct memblock_device mem_319857;
                        
                        mem_319857.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319857,
                                                  bytes_318522, "mem_319857")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock_device mem_319861;
                        
                        mem_319861.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319861,
                                                  bytes_318522, "mem_319861")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_327237 = ext_mem_318542.mem;
                        CUdeviceptr kernel_arg_327238 = mem_param_318838.mem;
                        CUdeviceptr kernel_arg_327239 = mem_319852.mem;
                        CUdeviceptr kernel_arg_327240 = mem_319857.mem;
                        CUdeviceptr kernel_arg_327241 = mem_319861.mem;
                        
                        if ((((((1 && segmap_usable_groups_313471 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_313470 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_313471;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_327234[] = {&ctx->global_failure,
                                                          &ctx->failure_is_an_option,
                                                          &ctx->global_failure_args,
                                                          &n_292675,
                                                          &partition_sizze_292766,
                                                          &ctx_param_ext_318833,
                                                          &ctx_param_ext_318834,
                                                          &ctx_param_ext_318836,
                                                          &kernel_arg_327237,
                                                          &kernel_arg_327238,
                                                          &kernel_arg_327239,
                                                          &kernel_arg_327240,
                                                          &kernel_arg_327241};
                            int64_t time_start_327235 = 0, time_end_327236 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_313476",
                                        (long) segmap_usable_groups_313471,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_313470,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_327235 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_313476_runs,
                                                          &ctx->mainzisegmap_313476_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_313476,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_313470,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_327234,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_327236 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_313476", time_end_327236 -
                                        time_start_327235);
                            }
                        }
                        ctx->failure_is_an_option = 1;
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_unref_device(ctx, &mem_319852,
                                                  "mem_319852") != 0)
                            return 1;
                        
                        struct memblock_device mem_319871;
                        
                        mem_319871.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319871,
                                                  bytes_318772, "mem_319871")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        int32_t num_chunks_324195 =
                                sext_i64_i32(sdiv_up64(q_t_292679, q_t_292679));
                        unsigned int shared_sizze_327245 = (int64_t) 8 *
                                     q_t_292679;
                        unsigned int shared_sizze_327247 = (int64_t) 8 *
                                     q_t_292679;
                        unsigned int shared_sizze_327249 = bytes_319865;
                        CUdeviceptr kernel_arg_327251 = ext_mem_318541.mem;
                        CUdeviceptr kernel_arg_327252 = ext_mem_318542.mem;
                        CUdeviceptr kernel_arg_327253 = ext_mem_318805.mem;
                        CUdeviceptr kernel_arg_327254 = ext_mem_318806.mem;
                        CUdeviceptr kernel_arg_327255 = mem_319857.mem;
                        CUdeviceptr kernel_arg_327256 = mem_319861.mem;
                        CUdeviceptr kernel_arg_327257 = mem_319871.mem;
                        unsigned int shared_offset_327246 = 0;
                        unsigned int shared_offset_327248 = 0 +
                                     (shared_sizze_327245 + (8 -
                                                             shared_sizze_327245 %
                                                             8) % 8);
                        unsigned int shared_offset_327250 = 0 +
                                     (shared_sizze_327245 + (8 -
                                                             shared_sizze_327245 %
                                                             8) % 8) +
                                     (shared_sizze_327247 + (8 -
                                                             shared_sizze_327247 %
                                                             8) % 8);
                        
                        if ((((((1 && nest_sizze_300870 != 0) && 1 != 0) && 1 !=
                               0) && q_t_292679 != 0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = nest_sizze_300870;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_327242[] = {&ctx->global_failure,
                                                          &shared_offset_327246,
                                                          &shared_offset_327248,
                                                          &shared_offset_327250,
                                                          &n_292675,
                                                          &q_t_292679,
                                                          &jump_t_292685,
                                                          &partition_sizze_292766,
                                                          &t_n_m_292839,
                                                          &i_292846,
                                                          &kernel_arg_327251,
                                                          &kernel_arg_327252,
                                                          &kernel_arg_327253,
                                                          &kernel_arg_327254,
                                                          &kernel_arg_327255,
                                                          &kernel_arg_327256,
                                                          &kernel_arg_327257};
                            int64_t time_start_327243 = 0, time_end_327244 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_intragroup_313503",
                                        (long) nest_sizze_300870, (long) 1,
                                        (long) 1, (long) q_t_292679, (long) 1,
                                        (long) 1, (int) (0 +
                                                         (shared_sizze_327245 +
                                                          (8 -
                                                           shared_sizze_327245 %
                                                           8) % 8) +
                                                         (shared_sizze_327247 +
                                                          (8 -
                                                           shared_sizze_327247 %
                                                           8) % 8) +
                                                         (shared_sizze_327249 +
                                                          (8 -
                                                           shared_sizze_327249 %
                                                           8) % 8)));
                                time_start_327243 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_intragroup_313503_runs,
                                                          &ctx->mainzisegmap_intragroup_313503_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_313503,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  q_t_292679, 1,
                                                                  1, 0 +
                                                                  (shared_sizze_327245 +
                                                                   (8 -
                                                                    shared_sizze_327245 %
                                                                    8) % 8) +
                                                                  (shared_sizze_327247 +
                                                                   (8 -
                                                                    shared_sizze_327247 %
                                                                    8) % 8) +
                                                                  (shared_sizze_327249 +
                                                                   (8 -
                                                                    shared_sizze_327249 %
                                                                    8) % 8),
                                                                  NULL,
                                                                  kernel_args_327242,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_327244 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_intragroup_313503",
                                        time_end_327244 - time_start_327243);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_unref_device(ctx, &mem_319857,
                                                  "mem_319857") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319861,
                                                  "mem_319861") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319944,
                                                &mem_319871, "mem_319871") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319943,
                                                &mem_319847, "mem_319847") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319871,
                                                  "mem_319871") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319861,
                                                  "mem_319861") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319857,
                                                  "mem_319857") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319852,
                                                  "mem_319852") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319847,
                                                  "mem_319847") != 0)
                            return 1;
                    } else {
                        bool match_lit_296275 = (int64_t) 1 == d_t_292682;
                        struct memblock_device ext_mem_319942;
                        
                        ext_mem_319942.references = NULL;
                        
                        struct memblock_device ext_mem_319941;
                        
                        ext_mem_319941.references = NULL;
                        if (match_lit_296275) {
                            int64_t segmap_group_sizze_313772;
                            
                            segmap_group_sizze_313772 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_313744;
                            
                            int64_t segmap_usable_groups_313773 =
                                    sdiv_up64(nest_sizze_297748,
                                              segmap_group_sizze_313772);
                            struct memblock_device mem_319876;
                            
                            mem_319876.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319876,
                                                      bytes_318522,
                                                      "mem_319876")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_327261 = mem_318506.mem;
                            CUdeviceptr kernel_arg_327262 = mem_319770.mem;
                            CUdeviceptr kernel_arg_327263 = mem_319876.mem;
                            
                            if ((((((1 && segmap_usable_groups_313773 != 0) &&
                                    1 != 0) && 1 != 0) &&
                                  segmap_group_sizze_313772 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = segmap_usable_groups_313773;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327258[] =
                                     {&ctx->global_failure, &n_292675,
                                      &partition_sizze_292766,
                                      &kernel_arg_327261, &kernel_arg_327262,
                                      &kernel_arg_327263};
                                int64_t time_start_327259 = 0, time_end_327260 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_313777",
                                            (long) segmap_usable_groups_313773,
                                            (long) 1, (long) 1,
                                            (long) segmap_group_sizze_313772,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_327259 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_313777_runs,
                                                              &ctx->mainzisegmap_313777_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_313777,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_313772,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_327258,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327260 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_313777",
                                            time_end_327260 -
                                            time_start_327259);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            
                            int64_t segmap_group_sizze_313789;
                            
                            segmap_group_sizze_313789 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_313688;
                            
                            int64_t segmap_usable_groups_313790 =
                                    sdiv_up64(nest_sizze_297748,
                                              segmap_group_sizze_313789);
                            struct memblock_device mem_319881;
                            
                            mem_319881.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319881,
                                                      bytes_318522,
                                                      "mem_319881")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319885;
                            
                            mem_319885.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319885,
                                                      bytes_318522,
                                                      "mem_319885")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_327267 = ext_mem_318542.mem;
                            CUdeviceptr kernel_arg_327268 =
                                        mem_param_318838.mem;
                            CUdeviceptr kernel_arg_327269 = mem_319876.mem;
                            CUdeviceptr kernel_arg_327270 = mem_319881.mem;
                            CUdeviceptr kernel_arg_327271 = mem_319885.mem;
                            
                            if ((((((1 && segmap_usable_groups_313790 != 0) &&
                                    1 != 0) && 1 != 0) &&
                                  segmap_group_sizze_313789 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = segmap_usable_groups_313790;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327264[] =
                                     {&ctx->global_failure,
                                      &ctx->failure_is_an_option,
                                      &ctx->global_failure_args, &n_292675,
                                      &partition_sizze_292766,
                                      &ctx_param_ext_318833,
                                      &ctx_param_ext_318834,
                                      &ctx_param_ext_318836, &kernel_arg_327267,
                                      &kernel_arg_327268, &kernel_arg_327269,
                                      &kernel_arg_327270, &kernel_arg_327271};
                                int64_t time_start_327265 = 0, time_end_327266 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_313795",
                                            (long) segmap_usable_groups_313790,
                                            (long) 1, (long) 1,
                                            (long) segmap_group_sizze_313789,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_327265 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_313795_runs,
                                                              &ctx->mainzisegmap_313795_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_313795,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_313789,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_327264,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327266 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_313795",
                                            time_end_327266 -
                                            time_start_327265);
                                }
                            }
                            ctx->failure_is_an_option = 1;
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx, &mem_319876,
                                                      "mem_319876") != 0)
                                return 1;
                            
                            struct memblock_device mem_319898;
                            
                            mem_319898.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319898,
                                                      bytes_318772,
                                                      "mem_319898")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319902;
                            
                            mem_319902.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319902,
                                                      bytes_318772,
                                                      "mem_319902")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            int32_t num_chunks_324236 =
                                    sext_i64_i32(sdiv_up64(q_t_292679,
                                                           q_t_292679));
                            unsigned int shared_sizze_327275 = (int64_t) 8 *
                                         q_t_292679;
                            unsigned int shared_sizze_327277 = (int64_t) 8 *
                                         q_t_292679;
                            unsigned int shared_sizze_327279 = (int64_t) 8 *
                                         q_t_292679;
                            unsigned int shared_sizze_327281 = (int64_t) 8 *
                                         q_t_292679;
                            unsigned int shared_sizze_327283 = (int64_t) 8 *
                                         q_t_292679;
                            unsigned int shared_sizze_327285 = bytes_319865;
                            unsigned int shared_sizze_327287 = bytes_319865;
                            CUdeviceptr kernel_arg_327289 = ext_mem_318541.mem;
                            CUdeviceptr kernel_arg_327290 = ext_mem_318542.mem;
                            CUdeviceptr kernel_arg_327291 = ext_mem_318805.mem;
                            CUdeviceptr kernel_arg_327292 = ext_mem_318806.mem;
                            CUdeviceptr kernel_arg_327293 = mem_319881.mem;
                            CUdeviceptr kernel_arg_327294 = mem_319885.mem;
                            CUdeviceptr kernel_arg_327295 = mem_319898.mem;
                            CUdeviceptr kernel_arg_327296 = mem_319902.mem;
                            unsigned int shared_offset_327276 = 0;
                            unsigned int shared_offset_327278 = 0 +
                                         (shared_sizze_327275 + (8 -
                                                                 shared_sizze_327275 %
                                                                 8) % 8);
                            unsigned int shared_offset_327280 = 0 +
                                         (shared_sizze_327275 + (8 -
                                                                 shared_sizze_327275 %
                                                                 8) % 8) +
                                         (shared_sizze_327277 + (8 -
                                                                 shared_sizze_327277 %
                                                                 8) % 8);
                            unsigned int shared_offset_327282 = 0 +
                                         (shared_sizze_327275 + (8 -
                                                                 shared_sizze_327275 %
                                                                 8) % 8) +
                                         (shared_sizze_327277 + (8 -
                                                                 shared_sizze_327277 %
                                                                 8) % 8) +
                                         (shared_sizze_327279 + (8 -
                                                                 shared_sizze_327279 %
                                                                 8) % 8);
                            unsigned int shared_offset_327284 = 0 +
                                         (shared_sizze_327275 + (8 -
                                                                 shared_sizze_327275 %
                                                                 8) % 8) +
                                         (shared_sizze_327277 + (8 -
                                                                 shared_sizze_327277 %
                                                                 8) % 8) +
                                         (shared_sizze_327279 + (8 -
                                                                 shared_sizze_327279 %
                                                                 8) % 8) +
                                         (shared_sizze_327281 + (8 -
                                                                 shared_sizze_327281 %
                                                                 8) % 8);
                            unsigned int shared_offset_327286 = 0 +
                                         (shared_sizze_327275 + (8 -
                                                                 shared_sizze_327275 %
                                                                 8) % 8) +
                                         (shared_sizze_327277 + (8 -
                                                                 shared_sizze_327277 %
                                                                 8) % 8) +
                                         (shared_sizze_327279 + (8 -
                                                                 shared_sizze_327279 %
                                                                 8) % 8) +
                                         (shared_sizze_327281 + (8 -
                                                                 shared_sizze_327281 %
                                                                 8) % 8) +
                                         (shared_sizze_327283 + (8 -
                                                                 shared_sizze_327283 %
                                                                 8) % 8);
                            unsigned int shared_offset_327288 = 0 +
                                         (shared_sizze_327275 + (8 -
                                                                 shared_sizze_327275 %
                                                                 8) % 8) +
                                         (shared_sizze_327277 + (8 -
                                                                 shared_sizze_327277 %
                                                                 8) % 8) +
                                         (shared_sizze_327279 + (8 -
                                                                 shared_sizze_327279 %
                                                                 8) % 8) +
                                         (shared_sizze_327281 + (8 -
                                                                 shared_sizze_327281 %
                                                                 8) % 8) +
                                         (shared_sizze_327283 + (8 -
                                                                 shared_sizze_327283 %
                                                                 8) % 8) +
                                         (shared_sizze_327285 + (8 -
                                                                 shared_sizze_327285 %
                                                                 8) % 8);
                            
                            if ((((((1 && nest_sizze_300870 != 0) && 1 != 0) &&
                                   1 != 0) && q_t_292679 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = nest_sizze_300870;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327272[] =
                                     {&ctx->global_failure,
                                      &shared_offset_327276,
                                      &shared_offset_327278,
                                      &shared_offset_327280,
                                      &shared_offset_327282,
                                      &shared_offset_327284,
                                      &shared_offset_327286,
                                      &shared_offset_327288, &n_292675,
                                      &q_t_292679, &jump_t_292685,
                                      &partition_sizze_292766, &t_n_m_292839,
                                      &i_292846, &kernel_arg_327289,
                                      &kernel_arg_327290, &kernel_arg_327291,
                                      &kernel_arg_327292, &kernel_arg_327293,
                                      &kernel_arg_327294, &kernel_arg_327295,
                                      &kernel_arg_327296};
                                int64_t time_start_327273 = 0, time_end_327274 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_intragroup_313823",
                                            (long) nest_sizze_300870, (long) 1,
                                            (long) 1, (long) q_t_292679,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_327275 +
                                                                        (8 -
                                                                         shared_sizze_327275 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327277 +
                                                                        (8 -
                                                                         shared_sizze_327277 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327279 +
                                                                        (8 -
                                                                         shared_sizze_327279 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327281 +
                                                                        (8 -
                                                                         shared_sizze_327281 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327283 +
                                                                        (8 -
                                                                         shared_sizze_327283 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327285 +
                                                                        (8 -
                                                                         shared_sizze_327285 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327287 +
                                                                        (8 -
                                                                         shared_sizze_327287 %
                                                                         8) %
                                                                        8)));
                                    time_start_327273 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_intragroup_313823_runs,
                                                              &ctx->mainzisegmap_intragroup_313823_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_313823,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      q_t_292679,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_327275 +
                                                                       (8 -
                                                                        shared_sizze_327275 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327277 +
                                                                       (8 -
                                                                        shared_sizze_327277 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327279 +
                                                                       (8 -
                                                                        shared_sizze_327279 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327281 +
                                                                       (8 -
                                                                        shared_sizze_327281 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327283 +
                                                                       (8 -
                                                                        shared_sizze_327283 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327285 +
                                                                       (8 -
                                                                        shared_sizze_327285 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327287 +
                                                                       (8 -
                                                                        shared_sizze_327287 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_327272,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327274 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_intragroup_313823",
                                            time_end_327274 -
                                            time_start_327273);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx, &mem_319881,
                                                      "mem_319881") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319885,
                                                      "mem_319885") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319942,
                                                    &mem_319898,
                                                    "mem_319898") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319941,
                                                    &mem_319902,
                                                    "mem_319902") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319902,
                                                      "mem_319902") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319898,
                                                      "mem_319898") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319885,
                                                      "mem_319885") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319881,
                                                      "mem_319881") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319876,
                                                      "mem_319876") != 0)
                                return 1;
                        } else {
                            int64_t segmap_group_sizze_314187;
                            
                            segmap_group_sizze_314187 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_314159;
                            
                            int64_t segmap_usable_groups_314188 =
                                    sdiv_up64(nest_sizze_297748,
                                              segmap_group_sizze_314187);
                            struct memblock_device mem_319907;
                            
                            mem_319907.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319907,
                                                      bytes_318522,
                                                      "mem_319907")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_327300 = mem_318506.mem;
                            CUdeviceptr kernel_arg_327301 = mem_319770.mem;
                            CUdeviceptr kernel_arg_327302 = mem_319907.mem;
                            
                            if ((((((1 && segmap_usable_groups_314188 != 0) &&
                                    1 != 0) && 1 != 0) &&
                                  segmap_group_sizze_314187 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = segmap_usable_groups_314188;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327297[] =
                                     {&ctx->global_failure, &n_292675,
                                      &partition_sizze_292766,
                                      &kernel_arg_327300, &kernel_arg_327301,
                                      &kernel_arg_327302};
                                int64_t time_start_327298 = 0, time_end_327299 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_314192",
                                            (long) segmap_usable_groups_314188,
                                            (long) 1, (long) 1,
                                            (long) segmap_group_sizze_314187,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_327298 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_314192_runs,
                                                              &ctx->mainzisegmap_314192_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_314192,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_314187,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_327297,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327299 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_314192",
                                            time_end_327299 -
                                            time_start_327298);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            
                            int64_t segmap_group_sizze_314204;
                            
                            segmap_group_sizze_314204 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_314103;
                            
                            int64_t segmap_usable_groups_314205 =
                                    sdiv_up64(nest_sizze_297748,
                                              segmap_group_sizze_314204);
                            struct memblock_device mem_319912;
                            
                            mem_319912.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319912,
                                                      bytes_318522,
                                                      "mem_319912")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319916;
                            
                            mem_319916.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319916,
                                                      bytes_318522,
                                                      "mem_319916")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_327306 = ext_mem_318542.mem;
                            CUdeviceptr kernel_arg_327307 =
                                        mem_param_318838.mem;
                            CUdeviceptr kernel_arg_327308 = mem_319907.mem;
                            CUdeviceptr kernel_arg_327309 = mem_319912.mem;
                            CUdeviceptr kernel_arg_327310 = mem_319916.mem;
                            
                            if ((((((1 && segmap_usable_groups_314205 != 0) &&
                                    1 != 0) && 1 != 0) &&
                                  segmap_group_sizze_314204 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = segmap_usable_groups_314205;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327303[] =
                                     {&ctx->global_failure,
                                      &ctx->failure_is_an_option,
                                      &ctx->global_failure_args, &n_292675,
                                      &partition_sizze_292766,
                                      &ctx_param_ext_318833,
                                      &ctx_param_ext_318834,
                                      &ctx_param_ext_318836, &kernel_arg_327306,
                                      &kernel_arg_327307, &kernel_arg_327308,
                                      &kernel_arg_327309, &kernel_arg_327310};
                                int64_t time_start_327304 = 0, time_end_327305 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_314210",
                                            (long) segmap_usable_groups_314205,
                                            (long) 1, (long) 1,
                                            (long) segmap_group_sizze_314204,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_327304 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_314210_runs,
                                                              &ctx->mainzisegmap_314210_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_314210,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_314204,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_327303,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327305 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_314210",
                                            time_end_327305 -
                                            time_start_327304);
                                }
                            }
                            ctx->failure_is_an_option = 1;
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx, &mem_319907,
                                                      "mem_319907") != 0)
                                return 1;
                            
                            struct memblock_device mem_319936;
                            
                            mem_319936.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319936,
                                                      bytes_318772,
                                                      "mem_319936")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319940;
                            
                            mem_319940.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319940,
                                                      bytes_318772,
                                                      "mem_319940")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            int32_t num_chunks_324283 =
                                    sext_i64_i32(sdiv_up64(q_t_292679,
                                                           q_t_292679));
                            unsigned int shared_sizze_327314 = (int64_t) 8 *
                                         q_t_292679;
                            unsigned int shared_sizze_327316 = (int64_t) 8 *
                                         q_t_292679;
                            unsigned int shared_sizze_327318 = (int64_t) 8 *
                                         q_t_292679;
                            unsigned int shared_sizze_327320 = (int64_t) 8 *
                                         q_t_292679;
                            unsigned int shared_sizze_327322 = (int64_t) 8 *
                                         q_t_292679;
                            unsigned int shared_sizze_327324 = (int64_t) 8 *
                                         q_t_292679;
                            unsigned int shared_sizze_327326 = (int64_t) 8 *
                                         q_t_292679;
                            unsigned int shared_sizze_327328 = bytes_319865;
                            unsigned int shared_sizze_327330 = bytes_319865;
                            unsigned int shared_sizze_327332 = bytes_319865;
                            unsigned int shared_sizze_327334 = bytes_319865;
                            CUdeviceptr kernel_arg_327336 = ext_mem_318541.mem;
                            CUdeviceptr kernel_arg_327337 = ext_mem_318542.mem;
                            CUdeviceptr kernel_arg_327338 = ext_mem_318805.mem;
                            CUdeviceptr kernel_arg_327339 = ext_mem_318806.mem;
                            CUdeviceptr kernel_arg_327340 = mem_319912.mem;
                            CUdeviceptr kernel_arg_327341 = mem_319916.mem;
                            CUdeviceptr kernel_arg_327342 = mem_319936.mem;
                            CUdeviceptr kernel_arg_327343 = mem_319940.mem;
                            unsigned int shared_offset_327315 = 0;
                            unsigned int shared_offset_327317 = 0 +
                                         (shared_sizze_327314 + (8 -
                                                                 shared_sizze_327314 %
                                                                 8) % 8);
                            unsigned int shared_offset_327319 = 0 +
                                         (shared_sizze_327314 + (8 -
                                                                 shared_sizze_327314 %
                                                                 8) % 8) +
                                         (shared_sizze_327316 + (8 -
                                                                 shared_sizze_327316 %
                                                                 8) % 8);
                            unsigned int shared_offset_327321 = 0 +
                                         (shared_sizze_327314 + (8 -
                                                                 shared_sizze_327314 %
                                                                 8) % 8) +
                                         (shared_sizze_327316 + (8 -
                                                                 shared_sizze_327316 %
                                                                 8) % 8) +
                                         (shared_sizze_327318 + (8 -
                                                                 shared_sizze_327318 %
                                                                 8) % 8);
                            unsigned int shared_offset_327323 = 0 +
                                         (shared_sizze_327314 + (8 -
                                                                 shared_sizze_327314 %
                                                                 8) % 8) +
                                         (shared_sizze_327316 + (8 -
                                                                 shared_sizze_327316 %
                                                                 8) % 8) +
                                         (shared_sizze_327318 + (8 -
                                                                 shared_sizze_327318 %
                                                                 8) % 8) +
                                         (shared_sizze_327320 + (8 -
                                                                 shared_sizze_327320 %
                                                                 8) % 8);
                            unsigned int shared_offset_327325 = 0 +
                                         (shared_sizze_327314 + (8 -
                                                                 shared_sizze_327314 %
                                                                 8) % 8) +
                                         (shared_sizze_327316 + (8 -
                                                                 shared_sizze_327316 %
                                                                 8) % 8) +
                                         (shared_sizze_327318 + (8 -
                                                                 shared_sizze_327318 %
                                                                 8) % 8) +
                                         (shared_sizze_327320 + (8 -
                                                                 shared_sizze_327320 %
                                                                 8) % 8) +
                                         (shared_sizze_327322 + (8 -
                                                                 shared_sizze_327322 %
                                                                 8) % 8);
                            unsigned int shared_offset_327327 = 0 +
                                         (shared_sizze_327314 + (8 -
                                                                 shared_sizze_327314 %
                                                                 8) % 8) +
                                         (shared_sizze_327316 + (8 -
                                                                 shared_sizze_327316 %
                                                                 8) % 8) +
                                         (shared_sizze_327318 + (8 -
                                                                 shared_sizze_327318 %
                                                                 8) % 8) +
                                         (shared_sizze_327320 + (8 -
                                                                 shared_sizze_327320 %
                                                                 8) % 8) +
                                         (shared_sizze_327322 + (8 -
                                                                 shared_sizze_327322 %
                                                                 8) % 8) +
                                         (shared_sizze_327324 + (8 -
                                                                 shared_sizze_327324 %
                                                                 8) % 8);
                            unsigned int shared_offset_327329 = 0 +
                                         (shared_sizze_327314 + (8 -
                                                                 shared_sizze_327314 %
                                                                 8) % 8) +
                                         (shared_sizze_327316 + (8 -
                                                                 shared_sizze_327316 %
                                                                 8) % 8) +
                                         (shared_sizze_327318 + (8 -
                                                                 shared_sizze_327318 %
                                                                 8) % 8) +
                                         (shared_sizze_327320 + (8 -
                                                                 shared_sizze_327320 %
                                                                 8) % 8) +
                                         (shared_sizze_327322 + (8 -
                                                                 shared_sizze_327322 %
                                                                 8) % 8) +
                                         (shared_sizze_327324 + (8 -
                                                                 shared_sizze_327324 %
                                                                 8) % 8) +
                                         (shared_sizze_327326 + (8 -
                                                                 shared_sizze_327326 %
                                                                 8) % 8);
                            unsigned int shared_offset_327331 = 0 +
                                         (shared_sizze_327314 + (8 -
                                                                 shared_sizze_327314 %
                                                                 8) % 8) +
                                         (shared_sizze_327316 + (8 -
                                                                 shared_sizze_327316 %
                                                                 8) % 8) +
                                         (shared_sizze_327318 + (8 -
                                                                 shared_sizze_327318 %
                                                                 8) % 8) +
                                         (shared_sizze_327320 + (8 -
                                                                 shared_sizze_327320 %
                                                                 8) % 8) +
                                         (shared_sizze_327322 + (8 -
                                                                 shared_sizze_327322 %
                                                                 8) % 8) +
                                         (shared_sizze_327324 + (8 -
                                                                 shared_sizze_327324 %
                                                                 8) % 8) +
                                         (shared_sizze_327326 + (8 -
                                                                 shared_sizze_327326 %
                                                                 8) % 8) +
                                         (shared_sizze_327328 + (8 -
                                                                 shared_sizze_327328 %
                                                                 8) % 8);
                            unsigned int shared_offset_327333 = 0 +
                                         (shared_sizze_327314 + (8 -
                                                                 shared_sizze_327314 %
                                                                 8) % 8) +
                                         (shared_sizze_327316 + (8 -
                                                                 shared_sizze_327316 %
                                                                 8) % 8) +
                                         (shared_sizze_327318 + (8 -
                                                                 shared_sizze_327318 %
                                                                 8) % 8) +
                                         (shared_sizze_327320 + (8 -
                                                                 shared_sizze_327320 %
                                                                 8) % 8) +
                                         (shared_sizze_327322 + (8 -
                                                                 shared_sizze_327322 %
                                                                 8) % 8) +
                                         (shared_sizze_327324 + (8 -
                                                                 shared_sizze_327324 %
                                                                 8) % 8) +
                                         (shared_sizze_327326 + (8 -
                                                                 shared_sizze_327326 %
                                                                 8) % 8) +
                                         (shared_sizze_327328 + (8 -
                                                                 shared_sizze_327328 %
                                                                 8) % 8) +
                                         (shared_sizze_327330 + (8 -
                                                                 shared_sizze_327330 %
                                                                 8) % 8);
                            unsigned int shared_offset_327335 = 0 +
                                         (shared_sizze_327314 + (8 -
                                                                 shared_sizze_327314 %
                                                                 8) % 8) +
                                         (shared_sizze_327316 + (8 -
                                                                 shared_sizze_327316 %
                                                                 8) % 8) +
                                         (shared_sizze_327318 + (8 -
                                                                 shared_sizze_327318 %
                                                                 8) % 8) +
                                         (shared_sizze_327320 + (8 -
                                                                 shared_sizze_327320 %
                                                                 8) % 8) +
                                         (shared_sizze_327322 + (8 -
                                                                 shared_sizze_327322 %
                                                                 8) % 8) +
                                         (shared_sizze_327324 + (8 -
                                                                 shared_sizze_327324 %
                                                                 8) % 8) +
                                         (shared_sizze_327326 + (8 -
                                                                 shared_sizze_327326 %
                                                                 8) % 8) +
                                         (shared_sizze_327328 + (8 -
                                                                 shared_sizze_327328 %
                                                                 8) % 8) +
                                         (shared_sizze_327330 + (8 -
                                                                 shared_sizze_327330 %
                                                                 8) % 8) +
                                         (shared_sizze_327332 + (8 -
                                                                 shared_sizze_327332 %
                                                                 8) % 8);
                            
                            if ((((((1 && nest_sizze_300870 != 0) && 1 != 0) &&
                                   1 != 0) && q_t_292679 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = nest_sizze_300870;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327311[] =
                                     {&ctx->global_failure,
                                      &shared_offset_327315,
                                      &shared_offset_327317,
                                      &shared_offset_327319,
                                      &shared_offset_327321,
                                      &shared_offset_327323,
                                      &shared_offset_327325,
                                      &shared_offset_327327,
                                      &shared_offset_327329,
                                      &shared_offset_327331,
                                      &shared_offset_327333,
                                      &shared_offset_327335, &n_292675,
                                      &q_t_292679, &jump_t_292685,
                                      &partition_sizze_292766, &t_n_m_292839,
                                      &i_292846, &kernel_arg_327336,
                                      &kernel_arg_327337, &kernel_arg_327338,
                                      &kernel_arg_327339, &kernel_arg_327340,
                                      &kernel_arg_327341, &kernel_arg_327342,
                                      &kernel_arg_327343};
                                int64_t time_start_327312 = 0, time_end_327313 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_intragroup_314238",
                                            (long) nest_sizze_300870, (long) 1,
                                            (long) 1, (long) q_t_292679,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_327314 +
                                                                        (8 -
                                                                         shared_sizze_327314 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327316 +
                                                                        (8 -
                                                                         shared_sizze_327316 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327318 +
                                                                        (8 -
                                                                         shared_sizze_327318 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327320 +
                                                                        (8 -
                                                                         shared_sizze_327320 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327322 +
                                                                        (8 -
                                                                         shared_sizze_327322 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327324 +
                                                                        (8 -
                                                                         shared_sizze_327324 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327326 +
                                                                        (8 -
                                                                         shared_sizze_327326 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327328 +
                                                                        (8 -
                                                                         shared_sizze_327328 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327330 +
                                                                        (8 -
                                                                         shared_sizze_327330 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327332 +
                                                                        (8 -
                                                                         shared_sizze_327332 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327334 +
                                                                        (8 -
                                                                         shared_sizze_327334 %
                                                                         8) %
                                                                        8)));
                                    time_start_327312 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_intragroup_314238_runs,
                                                              &ctx->mainzisegmap_intragroup_314238_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_314238,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      q_t_292679,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_327314 +
                                                                       (8 -
                                                                        shared_sizze_327314 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327316 +
                                                                       (8 -
                                                                        shared_sizze_327316 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327318 +
                                                                       (8 -
                                                                        shared_sizze_327318 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327320 +
                                                                       (8 -
                                                                        shared_sizze_327320 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327322 +
                                                                       (8 -
                                                                        shared_sizze_327322 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327324 +
                                                                       (8 -
                                                                        shared_sizze_327324 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327326 +
                                                                       (8 -
                                                                        shared_sizze_327326 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327328 +
                                                                       (8 -
                                                                        shared_sizze_327328 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327330 +
                                                                       (8 -
                                                                        shared_sizze_327330 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327332 +
                                                                       (8 -
                                                                        shared_sizze_327332 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327334 +
                                                                       (8 -
                                                                        shared_sizze_327334 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_327311,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327313 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_intragroup_314238",
                                            time_end_327313 -
                                            time_start_327312);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx, &mem_319912,
                                                      "mem_319912") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319916,
                                                      "mem_319916") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319942,
                                                    &mem_319936,
                                                    "mem_319936") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_319941,
                                                    &mem_319940,
                                                    "mem_319940") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319940,
                                                      "mem_319940") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319936,
                                                      "mem_319936") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319916,
                                                      "mem_319916") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319912,
                                                      "mem_319912") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319907,
                                                      "mem_319907") != 0)
                                return 1;
                        }
                        if (memblock_set_device(ctx, &ext_mem_319944,
                                                &ext_mem_319942,
                                                "ext_mem_319942") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_319943,
                                                &ext_mem_319941,
                                                "ext_mem_319941") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319941,
                                                  "ext_mem_319941") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_319942,
                                                  "ext_mem_319942") != 0)
                            return 1;
                    }
                    if (memblock_set_device(ctx, &ext_mem_320097,
                                            &ext_mem_319944,
                                            "ext_mem_319944") != 0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_320096,
                                            &ext_mem_319943,
                                            "ext_mem_319943") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319943,
                                              "ext_mem_319943") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319944,
                                              "ext_mem_319944") != 0)
                        return 1;
                } else {
                    bool match_lit_296577 = (int64_t) 0 == d_t_292682;
                    struct memblock_device ext_mem_320095;
                    
                    ext_mem_320095.references = NULL;
                    
                    struct memblock_device ext_mem_320094;
                    
                    ext_mem_320094.references = NULL;
                    if (match_lit_296577) {
                        struct memblock_device mem_319948;
                        
                        mem_319948.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319948,
                                                  bytes_318772, "mem_319948")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (futrts_builtinzhreplicate_f64(ctx, mem_319948,
                                                          partition_sizze_292766 *
                                                          t_n_m_292839, 0.0) !=
                            0) {
                            if (memblock_unref_device(ctx, &mem_319948,
                                                      "mem_319948") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320094,
                                                      "ext_mem_320094") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320095,
                                                      "ext_mem_320095") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320096,
                                                      "ext_mem_320096") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320097,
                                                      "ext_mem_320097") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320098,
                                                      "ext_mem_320098") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320099,
                                                      "ext_mem_320099") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319770,
                                                      "mem_319770") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319764,
                                                      "ext_mem_319764") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319757,
                                                      "ext_mem_319757") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319758,
                                                      "ext_mem_319758") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319550,
                                                      "ext_mem_319550") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319533,
                                                      "ext_mem_319533") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319516,
                                                      "ext_mem_319516") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319498,
                                                      "ext_mem_319498") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319490,
                                                      "ext_mem_319490") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_319491,
                                                      "ext_mem_319491") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318860,
                                                      "mem_param_318860") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318852,
                                                      "mem_param_318852") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320111,
                                                      "ext_mem_320111") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320112,
                                                      "ext_mem_320112") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318838,
                                                      "mem_param_318838") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318830,
                                                      "mem_param_318830") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_param_318822,
                                                      "mem_param_318822") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320430,
                                                      "ext_mem_320430") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320431,
                                                      "ext_mem_320431") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_320432,
                                                      "ext_mem_320432") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319555,
                                                      "mem_319555") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319538,
                                                      "mem_319538") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319521,
                                                      "mem_319521") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319504,
                                                      "mem_319504") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318876,
                                                      "mem_318876") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318871,
                                                      "mem_318871") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318865,
                                                      "mem_318865") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318814,
                                                      "mem_318814") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318810,
                                                      "mem_318810") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318805,
                                                      "ext_mem_318805") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318806,
                                                      "ext_mem_318806") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318756,
                                                      "ext_mem_318756") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318757,
                                                      "ext_mem_318757") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318707,
                                                      "ext_mem_318707") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318708,
                                                      "ext_mem_318708") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318609,
                                                      "ext_mem_318609") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318610,
                                                      "ext_mem_318610") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318551,
                                                      "mem_318551") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318545,
                                                      "mem_318545") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318541,
                                                      "ext_mem_318541") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &ext_mem_318542,
                                                      "ext_mem_318542") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318509,
                                                      "mem_318509") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318506,
                                                      "mem_318506") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318502,
                                                      "mem_318502") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318500,
                                                      "mem_318500") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318497,
                                                      "mem_318497") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_318493,
                                                      "mem_318493") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320825,
                                                      "mem_out_320825") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320824,
                                                      "mem_out_320824") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_out_320823,
                                                      "mem_out_320823") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t segmap_group_sizze_314727;
                        
                        segmap_group_sizze_314727 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_314699;
                        
                        int64_t segmap_usable_groups_314728 =
                                sdiv_up64(nest_sizze_297748,
                                          segmap_group_sizze_314727);
                        struct memblock_device mem_319953;
                        
                        mem_319953.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319953,
                                                  bytes_318522, "mem_319953")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_327347 = mem_318506.mem;
                        CUdeviceptr kernel_arg_327348 = mem_319770.mem;
                        CUdeviceptr kernel_arg_327349 = mem_319953.mem;
                        
                        if ((((((1 && segmap_usable_groups_314728 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_314727 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_314728;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_327344[] = {&ctx->global_failure,
                                                          &n_292675,
                                                          &partition_sizze_292766,
                                                          &kernel_arg_327347,
                                                          &kernel_arg_327348,
                                                          &kernel_arg_327349};
                            int64_t time_start_327345 = 0, time_end_327346 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_314732",
                                        (long) segmap_usable_groups_314728,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_314727,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_327345 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_314732_runs,
                                                          &ctx->mainzisegmap_314732_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_314732,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_314727,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_327344,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_327346 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_314732", time_end_327346 -
                                        time_start_327345);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        
                        int64_t segmap_group_sizze_314744;
                        
                        segmap_group_sizze_314744 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_314643;
                        
                        int64_t segmap_usable_groups_314745 =
                                sdiv_up64(nest_sizze_297748,
                                          segmap_group_sizze_314744);
                        struct memblock_device mem_319958;
                        
                        mem_319958.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319958,
                                                  bytes_318522, "mem_319958")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock_device mem_319962;
                        
                        mem_319962.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319962,
                                                  bytes_318522, "mem_319962")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_327353 = ext_mem_318542.mem;
                        CUdeviceptr kernel_arg_327354 = mem_param_318838.mem;
                        CUdeviceptr kernel_arg_327355 = mem_319953.mem;
                        CUdeviceptr kernel_arg_327356 = mem_319958.mem;
                        CUdeviceptr kernel_arg_327357 = mem_319962.mem;
                        
                        if ((((((1 && segmap_usable_groups_314745 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_314744 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_314745;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_327350[] = {&ctx->global_failure,
                                                          &ctx->failure_is_an_option,
                                                          &ctx->global_failure_args,
                                                          &n_292675,
                                                          &partition_sizze_292766,
                                                          &ctx_param_ext_318833,
                                                          &ctx_param_ext_318834,
                                                          &ctx_param_ext_318836,
                                                          &kernel_arg_327353,
                                                          &kernel_arg_327354,
                                                          &kernel_arg_327355,
                                                          &kernel_arg_327356,
                                                          &kernel_arg_327357};
                            int64_t time_start_327351 = 0, time_end_327352 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_314750",
                                        (long) segmap_usable_groups_314745,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_314744,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_327351 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_314750_runs,
                                                          &ctx->mainzisegmap_314750_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_314750,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_314744,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_327350,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_327352 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_314750", time_end_327352 -
                                        time_start_327351);
                            }
                        }
                        ctx->failure_is_an_option = 1;
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_unref_device(ctx, &mem_319953,
                                                  "mem_319953") != 0)
                            return 1;
                        
                        int64_t nest_sizze_314785 = q_t_292679 *
                                nest_sizze_300870;
                        int64_t segred_group_sizze_314786;
                        
                        segred_group_sizze_314786 =
                            *ctx->tuning_params.mainzisegred_group_sizze_314457;
                        
                        int64_t num_groups_314787;
                        int32_t max_num_groups_324334;
                        
                        max_num_groups_324334 =
                            *ctx->tuning_params.mainzisegred_num_groups_314459;
                        num_groups_314787 = sext_i64_i32(smax64((int64_t) 1,
                                                                smin64(sdiv_up64(nest_sizze_314785,
                                                                                 segred_group_sizze_314786),
                                                                       sext_i32_i64(max_num_groups_324334))));
                        
                        struct memblock_device mem_319967;
                        
                        mem_319967.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319967,
                                                  bytes_318772, "mem_319967")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (slt64(q_t_292679 * (int64_t) 2,
                                  segred_group_sizze_314786)) {
                            int64_t segment_sizze_nonzzero_324335 =
                                    smax64((int64_t) 1, q_t_292679);
                            int64_t num_threads_324336 = num_groups_314787 *
                                    segred_group_sizze_314786;
                            
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegRed-small");
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                        (long long) (partition_sizze_292766 *
                                                     t_n_m_292839), '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                        (long long) q_t_292679, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "segments_per_group",
                                        (long long) squot64(segred_group_sizze_314786,
                                                            segment_sizze_nonzzero_324335),
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "required_groups",
                                        (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                           t_n_m_292839,
                                                                           squot64(segred_group_sizze_314786,
                                                                                   segment_sizze_nonzzero_324335))),
                                        '\n');
                            
                            unsigned int shared_sizze_327361 = (int64_t) 8 *
                                         segred_group_sizze_314786;
                            CUdeviceptr kernel_arg_327363 = ext_mem_318541.mem;
                            CUdeviceptr kernel_arg_327364 = ext_mem_318542.mem;
                            CUdeviceptr kernel_arg_327365 = ext_mem_318805.mem;
                            CUdeviceptr kernel_arg_327366 = ext_mem_318806.mem;
                            CUdeviceptr kernel_arg_327367 = mem_319958.mem;
                            CUdeviceptr kernel_arg_327368 = mem_319967.mem;
                            unsigned int shared_offset_327362 = 0;
                            
                            if ((((((1 && num_groups_314787 != 0) && 1 != 0) &&
                                   1 != 0) && segred_group_sizze_314786 != 0) &&
                                 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_314787;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327358[] =
                                     {&ctx->global_failure,
                                      &shared_offset_327362, &n_292675,
                                      &q_t_292679, &jump_t_292685,
                                      &partition_sizze_292766, &t_n_m_292839,
                                      &i_292846, &num_groups_314787,
                                      &segment_sizze_nonzzero_324335,
                                      &kernel_arg_327363, &kernel_arg_327364,
                                      &kernel_arg_327365, &kernel_arg_327366,
                                      &kernel_arg_327367, &kernel_arg_327368};
                                int64_t time_start_327359 = 0, time_end_327360 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segred_small_314793",
                                            (long) num_groups_314787, (long) 1,
                                            (long) 1,
                                            (long) segred_group_sizze_314786,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_327361 +
                                                                        (8 -
                                                                         shared_sizze_327361 %
                                                                         8) %
                                                                        8)));
                                    time_start_327359 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegred_small_314793_runs,
                                                              &ctx->mainzisegred_small_314793_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_314793,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segred_group_sizze_314786,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_327361 +
                                                                       (8 -
                                                                        shared_sizze_327361 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_327358,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327360 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segred_small_314793",
                                            time_end_327360 -
                                            time_start_327359);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                        } else {
                            int64_t groups_per_segment_324364 =
                                    sdiv_up64(num_groups_314787,
                                              smax64((int64_t) 1,
                                                     partition_sizze_292766 *
                                                     t_n_m_292839));
                            int64_t elements_per_thread_324365 =
                                    sdiv_up64(q_t_292679,
                                              segred_group_sizze_314786 *
                                              groups_per_segment_324364);
                            int64_t virt_num_groups_324366 =
                                    groups_per_segment_324364 *
                                    (partition_sizze_292766 * t_n_m_292839);
                            int64_t num_threads_324367 = num_groups_314787 *
                                    segred_group_sizze_314786;
                            int64_t threads_per_segment_324368 =
                                    groups_per_segment_324364 *
                                    segred_group_sizze_314786;
                            
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegRed-large");
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                        (long long) (partition_sizze_292766 *
                                                     t_n_m_292839), '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                        (long long) q_t_292679, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "virt_num_groups",
                                        (long long) virt_num_groups_324366,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_groups",
                                        (long long) num_groups_314787, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "group_size",
                                        (long long) segred_group_sizze_314786,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "elems_per_thread",
                                        (long long) elements_per_thread_324365,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "groups_per_segment",
                                        (long long) groups_per_segment_324364,
                                        '\n');
                            
                            struct memblock_device segred_tmp_mem_324369;
                            
                            segred_tmp_mem_324369.references = NULL;
                            if (memblock_alloc_device(ctx,
                                                      &segred_tmp_mem_324369,
                                                      (int64_t) 8 *
                                                      virt_num_groups_324366,
                                                      "segred_tmp_mem_324369")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mainzicounter_mem_324371 =
                                                   ctx->mainzicounter_mem_324371;
                            unsigned int shared_sizze_327373 = 1;
                            unsigned int shared_sizze_327375 = (int64_t) 8 *
                                         segred_group_sizze_314786;
                            CUdeviceptr kernel_arg_327377 = ext_mem_318541.mem;
                            CUdeviceptr kernel_arg_327378 = ext_mem_318542.mem;
                            CUdeviceptr kernel_arg_327379 = ext_mem_318805.mem;
                            CUdeviceptr kernel_arg_327380 = ext_mem_318806.mem;
                            CUdeviceptr kernel_arg_327381 = mem_319958.mem;
                            CUdeviceptr kernel_arg_327382 = mem_319967.mem;
                            CUdeviceptr kernel_arg_327383 =
                                        segred_tmp_mem_324369.mem;
                            CUdeviceptr kernel_arg_327384 =
                                        mainzicounter_mem_324371.mem;
                            unsigned int shared_offset_327374 = 0;
                            unsigned int shared_offset_327376 = 0 +
                                         (shared_sizze_327373 + (8 -
                                                                 shared_sizze_327373 %
                                                                 8) % 8);
                            
                            if ((((((1 && num_groups_314787 != 0) && 1 != 0) &&
                                   1 != 0) && segred_group_sizze_314786 != 0) &&
                                 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_314787;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327370[] =
                                     {&ctx->global_failure,
                                      &shared_offset_327374,
                                      &shared_offset_327376, &n_292675,
                                      &q_t_292679, &jump_t_292685,
                                      &partition_sizze_292766, &t_n_m_292839,
                                      &i_292846, &num_groups_314787,
                                      &groups_per_segment_324364,
                                      &elements_per_thread_324365,
                                      &virt_num_groups_324366,
                                      &threads_per_segment_324368,
                                      &kernel_arg_327377, &kernel_arg_327378,
                                      &kernel_arg_327379, &kernel_arg_327380,
                                      &kernel_arg_327381, &kernel_arg_327382,
                                      &kernel_arg_327383, &kernel_arg_327384};
                                int64_t time_start_327371 = 0, time_end_327372 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segred_large_314793",
                                            (long) num_groups_314787, (long) 1,
                                            (long) 1,
                                            (long) segred_group_sizze_314786,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_327373 +
                                                                        (8 -
                                                                         shared_sizze_327373 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327375 +
                                                                        (8 -
                                                                         shared_sizze_327375 %
                                                                         8) %
                                                                        8)));
                                    time_start_327371 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegred_large_314793_runs,
                                                              &ctx->mainzisegred_large_314793_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_314793,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segred_group_sizze_314786,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_327373 +
                                                                       (8 -
                                                                        shared_sizze_327373 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327375 +
                                                                       (8 -
                                                                        shared_sizze_327375 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_327370,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327372 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segred_large_314793",
                                            time_end_327372 -
                                            time_start_327371);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx,
                                                      &segred_tmp_mem_324369,
                                                      "segred_tmp_mem_324369") !=
                                0)
                                return 1;
                        }
                        
                        int64_t segmap_group_sizze_314827;
                        
                        segmap_group_sizze_314827 =
                            *ctx->tuning_params.mainzisegmap_group_sizze_314443;
                        
                        int64_t segmap_usable_groups_314828 =
                                sdiv_up64(nest_sizze_300870,
                                          segmap_group_sizze_314827);
                        struct memblock_device mem_319972;
                        
                        mem_319972.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319972,
                                                  bytes_318772, "mem_319972")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "\n# SegMap");
                        
                        CUdeviceptr kernel_arg_327388 = mem_319967.mem;
                        CUdeviceptr kernel_arg_327389 = mem_319972.mem;
                        
                        if ((((((1 && segmap_usable_groups_314828 != 0) && 1 !=
                                0) && 1 != 0) && segmap_group_sizze_314827 !=
                              0) && 1 != 0) && 1 != 0) {
                            int perm[3] = {0, 1, 2};
                            
                            if (1 >= 1 << 16) {
                                perm[1] = perm[0];
                                perm[0] = 1;
                            }
                            if (1 >= 1 << 16) {
                                perm[2] = perm[0];
                                perm[0] = 2;
                            }
                            
                            size_t grid[3];
                            
                            grid[perm[0]] = segmap_usable_groups_314828;
                            grid[perm[1]] = 1;
                            grid[perm[2]] = 1;
                            
                            void *kernel_args_327385[] = {&ctx->global_failure,
                                                          &partition_sizze_292766,
                                                          &t_n_m_292839,
                                                          &kernel_arg_327388,
                                                          &kernel_arg_327389};
                            int64_t time_start_327386 = 0, time_end_327387 = 0;
                            
                            if (ctx->debugging) {
                                fprintf(ctx->log,
                                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                        "main.segmap_314832",
                                        (long) segmap_usable_groups_314828,
                                        (long) 1, (long) 1,
                                        (long) segmap_group_sizze_314827,
                                        (long) 1, (long) 1, (int) 0);
                                time_start_327386 = get_wall_time();
                            }
                            
                            cudaEvent_t *pevents = NULL;
                            
                            if (ctx->profiling && !ctx->profiling_paused) {
                                pevents = cuda_get_events(&ctx->cuda,
                                                          &ctx->mainzisegmap_314832_runs,
                                                          &ctx->mainzisegmap_314832_total_runtime);
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                   0));
                            }
                            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_314832,
                                                                  grid[0],
                                                                  grid[1],
                                                                  grid[2],
                                                                  segmap_group_sizze_314827,
                                                                  1, 1, 0, NULL,
                                                                  kernel_args_327385,
                                                                  NULL));
                            if (pevents != NULL)
                                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                   0));
                            if (ctx->debugging) {
                                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                time_end_327387 = get_wall_time();
                                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                        "main.segmap_314832", time_end_327387 -
                                        time_start_327386);
                            }
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "");
                        if (memblock_unref_device(ctx, &mem_319967,
                                                  "mem_319967") != 0)
                            return 1;
                        
                        int64_t segred_group_sizze_314839;
                        
                        segred_group_sizze_314839 =
                            *ctx->tuning_params.mainzisegred_group_sizze_314386;
                        
                        int64_t num_groups_314840;
                        int32_t max_num_groups_324417;
                        
                        max_num_groups_324417 =
                            *ctx->tuning_params.mainzisegred_num_groups_314388;
                        num_groups_314840 = sext_i64_i32(smax64((int64_t) 1,
                                                                smin64(sdiv_up64(nest_sizze_314785,
                                                                                 segred_group_sizze_314839),
                                                                       sext_i32_i64(max_num_groups_324417))));
                        
                        struct memblock_device mem_319977;
                        
                        mem_319977.references = NULL;
                        if (memblock_alloc_device(ctx, &mem_319977,
                                                  bytes_318772, "mem_319977")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (slt64(q_t_292679 * (int64_t) 2,
                                  segred_group_sizze_314839)) {
                            int64_t segment_sizze_nonzzero_324418 =
                                    smax64((int64_t) 1, q_t_292679);
                            int64_t num_threads_324419 = num_groups_314840 *
                                    segred_group_sizze_314839;
                            
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegRed-small");
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                        (long long) (partition_sizze_292766 *
                                                     t_n_m_292839), '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                        (long long) q_t_292679, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "segments_per_group",
                                        (long long) squot64(segred_group_sizze_314839,
                                                            segment_sizze_nonzzero_324418),
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "required_groups",
                                        (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                           t_n_m_292839,
                                                                           squot64(segred_group_sizze_314839,
                                                                                   segment_sizze_nonzzero_324418))),
                                        '\n');
                            
                            unsigned int shared_sizze_327393 = (int64_t) 8 *
                                         segred_group_sizze_314839;
                            CUdeviceptr kernel_arg_327395 = ext_mem_318541.mem;
                            CUdeviceptr kernel_arg_327396 = ext_mem_318542.mem;
                            CUdeviceptr kernel_arg_327397 = ext_mem_318805.mem;
                            CUdeviceptr kernel_arg_327398 = ext_mem_318806.mem;
                            CUdeviceptr kernel_arg_327399 = mem_319958.mem;
                            CUdeviceptr kernel_arg_327400 = mem_319962.mem;
                            CUdeviceptr kernel_arg_327401 = mem_319972.mem;
                            CUdeviceptr kernel_arg_327402 = mem_319977.mem;
                            unsigned int shared_offset_327394 = 0;
                            
                            if ((((((1 && num_groups_314840 != 0) && 1 != 0) &&
                                   1 != 0) && segred_group_sizze_314839 != 0) &&
                                 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_314840;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327390[] =
                                     {&ctx->global_failure,
                                      &shared_offset_327394, &n_292675,
                                      &q_t_292679, &jump_t_292685,
                                      &partition_sizze_292766, &t_n_m_292839,
                                      &i_292846, &num_groups_314840,
                                      &segment_sizze_nonzzero_324418,
                                      &kernel_arg_327395, &kernel_arg_327396,
                                      &kernel_arg_327397, &kernel_arg_327398,
                                      &kernel_arg_327399, &kernel_arg_327400,
                                      &kernel_arg_327401, &kernel_arg_327402};
                                int64_t time_start_327391 = 0, time_end_327392 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segred_small_314846",
                                            (long) num_groups_314840, (long) 1,
                                            (long) 1,
                                            (long) segred_group_sizze_314839,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_327393 +
                                                                        (8 -
                                                                         shared_sizze_327393 %
                                                                         8) %
                                                                        8)));
                                    time_start_327391 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegred_small_314846_runs,
                                                              &ctx->mainzisegred_small_314846_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_314846,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segred_group_sizze_314839,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_327393 +
                                                                       (8 -
                                                                        shared_sizze_327393 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_327390,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327392 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segred_small_314846",
                                            time_end_327392 -
                                            time_start_327391);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                        } else {
                            int64_t groups_per_segment_324447 =
                                    sdiv_up64(num_groups_314840,
                                              smax64((int64_t) 1,
                                                     partition_sizze_292766 *
                                                     t_n_m_292839));
                            int64_t elements_per_thread_324448 =
                                    sdiv_up64(q_t_292679,
                                              segred_group_sizze_314839 *
                                              groups_per_segment_324447);
                            int64_t virt_num_groups_324449 =
                                    groups_per_segment_324447 *
                                    (partition_sizze_292766 * t_n_m_292839);
                            int64_t num_threads_324450 = num_groups_314840 *
                                    segred_group_sizze_314839;
                            int64_t threads_per_segment_324451 =
                                    groups_per_segment_324447 *
                                    segred_group_sizze_314839;
                            
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegRed-large");
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                        (long long) (partition_sizze_292766 *
                                                     t_n_m_292839), '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                        (long long) q_t_292679, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "virt_num_groups",
                                        (long long) virt_num_groups_324449,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_groups",
                                        (long long) num_groups_314840, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "group_size",
                                        (long long) segred_group_sizze_314839,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "elems_per_thread",
                                        (long long) elements_per_thread_324448,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "groups_per_segment",
                                        (long long) groups_per_segment_324447,
                                        '\n');
                            
                            struct memblock_device segred_tmp_mem_324452;
                            
                            segred_tmp_mem_324452.references = NULL;
                            if (memblock_alloc_device(ctx,
                                                      &segred_tmp_mem_324452,
                                                      (int64_t) 8 *
                                                      virt_num_groups_324449,
                                                      "segred_tmp_mem_324452")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mainzicounter_mem_324454 =
                                                   ctx->mainzicounter_mem_324454;
                            unsigned int shared_sizze_327407 = 1;
                            unsigned int shared_sizze_327409 = (int64_t) 8 *
                                         segred_group_sizze_314839;
                            CUdeviceptr kernel_arg_327411 = ext_mem_318541.mem;
                            CUdeviceptr kernel_arg_327412 = ext_mem_318542.mem;
                            CUdeviceptr kernel_arg_327413 = ext_mem_318805.mem;
                            CUdeviceptr kernel_arg_327414 = ext_mem_318806.mem;
                            CUdeviceptr kernel_arg_327415 = mem_319958.mem;
                            CUdeviceptr kernel_arg_327416 = mem_319962.mem;
                            CUdeviceptr kernel_arg_327417 = mem_319972.mem;
                            CUdeviceptr kernel_arg_327418 = mem_319977.mem;
                            CUdeviceptr kernel_arg_327419 =
                                        segred_tmp_mem_324452.mem;
                            CUdeviceptr kernel_arg_327420 =
                                        mainzicounter_mem_324454.mem;
                            unsigned int shared_offset_327408 = 0;
                            unsigned int shared_offset_327410 = 0 +
                                         (shared_sizze_327407 + (8 -
                                                                 shared_sizze_327407 %
                                                                 8) % 8);
                            
                            if ((((((1 && num_groups_314840 != 0) && 1 != 0) &&
                                   1 != 0) && segred_group_sizze_314839 != 0) &&
                                 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_314840;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327404[] =
                                     {&ctx->global_failure,
                                      &shared_offset_327408,
                                      &shared_offset_327410, &n_292675,
                                      &q_t_292679, &jump_t_292685,
                                      &partition_sizze_292766, &t_n_m_292839,
                                      &i_292846, &num_groups_314840,
                                      &groups_per_segment_324447,
                                      &elements_per_thread_324448,
                                      &virt_num_groups_324449,
                                      &threads_per_segment_324451,
                                      &kernel_arg_327411, &kernel_arg_327412,
                                      &kernel_arg_327413, &kernel_arg_327414,
                                      &kernel_arg_327415, &kernel_arg_327416,
                                      &kernel_arg_327417, &kernel_arg_327418,
                                      &kernel_arg_327419, &kernel_arg_327420};
                                int64_t time_start_327405 = 0, time_end_327406 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segred_large_314846",
                                            (long) num_groups_314840, (long) 1,
                                            (long) 1,
                                            (long) segred_group_sizze_314839,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_327407 +
                                                                        (8 -
                                                                         shared_sizze_327407 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327409 +
                                                                        (8 -
                                                                         shared_sizze_327409 %
                                                                         8) %
                                                                        8)));
                                    time_start_327405 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegred_large_314846_runs,
                                                              &ctx->mainzisegred_large_314846_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_314846,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segred_group_sizze_314839,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_327407 +
                                                                       (8 -
                                                                        shared_sizze_327407 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327409 +
                                                                       (8 -
                                                                        shared_sizze_327409 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_327404,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327406 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segred_large_314846",
                                            time_end_327406 -
                                            time_start_327405);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx,
                                                      &segred_tmp_mem_324452,
                                                      "segred_tmp_mem_324452") !=
                                0)
                                return 1;
                        }
                        if (memblock_unref_device(ctx, &mem_319958,
                                                  "mem_319958") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319962,
                                                  "mem_319962") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319972,
                                                  "mem_319972") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_320095,
                                                &mem_319977, "mem_319977") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_320094,
                                                &mem_319948, "mem_319948") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319977,
                                                  "mem_319977") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319972,
                                                  "mem_319972") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319967,
                                                  "mem_319967") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319962,
                                                  "mem_319962") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319958,
                                                  "mem_319958") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319953,
                                                  "mem_319953") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319948,
                                                  "mem_319948") != 0)
                            return 1;
                    } else {
                        bool match_lit_296673 = (int64_t) 1 == d_t_292682;
                        struct memblock_device ext_mem_320093;
                        
                        ext_mem_320093.references = NULL;
                        
                        struct memblock_device ext_mem_320092;
                        
                        ext_mem_320092.references = NULL;
                        if (match_lit_296673) {
                            int64_t segmap_group_sizze_315326;
                            
                            segmap_group_sizze_315326 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_315298;
                            
                            int64_t segmap_usable_groups_315327 =
                                    sdiv_up64(nest_sizze_297748,
                                              segmap_group_sizze_315326);
                            struct memblock_device mem_319982;
                            
                            mem_319982.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319982,
                                                      bytes_318522,
                                                      "mem_319982")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_327424 = mem_318506.mem;
                            CUdeviceptr kernel_arg_327425 = mem_319770.mem;
                            CUdeviceptr kernel_arg_327426 = mem_319982.mem;
                            
                            if ((((((1 && segmap_usable_groups_315327 != 0) &&
                                    1 != 0) && 1 != 0) &&
                                  segmap_group_sizze_315326 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = segmap_usable_groups_315327;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327421[] =
                                     {&ctx->global_failure, &n_292675,
                                      &partition_sizze_292766,
                                      &kernel_arg_327424, &kernel_arg_327425,
                                      &kernel_arg_327426};
                                int64_t time_start_327422 = 0, time_end_327423 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_315331",
                                            (long) segmap_usable_groups_315327,
                                            (long) 1, (long) 1,
                                            (long) segmap_group_sizze_315326,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_327422 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_315331_runs,
                                                              &ctx->mainzisegmap_315331_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_315331,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_315326,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_327421,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327423 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_315331",
                                            time_end_327423 -
                                            time_start_327422);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            
                            int64_t segmap_group_sizze_315343;
                            
                            segmap_group_sizze_315343 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_315242;
                            
                            int64_t segmap_usable_groups_315344 =
                                    sdiv_up64(nest_sizze_297748,
                                              segmap_group_sizze_315343);
                            struct memblock_device mem_319987;
                            
                            mem_319987.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319987,
                                                      bytes_318522,
                                                      "mem_319987")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_319991;
                            
                            mem_319991.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319991,
                                                      bytes_318522,
                                                      "mem_319991")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_327430 = ext_mem_318542.mem;
                            CUdeviceptr kernel_arg_327431 =
                                        mem_param_318838.mem;
                            CUdeviceptr kernel_arg_327432 = mem_319982.mem;
                            CUdeviceptr kernel_arg_327433 = mem_319987.mem;
                            CUdeviceptr kernel_arg_327434 = mem_319991.mem;
                            
                            if ((((((1 && segmap_usable_groups_315344 != 0) &&
                                    1 != 0) && 1 != 0) &&
                                  segmap_group_sizze_315343 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = segmap_usable_groups_315344;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327427[] =
                                     {&ctx->global_failure,
                                      &ctx->failure_is_an_option,
                                      &ctx->global_failure_args, &n_292675,
                                      &partition_sizze_292766,
                                      &ctx_param_ext_318833,
                                      &ctx_param_ext_318834,
                                      &ctx_param_ext_318836, &kernel_arg_327430,
                                      &kernel_arg_327431, &kernel_arg_327432,
                                      &kernel_arg_327433, &kernel_arg_327434};
                                int64_t time_start_327428 = 0, time_end_327429 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_315349",
                                            (long) segmap_usable_groups_315344,
                                            (long) 1, (long) 1,
                                            (long) segmap_group_sizze_315343,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_327428 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_315349_runs,
                                                              &ctx->mainzisegmap_315349_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_315349,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_315343,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_327427,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327429 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_315349",
                                            time_end_327429 -
                                            time_start_327428);
                                }
                            }
                            ctx->failure_is_an_option = 1;
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx, &mem_319982,
                                                      "mem_319982") != 0)
                                return 1;
                            
                            int64_t nest_sizze_315384 = q_t_292679 *
                                    nest_sizze_300870;
                            int64_t segred_group_sizze_315385;
                            
                            segred_group_sizze_315385 =
                                *ctx->tuning_params.mainzisegred_group_sizze_315010;
                            
                            int64_t num_groups_315386;
                            int32_t max_num_groups_324510;
                            
                            max_num_groups_324510 =
                                *ctx->tuning_params.mainzisegred_num_groups_315012;
                            num_groups_315386 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(nest_sizze_315384,
                                                                                     segred_group_sizze_315385),
                                                                           sext_i32_i64(max_num_groups_324510))));
                            
                            struct memblock_device mem_319996;
                            
                            mem_319996.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_319996,
                                                      bytes_318772,
                                                      "mem_319996")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320000;
                            
                            mem_320000.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320000,
                                                      bytes_318772,
                                                      "mem_320000")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320004;
                            
                            mem_320004.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320004,
                                                      bytes_318772,
                                                      "mem_320004")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (slt64(q_t_292679 * (int64_t) 2,
                                      segred_group_sizze_315385)) {
                                int64_t segment_sizze_nonzzero_324511 =
                                        smax64((int64_t) 1, q_t_292679);
                                int64_t num_threads_324512 = num_groups_315386 *
                                        segred_group_sizze_315385;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-small");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         t_n_m_292839), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_t_292679, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segments_per_group",
                                            (long long) squot64(segred_group_sizze_315385,
                                                                segment_sizze_nonzzero_324511),
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "required_groups",
                                            (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                               t_n_m_292839,
                                                                               squot64(segred_group_sizze_315385,
                                                                                       segment_sizze_nonzzero_324511))),
                                            '\n');
                                
                                unsigned int shared_sizze_327438 = (int64_t) 8 *
                                             segred_group_sizze_315385;
                                unsigned int shared_sizze_327440 = (int64_t) 8 *
                                             segred_group_sizze_315385;
                                unsigned int shared_sizze_327442 = (int64_t) 8 *
                                             segred_group_sizze_315385;
                                CUdeviceptr kernel_arg_327444 =
                                            ext_mem_318541.mem;
                                CUdeviceptr kernel_arg_327445 =
                                            ext_mem_318542.mem;
                                CUdeviceptr kernel_arg_327446 =
                                            ext_mem_318805.mem;
                                CUdeviceptr kernel_arg_327447 =
                                            ext_mem_318806.mem;
                                CUdeviceptr kernel_arg_327448 = mem_319987.mem;
                                CUdeviceptr kernel_arg_327449 = mem_319996.mem;
                                CUdeviceptr kernel_arg_327450 = mem_320000.mem;
                                CUdeviceptr kernel_arg_327451 = mem_320004.mem;
                                unsigned int shared_offset_327439 = 0;
                                unsigned int shared_offset_327441 = 0 +
                                             (shared_sizze_327438 + (8 -
                                                                     shared_sizze_327438 %
                                                                     8) % 8);
                                unsigned int shared_offset_327443 = 0 +
                                             (shared_sizze_327438 + (8 -
                                                                     shared_sizze_327438 %
                                                                     8) % 8) +
                                             (shared_sizze_327440 + (8 -
                                                                     shared_sizze_327440 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_315386 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_315385 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_315386;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327435[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327439,
                                          &shared_offset_327441,
                                          &shared_offset_327443, &n_292675,
                                          &q_t_292679, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &t_n_m_292839, &i_292846,
                                          &num_groups_315386,
                                          &segment_sizze_nonzzero_324511,
                                          &kernel_arg_327444,
                                          &kernel_arg_327445,
                                          &kernel_arg_327446,
                                          &kernel_arg_327447,
                                          &kernel_arg_327448,
                                          &kernel_arg_327449,
                                          &kernel_arg_327450,
                                          &kernel_arg_327451};
                                    int64_t time_start_327436 = 0,
                                            time_end_327437 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_small_315394",
                                                (long) num_groups_315386,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_315385,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327438 +
                                                                            (8 -
                                                                             shared_sizze_327438 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327440 +
                                                                            (8 -
                                                                             shared_sizze_327440 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327442 +
                                                                            (8 -
                                                                             shared_sizze_327442 %
                                                                             8) %
                                                                            8)));
                                        time_start_327436 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_small_315394_runs,
                                                                  &ctx->mainzisegred_small_315394_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_315394,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_315385,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327438 +
                                                                           (8 -
                                                                            shared_sizze_327438 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327440 +
                                                                           (8 -
                                                                            shared_sizze_327440 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327442 +
                                                                           (8 -
                                                                            shared_sizze_327442 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327435,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327437 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_small_315394",
                                                time_end_327437 -
                                                time_start_327436);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                            } else {
                                int64_t groups_per_segment_324552 =
                                        sdiv_up64(num_groups_315386,
                                                  smax64((int64_t) 1,
                                                         partition_sizze_292766 *
                                                         t_n_m_292839));
                                int64_t elements_per_thread_324553 =
                                        sdiv_up64(q_t_292679,
                                                  segred_group_sizze_315385 *
                                                  groups_per_segment_324552);
                                int64_t virt_num_groups_324554 =
                                        groups_per_segment_324552 *
                                        (partition_sizze_292766 * t_n_m_292839);
                                int64_t num_threads_324555 = num_groups_315386 *
                                        segred_group_sizze_315385;
                                int64_t threads_per_segment_324556 =
                                        groups_per_segment_324552 *
                                        segred_group_sizze_315385;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-large");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         t_n_m_292839), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_t_292679, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "virt_num_groups",
                                            (long long) virt_num_groups_324554,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_groups",
                                            (long long) num_groups_315386,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "group_size",
                                            (long long) segred_group_sizze_315385,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "elems_per_thread",
                                            (long long) elements_per_thread_324553,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "groups_per_segment",
                                            (long long) groups_per_segment_324552,
                                            '\n');
                                
                                struct memblock_device segred_tmp_mem_324557;
                                
                                segred_tmp_mem_324557.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324557,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324554,
                                                          "segred_tmp_mem_324557")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_324559;
                                
                                segred_tmp_mem_324559.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324559,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324554,
                                                          "segred_tmp_mem_324559")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_324561;
                                
                                segred_tmp_mem_324561.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324561,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324554,
                                                          "segred_tmp_mem_324561")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mainzicounter_mem_324563
                                                       =
                                                       ctx->mainzicounter_mem_324563;
                                unsigned int shared_sizze_327456 = 1;
                                unsigned int shared_sizze_327458 = (int64_t) 8 *
                                             segred_group_sizze_315385;
                                unsigned int shared_sizze_327460 = (int64_t) 8 *
                                             segred_group_sizze_315385;
                                unsigned int shared_sizze_327462 = (int64_t) 8 *
                                             segred_group_sizze_315385;
                                CUdeviceptr kernel_arg_327464 =
                                            ext_mem_318541.mem;
                                CUdeviceptr kernel_arg_327465 =
                                            ext_mem_318542.mem;
                                CUdeviceptr kernel_arg_327466 =
                                            ext_mem_318805.mem;
                                CUdeviceptr kernel_arg_327467 =
                                            ext_mem_318806.mem;
                                CUdeviceptr kernel_arg_327468 = mem_319987.mem;
                                CUdeviceptr kernel_arg_327469 = mem_319996.mem;
                                CUdeviceptr kernel_arg_327470 = mem_320000.mem;
                                CUdeviceptr kernel_arg_327471 = mem_320004.mem;
                                CUdeviceptr kernel_arg_327472 =
                                            segred_tmp_mem_324557.mem;
                                CUdeviceptr kernel_arg_327473 =
                                            segred_tmp_mem_324559.mem;
                                CUdeviceptr kernel_arg_327474 =
                                            segred_tmp_mem_324561.mem;
                                CUdeviceptr kernel_arg_327475 =
                                            mainzicounter_mem_324563.mem;
                                unsigned int shared_offset_327457 = 0;
                                unsigned int shared_offset_327459 = 0 +
                                             (shared_sizze_327456 + (8 -
                                                                     shared_sizze_327456 %
                                                                     8) % 8);
                                unsigned int shared_offset_327461 = 0 +
                                             (shared_sizze_327456 + (8 -
                                                                     shared_sizze_327456 %
                                                                     8) % 8) +
                                             (shared_sizze_327458 + (8 -
                                                                     shared_sizze_327458 %
                                                                     8) % 8);
                                unsigned int shared_offset_327463 = 0 +
                                             (shared_sizze_327456 + (8 -
                                                                     shared_sizze_327456 %
                                                                     8) % 8) +
                                             (shared_sizze_327458 + (8 -
                                                                     shared_sizze_327458 %
                                                                     8) % 8) +
                                             (shared_sizze_327460 + (8 -
                                                                     shared_sizze_327460 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_315386 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_315385 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_315386;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327453[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327457,
                                          &shared_offset_327459,
                                          &shared_offset_327461,
                                          &shared_offset_327463, &n_292675,
                                          &q_t_292679, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &t_n_m_292839, &i_292846,
                                          &num_groups_315386,
                                          &groups_per_segment_324552,
                                          &elements_per_thread_324553,
                                          &virt_num_groups_324554,
                                          &threads_per_segment_324556,
                                          &kernel_arg_327464,
                                          &kernel_arg_327465,
                                          &kernel_arg_327466,
                                          &kernel_arg_327467,
                                          &kernel_arg_327468,
                                          &kernel_arg_327469,
                                          &kernel_arg_327470,
                                          &kernel_arg_327471,
                                          &kernel_arg_327472,
                                          &kernel_arg_327473,
                                          &kernel_arg_327474,
                                          &kernel_arg_327475};
                                    int64_t time_start_327454 = 0,
                                            time_end_327455 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_large_315394",
                                                (long) num_groups_315386,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_315385,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327456 +
                                                                            (8 -
                                                                             shared_sizze_327456 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327458 +
                                                                            (8 -
                                                                             shared_sizze_327458 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327460 +
                                                                            (8 -
                                                                             shared_sizze_327460 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327462 +
                                                                            (8 -
                                                                             shared_sizze_327462 %
                                                                             8) %
                                                                            8)));
                                        time_start_327454 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_large_315394_runs,
                                                                  &ctx->mainzisegred_large_315394_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_315394,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_315385,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327456 +
                                                                           (8 -
                                                                            shared_sizze_327456 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327458 +
                                                                           (8 -
                                                                            shared_sizze_327458 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327460 +
                                                                           (8 -
                                                                            shared_sizze_327460 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327462 +
                                                                           (8 -
                                                                            shared_sizze_327462 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327453,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327455 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_large_315394",
                                                time_end_327455 -
                                                time_start_327454);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324561,
                                                          "segred_tmp_mem_324561") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324559,
                                                          "segred_tmp_mem_324559") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324557,
                                                          "segred_tmp_mem_324557") !=
                                    0)
                                    return 1;
                            }
                            
                            int64_t segmap_group_sizze_315436;
                            
                            segmap_group_sizze_315436 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_314985;
                            
                            int64_t segmap_usable_groups_315437 =
                                    sdiv_up64(nest_sizze_300870,
                                              segmap_group_sizze_315436);
                            struct memblock_device mem_320009;
                            
                            mem_320009.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320009,
                                                      bytes_318772,
                                                      "mem_320009")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320013;
                            
                            mem_320013.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320013,
                                                      bytes_318772,
                                                      "mem_320013")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320017;
                            
                            mem_320017.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320017,
                                                      bytes_318772,
                                                      "mem_320017")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_327479 = mem_319996.mem;
                            CUdeviceptr kernel_arg_327480 = mem_320000.mem;
                            CUdeviceptr kernel_arg_327481 = mem_320004.mem;
                            CUdeviceptr kernel_arg_327482 = mem_320009.mem;
                            CUdeviceptr kernel_arg_327483 = mem_320013.mem;
                            CUdeviceptr kernel_arg_327484 = mem_320017.mem;
                            
                            if ((((((1 && segmap_usable_groups_315437 != 0) &&
                                    1 != 0) && 1 != 0) &&
                                  segmap_group_sizze_315436 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = segmap_usable_groups_315437;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327476[] =
                                     {&ctx->global_failure,
                                      &partition_sizze_292766, &t_n_m_292839,
                                      &kernel_arg_327479, &kernel_arg_327480,
                                      &kernel_arg_327481, &kernel_arg_327482,
                                      &kernel_arg_327483, &kernel_arg_327484};
                                int64_t time_start_327477 = 0, time_end_327478 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_315443",
                                            (long) segmap_usable_groups_315437,
                                            (long) 1, (long) 1,
                                            (long) segmap_group_sizze_315436,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_327477 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_315443_runs,
                                                              &ctx->mainzisegmap_315443_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_315443,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_315436,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_327476,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327478 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_315443",
                                            time_end_327478 -
                                            time_start_327477);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx, &mem_319996,
                                                      "mem_319996") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320000,
                                                      "mem_320000") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320004,
                                                      "mem_320004") != 0)
                                return 1;
                            
                            int64_t segred_group_sizze_315461;
                            
                            segred_group_sizze_315461 =
                                *ctx->tuning_params.mainzisegred_group_sizze_314910;
                            
                            int64_t num_groups_315462;
                            int32_t max_num_groups_324621;
                            
                            max_num_groups_324621 =
                                *ctx->tuning_params.mainzisegred_num_groups_314912;
                            num_groups_315462 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(nest_sizze_315384,
                                                                                     segred_group_sizze_315461),
                                                                           sext_i32_i64(max_num_groups_324621))));
                            
                            struct memblock_device mem_320022;
                            
                            mem_320022.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320022,
                                                      bytes_318772,
                                                      "mem_320022")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320026;
                            
                            mem_320026.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320026,
                                                      bytes_318772,
                                                      "mem_320026")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (slt64(q_t_292679 * (int64_t) 2,
                                      segred_group_sizze_315461)) {
                                int64_t segment_sizze_nonzzero_324622 =
                                        smax64((int64_t) 1, q_t_292679);
                                int64_t num_threads_324623 = num_groups_315462 *
                                        segred_group_sizze_315461;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-small");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         t_n_m_292839), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_t_292679, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segments_per_group",
                                            (long long) squot64(segred_group_sizze_315461,
                                                                segment_sizze_nonzzero_324622),
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "required_groups",
                                            (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                               t_n_m_292839,
                                                                               squot64(segred_group_sizze_315461,
                                                                                       segment_sizze_nonzzero_324622))),
                                            '\n');
                                
                                unsigned int shared_sizze_327488 = (int64_t) 8 *
                                             segred_group_sizze_315461;
                                unsigned int shared_sizze_327490 = (int64_t) 8 *
                                             segred_group_sizze_315461;
                                CUdeviceptr kernel_arg_327492 =
                                            ext_mem_318541.mem;
                                CUdeviceptr kernel_arg_327493 =
                                            ext_mem_318542.mem;
                                CUdeviceptr kernel_arg_327494 =
                                            ext_mem_318805.mem;
                                CUdeviceptr kernel_arg_327495 =
                                            ext_mem_318806.mem;
                                CUdeviceptr kernel_arg_327496 = mem_319987.mem;
                                CUdeviceptr kernel_arg_327497 = mem_319991.mem;
                                CUdeviceptr kernel_arg_327498 = mem_320009.mem;
                                CUdeviceptr kernel_arg_327499 = mem_320013.mem;
                                CUdeviceptr kernel_arg_327500 = mem_320017.mem;
                                CUdeviceptr kernel_arg_327501 = mem_320022.mem;
                                CUdeviceptr kernel_arg_327502 = mem_320026.mem;
                                unsigned int shared_offset_327489 = 0;
                                unsigned int shared_offset_327491 = 0 +
                                             (shared_sizze_327488 + (8 -
                                                                     shared_sizze_327488 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_315462 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_315461 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_315462;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327485[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327489,
                                          &shared_offset_327491, &n_292675,
                                          &q_t_292679, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &t_n_m_292839, &i_292846,
                                          &num_groups_315462,
                                          &segment_sizze_nonzzero_324622,
                                          &kernel_arg_327492,
                                          &kernel_arg_327493,
                                          &kernel_arg_327494,
                                          &kernel_arg_327495,
                                          &kernel_arg_327496,
                                          &kernel_arg_327497,
                                          &kernel_arg_327498,
                                          &kernel_arg_327499,
                                          &kernel_arg_327500,
                                          &kernel_arg_327501,
                                          &kernel_arg_327502};
                                    int64_t time_start_327486 = 0,
                                            time_end_327487 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_small_315469",
                                                (long) num_groups_315462,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_315461,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327488 +
                                                                            (8 -
                                                                             shared_sizze_327488 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327490 +
                                                                            (8 -
                                                                             shared_sizze_327490 %
                                                                             8) %
                                                                            8)));
                                        time_start_327486 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_small_315469_runs,
                                                                  &ctx->mainzisegred_small_315469_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_315469,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_315461,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327488 +
                                                                           (8 -
                                                                            shared_sizze_327488 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327490 +
                                                                           (8 -
                                                                            shared_sizze_327490 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327485,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327487 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_small_315469",
                                                time_end_327487 -
                                                time_start_327486);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                            } else {
                                int64_t groups_per_segment_324657 =
                                        sdiv_up64(num_groups_315462,
                                                  smax64((int64_t) 1,
                                                         partition_sizze_292766 *
                                                         t_n_m_292839));
                                int64_t elements_per_thread_324658 =
                                        sdiv_up64(q_t_292679,
                                                  segred_group_sizze_315461 *
                                                  groups_per_segment_324657);
                                int64_t virt_num_groups_324659 =
                                        groups_per_segment_324657 *
                                        (partition_sizze_292766 * t_n_m_292839);
                                int64_t num_threads_324660 = num_groups_315462 *
                                        segred_group_sizze_315461;
                                int64_t threads_per_segment_324661 =
                                        groups_per_segment_324657 *
                                        segred_group_sizze_315461;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-large");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         t_n_m_292839), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_t_292679, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "virt_num_groups",
                                            (long long) virt_num_groups_324659,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_groups",
                                            (long long) num_groups_315462,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "group_size",
                                            (long long) segred_group_sizze_315461,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "elems_per_thread",
                                            (long long) elements_per_thread_324658,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "groups_per_segment",
                                            (long long) groups_per_segment_324657,
                                            '\n');
                                
                                struct memblock_device segred_tmp_mem_324662;
                                
                                segred_tmp_mem_324662.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324662,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324659,
                                                          "segred_tmp_mem_324662")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_324664;
                                
                                segred_tmp_mem_324664.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324664,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324659,
                                                          "segred_tmp_mem_324664")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mainzicounter_mem_324666
                                                       =
                                                       ctx->mainzicounter_mem_324666;
                                unsigned int shared_sizze_327507 = 1;
                                unsigned int shared_sizze_327509 = (int64_t) 8 *
                                             segred_group_sizze_315461;
                                unsigned int shared_sizze_327511 = (int64_t) 8 *
                                             segred_group_sizze_315461;
                                CUdeviceptr kernel_arg_327513 =
                                            ext_mem_318541.mem;
                                CUdeviceptr kernel_arg_327514 =
                                            ext_mem_318542.mem;
                                CUdeviceptr kernel_arg_327515 =
                                            ext_mem_318805.mem;
                                CUdeviceptr kernel_arg_327516 =
                                            ext_mem_318806.mem;
                                CUdeviceptr kernel_arg_327517 = mem_319987.mem;
                                CUdeviceptr kernel_arg_327518 = mem_319991.mem;
                                CUdeviceptr kernel_arg_327519 = mem_320009.mem;
                                CUdeviceptr kernel_arg_327520 = mem_320013.mem;
                                CUdeviceptr kernel_arg_327521 = mem_320017.mem;
                                CUdeviceptr kernel_arg_327522 = mem_320022.mem;
                                CUdeviceptr kernel_arg_327523 = mem_320026.mem;
                                CUdeviceptr kernel_arg_327524 =
                                            segred_tmp_mem_324662.mem;
                                CUdeviceptr kernel_arg_327525 =
                                            segred_tmp_mem_324664.mem;
                                CUdeviceptr kernel_arg_327526 =
                                            mainzicounter_mem_324666.mem;
                                unsigned int shared_offset_327508 = 0;
                                unsigned int shared_offset_327510 = 0 +
                                             (shared_sizze_327507 + (8 -
                                                                     shared_sizze_327507 %
                                                                     8) % 8);
                                unsigned int shared_offset_327512 = 0 +
                                             (shared_sizze_327507 + (8 -
                                                                     shared_sizze_327507 %
                                                                     8) % 8) +
                                             (shared_sizze_327509 + (8 -
                                                                     shared_sizze_327509 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_315462 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_315461 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_315462;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327504[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327508,
                                          &shared_offset_327510,
                                          &shared_offset_327512, &n_292675,
                                          &q_t_292679, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &t_n_m_292839, &i_292846,
                                          &num_groups_315462,
                                          &groups_per_segment_324657,
                                          &elements_per_thread_324658,
                                          &virt_num_groups_324659,
                                          &threads_per_segment_324661,
                                          &kernel_arg_327513,
                                          &kernel_arg_327514,
                                          &kernel_arg_327515,
                                          &kernel_arg_327516,
                                          &kernel_arg_327517,
                                          &kernel_arg_327518,
                                          &kernel_arg_327519,
                                          &kernel_arg_327520,
                                          &kernel_arg_327521,
                                          &kernel_arg_327522,
                                          &kernel_arg_327523,
                                          &kernel_arg_327524,
                                          &kernel_arg_327525,
                                          &kernel_arg_327526};
                                    int64_t time_start_327505 = 0,
                                            time_end_327506 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_large_315469",
                                                (long) num_groups_315462,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_315461,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327507 +
                                                                            (8 -
                                                                             shared_sizze_327507 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327509 +
                                                                            (8 -
                                                                             shared_sizze_327509 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327511 +
                                                                            (8 -
                                                                             shared_sizze_327511 %
                                                                             8) %
                                                                            8)));
                                        time_start_327505 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_large_315469_runs,
                                                                  &ctx->mainzisegred_large_315469_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_315469,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_315461,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327507 +
                                                                           (8 -
                                                                            shared_sizze_327507 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327509 +
                                                                           (8 -
                                                                            shared_sizze_327509 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327511 +
                                                                           (8 -
                                                                            shared_sizze_327511 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327504,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327506 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_large_315469",
                                                time_end_327506 -
                                                time_start_327505);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324664,
                                                          "segred_tmp_mem_324664") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324662,
                                                          "segred_tmp_mem_324662") !=
                                    0)
                                    return 1;
                            }
                            if (memblock_unref_device(ctx, &mem_319987,
                                                      "mem_319987") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319991,
                                                      "mem_319991") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320009,
                                                      "mem_320009") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320013,
                                                      "mem_320013") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320017,
                                                      "mem_320017") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_320093,
                                                    &mem_320022,
                                                    "mem_320022") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_320092,
                                                    &mem_320026,
                                                    "mem_320026") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320026,
                                                      "mem_320026") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320022,
                                                      "mem_320022") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320017,
                                                      "mem_320017") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320013,
                                                      "mem_320013") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320009,
                                                      "mem_320009") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320004,
                                                      "mem_320004") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320000,
                                                      "mem_320000") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319996,
                                                      "mem_319996") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319991,
                                                      "mem_319991") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319987,
                                                      "mem_319987") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_319982,
                                                      "mem_319982") != 0)
                                return 1;
                        } else {
                            int64_t segmap_group_sizze_316052;
                            
                            segmap_group_sizze_316052 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_316024;
                            
                            int64_t segmap_usable_groups_316053 =
                                    sdiv_up64(nest_sizze_297748,
                                              segmap_group_sizze_316052);
                            struct memblock_device mem_320031;
                            
                            mem_320031.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320031,
                                                      bytes_318522,
                                                      "mem_320031")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_327530 = mem_318506.mem;
                            CUdeviceptr kernel_arg_327531 = mem_319770.mem;
                            CUdeviceptr kernel_arg_327532 = mem_320031.mem;
                            
                            if ((((((1 && segmap_usable_groups_316053 != 0) &&
                                    1 != 0) && 1 != 0) &&
                                  segmap_group_sizze_316052 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = segmap_usable_groups_316053;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327527[] =
                                     {&ctx->global_failure, &n_292675,
                                      &partition_sizze_292766,
                                      &kernel_arg_327530, &kernel_arg_327531,
                                      &kernel_arg_327532};
                                int64_t time_start_327528 = 0, time_end_327529 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_316057",
                                            (long) segmap_usable_groups_316053,
                                            (long) 1, (long) 1,
                                            (long) segmap_group_sizze_316052,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_327528 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_316057_runs,
                                                              &ctx->mainzisegmap_316057_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_316057,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_316052,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_327527,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327529 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_316057",
                                            time_end_327529 -
                                            time_start_327528);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            
                            int64_t segmap_group_sizze_316069;
                            
                            segmap_group_sizze_316069 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_315968;
                            
                            int64_t segmap_usable_groups_316070 =
                                    sdiv_up64(nest_sizze_297748,
                                              segmap_group_sizze_316069);
                            struct memblock_device mem_320036;
                            
                            mem_320036.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320036,
                                                      bytes_318522,
                                                      "mem_320036")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320040;
                            
                            mem_320040.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320040,
                                                      bytes_318522,
                                                      "mem_320040")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_327536 = ext_mem_318542.mem;
                            CUdeviceptr kernel_arg_327537 =
                                        mem_param_318838.mem;
                            CUdeviceptr kernel_arg_327538 = mem_320031.mem;
                            CUdeviceptr kernel_arg_327539 = mem_320036.mem;
                            CUdeviceptr kernel_arg_327540 = mem_320040.mem;
                            
                            if ((((((1 && segmap_usable_groups_316070 != 0) &&
                                    1 != 0) && 1 != 0) &&
                                  segmap_group_sizze_316069 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = segmap_usable_groups_316070;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327533[] =
                                     {&ctx->global_failure,
                                      &ctx->failure_is_an_option,
                                      &ctx->global_failure_args, &n_292675,
                                      &partition_sizze_292766,
                                      &ctx_param_ext_318833,
                                      &ctx_param_ext_318834,
                                      &ctx_param_ext_318836, &kernel_arg_327536,
                                      &kernel_arg_327537, &kernel_arg_327538,
                                      &kernel_arg_327539, &kernel_arg_327540};
                                int64_t time_start_327534 = 0, time_end_327535 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_316075",
                                            (long) segmap_usable_groups_316070,
                                            (long) 1, (long) 1,
                                            (long) segmap_group_sizze_316069,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_327534 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_316075_runs,
                                                              &ctx->mainzisegmap_316075_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_316075,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_316069,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_327533,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327535 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_316075",
                                            time_end_327535 -
                                            time_start_327534);
                                }
                            }
                            ctx->failure_is_an_option = 1;
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx, &mem_320031,
                                                      "mem_320031") != 0)
                                return 1;
                            
                            int64_t nest_sizze_316110 = q_t_292679 *
                                    nest_sizze_300870;
                            int64_t segred_group_sizze_316111;
                            
                            segred_group_sizze_316111 =
                                *ctx->tuning_params.mainzisegred_group_sizze_315686;
                            
                            int64_t num_groups_316112;
                            int32_t max_num_groups_324728;
                            
                            max_num_groups_324728 =
                                *ctx->tuning_params.mainzisegred_num_groups_315688;
                            num_groups_316112 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(nest_sizze_316110,
                                                                                     segred_group_sizze_316111),
                                                                           sext_i32_i64(max_num_groups_324728))));
                            
                            struct memblock_device mem_320045;
                            
                            mem_320045.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320045,
                                                      bytes_318772,
                                                      "mem_320045")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320049;
                            
                            mem_320049.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320049,
                                                      bytes_318772,
                                                      "mem_320049")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320053;
                            
                            mem_320053.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320053,
                                                      bytes_318772,
                                                      "mem_320053")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320057;
                            
                            mem_320057.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320057,
                                                      bytes_318772,
                                                      "mem_320057")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320061;
                            
                            mem_320061.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320061,
                                                      bytes_318772,
                                                      "mem_320061")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (slt64(q_t_292679 * (int64_t) 2,
                                      segred_group_sizze_316111)) {
                                int64_t segment_sizze_nonzzero_324729 =
                                        smax64((int64_t) 1, q_t_292679);
                                int64_t num_threads_324730 = num_groups_316112 *
                                        segred_group_sizze_316111;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-small");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         t_n_m_292839), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_t_292679, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segments_per_group",
                                            (long long) squot64(segred_group_sizze_316111,
                                                                segment_sizze_nonzzero_324729),
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "required_groups",
                                            (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                               t_n_m_292839,
                                                                               squot64(segred_group_sizze_316111,
                                                                                       segment_sizze_nonzzero_324729))),
                                            '\n');
                                
                                unsigned int shared_sizze_327544 = (int64_t) 8 *
                                             segred_group_sizze_316111;
                                unsigned int shared_sizze_327546 = (int64_t) 8 *
                                             segred_group_sizze_316111;
                                unsigned int shared_sizze_327548 = (int64_t) 8 *
                                             segred_group_sizze_316111;
                                unsigned int shared_sizze_327550 = (int64_t) 8 *
                                             segred_group_sizze_316111;
                                unsigned int shared_sizze_327552 = (int64_t) 8 *
                                             segred_group_sizze_316111;
                                CUdeviceptr kernel_arg_327554 =
                                            ext_mem_318541.mem;
                                CUdeviceptr kernel_arg_327555 =
                                            ext_mem_318542.mem;
                                CUdeviceptr kernel_arg_327556 =
                                            ext_mem_318805.mem;
                                CUdeviceptr kernel_arg_327557 =
                                            ext_mem_318806.mem;
                                CUdeviceptr kernel_arg_327558 = mem_320036.mem;
                                CUdeviceptr kernel_arg_327559 = mem_320045.mem;
                                CUdeviceptr kernel_arg_327560 = mem_320049.mem;
                                CUdeviceptr kernel_arg_327561 = mem_320053.mem;
                                CUdeviceptr kernel_arg_327562 = mem_320057.mem;
                                CUdeviceptr kernel_arg_327563 = mem_320061.mem;
                                unsigned int shared_offset_327545 = 0;
                                unsigned int shared_offset_327547 = 0 +
                                             (shared_sizze_327544 + (8 -
                                                                     shared_sizze_327544 %
                                                                     8) % 8);
                                unsigned int shared_offset_327549 = 0 +
                                             (shared_sizze_327544 + (8 -
                                                                     shared_sizze_327544 %
                                                                     8) % 8) +
                                             (shared_sizze_327546 + (8 -
                                                                     shared_sizze_327546 %
                                                                     8) % 8);
                                unsigned int shared_offset_327551 = 0 +
                                             (shared_sizze_327544 + (8 -
                                                                     shared_sizze_327544 %
                                                                     8) % 8) +
                                             (shared_sizze_327546 + (8 -
                                                                     shared_sizze_327546 %
                                                                     8) % 8) +
                                             (shared_sizze_327548 + (8 -
                                                                     shared_sizze_327548 %
                                                                     8) % 8);
                                unsigned int shared_offset_327553 = 0 +
                                             (shared_sizze_327544 + (8 -
                                                                     shared_sizze_327544 %
                                                                     8) % 8) +
                                             (shared_sizze_327546 + (8 -
                                                                     shared_sizze_327546 %
                                                                     8) % 8) +
                                             (shared_sizze_327548 + (8 -
                                                                     shared_sizze_327548 %
                                                                     8) % 8) +
                                             (shared_sizze_327550 + (8 -
                                                                     shared_sizze_327550 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_316112 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_316111 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_316112;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327541[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327545,
                                          &shared_offset_327547,
                                          &shared_offset_327549,
                                          &shared_offset_327551,
                                          &shared_offset_327553, &n_292675,
                                          &q_t_292679, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &t_n_m_292839, &i_292846,
                                          &num_groups_316112,
                                          &segment_sizze_nonzzero_324729,
                                          &kernel_arg_327554,
                                          &kernel_arg_327555,
                                          &kernel_arg_327556,
                                          &kernel_arg_327557,
                                          &kernel_arg_327558,
                                          &kernel_arg_327559,
                                          &kernel_arg_327560,
                                          &kernel_arg_327561,
                                          &kernel_arg_327562,
                                          &kernel_arg_327563};
                                    int64_t time_start_327542 = 0,
                                            time_end_327543 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_small_316122",
                                                (long) num_groups_316112,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_316111,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327544 +
                                                                            (8 -
                                                                             shared_sizze_327544 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327546 +
                                                                            (8 -
                                                                             shared_sizze_327546 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327548 +
                                                                            (8 -
                                                                             shared_sizze_327548 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327550 +
                                                                            (8 -
                                                                             shared_sizze_327550 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327552 +
                                                                            (8 -
                                                                             shared_sizze_327552 %
                                                                             8) %
                                                                            8)));
                                        time_start_327542 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_small_316122_runs,
                                                                  &ctx->mainzisegred_small_316122_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_316122,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_316111,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327544 +
                                                                           (8 -
                                                                            shared_sizze_327544 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327546 +
                                                                           (8 -
                                                                            shared_sizze_327546 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327548 +
                                                                           (8 -
                                                                            shared_sizze_327548 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327550 +
                                                                           (8 -
                                                                            shared_sizze_327550 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327552 +
                                                                           (8 -
                                                                            shared_sizze_327552 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327541,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327543 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_small_316122",
                                                time_end_327543 -
                                                time_start_327542);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                            } else {
                                int64_t groups_per_segment_324782 =
                                        sdiv_up64(num_groups_316112,
                                                  smax64((int64_t) 1,
                                                         partition_sizze_292766 *
                                                         t_n_m_292839));
                                int64_t elements_per_thread_324783 =
                                        sdiv_up64(q_t_292679,
                                                  segred_group_sizze_316111 *
                                                  groups_per_segment_324782);
                                int64_t virt_num_groups_324784 =
                                        groups_per_segment_324782 *
                                        (partition_sizze_292766 * t_n_m_292839);
                                int64_t num_threads_324785 = num_groups_316112 *
                                        segred_group_sizze_316111;
                                int64_t threads_per_segment_324786 =
                                        groups_per_segment_324782 *
                                        segred_group_sizze_316111;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-large");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         t_n_m_292839), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_t_292679, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "virt_num_groups",
                                            (long long) virt_num_groups_324784,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_groups",
                                            (long long) num_groups_316112,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "group_size",
                                            (long long) segred_group_sizze_316111,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "elems_per_thread",
                                            (long long) elements_per_thread_324783,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "groups_per_segment",
                                            (long long) groups_per_segment_324782,
                                            '\n');
                                
                                struct memblock_device segred_tmp_mem_324787;
                                
                                segred_tmp_mem_324787.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324787,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324784,
                                                          "segred_tmp_mem_324787")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_324789;
                                
                                segred_tmp_mem_324789.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324789,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324784,
                                                          "segred_tmp_mem_324789")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_324791;
                                
                                segred_tmp_mem_324791.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324791,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324784,
                                                          "segred_tmp_mem_324791")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_324793;
                                
                                segred_tmp_mem_324793.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324793,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324784,
                                                          "segred_tmp_mem_324793")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_324795;
                                
                                segred_tmp_mem_324795.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324795,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324784,
                                                          "segred_tmp_mem_324795")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mainzicounter_mem_324797
                                                       =
                                                       ctx->mainzicounter_mem_324797;
                                unsigned int shared_sizze_327568 = 1;
                                unsigned int shared_sizze_327570 = (int64_t) 8 *
                                             segred_group_sizze_316111;
                                unsigned int shared_sizze_327572 = (int64_t) 8 *
                                             segred_group_sizze_316111;
                                unsigned int shared_sizze_327574 = (int64_t) 8 *
                                             segred_group_sizze_316111;
                                unsigned int shared_sizze_327576 = (int64_t) 8 *
                                             segred_group_sizze_316111;
                                unsigned int shared_sizze_327578 = (int64_t) 8 *
                                             segred_group_sizze_316111;
                                CUdeviceptr kernel_arg_327580 =
                                            ext_mem_318541.mem;
                                CUdeviceptr kernel_arg_327581 =
                                            ext_mem_318542.mem;
                                CUdeviceptr kernel_arg_327582 =
                                            ext_mem_318805.mem;
                                CUdeviceptr kernel_arg_327583 =
                                            ext_mem_318806.mem;
                                CUdeviceptr kernel_arg_327584 = mem_320036.mem;
                                CUdeviceptr kernel_arg_327585 = mem_320045.mem;
                                CUdeviceptr kernel_arg_327586 = mem_320049.mem;
                                CUdeviceptr kernel_arg_327587 = mem_320053.mem;
                                CUdeviceptr kernel_arg_327588 = mem_320057.mem;
                                CUdeviceptr kernel_arg_327589 = mem_320061.mem;
                                CUdeviceptr kernel_arg_327590 =
                                            segred_tmp_mem_324787.mem;
                                CUdeviceptr kernel_arg_327591 =
                                            segred_tmp_mem_324789.mem;
                                CUdeviceptr kernel_arg_327592 =
                                            segred_tmp_mem_324791.mem;
                                CUdeviceptr kernel_arg_327593 =
                                            segred_tmp_mem_324793.mem;
                                CUdeviceptr kernel_arg_327594 =
                                            segred_tmp_mem_324795.mem;
                                CUdeviceptr kernel_arg_327595 =
                                            mainzicounter_mem_324797.mem;
                                unsigned int shared_offset_327569 = 0;
                                unsigned int shared_offset_327571 = 0 +
                                             (shared_sizze_327568 + (8 -
                                                                     shared_sizze_327568 %
                                                                     8) % 8);
                                unsigned int shared_offset_327573 = 0 +
                                             (shared_sizze_327568 + (8 -
                                                                     shared_sizze_327568 %
                                                                     8) % 8) +
                                             (shared_sizze_327570 + (8 -
                                                                     shared_sizze_327570 %
                                                                     8) % 8);
                                unsigned int shared_offset_327575 = 0 +
                                             (shared_sizze_327568 + (8 -
                                                                     shared_sizze_327568 %
                                                                     8) % 8) +
                                             (shared_sizze_327570 + (8 -
                                                                     shared_sizze_327570 %
                                                                     8) % 8) +
                                             (shared_sizze_327572 + (8 -
                                                                     shared_sizze_327572 %
                                                                     8) % 8);
                                unsigned int shared_offset_327577 = 0 +
                                             (shared_sizze_327568 + (8 -
                                                                     shared_sizze_327568 %
                                                                     8) % 8) +
                                             (shared_sizze_327570 + (8 -
                                                                     shared_sizze_327570 %
                                                                     8) % 8) +
                                             (shared_sizze_327572 + (8 -
                                                                     shared_sizze_327572 %
                                                                     8) % 8) +
                                             (shared_sizze_327574 + (8 -
                                                                     shared_sizze_327574 %
                                                                     8) % 8);
                                unsigned int shared_offset_327579 = 0 +
                                             (shared_sizze_327568 + (8 -
                                                                     shared_sizze_327568 %
                                                                     8) % 8) +
                                             (shared_sizze_327570 + (8 -
                                                                     shared_sizze_327570 %
                                                                     8) % 8) +
                                             (shared_sizze_327572 + (8 -
                                                                     shared_sizze_327572 %
                                                                     8) % 8) +
                                             (shared_sizze_327574 + (8 -
                                                                     shared_sizze_327574 %
                                                                     8) % 8) +
                                             (shared_sizze_327576 + (8 -
                                                                     shared_sizze_327576 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_316112 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_316111 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_316112;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327565[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327569,
                                          &shared_offset_327571,
                                          &shared_offset_327573,
                                          &shared_offset_327575,
                                          &shared_offset_327577,
                                          &shared_offset_327579, &n_292675,
                                          &q_t_292679, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &t_n_m_292839, &i_292846,
                                          &num_groups_316112,
                                          &groups_per_segment_324782,
                                          &elements_per_thread_324783,
                                          &virt_num_groups_324784,
                                          &threads_per_segment_324786,
                                          &kernel_arg_327580,
                                          &kernel_arg_327581,
                                          &kernel_arg_327582,
                                          &kernel_arg_327583,
                                          &kernel_arg_327584,
                                          &kernel_arg_327585,
                                          &kernel_arg_327586,
                                          &kernel_arg_327587,
                                          &kernel_arg_327588,
                                          &kernel_arg_327589,
                                          &kernel_arg_327590,
                                          &kernel_arg_327591,
                                          &kernel_arg_327592,
                                          &kernel_arg_327593,
                                          &kernel_arg_327594,
                                          &kernel_arg_327595};
                                    int64_t time_start_327566 = 0,
                                            time_end_327567 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_large_316122",
                                                (long) num_groups_316112,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_316111,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327568 +
                                                                            (8 -
                                                                             shared_sizze_327568 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327570 +
                                                                            (8 -
                                                                             shared_sizze_327570 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327572 +
                                                                            (8 -
                                                                             shared_sizze_327572 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327574 +
                                                                            (8 -
                                                                             shared_sizze_327574 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327576 +
                                                                            (8 -
                                                                             shared_sizze_327576 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327578 +
                                                                            (8 -
                                                                             shared_sizze_327578 %
                                                                             8) %
                                                                            8)));
                                        time_start_327566 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_large_316122_runs,
                                                                  &ctx->mainzisegred_large_316122_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_316122,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_316111,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327568 +
                                                                           (8 -
                                                                            shared_sizze_327568 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327570 +
                                                                           (8 -
                                                                            shared_sizze_327570 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327572 +
                                                                           (8 -
                                                                            shared_sizze_327572 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327574 +
                                                                           (8 -
                                                                            shared_sizze_327574 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327576 +
                                                                           (8 -
                                                                            shared_sizze_327576 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327578 +
                                                                           (8 -
                                                                            shared_sizze_327578 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327565,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327567 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_large_316122",
                                                time_end_327567 -
                                                time_start_327566);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324795,
                                                          "segred_tmp_mem_324795") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324793,
                                                          "segred_tmp_mem_324793") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324791,
                                                          "segred_tmp_mem_324791") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324789,
                                                          "segred_tmp_mem_324789") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324787,
                                                          "segred_tmp_mem_324787") !=
                                    0)
                                    return 1;
                            }
                            
                            int64_t segmap_group_sizze_316172;
                            
                            segmap_group_sizze_316172 =
                                *ctx->tuning_params.mainzisegmap_group_sizze_315640;
                            
                            int64_t segmap_usable_groups_316173 =
                                    sdiv_up64(nest_sizze_300870,
                                              segmap_group_sizze_316172);
                            struct memblock_device mem_320066;
                            
                            mem_320066.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320066,
                                                      bytes_318772,
                                                      "mem_320066")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320070;
                            
                            mem_320070.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320070,
                                                      bytes_318772,
                                                      "mem_320070")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320074;
                            
                            mem_320074.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320074,
                                                      bytes_318772,
                                                      "mem_320074")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320078;
                            
                            mem_320078.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320078,
                                                      bytes_318772,
                                                      "mem_320078")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320082;
                            
                            mem_320082.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320082,
                                                      bytes_318772,
                                                      "mem_320082")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegMap");
                            
                            CUdeviceptr kernel_arg_327599 = mem_320045.mem;
                            CUdeviceptr kernel_arg_327600 = mem_320049.mem;
                            CUdeviceptr kernel_arg_327601 = mem_320053.mem;
                            CUdeviceptr kernel_arg_327602 = mem_320057.mem;
                            CUdeviceptr kernel_arg_327603 = mem_320061.mem;
                            CUdeviceptr kernel_arg_327604 = mem_320066.mem;
                            CUdeviceptr kernel_arg_327605 = mem_320070.mem;
                            CUdeviceptr kernel_arg_327606 = mem_320074.mem;
                            CUdeviceptr kernel_arg_327607 = mem_320078.mem;
                            CUdeviceptr kernel_arg_327608 = mem_320082.mem;
                            
                            if ((((((1 && segmap_usable_groups_316173 != 0) &&
                                    1 != 0) && 1 != 0) &&
                                  segmap_group_sizze_316172 != 0) && 1 != 0) &&
                                1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = segmap_usable_groups_316173;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327596[] =
                                     {&ctx->global_failure,
                                      &partition_sizze_292766, &t_n_m_292839,
                                      &kernel_arg_327599, &kernel_arg_327600,
                                      &kernel_arg_327601, &kernel_arg_327602,
                                      &kernel_arg_327603, &kernel_arg_327604,
                                      &kernel_arg_327605, &kernel_arg_327606,
                                      &kernel_arg_327607, &kernel_arg_327608};
                                int64_t time_start_327597 = 0, time_end_327598 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segmap_316181",
                                            (long) segmap_usable_groups_316173,
                                            (long) 1, (long) 1,
                                            (long) segmap_group_sizze_316172,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_327597 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegmap_316181_runs,
                                                              &ctx->mainzisegmap_316181_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_316181,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      segmap_group_sizze_316172,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_327596,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327598 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segmap_316181",
                                            time_end_327598 -
                                            time_start_327597);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx, &mem_320045,
                                                      "mem_320045") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320049,
                                                      "mem_320049") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320053,
                                                      "mem_320053") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320057,
                                                      "mem_320057") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320061,
                                                      "mem_320061") != 0)
                                return 1;
                            
                            int64_t segred_group_sizze_316220;
                            
                            segred_group_sizze_316220 =
                                *ctx->tuning_params.mainzisegred_group_sizze_315552;
                            
                            int64_t num_groups_316221;
                            int32_t max_num_groups_324867;
                            
                            max_num_groups_324867 =
                                *ctx->tuning_params.mainzisegred_num_groups_315554;
                            num_groups_316221 = sext_i64_i32(smax64((int64_t) 1,
                                                                    smin64(sdiv_up64(nest_sizze_316110,
                                                                                     segred_group_sizze_316220),
                                                                           sext_i32_i64(max_num_groups_324867))));
                            
                            struct memblock_device mem_320087;
                            
                            mem_320087.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320087,
                                                      bytes_318772,
                                                      "mem_320087")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mem_320091;
                            
                            mem_320091.references = NULL;
                            if (memblock_alloc_device(ctx, &mem_320091,
                                                      bytes_318772,
                                                      "mem_320091")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (slt64(q_t_292679 * (int64_t) 2,
                                      segred_group_sizze_316220)) {
                                int64_t segment_sizze_nonzzero_324868 =
                                        smax64((int64_t) 1, q_t_292679);
                                int64_t num_threads_324869 = num_groups_316221 *
                                        segred_group_sizze_316220;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-small");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         t_n_m_292839), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_t_292679, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segments_per_group",
                                            (long long) squot64(segred_group_sizze_316220,
                                                                segment_sizze_nonzzero_324868),
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "required_groups",
                                            (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766 *
                                                                               t_n_m_292839,
                                                                               squot64(segred_group_sizze_316220,
                                                                                       segment_sizze_nonzzero_324868))),
                                            '\n');
                                
                                unsigned int shared_sizze_327612 = (int64_t) 8 *
                                             segred_group_sizze_316220;
                                unsigned int shared_sizze_327614 = (int64_t) 8 *
                                             segred_group_sizze_316220;
                                CUdeviceptr kernel_arg_327616 =
                                            ext_mem_318541.mem;
                                CUdeviceptr kernel_arg_327617 =
                                            ext_mem_318542.mem;
                                CUdeviceptr kernel_arg_327618 =
                                            ext_mem_318805.mem;
                                CUdeviceptr kernel_arg_327619 =
                                            ext_mem_318806.mem;
                                CUdeviceptr kernel_arg_327620 = mem_320036.mem;
                                CUdeviceptr kernel_arg_327621 = mem_320040.mem;
                                CUdeviceptr kernel_arg_327622 = mem_320066.mem;
                                CUdeviceptr kernel_arg_327623 = mem_320070.mem;
                                CUdeviceptr kernel_arg_327624 = mem_320074.mem;
                                CUdeviceptr kernel_arg_327625 = mem_320078.mem;
                                CUdeviceptr kernel_arg_327626 = mem_320082.mem;
                                CUdeviceptr kernel_arg_327627 = mem_320087.mem;
                                CUdeviceptr kernel_arg_327628 = mem_320091.mem;
                                unsigned int shared_offset_327613 = 0;
                                unsigned int shared_offset_327615 = 0 +
                                             (shared_sizze_327612 + (8 -
                                                                     shared_sizze_327612 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_316221 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_316220 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_316221;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327609[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327613,
                                          &shared_offset_327615, &n_292675,
                                          &q_t_292679, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &t_n_m_292839, &i_292846,
                                          &num_groups_316221,
                                          &segment_sizze_nonzzero_324868,
                                          &kernel_arg_327616,
                                          &kernel_arg_327617,
                                          &kernel_arg_327618,
                                          &kernel_arg_327619,
                                          &kernel_arg_327620,
                                          &kernel_arg_327621,
                                          &kernel_arg_327622,
                                          &kernel_arg_327623,
                                          &kernel_arg_327624,
                                          &kernel_arg_327625,
                                          &kernel_arg_327626,
                                          &kernel_arg_327627,
                                          &kernel_arg_327628};
                                    int64_t time_start_327610 = 0,
                                            time_end_327611 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_small_316228",
                                                (long) num_groups_316221,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_316220,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327612 +
                                                                            (8 -
                                                                             shared_sizze_327612 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327614 +
                                                                            (8 -
                                                                             shared_sizze_327614 %
                                                                             8) %
                                                                            8)));
                                        time_start_327610 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_small_316228_runs,
                                                                  &ctx->mainzisegred_small_316228_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_316228,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_316220,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327612 +
                                                                           (8 -
                                                                            shared_sizze_327612 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327614 +
                                                                           (8 -
                                                                            shared_sizze_327614 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327609,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327611 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_small_316228",
                                                time_end_327611 -
                                                time_start_327610);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                            } else {
                                int64_t groups_per_segment_324903 =
                                        sdiv_up64(num_groups_316221,
                                                  smax64((int64_t) 1,
                                                         partition_sizze_292766 *
                                                         t_n_m_292839));
                                int64_t elements_per_thread_324904 =
                                        sdiv_up64(q_t_292679,
                                                  segred_group_sizze_316220 *
                                                  groups_per_segment_324903);
                                int64_t virt_num_groups_324905 =
                                        groups_per_segment_324903 *
                                        (partition_sizze_292766 * t_n_m_292839);
                                int64_t num_threads_324906 = num_groups_316221 *
                                        segred_group_sizze_316220;
                                int64_t threads_per_segment_324907 =
                                        groups_per_segment_324903 *
                                        segred_group_sizze_316220;
                                
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n",
                                            "\n# SegRed-large");
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_segments",
                                            (long long) (partition_sizze_292766 *
                                                         t_n_m_292839), '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "segment_size",
                                            (long long) q_t_292679, '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "virt_num_groups",
                                            (long long) virt_num_groups_324905,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "num_groups",
                                            (long long) num_groups_316221,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "group_size",
                                            (long long) segred_group_sizze_316220,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "elems_per_thread",
                                            (long long) elements_per_thread_324904,
                                            '\n');
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s: %llu%c",
                                            "groups_per_segment",
                                            (long long) groups_per_segment_324903,
                                            '\n');
                                
                                struct memblock_device segred_tmp_mem_324908;
                                
                                segred_tmp_mem_324908.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324908,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324905,
                                                          "segred_tmp_mem_324908")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device segred_tmp_mem_324910;
                                
                                segred_tmp_mem_324910.references = NULL;
                                if (memblock_alloc_device(ctx,
                                                          &segred_tmp_mem_324910,
                                                          (int64_t) 8 *
                                                          virt_num_groups_324905,
                                                          "segred_tmp_mem_324910")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                struct memblock_device mainzicounter_mem_324912
                                                       =
                                                       ctx->mainzicounter_mem_324912;
                                unsigned int shared_sizze_327633 = 1;
                                unsigned int shared_sizze_327635 = (int64_t) 8 *
                                             segred_group_sizze_316220;
                                unsigned int shared_sizze_327637 = (int64_t) 8 *
                                             segred_group_sizze_316220;
                                CUdeviceptr kernel_arg_327639 =
                                            ext_mem_318541.mem;
                                CUdeviceptr kernel_arg_327640 =
                                            ext_mem_318542.mem;
                                CUdeviceptr kernel_arg_327641 =
                                            ext_mem_318805.mem;
                                CUdeviceptr kernel_arg_327642 =
                                            ext_mem_318806.mem;
                                CUdeviceptr kernel_arg_327643 = mem_320036.mem;
                                CUdeviceptr kernel_arg_327644 = mem_320040.mem;
                                CUdeviceptr kernel_arg_327645 = mem_320066.mem;
                                CUdeviceptr kernel_arg_327646 = mem_320070.mem;
                                CUdeviceptr kernel_arg_327647 = mem_320074.mem;
                                CUdeviceptr kernel_arg_327648 = mem_320078.mem;
                                CUdeviceptr kernel_arg_327649 = mem_320082.mem;
                                CUdeviceptr kernel_arg_327650 = mem_320087.mem;
                                CUdeviceptr kernel_arg_327651 = mem_320091.mem;
                                CUdeviceptr kernel_arg_327652 =
                                            segred_tmp_mem_324908.mem;
                                CUdeviceptr kernel_arg_327653 =
                                            segred_tmp_mem_324910.mem;
                                CUdeviceptr kernel_arg_327654 =
                                            mainzicounter_mem_324912.mem;
                                unsigned int shared_offset_327634 = 0;
                                unsigned int shared_offset_327636 = 0 +
                                             (shared_sizze_327633 + (8 -
                                                                     shared_sizze_327633 %
                                                                     8) % 8);
                                unsigned int shared_offset_327638 = 0 +
                                             (shared_sizze_327633 + (8 -
                                                                     shared_sizze_327633 %
                                                                     8) % 8) +
                                             (shared_sizze_327635 + (8 -
                                                                     shared_sizze_327635 %
                                                                     8) % 8);
                                
                                if ((((((1 && num_groups_316221 != 0) && 1 !=
                                        0) && 1 != 0) &&
                                      segred_group_sizze_316220 != 0) && 1 !=
                                     0) && 1 != 0) {
                                    int perm[3] = {0, 1, 2};
                                    
                                    if (1 >= 1 << 16) {
                                        perm[1] = perm[0];
                                        perm[0] = 1;
                                    }
                                    if (1 >= 1 << 16) {
                                        perm[2] = perm[0];
                                        perm[0] = 2;
                                    }
                                    
                                    size_t grid[3];
                                    
                                    grid[perm[0]] = num_groups_316221;
                                    grid[perm[1]] = 1;
                                    grid[perm[2]] = 1;
                                    
                                    void *kernel_args_327630[] =
                                         {&ctx->global_failure,
                                          &shared_offset_327634,
                                          &shared_offset_327636,
                                          &shared_offset_327638, &n_292675,
                                          &q_t_292679, &jump_t_292685,
                                          &partition_sizze_292766,
                                          &t_n_m_292839, &i_292846,
                                          &num_groups_316221,
                                          &groups_per_segment_324903,
                                          &elements_per_thread_324904,
                                          &virt_num_groups_324905,
                                          &threads_per_segment_324907,
                                          &kernel_arg_327639,
                                          &kernel_arg_327640,
                                          &kernel_arg_327641,
                                          &kernel_arg_327642,
                                          &kernel_arg_327643,
                                          &kernel_arg_327644,
                                          &kernel_arg_327645,
                                          &kernel_arg_327646,
                                          &kernel_arg_327647,
                                          &kernel_arg_327648,
                                          &kernel_arg_327649,
                                          &kernel_arg_327650,
                                          &kernel_arg_327651,
                                          &kernel_arg_327652,
                                          &kernel_arg_327653,
                                          &kernel_arg_327654};
                                    int64_t time_start_327631 = 0,
                                            time_end_327632 = 0;
                                    
                                    if (ctx->debugging) {
                                        fprintf(ctx->log,
                                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                                "main.segred_large_316228",
                                                (long) num_groups_316221,
                                                (long) 1, (long) 1,
                                                (long) segred_group_sizze_316220,
                                                (long) 1, (long) 1, (int) (0 +
                                                                           (shared_sizze_327633 +
                                                                            (8 -
                                                                             shared_sizze_327633 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327635 +
                                                                            (8 -
                                                                             shared_sizze_327635 %
                                                                             8) %
                                                                            8) +
                                                                           (shared_sizze_327637 +
                                                                            (8 -
                                                                             shared_sizze_327637 %
                                                                             8) %
                                                                            8)));
                                        time_start_327631 = get_wall_time();
                                    }
                                    
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->mainzisegred_large_316228_runs,
                                                                  &ctx->mainzisegred_large_316228_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_316228,
                                                                          grid[0],
                                                                          grid[1],
                                                                          grid[2],
                                                                          segred_group_sizze_316220,
                                                                          1, 1,
                                                                          0 +
                                                                          (shared_sizze_327633 +
                                                                           (8 -
                                                                            shared_sizze_327633 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327635 +
                                                                           (8 -
                                                                            shared_sizze_327635 %
                                                                            8) %
                                                                           8) +
                                                                          (shared_sizze_327637 +
                                                                           (8 -
                                                                            shared_sizze_327637 %
                                                                            8) %
                                                                           8),
                                                                          NULL,
                                                                          kernel_args_327630,
                                                                          NULL));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                    if (ctx->debugging) {
                                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                        time_end_327632 = get_wall_time();
                                        fprintf(ctx->log,
                                                "Kernel %s runtime: %ldus\n",
                                                "main.segred_large_316228",
                                                time_end_327632 -
                                                time_start_327631);
                                    }
                                }
                                if (ctx->debugging)
                                    fprintf(ctx->log, "%s\n", "");
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324910,
                                                          "segred_tmp_mem_324910") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &segred_tmp_mem_324908,
                                                          "segred_tmp_mem_324908") !=
                                    0)
                                    return 1;
                            }
                            if (memblock_unref_device(ctx, &mem_320036,
                                                      "mem_320036") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320040,
                                                      "mem_320040") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320066,
                                                      "mem_320066") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320070,
                                                      "mem_320070") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320074,
                                                      "mem_320074") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320078,
                                                      "mem_320078") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320082,
                                                      "mem_320082") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_320093,
                                                    &mem_320087,
                                                    "mem_320087") != 0)
                                return 1;
                            if (memblock_set_device(ctx, &ext_mem_320092,
                                                    &mem_320091,
                                                    "mem_320091") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320091,
                                                      "mem_320091") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320087,
                                                      "mem_320087") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320082,
                                                      "mem_320082") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320078,
                                                      "mem_320078") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320074,
                                                      "mem_320074") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320070,
                                                      "mem_320070") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320066,
                                                      "mem_320066") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320061,
                                                      "mem_320061") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320057,
                                                      "mem_320057") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320053,
                                                      "mem_320053") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320049,
                                                      "mem_320049") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320045,
                                                      "mem_320045") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320040,
                                                      "mem_320040") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320036,
                                                      "mem_320036") != 0)
                                return 1;
                            if (memblock_unref_device(ctx, &mem_320031,
                                                      "mem_320031") != 0)
                                return 1;
                        }
                        if (memblock_set_device(ctx, &ext_mem_320095,
                                                &ext_mem_320093,
                                                "ext_mem_320093") != 0)
                            return 1;
                        if (memblock_set_device(ctx, &ext_mem_320094,
                                                &ext_mem_320092,
                                                "ext_mem_320092") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320092,
                                                  "ext_mem_320092") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320093,
                                                  "ext_mem_320093") != 0)
                            return 1;
                    }
                    if (memblock_set_device(ctx, &ext_mem_320097,
                                            &ext_mem_320095,
                                            "ext_mem_320095") != 0)
                        return 1;
                    if (memblock_set_device(ctx, &ext_mem_320096,
                                            &ext_mem_320094,
                                            "ext_mem_320094") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320094,
                                              "ext_mem_320094") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320095,
                                              "ext_mem_320095") != 0)
                        return 1;
                }
                if (memblock_set_device(ctx, &ext_mem_320099, &ext_mem_320097,
                                        "ext_mem_320097") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_320098, &ext_mem_320096,
                                        "ext_mem_320096") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320096,
                                          "ext_mem_320096") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320097,
                                          "ext_mem_320097") != 0)
                    return 1;
            }
            
            struct memblock_device ext_mem_320105;
            
            ext_mem_320105.references = NULL;
            if (cond_293286) {
                bool zzero_296959 = jump_t_292685 == (int64_t) 0;
                bool nonzzero_296960 = !zzero_296959;
                bool nonzzero_cert_296961;
                
                if (!nonzzero_296960) {
                    ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                           "division by zero",
                                           "-> #0  loess.fut:742:20-27\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:741:3-745:9\n   #5  stl.fut:310:23-75\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:309:15-311:43\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                    if (memblock_unref_device(ctx, &ext_mem_320105,
                                              "ext_mem_320105") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320098,
                                              "ext_mem_320098") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320099,
                                              "ext_mem_320099") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319770, "mem_319770") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319764,
                                              "ext_mem_319764") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319757,
                                              "ext_mem_319757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319758,
                                              "ext_mem_319758") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319550,
                                              "ext_mem_319550") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319533,
                                              "ext_mem_319533") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319516,
                                              "ext_mem_319516") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319498,
                                              "ext_mem_319498") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319490,
                                              "ext_mem_319490") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319491,
                                              "ext_mem_319491") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t y_296962 = sub64(t_n_m_292839, (int64_t) 1);
                int64_t segmap_group_sizze_316424;
                
                segmap_group_sizze_316424 =
                    *ctx->tuning_params.mainzisegmap_group_sizze_316306;
                
                int64_t segmap_usable_groups_316425 =
                        sdiv_up64(nest_sizze_297748, segmap_group_sizze_316424);
                struct memblock_device mem_320104;
                
                mem_320104.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320104, bytes_318522,
                                          "mem_320104")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_327658 = ext_mem_320098.mem;
                CUdeviceptr kernel_arg_327659 = ext_mem_320099.mem;
                CUdeviceptr kernel_arg_327660 = mem_320104.mem;
                
                if ((((((1 && segmap_usable_groups_316425 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_316424 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_316425;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327655[] = {&ctx->global_failure,
                                                  &ctx->failure_is_an_option,
                                                  &ctx->global_failure_args,
                                                  &n_292675, &jump_t_292685,
                                                  &partition_sizze_292766,
                                                  &t_n_m_292839, &i_292846,
                                                  &y_296962, &kernel_arg_327658,
                                                  &kernel_arg_327659,
                                                  &kernel_arg_327660};
                    int64_t time_start_327656 = 0, time_end_327657 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_316429",
                                (long) segmap_usable_groups_316425, (long) 1,
                                (long) 1, (long) segmap_group_sizze_316424,
                                (long) 1, (long) 1, (int) 0);
                        time_start_327656 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_316429_runs,
                                                  &ctx->mainzisegmap_316429_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_316429,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_316424,
                                                          1, 1, 0, NULL,
                                                          kernel_args_327655,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327657 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_316429", time_end_327657 -
                                time_start_327656);
                    }
                }
                ctx->failure_is_an_option = 1;
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_set_device(ctx, &ext_mem_320105, &mem_320104,
                                        "mem_320104") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320104, "mem_320104") != 0)
                    return 1;
            } else {
                bool dim_match_297015 = n_292675 == t_n_m_292839;
                bool empty_or_match_cert_297016;
                
                if (!dim_match_297015) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Value of (core language) shape (",
                                  (long long) partition_sizze_292766, ", ",
                                  (long long) t_n_m_292839,
                                  ") cannot match shape of type `[",
                                  (long long) partition_sizze_292766, "][",
                                  (long long) n_292675, "]t`.",
                                  "-> #0  stl.fut:313:15-36\n   #1  stl.fut:419:61-435:77\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
                    if (memblock_unref_device(ctx, &ext_mem_320105,
                                              "ext_mem_320105") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320098,
                                              "ext_mem_320098") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320099,
                                              "ext_mem_320099") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319770, "mem_319770") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319764,
                                              "ext_mem_319764") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319757,
                                              "ext_mem_319757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319758,
                                              "ext_mem_319758") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319550,
                                              "ext_mem_319550") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319533,
                                              "ext_mem_319533") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319516,
                                              "ext_mem_319516") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319498,
                                              "ext_mem_319498") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319490,
                                              "ext_mem_319490") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_319491,
                                              "ext_mem_319491") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                if (memblock_set_device(ctx, &ext_mem_320105, &ext_mem_320099,
                                        "ext_mem_320099") != 0)
                    return 1;
            }
            if (memblock_unref_device(ctx, &ext_mem_320098, "ext_mem_320098") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320099, "ext_mem_320099") !=
                0)
                return 1;
            
            int64_t ctx_param_ext_tmp_321617 = ext_320106;
            int64_t ctx_param_ext_tmp_321618 = ext_320106;
            struct memblock_device mem_param_tmp_321619;
            
            mem_param_tmp_321619.references = NULL;
            if (memblock_set_device(ctx, &mem_param_tmp_321619, &mem_319770,
                                    "mem_319770") != 0)
                return 1;
            
            struct memblock_device mem_param_tmp_321620;
            
            mem_param_tmp_321620.references = NULL;
            if (memblock_set_device(ctx, &mem_param_tmp_321620, &ext_mem_320105,
                                    "ext_mem_320105") != 0)
                return 1;
            ctx_param_ext_318854 = ctx_param_ext_tmp_321617;
            ctx_param_ext_318856 = ctx_param_ext_tmp_321618;
            if (memblock_set_device(ctx, &mem_param_318852,
                                    &mem_param_tmp_321619,
                                    "mem_param_tmp_321619") != 0)
                return 1;
            if (memblock_set_device(ctx, &mem_param_318860,
                                    &mem_param_tmp_321620,
                                    "mem_param_tmp_321620") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_param_tmp_321620,
                                      "mem_param_tmp_321620") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_param_tmp_321619,
                                      "mem_param_tmp_321619") != 0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320105, "ext_mem_320105") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320098, "ext_mem_320098") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320099, "ext_mem_320099") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_319770, "mem_319770") != 0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_319764, "ext_mem_319764") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_319757, "ext_mem_319757") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_319758, "ext_mem_319758") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_319550, "ext_mem_319550") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_319533, "ext_mem_319533") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_319516, "ext_mem_319516") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_319498, "ext_mem_319498") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_319490, "ext_mem_319490") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_319491, "ext_mem_319491") !=
                0)
                return 1;
        }
        ext_320118 = ctx_param_ext_318854;
        ext_320116 = ctx_param_ext_318856;
        if (memblock_set_device(ctx, &ext_mem_320112, &mem_param_318852,
                                "mem_param_318852") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_320111, &mem_param_318860,
                                "mem_param_318860") != 0)
            return 1;
        
        bool cond_297018 = slt64(i_outer_293375, y_293287);
        int64_t ext_320429;
        
        if (cond_297018) {
            ext_320429 = partition_sizze_292766;
        } else {
            ext_320429 = ctx_param_ext_318835;
        }
        
        int64_t ext_320428;
        
        if (cond_297018) {
            ext_320428 = n_292675;
        } else {
            ext_320428 = ctx_param_ext_318837;
        }
        
        int64_t ext_320427;
        
        if (cond_297018) {
            ext_320427 = partition_sizze_292766;
        } else {
            ext_320427 = ctx_param_ext_318831;
        }
        
        int64_t ext_320426;
        
        if (cond_297018) {
            ext_320426 = n_292675;
        } else {
            ext_320426 = ctx_param_ext_318832;
        }
        
        int64_t ext_320425;
        
        if (cond_297018) {
            ext_320425 = n_292675;
        } else {
            ext_320425 = ctx_param_ext_318834;
        }
        
        int64_t ext_320424;
        
        if (cond_297018) {
            ext_320424 = (int64_t) 1;
        } else {
            ext_320424 = ctx_param_ext_318836;
        }
        
        int64_t ext_320423;
        
        if (cond_297018) {
            ext_320423 = (int64_t) 0;
        } else {
            ext_320423 = ctx_param_ext_318833;
        }
        
        struct memblock_device ext_mem_320422;
        
        ext_mem_320422.references = NULL;
        if (cond_297018) {
            int64_t segmap_usable_groups_316646 =
                    sdiv_up_safe64(nest_sizze_297748,
                                   segmap_group_sizze_316645);
            int64_t segmap_usable_groups_316668 =
                    sdiv_up_safe64(nest_sizze_297748,
                                   segmap_group_sizze_316667);
            struct memblock_device ext_mem_320155;
            
            ext_mem_320155.references = NULL;
            
            struct memblock_device ext_mem_320154;
            
            ext_mem_320154.references = NULL;
            
            int32_t local_memory_capacity_324997;
            
            local_memory_capacity_324997 = ctx->cuda.max_shared_memory;
            if (sle64(bytes_318514 + srem64((int64_t) 8 - srem64(bytes_318514,
                                                                 (int64_t) 8),
                                            (int64_t) 8) + (bytes_318514 +
                                                            srem64((int64_t) 8 -
                                                                   srem64(bytes_318514,
                                                                          (int64_t) 8),
                                                                   (int64_t) 8)),
                      sext_i32_i64(local_memory_capacity_324997)) &&
                intra_suff_and_fits_316516) {
                struct memblock_device mem_320139;
                
                mem_320139.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320139, bytes_318522,
                                          "mem_320139")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device mem_320143;
                
                mem_320143.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320143, bytes_318522,
                                          "mem_320143")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                int32_t num_chunks_324964 = sext_i64_i32(sdiv_up64(n_292675,
                                                                   n_292675));
                unsigned int shared_sizze_327664 = bytes_318514;
                unsigned int shared_sizze_327666 = bytes_318514;
                CUdeviceptr kernel_arg_327668 = mem_318506.mem;
                CUdeviceptr kernel_arg_327669 = ext_mem_318542.mem;
                CUdeviceptr kernel_arg_327670 = ext_mem_320111.mem;
                CUdeviceptr kernel_arg_327671 = ext_mem_320112.mem;
                CUdeviceptr kernel_arg_327672 = mem_320139.mem;
                CUdeviceptr kernel_arg_327673 = mem_320143.mem;
                unsigned int shared_offset_327665 = 0;
                unsigned int shared_offset_327667 = 0 + (shared_sizze_327664 +
                                                         (8 -
                                                          shared_sizze_327664 %
                                                          8) % 8);
                
                if ((((((1 && partition_sizze_292766 != 0) && 1 != 0) && 1 !=
                       0) && n_292675 != 0) && 1 != 0) && 1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = partition_sizze_292766;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327661[] = {&ctx->global_failure,
                                                  &ctx->failure_is_an_option,
                                                  &ctx->global_failure_args,
                                                  &shared_offset_327665,
                                                  &shared_offset_327667,
                                                  &n_292675,
                                                  &partition_sizze_292766,
                                                  &ext_320116,
                                                  &kernel_arg_327668,
                                                  &kernel_arg_327669,
                                                  &kernel_arg_327670,
                                                  &kernel_arg_327671,
                                                  &kernel_arg_327672,
                                                  &kernel_arg_327673};
                    int64_t time_start_327662 = 0, time_end_327663 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_intragroup_316520",
                                (long) partition_sizze_292766, (long) 1,
                                (long) 1, (long) n_292675, (long) 1, (long) 1,
                                (int) (0 + (shared_sizze_327664 + (8 -
                                                                   shared_sizze_327664 %
                                                                   8) % 8) +
                                       (shared_sizze_327666 + (8 -
                                                               shared_sizze_327666 %
                                                               8) % 8)));
                        time_start_327662 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_intragroup_316520_runs,
                                                  &ctx->mainzisegmap_intragroup_316520_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_316520,
                                                          grid[0], grid[1],
                                                          grid[2], n_292675, 1,
                                                          1, 0 +
                                                          (shared_sizze_327664 +
                                                           (8 -
                                                            shared_sizze_327664 %
                                                            8) % 8) +
                                                          (shared_sizze_327666 +
                                                           (8 -
                                                            shared_sizze_327666 %
                                                            8) % 8), NULL,
                                                          kernel_args_327661,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327663 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_intragroup_316520",
                                time_end_327663 - time_start_327662);
                    }
                }
                ctx->failure_is_an_option = 1;
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_set_device(ctx, &ext_mem_320155, &mem_320139,
                                        "mem_320139") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_320154, &mem_320143,
                                        "mem_320143") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320143, "mem_320143") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320139, "mem_320139") != 0)
                    return 1;
            } else {
                struct memblock_device mem_320148;
                
                mem_320148.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320148, bytes_318522,
                                          "mem_320148")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_327677 = mem_318506.mem;
                CUdeviceptr kernel_arg_327678 = ext_mem_320111.mem;
                CUdeviceptr kernel_arg_327679 = ext_mem_320112.mem;
                CUdeviceptr kernel_arg_327680 = mem_320148.mem;
                
                if ((((((1 && segmap_usable_groups_316646 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_316645 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_316646;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327674[] = {&ctx->global_failure,
                                                  &n_292675,
                                                  &partition_sizze_292766,
                                                  &ext_320116,
                                                  &kernel_arg_327677,
                                                  &kernel_arg_327678,
                                                  &kernel_arg_327679,
                                                  &kernel_arg_327680};
                    int64_t time_start_327675 = 0, time_end_327676 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_316650",
                                (long) segmap_usable_groups_316646, (long) 1,
                                (long) 1, (long) segmap_group_sizze_316645,
                                (long) 1, (long) 1, (int) 0);
                        time_start_327675 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_316650_runs,
                                                  &ctx->mainzisegmap_316650_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_316650,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_316645,
                                                          1, 1, 0, NULL,
                                                          kernel_args_327674,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327676 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_316650", time_end_327676 -
                                time_start_327675);
                    }
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                
                struct memblock_device mem_320153;
                
                mem_320153.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320153, bytes_318522,
                                          "mem_320153")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_327684 = ext_mem_318542.mem;
                CUdeviceptr kernel_arg_327685 = mem_320148.mem;
                CUdeviceptr kernel_arg_327686 = mem_320153.mem;
                
                if ((((((1 && segmap_usable_groups_316668 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_316667 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_316668;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327681[] = {&ctx->global_failure,
                                                  &ctx->failure_is_an_option,
                                                  &ctx->global_failure_args,
                                                  &n_292675,
                                                  &partition_sizze_292766,
                                                  &kernel_arg_327684,
                                                  &kernel_arg_327685,
                                                  &kernel_arg_327686};
                    int64_t time_start_327682 = 0, time_end_327683 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_316672",
                                (long) segmap_usable_groups_316668, (long) 1,
                                (long) 1, (long) segmap_group_sizze_316667,
                                (long) 1, (long) 1, (int) 0);
                        time_start_327682 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_316672_runs,
                                                  &ctx->mainzisegmap_316672_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_316672,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_316667,
                                                          1, 1, 0, NULL,
                                                          kernel_args_327681,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327683 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_316672", time_end_327683 -
                                time_start_327682);
                    }
                }
                ctx->failure_is_an_option = 1;
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_set_device(ctx, &ext_mem_320155, &mem_320153,
                                        "mem_320153") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_320154, &mem_320148,
                                        "mem_320148") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320153, "mem_320153") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320148, "mem_320148") != 0)
                    return 1;
            }
            
            int64_t segmap_usable_groups_316708 =
                    sdiv_up_safe64(partition_sizze_292766,
                                   segmap_group_sizze_316707);
            int64_t segmap_usable_groups_316779 =
                    sdiv_up_safe64(partition_sizze_292766,
                                   segmap_group_sizze_316778);
            struct memblock_device ext_mem_320174;
            
            ext_mem_320174.references = NULL;
            
            int32_t local_memory_capacity_325098;
            
            local_memory_capacity_325098 = ctx->cuda.max_shared_memory;
            if (sle64((int64_t) 0,
                      sext_i32_i64(local_memory_capacity_325098)) &&
                suff_outer_par_316685) {
                struct memblock_device mem_320158;
                
                mem_320158.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320158, binop_y_318521,
                                          "mem_320158")) {
                    err = 1;
                    goto cleanup;
                }
                if (futrts_builtinzhgpu_map_transpose_f64(ctx, mem_320158,
                                                          (int64_t) 0,
                                                          ext_mem_320155,
                                                          (int64_t) 0,
                                                          (int64_t) 1, n_292675,
                                                          partition_sizze_292766) !=
                    0) {
                    if (memblock_unref_device(ctx, &mem_320158, "mem_320158") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320174,
                                              "ext_mem_320174") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320154,
                                              "ext_mem_320154") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320155,
                                              "ext_mem_320155") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320422,
                                              "ext_mem_320422") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device mem_320162;
                
                mem_320162.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320162, bytes_318525,
                                          "mem_320162")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_327690 = mem_320158.mem;
                CUdeviceptr kernel_arg_327691 = mem_320162.mem;
                
                if ((((((1 && segmap_usable_groups_316708 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_316707 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_316708;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327687[] = {&ctx->global_failure,
                                                  &n_292675,
                                                  &partition_sizze_292766,
                                                  &kernel_arg_327690,
                                                  &kernel_arg_327691};
                    int64_t time_start_327688 = 0, time_end_327689 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_316711",
                                (long) segmap_usable_groups_316708, (long) 1,
                                (long) 1, (long) segmap_group_sizze_316707,
                                (long) 1, (long) 1, (int) 0);
                        time_start_327688 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_316711_runs,
                                                  &ctx->mainzisegmap_316711_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_316711,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_316707,
                                                          1, 1, 0, NULL,
                                                          kernel_args_327687,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327689 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_316711", time_end_327689 -
                                time_start_327688);
                    }
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_unref_device(ctx, &mem_320158, "mem_320158") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_320174, &mem_320162,
                                        "mem_320162") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320162, "mem_320162") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320158, "mem_320158") != 0)
                    return 1;
            } else {
                struct memblock_device mem_320166;
                
                mem_320166.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320166, bytes_318525,
                                          "mem_320166")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device mem_320169;
                
                mem_320169.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320169, bytes_318525,
                                          "mem_320169")) {
                    err = 1;
                    goto cleanup;
                }
                if (slt64(n_292675 * (int64_t) 2, segred_group_sizze_316761)) {
                    int64_t segment_sizze_nonzzero_325008 = smax64((int64_t) 1,
                                                                   n_292675);
                    int64_t num_threads_325009 = num_groups_316762 *
                            segred_group_sizze_316761;
                    
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegRed-small");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                (long long) partition_sizze_292766, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                (long long) n_292675, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segments_per_group",
                                (long long) squot64(segred_group_sizze_316761,
                                                    segment_sizze_nonzzero_325008),
                                '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "required_groups",
                                (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766,
                                                                   squot64(segred_group_sizze_316761,
                                                                           segment_sizze_nonzzero_325008))),
                                '\n');
                    
                    unsigned int shared_sizze_327695 = (int64_t) 8 *
                                 segred_group_sizze_316761;
                    unsigned int shared_sizze_327697 = (int64_t) 8 *
                                 segred_group_sizze_316761;
                    CUdeviceptr kernel_arg_327699 = ext_mem_320155.mem;
                    CUdeviceptr kernel_arg_327700 = mem_320166.mem;
                    CUdeviceptr kernel_arg_327701 = mem_320169.mem;
                    unsigned int shared_offset_327696 = 0;
                    unsigned int shared_offset_327698 = 0 +
                                 (shared_sizze_327695 + (8 -
                                                         shared_sizze_327695 %
                                                         8) % 8);
                    
                    if ((((((1 && num_groups_316762 != 0) && 1 != 0) && 1 !=
                           0) && segred_group_sizze_316761 != 0) && 1 != 0) &&
                        1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = num_groups_316762;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_327692[] = {&ctx->global_failure,
                                                      &shared_offset_327696,
                                                      &shared_offset_327698,
                                                      &n_292675,
                                                      &partition_sizze_292766,
                                                      &num_groups_316762,
                                                      &segment_sizze_nonzzero_325008,
                                                      &kernel_arg_327699,
                                                      &kernel_arg_327700,
                                                      &kernel_arg_327701};
                        int64_t time_start_327693 = 0, time_end_327694 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segred_small_316768",
                                    (long) num_groups_316762, (long) 1,
                                    (long) 1, (long) segred_group_sizze_316761,
                                    (long) 1, (long) 1, (int) (0 +
                                                               (shared_sizze_327695 +
                                                                (8 -
                                                                 shared_sizze_327695 %
                                                                 8) % 8) +
                                                               (shared_sizze_327697 +
                                                                (8 -
                                                                 shared_sizze_327697 %
                                                                 8) % 8)));
                            time_start_327693 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegred_small_316768_runs,
                                                      &ctx->mainzisegred_small_316768_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_316768,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segred_group_sizze_316761,
                                                              1, 1, 0 +
                                                              (shared_sizze_327695 +
                                                               (8 -
                                                                shared_sizze_327695 %
                                                                8) % 8) +
                                                              (shared_sizze_327697 +
                                                               (8 -
                                                                shared_sizze_327697 %
                                                                8) % 8), NULL,
                                                              kernel_args_327692,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_327694 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segred_small_316768",
                                    time_end_327694 - time_start_327693);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                } else {
                    int64_t groups_per_segment_325041 =
                            sdiv_up64(num_groups_316762, smax64((int64_t) 1,
                                                                partition_sizze_292766));
                    int64_t elements_per_thread_325042 = sdiv_up64(n_292675,
                                                                   segred_group_sizze_316761 *
                                                                   groups_per_segment_325041);
                    int64_t virt_num_groups_325043 = groups_per_segment_325041 *
                            partition_sizze_292766;
                    int64_t num_threads_325044 = num_groups_316762 *
                            segred_group_sizze_316761;
                    int64_t threads_per_segment_325045 =
                            groups_per_segment_325041 *
                            segred_group_sizze_316761;
                    
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegRed-large");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                (long long) partition_sizze_292766, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                (long long) n_292675, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "virt_num_groups",
                                (long long) virt_num_groups_325043, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_groups",
                                (long long) num_groups_316762, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "group_size",
                                (long long) segred_group_sizze_316761, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "elems_per_thread",
                                (long long) elements_per_thread_325042, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "groups_per_segment",
                                (long long) groups_per_segment_325041, '\n');
                    
                    struct memblock_device segred_tmp_mem_325046;
                    
                    segred_tmp_mem_325046.references = NULL;
                    if (memblock_alloc_device(ctx, &segred_tmp_mem_325046,
                                              (int64_t) 8 *
                                              virt_num_groups_325043,
                                              "segred_tmp_mem_325046")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device segred_tmp_mem_325048;
                    
                    segred_tmp_mem_325048.references = NULL;
                    if (memblock_alloc_device(ctx, &segred_tmp_mem_325048,
                                              (int64_t) 8 *
                                              virt_num_groups_325043,
                                              "segred_tmp_mem_325048")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device mainzicounter_mem_325050 =
                                           ctx->mainzicounter_mem_325050;
                    unsigned int shared_sizze_327706 = 1;
                    unsigned int shared_sizze_327708 = (int64_t) 8 *
                                 segred_group_sizze_316761;
                    unsigned int shared_sizze_327710 = (int64_t) 8 *
                                 segred_group_sizze_316761;
                    CUdeviceptr kernel_arg_327712 = ext_mem_320155.mem;
                    CUdeviceptr kernel_arg_327713 = mem_320166.mem;
                    CUdeviceptr kernel_arg_327714 = mem_320169.mem;
                    CUdeviceptr kernel_arg_327715 = segred_tmp_mem_325046.mem;
                    CUdeviceptr kernel_arg_327716 = segred_tmp_mem_325048.mem;
                    CUdeviceptr kernel_arg_327717 =
                                mainzicounter_mem_325050.mem;
                    unsigned int shared_offset_327707 = 0;
                    unsigned int shared_offset_327709 = 0 +
                                 (shared_sizze_327706 + (8 -
                                                         shared_sizze_327706 %
                                                         8) % 8);
                    unsigned int shared_offset_327711 = 0 +
                                 (shared_sizze_327706 + (8 -
                                                         shared_sizze_327706 %
                                                         8) % 8) +
                                 (shared_sizze_327708 + (8 -
                                                         shared_sizze_327708 %
                                                         8) % 8);
                    
                    if ((((((1 && num_groups_316762 != 0) && 1 != 0) && 1 !=
                           0) && segred_group_sizze_316761 != 0) && 1 != 0) &&
                        1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = num_groups_316762;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_327703[] = {&ctx->global_failure,
                                                      &shared_offset_327707,
                                                      &shared_offset_327709,
                                                      &shared_offset_327711,
                                                      &n_292675,
                                                      &partition_sizze_292766,
                                                      &num_groups_316762,
                                                      &groups_per_segment_325041,
                                                      &elements_per_thread_325042,
                                                      &virt_num_groups_325043,
                                                      &threads_per_segment_325045,
                                                      &kernel_arg_327712,
                                                      &kernel_arg_327713,
                                                      &kernel_arg_327714,
                                                      &kernel_arg_327715,
                                                      &kernel_arg_327716,
                                                      &kernel_arg_327717};
                        int64_t time_start_327704 = 0, time_end_327705 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segred_large_316768",
                                    (long) num_groups_316762, (long) 1,
                                    (long) 1, (long) segred_group_sizze_316761,
                                    (long) 1, (long) 1, (int) (0 +
                                                               (shared_sizze_327706 +
                                                                (8 -
                                                                 shared_sizze_327706 %
                                                                 8) % 8) +
                                                               (shared_sizze_327708 +
                                                                (8 -
                                                                 shared_sizze_327708 %
                                                                 8) % 8) +
                                                               (shared_sizze_327710 +
                                                                (8 -
                                                                 shared_sizze_327710 %
                                                                 8) % 8)));
                            time_start_327704 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegred_large_316768_runs,
                                                      &ctx->mainzisegred_large_316768_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_316768,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segred_group_sizze_316761,
                                                              1, 1, 0 +
                                                              (shared_sizze_327706 +
                                                               (8 -
                                                                shared_sizze_327706 %
                                                                8) % 8) +
                                                              (shared_sizze_327708 +
                                                               (8 -
                                                                shared_sizze_327708 %
                                                                8) % 8) +
                                                              (shared_sizze_327710 +
                                                               (8 -
                                                                shared_sizze_327710 %
                                                                8) % 8), NULL,
                                                              kernel_args_327703,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_327705 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segred_large_316768",
                                    time_end_327705 - time_start_327704);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                    if (memblock_unref_device(ctx, &segred_tmp_mem_325048,
                                              "segred_tmp_mem_325048") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &segred_tmp_mem_325046,
                                              "segred_tmp_mem_325046") != 0)
                        return 1;
                }
                
                struct memblock_device mem_320173;
                
                mem_320173.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320173, bytes_318525,
                                          "mem_320173")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_327721 = mem_320166.mem;
                CUdeviceptr kernel_arg_327722 = mem_320169.mem;
                CUdeviceptr kernel_arg_327723 = mem_320173.mem;
                
                if ((((((1 && segmap_usable_groups_316779 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_316778 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_316779;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327718[] = {&ctx->global_failure,
                                                  &partition_sizze_292766,
                                                  &kernel_arg_327721,
                                                  &kernel_arg_327722,
                                                  &kernel_arg_327723};
                    int64_t time_start_327719 = 0, time_end_327720 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_316782",
                                (long) segmap_usable_groups_316779, (long) 1,
                                (long) 1, (long) segmap_group_sizze_316778,
                                (long) 1, (long) 1, (int) 0);
                        time_start_327719 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_316782_runs,
                                                  &ctx->mainzisegmap_316782_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_316782,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_316778,
                                                          1, 1, 0, NULL,
                                                          kernel_args_327718,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327720 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_316782", time_end_327720 -
                                time_start_327719);
                    }
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_unref_device(ctx, &mem_320166, "mem_320166") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320169, "mem_320169") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_320174, &mem_320173,
                                        "mem_320173") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320173, "mem_320173") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320169, "mem_320169") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320166, "mem_320166") != 0)
                    return 1;
            }
            
            struct memblock_device mem_320177;
            
            mem_320177.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320177, bytes_320176,
                                      "mem_320177")) {
                err = 1;
                goto cleanup;
            }
            if (futrts_builtinzhreplicate_i32(ctx, mem_320177,
                                              partition_sizze_292766,
                                              i64_res_297059) != 0) {
                if (memblock_unref_device(ctx, &mem_320177, "mem_320177") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320174,
                                          "ext_mem_320174") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320154,
                                          "ext_mem_320154") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320155,
                                          "ext_mem_320155") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320422,
                                          "ext_mem_320422") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318860,
                                          "mem_param_318860") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318852,
                                          "mem_param_318852") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320111,
                                          "ext_mem_320111") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320112,
                                          "ext_mem_320112") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318838,
                                          "mem_param_318838") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318830,
                                          "mem_param_318830") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318822,
                                          "mem_param_318822") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320430,
                                          "ext_mem_320430") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320431,
                                          "ext_mem_320431") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320432,
                                          "ext_mem_320432") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319555, "mem_319555") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319538, "mem_319538") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319521, "mem_319521") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319504, "mem_319504") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318876, "mem_318876") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318871, "mem_318871") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318865, "mem_318865") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318805,
                                          "ext_mem_318805") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318806,
                                          "ext_mem_318806") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318756,
                                          "ext_mem_318756") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318757,
                                          "ext_mem_318757") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318707,
                                          "ext_mem_318707") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318708,
                                          "ext_mem_318708") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318609,
                                          "ext_mem_318609") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318610,
                                          "ext_mem_318610") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318541,
                                          "ext_mem_318541") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318542,
                                          "ext_mem_318542") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320825,
                                          "mem_out_320825") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320824,
                                          "mem_out_320824") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320823,
                                          "mem_out_320823") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t segmap_usable_groups_316836 =
                    sdiv_up64(partition_sizze_292766,
                              segmap_group_sizze_316835);
            struct memblock_device mem_320181;
            
            mem_320181.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320181, bytes_320176,
                                      "mem_320181")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_320184;
            
            mem_320184.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320184, bytes_318525,
                                      "mem_320184")) {
                err = 1;
                goto cleanup;
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            CUdeviceptr kernel_arg_327727 = ext_mem_318541.mem;
            CUdeviceptr kernel_arg_327728 = mem_320181.mem;
            CUdeviceptr kernel_arg_327729 = mem_320184.mem;
            
            if ((((((1 && segmap_usable_groups_316836 != 0) && 1 != 0) && 1 !=
                   0) && segmap_group_sizze_316835 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = segmap_usable_groups_316836;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_327724[] = {&ctx->global_failure,
                                              &partition_sizze_292766,
                                              &kernel_arg_327727,
                                              &kernel_arg_327728,
                                              &kernel_arg_327729};
                int64_t time_start_327725 = 0, time_end_327726 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_316840",
                            (long) segmap_usable_groups_316836, (long) 1,
                            (long) 1, (long) segmap_group_sizze_316835,
                            (long) 1, (long) 1, (int) 0);
                    time_start_327725 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_316840_runs,
                                              &ctx->mainzisegmap_316840_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_316840,
                                                      grid[0], grid[1], grid[2],
                                                      segmap_group_sizze_316835,
                                                      1, 1, 0, NULL,
                                                      kernel_args_327724,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_327726 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_316840", time_end_327726 -
                            time_start_327725);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            if (memblock_unref_device(ctx, &mem_320181, "mem_320181") != 0)
                return 1;
            
            int64_t segmap_usable_groups_316853 = sdiv_up64(nest_sizze_297748,
                                                            segmap_group_sizze_316852);
            struct memblock_device mem_320189;
            
            mem_320189.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320189, bytes_320188,
                                      "mem_320189")) {
                err = 1;
                goto cleanup;
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            CUdeviceptr kernel_arg_327733 = mem_320189.mem;
            
            if ((((((1 && segmap_usable_groups_316853 != 0) && 1 != 0) && 1 !=
                   0) && segmap_group_sizze_316852 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = segmap_usable_groups_316853;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_327730[] = {&ctx->global_failure, &n_292675,
                                              &partition_sizze_292766,
                                              &kernel_arg_327733};
                int64_t time_start_327731 = 0, time_end_327732 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_316857",
                            (long) segmap_usable_groups_316853, (long) 1,
                            (long) 1, (long) segmap_group_sizze_316852,
                            (long) 1, (long) 1, (int) 0);
                    time_start_327731 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_316857_runs,
                                              &ctx->mainzisegmap_316857_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_316857,
                                                      grid[0], grid[1], grid[2],
                                                      segmap_group_sizze_316852,
                                                      1, 1, 0, NULL,
                                                      kernel_args_327730,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_327732 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_316857", time_end_327732 -
                            time_start_327731);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            
            struct memblock_device mem_320192;
            
            mem_320192.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320192, bytes_318522,
                                      "mem_320192")) {
                err = 1;
                goto cleanup;
            }
            {
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->copy_dev_to_dev_runs,
                                              &ctx->copy_dev_to_dev_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuMemcpy(mem_320192.mem + (int64_t) 0,
                                                ext_mem_320155.mem +
                                                (int64_t) 0, nest_sizze_297748 *
                                                (int64_t) 8));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            }
            
            int64_t segmap_usable_groups_316873 =
                    sdiv_up64(partition_sizze_292766,
                              segmap_group_sizze_316872);
            struct memblock_device mem_320196;
            
            mem_320196.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320196, bytes_320176,
                                      "mem_320196")) {
                err = 1;
                goto cleanup;
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            CUdeviceptr kernel_arg_327737 = mem_320184.mem;
            CUdeviceptr kernel_arg_327738 = mem_320196.mem;
            
            if ((((((1 && segmap_usable_groups_316873 != 0) && 1 != 0) && 1 !=
                   0) && segmap_group_sizze_316872 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = segmap_usable_groups_316873;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_327734[] = {&ctx->global_failure,
                                              &partition_sizze_292766,
                                              &kernel_arg_327737,
                                              &kernel_arg_327738};
                int64_t time_start_327735 = 0, time_end_327736 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_316876",
                            (long) segmap_usable_groups_316873, (long) 1,
                            (long) 1, (long) segmap_group_sizze_316872,
                            (long) 1, (long) 1, (int) 0);
                    time_start_327735 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_316876_runs,
                                              &ctx->mainzisegmap_316876_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_316876,
                                                      grid[0], grid[1], grid[2],
                                                      segmap_group_sizze_316872,
                                                      1, 1, 0, NULL,
                                                      kernel_args_327734,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_327736 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_316876", time_end_327736 -
                            time_start_327735);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            
            struct memblock_device mem_320199;
            
            mem_320199.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320199, bytes_320188,
                                      "mem_320199")) {
                err = 1;
                goto cleanup;
            }
            if (futrts_builtinzhreplicate_i32(ctx, mem_320199,
                                              nest_sizze_297748, 0) != 0) {
                if (memblock_unref_device(ctx, &mem_320199, "mem_320199") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320196, "mem_320196") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320192, "mem_320192") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320189, "mem_320189") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320184, "mem_320184") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320181, "mem_320181") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320177, "mem_320177") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320174,
                                          "ext_mem_320174") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320154,
                                          "ext_mem_320154") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320155,
                                          "ext_mem_320155") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320422,
                                          "ext_mem_320422") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318860,
                                          "mem_param_318860") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318852,
                                          "mem_param_318852") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320111,
                                          "ext_mem_320111") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320112,
                                          "ext_mem_320112") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318838,
                                          "mem_param_318838") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318830,
                                          "mem_param_318830") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318822,
                                          "mem_param_318822") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320430,
                                          "ext_mem_320430") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320431,
                                          "ext_mem_320431") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320432,
                                          "ext_mem_320432") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319555, "mem_319555") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319538, "mem_319538") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319521, "mem_319521") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319504, "mem_319504") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318876, "mem_318876") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318871, "mem_318871") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318865, "mem_318865") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318805,
                                          "ext_mem_318805") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318806,
                                          "ext_mem_318806") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318756,
                                          "ext_mem_318756") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318757,
                                          "ext_mem_318757") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318707,
                                          "ext_mem_318707") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318708,
                                          "ext_mem_318708") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318609,
                                          "ext_mem_318609") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318610,
                                          "ext_mem_318610") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318541,
                                          "ext_mem_318541") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318542,
                                          "ext_mem_318542") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320825,
                                          "mem_out_320825") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320824,
                                          "mem_out_320824") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320823,
                                          "mem_out_320823") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_320202;
            
            mem_320202.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320202, bytes_318522,
                                      "mem_320202")) {
                err = 1;
                goto cleanup;
            }
            if (futrts_builtinzhreplicate_f64(ctx, mem_320202,
                                              nest_sizze_297748, 0.0) != 0) {
                if (memblock_unref_device(ctx, &mem_320202, "mem_320202") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320199, "mem_320199") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320196, "mem_320196") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320192, "mem_320192") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320189, "mem_320189") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320184, "mem_320184") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320181, "mem_320181") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320177, "mem_320177") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320174,
                                          "ext_mem_320174") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320154,
                                          "ext_mem_320154") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320155,
                                          "ext_mem_320155") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320422,
                                          "ext_mem_320422") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318860,
                                          "mem_param_318860") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318852,
                                          "mem_param_318852") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320111,
                                          "ext_mem_320111") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320112,
                                          "ext_mem_320112") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318838,
                                          "mem_param_318838") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318830,
                                          "mem_param_318830") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318822,
                                          "mem_param_318822") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320430,
                                          "ext_mem_320430") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320431,
                                          "ext_mem_320431") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320432,
                                          "ext_mem_320432") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319555, "mem_319555") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319538, "mem_319538") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319521, "mem_319521") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319504, "mem_319504") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318876, "mem_318876") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318871, "mem_318871") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318865, "mem_318865") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318805,
                                          "ext_mem_318805") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318806,
                                          "ext_mem_318806") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318756,
                                          "ext_mem_318756") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318757,
                                          "ext_mem_318757") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318707,
                                          "ext_mem_318707") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318708,
                                          "ext_mem_318708") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318609,
                                          "ext_mem_318609") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318610,
                                          "ext_mem_318610") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318541,
                                          "ext_mem_318541") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318542,
                                          "ext_mem_318542") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320825,
                                          "mem_out_320825") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320824,
                                          "mem_out_320824") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320823,
                                          "mem_out_320823") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_320205;
            
            mem_320205.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320205, bytes_318525,
                                      "mem_320205")) {
                err = 1;
                goto cleanup;
            }
            if (futrts_builtinzhreplicate_f64(ctx, mem_320205,
                                              partition_sizze_292766, 0.0) !=
                0) {
                if (memblock_unref_device(ctx, &mem_320205, "mem_320205") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320202, "mem_320202") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320199, "mem_320199") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320196, "mem_320196") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320192, "mem_320192") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320189, "mem_320189") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320184, "mem_320184") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320181, "mem_320181") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320177, "mem_320177") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320174,
                                          "ext_mem_320174") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320154,
                                          "ext_mem_320154") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320155,
                                          "ext_mem_320155") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320422,
                                          "ext_mem_320422") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318860,
                                          "mem_param_318860") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318852,
                                          "mem_param_318852") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320111,
                                          "ext_mem_320111") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320112,
                                          "ext_mem_320112") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318838,
                                          "mem_param_318838") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318830,
                                          "mem_param_318830") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_318822,
                                          "mem_param_318822") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320430,
                                          "ext_mem_320430") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320431,
                                          "ext_mem_320431") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_320432,
                                          "ext_mem_320432") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319555, "mem_319555") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319538, "mem_319538") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319521, "mem_319521") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_319504, "mem_319504") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318876, "mem_318876") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318871, "mem_318871") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318865, "mem_318865") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318805,
                                          "ext_mem_318805") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318806,
                                          "ext_mem_318806") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318756,
                                          "ext_mem_318756") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318757,
                                          "ext_mem_318757") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318707,
                                          "ext_mem_318707") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318708,
                                          "ext_mem_318708") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318609,
                                          "ext_mem_318609") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318610,
                                          "ext_mem_318610") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318541,
                                          "ext_mem_318541") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &ext_mem_318542,
                                          "ext_mem_318542") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320825,
                                          "mem_out_320825") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320824,
                                          "mem_out_320824") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_out_320823,
                                          "mem_out_320823") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_320218;
            
            mem_320218.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320218, bytes_320188,
                                      "mem_320218")) {
                err = 1;
                goto cleanup;
            }
            {
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->copy_dev_to_dev_runs,
                                              &ctx->copy_dev_to_dev_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuMemcpy(mem_320218.mem + (int64_t) 0,
                                                mem_320189.mem + (int64_t) 0,
                                                nest_sizze_297748 *
                                                (int64_t) 4));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            }
            if (memblock_unref_device(ctx, &mem_320189, "mem_320189") != 0)
                return 1;
            
            struct memblock_device mem_320262;
            
            mem_320262.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320262, bytes_320176,
                                      "mem_320262")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_320266;
            
            mem_320266.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320266, bytes_318525,
                                      "mem_320266")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_320269;
            
            mem_320269.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320269, bytes_320268,
                                      "mem_320269")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_320274;
            
            mem_320274.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320274, bytes_320176,
                                      "mem_320274")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_320276;
            
            mem_320276.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320276, bytes_320275,
                                      "mem_320276")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device mem_320279;
            
            mem_320279.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320279, bytes_320176,
                                      "mem_320279")) {
                err = 1;
                goto cleanup;
            }
            
            int64_t ext_320325;
            int64_t ext_320324;
            int64_t ext_320323;
            int64_t ext_320322;
            int64_t ext_320321;
            int64_t ext_320320;
            int64_t ext_320319;
            int64_t ext_320318;
            int64_t ext_320317;
            int64_t ext_320316;
            int64_t ext_320315;
            int64_t ext_320314;
            int64_t ext_320313;
            int64_t ext_320312;
            int64_t ext_320311;
            int64_t ext_320310;
            struct memblock_device ext_mem_320305;
            
            ext_mem_320305.references = NULL;
            
            struct memblock_device ext_mem_320304;
            
            ext_mem_320304.references = NULL;
            
            struct memblock_device ext_mem_320303;
            
            ext_mem_320303.references = NULL;
            
            struct memblock_device ext_mem_320302;
            
            ext_mem_320302.references = NULL;
            
            struct memblock_device ext_mem_320301;
            
            ext_mem_320301.references = NULL;
            
            struct memblock_device ext_mem_320300;
            
            ext_mem_320300.references = NULL;
            
            int64_t rankSearchBatch_res_297081;
            int64_t rankSearchBatch_res_297082;
            int64_t rankSearchBatch_res_297083;
            bool rankSearchBatch_res_297084;
            int64_t rankSearchBatch_res_297091;
            int64_t loopz2088U_297093;
            int64_t loopz2089U_297094;
            int64_t loopz2081Uz2080U_297095;
            bool loop_while_297096;
            int64_t q_297103;
            struct memblock_device mem_param_320210;
            
            mem_param_320210.references = NULL;
            
            struct memblock_device mem_param_320215;
            
            mem_param_320215.references = NULL;
            
            int64_t ctx_param_ext_320220;
            int64_t ctx_param_ext_320221;
            int64_t ctx_param_ext_320222;
            int64_t ctx_param_ext_320223;
            struct memblock_device mem_param_320224;
            
            mem_param_320224.references = NULL;
            
            int64_t ctx_param_ext_320225;
            int64_t ctx_param_ext_320226;
            int64_t ctx_param_ext_320227;
            int64_t ctx_param_ext_320228;
            struct memblock_device mem_param_320229;
            
            mem_param_320229.references = NULL;
            
            int64_t ctx_param_ext_320230;
            int64_t ctx_param_ext_320231;
            int64_t ctx_param_ext_320232;
            int64_t ctx_param_ext_320233;
            struct memblock_device mem_param_320234;
            
            mem_param_320234.references = NULL;
            
            int64_t ctx_param_ext_320235;
            int64_t ctx_param_ext_320236;
            int64_t ctx_param_ext_320237;
            int64_t ctx_param_ext_320238;
            struct memblock_device mem_param_320239;
            
            mem_param_320239.references = NULL;
            ctx_param_ext_320220 = nest_sizze_297748;
            ctx_param_ext_320221 = (int64_t) 0;
            ctx_param_ext_320222 = (int64_t) 1;
            ctx_param_ext_320223 = nest_sizze_297748;
            ctx_param_ext_320225 = nest_sizze_297748;
            ctx_param_ext_320226 = (int64_t) 0;
            ctx_param_ext_320227 = (int64_t) 1;
            ctx_param_ext_320228 = nest_sizze_297748;
            ctx_param_ext_320230 = nest_sizze_297748;
            ctx_param_ext_320231 = (int64_t) 0;
            ctx_param_ext_320232 = (int64_t) 1;
            ctx_param_ext_320233 = nest_sizze_297748;
            ctx_param_ext_320235 = nest_sizze_297748;
            ctx_param_ext_320236 = (int64_t) 0;
            ctx_param_ext_320237 = (int64_t) 1;
            ctx_param_ext_320238 = nest_sizze_297748;
            if (memblock_set_device(ctx, &mem_param_320210, &mem_320196,
                                    "mem_320196") != 0)
                return 1;
            if (memblock_set_device(ctx, &mem_param_320215, &mem_320177,
                                    "mem_320177") != 0)
                return 1;
            if (memblock_set_device(ctx, &mem_param_320224, &mem_320218,
                                    "mem_320218") != 0)
                return 1;
            if (memblock_set_device(ctx, &mem_param_320229, &mem_320199,
                                    "mem_320199") != 0)
                return 1;
            if (memblock_set_device(ctx, &mem_param_320234, &mem_320192,
                                    "mem_320192") != 0)
                return 1;
            if (memblock_set_device(ctx, &mem_param_320239, &mem_320202,
                                    "mem_320202") != 0)
                return 1;
            loopz2088U_297093 = nest_sizze_297748;
            loopz2089U_297094 = nest_sizze_297748;
            loopz2081Uz2080U_297095 = nest_sizze_297748;
            loop_while_297096 = loop_cond_297079;
            q_297103 = (int64_t) 0;
            while (loop_while_297096) {
                bool cond_297105 = q_297103 == (int64_t) 0;
                
                if (slt64((int64_t) 0, partition_sizze_292766)) {
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegScan");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c",
                                "SegScan: number of elements processed sequentially per thread is m:",
                                (long long) 23, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c",
                                "SegScan: memory constraints is: ",
                                (long long) 23, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c",
                                "SegScan: register constraints is: ",
                                (long long) 31, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "SegScan: sumT' is: ",
                                (long long) 1, '\n');
                    
                    int64_t numThreads_325171 =
                            sdiv_up64(partition_sizze_292766,
                                      segscan_group_sizze_316881 *
                                      (int64_t) 23) *
                            segscan_group_sizze_316881;
                    int64_t numGroups_325172 = sdiv_up64(partition_sizze_292766,
                                                         segscan_group_sizze_316881 *
                                                         (int64_t) 23);
                    struct memblock_device mainziid_counter_mem_325173 =
                                           ctx->mainziid_counter_mem_325173;
                    struct memblock_device status_flags_mem_325175;
                    
                    status_flags_mem_325175.references = NULL;
                    if (memblock_alloc_device(ctx, &status_flags_mem_325175,
                                              numGroups_325172,
                                              "status_flags_mem_325175")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device aggregates_mem_325177;
                    
                    aggregates_mem_325177.references = NULL;
                    if (memblock_alloc_device(ctx, &aggregates_mem_325177,
                                              (int64_t) 4 * numGroups_325172,
                                              "aggregates_mem_325177")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device incprefixes_mem_325179;
                    
                    incprefixes_mem_325179.references = NULL;
                    if (memblock_alloc_device(ctx, &incprefixes_mem_325179,
                                              (int64_t) 4 * numGroups_325172,
                                              "incprefixes_mem_325179")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (futrts_builtinzhreplicate_i8(ctx,
                                                     status_flags_mem_325175,
                                                     numGroups_325172,
                                                     (int8_t) 0) != 0) {
                        if (memblock_unref_device(ctx, &incprefixes_mem_325179,
                                                  "incprefixes_mem_325179") !=
                            0)
                            return 1;
                        if (memblock_unref_device(ctx, &aggregates_mem_325177,
                                                  "aggregates_mem_325177") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &status_flags_mem_325175,
                                                  "status_flags_mem_325175") !=
                            0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_320239,
                                                  "mem_param_320239") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_320234,
                                                  "mem_param_320234") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_320229,
                                                  "mem_param_320229") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_320224,
                                                  "mem_param_320224") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_320215,
                                                  "mem_param_320215") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_320210,
                                                  "mem_param_320210") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320300,
                                                  "ext_mem_320300") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320301,
                                                  "ext_mem_320301") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320302,
                                                  "ext_mem_320302") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320303,
                                                  "ext_mem_320303") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320304,
                                                  "ext_mem_320304") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320305,
                                                  "ext_mem_320305") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320279,
                                                  "mem_320279") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320276,
                                                  "mem_320276") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320274,
                                                  "mem_320274") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320269,
                                                  "mem_320269") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320266,
                                                  "mem_320266") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320262,
                                                  "mem_320262") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320218,
                                                  "mem_320218") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320205,
                                                  "mem_320205") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320202,
                                                  "mem_320202") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320199,
                                                  "mem_320199") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320196,
                                                  "mem_320196") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320192,
                                                  "mem_320192") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320189,
                                                  "mem_320189") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320184,
                                                  "mem_320184") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320181,
                                                  "mem_320181") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320177,
                                                  "mem_320177") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320174,
                                                  "ext_mem_320174") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320154,
                                                  "ext_mem_320154") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320155,
                                                  "ext_mem_320155") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320422,
                                                  "ext_mem_320422") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318860,
                                                  "mem_param_318860") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318852,
                                                  "mem_param_318852") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320111,
                                                  "ext_mem_320111") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320112,
                                                  "ext_mem_320112") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318838,
                                                  "mem_param_318838") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318830,
                                                  "mem_param_318830") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318822,
                                                  "mem_param_318822") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320430,
                                                  "ext_mem_320430") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320431,
                                                  "ext_mem_320431") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320432,
                                                  "ext_mem_320432") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319555,
                                                  "mem_319555") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319538,
                                                  "mem_319538") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319521,
                                                  "mem_319521") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319504,
                                                  "mem_319504") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318876,
                                                  "mem_318876") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318871,
                                                  "mem_318871") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318865,
                                                  "mem_318865") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318814,
                                                  "mem_318814") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318810,
                                                  "mem_318810") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318805,
                                                  "ext_mem_318805") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318806,
                                                  "ext_mem_318806") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318756,
                                                  "ext_mem_318756") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318757,
                                                  "ext_mem_318757") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318707,
                                                  "ext_mem_318707") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318708,
                                                  "ext_mem_318708") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318609,
                                                  "ext_mem_318609") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318610,
                                                  "ext_mem_318610") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318551,
                                                  "mem_318551") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318545,
                                                  "mem_318545") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318541,
                                                  "ext_mem_318541") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318542,
                                                  "ext_mem_318542") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318509,
                                                  "mem_318509") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318506,
                                                  "mem_318506") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318502,
                                                  "mem_318502") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318500,
                                                  "mem_318500") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318497,
                                                  "mem_318497") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318493,
                                                  "mem_318493") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320825,
                                                  "mem_out_320825") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320824,
                                                  "mem_out_320824") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320823,
                                                  "mem_out_320823") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    unsigned int shared_sizze_327743 =
                                 smax64(smax64((int64_t) 160, (int64_t) 4 *
                                               segscan_group_sizze_316881),
                                        (int64_t) 23 *
                                        segscan_group_sizze_316881 *
                                        (int64_t) 4);
                    CUdeviceptr kernel_arg_327745 = mem_param_320215.mem;
                    CUdeviceptr kernel_arg_327746 = mem_320262.mem;
                    CUdeviceptr kernel_arg_327747 =
                                mainziid_counter_mem_325173.mem;
                    CUdeviceptr kernel_arg_327748 = status_flags_mem_325175.mem;
                    CUdeviceptr kernel_arg_327749 = aggregates_mem_325177.mem;
                    CUdeviceptr kernel_arg_327750 = incprefixes_mem_325179.mem;
                    unsigned int shared_offset_327744 = 0;
                    
                    if ((((((1 && sdiv_up64(partition_sizze_292766,
                                            segscan_group_sizze_316881 *
                                            (int64_t) 23) != 0) && 1 != 0) &&
                           1 != 0) && segscan_group_sizze_316881 != 0) && 1 !=
                         0) && 1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = sdiv_up64(partition_sizze_292766,
                                                  segscan_group_sizze_316881 *
                                                  (int64_t) 23);
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_327740[] = {&ctx->global_failure,
                                                      &shared_offset_327744,
                                                      &partition_sizze_292766,
                                                      &kernel_arg_327745,
                                                      &kernel_arg_327746,
                                                      &kernel_arg_327747,
                                                      &kernel_arg_327748,
                                                      &kernel_arg_327749,
                                                      &kernel_arg_327750};
                        int64_t time_start_327741 = 0, time_end_327742 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segscan_316886",
                                    (long) sdiv_up64(partition_sizze_292766,
                                                     segscan_group_sizze_316881 *
                                                     (int64_t) 23), (long) 1,
                                    (long) 1, (long) segscan_group_sizze_316881,
                                    (long) 1, (long) 1, (int) (0 +
                                                               (shared_sizze_327743 +
                                                                (8 -
                                                                 shared_sizze_327743 %
                                                                 8) % 8)));
                            time_start_327741 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegscan_316886_runs,
                                                      &ctx->mainzisegscan_316886_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegscan_316886,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segscan_group_sizze_316881,
                                                              1, 1, 0 +
                                                              (shared_sizze_327743 +
                                                               (8 -
                                                                shared_sizze_327743 %
                                                                8) % 8), NULL,
                                                              kernel_args_327740,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_327742 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segscan_316886", time_end_327742 -
                                    time_start_327741);
                        }
                    }
                    if (memblock_unref_device(ctx, &incprefixes_mem_325179,
                                              "incprefixes_mem_325179") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &aggregates_mem_325177,
                                              "aggregates_mem_325177") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &status_flags_mem_325175,
                                              "status_flags_mem_325175") != 0)
                        return 1;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_327754 = ext_mem_320174.mem;
                CUdeviceptr kernel_arg_327755 = mem_param_320234.mem;
                CUdeviceptr kernel_arg_327756 = mem_320262.mem;
                CUdeviceptr kernel_arg_327757 = mem_320266.mem;
                
                if ((((((1 && segmap_usable_groups_316915 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_316914 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_316915;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327751[] = {&ctx->global_failure,
                                                  &ctx->failure_is_an_option,
                                                  &ctx->global_failure_args,
                                                  &partition_sizze_292766,
                                                  &loopz2089U_297094,
                                                  &cond_297105,
                                                  &ctx_param_ext_320231,
                                                  &ctx_param_ext_320232,
                                                  &kernel_arg_327754,
                                                  &kernel_arg_327755,
                                                  &kernel_arg_327756,
                                                  &kernel_arg_327757};
                    int64_t time_start_327752 = 0, time_end_327753 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_316918",
                                (long) segmap_usable_groups_316915, (long) 1,
                                (long) 1, (long) segmap_group_sizze_316914,
                                (long) 1, (long) 1, (int) 0);
                        time_start_327752 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_316918_runs,
                                                  &ctx->mainzisegmap_316918_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_316918,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_316914,
                                                          1, 1, 0, NULL,
                                                          kernel_args_327751,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327753 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_316918", time_end_327753 -
                                time_start_327752);
                    }
                }
                ctx->failure_is_an_option = 1;
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (futrts_builtinzhreplicate_i32(ctx, mem_320269,
                                                  replicate_arg_297080, 0) !=
                    0) {
                    if (memblock_unref_device(ctx, &mem_param_320239,
                                              "mem_param_320239") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320234,
                                              "mem_param_320234") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320229,
                                              "mem_param_320229") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320224,
                                              "mem_param_320224") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320215,
                                              "mem_param_320215") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320210,
                                              "mem_param_320210") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320300,
                                              "ext_mem_320300") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320301,
                                              "ext_mem_320301") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320302,
                                              "ext_mem_320302") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320303,
                                              "ext_mem_320303") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320304,
                                              "ext_mem_320304") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320305,
                                              "ext_mem_320305") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320279, "mem_320279") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320276, "mem_320276") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320274, "mem_320274") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320269, "mem_320269") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320266, "mem_320266") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320262, "mem_320262") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320218, "mem_320218") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320205, "mem_320205") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320202, "mem_320202") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320199, "mem_320199") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320196, "mem_320196") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320192, "mem_320192") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320189, "mem_320189") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320184, "mem_320184") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320181, "mem_320181") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320177, "mem_320177") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320174,
                                              "ext_mem_320174") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320154,
                                              "ext_mem_320154") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320155,
                                              "ext_mem_320155") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320422,
                                              "ext_mem_320422") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t num_groups_316941;
                int32_t max_num_groups_325274;
                
                max_num_groups_325274 =
                    *ctx->tuning_params.mainziseghist_num_groups_316940;
                num_groups_316941 = sext_i64_i32(smax64((int64_t) 1,
                                                        smin64(sdiv_up64(loopz2089U_297094,
                                                                         seghist_group_sizze_316939),
                                                               sext_i32_i64(max_num_groups_325274))));
                
                int32_t num_subhistos_325275;
                struct memblock_device defunc_1_map_res_subhistos_mem_325276;
                
                defunc_1_map_res_subhistos_mem_325276.references = NULL;
                
                int64_t h_325278 = (int64_t) 4 * replicate_arg_297080;
                int64_t seg_h_325279 = (int64_t) 4 * replicate_arg_297080;
                
                if (!(seg_h_325279 == (int64_t) 0)) {
                    int64_t hist_H_325280 = replicate_arg_297080;
                    int64_t hist_el_sizze_325281 = sdiv_up64(h_325278,
                                                             hist_H_325280);
                    int64_t hist_N_325282 = loopz2089U_297094;
                    int32_t hist_RF_325283 = 1;
                    
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegHist");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "Number of threads (T)",
                                (long long) sext_i64_i32(num_groups_316941 *
                                seghist_group_sizze_316939), '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c",
                                "Desired group size (B)",
                                (long long) seghist_group_sizze_316939, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "Histogram size (H)",
                                (long long) hist_H_325280, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c",
                                "Input elements per histogram (N)",
                                (long long) hist_N_325282, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "Number of segments",
                                (long long) (int64_t) 1, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c",
                                "Histogram element size (el_size)",
                                (long long) hist_el_sizze_325281, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "Race factor (RF)",
                                (long long) hist_RF_325283, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c",
                                "Memory per set of subhistograms per segment",
                                (long long) h_325278, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c",
                                "Memory per set of subhistograms times segments",
                                (long long) seg_h_325279, '\n');
                    
                    int32_t hist_L_325284;
                    
                    hist_L_325284 = ctx->cuda.max_shared_memory;
                    
                    int32_t max_group_sizze_325285;
                    
                    max_group_sizze_325285 = ctx->cuda.max_block_size;
                    
                    int64_t num_groups_325286 =
                            sdiv_up64(sext_i32_i64(sext_i64_i32(num_groups_316941 *
                                      seghist_group_sizze_316939)),
                                      max_group_sizze_325285);
                    double hist_m_prime_325287 =
                           sitofp_i64_f64(smin64(sext_i32_i64(squot32(hist_L_325284,
                                                                      hist_el_sizze_325281)),
                                                 sdiv_up64(hist_N_325282,
                                                           num_groups_325286))) /
                           sitofp_i64_f64(hist_H_325280);
                    int64_t hist_M0_325288 = smax64((int64_t) 1,
                                                    smin64(fptosi_f64_i64(hist_m_prime_325287),
                                                           max_group_sizze_325285));
                    int64_t hist_Nout_325289 = (int64_t) 1;
                    int64_t hist_Nin_325290 = loopz2089U_297094;
                    int64_t work_asymp_M_max_325291 = squot64(hist_Nout_325289 *
                                                              hist_N_325282,
                                                              (int64_t) 2 *
                                                              num_groups_325286 *
                                                              hist_H_325280);
                    int32_t hist_M_325292 = sext_i64_i32(smin64(hist_M0_325288,
                                                                work_asymp_M_max_325291));
                    int64_t hist_C_325293 = sdiv_up64(max_group_sizze_325285,
                                                      sext_i32_i64(smax32(1,
                                                                          hist_M_325292)));
                    
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "local hist_M0",
                                (long long) hist_M0_325288, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c",
                                "local work asymp M max",
                                (long long) work_asymp_M_max_325291, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "local C",
                                (long long) hist_C_325293, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "local B",
                                (long long) max_group_sizze_325285, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "local M",
                                (long long) hist_M_325292, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "local memory needed",
                                (long long) (hist_H_325280 *
                                             hist_el_sizze_325281 *
                                             sext_i32_i64(hist_M_325292)),
                                '\n');
                    
                    int64_t local_mem_needed_325294 = hist_el_sizze_325281 *
                            sext_i32_i64(hist_M_325292);
                    int32_t hist_S_325295 =
                            sext_i64_i32(sdiv_up64(hist_H_325280 *
                                                   local_mem_needed_325294,
                                                   hist_L_325284));
                    
                    if (sle64(hist_H_325280, hist_Nin_325290) &&
                        (sle64(local_mem_needed_325294, hist_L_325284) &&
                         (sle32(hist_S_325295, 3) && (sle64(hist_C_325293,
                                                            max_group_sizze_325285) &&
                                                      slt32(0,
                                                            hist_M_325292))))) {
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "## Using local memory");
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s: %llu%c",
                                    "Histogram size (H)",
                                    (long long) hist_H_325280, '\n');
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s: %llu%c",
                                    "Multiplication degree (M)",
                                    (long long) hist_M_325292, '\n');
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s: %llu%c",
                                    "Cooperation level (C)",
                                    (long long) hist_C_325293, '\n');
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s: %llu%c",
                                    "Number of chunks (S)",
                                    (long long) hist_S_325295, '\n');
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s: %llu%c",
                                    "Number of local subhistograms per group",
                                    (long long) hist_M_325292, '\n');
                        num_subhistos_325275 = num_groups_325286;
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s: %llu%c",
                                    "Number of subhistograms in global memory per segment",
                                    (long long) num_subhistos_325275, '\n');
                        if (num_subhistos_325275 == (int64_t) 1) {
                            if (memblock_set_device(ctx,
                                                    &defunc_1_map_res_subhistos_mem_325276,
                                                    &mem_320269,
                                                    "mem_320269") != 0)
                                return 1;
                        } else {
                            if (memblock_alloc_device(ctx,
                                                      &defunc_1_map_res_subhistos_mem_325276,
                                                      num_subhistos_325275 *
                                                      replicate_arg_297080 *
                                                      (int64_t) 4,
                                                      "defunc_1_map_res_subhistos_mem_325276")) {
                                err = 1;
                                goto cleanup;
                            }
                            if (futrts_builtinzhreplicate_i32(ctx,
                                                              defunc_1_map_res_subhistos_mem_325276,
                                                              num_subhistos_325275 *
                                                              replicate_arg_297080,
                                                              0) != 0) {
                                if (memblock_unref_device(ctx,
                                                          &defunc_1_map_res_subhistos_mem_325276,
                                                          "defunc_1_map_res_subhistos_mem_325276") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_320239,
                                                          "mem_param_320239") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_320234,
                                                          "mem_param_320234") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_320229,
                                                          "mem_param_320229") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_320224,
                                                          "mem_param_320224") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_320215,
                                                          "mem_param_320215") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_320210,
                                                          "mem_param_320210") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320300,
                                                          "ext_mem_320300") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320301,
                                                          "ext_mem_320301") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320302,
                                                          "ext_mem_320302") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320303,
                                                          "ext_mem_320303") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320304,
                                                          "ext_mem_320304") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320305,
                                                          "ext_mem_320305") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320279,
                                                          "mem_320279") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320276,
                                                          "mem_320276") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320274,
                                                          "mem_320274") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320269,
                                                          "mem_320269") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320266,
                                                          "mem_320266") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320262,
                                                          "mem_320262") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320218,
                                                          "mem_320218") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320205,
                                                          "mem_320205") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320202,
                                                          "mem_320202") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320199,
                                                          "mem_320199") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320196,
                                                          "mem_320196") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320192,
                                                          "mem_320192") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320189,
                                                          "mem_320189") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320184,
                                                          "mem_320184") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320181,
                                                          "mem_320181") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_320177,
                                                          "mem_320177") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320174,
                                                          "ext_mem_320174") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320154,
                                                          "ext_mem_320154") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320155,
                                                          "ext_mem_320155") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320422,
                                                          "ext_mem_320422") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318860,
                                                          "mem_param_318860") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318852,
                                                          "mem_param_318852") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320111,
                                                          "ext_mem_320111") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320112,
                                                          "ext_mem_320112") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318838,
                                                          "mem_param_318838") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318830,
                                                          "mem_param_318830") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx,
                                                          &mem_param_318822,
                                                          "mem_param_318822") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320430,
                                                          "ext_mem_320430") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320431,
                                                          "ext_mem_320431") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_320432,
                                                          "ext_mem_320432") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319555,
                                                          "mem_319555") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319538,
                                                          "mem_319538") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319521,
                                                          "mem_319521") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_319504,
                                                          "mem_319504") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318876,
                                                          "mem_318876") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318871,
                                                          "mem_318871") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318865,
                                                          "mem_318865") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318814,
                                                          "mem_318814") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318810,
                                                          "mem_318810") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318805,
                                                          "ext_mem_318805") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318806,
                                                          "ext_mem_318806") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318756,
                                                          "ext_mem_318756") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318757,
                                                          "ext_mem_318757") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318707,
                                                          "ext_mem_318707") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318708,
                                                          "ext_mem_318708") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318609,
                                                          "ext_mem_318609") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318610,
                                                          "ext_mem_318610") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318551,
                                                          "mem_318551") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318545,
                                                          "mem_318545") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318541,
                                                          "ext_mem_318541") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &ext_mem_318542,
                                                          "ext_mem_318542") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318509,
                                                          "mem_318509") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318506,
                                                          "mem_318506") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318502,
                                                          "mem_318502") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318500,
                                                          "mem_318500") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318497,
                                                          "mem_318497") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_318493,
                                                          "mem_318493") != 0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320825,
                                                          "mem_out_320825") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320824,
                                                          "mem_out_320824") !=
                                    0)
                                    return 1;
                                if (memblock_unref_device(ctx, &mem_out_320823,
                                                          "mem_out_320823") !=
                                    0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            {
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->copy_dev_to_dev_runs,
                                                              &ctx->copy_dev_to_dev_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuMemcpy(defunc_1_map_res_subhistos_mem_325276.mem +
                                                                (int64_t) 0,
                                                                mem_320269.mem +
                                                                (int64_t) 0,
                                                                replicate_arg_297080 *
                                                                (int64_t) 4));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                            }
                        }
                        for (int32_t chk_i_325296 = 0; chk_i_325296 <
                             hist_S_325295; chk_i_325296++) {
                            int64_t num_segments_325297 = (int64_t) 1;
                            int64_t hist_H_chk_325298 =
                                    sdiv_up64(replicate_arg_297080,
                                              sext_i32_i64(hist_S_325295));
                            int64_t histo_sizze_325299 = hist_H_chk_325298;
                            int32_t init_per_thread_325300 =
                                    sext_i64_i32(sdiv_up64(sext_i32_i64(hist_M_325292) *
                                                           histo_sizze_325299,
                                                           max_group_sizze_325285));
                            unsigned int shared_sizze_327761 = (int64_t) 4 *
                                         (hist_M_325292 * hist_H_chk_325298);
                            CUdeviceptr kernel_arg_327763 =
                                        mem_param_320224.mem;
                            CUdeviceptr kernel_arg_327764 =
                                        mem_param_320234.mem;
                            CUdeviceptr kernel_arg_327765 = mem_320266.mem;
                            CUdeviceptr kernel_arg_327766 =
                                        defunc_1_map_res_subhistos_mem_325276.mem;
                            unsigned int shared_offset_327762 = 0;
                            
                            if ((((((1 && num_groups_325286 != 0) && 1 != 0) &&
                                   1 != 0) && max_group_sizze_325285 != 0) &&
                                 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_325286;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327758[] =
                                     {&ctx->global_failure,
                                      &ctx->failure_is_an_option,
                                      &ctx->global_failure_args,
                                      &shared_offset_327762,
                                      &partition_sizze_292766,
                                      &replicate_arg_297080, &loopz2089U_297094,
                                      &ctx_param_ext_320221,
                                      &ctx_param_ext_320222,
                                      &ctx_param_ext_320231,
                                      &ctx_param_ext_320232,
                                      &max_group_sizze_325285,
                                      &num_groups_325286, &hist_M_325292,
                                      &chk_i_325296, &num_segments_325297,
                                      &hist_H_chk_325298, &histo_sizze_325299,
                                      &init_per_thread_325300,
                                      &kernel_arg_327763, &kernel_arg_327764,
                                      &kernel_arg_327765, &kernel_arg_327766};
                                int64_t time_start_327759 = 0, time_end_327760 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.seghist_local_316946",
                                            (long) num_groups_325286, (long) 1,
                                            (long) 1,
                                            (long) max_group_sizze_325285,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_327761 +
                                                                        (8 -
                                                                         shared_sizze_327761 %
                                                                         8) %
                                                                        8)));
                                    time_start_327759 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainziseghist_local_316946_runs,
                                                              &ctx->mainziseghist_local_316946_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainziseghist_local_316946,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      max_group_sizze_325285,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_327761 +
                                                                       (8 -
                                                                        shared_sizze_327761 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_327758,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327760 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.seghist_local_316946",
                                            time_end_327760 -
                                            time_start_327759);
                                }
                            }
                            ctx->failure_is_an_option = 1;
                        }
                    } else {
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s\n", "## Using global memory");
                        
                        int64_t hist_H_325331 = replicate_arg_297080;
                        double hist_RF_325332 = (0.0 +
                                                 sitofp_i32_f64((int64_t) 1)) /
                               1.0;
                        int32_t hist_el_sizze_325333 = 4;
                        double hist_C_max_325334 =
                               fmin64(sitofp_i32_f64(sext_i64_i32(num_groups_316941 *
                                      seghist_group_sizze_316939)),
                                      sitofp_i32_f64(hist_H_325331) / 2.0);
                        int32_t hist_M_min_325335 = smax32(1,
                                                           sext_i64_i32(fptosi_f64_i64(sitofp_i32_f64(sext_i64_i32(num_groups_316941 *
                                                           seghist_group_sizze_316939)) /
                                                           hist_C_max_325334)));
                        int32_t L2_sizze_325336;
                        
                        L2_sizze_325336 =
                            *ctx->tuning_params.mainziL2_sizze_325336;
                        
                        double hist_RACE_exp_325337 = fmax64(1.0, 0.75 *
                                                             hist_RF_325332 /
                                                             (64.0 /
                                                              sitofp_i32_f64(hist_el_sizze_325333)));
                        int32_t hist_S_325338;
                        
                        if (slt64(loopz2089U_297094, hist_H_325331)) {
                            hist_S_325338 = 1;
                        } else {
                            hist_S_325338 =
                                sext_i64_i32(sdiv_up64(sext_i32_i64(hist_M_min_325335) *
                                                       hist_H_325331 *
                                                       sext_i32_i64(hist_el_sizze_325333),
                                                       fptosi_f64_i64(0.4 *
                                                       sitofp_i32_f64(L2_sizze_325336) *
                                                       hist_RACE_exp_325337)));
                        }
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s: %f%c",
                                    "Race expansion factor (RACE^exp)",
                                    (double) hist_RACE_exp_325337, '\n');
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s: %llu%c",
                                    "Number of chunks (S)",
                                    (long long) hist_S_325338, '\n');
                        
                        int64_t hist_H_chk_325339 =
                                sdiv_up64(replicate_arg_297080,
                                          sext_i32_i64(hist_S_325338));
                        
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s: %llu%c",
                                    "Chunk size (H_chk)",
                                    (long long) hist_H_chk_325339, '\n');
                        
                        double hist_k_max_325340 = fmin64(0.4 *
                                                          (sitofp_i32_f64(L2_sizze_325336) /
                                                           sitofp_i32_f64(4)) *
                                                          hist_RACE_exp_325337,
                                                          sitofp_i32_f64(loopz2089U_297094)) /
                               sitofp_i32_f64(sext_i64_i32(num_groups_316941 *
                               seghist_group_sizze_316939));
                        int64_t hist_u_325341 = (int64_t) 2;
                        double hist_C_325342 =
                               fmin64(sitofp_i32_f64(sext_i64_i32(num_groups_316941 *
                                      seghist_group_sizze_316939)),
                                      sitofp_i32_f64(hist_u_325341 *
                                      hist_H_chk_325339) / hist_k_max_325340);
                        int32_t hist_M_325343 = 1;
                        
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s: %f%c",
                                    "Elements/thread in L2 cache (k_max)",
                                    (double) hist_k_max_325340, '\n');
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s: %llu%c",
                                    "Multiplication degree (M)",
                                    (long long) hist_M_325343, '\n');
                        if (ctx->debugging)
                            fprintf(ctx->log, "%s: %f%c",
                                    "Cooperation level (C)",
                                    (double) hist_C_325342, '\n');
                        num_subhistos_325275 = sext_i32_i64(hist_M_325343);
                        if (hist_M_325343 == 1) {
                            if (memblock_set_device(ctx,
                                                    &defunc_1_map_res_subhistos_mem_325276,
                                                    &mem_320269,
                                                    "mem_320269") != 0)
                                return 1;
                        } else {
                            if (num_subhistos_325275 == (int64_t) 1) {
                                if (memblock_set_device(ctx,
                                                        &defunc_1_map_res_subhistos_mem_325276,
                                                        &mem_320269,
                                                        "mem_320269") != 0)
                                    return 1;
                            } else {
                                if (memblock_alloc_device(ctx,
                                                          &defunc_1_map_res_subhistos_mem_325276,
                                                          num_subhistos_325275 *
                                                          replicate_arg_297080 *
                                                          (int64_t) 4,
                                                          "defunc_1_map_res_subhistos_mem_325276")) {
                                    err = 1;
                                    goto cleanup;
                                }
                                if (futrts_builtinzhreplicate_i32(ctx,
                                                                  defunc_1_map_res_subhistos_mem_325276,
                                                                  num_subhistos_325275 *
                                                                  replicate_arg_297080,
                                                                  0) != 0) {
                                    if (memblock_unref_device(ctx,
                                                              &defunc_1_map_res_subhistos_mem_325276,
                                                              "defunc_1_map_res_subhistos_mem_325276") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_320239,
                                                              "mem_param_320239") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_320234,
                                                              "mem_param_320234") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_320229,
                                                              "mem_param_320229") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_320224,
                                                              "mem_param_320224") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_320215,
                                                              "mem_param_320215") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_320210,
                                                              "mem_param_320210") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320300,
                                                              "ext_mem_320300") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320301,
                                                              "ext_mem_320301") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320302,
                                                              "ext_mem_320302") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320303,
                                                              "ext_mem_320303") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320304,
                                                              "ext_mem_320304") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320305,
                                                              "ext_mem_320305") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320279,
                                                              "mem_320279") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320276,
                                                              "mem_320276") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320274,
                                                              "mem_320274") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320269,
                                                              "mem_320269") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320266,
                                                              "mem_320266") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320262,
                                                              "mem_320262") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320218,
                                                              "mem_320218") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320205,
                                                              "mem_320205") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320202,
                                                              "mem_320202") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320199,
                                                              "mem_320199") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320196,
                                                              "mem_320196") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320192,
                                                              "mem_320192") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320189,
                                                              "mem_320189") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320184,
                                                              "mem_320184") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320181,
                                                              "mem_320181") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_320177,
                                                              "mem_320177") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320174,
                                                              "ext_mem_320174") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320154,
                                                              "ext_mem_320154") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320155,
                                                              "ext_mem_320155") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320422,
                                                              "ext_mem_320422") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318860,
                                                              "mem_param_318860") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318852,
                                                              "mem_param_318852") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320111,
                                                              "ext_mem_320111") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320112,
                                                              "ext_mem_320112") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318838,
                                                              "mem_param_318838") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318830,
                                                              "mem_param_318830") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_param_318822,
                                                              "mem_param_318822") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320430,
                                                              "ext_mem_320430") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320431,
                                                              "ext_mem_320431") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_320432,
                                                              "ext_mem_320432") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319555,
                                                              "mem_319555") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319538,
                                                              "mem_319538") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319521,
                                                              "mem_319521") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_319504,
                                                              "mem_319504") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318876,
                                                              "mem_318876") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318871,
                                                              "mem_318871") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318865,
                                                              "mem_318865") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318814,
                                                              "mem_318814") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318810,
                                                              "mem_318810") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318805,
                                                              "ext_mem_318805") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318806,
                                                              "ext_mem_318806") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318756,
                                                              "ext_mem_318756") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318757,
                                                              "ext_mem_318757") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318707,
                                                              "ext_mem_318707") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318708,
                                                              "ext_mem_318708") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318609,
                                                              "ext_mem_318609") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318610,
                                                              "ext_mem_318610") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318551,
                                                              "mem_318551") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318545,
                                                              "mem_318545") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318541,
                                                              "ext_mem_318541") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &ext_mem_318542,
                                                              "ext_mem_318542") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318509,
                                                              "mem_318509") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318506,
                                                              "mem_318506") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318502,
                                                              "mem_318502") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318500,
                                                              "mem_318500") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318497,
                                                              "mem_318497") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx, &mem_318493,
                                                              "mem_318493") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320825,
                                                              "mem_out_320825") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320824,
                                                              "mem_out_320824") !=
                                        0)
                                        return 1;
                                    if (memblock_unref_device(ctx,
                                                              &mem_out_320823,
                                                              "mem_out_320823") !=
                                        0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                {
                                    cudaEvent_t *pevents = NULL;
                                    
                                    if (ctx->profiling &&
                                        !ctx->profiling_paused) {
                                        pevents = cuda_get_events(&ctx->cuda,
                                                                  &ctx->copy_dev_to_dev_runs,
                                                                  &ctx->copy_dev_to_dev_total_runtime);
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                           0));
                                    }
                                    CUDA_SUCCEED_OR_RETURN(cuMemcpy(defunc_1_map_res_subhistos_mem_325276.mem +
                                                                    (int64_t) 0,
                                                                    mem_320269.mem +
                                                                    (int64_t) 0,
                                                                    replicate_arg_297080 *
                                                                    (int64_t) 4));
                                    if (pevents != NULL)
                                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                           0));
                                }
                            }
                        }
                        for (int32_t chk_i_325344 = 0; chk_i_325344 <
                             hist_S_325338; chk_i_325344++) {
                            int64_t hist_H_chk_325345 =
                                    sdiv_up64(replicate_arg_297080,
                                              sext_i32_i64(hist_S_325338));
                            CUdeviceptr kernel_arg_327770 =
                                        mem_param_320224.mem;
                            CUdeviceptr kernel_arg_327771 =
                                        mem_param_320234.mem;
                            CUdeviceptr kernel_arg_327772 = mem_320266.mem;
                            CUdeviceptr kernel_arg_327773 =
                                        defunc_1_map_res_subhistos_mem_325276.mem;
                            
                            if ((((((1 && num_groups_316941 != 0) && 1 != 0) &&
                                   1 != 0) && seghist_group_sizze_316939 !=
                                  0) && 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_316941;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327767[] =
                                     {&ctx->global_failure,
                                      &ctx->failure_is_an_option,
                                      &ctx->global_failure_args,
                                      &partition_sizze_292766,
                                      &replicate_arg_297080, &loopz2089U_297094,
                                      &num_groups_316941, &ctx_param_ext_320221,
                                      &ctx_param_ext_320222,
                                      &ctx_param_ext_320231,
                                      &ctx_param_ext_320232,
                                      &num_subhistos_325275, &chk_i_325344,
                                      &hist_H_chk_325345, &kernel_arg_327770,
                                      &kernel_arg_327771, &kernel_arg_327772,
                                      &kernel_arg_327773};
                                int64_t time_start_327768 = 0, time_end_327769 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.seghist_global_316946",
                                            (long) num_groups_316941, (long) 1,
                                            (long) 1,
                                            (long) seghist_group_sizze_316939,
                                            (long) 1, (long) 1, (int) 0);
                                    time_start_327768 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainziseghist_global_316946_runs,
                                                              &ctx->mainziseghist_global_316946_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainziseghist_global_316946,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      seghist_group_sizze_316939,
                                                                      1, 1, 0,
                                                                      NULL,
                                                                      kernel_args_327767,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327769 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.seghist_global_316946",
                                            time_end_327769 -
                                            time_start_327768);
                                }
                            }
                            ctx->failure_is_an_option = 1;
                        }
                    }
                    if (num_subhistos_325275 == (int64_t) 1) {
                        if (memblock_set_device(ctx, &mem_320269,
                                                &defunc_1_map_res_subhistos_mem_325276,
                                                "defunc_1_map_res_subhistos_mem_325276") !=
                            0)
                            return 1;
                    } else {
                        if (slt64(num_subhistos_325275 * (int64_t) 2,
                                  seghist_group_sizze_316939)) {
                            int64_t segment_sizze_nonzzero_325359 =
                                    smax64((int64_t) 1, num_subhistos_325275);
                            int64_t num_threads_325360 = num_groups_316941 *
                                    seghist_group_sizze_316939;
                            
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegRed-small");
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                        (long long) replicate_arg_297080, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                        (long long) num_subhistos_325275, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "segments_per_group",
                                        (long long) squot64(seghist_group_sizze_316939,
                                                            segment_sizze_nonzzero_325359),
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "required_groups",
                                        (long long) sext_i64_i32(sdiv_up64(replicate_arg_297080,
                                                                           squot64(seghist_group_sizze_316939,
                                                                                   segment_sizze_nonzzero_325359))),
                                        '\n');
                            
                            unsigned int shared_sizze_327777 = (int64_t) 4 *
                                         seghist_group_sizze_316939;
                            CUdeviceptr kernel_arg_327779 = mem_320269.mem;
                            CUdeviceptr kernel_arg_327780 =
                                        defunc_1_map_res_subhistos_mem_325276.mem;
                            unsigned int shared_offset_327778 = 0;
                            
                            if ((((((1 && num_groups_316941 != 0) && 1 != 0) &&
                                   1 != 0) && seghist_group_sizze_316939 !=
                                  0) && 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_316941;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327774[] =
                                     {&ctx->global_failure,
                                      &shared_offset_327778,
                                      &replicate_arg_297080, &num_groups_316941,
                                      &num_subhistos_325275,
                                      &segment_sizze_nonzzero_325359,
                                      &kernel_arg_327779, &kernel_arg_327780};
                                int64_t time_start_327775 = 0, time_end_327776 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segred_small_325358",
                                            (long) num_groups_316941, (long) 1,
                                            (long) 1,
                                            (long) seghist_group_sizze_316939,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_327777 +
                                                                        (8 -
                                                                         shared_sizze_327777 %
                                                                         8) %
                                                                        8)));
                                    time_start_327775 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegred_small_325358_runs,
                                                              &ctx->mainzisegred_small_325358_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_325358,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      seghist_group_sizze_316939,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_327777 +
                                                                       (8 -
                                                                        shared_sizze_327777 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_327774,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327776 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segred_small_325358",
                                            time_end_327776 -
                                            time_start_327775);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                        } else {
                            int64_t groups_per_segment_325387 =
                                    sdiv_up64(num_groups_316941,
                                              smax64((int64_t) 1,
                                                     replicate_arg_297080));
                            int64_t elements_per_thread_325388 =
                                    sdiv_up64(num_subhistos_325275,
                                              seghist_group_sizze_316939 *
                                              groups_per_segment_325387);
                            int64_t virt_num_groups_325389 =
                                    groups_per_segment_325387 *
                                    replicate_arg_297080;
                            int64_t num_threads_325390 = num_groups_316941 *
                                    seghist_group_sizze_316939;
                            int64_t threads_per_segment_325391 =
                                    groups_per_segment_325387 *
                                    seghist_group_sizze_316939;
                            
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "\n# SegRed-large");
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                        (long long) replicate_arg_297080, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                        (long long) num_subhistos_325275, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "virt_num_groups",
                                        (long long) virt_num_groups_325389,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "num_groups",
                                        (long long) num_groups_316941, '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c", "group_size",
                                        (long long) seghist_group_sizze_316939,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "elems_per_thread",
                                        (long long) elements_per_thread_325388,
                                        '\n');
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s: %llu%c",
                                        "groups_per_segment",
                                        (long long) groups_per_segment_325387,
                                        '\n');
                            
                            struct memblock_device segred_tmp_mem_325392;
                            
                            segred_tmp_mem_325392.references = NULL;
                            if (memblock_alloc_device(ctx,
                                                      &segred_tmp_mem_325392,
                                                      (int64_t) 4 *
                                                      virt_num_groups_325389,
                                                      "segred_tmp_mem_325392")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock_device mainzicounter_mem_325394 =
                                                   ctx->mainzicounter_mem_325394;
                            unsigned int shared_sizze_327785 = 1;
                            unsigned int shared_sizze_327787 = (int64_t) 4 *
                                         seghist_group_sizze_316939;
                            CUdeviceptr kernel_arg_327789 = mem_320269.mem;
                            CUdeviceptr kernel_arg_327790 =
                                        defunc_1_map_res_subhistos_mem_325276.mem;
                            CUdeviceptr kernel_arg_327791 =
                                        segred_tmp_mem_325392.mem;
                            CUdeviceptr kernel_arg_327792 =
                                        mainzicounter_mem_325394.mem;
                            unsigned int shared_offset_327786 = 0;
                            unsigned int shared_offset_327788 = 0 +
                                         (shared_sizze_327785 + (8 -
                                                                 shared_sizze_327785 %
                                                                 8) % 8);
                            
                            if ((((((1 && num_groups_316941 != 0) && 1 != 0) &&
                                   1 != 0) && seghist_group_sizze_316939 !=
                                  0) && 1 != 0) && 1 != 0) {
                                int perm[3] = {0, 1, 2};
                                
                                if (1 >= 1 << 16) {
                                    perm[1] = perm[0];
                                    perm[0] = 1;
                                }
                                if (1 >= 1 << 16) {
                                    perm[2] = perm[0];
                                    perm[0] = 2;
                                }
                                
                                size_t grid[3];
                                
                                grid[perm[0]] = num_groups_316941;
                                grid[perm[1]] = 1;
                                grid[perm[2]] = 1;
                                
                                void *kernel_args_327782[] =
                                     {&ctx->global_failure,
                                      &shared_offset_327786,
                                      &shared_offset_327788,
                                      &replicate_arg_297080, &num_groups_316941,
                                      &num_subhistos_325275,
                                      &groups_per_segment_325387,
                                      &elements_per_thread_325388,
                                      &virt_num_groups_325389,
                                      &threads_per_segment_325391,
                                      &kernel_arg_327789, &kernel_arg_327790,
                                      &kernel_arg_327791, &kernel_arg_327792};
                                int64_t time_start_327783 = 0, time_end_327784 =
                                        0;
                                
                                if (ctx->debugging) {
                                    fprintf(ctx->log,
                                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                            "main.segred_large_325358",
                                            (long) num_groups_316941, (long) 1,
                                            (long) 1,
                                            (long) seghist_group_sizze_316939,
                                            (long) 1, (long) 1, (int) (0 +
                                                                       (shared_sizze_327785 +
                                                                        (8 -
                                                                         shared_sizze_327785 %
                                                                         8) %
                                                                        8) +
                                                                       (shared_sizze_327787 +
                                                                        (8 -
                                                                         shared_sizze_327787 %
                                                                         8) %
                                                                        8)));
                                    time_start_327783 = get_wall_time();
                                }
                                
                                cudaEvent_t *pevents = NULL;
                                
                                if (ctx->profiling && !ctx->profiling_paused) {
                                    pevents = cuda_get_events(&ctx->cuda,
                                                              &ctx->mainzisegred_large_325358_runs,
                                                              &ctx->mainzisegred_large_325358_total_runtime);
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0],
                                                                       0));
                                }
                                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_325358,
                                                                      grid[0],
                                                                      grid[1],
                                                                      grid[2],
                                                                      seghist_group_sizze_316939,
                                                                      1, 1, 0 +
                                                                      (shared_sizze_327785 +
                                                                       (8 -
                                                                        shared_sizze_327785 %
                                                                        8) %
                                                                       8) +
                                                                      (shared_sizze_327787 +
                                                                       (8 -
                                                                        shared_sizze_327787 %
                                                                        8) % 8),
                                                                      NULL,
                                                                      kernel_args_327782,
                                                                      NULL));
                                if (pevents != NULL)
                                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1],
                                                                       0));
                                if (ctx->debugging) {
                                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                                    time_end_327784 = get_wall_time();
                                    fprintf(ctx->log,
                                            "Kernel %s runtime: %ldus\n",
                                            "main.segred_large_325358",
                                            time_end_327784 -
                                            time_start_327783);
                                }
                            }
                            if (ctx->debugging)
                                fprintf(ctx->log, "%s\n", "");
                            if (memblock_unref_device(ctx,
                                                      &segred_tmp_mem_325392,
                                                      "segred_tmp_mem_325392") !=
                                0)
                                return 1;
                        }
                    }
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_327796 = mem_param_320210.mem;
                CUdeviceptr kernel_arg_327797 = mem_param_320215.mem;
                CUdeviceptr kernel_arg_327798 = mem_320269.mem;
                CUdeviceptr kernel_arg_327799 = mem_320274.mem;
                CUdeviceptr kernel_arg_327800 = mem_320276.mem;
                CUdeviceptr kernel_arg_327801 = mem_320279.mem;
                
                if ((((((1 && segmap_usable_groups_317011 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_317010 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_317011;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327793[] = {&ctx->global_failure,
                                                  &ctx->failure_is_an_option,
                                                  &ctx->global_failure_args,
                                                  &partition_sizze_292766,
                                                  &replicate_arg_297080,
                                                  &kernel_arg_327796,
                                                  &kernel_arg_327797,
                                                  &kernel_arg_327798,
                                                  &kernel_arg_327799,
                                                  &kernel_arg_327800,
                                                  &kernel_arg_327801};
                    int64_t time_start_327794 = 0, time_end_327795 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_317016",
                                (long) segmap_usable_groups_317011, (long) 1,
                                (long) 1, (long) segmap_group_sizze_317010,
                                (long) 1, (long) 1, (int) 0);
                        time_start_327794 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_317016_runs,
                                                  &ctx->mainzisegmap_317016_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_317016,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_317010,
                                                          1, 1, 0, NULL,
                                                          kernel_args_327793,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327795 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_317016", time_end_327795 -
                                time_start_327794);
                    }
                }
                ctx->failure_is_an_option = 1;
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                
                struct memblock_device mem_320282;
                
                mem_320282.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320282, bytes_320176,
                                          "mem_320282")) {
                    err = 1;
                    goto cleanup;
                }
                {
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->copy_dev_to_dev_runs,
                                                  &ctx->copy_dev_to_dev_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuMemcpy(mem_320282.mem +
                                                    (int64_t) 0,
                                                    mem_320274.mem +
                                                    (int64_t) 0,
                                                    partition_sizze_292766 *
                                                    (int64_t) 4));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                }
                
                struct memblock_device mem_320285;
                
                mem_320285.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320285, bytes_320176,
                                          "mem_320285")) {
                    err = 1;
                    goto cleanup;
                }
                {
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->copy_dev_to_dev_runs,
                                                  &ctx->copy_dev_to_dev_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuMemcpy(mem_320285.mem +
                                                    (int64_t) 0,
                                                    mem_320279.mem +
                                                    (int64_t) 0,
                                                    partition_sizze_292766 *
                                                    (int64_t) 4));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_327805 = mem_320205.mem;
                CUdeviceptr kernel_arg_327806 = mem_320266.mem;
                CUdeviceptr kernel_arg_327807 = mem_320276.mem;
                
                if ((((((1 && segmap_usable_groups_317056 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_317055 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_317056;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327802[] = {&ctx->global_failure,
                                                  &partition_sizze_292766,
                                                  &kernel_arg_327805,
                                                  &kernel_arg_327806,
                                                  &kernel_arg_327807};
                    int64_t time_start_327803 = 0, time_end_327804 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_317052",
                                (long) segmap_usable_groups_317056, (long) 1,
                                (long) 1, (long) segmap_group_sizze_317055,
                                (long) 1, (long) 1, (int) 0);
                        time_start_327803 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_317052_runs,
                                                  &ctx->mainzisegmap_317052_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_317052,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_317055,
                                                          1, 1, 0, NULL,
                                                          kernel_args_327802,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327804 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_317052", time_end_327804 -
                                time_start_327803);
                    }
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                
                int64_t segmap_usable_groups_317086 =
                        sdiv_up64(loopz2089U_297094, segmap_group_sizze_317085);
                int64_t bytes_320288 = smax64((int64_t) 0, loopz2089U_297094);
                struct memblock_device mem_320289;
                
                mem_320289.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320289, bytes_320288,
                                          "mem_320289")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_327811 = mem_param_320224.mem;
                CUdeviceptr kernel_arg_327812 = mem_param_320234.mem;
                CUdeviceptr kernel_arg_327813 = mem_320266.mem;
                CUdeviceptr kernel_arg_327814 = mem_320276.mem;
                CUdeviceptr kernel_arg_327815 = mem_320289.mem;
                
                if ((((((1 && segmap_usable_groups_317086 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_317085 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_317086;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327808[] = {&ctx->global_failure,
                                                  &ctx->failure_is_an_option,
                                                  &ctx->global_failure_args,
                                                  &partition_sizze_292766,
                                                  &loopz2089U_297094,
                                                  &ctx_param_ext_320221,
                                                  &ctx_param_ext_320222,
                                                  &ctx_param_ext_320231,
                                                  &ctx_param_ext_320232,
                                                  &kernel_arg_327811,
                                                  &kernel_arg_327812,
                                                  &kernel_arg_327813,
                                                  &kernel_arg_327814,
                                                  &kernel_arg_327815};
                    int64_t time_start_327809 = 0, time_end_327810 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_317089",
                                (long) segmap_usable_groups_317086, (long) 1,
                                (long) 1, (long) segmap_group_sizze_317085,
                                (long) 1, (long) 1, (int) 0);
                        time_start_327809 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_317089_runs,
                                                  &ctx->mainzisegmap_317089_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_317089,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_317085,
                                                          1, 1, 0, NULL,
                                                          kernel_args_327808,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327810 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_317089", time_end_327810 -
                                time_start_327809);
                    }
                }
                ctx->failure_is_an_option = 1;
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                
                int64_t num_groups_317113;
                int32_t max_num_groups_325452;
                
                max_num_groups_325452 =
                    *ctx->tuning_params.mainzisegscan_num_groups_317112;
                num_groups_317113 = sext_i64_i32(smax64((int64_t) 1,
                                                        smin64(sdiv_up64(loopz2089U_297094,
                                                                         segscan_group_sizze_317111),
                                                               sext_i32_i64(max_num_groups_325452))));
                
                int64_t binop_y_320291 = (int64_t) 4 * loopz2089U_297094;
                int64_t bytes_320292 = smax64((int64_t) 0, binop_y_320291);
                struct memblock_device mem_320293;
                
                mem_320293.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320293, bytes_320292,
                                          "mem_320293")) {
                    err = 1;
                    goto cleanup;
                }
                if (slt64((int64_t) 0, loopz2089U_297094)) {
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegScan");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c",
                                "SegScan: number of elements processed sequentially per thread is m:",
                                (long long) 23, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c",
                                "SegScan: memory constraints is: ",
                                (long long) 23, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c",
                                "SegScan: register constraints is: ",
                                (long long) 31, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "SegScan: sumT' is: ",
                                (long long) 1, '\n');
                    
                    int64_t numThreads_325453 = sdiv_up64(loopz2089U_297094,
                                                          segscan_group_sizze_317111 *
                                                          (int64_t) 23) *
                            segscan_group_sizze_317111;
                    int64_t numGroups_325454 = sdiv_up64(loopz2089U_297094,
                                                         segscan_group_sizze_317111 *
                                                         (int64_t) 23);
                    struct memblock_device mainziid_counter_mem_325455 =
                                           ctx->mainziid_counter_mem_325455;
                    struct memblock_device status_flags_mem_325457;
                    
                    status_flags_mem_325457.references = NULL;
                    if (memblock_alloc_device(ctx, &status_flags_mem_325457,
                                              numGroups_325454,
                                              "status_flags_mem_325457")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device aggregates_mem_325459;
                    
                    aggregates_mem_325459.references = NULL;
                    if (memblock_alloc_device(ctx, &aggregates_mem_325459,
                                              (int64_t) 4 * numGroups_325454,
                                              "aggregates_mem_325459")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device incprefixes_mem_325461;
                    
                    incprefixes_mem_325461.references = NULL;
                    if (memblock_alloc_device(ctx, &incprefixes_mem_325461,
                                              (int64_t) 4 * numGroups_325454,
                                              "incprefixes_mem_325461")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (futrts_builtinzhreplicate_i8(ctx,
                                                     status_flags_mem_325457,
                                                     numGroups_325454,
                                                     (int8_t) 0) != 0) {
                        if (memblock_unref_device(ctx, &incprefixes_mem_325461,
                                                  "incprefixes_mem_325461") !=
                            0)
                            return 1;
                        if (memblock_unref_device(ctx, &aggregates_mem_325459,
                                                  "aggregates_mem_325459") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &status_flags_mem_325457,
                                                  "status_flags_mem_325457") !=
                            0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320293,
                                                  "mem_320293") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320289,
                                                  "mem_320289") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320285,
                                                  "mem_320285") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320282,
                                                  "mem_320282") != 0)
                            return 1;
                        if (memblock_unref_device(ctx,
                                                  &defunc_1_map_res_subhistos_mem_325276,
                                                  "defunc_1_map_res_subhistos_mem_325276") !=
                            0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_320239,
                                                  "mem_param_320239") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_320234,
                                                  "mem_param_320234") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_320229,
                                                  "mem_param_320229") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_320224,
                                                  "mem_param_320224") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_320215,
                                                  "mem_param_320215") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_320210,
                                                  "mem_param_320210") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320300,
                                                  "ext_mem_320300") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320301,
                                                  "ext_mem_320301") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320302,
                                                  "ext_mem_320302") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320303,
                                                  "ext_mem_320303") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320304,
                                                  "ext_mem_320304") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320305,
                                                  "ext_mem_320305") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320279,
                                                  "mem_320279") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320276,
                                                  "mem_320276") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320274,
                                                  "mem_320274") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320269,
                                                  "mem_320269") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320266,
                                                  "mem_320266") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320262,
                                                  "mem_320262") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320218,
                                                  "mem_320218") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320205,
                                                  "mem_320205") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320202,
                                                  "mem_320202") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320199,
                                                  "mem_320199") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320196,
                                                  "mem_320196") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320192,
                                                  "mem_320192") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320189,
                                                  "mem_320189") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320184,
                                                  "mem_320184") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320181,
                                                  "mem_320181") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_320177,
                                                  "mem_320177") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320174,
                                                  "ext_mem_320174") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320154,
                                                  "ext_mem_320154") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320155,
                                                  "ext_mem_320155") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320422,
                                                  "ext_mem_320422") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318860,
                                                  "mem_param_318860") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318852,
                                                  "mem_param_318852") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320111,
                                                  "ext_mem_320111") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320112,
                                                  "ext_mem_320112") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318838,
                                                  "mem_param_318838") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318830,
                                                  "mem_param_318830") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_param_318822,
                                                  "mem_param_318822") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320430,
                                                  "ext_mem_320430") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320431,
                                                  "ext_mem_320431") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_320432,
                                                  "ext_mem_320432") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319555,
                                                  "mem_319555") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319538,
                                                  "mem_319538") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319521,
                                                  "mem_319521") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_319504,
                                                  "mem_319504") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318876,
                                                  "mem_318876") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318871,
                                                  "mem_318871") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318865,
                                                  "mem_318865") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318814,
                                                  "mem_318814") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318810,
                                                  "mem_318810") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318805,
                                                  "ext_mem_318805") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318806,
                                                  "ext_mem_318806") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318756,
                                                  "ext_mem_318756") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318757,
                                                  "ext_mem_318757") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318707,
                                                  "ext_mem_318707") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318708,
                                                  "ext_mem_318708") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318609,
                                                  "ext_mem_318609") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318610,
                                                  "ext_mem_318610") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318551,
                                                  "mem_318551") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318545,
                                                  "mem_318545") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318541,
                                                  "ext_mem_318541") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &ext_mem_318542,
                                                  "ext_mem_318542") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318509,
                                                  "mem_318509") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318506,
                                                  "mem_318506") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318502,
                                                  "mem_318502") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318500,
                                                  "mem_318500") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318497,
                                                  "mem_318497") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_318493,
                                                  "mem_318493") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320825,
                                                  "mem_out_320825") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320824,
                                                  "mem_out_320824") != 0)
                            return 1;
                        if (memblock_unref_device(ctx, &mem_out_320823,
                                                  "mem_out_320823") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    unsigned int shared_sizze_327820 =
                                 smax64(smax64((int64_t) 160, (int64_t) 4 *
                                               segscan_group_sizze_317111),
                                        (int64_t) 23 *
                                        segscan_group_sizze_317111 *
                                        (int64_t) 4);
                    CUdeviceptr kernel_arg_327822 = mem_320289.mem;
                    CUdeviceptr kernel_arg_327823 = mem_320293.mem;
                    CUdeviceptr kernel_arg_327824 =
                                mainziid_counter_mem_325455.mem;
                    CUdeviceptr kernel_arg_327825 = status_flags_mem_325457.mem;
                    CUdeviceptr kernel_arg_327826 = aggregates_mem_325459.mem;
                    CUdeviceptr kernel_arg_327827 = incprefixes_mem_325461.mem;
                    unsigned int shared_offset_327821 = 0;
                    
                    if ((((((1 && sdiv_up64(loopz2089U_297094,
                                            segscan_group_sizze_317111 *
                                            (int64_t) 23) != 0) && 1 != 0) &&
                           1 != 0) && segscan_group_sizze_317111 != 0) && 1 !=
                         0) && 1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = sdiv_up64(loopz2089U_297094,
                                                  segscan_group_sizze_317111 *
                                                  (int64_t) 23);
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_327817[] = {&ctx->global_failure,
                                                      &shared_offset_327821,
                                                      &loopz2089U_297094,
                                                      &kernel_arg_327822,
                                                      &kernel_arg_327823,
                                                      &kernel_arg_327824,
                                                      &kernel_arg_327825,
                                                      &kernel_arg_327826,
                                                      &kernel_arg_327827};
                        int64_t time_start_327818 = 0, time_end_327819 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segscan_317116",
                                    (long) sdiv_up64(loopz2089U_297094,
                                                     segscan_group_sizze_317111 *
                                                     (int64_t) 23), (long) 1,
                                    (long) 1, (long) segscan_group_sizze_317111,
                                    (long) 1, (long) 1, (int) (0 +
                                                               (shared_sizze_327820 +
                                                                (8 -
                                                                 shared_sizze_327820 %
                                                                 8) % 8)));
                            time_start_327818 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegscan_317116_runs,
                                                      &ctx->mainzisegscan_317116_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegscan_317116,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segscan_group_sizze_317111,
                                                              1, 1, 0 +
                                                              (shared_sizze_327820 +
                                                               (8 -
                                                                shared_sizze_327820 %
                                                                8) % 8), NULL,
                                                              kernel_args_327817,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_327819 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segscan_317116", time_end_327819 -
                                    time_start_327818);
                        }
                    }
                    if (memblock_unref_device(ctx, &incprefixes_mem_325461,
                                              "incprefixes_mem_325461") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &aggregates_mem_325459,
                                              "aggregates_mem_325459") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &status_flags_mem_325457,
                                              "status_flags_mem_325457") != 0)
                        return 1;
                }
                
                int64_t i_297244 = sub64(loopz2089U_297094, (int64_t) 1);
                bool x_297245 = sle64((int64_t) 0, i_297244);
                bool y_297246 = slt64(i_297244, loopz2089U_297094);
                bool bounds_check_297247 = x_297245 && y_297246;
                bool index_certs_297248;
                
                if (!bounds_check_297247) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_297244,
                                  "] out of bounds for array of shape [",
                                  (long long) loopz2089U_297094, "].",
                                  "-> #0  /prelude/array.fut:26:29-34\n   #1  median.fut:87:32-44\n   #2  median.fut:112:18-67\n   #3  stl.fut:343:23-52\n   #4  stl.fut:419:61-435:77\n   #5  stl.fut:463:3-479:36\n   #6  stl.fut:445:1-479:36\n");
                    if (memblock_unref_device(ctx, &mem_320293, "mem_320293") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320289, "mem_320289") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320285, "mem_320285") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320282, "mem_320282") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx,
                                              &defunc_1_map_res_subhistos_mem_325276,
                                              "defunc_1_map_res_subhistos_mem_325276") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320239,
                                              "mem_param_320239") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320234,
                                              "mem_param_320234") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320229,
                                              "mem_param_320229") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320224,
                                              "mem_param_320224") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320215,
                                              "mem_param_320215") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320210,
                                              "mem_param_320210") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320300,
                                              "ext_mem_320300") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320301,
                                              "ext_mem_320301") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320302,
                                              "ext_mem_320302") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320303,
                                              "ext_mem_320303") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320304,
                                              "ext_mem_320304") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320305,
                                              "ext_mem_320305") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320279, "mem_320279") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320276, "mem_320276") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320274, "mem_320274") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320269, "mem_320269") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320266, "mem_320266") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320262, "mem_320262") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320218, "mem_320218") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320205, "mem_320205") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320202, "mem_320202") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320199, "mem_320199") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320196, "mem_320196") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320192, "mem_320192") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320189, "mem_320189") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320184, "mem_320184") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320181, "mem_320181") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320177, "mem_320177") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320174,
                                              "ext_mem_320174") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320154,
                                              "ext_mem_320154") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320155,
                                              "ext_mem_320155") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320422,
                                              "ext_mem_320422") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int32_t last_res_297249;
                int32_t read_res_327828;
                
                {
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->copy_scalar_from_dev_runs,
                                                  &ctx->copy_scalar_from_dev_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuMemcpyDtoH(&read_res_327828,
                                                        mem_320293.mem +
                                                        i_297244 *
                                                        sizeof(int32_t),
                                                        sizeof(int32_t)));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                }
                if (futhark_context_sync(ctx) != 0)
                    return 1;
                last_res_297249 = read_res_327828;
                
                int64_t i32_res_297250 = sext_i32_i64(last_res_297249);
                int64_t segmap_usable_groups_317122 =
                        sdiv_up64(loopz2089U_297094, segmap_group_sizze_317121);
                
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_327832 = mem_param_320224.mem;
                CUdeviceptr kernel_arg_327833 = mem_param_320229.mem;
                CUdeviceptr kernel_arg_327834 = mem_param_320234.mem;
                CUdeviceptr kernel_arg_327835 = mem_param_320239.mem;
                CUdeviceptr kernel_arg_327836 = mem_320289.mem;
                CUdeviceptr kernel_arg_327837 = mem_320293.mem;
                
                if ((((((1 && segmap_usable_groups_317122 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_317121 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_317122;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327829[] = {&ctx->global_failure,
                                                  &loopz2088U_297093,
                                                  &loopz2089U_297094,
                                                  &loopz2081Uz2080U_297095,
                                                  &ctx_param_ext_320221,
                                                  &ctx_param_ext_320222,
                                                  &ctx_param_ext_320226,
                                                  &ctx_param_ext_320227,
                                                  &ctx_param_ext_320231,
                                                  &ctx_param_ext_320232,
                                                  &ctx_param_ext_320236,
                                                  &ctx_param_ext_320237,
                                                  &kernel_arg_327832,
                                                  &kernel_arg_327833,
                                                  &kernel_arg_327834,
                                                  &kernel_arg_327835,
                                                  &kernel_arg_327836,
                                                  &kernel_arg_327837};
                    int64_t time_start_327830 = 0, time_end_327831 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_317118",
                                (long) segmap_usable_groups_317122, (long) 1,
                                (long) 1, (long) segmap_group_sizze_317121,
                                (long) 1, (long) 1, (int) 0);
                        time_start_327830 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_317118_runs,
                                                  &ctx->mainzisegmap_317118_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_317118,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_317121,
                                                          1, 1, 0, NULL,
                                                          kernel_args_327829,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327831 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_317118", time_end_327831 -
                                time_start_327830);
                    }
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_unref_device(ctx, &mem_320289, "mem_320289") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320293, "mem_320293") != 0)
                    return 1;
                
                bool empty_slice_297260 = i32_res_297250 == (int64_t) 0;
                int64_t m_297261 = sub64(i32_res_297250, (int64_t) 1);
                bool zzero_leq_i_p_m_t_s_297262 = sle64((int64_t) 0, m_297261);
                bool i_p_m_t_s_leq_w_297263 = slt64(m_297261,
                                                    loopz2088U_297093);
                bool i_lte_j_297264 = sle64((int64_t) 0, i32_res_297250);
                bool y_297265 = zzero_leq_i_p_m_t_s_297262 &&
                     i_p_m_t_s_leq_w_297263;
                bool y_297266 = i_lte_j_297264 && y_297265;
                bool ok_or_empty_297267 = empty_slice_297260 || y_297266;
                bool index_certs_297268;
                
                if (!ok_or_empty_297267) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [:", (long long) i32_res_297250,
                                  "] out of bounds for array of shape [",
                                  (long long) loopz2088U_297093, "].",
                                  "-> #0  median.fut:91:20-33\n   #1  median.fut:112:18-67\n   #2  stl.fut:343:23-52\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
                    if (memblock_unref_device(ctx, &mem_320293, "mem_320293") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320289, "mem_320289") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320285, "mem_320285") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320282, "mem_320282") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx,
                                              &defunc_1_map_res_subhistos_mem_325276,
                                              "defunc_1_map_res_subhistos_mem_325276") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320239,
                                              "mem_param_320239") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320234,
                                              "mem_param_320234") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320229,
                                              "mem_param_320229") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320224,
                                              "mem_param_320224") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320215,
                                              "mem_param_320215") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320210,
                                              "mem_param_320210") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320300,
                                              "ext_mem_320300") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320301,
                                              "ext_mem_320301") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320302,
                                              "ext_mem_320302") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320303,
                                              "ext_mem_320303") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320304,
                                              "ext_mem_320304") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320305,
                                              "ext_mem_320305") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320279, "mem_320279") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320276, "mem_320276") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320274, "mem_320274") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320269, "mem_320269") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320266, "mem_320266") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320262, "mem_320262") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320218, "mem_320218") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320205, "mem_320205") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320202, "mem_320202") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320199, "mem_320199") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320196, "mem_320196") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320192, "mem_320192") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320189, "mem_320189") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320184, "mem_320184") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320181, "mem_320181") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320177, "mem_320177") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320174,
                                              "ext_mem_320174") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320154,
                                              "ext_mem_320154") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320155,
                                              "ext_mem_320155") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320422,
                                              "ext_mem_320422") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                bool i_p_m_t_s_leq_w_297270 = slt64(m_297261,
                                                    loopz2081Uz2080U_297095);
                bool y_297271 = zzero_leq_i_p_m_t_s_297262 &&
                     i_p_m_t_s_leq_w_297270;
                bool y_297272 = i_lte_j_297264 && y_297271;
                bool ok_or_empty_297273 = empty_slice_297260 || y_297272;
                bool index_certs_297274;
                
                if (!ok_or_empty_297273) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [:", (long long) i32_res_297250,
                                  "] out of bounds for array of shape [",
                                  (long long) loopz2081Uz2080U_297095, "].",
                                  "-> #0  median.fut:92:20-31\n   #1  median.fut:112:18-67\n   #2  stl.fut:343:23-52\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
                    if (memblock_unref_device(ctx, &mem_320293, "mem_320293") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320289, "mem_320289") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320285, "mem_320285") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320282, "mem_320282") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx,
                                              &defunc_1_map_res_subhistos_mem_325276,
                                              "defunc_1_map_res_subhistos_mem_325276") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320239,
                                              "mem_param_320239") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320234,
                                              "mem_param_320234") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320229,
                                              "mem_param_320229") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320224,
                                              "mem_param_320224") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320215,
                                              "mem_param_320215") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320210,
                                              "mem_param_320210") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320300,
                                              "ext_mem_320300") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320301,
                                              "ext_mem_320301") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320302,
                                              "ext_mem_320302") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320303,
                                              "ext_mem_320303") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320304,
                                              "ext_mem_320304") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320305,
                                              "ext_mem_320305") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320279, "mem_320279") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320276, "mem_320276") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320274, "mem_320274") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320269, "mem_320269") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320266, "mem_320266") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320262, "mem_320262") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320218, "mem_320218") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320205, "mem_320205") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320202, "mem_320202") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320199, "mem_320199") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320196, "mem_320196") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320192, "mem_320192") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320189, "mem_320189") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320184, "mem_320184") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320181, "mem_320181") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320177, "mem_320177") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320174,
                                              "ext_mem_320174") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320154,
                                              "ext_mem_320154") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320155,
                                              "ext_mem_320155") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320422,
                                              "ext_mem_320422") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t loopres_297276 = add64((int64_t) 1, q_297103);
                bool loop_cond_297277 = slt64((int64_t) 0, i32_res_297250);
                int64_t ctx_param_ext_tmp_325137 = ctx_param_ext_320225;
                int64_t ctx_param_ext_tmp_325138 = ctx_param_ext_320226;
                int64_t ctx_param_ext_tmp_325139 = ctx_param_ext_320227;
                int64_t ctx_param_ext_tmp_325140 = i32_res_297250;
                int64_t ctx_param_ext_tmp_325141 = ctx_param_ext_320220;
                int64_t ctx_param_ext_tmp_325142 = ctx_param_ext_320221;
                int64_t ctx_param_ext_tmp_325143 = ctx_param_ext_320222;
                int64_t ctx_param_ext_tmp_325144 = ctx_param_ext_320223;
                int64_t ctx_param_ext_tmp_325145 = ctx_param_ext_320235;
                int64_t ctx_param_ext_tmp_325146 = ctx_param_ext_320236;
                int64_t ctx_param_ext_tmp_325147 = ctx_param_ext_320237;
                int64_t ctx_param_ext_tmp_325148 = i32_res_297250;
                int64_t ctx_param_ext_tmp_325149 = ctx_param_ext_320230;
                int64_t ctx_param_ext_tmp_325150 = ctx_param_ext_320231;
                int64_t ctx_param_ext_tmp_325151 = ctx_param_ext_320232;
                int64_t ctx_param_ext_tmp_325152 = ctx_param_ext_320233;
                struct memblock_device mem_param_tmp_325153;
                
                mem_param_tmp_325153.references = NULL;
                if (memblock_set_device(ctx, &mem_param_tmp_325153, &mem_320285,
                                        "mem_320285") != 0)
                    return 1;
                
                struct memblock_device mem_param_tmp_325154;
                
                mem_param_tmp_325154.references = NULL;
                if (memblock_set_device(ctx, &mem_param_tmp_325154, &mem_320282,
                                        "mem_320282") != 0)
                    return 1;
                
                struct memblock_device mem_param_tmp_325155;
                
                mem_param_tmp_325155.references = NULL;
                if (memblock_set_device(ctx, &mem_param_tmp_325155,
                                        &mem_param_320229,
                                        "mem_param_320229") != 0)
                    return 1;
                
                struct memblock_device mem_param_tmp_325156;
                
                mem_param_tmp_325156.references = NULL;
                if (memblock_set_device(ctx, &mem_param_tmp_325156,
                                        &mem_param_320224,
                                        "mem_param_320224") != 0)
                    return 1;
                
                struct memblock_device mem_param_tmp_325157;
                
                mem_param_tmp_325157.references = NULL;
                if (memblock_set_device(ctx, &mem_param_tmp_325157,
                                        &mem_param_320239,
                                        "mem_param_320239") != 0)
                    return 1;
                
                struct memblock_device mem_param_tmp_325158;
                
                mem_param_tmp_325158.references = NULL;
                if (memblock_set_device(ctx, &mem_param_tmp_325158,
                                        &mem_param_320234,
                                        "mem_param_320234") != 0)
                    return 1;
                
                int64_t loopz2088U_tmp_325159 = loopz2089U_297094;
                int64_t loopz2089U_tmp_325160 = i32_res_297250;
                int64_t loopz2081Uz2080U_tmp_325161 = loopz2089U_297094;
                bool loop_while_tmp_325162 = loop_cond_297277;
                int64_t q_tmp_325169 = loopres_297276;
                
                ctx_param_ext_320220 = ctx_param_ext_tmp_325137;
                ctx_param_ext_320221 = ctx_param_ext_tmp_325138;
                ctx_param_ext_320222 = ctx_param_ext_tmp_325139;
                ctx_param_ext_320223 = ctx_param_ext_tmp_325140;
                ctx_param_ext_320225 = ctx_param_ext_tmp_325141;
                ctx_param_ext_320226 = ctx_param_ext_tmp_325142;
                ctx_param_ext_320227 = ctx_param_ext_tmp_325143;
                ctx_param_ext_320228 = ctx_param_ext_tmp_325144;
                ctx_param_ext_320230 = ctx_param_ext_tmp_325145;
                ctx_param_ext_320231 = ctx_param_ext_tmp_325146;
                ctx_param_ext_320232 = ctx_param_ext_tmp_325147;
                ctx_param_ext_320233 = ctx_param_ext_tmp_325148;
                ctx_param_ext_320235 = ctx_param_ext_tmp_325149;
                ctx_param_ext_320236 = ctx_param_ext_tmp_325150;
                ctx_param_ext_320237 = ctx_param_ext_tmp_325151;
                ctx_param_ext_320238 = ctx_param_ext_tmp_325152;
                if (memblock_set_device(ctx, &mem_param_320210,
                                        &mem_param_tmp_325153,
                                        "mem_param_tmp_325153") != 0)
                    return 1;
                if (memblock_set_device(ctx, &mem_param_320215,
                                        &mem_param_tmp_325154,
                                        "mem_param_tmp_325154") != 0)
                    return 1;
                if (memblock_set_device(ctx, &mem_param_320224,
                                        &mem_param_tmp_325155,
                                        "mem_param_tmp_325155") != 0)
                    return 1;
                if (memblock_set_device(ctx, &mem_param_320229,
                                        &mem_param_tmp_325156,
                                        "mem_param_tmp_325156") != 0)
                    return 1;
                if (memblock_set_device(ctx, &mem_param_320234,
                                        &mem_param_tmp_325157,
                                        "mem_param_tmp_325157") != 0)
                    return 1;
                if (memblock_set_device(ctx, &mem_param_320239,
                                        &mem_param_tmp_325158,
                                        "mem_param_tmp_325158") != 0)
                    return 1;
                loopz2088U_297093 = loopz2088U_tmp_325159;
                loopz2089U_297094 = loopz2089U_tmp_325160;
                loopz2081Uz2080U_297095 = loopz2081Uz2080U_tmp_325161;
                loop_while_297096 = loop_while_tmp_325162;
                q_297103 = q_tmp_325169;
                if (memblock_unref_device(ctx, &mem_param_tmp_325158,
                                          "mem_param_tmp_325158") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_tmp_325157,
                                          "mem_param_tmp_325157") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_tmp_325156,
                                          "mem_param_tmp_325156") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_tmp_325155,
                                          "mem_param_tmp_325155") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_tmp_325154,
                                          "mem_param_tmp_325154") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_param_tmp_325153,
                                          "mem_param_tmp_325153") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320293, "mem_320293") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320289, "mem_320289") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320285, "mem_320285") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320282, "mem_320282") != 0)
                    return 1;
                if (memblock_unref_device(ctx,
                                          &defunc_1_map_res_subhistos_mem_325276,
                                          "defunc_1_map_res_subhistos_mem_325276") !=
                    0)
                    return 1;
            }
            ext_320325 = ctx_param_ext_320220;
            ext_320324 = ctx_param_ext_320221;
            ext_320323 = ctx_param_ext_320222;
            ext_320322 = ctx_param_ext_320223;
            ext_320321 = ctx_param_ext_320225;
            ext_320320 = ctx_param_ext_320226;
            ext_320319 = ctx_param_ext_320227;
            ext_320318 = ctx_param_ext_320228;
            ext_320317 = ctx_param_ext_320230;
            ext_320316 = ctx_param_ext_320231;
            ext_320315 = ctx_param_ext_320232;
            ext_320314 = ctx_param_ext_320233;
            ext_320313 = ctx_param_ext_320235;
            ext_320312 = ctx_param_ext_320236;
            ext_320311 = ctx_param_ext_320237;
            ext_320310 = ctx_param_ext_320238;
            if (memblock_set_device(ctx, &ext_mem_320305, &mem_param_320210,
                                    "mem_param_320210") != 0)
                return 1;
            if (memblock_set_device(ctx, &ext_mem_320304, &mem_param_320215,
                                    "mem_param_320215") != 0)
                return 1;
            if (memblock_set_device(ctx, &ext_mem_320303, &mem_param_320224,
                                    "mem_param_320224") != 0)
                return 1;
            if (memblock_set_device(ctx, &ext_mem_320302, &mem_param_320229,
                                    "mem_param_320229") != 0)
                return 1;
            if (memblock_set_device(ctx, &ext_mem_320301, &mem_param_320234,
                                    "mem_param_320234") != 0)
                return 1;
            if (memblock_set_device(ctx, &ext_mem_320300, &mem_param_320239,
                                    "mem_param_320239") != 0)
                return 1;
            rankSearchBatch_res_297081 = loopz2088U_297093;
            rankSearchBatch_res_297082 = loopz2089U_297094;
            rankSearchBatch_res_297083 = loopz2081Uz2080U_297095;
            rankSearchBatch_res_297084 = loop_while_297096;
            rankSearchBatch_res_297091 = q_297103;
            if (memblock_unref_device(ctx, &ext_mem_320174, "ext_mem_320174") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320177, "mem_320177") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320192, "mem_320192") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320196, "mem_320196") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320199, "mem_320199") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320202, "mem_320202") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320218, "mem_320218") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320262, "mem_320262") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320266, "mem_320266") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320269, "mem_320269") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320274, "mem_320274") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320276, "mem_320276") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320279, "mem_320279") != 0)
                return 1;
            
            bool suff_outer_par_317124;
            
            suff_outer_par_317124 =
                *ctx->tuning_params.mainzisuff_outer_par_18 <=
                partition_sizze_292766;
            if (ctx->logging)
                fprintf(ctx->log, "Compared %s <= %ld: %s.\n",
                        "main.suff_outer_par_18", (long) partition_sizze_292766,
                        suff_outer_par_317124 ? "true" : "false");
            
            int64_t segmap_group_sizze_317188;
            
            segmap_group_sizze_317188 =
                *ctx->tuning_params.mainzisegmap_group_sizze_317128;
            
            int64_t segred_group_sizze_317329;
            
            segred_group_sizze_317329 =
                *ctx->tuning_params.mainzisegred_group_sizze_317285;
            
            int64_t num_groups_317330;
            int32_t max_num_groups_325556;
            
            max_num_groups_325556 =
                *ctx->tuning_params.mainzisegred_num_groups_317287;
            num_groups_317330 = sext_i64_i32(smax64((int64_t) 1,
                                                    smin64(sdiv_up64(nest_sizze_297748,
                                                                     segred_group_sizze_317329),
                                                           sext_i32_i64(max_num_groups_325556))));
            
            int64_t segmap_group_sizze_317371;
            
            segmap_group_sizze_317371 =
                *ctx->tuning_params.mainzisegmap_group_sizze_317254;
            
            int64_t bytes_320339 = (int64_t) 8 * segmap_group_sizze_317188;
            int64_t bytes_320353 = smax64((int64_t) 0, bytes_320339);
            int64_t num_bytes_320570 = (int64_t) 8 * segmap_group_sizze_317188;
            int64_t num_bytes_320574 = (int64_t) 8 * segmap_group_sizze_317188;
            int64_t num_bytes_320578 = (int64_t) 8 * segmap_group_sizze_317188;
            int64_t maxSubHelper_320659 = umax64(bytes_320339,
                                                 num_bytes_320578);
            int64_t maxSubHelper_320660 = umax64(bytes_320339,
                                                 num_bytes_320574);
            int64_t maxSubHelper_320661 = umax64(bytes_320339,
                                                 num_bytes_320570);
            struct memblock_device ext_mem_320416;
            
            ext_mem_320416.references = NULL;
            
            struct memblock_device ext_mem_320415;
            
            ext_mem_320415.references = NULL;
            
            struct memblock_device ext_mem_320414;
            
            ext_mem_320414.references = NULL;
            
            int32_t local_memory_capacity_325731;
            
            local_memory_capacity_325731 = ctx->cuda.max_shared_memory;
            if (sle64(bytes_320353 + srem64((int64_t) 8 - srem64(bytes_320353,
                                                                 (int64_t) 8),
                                            (int64_t) 8),
                      sext_i32_i64(local_memory_capacity_325731)) &&
                suff_outer_par_317124) {
                int64_t segmap_usable_groups_317189 =
                        sdiv_up64(partition_sizze_292766,
                                  segmap_group_sizze_317188);
                struct memblock_device mem_320336;
                
                mem_320336.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320336, binop_y_318521,
                                          "mem_320336")) {
                    err = 1;
                    goto cleanup;
                }
                if (futrts_builtinzhgpu_map_transpose_f64(ctx, mem_320336,
                                                          (int64_t) 0,
                                                          ext_mem_320155,
                                                          (int64_t) 0,
                                                          (int64_t) 1, n_292675,
                                                          partition_sizze_292766) !=
                    0) {
                    if (memblock_unref_device(ctx, &mem_320336, "mem_320336") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320414,
                                              "ext_mem_320414") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320415,
                                              "ext_mem_320415") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320416,
                                              "ext_mem_320416") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320239,
                                              "mem_param_320239") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320234,
                                              "mem_param_320234") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320229,
                                              "mem_param_320229") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320224,
                                              "mem_param_320224") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320215,
                                              "mem_param_320215") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_320210,
                                              "mem_param_320210") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320300,
                                              "ext_mem_320300") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320301,
                                              "ext_mem_320301") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320302,
                                              "ext_mem_320302") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320303,
                                              "ext_mem_320303") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320304,
                                              "ext_mem_320304") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320305,
                                              "ext_mem_320305") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320279, "mem_320279") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320276, "mem_320276") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320274, "mem_320274") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320269, "mem_320269") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320266, "mem_320266") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320262, "mem_320262") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320218, "mem_320218") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320205, "mem_320205") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320202, "mem_320202") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320199, "mem_320199") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320196, "mem_320196") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320192, "mem_320192") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320189, "mem_320189") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320184, "mem_320184") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320181, "mem_320181") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_320177, "mem_320177") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320174,
                                              "ext_mem_320174") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320154,
                                              "ext_mem_320154") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320155,
                                              "ext_mem_320155") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320422,
                                              "ext_mem_320422") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318860,
                                              "mem_param_318860") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318852,
                                              "mem_param_318852") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320111,
                                              "ext_mem_320111") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320112,
                                              "ext_mem_320112") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318838,
                                              "mem_param_318838") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318830,
                                              "mem_param_318830") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_param_318822,
                                              "mem_param_318822") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320430,
                                              "ext_mem_320430") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320431,
                                              "ext_mem_320431") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_320432,
                                              "ext_mem_320432") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318805,
                                              "ext_mem_318805") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318806,
                                              "ext_mem_318806") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318756,
                                              "ext_mem_318756") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318757,
                                              "ext_mem_318757") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318707,
                                              "ext_mem_318707") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318708,
                                              "ext_mem_318708") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318609,
                                              "ext_mem_318609") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318610,
                                              "ext_mem_318610") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318541,
                                              "ext_mem_318541") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &ext_mem_318542,
                                              "ext_mem_318542") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") !=
                        0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320825,
                                              "mem_out_320825") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320824,
                                              "mem_out_320824") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &mem_out_320823,
                                              "mem_out_320823") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t num_whole_tiles_318102 = squot64(n_292675,
                                                         segmap_group_sizze_317188);
                int64_t residual_input_318296 = srem64(n_292675,
                                                       segmap_group_sizze_317188);
                bool cond_318297 = residual_input_318296 == (int64_t) 0;
                struct memblock_device mem_320387;
                
                mem_320387.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320387, bytes_318525,
                                          "mem_320387")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device mem_320390;
                
                mem_320390.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320390, bytes_318525,
                                          "mem_320390")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device mem_320393;
                
                mem_320393.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320393, bytes_318525,
                                          "mem_320393")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                int32_t num_chunks_325557 =
                        sext_i64_i32(sdiv_up64(segmap_group_sizze_317188,
                                               segmap_group_sizze_317188));
                unsigned int shared_sizze_327841 = bytes_320353;
                CUdeviceptr kernel_arg_327843 = ext_mem_318541.mem;
                CUdeviceptr kernel_arg_327844 = mem_320184.mem;
                CUdeviceptr kernel_arg_327845 = mem_320205.mem;
                CUdeviceptr kernel_arg_327846 = mem_320336.mem;
                CUdeviceptr kernel_arg_327847 = mem_320387.mem;
                CUdeviceptr kernel_arg_327848 = mem_320390.mem;
                CUdeviceptr kernel_arg_327849 = mem_320393.mem;
                unsigned int shared_offset_327842 = 0;
                
                if ((((((1 && segmap_usable_groups_317189 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_317188 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_317189;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327838[] = {&ctx->global_failure,
                                                  &shared_offset_327842,
                                                  &n_292675,
                                                  &partition_sizze_292766,
                                                  &segmap_usable_groups_317189,
                                                  &num_whole_tiles_318102,
                                                  &residual_input_318296,
                                                  &cond_318297,
                                                  &kernel_arg_327843,
                                                  &kernel_arg_327844,
                                                  &kernel_arg_327845,
                                                  &kernel_arg_327846,
                                                  &kernel_arg_327847,
                                                  &kernel_arg_327848,
                                                  &kernel_arg_327849};
                    int64_t time_start_327839 = 0, time_end_327840 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_intragroup_318088",
                                (long) segmap_usable_groups_317189, (long) 1,
                                (long) 1, (long) segmap_group_sizze_317188,
                                (long) 1, (long) 1, (int) (0 +
                                                           (shared_sizze_327841 +
                                                            (8 -
                                                             shared_sizze_327841 %
                                                             8) % 8)));
                        time_start_327839 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_intragroup_318088_runs,
                                                  &ctx->mainzisegmap_intragroup_318088_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_intragroup_318088,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_317188,
                                                          1, 1, 0 +
                                                          (shared_sizze_327841 +
                                                           (8 -
                                                            shared_sizze_327841 %
                                                            8) % 8), NULL,
                                                          kernel_args_327838,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327840 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_intragroup_318088",
                                time_end_327840 - time_start_327839);
                    }
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_unref_device(ctx, &mem_320336, "mem_320336") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_320416, &mem_320387,
                                        "mem_320387") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_320415, &mem_320390,
                                        "mem_320390") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_320414, &mem_320393,
                                        "mem_320393") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320393, "mem_320393") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320390, "mem_320390") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320387, "mem_320387") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320336, "mem_320336") != 0)
                    return 1;
            } else {
                struct memblock_device mem_320397;
                
                mem_320397.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320397, bytes_318525,
                                          "mem_320397")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device mem_320400;
                
                mem_320400.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320400, bytes_318525,
                                          "mem_320400")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device mem_320403;
                
                mem_320403.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320403, bytes_318525,
                                          "mem_320403")) {
                    err = 1;
                    goto cleanup;
                }
                if (slt64(n_292675 * (int64_t) 2, segred_group_sizze_317329)) {
                    int64_t segment_sizze_nonzzero_325593 = smax64((int64_t) 1,
                                                                   n_292675);
                    int64_t num_threads_325594 = num_groups_317330 *
                            segred_group_sizze_317329;
                    
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegRed-small");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                (long long) partition_sizze_292766, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                (long long) n_292675, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segments_per_group",
                                (long long) squot64(segred_group_sizze_317329,
                                                    segment_sizze_nonzzero_325593),
                                '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "required_groups",
                                (long long) sext_i64_i32(sdiv_up64(partition_sizze_292766,
                                                                   squot64(segred_group_sizze_317329,
                                                                           segment_sizze_nonzzero_325593))),
                                '\n');
                    
                    unsigned int shared_sizze_327853 = (int64_t) 8 *
                                 segred_group_sizze_317329;
                    unsigned int shared_sizze_327855 = (int64_t) 8 *
                                 segred_group_sizze_317329;
                    unsigned int shared_sizze_327857 = (int64_t) 8 *
                                 segred_group_sizze_317329;
                    CUdeviceptr kernel_arg_327859 = ext_mem_320155.mem;
                    CUdeviceptr kernel_arg_327860 = mem_320205.mem;
                    CUdeviceptr kernel_arg_327861 = mem_320397.mem;
                    CUdeviceptr kernel_arg_327862 = mem_320400.mem;
                    CUdeviceptr kernel_arg_327863 = mem_320403.mem;
                    unsigned int shared_offset_327854 = 0;
                    unsigned int shared_offset_327856 = 0 +
                                 (shared_sizze_327853 + (8 -
                                                         shared_sizze_327853 %
                                                         8) % 8);
                    unsigned int shared_offset_327858 = 0 +
                                 (shared_sizze_327853 + (8 -
                                                         shared_sizze_327853 %
                                                         8) % 8) +
                                 (shared_sizze_327855 + (8 -
                                                         shared_sizze_327855 %
                                                         8) % 8);
                    
                    if ((((((1 && num_groups_317330 != 0) && 1 != 0) && 1 !=
                           0) && segred_group_sizze_317329 != 0) && 1 != 0) &&
                        1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = num_groups_317330;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_327850[] = {&ctx->global_failure,
                                                      &shared_offset_327854,
                                                      &shared_offset_327856,
                                                      &shared_offset_327858,
                                                      &n_292675,
                                                      &partition_sizze_292766,
                                                      &num_groups_317330,
                                                      &segment_sizze_nonzzero_325593,
                                                      &kernel_arg_327859,
                                                      &kernel_arg_327860,
                                                      &kernel_arg_327861,
                                                      &kernel_arg_327862,
                                                      &kernel_arg_327863};
                        int64_t time_start_327851 = 0, time_end_327852 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segred_small_317337",
                                    (long) num_groups_317330, (long) 1,
                                    (long) 1, (long) segred_group_sizze_317329,
                                    (long) 1, (long) 1, (int) (0 +
                                                               (shared_sizze_327853 +
                                                                (8 -
                                                                 shared_sizze_327853 %
                                                                 8) % 8) +
                                                               (shared_sizze_327855 +
                                                                (8 -
                                                                 shared_sizze_327855 %
                                                                 8) % 8) +
                                                               (shared_sizze_327857 +
                                                                (8 -
                                                                 shared_sizze_327857 %
                                                                 8) % 8)));
                            time_start_327851 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegred_small_317337_runs,
                                                      &ctx->mainzisegred_small_317337_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_small_317337,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segred_group_sizze_317329,
                                                              1, 1, 0 +
                                                              (shared_sizze_327853 +
                                                               (8 -
                                                                shared_sizze_327853 %
                                                                8) % 8) +
                                                              (shared_sizze_327855 +
                                                               (8 -
                                                                shared_sizze_327855 %
                                                                8) % 8) +
                                                              (shared_sizze_327857 +
                                                               (8 -
                                                                shared_sizze_327857 %
                                                                8) % 8), NULL,
                                                              kernel_args_327850,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_327852 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segred_small_317337",
                                    time_end_327852 - time_start_327851);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                } else {
                    int64_t groups_per_segment_325649 =
                            sdiv_up64(num_groups_317330, smax64((int64_t) 1,
                                                                partition_sizze_292766));
                    int64_t elements_per_thread_325650 = sdiv_up64(n_292675,
                                                                   segred_group_sizze_317329 *
                                                                   groups_per_segment_325649);
                    int64_t virt_num_groups_325651 = groups_per_segment_325649 *
                            partition_sizze_292766;
                    int64_t num_threads_325652 = num_groups_317330 *
                            segred_group_sizze_317329;
                    int64_t threads_per_segment_325653 =
                            groups_per_segment_325649 *
                            segred_group_sizze_317329;
                    
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "\n# SegRed-large");
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_segments",
                                (long long) partition_sizze_292766, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "segment_size",
                                (long long) n_292675, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "virt_num_groups",
                                (long long) virt_num_groups_325651, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "num_groups",
                                (long long) num_groups_317330, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "group_size",
                                (long long) segred_group_sizze_317329, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "elems_per_thread",
                                (long long) elements_per_thread_325650, '\n');
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s: %llu%c", "groups_per_segment",
                                (long long) groups_per_segment_325649, '\n');
                    
                    struct memblock_device segred_tmp_mem_325654;
                    
                    segred_tmp_mem_325654.references = NULL;
                    if (memblock_alloc_device(ctx, &segred_tmp_mem_325654,
                                              (int64_t) 8 *
                                              virt_num_groups_325651,
                                              "segred_tmp_mem_325654")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device segred_tmp_mem_325656;
                    
                    segred_tmp_mem_325656.references = NULL;
                    if (memblock_alloc_device(ctx, &segred_tmp_mem_325656,
                                              (int64_t) 8 *
                                              virt_num_groups_325651,
                                              "segred_tmp_mem_325656")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device segred_tmp_mem_325658;
                    
                    segred_tmp_mem_325658.references = NULL;
                    if (memblock_alloc_device(ctx, &segred_tmp_mem_325658,
                                              (int64_t) 8 *
                                              virt_num_groups_325651,
                                              "segred_tmp_mem_325658")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    struct memblock_device mainzicounter_mem_325660 =
                                           ctx->mainzicounter_mem_325660;
                    unsigned int shared_sizze_327868 = 1;
                    unsigned int shared_sizze_327870 = (int64_t) 8 *
                                 segred_group_sizze_317329;
                    unsigned int shared_sizze_327872 = (int64_t) 8 *
                                 segred_group_sizze_317329;
                    unsigned int shared_sizze_327874 = (int64_t) 8 *
                                 segred_group_sizze_317329;
                    CUdeviceptr kernel_arg_327876 = ext_mem_320155.mem;
                    CUdeviceptr kernel_arg_327877 = mem_320205.mem;
                    CUdeviceptr kernel_arg_327878 = mem_320397.mem;
                    CUdeviceptr kernel_arg_327879 = mem_320400.mem;
                    CUdeviceptr kernel_arg_327880 = mem_320403.mem;
                    CUdeviceptr kernel_arg_327881 = segred_tmp_mem_325654.mem;
                    CUdeviceptr kernel_arg_327882 = segred_tmp_mem_325656.mem;
                    CUdeviceptr kernel_arg_327883 = segred_tmp_mem_325658.mem;
                    CUdeviceptr kernel_arg_327884 =
                                mainzicounter_mem_325660.mem;
                    unsigned int shared_offset_327869 = 0;
                    unsigned int shared_offset_327871 = 0 +
                                 (shared_sizze_327868 + (8 -
                                                         shared_sizze_327868 %
                                                         8) % 8);
                    unsigned int shared_offset_327873 = 0 +
                                 (shared_sizze_327868 + (8 -
                                                         shared_sizze_327868 %
                                                         8) % 8) +
                                 (shared_sizze_327870 + (8 -
                                                         shared_sizze_327870 %
                                                         8) % 8);
                    unsigned int shared_offset_327875 = 0 +
                                 (shared_sizze_327868 + (8 -
                                                         shared_sizze_327868 %
                                                         8) % 8) +
                                 (shared_sizze_327870 + (8 -
                                                         shared_sizze_327870 %
                                                         8) % 8) +
                                 (shared_sizze_327872 + (8 -
                                                         shared_sizze_327872 %
                                                         8) % 8);
                    
                    if ((((((1 && num_groups_317330 != 0) && 1 != 0) && 1 !=
                           0) && segred_group_sizze_317329 != 0) && 1 != 0) &&
                        1 != 0) {
                        int perm[3] = {0, 1, 2};
                        
                        if (1 >= 1 << 16) {
                            perm[1] = perm[0];
                            perm[0] = 1;
                        }
                        if (1 >= 1 << 16) {
                            perm[2] = perm[0];
                            perm[0] = 2;
                        }
                        
                        size_t grid[3];
                        
                        grid[perm[0]] = num_groups_317330;
                        grid[perm[1]] = 1;
                        grid[perm[2]] = 1;
                        
                        void *kernel_args_327865[] = {&ctx->global_failure,
                                                      &shared_offset_327869,
                                                      &shared_offset_327871,
                                                      &shared_offset_327873,
                                                      &shared_offset_327875,
                                                      &n_292675,
                                                      &partition_sizze_292766,
                                                      &num_groups_317330,
                                                      &groups_per_segment_325649,
                                                      &elements_per_thread_325650,
                                                      &virt_num_groups_325651,
                                                      &threads_per_segment_325653,
                                                      &kernel_arg_327876,
                                                      &kernel_arg_327877,
                                                      &kernel_arg_327878,
                                                      &kernel_arg_327879,
                                                      &kernel_arg_327880,
                                                      &kernel_arg_327881,
                                                      &kernel_arg_327882,
                                                      &kernel_arg_327883,
                                                      &kernel_arg_327884};
                        int64_t time_start_327866 = 0, time_end_327867 = 0;
                        
                        if (ctx->debugging) {
                            fprintf(ctx->log,
                                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                    "main.segred_large_317337",
                                    (long) num_groups_317330, (long) 1,
                                    (long) 1, (long) segred_group_sizze_317329,
                                    (long) 1, (long) 1, (int) (0 +
                                                               (shared_sizze_327868 +
                                                                (8 -
                                                                 shared_sizze_327868 %
                                                                 8) % 8) +
                                                               (shared_sizze_327870 +
                                                                (8 -
                                                                 shared_sizze_327870 %
                                                                 8) % 8) +
                                                               (shared_sizze_327872 +
                                                                (8 -
                                                                 shared_sizze_327872 %
                                                                 8) % 8) +
                                                               (shared_sizze_327874 +
                                                                (8 -
                                                                 shared_sizze_327874 %
                                                                 8) % 8)));
                            time_start_327866 = get_wall_time();
                        }
                        
                        cudaEvent_t *pevents = NULL;
                        
                        if (ctx->profiling && !ctx->profiling_paused) {
                            pevents = cuda_get_events(&ctx->cuda,
                                                      &ctx->mainzisegred_large_317337_runs,
                                                      &ctx->mainzisegred_large_317337_total_runtime);
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                        }
                        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegred_large_317337,
                                                              grid[0], grid[1],
                                                              grid[2],
                                                              segred_group_sizze_317329,
                                                              1, 1, 0 +
                                                              (shared_sizze_327868 +
                                                               (8 -
                                                                shared_sizze_327868 %
                                                                8) % 8) +
                                                              (shared_sizze_327870 +
                                                               (8 -
                                                                shared_sizze_327870 %
                                                                8) % 8) +
                                                              (shared_sizze_327872 +
                                                               (8 -
                                                                shared_sizze_327872 %
                                                                8) % 8) +
                                                              (shared_sizze_327874 +
                                                               (8 -
                                                                shared_sizze_327874 %
                                                                8) % 8), NULL,
                                                              kernel_args_327865,
                                                              NULL));
                        if (pevents != NULL)
                            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                        if (ctx->debugging) {
                            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                            time_end_327867 = get_wall_time();
                            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                    "main.segred_large_317337",
                                    time_end_327867 - time_start_327866);
                        }
                    }
                    if (ctx->debugging)
                        fprintf(ctx->log, "%s\n", "");
                    if (memblock_unref_device(ctx, &segred_tmp_mem_325658,
                                              "segred_tmp_mem_325658") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &segred_tmp_mem_325656,
                                              "segred_tmp_mem_325656") != 0)
                        return 1;
                    if (memblock_unref_device(ctx, &segred_tmp_mem_325654,
                                              "segred_tmp_mem_325654") != 0)
                        return 1;
                }
                if (memblock_unref_device(ctx, &mem_320400, "mem_320400") != 0)
                    return 1;
                
                int64_t segmap_usable_groups_317372 =
                        sdiv_up64(partition_sizze_292766,
                                  segmap_group_sizze_317371);
                struct memblock_device mem_320407;
                
                mem_320407.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320407, bytes_318525,
                                          "mem_320407")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device mem_320410;
                
                mem_320410.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320410, bytes_318525,
                                          "mem_320410")) {
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock_device mem_320413;
                
                mem_320413.references = NULL;
                if (memblock_alloc_device(ctx, &mem_320413, bytes_318525,
                                          "mem_320413")) {
                    err = 1;
                    goto cleanup;
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "\n# SegMap");
                
                CUdeviceptr kernel_arg_327888 = ext_mem_318541.mem;
                CUdeviceptr kernel_arg_327889 = mem_320184.mem;
                CUdeviceptr kernel_arg_327890 = mem_320205.mem;
                CUdeviceptr kernel_arg_327891 = mem_320397.mem;
                CUdeviceptr kernel_arg_327892 = mem_320403.mem;
                CUdeviceptr kernel_arg_327893 = mem_320407.mem;
                CUdeviceptr kernel_arg_327894 = mem_320410.mem;
                CUdeviceptr kernel_arg_327895 = mem_320413.mem;
                
                if ((((((1 && segmap_usable_groups_317372 != 0) && 1 != 0) &&
                       1 != 0) && segmap_group_sizze_317371 != 0) && 1 != 0) &&
                    1 != 0) {
                    int perm[3] = {0, 1, 2};
                    
                    if (1 >= 1 << 16) {
                        perm[1] = perm[0];
                        perm[0] = 1;
                    }
                    if (1 >= 1 << 16) {
                        perm[2] = perm[0];
                        perm[0] = 2;
                    }
                    
                    size_t grid[3];
                    
                    grid[perm[0]] = segmap_usable_groups_317372;
                    grid[perm[1]] = 1;
                    grid[perm[2]] = 1;
                    
                    void *kernel_args_327885[] = {&ctx->global_failure,
                                                  &partition_sizze_292766,
                                                  &kernel_arg_327888,
                                                  &kernel_arg_327889,
                                                  &kernel_arg_327890,
                                                  &kernel_arg_327891,
                                                  &kernel_arg_327892,
                                                  &kernel_arg_327893,
                                                  &kernel_arg_327894,
                                                  &kernel_arg_327895};
                    int64_t time_start_327886 = 0, time_end_327887 = 0;
                    
                    if (ctx->debugging) {
                        fprintf(ctx->log,
                                "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                                "main.segmap_317377",
                                (long) segmap_usable_groups_317372, (long) 1,
                                (long) 1, (long) segmap_group_sizze_317371,
                                (long) 1, (long) 1, (int) 0);
                        time_start_327886 = get_wall_time();
                    }
                    
                    cudaEvent_t *pevents = NULL;
                    
                    if (ctx->profiling && !ctx->profiling_paused) {
                        pevents = cuda_get_events(&ctx->cuda,
                                                  &ctx->mainzisegmap_317377_runs,
                                                  &ctx->mainzisegmap_317377_total_runtime);
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                    }
                    CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_317377,
                                                          grid[0], grid[1],
                                                          grid[2],
                                                          segmap_group_sizze_317371,
                                                          1, 1, 0, NULL,
                                                          kernel_args_327885,
                                                          NULL));
                    if (pevents != NULL)
                        CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                    if (ctx->debugging) {
                        CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                        time_end_327887 = get_wall_time();
                        fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                                "main.segmap_317377", time_end_327887 -
                                time_start_327886);
                    }
                }
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "");
                if (memblock_unref_device(ctx, &mem_320397, "mem_320397") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320403, "mem_320403") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_320416, &mem_320407,
                                        "mem_320407") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_320415, &mem_320410,
                                        "mem_320410") != 0)
                    return 1;
                if (memblock_set_device(ctx, &ext_mem_320414, &mem_320413,
                                        "mem_320413") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320413, "mem_320413") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320410, "mem_320410") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320407, "mem_320407") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320403, "mem_320403") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320400, "mem_320400") != 0)
                    return 1;
                if (memblock_unref_device(ctx, &mem_320397, "mem_320397") != 0)
                    return 1;
            }
            if (memblock_unref_device(ctx, &ext_mem_320155, "ext_mem_320155") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320184, "mem_320184") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320205, "mem_320205") != 0)
                return 1;
            
            int64_t segmap_group_sizze_317476;
            
            segmap_group_sizze_317476 =
                *ctx->tuning_params.mainzisegmap_group_sizze_317416;
            
            int64_t segmap_usable_groups_317477 = sdiv_up64(nest_sizze_297748,
                                                            segmap_group_sizze_317476);
            struct memblock_device mem_320421;
            
            mem_320421.references = NULL;
            if (memblock_alloc_device(ctx, &mem_320421, bytes_318522,
                                      "mem_320421")) {
                err = 1;
                goto cleanup;
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegMap");
            
            CUdeviceptr kernel_arg_327899 = ext_mem_320154.mem;
            CUdeviceptr kernel_arg_327900 = ext_mem_320414.mem;
            CUdeviceptr kernel_arg_327901 = ext_mem_320415.mem;
            CUdeviceptr kernel_arg_327902 = ext_mem_320416.mem;
            CUdeviceptr kernel_arg_327903 = mem_320421.mem;
            
            if ((((((1 && segmap_usable_groups_317477 != 0) && 1 != 0) && 1 !=
                   0) && segmap_group_sizze_317476 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = segmap_usable_groups_317477;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_327896[] = {&ctx->global_failure, &n_292675,
                                              &partition_sizze_292766,
                                              &kernel_arg_327899,
                                              &kernel_arg_327900,
                                              &kernel_arg_327901,
                                              &kernel_arg_327902,
                                              &kernel_arg_327903};
                int64_t time_start_327897 = 0, time_end_327898 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "main.segmap_317481",
                            (long) segmap_usable_groups_317477, (long) 1,
                            (long) 1, (long) segmap_group_sizze_317476,
                            (long) 1, (long) 1, (int) 0);
                    time_start_327897 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->mainzisegmap_317481_runs,
                                              &ctx->mainzisegmap_317481_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_317481,
                                                      grid[0], grid[1], grid[2],
                                                      segmap_group_sizze_317476,
                                                      1, 1, 0, NULL,
                                                      kernel_args_327896,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_327898 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "main.segmap_317481", time_end_327898 -
                            time_start_327897);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            if (memblock_unref_device(ctx, &ext_mem_320154, "ext_mem_320154") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320414, "ext_mem_320414") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320415, "ext_mem_320415") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320416, "ext_mem_320416") !=
                0)
                return 1;
            if (memblock_set_device(ctx, &ext_mem_320422, &mem_320421,
                                    "mem_320421") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320421, "mem_320421") != 0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320414, "ext_mem_320414") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320415, "ext_mem_320415") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320416, "ext_mem_320416") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_param_320239,
                                      "mem_param_320239") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_param_320234,
                                      "mem_param_320234") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_param_320229,
                                      "mem_param_320229") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_param_320224,
                                      "mem_param_320224") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_param_320215,
                                      "mem_param_320215") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_param_320210,
                                      "mem_param_320210") != 0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320300, "ext_mem_320300") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320301, "ext_mem_320301") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320302, "ext_mem_320302") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320303, "ext_mem_320303") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320304, "ext_mem_320304") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320305, "ext_mem_320305") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320279, "mem_320279") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320276, "mem_320276") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320274, "mem_320274") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320269, "mem_320269") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320266, "mem_320266") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320262, "mem_320262") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320218, "mem_320218") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320205, "mem_320205") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320202, "mem_320202") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320199, "mem_320199") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320196, "mem_320196") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320192, "mem_320192") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320189, "mem_320189") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320184, "mem_320184") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320181, "mem_320181") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_320177, "mem_320177") != 0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320174, "ext_mem_320174") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320154, "ext_mem_320154") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_320155, "ext_mem_320155") !=
                0)
                return 1;
        } else {
            if (memblock_set_device(ctx, &ext_mem_320422, &mem_param_318838,
                                    "mem_param_318838") != 0)
                return 1;
        }
        
        int64_t ctx_param_ext_tmp_321602 = ext_320118;
        int64_t ctx_param_ext_tmp_321603 = ext_320116;
        int64_t ctx_param_ext_tmp_321604 = ext_320427;
        int64_t ctx_param_ext_tmp_321605 = ext_320426;
        int64_t ctx_param_ext_tmp_321606 = ext_320423;
        int64_t ctx_param_ext_tmp_321607 = ext_320425;
        int64_t ctx_param_ext_tmp_321608 = ext_320429;
        int64_t ctx_param_ext_tmp_321609 = ext_320424;
        int64_t ctx_param_ext_tmp_321610 = ext_320428;
        struct memblock_device mem_param_tmp_321611;
        
        mem_param_tmp_321611.references = NULL;
        if (memblock_set_device(ctx, &mem_param_tmp_321611, &ext_mem_320112,
                                "ext_mem_320112") != 0)
            return 1;
        
        struct memblock_device mem_param_tmp_321612;
        
        mem_param_tmp_321612.references = NULL;
        if (memblock_set_device(ctx, &mem_param_tmp_321612, &ext_mem_320111,
                                "ext_mem_320111") != 0)
            return 1;
        
        struct memblock_device mem_param_tmp_321613;
        
        mem_param_tmp_321613.references = NULL;
        if (memblock_set_device(ctx, &mem_param_tmp_321613, &ext_mem_320422,
                                "ext_mem_320422") != 0)
            return 1;
        ctx_param_ext_318824 = ctx_param_ext_tmp_321602;
        ctx_param_ext_318826 = ctx_param_ext_tmp_321603;
        ctx_param_ext_318831 = ctx_param_ext_tmp_321604;
        ctx_param_ext_318832 = ctx_param_ext_tmp_321605;
        ctx_param_ext_318833 = ctx_param_ext_tmp_321606;
        ctx_param_ext_318834 = ctx_param_ext_tmp_321607;
        ctx_param_ext_318835 = ctx_param_ext_tmp_321608;
        ctx_param_ext_318836 = ctx_param_ext_tmp_321609;
        ctx_param_ext_318837 = ctx_param_ext_tmp_321610;
        if (memblock_set_device(ctx, &mem_param_318822, &mem_param_tmp_321611,
                                "mem_param_tmp_321611") != 0)
            return 1;
        if (memblock_set_device(ctx, &mem_param_318830, &mem_param_tmp_321612,
                                "mem_param_tmp_321612") != 0)
            return 1;
        if (memblock_set_device(ctx, &mem_param_318838, &mem_param_tmp_321613,
                                "mem_param_tmp_321613") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_tmp_321613,
                                  "mem_param_tmp_321613") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_tmp_321612,
                                  "mem_param_tmp_321612") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_tmp_321611,
                                  "mem_param_tmp_321611") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320422, "ext_mem_320422") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318860, "mem_param_318860") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318852, "mem_param_318852") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320111, "ext_mem_320111") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320112, "ext_mem_320112") != 0)
            return 1;
    }
    ext_320445 = ctx_param_ext_318824;
    ext_320443 = ctx_param_ext_318826;
    ext_320439 = ctx_param_ext_318831;
    ext_320438 = ctx_param_ext_318832;
    ext_320437 = ctx_param_ext_318833;
    ext_320436 = ctx_param_ext_318834;
    ext_320435 = ctx_param_ext_318835;
    ext_320434 = ctx_param_ext_318836;
    ext_320433 = ctx_param_ext_318837;
    if (memblock_set_device(ctx, &ext_mem_320432, &mem_param_318822,
                            "mem_param_318822") != 0)
        return 1;
    if (memblock_set_device(ctx, &ext_mem_320431, &mem_param_318830,
                            "mem_param_318830") != 0)
        return 1;
    if (memblock_set_device(ctx, &ext_mem_320430, &mem_param_318838,
                            "mem_param_318838") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") != 0)
        return 1;
    
    struct memblock_device mem_320457;
    
    mem_320457.references = NULL;
    if (memblock_alloc_device(ctx, &mem_320457, bytes_318505, "mem_320457")) {
        err = 1;
        goto cleanup;
    }
    if (futrts_builtinzhreplicate_f32(ctx, mem_320457, m_292674 * n_292675,
                                      NAN) != 0) {
        if (memblock_unref_device(ctx, &mem_320457, "mem_320457") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318838, "mem_param_318838") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318830, "mem_param_318830") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318822, "mem_param_318822") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320430, "ext_mem_320430") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320431, "ext_mem_320431") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320432, "ext_mem_320432") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319555, "mem_319555") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319538, "mem_319538") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319521, "mem_319521") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319504, "mem_319504") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318876, "mem_318876") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318871, "mem_318871") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318865, "mem_318865") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    struct memblock_device mem_320461;
    
    mem_320461.references = NULL;
    if (memblock_alloc_device(ctx, &mem_320461, bytes_318505, "mem_320461")) {
        err = 1;
        goto cleanup;
    }
    if (futrts_builtinzhreplicate_f32(ctx, mem_320461, m_292674 * n_292675,
                                      NAN) != 0) {
        if (memblock_unref_device(ctx, &mem_320461, "mem_320461") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_320457, "mem_320457") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318838, "mem_param_318838") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318830, "mem_param_318830") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318822, "mem_param_318822") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320430, "ext_mem_320430") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320431, "ext_mem_320431") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320432, "ext_mem_320432") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319555, "mem_319555") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319538, "mem_319538") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319521, "mem_319521") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319504, "mem_319504") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318876, "mem_318876") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318871, "mem_318871") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318865, "mem_318865") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    struct memblock_device mem_320465;
    
    mem_320465.references = NULL;
    if (memblock_alloc_device(ctx, &mem_320465, bytes_318505, "mem_320465")) {
        err = 1;
        goto cleanup;
    }
    if (futrts_builtinzhreplicate_f32(ctx, mem_320465, m_292674 * n_292675,
                                      NAN) != 0) {
        if (memblock_unref_device(ctx, &mem_320465, "mem_320465") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_320461, "mem_320461") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_320457, "mem_320457") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318838, "mem_param_318838") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318830, "mem_param_318830") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318822, "mem_param_318822") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320430, "ext_mem_320430") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320431, "ext_mem_320431") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320432, "ext_mem_320432") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319555, "mem_319555") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319538, "mem_319538") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319521, "mem_319521") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319504, "mem_319504") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318876, "mem_318876") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318871, "mem_318871") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318865, "mem_318865") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t segmap_group_sizze_317507;
    
    segmap_group_sizze_317507 =
        *ctx->tuning_params.mainzisegmap_group_sizze_317506;
    
    int64_t num_groups_317509;
    int32_t max_num_groups_325754;
    
    max_num_groups_325754 = *ctx->tuning_params.mainzisegmap_num_groups_317508;
    num_groups_317509 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(partition_sizze_292766,
                                                             segmap_group_sizze_317507),
                                                   sext_i32_i64(max_num_groups_325754))));
    
    struct memblock_device mem_320468;
    
    mem_320468.references = NULL;
    if (memblock_alloc_device(ctx, &mem_320468, binop_y_318521, "mem_320468")) {
        err = 1;
        goto cleanup;
    }
    if (futrts_builtinzhgpu_map_transpose_f64(ctx, mem_320468, (int64_t) 0,
                                              ext_mem_320432, (int64_t) 0,
                                              (int64_t) 1, n_292675,
                                              partition_sizze_292766) != 0) {
        if (memblock_unref_device(ctx, &mem_320468, "mem_320468") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_320465, "mem_320465") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_320461, "mem_320461") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_320457, "mem_320457") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318838, "mem_param_318838") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318830, "mem_param_318830") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318822, "mem_param_318822") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320430, "ext_mem_320430") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320431, "ext_mem_320431") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320432, "ext_mem_320432") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319555, "mem_319555") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319538, "mem_319538") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319521, "mem_319521") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319504, "mem_319504") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318876, "mem_318876") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318871, "mem_318871") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318865, "mem_318865") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    if (memblock_unref_device(ctx, &ext_mem_320432, "ext_mem_320432") != 0)
        return 1;
    
    struct memblock_device mem_320471;
    
    mem_320471.references = NULL;
    if (memblock_alloc_device(ctx, &mem_320471, binop_y_318521, "mem_320471")) {
        err = 1;
        goto cleanup;
    }
    if (futrts_builtinzhgpu_map_transpose_f64(ctx, mem_320471, (int64_t) 0,
                                              ext_mem_320431, (int64_t) 0,
                                              (int64_t) 1, n_292675,
                                              partition_sizze_292766) != 0) {
        if (memblock_unref_device(ctx, &mem_320471, "mem_320471") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_320468, "mem_320468") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_320465, "mem_320465") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_320461, "mem_320461") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_320457, "mem_320457") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318838, "mem_param_318838") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318830, "mem_param_318830") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &mem_param_318822, "mem_param_318822") !=
            0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320430, "ext_mem_320430") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320431, "ext_mem_320431") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_320432, "ext_mem_320432") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319555, "mem_319555") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319538, "mem_319538") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319521, "mem_319521") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_319504, "mem_319504") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318876, "mem_318876") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318871, "mem_318871") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318865, "mem_318865") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
            return 1;
        if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    if (memblock_unref_device(ctx, &ext_mem_320431, "ext_mem_320431") != 0)
        return 1;
    
    int64_t binop_y_320473 = (int64_t) 4 * n_292675;
    int64_t bytes_320474 = smax64((int64_t) 0, binop_y_320473);
    int64_t num_threads_320819 = segmap_group_sizze_317507 * num_groups_317509;
    int64_t total_sizze_320820 = bytes_320474 * num_threads_320819;
    struct memblock_device color_320672;
    
    color_320672.references = NULL;
    if (memblock_alloc_device(ctx, &color_320672, total_sizze_320820,
                              "color_320672")) {
        err = 1;
        goto cleanup;
    }
    
    int64_t total_sizze_320821 = bytes_320474 * num_threads_320819;
    struct memblock_device color_320673;
    
    color_320673.references = NULL;
    if (memblock_alloc_device(ctx, &color_320673, total_sizze_320821,
                              "color_320673")) {
        err = 1;
        goto cleanup;
    }
    
    int64_t total_sizze_320822 = bytes_320474 * num_threads_320819;
    struct memblock_device color_320674;
    
    color_320674.references = NULL;
    if (memblock_alloc_device(ctx, &color_320674, total_sizze_320822,
                              "color_320674")) {
        err = 1;
        goto cleanup;
    }
    if (ctx->debugging)
        fprintf(ctx->log, "%s\n", "\n# SegMap");
    
    CUdeviceptr kernel_arg_327907 = mem_318506.mem;
    CUdeviceptr kernel_arg_327908 = mem_318509.mem;
    CUdeviceptr kernel_arg_327909 = mem_320457.mem;
    CUdeviceptr kernel_arg_327910 = mem_320461.mem;
    CUdeviceptr kernel_arg_327911 = mem_320465.mem;
    CUdeviceptr kernel_arg_327912 = mem_320468.mem;
    CUdeviceptr kernel_arg_327913 = mem_320471.mem;
    CUdeviceptr kernel_arg_327914 = color_320672.mem;
    CUdeviceptr kernel_arg_327915 = color_320673.mem;
    CUdeviceptr kernel_arg_327916 = color_320674.mem;
    
    if ((((((1 && num_groups_317509 != 0) && 1 != 0) && 1 != 0) &&
          segmap_group_sizze_317507 != 0) && 1 != 0) && 1 != 0) {
        int perm[3] = {0, 1, 2};
        
        if (1 >= 1 << 16) {
            perm[1] = perm[0];
            perm[0] = 1;
        }
        if (1 >= 1 << 16) {
            perm[2] = perm[0];
            perm[0] = 2;
        }
        
        size_t grid[3];
        
        grid[perm[0]] = num_groups_317509;
        grid[perm[1]] = 1;
        grid[perm[2]] = 1;
        
        void *kernel_args_327904[] = {&ctx->global_failure, &m_292674,
                                      &n_292675, &partition_sizze_292766,
                                      &num_groups_317509, &num_threads_320819,
                                      &kernel_arg_327907, &kernel_arg_327908,
                                      &kernel_arg_327909, &kernel_arg_327910,
                                      &kernel_arg_327911, &kernel_arg_327912,
                                      &kernel_arg_327913, &kernel_arg_327914,
                                      &kernel_arg_327915, &kernel_arg_327916};
        int64_t time_start_327905 = 0, time_end_327906 = 0;
        
        if (ctx->debugging) {
            fprintf(ctx->log,
                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                    "main.segmap_317504", (long) num_groups_317509, (long) 1,
                    (long) 1, (long) segmap_group_sizze_317507, (long) 1,
                    (long) 1, (int) 0);
            time_start_327905 = get_wall_time();
        }
        
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda,
                                      &ctx->mainzisegmap_317504_runs,
                                      &ctx->mainzisegmap_317504_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->mainzisegmap_317504, grid[0],
                                              grid[1], grid[2],
                                              segmap_group_sizze_317507, 1, 1,
                                              0, NULL, kernel_args_327904,
                                              NULL));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
        if (ctx->debugging) {
            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
            time_end_327906 = get_wall_time();
            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                    "main.segmap_317504", time_end_327906 - time_start_327905);
        }
    }
    if (ctx->debugging)
        fprintf(ctx->log, "%s\n", "");
    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_320468, "mem_320468") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_320471, "mem_320471") != 0)
        return 1;
    if (memblock_unref_device(ctx, &color_320672, "color_320672") != 0)
        return 1;
    if (memblock_unref_device(ctx, &color_320673, "color_320673") != 0)
        return 1;
    if (memblock_unref_device(ctx, &color_320674, "color_320674") != 0)
        return 1;
    if (memblock_set_device(ctx, &mem_out_320823, &mem_320457, "mem_320457") !=
        0)
        return 1;
    if (memblock_set_device(ctx, &mem_out_320824, &mem_320461, "mem_320461") !=
        0)
        return 1;
    if (memblock_set_device(ctx, &mem_out_320825, &mem_320465, "mem_320465") !=
        0)
        return 1;
    (*mem_out_p_325879).references = NULL;
    if (memblock_set_device(ctx, &*mem_out_p_325879, &mem_out_320823,
                            "mem_out_320823") != 0)
        return 1;
    (*mem_out_p_325880).references = NULL;
    if (memblock_set_device(ctx, &*mem_out_p_325880, &mem_out_320824,
                            "mem_out_320824") != 0)
        return 1;
    (*mem_out_p_325881).references = NULL;
    if (memblock_set_device(ctx, &*mem_out_p_325881, &mem_out_320825,
                            "mem_out_320825") != 0)
        return 1;
    if (memblock_unref_device(ctx, &color_320674, "color_320674") != 0)
        return 1;
    if (memblock_unref_device(ctx, &color_320673, "color_320673") != 0)
        return 1;
    if (memblock_unref_device(ctx, &color_320672, "color_320672") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_320471, "mem_320471") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_320468, "mem_320468") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_320465, "mem_320465") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_320461, "mem_320461") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_320457, "mem_320457") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_param_318838, "mem_param_318838") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_param_318830, "mem_param_318830") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_param_318822, "mem_param_318822") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_320430, "ext_mem_320430") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_320431, "ext_mem_320431") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_320432, "ext_mem_320432") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_319555, "mem_319555") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_319538, "mem_319538") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_319521, "mem_319521") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_319504, "mem_319504") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318876, "mem_318876") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318871, "mem_318871") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318865, "mem_318865") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318814, "mem_318814") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318810, "mem_318810") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318805, "ext_mem_318805") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318806, "ext_mem_318806") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318756, "ext_mem_318756") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318757, "ext_mem_318757") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318707, "ext_mem_318707") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318708, "ext_mem_318708") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318609, "ext_mem_318609") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318610, "ext_mem_318610") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318551, "mem_318551") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318545, "mem_318545") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318541, "ext_mem_318541") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318542, "ext_mem_318542") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318509, "mem_318509") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318506, "mem_318506") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318502, "mem_318502") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318500, "mem_318500") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_out_320825, "mem_out_320825") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_out_320824, "mem_out_320824") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
        return 1;
    
  cleanup:
    { }
    return err;
}
static int futrts_entry_seasonal_amplitude(struct futhark_context *ctx,
                                           struct memblock_device *mem_out_p_327917,
                                           struct memblock_device seasonal_l_mem_318490,
                                           int64_t m_292609, int64_t n_292610)
{
    (void) ctx;
    
    int err = 0;
    struct memblock_device mem_out_320823;
    
    mem_out_320823.references = NULL;
    
    bool suff_outer_par_297383;
    
    suff_outer_par_297383 =
        *ctx->tuning_params.seasonal_amplitudezisuff_outer_par_0 <= m_292609;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n",
                "seasonal_amplitude.suff_outer_par_0", (long) m_292609,
                suff_outer_par_297383 ? "true" : "false");
    
    int64_t segmap_group_sizze_297406;
    
    segmap_group_sizze_297406 =
        *ctx->tuning_params.seasonal_amplitudezisegmap_group_sizze_297387;
    
    int64_t nest_sizze_297461 = m_292609 * n_292610;
    int64_t segred_group_sizze_297462;
    
    segred_group_sizze_297462 =
        *ctx->tuning_params.seasonal_amplitudezisegred_group_sizze_297442;
    
    int64_t num_groups_297463;
    int32_t max_num_groups_320824;
    
    max_num_groups_320824 =
        *ctx->tuning_params.seasonal_amplitudezisegred_num_groups_297444;
    num_groups_297463 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(nest_sizze_297461,
                                                             segred_group_sizze_297462),
                                                   sext_i32_i64(max_num_groups_320824))));
    
    int64_t segmap_group_sizze_297479;
    
    segmap_group_sizze_297479 =
        *ctx->tuning_params.seasonal_amplitudezisegmap_group_sizze_297429;
    
    int64_t bytes_318492 = (int64_t) 4 * nest_sizze_297461;
    int64_t binop_y_318495 = (int64_t) 4 * m_292609;
    int64_t bytes_318496 = smax64((int64_t) 0, binop_y_318495);
    struct memblock_device ext_mem_318509;
    
    ext_mem_318509.references = NULL;
    
    int32_t local_memory_capacity_320925;
    
    local_memory_capacity_320925 = ctx->cuda.max_shared_memory;
    if (sle64((int64_t) 0, sext_i32_i64(local_memory_capacity_320925)) &&
        suff_outer_par_297383) {
        int64_t segmap_usable_groups_297407 = sdiv_up64(m_292609,
                                                        segmap_group_sizze_297406);
        struct memblock_device mem_318493;
        
        mem_318493.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318493, bytes_318492,
                                  "mem_318493")) {
            err = 1;
            goto cleanup;
        }
        if (futrts_builtinzhgpu_map_transpose_f32(ctx, mem_318493, (int64_t) 0,
                                                  seasonal_l_mem_318490,
                                                  (int64_t) 0, (int64_t) 1,
                                                  n_292610, m_292609) != 0) {
            if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_318509, "ext_mem_318509") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") !=
                0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318497;
        
        mem_318497.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318497, bytes_318496,
                                  "mem_318497")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        CUdeviceptr kernel_arg_327921 = mem_318493.mem;
        CUdeviceptr kernel_arg_327922 = mem_318497.mem;
        
        if ((((((1 && segmap_usable_groups_297407 != 0) && 1 != 0) && 1 != 0) &&
              segmap_group_sizze_297406 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = segmap_usable_groups_297407;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_327918[] = {&ctx->global_failure, &m_292609,
                                          &n_292610, &kernel_arg_327921,
                                          &kernel_arg_327922};
            int64_t time_start_327919 = 0, time_end_327920 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "seasonal_amplitude.segmap_297410",
                        (long) segmap_usable_groups_297407, (long) 1, (long) 1,
                        (long) segmap_group_sizze_297406, (long) 1, (long) 1,
                        (int) 0);
                time_start_327919 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->seasonal_amplitudezisegmap_297410_runs,
                                          &ctx->seasonal_amplitudezisegmap_297410_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->seasonal_amplitudezisegmap_297410,
                                                  grid[0], grid[1], grid[2],
                                                  segmap_group_sizze_297406, 1,
                                                  1, 0, NULL,
                                                  kernel_args_327918, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_327920 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "seasonal_amplitude.segmap_297410", time_end_327920 -
                        time_start_327919);
            }
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318509, &mem_318497,
                                "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318497, "mem_318497") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
            return 1;
    } else {
        struct memblock_device mem_318501;
        
        mem_318501.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318501, bytes_318496,
                                  "mem_318501")) {
            err = 1;
            goto cleanup;
        }
        
        struct memblock_device mem_318504;
        
        mem_318504.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318504, bytes_318496,
                                  "mem_318504")) {
            err = 1;
            goto cleanup;
        }
        if (slt64(n_292610 * (int64_t) 2, segred_group_sizze_297462)) {
            int64_t segment_sizze_nonzzero_320835 = smax64((int64_t) 1,
                                                           n_292610);
            int64_t num_threads_320836 = num_groups_297463 *
                    segred_group_sizze_297462;
            
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegRed-small");
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                        (long long) m_292609, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                        (long long) n_292610, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "segments_per_group",
                        (long long) squot64(segred_group_sizze_297462,
                                            segment_sizze_nonzzero_320835),
                        '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "required_groups",
                        (long long) sext_i64_i32(sdiv_up64(m_292609,
                                                           squot64(segred_group_sizze_297462,
                                                                   segment_sizze_nonzzero_320835))),
                        '\n');
            
            unsigned int shared_sizze_327926 = (int64_t) 4 *
                         segred_group_sizze_297462;
            unsigned int shared_sizze_327928 = (int64_t) 4 *
                         segred_group_sizze_297462;
            CUdeviceptr kernel_arg_327930 = seasonal_l_mem_318490.mem;
            CUdeviceptr kernel_arg_327931 = mem_318501.mem;
            CUdeviceptr kernel_arg_327932 = mem_318504.mem;
            unsigned int shared_offset_327927 = 0;
            unsigned int shared_offset_327929 = 0 + (shared_sizze_327926 + (8 -
                                                                            shared_sizze_327926 %
                                                                            8) %
                                                     8);
            
            if ((((((1 && num_groups_297463 != 0) && 1 != 0) && 1 != 0) &&
                  segred_group_sizze_297462 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = num_groups_297463;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_327923[] = {&ctx->global_failure,
                                              &shared_offset_327927,
                                              &shared_offset_327929, &m_292609,
                                              &n_292610, &num_groups_297463,
                                              &segment_sizze_nonzzero_320835,
                                              &kernel_arg_327930,
                                              &kernel_arg_327931,
                                              &kernel_arg_327932};
                int64_t time_start_327924 = 0, time_end_327925 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "seasonal_amplitude.segred_small_297469",
                            (long) num_groups_297463, (long) 1, (long) 1,
                            (long) segred_group_sizze_297462, (long) 1,
                            (long) 1, (int) (0 + (shared_sizze_327926 + (8 -
                                                                         shared_sizze_327926 %
                                                                         8) %
                                                  8) + (shared_sizze_327928 +
                                                        (8 -
                                                         shared_sizze_327928 %
                                                         8) % 8)));
                    time_start_327924 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->seasonal_amplitudezisegred_small_297469_runs,
                                              &ctx->seasonal_amplitudezisegred_small_297469_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->seasonal_amplitudezisegred_small_297469,
                                                      grid[0], grid[1], grid[2],
                                                      segred_group_sizze_297462,
                                                      1, 1, 0 +
                                                      (shared_sizze_327926 +
                                                       (8 -
                                                        shared_sizze_327926 %
                                                        8) % 8) +
                                                      (shared_sizze_327928 +
                                                       (8 -
                                                        shared_sizze_327928 %
                                                        8) % 8), NULL,
                                                      kernel_args_327923,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_327925 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "seasonal_amplitude.segred_small_297469",
                            time_end_327925 - time_start_327924);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
        } else {
            int64_t groups_per_segment_320868 = sdiv_up64(num_groups_297463,
                                                          smax64((int64_t) 1,
                                                                 m_292609));
            int64_t elements_per_thread_320869 = sdiv_up64(n_292610,
                                                           segred_group_sizze_297462 *
                                                           groups_per_segment_320868);
            int64_t virt_num_groups_320870 = groups_per_segment_320868 *
                    m_292609;
            int64_t num_threads_320871 = num_groups_297463 *
                    segred_group_sizze_297462;
            int64_t threads_per_segment_320872 = groups_per_segment_320868 *
                    segred_group_sizze_297462;
            
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegRed-large");
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                        (long long) m_292609, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                        (long long) n_292610, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "virt_num_groups",
                        (long long) virt_num_groups_320870, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "num_groups",
                        (long long) num_groups_297463, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "group_size",
                        (long long) segred_group_sizze_297462, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "elems_per_thread",
                        (long long) elements_per_thread_320869, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "groups_per_segment",
                        (long long) groups_per_segment_320868, '\n');
            
            struct memblock_device segred_tmp_mem_320873;
            
            segred_tmp_mem_320873.references = NULL;
            if (memblock_alloc_device(ctx, &segred_tmp_mem_320873, (int64_t) 4 *
                                      virt_num_groups_320870,
                                      "segred_tmp_mem_320873")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device segred_tmp_mem_320875;
            
            segred_tmp_mem_320875.references = NULL;
            if (memblock_alloc_device(ctx, &segred_tmp_mem_320875, (int64_t) 4 *
                                      virt_num_groups_320870,
                                      "segred_tmp_mem_320875")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device seasonal_amplitudezicounter_mem_320877 =
                                   ctx->seasonal_amplitudezicounter_mem_320877;
            unsigned int shared_sizze_327937 = 1;
            unsigned int shared_sizze_327939 = (int64_t) 4 *
                         segred_group_sizze_297462;
            unsigned int shared_sizze_327941 = (int64_t) 4 *
                         segred_group_sizze_297462;
            CUdeviceptr kernel_arg_327943 = seasonal_l_mem_318490.mem;
            CUdeviceptr kernel_arg_327944 = mem_318501.mem;
            CUdeviceptr kernel_arg_327945 = mem_318504.mem;
            CUdeviceptr kernel_arg_327946 = segred_tmp_mem_320873.mem;
            CUdeviceptr kernel_arg_327947 = segred_tmp_mem_320875.mem;
            CUdeviceptr kernel_arg_327948 =
                        seasonal_amplitudezicounter_mem_320877.mem;
            unsigned int shared_offset_327938 = 0;
            unsigned int shared_offset_327940 = 0 + (shared_sizze_327937 + (8 -
                                                                            shared_sizze_327937 %
                                                                            8) %
                                                     8);
            unsigned int shared_offset_327942 = 0 + (shared_sizze_327937 + (8 -
                                                                            shared_sizze_327937 %
                                                                            8) %
                                                     8) + (shared_sizze_327939 +
                                                           (8 -
                                                            shared_sizze_327939 %
                                                            8) % 8);
            
            if ((((((1 && num_groups_297463 != 0) && 1 != 0) && 1 != 0) &&
                  segred_group_sizze_297462 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = num_groups_297463;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_327934[] = {&ctx->global_failure,
                                              &shared_offset_327938,
                                              &shared_offset_327940,
                                              &shared_offset_327942, &m_292609,
                                              &n_292610, &num_groups_297463,
                                              &groups_per_segment_320868,
                                              &elements_per_thread_320869,
                                              &virt_num_groups_320870,
                                              &threads_per_segment_320872,
                                              &kernel_arg_327943,
                                              &kernel_arg_327944,
                                              &kernel_arg_327945,
                                              &kernel_arg_327946,
                                              &kernel_arg_327947,
                                              &kernel_arg_327948};
                int64_t time_start_327935 = 0, time_end_327936 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "seasonal_amplitude.segred_large_297469",
                            (long) num_groups_297463, (long) 1, (long) 1,
                            (long) segred_group_sizze_297462, (long) 1,
                            (long) 1, (int) (0 + (shared_sizze_327937 + (8 -
                                                                         shared_sizze_327937 %
                                                                         8) %
                                                  8) + (shared_sizze_327939 +
                                                        (8 -
                                                         shared_sizze_327939 %
                                                         8) % 8) +
                                             (shared_sizze_327941 + (8 -
                                                                     shared_sizze_327941 %
                                                                     8) % 8)));
                    time_start_327935 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->seasonal_amplitudezisegred_large_297469_runs,
                                              &ctx->seasonal_amplitudezisegred_large_297469_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->seasonal_amplitudezisegred_large_297469,
                                                      grid[0], grid[1], grid[2],
                                                      segred_group_sizze_297462,
                                                      1, 1, 0 +
                                                      (shared_sizze_327937 +
                                                       (8 -
                                                        shared_sizze_327937 %
                                                        8) % 8) +
                                                      (shared_sizze_327939 +
                                                       (8 -
                                                        shared_sizze_327939 %
                                                        8) % 8) +
                                                      (shared_sizze_327941 +
                                                       (8 -
                                                        shared_sizze_327941 %
                                                        8) % 8), NULL,
                                                      kernel_args_327934,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_327936 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "seasonal_amplitude.segred_large_297469",
                            time_end_327936 - time_start_327935);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            if (memblock_unref_device(ctx, &segred_tmp_mem_320875,
                                      "segred_tmp_mem_320875") != 0)
                return 1;
            if (memblock_unref_device(ctx, &segred_tmp_mem_320873,
                                      "segred_tmp_mem_320873") != 0)
                return 1;
        }
        
        int64_t segmap_usable_groups_297480 = sdiv_up64(m_292609,
                                                        segmap_group_sizze_297479);
        struct memblock_device mem_318508;
        
        mem_318508.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318508, bytes_318496,
                                  "mem_318508")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        CUdeviceptr kernel_arg_327952 = mem_318501.mem;
        CUdeviceptr kernel_arg_327953 = mem_318504.mem;
        CUdeviceptr kernel_arg_327954 = mem_318508.mem;
        
        if ((((((1 && segmap_usable_groups_297480 != 0) && 1 != 0) && 1 != 0) &&
              segmap_group_sizze_297479 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = segmap_usable_groups_297480;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_327949[] = {&ctx->global_failure, &m_292609,
                                          &kernel_arg_327952,
                                          &kernel_arg_327953,
                                          &kernel_arg_327954};
            int64_t time_start_327950 = 0, time_end_327951 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "seasonal_amplitude.segmap_297483",
                        (long) segmap_usable_groups_297480, (long) 1, (long) 1,
                        (long) segmap_group_sizze_297479, (long) 1, (long) 1,
                        (int) 0);
                time_start_327950 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->seasonal_amplitudezisegmap_297483_runs,
                                          &ctx->seasonal_amplitudezisegmap_297483_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->seasonal_amplitudezisegmap_297483,
                                                  grid[0], grid[1], grid[2],
                                                  segmap_group_sizze_297479, 1,
                                                  1, 0, NULL,
                                                  kernel_args_327949, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_327951 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "seasonal_amplitude.segmap_297483", time_end_327951 -
                        time_start_327950);
            }
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        if (memblock_unref_device(ctx, &mem_318501, "mem_318501") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318504, "mem_318504") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318509, &mem_318508,
                                "mem_318508") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318508, "mem_318508") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318504, "mem_318504") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318501, "mem_318501") != 0)
            return 1;
    }
    if (memblock_set_device(ctx, &mem_out_320823, &ext_mem_318509,
                            "ext_mem_318509") != 0)
        return 1;
    (*mem_out_p_327917).references = NULL;
    if (memblock_set_device(ctx, &*mem_out_p_327917, &mem_out_320823,
                            "mem_out_320823") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318509, "ext_mem_318509") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
        return 1;
    
  cleanup:
    { }
    return err;
}
static int futrts_entry_trend_magnitude(struct futhark_context *ctx,
                                        struct memblock_device *mem_out_p_327955,
                                        struct memblock_device trend_l_mem_318490,
                                        int64_t m_292626, int64_t n_292627)
{
    (void) ctx;
    
    int err = 0;
    struct memblock_device mem_out_320823;
    
    mem_out_320823.references = NULL;
    
    int64_t segred_group_sizze_297492;
    
    segred_group_sizze_297492 =
        *ctx->tuning_params.trend_magnitudezisegred_group_sizze_297491;
    
    int64_t num_groups_297494;
    int32_t max_num_groups_320824;
    
    max_num_groups_320824 =
        *ctx->tuning_params.trend_magnitudezisegred_num_groups_297493;
    num_groups_297494 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(n_292627,
                                                             segred_group_sizze_297492),
                                                   sext_i32_i64(max_num_groups_320824))));
    
    struct memblock_device mem_318493;
    
    mem_318493.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318493, (int64_t) 8, "mem_318493")) {
        err = 1;
        goto cleanup;
    }
    
    struct memblock_device mem_318495;
    
    mem_318495.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318495, (int64_t) 8, "mem_318495")) {
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_y_318496 = (int64_t) 8 * n_292627;
    int64_t bytes_318497 = smax64((int64_t) 0, binop_y_318496);
    struct memblock_device mem_318498;
    
    mem_318498.references = NULL;
    if (memblock_alloc_device(ctx, &mem_318498, bytes_318497, "mem_318498")) {
        err = 1;
        goto cleanup;
    }
    
    struct memblock_device trend_magnitudezicounter_mem_320825 =
                           ctx->trend_magnitudezicounter_mem_320825;
    struct memblock_device segred_tmp_mem_320827;
    
    segred_tmp_mem_320827.references = NULL;
    if (memblock_alloc_device(ctx, &segred_tmp_mem_320827, (int64_t) 8 *
                              num_groups_297494, "segred_tmp_mem_320827")) {
        err = 1;
        goto cleanup;
    }
    
    struct memblock_device segred_tmp_mem_320829;
    
    segred_tmp_mem_320829.references = NULL;
    if (memblock_alloc_device(ctx, &segred_tmp_mem_320829, (int64_t) 8 *
                              num_groups_297494, "segred_tmp_mem_320829")) {
        err = 1;
        goto cleanup;
    }
    
    int64_t num_threads_320831 = num_groups_297494 * segred_group_sizze_297492;
    
    if (ctx->debugging)
        fprintf(ctx->log, "%s\n", "\n# SegRed");
    
    unsigned int shared_sizze_327960 = (int64_t) 8 * segred_group_sizze_297492;
    unsigned int shared_sizze_327962 = (int64_t) 8 * segred_group_sizze_297492;
    unsigned int shared_sizze_327964 = 1;
    CUdeviceptr kernel_arg_327966 = mem_318493.mem;
    CUdeviceptr kernel_arg_327967 = mem_318495.mem;
    CUdeviceptr kernel_arg_327968 = mem_318498.mem;
    CUdeviceptr kernel_arg_327969 = trend_magnitudezicounter_mem_320825.mem;
    CUdeviceptr kernel_arg_327970 = segred_tmp_mem_320827.mem;
    CUdeviceptr kernel_arg_327971 = segred_tmp_mem_320829.mem;
    unsigned int shared_offset_327961 = 0;
    unsigned int shared_offset_327963 = 0 + (shared_sizze_327960 + (8 -
                                                                    shared_sizze_327960 %
                                                                    8) % 8);
    unsigned int shared_offset_327965 = 0 + (shared_sizze_327960 + (8 -
                                                                    shared_sizze_327960 %
                                                                    8) % 8) +
                 (shared_sizze_327962 + (8 - shared_sizze_327962 % 8) % 8);
    
    if ((((((1 && num_groups_297494 != 0) && 1 != 0) && 1 != 0) &&
          segred_group_sizze_297492 != 0) && 1 != 0) && 1 != 0) {
        int perm[3] = {0, 1, 2};
        
        if (1 >= 1 << 16) {
            perm[1] = perm[0];
            perm[0] = 1;
        }
        if (1 >= 1 << 16) {
            perm[2] = perm[0];
            perm[0] = 2;
        }
        
        size_t grid[3];
        
        grid[perm[0]] = num_groups_297494;
        grid[perm[1]] = 1;
        grid[perm[2]] = 1;
        
        void *kernel_args_327957[] = {&ctx->global_failure,
                                      &shared_offset_327961,
                                      &shared_offset_327963,
                                      &shared_offset_327965, &n_292627,
                                      &num_groups_297494, &num_threads_320831,
                                      &kernel_arg_327966, &kernel_arg_327967,
                                      &kernel_arg_327968, &kernel_arg_327969,
                                      &kernel_arg_327970, &kernel_arg_327971};
        int64_t time_start_327958 = 0, time_end_327959 = 0;
        
        if (ctx->debugging) {
            fprintf(ctx->log,
                    "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                    "trend_magnitude.segred_nonseg_297501",
                    (long) num_groups_297494, (long) 1, (long) 1,
                    (long) segred_group_sizze_297492, (long) 1, (long) 1,
                    (int) (0 + (shared_sizze_327960 + (8 - shared_sizze_327960 %
                                                       8) % 8) +
                           (shared_sizze_327962 + (8 - shared_sizze_327962 %
                                                   8) % 8) +
                           (shared_sizze_327964 + (8 - shared_sizze_327964 %
                                                   8) % 8)));
            time_start_327958 = get_wall_time();
        }
        
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda,
                                      &ctx->trend_magnitudezisegred_nonseg_297501_runs,
                                      &ctx->trend_magnitudezisegred_nonseg_297501_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->trend_magnitudezisegred_nonseg_297501,
                                              grid[0], grid[1], grid[2],
                                              segred_group_sizze_297492, 1, 1,
                                              0 + (shared_sizze_327960 + (8 -
                                                                          shared_sizze_327960 %
                                                                          8) %
                                                   8) + (shared_sizze_327962 +
                                                         (8 -
                                                          shared_sizze_327962 %
                                                          8) % 8) +
                                              (shared_sizze_327964 + (8 -
                                                                      shared_sizze_327964 %
                                                                      8) % 8),
                                              NULL, kernel_args_327957, NULL));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
        if (ctx->debugging) {
            CUDA_SUCCEED_FATAL(cuCtxSynchronize());
            time_end_327959 = get_wall_time();
            fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                    "trend_magnitude.segred_nonseg_297501", time_end_327959 -
                    time_start_327958);
        }
    }
    if (ctx->debugging)
        fprintf(ctx->log, "%s\n", "");
    
    double defunc_2_reduce_res_292636;
    double read_res_327972;
    
    {
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda,
                                      &ctx->copy_scalar_from_dev_runs,
                                      &ctx->copy_scalar_from_dev_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuMemcpyDtoH(&read_res_327972, mem_318493.mem +
                                            (int64_t) 0 * sizeof(double),
                                            sizeof(double)));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
    }
    if (futhark_context_sync(ctx) != 0)
        return 1;
    defunc_2_reduce_res_292636 = read_res_327972;
    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
        return 1;
    
    double defunc_2_reduce_res_292637;
    double read_res_327973;
    
    {
        cudaEvent_t *pevents = NULL;
        
        if (ctx->profiling && !ctx->profiling_paused) {
            pevents = cuda_get_events(&ctx->cuda,
                                      &ctx->copy_scalar_from_dev_runs,
                                      &ctx->copy_scalar_from_dev_total_runtime);
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
        }
        CUDA_SUCCEED_OR_RETURN(cuMemcpyDtoH(&read_res_327973, mem_318495.mem +
                                            (int64_t) 0 * sizeof(double),
                                            sizeof(double)));
        if (pevents != NULL)
            CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
    }
    if (futhark_context_sync(ctx) != 0)
        return 1;
    defunc_2_reduce_res_292637 = read_res_327973;
    if (memblock_unref_device(ctx, &mem_318495, "mem_318495") != 0)
        return 1;
    
    double i64_res_292652 = sitofp_i64_f64(n_292627);
    double x_292653 = defunc_2_reduce_res_292637 * i64_res_292652;
    double y_292654 = defunc_2_reduce_res_292636 * defunc_2_reduce_res_292636;
    double y_292655 = x_292653 - y_292654;
    double det1_292656 = 1.0 / y_292655;
    double x_292657 = 0.0 - defunc_2_reduce_res_292636;
    double b11_292658 = det1_292656 * x_292657;
    double c11_292659 = i64_res_292652 * det1_292656;
    bool suff_outer_par_297503;
    
    suff_outer_par_297503 =
        *ctx->tuning_params.trend_magnitudezisuff_outer_par_0 <= m_292626;
    if (ctx->logging)
        fprintf(ctx->log, "Compared %s <= %ld: %s.\n",
                "trend_magnitude.suff_outer_par_0", (long) m_292626,
                suff_outer_par_297503 ? "true" : "false");
    
    int64_t segmap_group_sizze_297526;
    
    segmap_group_sizze_297526 =
        *ctx->tuning_params.trend_magnitudezisegmap_group_sizze_297507;
    
    int64_t nest_sizze_297580 = m_292626 * n_292627;
    int64_t segred_group_sizze_297581;
    
    segred_group_sizze_297581 =
        *ctx->tuning_params.trend_magnitudezisegred_group_sizze_297559;
    
    int64_t num_groups_297582;
    int32_t max_num_groups_320863;
    
    max_num_groups_320863 =
        *ctx->tuning_params.trend_magnitudezisegred_num_groups_297561;
    num_groups_297582 = sext_i64_i32(smax64((int64_t) 1,
                                            smin64(sdiv_up64(nest_sizze_297580,
                                                             segred_group_sizze_297581),
                                                   sext_i32_i64(max_num_groups_320863))));
    
    int64_t segmap_group_sizze_297599;
    
    segmap_group_sizze_297599 =
        *ctx->tuning_params.trend_magnitudezisegmap_group_sizze_297548;
    
    int64_t bytes_318500 = (int64_t) 4 * nest_sizze_297580;
    int64_t binop_y_318526 = (int64_t) 4 * m_292626;
    int64_t bytes_318527 = smax64((int64_t) 0, binop_y_318526);
    int64_t bytes_318504 = (int64_t) 8 * segmap_group_sizze_297526;
    int64_t bytes_318509 = smax64((int64_t) 0, bytes_318504);
    int64_t bytes_318524 = (int64_t) 4 * segmap_group_sizze_297526;
    int64_t binop_y_318530 = (int64_t) 8 * m_292626;
    int64_t bytes_318531 = smax64((int64_t) 0, binop_y_318530);
    int64_t num_bytes_320570 = (int64_t) 8 * segmap_group_sizze_297526;
    struct memblock_device ext_mem_318537;
    
    ext_mem_318537.references = NULL;
    
    int32_t local_memory_capacity_320960;
    
    local_memory_capacity_320960 = ctx->cuda.max_shared_memory;
    if (sle64(bytes_318509 + srem64((int64_t) 8 - srem64(bytes_318509,
                                                         (int64_t) 8),
                                    (int64_t) 8),
              sext_i32_i64(local_memory_capacity_320960)) &&
        suff_outer_par_297503) {
        int64_t segmap_usable_groups_297527 = sdiv_up64(m_292626,
                                                        segmap_group_sizze_297526);
        struct memblock_device mem_318501;
        
        mem_318501.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318501, bytes_318500,
                                  "mem_318501")) {
            err = 1;
            goto cleanup;
        }
        if (futrts_builtinzhgpu_map_transpose_f32(ctx, mem_318501, (int64_t) 0,
                                                  trend_l_mem_318490,
                                                  (int64_t) 0, (int64_t) 1,
                                                  n_292627, m_292626) != 0) {
            if (memblock_unref_device(ctx, &mem_318501, "mem_318501") != 0)
                return 1;
            if (memblock_unref_device(ctx, &ext_mem_318537, "ext_mem_318537") !=
                0)
                return 1;
            if (memblock_unref_device(ctx, &segred_tmp_mem_320829,
                                      "segred_tmp_mem_320829") != 0)
                return 1;
            if (memblock_unref_device(ctx, &segred_tmp_mem_320827,
                                      "segred_tmp_mem_320827") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318498, "mem_318498") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318495, "mem_318495") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
                return 1;
            if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") !=
                0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t num_whole_tiles_318096 = squot64(n_292627,
                                                 segmap_group_sizze_297526);
        int64_t residual_input_318195 = srem64(n_292627,
                                               segmap_group_sizze_297526);
        bool cond_318196 = residual_input_318195 == (int64_t) 0;
        struct memblock_device mem_318528;
        
        mem_318528.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318528, bytes_318527,
                                  "mem_318528")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        int32_t num_chunks_320864 =
                sext_i64_i32(sdiv_up64(segmap_group_sizze_297526,
                                       segmap_group_sizze_297526));
        unsigned int shared_sizze_327977 = bytes_318509;
        CUdeviceptr kernel_arg_327979 = mem_318498.mem;
        CUdeviceptr kernel_arg_327980 = mem_318501.mem;
        CUdeviceptr kernel_arg_327981 = mem_318528.mem;
        unsigned int shared_offset_327978 = 0;
        
        if ((((((1 && segmap_usable_groups_297527 != 0) && 1 != 0) && 1 != 0) &&
              segmap_group_sizze_297526 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = segmap_usable_groups_297527;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_327974[] = {&ctx->global_failure,
                                          &shared_offset_327978, &m_292626,
                                          &n_292627, &i64_res_292652,
                                          &b11_292658, &c11_292659,
                                          &segmap_usable_groups_297527,
                                          &num_whole_tiles_318096,
                                          &residual_input_318195, &cond_318196,
                                          &kernel_arg_327979,
                                          &kernel_arg_327980,
                                          &kernel_arg_327981};
            int64_t time_start_327975 = 0, time_end_327976 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "trend_magnitude.segmap_intragroup_318088",
                        (long) segmap_usable_groups_297527, (long) 1, (long) 1,
                        (long) segmap_group_sizze_297526, (long) 1, (long) 1,
                        (int) (0 + (shared_sizze_327977 + (8 -
                                                           shared_sizze_327977 %
                                                           8) % 8)));
                time_start_327975 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->trend_magnitudezisegmap_intragroup_318088_runs,
                                          &ctx->trend_magnitudezisegmap_intragroup_318088_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->trend_magnitudezisegmap_intragroup_318088,
                                                  grid[0], grid[1], grid[2],
                                                  segmap_group_sizze_297526, 1,
                                                  1, 0 + (shared_sizze_327977 +
                                                          (8 -
                                                           shared_sizze_327977 %
                                                           8) % 8), NULL,
                                                  kernel_args_327974, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_327976 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "trend_magnitude.segmap_intragroup_318088",
                        time_end_327976 - time_start_327975);
            }
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        if (memblock_unref_device(ctx, &mem_318501, "mem_318501") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318537, &mem_318528,
                                "mem_318528") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318528, "mem_318528") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318501, "mem_318501") != 0)
            return 1;
    } else {
        struct memblock_device mem_318532;
        
        mem_318532.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318532, bytes_318531,
                                  "mem_318532")) {
            err = 1;
            goto cleanup;
        }
        if (slt64(n_292627 * (int64_t) 2, segred_group_sizze_297581)) {
            int64_t segment_sizze_nonzzero_320884 = smax64((int64_t) 1,
                                                           n_292627);
            int64_t num_threads_320885 = num_groups_297582 *
                    segred_group_sizze_297581;
            
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegRed-small");
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                        (long long) m_292626, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                        (long long) n_292627, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "segments_per_group",
                        (long long) squot64(segred_group_sizze_297581,
                                            segment_sizze_nonzzero_320884),
                        '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "required_groups",
                        (long long) sext_i64_i32(sdiv_up64(m_292626,
                                                           squot64(segred_group_sizze_297581,
                                                                   segment_sizze_nonzzero_320884))),
                        '\n');
            
            unsigned int shared_sizze_327985 = (int64_t) 8 *
                         segred_group_sizze_297581;
            CUdeviceptr kernel_arg_327987 = trend_l_mem_318490.mem;
            CUdeviceptr kernel_arg_327988 = mem_318498.mem;
            CUdeviceptr kernel_arg_327989 = mem_318532.mem;
            unsigned int shared_offset_327986 = 0;
            
            if ((((((1 && num_groups_297582 != 0) && 1 != 0) && 1 != 0) &&
                  segred_group_sizze_297581 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = num_groups_297582;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_327982[] = {&ctx->global_failure,
                                              &shared_offset_327986, &m_292626,
                                              &n_292627, &b11_292658,
                                              &c11_292659, &num_groups_297582,
                                              &segment_sizze_nonzzero_320884,
                                              &kernel_arg_327987,
                                              &kernel_arg_327988,
                                              &kernel_arg_327989};
                int64_t time_start_327983 = 0, time_end_327984 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "trend_magnitude.segred_small_297587",
                            (long) num_groups_297582, (long) 1, (long) 1,
                            (long) segred_group_sizze_297581, (long) 1,
                            (long) 1, (int) (0 + (shared_sizze_327985 + (8 -
                                                                         shared_sizze_327985 %
                                                                         8) %
                                                  8)));
                    time_start_327983 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->trend_magnitudezisegred_small_297587_runs,
                                              &ctx->trend_magnitudezisegred_small_297587_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->trend_magnitudezisegred_small_297587,
                                                      grid[0], grid[1], grid[2],
                                                      segred_group_sizze_297581,
                                                      1, 1, 0 +
                                                      (shared_sizze_327985 +
                                                       (8 -
                                                        shared_sizze_327985 %
                                                        8) % 8), NULL,
                                                      kernel_args_327982,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_327984 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "trend_magnitude.segred_small_297587",
                            time_end_327984 - time_start_327983);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
        } else {
            int64_t groups_per_segment_320911 = sdiv_up64(num_groups_297582,
                                                          smax64((int64_t) 1,
                                                                 m_292626));
            int64_t elements_per_thread_320912 = sdiv_up64(n_292627,
                                                           segred_group_sizze_297581 *
                                                           groups_per_segment_320911);
            int64_t virt_num_groups_320913 = groups_per_segment_320911 *
                    m_292626;
            int64_t num_threads_320914 = num_groups_297582 *
                    segred_group_sizze_297581;
            int64_t threads_per_segment_320915 = groups_per_segment_320911 *
                    segred_group_sizze_297581;
            
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "\n# SegRed-large");
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "num_segments",
                        (long long) m_292626, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "segment_size",
                        (long long) n_292627, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "virt_num_groups",
                        (long long) virt_num_groups_320913, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "num_groups",
                        (long long) num_groups_297582, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "group_size",
                        (long long) segred_group_sizze_297581, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "elems_per_thread",
                        (long long) elements_per_thread_320912, '\n');
            if (ctx->debugging)
                fprintf(ctx->log, "%s: %llu%c", "groups_per_segment",
                        (long long) groups_per_segment_320911, '\n');
            
            struct memblock_device segred_tmp_mem_320916;
            
            segred_tmp_mem_320916.references = NULL;
            if (memblock_alloc_device(ctx, &segred_tmp_mem_320916, (int64_t) 8 *
                                      virt_num_groups_320913,
                                      "segred_tmp_mem_320916")) {
                err = 1;
                goto cleanup;
            }
            
            struct memblock_device trend_magnitudezicounter_mem_320918 =
                                   ctx->trend_magnitudezicounter_mem_320918;
            unsigned int shared_sizze_327994 = 1;
            unsigned int shared_sizze_327996 = (int64_t) 8 *
                         segred_group_sizze_297581;
            CUdeviceptr kernel_arg_327998 = trend_l_mem_318490.mem;
            CUdeviceptr kernel_arg_327999 = mem_318498.mem;
            CUdeviceptr kernel_arg_328000 = mem_318532.mem;
            CUdeviceptr kernel_arg_328001 = segred_tmp_mem_320916.mem;
            CUdeviceptr kernel_arg_328002 =
                        trend_magnitudezicounter_mem_320918.mem;
            unsigned int shared_offset_327995 = 0;
            unsigned int shared_offset_327997 = 0 + (shared_sizze_327994 + (8 -
                                                                            shared_sizze_327994 %
                                                                            8) %
                                                     8);
            
            if ((((((1 && num_groups_297582 != 0) && 1 != 0) && 1 != 0) &&
                  segred_group_sizze_297581 != 0) && 1 != 0) && 1 != 0) {
                int perm[3] = {0, 1, 2};
                
                if (1 >= 1 << 16) {
                    perm[1] = perm[0];
                    perm[0] = 1;
                }
                if (1 >= 1 << 16) {
                    perm[2] = perm[0];
                    perm[0] = 2;
                }
                
                size_t grid[3];
                
                grid[perm[0]] = num_groups_297582;
                grid[perm[1]] = 1;
                grid[perm[2]] = 1;
                
                void *kernel_args_327991[] = {&ctx->global_failure,
                                              &shared_offset_327995,
                                              &shared_offset_327997, &m_292626,
                                              &n_292627, &b11_292658,
                                              &c11_292659, &num_groups_297582,
                                              &groups_per_segment_320911,
                                              &elements_per_thread_320912,
                                              &virt_num_groups_320913,
                                              &threads_per_segment_320915,
                                              &kernel_arg_327998,
                                              &kernel_arg_327999,
                                              &kernel_arg_328000,
                                              &kernel_arg_328001,
                                              &kernel_arg_328002};
                int64_t time_start_327992 = 0, time_end_327993 = 0;
                
                if (ctx->debugging) {
                    fprintf(ctx->log,
                            "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                            "trend_magnitude.segred_large_297587",
                            (long) num_groups_297582, (long) 1, (long) 1,
                            (long) segred_group_sizze_297581, (long) 1,
                            (long) 1, (int) (0 + (shared_sizze_327994 + (8 -
                                                                         shared_sizze_327994 %
                                                                         8) %
                                                  8) + (shared_sizze_327996 +
                                                        (8 -
                                                         shared_sizze_327996 %
                                                         8) % 8)));
                    time_start_327992 = get_wall_time();
                }
                
                cudaEvent_t *pevents = NULL;
                
                if (ctx->profiling && !ctx->profiling_paused) {
                    pevents = cuda_get_events(&ctx->cuda,
                                              &ctx->trend_magnitudezisegred_large_297587_runs,
                                              &ctx->trend_magnitudezisegred_large_297587_total_runtime);
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
                }
                CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->trend_magnitudezisegred_large_297587,
                                                      grid[0], grid[1], grid[2],
                                                      segred_group_sizze_297581,
                                                      1, 1, 0 +
                                                      (shared_sizze_327994 +
                                                       (8 -
                                                        shared_sizze_327994 %
                                                        8) % 8) +
                                                      (shared_sizze_327996 +
                                                       (8 -
                                                        shared_sizze_327996 %
                                                        8) % 8), NULL,
                                                      kernel_args_327991,
                                                      NULL));
                if (pevents != NULL)
                    CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
                if (ctx->debugging) {
                    CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                    time_end_327993 = get_wall_time();
                    fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                            "trend_magnitude.segred_large_297587",
                            time_end_327993 - time_start_327992);
                }
            }
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "");
            if (memblock_unref_device(ctx, &segred_tmp_mem_320916,
                                      "segred_tmp_mem_320916") != 0)
                return 1;
        }
        
        int64_t segmap_usable_groups_297600 = sdiv_up64(m_292626,
                                                        segmap_group_sizze_297599);
        struct memblock_device mem_318536;
        
        mem_318536.references = NULL;
        if (memblock_alloc_device(ctx, &mem_318536, bytes_318527,
                                  "mem_318536")) {
            err = 1;
            goto cleanup;
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "\n# SegMap");
        
        CUdeviceptr kernel_arg_328006 = mem_318532.mem;
        CUdeviceptr kernel_arg_328007 = mem_318536.mem;
        
        if ((((((1 && segmap_usable_groups_297600 != 0) && 1 != 0) && 1 != 0) &&
              segmap_group_sizze_297599 != 0) && 1 != 0) && 1 != 0) {
            int perm[3] = {0, 1, 2};
            
            if (1 >= 1 << 16) {
                perm[1] = perm[0];
                perm[0] = 1;
            }
            if (1 >= 1 << 16) {
                perm[2] = perm[0];
                perm[0] = 2;
            }
            
            size_t grid[3];
            
            grid[perm[0]] = segmap_usable_groups_297600;
            grid[perm[1]] = 1;
            grid[perm[2]] = 1;
            
            void *kernel_args_328003[] = {&ctx->global_failure, &m_292626,
                                          &i64_res_292652, &kernel_arg_328006,
                                          &kernel_arg_328007};
            int64_t time_start_328004 = 0, time_end_328005 = 0;
            
            if (ctx->debugging) {
                fprintf(ctx->log,
                        "Launching %s with grid size [%ld, %ld, %ld] and block size [%ld, %ld, %ld]; shared memory: %d bytes.\n",
                        "trend_magnitude.segmap_297603",
                        (long) segmap_usable_groups_297600, (long) 1, (long) 1,
                        (long) segmap_group_sizze_297599, (long) 1, (long) 1,
                        (int) 0);
                time_start_328004 = get_wall_time();
            }
            
            cudaEvent_t *pevents = NULL;
            
            if (ctx->profiling && !ctx->profiling_paused) {
                pevents = cuda_get_events(&ctx->cuda,
                                          &ctx->trend_magnitudezisegmap_297603_runs,
                                          &ctx->trend_magnitudezisegmap_297603_total_runtime);
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[0], 0));
            }
            CUDA_SUCCEED_OR_RETURN(cuLaunchKernel(ctx->trend_magnitudezisegmap_297603,
                                                  grid[0], grid[1], grid[2],
                                                  segmap_group_sizze_297599, 1,
                                                  1, 0, NULL,
                                                  kernel_args_328003, NULL));
            if (pevents != NULL)
                CUDA_SUCCEED_FATAL(cudaEventRecord(pevents[1], 0));
            if (ctx->debugging) {
                CUDA_SUCCEED_FATAL(cuCtxSynchronize());
                time_end_328005 = get_wall_time();
                fprintf(ctx->log, "Kernel %s runtime: %ldus\n",
                        "trend_magnitude.segmap_297603", time_end_328005 -
                        time_start_328004);
            }
        }
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "");
        if (memblock_unref_device(ctx, &mem_318532, "mem_318532") != 0)
            return 1;
        if (memblock_set_device(ctx, &ext_mem_318537, &mem_318536,
                                "mem_318536") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318536, "mem_318536") != 0)
            return 1;
        if (memblock_unref_device(ctx, &mem_318532, "mem_318532") != 0)
            return 1;
    }
    if (memblock_unref_device(ctx, &mem_318498, "mem_318498") != 0)
        return 1;
    if (memblock_set_device(ctx, &mem_out_320823, &ext_mem_318537,
                            "ext_mem_318537") != 0)
        return 1;
    (*mem_out_p_327955).references = NULL;
    if (memblock_set_device(ctx, &*mem_out_p_327955, &mem_out_320823,
                            "mem_out_320823") != 0)
        return 1;
    if (memblock_unref_device(ctx, &ext_mem_318537, "ext_mem_318537") != 0)
        return 1;
    if (memblock_unref_device(ctx, &segred_tmp_mem_320829,
                              "segred_tmp_mem_320829") != 0)
        return 1;
    if (memblock_unref_device(ctx, &segred_tmp_mem_320827,
                              "segred_tmp_mem_320827") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318498, "mem_318498") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318495, "mem_318495") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_318493, "mem_318493") != 0)
        return 1;
    if (memblock_unref_device(ctx, &mem_out_320823, "mem_out_320823") != 0)
        return 1;
    
  cleanup:
    { }
    return err;
}

int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f32_2d **out0,
                       struct futhark_f32_2d **out1,
                       struct futhark_f32_2d **out2, const
                       struct futhark_f32_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5, const int64_t in6, const int64_t in7, const
                       int64_t in8, const int64_t in9, const int64_t in10, const
                       int64_t in11, const int64_t in12, const int64_t in13,
                       const int64_t in14, const int64_t in15, const
                       int64_t in16)
{
    struct memblock_device Y_mem_318490;
    
    Y_mem_318490.references = NULL;
    
    int64_t m_292674;
    int64_t n_292675;
    int64_t n_p_292677;
    int64_t q_s_292678;
    int64_t q_t_292679;
    int64_t q_l_292680;
    int64_t d_s_292681;
    int64_t d_t_292682;
    int64_t d_l_292683;
    int64_t jump_s_292684;
    int64_t jump_t_292685;
    int64_t jump_l_292686;
    int64_t n_inner_292687;
    int64_t n_outer_292688;
    int64_t jump_threshold_1_292689;
    int64_t jump_threshold_2_292690;
    int64_t q_threshold_1_292691;
    int64_t q_threshold_2_292692;
    struct memblock_device mem_out_320823;
    
    mem_out_320823.references = NULL;
    
    struct memblock_device mem_out_320824;
    
    mem_out_320824.references = NULL;
    
    struct memblock_device mem_out_320825;
    
    mem_out_320825.references = NULL;
    
    int ret = 0;
    
    lock_lock(&ctx->lock);
    CUDA_SUCCEED_FATAL(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    Y_mem_318490 = in0->mem;
    m_292674 = in0->shape[0];
    n_292675 = in0->shape[1];
    n_p_292677 = in1;
    q_s_292678 = in2;
    q_t_292679 = in3;
    q_l_292680 = in4;
    d_s_292681 = in5;
    d_t_292682 = in6;
    d_l_292683 = in7;
    jump_s_292684 = in8;
    jump_t_292685 = in9;
    jump_l_292686 = in10;
    n_inner_292687 = in11;
    n_outer_292688 = in12;
    jump_threshold_1_292689 = in13;
    jump_threshold_2_292690 = in14;
    q_threshold_1_292691 = in15;
    q_threshold_2_292692 = in16;
    if (!(m_292674 == in0->shape[0] && n_292675 == in0->shape[1])) {
        ret = 1;
        if (!ctx->error)
            ctx->error =
                msgprintf("Error: entry point arguments have invalid sizes.\n");
    }
    if (ret == 0) {
        ret = futrts_entry_main(ctx, &mem_out_320823, &mem_out_320824,
                                &mem_out_320825, Y_mem_318490, m_292674,
                                n_292675, n_p_292677, q_s_292678, q_t_292679,
                                q_l_292680, d_s_292681, d_t_292682, d_l_292683,
                                jump_s_292684, jump_t_292685, jump_l_292686,
                                n_inner_292687, n_outer_292688,
                                jump_threshold_1_292689,
                                jump_threshold_2_292690, q_threshold_1_292691,
                                q_threshold_2_292692);
        if (ret == 0) {
            assert((*out0 =
                    (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d))) !=
                NULL);
            (*out0)->mem = mem_out_320823;
            (*out0)->shape[0] = m_292674;
            (*out0)->shape[1] = n_292675;
            assert((*out1 =
                    (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d))) !=
                NULL);
            (*out1)->mem = mem_out_320824;
            (*out1)->shape[0] = m_292674;
            (*out1)->shape[1] = n_292675;
            assert((*out2 =
                    (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d))) !=
                NULL);
            (*out2)->mem = mem_out_320825;
            (*out2)->shape[0] = m_292674;
            (*out2)->shape[1] = n_292675;
        }
    }
    CUDA_SUCCEED_FATAL(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    lock_unlock(&ctx->lock);
    return ret;
}
int futhark_entry_seasonal_amplitude(struct futhark_context *ctx,
                                     struct futhark_f32_1d **out0, const
                                     struct futhark_f32_2d *in0)
{
    struct memblock_device seasonal_l_mem_318490;
    
    seasonal_l_mem_318490.references = NULL;
    
    int64_t m_292609;
    int64_t n_292610;
    struct memblock_device mem_out_320823;
    
    mem_out_320823.references = NULL;
    
    int ret = 0;
    
    lock_lock(&ctx->lock);
    CUDA_SUCCEED_FATAL(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    seasonal_l_mem_318490 = in0->mem;
    m_292609 = in0->shape[0];
    n_292610 = in0->shape[1];
    if (!(m_292609 == in0->shape[0] && n_292610 == in0->shape[1])) {
        ret = 1;
        if (!ctx->error)
            ctx->error =
                msgprintf("Error: entry point arguments have invalid sizes.\n");
    }
    if (ret == 0) {
        ret = futrts_entry_seasonal_amplitude(ctx, &mem_out_320823,
                                              seasonal_l_mem_318490, m_292609,
                                              n_292610);
        if (ret == 0) {
            assert((*out0 =
                    (struct futhark_f32_1d *) malloc(sizeof(struct futhark_f32_1d))) !=
                NULL);
            (*out0)->mem = mem_out_320823;
            (*out0)->shape[0] = m_292609;
        }
    }
    CUDA_SUCCEED_FATAL(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    lock_unlock(&ctx->lock);
    return ret;
}
int futhark_entry_trend_magnitude(struct futhark_context *ctx,
                                  struct futhark_f32_1d **out0, const
                                  struct futhark_f32_2d *in0)
{
    struct memblock_device trend_l_mem_318490;
    
    trend_l_mem_318490.references = NULL;
    
    int64_t m_292626;
    int64_t n_292627;
    struct memblock_device mem_out_320823;
    
    mem_out_320823.references = NULL;
    
    int ret = 0;
    
    lock_lock(&ctx->lock);
    CUDA_SUCCEED_FATAL(cuCtxPushCurrent(ctx->cuda.cu_ctx));
    trend_l_mem_318490 = in0->mem;
    m_292626 = in0->shape[0];
    n_292627 = in0->shape[1];
    if (!(m_292626 == in0->shape[0] && n_292627 == in0->shape[1])) {
        ret = 1;
        if (!ctx->error)
            ctx->error =
                msgprintf("Error: entry point arguments have invalid sizes.\n");
    }
    if (ret == 0) {
        ret = futrts_entry_trend_magnitude(ctx, &mem_out_320823,
                                           trend_l_mem_318490, m_292626,
                                           n_292627);
        if (ret == 0) {
            assert((*out0 =
                    (struct futhark_f32_1d *) malloc(sizeof(struct futhark_f32_1d))) !=
                NULL);
            (*out0)->mem = mem_out_320823;
            (*out0)->shape[0] = m_292626;
        }
    }
    CUDA_SUCCEED_FATAL(cuCtxPopCurrent(&ctx->cuda.cu_ctx));
    lock_unlock(&ctx->lock);
    return ret;
}
  
